
type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type empty_set = |

(** val implb : bool -> bool -> bool **)

let implb b1 b2 =
  if b1 then b2 else true

(** val negb : bool -> bool **)

let negb = function
| true -> false
| false -> true

type nat =
| O
| S of nat

(** val option_map : ('a1 -> 'a2) -> 'a1 option -> 'a2 option **)

let option_map f = function
| Some a -> Some (f a)
| None -> None

type ('a, 'b) sum =
| Inl of 'a
| Inr of 'b

(** val fst : ('a1 * 'a2) -> 'a1 **)

let fst = function
| (x, _) -> x

(** val snd : ('a1 * 'a2) -> 'a2 **)

let snd = function
| (_, y) -> y

(** val length : 'a1 list -> nat **)

let length x =
  let rec length1 = function
  | [] -> O
  | _ :: l' -> S (length1 l')
  in length1 x

(** val app : 'a1 list -> 'a1 list -> 'a1 list **)

let app x =
  let rec app2 l m4 =
    match l with
    | [] -> m4
    | a :: l1 -> a :: (app2 l1 m4)
  in app2 x

type comparison =
| Eq
| Lt
| Gt

(** val compOpp : comparison -> comparison **)

let compOpp = function
| Eq -> Eq
| Lt -> Gt
| Gt -> Lt

type compareSpecT =
| CompEqT
| CompLtT
| CompGtT

(** val compareSpec2Type : comparison -> compareSpecT **)

let compareSpec2Type c0 =
  (match c0 with
   | Eq -> (fun _ -> CompEqT)
   | Lt -> (fun _ -> CompLtT)
   | Gt -> (fun _ -> CompGtT)) __

type 'a compSpecT = compareSpecT

(** val compSpec2Type : 'a1 -> 'a1 -> comparison -> 'a1 compSpecT **)

let compSpec2Type _ _ =
  compareSpec2Type

(** val id : __ -> __ **)

let id x =
  x

type 'a sig0 = 'a
  (* singleton inductive, whose constructor was exist *)

type ('a, 'p) sigT =
| ExistT of 'a * 'p

(** val projT1 : ('a1, 'a2) sigT -> 'a1 **)

let projT1 = function
| ExistT (a, _) -> a

(** val projT2 : ('a1, 'a2) sigT -> 'a2 **)

let projT2 = function
| ExistT (_, h) -> h



type uint =
| Nil
| D0 of uint
| D1 of uint
| D2 of uint
| D3 of uint
| D4 of uint
| D5 of uint
| D6 of uint
| D7 of uint
| D8 of uint
| D9 of uint

type signed_int =
| Pos of uint
| Neg of uint

(** val nzhead : uint -> uint **)

let rec nzhead d = match d with
| Nil -> d
| D0 d0 -> nzhead d0
| D1 _ -> d
| D2 _ -> d
| D3 _ -> d
| D4 _ -> d
| D5 _ -> d
| D6 _ -> d
| D7 _ -> d
| D8 _ -> d
| D9 _ -> d

(** val unorm : uint -> uint **)

let unorm d =
  match nzhead d with
  | Nil -> D0 Nil
  | D0 u -> D0 u
  | D1 u -> D1 u
  | D2 u -> D2 u
  | D3 u -> D3 u
  | D4 u -> D4 u
  | D5 u -> D5 u
  | D6 u -> D6 u
  | D7 u -> D7 u
  | D8 u -> D8 u
  | D9 u -> D9 u

(** val norm : signed_int -> signed_int **)

let norm = function
| Pos d0 -> Pos (unorm d0)
| Neg d0 ->
  (match nzhead d0 with
   | Nil -> Pos (D0 Nil)
   | D0 u -> Neg (D0 u)
   | D1 u -> Neg (D1 u)
   | D2 u -> Neg (D2 u)
   | D3 u -> Neg (D3 u)
   | D4 u -> Neg (D4 u)
   | D5 u -> Neg (D5 u)
   | D6 u -> Neg (D6 u)
   | D7 u -> Neg (D7 u)
   | D8 u -> Neg (D8 u)
   | D9 u -> Neg (D9 u))

(** val revapp : uint -> uint -> uint **)

let rec revapp d d' =
  match d with
  | Nil -> d'
  | D0 d0 -> revapp d0 (D0 d')
  | D1 d0 -> revapp d0 (D1 d')
  | D2 d0 -> revapp d0 (D2 d')
  | D3 d0 -> revapp d0 (D3 d')
  | D4 d0 -> revapp d0 (D4 d')
  | D5 d0 -> revapp d0 (D5 d')
  | D6 d0 -> revapp d0 (D6 d')
  | D7 d0 -> revapp d0 (D7 d')
  | D8 d0 -> revapp d0 (D8 d')
  | D9 d0 -> revapp d0 (D9 d')

(** val rev : uint -> uint **)

let rev d =
  revapp d Nil

module Little =
 struct
  (** val double : uint -> uint **)

  let rec double = function
  | Nil -> Nil
  | D0 d0 -> D0 (double d0)
  | D1 d0 -> D2 (double d0)
  | D2 d0 -> D4 (double d0)
  | D3 d0 -> D6 (double d0)
  | D4 d0 -> D8 (double d0)
  | D5 d0 -> D0 (succ_double d0)
  | D6 d0 -> D2 (succ_double d0)
  | D7 d0 -> D4 (succ_double d0)
  | D8 d0 -> D6 (succ_double d0)
  | D9 d0 -> D8 (succ_double d0)

  (** val succ_double : uint -> uint **)

  and succ_double = function
  | Nil -> D1 Nil
  | D0 d0 -> D1 (double d0)
  | D1 d0 -> D3 (double d0)
  | D2 d0 -> D5 (double d0)
  | D3 d0 -> D7 (double d0)
  | D4 d0 -> D9 (double d0)
  | D5 d0 -> D1 (succ_double d0)
  | D6 d0 -> D3 (succ_double d0)
  | D7 d0 -> D5 (succ_double d0)
  | D8 d0 -> D7 (succ_double d0)
  | D9 d0 -> D9 (succ_double d0)
 end

type uint0 =
| Nil0
| D10 of uint0
| D11 of uint0
| D12 of uint0
| D13 of uint0
| D14 of uint0
| D15 of uint0
| D16 of uint0
| D17 of uint0
| D18 of uint0
| D19 of uint0
| Da of uint0
| Db of uint0
| Dc of uint0
| Dd of uint0
| De of uint0
| Df of uint0

type signed_int0 =
| Pos0 of uint0
| Neg0 of uint0

(** val nzhead0 : uint0 -> uint0 **)

let rec nzhead0 d = match d with
| Nil0 -> d
| D10 d0 -> nzhead0 d0
| D11 _ -> d
| D12 _ -> d
| D13 _ -> d
| D14 _ -> d
| D15 _ -> d
| D16 _ -> d
| D17 _ -> d
| D18 _ -> d
| D19 _ -> d
| Da _ -> d
| Db _ -> d
| Dc _ -> d
| Dd _ -> d
| De _ -> d
| Df _ -> d

(** val unorm0 : uint0 -> uint0 **)

let unorm0 d =
  match nzhead0 d with
  | Nil0 -> D10 Nil0
  | D10 u -> D10 u
  | D11 u -> D11 u
  | D12 u -> D12 u
  | D13 u -> D13 u
  | D14 u -> D14 u
  | D15 u -> D15 u
  | D16 u -> D16 u
  | D17 u -> D17 u
  | D18 u -> D18 u
  | D19 u -> D19 u
  | Da u -> Da u
  | Db u -> Db u
  | Dc u -> Dc u
  | Dd u -> Dd u
  | De u -> De u
  | Df u -> Df u

(** val norm0 : signed_int0 -> signed_int0 **)

let norm0 = function
| Pos0 d0 -> Pos0 (unorm0 d0)
| Neg0 d0 ->
  (match nzhead0 d0 with
   | Nil0 -> Pos0 (D10 Nil0)
   | D10 u -> Neg0 (D10 u)
   | D11 u -> Neg0 (D11 u)
   | D12 u -> Neg0 (D12 u)
   | D13 u -> Neg0 (D13 u)
   | D14 u -> Neg0 (D14 u)
   | D15 u -> Neg0 (D15 u)
   | D16 u -> Neg0 (D16 u)
   | D17 u -> Neg0 (D17 u)
   | D18 u -> Neg0 (D18 u)
   | D19 u -> Neg0 (D19 u)
   | Da u -> Neg0 (Da u)
   | Db u -> Neg0 (Db u)
   | Dc u -> Neg0 (Dc u)
   | Dd u -> Neg0 (Dd u)
   | De u -> Neg0 (De u)
   | Df u -> Neg0 (Df u))

(** val revapp0 : uint0 -> uint0 -> uint0 **)

let rec revapp0 d d' =
  match d with
  | Nil0 -> d'
  | D10 d0 -> revapp0 d0 (D10 d')
  | D11 d0 -> revapp0 d0 (D11 d')
  | D12 d0 -> revapp0 d0 (D12 d')
  | D13 d0 -> revapp0 d0 (D13 d')
  | D14 d0 -> revapp0 d0 (D14 d')
  | D15 d0 -> revapp0 d0 (D15 d')
  | D16 d0 -> revapp0 d0 (D16 d')
  | D17 d0 -> revapp0 d0 (D17 d')
  | D18 d0 -> revapp0 d0 (D18 d')
  | D19 d0 -> revapp0 d0 (D19 d')
  | Da d0 -> revapp0 d0 (Da d')
  | Db d0 -> revapp0 d0 (Db d')
  | Dc d0 -> revapp0 d0 (Dc d')
  | Dd d0 -> revapp0 d0 (Dd d')
  | De d0 -> revapp0 d0 (De d')
  | Df d0 -> revapp0 d0 (Df d')

(** val rev0 : uint0 -> uint0 **)

let rev0 d =
  revapp0 d Nil0

module Coq_Little =
 struct
  (** val double : uint0 -> uint0 **)

  let rec double = function
  | Nil0 -> Nil0
  | D10 d0 -> D10 (double d0)
  | D11 d0 -> D12 (double d0)
  | D12 d0 -> D14 (double d0)
  | D13 d0 -> D16 (double d0)
  | D14 d0 -> D18 (double d0)
  | D15 d0 -> Da (double d0)
  | D16 d0 -> Dc (double d0)
  | D17 d0 -> De (double d0)
  | D18 d0 -> D10 (succ_double d0)
  | D19 d0 -> D12 (succ_double d0)
  | Da d0 -> D14 (succ_double d0)
  | Db d0 -> D16 (succ_double d0)
  | Dc d0 -> D18 (succ_double d0)
  | Dd d0 -> Da (succ_double d0)
  | De d0 -> Dc (succ_double d0)
  | Df d0 -> De (succ_double d0)

  (** val succ_double : uint0 -> uint0 **)

  and succ_double = function
  | Nil0 -> D11 Nil0
  | D10 d0 -> D11 (double d0)
  | D11 d0 -> D13 (double d0)
  | D12 d0 -> D15 (double d0)
  | D13 d0 -> D17 (double d0)
  | D14 d0 -> D19 (double d0)
  | D15 d0 -> Db (double d0)
  | D16 d0 -> Dd (double d0)
  | D17 d0 -> Df (double d0)
  | D18 d0 -> D11 (succ_double d0)
  | D19 d0 -> D13 (succ_double d0)
  | Da d0 -> D15 (succ_double d0)
  | Db d0 -> D17 (succ_double d0)
  | Dc d0 -> D19 (succ_double d0)
  | Dd d0 -> Db (succ_double d0)
  | De d0 -> Dd (succ_double d0)
  | Df d0 -> Df (succ_double d0)
 end

type uint1 =
| UIntDecimal of uint
| UIntHexadecimal of uint0

type signed_int1 =
| IntDecimal of signed_int
| IntHexadecimal of signed_int0

(** val pred : nat -> nat **)

let pred n3 = match n3 with
| O -> n3
| S u -> u

module Coq__1 = struct
 (** val add : nat -> nat -> nat **)

 let rec add n3 m4 =
   match n3 with
   | O -> m4
   | S p -> S (add p m4)
end
include Coq__1

(** val mul : nat -> nat -> nat **)

let rec mul n3 m4 =
  match n3 with
  | O -> O
  | S p -> add m4 (mul p m4)

(** val sub : nat -> nat -> nat **)

let rec sub n3 m4 =
  match n3 with
  | O -> n3
  | S k -> (match m4 with
            | O -> n3
            | S l -> sub k l)

(** val max : nat -> nat -> nat **)

let rec max n3 m4 =
  match n3 with
  | O -> m4
  | S n' -> (match m4 with
             | O -> n3
             | S m'0 -> S (max n' m'0))

(** val min : nat -> nat -> nat **)

let rec min n3 m4 =
  match n3 with
  | O -> O
  | S n' -> (match m4 with
             | O -> O
             | S m'0 -> S (min n' m'0))

(** val eqb : bool -> bool -> bool **)

let eqb b1 b2 =
  if b1 then if b2 then true else false else if b2 then false else true

type reflect =
| ReflectT
| ReflectF

(** val iff_reflect : bool -> reflect **)

let iff_reflect b =
  (if b then (fun _ -> ReflectT) else (fun _ -> ReflectF)) __

(** val eqb_spec : bool -> bool -> reflect **)

let eqb_spec b b' =
  if b
  then if b' then ReflectT else ReflectF
  else if b' then ReflectF else ReflectT

module type DecidableType =
 sig
  type t

  val eq_dec : t -> t -> bool
 end

module type EqLtLe =
 sig
  type t
 end

module type OrderedType =
 sig
  type t

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool
 end

module type OrderedType' =
 sig
  type t

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool
 end

module OT_to_Full =
 functor (O:OrderedType') ->
 struct
  type t = O.t

  (** val compare : t -> t -> comparison **)

  let compare =
    O.compare

  (** val eq_dec : t -> t -> bool **)

  let eq_dec =
    O.eq_dec
 end

module type TotalLeBool' =
 sig
  type t

  val leb : t -> t -> bool
 end

module MakeOrderTac =
 functor (O:EqLtLe) ->
 functor (P:sig
 end) ->
 struct
 end

module OT_to_OrderTac =
 functor (OT:OrderedType) ->
 struct
  module OTF = OT_to_Full(OT)

  module TO =
   struct
    type t = OTF.t

    (** val compare : t -> t -> comparison **)

    let compare =
      OTF.compare

    (** val eq_dec : t -> t -> bool **)

    let eq_dec =
      OTF.eq_dec
   end
 end

module OrderedTypeFacts =
 functor (O:OrderedType') ->
 struct
  module OrderTac = OT_to_OrderTac(O)

  (** val eq_dec : O.t -> O.t -> bool **)

  let eq_dec =
    O.eq_dec

  (** val lt_dec : O.t -> O.t -> bool **)

  let lt_dec x y =
    let c0 = compSpec2Type x y (O.compare x y) in
    (match c0 with
     | CompEqT -> false
     | CompLtT -> true
     | CompGtT -> false)

  (** val eqb : O.t -> O.t -> bool **)

  let eqb x y =
    if eq_dec x y then true else false
 end

module Nat =
 struct
  (** val succ : nat -> nat **)

  let succ x =
    S x

  (** val pred : nat -> nat **)

  let pred n3 = match n3 with
  | O -> n3
  | S u -> u

  (** val add : nat -> nat -> nat **)

  let rec add n3 m4 =
    match n3 with
    | O -> m4
    | S p -> S (add p m4)

  (** val mul : nat -> nat -> nat **)

  let rec mul n3 m4 =
    match n3 with
    | O -> O
    | S p -> add m4 (mul p m4)

  (** val sub : nat -> nat -> nat **)

  let rec sub n3 m4 =
    match n3 with
    | O -> n3
    | S k -> (match m4 with
              | O -> n3
              | S l -> sub k l)

  (** val eqb : nat -> nat -> bool **)

  let rec eqb n3 m4 =
    match n3 with
    | O -> (match m4 with
            | O -> true
            | S _ -> false)
    | S n' -> (match m4 with
               | O -> false
               | S m'0 -> eqb n' m'0)

  (** val leb : nat -> nat -> bool **)

  let rec leb n3 m4 =
    match n3 with
    | O -> true
    | S n' -> (match m4 with
               | O -> false
               | S m'0 -> leb n' m'0)

  (** val ltb : nat -> nat -> bool **)

  let ltb n3 m4 =
    leb (S n3) m4

  (** val max : nat -> nat -> nat **)

  let rec max n3 m4 =
    match n3 with
    | O -> m4
    | S n' -> (match m4 with
               | O -> n3
               | S m'0 -> S (max n' m'0))

  (** val min : nat -> nat -> nat **)

  let rec min n3 m4 =
    match n3 with
    | O -> O
    | S n' -> (match m4 with
               | O -> O
               | S m'0 -> S (min n' m'0))

  (** val eqb_spec : nat -> nat -> reflect **)

  let eqb_spec x y =
    iff_reflect (eqb x y)
 end

(** val hd : 'a1 -> 'a1 list -> 'a1 **)

let hd default0 = function
| [] -> default0
| x :: _ -> x

(** val tl : 'a1 list -> 'a1 list **)

let tl = function
| [] -> []
| _ :: m4 -> m4

(** val nth : nat -> 'a1 list -> 'a1 -> 'a1 **)

let nth n3 =
  let rec nth0 n4 l default0 =
    match n4 with
    | O -> (match l with
            | [] -> default0
            | x :: _ -> x)
    | S m4 -> (match l with
               | [] -> default0
               | _ :: t0 -> nth0 m4 t0 default0)
  in nth0 n3

(** val nth_error : 'a1 list -> nat -> 'a1 option **)

let nth_error l =
  let rec nth_error0 l0 = function
  | O -> (match l0 with
          | [] -> None
          | x :: _ -> Some x)
  | S n4 -> (match l0 with
             | [] -> None
             | _ :: l1 -> nth_error0 l1 n4)
  in nth_error0 l

(** val nth_default : 'a1 -> 'a1 list -> nat -> 'a1 **)

let nth_default default0 l n3 =
  match nth_error l n3 with
  | Some x -> x
  | None -> default0

(** val last : 'a1 list -> 'a1 -> 'a1 **)

let last l =
  let rec last0 l0 d =
    match l0 with
    | [] -> d
    | a :: l1 -> (match l1 with
                  | [] -> a
                  | _ :: _ -> last0 l1 d)
  in last0 l

(** val removelast : 'a1 list -> 'a1 list **)

let removelast l =
  let rec removelast0 = function
  | [] -> []
  | a :: l1 -> (match l1 with
                | [] -> []
                | _ :: _ -> a :: (removelast0 l1))
  in removelast0 l

(** val count_occ : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 -> nat **)

let count_occ eq_dec0 =
  let rec count_occ0 l x =
    match l with
    | [] -> O
    | y :: tl1 ->
      let n3 = count_occ0 tl1 x in if eq_dec0 y x then S n3 else n3
  in count_occ0

(** val rev1 : 'a1 list -> 'a1 list **)

let rev1 l =
  let rec rev3 = function
  | [] -> []
  | x :: l' -> app (rev3 l') (x :: [])
  in rev3 l

(** val rev_append : 'a1 list -> 'a1 list -> 'a1 list **)

let rev_append l =
  let rec rev_append0 l0 l' =
    match l0 with
    | [] -> l'
    | a :: l1 -> rev_append0 l1 (a :: l')
  in rev_append0 l

(** val rev' : 'a1 list -> 'a1 list **)

let rev' l =
  rev_append l []

(** val concat : 'a1 list list -> 'a1 list **)

let concat l =
  let rec concat1 = function
  | [] -> []
  | x :: l1 -> app x (concat1 l1)
  in concat1 l

(** val map : ('a1 -> 'a2) -> 'a1 list -> 'a2 list **)

let map f =
  let rec map6 = function
  | [] -> []
  | a :: t0 -> (f a) :: (map6 t0)
  in map6

(** val flat_map : ('a1 -> 'a2 list) -> 'a1 list -> 'a2 list **)

let flat_map f =
  let rec flat_map0 = function
  | [] -> []
  | x :: t0 -> app (f x) (flat_map0 t0)
  in flat_map0

(** val fold_left : ('a1 -> 'a2 -> 'a1) -> 'a2 list -> 'a1 -> 'a1 **)

let fold_left f =
  let rec fold_left0 l a0 =
    match l with
    | [] -> a0
    | b :: t0 -> fold_left0 t0 (f a0 b)
  in fold_left0

(** val fold_right : ('a2 -> 'a1 -> 'a1) -> 'a1 -> 'a2 list -> 'a1 **)

let fold_right f a0 =
  let rec fold_right0 = function
  | [] -> a0
  | b :: t0 -> f b (fold_right0 t0)
  in fold_right0

(** val existsb : ('a1 -> bool) -> 'a1 list -> bool **)

let existsb f =
  let rec existsb0 = function
  | [] -> false
  | a :: l0 -> (||) (f a) (existsb0 l0)
  in existsb0

(** val forallb : ('a1 -> bool) -> 'a1 list -> bool **)

let forallb f =
  let rec forallb0 = function
  | [] -> true
  | a :: l0 -> (&&) (f a) (forallb0 l0)
  in forallb0

(** val filter : ('a1 -> bool) -> 'a1 list -> 'a1 list **)

let filter f =
  let rec filter0 = function
  | [] -> []
  | x :: l0 -> if f x then x :: (filter0 l0) else filter0 l0
  in filter0

(** val find : ('a1 -> bool) -> 'a1 list -> 'a1 option **)

let find f =
  let rec find0 = function
  | [] -> None
  | x :: tl1 -> if f x then Some x else find0 tl1
  in find0

(** val partition : ('a1 -> bool) -> 'a1 list -> 'a1 list * 'a1 list **)

let partition f =
  let rec partition0 = function
  | [] -> ([], [])
  | x :: tl1 ->
    let (g, d) = partition0 tl1 in
    if f x then ((x :: g), d) else (g, (x :: d))
  in partition0

(** val combine : 'a1 list -> 'a2 list -> ('a1 * 'a2) list **)

let combine l =
  let rec combine1 l0 l' =
    match l0 with
    | [] -> []
    | x :: tl1 ->
      (match l' with
       | [] -> []
       | y :: tl'0 -> (x, y) :: (combine1 tl1 tl'0))
  in combine1 l

(** val firstn : nat -> 'a1 list -> 'a1 list **)

let firstn n3 =
  let rec firstn0 n4 l =
    match n4 with
    | O -> []
    | S n5 -> (match l with
               | [] -> []
               | a :: l0 -> a :: (firstn0 n5 l0))
  in firstn0 n3

(** val skipn : nat -> 'a1 list -> 'a1 list **)

let skipn n3 =
  let rec skipn0 n4 l =
    match n4 with
    | O -> l
    | S n5 -> (match l with
               | [] -> []
               | _ :: l0 -> skipn0 n5 l0)
  in skipn0 n3

(** val seq : nat -> nat -> nat list **)

let rec seq start = function
| O -> []
| S len0 -> start :: (seq (S start) len0)

(** val repeat : 'a1 -> nat -> 'a1 list **)

let repeat x =
  let rec repeat2 x0 = function
  | O -> []
  | S k -> x0 :: (repeat2 x0 k)
  in repeat2 x

type positive =
| XI of positive
| XO of positive
| XH

type n =
| N0
| Npos of positive

type z =
| Z0
| Zpos of positive
| Zneg of positive

module Pos =
 struct
  type mask =
  | IsNul
  | IsPos of positive
  | IsNeg
 end

module Coq_Pos =
 struct
  (** val succ : positive -> positive **)

  let rec succ = function
  | XI p -> XO (succ p)
  | XO p -> XI p
  | XH -> XO XH

  (** val add : positive -> positive -> positive **)

  let rec add x y =
    match x with
    | XI p ->
      (match y with
       | XI q0 -> XO (add_carry p q0)
       | XO q0 -> XI (add p q0)
       | XH -> XO (succ p))
    | XO p ->
      (match y with
       | XI q0 -> XI (add p q0)
       | XO q0 -> XO (add p q0)
       | XH -> XI p)
    | XH -> (match y with
             | XI q0 -> XO (succ q0)
             | XO q0 -> XI q0
             | XH -> XO XH)

  (** val add_carry : positive -> positive -> positive **)

  and add_carry x y =
    match x with
    | XI p ->
      (match y with
       | XI q0 -> XI (add_carry p q0)
       | XO q0 -> XO (add_carry p q0)
       | XH -> XI (succ p))
    | XO p ->
      (match y with
       | XI q0 -> XO (add_carry p q0)
       | XO q0 -> XI (add p q0)
       | XH -> XO (succ p))
    | XH ->
      (match y with
       | XI q0 -> XI (succ q0)
       | XO q0 -> XO (succ q0)
       | XH -> XI XH)

  (** val pred_double : positive -> positive **)

  let rec pred_double = function
  | XI p -> XI (XO p)
  | XO p -> XI (pred_double p)
  | XH -> XH

  (** val pred_N : positive -> n **)

  let pred_N = function
  | XI p -> Npos (XO p)
  | XO p -> Npos (pred_double p)
  | XH -> N0

  type mask = Pos.mask =
  | IsNul
  | IsPos of positive
  | IsNeg

  (** val succ_double_mask : mask -> mask **)

  let succ_double_mask = function
  | IsNul -> IsPos XH
  | IsPos p -> IsPos (XI p)
  | IsNeg -> IsNeg

  (** val double_mask : mask -> mask **)

  let double_mask = function
  | IsNul -> IsNul
  | IsPos p -> IsPos (XO p)
  | IsNeg -> IsNeg

  (** val double_pred_mask : positive -> mask **)

  let double_pred_mask = function
  | XI p -> IsPos (XO (XO p))
  | XO p -> IsPos (XO (pred_double p))
  | XH -> IsNul

  (** val sub_mask : positive -> positive -> mask **)

  let rec sub_mask x y =
    match x with
    | XI p ->
      (match y with
       | XI q0 -> double_mask (sub_mask p q0)
       | XO q0 -> succ_double_mask (sub_mask p q0)
       | XH -> IsPos (XO p))
    | XO p ->
      (match y with
       | XI q0 -> succ_double_mask (sub_mask_carry p q0)
       | XO q0 -> double_mask (sub_mask p q0)
       | XH -> IsPos (pred_double p))
    | XH -> (match y with
             | XI _ -> IsNeg
             | XO _ -> IsNeg
             | XH -> IsNul)

  (** val sub_mask_carry : positive -> positive -> mask **)

  and sub_mask_carry x y =
    match x with
    | XI p ->
      (match y with
       | XI q0 -> succ_double_mask (sub_mask_carry p q0)
       | XO q0 -> double_mask (sub_mask p q0)
       | XH -> IsPos (pred_double p))
    | XO p ->
      (match y with
       | XI q0 -> double_mask (sub_mask_carry p q0)
       | XO q0 -> succ_double_mask (sub_mask_carry p q0)
       | XH -> double_pred_mask p)
    | XH -> IsNeg

  (** val sub : positive -> positive -> positive **)

  let sub x y =
    match sub_mask x y with
    | IsNul -> XH
    | IsPos z0 -> z0
    | IsNeg -> XH

  (** val mul : positive -> positive -> positive **)

  let rec mul x y =
    match x with
    | XI p -> add y (XO (mul p y))
    | XO p -> XO (mul p y)
    | XH -> y

  (** val iter : ('a1 -> 'a1) -> 'a1 -> positive -> 'a1 **)

  let iter f =
    let rec iter_fix x = function
    | XI n' -> f (iter_fix (iter_fix x n') n')
    | XO n' -> iter_fix (iter_fix x n') n'
    | XH -> f x
    in iter_fix

  (** val pow : positive -> positive -> positive **)

  let pow x =
    iter (mul x) XH

  (** val square : positive -> positive **)

  let rec square = function
  | XI p0 -> XI (XO (add (square p0) p0))
  | XO p0 -> XO (XO (square p0))
  | XH -> XH

  (** val div2 : positive -> positive **)

  let div2 = function
  | XI p0 -> p0
  | XO p0 -> p0
  | XH -> XH

  (** val div2_up : positive -> positive **)

  let div2_up = function
  | XI p0 -> succ p0
  | XO p0 -> p0
  | XH -> XH

  (** val size_nat : positive -> nat **)

  let rec size_nat = function
  | XI p0 -> S (size_nat p0)
  | XO p0 -> S (size_nat p0)
  | XH -> S O

  (** val size : positive -> positive **)

  let rec size = function
  | XI p0 -> succ (size p0)
  | XO p0 -> succ (size p0)
  | XH -> XH

  (** val compare_cont : comparison -> positive -> positive -> comparison **)

  let rec compare_cont r0 x y =
    match x with
    | XI p ->
      (match y with
       | XI q0 -> compare_cont r0 p q0
       | XO q0 -> compare_cont Gt p q0
       | XH -> Gt)
    | XO p ->
      (match y with
       | XI q0 -> compare_cont Lt p q0
       | XO q0 -> compare_cont r0 p q0
       | XH -> Gt)
    | XH -> (match y with
             | XI _ -> Lt
             | XO _ -> Lt
             | XH -> r0)

  (** val compare : positive -> positive -> comparison **)

  let compare =
    compare_cont Eq

  (** val eqb : positive -> positive -> bool **)

  let rec eqb p q0 =
    match p with
    | XI p0 -> (match q0 with
                | XI q1 -> eqb p0 q1
                | XO _ -> false
                | XH -> false)
    | XO p0 -> (match q0 with
                | XI _ -> false
                | XO q1 -> eqb p0 q1
                | XH -> false)
    | XH -> (match q0 with
             | XI _ -> false
             | XO _ -> false
             | XH -> true)

  (** val leb : positive -> positive -> bool **)

  let leb x y =
    match compare x y with
    | Eq -> true
    | Lt -> true
    | Gt -> false

  (** val sqrtrem_step :
      (positive -> positive) -> (positive -> positive) -> (positive * mask)
      -> positive * mask **)

  let sqrtrem_step f g = function
  | (s0, y) ->
    (match y with
     | IsNul -> ((XO s0), (sub_mask (g (f XH)) (XO (XO XH))))
     | IsPos r0 ->
       let s' = XI (XO s0) in
       let r'0 = g (f r0) in
       if leb s' r'0
       then ((XI s0), (sub_mask r'0 s'))
       else ((XO s0), (IsPos r'0))
     | IsNeg -> ((XO s0), (sub_mask (g (f XH)) (XO (XO XH)))))

  (** val sqrtrem : positive -> positive * mask **)

  let rec sqrtrem = function
  | XI p0 ->
    (match p0 with
     | XI p1 -> sqrtrem_step (fun x -> XI x) (fun x -> XI x) (sqrtrem p1)
     | XO p1 -> sqrtrem_step (fun x -> XO x) (fun x -> XI x) (sqrtrem p1)
     | XH -> (XH, (IsPos (XO XH))))
  | XO p0 ->
    (match p0 with
     | XI p1 -> sqrtrem_step (fun x -> XI x) (fun x -> XO x) (sqrtrem p1)
     | XO p1 -> sqrtrem_step (fun x -> XO x) (fun x -> XO x) (sqrtrem p1)
     | XH -> (XH, (IsPos XH)))
  | XH -> (XH, IsNul)

  (** val sqrt : positive -> positive **)

  let sqrt p =
    fst (sqrtrem p)

  (** val gcdn : nat -> positive -> positive -> positive **)

  let rec gcdn n3 a b =
    match n3 with
    | O -> XH
    | S n4 ->
      (match a with
       | XI a' ->
         (match b with
          | XI b' ->
            (match compare a' b' with
             | Eq -> a
             | Lt -> gcdn n4 (sub b' a') a
             | Gt -> gcdn n4 (sub a' b') b)
          | XO b0 -> gcdn n4 a b0
          | XH -> XH)
       | XO a0 ->
         (match b with
          | XI _ -> gcdn n4 a0 b
          | XO b0 -> XO (gcdn n4 a0 b0)
          | XH -> XH)
       | XH -> XH)

  (** val gcd : positive -> positive -> positive **)

  let gcd a b =
    gcdn (Coq__1.add (size_nat a) (size_nat b)) a b

  (** val ggcdn :
      nat -> positive -> positive -> positive * (positive * positive) **)

  let rec ggcdn n3 a b =
    match n3 with
    | O -> (XH, (a, b))
    | S n4 ->
      (match a with
       | XI a' ->
         (match b with
          | XI b' ->
            (match compare a' b' with
             | Eq -> (a, (XH, XH))
             | Lt ->
               let (g, p) = ggcdn n4 (sub b' a') a in
               let (ba, aa) = p in (g, (aa, (add aa (XO ba))))
             | Gt ->
               let (g, p) = ggcdn n4 (sub a' b') b in
               let (ab, bb) = p in (g, ((add bb (XO ab)), bb)))
          | XO b0 ->
            let (g, p) = ggcdn n4 a b0 in
            let (aa, bb) = p in (g, (aa, (XO bb)))
          | XH -> (XH, (a, XH)))
       | XO a0 ->
         (match b with
          | XI _ ->
            let (g, p) = ggcdn n4 a0 b in
            let (aa, bb) = p in (g, ((XO aa), bb))
          | XO b0 -> let (g, p) = ggcdn n4 a0 b0 in ((XO g), p)
          | XH -> (XH, (a, XH)))
       | XH -> (XH, (XH, b)))

  (** val ggcd : positive -> positive -> positive * (positive * positive) **)

  let ggcd a b =
    ggcdn (Coq__1.add (size_nat a) (size_nat b)) a b

  (** val coq_Nsucc_double : n -> n **)

  let coq_Nsucc_double = function
  | N0 -> Npos XH
  | Npos p -> Npos (XI p)

  (** val coq_Ndouble : n -> n **)

  let coq_Ndouble = function
  | N0 -> N0
  | Npos p -> Npos (XO p)

  (** val coq_lor : positive -> positive -> positive **)

  let rec coq_lor p q0 =
    match p with
    | XI p0 ->
      (match q0 with
       | XI q1 -> XI (coq_lor p0 q1)
       | XO q1 -> XI (coq_lor p0 q1)
       | XH -> p)
    | XO p0 ->
      (match q0 with
       | XI q1 -> XI (coq_lor p0 q1)
       | XO q1 -> XO (coq_lor p0 q1)
       | XH -> XI p0)
    | XH -> (match q0 with
             | XI _ -> q0
             | XO q1 -> XI q1
             | XH -> q0)

  (** val coq_land : positive -> positive -> n **)

  let rec coq_land p q0 =
    match p with
    | XI p0 ->
      (match q0 with
       | XI q1 -> coq_Nsucc_double (coq_land p0 q1)
       | XO q1 -> coq_Ndouble (coq_land p0 q1)
       | XH -> Npos XH)
    | XO p0 ->
      (match q0 with
       | XI q1 -> coq_Ndouble (coq_land p0 q1)
       | XO q1 -> coq_Ndouble (coq_land p0 q1)
       | XH -> N0)
    | XH -> (match q0 with
             | XI _ -> Npos XH
             | XO _ -> N0
             | XH -> Npos XH)

  (** val ldiff : positive -> positive -> n **)

  let rec ldiff p q0 =
    match p with
    | XI p0 ->
      (match q0 with
       | XI q1 -> coq_Ndouble (ldiff p0 q1)
       | XO q1 -> coq_Nsucc_double (ldiff p0 q1)
       | XH -> Npos (XO p0))
    | XO p0 ->
      (match q0 with
       | XI q1 -> coq_Ndouble (ldiff p0 q1)
       | XO q1 -> coq_Ndouble (ldiff p0 q1)
       | XH -> Npos p)
    | XH -> (match q0 with
             | XI _ -> N0
             | XO _ -> Npos XH
             | XH -> N0)

  (** val coq_lxor : positive -> positive -> n **)

  let rec coq_lxor p q0 =
    match p with
    | XI p0 ->
      (match q0 with
       | XI q1 -> coq_Ndouble (coq_lxor p0 q1)
       | XO q1 -> coq_Nsucc_double (coq_lxor p0 q1)
       | XH -> Npos (XO p0))
    | XO p0 ->
      (match q0 with
       | XI q1 -> coq_Nsucc_double (coq_lxor p0 q1)
       | XO q1 -> coq_Ndouble (coq_lxor p0 q1)
       | XH -> Npos (XI p0))
    | XH ->
      (match q0 with
       | XI q1 -> Npos (XO q1)
       | XO q1 -> Npos (XI q1)
       | XH -> N0)

  (** val shiftl : positive -> n -> positive **)

  let shiftl p = function
  | N0 -> p
  | Npos n4 -> iter (fun x -> XO x) p n4

  (** val testbit_nat : positive -> nat -> bool **)

  let rec testbit_nat = function
  | XI p0 -> (fun n3 -> match n3 with
                        | O -> true
                        | S n' -> testbit_nat p0 n')
  | XO p0 -> (fun n3 -> match n3 with
                        | O -> false
                        | S n' -> testbit_nat p0 n')
  | XH -> (fun n3 -> match n3 with
                     | O -> true
                     | S _ -> false)

  (** val testbit : positive -> n -> bool **)

  let rec testbit p n3 =
    match p with
    | XI p0 -> (match n3 with
                | N0 -> true
                | Npos n4 -> testbit p0 (pred_N n4))
    | XO p0 -> (match n3 with
                | N0 -> false
                | Npos n4 -> testbit p0 (pred_N n4))
    | XH -> (match n3 with
             | N0 -> true
             | Npos _ -> false)

  (** val iter_op : ('a1 -> 'a1 -> 'a1) -> positive -> 'a1 -> 'a1 **)

  let iter_op op1 =
    let rec iter0 p a =
      match p with
      | XI p0 -> op1 a (iter0 p0 (op1 a a))
      | XO p0 -> iter0 p0 (op1 a a)
      | XH -> a
    in iter0

  (** val to_nat : positive -> nat **)

  let to_nat x =
    iter_op Coq__1.add x (S O)

  (** val of_succ_nat : nat -> positive **)

  let rec of_succ_nat = function
  | O -> XH
  | S x -> succ (of_succ_nat x)

  (** val of_uint_acc : uint -> positive -> positive **)

  let rec of_uint_acc d acc =
    match d with
    | Nil -> acc
    | D0 l -> of_uint_acc l (mul (XO (XI (XO XH))) acc)
    | D1 l -> of_uint_acc l (add XH (mul (XO (XI (XO XH))) acc))
    | D2 l -> of_uint_acc l (add (XO XH) (mul (XO (XI (XO XH))) acc))
    | D3 l -> of_uint_acc l (add (XI XH) (mul (XO (XI (XO XH))) acc))
    | D4 l -> of_uint_acc l (add (XO (XO XH)) (mul (XO (XI (XO XH))) acc))
    | D5 l -> of_uint_acc l (add (XI (XO XH)) (mul (XO (XI (XO XH))) acc))
    | D6 l -> of_uint_acc l (add (XO (XI XH)) (mul (XO (XI (XO XH))) acc))
    | D7 l -> of_uint_acc l (add (XI (XI XH)) (mul (XO (XI (XO XH))) acc))
    | D8 l ->
      of_uint_acc l (add (XO (XO (XO XH))) (mul (XO (XI (XO XH))) acc))
    | D9 l ->
      of_uint_acc l (add (XI (XO (XO XH))) (mul (XO (XI (XO XH))) acc))

  (** val of_uint : uint -> n **)

  let rec of_uint = function
  | Nil -> N0
  | D0 l -> of_uint l
  | D1 l -> Npos (of_uint_acc l XH)
  | D2 l -> Npos (of_uint_acc l (XO XH))
  | D3 l -> Npos (of_uint_acc l (XI XH))
  | D4 l -> Npos (of_uint_acc l (XO (XO XH)))
  | D5 l -> Npos (of_uint_acc l (XI (XO XH)))
  | D6 l -> Npos (of_uint_acc l (XO (XI XH)))
  | D7 l -> Npos (of_uint_acc l (XI (XI XH)))
  | D8 l -> Npos (of_uint_acc l (XO (XO (XO XH))))
  | D9 l -> Npos (of_uint_acc l (XI (XO (XO XH))))

  (** val of_hex_uint_acc : uint0 -> positive -> positive **)

  let rec of_hex_uint_acc d acc =
    match d with
    | Nil0 -> acc
    | D10 l -> of_hex_uint_acc l (mul (XO (XO (XO (XO XH)))) acc)
    | D11 l -> of_hex_uint_acc l (add XH (mul (XO (XO (XO (XO XH)))) acc))
    | D12 l ->
      of_hex_uint_acc l (add (XO XH) (mul (XO (XO (XO (XO XH)))) acc))
    | D13 l ->
      of_hex_uint_acc l (add (XI XH) (mul (XO (XO (XO (XO XH)))) acc))
    | D14 l ->
      of_hex_uint_acc l (add (XO (XO XH)) (mul (XO (XO (XO (XO XH)))) acc))
    | D15 l ->
      of_hex_uint_acc l (add (XI (XO XH)) (mul (XO (XO (XO (XO XH)))) acc))
    | D16 l ->
      of_hex_uint_acc l (add (XO (XI XH)) (mul (XO (XO (XO (XO XH)))) acc))
    | D17 l ->
      of_hex_uint_acc l (add (XI (XI XH)) (mul (XO (XO (XO (XO XH)))) acc))
    | D18 l ->
      of_hex_uint_acc l
        (add (XO (XO (XO XH))) (mul (XO (XO (XO (XO XH)))) acc))
    | D19 l ->
      of_hex_uint_acc l
        (add (XI (XO (XO XH))) (mul (XO (XO (XO (XO XH)))) acc))
    | Da l ->
      of_hex_uint_acc l
        (add (XO (XI (XO XH))) (mul (XO (XO (XO (XO XH)))) acc))
    | Db l ->
      of_hex_uint_acc l
        (add (XI (XI (XO XH))) (mul (XO (XO (XO (XO XH)))) acc))
    | Dc l ->
      of_hex_uint_acc l
        (add (XO (XO (XI XH))) (mul (XO (XO (XO (XO XH)))) acc))
    | Dd l ->
      of_hex_uint_acc l
        (add (XI (XO (XI XH))) (mul (XO (XO (XO (XO XH)))) acc))
    | De l ->
      of_hex_uint_acc l
        (add (XO (XI (XI XH))) (mul (XO (XO (XO (XO XH)))) acc))
    | Df l ->
      of_hex_uint_acc l
        (add (XI (XI (XI XH))) (mul (XO (XO (XO (XO XH)))) acc))

  (** val of_hex_uint : uint0 -> n **)

  let rec of_hex_uint = function
  | Nil0 -> N0
  | D10 l -> of_hex_uint l
  | D11 l -> Npos (of_hex_uint_acc l XH)
  | D12 l -> Npos (of_hex_uint_acc l (XO XH))
  | D13 l -> Npos (of_hex_uint_acc l (XI XH))
  | D14 l -> Npos (of_hex_uint_acc l (XO (XO XH)))
  | D15 l -> Npos (of_hex_uint_acc l (XI (XO XH)))
  | D16 l -> Npos (of_hex_uint_acc l (XO (XI XH)))
  | D17 l -> Npos (of_hex_uint_acc l (XI (XI XH)))
  | D18 l -> Npos (of_hex_uint_acc l (XO (XO (XO XH))))
  | D19 l -> Npos (of_hex_uint_acc l (XI (XO (XO XH))))
  | Da l -> Npos (of_hex_uint_acc l (XO (XI (XO XH))))
  | Db l -> Npos (of_hex_uint_acc l (XI (XI (XO XH))))
  | Dc l -> Npos (of_hex_uint_acc l (XO (XO (XI XH))))
  | Dd l -> Npos (of_hex_uint_acc l (XI (XO (XI XH))))
  | De l -> Npos (of_hex_uint_acc l (XO (XI (XI XH))))
  | Df l -> Npos (of_hex_uint_acc l (XI (XI (XI XH))))

  (** val to_little_uint : positive -> uint **)

  let rec to_little_uint = function
  | XI p0 -> Little.succ_double (to_little_uint p0)
  | XO p0 -> Little.double (to_little_uint p0)
  | XH -> D1 Nil

  (** val to_uint : positive -> uint **)

  let to_uint p =
    rev (to_little_uint p)

  (** val to_little_hex_uint : positive -> uint0 **)

  let rec to_little_hex_uint = function
  | XI p0 -> Coq_Little.succ_double (to_little_hex_uint p0)
  | XO p0 -> Coq_Little.double (to_little_hex_uint p0)
  | XH -> D11 Nil0

  (** val to_hex_uint : positive -> uint0 **)

  let to_hex_uint p =
    rev0 (to_little_hex_uint p)

  (** val eq_dec : positive -> positive -> bool **)

  let eq_dec x y =
    let rec f = function
    | XI p0 ->
      (fun x0 ->
        match x0 with
        | XI p1 -> if f p0 p1 then true else false
        | XO _ -> false
        | XH -> false)
    | XO p0 ->
      (fun x0 ->
        match x0 with
        | XI _ -> false
        | XO p1 -> if f p0 p1 then true else false
        | XH -> false)
    | XH ->
      (fun x0 -> match x0 with
                 | XI _ -> false
                 | XO _ -> false
                 | XH -> true)
    in f x y

  (** val peano_rect : 'a1 -> (positive -> 'a1 -> 'a1) -> positive -> 'a1 **)

  let rec peano_rect a f p =
    let f2 = peano_rect (f XH a) (fun p0 x -> f (succ (XO p0)) (f (XO p0) x))
    in
    (match p with
     | XI q0 -> f (XO q0) (f2 q0)
     | XO q0 -> f2 q0
     | XH -> a)
 end

module N =
 struct
  (** val double : n -> n **)

  let double = function
  | N0 -> N0
  | Npos p -> Npos (XO p)

  (** val add : n -> n -> n **)

  let add n3 m4 =
    match n3 with
    | N0 -> m4
    | Npos p -> (match m4 with
                 | N0 -> n3
                 | Npos q0 -> Npos (Coq_Pos.add p q0))

  (** val mul : n -> n -> n **)

  let mul n3 m4 =
    match n3 with
    | N0 -> N0
    | Npos p -> (match m4 with
                 | N0 -> N0
                 | Npos q0 -> Npos (Coq_Pos.mul p q0))

  (** val compare : n -> n -> comparison **)

  let compare n3 m4 =
    match n3 with
    | N0 -> (match m4 with
             | N0 -> Eq
             | Npos _ -> Lt)
    | Npos n' -> (match m4 with
                  | N0 -> Gt
                  | Npos m'0 -> Coq_Pos.compare n' m'0)

  (** val ltb : n -> n -> bool **)

  let ltb x y =
    match compare x y with
    | Eq -> false
    | Lt -> true
    | Gt -> false

  (** val to_uint : n -> uint **)

  let to_uint = function
  | N0 -> D0 Nil
  | Npos p -> Coq_Pos.to_uint p
 end

module Coq_N =
 struct
  type t = n

  (** val zero : n **)

  let zero =
    N0

  (** val one : n **)

  let one =
    Npos XH

  (** val two : n **)

  let two =
    Npos (XO XH)

  (** val succ_double : n -> n **)

  let succ_double = function
  | N0 -> Npos XH
  | Npos p -> Npos (XI p)

  (** val double : n -> n **)

  let double = function
  | N0 -> N0
  | Npos p -> Npos (XO p)

  (** val succ : n -> n **)

  let succ = function
  | N0 -> Npos XH
  | Npos p -> Npos (Coq_Pos.succ p)

  (** val pred : n -> n **)

  let pred = function
  | N0 -> N0
  | Npos p -> Coq_Pos.pred_N p

  (** val succ_pos : n -> positive **)

  let succ_pos = function
  | N0 -> XH
  | Npos p -> Coq_Pos.succ p

  (** val add : n -> n -> n **)

  let add n3 m4 =
    match n3 with
    | N0 -> m4
    | Npos p -> (match m4 with
                 | N0 -> n3
                 | Npos q0 -> Npos (Coq_Pos.add p q0))

  (** val sub : n -> n -> n **)

  let sub n3 m4 =
    match n3 with
    | N0 -> N0
    | Npos n' ->
      (match m4 with
       | N0 -> n3
       | Npos m'0 ->
         (match Coq_Pos.sub_mask n' m'0 with
          | Coq_Pos.IsNul -> N0
          | Coq_Pos.IsPos p -> Npos p
          | Coq_Pos.IsNeg -> N0))

  (** val mul : n -> n -> n **)

  let mul n3 m4 =
    match n3 with
    | N0 -> N0
    | Npos p -> (match m4 with
                 | N0 -> N0
                 | Npos q0 -> Npos (Coq_Pos.mul p q0))

  (** val compare : n -> n -> comparison **)

  let compare n3 m4 =
    match n3 with
    | N0 -> (match m4 with
             | N0 -> Eq
             | Npos _ -> Lt)
    | Npos n' -> (match m4 with
                  | N0 -> Gt
                  | Npos m'0 -> Coq_Pos.compare n' m'0)

  (** val eqb : n -> n -> bool **)

  let eqb n3 m4 =
    match n3 with
    | N0 -> (match m4 with
             | N0 -> true
             | Npos _ -> false)
    | Npos p -> (match m4 with
                 | N0 -> false
                 | Npos q0 -> Coq_Pos.eqb p q0)

  (** val leb : n -> n -> bool **)

  let leb x y =
    match compare x y with
    | Eq -> true
    | Lt -> true
    | Gt -> false

  (** val ltb : n -> n -> bool **)

  let ltb x y =
    match compare x y with
    | Eq -> false
    | Lt -> true
    | Gt -> false

  (** val min : n -> n -> n **)

  let min n3 n' =
    match compare n3 n' with
    | Eq -> n3
    | Lt -> n3
    | Gt -> n'

  (** val max : n -> n -> n **)

  let max n3 n' =
    match compare n3 n' with
    | Eq -> n'
    | Lt -> n'
    | Gt -> n3

  (** val div2 : n -> n **)

  let div2 = function
  | N0 -> N0
  | Npos p0 -> (match p0 with
                | XI p -> Npos p
                | XO p -> Npos p
                | XH -> N0)

  (** val even : n -> bool **)

  let even = function
  | N0 -> true
  | Npos p -> (match p with
               | XI _ -> false
               | XO _ -> true
               | XH -> false)

  (** val odd : n -> bool **)

  let odd n3 =
    negb (even n3)

  (** val pow : n -> n -> n **)

  let pow n3 = function
  | N0 -> Npos XH
  | Npos p0 -> (match n3 with
                | N0 -> N0
                | Npos q0 -> Npos (Coq_Pos.pow q0 p0))

  (** val square : n -> n **)

  let square = function
  | N0 -> N0
  | Npos p -> Npos (Coq_Pos.square p)

  (** val log2 : n -> n **)

  let log2 = function
  | N0 -> N0
  | Npos p0 ->
    (match p0 with
     | XI p -> Npos (Coq_Pos.size p)
     | XO p -> Npos (Coq_Pos.size p)
     | XH -> N0)

  (** val size : n -> n **)

  let size = function
  | N0 -> N0
  | Npos p -> Npos (Coq_Pos.size p)

  (** val size_nat : n -> nat **)

  let size_nat = function
  | N0 -> O
  | Npos p -> Coq_Pos.size_nat p

  (** val pos_div_eucl : positive -> n -> n * n **)

  let rec pos_div_eucl a b =
    match a with
    | XI a' ->
      let (q0, r0) = pos_div_eucl a' b in
      let r'0 = succ_double r0 in
      if leb b r'0
      then ((succ_double q0), (sub r'0 b))
      else ((double q0), r'0)
    | XO a' ->
      let (q0, r0) = pos_div_eucl a' b in
      let r'0 = double r0 in
      if leb b r'0
      then ((succ_double q0), (sub r'0 b))
      else ((double q0), r'0)
    | XH ->
      (match b with
       | N0 -> (N0, (Npos XH))
       | Npos p ->
         (match p with
          | XI _ -> (N0, (Npos XH))
          | XO _ -> (N0, (Npos XH))
          | XH -> ((Npos XH), N0)))

  (** val div_eucl : n -> n -> n * n **)

  let div_eucl a b =
    match a with
    | N0 -> (N0, N0)
    | Npos na -> (match b with
                  | N0 -> (N0, a)
                  | Npos _ -> pos_div_eucl na b)

  (** val div : n -> n -> n **)

  let div a b =
    fst (div_eucl a b)

  (** val modulo : n -> n -> n **)

  let modulo a b =
    snd (div_eucl a b)

  (** val gcd : n -> n -> n **)

  let gcd a b =
    match a with
    | N0 -> b
    | Npos p -> (match b with
                 | N0 -> a
                 | Npos q0 -> Npos (Coq_Pos.gcd p q0))

  (** val ggcd : n -> n -> n * (n * n) **)

  let ggcd a b =
    match a with
    | N0 -> (b, (N0, (Npos XH)))
    | Npos p ->
      (match b with
       | N0 -> (a, ((Npos XH), N0))
       | Npos q0 ->
         let (g, p0) = Coq_Pos.ggcd p q0 in
         let (aa, bb) = p0 in ((Npos g), ((Npos aa), (Npos bb))))

  (** val sqrtrem : n -> n * n **)

  let sqrtrem = function
  | N0 -> (N0, N0)
  | Npos p ->
    let (s0, m4) = Coq_Pos.sqrtrem p in
    (match m4 with
     | Coq_Pos.IsNul -> ((Npos s0), N0)
     | Coq_Pos.IsPos r0 -> ((Npos s0), (Npos r0))
     | Coq_Pos.IsNeg -> ((Npos s0), N0))

  (** val sqrt : n -> n **)

  let sqrt = function
  | N0 -> N0
  | Npos p -> Npos (Coq_Pos.sqrt p)

  (** val coq_lor : n -> n -> n **)

  let coq_lor n3 m4 =
    match n3 with
    | N0 -> m4
    | Npos p ->
      (match m4 with
       | N0 -> n3
       | Npos q0 -> Npos (Coq_Pos.coq_lor p q0))

  (** val coq_land : n -> n -> n **)

  let coq_land n3 m4 =
    match n3 with
    | N0 -> N0
    | Npos p -> (match m4 with
                 | N0 -> N0
                 | Npos q0 -> Coq_Pos.coq_land p q0)

  (** val ldiff : n -> n -> n **)

  let ldiff n3 m4 =
    match n3 with
    | N0 -> N0
    | Npos p -> (match m4 with
                 | N0 -> n3
                 | Npos q0 -> Coq_Pos.ldiff p q0)

  (** val coq_lxor : n -> n -> n **)

  let coq_lxor n3 m4 =
    match n3 with
    | N0 -> m4
    | Npos p -> (match m4 with
                 | N0 -> n3
                 | Npos q0 -> Coq_Pos.coq_lxor p q0)

  (** val shiftl_nat : n -> nat -> n **)

  let shiftl_nat a =
    let rec f = function
    | O -> a
    | S n4 -> double (f n4)
    in f

  (** val shiftr_nat : n -> nat -> n **)

  let shiftr_nat a =
    let rec f = function
    | O -> a
    | S n4 -> div2 (f n4)
    in f

  (** val shiftl : n -> n -> n **)

  let shiftl a n3 =
    match a with
    | N0 -> N0
    | Npos a0 -> Npos (Coq_Pos.shiftl a0 n3)

  (** val shiftr : n -> n -> n **)

  let shiftr a = function
  | N0 -> a
  | Npos p -> Coq_Pos.iter div2 a p

  (** val testbit_nat : n -> nat -> bool **)

  let testbit_nat = function
  | N0 -> (fun _ -> false)
  | Npos p -> Coq_Pos.testbit_nat p

  (** val testbit : n -> n -> bool **)

  let testbit a n3 =
    match a with
    | N0 -> false
    | Npos p -> Coq_Pos.testbit p n3

  (** val to_nat : n -> nat **)

  let to_nat = function
  | N0 -> O
  | Npos p -> Coq_Pos.to_nat p

  (** val of_nat : nat -> n **)

  let of_nat = function
  | O -> N0
  | S n' -> Npos (Coq_Pos.of_succ_nat n')

  (** val iter : n -> ('a1 -> 'a1) -> 'a1 -> 'a1 **)

  let iter n3 f x =
    match n3 with
    | N0 -> x
    | Npos p -> Coq_Pos.iter f x p

  (** val of_uint : uint -> n **)

  let of_uint =
    Coq_Pos.of_uint

  (** val of_hex_uint : uint0 -> n **)

  let of_hex_uint =
    Coq_Pos.of_hex_uint

  (** val of_num_uint : uint1 -> n **)

  let of_num_uint = function
  | UIntDecimal d0 -> of_uint d0
  | UIntHexadecimal d0 -> of_hex_uint d0

  (** val of_int : signed_int -> n option **)

  let of_int d =
    match norm d with
    | Pos d0 -> Some (Coq_Pos.of_uint d0)
    | Neg _ -> None

  (** val of_hex_int : signed_int0 -> n option **)

  let of_hex_int d =
    match norm0 d with
    | Pos0 d0 -> Some (Coq_Pos.of_hex_uint d0)
    | Neg0 _ -> None

  (** val of_num_int : signed_int1 -> n option **)

  let of_num_int = function
  | IntDecimal d0 -> of_int d0
  | IntHexadecimal d0 -> of_hex_int d0

  (** val to_uint : n -> uint **)

  let to_uint = function
  | N0 -> D0 Nil
  | Npos p -> Coq_Pos.to_uint p

  (** val to_hex_uint : n -> uint0 **)

  let to_hex_uint = function
  | N0 -> D10 Nil0
  | Npos p -> Coq_Pos.to_hex_uint p

  (** val to_num_uint : n -> uint1 **)

  let to_num_uint n3 =
    UIntDecimal (to_uint n3)

  (** val to_num_hex_uint : n -> uint1 **)

  let to_num_hex_uint n3 =
    UIntHexadecimal (to_hex_uint n3)

  (** val to_int : n -> signed_int **)

  let to_int n3 =
    Pos (to_uint n3)

  (** val to_hex_int : n -> signed_int0 **)

  let to_hex_int n3 =
    Pos0 (to_hex_uint n3)

  (** val to_num_int : n -> signed_int1 **)

  let to_num_int n3 =
    IntDecimal (to_int n3)

  (** val to_num_hex_int : n -> signed_int1 **)

  let to_num_hex_int n3 =
    IntHexadecimal (to_hex_int n3)

  (** val eq_dec : n -> n -> bool **)

  let eq_dec n3 m4 =
    (match n3 with
     | N0 -> (fun x -> match x with
                       | N0 -> true
                       | Npos _ -> false)
     | Npos p ->
       (fun x ->
         match x with
         | N0 -> false
         | Npos p0 -> if Coq_Pos.eq_dec p p0 then true else false)) m4

  (** val discr : n -> positive option **)

  let discr = function
  | N0 -> None
  | Npos p -> Some p

  (** val binary_rect :
      'a1 -> (n -> 'a1 -> 'a1) -> (n -> 'a1 -> 'a1) -> n -> 'a1 **)

  let binary_rect f0 f2 fS2 n3 =
    let f2' = fun p -> f2 (Npos p) in
    let fS2' = fun p -> fS2 (Npos p) in
    (match n3 with
     | N0 -> f0
     | Npos p ->
       let rec f = function
       | XI p1 -> fS2' p1 (f p1)
       | XO p1 -> f2' p1 (f p1)
       | XH -> fS2 N0 f0
       in f p)

  (** val binary_rec :
      'a1 -> (n -> 'a1 -> 'a1) -> (n -> 'a1 -> 'a1) -> n -> 'a1 **)

  let binary_rec =
    binary_rect

  (** val peano_rect : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1 **)

  let peano_rect f0 f n3 =
    let f' = fun p -> f (Npos p) in
    (match n3 with
     | N0 -> f0
     | Npos p -> Coq_Pos.peano_rect (f N0 f0) f' p)

  (** val peano_rec : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1 **)

  let peano_rec =
    peano_rect

  (** val recursion : 'a1 -> (n -> 'a1 -> 'a1) -> n -> 'a1 **)

  let recursion =
    peano_rect

  (** val leb_spec0 : n -> n -> reflect **)

  let leb_spec0 x y =
    iff_reflect (leb x y)

  (** val ltb_spec0 : n -> n -> reflect **)

  let ltb_spec0 x y =
    iff_reflect (ltb x y)

  module Private_OrderTac =
   struct
    module IsTotal =
     struct
     end

    module Tac =
     struct
     end
   end

  (** val measure_right_induction :
      ('a1 -> n) -> n -> ('a1 -> __ -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 ->
      'a2 **)

  let measure_right_induction f _ iH x =
    (let t0 = f x in
     let rec f0 _ _ _ y _ =
       iH y __ (fun y' _ -> let y0 = f y' in f0 y0 __ __ y' __)
     in f0 t0 __ __) x __

  (** val measure_left_induction :
      ('a1 -> n) -> n -> ('a1 -> __ -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 ->
      'a2 **)

  let measure_left_induction f _ iH x =
    (let t0 = f x in
     let rec f0 _ _ _ y _ =
       iH y __ (fun y' _ -> let y0 = f y' in f0 y0 __ __ y' __)
     in f0 t0 __ __) x __

  (** val measure_induction :
      ('a1 -> n) -> ('a1 -> ('a1 -> __ -> 'a2) -> 'a2) -> 'a1 -> 'a2 **)

  let measure_induction f iH x =
    measure_right_induction f N0 (fun y _ iH' ->
      iH y (fun y0 _ -> iH' y0 __)) x

  module Private_Tac =
   struct
   end

  module Private_Dec =
   struct
    (** val max_case_strong :
        n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1)
        -> 'a1 **)

    let max_case_strong n3 m4 compat hl hr =
      let c0 = compSpec2Type n3 m4 (compare n3 m4) in
      (match c0 with
       | CompEqT -> compat m4 (max n3 m4) __ (hr __)
       | CompLtT -> compat m4 (max n3 m4) __ (hr __)
       | CompGtT -> compat n3 (max n3 m4) __ (hl __))

    (** val max_case :
        n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1 **)

    let max_case n3 m4 x x0 x1 =
      max_case_strong n3 m4 x (fun _ -> x0) (fun _ -> x1)

    (** val max_dec : n -> n -> bool **)

    let max_dec n3 m4 =
      max_case n3 m4 (fun _ _ _ h0 -> if h0 then true else false) true false

    (** val min_case_strong :
        n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> (__ -> 'a1) -> (__ -> 'a1)
        -> 'a1 **)

    let min_case_strong n3 m4 compat hl hr =
      let c0 = compSpec2Type n3 m4 (compare n3 m4) in
      (match c0 with
       | CompEqT -> compat n3 (min n3 m4) __ (hl __)
       | CompLtT -> compat n3 (min n3 m4) __ (hl __)
       | CompGtT -> compat m4 (min n3 m4) __ (hr __))

    (** val min_case :
        n -> n -> (n -> n -> __ -> 'a1 -> 'a1) -> 'a1 -> 'a1 -> 'a1 **)

    let min_case n3 m4 x x0 x1 =
      min_case_strong n3 m4 x (fun _ -> x0) (fun _ -> x1)

    (** val min_dec : n -> n -> bool **)

    let min_dec n3 m4 =
      min_case n3 m4 (fun _ _ _ h0 -> if h0 then true else false) true false
   end

  (** val max_case_strong : n -> n -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1 **)

  let max_case_strong n3 m4 x x0 =
    Private_Dec.max_case_strong n3 m4 (fun _ _ _ x1 -> x1) x x0

  (** val max_case : n -> n -> 'a1 -> 'a1 -> 'a1 **)

  let max_case n3 m4 x x0 =
    max_case_strong n3 m4 (fun _ -> x) (fun _ -> x0)

  (** val max_dec : n -> n -> bool **)

  let max_dec =
    Private_Dec.max_dec

  (** val min_case_strong : n -> n -> (__ -> 'a1) -> (__ -> 'a1) -> 'a1 **)

  let min_case_strong n3 m4 x x0 =
    Private_Dec.min_case_strong n3 m4 (fun _ _ _ x1 -> x1) x x0

  (** val min_case : n -> n -> 'a1 -> 'a1 -> 'a1 **)

  let min_case n3 m4 x x0 =
    min_case_strong n3 m4 (fun _ -> x) (fun _ -> x0)

  (** val min_dec : n -> n -> bool **)

  let min_dec =
    Private_Dec.min_dec

  module Private_NZPow =
   struct
   end

  module Private_NZSqrt =
   struct
   end

  (** val sqrt_up : n -> n **)

  let sqrt_up a =
    match compare N0 a with
    | Eq -> N0
    | Lt -> succ (sqrt (pred a))
    | Gt -> N0

  (** val log2_up : n -> n **)

  let log2_up a =
    match compare (Npos XH) a with
    | Eq -> N0
    | Lt -> succ (log2 (pred a))
    | Gt -> N0

  module Private_NZGcdProp =
   struct
   end

  module Private_NDivProp =
   struct
    module Private_NZDiv =
     struct
     end
   end

  module Div0 =
   struct
   end

  module Private_NLcmProp =
   struct
    (** val lcm : n -> n -> n **)

    let lcm a b =
      mul a (div b (gcd a b))
   end

  (** val lcm : n -> n -> n **)

  let lcm a b =
    mul a (div b (gcd a b))

  module Lcm0 =
   struct
   end

  (** val eqb_spec : n -> n -> reflect **)

  let eqb_spec x y =
    iff_reflect (eqb x y)

  (** val b2n : bool -> n **)

  let b2n = function
  | true -> Npos XH
  | false -> N0

  (** val setbit : n -> n -> n **)

  let setbit a n3 =
    coq_lor a (shiftl (Npos XH) n3)

  (** val clearbit : n -> n -> n **)

  let clearbit a n3 =
    ldiff a (shiftl (Npos XH) n3)

  (** val ones : n -> n **)

  let ones n3 =
    pred (shiftl (Npos XH) n3)

  (** val lnot : n -> n -> n **)

  let lnot a n3 =
    coq_lxor a (ones n3)
 end

(** val pow_pos : ('a1 -> 'a1 -> 'a1) -> 'a1 -> positive -> 'a1 **)

let pow_pos rmul =
  let rec pow_pos0 x = function
  | XI i0 -> let p = pow_pos0 x i0 in rmul x (rmul p p)
  | XO i0 -> let p = pow_pos0 x i0 in rmul p p
  | XH -> x
  in pow_pos0

module Z =
 struct
  (** val opp : z -> z **)

  let opp = function
  | Z0 -> Z0
  | Zpos x0 -> Zneg x0
  | Zneg x0 -> Zpos x0

  (** val to_nat : z -> nat **)

  let to_nat = function
  | Z0 -> O
  | Zpos p -> Coq_Pos.to_nat p
  | Zneg _ -> O

  (** val of_nat : nat -> z **)

  let of_nat = function
  | O -> Z0
  | S n4 -> Zpos (Coq_Pos.of_succ_nat n4)

  (** val of_N : n -> z **)

  let of_N = function
  | N0 -> Z0
  | Npos p -> Zpos p

  (** val of_uint : uint -> z **)

  let of_uint d =
    of_N (Coq_Pos.of_uint d)

  (** val of_int : signed_int -> z **)

  let of_int = function
  | Pos d0 -> of_uint d0
  | Neg d0 -> opp (of_uint d0)

  (** val to_int : z -> signed_int **)

  let to_int = function
  | Z0 -> Pos (D0 Nil)
  | Zpos p -> Pos (Coq_Pos.to_uint p)
  | Zneg p -> Neg (Coq_Pos.to_uint p)
 end

module Coq_Z =
 struct
  (** val double : z -> z **)

  let double = function
  | Z0 -> Z0
  | Zpos p -> Zpos (XO p)
  | Zneg p -> Zneg (XO p)

  (** val succ_double : z -> z **)

  let succ_double = function
  | Z0 -> Zpos XH
  | Zpos p -> Zpos (XI p)
  | Zneg p -> Zneg (Coq_Pos.pred_double p)

  (** val pred_double : z -> z **)

  let pred_double = function
  | Z0 -> Zneg XH
  | Zpos p -> Zpos (Coq_Pos.pred_double p)
  | Zneg p -> Zneg (XI p)

  (** val pos_sub : positive -> positive -> z **)

  let rec pos_sub x y =
    match x with
    | XI p ->
      (match y with
       | XI q0 -> double (pos_sub p q0)
       | XO q0 -> succ_double (pos_sub p q0)
       | XH -> Zpos (XO p))
    | XO p ->
      (match y with
       | XI q0 -> pred_double (pos_sub p q0)
       | XO q0 -> double (pos_sub p q0)
       | XH -> Zpos (Coq_Pos.pred_double p))
    | XH ->
      (match y with
       | XI q0 -> Zneg (XO q0)
       | XO q0 -> Zneg (Coq_Pos.pred_double q0)
       | XH -> Z0)

  (** val add : z -> z -> z **)

  let add x y =
    match x with
    | Z0 -> y
    | Zpos x' ->
      (match y with
       | Z0 -> x
       | Zpos y' -> Zpos (Coq_Pos.add x' y')
       | Zneg y' -> pos_sub x' y')
    | Zneg x' ->
      (match y with
       | Z0 -> x
       | Zpos y' -> pos_sub y' x'
       | Zneg y' -> Zneg (Coq_Pos.add x' y'))

  (** val opp : z -> z **)

  let opp = function
  | Z0 -> Z0
  | Zpos x0 -> Zneg x0
  | Zneg x0 -> Zpos x0

  (** val succ : z -> z **)

  let succ x =
    add x (Zpos XH)

  (** val pred : z -> z **)

  let pred x =
    add x (Zneg XH)

  (** val sub : z -> z -> z **)

  let sub m4 n3 =
    add m4 (opp n3)

  (** val mul : z -> z -> z **)

  let mul x y =
    match x with
    | Z0 -> Z0
    | Zpos x' ->
      (match y with
       | Z0 -> Z0
       | Zpos y' -> Zpos (Coq_Pos.mul x' y')
       | Zneg y' -> Zneg (Coq_Pos.mul x' y'))
    | Zneg x' ->
      (match y with
       | Z0 -> Z0
       | Zpos y' -> Zneg (Coq_Pos.mul x' y')
       | Zneg y' -> Zpos (Coq_Pos.mul x' y'))

  (** val pow_pos : z -> positive -> z **)

  let pow_pos z0 =
    Coq_Pos.iter (mul z0) (Zpos XH)

  (** val pow : z -> z -> z **)

  let pow x = function
  | Z0 -> Zpos XH
  | Zpos p -> pow_pos x p
  | Zneg _ -> Z0

  (** val compare : z -> z -> comparison **)

  let compare x y =
    match x with
    | Z0 -> (match y with
             | Z0 -> Eq
             | Zpos _ -> Lt
             | Zneg _ -> Gt)
    | Zpos x' ->
      (match y with
       | Z0 -> Gt
       | Zpos y' -> Coq_Pos.compare x' y'
       | Zneg _ -> Gt)
    | Zneg x' ->
      (match y with
       | Z0 -> Lt
       | Zpos _ -> Lt
       | Zneg y' -> compOpp (Coq_Pos.compare x' y'))

  (** val sgn : z -> z **)

  let sgn = function
  | Z0 -> Z0
  | Zpos _ -> Zpos XH
  | Zneg _ -> Zneg XH

  (** val leb : z -> z -> bool **)

  let leb x y =
    match compare x y with
    | Eq -> true
    | Lt -> true
    | Gt -> false

  (** val ltb : z -> z -> bool **)

  let ltb x y =
    match compare x y with
    | Eq -> false
    | Lt -> true
    | Gt -> false

  (** val geb : z -> z -> bool **)

  let geb x y =
    match compare x y with
    | Eq -> true
    | Lt -> false
    | Gt -> true

  (** val gtb : z -> z -> bool **)

  let gtb x y =
    match compare x y with
    | Eq -> false
    | Lt -> false
    | Gt -> true

  (** val eqb : z -> z -> bool **)

  let eqb x y =
    match x with
    | Z0 -> (match y with
             | Z0 -> true
             | Zpos _ -> false
             | Zneg _ -> false)
    | Zpos p ->
      (match y with
       | Z0 -> false
       | Zpos q0 -> Coq_Pos.eqb p q0
       | Zneg _ -> false)
    | Zneg p ->
      (match y with
       | Z0 -> false
       | Zpos _ -> false
       | Zneg q0 -> Coq_Pos.eqb p q0)

  (** val max : z -> z -> z **)

  let max n3 m4 =
    match compare n3 m4 with
    | Eq -> n3
    | Lt -> m4
    | Gt -> n3

  (** val min : z -> z -> z **)

  let min n3 m4 =
    match compare n3 m4 with
    | Eq -> n3
    | Lt -> n3
    | Gt -> m4

  (** val abs : z -> z **)

  let abs = function
  | Z0 -> Z0
  | Zpos p -> Zpos p
  | Zneg p -> Zpos p

  (** val to_nat : z -> nat **)

  let to_nat = function
  | Z0 -> O
  | Zpos p -> Coq_Pos.to_nat p
  | Zneg _ -> O

  (** val to_N : z -> n **)

  let to_N = function
  | Z0 -> N0
  | Zpos p -> Npos p
  | Zneg _ -> N0

  (** val of_nat : nat -> z **)

  let of_nat = function
  | O -> Z0
  | S n4 -> Zpos (Coq_Pos.of_succ_nat n4)

  (** val of_N : n -> z **)

  let of_N = function
  | N0 -> Z0
  | Npos p -> Zpos p

  (** val to_pos : z -> positive **)

  let to_pos = function
  | Z0 -> XH
  | Zpos p -> p
  | Zneg _ -> XH

  (** val to_int : z -> signed_int **)

  let to_int = function
  | Z0 -> Pos (D0 Nil)
  | Zpos p -> Pos (Coq_Pos.to_uint p)
  | Zneg p -> Neg (Coq_Pos.to_uint p)

  (** val pos_div_eucl : positive -> z -> z * z **)

  let rec pos_div_eucl a b =
    match a with
    | XI a' ->
      let (q0, r0) = pos_div_eucl a' b in
      let r'0 = add (mul (Zpos (XO XH)) r0) (Zpos XH) in
      if ltb r'0 b
      then ((mul (Zpos (XO XH)) q0), r'0)
      else ((add (mul (Zpos (XO XH)) q0) (Zpos XH)), (sub r'0 b))
    | XO a' ->
      let (q0, r0) = pos_div_eucl a' b in
      let r'0 = mul (Zpos (XO XH)) r0 in
      if ltb r'0 b
      then ((mul (Zpos (XO XH)) q0), r'0)
      else ((add (mul (Zpos (XO XH)) q0) (Zpos XH)), (sub r'0 b))
    | XH -> if leb (Zpos (XO XH)) b then (Z0, (Zpos XH)) else ((Zpos XH), Z0)

  (** val div_eucl : z -> z -> z * z **)

  let div_eucl a b =
    match a with
    | Z0 -> (Z0, Z0)
    | Zpos a' ->
      (match b with
       | Z0 -> (Z0, a)
       | Zpos _ -> pos_div_eucl a' b
       | Zneg b' ->
         let (q0, r0) = pos_div_eucl a' (Zpos b') in
         (match r0 with
          | Z0 -> ((opp q0), Z0)
          | Zpos _ -> ((opp (add q0 (Zpos XH))), (add b r0))
          | Zneg _ -> ((opp (add q0 (Zpos XH))), (add b r0))))
    | Zneg a' ->
      (match b with
       | Z0 -> (Z0, a)
       | Zpos _ ->
         let (q0, r0) = pos_div_eucl a' b in
         (match r0 with
          | Z0 -> ((opp q0), Z0)
          | Zpos _ -> ((opp (add q0 (Zpos XH))), (sub b r0))
          | Zneg _ -> ((opp (add q0 (Zpos XH))), (sub b r0)))
       | Zneg b' -> let (q0, r0) = pos_div_eucl a' (Zpos b') in (q0, (opp r0)))

  (** val div : z -> z -> z **)

  let div a b =
    let (q0, _) = div_eucl a b in q0

  (** val modulo : z -> z -> z **)

  let modulo a b =
    let (_, r0) = div_eucl a b in r0

  (** val quotrem : z -> z -> z * z **)

  let quotrem a b =
    match a with
    | Z0 -> (Z0, Z0)
    | Zpos a0 ->
      (match b with
       | Z0 -> (Z0, a)
       | Zpos b0 ->
         let (q0, r0) = Coq_N.pos_div_eucl a0 (Npos b0) in
         ((of_N q0), (of_N r0))
       | Zneg b0 ->
         let (q0, r0) = Coq_N.pos_div_eucl a0 (Npos b0) in
         ((opp (of_N q0)), (of_N r0)))
    | Zneg a0 ->
      (match b with
       | Z0 -> (Z0, a)
       | Zpos b0 ->
         let (q0, r0) = Coq_N.pos_div_eucl a0 (Npos b0) in
         ((opp (of_N q0)), (opp (of_N r0)))
       | Zneg b0 ->
         let (q0, r0) = Coq_N.pos_div_eucl a0 (Npos b0) in
         ((of_N q0), (opp (of_N r0))))

  (** val quot : z -> z -> z **)

  let quot a b =
    fst (quotrem a b)

  (** val rem : z -> z -> z **)

  let rem a b =
    snd (quotrem a b)

  (** val div2 : z -> z **)

  let div2 = function
  | Z0 -> Z0
  | Zpos p ->
    (match p with
     | XI _ -> Zpos (Coq_Pos.div2 p)
     | XO _ -> Zpos (Coq_Pos.div2 p)
     | XH -> Z0)
  | Zneg p -> Zneg (Coq_Pos.div2_up p)

  (** val log2 : z -> z **)

  let log2 = function
  | Z0 -> Z0
  | Zpos p0 ->
    (match p0 with
     | XI p -> Zpos (Coq_Pos.size p)
     | XO p -> Zpos (Coq_Pos.size p)
     | XH -> Z0)
  | Zneg _ -> Z0

  (** val ggcd : z -> z -> z * (z * z) **)

  let ggcd a b =
    match a with
    | Z0 -> ((abs b), (Z0, (sgn b)))
    | Zpos a0 ->
      (match b with
       | Z0 -> ((abs a), ((sgn a), Z0))
       | Zpos b0 ->
         let (g, p) = Coq_Pos.ggcd a0 b0 in
         let (aa, bb) = p in ((Zpos g), ((Zpos aa), (Zpos bb)))
       | Zneg b0 ->
         let (g, p) = Coq_Pos.ggcd a0 b0 in
         let (aa, bb) = p in ((Zpos g), ((Zpos aa), (Zneg bb))))
    | Zneg a0 ->
      (match b with
       | Z0 -> ((abs a), ((sgn a), Z0))
       | Zpos b0 ->
         let (g, p) = Coq_Pos.ggcd a0 b0 in
         let (aa, bb) = p in ((Zpos g), ((Zneg aa), (Zpos bb)))
       | Zneg b0 ->
         let (g, p) = Coq_Pos.ggcd a0 b0 in
         let (aa, bb) = p in ((Zpos g), ((Zneg aa), (Zneg bb))))

  (** val shiftl : z -> z -> z **)

  let shiftl a = function
  | Z0 -> a
  | Zpos p -> Coq_Pos.iter (mul (Zpos (XO XH))) a p
  | Zneg p -> Coq_Pos.iter div2 a p

  (** val shiftr : z -> z -> z **)

  let shiftr a n3 =
    shiftl a (opp n3)

  (** val coq_lor : z -> z -> z **)

  let coq_lor a b =
    match a with
    | Z0 -> b
    | Zpos a0 ->
      (match b with
       | Z0 -> a
       | Zpos b0 -> Zpos (Coq_Pos.coq_lor a0 b0)
       | Zneg b0 ->
         Zneg (Coq_N.succ_pos (Coq_N.ldiff (Coq_Pos.pred_N b0) (Npos a0))))
    | Zneg a0 ->
      (match b with
       | Z0 -> a
       | Zpos b0 ->
         Zneg (Coq_N.succ_pos (Coq_N.ldiff (Coq_Pos.pred_N a0) (Npos b0)))
       | Zneg b0 ->
         Zneg
           (Coq_N.succ_pos
             (Coq_N.coq_land (Coq_Pos.pred_N a0) (Coq_Pos.pred_N b0))))

  (** val coq_land : z -> z -> z **)

  let coq_land a b =
    match a with
    | Z0 -> Z0
    | Zpos a0 ->
      (match b with
       | Z0 -> Z0
       | Zpos b0 -> of_N (Coq_Pos.coq_land a0 b0)
       | Zneg b0 -> of_N (Coq_N.ldiff (Npos a0) (Coq_Pos.pred_N b0)))
    | Zneg a0 ->
      (match b with
       | Z0 -> Z0
       | Zpos b0 -> of_N (Coq_N.ldiff (Npos b0) (Coq_Pos.pred_N a0))
       | Zneg b0 ->
         Zneg
           (Coq_N.succ_pos
             (Coq_N.coq_lor (Coq_Pos.pred_N a0) (Coq_Pos.pred_N b0))))

  (** val ldiff : z -> z -> z **)

  let ldiff a b =
    match a with
    | Z0 -> Z0
    | Zpos a0 ->
      (match b with
       | Z0 -> a
       | Zpos b0 -> of_N (Coq_Pos.ldiff a0 b0)
       | Zneg b0 -> of_N (Coq_N.coq_land (Npos a0) (Coq_Pos.pred_N b0)))
    | Zneg a0 ->
      (match b with
       | Z0 -> a
       | Zpos b0 ->
         Zneg (Coq_N.succ_pos (Coq_N.coq_lor (Coq_Pos.pred_N a0) (Npos b0)))
       | Zneg b0 -> of_N (Coq_N.ldiff (Coq_Pos.pred_N b0) (Coq_Pos.pred_N a0)))

  (** val coq_lxor : z -> z -> z **)

  let coq_lxor a b =
    match a with
    | Z0 -> b
    | Zpos a0 ->
      (match b with
       | Z0 -> a
       | Zpos b0 -> of_N (Coq_Pos.coq_lxor a0 b0)
       | Zneg b0 ->
         Zneg (Coq_N.succ_pos (Coq_N.coq_lxor (Npos a0) (Coq_Pos.pred_N b0))))
    | Zneg a0 ->
      (match b with
       | Z0 -> a
       | Zpos b0 ->
         Zneg (Coq_N.succ_pos (Coq_N.coq_lxor (Coq_Pos.pred_N a0) (Npos b0)))
       | Zneg b0 ->
         of_N (Coq_N.coq_lxor (Coq_Pos.pred_N a0) (Coq_Pos.pred_N b0)))

  (** val eq_dec : z -> z -> bool **)

  let eq_dec x y =
    (match x with
     | Z0 ->
       (fun x0 -> match x0 with
                  | Z0 -> true
                  | Zpos _ -> false
                  | Zneg _ -> false)
     | Zpos p ->
       (fun x0 ->
         match x0 with
         | Z0 -> false
         | Zpos p0 -> if Coq_Pos.eq_dec p p0 then true else false
         | Zneg _ -> false)
     | Zneg p ->
       (fun x0 ->
         match x0 with
         | Z0 -> false
         | Zpos _ -> false
         | Zneg p0 -> if Coq_Pos.eq_dec p p0 then true else false)) y

  (** val log2_up : z -> z **)

  let log2_up a =
    match compare (Zpos XH) a with
    | Eq -> Z0
    | Lt -> succ (log2 (pred a))
    | Gt -> Z0

  (** val eqb_spec : z -> z -> reflect **)

  let eqb_spec x y =
    iff_reflect (eqb x y)

  (** val b2z : bool -> z **)

  let b2z = function
  | true -> Zpos XH
  | false -> Z0

  (** val lnot : z -> z **)

  let lnot a =
    pred (opp a)

  (** val ones : z -> z **)

  let ones n3 =
    pred (shiftl (Zpos XH) n3)
 end

(** val z_lt_dec : z -> z -> bool **)

let z_lt_dec x y =
  match Coq_Z.compare x y with
  | Eq -> false
  | Lt -> true
  | Gt -> false

(** val zeq_bool : z -> z -> bool **)

let zeq_bool x y =
  match Coq_Z.compare x y with
  | Eq -> true
  | Lt -> false
  | Gt -> false

(** val to_N0 : char -> n **)

let to_N0 = function
| '\x00' -> N0
| '\x01' -> Npos XH
| '\x02' -> Npos (XO XH)
| '\x03' -> Npos (XI XH)
| '\x04' -> Npos (XO (XO XH))
| '\x05' -> Npos (XI (XO XH))
| '\x06' -> Npos (XO (XI XH))
| '\x07' -> Npos (XI (XI XH))
| '\x08' -> Npos (XO (XO (XO XH)))
| '\t' -> Npos (XI (XO (XO XH)))
| '\n' -> Npos (XO (XI (XO XH)))
| '\x0b' -> Npos (XI (XI (XO XH)))
| '\x0c' -> Npos (XO (XO (XI XH)))
| '\r' -> Npos (XI (XO (XI XH)))
| '\x0e' -> Npos (XO (XI (XI XH)))
| '\x0f' -> Npos (XI (XI (XI XH)))
| '\x10' -> Npos (XO (XO (XO (XO XH))))
| '\x11' -> Npos (XI (XO (XO (XO XH))))
| '\x12' -> Npos (XO (XI (XO (XO XH))))
| '\x13' -> Npos (XI (XI (XO (XO XH))))
| '\x14' -> Npos (XO (XO (XI (XO XH))))
| '\x15' -> Npos (XI (XO (XI (XO XH))))
| '\x16' -> Npos (XO (XI (XI (XO XH))))
| '\x17' -> Npos (XI (XI (XI (XO XH))))
| '\x18' -> Npos (XO (XO (XO (XI XH))))
| '\x19' -> Npos (XI (XO (XO (XI XH))))
| '\x1a' -> Npos (XO (XI (XO (XI XH))))
| '\x1b' -> Npos (XI (XI (XO (XI XH))))
| '\x1c' -> Npos (XO (XO (XI (XI XH))))
| '\x1d' -> Npos (XI (XO (XI (XI XH))))
| '\x1e' -> Npos (XO (XI (XI (XI XH))))
| '\x1f' -> Npos (XI (XI (XI (XI XH))))
| ' ' -> Npos (XO (XO (XO (XO (XO XH)))))
| '!' -> Npos (XI (XO (XO (XO (XO XH)))))
| '"' -> Npos (XO (XI (XO (XO (XO XH)))))
| '#' -> Npos (XI (XI (XO (XO (XO XH)))))
| '$' -> Npos (XO (XO (XI (XO (XO XH)))))
| '%' -> Npos (XI (XO (XI (XO (XO XH)))))
| '&' -> Npos (XO (XI (XI (XO (XO XH)))))
| '\'' -> Npos (XI (XI (XI (XO (XO XH)))))
| '(' -> Npos (XO (XO (XO (XI (XO XH)))))
| ')' -> Npos (XI (XO (XO (XI (XO XH)))))
| '*' -> Npos (XO (XI (XO (XI (XO XH)))))
| '+' -> Npos (XI (XI (XO (XI (XO XH)))))
| ',' -> Npos (XO (XO (XI (XI (XO XH)))))
| '-' -> Npos (XI (XO (XI (XI (XO XH)))))
| '.' -> Npos (XO (XI (XI (XI (XO XH)))))
| '/' -> Npos (XI (XI (XI (XI (XO XH)))))
| '0' -> Npos (XO (XO (XO (XO (XI XH)))))
| '1' -> Npos (XI (XO (XO (XO (XI XH)))))
| '2' -> Npos (XO (XI (XO (XO (XI XH)))))
| '3' -> Npos (XI (XI (XO (XO (XI XH)))))
| '4' -> Npos (XO (XO (XI (XO (XI XH)))))
| '5' -> Npos (XI (XO (XI (XO (XI XH)))))
| '6' -> Npos (XO (XI (XI (XO (XI XH)))))
| '7' -> Npos (XI (XI (XI (XO (XI XH)))))
| '8' -> Npos (XO (XO (XO (XI (XI XH)))))
| '9' -> Npos (XI (XO (XO (XI (XI XH)))))
| ':' -> Npos (XO (XI (XO (XI (XI XH)))))
| ';' -> Npos (XI (XI (XO (XI (XI XH)))))
| '<' -> Npos (XO (XO (XI (XI (XI XH)))))
| '=' -> Npos (XI (XO (XI (XI (XI XH)))))
| '>' -> Npos (XO (XI (XI (XI (XI XH)))))
| '?' -> Npos (XI (XI (XI (XI (XI XH)))))
| '@' -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| 'A' -> Npos (XI (XO (XO (XO (XO (XO XH))))))
| 'B' -> Npos (XO (XI (XO (XO (XO (XO XH))))))
| 'C' -> Npos (XI (XI (XO (XO (XO (XO XH))))))
| 'D' -> Npos (XO (XO (XI (XO (XO (XO XH))))))
| 'E' -> Npos (XI (XO (XI (XO (XO (XO XH))))))
| 'F' -> Npos (XO (XI (XI (XO (XO (XO XH))))))
| 'G' -> Npos (XI (XI (XI (XO (XO (XO XH))))))
| 'H' -> Npos (XO (XO (XO (XI (XO (XO XH))))))
| 'I' -> Npos (XI (XO (XO (XI (XO (XO XH))))))
| 'J' -> Npos (XO (XI (XO (XI (XO (XO XH))))))
| 'K' -> Npos (XI (XI (XO (XI (XO (XO XH))))))
| 'L' -> Npos (XO (XO (XI (XI (XO (XO XH))))))
| 'M' -> Npos (XI (XO (XI (XI (XO (XO XH))))))
| 'N' -> Npos (XO (XI (XI (XI (XO (XO XH))))))
| 'O' -> Npos (XI (XI (XI (XI (XO (XO XH))))))
| 'P' -> Npos (XO (XO (XO (XO (XI (XO XH))))))
| 'Q' -> Npos (XI (XO (XO (XO (XI (XO XH))))))
| 'R' -> Npos (XO (XI (XO (XO (XI (XO XH))))))
| 'S' -> Npos (XI (XI (XO (XO (XI (XO XH))))))
| 'T' -> Npos (XO (XO (XI (XO (XI (XO XH))))))
| 'U' -> Npos (XI (XO (XI (XO (XI (XO XH))))))
| 'V' -> Npos (XO (XI (XI (XO (XI (XO XH))))))
| 'W' -> Npos (XI (XI (XI (XO (XI (XO XH))))))
| 'X' -> Npos (XO (XO (XO (XI (XI (XO XH))))))
| 'Y' -> Npos (XI (XO (XO (XI (XI (XO XH))))))
| 'Z' -> Npos (XO (XI (XO (XI (XI (XO XH))))))
| '[' -> Npos (XI (XI (XO (XI (XI (XO XH))))))
| '\\' -> Npos (XO (XO (XI (XI (XI (XO XH))))))
| ']' -> Npos (XI (XO (XI (XI (XI (XO XH))))))
| '^' -> Npos (XO (XI (XI (XI (XI (XO XH))))))
| '_' -> Npos (XI (XI (XI (XI (XI (XO XH))))))
| '`' -> Npos (XO (XO (XO (XO (XO (XI XH))))))
| 'a' -> Npos (XI (XO (XO (XO (XO (XI XH))))))
| 'b' -> Npos (XO (XI (XO (XO (XO (XI XH))))))
| 'c' -> Npos (XI (XI (XO (XO (XO (XI XH))))))
| 'd' -> Npos (XO (XO (XI (XO (XO (XI XH))))))
| 'e' -> Npos (XI (XO (XI (XO (XO (XI XH))))))
| 'f' -> Npos (XO (XI (XI (XO (XO (XI XH))))))
| 'g' -> Npos (XI (XI (XI (XO (XO (XI XH))))))
| 'h' -> Npos (XO (XO (XO (XI (XO (XI XH))))))
| 'i' -> Npos (XI (XO (XO (XI (XO (XI XH))))))
| 'j' -> Npos (XO (XI (XO (XI (XO (XI XH))))))
| 'k' -> Npos (XI (XI (XO (XI (XO (XI XH))))))
| 'l' -> Npos (XO (XO (XI (XI (XO (XI XH))))))
| 'm' -> Npos (XI (XO (XI (XI (XO (XI XH))))))
| 'n' -> Npos (XO (XI (XI (XI (XO (XI XH))))))
| 'o' -> Npos (XI (XI (XI (XI (XO (XI XH))))))
| 'p' -> Npos (XO (XO (XO (XO (XI (XI XH))))))
| 'q' -> Npos (XI (XO (XO (XO (XI (XI XH))))))
| 'r' -> Npos (XO (XI (XO (XO (XI (XI XH))))))
| 's' -> Npos (XI (XI (XO (XO (XI (XI XH))))))
| 't' -> Npos (XO (XO (XI (XO (XI (XI XH))))))
| 'u' -> Npos (XI (XO (XI (XO (XI (XI XH))))))
| 'v' -> Npos (XO (XI (XI (XO (XI (XI XH))))))
| 'w' -> Npos (XI (XI (XI (XO (XI (XI XH))))))
| 'x' -> Npos (XO (XO (XO (XI (XI (XI XH))))))
| 'y' -> Npos (XI (XO (XO (XI (XI (XI XH))))))
| 'z' -> Npos (XO (XI (XO (XI (XI (XI XH))))))
| '{' -> Npos (XI (XI (XO (XI (XI (XI XH))))))
| '|' -> Npos (XO (XO (XI (XI (XI (XI XH))))))
| '}' -> Npos (XI (XO (XI (XI (XI (XI XH))))))
| '~' -> Npos (XO (XI (XI (XI (XI (XI XH))))))
| '\x7f' -> Npos (XI (XI (XI (XI (XI (XI XH))))))
| '\x80' -> Npos (XO (XO (XO (XO (XO (XO (XO XH)))))))
| '\x81' -> Npos (XI (XO (XO (XO (XO (XO (XO XH)))))))
| '\x82' -> Npos (XO (XI (XO (XO (XO (XO (XO XH)))))))
| '\x83' -> Npos (XI (XI (XO (XO (XO (XO (XO XH)))))))
| '\x84' -> Npos (XO (XO (XI (XO (XO (XO (XO XH)))))))
| '\x85' -> Npos (XI (XO (XI (XO (XO (XO (XO XH)))))))
| '\x86' -> Npos (XO (XI (XI (XO (XO (XO (XO XH)))))))
| '\x87' -> Npos (XI (XI (XI (XO (XO (XO (XO XH)))))))
| '\x88' -> Npos (XO (XO (XO (XI (XO (XO (XO XH)))))))
| '\x89' -> Npos (XI (XO (XO (XI (XO (XO (XO XH)))))))
| '\x8a' -> Npos (XO (XI (XO (XI (XO (XO (XO XH)))))))
| '\x8b' -> Npos (XI (XI (XO (XI (XO (XO (XO XH)))))))
| '\x8c' -> Npos (XO (XO (XI (XI (XO (XO (XO XH)))))))
| '\x8d' -> Npos (XI (XO (XI (XI (XO (XO (XO XH)))))))
| '\x8e' -> Npos (XO (XI (XI (XI (XO (XO (XO XH)))))))
| '\x8f' -> Npos (XI (XI (XI (XI (XO (XO (XO XH)))))))
| '\x90' -> Npos (XO (XO (XO (XO (XI (XO (XO XH)))))))
| '\x91' -> Npos (XI (XO (XO (XO (XI (XO (XO XH)))))))
| '\x92' -> Npos (XO (XI (XO (XO (XI (XO (XO XH)))))))
| '\x93' -> Npos (XI (XI (XO (XO (XI (XO (XO XH)))))))
| '\x94' -> Npos (XO (XO (XI (XO (XI (XO (XO XH)))))))
| '\x95' -> Npos (XI (XO (XI (XO (XI (XO (XO XH)))))))
| '\x96' -> Npos (XO (XI (XI (XO (XI (XO (XO XH)))))))
| '\x97' -> Npos (XI (XI (XI (XO (XI (XO (XO XH)))))))
| '\x98' -> Npos (XO (XO (XO (XI (XI (XO (XO XH)))))))
| '\x99' -> Npos (XI (XO (XO (XI (XI (XO (XO XH)))))))
| '\x9a' -> Npos (XO (XI (XO (XI (XI (XO (XO XH)))))))
| '\x9b' -> Npos (XI (XI (XO (XI (XI (XO (XO XH)))))))
| '\x9c' -> Npos (XO (XO (XI (XI (XI (XO (XO XH)))))))
| '\x9d' -> Npos (XI (XO (XI (XI (XI (XO (XO XH)))))))
| '\x9e' -> Npos (XO (XI (XI (XI (XI (XO (XO XH)))))))
| '\x9f' -> Npos (XI (XI (XI (XI (XI (XO (XO XH)))))))
| '\xa0' -> Npos (XO (XO (XO (XO (XO (XI (XO XH)))))))
| '\xa1' -> Npos (XI (XO (XO (XO (XO (XI (XO XH)))))))
| '\xa2' -> Npos (XO (XI (XO (XO (XO (XI (XO XH)))))))
| '\xa3' -> Npos (XI (XI (XO (XO (XO (XI (XO XH)))))))
| '\xa4' -> Npos (XO (XO (XI (XO (XO (XI (XO XH)))))))
| '\xa5' -> Npos (XI (XO (XI (XO (XO (XI (XO XH)))))))
| '\xa6' -> Npos (XO (XI (XI (XO (XO (XI (XO XH)))))))
| '\xa7' -> Npos (XI (XI (XI (XO (XO (XI (XO XH)))))))
| '\xa8' -> Npos (XO (XO (XO (XI (XO (XI (XO XH)))))))
| '\xa9' -> Npos (XI (XO (XO (XI (XO (XI (XO XH)))))))
| '\xaa' -> Npos (XO (XI (XO (XI (XO (XI (XO XH)))))))
| '\xab' -> Npos (XI (XI (XO (XI (XO (XI (XO XH)))))))
| '\xac' -> Npos (XO (XO (XI (XI (XO (XI (XO XH)))))))
| '\xad' -> Npos (XI (XO (XI (XI (XO (XI (XO XH)))))))
| '\xae' -> Npos (XO (XI (XI (XI (XO (XI (XO XH)))))))
| '\xaf' -> Npos (XI (XI (XI (XI (XO (XI (XO XH)))))))
| '\xb0' -> Npos (XO (XO (XO (XO (XI (XI (XO XH)))))))
| '\xb1' -> Npos (XI (XO (XO (XO (XI (XI (XO XH)))))))
| '\xb2' -> Npos (XO (XI (XO (XO (XI (XI (XO XH)))))))
| '\xb3' -> Npos (XI (XI (XO (XO (XI (XI (XO XH)))))))
| '\xb4' -> Npos (XO (XO (XI (XO (XI (XI (XO XH)))))))
| '\xb5' -> Npos (XI (XO (XI (XO (XI (XI (XO XH)))))))
| '\xb6' -> Npos (XO (XI (XI (XO (XI (XI (XO XH)))))))
| '\xb7' -> Npos (XI (XI (XI (XO (XI (XI (XO XH)))))))
| '\xb8' -> Npos (XO (XO (XO (XI (XI (XI (XO XH)))))))
| '\xb9' -> Npos (XI (XO (XO (XI (XI (XI (XO XH)))))))
| '\xba' -> Npos (XO (XI (XO (XI (XI (XI (XO XH)))))))
| '\xbb' -> Npos (XI (XI (XO (XI (XI (XI (XO XH)))))))
| '\xbc' -> Npos (XO (XO (XI (XI (XI (XI (XO XH)))))))
| '\xbd' -> Npos (XI (XO (XI (XI (XI (XI (XO XH)))))))
| '\xbe' -> Npos (XO (XI (XI (XI (XI (XI (XO XH)))))))
| '\xbf' -> Npos (XI (XI (XI (XI (XI (XI (XO XH)))))))
| '\xc0' -> Npos (XO (XO (XO (XO (XO (XO (XI XH)))))))
| '\xc1' -> Npos (XI (XO (XO (XO (XO (XO (XI XH)))))))
| '\xc2' -> Npos (XO (XI (XO (XO (XO (XO (XI XH)))))))
| '\xc3' -> Npos (XI (XI (XO (XO (XO (XO (XI XH)))))))
| '\xc4' -> Npos (XO (XO (XI (XO (XO (XO (XI XH)))))))
| '\xc5' -> Npos (XI (XO (XI (XO (XO (XO (XI XH)))))))
| '\xc6' -> Npos (XO (XI (XI (XO (XO (XO (XI XH)))))))
| '\xc7' -> Npos (XI (XI (XI (XO (XO (XO (XI XH)))))))
| '\xc8' -> Npos (XO (XO (XO (XI (XO (XO (XI XH)))))))
| '\xc9' -> Npos (XI (XO (XO (XI (XO (XO (XI XH)))))))
| '\xca' -> Npos (XO (XI (XO (XI (XO (XO (XI XH)))))))
| '\xcb' -> Npos (XI (XI (XO (XI (XO (XO (XI XH)))))))
| '\xcc' -> Npos (XO (XO (XI (XI (XO (XO (XI XH)))))))
| '\xcd' -> Npos (XI (XO (XI (XI (XO (XO (XI XH)))))))
| '\xce' -> Npos (XO (XI (XI (XI (XO (XO (XI XH)))))))
| '\xcf' -> Npos (XI (XI (XI (XI (XO (XO (XI XH)))))))
| '\xd0' -> Npos (XO (XO (XO (XO (XI (XO (XI XH)))))))
| '\xd1' -> Npos (XI (XO (XO (XO (XI (XO (XI XH)))))))
| '\xd2' -> Npos (XO (XI (XO (XO (XI (XO (XI XH)))))))
| '\xd3' -> Npos (XI (XI (XO (XO (XI (XO (XI XH)))))))
| '\xd4' -> Npos (XO (XO (XI (XO (XI (XO (XI XH)))))))
| '\xd5' -> Npos (XI (XO (XI (XO (XI (XO (XI XH)))))))
| '\xd6' -> Npos (XO (XI (XI (XO (XI (XO (XI XH)))))))
| '\xd7' -> Npos (XI (XI (XI (XO (XI (XO (XI XH)))))))
| '\xd8' -> Npos (XO (XO (XO (XI (XI (XO (XI XH)))))))
| '\xd9' -> Npos (XI (XO (XO (XI (XI (XO (XI XH)))))))
| '\xda' -> Npos (XO (XI (XO (XI (XI (XO (XI XH)))))))
| '\xdb' -> Npos (XI (XI (XO (XI (XI (XO (XI XH)))))))
| '\xdc' -> Npos (XO (XO (XI (XI (XI (XO (XI XH)))))))
| '\xdd' -> Npos (XI (XO (XI (XI (XI (XO (XI XH)))))))
| '\xde' -> Npos (XO (XI (XI (XI (XI (XO (XI XH)))))))
| '\xdf' -> Npos (XI (XI (XI (XI (XI (XO (XI XH)))))))
| '\xe0' -> Npos (XO (XO (XO (XO (XO (XI (XI XH)))))))
| '\xe1' -> Npos (XI (XO (XO (XO (XO (XI (XI XH)))))))
| '\xe2' -> Npos (XO (XI (XO (XO (XO (XI (XI XH)))))))
| '\xe3' -> Npos (XI (XI (XO (XO (XO (XI (XI XH)))))))
| '\xe4' -> Npos (XO (XO (XI (XO (XO (XI (XI XH)))))))
| '\xe5' -> Npos (XI (XO (XI (XO (XO (XI (XI XH)))))))
| '\xe6' -> Npos (XO (XI (XI (XO (XO (XI (XI XH)))))))
| '\xe7' -> Npos (XI (XI (XI (XO (XO (XI (XI XH)))))))
| '\xe8' -> Npos (XO (XO (XO (XI (XO (XI (XI XH)))))))
| '\xe9' -> Npos (XI (XO (XO (XI (XO (XI (XI XH)))))))
| '\xea' -> Npos (XO (XI (XO (XI (XO (XI (XI XH)))))))
| '\xeb' -> Npos (XI (XI (XO (XI (XO (XI (XI XH)))))))
| '\xec' -> Npos (XO (XO (XI (XI (XO (XI (XI XH)))))))
| '\xed' -> Npos (XI (XO (XI (XI (XO (XI (XI XH)))))))
| '\xee' -> Npos (XO (XI (XI (XI (XO (XI (XI XH)))))))
| '\xef' -> Npos (XI (XI (XI (XI (XO (XI (XI XH)))))))
| '\xf0' -> Npos (XO (XO (XO (XO (XI (XI (XI XH)))))))
| '\xf1' -> Npos (XI (XO (XO (XO (XI (XI (XI XH)))))))
| '\xf2' -> Npos (XO (XI (XO (XO (XI (XI (XI XH)))))))
| '\xf3' -> Npos (XI (XI (XO (XO (XI (XI (XI XH)))))))
| '\xf4' -> Npos (XO (XO (XI (XO (XI (XI (XI XH)))))))
| '\xf5' -> Npos (XI (XO (XI (XO (XI (XI (XI XH)))))))
| '\xf6' -> Npos (XO (XI (XI (XO (XI (XI (XI XH)))))))
| '\xf7' -> Npos (XI (XI (XI (XO (XI (XI (XI XH)))))))
| '\xf8' -> Npos (XO (XO (XO (XI (XI (XI (XI XH)))))))
| '\xf9' -> Npos (XI (XO (XO (XI (XI (XI (XI XH)))))))
| '\xfa' -> Npos (XO (XI (XO (XI (XI (XI (XI XH)))))))
| '\xfb' -> Npos (XI (XI (XO (XI (XI (XI (XI XH)))))))
| '\xfc' -> Npos (XO (XO (XI (XI (XI (XI (XI XH)))))))
| '\xfd' -> Npos (XI (XO (XI (XI (XI (XI (XI XH)))))))
| '\xfe' -> Npos (XO (XI (XI (XI (XI (XI (XI XH)))))))
| '\xff' -> Npos (XI (XI (XI (XI (XI (XI (XI XH)))))))

(** val zero0 : char **)

let zero0 = '\000'

(** val one0 : char **)

let one0 = '\001'

(** val shift : bool -> char -> char **)

let shift = fun b c -> Char.chr (((Char.code c) lsl 1) land 255 + if b then 1 else 0)

(** val eqb_spec0 : char -> char -> reflect **)

let eqb_spec0 a b =
  (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
    (fun b0 b1 b2 b3 b4 b5 b6 b7 ->
    (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
      (fun b8 b9 b10 b11 b12 b13 b14 b15 ->
      match eqb_spec b0 b8 with
      | ReflectT ->
        (match eqb_spec b1 b9 with
         | ReflectT ->
           (match eqb_spec b2 b10 with
            | ReflectT ->
              (match eqb_spec b3 b11 with
               | ReflectT ->
                 (match eqb_spec b4 b12 with
                  | ReflectT ->
                    (match eqb_spec b5 b13 with
                     | ReflectT ->
                       (match eqb_spec b6 b14 with
                        | ReflectT ->
                          (match eqb_spec b7 b15 with
                           | ReflectT -> ReflectT
                           | ReflectF -> ReflectF)
                        | ReflectF -> ReflectF)
                     | ReflectF -> ReflectF)
                  | ReflectF -> ReflectF)
               | ReflectF -> ReflectF)
            | ReflectF -> ReflectF)
         | ReflectF -> ReflectF)
      | ReflectF -> ReflectF)
      b)
    a

(** val ascii_of_pos : positive -> char **)

let ascii_of_pos =
  let rec loop n3 p =
    match n3 with
    | O -> zero0
    | S n' ->
      (match p with
       | XI p' -> shift true (loop n' p')
       | XO p' -> shift false (loop n' p')
       | XH -> one0)
  in loop (S (S (S (S (S (S (S (S O))))))))

(** val ascii_of_N : n -> char **)

let ascii_of_N = function
| N0 -> zero0
| Npos p -> ascii_of_pos p

(** val n_of_digits : bool list -> n **)

let rec n_of_digits = function
| [] -> N0
| b :: l' ->
  Coq_N.add (if b then Npos XH else N0)
    (Coq_N.mul (Npos (XO XH)) (n_of_digits l'))

(** val n_of_ascii : char -> n **)

let n_of_ascii a =
  (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
    (fun a0 a1 a2 a3 a4 a5 a6 a7 ->
    n_of_digits
      (a0 :: (a1 :: (a2 :: (a3 :: (a4 :: (a5 :: (a6 :: (a7 :: [])))))))))
    a

(** val compare0 : char -> char -> comparison **)

let compare0 = fun c1 c2 ->
    let cmp = Char.compare c1 c2 in
    if cmp < 0 then Lt else if cmp = 0 then Eq else Gt

(** val string_dec : char list -> char list -> bool **)

let string_dec s1 s2 =
  let rec f = function
  | [] -> (fun x -> match x with
                    | [] -> true
                    | _::_ -> false)
  | a::s3 ->
    (fun x ->
      match x with
      | [] -> false
      | a0::s4 -> if (=) a a0 then if f s3 s4 then true else false else false)
  in f s1 s2

(** val eqb0 : char list -> char list -> bool **)

let rec eqb0 s1 s2 =
  match s1 with
  | [] -> (match s2 with
           | [] -> true
           | _::_ -> false)
  | c1::s1' ->
    (match s2 with
     | [] -> false
     | c2::s2' -> if (=) c1 c2 then eqb0 s1' s2' else false)

(** val eqb_spec1 : char list -> char list -> reflect **)

let eqb_spec1 s1 s2 =
  let rec f = function
  | [] -> (fun s3 -> match s3 with
                     | [] -> ReflectT
                     | _::_ -> ReflectF)
  | a::s3 ->
    (fun s4 ->
      match s4 with
      | [] -> ReflectF
      | a0::s5 ->
        (match eqb_spec0 a a0 with
         | ReflectT ->
           (match f s3 s5 with
            | ReflectT -> ReflectT
            | ReflectF -> ReflectF)
         | ReflectF -> ReflectF))
  in f s1 s2

(** val compare1 : char list -> char list -> comparison **)

let rec compare1 s1 s2 =
  match s1 with
  | [] -> (match s2 with
           | [] -> Eq
           | _::_ -> Lt)
  | c1::s1' ->
    (match s2 with
     | [] -> Gt
     | c2::s2' ->
       (match compare0 c1 c2 with
        | Eq -> compare1 s1' s2'
        | Lt -> Lt
        | Gt -> Gt))

(** val append : char list -> char list -> char list **)

let rec append s1 s2 =
  match s1 with
  | [] -> s2
  | c0::s1' -> c0::(append s1' s2)

(** val length0 : char list -> nat **)

let rec length0 = function
| [] -> O
| _::s' -> S (length0 s')

(** val substring : nat -> nat -> char list -> char list **)

let rec substring n3 m4 s0 =
  match n3 with
  | O ->
    (match m4 with
     | O -> []
     | S m'0 -> (match s0 with
                 | [] -> s0
                 | c0::s' -> c0::(substring O m'0 s')))
  | S n' -> (match s0 with
             | [] -> s0
             | _::s' -> substring n' m4 s')

(** val concat0 : char list -> char list list -> char list **)

let rec concat0 sep = function
| [] -> []
| x :: xs ->
  (match xs with
   | [] -> x
   | _ :: _ -> append x (append sep (concat0 sep xs)))

(** val prefix : char list -> char list -> bool **)

let rec prefix s1 s2 =
  match s1 with
  | [] -> true
  | a::s1' ->
    (match s2 with
     | [] -> false
     | b::s2' -> if (=) a b then prefix s1' s2' else false)

type q = { qnum : z; qden : positive }

(** val inject_Z : z -> q **)

let inject_Z x =
  { qnum = x; qden = XH }

(** val qeq_bool : q -> q -> bool **)

let qeq_bool x y =
  zeq_bool (Coq_Z.mul x.qnum (Zpos y.qden)) (Coq_Z.mul y.qnum (Zpos x.qden))

(** val qle_bool : q -> q -> bool **)

let qle_bool x y =
  Coq_Z.leb (Coq_Z.mul x.qnum (Zpos y.qden)) (Coq_Z.mul y.qnum (Zpos x.qden))

(** val qplus : q -> q -> q **)

let qplus x y =
  { qnum =
    (Coq_Z.add (Coq_Z.mul x.qnum (Zpos y.qden))
      (Coq_Z.mul y.qnum (Zpos x.qden))); qden = (Coq_Pos.mul x.qden y.qden) }

(** val qmult : q -> q -> q **)

let qmult x y =
  { qnum = (Coq_Z.mul x.qnum y.qnum); qden = (Coq_Pos.mul x.qden y.qden) }

(** val qopp : q -> q **)

let qopp x =
  { qnum = (Coq_Z.opp x.qnum); qden = x.qden }

(** val qminus : q -> q -> q **)

let qminus x y =
  qplus x (qopp y)

(** val qinv : q -> q **)

let qinv x =
  match x.qnum with
  | Z0 -> { qnum = Z0; qden = XH }
  | Zpos p -> { qnum = (Zpos x.qden); qden = p }
  | Zneg p -> { qnum = (Zneg x.qden); qden = p }

(** val qdiv : q -> q -> q **)

let qdiv x y =
  qmult x (qinv y)

(** val qpower_positive : q -> positive -> q **)

let qpower_positive =
  pow_pos qmult

(** val qpower : q -> z -> q **)

let qpower q0 = function
| Z0 -> { qnum = (Zpos XH); qden = XH }
| Zpos p -> qpower_positive q0 p
| Zneg p -> qinv (qpower_positive q0 p)

(** val qred : q -> q **)

let qred q0 =
  let { qnum = q1; qden = q2 } = q0 in
  let (r1, r2) = snd (Coq_Z.ggcd q1 (Zpos q2)) in
  { qnum = r1; qden = (Coq_Z.to_pos r2) }

(** val ascii_to_digit : char -> n option **)

let ascii_to_digit ch =
  if (=) ch '0'
  then Some N0
  else if (=) ch '1'
       then Some (Npos XH)
       else if (=) ch '2'
            then Some (Npos (XO XH))
            else if (=) ch '3'
                 then Some (Npos (XI XH))
                 else if (=) ch '4'
                      then Some (Npos (XO (XO XH)))
                      else if (=) ch '5'
                           then Some (Npos (XI (XO XH)))
                           else if (=) ch '6'
                                then Some (Npos (XO (XI XH)))
                                else if (=) ch '7'
                                     then Some (Npos (XI (XI XH)))
                                     else if (=) ch '8'
                                          then Some (Npos (XO (XO (XO XH))))
                                          else if (=) ch '9'
                                               then Some (Npos (XI (XO (XO
                                                      XH))))
                                               else if if (=) ch 'a'
                                                       then true
                                                       else if (=) ch 'A'
                                                            then true
                                                            else false
                                                    then Some (Npos (XO (XI
                                                           (XO XH))))
                                                    else if if (=) ch 'b'
                                                            then true
                                                            else if (=) ch 'B'
                                                                 then true
                                                                 else false
                                                         then Some (Npos (XI
                                                                (XI (XO XH))))
                                                         else if if (=) ch 'c'
                                                                 then true
                                                                 else 
                                                                   if 
                                                                    (=) ch 'C'
                                                                   then true
                                                                   else false
                                                              then Some (Npos
                                                                    (XO (XO
                                                                    (XI XH))))
                                                              else if 
                                                                    if 
                                                                    (=) ch 'd'
                                                                    then true
                                                                    else 
                                                                    if 
                                                                    (=) ch 'D'
                                                                    then true
                                                                    else false
                                                                   then 
                                                                    Some
                                                                    (Npos (XI
                                                                    (XO (XI
                                                                    XH))))
                                                                   else 
                                                                    if 
                                                                    if 
                                                                    (=) ch 'e'
                                                                    then true
                                                                    else 
                                                                    if 
                                                                    (=) ch 'E'
                                                                    then true
                                                                    else false
                                                                    then 
                                                                    Some
                                                                    (Npos (XO
                                                                    (XI (XI
                                                                    XH))))
                                                                    else 
                                                                    if 
                                                                    if 
                                                                    (=) ch 'f'
                                                                    then true
                                                                    else 
                                                                    if 
                                                                    (=) ch 'F'
                                                                    then true
                                                                    else false
                                                                    then 
                                                                    Some
                                                                    (Npos (XI
                                                                    (XI (XI
                                                                    XH))))
                                                                    else None

module Raw =
 struct
  (** val of_pos : positive -> char list -> char list **)

  let rec of_pos p rest =
    match p with
    | XI p0 ->
      (match p0 with
       | XI p1 ->
         (match p1 with
          | XI p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('f'::rest)
             | XO p' -> of_pos p' ('7'::rest)
             | XH -> 'f'::rest)
          | XO p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('b'::rest)
             | XO p' -> of_pos p' ('3'::rest)
             | XH -> 'b'::rest)
          | XH -> '7'::rest)
       | XO p1 ->
         (match p1 with
          | XI p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('d'::rest)
             | XO p' -> of_pos p' ('5'::rest)
             | XH -> 'd'::rest)
          | XO p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('9'::rest)
             | XO p' -> of_pos p' ('1'::rest)
             | XH -> '9'::rest)
          | XH -> '5'::rest)
       | XH -> '3'::rest)
    | XO p0 ->
      (match p0 with
       | XI p1 ->
         (match p1 with
          | XI p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('e'::rest)
             | XO p' -> of_pos p' ('6'::rest)
             | XH -> 'e'::rest)
          | XO p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('a'::rest)
             | XO p' -> of_pos p' ('2'::rest)
             | XH -> 'a'::rest)
          | XH -> '6'::rest)
       | XO p1 ->
         (match p1 with
          | XI p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('c'::rest)
             | XO p' -> of_pos p' ('4'::rest)
             | XH -> 'c'::rest)
          | XO p2 ->
            (match p2 with
             | XI p' -> of_pos p' ('8'::rest)
             | XO p' -> of_pos p' ('0'::rest)
             | XH -> '8'::rest)
          | XH -> '4'::rest)
       | XH -> '2'::rest)
    | XH -> '1'::rest

  (** val to_N : char list -> n -> n **)

  let rec to_N s0 rest =
    match s0 with
    | [] -> rest
    | ch::s' ->
      to_N s'
        (match ascii_to_digit ch with
         | Some v -> N.add v (N.mul (Npos (XO (XO (XO (XO XH))))) rest)
         | None -> N0)
 end

(** val of_pos0 : positive -> char list **)

let of_pos0 p =
  '0'::('x'::(Raw.of_pos p []))

(** val of_Z : z -> char list **)

let of_Z = function
| Z0 -> '0'::('x'::('0'::[]))
| Zpos p -> of_pos0 p
| Zneg p -> '-'::(of_pos0 p)

(** val to_N1 : char list -> n **)

let to_N1 = function
| [] -> N0
| s1::s2 ->
  (match s2 with
   | [] -> N0
   | so::s3 ->
     if (=) s1 '0' then if (=) so 'x' then Raw.to_N s3 N0 else N0 else N0)

(** val to_Z : char list -> z **)

let to_Z s0 =
  let (is_neg, n3) =
    match s0 with
    | [] -> (false, (to_N1 s0))
    | s1::s' -> if (=) s1 '-' then (true, (to_N1 s')) else (false, (to_N1 s0))
  in
  (match n3 with
   | N0 -> Z0
   | Npos p -> if is_neg then Zneg p else Zpos p)

(** val tab : char **)

let tab =
  '\t'

(** val lF : char **)

let lF =
  '\n'

(** val newPage : char **)

let newPage =
  '\012'

(** val cR : char **)

let cR =
  '\r'

(** val newLine : char **)

let newLine =
  '\n'

(** val leb0 : char -> char -> bool **)

let leb0 x y =
  Coq_N.leb (n_of_ascii x) (n_of_ascii y)

(** val is_upper : char -> bool **)

let is_upper ch =
  (&&) (leb0 'A' ch) (leb0 ch 'Z')

(** val is_lower : char -> bool **)

let is_lower ch =
  (&&) (leb0 'a' ch) (leb0 ch 'z')

(** val to_lower : char -> char **)

let to_lower ch =
  if (&&) (leb0 'A' ch) (leb0 ch 'Z')
  then ascii_of_N
         (Coq_N.sub (Coq_N.add (n_of_ascii 'a') (n_of_ascii ch))
           (n_of_ascii 'A'))
  else ch

(** val to_upper : char -> char **)

let to_upper ch =
  if (&&) (leb0 'a' ch) (leb0 ch 'z')
  then ascii_of_N
         (Coq_N.sub (Coq_N.add (n_of_ascii 'A') (n_of_ascii ch))
           (n_of_ascii 'a'))
  else ch

(** val is_whitespace : char -> bool **)

let is_whitespace x =
  (||) ((||) ((||) ((||) ((=) x ' ') ((=) x newPage)) ((=) x lF)) ((=) x cR))
    ((=) x tab)

(** val string_of_list_ascii : char list -> char list **)

let rec string_of_list_ascii = function
| [] -> []
| ch :: s1 -> ch::(string_of_list_ascii s1)

(** val list_ascii_of_string : char list -> char list **)

let rec list_ascii_of_string = function
| [] -> []
| ch::s1 -> ch :: (list_ascii_of_string s1)

(** val lift_list_function :
    (char list -> char list) -> char list -> char list **)

let lift_list_function f s0 =
  string_of_list_ascii (f (list_ascii_of_string s0))

(** val map0 : (char -> char) -> char list -> char list **)

let map0 f =
  lift_list_function (map f)

(** val to_lower0 : char list -> char list **)

let to_lower0 s0 =
  map0 to_lower s0

(** val to_upper0 : char list -> char list **)

let to_upper0 s0 =
  map0 to_upper s0

(** val rev2 : char list -> char list **)

let rev2 =
  lift_list_function (fun s0 -> rev_append s0 [])

(** val take_while_drop_while :
    (char -> bool) -> char list -> char list * char list **)

let rec take_while_drop_while f = function
| [] -> ([], [])
| ch::s1 ->
  if f ch
  then let (s2, s3) = take_while_drop_while f s1 in ((ch::s2), s3)
  else ([], (ch::s1))

(** val ltrim : char list -> char list **)

let ltrim s0 =
  snd (take_while_drop_while is_whitespace s0)

(** val rtrim : char list -> char list **)

let rtrim s0 =
  rev2 (ltrim (rev2 s0))

(** val trim : char list -> char list **)

let trim s0 =
  rtrim (ltrim s0)

(** val startswith : char list -> char list -> bool **)

let startswith prefix1 s0 =
  eqb0 prefix1 (substring O (length0 prefix1) s0)

(** val endswith : char list -> char list -> bool **)

let endswith postfix s0 =
  eqb0 postfix
    (substring (sub (length0 s0) (length0 postfix)) (length0 postfix) s0)

(** val strip_prefix_cps :
    (char list -> 'a1) -> (char list -> char list -> 'a1) -> char ->
    char list -> char list -> 'a1 **)

let strip_prefix_cps found remaining =
  let rec strip_prefix_cps0 sepch sep s2 = match s2 with
  | [] -> remaining (sepch::sep) s2
  | x::xs ->
    if (=) sepch x
    then (match sep with
          | [] -> found xs
          | sepch0::sep0 -> strip_prefix_cps0 sepch0 sep0 xs)
    else remaining (sepch::sep) s2
  in strip_prefix_cps0

(** val split_helper :
    char -> char list -> char list -> char list -> char list list **)

let rec split_helper sepch sep s0 rev_acc =
  strip_prefix_cps (fun s1 ->
    (rev2 rev_acc) :: (split_helper sepch sep s1 [])) (fun _ _ ->
    match s0 with
    | [] -> (rev2 rev_acc) :: []
    | x::xs -> split_helper sepch sep xs (x::rev_acc)) sepch sep s0

(** val split : char list -> char list -> char list list **)

let split sep s0 =
  match sep with
  | [] ->
    if eqb0 s0 []
    then [] :: []
    else map (fun ch -> ch::[]) (list_ascii_of_string s0)
  | sepch::sep0 -> split_helper sepch sep0 s0 []

(** val replace : char list -> char list -> char list -> char list **)

let replace from to0 s0 =
  concat0 to0 (split from s0)

(** val split_newlines : char list list -> char list list **)

let split_newlines s0 =
  flat_map (split (cR::[]))
    (flat_map (split (lF::[])) (flat_map (split (cR::(lF::[]))) s0))

(** val repeat0 : char -> nat -> char list **)

let repeat0 ch n3 =
  string_of_list_ascii (repeat ch n3)

(** val strip_trailing_spaces : char list -> char list **)

let strip_trailing_spaces s0 =
  concat0 (newLine::[]) (map rtrim (split (newLine::[]) s0))

(** val strip_leading_newlines : char list list -> char list list **)

let rec strip_leading_newlines = function
| [] -> []
| s1 :: ls ->
  if eqb0 (rtrim s1) [] then strip_leading_newlines ls else s1 :: ls

(** val strip_trailing_newlines : char list list -> char list list **)

let strip_trailing_newlines s0 =
  rev_append (strip_leading_newlines (rev_append s0 [])) []

(** val option_beq :
    ('a1 -> 'a1 -> bool) -> 'a1 option -> 'a1 option -> bool **)

let option_beq eq_A x y =
  match x with
  | Some x0 -> (match y with
                | Some x1 -> eq_A x0 x1
                | None -> false)
  | None -> (match y with
             | Some _ -> false
             | None -> true)

(** val option_beq_hetero :
    ('a1 -> 'a2 -> bool) -> 'a1 option -> 'a2 option -> bool **)

let option_beq_hetero aB_beq x y =
  match x with
  | Some x0 -> (match y with
                | Some y0 -> aB_beq x0 y0
                | None -> false)
  | None -> (match y with
             | Some _ -> false
             | None -> true)

(** val bind : 'a1 option -> ('a1 -> 'a2 option) -> 'a2 option **)

let bind v f =
  match v with
  | Some v0 -> f v0
  | None -> None

(** val sequence_return : 'a1 option -> 'a1 -> 'a1 **)

let sequence_return v1 v2 =
  match v1 with
  | Some v -> v
  | None -> v2

(** val invert_Some : 'a1 option -> __ **)

let invert_Some = function
| Some x' -> Obj.magic x'
| None -> Obj.magic ()

(** val prod_beq :
    ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1 * 'a2) ->
    ('a1 * 'a2) -> bool **)

let prod_beq eq_A eq_B x y =
  let (x0, x1) = x in let (x2, x3) = y in (&&) (eq_A x0 x2) (eq_B x1 x3)

type decidable = bool

(** val dec : decidable -> bool **)

let dec decidable1 =
  decidable1

(** val dec_eq_Z : z -> z -> decidable **)

let dec_eq_Z =
  Coq_Z.eq_dec

(** val list_beq : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool **)

let list_beq eq_A =
  let rec list_eqrec x y =
    match x with
    | [] -> (match y with
             | [] -> true
             | _ :: _ -> false)
    | x0 :: x1 ->
      (match y with
       | [] -> false
       | x2 :: x3 -> (&&) (eq_A x0 x2) (list_eqrec x1 x3))
  in list_eqrec

(** val list_case : 'a2 -> ('a1 -> 'a1 list -> 'a2) -> 'a1 list -> 'a2 **)

let list_case n3 c0 = function
| [] -> n3
| x :: xs -> c0 x xs

module List =
 struct
  (** val enumerate : 'a1 list -> (nat * 'a1) list **)

  let enumerate ls =
    combine (seq O (length ls)) ls
 end

(** val list_beq_hetero :
    ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool **)

let list_beq_hetero f =
  let rec list_beq_hetero1 l1 l2 =
    match l1 with
    | [] -> (match l2 with
             | [] -> true
             | _ :: _ -> false)
    | x :: xs ->
      (match l2 with
       | [] -> false
       | y :: ys -> (&&) (f x y) (list_beq_hetero1 xs ys))
  in list_beq_hetero1

(** val map2 : ('a1 -> 'a2 -> 'a3) -> 'a1 list -> 'a2 list -> 'a3 list **)

let map2 f =
  let rec map6 la lb =
    match la with
    | [] -> []
    | a :: la' ->
      (match lb with
       | [] -> []
       | b :: lb' -> (f a b) :: (map6 la' lb'))
  in map6

(** val update_nth : nat -> ('a1 -> 'a1) -> 'a1 list -> 'a1 list **)

let rec update_nth n3 f xs =
  match n3 with
  | O -> (match xs with
          | [] -> []
          | x' :: xs' -> (f x') :: xs')
  | S n' ->
    (match xs with
     | [] -> []
     | x' :: xs' -> x' :: (update_nth n' f xs'))

(** val set_nth : nat -> 'a1 -> 'a1 list -> 'a1 list **)

let set_nth n3 x xs =
  update_nth n3 (fun _ -> x) xs

(** val remove_duplicates' : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list **)

let rec remove_duplicates' beq = function
| [] -> []
| x :: xs ->
  if existsb (beq x) xs
  then remove_duplicates' beq xs
  else x :: (remove_duplicates' beq xs)

(** val remove_duplicates : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list **)

let remove_duplicates beq ls =
  rev1 (remove_duplicates' beq (rev1 ls))

(** val find_duplicates' : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list **)

let rec find_duplicates' beq = function
| [] -> []
| x :: xs ->
  if existsb (beq x) xs
  then x :: (find_duplicates' beq xs)
  else find_duplicates' beq xs

(** val find_duplicates : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list **)

let find_duplicates beq ls =
  remove_duplicates beq (find_duplicates' beq ls)

(** val span_cps' :
    ('a1 -> bool) -> (('a1 list * 'a1 list) -> 'a2) -> 'a1 list -> 'a1 list
    -> 'a2 **)

let span_cps' f k =
  let rec span_cps'0 ls prefix1 =
    match ls with
    | [] -> k ((rev1 prefix1), ls)
    | x :: xs ->
      if f x then span_cps'0 xs (x :: prefix1) else k ((rev1 prefix1), ls)
  in span_cps'0

(** val span_cps :
    ('a1 -> bool) -> 'a1 list -> (('a1 list * 'a1 list) -> 'a2) -> 'a2 **)

let span_cps f ls k =
  span_cps' f k ls []

(** val span : ('a1 -> bool) -> 'a1 list -> 'a1 list * 'a1 list **)

let span f ls =
  span_cps f ls (Obj.magic id)

(** val takeWhile : ('a1 -> bool) -> 'a1 list -> 'a1 list **)

let takeWhile f ls =
  fst (span f ls)

(** val dropWhile : ('a1 -> bool) -> 'a1 list -> 'a1 list **)

let dropWhile f ls =
  snd (span f ls)

type 't tuple' = __

type 't tuple = __

(** val cons' : nat -> 'a1 -> 'a1 tuple' -> 'a1 tuple' **)

let rec cons' = function
| O -> (fun y x -> Obj.magic (y, x))
| S n' ->
  (fun y x ->
    Obj.magic ((cons' n' y (fst (Obj.magic x))), (snd (Obj.magic x))))

(** val cons : nat -> 'a1 -> 'a1 tuple -> 'a1 tuple **)

let cons = function
| O -> (fun x _ -> Obj.magic x)
| S n' -> cons' n'

(** val tl' : nat -> 'a1 tuple' -> 'a1 tuple' **)

let tl' _ =
  Obj.magic fst

(** val tl0 : nat -> 'a1 tuple -> 'a1 tuple **)

let tl0 = function
| O -> (fun _ -> Obj.magic ())
| S n' -> tl' n'

(** val hd' : nat -> 'a1 tuple' -> 'a1 **)

let hd' = function
| O -> (fun x -> Obj.magic x)
| S _ -> Obj.magic snd

(** val hd0 : nat -> 'a1 tuple -> 'a1 **)

let hd0 =
  hd'

(** val to_list' : nat -> 'a1 tuple' -> 'a1 list **)

let rec to_list' = function
| O -> (fun x -> (Obj.magic x) :: [])
| S n' -> (fun xs -> let (xs', x) = Obj.magic xs in x :: (to_list' n' xs'))

(** val to_list : nat -> 'a1 tuple -> 'a1 list **)

let to_list = function
| O -> (fun _ -> [])
| S n' -> (fun xs -> to_list' n' xs)

(** val from_list'_obligation_1 : 'a1 -> 'a1 list -> 'a1 tuple' **)

let from_list'_obligation_1 _ _ =
  assert false (* absurd case *)

(** val from_list'_obligation_2 : nat -> 'a1 tuple' **)

let from_list'_obligation_2 _ =
  assert false (* absurd case *)

(** val from_list' : 'a1 -> nat -> 'a1 list -> 'a1 tuple' **)

let rec from_list' y n3 xs =
  (match n3 with
   | O ->
     (match xs with
      | [] -> (fun _ -> Obj.magic y)
      | t0 :: l -> (fun _ -> from_list'_obligation_1 t0 l))
   | S n' ->
     (match xs with
      | [] -> (fun _ -> from_list'_obligation_2 n')
      | x :: xs' -> (fun _ -> Obj.magic ((from_list' x n' xs'), y)))) __

(** val from_list_obligation_1 : 'a1 -> 'a1 list -> 'a1 tuple **)

let from_list_obligation_1 _ _ =
  assert false (* absurd case *)

(** val from_list_obligation_2 : nat -> 'a1 tuple **)

let from_list_obligation_2 _ =
  assert false (* absurd case *)

(** val from_list : nat -> 'a1 list -> 'a1 tuple **)

let from_list n3 xs =
  (match n3 with
   | O ->
     (match xs with
      | [] -> (fun _ -> Obj.magic ())
      | t0 :: l -> (fun _ -> from_list_obligation_1 t0 l))
   | S n' ->
     (match xs with
      | [] -> (fun _ -> from_list_obligation_2 n')
      | x :: xs' -> (fun _ -> from_list' x n' xs'))) __

(** val on_tuple2 :
    ('a1 list -> 'a2 list -> 'a3 list) -> nat -> nat -> nat -> 'a1 tuple ->
    'a2 tuple -> 'a3 tuple **)

let on_tuple2 f a b c0 ta tb =
  from_list c0 (f (to_list a ta) (to_list b tb))

(** val map1 :
    nat -> ('a1 -> 'a2 -> 'a3) -> 'a1 tuple -> 'a2 tuple -> 'a3 tuple **)

let map1 n3 f xs ys =
  on_tuple2 (map2 f) n3 n3 n3 xs ys

(** val from_list_default' : 'a1 -> 'a1 -> nat -> 'a1 list -> 'a1 tuple' **)

let rec from_list_default' d y n3 xs =
  match n3 with
  | O -> Obj.magic y
  | S n' ->
    (match xs with
     | [] -> Obj.magic ((from_list_default' d d n' []), y)
     | x :: xs' -> Obj.magic ((from_list_default' d x n' xs'), y))

(** val from_list_default : 'a1 -> nat -> 'a1 list -> 'a1 tuple **)

let from_list_default d n3 xs =
  match n3 with
  | O -> Obj.magic ()
  | S n' ->
    (match xs with
     | [] -> from_list_default' d d n' []
     | x :: xs' -> from_list_default' d x n' xs')

(** val append0 : nat -> 'a1 -> 'a1 tuple -> 'a1 tuple **)

let append0 n3 a =
  match n3 with
  | O -> (fun _ -> Obj.magic a)
  | S _ -> (fun t0 -> Obj.magic (t0, a))

(** val nth_default0 : nat -> 'a1 -> nat -> 'a1 tuple -> 'a1 **)

let rec nth_default0 m4 d n3 =
  match m4 with
  | O -> (fun _ -> d)
  | S m'0 ->
    (match n3 with
     | O -> hd0 m'0
     | S n' -> (fun x -> nth_default0 m'0 d n' (tl0 m'0 x)))

(** val repeat1 : 'a1 -> nat -> 'a1 tuple **)

let rec repeat1 a = function
| O -> Obj.magic ()
| S n' -> append0 n' a (repeat1 a n')

module Option =
 struct
  module List =
   struct
    (** val map : ('a1 -> 'a2 option) -> 'a1 list -> 'a2 list **)

    let map f =
      let rec map6 = function
      | [] -> []
      | x :: xs ->
        (match f x with
         | Some fx -> fx :: (map6 xs)
         | None -> map6 xs)
      in map6

    (** val bind_list :
        'a1 option list -> ('a1 list -> 'a2 option) -> 'a2 option **)

    let rec bind_list v f =
      match v with
      | [] -> f []
      | x :: xs -> bind x (fun x0 -> bind_list xs (fun xs0 -> f (x0 :: xs0)))

    (** val lift : 'a1 option list -> 'a1 list option **)

    let lift ls =
      fold_right (fun x xs ->
        bind x (fun x0 -> bind xs (fun xs0 -> Some (x0 :: xs0)))) (Some []) ls
   end
 end

type rEG =
| Rax
| Rcx
| Rdx
| Rbx
| Rsp
| Rbp
| Rsi
| Rdi
| R8
| R9
| R10
| R11
| R12
| R13
| R14
| R15
| Eax
| Ecx
| Edx
| Ebx
| Esp
| Ebp
| Esi
| Edi
| R8d
| R9d
| R10d
| R11d
| R12d
| R13d
| R14d
| R15d
| Ax
| Cx
| Dx
| Bx
| Sp
| Bp
| Si
| Di
| R8w
| R9w
| R10w
| R11w
| R12w
| R13w
| R14w
| R15w
| Ah
| Al
| Ch
| Cl
| Dh
| Dl
| Bh
| Bl
| Spl
| Bpl
| Sil
| Dil
| R8b
| R9b
| R10b
| R11b
| R12b
| R13b
| R14b
| R15b

(** val rEG_beq : rEG -> rEG -> bool **)

let rEG_beq x y =
  match x with
  | Rax ->
    (match y with
     | Rax -> true
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Rcx ->
    (match y with
     | Rax -> false
     | Rcx -> true
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Rdx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> true
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Rbx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> true
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Rsp ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> true
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Rbp ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> true
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Rsi ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> true
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Rdi ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> true
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R8 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> true
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R9 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> true
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R10 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> true
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R11 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> true
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R12 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> true
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R13 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> true
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R14 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> true
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R15 ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> true
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Eax ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> true
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Ecx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> true
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Edx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> true
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Ebx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> true
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Esp ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> true
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Ebp ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> true
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Esi ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> true
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Edi ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> true
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R8d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> true
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R9d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> true
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R10d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> true
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R11d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> true
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R12d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> true
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R13d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> true
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R14d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> true
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R15d ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> true
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Ax ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> true
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Cx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> true
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Dx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> true
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Bx ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> true
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Sp ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> true
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Bp ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> true
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Si ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> true
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Di ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> true
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R8w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> true
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R9w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> true
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R10w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> true
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R11w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> true
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R12w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> true
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R13w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> true
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R14w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> true
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R15w ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> true
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Ah ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> true
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Al ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> true
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Ch ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> true
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Cl ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> true
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Dh ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> true
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Dl ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> true
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Bh ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> true
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Bl ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> true
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Spl ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> true
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Bpl ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> true
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Sil ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> true
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | Dil ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> true
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R8b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> true
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R9b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> true
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R10b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> true
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R11b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> true
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R12b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> true
     | R13b -> false
     | R14b -> false
     | R15b -> false)
  | R13b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> true
     | R14b -> false
     | R15b -> false)
  | R14b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> true
     | R15b -> false)
  | R15b ->
    (match y with
     | Rax -> false
     | Rcx -> false
     | Rdx -> false
     | Rbx -> false
     | Rsp -> false
     | Rbp -> false
     | Rsi -> false
     | Rdi -> false
     | R8 -> false
     | R9 -> false
     | R10 -> false
     | R11 -> false
     | R12 -> false
     | R13 -> false
     | R14 -> false
     | R15 -> false
     | Eax -> false
     | Ecx -> false
     | Edx -> false
     | Ebx -> false
     | Esp -> false
     | Ebp -> false
     | Esi -> false
     | Edi -> false
     | R8d -> false
     | R9d -> false
     | R10d -> false
     | R11d -> false
     | R12d -> false
     | R13d -> false
     | R14d -> false
     | R15d -> false
     | Ax -> false
     | Cx -> false
     | Dx -> false
     | Bx -> false
     | Sp -> false
     | Bp -> false
     | Si -> false
     | Di -> false
     | R8w -> false
     | R9w -> false
     | R10w -> false
     | R11w -> false
     | R12w -> false
     | R13w -> false
     | R14w -> false
     | R15w -> false
     | Ah -> false
     | Al -> false
     | Ch -> false
     | Cl -> false
     | Dh -> false
     | Dl -> false
     | Bh -> false
     | Bl -> false
     | Spl -> false
     | Bpl -> false
     | Sil -> false
     | Dil -> false
     | R8b -> false
     | R9b -> false
     | R10b -> false
     | R11b -> false
     | R12b -> false
     | R13b -> false
     | R14b -> false
     | R15b -> true)

type cONST = z

(** val cONST_of_Z : z -> cONST **)

let cONST_of_Z x =
  x

type accessSize =
| Byte
| Word
| Dword
| Qword

(** val accessSize_beq : accessSize -> accessSize -> bool **)

let accessSize_beq x y =
  match x with
  | Byte ->
    (match y with
     | Byte -> true
     | Word -> false
     | Dword -> false
     | Qword -> false)
  | Word ->
    (match y with
     | Byte -> false
     | Word -> true
     | Dword -> false
     | Qword -> false)
  | Dword ->
    (match y with
     | Byte -> false
     | Word -> false
     | Dword -> true
     | Qword -> false)
  | Qword ->
    (match y with
     | Byte -> false
     | Word -> false
     | Dword -> false
     | Qword -> true)

(** val bits_of_AccessSize : accessSize -> n **)

let bits_of_AccessSize = function
| Byte -> Npos (XO (XO (XO XH)))
| Word -> Npos (XO (XO (XO (XO XH))))
| Dword -> Npos (XO (XO (XO (XO (XO XH)))))
| Qword -> Npos (XO (XO (XO (XO (XO (XO XH))))))

type mEM = { mem_bits_access_size : accessSize option;
             mem_base_reg : rEG option; mem_scale_reg : (z * rEG) option;
             mem_base_label : char list option; mem_offset : z option }

(** val internal_positive_beq : positive -> positive -> bool **)

let rec internal_positive_beq x y =
  match x with
  | XI x0 ->
    (match y with
     | XI x1 -> internal_positive_beq x0 x1
     | XO _ -> false
     | XH -> false)
  | XO x0 ->
    (match y with
     | XI _ -> false
     | XO x1 -> internal_positive_beq x0 x1
     | XH -> false)
  | XH -> (match y with
           | XI _ -> false
           | XO _ -> false
           | XH -> true)

(** val mem_of_reg : rEG -> mEM **)

let mem_of_reg r0 =
  { mem_bits_access_size = None; mem_base_reg = (Some r0); mem_scale_reg =
    None; mem_base_label = None; mem_offset = None }

type fLAG =
| CF
| PF
| AF
| ZF
| SF
| OF

type opPrefix =
| Rep
| Repz
| Repnz

(** val opPrefix_beq : opPrefix -> opPrefix -> bool **)

let opPrefix_beq x y =
  match x with
  | Rep -> (match y with
            | Rep -> true
            | Repz -> false
            | Repnz -> false)
  | Repz -> (match y with
             | Rep -> false
             | Repz -> true
             | Repnz -> false)
  | Repnz -> (match y with
              | Rep -> false
              | Repz -> false
              | Repnz -> true)

type opCode =
| Adc
| Adcx
| Add
| Adox
| And
| Bzhi
| Call
| Clc
| Cmovb
| Cmovc
| Cmovnz
| Cmovo
| Cmp
| Db0
| Dd0
| Dec
| Dq
| Dw
| Imul
| Inc
| Je
| Jmp
| Lea
| Mov
| Movzx
| Mul
| Mulx
| Or
| Pop
| Push
| Rcr
| Ret
| Sar
| Sbb
| Setc
| Seto
| Shl
| Shlx
| Shr
| Shrx
| Shrd
| Sub
| Test
| Xchg
| Xor

(** val opCode_beq : opCode -> opCode -> bool **)

let opCode_beq x y =
  match x with
  | Adc ->
    (match y with
     | Adc -> true
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Adcx ->
    (match y with
     | Adc -> false
     | Adcx -> true
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Add ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> true
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Adox ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> true
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | And ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> true
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Bzhi ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> true
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Call ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> true
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Clc ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> true
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Cmovb ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> true
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Cmovc ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> true
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Cmovnz ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> true
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Cmovo ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> true
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Cmp ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> true
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Db0 ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> true
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Dd0 ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> true
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Dec ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> true
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Dq ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> true
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Dw ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> true
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Imul ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> true
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Inc ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> true
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Je ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> true
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Jmp ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> true
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Lea ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> true
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Mov ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> true
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Movzx ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> true
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Mul ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> true
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Mulx ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> true
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Or ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> true
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Pop ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> true
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Push ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> true
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Rcr ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> true
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Ret ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> true
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Sar ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> true
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Sbb ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> true
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Setc ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> true
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Seto ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> true
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Shl ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> true
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Shlx ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> true
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Shr ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> true
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Shrx ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> true
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Shrd ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> true
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Sub ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> true
     | Test -> false
     | Xchg -> false
     | Xor -> false)
  | Test ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> true
     | Xchg -> false
     | Xor -> false)
  | Xchg ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> true
     | Xor -> false)
  | Xor ->
    (match y with
     | Adc -> false
     | Adcx -> false
     | Add -> false
     | Adox -> false
     | And -> false
     | Bzhi -> false
     | Call -> false
     | Clc -> false
     | Cmovb -> false
     | Cmovc -> false
     | Cmovnz -> false
     | Cmovo -> false
     | Cmp -> false
     | Db0 -> false
     | Dd0 -> false
     | Dec -> false
     | Dq -> false
     | Dw -> false
     | Imul -> false
     | Inc -> false
     | Je -> false
     | Jmp -> false
     | Lea -> false
     | Mov -> false
     | Movzx -> false
     | Mul -> false
     | Mulx -> false
     | Or -> false
     | Pop -> false
     | Push -> false
     | Rcr -> false
     | Ret -> false
     | Sar -> false
     | Sbb -> false
     | Setc -> false
     | Seto -> false
     | Shl -> false
     | Shlx -> false
     | Shr -> false
     | Shrx -> false
     | Shrd -> false
     | Sub -> false
     | Test -> false
     | Xchg -> false
     | Xor -> true)

type jUMP_LABEL = { jump_near : bool; label_name : char list }

type aRG =
| Reg of rEG
| Mem of mEM
| Const of cONST
| Label of jUMP_LABEL

type normalInstruction = { prefix0 : opPrefix option; op : opCode;
                           args : aRG list }

type rawLine =
| SECTION of char list
| GLOBAL of char list
| LABEL of char list
| ALIGN of char list
| DEFAULT_REL
| EMPTY
| INSTR of normalInstruction

type line = { indent : char list; rawline : rawLine;
              pre_comment_whitespace : char list; comment : char list option;
              line_number : n }

(** val internal_N_beq : n -> n -> bool **)

let internal_N_beq x y =
  match x with
  | N0 -> (match y with
           | N0 -> true
           | Npos _ -> false)
  | Npos x0 ->
    (match y with
     | N0 -> false
     | Npos x1 -> internal_positive_beq x0 x1)

type lines = line list

(** val reg_size : rEG -> n **)

let reg_size = function
| Rax -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Rcx -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Rdx -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Rbx -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Rsp -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Rbp -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Rsi -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Rdi -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R8 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R9 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R10 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R11 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R12 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R13 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R14 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| R15 -> Npos (XO (XO (XO (XO (XO (XO XH))))))
| Eax -> Npos (XO (XO (XO (XO (XO XH)))))
| Ecx -> Npos (XO (XO (XO (XO (XO XH)))))
| Edx -> Npos (XO (XO (XO (XO (XO XH)))))
| Ebx -> Npos (XO (XO (XO (XO (XO XH)))))
| Esp -> Npos (XO (XO (XO (XO (XO XH)))))
| Ebp -> Npos (XO (XO (XO (XO (XO XH)))))
| Esi -> Npos (XO (XO (XO (XO (XO XH)))))
| Edi -> Npos (XO (XO (XO (XO (XO XH)))))
| R8d -> Npos (XO (XO (XO (XO (XO XH)))))
| R9d -> Npos (XO (XO (XO (XO (XO XH)))))
| R10d -> Npos (XO (XO (XO (XO (XO XH)))))
| R11d -> Npos (XO (XO (XO (XO (XO XH)))))
| R12d -> Npos (XO (XO (XO (XO (XO XH)))))
| R13d -> Npos (XO (XO (XO (XO (XO XH)))))
| R14d -> Npos (XO (XO (XO (XO (XO XH)))))
| R15d -> Npos (XO (XO (XO (XO (XO XH)))))
| Ax -> Npos (XO (XO (XO (XO XH))))
| Cx -> Npos (XO (XO (XO (XO XH))))
| Dx -> Npos (XO (XO (XO (XO XH))))
| Bx -> Npos (XO (XO (XO (XO XH))))
| Sp -> Npos (XO (XO (XO (XO XH))))
| Bp -> Npos (XO (XO (XO (XO XH))))
| Si -> Npos (XO (XO (XO (XO XH))))
| Di -> Npos (XO (XO (XO (XO XH))))
| R8w -> Npos (XO (XO (XO (XO XH))))
| R9w -> Npos (XO (XO (XO (XO XH))))
| R10w -> Npos (XO (XO (XO (XO XH))))
| R11w -> Npos (XO (XO (XO (XO XH))))
| R12w -> Npos (XO (XO (XO (XO XH))))
| R13w -> Npos (XO (XO (XO (XO XH))))
| R14w -> Npos (XO (XO (XO (XO XH))))
| R15w -> Npos (XO (XO (XO (XO XH))))
| Ah -> Npos (XO (XO (XO XH)))
| Al -> Npos (XO (XO (XO XH)))
| Ch -> Npos (XO (XO (XO XH)))
| Cl -> Npos (XO (XO (XO XH)))
| Dh -> Npos (XO (XO (XO XH)))
| Dl -> Npos (XO (XO (XO XH)))
| Bh -> Npos (XO (XO (XO XH)))
| Bl -> Npos (XO (XO (XO XH)))
| Spl -> Npos (XO (XO (XO XH)))
| Bpl -> Npos (XO (XO (XO XH)))
| Sil -> Npos (XO (XO (XO XH)))
| Dil -> Npos (XO (XO (XO XH)))
| R8b -> Npos (XO (XO (XO XH)))
| R9b -> Npos (XO (XO (XO XH)))
| R10b -> Npos (XO (XO (XO XH)))
| R11b -> Npos (XO (XO (XO XH)))
| R12b -> Npos (XO (XO (XO XH)))
| R13b -> Npos (XO (XO (XO XH)))
| R14b -> Npos (XO (XO (XO XH)))
| R15b -> Npos (XO (XO (XO XH)))

(** val standalone_operand_size : aRG -> n option **)

let standalone_operand_size = function
| Reg r0 -> Some (reg_size r0)
| Mem m4 -> option_map bits_of_AccessSize m4.mem_bits_access_size
| Const _ -> None
| Label _ -> None

(** val opcode_size : opCode -> n option **)

let opcode_size = function
| Adc -> None
| Adcx -> None
| Add -> None
| Adox -> None
| And -> None
| Bzhi -> None
| Call -> None
| Clc -> Some (Npos XH)
| Cmovb -> None
| Cmovc -> None
| Cmovnz -> None
| Cmovo -> None
| Cmp -> None
| Db0 -> None
| Dd0 -> None
| Dec -> None
| Dq -> None
| Dw -> None
| Imul -> None
| Inc -> None
| Je -> None
| Jmp -> None
| Lea -> None
| Mov -> None
| Movzx -> None
| Mul -> None
| Mulx -> None
| Or -> None
| Pop -> None
| Push -> None
| Rcr -> None
| Ret -> Some (Npos (XO (XO (XO (XO (XO (XO XH)))))))
| Sar -> None
| Sbb -> None
| Setc -> Some (Npos (XO (XO (XO XH))))
| Seto -> Some (Npos (XO (XO (XO XH))))
| Shl -> None
| Shlx -> None
| Shr -> None
| Shrx -> None
| Shrd -> None
| Sub -> None
| Test -> None
| Xchg -> None
| Xor -> None

(** val operation_size : normalInstruction -> n option **)

let operation_size instr =
  match opcode_size instr.op with
  | Some s0 -> Some s0
  | None ->
    let argsizes = map standalone_operand_size instr.args in
    (match Option.List.lift argsizes with
     | Some szs ->
       (match szs with
        | [] -> None
        | _ :: _ -> Some (fold_right Coq_N.max N0 szs))
     | None ->
       (match Option.List.map (Obj.magic id) argsizes with
        | [] -> None
        | n3 :: l ->
          let szs = n3 :: l in
          let m4 = fold_right Coq_N.max N0 szs in
          let n4 = fold_right Coq_N.min m4 szs in
          if Coq_N.eqb m4 n4 then Some n4 else None))

(** val operand_size : aRG -> n -> n **)

let operand_size x operation_size0 =
  match standalone_operand_size x with
  | Some s0 -> s0
  | None -> operation_size0

(** val reg_index : rEG -> nat **)

let reg_index = function
| Rax -> O
| Rcx -> S O
| Rdx -> S (S O)
| Rbx -> S (S (S O))
| Rsp -> S (S (S (S O)))
| Rbp -> S (S (S (S (S O))))
| Rsi -> S (S (S (S (S (S O)))))
| Rdi -> S (S (S (S (S (S (S O))))))
| R8 -> S (S (S (S (S (S (S (S O)))))))
| R9 -> S (S (S (S (S (S (S (S (S O))))))))
| R10 -> S (S (S (S (S (S (S (S (S (S O)))))))))
| R11 -> S (S (S (S (S (S (S (S (S (S (S O))))))))))
| R12 -> S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))
| R13 -> S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))
| R14 -> S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))
| R15 -> S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))
| Eax -> O
| Ecx -> S O
| Edx -> S (S O)
| Ebx -> S (S (S O))
| Esp -> S (S (S (S O)))
| Ebp -> S (S (S (S (S O))))
| Esi -> S (S (S (S (S (S O)))))
| Edi -> S (S (S (S (S (S (S O))))))
| R8d -> S (S (S (S (S (S (S (S O)))))))
| R9d -> S (S (S (S (S (S (S (S (S O))))))))
| R10d -> S (S (S (S (S (S (S (S (S (S O)))))))))
| R11d -> S (S (S (S (S (S (S (S (S (S (S O))))))))))
| R12d -> S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))
| R13d -> S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))
| R14d -> S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))
| R15d -> S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))
| Ax -> O
| Cx -> S O
| Dx -> S (S O)
| Bx -> S (S (S O))
| Sp -> S (S (S (S O)))
| Bp -> S (S (S (S (S O))))
| Si -> S (S (S (S (S (S O)))))
| Di -> S (S (S (S (S (S (S O))))))
| R8w -> S (S (S (S (S (S (S (S O)))))))
| R9w -> S (S (S (S (S (S (S (S (S O))))))))
| R10w -> S (S (S (S (S (S (S (S (S (S O)))))))))
| R11w -> S (S (S (S (S (S (S (S (S (S (S O))))))))))
| R12w -> S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))
| R13w -> S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))
| R14w -> S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))
| R15w -> S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))
| Ah -> O
| Al -> O
| Ch -> S O
| Cl -> S O
| Dh -> S (S O)
| Dl -> S (S O)
| Bh -> S (S (S O))
| Bl -> S (S (S O))
| Spl -> S (S (S (S O)))
| Bpl -> S (S (S (S (S O))))
| Sil -> S (S (S (S (S (S O)))))
| Dil -> S (S (S (S (S (S (S O))))))
| R8b -> S (S (S (S (S (S (S (S O)))))))
| R9b -> S (S (S (S (S (S (S (S (S O))))))))
| R10b -> S (S (S (S (S (S (S (S (S (S O)))))))))
| R11b -> S (S (S (S (S (S (S (S (S (S (S O))))))))))
| R12b -> S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))
| R13b -> S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))
| R14b -> S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))
| R15b -> S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))

(** val reg_offset : rEG -> n **)

let reg_offset = function
| Rax -> N0
| Rcx -> N0
| Rdx -> N0
| Rbx -> N0
| Rsp -> N0
| Rbp -> N0
| Rsi -> N0
| Rdi -> N0
| R8 -> N0
| R9 -> N0
| R10 -> N0
| R11 -> N0
| R12 -> N0
| R13 -> N0
| R14 -> N0
| R15 -> N0
| Eax -> N0
| Ecx -> N0
| Edx -> N0
| Ebx -> N0
| Esp -> N0
| Ebp -> N0
| Esi -> N0
| Edi -> N0
| R8d -> N0
| R9d -> N0
| R10d -> N0
| R11d -> N0
| R12d -> N0
| R13d -> N0
| R14d -> N0
| R15d -> N0
| Ax -> N0
| Cx -> N0
| Dx -> N0
| Bx -> N0
| Sp -> N0
| Bp -> N0
| Si -> N0
| Di -> N0
| R8w -> N0
| R9w -> N0
| R10w -> N0
| R11w -> N0
| R12w -> N0
| R13w -> N0
| R14w -> N0
| R15w -> N0
| Ah -> Npos (XO (XO (XO XH)))
| Al -> N0
| Ch -> Npos (XO (XO (XO XH)))
| Cl -> N0
| Dh -> Npos (XO (XO (XO XH)))
| Dl -> N0
| Bh -> Npos (XO (XO (XO XH)))
| Bl -> N0
| Spl -> N0
| Bpl -> N0
| Sil -> N0
| Dil -> N0
| R8b -> N0
| R9b -> N0
| R10b -> N0
| R11b -> N0
| R12b -> N0
| R13b -> N0
| R14b -> N0
| R15b -> N0

(** val index_and_shift_and_bitcount_of_reg : rEG -> (nat * n) * n **)

let index_and_shift_and_bitcount_of_reg r0 =
  (((reg_index r0), (reg_offset r0)), (reg_size r0))

(** val regs_of_index : nat -> rEG list list **)

let regs_of_index = function
| O ->
  (Al :: (Ah :: [])) :: ((Ax :: []) :: ((Eax :: []) :: ((Rax :: []) :: [])))
| S n3 ->
  (match n3 with
   | O ->
     (Cl :: (Ch :: [])) :: ((Cx :: []) :: ((Ecx :: []) :: ((Rcx :: []) :: [])))
   | S n4 ->
     (match n4 with
      | O ->
        (Dl :: (Dh :: [])) :: ((Dx :: []) :: ((Edx :: []) :: ((Rdx :: []) :: [])))
      | S n5 ->
        (match n5 with
         | O ->
           (Bl :: (Bh :: [])) :: ((Bx :: []) :: ((Ebx :: []) :: ((Rbx :: []) :: [])))
         | S n6 ->
           (match n6 with
            | O ->
              (Spl :: []) :: ((Sp :: []) :: ((Esp :: []) :: ((Rsp :: []) :: [])))
            | S n7 ->
              (match n7 with
               | O ->
                 (Bpl :: []) :: ((Bp :: []) :: ((Ebp :: []) :: ((Rbp :: []) :: [])))
               | S n8 ->
                 (match n8 with
                  | O ->
                    (Sil :: []) :: ((Si :: []) :: ((Esi :: []) :: ((Rsi :: []) :: [])))
                  | S n9 ->
                    (match n9 with
                     | O ->
                       (Dil :: []) :: ((Di :: []) :: ((Edi :: []) :: ((Rdi :: []) :: [])))
                     | S n10 ->
                       (match n10 with
                        | O ->
                          (R8b :: []) :: ((R8w :: []) :: ((R8d :: []) :: ((R8 :: []) :: [])))
                        | S n11 ->
                          (match n11 with
                           | O ->
                             (R9b :: []) :: ((R9w :: []) :: ((R9d :: []) :: ((R9 :: []) :: [])))
                           | S n12 ->
                             (match n12 with
                              | O ->
                                (R10b :: []) :: ((R10w :: []) :: ((R10d :: []) :: ((R10 :: []) :: [])))
                              | S n13 ->
                                (match n13 with
                                 | O ->
                                   (R11b :: []) :: ((R11w :: []) :: ((R11d :: []) :: ((R11 :: []) :: [])))
                                 | S n14 ->
                                   (match n14 with
                                    | O ->
                                      (R12b :: []) :: ((R12w :: []) :: ((R12d :: []) :: ((R12 :: []) :: [])))
                                    | S n15 ->
                                      (match n15 with
                                       | O ->
                                         (R13b :: []) :: ((R13w :: []) :: ((R13d :: []) :: ((R13 :: []) :: [])))
                                       | S n16 ->
                                         (match n16 with
                                          | O ->
                                            (R14b :: []) :: ((R14w :: []) :: ((R14d :: []) :: ((R14 :: []) :: [])))
                                          | S n17 ->
                                            (match n17 with
                                             | O ->
                                               (R15b :: []) :: ((R15w :: []) :: ((R15d :: []) :: ((R15 :: []) :: [])))
                                             | S _ -> [])))))))))))))))

(** val widest_register_of_index : nat -> rEG **)

let widest_register_of_index = function
| O -> Rax
| S n4 ->
  (match n4 with
   | O -> Rcx
   | S n5 ->
     (match n5 with
      | O -> Rdx
      | S n6 ->
        (match n6 with
         | O -> Rbx
         | S n7 ->
           (match n7 with
            | O -> Rsp
            | S n8 ->
              (match n8 with
               | O -> Rbp
               | S n9 ->
                 (match n9 with
                  | O -> Rsi
                  | S n10 ->
                    (match n10 with
                     | O -> Rdi
                     | S n11 ->
                       (match n11 with
                        | O -> R8
                        | S n12 ->
                          (match n12 with
                           | O -> R9
                           | S n13 ->
                             (match n13 with
                              | O -> R10
                              | S n14 ->
                                (match n14 with
                                 | O -> R11
                                 | S n15 ->
                                   (match n15 with
                                    | O -> R12
                                    | S n16 ->
                                      (match n16 with
                                       | O -> R13
                                       | S n17 ->
                                         (match n17 with
                                          | O -> R14
                                          | S n18 ->
                                            (match n18 with
                                             | O -> R15
                                             | S _ -> Rax)))))))))))))))

(** val reg_of_index_and_shift_and_bitcount_opt :
    ((nat * n) * n) -> rEG option **)

let reg_of_index_and_shift_and_bitcount_opt = function
| (y, size0) ->
  let (index, offset) = y in
  let sz = Coq_N.log2 (Coq_N.div size0 (Npos (XO (XO (XO XH))))) in
  let offset_n = Coq_N.div offset (Npos (XO (XO (XO XH)))) in
  if (&&)
       (Coq_N.eqb
         (Coq_N.mul (Npos (XO (XO (XO XH)))) (Coq_N.pow (Npos (XO XH)) sz))
         size0)
       (Coq_N.eqb offset (Coq_N.mul offset_n (Npos (XO (XO (XO XH))))))
  then bind (nth_error (regs_of_index index) (Coq_N.to_nat sz)) (fun rs ->
         nth_error rs (Coq_N.to_nat offset_n))
  else None

(** val sum_beq :
    ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) sum -> ('a1,
    'a2) sum -> bool **)

let sum_beq eq_A eq_B x y =
  match x with
  | Inl x0 -> (match y with
               | Inl x1 -> eq_A x0 x1
               | Inr _ -> false)
  | Inr x0 -> (match y with
               | Inl _ -> false
               | Inr x1 -> eq_B x0 x1)

(** val dec_sumwise :
    ('a1 -> 'a1 -> decidable) -> ('a2 -> 'a2 -> decidable) -> ('a1, 'a2) sum
    -> ('a1, 'a2) sum -> decidable **)

let dec_sumwise hA hB = function
| Inl a -> (fun y0 -> match y0 with
                      | Inl a0 -> hA a a0
                      | Inr _ -> false)
| Inr b -> (fun y0 -> match y0 with
                      | Inl _ -> false
                      | Inr b0 -> hB b b0)

module Sum =
 struct
  (** val compare :
      ('a1 -> 'a1 -> comparison) -> ('a2 -> 'a2 -> comparison) -> ('a1, 'a2)
      sum -> ('a1, 'a2) sum -> comparison **)

  let compare a_compare b_compare x y =
    match x with
    | Inl x0 -> (match y with
                 | Inl y0 -> a_compare x0 y0
                 | Inr _ -> Lt)
    | Inr x0 -> (match y with
                 | Inl _ -> Gt
                 | Inr y0 -> b_compare x0 y0)
 end

(** val reflect_of_brel : ('a1 -> 'a2 -> bool) -> 'a1 -> 'a2 -> reflect **)

let reflect_of_brel rb x y =
  let b = rb x y in
  (if b then (fun _ _ -> ReflectT) else (fun _ _ -> ReflectF)) __ __

(** val reflect_of_beq : ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 -> reflect **)

let reflect_of_beq =
  reflect_of_brel

(** val reflect_of_BoolSpec : bool -> reflect **)

let reflect_of_BoolSpec b =
  (if b then (fun _ -> ReflectT) else (fun _ -> ReflectF)) __

(** val reflect_rel_of_BoolSpec :
    ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 -> reflect **)

let reflect_rel_of_BoolSpec rb x y =
  reflect_of_BoolSpec (rb x y)

(** val cONST_beq : cONST -> cONST -> bool **)

let cONST_beq =
  Coq_Z.eqb

(** val jUMP_LABEL_beq : jUMP_LABEL -> jUMP_LABEL -> bool **)

let jUMP_LABEL_beq x y =
  (&&) (eqb x.jump_near y.jump_near) (eqb0 x.label_name y.label_name)

(** val mEM_beq : mEM -> mEM -> bool **)

let mEM_beq x y =
  (&&)
    ((&&)
      ((&&)
        ((&&)
          (option_beq accessSize_beq x.mem_bits_access_size
            y.mem_bits_access_size)
          (option_beq eqb0 x.mem_base_label y.mem_base_label))
        (option_beq rEG_beq x.mem_base_reg y.mem_base_reg))
      (option_beq (prod_beq Coq_Z.eqb rEG_beq) x.mem_scale_reg
        y.mem_scale_reg)) (option_beq Coq_Z.eqb x.mem_offset y.mem_offset)

(** val aRG_beq : aRG -> aRG -> bool **)

let aRG_beq x y =
  match x with
  | Reg x0 ->
    (match y with
     | Reg y0 -> rEG_beq x0 y0
     | Mem _ -> false
     | Const _ -> false
     | Label _ -> false)
  | Mem x0 ->
    (match y with
     | Reg _ -> false
     | Mem y0 -> mEM_beq x0 y0
     | Const _ -> false
     | Label _ -> false)
  | Const x0 ->
    (match y with
     | Reg _ -> false
     | Mem _ -> false
     | Const y0 -> cONST_beq x0 y0
     | Label _ -> false)
  | Label x0 ->
    (match y with
     | Reg _ -> false
     | Mem _ -> false
     | Const _ -> false
     | Label y0 -> jUMP_LABEL_beq x0 y0)

(** val normalInstruction_beq :
    normalInstruction -> normalInstruction -> bool **)

let normalInstruction_beq x y =
  (&&)
    ((&&) (option_beq opPrefix_beq x.prefix0 y.prefix0)
      (opCode_beq x.op y.op)) (list_beq aRG_beq x.args y.args)

(** val rawLine_beq : rawLine -> rawLine -> bool **)

let rawLine_beq x y =
  match x with
  | SECTION x0 ->
    (match y with
     | SECTION y0 -> eqb0 x0 y0
     | GLOBAL _ -> false
     | LABEL _ -> false
     | ALIGN _ -> false
     | DEFAULT_REL -> false
     | EMPTY -> false
     | INSTR _ -> false)
  | GLOBAL x0 ->
    (match y with
     | SECTION _ -> false
     | GLOBAL y0 -> eqb0 x0 y0
     | LABEL _ -> false
     | ALIGN _ -> false
     | DEFAULT_REL -> false
     | EMPTY -> false
     | INSTR _ -> false)
  | LABEL x0 ->
    (match y with
     | SECTION _ -> false
     | GLOBAL _ -> false
     | LABEL y0 -> eqb0 x0 y0
     | ALIGN _ -> false
     | DEFAULT_REL -> false
     | EMPTY -> false
     | INSTR _ -> false)
  | ALIGN x0 ->
    (match y with
     | SECTION _ -> false
     | GLOBAL _ -> false
     | LABEL _ -> false
     | ALIGN y0 -> eqb0 x0 y0
     | DEFAULT_REL -> false
     | EMPTY -> false
     | INSTR _ -> false)
  | DEFAULT_REL ->
    (match y with
     | SECTION _ -> false
     | GLOBAL _ -> false
     | LABEL _ -> false
     | ALIGN _ -> false
     | DEFAULT_REL -> true
     | EMPTY -> false
     | INSTR _ -> false)
  | EMPTY ->
    (match y with
     | SECTION _ -> false
     | GLOBAL _ -> false
     | LABEL _ -> false
     | ALIGN _ -> false
     | DEFAULT_REL -> false
     | EMPTY -> true
     | INSTR _ -> false)
  | INSTR x0 ->
    (match y with
     | SECTION _ -> false
     | GLOBAL _ -> false
     | LABEL _ -> false
     | ALIGN _ -> false
     | DEFAULT_REL -> false
     | EMPTY -> false
     | INSTR y0 -> normalInstruction_beq x0 y0)

(** val line_beq : line -> line -> bool **)

let line_beq x y =
  (&&)
    ((&&)
      ((&&) ((&&) (eqb0 x.indent y.indent) (rawLine_beq x.rawline y.rawline))
        (eqb0 x.pre_comment_whitespace y.pre_comment_whitespace))
      (option_beq eqb0 x.comment y.comment))
    (Coq_N.eqb x.line_number y.line_number)

type 't parserAction = char list -> ('t * char list) list

(** val parse_impossible : 'a1 parserAction **)

let parse_impossible _ =
  []

(** val parse_empty : unit parserAction **)

let parse_empty s0 =
  if eqb0 s0 [] then ((), []) :: [] else []

(** val parse_seq_gen :
    ('a1 -> 'a2 -> 'a3) -> 'a1 parserAction -> 'a2 parserAction -> 'a3
    parserAction **)

let parse_seq_gen f p1 p2 s0 =
  flat_map (fun pat ->
    let (a, s1) = pat in
    map (fun pat0 -> let (b, s2) = pat0 in ((f a b), s2)) (p2 s1)) (p1 s0)

(** val parse_alt_gen :
    (('a1, 'a2) sum -> 'a3) -> 'a1 parserAction -> 'a2 parserAction -> 'a3
    parserAction **)

let parse_alt_gen f p1 p2 s0 =
  app (map (fun pat -> let (v, s1) = pat in ((f (Inl v)), s1)) (p1 s0))
    (map (fun pat -> let (v, s1) = pat in ((f (Inr v)), s1)) (p2 s0))

(** val parse_alt :
    'a1 parserAction -> 'a1 parserAction -> 'a1 parserAction **)

let parse_alt p1 p2 =
  parse_alt_gen (fun aa -> match aa with
                           | Inl a -> a
                           | Inr a -> a) p1 p2

(** val parse_or_else_gen :
    (('a1, 'a2) sum -> 'a3) -> 'a1 parserAction -> 'a2 parserAction -> 'a3
    parserAction **)

let parse_or_else_gen f p1 p2 s0 =
  match p1 s0 with
  | [] -> map (fun pat -> let (v, s1) = pat in ((f (Inr v)), s1)) (p2 s0)
  | p :: l -> map (fun pat -> let (v, s1) = pat in ((f (Inl v)), s1)) (p :: l)

(** val parse_or_else :
    'a1 parserAction -> 'a1 parserAction -> 'a1 parserAction **)

let parse_or_else p1 p2 =
  parse_or_else_gen (fun aa -> match aa with
                               | Inl a -> a
                               | Inr a -> a) p1 p2

(** val parse_alpha_char : bool -> bool -> char parserAction **)

let parse_alpha_char lower0 upper0 = function
| [] -> []
| ch::s' ->
  if (||) ((&&) ((&&) lower0 (leb0 'a' ch)) (leb0 ch 'z'))
       ((&&) ((&&) upper0 (leb0 'A' ch)) (leb0 ch 'Z'))
  then (ch, s') :: []
  else []

(** val parse_ascii : char -> char parserAction **)

let parse_ascii prefix1 = function
| [] -> []
| ch::s' -> if (=) ch prefix1 then (ch, s') :: [] else []

(** val parse_str : char list -> char list parserAction **)

let parse_str prefix1 s0 =
  if startswith prefix1 s0
  then (prefix1, (substring (length0 prefix1) (length0 s0) s0)) :: []
  else []

(** val parse_str_case_insensitive : char list -> char list parserAction **)

let parse_str_case_insensitive prefix1 s0 =
  let (s1, s2) = ((substring O (length0 prefix1) s0),
    (substring (length0 prefix1) (length0 s0) s0))
  in
  if eqb0 (to_lower0 prefix1) (to_lower0 s1) then (s1, s2) :: [] else []

(** val parse_map : ('a1 -> 'a2) -> 'a1 parserAction -> 'a2 parserAction **)

let parse_map f p s0 =
  map (fun pat -> let (v, s1) = pat in ((f v), s1)) (p s0)

(** val parse_flat_map :
    ('a1 -> 'a2 list) -> 'a1 parserAction -> 'a2 parserAction **)

let parse_flat_map f p s0 =
  flat_map (fun pat -> let (v, s1) = pat in map (fun fv -> (fv, s1)) (f v))
    (p s0)

(** val parse_option_list_map :
    ('a1 -> 'a2 option) -> 'a1 parserAction -> 'a2 parserAction **)

let parse_option_list_map f =
  parse_flat_map (fun a -> match f a with
                           | Some v -> v :: []
                           | None -> [])

(** val parse_maybe : 'a1 parserAction -> 'a1 option parserAction **)

let parse_maybe p =
  parse_alt_gen (fun v -> match v with
                          | Inl v0 -> Some v0
                          | Inr _ -> None) p (parse_str [])

(** val option_list_to_list : 'a1 list option -> 'a1 list **)

let option_list_to_list = function
| Some v0 -> v0
| None -> []

(** val fuel : (nat -> 'a1 parserAction) -> 'a1 parserAction **)

let fuel p s0 =
  p (S (length0 s0)) s0

(** val parse_plus_fueled :
    'a1 parserAction -> nat -> 'a1 list parserAction **)

let rec parse_plus_fueled p fuel0 =
  parse_seq_gen (fun x x0 -> x :: x0) p
    (match fuel0 with
     | O -> (fun _ -> [])
     | S fuel1 ->
       parse_map option_list_to_list (parse_maybe (parse_plus_fueled p fuel1)))

(** val parse_plus : 'a1 parserAction -> 'a1 list parserAction **)

let parse_plus p =
  fuel (parse_plus_fueled p)

(** val parse_star : 'a1 parserAction -> 'a1 list parserAction **)

let parse_star p =
  parse_map option_list_to_list (parse_maybe (parse_plus p))

(** val parse_lookahead_not : 'a1 parserAction -> unit parserAction **)

let parse_lookahead_not p s0 =
  match p s0 with
  | [] -> ((), s0) :: []
  | _ :: _ -> []

(** val parse_alt_list : 'a1 parserAction list -> 'a1 parserAction **)

let parse_alt_list ls =
  fold_left (fun p2 p1 ->
    parse_alt_gen (fun v -> match v with
                            | Inl v0 -> v0
                            | Inr v0 -> v0) p1 p2) ls parse_impossible

(** val parse_strs : (char list * 'a1) list -> 'a1 parserAction **)

let parse_strs ls =
  parse_alt_list
    (map (fun pat ->
      let (s0, v) = pat in parse_map (fun _ -> v) (parse_str s0)) ls)

(** val parse_strs_case_insensitive :
    (char list * 'a1) list -> 'a1 parserAction **)

let parse_strs_case_insensitive ls =
  parse_alt_list
    (map (fun pat ->
      let (s0, v) = pat in
      parse_map (fun _ -> v) (parse_str_case_insensitive s0)) ls)

(** val parse_one_whitespace : char list parserAction **)

let parse_one_whitespace =
  parse_alt
    (parse_alt
      (parse_alt
        (parse_alt (parse_alt (parse_str (' '::[])) (parse_str ('\t'::[])))
          (parse_str ('\n'::[]))) (parse_str ('\r'::[])))
      (parse_str ('\012'::[]))) (parse_str ('\011'::[]))

(** val parse_any_whitespace : char list list parserAction **)

let parse_any_whitespace =
  parse_star
    (parse_alt
      (parse_alt
        (parse_alt
          (parse_alt (parse_alt (parse_str (' '::[])) (parse_str ('\t'::[])))
            (parse_str ('\n'::[]))) (parse_str ('\r'::[])))
        (parse_str ('\012'::[]))) (parse_str ('\011'::[])))

(** val strip_whitespace_around : 'a1 parserAction -> 'a1 parserAction **)

let strip_whitespace_around p =
  parse_seq_gen (fun _ v -> v) parse_any_whitespace
    (parse_seq_gen (fun v _ -> v) p parse_any_whitespace)

(** val strip_whitespace_after : 'a1 parserAction -> 'a1 parserAction **)

let strip_whitespace_after p =
  parse_seq_gen (fun v _ -> v) p parse_any_whitespace

(** val parse_list_gen :
    char list -> char list -> char list -> 'a1 parserAction -> 'a1 list
    parserAction **)

let parse_list_gen leftbr sep rightbr parse =
  parse_seq_gen (fun _ v -> v) (strip_whitespace_around (parse_str leftbr))
    (parse_seq_gen (fun v _ -> match v with
                               | Some ls -> ls
                               | None -> [])
      (parse_maybe
        (parse_seq_gen (fun x x0 -> x :: x0) parse
          (parse_star
            (parse_seq_gen (fun _ tl1 -> tl1)
              (strip_whitespace_around (parse_str sep)) parse))))
      (strip_whitespace_around (parse_str rightbr)))

(** val parse_list : 'a1 parserAction -> 'a1 list parserAction **)

let parse_list parse =
  parse_list_gen ('['::[]) (';'::[]) (']'::[]) parse

(** val parse_comma_list : 'a1 parserAction -> 'a1 list parserAction **)

let parse_comma_list parse =
  parse_list_gen [] (','::[]) [] parse

(** val finalize : 'a1 parserAction -> char list -> 'a1 option **)

let finalize p s0 =
  match parse_seq_gen (fun v _ -> v) p parse_empty s0 with
  | [] -> None
  | p0 :: l -> let (v, _) = p0 in (match l with
                                   | [] -> Some v
                                   | _ :: _ -> None)

(** val ascii_to_digit0 : char -> n option **)

let ascii_to_digit0 ch =
  if (=) ch '0' then Some N0 else if (=) ch '1' then Some (Npos XH) else None

module Coq_Raw =
 struct
  (** val of_pos : positive -> char list -> char list **)

  let rec of_pos p rest =
    match p with
    | XI p' -> of_pos p' ('1'::rest)
    | XO p' -> of_pos p' ('0'::rest)
    | XH -> '1'::rest

  (** val to_N : char list -> n -> n **)

  let rec to_N s0 rest =
    match s0 with
    | [] -> rest
    | ch::s' ->
      to_N s'
        (match ascii_to_digit0 ch with
         | Some v -> N.add v (N.double rest)
         | None -> N0)
 end

(** val of_pos1 : positive -> char list **)

let of_pos1 p =
  '0'::('b'::(Coq_Raw.of_pos p []))

(** val of_Z0 : z -> char list **)

let of_Z0 = function
| Z0 -> '0'::('b'::('0'::[]))
| Zpos p -> of_pos1 p
| Zneg p -> '-'::(of_pos1 p)

(** val to_N2 : char list -> n **)

let to_N2 = function
| [] -> N0
| s1::s2 ->
  (match s2 with
   | [] -> N0
   | sb::s3 ->
     if (=) s1 '0' then if (=) sb 'b' then Coq_Raw.to_N s3 N0 else N0 else N0)

(** val to_Z0 : char list -> z **)

let to_Z0 s0 =
  let (is_neg, n3) =
    match s0 with
    | [] -> (false, (to_N2 s0))
    | s1::s' -> if (=) s1 '-' then (true, (to_N2 s')) else (false, (to_N2 s0))
  in
  (match n3 with
   | N0 -> Z0
   | Npos p -> if is_neg then Zneg p else Zpos p)

(** val ascii_to_digit1 : char -> n option **)

let ascii_to_digit1 ch =
  if (=) ch '0'
  then Some N0
  else if (=) ch '1'
       then Some (Npos XH)
       else if (=) ch '2'
            then Some (Npos (XO XH))
            else if (=) ch '3'
                 then Some (Npos (XI XH))
                 else if (=) ch '4'
                      then Some (Npos (XO (XO XH)))
                      else if (=) ch '5'
                           then Some (Npos (XI (XO XH)))
                           else if (=) ch '6'
                                then Some (Npos (XO (XI XH)))
                                else if (=) ch '7'
                                     then Some (Npos (XI (XI XH)))
                                     else None

module Coq0_Raw =
 struct
  (** val of_pos : positive -> char list -> char list **)

  let rec of_pos p rest =
    match p with
    | XI p0 ->
      (match p0 with
       | XI p1 ->
         (match p1 with
          | XI p' -> of_pos p' ('7'::rest)
          | XO p' -> of_pos p' ('3'::rest)
          | XH -> '7'::rest)
       | XO p1 ->
         (match p1 with
          | XI p' -> of_pos p' ('5'::rest)
          | XO p' -> of_pos p' ('1'::rest)
          | XH -> '5'::rest)
       | XH -> '3'::rest)
    | XO p0 ->
      (match p0 with
       | XI p1 ->
         (match p1 with
          | XI p' -> of_pos p' ('6'::rest)
          | XO p' -> of_pos p' ('2'::rest)
          | XH -> '6'::rest)
       | XO p1 ->
         (match p1 with
          | XI p' -> of_pos p' ('4'::rest)
          | XO p' -> of_pos p' ('0'::rest)
          | XH -> '4'::rest)
       | XH -> '2'::rest)
    | XH -> '1'::rest

  (** val to_N : char list -> n -> n **)

  let rec to_N s0 rest =
    match s0 with
    | [] -> rest
    | ch::s' ->
      to_N s'
        (match ascii_to_digit1 ch with
         | Some v -> N.add v (N.mul (Npos (XO (XO (XO XH)))) rest)
         | None -> N0)
 end

(** val of_pos2 : positive -> char list **)

let of_pos2 p =
  '0'::('o'::(Coq0_Raw.of_pos p []))

(** val of_Z1 : z -> char list **)

let of_Z1 = function
| Z0 -> '0'::('o'::('0'::[]))
| Zpos p -> of_pos2 p
| Zneg p -> '-'::(of_pos2 p)

(** val to_N3 : char list -> n **)

let to_N3 = function
| [] -> N0
| s1::s2 ->
  (match s2 with
   | [] -> N0
   | so::s3 ->
     if (=) s1 '0' then if (=) so 'o' then Coq0_Raw.to_N s3 N0 else N0 else N0)

(** val to_Z1 : char list -> z **)

let to_Z1 s0 =
  let (is_neg, n3) =
    match s0 with
    | [] -> (false, (to_N3 s0))
    | s1::s' -> if (=) s1 '-' then (true, (to_N3 s')) else (false, (to_N3 s0))
  in
  (match n3 with
   | N0 -> Z0
   | Npos p -> if is_neg then Zneg p else Zpos p)

(** val uint_of_char : char -> uint option -> uint option **)

let uint_of_char a = function
| Some d0 ->
  (* If this appears, you're using Ascii internals. Please don't *)
 (fun f c ->
  let n = Char.code c in
  let h i = (n land (1 lsl i)) <> 0 in
  f (h 0) (h 1) (h 2) (h 3) (h 4) (h 5) (h 6) (h 7))
    (fun b b0 b1 b2 b3 b4 b5 b6 ->
    if b
    then if b0
         then if b1
              then if b2
                   then None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D7 d0)
                             else None
                        else None
              else if b2
                   then None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D3 d0)
                             else None
                        else None
         else if b1
              then if b2
                   then None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D5 d0)
                             else None
                        else None
              else if b2
                   then if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D9 d0)
                             else None
                        else None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D1 d0)
                             else None
                        else None
    else if b0
         then if b1
              then if b2
                   then None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D6 d0)
                             else None
                        else None
              else if b2
                   then None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D2 d0)
                             else None
                        else None
         else if b1
              then if b2
                   then None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D4 d0)
                             else None
                        else None
              else if b2
                   then if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D8 d0)
                             else None
                        else None
                   else if b3
                        then if b4
                             then if b5
                                  then None
                                  else if b6 then None else Some (D0 d0)
                             else None
                        else None)
    a
| None -> None

module NilEmpty =
 struct
  (** val string_of_uint : uint -> char list **)

  let rec string_of_uint = function
  | Nil -> []
  | D0 d0 -> '0'::(string_of_uint d0)
  | D1 d0 -> '1'::(string_of_uint d0)
  | D2 d0 -> '2'::(string_of_uint d0)
  | D3 d0 -> '3'::(string_of_uint d0)
  | D4 d0 -> '4'::(string_of_uint d0)
  | D5 d0 -> '5'::(string_of_uint d0)
  | D6 d0 -> '6'::(string_of_uint d0)
  | D7 d0 -> '7'::(string_of_uint d0)
  | D8 d0 -> '8'::(string_of_uint d0)
  | D9 d0 -> '9'::(string_of_uint d0)

  (** val uint_of_string : char list -> uint option **)

  let rec uint_of_string = function
  | [] -> Some Nil
  | a::s1 -> uint_of_char a (uint_of_string s1)

  (** val string_of_int : signed_int -> char list **)

  let string_of_int = function
  | Pos d0 -> string_of_uint d0
  | Neg d0 -> '-'::(string_of_uint d0)

  (** val int_of_string : char list -> signed_int option **)

  let int_of_string s0 = match s0 with
  | [] -> Some (Pos Nil)
  | a::s' ->
    if (=) a '-'
    then option_map (fun x -> Neg x) (uint_of_string s')
    else option_map (fun x -> Pos x) (uint_of_string s0)
 end

module NilZero =
 struct
  (** val string_of_uint : uint -> char list **)

  let string_of_uint d = match d with
  | Nil -> '0'::[]
  | D0 _ -> NilEmpty.string_of_uint d
  | D1 _ -> NilEmpty.string_of_uint d
  | D2 _ -> NilEmpty.string_of_uint d
  | D3 _ -> NilEmpty.string_of_uint d
  | D4 _ -> NilEmpty.string_of_uint d
  | D5 _ -> NilEmpty.string_of_uint d
  | D6 _ -> NilEmpty.string_of_uint d
  | D7 _ -> NilEmpty.string_of_uint d
  | D8 _ -> NilEmpty.string_of_uint d
  | D9 _ -> NilEmpty.string_of_uint d

  (** val string_of_int : signed_int -> char list **)

  let string_of_int = function
  | Pos d0 -> string_of_uint d0
  | Neg d0 -> '-'::(string_of_uint d0)
 end

module Coq0_N =
 struct
  (** val to_string : n -> char list **)

  let to_string v =
    NilEmpty.string_of_uint (N.to_uint v)
 end

module Coq0_Pos =
 struct
  (** val to_string : positive -> char list **)

  let to_string v =
    Coq0_N.to_string (Npos v)
 end

module Coq0_Z =
 struct
  (** val of_string : char list -> z option **)

  let of_string s0 =
    option_map Z.of_int (NilEmpty.int_of_string s0)

  (** val to_string : z -> char list **)

  let to_string v =
    NilEmpty.string_of_int (Z.to_int v)
 end

module Coq_List =
 struct
  (** val groupAllBy' :
      ('a1 -> 'a1 -> bool) -> 'a1 list -> nat -> 'a1 list list **)

  let groupAllBy' f =
    let rec groupAllBy'0 ls = function
    | O -> (match ls with
            | [] -> []
            | _ :: _ -> ls :: [])
    | S fuel1 ->
      (match ls with
       | [] -> []
       | x :: xs ->
         let (xs0, ys) = partition (f x) xs in
         (x :: xs0) :: (groupAllBy'0 ys fuel1))
    in groupAllBy'0

  (** val groupAllBy : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list list **)

  let groupAllBy f ls =
    groupAllBy' f ls (length ls)
 end

(** val parse_bin_prefix : char list parserAction **)

let parse_bin_prefix =
  parse_str ('0'::('b'::[]))

(** val parse_oct_prefix : char list parserAction **)

let parse_oct_prefix =
  parse_str ('0'::('o'::[]))

(** val parse_dec_prefix : char list parserAction **)

let parse_dec_prefix =
  parse_str []

(** val parse_hex_prefix : char list parserAction **)

let parse_hex_prefix =
  parse_str ('0'::('x'::[]))

(** val parse_hex_postfix : char list parserAction **)

let parse_hex_postfix =
  parse_str ('h'::[])

(** val base_accepts_E : n -> bool **)

let base_accepts_E base1 =
  Coq_N.ltb
    (Coq_N.sub (Coq_N.add (Npos (XO (XI (XO XH)))) (n_of_ascii 'E'))
      (n_of_ascii 'A')) base1

(** val parse_digits_gen_step : n -> n parserAction **)

let parse_digits_gen_step base1 =
  parse_strs
    (flat_map (fun v ->
      if Coq_N.ltb v (Npos (XO (XI (XO XH))))
      then (((ascii_of_N (Coq_N.add v (n_of_ascii '0')))::[]), v) :: []
      else (((ascii_of_N
               (Coq_N.add (Coq_N.sub v (Npos (XO (XI (XO XH)))))
                 (n_of_ascii 'A')))::[]),
             v) :: ((((ascii_of_N
                        (Coq_N.add (Coq_N.sub v (Npos (XO (XI (XO XH)))))
                          (n_of_ascii 'a')))::[]), v) :: []))
      (map Coq_N.of_nat (seq O (Coq_N.to_nat base1))))

(** val digits_to_N : n -> n list -> n **)

let digits_to_N base1 digits =
  fold_left (fun so_far d -> Coq_N.add (Coq_N.mul base1 so_far) d) digits N0

(** val parse_N_digits : n -> n parserAction **)

let parse_N_digits base1 =
  parse_map (digits_to_N base1) (parse_plus (parse_digits_gen_step base1))

(** val parse_num_gen :
    bool -> n -> 'a1 parserAction option -> 'a2 parserAction option -> q
    parserAction **)

let parse_num_gen allow_neg base1 parse_prefix parse_postfix =
  let parse_E_exponent =
    parse_seq_gen (fun _ v ->
      qpower { qnum = (Zpos (XO (XI (XO XH)))); qden = XH } v)
      (parse_alt (parse_str ('e'::[])) (parse_str ('E'::[])))
      (parse_seq_gen (fun n3 v ->
        match n3 with
        | Some _ -> Coq_Z.opp (Coq_Z.of_N v)
        | None -> Coq_Z.of_N v)
        (parse_maybe (strip_whitespace_after (parse_str ('-'::[]))))
        (parse_N_digits base1))
  in
  let parse_P_exponent =
    parse_seq_gen (fun _ v -> qpower { qnum = (Zpos (XO XH)); qden = XH } v)
      (parse_alt (parse_str ('p'::[])) (parse_str ('P'::[])))
      (parse_seq_gen (fun n3 v ->
        match n3 with
        | Some _ -> Coq_Z.opp (Coq_Z.of_N v)
        | None -> Coq_Z.of_N v)
        (parse_maybe (strip_whitespace_after (parse_str ('-'::[]))))
        (parse_N_digits base1))
  in
  parse_seq_gen (fun n3 v -> match n3 with
                             | Some _ -> qopp v
                             | None -> v)
    (if allow_neg
     then parse_maybe (strip_whitespace_after (parse_str ('-'::[])))
     else parse_map (fun _ -> None) (parse_str []))
    (let parse_main =
       let parse_main_digits = parse_star (parse_digits_gen_step base1) in
       parse_seq_gen (fun n3 e ->
         match e with
         | Some e0 -> qmult n3 e0
         | None -> n3)
         (parse_alt
           (parse_seq_gen (fun ds decimals ->
             qplus (inject_Z (Coq_Z.of_N (digits_to_N base1 ds)))
               (qdiv (inject_Z (Coq_Z.of_N (digits_to_N base1 decimals)))
                 (qpower (inject_Z (Coq_Z.of_N base1))
                   (Coq_Z.of_N (Coq_N.of_nat (length decimals))))))
             (match parse_prefix with
              | Some _ -> parse_main_digits
              | None ->
                parse_seq_gen (fun x x0 -> x :: x0)
                  (parse_digits_gen_step
                    (Coq_N.min (Npos (XO (XI (XO XH)))) base1))
                  parse_main_digits)
             (parse_seq_gen (fun _ r0 -> r0) (parse_str ('.'::[]))
               (parse_star (parse_digits_gen_step base1))))
           (parse_map (fun digits ->
             inject_Z (Coq_Z.of_N (digits_to_N base1 digits)))
             (parse_plus (parse_digits_gen_step base1))))
         (parse_maybe
           (if base_accepts_E base1
            then parse_P_exponent
            else parse_alt parse_E_exponent parse_P_exponent))
     in
     match parse_prefix with
     | Some parse_prefix0 ->
       (match parse_postfix with
        | Some parse_postfix0 ->
          parse_seq_gen (fun _ r0 -> r0) parse_prefix0
            (parse_seq_gen (fun l _ -> l) parse_main parse_postfix0)
        | None -> parse_seq_gen (fun _ r0 -> r0) parse_prefix0 parse_main)
     | None ->
       (match parse_postfix with
        | Some parse_postfix0 ->
          parse_seq_gen (fun l _ -> l) parse_main parse_postfix0
        | None -> parse_main))

(** val parse_num_gen_prefix :
    bool -> n -> 'a1 parserAction -> q parserAction **)

let parse_num_gen_prefix allow_neg base1 parse_prefix =
  parse_num_gen allow_neg base1 (Some parse_prefix) None

(** val parse_num_gen_postfix :
    bool -> n -> 'a1 parserAction -> q parserAction **)

let parse_num_gen_postfix allow_neg base1 parse_postfix =
  parse_num_gen allow_neg base1 None (Some parse_postfix)

(** val parse_num : bool -> q parserAction **)

let parse_num allow_neg =
  parse_alt
    (parse_alt
      (parse_alt
        (parse_alt
          (parse_num_gen_prefix allow_neg (Npos (XO XH)) parse_bin_prefix)
          (parse_num_gen_prefix allow_neg (Npos (XO (XO (XO XH))))
            parse_oct_prefix))
        (parse_num_gen_prefix allow_neg (Npos (XO (XI (XO XH))))
          parse_dec_prefix))
      (parse_num_gen_prefix allow_neg (Npos (XO (XO (XO (XO XH)))))
        parse_hex_prefix))
    (parse_num_gen_postfix allow_neg (Npos (XO (XO (XO (XO XH)))))
      parse_hex_postfix)

type 'var qexpr_poly =
| Qvar of 'var
| Qv of q
| Qeopp of 'var qexpr_poly
| Qeadd of 'var qexpr_poly * 'var qexpr_poly
| Qesub of 'var qexpr_poly * 'var qexpr_poly
| Qemul of 'var qexpr_poly * 'var qexpr_poly
| Qediv of 'var qexpr_poly * 'var qexpr_poly
| Qepow of 'var qexpr_poly * 'var qexpr_poly

type ('t, 'var) monomial_in = ('t * ('var * z)) * ('var * z) list

type ('t, 'var) poly_in = 't * ('t, 'var) monomial_in list

(** val reduce_monomial :
    ('a2 -> 'a2 -> bool) -> ('a1, 'a2) monomial_in -> ('a1, ('a1, 'a2)
    monomial_in) sum **)

let reduce_monomial var_beq = function
| (p, vs) ->
  let (c0, v) = p in
  let vs0 =
    Coq_List.groupAllBy (fun pat ->
      let (v0, _) = pat in (fun pat0 -> let (v', _) = pat0 in var_beq v0 v'))
      (v :: vs)
  in
  (match Option.List.map (fun vs1 ->
           match vs1 with
           | [] -> None
           | y :: _ ->
             let (v0, _) = y in
             let e = fold_right Coq_Z.add Z0 (map snd vs1) in
             if Coq_Z.eqb e Z0 then None else Some (v0, e)) vs0 with
   | [] -> Inl c0
   | v0 :: vs1 -> Inr ((c0, v0), vs1))

(** val const_poly : 'a1 -> ('a1, 'a2) poly_in **)

let const_poly v =
  (v, [])

(** val var_monomial : 'a1 -> 'a2 -> ('a1, 'a2) monomial_in **)

let var_monomial one1 v =
  ((one1, (v, (Zpos XH))), [])

(** val var_poly : 'a1 -> 'a1 -> 'a2 -> ('a1, 'a2) poly_in **)

let var_poly zero1 one1 v =
  (zero1, ((var_monomial one1 v) :: []))

(** val add_poly :
    ('a1 -> 'a1 -> 'a1) -> ('a1, 'a2) poly_in -> ('a1, 'a2) poly_in -> ('a1,
    'a2) poly_in **)

let add_poly addT p1 p2 =
  let (c1, p3) = p1 in let (c2, p4) = p2 in ((addT c1 c2), (app p3 p4))

(** val mul_monomial :
    ('a1 -> 'a1 -> 'a1) -> ('a1, 'a2) monomial_in -> ('a1, 'a2) monomial_in
    -> ('a1, 'a2) monomial_in **)

let mul_monomial mulT m4 m5 =
  let (p, vs1) = m4 in
  let (coef1, p0) = p in
  let (v1, e1) = p0 in
  let (p1, vs2) = m5 in
  let (coef2, p2) = p1 in
  let (v2, e2) = p2 in
  (((mulT coef1 coef2), (v1, e1)), (app vs1 ((v2, e2) :: vs2)))

(** val scmul_monomial :
    ('a1 -> 'a1 -> 'a1) -> 'a1 -> ('a1, 'a2) monomial_in -> ('a1, 'a2)
    monomial_in **)

let scmul_monomial mulT sc = function
| (p, vs) ->
  let (coef0, p0) = p in let (v, e) = p0 in (((mulT sc coef0), (v, e)), vs)

(** val mul_poly :
    ('a1 -> 'a1 -> 'a1) -> ('a1 -> 'a1 -> 'a1) -> ('a1, 'a2) poly_in -> ('a1,
    'a2) poly_in -> ('a1, 'a2) poly_in **)

let mul_poly _ mulT p1 p2 =
  let (c1, p3) = p1 in
  let (c2, p4) = p2 in
  ((mulT c1 c2),
  (app (map (scmul_monomial mulT c1) p4)
    (app (map (scmul_monomial mulT c2) p3)
      (flat_map (fun p -> map (mul_monomial mulT p) p4) p3))))

(** val pow_monomial :
    ('a1 -> z -> 'a1) -> ('a1, 'a2) monomial_in -> z -> ('a1, 'a2) monomial_in **)

let pow_monomial powT m4 e =
  let (p, vs) = m4 in
  let (coef0, p0) = p in
  let (v, ev) = p0 in
  (((powT coef0 e), (v, (Coq_Z.add ev e))),
  (map (fun pat -> let (v0, ev0) = pat in (v0, (Coq_Z.add ev0 e))) vs))

(** val pow_poly_strict :
    ('a1 -> 'a1 -> 'a1) -> ('a1 -> 'a1 -> 'a1) -> ('a1 -> z -> 'a1 option) ->
    'a1 -> ('a1, 'a2) poly_in -> z -> ('a1, 'a2) poly_in option **)

let pow_poly_strict addT mulT powT one1 p e =
  let (c0, l) = p in
  (match l with
   | [] -> bind (powT c0 e) (fun c1 -> Some (c1, []))
   | _ :: _ ->
     (match e with
      | Z0 -> Some (one1, [])
      | Zpos e0 ->
        Some (Coq_Pos.iter (mul_poly addT mulT p) (const_poly one1) e0)
      | Zneg _ -> None))

(** val monomial_var_part_beq :
    ('a2 -> 'a2 -> bool) -> ('a1, 'a2) monomial_in -> ('a1, 'a2) monomial_in
    -> bool **)

let monomial_var_part_beq var_beq m4 m5 =
  match reduce_monomial var_beq
          (mul_monomial (fun a _ -> a) m4
            (pow_monomial (fun a _ -> a) m5 (Zneg XH))) with
  | Inl _ -> true
  | Inr _ -> false

(** val reduce_poly :
    ('a2 -> 'a2 -> bool) -> ('a1 -> bool) -> ('a1 -> 'a1) -> ('a1 -> 'a1 ->
    'a1) -> ('a1, 'a2) poly_in -> ('a1, 'a2) poly_in **)

let reduce_poly var_beq t_zero_beq reduceT addT = function
| (c0, vs) ->
  let vs0 = map (reduce_monomial var_beq) vs in
  let cs =
    Option.List.map (fun v -> match v with
                              | Inl v0 -> Some v0
                              | Inr _ -> None) vs0
  in
  let vs1 =
    Option.List.map (fun v -> match v with
                              | Inl _ -> None
                              | Inr v0 -> Some v0) vs0
  in
  let c1 = fold_right addT c0 cs in
  let vs2 = Coq_List.groupAllBy (monomial_var_part_beq var_beq) vs1 in
  ((reduceT c1),
  (Option.List.map (fun vs3 ->
    match vs3 with
    | [] -> None
    | y :: vs4 ->
      let (y0, v0s) = y in
      let (c2, v0) = y0 in
      let c3 =
        reduceT
          (fold_right addT c2
            (map (fun pat -> let (y1, _) = pat in let (c3, _) = y1 in c3) vs4))
      in
      if t_zero_beq c3 then None else Some ((c3, v0), v0s)) vs2))

(** val reduce_Qpoly :
    ('a1 -> 'a1 -> bool) -> (q, 'a1) poly_in -> (q, 'a1) poly_in **)

let reduce_Qpoly var_beq =
  reduce_poly var_beq (qeq_bool { qnum = Z0; qden = XH }) qred qplus

(** val poly_coef_map_strict :
    ('a1 -> 'a2 option) -> ('a1, 'a3) poly_in -> ('a2, 'a3) poly_in option **)

let poly_coef_map_strict f = function
| (c0, vs) ->
  bind (f c0) (fun c1 ->
    Option.List.bind_list
      (map (fun pat ->
        let (y, vs0) = pat in
        let (c2, v) = y in bind (f c2) (fun c3 -> Some ((c3, v), vs0))) vs)
      (fun vs0 -> Some (c1, vs0)))

(** val eval_Qexpr_poly_strict : 'a1 qexpr_poly -> (q, 'a1) poly_in option **)

let rec eval_Qexpr_poly_strict = function
| Qvar v0 ->
  Some (var_poly { qnum = Z0; qden = XH } { qnum = (Zpos XH); qden = XH } v0)
| Qv x -> Some (const_poly x)
| Qeopp a ->
  option_map
    (mul_poly qplus qmult (const_poly { qnum = (Zneg XH); qden = XH }))
    (eval_Qexpr_poly_strict a)
| Qeadd (a, b) ->
  bind (eval_Qexpr_poly_strict a) (fun a0 ->
    bind (eval_Qexpr_poly_strict b) (fun b0 -> Some (add_poly qplus a0 b0)))
| Qesub (a, b) ->
  bind (eval_Qexpr_poly_strict a) (fun a0 ->
    bind (eval_Qexpr_poly_strict b) (fun b0 -> Some
      (add_poly qplus a0
        (mul_poly qplus qmult (const_poly { qnum = (Zneg XH); qden = XH }) b0))))
| Qemul (a, b) ->
  bind (eval_Qexpr_poly_strict a) (fun a0 ->
    bind (eval_Qexpr_poly_strict b) (fun b0 -> Some
      (mul_poly qplus qmult a0 b0)))
| Qediv (a, b) ->
  bind (eval_Qexpr_poly_strict a) (fun a0 ->
    bind (eval_Qexpr_poly_strict b) (fun b0 ->
      bind
        (pow_poly_strict qplus qmult (fun x y ->
          if (&&) (qeq_bool x { qnum = Z0; qden = XH }) (Coq_Z.leb y Z0)
          then None
          else Some (qpower x y)) { qnum = (Zpos XH); qden = XH } b0 (Zneg
          XH)) (fun b1 -> Some (mul_poly qplus qmult a0 b1))))
| Qepow (b, e) ->
  bind (eval_Qexpr_poly_strict b) (fun b0 ->
    bind (eval_Qexpr_poly_strict e) (fun e0 ->
      let (e1, l) = e0 in
      (match l with
       | [] ->
         let (qe, re) = Coq_Z.div_eucl e1.qnum (Zpos e1.qden) in
         if Coq_Z.eqb re Z0
         then pow_poly_strict qplus qmult (fun x y ->
                if (&&) (qeq_bool x { qnum = Z0; qden = XH }) (Coq_Z.leb y Z0)
                then None
                else Some (qpower x y)) { qnum = (Zpos XH); qden = XH } b0 qe
         else None
       | _ :: _ -> None)))

(** val eval_Qexpr_strict : empty_set qexpr_poly -> q option **)

let eval_Qexpr_strict v =
  match eval_Qexpr_poly_strict v with
  | Some p ->
    let (c0, l) = p in
    (match l with
     | [] -> Some c0
     | m4 :: _ ->
       let (p0, _) = m4 in
       let (_, p1) = p0 in let (_, _) = p1 in assert false (* absurd case *))
  | None -> None

(** val eval_Qexpr_poly_reduced_strict :
    ('a1 -> 'a1 -> bool) -> 'a1 qexpr_poly -> (q, 'a1) poly_in option **)

let eval_Qexpr_poly_reduced_strict var_beq v =
  option_map (reduce_Qpoly var_beq) (eval_Qexpr_poly_strict v)

(** val parse_ops :
    (char list * ('a1 -> 'a1 -> 'a1)) list -> 'a1 parserAction -> 'a1
    parserAction **)

let parse_ops ls parse =
  parse_seq_gen (fun l fs -> fold_left (fun v f -> f v) fs l) parse
    (parse_star
      (parse_seq_gen (fun f r0 l -> f l r0)
        (strip_whitespace_around (parse_strs ls)) parse))

(** val parse_prefix_ops :
    (char list * ('a1 -> 'a1)) list -> 'a1 parserAction -> 'a1 parserAction **)

let parse_prefix_ops ls parse =
  parse_seq_gen (fun ls0 v -> fold_right (fun f -> f) v ls0)
    (parse_star (strip_whitespace_after (parse_strs ls))) parse

(** val parseQexpr_poly_gen_parens :
    q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
    qexpr_poly parserAction **)

let parseQexpr_poly_gen_parens parse_num0 parse_var parse =
  parse_alt
    (parse_alt
      (parse_seq_gen (fun _ v -> v) (parse_str ('('::[]))
        (parse_seq_gen (fun v _ -> v) (strip_whitespace_around parse)
          (parse_str (')'::[])))) (parse_map (fun x -> Qv x) parse_num0))
    (parse_map (fun x -> Qvar x) parse_var)

(** val parseQexpr_poly_gen_exp :
    q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
    qexpr_poly parserAction **)

let parseQexpr_poly_gen_exp parse_num0 parse_var parse =
  parse_ops ((('^'::[]), (fun x x0 -> Qepow (x, x0))) :: [])
    (parseQexpr_poly_gen_parens parse_num0 parse_var parse)

(** val parseQexpr_poly_gen_opp :
    q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
    qexpr_poly parserAction **)

let parseQexpr_poly_gen_opp parse_num0 parse_var parse =
  parse_prefix_ops ((('-'::[]), (fun x -> Qeopp x)) :: [])
    (parseQexpr_poly_gen_exp parse_num0 parse_var parse)

(** val parseQexpr_poly_gen_mul_div :
    q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
    qexpr_poly parserAction **)

let parseQexpr_poly_gen_mul_div parse_num0 parse_var parse =
  parse_ops ((('*'::[]), (fun x x0 -> Qemul (x, x0))) :: ((('/'::[]),
    (fun x x0 -> Qediv (x, x0))) :: []))
    (parseQexpr_poly_gen_opp parse_num0 parse_var parse)

(** val parseQexpr_poly_gen_add_sub :
    q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction -> 'a1
    qexpr_poly parserAction **)

let parseQexpr_poly_gen_add_sub parse_num0 parse_var parse =
  parse_ops ((('+'::[]), (fun x x0 -> Qeadd (x, x0))) :: ((('-'::[]),
    (fun x x0 -> Qesub (x, x0))) :: []))
    (parseQexpr_poly_gen_mul_div parse_num0 parse_var parse)

(** val parse_Qexpr_poly_fueled :
    q parserAction -> 'a1 parserAction -> nat -> 'a1 qexpr_poly parserAction **)

let rec parse_Qexpr_poly_fueled parse_num0 parse_var fuel0 =
  strip_whitespace_around
    (parseQexpr_poly_gen_add_sub parse_num0 parse_var
      (match fuel0 with
       | O -> parse_impossible
       | S fuel1 -> parse_Qexpr_poly_fueled parse_num0 parse_var fuel1))

(** val parse_Qexpr_poly_gen :
    q parserAction -> 'a1 parserAction -> 'a1 qexpr_poly parserAction **)

let parse_Qexpr_poly_gen parse_num0 parse_var =
  fuel (parse_Qexpr_poly_fueled parse_num0 parse_var)

(** val parse_Qexpr_poly : 'a1 parserAction -> 'a1 qexpr_poly parserAction **)

let parse_Qexpr_poly parse_var =
  parse_Qexpr_poly_gen (parse_num false) parse_var

(** val parse_Qexpr_with_vars :
    (char list * q) list -> empty_set qexpr_poly parserAction **)

let parse_Qexpr_with_vars vars0 =
  parse_Qexpr_poly_gen
    (fold_right (fun pat ->
      let (s0, q0) = pat in
      (fun default0 ->
      parse_alt default0 (parse_map (fun _ -> q0) (parse_str s0))))
      (parse_num false) vars0) parse_impossible

(** val q_to_Z_strict : q -> z option **)

let q_to_Z_strict x =
  let (q0, r0) = Coq_Z.div_eucl x.qnum (Zpos x.qden) in
  if Coq_Z.eqb r0 Z0 then Some q0 else None

(** val parse_Q_strict_with_vars : (char list * q) list -> q parserAction **)

let parse_Q_strict_with_vars vars0 =
  parse_option_list_map eval_Qexpr_strict (parse_Qexpr_with_vars vars0)

(** val parse_Q_poly_strict :
    ('a1 -> 'a1 -> bool) -> 'a1 parserAction -> (q, 'a1) poly_in parserAction **)

let parse_Q_poly_strict var_beq parse_var =
  parse_option_list_map (eval_Qexpr_poly_reduced_strict var_beq)
    (parse_Qexpr_poly parse_var)

(** val parse_Z_strict_with_vars : (char list * q) list -> z parserAction **)

let parse_Z_strict_with_vars vars0 =
  parse_option_list_map q_to_Z_strict (parse_Q_strict_with_vars vars0)

(** val parse_Z_poly_strict :
    ('a1 -> 'a1 -> bool) -> 'a1 parserAction -> (z, 'a1) poly_in parserAction **)

let parse_Z_poly_strict var_beq parse_var =
  parse_option_list_map (poly_coef_map_strict q_to_Z_strict)
    (parse_Q_poly_strict var_beq parse_var)

(** val parseQexpr_arith_with_vars :
    (char list * q) list -> char list -> empty_set qexpr_poly option **)

let parseQexpr_arith_with_vars vars0 s0 =
  finalize (parse_Qexpr_with_vars vars0) s0

(** val parseQ_arith_strict_with_vars :
    (char list * q) list -> char list -> q option **)

let parseQ_arith_strict_with_vars vars0 s0 =
  bind (parseQexpr_arith_with_vars vars0 s0) eval_Qexpr_strict

(** val parseZ_arith_strict_with_vars :
    (char list * q) list -> char list -> z option **)

let parseZ_arith_strict_with_vars vars0 s0 =
  bind (parseQ_arith_strict_with_vars vars0 s0) q_to_Z_strict

(** val parseN_arith_strict_with_vars :
    (char list * q) list -> char list -> n option **)

let parseN_arith_strict_with_vars vars0 s0 =
  bind (parseZ_arith_strict_with_vars vars0 s0) (fun z0 ->
    match z0 with
    | Z0 -> Some N0
    | Zpos p -> Some (Npos p)
    | Zneg _ -> None)

(** val parsenat_arith_strict_with_vars :
    (char list * q) list -> char list -> nat option **)

let parsenat_arith_strict_with_vars vars0 s0 =
  bind (parseN_arith_strict_with_vars vars0 s0) (fun n3 -> Some
    (Coq_N.to_nat n3))

(** val parse_Qexpr : empty_set qexpr_poly parserAction **)

let parse_Qexpr =
  parse_Qexpr_with_vars []

(** val parseQexpr_arith : char list -> empty_set qexpr_poly option **)

let parseQexpr_arith =
  parseQexpr_arith_with_vars []

(** val parseQ_arith_strict : char list -> q option **)

let parseQ_arith_strict =
  parseQ_arith_strict_with_vars []

(** val parseZ_arith_strict : char list -> z option **)

let parseZ_arith_strict =
  parseZ_arith_strict_with_vars []

(** val parseN_arith_strict : char list -> n option **)

let parseN_arith_strict =
  parseN_arith_strict_with_vars []

(** val parsenat_arith_strict : char list -> nat option **)

let parsenat_arith_strict =
  parsenat_arith_strict_with_vars []

(** val parse_Z_arith_strict : z parserAction **)

let parse_Z_arith_strict =
  parse_Z_strict_with_vars []

(** val let_In : 'a1 -> ('a1 -> 'a2) -> 'a2 **)

let let_In x f =
  f x

module Coq1_Z =
 struct
  (** val divideb : z -> z -> bool **)

  let divideb x y =
    if Coq_Z.eqb x Z0 then Coq_Z.eqb y Z0 else Coq_Z.eqb (Coq_Z.modulo y x) Z0

  (** val zselect : z -> z -> z -> z **)

  let zselect cond zero_case nonzero_case =
    if Coq_Z.eqb cond Z0 then zero_case else nonzero_case

  (** val add_modulo : z -> z -> z -> z **)

  let add_modulo x y modulus =
    if Coq_Z.leb modulus (Coq_Z.add x y)
    then Coq_Z.sub (Coq_Z.add x y) modulus
    else Coq_Z.add x y

  (** val lnot_modulo : z -> z -> z **)

  let lnot_modulo v modulus =
    Coq_Z.modulo (Coq_Z.lnot v) modulus

  (** val bneg : z -> z **)

  let bneg v =
    if dec (dec_eq_Z v Z0) then Zpos XH else Z0

  (** val cc_m : z -> z -> z **)

  let cc_m s0 x =
    if dec (dec_eq_Z (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 s0)) s0)
    then Coq_Z.shiftr x (Coq_Z.sub (Coq_Z.log2 s0) (Zpos XH))
    else Coq_Z.div x (Coq_Z.div s0 (Zpos (XO XH)))

  (** val rshi : z -> z -> z -> z -> z **)

  let rshi s0 hi lo n3 =
    let k = Coq_Z.log2 s0 in
    if dec (dec_eq_Z (Coq_Z.pow (Zpos (XO XH)) k) s0)
    then Coq_Z.coq_land (Coq_Z.shiftr (Coq_Z.add lo (Coq_Z.shiftl hi k)) n3)
           (Coq_Z.ones k)
    else Coq_Z.modulo (Coq_Z.shiftr (Coq_Z.add lo (Coq_Z.mul hi s0)) n3) s0

  (** val truncating_shiftl : z -> z -> z -> z **)

  let truncating_shiftl bw x n3 =
    Coq_Z.modulo (Coq_Z.shiftl x n3) (Coq_Z.pow (Zpos (XO XH)) bw)

  (** val get_carry : z -> z -> z * z **)

  let get_carry bitwidth v =
    ((Coq_Z.modulo v (Coq_Z.pow (Zpos (XO XH)) bitwidth)),
      (Coq_Z.div v (Coq_Z.pow (Zpos (XO XH)) bitwidth)))

  (** val add_with_carry : z -> z -> z -> z **)

  let add_with_carry c0 x y =
    Coq_Z.add (Coq_Z.add c0 x) y

  (** val add_with_get_carry : z -> z -> z -> z -> z * z **)

  let add_with_get_carry bitwidth c0 x y =
    let_In (add_with_carry c0 x y) (fun v -> get_carry bitwidth v)

  (** val add_get_carry : z -> z -> z -> z * z **)

  let add_get_carry bitwidth x y =
    add_with_get_carry bitwidth Z0 x y

  (** val get_borrow : z -> z -> z * z **)

  let get_borrow bitwidth v =
    let (v0, c0) = get_carry bitwidth v in (v0, (Coq_Z.opp c0))

  (** val sub_with_borrow : z -> z -> z -> z **)

  let sub_with_borrow c0 x y =
    add_with_carry (Coq_Z.opp c0) x (Coq_Z.opp y)

  (** val sub_with_get_borrow : z -> z -> z -> z -> z * z **)

  let sub_with_get_borrow bitwidth c0 x y =
    let_In (sub_with_borrow c0 x y) (fun v -> get_borrow bitwidth v)

  (** val sub_get_borrow : z -> z -> z -> z * z **)

  let sub_get_borrow bitwidth x y =
    sub_with_get_borrow bitwidth Z0 x y

  (** val add_get_carry_full : z -> z -> z -> z * z **)

  let add_get_carry_full bound x y =
    if Coq_Z.eqb (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 bound)) bound
    then add_get_carry (Coq_Z.log2 bound) x y
    else ((Coq_Z.modulo (Coq_Z.add x y) bound),
           (Coq_Z.div (Coq_Z.add x y) bound))

  (** val add_with_get_carry_full : z -> z -> z -> z -> z * z **)

  let add_with_get_carry_full bound c0 x y =
    if Coq_Z.eqb (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 bound)) bound
    then add_with_get_carry (Coq_Z.log2 bound) c0 x y
    else ((Coq_Z.modulo (Coq_Z.add (Coq_Z.add c0 x) y) bound),
           (Coq_Z.div (Coq_Z.add (Coq_Z.add c0 x) y) bound))

  (** val sub_get_borrow_full : z -> z -> z -> z * z **)

  let sub_get_borrow_full bound x y =
    if Coq_Z.eqb (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 bound)) bound
    then sub_get_borrow (Coq_Z.log2 bound) x y
    else ((Coq_Z.modulo (Coq_Z.sub x y) bound),
           (Coq_Z.opp (Coq_Z.div (Coq_Z.sub x y) bound)))

  (** val sub_with_get_borrow_full : z -> z -> z -> z -> z * z **)

  let sub_with_get_borrow_full bound c0 x y =
    if Coq_Z.eqb (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 bound)) bound
    then sub_with_get_borrow (Coq_Z.log2 bound) c0 x y
    else ((Coq_Z.modulo (Coq_Z.sub (Coq_Z.sub x y) c0) bound),
           (Coq_Z.opp (Coq_Z.div (Coq_Z.sub (Coq_Z.sub x y) c0) bound)))

  (** val mul_split_at_bitwidth : z -> z -> z -> z * z **)

  let mul_split_at_bitwidth bitwidth x y =
    let_In (Coq_Z.mul x y) (fun xy ->
      ((if Coq_Z.geb bitwidth Z0
        then Coq_Z.coq_land xy (Coq_Z.ones bitwidth)
        else Coq_Z.modulo xy (Coq_Z.pow (Zpos (XO XH)) bitwidth)),
      (if Coq_Z.geb bitwidth Z0
       then Coq_Z.shiftr xy bitwidth
       else Coq_Z.div xy (Coq_Z.pow (Zpos (XO XH)) bitwidth))))

  (** val mul_split : z -> z -> z -> z * z **)

  let mul_split s0 x y =
    if Coq_Z.eqb s0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 s0))
    then mul_split_at_bitwidth (Coq_Z.log2 s0) x y
    else ((Coq_Z.modulo (Coq_Z.mul x y) s0), (Coq_Z.div (Coq_Z.mul x y) s0))

  (** val mul_high : z -> z -> z -> z **)

  let mul_high s0 x y =
    snd (mul_split s0 x y)

  (** val ltz : z -> z -> z **)

  let ltz x y =
    if Coq_Z.ltb x y then Zpos XH else Z0

  (** val combine_at_bitwidth : z -> z -> z -> z **)

  let combine_at_bitwidth bitwidth lo hi =
    Coq_Z.add lo (Coq_Z.shiftl hi bitwidth)

  (** val round_lor_land_bound : z -> z **)

  let round_lor_land_bound x =
    if Coq_Z.leb Z0 x
    then Coq_Z.sub
           (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2_up (Coq_Z.add x (Zpos XH))))
           (Zpos XH)
    else Coq_Z.opp (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2_up (Coq_Z.opp x)))

  (** val log10_fuel : nat -> z -> z **)

  let rec log10_fuel fuel0 v =
    match fuel0 with
    | O -> Z0
    | S fuel1 ->
      if Coq_Z.gtb v (Zpos XH)
      then Coq_Z.add (Zpos XH)
             (log10_fuel fuel1 (Coq_Z.div v (Zpos (XO (XI (XO XH))))))
      else Z0

  (** val log10 : z -> z **)

  let log10 v =
    log10_fuel (Coq_Z.to_nat (Coq_Z.log2 v)) v

  (** val value_barrier : z -> z **)

  let value_barrier x =
    x
 end

module Level =
 struct
  type coq_Level =
  | Coq_neg_inf
  | Coq_level of z
  | Coq_pos_inf

  (** val internal_positive_beq : positive -> positive -> bool **)

  let rec internal_positive_beq x y =
    match x with
    | XI x0 ->
      (match y with
       | XI x1 -> internal_positive_beq x0 x1
       | XO _ -> false
       | XH -> false)
    | XO x0 ->
      (match y with
       | XI _ -> false
       | XO x1 -> internal_positive_beq x0 x1
       | XH -> false)
    | XH -> (match y with
             | XI _ -> false
             | XO _ -> false
             | XH -> true)

  (** val internal_Z_beq : z -> z -> bool **)

  let internal_Z_beq x y =
    match x with
    | Z0 -> (match y with
             | Z0 -> true
             | Zpos _ -> false
             | Zneg _ -> false)
    | Zpos x0 ->
      (match y with
       | Z0 -> false
       | Zpos x1 -> internal_positive_beq x0 x1
       | Zneg _ -> false)
    | Zneg x0 ->
      (match y with
       | Z0 -> false
       | Zpos _ -> false
       | Zneg x1 -> internal_positive_beq x0 x1)

  (** val next : coq_Level -> coq_Level **)

  let next = function
  | Coq_neg_inf -> Coq_neg_inf
  | Coq_level lvl -> Coq_level (Coq_Z.pred lvl)
  | Coq_pos_inf -> Coq_pos_inf

  (** val prev : coq_Level -> coq_Level **)

  let prev = function
  | Coq_neg_inf -> Coq_neg_inf
  | Coq_level lvl -> Coq_level (Coq_Z.succ lvl)
  | Coq_pos_inf -> Coq_pos_inf

  (** val compare : coq_Level -> coq_Level -> comparison **)

  let compare l1 l2 =
    match l1 with
    | Coq_neg_inf ->
      (match l2 with
       | Coq_neg_inf -> Eq
       | Coq_level _ -> Lt
       | Coq_pos_inf -> Lt)
    | Coq_level l3 ->
      (match l2 with
       | Coq_neg_inf -> Gt
       | Coq_level l4 -> Coq_Z.compare l3 l4
       | Coq_pos_inf -> Lt)
    | Coq_pos_inf ->
      (match l2 with
       | Coq_neg_inf -> Gt
       | Coq_level _ -> Gt
       | Coq_pos_inf -> Eq)

  (** val ltb : coq_Level -> coq_Level -> bool **)

  let ltb l1 l2 =
    match compare l1 l2 with
    | Eq -> false
    | Lt -> true
    | Gt -> false
 end

type associativity =
| LeftAssoc
| RightAssoc
| NoAssoc
| FullyAssoc
| ExplicitAssoc of Level.coq_Level * Level.coq_Level

type 't showLevel = 't -> Level.coq_Level -> char list

(** val show_lvl : 'a1 showLevel -> 'a1 -> Level.coq_Level -> char list **)

let show_lvl showLevel0 =
  showLevel0

type ('a, 'b) showLevel2 = 'a -> 'b -> Level.coq_Level -> char list

type ('a, 'b, 'c) showLevel3 = 'a -> 'b -> 'c -> Level.coq_Level -> char list

type 't show = 't -> char list

(** val show0 : 'a1 show -> 'a1 -> char list **)

let show0 show1 =
  show1

type 't showLines = 't -> char list list

(** val show_lines : 'a1 showLines -> 'a1 -> char list list **)

let show_lines showLines0 =
  showLines0

(** val show_of_ShowLevel : 'a1 showLevel -> 'a1 show **)

let show_of_ShowLevel h t0 =
  show_lvl h t0 (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI XH)))))))))

(** val showLines_of_Show : 'a1 show -> 'a1 showLines **)

let showLines_of_Show h t0 =
  (show0 h t0) :: []

(** val show_of_ShowLines : 'a1 showLines -> 'a1 show **)

let show_of_ShowLines h t0 =
  concat0 (newLine::[]) (show_lines h t0)

(** val show_lvl_const : (unit -> char list) showLevel **)

let show_lvl_const f _ =
  f ()

(** val show_lvl_id : (Level.coq_Level -> char list) showLevel **)

let show_lvl_id f =
  f

(** val maybe_wrap_parens : bool -> char list -> char list **)

let maybe_wrap_parens parens s0 =
  if parens then append ('('::[]) (append s0 (')'::[])) else s0

(** val show_wrap_parens :
    Level.coq_Level -> 'a1 showLevel -> 'a1 showLevel **)

let show_wrap_parens plvl h a lvl =
  if Level.ltb lvl plvl
  then append ('('::[])
         (append
           (show_lvl h a (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
             XH)))))))))) (')'::[]))
  else show_lvl h a lvl

(** val lvl_wrap_parens :
    Level.coq_Level -> char list -> Level.coq_Level -> char list **)

let lvl_wrap_parens plvl s0 =
  show_wrap_parens plvl show_lvl_const (fun pat -> let () = pat in s0)

(** val neg_wrap_parens_with_lvl :
    (Level.coq_Level -> char list) -> Level.coq_Level -> char list **)

let neg_wrap_parens_with_lvl f =
  show_wrap_parens (Level.Coq_level Z0) show_lvl_id f

(** val neg_wrap_parens : char list -> Level.coq_Level -> char list **)

let neg_wrap_parens f =
  neg_wrap_parens_with_lvl (fun _ -> f)

(** val showLevel2_binop_assoc :
    associativity -> Level.coq_Level -> char list -> 'a1 showLevel -> 'a2
    showLevel -> ('a1, 'a2) showLevel2 **)

let showLevel2_binop_assoc assoc binop_lvl binop h h0 a b =
  lvl_wrap_parens binop_lvl
    (match assoc with
     | LeftAssoc ->
       append (show_lvl h a binop_lvl)
         (append binop (show_lvl h0 b (Level.next binop_lvl)))
     | RightAssoc ->
       append (show_lvl h a (Level.next binop_lvl))
         (append binop (show_lvl h0 b binop_lvl))
     | NoAssoc ->
       append (show_lvl h a (Level.next binop_lvl))
         (append binop (show_lvl h0 b (Level.next binop_lvl)))
     | FullyAssoc ->
       append (show_lvl h a binop_lvl)
         (append binop (show_lvl h0 b binop_lvl))
     | ExplicitAssoc (lvl_l, lvl_r) ->
       append (show_lvl h a lvl_l) (append binop (show_lvl h0 b lvl_r)))

(** val show_lvl_binop :
    associativity -> Level.coq_Level -> 'a1 showLevel -> 'a2 showLevel -> 'a1
    -> char list -> 'a2 -> Level.coq_Level -> char list **)

let show_lvl_binop assoc binop_lvl sA sB a binop b =
  showLevel2_binop_assoc assoc binop_lvl binop sA sB a b

(** val show_lvl_app :
    'a1 showLevel -> 'a2 showLevel -> ('a1, 'a2) showLevel2 **)

let show_lvl_app h h0 =
  showLevel2_binop_assoc LeftAssoc (Level.Coq_level (Zpos (XO (XI (XO XH)))))
    (' '::[]) h h0

(** val show_lvl_app2 :
    'a1 showLevel -> 'a2 showLevel -> 'a3 showLevel -> ('a1, 'a2, 'a3)
    showLevel3 **)

let show_lvl_app2 h h0 h1 a b c0 =
  show_lvl_app show_lvl_id h1 (show_lvl_app h h0 a b) c0

(** val show_lvl_preop_assoc :
    associativity -> Level.coq_Level -> 'a1 showLevel -> char list -> 'a1 ->
    Level.coq_Level -> char list **)

let show_lvl_preop_assoc assoc op_lvl h preop a =
  show_lvl_binop assoc op_lvl show_lvl_const h (fun pat ->
    let () = pat in []) preop a

(** val show_lvl_postop_assoc :
    associativity -> Level.coq_Level -> 'a1 showLevel -> 'a1 -> char list ->
    Level.coq_Level -> char list **)

let show_lvl_postop_assoc assoc op_lvl h a postop =
  show_lvl_binop assoc op_lvl h show_lvl_const a postop (fun pat ->
    let () = pat in [])

(** val show_lvl_unop :
    Level.coq_Level -> char list -> 'a1 showLevel -> 'a1 showLevel **)

let show_lvl_unop unop_lvl unop h a =
  show_lvl_preop_assoc RightAssoc unop_lvl h unop a

(** val show_lvl_unit : unit showLevel **)

let show_lvl_unit = function
| () -> neg_wrap_parens ('t'::('t'::[]))

(** val show_lvl_bool : bool showLevel **)

let show_lvl_bool b =
  neg_wrap_parens
    (if b
     then 't'::('r'::('u'::('e'::[])))
     else 'f'::('a'::('l'::('s'::('e'::[])))))

(** val show_lvl_option : 'a1 showLevel -> 'a1 option showLevel **)

let show_lvl_option h = function
| Some v0 ->
  show_lvl_app show_lvl_const show_lvl_id (fun pat ->
    let () = pat in 'S'::('o'::('m'::('e'::[])))) (show_lvl h v0)
| None -> neg_wrap_parens ('N'::('o'::('n'::('e'::[]))))

(** val show_lvl_list : 'a1 showLevel -> 'a1 list showLevel **)

let show_lvl_list h ls =
  neg_wrap_parens
    (append ('['::[])
      (append
        (concat0 (','::(' '::[]))
          (map (fun v ->
            show_lvl h v (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
              XH)))))))))) ls)) (']'::[])))

(** val show_list : 'a1 show -> 'a1 list show **)

let show_list h =
  let x = fun h0 t0 _ -> show0 h0 t0 in
  show_of_ShowLevel (show_lvl_list (x h))

(** val show_lvl_prod :
    'a1 showLevel -> 'a2 showLevel -> ('a1 * 'a2) showLevel **)

let show_lvl_prod h h0 = function
| (a, b) ->
  show_lvl_binop LeftAssoc
    (Level.prev (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
      XH)))))))))) h h0 a (','::(' '::[])) b

(** val show_prod : 'a1 show -> 'a2 show -> ('a1 * 'a2) show **)

let show_prod h h0 =
  let x = fun h1 t0 _ -> show0 h1 t0 in
  let x0 = fun h1 t0 _ -> show0 h1 t0 in
  show_of_ShowLevel (show_lvl_prod (x h) (x0 h0))

(** val show_lvl_sum :
    'a1 showLevel -> 'a2 showLevel -> ('a1, 'a2) sum showLevel **)

let show_lvl_sum h h0 = function
| Inl v ->
  show_lvl_app show_lvl_const show_lvl_id (fun pat ->
    let () = pat in 'i'::('n'::('l'::[]))) (show_lvl h v)
| Inr v ->
  show_lvl_app show_lvl_const show_lvl_id (fun pat ->
    let () = pat in 'i'::('n'::('r'::[]))) (show_lvl h0 v)

(** val show_lvl_string : char list showLevel **)

let show_lvl_string s0 =
  neg_wrap_parens
    (append ('"'::[])
      (append (replace ('"'::[]) ('"'::('"'::[])) s0) ('"'::[])))

(** val show_lines_list : 'a1 showLines -> 'a1 list showLines **)

let show_lines_list h ls =
  let ls0 = map (show_lines h) ls in
  if forallb (fun lines0 -> Nat.eqb (length lines0) (S O)) ls0
  then (append ('['::[])
         (append (concat0 (','::(' '::[])) (map (concat0 (newLine::[])) ls0))
           (']'::[]))) :: []
  else app (('['::[]) :: [])
         (match ls0 with
          | [] -> (']'::[]) :: []
          | x :: xs ->
            app (map (fun x0 -> ' '::x0) x)
              (app
                (flat_map (fun x' ->
                  (','::[]) :: (map (fun x0 -> ' '::x0) x')) xs)
                ((']'::[]) :: [])))

module Decimal =
 struct
  (** val show_lvl_positive : positive showLevel **)

  let show_lvl_positive p =
    neg_wrap_parens (Coq0_Pos.to_string p)

  (** val show_positive : positive show **)

  let show_positive =
    show_of_ShowLevel show_lvl_positive

  (** val show_lvl_N : n showLevel **)

  let show_lvl_N n3 =
    neg_wrap_parens
      (match n3 with
       | N0 -> '0'::[]
       | Npos p -> show0 show_positive p)

  (** val show_N : n show **)

  let show_N =
    show_of_ShowLevel show_lvl_N

  (** val show_lvl_nat : nat showLevel **)

  let show_lvl_nat n3 =
    show_lvl show_lvl_N (Coq_N.of_nat n3)

  (** val show_nat : nat show **)

  let show_nat =
    show_of_ShowLevel show_lvl_nat

  (** val show_lvl_Z : z showLevel **)

  let show_lvl_Z = function
  | Z0 -> neg_wrap_parens ('0'::[])
  | Zpos p -> show_lvl show_lvl_positive p
  | Zneg p ->
    show_lvl_unop (Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH)))))))
      ('-'::[]) show_lvl_positive p

  (** val show_Z : z show **)

  let show_Z =
    show_of_ShowLevel show_lvl_Z

  (** val show_lvl_Q_frac : q showLevel **)

  let show_lvl_Q_frac q0 =
    if Coq_Pos.eqb q0.qden XH
    then show_lvl show_lvl_Z q0.qnum
    else show_lvl_binop NoAssoc (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
           XH))))))) show_lvl_Z show_lvl_positive q0.qnum
           (' '::('/'::(' '::[]))) q0.qden

  (** val show_lvl_Q : q showLevel **)

  let show_lvl_Q q0 =
    if Coq_Pos.eqb q0.qden XH
    then show_lvl show_lvl_Z q0.qnum
    else let lg10 = Coq1_Z.log10 (Zpos q0.qden) in
         if Coq_Z.eqb (Coq_Z.pow (Zpos (XO (XI (XO XH)))) lg10) (Zpos q0.qden)
         then let lg11 = Coq_Z.to_nat lg10 in
              let int_part =
                show_Z (Coq_Z.div (Coq_Z.abs q0.qnum) (Zpos q0.qden))
              in
              let dec_part =
                show_Z (Coq_Z.modulo (Coq_Z.abs q0.qnum) (Zpos q0.qden))
              in
              let abs_part =
                append int_part
                  (append ('.'::[])
                    (append
                      (string_of_list_ascii
                        (repeat '0' (sub lg11 (length0 dec_part)))) dec_part))
              in
              if Coq_Z.ltb q0.qnum Z0
              then show_lvl_unop (Level.Coq_level (Zpos (XI (XI (XO (XO (XO
                     XH))))))) ('-'::[]) show_lvl_const (fun pat ->
                     let () = pat in abs_part)
              else neg_wrap_parens abs_part
         else show_lvl_Q_frac q0

  (** val show_Q : q show **)

  let show_Q =
    show_of_ShowLevel show_lvl_Q
 end

module Hex =
 struct
  (** val show_lvl_positive : positive showLevel **)

  let show_lvl_positive p =
    neg_wrap_parens (of_pos0 p)

  (** val show_lvl_Z : z showLevel **)

  let show_lvl_Z z0 =
    let s0 = of_Z (Coq_Z.abs z0) in
    if Level.ltb (Level.Coq_level z0) (Level.Coq_level Z0)
    then show_lvl_unop (Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH)))))))
           ('-'::[]) show_lvl_const (fun pat -> let () = pat in s0)
    else neg_wrap_parens s0

  (** val show_Z : z show **)

  let show_Z =
    show_of_ShowLevel show_lvl_Z

  (** val show_lvl_N : n showLevel **)

  let show_lvl_N = function
  | N0 -> neg_wrap_parens ('0'::[])
  | Npos p -> show_lvl_positive p

  (** val show_N : n show **)

  let show_N =
    show_of_ShowLevel show_lvl_N
 end

module PowersOfTwo =
 struct
  (** val show_lvl_Z_up_to' : nat -> z -> bool -> z showLevel **)

  let rec show_lvl_Z_up_to' max0 max_dec0 neg =
    match max0 with
    | O -> Hex.show_lvl_Z
    | S n' ->
      (fun z0 ->
        if Coq_Z.ltb z0 max_dec0
        then Decimal.show_lvl_Z z0
        else if Coq_Z.leb
                  (Coq_Z.abs
                    (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2_up z0))
                      z0))
                  (Coq_Z.abs
                    (Coq_Z.sub z0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 z0))))
             then let log2z = Coq_Z.log2_up z0 in
                  let z1 = Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) log2z) z0 in
                  if Coq_Z.eqb z1 Z0
                  then show_lvl_binop RightAssoc (Level.Coq_level (Zpos (XO
                         (XI (XI (XI XH)))))) Decimal.show_lvl_Z show_lvl_id
                         (Zpos (XO XH)) ('^'::[]) (Decimal.show_lvl_Z log2z)
                  else show_lvl_binop FullyAssoc (Level.Coq_level (Zpos (XO
                         (XI (XO (XO (XI XH))))))) show_lvl_id show_lvl_id
                         (show_lvl_binop RightAssoc (Level.Coq_level (Zpos
                           (XO (XI (XI (XI XH)))))) Decimal.show_lvl_Z
                           show_lvl_id (Zpos (XO XH)) ('^'::[])
                           (Decimal.show_lvl_Z log2z))
                         (if neg then '+'::[] else '-'::[])
                         (show_lvl_Z_up_to' n' max_dec0 (negb neg) z1)
             else let log2z = Coq_Z.log2 z0 in
                  let z1 = Coq_Z.sub z0 (Coq_Z.pow (Zpos (XO XH)) log2z) in
                  if Coq_Z.eqb z1 Z0
                  then show_lvl_binop RightAssoc (Level.Coq_level (Zpos (XO
                         (XI (XI (XI XH)))))) Decimal.show_lvl_Z show_lvl_id
                         (Zpos (XO XH)) ('^'::[]) (Decimal.show_lvl_Z log2z)
                  else show_lvl_binop FullyAssoc (Level.Coq_level (Zpos (XO
                         (XI (XO (XO (XI XH))))))) show_lvl_id show_lvl_id
                         (show_lvl_binop RightAssoc (Level.Coq_level (Zpos
                           (XO (XI (XI (XI XH)))))) Decimal.show_lvl_Z
                           show_lvl_id (Zpos (XO XH)) ('^'::[])
                           (Decimal.show_lvl_Z log2z))
                         (if neg then '-'::[] else '+'::[])
                         (show_lvl_Z_up_to' n' max_dec0 neg z1))

  (** val show_lvl_Z_up_to : nat -> z -> z showLevel **)

  let show_lvl_Z_up_to max0 max_dec0 z0 =
    if Coq_Z.ltb z0 Z0
    then lvl_wrap_parens (Level.Coq_level (Zpos (XO (XI (XO (XO (XI XH)))))))
           (append ('-'::[])
             (show_lvl_Z_up_to' max0 max_dec0 false (Coq_Z.opp z0)
               (Level.Coq_level (Zpos (XO (XI (XO (XO (XI XH)))))))))
    else if Coq_Z.eqb z0 Z0
         then neg_wrap_parens ('0'::[])
         else show_lvl_Z_up_to' max0 max_dec0 false z0

  (** val show_lvl_Z : z showLevel **)

  let show_lvl_Z z0 =
    show_lvl_Z_up_to (S (Coq_Z.to_nat (Coq_Z.log2_up (Coq_Z.abs z0)))) (Zpos
      (XO (XO (XO (XO (XO XH)))))) z0

  (** val show_Z : z show **)

  let show_Z =
    show_of_ShowLevel show_lvl_Z
 end

type ('errT, 't) errorT =
| Success of 't
| Error of 'errT

(** val bind0 :
    ('a3, 'a1) errorT -> ('a1 -> ('a3, 'a2) errorT) -> ('a3, 'a2) errorT **)

let bind0 x k =
  match x with
  | Success v -> k v
  | Error msg -> Error msg

(** val map3 :
    ('a3 -> 'a4) -> ('a1 -> 'a2) -> ('a1, 'a3) errorT -> ('a2, 'a4) errorT **)

let map3 f fe = function
| Success v -> Success (f v)
| Error e -> Error (fe e)

(** val map_error : ('a1 -> 'a2) -> ('a1, 'a3) errorT -> ('a2, 'a3) errorT **)

let map_error fe =
  map3 (Obj.magic id) fe

(** val show_REG : rEG show **)

let show_REG = function
| Rax -> 'r'::('a'::('x'::[]))
| Rcx -> 'r'::('c'::('x'::[]))
| Rdx -> 'r'::('d'::('x'::[]))
| Rbx -> 'r'::('b'::('x'::[]))
| Rsp -> 'r'::('s'::('p'::[]))
| Rbp -> 'r'::('b'::('p'::[]))
| Rsi -> 'r'::('s'::('i'::[]))
| Rdi -> 'r'::('d'::('i'::[]))
| R8 -> 'r'::('8'::[])
| R9 -> 'r'::('9'::[])
| R10 -> 'r'::('1'::('0'::[]))
| R11 -> 'r'::('1'::('1'::[]))
| R12 -> 'r'::('1'::('2'::[]))
| R13 -> 'r'::('1'::('3'::[]))
| R14 -> 'r'::('1'::('4'::[]))
| R15 -> 'r'::('1'::('5'::[]))
| Eax -> 'e'::('a'::('x'::[]))
| Ecx -> 'e'::('c'::('x'::[]))
| Edx -> 'e'::('d'::('x'::[]))
| Ebx -> 'e'::('b'::('x'::[]))
| Esp -> 'e'::('s'::('p'::[]))
| Ebp -> 'e'::('b'::('p'::[]))
| Esi -> 'e'::('s'::('i'::[]))
| Edi -> 'e'::('d'::('i'::[]))
| R8d -> 'r'::('8'::('d'::[]))
| R9d -> 'r'::('9'::('d'::[]))
| R10d -> 'r'::('1'::('0'::('d'::[])))
| R11d -> 'r'::('1'::('1'::('d'::[])))
| R12d -> 'r'::('1'::('2'::('d'::[])))
| R13d -> 'r'::('1'::('3'::('d'::[])))
| R14d -> 'r'::('1'::('4'::('d'::[])))
| R15d -> 'r'::('1'::('5'::('d'::[])))
| Ax -> 'a'::('x'::[])
| Cx -> 'c'::('x'::[])
| Dx -> 'd'::('x'::[])
| Bx -> 'b'::('x'::[])
| Sp -> 's'::('p'::[])
| Bp -> 'b'::('p'::[])
| Si -> 's'::('i'::[])
| Di -> 'd'::('i'::[])
| R8w -> 'r'::('8'::('w'::[]))
| R9w -> 'r'::('9'::('w'::[]))
| R10w -> 'r'::('1'::('0'::('w'::[])))
| R11w -> 'r'::('1'::('1'::('w'::[])))
| R12w -> 'r'::('1'::('2'::('w'::[])))
| R13w -> 'r'::('1'::('3'::('w'::[])))
| R14w -> 'r'::('1'::('4'::('w'::[])))
| R15w -> 'r'::('1'::('5'::('w'::[])))
| Ah -> 'a'::('h'::[])
| Al -> 'a'::('l'::[])
| Ch -> 'c'::('h'::[])
| Cl -> 'c'::('l'::[])
| Dh -> 'd'::('h'::[])
| Dl -> 'd'::('l'::[])
| Bh -> 'b'::('h'::[])
| Bl -> 'b'::('l'::[])
| Spl -> 's'::('p'::('l'::[]))
| Bpl -> 'b'::('p'::('l'::[]))
| Sil -> 's'::('i'::('l'::[]))
| Dil -> 'd'::('i'::('l'::[]))
| R8b -> 'r'::('8'::('b'::[]))
| R9b -> 'r'::('9'::('b'::[]))
| R10b -> 'r'::('1'::('0'::('b'::[])))
| R11b -> 'r'::('1'::('1'::('b'::[])))
| R12b -> 'r'::('1'::('2'::('b'::[])))
| R13b -> 'r'::('1'::('3'::('b'::[])))
| R14b -> 'r'::('1'::('4'::('b'::[])))
| R15b -> 'r'::('1'::('5'::('b'::[])))

(** val show_lvl_REG : rEG showLevel **)

let show_lvl_REG t0 _ =
  show0 show_REG t0

(** val show_FLAG : fLAG show **)

let show_FLAG = function
| CF -> 'C'::('F'::[])
| PF -> 'P'::('F'::[])
| AF -> 'A'::('F'::[])
| ZF -> 'Z'::('F'::[])
| SF -> 'S'::('F'::[])
| OF -> 'O'::('F'::[])

(** val show_OpCode : opCode show **)

let show_OpCode = function
| Adc -> 'a'::('d'::('c'::[]))
| Adcx -> 'a'::('d'::('c'::('x'::[])))
| Add -> 'a'::('d'::('d'::[]))
| Adox -> 'a'::('d'::('o'::('x'::[])))
| And -> 'a'::('n'::('d'::[]))
| Bzhi -> 'b'::('z'::('h'::('i'::[])))
| Call -> 'c'::('a'::('l'::('l'::[])))
| Clc -> 'c'::('l'::('c'::[]))
| Cmovb -> 'c'::('m'::('o'::('v'::('b'::[]))))
| Cmovc -> 'c'::('m'::('o'::('v'::('c'::[]))))
| Cmovnz -> 'c'::('m'::('o'::('v'::('n'::('z'::[])))))
| Cmovo -> 'c'::('m'::('o'::('v'::('o'::[]))))
| Cmp -> 'c'::('m'::('p'::[]))
| Db0 -> 'd'::('b'::[])
| Dd0 -> 'd'::('d'::[])
| Dec -> 'd'::('e'::('c'::[]))
| Dq -> 'd'::('q'::[])
| Dw -> 'd'::('w'::[])
| Imul -> 'i'::('m'::('u'::('l'::[])))
| Inc -> 'i'::('n'::('c'::[]))
| Je -> 'j'::('e'::[])
| Jmp -> 'j'::('m'::('p'::[]))
| Lea -> 'l'::('e'::('a'::[]))
| Mov -> 'm'::('o'::('v'::[]))
| Movzx -> 'm'::('o'::('v'::('z'::('x'::[]))))
| Mul -> 'm'::('u'::('l'::[]))
| Mulx -> 'm'::('u'::('l'::('x'::[])))
| Or -> 'o'::('r'::[])
| Pop -> 'p'::('o'::('p'::[]))
| Push -> 'p'::('u'::('s'::('h'::[])))
| Rcr -> 'r'::('c'::('r'::[]))
| Ret -> 'r'::('e'::('t'::[]))
| Sar -> 's'::('a'::('r'::[]))
| Sbb -> 's'::('b'::('b'::[]))
| Setc -> 's'::('e'::('t'::('c'::[])))
| Seto -> 's'::('e'::('t'::('o'::[])))
| Shl -> 's'::('h'::('l'::[]))
| Shlx -> 's'::('h'::('l'::('x'::[])))
| Shr -> 's'::('h'::('r'::[]))
| Shrx -> 's'::('h'::('r'::('x'::[])))
| Shrd -> 's'::('h'::('r'::('d'::[])))
| Sub -> 's'::('u'::('b'::[]))
| Test -> 't'::('e'::('s'::('t'::[])))
| Xchg -> 'x'::('c'::('h'::('g'::[])))
| Xor -> 'x'::('o'::('r'::[]))

(** val show_OpPrefix : opPrefix show **)

let show_OpPrefix = function
| Rep -> 'r'::('e'::('p'::[]))
| Repz -> 'r'::('e'::('p'::('z'::[])))
| Repnz -> 'r'::('e'::('p'::('n'::('z'::[]))))

(** val parse_REG_list : (char list * rEG) list **)

let parse_REG_list =
  (('r'::('a'::('x'::[]))), Rax) :: ((('r'::('c'::('x'::[]))),
    Rcx) :: ((('r'::('d'::('x'::[]))), Rdx) :: ((('r'::('b'::('x'::[]))),
    Rbx) :: ((('r'::('s'::('p'::[]))), Rsp) :: ((('r'::('b'::('p'::[]))),
    Rbp) :: ((('r'::('s'::('i'::[]))), Rsi) :: ((('r'::('d'::('i'::[]))),
    Rdi) :: ((('r'::('8'::[])), R8) :: ((('r'::('9'::[])),
    R9) :: ((('r'::('1'::('0'::[]))), R10) :: ((('r'::('1'::('1'::[]))),
    R11) :: ((('r'::('1'::('2'::[]))), R12) :: ((('r'::('1'::('3'::[]))),
    R13) :: ((('r'::('1'::('4'::[]))), R14) :: ((('r'::('1'::('5'::[]))),
    R15) :: ((('e'::('a'::('x'::[]))), Eax) :: ((('e'::('c'::('x'::[]))),
    Ecx) :: ((('e'::('d'::('x'::[]))), Edx) :: ((('e'::('b'::('x'::[]))),
    Ebx) :: ((('e'::('s'::('p'::[]))), Esp) :: ((('e'::('b'::('p'::[]))),
    Ebp) :: ((('e'::('s'::('i'::[]))), Esi) :: ((('e'::('d'::('i'::[]))),
    Edi) :: ((('r'::('8'::('d'::[]))), R8d) :: ((('r'::('9'::('d'::[]))),
    R9d) :: ((('r'::('1'::('0'::('d'::[])))),
    R10d) :: ((('r'::('1'::('1'::('d'::[])))),
    R11d) :: ((('r'::('1'::('2'::('d'::[])))),
    R12d) :: ((('r'::('1'::('3'::('d'::[])))),
    R13d) :: ((('r'::('1'::('4'::('d'::[])))),
    R14d) :: ((('r'::('1'::('5'::('d'::[])))), R15d) :: ((('a'::('x'::[])),
    Ax) :: ((('c'::('x'::[])), Cx) :: ((('d'::('x'::[])),
    Dx) :: ((('b'::('x'::[])), Bx) :: ((('s'::('p'::[])),
    Sp) :: ((('b'::('p'::[])), Bp) :: ((('s'::('i'::[])),
    Si) :: ((('d'::('i'::[])), Di) :: ((('r'::('8'::('w'::[]))),
    R8w) :: ((('r'::('9'::('w'::[]))),
    R9w) :: ((('r'::('1'::('0'::('w'::[])))),
    R10w) :: ((('r'::('1'::('1'::('w'::[])))),
    R11w) :: ((('r'::('1'::('2'::('w'::[])))),
    R12w) :: ((('r'::('1'::('3'::('w'::[])))),
    R13w) :: ((('r'::('1'::('4'::('w'::[])))),
    R14w) :: ((('r'::('1'::('5'::('w'::[])))), R15w) :: ((('a'::('h'::[])),
    Ah) :: ((('a'::('l'::[])), Al) :: ((('c'::('h'::[])),
    Ch) :: ((('c'::('l'::[])), Cl) :: ((('d'::('h'::[])),
    Dh) :: ((('d'::('l'::[])), Dl) :: ((('b'::('h'::[])),
    Bh) :: ((('b'::('l'::[])), Bl) :: ((('s'::('p'::('l'::[]))),
    Spl) :: ((('b'::('p'::('l'::[]))), Bpl) :: ((('s'::('i'::('l'::[]))),
    Sil) :: ((('d'::('i'::('l'::[]))), Dil) :: ((('r'::('8'::('b'::[]))),
    R8b) :: ((('r'::('9'::('b'::[]))),
    R9b) :: ((('r'::('1'::('0'::('b'::[])))),
    R10b) :: ((('r'::('1'::('1'::('b'::[])))),
    R11b) :: ((('r'::('1'::('2'::('b'::[])))),
    R12b) :: ((('r'::('1'::('3'::('b'::[])))),
    R13b) :: ((('r'::('1'::('4'::('b'::[])))),
    R14b) :: ((('r'::('1'::('5'::('b'::[])))),
    R15b) :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val parse_REG : rEG parserAction **)

let parse_REG =
  parse_strs parse_REG_list

(** val parse_AccessSize_list : (char list * accessSize) list **)

let parse_AccessSize_list =
  (('b'::('y'::('t'::('e'::[])))), Byte) :: ((('w'::('o'::('r'::('d'::[])))),
    Word) :: ((('d'::('w'::('o'::('r'::('d'::[]))))),
    Dword) :: ((('q'::('w'::('o'::('r'::('d'::[]))))), Qword) :: [])))

(** val parse_AccessSize : accessSize parserAction **)

let parse_AccessSize =
  parse_seq_gen (fun l _ -> l)
    (parse_strs_case_insensitive parse_AccessSize_list)
    (parse_maybe (parse_str_case_insensitive (' '::('p'::('t'::('r'::[]))))))

(** val parse_label : char list parserAction **)

let parse_label =
  let parse_any_ascii = fun s0 ->
    parse_alt_list (map parse_ascii (list_ascii_of_string s0))
  in
  parse_map (fun pat ->
    let (char, ls) = pat in string_of_list_ascii (char :: ls))
    (parse_seq_gen (fun x x0 -> (x, x0))
      (parse_alt (parse_alpha_char true true)
        (parse_any_ascii ('.'::('_'::('?'::('$'::[]))))))
      (parse_star
        (parse_alt (parse_alpha_char true true)
          (parse_any_ascii
            ('0'::('1'::('2'::('3'::('4'::('5'::('6'::('7'::('8'::('9'::('_'::('$'::('#'::('@'::('~'::('.'::('?'::[])))))))))))))))))))))

(** val parse_MEM : mEM parserAction **)

let parse_MEM =
  parse_map (fun pat ->
    let (access_size0, y) = pat in
    let (y0, base_label) = y in
    let (y1, offset) = y0 in
    let (br, sr) = y1 in
    { mem_bits_access_size = access_size0; mem_base_reg = br; mem_scale_reg =
    sr; mem_base_label = base_label; mem_offset = offset })
    (parse_seq_gen (fun x x0 -> (x, x0))
      (parse_maybe (strip_whitespace_after parse_AccessSize))
      (parse_option_list_map (fun pat ->
        let (offset, vars0) = pat in
        Option.List.bind_list
          (map (fun pat0 ->
            let (y, vs) = pat0 in
            let (c0, y0) = y in
            let (v, e) = y0 in
            (match vs with
             | [] ->
               (match e with
                | Z0 -> None
                | Zpos p ->
                  (match p with
                   | XI _ -> None
                   | XO _ -> None
                   | XH -> Some (c0, v))
                | Zneg _ -> None)
             | _ :: _ -> None)) vars0) (fun vars1 ->
          let regs =
            Option.List.map (fun pat0 ->
              let (c0, v) = pat0 in
              (match v with
               | Inl v0 -> Some (c0, v0)
               | Inr _ -> None)) vars1
          in
          let labels =
            Option.List.map (fun pat0 ->
              let (c0, v) = pat0 in
              (match v with
               | Inl _ -> None
               | Inr v0 -> Some (c0, v0))) vars1
          in
          bind
            (match labels with
             | [] -> Some None
             | p :: l ->
               let (z0, lbl) = p in
               (match z0 with
                | Z0 -> None
                | Zpos p0 ->
                  (match p0 with
                   | XI _ -> None
                   | XO _ -> None
                   | XH ->
                     (match l with
                      | [] -> Some (Some lbl)
                      | _ :: _ -> None))
                | Zneg _ -> None)) (fun base_label ->
            let offset0 = if Coq_Z.eqb Z0 offset then None else Some offset in
            bind
              (match regs with
               | [] -> Some (None, None)
               | p :: l ->
                 let (s0, r2) = p in
                 (match s0 with
                  | Z0 ->
                    (match l with
                     | [] -> Some (None, (Some (s0, r2)))
                     | p0 :: l0 ->
                       let (z0, r1) = p0 in
                       (match z0 with
                        | Z0 -> None
                        | Zpos p1 ->
                          (match p1 with
                           | XI _ -> None
                           | XO _ -> None
                           | XH ->
                             (match l0 with
                              | [] -> Some ((Some r1), (Some (s0, r2)))
                              | _ :: _ -> None))
                        | Zneg _ -> None))
                  | Zpos p0 ->
                    (match p0 with
                     | XI _ ->
                       (match l with
                        | [] -> Some (None, (Some (s0, r2)))
                        | p2 :: l0 ->
                          let (z0, r1) = p2 in
                          (match z0 with
                           | Z0 -> None
                           | Zpos p3 ->
                             (match p3 with
                              | XI _ -> None
                              | XO _ -> None
                              | XH ->
                                (match l0 with
                                 | [] -> Some ((Some r1), (Some (s0, r2)))
                                 | _ :: _ -> None))
                           | Zneg _ -> None))
                     | XO _ ->
                       (match l with
                        | [] -> Some (None, (Some (s0, r2)))
                        | p2 :: l0 ->
                          let (z0, r1) = p2 in
                          (match z0 with
                           | Z0 -> None
                           | Zpos p3 ->
                             (match p3 with
                              | XI _ -> None
                              | XO _ -> None
                              | XH ->
                                (match l0 with
                                 | [] -> Some ((Some r1), (Some (s0, r2)))
                                 | _ :: _ -> None))
                           | Zneg _ -> None))
                     | XH ->
                       (match l with
                        | [] -> Some ((Some r2), None)
                        | p1 :: l0 ->
                          let (s1, r1) = p1 in
                          (match s1 with
                           | Z0 ->
                             (match l0 with
                              | [] -> Some ((Some r2), (Some (s1, r1)))
                              | _ :: _ -> None)
                           | Zpos p2 ->
                             (match p2 with
                              | XI _ ->
                                (match l0 with
                                 | [] -> Some ((Some r2), (Some (s1, r1)))
                                 | _ :: _ -> None)
                              | XO _ ->
                                (match l0 with
                                 | [] -> Some ((Some r2), (Some (s1, r1)))
                                 | _ :: _ -> None)
                              | XH ->
                                (match l0 with
                                 | [] -> Some ((Some r2), (Some (s1, r1)))
                                 | _ :: _ -> None))
                           | Zneg _ ->
                             (match l0 with
                              | [] -> Some ((Some r2), (Some (s1, r1)))
                              | _ :: _ -> None))))
                  | Zneg _ ->
                    (match l with
                     | [] -> Some (None, (Some (s0, r2)))
                     | p1 :: l0 ->
                       let (z0, r1) = p1 in
                       (match z0 with
                        | Z0 -> None
                        | Zpos p2 ->
                          (match p2 with
                           | XI _ -> None
                           | XO _ -> None
                           | XH ->
                             (match l0 with
                              | [] -> Some ((Some r1), (Some (s0, r2)))
                              | _ :: _ -> None))
                        | Zneg _ -> None)))) (fun base_scale_reg ->
              let (br, sr) = base_scale_reg in
              Some (((br, sr), offset0), base_label)))))
        (parse_seq_gen (fun _ r0 -> r0) (parse_str ('['::[]))
          (parse_seq_gen (fun l _ -> l)
            (parse_Z_poly_strict (sum_beq rEG_beq eqb0)
              (parse_or_else_gen (fun x -> x) parse_REG parse_label))
            (parse_str (']'::[]))))))

(** val parse_CONST : bool -> cONST parserAction **)

let parse_CONST = function
| true ->
  parse_seq_gen (fun _ r0 -> r0)
    (parse_str ('C'::('O'::('N'::('S'::('T'::(' '::[])))))))
    (parse_seq_gen (fun l _ -> l) parse_Z_arith_strict
      (parse_lookahead_not parse_one_whitespace))
| false ->
  parse_seq_gen (fun _ r0 -> r0) (parse_lookahead_not parse_one_whitespace)
    (parse_seq_gen (fun l _ -> l) parse_Z_arith_strict
      (parse_lookahead_not parse_one_whitespace))

(** val parse_JUMP_LABEL : jUMP_LABEL parserAction **)

let parse_JUMP_LABEL =
  parse_map (fun pat ->
    let (near, lbl) = pat in
    { jump_near = (match near with
                   | Some _ -> true
                   | None -> false); label_name = lbl })
    (parse_seq_gen (fun x x0 -> (x, x0))
      (parse_maybe
        (strip_whitespace_after
          (parse_str ('N'::('E'::('A'::('R'::(' '::[])))))))) parse_label)

(** val parse_ARG : bool -> aRG parserAction **)

let parse_ARG const_keyword =
  parse_or_else
    (parse_alt_list
      ((parse_map (fun x -> Reg x) parse_REG) :: ((parse_map (fun x -> Mem x)
                                                    parse_MEM) :: ((parse_map
                                                                    (fun x ->
                                                                    Const x)
                                                                    (parse_CONST
                                                                    const_keyword)) :: []))))
    (parse_map (fun x -> Label x) parse_JUMP_LABEL)

(** val parse_OpCode_list : (char list * opCode) list **)

let parse_OpCode_list =
  (('a'::('d'::('c'::[]))), Adc) :: ((('a'::('d'::('c'::('x'::[])))),
    Adcx) :: ((('a'::('d'::('d'::[]))),
    Add) :: ((('a'::('d'::('o'::('x'::[])))),
    Adox) :: ((('a'::('n'::('d'::[]))),
    And) :: ((('b'::('z'::('h'::('i'::[])))),
    Bzhi) :: ((('c'::('a'::('l'::('l'::[])))),
    Call) :: ((('c'::('l'::('c'::[]))),
    Clc) :: ((('c'::('m'::('o'::('v'::('b'::[]))))),
    Cmovb) :: ((('c'::('m'::('o'::('v'::('c'::[]))))),
    Cmovc) :: ((('c'::('m'::('o'::('v'::('n'::('z'::[])))))),
    Cmovnz) :: ((('c'::('m'::('o'::('v'::('o'::[]))))),
    Cmovo) :: ((('c'::('m'::('p'::[]))), Cmp) :: ((('d'::('b'::[])),
    Db0) :: ((('d'::('d'::[])), Dd0) :: ((('d'::('e'::('c'::[]))),
    Dec) :: ((('d'::('q'::[])), Dq) :: ((('d'::('w'::[])),
    Dw) :: ((('i'::('m'::('u'::('l'::[])))),
    Imul) :: ((('i'::('n'::('c'::[]))), Inc) :: ((('j'::('e'::[])),
    Je) :: ((('j'::('m'::('p'::[]))), Jmp) :: ((('l'::('e'::('a'::[]))),
    Lea) :: ((('m'::('o'::('v'::[]))),
    Mov) :: ((('m'::('o'::('v'::('z'::('x'::[]))))),
    Movzx) :: ((('m'::('u'::('l'::[]))),
    Mul) :: ((('m'::('u'::('l'::('x'::[])))), Mulx) :: ((('o'::('r'::[])),
    Or) :: ((('p'::('o'::('p'::[]))),
    Pop) :: ((('p'::('u'::('s'::('h'::[])))),
    Push) :: ((('r'::('c'::('r'::[]))), Rcr) :: ((('r'::('e'::('t'::[]))),
    Ret) :: ((('s'::('a'::('r'::[]))), Sar) :: ((('s'::('b'::('b'::[]))),
    Sbb) :: ((('s'::('e'::('t'::('c'::[])))),
    Setc) :: ((('s'::('e'::('t'::('o'::[])))),
    Seto) :: ((('s'::('h'::('l'::[]))),
    Shl) :: ((('s'::('h'::('l'::('x'::[])))),
    Shlx) :: ((('s'::('h'::('r'::[]))),
    Shr) :: ((('s'::('h'::('r'::('x'::[])))),
    Shrx) :: ((('s'::('h'::('r'::('d'::[])))),
    Shrd) :: ((('s'::('u'::('b'::[]))),
    Sub) :: ((('t'::('e'::('s'::('t'::[])))),
    Test) :: ((('x'::('c'::('h'::('g'::[])))),
    Xchg) :: ((('x'::('o'::('r'::[]))),
    Xor) :: []))))))))))))))))))))))))))))))))))))))))))))

(** val parse_OpCode : opCode parserAction **)

let parse_OpCode =
  parse_strs_case_insensitive parse_OpCode_list

(** val parse_OpPrefix_list : (char list * opPrefix) list **)

let parse_OpPrefix_list =
  (('r'::('e'::('p'::[]))), Rep) :: ((('r'::('e'::('p'::('z'::[])))),
    Repz) :: ((('r'::('e'::('p'::('n'::('z'::[]))))), Repnz) :: []))

(** val parse_OpPrefix : opPrefix parserAction **)

let parse_OpPrefix =
  parse_strs parse_OpPrefix_list

(** val parse_RawLine : rawLine parserAction **)

let parse_RawLine s0 =
  let s1 = trim s0 in
  let (mnemonic, args0) =
    take_while_drop_while (fun ch -> negb (is_whitespace ch)) s1
  in
  let args1 = trim args0 in
  if eqb0 (to_upper0 mnemonic)
       ('S'::('E'::('C'::('T'::('I'::('O'::('N'::[])))))))
  then ((SECTION args1), []) :: []
  else if eqb0 (to_upper0 mnemonic)
            ('G'::('L'::('O'::('B'::('A'::('L'::[]))))))
       then ((GLOBAL args1), []) :: []
       else if eqb0 (to_upper0 mnemonic) ('A'::('L'::('I'::('G'::('N'::[])))))
            then ((ALIGN args1), []) :: []
            else if (&&)
                      (eqb0 (to_upper0 mnemonic)
                        ('D'::('E'::('F'::('A'::('U'::('L'::('T'::[]))))))))
                      (eqb0 (to_upper0 args1) ('R'::('E'::('L'::[]))))
                 then (DEFAULT_REL, []) :: []
                 else if endswith (':'::[]) s1
                      then ((LABEL (substring O (pred (length0 s1)) s1)),
                             []) :: []
                      else if eqb0 s1 []
                           then (EMPTY, []) :: []
                           else let parsed_prefix =
                                  parse_seq_gen (fun l _ -> l) parse_OpPrefix
                                    parse_empty mnemonic
                                in
                                flat_map (fun pat ->
                                  let (y, args2) = pat in
                                  let (parsed_prefix0, mnemonic0) = y in
                                  let parsed_mnemonic =
                                    parse_seq_gen (fun l _ -> l) parse_OpCode
                                      parse_empty mnemonic0
                                  in
                                  let parsed_args =
                                    parse_seq_gen (fun l _ -> l)
                                      (parse_list_gen [] (','::[]) []
                                        (parse_ARG false)) parse_empty args2
                                  in
                                  flat_map (fun pat0 ->
                                    let (opc, _) = pat0 in
                                    map (fun pat1 ->
                                      let (argsv, _) = pat1 in
                                      ((INSTR { prefix0 = parsed_prefix0;
                                      op = opc; args = argsv }), []))
                                      parsed_args) parsed_mnemonic)
                                  (match parsed_prefix with
                                   | [] -> ((None, mnemonic), args1) :: []
                                   | _ :: _ ->
                                     map (fun pat ->
                                       let (parsed_prefix0, _) = pat in
                                       let (mnemonic0, args2) =
                                         take_while_drop_while (fun ch ->
                                           negb (is_whitespace ch)) args1
                                       in
                                       let args3 = trim args2 in
                                       (((Some parsed_prefix0), mnemonic0),
                                       args3)) parsed_prefix)

(** val parse_Line : n -> line parserAction **)

let parse_Line line_num s0 =
  let (indentv, rest_linev) = take_while_drop_while is_whitespace s0 in
  let (precommentv, commentv) =
    match split (';'::[]) rest_linev with
    | [] -> ([], None)
    | precommentv :: commentv ->
      (match commentv with
       | [] -> ((rtrim precommentv), None)
       | _ :: _ -> (precommentv, (Some (concat0 (';'::[]) commentv))))
  in
  let (rev_trailing_whitespacev, rev_rawlinev) =
    take_while_drop_while is_whitespace (rev2 precommentv)
  in
  let rawlinev = rev2 rev_rawlinev in
  let trailing_whitespacev = rev2 rev_trailing_whitespacev in
  map (fun pat ->
    let (r0, rem0) = pat in
    ({ indent = indentv; rawline = r0; pre_comment_whitespace =
    trailing_whitespacev; comment = commentv; line_number = line_num }, rem0))
    (parse_RawLine rawlinev)

(** val parse_Lines' :
    char list list -> n -> (char list list, lines) errorT **)

let rec parse_Lines' l line_num =
  match l with
  | [] -> Success []
  | l0 :: ls ->
    (match finalize (parse_Line line_num) l0 with
     | Some l1 ->
       (match parse_Lines' ls (Coq_N.add line_num (Npos XH)) with
        | Success ls0 -> Success (l1 :: ls0)
        | Error ls0 -> Error ls0)
     | None ->
       (match parse_Lines' ls (Coq_N.add line_num (Npos XH)) with
        | Success _ ->
          Error
            ((append ('L'::('i'::('n'::('e'::(' '::[])))))
               (append (show0 Decimal.show_N line_num)
                 (append (':'::(' '::[])) l0))) :: [])
        | Error ls0 ->
          Error
            ((append ('L'::('i'::('n'::('e'::(' '::[])))))
               (append (show0 Decimal.show_N line_num)
                 (append (':'::(' '::[])) l0))) :: ls0)))

(** val parse_Lines : char list list -> (char list list, lines) errorT **)

let parse_Lines l =
  parse_Lines' (split_newlines l) (Npos XH)

(** val show_lvl_MEM : mEM showLevel **)

let show_lvl_MEM m4 =
  (match m4.mem_bits_access_size with
   | Some n3 ->
     show_lvl_app show_lvl_const show_lvl_const (fun pat ->
       let () = pat in
       if Coq_N.eqb (bits_of_AccessSize n3) (Npos (XO (XO (XO XH))))
       then 'b'::('y'::('t'::('e'::[])))
       else if Coq_N.eqb (bits_of_AccessSize n3) (Npos (XO (XO (XO (XO (XO
                 (XO XH)))))))
            then 'Q'::('W'::('O'::('R'::('D'::(' '::('P'::('T'::('R'::[]))))))))
            else 'B'::('A'::('D'::(' '::('S'::('I'::('Z'::('E'::[]))))))))
   | None -> show_lvl show_lvl_const) (fun pat ->
    let () = pat in
    let reg_part =
      match m4.mem_base_reg with
      | Some br ->
        (match m4.mem_scale_reg with
         | Some p ->
           let (z0, sr) = p in
           append (show_REG br)
             (append (' '::('+'::(' '::[])))
               (append (Decimal.show_Z z0)
                 (append (' '::('*'::(' '::[]))) (show_REG sr))))
         | None -> show_REG br)
      | None ->
        (match m4.mem_scale_reg with
         | Some p ->
           let (z0, sr) = p in
           append (Decimal.show_Z z0)
             (append (' '::('*'::(' '::[]))) (show_REG sr))
         | None -> [])
    in
    let offset_part =
      match m4.mem_offset with
      | Some offset ->
        append
          (if Coq_Z.ltb offset Z0
           then ' '::('-'::(' '::[]))
           else ' '::('+'::(' '::[])))
          (let offset0 = Coq_Z.abs offset in
           if Coq_Z.eqb (Coq_Z.modulo offset0 (Zpos (XO (XO (XO XH))))) Z0
           then append ('0'::('x'::('0'::('8'::(' '::('*'::(' '::[])))))))
                  (Decimal.show_Z
                    (Coq_Z.div offset0 (Zpos (XO (XO (XO XH))))))
           else Hex.show_Z offset0)
      | None -> []
    in
    append ('['::[])
      (append
        (match m4.mem_base_label with
         | Some l ->
           append ('('::('('::[]))
             (append l (append offset_part (')'::(')'::[]))))
         | None -> append reg_part offset_part) (']'::[])))

(** val show_lvl_JUMP_LABEL : jUMP_LABEL showLevel **)

let show_lvl_JUMP_LABEL l _ =
  append (if l.jump_near then 'N'::('E'::('A'::('R'::(' '::[])))) else [])
    l.label_name

(** val show_JUMP_LABEL : jUMP_LABEL show **)

let show_JUMP_LABEL =
  show_of_ShowLevel show_lvl_JUMP_LABEL

(** val show_lvl_ARG : aRG showLevel **)

let show_lvl_ARG = function
| Reg r0 -> show_lvl show_lvl_REG r0
| Mem m4 -> show_lvl show_lvl_MEM m4
| Const c0 -> show_lvl Decimal.show_lvl_Z c0
| Label l -> show_lvl show_lvl_JUMP_LABEL l

(** val show_ARG : aRG show **)

let show_ARG =
  show_of_ShowLevel show_lvl_ARG

(** val show_NormalInstruction : normalInstruction show **)

let show_NormalInstruction i =
  append
    (match i.prefix0 with
     | Some prefix1 -> append (show0 show_OpPrefix prefix1) (' '::[])
     | None -> [])
    (append (show0 show_OpCode i.op)
      (match i.args with
       | [] -> []
       | _ :: _ ->
         append (' '::[])
           (concat0 (','::(' '::[])) (map (show0 show_ARG) i.args))))

(** val show_RawLine : rawLine show **)

let show_RawLine = function
| SECTION name0 ->
  append ('S'::('E'::('C'::('T'::('I'::('O'::('N'::(' '::[])))))))) name0
| GLOBAL name0 ->
  append ('G'::('L'::('O'::('B'::('A'::('L'::(' '::[]))))))) name0
| LABEL name0 -> append name0 (':'::[])
| ALIGN args0 -> append ('A'::('L'::('I'::('G'::('N'::(' '::[])))))) args0
| DEFAULT_REL ->
  'D'::('E'::('F'::('A'::('U'::('L'::('T'::(' '::('R'::('E'::('L'::[]))))))))))
| EMPTY -> []
| INSTR instr -> show0 show_NormalInstruction instr

(** val show_Line : line show **)

let show_Line l =
  append l.indent
    (append (show0 show_RawLine l.rawline)
      (append l.pre_comment_whitespace
        (match l.comment with
         | Some c0 -> append (';'::[]) c0
         | None -> [])))

(** val show_Line_with_line_number : line show **)

let show_Line_with_line_number l =
  append (show0 show_Line l)
    (append (';'::(' '::('('::('l'::('i'::('n'::('e'::(' '::[]))))))))
      (append (show0 Decimal.show_N l.line_number) (')'::[])))

(** val show_lines_Lines : lines showLines **)

let show_lines_Lines ls =
  map (show0 show_Line) ls

type parseError =
  char list list
  (* singleton inductive, whose constructor was Parse_error *)

type parseValidatedError =
| Initial_parse_error of parseError
| Reparse_error of char list list * parseError
| Lengths_not_equal of lines * lines
| Lines_not_equal of (line * line) list
| Duplicate_labels of (char list * nat) list

(** val show_lines_ParseError : parseError showLines **)

let show_lines_ParseError err0 =
  err0

(** val show_lines_ParseValidatedError : parseValidatedError showLines **)

let show_lines_ParseValidatedError = function
| Initial_parse_error err1 ->
  (match show_lines show_lines_ParseError err1 with
   | [] ->
     ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::[])))))))))))))))))))))))))))))))))))) :: []
   | err2 :: l ->
     (match l with
      | [] ->
        (append
          ('E'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::(' '::[]))))))))))))))))))))))))))))))
          err2) :: []
      | s0 :: l0 ->
        ('E'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::[]))))))))))))))))))))))))))))) :: (err2 :: (s0 :: l0))))
| Reparse_error (new_asm, err1) ->
  (match show_lines show_lines_ParseError err1 with
   | [] ->
     app
       (('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('r'::('e'::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::[]))))))))))))))))))))))))))))))))))))))) :: [])
       new_asm
   | err2 :: l ->
     (match l with
      | [] ->
        app
          ((append
             ('E'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('r'::('e'::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::(' '::[]))))))))))))))))))))))))))))))))
             err2) :: (('N'::('e'::('w'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('p'::('a'::('r'::('s'::('e'::('d'::(':'::[])))))))))))))))))))))))))) :: []))
          new_asm
      | s0 :: l0 ->
        app
          (('E'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::[]))))))))))))))))))))))))))))) :: [])
          (app (err2 :: (s0 :: l0))
            (app ([] :: [])
              (app
                (('N'::('e'::('w'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('p'::('a'::('r'::('s'::('e'::('d'::(':'::[])))))))))))))))))))))))))) :: [])
                new_asm)))))
| Lengths_not_equal (old_asm, new_asm) ->
  app
    (('R'::('e'::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::[]))))))))))))))))))))))) :: [])
    (app (show_lines show_lines_Lines old_asm)
      (app ([] :: [])
        (app
          (('Y'::('i'::('e'::('l'::('d'::('e'::('d'::(' '::('n'::('o'::('n'::('-'::('e'::('q'::('u'::('a'::('l'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::[]))))))))))))))))))))))))))) :: [])
          (app (show_lines show_lines_Lines new_asm)
            (app ([] :: [])
              ((append
                 ('T'::('h'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('o'::('f'::(' '::('l'::('i'::('n'::('e'::('s'::(' '::('w'::('a'::('s'::(' '::('n'::('o'::('t'::(' '::('e'::('q'::('u'::('a'::('l'::(' '::('('::[])))))))))))))))))))))))))))))))))))
                 (append (show0 Decimal.show_nat (length old_asm))
                   (append (' '::('\226'::('\137'::('\160'::(' '::[])))))
                     (append (show0 Decimal.show_nat (length new_asm))
                       (')'::[]))))) :: []))))))
| Lines_not_equal mismatched_lines ->
  app
    (('W'::('h'::('e'::('n'::(' '::('r'::('e'::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('f'::('o'::('r'::(' '::('v'::('a'::('l'::('i'::('d'::('a'::('t'::('i'::('o'::('n'::(','::(' '::('t'::('h'::('e'::(' '::('f'::('o'::('l'::('l'::('o'::('w'::('i'::('n'::('g'::(' '::('l'::('i'::('n'::('e'::('s'::(' '::('w'::('e'::('r'::('e'::(' '::('n'::('o'::('t'::(' '::('e'::('q'::('u'::('a'::('l'::(':'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
    (flat_map (fun pat ->
      let (old, new0) = pat in
      (append ('-'::(' '::[])) (show0 show_Line old)) :: ((append
                                                            ('+'::(' '::[]))
                                                            (show0 show_Line
                                                              new0)) :: ([] :: [])))
      mismatched_lines)
| Duplicate_labels name_counts ->
  (match name_counts with
   | [] ->
     ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('D'::('u'::('p'::('l'::('i'::('c'::('a'::('t'::('e'::('_'::('l'::('a'::('b'::('e'::('l'::('s'::(' '::('['::(']'::[]))))))))))))))))))))))))))))))))))) :: []
   | p :: l ->
     let (name0, count) = p in
     (match l with
      | [] ->
        (append
          ('L'::('a'::('b'::('e'::('l'::(' '::('o'::('c'::('c'::('u'::('r'::('s'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))
          (append name0
            (append
              (' '::('o'::('c'::('c'::('u'::('r'::('s'::(' '::[]))))))))
              (append (show0 Decimal.show_nat count)
                (' '::('t'::('i'::('m'::('e'::('s'::[])))))))))) :: []
      | _ :: _ ->
        app
          (('L'::('a'::('b'::('e'::('l'::('s'::(' '::('o'::('c'::('c'::('u'::('r'::('s'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::(':'::[]))))))))))))))))))))))))))))) :: [])
          (map (fun pat ->
            let (name1, count0) = pat in
            append name1
              (append
                (' '::('o'::('c'::('c'::('u'::('r'::('s'::(' '::[]))))))))
                (append (show0 Decimal.show_nat count0)
                  (' '::('t'::('i'::('m'::('e'::('s'::[]))))))))) name_counts)))

(** val parse_validated :
    char list list -> (parseValidatedError, lines) errorT **)

let parse_validated v =
  match parse_Lines v with
  | Success v0 ->
    let new_asm = show_lines show_lines_Lines v0 in
    (match parse_Lines new_asm with
     | Success v' ->
       let labels =
         Option.List.map (fun l ->
           match l.rawline with
           | SECTION _ -> None
           | GLOBAL _ -> None
           | LABEL n3 -> Some n3
           | ALIGN _ -> None
           | DEFAULT_REL -> None
           | EMPTY -> None
           | INSTR _ -> None) v'
       in
       let counts = map (fun l -> (l, (count_occ string_dec labels l))) labels
       in
       let big_counts =
         filter (fun pat -> let (_, n3) = pat in Nat.ltb (S O) n3) counts
       in
       (match big_counts with
        | [] ->
          if Nat.eqb (length v0) (length v')
          then (match filter (fun pat ->
                        let (x, y) = pat in negb (line_beq x y))
                        (combine v0 v') with
                | [] -> Success v0
                | p :: l -> Error (Lines_not_equal (p :: l)))
          else Error (Lengths_not_equal (v0, v'))
        | _ :: _ -> Error (Duplicate_labels big_counts))
     | Error e -> Error (Reparse_error (new_asm, e)))
  | Error e -> Error (Initial_parse_error e)

(** val find_globals : lines -> char list list **)

let find_globals ls =
  Option.List.map (fun l ->
    match l.rawline with
    | SECTION _ -> None
    | GLOBAL name0 -> Some name0
    | LABEL _ -> None
    | ALIGN _ -> None
    | DEFAULT_REL -> None
    | EMPTY -> None
    | INSTR _ -> None) ls

(** val split_code_to_functions' :
    char list list -> lines -> lines * (char list * lines) list **)

let rec split_code_to_functions' globals = function
| [] -> ([], [])
| l :: ls0 ->
  let (prefix1, rest) = split_code_to_functions' globals ls0 in
  let default0 = ((l :: prefix1), rest) in
  (match l.rawline with
   | SECTION _ -> default0
   | GLOBAL _ -> default0
   | LABEL name0 ->
     if existsb (fun n3 -> eqb0 name0 n3) globals
     then ([], ((name0, (l :: prefix1)) :: rest))
     else default0
   | ALIGN _ -> default0
   | DEFAULT_REL -> default0
   | EMPTY -> default0
   | INSTR _ -> default0)

(** val split_code_to_functions :
    lines -> lines * (char list * lines) list **)

let split_code_to_functions ls =
  let globals = find_globals ls in split_code_to_functions' globals ls

type 'x compare2 =
| LT
| EQ
| GT

module type Coq_OrderedType =
 sig
  type t

  val compare : t -> t -> t compare2

  val eq_dec : t -> t -> bool
 end

module Coq_OrderedTypeFacts =
 functor (O:Coq_OrderedType) ->
 struct
  module TO =
   struct
    type t = O.t
   end

  module IsTO =
   struct
   end

  module OrderTac = MakeOrderTac(TO)(IsTO)

  (** val eq_dec : O.t -> O.t -> bool **)

  let eq_dec =
    O.eq_dec

  (** val lt_dec : O.t -> O.t -> bool **)

  let lt_dec x y =
    match O.compare x y with
    | LT -> true
    | EQ -> false
    | GT -> false

  (** val eqb : O.t -> O.t -> bool **)

  let eqb x y =
    if eq_dec x y then true else false
 end

module KeyOrderedType =
 functor (O:Coq_OrderedType) ->
 struct
  module MO = Coq_OrderedTypeFacts(O)
 end

module String_as_OT =
 struct
  type t = char list

  (** val cmp : char list -> char list -> comparison **)

  let cmp =
    compare1

  (** val compare : char list -> char list -> char list compare2 **)

  let compare a b =
    (match cmp a b with
     | Eq -> (fun _ -> EQ)
     | Lt -> (fun _ -> LT)
     | Gt -> (fun _ -> GT)) __

  (** val eq_dec : char list -> char list -> bool **)

  let eq_dec =
    string_dec
 end

(** val append1 : positive -> positive -> positive **)

let rec append1 i j =
  match i with
  | XI ii -> XI (append1 ii j)
  | XO ii -> XO (append1 ii j)
  | XH -> j

module PositiveMap =
 struct
  type key = positive

  type 'a tree =
  | Leaf
  | Node of 'a tree * 'a option * 'a tree

  type 'a t = 'a tree

  (** val empty : 'a1 t **)

  let empty =
    Leaf

  (** val find : key -> 'a1 t -> 'a1 option **)

  let find i =
    let rec find0 i0 = function
    | Leaf -> None
    | Node (l, o, r0) ->
      (match i0 with
       | XI ii -> find0 ii r0
       | XO ii -> find0 ii l
       | XH -> o)
    in find0 i

  (** val mem : key -> 'a1 t -> bool **)

  let mem i =
    let rec mem0 i0 = function
    | Leaf -> false
    | Node (l, o, r0) ->
      (match i0 with
       | XI ii -> mem0 ii r0
       | XO ii -> mem0 ii l
       | XH -> (match o with
                | Some _ -> true
                | None -> false))
    in mem0 i

  (** val add : key -> 'a1 -> 'a1 t -> 'a1 t **)

  let add i =
    let rec add0 i0 v = function
    | Leaf ->
      (match i0 with
       | XI ii -> Node (Leaf, None, (add0 ii v Leaf))
       | XO ii -> Node ((add0 ii v Leaf), None, Leaf)
       | XH -> Node (Leaf, (Some v), Leaf))
    | Node (l, o, r0) ->
      (match i0 with
       | XI ii -> Node (l, o, (add0 ii v r0))
       | XO ii -> Node ((add0 ii v l), o, r0)
       | XH -> Node (l, (Some v), r0))
    in add0 i

  (** val xelements : 'a1 t -> key -> (key * 'a1) list **)

  let xelements m4 =
    let rec xelements0 m5 i =
      match m5 with
      | Leaf -> []
      | Node (l, o, r0) ->
        (match o with
         | Some x ->
           app (xelements0 l (append1 i (XO XH))) ((i,
             x) :: (xelements0 r0 (append1 i (XI XH))))
         | None ->
           app (xelements0 l (append1 i (XO XH)))
             (xelements0 r0 (append1 i (XI XH))))
    in xelements0 m4

  (** val elements : 'a1 t -> (key * 'a1) list **)

  let elements m4 =
    xelements m4 XH
 end

type zrange = { lower : z; upper : z }

(** val zrange_rect_nodep : (z -> z -> 'a1) -> zrange -> 'a1 **)

let zrange_rect_nodep f z0 =
  let { lower = lower0; upper = upper0 } = z0 in f lower0 upper0

(** val is_bounded_by_bool : z -> zrange -> bool **)

let is_bounded_by_bool v x =
  (&&) (Coq_Z.leb x.lower v) (Coq_Z.leb v x.upper)

(** val is_tighter_than_bool : zrange -> zrange -> bool **)

let is_tighter_than_bool x y =
  (&&) (Coq_Z.leb y.lower x.lower) (Coq_Z.leb x.upper y.upper)

(** val zrange_beq : zrange -> zrange -> bool **)

let zrange_beq x y =
  (&&) (Coq_Z.eqb x.lower y.lower) (Coq_Z.eqb x.upper y.upper)

(** val reflect_zrange_eq : zrange -> zrange -> reflect **)

let reflect_zrange_eq =
  reflect_of_beq zrange_beq

(** val subscript_map : (char * char list) list **)

let subscript_map =
  ('(', ('\226'::('\130'::('\141'::[])))) :: ((')',
    ('\226'::('\130'::('\142'::[])))) :: (('+',
    ('\226'::('\130'::('\138'::[])))) :: (('-',
    ('\226'::('\130'::('\139'::[])))) :: (('0',
    ('\226'::('\130'::('\128'::[])))) :: (('1',
    ('\226'::('\130'::('\129'::[])))) :: (('2',
    ('\226'::('\130'::('\130'::[])))) :: (('3',
    ('\226'::('\130'::('\131'::[])))) :: (('4',
    ('\226'::('\130'::('\132'::[])))) :: (('5',
    ('\226'::('\130'::('\133'::[])))) :: (('6',
    ('\226'::('\130'::('\134'::[])))) :: (('7',
    ('\226'::('\130'::('\135'::[])))) :: (('8',
    ('\226'::('\130'::('\136'::[])))) :: (('9',
    ('\226'::('\130'::('\137'::[])))) :: (('=',
    ('\226'::('\130'::('\140'::[])))) :: (('a',
    ('\226'::('\130'::('\144'::[])))) :: (('e',
    ('\226'::('\130'::('\145'::[])))) :: (('h',
    ('\226'::('\130'::('\149'::[])))) :: (('i',
    ('\225'::('\181'::('\162'::[])))) :: (('j',
    ('\226'::('\177'::('\188'::[])))) :: (('k',
    ('\226'::('\130'::('\150'::[])))) :: (('l',
    ('\226'::('\130'::('\151'::[])))) :: (('m',
    ('\226'::('\130'::('\152'::[])))) :: (('n',
    ('\226'::('\130'::('\153'::[])))) :: (('o',
    ('\226'::('\130'::('\146'::[])))) :: (('p',
    ('\226'::('\130'::('\154'::[])))) :: (('r',
    ('\225'::('\181'::('\163'::[])))) :: (('s',
    ('\226'::('\130'::('\155'::[])))) :: (('t',
    ('\226'::('\130'::('\156'::[])))) :: (('u',
    ('\225'::('\181'::('\164'::[])))) :: (('v',
    ('\225'::('\181'::('\165'::[])))) :: (('x',
    ('\226'::('\130'::('\147'::[])))) :: (('y',
    ('\225'::('\181'::('\167'::[])))) :: []))))))))))))))))))))))))))))))))

module Ascii =
 struct
  (** val to_subscript_opt : char -> char list option **)

  let to_subscript_opt c0 =
    option_map snd
      (find (fun pat -> let (ch, _) = pat in (=) c0 ch) subscript_map)

  (** val to_subscript : char -> char list **)

  let to_subscript c0 =
    match to_subscript_opt c0 with
    | Some s0 -> s0
    | None -> c0::[]
 end

module WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING =
 struct
  module String =
   struct
    (** val to_subscript : char list -> char list **)

    let to_subscript s0 =
      string_of_list_ascii
        (flat_map (fun a -> list_ascii_of_string (Ascii.to_subscript a))
          (list_ascii_of_string s0))
   end
 end

module N_as_OT = Coq_N

module PositiveOrderedTypeBits =
 struct
  type t = positive

  (** val eqb : positive -> positive -> bool **)

  let eqb =
    Coq_Pos.eqb

  (** val eq_dec : positive -> positive -> bool **)

  let eq_dec x y =
    let b = Coq_Pos.eqb x y in
    (if b then (fun _ -> true) else (fun _ -> false)) __

  (** val compare : positive -> positive -> comparison **)

  let rec compare x y =
    match x with
    | XI x0 -> (match y with
                | XI y0 -> compare x0 y0
                | XO _ -> Gt
                | XH -> Gt)
    | XO x0 -> (match y with
                | XI _ -> Lt
                | XO y0 -> compare x0 y0
                | XH -> Lt)
    | XH -> (match y with
             | XI _ -> Lt
             | XO _ -> Gt
             | XH -> Eq)
 end

module Ascii_as_OT =
 struct
  (** val compare : char -> char -> comparison **)

  let compare a b =
    N_as_OT.compare (n_of_ascii a) (n_of_ascii b)
 end

module Coq_String_as_OT =
 struct
  type t = char list

  (** val eqb : char list -> char list -> bool **)

  let eqb =
    eqb0

  (** val eq_dec : char list -> char list -> bool **)

  let eq_dec x y =
    let b = eqb0 x y in (if b then (fun _ -> true) else (fun _ -> false)) __

  (** val compare : char list -> char list -> comparison **)

  let rec compare a b =
    match a with
    | [] -> (match b with
             | [] -> Eq
             | _::_ -> Lt)
    | a_head::a_tail ->
      (match b with
       | [] -> Gt
       | b_head::b_tail ->
         (match Ascii_as_OT.compare a_head b_head with
          | Eq -> compare a_tail b_tail
          | Lt -> Lt
          | Gt -> Gt))
 end

module SumOrderedType =
 functor (E1:OrderedType) ->
 functor (E2:OrderedType) ->
 struct
  type t = (E1.t, E2.t) sum

  (** val compare : (E1.t, E2.t) sum -> (E1.t, E2.t) sum -> comparison **)

  let compare =
    Sum.compare E1.compare E2.compare

  (** val eq_dec : (E1.t, E2.t) sum -> (E1.t, E2.t) sum -> bool **)

  let eq_dec x y =
    dec_sumwise E1.eq_dec E2.eq_dec x y
 end

module Coq0_List =
 struct
  (** val foldmap :
      ('a1 -> 'a3 -> 'a2 * 'a3) -> 'a1 list -> 'a3 -> 'a2 list * 'a3 **)

  let foldmap f =
    let rec foldmap0 l s0 =
      match l with
      | [] -> ([], s0)
      | a :: l0 ->
        let bs_s = foldmap0 l0 s0 in
        let b_s = f a (snd bs_s) in (((fst b_s) :: (fst bs_s)), (snd b_s))
    in foldmap0
 end

module Coq1_List =
 struct
  (** val indexof : ('a1 -> bool) -> 'a1 list -> nat option **)

  let indexof f =
    let rec indexof0 = function
    | [] -> None
    | a :: l0 ->
      if f a then Some O else option_map (fun x -> S x) (indexof0 l0)
    in indexof0
 end

module Sort =
 functor (X:TotalLeBool') ->
 struct
  (** val merge : X.t list -> X.t list -> X.t list **)

  let rec merge l1 l2 =
    let rec merge_aux l3 =
      match l1 with
      | [] -> l3
      | a1 :: l1' ->
        (match l3 with
         | [] -> l1
         | a2 :: l2' ->
           if X.leb a1 a2 then a1 :: (merge l1' l3) else a2 :: (merge_aux l2'))
    in merge_aux l2

  (** val merge_list_to_stack :
      X.t list option list -> X.t list -> X.t list option list **)

  let rec merge_list_to_stack stack l =
    match stack with
    | [] -> (Some l) :: []
    | y :: stack' ->
      (match y with
       | Some l' -> None :: (merge_list_to_stack stack' (merge l' l))
       | None -> (Some l) :: stack')

  (** val merge_stack : X.t list option list -> X.t list **)

  let rec merge_stack = function
  | [] -> []
  | y :: stack' ->
    (match y with
     | Some l -> merge l (merge_stack stack')
     | None -> merge_stack stack')

  (** val iter_merge : X.t list option list -> X.t list -> X.t list **)

  let rec iter_merge stack = function
  | [] -> merge_stack stack
  | a :: l' -> iter_merge (merge_list_to_stack stack (a :: [])) l'

  (** val sort : X.t list -> X.t list **)

  let sort =
    iter_merge []

  (** val flatten_stack : X.t list option list -> X.t list **)

  let rec flatten_stack = function
  | [] -> []
  | o :: stack' ->
    (match o with
     | Some l -> app l (flatten_stack stack')
     | None -> flatten_stack stack')
 end

module Coq1_N =
 struct
  module Order =
   struct
    type t = n

    (** val ltb : n -> n -> bool **)

    let ltb =
      Coq_N.ltb

    (** val leb : n -> n -> bool **)

    let leb =
      Coq_N.leb
   end

  module Sort = Sort(Order)
 end

module type WSets =
 sig
  module E :
   DecidableType

  type elt = E.t

  type t

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val singleton : elt -> t

  val remove : elt -> t -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool
 end

module type Sets =
 sig
  module E :
   OrderedType

  type elt = E.t

  type t

  val empty : t

  val is_empty : t -> bool

  val mem : elt -> t -> bool

  val add : elt -> t -> t

  val singleton : elt -> t

  val remove : elt -> t -> t

  val union : t -> t -> t

  val inter : t -> t -> t

  val diff : t -> t -> t

  val equal : t -> t -> bool

  val subset : t -> t -> bool

  val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1

  val for_all : (elt -> bool) -> t -> bool

  val exists_ : (elt -> bool) -> t -> bool

  val filter : (elt -> bool) -> t -> t

  val partition : (elt -> bool) -> t -> t * t

  val cardinal : t -> nat

  val elements : t -> elt list

  val choose : t -> elt option

  val eq_dec : t -> t -> bool

  val compare : t -> t -> comparison

  val min_elt : t -> elt option

  val max_elt : t -> elt option
 end

module MakeListOrdering =
 functor (O:OrderedType) ->
 struct
  module MO = OrderedTypeFacts(O)
 end

module PositiveSet =
 struct
  module E = PositiveOrderedTypeBits

  type elt = positive

  type tree =
  | Leaf
  | Node of tree * bool * tree

  type t = tree

  (** val empty : t **)

  let empty =
    Leaf

  (** val is_empty : t -> bool **)

  let rec is_empty = function
  | Leaf -> true
  | Node (l, b, r0) ->
    if if negb b then is_empty l else false then is_empty r0 else false

  (** val mem : positive -> t -> bool **)

  let rec mem i = function
  | Leaf -> false
  | Node (l, o, r0) ->
    (match i with
     | XI i0 -> mem i0 r0
     | XO i0 -> mem i0 l
     | XH -> o)

  (** val add : positive -> t -> t **)

  let rec add i = function
  | Leaf ->
    (match i with
     | XI i0 -> Node (Leaf, false, (add i0 Leaf))
     | XO i0 -> Node ((add i0 Leaf), false, Leaf)
     | XH -> Node (Leaf, true, Leaf))
  | Node (l, o, r0) ->
    (match i with
     | XI i0 -> Node (l, o, (add i0 r0))
     | XO i0 -> Node ((add i0 l), o, r0)
     | XH -> Node (l, true, r0))

  (** val singleton : positive -> t **)

  let singleton i =
    add i empty

  (** val node : t -> bool -> t -> t **)

  let node l b r0 =
    if b
    then Node (l, b, r0)
    else (match l with
          | Leaf ->
            (match r0 with
             | Leaf -> Leaf
             | Node (_, _, _) -> Node (l, false, r0))
          | Node (_, _, _) -> Node (l, false, r0))

  (** val remove : positive -> t -> t **)

  let rec remove i = function
  | Leaf -> Leaf
  | Node (l, o, r0) ->
    (match i with
     | XI i0 -> node l o (remove i0 r0)
     | XO i0 -> node (remove i0 l) o r0
     | XH -> node l false r0)

  (** val union : t -> t -> t **)

  let rec union m4 m'0 =
    match m4 with
    | Leaf -> m'0
    | Node (l, o, r0) ->
      (match m'0 with
       | Leaf -> m4
       | Node (l', o', r'0) ->
         Node ((union l l'), ((||) o o'), (union r0 r'0)))

  (** val inter : t -> t -> t **)

  let rec inter m4 m'0 =
    match m4 with
    | Leaf -> Leaf
    | Node (l, o, r0) ->
      (match m'0 with
       | Leaf -> Leaf
       | Node (l', o', r'0) -> node (inter l l') ((&&) o o') (inter r0 r'0))

  (** val diff : t -> t -> t **)

  let rec diff m4 m'0 =
    match m4 with
    | Leaf -> Leaf
    | Node (l, o, r0) ->
      (match m'0 with
       | Leaf -> m4
       | Node (l', o', r'0) ->
         node (diff l l') ((&&) o (negb o')) (diff r0 r'0))

  (** val equal : t -> t -> bool **)

  let rec equal m4 m'0 =
    match m4 with
    | Leaf -> is_empty m'0
    | Node (l, o, r0) ->
      (match m'0 with
       | Leaf -> is_empty m4
       | Node (l', o', r'0) ->
         if if eqb o o' then equal l l' else false
         then equal r0 r'0
         else false)

  (** val subset : t -> t -> bool **)

  let rec subset m4 m'0 =
    match m4 with
    | Leaf -> true
    | Node (l, o, r0) ->
      (match m'0 with
       | Leaf -> is_empty m4
       | Node (l', o', r'0) ->
         if if if negb o then true else o' then subset l l' else false
         then subset r0 r'0
         else false)

  (** val rev_append : elt -> elt -> elt **)

  let rec rev_append y x =
    match y with
    | XI y0 -> rev_append y0 (XI x)
    | XO y0 -> rev_append y0 (XO x)
    | XH -> x

  (** val rev : elt -> elt **)

  let rev x =
    rev_append x XH

  (** val xfold : (positive -> 'a1 -> 'a1) -> t -> 'a1 -> positive -> 'a1 **)

  let xfold f =
    let rec xfold0 m4 v i =
      match m4 with
      | Leaf -> v
      | Node (l, b, r0) ->
        if b
        then xfold0 r0 (f (rev i) (xfold0 l v (XO i))) (XI i)
        else xfold0 r0 (xfold0 l v (XO i)) (XI i)
    in xfold0

  (** val fold : (positive -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1 **)

  let fold f m4 i =
    xfold f m4 i XH

  (** val xforall : (positive -> bool) -> t -> positive -> bool **)

  let xforall f =
    let rec xforall0 m4 i =
      match m4 with
      | Leaf -> true
      | Node (l, o, r0) ->
        if if if negb o then true else f (rev i)
           then xforall0 r0 (XI i)
           else false
        then xforall0 l (XO i)
        else false
    in xforall0

  (** val for_all : (positive -> bool) -> t -> bool **)

  let for_all f m4 =
    xforall f m4 XH

  (** val xexists : (positive -> bool) -> t -> positive -> bool **)

  let xexists f =
    let rec xexists0 m4 i =
      match m4 with
      | Leaf -> false
      | Node (l, o, r0) ->
        if if if o then f (rev i) else false then true else xexists0 r0 (XI i)
        then true
        else xexists0 l (XO i)
    in xexists0

  (** val exists_ : (positive -> bool) -> t -> bool **)

  let exists_ f m4 =
    xexists f m4 XH

  (** val xfilter : (positive -> bool) -> t -> positive -> t **)

  let xfilter f =
    let rec xfilter0 m4 i =
      match m4 with
      | Leaf -> Leaf
      | Node (l, o, r0) ->
        node (xfilter0 l (XO i)) (if o then f (rev i) else false)
          (xfilter0 r0 (XI i))
    in xfilter0

  (** val filter : (positive -> bool) -> t -> t **)

  let filter f m4 =
    xfilter f m4 XH

  (** val xpartition : (positive -> bool) -> t -> positive -> t * t **)

  let xpartition f =
    let rec xpartition0 m4 i =
      match m4 with
      | Leaf -> (Leaf, Leaf)
      | Node (l, o, r0) ->
        let (lt, lf) = xpartition0 l (XO i) in
        let (rt, rf) = xpartition0 r0 (XI i) in
        if o
        then let fi = f (rev i) in ((node lt fi rt), (node lf (negb fi) rf))
        else ((node lt false rt), (node lf false rf))
    in xpartition0

  (** val partition : (positive -> bool) -> t -> t * t **)

  let partition f m4 =
    xpartition f m4 XH

  (** val xelements : t -> positive -> positive list -> positive list **)

  let rec xelements m4 i a =
    match m4 with
    | Leaf -> a
    | Node (l, b, r0) ->
      if b
      then xelements l (XO i) ((rev i) :: (xelements r0 (XI i) a))
      else xelements l (XO i) (xelements r0 (XI i) a)

  (** val elements : t -> positive list **)

  let elements m4 =
    xelements m4 XH []

  (** val cardinal : t -> nat **)

  let rec cardinal = function
  | Leaf -> O
  | Node (l, b, r0) ->
    if b
    then S (Coq__1.add (cardinal l) (cardinal r0))
    else Coq__1.add (cardinal l) (cardinal r0)

  (** val choose : t -> elt option **)

  let rec choose = function
  | Leaf -> None
  | Node (l, o, r0) ->
    if o
    then Some XH
    else (match choose l with
          | Some i -> Some (XO i)
          | None -> option_map (fun x -> XI x) (choose r0))

  (** val min_elt : t -> elt option **)

  let rec min_elt = function
  | Leaf -> None
  | Node (l, o, r0) ->
    (match min_elt l with
     | Some i -> Some (XO i)
     | None -> if o then Some XH else option_map (fun x -> XI x) (min_elt r0))

  (** val max_elt : t -> elt option **)

  let rec max_elt = function
  | Leaf -> None
  | Node (l, o, r0) ->
    (match max_elt r0 with
     | Some i -> Some (XI i)
     | None -> if o then Some XH else option_map (fun x -> XO x) (max_elt l))

  (** val compare_bool : bool -> bool -> comparison **)

  let compare_bool a b =
    if a then if b then Eq else Gt else if b then Lt else Eq

  (** val compare : t -> t -> comparison **)

  let rec compare m4 m'0 =
    match m4 with
    | Leaf -> if is_empty m'0 then Eq else Lt
    | Node (l, o, r0) ->
      (match m'0 with
       | Leaf -> if is_empty m4 then Eq else Gt
       | Node (l', o', r'0) ->
         (match compare_bool o o' with
          | Eq ->
            (match compare l l' with
             | Eq -> compare r0 r'0
             | Lt -> Lt
             | Gt -> Gt)
          | Lt -> Lt
          | Gt -> Gt))

  (** val eq_dec : t -> t -> bool **)

  let eq_dec s0 s' =
    (if equal s0 s' then (fun _ -> true) else (fun _ -> false)) __
 end

module IsoWSets =
 functor (W':WSets) ->
 functor (E0:sig
  type t

  val eq_dec : t -> t -> bool

  val to_ : t -> W'.E.t

  val of_ : W'.E.t -> t
 end) ->
 struct
  module E = E0

  type elt = E0.t

  type t = W'.t

  (** val lift : (W'.elt -> 'a1) -> elt -> 'a1 **)

  let lift f x =
    f (E.to_ x)

  (** val liftho : ((W'.elt -> 'a1) -> 'a2) -> (elt -> 'a1) -> 'a2 **)

  let liftho f f' =
    f (fun x -> f' (E.of_ x))

  (** val empty : t **)

  let empty =
    W'.empty

  (** val is_empty : t -> bool **)

  let is_empty =
    W'.is_empty

  (** val mem : elt -> t -> bool **)

  let mem =
    lift W'.mem

  (** val add : elt -> t -> t **)

  let add =
    lift W'.add

  (** val remove : elt -> t -> t **)

  let remove =
    lift W'.remove

  (** val singleton : elt -> t **)

  let singleton =
    lift W'.singleton

  (** val union : t -> t -> t **)

  let union =
    W'.union

  (** val inter : t -> t -> t **)

  let inter =
    W'.inter

  (** val diff : t -> t -> t **)

  let diff =
    W'.diff

  (** val equal : t -> t -> bool **)

  let equal =
    W'.equal

  (** val subset : t -> t -> bool **)

  let subset =
    W'.subset

  (** val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1 **)

  let fold x =
    liftho W'.fold x

  (** val for_all : (elt -> bool) -> t -> bool **)

  let for_all =
    liftho W'.for_all

  (** val exists_ : (elt -> bool) -> t -> bool **)

  let exists_ =
    liftho W'.exists_

  (** val filter : (elt -> bool) -> t -> t **)

  let filter =
    liftho W'.filter

  (** val partition : (elt -> bool) -> t -> t * t **)

  let partition =
    liftho W'.partition

  (** val cardinal : t -> nat **)

  let cardinal =
    W'.cardinal

  (** val elements : t -> elt list **)

  let elements v =
    map E.of_ (W'.elements v)

  (** val choose : t -> elt option **)

  let choose v =
    option_map E.of_ (W'.choose v)

  (** val eq_dec : t -> t -> bool **)

  let eq_dec x y =
    let s0 = W'.eq_dec x y in if s0 then true else false
 end

module IsoSets =
 functor (W':Sets) ->
 functor (E0:sig
  type t

  val compare : t -> t -> comparison

  val eq_dec : t -> t -> bool

  val to_ : t -> W'.E.t

  val of_ : W'.E.t -> t
 end) ->
 struct
  module E = E0

  type elt = E0.t

  type t = W'.t

  (** val lift : (W'.elt -> 'a1) -> elt -> 'a1 **)

  let lift f x =
    f (E.to_ x)

  (** val liftho : ((W'.elt -> 'a1) -> 'a2) -> (elt -> 'a1) -> 'a2 **)

  let liftho f f' =
    f (fun x -> f' (E.of_ x))

  (** val empty : t **)

  let empty =
    W'.empty

  (** val is_empty : t -> bool **)

  let is_empty =
    W'.is_empty

  (** val mem : elt -> t -> bool **)

  let mem =
    lift W'.mem

  (** val add : elt -> t -> t **)

  let add =
    lift W'.add

  (** val remove : elt -> t -> t **)

  let remove =
    lift W'.remove

  (** val singleton : elt -> t **)

  let singleton =
    lift W'.singleton

  (** val union : t -> t -> t **)

  let union =
    W'.union

  (** val inter : t -> t -> t **)

  let inter =
    W'.inter

  (** val diff : t -> t -> t **)

  let diff =
    W'.diff

  (** val equal : t -> t -> bool **)

  let equal =
    W'.equal

  (** val subset : t -> t -> bool **)

  let subset =
    W'.subset

  (** val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1 **)

  let fold x =
    liftho W'.fold x

  (** val for_all : (elt -> bool) -> t -> bool **)

  let for_all =
    liftho W'.for_all

  (** val exists_ : (elt -> bool) -> t -> bool **)

  let exists_ =
    liftho W'.exists_

  (** val filter : (elt -> bool) -> t -> t **)

  let filter =
    liftho W'.filter

  (** val partition : (elt -> bool) -> t -> t * t **)

  let partition =
    liftho W'.partition

  (** val cardinal : t -> nat **)

  let cardinal =
    W'.cardinal

  (** val elements : t -> elt list **)

  let elements v =
    map E.of_ (W'.elements v)

  (** val choose : t -> elt option **)

  let choose v =
    option_map E.of_ (W'.choose v)

  (** val eq_dec : t -> t -> bool **)

  let eq_dec x y =
    let s0 = W'.eq_dec x y in if s0 then true else false

  (** val compare : t -> t -> comparison **)

  let compare =
    W'.compare

  (** val min_elt : t -> elt option **)

  let min_elt v =
    option_map E.of_ (W'.min_elt v)

  (** val max_elt : t -> elt option **)

  let max_elt v =
    option_map E.of_ (W'.max_elt v)
 end

module NIsoPositive =
 struct
  type t = n

  (** val eq_dec : t -> t -> bool **)

  let eq_dec =
    Coq_N.eq_dec

  (** val to_ : t -> PositiveSet.E.t **)

  let to_ =
    Coq_N.succ_pos

  (** val of_ : PositiveSet.E.t -> t **)

  let of_ =
    Coq_Pos.pred_N

  (** val compare : t -> t -> comparison **)

  let compare x y =
    PositiveSet.E.compare (to_ x) (to_ y)
 end

module NSet = IsoSets(PositiveSet)(NIsoPositive)

module ZRange =
 struct
  (** val union : zrange -> zrange -> zrange **)

  let union x y =
    let { lower = lx; upper = ux } = { lower = x.lower; upper = x.upper } in
    let { lower = ly; upper = uy } = { lower = y.lower; upper = y.upper } in
    { lower = (Coq_Z.min lx ly); upper = (Coq_Z.max ux uy) }

  (** val normalize : zrange -> zrange **)

  let normalize v =
    { lower = (Coq_Z.min v.lower v.upper); upper =
      (Coq_Z.max v.upper v.lower) }

  (** val opp : zrange -> zrange **)

  let opp v =
    let { lower = l; upper = u } = { lower = v.lower; upper = v.upper } in
    { lower = (Coq_Z.opp u); upper = (Coq_Z.opp l) }

  (** val split_range_at_0 :
      zrange -> (zrange option * zrange option) * zrange option **)

  let split_range_at_0 x =
    let { lower = l; upper = u } = { lower = x.lower; upper = x.upper } in
    (((if Coq_Z.leb Z0 l
       then None
       else Some { lower = l; upper = (Coq_Z.min u (Zneg XH)) }),
    (if (||) (Coq_Z.ltb Z0 l) (Coq_Z.ltb u Z0)
     then None
     else Some { lower = Z0; upper = Z0 })),
    (if Coq_Z.leb u Z0
     then None
     else Some { lower = (Coq_Z.max (Zpos XH) l); upper = u }))

  (** val apply_to_split_range : (zrange -> zrange) -> zrange -> zrange **)

  let apply_to_split_range f v =
    let (p0, o) = split_range_at_0 v in
    let (o0, o1) = p0 in
    (match o0 with
     | Some v0 ->
       (match o1 with
        | Some v2 ->
          (match o with
           | Some p -> union (union (f v0) (f p)) (f v2)
           | None -> union (f v0) (f v2))
        | None -> (match o with
                   | Some v2 -> union (f v0) (f v2)
                   | None -> f v0))
     | None ->
       (match o1 with
        | Some v0 ->
          (match o with
           | Some v2 -> union (f v0) (f v2)
           | None -> f v0)
        | None -> (match o with
                   | Some v0 -> f v0
                   | None -> f v)))

  (** val apply_to_range : (z -> zrange) -> zrange -> zrange **)

  let apply_to_range f v =
    let { lower = l; upper = u } = { lower = v.lower; upper = v.upper } in
    union (f l) (f u)

  (** val apply_to_each_split_range : (z -> zrange) -> zrange -> zrange **)

  let apply_to_each_split_range f v =
    apply_to_split_range (apply_to_range f) v

  (** val constant : z -> zrange **)

  let constant v =
    { lower = v; upper = v }

  (** val two_corners : (z -> z) -> zrange -> zrange **)

  let two_corners f v =
    apply_to_range (fun x -> constant (f x)) v

  (** val four_corners : (z -> z -> z) -> zrange -> zrange -> zrange **)

  let four_corners f x y =
    apply_to_range (fun x0 -> two_corners (f x0) y) x

  (** val eight_corners :
      (z -> z -> z -> z) -> zrange -> zrange -> zrange -> zrange **)

  let eight_corners f x y z0 =
    apply_to_range (fun x0 -> four_corners (f x0) y z0) x

  (** val two_corners_and_zero : (z -> z) -> zrange -> zrange **)

  let two_corners_and_zero f v =
    apply_to_each_split_range (fun x -> constant (f x)) v

  (** val four_corners_and_zero :
      (z -> z -> z) -> zrange -> zrange -> zrange **)

  let four_corners_and_zero f x y =
    apply_to_split_range
      (apply_to_range (fun x0 -> two_corners_and_zero (f x0) y)) x

  (** val extend_land_lor_bounds : zrange -> zrange **)

  let extend_land_lor_bounds v =
    let { lower = l; upper = u } = { lower = v.lower; upper = v.upper } in
    { lower = (Coq_Z.min Z0 l); upper = (Coq_Z.max (Zneg XH) u) }

  (** val land_lor_bounds : (z -> z -> z) -> zrange -> zrange -> zrange **)

  let land_lor_bounds f x y =
    four_corners_and_zero (fun x0 y0 ->
      f (Coq1_Z.round_lor_land_bound x0) (Coq1_Z.round_lor_land_bound y0))
      (extend_land_lor_bounds x) (extend_land_lor_bounds y)

  (** val lor_bounds : zrange -> zrange -> zrange **)

  let lor_bounds =
    land_lor_bounds Coq_Z.coq_lor

  (** val land_bounds : zrange -> zrange -> zrange **)

  let land_bounds x y =
    let low =
      if (&&) (Coq_Z.ltb x.lower Z0) (Coq_Z.ltb y.lower Z0)
      then let logx = Coq_Z.log2_up (Coq_Z.opp x.lower) in
           let logy = Coq_Z.log2_up (Coq_Z.opp y.lower) in
           Coq_Z.opp (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.max logx logy))
      else Z0
    in
    let high =
      if (&&) (Coq_Z.leb Z0 x.lower) (Coq_Z.leb Z0 y.lower)
      then if (&&) (Coq_Z.leb Z0 x.upper) (Coq_Z.leb Z0 y.upper)
           then Coq_Z.min x.upper y.upper
           else Coq_Z.max (Coq_Z.max x.lower x.upper)
                  (Coq_Z.max y.lower y.upper)
      else if (&&) (Coq_Z.ltb x.upper Z0) (Coq_Z.ltb y.upper Z0)
           then Z0
           else Coq_Z.max x.upper y.upper
    in
    { lower = low; upper = high }

  (** val split_bounds_pos : zrange -> z -> zrange * zrange **)

  let split_bounds_pos r0 split_at =
    if Coq_Z.ltb r0.upper split_at
    then if Coq_Z.leb Z0 r0.lower
         then (r0, { lower = Z0; upper = Z0 })
         else ({ lower = Z0; upper = (Coq_Z.sub split_at (Zpos XH)) },
                { lower = (Coq_Z.div r0.lower split_at); upper =
                (Coq_Z.div r0.upper split_at) })
    else ({ lower = Z0; upper = (Coq_Z.sub split_at (Zpos XH)) }, { lower =
           (Coq_Z.div r0.lower split_at); upper =
           (Coq_Z.div r0.upper split_at) })

  (** val split_bounds : zrange -> z -> zrange * zrange **)

  let split_bounds r0 split_at =
    if Coq_Z.ltb Z0 split_at
    then split_bounds_pos r0 split_at
    else if Coq_Z.eqb split_at Z0
         then (r0, { lower = Z0; upper = Z0 })
         else let (q0, r1) = split_bounds_pos (opp r0) (Coq_Z.opp split_at) in
              ((opp q0), r1)
 end
module Coq__9 = ZRange

(** val bool_rect_nodep : 'a1 -> 'a1 -> bool -> 'a1 **)

let bool_rect_nodep f f0 = function
| true -> f
| false -> f0

module Thunked =
 struct
  (** val bool_rect : (unit -> 'a1) -> (unit -> 'a1) -> bool -> 'a1 **)

  let bool_rect t0 f = function
  | true -> t0 ()
  | false -> f ()
 end

(** val option_beq0 :
    ('a1 -> 'a1 -> bool) -> 'a1 option -> 'a1 option -> bool **)

let option_beq0 eq_A x y =
  match x with
  | Some x0 -> (match y with
                | Some x1 -> eq_A x0 x1
                | None -> false)
  | None -> (match y with
             | Some _ -> false
             | None -> true)

module Coq_Thunked =
 struct
  (** val option_rect : ('a1 -> 'a2) -> (unit -> 'a2) -> 'a1 option -> 'a2 **)

  let option_rect s_case n_case = function
  | Some a -> s_case a
  | None -> n_case ()
 end

(** val option_beq_hetero0 :
    ('a1 -> 'a2 -> bool) -> 'a1 option -> 'a2 option -> bool **)

let option_beq_hetero0 aB_beq x y =
  match x with
  | Some x0 -> (match y with
                | Some y0 -> aB_beq x0 y0
                | None -> false)
  | None -> (match y with
             | Some _ -> false
             | None -> true)

(** val lift0 : 'a1 option option -> 'a1 option option **)

let lift0 = function
| Some o -> (match o with
             | Some x0 -> Some (Some x0)
             | None -> None)
| None -> Some None

(** val bind1 : 'a1 option -> ('a1 -> 'a2 option) -> 'a2 option **)

let bind1 v f =
  match v with
  | Some v0 -> f v0
  | None -> None

(** val sequence : 'a1 option -> 'a1 option -> 'a1 option **)

let sequence v1 v2 =
  match v1 with
  | Some v -> Some v
  | None -> v2

(** val sequence_return0 : 'a1 option -> 'a1 -> 'a1 **)

let sequence_return0 v1 v2 =
  match v1 with
  | Some v -> v
  | None -> v2

(** val combine0 : 'a1 option -> 'a2 option -> ('a1 * 'a2) option **)

let combine0 x y =
  match x with
  | Some x0 -> (match y with
                | Some y0 -> Some (x0, y0)
                | None -> None)
  | None -> None

(** val is_None : 'a1 option -> bool **)

let is_None = function
| Some _ -> false
| None -> true

(** val is_Some : 'a1 option -> bool **)

let is_Some = function
| Some _ -> true
| None -> false

(** val invert_Some0 : 'a1 option -> __ **)

let invert_Some0 = function
| Some x' -> Obj.magic x'
| None -> Obj.magic ()

(** val prod_beq0 :
    ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1 * 'a2) ->
    ('a1 * 'a2) -> bool **)

let prod_beq0 eq_A eq_B x y =
  let (x0, x1) = x in let (x2, x3) = y in (&&) (eq_A x0 x2) (eq_B x1 x3)

(** val prod_beq_hetero :
    ('a1 -> 'a3 -> bool) -> ('a2 -> 'a4 -> bool) -> ('a1 * 'a2) ->
    ('a3 * 'a4) -> bool **)

let prod_beq_hetero a_beq_hetero b_beq_hetero x y =
  (&&) (a_beq_hetero (fst x) (fst y)) (b_beq_hetero (snd x) (snd y))

(** val prod_rect_nodep : ('a1 -> 'a2 -> 'a3) -> ('a1 * 'a2) -> 'a3 **)

let prod_rect_nodep x = function
| (a, b) -> x a b

(** val nat_beq : nat -> nat -> bool **)

let rec nat_beq x y =
  match x with
  | O -> (match y with
          | O -> true
          | S _ -> false)
  | S x0 -> (match y with
             | O -> false
             | S x1 -> nat_beq x0 x1)

(** val nat_rect_nodep : 'a1 -> (nat -> 'a1 -> 'a1) -> nat -> 'a1 **)

let nat_rect_nodep x f0 =
  let rec f = function
  | O -> x
  | S n4 -> f0 n4 (f n4)
  in f

(** val nat_rect_arrow_nodep :
    ('a1 -> 'a2) -> (nat -> ('a1 -> 'a2) -> 'a1 -> 'a2) -> nat -> 'a1 -> 'a2 **)

let nat_rect_arrow_nodep =
  nat_rect_nodep

module Coq0_Thunked =
 struct
  (** val nat_rect : (unit -> 'a1) -> (nat -> 'a1 -> 'a1) -> nat -> 'a1 **)

  let nat_rect o_case s_case n3 =
    let rec f = function
    | O -> o_case ()
    | S n5 -> s_case n5 (f n5)
    in f n3
 end

type decidable0 = bool

(** val dec0 : decidable0 -> bool **)

let dec0 decidable1 =
  decidable1

(** val dec_or : decidable0 -> decidable0 -> decidable0 **)

let dec_or h = function
| true -> if h then true else true
| false -> if h then true else false

(** val dec_eq_list :
    ('a1 -> 'a1 -> decidable0) -> 'a1 list -> 'a1 list -> decidable0 **)

let dec_eq_list decidableRel0 x y =
  let rec f = function
  | [] -> (fun x0 -> match x0 with
                     | [] -> true
                     | _ :: _ -> false)
  | y0 :: l0 ->
    (fun x0 ->
      match x0 with
      | [] -> false
      | a :: l1 ->
        if decidableRel0 y0 a then if f l0 l1 then true else false else false)
  in f x y

(** val dec_eq_sum :
    ('a1 -> 'a1 -> decidable0) -> ('a2 -> 'a2 -> decidable0) -> ('a1, 'a2)
    sum -> ('a1, 'a2) sum -> decidable0 **)

let dec_eq_sum decidableRel0 decidableRel1 x y =
  (match x with
   | Inl a ->
     (fun x0 ->
       match x0 with
       | Inl a0 -> if decidableRel0 a a0 then true else false
       | Inr _ -> false)
   | Inr b ->
     (fun x0 ->
       match x0 with
       | Inl _ -> false
       | Inr b0 -> if decidableRel1 b b0 then true else false)) y

(** val dec_eq_N : n -> n -> decidable0 **)

let dec_eq_N =
  Coq_N.eq_dec

(** val dec_eq_Z0 : z -> z -> decidable0 **)

let dec_eq_Z0 =
  Coq_Z.eq_dec

(** val dec_lt_Z : z -> z -> decidable0 **)

let dec_lt_Z =
  z_lt_dec

(** val decidable_iff_to_impl : decidable0 -> decidable0 **)

let decidable_iff_to_impl = function
| true -> true
| false -> false

(** val list_beq0 : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> bool **)

let list_beq0 eq_A =
  let rec list_eqrec x y =
    match x with
    | [] -> (match y with
             | [] -> true
             | _ :: _ -> false)
    | x0 :: x1 ->
      (match y with
       | [] -> false
       | x2 :: x3 -> (&&) (eq_A x0 x2) (list_eqrec x1 x3))
  in list_eqrec

(** val list_case0 : 'a2 -> ('a1 -> 'a1 list -> 'a2) -> 'a1 list -> 'a2 **)

let list_case0 n3 c0 = function
| [] -> n3
| x :: xs -> c0 x xs

(** val list_rect_nodep :
    'a2 -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2 **)

let list_rect_nodep x f0 =
  let rec f = function
  | [] -> x
  | y :: l0 -> f0 y l0 (f l0)
  in f

(** val list_rect_arrow_nodep :
    ('a2 -> 'a3) -> ('a1 -> 'a1 list -> ('a2 -> 'a3) -> 'a2 -> 'a3) -> 'a1
    list -> 'a2 -> 'a3 **)

let list_rect_arrow_nodep =
  list_rect_nodep

module Coq1_Thunked =
 struct
  (** val list_rect :
      (unit -> 'a2) -> ('a1 -> 'a1 list -> 'a2 -> 'a2) -> 'a1 list -> 'a2 **)

  let list_rect n3 c0 ls =
    let rec f = function
    | [] -> n3 ()
    | y :: l0 -> c0 y l0 (f l0)
    in f ls

  (** val list_case :
      (unit -> 'a2) -> ('a1 -> 'a1 list -> 'a2) -> 'a1 list -> 'a2 **)

  let list_case n3 c0 ls =
    list_case0 (n3 ()) c0 ls
 end

module Coq2_List =
 struct
  (** val enumerate : 'a1 list -> (nat * 'a1) list **)

  let enumerate ls =
    combine (seq O (length ls)) ls
 end

(** val list_beq_hetero0 :
    ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool **)

let list_beq_hetero0 f =
  let rec list_beq_hetero1 l1 l2 =
    match l1 with
    | [] -> (match l2 with
             | [] -> true
             | _ :: _ -> false)
    | x :: xs ->
      (match l2 with
       | [] -> false
       | y :: ys -> (&&) (f x y) (list_beq_hetero1 xs ys))
  in list_beq_hetero1

(** val update_nth0 : nat -> ('a1 -> 'a1) -> 'a1 list -> 'a1 list **)

let rec update_nth0 n3 f xs =
  match n3 with
  | O -> (match xs with
          | [] -> []
          | x' :: xs' -> (f x') :: xs')
  | S n' ->
    (match xs with
     | [] -> []
     | x' :: xs' -> x' :: (update_nth0 n' f xs'))

(** val set_nth0 : nat -> 'a1 -> 'a1 list -> 'a1 list **)

let set_nth0 n3 x xs =
  update_nth0 n3 (fun _ -> x) xs

module Primitive =
 struct
  type ('a, 'b) prod = { fst : 'a; snd : 'b }

  (** val fst : ('a1, 'a2) prod -> 'a1 **)

  let fst p =
    p.fst

  (** val snd : ('a1, 'a2) prod -> 'a2 **)

  let snd p =
    p.snd
 end

type ('a, 'p) hlist = __

(** val combine_hlist :
    'a1 list -> ('a1, 'a2) hlist -> ('a1, 'a2) sigT list **)

let rec combine_hlist = function
| [] -> (fun _ -> [])
| x :: xs ->
  (fun pat ->
    let px = (Obj.magic pat).Primitive.fst in
    let pxs = (Obj.magic pat).Primitive.snd in
    (ExistT (x, px)) :: (combine_hlist xs pxs))

module Pre =
 struct
  module Coq_ident =
   struct
    (** val literal : 'a1 -> 'a1 **)

    let literal v =
      v

    (** val eagerly : 'a1 -> 'a1 **)

    let eagerly v =
      v
   end
 end

module Named =
 struct
  type maybe_name =
  | Coq_no_name
  | Coq_a_name

  type t = { value : __; naming : maybe_name }
 end

module Coq_ident =
 struct
  (** val is_more_pos_than_neg : zrange -> z -> bool **)

  let is_more_pos_than_neg r0 v =
    (||)
      ((||) (Coq_Z.ltb (Coq_Z.abs r0.lower) (Coq_Z.abs r0.upper))
        ((&&) (Coq_Z.eqb r0.lower r0.upper) (Coq_Z.leb Z0 r0.lower)))
      ((&&) (Coq_Z.eqb (Coq_Z.abs r0.lower) (Coq_Z.abs r0.upper))
        (Coq_Z.leb Z0 v))

  (** val cast : zrange -> z -> z **)

  let cast =
    let cast_outside_of_range = fun r0 v ->
      Coq_Z.add
        (Coq_Z.modulo (Coq_Z.sub v r0.lower)
          (Coq_Z.add (Coq_Z.sub r0.upper r0.lower) (Zpos XH))) r0.lower
    in
    (fun r0 x ->
    let r1 = ZRange.normalize r0 in
    if (&&) (Coq_Z.leb r1.lower x) (Coq_Z.leb x r1.upper)
    then x
    else if is_more_pos_than_neg r1 x
         then cast_outside_of_range r1 x
         else Coq_Z.opp (cast_outside_of_range (ZRange.opp r1) (Coq_Z.opp x)))

  (** val cast2 : (zrange * zrange) -> (z * z) -> z * z **)

  let cast2 r0 x =
    ((cast (fst r0) (fst x)), (cast (snd r0) (snd x)))

  (** val comment : 'a1 -> unit **)

  let comment _ =
    ()

  (** val comment_no_keep : 'a1 -> unit **)

  let comment_no_keep _ =
    ()

  module Coq_fancy =
   struct
    (** val add : ((z * z) * (z * z)) -> z * z **)

    let add x =
      Coq1_Z.add_get_carry_full (Coq_Z.pow (Zpos (XO XH)) (fst (fst x)))
        (fst (snd x))
        (Coq_Z.modulo (Coq_Z.shiftl (snd (snd x)) (snd (fst x)))
          (Coq_Z.pow (Zpos (XO XH)) (fst (fst x))))

    (** val addc : ((z * z) * ((z * z) * z)) -> z * z **)

    let addc x =
      Coq1_Z.add_with_get_carry_full (Coq_Z.pow (Zpos (XO XH)) (fst (fst x)))
        (fst (fst (snd x))) (snd (fst (snd x)))
        (Coq_Z.modulo (Coq_Z.shiftl (snd (snd x)) (snd (fst x)))
          (Coq_Z.pow (Zpos (XO XH)) (fst (fst x))))

    (** val sub : ((z * z) * (z * z)) -> z * z **)

    let sub x =
      Coq1_Z.sub_get_borrow_full (Coq_Z.pow (Zpos (XO XH)) (fst (fst x)))
        (fst (snd x))
        (Coq_Z.modulo (Coq_Z.shiftl (snd (snd x)) (snd (fst x)))
          (Coq_Z.pow (Zpos (XO XH)) (fst (fst x))))

    (** val subb : ((z * z) * ((z * z) * z)) -> z * z **)

    let subb x =
      Coq1_Z.sub_with_get_borrow_full
        (Coq_Z.pow (Zpos (XO XH)) (fst (fst x))) (fst (fst (snd x)))
        (snd (fst (snd x)))
        (Coq_Z.modulo (Coq_Z.shiftl (snd (snd x)) (snd (fst x)))
          (Coq_Z.pow (Zpos (XO XH)) (fst (fst x))))

    (** val mulll : (z * (z * z)) -> z **)

    let mulll x =
      Coq_Z.mul
        (Coq_Z.coq_land (fst (snd x))
          (Coq_Z.sub
            (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.div (fst x) (Zpos (XO XH))))
            (Zpos XH)))
        (Coq_Z.coq_land (snd (snd x))
          (Coq_Z.sub
            (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.div (fst x) (Zpos (XO XH))))
            (Zpos XH)))

    (** val mullh : (z * (z * z)) -> z **)

    let mullh x =
      Coq_Z.mul
        (Coq_Z.coq_land (fst (snd x))
          (Coq_Z.sub
            (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.div (fst x) (Zpos (XO XH))))
            (Zpos XH)))
        (Coq_Z.shiftr (snd (snd x)) (Coq_Z.div (fst x) (Zpos (XO XH))))

    (** val mulhl : (z * (z * z)) -> z **)

    let mulhl x =
      Coq_Z.mul
        (Coq_Z.shiftr (fst (snd x)) (Coq_Z.div (fst x) (Zpos (XO XH))))
        (Coq_Z.coq_land (snd (snd x))
          (Coq_Z.sub
            (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.div (fst x) (Zpos (XO XH))))
            (Zpos XH)))

    (** val mulhh : (z * (z * z)) -> z **)

    let mulhh x =
      Coq_Z.mul
        (Coq_Z.shiftr (fst (snd x)) (Coq_Z.div (fst x) (Zpos (XO XH))))
        (Coq_Z.shiftr (snd (snd x)) (Coq_Z.div (fst x) (Zpos (XO XH))))

    (** val selm : (z * ((z * z) * z)) -> z **)

    let selm x =
      Coq1_Z.zselect
        (Coq1_Z.cc_m (Coq_Z.pow (Zpos (XO XH)) (fst x)) (fst (fst (snd x))))
        (snd (fst (snd x))) (snd (snd x))

    (** val rshi : ((z * z) * (z * z)) -> z **)

    let rshi x =
      Coq1_Z.rshi (Coq_Z.pow (Zpos (XO XH)) (fst (fst x))) (fst (snd x))
        (snd (snd x)) (snd (fst x))

    (** val selc : ((z * z) * z) -> z **)

    let selc x =
      Coq1_Z.zselect (fst (fst x)) (snd (fst x)) (snd x)

    (** val sell : ((z * z) * z) -> z **)

    let sell x =
      Coq1_Z.zselect (Coq_Z.coq_land (fst (fst x)) (Zpos XH)) (snd (fst x))
        (snd x)

    (** val addm : ((z * z) * z) -> z **)

    let addm x =
      Coq1_Z.add_modulo (fst (fst x)) (snd (fst x)) (snd x)
   end
 end

module Coq_Option =
 struct
  module List =
   struct
    (** val lift : 'a1 option list -> 'a1 list option **)

    let lift ls =
      fold_right (fun x xs ->
        bind1 x (fun x0 -> bind1 xs (fun xs0 -> Some (x0 :: xs0)))) (Some [])
        ls
   end
 end

(** val cpscall : (__ -> ('a1 -> __) -> __) -> ('a1 -> 'a2) -> 'a2 **)

let cpscall f continuation =
  Obj.magic f __ continuation

(** val cpsreturn : 'a1 -> 'a1 **)

let cpsreturn x =
  x

(** val cpsbind :
    (__ -> ('a1 -> __) -> __) -> ('a1 -> __ -> ('a2 -> __) -> __) -> ('a2 ->
    'a3) -> 'a3 **)

let cpsbind v f k =
  cpscall v (fun a -> cpscall (f a) k)

(** val cps_option_bind :
    (__ -> ('a1 option -> __) -> __) -> ('a1 -> __ -> ('a2 option -> __) ->
    __) -> ('a2 option -> 'a3) -> 'a3 **)

let cps_option_bind v f x =
  cpsbind v (fun x' _ k ->
    match x' with
    | Some x'0 -> f x'0 __ k
    | None -> k None) x

(** val reflect_of_brel0 : ('a1 -> 'a2 -> bool) -> 'a1 -> 'a2 -> reflect **)

let reflect_of_brel0 rb x y =
  let b = rb x y in
  (if b then (fun _ _ -> ReflectT) else (fun _ _ -> ReflectF)) __ __

(** val reflect_of_beq0 : ('a1 -> 'a1 -> bool) -> 'a1 -> 'a1 -> reflect **)

let reflect_of_beq0 =
  reflect_of_brel0

(** val dec_of_reflect : bool -> reflect -> decidable0 **)

let dec_of_reflect b h =
  (if b then (fun _ -> true) else (fun _ -> false)) h

(** val eq_decb_hprop : 'a1 -> 'a1 -> reflect **)

let eq_decb_hprop _ _ =
  ReflectT

(** val reflect_eq_unit : unit -> unit -> reflect **)

let reflect_eq_unit =
  eq_decb_hprop

(** val reflect_eq_bool : bool -> bool -> reflect **)

let reflect_eq_bool x y =
  reflect_of_brel0 eqb x y

(** val reflect_eq_prod :
    ('a1 -> 'a1 -> bool) -> ('a2 -> 'a2 -> bool) -> ('a1 -> 'a1 -> reflect)
    -> ('a2 -> 'a2 -> reflect) -> ('a1 * 'a2) -> ('a1 * 'a2) -> reflect **)

let reflect_eq_prod eqA eqB _ _ x y =
  reflect_of_brel0 (prod_beq0 eqA eqB) x y

module Compilers =
 struct
  module Coq_type =
   struct
    type 'base_type coq_type =
    | Coq_base of 'base_type
    | Coq_arrow of 'base_type coq_type * 'base_type coq_type

    (** val type_beq :
        ('a1 -> 'a1 -> bool) -> 'a1 coq_type -> 'a1 coq_type -> bool **)

    let type_beq eq_base_type =
      let rec type_eqrec x y =
        match x with
        | Coq_base t0 ->
          (match y with
           | Coq_base t1 -> eq_base_type t0 t1
           | Coq_arrow (_, _) -> false)
        | Coq_arrow (s0, d) ->
          (match y with
           | Coq_base _ -> false
           | Coq_arrow (s1, d0) -> (&&) (type_eqrec s0 s1) (type_eqrec d d0))
      in type_eqrec

    (** val final_codomain : 'a1 coq_type -> 'a1 **)

    let rec final_codomain = function
    | Coq_base t1 -> t1
    | Coq_arrow (_, d) -> final_codomain d

    type ('base_type, 'f) for_each_lhs_of_arrow = __

    (** val forall_each_lhs_of_arrow :
        ('a1 coq_type -> 'a2) -> 'a1 coq_type -> ('a1, 'a2)
        for_each_lhs_of_arrow **)

    let rec forall_each_lhs_of_arrow f = function
    | Coq_base _ -> Obj.magic ()
    | Coq_arrow (s0, d) -> Obj.magic ((f s0), (forall_each_lhs_of_arrow f d))

    type ('base_type, 'base_interp) interp = __

    (** val app_curried :
        'a1 coq_type -> ('a1, 'a2) interp -> ('a1, ('a1, 'a2) interp)
        for_each_lhs_of_arrow -> 'a2 **)

    let rec app_curried = function
    | Coq_base _ -> (fun v _ -> Obj.magic v)
    | Coq_arrow (_, d) ->
      (fun f x_xs ->
        app_curried d (Obj.magic f (fst (Obj.magic x_xs)))
          (snd (Obj.magic x_xs)))

    (** val map_for_each_lhs_of_arrow :
        ('a1 coq_type -> 'a2 -> 'a3) -> 'a1 coq_type -> ('a1, 'a2)
        for_each_lhs_of_arrow -> ('a1, 'a3) for_each_lhs_of_arrow **)

    let rec map_for_each_lhs_of_arrow f = function
    | Coq_base _ -> (fun pat -> let () = Obj.magic pat in Obj.magic ())
    | Coq_arrow (s0, d) ->
      (fun pat ->
        let (x, xs) = Obj.magic pat in
        Obj.magic ((f s0 x), (map_for_each_lhs_of_arrow f d xs)))

    type ('base_type, 'm, 'base_interp) interpM_final' = __

    type ('base_type, 'm, 'base_interp) interpM_final =
      ('base_type, 'm, 'base_interp) interpM_final'

    (** val interpM_return :
        'a1 coq_type -> 'a2 -> ('a1, 'a2, 'a3) interpM_final **)

    let interpM_return t0 =
      let rec interpM_return0 = function
      | Coq_base _ -> (fun v -> Obj.magic v)
      | Coq_arrow (_, d) ->
        (fun v -> Obj.magic (fun _ -> interpM_return0 d v))
      in interpM_return0 t0

    type 'base try_make_transport_cpsT =
      __ -> 'base -> 'base -> __ -> ((__ -> __) option -> __) -> __

    (** val try_make_transport_cpsv :
        'a1 try_make_transport_cpsT -> 'a1 -> 'a1 -> (('a2 -> 'a2) option ->
        'a3) -> 'a3 **)

    let try_make_transport_cpsv try_make_transport_cpsT0 t1 t2 x =
      Obj.magic try_make_transport_cpsT0 __ t1 t2 __ x

    (** val try_make_transport_cps :
        'a1 try_make_transport_cpsT -> 'a1 coq_type -> 'a1 coq_type -> (('a2
        -> 'a2) option -> 'a3) -> 'a3 **)

    let try_make_transport_cps try_make_transport_base_type_cps t1 t2 x =
      let rec try_make_transport_cps0 _ t3 t4 =
        match t3 with
        | Coq_base t5 ->
          (match t4 with
           | Coq_base t6 ->
             Obj.magic try_make_transport_base_type_cps __ t5 t6
           | Coq_arrow (_, _) ->
             cpsreturn (fun _ continuation -> continuation None))
        | Coq_arrow (s1, d1) ->
          (match t4 with
           | Coq_base _ -> cpsreturn (fun _ continuation -> continuation None)
           | Coq_arrow (s2, d2) ->
             (fun _ ->
               cps_option_bind (Obj.magic try_make_transport_cps0 __ s1 s2)
                 (fun trs _ ->
                 cps_option_bind (Obj.magic try_make_transport_cps0 __ d1 d2)
                   (fun trd ->
                   cpsreturn (fun _ continuation ->
                     continuation (Some (fun v -> trd (trs v))))))))
      in try_make_transport_cps0 __ t1 t2 __ x

    (** val try_transport_cps :
        'a1 try_make_transport_cpsT -> 'a1 coq_type -> 'a1 coq_type -> 'a2 ->
        ('a2 option -> 'a3) -> 'a3 **)

    let try_transport_cps try_make_transport_base_type_cps t1 t2 v x =
      cps_option_bind (fun _ ->
        try_make_transport_cps try_make_transport_base_type_cps t1 t2)
        (fun tr ->
        cpsreturn (fun _ continuation -> continuation (Some (tr v)))) x

    (** val try_transport :
        'a1 try_make_transport_cpsT -> 'a1 coq_type -> 'a1 coq_type -> 'a2 ->
        'a2 option **)

    let try_transport try_make_transport_base_type_cps t1 t2 v =
      try_transport_cps try_make_transport_base_type_cps t1 t2 v
        (Obj.magic id)
   end
  module Coq__2 = Coq_type

  module Coq_base =
   struct
    module Coq_type =
     struct
      type 'base_type coq_type =
      | Coq_type_base of 'base_type
      | Coq_prod of 'base_type coq_type * 'base_type coq_type
      | Coq_list of 'base_type coq_type
      | Coq_option of 'base_type coq_type
      | Coq_unit

      (** val type_beq :
          ('a1 -> 'a1 -> bool) -> 'a1 coq_type -> 'a1 coq_type -> bool **)

      let type_beq eq_base_type =
        let rec type_eqrec x y =
          match x with
          | Coq_type_base t0 ->
            (match y with
             | Coq_type_base t1 -> eq_base_type t0 t1
             | Coq_prod (_, _) -> false
             | Coq_list _ -> false
             | Coq_option _ -> false
             | Coq_unit -> false)
          | Coq_prod (a, b) ->
            (match y with
             | Coq_type_base _ -> false
             | Coq_prod (a0, b0) -> (&&) (type_eqrec a a0) (type_eqrec b b0)
             | Coq_list _ -> false
             | Coq_option _ -> false
             | Coq_unit -> false)
          | Coq_list a ->
            (match y with
             | Coq_type_base _ -> false
             | Coq_prod (_, _) -> false
             | Coq_list a0 -> type_eqrec a a0
             | Coq_option _ -> false
             | Coq_unit -> false)
          | Coq_option a ->
            (match y with
             | Coq_type_base _ -> false
             | Coq_prod (_, _) -> false
             | Coq_list _ -> false
             | Coq_option a0 -> type_eqrec a a0
             | Coq_unit -> false)
          | Coq_unit ->
            (match y with
             | Coq_type_base _ -> false
             | Coq_prod (_, _) -> false
             | Coq_list _ -> false
             | Coq_option _ -> false
             | Coq_unit -> true)
        in type_eqrec

      type 'base coq_BaseTypeHasNatT = 'base

      (** val nat : 'a1 coq_BaseTypeHasNatT -> 'a1 **)

      let nat baseTypeHasNatT =
        baseTypeHasNatT
     end

    type ('base, 'base_interp) coq_BaseHasNatCorrectT = { to_nat : ('base_interp
                                                                   -> nat);
                                                          of_nat : (nat ->
                                                                   'base_interp);
                                                          of_to_nat : 
                                                          (__ -> 'base_interp
                                                          -> __ -> __);
                                                          to_of_nat : 
                                                          (__ -> nat -> __ ->
                                                          __) }

    (** val to_nat :
        'a1 Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2) coq_BaseHasNatCorrectT
        -> 'a2 -> nat **)

    let to_nat _ baseHasNatCorrectT =
      baseHasNatCorrectT.to_nat

    (** val of_nat :
        'a1 Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2) coq_BaseHasNatCorrectT
        -> nat -> 'a2 **)

    let of_nat _ baseHasNatCorrectT =
      baseHasNatCorrectT.of_nat

    (** val reflect_type_beq :
        ('a1 -> 'a1 -> bool) -> ('a1 -> 'a1 -> reflect) -> 'a1
        Coq_type.coq_type -> 'a1 Coq_type.coq_type -> reflect **)

    let reflect_type_beq base_beq0 _ =
      reflect_of_beq0 (Coq_type.type_beq base_beq0)

    type ('base, 'base_interp) interp = __

    (** val interp_beq :
        ('a1 -> 'a2 -> 'a2 -> bool) -> 'a1 Coq_type.coq_type -> ('a1, 'a2)
        interp -> ('a1, 'a2) interp -> bool **)

    let rec interp_beq base_interp_beq0 = function
    | Coq_type.Coq_type_base t1 -> Obj.magic base_interp_beq0 t1
    | Coq_type.Coq_prod (a, b) ->
      Obj.magic prod_beq0 (interp_beq base_interp_beq0 a)
        (interp_beq base_interp_beq0 b)
    | Coq_type.Coq_list a ->
      Obj.magic list_beq0 (interp_beq base_interp_beq0 a)
    | Coq_type.Coq_option a ->
      Obj.magic option_beq0 (interp_beq base_interp_beq0 a)
    | Coq_type.Coq_unit -> (fun _ _ -> true)

    (** val interp_beq_hetero :
        ('a1 -> 'a1 -> 'a2 -> 'a2 -> bool) -> 'a1 Coq_type.coq_type -> 'a1
        Coq_type.coq_type -> ('a1, 'a2) interp -> ('a1, 'a2) interp -> bool **)

    let rec interp_beq_hetero base_interp_beq_hetero t1 t2 =
      match t1 with
      | Coq_type.Coq_type_base t3 ->
        (match t2 with
         | Coq_type.Coq_type_base t4 -> Obj.magic base_interp_beq_hetero t3 t4
         | Coq_type.Coq_prod (_, _) -> (fun _ _ -> false)
         | Coq_type.Coq_list _ -> (fun _ _ -> false)
         | Coq_type.Coq_option _ -> (fun _ _ -> false)
         | Coq_type.Coq_unit -> (fun _ _ -> false))
      | Coq_type.Coq_prod (a1, b1) ->
        (match t2 with
         | Coq_type.Coq_type_base _ -> (fun _ _ -> false)
         | Coq_type.Coq_prod (a2, b2) ->
           Obj.magic prod_beq_hetero
             (interp_beq_hetero base_interp_beq_hetero a1 a2)
             (interp_beq_hetero base_interp_beq_hetero b1 b2)
         | Coq_type.Coq_list _ -> (fun _ _ -> false)
         | Coq_type.Coq_option _ -> (fun _ _ -> false)
         | Coq_type.Coq_unit -> (fun _ _ -> false))
      | Coq_type.Coq_list a1 ->
        (match t2 with
         | Coq_type.Coq_type_base _ -> (fun _ _ -> false)
         | Coq_type.Coq_prod (_, _) -> (fun _ _ -> false)
         | Coq_type.Coq_list a2 ->
           Obj.magic list_beq_hetero0
             (interp_beq_hetero base_interp_beq_hetero a1 a2)
         | Coq_type.Coq_option _ -> (fun _ _ -> false)
         | Coq_type.Coq_unit -> (fun _ _ -> false))
      | Coq_type.Coq_option a1 ->
        (match t2 with
         | Coq_type.Coq_type_base _ -> (fun _ _ -> false)
         | Coq_type.Coq_prod (_, _) -> (fun _ _ -> false)
         | Coq_type.Coq_list _ -> (fun _ _ -> false)
         | Coq_type.Coq_option a2 ->
           Obj.magic option_beq_hetero0
             (interp_beq_hetero base_interp_beq_hetero a1 a2)
         | Coq_type.Coq_unit -> (fun _ _ -> false))
      | Coq_type.Coq_unit ->
        (match t2 with
         | Coq_type.Coq_type_base _ -> (fun _ _ -> false)
         | Coq_type.Coq_prod (_, _) -> (fun _ _ -> false)
         | Coq_type.Coq_list _ -> (fun _ _ -> false)
         | Coq_type.Coq_option _ -> (fun _ _ -> false)
         | Coq_type.Coq_unit -> (fun _ _ -> true))

    (** val try_make_transport_cps :
        'a1 Coq__2.try_make_transport_cpsT -> 'a1 Coq_type.coq_type -> 'a1
        Coq_type.coq_type -> (('a2 -> 'a2) option -> 'a3) -> 'a3 **)

    let rec try_make_transport_cps try_make_transport_base_type_cps t1 t2 x =
      (match t1 with
       | Coq_type.Coq_type_base t3 ->
         (match t2 with
          | Coq_type.Coq_type_base t4 ->
            (fun _ ->
              Coq__2.try_make_transport_cpsv try_make_transport_base_type_cps
                t3 t4)
          | Coq_type.Coq_prod (_, _) ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_list _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_option _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_unit ->
            cpsreturn (fun _ continuation -> continuation None))
       | Coq_type.Coq_prod (a, b) ->
         (match t2 with
          | Coq_type.Coq_type_base _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_prod (a', b') ->
            (fun _ ->
              cps_option_bind
                (Obj.magic (fun _ ->
                  try_make_transport_cps try_make_transport_base_type_cps a a'))
                (fun trA _ ->
                cps_option_bind
                  (Obj.magic (fun _ ->
                    try_make_transport_cps try_make_transport_base_type_cps b
                      b')) (fun trB ->
                  cpsreturn (fun _ continuation ->
                    continuation (Some (fun v -> trB (trA v)))))))
          | Coq_type.Coq_list _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_option _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_unit ->
            cpsreturn (fun _ continuation -> continuation None))
       | Coq_type.Coq_list a ->
         (match t2 with
          | Coq_type.Coq_type_base _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_prod (_, _) ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_list a' ->
            (fun _ ->
              try_make_transport_cps try_make_transport_base_type_cps a a')
          | Coq_type.Coq_option _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_unit ->
            cpsreturn (fun _ continuation -> continuation None))
       | Coq_type.Coq_option a ->
         (match t2 with
          | Coq_type.Coq_type_base _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_prod (_, _) ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_list _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_option a' ->
            (fun _ ->
              try_make_transport_cps try_make_transport_base_type_cps a a')
          | Coq_type.Coq_unit ->
            cpsreturn (fun _ continuation -> continuation None))
       | Coq_type.Coq_unit ->
         (match t2 with
          | Coq_type.Coq_type_base _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_prod (_, _) ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_list _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_option _ ->
            cpsreturn (fun _ continuation -> continuation None)
          | Coq_type.Coq_unit ->
            cpsreturn (fun _ continuation ->
              continuation (Some (fun x0 -> x0))))) __ x
   end
  module Coq__3 = Coq_base

  module Coq_pattern =
   struct
    module Coq_base =
     struct
      module Coq_type =
       struct
        type 'base_type coq_type =
        | Coq_var of positive
        | Coq_type_base of 'base_type
        | Coq_prod of 'base_type coq_type * 'base_type coq_type
        | Coq_list of 'base_type coq_type
        | Coq_option of 'base_type coq_type
        | Coq_unit

        (** val internal_positive_beq : positive -> positive -> bool **)

        let rec internal_positive_beq x y =
          match x with
          | XI x0 ->
            (match y with
             | XI x1 -> internal_positive_beq x0 x1
             | XO _ -> false
             | XH -> false)
          | XO x0 ->
            (match y with
             | XI _ -> false
             | XO x1 -> internal_positive_beq x0 x1
             | XH -> false)
          | XH -> (match y with
                   | XI _ -> false
                   | XO _ -> false
                   | XH -> true)

        (** val type_beq :
            ('a1 -> 'a1 -> bool) -> 'a1 coq_type -> 'a1 coq_type -> bool **)

        let type_beq eq_base_type =
          let rec type_eqrec x y =
            match x with
            | Coq_var p ->
              (match y with
               | Coq_var p0 -> internal_positive_beq p p0
               | Coq_type_base _ -> false
               | Coq_prod (_, _) -> false
               | Coq_list _ -> false
               | Coq_option _ -> false
               | Coq_unit -> false)
            | Coq_type_base t0 ->
              (match y with
               | Coq_var _ -> false
               | Coq_type_base t1 -> eq_base_type t0 t1
               | Coq_prod (_, _) -> false
               | Coq_list _ -> false
               | Coq_option _ -> false
               | Coq_unit -> false)
            | Coq_prod (a, b) ->
              (match y with
               | Coq_var _ -> false
               | Coq_type_base _ -> false
               | Coq_prod (a0, b0) -> (&&) (type_eqrec a a0) (type_eqrec b b0)
               | Coq_list _ -> false
               | Coq_option _ -> false
               | Coq_unit -> false)
            | Coq_list a ->
              (match y with
               | Coq_var _ -> false
               | Coq_type_base _ -> false
               | Coq_prod (_, _) -> false
               | Coq_list a0 -> type_eqrec a a0
               | Coq_option _ -> false
               | Coq_unit -> false)
            | Coq_option a ->
              (match y with
               | Coq_var _ -> false
               | Coq_type_base _ -> false
               | Coq_prod (_, _) -> false
               | Coq_list _ -> false
               | Coq_option a0 -> type_eqrec a a0
               | Coq_unit -> false)
            | Coq_unit ->
              (match y with
               | Coq_var _ -> false
               | Coq_type_base _ -> false
               | Coq_prod (_, _) -> false
               | Coq_list _ -> false
               | Coq_option _ -> false
               | Coq_unit -> true)
          in type_eqrec
       end
     end
   end

  module Coq_expr =
   struct
    type ('base_type, 'ident, 'var) expr =
    | Ident of 'base_type Coq_type.coq_type * 'ident
    | Var of 'base_type Coq_type.coq_type * 'var
    | Abs of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
       * ('var -> ('base_type, 'ident, 'var) expr)
    | App of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
       * ('base_type, 'ident, 'var) expr * ('base_type, 'ident, 'var) expr
    | LetIn of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
       * ('base_type, 'ident, 'var) expr
       * ('var -> ('base_type, 'ident, 'var) expr)

    type ('base_type, 'ident) coq_Expr = __ -> ('base_type, 'ident, __) expr

    (** val coq_APP :
        'a1 Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2) coq_Expr
        -> ('a1, 'a2) coq_Expr -> ('a1, 'a2, __) expr **)

    let coq_APP s0 d f x =
      App (s0, d, (f __), (x __))
   end

  module Coq_ident =
   struct
    type ('base, 'base_interp, 'ident) coq_BuildIdentT = { ident_Literal : 
                                                           ('base ->
                                                           'base_interp ->
                                                           'ident);
                                                           ident_nil : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_cons : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_Some : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_None : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_pair : 
                                                           ('base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'base
                                                           Coq_base.Coq_type.coq_type
                                                           -> 'ident);
                                                           ident_tt : 
                                                           'ident }

    (** val ident_Literal :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 -> 'a2 -> 'a3 **)

    let ident_Literal buildIdentT =
      buildIdentT.ident_Literal

    (** val ident_nil :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        'a3 **)

    let ident_nil buildIdentT =
      buildIdentT.ident_nil

    (** val ident_cons :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        'a3 **)

    let ident_cons buildIdentT =
      buildIdentT.ident_cons

    (** val ident_Some :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        'a3 **)

    let ident_Some buildIdentT =
      buildIdentT.ident_Some

    (** val ident_None :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        'a3 **)

    let ident_None buildIdentT =
      buildIdentT.ident_None

    (** val ident_pair :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        'a1 Coq_base.Coq_type.coq_type -> 'a3 **)

    let ident_pair buildIdentT =
      buildIdentT.ident_pair

    (** val ident_tt : ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a3 **)

    let ident_tt buildIdentT =
      buildIdentT.ident_tt

    (** val reify_list :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr **)

    let reify_list buildIdent0 t0 ls =
      let rec f = function
      | [] ->
        Coq_expr.Ident ((Coq_type.Coq_base (Coq_base.Coq_type.Coq_list t0)),
          (buildIdent0.ident_nil t0))
      | y :: l0 ->
        Coq_expr.App ((Coq_type.Coq_base (Coq_base.Coq_type.Coq_list t0)),
          (Coq_type.Coq_base (Coq_base.Coq_type.Coq_list t0)), (Coq_expr.App
          ((Coq_type.Coq_base t0), (Coq_type.Coq_arrow ((Coq_type.Coq_base
          (Coq_base.Coq_type.Coq_list t0)), (Coq_type.Coq_base
          (Coq_base.Coq_type.Coq_list t0)))), (Coq_expr.Ident
          ((Coq_type.Coq_arrow ((Coq_type.Coq_base t0), (Coq_type.Coq_arrow
          ((Coq_type.Coq_base (Coq_base.Coq_type.Coq_list t0)),
          (Coq_type.Coq_base (Coq_base.Coq_type.Coq_list t0)))))),
          (buildIdent0.ident_cons t0))), y)), (f l0))
      in f ls

    (** val reify_option :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr option ->
        ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr **)

    let reify_option buildIdent0 t0 = function
    | Some a ->
      Coq_expr.App ((Coq_type.Coq_base t0), (Coq_type.Coq_base
        (Coq_base.Coq_type.Coq_option t0)), (Coq_expr.Ident
        ((Coq_type.Coq_arrow ((Coq_type.Coq_base t0), (Coq_type.Coq_base
        (Coq_base.Coq_type.Coq_option t0)))), (buildIdent0.ident_Some t0))),
        a)
    | None ->
      Coq_expr.Ident ((Coq_type.Coq_base (Coq_base.Coq_type.Coq_option t0)),
        (buildIdent0.ident_None t0))

    (** val smart_Literal :
        ('a1, 'a2, 'a3) coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        ('a1, 'a2) Coq_base.interp -> ('a1 Coq_base.Coq_type.coq_type, 'a3,
        'a4) Coq_expr.expr **)

    let smart_Literal buildIdent0 =
      let rec smart_Literal0 = function
      | Coq_base.Coq_type.Coq_type_base t1 ->
        (fun v -> Coq_expr.Ident ((Coq_type.Coq_base
          (Coq_base.Coq_type.Coq_type_base t1)),
          ((Obj.magic buildIdent0).ident_Literal t1 v)))
      | Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun pat ->
          let (a0, b0) = Obj.magic pat in
          Coq_expr.App ((Coq_type.Coq_base b), (Coq_type.Coq_base
          (Coq_base.Coq_type.Coq_prod (a, b))), (Coq_expr.App
          ((Coq_type.Coq_base a), (Coq_type.Coq_arrow ((Coq_type.Coq_base b),
          (Coq_type.Coq_base (Coq_base.Coq_type.Coq_prod (a, b))))),
          (Coq_expr.Ident ((Coq_type.Coq_arrow ((Coq_type.Coq_base a),
          (Coq_type.Coq_arrow ((Coq_type.Coq_base b), (Coq_type.Coq_base
          (Coq_base.Coq_type.Coq_prod (a, b))))))),
          (buildIdent0.ident_pair a b))), (smart_Literal0 a a0))),
          (smart_Literal0 b b0)))
      | Coq_base.Coq_type.Coq_list a ->
        (fun v ->
          reify_list buildIdent0 a (map (smart_Literal0 a) (Obj.magic v)))
      | Coq_base.Coq_type.Coq_option a ->
        (fun v ->
          reify_option buildIdent0 a
            (option_map (smart_Literal0 a) (Obj.magic v)))
      | Coq_base.Coq_type.Coq_unit ->
        (fun _ -> Coq_expr.Ident ((Coq_type.Coq_base
          Coq_base.Coq_type.Coq_unit), buildIdent0.ident_tt))
      in smart_Literal0

    type 'base restricted_ident =
    | Coq_restricted_ident_nat_rect of 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_nat_rect_arrow of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_list_rect of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_list_rect_arrow of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_List_nth_default of 'base
                                               Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_nat_rect of 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_nat_rect_arrow of 'base
                                                   Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_list_rect of 'base Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_list_rect_arrow of 'base
                                                    Coq_base.Coq_type.coq_type
       * 'base Coq_base.Coq_type.coq_type * 'base Coq_base.Coq_type.coq_type
    | Coq_restricted_ident_eager_List_nth_default of 'base
                                                     Coq_base.Coq_type.coq_type

    type ('base, 'ident) coq_BuildEagerIdentT = { ident_nat_rect : ('base
                                                                   Coq_base.Coq_type.coq_type
                                                                   -> 'ident);
                                                  ident_nat_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_list_rect : ('base
                                                                    Coq_base.Coq_type.coq_type
                                                                    -> 'base
                                                                    Coq_base.Coq_type.coq_type
                                                                    -> 'ident);
                                                  ident_list_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_List_nth_default : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_nat_rect : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_nat_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_list_rect : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_list_rect_arrow : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident);
                                                  ident_eager_List_nth_default : 
                                                  ('base
                                                  Coq_base.Coq_type.coq_type
                                                  -> 'ident) }

    (** val ident_nat_rect :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_nat_rect _ buildEagerIdentT =
      buildEagerIdentT.ident_nat_rect

    (** val ident_nat_rect_arrow :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
        Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_nat_rect_arrow _ buildEagerIdentT =
      buildEagerIdentT.ident_nat_rect_arrow

    (** val ident_list_rect :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
        Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_list_rect _ buildEagerIdentT =
      buildEagerIdentT.ident_list_rect

    (** val ident_list_rect_arrow :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
        Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_list_rect_arrow _ buildEagerIdentT =
      buildEagerIdentT.ident_list_rect_arrow

    (** val ident_List_nth_default :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_List_nth_default _ buildEagerIdentT =
      buildEagerIdentT.ident_List_nth_default

    (** val ident_eager_nat_rect :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_eager_nat_rect _ buildEagerIdentT =
      buildEagerIdentT.ident_eager_nat_rect

    (** val ident_eager_nat_rect_arrow :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
        Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_eager_nat_rect_arrow _ buildEagerIdentT =
      buildEagerIdentT.ident_eager_nat_rect_arrow

    (** val ident_eager_list_rect :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
        Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_eager_list_rect _ buildEagerIdentT =
      buildEagerIdentT.ident_eager_list_rect

    (** val ident_eager_list_rect_arrow :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
        Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_eager_list_rect_arrow _ buildEagerIdentT =
      buildEagerIdentT.ident_eager_list_rect_arrow

    (** val ident_eager_List_nth_default :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a2 **)

    let ident_eager_List_nth_default _ buildEagerIdentT =
      buildEagerIdentT.ident_eager_List_nth_default

    (** val fromRestrictedIdent :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a1 restricted_ident -> 'a2 **)

    let fromRestrictedIdent _ buildEagerIdent0 _ = function
    | Coq_restricted_ident_nat_rect p -> buildEagerIdent0.ident_nat_rect p
    | Coq_restricted_ident_nat_rect_arrow (p, q0) ->
      buildEagerIdent0.ident_nat_rect_arrow p q0
    | Coq_restricted_ident_list_rect (a, p) ->
      buildEagerIdent0.ident_list_rect a p
    | Coq_restricted_ident_list_rect_arrow (a, p, q0) ->
      buildEagerIdent0.ident_list_rect_arrow a p q0
    | Coq_restricted_ident_List_nth_default t0 ->
      buildEagerIdent0.ident_List_nth_default t0
    | Coq_restricted_ident_eager_nat_rect p ->
      buildEagerIdent0.ident_eager_nat_rect p
    | Coq_restricted_ident_eager_nat_rect_arrow (p, q0) ->
      buildEagerIdent0.ident_eager_nat_rect_arrow p q0
    | Coq_restricted_ident_eager_list_rect (a, p) ->
      buildEagerIdent0.ident_eager_list_rect a p
    | Coq_restricted_ident_eager_list_rect_arrow (a, p, q0) ->
      buildEagerIdent0.ident_eager_list_rect_arrow a p q0
    | Coq_restricted_ident_eager_List_nth_default t0 ->
      buildEagerIdent0.ident_eager_List_nth_default t0

    type ('base, 'ident) coq_ToRestrictedIdentT =
      'base Coq_base.Coq_type.coq_type Coq_type.coq_type -> 'ident -> 'base
      restricted_ident option

    (** val eager_ident_rect :
        'a1 Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a2)
        coq_BuildEagerIdentT -> ('a1, 'a2) coq_ToRestrictedIdentT -> ('a1
        Coq_base.Coq_type.coq_type -> 'a3) -> ('a1 Coq_base.Coq_type.coq_type
        -> 'a1 Coq_base.Coq_type.coq_type -> 'a3) -> ('a1
        Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type -> 'a3)
        -> ('a1 Coq_base.Coq_type.coq_type -> 'a1 Coq_base.Coq_type.coq_type
        -> 'a1 Coq_base.Coq_type.coq_type -> 'a3) -> ('a1
        Coq_base.Coq_type.coq_type -> 'a3) -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a2 -> 'a3 option **)

    let eager_ident_rect _ _ toRestrictedIdent0 eager_nat_rect_f eager_nat_rect_arrow_f eager_list_rect_f eager_list_rect_arrow_f eager_List_nth_default_f t0 idc =
      (match toRestrictedIdent0 t0 idc with
       | Some _ -> (fun v -> v)
       | None -> (fun v -> v))
        (match toRestrictedIdent0 t0 idc with
         | Some idc' ->
           (match idc' with
            | Coq_restricted_ident_nat_rect _ -> None
            | Coq_restricted_ident_nat_rect_arrow (_, _) -> None
            | Coq_restricted_ident_list_rect (_, _) -> None
            | Coq_restricted_ident_list_rect_arrow (_, _, _) -> None
            | Coq_restricted_ident_List_nth_default _ -> None
            | Coq_restricted_ident_eager_nat_rect p ->
              Some (eager_nat_rect_f p)
            | Coq_restricted_ident_eager_nat_rect_arrow (p, q0) ->
              Some (eager_nat_rect_arrow_f p q0)
            | Coq_restricted_ident_eager_list_rect (a, p) ->
              Some (eager_list_rect_f a p)
            | Coq_restricted_ident_eager_list_rect_arrow (a, p, q0) ->
              Some (eager_list_rect_arrow_f a p q0)
            | Coq_restricted_ident_eager_List_nth_default t1 ->
              Some (eager_List_nth_default_f t1))
         | None -> None)
   end

  module Coq_invert_expr =
   struct
    (** val invert_Ident :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a2 option **)

    let invert_Ident _ = function
    | Coq_expr.Ident (_, idc) -> Some idc
    | Coq_expr.Var (_, _) -> None
    | Coq_expr.Abs (_, _, _) -> None
    | Coq_expr.App (_, _, _, _) -> None
    | Coq_expr.LetIn (_, _, _, _) -> None

    (** val invert_App_cps :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
        Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Coq_expr.expr -> 'a4) -> ('a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Coq_expr.expr -> 'a5) -> ('a1 Coq_type.coq_type, 'a4 * 'a5) sigT
        option **)

    let invert_App_cps _ e f1 f2 =
      match e with
      | Coq_expr.Ident (_, _) -> None
      | Coq_expr.Var (_, _) -> None
      | Coq_expr.Abs (_, _, _) -> None
      | Coq_expr.App (a, b, f, x) -> Some (ExistT (a, ((f1 a b f), (f2 a x))))
      | Coq_expr.LetIn (_, _, _, _) -> None

    (** val invert_App :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
        Coq_type.coq_type, ('a1, 'a2, 'a3) Coq_expr.expr * ('a1, 'a2, 'a3)
        Coq_expr.expr) sigT option **)

    let invert_App t0 e =
      invert_App_cps t0 e (fun _ _ x -> x) (fun _ x -> x)

    (** val invert_Abs :
        'a1 Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Coq_expr.expr -> ('a3 -> ('a1, 'a2, 'a3) Coq_expr.expr) option **)

    let invert_Abs _ _ = function
    | Coq_expr.Ident (_, _) -> None
    | Coq_expr.Var (_, _) -> None
    | Coq_expr.Abs (_, _, f) -> Some f
    | Coq_expr.App (_, _, _, _) -> None
    | Coq_expr.LetIn (_, _, _, _) -> None

    (** val invert_App2_cps :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
        Coq_type.coq_type -> 'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Coq_expr.expr -> 'a4) -> ('a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Coq_expr.expr -> 'a5) -> ('a1 Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Coq_expr.expr -> 'a6) -> ('a1 Coq_type.coq_type * 'a1
        Coq_type.coq_type, ('a4 * 'a5) * 'a6) sigT option **)

    let invert_App2_cps t0 e f1 f2 f3 =
      bind1
        (invert_App_cps t0 e (fun s0 d f ->
          invert_App_cps (Coq_type.Coq_arrow (s0, d)) f f1 f2) f3) (fun v1 ->
        let ExistT (s0, p) = v1 in
        let (v2, r0) = p in
        bind1 v2 (fun v3 ->
          let ExistT (s', p0) = v3 in
          let (p1, q0) = p0 in Some (ExistT ((s', s0), ((p1, q0), r0)))))

    (** val invert_AppIdent_cps :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
        Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a4) -> ('a1
        Coq_type.coq_type, 'a2 * 'a4) sigT option **)

    let invert_AppIdent_cps t0 e f =
      bind1 (invert_App_cps t0 e (fun _ _ f0 -> f0) f) (fun e0 ->
        let ExistT (s0, p) = e0 in
        let (f0, x) = p in
        bind1 (invert_Ident (Coq_type.Coq_arrow (s0, t0)) f0) (fun f' -> Some
          (ExistT (s0, (f', x)))))

    (** val invert_AppIdent :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
        Coq_type.coq_type, 'a2 * ('a1, 'a2, 'a3) Coq_expr.expr) sigT option **)

    let invert_AppIdent t0 e =
      invert_AppIdent_cps t0 e (fun _ x -> x)

    (** val invert_AppIdent2_cps :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
        Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a4) -> ('a1
        Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a5) -> ('a1
        Coq_type.coq_type * 'a1 Coq_type.coq_type, ('a2 * 'a4) * 'a5) sigT
        option **)

    let invert_AppIdent2_cps t0 e f1 f2 =
      bind1 (invert_App2_cps t0 e (fun _ _ x -> x) f1 f2) (fun e0 ->
        let ExistT (ss', p) = e0 in
        let (p0, x') = p in
        let (f, x) = p0 in
        bind1
          (invert_Ident (Coq_type.Coq_arrow ((fst ss'), (Coq_type.Coq_arrow
            ((snd ss'), t0)))) f) (fun f' -> Some (ExistT (ss', ((f', x),
          x')))))

    (** val invert_Var :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> 'a3 option **)

    let invert_Var _ = function
    | Coq_expr.Ident (_, _) -> None
    | Coq_expr.Var (_, v) -> Some v
    | Coq_expr.Abs (_, _, _) -> None
    | Coq_expr.App (_, _, _, _) -> None
    | Coq_expr.LetIn (_, _, _, _) -> None

    (** val coq_App_curried :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1, ('a1,
        'a2, 'a3) Coq_expr.expr) Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2,
        'a3) Coq_expr.expr **)

    let coq_App_curried t0 =
      let rec app_curried0 = function
      | Coq_type.Coq_base _ -> (fun e _ -> e)
      | Coq_type.Coq_arrow (s0, d) ->
        (fun e x ->
          app_curried0 d (Coq_expr.App (s0, d, e, (fst (Obj.magic x))))
            (snd (Obj.magic x)))
      in app_curried0 t0

    (** val smart_App_curried :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1, 'a3)
        Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3) Coq_expr.expr **)

    let smart_App_curried t0 =
      let rec smart_App_curried0 _ = function
      | Coq_expr.Ident (t1, idc) ->
        (fun v ->
          coq_App_curried t1 (Coq_expr.Ident (t1, idc))
            (Coq_type.map_for_each_lhs_of_arrow (fun t2 v0 -> Coq_expr.Var
              (t2, v0)) t1 v))
      | Coq_expr.Var (t1, v) ->
        (fun v0 ->
          coq_App_curried t1 (Coq_expr.Var (t1, v))
            (Coq_type.map_for_each_lhs_of_arrow (fun t2 v1 -> Coq_expr.Var
              (t2, v1)) t1 v0))
      | Coq_expr.Abs (_, d, f) ->
        (fun v ->
          smart_App_curried0 d (f (fst (Obj.magic v))) (snd (Obj.magic v)))
      | Coq_expr.App (s0, d, f, x) ->
        (fun v ->
          coq_App_curried d (Coq_expr.App (s0, d, f, x))
            (Coq_type.map_for_each_lhs_of_arrow (fun t1 v0 -> Coq_expr.Var
              (t1, v0)) d v))
      | Coq_expr.LetIn (a, b, x, f) ->
        (fun v ->
          coq_App_curried b (Coq_expr.LetIn (a, b, x, f))
            (Coq_type.map_for_each_lhs_of_arrow (fun t1 v0 -> Coq_expr.Var
              (t1, v0)) b v))
      in smart_App_curried0 t0

    (** val invert_App_curried :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1, ('a1,
        'a2, 'a3) Coq_expr.expr) Coq_type.for_each_lhs_of_arrow -> ('a1
        Coq_type.coq_type, ('a1, 'a2, 'a3) Coq_expr.expr * ('a1, ('a1, 'a2,
        'a3) Coq_expr.expr) Coq_type.for_each_lhs_of_arrow) sigT **)

    let invert_App_curried t0 =
      let rec invert_App_curried0 _ = function
      | Coq_expr.Ident (t1, idc) ->
        (fun args0 -> ExistT (t1, ((Coq_expr.Ident (t1, idc)), args0)))
      | Coq_expr.Var (t1, v) ->
        (fun args0 -> ExistT (t1, ((Coq_expr.Var (t1, v)), args0)))
      | Coq_expr.Abs (s0, d, f) ->
        (fun args0 -> ExistT ((Coq_type.Coq_arrow (s0, d)), ((Coq_expr.Abs
          (s0, d, f)), args0)))
      | Coq_expr.App (s0, d, f, x) ->
        (fun args0 ->
          Obj.magic invert_App_curried0 (Coq_type.Coq_arrow (s0, d)) f (x,
            args0))
      | Coq_expr.LetIn (a, b, x, f) ->
        (fun args0 -> ExistT (b, ((Coq_expr.LetIn (a, b, x, f)), args0)))
      in invert_App_curried0 t0

    (** val invert_AppIdent_curried :
        'a1 Coq_type.coq_type -> ('a1, 'a2, 'a3) Coq_expr.expr -> ('a1
        Coq_type.coq_type, 'a2 * ('a1, ('a1, 'a2, 'a3) Coq_expr.expr)
        Coq_type.for_each_lhs_of_arrow) sigT option **)

    let invert_AppIdent_curried t0 e =
      (match t0 with
       | Coq_type.Coq_base t1 ->
         (fun e0 ->
           let ExistT (t2, p) =
             invert_App_curried (Coq_type.Coq_base t1) e0 (Obj.magic ())
           in
           let (f, args0) = p in
           bind1 (invert_Ident t2 f) (fun idc -> Some (ExistT (t2, (idc,
             args0)))))
       | Coq_type.Coq_arrow (_, _) -> (fun _ -> None)) e

    type ('base, 'base_interp, 'ident) coq_InvertIdentT = { invert_ident_Literal : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident ->
                                                            ('base
                                                            Coq_base.Coq_type.coq_type,
                                                            ('base,
                                                            'base_interp)
                                                            Coq_base.interp)
                                                            Coq_type.interp
                                                            option);
                                                            is_nil : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_cons : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_Some : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_None : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_pair : 
                                                            ('base
                                                            Coq_base.Coq_type.coq_type
                                                            Coq_type.coq_type
                                                            -> 'ident -> bool);
                                                            is_tt : ('base
                                                                    Coq_base.Coq_type.coq_type
                                                                    Coq_type.coq_type
                                                                    -> 'ident
                                                                    -> bool) }

    (** val invert_ident_Literal :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a3 -> ('a1 Coq_base.Coq_type.coq_type, ('a1,
        'a2) Coq_base.interp) Coq_type.interp option **)

    let invert_ident_Literal invertIdentT =
      invertIdentT.invert_ident_Literal

    (** val is_nil :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a3 -> bool **)

    let is_nil invertIdentT =
      invertIdentT.is_nil

    (** val is_cons :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a3 -> bool **)

    let is_cons invertIdentT =
      invertIdentT.is_cons

    (** val is_Some :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a3 -> bool **)

    let is_Some invertIdentT =
      invertIdentT.is_Some

    (** val is_None :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a3 -> bool **)

    let is_None invertIdentT =
      invertIdentT.is_None

    (** val is_pair :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a3 -> bool **)

    let is_pair invertIdentT =
      invertIdentT.is_pair

    (** val is_tt :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> 'a3 -> bool **)

    let is_tt invertIdentT =
      invertIdentT.is_tt

    (** val reflect_list_cps' :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type Coq_type.coq_type
        -> ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> (('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list option ->
        'a5) -> 'a5 **)

    let reflect_list_cps' try_make_transport_base_type_cps invertIdent0 t0 e x =
      let rec reflect_list_cps'0 _ = function
      | Coq_expr.Ident (t1, maybe_nil) ->
        if invertIdent0.is_nil t1 maybe_nil
        then cpsreturn (fun _ continuation -> continuation (Some []))
        else cpsreturn (fun _ continuation -> continuation None)
      | Coq_expr.Var (_, _) ->
        cpsreturn (fun _ continuation -> continuation None)
      | Coq_expr.Abs (_, _, _) ->
        cpsreturn (fun _ continuation -> continuation None)
      | Coq_expr.App (s0, d, f, xs) ->
        (match f with
         | Coq_expr.Ident (_, _) ->
           cpsreturn (fun _ continuation -> continuation None)
         | Coq_expr.Var (_, _) ->
           cpsreturn (fun _ continuation -> continuation None)
         | Coq_expr.Abs (_, _, _) ->
           cpsreturn (fun _ continuation -> continuation None)
         | Coq_expr.App (s1, _, f0, x0) ->
           (match f0 with
            | Coq_expr.Ident (t1, maybe_cons) ->
              if invertIdent0.is_cons t1 maybe_cons
              then (fun _ ->
                     cps_option_bind (fun _ ->
                       Coq_type.try_transport_cps (fun _ x1 x2 _ ->
                         Coq_base.try_make_transport_cps
                           try_make_transport_base_type_cps x1 x2) s1
                         (Coq_type.Coq_base
                         (match d with
                          | Coq_type.Coq_base t2 ->
                            (match t2 with
                             | Coq_base.Coq_type.Coq_type_base _ ->
                               Coq_base.Coq_type.Coq_unit
                             | Coq_base.Coq_type.Coq_prod (_, _) ->
                               Coq_base.Coq_type.Coq_unit
                             | Coq_base.Coq_type.Coq_list t3 -> t3
                             | Coq_base.Coq_type.Coq_option _ ->
                               Coq_base.Coq_type.Coq_unit
                             | Coq_base.Coq_type.Coq_unit ->
                               Coq_base.Coq_type.Coq_unit)
                          | Coq_type.Coq_arrow (_, _) ->
                            Coq_base.Coq_type.Coq_unit)) x0) (fun x' _ ->
                       cps_option_bind (Obj.magic reflect_list_cps'0 s0 xs)
                         (fun xs' _ ->
                         cps_option_bind (fun _ ->
                           Coq_type.try_transport_cps (fun _ x1 x2 _ ->
                             Coq_base.try_make_transport_cps
                               try_make_transport_base_type_cps x1 x2) s0 d
                             xs') (fun xs'0 ->
                           cpsreturn (fun _ continuation ->
                             continuation (Some (x' :: xs'0)))))))
              else cpsreturn (fun _ continuation -> continuation None)
            | Coq_expr.Var (_, _) ->
              cpsreturn (fun _ continuation -> continuation None)
            | Coq_expr.Abs (_, _, _) ->
              cpsreturn (fun _ continuation -> continuation None)
            | Coq_expr.App (_, _, _, _) ->
              cpsreturn (fun _ continuation -> continuation None)
            | Coq_expr.LetIn (_, _, _, _) ->
              cpsreturn (fun _ continuation -> continuation None))
         | Coq_expr.LetIn (_, _, _, _) ->
           cpsreturn (fun _ continuation -> continuation None))
      | Coq_expr.LetIn (_, _, _, _) ->
        cpsreturn (fun _ continuation -> continuation None)
      in reflect_list_cps'0 t0 e __ x

    (** val reflect_list_cps :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> (('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list option ->
        'a5) -> 'a5 **)

    let reflect_list_cps try_make_transport_base_type_cps invertIdent0 t0 e x =
      reflect_list_cps' try_make_transport_base_type_cps invertIdent0
        (Coq_type.Coq_base (Coq_base.Coq_type.Coq_list t0)) e x

    (** val reflect_list :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr list option **)

    let reflect_list try_make_transport_base_type_cps invertIdent0 t0 e =
      reflect_list_cps try_make_transport_base_type_cps invertIdent0 t0 e
        (Obj.magic id)

    (** val invert_pair_cps :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type Coq_type.coq_type
        -> ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
        Coq_base.Coq_type.coq_type Coq_type.coq_type -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> 'a5) -> ('a1
        Coq_base.Coq_type.coq_type Coq_type.coq_type -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> 'a6) ->
        ('a5 * 'a6) option **)

    let invert_pair_cps try_make_transport_base_type_cps invertIdent0 t0 e f1 f2 =
      let base' = fun _ x -> Coq_type.Coq_base x in
      let a =
        match t0 with
        | Coq_type.Coq_base t1 ->
          (match t1 with
           | Coq_base.Coq_type.Coq_type_base _ -> t0
           | Coq_base.Coq_type.Coq_prod (a, _) -> base' __ a
           | Coq_base.Coq_type.Coq_list _ -> t0
           | Coq_base.Coq_type.Coq_option _ -> t0
           | Coq_base.Coq_type.Coq_unit -> t0)
        | Coq_type.Coq_arrow (_, _) -> t0
      in
      let b =
        match t0 with
        | Coq_type.Coq_base t1 ->
          (match t1 with
           | Coq_base.Coq_type.Coq_type_base _ -> t0
           | Coq_base.Coq_type.Coq_prod (_, b) -> base' __ b
           | Coq_base.Coq_type.Coq_list _ -> t0
           | Coq_base.Coq_type.Coq_option _ -> t0
           | Coq_base.Coq_type.Coq_unit -> t0)
        | Coq_type.Coq_arrow (_, _) -> t0
      in
      bind1 (invert_AppIdent2_cps t0 e f1 f2) (fun v ->
        let ExistT (x, p) = v in
        let (p0, b0) = p in
        let (maybe_pair, a0) = p0 in
        if invertIdent0.is_pair (Coq_type.Coq_arrow ((fst x),
             (Coq_type.Coq_arrow ((snd x), t0)))) maybe_pair
        then bind1
               (Coq_type.try_transport (fun _ x0 x1 _ ->
                 Coq_base.try_make_transport_cps
                   try_make_transport_base_type_cps x0 x1) (fst x) a a0)
               (fun a1 ->
               bind1
                 (Coq_type.try_transport (fun _ x0 x1 _ ->
                   Coq_base.try_make_transport_cps
                     try_make_transport_base_type_cps x0 x1) (snd x) b b0)
                 (fun b1 -> Some (a1, b1)))
        else None)

    (** val invert_pair :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> 'a1
        Coq_base.Coq_type.coq_type -> ('a1 Coq_base.Coq_type.coq_type, 'a3,
        'a4) Coq_expr.expr -> (('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4)
        Coq_expr.expr * ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4)
        Coq_expr.expr) option **)

    let invert_pair try_make_transport_base_type_cps invertIdent0 =
      let base' = fun _ x -> Coq_type.Coq_base x in
      (fun a b e ->
      invert_pair_cps try_make_transport_base_type_cps invertIdent0
        (base' __ (Coq_base.Coq_type.Coq_prod (a, b))) e (fun _ x -> x)
        (fun _ x -> x))

    (** val invert_Literal :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type
        Coq_type.coq_type -> ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4)
        Coq_expr.expr -> ('a1 Coq_base.Coq_type.coq_type, ('a1, 'a2)
        Coq_base.interp) Coq_type.interp option **)

    let invert_Literal invertIdent0 _ = function
    | Coq_expr.Ident (t0, idc) -> invertIdent0.invert_ident_Literal t0 idc
    | Coq_expr.Var (_, _) -> None
    | Coq_expr.Abs (_, _, _) -> None
    | Coq_expr.App (_, _, _, _) -> None
    | Coq_expr.LetIn (_, _, _, _) -> None

    (** val invert_None :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
        ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> bool **)

    let invert_None invertIdent0 =
      let base' = fun _ x -> Coq_type.Coq_base x in
      (fun t0 e ->
      match invert_Ident (base' __ (Coq_base.Coq_type.Coq_option t0)) e with
      | Some maybe_None ->
        invertIdent0.is_None (base' __ (Coq_base.Coq_type.Coq_option t0))
          maybe_None
      | None -> false)

    (** val invert_Some :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr option **)

    let invert_Some try_make_transport_base_type_cps invertIdent0 =
      let base' = fun _ x -> Coq_type.Coq_base x in
      (fun t0 e ->
      match e with
      | Coq_expr.Ident (_, _) -> None
      | Coq_expr.Var (_, _) -> None
      | Coq_expr.Abs (_, _, _) -> None
      | Coq_expr.App (s0, _, f, v) ->
        (match f with
         | Coq_expr.Ident (t1, maybe_Some) ->
           if invertIdent0.is_Some t1 maybe_Some
           then Coq_type.try_transport (fun _ x x0 _ ->
                  Coq_base.try_make_transport_cps
                    try_make_transport_base_type_cps x x0) s0 (base' __ t0) v
           else None
         | Coq_expr.Var (_, _) -> None
         | Coq_expr.Abs (_, _, _) -> None
         | Coq_expr.App (_, _, _, _) -> None
         | Coq_expr.LetIn (_, _, _, _) -> None)
      | Coq_expr.LetIn (_, _, _, _) -> None)

    (** val invert_tt :
        ('a1, 'a2, 'a3) coq_InvertIdentT -> ('a1 Coq_base.Coq_type.coq_type,
        'a3, 'a4) Coq_expr.expr -> bool **)

    let invert_tt invertIdent0 =
      let base' = fun _ x -> Coq_type.Coq_base x in
      (fun e ->
      match invert_Ident (base' __ Coq_base.Coq_type.Coq_unit) e with
      | Some maybe_tt ->
        invertIdent0.is_tt (base' __ Coq_base.Coq_type.Coq_unit) maybe_tt
      | None -> false)

    (** val reflect_option :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr option option **)

    let reflect_option try_make_transport_base_type_cps invertIdent0 t0 e =
      if invert_None invertIdent0 t0 e
      then Some None
      else (match invert_Some try_make_transport_base_type_cps invertIdent0
                    t0 e with
            | Some x -> Some (Some x)
            | None -> None)

    (** val reflect_smart_Literal :
        'a1 Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        coq_InvertIdentT -> 'a1 Coq_base.Coq_type.coq_type -> ('a1
        Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr -> ('a1, 'a2)
        Coq_base.interp option **)

    let reflect_smart_Literal try_make_transport_base_type_cps invertIdent0 =
      let base' = fun _ x -> Coq_type.Coq_base x in
      let rec reflect_smart_Literal0 = function
      | Coq_base.Coq_type.Coq_type_base t1 ->
        invert_Literal invertIdent0
          (base' __ (Coq_base.Coq_type.Coq_type_base t1))
      | Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun e ->
          bind1
            (invert_pair try_make_transport_base_type_cps invertIdent0 a b e)
            (fun ab ->
            bind1 (reflect_smart_Literal0 a (fst ab)) (fun a0 ->
              bind1 (reflect_smart_Literal0 b (snd ab)) (fun b0 -> Some
                (Obj.magic (a0, b0))))))
      | Coq_base.Coq_type.Coq_list a ->
        (fun e ->
          bind1
            (reflect_list try_make_transport_base_type_cps invertIdent0 a e)
            (fun e0 ->
            Obj.magic Coq_Option.List.lift (map (reflect_smart_Literal0 a) e0)))
      | Coq_base.Coq_type.Coq_option a ->
        (fun e ->
          bind1
            (reflect_option try_make_transport_base_type_cps invertIdent0 a e)
            (fun e0 ->
            match e0 with
            | Some e1 ->
              option_map (Obj.magic (fun x -> Some x))
                (reflect_smart_Literal0 a e1)
            | None -> Some (Obj.magic None)))
      | Coq_base.Coq_type.Coq_unit ->
        (fun e ->
          if invert_tt invertIdent0 e then Some (Obj.magic ()) else None)
      in reflect_smart_Literal0
   end

  module DefaultValue =
   struct
    module Coq_type =
     struct
      module Coq_base =
       struct
        type ('base, 'base_interp) coq_DefaultT = 'base -> 'base_interp

        (** val defaultv : ('a1, 'a2) coq_DefaultT -> 'a1 -> 'a2 **)

        let defaultv defaultT =
          defaultT

        (** val default :
            ('a1, 'a2) coq_DefaultT -> 'a1 Coq_base.Coq_type.coq_type ->
            ('a1, 'a2) Coq_base.interp **)

        let default baseDefault =
          let rec default0 = function
          | Coq_base.Coq_type.Coq_type_base t1 ->
            defaultv (Obj.magic baseDefault) t1
          | Coq_base.Coq_type.Coq_prod (a, b) ->
            Obj.magic ((default0 a), (default0 b))
          | Coq_base.Coq_type.Coq_list _ -> Obj.magic []
          | Coq_base.Coq_type.Coq_option _ -> Obj.magic None
          | Coq_base.Coq_type.Coq_unit -> Obj.magic ()
          in default0
       end
     end

    module Coq_expr =
     struct
      module Coq_base =
       struct
        (** val default :
            ('a1, 'a2) Coq_type.Coq_base.coq_DefaultT -> ('a1, 'a2, 'a3)
            Coq_ident.coq_BuildIdentT -> 'a1 Coq_base.Coq_type.coq_type ->
            ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr **)

        let default baseDefault buildIdent0 t0 =
          Coq_ident.smart_Literal buildIdent0 t0
            (Coq_type.Coq_base.default baseDefault t0)
       end

      (** val default :
          ('a1, 'a2) Coq_type.Coq_base.coq_DefaultT -> ('a1, 'a2, 'a3)
          Coq_ident.coq_BuildIdentT -> 'a1 Coq__3.Coq_type.coq_type
          Coq__2.coq_type -> ('a1 Coq__3.Coq_type.coq_type, 'a3, 'a4)
          Coq_expr.expr **)

      let default baseDefault buildIdent0 =
        let rec default0 = function
        | Coq__2.Coq_base x -> Coq_base.default baseDefault buildIdent0 x
        | Coq__2.Coq_arrow (s0, d) ->
          Coq_expr.Abs (s0, d, (fun _ -> default0 d))
        in default0
     end
   end

  module GallinaReify =
   struct
    type ('base, 'base_interp, 'var) value = __

    (** val reify :
        ('a1, 'a2, 'a3) Coq_ident.coq_BuildIdentT -> 'a1
        Coq_base.Coq_type.coq_type Coq_type.coq_type -> ('a1, 'a2, 'a4) value
        -> ('a1 Coq_base.Coq_type.coq_type, 'a3, 'a4) Coq_expr.expr **)

    let reify buildIdent0 =
      let rec reify0 = function
      | Coq_type.Coq_base t1 -> Coq_ident.smart_Literal buildIdent0 t1
      | Coq_type.Coq_arrow (s0, d) ->
        (fun f -> Coq_expr.Abs (s0, d, (fun x -> reify0 d (Obj.magic f x))))
      in reify0

    (** val coq_Reify_as :
        ('a1, 'a2, 'a3) Coq_ident.coq_BuildIdentT -> 'a1
        Coq_base.Coq_type.coq_type Coq_type.coq_type -> (__ -> ('a1, 'a2, __)
        value) -> ('a1 Coq_base.Coq_type.coq_type, 'a3, __) Coq_expr.expr **)

    let coq_Reify_as buildIdent0 t0 v =
      reify buildIdent0 t0 (v __)
   end

  module GeneralizeVar =
   struct
    module Flat =
     struct
      type ('base_type, 'ident) expr =
      | Ident of 'base_type Coq_type.coq_type * 'ident
      | Var of 'base_type Coq_type.coq_type * positive
      | Abs of 'base_type Coq_type.coq_type * positive
         * 'base_type Coq_type.coq_type * ('base_type, 'ident) expr
      | App of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
         * ('base_type, 'ident) expr * ('base_type, 'ident) expr
      | LetIn of 'base_type Coq_type.coq_type * 'base_type Coq_type.coq_type
         * positive * ('base_type, 'ident) expr * ('base_type, 'ident) expr
     end

    (** val coq_ERROR : 'a1 -> 'a1 **)

    let coq_ERROR v =
      v

    (** val to_flat' :
        'a1 Coq_type.coq_type -> ('a1, 'a2, PositiveMap.key) Coq_expr.expr ->
        PositiveMap.key -> ('a1, 'a2) Flat.expr **)

    let to_flat' t0 =
      let rec to_flat'0 _ e cur_idx =
        match e with
        | Coq_expr.Ident (t1, idc) -> Flat.Ident (t1, idc)
        | Coq_expr.Var (t1, v) -> Flat.Var (t1, v)
        | Coq_expr.Abs (s0, d, f) ->
          Flat.Abs (s0, cur_idx, d,
            (to_flat'0 d (f cur_idx) (Coq_Pos.succ cur_idx)))
        | Coq_expr.App (s0, d, f, x) ->
          Flat.App (s0, d,
            (to_flat'0 (Coq_type.Coq_arrow (s0, d)) f cur_idx),
            (to_flat'0 s0 x cur_idx))
        | Coq_expr.LetIn (a, b, ex, eC) ->
          Flat.LetIn (a, b, cur_idx, (to_flat'0 a ex cur_idx),
            (to_flat'0 b (eC cur_idx) (Coq_Pos.succ cur_idx)))
      in to_flat'0 t0

    (** val from_flat :
        'a1 Coq_type.try_make_transport_cpsT -> (__ -> ('a1
        Coq_type.coq_type, ('a1, 'a2, __) Coq_expr.expr)
        DefaultValue.Coq_type.Coq_base.coq_DefaultT) -> 'a1 Coq_type.coq_type
        -> ('a1, 'a2) Flat.expr -> ('a1 Coq_type.coq_type, 'a3) sigT
        PositiveMap.t -> ('a1, 'a2, 'a3) Coq_expr.expr **)

    let from_flat try_make_transport_base_type_cps exprDefault t0 e x =
      let rec from_flat0 _ = function
      | Flat.Ident (t1, idc) -> (fun _ _ -> Coq_expr.Ident (t1, idc))
      | Flat.Var (t1, v) ->
        (fun _ ctx ->
          match bind1 (PositiveMap.find v ctx) (fun tv ->
                  Coq_type.try_transport try_make_transport_base_type_cps
                    (projT1 tv) t1 (projT2 tv)) with
          | Some v0 -> Coq_expr.Var (t1, v0)
          | None ->
            coq_ERROR
              (DefaultValue.Coq_type.Coq_base.defaultv
                (Obj.magic exprDefault __) t1))
      | Flat.Abs (s0, cur_idx, d, f) ->
        let f' = from_flat0 d f in
        (fun _ ctx -> Coq_expr.Abs (s0, d, (fun v ->
        f' __ (PositiveMap.add cur_idx (ExistT (s0, v)) ctx))))
      | Flat.App (s0, d, f, x0) ->
        let f' = from_flat0 (Coq_type.Coq_arrow (s0, d)) f in
        let x' = from_flat0 s0 x0 in
        (fun _ ctx -> Coq_expr.App (s0, d, (f' __ ctx), (x' __ ctx)))
      | Flat.LetIn (a, b, cur_idx, ex, eC) ->
        let ex' = from_flat0 a ex in
        let eC' = from_flat0 b eC in
        (fun _ ctx -> Coq_expr.LetIn (a, b, (ex' __ ctx), (fun v ->
        eC' __ (PositiveMap.add cur_idx (ExistT (a, v)) ctx))))
      in from_flat0 t0 e __ x

    (** val to_flat :
        'a1 Coq_type.coq_type -> ('a1, 'a2, PositiveMap.key) Coq_expr.expr ->
        ('a1, 'a2) Flat.expr **)

    let to_flat t0 e =
      to_flat' t0 e XH

    (** val coq_ToFlat :
        'a1 Coq_type.coq_type -> ('a1, 'a2) Coq_expr.coq_Expr -> ('a1, 'a2)
        Flat.expr **)

    let coq_ToFlat t0 e =
      to_flat t0 (Obj.magic e __)

    (** val coq_FromFlat :
        'a1 Coq_type.try_make_transport_cpsT -> (__ -> ('a1
        Coq_type.coq_type, ('a1, 'a2, __) Coq_expr.expr)
        DefaultValue.Coq_type.Coq_base.coq_DefaultT) -> 'a1 Coq_type.coq_type
        -> ('a1, 'a2) Flat.expr -> ('a1, 'a2, __) Coq_expr.expr **)

    let coq_FromFlat try_make_transport_base_type_cps exprDefault t0 e =
      from_flat try_make_transport_base_type_cps exprDefault t0 e
        PositiveMap.empty

    (** val coq_GeneralizeVar :
        'a1 Coq_type.try_make_transport_cpsT -> (__ -> ('a1
        Coq_type.coq_type, ('a1, 'a2, __) Coq_expr.expr)
        DefaultValue.Coq_type.Coq_base.coq_DefaultT) -> 'a1 Coq_type.coq_type
        -> ('a1, 'a2, PositiveMap.key) Coq_expr.expr -> ('a1, 'a2, __)
        Coq_expr.expr **)

    let coq_GeneralizeVar try_make_transport_base_type_cps exprDefault t0 e =
      coq_FromFlat try_make_transport_base_type_cps exprDefault t0
        (to_flat t0 e)
   end

  module Classes =
   struct
    type coq_ExprInfoT =
      __ Coq_base.Coq_type.coq_type Coq_type.coq_type -> __ -> (__
      Coq_base.Coq_type.coq_type, (__, __) Coq_base.interp) Coq_type.interp
      (* singleton inductive, whose constructor was Build_ExprInfoT *)

    type coq_ExprExtraInfoT = { base_beq : (__ -> __ -> bool);
                                base_interp_beq : (__ -> __ -> __ -> __ ->
                                                  bool);
                                try_make_transport_base_cps : __
                                                              Coq_type.try_make_transport_cpsT;
                                baseHasNat : __
                                             Coq_base.Coq_type.coq_BaseTypeHasNatT;
                                buildIdent : (__, __, __)
                                             Coq_ident.coq_BuildIdentT;
                                toRestrictedIdent : (__, __)
                                                    Coq_ident.coq_ToRestrictedIdentT;
                                buildEagerIdent : (__, __)
                                                  Coq_ident.coq_BuildEagerIdentT;
                                invertIdent : (__, __, __)
                                              Coq_invert_expr.coq_InvertIdentT;
                                defaultBase : (__, __)
                                              DefaultValue.Coq_type.Coq_base.coq_DefaultT;
                                reflect_base_beq : (__ -> __ -> reflect);
                                reflect_base_interp_beq : (__ -> __ -> __ ->
                                                          reflect);
                                baseHasNatCorrect : (__, __)
                                                    Coq_base.coq_BaseHasNatCorrectT }

    (** val base_beq :
        coq_ExprInfoT -> coq_ExprExtraInfoT -> __ -> __ -> bool **)

    let base_beq _ exprExtraInfoT =
      exprExtraInfoT.base_beq

    (** val try_make_transport_base_cps :
        coq_ExprInfoT -> coq_ExprExtraInfoT -> __ -> __ -> ((__ -> __) option
        -> __) -> __ **)

    let try_make_transport_base_cps _ exprExtraInfoT t1 t2 x =
      exprExtraInfoT.try_make_transport_base_cps __ t1 t2 __ x
   end
 end

module Coq_Compilers =
 struct
  module SubstVarLike =
   struct
    (** val is_recursively_var_or_ident :
        ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr -> bool **)

    let is_recursively_var_or_ident ident_is_good =
      let rec is_recursively_var_or_ident0 _ = function
      | Compilers.Coq_expr.Ident (t0, idc) -> ident_is_good t0 idc
      | Compilers.Coq_expr.Var (_, _) -> true
      | Compilers.Coq_expr.Abs (_, _, _) -> false
      | Compilers.Coq_expr.App (s0, d, f, x) ->
        (&&)
          (is_recursively_var_or_ident0 (Compilers.Coq_type.Coq_arrow (s0,
            d)) f) (is_recursively_var_or_ident0 s0 x)
      | Compilers.Coq_expr.LetIn (_, _, _, _) -> false
      in is_recursively_var_or_ident0
   end

  module UnderLets =
   struct
    type ('base_type, 'ident, 'var, 't) coq_UnderLets =
    | Base of 't
    | UnderLet of 'base_type Compilers.Coq_type.coq_type
       * ('base_type, 'ident, 'var) Compilers.Coq_expr.expr
       * ('var -> ('base_type, 'ident, 'var, 't) coq_UnderLets)

    (** val splice :
        ('a1, 'a2, 'a3, 'a4) coq_UnderLets -> ('a4 -> ('a1, 'a2, 'a3, 'a5)
        coq_UnderLets) -> ('a1, 'a2, 'a3, 'a5) coq_UnderLets **)

    let splice x e =
      let rec splice0 _ _ x0 e0 =
        match x0 with
        | Base v -> e0 v
        | UnderLet (a, x1, f) ->
          UnderLet (a, x1, (fun v -> splice0 __ __ (f v) e0))
      in splice0 __ __ x e

    (** val splice_list :
        ('a1, 'a2, 'a3, 'a4) coq_UnderLets list -> ('a4 list -> ('a1, 'a2,
        'a3, 'a5) coq_UnderLets) -> ('a1, 'a2, 'a3, 'a5) coq_UnderLets **)

    let splice_list ls e =
      let rec splice_list0 _ _ ls0 e0 =
        match ls0 with
        | [] -> e0 []
        | x :: xs ->
          splice x (fun x0 ->
            splice_list0 __ __ xs (fun xs0 -> e0 (x0 :: xs0)))
      in splice_list0 __ __ ls e

    (** val splice_option :
        ('a1, 'a2, 'a3, 'a4) coq_UnderLets option -> ('a4 option -> ('a1,
        'a2, 'a3, 'a5) coq_UnderLets) -> ('a1, 'a2, 'a3, 'a5) coq_UnderLets **)

    let splice_option v e =
      match v with
      | Some x -> splice x (fun x0 -> e (Some x0))
      | None -> e None

    (** val to_expr :
        'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr) coq_UnderLets -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr **)

    let to_expr t0 =
      let rec to_expr0 t1 = function
      | Base v -> v
      | UnderLet (a, x0, f) ->
        Compilers.Coq_expr.LetIn (a, t1, x0, (fun v -> to_expr0 t1 (f v)))
      in to_expr0 t0

    (** val of_expr :
        'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1, 'a2, 'a3, ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr) coq_UnderLets **)

    let of_expr t0 =
      let rec of_expr0 _ = function
      | Compilers.Coq_expr.Ident (t1, idc) ->
        Base (Compilers.Coq_expr.Ident (t1, idc))
      | Compilers.Coq_expr.Var (t1, v) ->
        Base (Compilers.Coq_expr.Var (t1, v))
      | Compilers.Coq_expr.Abs (s0, d, f) ->
        Base (Compilers.Coq_expr.Abs (s0, d, f))
      | Compilers.Coq_expr.App (s0, d, f, x0) ->
        Base (Compilers.Coq_expr.App (s0, d, f, x0))
      | Compilers.Coq_expr.LetIn (a, b, x0, f) ->
        UnderLet (a, x0, (fun v -> of_expr0 b (f v)))
      in of_expr0 t0

    (** val flat_map :
        ('a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1, 'a4, 'a5, ('a1, 'a4, 'a5)
        Compilers.Coq_expr.expr) coq_UnderLets) -> ('a1
        Compilers.Coq_type.coq_type -> 'a5 -> 'a3) -> ('a1, 'a2, 'a3, 'a6)
        coq_UnderLets -> ('a1, 'a4, 'a5, 'a6) coq_UnderLets **)

    let flat_map f f' =
      let rec flat_map0 = function
      | Base x0 -> Base x0
      | UnderLet (a, x0, f0) ->
        splice (f a x0) (fun v -> UnderLet (a, v, (fun v0 ->
          flat_map0 (f0 (f' a v0)))))
      in flat_map0

    (** val reify_and_let_binds_base_cps :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a2, 'a3)
        Compilers.Coq_ident.coq_BuildIdentT -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a3 -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4)
        Compilers.Coq_expr.expr -> (('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a3, 'a4, 'a5) coq_UnderLets) -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4, 'a5) coq_UnderLets **)

    let reify_and_let_binds_base_cps try_make_transport_base_type_cps invertIdent0 buildIdent0 ident_is_var_like0 t0 x x0 =
      let base' = fun _ x1 -> Compilers.Coq_type.Coq_base x1 in
      let default_reify_and_let_binds_base_cps = fun t1 e _ k ->
        match Compilers.Coq_invert_expr.invert_Var (base' __ t1) e with
        | Some v -> k (Compilers.Coq_expr.Var ((base' __ t1), v))
        | None ->
          if SubstVarLike.is_recursively_var_or_ident ident_is_var_like0
               (base' __ t1) e
          then k e
          else UnderLet ((base' __ t1), e, (fun v ->
                 k (Compilers.Coq_expr.Var ((base' __ t1), v))))
      in
      let rec reify_and_let_binds_base_cps0 = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
        (fun e _ k ->
          match Compilers.Coq_invert_expr.invert_Literal invertIdent0
                  (base' __ (Compilers.Coq_base.Coq_type.Coq_type_base t2)) e with
          | Some v ->
            k (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base t2)),
              ((Obj.magic buildIdent0).Compilers.Coq_ident.ident_Literal t2 v)))
          | None ->
            default_reify_and_let_binds_base_cps
              (Compilers.Coq_base.Coq_type.Coq_type_base t2) e __ k)
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun e _ k ->
          match Compilers.Coq_invert_expr.invert_pair
                  try_make_transport_base_type_cps invertIdent0 a b e with
          | Some p ->
            let (a0, b0) = p in
            reify_and_let_binds_base_cps0 a a0 __ (fun ae ->
              reify_and_let_binds_base_cps0 b b0 __ (fun be ->
                k (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base b),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                  (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base a),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  b), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))),
                  (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base a),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  b), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))))),
                  (buildIdent0.Compilers.Coq_ident.ident_pair a b))), ae)),
                  be))))
          | None ->
            default_reify_and_let_binds_base_cps
              (Compilers.Coq_base.Coq_type.Coq_prod (a, b)) e __ k)
      | Compilers.Coq_base.Coq_type.Coq_list a ->
        (fun e _ k ->
          match Compilers.Coq_invert_expr.reflect_list
                  try_make_transport_base_type_cps invertIdent0 a e with
          | Some ls ->
            let rec f = function
            | [] ->
              (fun k0 ->
                k0 (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list a)),
                  (buildIdent0.Compilers.Coq_ident.ident_nil a))))
            | y :: l0 ->
              (fun k0 ->
                reify_and_let_binds_base_cps0 a y __ (fun xe ->
                  f l0 (fun xse ->
                    k0 (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list a)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list a)),
                      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                      a), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list a)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list a)))),
                      (Compilers.Coq_expr.Ident
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base a),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list a)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list a)))))),
                      (buildIdent0.Compilers.Coq_ident.ident_cons a))), xe)),
                      xse)))))
            in f ls k
          | None ->
            default_reify_and_let_binds_base_cps
              (Compilers.Coq_base.Coq_type.Coq_list a) e __ k)
      | Compilers.Coq_base.Coq_type.Coq_option a ->
        (fun e _ k ->
          match Compilers.Coq_invert_expr.reflect_option
                  try_make_transport_base_type_cps invertIdent0 a e with
          | Some ls ->
            (match ls with
             | Some a0 ->
               (fun k0 ->
                 reify_and_let_binds_base_cps0 a a0 __ (fun xe ->
                   k0 (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     a), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_option a)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base a),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_option a)))),
                     (buildIdent0.Compilers.Coq_ident.ident_Some a))), xe))))
             | None ->
               (fun k0 ->
                 k0 (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_option a)),
                   (buildIdent0.Compilers.Coq_ident.ident_None a))))) k
          | None ->
            default_reify_and_let_binds_base_cps
              (Compilers.Coq_base.Coq_type.Coq_option a) e __ k)
      | Compilers.Coq_base.Coq_type.Coq_unit ->
        (fun e _ k ->
          if SubstVarLike.is_recursively_var_or_ident ident_is_var_like0
               (base' __ Compilers.Coq_base.Coq_type.Coq_unit) e
          then k (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                 Compilers.Coq_base.Coq_type.Coq_unit),
                 buildIdent0.Compilers.Coq_ident.ident_tt))
          else UnderLet ((base' __ Compilers.Coq_base.Coq_type.Coq_unit), e,
                 (fun _ ->
                 k (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   buildIdent0.Compilers.Coq_ident.ident_tt)))))
      in reify_and_let_binds_base_cps0 t0 x __ x0

    (** val let_bind_return :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a2, 'a3)
        Compilers.Coq_ident.coq_BuildIdentT -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a3 -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a3, 'a4)
        Compilers.Coq_expr.expr -> ('a1 Compilers.Coq_base.Coq_type.coq_type,
        'a3, 'a4) Compilers.Coq_expr.expr **)

    let let_bind_return try_make_transport_base_type_cps invertIdent0 buildIdent0 ident_is_var_like0 t0 x =
      let base' = fun _ x0 -> Compilers.Coq_type.Coq_base x0 in
      let rec let_bind_return0 = function
      | Compilers.Coq_type.Coq_base t2 ->
        (fun e ->
          to_expr (base' __ t2)
            (splice (of_expr (Compilers.Coq_type.Coq_base t2) e) (fun v ->
              reify_and_let_binds_base_cps try_make_transport_base_type_cps
                invertIdent0 buildIdent0 ident_is_var_like0 t2 v (fun x0 ->
                Base x0))))
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun e -> Compilers.Coq_expr.Abs (s0, d, (fun v ->
          let_bind_return0 d
            (match Compilers.Coq_invert_expr.invert_Abs s0 d e with
             | Some f -> f v
             | None ->
               Compilers.Coq_expr.App (s0, d, e, (Compilers.Coq_expr.Var (s0,
                 v)))))))
      in let_bind_return0 t0 x

    (** val coq_LetBindReturn :
        'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1, 'a2, 'a3)
        Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a2, 'a3)
        Compilers.Coq_ident.coq_BuildIdentT -> ('a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        'a3 -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a3)
        Compilers.Coq_expr.coq_Expr -> ('a1
        Compilers.Coq_base.Coq_type.coq_type, 'a3, __) Compilers.Coq_expr.expr **)

    let coq_LetBindReturn try_make_transport_base_type_cps invertIdent0 buildIdent0 ident_is_var_like0 t0 e =
      let_bind_return try_make_transport_base_type_cps invertIdent0
        buildIdent0 ident_is_var_like0 t0 (e __)
   end
 end

module Coq_Primitive =
 struct
  type ('a, 'p) sigT = { projT1 : 'a; projT2 : 'p }

  (** val projT1 : ('a1, 'a2) sigT -> 'a1 **)

  let projT1 s0 =
    s0.projT1

  (** val projT2 : ('a1, 'a2) sigT -> 'a2 **)

  let projT2 s0 =
    s0.projT2
 end

module Coq0_Compilers =
 struct
  (** val app_type_of_list : __ list -> __ -> __ -> 'a1 **)

  let app_type_of_list ls f args0 =
    let rec f0 = function
    | [] -> (fun v _ -> Obj.magic v)
    | _ :: l0 ->
      (fun f1 x ->
        f0 l0 (Obj.magic f1 (fst (Obj.magic x))) (snd (Obj.magic x)))
    in f0 ls f args0

  module Coq_pattern =
   struct
    module Coq_base =
     struct
      (** val relax :
          'a1 Compilers.Coq_base.Coq_type.coq_type -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type **)

      let relax t0 =
        let rec relax0 = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base t2
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod ((relax0 a),
            (relax0 b))
        | Compilers.Coq_base.Coq_type.Coq_list a ->
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list (relax0 a)
        | Compilers.Coq_base.Coq_type.Coq_option a ->
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option (relax0 a)
        | Compilers.Coq_base.Coq_type.Coq_unit ->
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit
        in relax0 t0

      (** val lookup_default :
          positive -> 'a1 Compilers.Coq_base.Coq_type.coq_type PositiveMap.t
          -> 'a1 Compilers.Coq_base.Coq_type.coq_type **)

      let lookup_default p evar_map =
        match PositiveMap.find p evar_map with
        | Some t0 -> t0
        | None -> Compilers.Coq_base.Coq_type.Coq_unit

      (** val subst_default :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
          Compilers.Coq_base.Coq_type.coq_type **)

      let subst_default ptype =
        let rec subst_default0 ptype0 evar_map =
          match ptype0 with
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var p ->
            lookup_default p evar_map
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base t0 ->
            Compilers.Coq_base.Coq_type.Coq_type_base t0
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (a, b) ->
            Compilers.Coq_base.Coq_type.Coq_prod
              ((subst_default0 a evar_map), (subst_default0 b evar_map))
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list a ->
            Compilers.Coq_base.Coq_type.Coq_list (subst_default0 a evar_map)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option a ->
            Compilers.Coq_base.Coq_type.Coq_option (subst_default0 a evar_map)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit ->
            Compilers.Coq_base.Coq_type.Coq_unit
        in subst_default0 ptype

      (** val collect_vars :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type ->
          PositiveSet.t **)

      let collect_vars t0 =
        let rec collect_vars0 = function
        | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var p ->
          PositiveSet.add p PositiveSet.empty
        | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base _ ->
          PositiveSet.empty
        | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (a, b) ->
          PositiveSet.union (collect_vars0 a) (collect_vars0 b)
        | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list a ->
          collect_vars0 a
        | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option a ->
          collect_vars0 a
        | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit ->
          PositiveSet.empty
        in collect_vars0 t0
     end

    module Coq_type =
     struct
      (** val relax :
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type **)

      let relax t0 =
        let rec relax0 = function
        | Compilers.Coq_type.Coq_base t2 ->
          Compilers.Coq_type.Coq_base (Coq_base.relax t2)
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          Compilers.Coq_type.Coq_arrow ((relax0 s0), (relax0 d))
        in relax0 t0

      (** val subst_default :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type **)

      let subst_default ptype =
        let rec subst_default0 ptype0 evar_map =
          match ptype0 with
          | Compilers.Coq_type.Coq_base t0 ->
            Compilers.Coq_type.Coq_base (Coq_base.subst_default t0 evar_map)
          | Compilers.Coq_type.Coq_arrow (a, b) ->
            Compilers.Coq_type.Coq_arrow ((subst_default0 a evar_map),
              (subst_default0 b evar_map))
        in subst_default0 ptype

      (** val collect_vars :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> PositiveSet.t **)

      let collect_vars t0 =
        let rec collect_vars0 = function
        | Compilers.Coq_type.Coq_base t2 -> Coq_base.collect_vars t2
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          PositiveSet.union (collect_vars0 s0) (collect_vars0 d)
        in collect_vars0 t0
     end

    module Raw =
     struct
      module Coq_ident =
       struct
        type kind_of_type =
        | GallinaType
        | BaseBaseType
        | BaseType

        type ('base, 'cident) preident_infos = { dep_types : __ list;
                                                 indep_types : kind_of_type
                                                               list;
                                                 indep_args : (__ -> __ list);
                                                 to_type : (__ -> __ -> 'base
                                                           Compilers.Coq_base.Coq_type.coq_type
                                                           Compilers.Coq_type.coq_type);
                                                 to_ident : (__ -> __ -> __
                                                            -> 'cident) }

        (** val dep_types : ('a1, 'a2) preident_infos -> __ list **)

        let dep_types p =
          p.dep_types

        (** val indep_types :
            ('a1, 'a2) preident_infos -> kind_of_type list **)

        let indep_types p =
          p.indep_types

        (** val indep_args : ('a1, 'a2) preident_infos -> __ -> __ list **)

        let indep_args p =
          p.indep_args

        (** val to_type :
            ('a1, 'a2) preident_infos -> __ -> __ -> 'a1
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type **)

        let to_type p =
          p.to_type

        (** val to_ident :
            ('a1, 'a2) preident_infos -> __ -> __ -> __ -> 'a2 **)

        let to_ident p =
          p.to_ident

        type ('base, 'cident) ident_infos = { preinfos : ('base, 'cident)
                                                         preident_infos;
                                              dep_types_dec_transparent : 
                                              (__ -> __ -> bool);
                                              indep_args_beq : (__ -> __ ->
                                                               __ -> bool);
                                              indep_args_reflect : (__ -> __
                                                                   -> __ ->
                                                                   reflect);
                                              indep_types_beq : (__ -> __ ->
                                                                bool);
                                              indep_types_reflect : (__ -> __
                                                                    ->
                                                                    reflect) }

        (** val preinfos :
            ('a1, 'a2) ident_infos -> ('a1, 'a2) preident_infos **)

        let preinfos i =
          i.preinfos

        type ('base, 'cident) ident_args = (__, __ * __) Coq_Primitive.sigT

        (** val eta_ident_cps_gen2 :
            (__ -> ('a1 -> __) -> ('a1 -> __)) -> ('a1 -> 'a2) -> ('a1 ->
            'a3) -> ('a1 -> 'a3) **)

        let eta_ident_cps_gen2 eta_ident_cps_gen4 _ f1 =
          Obj.magic eta_ident_cps_gen4 __ f1

        (** val eta_ident_cps_gen3 :
            (__ -> ('a1 -> __) -> ('a1 -> __)) -> ('a1 -> 'a2) -> ('a1 ->
            'a3) -> ('a1 -> 'a4) -> ('a1 -> 'a4) **)

        let eta_ident_cps_gen3 eta_ident_cps_gen4 _ _ f2 =
          Obj.magic eta_ident_cps_gen4 __ f2

        type ('base, 'cident, 'ident) full_types = __

        (** val is_simple : ('a3 -> ('a1, 'a2) ident_infos) -> 'a3 -> bool **)

        let is_simple ident_infos_of idc =
          let ii = ident_infos_of idc in
          (match ii.preinfos.dep_types with
           | [] ->
             (match ii.preinfos.indep_types with
              | [] -> true
              | _ :: _ -> false)
           | _ :: _ -> false)

        (** val type_of :
            (__ -> ('a3 -> __) -> ('a3 -> __)) -> ('a3 -> ('a1, 'a2)
            ident_infos) -> 'a3 -> ('a1, 'a2, 'a3) full_types -> 'a1
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type **)

        let type_of eta_ident_cps_gen4 ident_infos_of =
          eta_ident_cps_gen2 eta_ident_cps_gen4 (Obj.magic __)
            (fun pidc args0 ->
            (ident_infos_of pidc).preinfos.to_type
              (Obj.magic args0).Coq_Primitive.projT1
              (fst (Obj.magic args0).Coq_Primitive.projT2))

        (** val to_typed :
            (__ -> ('a3 -> __) -> ('a3 -> __)) -> ('a3 -> ('a1, 'a2)
            ident_infos) -> 'a3 -> ('a1, 'a2, 'a3) full_types -> 'a2 **)

        let to_typed eta_ident_cps_gen4 ident_infos_of =
          eta_ident_cps_gen3 eta_ident_cps_gen4 (Obj.magic __)
            (fun pidc args0 ->
            (ident_infos_of pidc).preinfos.to_type args0.Coq_Primitive.projT1
              (fst args0.Coq_Primitive.projT2)) (fun pidc args0 ->
            (ident_infos_of pidc).preinfos.to_ident
              (Obj.magic args0).Coq_Primitive.projT1
              (fst (Obj.magic args0).Coq_Primitive.projT2)
              (snd (Obj.magic args0).Coq_Primitive.projT2))
       end
     end

    module Coq_ident =
     struct
      (** val prearg_types :
          ('a3 -> ('a1, 'a2) Raw.Coq_ident.ident_infos) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> ('a3, __ * __)
          Coq_Primitive.sigT) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list **)

      let prearg_types raw_ident_infos_of0 split_types0 t0 idc =
        let st = split_types0 t0 idc in
        let pi =
          (raw_ident_infos_of0 st.Coq_Primitive.projT1).Raw.Coq_ident.preinfos
        in
        pi.Raw.Coq_ident.indep_args (fst st.Coq_Primitive.projT2)

      (** val arg_types :
          ('a3 -> ('a1, 'a2) Raw.Coq_ident.ident_infos) -> (__ -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __)) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> ('a3, __ * __)
          Coq_Primitive.sigT) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list **)

      let arg_types raw_ident_infos_of0 eta_ident_cps_gen4 split_types0 =
        Obj.magic eta_ident_cps_gen4 __
          (prearg_types raw_ident_infos_of0 split_types0)

      module GoalType =
       struct
        type ('base, 'ident) package = { all_base : 'base list;
                                         all_idents : (__, __)
                                                      Coq_Primitive.sigT list;
                                         ident_index : ('base
                                                       Compilers.Coq_base.Coq_type.coq_type
                                                       Compilers.Coq_type.coq_type
                                                       -> 'ident -> nat);
                                         eta_ident_cps_gen : (__ -> ('base
                                                             Compilers.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type
                                                             -> 'ident -> __)
                                                             -> ('base
                                                             Compilers.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type
                                                             -> 'ident -> __));
                                         eta_ident_cps_gen_expand_literal : 
                                         (__ -> ('base
                                         Compilers.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type ->
                                         'ident -> __) -> ('base
                                         Compilers.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type ->
                                         'ident -> __));
                                         eta_ident_cps : (__ -> 'base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> 'ident -> ('base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> 'ident -> __) ->
                                                         __);
                                         simple_idents : ('base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type,
                                                         'ident)
                                                         Coq_Primitive.sigT
                                                         list;
                                         all_raw_idents : __ list;
                                         raw_ident_index : (__ -> nat);
                                         eta_raw_ident_cps_gen : (__ -> (__
                                                                 -> __) ->
                                                                 (__ -> __));
                                         raw_ident_infos_of : (__ -> ('base,
                                                              'ident)
                                                              Raw.Coq_ident.ident_infos);
                                         split_raw_ident_gen : ('base
                                                               Compilers.Coq_base.Coq_type.coq_type
                                                               Compilers.Coq_type.coq_type
                                                               -> 'ident ->
                                                               (__, ('base,
                                                               'ident)
                                                               Raw.Coq_ident.ident_args)
                                                               Coq_Primitive.sigT);
                                         invert_bind_args : ('base
                                                            Compilers.Coq_base.Coq_type.coq_type
                                                            Compilers.Coq_type.coq_type
                                                            -> 'ident -> __
                                                            -> ('base,
                                                            'ident, __)
                                                            Raw.Coq_ident.full_types
                                                            option);
                                         invert_bind_args_unknown : ('base
                                                                    Compilers.Coq_base.Coq_type.coq_type
                                                                    Compilers.Coq_type.coq_type
                                                                    -> 'ident
                                                                    -> __ ->
                                                                    ('base,
                                                                    'ident,
                                                                    __)
                                                                    Raw.Coq_ident.full_types
                                                                    option);
                                         all_pattern_idents : (__, __)
                                                              Coq_Primitive.sigT
                                                              list;
                                         eta_pattern_ident_cps_gen : 
                                         (__ -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __) -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __));
                                         eta_pattern_ident_cps_gen_expand_literal : 
                                         (__ -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __) -> ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __));
                                         split_types : ('base
                                                       Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                       Compilers.Coq_type.coq_type
                                                       -> __ -> (__, __ * __)
                                                       Coq_Primitive.sigT);
                                         add_types_from_raw_sig : (__ -> __
                                                                  -> __ ->
                                                                  ('base
                                                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                                  Compilers.Coq_type.coq_type,
                                                                  __)
                                                                  Coq_Primitive.sigT);
                                         arg_types_unfolded : ('base
                                                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                              Compilers.Coq_type.coq_type
                                                              -> __ -> __
                                                              list);
                                         to_typed_unfolded : ('base
                                                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type
                                                             -> __ -> 'base
                                                             Compilers.Coq_base.Coq_type.coq_type
                                                             PositiveMap.t ->
                                                             __ -> 'ident);
                                         type_of_list_arg_types_beq_unfolded : 
                                         ('base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type -> __ ->
                                         __ -> __ -> bool);
                                         of_typed_ident_unfolded : ('base
                                                                   Compilers.Coq_base.Coq_type.coq_type
                                                                   Compilers.Coq_type.coq_type
                                                                   -> 'ident
                                                                   -> __);
                                         arg_types_of_typed_ident_unfolded : 
                                         ('base
                                         Compilers.Coq_base.Coq_type.coq_type
                                         Compilers.Coq_type.coq_type ->
                                         'ident -> __);
                                         unify : ('base
                                                 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                 Compilers.Coq_type.coq_type
                                                 -> 'base
                                                 Compilers.Coq_base.Coq_type.coq_type
                                                 Compilers.Coq_type.coq_type
                                                 -> __ -> 'ident -> __ option);
                                         unify_unknown : ('base
                                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> 'base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         -> __ -> 'ident ->
                                                         __ option) }

        (** val eta_ident_cps :
            ('a1, 'a2) package -> 'a1 Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> 'a2 -> ('a1
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> 'a2 -> 'a3) -> 'a3 **)

        let eta_ident_cps package0 t0 idc f =
          Obj.magic package0.eta_ident_cps __ t0 idc f

        (** val eta_raw_ident_cps_gen :
            ('a1, 'a2) package -> (__ -> 'a3) -> (__ -> 'a3) **)

        let eta_raw_ident_cps_gen package0 f =
          Obj.magic package0.eta_raw_ident_cps_gen __ f

        (** val raw_ident_infos_of :
            ('a1, 'a2) package -> __ -> ('a1, 'a2) Raw.Coq_ident.ident_infos **)

        let raw_ident_infos_of package0 =
          package0.raw_ident_infos_of

        (** val invert_bind_args :
            ('a1, 'a2) package -> 'a1 Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> 'a2 -> __ -> ('a1, 'a2, __)
            Raw.Coq_ident.full_types option **)

        let invert_bind_args package0 =
          package0.invert_bind_args

        (** val invert_bind_args_unknown :
            ('a1, 'a2) package -> 'a1 Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> 'a2 -> __ -> ('a1, 'a2, __)
            Raw.Coq_ident.full_types option **)

        let invert_bind_args_unknown package0 =
          package0.invert_bind_args_unknown

        (** val eta_pattern_ident_cps_gen :
            ('a1, 'a2) package -> ('a1
            Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> __ -> 'a3) -> ('a1
            Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> __ -> 'a3) **)

        let eta_pattern_ident_cps_gen package0 f =
          Obj.magic package0.eta_pattern_ident_cps_gen __ f

        (** val split_types :
            ('a1, 'a2) package -> 'a1
            Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> __ -> (__, __ * __)
            Coq_Primitive.sigT **)

        let split_types package0 =
          package0.split_types

        (** val unify :
            ('a1, 'a2) package -> 'a1
            Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> 'a1
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> __ -> 'a2 -> __ option **)

        let unify package0 =
          package0.unify

        (** val unify_unknown :
            ('a1, 'a2) package -> 'a1
            Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> 'a1
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> __ -> 'a2 -> __ option **)

        let unify_unknown package0 =
          package0.unify_unknown
       end
     end
   end
 end

module Coq1_Compilers =
 struct
  module Coq_pattern =
   struct
    module Coq_base =
     struct
      (** val subst :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
          Compilers.Coq_base.Coq_type.coq_type option **)

      let subst ptype =
        let rec subst0 ptype0 evar_map =
          match ptype0 with
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var p ->
            PositiveMap.find p evar_map
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base t0 ->
            Some (Compilers.Coq_base.Coq_type.Coq_type_base t0)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (a, b) ->
            bind1 (subst0 a evar_map) (fun a' ->
              bind1 (subst0 b evar_map) (fun b' -> Some
                (Compilers.Coq_base.Coq_type.Coq_prod (a', b'))))
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list a ->
            option_map (fun x -> Compilers.Coq_base.Coq_type.Coq_list x)
              (subst0 a evar_map)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option a ->
            option_map (fun x -> Compilers.Coq_base.Coq_type.Coq_option x)
              (subst0 a evar_map)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit ->
            Some Compilers.Coq_base.Coq_type.Coq_unit
        in subst0 ptype

      type 'base var_types_of = __

      (** val add_var_types_cps :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
          var_types_of -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          PositiveMap.t -> ('a1 Compilers.Coq_base.Coq_type.coq_type
          PositiveMap.t -> 'a2) -> 'a2 **)

      let add_var_types_cps t0 v evm x =
        let rec add_var_types_cps0 t1 v0 evm0 _ k =
          (match t1 with
           | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var p ->
             (fun t2 -> k (PositiveMap.add p (Obj.magic t2) evm0))
           | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base _ ->
             (fun _ -> k evm0)
           | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (a, b) ->
             (fun pat ->
               let (a0, b0) = Obj.magic pat in
               add_var_types_cps0 a a0 evm0 __ (fun evm1 ->
                 add_var_types_cps0 b b0 evm1 __ k))
           | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list a ->
             (fun t2 -> add_var_types_cps0 a t2 evm0 __ k)
           | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option a ->
             (fun t2 -> add_var_types_cps0 a t2 evm0 __ k)
           | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit ->
             (fun _ -> k evm0)) v0
        in add_var_types_cps0 t0 v evm __ x

      (** val unify_extracted :
          ('a1 -> 'a1 -> bool) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type -> 'a1 var_types_of option **)

      let unify_extracted base_beq0 =
        let rec unify_extracted0 ptype etype =
          match ptype with
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var _ ->
            Some (Obj.magic etype)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base t0 ->
            (match etype with
             | Compilers.Coq_base.Coq_type.Coq_type_base t' ->
               if base_beq0 t0 t' then Some (Obj.magic ()) else None
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> None
             | Compilers.Coq_base.Coq_type.Coq_list _ -> None
             | Compilers.Coq_base.Coq_type.Coq_option _ -> None
             | Compilers.Coq_base.Coq_type.Coq_unit -> None)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (a, b) ->
            (match etype with
             | Compilers.Coq_base.Coq_type.Coq_type_base _ -> None
             | Compilers.Coq_base.Coq_type.Coq_prod (a', b') ->
               bind1 (unify_extracted0 a a') (fun a0 ->
                 bind1 (unify_extracted0 b b') (fun b0 -> Some
                   (Obj.magic (a0, b0))))
             | Compilers.Coq_base.Coq_type.Coq_list _ -> None
             | Compilers.Coq_base.Coq_type.Coq_option _ -> None
             | Compilers.Coq_base.Coq_type.Coq_unit -> None)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list a ->
            (match etype with
             | Compilers.Coq_base.Coq_type.Coq_type_base _ -> None
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> None
             | Compilers.Coq_base.Coq_type.Coq_list a' ->
               unify_extracted0 a a'
             | Compilers.Coq_base.Coq_type.Coq_option _ -> None
             | Compilers.Coq_base.Coq_type.Coq_unit -> None)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option a ->
            (match etype with
             | Compilers.Coq_base.Coq_type.Coq_type_base _ -> None
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> None
             | Compilers.Coq_base.Coq_type.Coq_list _ -> None
             | Compilers.Coq_base.Coq_type.Coq_option a' ->
               unify_extracted0 a a'
             | Compilers.Coq_base.Coq_type.Coq_unit -> None)
          | Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit ->
            (match etype with
             | Compilers.Coq_base.Coq_type.Coq_type_base _ -> None
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> None
             | Compilers.Coq_base.Coq_type.Coq_list _ -> None
             | Compilers.Coq_base.Coq_type.Coq_option _ -> None
             | Compilers.Coq_base.Coq_type.Coq_unit -> Some (Obj.magic ()))
        in unify_extracted0
     end

    module Coq_type =
     struct
      (** val subst :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
          option **)

      let subst ptype =
        let rec subst0 ptype0 evar_map =
          match ptype0 with
          | Compilers.Coq_type.Coq_base t0 ->
            option_map (fun x -> Compilers.Coq_type.Coq_base x)
              (Coq_base.subst t0 evar_map)
          | Compilers.Coq_type.Coq_arrow (s0, d) ->
            bind1 (subst0 s0 evar_map) (fun s' ->
              bind1 (subst0 d evar_map) (fun d' -> Some
                (Compilers.Coq_type.Coq_arrow (s', d'))))
        in subst0 ptype

      type 'base var_types_of = __

      (** val add_var_types_cps :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1 var_types_of -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> ('a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a2) -> 'a2 **)

      let add_var_types_cps t0 v evm x =
        let rec add_var_types_cps0 t1 v0 evm0 _ k =
          (match t1 with
           | Compilers.Coq_type.Coq_base t2 ->
             (fun v1 -> Coq_base.add_var_types_cps t2 v1 evm0 k)
           | Compilers.Coq_type.Coq_arrow (a, b) ->
             (fun pat ->
               let (a0, b0) = Obj.magic pat in
               add_var_types_cps0 a a0 evm0 __ (fun evm1 ->
                 add_var_types_cps0 b b0 evm1 __ k))) v0
        in add_var_types_cps0 t0 v evm __ x

      (** val unify_extracted :
          ('a1 -> 'a1 -> bool) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a1 var_types_of option **)

      let unify_extracted base_beq0 =
        let rec unify_extracted0 ptype etype =
          match ptype with
          | Compilers.Coq_type.Coq_base t0 ->
            (match etype with
             | Compilers.Coq_type.Coq_base t' ->
               Coq_base.unify_extracted base_beq0 t0 t'
             | Compilers.Coq_type.Coq_arrow (_, _) -> None)
          | Compilers.Coq_type.Coq_arrow (a, b) ->
            (match etype with
             | Compilers.Coq_type.Coq_base _ -> None
             | Compilers.Coq_type.Coq_arrow (a', b') ->
               bind1 (unify_extracted0 a a') (fun a0 ->
                 bind1 (unify_extracted0 b b') (fun b0 -> Some
                   (Obj.magic (a0, b0)))))
        in unify_extracted0

      type ('base, 'k) forall_vars = __

      (** val app_forall_vars_gen :
          'a1 Compilers.Coq_base.Coq_type.coq_type PositiveMap.t ->
          PositiveMap.key list -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          PositiveMap.t -> __ -> 'a2 option **)

      let app_forall_vars_gen evm ls evm0 x =
        let rec app_forall_vars_gen0 _ evm1 = function
        | [] -> (fun _ val0 -> Some (Obj.magic val0))
        | x0 :: xs ->
          (match PositiveMap.find x0 evm1 with
           | Some v ->
             (fun evm2 val0 ->
               app_forall_vars_gen0 __ evm1 xs (PositiveMap.add x0 v evm2)
                 (Obj.magic val0 v))
           | None -> (fun _ _ -> None))
        in app_forall_vars_gen0 __ evm ls evm0 x

      (** val app_forall_vars :
          PositiveSet.t -> ('a1, 'a2) forall_vars -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a2 option **)

      let app_forall_vars p f evm =
        app_forall_vars_gen evm (rev1 (PositiveSet.elements p))
          PositiveMap.empty f
     end

    type ('base, 'ident) pattern =
    | Wildcard of 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                  Compilers.Coq_type.coq_type
    | Ident of 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
               Compilers.Coq_type.coq_type * 'ident
    | App of 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
             Compilers.Coq_type.coq_type
       * 'base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
         Compilers.Coq_type.coq_type * ('base, 'ident) pattern
       * ('base, 'ident) pattern

    type ('base, 'ident) anypattern = { type_of_anypattern : 'base
                                                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
                                                             Compilers.Coq_type.coq_type;
                                        pattern_of_anypattern : ('base,
                                                                'ident)
                                                                pattern }

    (** val type_of_anypattern :
        ('a1, 'a2) anypattern -> 'a1
        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type **)

    let type_of_anypattern a =
      a.type_of_anypattern

    (** val pattern_of_anypattern :
        ('a1, 'a2) anypattern -> ('a1, 'a2) pattern **)

    let pattern_of_anypattern a =
      a.pattern_of_anypattern

    (** val collect_vars :
        'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> ('a1, 'a2) pattern -> PositiveSet.t **)

    let rec collect_vars _ = function
    | Wildcard t0 -> Coq0_Compilers.Coq_pattern.Coq_type.collect_vars t0
    | Ident (t0, _) -> Coq0_Compilers.Coq_pattern.Coq_type.collect_vars t0
    | App (s0, d, f, x) ->
      PositiveSet.union (collect_vars s0 x)
        (collect_vars (Compilers.Coq_type.Coq_arrow (s0, d)) f)
   end

  module RewriteRules =
   struct
    module Compile =
     struct
      type ('base_type, 'ident, 'var) value' = __

      type ('base_type, 'ident, 'var) value =
        ('base_type, 'ident, 'var) value'

      type ('base_type, 'ident, 'var) value_with_lets =
        ('base_type, 'ident, 'var) value'

      (** val coq_Base_value :
          'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) value -> ('a1,
          'a2, 'a3) value_with_lets **)

      let coq_Base_value = function
      | Compilers.Coq_type.Coq_base _ ->
        (fun v -> Obj.magic (Coq_Compilers.UnderLets.Base v))
      | Compilers.Coq_type.Coq_arrow (_, _) -> (fun v -> v)

      (** val splice_under_lets_with_value :
          'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, 'a4)
          Coq_Compilers.UnderLets.coq_UnderLets -> ('a4 -> ('a1, 'a2, 'a3)
          value_with_lets) -> ('a1, 'a2, 'a3) value_with_lets **)

      let splice_under_lets_with_value t0 x x0 =
        let rec splice_under_lets_with_value0 _ t1 x1 =
          match t1 with
          | Compilers.Coq_type.Coq_base _ ->
            (fun k ->
              Obj.magic Coq_Compilers.UnderLets.splice x1 (fun x2 ->
                Obj.magic k x2))
          | Compilers.Coq_type.Coq_arrow (_, d) ->
            (fun k ->
              Obj.magic (fun v ->
                splice_under_lets_with_value0 __ d x1 (fun x' ->
                  Obj.magic k x' v)))
        in splice_under_lets_with_value0 __ t0 x x0

      (** val splice_value_with_lets :
          'a1 Compilers.Coq_type.coq_type -> 'a1 Compilers.Coq_type.coq_type
          -> ('a1, 'a2, 'a3) value_with_lets -> (('a1, 'a2, 'a3) value ->
          ('a1, 'a2, 'a3) value_with_lets) -> ('a1, 'a2, 'a3) value_with_lets **)

      let splice_value_with_lets t0 t' =
        match t0 with
        | Compilers.Coq_type.Coq_base _ ->
          (fun e k -> splice_under_lets_with_value t' (Obj.magic e) k)
        | Compilers.Coq_type.Coq_arrow (_, _) -> (fun e k -> k e)

      (** val reify :
          bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value' -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr **)

      let reify with_lets =
        let rec reify0 with_lets0 = function
        | Compilers.Coq_type.Coq_base t1 ->
          if with_lets0
          then (fun v ->
                 Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
                   t1) (Obj.magic v))
          else (fun v -> Obj.magic v)
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          (fun f -> Compilers.Coq_expr.Abs (s0, d, (fun x ->
            reify0 true d
              (Obj.magic f
                (reflect0 false s0 (Compilers.Coq_expr.Var (s0, x)))))))
        and reflect0 with_lets0 = function
        | Compilers.Coq_type.Coq_base _ ->
          if with_lets0
          then (fun v -> Coq_Compilers.UnderLets.Base v)
          else (fun v -> Obj.magic v)
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          (fun f ->
            Obj.magic (fun x ->
              reflect0 true d (Compilers.Coq_expr.App (s0, d, f,
                (reify0 false s0 x)))))
        in reify0 with_lets

      (** val reflect :
          bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value' **)

      let reflect with_lets =
        let rec reify0 with_lets0 = function
        | Compilers.Coq_type.Coq_base t1 ->
          if with_lets0
          then (fun v ->
                 Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
                   t1) v)
          else (fun v -> Obj.magic v)
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          (fun f -> Compilers.Coq_expr.Abs (s0, d, (fun x ->
            reify0 true d
              (Obj.magic f
                (reflect0 false s0 (Compilers.Coq_expr.Var (s0, x)))))))
        and reflect0 with_lets0 = function
        | Compilers.Coq_type.Coq_base _ ->
          if with_lets0
          then (fun v -> Obj.magic (Coq_Compilers.UnderLets.Base v))
          else (fun v -> Obj.magic v)
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          (fun f ->
            Obj.magic (fun x ->
              reflect0 true d (Compilers.Coq_expr.App (s0, d, f,
                (reify0 false s0 x)))))
        in reflect0 with_lets

      (** val reflect_expr_beta_iota :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value option) ->
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Coq_Compilers.UnderLets.coq_UnderLets **)

      let reflect_expr_beta_iota reflect_ident_iota0 =
        let rec reflect_expr_beta_iota0 _ = function
        | Compilers.Coq_expr.Ident (t0, idc) ->
          Coq_Compilers.UnderLets.Base
            (match reflect_ident_iota0 t0 idc with
             | Some ridc -> ridc
             | None -> reflect false t0 (Compilers.Coq_expr.Ident (t0, idc)))
        | Compilers.Coq_expr.Var (_, v) -> Coq_Compilers.UnderLets.Base v
        | Compilers.Coq_expr.Abs (_, d, f) ->
          Coq_Compilers.UnderLets.Base
            (Obj.magic (fun x ->
              splice_under_lets_with_value d
                (reflect_expr_beta_iota0 d (f x)) (fun fx ->
                coq_Base_value d fx)))
        | Compilers.Coq_expr.App (s0, d0, f, x) ->
          (match d0 with
           | Compilers.Coq_type.Coq_base d ->
             (fun f0 ->
               Coq_Compilers.UnderLets.splice
                 (Obj.magic reflect_expr_beta_iota0
                   (Compilers.Coq_type.Coq_arrow (s0,
                   (Compilers.Coq_type.Coq_base d))) f0) (fun f1 ->
                 Coq_Compilers.UnderLets.splice
                   (reflect_expr_beta_iota0 s0 x) f1))
           | Compilers.Coq_type.Coq_arrow (s1, d) ->
             (fun f0 ->
               Coq_Compilers.UnderLets.splice
                 (Obj.magic reflect_expr_beta_iota0
                   (Compilers.Coq_type.Coq_arrow (s0,
                   (Compilers.Coq_type.Coq_arrow (s1, d)))) f0) (fun f1 ->
                 Coq_Compilers.UnderLets.splice
                   (reflect_expr_beta_iota0 s0 x) (fun x0 ->
                   Coq_Compilers.UnderLets.Base (f1 x0))))) f
        | Compilers.Coq_expr.LetIn (a, b, x, f) ->
          Coq_Compilers.UnderLets.splice (reflect_expr_beta_iota0 a x)
            (fun x0 -> Coq_Compilers.UnderLets.UnderLet (a,
            (reify false a x0), (fun xv ->
            reflect_expr_beta_iota0 b
              (f (reflect false a (Compilers.Coq_expr.Var (a, xv)))))))
        in reflect_expr_beta_iota0

      (** val reify_to_UnderLets :
          bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value' -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets **)

      let reify_to_UnderLets with_lets = function
      | Compilers.Coq_type.Coq_base _ ->
        if with_lets
        then (fun v -> Obj.magic v)
        else (fun v -> Coq_Compilers.UnderLets.Base (Obj.magic v))
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun f -> Coq_Compilers.UnderLets.Base
          (reify with_lets (Compilers.Coq_type.Coq_arrow (s0, d)) f))

      (** val reify_expr_beta_iota :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value option) ->
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets **)

      let reify_expr_beta_iota reflect_ident_iota0 t0 e =
        Coq_Compilers.UnderLets.splice
          (reflect_expr_beta_iota reflect_ident_iota0 t0 e) (fun e0 ->
          reify_to_UnderLets false t0 e0)

      (** val reify_and_let_binds_cps :
          ('a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr -> __ -> (('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, __)
          Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, __)
          Coq_Compilers.UnderLets.coq_UnderLets) -> bool -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value' ->
          (('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, 'a4)
          Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, 'a4)
          Coq_Compilers.UnderLets.coq_UnderLets **)

      let reify_and_let_binds_cps reify_and_let_binds_base_cps0 with_lets t0 x x0 =
        (match t0 with
         | Compilers.Coq_type.Coq_base t1 ->
           if with_lets
           then (fun v _ k ->
                  Coq_Compilers.UnderLets.splice (Obj.magic v) (fun v' ->
                    Obj.magic reify_and_let_binds_base_cps0 t1 v' __ k))
           else Obj.magic reify_and_let_binds_base_cps0 t1
         | Compilers.Coq_type.Coq_arrow (s0, d) ->
           (fun f _ k ->
             k (reify with_lets (Compilers.Coq_type.Coq_arrow (s0, d)) f))) x
          __ x0

      type ('base, 'ident, 'var) rawexpr =
      | Coq_rIdent of bool
         * 'base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type * 'ident
         * 'base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
           Compilers.Coq_expr.expr
      | Coq_rApp of ('base, 'ident, 'var) rawexpr
         * ('base, 'ident, 'var) rawexpr
         * 'base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
           Compilers.Coq_expr.expr
      | Coq_rExpr of 'base Compilers.Coq_base.Coq_type.coq_type
                     Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
           Compilers.Coq_expr.expr
      | Coq_rValue of 'base Compilers.Coq_base.Coq_type.coq_type
                      Compilers.Coq_type.coq_type
         * ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var) value

      (** val type_of_rawexpr :
          ('a1, 'a2, 'a3) rawexpr -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type **)

      let type_of_rawexpr = function
      | Coq_rIdent (_, _, _, t', _) -> t'
      | Coq_rApp (_, _, t0, _) -> t0
      | Coq_rExpr (t0, _) -> t0
      | Coq_rValue (t0, _) -> t0

      (** val expr_of_rawexpr :
          ('a1, 'a2, 'a3) rawexpr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr **)

      let expr_of_rawexpr = function
      | Coq_rIdent (_, _, _, _, alt) -> alt
      | Coq_rApp (_, _, _, alt) -> alt
      | Coq_rExpr (_, e0) -> e0
      | Coq_rValue (t0, e0) -> reify false t0 e0

      (** val value_of_rawexpr :
          ('a1, 'a2, 'a3) rawexpr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value **)

      let value_of_rawexpr = function
      | Coq_rIdent (known, t0, idc, t', alt) ->
        reflect false
          (type_of_rawexpr (Coq_rIdent (known, t0, idc, t', alt))) alt
      | Coq_rApp (f, x, t0, alt) ->
        reflect false (type_of_rawexpr (Coq_rApp (f, x, t0, alt))) alt
      | Coq_rExpr (t0, e0) ->
        reflect false (type_of_rawexpr (Coq_rExpr (t0, e0))) e0
      | Coq_rValue (_, e0) -> e0

      (** val rValueOrExpr2 :
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr -> ('a1, 'a2, 'a3) rawexpr **)

      let rValueOrExpr2 = function
      | Compilers.Coq_type.Coq_base t1 ->
        (fun _ e -> Coq_rExpr ((Compilers.Coq_type.Coq_base t1), e))
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun v _ -> Coq_rValue ((Compilers.Coq_type.Coq_arrow (s0, d)), v))

      (** val reveal_rawexpr_cps_gen :
          bool option -> ('a1, 'a2, 'a3) rawexpr -> (('a1, 'a2, 'a3) rawexpr
          -> 'a4) -> 'a4 **)

      let reveal_rawexpr_cps_gen assume_known e k =
        match e with
        | Coq_rIdent (_, t0, idc, t', alt) ->
          (match assume_known with
           | Some known -> k (Coq_rIdent (known, t0, idc, t', alt))
           | None -> k e)
        | Coq_rApp (_, _, _, _) -> k e
        | Coq_rExpr (t0, e0) ->
          (match e0 with
           | Compilers.Coq_expr.Ident (t1, idc) ->
             k (Coq_rIdent
               ((match assume_known with
                 | Some known -> known
                 | None -> false), t1, idc, t0, e0))
           | Compilers.Coq_expr.Var (_, _) -> k e
           | Compilers.Coq_expr.Abs (_, _, _) -> k e
           | Compilers.Coq_expr.App (s0, d, f, x) ->
             k (Coq_rApp ((Coq_rExpr ((Compilers.Coq_type.Coq_arrow (s0, d)),
               f)), (Coq_rExpr (s0, x)), t0, e0))
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> k e)
        | Coq_rValue (t0, e0) ->
          (match t0 with
           | Compilers.Coq_type.Coq_base t1 ->
             (fun e1 ->
               match Obj.magic e1 with
               | Compilers.Coq_expr.Ident (t2, idc) ->
                 k (Coq_rIdent
                   ((match assume_known with
                     | Some known -> known
                     | None -> false), t2, idc, (Compilers.Coq_type.Coq_base
                   t1), (Obj.magic e1)))
               | Compilers.Coq_expr.Var (_, _) -> k e
               | Compilers.Coq_expr.Abs (_, _, _) -> k e
               | Compilers.Coq_expr.App (s0, d, f, x) ->
                 k (Coq_rApp ((Coq_rExpr ((Compilers.Coq_type.Coq_arrow (s0,
                   d)), f)), (Coq_rExpr (s0, x)),
                   (Compilers.Coq_type.Coq_base t1), (Obj.magic e1)))
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> k e)
           | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> k e)) e0

      (** val reveal_rawexpr_cps :
          ('a1, 'a2, 'a3) rawexpr -> (('a1, 'a2, 'a3) rawexpr -> 'a4) -> 'a4 **)

      let reveal_rawexpr_cps e x =
        reveal_rawexpr_cps_gen None e x

      type ('base, 'pident, 'var) unification_resultT' = __

      type ('base, 'pident, 'var, 'k) with_unification_resultT' = __

      (** val app_transport_with_unification_resultT'_cps :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> __ list) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2) Coq_pattern.pattern ->
          'a1 Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> ('a1, 'a2,
          'a3, 'a4) with_unification_resultT' -> ('a1, 'a2, 'a3)
          unification_resultT' -> ('a4 -> 'a5 option) -> 'a5 option **)

      let app_transport_with_unification_resultT'_cps try_make_transport_base_type_cps pident_arg_types t0 p evm1 evm2 x x0 x1 =
        let rec app_transport_with_unification_resultT'_cps0 _ _ p0 evm3 evm4 _ f x2 _ k =
          (match p0 with
           | Coq_pattern.Wildcard t1 ->
             (fun f0 x3 ->
               cpscall (fun _ ->
                 Compilers.Coq_type.try_make_transport_cps (fun _ x4 x5 _ ->
                   Compilers.Coq_base.try_make_transport_cps
                     try_make_transport_base_type_cps x4 x5)
                   (Coq0_Compilers.Coq_pattern.Coq_type.subst_default t1 evm4)
                   (Coq0_Compilers.Coq_pattern.Coq_type.subst_default t1 evm3))
                 (fun tr -> bind1 tr (fun tr0 -> k (Obj.magic f0 (tr0 x3)))))
           | Coq_pattern.Ident (t1, idc) ->
             (fun f0 x3 ->
               k
                 (Coq0_Compilers.app_type_of_list (pident_arg_types t1 idc)
                   f0 x3))
           | Coq_pattern.App (s0, d, f0, x3) ->
             (fun f1 xy ->
               Obj.magic app_transport_with_unification_resultT'_cps0 __
                 (Compilers.Coq_type.Coq_arrow (s0, d)) f0 evm3 evm4 __ f1
                 (fst (Obj.magic xy)) __ (fun f' ->
                 app_transport_with_unification_resultT'_cps0 __ s0 x3 evm3
                   evm4 __ f' (snd (Obj.magic xy)) __ k))) f x2
        in app_transport_with_unification_resultT'_cps0 __ t0 p evm1 evm2 __
             x x0 __ x1

      type ('base, 'pident, 'var, 'k) with_unification_resultT =
        ('base, ('base, 'pident, 'var, 'k) with_unification_resultT')
        Coq_pattern.Coq_type.forall_vars

      type ('base, 'pident, 'var) unification_resultT =
        ('base Compilers.Coq_base.Coq_type.coq_type PositiveMap.t, ('base,
        'pident, 'var) unification_resultT') sigT

      (** val app_with_unification_resultT_cps :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> __ list) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2) Coq_pattern.pattern ->
          ('a1, 'a2, 'a3, 'a4) with_unification_resultT -> ('a1, 'a2, 'a3)
          unification_resultT -> (('a1 Compilers.Coq_base.Coq_type.coq_type
          PositiveMap.t, 'a4) sigT -> 'a5 option) -> 'a5 option **)

      let app_with_unification_resultT_cps try_make_transport_base_type_cps pident_arg_types t0 p f x k =
        bind1
          (Coq_pattern.Coq_type.app_forall_vars
            (Coq_pattern.collect_vars t0 p) f (projT1 x)) (fun f' ->
          app_transport_with_unification_resultT'_cps
            try_make_transport_base_type_cps pident_arg_types t0 p
            (fold_right (fun i k0 evm' ->
              k0
                (match PositiveMap.find i (projT1 x) with
                 | Some v -> PositiveMap.add i v evm'
                 | None -> evm')) (fun evm -> evm)
              (rev1 (PositiveSet.elements (Coq_pattern.collect_vars t0 p)))
              PositiveMap.empty) (projT1 x) f' (projT2 x) (fun fx ->
            k (ExistT
              ((fold_right (fun i k0 evm' ->
                 k0
                   (match PositiveMap.find i (projT1 x) with
                    | Some v -> PositiveMap.add i v evm'
                    | None -> evm')) (fun evm -> evm)
                 (rev1 (PositiveSet.elements (Coq_pattern.collect_vars t0 p)))
                 PositiveMap.empty), fx))))

      (** val preunify_types :
          ('a1 -> 'a1 -> bool) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1,
          'a4) Coq_pattern.pattern -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type * 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type)
          option option **)

      let preunify_types base_beq0 =
        let rec preunify_types0 _ e = function
        | Coq_pattern.Wildcard t0 -> Some (Some (t0, (type_of_rawexpr e)))
        | Coq_pattern.Ident (pt, _) ->
          (match e with
           | Coq_rIdent (known, t0, _, _, _) ->
             if (&&) known
                  (Compilers.Coq_type.type_beq
                    (Compilers.Coq_pattern.Coq_base.Coq_type.type_beq
                      base_beq0) pt
                    (Coq0_Compilers.Coq_pattern.Coq_type.relax t0))
             then Some None
             else Some (Some (pt, t0))
           | Coq_rApp (_, _, _, _) -> None
           | Coq_rExpr (_, _) -> None
           | Coq_rValue (_, _) -> None)
        | Coq_pattern.App (s0, d, pf, px) ->
          (match e with
           | Coq_rIdent (_, _, _, _, _) -> None
           | Coq_rApp (f, x, _, _) ->
             bind1
               (preunify_types0 (Compilers.Coq_type.Coq_arrow (s0, d)) f pf)
               (fun resa ->
               bind1 (preunify_types0 s0 x px) (fun resb -> Some
                 (match resa with
                  | Some t0 ->
                    let (a, a') = t0 in
                    (match resb with
                     | Some p0 ->
                       let (b, b') = p0 in
                       Some ((Compilers.Coq_type.Coq_arrow (a, b)),
                       (Compilers.Coq_type.Coq_arrow (a', b')))
                     | None -> Some t0)
                  | None ->
                    (match resb with
                     | Some t0 -> Some t0
                     | None -> None))))
           | Coq_rExpr (_, _) -> None
           | Coq_rValue (_, _) -> None)
        in preunify_types0

      (** val option_type_type_beq :
          ('a1 -> 'a1 -> bool) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type option -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
          option -> bool **)

      let option_type_type_beq base_beq0 =
        option_beq0
          (Compilers.Coq_type.type_beq
            (Compilers.Coq_base.Coq_type.type_beq base_beq0))

      (** val unify_types :
          ('a1 -> 'a1 -> bool) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1,
          'a4) Coq_pattern.pattern -> ('a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t option -> 'a5)
          -> 'a5 **)

      let unify_types base_beq0 t0 e p k =
        match preunify_types base_beq0 t0 e p with
        | Some o ->
          (match o with
           | Some p0 ->
             let (pt, t1) = p0 in
             (match Coq_pattern.Coq_type.unify_extracted base_beq0 pt t1 with
              | Some vars0 ->
                Coq_pattern.Coq_type.add_var_types_cps pt vars0
                  PositiveMap.empty (fun evm ->
                  if option_type_type_beq base_beq0
                       (Coq_pattern.Coq_type.subst pt evm) (Some t1)
                  then k (Some evm)
                  else k None)
              | None -> k None)
           | None -> k (Some PositiveMap.empty))
        | None -> k None

      (** val option_bind' :
          'a1 option -> ('a1 -> 'a2 option) -> 'a2 option **)

      let option_bind' =
        bind1

      (** val reveal_rawexpr_of_pattern_cps :
          'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1,
          'a4) Coq_pattern.pattern -> (('a1, 'a2, 'a3) rawexpr -> 'a5) -> 'a5 **)

      let reveal_rawexpr_of_pattern_cps t0 e p x =
        let rec reveal_rawexpr_of_pattern_cps0 _ e0 = function
        | Coq_pattern.Wildcard _ -> (fun _ k -> k e0)
        | Coq_pattern.Ident (_, _) -> (fun _ -> reveal_rawexpr_cps e0)
        | Coq_pattern.App (s0, d, pf, px) ->
          (fun _ k ->
            reveal_rawexpr_cps e0 (fun e1 ->
              match e1 with
              | Coq_rIdent (_, _, _, _, _) -> k e1
              | Coq_rApp (f, x0, t1, alt) ->
                reveal_rawexpr_of_pattern_cps0 (Compilers.Coq_type.Coq_arrow
                  (s0, d)) f pf __ (fun f0 ->
                  reveal_rawexpr_of_pattern_cps0 s0 x0 px __ (fun x1 ->
                    k (Coq_rApp (f0, x1, t1, alt))))
              | Coq_rExpr (_, _) -> k e1
              | Coq_rValue (_, _) -> k e1))
        in reveal_rawexpr_of_pattern_cps0 t0 e p __ x

      (** val unify_pattern' :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1,
          'a4) Coq_pattern.pattern -> 'a1
          Compilers.Coq_base.Coq_type.coq_type PositiveMap.t -> (('a1, 'a4,
          ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          unification_resultT' -> 'a5 option) -> 'a5 option **)

      let unify_pattern' try_make_transport_base_type_cps _ pident_unify pident_unify_unknown t0 e p evm x =
        let rec unify_pattern'0 _ e0 p0 evm0 =
          match p0 with
          | Coq_pattern.Wildcard t' ->
            (fun _ k ->
              cpscall (fun _ ->
                Compilers.Coq_type.try_make_transport_cps (fun _ x0 x1 _ ->
                  Compilers.Coq_base.try_make_transport_cps
                    try_make_transport_base_type_cps x0 x1)
                  (type_of_rawexpr e0)
                  (Coq0_Compilers.Coq_pattern.Coq_type.subst_default t' evm0))
                (fun tro ->
                bind1 tro (fun tr ->
                  bind1 (Coq_pattern.Coq_type.subst t' evm0) (fun _ ->
                    k (tr (value_of_rawexpr e0))))))
          | Coq_pattern.Ident (t1, pidc) ->
            (match e0 with
             | Coq_rIdent (known, t2, idc, _, _) ->
               (fun _ k ->
                 (if known
                  then bind1 (pident_unify t1 t2 pidc idc)
                  else option_bind' (pident_unify_unknown t1 t2 pidc idc)) k)
             | Coq_rApp (_, _, _, _) -> (fun _ _ -> None)
             | Coq_rExpr (_, _) -> (fun _ _ -> None)
             | Coq_rValue (_, _) -> (fun _ _ -> None))
          | Coq_pattern.App (s0, d, pf, px) ->
            (match e0 with
             | Coq_rIdent (_, _, _, _, _) -> (fun _ _ -> None)
             | Coq_rApp (f, x0, _, _) ->
               (fun _ k ->
                 unify_pattern'0 (Compilers.Coq_type.Coq_arrow (s0, d)) f pf
                   evm0 __ (fun fv ->
                   unify_pattern'0 s0 x0 px evm0 __ (fun xv ->
                     Obj.magic k (fv, xv))))
             | Coq_rExpr (_, _) -> (fun _ _ -> None)
             | Coq_rValue (_, _) -> (fun _ _ -> None))
        in unify_pattern'0 t0 e p evm __ x

      (** val reveal_rawexpr_of_pattern_as_necessary_cps :
          bool -> 'a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1,
          'a4) Coq_pattern.pattern -> (('a1, 'a2, 'a3) rawexpr -> 'a5) -> 'a5 **)

      let reveal_rawexpr_of_pattern_as_necessary_cps reveal_as_necessary t0 e p x =
        (if reveal_as_necessary
         then (fun _ -> reveal_rawexpr_of_pattern_cps t0 e p)
         else (fun _ k -> k e)) __ x

      (** val unify_pattern :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
          bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> bool -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1,
          'a4) Coq_pattern.pattern -> (('a1, 'a4, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          unification_resultT -> 'a5 option) -> 'a5 option **)

      let unify_pattern try_make_transport_base_type_cps base_beq0 pident_arg_types pident_unify pident_unify_unknown reveal_as_necessary t0 e p cont =
        reveal_rawexpr_of_pattern_as_necessary_cps reveal_as_necessary t0 e p
          (fun e0 ->
          unify_types base_beq0 t0 e0 p (fun evm ->
            bind1 evm (fun evm0 ->
              unify_pattern' try_make_transport_base_type_cps
                pident_arg_types pident_unify pident_unify_unknown t0 e0 p
                evm0 (fun v -> cont (ExistT (evm0, v))))))

      type 'raw_pident decision_tree =
      | TryLeaf of nat * 'raw_pident decision_tree
      | Failure
      | Switch of ('raw_pident * 'raw_pident decision_tree) list
         * 'raw_pident decision_tree option * 'raw_pident decision_tree
      | Swap of nat * 'raw_pident decision_tree

      (** val swap_list : nat -> nat -> 'a1 list -> 'a1 list option **)

      let swap_list i j ls =
        match nth_error ls i with
        | Some vi ->
          (match nth_error ls j with
           | Some vj -> Some (set_nth0 i vj (set_nth0 j vi ls))
           | None -> None)
        | None -> None

      (** val eval_decision_tree :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> 'a4 -> 'a5 option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a4 -> 'a5 option) -> ('a4 -> 'a5 -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type)
          -> ('a4 -> 'a5 -> 'a2) -> ('a4 -> bool) -> ('a1, 'a2, 'a3) rawexpr
          list -> 'a4 decision_tree -> (nat -> ('a1, 'a2, 'a3) rawexpr list
          -> 'a6 option) -> 'a6 option **)

      let eval_decision_tree invert_bind_args0 invert_bind_args_unknown0 type_of_raw_pident raw_pident_to_typed raw_pident_is_simple ctx d cont =
        let rec eval_decision_tree0 _ ctx0 d0 cont0 =
          match d0 with
          | TryLeaf (k, onfailure) ->
            let res = cont0 k ctx0 in
            (match onfailure with
             | TryLeaf (_, _) ->
               sequence res (eval_decision_tree0 __ ctx0 onfailure cont0)
             | Failure -> res
             | Switch (_, _, _) ->
               sequence res (eval_decision_tree0 __ ctx0 onfailure cont0)
             | Swap (_, _) ->
               sequence res (eval_decision_tree0 __ ctx0 onfailure cont0))
          | Failure -> None
          | Switch (icases, app_case, default_case) ->
            (match ctx0 with
             | [] -> None
             | ctx1 :: ctx' ->
               let res =
                 reveal_rawexpr_cps ctx1 (fun ctx0' ->
                   match ctx0' with
                   | Coq_rIdent (known, t0, idc, t', alt) ->
                     sequence_return0
                       (fold_right (fun pat ->
                         let (pidc, icase) = pat in
                         (fun rest ->
                         let res =
                           if known
                           then bind1 (invert_bind_args0 t0 idc pidc)
                                  (fun args0 ->
                                  eval_decision_tree0 __ ctx' icase
                                    (fun k ctx'' ->
                                    cont0 k ((Coq_rIdent
                                      ((raw_pident_is_simple pidc),
                                      (type_of_raw_pident pidc args0),
                                      (raw_pident_to_typed pidc args0), t',
                                      alt)) :: ctx'')))
                           else eval_decision_tree0 __ ctx' icase
                                  (fun k ctx'' ->
                                  option_bind'
                                    (invert_bind_args_unknown0 t0 idc pidc)
                                    (fun args0 ->
                                    cont0 k ((Coq_rIdent
                                      ((raw_pident_is_simple pidc),
                                      (type_of_raw_pident pidc args0),
                                      (raw_pident_to_typed pidc args0), t',
                                      alt)) :: ctx'')))
                         in
                         (match rest with
                          | Some rest0 -> Some (sequence res rest0)
                          | None -> Some res))) None icases) None
                   | Coq_rApp (f, x, t0, alt) ->
                     (match app_case with
                      | Some app_case0 ->
                        eval_decision_tree0 __ (f :: (x :: ctx')) app_case0
                          (fun k ctx'' ->
                          match ctx'' with
                          | [] -> None
                          | f' :: l ->
                            (match l with
                             | [] -> None
                             | x' :: ctx''' ->
                               cont0 k ((Coq_rApp (f', x', t0,
                                 alt)) :: ctx''')))
                      | None -> None)
                   | Coq_rExpr (_, _) -> None
                   | Coq_rValue (_, _) -> None)
               in
               (match default_case with
                | TryLeaf (_, _) ->
                  sequence res
                    (eval_decision_tree0 __ ctx0 default_case cont0)
                | Failure -> res
                | Switch (_, _, _) ->
                  sequence res
                    (eval_decision_tree0 __ ctx0 default_case cont0)
                | Swap (_, _) ->
                  sequence res
                    (eval_decision_tree0 __ ctx0 default_case cont0)))
          | Swap (i, d') ->
            (match swap_list O i ctx0 with
             | Some ctx' ->
               eval_decision_tree0 __ ctx' d' (fun k ctx'' ->
                 match swap_list O i ctx'' with
                 | Some ctx''' -> cont0 k ctx'''
                 | None -> None)
             | None -> None)
        in eval_decision_tree0 __ ctx d cont

      type ('base, 'ident, 'var) deep_rewrite_ruleTP_gen = __

      (** val normalize_deep_rewrite_rule :
          bool -> bool -> bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
          deep_rewrite_ruleTP_gen -> ('a1, 'a2, 'a3) deep_rewrite_ruleTP_gen **)

      let normalize_deep_rewrite_rule _ with_opt under_lets _ =
        if with_opt
        then if under_lets
             then (fun x -> x)
             else (fun x ->
                    Obj.magic bind1 x (fun x0 -> Some
                      (Coq_Compilers.UnderLets.Base x0)))
        else if under_lets
             then (fun x -> Obj.magic (Some x))
             else (fun x -> Obj.magic (Some (Coq_Compilers.UnderLets.Base x)))

      type ('base, 'ident, 'var0, 'pident, 'var) with_unif_rewrite_ruleTP_gen =
        ('base, 'pident, 'var, __) with_unification_resultT

      type ('base, 'ident, 'var, 'pident) rewrite_rule_data = { rew_should_do_again : 
                                                                bool;
                                                                rew_with_opt : 
                                                                bool;
                                                                rew_under_lets : 
                                                                bool;
                                                                rew_replacement : 
                                                                ('base,
                                                                'ident, 'var,
                                                                'pident,
                                                                ('base
                                                                Compilers.Coq_base.Coq_type.coq_type,
                                                                'ident, 'var)
                                                                value)
                                                                with_unif_rewrite_ruleTP_gen }

      (** val rew_should_do_again :
          ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
          ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> bool **)

      let rew_should_do_again _ _ _ r0 =
        r0.rew_should_do_again

      (** val rew_with_opt :
          ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
          ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> bool **)

      let rew_with_opt _ _ _ r0 =
        r0.rew_with_opt

      (** val rew_under_lets :
          ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
          ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> bool **)

      let rew_under_lets _ _ _ r0 =
        r0.rew_under_lets

      (** val rew_replacement :
          ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> 'a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a4) Coq_pattern.pattern ->
          ('a1, 'a2, 'a3, 'a4) rewrite_rule_data -> ('a1, 'a2, 'a3, 'a4, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          with_unif_rewrite_ruleTP_gen **)

      let rew_replacement _ _ _ r0 =
        r0.rew_replacement

      type ('base, 'ident, 'var, 'pident) rewrite_ruleTP =
        ('base, 'ident, 'var, 'pident) rewrite_rule_data

      type ('base, 'ident, 'var, 'pident) rewrite_ruleT =
        (('base, 'pident) Coq_pattern.anypattern, ('base, 'ident, 'var,
        'pident) rewrite_ruleTP) sigT

      type ('base, 'ident, 'var, 'pident) rewrite_rulesT =
        ('base, 'ident, 'var, 'pident) rewrite_ruleT list

      type ('base, 'ident, 'var) maybe_do_againT =
        ('base Compilers.Coq_base.Coq_type.coq_type, 'ident, __)
        Compilers.Coq_expr.expr -> ('base
        Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var, ('base
        Compilers.Coq_base.Coq_type.coq_type, 'ident, 'var)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets

      (** val maybe_do_again :
          ('a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type -> ('a1, 'a2, 'a3)
          maybe_do_againT **)

      let maybe_do_again do_again should_do_again t0 =
        if should_do_again
        then do_again t0
        else Obj.magic (fun x -> Coq_Compilers.UnderLets.Base x)

      (** val rewrite_with_rule :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
          bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> ('a1,
          'a2, 'a3, 'a4) rewrite_ruleT -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets
          option **)

      let rewrite_with_rule try_make_transport_base_type_cps base_beq0 pident_arg_types pident_unify pident_unify_unknown =
        let base' = fun _ x -> Compilers.Coq_type.Coq_base x in
        (fun do_again deeper t0 e' pf ->
        let ExistT (p, f) = pf in
        let should_do_again = f.rew_should_do_again in
        unify_pattern try_make_transport_base_type_cps base_beq0
          pident_arg_types pident_unify pident_unify_unknown deeper
          p.Coq_pattern.type_of_anypattern e'
          p.Coq_pattern.pattern_of_anypattern (fun x ->
          app_with_unification_resultT_cps try_make_transport_base_type_cps
            pident_arg_types p.Coq_pattern.type_of_anypattern
            p.Coq_pattern.pattern_of_anypattern f.rew_replacement x
            (fun f' ->
            cpscall (fun _ ->
              Compilers.Coq_type.try_make_transport_cps (fun _ x0 x1 _ ->
                Compilers.Coq_base.try_make_transport_cps
                  try_make_transport_base_type_cps x0 x1)
                (Coq0_Compilers.Coq_pattern.Coq_type.subst_default
                  p.Coq_pattern.type_of_anypattern (projT1 f'))
                (base' __
                  (match type_of_rawexpr e' with
                   | Compilers.Coq_type.Coq_base t' -> t'
                   | Compilers.Coq_type.Coq_arrow (_, _) ->
                     Compilers.Coq_base.Coq_type.Coq_unit))) (fun tr ->
              bind1 tr (fun tr0 ->
                cpscall (fun _ ->
                  Compilers.Coq_type.try_make_transport_cps (fun _ x0 x1 _ ->
                    Compilers.Coq_base.try_make_transport_cps
                      try_make_transport_base_type_cps x0 x1)
                    (base' __
                      (match type_of_rawexpr e' with
                       | Compilers.Coq_type.Coq_base t' -> t'
                       | Compilers.Coq_type.Coq_arrow (_, _) ->
                         Compilers.Coq_base.Coq_type.Coq_unit)) t0)
                  (fun tr' ->
                  bind1 tr' (fun tr'0 ->
                    option_bind'
                      (Obj.magic normalize_deep_rewrite_rule
                        f.rew_should_do_again f.rew_with_opt f.rew_under_lets
                        (Coq0_Compilers.Coq_pattern.Coq_type.subst_default
                          p.Coq_pattern.type_of_anypattern (projT1 f'))
                        (projT2 f')) (fun fv -> Some
                      (Coq_Compilers.UnderLets.splice fv (fun fv0 ->
                        Coq_Compilers.UnderLets.splice
                          (maybe_do_again do_again should_do_again
                            (match type_of_rawexpr e' with
                             | Compilers.Coq_type.Coq_base t' -> t'
                             | Compilers.Coq_type.Coq_arrow (_, _) ->
                               Compilers.Coq_base.Coq_type.Coq_unit)
                            (tr0 fv0)) (fun fv1 ->
                          Coq_Compilers.UnderLets.Base (tr'0 fv1))))))))))))

      (** val eval_rewrite_rules :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
          bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a5 -> 'a6 option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a5 -> 'a6 option) -> ('a5 -> 'a6 -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type)
          -> ('a5 -> 'a6 -> 'a2) -> ('a5 -> bool) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          'a5 decision_tree option -> ('a1, 'a2, 'a3, 'a4) rewrite_rulesT ->
          ('a1, 'a2, 'a3) rawexpr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets **)

      let eval_rewrite_rules try_make_transport_base_type_cps base_beq0 pident_arg_types pident_unify pident_unify_unknown invert_bind_args0 invert_bind_args_unknown0 type_of_raw_pident raw_pident_to_typed raw_pident_is_simple do_again d rews e =
        let defaulte = expr_of_rawexpr e in
        (match d with
         | Some d0 ->
           sequence_return0
             (eval_decision_tree invert_bind_args0 invert_bind_args_unknown0
               type_of_raw_pident raw_pident_to_typed raw_pident_is_simple
               (e :: []) d0 (fun k ctx ->
               match ctx with
               | [] -> None
               | e' :: l ->
                 (match l with
                  | [] ->
                    bind1 (nth_error rews k) (fun pf ->
                      rewrite_with_rule try_make_transport_base_type_cps
                        base_beq0 pident_arg_types pident_unify
                        pident_unify_unknown do_again false
                        (type_of_rawexpr e) e' pf)
                  | _ :: _ -> None))) (Coq_Compilers.UnderLets.Base defaulte)
         | None ->
           fold_right (fun pf res ->
             sequence_return0
               (rewrite_with_rule try_make_transport_base_type_cps base_beq0
                 pident_arg_types pident_unify pident_unify_unknown do_again
                 true (type_of_rawexpr e) e pf) res)
             (Coq_Compilers.UnderLets.Base defaulte) rews)

      (** val assemble_identifier_rewriters' :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
          bool) -> ('a1 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a5 -> 'a6 option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a5 -> 'a6 option) -> ('a5 -> 'a6 -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type)
          -> ('a5 -> 'a6 -> 'a2) -> ('a5 -> bool) -> 'a5 decision_tree option
          -> ('a1, 'a2, 'a3, 'a4) rewrite_rulesT -> ('a1
          Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3) rawexpr -> (__ -> __
          -> __) -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          value_with_lets **)

      let assemble_identifier_rewriters' try_make_transport_base_type_cps base_beq0 pident_arg_types pident_unify pident_unify_unknown invert_bind_args0 invert_bind_args_unknown0 type_of_raw_pident raw_pident_to_typed raw_pident_is_simple dtree0 rewrite_rules0 do_again =
        let dorewrite1 = fun e ->
          eval_rewrite_rules try_make_transport_base_type_cps base_beq0
            pident_arg_types pident_unify pident_unify_unknown
            invert_bind_args0 invert_bind_args_unknown0 type_of_raw_pident
            raw_pident_to_typed raw_pident_is_simple do_again dtree0
            rewrite_rules0 e
        in
        let rec assemble_identifier_rewriters'0 = function
        | Compilers.Coq_type.Coq_base _ ->
          (fun e k -> Obj.magic k __ (dorewrite1 e))
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          (fun f k ->
            Obj.magic (fun x ->
              let x' = reify false s0 x in
              assemble_identifier_rewriters'0 d (Coq_rApp (f,
                (rValueOrExpr2 s0 x x'), d, (Compilers.Coq_expr.App (s0, d,
                (Obj.magic k __ (expr_of_rawexpr f)), x')))) (fun _ -> id)))
        in assemble_identifier_rewriters'0

      (** val assemble_identifier_rewriters :
          'a1 Compilers.Coq_type.try_make_transport_cpsT -> ('a1 -> 'a1 ->
          bool) -> (__ -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> __) -> __) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a4 -> __ list) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a4 -> 'a2 -> __ option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a5 -> 'a6 option) -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> 'a5 -> 'a6 option) -> ('a5 -> 'a6 -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type)
          -> ('a5 -> 'a6 -> 'a2) -> ('a5 -> bool) -> 'a5 decision_tree option
          -> ('a1, 'a2, 'a3, 'a4) rewrite_rulesT -> ('a1
          Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) value_with_lets **)

      let assemble_identifier_rewriters try_make_transport_base_type_cps base_beq0 eta_ident_cps0 pident_arg_types pident_unify pident_unify_unknown invert_bind_args0 invert_bind_args_unknown0 type_of_raw_pident raw_pident_to_typed raw_pident_is_simple dtree0 rewrite_rules0 do_again t0 idc =
        eta_ident_cps0 __ t0 idc (fun t' idc' ->
          assemble_identifier_rewriters' try_make_transport_base_type_cps
            base_beq0 pident_arg_types pident_unify pident_unify_unknown
            invert_bind_args0 invert_bind_args_unknown0 type_of_raw_pident
            raw_pident_to_typed raw_pident_is_simple dtree0 rewrite_rules0
            do_again t' (Coq_rIdent (true, t', idc', t',
            (Compilers.Coq_expr.Ident (t', idc')))) (fun _ -> id))

      (** val reflect_ident_iota :
          'a1 Compilers.Coq_base.Coq_type.coq_BaseTypeHasNatT -> ('a1, 'a3,
          'a2) Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a2)
          Compilers.Coq_ident.coq_BuildEagerIdentT -> ('a1, 'a2)
          Compilers.Coq_ident.coq_ToRestrictedIdentT -> ('a1, 'a3, 'a2)
          Compilers.Coq_invert_expr.coq_InvertIdentT -> ('a1, 'a3)
          Compilers.Coq_base.coq_BaseHasNatCorrectT -> 'a1
          Compilers.Coq_type.try_make_transport_cpsT -> 'a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value
          option **)

      let reflect_ident_iota baseTypeHasNat buildIdent0 buildEagerIdent0 toRestrictedIdent0 invertIdent0 baseHasNatCorrect0 try_make_transport_base_cps0 t0 idc =
        let type_base0 = fun x -> Compilers.Coq_base.Coq_type.Coq_type_base x
        in
        let base' = fun _ x -> Compilers.Coq_type.Coq_base x in
        Compilers.Coq_ident.eager_ident_rect baseTypeHasNat buildEagerIdent0
          toRestrictedIdent0 (fun p ->
          Obj.magic (fun n_case s_case n3 ->
            match Compilers.Coq_invert_expr.invert_Literal invertIdent0
                    (base' __
                      (type_base0
                        (Compilers.Coq_base.Coq_type.nat baseTypeHasNat))) n3 with
            | Some n4 ->
              let rec f = function
              | O ->
                n_case (Compilers.Coq_expr.Ident
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  buildIdent0.Compilers.Coq_ident.ident_tt))
              | S n6 ->
                Coq_Compilers.UnderLets.splice (f n6) (fun rec0 ->
                  s_case (Compilers.Coq_expr.Ident
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    (Compilers.Coq_base.Coq_type.nat baseTypeHasNat))),
                    (buildIdent0.Compilers.Coq_ident.ident_Literal
                      (Compilers.Coq_base.Coq_type.nat baseTypeHasNat)
                      (baseHasNatCorrect0.Compilers.Coq_base.of_nat n6))))
                    rec0)
              in f
                   ((Obj.magic baseHasNatCorrect0).Compilers.Coq_base.to_nat
                     n4)
            | None ->
              Obj.magic reflect false (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_unit in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base p))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_unit in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base p))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p))))))),
                (buildEagerIdent0.Compilers.Coq_ident.ident_nat_rect p)))
                n_case s_case n3)) (fun p q0 ->
          Obj.magic (fun n_case s_case n3 v ->
            match Compilers.Coq_invert_expr.invert_Literal invertIdent0
                    (base' __
                      (type_base0
                        (Compilers.Coq_base.Coq_type.nat baseTypeHasNat))) n3 with
            | Some n4 ->
              let rec f = function
              | O -> n_case
              | S n6 ->
                (fun v' ->
                  s_case (Compilers.Coq_expr.Ident
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    (Compilers.Coq_base.Coq_type.nat baseTypeHasNat))),
                    (buildIdent0.Compilers.Coq_ident.ident_Literal
                      (Compilers.Coq_base.Coq_type.nat baseTypeHasNat)
                      (baseHasNatCorrect0.Compilers.Coq_base.of_nat n6))))
                    (f n6) v')
              in f
                   ((Obj.magic baseHasNatCorrect0).Compilers.Coq_base.to_nat
                     n4) v
            | None ->
              Obj.magic reflect false (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base p),
                (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0)))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base p),
                (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))))))))),
                (buildEagerIdent0.Compilers.Coq_ident.ident_nat_rect_arrow p
                  q0))) n_case s_case n3 v)) (fun a p ->
          Obj.magic (fun n_case c_case ls ->
            match Compilers.Coq_invert_expr.reflect_list
                    try_make_transport_base_cps0 invertIdent0 a ls with
            | Some ls0 ->
              let rec f = function
              | [] ->
                n_case (Compilers.Coq_expr.Ident
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  buildIdent0.Compilers.Coq_ident.ident_tt))
              | y :: l0 ->
                Coq_Compilers.UnderLets.splice (f l0) (fun rec0 ->
                  c_case y (Compilers.Coq_ident.reify_list buildIdent0 a l0)
                    rec0)
              in f ls0
            | None ->
              Obj.magic reflect false (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_unit in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base a),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base p))))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_unit in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base a),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base p))))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base p))))))),
                (buildEagerIdent0.Compilers.Coq_ident.ident_list_rect a p)))
                n_case c_case ls)) (fun a p q0 ->
          Obj.magic (fun n_case c_case ls v ->
            match Compilers.Coq_invert_expr.reflect_list
                    try_make_transport_base_cps0 invertIdent0 a ls with
            | Some ls0 ->
              let rec f = function
              | [] -> n_case
              | y :: l0 ->
                (fun v0 ->
                  c_case y (Compilers.Coq_ident.reify_list buildIdent0 a l0)
                    (f l0) v0)
              in f ls0 v
            | None ->
              Obj.magic reflect false (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base a),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base p),
                (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))))))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0)))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base a),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base p),
                (Compilers.Coq_type.Coq_base q0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))))))))),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                p), (Compilers.Coq_type.Coq_base q0))))))))),
                (buildEagerIdent0.Compilers.Coq_ident.ident_list_rect_arrow a
                  p q0))) n_case c_case ls v)) (fun a ->
          Obj.magic (fun default0 ls n3 ->
            match Compilers.Coq_invert_expr.reflect_list
                    try_make_transport_base_cps0 invertIdent0 a ls with
            | Some ls0 ->
              (match Compilers.Coq_invert_expr.invert_Literal invertIdent0
                       (base' __
                         (type_base0
                           (Compilers.Coq_base.Coq_type.nat baseTypeHasNat)))
                       n3 with
               | Some n4 ->
                 Coq_Compilers.UnderLets.Base
                   (nth_default default0 ls0
                     ((Obj.magic baseHasNatCorrect0).Compilers.Coq_base.to_nat
                       n4))
               | None ->
                 Obj.magic reflect false (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base a),
                   (Compilers.Coq_type.Coq_arrow
                   ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                     Compilers.Coq_type.Coq_base x),
                   (Compilers.Coq_type.Coq_arrow
                   ((let x =
                       let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat
                       in
                       Compilers.Coq_base.Coq_type.Coq_type_base x
                     in
                     Compilers.Coq_type.Coq_base x),
                   (Compilers.Coq_type.Coq_base a)))))))
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base a),
                   (Compilers.Coq_type.Coq_arrow
                   ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                     Compilers.Coq_type.Coq_base x),
                   (Compilers.Coq_type.Coq_arrow
                   ((let x =
                       let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat
                       in
                       Compilers.Coq_base.Coq_type.Coq_type_base x
                     in
                     Compilers.Coq_type.Coq_base x),
                   (Compilers.Coq_type.Coq_base a))))))),
                   (buildEagerIdent0.Compilers.Coq_ident.ident_List_nth_default
                     a))) default0 ls n3)
            | None ->
              Obj.magic reflect false (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base a),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base a)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base a),
                (Compilers.Coq_type.Coq_arrow
                ((let x = Compilers.Coq_base.Coq_type.Coq_list a in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_arrow
                ((let x =
                    let x = Compilers.Coq_base.Coq_type.nat baseTypeHasNat in
                    Compilers.Coq_base.Coq_type.Coq_type_base x
                  in
                  Compilers.Coq_type.Coq_base x),
                (Compilers.Coq_type.Coq_base a))))))),
                (buildEagerIdent0.Compilers.Coq_ident.ident_List_nth_default
                  a))) default0 ls n3)) t0 idc

      (** val rewrite_bottomup :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
          Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
          Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
          Compilers.Coq_type.try_make_transport_cpsT -> ('a1
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          'a2 -> ('a1 Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
          value_with_lets) -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value_with_lets **)

      let rewrite_bottomup ident_is_var_like0 buildIdent0 invertIdent0 try_make_transport_base_cps0 rewrite_head0 =
        let rec rewrite_bottomup0 _ = function
        | Compilers.Coq_expr.Ident (t0, idc) -> rewrite_head0 t0 idc
        | Compilers.Coq_expr.Var (t0, v) -> coq_Base_value t0 v
        | Compilers.Coq_expr.Abs (_, d, f) ->
          Obj.magic (fun x -> rewrite_bottomup0 d (f x))
        | Compilers.Coq_expr.App (s0, d, f, x) ->
          let f0 = rewrite_bottomup0 (Compilers.Coq_type.Coq_arrow (s0, d)) f
          in
          splice_value_with_lets s0 d (rewrite_bottomup0 s0 x) (fun x0 ->
            Obj.magic f0 x0)
        | Compilers.Coq_expr.LetIn (a, b, x, f) ->
          splice_value_with_lets a b (rewrite_bottomup0 a x) (fun x0 ->
            splice_under_lets_with_value b
              (reify_and_let_binds_cps (fun t0 x1 _ ->
                Coq_Compilers.UnderLets.reify_and_let_binds_base_cps
                  try_make_transport_base_cps0 invertIdent0 buildIdent0
                  ident_is_var_like0 t0 x1) false a x0 (fun x1 ->
                Coq_Compilers.UnderLets.Base x1)) (fun xv ->
              rewrite_bottomup0 b (f (reflect false a xv))))
        in rewrite_bottomup0

      (** val repeat_rewrite :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
          Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
          Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
          Compilers.Coq_type.try_make_transport_cpsT -> (('a1
          Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value_with_lets) ->
          nat -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value_with_lets **)

      let repeat_rewrite ident_is_var_like0 buildIdent0 invertIdent0 try_make_transport_base_cps0 =
        let rec repeat_rewrite0 rewrite_head0 fuel0 t0 e =
          rewrite_bottomup ident_is_var_like0 buildIdent0 invertIdent0
            try_make_transport_base_cps0
            (Obj.magic rewrite_head0 (fun t' e' ->
              match fuel0 with
              | O ->
                rewrite_bottomup ident_is_var_like0 buildIdent0 invertIdent0
                  try_make_transport_base_cps0 (fun t1 idc ->
                  reflect true t1 (Compilers.Coq_expr.Ident (t1, idc)))
                  (Compilers.Coq_type.Coq_base t') e'
              | S fuel' ->
                repeat_rewrite0 rewrite_head0 fuel'
                  (Compilers.Coq_type.Coq_base t') e')) t0 e
        in repeat_rewrite0

      (** val rewrite :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
          Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
          Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
          Compilers.Coq_type.try_make_transport_cpsT -> (('a1
          Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value_with_lets) ->
          nat -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a4)
          Compilers.Coq_expr.expr **)

      let rewrite ident_is_var_like0 buildIdent0 invertIdent0 try_make_transport_base_cps0 rewrite_head0 fuel0 t0 e =
        reify true t0
          (repeat_rewrite ident_is_var_like0 buildIdent0 invertIdent0
            try_make_transport_base_cps0 rewrite_head0 fuel0 t0 e)

      (** val coq_Rewrite :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> bool) -> ('a1, 'a3, 'a2)
          Compilers.Coq_ident.coq_BuildIdentT -> ('a1, 'a3, 'a2)
          Compilers.Coq_invert_expr.coq_InvertIdentT -> 'a1
          Compilers.Coq_type.try_make_transport_cpsT -> (__ -> ('a1
          Compilers.Coq_base.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, __) value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, __, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, __)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
          'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, __) value_with_lets) ->
          nat -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2)
          Compilers.Coq_expr.coq_Expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, __)
          Compilers.Coq_expr.expr **)

      let coq_Rewrite ident_is_var_like0 buildIdent0 invertIdent0 try_make_transport_base_cps0 rewrite_head0 fuel0 t0 e =
        rewrite ident_is_var_like0 buildIdent0 invertIdent0
          try_make_transport_base_cps0 (rewrite_head0 __) fuel0 t0 (e __)
     end

    module Reify =
     struct
      (** val expr_value_to_rewrite_rule_replacement :
          ('a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> 'a2 -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) Compile.value
          option) -> bool -> 'a1 Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3) Compile.value)
          Compilers.Coq_expr.expr -> ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, 'a3, ('a1
          Compilers.Coq_base.Coq_type.coq_type, 'a2, __)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets **)

      let expr_value_to_rewrite_rule_replacement reflect_ident_iota0 should_do_again t0 e =
        Coq_Compilers.UnderLets.splice
          (Coq_Compilers.UnderLets.flat_map
            (Compile.reify_expr_beta_iota reflect_ident_iota0) (fun t1 v ->
            Compile.reflect false t1 (Compilers.Coq_expr.Var (t1, v)))
            (Coq_Compilers.UnderLets.of_expr t0 e)) (fun e0 ->
          if should_do_again
          then Coq_Compilers.UnderLets.Base e0
          else Obj.magic Compile.reify_expr_beta_iota reflect_ident_iota0 t0
                 e0)
     end

    module Make =
     struct
      module GoalType =
       struct
        type rewriter_dataT = { ident_is_var_like : (__
                                                    Compilers.Coq_base.Coq_type.coq_type
                                                    Compilers.Coq_type.coq_type
                                                    -> __ -> bool);
                                rewrite_rules_specs : (bool * __) list;
                                dummy_count : nat;
                                dtree : __ Compile.decision_tree;
                                rewrite_rules : (__ -> (__, __, __, __)
                                                Compile.rewrite_rulesT);
                                all_rewrite_rules : (__ -> (__, __, __, __)
                                                    Compile.rewrite_rulesT);
                                default_fuel : nat;
                                rewrite_head : (__ -> (__
                                               Compilers.Coq_base.Coq_type.coq_type
                                               -> (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __) Compile.value)
                                               Compilers.Coq_expr.expr -> (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __, (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __)
                                               Compilers.Coq_expr.expr)
                                               Coq_Compilers.UnderLets.coq_UnderLets)
                                               -> __
                                               Compilers.Coq_base.Coq_type.coq_type
                                               Compilers.Coq_type.coq_type ->
                                               __ -> (__
                                               Compilers.Coq_base.Coq_type.coq_type,
                                               __, __)
                                               Compile.value_with_lets);
                                rewrite_head_no_dtree : (__ -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type
                                                        -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __)
                                                        Compile.value)
                                                        Compilers.Coq_expr.expr
                                                        -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __, (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __)
                                                        Compilers.Coq_expr.expr)
                                                        Coq_Compilers.UnderLets.coq_UnderLets)
                                                        -> __
                                                        Compilers.Coq_base.Coq_type.coq_type
                                                        Compilers.Coq_type.coq_type
                                                        -> __ -> (__
                                                        Compilers.Coq_base.Coq_type.coq_type,
                                                        __, __)
                                                        Compile.value_with_lets) }

        (** val dtree :
            Compilers.Classes.coq_ExprInfoT ->
            Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
            rewriter_dataT -> __ Compile.decision_tree **)

        let dtree _ _ _ r0 =
          r0.dtree

        (** val all_rewrite_rules :
            Compilers.Classes.coq_ExprInfoT ->
            Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
            rewriter_dataT -> (__, __, 'a1, __) Compile.rewrite_rulesT **)

        let all_rewrite_rules _ _ _ r0 =
          Obj.magic r0.all_rewrite_rules __

        (** val rewrite_head :
            Compilers.Classes.coq_ExprInfoT ->
            Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
            rewriter_dataT -> (__ Compilers.Coq_base.Coq_type.coq_type -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1) Compile.value)
            Compilers.Coq_expr.expr -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1, (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
            Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets)
            -> __ Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> __ -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
            Compile.value_with_lets **)

        let rewrite_head _ _ _ r0 do_again t0 idc =
          Obj.magic r0.rewrite_head __ do_again t0 idc

        (** val rewrite_head_no_dtree :
            Compilers.Classes.coq_ExprInfoT ->
            Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
            rewriter_dataT -> (__ Compilers.Coq_base.Coq_type.coq_type -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1) Compile.value)
            Compilers.Coq_expr.expr -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1, (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
            Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets)
            -> __ Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> __ -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
            Compile.value_with_lets **)

        let rewrite_head_no_dtree _ _ _ r0 do_again t0 idc =
          Obj.magic r0.rewrite_head_no_dtree __ do_again t0 idc

        (** val rewrite_head_gen :
            Compilers.Classes.coq_ExprInfoT ->
            Compilers.Classes.coq_ExprExtraInfoT -> (__, __)
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.package ->
            rewriter_dataT -> bool -> bool -> (__
            Compilers.Coq_base.Coq_type.coq_type -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1) Compile.value)
            Compilers.Coq_expr.expr -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1, (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
            Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets)
            -> __ Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> __ -> (__
            Compilers.Coq_base.Coq_type.coq_type, __, 'a1)
            Compile.value_with_lets **)

        let rewrite_head_gen exprInfo exprExtraInfo pkg r0 use_dtree use_precomputed_functions0 do_again t0 idc =
          (if use_precomputed_functions0
           then if use_dtree
                then (fun _ -> rewrite_head exprInfo exprExtraInfo pkg r0)
                else (fun _ ->
                       rewrite_head_no_dtree exprInfo exprExtraInfo pkg r0)
           else if use_dtree
                then (fun _ ->
                       Compile.assemble_identifier_rewriters (fun _ x x0 _ ->
                         Compilers.Classes.try_make_transport_base_cps
                           exprInfo exprExtraInfo x x0)
                         exprExtraInfo.Compilers.Classes.base_beq (fun _ ->
                         Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
                           pkg)
                         (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
                           (fun _ ->
                           Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
                             pkg)
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types)
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown
                         (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of
                           (fun _ ->
                           Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
                             pkg)
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
                         (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed
                           (fun _ ->
                           Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
                             pkg)
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
                         (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
                         (Some r0.dtree)
                         (all_rewrite_rules exprInfo exprExtraInfo pkg r0))
                else (fun _ ->
                       Compile.assemble_identifier_rewriters (fun _ x x0 _ ->
                         Compilers.Classes.try_make_transport_base_cps
                           exprInfo exprExtraInfo x x0)
                         exprExtraInfo.Compilers.Classes.base_beq (fun _ ->
                         Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
                           pkg)
                         (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
                           (fun _ ->
                           Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
                             pkg)
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types)
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
                         pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown
                         (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of
                           (fun _ ->
                           Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
                             pkg)
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
                         (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed
                           (fun _ ->
                           Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
                             pkg)
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
                         (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
                           pkg.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
                         None
                         (all_rewrite_rules exprInfo exprExtraInfo pkg r0)))
            __ do_again t0 idc
       end
     end
   end
 end

module Coq2_Compilers =
 struct
  module RewriteRules =
   struct
    module GoalType =
     struct
      module DefaultOptionType =
       struct
        type coq_RewriterOptions = { use_decision_tree : bool;
                                     use_precomputed_functions : bool }

        (** val use_decision_tree : coq_RewriterOptions -> bool **)

        let use_decision_tree r0 =
          r0.use_decision_tree

        (** val use_precomputed_functions : coq_RewriterOptions -> bool **)

        let use_precomputed_functions r0 =
          r0.use_precomputed_functions
       end
     end
   end
 end

module Coq3_Compilers =
 struct
  type base =
  | Z
  | Coq_bool
  | Coq_nat
  | Coq_zrange
  | Coq_string

  (** val base_rect : 'a1 -> 'a1 -> 'a1 -> 'a1 -> 'a1 -> base -> 'a1 **)

  let base_rect f f0 f1 f2 f3 = function
  | Z -> f
  | Coq_bool -> f0
  | Coq_nat -> f1
  | Coq_zrange -> f2
  | Coq_string -> f3

  (** val base_rec : 'a1 -> 'a1 -> 'a1 -> 'a1 -> 'a1 -> base -> 'a1 **)

  let base_rec f f0 f1 f2 f3 = function
  | Z -> f
  | Coq_bool -> f0
  | Coq_nat -> f1
  | Coq_zrange -> f2
  | Coq_string -> f3

  type ident =
  | Coq_ident_Literal of base * __
  | Coq_ident_comment of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_comment_no_keep of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_value_barrier
  | Coq_ident_Nat_succ
  | Coq_ident_Nat_pred
  | Coq_ident_Nat_max
  | Coq_ident_Nat_mul
  | Coq_ident_Nat_add
  | Coq_ident_Nat_sub
  | Coq_ident_Nat_eqb
  | Coq_ident_nil of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_cons of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_tt
  | Coq_ident_pair of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_fst of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_snd of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_prod_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_bool_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_bool_rect_nodep of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_nat_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_nat_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_nat_rect_arrow of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_nat_rect_arrow of base
                                      Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_list_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_list_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_list_rect_arrow of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_list_rect_arrow of base
                                       Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_list_case of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_length of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_seq
  | Coq_ident_List_firstn of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_skipn of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_repeat of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_combine of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_map of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_app of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_rev of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_flat_map of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_partition of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_filter of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_fold_right of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_update_nth of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_List_nth_default of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_eager_List_nth_default of base
                                        Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_Z_add
  | Coq_ident_Z_mul
  | Coq_ident_Z_pow
  | Coq_ident_Z_sub
  | Coq_ident_Z_opp
  | Coq_ident_Z_div
  | Coq_ident_Z_modulo
  | Coq_ident_Z_eqb
  | Coq_ident_Z_leb
  | Coq_ident_Z_ltb
  | Coq_ident_Z_geb
  | Coq_ident_Z_gtb
  | Coq_ident_Z_log2
  | Coq_ident_Z_log2_up
  | Coq_ident_Z_of_nat
  | Coq_ident_Z_to_nat
  | Coq_ident_Z_shiftr
  | Coq_ident_Z_shiftl
  | Coq_ident_Z_land
  | Coq_ident_Z_lor
  | Coq_ident_Z_min
  | Coq_ident_Z_max
  | Coq_ident_Z_mul_split
  | Coq_ident_Z_mul_high
  | Coq_ident_Z_add_get_carry
  | Coq_ident_Z_add_with_carry
  | Coq_ident_Z_add_with_get_carry
  | Coq_ident_Z_sub_get_borrow
  | Coq_ident_Z_sub_with_get_borrow
  | Coq_ident_Z_ltz
  | Coq_ident_Z_zselect
  | Coq_ident_Z_add_modulo
  | Coq_ident_Z_truncating_shiftl
  | Coq_ident_Z_bneg
  | Coq_ident_Z_lnot_modulo
  | Coq_ident_Z_lxor
  | Coq_ident_Z_rshi
  | Coq_ident_Z_cc_m
  | Coq_ident_Z_combine_at_bitwidth
  | Coq_ident_Z_cast
  | Coq_ident_Z_cast2
  | Coq_ident_Some of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_None of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_option_rect of base Compilers.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_Build_zrange
  | Coq_ident_zrange_rect of base Compilers.Coq_base.Coq_type.coq_type
  | Coq_ident_fancy_add
  | Coq_ident_fancy_addc
  | Coq_ident_fancy_sub
  | Coq_ident_fancy_subb
  | Coq_ident_fancy_mulll
  | Coq_ident_fancy_mullh
  | Coq_ident_fancy_mulhl
  | Coq_ident_fancy_mulhh
  | Coq_ident_fancy_rshi
  | Coq_ident_fancy_selc
  | Coq_ident_fancy_selm
  | Coq_ident_fancy_sell
  | Coq_ident_fancy_addm

  type pattern_ident =
  | Coq_pattern_ident_Literal of base
  | Coq_pattern_ident_comment of base
                                 Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_comment_no_keep of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_value_barrier
  | Coq_pattern_ident_Nat_succ
  | Coq_pattern_ident_Nat_pred
  | Coq_pattern_ident_Nat_max
  | Coq_pattern_ident_Nat_mul
  | Coq_pattern_ident_Nat_add
  | Coq_pattern_ident_Nat_sub
  | Coq_pattern_ident_Nat_eqb
  | Coq_pattern_ident_nil of base
                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_cons of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_tt
  | Coq_pattern_ident_pair of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_fst of base
                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_snd of base
                             Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_prod_rect of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_bool_rect of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_bool_rect_nodep of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_nat_rect of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_nat_rect of base
                                        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_nat_rect_arrow of base
                                        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_nat_rect_arrow of base
                                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_list_rect of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_list_rect of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_list_rect_arrow of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_list_rect_arrow of base
                                               Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_list_case of base
                                   Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_length of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_seq
  | Coq_pattern_ident_List_firstn of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_skipn of base
                                    Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_repeat of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_combine of base
                                      Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_map of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_app of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_rev of base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_flat_map of base
                                       Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_partition of base
                                        Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_filter of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_fold_right of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_update_nth of base
                                         Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_List_nth_default of base
                                          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_eager_List_nth_default of base
                                                Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_Z_add
  | Coq_pattern_ident_Z_mul
  | Coq_pattern_ident_Z_pow
  | Coq_pattern_ident_Z_sub
  | Coq_pattern_ident_Z_opp
  | Coq_pattern_ident_Z_div
  | Coq_pattern_ident_Z_modulo
  | Coq_pattern_ident_Z_eqb
  | Coq_pattern_ident_Z_leb
  | Coq_pattern_ident_Z_ltb
  | Coq_pattern_ident_Z_geb
  | Coq_pattern_ident_Z_gtb
  | Coq_pattern_ident_Z_log2
  | Coq_pattern_ident_Z_log2_up
  | Coq_pattern_ident_Z_of_nat
  | Coq_pattern_ident_Z_to_nat
  | Coq_pattern_ident_Z_shiftr
  | Coq_pattern_ident_Z_shiftl
  | Coq_pattern_ident_Z_land
  | Coq_pattern_ident_Z_lor
  | Coq_pattern_ident_Z_min
  | Coq_pattern_ident_Z_max
  | Coq_pattern_ident_Z_mul_split
  | Coq_pattern_ident_Z_mul_high
  | Coq_pattern_ident_Z_add_get_carry
  | Coq_pattern_ident_Z_add_with_carry
  | Coq_pattern_ident_Z_add_with_get_carry
  | Coq_pattern_ident_Z_sub_get_borrow
  | Coq_pattern_ident_Z_sub_with_get_borrow
  | Coq_pattern_ident_Z_ltz
  | Coq_pattern_ident_Z_zselect
  | Coq_pattern_ident_Z_add_modulo
  | Coq_pattern_ident_Z_truncating_shiftl
  | Coq_pattern_ident_Z_bneg
  | Coq_pattern_ident_Z_lnot_modulo
  | Coq_pattern_ident_Z_lxor
  | Coq_pattern_ident_Z_rshi
  | Coq_pattern_ident_Z_cc_m
  | Coq_pattern_ident_Z_combine_at_bitwidth
  | Coq_pattern_ident_Z_cast
  | Coq_pattern_ident_Z_cast2
  | Coq_pattern_ident_Some of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_None of base
                              Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_option_rect of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
     * base Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_Build_zrange
  | Coq_pattern_ident_zrange_rect of base
                                     Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
  | Coq_pattern_ident_fancy_add
  | Coq_pattern_ident_fancy_addc
  | Coq_pattern_ident_fancy_sub
  | Coq_pattern_ident_fancy_subb
  | Coq_pattern_ident_fancy_mulll
  | Coq_pattern_ident_fancy_mullh
  | Coq_pattern_ident_fancy_mulhl
  | Coq_pattern_ident_fancy_mulhh
  | Coq_pattern_ident_fancy_rshi
  | Coq_pattern_ident_fancy_selc
  | Coq_pattern_ident_fancy_selm
  | Coq_pattern_ident_fancy_sell
  | Coq_pattern_ident_fancy_addm

  type raw_ident =
  | Coq_raw_ident_Literal
  | Coq_raw_ident_comment
  | Coq_raw_ident_comment_no_keep
  | Coq_raw_ident_value_barrier
  | Coq_raw_ident_Nat_succ
  | Coq_raw_ident_Nat_pred
  | Coq_raw_ident_Nat_max
  | Coq_raw_ident_Nat_mul
  | Coq_raw_ident_Nat_add
  | Coq_raw_ident_Nat_sub
  | Coq_raw_ident_Nat_eqb
  | Coq_raw_ident_nil
  | Coq_raw_ident_cons
  | Coq_raw_ident_tt
  | Coq_raw_ident_pair
  | Coq_raw_ident_fst
  | Coq_raw_ident_snd
  | Coq_raw_ident_prod_rect
  | Coq_raw_ident_bool_rect
  | Coq_raw_ident_bool_rect_nodep
  | Coq_raw_ident_nat_rect
  | Coq_raw_ident_eager_nat_rect
  | Coq_raw_ident_nat_rect_arrow
  | Coq_raw_ident_eager_nat_rect_arrow
  | Coq_raw_ident_list_rect
  | Coq_raw_ident_eager_list_rect
  | Coq_raw_ident_list_rect_arrow
  | Coq_raw_ident_eager_list_rect_arrow
  | Coq_raw_ident_list_case
  | Coq_raw_ident_List_length
  | Coq_raw_ident_List_seq
  | Coq_raw_ident_List_firstn
  | Coq_raw_ident_List_skipn
  | Coq_raw_ident_List_repeat
  | Coq_raw_ident_List_combine
  | Coq_raw_ident_List_map
  | Coq_raw_ident_List_app
  | Coq_raw_ident_List_rev
  | Coq_raw_ident_List_flat_map
  | Coq_raw_ident_List_partition
  | Coq_raw_ident_List_filter
  | Coq_raw_ident_List_fold_right
  | Coq_raw_ident_List_update_nth
  | Coq_raw_ident_List_nth_default
  | Coq_raw_ident_eager_List_nth_default
  | Coq_raw_ident_Z_add
  | Coq_raw_ident_Z_mul
  | Coq_raw_ident_Z_pow
  | Coq_raw_ident_Z_sub
  | Coq_raw_ident_Z_opp
  | Coq_raw_ident_Z_div
  | Coq_raw_ident_Z_modulo
  | Coq_raw_ident_Z_eqb
  | Coq_raw_ident_Z_leb
  | Coq_raw_ident_Z_ltb
  | Coq_raw_ident_Z_geb
  | Coq_raw_ident_Z_gtb
  | Coq_raw_ident_Z_log2
  | Coq_raw_ident_Z_log2_up
  | Coq_raw_ident_Z_of_nat
  | Coq_raw_ident_Z_to_nat
  | Coq_raw_ident_Z_shiftr
  | Coq_raw_ident_Z_shiftl
  | Coq_raw_ident_Z_land
  | Coq_raw_ident_Z_lor
  | Coq_raw_ident_Z_min
  | Coq_raw_ident_Z_max
  | Coq_raw_ident_Z_mul_split
  | Coq_raw_ident_Z_mul_high
  | Coq_raw_ident_Z_add_get_carry
  | Coq_raw_ident_Z_add_with_carry
  | Coq_raw_ident_Z_add_with_get_carry
  | Coq_raw_ident_Z_sub_get_borrow
  | Coq_raw_ident_Z_sub_with_get_borrow
  | Coq_raw_ident_Z_ltz
  | Coq_raw_ident_Z_zselect
  | Coq_raw_ident_Z_add_modulo
  | Coq_raw_ident_Z_truncating_shiftl
  | Coq_raw_ident_Z_bneg
  | Coq_raw_ident_Z_lnot_modulo
  | Coq_raw_ident_Z_lxor
  | Coq_raw_ident_Z_rshi
  | Coq_raw_ident_Z_cc_m
  | Coq_raw_ident_Z_combine_at_bitwidth
  | Coq_raw_ident_Z_cast
  | Coq_raw_ident_Z_cast2
  | Coq_raw_ident_Some
  | Coq_raw_ident_None
  | Coq_raw_ident_option_rect
  | Coq_raw_ident_Build_zrange
  | Coq_raw_ident_zrange_rect
  | Coq_raw_ident_fancy_add
  | Coq_raw_ident_fancy_addc
  | Coq_raw_ident_fancy_sub
  | Coq_raw_ident_fancy_subb
  | Coq_raw_ident_fancy_mulll
  | Coq_raw_ident_fancy_mullh
  | Coq_raw_ident_fancy_mulhl
  | Coq_raw_ident_fancy_mulhh
  | Coq_raw_ident_fancy_rshi
  | Coq_raw_ident_fancy_selc
  | Coq_raw_ident_fancy_selm
  | Coq_raw_ident_fancy_sell
  | Coq_raw_ident_fancy_addm

  (** val eta_base_cps_gen : (base -> 'a1) -> (base -> 'a1) **)

  let eta_base_cps_gen f = function
  | Z -> f Z
  | Coq_bool -> f Coq_bool
  | Coq_nat -> f Coq_nat
  | Coq_zrange -> f Coq_zrange
  | Coq_string -> f Coq_string

  (** val eta_base_cps : (base -> 'a1) -> base -> 'a1 **)

  let eta_base_cps =
    eta_base_cps_gen

  type base_interp = __

  (** val ident_interp :
      base Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
      -> ident -> (base Compilers.Coq_base.Coq_type.coq_type, (base,
      base_interp) Compilers.Coq_base.interp) Compilers.Coq_type.interp **)

  let ident_interp _ = function
  | Coq_ident_Literal (_, y) -> Pre.Coq_ident.literal y
  | Coq_ident_comment _ -> Obj.magic Coq_ident.comment
  | Coq_ident_comment_no_keep _ -> Obj.magic Coq_ident.comment_no_keep
  | Coq_ident_value_barrier -> Obj.magic Coq1_Z.value_barrier
  | Coq_ident_Nat_succ -> Obj.magic Nat.succ
  | Coq_ident_Nat_pred -> Obj.magic Nat.pred
  | Coq_ident_Nat_max -> Obj.magic Nat.max
  | Coq_ident_Nat_mul -> Obj.magic Nat.mul
  | Coq_ident_Nat_add -> Obj.magic Nat.add
  | Coq_ident_Nat_sub -> Obj.magic Nat.sub
  | Coq_ident_Nat_eqb -> Obj.magic Nat.eqb
  | Coq_ident_nil _ -> Obj.magic []
  | Coq_ident_cons _ -> Obj.magic (fun x x0 -> x :: x0)
  | Coq_ident_tt -> Obj.magic ()
  | Coq_ident_pair (_, _) -> Obj.magic (fun x x0 -> (x, x0))
  | Coq_ident_fst (_, _) -> Obj.magic fst
  | Coq_ident_snd (_, _) -> Obj.magic snd
  | Coq_ident_prod_rect (_, _, _) -> Obj.magic prod_rect_nodep
  | Coq_ident_bool_rect _ -> Obj.magic Thunked.bool_rect
  | Coq_ident_bool_rect_nodep _ -> Obj.magic bool_rect_nodep
  | Coq_ident_nat_rect _ -> Obj.magic Coq0_Thunked.nat_rect
  | Coq_ident_eager_nat_rect _ ->
    Pre.Coq_ident.eagerly (Obj.magic (fun _ -> Coq0_Thunked.nat_rect)) __
  | Coq_ident_nat_rect_arrow (_, _) -> Obj.magic nat_rect_arrow_nodep
  | Coq_ident_eager_nat_rect_arrow (_, _) ->
    Pre.Coq_ident.eagerly (Obj.magic (fun _ _ -> nat_rect_arrow_nodep)) __ __
  | Coq_ident_list_rect (_, _) -> Obj.magic Coq1_Thunked.list_rect
  | Coq_ident_eager_list_rect (_, _) ->
    Pre.Coq_ident.eagerly (Obj.magic (fun _ _ -> Coq1_Thunked.list_rect)) __
      __
  | Coq_ident_list_rect_arrow (_, _, _) -> Obj.magic list_rect_arrow_nodep
  | Coq_ident_eager_list_rect_arrow (_, _, _) ->
    Pre.Coq_ident.eagerly (Obj.magic (fun _ _ _ -> list_rect_arrow_nodep)) __
      __ __
  | Coq_ident_list_case (_, _) -> Obj.magic Coq1_Thunked.list_case
  | Coq_ident_List_length _ -> Obj.magic length
  | Coq_ident_List_seq -> Obj.magic seq
  | Coq_ident_List_firstn _ -> Obj.magic firstn
  | Coq_ident_List_skipn _ -> Obj.magic skipn
  | Coq_ident_List_repeat _ -> Obj.magic repeat
  | Coq_ident_List_combine (_, _) -> Obj.magic combine
  | Coq_ident_List_map (_, _) -> Obj.magic map
  | Coq_ident_List_app _ -> Obj.magic app
  | Coq_ident_List_rev _ -> Obj.magic rev1
  | Coq_ident_List_flat_map (_, _) -> Obj.magic flat_map
  | Coq_ident_List_partition _ -> Obj.magic partition
  | Coq_ident_List_filter _ -> Obj.magic filter
  | Coq_ident_List_fold_right (_, _) -> Obj.magic fold_right
  | Coq_ident_List_update_nth _ -> Obj.magic update_nth
  | Coq_ident_List_nth_default _ -> Obj.magic nth_default
  | Coq_ident_eager_List_nth_default _ ->
    Pre.Coq_ident.eagerly (Obj.magic (fun _ -> nth_default)) __
  | Coq_ident_Z_add -> Obj.magic Coq_Z.add
  | Coq_ident_Z_mul -> Obj.magic Coq_Z.mul
  | Coq_ident_Z_pow -> Obj.magic Coq_Z.pow
  | Coq_ident_Z_sub -> Obj.magic Coq_Z.sub
  | Coq_ident_Z_opp -> Obj.magic Coq_Z.opp
  | Coq_ident_Z_div -> Obj.magic Coq_Z.div
  | Coq_ident_Z_modulo -> Obj.magic Coq_Z.modulo
  | Coq_ident_Z_eqb -> Obj.magic Coq_Z.eqb
  | Coq_ident_Z_leb -> Obj.magic Coq_Z.leb
  | Coq_ident_Z_ltb -> Obj.magic Coq_Z.ltb
  | Coq_ident_Z_geb -> Obj.magic Coq_Z.geb
  | Coq_ident_Z_gtb -> Obj.magic Coq_Z.gtb
  | Coq_ident_Z_log2 -> Obj.magic Coq_Z.log2
  | Coq_ident_Z_log2_up -> Obj.magic Coq_Z.log2_up
  | Coq_ident_Z_of_nat -> Obj.magic Coq_Z.of_nat
  | Coq_ident_Z_to_nat -> Obj.magic Coq_Z.to_nat
  | Coq_ident_Z_shiftr -> Obj.magic Coq_Z.shiftr
  | Coq_ident_Z_shiftl -> Obj.magic Coq_Z.shiftl
  | Coq_ident_Z_land -> Obj.magic Coq_Z.coq_land
  | Coq_ident_Z_lor -> Obj.magic Coq_Z.coq_lor
  | Coq_ident_Z_min -> Obj.magic Coq_Z.min
  | Coq_ident_Z_max -> Obj.magic Coq_Z.max
  | Coq_ident_Z_mul_split -> Obj.magic Coq1_Z.mul_split
  | Coq_ident_Z_mul_high -> Obj.magic Coq1_Z.mul_high
  | Coq_ident_Z_add_get_carry -> Obj.magic Coq1_Z.add_get_carry_full
  | Coq_ident_Z_add_with_carry -> Obj.magic Coq1_Z.add_with_carry
  | Coq_ident_Z_add_with_get_carry -> Obj.magic Coq1_Z.add_with_get_carry_full
  | Coq_ident_Z_sub_get_borrow -> Obj.magic Coq1_Z.sub_get_borrow_full
  | Coq_ident_Z_sub_with_get_borrow ->
    Obj.magic Coq1_Z.sub_with_get_borrow_full
  | Coq_ident_Z_ltz -> Obj.magic Coq1_Z.ltz
  | Coq_ident_Z_zselect -> Obj.magic Coq1_Z.zselect
  | Coq_ident_Z_add_modulo -> Obj.magic Coq1_Z.add_modulo
  | Coq_ident_Z_truncating_shiftl -> Obj.magic Coq1_Z.truncating_shiftl
  | Coq_ident_Z_bneg -> Obj.magic Coq1_Z.bneg
  | Coq_ident_Z_lnot_modulo -> Obj.magic Coq1_Z.lnot_modulo
  | Coq_ident_Z_lxor -> Obj.magic Coq_Z.coq_lxor
  | Coq_ident_Z_rshi -> Obj.magic Coq1_Z.rshi
  | Coq_ident_Z_cc_m -> Obj.magic Coq1_Z.cc_m
  | Coq_ident_Z_combine_at_bitwidth -> Obj.magic Coq1_Z.combine_at_bitwidth
  | Coq_ident_Z_cast -> Obj.magic Coq_ident.cast
  | Coq_ident_Z_cast2 -> Obj.magic Coq_ident.cast2
  | Coq_ident_Some _ -> Obj.magic (fun x -> Some x)
  | Coq_ident_None _ -> Obj.magic None
  | Coq_ident_option_rect (_, _) -> Obj.magic Coq_Thunked.option_rect
  | Coq_ident_Build_zrange ->
    Obj.magic (fun x x0 -> { lower = x; upper = x0 })
  | Coq_ident_zrange_rect _ -> Obj.magic zrange_rect_nodep
  | Coq_ident_fancy_add -> Obj.magic Coq_ident.Coq_fancy.add
  | Coq_ident_fancy_addc -> Obj.magic Coq_ident.Coq_fancy.addc
  | Coq_ident_fancy_sub -> Obj.magic Coq_ident.Coq_fancy.sub
  | Coq_ident_fancy_subb -> Obj.magic Coq_ident.Coq_fancy.subb
  | Coq_ident_fancy_mulll -> Obj.magic Coq_ident.Coq_fancy.mulll
  | Coq_ident_fancy_mullh -> Obj.magic Coq_ident.Coq_fancy.mullh
  | Coq_ident_fancy_mulhl -> Obj.magic Coq_ident.Coq_fancy.mulhl
  | Coq_ident_fancy_mulhh -> Obj.magic Coq_ident.Coq_fancy.mulhh
  | Coq_ident_fancy_rshi -> Obj.magic Coq_ident.Coq_fancy.rshi
  | Coq_ident_fancy_selc -> Obj.magic Coq_ident.Coq_fancy.selc
  | Coq_ident_fancy_selm -> Obj.magic Coq_ident.Coq_fancy.selm
  | Coq_ident_fancy_sell -> Obj.magic Coq_ident.Coq_fancy.sell
  | Coq_ident_fancy_addm -> Obj.magic Coq_ident.Coq_fancy.addm

  (** val base_eq_dec : base -> base -> bool **)

  let base_eq_dec x y =
    (match x with
     | Z ->
       (fun x0 ->
         match x0 with
         | Z -> true
         | Coq_bool -> false
         | Coq_nat -> false
         | Coq_zrange -> false
         | Coq_string -> false)
     | Coq_bool ->
       (fun x0 ->
         match x0 with
         | Z -> false
         | Coq_bool -> true
         | Coq_nat -> false
         | Coq_zrange -> false
         | Coq_string -> false)
     | Coq_nat ->
       (fun x0 ->
         match x0 with
         | Z -> false
         | Coq_bool -> false
         | Coq_nat -> true
         | Coq_zrange -> false
         | Coq_string -> false)
     | Coq_zrange ->
       (fun x0 ->
         match x0 with
         | Z -> false
         | Coq_bool -> false
         | Coq_nat -> false
         | Coq_zrange -> true
         | Coq_string -> false)
     | Coq_string ->
       (fun x0 ->
         match x0 with
         | Z -> false
         | Coq_bool -> false
         | Coq_nat -> false
         | Coq_zrange -> false
         | Coq_string -> true)) y

  (** val base_beq_and_reflect :
      (base -> base -> bool, base -> base -> reflect) sigT **)

  let base_beq_and_reflect =
    ExistT ((fun x y ->
      match x with
      | Z ->
        (match y with
         | Z -> true
         | Coq_bool -> false
         | Coq_nat -> false
         | Coq_zrange -> false
         | Coq_string -> false)
      | Coq_bool ->
        (match y with
         | Z -> false
         | Coq_bool -> true
         | Coq_nat -> false
         | Coq_zrange -> false
         | Coq_string -> false)
      | Coq_nat ->
        (match y with
         | Z -> false
         | Coq_bool -> false
         | Coq_nat -> true
         | Coq_zrange -> false
         | Coq_string -> false)
      | Coq_zrange ->
        (match y with
         | Z -> false
         | Coq_bool -> false
         | Coq_nat -> false
         | Coq_zrange -> true
         | Coq_string -> false)
      | Coq_string ->
        (match y with
         | Z -> false
         | Coq_bool -> false
         | Coq_nat -> false
         | Coq_zrange -> false
         | Coq_string -> true)),
      (reflect_of_beq0 (fun x y ->
        match x with
        | Z ->
          (match y with
           | Z -> true
           | Coq_bool -> false
           | Coq_nat -> false
           | Coq_zrange -> false
           | Coq_string -> false)
        | Coq_bool ->
          (match y with
           | Z -> false
           | Coq_bool -> true
           | Coq_nat -> false
           | Coq_zrange -> false
           | Coq_string -> false)
        | Coq_nat ->
          (match y with
           | Z -> false
           | Coq_bool -> false
           | Coq_nat -> true
           | Coq_zrange -> false
           | Coq_string -> false)
        | Coq_zrange ->
          (match y with
           | Z -> false
           | Coq_bool -> false
           | Coq_nat -> false
           | Coq_zrange -> true
           | Coq_string -> false)
        | Coq_string ->
          (match y with
           | Z -> false
           | Coq_bool -> false
           | Coq_nat -> false
           | Coq_zrange -> false
           | Coq_string -> true))))

  (** val base_beq : base -> base -> bool **)

  let base_beq x y =
    match x with
    | Z ->
      (match y with
       | Z -> true
       | Coq_bool -> false
       | Coq_nat -> false
       | Coq_zrange -> false
       | Coq_string -> false)
    | Coq_bool ->
      (match y with
       | Z -> false
       | Coq_bool -> true
       | Coq_nat -> false
       | Coq_zrange -> false
       | Coq_string -> false)
    | Coq_nat ->
      (match y with
       | Z -> false
       | Coq_bool -> false
       | Coq_nat -> true
       | Coq_zrange -> false
       | Coq_string -> false)
    | Coq_zrange ->
      (match y with
       | Z -> false
       | Coq_bool -> false
       | Coq_nat -> false
       | Coq_zrange -> true
       | Coq_string -> false)
    | Coq_string ->
      (match y with
       | Z -> false
       | Coq_bool -> false
       | Coq_nat -> false
       | Coq_zrange -> false
       | Coq_string -> true)

  (** val reflect_base_beq : base -> base -> reflect **)

  let reflect_base_beq =
    projT2 base_beq_and_reflect

  (** val baseHasNat :
      base Compilers.Coq_base.Coq_type.coq_BaseTypeHasNatT **)

  let baseHasNat =
    Coq_nat

  (** val baseHasNatCorrect :
      (base, base_interp) Compilers.Coq_base.coq_BaseHasNatCorrectT **)

  let baseHasNatCorrect =
    { Compilers.Coq_base.to_nat = (fun x -> Obj.magic x);
      Compilers.Coq_base.of_nat = (fun x -> Obj.magic x);
      Compilers.Coq_base.of_to_nat = (fun _ _ v -> v);
      Compilers.Coq_base.to_of_nat = (fun _ _ v -> v) }

  (** val base_interp_beq :
      base -> base -> base_interp -> base_interp -> bool **)

  let base_interp_beq t1 t2 =
    match t1 with
    | Z ->
      (match t2 with
       | Z -> Obj.magic Coq_Z.eqb
       | Coq_bool -> (fun _ _ -> false)
       | Coq_nat -> (fun _ _ -> false)
       | Coq_zrange -> (fun _ _ -> false)
       | Coq_string -> (fun _ _ -> false))
    | Coq_bool ->
      (match t2 with
       | Z -> (fun _ _ -> false)
       | Coq_bool -> Obj.magic eqb
       | Coq_nat -> (fun _ _ -> false)
       | Coq_zrange -> (fun _ _ -> false)
       | Coq_string -> (fun _ _ -> false))
    | Coq_nat ->
      (match t2 with
       | Z -> (fun _ _ -> false)
       | Coq_bool -> (fun _ _ -> false)
       | Coq_nat -> Obj.magic Nat.eqb
       | Coq_zrange -> (fun _ _ -> false)
       | Coq_string -> (fun _ _ -> false))
    | Coq_zrange ->
      (match t2 with
       | Z -> (fun _ _ -> false)
       | Coq_bool -> (fun _ _ -> false)
       | Coq_nat -> (fun _ _ -> false)
       | Coq_zrange -> Obj.magic zrange_beq
       | Coq_string -> (fun _ _ -> false))
    | Coq_string ->
      (match t2 with
       | Z -> (fun _ _ -> false)
       | Coq_bool -> (fun _ _ -> false)
       | Coq_nat -> (fun _ _ -> false)
       | Coq_zrange -> (fun _ _ -> false)
       | Coq_string -> Obj.magic eqb0)

  (** val reflect_base_interp_beq :
      base -> base_interp -> base_interp -> reflect **)

  let reflect_base_interp_beq = function
  | Z -> Obj.magic Coq_Z.eqb_spec
  | Coq_bool -> Obj.magic reflect_eq_bool
  | Coq_nat -> Obj.magic Nat.eqb_spec
  | Coq_zrange -> Obj.magic reflect_zrange_eq
  | Coq_string -> Obj.magic eqb_spec1

  (** val try_make_base_transport_cps :
      base -> base -> ((__ -> __) option -> __) -> __ **)

  let try_make_base_transport_cps t1 t2 x =
    eta_base_cps (fun t3 ->
      eta_base_cps (fun t4 ->
        if base_eq_dec t3 t4
        then cpsreturn (fun _ continuation -> continuation (Some id))
        else cpsreturn (fun _ continuation -> continuation None)) t2) t1 __ x

  (** val buildEagerIdent :
      (base, ident) Compilers.Coq_ident.coq_BuildEagerIdentT **)

  let buildEagerIdent =
    { Compilers.Coq_ident.ident_nat_rect = (fun p -> Coq_ident_nat_rect p);
      Compilers.Coq_ident.ident_nat_rect_arrow = (fun p q0 ->
      Coq_ident_nat_rect_arrow (p, q0));
      Compilers.Coq_ident.ident_list_rect = (fun a p -> Coq_ident_list_rect
      (a, p)); Compilers.Coq_ident.ident_list_rect_arrow = (fun a p q0 ->
      Coq_ident_list_rect_arrow (a, p, q0));
      Compilers.Coq_ident.ident_List_nth_default = (fun t0 ->
      Coq_ident_List_nth_default t0);
      Compilers.Coq_ident.ident_eager_nat_rect = (fun p ->
      Coq_ident_eager_nat_rect p);
      Compilers.Coq_ident.ident_eager_nat_rect_arrow = (fun p q0 ->
      Coq_ident_eager_nat_rect_arrow (p, q0));
      Compilers.Coq_ident.ident_eager_list_rect = (fun a p ->
      Coq_ident_eager_list_rect (a, p));
      Compilers.Coq_ident.ident_eager_list_rect_arrow = (fun a p q0 ->
      Coq_ident_eager_list_rect_arrow (a, p, q0));
      Compilers.Coq_ident.ident_eager_List_nth_default = (fun t0 ->
      Coq_ident_eager_List_nth_default t0) }

  (** val toRestrictedIdent :
      (base, ident) Compilers.Coq_ident.coq_ToRestrictedIdentT **)

  let toRestrictedIdent _ = function
  | Coq_ident_Literal (_, _) -> None
  | Coq_ident_comment _ -> None
  | Coq_ident_comment_no_keep _ -> None
  | Coq_ident_value_barrier -> None
  | Coq_ident_Nat_succ -> None
  | Coq_ident_Nat_pred -> None
  | Coq_ident_Nat_max -> None
  | Coq_ident_Nat_mul -> None
  | Coq_ident_Nat_add -> None
  | Coq_ident_Nat_sub -> None
  | Coq_ident_Nat_eqb -> None
  | Coq_ident_nil _ -> None
  | Coq_ident_cons _ -> None
  | Coq_ident_tt -> None
  | Coq_ident_pair (_, _) -> None
  | Coq_ident_fst (_, _) -> None
  | Coq_ident_snd (_, _) -> None
  | Coq_ident_prod_rect (_, _, _) -> None
  | Coq_ident_bool_rect _ -> None
  | Coq_ident_bool_rect_nodep _ -> None
  | Coq_ident_nat_rect t0 ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_nat_rect t0)
  | Coq_ident_eager_nat_rect t0 ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_eager_nat_rect t0)
  | Coq_ident_nat_rect_arrow (t0, t1) ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_nat_rect_arrow (t0, t1))
  | Coq_ident_eager_nat_rect_arrow (t0, t1) ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_eager_nat_rect_arrow (t0,
      t1))
  | Coq_ident_list_rect (t0, t1) ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_list_rect (t0, t1))
  | Coq_ident_eager_list_rect (t0, t1) ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_eager_list_rect (t0, t1))
  | Coq_ident_list_rect_arrow (t0, t1, t2) ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_list_rect_arrow (t0, t1,
      t2))
  | Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_eager_list_rect_arrow (t0,
      t1, t2))
  | Coq_ident_list_case (_, _) -> None
  | Coq_ident_List_length _ -> None
  | Coq_ident_List_seq -> None
  | Coq_ident_List_firstn _ -> None
  | Coq_ident_List_skipn _ -> None
  | Coq_ident_List_repeat _ -> None
  | Coq_ident_List_combine (_, _) -> None
  | Coq_ident_List_map (_, _) -> None
  | Coq_ident_List_app _ -> None
  | Coq_ident_List_rev _ -> None
  | Coq_ident_List_flat_map (_, _) -> None
  | Coq_ident_List_partition _ -> None
  | Coq_ident_List_filter _ -> None
  | Coq_ident_List_fold_right (_, _) -> None
  | Coq_ident_List_update_nth _ -> None
  | Coq_ident_List_nth_default t0 ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_List_nth_default t0)
  | Coq_ident_eager_List_nth_default t0 ->
    Some (Compilers.Coq_ident.Coq_restricted_ident_eager_List_nth_default t0)
  | Coq_ident_Z_add -> None
  | Coq_ident_Z_mul -> None
  | Coq_ident_Z_pow -> None
  | Coq_ident_Z_sub -> None
  | Coq_ident_Z_opp -> None
  | Coq_ident_Z_div -> None
  | Coq_ident_Z_modulo -> None
  | Coq_ident_Z_eqb -> None
  | Coq_ident_Z_leb -> None
  | Coq_ident_Z_ltb -> None
  | Coq_ident_Z_geb -> None
  | Coq_ident_Z_gtb -> None
  | Coq_ident_Z_log2 -> None
  | Coq_ident_Z_log2_up -> None
  | Coq_ident_Z_of_nat -> None
  | Coq_ident_Z_to_nat -> None
  | Coq_ident_Z_shiftr -> None
  | Coq_ident_Z_shiftl -> None
  | Coq_ident_Z_land -> None
  | Coq_ident_Z_lor -> None
  | Coq_ident_Z_min -> None
  | Coq_ident_Z_max -> None
  | Coq_ident_Z_mul_split -> None
  | Coq_ident_Z_mul_high -> None
  | Coq_ident_Z_add_get_carry -> None
  | Coq_ident_Z_add_with_carry -> None
  | Coq_ident_Z_add_with_get_carry -> None
  | Coq_ident_Z_sub_get_borrow -> None
  | Coq_ident_Z_sub_with_get_borrow -> None
  | Coq_ident_Z_ltz -> None
  | Coq_ident_Z_zselect -> None
  | Coq_ident_Z_add_modulo -> None
  | Coq_ident_Z_truncating_shiftl -> None
  | Coq_ident_Z_bneg -> None
  | Coq_ident_Z_lnot_modulo -> None
  | Coq_ident_Z_lxor -> None
  | Coq_ident_Z_rshi -> None
  | Coq_ident_Z_cc_m -> None
  | Coq_ident_Z_combine_at_bitwidth -> None
  | Coq_ident_Z_cast -> None
  | Coq_ident_Z_cast2 -> None
  | Coq_ident_Some _ -> None
  | Coq_ident_None _ -> None
  | Coq_ident_option_rect (_, _) -> None
  | Coq_ident_Build_zrange -> None
  | Coq_ident_zrange_rect _ -> None
  | Coq_ident_fancy_add -> None
  | Coq_ident_fancy_addc -> None
  | Coq_ident_fancy_sub -> None
  | Coq_ident_fancy_subb -> None
  | Coq_ident_fancy_mulll -> None
  | Coq_ident_fancy_mullh -> None
  | Coq_ident_fancy_mulhl -> None
  | Coq_ident_fancy_mulhh -> None
  | Coq_ident_fancy_rshi -> None
  | Coq_ident_fancy_selc -> None
  | Coq_ident_fancy_selm -> None
  | Coq_ident_fancy_sell -> None
  | Coq_ident_fancy_addm -> None

  (** val buildIdent :
      (base, base_interp, ident) Compilers.Coq_ident.coq_BuildIdentT **)

  let buildIdent =
    { Compilers.Coq_ident.ident_Literal = (fun t0 x -> Coq_ident_Literal (t0,
      (Pre.Coq_ident.literal x))); Compilers.Coq_ident.ident_nil = (fun t0 ->
      Coq_ident_nil t0); Compilers.Coq_ident.ident_cons = (fun t0 ->
      Coq_ident_cons t0); Compilers.Coq_ident.ident_Some = (fun t0 ->
      Coq_ident_Some t0); Compilers.Coq_ident.ident_None = (fun t0 ->
      Coq_ident_None t0); Compilers.Coq_ident.ident_pair = (fun a b ->
      Coq_ident_pair (a, b)); Compilers.Coq_ident.ident_tt = Coq_ident_tt }

  (** val ident_is_var_like :
      base Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
      -> ident -> bool **)

  let ident_is_var_like _ = function
  | Coq_ident_Literal (_, _) -> true
  | Coq_ident_comment _ -> false
  | Coq_ident_comment_no_keep _ -> false
  | Coq_ident_value_barrier -> false
  | Coq_ident_Nat_succ -> false
  | Coq_ident_Nat_pred -> false
  | Coq_ident_Nat_max -> false
  | Coq_ident_Nat_mul -> false
  | Coq_ident_Nat_add -> false
  | Coq_ident_Nat_sub -> false
  | Coq_ident_Nat_eqb -> false
  | Coq_ident_nil _ -> true
  | Coq_ident_cons _ -> true
  | Coq_ident_tt -> true
  | Coq_ident_pair (_, _) -> true
  | Coq_ident_fst (_, _) -> true
  | Coq_ident_snd (_, _) -> true
  | Coq_ident_prod_rect (_, _, _) -> false
  | Coq_ident_bool_rect _ -> false
  | Coq_ident_bool_rect_nodep _ -> false
  | Coq_ident_nat_rect _ -> false
  | Coq_ident_eager_nat_rect _ -> false
  | Coq_ident_nat_rect_arrow (_, _) -> false
  | Coq_ident_eager_nat_rect_arrow (_, _) -> false
  | Coq_ident_list_rect (_, _) -> false
  | Coq_ident_eager_list_rect (_, _) -> false
  | Coq_ident_list_rect_arrow (_, _, _) -> false
  | Coq_ident_eager_list_rect_arrow (_, _, _) -> false
  | Coq_ident_list_case (_, _) -> false
  | Coq_ident_List_length _ -> false
  | Coq_ident_List_seq -> false
  | Coq_ident_List_firstn _ -> false
  | Coq_ident_List_skipn _ -> false
  | Coq_ident_List_repeat _ -> false
  | Coq_ident_List_combine (_, _) -> false
  | Coq_ident_List_map (_, _) -> false
  | Coq_ident_List_app _ -> false
  | Coq_ident_List_rev _ -> false
  | Coq_ident_List_flat_map (_, _) -> false
  | Coq_ident_List_partition _ -> false
  | Coq_ident_List_filter _ -> false
  | Coq_ident_List_fold_right (_, _) -> false
  | Coq_ident_List_update_nth _ -> false
  | Coq_ident_List_nth_default _ -> false
  | Coq_ident_eager_List_nth_default _ -> false
  | Coq_ident_Z_add -> false
  | Coq_ident_Z_mul -> false
  | Coq_ident_Z_pow -> false
  | Coq_ident_Z_sub -> false
  | Coq_ident_Z_opp -> true
  | Coq_ident_Z_div -> false
  | Coq_ident_Z_modulo -> false
  | Coq_ident_Z_eqb -> false
  | Coq_ident_Z_leb -> false
  | Coq_ident_Z_ltb -> false
  | Coq_ident_Z_geb -> false
  | Coq_ident_Z_gtb -> false
  | Coq_ident_Z_log2 -> false
  | Coq_ident_Z_log2_up -> false
  | Coq_ident_Z_of_nat -> false
  | Coq_ident_Z_to_nat -> false
  | Coq_ident_Z_shiftr -> false
  | Coq_ident_Z_shiftl -> false
  | Coq_ident_Z_land -> false
  | Coq_ident_Z_lor -> false
  | Coq_ident_Z_min -> false
  | Coq_ident_Z_max -> false
  | Coq_ident_Z_mul_split -> false
  | Coq_ident_Z_mul_high -> false
  | Coq_ident_Z_add_get_carry -> false
  | Coq_ident_Z_add_with_carry -> false
  | Coq_ident_Z_add_with_get_carry -> false
  | Coq_ident_Z_sub_get_borrow -> false
  | Coq_ident_Z_sub_with_get_borrow -> false
  | Coq_ident_Z_ltz -> false
  | Coq_ident_Z_zselect -> false
  | Coq_ident_Z_add_modulo -> false
  | Coq_ident_Z_truncating_shiftl -> false
  | Coq_ident_Z_bneg -> false
  | Coq_ident_Z_lnot_modulo -> false
  | Coq_ident_Z_lxor -> false
  | Coq_ident_Z_rshi -> false
  | Coq_ident_Z_cc_m -> false
  | Coq_ident_Z_combine_at_bitwidth -> true
  | Coq_ident_Z_cast -> true
  | Coq_ident_Z_cast2 -> true
  | Coq_ident_Some _ -> false
  | Coq_ident_None _ -> false
  | Coq_ident_option_rect (_, _) -> false
  | Coq_ident_Build_zrange -> false
  | Coq_ident_zrange_rect _ -> false
  | Coq_ident_fancy_add -> false
  | Coq_ident_fancy_addc -> false
  | Coq_ident_fancy_sub -> false
  | Coq_ident_fancy_subb -> false
  | Coq_ident_fancy_mulll -> false
  | Coq_ident_fancy_mullh -> false
  | Coq_ident_fancy_mulhl -> false
  | Coq_ident_fancy_mulhh -> false
  | Coq_ident_fancy_rshi -> false
  | Coq_ident_fancy_selc -> false
  | Coq_ident_fancy_selm -> false
  | Coq_ident_fancy_sell -> false
  | Coq_ident_fancy_addm -> false

  (** val invertIdent :
      (base, base_interp, ident) Compilers.Coq_invert_expr.coq_InvertIdentT **)

  let invertIdent =
    { Compilers.Coq_invert_expr.invert_ident_Literal = (fun _ idc ->
      match idc with
      | Coq_ident_Literal (_, y) -> Some y
      | Coq_ident_comment _ -> None
      | Coq_ident_comment_no_keep _ -> None
      | Coq_ident_value_barrier -> None
      | Coq_ident_Nat_succ -> None
      | Coq_ident_Nat_pred -> None
      | Coq_ident_Nat_max -> None
      | Coq_ident_Nat_mul -> None
      | Coq_ident_Nat_add -> None
      | Coq_ident_Nat_sub -> None
      | Coq_ident_Nat_eqb -> None
      | Coq_ident_nil _ -> None
      | Coq_ident_cons _ -> None
      | Coq_ident_tt -> None
      | Coq_ident_pair (_, _) -> None
      | Coq_ident_fst (_, _) -> None
      | Coq_ident_snd (_, _) -> None
      | Coq_ident_prod_rect (_, _, _) -> None
      | Coq_ident_bool_rect _ -> None
      | Coq_ident_bool_rect_nodep _ -> None
      | Coq_ident_nat_rect _ -> None
      | Coq_ident_eager_nat_rect _ -> None
      | Coq_ident_nat_rect_arrow (_, _) -> None
      | Coq_ident_eager_nat_rect_arrow (_, _) -> None
      | Coq_ident_list_rect (_, _) -> None
      | Coq_ident_eager_list_rect (_, _) -> None
      | Coq_ident_list_rect_arrow (_, _, _) -> None
      | Coq_ident_eager_list_rect_arrow (_, _, _) -> None
      | Coq_ident_list_case (_, _) -> None
      | Coq_ident_List_length _ -> None
      | Coq_ident_List_seq -> None
      | Coq_ident_List_firstn _ -> None
      | Coq_ident_List_skipn _ -> None
      | Coq_ident_List_repeat _ -> None
      | Coq_ident_List_combine (_, _) -> None
      | Coq_ident_List_map (_, _) -> None
      | Coq_ident_List_app _ -> None
      | Coq_ident_List_rev _ -> None
      | Coq_ident_List_flat_map (_, _) -> None
      | Coq_ident_List_partition _ -> None
      | Coq_ident_List_filter _ -> None
      | Coq_ident_List_fold_right (_, _) -> None
      | Coq_ident_List_update_nth _ -> None
      | Coq_ident_List_nth_default _ -> None
      | Coq_ident_eager_List_nth_default _ -> None
      | Coq_ident_Z_add -> None
      | Coq_ident_Z_mul -> None
      | Coq_ident_Z_pow -> None
      | Coq_ident_Z_sub -> None
      | Coq_ident_Z_opp -> None
      | Coq_ident_Z_div -> None
      | Coq_ident_Z_modulo -> None
      | Coq_ident_Z_eqb -> None
      | Coq_ident_Z_leb -> None
      | Coq_ident_Z_ltb -> None
      | Coq_ident_Z_geb -> None
      | Coq_ident_Z_gtb -> None
      | Coq_ident_Z_log2 -> None
      | Coq_ident_Z_log2_up -> None
      | Coq_ident_Z_of_nat -> None
      | Coq_ident_Z_to_nat -> None
      | Coq_ident_Z_shiftr -> None
      | Coq_ident_Z_shiftl -> None
      | Coq_ident_Z_land -> None
      | Coq_ident_Z_lor -> None
      | Coq_ident_Z_min -> None
      | Coq_ident_Z_max -> None
      | Coq_ident_Z_mul_split -> None
      | Coq_ident_Z_mul_high -> None
      | Coq_ident_Z_add_get_carry -> None
      | Coq_ident_Z_add_with_carry -> None
      | Coq_ident_Z_add_with_get_carry -> None
      | Coq_ident_Z_sub_get_borrow -> None
      | Coq_ident_Z_sub_with_get_borrow -> None
      | Coq_ident_Z_ltz -> None
      | Coq_ident_Z_zselect -> None
      | Coq_ident_Z_add_modulo -> None
      | Coq_ident_Z_truncating_shiftl -> None
      | Coq_ident_Z_bneg -> None
      | Coq_ident_Z_lnot_modulo -> None
      | Coq_ident_Z_lxor -> None
      | Coq_ident_Z_rshi -> None
      | Coq_ident_Z_cc_m -> None
      | Coq_ident_Z_combine_at_bitwidth -> None
      | Coq_ident_Z_cast -> None
      | Coq_ident_Z_cast2 -> None
      | Coq_ident_Some _ -> None
      | Coq_ident_None _ -> None
      | Coq_ident_option_rect (_, _) -> None
      | Coq_ident_Build_zrange -> None
      | Coq_ident_zrange_rect _ -> None
      | Coq_ident_fancy_add -> None
      | Coq_ident_fancy_addc -> None
      | Coq_ident_fancy_sub -> None
      | Coq_ident_fancy_subb -> None
      | Coq_ident_fancy_mulll -> None
      | Coq_ident_fancy_mullh -> None
      | Coq_ident_fancy_mulhl -> None
      | Coq_ident_fancy_mulhh -> None
      | Coq_ident_fancy_rshi -> None
      | Coq_ident_fancy_selc -> None
      | Coq_ident_fancy_selm -> None
      | Coq_ident_fancy_sell -> None
      | Coq_ident_fancy_addm -> None); Compilers.Coq_invert_expr.is_nil =
      (fun _ idc ->
      match idc with
      | Coq_ident_Literal (_, _) -> false
      | Coq_ident_comment _ -> false
      | Coq_ident_comment_no_keep _ -> false
      | Coq_ident_value_barrier -> false
      | Coq_ident_Nat_succ -> false
      | Coq_ident_Nat_pred -> false
      | Coq_ident_Nat_max -> false
      | Coq_ident_Nat_mul -> false
      | Coq_ident_Nat_add -> false
      | Coq_ident_Nat_sub -> false
      | Coq_ident_Nat_eqb -> false
      | Coq_ident_nil _ -> true
      | Coq_ident_cons _ -> false
      | Coq_ident_tt -> false
      | Coq_ident_pair (_, _) -> false
      | Coq_ident_fst (_, _) -> false
      | Coq_ident_snd (_, _) -> false
      | Coq_ident_prod_rect (_, _, _) -> false
      | Coq_ident_bool_rect _ -> false
      | Coq_ident_bool_rect_nodep _ -> false
      | Coq_ident_nat_rect _ -> false
      | Coq_ident_eager_nat_rect _ -> false
      | Coq_ident_nat_rect_arrow (_, _) -> false
      | Coq_ident_eager_nat_rect_arrow (_, _) -> false
      | Coq_ident_list_rect (_, _) -> false
      | Coq_ident_eager_list_rect (_, _) -> false
      | Coq_ident_list_rect_arrow (_, _, _) -> false
      | Coq_ident_eager_list_rect_arrow (_, _, _) -> false
      | Coq_ident_list_case (_, _) -> false
      | Coq_ident_List_length _ -> false
      | Coq_ident_List_seq -> false
      | Coq_ident_List_firstn _ -> false
      | Coq_ident_List_skipn _ -> false
      | Coq_ident_List_repeat _ -> false
      | Coq_ident_List_combine (_, _) -> false
      | Coq_ident_List_map (_, _) -> false
      | Coq_ident_List_app _ -> false
      | Coq_ident_List_rev _ -> false
      | Coq_ident_List_flat_map (_, _) -> false
      | Coq_ident_List_partition _ -> false
      | Coq_ident_List_filter _ -> false
      | Coq_ident_List_fold_right (_, _) -> false
      | Coq_ident_List_update_nth _ -> false
      | Coq_ident_List_nth_default _ -> false
      | Coq_ident_eager_List_nth_default _ -> false
      | Coq_ident_Z_add -> false
      | Coq_ident_Z_mul -> false
      | Coq_ident_Z_pow -> false
      | Coq_ident_Z_sub -> false
      | Coq_ident_Z_opp -> false
      | Coq_ident_Z_div -> false
      | Coq_ident_Z_modulo -> false
      | Coq_ident_Z_eqb -> false
      | Coq_ident_Z_leb -> false
      | Coq_ident_Z_ltb -> false
      | Coq_ident_Z_geb -> false
      | Coq_ident_Z_gtb -> false
      | Coq_ident_Z_log2 -> false
      | Coq_ident_Z_log2_up -> false
      | Coq_ident_Z_of_nat -> false
      | Coq_ident_Z_to_nat -> false
      | Coq_ident_Z_shiftr -> false
      | Coq_ident_Z_shiftl -> false
      | Coq_ident_Z_land -> false
      | Coq_ident_Z_lor -> false
      | Coq_ident_Z_min -> false
      | Coq_ident_Z_max -> false
      | Coq_ident_Z_mul_split -> false
      | Coq_ident_Z_mul_high -> false
      | Coq_ident_Z_add_get_carry -> false
      | Coq_ident_Z_add_with_carry -> false
      | Coq_ident_Z_add_with_get_carry -> false
      | Coq_ident_Z_sub_get_borrow -> false
      | Coq_ident_Z_sub_with_get_borrow -> false
      | Coq_ident_Z_ltz -> false
      | Coq_ident_Z_zselect -> false
      | Coq_ident_Z_add_modulo -> false
      | Coq_ident_Z_truncating_shiftl -> false
      | Coq_ident_Z_bneg -> false
      | Coq_ident_Z_lnot_modulo -> false
      | Coq_ident_Z_lxor -> false
      | Coq_ident_Z_rshi -> false
      | Coq_ident_Z_cc_m -> false
      | Coq_ident_Z_combine_at_bitwidth -> false
      | Coq_ident_Z_cast -> false
      | Coq_ident_Z_cast2 -> false
      | Coq_ident_Some _ -> false
      | Coq_ident_None _ -> false
      | Coq_ident_option_rect (_, _) -> false
      | Coq_ident_Build_zrange -> false
      | Coq_ident_zrange_rect _ -> false
      | Coq_ident_fancy_add -> false
      | Coq_ident_fancy_addc -> false
      | Coq_ident_fancy_sub -> false
      | Coq_ident_fancy_subb -> false
      | Coq_ident_fancy_mulll -> false
      | Coq_ident_fancy_mullh -> false
      | Coq_ident_fancy_mulhl -> false
      | Coq_ident_fancy_mulhh -> false
      | Coq_ident_fancy_rshi -> false
      | Coq_ident_fancy_selc -> false
      | Coq_ident_fancy_selm -> false
      | Coq_ident_fancy_sell -> false
      | Coq_ident_fancy_addm -> false); Compilers.Coq_invert_expr.is_cons =
      (fun _ idc ->
      match idc with
      | Coq_ident_Literal (_, _) -> false
      | Coq_ident_comment _ -> false
      | Coq_ident_comment_no_keep _ -> false
      | Coq_ident_value_barrier -> false
      | Coq_ident_Nat_succ -> false
      | Coq_ident_Nat_pred -> false
      | Coq_ident_Nat_max -> false
      | Coq_ident_Nat_mul -> false
      | Coq_ident_Nat_add -> false
      | Coq_ident_Nat_sub -> false
      | Coq_ident_Nat_eqb -> false
      | Coq_ident_nil _ -> false
      | Coq_ident_cons _ -> true
      | Coq_ident_tt -> false
      | Coq_ident_pair (_, _) -> false
      | Coq_ident_fst (_, _) -> false
      | Coq_ident_snd (_, _) -> false
      | Coq_ident_prod_rect (_, _, _) -> false
      | Coq_ident_bool_rect _ -> false
      | Coq_ident_bool_rect_nodep _ -> false
      | Coq_ident_nat_rect _ -> false
      | Coq_ident_eager_nat_rect _ -> false
      | Coq_ident_nat_rect_arrow (_, _) -> false
      | Coq_ident_eager_nat_rect_arrow (_, _) -> false
      | Coq_ident_list_rect (_, _) -> false
      | Coq_ident_eager_list_rect (_, _) -> false
      | Coq_ident_list_rect_arrow (_, _, _) -> false
      | Coq_ident_eager_list_rect_arrow (_, _, _) -> false
      | Coq_ident_list_case (_, _) -> false
      | Coq_ident_List_length _ -> false
      | Coq_ident_List_seq -> false
      | Coq_ident_List_firstn _ -> false
      | Coq_ident_List_skipn _ -> false
      | Coq_ident_List_repeat _ -> false
      | Coq_ident_List_combine (_, _) -> false
      | Coq_ident_List_map (_, _) -> false
      | Coq_ident_List_app _ -> false
      | Coq_ident_List_rev _ -> false
      | Coq_ident_List_flat_map (_, _) -> false
      | Coq_ident_List_partition _ -> false
      | Coq_ident_List_filter _ -> false
      | Coq_ident_List_fold_right (_, _) -> false
      | Coq_ident_List_update_nth _ -> false
      | Coq_ident_List_nth_default _ -> false
      | Coq_ident_eager_List_nth_default _ -> false
      | Coq_ident_Z_add -> false
      | Coq_ident_Z_mul -> false
      | Coq_ident_Z_pow -> false
      | Coq_ident_Z_sub -> false
      | Coq_ident_Z_opp -> false
      | Coq_ident_Z_div -> false
      | Coq_ident_Z_modulo -> false
      | Coq_ident_Z_eqb -> false
      | Coq_ident_Z_leb -> false
      | Coq_ident_Z_ltb -> false
      | Coq_ident_Z_geb -> false
      | Coq_ident_Z_gtb -> false
      | Coq_ident_Z_log2 -> false
      | Coq_ident_Z_log2_up -> false
      | Coq_ident_Z_of_nat -> false
      | Coq_ident_Z_to_nat -> false
      | Coq_ident_Z_shiftr -> false
      | Coq_ident_Z_shiftl -> false
      | Coq_ident_Z_land -> false
      | Coq_ident_Z_lor -> false
      | Coq_ident_Z_min -> false
      | Coq_ident_Z_max -> false
      | Coq_ident_Z_mul_split -> false
      | Coq_ident_Z_mul_high -> false
      | Coq_ident_Z_add_get_carry -> false
      | Coq_ident_Z_add_with_carry -> false
      | Coq_ident_Z_add_with_get_carry -> false
      | Coq_ident_Z_sub_get_borrow -> false
      | Coq_ident_Z_sub_with_get_borrow -> false
      | Coq_ident_Z_ltz -> false
      | Coq_ident_Z_zselect -> false
      | Coq_ident_Z_add_modulo -> false
      | Coq_ident_Z_truncating_shiftl -> false
      | Coq_ident_Z_bneg -> false
      | Coq_ident_Z_lnot_modulo -> false
      | Coq_ident_Z_lxor -> false
      | Coq_ident_Z_rshi -> false
      | Coq_ident_Z_cc_m -> false
      | Coq_ident_Z_combine_at_bitwidth -> false
      | Coq_ident_Z_cast -> false
      | Coq_ident_Z_cast2 -> false
      | Coq_ident_Some _ -> false
      | Coq_ident_None _ -> false
      | Coq_ident_option_rect (_, _) -> false
      | Coq_ident_Build_zrange -> false
      | Coq_ident_zrange_rect _ -> false
      | Coq_ident_fancy_add -> false
      | Coq_ident_fancy_addc -> false
      | Coq_ident_fancy_sub -> false
      | Coq_ident_fancy_subb -> false
      | Coq_ident_fancy_mulll -> false
      | Coq_ident_fancy_mullh -> false
      | Coq_ident_fancy_mulhl -> false
      | Coq_ident_fancy_mulhh -> false
      | Coq_ident_fancy_rshi -> false
      | Coq_ident_fancy_selc -> false
      | Coq_ident_fancy_selm -> false
      | Coq_ident_fancy_sell -> false
      | Coq_ident_fancy_addm -> false); Compilers.Coq_invert_expr.is_Some =
      (fun _ idc ->
      match idc with
      | Coq_ident_Literal (_, _) -> false
      | Coq_ident_comment _ -> false
      | Coq_ident_comment_no_keep _ -> false
      | Coq_ident_value_barrier -> false
      | Coq_ident_Nat_succ -> false
      | Coq_ident_Nat_pred -> false
      | Coq_ident_Nat_max -> false
      | Coq_ident_Nat_mul -> false
      | Coq_ident_Nat_add -> false
      | Coq_ident_Nat_sub -> false
      | Coq_ident_Nat_eqb -> false
      | Coq_ident_nil _ -> false
      | Coq_ident_cons _ -> false
      | Coq_ident_tt -> false
      | Coq_ident_pair (_, _) -> false
      | Coq_ident_fst (_, _) -> false
      | Coq_ident_snd (_, _) -> false
      | Coq_ident_prod_rect (_, _, _) -> false
      | Coq_ident_bool_rect _ -> false
      | Coq_ident_bool_rect_nodep _ -> false
      | Coq_ident_nat_rect _ -> false
      | Coq_ident_eager_nat_rect _ -> false
      | Coq_ident_nat_rect_arrow (_, _) -> false
      | Coq_ident_eager_nat_rect_arrow (_, _) -> false
      | Coq_ident_list_rect (_, _) -> false
      | Coq_ident_eager_list_rect (_, _) -> false
      | Coq_ident_list_rect_arrow (_, _, _) -> false
      | Coq_ident_eager_list_rect_arrow (_, _, _) -> false
      | Coq_ident_list_case (_, _) -> false
      | Coq_ident_List_length _ -> false
      | Coq_ident_List_seq -> false
      | Coq_ident_List_firstn _ -> false
      | Coq_ident_List_skipn _ -> false
      | Coq_ident_List_repeat _ -> false
      | Coq_ident_List_combine (_, _) -> false
      | Coq_ident_List_map (_, _) -> false
      | Coq_ident_List_app _ -> false
      | Coq_ident_List_rev _ -> false
      | Coq_ident_List_flat_map (_, _) -> false
      | Coq_ident_List_partition _ -> false
      | Coq_ident_List_filter _ -> false
      | Coq_ident_List_fold_right (_, _) -> false
      | Coq_ident_List_update_nth _ -> false
      | Coq_ident_List_nth_default _ -> false
      | Coq_ident_eager_List_nth_default _ -> false
      | Coq_ident_Z_add -> false
      | Coq_ident_Z_mul -> false
      | Coq_ident_Z_pow -> false
      | Coq_ident_Z_sub -> false
      | Coq_ident_Z_opp -> false
      | Coq_ident_Z_div -> false
      | Coq_ident_Z_modulo -> false
      | Coq_ident_Z_eqb -> false
      | Coq_ident_Z_leb -> false
      | Coq_ident_Z_ltb -> false
      | Coq_ident_Z_geb -> false
      | Coq_ident_Z_gtb -> false
      | Coq_ident_Z_log2 -> false
      | Coq_ident_Z_log2_up -> false
      | Coq_ident_Z_of_nat -> false
      | Coq_ident_Z_to_nat -> false
      | Coq_ident_Z_shiftr -> false
      | Coq_ident_Z_shiftl -> false
      | Coq_ident_Z_land -> false
      | Coq_ident_Z_lor -> false
      | Coq_ident_Z_min -> false
      | Coq_ident_Z_max -> false
      | Coq_ident_Z_mul_split -> false
      | Coq_ident_Z_mul_high -> false
      | Coq_ident_Z_add_get_carry -> false
      | Coq_ident_Z_add_with_carry -> false
      | Coq_ident_Z_add_with_get_carry -> false
      | Coq_ident_Z_sub_get_borrow -> false
      | Coq_ident_Z_sub_with_get_borrow -> false
      | Coq_ident_Z_ltz -> false
      | Coq_ident_Z_zselect -> false
      | Coq_ident_Z_add_modulo -> false
      | Coq_ident_Z_truncating_shiftl -> false
      | Coq_ident_Z_bneg -> false
      | Coq_ident_Z_lnot_modulo -> false
      | Coq_ident_Z_lxor -> false
      | Coq_ident_Z_rshi -> false
      | Coq_ident_Z_cc_m -> false
      | Coq_ident_Z_combine_at_bitwidth -> false
      | Coq_ident_Z_cast -> false
      | Coq_ident_Z_cast2 -> false
      | Coq_ident_Some _ -> true
      | Coq_ident_None _ -> false
      | Coq_ident_option_rect (_, _) -> false
      | Coq_ident_Build_zrange -> false
      | Coq_ident_zrange_rect _ -> false
      | Coq_ident_fancy_add -> false
      | Coq_ident_fancy_addc -> false
      | Coq_ident_fancy_sub -> false
      | Coq_ident_fancy_subb -> false
      | Coq_ident_fancy_mulll -> false
      | Coq_ident_fancy_mullh -> false
      | Coq_ident_fancy_mulhl -> false
      | Coq_ident_fancy_mulhh -> false
      | Coq_ident_fancy_rshi -> false
      | Coq_ident_fancy_selc -> false
      | Coq_ident_fancy_selm -> false
      | Coq_ident_fancy_sell -> false
      | Coq_ident_fancy_addm -> false); Compilers.Coq_invert_expr.is_None =
      (fun _ idc ->
      match idc with
      | Coq_ident_Literal (_, _) -> false
      | Coq_ident_comment _ -> false
      | Coq_ident_comment_no_keep _ -> false
      | Coq_ident_value_barrier -> false
      | Coq_ident_Nat_succ -> false
      | Coq_ident_Nat_pred -> false
      | Coq_ident_Nat_max -> false
      | Coq_ident_Nat_mul -> false
      | Coq_ident_Nat_add -> false
      | Coq_ident_Nat_sub -> false
      | Coq_ident_Nat_eqb -> false
      | Coq_ident_nil _ -> false
      | Coq_ident_cons _ -> false
      | Coq_ident_tt -> false
      | Coq_ident_pair (_, _) -> false
      | Coq_ident_fst (_, _) -> false
      | Coq_ident_snd (_, _) -> false
      | Coq_ident_prod_rect (_, _, _) -> false
      | Coq_ident_bool_rect _ -> false
      | Coq_ident_bool_rect_nodep _ -> false
      | Coq_ident_nat_rect _ -> false
      | Coq_ident_eager_nat_rect _ -> false
      | Coq_ident_nat_rect_arrow (_, _) -> false
      | Coq_ident_eager_nat_rect_arrow (_, _) -> false
      | Coq_ident_list_rect (_, _) -> false
      | Coq_ident_eager_list_rect (_, _) -> false
      | Coq_ident_list_rect_arrow (_, _, _) -> false
      | Coq_ident_eager_list_rect_arrow (_, _, _) -> false
      | Coq_ident_list_case (_, _) -> false
      | Coq_ident_List_length _ -> false
      | Coq_ident_List_seq -> false
      | Coq_ident_List_firstn _ -> false
      | Coq_ident_List_skipn _ -> false
      | Coq_ident_List_repeat _ -> false
      | Coq_ident_List_combine (_, _) -> false
      | Coq_ident_List_map (_, _) -> false
      | Coq_ident_List_app _ -> false
      | Coq_ident_List_rev _ -> false
      | Coq_ident_List_flat_map (_, _) -> false
      | Coq_ident_List_partition _ -> false
      | Coq_ident_List_filter _ -> false
      | Coq_ident_List_fold_right (_, _) -> false
      | Coq_ident_List_update_nth _ -> false
      | Coq_ident_List_nth_default _ -> false
      | Coq_ident_eager_List_nth_default _ -> false
      | Coq_ident_Z_add -> false
      | Coq_ident_Z_mul -> false
      | Coq_ident_Z_pow -> false
      | Coq_ident_Z_sub -> false
      | Coq_ident_Z_opp -> false
      | Coq_ident_Z_div -> false
      | Coq_ident_Z_modulo -> false
      | Coq_ident_Z_eqb -> false
      | Coq_ident_Z_leb -> false
      | Coq_ident_Z_ltb -> false
      | Coq_ident_Z_geb -> false
      | Coq_ident_Z_gtb -> false
      | Coq_ident_Z_log2 -> false
      | Coq_ident_Z_log2_up -> false
      | Coq_ident_Z_of_nat -> false
      | Coq_ident_Z_to_nat -> false
      | Coq_ident_Z_shiftr -> false
      | Coq_ident_Z_shiftl -> false
      | Coq_ident_Z_land -> false
      | Coq_ident_Z_lor -> false
      | Coq_ident_Z_min -> false
      | Coq_ident_Z_max -> false
      | Coq_ident_Z_mul_split -> false
      | Coq_ident_Z_mul_high -> false
      | Coq_ident_Z_add_get_carry -> false
      | Coq_ident_Z_add_with_carry -> false
      | Coq_ident_Z_add_with_get_carry -> false
      | Coq_ident_Z_sub_get_borrow -> false
      | Coq_ident_Z_sub_with_get_borrow -> false
      | Coq_ident_Z_ltz -> false
      | Coq_ident_Z_zselect -> false
      | Coq_ident_Z_add_modulo -> false
      | Coq_ident_Z_truncating_shiftl -> false
      | Coq_ident_Z_bneg -> false
      | Coq_ident_Z_lnot_modulo -> false
      | Coq_ident_Z_lxor -> false
      | Coq_ident_Z_rshi -> false
      | Coq_ident_Z_cc_m -> false
      | Coq_ident_Z_combine_at_bitwidth -> false
      | Coq_ident_Z_cast -> false
      | Coq_ident_Z_cast2 -> false
      | Coq_ident_Some _ -> false
      | Coq_ident_None _ -> true
      | Coq_ident_option_rect (_, _) -> false
      | Coq_ident_Build_zrange -> false
      | Coq_ident_zrange_rect _ -> false
      | Coq_ident_fancy_add -> false
      | Coq_ident_fancy_addc -> false
      | Coq_ident_fancy_sub -> false
      | Coq_ident_fancy_subb -> false
      | Coq_ident_fancy_mulll -> false
      | Coq_ident_fancy_mullh -> false
      | Coq_ident_fancy_mulhl -> false
      | Coq_ident_fancy_mulhh -> false
      | Coq_ident_fancy_rshi -> false
      | Coq_ident_fancy_selc -> false
      | Coq_ident_fancy_selm -> false
      | Coq_ident_fancy_sell -> false
      | Coq_ident_fancy_addm -> false); Compilers.Coq_invert_expr.is_pair =
      (fun _ idc ->
      match idc with
      | Coq_ident_Literal (_, _) -> false
      | Coq_ident_comment _ -> false
      | Coq_ident_comment_no_keep _ -> false
      | Coq_ident_value_barrier -> false
      | Coq_ident_Nat_succ -> false
      | Coq_ident_Nat_pred -> false
      | Coq_ident_Nat_max -> false
      | Coq_ident_Nat_mul -> false
      | Coq_ident_Nat_add -> false
      | Coq_ident_Nat_sub -> false
      | Coq_ident_Nat_eqb -> false
      | Coq_ident_nil _ -> false
      | Coq_ident_cons _ -> false
      | Coq_ident_tt -> false
      | Coq_ident_pair (_, _) -> true
      | Coq_ident_fst (_, _) -> false
      | Coq_ident_snd (_, _) -> false
      | Coq_ident_prod_rect (_, _, _) -> false
      | Coq_ident_bool_rect _ -> false
      | Coq_ident_bool_rect_nodep _ -> false
      | Coq_ident_nat_rect _ -> false
      | Coq_ident_eager_nat_rect _ -> false
      | Coq_ident_nat_rect_arrow (_, _) -> false
      | Coq_ident_eager_nat_rect_arrow (_, _) -> false
      | Coq_ident_list_rect (_, _) -> false
      | Coq_ident_eager_list_rect (_, _) -> false
      | Coq_ident_list_rect_arrow (_, _, _) -> false
      | Coq_ident_eager_list_rect_arrow (_, _, _) -> false
      | Coq_ident_list_case (_, _) -> false
      | Coq_ident_List_length _ -> false
      | Coq_ident_List_seq -> false
      | Coq_ident_List_firstn _ -> false
      | Coq_ident_List_skipn _ -> false
      | Coq_ident_List_repeat _ -> false
      | Coq_ident_List_combine (_, _) -> false
      | Coq_ident_List_map (_, _) -> false
      | Coq_ident_List_app _ -> false
      | Coq_ident_List_rev _ -> false
      | Coq_ident_List_flat_map (_, _) -> false
      | Coq_ident_List_partition _ -> false
      | Coq_ident_List_filter _ -> false
      | Coq_ident_List_fold_right (_, _) -> false
      | Coq_ident_List_update_nth _ -> false
      | Coq_ident_List_nth_default _ -> false
      | Coq_ident_eager_List_nth_default _ -> false
      | Coq_ident_Z_add -> false
      | Coq_ident_Z_mul -> false
      | Coq_ident_Z_pow -> false
      | Coq_ident_Z_sub -> false
      | Coq_ident_Z_opp -> false
      | Coq_ident_Z_div -> false
      | Coq_ident_Z_modulo -> false
      | Coq_ident_Z_eqb -> false
      | Coq_ident_Z_leb -> false
      | Coq_ident_Z_ltb -> false
      | Coq_ident_Z_geb -> false
      | Coq_ident_Z_gtb -> false
      | Coq_ident_Z_log2 -> false
      | Coq_ident_Z_log2_up -> false
      | Coq_ident_Z_of_nat -> false
      | Coq_ident_Z_to_nat -> false
      | Coq_ident_Z_shiftr -> false
      | Coq_ident_Z_shiftl -> false
      | Coq_ident_Z_land -> false
      | Coq_ident_Z_lor -> false
      | Coq_ident_Z_min -> false
      | Coq_ident_Z_max -> false
      | Coq_ident_Z_mul_split -> false
      | Coq_ident_Z_mul_high -> false
      | Coq_ident_Z_add_get_carry -> false
      | Coq_ident_Z_add_with_carry -> false
      | Coq_ident_Z_add_with_get_carry -> false
      | Coq_ident_Z_sub_get_borrow -> false
      | Coq_ident_Z_sub_with_get_borrow -> false
      | Coq_ident_Z_ltz -> false
      | Coq_ident_Z_zselect -> false
      | Coq_ident_Z_add_modulo -> false
      | Coq_ident_Z_truncating_shiftl -> false
      | Coq_ident_Z_bneg -> false
      | Coq_ident_Z_lnot_modulo -> false
      | Coq_ident_Z_lxor -> false
      | Coq_ident_Z_rshi -> false
      | Coq_ident_Z_cc_m -> false
      | Coq_ident_Z_combine_at_bitwidth -> false
      | Coq_ident_Z_cast -> false
      | Coq_ident_Z_cast2 -> false
      | Coq_ident_Some _ -> false
      | Coq_ident_None _ -> false
      | Coq_ident_option_rect (_, _) -> false
      | Coq_ident_Build_zrange -> false
      | Coq_ident_zrange_rect _ -> false
      | Coq_ident_fancy_add -> false
      | Coq_ident_fancy_addc -> false
      | Coq_ident_fancy_sub -> false
      | Coq_ident_fancy_subb -> false
      | Coq_ident_fancy_mulll -> false
      | Coq_ident_fancy_mullh -> false
      | Coq_ident_fancy_mulhl -> false
      | Coq_ident_fancy_mulhh -> false
      | Coq_ident_fancy_rshi -> false
      | Coq_ident_fancy_selc -> false
      | Coq_ident_fancy_selm -> false
      | Coq_ident_fancy_sell -> false
      | Coq_ident_fancy_addm -> false); Compilers.Coq_invert_expr.is_tt =
      (fun _ idc ->
      match idc with
      | Coq_ident_Literal (_, _) -> false
      | Coq_ident_comment _ -> false
      | Coq_ident_comment_no_keep _ -> false
      | Coq_ident_value_barrier -> false
      | Coq_ident_Nat_succ -> false
      | Coq_ident_Nat_pred -> false
      | Coq_ident_Nat_max -> false
      | Coq_ident_Nat_mul -> false
      | Coq_ident_Nat_add -> false
      | Coq_ident_Nat_sub -> false
      | Coq_ident_Nat_eqb -> false
      | Coq_ident_nil _ -> false
      | Coq_ident_cons _ -> false
      | Coq_ident_tt -> true
      | Coq_ident_pair (_, _) -> false
      | Coq_ident_fst (_, _) -> false
      | Coq_ident_snd (_, _) -> false
      | Coq_ident_prod_rect (_, _, _) -> false
      | Coq_ident_bool_rect _ -> false
      | Coq_ident_bool_rect_nodep _ -> false
      | Coq_ident_nat_rect _ -> false
      | Coq_ident_eager_nat_rect _ -> false
      | Coq_ident_nat_rect_arrow (_, _) -> false
      | Coq_ident_eager_nat_rect_arrow (_, _) -> false
      | Coq_ident_list_rect (_, _) -> false
      | Coq_ident_eager_list_rect (_, _) -> false
      | Coq_ident_list_rect_arrow (_, _, _) -> false
      | Coq_ident_eager_list_rect_arrow (_, _, _) -> false
      | Coq_ident_list_case (_, _) -> false
      | Coq_ident_List_length _ -> false
      | Coq_ident_List_seq -> false
      | Coq_ident_List_firstn _ -> false
      | Coq_ident_List_skipn _ -> false
      | Coq_ident_List_repeat _ -> false
      | Coq_ident_List_combine (_, _) -> false
      | Coq_ident_List_map (_, _) -> false
      | Coq_ident_List_app _ -> false
      | Coq_ident_List_rev _ -> false
      | Coq_ident_List_flat_map (_, _) -> false
      | Coq_ident_List_partition _ -> false
      | Coq_ident_List_filter _ -> false
      | Coq_ident_List_fold_right (_, _) -> false
      | Coq_ident_List_update_nth _ -> false
      | Coq_ident_List_nth_default _ -> false
      | Coq_ident_eager_List_nth_default _ -> false
      | Coq_ident_Z_add -> false
      | Coq_ident_Z_mul -> false
      | Coq_ident_Z_pow -> false
      | Coq_ident_Z_sub -> false
      | Coq_ident_Z_opp -> false
      | Coq_ident_Z_div -> false
      | Coq_ident_Z_modulo -> false
      | Coq_ident_Z_eqb -> false
      | Coq_ident_Z_leb -> false
      | Coq_ident_Z_ltb -> false
      | Coq_ident_Z_geb -> false
      | Coq_ident_Z_gtb -> false
      | Coq_ident_Z_log2 -> false
      | Coq_ident_Z_log2_up -> false
      | Coq_ident_Z_of_nat -> false
      | Coq_ident_Z_to_nat -> false
      | Coq_ident_Z_shiftr -> false
      | Coq_ident_Z_shiftl -> false
      | Coq_ident_Z_land -> false
      | Coq_ident_Z_lor -> false
      | Coq_ident_Z_min -> false
      | Coq_ident_Z_max -> false
      | Coq_ident_Z_mul_split -> false
      | Coq_ident_Z_mul_high -> false
      | Coq_ident_Z_add_get_carry -> false
      | Coq_ident_Z_add_with_carry -> false
      | Coq_ident_Z_add_with_get_carry -> false
      | Coq_ident_Z_sub_get_borrow -> false
      | Coq_ident_Z_sub_with_get_borrow -> false
      | Coq_ident_Z_ltz -> false
      | Coq_ident_Z_zselect -> false
      | Coq_ident_Z_add_modulo -> false
      | Coq_ident_Z_truncating_shiftl -> false
      | Coq_ident_Z_bneg -> false
      | Coq_ident_Z_lnot_modulo -> false
      | Coq_ident_Z_lxor -> false
      | Coq_ident_Z_rshi -> false
      | Coq_ident_Z_cc_m -> false
      | Coq_ident_Z_combine_at_bitwidth -> false
      | Coq_ident_Z_cast -> false
      | Coq_ident_Z_cast2 -> false
      | Coq_ident_Some _ -> false
      | Coq_ident_None _ -> false
      | Coq_ident_option_rect (_, _) -> false
      | Coq_ident_Build_zrange -> false
      | Coq_ident_zrange_rect _ -> false
      | Coq_ident_fancy_add -> false
      | Coq_ident_fancy_addc -> false
      | Coq_ident_fancy_sub -> false
      | Coq_ident_fancy_subb -> false
      | Coq_ident_fancy_mulll -> false
      | Coq_ident_fancy_mullh -> false
      | Coq_ident_fancy_mulhl -> false
      | Coq_ident_fancy_mulhh -> false
      | Coq_ident_fancy_rshi -> false
      | Coq_ident_fancy_selc -> false
      | Coq_ident_fancy_selm -> false
      | Coq_ident_fancy_sell -> false
      | Coq_ident_fancy_addm -> false) }

  (** val base_default :
      (base, base_interp)
      Compilers.DefaultValue.Coq_type.Coq_base.coq_DefaultT **)

  let base_default = function
  | Z -> Obj.magic Z0
  | Coq_bool -> Obj.magic true
  | Coq_nat -> Obj.magic O
  | Coq_zrange -> Obj.magic { lower = Z0; upper = Z0 }
  | Coq_string -> Obj.magic []
 end

module Coq4_Compilers =
 struct
  module Coq_ident =
   struct
    (** val is_comment :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool **)

    let is_comment _ = function
    | Coq3_Compilers.Coq_ident_Literal (_, _) -> false
    | Coq3_Compilers.Coq_ident_comment _ -> true
    | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
    | Coq3_Compilers.Coq_ident_value_barrier -> false
    | Coq3_Compilers.Coq_ident_Nat_succ -> false
    | Coq3_Compilers.Coq_ident_Nat_pred -> false
    | Coq3_Compilers.Coq_ident_Nat_max -> false
    | Coq3_Compilers.Coq_ident_Nat_mul -> false
    | Coq3_Compilers.Coq_ident_Nat_add -> false
    | Coq3_Compilers.Coq_ident_Nat_sub -> false
    | Coq3_Compilers.Coq_ident_Nat_eqb -> false
    | Coq3_Compilers.Coq_ident_nil _ -> false
    | Coq3_Compilers.Coq_ident_cons _ -> false
    | Coq3_Compilers.Coq_ident_tt -> false
    | Coq3_Compilers.Coq_ident_pair (_, _) -> false
    | Coq3_Compilers.Coq_ident_fst (_, _) -> false
    | Coq3_Compilers.Coq_ident_snd (_, _) -> false
    | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> false
    | Coq3_Compilers.Coq_ident_bool_rect _ -> false
    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> false
    | Coq3_Compilers.Coq_ident_nat_rect _ -> false
    | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> false
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> false
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> false
    | Coq3_Compilers.Coq_ident_list_rect (_, _) -> false
    | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> false
    | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> false
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> false
    | Coq3_Compilers.Coq_ident_list_case (_, _) -> false
    | Coq3_Compilers.Coq_ident_List_length _ -> false
    | Coq3_Compilers.Coq_ident_List_seq -> false
    | Coq3_Compilers.Coq_ident_List_firstn _ -> false
    | Coq3_Compilers.Coq_ident_List_skipn _ -> false
    | Coq3_Compilers.Coq_ident_List_repeat _ -> false
    | Coq3_Compilers.Coq_ident_List_combine (_, _) -> false
    | Coq3_Compilers.Coq_ident_List_map (_, _) -> false
    | Coq3_Compilers.Coq_ident_List_app _ -> false
    | Coq3_Compilers.Coq_ident_List_rev _ -> false
    | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> false
    | Coq3_Compilers.Coq_ident_List_partition _ -> false
    | Coq3_Compilers.Coq_ident_List_filter _ -> false
    | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> false
    | Coq3_Compilers.Coq_ident_List_update_nth _ -> false
    | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> false
    | Coq3_Compilers.Coq_ident_Z_add -> false
    | Coq3_Compilers.Coq_ident_Z_mul -> false
    | Coq3_Compilers.Coq_ident_Z_pow -> false
    | Coq3_Compilers.Coq_ident_Z_sub -> false
    | Coq3_Compilers.Coq_ident_Z_opp -> false
    | Coq3_Compilers.Coq_ident_Z_div -> false
    | Coq3_Compilers.Coq_ident_Z_modulo -> false
    | Coq3_Compilers.Coq_ident_Z_eqb -> false
    | Coq3_Compilers.Coq_ident_Z_leb -> false
    | Coq3_Compilers.Coq_ident_Z_ltb -> false
    | Coq3_Compilers.Coq_ident_Z_geb -> false
    | Coq3_Compilers.Coq_ident_Z_gtb -> false
    | Coq3_Compilers.Coq_ident_Z_log2 -> false
    | Coq3_Compilers.Coq_ident_Z_log2_up -> false
    | Coq3_Compilers.Coq_ident_Z_of_nat -> false
    | Coq3_Compilers.Coq_ident_Z_to_nat -> false
    | Coq3_Compilers.Coq_ident_Z_shiftr -> false
    | Coq3_Compilers.Coq_ident_Z_shiftl -> false
    | Coq3_Compilers.Coq_ident_Z_land -> false
    | Coq3_Compilers.Coq_ident_Z_lor -> false
    | Coq3_Compilers.Coq_ident_Z_min -> false
    | Coq3_Compilers.Coq_ident_Z_max -> false
    | Coq3_Compilers.Coq_ident_Z_mul_split -> false
    | Coq3_Compilers.Coq_ident_Z_mul_high -> false
    | Coq3_Compilers.Coq_ident_Z_add_get_carry -> false
    | Coq3_Compilers.Coq_ident_Z_add_with_carry -> false
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> false
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> false
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> false
    | Coq3_Compilers.Coq_ident_Z_ltz -> false
    | Coq3_Compilers.Coq_ident_Z_zselect -> false
    | Coq3_Compilers.Coq_ident_Z_add_modulo -> false
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> false
    | Coq3_Compilers.Coq_ident_Z_bneg -> false
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
    | Coq3_Compilers.Coq_ident_Z_lxor -> false
    | Coq3_Compilers.Coq_ident_Z_rshi -> false
    | Coq3_Compilers.Coq_ident_Z_cc_m -> false
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> false
    | Coq3_Compilers.Coq_ident_Z_cast -> false
    | Coq3_Compilers.Coq_ident_Z_cast2 -> false
    | Coq3_Compilers.Coq_ident_Some _ -> false
    | Coq3_Compilers.Coq_ident_None _ -> false
    | Coq3_Compilers.Coq_ident_option_rect (_, _) -> false
    | Coq3_Compilers.Coq_ident_Build_zrange -> false
    | Coq3_Compilers.Coq_ident_zrange_rect _ -> false
    | Coq3_Compilers.Coq_ident_fancy_add -> false
    | Coq3_Compilers.Coq_ident_fancy_addc -> false
    | Coq3_Compilers.Coq_ident_fancy_sub -> false
    | Coq3_Compilers.Coq_ident_fancy_subb -> false
    | Coq3_Compilers.Coq_ident_fancy_mulll -> false
    | Coq3_Compilers.Coq_ident_fancy_mullh -> false
    | Coq3_Compilers.Coq_ident_fancy_mulhl -> false
    | Coq3_Compilers.Coq_ident_fancy_mulhh -> false
    | Coq3_Compilers.Coq_ident_fancy_rshi -> false
    | Coq3_Compilers.Coq_ident_fancy_selc -> false
    | Coq3_Compilers.Coq_ident_fancy_selm -> false
    | Coq3_Compilers.Coq_ident_fancy_sell -> false
    | Coq3_Compilers.Coq_ident_fancy_addm -> false

    module Notations =
     struct
     end
   end

  module Coq_invert_expr =
   struct
    module Coq_ident =
     struct
     end

    (** val invert_Z_cast :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> zrange option **)

    let invert_Z_cast t0 e =
      match Compilers.Coq_invert_expr.invert_AppIdent t0 e with
      | Some s0 ->
        let ExistT (x, p) = s0 in
        (match x with
         | Compilers.Coq_type.Coq_base t1 ->
           (match t1 with
            | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
              (match t2 with
               | Coq3_Compilers.Z -> (fun _ -> None)
               | Coq3_Compilers.Coq_bool -> (fun _ -> None)
               | Coq3_Compilers.Coq_nat -> (fun _ -> None)
               | Coq3_Compilers.Coq_zrange ->
                 (fun p0 ->
                   let (idc, r0) = p0 in
                   bind
                     (Obj.magic
                       Compilers.Coq_invert_expr.reflect_smart_Literal
                       (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1)
                       Coq3_Compilers.invertIdent
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_zrange) r0) (fun r1 ->
                     if match idc with
                        | Coq3_Compilers.Coq_ident_Literal (_, _) -> false
                        | Coq3_Compilers.Coq_ident_comment _ -> false
                        | Coq3_Compilers.Coq_ident_comment_no_keep _ -> false
                        | Coq3_Compilers.Coq_ident_value_barrier -> false
                        | Coq3_Compilers.Coq_ident_Nat_succ -> false
                        | Coq3_Compilers.Coq_ident_Nat_pred -> false
                        | Coq3_Compilers.Coq_ident_Nat_max -> false
                        | Coq3_Compilers.Coq_ident_Nat_mul -> false
                        | Coq3_Compilers.Coq_ident_Nat_add -> false
                        | Coq3_Compilers.Coq_ident_Nat_sub -> false
                        | Coq3_Compilers.Coq_ident_Nat_eqb -> false
                        | Coq3_Compilers.Coq_ident_nil _ -> false
                        | Coq3_Compilers.Coq_ident_cons _ -> false
                        | Coq3_Compilers.Coq_ident_tt -> false
                        | Coq3_Compilers.Coq_ident_pair (_, _) -> false
                        | Coq3_Compilers.Coq_ident_fst (_, _) -> false
                        | Coq3_Compilers.Coq_ident_snd (_, _) -> false
                        | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_bool_rect _ -> false
                        | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> false
                        | Coq3_Compilers.Coq_ident_nat_rect _ -> false
                        | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> false
                        | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                            _, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_list_rect (_, _) -> false
                        | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                            _, _, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_list_case (_, _) -> false
                        | Coq3_Compilers.Coq_ident_List_length _ -> false
                        | Coq3_Compilers.Coq_ident_List_seq -> false
                        | Coq3_Compilers.Coq_ident_List_firstn _ -> false
                        | Coq3_Compilers.Coq_ident_List_skipn _ -> false
                        | Coq3_Compilers.Coq_ident_List_repeat _ -> false
                        | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_List_map (_, _) -> false
                        | Coq3_Compilers.Coq_ident_List_app _ -> false
                        | Coq3_Compilers.Coq_ident_List_rev _ -> false
                        | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_List_partition _ -> false
                        | Coq3_Compilers.Coq_ident_List_filter _ -> false
                        | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                          false
                        | Coq3_Compilers.Coq_ident_List_update_nth _ -> false
                        | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                        | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                          false
                        | Coq3_Compilers.Coq_ident_Z_add -> false
                        | Coq3_Compilers.Coq_ident_Z_mul -> false
                        | Coq3_Compilers.Coq_ident_Z_pow -> false
                        | Coq3_Compilers.Coq_ident_Z_sub -> false
                        | Coq3_Compilers.Coq_ident_Z_opp -> false
                        | Coq3_Compilers.Coq_ident_Z_div -> false
                        | Coq3_Compilers.Coq_ident_Z_modulo -> false
                        | Coq3_Compilers.Coq_ident_Z_eqb -> false
                        | Coq3_Compilers.Coq_ident_Z_leb -> false
                        | Coq3_Compilers.Coq_ident_Z_ltb -> false
                        | Coq3_Compilers.Coq_ident_Z_geb -> false
                        | Coq3_Compilers.Coq_ident_Z_gtb -> false
                        | Coq3_Compilers.Coq_ident_Z_log2 -> false
                        | Coq3_Compilers.Coq_ident_Z_log2_up -> false
                        | Coq3_Compilers.Coq_ident_Z_of_nat -> false
                        | Coq3_Compilers.Coq_ident_Z_to_nat -> false
                        | Coq3_Compilers.Coq_ident_Z_shiftr -> false
                        | Coq3_Compilers.Coq_ident_Z_shiftl -> false
                        | Coq3_Compilers.Coq_ident_Z_land -> false
                        | Coq3_Compilers.Coq_ident_Z_lor -> false
                        | Coq3_Compilers.Coq_ident_Z_min -> false
                        | Coq3_Compilers.Coq_ident_Z_max -> false
                        | Coq3_Compilers.Coq_ident_Z_mul_split -> false
                        | Coq3_Compilers.Coq_ident_Z_mul_high -> false
                        | Coq3_Compilers.Coq_ident_Z_add_get_carry -> false
                        | Coq3_Compilers.Coq_ident_Z_add_with_carry -> false
                        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                          false
                        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> false
                        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                          false
                        | Coq3_Compilers.Coq_ident_Z_ltz -> false
                        | Coq3_Compilers.Coq_ident_Z_zselect -> false
                        | Coq3_Compilers.Coq_ident_Z_add_modulo -> false
                        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                          false
                        | Coq3_Compilers.Coq_ident_Z_bneg -> false
                        | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                        | Coq3_Compilers.Coq_ident_Z_lxor -> false
                        | Coq3_Compilers.Coq_ident_Z_rshi -> false
                        | Coq3_Compilers.Coq_ident_Z_cc_m -> false
                        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                          false
                        | Coq3_Compilers.Coq_ident_Z_cast -> true
                        | Coq3_Compilers.Coq_ident_Z_cast2 -> false
                        | Coq3_Compilers.Coq_ident_Some _ -> false
                        | Coq3_Compilers.Coq_ident_None _ -> false
                        | Coq3_Compilers.Coq_ident_option_rect (_, _) -> false
                        | Coq3_Compilers.Coq_ident_Build_zrange -> false
                        | Coq3_Compilers.Coq_ident_zrange_rect _ -> false
                        | Coq3_Compilers.Coq_ident_fancy_add -> false
                        | Coq3_Compilers.Coq_ident_fancy_addc -> false
                        | Coq3_Compilers.Coq_ident_fancy_sub -> false
                        | Coq3_Compilers.Coq_ident_fancy_subb -> false
                        | Coq3_Compilers.Coq_ident_fancy_mulll -> false
                        | Coq3_Compilers.Coq_ident_fancy_mullh -> false
                        | Coq3_Compilers.Coq_ident_fancy_mulhl -> false
                        | Coq3_Compilers.Coq_ident_fancy_mulhh -> false
                        | Coq3_Compilers.Coq_ident_fancy_rshi -> false
                        | Coq3_Compilers.Coq_ident_fancy_selc -> false
                        | Coq3_Compilers.Coq_ident_fancy_selm -> false
                        | Coq3_Compilers.Coq_ident_fancy_sell -> false
                        | Coq3_Compilers.Coq_ident_fancy_addm -> false
                     then Some r1
                     else None))
               | Coq3_Compilers.Coq_string -> (fun _ -> None))
            | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> None)
            | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
            | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
            | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
         | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None)) p
      | None -> None

    (** val invert_Z_cast2 :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> (zrange * zrange) option **)

    let invert_Z_cast2 t0 e =
      match Compilers.Coq_invert_expr.invert_AppIdent t0 e with
      | Some s0 ->
        let ExistT (x, p) = s0 in
        (match x with
         | Compilers.Coq_type.Coq_base t1 ->
           (match t1 with
            | Compilers.Coq_base.Coq_type.Coq_type_base _ -> (fun _ -> None)
            | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
              (match a with
               | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                 (match t2 with
                  | Coq3_Compilers.Z -> (fun _ -> None)
                  | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                  | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                  | Coq3_Compilers.Coq_zrange ->
                    (match b with
                     | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                       (match t3 with
                        | Coq3_Compilers.Z -> (fun _ -> None)
                        | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                        | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                        | Coq3_Compilers.Coq_zrange ->
                          (fun p0 ->
                            let (idc, r0) = p0 in
                            bind
                              (Obj.magic
                                Compilers.Coq_invert_expr.reflect_smart_Literal
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1) Coq3_Compilers.invertIdent
                                (Compilers.Coq_base.Coq_type.Coq_prod
                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_zrange),
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_zrange))) r0) (fun r1 ->
                              if match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_comment _ -> false
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> false
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> false
                                 | Coq3_Compilers.Coq_ident_Nat_max -> false
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> false
                                 | Coq3_Compilers.Coq_ident_Nat_add -> false
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> false
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> false
                                 | Coq3_Compilers.Coq_ident_nil _ -> false
                                 | Coq3_Compilers.Coq_ident_cons _ -> false
                                 | Coq3_Compilers.Coq_ident_tt -> false
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_seq -> false
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_add -> false
                                 | Coq3_Compilers.Coq_ident_Z_mul -> false
                                 | Coq3_Compilers.Coq_ident_Z_pow -> false
                                 | Coq3_Compilers.Coq_ident_Z_sub -> false
                                 | Coq3_Compilers.Coq_ident_Z_opp -> false
                                 | Coq3_Compilers.Coq_ident_Z_div -> false
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> false
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> false
                                 | Coq3_Compilers.Coq_ident_Z_leb -> false
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> false
                                 | Coq3_Compilers.Coq_ident_Z_geb -> false
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> false
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> false
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> false
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> false
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> false
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> false
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> false
                                 | Coq3_Compilers.Coq_ident_Z_land -> false
                                 | Coq3_Compilers.Coq_ident_Z_lor -> false
                                 | Coq3_Compilers.Coq_ident_Z_min -> false
                                 | Coq3_Compilers.Coq_ident_Z_max -> false
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> false
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> false
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> false
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> false
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> false
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> false
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_cast -> false
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> false
                                 | Coq3_Compilers.Coq_ident_None _ -> false
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   false
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_add -> false
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> false
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   false
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   false
                              then Some r1
                              else None))
                        | Coq3_Compilers.Coq_string -> (fun _ -> None))
                     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                       (fun _ -> None)
                     | Compilers.Coq_base.Coq_type.Coq_list _ ->
                       (fun _ -> None)
                     | Compilers.Coq_base.Coq_type.Coq_option _ ->
                       (fun _ -> None)
                     | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
                  | Coq3_Compilers.Coq_string -> (fun _ -> None))
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun _ -> None)
               | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
               | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
               | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
            | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
            | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
            | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
         | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None)) p
      | None -> None

    (** val invert_App_Z_cast :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
        (zrange * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr) option **)

    let invert_App_Z_cast e =
      let base1 = fun _ x -> Compilers.Coq_type.Coq_base x in
      (match Compilers.Coq_invert_expr.invert_App
               (base1 __ (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z)) e with
       | Some s0 ->
         let ExistT (x, p) = s0 in
         (match x with
          | Compilers.Coq_type.Coq_base t0 ->
            (match t0 with
             | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
               (match t1 with
                | Coq3_Compilers.Z ->
                  (fun p0 ->
                    let (idc, v) = p0 in
                    bind
                      (invert_Z_cast (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)),
                        (base1 __ (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) idc) (fun r0 -> Some (r0, v)))
                | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                | Coq3_Compilers.Coq_string -> (fun _ -> None))
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
          | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None)) p
       | None -> None)

    (** val invert_App_Z_cast2 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
        ((zrange * zrange) * (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) option **)

    let invert_App_Z_cast2 e =
      let base1 = fun _ x -> Compilers.Coq_type.Coq_base x in
      (match Compilers.Coq_invert_expr.invert_App
               (base1 __ (Compilers.Coq_base.Coq_type.Coq_prod
                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z),
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z)))) e with
       | Some s0 ->
         let ExistT (x, p) = s0 in
         (match x with
          | Compilers.Coq_type.Coq_base t0 ->
            (match t0 with
             | Compilers.Coq_base.Coq_type.Coq_type_base _ -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
               (match a with
                | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
                  (match t1 with
                   | Coq3_Compilers.Z ->
                     (match b with
                      | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                        (match t2 with
                         | Coq3_Compilers.Z ->
                           (fun p0 ->
                             let (idc, v) = p0 in
                             bind
                               (invert_Z_cast2 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z),
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)))),
                                 (base1 __
                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z),
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))))) idc) (fun r0 ->
                               Some (r0, v)))
                         | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                         | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                         | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                         | Coq3_Compilers.Coq_string -> (fun _ -> None))
                      | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                        (fun _ -> None)
                      | Compilers.Coq_base.Coq_type.Coq_list _ ->
                        (fun _ -> None)
                      | Compilers.Coq_base.Coq_type.Coq_option _ ->
                        (fun _ -> None)
                      | Compilers.Coq_base.Coq_type.Coq_unit ->
                        (fun _ -> None))
                   | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                   | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                   | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                   | Coq3_Compilers.Coq_string -> (fun _ -> None))
                | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                  (fun _ -> None)
                | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
                | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
                | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
             | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
          | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None)) p
       | None -> None)

    (** val invert_App_cast :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> ((Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base, zrange)
        Compilers.Coq_base.interp)
        Compilers.Coq_type.interp * (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) option **)

    let invert_App_cast t0 e =
      (match t0 with
       | Compilers.Coq_type.Coq_base t1 ->
         (match t1 with
          | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
            (match t2 with
             | Coq3_Compilers.Z -> Obj.magic invert_App_Z_cast
             | Coq3_Compilers.Coq_bool -> (fun _ -> None)
             | Coq3_Compilers.Coq_nat -> (fun _ -> None)
             | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
             | Coq3_Compilers.Coq_string -> (fun _ -> None))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (match a with
             | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
               (match t2 with
                | Coq3_Compilers.Z ->
                  (match b with
                   | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                     (match t3 with
                      | Coq3_Compilers.Z -> Obj.magic invert_App_Z_cast2
                      | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                      | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                      | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                      | Coq3_Compilers.Coq_string -> (fun _ -> None))
                   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                     (fun _ -> None)
                   | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
                   | Compilers.Coq_base.Coq_type.Coq_option _ ->
                     (fun _ -> None)
                   | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
                | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                | Coq3_Compilers.Coq_string -> (fun _ -> None))
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
             | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
          | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
          | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
       | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None)) e

    (** val invert_Literal_through_cast :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> ((Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base, zrange)
        Compilers.Coq_base.interp) Compilers.Coq_type.interp
        option * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        (Coq3_Compilers.base, Coq3_Compilers.base_interp)
        Compilers.Coq_base.interp) Compilers.Coq_type.interp) option **)

    let invert_Literal_through_cast t0 e =
      match Compilers.Coq_invert_expr.invert_Literal
              Coq3_Compilers.invertIdent t0 e with
      | Some v -> Some (None, v)
      | None ->
        (match invert_App_cast t0 e with
         | Some p ->
           let (r0, e0) = p in
           bind
             (Compilers.Coq_invert_expr.invert_Literal
               Coq3_Compilers.invertIdent t0 e0) (fun v -> Some ((Some r0),
             v))
         | None -> None)
   end

  module Coercions =
   struct
    (** val type_base :
        Coq3_Compilers.base -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type **)

    let type_base x =
      Compilers.Coq_base.Coq_type.Coq_type_base x

    (** val base :
        'a1 Compilers.Coq_base.Coq_type.coq_type -> 'a1
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type **)

    let base x =
      Compilers.Coq_type.Coq_base x
   end
 end

module Coq5_Compilers =
 struct
  module Coq_ident = Coq4_Compilers.Coq_ident

  module Coq_invert_expr = Coq4_Compilers.Coq_invert_expr

  module Coercions = Coq4_Compilers.Coercions
 end

(** val fold_andb_map :
    ('a1 -> 'a2 -> bool) -> 'a1 list -> 'a2 list -> bool **)

let rec fold_andb_map f ls1 ls2 =
  match ls1 with
  | [] -> (match ls2 with
           | [] -> true
           | _ :: _ -> false)
  | x :: xs ->
    (match ls2 with
     | [] -> false
     | y :: ys -> (&&) (f x y) (fold_andb_map f xs ys))

module Coq6_Compilers =
 struct
  module ZRange =
   struct
    module Settings =
     struct
      type shiftr_avoid_uint1_opt = bool

      module AbstractInterpretation =
       struct
        type coq_Options =
          shiftr_avoid_uint1_opt
          (* singleton inductive, whose constructor was Build_Options *)

        (** val shiftr_avoid_uint1 : coq_Options -> shiftr_avoid_uint1_opt **)

        let shiftr_avoid_uint1 options =
          options

        (** val default_Options : coq_Options **)

        let default_Options =
          false
       end
     end

    module Coq_type =
     struct
      module Coq_base =
       struct
        module Coq__4 = struct
         type interp = __
        end
        include Coq__4

        module Coq__5 = struct
         (** val map_ranges :
             (zrange -> zrange) -> Coq3_Compilers.base
             Compilers.Coq_base.Coq_type.coq_type -> interp -> interp **)

         let rec map_ranges f = function
         | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
           (match t1 with
            | Coq3_Compilers.Z -> Obj.magic f
            | Coq3_Compilers.Coq_bool -> (fun x -> x)
            | Coq3_Compilers.Coq_nat -> (fun x -> x)
            | Coq3_Compilers.Coq_zrange -> (fun x -> x)
            | Coq3_Compilers.Coq_string -> (fun x -> x))
         | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
           (fun pat ->
             let (a0, b0) = Obj.magic pat in
             Obj.magic ((map_ranges f a a0), (map_ranges f b b0)))
         | Compilers.Coq_base.Coq_type.Coq_list a ->
           Obj.magic map (map_ranges f a)
         | Compilers.Coq_base.Coq_type.Coq_option a ->
           Obj.magic option_map (map_ranges f a)
         | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> x)
        end
        include Coq__5

        module Coq__6 = struct
         (** val is_tighter_than :
             Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
             interp -> interp -> bool **)

         let rec is_tighter_than = function
         | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
           (match t1 with
            | Coq3_Compilers.Z -> Obj.magic is_tighter_than_bool
            | Coq3_Compilers.Coq_bool ->
              Compilers.Coq_base.interp_beq (fun t2 ->
                Coq3_Compilers.base_interp_beq t2 t2)
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)
            | Coq3_Compilers.Coq_nat ->
              Compilers.Coq_base.interp_beq (fun t2 ->
                Coq3_Compilers.base_interp_beq t2 t2)
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)
            | Coq3_Compilers.Coq_zrange ->
              Compilers.Coq_base.interp_beq (fun t2 ->
                Coq3_Compilers.base_interp_beq t2 t2)
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)
            | Coq3_Compilers.Coq_string ->
              Compilers.Coq_base.interp_beq (fun t2 ->
                Coq3_Compilers.base_interp_beq t2 t2)
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_string))
         | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
           (fun pat ->
             let (a0, b0) = Obj.magic pat in
             (fun pat0 ->
             let (a', b') = Obj.magic pat0 in
             (&&) (is_tighter_than a a0 a') (is_tighter_than b b0 b')))
         | Compilers.Coq_base.Coq_type.Coq_list a ->
           Obj.magic fold_andb_map (is_tighter_than a)
         | Compilers.Coq_base.Coq_type.Coq_option a ->
           Obj.magic option_beq (is_tighter_than a)
         | Compilers.Coq_base.Coq_type.Coq_unit ->
           Compilers.Coq_base.interp_beq (fun t1 ->
             Coq3_Compilers.base_interp_beq t1 t1)
             Compilers.Coq_base.Coq_type.Coq_unit
        end
        include Coq__6

        (** val is_bounded_by :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            interp -> (Coq3_Compilers.base, Coq3_Compilers.base_interp)
            Compilers.Coq_base.interp -> bool **)

        let rec is_bounded_by = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z ->
             (fun r0 z0 -> is_bounded_by_bool (Obj.magic z0) (Obj.magic r0))
           | Coq3_Compilers.Coq_bool ->
             Compilers.Coq_base.interp_beq (fun t2 ->
               Coq3_Compilers.base_interp_beq t2 t2)
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_bool)
           | Coq3_Compilers.Coq_nat ->
             Compilers.Coq_base.interp_beq (fun t2 ->
               Coq3_Compilers.base_interp_beq t2 t2)
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_nat)
           | Coq3_Compilers.Coq_zrange ->
             Compilers.Coq_base.interp_beq (fun t2 ->
               Coq3_Compilers.base_interp_beq t2 t2)
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_zrange)
           | Coq3_Compilers.Coq_string ->
             Compilers.Coq_base.interp_beq (fun t2 ->
               Coq3_Compilers.base_interp_beq t2 t2)
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_string))
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          (fun pat ->
            let (a0, b0) = Obj.magic pat in
            (fun pat0 ->
            let (a', b') = Obj.magic pat0 in
            (&&) (is_bounded_by a a0 a') (is_bounded_by b b0 b')))
        | Compilers.Coq_base.Coq_type.Coq_list a ->
          Obj.magic fold_andb_map (is_bounded_by a)
        | Compilers.Coq_base.Coq_type.Coq_option a ->
          Obj.magic option_beq_hetero (is_bounded_by a)
        | Compilers.Coq_base.Coq_type.Coq_unit ->
          Compilers.Coq_base.interp_beq (fun t1 ->
            Coq3_Compilers.base_interp_beq t1 t1)
            Compilers.Coq_base.Coq_type.Coq_unit

        module Coq__7 = struct
         (** val interp_beq :
             Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
             Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
             interp -> interp -> bool **)

         let rec interp_beq t1 t2 =
           match t1 with
           | Compilers.Coq_base.Coq_type.Coq_type_base t0 ->
             (match t0 with
              | Coq3_Compilers.Z ->
                (match t2 with
                 | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                   (match t3 with
                    | Coq3_Compilers.Z -> Obj.magic zrange_beq
                    | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
                    | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
                    | Coq3_Compilers.Coq_zrange -> (fun _ _ -> false)
                    | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
                 | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_list _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_option _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
              | Coq3_Compilers.Coq_bool ->
                (match t2 with
                 | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                   (match t3 with
                    | Coq3_Compilers.Z -> (fun _ _ -> false)
                    | Coq3_Compilers.Coq_bool ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                    | Coq3_Compilers.Coq_nat ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                    | Coq3_Compilers.Coq_zrange ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                    | Coq3_Compilers.Coq_string ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string))
                 | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_list _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_option _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
              | Coq3_Compilers.Coq_nat ->
                (match t2 with
                 | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                   (match t3 with
                    | Coq3_Compilers.Z -> (fun _ _ -> false)
                    | Coq3_Compilers.Coq_bool ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                    | Coq3_Compilers.Coq_nat ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                    | Coq3_Compilers.Coq_zrange ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                    | Coq3_Compilers.Coq_string ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string))
                 | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_list _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_option _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
              | Coq3_Compilers.Coq_zrange ->
                (match t2 with
                 | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                   (match t3 with
                    | Coq3_Compilers.Z -> (fun _ _ -> false)
                    | Coq3_Compilers.Coq_bool ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                    | Coq3_Compilers.Coq_nat ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                    | Coq3_Compilers.Coq_zrange ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                    | Coq3_Compilers.Coq_string ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string))
                 | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_list _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_option _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
              | Coq3_Compilers.Coq_string ->
                (match t2 with
                 | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                   (match t3 with
                    | Coq3_Compilers.Z -> (fun _ _ -> false)
                    | Coq3_Compilers.Coq_bool ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)
                    | Coq3_Compilers.Coq_nat ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)
                    | Coq3_Compilers.Coq_zrange ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)
                    | Coq3_Compilers.Coq_string ->
                      Compilers.Coq_base.interp_beq_hetero
                        Coq3_Compilers.base_interp_beq
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string))
                 | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_list _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_option _ ->
                   (fun _ _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false)))
           | Compilers.Coq_base.Coq_type.Coq_prod (a1, b1) ->
             (match t2 with
              | Compilers.Coq_base.Coq_type.Coq_type_base t0 ->
                (match t0 with
                 | Coq3_Compilers.Z -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_zrange -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
              | Compilers.Coq_base.Coq_type.Coq_prod (a2, b2) ->
                (fun pat ->
                  let (a, b) = Obj.magic pat in
                  (fun pat0 ->
                  let (a', b') = Obj.magic pat0 in
                  (&&) (interp_beq a1 a2 a a') (interp_beq b1 b2 b b')))
              | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
           | Compilers.Coq_base.Coq_type.Coq_list a1 ->
             (match t2 with
              | Compilers.Coq_base.Coq_type.Coq_type_base t0 ->
                (match t0 with
                 | Coq3_Compilers.Z -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_zrange -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
              | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_list a2 ->
                Obj.magic list_beq_hetero (interp_beq a1 a2)
              | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
           | Compilers.Coq_base.Coq_type.Coq_option a1 ->
             (match t2 with
              | Compilers.Coq_base.Coq_type.Coq_type_base t0 ->
                (match t0 with
                 | Coq3_Compilers.Z -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_zrange -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
              | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_option a2 ->
                Obj.magic option_beq_hetero (interp_beq a1 a2)
              | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
           | Compilers.Coq_base.Coq_type.Coq_unit ->
             (match t2 with
              | Compilers.Coq_base.Coq_type.Coq_type_base t0 ->
                (match t0 with
                 | Coq3_Compilers.Z -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_zrange -> (fun _ _ -> false)
                 | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
              | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> false)
              | Compilers.Coq_base.Coq_type.Coq_unit ->
                Compilers.Coq_base.interp_beq_hetero
                  Coq3_Compilers.base_interp_beq
                  Compilers.Coq_base.Coq_type.Coq_unit
                  Compilers.Coq_base.Coq_type.Coq_unit)
        end
        include Coq__7

        module Coq_option =
         struct
          type interp = __

          (** val map_ranges :
              (zrange -> zrange) -> Coq3_Compilers.base
              Compilers.Coq_base.Coq_type.coq_type -> interp -> interp **)

          let rec map_ranges f = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            let t2 = Compilers.Coq_base.Coq_type.Coq_type_base t1 in
            Obj.magic option_map (Coq__5.map_ranges f t2)
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              Obj.magic ((map_ranges f a a0), (map_ranges f b b0)))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            Obj.magic option_map (map (map_ranges f a))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            Obj.magic option_map (option_map (map_ranges f a))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            (fun pat -> let () = Obj.magic pat in Obj.magic ())

          (** val coq_None :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              interp **)

          let rec coq_None = function
          | Compilers.Coq_base.Coq_type.Coq_type_base _ -> Obj.magic None
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            Obj.magic ((coq_None a), (coq_None b))
          | Compilers.Coq_base.Coq_type.Coq_list _ -> Obj.magic None
          | Compilers.Coq_base.Coq_type.Coq_option _ -> Obj.magic None
          | Compilers.Coq_base.Coq_type.Coq_unit -> Obj.magic ()

          (** val coq_Some :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              Coq__4.interp -> interp **)

          let rec coq_Some = function
          | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
            Obj.magic (fun x -> Some x)
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              Obj.magic ((coq_Some a a0), (coq_Some b b0)))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun ls -> Obj.magic (Some (map (coq_Some a) (Obj.magic ls))))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun ls ->
              Obj.magic (Some (option_map (coq_Some a) (Obj.magic ls))))
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> Obj.magic ())

          (** val lift_Some :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              interp -> Coq__4.interp option **)

          let rec lift_Some = function
          | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
            (fun x -> Obj.magic x)
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              bind (lift_Some a a0) (fun a1 ->
                bind (lift_Some b b0) (fun b1 -> Some (Obj.magic (a1, b1)))))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun ls ->
              bind (Obj.magic ls) (fun ls0 ->
                Obj.magic Option.List.lift (map (lift_Some a) ls0)))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun v ->
              bind (Obj.magic v) (fun v0 ->
                Obj.magic lift0 (option_map (lift_Some a) v0)))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            (fun _ -> Some (Obj.magic ()))

          (** val is_informative :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              interp -> bool **)

          let rec is_informative = function
          | Compilers.Coq_base.Coq_type.Coq_type_base _ -> Obj.magic is_Some
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              (||) (is_informative a a0) (is_informative b b0))
          | Compilers.Coq_base.Coq_type.Coq_list _ -> Obj.magic is_Some
          | Compilers.Coq_base.Coq_type.Coq_option _ -> Obj.magic is_Some
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false)

          (** val strip_ranges :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              interp -> interp **)

          let rec strip_ranges = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z -> (fun _ -> Obj.magic None)
             | Coq3_Compilers.Coq_bool -> (fun x -> x)
             | Coq3_Compilers.Coq_nat -> (fun x -> x)
             | Coq3_Compilers.Coq_zrange -> (fun x -> x)
             | Coq3_Compilers.Coq_string -> (fun x -> x))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              Obj.magic ((strip_ranges a a0), (strip_ranges b b0)))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun ls ->
              Obj.magic bind ls (fun ls0 -> Some (map (strip_ranges a) ls0)))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun v ->
              Obj.magic bind v (fun v0 -> Some
                (option_map (strip_ranges a) v0)))
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> x)

          (** val is_tighter_than :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              interp -> interp -> bool **)

          let rec is_tighter_than = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (fun r1 r2 ->
              match Obj.magic r1 with
              | Some r3 ->
                (match Obj.magic r2 with
                 | Some r4 ->
                   Coq__6.is_tighter_than
                     (Compilers.Coq_base.Coq_type.Coq_type_base t1) r3 r4
                 | None -> true)
              | None ->
                (match Obj.magic r2 with
                 | Some _ -> false
                 | None -> true))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              (fun pat0 ->
              let (a', b') = Obj.magic pat0 in
              (&&) (is_tighter_than a a0 a') (is_tighter_than b b0 b')))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun ls1 ls2 ->
              match Obj.magic ls1 with
              | Some ls3 ->
                (match Obj.magic ls2 with
                 | Some ls4 -> fold_andb_map (is_tighter_than a) ls3 ls4
                 | None -> true)
              | None ->
                (match Obj.magic ls2 with
                 | Some _ -> false
                 | None -> true))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun v1 v2 ->
              match Obj.magic v1 with
              | Some v3 ->
                (match Obj.magic v2 with
                 | Some v4 -> option_beq (is_tighter_than a) v3 v4
                 | None -> true)
              | None ->
                (match Obj.magic v2 with
                 | Some _ -> false
                 | None -> true))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            (fun pat ->
              let () = Obj.magic pat in
              (fun pat0 -> let () = Obj.magic pat0 in true))

          (** val interp_beq :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              interp -> interp -> bool **)

          let rec interp_beq t1 t2 =
            match t1 with
            | Compilers.Coq_base.Coq_type.Coq_type_base t0 ->
              (match t2 with
               | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                 Obj.magic option_beq_hetero
                   (Coq__7.interp_beq
                     (Compilers.Coq_base.Coq_type.Coq_type_base t0)
                     (Compilers.Coq_base.Coq_type.Coq_type_base t3))
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
            | Compilers.Coq_base.Coq_type.Coq_prod (a1, b1) ->
              (match t2 with
               | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_prod (a2, b2) ->
                 (fun pat ->
                   let (a, b) = Obj.magic pat in
                   (fun pat0 ->
                   let (a', b') = Obj.magic pat0 in
                   (&&) (interp_beq a1 a2 a a') (interp_beq b1 b2 b b')))
               | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
            | Compilers.Coq_base.Coq_type.Coq_list a1 ->
              (match t2 with
               | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_list a2 ->
                 Obj.magic option_beq_hetero
                   (list_beq_hetero (interp_beq a1 a2))
               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
            | Compilers.Coq_base.Coq_type.Coq_option a1 ->
              (match t2 with
               | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_option a2 ->
                 Obj.magic option_beq_hetero
                   (option_beq_hetero (interp_beq a1 a2))
               | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
            | Compilers.Coq_base.Coq_type.Coq_unit ->
              (match t2 with
               | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_unit ->
                 (fun pat ->
                   let () = Obj.magic pat in
                   (fun pat0 -> let () = Obj.magic pat0 in true)))
         end
       end

      type interp =
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq_base.interp) Compilers.Coq_type.interp

      (** val is_bounded_by :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> interp -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base,
          Coq3_Compilers.base_interp) Compilers.Coq_base.interp)
          Compilers.Coq_type.interp -> bool **)

      let is_bounded_by = function
      | Compilers.Coq_type.Coq_base x -> Coq_base.is_bounded_by x
      | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ _ -> false)

      module Coq_option =
       struct
        type interp =
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq_base.Coq_option.interp) Compilers.Coq_type.interp

        (** val coq_None :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> interp **)

        let rec coq_None = function
        | Compilers.Coq_type.Coq_base x -> Coq_base.Coq_option.coq_None x
        | Compilers.Coq_type.Coq_arrow (_, d) ->
          Obj.magic (fun _ -> coq_None d)

        (** val strip_ranges :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> interp -> interp **)

        let rec strip_ranges = function
        | Compilers.Coq_type.Coq_base x -> Coq_base.Coq_option.strip_ranges x
        | Compilers.Coq_type.Coq_arrow (_, d) ->
          (fun f -> Obj.magic (fun x -> strip_ranges d (Obj.magic f x)))
       end
     end

    module Coq_ident =
     struct
      module Coq_option =
       struct
        (** val of_literal :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            (Coq3_Compilers.base, Coq3_Compilers.base_interp)
            Compilers.Coq_base.interp -> Coq_type.Coq_base.Coq_option.interp **)

        let rec of_literal = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z ->
             (fun z0 ->
               Obj.magic (Some { lower = (Obj.magic z0); upper =
                 (Obj.magic z0) }))
           | Coq3_Compilers.Coq_bool -> (fun n3 -> Obj.magic (Some n3))
           | Coq3_Compilers.Coq_nat -> (fun n3 -> Obj.magic (Some n3))
           | Coq3_Compilers.Coq_zrange -> (fun n3 -> Obj.magic (Some n3))
           | Coq3_Compilers.Coq_string -> (fun n3 -> Obj.magic (Some n3)))
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          (fun pat ->
            let (a0, b0) = Obj.magic pat in
            Obj.magic ((of_literal a a0), (of_literal b b0)))
        | Compilers.Coq_base.Coq_type.Coq_list a ->
          (fun ls -> Obj.magic (Some (map (of_literal a) (Obj.magic ls))))
        | Compilers.Coq_base.Coq_type.Coq_option a ->
          (fun v ->
            Obj.magic (Some (option_map (of_literal a) (Obj.magic v))))
        | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> Obj.magic ())

        (** val to_literal :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq_type.Coq_base.Coq_option.interp -> (Coq3_Compilers.base,
            Coq3_Compilers.base_interp) Compilers.Coq_base.interp option **)

        let rec to_literal = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z ->
             (fun r0 ->
               bind (Obj.magic r0) (fun r1 ->
                 if Coq_Z.eqb r1.lower r1.upper
                 then Some (Obj.magic r1.lower)
                 else None))
           | Coq3_Compilers.Coq_bool -> (fun v -> Obj.magic v)
           | Coq3_Compilers.Coq_nat -> (fun v -> Obj.magic v)
           | Coq3_Compilers.Coq_zrange -> (fun v -> Obj.magic v)
           | Coq3_Compilers.Coq_string -> (fun v -> Obj.magic v))
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          (fun pat ->
            let (a0, b0) = Obj.magic pat in
            bind (to_literal a a0) (fun a1 ->
              bind (to_literal b b0) (fun b1 -> Some (Obj.magic (a1, b1)))))
        | Compilers.Coq_base.Coq_type.Coq_list a ->
          (fun ls ->
            bind (Obj.magic ls) (fun ls0 ->
              Obj.magic Option.List.lift (map (to_literal a) ls0)))
        | Compilers.Coq_base.Coq_type.Coq_option a ->
          (fun v ->
            bind (Obj.magic v) (fun v0 ->
              Obj.magic lift0 (option_map (to_literal a) v0)))
        | Compilers.Coq_base.Coq_type.Coq_unit ->
          (fun _ -> Some (Obj.magic ()))

        (** val interp_Z_cast :
            zrange option -> zrange option -> zrange option **)

        let interp_Z_cast r0 v =
          match r0 with
          | Some r1 ->
            (match v with
             | Some v0 -> if is_tighter_than_bool v0 r1 then Some v0 else None
             | None -> None)
          | None -> None

        (** val interp_Z_cast_truncate :
            zrange option -> zrange option -> zrange option **)

        let interp_Z_cast_truncate r0 v =
          match interp_Z_cast r0 v with
          | Some x -> Some x
          | None ->
            (match r0 with
             | Some r1 -> Some (ZRange.normalize r1)
             | None -> None)

        (** val interp :
            Settings.shiftr_avoid_uint1_opt -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> Coq3_Compilers.ident -> Coq_type.Coq_option.interp **)

        let interp shiftr_avoid_uint2 assume_cast_truncates _ idc =
          let interp_Z_cast0 =
            if assume_cast_truncates
            then interp_Z_cast_truncate
            else interp_Z_cast
          in
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, v) ->
             of_literal (Compilers.Coq_base.Coq_type.Coq_type_base t0) v
           | Coq3_Compilers.Coq_ident_comment _ -> Obj.magic (fun _ -> ())
           | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
             Obj.magic (fun _ -> ())
           | Coq3_Compilers.Coq_ident_value_barrier -> Obj.magic (fun x -> x)
           | Coq3_Compilers.Coq_ident_Nat_succ ->
             Obj.magic option_map
               (Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_succ)
           | Coq3_Compilers.Coq_ident_Nat_pred ->
             Obj.magic option_map
               (Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_pred)
           | Coq3_Compilers.Coq_ident_Nat_max ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   Obj.magic Coq_type.Coq_base.Coq_option.coq_Some
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_nat)
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat))))))
                       Coq3_Compilers.Coq_ident_Nat_max x0 y0))))
           | Coq3_Compilers.Coq_ident_Nat_mul ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   Obj.magic Coq_type.Coq_base.Coq_option.coq_Some
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_nat)
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat))))))
                       Coq3_Compilers.Coq_ident_Nat_mul x0 y0))))
           | Coq3_Compilers.Coq_ident_Nat_add ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   Obj.magic Coq_type.Coq_base.Coq_option.coq_Some
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_nat)
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat))))))
                       Coq3_Compilers.Coq_ident_Nat_add x0 y0))))
           | Coq3_Compilers.Coq_ident_Nat_sub ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   Obj.magic Coq_type.Coq_base.Coq_option.coq_Some
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_nat)
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat))))))
                       Coq3_Compilers.Coq_ident_Nat_sub x0 y0))))
           | Coq3_Compilers.Coq_ident_Nat_eqb ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   Obj.magic Coq_type.Coq_base.Coq_option.coq_Some
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_bool))))))
                       Coq3_Compilers.Coq_ident_Nat_eqb x0 y0))))
           | Coq3_Compilers.Coq_ident_nil _ -> Obj.magic (Some [])
           | Coq3_Compilers.Coq_ident_cons _ ->
             Obj.magic (fun x -> option_map (fun x0 -> x :: x0))
           | Coq3_Compilers.Coq_ident_tt ->
             Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_base
               Compilers.Coq_base.Coq_type.Coq_unit)
               Coq3_Compilers.Coq_ident_tt
           | Coq3_Compilers.Coq_ident_pair (_, _) ->
             Obj.magic (fun x x0 -> (x, x0))
           | Coq3_Compilers.Coq_ident_fst (_, _) -> Obj.magic fst
           | Coq3_Compilers.Coq_ident_snd (_, _) -> Obj.magic snd
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
             Obj.magic (fun f pat -> let (a, b) = pat in f a b)
           | Coq3_Compilers.Coq_ident_bool_rect t0 ->
             Obj.magic (fun t1 f b ->
               match b with
               | Some b0 -> if b0 then t1 () else f ()
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
             Obj.magic (fun t1 f b ->
               match b with
               | Some b0 -> if b0 then t1 else f
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_nat_rect t0 ->
             Obj.magic (fun o_case s_case n3 ->
               match n3 with
               | Some n4 ->
                 let rec f = function
                 | O -> o_case ()
                 | S n6 -> s_case (Some n6) (f n6)
                 in f n4
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
             Obj.magic (fun o_case s_case n3 ->
               match n3 with
               | Some n4 ->
                 let rec f = function
                 | O -> o_case ()
                 | S n6 -> s_case (Some n6) (f n6)
                 in f n4
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, t1) ->
             Obj.magic (fun o_case s_case n3 v ->
               match n3 with
               | Some n4 ->
                 let rec f = function
                 | O -> o_case
                 | S n6 -> s_case (Some n6) (f n6)
                 in f n4 v
               | None -> Coq_type.Coq_base.Coq_option.coq_None t1)
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, t1) ->
             Obj.magic (fun o_case s_case n3 v ->
               match n3 with
               | Some n4 ->
                 let rec f = function
                 | O -> o_case
                 | S n6 -> s_case (Some n6) (f n6)
                 in f n4 v
               | None -> Coq_type.Coq_base.Coq_option.coq_None t1)
           | Coq3_Compilers.Coq_ident_list_rect (_, t1) ->
             Obj.magic (fun n3 c0 ls ->
               match ls with
               | Some ls0 ->
                 let rec f = function
                 | [] -> n3 ()
                 | y :: l0 -> c0 y (Some l0) (f l0)
                 in f ls0
               | None -> Coq_type.Coq_base.Coq_option.coq_None t1)
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, t1) ->
             Obj.magic (fun n3 c0 ls ->
               match ls with
               | Some ls0 ->
                 let rec f = function
                 | [] -> n3 ()
                 | y :: l0 -> c0 y (Some l0) (f l0)
                 in f ls0
               | None -> Coq_type.Coq_base.Coq_option.coq_None t1)
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, t2) ->
             Obj.magic (fun n3 c0 ls v ->
               match ls with
               | Some ls0 ->
                 let rec f = function
                 | [] -> n3
                 | y :: l0 -> c0 y (Some l0) (f l0)
                 in f ls0 v
               | None -> Coq_type.Coq_base.Coq_option.coq_None t2)
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, t2) ->
             Obj.magic (fun n3 c0 ls v ->
               match ls with
               | Some ls0 ->
                 let rec f = function
                 | [] -> n3
                 | y :: l0 -> c0 y (Some l0) (f l0)
                 in f ls0 v
               | None -> Coq_type.Coq_base.Coq_option.coq_None t2)
           | Coq3_Compilers.Coq_ident_list_case (_, t1) ->
             Obj.magic (fun n3 c0 ls ->
               match ls with
               | Some ls0 ->
                 list_case (n3 ()) (fun x xs -> c0 x (Some xs)) ls0
               | None -> Coq_type.Coq_base.Coq_option.coq_None t1)
           | Coq3_Compilers.Coq_ident_List_length _ ->
             Obj.magic option_map length
           | Coq3_Compilers.Coq_ident_List_seq ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   Obj.magic Coq_type.Coq_base.Coq_option.coq_Some
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_nat))
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_list
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)))))))
                       Coq3_Compilers.Coq_ident_List_seq x0 y0))))
           | Coq3_Compilers.Coq_ident_List_firstn _ ->
             Obj.magic (fun n3 ls ->
               bind n3 (fun n4 -> bind ls (fun ls0 -> Some (firstn n4 ls0))))
           | Coq3_Compilers.Coq_ident_List_skipn _ ->
             Obj.magic (fun n3 ls ->
               bind n3 (fun n4 -> bind ls (fun ls0 -> Some (skipn n4 ls0))))
           | Coq3_Compilers.Coq_ident_List_repeat _ ->
             Obj.magic (fun x y -> bind y (fun y0 -> Some (repeat x y0)))
           | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
             Obj.magic (fun x y ->
               bind x (fun x0 -> bind y (fun y0 -> Some (combine x0 y0))))
           | Coq3_Compilers.Coq_ident_List_map (_, _) ->
             Obj.magic (fun f ls -> bind ls (fun ls0 -> Some (map f ls0)))
           | Coq3_Compilers.Coq_ident_List_app _ ->
             Obj.magic (fun ls1 ls2 ->
               bind ls1 (fun ls3 -> bind ls2 (fun ls4 -> Some (app ls3 ls4))))
           | Coq3_Compilers.Coq_ident_List_rev _ -> Obj.magic option_map rev1
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
             Obj.magic (fun f ls ->
               bind ls (fun ls0 ->
                 let fls = map f ls0 in
                 fold_right (fun ls1 ls2 ->
                   bind ls1 (fun ls3 ->
                     bind ls2 (fun ls4 -> Some (app ls3 ls4)))) (Some []) fls))
           | Coq3_Compilers.Coq_ident_List_partition _ ->
             Obj.magic (fun f ls ->
               match ls with
               | Some ls0 ->
                 let rec f0 = function
                 | [] -> ((Some []), (Some []))
                 | y :: l0 ->
                   let (g, d) = f0 l0 in
                   ((bind (f y) (fun fx ->
                      if fx then bind g (fun g0 -> Some (y :: g0)) else g)),
                   (bind (f y) (fun fx ->
                     if fx then d else bind d (fun d0 -> Some (y :: d0)))))
                 in f0 ls0
               | None -> (None, None))
           | Coq3_Compilers.Coq_ident_List_filter _ ->
             Obj.magic (fun f ls ->
               match ls with
               | Some xs ->
                 let rec f0 = function
                 | [] -> Some []
                 | y :: l0 ->
                   bind (f y) (fun fx ->
                     if fx
                     then bind (f0 l0) (fun filter_xs' -> Some
                            (y :: filter_xs'))
                     else f0 l0)
                 in f0 xs
               | None -> None)
           | Coq3_Compilers.Coq_ident_List_fold_right (t0, _) ->
             Obj.magic (fun f v ls ->
               match ls with
               | Some ls0 -> fold_right f v ls0
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_List_update_nth _ ->
             Obj.magic (fun n3 f ls ->
               bind ls (fun ls0 ->
                 bind n3 (fun n4 -> Some (update_nth n4 f ls0))))
           | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
             Obj.magic (fun d ls n3 ->
               match ls with
               | Some ls0 ->
                 (match n3 with
                  | Some n4 -> nth_default d ls0 n4
                  | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
             Obj.magic (fun d ls n3 ->
               match ls with
               | Some ls0 ->
                 (match n3 with
                  | Some n4 -> nth_default d ls0 n4
                  | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_Z_add ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some
                   (ZRange.four_corners
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_add)
                     x0 y0))))
           | Coq3_Compilers.Coq_ident_Z_mul ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some
                   (ZRange.four_corners
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_mul)
                     x0 y0))))
           | Coq3_Compilers.Coq_ident_Z_pow ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_pow
                        x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))
           | Coq3_Compilers.Coq_ident_Z_sub ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some
                   (ZRange.four_corners
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_sub)
                     x0 y0))))
           | Coq3_Compilers.Coq_ident_Z_opp ->
             Obj.magic (fun x ->
               bind x (fun x0 -> Some
                 (ZRange.two_corners
                   (Obj.magic Coq3_Compilers.ident_interp
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_opp) x0)))
           | Coq3_Compilers.Coq_ident_Z_div ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some
                   (ZRange.four_corners_and_zero
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_div)
                     x0 y0))))
           | Coq3_Compilers.Coq_ident_Z_modulo ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))))))
                        Coq3_Compilers.Coq_ident_Z_modulo x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))
           | Coq3_Compilers.Coq_ident_Z_eqb ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool))))))
                        Coq3_Compilers.Coq_ident_Z_eqb x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))
           | Coq3_Compilers.Coq_ident_Z_leb ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool))))))
                        Coq3_Compilers.Coq_ident_Z_leb x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))
           | Coq3_Compilers.Coq_ident_Z_ltb ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool))))))
                        Coq3_Compilers.Coq_ident_Z_ltb x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))
           | Coq3_Compilers.Coq_ident_Z_geb ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool))))))
                        Coq3_Compilers.Coq_ident_Z_geb x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))
           | Coq3_Compilers.Coq_ident_Z_gtb ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool))))))
                        Coq3_Compilers.Coq_ident_Z_gtb x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))
           | Coq3_Compilers.Coq_ident_Z_log2 ->
             Obj.magic (fun x ->
               bind x (fun x0 -> Some
                 (ZRange.two_corners
                   (Obj.magic Coq3_Compilers.ident_interp
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_log2) x0)))
           | Coq3_Compilers.Coq_ident_Z_log2_up ->
             Obj.magic (fun x ->
               bind x (fun x0 -> Some
                 (ZRange.two_corners
                   (Obj.magic Coq3_Compilers.ident_interp
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_log2_up)
                   x0)))
           | Coq3_Compilers.Coq_ident_Z_of_nat ->
             Obj.magic option_map (fun n3 -> { lower = (Coq_Z.of_nat n3);
               upper = (Coq_Z.of_nat n3) })
           | Coq3_Compilers.Coq_ident_Z_to_nat ->
             Obj.magic (fun v ->
               bind
                 (to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z) v) (fun v0 -> Some
                 (Obj.magic Coq3_Compilers.ident_interp
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))
                   Coq3_Compilers.Coq_ident_Z_to_nat v0)))
           | Coq3_Compilers.Coq_ident_Z_shiftr ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some
                   (let r0 =
                      ZRange.four_corners_and_zero
                        (Obj.magic Coq3_Compilers.ident_interp
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))))))
                          Coq3_Compilers.Coq_ident_Z_shiftr) x0 y0
                    in
                    if (&&) shiftr_avoid_uint2
                         (zrange_beq r0 { lower = Z0; upper = (Zpos XH) })
                    then { lower = Z0; upper = (Zpos (XO XH)) }
                    else r0))))
           | Coq3_Compilers.Coq_ident_Z_shiftl ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some
                   (ZRange.four_corners_and_zero
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))))))
                       Coq3_Compilers.Coq_ident_Z_shiftl) x0 y0))))
           | Coq3_Compilers.Coq_ident_Z_land ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some (ZRange.land_bounds x0 y0))))
           | Coq3_Compilers.Coq_ident_Z_lor ->
             Obj.magic (fun x y ->
               bind x (fun x0 ->
                 bind y (fun y0 -> Some (ZRange.lor_bounds x0 y0))))
           | Coq3_Compilers.Coq_ident_Z_min ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_min
                        x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))
           | Coq3_Compilers.Coq_ident_Z_max ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_max
                        x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))
           | Coq3_Compilers.Coq_ident_Z_mul_split ->
             Obj.magic (fun split_at x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) split_at with
               | Some split_at0 ->
                 (match x with
                  | Some x0 ->
                    (match y with
                     | Some y0 ->
                       Coq_type.Coq_base.Coq_option.coq_Some
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))
                         (Obj.magic ZRange.split_bounds
                           (ZRange.four_corners Coq_Z.mul x0 y0) split_at0)
                     | None ->
                       Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))))
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))
           | Coq3_Compilers.Coq_ident_Z_mul_high ->
             Obj.magic (fun split_at x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) split_at with
               | Some split_at0 ->
                 (match x with
                  | Some x0 ->
                    (match y with
                     | Some y0 ->
                       Coq_type.Coq_base.Coq_option.coq_Some
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)
                         (snd
                           (Obj.magic ZRange.split_bounds
                             (ZRange.four_corners Coq_Z.mul x0 y0) split_at0))
                     | None ->
                       Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))
           | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
             Obj.magic (fun split_at x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) split_at with
               | Some split_at0 ->
                 (match x with
                  | Some x0 ->
                    (match y with
                     | Some y0 ->
                       Coq_type.Coq_base.Coq_option.coq_Some
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))
                         (Obj.magic ZRange.split_bounds
                           (ZRange.four_corners Coq_Z.add x0 y0) split_at0)
                     | None ->
                       Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))))
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))
           | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
             Obj.magic (fun x y z0 ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   bind z0 (fun z1 -> Some
                     (ZRange.eight_corners
                       (Obj.magic Coq3_Compilers.ident_interp
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))))))))
                         Coq3_Compilers.Coq_ident_Z_add_with_carry) x0 y0 z1)))))
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
             Obj.magic (fun split_at x y z0 ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) split_at with
               | Some split_at0 ->
                 (match x with
                  | Some x0 ->
                    (match y with
                     | Some y0 ->
                       (match z0 with
                        | Some z1 ->
                          Coq_type.Coq_base.Coq_option.coq_Some
                            (Compilers.Coq_base.Coq_type.Coq_prod
                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z),
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))
                            (Obj.magic ZRange.split_bounds
                              (ZRange.eight_corners (fun x1 y1 z2 ->
                                Coq_Z.add (Coq_Z.add x1 y1) z2) x0 y0 z1)
                              split_at0)
                        | None ->
                          Coq_type.Coq_base.Coq_option.coq_None
                            (Compilers.Coq_base.Coq_type.Coq_prod
                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z),
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                     | None ->
                       Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))))
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
             Obj.magic (fun split_at x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) split_at with
               | Some split_at0 ->
                 (match x with
                  | Some x0 ->
                    (match y with
                     | Some y0 ->
                       Coq_type.Coq_base.Coq_option.coq_Some
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))
                         (let b =
                            ZRange.split_bounds
                              (ZRange.four_corners Coq_Z.sub x0 y0)
                              (Obj.magic split_at0)
                          in
                          Obj.magic ((fst b), (ZRange.opp (snd b))))
                     | None ->
                       Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))))
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
             Obj.magic (fun split_at x y z0 ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) split_at with
               | Some split_at0 ->
                 (match x with
                  | Some x0 ->
                    (match y with
                     | Some y0 ->
                       (match z0 with
                        | Some z1 ->
                          Coq_type.Coq_base.Coq_option.coq_Some
                            (Compilers.Coq_base.Coq_type.Coq_prod
                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z),
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))
                            (let b =
                               ZRange.split_bounds
                                 (ZRange.eight_corners (fun x1 y1 z2 ->
                                   Coq_Z.sub (Coq_Z.sub y1 z2) x1) x0 y0 z1)
                                 (Obj.magic split_at0)
                             in
                             Obj.magic ((fst b), (ZRange.opp (snd b))))
                        | None ->
                          Coq_type.Coq_base.Coq_option.coq_None
                            (Compilers.Coq_base.Coq_type.Coq_prod
                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z),
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                     | None ->
                       Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))))
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))
           | Coq3_Compilers.Coq_ident_Z_ltz ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_ltz
                        x0 y0)
                  | None -> Obj.magic (Some { lower = Z0; upper = (Zpos XH) }))
               | None -> Obj.magic (Some { lower = Z0; upper = (Zpos XH) }))
           | Coq3_Compilers.Coq_ident_Z_zselect ->
             Obj.magic (fun _ y z0 ->
               bind y (fun y0 ->
                 bind z0 (fun z1 -> Some (ZRange.union y0 z1))))
           | Coq3_Compilers.Coq_ident_Z_add_modulo ->
             Obj.magic (fun x y m4 ->
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   bind m4 (fun m5 -> Some
                     (ZRange.union (ZRange.four_corners Coq_Z.add x0 y0)
                       (ZRange.eight_corners (fun x1 y1 m6 ->
                         Coq_Z.max Z0 (Coq_Z.sub (Coq_Z.add x1 y1) m6)) x0 y0
                         m5))))))
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
             Obj.magic (fun bw x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) bw with
               | Some bw0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) x with
                  | Some x0 ->
                    (match to_literal
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z) y with
                     | Some y0 ->
                       of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)
                         (Obj.magic Coq3_Compilers.ident_interp
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z))))))))
                           Coq3_Compilers.Coq_ident_Z_truncating_shiftl bw0
                           x0 y0)
                     | None ->
                       Obj.magic bind x (fun x1 ->
                         bind (Obj.magic y) (fun y0 -> Some
                           (ZRange.land_bounds
                             (ZRange.four_corners_and_zero Coq_Z.shiftl x1 y0)
                             (ZRange.constant (Coq_Z.ones (Obj.magic bw0)))))))
                  | None ->
                    Obj.magic bind x (fun x0 ->
                      bind (Obj.magic y) (fun y0 -> Some
                        (ZRange.land_bounds
                          (ZRange.four_corners_and_zero Coq_Z.shiftl x0 y0)
                          (ZRange.constant (Coq_Z.ones (Obj.magic bw0)))))))
               | None -> Obj.magic None)
           | Coq3_Compilers.Coq_ident_Z_bneg ->
             Obj.magic (fun x ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)
                   (Obj.magic Coq3_Compilers.ident_interp
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_bneg x0)
               | None -> Obj.magic (Some { lower = Z0; upper = (Zpos XH) }))
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
             Obj.magic (fun v m4 ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) m4 with
               | Some m5 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) v with
                  | Some v0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))))))
                        Coq3_Compilers.Coq_ident_Z_lnot_modulo v0 m5)
                  | None ->
                    if Coq_Z.ltb Z0 (Obj.magic m5)
                    then Obj.magic (Some { lower = Z0; upper =
                           (Coq_Z.sub (Obj.magic m5) (Zpos XH)) })
                    else if Coq_Z.eqb (Obj.magic m5) Z0
                         then Obj.magic None
                         else Obj.magic (Some { lower =
                                (Coq_Z.add (Obj.magic m5) (Zpos XH)); upper =
                                Z0 }))
               | None -> Obj.magic None)
           | Coq3_Compilers.Coq_ident_Z_lxor ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))))))
                        Coq3_Compilers.Coq_ident_Z_lxor x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))
           | Coq3_Compilers.Coq_ident_Z_rshi ->
             Obj.magic (fun s0 x y offset ->
               bind
                 (Obj.magic to_literal
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z) s0) (fun s1 ->
                 bind x (fun _ ->
                   bind y (fun _ ->
                     bind
                       (to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z) offset) (fun _ ->
                       if Coq_Z.ltb Z0 s1
                       then Some { lower = Z0; upper =
                              (Coq_Z.sub s1 (Zpos XH)) }
                       else None)))))
           | Coq3_Compilers.Coq_ident_Z_cc_m ->
             Obj.magic (fun s0 x ->
               bind
                 (to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z) s0) (fun s1 ->
                 bind x (fun x0 -> Some
                   (ZRange.two_corners
                     (Obj.magic Coq3_Compilers.ident_interp
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_cc_m
                       s1) x0))))
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
             Obj.magic (fun bitwidth lo hi ->
               bind
                 (to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z) bitwidth) (fun bitwidth0 ->
                 bind lo (fun lo0 ->
                   bind hi (fun hi0 -> Some
                     (ZRange.four_corners
                       (Obj.magic Coq3_Compilers.ident_interp
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z))))))))
                         Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth
                         bitwidth0) lo0 hi0)))))
           | Coq3_Compilers.Coq_ident_Z_cast -> Obj.magic interp_Z_cast0
           | Coq3_Compilers.Coq_ident_Z_cast2 ->
             Obj.magic (fun pat ->
               let (r1, r2) = pat in
               (fun pat0 ->
               let (r1', r2') = pat0 in
               ((interp_Z_cast0 r1 r1'), (interp_Z_cast0 r2 r2'))))
           | Coq3_Compilers.Coq_ident_Some _ ->
             Obj.magic (fun x -> Some (Some x))
           | Coq3_Compilers.Coq_ident_None _ -> Obj.magic (Some None)
           | Coq3_Compilers.Coq_ident_option_rect (_, t1) ->
             Obj.magic (fun s0 n3 o ->
               match o with
               | Some o0 -> (match o0 with
                             | Some a -> s0 a
                             | None -> n3 ())
               | None -> Coq_type.Coq_base.Coq_option.coq_None t1)
           | Coq3_Compilers.Coq_ident_Build_zrange ->
             Obj.magic (fun x y ->
               match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) x with
               | Some x0 ->
                 (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) y with
                  | Some y0 ->
                    of_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_zrange)
                      (Obj.magic Coq3_Compilers.ident_interp
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange))))))
                        Coq3_Compilers.Coq_ident_Build_zrange x0 y0)
                  | None ->
                    Coq_type.Coq_base.Coq_option.coq_None
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_zrange))
               | None ->
                 Coq_type.Coq_base.Coq_option.coq_None
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))
           | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
             Obj.magic (fun f v ->
               match v with
               | Some v0 ->
                 let { lower = lower0; upper = upper0 } = v0 in
                 f (Some (ZRange.constant lower0)) (Some
                   (ZRange.constant upper0))
               | None -> Coq_type.Coq_base.Coq_option.coq_None t0)
           | Coq3_Compilers.Coq_ident_fancy_add ->
             Obj.magic (fun pat ->
               let (i, args0) = pat in
               let (log2wordmax, _) = i in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic ((Some r0), (Some r0)))
                  then ((Some r0), (Some { lower = Z0; upper = (Zpos XH) }))
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))
           | Coq3_Compilers.Coq_ident_fancy_addc ->
             Obj.magic (fun pat ->
               let (i, args0) = pat in
               let (log2wordmax, _) = i in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic (((Some { lower = Z0; upper = (Zpos XH) }),
                         (Some r0)), (Some r0)))
                  then ((Some r0), (Some { lower = Z0; upper = (Zpos XH) }))
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))
           | Coq3_Compilers.Coq_ident_fancy_sub ->
             Obj.magic (fun pat ->
               let (i, args0) = pat in
               let (log2wordmax, _) = i in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic ((Some r0), (Some r0)))
                  then ((Some r0), (Some { lower = Z0; upper = (Zpos XH) }))
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))
           | Coq3_Compilers.Coq_ident_fancy_subb ->
             Obj.magic (fun pat ->
               let (i, args0) = pat in
               let (log2wordmax, _) = i in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic (((Some { lower = Z0; upper = (Zpos XH) }),
                         (Some r0)), (Some r0)))
                  then ((Some r0), (Some { lower = Z0; upper = (Zpos XH) }))
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_prod
                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z),
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))
           | Coq3_Compilers.Coq_ident_fancy_mulll ->
             Obj.magic (fun pat ->
               let (log2wordmax, args0) = pat in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic ((Some r0), (Some r0)))
                  then if Coq_Z.eqb
                            (Coq_Z.modulo (Obj.magic log2wordmax0) (Zpos (XO
                              XH))) Z0
                       then Some r0
                       else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))
           | Coq3_Compilers.Coq_ident_fancy_mullh ->
             Obj.magic (fun pat ->
               let (log2wordmax, args0) = pat in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic ((Some r0), (Some r0)))
                  then if Coq_Z.eqb
                            (Coq_Z.modulo (Obj.magic log2wordmax0) (Zpos (XO
                              XH))) Z0
                       then Some r0
                       else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))
           | Coq3_Compilers.Coq_ident_fancy_mulhl ->
             Obj.magic (fun pat ->
               let (log2wordmax, args0) = pat in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic ((Some r0), (Some r0)))
                  then if Coq_Z.eqb
                            (Coq_Z.modulo (Obj.magic log2wordmax0) (Zpos (XO
                              XH))) Z0
                       then Some r0
                       else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))
           | Coq3_Compilers.Coq_ident_fancy_mulhh ->
             Obj.magic (fun pat ->
               let (log2wordmax, args0) = pat in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  let wordmax =
                    Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                  in
                  let r0 = { lower = Z0; upper =
                    (Coq_Z.sub wordmax (Zpos XH)) }
                  in
                  if Coq_type.Coq_base.Coq_option.is_tighter_than
                       (Compilers.Coq_base.Coq_type.Coq_prod
                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z),
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))) args0
                       (Obj.magic ((Some r0), (Some r0)))
                  then if Coq_Z.eqb
                            (Coq_Z.modulo (Obj.magic log2wordmax0) (Zpos (XO
                              XH))) Z0
                       then Some r0
                       else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                  else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))
           | Coq3_Compilers.Coq_ident_fancy_rshi ->
             Obj.magic (fun pat ->
               let (i, args0) = pat in
               let (log2wordmax, n3) = i in
               (match to_literal (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) log2wordmax with
                | Some log2wordmax0 ->
                  (match to_literal
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z) n3 with
                   | Some n4 ->
                     let wordmax =
                       Coq_Z.pow (Zpos (XO XH)) (Obj.magic log2wordmax0)
                     in
                     let r0 = { lower = Z0; upper =
                       (Coq_Z.sub wordmax (Zpos XH)) }
                     in
                     let r_nbits = { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) (Obj.magic n4))
                         (Zpos XH)) }
                     in
                     if Coq_Z.leb Z0 (Obj.magic log2wordmax0)
                     then if (&&)
                               (Coq_type.Coq_base.Coq_option.is_tighter_than
                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z),
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))) args0
                                 (Obj.magic ((Some r_nbits), (Some r0))))
                               (Coq_Z.leb Z0 (Obj.magic n4))
                          then bind (fst (Obj.magic args0)) (fun hi_range ->
                                 bind (snd (Obj.magic args0))
                                   (fun lo_range -> Some
                                   (ZRange.four_corners (fun x y ->
                                     Obj.magic Coq3_Compilers.ident_interp
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                       ((Compilers.Coq_base.Coq_type.Coq_prod
                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z),
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))),
                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z),
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))))
                                       Coq3_Compilers.Coq_ident_fancy_rshi
                                       ((log2wordmax0, n4), (x, y))) hi_range
                                     lo_range)))
                          else if Coq_type.Coq_base.Coq_option.is_tighter_than
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z),
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))) args0
                                    (Obj.magic ((Some r0), (Some r0)))
                               then Some r0
                               else Obj.magic
                                      Coq_type.Coq_base.Coq_option.coq_None
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                     else Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                   | None ->
                     Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))
                | None ->
                  Obj.magic Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))
           | Coq3_Compilers.Coq_ident_fancy_selc ->
             Obj.magic (fun pat ->
               let (i, z0) = pat in
               let (_, y) = i in
               bind y (fun y0 ->
                 bind z0 (fun z1 -> Some (ZRange.union y0 z1))))
           | Coq3_Compilers.Coq_ident_fancy_selm ->
             Obj.magic (fun pat ->
               let (_, i0) = pat in
               let (p, z0) = i0 in
               let (_, y) = p in
               bind y (fun y0 ->
                 bind z0 (fun z1 -> Some (ZRange.union y0 z1))))
           | Coq3_Compilers.Coq_ident_fancy_sell ->
             Obj.magic (fun pat ->
               let (i, z0) = pat in
               let (_, y) = i in
               bind y (fun y0 ->
                 bind z0 (fun z1 -> Some (ZRange.union y0 z1))))
           | Coq3_Compilers.Coq_ident_fancy_addm ->
             Obj.magic (fun pat ->
               let (i, m4) = pat in
               let (x, y) = i in
               bind x (fun x0 ->
                 bind y (fun y0 ->
                   bind m4 (fun m5 -> Some
                     (ZRange.union (ZRange.four_corners Coq_Z.add x0 y0)
                       (ZRange.eight_corners (fun x1 y1 m6 ->
                         Coq_Z.max Z0 (Coq_Z.sub (Coq_Z.add x1 y1) m6)) x0 y0
                         m5)))))))
       end
     end
   end
 end

type idx = n

type symbol = n

type operationSize = n

(** val show_OperationSize : operationSize show **)

let show_OperationSize =
  Decimal.show_N

type op0 =
| Old of operationSize * symbol
| Const0 of z
| Add0 of operationSize
| Addcarry of operationSize
| Subborrow of operationSize
| Addoverflow of operationSize
| Neg1 of operationSize
| Shl0 of operationSize
| Shr0 of operationSize
| Sar0 of operationSize
| Rcr0 of operationSize
| And0 of operationSize
| Or0 of operationSize
| Xor0 of operationSize
| Slice of n * n
| Mul0 of operationSize
| Set_slice of n * n
| Selectznz
| Iszero
| AddZ
| MulZ
| NegZ
| ShlZ
| ShrZ
| AndZ
| OrZ
| XorZ
| AddcarryZ of operationSize
| SubborrowZ of operationSize

(** val internal_op_beq0 : op0 -> op0 -> bool **)

let internal_op_beq0 x y =
  match x with
  | Old (s0, x0) ->
    (match y with
     | Old (s1, x1) -> (&&) (internal_N_beq s0 s1) (internal_N_beq x0 x1)
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Const0 x0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 x1 -> Level.internal_Z_beq x0 x1
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Add0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 s1 -> internal_N_beq s0 s1
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Addcarry s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry s1 -> internal_N_beq s0 s1
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Subborrow s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow s1 -> internal_N_beq s0 s1
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Addoverflow s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow s1 -> internal_N_beq s0 s1
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Neg1 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 s1 -> internal_N_beq s0 s1
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Shl0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 s1 -> internal_N_beq s0 s1
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Shr0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 s1 -> internal_N_beq s0 s1
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Sar0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 s1 -> internal_N_beq s0 s1
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Rcr0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 s1 -> internal_N_beq s0 s1
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | And0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 s1 -> internal_N_beq s0 s1
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Or0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 s1 -> internal_N_beq s0 s1
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Xor0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 s1 -> internal_N_beq s0 s1
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Slice (lo, sz) ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (lo0, sz0) ->
       (&&) (internal_N_beq lo lo0) (internal_N_beq sz sz0)
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Mul0 s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 s1 -> internal_N_beq s0 s1
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Set_slice (lo, sz) ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (lo0, sz0) ->
       (&&) (internal_N_beq lo lo0) (internal_N_beq sz sz0)
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Selectznz ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> true
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | Iszero ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> true
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | AddZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> true
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | MulZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> true
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | NegZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> true
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | ShlZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> true
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | ShrZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> true
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | AndZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> true
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | OrZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> true
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | XorZ ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> true
     | AddcarryZ _ -> false
     | SubborrowZ _ -> false)
  | AddcarryZ s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ s1 -> internal_N_beq s0 s1
     | SubborrowZ _ -> false)
  | SubborrowZ s0 ->
    (match y with
     | Old (_, _) -> false
     | Const0 _ -> false
     | Add0 _ -> false
     | Addcarry _ -> false
     | Subborrow _ -> false
     | Addoverflow _ -> false
     | Neg1 _ -> false
     | Shl0 _ -> false
     | Shr0 _ -> false
     | Sar0 _ -> false
     | Rcr0 _ -> false
     | And0 _ -> false
     | Or0 _ -> false
     | Xor0 _ -> false
     | Slice (_, _) -> false
     | Mul0 _ -> false
     | Set_slice (_, _) -> false
     | Selectznz -> false
     | Iszero -> false
     | AddZ -> false
     | MulZ -> false
     | NegZ -> false
     | ShlZ -> false
     | ShrZ -> false
     | AndZ -> false
     | OrZ -> false
     | XorZ -> false
     | AddcarryZ _ -> false
     | SubborrowZ s1 -> internal_N_beq s0 s1)

(** val op_eq_dec : op0 -> op0 -> bool **)

let op_eq_dec x y =
  let h = let b = internal_op_beq0 x y in if b then true else false in
  if h then true else false

(** val op_beq : op0 -> op0 -> bool **)

let op_beq a b =
  if op_eq_dec a b then true else false

(** val show_op : op0 show **)

let show_op = function
| Old (s0, n3) ->
  append ('o'::('l'::('d'::(' '::[]))))
    (append (show0 show_OperationSize s0)
      (append (' '::[]) (show0 Decimal.show_N n3)))
| Const0 n3 ->
  append ('c'::('o'::('n'::('s'::('t'::(' '::[]))))))
    (show0 Decimal.show_Z n3)
| Add0 s0 ->
  append ('a'::('d'::('d'::(' '::[])))) (show0 show_OperationSize s0)
| Addcarry s0 ->
  append ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::(' '::[])))))))))
    (show0 show_OperationSize s0)
| Subborrow s0 ->
  append
    ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::(' '::[]))))))))))
    (show0 show_OperationSize s0)
| Addoverflow s0 ->
  append
    ('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::(' '::[]))))))))))))
    (show0 show_OperationSize s0)
| Neg1 s0 ->
  append ('n'::('e'::('g'::(' '::[])))) (show0 show_OperationSize s0)
| Shl0 s0 ->
  append ('s'::('h'::('l'::(' '::[])))) (show0 show_OperationSize s0)
| Shr0 s0 ->
  append ('s'::('h'::('r'::(' '::[])))) (show0 show_OperationSize s0)
| Sar0 s0 ->
  append ('s'::('a'::('r'::(' '::[])))) (show0 show_OperationSize s0)
| Rcr0 s0 ->
  append ('r'::('c'::('r'::(' '::[])))) (show0 show_OperationSize s0)
| And0 s0 ->
  append ('a'::('n'::('d'::(' '::[])))) (show0 show_OperationSize s0)
| Or0 s0 -> append ('o'::('r'::(' '::[]))) (show0 show_OperationSize s0)
| Xor0 s0 ->
  append ('x'::('o'::('r'::(' '::[])))) (show0 show_OperationSize s0)
| Slice (lo, sz) ->
  append ('s'::('l'::('i'::('c'::('e'::(' '::[]))))))
    (append (show0 Decimal.show_N lo)
      (append (' '::[]) (show0 Decimal.show_N sz)))
| Mul0 s0 ->
  append ('m'::('u'::('l'::(' '::[])))) (show0 show_OperationSize s0)
| Set_slice (lo, sz) ->
  append
    ('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::(' '::[]))))))))))
    (append (show0 Decimal.show_N lo)
      (append (' '::[]) (show0 Decimal.show_N sz)))
| Selectznz -> 's'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::[]))))))))
| Iszero -> 'i'::('s'::('z'::('e'::('r'::('o'::[])))))
| AddZ -> 'a'::('d'::('d'::('Z'::[])))
| MulZ -> 'm'::('u'::('l'::('Z'::[])))
| NegZ -> 'n'::('e'::('g'::('Z'::[])))
| ShlZ -> 's'::('h'::('l'::('Z'::[])))
| ShrZ -> 's'::('h'::('r'::('Z'::[])))
| AndZ -> 'a'::('n'::('d'::('Z'::[])))
| OrZ -> 'o'::('r'::('Z'::[]))
| XorZ -> 'x'::('o'::('r'::('Z'::[])))
| AddcarryZ s0 ->
  append
    ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('Z'::(' '::[]))))))))))
    (show0 show_OperationSize s0)
| SubborrowZ s0 ->
  append
    ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('Z'::(' '::[])))))))))))
    (show0 show_OperationSize s0)

(** val show_op_subscript : op0 show **)

let show_op_subscript = function
| Old (s0, n3) ->
  append ('o'::('l'::('d'::[])))
    (append
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0))
      (append (' '::[]) (show0 Decimal.show_N n3)))
| Const0 n3 ->
  append ('c'::('o'::('n'::('s'::('t'::(' '::[]))))))
    (show0 Decimal.show_Z n3)
| Add0 s0 ->
  append ('a'::('d'::('d'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Addcarry s0 ->
  append ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::[]))))))))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Subborrow s0 ->
  append ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::[])))))))))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Addoverflow s0 ->
  append
    ('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::[])))))))))))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Neg1 s0 ->
  append ('n'::('e'::('g'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Shl0 s0 ->
  append ('s'::('h'::('l'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Shr0 s0 ->
  append ('s'::('h'::('r'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Sar0 s0 ->
  append ('s'::('a'::('r'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Rcr0 s0 ->
  append ('r'::('c'::('r'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| And0 s0 ->
  append ('a'::('n'::('d'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Or0 s0 ->
  append ('o'::('r'::[]))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Xor0 s0 ->
  append ('x'::('o'::('r'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Slice (lo, sz) ->
  append ('s'::('l'::('i'::('c'::('e'::[])))))
    (append
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 Decimal.show_N lo))
      (append (','::[])
        (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
          (show0 Decimal.show_N sz))))
| Mul0 s0 ->
  append ('m'::('u'::('l'::[])))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| Set_slice (lo, sz) ->
  append ('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[])))))))))
    (append
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 Decimal.show_N lo))
      (append (','::[])
        (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
          (show0 Decimal.show_N sz))))
| Selectznz -> 's'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::[]))))))))
| Iszero -> 'i'::('s'::('z'::('e'::('r'::('o'::[])))))
| AddZ -> 'a'::('d'::('d'::('\226'::('\132'::('\164'::[])))))
| MulZ -> 'm'::('u'::('l'::('\226'::('\132'::('\164'::[])))))
| NegZ -> 'n'::('e'::('g'::('\226'::('\132'::('\164'::[])))))
| ShlZ -> 's'::('h'::('l'::('\226'::('\132'::('\164'::[])))))
| ShrZ -> 's'::('h'::('r'::('\226'::('\132'::('\164'::[])))))
| AndZ -> 'a'::('n'::('d'::('\226'::('\132'::('\164'::[])))))
| OrZ -> 'o'::('r'::('\226'::('\132'::('\164'::[]))))
| XorZ -> 'x'::('o'::('r'::('\226'::('\132'::('\164'::[])))))
| AddcarryZ s0 ->
  append
    ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('\226'::('\132'::('\164'::[])))))))))))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))
| SubborrowZ s0 ->
  append
    ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('\226'::('\132'::('\164'::[]))))))))))))
    (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
      (show0 show_OperationSize s0))

module RewritePass =
 struct
  type rewrite_pass =
  | Coq_addbyte_small
  | Coq_addcarry_bit
  | Coq_addcarry_small
  | Coq_addoverflow_bit
  | Coq_addoverflow_small
  | Coq_combine_consts
  | Coq_constprop
  | Coq_consts_commutative
  | Coq_drop_identity
  | Coq_flatten_associative
  | Coq_flatten_bounded_associative
  | Coq_fold_consts_to_and
  | Coq_set_slice0_small
  | Coq_set_slice_set_slice
  | Coq_shift_to_mul
  | Coq_slice0
  | Coq_slice01_addcarryZ
  | Coq_slice01_subborrowZ
  | Coq_slice_set_slice
  | Coq_truncate_small
  | Coq_unary_truncate
  | Coq_xor_same

  (** val show_rewrite_pass : rewrite_pass show **)

  let show_rewrite_pass = function
  | Coq_addbyte_small ->
    'a'::('d'::('d'::('b'::('y'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))
  | Coq_addcarry_bit ->
    'a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('b'::('i'::('t'::[])))))))))))
  | Coq_addcarry_small ->
    'a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))
  | Coq_addoverflow_bit ->
    'a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('b'::('i'::('t'::[]))))))))))))))
  | Coq_addoverflow_small ->
    'a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))))))
  | Coq_combine_consts ->
    'c'::('o'::('m'::('b'::('i'::('n'::('e'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::[])))))))))))))
  | Coq_constprop ->
    'c'::('o'::('n'::('s'::('t'::('p'::('r'::('o'::('p'::[]))))))))
  | Coq_consts_commutative ->
    'c'::('o'::('n'::('s'::('t'::('s'::('_'::('c'::('o'::('m'::('m'::('u'::('t'::('a'::('t'::('i'::('v'::('e'::[])))))))))))))))))
  | Coq_drop_identity ->
    'd'::('r'::('o'::('p'::('_'::('i'::('d'::('e'::('n'::('t'::('i'::('t'::('y'::[]))))))))))))
  | Coq_flatten_associative ->
    'f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))
  | Coq_flatten_bounded_associative ->
    'f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('b'::('o'::('u'::('n'::('d'::('e'::('d'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))))))))))
  | Coq_fold_consts_to_and ->
    'f'::('o'::('l'::('d'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::('_'::('t'::('o'::('_'::('a'::('n'::('d'::[])))))))))))))))))
  | Coq_set_slice0_small ->
    's'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('0'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))))
  | Coq_set_slice_set_slice ->
    's'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))))))
  | Coq_shift_to_mul ->
    's'::('h'::('i'::('f'::('t'::('_'::('t'::('o'::('_'::('m'::('u'::('l'::[])))))))))))
  | Coq_slice0 -> 's'::('l'::('i'::('c'::('e'::('0'::[])))))
  | Coq_slice01_addcarryZ ->
    's'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('Z'::[]))))))))))))))))
  | Coq_slice01_subborrowZ ->
    's'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('Z'::[])))))))))))))))))
  | Coq_slice_set_slice ->
    's'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))
  | Coq_truncate_small ->
    't'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))
  | Coq_unary_truncate ->
    'u'::('n'::('a'::('r'::('y'::('_'::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::[])))))))))))))
  | Coq_xor_same -> 'x'::('o'::('r'::('_'::('s'::('a'::('m'::('e'::[])))))))

  (** val parse_rewrite_pass_list : (char list * rewrite_pass) list **)

  let parse_rewrite_pass_list =
    (('a'::('d'::('d'::('b'::('y'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))),
      Coq_addbyte_small) :: ((('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('b'::('i'::('t'::[])))))))))))),
      Coq_addcarry_bit) :: ((('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))),
      Coq_addcarry_small) :: ((('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('b'::('i'::('t'::[]))))))))))))))),
      Coq_addoverflow_bit) :: ((('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))))))),
      Coq_addoverflow_small) :: ((('c'::('o'::('m'::('b'::('i'::('n'::('e'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::[])))))))))))))),
      Coq_combine_consts) :: ((('c'::('o'::('n'::('s'::('t'::('p'::('r'::('o'::('p'::[]))))))))),
      Coq_constprop) :: ((('c'::('o'::('n'::('s'::('t'::('s'::('_'::('c'::('o'::('m'::('m'::('u'::('t'::('a'::('t'::('i'::('v'::('e'::[])))))))))))))))))),
      Coq_consts_commutative) :: ((('d'::('r'::('o'::('p'::('_'::('i'::('d'::('e'::('n'::('t'::('i'::('t'::('y'::[]))))))))))))),
      Coq_drop_identity) :: ((('f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))),
      Coq_flatten_associative) :: ((('f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('b'::('o'::('u'::('n'::('d'::('e'::('d'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))))))))))),
      Coq_flatten_bounded_associative) :: ((('f'::('o'::('l'::('d'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::('_'::('t'::('o'::('_'::('a'::('n'::('d'::[])))))))))))))))))),
      Coq_fold_consts_to_and) :: ((('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('0'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))))),
      Coq_set_slice0_small) :: ((('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))))))),
      Coq_set_slice_set_slice) :: ((('s'::('h'::('i'::('f'::('t'::('_'::('t'::('o'::('_'::('m'::('u'::('l'::[])))))))))))),
      Coq_shift_to_mul) :: ((('s'::('l'::('i'::('c'::('e'::('0'::[])))))),
      Coq_slice0) :: ((('s'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('Z'::[]))))))))))))))))),
      Coq_slice01_addcarryZ) :: ((('s'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('Z'::[])))))))))))))))))),
      Coq_slice01_subborrowZ) :: ((('s'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))),
      Coq_slice_set_slice) :: ((('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))),
      Coq_truncate_small) :: ((('u'::('n'::('a'::('r'::('y'::('_'::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::[])))))))))))))),
      Coq_unary_truncate) :: ((('x'::('o'::('r'::('_'::('s'::('a'::('m'::('e'::[])))))))),
      Coq_xor_same) :: [])))))))))))))))))))))

  (** val parse_rewrite_pass : rewrite_pass parserAction **)

  let parse_rewrite_pass =
    parse_strs parse_rewrite_pass_list

  (** val default_rewrite_pass_order : rewrite_pass list **)

  let default_rewrite_pass_order =
    Coq_constprop :: (Coq_slice0 :: (Coq_slice01_addcarryZ :: (Coq_slice01_subborrowZ :: (Coq_set_slice_set_slice :: (Coq_slice_set_slice :: (Coq_set_slice0_small :: (Coq_shift_to_mul :: (Coq_flatten_associative :: (Coq_consts_commutative :: (Coq_fold_consts_to_and :: (Coq_drop_identity :: (Coq_flatten_bounded_associative :: (Coq_unary_truncate :: (Coq_truncate_small :: (Coq_combine_consts :: (Coq_addoverflow_bit :: (Coq_addcarry_bit :: (Coq_addcarry_small :: (Coq_addoverflow_small :: (Coq_addbyte_small :: (Coq_xor_same :: [])))))))))))))))))))))
 end

module Options =
 struct
  type rewriting_pipeline_opt = RewritePass.rewrite_pass list

  type rewriting_pass_filter_opt = RewritePass.rewrite_pass -> bool

  type rewriting_passes_opt = RewritePass.rewrite_pass list

  (** val default_rewriting_passes :
      rewriting_pipeline_opt -> rewriting_pass_filter_opt ->
      rewriting_passes_opt **)

  let default_rewriting_passes rewriting_pipeline rewriting_pass_filter =
    filter rewriting_pass_filter rewriting_pipeline

  type symbolic_options_opt = { asm_rewriting_pipeline : rewriting_pipeline_opt;
                                asm_rewriting_pass_filter : rewriting_pass_filter_opt }

  (** val asm_rewriting_pipeline :
      symbolic_options_opt -> rewriting_pipeline_opt **)

  let asm_rewriting_pipeline symbolic_options_opt0 =
    symbolic_options_opt0.asm_rewriting_pipeline

  (** val asm_rewriting_pass_filter :
      symbolic_options_opt -> rewriting_pass_filter_opt **)

  let asm_rewriting_pass_filter symbolic_options_opt0 =
    symbolic_options_opt0.asm_rewriting_pass_filter

  type symbolic_options_computed_opt =
    rewriting_passes_opt
    (* singleton inductive, whose constructor was Build_symbolic_options_computed_opt *)

  (** val asm_rewriting_passes :
      symbolic_options_computed_opt -> rewriting_passes_opt **)

  let asm_rewriting_passes symbolic_options_computed_opt0 =
    symbolic_options_computed_opt0
 end

(** val associative : op0 -> bool **)

let associative = function
| Old (_, _) -> false
| Const0 _ -> false
| Add0 _ -> true
| Addcarry _ -> false
| Subborrow _ -> false
| Addoverflow _ -> false
| Neg1 _ -> false
| Shl0 _ -> false
| Shr0 _ -> false
| Sar0 _ -> false
| Rcr0 _ -> false
| And0 _ -> true
| Or0 _ -> true
| Xor0 _ -> true
| Slice (_, _) -> false
| Mul0 _ -> true
| Set_slice (_, _) -> false
| Selectznz -> false
| Iszero -> false
| AddZ -> true
| MulZ -> true
| NegZ -> false
| ShlZ -> false
| ShrZ -> false
| AndZ -> true
| OrZ -> true
| XorZ -> true
| AddcarryZ _ -> false
| SubborrowZ _ -> false

(** val commutative : op0 -> bool **)

let commutative = function
| Old (_, _) -> false
| Const0 _ -> false
| Add0 _ -> true
| Addcarry _ -> true
| Subborrow _ -> false
| Addoverflow _ -> true
| Neg1 _ -> false
| Shl0 _ -> false
| Shr0 _ -> false
| Sar0 _ -> false
| Rcr0 _ -> false
| And0 _ -> true
| Or0 _ -> true
| Xor0 _ -> true
| Slice (_, _) -> false
| Mul0 _ -> true
| Set_slice (_, _) -> false
| Selectznz -> false
| Iszero -> false
| AddZ -> true
| MulZ -> true
| NegZ -> false
| ShlZ -> false
| ShrZ -> false
| AndZ -> true
| OrZ -> true
| XorZ -> true
| AddcarryZ _ -> false
| SubborrowZ _ -> false

(** val identity : op0 -> z option **)

let identity = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 _ -> Some Z0
| Addcarry _ -> Some Z0
| Subborrow _ -> None
| Addoverflow _ -> Some Z0
| Neg1 _ -> None
| Shl0 _ -> None
| Shr0 _ -> None
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 s0 -> Some (Coq_Z.ones (Coq_Z.of_N s0))
| Or0 _ -> Some Z0
| Xor0 _ -> Some Z0
| Slice (_, _) -> None
| Mul0 s0 -> Some (match s0 with
                   | N0 -> Z0
                   | Npos _ -> Zpos XH)
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> Some Z0
| MulZ -> Some (Zpos XH)
| NegZ -> None
| ShlZ -> None
| ShrZ -> None
| AndZ -> Some (Zneg XH)
| OrZ -> Some Z0
| XorZ -> Some Z0
| AddcarryZ _ -> Some Z0
| SubborrowZ _ -> None

(** val identity_after_0 : op0 -> z option **)

let identity_after_0 = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 _ -> None
| Addcarry _ -> None
| Subborrow _ -> Some Z0
| Addoverflow _ -> None
| Neg1 _ -> None
| Shl0 _ -> None
| Shr0 _ -> None
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 _ -> None
| Or0 _ -> None
| Xor0 _ -> None
| Slice (_, _) -> None
| Mul0 _ -> None
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> None
| MulZ -> None
| NegZ -> None
| ShlZ -> None
| ShrZ -> None
| AndZ -> None
| OrZ -> None
| XorZ -> None
| AddcarryZ _ -> None
| SubborrowZ _ -> Some Z0

(** val unary_truncate_size : op0 -> z option **)

let unary_truncate_size = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 s0 -> Some (Coq_Z.of_N s0)
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 _ -> None
| Shl0 _ -> None
| Shr0 _ -> None
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 s0 -> Some (Coq_Z.of_N s0)
| Or0 s0 -> Some (Coq_Z.of_N s0)
| Xor0 s0 -> Some (Coq_Z.of_N s0)
| Slice (_, _) -> None
| Mul0 s0 -> Some (Coq_Z.of_N s0)
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> Some (Zneg XH)
| MulZ -> Some (Zneg XH)
| NegZ -> None
| ShlZ -> None
| ShrZ -> None
| AndZ -> Some (Zneg XH)
| OrZ -> Some (Zneg XH)
| XorZ -> Some (Zneg XH)
| AddcarryZ _ -> None
| SubborrowZ _ -> None

(** val op_always_interps : op0 -> bool **)

let op_always_interps = function
| Old (_, _) -> false
| Const0 _ -> false
| Add0 _ -> true
| Addcarry _ -> true
| Subborrow _ -> false
| Addoverflow _ -> true
| Neg1 _ -> false
| Shl0 _ -> false
| Shr0 _ -> false
| Sar0 _ -> false
| Rcr0 _ -> false
| And0 _ -> true
| Or0 _ -> true
| Xor0 _ -> true
| Slice (_, _) -> false
| Mul0 _ -> true
| Set_slice (_, _) -> false
| Selectznz -> false
| Iszero -> false
| AddZ -> true
| MulZ -> true
| NegZ -> false
| ShlZ -> false
| ShrZ -> false
| AndZ -> true
| OrZ -> true
| XorZ -> true
| AddcarryZ _ -> true
| SubborrowZ _ -> false

(** val combines_to : op0 -> op0 option **)

let combines_to = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 s0 -> Some (Mul0 s0)
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 _ -> None
| Shl0 _ -> None
| Shr0 _ -> None
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 _ -> None
| Or0 _ -> None
| Xor0 _ -> None
| Slice (_, _) -> None
| Mul0 _ -> None
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> Some MulZ
| MulZ -> None
| NegZ -> None
| ShlZ -> None
| ShrZ -> None
| AndZ -> None
| OrZ -> None
| XorZ -> None
| AddcarryZ _ -> None
| SubborrowZ _ -> None

type drop_kind =
| Drop_always
| Drop_if_bounded of zrange * op0

(** val bounds_for_drop_inner_associative : op0 -> op0 -> drop_kind option **)

let bounds_for_drop_inner_associative o_outer o_inner =
  match o_outer with
  | Old (_, _) -> None
  | Const0 _ -> None
  | Add0 _ -> None
  | Addcarry _ ->
    (match o_inner with
     | Old (_, _) -> None
     | Const0 _ -> None
     | Add0 _ ->
       bind (unary_truncate_size o_inner) (fun s' -> Some (Drop_if_bounded
         ({ lower = Z0; upper = (Coq_Z.ones s') }, AddZ)))
     | Addcarry _ -> None
     | Subborrow _ -> None
     | Addoverflow _ -> None
     | Neg1 _ -> None
     | Shl0 _ -> None
     | Shr0 _ -> None
     | Sar0 _ -> None
     | Rcr0 _ -> None
     | And0 _ -> None
     | Or0 _ -> None
     | Xor0 _ -> None
     | Slice (_, _) -> None
     | Mul0 _ -> None
     | Set_slice (_, _) -> None
     | Selectznz -> None
     | Iszero -> None
     | AddZ -> Some Drop_always
     | MulZ -> None
     | NegZ -> None
     | ShlZ -> None
     | ShrZ -> None
     | AndZ -> None
     | OrZ -> None
     | XorZ -> None
     | AddcarryZ _ -> None
     | SubborrowZ _ -> None)
  | Subborrow _ -> None
  | Addoverflow _ -> None
  | Neg1 _ -> None
  | Shl0 _ -> None
  | Shr0 _ -> None
  | Sar0 _ -> None
  | Rcr0 _ -> None
  | And0 _ -> None
  | Or0 _ -> None
  | Xor0 _ -> None
  | Slice (_, _) -> None
  | Mul0 _ -> None
  | Set_slice (_, _) -> None
  | Selectznz -> None
  | Iszero -> None
  | AddZ -> None
  | MulZ -> None
  | NegZ -> None
  | ShlZ -> None
  | ShrZ -> None
  | AndZ -> None
  | OrZ -> None
  | XorZ -> None
  | AddcarryZ _ ->
    (match o_inner with
     | Old (_, _) -> None
     | Const0 _ -> None
     | Add0 _ ->
       bind (unary_truncate_size o_inner) (fun s' -> Some (Drop_if_bounded
         ({ lower = Z0; upper = (Coq_Z.ones s') }, AddZ)))
     | Addcarry _ -> None
     | Subborrow _ -> None
     | Addoverflow _ -> None
     | Neg1 _ -> None
     | Shl0 _ -> None
     | Shr0 _ -> None
     | Sar0 _ -> None
     | Rcr0 _ -> None
     | And0 _ -> None
     | Or0 _ -> None
     | Xor0 _ -> None
     | Slice (_, _) -> None
     | Mul0 _ -> None
     | Set_slice (_, _) -> None
     | Selectznz -> None
     | Iszero -> None
     | AddZ -> Some Drop_always
     | MulZ -> None
     | NegZ -> None
     | ShlZ -> None
     | ShrZ -> None
     | AndZ -> None
     | OrZ -> None
     | XorZ -> None
     | AddcarryZ _ -> None
     | SubborrowZ _ -> None)
  | SubborrowZ _ -> None

type 'a node0 = op0 * 'a list

(** val show_node : 'a1 show -> 'a1 node0 show **)

let show_node show_A =
  show_prod show_op (show_list show_A)

type expr0 =
| ExprRef of idx
| ExprApp of expr0 node0

(** val show_expr : expr0 show **)

let rec show_expr = function
| ExprRef i ->
  append ('E'::('x'::('p'::('r'::('R'::('e'::('f'::(' '::[]))))))))
    (Decimal.show_N i)
| ExprApp n3 ->
  let (o, e0) = n3 in
  append ('E'::('x'::('p'::('r'::('A'::('p'::('p'::(' '::[]))))))))
    (append ('('::[])
      (append
        (append (show_op o)
          (append (','::(' '::[]))
            (append ('['::[])
              (append (concat0 (','::(' '::[])) (map show_expr e0)) (']'::[])))))
        (')'::[])))

(** val show_infix_op : op0 -> char list option **)

let show_infix_op = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 s0 ->
  Some
    (append ('+'::[])
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 _ -> None
| Shl0 s0 ->
  Some
    (append ('>'::('>'::[]))
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Shr0 s0 ->
  Some
    (append ('>'::('>'::[]))
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Sar0 s0 ->
  Some
    (append ('>'::('>'::('>'::[])))
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Rcr0 _ -> None
| And0 s0 ->
  Some
    (append ('&'::[])
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Or0 s0 ->
  Some
    (append ('|'::[])
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Xor0 s0 ->
  Some
    (append ('^'::[])
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Slice (_, _) -> None
| Mul0 s0 ->
  Some
    (append ('*'::[])
      (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
        (show0 show_OperationSize s0)))
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> Some ('+'::('\226'::('\132'::('\164'::[]))))
| MulZ -> Some ('*'::('\226'::('\132'::('\164'::[]))))
| NegZ -> None
| ShlZ -> Some ('<'::('<'::('\226'::('\132'::('\164'::[])))))
| ShrZ -> Some ('>'::('>'::('\226'::('\132'::('\164'::[])))))
| AndZ -> Some ('&'::('\226'::('\132'::('\164'::[]))))
| OrZ -> Some ('|'::('\226'::('\132'::('\164'::[]))))
| XorZ -> Some ('^'::('\226'::('\132'::('\164'::[]))))
| AddcarryZ _ -> None
| SubborrowZ _ -> None

(** val show_prefix_op : op0 -> (char list * Level.coq_Level) option **)

let show_prefix_op = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 _ -> None
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 s0 ->
  Some
    ((append ('-'::[])
       (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
         (show0 show_OperationSize s0))), (Level.Coq_level (Zpos (XI (XI (XO
    (XO (XO XH))))))))
| Shl0 _ -> None
| Shr0 _ -> None
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 _ -> None
| Or0 _ -> None
| Xor0 _ -> None
| Slice (_, _) -> None
| Mul0 _ -> None
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> None
| MulZ -> None
| NegZ ->
  Some (('-'::('\226'::('\132'::('\164'::[])))), (Level.Coq_level (Zpos (XI
    (XI (XO (XO (XO XH))))))))
| ShlZ -> None
| ShrZ -> None
| AndZ -> None
| OrZ -> None
| XorZ -> None
| AddcarryZ _ -> None
| SubborrowZ _ -> None

(** val show_lvl_expr_pretty : expr0 showLevel **)

let rec show_lvl_expr_pretty e =
  let __0 = show_of_ShowLevel show_lvl_expr_pretty in
  let show_comment_args = fun args0 ->
    match args0 with
    | [] -> []
    | _ :: _ ->
      append (' '::('('::('*'::(' '::[]))))
        (append
          (show0 (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
            args0) (' '::('*'::(')'::[]))))
  in
  (match e with
   | ExprRef i -> (fun _ -> append ('#'::[]) (show0 Decimal.show_N i))
   | ExprApp n3 ->
     let (o, args0) = n3 in
     (match o with
      | Old (s0, x) ->
        lvl_wrap_parens (Level.Coq_level (Zpos (XO (XI (XO XH)))))
          (append ('o'::('l'::('d'::[])))
            (append
              (WORKAROUND_EXTRACTION_DONT_SHADOW_OCAML_STRING.String.to_subscript
                (show0 show_OperationSize s0))
              (append (' '::[])
                (append (show0 Decimal.show_N x) (show_comment_args args0)))))
      | Const0 x ->
        (fun lvl ->
          append
            (PowersOfTwo.show_lvl_Z_up_to (S (S (S (S (S O))))) (Zpos (XO (XO
              (XO (XO (XO (XO (XO (XO XH))))))))) x lvl)
            (show_comment_args args0))
      | Add0 s0 ->
        let o0 = invert_Some (show_infix_op (Add0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Addcarry _ ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | Subborrow _ ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | Addoverflow _ ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | Neg1 s0 ->
        let (o0, lvl) = Obj.magic invert_Some (show_prefix_op (Neg1 s0)) in
        (match args0 with
         | [] -> (fun _ -> append o0 ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] -> (fun _ -> append o0 (show_lvl show_lvl_expr_pretty x lvl))
            | _ :: _ ->
              (fun _ ->
                append o0
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0))))
      | Shl0 s0 ->
        let o0 = invert_Some (show_infix_op (Shl0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Shr0 s0 ->
        let o0 = invert_Some (show_infix_op (Shr0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Sar0 s0 ->
        let o0 = invert_Some (show_infix_op (Sar0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Rcr0 _ ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | And0 s0 ->
        let o0 = invert_Some (show_infix_op (And0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Or0 s0 ->
        let o0 = invert_Some (show_infix_op (Or0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Xor0 s0 ->
        let o0 = invert_Some (show_infix_op (Xor0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Slice (_, _) ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | Mul0 s0 ->
        let o0 = invert_Some (show_infix_op (Mul0 s0)) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | Set_slice (_, _) ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | Selectznz ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | Iszero ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | AddZ ->
        let o0 = invert_Some (show_infix_op AddZ) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | MulZ ->
        let o0 = invert_Some (show_infix_op MulZ) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | NegZ ->
        let (o0, lvl) = Obj.magic invert_Some (show_prefix_op NegZ) in
        (match args0 with
         | [] -> (fun _ -> append o0 ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] -> (fun _ -> append o0 (show_lvl show_lvl_expr_pretty x lvl))
            | _ :: _ ->
              (fun _ ->
                append o0
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0))))
      | ShlZ ->
        let o0 = invert_Some (show_infix_op ShlZ) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | ShrZ ->
        let o0 = invert_Some (show_infix_op ShrZ) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | AndZ ->
        let o0 = invert_Some (show_infix_op AndZ) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | OrZ ->
        let o0 = invert_Some (show_infix_op OrZ) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | XorZ ->
        let o0 = invert_Some (show_infix_op XorZ) in
        (match args0 with
         | [] -> (fun _ -> append (Obj.magic o0) ('['::(']'::[])))
         | x :: l ->
           (match l with
            | [] ->
              (fun _ ->
                append (Obj.magic o0)
                  (append ('['::[]) (append (show0 __0 x) (']'::[]))))
            | _ :: _ ->
              (fun _ ->
                append ('('::[])
                  (append
                    (concat0
                      (append (' '::[]) (append (Obj.magic o0) (' '::[])))
                      (map (show0 __0) args0)) (')'::[])))))
      | AddcarryZ _ ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))
      | SubborrowZ _ ->
        (fun _ ->
          append ('('::[])
            (append (show_op_subscript o)
              (append (','::(' '::[]))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_list show_lvl_expr_pretty))
                    args0) (')'::[])))))))

(** val show_expr_pretty : expr0 show **)

let show_expr_pretty =
  show_of_ShowLevel show_lvl_expr_pretty

(** val reflect_eq_op : op0 -> op0 -> reflect **)

let reflect_eq_op =
  reflect_rel_of_BoolSpec op_beq

(** val expr_beq : expr0 -> expr0 -> bool **)

let rec expr_beq x y =
  match x with
  | ExprRef x0 ->
    (match y with
     | ExprRef x1 -> Coq_N.eqb x0 x1
     | ExprApp _ -> false)
  | ExprApp x0 ->
    (match y with
     | ExprRef _ -> false
     | ExprApp x1 -> prod_beq op_beq (list_beq expr_beq) x0 x1)

(** val signed : n -> z -> z **)

let signed s0 n3 =
  Coq_Z.sub
    (Coq_Z.coq_land
      (Coq_Z.add
        (Coq_Z.shiftl (Zpos XH) (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))) n3)
      (Coq_Z.ones (Coq_Z.of_N s0)))
    (Coq_Z.shiftl (Zpos XH) (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH)))

(** val interp_op : (symbol -> z option) -> op0 -> z list -> z option **)

let interp_op ctx o args0 =
  match o with
  | Old (s0, x) ->
    (match args0 with
     | [] ->
       (match ctx x with
        | Some v -> Some (Coq_Z.coq_land v (Coq_Z.ones (Coq_Z.of_N s0)))
        | None -> None)
     | _ :: _ -> None)
  | Const0 z0 -> (match args0 with
                  | [] -> Some z0
                  | _ :: _ -> None)
  | Add0 s0 ->
    Some
      (Coq_Z.coq_land (fold_right Coq_Z.add Z0 args0)
        (Coq_Z.ones (Coq_Z.of_N s0)))
  | Addcarry s0 ->
    Some
      (Coq_Z.modulo
        (Coq_Z.shiftr (fold_right Coq_Z.add Z0 args0) (Coq_Z.of_N s0)) (Zpos
        (XO XH)))
  | Subborrow s0 ->
    (match args0 with
     | [] -> None
     | a :: args' ->
       Some
         (Coq_Z.modulo
           (Coq_Z.opp
             (Coq_Z.shiftr (Coq_Z.sub a (fold_right Coq_Z.add Z0 args'))
               (Coq_Z.of_N s0))) (Zpos (XO XH))))
  | Addoverflow s0 ->
    Some
      (Coq_Z.b2z
        (negb
          (Coq_Z.eqb
            (signed s0
              (Coq_Z.coq_land (fold_right Coq_Z.add Z0 args0)
                (Coq_Z.ones (Coq_Z.of_N s0))))
            (fold_right Coq_Z.add Z0 (map (signed s0) args0)))))
  | Neg1 s0 ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] ->
          Some (Coq_Z.coq_land (Coq_Z.opp a) (Coq_Z.ones (Coq_Z.of_N s0)))
        | _ :: _ -> None))
  | Shl0 s0 ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] -> None
        | b :: l0 ->
          (match l0 with
           | [] ->
             Some
               (Coq_Z.coq_land (Coq_Z.shiftl a b)
                 (Coq_Z.ones (Coq_Z.of_N s0)))
           | _ :: _ -> None)))
  | Shr0 s0 ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] -> None
        | b :: l0 ->
          (match l0 with
           | [] ->
             Some
               (Coq_Z.coq_land (Coq_Z.shiftr a b)
                 (Coq_Z.ones (Coq_Z.of_N s0)))
           | _ :: _ -> None)))
  | Sar0 s0 ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] -> None
        | b :: l0 ->
          (match l0 with
           | [] ->
             Some
               (Coq_Z.coq_land (Coq_Z.shiftr (signed s0 a) b)
                 (Coq_Z.ones (Coq_Z.of_N s0)))
           | _ :: _ -> None)))
  | Rcr0 s0 ->
    (match args0 with
     | [] -> None
     | v1 :: l ->
       (match l with
        | [] -> None
        | cf :: l0 ->
          (match l0 with
           | [] -> None
           | cnt :: l1 ->
             (match l1 with
              | [] ->
                Some
                  (Coq_Z.coq_land
                    (Coq_Z.shiftr
                      (Coq_Z.coq_lor
                        (Coq_Z.coq_lor v1 (Coq_Z.shiftl cf (Coq_Z.of_N s0)))
                        (Coq_Z.shiftl v1
                          (Coq_Z.add (Zpos XH) (Coq_Z.of_N s0)))) cnt)
                    (Coq_Z.ones (Coq_Z.of_N s0)))
              | _ :: _ -> None))))
  | And0 s0 ->
    Some
      (Coq_Z.coq_land
        (fold_right Coq_Z.coq_land (Coq_Z.ones (Coq_Z.of_N s0)) args0)
        (Coq_Z.ones (Coq_Z.of_N s0)))
  | Or0 s0 ->
    Some
      (Coq_Z.coq_land (fold_right Coq_Z.coq_lor Z0 args0)
        (Coq_Z.ones (Coq_Z.of_N s0)))
  | Xor0 s0 ->
    Some
      (Coq_Z.coq_land (fold_right Coq_Z.coq_lxor Z0 args0)
        (Coq_Z.ones (Coq_Z.of_N s0)))
  | Slice (lo, sz) ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] ->
          Some
            (Coq_Z.coq_land (Coq_Z.shiftr a (Coq_Z.of_N lo))
              (Coq_Z.ones (Coq_Z.of_N sz)))
        | _ :: _ -> None))
  | Mul0 s0 ->
    Some
      (Coq_Z.coq_land
        (fold_right Coq_Z.mul (match s0 with
                               | N0 -> Z0
                               | Npos _ -> Zpos XH) args0)
        (Coq_Z.ones (Coq_Z.of_N s0)))
  | Set_slice (lo, sz) ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] -> None
        | b :: l0 ->
          (match l0 with
           | [] ->
             Some
               (Coq_Z.coq_lor
                 (Coq_Z.shiftl
                   (Coq_Z.coq_land b (Coq_Z.ones (Coq_Z.of_N sz)))
                   (Coq_Z.of_N lo))
                 (Coq_Z.ldiff a
                   (Coq_Z.shiftl (Coq_Z.ones (Coq_Z.of_N sz)) (Coq_Z.of_N lo))))
           | _ :: _ -> None)))
  | Selectznz ->
    (match args0 with
     | [] -> None
     | c0 :: l ->
       (match l with
        | [] -> None
        | a :: l0 ->
          (match l0 with
           | [] -> None
           | b :: l1 ->
             (match l1 with
              | [] -> Some (if Coq_Z.eqb c0 Z0 then a else b)
              | _ :: _ -> None))))
  | Iszero ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] -> Some (Coq_Z.b2z (Coq_Z.eqb a Z0))
        | _ :: _ -> None))
  | AddZ -> Some (fold_right Coq_Z.add Z0 args0)
  | MulZ -> Some (fold_right Coq_Z.mul (Zpos XH) args0)
  | NegZ ->
    (match args0 with
     | [] -> None
     | a :: l -> (match l with
                  | [] -> Some (Coq_Z.opp a)
                  | _ :: _ -> None))
  | ShlZ ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] -> None
        | b :: l0 ->
          (match l0 with
           | [] -> Some (Coq_Z.shiftl a b)
           | _ :: _ -> None)))
  | ShrZ ->
    (match args0 with
     | [] -> None
     | a :: l ->
       (match l with
        | [] -> None
        | b :: l0 ->
          (match l0 with
           | [] -> Some (Coq_Z.shiftr a b)
           | _ :: _ -> None)))
  | AndZ -> Some (fold_right Coq_Z.coq_land (Zneg XH) args0)
  | OrZ -> Some (fold_right Coq_Z.coq_lor Z0 args0)
  | XorZ -> Some (fold_right Coq_Z.coq_lxor Z0 args0)
  | AddcarryZ s0 ->
    Some (Coq_Z.shiftr (fold_right Coq_Z.add Z0 args0) (Coq_Z.of_N s0))
  | SubborrowZ s0 ->
    (match args0 with
     | [] -> None
     | a :: args' ->
       Some
         (Coq_Z.opp
           (Coq_Z.shiftr (Coq_Z.sub a (fold_right Coq_Z.add Z0 args'))
             (Coq_Z.of_N s0))))

(** val interp0_op : op0 -> z list -> z option **)

let interp0_op =
  interp_op (fun _ -> None)

(** val node_beq : ('a1 -> 'a1 -> bool) -> 'a1 node0 -> 'a1 node0 -> bool **)

let node_beq arg_eqb =
  prod_beq op_beq (list_beq arg_eqb)

(** val shiftr_avoid_uint1_opt_instance_0 :
    Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt **)

let shiftr_avoid_uint1_opt_instance_0 =
  false

(** val op_to_PHOAS_binop : op0 -> Coq3_Compilers.ident option **)

let op_to_PHOAS_binop = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 _ -> Some Coq3_Compilers.Coq_ident_Z_add
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 _ -> None
| Shl0 _ -> Some Coq3_Compilers.Coq_ident_Z_shiftl
| Shr0 _ -> Some Coq3_Compilers.Coq_ident_Z_shiftr
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 _ -> Some Coq3_Compilers.Coq_ident_Z_land
| Or0 _ -> Some Coq3_Compilers.Coq_ident_Z_lor
| Xor0 _ -> Some Coq3_Compilers.Coq_ident_Z_lxor
| Slice (_, _) -> None
| Mul0 _ -> Some Coq3_Compilers.Coq_ident_Z_mul
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> Some Coq3_Compilers.Coq_ident_Z_add
| MulZ -> Some Coq3_Compilers.Coq_ident_Z_mul
| NegZ -> None
| ShlZ -> Some Coq3_Compilers.Coq_ident_Z_shiftl
| ShrZ -> Some Coq3_Compilers.Coq_ident_Z_shiftr
| AndZ -> Some Coq3_Compilers.Coq_ident_Z_land
| OrZ -> Some Coq3_Compilers.Coq_ident_Z_lor
| XorZ -> Some Coq3_Compilers.Coq_ident_Z_lxor
| AddcarryZ _ -> None
| SubborrowZ _ -> None

(** val op_to_PHOAS_unop : op0 -> Coq3_Compilers.ident option **)

let op_to_PHOAS_unop = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 _ -> None
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 _ -> Some Coq3_Compilers.Coq_ident_Z_opp
| Shl0 _ -> None
| Shr0 _ -> None
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 _ -> None
| Or0 _ -> None
| Xor0 _ -> None
| Slice (_, _) -> None
| Mul0 _ -> None
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> None
| MulZ -> None
| NegZ -> Some Coq3_Compilers.Coq_ident_Z_opp
| ShlZ -> None
| ShrZ -> None
| AndZ -> None
| OrZ -> None
| XorZ -> None
| AddcarryZ _ -> None
| SubborrowZ _ -> None

(** val op_to_PHOAS_tritop : op0 -> Coq3_Compilers.ident option **)

let op_to_PHOAS_tritop = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 _ -> None
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 _ -> None
| Shl0 _ -> None
| Shr0 _ -> None
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 _ -> None
| Or0 _ -> None
| Xor0 _ -> None
| Slice (_, _) -> None
| Mul0 _ -> None
| Set_slice (_, _) -> None
| Selectznz -> Some Coq3_Compilers.Coq_ident_Z_zselect
| Iszero -> None
| AddZ -> None
| MulZ -> None
| NegZ -> None
| ShlZ -> None
| ShrZ -> None
| AndZ -> None
| OrZ -> None
| XorZ -> None
| AddcarryZ _ -> None
| SubborrowZ _ -> None

(** val op_to_bounds : op0 -> zrange option **)

let op_to_bounds = function
| Old (_, _) -> None
| Const0 _ -> None
| Add0 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Addcarry _ -> None
| Subborrow _ -> None
| Addoverflow _ -> None
| Neg1 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Shl0 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Shr0 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Sar0 _ -> None
| Rcr0 _ -> None
| And0 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Or0 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Xor0 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Slice (_, _) -> None
| Mul0 s0 -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) }
| Set_slice (_, _) -> None
| Selectznz -> None
| Iszero -> None
| AddZ -> None
| MulZ -> None
| NegZ -> None
| ShlZ -> None
| ShrZ -> None
| AndZ -> None
| OrZ -> None
| XorZ -> None
| AddcarryZ _ -> None
| SubborrowZ _ -> None

(** val op_to_PHOAS_bounds :
    op0 -> ((unit -> zrange option) list -> zrange option) option **)

let op_to_PHOAS_bounds o =
  let unthunk = map (fun x -> x ()) in
  (match o with
   | Old (s0, _) ->
     Some (fun _ -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) })
   | Const0 x ->
     Some (fun _ ->
       Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
         (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z, (Obj.magic x))))
   | Add0 s0 ->
     let o0 = Add0 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
       shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       Coq3_Compilers.Coq_ident_Z_cast (Some b)
       (fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
         (Obj.magic id0) }) (unthunk args0)))
   | Addcarry _ -> Some (fun _ -> Some { lower = Z0; upper = (Zpos XH) })
   | Subborrow _ -> Some (fun _ -> Some { lower = Z0; upper = (Zpos XH) })
   | Addoverflow _ -> Some (fun _ -> Some { lower = Z0; upper = (Zpos XH) })
   | Neg1 s0 ->
     let o0 = Neg1 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
         (Obj.magic invert_Some (op_to_PHOAS_unop o0))
     in
     Some (fun args0 ->
     match args0 with
     | [] -> None
     | x :: l ->
       (match l with
        | [] ->
          Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
            shiftr_avoid_uint1_opt_instance_0 true
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_cast (Some b) (Obj.magic o1 (x ()))
        | _ :: _ -> None))
   | Shl0 s0 ->
     let o0 = Shl0 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     match args0 with
     | [] -> None
     | x :: l ->
       (match l with
        | [] -> None
        | y :: l0 ->
          (match l0 with
           | [] ->
             Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
               shiftr_avoid_uint1_opt_instance_0 true
               (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
               ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
               (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_cast (Some
               b) (Obj.magic o1 (x ()) (y ()))
           | _ :: _ -> None)))
   | Shr0 s0 ->
     let o0 = Shr0 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     match args0 with
     | [] -> None
     | x :: l ->
       (match l with
        | [] -> None
        | y :: l0 ->
          (match l0 with
           | [] ->
             Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
               shiftr_avoid_uint1_opt_instance_0 true
               (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
               ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
               (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_ident_Z_cast (Some
               b) (Obj.magic o1 (x ()) (y ()))
           | _ :: _ -> None)))
   | Sar0 s0 ->
     Some (fun _ -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) })
   | Rcr0 s0 ->
     Some (fun _ -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) })
   | And0 s0 ->
     let o0 = And0 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
       shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       Coq3_Compilers.Coq_ident_Z_cast (Some b)
       (fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
         (Obj.magic id0) }) (unthunk args0)))
   | Or0 s0 ->
     let o0 = Or0 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
       shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       Coq3_Compilers.Coq_ident_Z_cast (Some b)
       (fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
         (Obj.magic id0) }) (unthunk args0)))
   | Xor0 s0 ->
     let o0 = Xor0 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
       shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       Coq3_Compilers.Coq_ident_Z_cast (Some b)
       (fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
         (Obj.magic id0) }) (unthunk args0)))
   | Slice (_, s0) ->
     Some (fun _ -> Some { lower = Z0; upper = (Coq_Z.ones (Coq_Z.of_N s0)) })
   | Mul0 s0 ->
     let o0 = Mul0 s0 in
     let b = invert_Some (op_to_bounds o0) in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     Obj.magic Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
       shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       Coq3_Compilers.Coq_ident_Z_cast (Some b)
       (fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
         (Obj.magic id0) }) (unthunk args0)))
   | Set_slice (lo, w) ->
     (match lo with
      | N0 ->
        Some (fun args0 ->
          match unthunk args0 with
          | [] -> None
          | i :: l ->
            (match i with
             | Some a ->
               (match l with
                | [] -> None
                | i0 :: l0 ->
                  (match i0 with
                   | Some b ->
                     (match l0 with
                      | [] ->
                        if (||) (Coq_Z.ltb a.lower Z0) (Coq_Z.ltb b.lower Z0)
                        then None
                        else let a0 = a.upper in
                             let b0 = b.upper in
                             Some { lower = Z0; upper =
                             (Coq_Z.coq_lor
                               (Coq_Z.coq_land
                                 (Coq_Z.ones (Coq_Z.succ (Coq_Z.log2 b0)))
                                 (Coq_Z.ones (Coq_Z.of_N w)))
                               (Coq_Z.ldiff
                                 (Coq_Z.ones (Coq_Z.succ (Coq_Z.log2 a0)))
                                 (Coq_Z.ones (Coq_Z.of_N w)))) }
                      | _ :: _ -> None)
                   | None -> None))
             | None -> None))
      | Npos _ -> None)
   | Selectznz ->
     let o0 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
         (Obj.magic invert_Some (op_to_PHOAS_tritop Selectznz))
     in
     Some (fun args0 ->
     match args0 with
     | [] -> None
     | x :: l ->
       (match l with
        | [] -> None
        | y :: l0 ->
          (match l0 with
           | [] -> None
           | z0 :: l1 ->
             (match l1 with
              | [] -> Obj.magic o0 (x ()) (y ()) (z0 ())
              | _ :: _ -> None))))
   | Iszero -> Some (fun _ -> Some { lower = Z0; upper = (Zpos XH) })
   | AddZ ->
     let o0 = AddZ in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
       (Obj.magic id0) }) (unthunk args0))
   | MulZ ->
     let o0 = MulZ in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
       (Obj.magic id0) }) (unthunk args0))
   | NegZ ->
     let o0 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
         (Obj.magic invert_Some (op_to_PHOAS_unop NegZ))
     in
     Some (fun args0 ->
     match args0 with
     | [] -> None
     | x :: l -> (match l with
                  | [] -> Obj.magic o0 (x ())
                  | _ :: _ -> None))
   | ShlZ ->
     let o0 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop ShlZ))
     in
     Some (fun args0 ->
     match args0 with
     | [] -> None
     | x :: l ->
       (match l with
        | [] -> None
        | y :: l0 ->
          (match l0 with
           | [] -> Obj.magic o0 (x ()) (y ())
           | _ :: _ -> None)))
   | ShrZ ->
     let o0 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop ShrZ))
     in
     Some (fun args0 ->
     match args0 with
     | [] -> None
     | x :: l ->
       (match l with
        | [] -> None
        | y :: l0 ->
          (match l0 with
           | [] -> Obj.magic o0 (x ()) (y ())
           | _ :: _ -> None)))
   | AndZ ->
     let o0 = AndZ in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
       (Obj.magic id0) }) (unthunk args0))
   | OrZ ->
     let o0 = OrZ in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
       (Obj.magic id0) }) (unthunk args0))
   | XorZ ->
     let o0 = XorZ in
     let id0 = invert_Some (identity o0) in
     let o1 =
       Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
         shiftr_avoid_uint1_opt_instance_0 true (Compilers.Coq_type.Coq_arrow
         ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
         (Compilers.Coq_type.Coq_base
         (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
         (Obj.magic invert_Some (op_to_PHOAS_binop o0))
     in
     Some (fun args0 ->
     fold_right (Obj.magic o1) (Some { lower = (Obj.magic id0); upper =
       (Obj.magic id0) }) (unthunk args0))
   | AddcarryZ _ -> None
   | SubborrowZ _ -> None)

(** val bound_node_idx_via_PHOAS :
    (idx -> zrange option) -> idx node0 -> zrange option **)

let bound_node_idx_via_PHOAS lookup_bounds0 = function
| (o, args0) ->
  bind (op_to_PHOAS_bounds o) (fun b ->
    b (map (fun idx0 pat -> let () = pat in lookup_bounds0 idx0) args0))

type description = ((unit -> char list) * bool) option

type eager_description = (char list * bool) option

module Old =
 struct
  module Coq_dag =
   struct
    module Coq__8 = struct
     type t = ((idx node0 * description) * zrange option) list
    end
    include Coq__8

    (** val empty : t **)

    let empty =
      []

    (** val size : t -> n **)

    let size d =
      Coq_N.of_nat (length d)

    (** val lookup : t -> idx -> idx node0 option **)

    let lookup d i =
      option_map (fun pat -> let (y, _) = pat in let (n3, _) = y in n3)
        (nth_error d (Coq_N.to_nat i))

    (** val lookup_bounds : t -> idx -> zrange option **)

    let lookup_bounds d i =
      bind (nth_error d (Coq_N.to_nat i)) (fun n3 ->
        let (p, b) = n3 in let (_, _) = p in b)

    (** val reverse_lookup : t -> idx node0 -> idx option **)

    let reverse_lookup d i =
      option_map Coq_N.of_nat
        (Coq1_List.indexof (fun pat ->
          let (y, _) = pat in let (n', _) = y in node_beq Coq_N.eqb i n') d)

    (** val merge_node : description -> idx node0 -> t -> idx * t **)

    let merge_node descr n3 d =
      match reverse_lookup d n3 with
      | Some i -> (i, d)
      | None ->
        ((size d),
          (app d (((n3, descr),
            (bound_node_idx_via_PHOAS (lookup_bounds d) n3)) :: [])))

    (** val gensym : operationSize -> t -> idx node0 **)

    let gensym s0 d =
      ((Old (s0, (size d))), [])

    (** val get_eager_description_description :
        eager_description -> char list option **)

    let get_eager_description_description d =
      option_map fst d

    (** val get_eager_description_always_show : eager_description -> bool **)

    let get_eager_description_always_show = function
    | Some p -> let (_, always_show) = p in always_show
    | None -> false

    (** val force_description : description -> eager_description **)

    let force_description =
      option_map (fun pat ->
        let (descr, always_show) = pat in ((descr ()), always_show))

    type 't coq_M = t -> 't * t

    (** val bind : 'a1 coq_M -> ('a1 -> 'a2 coq_M) -> 'a2 coq_M **)

    let bind v f d =
      let (v0, d0) = v d in f v0 d0

    (** val ret : 'a1 -> 'a1 coq_M **)

    let ret v d =
      (v, d)

    module Coq_eager =
     struct
      type t = ((idx * idx node0) * eager_description) list

      (** val force : Coq__8.t -> t **)

      let force d =
        map (fun pat ->
          let (idx0, y) = pat in
          let (y0, _) = y in
          let (n3, descr) = y0 in
          (((Coq_N.of_nat idx0), n3), (force_description descr)))
          (List.enumerate d)

      (** val description_lookup : t -> char list -> idx list **)

      let description_lookup d descr =
        map (fun pat -> let (y, _) = pat in let (idx0, _) = y in idx0)
          (filter (fun pat ->
            let (y, descr') = pat in
            let (_, _) = y in
            (match get_eager_description_description descr' with
             | Some descr'0 -> eqb0 descr descr'0
             | None -> false)) d)

      (** val elements : t -> ((idx * idx node0) * eager_description) list **)

      let elements d =
        d
     end
   end
 end

(** val reveal_step : Old.Coq_dag.t -> (idx -> expr0) -> idx -> expr0 **)

let reveal_step dag reveal1 i =
  match Old.Coq_dag.lookup dag i with
  | Some n3 -> let (op1, args0) = n3 in ExprApp (op1, (map reveal1 args0))
  | None -> ExprRef i

(** val reveal : Old.Coq_dag.t -> nat -> idx -> expr0 **)

let reveal dag =
  let rec reveal1 n3 i =
    match n3 with
    | O -> ExprRef i
    | S n4 -> reveal_step dag (reveal1 n4) i
  in reveal1

(** val reveal_gather_deps_args : Old.Coq_dag.t -> NSet.t -> NSet.t **)

let reveal_gather_deps_args dag ls =
  fold_right (fun i so_far ->
    match Old.Coq_dag.lookup dag i with
    | Some n3 -> let (_, args0) = n3 in fold_right NSet.add so_far args0
    | None -> so_far) NSet.empty (NSet.elements ls)

(** val reveal_gather_deps_step :
    Old.Coq_dag.t -> (NSet.t -> NSet.t -> NSet.t) -> NSet.t -> NSet.t ->
    NSet.t **)

let reveal_gather_deps_step dag reveal_gather_deps0 so_far new_idxs =
  let new_idxs0 = NSet.diff new_idxs so_far in
  if NSet.is_empty new_idxs0
  then so_far
  else reveal_gather_deps0 (NSet.union so_far new_idxs0)
         (reveal_gather_deps_args dag new_idxs0)

(** val reveal_gather_deps_list :
    Old.Coq_dag.t -> nat -> NSet.t -> NSet.t -> NSet.t **)

let reveal_gather_deps_list dag =
  let rec reveal_gather_deps_list0 n3 so_far new_idxs =
    match n3 with
    | O -> NSet.union so_far new_idxs
    | S n4 ->
      reveal_gather_deps_step dag (reveal_gather_deps_list0 n4) so_far
        new_idxs
  in reveal_gather_deps_list0

(** val reveal_gather_deps : Old.Coq_dag.t -> nat -> idx -> NSet.t **)

let reveal_gather_deps dag n3 i =
  reveal_gather_deps_list dag n3 NSet.empty (NSet.singleton i)

(** val reveal_step_from_deps :
    Old.Coq_dag.t -> (idx -> expr0) -> NSet.t -> idx -> expr0 **)

let reveal_step_from_deps dag reveal1 deps i =
  if NSet.mem i deps
  then (match Old.Coq_dag.lookup dag i with
        | Some n3 ->
          let (op1, args0) = n3 in ExprApp (op1, (map reveal1 args0))
        | None -> ExprRef i)
  else ExprRef i

(** val reveal_from_deps_fueled :
    Old.Coq_dag.t -> nat -> NSet.t -> idx -> expr0 **)

let reveal_from_deps_fueled dag =
  let rec reveal_from_deps_fueled0 fuel0 deps i =
    match fuel0 with
    | O -> ExprRef i
    | S fuel1 ->
      reveal_step_from_deps dag (reveal_from_deps_fueled0 fuel1 deps) deps i
  in reveal_from_deps_fueled0

(** val reveal_at_least : Old.Coq_dag.t -> nat -> idx -> expr0 **)

let reveal_at_least dag n3 i =
  reveal_from_deps_fueled dag (S (Coq_N.to_nat (Old.Coq_dag.size dag)))
    (reveal_gather_deps dag n3 i) i

(** val reveal_node_at_least :
    Old.Coq_dag.t -> nat -> (op0 * idx list) -> expr0 **)

let reveal_node_at_least dag n3 = function
| (op1, args0) -> ExprApp (op1, (map (reveal_at_least dag n3) args0))

(** val merge_node0 : description -> idx node0 -> idx Old.Coq_dag.coq_M **)

let merge_node0 =
  Old.Coq_dag.merge_node

(** val merge0 :
    description -> expr0 -> Old.Coq_dag.t -> idx * Old.Coq_dag.t **)

let rec merge0 descr e d =
  match e with
  | ExprRef i -> (i, d)
  | ExprApp n3 ->
    let (op1, args0) = n3 in
    let idxs_d = Coq0_List.foldmap (merge0 descr) args0 d in
    let idxs0 =
      if commutative op1 then Coq1_N.Sort.sort (fst idxs_d) else fst idxs_d
    in
    merge_node0 descr (op1, idxs0) (snd idxs_d)

(** val zconst : n -> z -> op0 **)

let zconst s0 z0 =
  Const0 (Coq_Z.coq_land z0 (Coq_Z.ones (Coq_Z.of_N s0)))

(** val interp_expr : (symbol -> z option) -> expr0 -> z option **)

let interp_expr ctx =
  let rec interp_expr0 = function
  | ExprRef _ -> None
  | ExprApp n3 ->
    let (o, arges) = n3 in
    bind (Option.List.lift (map interp_expr0 arges)) (fun args0 ->
      interp_op ctx o args0)
  in interp_expr0

(** val interp0_expr : expr0 -> z option **)

let interp0_expr =
  interp_expr (fun _ -> None)

(** val bound_expr_via_PHOAS : Old.Coq_dag.t -> expr0 -> zrange option **)

let rec bound_expr_via_PHOAS d = function
| ExprRef i -> Old.Coq_dag.lookup_bounds d i
| ExprApp n3 ->
  let (o, args0) = n3 in
  (match op_to_PHOAS_bounds o with
   | Some o0 ->
     o0 (map (fun e0 pat -> let () = pat in bound_expr_via_PHOAS d e0) args0)
   | None -> None)

(** val isCst : expr0 -> bool **)

let isCst = function
| ExprRef _ -> false
| ExprApp n3 ->
  let (o, l) = n3 in
  (match o with
   | Old (_, _) -> false
   | Const0 _ -> (match l with
                  | [] -> true
                  | _ :: _ -> false)
   | Add0 _ -> false
   | Addcarry _ -> false
   | Subborrow _ -> false
   | Addoverflow _ -> false
   | Neg1 _ -> false
   | Shl0 _ -> false
   | Shr0 _ -> false
   | Sar0 _ -> false
   | Rcr0 _ -> false
   | And0 _ -> false
   | Or0 _ -> false
   | Xor0 _ -> false
   | Slice (_, _) -> false
   | Mul0 _ -> false
   | Set_slice (_, _) -> false
   | Selectznz -> false
   | Iszero -> false
   | AddZ -> false
   | MulZ -> false
   | NegZ -> false
   | ShlZ -> false
   | ShrZ -> false
   | AndZ -> false
   | OrZ -> false
   | XorZ -> false
   | AddcarryZ _ -> false
   | SubborrowZ _ -> false)

module Rewrite =
 struct
  (** val slice0 : Old.Coq_dag.t -> expr0 -> expr0 **)

  let slice0 _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o0, l) = n3 in
    (match o0 with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (lo, s0) ->
       (match lo with
        | N0 ->
          (match l with
           | [] -> e
           | e0 :: l0 ->
             (match e0 with
              | ExprRef _ -> e
              | ExprApp n4 ->
                let (o, args0) = n4 in
                (match o with
                 | Old (_, _) -> e
                 | Const0 _ -> e
                 | Add0 _ -> e
                 | Addcarry _ -> e
                 | Subborrow _ -> e
                 | Addoverflow _ -> e
                 | Neg1 _ -> e
                 | Shl0 _ -> e
                 | Shr0 _ -> e
                 | Sar0 _ -> e
                 | Rcr0 _ -> e
                 | And0 _ -> e
                 | Or0 _ -> e
                 | Xor0 _ -> e
                 | Slice (_, _) -> e
                 | Mul0 _ -> e
                 | Set_slice (_, _) -> e
                 | Selectznz -> e
                 | Iszero -> e
                 | AddZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | MulZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | NegZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | ShlZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | ShrZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | AndZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | OrZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | XorZ ->
                   (match l0 with
                    | [] ->
                      ExprApp
                        ((match o with
                          | Old (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Const0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Add0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addcarry _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Subborrow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Addoverflow _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Neg1 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shl0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Shr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Sar0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Rcr0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | And0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Or0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Xor0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Mul0 _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Set_slice (_, _) ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Selectznz ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | Iszero ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | AddZ -> Add0 s0
                          | MulZ -> Mul0 s0
                          | NegZ -> Neg1 s0
                          | ShlZ -> Shl0 s0
                          | ShrZ -> Shr0 s0
                          | AndZ -> And0 s0
                          | OrZ -> Or0 s0
                          | XorZ -> Xor0 s0
                          | AddcarryZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))
                          | SubborrowZ _ ->
                            Old (N0, (Npos (XI (XI (XI (XI (XI (XI (XO (XO
                              (XO (XI (XO (XO (XO (XO (XI (XO (XI (XI (XI
                              XH)))))))))))))))))))))), args0)
                    | _ :: _ -> e)
                 | AddcarryZ _ -> e
                 | SubborrowZ _ -> e)))
        | Npos _ -> e)
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val slice01_addcarryZ : Old.Coq_dag.t -> expr0 -> expr0 **)

  let slice01_addcarryZ _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (lo, sz) ->
       (match lo with
        | N0 ->
          (match sz with
           | N0 -> e
           | Npos p ->
             (match p with
              | XI _ -> e
              | XO _ -> e
              | XH ->
                (match l with
                 | [] -> e
                 | e0 :: l0 ->
                   (match e0 with
                    | ExprRef _ -> e
                    | ExprApp n4 ->
                      let (o0, args0) = n4 in
                      (match o0 with
                       | Old (_, _) -> e
                       | Const0 _ -> e
                       | Add0 _ -> e
                       | Addcarry _ -> e
                       | Subborrow _ -> e
                       | Addoverflow _ -> e
                       | Neg1 _ -> e
                       | Shl0 _ -> e
                       | Shr0 _ -> e
                       | Sar0 _ -> e
                       | Rcr0 _ -> e
                       | And0 _ -> e
                       | Or0 _ -> e
                       | Xor0 _ -> e
                       | Slice (_, _) -> e
                       | Mul0 _ -> e
                       | Set_slice (_, _) -> e
                       | Selectznz -> e
                       | Iszero -> e
                       | AddZ -> e
                       | MulZ -> e
                       | NegZ -> e
                       | ShlZ -> e
                       | ShrZ -> e
                       | AndZ -> e
                       | OrZ -> e
                       | XorZ -> e
                       | AddcarryZ s0 ->
                         (match l0 with
                          | [] -> ExprApp ((Addcarry s0), args0)
                          | _ :: _ -> e)
                       | SubborrowZ _ -> e)))))
        | Npos _ -> e)
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val slice01_subborrowZ : Old.Coq_dag.t -> expr0 -> expr0 **)

  let slice01_subborrowZ _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (lo, sz) ->
       (match lo with
        | N0 ->
          (match sz with
           | N0 -> e
           | Npos p ->
             (match p with
              | XI _ -> e
              | XO _ -> e
              | XH ->
                (match l with
                 | [] -> e
                 | e0 :: l0 ->
                   (match e0 with
                    | ExprRef _ -> e
                    | ExprApp n4 ->
                      let (o0, args0) = n4 in
                      (match o0 with
                       | Old (_, _) -> e
                       | Const0 _ -> e
                       | Add0 _ -> e
                       | Addcarry _ -> e
                       | Subborrow _ -> e
                       | Addoverflow _ -> e
                       | Neg1 _ -> e
                       | Shl0 _ -> e
                       | Shr0 _ -> e
                       | Sar0 _ -> e
                       | Rcr0 _ -> e
                       | And0 _ -> e
                       | Or0 _ -> e
                       | Xor0 _ -> e
                       | Slice (_, _) -> e
                       | Mul0 _ -> e
                       | Set_slice (_, _) -> e
                       | Selectznz -> e
                       | Iszero -> e
                       | AddZ -> e
                       | MulZ -> e
                       | NegZ -> e
                       | ShlZ -> e
                       | ShrZ -> e
                       | AndZ -> e
                       | OrZ -> e
                       | XorZ -> e
                       | AddcarryZ _ -> e
                       | SubborrowZ s0 ->
                         (match l0 with
                          | [] -> ExprApp ((Subborrow s0), args0)
                          | _ :: _ -> e))))))
        | Npos _ -> e)
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val slice_set_slice : Old.Coq_dag.t -> expr0 -> expr0 **)

  let slice_set_slice _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (lo, s1) ->
       (match lo with
        | N0 ->
          (match l with
           | [] -> e
           | e0 :: l0 ->
             (match e0 with
              | ExprRef _ -> e
              | ExprApp n4 ->
                let (o0, l1) = n4 in
                (match o0 with
                 | Old (_, _) -> e
                 | Const0 _ -> e
                 | Add0 _ -> e
                 | Addcarry _ -> e
                 | Subborrow _ -> e
                 | Addoverflow _ -> e
                 | Neg1 _ -> e
                 | Shl0 _ -> e
                 | Shr0 _ -> e
                 | Sar0 _ -> e
                 | Rcr0 _ -> e
                 | And0 _ -> e
                 | Or0 _ -> e
                 | Xor0 _ -> e
                 | Slice (_, _) -> e
                 | Mul0 _ -> e
                 | Set_slice (lo0, s2) ->
                   (match lo0 with
                    | N0 ->
                      (match l1 with
                       | [] -> e
                       | _ :: l2 ->
                         (match l2 with
                          | [] -> e
                          | e' :: l3 ->
                            (match l3 with
                             | [] ->
                               (match l0 with
                                | [] ->
                                  if Coq_N.leb s1 s2
                                  then ExprApp ((Slice (N0, s1)), (e' :: []))
                                  else e
                                | _ :: _ -> e)
                             | _ :: _ -> e)))
                    | Npos _ -> e)
                 | Selectznz -> e
                 | Iszero -> e
                 | AddZ -> e
                 | MulZ -> e
                 | NegZ -> e
                 | ShlZ -> e
                 | ShrZ -> e
                 | AndZ -> e
                 | OrZ -> e
                 | XorZ -> e
                 | AddcarryZ _ -> e
                 | SubborrowZ _ -> e)))
        | Npos _ -> e)
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val set_slice_set_slice : Old.Coq_dag.t -> expr0 -> expr0 **)

  let set_slice_set_slice _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (lo1, s1) ->
       (match l with
        | [] -> e
        | e0 :: l0 ->
          (match e0 with
           | ExprRef _ -> e
           | ExprApp n4 ->
             let (o0, l1) = n4 in
             (match o0 with
              | Old (_, _) -> e
              | Const0 _ -> e
              | Add0 _ -> e
              | Addcarry _ -> e
              | Subborrow _ -> e
              | Addoverflow _ -> e
              | Neg1 _ -> e
              | Shl0 _ -> e
              | Shr0 _ -> e
              | Sar0 _ -> e
              | Rcr0 _ -> e
              | And0 _ -> e
              | Or0 _ -> e
              | Xor0 _ -> e
              | Slice (_, _) -> e
              | Mul0 _ -> e
              | Set_slice (lo2, s2) ->
                (match l1 with
                 | [] -> e
                 | x :: l2 ->
                   (match l2 with
                    | [] -> e
                    | _ :: l3 ->
                      (match l3 with
                       | [] ->
                         (match l0 with
                          | [] -> e
                          | y :: l4 ->
                            (match l4 with
                             | [] ->
                               if (&&) (Coq_N.eqb lo1 lo2) (Coq_N.leb s2 s1)
                               then ExprApp ((Set_slice (lo1, s1)),
                                      (x :: (y :: [])))
                               else e
                             | _ :: _ -> e))
                       | _ :: _ -> e)))
              | Selectznz -> e
              | Iszero -> e
              | AddZ -> e
              | MulZ -> e
              | NegZ -> e
              | ShlZ -> e
              | ShrZ -> e
              | AndZ -> e
              | OrZ -> e
              | XorZ -> e
              | AddcarryZ _ -> e
              | SubborrowZ _ -> e)))
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val set_slice0_small : Old.Coq_dag.t -> expr0 -> expr0 **)

  let set_slice0_small d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (lo, s0) ->
       (match lo with
        | N0 ->
          (match l with
           | [] -> e
           | x :: l0 ->
             (match l0 with
              | [] -> e
              | y :: l1 ->
                (match l1 with
                 | [] ->
                   (match bound_expr_via_PHOAS d x with
                    | Some a ->
                      (match bound_expr_via_PHOAS d y with
                       | Some b ->
                         if (&&)
                              ((&&)
                                ((&&) (Coq_Z.leb Z0 a.lower)
                                  (Coq_Z.leb Z0 b.lower))
                                (Coq_Z.leb a.upper
                                  (Coq_Z.ones (Coq_Z.of_N s0))))
                              (Coq_Z.leb b.upper (Coq_Z.ones (Coq_Z.of_N s0)))
                         then y
                         else e
                       | None -> e)
                    | None -> e)
                 | _ :: _ -> e)))
        | Npos _ -> e)
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val truncate_small : Old.Coq_dag.t -> expr0 -> expr0 **)

  let truncate_small d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (lo, s0) ->
       (match lo with
        | N0 ->
          (match l with
           | [] -> e
           | e' :: l0 ->
             (match l0 with
              | [] ->
                (match bound_expr_via_PHOAS d e' with
                 | Some b ->
                   if (&&) (Coq_Z.leb Z0 b.lower)
                        (Coq_Z.leb b.upper (Coq_Z.ones (Coq_Z.of_N s0)))
                   then e'
                   else e
                 | None -> e)
              | _ :: _ -> e))
        | Npos _ -> e)
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val addcarry_bit : Old.Coq_dag.t -> expr0 -> expr0 **)

  let addcarry_bit d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry s0 ->
       (match l with
        | [] -> e
        | e0 :: l0 ->
          (match e0 with
           | ExprRef _ -> e
           | ExprApp n4 ->
             let (o0, l1) = n4 in
             (match o0 with
              | Old (_, _) -> e
              | Const0 a ->
                (match l1 with
                 | [] ->
                   (match l0 with
                    | [] -> e
                    | b :: l2 ->
                      (match l2 with
                       | [] ->
                         if option_beq zrange_beq (bound_expr_via_PHOAS d b)
                              (Some { lower = Z0; upper = (Zpos XH) })
                         then (match interp0_op (Addcarry s0)
                                       (a :: (Z0 :: [])) with
                               | Some z0 ->
                                 (match z0 with
                                  | Z0 ->
                                    (match interp0_op (Addcarry s0)
                                             (a :: ((Zpos XH) :: [])) with
                                     | Some z1 ->
                                       (match z1 with
                                        | Z0 -> ExprApp ((Const0 Z0), [])
                                        | Zpos p ->
                                          (match p with
                                           | XI _ -> e
                                           | XO _ -> e
                                           | XH -> b)
                                        | Zneg _ -> e)
                                     | None -> e)
                                  | Zpos _ -> e
                                  | Zneg _ -> e)
                               | None -> e)
                         else e
                       | _ :: _ -> e))
                 | _ :: _ -> e)
              | Add0 _ -> e
              | Addcarry _ -> e
              | Subborrow _ -> e
              | Addoverflow _ -> e
              | Neg1 _ -> e
              | Shl0 _ -> e
              | Shr0 _ -> e
              | Sar0 _ -> e
              | Rcr0 _ -> e
              | And0 _ -> e
              | Or0 _ -> e
              | Xor0 _ -> e
              | Slice (_, _) -> e
              | Mul0 _ -> e
              | Set_slice (_, _) -> e
              | Selectznz -> e
              | Iszero -> e
              | AddZ -> e
              | MulZ -> e
              | NegZ -> e
              | ShlZ -> e
              | ShrZ -> e
              | AndZ -> e
              | OrZ -> e
              | XorZ -> e
              | AddcarryZ _ -> e
              | SubborrowZ _ -> e)))
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val addoverflow_bit : Old.Coq_dag.t -> expr0 -> expr0 **)

  let addoverflow_bit d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow s0 ->
       (match l with
        | [] -> e
        | e0 :: l0 ->
          (match e0 with
           | ExprRef _ -> e
           | ExprApp n4 ->
             let (o0, l1) = n4 in
             (match o0 with
              | Old (_, _) -> e
              | Const0 a ->
                (match l1 with
                 | [] ->
                   (match l0 with
                    | [] -> e
                    | b :: l2 ->
                      (match l2 with
                       | [] ->
                         if option_beq zrange_beq (bound_expr_via_PHOAS d b)
                              (Some { lower = Z0; upper = (Zpos XH) })
                         then (match interp0_op (Addoverflow s0)
                                       (a :: (Z0 :: [])) with
                               | Some z0 ->
                                 (match z0 with
                                  | Z0 ->
                                    (match interp0_op (Addoverflow s0)
                                             (a :: ((Zpos XH) :: [])) with
                                     | Some z1 ->
                                       (match z1 with
                                        | Z0 -> ExprApp ((Const0 Z0), [])
                                        | Zpos p ->
                                          (match p with
                                           | XI _ -> e
                                           | XO _ -> e
                                           | XH -> b)
                                        | Zneg _ -> e)
                                     | None -> e)
                                  | Zpos _ -> e
                                  | Zneg _ -> e)
                               | None -> e)
                         else e
                       | _ :: _ -> e))
                 | _ :: _ -> e)
              | Add0 _ -> e
              | Addcarry _ -> e
              | Subborrow _ -> e
              | Addoverflow _ -> e
              | Neg1 _ -> e
              | Shl0 _ -> e
              | Shr0 _ -> e
              | Sar0 _ -> e
              | Rcr0 _ -> e
              | And0 _ -> e
              | Or0 _ -> e
              | Xor0 _ -> e
              | Slice (_, _) -> e
              | Mul0 _ -> e
              | Set_slice (_, _) -> e
              | Selectznz -> e
              | Iszero -> e
              | AddZ -> e
              | MulZ -> e
              | NegZ -> e
              | ShlZ -> e
              | ShrZ -> e
              | AndZ -> e
              | OrZ -> e
              | XorZ -> e
              | AddcarryZ _ -> e
              | SubborrowZ _ -> e)))
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val addbyte_small : Old.Coq_dag.t -> expr0 -> expr0 **)

  let addbyte_small d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 s0 ->
       (match s0 with
        | N0 -> e
        | Npos p ->
          (match p with
           | XI _ -> e
           | XO p0 ->
             (match p0 with
              | XI _ -> e
              | XO p1 ->
                (match p1 with
                 | XI _ -> e
                 | XO p2 ->
                   (match p2 with
                    | XI _ -> e
                    | XO _ -> e
                    | XH ->
                      (match Option.List.lift
                               (map (bound_expr_via_PHOAS d) args0) with
                       | Some bounds1 ->
                         if (&&)
                              (Coq_Z.leb Z0
                                (fold_right Coq_Z.add Z0
                                  (map (fun z0 -> z0.lower) bounds1)))
                              (Coq_Z.leb
                                (fold_right Coq_Z.add Z0
                                  (map (fun z0 -> z0.upper) bounds1))
                                (Coq_Z.ones (Coq_Z.of_N s0)))
                         then ExprApp ((Add0 (Npos (XO (XO (XO (XO (XO (XO
                                XH)))))))), args0)
                         else e
                       | None -> e))
                 | XH -> e)
              | XH -> e)
           | XH -> e))
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val addcarry_small : Old.Coq_dag.t -> expr0 -> expr0 **)

  let addcarry_small d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry s0 ->
       (match Option.List.lift (map (bound_expr_via_PHOAS d) args0) with
        | Some bounds1 ->
          if (&&)
               (Coq_Z.leb Z0
                 (fold_right Coq_Z.add Z0 (map (fun z0 -> z0.lower) bounds1)))
               (Coq_Z.leb
                 (fold_right Coq_Z.add Z0 (map (fun z0 -> z0.upper) bounds1))
                 (Coq_Z.ones (Coq_Z.of_N s0)))
          then ExprApp ((Const0 Z0), [])
          else e
        | None -> e)
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val addoverflow_small : Old.Coq_dag.t -> expr0 -> expr0 **)

  let addoverflow_small d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow s0 ->
       (match args0 with
        | [] -> e
        | _ :: l ->
          (match l with
           | [] ->
             (match Option.List.lift (map (bound_expr_via_PHOAS d) args0) with
              | Some bounds1 ->
                if (&&)
                     (forallb (Coq_Z.leb Z0)
                       (map (fun z0 -> z0.lower) bounds1))
                     (Coq_Z.leb
                       (fold_right Coq_Z.add Z0
                         (map (fun z0 -> z0.upper) bounds1))
                       (Coq_Z.ones (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))))
                then ExprApp ((Const0 Z0), [])
                else e
              | None -> e)
           | _ :: l0 ->
             (match l0 with
              | [] ->
                (match Option.List.lift (map (bound_expr_via_PHOAS d) args0) with
                 | Some bounds1 ->
                   if (&&)
                        (forallb (Coq_Z.leb Z0)
                          (map (fun z0 -> z0.lower) bounds1))
                        (Coq_Z.leb
                          (fold_right Coq_Z.add Z0
                            (map (fun z0 -> z0.upper) bounds1))
                          (Coq_Z.ones (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))))
                   then ExprApp ((Const0 Z0), [])
                   else e
                 | None -> e)
              | _ :: l1 ->
                (match l1 with
                 | [] ->
                   (match Option.List.lift
                            (map (bound_expr_via_PHOAS d) args0) with
                    | Some bounds1 ->
                      if (&&)
                           (forallb (Coq_Z.leb Z0)
                             (map (fun z0 -> z0.lower) bounds1))
                           (Coq_Z.leb
                             (fold_right Coq_Z.add Z0
                               (map (fun z0 -> z0.upper) bounds1))
                             (Coq_Z.ones
                               (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))))
                      then ExprApp ((Const0 Z0), [])
                      else e
                    | None -> e)
                 | _ :: _ -> e))))
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val constprop : Old.Coq_dag.t -> expr0 -> expr0 **)

  let constprop _ e =
    match interp0_expr e with
    | Some v -> ExprApp ((Const0 v), [])
    | None -> e

  (** val unary_truncate : Old.Coq_dag.t -> expr0 -> expr0 **)

  let unary_truncate _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match l with
     | [] -> e
     | x :: l0 ->
       (match l0 with
        | [] ->
          (match unary_truncate_size o with
           | Some z0 ->
             (match z0 with
              | Z0 -> ExprApp ((Const0 Z0), [])
              | Zpos p -> ExprApp ((Slice (N0, (Npos p))), (x :: []))
              | Zneg p -> (match p with
                           | XI _ -> e
                           | XO _ -> e
                           | XH -> x))
           | None -> e)
        | _ :: _ -> e))

  (** val flatten_associative : Old.Coq_dag.t -> expr0 -> expr0 **)

  let flatten_associative _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    if associative o
    then ExprApp (o,
           (flat_map (fun e' ->
             match e' with
             | ExprRef _ -> e' :: []
             | ExprApp n4 ->
               let (o', args') = n4 in if op_beq o o' then args' else e' :: [])
             args0))
    else e

  (** val flatten_bounded_associative : Old.Coq_dag.t -> expr0 -> expr0 **)

  let flatten_bounded_associative d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    ExprApp (o,
    (flat_map (fun e' ->
      match e' with
      | ExprRef _ -> e' :: []
      | ExprApp n4 ->
        let (o', args') = n4 in
        (match bounds_for_drop_inner_associative o o' with
         | Some d0 ->
           (match d0 with
            | Drop_always -> args'
            | Drop_if_bounded (bound, o'') ->
              (match bound_expr_via_PHOAS d (ExprApp (o'', args')) with
               | Some ubound ->
                 if is_tighter_than_bool ubound bound then args' else e' :: []
               | None -> e' :: []))
         | None -> e' :: [])) args0))

  (** val consts_commutative : Old.Coq_dag.t -> expr0 -> expr0 **)

  let consts_commutative _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    if commutative o
    then let csts_exprs = partition isCst args0 in
         if associative o
         then (match interp0_expr (ExprApp (o, (fst csts_exprs))) with
               | Some v ->
                 ExprApp (o, ((ExprApp ((Const0 v), [])) :: (snd csts_exprs)))
               | None -> ExprApp (o, (app (fst csts_exprs) (snd csts_exprs))))
         else ExprApp (o, (app (fst csts_exprs) (snd csts_exprs)))
    else e

  (** val neqconst : z -> expr0 -> bool **)

  let neqconst i a =
    negb (option_beq Coq_Z.eqb (interp0_expr a) (Some i))

  (** val drop_identity : Old.Coq_dag.t -> expr0 -> expr0 **)

  let drop_identity _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    (match identity o with
     | Some i ->
       let args1 = filter (neqconst i) args0 in
       (match args1 with
        | [] -> ExprApp ((Const0 i), [])
        | _ :: _ -> ExprApp (o, args1))
     | None ->
       (match identity_after_0 o with
        | Some i ->
          (match args0 with
           | [] -> e
           | arg :: args1 ->
             let args2 = filter (neqconst i) args1 in
             ExprApp (o, (arg :: args2)))
        | None -> e))

  (** val fold_consts_to_and : Old.Coq_dag.t -> expr0 -> expr0 **)

  let fold_consts_to_and d e =
    match consts_commutative d e with
    | ExprRef _ -> e
    | ExprApp n3 ->
      let (o, l) = n3 in
      (match o with
       | Old (_, _) -> e
       | Const0 _ -> e
       | Add0 _ -> e
       | Addcarry _ -> e
       | Subborrow _ -> e
       | Addoverflow _ -> e
       | Neg1 _ -> e
       | Shl0 _ -> e
       | Shr0 _ -> e
       | Sar0 _ -> e
       | Rcr0 _ -> e
       | And0 _ ->
         (match l with
          | [] -> e
          | e0 :: args0 ->
            (match e0 with
             | ExprRef _ -> e
             | ExprApp n4 ->
               let (o0, l0) = n4 in
               (match o0 with
                | Old (_, _) -> e
                | Const0 v ->
                  (match l0 with
                   | [] ->
                     let v' =
                       match o with
                       | Old (_, _) -> v
                       | Const0 _ -> v
                       | Add0 _ -> v
                       | Addcarry _ -> v
                       | Subborrow _ -> v
                       | Addoverflow _ -> v
                       | Neg1 _ -> v
                       | Shl0 _ -> v
                       | Shr0 _ -> v
                       | Sar0 _ -> v
                       | Rcr0 _ -> v
                       | And0 sz ->
                         Coq_Z.coq_land v (Coq_Z.ones (Coq_Z.of_N sz))
                       | Or0 _ -> v
                       | Xor0 _ -> v
                       | Slice (_, _) -> v
                       | Mul0 _ -> v
                       | Set_slice (_, _) -> v
                       | Selectznz -> v
                       | Iszero -> v
                       | AddZ -> v
                       | MulZ -> v
                       | NegZ -> v
                       | ShlZ -> v
                       | ShrZ -> v
                       | AndZ -> v
                       | OrZ -> v
                       | XorZ -> v
                       | AddcarryZ _ -> v
                       | SubborrowZ _ -> v
                     in
                     if Coq_Z.ltb v' Z0
                     then if Coq_Z.eqb v' (Zneg XH)
                          then ExprApp (AndZ, args0)
                          else ExprApp (AndZ, ((ExprApp ((Const0 v'),
                                 [])) :: args0))
                     else if Coq_Z.eqb v' Z0
                          then ExprApp ((Const0 Z0), [])
                          else let v_sz = Coq_Z.add (Zpos XH) (Coq_Z.log2 v')
                               in
                               if Coq_Z.eqb v' (Coq_Z.ones v_sz)
                               then ExprApp ((And0 (Coq_Z.to_N v_sz)), args0)
                               else ExprApp ((And0 (Coq_Z.to_N v_sz)),
                                      ((ExprApp ((Const0 v'), [])) :: args0))
                   | _ :: _ -> e)
                | Add0 _ -> e
                | Addcarry _ -> e
                | Subborrow _ -> e
                | Addoverflow _ -> e
                | Neg1 _ -> e
                | Shl0 _ -> e
                | Shr0 _ -> e
                | Sar0 _ -> e
                | Rcr0 _ -> e
                | And0 _ -> e
                | Or0 _ -> e
                | Xor0 _ -> e
                | Slice (_, _) -> e
                | Mul0 _ -> e
                | Set_slice (_, _) -> e
                | Selectznz -> e
                | Iszero -> e
                | AddZ -> e
                | MulZ -> e
                | NegZ -> e
                | ShlZ -> e
                | ShrZ -> e
                | AndZ -> e
                | OrZ -> e
                | XorZ -> e
                | AddcarryZ _ -> e
                | SubborrowZ _ -> e)))
       | Or0 _ -> e
       | Xor0 _ -> e
       | Slice (_, _) -> e
       | Mul0 _ -> e
       | Set_slice (_, _) -> e
       | Selectznz -> e
       | Iszero -> e
       | AddZ -> e
       | MulZ -> e
       | NegZ -> e
       | ShlZ -> e
       | ShrZ -> e
       | AndZ ->
         (match l with
          | [] -> e
          | e0 :: args0 ->
            (match e0 with
             | ExprRef _ -> e
             | ExprApp n4 ->
               let (o0, l0) = n4 in
               (match o0 with
                | Old (_, _) -> e
                | Const0 v ->
                  (match l0 with
                   | [] ->
                     let v' =
                       match o with
                       | Old (_, _) -> v
                       | Const0 _ -> v
                       | Add0 _ -> v
                       | Addcarry _ -> v
                       | Subborrow _ -> v
                       | Addoverflow _ -> v
                       | Neg1 _ -> v
                       | Shl0 _ -> v
                       | Shr0 _ -> v
                       | Sar0 _ -> v
                       | Rcr0 _ -> v
                       | And0 sz ->
                         Coq_Z.coq_land v (Coq_Z.ones (Coq_Z.of_N sz))
                       | Or0 _ -> v
                       | Xor0 _ -> v
                       | Slice (_, _) -> v
                       | Mul0 _ -> v
                       | Set_slice (_, _) -> v
                       | Selectznz -> v
                       | Iszero -> v
                       | AddZ -> v
                       | MulZ -> v
                       | NegZ -> v
                       | ShlZ -> v
                       | ShrZ -> v
                       | AndZ -> v
                       | OrZ -> v
                       | XorZ -> v
                       | AddcarryZ _ -> v
                       | SubborrowZ _ -> v
                     in
                     if Coq_Z.ltb v' Z0
                     then if Coq_Z.eqb v' (Zneg XH)
                          then ExprApp (AndZ, args0)
                          else ExprApp (AndZ, ((ExprApp ((Const0 v'),
                                 [])) :: args0))
                     else if Coq_Z.eqb v' Z0
                          then ExprApp ((Const0 Z0), [])
                          else let v_sz = Coq_Z.add (Zpos XH) (Coq_Z.log2 v')
                               in
                               if Coq_Z.eqb v' (Coq_Z.ones v_sz)
                               then ExprApp ((And0 (Coq_Z.to_N v_sz)), args0)
                               else ExprApp ((And0 (Coq_Z.to_N v_sz)),
                                      ((ExprApp ((Const0 v'), [])) :: args0))
                   | _ :: _ -> e)
                | Add0 _ -> e
                | Addcarry _ -> e
                | Subborrow _ -> e
                | Addoverflow _ -> e
                | Neg1 _ -> e
                | Shl0 _ -> e
                | Shr0 _ -> e
                | Sar0 _ -> e
                | Rcr0 _ -> e
                | And0 _ -> e
                | Or0 _ -> e
                | Xor0 _ -> e
                | Slice (_, _) -> e
                | Mul0 _ -> e
                | Set_slice (_, _) -> e
                | Selectznz -> e
                | Iszero -> e
                | AddZ -> e
                | MulZ -> e
                | NegZ -> e
                | ShlZ -> e
                | ShrZ -> e
                | AndZ -> e
                | OrZ -> e
                | XorZ -> e
                | AddcarryZ _ -> e
                | SubborrowZ _ -> e)))
       | OrZ -> e
       | XorZ -> e
       | AddcarryZ _ -> e
       | SubborrowZ _ -> e)

  (** val xor_same : Old.Coq_dag.t -> expr0 -> expr0 **)

  let xor_same _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ -> e
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ ->
       (match l with
        | [] -> e
        | x :: l0 ->
          (match l0 with
           | [] -> e
           | y :: l1 ->
             (match l1 with
              | [] -> if expr_beq x y then ExprApp ((Const0 Z0), []) else e
              | _ :: _ -> e)))
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ -> e
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val shift_to_mul : Old.Coq_dag.t -> expr0 -> expr0 **)

  let shift_to_mul _ e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> e
     | Const0 _ -> e
     | Add0 _ -> e
     | Addcarry _ -> e
     | Subborrow _ -> e
     | Addoverflow _ -> e
     | Neg1 _ -> e
     | Shl0 _ ->
       (match l with
        | [] -> e
        | e' :: l0 ->
          (match l0 with
           | [] -> e
           | e0 :: l1 ->
             (match e0 with
              | ExprRef _ -> e
              | ExprApp n4 ->
                let (o0, l2) = n4 in
                (match o0 with
                 | Old (_, _) -> e
                 | Const0 v ->
                   (match l2 with
                    | [] ->
                      (match l1 with
                       | [] ->
                         let o' =
                           match o with
                           | Old (_, _) -> o
                           | Const0 _ -> o
                           | Add0 _ -> o
                           | Addcarry _ -> o
                           | Subborrow _ -> o
                           | Addoverflow _ -> o
                           | Neg1 _ -> o
                           | Shl0 bitwidth -> Mul0 bitwidth
                           | Shr0 _ -> o
                           | Sar0 _ -> o
                           | Rcr0 _ -> o
                           | And0 _ -> o
                           | Or0 _ -> o
                           | Xor0 _ -> o
                           | Slice (_, _) -> o
                           | Mul0 _ -> o
                           | Set_slice (_, _) -> o
                           | Selectznz -> o
                           | Iszero -> o
                           | AddZ -> o
                           | MulZ -> o
                           | NegZ -> o
                           | ShlZ -> MulZ
                           | ShrZ -> o
                           | AndZ -> o
                           | OrZ -> o
                           | XorZ -> o
                           | AddcarryZ _ -> o
                           | SubborrowZ _ -> o
                         in
                         let bw =
                           match o with
                           | Old (_, _) -> None
                           | Const0 _ -> None
                           | Add0 _ -> None
                           | Addcarry _ -> None
                           | Subborrow _ -> None
                           | Addoverflow _ -> None
                           | Neg1 _ -> None
                           | Shl0 bitwidth -> Some bitwidth
                           | Shr0 _ -> None
                           | Sar0 _ -> None
                           | Rcr0 _ -> None
                           | And0 _ -> None
                           | Or0 _ -> None
                           | Xor0 _ -> None
                           | Slice (_, _) -> None
                           | Mul0 _ -> None
                           | Set_slice (_, _) -> None
                           | Selectznz -> None
                           | Iszero -> None
                           | AddZ -> None
                           | MulZ -> None
                           | NegZ -> None
                           | ShlZ -> None
                           | ShrZ -> None
                           | AndZ -> None
                           | OrZ -> None
                           | XorZ -> None
                           | AddcarryZ _ -> None
                           | SubborrowZ _ -> None
                         in
                         if Coq_Z.eqb v Z0
                         then (match bw with
                               | Some o1 ->
                                 (match o1 with
                                  | N0 -> ExprApp ((Const0 Z0), [])
                                  | Npos p ->
                                    ExprApp ((Slice (N0, (Npos p))),
                                      (e' :: [])))
                               | None -> e')
                         else if Coq_Z.ltb Z0 v
                              then ExprApp (o', (e' :: ((ExprApp ((Const0
                                     (Coq_Z.pow (Zpos (XO XH)) v)),
                                     [])) :: [])))
                              else e
                       | _ :: _ -> e)
                    | _ :: _ -> e)
                 | Add0 _ -> e
                 | Addcarry _ -> e
                 | Subborrow _ -> e
                 | Addoverflow _ -> e
                 | Neg1 _ -> e
                 | Shl0 _ -> e
                 | Shr0 _ -> e
                 | Sar0 _ -> e
                 | Rcr0 _ -> e
                 | And0 _ -> e
                 | Or0 _ -> e
                 | Xor0 _ -> e
                 | Slice (_, _) -> e
                 | Mul0 _ -> e
                 | Set_slice (_, _) -> e
                 | Selectznz -> e
                 | Iszero -> e
                 | AddZ -> e
                 | MulZ -> e
                 | NegZ -> e
                 | ShlZ -> e
                 | ShrZ -> e
                 | AndZ -> e
                 | OrZ -> e
                 | XorZ -> e
                 | AddcarryZ _ -> e
                 | SubborrowZ _ -> e))))
     | Shr0 _ -> e
     | Sar0 _ -> e
     | Rcr0 _ -> e
     | And0 _ -> e
     | Or0 _ -> e
     | Xor0 _ -> e
     | Slice (_, _) -> e
     | Mul0 _ -> e
     | Set_slice (_, _) -> e
     | Selectznz -> e
     | Iszero -> e
     | AddZ -> e
     | MulZ -> e
     | NegZ -> e
     | ShlZ ->
       (match l with
        | [] -> e
        | e' :: l0 ->
          (match l0 with
           | [] -> e
           | e0 :: l1 ->
             (match e0 with
              | ExprRef _ -> e
              | ExprApp n4 ->
                let (o0, l2) = n4 in
                (match o0 with
                 | Old (_, _) -> e
                 | Const0 v ->
                   (match l2 with
                    | [] ->
                      (match l1 with
                       | [] ->
                         let o' =
                           match o with
                           | Old (_, _) -> o
                           | Const0 _ -> o
                           | Add0 _ -> o
                           | Addcarry _ -> o
                           | Subborrow _ -> o
                           | Addoverflow _ -> o
                           | Neg1 _ -> o
                           | Shl0 bitwidth -> Mul0 bitwidth
                           | Shr0 _ -> o
                           | Sar0 _ -> o
                           | Rcr0 _ -> o
                           | And0 _ -> o
                           | Or0 _ -> o
                           | Xor0 _ -> o
                           | Slice (_, _) -> o
                           | Mul0 _ -> o
                           | Set_slice (_, _) -> o
                           | Selectznz -> o
                           | Iszero -> o
                           | AddZ -> o
                           | MulZ -> o
                           | NegZ -> o
                           | ShlZ -> MulZ
                           | ShrZ -> o
                           | AndZ -> o
                           | OrZ -> o
                           | XorZ -> o
                           | AddcarryZ _ -> o
                           | SubborrowZ _ -> o
                         in
                         let bw =
                           match o with
                           | Old (_, _) -> None
                           | Const0 _ -> None
                           | Add0 _ -> None
                           | Addcarry _ -> None
                           | Subborrow _ -> None
                           | Addoverflow _ -> None
                           | Neg1 _ -> None
                           | Shl0 bitwidth -> Some bitwidth
                           | Shr0 _ -> None
                           | Sar0 _ -> None
                           | Rcr0 _ -> None
                           | And0 _ -> None
                           | Or0 _ -> None
                           | Xor0 _ -> None
                           | Slice (_, _) -> None
                           | Mul0 _ -> None
                           | Set_slice (_, _) -> None
                           | Selectznz -> None
                           | Iszero -> None
                           | AddZ -> None
                           | MulZ -> None
                           | NegZ -> None
                           | ShlZ -> None
                           | ShrZ -> None
                           | AndZ -> None
                           | OrZ -> None
                           | XorZ -> None
                           | AddcarryZ _ -> None
                           | SubborrowZ _ -> None
                         in
                         if Coq_Z.eqb v Z0
                         then (match bw with
                               | Some o1 ->
                                 (match o1 with
                                  | N0 -> ExprApp ((Const0 Z0), [])
                                  | Npos p ->
                                    ExprApp ((Slice (N0, (Npos p))),
                                      (e' :: [])))
                               | None -> e')
                         else if Coq_Z.ltb Z0 v
                              then ExprApp (o', (e' :: ((ExprApp ((Const0
                                     (Coq_Z.pow (Zpos (XO XH)) v)),
                                     [])) :: [])))
                              else e
                       | _ :: _ -> e)
                    | _ :: _ -> e)
                 | Add0 _ -> e
                 | Addcarry _ -> e
                 | Subborrow _ -> e
                 | Addoverflow _ -> e
                 | Neg1 _ -> e
                 | Shl0 _ -> e
                 | Shr0 _ -> e
                 | Sar0 _ -> e
                 | Rcr0 _ -> e
                 | And0 _ -> e
                 | Or0 _ -> e
                 | Xor0 _ -> e
                 | Slice (_, _) -> e
                 | Mul0 _ -> e
                 | Set_slice (_, _) -> e
                 | Selectznz -> e
                 | Iszero -> e
                 | AddZ -> e
                 | MulZ -> e
                 | NegZ -> e
                 | ShlZ -> e
                 | ShrZ -> e
                 | AndZ -> e
                 | OrZ -> e
                 | XorZ -> e
                 | AddcarryZ _ -> e
                 | SubborrowZ _ -> e))))
     | ShrZ -> e
     | AndZ -> e
     | OrZ -> e
     | XorZ -> e
     | AddcarryZ _ -> e
     | SubborrowZ _ -> e)

  (** val split_consts :
      Old.Coq_dag.t -> op0 -> z -> expr0 list -> (expr0 * z) list **)

  let split_consts _ o i =
    map (fun e ->
      match e with
      | ExprRef _ -> (e, i)
      | ExprApp n3 ->
        let (o', args0) = n3 in
        if op_beq o' o
        then let (csts, exprs) =
               if (&&) (commutative o') (associative o')
               then let (csts, exprs) = partition isCst args0 in
                    ((interp0_expr (ExprApp (o', csts))), exprs)
               else (match match args0 with
                           | [] -> None
                           | arg :: l ->
                             (match l with
                              | [] -> None
                              | e0 :: l0 ->
                                (match e0 with
                                 | ExprRef _ -> None
                                 | ExprApp n4 ->
                                   let (o0, _) = n4 in
                                   (match o0 with
                                    | Old (_, _) -> None
                                    | Const0 c0 ->
                                      (match l0 with
                                       | [] -> Some (c0, arg)
                                       | _ :: _ -> None)
                                    | Add0 _ -> None
                                    | Addcarry _ -> None
                                    | Subborrow _ -> None
                                    | Addoverflow _ -> None
                                    | Neg1 _ -> None
                                    | Shl0 _ -> None
                                    | Shr0 _ -> None
                                    | Sar0 _ -> None
                                    | Rcr0 _ -> None
                                    | And0 _ -> None
                                    | Or0 _ -> None
                                    | Xor0 _ -> None
                                    | Slice (_, _) -> None
                                    | Mul0 _ -> None
                                    | Set_slice (_, _) -> None
                                    | Selectznz -> None
                                    | Iszero -> None
                                    | AddZ -> None
                                    | MulZ -> None
                                    | NegZ -> None
                                    | ShlZ -> None
                                    | ShrZ -> None
                                    | AndZ -> None
                                    | OrZ -> None
                                    | XorZ -> None
                                    | AddcarryZ _ -> None
                                    | SubborrowZ _ -> None))) with
                     | Some p -> let (c0, arg) = p in ((Some c0), (arg :: []))
                     | None -> ((Some i), args0))
             in
             (match csts with
              | Some c0 ->
                (match exprs with
                 | [] -> ((ExprApp (o', exprs)), c0)
                 | arg :: l ->
                   (match l with
                    | [] -> (arg, c0)
                    | _ :: _ -> ((ExprApp (o', exprs)), c0)))
              | None -> (e, i))
        else (e, i))

  (** val group_consts :
      Old.Coq_dag.t -> (expr0 * z) list -> (expr0 * z list) list **)

  let group_consts _ ls =
    Option.List.map (fun xs ->
      match xs with
      | [] -> None
      | y :: xs0 -> let (e, z0) = y in Some (e, (z0 :: (map snd xs0))))
      (Coq_List.groupAllBy (fun x y -> expr_beq (fst x) (fst y)) ls)

  (** val compress_consts :
      Old.Coq_dag.t -> op0 -> (expr0 * z list) list -> (expr0 * z) list **)

  let compress_consts _ o ls =
    flat_map (fun pat ->
      let (e, zs) = pat in
      (match interp0_op o zs with
       | Some z0 -> (e, z0) :: []
       | None -> map (fun x -> (e, x)) zs)) ls

  (** val app_consts :
      Old.Coq_dag.t -> op0 -> (expr0 * z) list -> expr0 list **)

  let app_consts _ o ls =
    map (fun pat ->
      let (e, z0) = pat in
      let z1 = ExprApp ((Const0 z0), []) in
      let default0 = ExprApp (o, (e :: (z1 :: []))) in
      if associative o
      then (match e with
            | ExprRef _ -> default0
            | ExprApp n3 ->
              let (o', args0) = n3 in
              if op_beq o' o
              then ExprApp (o, (app args0 (z1 :: [])))
              else default0)
      else default0) ls

  (** val combine_consts_pre : Old.Coq_dag.t -> expr0 -> expr0 **)

  let combine_consts_pre d e = match e with
  | ExprRef _ -> e
  | ExprApp n3 ->
    let (o, args0) = n3 in
    if (&&) ((&&) (commutative o) (associative o)) (op_always_interps o)
    then (match combines_to o with
          | Some o' ->
            (match identity o' with
             | Some idv ->
               ExprApp (o,
                 (app_consts d o'
                   (compress_consts d o
                     (group_consts d (split_consts d o' idv args0)))))
             | None -> e)
          | None -> e)
    else e

  (** val cleanup_combine_consts : Old.Coq_dag.t -> expr0 -> expr0 **)

  let cleanup_combine_consts d =
    let simp_outside =
      fold_left (fun e f -> f e) ((flatten_associative d) :: [])
    in
    let simp_inside =
      fold_left (fun e f -> f e)
        ((constprop d) :: ((drop_identity d) :: ((unary_truncate d) :: (
        (truncate_small d) :: []))))
    in
    (fun e ->
    simp_outside
      (match e with
       | ExprRef _ -> e
       | ExprApp n3 ->
         let (o, args0) = n3 in ExprApp (o, (map simp_inside args0))))

  (** val combine_consts : Old.Coq_dag.t -> expr0 -> expr0 **)

  let combine_consts d e =
    cleanup_combine_consts d (combine_consts_pre d e)

  (** val named_pass :
      RewritePass.rewrite_pass -> Old.Coq_dag.t -> expr0 -> expr0 **)

  let named_pass = function
  | RewritePass.Coq_addbyte_small -> addbyte_small
  | RewritePass.Coq_addcarry_bit -> addcarry_bit
  | RewritePass.Coq_addcarry_small -> addcarry_small
  | RewritePass.Coq_addoverflow_bit -> addoverflow_bit
  | RewritePass.Coq_addoverflow_small -> addoverflow_small
  | RewritePass.Coq_combine_consts -> combine_consts
  | RewritePass.Coq_constprop -> constprop
  | RewritePass.Coq_consts_commutative -> consts_commutative
  | RewritePass.Coq_drop_identity -> drop_identity
  | RewritePass.Coq_flatten_associative -> flatten_associative
  | RewritePass.Coq_flatten_bounded_associative -> flatten_bounded_associative
  | RewritePass.Coq_fold_consts_to_and -> fold_consts_to_and
  | RewritePass.Coq_set_slice0_small -> set_slice0_small
  | RewritePass.Coq_set_slice_set_slice -> set_slice_set_slice
  | RewritePass.Coq_shift_to_mul -> shift_to_mul
  | RewritePass.Coq_slice0 -> slice0
  | RewritePass.Coq_slice01_addcarryZ -> slice01_addcarryZ
  | RewritePass.Coq_slice01_subborrowZ -> slice01_subborrowZ
  | RewritePass.Coq_slice_set_slice -> slice_set_slice
  | RewritePass.Coq_truncate_small -> truncate_small
  | RewritePass.Coq_unary_truncate -> unary_truncate
  | RewritePass.Coq_xor_same -> xor_same

  (** val expr :
      Options.rewriting_passes_opt -> Old.Coq_dag.t -> expr0 -> expr0 **)

  let expr rewriting_passes d =
    fold_left (fun e f -> f d e) (map named_pass rewriting_passes)
 end

(** val simplify :
    Options.symbolic_options_computed_opt -> Old.Coq_dag.t -> idx node0 ->
    expr0 **)

let simplify opts dag e =
  Rewrite.expr (Options.asm_rewriting_passes opts) dag
    (reveal_node_at_least dag (S (S (S O))) e)

type reg_state = idx option tuple

type flag_state = idx option tuple

type mem_state = (idx * idx) list

(** val get_flag : flag_state -> fLAG -> idx option **)

let get_flag st f =
  let (t0, ofv) = Obj.magic st in
  let (p, sfv) = t0 in
  let (p0, zfv) = p in
  let (p1, afv) = p0 in
  let (cfv, pfv) = p1 in
  (match f with
   | CF -> cfv
   | PF -> pfv
   | AF -> afv
   | ZF -> zfv
   | SF -> sfv
   | OF -> ofv)

(** val set_flag_internal : flag_state -> fLAG -> idx option -> flag_state **)

let set_flag_internal st f v =
  let (t0, ofv) = Obj.magic st in
  let (p, sfv) = t0 in
  let (p0, zfv) = p in
  let (p1, afv) = p0 in
  let (cfv, pfv) = p1 in
  Obj.magic
    ((((((match f with
          | CF -> v
          | PF -> cfv
          | AF -> cfv
          | ZF -> cfv
          | SF -> cfv
          | OF -> cfv),
    (match f with
     | CF -> pfv
     | PF -> v
     | AF -> pfv
     | ZF -> pfv
     | SF -> pfv
     | OF -> pfv)),
    (match f with
     | CF -> afv
     | PF -> afv
     | AF -> v
     | ZF -> afv
     | SF -> afv
     | OF -> afv)),
    (match f with
     | CF -> zfv
     | PF -> zfv
     | AF -> zfv
     | ZF -> v
     | SF -> zfv
     | OF -> zfv)),
    (match f with
     | CF -> sfv
     | PF -> sfv
     | AF -> sfv
     | ZF -> sfv
     | SF -> v
     | OF -> sfv)),
    (match f with
     | CF -> ofv
     | PF -> ofv
     | AF -> ofv
     | ZF -> ofv
     | SF -> ofv
     | OF -> v))

(** val set_flag : flag_state -> fLAG -> idx -> flag_state **)

let set_flag st f v =
  set_flag_internal st f (Some v)

(** val reverse_lookup_flag : flag_state -> idx -> fLAG option **)

let reverse_lookup_flag st i =
  option_map snd
    (find (fun v -> option_beq Coq_N.eqb (Some i) (fst v))
      (to_list (S (S (S (S (S (S O))))))
        (map1 (S (S (S (S (S (S O)))))) (fun x x0 -> (x, x0)) st
          (Obj.magic (((((CF, PF), AF), ZF), SF), OF)))))

(** val get_reg : reg_state -> nat -> idx option **)

let get_reg st ri =
  nth_default0 (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    O)))))))))))))))) None ri st

(** val set_reg : reg_state -> nat -> idx -> reg_state **)

let set_reg st ri i =
  from_list_default None (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    O))))))))))))))))
    (set_nth0 ri (Some i)
      (to_list (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))) st))

(** val reverse_lookup_widest_reg : reg_state -> idx -> rEG option **)

let reverse_lookup_widest_reg st i =
  option_map (fun v -> widest_register_of_index (fst v))
    (find (fun v -> option_beq Coq_N.eqb (Some i) (snd v))
      (List.enumerate
        (to_list (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))) st)))

(** val load : idx -> mem_state -> idx option **)

let load a s0 =
  option_map snd (find (fun p -> Coq_N.eqb (fst p) a) s0)

(** val remove0 : idx -> mem_state -> idx list * mem_state **)

let remove0 a s0 =
  let (vs, s1) = partition (fun p -> Coq_N.eqb (fst p) a) s0 in
  ((map snd vs), s1)

(** val store : idx -> idx -> mem_state -> mem_state option **)

let store a v s0 =
  bind (Coq1_List.indexof (fun p -> Coq_N.eqb (fst p) a) s0) (fun n3 -> Some
    (update_nth0 n3 (fun ptsto -> ((fst ptsto), v)) s0))

(** val reverse_lookup_mem : mem_state -> idx -> (n * idx) option **)

let reverse_lookup_mem st i =
  option_map (fun pat ->
    let (n3, y) = pat in let (_, ptsto) = y in ((Coq_N.of_nat n3), ptsto))
    (find (fun v -> Coq_N.eqb i (fst (snd v))) (List.enumerate st))

type symbolic_state = { dag_state : Old.Coq_dag.t;
                        symbolic_reg_state : reg_state;
                        symbolic_flag_state : flag_state;
                        symbolic_mem_state : mem_state }

(** val update_dag_with :
    symbolic_state -> (Old.Coq_dag.t -> Old.Coq_dag.t) -> symbolic_state **)

let update_dag_with st f =
  { dag_state = (f st.dag_state); symbolic_reg_state = st.symbolic_reg_state;
    symbolic_flag_state = st.symbolic_flag_state; symbolic_mem_state =
    st.symbolic_mem_state }

(** val update_reg_with :
    symbolic_state -> (reg_state -> reg_state) -> symbolic_state **)

let update_reg_with st f =
  { dag_state = st.dag_state; symbolic_reg_state = (f st.symbolic_reg_state);
    symbolic_flag_state = st.symbolic_flag_state; symbolic_mem_state =
    st.symbolic_mem_state }

(** val update_flag_with :
    symbolic_state -> (flag_state -> flag_state) -> symbolic_state **)

let update_flag_with st f =
  { dag_state = st.dag_state; symbolic_reg_state = st.symbolic_reg_state;
    symbolic_flag_state = (f st.symbolic_flag_state); symbolic_mem_state =
    st.symbolic_mem_state }

(** val update_mem_with :
    symbolic_state -> (mem_state -> mem_state) -> symbolic_state **)

let update_mem_with st f =
  { dag_state = st.dag_state; symbolic_reg_state = st.symbolic_reg_state;
    symbolic_flag_state = st.symbolic_flag_state; symbolic_mem_state =
    (f st.symbolic_mem_state) }

(** val show_reg_state : reg_state show **)

let show_reg_state st =
  show0
    (show_of_ShowLevel
      (show_lvl_list (show_lvl_prod show_lvl_REG Decimal.show_lvl_N)))
    (map (fun pat -> let (n3, v) = pat in ((widest_register_of_index n3), v))
      (Coq2_List.enumerate
        (Option.List.map (Obj.magic id)
          (to_list (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            O)))))))))))))))) st))))

(** val show_flag_state : flag_state show **)

let show_flag_state pat =
  let (t0, ofv) = Obj.magic pat in
  let (p, sfv) = t0 in
  let (p0, zfv) = p in
  let (p1, afv) = p0 in
  let (cfv, pfv) = p1 in
  append
    ('('::('*'::('f'::('l'::('a'::('g'::('_'::('s'::('t'::('a'::('t'::('e'::('*'::(')'::('('::('C'::('F'::('='::[]))))))))))))))))))
    (append
      (show0 (show_of_ShowLevel (show_lvl_option Decimal.show_lvl_N)) cfv)
      (append (' '::('P'::('F'::('='::[]))))
        (append
          (show0 (show_of_ShowLevel (show_lvl_option Decimal.show_lvl_N)) pfv)
          (append (' '::('A'::('F'::('='::[]))))
            (append
              (show0 (show_of_ShowLevel (show_lvl_option Decimal.show_lvl_N))
                afv)
              (append (' '::('Z'::('F'::('='::[]))))
                (append
                  (show0
                    (show_of_ShowLevel (show_lvl_option Decimal.show_lvl_N))
                    zfv)
                  (append (' '::('S'::('F'::('='::[]))))
                    (append
                      (show0
                        (show_of_ShowLevel
                          (show_lvl_option Decimal.show_lvl_N)) sfv)
                      (append (' '::('Z'::('F'::('='::[]))))
                        (append
                          (show0
                            (show_of_ShowLevel
                              (show_lvl_option Decimal.show_lvl_N)) zfv)
                          (append (' '::('O'::('F'::('='::[]))))
                            (append
                              (show0
                                (show_of_ShowLevel
                                  (show_lvl_option Decimal.show_lvl_N)) ofv)
                              (')'::[]))))))))))))))

(** val show_lines_dag : Old.Coq_dag.t showLines **)

let show_lines_dag d =
  app (('('::('*'::('d'::('a'::('g'::('*'::(')'::('['::[])))))))) :: [])
    (app
      (map (fun pat ->
        let (y, descr) = pat in
        let (i, v) = y in
        append ('('::('*'::[]))
          (append (show0 Decimal.show_N i)
            (append ('*'::(')'::(' '::[])))
              (append (show0 (show_node Decimal.show_N) v)
                (append (';'::[])
                  (if Old.Coq_dag.get_eager_description_always_show descr
                   then (match Old.Coq_dag.get_eager_description_description
                                 descr with
                         | Some descr0 ->
                           append (' '::[])
                             (append (tab::[])
                               (append ('('::('*'::[]))
                                 (append descr0 ('*'::(')'::[])))))
                         | None -> [])
                   else []))))))
        (Old.Coq_dag.Coq_eager.elements (Old.Coq_dag.Coq_eager.force d)))
      ((']'::[]) :: []))

(** val show_lines_mem_state : mem_state showLines **)

let show_lines_mem_state =
  show_lines_list
    (showLines_of_Show
      (show_of_ShowLevel
        (show_lvl_prod Decimal.show_lvl_N Decimal.show_lvl_N)))

(** val showLines_symbolic_state : symbolic_state showLines **)

let showLines_symbolic_state x =
  let { dag_state = ds; symbolic_reg_state = rs; symbolic_flag_state = fs;
    symbolic_mem_state = ms } = x
  in
  app
    (('('::('*'::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::('_'::('s'::('t'::('a'::('t'::('e'::('*'::(')'::(' '::('{'::('|'::[]))))))))))))))))))))) :: ((' '::(' '::('d'::('a'::('g'::('_'::('s'::('t'::('a'::('t'::('e'::(' '::(':'::('='::[])))))))))))))) :: []))
    (app (show_lines show_lines_dag ds)
      (app
        ((';'::[]) :: ((append
                         (' '::(' '::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::('_'::('r'::('e'::('g'::('_'::('s'::('t'::('a'::('t'::('e'::(' '::(':'::('='::(' '::[]))))))))))))))))))))))))
                         (append (show0 show_reg_state rs) (';'::[]))) :: (
        (append
          (' '::(' '::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::('_'::('f'::('l'::('a'::('g'::('_'::('s'::('t'::('a'::('t'::('e'::(' '::(':'::('='::(' '::[])))))))))))))))))))))))))
          (append (show0 show_flag_state fs) (';'::[]))) :: ((' '::(' '::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::('_'::('m'::('e'::('m'::('_'::('s'::('t'::('a'::('t'::('e'::(' '::(':'::('='::[]))))))))))))))))))))))) :: []))))
        (app (show_lines show_lines_mem_state ms)
          ((';'::[]) :: (('|'::('}'::[])) :: [])))))

module Coq_error =
 struct
  type error =
  | Coq_get_flag of fLAG * flag_state
  | Coq_get_reg of (nat, rEG) sum * reg_state
  | Coq_load of idx * symbolic_state
  | Coq_remove of idx * symbolic_state
  | Coq_remove_has_duplicates of idx * idx list * symbolic_state
  | Coq_store of idx * idx * symbolic_state
  | Coq_set_const of cONST * idx
  | Coq_expected_const of idx * expr0
  | Coq_unsupported_memory_access_size of n
  | Coq_unsupported_label_in_memory of char list
  | Coq_unsupported_label_argument of jUMP_LABEL
  | Coq_unimplemented_prefix of normalInstruction
  | Coq_unimplemented_instruction of normalInstruction
  | Coq_unsupported_line of rawLine
  | Coq_ambiguous_operation_size of normalInstruction

  (** val show_lines_error : error showLines **)

  let show_lines_error = function
  | Coq_get_flag (f, s0) ->
    (append
      ('I'::('n'::(' '::('f'::('l'::('a'::('g'::(' '::('s'::('t'::('a'::('t'::('e'::(' '::[]))))))))))))))
      (show_flag_state s0)) :: ((append ('F'::('l'::('a'::('g'::(' '::[])))))
                                  (append (show0 show_FLAG f)
                                    (' '::('w'::('a'::('s'::(' '::('r'::('e'::('a'::('d'::(' '::('w'::('i'::('t'::('h'::('o'::('u'::('t'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('s'::('e'::('t'::('.'::[])))))))))))))))))))))))))))))) :: [])
  | Coq_get_reg (r0, s0) ->
    (match r0 with
     | Inl i ->
       (append
         ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('r'::('e'::('g'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))))))))))))
         (Decimal.show_nat i)) :: []
     | Inr r1 ->
       (append
         ('I'::('n'::(' '::('r'::('e'::('g'::(' '::('s'::('t'::('a'::('t'::('e'::(' '::[])))))))))))))
         (show_reg_state s0)) :: ((append
                                    ('R'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::(' '::[])))))))))
                                    (append (show0 show_REG r1)
                                      (' '::('r'::('e'::('a'::('d'::(' '::('w'::('i'::('t'::('h'::('o'::('u'::('t'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('s'::('e'::('t'::('.'::[])))))))))))))))))))))))))) :: []))
  | Coq_load (a, s0) ->
    app
      (('I'::('n'::(' '::('m'::('e'::('m'::(' '::('s'::('t'::('a'::('t'::('e'::(':'::[]))))))))))))) :: [])
      (app (show_lines_mem_state s0.symbolic_mem_state)
        ((append ('I'::('n'::('d'::('e'::('x'::(' '::[]))))))
           (append (show0 Decimal.show_N a)
             (' '::('l'::('o'::('a'::('d'::('e'::('d'::(' '::('w'::('i'::('t'::('h'::('o'::('u'::('t'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('.'::[])))))))))))))))))))))))))))))))) :: []))
  | Coq_remove (a, s0) ->
    app
      (('I'::('n'::(' '::('m'::('e'::('m'::(' '::('s'::('t'::('a'::('t'::('e'::(':'::[]))))))))))))) :: [])
      (app (show_lines_mem_state s0.symbolic_mem_state)
        ((append ('I'::('n'::('d'::('e'::('x'::(' '::[]))))))
           (append (show0 Decimal.show_N a)
             (' '::('r'::('e'::('m'::('o'::('v'::('e'::('d'::(' '::('w'::('i'::('t'::('h'::('o'::('u'::('t'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('.'::[]))))))))))))))))))))))))))))))))) :: []))
  | Coq_remove_has_duplicates (a, ls, s0) ->
    app
      (('I'::('n'::(' '::('m'::('e'::('m'::(' '::('s'::('t'::('a'::('t'::('e'::(':'::[]))))))))))))) :: [])
      (app (show_lines_mem_state s0.symbolic_mem_state)
        ((append ('I'::('n'::('d'::('e'::('x'::(' '::[]))))))
           (append (show0 Decimal.show_N a)
             (append
               (' '::('o'::('c'::('c'::('u'::('r'::('s'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::(' '::('d'::('u'::('r'::('i'::('n'::('g'::(' '::('r'::('e'::('m'::('o'::('v'::('a'::('l'::(' '::('('::[])))))))))))))))))))))))))))))))))))))))
               (append
                 (show0
                   (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_N)) ls)
                 (')'::('.'::[])))))) :: []))
  | Coq_store (a, v, s0) ->
    app
      (('I'::('n'::(' '::('m'::('e'::('m'::(' '::('s'::('t'::('a'::('t'::('e'::(':'::[]))))))))))))) :: [])
      (app (show_lines_mem_state s0.symbolic_mem_state)
        ((append ('I'::('n'::('d'::('e'::('x'::(' '::[]))))))
           (append (show0 Decimal.show_N a)
             (append
               (' '::('u'::('p'::('d'::('a'::('t'::('e'::('d'::(' '::('('::('w'::('i'::('t'::('h'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[])))))))))))))))))))))
               (append (show0 Decimal.show_N v)
                 (')'::(' '::('w'::('i'::('t'::('h'::('o'::('u'::('t'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('.'::[])))))))))))))))))))))))))))) :: []))
  | Coq_set_const (c0, i) ->
    (append
      ('S'::('e'::('t'::('O'::('p'::('e'::('r'::('a'::('n'::('d'::(' '::('c'::('a'::('l'::('l'::('e'::('d'::(' '::('w'::('i'::('t'::('h'::(' '::('S'::('y'::('n'::('t'::('a'::('x'::('.'::('c'::('o'::('n'::('s'::('t'::(' '::[]))))))))))))))))))))))))))))))))))))
      (append (show0 Decimal.show_Z c0)
        (append (' '::[]) (show0 Decimal.show_N i)))) :: []
  | Coq_expected_const (i, x) ->
    (append
      ('R'::('e'::('v'::('e'::('a'::('l'::('C'::('o'::('n'::('s'::('t'::(' '::('c'::('a'::('l'::('l'::('e'::('d'::(' '::('a'::('t'::(' '::[]))))))))))))))))))))))
      (append (show0 Decimal.show_N i)
        (append
          (' '::('r'::('e'::('s'::('u'::('l'::('t'::('e'::('d'::(' '::('i'::('n'::(' '::('n'::('o'::('n'::('-'::('c'::('o'::('n'::('s'::('t'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[])))))))))))))))))))))))))))))
          (show0 show_expr x)))) :: []
  | Coq_unsupported_memory_access_size n3 ->
    (append
      ('e'::('r'::('r'::('o'::('r'::('.'::('u'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::('_'::('m'::('e'::('m'::('o'::('r'::('y'::('_'::('a'::('c'::('c'::('e'::('s'::('s'::('_'::('s'::('i'::('z'::('e'::(' '::[])))))))))))))))))))))))))))))))))))))
      (show0 Decimal.show_N n3)) :: []
  | Coq_unsupported_label_in_memory l ->
    (append
      ('e'::('r'::('r'::('o'::('r'::('.'::('u'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::('_'::('l'::('a'::('b'::('e'::('l'::('_'::('i'::('n'::('_'::('m'::('e'::('m'::('o'::('r'::('y'::(' '::[]))))))))))))))))))))))))))))))))))
      l) :: []
  | Coq_unsupported_label_argument l ->
    (append
      ('e'::('r'::('r'::('o'::('r'::('.'::('u'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::('_'::('l'::('a'::('b'::('e'::('l'::('_'::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::[])))))))))))))))))))))))))))))))))
      (show0 show_JUMP_LABEL l)) :: []
  | Coq_unimplemented_prefix n3 ->
    (append
      ('e'::('r'::('r'::('o'::('r'::('.'::('u'::('n'::('i'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('e'::('d'::('_'::('p'::('r'::('e'::('f'::('i'::('x'::(' '::[])))))))))))))))))))))))))))
      (show0 show_NormalInstruction n3)) :: []
  | Coq_unimplemented_instruction n3 ->
    (append
      ('e'::('r'::('r'::('o'::('r'::('.'::('u'::('n'::('i'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('e'::('d'::('_'::('i'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))
      (show0 show_NormalInstruction n3)) :: []
  | Coq_unsupported_line n3 ->
    (append
      ('e'::('r'::('r'::('o'::('r'::('.'::('u'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::('_'::('l'::('i'::('n'::('e'::(' '::[])))))))))))))))))))))))
      (show0 show_RawLine n3)) :: []
  | Coq_ambiguous_operation_size n3 ->
    (append
      ('e'::('r'::('r'::('o'::('r'::('.'::('a'::('m'::('b'::('i'::('g'::('u'::('o'::('u'::('s'::('_'::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('_'::('s'::('i'::('z'::('e'::(' '::[])))))))))))))))))))))))))))))))
      (show0 show_NormalInstruction n3)) :: []

  (** val coq_Show_error : error show **)

  let coq_Show_error =
    show_of_ShowLines show_lines_error
 end

type 't m =
  symbolic_state -> (Coq_error.error * symbolic_state, 't * symbolic_state)
  errorT

(** val ret0 : 'a1 -> 'a1 m **)

let ret0 x s0 =
  Success (x, s0)

(** val err : Coq_error.error -> 'a1 m **)

let err e s0 =
  Error (e, s0)

(** val some_or :
    (symbolic_state -> 'a1 option) -> (symbolic_state -> Coq_error.error) ->
    'a1 m **)

let some_or f e st =
  match f st with
  | Some x -> Success (x, st)
  | None -> Error ((e st), st)

(** val bind2 : 'a1 m -> ('a1 -> 'a2 m) -> 'a2 m **)

let bind2 x f s0 =
  bind0 (x s0) (fun x_s -> f (fst x_s) (snd x_s))

(** val lift_dag : 'a1 Old.Coq_dag.coq_M -> 'a1 m **)

let lift_dag v s0 =
  let (v0, d) = v s0.dag_state in
  Success (v0, (update_dag_with s0 (fun _ -> d)))

(** val mapM : ('a1 -> 'a2 m) -> 'a1 list -> 'a2 list m **)

let mapM f =
  let rec mapM0 = function
  | [] -> ret0 []
  | a :: l0 ->
    bind2 (f a) (fun b -> bind2 (mapM0 l0) (fun bs -> ret0 (b :: bs)))
  in mapM0

(** val error_get_reg_of_reg_index :
    nat -> symbolic_state -> Coq_error.error **)

let error_get_reg_of_reg_index ri s0 =
  Coq_error.Coq_get_reg
    ((let r0 = widest_register_of_index ri in
      if Nat.eqb (reg_index r0) ri then Inr r0 else Inl ri),
    s0.symbolic_reg_state)

(** val getFlag : fLAG -> idx m **)

let getFlag f =
  some_or (fun s0 -> get_flag s0.symbolic_flag_state f) (fun s0 ->
    Coq_error.Coq_get_flag (f, s0.symbolic_flag_state))

(** val getReg64 : nat -> idx m **)

let getReg64 ri =
  some_or (fun st -> get_reg st.symbolic_reg_state ri)
    (error_get_reg_of_reg_index ri)

(** val load64 : idx -> idx m **)

let load64 a =
  some_or (fun s0 -> load a s0.symbolic_mem_state) (fun x ->
    Coq_error.Coq_load (a, x))

(** val remove64 : idx -> idx m **)

let remove64 a s0 =
  let (vs, m4) = remove0 a s0.symbolic_mem_state in
  (match vs with
   | [] -> Error ((Coq_error.Coq_remove (a, s0)), s0)
   | v :: l ->
     (match l with
      | [] -> Success (v, (update_mem_with s0 (fun _ -> m4)))
      | _ :: _ ->
        Error ((Coq_error.Coq_remove_has_duplicates (a, vs, s0)), s0)))

(** val setFlag : fLAG -> idx -> unit m **)

let setFlag f i s0 =
  Success ((), (update_flag_with s0 (fun s1 -> set_flag s1 f i)))

(** val havocFlags : unit m **)

let havocFlags s0 =
  Success ((),
    (update_flag_with s0 (fun _ -> repeat1 None (S (S (S (S (S (S O)))))))))

(** val preserveFlag : fLAG -> 'a1 m -> 'a1 m **)

let preserveFlag f k =
  bind2 (fun s0 -> Success ((get_flag s0.symbolic_flag_state f), s0))
    (fun vf ->
    bind2 k (fun x ->
      bind2 (fun s0 -> Success ((),
        (update_flag_with s0 (fun s1 -> set_flag_internal s1 f vf))))
        (fun _ -> ret0 x)))

(** val setReg64 : nat -> idx -> unit m **)

let setReg64 rn i s0 =
  Success ((), (update_reg_with s0 (fun s1 -> set_reg s1 rn i)))

(** val store64 : idx -> idx -> unit m **)

let store64 a v =
  bind2
    (some_or (fun s0 -> store a v s0.symbolic_mem_state) (fun x ->
      Coq_error.Coq_store (a, v, x))) (fun ms s0 -> Success ((),
    (update_mem_with s0 (fun _ -> ms))))

(** val merge1 : description -> expr0 -> idx m **)

let merge1 descr e s0 =
  let i_dag = merge0 descr e s0.dag_state in
  Success ((fst i_dag), (update_dag_with s0 (fun _ -> snd i_dag)))

(** val app0 :
    Options.symbolic_options_computed_opt -> description -> idx node0 -> idx m **)

let app0 opts descr n3 s0 =
  merge1 descr (simplify opts s0.dag_state n3) s0

(** val reveal0 : nat -> idx -> expr0 m **)

let reveal0 n3 i s0 =
  Success ((reveal s0.dag_state n3 i), s0)

(** val revealConst : idx -> z m **)

let revealConst i =
  bind2 (reveal0 (S O) i) (fun x ->
    match x with
    | ExprRef _ -> err (Coq_error.Coq_expected_const (i, x))
    | ExprApp n3 ->
      let (o, l) = n3 in
      (match o with
       | Old (_, _) -> err (Coq_error.Coq_expected_const (i, x))
       | Const0 n4 ->
         (match l with
          | [] -> ret0 n4
          | _ :: _ -> err (Coq_error.Coq_expected_const (i, x)))
       | Add0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Addcarry _ -> err (Coq_error.Coq_expected_const (i, x))
       | Subborrow _ -> err (Coq_error.Coq_expected_const (i, x))
       | Addoverflow _ -> err (Coq_error.Coq_expected_const (i, x))
       | Neg1 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Shl0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Shr0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Sar0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Rcr0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | And0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Or0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Xor0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Slice (_, _) -> err (Coq_error.Coq_expected_const (i, x))
       | Mul0 _ -> err (Coq_error.Coq_expected_const (i, x))
       | Set_slice (_, _) -> err (Coq_error.Coq_expected_const (i, x))
       | Selectznz -> err (Coq_error.Coq_expected_const (i, x))
       | Iszero -> err (Coq_error.Coq_expected_const (i, x))
       | AddZ -> err (Coq_error.Coq_expected_const (i, x))
       | MulZ -> err (Coq_error.Coq_expected_const (i, x))
       | NegZ -> err (Coq_error.Coq_expected_const (i, x))
       | ShlZ -> err (Coq_error.Coq_expected_const (i, x))
       | ShrZ -> err (Coq_error.Coq_expected_const (i, x))
       | AndZ -> err (Coq_error.Coq_expected_const (i, x))
       | OrZ -> err (Coq_error.Coq_expected_const (i, x))
       | XorZ -> err (Coq_error.Coq_expected_const (i, x))
       | AddcarryZ _ -> err (Coq_error.Coq_expected_const (i, x))
       | SubborrowZ _ -> err (Coq_error.Coq_expected_const (i, x))))

(** val getReg :
    Options.symbolic_options_computed_opt -> description -> rEG -> idx m **)

let getReg opts descr r0 =
  let (p, sz) = index_and_shift_and_bitcount_of_reg r0 in
  let (rn, lo) = p in
  bind2 (getReg64 rn) (fun v -> app0 opts descr ((Slice (lo, sz)), (v :: [])))

(** val setReg :
    Options.symbolic_options_computed_opt -> description -> rEG -> idx ->
    unit m **)

let setReg opts descr r0 v =
  let (p, sz) = index_and_shift_and_bitcount_of_reg r0 in
  let (rn, lo) = p in
  if Coq_N.eqb sz (Npos (XO (XO (XO (XO (XO (XO XH)))))))
  then bind2
         (app0 opts descr ((Slice (N0, (Npos (XO (XO (XO (XO (XO (XO
           XH))))))))), (v :: []))) (fun v0 -> setReg64 rn v0)
  else bind2 (getReg64 rn) (fun old ->
         bind2 (app0 opts descr ((Set_slice (lo, sz)), (old :: (v :: []))))
           (fun v0 -> setReg64 rn v0))

type addressSize = operationSize

(** val address :
    Options.symbolic_options_computed_opt -> description -> addressSize ->
    mEM -> idx m **)

let address opts descr sa a =
  bind2
    (match a.mem_base_label with
     | Some l -> err (Coq_error.Coq_unsupported_label_in_memory l)
     | None -> ret0 ()) (fun _ ->
    bind2
      (match a.mem_base_reg with
       | Some r0 -> getReg opts descr r0
       | None -> app0 opts descr ((Const0 Z0), [])) (fun base1 ->
      bind2
        (match a.mem_scale_reg with
         | Some p ->
           let (z0, r0) = p in
           bind2 (app0 opts descr ((zconst sa z0), [])) (fun z1 ->
             bind2 (getReg opts descr r0) (fun r1 ->
               app0 opts descr ((Mul0 sa), (r1 :: (z1 :: [])))))
         | None -> app0 opts descr ((Const0 Z0), [])) (fun index ->
        bind2
          (app0 opts descr
            (match a.mem_offset with
             | Some s0 -> ((zconst sa s0), [])
             | None -> ((Const0 Z0), []))) (fun offset ->
          bind2 (app0 opts descr ((Add0 sa), (base1 :: (index :: []))))
            (fun bi -> app0 opts descr ((Add0 sa), (bi :: (offset :: []))))))))

(** val load0 :
    Options.symbolic_options_computed_opt -> description -> operationSize ->
    addressSize -> mEM -> idx m **)

let load0 opts descr s0 sa a =
  if negb
       ((||) (Coq_N.eqb (operand_size (Mem a) s0) (Npos (XO (XO (XO XH)))))
         (Coq_N.eqb (operand_size (Mem a) s0) (Npos (XO (XO (XO (XO (XO (XO
           XH)))))))))
  then err (Coq_error.Coq_unsupported_memory_access_size
         (operand_size (Mem a) s0))
  else bind2 (address opts descr sa a) (fun addr ->
         bind2 (load64 addr) (fun v ->
           app0 opts descr ((Slice (N0, (operand_size (Mem a) s0))),
             (v :: []))))

(** val store0 :
    Options.symbolic_options_computed_opt -> description -> operationSize ->
    addressSize -> mEM -> idx -> unit m **)

let store0 opts descr s0 sa a v =
  if negb
       ((||) (Coq_N.eqb (operand_size (Mem a) s0) (Npos (XO (XO (XO XH)))))
         (Coq_N.eqb (operand_size (Mem a) s0) (Npos (XO (XO (XO (XO (XO (XO
           XH)))))))))
  then err (Coq_error.Coq_unsupported_memory_access_size
         (operand_size (Mem a) s0))
  else bind2 (address opts descr sa a) (fun addr ->
         bind2 (load64 addr) (fun old ->
           bind2
             (app0 opts descr ((Slice (N0, (operand_size (Mem a) s0))),
               (v :: []))) (fun v0 ->
             bind2
               (app0 opts descr ((Set_slice (N0, (operand_size (Mem a) s0))),
                 (old :: (v0 :: [])))) (fun v1 -> store64 addr v1))))

(** val getOperand :
    Options.symbolic_options_computed_opt -> description -> operationSize ->
    addressSize -> aRG -> idx m **)

let getOperand opts descr s0 sa = function
| Reg r0 -> getReg opts descr r0
| Mem a -> load0 opts descr s0 sa a
| Const a -> app0 opts descr ((zconst s0 a), [])
| Label l -> err (Coq_error.Coq_unsupported_label_argument l)

(** val setOperand :
    Options.symbolic_options_computed_opt -> description -> operationSize ->
    addressSize -> aRG -> idx -> unit m **)

let setOperand opts descr s0 sa o v =
  match o with
  | Reg a -> setReg opts descr a v
  | Mem a -> store0 opts descr s0 sa a v
  | Const a -> err (Coq_error.Coq_set_const (a, v))
  | Label l -> err (Coq_error.Coq_unsupported_label_argument l)

type pre_expr =
| PreARG of aRG
| PreFLG of fLAG
| PreRef of idx
| PreApp of op0 * pre_expr list

(** val symeval :
    Options.symbolic_options_computed_opt -> description -> operationSize ->
    addressSize -> pre_expr -> idx m **)

let rec symeval opts descr s0 sa = function
| PreARG o -> getOperand opts descr s0 sa o
| PreFLG f -> getFlag f
| PreRef i -> ret0 i
| PreApp (op1, args0) ->
  bind2 (mapM (symeval opts descr s0 sa) args0) (fun idxs0 ->
    app0 opts descr (op1, idxs0))

(** val rcrcnt : n -> z -> z **)

let rcrcnt s0 cnt =
  if Coq_N.eqb s0 (Npos (XO (XO (XO XH))))
  then Coq_Z.modulo (Coq_Z.coq_land cnt (Zpos (XI (XI (XI (XI XH)))))) (Zpos
         (XI (XO (XO XH))))
  else if Coq_N.eqb s0 (Npos (XO (XO (XO (XO XH)))))
       then Coq_Z.modulo (Coq_Z.coq_land cnt (Zpos (XI (XI (XI (XI XH))))))
              (Zpos (XI (XO (XO (XO XH)))))
       else Coq_Z.coq_land cnt (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))

(** val symexNormalInstruction :
    Options.symbolic_options_computed_opt -> description -> normalInstruction
    -> unit m **)

let symexNormalInstruction opts descr instr =
  let stack_addr_size = Npos (XO (XO (XO (XO (XO (XO XH)))))) in
  let sa = Npos (XO (XO (XO (XO (XO (XO XH)))))) in
  (match operation_size instr with
   | Some s0 ->
     (match instr.prefix0 with
      | Some _ -> err (Coq_error.Coq_unimplemented_prefix instr)
      | None ->
        let resize_reg = fun r0 ->
          some_or (fun _ ->
            reg_of_index_and_shift_and_bitcount_opt (((reg_index r0), N0), s0))
            (fun _ -> Coq_error.Coq_unimplemented_instruction instr)
        in
        (match instr.op with
         | Adc ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                        dst) :: ((PreARG src) :: ((PreFLG CF) :: []))))))
                      (fun v ->
                      bind2
                        (symeval opts descr s0 sa (PreApp ((Addcarry s0),
                          ((PreARG dst) :: ((PreARG src) :: ((PreFLG
                          CF) :: [])))))) (fun c0 ->
                        bind2
                          (symeval opts descr s0 sa (PreApp ((Addoverflow
                            s0), ((PreARG dst) :: ((PreARG src) :: ((PreFLG
                            CF) :: [])))))) (fun o ->
                          bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                            bind2 havocFlags (fun _ ->
                              bind2 (setFlag CF c0) (fun _ -> setFlag OF o))))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Adcx ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    let f =
                      match Adcx with
                      | Adc -> OF
                      | Adcx -> CF
                      | Add -> OF
                      | Adox -> OF
                      | And -> OF
                      | Bzhi -> OF
                      | Call -> OF
                      | Clc -> OF
                      | Cmovb -> OF
                      | Cmovc -> OF
                      | Cmovnz -> OF
                      | Cmovo -> OF
                      | Cmp -> OF
                      | Db0 -> OF
                      | Dd0 -> OF
                      | Dec -> OF
                      | Dq -> OF
                      | Dw -> OF
                      | Imul -> OF
                      | Inc -> OF
                      | Je -> OF
                      | Jmp -> OF
                      | Lea -> OF
                      | Mov -> OF
                      | Movzx -> OF
                      | Mul -> OF
                      | Mulx -> OF
                      | Or -> OF
                      | Pop -> OF
                      | Push -> OF
                      | Rcr -> OF
                      | Ret -> OF
                      | Sar -> OF
                      | Sbb -> OF
                      | Setc -> OF
                      | Seto -> OF
                      | Shl -> OF
                      | Shlx -> OF
                      | Shr -> OF
                      | Shrx -> OF
                      | Shrd -> OF
                      | Sub -> OF
                      | Test -> OF
                      | Xchg -> OF
                      | Xor -> OF
                    in
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                        dst) :: ((PreARG src) :: ((PreFLG f) :: []))))))
                      (fun v ->
                      bind2
                        (symeval opts descr s0 sa (PreApp ((Addcarry s0),
                          ((PreARG dst) :: ((PreARG src) :: ((PreFLG
                          f) :: [])))))) (fun c0 ->
                        bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                          setFlag f c0)))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Add ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                        dst) :: ((PreARG src) :: []))))) (fun v ->
                      bind2
                        (symeval opts descr s0 sa (PreApp ((Addcarry s0),
                          ((PreARG dst) :: ((PreARG src) :: [])))))
                        (fun c0 ->
                        bind2
                          (symeval opts descr s0 sa (PreApp ((Addoverflow
                            s0), ((PreARG dst) :: ((PreARG src) :: [])))))
                          (fun o ->
                          bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                            bind2 havocFlags (fun _ ->
                              bind2 (setFlag CF c0) (fun _ -> setFlag OF o))))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Adox ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    let f =
                      match Adox with
                      | Adc -> OF
                      | Adcx -> CF
                      | Add -> OF
                      | Adox -> OF
                      | And -> OF
                      | Bzhi -> OF
                      | Call -> OF
                      | Clc -> OF
                      | Cmovb -> OF
                      | Cmovc -> OF
                      | Cmovnz -> OF
                      | Cmovo -> OF
                      | Cmp -> OF
                      | Db0 -> OF
                      | Dd0 -> OF
                      | Dec -> OF
                      | Dq -> OF
                      | Dw -> OF
                      | Imul -> OF
                      | Inc -> OF
                      | Je -> OF
                      | Jmp -> OF
                      | Lea -> OF
                      | Mov -> OF
                      | Movzx -> OF
                      | Mul -> OF
                      | Mulx -> OF
                      | Or -> OF
                      | Pop -> OF
                      | Push -> OF
                      | Rcr -> OF
                      | Ret -> OF
                      | Sar -> OF
                      | Sbb -> OF
                      | Setc -> OF
                      | Seto -> OF
                      | Shl -> OF
                      | Shlx -> OF
                      | Shr -> OF
                      | Shrx -> OF
                      | Shrd -> OF
                      | Sub -> OF
                      | Test -> OF
                      | Xchg -> OF
                      | Xor -> OF
                    in
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                        dst) :: ((PreARG src) :: ((PreFLG f) :: []))))))
                      (fun v ->
                      bind2
                        (symeval opts descr s0 sa (PreApp ((Addcarry s0),
                          ((PreARG dst) :: ((PreARG src) :: ((PreFLG
                          f) :: [])))))) (fun c0 ->
                        bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                          setFlag f c0)))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | And ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp (AndZ, ((PreARG
                        dst) :: ((PreARG src) :: []))))) (fun v ->
                      bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                        bind2 havocFlags (fun _ ->
                          bind2
                            (symeval opts descr s0 sa (PreApp ((Const0 Z0),
                              []))) (fun zero1 ->
                            bind2 (setFlag CF zero1) (fun _ ->
                              setFlag OF zero1)))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Bzhi ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
                  | cnt :: l1 ->
                    (match l1 with
                     | [] ->
                       bind2 (getOperand opts descr s0 sa cnt) (fun cnt0 ->
                         bind2 (revealConst cnt0) (fun cnt1 ->
                           bind2
                             (symeval opts descr s0 sa (PreApp (AndZ,
                               ((PreARG src) :: ((PreApp ((Const0
                               (Coq_Z.ones
                                 (Coq_Z.coq_land cnt1
                                   (Coq_Z.ones (Zpos (XO (XO (XO XH)))))))),
                               [])) :: []))))) (fun v ->
                             bind2 (setOperand opts descr s0 sa dst v)
                               (fun _ ->
                               bind2 havocFlags (fun _ ->
                                 bind2 (app0 opts descr ((Const0 Z0), []))
                                   (fun zero1 -> setFlag OF zero1))))))
                     | _ :: _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)))))
         | Call -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Clc ->
           (match instr.args with
            | [] ->
              bind2 (merge1 descr (ExprApp ((Const0 Z0), []))) (fun zero1 ->
                setFlag CF zero1)
            | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr))
         | Cmovb ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    let flag =
                      match instr.op with
                      | Adc -> CF
                      | Adcx -> CF
                      | Add -> CF
                      | Adox -> CF
                      | And -> CF
                      | Bzhi -> CF
                      | Call -> CF
                      | Clc -> CF
                      | Cmovb -> CF
                      | Cmovc -> CF
                      | Cmovnz -> CF
                      | Cmovo -> OF
                      | Cmp -> CF
                      | Db0 -> CF
                      | Dd0 -> CF
                      | Dec -> CF
                      | Dq -> CF
                      | Dw -> CF
                      | Imul -> CF
                      | Inc -> CF
                      | Je -> CF
                      | Jmp -> CF
                      | Lea -> CF
                      | Mov -> CF
                      | Movzx -> CF
                      | Mul -> CF
                      | Mulx -> CF
                      | Or -> CF
                      | Pop -> CF
                      | Push -> CF
                      | Rcr -> CF
                      | Ret -> CF
                      | Sar -> CF
                      | Sbb -> CF
                      | Setc -> CF
                      | Seto -> CF
                      | Shl -> CF
                      | Shlx -> CF
                      | Shr -> CF
                      | Shrx -> CF
                      | Shrd -> CF
                      | Sub -> CF
                      | Test -> CF
                      | Xchg -> CF
                      | Xor -> CF
                    in
                    bind2
                      (symeval opts descr s0 sa (PreApp (Selectznz, ((PreFLG
                        flag) :: ((PreARG dst) :: ((PreARG src) :: []))))))
                      (fun v -> setOperand opts descr s0 sa dst v)
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Cmovc ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    let flag =
                      match instr.op with
                      | Adc -> CF
                      | Adcx -> CF
                      | Add -> CF
                      | Adox -> CF
                      | And -> CF
                      | Bzhi -> CF
                      | Call -> CF
                      | Clc -> CF
                      | Cmovb -> CF
                      | Cmovc -> CF
                      | Cmovnz -> CF
                      | Cmovo -> OF
                      | Cmp -> CF
                      | Db0 -> CF
                      | Dd0 -> CF
                      | Dec -> CF
                      | Dq -> CF
                      | Dw -> CF
                      | Imul -> CF
                      | Inc -> CF
                      | Je -> CF
                      | Jmp -> CF
                      | Lea -> CF
                      | Mov -> CF
                      | Movzx -> CF
                      | Mul -> CF
                      | Mulx -> CF
                      | Or -> CF
                      | Pop -> CF
                      | Push -> CF
                      | Rcr -> CF
                      | Ret -> CF
                      | Sar -> CF
                      | Sbb -> CF
                      | Setc -> CF
                      | Seto -> CF
                      | Shl -> CF
                      | Shlx -> CF
                      | Shr -> CF
                      | Shrx -> CF
                      | Shrd -> CF
                      | Sub -> CF
                      | Test -> CF
                      | Xchg -> CF
                      | Xor -> CF
                    in
                    bind2
                      (symeval opts descr s0 sa (PreApp (Selectznz, ((PreFLG
                        flag) :: ((PreARG dst) :: ((PreARG src) :: []))))))
                      (fun v -> setOperand opts descr s0 sa dst v)
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Cmovnz ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp (Selectznz, ((PreFLG
                        ZF) :: ((PreARG src) :: ((PreARG dst) :: []))))))
                      (fun v -> setOperand opts descr s0 sa dst v)
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Cmovo ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    let flag =
                      match instr.op with
                      | Adc -> CF
                      | Adcx -> CF
                      | Add -> CF
                      | Adox -> CF
                      | And -> CF
                      | Bzhi -> CF
                      | Call -> CF
                      | Clc -> CF
                      | Cmovb -> CF
                      | Cmovc -> CF
                      | Cmovnz -> CF
                      | Cmovo -> OF
                      | Cmp -> CF
                      | Db0 -> CF
                      | Dd0 -> CF
                      | Dec -> CF
                      | Dq -> CF
                      | Dw -> CF
                      | Imul -> CF
                      | Inc -> CF
                      | Je -> CF
                      | Jmp -> CF
                      | Lea -> CF
                      | Mov -> CF
                      | Movzx -> CF
                      | Mul -> CF
                      | Mulx -> CF
                      | Or -> CF
                      | Pop -> CF
                      | Push -> CF
                      | Rcr -> CF
                      | Ret -> CF
                      | Sar -> CF
                      | Sbb -> CF
                      | Setc -> CF
                      | Seto -> CF
                      | Shl -> CF
                      | Shlx -> CF
                      | Shr -> CF
                      | Shrx -> CF
                      | Shrd -> CF
                      | Sub -> CF
                      | Test -> CF
                      | Xchg -> CF
                      | Xor -> CF
                    in
                    bind2
                      (symeval opts descr s0 sa (PreApp (Selectznz, ((PreFLG
                        flag) :: ((PreARG dst) :: ((PreARG src) :: []))))))
                      (fun v -> setOperand opts descr s0 sa dst v)
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Cmp -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Db0 -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Dd0 -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Dec ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] ->
                 bind2
                   (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                     dst) :: ((PreARG (Const
                     (cONST_of_Z (Zneg XH)))) :: []))))) (fun v ->
                   bind2
                     (symeval opts descr s0 sa (PreApp ((Addoverflow s0),
                       ((PreARG dst) :: ((PreARG (Const
                       (cONST_of_Z (Zneg XH)))) :: []))))) (fun o ->
                     bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                       bind2 (preserveFlag CF havocFlags) (fun _ ->
                         setFlag OF o))))
               | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr)))
         | Dq -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Dw -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Imul ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | src2 :: l ->
              (match l with
               | [] ->
                 let src1 = Reg Rax in
                 bind2
                   (symeval opts descr s0 sa (PreApp (MulZ, ((PreARG
                     src1) :: ((PreARG src2) :: []))))) (fun v ->
                   bind2
                     (symeval opts descr s0 sa (PreApp (ShrZ, ((PreRef
                       v) :: ((PreARG (Const
                       (cONST_of_Z (Coq_Z.of_N s0)))) :: []))))) (fun vh ->
                     bind2 (resize_reg Rax) (fun lo ->
                       bind2
                         (if Coq_N.eqb s0 (Npos (XO (XO (XO XH))))
                          then ret0 Ah
                          else resize_reg Rdx) (fun hi ->
                         bind2 (setOperand opts descr s0 sa (Reg lo) v)
                           (fun _ ->
                           bind2 (setOperand opts descr s0 sa (Reg hi) vh)
                             (fun _ -> havocFlags))))))
               | src1 :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp (MulZ, ((PreARG
                        src2) :: ((PreARG src1) :: []))))) (fun v ->
                      bind2 (setOperand opts descr s0 sa src2 v) (fun _ ->
                        havocFlags))
                  | src3 :: l1 ->
                    (match l1 with
                     | [] ->
                       bind2
                         (symeval opts descr s0 sa (PreApp (MulZ, ((PreARG
                           src1) :: ((PreARG src3) :: []))))) (fun v ->
                         bind2 (setOperand opts descr s0 sa src2 v) (fun _ ->
                           havocFlags))
                     | _ :: _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)))))
         | Inc ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] ->
                 bind2
                   (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                     dst) :: ((PreARG (Const
                     (cONST_of_Z (Zpos XH)))) :: []))))) (fun v ->
                   bind2
                     (symeval opts descr s0 sa (PreApp ((Addoverflow s0),
                       ((PreARG dst) :: ((PreARG (Const
                       (cONST_of_Z (Zpos XH)))) :: []))))) (fun o ->
                     bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                       bind2 (preserveFlag CF havocFlags) (fun _ ->
                         setFlag OF o))))
               | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr)))
         | Je -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Jmp -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Lea ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | a :: l ->
              (match a with
               | Reg dst ->
                 (match l with
                  | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
                  | a0 :: l0 ->
                    (match a0 with
                     | Reg _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)
                     | Mem src ->
                       (match l0 with
                        | [] ->
                          bind2 (address opts descr sa src) (fun a1 ->
                            setOperand opts descr s0 sa (Reg dst) a1)
                        | _ :: _ ->
                          err (Coq_error.Coq_unimplemented_instruction instr))
                     | Const _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)
                     | Label _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)))
               | Mem _ -> err (Coq_error.Coq_unimplemented_instruction instr)
               | Const _ ->
                 err (Coq_error.Coq_unimplemented_instruction instr)
               | Label _ ->
                 err (Coq_error.Coq_unimplemented_instruction instr)))
         | Mov ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2 (getOperand opts descr s0 sa src) (fun v ->
                      setOperand opts descr s0 sa dst v)
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Movzx ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2 (getOperand opts descr s0 sa src) (fun v ->
                      setOperand opts descr s0 sa dst v)
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Mul ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | src2 :: l ->
              (match l with
               | [] ->
                 let src1 = Reg Rax in
                 bind2
                   (symeval opts descr s0 sa (PreApp (MulZ, ((PreARG
                     src1) :: ((PreARG src2) :: []))))) (fun v ->
                   bind2
                     (symeval opts descr s0 sa (PreApp (ShrZ, ((PreRef
                       v) :: ((PreARG (Const
                       (cONST_of_Z (Coq_Z.of_N s0)))) :: []))))) (fun vh ->
                     bind2 (resize_reg Rax) (fun lo ->
                       bind2
                         (if Coq_N.eqb s0 (Npos (XO (XO (XO XH))))
                          then ret0 Ah
                          else resize_reg Rdx) (fun hi ->
                         bind2 (setOperand opts descr s0 sa (Reg lo) v)
                           (fun _ ->
                           bind2 (setOperand opts descr s0 sa (Reg hi) vh)
                             (fun _ -> havocFlags))))))
               | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr)))
         | Mulx ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | hi :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | lo :: l0 ->
                 (match l0 with
                  | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
                  | src2 :: l1 ->
                    (match l1 with
                     | [] ->
                       let src1 = Reg Rdx in
                       bind2
                         (symeval opts descr s0 sa (PreApp (MulZ, ((PreARG
                           src1) :: ((PreARG src2) :: []))))) (fun v ->
                         bind2
                           (symeval opts descr s0 sa (PreApp (ShrZ, ((PreRef
                             v) :: ((PreARG (Const
                             (cONST_of_Z (Coq_Z.of_N s0)))) :: [])))))
                           (fun vh ->
                           bind2 (setOperand opts descr s0 sa lo v) (fun _ ->
                             setOperand opts descr s0 sa hi vh)))
                     | _ :: _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)))))
         | Or ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp (OrZ, ((PreARG
                        dst) :: ((PreARG src) :: []))))) (fun v ->
                      bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                        bind2 havocFlags (fun _ ->
                          bind2
                            (symeval opts descr s0 sa (PreApp ((Const0 Z0),
                              []))) (fun zero1 ->
                            bind2 (setFlag CF zero1) (fun _ ->
                              setFlag OF zero1)))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Pop ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] ->
                 bind2 (getOperand opts descr s0 sa (Mem (mem_of_reg Rsp)))
                   (fun v ->
                   bind2 (getOperand opts descr stack_addr_size sa (Reg Rsp))
                     (fun rsp' ->
                     bind2
                       (symeval opts descr stack_addr_size sa (PreApp ((Add0
                         stack_addr_size), ((PreRef rsp') :: ((PreARG (Const
                         (cONST_of_Z
                           (Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                             XH)))))))) :: []))))) (fun rsp'0 ->
                       bind2 (setOperand opts descr s0 sa (Reg Rsp) rsp'0)
                         (fun _ -> setOperand opts descr s0 sa dst v))))
               | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr)))
         | Push ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | src :: l ->
              (match l with
               | [] ->
                 bind2 (getOperand opts descr s0 sa src) (fun v ->
                   bind2 (getOperand opts descr stack_addr_size sa (Reg Rsp))
                     (fun rsp' ->
                     bind2
                       (symeval opts descr stack_addr_size sa (PreApp ((Add0
                         stack_addr_size), ((PreRef rsp') :: ((PreARG (Const
                         (cONST_of_Z
                           (Coq_Z.opp
                             (Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                               XH))))))))) :: []))))) (fun rsp'0 ->
                       bind2 (setOperand opts descr s0 sa (Reg Rsp) rsp'0)
                         (fun _ ->
                         setOperand opts descr s0 sa (Mem (mem_of_reg Rsp)) v))))
               | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr)))
         | Rcr ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | cnt :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2 (getOperand opts descr s0 sa dst) (fun x ->
                      bind2 (getFlag CF) (fun cf ->
                        bind2 (getOperand opts descr s0 sa cnt) (fun cnt0 ->
                          bind2 (revealConst cnt0) (fun cnt1 ->
                            let cnt2 = rcrcnt s0 cnt1 in
                            bind2 (app0 opts descr ((Const0 cnt2), []))
                              (fun cntv ->
                              bind2
                                (app0 opts descr ((Rcr0 s0),
                                  (x :: (cf :: (cntv :: []))))) (fun y ->
                                bind2 (setOperand opts descr s0 sa dst y)
                                  (fun _ ->
                                  bind2 havocFlags (fun _ ->
                                    if Coq_Z.eqb cnt2 (Zpos XH)
                                    then bind2
                                           (app0 opts descr ((Slice (N0,
                                             (Npos XH))), (x :: [])))
                                           (fun cf0 -> setFlag CF cf0)
                                    else ret0 ()))))))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Ret -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Sar ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | cnt :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2 (getOperand opts descr s0 sa dst) (fun x ->
                      let cnt0 = PreApp (AndZ, ((PreARG cnt) :: ((PreApp
                        ((Const0 (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))),
                        [])) :: [])))
                      in
                      bind2 (symeval opts descr s0 sa cnt0) (fun c0 ->
                        bind2 (reveal0 (S O) c0) (fun rc ->
                          bind2
                            (app0 opts descr ((Sar0 s0), (x :: (c0 :: []))))
                            (fun y ->
                            bind2 (setOperand opts descr s0 sa dst y)
                              (fun _ ->
                              bind2 havocFlags (fun _ ->
                                if expr_beq rc (ExprApp ((Const0 (Zpos XH)),
                                     []))
                                then bind2
                                       (app0 opts descr ((Slice (N0, (Npos
                                         XH))), (x :: []))) (fun cf ->
                                       bind2 (setFlag CF cf) (fun _ ->
                                         bind2
                                           (app0 opts descr ((Const0 Z0), []))
                                           (fun zero1 -> setFlag OF zero1)))
                                else ret0 ()))))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Sbb ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                        dst) :: ((PreApp ((Neg1 s0), ((PreARG
                        src) :: []))) :: ((PreApp ((Neg1 s0), ((PreFLG
                        CF) :: []))) :: [])))))) (fun v ->
                      bind2
                        (symeval opts descr s0 sa (PreApp ((Subborrow s0),
                          ((PreARG dst) :: ((PreARG src) :: ((PreFLG
                          CF) :: [])))))) (fun c0 ->
                        bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                          bind2 havocFlags (fun _ -> setFlag CF c0))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Setc ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] ->
                 bind2 (getFlag CF) (fun cf ->
                   setOperand opts descr s0 sa dst cf)
               | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr)))
         | Seto ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] ->
                 bind2 (getFlag OF) (fun of0 ->
                   setOperand opts descr s0 sa dst of0)
               | _ :: _ -> err (Coq_error.Coq_unimplemented_instruction instr)))
         | Shl ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | cnt :: l0 ->
                 (match l0 with
                  | [] ->
                    let cnt0 = PreApp (AndZ, ((PreARG cnt) :: ((PreApp
                      ((Const0 (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))),
                      [])) :: [])))
                    in
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Shl0 s0), ((PreARG
                        dst) :: (cnt0 :: []))))) (fun v ->
                      bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                        havocFlags))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Shlx ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
                  | cnt :: l1 ->
                    (match l1 with
                     | [] ->
                       bind2 (getOperand opts descr s0 sa cnt) (fun cnt0 ->
                         bind2 (revealConst cnt0) (fun cnt1 ->
                           let cnt' = PreApp (AndZ, ((PreARG (Const
                             (cONST_of_Z cnt1))) :: ((PreApp ((Const0
                             (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))),
                             [])) :: [])))
                           in
                           bind2
                             (symeval opts descr s0 sa (PreApp ((Shl0 s0),
                               ((PreARG src) :: (cnt' :: []))))) (fun v ->
                             setOperand opts descr s0 sa dst v)))
                     | _ :: _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)))))
         | Shr ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | cnt :: l0 ->
                 (match l0 with
                  | [] ->
                    let cnt0 = PreApp (AndZ, ((PreARG cnt) :: ((PreApp
                      ((Const0 (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))),
                      [])) :: [])))
                    in
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Shr0 s0), ((PreARG
                        dst) :: (cnt0 :: []))))) (fun v ->
                      bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                        havocFlags))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Shrx -> err (Coq_error.Coq_unimplemented_instruction instr)
         | Shrd ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | hi :: l0 ->
                 (match l0 with
                  | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
                  | cnt :: l1 ->
                    (match l1 with
                     | [] ->
                       let cnt0 = PreApp (AndZ, ((PreARG cnt) :: ((PreApp
                         ((Const0 (Coq_Z.sub (Coq_Z.of_N s0) (Zpos XH))),
                         [])) :: [])))
                       in
                       let cnt' = PreApp (AddZ, ((PreARG (Const
                         (cONST_of_Z (Coq_Z.of_N s0)))) :: ((PreApp (NegZ,
                         (cnt0 :: []))) :: [])))
                       in
                       bind2
                         (symeval opts descr s0 sa (PreApp ((Or0 s0),
                           ((PreApp ((Shr0 s0), ((PreARG
                           dst) :: (cnt0 :: [])))) :: ((PreApp ((Shl0 s0),
                           ((PreARG hi) :: (cnt' :: [])))) :: [])))))
                         (fun v ->
                         bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                           havocFlags))
                     | _ :: _ ->
                       err (Coq_error.Coq_unimplemented_instruction instr)))))
         | Sub ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp ((Add0 s0), ((PreARG
                        dst) :: ((PreApp ((Neg1 s0), ((PreARG
                        src) :: []))) :: []))))) (fun v ->
                      bind2
                        (symeval opts descr s0 sa (PreApp ((Subborrow s0),
                          ((PreARG dst) :: ((PreARG src) :: [])))))
                        (fun c0 ->
                        bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                          bind2 havocFlags (fun _ -> setFlag CF c0))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Test ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | ea :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | eb :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2 (getOperand opts descr s0 sa ea) (fun a ->
                      bind2 (getOperand opts descr s0 sa eb) (fun _ ->
                        bind2 (app0 opts descr ((Const0 Z0), []))
                          (fun zero1 ->
                          bind2 havocFlags (fun _ ->
                            bind2 (setFlag CF zero1) (fun _ ->
                              bind2 (setFlag OF zero1) (fun _ ->
                                if aRG_beq ea eb
                                then bind2
                                       (app0 opts descr (Iszero, (a :: [])))
                                       (fun zf -> setFlag ZF zf)
                                else ret0 ()))))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Xchg ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | a :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | b :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2 (getOperand opts descr s0 sa a) (fun va ->
                      bind2 (getOperand opts descr s0 sa b) (fun vb ->
                        bind2 (setOperand opts descr s0 sa b va) (fun _ ->
                          setOperand opts descr s0 sa a vb)))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))
         | Xor ->
           (match instr.args with
            | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
            | dst :: l ->
              (match l with
               | [] -> err (Coq_error.Coq_unimplemented_instruction instr)
               | src :: l0 ->
                 (match l0 with
                  | [] ->
                    bind2
                      (symeval opts descr s0 sa (PreApp (XorZ, ((PreARG
                        dst) :: ((PreARG src) :: []))))) (fun v ->
                      bind2 (setOperand opts descr s0 sa dst v) (fun _ ->
                        bind2 havocFlags (fun _ ->
                          bind2
                            (symeval opts descr s0 sa (PreApp ((Const0 Z0),
                              []))) (fun zero1 ->
                            bind2 (setFlag CF zero1) (fun _ ->
                              setFlag OF zero1)))))
                  | _ :: _ ->
                    err (Coq_error.Coq_unimplemented_instruction instr))))))
   | None -> err (Coq_error.Coq_ambiguous_operation_size instr))

(** val symexRawLine :
    Options.symbolic_options_computed_opt -> description -> rawLine -> unit m **)

let symexRawLine opts descr rawline0 = match rawline0 with
| SECTION _ -> err (Coq_error.Coq_unsupported_line rawline0)
| GLOBAL _ -> err (Coq_error.Coq_unsupported_line rawline0)
| LABEL _ -> ret0 ()
| ALIGN _ -> err (Coq_error.Coq_unsupported_line rawline0)
| DEFAULT_REL -> err (Coq_error.Coq_unsupported_line rawline0)
| EMPTY -> ret0 ()
| INSTR instr -> symexNormalInstruction opts descr instr

(** val symexLine :
    Options.symbolic_options_computed_opt -> line -> unit m **)

let symexLine opts line0 =
  let descr = Some ((fun pat ->
    let () = pat in show_Line_with_line_number line0), false)
  in
  symexRawLine opts descr line0.rawline

(** val symexLines :
    Options.symbolic_options_computed_opt -> lines -> unit m **)

let rec symexLines opts = function
| [] -> ret0 ()
| line0 :: lines1 ->
  bind2 (symexLine opts line0) (fun _ -> symexLines opts lines1)

module SumSets =
 functor (W1:Sets) ->
 functor (W2:Sets) ->
 struct
  module E = SumOrderedType(W1.E)(W2.E)

  module WSumSetsOn_E =
   struct
    module E =
     struct
      type t = (W1.E.t, W2.E.t) sum

      (** val eq_dec :
          (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> bool **)

      let eq_dec x y =
        dec_sumwise W1.E.eq_dec W2.E.eq_dec x y
     end
   end

  type elt = WSumSetsOn_E.E.t

  type t = W1.t * W2.t

  (** val lift_tT :
      ('a1 -> 'a2 -> 'a3) -> (W1.t -> 'a1) -> (W2.t -> 'a2) -> t -> 'a3 **)

  let lift_tT f f1 f2 x =
    f (f1 (fst x)) (f2 (snd x))

  (** val lift_ttT :
      ('a1 -> 'a2 -> 'a3) -> (W1.t -> W1.t -> 'a1) -> (W2.t -> W2.t -> 'a2)
      -> t -> t -> 'a3 **)

  let lift_ttT f f1 f2 x y =
    f (f1 (fst x) (fst y)) (f2 (snd x) (snd y))

  (** val lift_eT : (W1.E.t -> 'a1) -> (W2.E.t -> 'a1) -> elt -> 'a1 **)

  let lift_eT f1 f2 = function
  | Inl e0 -> f1 e0
  | Inr e0 -> f2 e0

  (** val drop_eT : (elt -> 'a1) -> (W1.E.t -> 'a1) * (W2.E.t -> 'a1) **)

  let drop_eT f =
    ((fun e -> f (Inl e)), (fun e -> f (Inr e)))

  (** val lift_et : (W1.E.t -> W1.t) -> (W2.E.t -> W2.t) -> elt -> t **)

  let lift_et f1 f2 e =
    ((match e with
      | Inl e0 -> f1 e0
      | Inr _ -> W1.empty),
      (match e with
       | Inl _ -> W2.empty
       | Inr e0 -> f2 e0))

  (** val lift_etT :
      (W1.E.t -> W1.t -> 'a1) -> (W2.E.t -> W2.t -> 'a1) -> elt -> t -> 'a1 **)

  let lift_etT f1 f2 e x =
    match e with
    | Inl e0 -> f1 e0 (fst x)
    | Inr e0 -> f2 e0 (snd x)

  (** val lift_ett :
      (W1.E.t -> W1.t -> W1.t) -> (W2.E.t -> W2.t -> W2.t) -> elt -> t -> t **)

  let lift_ett f1 f2 e x =
    ((match e with
      | Inl e0 -> f1 e0 (fst x)
      | Inr _ -> fst x),
      (match e with
       | Inl _ -> snd x
       | Inr e0 -> f2 e0 (snd x)))

  (** val lift_ttt :
      (W1.t -> W1.t -> W1.t) -> (W2.t -> W2.t -> W2.t) -> t -> t -> t **)

  let lift_ttt f1 f2 x y =
    ((f1 (fst x) (fst y)), (f2 (snd x) (snd y)))

  (** val lift_eT_tT :
      ('a2 -> 'a2 -> 'a2) -> ((W1.E.t -> 'a1) -> W1.t -> 'a2) -> ((W2.E.t ->
      'a1) -> W2.t -> 'a2) -> (elt -> 'a1) -> t -> 'a2 **)

  let lift_eT_tT f f1 f2 f0 x =
    f (f1 (fst (drop_eT f0)) (fst x)) (f2 (snd (drop_eT f0)) (snd x))

  (** val lift_eT_tt :
      ((W1.E.t -> 'a1) -> W1.t -> W1.t) -> ((W2.E.t -> 'a1) -> W2.t -> W2.t)
      -> (elt -> 'a1) -> t -> t **)

  let lift_eT_tt f1 f2 f x =
    ((f1 (fst (drop_eT f)) (fst x)), (f2 (snd (drop_eT f)) (snd x)))

  (** val lift_eT_tt2 :
      ((W1.E.t -> 'a1) -> W1.t -> W1.t * W1.t) -> ((W2.E.t -> 'a1) -> W2.t ->
      W2.t * W2.t) -> (elt -> 'a1) -> t -> t * t **)

  let lift_eT_tt2 f1 f2 f x =
    let f1v = f1 (fst (drop_eT f)) (fst x) in
    let f2v = f2 (snd (drop_eT f)) (snd x) in
    (((fst f1v), (fst f2v)), ((snd f1v), (snd f2v)))

  (** val choose_option : 'a1 option -> 'a1 option -> 'a1 option **)

  let choose_option x y =
    match x with
    | Some v -> Some v
    | None -> (match y with
               | Some v -> Some v
               | None -> None)

  (** val choose_option_sum :
      'a1 option -> 'a2 option -> ('a1, 'a2) sum option **)

  let choose_option_sum v1 v2 =
    choose_option (option_map (fun x -> Inl x) v1)
      (option_map (fun x -> Inr x) v2)

  (** val choose_option_sum_rev :
      'a1 option -> 'a2 option -> ('a1, 'a2) sum option **)

  let choose_option_sum_rev v1 v2 =
    choose_option (option_map (fun x -> Inr x) v2)
      (option_map (fun x -> Inl x) v1)

  (** val empty : t **)

  let empty =
    (W1.empty, W2.empty)

  (** val is_empty : t -> bool **)

  let is_empty =
    lift_tT (&&) W1.is_empty W2.is_empty

  (** val mem : elt -> t -> bool **)

  let mem =
    lift_etT W1.mem W2.mem

  (** val add : elt -> t -> t **)

  let add =
    lift_ett W1.add W2.add

  (** val remove : elt -> t -> t **)

  let remove =
    lift_ett W1.remove W2.remove

  (** val singleton : elt -> t **)

  let singleton =
    lift_et W1.singleton W2.singleton

  (** val union : t -> t -> t **)

  let union =
    lift_ttt W1.union W2.union

  (** val inter : t -> t -> t **)

  let inter =
    lift_ttt W1.inter W2.inter

  (** val diff : t -> t -> t **)

  let diff =
    lift_ttt W1.diff W2.diff

  (** val equal : t -> t -> bool **)

  let equal =
    lift_ttT (&&) W1.equal W2.equal

  (** val subset : t -> t -> bool **)

  let subset =
    lift_ttT (&&) W1.subset W2.subset

  (** val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1 **)

  let fold f v i =
    W2.fold (snd (drop_eT f)) (snd v) (W1.fold (fst (drop_eT f)) (fst v) i)

  (** val for_all : (elt -> bool) -> t -> bool **)

  let for_all =
    lift_eT_tT (&&) W1.for_all W2.for_all

  (** val exists_ : (elt -> bool) -> t -> bool **)

  let exists_ =
    lift_eT_tT (||) W1.exists_ W2.exists_

  (** val filter : (elt -> bool) -> t -> t **)

  let filter =
    lift_eT_tt W1.filter W2.filter

  (** val partition : (elt -> bool) -> t -> t * t **)

  let partition =
    lift_eT_tt2 W1.partition W2.partition

  (** val cardinal : t -> nat **)

  let cardinal =
    lift_tT Coq__1.add W1.cardinal W2.cardinal

  (** val elements : t -> elt list **)

  let elements =
    lift_tT (fun l1 l2 ->
      app (map (fun x -> Inl x) l1) (map (fun x -> Inr x) l2)) W1.elements
      W2.elements

  (** val choose : t -> elt option **)

  let choose =
    lift_tT choose_option_sum W1.choose W2.choose

  (** val eq_dec : t -> t -> bool **)

  let eq_dec x y =
    let s0 = W1.eq_dec (fst x) (fst y) in
    if s0
    then let s1 = W2.eq_dec (snd x) (snd y) in if s1 then true else false
    else let s1 = W2.eq_dec (snd x) (snd y) in if s1 then false else false

  module SumSetsOn_E =
   struct
    module E =
     struct
      type t = (W1.E.t, W2.E.t) sum

      (** val compare :
          (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> comparison **)

      let compare =
        Sum.compare W1.E.compare W2.E.compare

      (** val eq_dec :
          (W1.E.t, W2.E.t) sum -> (W1.E.t, W2.E.t) sum -> bool **)

      let eq_dec x y =
        dec_sumwise W1.E.eq_dec W2.E.eq_dec x y
     end
   end

  (** val choose_comparison : comparison -> comparison -> comparison **)

  let choose_comparison x y =
    match x with
    | Eq -> y
    | Lt -> x
    | Gt -> x

  (** val compare : t -> t -> comparison **)

  let compare =
    lift_ttT choose_comparison W1.compare W2.compare

  (** val min_elt : t -> elt option **)

  let min_elt =
    lift_tT choose_option_sum W1.min_elt W2.min_elt

  (** val max_elt : t -> elt option **)

  let max_elt =
    lift_tT choose_option_sum_rev W1.max_elt W2.max_elt
 end

type name_case_kind =
| Lower
| Upper

type word_case_data = { first_letter_case : name_case_kind;
                        rest_letters_case : name_case_kind }

type capitalization_data = { separator : char list;
                             first_word_case : word_case_data;
                             rest_words_case : word_case_data }

type capitalization_convention = { capitalization_convention_data : capitalization_data;
                                   only_lower_first_letters : bool }

(** val case_adjust_ascii : name_case_kind -> char -> char **)

let case_adjust_ascii = function
| Lower -> to_lower
| Upper -> to_upper

(** val case_adjust_string : name_case_kind -> char list -> char list **)

let case_adjust_string = function
| Lower -> to_lower0
| Upper -> to_upper0

(** val case_adjust_word :
    bool -> word_case_data -> char list -> char list **)

let case_adjust_word only_lower_first_char data = function
| [] -> []
| ch::rest ->
  (case_adjust_ascii data.first_letter_case ch)::(let adjusted =
                                                    case_adjust_string
                                                      data.rest_letters_case
                                                      rest
                                                  in
                                                  if only_lower_first_char
                                                  then (match data.rest_letters_case with
                                                        | Lower -> rest
                                                        | Upper -> adjusted)
                                                  else (match data.rest_letters_case with
                                                        | Lower -> adjusted
                                                        | Upper -> adjusted))

(** val case_adjust_word_list :
    bool -> capitalization_data -> char list list -> char list list **)

let case_adjust_word_list only_lower_first_char data = function
| [] -> []
| firstword :: restwords ->
  (case_adjust_word only_lower_first_char data.first_word_case firstword) :: 
    (map (case_adjust_word only_lower_first_char data.rest_words_case)
      restwords)

(** val case_adjust_words :
    bool -> capitalization_data -> char list list -> char list **)

let case_adjust_words only_lower_first_char data words =
  concat0 data.separator
    (case_adjust_word_list only_lower_first_char data words)

(** val split_before_gen : (char -> bool) -> char list -> char list list **)

let rec split_before_gen f = function
| [] -> []
| ch::rest ->
  (match split_before_gen f rest with
   | [] -> (ch::[]) :: []
   | x :: xs ->
     (match x with
      | [] -> (ch::[]) :: xs
      | ch'::_ -> if f ch' then (ch::[]) :: (x :: xs) else (ch::x) :: xs))

(** val split_before_uppercase : char list -> char list list **)

let split_before_uppercase s0 =
  split_before_gen is_upper s0

(** val split_before_lowercase : char list -> char list list **)

let split_before_lowercase s0 =
  split_before_gen is_lower s0

(** val splitter_function :
    capitalization_data -> (char list -> char list list) option **)

let splitter_function data =
  if eqb0 data.separator []
  then (match data.first_word_case.rest_letters_case with
        | Lower ->
          (match data.rest_words_case.first_letter_case with
           | Lower -> None
           | Upper ->
             (match data.rest_words_case.rest_letters_case with
              | Lower -> Some split_before_uppercase
              | Upper -> None))
        | Upper ->
          (match data.rest_words_case.first_letter_case with
           | Lower ->
             (match data.rest_words_case.rest_letters_case with
              | Lower -> None
              | Upper -> Some split_before_lowercase)
           | Upper -> None))
  else Some (split data.separator)

(** val convert_case :
    capitalization_data -> capitalization_convention -> char list -> __ **)

let convert_case from to0 s0 =
  match splitter_function from with
  | Some f ->
    Obj.magic case_adjust_words to0.only_lower_first_letters
      to0.capitalization_convention_data (f s0)
  | None -> Obj.magic ()

(** val parse_capitalization_data_list :
    (char list * capitalization_data) list **)

let parse_capitalization_data_list =
  (('f'::('l'::('a'::('t'::(' '::('c'::('a'::('s'::('e'::[]))))))))),
    { separator = []; first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('f'::('l'::('a'::('t'::('c'::('a'::('s'::('e'::[])))))))),
    { separator = []; first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('u'::('p'::('p'::('e'::('r'::(' '::('f'::('l'::('a'::('t'::(' '::('c'::('a'::('s'::('e'::[]))))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('U'::('P'::('P'::('E'::('R'::(' '::('F'::('L'::('A'::('T'::(' '::('C'::('A'::('S'::('E'::[]))))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('U'::('P'::('P'::('E'::('R'::('F'::('L'::('A'::('T'::('C'::('A'::('S'::('E'::[]))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('c'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::[]))))))))),
    { separator = []; first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('l'::('o'::('w'::('e'::('r'::(' '::('c'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::[]))))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('l'::('o'::('w'::('e'::('r'::('C'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::[])))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('d'::('r'::('o'::('m'::('e'::('d'::('a'::('r'::('y'::('C'::('a'::('s'::('e'::[]))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('P'::('a'::('s'::('c'::('a'::('l'::('C'::('a'::('s'::('e'::[])))))))))),
    { separator = []; first_word_case = { first_letter_case = Upper;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('U'::('p'::('p'::('e'::('r'::('C'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::[])))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Upper;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('U'::('p'::('p'::('e'::('r'::(' '::('C'::('a'::('m'::('e'::('l'::(' '::('C'::('a'::('s'::('e'::[])))))))))))))))),
    { separator = []; first_word_case = { first_letter_case = Upper;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('S'::('t'::('u'::('d'::('l'::('y'::('C'::('a'::('s'::('e'::[])))))))))),
    { separator = []; first_word_case = { first_letter_case = Upper;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('s'::('n'::('a'::('k'::('e'::('_'::('c'::('a'::('s'::('e'::[])))))))))),
    { separator = ('_'::[]); first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('p'::('o'::('t'::('h'::('o'::('l'::('e'::('_'::('c'::('a'::('s'::('e'::[])))))))))))),
    { separator = ('_'::[]); first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('S'::('C'::('R'::('E'::('A'::('M'::('I'::('N'::('G'::('_'::('S'::('N'::('A'::('K'::('E'::('_'::('C'::('A'::('S'::('E'::[])))))))))))))))))))),
    { separator = ('_'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('M'::('A'::('C'::('R'::('O'::('_'::('C'::('A'::('S'::('E'::[])))))))))),
    { separator = ('_'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('C'::('O'::('N'::('S'::('T'::('A'::('N'::('T'::('_'::('C'::('A'::('S'::('E'::[]))))))))))))),
    { separator = ('_'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('c'::('a'::('m'::('e'::('l'::('_'::('S'::('n'::('a'::('k'::('e'::('_'::('C'::('a'::('s'::('e'::[])))))))))))))))),
    { separator = ('_'::[]); first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('P'::('a'::('s'::('c'::('a'::('l'::('_'::('S'::('n'::('a'::('k'::('e'::('_'::('C'::('a'::('s'::('e'::[]))))))))))))))))),
    { separator = ('_'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('k'::('e'::('b'::('a'::('b'::('-'::('c'::('a'::('s'::('e'::[])))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('d'::('a'::('s'::('h'::('-'::('c'::('a'::('s'::('e'::[]))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('l'::('i'::('s'::('p'::('-'::('c'::('a'::('s'::('e'::[]))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('d'::('o'::('n'::('e'::('r'::('|'::('c'::('a'::('s'::('e'::[])))))))))),
    { separator = ('|'::[]); first_word_case = { first_letter_case = Lower;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Lower; rest_letters_case =
    Lower } }) :: ((('T'::('R'::('A'::('I'::('N'::('-'::('C'::('A'::('S'::('E'::[])))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('C'::('O'::('B'::('O'::('L'::('-'::('C'::('A'::('S'::('E'::[])))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('S'::('C'::('R'::('E'::('A'::('M'::('I'::('N'::('G'::('-'::('K'::('E'::('B'::('A'::('B'::('-'::('C'::('A'::('S'::('E'::[])))))))))))))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Upper }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Upper } }) :: ((('T'::('r'::('a'::('i'::('n'::('-'::('C'::('a'::('s'::('e'::[])))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case =
    Lower } }) :: ((('H'::('T'::('T'::('P'::('-'::('H'::('e'::('a'::('d'::('e'::('r'::('-'::('C'::('a'::('s'::('e'::[])))))))))))))))),
    { separator = ('-'::[]); first_word_case = { first_letter_case = Upper;
    rest_letters_case = Lower }; rest_words_case = { first_letter_case =
    Upper; rest_letters_case = Lower } }) :: []))))))))))))))))))))))))))))

(** val parse_capitalization_data : capitalization_data parserAction **)

let parse_capitalization_data =
  parse_strs parse_capitalization_data_list

(** val parse_capitalization_data_strict :
    char list -> capitalization_data option **)

let parse_capitalization_data_strict =
  finalize parse_capitalization_data

(** val show_zrange : zrange show **)

let show_zrange r0 =
  append ('['::[])
    (append (Hex.show_Z r0.lower)
      (append (' '::('~'::('>'::(' '::[]))))
        (append (Hex.show_Z r0.upper) (']'::[]))))

(** val show_lvl_zrange : zrange showLevel **)

let show_lvl_zrange t0 _ =
  show0 show_zrange t0

(** val bool_beq : bool -> bool -> bool **)

let bool_beq x y =
  if x then if y then true else false else if y then false else true

module Coq7_Compilers =
 struct
  module Options =
   struct
    module PHOAS =
     struct
      type with_casts = bool

      type with_all_casts = bool

      (** val default_with_casts : with_casts **)

      let default_with_casts =
        true

      (** val default_with_all_casts : with_all_casts **)

      let default_with_all_casts =
        false
     end

    type relax_zrange_opt = zrange -> zrange

    type package_name_opt = char list option

    type class_name_opt = char list option

    type skip_typedefs_opt = bool

    (** val skip_typedefs : skip_typedefs_opt -> bool **)

    let skip_typedefs skip_typedefs_opt0 =
      skip_typedefs_opt0

    type relax_adc_sbb_return_carry_to_bitwidth_opt = z list

    (** val relax_adc_sbb_return_carry_to_bitwidth :
        relax_adc_sbb_return_carry_to_bitwidth_opt -> z list **)

    let relax_adc_sbb_return_carry_to_bitwidth relax_adc_sbb_return_carry_to_bitwidth_opt0 =
      relax_adc_sbb_return_carry_to_bitwidth_opt0

    type language_specific_cast_adjustment_opt = bool

    type language_naming_conventions_opt = { public_function_naming_convention : 
                                             capitalization_convention option;
                                             private_function_naming_convention : 
                                             capitalization_convention option;
                                             public_type_naming_convention : 
                                             capitalization_convention option;
                                             private_type_naming_convention : 
                                             capitalization_convention option;
                                             variable_naming_convention : 
                                             capitalization_convention option;
                                             package_naming_convention : 
                                             capitalization_convention option;
                                             class_naming_convention : 
                                             capitalization_convention option }

    (** val public_function_naming_convention :
        language_naming_conventions_opt -> capitalization_convention option **)

    let public_function_naming_convention language_naming_conventions_opt0 =
      language_naming_conventions_opt0.public_function_naming_convention

    (** val private_function_naming_convention :
        language_naming_conventions_opt -> capitalization_convention option **)

    let private_function_naming_convention language_naming_conventions_opt0 =
      language_naming_conventions_opt0.private_function_naming_convention

    (** val public_type_naming_convention :
        language_naming_conventions_opt -> capitalization_convention option **)

    let public_type_naming_convention language_naming_conventions_opt0 =
      language_naming_conventions_opt0.public_type_naming_convention

    (** val private_type_naming_convention :
        language_naming_conventions_opt -> capitalization_convention option **)

    let private_type_naming_convention language_naming_conventions_opt0 =
      language_naming_conventions_opt0.private_type_naming_convention

    (** val package_naming_convention :
        language_naming_conventions_opt -> capitalization_convention option **)

    let package_naming_convention language_naming_conventions_opt0 =
      language_naming_conventions_opt0.package_naming_convention

    (** val class_naming_convention :
        language_naming_conventions_opt -> capitalization_convention option **)

    let class_naming_convention language_naming_conventions_opt0 =
      language_naming_conventions_opt0.class_naming_convention

    (** val default_language_naming_conventions :
        language_naming_conventions_opt **)

    let default_language_naming_conventions =
      { public_function_naming_convention = None;
        private_function_naming_convention = None;
        public_type_naming_convention = None;
        private_type_naming_convention = None; variable_naming_convention =
        None; package_naming_convention = None; class_naming_convention =
        None }

    (** val convert_to_naming_convention :
        capitalization_convention option -> char list -> char list **)

    let convert_to_naming_convention convention s0 =
      match convention with
      | Some convention0 ->
        Obj.magic convert_case { separator = ('_'::[]); first_word_case =
          { first_letter_case = Lower; rest_letters_case = Lower };
          rest_words_case = { first_letter_case = Lower; rest_letters_case =
          Lower } } convention0 s0
      | None -> s0

    (** val package_name :
        package_name_opt -> language_naming_conventions_opt -> char list ->
        char list **)

    let package_name pkg_name language_naming_conventions0 prefix1 =
      match pkg_name with
      | Some name0 -> name0
      | None ->
        convert_to_naming_convention
          language_naming_conventions0.package_naming_convention
          (if endswith ('_'::[]) prefix1
           then substring O (sub (length0 prefix1) (S O)) prefix1
           else prefix1)

    (** val class_name :
        class_name_opt -> language_naming_conventions_opt -> char list ->
        char list **)

    let class_name cls_name language_naming_conventions0 prefix1 =
      match cls_name with
      | Some name0 -> name0
      | None ->
        convert_to_naming_convention
          language_naming_conventions0.class_naming_convention
          (if endswith ('_'::[]) prefix1
           then substring O (sub (length0 prefix1) (S O)) prefix1
           else prefix1)

    (** val default_text_before_function_name : char list **)

    let default_text_before_function_name =
      'T'::('h'::('e'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::[]))))))))))))

    (** val default_text_before_type_name : char list **)

    let default_text_before_type_name =
      'T'::('h'::('e'::(' '::('t'::('y'::('p'::('e'::(' '::[]))))))))

    type documentation_options_opt = { text_before_function_name_opt : 
                                       char list option;
                                       text_before_type_name_opt : char list
                                                                   option;
                                       newline_before_package_declaration : 
                                       bool; newline_in_typedef_bounds : 
                                       bool }

    (** val text_before_function_name_opt :
        documentation_options_opt -> char list option **)

    let text_before_function_name_opt documentation_options_opt0 =
      documentation_options_opt0.text_before_function_name_opt

    (** val text_before_function_name :
        documentation_options_opt -> char list **)

    let text_before_function_name documentation_options_opt0 =
      sequence_return0
        documentation_options_opt0.text_before_function_name_opt
        default_text_before_function_name

    (** val text_before_type_name_opt :
        documentation_options_opt -> char list option **)

    let text_before_type_name_opt documentation_options_opt0 =
      documentation_options_opt0.text_before_type_name_opt

    (** val text_before_type_name : documentation_options_opt -> char list **)

    let text_before_type_name documentation_options_opt0 =
      sequence_return0 documentation_options_opt0.text_before_type_name_opt
        default_text_before_type_name

    (** val newline_before_package_declaration :
        documentation_options_opt -> bool **)

    let newline_before_package_declaration documentation_options_opt0 =
      documentation_options_opt0.newline_before_package_declaration

    (** val newline_in_typedef_bounds : documentation_options_opt -> bool **)

    let newline_in_typedef_bounds documentation_options_opt0 =
      documentation_options_opt0.newline_in_typedef_bounds

    (** val default_documentation_options : documentation_options_opt **)

    let default_documentation_options =
      { text_before_function_name_opt = None; text_before_type_name_opt =
        None; newline_before_package_declaration = false;
        newline_in_typedef_bounds = false }

    type output_options_opt = { skip_typedefs_ : skip_typedefs_opt;
                                relax_adc_sbb_return_carry_to_bitwidth_ : 
                                relax_adc_sbb_return_carry_to_bitwidth_opt;
                                language_specific_cast_adjustment_ : 
                                language_specific_cast_adjustment_opt }

    (** val skip_typedefs_ : output_options_opt -> skip_typedefs_opt **)

    let skip_typedefs_ output_options_opt0 =
      output_options_opt0.skip_typedefs_

    (** val relax_adc_sbb_return_carry_to_bitwidth_ :
        output_options_opt -> relax_adc_sbb_return_carry_to_bitwidth_opt **)

    let relax_adc_sbb_return_carry_to_bitwidth_ output_options_opt0 =
      output_options_opt0.relax_adc_sbb_return_carry_to_bitwidth_

    (** val language_specific_cast_adjustment_ :
        output_options_opt -> language_specific_cast_adjustment_opt **)

    let language_specific_cast_adjustment_ output_options_opt0 =
      output_options_opt0.language_specific_cast_adjustment_

    (** val default_output_options : output_options_opt **)

    let default_output_options =
      { skip_typedefs_ = true; relax_adc_sbb_return_carry_to_bitwidth_ = [];
        language_specific_cast_adjustment_ = true }
   end

  module ToString =
   struct
    module ZRange =
     struct
      module Coq_type =
       struct
        module Coq_base =
         struct
          (** val show_lvl_interp :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              Coq6_Compilers.ZRange.Coq_type.Coq_base.interp showLevel **)

          let rec show_lvl_interp = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z -> show_lvl (Obj.magic show_lvl_zrange)
             | Coq3_Compilers.Coq_bool -> show_lvl (Obj.magic show_lvl_bool)
             | Coq3_Compilers.Coq_nat ->
               show_lvl (Obj.magic Decimal.show_lvl_nat)
             | Coq3_Compilers.Coq_zrange ->
               show_lvl (Obj.magic show_lvl_zrange)
             | Coq3_Compilers.Coq_string ->
               show_lvl (Obj.magic show_lvl_string))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            show_lvl
              (Obj.magic show_lvl_prod (show_lvl_interp a)
                (show_lvl_interp b))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            show_lvl (Obj.magic show_lvl_list (show_lvl_interp a))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            show_lvl (Obj.magic show_lvl_option (show_lvl_interp a))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            show_lvl (Obj.magic show_lvl_unit)

          (** val show_interp :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              Coq6_Compilers.ZRange.Coq_type.Coq_base.interp show **)

          let show_interp t0 =
            show_of_ShowLevel (show_lvl_interp t0)

          module Coq_option =
           struct
            (** val show_lvl_interp :
                Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
                Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
                showLevel **)

            let rec show_lvl_interp = function
            | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
              (match t1 with
               | Coq3_Compilers.Z ->
                 show_lvl (Obj.magic show_lvl_option show_lvl_zrange)
               | Coq3_Compilers.Coq_bool ->
                 show_lvl (Obj.magic show_lvl_option show_lvl_bool)
               | Coq3_Compilers.Coq_nat ->
                 show_lvl (Obj.magic show_lvl_option Decimal.show_lvl_nat)
               | Coq3_Compilers.Coq_zrange ->
                 show_lvl (Obj.magic show_lvl_option show_lvl_zrange)
               | Coq3_Compilers.Coq_string ->
                 show_lvl (Obj.magic show_lvl_option show_lvl_string))
            | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
              show_lvl
                (Obj.magic show_lvl_prod (show_lvl_interp a)
                  (show_lvl_interp b))
            | Compilers.Coq_base.Coq_type.Coq_list a ->
              show_lvl
                (Obj.magic show_lvl_option
                  (show_lvl_list (show_lvl_interp a)))
            | Compilers.Coq_base.Coq_type.Coq_option a ->
              show_lvl
                (Obj.magic show_lvl_option
                  (show_lvl_option (show_lvl_interp a)))
            | Compilers.Coq_base.Coq_type.Coq_unit ->
              show_lvl (Obj.magic show_lvl_unit)

            (** val show_interp :
                Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
                Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp show **)

            let show_interp t0 =
              show_of_ShowLevel (show_lvl_interp t0)
           end
         end

        module Coq_option =
         struct
          (** val show_lvl_interp :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
              Compilers.Coq_type.coq_type ->
              Coq6_Compilers.ZRange.Coq_type.Coq_option.interp showLevel **)

          let show_lvl_interp = function
          | Compilers.Coq_type.Coq_base t1 ->
            show_lvl (Coq_base.Coq_option.show_lvl_interp t1)
          | Compilers.Coq_type.Coq_arrow (_, _) ->
            (fun _ _ -> '\206'::('\187'::[]))
         end
       end
     end

    module PHOAS =
     struct
      module Coq_type =
       struct
        module Coq_base =
         struct
          (** val show_base : Coq3_Compilers.base show **)

          let show_base = function
          | Coq3_Compilers.Z -> '\226'::('\132'::('\164'::[]))
          | Coq3_Compilers.Coq_bool ->
            '\240'::('\157'::('\148'::('\185'::[])))
          | Coq3_Compilers.Coq_nat -> '\226'::('\132'::('\149'::[]))
          | Coq3_Compilers.Coq_zrange ->
            'z'::('r'::('a'::('n'::('g'::('e'::[])))))
          | Coq3_Compilers.Coq_string ->
            's'::('t'::('r'::('i'::('n'::('g'::[])))))

          (** val show_lvl_base : Coq3_Compilers.base showLevel **)

          let show_lvl_base t0 _ =
            show0 show_base t0

          (** val show_lvl_type :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
              showLevel **)

          let rec show_lvl_type = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            show_lvl show_lvl_base t1
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            show_lvl_binop FullyAssoc (Level.Coq_level (Zpos (XO (XO (XO (XI
              (XO XH))))))) show_lvl_id show_lvl_id (show_lvl_type a)
              (' '::('*'::(' '::[]))) (show_lvl_type b)
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun _ ->
              append ('['::[])
                (append
                  (show_lvl_type a (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
                    (XO (XI XH)))))))))) (']'::[])))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            show_lvl_app show_lvl_const show_lvl_id (fun pat ->
              let () = pat in 'o'::('p'::('t'::('i'::('o'::('n'::[]))))))
              (show_lvl_type a)
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> '('::(')'::[]))

          (** val show_type :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type show **)

          let show_type =
            show_of_ShowLevel show_lvl_type

          (** val show_lvl_base_interp :
              Coq3_Compilers.base -> Coq3_Compilers.base_interp showLevel **)

          let show_lvl_base_interp = function
          | Coq3_Compilers.Z -> show_lvl (Obj.magic Decimal.show_lvl_Z)
          | Coq3_Compilers.Coq_bool -> show_lvl (Obj.magic show_lvl_bool)
          | Coq3_Compilers.Coq_nat ->
            show_lvl (Obj.magic Decimal.show_lvl_nat)
          | Coq3_Compilers.Coq_zrange -> show_lvl (Obj.magic show_lvl_zrange)
          | Coq3_Compilers.Coq_string -> show_lvl (Obj.magic show_lvl_string)

          (** val show_lvl_interp :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              (Coq3_Compilers.base, Coq3_Compilers.base_interp)
              Compilers.Coq_base.interp showLevel **)

          let rec show_lvl_interp = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            show_lvl (show_lvl_base_interp t1)
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            show_lvl
              (Obj.magic show_lvl_prod (show_lvl_interp a)
                (show_lvl_interp b))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            show_lvl (Obj.magic show_lvl_list (show_lvl_interp a))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            show_lvl (Obj.magic show_lvl_option (show_lvl_interp a))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            show_lvl (Obj.magic show_lvl_unit)

          (** val show_interp :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              (Coq3_Compilers.base, Coq3_Compilers.base_interp)
              Compilers.Coq_base.interp show **)

          let show_interp t0 =
            show_of_ShowLevel (show_lvl_interp t0)

          (** val show_lvl :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
              showLevel **)

          let show_lvl =
            show_lvl_type

          (** val show :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type show **)

          let show =
            show_type
         end

        (** val show_lvl_for_each_lhs_of_arrow :
            ('a1 Compilers.Coq_type.coq_type -> 'a2 showLevel) -> 'a1
            Compilers.Coq_type.coq_type -> ('a1, 'a2)
            Compilers.Coq_type.for_each_lhs_of_arrow showLevel **)

        let rec show_lvl_for_each_lhs_of_arrow show_f = function
        | Compilers.Coq_type.Coq_base _ -> show_lvl (Obj.magic show_lvl_unit)
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          sequence_return0
            (match d with
             | Compilers.Coq_type.Coq_base _ ->
               Some (fun pat ->
                 let (x, _) = Obj.magic pat in show_lvl (show_f s0) x)
             | Compilers.Coq_type.Coq_arrow (_, _) -> None)
            (show_lvl
              (Obj.magic show_lvl_prod (show_f s0)
                (show_lvl_for_each_lhs_of_arrow show_f d)))

        (** val show_lvl_type :
            'a1 showLevel -> 'a1 Compilers.Coq_type.coq_type showLevel **)

        let rec show_lvl_type s0 = function
        | Compilers.Coq_type.Coq_base t1 -> show_lvl s0 t1
        | Compilers.Coq_type.Coq_arrow (s1, d) ->
          show_lvl_binop RightAssoc (Level.Coq_level (Zpos (XI (XI (XO (XO
            (XO (XI XH)))))))) show_lvl_id show_lvl_id (show_lvl_type s0 s1)
            (' '::('\226'::('\134'::('\146'::(' '::[])))))
            (show_lvl_type s0 d)

        (** val show_lvl :
            'a1 showLevel -> 'a1 Compilers.Coq_type.coq_type showLevel **)

        let show_lvl =
          show_lvl_type

        (** val show_type :
            'a1 show -> 'a1 Compilers.Coq_type.coq_type show **)

        let show_type s0 =
          let x = fun h t0 _ -> show0 h t0 in
          show_of_ShowLevel (show_lvl_type (x s0))

        (** val show : 'a1 show -> 'a1 Compilers.Coq_type.coq_type show **)

        let show =
          show_type
       end

      (** val show_range_or_ctype : zrange show **)

      let show_range_or_ctype v =
        if (&&) (Coq_Z.eqb v.lower Z0)
             (Coq_Z.eqb v.upper
               (Coq_Z.sub
                 (Coq_Z.pow (Zpos (XO XH))
                   (Coq_Z.log2 (Coq_Z.add v.upper (Zpos XH)))) (Zpos XH)))
        then append ('u'::('i'::('n'::('t'::[]))))
               (append
                 (Coq0_Z.to_string (Coq_Z.log2 (Coq_Z.add v.upper (Zpos XH))))
                 ('_'::('t'::[])))
        else let lg2 = Coq_Z.add (Zpos XH) (Coq_Z.log2 (Coq_Z.opp v.lower)) in
             if (&&)
                  (Coq_Z.eqb v.lower
                    (Coq_Z.opp
                      (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub lg2 (Zpos XH)))))
                  (Coq_Z.eqb v.upper
                    (Coq_Z.sub
                      (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub lg2 (Zpos XH)))
                      (Zpos XH)))
             then append ('i'::('n'::('t'::[])))
                    (append (Coq0_Z.to_string lg2) ('_'::('t'::[])))
             else show0 show_zrange v

      (** val show_lvl_compact_Z : z showLevel **)

      let show_lvl_compact_Z v =
        let is_neg = Coq_Z.ltb v Z0 in
        (if is_neg
         then show_lvl_unop (Level.Coq_level (Zpos (XI (XI (XO (XO (XO
                XH))))))) ('-'::[]) show_lvl_id
         else show_lvl show_lvl_id)
          (let v0 = Coq_Z.abs v in
           if Coq_Z.leb v0 (Coq_Z.pow (Zpos (XO XH)) (Zpos (XO (XO (XO XH)))))
           then Decimal.show_lvl_Z v0
           else if Coq_Z.eqb v0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 v0))
                then show_lvl_binop RightAssoc (Level.Coq_level (Zpos (XO (XI
                       (XI (XI XH)))))) Decimal.show_lvl_Z show_lvl_id (Zpos
                       (XO XH)) ('^'::[]) (Decimal.show_lvl_Z (Coq_Z.log2 v0))
                else if Coq_Z.eqb v0
                          (Coq_Z.sub
                            (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2_up v0))
                            (Zpos XH))
                     then show_lvl_binop LeftAssoc (Level.Coq_level (Zpos (XO
                            (XI (XO (XO (XI XH))))))) show_lvl_id
                            Decimal.show_lvl_Z
                            (show_lvl_binop RightAssoc (Level.Coq_level (Zpos
                              (XO (XI (XI (XI XH)))))) Decimal.show_lvl_Z
                              show_lvl_id (Zpos (XO XH)) ('^'::[])
                              (Decimal.show_lvl_Z (Coq_Z.log2_up v0)))
                            ('-'::[]) (Zpos XH)
                     else Hex.show_lvl_Z v0)

      (** val make_castb :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
          char list option **)

      let rec make_castb = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z -> Obj.magic option_map show_range_or_ctype
         | Coq3_Compilers.Coq_bool -> (fun _ -> None)
         | Coq3_Compilers.Coq_nat -> (fun _ -> None)
         | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
         | Coq3_Compilers.Coq_string -> (fun _ -> None))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun pat ->
          let (r1, r2) = Obj.magic pat in
          (match make_castb a r1 with
           | Some c0 ->
             (match make_castb b r2 with
              | Some c2 -> Some (append c0 (append (','::(' '::[])) c2))
              | None -> Some (append c0 (','::(' '::('?'::('?'::[]))))))
           | None ->
             (match make_castb b r2 with
              | Some c0 -> Some (append ('?'::('?'::(','::(' '::[])))) c0)
              | None -> None)))
      | Compilers.Coq_base.Coq_type.Coq_list a ->
        (fun r0 ->
          match Obj.magic r0 with
          | Some ls ->
            (match ls with
             | [] -> Some ('v'::('o'::('i'::('d'::('['::('0'::(']'::[])))))))
             | r1 :: rs ->
               let n3 = show0 Decimal.show_nat (length ls) in
               let c1 = make_castb a r1 in
               let all_same =
                 forallb
                   (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp_beq
                     a a r1) rs
               in
               Some
               (append
                 (if all_same
                  then (match c1 with
                        | Some c2 -> c2
                        | None -> '?'::('?'::[]))
                  else '?'::('?'::[]))
                 (append ('['::[]) (append n3 (']'::[])))))
          | None -> None)
      | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None)

      (** val make_cast :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> char list option **)

      let make_cast = function
      | Compilers.Coq_type.Coq_base t1 -> make_castb t1
      | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None)

      (** val maybe_wrap_cast :
          bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> ((Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp) ->
          Level.coq_Level -> char list **)

      let maybe_wrap_cast with_cast t0 xr lvl =
        if with_cast
        then (match make_cast t0 (snd xr) with
              | Some c0 ->
                append ('('::[])
                  (append c0
                    (append (')'::[])
                      (fst xr
                        (Level.next (Level.Coq_level (Zpos (XO (XI (XO
                          XH)))))))))
              | None -> fst xr lvl)
        else fst xr lvl

      (** val show_application :
          bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Level.coq_Level -> char list) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          (Level.coq_Level ->
          char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> Level.coq_Level ->
          char list **)

      let show_application with_casts0 t0 f args0 =
        (match t0 with
         | Compilers.Coq_type.Coq_base _ ->
           (fun pat -> let () = Obj.magic pat in f)
         | Compilers.Coq_type.Coq_arrow (s0, d) ->
           (fun xs lvl ->
             let x = fun t1 x ->
               maybe_wrap_cast with_casts0 t1 x (Level.Coq_level (Zpos (XO
                 (XI (XO XH)))))
             in
             let x0 = fun t1 t2 _ -> show0 (x t1) t2 in
             maybe_wrap_parens
               (Level.ltb lvl
                 (Level.prev (Level.Coq_level (Zpos (XO (XI (XO XH)))))))
               (append
                 (f (Level.prev (Level.Coq_level (Zpos (XO (XI (XO XH)))))))
                 (show_lvl
                   (Coq_type.show_lvl_for_each_lhs_of_arrow x0
                     (Compilers.Coq_type.Coq_arrow (s0, d))) xs
                   Level.Coq_neg_inf)))) args0

      module Coq_ident =
       struct
        (** val show_lvl_ident :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.ident showLevel **)

        let show_lvl_ident _ = function
        | Coq3_Compilers.Coq_ident_Literal (_t, v) ->
          (match _t with
           | Coq3_Compilers.Z -> (fun v0 -> show_lvl_compact_Z (Obj.magic v0))
           | Coq3_Compilers.Coq_bool ->
             (fun v0 -> show_lvl (Obj.magic show_lvl_bool) v0)
           | Coq3_Compilers.Coq_nat ->
             (fun v0 -> show_lvl (Obj.magic Decimal.show_lvl_nat) v0)
           | Coq3_Compilers.Coq_zrange ->
             (fun v0 -> show_lvl (Obj.magic show_lvl_zrange) v0)
           | Coq3_Compilers.Coq_string ->
             (fun v0 -> show_lvl (Obj.magic show_lvl_string) v0)) v
        | Coq3_Compilers.Coq_ident_comment _ ->
          neg_wrap_parens ('c'::('o'::('m'::('m'::('e'::('n'::('t'::[])))))))
        | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
          neg_wrap_parens
            ('c'::('o'::('m'::('m'::('e'::('n'::('t'::('_'::('n'::('o'::('_'::('k'::('e'::('e'::('p'::[])))))))))))))))
        | Coq3_Compilers.Coq_ident_value_barrier ->
          neg_wrap_parens
            ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))
        | Coq3_Compilers.Coq_ident_Nat_succ ->
          neg_wrap_parens
            ('N'::('a'::('t'::('.'::('s'::('u'::('c'::('c'::[]))))))))
        | Coq3_Compilers.Coq_ident_Nat_pred ->
          neg_wrap_parens
            ('N'::('a'::('t'::('.'::('p'::('r'::('e'::('d'::[]))))))))
        | Coq3_Compilers.Coq_ident_Nat_max ->
          neg_wrap_parens ('N'::('a'::('t'::('.'::('m'::('a'::('x'::[])))))))
        | Coq3_Compilers.Coq_ident_Nat_mul ->
          neg_wrap_parens ('N'::('a'::('t'::('.'::('m'::('u'::('l'::[])))))))
        | Coq3_Compilers.Coq_ident_Nat_add ->
          neg_wrap_parens ('N'::('a'::('t'::('.'::('a'::('d'::('d'::[])))))))
        | Coq3_Compilers.Coq_ident_Nat_sub ->
          neg_wrap_parens ('N'::('a'::('t'::('.'::('s'::('u'::('b'::[])))))))
        | Coq3_Compilers.Coq_ident_Nat_eqb ->
          neg_wrap_parens ('N'::('a'::('t'::('.'::('e'::('q'::('b'::[])))))))
        | Coq3_Compilers.Coq_ident_nil _ -> neg_wrap_parens ('['::(']'::[]))
        | Coq3_Compilers.Coq_ident_cons _ ->
          (fun _ -> '('::(':'::(':'::(')'::[]))))
        | Coq3_Compilers.Coq_ident_tt -> (fun _ -> '('::(')'::[]))
        | Coq3_Compilers.Coq_ident_pair (_, _) ->
          (fun _ -> '('::(','::(')'::[])))
        | Coq3_Compilers.Coq_ident_fst (_, _) ->
          neg_wrap_parens ('f'::('s'::('t'::[])))
        | Coq3_Compilers.Coq_ident_snd (_, _) ->
          neg_wrap_parens ('s'::('n'::('d'::[])))
        | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
          neg_wrap_parens
            ('p'::('r'::('o'::('d'::('_'::('r'::('e'::('c'::('t'::[])))))))))
        | Coq3_Compilers.Coq_ident_bool_rect _ ->
          neg_wrap_parens
            ('b'::('o'::('o'::('l'::('_'::('r'::('e'::('c'::('t'::[])))))))))
        | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
          neg_wrap_parens
            ('b'::('o'::('o'::('l'::('_'::('r'::('e'::('c'::('t'::('_'::('n'::('o'::('d'::('e'::('p'::[])))))))))))))))
        | Coq3_Compilers.Coq_ident_nat_rect _ ->
          neg_wrap_parens
            ('n'::('a'::('t'::('_'::('r'::('e'::('c'::('t'::[]))))))))
        | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
          neg_wrap_parens
            ('e'::('a'::('g'::('e'::('r'::('_'::('n'::('a'::('t'::('_'::('r'::('e'::('c'::('t'::[]))))))))))))))
        | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
          neg_wrap_parens
            ('n'::('a'::('t'::('_'::('r'::('e'::('c'::('t'::('('::('\226'::('\134'::('\146'::(')'::[])))))))))))))
        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
          neg_wrap_parens
            ('e'::('a'::('g'::('e'::('r'::('_'::('n'::('a'::('t'::('_'::('r'::('e'::('c'::('t'::('('::('\226'::('\134'::('\146'::(')'::[])))))))))))))))))))
        | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
          neg_wrap_parens
            ('l'::('i'::('s'::('t'::('_'::('r'::('e'::('c'::('t'::[])))))))))
        | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
          neg_wrap_parens
            ('e'::('a'::('g'::('e'::('r'::('_'::('l'::('i'::('s'::('t'::('_'::('r'::('e'::('c'::('t'::[])))))))))))))))
        | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
          neg_wrap_parens
            ('l'::('i'::('s'::('t'::('_'::('r'::('e'::('c'::('t'::('('::('\226'::('\134'::('\146'::(')'::[]))))))))))))))
        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
          neg_wrap_parens
            ('e'::('a'::('g'::('e'::('r'::('_'::('l'::('i'::('s'::('t'::('_'::('r'::('e'::('c'::('t'::('('::('\226'::('\134'::('\146'::(')'::[]))))))))))))))))))))
        | Coq3_Compilers.Coq_ident_list_case (_, _) ->
          neg_wrap_parens
            ('l'::('i'::('s'::('t'::('_'::('c'::('a'::('s'::('e'::[])))))))))
        | Coq3_Compilers.Coq_ident_List_length _ ->
          neg_wrap_parens ('l'::('e'::('n'::('g'::('t'::('h'::[]))))))
        | Coq3_Compilers.Coq_ident_List_seq ->
          neg_wrap_parens ('s'::('e'::('q'::[])))
        | Coq3_Compilers.Coq_ident_List_firstn _ ->
          neg_wrap_parens ('f'::('i'::('r'::('s'::('t'::('n'::[]))))))
        | Coq3_Compilers.Coq_ident_List_skipn _ ->
          neg_wrap_parens ('s'::('k'::('i'::('p'::('n'::[])))))
        | Coq3_Compilers.Coq_ident_List_repeat _ ->
          neg_wrap_parens ('r'::('e'::('p'::('e'::('a'::('t'::[]))))))
        | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
          neg_wrap_parens ('c'::('o'::('m'::('b'::('i'::('n'::('e'::[])))))))
        | Coq3_Compilers.Coq_ident_List_map (_, _) ->
          neg_wrap_parens ('m'::('a'::('p'::[])))
        | Coq3_Compilers.Coq_ident_List_app _ ->
          (fun _ -> '('::('+'::('+'::(')'::[]))))
        | Coq3_Compilers.Coq_ident_List_rev _ ->
          neg_wrap_parens ('r'::('e'::('v'::[])))
        | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
          neg_wrap_parens
            ('f'::('l'::('a'::('t'::('_'::('m'::('a'::('p'::[]))))))))
        | Coq3_Compilers.Coq_ident_List_partition _ ->
          neg_wrap_parens
            ('p'::('a'::('r'::('t'::('i'::('t'::('i'::('o'::('n'::[])))))))))
        | Coq3_Compilers.Coq_ident_List_filter _ ->
          neg_wrap_parens ('f'::('i'::('l'::('t'::('e'::('r'::[]))))))
        | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
          neg_wrap_parens
            ('f'::('o'::('l'::('d'::('_'::('r'::('i'::('g'::('h'::('t'::[]))))))))))
        | Coq3_Compilers.Coq_ident_List_update_nth _ ->
          neg_wrap_parens
            ('u'::('p'::('d'::('a'::('t'::('e'::('_'::('n'::('t'::('h'::[]))))))))))
        | Coq3_Compilers.Coq_ident_List_nth_default _ ->
          neg_wrap_parens ('n'::('t'::('h'::[])))
        | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
          neg_wrap_parens
            ('e'::('a'::('g'::('e'::('r'::('_'::('n'::('t'::('h'::[])))))))))
        | Coq3_Compilers.Coq_ident_Z_add -> (fun _ -> '('::('+'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_mul ->
          (fun _ -> '('::(' '::('*'::(' '::(')'::[])))))
        | Coq3_Compilers.Coq_ident_Z_pow -> (fun _ -> '('::('^'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_sub -> (fun _ -> '('::('-'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_opp -> (fun _ -> '-'::[])
        | Coq3_Compilers.Coq_ident_Z_div -> (fun _ -> '('::('/'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_modulo ->
          (fun _ -> '('::('m'::('o'::('d'::(')'::[])))))
        | Coq3_Compilers.Coq_ident_Z_eqb -> (fun _ -> '('::('='::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_leb ->
          (fun _ -> '('::('\226'::('\137'::('\164'::(')'::[])))))
        | Coq3_Compilers.Coq_ident_Z_ltb -> (fun _ -> '('::('<'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_geb ->
          (fun _ -> '('::('\226'::('\137'::('\165'::(')'::[])))))
        | Coq3_Compilers.Coq_ident_Z_gtb -> (fun _ -> '('::('>'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_log2 ->
          neg_wrap_parens
            ('l'::('o'::('g'::('\226'::('\130'::('\130'::[]))))))
        | Coq3_Compilers.Coq_ident_Z_log2_up ->
          neg_wrap_parens
            ('\226'::('\140'::('\136'::('l'::('o'::('g'::('\226'::('\130'::('\130'::('\226'::('\140'::('\137'::[]))))))))))))
        | Coq3_Compilers.Coq_ident_Z_of_nat ->
          (fun _ ->
            '('::('\226'::('\132'::('\149'::('\226'::('\134'::('\146'::('\226'::('\132'::('\164'::(')'::[])))))))))))
        | Coq3_Compilers.Coq_ident_Z_to_nat ->
          (fun _ ->
            '('::('\226'::('\132'::('\164'::('\226'::('\134'::('\146'::('\226'::('\132'::('\149'::(')'::[])))))))))))
        | Coq3_Compilers.Coq_ident_Z_shiftr ->
          (fun _ -> '('::('>'::('>'::(')'::[]))))
        | Coq3_Compilers.Coq_ident_Z_shiftl ->
          (fun _ -> '('::('<'::('<'::(')'::[]))))
        | Coq3_Compilers.Coq_ident_Z_land -> (fun _ -> '('::('&'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_lor -> (fun _ -> '('::('|'::(')'::[])))
        | Coq3_Compilers.Coq_ident_Z_min ->
          neg_wrap_parens ('m'::('i'::('n'::[])))
        | Coq3_Compilers.Coq_ident_Z_max ->
          neg_wrap_parens ('m'::('a'::('x'::[])))
        | Coq3_Compilers.Coq_ident_Z_mul_split ->
          neg_wrap_parens
            ('Z'::('.'::('m'::('u'::('l'::('_'::('s'::('p'::('l'::('i'::('t'::[])))))))))))
        | Coq3_Compilers.Coq_ident_Z_mul_high ->
          neg_wrap_parens
            ('Z'::('.'::('m'::('u'::('l'::('_'::('h'::('i'::('g'::('h'::[]))))))))))
        | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
          neg_wrap_parens
            ('Z'::('.'::('a'::('d'::('d'::('_'::('g'::('e'::('t'::('_'::('c'::('a'::('r'::('r'::('y'::[])))))))))))))))
        | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
          neg_wrap_parens
            ('Z'::('.'::('a'::('d'::('d'::('_'::('w'::('i'::('t'::('h'::('_'::('c'::('a'::('r'::('r'::('y'::[]))))))))))))))))
        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
          neg_wrap_parens
            ('Z'::('.'::('a'::('d'::('d'::('_'::('w'::('i'::('t'::('h'::('_'::('g'::('e'::('t'::('_'::('c'::('a'::('r'::('r'::('y'::[]))))))))))))))))))))
        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
          neg_wrap_parens
            ('Z'::('.'::('s'::('u'::('b'::('_'::('g'::('e'::('t'::('_'::('b'::('o'::('r'::('r'::('o'::('w'::[]))))))))))))))))
        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
          neg_wrap_parens
            ('Z'::('.'::('s'::('u'::('b'::('_'::('w'::('i'::('t'::('h'::('_'::('g'::('e'::('t'::('_'::('b'::('o'::('r'::('r'::('o'::('w'::[])))))))))))))))))))))
        | Coq3_Compilers.Coq_ident_Z_ltz ->
          neg_wrap_parens ('Z'::('.'::('l'::('t'::('z'::[])))))
        | Coq3_Compilers.Coq_ident_Z_zselect ->
          neg_wrap_parens
            ('Z'::('.'::('z'::('s'::('e'::('l'::('e'::('c'::('t'::[])))))))))
        | Coq3_Compilers.Coq_ident_Z_add_modulo ->
          neg_wrap_parens
            ('Z'::('.'::('a'::('d'::('d'::('_'::('m'::('o'::('d'::('u'::('l'::('o'::[]))))))))))))
        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
          neg_wrap_parens
            ('Z'::('.'::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('i'::('n'::('g'::('_'::('s'::('h'::('i'::('f'::('t'::('l'::[])))))))))))))))))))
        | Coq3_Compilers.Coq_ident_Z_bneg -> neg_wrap_parens ('!'::[])
        | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> neg_wrap_parens ('~'::[])
        | Coq3_Compilers.Coq_ident_Z_lxor ->
          neg_wrap_parens ('\226'::('\138'::('\149'::[])))
        | Coq3_Compilers.Coq_ident_Z_rshi ->
          neg_wrap_parens ('Z'::('.'::('r'::('s'::('h'::('i'::[]))))))
        | Coq3_Compilers.Coq_ident_Z_cc_m ->
          neg_wrap_parens ('Z'::('.'::('c'::('c'::('_'::('m'::[]))))))
        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
          neg_wrap_parens
            ('Z'::('.'::('c'::('o'::('m'::('b'::('i'::('n'::('e'::('_'::('a'::('t'::('_'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::[])))))))))))))))))))))
        | Coq3_Compilers.Coq_ident_Z_cast ->
          neg_wrap_parens ('Z'::('.'::('c'::('a'::('s'::('t'::[]))))))
        | Coq3_Compilers.Coq_ident_Z_cast2 ->
          neg_wrap_parens ('Z'::('.'::('c'::('a'::('s'::('t'::('2'::[])))))))
        | Coq3_Compilers.Coq_ident_Some _ ->
          neg_wrap_parens ('S'::('o'::('m'::('e'::[]))))
        | Coq3_Compilers.Coq_ident_None _ ->
          neg_wrap_parens ('N'::('o'::('n'::('e'::[]))))
        | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
          neg_wrap_parens
            ('o'::('p'::('t'::('i'::('o'::('n'::('_'::('r'::('e'::('c'::('t'::[])))))))))))
        | Coq3_Compilers.Coq_ident_Build_zrange ->
          neg_wrap_parens
            ('B'::('u'::('i'::('l'::('d'::('_'::('z'::('r'::('a'::('n'::('g'::('e'::[]))))))))))))
        | Coq3_Compilers.Coq_ident_zrange_rect _ ->
          neg_wrap_parens
            ('z'::('r'::('a'::('n'::('g'::('e'::('_'::('r'::('e'::('c'::('t'::[])))))))))))
        | Coq3_Compilers.Coq_ident_fancy_add ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('a'::('d'::('d'::[])))))))))
        | Coq3_Compilers.Coq_ident_fancy_addc ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('a'::('d'::('d'::('c'::[]))))))))))
        | Coq3_Compilers.Coq_ident_fancy_sub ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('s'::('u'::('b'::[])))))))))
        | Coq3_Compilers.Coq_ident_fancy_subb ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('s'::('u'::('b'::('b'::[]))))))))))
        | Coq3_Compilers.Coq_ident_fancy_mulll ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('m'::('u'::('l'::('l'::('l'::[])))))))))))
        | Coq3_Compilers.Coq_ident_fancy_mullh ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('m'::('u'::('l'::('l'::('h'::[])))))))))))
        | Coq3_Compilers.Coq_ident_fancy_mulhl ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('m'::('u'::('l'::('h'::('l'::[])))))))))))
        | Coq3_Compilers.Coq_ident_fancy_mulhh ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('m'::('u'::('l'::('h'::('h'::[])))))))))))
        | Coq3_Compilers.Coq_ident_fancy_rshi ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('r'::('s'::('h'::('i'::[]))))))))))
        | Coq3_Compilers.Coq_ident_fancy_selc ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('s'::('e'::('l'::('c'::[]))))))))))
        | Coq3_Compilers.Coq_ident_fancy_selm ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('s'::('e'::('l'::('m'::[]))))))))))
        | Coq3_Compilers.Coq_ident_fancy_sell ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('s'::('e'::('l'::('l'::[]))))))))))
        | Coq3_Compilers.Coq_ident_fancy_addm ->
          neg_wrap_parens
            ('f'::('a'::('n'::('c'::('y'::('.'::('a'::('d'::('d'::('m'::[]))))))))))

        (** val show_ident :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.ident show **)

        let show_ident t0 =
          show_of_ShowLevel (show_lvl_ident t0)

        (** val conservative_binop_precedence_table :
            (char list * (associativity * Level.coq_Level)) list **)

        let conservative_binop_precedence_table =
          (('*'::('\226'::('\132'::('\149'::[])))), (FullyAssoc,
            (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
            XH))))))))) :: ((('+'::('\226'::('\132'::('\149'::[])))),
            (FullyAssoc, (Level.Coq_level (Zpos (XO (XI (XO (XO (XI
            XH))))))))) :: ((('-'::('\226'::('\132'::('\149'::[])))),
            (LeftAssoc, (Level.Coq_level (Zpos (XO (XI (XO (XO (XI
            XH))))))))) :: ((('='::('\226'::('\132'::('\149'::[])))),
            (NoAssoc, (Level.Coq_level (Zpos (XO (XI (XI (XO (XO (XO
            XH)))))))))) :: (((':'::(':'::[])), (RightAssoc, (Level.Coq_level
            (Zpos (XO (XO (XI (XI (XI XH))))))))) :: ((('+'::('+'::[])),
            (FullyAssoc, (Level.Coq_level (Zpos (XO (XO (XI (XI (XI
            XH))))))))) :: ((('*'::[]), (FullyAssoc, (Level.Coq_level (Zpos
            (XO (XO (XO (XI (XO XH))))))))) :: ((('/'::[]), (NoAssoc,
            (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
            XH))))))))) :: ((('+'::[]), (FullyAssoc, (Level.Coq_level (Zpos
            (XO (XI (XO (XO (XI XH))))))))) :: ((('-'::[]), (LeftAssoc,
            (Level.Coq_level (Zpos (XO (XI (XO (XO (XI
            XH))))))))) :: ((('^'::[]), (RightAssoc, (Level.Coq_level (Zpos
            (XO (XI (XI (XI XH)))))))) :: ((('\226'::('\138'::('\149'::[]))),
            (LeftAssoc, (Level.Coq_level (Zpos (XO (XI (XO (XO (XI
            XH))))))))) :: ((('m'::('o'::('d'::[]))), (LeftAssoc,
            (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
            XH))))))))) :: ((('='::[]), (NoAssoc, (Level.Coq_level (Zpos (XO
            (XI (XI (XO (XO (XO XH)))))))))) :: ((('<'::[]), (NoAssoc,
            (Level.Coq_level (Zpos (XO (XI (XI (XO (XO (XO
            XH)))))))))) :: ((('\226'::('\137'::('\164'::[]))), (NoAssoc,
            (Level.Coq_level (Zpos (XO (XI (XI (XO (XO (XO
            XH)))))))))) :: ((('>'::[]), (NoAssoc, (Level.Coq_level (Zpos (XO
            (XI (XI (XO (XO (XO
            XH)))))))))) :: ((('\226'::('\137'::('\165'::[]))), (NoAssoc,
            (Level.Coq_level (Zpos (XO (XI (XI (XO (XO (XO
            XH)))))))))) :: ((('>'::('>'::[])), ((ExplicitAssoc
            ((Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH))))))),
            (Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH))))))))),
            (Level.Coq_level (Zpos (XI (XI (XI (XO (XI
            XH))))))))) :: ((('<'::('<'::[])), ((ExplicitAssoc
            ((Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH))))))),
            (Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH))))))))),
            (Level.Coq_level (Zpos (XI (XI (XI (XO (XI
            XH))))))))) :: ((('&'::[]), ((ExplicitAssoc ((Level.Coq_level
            (Zpos (XI (XI (XO (XO (XO XH))))))), (Level.Coq_level (Zpos (XI
            (XI (XO (XO (XO XH))))))))), (Level.Coq_level (Zpos (XI (XI (XI
            (XO (XI XH))))))))) :: ((('|'::[]), ((ExplicitAssoc
            ((Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH))))))),
            (Level.Coq_level (Zpos (XI (XI (XO (XO (XO XH))))))))),
            (Level.Coq_level (Zpos (XI (XI (XI (XO (XI
            XH))))))))) :: (((','::(' '::[])), (LeftAssoc,
            (Level.prev (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
              XH)))))))))))) :: []))))))))))))))))))))))

        (** val conservative_preop_precedence_table :
            (char list * (associativity * Level.coq_Level)) list **)

        let conservative_preop_precedence_table =
          (('-'::[]), (RightAssoc, (Level.Coq_level (Zpos (XI (XI (XO (XO (XO
            XH))))))))) :: ((('!'::[]), (RightAssoc, (Level.Coq_level (Zpos
            (XI (XI (XO (XI (XO (XO XH)))))))))) :: [])

        (** val conservative_postop_precedence_table :
            (char list * (associativity * Level.coq_Level)) list **)

        let conservative_postop_precedence_table =
          (('.'::('+'::('1'::[]))), (LeftAssoc, (Level.Coq_level (Zpos (XO
            (XI (XO XH))))))) :: ((('.'::('-'::('1'::[]))), (LeftAssoc,
            (Level.Coq_level (Zpos (XO (XI (XO
            XH))))))) :: ((('\226'::('\130'::('\129'::[]))), (LeftAssoc,
            (Level.Coq_level Z0))) :: ((('\226'::('\130'::('\130'::[]))),
            (LeftAssoc, (Level.Coq_level Z0))) :: [])))

        (** val lookup_show_lvl_binop :
            bool -> (char list * (associativity * Level.coq_Level)) list ->
            char list -> __ **)

        let lookup_show_lvl_binop with_space table binop =
          match find (fun pat -> let (binop', _) = pat in eqb0 binop binop')
                  table with
          | Some p ->
            let (_, p0) = p in
            let (binop_assoc, binop_lvl) = p0 in
            Obj.magic (fun x y ->
              show_lvl_binop binop_assoc binop_lvl show_lvl_id show_lvl_id x
                (if with_space
                 then append (' '::[]) (append binop (' '::[]))
                 else binop) y)
          | None -> Obj.magic __

        (** val lookup_show_lvl_preop :
            (char list * (associativity * Level.coq_Level)) list -> char list
            -> __ **)

        let lookup_show_lvl_preop table preop =
          match find (fun pat -> let (op', _) = pat in eqb0 preop op') table with
          | Some p ->
            let (op1, p0) = p in
            let (op_assoc, op_lvl) = p0 in
            Obj.magic (fun x ->
              show_lvl_preop_assoc op_assoc op_lvl show_lvl_id op1 x)
          | None -> Obj.magic __

        (** val lookup_show_lvl_postop :
            (char list * (associativity * Level.coq_Level)) list -> char list
            -> __ **)

        let lookup_show_lvl_postop table postop =
          match find (fun pat -> let (op', _) = pat in eqb0 postop op') table with
          | Some p ->
            let (op1, p0) = p in
            let (op_assoc, op_lvl) = p0 in
            Obj.magic (fun x ->
              show_lvl_postop_assoc op_assoc op_lvl show_lvl_id x op1)
          | None -> Obj.magic __

        (** val ident_to_op_string :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> Coq3_Compilers.ident -> char list **)

        let ident_to_op_string _ _ = function
        | Coq3_Compilers.Coq_ident_Literal (_, _) -> []
        | Coq3_Compilers.Coq_ident_comment _ -> []
        | Coq3_Compilers.Coq_ident_comment_no_keep _ -> []
        | Coq3_Compilers.Coq_ident_value_barrier -> []
        | Coq3_Compilers.Coq_ident_Nat_succ -> '.'::('+'::('1'::[]))
        | Coq3_Compilers.Coq_ident_Nat_pred -> '.'::('-'::('1'::[]))
        | Coq3_Compilers.Coq_ident_Nat_max -> []
        | Coq3_Compilers.Coq_ident_Nat_mul ->
          '*'::('\226'::('\132'::('\149'::[])))
        | Coq3_Compilers.Coq_ident_Nat_add ->
          '+'::('\226'::('\132'::('\149'::[])))
        | Coq3_Compilers.Coq_ident_Nat_sub ->
          '-'::('\226'::('\132'::('\149'::[])))
        | Coq3_Compilers.Coq_ident_Nat_eqb ->
          '='::('\226'::('\132'::('\149'::[])))
        | Coq3_Compilers.Coq_ident_nil _ -> []
        | Coq3_Compilers.Coq_ident_cons _ -> ':'::(':'::[])
        | Coq3_Compilers.Coq_ident_tt -> []
        | Coq3_Compilers.Coq_ident_pair (_, _) -> ','::(' '::[])
        | Coq3_Compilers.Coq_ident_fst (_, _) ->
          '\226'::('\130'::('\129'::[]))
        | Coq3_Compilers.Coq_ident_snd (_, _) ->
          '\226'::('\130'::('\130'::[]))
        | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> []
        | Coq3_Compilers.Coq_ident_bool_rect _ -> []
        | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> []
        | Coq3_Compilers.Coq_ident_nat_rect _ -> []
        | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> []
        | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> []
        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> []
        | Coq3_Compilers.Coq_ident_list_rect (_, _) -> []
        | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> []
        | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> []
        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> []
        | Coq3_Compilers.Coq_ident_list_case (_, _) -> []
        | Coq3_Compilers.Coq_ident_List_length _ -> []
        | Coq3_Compilers.Coq_ident_List_seq -> []
        | Coq3_Compilers.Coq_ident_List_firstn _ -> []
        | Coq3_Compilers.Coq_ident_List_skipn _ -> []
        | Coq3_Compilers.Coq_ident_List_repeat _ -> []
        | Coq3_Compilers.Coq_ident_List_combine (_, _) -> []
        | Coq3_Compilers.Coq_ident_List_map (_, _) -> []
        | Coq3_Compilers.Coq_ident_List_app _ -> '+'::('+'::[])
        | Coq3_Compilers.Coq_ident_List_rev _ -> []
        | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> []
        | Coq3_Compilers.Coq_ident_List_partition _ -> []
        | Coq3_Compilers.Coq_ident_List_filter _ -> []
        | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> []
        | Coq3_Compilers.Coq_ident_List_update_nth _ -> []
        | Coq3_Compilers.Coq_ident_List_nth_default _ -> []
        | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> []
        | Coq3_Compilers.Coq_ident_Z_add -> '+'::[]
        | Coq3_Compilers.Coq_ident_Z_mul -> '*'::[]
        | Coq3_Compilers.Coq_ident_Z_pow -> '^'::[]
        | Coq3_Compilers.Coq_ident_Z_sub -> '-'::[]
        | Coq3_Compilers.Coq_ident_Z_opp -> '-'::[]
        | Coq3_Compilers.Coq_ident_Z_div -> '/'::[]
        | Coq3_Compilers.Coq_ident_Z_modulo -> 'm'::('o'::('d'::[]))
        | Coq3_Compilers.Coq_ident_Z_eqb -> '='::[]
        | Coq3_Compilers.Coq_ident_Z_leb -> '\226'::('\137'::('\164'::[]))
        | Coq3_Compilers.Coq_ident_Z_ltb -> '<'::[]
        | Coq3_Compilers.Coq_ident_Z_geb -> '\226'::('\137'::('\165'::[]))
        | Coq3_Compilers.Coq_ident_Z_gtb -> '>'::[]
        | Coq3_Compilers.Coq_ident_Z_log2 -> []
        | Coq3_Compilers.Coq_ident_Z_log2_up -> []
        | Coq3_Compilers.Coq_ident_Z_of_nat -> []
        | Coq3_Compilers.Coq_ident_Z_to_nat -> []
        | Coq3_Compilers.Coq_ident_Z_shiftr -> '>'::('>'::[])
        | Coq3_Compilers.Coq_ident_Z_shiftl -> '<'::('<'::[])
        | Coq3_Compilers.Coq_ident_Z_land -> '&'::[]
        | Coq3_Compilers.Coq_ident_Z_lor -> '|'::[]
        | Coq3_Compilers.Coq_ident_Z_min -> []
        | Coq3_Compilers.Coq_ident_Z_max -> []
        | Coq3_Compilers.Coq_ident_Z_mul_split -> []
        | Coq3_Compilers.Coq_ident_Z_mul_high -> []
        | Coq3_Compilers.Coq_ident_Z_add_get_carry -> []
        | Coq3_Compilers.Coq_ident_Z_add_with_carry -> []
        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> []
        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> []
        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> []
        | Coq3_Compilers.Coq_ident_Z_ltz -> []
        | Coq3_Compilers.Coq_ident_Z_zselect -> []
        | Coq3_Compilers.Coq_ident_Z_add_modulo -> []
        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> []
        | Coq3_Compilers.Coq_ident_Z_bneg -> '!'::[]
        | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> []
        | Coq3_Compilers.Coq_ident_Z_lxor -> '\226'::('\138'::('\149'::[]))
        | Coq3_Compilers.Coq_ident_Z_rshi -> []
        | Coq3_Compilers.Coq_ident_Z_cc_m -> []
        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> []
        | Coq3_Compilers.Coq_ident_Z_cast -> []
        | Coq3_Compilers.Coq_ident_Z_cast2 -> []
        | Coq3_Compilers.Coq_ident_Some _ -> []
        | Coq3_Compilers.Coq_ident_None _ -> []
        | Coq3_Compilers.Coq_ident_option_rect (_, _) -> []
        | Coq3_Compilers.Coq_ident_Build_zrange -> []
        | Coq3_Compilers.Coq_ident_zrange_rect _ -> []
        | Coq3_Compilers.Coq_ident_fancy_add -> []
        | Coq3_Compilers.Coq_ident_fancy_addc -> []
        | Coq3_Compilers.Coq_ident_fancy_sub -> []
        | Coq3_Compilers.Coq_ident_fancy_subb -> []
        | Coq3_Compilers.Coq_ident_fancy_mulll -> []
        | Coq3_Compilers.Coq_ident_fancy_mullh -> []
        | Coq3_Compilers.Coq_ident_fancy_mulhl -> []
        | Coq3_Compilers.Coq_ident_fancy_mulhh -> []
        | Coq3_Compilers.Coq_ident_fancy_rshi -> []
        | Coq3_Compilers.Coq_ident_fancy_selc -> []
        | Coq3_Compilers.Coq_ident_fancy_selm -> []
        | Coq3_Compilers.Coq_ident_fancy_sell -> []
        | Coq3_Compilers.Coq_ident_fancy_addm -> []

        (** val show_ident_lvl :
            bool -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> Coq3_Compilers.ident -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

        let show_ident_lvl with_casts0 with_all_casts0 t0 idc =
          let with_casts1 = (&&) with_casts0 (negb with_all_casts0) in
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t1, v) ->
             (match t1 with
              | Coq3_Compilers.Z ->
                (fun v0 pat ->
                  let () = Obj.magic pat in
                  ((show_lvl_compact_Z (Obj.magic v0)),
                  (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))
              | Coq3_Compilers.Coq_bool ->
                let t2 = Coq3_Compilers.Coq_bool in
                (fun v0 pat ->
                let () = Obj.magic pat in
                ((show_lvl (Obj.magic show_lvl_bool) v0),
                (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_Some
                  (Coq5_Compilers.Coercions.type_base t2) v0)))
              | Coq3_Compilers.Coq_nat ->
                let t2 = Coq3_Compilers.Coq_nat in
                (fun v0 pat ->
                let () = Obj.magic pat in
                ((show_lvl (Obj.magic Decimal.show_lvl_nat) v0),
                (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_Some
                  (Coq5_Compilers.Coercions.type_base t2) v0)))
              | Coq3_Compilers.Coq_zrange ->
                let t2 = Coq3_Compilers.Coq_zrange in
                (fun v0 pat ->
                let () = Obj.magic pat in
                ((show_lvl (Obj.magic show_lvl_zrange) v0),
                (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_Some
                  (Coq5_Compilers.Coercions.type_base t2) v0)))
              | Coq3_Compilers.Coq_string ->
                let t2 = Coq3_Compilers.Coq_string in
                (fun v0 pat ->
                let () = Obj.magic pat in
                ((show_lvl (Obj.magic show_lvl_string) v0),
                (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_Some
                  (Coq5_Compilers.Coercions.type_base t2) v0)))) v
           | Coq3_Compilers.Coq_ident_comment t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit)))))))
           | Coq3_Compilers.Coq_ident_comment_no_keep t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit)))))))
           | Coq3_Compilers.Coq_ident_value_barrier ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_Nat_succ ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let () = f in
               ((Obj.magic lookup_show_lvl_postop
                  conservative_postop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))
                    Coq3_Compilers.Coq_ident_Nat_succ) x),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))
           | Coq3_Compilers.Coq_ident_Nat_pred ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let () = f in
               ((Obj.magic lookup_show_lvl_postop
                  conservative_postop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))
                    Coq3_Compilers.Coq_ident_Nat_pred) x),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))
           | Coq3_Compilers.Coq_ident_Nat_max ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((show_lvl_app2 show_lvl_id show_lvl_id show_lvl_id
                  (show_lvl_ident t0 idc) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))))
           | Coq3_Compilers.Coq_ident_Nat_mul ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))))
                    Coq3_Compilers.Coq_ident_Nat_mul) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))))
           | Coq3_Compilers.Coq_ident_Nat_add ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))))
                    Coq3_Compilers.Coq_ident_Nat_add) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))))
           | Coq3_Compilers.Coq_ident_Nat_sub ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))))
                    Coq3_Compilers.Coq_ident_Nat_sub) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))))
           | Coq3_Compilers.Coq_ident_Nat_eqb ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool))))
                    Coq3_Compilers.Coq_ident_Nat_eqb) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))))))))))
           | Coq3_Compilers.Coq_ident_nil t1 ->
             (fun pat ->
               let () = Obj.magic pat in
               ((neg_wrap_parens ('['::(']'::[]))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))
           | Coq3_Compilers.Coq_ident_cons t1 ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base t1)
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1))))
                    (Coq3_Compilers.Coq_ident_cons t1)) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))
           | Coq3_Compilers.Coq_ident_tt ->
             (fun _ -> ((fun _ -> '('::(')'::[])), (Obj.magic ())))
           | Coq3_Compilers.Coq_ident_pair (t1, t2) ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, xr) = p in
               let (p0, u) = f in
               let (y, yr) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop false
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base t1)
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t2),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod (t1, t2)))))
                    (Coq3_Compilers.Coq_ident_pair (t1, t2))) x y),
               (Obj.magic (xr, yr))))
           | Coq3_Compilers.Coq_ident_fst (t1, t2) ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, xr) = p in
               let () = f in
               ((Obj.magic lookup_show_lvl_postop
                  conservative_postop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod (t1, t2)))
                    (Compilers.Coq_type.Coq_base t1)
                    (Coq3_Compilers.Coq_ident_fst (t1, t2))) x), (fst xr)))
           | Coq3_Compilers.Coq_ident_snd (t1, t2) ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, xr) = p in
               let () = f in
               ((Obj.magic lookup_show_lvl_postop
                  conservative_postop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod (t1, t2)))
                    (Compilers.Coq_type.Coq_base t2)
                    (Coq3_Compilers.Coq_ident_snd (t1, t2))) x), (snd xr)))
           | Coq3_Compilers.Coq_ident_prod_rect (a, b, t1) ->
             (fun pat ->
               let (p0, f0) = Obj.magic pat in
               let (f, _) = p0 in
               let (p1, u) = f0 in
               let (p, _) = p1 in
               let () = u in
               ((neg_wrap_parens
                  (append ('m'::('a'::('t'::('c'::('h'::(' '::[]))))))
                    (append
                      (show_lvl show_lvl_id p (Level.Coq_level (Zpos (XO (XO
                        (XO (XI (XO (XO (XI XH))))))))))
                      (append (' '::('w'::('i'::('t'::('h'::(' '::[]))))))
                        (append
                          (show_lvl show_lvl_id f (Level.Coq_level (Zpos (XO
                            (XO (XO (XI (XO (XO (XI XH))))))))))
                          (' '::('e'::('n'::('d'::[]))))))))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base a),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base b),
                   (Compilers.Coq_type.Coq_base t1))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                   (Compilers.Coq_type.Coq_base t1)))))))))
           | Coq3_Compilers.Coq_ident_bool_rect t1 ->
             (fun pat ->
               let (t2, f0) = Obj.magic pat in
               let (f, p) = f0 in
               let (p0, u) = p in
               let (b, _) = p0 in
               let () = u in
               ((fun lvl ->
               maybe_wrap_parens
                 (Level.ltb lvl (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
                   (XO (XI XH))))))))))
                 (append ('i'::('f'::(' '::[])))
                   (append
                     (show_lvl show_lvl_id b (Level.Coq_level (Zpos (XO (XO
                       (XO (XI (XO (XO (XI XH))))))))))
                     (append (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                       (append
                         (maybe_wrap_cast with_casts1
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t1))) t2
                           (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
                           XH))))))))))
                         (append (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                           (maybe_wrap_cast with_casts1
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             Compilers.Coq_base.Coq_type.Coq_unit),
                             (Compilers.Coq_type.Coq_base t1))) f
                             (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO
                             (XI XH)))))))))))))))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t1))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t1))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                   t1)))))))))))
           | Coq3_Compilers.Coq_ident_bool_rect_nodep t1 ->
             (fun pat ->
               let (t2, f0) = Obj.magic pat in
               let (f, p) = f0 in
               let (p0, u) = p in
               let (b, _) = p0 in
               let () = u in
               ((fun lvl ->
               maybe_wrap_parens
                 (Level.ltb lvl (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
                   (XO (XI XH))))))))))
                 (append ('i'::('f'::(' '::[])))
                   (append
                     (show_lvl show_lvl_id b (Level.Coq_level (Zpos (XO (XO
                       (XO (XI (XO (XO (XI XH))))))))))
                     (append (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                       (append
                         (maybe_wrap_cast with_casts1
                           (Compilers.Coq_type.Coq_base t1) t2
                           (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
                           XH))))))))))
                         (append (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                           (maybe_wrap_cast with_casts1
                             (Compilers.Coq_type.Coq_base t1) f
                             (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO
                             (XI XH)))))))))))))))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                   t1)))))))))))
           | Coq3_Compilers.Coq_ident_nat_rect t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t1))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  t1))))))) (fun _ -> show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t1))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t1))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   t1)))))))))))
           | Coq3_Compilers.Coq_ident_eager_nat_rect t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t1))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  t1))))))) (fun _ -> show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t1))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t1))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   t1)))))))))))
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t2))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2)))))))))))))
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t2))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2)))))))))))))
           | Coq3_Compilers.Coq_ident_list_rect (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t2), (Compilers.Coq_type.Coq_base t2))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base t2))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t2))))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base t2)))))))))))
           | Coq3_Compilers.Coq_ident_eager_list_rect (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t2), (Compilers.Coq_type.Coq_base t2))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base t2))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t2))))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base t2)))))))))))
           | Coq3_Compilers.Coq_ident_list_rect_arrow (t1, t2, t3) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t2),
                  (Compilers.Coq_type.Coq_base t3))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t2),
                  (Compilers.Coq_type.Coq_base t3))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t2), (Compilers.Coq_type.Coq_base t3))))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t2), (Compilers.Coq_type.Coq_base t3))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3))))))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3)))))))))))))
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t1, t2, t3) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t2),
                  (Compilers.Coq_type.Coq_base t3))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t2),
                  (Compilers.Coq_type.Coq_base t3))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t2), (Compilers.Coq_type.Coq_base t3))))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t2), (Compilers.Coq_type.Coq_base t3))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3))))))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_base t3)))))))))))))
           | Coq3_Compilers.Coq_ident_list_case (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base t2))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base t2))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base t2))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base t2)))))))))))
           | Coq3_Compilers.Coq_ident_List_length t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))
           | Coq3_Compilers.Coq_ident_List_seq ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)))))))))))
           | Coq3_Compilers.Coq_ident_List_firstn t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))
           | Coq3_Compilers.Coq_ident_List_skipn t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))
           | Coq3_Compilers.Coq_ident_List_repeat t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))
           | Coq3_Compilers.Coq_ident_List_combine (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t2)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod (t1, t2))))))))
                  (fun _ -> show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t2)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_base.Coq_type.Coq_prod (t1, t2))))))))))))
           | Coq3_Compilers.Coq_ident_List_map (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t2)))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t2))))))))))
           | Coq3_Compilers.Coq_ident_List_app t1 ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1))))
                    (Coq3_Compilers.Coq_ident_List_app t1)) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))
           | Coq3_Compilers.Coq_ident_List_rev t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))
           | Coq3_Compilers.Coq_ident_List_flat_map (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t2)))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t2)))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t2)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t2))))))))))
           | Coq3_Compilers.Coq_ident_List_partition t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_list t1),
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_list t1),
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))))
           | Coq3_Compilers.Coq_ident_List_filter t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))
           | Coq3_Compilers.Coq_ident_List_fold_right (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t2),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t1))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t2)),
                  (Compilers.Coq_type.Coq_base t1))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t2),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t1))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t2)),
                   (Compilers.Coq_type.Coq_base t1)))))))))))
           | Coq3_Compilers.Coq_ident_List_update_nth t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t1))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1))))))))))))
           | Coq3_Compilers.Coq_ident_List_nth_default t1 ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (_, _) = p in
               let (p0, p1) = f in
               let (ls, _) = p0 in
               let (p2, u) = p1 in
               let (i, _) = p2 in
               let () = u in
               ((fun lvl ->
               maybe_wrap_parens
                 (Level.ltb lvl (Level.Coq_level (Zpos (XO (XI (XO XH))))))
                 (append
                   (show_lvl show_lvl_id ls (Level.Coq_level (Zpos (XO (XI
                     (XO XH))))))
                   (append ('['::[])
                     (append
                       (show_lvl show_lvl_id i (Level.Coq_level (Zpos (XO (XO
                         (XO (XI (XO (XO (XI XH)))))))))) (']'::[]))))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   t1)))))))))))
           | Coq3_Compilers.Coq_ident_eager_List_nth_default t1 ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (_, _) = p in
               let (p0, p1) = f in
               let (ls, _) = p0 in
               let (p2, u) = p1 in
               let (i, _) = p2 in
               let () = u in
               ((fun lvl ->
               maybe_wrap_parens
                 (Level.ltb lvl (Level.Coq_level (Zpos (XO (XI (XO XH))))))
                 (append
                   (show_lvl show_lvl_id ls (Level.Coq_level (Zpos (XO (XI
                     (XO XH))))))
                   (append ('['::('['::[]))
                     (append
                       (show_lvl show_lvl_id i (Level.Coq_level (Zpos (XO (XO
                         (XO (XI (XO (XO (XI XH)))))))))) (']'::(']'::[])))))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t1)),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   t1)))))))))))
           | Coq3_Compilers.Coq_ident_Z_add ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_add) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_mul ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_mul) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_pow ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_pow) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_sub ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_sub) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_opp ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let () = f in
               ((Obj.magic lookup_show_lvl_preop
                  conservative_preop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) Coq3_Compilers.Coq_ident_Z_opp) x),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_Z_div ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_div) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_modulo ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_modulo) x
                  y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_eqb ->
             (fun pat ->
               let (x, f) = Obj.magic pat in
               let (y, u) = f in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool))))
                    Coq3_Compilers.Coq_ident_Z_eqb)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) x)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) y)),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))))))))))
           | Coq3_Compilers.Coq_ident_Z_leb ->
             (fun pat ->
               let (x, f) = Obj.magic pat in
               let (y, u) = f in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool))))
                    Coq3_Compilers.Coq_ident_Z_leb)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) x)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) y)),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))))))))))
           | Coq3_Compilers.Coq_ident_Z_ltb ->
             (fun pat ->
               let (x, f) = Obj.magic pat in
               let (y, u) = f in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool))))
                    Coq3_Compilers.Coq_ident_Z_ltb)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) x)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) y)),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))))))))))
           | Coq3_Compilers.Coq_ident_Z_geb ->
             (fun pat ->
               let (x, f) = Obj.magic pat in
               let (y, u) = f in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool))))
                    Coq3_Compilers.Coq_ident_Z_geb)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) x)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) y)),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))))))))))
           | Coq3_Compilers.Coq_ident_Z_gtb ->
             (fun pat ->
               let (x, f) = Obj.magic pat in
               let (y, u) = f in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool))))
                    Coq3_Compilers.Coq_ident_Z_gtb)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) x)
                  (maybe_wrap_cast with_casts1 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) y)),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool))))))))))
           | Coq3_Compilers.Coq_ident_Z_log2 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_Z_log2_up ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_Z_of_nat ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_Z_to_nat ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_nat))))))))
           | Coq3_Compilers.Coq_ident_Z_shiftr ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_shiftr) x
                  y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_shiftl ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_shiftl) x
                  y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_land ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_land) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_lor ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_lor) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_min ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_max ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_mul_split ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))))
           | Coq3_Compilers.Coq_ident_Z_mul_high ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))
           | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))))
           | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))))))
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))))
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))))))
           | Coq3_Compilers.Coq_ident_Z_ltz ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_zselect ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))
           | Coq3_Compilers.Coq_ident_Z_add_modulo ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))
           | Coq3_Compilers.Coq_ident_Z_bneg ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let () = f in
               ((Obj.magic lookup_show_lvl_preop
                  conservative_preop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) Coq3_Compilers.Coq_ident_Z_bneg) x),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (m4, _) = p0 in
               let () = u in
               ((fun lvl ->
               maybe_wrap_parens
                 (Level.ltb lvl (Level.Coq_level (Zpos (XI (XI (XO (XI (XO
                   (XO XH)))))))))
                 (append ('~'::[])
                   (append
                     (show_lvl show_lvl_id x (Level.Coq_level (Zpos (XI (XI
                       (XO (XI (XO (XO XH)))))))))
                     (if with_casts1
                      then append
                             (' '::('('::('m'::('o'::('d'::(' '::[]))))))
                             (append
                               (show_lvl show_lvl_id m4 (Level.Coq_level
                                 (Zpos (XO (XO (XO (XI (XO (XO (XI
                                 XH)))))))))) (')'::[]))
                      else [])))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_lxor ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, _) = p in
               let (p0, u) = f in
               let (y, _) = p0 in
               let () = u in
               ((Obj.magic lookup_show_lvl_binop true
                  conservative_binop_precedence_table
                  (ident_to_op_string (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) Coq3_Compilers.Coq_ident_Z_lxor) x y),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_rshi ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))))
           | Coq3_Compilers.Coq_ident_Z_cc_m ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))))
           | Coq3_Compilers.Coq_ident_Z_cast ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (srange, range) = p in
               let (p0, u) = f in
               let (x, _) = p0 in
               let () = u in
               let t1 = Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)
               in
               ((if (&&) with_all_casts0
                      (is_None
                        (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_zrange) range))
                 then (fun _ ->
                        append ('('::[])
                          (append
                            (srange (Level.Coq_level (Zpos (XO (XO (XO (XI
                              (XO (XO (XI XH))))))))))
                            (append (')'::[]) (x (Level.Coq_level Z0)))))
                 else maybe_wrap_cast with_all_casts0 t1 (x, range)), range))
           | Coq3_Compilers.Coq_ident_Z_cast2 ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (srange, range) = p in
               let (p0, u) = f in
               let (x, _) = p0 in
               let () = u in
               let t1 = Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_prod
                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z),
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z)))
               in
               ((if (&&) with_all_casts0
                      (is_None
                        (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                          (Compilers.Coq_base.Coq_type.Coq_prod
                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_zrange),
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_zrange))) range))
                 then (fun _ ->
                        append ('('::[])
                          (append
                            (srange (Level.Coq_level (Zpos (XO (XO (XO (XI
                              (XO (XO (XI XH))))))))))
                            (append (')'::[]) (x (Level.Coq_level Z0)))))
                 else maybe_wrap_cast with_all_casts0 t1 (x, range)), range))
           | Coq3_Compilers.Coq_ident_Some t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_option t1)))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_option t1))))))))
           | Coq3_Compilers.Coq_ident_None t1 ->
             (fun pat ->
               let () = Obj.magic pat in
               ((neg_wrap_parens ('N'::('o'::('n'::('e'::[]))))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_option t1))))))
           | Coq3_Compilers.Coq_ident_option_rect (t1, t2) ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_option t1)),
                  (Compilers.Coq_type.Coq_base t2))))))) (fun _ ->
                  show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t1),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t2))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_option t1)),
                   (Compilers.Coq_type.Coq_base t2)))))))))))
           | Coq3_Compilers.Coq_ident_Build_zrange ->
             (fun pat ->
               let (p, f) = Obj.magic pat in
               let (x, xr) = p in
               let (p0, u) = f in
               let (y, yr) = p0 in
               let () = u in
               ((neg_wrap_parens
                  (append ('r'::('['::[]))
                    (append
                      (show_lvl show_lvl_id x (Level.Coq_level (Zpos (XO (XO
                        (XI (XI (XI XH))))))))
                      (append (' '::('~'::('>'::(' '::[]))))
                        (show_lvl show_lvl_id y (Level.Coq_level (Zpos (XO
                          (XO (XO (XI (XO (XO (XI XH)))))))))))))),
               (match Coq6_Compilers.ZRange.Coq_ident.Coq_option.to_literal
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) xr with
                | Some l ->
                  (match Coq6_Compilers.ZRange.Coq_ident.Coq_option.to_literal
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z) yr with
                   | Some h ->
                     Obj.magic (Some { lower = (Obj.magic l); upper =
                       (Obj.magic h) })
                   | None -> Obj.magic None)
                | None -> Obj.magic None)))
           | Coq3_Compilers.Coq_ident_zrange_rect t1 ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t1))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                  t1))))) (fun _ -> show0 (show_ident t0) idc) args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t1))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   t1)))))))))
           | Coq3_Compilers.Coq_ident_fancy_add ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_fancy_addc ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_fancy_sub ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_fancy_subb ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))))
           | Coq3_Compilers.Coq_ident_fancy_mulll ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_mullh ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_mulhl ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_mulhh ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_rshi ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_selc ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_selm ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_sell ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))))
           | Coq3_Compilers.Coq_ident_fancy_addm ->
             (fun args0 ->
               ((show_application with_casts1 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (fun _ -> show0 (show_ident t0) idc)
                  args0),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))
       end

      module Coq_expr =
       struct
        (** val get_eta_cps_args :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> positive -> ((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> positive -> 'a1) ->
            char list list * 'a1 **)

        let rec get_eta_cps_args t0 idx0 =
          match t0 with
          | Compilers.Coq_type.Coq_base _ ->
            (fun k -> ([], (Obj.magic k () idx0)))
          | Compilers.Coq_type.Coq_arrow (s0, d) ->
            (fun k ->
              let n3 = append ('x'::[]) (Coq0_Pos.to_string idx0) in
              let (args0, show_f) =
                get_eta_cps_args d (Coq_Pos.succ idx0) (fun arglist ->
                  Obj.magic k (((fun _ -> n3),
                    (Coq6_Compilers.ZRange.Coq_type.Coq_option.coq_None s0)),
                    arglist))
              in
              ((n3 :: args0), show_f))

        (** val show_eta_abs_aux :
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> positive -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr -> (positive * (char list
            list * (Level.coq_Level -> char list
            list))) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> positive -> ('a1 -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr) -> (positive * (char list
            list * (Level.coq_Level -> char list
            list))) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

        let show_eta_abs_aux of_string0 aux s0 d idx0 f =
          let n3 =
            match s0 with
            | Compilers.Coq_type.Coq_base t0 ->
              (match t0 with
               | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                 append ('x'::[]) (Coq0_Pos.to_string idx0)
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 append ('x'::[]) (Coq0_Pos.to_string idx0)
               | Compilers.Coq_base.Coq_type.Coq_list _ ->
                 append ('x'::[]) (Coq0_Pos.to_string idx0)
               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                 append ('x'::[]) (Coq0_Pos.to_string idx0)
               | Compilers.Coq_base.Coq_type.Coq_unit ->
                 append ('('::(')'::('_'::[]))) (Coq0_Pos.to_string idx0))
            | Compilers.Coq_type.Coq_arrow (_, _) ->
              append ('x'::[]) (Coq0_Pos.to_string idx0)
          in
          (match of_string0 s0 n3 with
           | Some n' ->
             let (p, r0) = aux d (Coq_Pos.succ idx0) (f n') in
             let (_, p1) = p in
             let (args0, show_f) = p1 in ((idx0, ((n3 :: args0), show_f)), r0)
           | None ->
             ((idx0, ((n3 :: []), (fun _ ->
               (append ('\206'::('\187'::('_'::('('::[]))))
                 (append (show0 (Coq_type.show Coq_type.Coq_base.show) s0)
                   (')'::[]))) :: []))),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain d))))

        (** val show_eta_abs_cps' :
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
            (positive * (Level.coq_Level -> char list
            list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> positive -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr -> (positive * (char list
            list * (Level.coq_Level -> char list
            list))) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

        let show_eta_abs_cps' of_string0 k =
          let rec show_eta_abs_cps'0 t0 idx0 e =
            (match e with
             | Compilers.Coq_expr.Ident (_, _) ->
               (fun default0 -> default0 ())
             | Compilers.Coq_expr.Var (_, _) -> (fun default0 -> default0 ())
             | Compilers.Coq_expr.Abs (s0, d, f) ->
               (fun _ ->
                 show_eta_abs_aux of_string0 show_eta_abs_cps'0 s0 d idx0 f)
             | Compilers.Coq_expr.App (_, _, _, _) ->
               (fun default0 -> default0 ())
             | Compilers.Coq_expr.LetIn (_, _, _, _) ->
               (fun default0 -> default0 ())) (fun _ ->
              let (args0, p) = get_eta_cps_args t0 idx0 (k t0 e) in
              let (p0, r0) = p in
              let (idx1, show_f) = p0 in ((idx1, (args0, show_f)), r0))
          in show_eta_abs_cps'0

        (** val show_eta_abs_cps :
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
            (positive * (Level.coq_Level -> char list
            list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
            -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> positive -> ('a1 ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr) ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            (positive * (Level.coq_Level -> char list
            list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

        let show_eta_abs_cps of_string0 k with_casts0 s0 d idx0 f extraargs =
          let (p, r0) =
            show_eta_abs_aux of_string0 (show_eta_abs_cps' of_string0 k) s0 d
              idx0 f
          in
          let (idx1, p0) = p in
          let (args0, show_f) = p0 in
          let argstr = concat0 (' '::[]) args0 in
          ((idx1, (fun lvl ->
          match show_f lvl with
          | [] ->
            (show_application with_casts0 (Compilers.Coq_type.Coq_arrow (s0,
              d)) (fun _ ->
              append ('('::('\206'::('\187'::(' '::[]))))
                (append argstr
                  (','::(' '::('('::('*'::(' '::('N'::('O'::('T'::('H'::('I'::('N'::('G'::('\226'::('\128'::('\189'::(' '::('*'::(')'::(')'::[])))))))))))))))))))))
              extraargs
              (Level.prev (Level.Coq_level (Zpos (XO (XI (XO XH))))))) :: []
          | show_f0 :: l ->
            (match l with
             | [] ->
               (show_application with_casts0 (Compilers.Coq_type.Coq_arrow
                 (s0, d)) (fun _ ->
                 append ('('::('\206'::('\187'::(' '::[]))))
                   (append argstr
                     (append (','::(' '::[])) (append show_f0 (')'::[])))))
                 extraargs
                 (Level.prev (Level.Coq_level (Zpos (XO (XI (XO XH))))))) :: []
             | s1 :: l0 ->
               app
                 ((append ('('::('\206'::('\187'::(' '::[]))))
                    (append argstr (','::[]))) :: [])
                 (app (map (fun v -> ' '::(' '::v)) (show_f0 :: (s1 :: l0)))
                   ((append (')'::[])
                      (show_application with_casts0
                        (Compilers.Coq_type.Coq_arrow (s0, d)) (fun _ -> [])
                        extraargs
                        (Level.prev (Level.Coq_level (Zpos (XO (XI (XO
                          XH)))))))) :: []))))), r0)

        (** val show_eta_cps :
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
            (positive * (Level.coq_Level -> char list
            list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> positive -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr -> (positive * (Level.coq_Level ->
            char list
            list)) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp **)

        let show_eta_cps of_string0 k t0 idx0 e =
          let (p, r0) = show_eta_abs_cps' of_string0 k t0 idx0 e in
          let (idx1, p0) = p in
          let (args0, show_f) = p0 in
          let argstr = concat0 (' '::[]) args0 in
          ((idx1, (fun lvl ->
          match args0 with
          | [] -> show_f lvl
          | _ :: _ ->
            (match show_f lvl with
             | [] ->
               (append ('('::('\206'::('\187'::(' '::[]))))
                 (append argstr
                   (','::(' '::('('::('*'::(' '::('N'::('O'::('T'::('H'::('I'::('N'::('G'::('\226'::('\128'::('\189'::(' '::('*'::(')'::(')'::[]))))))))))))))))))))) :: []
             | show_f0 :: l0 ->
               (match l0 with
                | [] ->
                  (append ('('::('\206'::('\187'::(' '::[]))))
                    (append argstr
                      (append (','::(' '::[])) (append show_f0 (')'::[]))))) :: []
                | s0 :: l1 ->
                  app
                    ((append ('('::('\206'::('\187'::(' '::[]))))
                       (append argstr (','::[]))) :: [])
                    (app
                      (map (fun v -> ' '::(' '::v)) (show_f0 :: (s0 :: l1)))
                      ((')'::[]) :: [])))))),
          ((match t0 with
            | Compilers.Coq_type.Coq_base _ -> (fun r1 -> r1)
            | Compilers.Coq_type.Coq_arrow (s0, d) ->
              (fun _ ->
                Coq6_Compilers.ZRange.Coq_type.Coq_option.coq_None
                  (Compilers.Coq_type.Coq_arrow (s0, d)))) r0))

        (** val show_expr_lines_gen :
            bool -> bool -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> 'a1 -> char list) -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> char list -> 'a1 option) -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            (Level.coq_Level ->
            char list) * Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
            (positive * (Level.coq_Level -> char list
            list)) * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

        let rec show_expr_lines_gen with_casts0 with_all_casts0 to_string0 of_string0 _ e args0 idx0 =
          let show_expr_lines_gen0 =
            show_expr_lines_gen with_casts0 with_all_casts0 to_string0
              of_string0
          in
          (match e with
           | Compilers.Coq_expr.Ident (t0, idc) ->
             (fun args1 ->
               let (v, r0) =
                 Coq_ident.show_ident_lvl with_casts0 with_all_casts0 t0 idc
                   args1
               in
               ((idx0, (fun lvl -> (v lvl) :: [])), r0))
           | Compilers.Coq_expr.Var (t0, v) ->
             (fun args1 -> ((idx0, (fun lvl ->
               (show_application with_casts0 t0 (fun _ -> to_string0 t0 v)
                 args1 lvl) :: [])),
               (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                 (Compilers.Coq_type.final_codomain t0))))
           | Compilers.Coq_expr.Abs (s0, d, f) ->
             (fun args1 ->
               show_eta_abs_cps of_string0 (fun t0 e0 args2 idx1 ->
                 let (p, r0) = show_expr_lines_gen0 t0 e0 args2 idx1 in
                 let (idx2, v) = p in
                 ((idx2, (fun _ ->
                 v (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
                   XH))))))))))), r0)) with_casts0 s0 d idx0 f args1)
           | Compilers.Coq_expr.App (s0, d, f, x) ->
             (fun args1 ->
               let (p, xr) =
                 show_eta_cps of_string0 show_expr_lines_gen0 s0 idx0 x
               in
               let (_, x') = p in
               Obj.magic show_expr_lines_gen0 (Compilers.Coq_type.Coq_arrow
                 (s0, d)) f (((fun lvl -> concat0 (newLine::[]) (x' lvl)),
                 xr), args1) idx0)
           | Compilers.Coq_expr.LetIn (a, b, x, f) ->
             (match b with
              | Compilers.Coq_type.Coq_base b0 ->
                (fun f0 pat ->
                  let () = Obj.magic pat in
                  let n3 = append ('x'::[]) (Coq0_Pos.to_string idx0) in
                  let (p, xr) =
                    show_eta_cps of_string0 show_expr_lines_gen0 a idx0 x
                  in
                  let (_, show_x) = p in
                  let (p0, fr) =
                    match of_string0 a n3 with
                    | Some n' ->
                      show_eta_cps of_string0 show_expr_lines_gen0
                        (Compilers.Coq_type.Coq_base b0) (Coq_Pos.succ idx0)
                        (f0 n')
                    | None ->
                      ((idx0, (fun _ -> ('_'::[]) :: [])),
                        (Coq6_Compilers.ZRange.Coq_type.Coq_option.coq_None
                          (Compilers.Coq_type.Coq_base b0)))
                  in
                  let (idx1, show_f) = p0 in
                  let (p1, space_comment_ty_str) =
                    match make_cast a xr with
                    | Some c0 ->
                      let ty_str = append (' '::(':'::(' '::[]))) c0 in
                      let comment_ty_str =
                        append ('('::('*'::[]))
                          (append ty_str (' '::('*'::(')'::[]))))
                      in
                      ((ty_str, comment_ty_str),
                      (append (' '::[]) comment_ty_str))
                    | None -> (([], []), [])
                  in
                  let (ty_str, _) = p1 in
                  let expr_let_line =
                    append ('l'::('e'::('t'::(' '::[]))))
                      (append n3 (' '::(':'::('='::(' '::[])))))
                  in
                  ((idx1, (fun _ ->
                  match show_x (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO
                          (XI XH))))))))) with
                  | [] ->
                    app
                      ((append expr_let_line
                         (append
                           ('('::('*'::(' '::('N'::('O'::('T'::('H'::('I'::('N'::('G'::('\226'::('\128'::('\189'::(' '::('*'::(')'::[]))))))))))))))))
                           (append space_comment_ty_str
                             (' '::('i'::('n'::[])))))) :: [])
                      (show_f (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO
                        (XI XH))))))))))
                  | show_x0 :: rest ->
                    (match rest with
                     | [] ->
                       app
                         ((append expr_let_line
                            (append show_x0
                              (append []
                                (append space_comment_ty_str
                                  (' '::('i'::('n'::[]))))))) :: [])
                         (show_f (Level.Coq_level (Zpos (XO (XO (XO (XI (XO
                           (XO (XI XH))))))))))
                     | _ :: _ ->
                       app ((append expr_let_line show_x0) :: [])
                         (app
                           (map (fun l ->
                             append
                               (string_of_list_ascii
                                 (repeat ' ' (length0 expr_let_line))) l)
                             rest)
                           (app
                             (if eqb0 ty_str []
                              then (append ('('::('*'::[]))
                                     (append ty_str (' '::('*'::(')'::[]))))) :: []
                              else [])
                             (app (('i'::('n'::[])) :: [])
                               (show_f (Level.Coq_level (Zpos (XO (XO (XO (XI
                                 (XO (XO (XI XH)))))))))))))))), fr))
              | Compilers.Coq_type.Coq_arrow (s0, d) ->
                (fun f0 args1 ->
                  let n3 = append ('x'::[]) (Coq0_Pos.to_string idx0) in
                  let (p, xr) =
                    show_eta_cps of_string0 show_expr_lines_gen0 a idx0 x
                  in
                  let (_, show_x) = p in
                  let (p0, _) =
                    match of_string0 a n3 with
                    | Some n' ->
                      show_eta_cps of_string0 show_expr_lines_gen0
                        (Compilers.Coq_type.Coq_arrow (s0, d))
                        (Coq_Pos.succ idx0) (f0 n')
                    | None ->
                      ((idx0, (fun _ -> ('_'::[]) :: [])),
                        (Coq6_Compilers.ZRange.Coq_type.Coq_option.coq_None
                          (Compilers.Coq_type.Coq_arrow (s0, d))))
                  in
                  let (idx1, show_f) = p0 in
                  let (p1, space_comment_ty_str) =
                    match make_cast a xr with
                    | Some c0 ->
                      let ty_str = append (' '::(':'::(' '::[]))) c0 in
                      let comment_ty_str =
                        append ('('::('*'::[]))
                          (append ty_str (' '::('*'::(')'::[]))))
                      in
                      ((ty_str, comment_ty_str),
                      (append (' '::[]) comment_ty_str))
                    | None -> (([], []), [])
                  in
                  let (ty_str, _) = p1 in
                  let expr_let_line =
                    append ('l'::('e'::('t'::(' '::[]))))
                      (append n3 (' '::(':'::('='::(' '::[])))))
                  in
                  ((idx1, (fun _ ->
                  app (('('::[]) :: [])
                    (app
                      (map (fun x0 -> ' '::x0)
                        (match show_x (Level.Coq_level (Zpos (XO (XO (XO (XI
                                 (XO (XO (XI XH))))))))) with
                         | [] ->
                           app
                             ((append expr_let_line
                                (append
                                  ('('::('*'::(' '::('N'::('O'::('T'::('H'::('I'::('N'::('G'::('\226'::('\128'::('\189'::(' '::('*'::(')'::[]))))))))))))))))
                                  (append space_comment_ty_str
                                    (' '::('i'::('n'::[])))))) :: [])
                             (show_f (Level.Coq_level (Zpos (XO (XO (XO (XI
                               (XO (XO (XI XH))))))))))
                         | show_x0 :: rest ->
                           (match rest with
                            | [] ->
                              app
                                ((append expr_let_line
                                   (append show_x0
                                     (append []
                                       (append space_comment_ty_str
                                         (' '::('i'::('n'::[]))))))) :: [])
                                (show_f (Level.Coq_level (Zpos (XO (XO (XO
                                  (XI (XO (XO (XI XH))))))))))
                            | _ :: _ ->
                              app ((append expr_let_line show_x0) :: [])
                                (app
                                  (map (fun l ->
                                    append
                                      (string_of_list_ascii
                                        (repeat ' ' (length0 expr_let_line)))
                                      l) rest)
                                  (app
                                    (if eqb0 ty_str []
                                     then (append ('('::('*'::[]))
                                            (append ty_str
                                              (' '::('*'::(')'::[]))))) :: []
                                     else [])
                                    (app (('i'::('n'::[])) :: [])
                                      (show_f (Level.Coq_level (Zpos (XO (XO
                                        (XO (XI (XO (XO (XI XH))))))))))))))))
                      ((')'::[]) :: ((show_application with_casts0
                                       (Compilers.Coq_type.Coq_arrow (s0, d))
                                       (fun _ -> []) args1
                                       (Level.prev (Level.Coq_level (Zpos (XO
                                         (XI (XO XH))))))) :: []))))),
                  (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow (s0, d))))))) f) args0

        (** val show_lvl_var_expr :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr showLevel **)

        let rec show_lvl_var_expr t0 = function
        | Compilers.Coq_expr.Ident (t1, idc) ->
          show_lvl (Coq_ident.show_lvl_ident t1) idc
        | Compilers.Coq_expr.Var (t1, _) ->
          neg_wrap_parens
            (append ('V'::('A'::('R'::('_'::[]))))
              (show_lvl (Coq_type.show_lvl Coq_type.Coq_base.show_lvl) t1
                (Level.Coq_level Z0)))
        | Compilers.Coq_expr.Abs (_, _, _) ->
          neg_wrap_parens
            (append ('\206'::('\187'::('_'::[])))
              (show_lvl (Coq_type.show_lvl Coq_type.Coq_base.show_lvl) t0
                (Level.Coq_level Z0)))
        | Compilers.Coq_expr.App (s0, d, f, x) ->
          show_lvl_binop LeftAssoc (Level.Coq_level (Zpos (XO (XI (XO XH)))))
            show_lvl_id show_lvl_id
            (show_lvl_var_expr (Compilers.Coq_type.Coq_arrow (s0, d)) f)
            (' '::('@'::(' '::[]))) (show_lvl_var_expr s0 x)
        | Compilers.Coq_expr.LetIn (a, _, x, _) ->
          (fun lvl ->
            maybe_wrap_parens
              (Level.ltb lvl (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO
                (XI XH))))))))))
              (append
                ('e'::('x'::('p'::('r'::('_'::('l'::('e'::('t'::(' '::('_'::(' '::(':'::('='::(' '::[]))))))))))))))
                (append
                  (show_lvl_var_expr a x (Level.Coq_level (Zpos (XO (XO (XO
                    (XI (XO (XO (XI XH))))))))))
                  (' '::('i'::('n'::(' '::('_'::[]))))))))

        (** val show_var_expr :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr show **)

        let show_var_expr t0 =
          show_of_ShowLevel (show_lvl_var_expr t0)

        (** val partially_show_expr :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr show **)

        let partially_show_expr =
          show_var_expr

        (** val show_lines_expr_gen :
            Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> 'a1 -> char list) ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> char list -> 'a1 option) ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
            Compilers.Coq_expr.expr showLines **)

        let show_lines_expr_gen with_casts0 with_all_casts0 to_string0 of_string0 t0 e =
          let (p, _) =
            show_eta_cps of_string0 (fun t1 e0 args0 idx0 ->
              show_expr_lines_gen with_casts0 with_all_casts0 to_string0
                of_string0 t1 e0 args0 idx0) t0 XH e
          in
          let (_, v) = p in
          v
            (Level.prev (Level.Coq_level (Zpos (XO (XO (XO (XI (XO (XO (XI
              XH))))))))))

        (** val show_lines_expr :
            Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            char list) Compilers.Coq_expr.expr showLines **)

        let show_lines_expr with_casts0 with_all_casts0 t0 =
          show_lines_expr_gen with_casts0 with_all_casts0 (fun _ x -> x)
            (fun _ x -> Some x) t0

        (** val show_lines_Expr :
            Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
            Compilers.Coq_expr.coq_Expr showLines **)

        let show_lines_Expr with_casts0 with_all_casts0 t0 e =
          show_lines
            (Obj.magic show_lines_expr with_casts0 with_all_casts0 t0) 
            (e __)

        (** val show_expr :
            Options.PHOAS.with_casts -> Options.PHOAS.with_all_casts ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            char list) Compilers.Coq_expr.expr show **)

        let show_expr with_casts0 with_all_casts0 t0 e =
          concat0 (newLine::[])
            (show_lines (show_lines_expr with_casts0 with_all_casts0 t0) e)
       end
     end

    (** val format_typedef_name :
        Options.language_naming_conventions_opt -> char list -> bool ->
        char list -> char list **)

    let format_typedef_name language_naming_conventions0 prefix1 private0 name0 =
      Options.convert_to_naming_convention
        (if private0
         then language_naming_conventions0.Options.private_type_naming_convention
         else language_naming_conventions0.Options.public_type_naming_convention)
        (append prefix1 name0)

    module Coq_int =
     struct
      type coq_type =
      | Coq_signed of nat
      | Coq_unsigned of nat

      (** val type_beq : coq_type -> coq_type -> bool **)

      let type_beq x y =
        match x with
        | Coq_signed lgbitwidth ->
          (match y with
           | Coq_signed lgbitwidth0 -> nat_beq lgbitwidth lgbitwidth0
           | Coq_unsigned _ -> false)
        | Coq_unsigned lgbitwidth ->
          (match y with
           | Coq_signed _ -> false
           | Coq_unsigned lgbitwidth0 -> nat_beq lgbitwidth lgbitwidth0)

      (** val type_eq_dec : coq_type -> coq_type -> bool **)

      let type_eq_dec x y =
        let h = let b = type_beq x y in if b then true else false in
        if h then true else false

      (** val lgbitwidth_of : coq_type -> nat **)

      let lgbitwidth_of = function
      | Coq_signed lgbitwidth -> lgbitwidth
      | Coq_unsigned lgbitwidth -> lgbitwidth

      (** val of_lgbitwidth : bool -> nat -> coq_type **)

      let of_lgbitwidth is_signed0 lgbitwidth =
        if is_signed0 then Coq_signed lgbitwidth else Coq_unsigned lgbitwidth

      (** val bitwidth_of : coq_type -> z **)

      let bitwidth_of t0 =
        Coq_Z.pow (Zpos (XO XH)) (Coq_Z.of_nat (lgbitwidth_of t0))

      (** val of_bitwidth : bool -> z -> coq_type **)

      let of_bitwidth is_signed0 bitwidth =
        of_lgbitwidth is_signed0 (Coq_Z.to_nat (Coq_Z.log2 bitwidth))

      (** val of_bitwidth_up : bool -> z -> coq_type **)

      let of_bitwidth_up is_signed0 bitwidth =
        of_lgbitwidth is_signed0 (Coq_Z.to_nat (Coq_Z.log2_up bitwidth))

      (** val is_signed : coq_type -> bool **)

      let is_signed = function
      | Coq_signed _ -> true
      | Coq_unsigned _ -> false

      (** val is_unsigned : coq_type -> bool **)

      let is_unsigned t0 =
        negb (is_signed t0)

      (** val to_zrange : coq_type -> zrange **)

      let to_zrange t0 =
        let bw = bitwidth_of t0 in
        if is_signed t0
        then { lower =
               (Coq_Z.opp (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub bw (Zpos XH))));
               upper =
               (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub bw (Zpos XH)))
                 (Zpos XH)) }
        else { lower = Z0; upper =
               (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bw) (Zpos XH)) }

      (** val is_tighter_than : coq_type -> coq_type -> bool **)

      let is_tighter_than t1 t2 =
        is_tighter_than_bool (to_zrange t1) (to_zrange t2)

      module Coq__10 = struct
       (** val of_zrange_relaxed : zrange -> coq_type **)

       let of_zrange_relaxed r0 =
         let lg2 =
           Coq_Z.log2_up (Coq_Z.add (Coq_Z.sub r0.upper r0.lower) (Zpos XH))
         in
         let lg2u = Coq_Z.log2_up (Coq_Z.add r0.upper (Zpos XH)) in
         let lg2l =
           if Coq_Z.ltb r0.lower Z0
           then Coq_Z.add (Zpos XH) (Coq_Z.log2_up (Coq_Z.opp r0.lower))
           else Z0
         in
         let lg3 = Coq_Z.max lg2 (Coq_Z.max lg2u lg2l) in
         let lg2lg2u = Coq_Z.log2_up lg3 in
         if Coq_Z.leb Z0 r0.lower
         then Coq_unsigned (Coq_Z.to_nat lg2lg2u)
         else Coq_signed (Coq_Z.to_nat lg2lg2u)
      end
      include Coq__10

      (** val unsigned_counterpart_of : coq_type -> coq_type **)

      let unsigned_counterpart_of t0 =
        Coq_unsigned (lgbitwidth_of t0)

      (** val signed_counterpart_of : coq_type -> coq_type **)

      let signed_counterpart_of t0 =
        Coq_signed (lgbitwidth_of t0)

      (** val show_lvl_type : coq_type showLevel **)

      let show_lvl_type t0 =
        neg_wrap_parens
          (append (if is_unsigned t0 then 'u'::[] else [])
            (append ('i'::('n'::('t'::[])))
              (Coq0_Z.to_string (bitwidth_of t0))))

      (** val show_type : coq_type show **)

      let show_type =
        show_of_ShowLevel show_lvl_type

      (** val to_string_gen :
          Options.language_naming_conventions_opt -> z list -> char list ->
          char list -> char list -> char list -> bool -> char list ->
          coq_type -> char list **)

      let to_string_gen language_naming_conventions0 standard_bitwidths unsigned_s signed_s standard_postfix special_postfix private0 prefix1 t0 =
        let is_standard =
          existsb (Coq_Z.eqb (bitwidth_of t0)) standard_bitwidths
        in
        (if is_standard
         then (fun s0 -> s0)
         else (fun s0 ->
                Options.convert_to_naming_convention
                  (if private0
                   then language_naming_conventions0.Options.private_type_naming_convention
                   else language_naming_conventions0.Options.public_type_naming_convention)
                  (append prefix1 s0)))
          (append (if is_unsigned t0 then unsigned_s else signed_s)
            (append (Coq0_Z.to_string (bitwidth_of t0))
              (if is_standard then standard_postfix else special_postfix)))

      (** val to_string_gen_opt_typedef :
          Options.language_naming_conventions_opt ->
          Options.skip_typedefs_opt -> z list -> char list -> char list ->
          char list -> char list -> bool -> bool -> char list -> coq_type ->
          char list option -> char list **)

      let to_string_gen_opt_typedef language_naming_conventions0 skip_typedefs0 standard_bitwidths unsigned_s signed_s standard_postfix special_postfix private0 typedef_private prefix1 t0 typedef0 =
        match if skip_typedefs0 then None else typedef0 with
        | Some typedef1 ->
          format_typedef_name language_naming_conventions0 prefix1
            typedef_private typedef1
        | None ->
          to_string_gen language_naming_conventions0 standard_bitwidths
            unsigned_s signed_s standard_postfix special_postfix private0
            prefix1 t0

      (** val union : coq_type -> coq_type -> coq_type **)

      let union t1 t2 =
        of_zrange_relaxed (Coq__9.union (to_zrange t1) (to_zrange t2))

      (** val union_zrange : zrange -> coq_type -> coq_type **)

      let union_zrange r0 t0 =
        of_zrange_relaxed (Coq__9.union r0 (to_zrange t0))

      module Coq_option =
       struct
        type interp = __

        module Coq_interp =
         struct
          (** val of_zrange_relaxed :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
              interp **)

          let rec of_zrange_relaxed = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z ->
               Obj.magic option_map Coq__10.of_zrange_relaxed
             | Coq3_Compilers.Coq_bool -> (fun _ -> Obj.magic ())
             | Coq3_Compilers.Coq_nat -> (fun _ -> Obj.magic ())
             | Coq3_Compilers.Coq_zrange -> (fun _ -> Obj.magic ())
             | Coq3_Compilers.Coq_string -> (fun _ -> Obj.magic ()))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              Obj.magic ((of_zrange_relaxed a a0), (of_zrange_relaxed b b0)))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            Obj.magic option_map (map (of_zrange_relaxed a))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            Obj.magic option_map (option_map (of_zrange_relaxed a))
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> Obj.magic ())

          (** val to_union :
              Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
              interp -> coq_type option **)

          let rec to_union = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z -> (fun r0 -> Obj.magic r0)
             | Coq3_Compilers.Coq_bool ->
               (fun pat -> let () = Obj.magic pat in None)
             | Coq3_Compilers.Coq_nat ->
               (fun pat -> let () = Obj.magic pat in None)
             | Coq3_Compilers.Coq_zrange ->
               (fun pat -> let () = Obj.magic pat in None)
             | Coq3_Compilers.Coq_string ->
               (fun pat -> let () = Obj.magic pat in None))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (a0, b0) = Obj.magic pat in
              bind (to_union a a0) (fun a1 ->
                bind (to_union b b0) (fun b1 -> Some (union a1 b1))))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun ls ->
              bind (Obj.magic ls) (fun ls0 ->
                Option.List.bind_list (map (to_union a) ls0) (fun ls1 ->
                  match ls1 with
                  | [] -> None
                  | x :: xs -> Some (fold_right union x xs))))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun x ->
              bind (Obj.magic x) (fun x0 ->
                bind (option_map (to_union a) x0) (fun x1 -> x1)))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            (fun pat -> let () = Obj.magic pat in None)
         end

        (** val coq_None :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> interp **)

        let rec coq_None = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z -> Obj.magic None
           | Coq3_Compilers.Coq_bool -> Obj.magic ()
           | Coq3_Compilers.Coq_nat -> Obj.magic ()
           | Coq3_Compilers.Coq_zrange -> Obj.magic ()
           | Coq3_Compilers.Coq_string -> Obj.magic ())
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          Obj.magic ((coq_None a), (coq_None b))
        | Compilers.Coq_base.Coq_type.Coq_list _ -> Obj.magic None
        | Compilers.Coq_base.Coq_type.Coq_option _ -> Obj.magic None
        | Compilers.Coq_base.Coq_type.Coq_unit -> Obj.magic ()
       end
     end

    module SumPositiveSet = SumSets(PositiveSet)(PositiveSet)

    module IntAsDecidableType =
     struct
      type t = Coq_int.coq_type

      (** val eq_dec : Coq_int.coq_type -> Coq_int.coq_type -> bool **)

      let eq_dec =
        Coq_int.type_eq_dec

      (** val to_ : t -> (positive, positive) sum **)

      let to_ v =
        (if Coq_int.is_signed v then (fun x -> Inl x) else (fun x -> Inr x))
          (Coq_Pos.of_succ_nat (Coq_int.lgbitwidth_of v))

      (** val of_ : (positive, positive) sum -> t **)

      let of_ v =
        let is_signed0 = match v with
                         | Inl _ -> true
                         | Inr _ -> false in
        let lgbitwidth = match v with
                         | Inl v0 -> v0
                         | Inr v0 -> v0 in
        Coq_int.of_lgbitwidth is_signed0
          (Nat.pred (Coq_Pos.to_nat lgbitwidth))
     end

    module IntSet = IsoWSets(SumPositiveSet)(IntAsDecidableType)

    type ident_infos = { bitwidths_used : IntSet.t;
                         addcarryx_lg_splits : PositiveSet.t;
                         mulx_lg_splits : PositiveSet.t;
                         cmovznz_bitwidths : IntSet.t;
                         value_barrier_bitwidths : IntSet.t;
                         typedefs_used : char list list }

    (** val bitwidths_used : ident_infos -> IntSet.t **)

    let bitwidths_used i =
      i.bitwidths_used

    (** val addcarryx_lg_splits : ident_infos -> PositiveSet.t **)

    let addcarryx_lg_splits i =
      i.addcarryx_lg_splits

    (** val mulx_lg_splits : ident_infos -> PositiveSet.t **)

    let mulx_lg_splits i =
      i.mulx_lg_splits

    (** val cmovznz_bitwidths : ident_infos -> IntSet.t **)

    let cmovznz_bitwidths i =
      i.cmovznz_bitwidths

    (** val value_barrier_bitwidths : ident_infos -> IntSet.t **)

    let value_barrier_bitwidths i =
      i.value_barrier_bitwidths

    (** val typedefs_used : ident_infos -> char list list **)

    let typedefs_used i =
      i.typedefs_used

    (** val ident_infos_equal : ident_infos -> ident_infos -> bool **)

    let ident_infos_equal x y =
      let { bitwidths_used = x0; addcarryx_lg_splits = x1; mulx_lg_splits =
        x2; cmovznz_bitwidths = x3; value_barrier_bitwidths = x4;
        typedefs_used = x5 } = x
      in
      let { bitwidths_used = y0; addcarryx_lg_splits = y1; mulx_lg_splits =
        y2; cmovznz_bitwidths = y3; value_barrier_bitwidths = y4;
        typedefs_used = y5 } = y
      in
      fold_right (&&) true
        ((IntSet.equal x0 y0) :: ((PositiveSet.equal x1 y1) :: ((PositiveSet.equal
                                                                  x2 y2) :: (
        (IntSet.equal x3 y3) :: ((IntSet.equal x4 y4) :: ((list_beq eqb0 x5
                                                            y5) :: []))))))

    (** val ident_info_empty : ident_infos **)

    let ident_info_empty =
      { bitwidths_used = IntSet.empty; addcarryx_lg_splits =
        PositiveSet.empty; mulx_lg_splits = PositiveSet.empty;
        cmovznz_bitwidths = IntSet.empty; value_barrier_bitwidths =
        IntSet.empty; typedefs_used = [] }

    (** val ident_info_diff : ident_infos -> ident_infos -> ident_infos **)

    let ident_info_diff x y =
      let { bitwidths_used = x0; addcarryx_lg_splits = x1; mulx_lg_splits =
        x2; cmovznz_bitwidths = x3; value_barrier_bitwidths = x4;
        typedefs_used = x5 } = x
      in
      let { bitwidths_used = y0; addcarryx_lg_splits = y1; mulx_lg_splits =
        y2; cmovznz_bitwidths = y3; value_barrier_bitwidths = y4;
        typedefs_used = y5 } = y
      in
      { bitwidths_used = (IntSet.diff x0 y0); addcarryx_lg_splits =
      (PositiveSet.diff x1 y1); mulx_lg_splits = (PositiveSet.diff x2 y2);
      cmovznz_bitwidths = (IntSet.diff x3 y3); value_barrier_bitwidths =
      (IntSet.diff x4 y4); typedefs_used =
      (filter (fun v -> negb (existsb (eqb0 v) y5)) x5) }

    (** val ident_info_union : ident_infos -> ident_infos -> ident_infos **)

    let ident_info_union x y =
      let { bitwidths_used = x0; addcarryx_lg_splits = x1; mulx_lg_splits =
        x2; cmovznz_bitwidths = x3; value_barrier_bitwidths = x4;
        typedefs_used = x5 } = x
      in
      let { bitwidths_used = y0; addcarryx_lg_splits = y1; mulx_lg_splits =
        y2; cmovznz_bitwidths = y3; value_barrier_bitwidths = y4;
        typedefs_used = y5 } = y
      in
      { bitwidths_used = (IntSet.union x0 y0); addcarryx_lg_splits =
      (PositiveSet.union x1 y1); mulx_lg_splits = (PositiveSet.union x2 y2);
      cmovznz_bitwidths = (IntSet.union x3 y3); value_barrier_bitwidths =
      (IntSet.union x4 y4); typedefs_used =
      (app x5 (filter (fun v -> negb (existsb (eqb0 v) x5)) y5)) }

    (** val ident_info_of_bitwidths_used : IntSet.t -> ident_infos **)

    let ident_info_of_bitwidths_used v =
      { bitwidths_used = v; addcarryx_lg_splits = PositiveSet.empty;
        mulx_lg_splits = PositiveSet.empty; cmovznz_bitwidths = IntSet.empty;
        value_barrier_bitwidths = IntSet.empty; typedefs_used = [] }

    (** val ident_info_of_addcarryx : PositiveSet.t -> ident_infos **)

    let ident_info_of_addcarryx v =
      { bitwidths_used = IntSet.empty; addcarryx_lg_splits = v;
        mulx_lg_splits = PositiveSet.empty; cmovznz_bitwidths = IntSet.empty;
        value_barrier_bitwidths = IntSet.empty; typedefs_used = [] }

    (** val ident_info_of_mulx : PositiveSet.t -> ident_infos **)

    let ident_info_of_mulx v =
      { bitwidths_used = IntSet.empty; addcarryx_lg_splits =
        PositiveSet.empty; mulx_lg_splits = v; cmovznz_bitwidths =
        IntSet.empty; value_barrier_bitwidths = IntSet.empty; typedefs_used =
        [] }

    (** val ident_info_of_cmovznz : IntSet.t -> ident_infos **)

    let ident_info_of_cmovznz v =
      { bitwidths_used = IntSet.empty; addcarryx_lg_splits =
        PositiveSet.empty; mulx_lg_splits = PositiveSet.empty;
        cmovznz_bitwidths = v; value_barrier_bitwidths = IntSet.empty;
        typedefs_used = [] }

    (** val ident_info_of_value_barrier : IntSet.t -> ident_infos **)

    let ident_info_of_value_barrier v =
      { bitwidths_used = IntSet.empty; addcarryx_lg_splits =
        PositiveSet.empty; mulx_lg_splits = PositiveSet.empty;
        cmovznz_bitwidths = IntSet.empty; value_barrier_bitwidths = v;
        typedefs_used = [] }

    (** val ident_info_of_typedefs : char list list -> ident_infos **)

    let ident_info_of_typedefs v =
      { bitwidths_used = IntSet.empty; addcarryx_lg_splits =
        PositiveSet.empty; mulx_lg_splits = PositiveSet.empty;
        cmovznz_bitwidths = IntSet.empty; value_barrier_bitwidths =
        IntSet.empty; typedefs_used = v }

    (** val ident_info_with_value_barrier :
        ident_infos -> IntSet.t -> ident_infos **)

    let ident_info_with_value_barrier i v =
      { bitwidths_used = i.bitwidths_used; addcarryx_lg_splits =
        i.addcarryx_lg_splits; mulx_lg_splits = i.mulx_lg_splits;
        cmovznz_bitwidths = i.cmovznz_bitwidths; value_barrier_bitwidths = v;
        typedefs_used = i.typedefs_used }

    module OfPHOAS =
     struct
      type base_var_data = __

      type var_data = __

      type base_var_typedef_data = __

      (** val base_var_typedef_data_None :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          base_var_typedef_data **)

      let rec base_var_typedef_data_None = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z -> Obj.magic None
         | Coq3_Compilers.Coq_bool -> Obj.magic ()
         | Coq3_Compilers.Coq_nat -> Obj.magic ()
         | Coq3_Compilers.Coq_zrange -> Obj.magic ()
         | Coq3_Compilers.Coq_string -> Obj.magic ())
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        Obj.magic ((base_var_typedef_data_None a),
          (base_var_typedef_data_None b))
      | Compilers.Coq_base.Coq_type.Coq_list _ -> Obj.magic None
      | Compilers.Coq_base.Coq_type.Coq_option _ -> Obj.magic ()
      | Compilers.Coq_base.Coq_type.Coq_unit -> Obj.magic ()

      type var_typedef_data = __

      (** val var_typedef_data_None :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> var_typedef_data **)

      let var_typedef_data_None = function
      | Compilers.Coq_type.Coq_base t1 -> base_var_typedef_data_None t1
      | Compilers.Coq_type.Coq_arrow (_, _) -> Obj.magic ()

      type base_var_names = __

      type var_names = __

      (** val names_list_of_base_var_names :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          base_var_names -> char list list **)

      let rec names_list_of_base_var_names = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z -> (fun n3 -> (Obj.magic n3) :: [])
         | Coq3_Compilers.Coq_bool ->
           (fun _ -> assert false (* absurd case *))
         | Coq3_Compilers.Coq_nat -> (fun _ -> assert false (* absurd case *))
         | Coq3_Compilers.Coq_zrange ->
           (fun _ -> assert false (* absurd case *))
         | Coq3_Compilers.Coq_string ->
           (fun _ -> assert false (* absurd case *)))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun x ->
          app (names_list_of_base_var_names a (fst (Obj.magic x)))
            (names_list_of_base_var_names b (snd (Obj.magic x))))
      | Compilers.Coq_base.Coq_type.Coq_list _ ->
        (fun n3 -> (Obj.magic n3) :: [])
      | Compilers.Coq_base.Coq_type.Coq_option _ ->
        (fun _ -> assert false (* absurd case *))
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> [])

      (** val names_list_of_var_names :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> var_names -> char list list **)

      let names_list_of_var_names = function
      | Compilers.Coq_type.Coq_base t1 -> names_list_of_base_var_names t1
      | Compilers.Coq_type.Coq_arrow (_, _) ->
        (fun _ -> assert false (* absurd case *))

      (** val names_of_base_var_data :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          base_var_data -> base_var_names **)

      let rec names_of_base_var_data = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z ->
           (fun pat ->
             let (p, _) = Obj.magic pat in
             let (p0, _) = p in let (n3, _) = p0 in n3)
         | Coq3_Compilers.Coq_bool -> (fun x -> x)
         | Coq3_Compilers.Coq_nat -> (fun x -> x)
         | Coq3_Compilers.Coq_zrange -> (fun x -> x)
         | Coq3_Compilers.Coq_string -> (fun x -> x))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun xy ->
          Obj.magic ((names_of_base_var_data a (fst (Obj.magic xy))),
            (names_of_base_var_data b (snd (Obj.magic xy)))))
      | Compilers.Coq_base.Coq_type.Coq_list _ ->
        (fun x -> fst (fst (fst (Obj.magic x))))
      | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun x -> x)
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> x)

      (** val names_of_var_data :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> var_data -> var_names **)

      let names_of_var_data = function
      | Compilers.Coq_type.Coq_base t1 -> names_of_base_var_data t1
      | Compilers.Coq_type.Coq_arrow (_, _) -> (fun x -> x)

      (** val names_list_of_var_data :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> var_data -> char list list **)

      let names_list_of_var_data t0 v =
        names_list_of_var_names t0 (names_of_var_data t0 v)

      (** val base_var_data_of_names :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          base_var_names -> base_var_data **)

      let rec base_var_data_of_names = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z ->
           (fun n3 -> Obj.magic (((n3, false), None), None))
         | Coq3_Compilers.Coq_bool -> (fun x -> x)
         | Coq3_Compilers.Coq_nat -> (fun x -> x)
         | Coq3_Compilers.Coq_zrange -> (fun x -> x)
         | Coq3_Compilers.Coq_string -> (fun x -> x))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun xy ->
          Obj.magic ((base_var_data_of_names a (fst (Obj.magic xy))),
            (base_var_data_of_names b (snd (Obj.magic xy)))))
      | Compilers.Coq_base.Coq_type.Coq_list _ ->
        (fun n3 -> Obj.magic (((n3, None), O), None))
      | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun x -> x)
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> x)

      (** val var_data_of_names :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> var_names -> var_data **)

      let var_data_of_names = function
      | Compilers.Coq_type.Coq_base t1 -> base_var_data_of_names t1
      | Compilers.Coq_type.Coq_arrow (_, _) -> (fun x -> x)

      (** val bound_to_string :
          Options.skip_typedefs_opt -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> var_data ->
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
          char list list **)

      let rec bound_to_string skip_typedefs0 = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z ->
           (fun pat ->
             let (p, td) = Obj.magic pat in
             let (p0, _) = p in
             let (name0, _) = p0 in
             (fun arg ->
             if (||) skip_typedefs0 (is_None td)
             then (append (append name0 (':'::(' '::[])))
                    (match Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z) arg with
                     | Some arg0 ->
                       show0
                         (ZRange.Coq_type.Coq_base.show_interp
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)) arg0
                     | None ->
                       show0
                         (ZRange.Coq_type.Coq_base.Coq_option.show_interp
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)) arg)) :: []
             else []))
         | Coq3_Compilers.Coq_bool ->
           (fun _ -> assert false (* absurd case *))
         | Coq3_Compilers.Coq_nat -> (fun _ -> assert false (* absurd case *))
         | Coq3_Compilers.Coq_zrange ->
           (fun _ -> assert false (* absurd case *))
         | Coq3_Compilers.Coq_string ->
           (fun _ -> assert false (* absurd case *)))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun pat ->
          let (va, vb) = Obj.magic pat in
          (fun pat0 ->
          let (a0, b0) = Obj.magic pat0 in
          app (bound_to_string skip_typedefs0 a va a0)
            (bound_to_string skip_typedefs0 b vb b0)))
      | Compilers.Coq_base.Coq_type.Coq_list a ->
        (fun pat ->
          let (p, td) = Obj.magic pat in
          let (p0, _) = p in
          let (name0, _) = p0 in
          (fun arg ->
          if (||) skip_typedefs0 (is_None td)
          then (append (append name0 (':'::(' '::[])))
                 (match Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                          (Compilers.Coq_base.Coq_type.Coq_list a) arg with
                  | Some arg0 ->
                    show0
                      (ZRange.Coq_type.Coq_base.show_interp
                        (Compilers.Coq_base.Coq_type.Coq_list a)) arg0
                  | None ->
                    show0
                      (ZRange.Coq_type.Coq_base.Coq_option.show_interp
                        (Compilers.Coq_base.Coq_type.Coq_list a)) arg)) :: []
          else []))
      | Compilers.Coq_base.Coq_type.Coq_option _ ->
        (fun _ -> assert false (* absurd case *))
      | Compilers.Coq_base.Coq_type.Coq_unit ->
        (fun pat -> let () = Obj.magic pat in (fun _ -> []))

      (** val input_bounds_to_string :
          Options.skip_typedefs_opt -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          var_data) Compilers.Coq_type.for_each_lhs_of_arrow ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow -> char list list **)

      let rec input_bounds_to_string skip_typedefs0 = function
      | Compilers.Coq_type.Coq_base _ -> (fun _ _ -> [])
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (match s0 with
         | Compilers.Coq_type.Coq_base s1 ->
           (fun pat ->
             let (v, vs) = Obj.magic pat in
             (fun pat0 ->
             let (arg, args0) = Obj.magic pat0 in
             app (bound_to_string skip_typedefs0 s1 v arg)
               (input_bounds_to_string skip_typedefs0 d vs args0)))
         | Compilers.Coq_type.Coq_arrow (_, _) ->
           (fun pat ->
             let (_, _) = Obj.magic pat in assert false (* absurd case *)))
     end

    (** val format_special_function_name :
        Options.language_naming_conventions_opt -> bool -> char list ->
        char list -> bool -> z -> char list **)

    let format_special_function_name language_naming_conventions0 internal_private prefix1 name0 is_signed0 bw =
      Options.convert_to_naming_convention
        (if internal_private
         then language_naming_conventions0.Options.private_function_naming_convention
         else language_naming_conventions0.Options.public_function_naming_convention)
        (append prefix1
          (append name0
            (append ('_'::[])
              (append (if negb is_signed0 then 'u'::[] else [])
                (Coq0_Z.to_string bw)))))

    (** val name_of_typedef :
        Options.language_naming_conventions_opt -> char list -> bool ->
        (((char list * (char list -> char list)) * Coq_int.coq_type
        option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
        char list **)

    let name_of_typedef language_naming_conventions0 prefix1 private0 = function
    | (p, s0) ->
      let (p0, _) = p in
      let (name0, _) = p0 in
      let ExistT (_, _) = s0 in
      format_typedef_name language_naming_conventions0 prefix1 private0 name0

    (** val describe_typedef :
        Options.language_naming_conventions_opt ->
        Options.documentation_options_opt -> char list -> bool ->
        (((char list * (char list -> char list)) * Coq_int.coq_type
        option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
        char list list **)

    let describe_typedef language_naming_conventions0 documentation_options0 prefix1 private0 typedef0 =
      let name0 =
        name_of_typedef language_naming_conventions0 prefix1 private0 typedef0
      in
      let (p, s0) = typedef0 in
      let (p0, _) = p in
      let (_, description0) = p0 in
      let ExistT (t0, bounds1) = s0 in
      app ((description0 name0) :: [])
        (if Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.is_informative
              t0 bounds1
         then let bounds2 =
                match Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                        t0 bounds1 with
                | Some bounds2 ->
                  show0 (ZRange.Coq_type.Coq_base.show_interp t0) bounds2
                | None ->
                  show0 (ZRange.Coq_type.Coq_base.Coq_option.show_interp t0)
                    bounds1
              in
              if documentation_options0.Options.newline_in_typedef_bounds
              then ('B'::('o'::('u'::('n'::('d'::('s'::(':'::[]))))))) :: (
                     (append (' '::(' '::[])) bounds2) :: [])
              else (append
                     ('B'::('o'::('u'::('n'::('d'::('s'::(':'::(' '::[]))))))))
                     bounds2) :: []
         else [])

    (** val array_length_of_typedef :
        (((char list * (char list -> char list)) * Coq_int.coq_type
        option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
        nat option option **)

    let array_length_of_typedef = function
    | (p, s0) ->
      let (p0, _) = p in
      let (_, _) = p0 in
      let ExistT (t0, bounds1) = s0 in
      (match t0 with
       | Compilers.Coq_base.Coq_type.Coq_type_base _ -> (fun _ -> None)
       | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> None)
       | Compilers.Coq_base.Coq_type.Coq_list _ ->
         (fun bounds2 -> Some (option_map length (Obj.magic bounds2)))
       | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
       | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None)) bounds1

    (** val name_and_type_and_describe_typedef :
        Options.language_naming_conventions_opt ->
        Options.documentation_options_opt -> char list -> bool ->
        (((char list * (char list -> char list)) * Coq_int.coq_type
        option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
        (char list * (Coq_int.coq_type option * nat option
        option)) * char list list **)

    let name_and_type_and_describe_typedef language_naming_conventions0 documentation_options0 prefix1 private0 typedef0 =
      let name0 =
        name_of_typedef language_naming_conventions0 prefix1 private0 typedef0
      in
      let description0 =
        describe_typedef language_naming_conventions0 documentation_options0
          prefix1 private0 typedef0
      in
      let len = array_length_of_typedef typedef0 in
      let (p, _) = typedef0 in
      let (p0, ty) = p in
      let (_, _) = p0 in ((name0, (ty, len)), description0)

    (** val format_special_function_name_ty :
        Options.language_naming_conventions_opt -> bool -> char list ->
        char list -> Coq_int.coq_type -> char list **)

    let format_special_function_name_ty language_naming_conventions0 internal_private prefix1 name0 t0 =
      format_special_function_name language_naming_conventions0
        internal_private prefix1 name0 (Coq_int.is_signed t0)
        (Coq_int.bitwidth_of t0)

    (** val normalize_newlines : char list list -> char list list **)

    let normalize_newlines lines0 =
      split (newLine::[]) (concat0 (newLine::[]) lines0)

    (** val preprocess_comment_block : char list list -> char list list **)

    let preprocess_comment_block =
      normalize_newlines

    (** val prefix_and_indent :
        char list -> char list list -> char list list **)

    let prefix_and_indent prefix1 lines0 =
      let lines1 = normalize_newlines lines0 in
      (match lines1 with
       | [] -> prefix1 :: []
       | val0 :: vals ->
         let indent0 = repeat0 ' ' (length0 prefix1) in
         (append prefix1 val0) :: (map (fun v -> append indent0 v) vals))

    type coq_OutputLanguageAPI = { comment_block : (char list list ->
                                                   char list list);
                                   comment_file_header_block : (char list
                                                               list ->
                                                               char list list);
                                   coq_ToFunctionLines : (Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
                                                         ->
                                                         Options.relax_zrange_opt
                                                         ->
                                                         Options.language_naming_conventions_opt
                                                         ->
                                                         Options.documentation_options_opt
                                                         ->
                                                         Options.output_options_opt
                                                         -> z -> bool -> bool
                                                         -> bool -> bool ->
                                                         bool -> char list ->
                                                         char list ->
                                                         Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type
                                                         Compilers.Coq_type.coq_type
                                                         ->
                                                         (Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         Coq3_Compilers.ident)
                                                         Compilers.Coq_expr.coq_Expr
                                                         ->
                                                         ((Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         OfPHOAS.var_data)
                                                         Compilers.Coq_type.for_each_lhs_of_arrow
                                                         -> OfPHOAS.var_data
                                                         -> char list list)
                                                         -> char list list
                                                         option ->
                                                         (Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
                                                         Compilers.Coq_type.for_each_lhs_of_arrow
                                                         ->
                                                         Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
                                                         ->
                                                         (Coq3_Compilers.base
                                                         Compilers.Coq_base.Coq_type.coq_type,
                                                         OfPHOAS.var_typedef_data)
                                                         Compilers.Coq_type.for_each_lhs_of_arrow
                                                         ->
                                                         OfPHOAS.base_var_typedef_data
                                                         -> (char list
                                                         list * ident_infos,
                                                         char list) sum);
                                   header : (Options.language_naming_conventions_opt
                                            ->
                                            Options.documentation_options_opt
                                            -> Options.package_name_opt ->
                                            Options.class_name_opt ->
                                            Options.output_options_opt -> z
                                            -> bool -> bool -> char list ->
                                            ident_infos ->
                                            (((char list * (char list ->
                                            char list)) * Coq_int.coq_type
                                            option) * (Coq3_Compilers.base
                                            Compilers.Coq_base.Coq_type.coq_type,
                                            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
                                            sigT) list -> char list list);
                                   footer : (Options.language_naming_conventions_opt
                                            ->
                                            Options.documentation_options_opt
                                            -> Options.package_name_opt ->
                                            Options.class_name_opt -> z ->
                                            bool -> bool -> char list ->
                                            ident_infos -> char list list);
                                   strip_special_infos : (z -> ident_infos ->
                                                         ident_infos) }

    (** val comment_file_header_block :
        coq_OutputLanguageAPI -> char list list -> char list list **)

    let comment_file_header_block outputLanguageAPI =
      outputLanguageAPI.comment_file_header_block

    (** val coq_ToFunctionLines :
        coq_OutputLanguageAPI ->
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        Options.relax_zrange_opt -> Options.language_naming_conventions_opt
        -> Options.documentation_options_opt -> Options.output_options_opt ->
        z -> bool -> bool -> bool -> bool -> bool -> char list -> char list
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> ((Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, OfPHOAS.var_data)
        Compilers.Coq_type.for_each_lhs_of_arrow -> OfPHOAS.var_data ->
        char list list) -> char list list option -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
        Compilers.Coq_type.for_each_lhs_of_arrow ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        OfPHOAS.var_typedef_data) Compilers.Coq_type.for_each_lhs_of_arrow ->
        OfPHOAS.base_var_typedef_data -> (char list list * ident_infos,
        char list) sum **)

    let coq_ToFunctionLines outputLanguageAPI =
      outputLanguageAPI.coq_ToFunctionLines

    (** val header :
        coq_OutputLanguageAPI -> Options.language_naming_conventions_opt ->
        Options.documentation_options_opt -> Options.package_name_opt ->
        Options.class_name_opt -> Options.output_options_opt -> z -> bool ->
        bool -> char list -> ident_infos -> (((char list * (char list ->
        char list)) * Coq_int.coq_type option) * (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list
        -> char list list **)

    let header outputLanguageAPI =
      outputLanguageAPI.header

    (** val footer :
        coq_OutputLanguageAPI -> Options.language_naming_conventions_opt ->
        Options.documentation_options_opt -> Options.package_name_opt ->
        Options.class_name_opt -> z -> bool -> bool -> char list ->
        ident_infos -> char list list **)

    let footer outputLanguageAPI =
      outputLanguageAPI.footer

    (** val strip_special_infos :
        coq_OutputLanguageAPI -> z -> ident_infos -> ident_infos **)

    let strip_special_infos outputLanguageAPI =
      outputLanguageAPI.strip_special_infos
   end
 end

module Coq3_List =
 struct
  (** val combine_extend :
      'a1 -> 'a2 -> 'a1 list -> 'a2 list -> ('a1 * 'a2) list **)

  let combine_extend defaultA =
    let rec combine_extend0 defaultA0 defaultB l l' =
      match l with
      | [] ->
        (match l' with
         | [] -> []
         | _ :: _ -> map (fun y -> (defaultA0, y)) l')
      | x :: tl1 ->
        (match l' with
         | [] -> map (fun x0 -> (x0, defaultB)) l
         | y :: tl'0 -> (x, y) :: (combine_extend0 x y tl1 tl'0))
    in combine_extend0 defaultA
 end

module Coq4_List =
 struct
  (** val removen : ('a1 -> bool) -> 'a1 list -> nat -> 'a1 list **)

  let removen f =
    let rec removen0 l n3 = match n3 with
    | O -> l
    | S n' ->
      (match l with
       | [] -> []
       | x :: xs -> if f x then removen0 xs n' else x :: (removen0 xs n3))
    in removen0
 end

module ErrorT =
 struct
  module List =
   struct
    (** val bind_list :
        ('a1, 'a2) errorT list -> ('a2 list -> ('a1, 'a3) errorT) -> ('a1,
        'a3) errorT **)

    let rec bind_list v f =
      match v with
      | [] -> f []
      | x :: xs -> bind0 x (fun x0 -> bind_list xs (fun xs0 -> f (x0 :: xs0)))
   end
 end

type assembly_calling_registers_opt = rEG list option

(** val default_assembly_calling_registers : rEG list **)

let default_assembly_calling_registers =
  Rdi :: (Rsi :: (Rdx :: (Rcx :: (R8 :: (R9 :: [])))))

(** val assembly_calling_registers :
    assembly_calling_registers_opt -> rEG list **)

let assembly_calling_registers v =
  sequence_return0 v default_assembly_calling_registers

type assembly_callee_saved_registers_opt =
| Microsoft_x64
| System_V_AMD64
| Explicit_registers of rEG list

(** val microsoft_x64_assembly_callee_saved_registers : rEG list **)

let microsoft_x64_assembly_callee_saved_registers =
  Rbx :: (Rbp :: (Rdi :: (Rsi :: (Rsp :: (R12 :: (R13 :: (R14 :: (R15 :: []))))))))

(** val system_v_amd64_assembly_callee_saved_registers : rEG list **)

let system_v_amd64_assembly_callee_saved_registers =
  Rbx :: (Rsp :: (Rbp :: (R12 :: (R13 :: (R14 :: (R15 :: []))))))

(** val default_assembly_callee_saved_registers :
    assembly_callee_saved_registers_opt **)

let default_assembly_callee_saved_registers =
  System_V_AMD64

(** val assembly_callee_saved_registers :
    assembly_callee_saved_registers_opt -> rEG list **)

let assembly_callee_saved_registers = function
| Microsoft_x64 -> microsoft_x64_assembly_callee_saved_registers
| System_V_AMD64 -> system_v_amd64_assembly_callee_saved_registers
| Explicit_registers ls -> ls

type assembly_output_first_opt = bool

type assembly_argument_registers_left_to_right_opt = bool

type assembly_stack_size_opt = n option

(** val assembly_stack_size_at : z -> line list -> z list **)

let rec assembly_stack_size_at cur_stack_size = function
| [] -> []
| l :: asm0 ->
  let cng =
    match l.rawline with
    | SECTION _ -> Z0
    | GLOBAL _ -> Z0
    | LABEL _ -> Z0
    | ALIGN _ -> Z0
    | DEFAULT_REL -> Z0
    | EMPTY -> Z0
    | INSTR instr ->
      let op1 = instr.op in
      let args0 = instr.args in
      (match op1 with
       | Adc ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Adcx ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Add ->
         (match args0 with
          | [] ->
            (match operation_size instr with
             | Some s0 ->
               let op2 = instr.op in
               let args1 = instr.args in
               (match op2 with
                | Adc -> Z0
                | Adcx -> Z0
                | Add -> Z0
                | Adox -> Z0
                | And -> Z0
                | Bzhi -> Z0
                | Call -> Z0
                | Clc -> Z0
                | Cmovb -> Z0
                | Cmovc -> Z0
                | Cmovnz -> Z0
                | Cmovo -> Z0
                | Cmp -> Z0
                | Db0 -> Z0
                | Dd0 -> Z0
                | Dec -> Z0
                | Dq -> Z0
                | Dw -> Z0
                | Imul -> Z0
                | Inc -> Z0
                | Je -> Z0
                | Jmp -> Z0
                | Lea -> Z0
                | Mov -> Z0
                | Movzx -> Z0
                | Mul -> Z0
                | Mulx -> Z0
                | Or -> Z0
                | Pop ->
                  (match args1 with
                   | [] -> Z0
                   | _ :: l0 ->
                     (match l0 with
                      | [] ->
                        Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO
                          (XO XH))))
                      | _ :: _ -> Z0))
                | Push ->
                  (match args1 with
                   | [] -> Z0
                   | _ :: l0 ->
                     (match l0 with
                      | [] ->
                        Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                      | _ :: _ -> Z0))
                | Rcr -> Z0
                | Ret -> Z0
                | Sar -> Z0
                | Sbb -> Z0
                | Setc -> Z0
                | Seto -> Z0
                | Shl -> Z0
                | Shlx -> Z0
                | Shr -> Z0
                | Shrx -> Z0
                | Shrd -> Z0
                | Sub -> Z0
                | Test -> Z0
                | Xchg -> Z0
                | Xor -> Z0)
             | None -> Z0)
          | a :: l0 ->
            (match a with
             | Reg r0 ->
               (match r0 with
                | Rax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rcx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rdx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rbx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rsp ->
                  (match l0 with
                   | [] ->
                     (match operation_size instr with
                      | Some s0 ->
                        let op2 = instr.op in
                        let args1 = instr.args in
                        (match op2 with
                         | Adc -> Z0
                         | Adcx -> Z0
                         | Add -> Z0
                         | Adox -> Z0
                         | And -> Z0
                         | Bzhi -> Z0
                         | Call -> Z0
                         | Clc -> Z0
                         | Cmovb -> Z0
                         | Cmovc -> Z0
                         | Cmovnz -> Z0
                         | Cmovo -> Z0
                         | Cmp -> Z0
                         | Db0 -> Z0
                         | Dd0 -> Z0
                         | Dec -> Z0
                         | Dq -> Z0
                         | Dw -> Z0
                         | Imul -> Z0
                         | Inc -> Z0
                         | Je -> Z0
                         | Jmp -> Z0
                         | Lea -> Z0
                         | Mov -> Z0
                         | Movzx -> Z0
                         | Mul -> Z0
                         | Mulx -> Z0
                         | Or -> Z0
                         | Pop ->
                           (match args1 with
                            | [] -> Z0
                            | _ :: l1 ->
                              (match l1 with
                               | [] ->
                                 Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos
                                   (XO (XO (XO XH))))
                               | _ :: _ -> Z0))
                         | Push ->
                           (match args1 with
                            | [] -> Z0
                            | _ :: l1 ->
                              (match l1 with
                               | [] ->
                                 Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                   XH))))
                               | _ :: _ -> Z0))
                         | Rcr -> Z0
                         | Ret -> Z0
                         | Sar -> Z0
                         | Sbb -> Z0
                         | Setc -> Z0
                         | Seto -> Z0
                         | Shl -> Z0
                         | Shlx -> Z0
                         | Shr -> Z0
                         | Shrx -> Z0
                         | Shrd -> Z0
                         | Sub -> Z0
                         | Test -> Z0
                         | Xchg -> Z0
                         | Xor -> Z0)
                      | None -> Z0)
                   | a0 :: l1 ->
                     (match a0 with
                      | Reg _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)
                      | Mem _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)
                      | Const n3 ->
                        (match l1 with
                         | [] -> Coq_Z.opp n3
                         | _ :: _ ->
                           (match operation_size instr with
                            | Some s0 ->
                              let op2 = instr.op in
                              let args1 = instr.args in
                              (match op2 with
                               | Adc -> Z0
                               | Adcx -> Z0
                               | Add -> Z0
                               | Adox -> Z0
                               | And -> Z0
                               | Bzhi -> Z0
                               | Call -> Z0
                               | Clc -> Z0
                               | Cmovb -> Z0
                               | Cmovc -> Z0
                               | Cmovnz -> Z0
                               | Cmovo -> Z0
                               | Cmp -> Z0
                               | Db0 -> Z0
                               | Dd0 -> Z0
                               | Dec -> Z0
                               | Dq -> Z0
                               | Dw -> Z0
                               | Imul -> Z0
                               | Inc -> Z0
                               | Je -> Z0
                               | Jmp -> Z0
                               | Lea -> Z0
                               | Mov -> Z0
                               | Movzx -> Z0
                               | Mul -> Z0
                               | Mulx -> Z0
                               | Or -> Z0
                               | Pop ->
                                 (match args1 with
                                  | [] -> Z0
                                  | _ :: l2 ->
                                    (match l2 with
                                     | [] ->
                                       Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                         (Zpos (XO (XO (XO XH))))
                                     | _ :: _ -> Z0))
                               | Push ->
                                 (match args1 with
                                  | [] -> Z0
                                  | _ :: l2 ->
                                    (match l2 with
                                     | [] ->
                                       Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO
                                         (XO (XO XH))))
                                     | _ :: _ -> Z0))
                               | Rcr -> Z0
                               | Ret -> Z0
                               | Sar -> Z0
                               | Sbb -> Z0
                               | Setc -> Z0
                               | Seto -> Z0
                               | Shl -> Z0
                               | Shlx -> Z0
                               | Shr -> Z0
                               | Shrx -> Z0
                               | Shrd -> Z0
                               | Sub -> Z0
                               | Test -> Z0
                               | Xchg -> Z0
                               | Xor -> Z0)
                            | None -> Z0))
                      | Label _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)))
                | Rbp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rsi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rdi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Eax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ecx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Edx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ebx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Esp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ebp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Esi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Edi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Cx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Sp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Si ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Di ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ah ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Al ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ch ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Cl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dh ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bh ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Spl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bpl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Sil ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dil ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0))
             | Mem _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)
             | Const _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)
             | Label _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)))
       | Adox ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | And ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Bzhi ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Call ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Clc ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Cmovb ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Cmovc ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Cmovnz ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Cmovo ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Cmp ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Db0 ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Dd0 ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Dec ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Dq ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Dw ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Imul ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Inc ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Je ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Jmp ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Lea ->
         (match args0 with
          | [] ->
            (match operation_size instr with
             | Some s0 ->
               let op2 = instr.op in
               let args1 = instr.args in
               (match op2 with
                | Adc -> Z0
                | Adcx -> Z0
                | Add -> Z0
                | Adox -> Z0
                | And -> Z0
                | Bzhi -> Z0
                | Call -> Z0
                | Clc -> Z0
                | Cmovb -> Z0
                | Cmovc -> Z0
                | Cmovnz -> Z0
                | Cmovo -> Z0
                | Cmp -> Z0
                | Db0 -> Z0
                | Dd0 -> Z0
                | Dec -> Z0
                | Dq -> Z0
                | Dw -> Z0
                | Imul -> Z0
                | Inc -> Z0
                | Je -> Z0
                | Jmp -> Z0
                | Lea -> Z0
                | Mov -> Z0
                | Movzx -> Z0
                | Mul -> Z0
                | Mulx -> Z0
                | Or -> Z0
                | Pop ->
                  (match args1 with
                   | [] -> Z0
                   | _ :: l0 ->
                     (match l0 with
                      | [] ->
                        Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO
                          (XO XH))))
                      | _ :: _ -> Z0))
                | Push ->
                  (match args1 with
                   | [] -> Z0
                   | _ :: l0 ->
                     (match l0 with
                      | [] ->
                        Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                      | _ :: _ -> Z0))
                | Rcr -> Z0
                | Ret -> Z0
                | Sar -> Z0
                | Sbb -> Z0
                | Setc -> Z0
                | Seto -> Z0
                | Shl -> Z0
                | Shlx -> Z0
                | Shr -> Z0
                | Shrx -> Z0
                | Shrd -> Z0
                | Sub -> Z0
                | Test -> Z0
                | Xchg -> Z0
                | Xor -> Z0)
             | None -> Z0)
          | a :: l0 ->
            (match a with
             | Reg r0 ->
               (match r0 with
                | Rax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rcx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rdx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rbx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rsp ->
                  (match l0 with
                   | [] ->
                     (match operation_size instr with
                      | Some s0 ->
                        let op2 = instr.op in
                        let args1 = instr.args in
                        (match op2 with
                         | Adc -> Z0
                         | Adcx -> Z0
                         | Add -> Z0
                         | Adox -> Z0
                         | And -> Z0
                         | Bzhi -> Z0
                         | Call -> Z0
                         | Clc -> Z0
                         | Cmovb -> Z0
                         | Cmovc -> Z0
                         | Cmovnz -> Z0
                         | Cmovo -> Z0
                         | Cmp -> Z0
                         | Db0 -> Z0
                         | Dd0 -> Z0
                         | Dec -> Z0
                         | Dq -> Z0
                         | Dw -> Z0
                         | Imul -> Z0
                         | Inc -> Z0
                         | Je -> Z0
                         | Jmp -> Z0
                         | Lea -> Z0
                         | Mov -> Z0
                         | Movzx -> Z0
                         | Mul -> Z0
                         | Mulx -> Z0
                         | Or -> Z0
                         | Pop ->
                           (match args1 with
                            | [] -> Z0
                            | _ :: l1 ->
                              (match l1 with
                               | [] ->
                                 Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos
                                   (XO (XO (XO XH))))
                               | _ :: _ -> Z0))
                         | Push ->
                           (match args1 with
                            | [] -> Z0
                            | _ :: l1 ->
                              (match l1 with
                               | [] ->
                                 Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                   XH))))
                               | _ :: _ -> Z0))
                         | Rcr -> Z0
                         | Ret -> Z0
                         | Sar -> Z0
                         | Sbb -> Z0
                         | Setc -> Z0
                         | Seto -> Z0
                         | Shl -> Z0
                         | Shlx -> Z0
                         | Shr -> Z0
                         | Shrx -> Z0
                         | Shrd -> Z0
                         | Sub -> Z0
                         | Test -> Z0
                         | Xchg -> Z0
                         | Xor -> Z0)
                      | None -> Z0)
                   | a0 :: l1 ->
                     (match a0 with
                      | Reg _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)
                      | Mem m4 ->
                        let mem_bits_access_size0 = m4.mem_bits_access_size in
                        let mem_base_reg0 = m4.mem_base_reg in
                        let mem_scale_reg0 = m4.mem_scale_reg in
                        let mem_offset0 = m4.mem_offset in
                        (match mem_bits_access_size0 with
                         | Some sz ->
                           (match mem_base_reg0 with
                            | Some r1 ->
                              (match r1 with
                               | Rax ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rcx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rdx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rbx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rsp ->
                                 (match mem_scale_reg0 with
                                  | Some _ ->
                                    (match operation_size instr with
                                     | Some s0 ->
                                       let op2 = instr.op in
                                       let args1 = instr.args in
                                       (match op2 with
                                        | Adc -> Z0
                                        | Adcx -> Z0
                                        | Add -> Z0
                                        | Adox -> Z0
                                        | And -> Z0
                                        | Bzhi -> Z0
                                        | Call -> Z0
                                        | Clc -> Z0
                                        | Cmovb -> Z0
                                        | Cmovc -> Z0
                                        | Cmovnz -> Z0
                                        | Cmovo -> Z0
                                        | Cmp -> Z0
                                        | Db0 -> Z0
                                        | Dd0 -> Z0
                                        | Dec -> Z0
                                        | Dq -> Z0
                                        | Dw -> Z0
                                        | Imul -> Z0
                                        | Inc -> Z0
                                        | Je -> Z0
                                        | Jmp -> Z0
                                        | Lea -> Z0
                                        | Mov -> Z0
                                        | Movzx -> Z0
                                        | Mul -> Z0
                                        | Mulx -> Z0
                                        | Or -> Z0
                                        | Pop ->
                                          (match args1 with
                                           | [] -> Z0
                                           | _ :: l2 ->
                                             (match l2 with
                                              | [] ->
                                                Coq_Z.div
                                                  (Coq_Z.opp (Coq_Z.of_N s0))
                                                  (Zpos (XO (XO (XO XH))))
                                              | _ :: _ -> Z0))
                                        | Push ->
                                          (match args1 with
                                           | [] -> Z0
                                           | _ :: l2 ->
                                             (match l2 with
                                              | [] ->
                                                Coq_Z.div (Coq_Z.of_N s0)
                                                  (Zpos (XO (XO (XO XH))))
                                              | _ :: _ -> Z0))
                                        | Rcr -> Z0
                                        | Ret -> Z0
                                        | Sar -> Z0
                                        | Sbb -> Z0
                                        | Setc -> Z0
                                        | Seto -> Z0
                                        | Shl -> Z0
                                        | Shlx -> Z0
                                        | Shr -> Z0
                                        | Shrx -> Z0
                                        | Shrd -> Z0
                                        | Sub -> Z0
                                        | Test -> Z0
                                        | Xchg -> Z0
                                        | Xor -> Z0)
                                     | None -> Z0)
                                  | None ->
                                    (match mem_offset0 with
                                     | Some n3 ->
                                       (match l1 with
                                        | [] ->
                                          if Coq_N.eqb
                                               (bits_of_AccessSize sz) (Npos
                                               (XO (XO (XO (XO (XO (XO
                                               XH)))))))
                                          then Coq_Z.opp n3
                                          else Z0
                                        | _ :: _ ->
                                          (match operation_size instr with
                                           | Some s0 ->
                                             let op2 = instr.op in
                                             let args1 = instr.args in
                                             (match op2 with
                                              | Adc -> Z0
                                              | Adcx -> Z0
                                              | Add -> Z0
                                              | Adox -> Z0
                                              | And -> Z0
                                              | Bzhi -> Z0
                                              | Call -> Z0
                                              | Clc -> Z0
                                              | Cmovb -> Z0
                                              | Cmovc -> Z0
                                              | Cmovnz -> Z0
                                              | Cmovo -> Z0
                                              | Cmp -> Z0
                                              | Db0 -> Z0
                                              | Dd0 -> Z0
                                              | Dec -> Z0
                                              | Dq -> Z0
                                              | Dw -> Z0
                                              | Imul -> Z0
                                              | Inc -> Z0
                                              | Je -> Z0
                                              | Jmp -> Z0
                                              | Lea -> Z0
                                              | Mov -> Z0
                                              | Movzx -> Z0
                                              | Mul -> Z0
                                              | Mulx -> Z0
                                              | Or -> Z0
                                              | Pop ->
                                                (match args1 with
                                                 | [] -> Z0
                                                 | _ :: l2 ->
                                                   (match l2 with
                                                    | [] ->
                                                      Coq_Z.div
                                                        (Coq_Z.opp
                                                          (Coq_Z.of_N s0))
                                                        (Zpos (XO (XO (XO
                                                        XH))))
                                                    | _ :: _ -> Z0))
                                              | Push ->
                                                (match args1 with
                                                 | [] -> Z0
                                                 | _ :: l2 ->
                                                   (match l2 with
                                                    | [] ->
                                                      Coq_Z.div
                                                        (Coq_Z.of_N s0) (Zpos
                                                        (XO (XO (XO XH))))
                                                    | _ :: _ -> Z0))
                                              | Rcr -> Z0
                                              | Ret -> Z0
                                              | Sar -> Z0
                                              | Sbb -> Z0
                                              | Setc -> Z0
                                              | Seto -> Z0
                                              | Shl -> Z0
                                              | Shlx -> Z0
                                              | Shr -> Z0
                                              | Shrx -> Z0
                                              | Shrd -> Z0
                                              | Sub -> Z0
                                              | Test -> Z0
                                              | Xchg -> Z0
                                              | Xor -> Z0)
                                           | None -> Z0))
                                     | None ->
                                       (match operation_size instr with
                                        | Some s0 ->
                                          let op2 = instr.op in
                                          let args1 = instr.args in
                                          (match op2 with
                                           | Adc -> Z0
                                           | Adcx -> Z0
                                           | Add -> Z0
                                           | Adox -> Z0
                                           | And -> Z0
                                           | Bzhi -> Z0
                                           | Call -> Z0
                                           | Clc -> Z0
                                           | Cmovb -> Z0
                                           | Cmovc -> Z0
                                           | Cmovnz -> Z0
                                           | Cmovo -> Z0
                                           | Cmp -> Z0
                                           | Db0 -> Z0
                                           | Dd0 -> Z0
                                           | Dec -> Z0
                                           | Dq -> Z0
                                           | Dw -> Z0
                                           | Imul -> Z0
                                           | Inc -> Z0
                                           | Je -> Z0
                                           | Jmp -> Z0
                                           | Lea -> Z0
                                           | Mov -> Z0
                                           | Movzx -> Z0
                                           | Mul -> Z0
                                           | Mulx -> Z0
                                           | Or -> Z0
                                           | Pop ->
                                             (match args1 with
                                              | [] -> Z0
                                              | _ :: l2 ->
                                                (match l2 with
                                                 | [] ->
                                                   Coq_Z.div
                                                     (Coq_Z.opp
                                                       (Coq_Z.of_N s0)) (Zpos
                                                     (XO (XO (XO XH))))
                                                 | _ :: _ -> Z0))
                                           | Push ->
                                             (match args1 with
                                              | [] -> Z0
                                              | _ :: l2 ->
                                                (match l2 with
                                                 | [] ->
                                                   Coq_Z.div (Coq_Z.of_N s0)
                                                     (Zpos (XO (XO (XO XH))))
                                                 | _ :: _ -> Z0))
                                           | Rcr -> Z0
                                           | Ret -> Z0
                                           | Sar -> Z0
                                           | Sbb -> Z0
                                           | Setc -> Z0
                                           | Seto -> Z0
                                           | Shl -> Z0
                                           | Shlx -> Z0
                                           | Shr -> Z0
                                           | Shrx -> Z0
                                           | Shrd -> Z0
                                           | Sub -> Z0
                                           | Test -> Z0
                                           | Xchg -> Z0
                                           | Xor -> Z0)
                                        | None -> Z0)))
                               | Rbp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rsi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rdi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Eax ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ecx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Edx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ebx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Esp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ebp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Esi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Edi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ax ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Cx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Sp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Si ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Di ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ah ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Al ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ch ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Cl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dh ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bh ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Spl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bpl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Sil ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dil ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0))
                            | None ->
                              (match operation_size instr with
                               | Some s0 ->
                                 let op2 = instr.op in
                                 let args1 = instr.args in
                                 (match op2 with
                                  | Adc -> Z0
                                  | Adcx -> Z0
                                  | Add -> Z0
                                  | Adox -> Z0
                                  | And -> Z0
                                  | Bzhi -> Z0
                                  | Call -> Z0
                                  | Clc -> Z0
                                  | Cmovb -> Z0
                                  | Cmovc -> Z0
                                  | Cmovnz -> Z0
                                  | Cmovo -> Z0
                                  | Cmp -> Z0
                                  | Db0 -> Z0
                                  | Dd0 -> Z0
                                  | Dec -> Z0
                                  | Dq -> Z0
                                  | Dw -> Z0
                                  | Imul -> Z0
                                  | Inc -> Z0
                                  | Je -> Z0
                                  | Jmp -> Z0
                                  | Lea -> Z0
                                  | Mov -> Z0
                                  | Movzx -> Z0
                                  | Mul -> Z0
                                  | Mulx -> Z0
                                  | Or -> Z0
                                  | Pop ->
                                    (match args1 with
                                     | [] -> Z0
                                     | _ :: l2 ->
                                       (match l2 with
                                        | [] ->
                                          Coq_Z.div
                                            (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos
                                            (XO (XO (XO XH))))
                                        | _ :: _ -> Z0))
                                  | Push ->
                                    (match args1 with
                                     | [] -> Z0
                                     | _ :: l2 ->
                                       (match l2 with
                                        | [] ->
                                          Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO
                                            (XO (XO XH))))
                                        | _ :: _ -> Z0))
                                  | Rcr -> Z0
                                  | Ret -> Z0
                                  | Sar -> Z0
                                  | Sbb -> Z0
                                  | Setc -> Z0
                                  | Seto -> Z0
                                  | Shl -> Z0
                                  | Shlx -> Z0
                                  | Shr -> Z0
                                  | Shrx -> Z0
                                  | Shrd -> Z0
                                  | Sub -> Z0
                                  | Test -> Z0
                                  | Xchg -> Z0
                                  | Xor -> Z0)
                               | None -> Z0))
                         | None ->
                           (match mem_base_reg0 with
                            | Some r1 ->
                              (match r1 with
                               | Rax ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rcx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rdx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rbx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rsp ->
                                 (match mem_scale_reg0 with
                                  | Some _ ->
                                    (match operation_size instr with
                                     | Some s0 ->
                                       let op2 = instr.op in
                                       let args1 = instr.args in
                                       (match op2 with
                                        | Adc -> Z0
                                        | Adcx -> Z0
                                        | Add -> Z0
                                        | Adox -> Z0
                                        | And -> Z0
                                        | Bzhi -> Z0
                                        | Call -> Z0
                                        | Clc -> Z0
                                        | Cmovb -> Z0
                                        | Cmovc -> Z0
                                        | Cmovnz -> Z0
                                        | Cmovo -> Z0
                                        | Cmp -> Z0
                                        | Db0 -> Z0
                                        | Dd0 -> Z0
                                        | Dec -> Z0
                                        | Dq -> Z0
                                        | Dw -> Z0
                                        | Imul -> Z0
                                        | Inc -> Z0
                                        | Je -> Z0
                                        | Jmp -> Z0
                                        | Lea -> Z0
                                        | Mov -> Z0
                                        | Movzx -> Z0
                                        | Mul -> Z0
                                        | Mulx -> Z0
                                        | Or -> Z0
                                        | Pop ->
                                          (match args1 with
                                           | [] -> Z0
                                           | _ :: l2 ->
                                             (match l2 with
                                              | [] ->
                                                Coq_Z.div
                                                  (Coq_Z.opp (Coq_Z.of_N s0))
                                                  (Zpos (XO (XO (XO XH))))
                                              | _ :: _ -> Z0))
                                        | Push ->
                                          (match args1 with
                                           | [] -> Z0
                                           | _ :: l2 ->
                                             (match l2 with
                                              | [] ->
                                                Coq_Z.div (Coq_Z.of_N s0)
                                                  (Zpos (XO (XO (XO XH))))
                                              | _ :: _ -> Z0))
                                        | Rcr -> Z0
                                        | Ret -> Z0
                                        | Sar -> Z0
                                        | Sbb -> Z0
                                        | Setc -> Z0
                                        | Seto -> Z0
                                        | Shl -> Z0
                                        | Shlx -> Z0
                                        | Shr -> Z0
                                        | Shrx -> Z0
                                        | Shrd -> Z0
                                        | Sub -> Z0
                                        | Test -> Z0
                                        | Xchg -> Z0
                                        | Xor -> Z0)
                                     | None -> Z0)
                                  | None ->
                                    (match mem_offset0 with
                                     | Some n3 ->
                                       (match l1 with
                                        | [] -> Coq_Z.opp n3
                                        | _ :: _ ->
                                          (match operation_size instr with
                                           | Some s0 ->
                                             let op2 = instr.op in
                                             let args1 = instr.args in
                                             (match op2 with
                                              | Adc -> Z0
                                              | Adcx -> Z0
                                              | Add -> Z0
                                              | Adox -> Z0
                                              | And -> Z0
                                              | Bzhi -> Z0
                                              | Call -> Z0
                                              | Clc -> Z0
                                              | Cmovb -> Z0
                                              | Cmovc -> Z0
                                              | Cmovnz -> Z0
                                              | Cmovo -> Z0
                                              | Cmp -> Z0
                                              | Db0 -> Z0
                                              | Dd0 -> Z0
                                              | Dec -> Z0
                                              | Dq -> Z0
                                              | Dw -> Z0
                                              | Imul -> Z0
                                              | Inc -> Z0
                                              | Je -> Z0
                                              | Jmp -> Z0
                                              | Lea -> Z0
                                              | Mov -> Z0
                                              | Movzx -> Z0
                                              | Mul -> Z0
                                              | Mulx -> Z0
                                              | Or -> Z0
                                              | Pop ->
                                                (match args1 with
                                                 | [] -> Z0
                                                 | _ :: l2 ->
                                                   (match l2 with
                                                    | [] ->
                                                      Coq_Z.div
                                                        (Coq_Z.opp
                                                          (Coq_Z.of_N s0))
                                                        (Zpos (XO (XO (XO
                                                        XH))))
                                                    | _ :: _ -> Z0))
                                              | Push ->
                                                (match args1 with
                                                 | [] -> Z0
                                                 | _ :: l2 ->
                                                   (match l2 with
                                                    | [] ->
                                                      Coq_Z.div
                                                        (Coq_Z.of_N s0) (Zpos
                                                        (XO (XO (XO XH))))
                                                    | _ :: _ -> Z0))
                                              | Rcr -> Z0
                                              | Ret -> Z0
                                              | Sar -> Z0
                                              | Sbb -> Z0
                                              | Setc -> Z0
                                              | Seto -> Z0
                                              | Shl -> Z0
                                              | Shlx -> Z0
                                              | Shr -> Z0
                                              | Shrx -> Z0
                                              | Shrd -> Z0
                                              | Sub -> Z0
                                              | Test -> Z0
                                              | Xchg -> Z0
                                              | Xor -> Z0)
                                           | None -> Z0))
                                     | None ->
                                       (match operation_size instr with
                                        | Some s0 ->
                                          let op2 = instr.op in
                                          let args1 = instr.args in
                                          (match op2 with
                                           | Adc -> Z0
                                           | Adcx -> Z0
                                           | Add -> Z0
                                           | Adox -> Z0
                                           | And -> Z0
                                           | Bzhi -> Z0
                                           | Call -> Z0
                                           | Clc -> Z0
                                           | Cmovb -> Z0
                                           | Cmovc -> Z0
                                           | Cmovnz -> Z0
                                           | Cmovo -> Z0
                                           | Cmp -> Z0
                                           | Db0 -> Z0
                                           | Dd0 -> Z0
                                           | Dec -> Z0
                                           | Dq -> Z0
                                           | Dw -> Z0
                                           | Imul -> Z0
                                           | Inc -> Z0
                                           | Je -> Z0
                                           | Jmp -> Z0
                                           | Lea -> Z0
                                           | Mov -> Z0
                                           | Movzx -> Z0
                                           | Mul -> Z0
                                           | Mulx -> Z0
                                           | Or -> Z0
                                           | Pop ->
                                             (match args1 with
                                              | [] -> Z0
                                              | _ :: l2 ->
                                                (match l2 with
                                                 | [] ->
                                                   Coq_Z.div
                                                     (Coq_Z.opp
                                                       (Coq_Z.of_N s0)) (Zpos
                                                     (XO (XO (XO XH))))
                                                 | _ :: _ -> Z0))
                                           | Push ->
                                             (match args1 with
                                              | [] -> Z0
                                              | _ :: l2 ->
                                                (match l2 with
                                                 | [] ->
                                                   Coq_Z.div (Coq_Z.of_N s0)
                                                     (Zpos (XO (XO (XO XH))))
                                                 | _ :: _ -> Z0))
                                           | Rcr -> Z0
                                           | Ret -> Z0
                                           | Sar -> Z0
                                           | Sbb -> Z0
                                           | Setc -> Z0
                                           | Seto -> Z0
                                           | Shl -> Z0
                                           | Shlx -> Z0
                                           | Shr -> Z0
                                           | Shrx -> Z0
                                           | Shrd -> Z0
                                           | Sub -> Z0
                                           | Test -> Z0
                                           | Xchg -> Z0
                                           | Xor -> Z0)
                                        | None -> Z0)))
                               | Rbp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rsi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Rdi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15 ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Eax ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ecx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Edx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ebx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Esp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ebp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Esi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Edi ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15d ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ax ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Cx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bx ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Sp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bp ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Si ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Di ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15w ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ah ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Al ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Ch ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Cl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dh ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bh ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Spl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Bpl ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Sil ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | Dil ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R8b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R9b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R10b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R11b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R12b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R13b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R14b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0)
                               | R15b ->
                                 (match operation_size instr with
                                  | Some s0 ->
                                    let op2 = instr.op in
                                    let args1 = instr.args in
                                    (match op2 with
                                     | Adc -> Z0
                                     | Adcx -> Z0
                                     | Add -> Z0
                                     | Adox -> Z0
                                     | And -> Z0
                                     | Bzhi -> Z0
                                     | Call -> Z0
                                     | Clc -> Z0
                                     | Cmovb -> Z0
                                     | Cmovc -> Z0
                                     | Cmovnz -> Z0
                                     | Cmovo -> Z0
                                     | Cmp -> Z0
                                     | Db0 -> Z0
                                     | Dd0 -> Z0
                                     | Dec -> Z0
                                     | Dq -> Z0
                                     | Dw -> Z0
                                     | Imul -> Z0
                                     | Inc -> Z0
                                     | Je -> Z0
                                     | Jmp -> Z0
                                     | Lea -> Z0
                                     | Mov -> Z0
                                     | Movzx -> Z0
                                     | Mul -> Z0
                                     | Mulx -> Z0
                                     | Or -> Z0
                                     | Pop ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div
                                               (Coq_Z.opp (Coq_Z.of_N s0))
                                               (Zpos (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Push ->
                                       (match args1 with
                                        | [] -> Z0
                                        | _ :: l2 ->
                                          (match l2 with
                                           | [] ->
                                             Coq_Z.div (Coq_Z.of_N s0) (Zpos
                                               (XO (XO (XO XH))))
                                           | _ :: _ -> Z0))
                                     | Rcr -> Z0
                                     | Ret -> Z0
                                     | Sar -> Z0
                                     | Sbb -> Z0
                                     | Setc -> Z0
                                     | Seto -> Z0
                                     | Shl -> Z0
                                     | Shlx -> Z0
                                     | Shr -> Z0
                                     | Shrx -> Z0
                                     | Shrd -> Z0
                                     | Sub -> Z0
                                     | Test -> Z0
                                     | Xchg -> Z0
                                     | Xor -> Z0)
                                  | None -> Z0))
                            | None ->
                              (match operation_size instr with
                               | Some s0 ->
                                 let op2 = instr.op in
                                 let args1 = instr.args in
                                 (match op2 with
                                  | Adc -> Z0
                                  | Adcx -> Z0
                                  | Add -> Z0
                                  | Adox -> Z0
                                  | And -> Z0
                                  | Bzhi -> Z0
                                  | Call -> Z0
                                  | Clc -> Z0
                                  | Cmovb -> Z0
                                  | Cmovc -> Z0
                                  | Cmovnz -> Z0
                                  | Cmovo -> Z0
                                  | Cmp -> Z0
                                  | Db0 -> Z0
                                  | Dd0 -> Z0
                                  | Dec -> Z0
                                  | Dq -> Z0
                                  | Dw -> Z0
                                  | Imul -> Z0
                                  | Inc -> Z0
                                  | Je -> Z0
                                  | Jmp -> Z0
                                  | Lea -> Z0
                                  | Mov -> Z0
                                  | Movzx -> Z0
                                  | Mul -> Z0
                                  | Mulx -> Z0
                                  | Or -> Z0
                                  | Pop ->
                                    (match args1 with
                                     | [] -> Z0
                                     | _ :: l2 ->
                                       (match l2 with
                                        | [] ->
                                          Coq_Z.div
                                            (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos
                                            (XO (XO (XO XH))))
                                        | _ :: _ -> Z0))
                                  | Push ->
                                    (match args1 with
                                     | [] -> Z0
                                     | _ :: l2 ->
                                       (match l2 with
                                        | [] ->
                                          Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO
                                            (XO (XO XH))))
                                        | _ :: _ -> Z0))
                                  | Rcr -> Z0
                                  | Ret -> Z0
                                  | Sar -> Z0
                                  | Sbb -> Z0
                                  | Setc -> Z0
                                  | Seto -> Z0
                                  | Shl -> Z0
                                  | Shlx -> Z0
                                  | Shr -> Z0
                                  | Shrx -> Z0
                                  | Shrd -> Z0
                                  | Sub -> Z0
                                  | Test -> Z0
                                  | Xchg -> Z0
                                  | Xor -> Z0)
                               | None -> Z0)))
                      | Const _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)
                      | Label _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)))
                | Rbp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rsi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rdi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Eax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ecx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Edx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ebx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Esp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ebp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Esi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Edi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Cx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Sp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Si ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Di ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ah ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Al ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ch ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Cl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dh ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bh ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Spl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bpl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Sil ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dil ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0))
             | Mem _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)
             | Const _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)
             | Label _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)))
       | Mov ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Movzx ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Mul ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Mulx ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Or ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Pop ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Push ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Rcr ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Ret ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Sar ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Sbb ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Setc ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Seto ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Shl ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Shlx ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Shr ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Shrx ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Shrd ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Sub ->
         (match args0 with
          | [] ->
            (match operation_size instr with
             | Some s0 ->
               let op2 = instr.op in
               let args1 = instr.args in
               (match op2 with
                | Adc -> Z0
                | Adcx -> Z0
                | Add -> Z0
                | Adox -> Z0
                | And -> Z0
                | Bzhi -> Z0
                | Call -> Z0
                | Clc -> Z0
                | Cmovb -> Z0
                | Cmovc -> Z0
                | Cmovnz -> Z0
                | Cmovo -> Z0
                | Cmp -> Z0
                | Db0 -> Z0
                | Dd0 -> Z0
                | Dec -> Z0
                | Dq -> Z0
                | Dw -> Z0
                | Imul -> Z0
                | Inc -> Z0
                | Je -> Z0
                | Jmp -> Z0
                | Lea -> Z0
                | Mov -> Z0
                | Movzx -> Z0
                | Mul -> Z0
                | Mulx -> Z0
                | Or -> Z0
                | Pop ->
                  (match args1 with
                   | [] -> Z0
                   | _ :: l0 ->
                     (match l0 with
                      | [] ->
                        Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO
                          (XO XH))))
                      | _ :: _ -> Z0))
                | Push ->
                  (match args1 with
                   | [] -> Z0
                   | _ :: l0 ->
                     (match l0 with
                      | [] ->
                        Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                      | _ :: _ -> Z0))
                | Rcr -> Z0
                | Ret -> Z0
                | Sar -> Z0
                | Sbb -> Z0
                | Setc -> Z0
                | Seto -> Z0
                | Shl -> Z0
                | Shlx -> Z0
                | Shr -> Z0
                | Shrx -> Z0
                | Shrd -> Z0
                | Sub -> Z0
                | Test -> Z0
                | Xchg -> Z0
                | Xor -> Z0)
             | None -> Z0)
          | a :: l0 ->
            (match a with
             | Reg r0 ->
               (match r0 with
                | Rax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rcx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rdx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rbx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rsp ->
                  (match l0 with
                   | [] ->
                     (match operation_size instr with
                      | Some s0 ->
                        let op2 = instr.op in
                        let args1 = instr.args in
                        (match op2 with
                         | Adc -> Z0
                         | Adcx -> Z0
                         | Add -> Z0
                         | Adox -> Z0
                         | And -> Z0
                         | Bzhi -> Z0
                         | Call -> Z0
                         | Clc -> Z0
                         | Cmovb -> Z0
                         | Cmovc -> Z0
                         | Cmovnz -> Z0
                         | Cmovo -> Z0
                         | Cmp -> Z0
                         | Db0 -> Z0
                         | Dd0 -> Z0
                         | Dec -> Z0
                         | Dq -> Z0
                         | Dw -> Z0
                         | Imul -> Z0
                         | Inc -> Z0
                         | Je -> Z0
                         | Jmp -> Z0
                         | Lea -> Z0
                         | Mov -> Z0
                         | Movzx -> Z0
                         | Mul -> Z0
                         | Mulx -> Z0
                         | Or -> Z0
                         | Pop ->
                           (match args1 with
                            | [] -> Z0
                            | _ :: l1 ->
                              (match l1 with
                               | [] ->
                                 Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos
                                   (XO (XO (XO XH))))
                               | _ :: _ -> Z0))
                         | Push ->
                           (match args1 with
                            | [] -> Z0
                            | _ :: l1 ->
                              (match l1 with
                               | [] ->
                                 Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                   XH))))
                               | _ :: _ -> Z0))
                         | Rcr -> Z0
                         | Ret -> Z0
                         | Sar -> Z0
                         | Sbb -> Z0
                         | Setc -> Z0
                         | Seto -> Z0
                         | Shl -> Z0
                         | Shlx -> Z0
                         | Shr -> Z0
                         | Shrx -> Z0
                         | Shrd -> Z0
                         | Sub -> Z0
                         | Test -> Z0
                         | Xchg -> Z0
                         | Xor -> Z0)
                      | None -> Z0)
                   | a0 :: l1 ->
                     (match a0 with
                      | Reg _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)
                      | Mem _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)
                      | Const n3 ->
                        (match l1 with
                         | [] -> n3
                         | _ :: _ ->
                           (match operation_size instr with
                            | Some s0 ->
                              let op2 = instr.op in
                              let args1 = instr.args in
                              (match op2 with
                               | Adc -> Z0
                               | Adcx -> Z0
                               | Add -> Z0
                               | Adox -> Z0
                               | And -> Z0
                               | Bzhi -> Z0
                               | Call -> Z0
                               | Clc -> Z0
                               | Cmovb -> Z0
                               | Cmovc -> Z0
                               | Cmovnz -> Z0
                               | Cmovo -> Z0
                               | Cmp -> Z0
                               | Db0 -> Z0
                               | Dd0 -> Z0
                               | Dec -> Z0
                               | Dq -> Z0
                               | Dw -> Z0
                               | Imul -> Z0
                               | Inc -> Z0
                               | Je -> Z0
                               | Jmp -> Z0
                               | Lea -> Z0
                               | Mov -> Z0
                               | Movzx -> Z0
                               | Mul -> Z0
                               | Mulx -> Z0
                               | Or -> Z0
                               | Pop ->
                                 (match args1 with
                                  | [] -> Z0
                                  | _ :: l2 ->
                                    (match l2 with
                                     | [] ->
                                       Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                         (Zpos (XO (XO (XO XH))))
                                     | _ :: _ -> Z0))
                               | Push ->
                                 (match args1 with
                                  | [] -> Z0
                                  | _ :: l2 ->
                                    (match l2 with
                                     | [] ->
                                       Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO
                                         (XO (XO XH))))
                                     | _ :: _ -> Z0))
                               | Rcr -> Z0
                               | Ret -> Z0
                               | Sar -> Z0
                               | Sbb -> Z0
                               | Setc -> Z0
                               | Seto -> Z0
                               | Shl -> Z0
                               | Shlx -> Z0
                               | Shr -> Z0
                               | Shrx -> Z0
                               | Shrd -> Z0
                               | Sub -> Z0
                               | Test -> Z0
                               | Xchg -> Z0
                               | Xor -> Z0)
                            | None -> Z0))
                      | Label _ ->
                        (match operation_size instr with
                         | Some s0 ->
                           let op2 = instr.op in
                           let args1 = instr.args in
                           (match op2 with
                            | Adc -> Z0
                            | Adcx -> Z0
                            | Add -> Z0
                            | Adox -> Z0
                            | And -> Z0
                            | Bzhi -> Z0
                            | Call -> Z0
                            | Clc -> Z0
                            | Cmovb -> Z0
                            | Cmovc -> Z0
                            | Cmovnz -> Z0
                            | Cmovo -> Z0
                            | Cmp -> Z0
                            | Db0 -> Z0
                            | Dd0 -> Z0
                            | Dec -> Z0
                            | Dq -> Z0
                            | Dw -> Z0
                            | Imul -> Z0
                            | Inc -> Z0
                            | Je -> Z0
                            | Jmp -> Z0
                            | Lea -> Z0
                            | Mov -> Z0
                            | Movzx -> Z0
                            | Mul -> Z0
                            | Mulx -> Z0
                            | Or -> Z0
                            | Pop ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0))
                                      (Zpos (XO (XO (XO XH))))
                                  | _ :: _ -> Z0))
                            | Push ->
                              (match args1 with
                               | [] -> Z0
                               | _ :: l2 ->
                                 (match l2 with
                                  | [] ->
                                    Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO
                                      (XO XH))))
                                  | _ :: _ -> Z0))
                            | Rcr -> Z0
                            | Ret -> Z0
                            | Sar -> Z0
                            | Sbb -> Z0
                            | Setc -> Z0
                            | Seto -> Z0
                            | Shl -> Z0
                            | Shlx -> Z0
                            | Shr -> Z0
                            | Shrx -> Z0
                            | Shrd -> Z0
                            | Sub -> Z0
                            | Test -> Z0
                            | Xchg -> Z0
                            | Xor -> Z0)
                         | None -> Z0)))
                | Rbp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rsi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Rdi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15 ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Eax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ecx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Edx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ebx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Esp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ebp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Esi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Edi ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15d ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ax ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Cx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bx ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Sp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bp ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Si ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Di ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15w ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ah ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Al ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Ch ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Cl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dh ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bh ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Spl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Bpl ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Sil ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | Dil ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R8b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R9b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R10b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R11b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R12b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R13b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R14b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0)
                | R15b ->
                  (match operation_size instr with
                   | Some s0 ->
                     let op2 = instr.op in
                     let args1 = instr.args in
                     (match op2 with
                      | Adc -> Z0
                      | Adcx -> Z0
                      | Add -> Z0
                      | Adox -> Z0
                      | And -> Z0
                      | Bzhi -> Z0
                      | Call -> Z0
                      | Clc -> Z0
                      | Cmovb -> Z0
                      | Cmovc -> Z0
                      | Cmovnz -> Z0
                      | Cmovo -> Z0
                      | Cmp -> Z0
                      | Db0 -> Z0
                      | Dd0 -> Z0
                      | Dec -> Z0
                      | Dq -> Z0
                      | Dw -> Z0
                      | Imul -> Z0
                      | Inc -> Z0
                      | Je -> Z0
                      | Jmp -> Z0
                      | Lea -> Z0
                      | Mov -> Z0
                      | Movzx -> Z0
                      | Mul -> Z0
                      | Mulx -> Z0
                      | Or -> Z0
                      | Pop ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                                (XO (XO XH))))
                            | _ :: _ -> Z0))
                      | Push ->
                        (match args1 with
                         | [] -> Z0
                         | _ :: l1 ->
                           (match l1 with
                            | [] ->
                              Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO
                                XH))))
                            | _ :: _ -> Z0))
                      | Rcr -> Z0
                      | Ret -> Z0
                      | Sar -> Z0
                      | Sbb -> Z0
                      | Setc -> Z0
                      | Seto -> Z0
                      | Shl -> Z0
                      | Shlx -> Z0
                      | Shr -> Z0
                      | Shrx -> Z0
                      | Shrd -> Z0
                      | Sub -> Z0
                      | Test -> Z0
                      | Xchg -> Z0
                      | Xor -> Z0)
                   | None -> Z0))
             | Mem _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)
             | Const _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)
             | Label _ ->
               (match operation_size instr with
                | Some s0 ->
                  let op2 = instr.op in
                  let args1 = instr.args in
                  (match op2 with
                   | Adc -> Z0
                   | Adcx -> Z0
                   | Add -> Z0
                   | Adox -> Z0
                   | And -> Z0
                   | Bzhi -> Z0
                   | Call -> Z0
                   | Clc -> Z0
                   | Cmovb -> Z0
                   | Cmovc -> Z0
                   | Cmovnz -> Z0
                   | Cmovo -> Z0
                   | Cmp -> Z0
                   | Db0 -> Z0
                   | Dd0 -> Z0
                   | Dec -> Z0
                   | Dq -> Z0
                   | Dw -> Z0
                   | Imul -> Z0
                   | Inc -> Z0
                   | Je -> Z0
                   | Jmp -> Z0
                   | Lea -> Z0
                   | Mov -> Z0
                   | Movzx -> Z0
                   | Mul -> Z0
                   | Mulx -> Z0
                   | Or -> Z0
                   | Pop ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO
                             (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Push ->
                     (match args1 with
                      | [] -> Z0
                      | _ :: l1 ->
                        (match l1 with
                         | [] ->
                           Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                         | _ :: _ -> Z0))
                   | Rcr -> Z0
                   | Ret -> Z0
                   | Sar -> Z0
                   | Sbb -> Z0
                   | Setc -> Z0
                   | Seto -> Z0
                   | Shl -> Z0
                   | Shlx -> Z0
                   | Shr -> Z0
                   | Shrx -> Z0
                   | Shrd -> Z0
                   | Sub -> Z0
                   | Test -> Z0
                   | Xchg -> Z0
                   | Xor -> Z0)
                | None -> Z0)))
       | Test ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Xchg ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0)
       | Xor ->
         (match operation_size instr with
          | Some s0 ->
            let op2 = instr.op in
            let args1 = instr.args in
            (match op2 with
             | Adc -> Z0
             | Adcx -> Z0
             | Add -> Z0
             | Adox -> Z0
             | And -> Z0
             | Bzhi -> Z0
             | Call -> Z0
             | Clc -> Z0
             | Cmovb -> Z0
             | Cmovc -> Z0
             | Cmovnz -> Z0
             | Cmovo -> Z0
             | Cmp -> Z0
             | Db0 -> Z0
             | Dd0 -> Z0
             | Dec -> Z0
             | Dq -> Z0
             | Dw -> Z0
             | Imul -> Z0
             | Inc -> Z0
             | Je -> Z0
             | Jmp -> Z0
             | Lea -> Z0
             | Mov -> Z0
             | Movzx -> Z0
             | Mul -> Z0
             | Mulx -> Z0
             | Or -> Z0
             | Pop ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] ->
                     Coq_Z.div (Coq_Z.opp (Coq_Z.of_N s0)) (Zpos (XO (XO (XO
                       XH))))
                   | _ :: _ -> Z0))
             | Push ->
               (match args1 with
                | [] -> Z0
                | _ :: l0 ->
                  (match l0 with
                   | [] -> Coq_Z.div (Coq_Z.of_N s0) (Zpos (XO (XO (XO XH))))
                   | _ :: _ -> Z0))
             | Rcr -> Z0
             | Ret -> Z0
             | Sar -> Z0
             | Sbb -> Z0
             | Setc -> Z0
             | Seto -> Z0
             | Shl -> Z0
             | Shlx -> Z0
             | Shr -> Z0
             | Shrx -> Z0
             | Shrd -> Z0
             | Sub -> Z0
             | Test -> Z0
             | Xchg -> Z0
             | Xor -> Z0)
          | None -> Z0))
  in
  let new_stack_size = Coq_Z.add cur_stack_size cng in
  new_stack_size :: (assembly_stack_size_at new_stack_size asm0)

(** val microsoft_x64_assembly_stack_red_zone : n **)

let microsoft_x64_assembly_stack_red_zone =
  N0

(** val system_v_amd64_assembly_stack_red_zone : n **)

let system_v_amd64_assembly_stack_red_zone =
  Npos (XO (XO (XO (XO (XO (XO (XO XH)))))))

(** val assembly_stack_red_zone : assembly_callee_saved_registers_opt -> n **)

let assembly_stack_red_zone = function
| Microsoft_x64 -> microsoft_x64_assembly_stack_red_zone
| System_V_AMD64 -> system_v_amd64_assembly_stack_red_zone
| Explicit_registers _ -> N0

(** val assembly_stack_size :
    assembly_callee_saved_registers_opt -> assembly_stack_size_opt -> line
    list -> n **)

let assembly_stack_size calling_convention v asm =
  match v with
  | Some v0 -> v0
  | None ->
    let red_zone = Coq_Z.of_N (assembly_stack_red_zone calling_convention) in
    Coq_Z.to_N
      (fold_right Coq_Z.max red_zone (assembly_stack_size_at red_zone asm))

type assembly_conventions_opt = { assembly_calling_registers_ : assembly_calling_registers_opt;
                                  assembly_stack_size_ : assembly_stack_size_opt;
                                  assembly_output_first_ : assembly_output_first_opt;
                                  assembly_argument_registers_left_to_right_ : 
                                  assembly_argument_registers_left_to_right_opt;
                                  assembly_callee_saved_registers_ : 
                                  assembly_callee_saved_registers_opt }

module Coq_Options =
 struct
  type equivalence_checker_options_opt = { assembly_conventions_ : assembly_conventions_opt;
                                           symbolic_options_ : Options.symbolic_options_opt }

  (** val assembly_conventions_ :
      equivalence_checker_options_opt -> assembly_conventions_opt **)

  let assembly_conventions_ equivalence_checker_options_opt0 =
    equivalence_checker_options_opt0.assembly_conventions_

  (** val symbolic_options_ :
      equivalence_checker_options_opt -> Options.symbolic_options_opt **)

  let symbolic_options_ equivalence_checker_options_opt0 =
    equivalence_checker_options_opt0.symbolic_options_
 end

(** val show_assembly_callee_saved_registers_opt :
    assembly_callee_saved_registers_opt show **)

let show_assembly_callee_saved_registers_opt = function
| Microsoft_x64 ->
  'M'::('i'::('c'::('r'::('o'::('s'::('o'::('f'::('t'::(' '::('x'::('6'::('4'::[]))))))))))))
| System_V_AMD64 ->
  'S'::('y'::('s'::('t'::('e'::('m'::(' '::('V'::(' '::('A'::('M'::('D'::('6'::('4'::[])))))))))))))
| Explicit_registers ls ->
  show0 (show_of_ShowLevel (show_lvl_list show_lvl_REG)) ls

(** val parse_assembly_callee_saved_registers_opt :
    assembly_callee_saved_registers_opt parserAction **)

let parse_assembly_callee_saved_registers_opt =
  parse_alt_gen (fun v ->
    match v with
    | Inl v0 -> v0
    | Inr ls -> Explicit_registers ls)
    (parse_strs
      (((show0 show_assembly_callee_saved_registers_opt Microsoft_x64),
      Microsoft_x64) :: ((('M'::('i'::('c'::('r'::('o'::('s'::('o'::('f'::('t'::(' '::('x'::('6'::('4'::[]))))))))))))),
      Microsoft_x64) :: ((('M'::('i'::('c'::('r'::('o'::('s'::('o'::('f'::('t'::('_'::('x'::('6'::('4'::[]))))))))))))),
      Microsoft_x64) :: ((('M'::('i'::('c'::('r'::('o'::('s'::('o'::('f'::('t'::('-'::('x'::('6'::('4'::[]))))))))))))),
      Microsoft_x64) :: ((('m'::('i'::('c'::('r'::('o'::('s'::('o'::('f'::('t'::[]))))))))),
      Microsoft_x64) :: ((('M'::('i'::('c'::('r'::('o'::('s'::('o'::('f'::('t'::[]))))))))),
      Microsoft_x64) :: (((show0 show_assembly_callee_saved_registers_opt
                            System_V_AMD64),
      System_V_AMD64) :: ((('S'::('y'::('s'::('t'::('e'::('m'::(' '::('V'::[])))))))),
      System_V_AMD64) :: ((('S'::('y'::('s'::('t'::('e'::('m'::('_'::('V'::('_'::('A'::('M'::('D'::('6'::('4'::[])))))))))))))),
      System_V_AMD64) :: ((('s'::('y'::('s'::('t'::('e'::('m'::('-'::('v'::[])))))))),
      System_V_AMD64) :: ((('S'::('y'::('s'::('t'::('e'::('m'::('-'::('V'::('-'::('A'::('M'::('D'::('6'::('4'::[])))))))))))))),
      System_V_AMD64) :: ((('A'::('M'::('D'::('6'::('4'::[]))))),
      System_V_AMD64) :: ((('a'::('m'::('d'::('6'::('4'::[]))))),
      System_V_AMD64) :: ((('s'::('y'::('s'::('t'::('e'::('m'::(' '::('v'::[])))))))),
      System_V_AMD64) :: []))))))))))))))) (parse_comma_list parse_REG)

type equivalenceCheckingError =
| Symbolic_execution_failed of Coq_error.error * symbolic_state
| Internal_error_output_load_failed of Coq_error.error option
   * ((rEG, idx) sum, idx) sum list * symbolic_state
| Internal_error_extra_input_arguments of Coq3_Compilers.base
                                          Compilers.Coq_base.Coq_type.coq_type
                                          Compilers.Coq_type.coq_type
   * (idx, idx list) sum list
| Internal_error_lingering_memory of symbolic_state
| Internal_error_LoadOutputs_length_mismatch of ((rEG, idx) sum, idx) sum list
   * nat option list
| Not_enough_registers of nat * nat
| Registers_too_narrow of rEG list
| Callee_saved_registers_too_narrow of rEG list
| Duplicate_registers of rEG list
| Incorrect_array_input_dag_node
| Incorrect_Z_input_dag_node
| Not_enough_input_dag_nodes of Coq3_Compilers.base
                                Compilers.Coq_base.Coq_type.coq_type
                                Compilers.Coq_type.coq_type
| Expected_const_in_reference_code of idx
| Expected_power_of_two of n * idx
| Unknown_array_length of Coq3_Compilers.base
                          Compilers.Coq_base.Coq_type.coq_type
| Registers_not_saved of (rEG * (idx * idx)) list * symbolic_state
| Invalid_arrow_type of Coq3_Compilers.base
                        Compilers.Coq_base.Coq_type.coq_type
                        Compilers.Coq_type.coq_type
| Invalid_argument_type of Coq3_Compilers.base
                           Compilers.Coq_base.Coq_type.coq_type
                           Compilers.Coq_type.coq_type
| Invalid_return_type of Coq3_Compilers.base
                         Compilers.Coq_base.Coq_type.coq_type
| Invalid_higher_order_application of Coq3_Compilers.base
                                      Compilers.Coq_base.Coq_type.coq_type
                                      Compilers.Coq_type.coq_type
   * Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
     Compilers.Coq_type.coq_type
   * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
     Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
   * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
     Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
| Invalid_higher_order_let of Coq3_Compilers.base
                              Compilers.Coq_base.Coq_type.coq_type
                              Compilers.Coq_type.coq_type
   * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
     Coq3_Compilers.ident, __) Compilers.Coq_expr.expr
| Unhandled_identifier of Coq3_Compilers.base
                          Compilers.Coq_base.Coq_type.coq_type
                          Compilers.Coq_type.coq_type * Coq3_Compilers.ident
| Unhandled_cast of z * z
| Unable_to_unify of (idx, idx list) sum list * (idx, idx list) sum list
   * idx option * symbolic_state
| Missing_ret
| Code_after_ret of lines * lines

(** val symbolic_state_of_EquivalenceCheckingError :
    equivalenceCheckingError -> symbolic_state option **)

let symbolic_state_of_EquivalenceCheckingError = function
| Symbolic_execution_failed (_, s0) -> Some s0
| Internal_error_output_load_failed (_, _, s0) -> Some s0
| Internal_error_extra_input_arguments (_, _) -> None
| Internal_error_lingering_memory s0 -> Some s0
| Internal_error_LoadOutputs_length_mismatch (_, _) -> None
| Not_enough_registers (_, _) -> None
| Registers_too_narrow _ -> None
| Callee_saved_registers_too_narrow _ -> None
| Duplicate_registers _ -> None
| Incorrect_array_input_dag_node -> None
| Incorrect_Z_input_dag_node -> None
| Not_enough_input_dag_nodes _ -> None
| Expected_const_in_reference_code _ -> None
| Expected_power_of_two (_, _) -> None
| Unknown_array_length _ -> None
| Registers_not_saved (_, s0) -> Some s0
| Invalid_arrow_type _ -> None
| Invalid_argument_type _ -> None
| Invalid_return_type _ -> None
| Invalid_higher_order_application (_, _, _, _) -> None
| Invalid_higher_order_let (_, _) -> None
| Unhandled_identifier (_, _) -> None
| Unhandled_cast (_, _) -> None
| Unable_to_unify (_, _, _, s0) -> Some s0
| Missing_ret -> None
| Code_after_ret (_, _) -> None

type annotatedLine = line * Old.Coq_dag.Coq_eager.t

type annotatedLines = lines * symbolic_state

(** val show_annotated_Line : annotatedLine show **)

let show_annotated_Line = function
| (l, d) ->
  let l_n = show_Line_with_line_number l in
  let l0 = show0 show_Line l in
  append l0
    (match Old.Coq_dag.Coq_eager.description_lookup d l_n with
     | [] -> []
     | i :: l1 ->
       append (tab::[])
         (append (';'::(' '::[]))
           (concat0 (','::(' '::[]))
             (map (fun i0 -> append ('#'::[]) (show0 Decimal.show_N i0))
               (i :: l1)))))

(** val show_lines_AnnotatedLines : annotatedLines showLines **)

let show_lines_AnnotatedLines = function
| (ls, ss) ->
  let d = Old.Coq_dag.Coq_eager.force ss.dag_state in
  map (fun l -> show_annotated_Line (l, d)) ls

(** val remove_common_indices :
    ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> nat -> (nat * 'a1)
    list * 'a1 list **)

let rec remove_common_indices eqb2 xs ys start_idx =
  match xs with
  | [] ->
    ((map (fun pat -> let (idx0, x) = pat in ((add start_idx idx0), x))
       (List.enumerate xs)), ys)
  | x :: xs0 ->
    let (xs', ys') =
      remove_common_indices eqb2 xs0 (Coq4_List.removen (eqb2 x) ys (S O)) (S
        start_idx)
    in
    if existsb (eqb2 x) ys then (xs', ys') else (((start_idx, x) :: xs'), ys')

(** val show_expr_node_lite : expr0 show **)

let rec show_expr_node_lite = function
| ExprRef i -> append ('#'::[]) (show0 Decimal.show_N i)
| ExprApp n3 ->
  let (op1, e0) = n3 in
  append ('('::[])
    (append (show0 show_op op1)
      (append (','::(' '::[]))
        (append (show_list show_expr_node_lite e0) (')'::[]))))

(** val show_node_lite : idx node0 show **)

let show_node_lite = function
| (op1, e) ->
  show_expr_node_lite (ExprApp (op1, (map (fun x -> ExprRef x) e)))

(** val recursive_deps_list_step :
    (NSet.t -> idx -> NSet.t) -> NSet.t -> idx list -> NSet.t **)

let recursive_deps_list_step recursive_deps0 so_far ls =
  fold_left recursive_deps0 ls so_far

(** val recursive_deps_step :
    (NSet.t -> idx -> NSet.t) -> Old.Coq_dag.t -> NSet.t -> idx -> NSet.t **)

let recursive_deps_step recursive_deps0 dag so_far i =
  if NSet.mem i so_far
  then so_far
  else let so_far0 = NSet.add i so_far in
       (match Old.Coq_dag.lookup dag i with
        | Some n3 ->
          let (_, args0) = n3 in
          recursive_deps_list_step recursive_deps0 so_far0 args0
        | None -> so_far0)

(** val recursive_deps : nat -> Old.Coq_dag.t -> NSet.t -> idx -> NSet.t **)

let rec recursive_deps fuel0 dag init i =
  match fuel0 with
  | O -> NSet.singleton i
  | S fuel1 -> recursive_deps_step (recursive_deps fuel1 dag) dag init i

(** val recursive_deps_list :
    nat -> Old.Coq_dag.t -> NSet.t -> idx list -> NSet.t **)

let recursive_deps_list fuel0 dag init ls =
  recursive_deps_list_step (recursive_deps fuel0 dag) init ls

(** val at_leaves_fold :
    (idx -> 'a1 -> expr0 * 'a1) -> expr0 -> 'a1 -> expr0 * 'a1 **)

let at_leaves_fold f =
  let rec at_leaves_fold0 = function
  | ExprRef i -> f i
  | ExprApp n3 ->
    let (op1, args0) = n3 in
    (fun st ->
    let (args1, st0) = Coq0_List.foldmap at_leaves_fold0 args0 st in
    ((ExprApp (op1, args1)), st0))
  in at_leaves_fold0

(** val at_leaves : (idx -> expr0) -> expr0 -> expr0 **)

let at_leaves f e =
  fst (at_leaves_fold (fun i pat -> let () = pat in ((f i), ())) e ())

(** val reveal_one_except :
    Old.Coq_dag.t -> (idx -> bool) -> expr0 -> expr0 * bool **)

let reveal_one_except dag except e =
  at_leaves_fold (fun i revealed ->
    if except i
    then ((ExprRef i), revealed)
    else (match Old.Coq_dag.lookup dag i with
          | Some n3 ->
            let (op1, args0) = n3 in
            ((ExprApp (op1, (map (fun x -> ExprRef x) args0))), true)
          | None -> ((ExprRef i), revealed))) e false

(** val indices_at_leaves_map : expr0 list -> idx list **)

let indices_at_leaves_map ls =
  Coq1_N.Sort.sort
    (NSet.elements
      (snd
        (Coq0_List.foldmap
          (at_leaves_fold (fun i idxs0 -> ((ExprRef i), (NSet.add i idxs0))))
          ls NSet.empty)))

(** val make_iteratively_revealed_exprs :
    Old.Coq_dag.t -> nat -> (idx -> bool) -> expr0 list -> expr0 list list **)

let rec make_iteratively_revealed_exprs dag max_depth except ls =
  match max_depth with
  | O -> []
  | S max_depth0 ->
    let res = map (reveal_one_except dag except) ls in
    let ls0 = map fst res in
    let progress = existsb (fun b -> b) (map snd res) in
    if progress
    then ls0 :: (make_iteratively_revealed_exprs dag max_depth0 except ls0)
    else []

(** val describe_idx_from_state :
    bool -> symbolic_state -> idx -> char list list **)

let describe_idx_from_state show_full st idx0 =
  let description_from_state =
    match reverse_lookup_widest_reg st.symbolic_reg_state idx0 with
    | Some r0 ->
      Some
        (append
          ('t'::('h'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::(' '::[]))))))))))))))))))))))))))
          (show0 show_REG r0))
    | None ->
      (match reverse_lookup_flag st.symbolic_flag_state idx0 with
       | Some f ->
         Some
           (append
             ('t'::('h'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('f'::('l'::('a'::('g'::(' '::[]))))))))))))))))))))))
             (show0 show_FLAG f))
       | None ->
         (match reverse_lookup_mem st.symbolic_mem_state idx0 with
          | Some p ->
            let (ptr, ptsto) = p in
            Some
            (append
              ('t'::('h'::('e'::(' '::('m'::('e'::('m'::('o'::('r'::('y'::(' '::('l'::('o'::('c'::('a'::('t'::('i'::('o'::('n'::(' '::('a'::('t'::(' '::('p'::('s'::('e'::('u'::('d'::('o'::('-'::('a'::('d'::('d'::('r'::('e'::('s'::('s'::(' '::[]))))))))))))))))))))))))))))))))))))))
              (append (Hex.show_N ptr)
                (append
                  (' '::('w'::('h'::('i'::('c'::('h'::(' '::('p'::('o'::('i'::('n'::('t'::('s'::(' '::('t'::('o'::(' '::('d'::('a'::('g'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[])))))))))))))))))))))))))))
                  (append (show0 Decimal.show_N ptsto)
                    (append
                      (' '::('w'::('h'::('i'::('c'::('h'::(' '::('h'::('o'::('l'::('d'::('s'::(' '::('t'::('h'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[])))))))))))))))))))))))
                      (show0 show_expr (reveal st.dag_state (S O) ptsto)))))))
          | None -> None))
  in
  let is_old =
    match reveal st.dag_state (S O) idx0 with
    | ExprRef _ -> false
    | ExprApp n3 ->
      let (o, _) = n3 in
      (match o with
       | Old (_, _) -> true
       | Const0 _ -> false
       | Add0 _ -> false
       | Addcarry _ -> false
       | Subborrow _ -> false
       | Addoverflow _ -> false
       | Neg1 _ -> false
       | Shl0 _ -> false
       | Shr0 _ -> false
       | Sar0 _ -> false
       | Rcr0 _ -> false
       | And0 _ -> false
       | Or0 _ -> false
       | Xor0 _ -> false
       | Slice (_, _) -> false
       | Mul0 _ -> false
       | Set_slice (_, _) -> false
       | Selectznz -> false
       | Iszero -> false
       | AddZ -> false
       | MulZ -> false
       | NegZ -> false
       | ShlZ -> false
       | ShrZ -> false
       | AndZ -> false
       | OrZ -> false
       | XorZ -> false
       | AddcarryZ _ -> false
       | SubborrowZ _ -> false)
  in
  if is_old
  then (match description_from_state with
        | Some descr ->
          (append (show0 Decimal.show_N idx0)
            (append (' '::('i'::('s'::(' '::[])))) (append descr ('.'::[])))) :: []
        | None ->
          (append (show0 Decimal.show_N idx0)
            (' '::('i'::('s'::(' '::('a'::(' '::('s'::('p'::('e'::('c'::('i'::('a'::('l'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('n'::('o'::(' '::('l'::('o'::('n'::('g'::('e'::('r'::(' '::('p'::('r'::('e'::('s'::('e'::('n'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::(' '::('m'::('a'::('c'::('h'::('i'::('n'::('e'::(' '::('s'::('t'::('a'::('t'::('e'::(' '::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('e'::('n'::('d'::(' '::('o'::('f'::(' '::('e'::('x'::('e'::('c'::('u'::('t'::('i'::('o'::('n'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
  else (match description_from_state with
        | Some descr ->
          if show_full
          then (append (show0 Decimal.show_N idx0)
                 (append (' '::('i'::('s'::(' '::[]))))
                   (append descr ('.'::[])))) :: []
          else []
        | None ->
          if show_full
          then (append (show0 Decimal.show_N idx0)
                 (append (' '::('i'::('s'::(' '::[]))))
                   (match Old.Coq_dag.lookup st.dag_state idx0 with
                    | Some e -> show_node_lite e
                    | None ->
                      'n'::('o'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('d'::('a'::('g'::[])))))))))))))))) :: []
          else [])

(** val iteratively_describe_idxs_after :
    idx option -> Old.Coq_dag.t -> (idx -> char list list) -> bool -> idx
    list -> char list list **)

let iteratively_describe_idxs_after first_new_idx_after_all_old_idxs dag describe_idx show_initial idxs0 =
  let deps =
    recursive_deps_list (S (Coq_N.to_nat (Old.Coq_dag.size dag))) dag
      NSet.empty idxs0
  in
  let deps0 = if show_initial then fold_right NSet.add deps idxs0 else deps in
  let deps1 = rev1 (Coq1_N.Sort.sort (NSet.elements deps0)) in
  let deps2 =
    match first_new_idx_after_all_old_idxs with
    | Some first_new_idx_after_all_old_idxs0 ->
      filter (fun i -> Coq_N.leb first_new_idx_after_all_old_idxs0 i) deps1
    | None -> deps1
  in
  flat_map describe_idx deps2

(** val iteratively_describe_idx :
    Old.Coq_dag.t -> (idx -> char list list) -> bool -> idx -> char list list **)

let iteratively_describe_idx dag describe_idx show_initial i =
  iteratively_describe_idxs_after None dag describe_idx show_initial (i :: [])

(** val describe_full_idx_from_state :
    symbolic_state -> idx -> char list list **)

let describe_full_idx_from_state st i =
  iteratively_describe_idx st.dag_state (describe_idx_from_state true st)
    true i

(** val explain_array_unification_error_single :
    Old.Coq_dag.t -> idx option -> char list -> char list -> char list ->
    char list -> (idx -> idx -> char list list) -> (idx -> char list list) ->
    bool -> idx list -> idx list -> nat -> char list list **)

let rec explain_array_unification_error_single dag first_new_idx_after_all_old_idxs singular plural left_descr right_descr explain_idx_unification_error0 describe_idx modulo_commutativity asm_array pHOAS_array start_idx =
  let recr =
    explain_array_unification_error_single dag
      first_new_idx_after_all_old_idxs singular plural left_descr right_descr
      explain_idx_unification_error0 describe_idx modulo_commutativity
  in
  (match asm_array with
   | [] ->
     (match pHOAS_array with
      | [] ->
        (append
          ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('E'::('r'::('r'::('o'::('r'::(':'::(' '::('U'::('n'::('i'::('f'::('i'::('a'::('b'::('l'::('e'::(' '::[]))))))))))))))))))))))))))
          (append plural
            (if modulo_commutativity
             then ' '::('m'::('o'::('d'::('u'::('l'::('o'::(' '::('c'::('o'::('m'::('m'::('u'::('t'::('a'::('t'::('i'::('v'::('i'::('t'::('y'::[]))))))))))))))))))))
             else []))) :: []
      | _ :: _ ->
        app
          ((append ('T'::('h'::('e'::(' '::[]))))
             (append right_descr
               (append (' '::[])
                 (append singular
                   (append
                     (' '::('c'::('o'::('n'::('t'::('a'::('i'::('n'::('s'::(' '::[]))))))))))
                     (append (show0 Decimal.show_nat (length pHOAS_array))
                       (append
                         (' '::('m'::('o'::('r'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::[]))))))))))))))))))))))
                         (append left_descr
                           (append (' '::[]) (append singular ('.'::[]))))))))))) :: [])
          (flat_map describe_idx pHOAS_array))
   | asm_value :: asm_array0 ->
     (match pHOAS_array with
      | [] ->
        app
          ((append ('T'::('h'::('e'::(' '::[]))))
             (append left_descr
               (append (' '::[])
                 (append singular
                   (append
                     (' '::('c'::('o'::('n'::('t'::('a'::('i'::('n'::('s'::(' '::[]))))))))))
                     (append (show0 Decimal.show_nat (length asm_array))
                       (append
                         (' '::('m'::('o'::('r'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::[]))))))))))))))))))))))
                         (append right_descr
                           (append (' '::[]) (append singular ('.'::[]))))))))))) :: [])
          (flat_map describe_idx asm_array)
      | pHOAS_value :: pHOAS_array0 ->
        if dec0 (dec_eq_N asm_value pHOAS_value)
        then recr asm_array0 pHOAS_array0 (S start_idx)
        else if (&&) modulo_commutativity
                  (existsb (Coq_N.eqb asm_value) pHOAS_array0)
             then recr asm_array0
                    (pHOAS_value :: (Coq4_List.removen (Coq_N.eqb asm_value)
                                      pHOAS_array0 (S O))) (S start_idx)
             else app
                    ((append ('i'::('n'::('d'::('e'::('x'::(' '::[]))))))
                       (append (show0 Decimal.show_nat start_idx)
                         (append (':'::(' '::[]))
                           (append (show_expr_node_lite (ExprRef asm_value))
                             (append
                               (' '::('\226'::('\137'::('\160'::(' '::[])))))
                               (show_expr_node_lite (ExprRef pHOAS_value))))))) :: [])
                    (app
                      (match first_new_idx_after_all_old_idxs with
                       | Some first_new_idx_after_all_old_idxs0 ->
                         if (&&)
                              (Coq_N.ltb asm_value
                                first_new_idx_after_all_old_idxs0)
                              (Coq_N.ltb pHOAS_value
                                first_new_idx_after_all_old_idxs0)
                         then (match filter (fun i ->
                                       Coq_N.leb
                                         first_new_idx_after_all_old_idxs0 i)
                                       (app asm_array0 pHOAS_array0) with
                               | [] -> []
                               | n3 :: l ->
                                 iteratively_describe_idxs_after None dag
                                   describe_idx true (n3 :: l))
                         else []
                       | None -> [])
                      (explain_idx_unification_error0 asm_value pHOAS_value))))

(** val iteratively_explain_array_unification_error_modulo_commutativity :
    Old.Coq_dag.t -> (idx -> char list list) -> op0 option -> bool ->
    (nat * idx) list -> idx list -> char list list **)

let iteratively_explain_array_unification_error_modulo_commutativity dag describe_idx op1 show_initial asm_array pHOAS_array =
  let recursive_deps0 =
    recursive_deps_list (S (Coq_N.to_nat (Old.Coq_dag.size dag))) dag
      NSet.empty
  in
  let asm_deps = recursive_deps0 (map snd asm_array) in
  let pHOAS_deps = recursive_deps0 pHOAS_array in
  let common_deps = NSet.inter asm_deps pHOAS_deps in
  let make_iteratively_revealed_exprs0 =
    make_iteratively_revealed_exprs dag (S
      (Coq_N.to_nat (Old.Coq_dag.size dag))) (fun i -> NSet.mem i common_deps)
  in
  let asm_exprs = map (fun x -> ExprRef x) (map snd asm_array) in
  let pHOAS_exprs = map (fun x -> ExprRef x) pHOAS_array in
  let asm_reveals = make_iteratively_revealed_exprs0 asm_exprs in
  let pHOAS_reveals = make_iteratively_revealed_exprs0 pHOAS_exprs in
  let reveals =
    Coq3_List.combine_extend asm_exprs pHOAS_exprs asm_reveals pHOAS_reveals
  in
  let (last_asm, last_PHOAS) = last reveals (asm_exprs, pHOAS_exprs) in
  let reveal_one_final_time = map (at_leaves (reveal dag (S O))) in
  let last_asm0 = reveal_one_final_time last_asm in
  let last_PHOAS0 = reveal_one_final_time last_PHOAS in
  let reveals0 =
    app (if show_initial then (asm_exprs, pHOAS_exprs) :: [] else [])
      (app reveals ((last_asm0, last_PHOAS0) :: []))
  in
  let show_array = fun array ->
    let args0 = show_list show_expr_node_lite array in
    (match op1 with
     | Some op2 ->
       append ('('::[])
         (append (show0 show_op op2)
           (append (','::(' '::[])) (append args0 (')'::[]))))
     | None -> args0)
  in
  let show_array_pretty = fun array ->
    match op1 with
    | Some op2 -> show_expr_pretty (ExprApp (op2, array))
    | None -> show_list show_expr_pretty array
  in
  app
    (map (fun pat ->
      let (asm_array0, pHOAS_array0) = pat in
      append (show_array asm_array0)
        (append (' '::('\226'::('\137'::('\160'::(' '::[])))))
          (show_array pHOAS_array0))) reveals0)
    (app
      ((append (show_array_pretty last_asm0)
         (append (' '::('\226'::('\137'::('\160'::(' '::[])))))
           (show_array_pretty last_PHOAS0))) :: [])
      (flat_map describe_idx
        (indices_at_leaves_map (app last_asm0 last_PHOAS0))))

(** val explain_array_unification_error :
    idx option -> Old.Coq_dag.t -> char list -> char list -> char list ->
    char list -> (idx -> idx -> char list list) -> (idx -> char list list) ->
    op0 option -> idx list -> idx list -> char list list **)

let explain_array_unification_error first_new_idx_after_all_old_idxs dag singular plural left_descr right_descr explain_idx_unification_error0 describe_idx op1 asm_array pHOAS_array =
  let modulo_commutativity =
    match op1 with
    | Some o -> commutative o
    | None -> false
  in
  if (&&) modulo_commutativity
       (negb (Nat.eqb (length asm_array) (length pHOAS_array)))
  then let (asm_array0, pHOAS_array0) =
         remove_common_indices Coq_N.eqb asm_array pHOAS_array O
       in
       (match asm_array0 with
        | [] ->
          (match pHOAS_array0 with
           | [] ->
             (append
               ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('E'::('r'::('r'::('o'::('r'::(':'::(' '::('U'::('n'::('i'::('f'::('i'::('a'::('b'::('l'::('e'::(' '::[]))))))))))))))))))))))))))
               (append plural
                 (' '::('m'::('o'::('d'::('u'::('l'::('o'::(' '::('c'::('o'::('m'::('m'::('u'::('t'::('a'::('t'::('i'::('v'::('i'::('t'::('y'::[]))))))))))))))))))))))) :: []
           | _ :: _ ->
             app
               ((append ('T'::('h'::('e'::(' '::[]))))
                  (append right_descr
                    (append (' '::[])
                      (append singular
                        (append
                          (' '::('c'::('o'::('n'::('t'::('a'::('i'::('n'::('s'::(' '::[]))))))))))
                          (append
                            (show0 Decimal.show_nat (length pHOAS_array0))
                            (append
                              (' '::('m'::('o'::('r'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::[]))))))))))))))))))))))
                              (append left_descr
                                (append (' '::[]) (append singular ('.'::[]))))))))))) :: [])
               (flat_map describe_idx pHOAS_array0))
        | p :: l ->
          let (arr_index, asm_value) = p in
          (match l with
           | [] ->
             (match pHOAS_array0 with
              | [] ->
                app
                  ((append ('T'::('h'::('e'::(' '::[]))))
                     (append left_descr
                       (append (' '::[])
                         (append singular
                           (append
                             (' '::('c'::('o'::('n'::('t'::('a'::('i'::('n'::('s'::(' '::[]))))))))))
                             (append
                               (show0 Decimal.show_nat (length asm_array0))
                               (append
                                 (' '::('m'::('o'::('r'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::[]))))))))))))))))))))))
                                 (append right_descr
                                   (append (' '::[])
                                     (append singular ('.'::[]))))))))))) :: [])
                  (flat_map describe_idx (map snd asm_array0))
              | pHOAS_value :: l0 ->
                (match l0 with
                 | [] ->
                   app
                     ((append ('i'::('n'::('d'::('e'::('x'::(' '::[]))))))
                        (append (show0 Decimal.show_nat arr_index)
                          (append (':'::(' '::[]))
                            (append (show_expr_node_lite (ExprRef asm_value))
                              (append
                                (' '::('\226'::('\137'::('\160'::(' '::[])))))
                                (show_expr_node_lite (ExprRef pHOAS_value))))))) :: [])
                     (explain_idx_unification_error0 asm_value pHOAS_value)
                 | _ :: _ ->
                   let show_initial_state =
                     negb
                       ((&&) (Nat.eqb (length asm_array0) (length asm_array))
                         (Nat.eqb (length pHOAS_array0) (length pHOAS_array)))
                   in
                   iteratively_explain_array_unification_error_modulo_commutativity
                     dag describe_idx op1 show_initial_state asm_array0
                     pHOAS_array0))
           | _ :: _ ->
             (match pHOAS_array0 with
              | [] ->
                app
                  ((append ('T'::('h'::('e'::(' '::[]))))
                     (append left_descr
                       (append (' '::[])
                         (append singular
                           (append
                             (' '::('c'::('o'::('n'::('t'::('a'::('i'::('n'::('s'::(' '::[]))))))))))
                             (append
                               (show0 Decimal.show_nat (length asm_array0))
                               (append
                                 (' '::('m'::('o'::('r'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::[]))))))))))))))))))))))
                                 (append right_descr
                                   (append (' '::[])
                                     (append singular ('.'::[]))))))))))) :: [])
                  (flat_map describe_idx (map snd asm_array0))
              | _ :: _ ->
                let show_initial_state =
                  negb
                    ((&&) (Nat.eqb (length asm_array0) (length asm_array))
                      (Nat.eqb (length pHOAS_array0) (length pHOAS_array)))
                in
                iteratively_explain_array_unification_error_modulo_commutativity
                  dag describe_idx op1 show_initial_state asm_array0
                  pHOAS_array0)))
  else explain_array_unification_error_single dag
         first_new_idx_after_all_old_idxs singular plural left_descr
         right_descr explain_idx_unification_error0 describe_idx
         modulo_commutativity asm_array pHOAS_array O

(** val explain_mismatch_from_state :
    char list -> char list -> symbolic_state -> idx -> idx -> char list list **)

let explain_mismatch_from_state _ _ st asm_idx pHOAS_idx =
  app (describe_idx_from_state false st asm_idx)
    (describe_idx_from_state false st pHOAS_idx)

(** val explain_idx_unification_error :
    idx option -> char list -> char list -> symbolic_state -> nat -> idx ->
    idx -> char list list **)

let rec explain_idx_unification_error first_new_idx_after_all_old_idxs left_descr right_descr st fuel0 asm_idx pHOAS_idx =
  let recr =
    match fuel0 with
    | O ->
      (fun _ _ ->
        ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('o'::('u'::('t'::(' '::('o'::('f'::(' '::('f'::('u'::('e'::('l'::(' '::('i'::('n'::(' '::('e'::('x'::('p'::('l'::('a'::('i'::('n'::('_'::('e'::('x'::('p'::('r'::('_'::('u'::('n'::('i'::('f'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::('_'::('e'::('r'::('r'::('o'::('r'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
    | S fuel1 ->
      explain_idx_unification_error first_new_idx_after_all_old_idxs
        left_descr right_descr st fuel1
  in
  let reveal_idx = fun idx0 -> Old.Coq_dag.lookup st.dag_state idx0 in
  let reveal_show_idx = fun idx0 ->
    match reveal_idx idx0 with
    | Some n3 -> show0 (show_node Decimal.show_N) n3
    | None -> show_expr_node_lite (ExprRef idx0)
  in
  let reveal_show_node = fun pat ->
    let (op1, e) = pat in
    append ('('::[])
      (append (show0 show_op op1)
        (append (','::(' '::[]))
          (append (show_list reveal_show_idx e) (')'::[]))))
  in
  (match reveal_idx asm_idx with
   | Some asm ->
     let (asm_o, asm_e) = asm in
     (match reveal_idx pHOAS_idx with
      | Some pHOAS ->
        let (pHOAS_o, pHOAS_e) = pHOAS in
        app
          ((append (show_node_lite asm)
             (append (' '::('\226'::('\137'::('\160'::(' '::[])))))
               (show_node_lite pHOAS))) :: [])
          (if dec0
                (dec_of_reflect (op_beq asm_o pHOAS_o)
                  (reflect_eq_op asm_o pHOAS_o))
           then explain_array_unification_error
                  first_new_idx_after_all_old_idxs st.dag_state
                  ('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::[]))))))))
                  ('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::[])))))))))
                  left_descr right_descr recr
                  (describe_idx_from_state false st) (Some asm_o) asm_e
                  pHOAS_e
           else app
                  ((append (reveal_show_node asm)
                     (append (' '::('\226'::('\137'::('\160'::(' '::[])))))
                       (reveal_show_node pHOAS))) :: ((append
                                                        ('O'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::(' '::('m'::('i'::('s'::('m'::('a'::('t'::('c'::('h'::(':'::(' '::[]))))))))))))))))))))
                                                        (append
                                                          (show0 show_op
                                                            asm_o)
                                                          (append
                                                            (' '::('\226'::('\137'::('\160'::(' '::[])))))
                                                            (show0 show_op
                                                              pHOAS_o)))) :: []))
                  (explain_mismatch_from_state left_descr right_descr st
                    asm_idx pHOAS_idx))
      | None ->
        (append
          ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))))))))))))))))))))))))))))
          (append (show0 Decimal.show_N pHOAS_idx)
            (' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('d'::('a'::('g'::[])))))))))))))))))))) :: [])
   | None ->
     (match reveal_idx pHOAS_idx with
      | Some _ ->
        (append
          ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[])))))))))))))))))))))))))))))))
          (append (show0 Decimal.show_N asm_idx)
            (' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('d'::('a'::('g'::[])))))))))))))))))))) :: []
      | None ->
        ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('n'::('e'::('i'::('t'::('h'::('e'::('r'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::('i'::('s'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('d'::('a'::('g'::[])))))))))))))))))))))))))))))))))))))))))))))))) :: []))

(** val explain_unification_default_fuel : symbolic_state -> nat **)

let explain_unification_default_fuel st =
  Coq_N.to_nat
    (Coq_N.add (Npos (XO (XI (XO XH))))
      (Coq_N.mul (Npos (XO XH)) (Old.Coq_dag.size st.dag_state)))

(** val explain_unification_error :
    (idx, idx list) sum list -> (idx, idx list) sum list -> idx option -> nat
    -> symbolic_state -> char list list **)

let rec explain_unification_error asm_output pHOAS_output first_new_idx_after_all_old_idxs start_idx st =
  let fuel0 = explain_unification_default_fuel st in
  (match asm_output with
   | [] ->
     (match pHOAS_output with
      | [] ->
        ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('E'::('r'::('r'::('o'::('r'::(':'::(' '::('U'::('n'::('i'::('f'::('i'::('a'::('b'::('l'::('e'::[]))))))))))))))))))))))))) :: []
      | _ :: _ ->
        (append
          ('T'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('d'::('e'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::[])))))))))))))))))))))))))))))
          (append (show0 Decimal.show_nat (length pHOAS_output))
            (' '::('m'::('o'::('r'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('c'::('o'::('d'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))) :: [])
   | asm_value :: asm_output0 ->
     (match pHOAS_output with
      | [] ->
        (append
          ('T'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('c'::('o'::('d'::('e'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::[]))))))))))))))))))))))))))
          (append (show0 Decimal.show_nat (length asm_output))
            (' '::('m'::('o'::('r'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('d'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))))))) :: []
      | pHOAS_value :: pHOAS_output0 ->
        if dec0
             (dec_eq_sum dec_eq_N (dec_eq_list dec_eq_N) asm_value
               pHOAS_value)
        then explain_unification_error asm_output0 pHOAS_output0
               first_new_idx_after_all_old_idxs (S start_idx) st
        else let prefix1 =
               append
                 ('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('u'::('n'::('i'::('f'::('y'::(' '::('t'::('h'::('e'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('a'::('t'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))))))))))))))))))))))))))))))
                 (append (show0 Decimal.show_nat start_idx) (':'::[]))
             in
             (match asm_value with
              | Inl asm_idx ->
                (match pHOAS_value with
                 | Inl pHOAS_idx ->
                   app
                     ((append
                        ('i'::('n'::('d'::('e'::('x'::(' '::(' '::[])))))))
                        (append (show0 Decimal.show_nat start_idx)
                          (append (':'::(' '::[]))
                            (append (show_expr_node_lite (ExprRef asm_idx))
                              (append
                                (' '::('\226'::('\137'::('\160'::(' '::[])))))
                                (show_expr_node_lite (ExprRef pHOAS_idx))))))) :: [])
                     (explain_idx_unification_error
                       first_new_idx_after_all_old_idxs
                       ('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::[]))))))))
                       ('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::[])))))))))))
                       st fuel0 asm_idx pHOAS_idx)
                 | Inr _ ->
                   prefix1 :: (('T'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('c'::('o'::('d'::('e'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::('a'::(' '::('s'::('c'::('a'::('l'::('a'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('d'::('e'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::('a'::('n'::(' '::('a'::('r'::('r'::('a'::('y'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))
              | Inr asm_idxs ->
                (match pHOAS_value with
                 | Inl _ ->
                   prefix1 :: (('T'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('c'::('o'::('d'::('e'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::('a'::('n'::(' '::('a'::('r'::('r'::('a'::('y'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(' '::('c'::('o'::('d'::('e'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::('a'::(' '::('s'::('c'::('a'::('l'::('a'::('r'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
                 | Inr pHOAS_idxs ->
                   app
                     ((append prefix1
                        (append (' '::[])
                          (append
                            (show_list show_expr_node_lite
                              (map (fun x -> ExprRef x) asm_idxs))
                            (append
                              (' '::('\226'::('\137'::('\160'::(' '::[])))))
                              (show_list show_expr_node_lite
                                (map (fun x -> ExprRef x) pHOAS_idxs)))))) :: [])
                     (explain_array_unification_error
                       first_new_idx_after_all_old_idxs st.dag_state
                       ('a'::('r'::('r'::('a'::('y'::[])))))
                       ('a'::('r'::('r'::('a'::('y'::('s'::[]))))))
                       ('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::[]))))))))
                       ('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::[])))))))))))
                       (explain_idx_unification_error
                         first_new_idx_after_all_old_idxs
                         ('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::[]))))))))
                         ('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::[])))))))))))
                         st fuel0) (describe_idx_from_state false st) None
                       asm_idxs pHOAS_idxs)))))

(** val show_lines_EquivalenceCheckingError :
    equivalenceCheckingError showLines **)

let show_lines_EquivalenceCheckingError = function
| Symbolic_execution_failed (l, r0) ->
  app
    (('I'::('n'::(' '::('c'::('o'::('m'::('b'::('i'::('n'::('e'::('d'::(' '::('s'::('t'::('a'::('t'::('e'::(':'::[])))))))))))))))))) :: [])
    (app (show_lines showLines_symbolic_state r0)
      (app
        (('S'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::(' '::('e'::('x'::('e'::('c'::('u'::('t'::('i'::('o'::('n'::(' '::('f'::('a'::('i'::('l'::('e'::('d'::(':'::[])))))))))))))))))))))))))) :: [])
        (app (show_lines Coq_error.show_lines_error l)
          (match l with
           | Coq_error.Coq_get_flag (_, _) -> []
           | Coq_error.Coq_get_reg (_, _) -> []
           | Coq_error.Coq_load (idx0, s0) ->
             describe_full_idx_from_state s0 idx0
           | Coq_error.Coq_remove (idx0, s0) ->
             describe_full_idx_from_state s0 idx0
           | Coq_error.Coq_remove_has_duplicates (idx0, _, s0) ->
             describe_full_idx_from_state s0 idx0
           | Coq_error.Coq_store (idx0, _, s0) ->
             describe_full_idx_from_state s0 idx0
           | Coq_error.Coq_set_const (_, _) -> []
           | Coq_error.Coq_expected_const (_, _) -> []
           | Coq_error.Coq_unsupported_memory_access_size _ -> []
           | Coq_error.Coq_unsupported_label_in_memory _ -> []
           | Coq_error.Coq_unsupported_label_argument _ -> []
           | Coq_error.Coq_unimplemented_prefix _ -> []
           | Coq_error.Coq_unimplemented_instruction _ -> []
           | Coq_error.Coq_unsupported_line _ -> []
           | Coq_error.Coq_ambiguous_operation_size _ -> []))))
| Internal_error_output_load_failed (err1, l, r0) ->
  app
    (('I'::('n'::(' '::('c'::('o'::('m'::('b'::('i'::('n'::('e'::('d'::(' '::('s'::('t'::('a'::('t'::('e'::(':'::[])))))))))))))))))) :: [])
    (app (show_lines showLines_symbolic_state r0)
      ((append
         ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::('.'::(' '::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('l'::('o'::('a'::('d'::(' '::('f'::('a'::('i'::('l'::('e'::('d'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))
         (append
           (show0
             (show_of_ShowLevel
               (show_lvl_list
                 (show_lvl_sum (show_lvl_sum show_lvl_REG Decimal.show_lvl_N)
                   Decimal.show_lvl_N))) l)
           (match err1 with
            | Some err2 ->
              append ('('::[])
                (append (show0 Coq_error.coq_Show_error err2) (')'::[]))
            | None -> []))) :: []))
| Internal_error_extra_input_arguments (t0, unused_arguments) ->
  (append
    ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::('.'::(' '::('T'::('o'::('o'::(' '::('m'::('a'::('n'::('y'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(' '::('f'::('o'::('r'::(' '::('t'::('y'::('p'::('e'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))
    (append
      (show0
        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) t0)
      (append
        ('.'::(' '::('U'::('n'::('u'::('s'::('e'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[]))))))))))))))))))))
        (show0
          (show_of_ShowLevel
            (show_lvl_list
              (show_lvl_sum Decimal.show_lvl_N
                (show_lvl_list Decimal.show_lvl_N)))) unused_arguments)))) :: []
| Internal_error_lingering_memory s0 ->
  app
    (('I'::('n'::(' '::('c'::('o'::('m'::('b'::('i'::('n'::('e'::('d'::(' '::('s'::('t'::('a'::('t'::('e'::(':'::[])))))))))))))))))) :: [])
    (app (show_lines showLines_symbolic_state s0)
      ((append
         ('S'::('o'::('m'::('e'::(' '::('m'::('e'::('m'::('o'::('r'::('y'::(' '::('r'::('e'::('m'::('a'::('i'::('n'::('e'::('d'::(' '::('a'::('f'::('t'::('e'::('r'::(' '::('a'::('l'::('l'::(' '::('k'::('n'::('o'::('w'::('n'::(' '::('m'::('e'::('m'::('o'::('r'::('y'::(' '::('w'::('a'::('s'::(' '::('r'::('e'::('m'::('o'::('v'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         (show0 (show_of_ShowLines show_lines_mem_state)
           s0.symbolic_mem_state)) :: []))
| Internal_error_LoadOutputs_length_mismatch (l1, l2) ->
  (append
    ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::('.'::(' '::('L'::('e'::('n'::('g'::('t'::('h'::(' '::('m'::('i'::('s'::('m'::('a'::('t'::('c'::('h'::(' '::('f'::('o'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))
    (append
      (show0
        (show_of_ShowLevel
          (show_lvl_list
            (show_lvl_sum (show_lvl_sum show_lvl_REG Decimal.show_lvl_N)
              Decimal.show_lvl_N))) l1)
      (append (' '::('a'::('n'::('d'::(' '::[])))))
        (append
          (show0
            (show_of_ShowLevel
              (show_lvl_list (show_lvl_option Decimal.show_lvl_nat))) l2)
          ('.'::[]))))) :: ((append (show0 Decimal.show_nat (length l1))
                              (append
                                (' '::('\226'::('\137'::('\160'::(' '::[])))))
                                (show0 Decimal.show_nat (length l2)))) :: [])
| Not_enough_registers (num_given, num_extra_needed) ->
  (append
    ('N'::('o'::('t'::(' '::('e'::('n'::('o'::('u'::('g'::('h'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('a'::('v'::('a'::('i'::('l'::('a'::('b'::('l'::('e'::(' '::('f'::('o'::('r'::(' '::('s'::('t'::('o'::('r'::('i'::('n'::('g'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('a'::('n'::('d'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('('::('g'::('i'::('v'::('e'::('n'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
    (append (show0 Decimal.show_nat num_given)
      (append
        (','::(' '::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('a'::('n'::(' '::('a'::('d'::('d'::('i'::('t'::('i'::('o'::('n'::('a'::('l'::(' '::[])))))))))))))))))))))))
        (append (show0 Decimal.show_nat num_extra_needed) ('.'::[]))))) :: []
| Registers_too_narrow regs ->
  (append
    ('S'::('o'::('m'::('e'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::('w'::('e'::('r'::('e'::(' '::('m'::('o'::('r'::('e'::(' '::('n'::('a'::('r'::('r'::('o'::('w'::(' '::('t'::('h'::('a'::('n'::(' '::('6'::('4'::(' '::('b'::('i'::('t'::('s'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))
    (concat0 (','::(' '::[]))
      (map (fun r0 ->
        append (show0 show_REG r0)
          (append
            (' '::('('::('w'::('i'::('d'::('t'::('h'::(':'::(' '::[])))))))))
            (append (show0 Decimal.show_N (reg_size r0)) (')'::[])))) regs))) :: []
| Callee_saved_registers_too_narrow regs ->
  (append
    ('S'::('o'::('m'::('e'::(' '::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::(' '::('/'::(' '::('n'::('o'::('n'::('-'::('v'::('o'::('l'::('a'::('t'::('i'::('l'::('e'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::('w'::('e'::('r'::('e'::(' '::('m'::('o'::('r'::('e'::(' '::('n'::('a'::('r'::('r'::('o'::('w'::(' '::('t'::('h'::('a'::('n'::(' '::('6'::('4'::(' '::('b'::('i'::('t'::('s'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
    (concat0 (','::(' '::[]))
      (map (fun r0 ->
        append (show0 show_REG r0)
          (append
            (' '::('('::('w'::('i'::('d'::('t'::('h'::(':'::(' '::[])))))))))
            (append (show0 Decimal.show_N (reg_size r0)) (')'::[])))) regs))) :: []
| Duplicate_registers regs ->
  (append
    ('L'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('c'::('o'::('n'::('t'::('a'::('i'::('n'::('s'::(' '::('d'::('u'::('p'::('l'::('i'::('c'::('a'::('t'::('e'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
    (concat0 (','::(' '::[])) (map (show0 show_REG) regs))) :: []
| Incorrect_array_input_dag_node ->
  ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('I'::('n'::('p'::('u'::('t'::(' '::('d'::('a'::('g'::(' '::('n'::('o'::('d'::('e'::(' '::('h'::('a'::('d'::(' '::('a'::('n'::(' '::('u'::('n'::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('a'::('r'::('r'::('a'::('y'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []
| Incorrect_Z_input_dag_node ->
  ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('I'::('n'::('p'::('u'::('t'::(' '::('d'::('a'::('g'::(' '::('n'::('o'::('d'::('e'::(' '::('h'::('a'::('d'::(' '::('a'::('n'::(' '::('u'::('n'::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('Z'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))) :: []
| Not_enough_input_dag_nodes t0 ->
  (append
    ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('N'::('o'::('t'::(' '::('e'::('n'::('o'::('u'::('g'::('h'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('d'::('a'::('g'::(' '::('n'::('o'::('d'::('e'::('s'::(' '::('t'::('o'::(' '::('a'::('l'::('l'::('o'::('c'::('a'::('t'::('e'::(' '::('f'::('o'::('r'::(' '::('t'::('y'::('p'::('e'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
    (append
      (show0
        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) t0) ('.'::[]))) :: []
| Expected_const_in_reference_code i ->
  (append
    ('E'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('N'::(' '::('c'::('o'::('n'::('s'::('t'::(' '::('i'::('n'::(' '::('r'::('e'::('f'::('e'::('r'::('e'::('n'::('c'::('e'::(' '::('c'::('o'::('d'::('e'::(' '::('f'::('o'::('r'::(' '::('d'::('a'::('g'::(' '::('n'::('o'::('d'::('e'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))
    (show0 Decimal.show_N i)) :: []
| Expected_power_of_two (w, i) ->
  (append
    ('E'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('p'::('o'::('w'::('e'::('r'::(' '::('o'::('f'::(' '::('2'::(','::(' '::('g'::('o'::('t'::(' '::[])))))))))))))))))))))))))
    (append (show0 Decimal.show_N w)
      (append (' '::('('::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))
        (append (show0 Decimal.show_N i) (')'::[]))))) :: []
| Unknown_array_length t0 ->
  (append
    ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('a'::('r'::('r'::('a'::('y'::(' '::('l'::('e'::('n'::('g'::('t'::('h'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))
    (append (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)
      ('.'::[]))) :: []
| Registers_not_saved (regs, r0) ->
  let reg_before =
    map (fun pat ->
      let (_, y) = pat in let (idx_before, _) = y in idx_before) regs
  in
  let reg_after =
    map (fun pat -> let (_, y) = pat in let (_, idx_after) = y in idx_after)
      regs
  in
  let regs0 = map (fun pat -> let (r1, y) = pat in let (_, _) = y in r1) regs
  in
  app
    ((append
       ('U'::('n'::('a'::('b'::('l'::('e'::(' '::('t'::('o'::(' '::('e'::('s'::('t'::('a'::('b'::('l'::('i'::('s'::('h'::(' '::('t'::('h'::('a'::('t'::(' '::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::(' '::('n'::('o'::('n'::('-'::('v'::('o'::('l'::('a'::('t'::('i'::('l'::('e'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('w'::('e'::('r'::('e'::(' '::('p'::('r'::('e'::('s'::('e'::('r'::('v'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
       (concat0 (','::(' '::[])) (map (show0 show_REG) regs0))) :: (('I'::('n'::(' '::('e'::('n'::('v'::('i'::('r'::('o'::('n'::('m'::('e'::('n'::('t'::(':'::[]))))))))))))))) :: []))
    (app (show_lines showLines_symbolic_state r0)
      (app
        ((append
           ('U'::('n'::('a'::('b'::('l'::('e'::(' '::('t'::('o'::(' '::('e'::('s'::('t'::('a'::('b'::('l'::('i'::('s'::('h'::(' '::('t'::('h'::('a'::('t'::(' '::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::(' '::('n'::('o'::('n'::('-'::('v'::('o'::('l'::('a'::('t'::('i'::('l'::('e'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('w'::('e'::('r'::('e'::(' '::('p'::('r'::('e'::('s'::('e'::('r'::('v'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
           (concat0 (','::(' '::[])) (map (show0 show_REG) regs0))) :: (
        (append
          ('U'::('n'::('a'::('b'::('l'::('e'::(' '::('t'::('o'::(' '::('u'::('n'::('i'::('f'::('y'::(':'::(' '::[])))))))))))))))))
          (append
            (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_N))
              reg_before)
            (append (' '::('='::('='::(' '::[]))))
              (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_N))
                reg_after)))) :: []))
        (let first_new_idx_after_all_old_idxs = None in
         explain_array_unification_error first_new_idx_after_all_old_idxs
           r0.dag_state ('l'::('i'::('s'::('t'::[]))))
           ('l'::('i'::('s'::('t'::('s'::[])))))
           ('o'::('r'::('i'::('g'::('i'::('n'::('a'::('l'::[]))))))))
           ('f'::('i'::('n'::('a'::('l'::[])))))
           (explain_idx_unification_error first_new_idx_after_all_old_idxs
             ('o'::('r'::('i'::('g'::('i'::('n'::('a'::('l'::[]))))))))
             ('f'::('i'::('n'::('a'::('l'::[]))))) r0
             (explain_unification_default_fuel r0))
           (describe_idx_from_state false r0) None reg_before reg_after)))
| Invalid_arrow_type t0 ->
  (append
    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('h'::('i'::('g'::('h'::('e'::('r'::(' '::('o'::('r'::('d'::('e'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('i'::('n'::('v'::('o'::('l'::('v'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))
    (append
      (show0
        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) t0) ('.'::[]))) :: []
| Invalid_argument_type t0 ->
  (append
    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(':'::(' '::[])))))))))))))))))))))))))))
    (show0
      (Coq7_Compilers.ToString.PHOAS.Coq_type.show
        Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) t0)) :: []
| Invalid_return_type t0 ->
  (append
    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(':'::(' '::[])))))))))))))))))))))))))
    (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []
| Invalid_higher_order_application (s0, d, f, x) ->
  let __0 = fun _ ->
    Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
  in
  (append
    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('h'::('i'::('g'::('h'::('e'::('r'::('-'::('o'::('r'::('d'::('e'::('r'::(' '::('a'::('p'::('p'::('l'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(' '::('n'::('o'::('d'::('e'::(' '::('w'::('i'::('t'::('h'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
    (append
      (show0
        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) s0) (':'::[]))) :: (
  (append
    ('F'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))
    (show0 (__0 __ (Compilers.Coq_type.Coq_arrow (s0, d))) f)) :: ((append
                                                                    ('A'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))
                                                                    (show0
                                                                    (__0 __
                                                                    s0) x)) :: []))
| Invalid_higher_order_let (s0, x) ->
  let __0 = fun _ ->
    Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
  in
  (append
    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('h'::('i'::('g'::('h'::('e'::('r'::('-'::('o'::('r'::('d'::('e'::('r'::(' '::('l'::('e'::('t'::('-'::('i'::('n'::(' '::('n'::('o'::('d'::('e'::(' '::('w'::('i'::('t'::('h'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))
    (append
      (show0
        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) s0) (':'::[]))) :: (
  (append
    ('L'::('e'::('t'::('-'::('b'::('o'::('u'::('n'::('d'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[]))))))))))))))))))))))
    (show0 (__0 __ s0) x)) :: [])
| Unhandled_identifier (t0, idc) ->
  (append
    ('I'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('n'::('o'::('t'::(' '::('y'::('e'::('t'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::('d'::(' '::('b'::('y'::(' '::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::(' '::('e'::('v'::('a'::('l'::('u'::('a'::('t'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))
    (append
      (show0 (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0) idc)
      ('.'::[]))) :: []
| Unhandled_cast (l, u) ->
  (append
    ('A'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('n'::('o'::('t'::(' '::('y'::('e'::('t'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::('d'::(' '::('b'::('y'::(' '::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::(' '::('e'::('v'::('a'::('l'::('u'::('a'::('t'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))
    (show0
      (show_of_ShowLevel
        (show_lvl_prod Decimal.show_lvl_Z Decimal.show_lvl_Z)) (l, u))) :: []
| Unable_to_unify (asm_output, pHOAS_output,
                   first_new_idx_after_all_old_idxs, r0) ->
  app
    (('U'::('n'::('a'::('b'::('l'::('e'::(' '::('t'::('o'::(' '::('u'::('n'::('i'::('f'::('y'::(':'::[])))))))))))))))) :: (('I'::('n'::(' '::('e'::('n'::('v'::('i'::('r'::('o'::('n'::('m'::('e'::('n'::('t'::(':'::[]))))))))))))))) :: []))
    (app (show_lines showLines_symbolic_state r0)
      (app
        ((append
           ('U'::('n'::('a'::('b'::('l'::('e'::(' '::('t'::('o'::(' '::('u'::('n'::('i'::('f'::('y'::(':'::(' '::[])))))))))))))))))
           (append
             (show0
               (show_of_ShowLevel
                 (show_lvl_list
                   (show_lvl_sum Decimal.show_lvl_N
                     (show_lvl_list Decimal.show_lvl_N)))) asm_output)
             (append (' '::('='::('='::(' '::[]))))
               (show0
                 (show_of_ShowLevel
                   (show_lvl_list
                     (show_lvl_sum Decimal.show_lvl_N
                       (show_lvl_list Decimal.show_lvl_N)))) pHOAS_output)))) :: [])
        (explain_unification_error asm_output pHOAS_output
          first_new_idx_after_all_old_idxs O r0)))
| Missing_ret ->
  ('M'::('i'::('s'::('s'::('i'::('n'::('g'::(' '::('\''::('r'::('e'::('t'::('\''::(' '::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('e'::('n'::('d'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::[])))))))))))))))))))))))))))))))))))))))) :: []
| Code_after_ret (significant, l) ->
  app
    (('C'::('o'::('d'::('e'::(' '::('a'::('f'::('t'::('e'::('r'::(' '::('r'::('e'::('t'::(':'::[]))))))))))))))) :: (('I'::('n'::(':'::[]))) :: []))
    (app (show_lines show_lines_Lines l)
      (app
        (('F'::('o'::('u'::('n'::('d'::(' '::('i'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('f'::('t'::('e'::('r'::(' '::('r'::('e'::('t'::(':'::[]))))))))))))))))))))))))))))) :: [])
        (show_lines show_lines_Lines significant)))

(** val merge_fresh_symbol : description -> idx Old.Coq_dag.coq_M **)

let merge_fresh_symbol descr d =
  merge_node0 descr
    (Old.Coq_dag.gensym (Npos (XO (XO (XO (XO (XO (XO XH))))))) d) d

(** val setRegFresh :
    Options.symbolic_options_computed_opt -> description -> rEG -> idx m **)

let setRegFresh opts descr r0 =
  bind2 (lift_dag (merge_fresh_symbol descr)) (fun idx0 ->
    bind2 (setReg opts descr r0 idx0) (fun _ -> ret0 idx0))

type 't symexM =
  Old.Coq_dag.t -> (equivalenceCheckingError, 't * Old.Coq_dag.t) errorT

(** val symex_return : 'a1 -> 'a1 symexM **)

let symex_return v st =
  Success (v, st)

(** val symex_error : equivalenceCheckingError -> 'a1 symexM **)

let symex_error err0 _ =
  Error err0

(** val symex_bind : 'a1 symexM -> ('a1 -> 'a2 symexM) -> 'a2 symexM **)

let symex_bind v f st =
  bind0 (v st) (fun v0 -> let (a, st0) = v0 in f a st0)

(** val app1 :
    Options.symbolic_options_computed_opt -> description -> idx node0 -> idx
    symexM **)

let app1 opts descr e st =
  Success (merge0 descr (simplify opts st e) st)

(** val revealConstant : idx -> n symexM **)

let revealConstant i st =
  match reveal st (S O) i with
  | ExprRef _ -> Error (Expected_const_in_reference_code i)
  | ExprApp n3 ->
    let (o, l) = n3 in
    (match o with
     | Old (_, _) -> Error (Expected_const_in_reference_code i)
     | Const0 n4 ->
       (match l with
        | [] ->
          if Coq_Z.leb Z0 n4
          then Success ((Coq_Z.to_N n4), st)
          else Error (Expected_const_in_reference_code i)
        | _ :: _ -> Error (Expected_const_in_reference_code i))
     | Add0 _ -> Error (Expected_const_in_reference_code i)
     | Addcarry _ -> Error (Expected_const_in_reference_code i)
     | Subborrow _ -> Error (Expected_const_in_reference_code i)
     | Addoverflow _ -> Error (Expected_const_in_reference_code i)
     | Neg1 _ -> Error (Expected_const_in_reference_code i)
     | Shl0 _ -> Error (Expected_const_in_reference_code i)
     | Shr0 _ -> Error (Expected_const_in_reference_code i)
     | Sar0 _ -> Error (Expected_const_in_reference_code i)
     | Rcr0 _ -> Error (Expected_const_in_reference_code i)
     | And0 _ -> Error (Expected_const_in_reference_code i)
     | Or0 _ -> Error (Expected_const_in_reference_code i)
     | Xor0 _ -> Error (Expected_const_in_reference_code i)
     | Slice (_, _) -> Error (Expected_const_in_reference_code i)
     | Mul0 _ -> Error (Expected_const_in_reference_code i)
     | Set_slice (_, _) -> Error (Expected_const_in_reference_code i)
     | Selectznz -> Error (Expected_const_in_reference_code i)
     | Iszero -> Error (Expected_const_in_reference_code i)
     | AddZ -> Error (Expected_const_in_reference_code i)
     | MulZ -> Error (Expected_const_in_reference_code i)
     | NegZ -> Error (Expected_const_in_reference_code i)
     | ShlZ -> Error (Expected_const_in_reference_code i)
     | ShrZ -> Error (Expected_const_in_reference_code i)
     | AndZ -> Error (Expected_const_in_reference_code i)
     | OrZ -> Error (Expected_const_in_reference_code i)
     | XorZ -> Error (Expected_const_in_reference_code i)
     | AddcarryZ _ -> Error (Expected_const_in_reference_code i)
     | SubborrowZ _ -> Error (Expected_const_in_reference_code i))

(** val revealWidth : idx -> n symexM **)

let revealWidth i =
  symex_bind (revealConstant i) (fun s0 ->
    let w = Coq_N.log2 s0 in
    if Coq_N.eqb s0 (Coq_N.pow (Npos (XO XH)) w)
    then symex_return w
    else symex_error (Expected_power_of_two (s0, i)))

type type_spec = nat option list

(** val simplify_base_type :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (equivalenceCheckingError, type_spec) errorT **)

let rec simplify_base_type t0 = match t0 with
| Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
  (match t1 with
   | Coq3_Compilers.Z -> (fun _ -> Success (None :: []))
   | Coq3_Compilers.Coq_bool ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
   | Coq3_Compilers.Coq_nat ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
   | Coq3_Compilers.Coq_zrange ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
   | Coq3_Compilers.Coq_string ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0))))
| Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
  (fun pat ->
    let (bA, bB) = Obj.magic pat in
    bind0 (simplify_base_type a bA) (fun vA ->
      bind0 (simplify_base_type b bB) (fun vB -> Success (app vA vB))))
| Compilers.Coq_base.Coq_type.Coq_list a ->
  (match a with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z ->
        (fun b ->
          match Obj.magic b with
          | Some bs -> Success ((Some (length bs)) :: [])
          | None -> Error (Unknown_array_length t0))
      | Coq3_Compilers.Coq_bool ->
        (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base
          t0)))
      | Coq3_Compilers.Coq_nat ->
        (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base
          t0)))
      | Coq3_Compilers.Coq_zrange ->
        (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base
          t0)))
      | Coq3_Compilers.Coq_string ->
        (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base
          t0))))
   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
   | Compilers.Coq_base.Coq_type.Coq_list _ ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
   | Compilers.Coq_base.Coq_type.Coq_option _ ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
   | Compilers.Coq_base.Coq_type.Coq_unit ->
     (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0))))
| Compilers.Coq_base.Coq_type.Coq_option _ ->
  (fun _ -> Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
| Compilers.Coq_base.Coq_type.Coq_unit ->
  (fun pat -> let () = Obj.magic pat in Success [])

(** val simplify_type :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
    (equivalenceCheckingError, type_spec) errorT **)

let simplify_type t0 = match t0 with
| Compilers.Coq_type.Coq_base t1 -> simplify_base_type t1
| Compilers.Coq_type.Coq_arrow (_, _) ->
  (fun _ -> Error (Invalid_argument_type t0))

(** val simplify_input_type :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (equivalenceCheckingError,
    type_spec) errorT **)

let rec simplify_input_type = function
| Compilers.Coq_type.Coq_base _ ->
  (fun pat -> let () = Obj.magic pat in Success [])
| Compilers.Coq_type.Coq_arrow (a, b) ->
  (fun pat ->
    let (bA, bB) = Obj.magic pat in
    bind0 (simplify_type a bA) (fun vA ->
      bind0 (simplify_input_type b bB) (fun vB -> Success (app vA vB))))

(** val build_inputarray :
    description -> nat -> idx list Old.Coq_dag.coq_M **)

let build_inputarray descr len =
  Coq0_List.foldmap (fun _ -> merge_fresh_symbol descr) (seq O len)

(** val build_inputs :
    description -> type_spec -> (idx, idx list) sum list Old.Coq_dag.coq_M **)

let rec build_inputs descr = function
| [] -> Old.Coq_dag.ret []
| o :: tys ->
  (match o with
   | Some len ->
     Old.Coq_dag.bind (build_inputarray descr len) (fun idxs0 ->
       Old.Coq_dag.bind (build_inputs descr tys) (fun rest ->
         Old.Coq_dag.ret ((Inr idxs0) :: rest)))
   | None ->
     Old.Coq_dag.bind (merge_fresh_symbol descr) (fun idx0 ->
       Old.Coq_dag.bind (build_inputs descr tys) (fun rest ->
         Old.Coq_dag.ret ((Inl idx0) :: rest))))

(** val compute_array_address :
    Options.symbolic_options_computed_opt -> description -> idx -> nat -> idx
    m **)

let compute_array_address opts descr base1 i =
  bind2
    (app0 opts descr
      ((zconst (Npos (XO (XO (XO (XO (XO (XO XH)))))))
         (Coq_Z.mul (Zpos (XO (XO (XO XH)))) (Coq_Z.of_nat i))), []))
    (fun offset ->
    app0 opts descr ((Add0 (Npos (XO (XO (XO (XO (XO (XO XH)))))))),
      (base1 :: (offset :: []))))

(** val build_merge_array_addresses :
    Options.symbolic_options_computed_opt -> description -> idx -> idx list
    -> idx list m **)

let build_merge_array_addresses opts descr base1 items =
  mapM (fun pat ->
    let (i, idx0) = pat in
    bind2 (compute_array_address opts descr base1 i) (fun addr s0 -> Success
      (addr, (update_mem_with s0 (fun x -> (addr, idx0) :: x)))))
    (List.enumerate items)

(** val build_merge_base_addresses :
    Options.symbolic_options_computed_opt -> description -> bool -> (idx, idx
    list) sum list -> rEG list -> ((rEG, idx) sum, idx) sum list m **)

let rec build_merge_base_addresses opts descr dereference_scalar items reg_available =
  match items with
  | [] -> ret0 []
  | s0 :: xs ->
    (match s0 with
     | Inl idx0 ->
       (match reg_available with
        | [] -> ret0 []
        | r0 :: reg_available0 ->
          bind2
            (if dereference_scalar
             then bind2 (setRegFresh opts descr r0) (fun addr s1 -> Success
                    ((Inr addr),
                    (update_mem_with s1 (fun x -> (addr, idx0) :: x))))
             else bind2 (setReg opts descr r0 idx0) (fun _ -> ret0 (Inl r0)))
            (fun addr ->
            bind2
              (build_merge_base_addresses opts descr dereference_scalar xs
                reg_available0) (fun rest -> ret0 ((Inl addr) :: rest))))
     | Inr idxs0 ->
       (match reg_available with
        | [] -> ret0 []
        | r0 :: reg_available0 ->
          bind2 (setRegFresh opts descr r0) (fun base1 ->
            bind2 (build_merge_array_addresses opts descr base1 idxs0)
              (fun _ ->
              bind2
                (build_merge_base_addresses opts descr dereference_scalar xs
                  reg_available0) (fun rest -> ret0 ((Inr base1) :: rest))))))

(** val dag_gensym_n : description -> nat -> symbol list Old.Coq_dag.coq_M **)

let rec dag_gensym_n descr = function
| O -> Old.Coq_dag.ret []
| S n4 ->
  Old.Coq_dag.bind (merge_fresh_symbol descr) (fun i ->
    Old.Coq_dag.bind (dag_gensym_n descr n4) (fun rest ->
      Old.Coq_dag.ret (i :: rest)))

type base_var = __

type var = __

(** val simplify_base_var :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> base_var ->
    (equivalenceCheckingError, (idx, idx list) sum list) errorT **)

let rec simplify_base_var t0 = match t0 with
| Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
  (match t1 with
   | Coq3_Compilers.Z -> (fun idx0 -> Success ((Inl (Obj.magic idx0)) :: []))
   | Coq3_Compilers.Coq_bool -> (fun _ -> Error (Invalid_return_type t0))
   | Coq3_Compilers.Coq_nat -> (fun _ -> Error (Invalid_return_type t0))
   | Coq3_Compilers.Coq_zrange -> (fun _ -> Error (Invalid_return_type t0))
   | Coq3_Compilers.Coq_string -> (fun _ -> Error (Invalid_return_type t0)))
| Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
  (fun ab ->
    bind0 (simplify_base_var a (fst (Obj.magic ab))) (fun a0 ->
      bind0 (simplify_base_var b (snd (Obj.magic ab))) (fun b0 -> Success
        (app a0 b0))))
| Compilers.Coq_base.Coq_type.Coq_list a ->
  (match a with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z -> (fun ls -> Success ((Inr (Obj.magic ls)) :: []))
      | Coq3_Compilers.Coq_bool -> (fun _ -> Error (Invalid_return_type t0))
      | Coq3_Compilers.Coq_nat -> (fun _ -> Error (Invalid_return_type t0))
      | Coq3_Compilers.Coq_zrange -> (fun _ -> Error (Invalid_return_type t0))
      | Coq3_Compilers.Coq_string -> (fun _ -> Error (Invalid_return_type t0)))
   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
     (fun _ -> Error (Invalid_return_type t0))
   | Compilers.Coq_base.Coq_type.Coq_list _ ->
     (fun _ -> Error (Invalid_return_type t0))
   | Compilers.Coq_base.Coq_type.Coq_option _ ->
     (fun _ -> Error (Invalid_return_type t0))
   | Compilers.Coq_base.Coq_type.Coq_unit ->
     (fun _ -> Error (Invalid_return_type t0)))
| Compilers.Coq_base.Coq_type.Coq_option _ ->
  (fun _ -> Error (Invalid_return_type t0))
| Compilers.Coq_base.Coq_type.Coq_unit ->
  (fun pat -> let () = Obj.magic pat in Success [])

(** val build_base_var :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> (idx, idx
    list) sum list -> (equivalenceCheckingError, base_var * (idx, idx list)
    sum list) errorT **)

let rec build_base_var t0 indices =
  match t0 with
  | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
    (match t1 with
     | Coq3_Compilers.Z ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | s0 :: indices0 ->
          (match s0 with
           | Inl idx0 -> Success ((Obj.magic idx0), indices0)
           | Inr _ -> Error Incorrect_array_input_dag_node))
     | Coq3_Compilers.Coq_bool ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
     | Coq3_Compilers.Coq_nat ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
     | Coq3_Compilers.Coq_zrange ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
     | Coq3_Compilers.Coq_string ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0))))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    bind0 (build_base_var a indices) (fun vA ->
      let (vA0, indices0) = vA in
      bind0 (build_base_var b indices0) (fun vB ->
        let (vB0, indices1) = vB in Success ((Obj.magic (vA0, vB0)), indices1)))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (match indices with
           | [] ->
             Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base
               t0))
           | s0 :: indices0 ->
             (match s0 with
              | Inl _ -> Error Incorrect_Z_input_dag_node
              | Inr idxs0 -> Success ((Obj.magic idxs0), indices0)))
        | Coq3_Compilers.Coq_bool ->
          (match indices with
           | [] ->
             Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base
               t0))
           | _ :: _ ->
             Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
        | Coq3_Compilers.Coq_nat ->
          (match indices with
           | [] ->
             Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base
               t0))
           | _ :: _ ->
             Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
        | Coq3_Compilers.Coq_zrange ->
          (match indices with
           | [] ->
             Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base
               t0))
           | _ :: _ ->
             Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
        | Coq3_Compilers.Coq_string ->
          (match indices with
           | [] ->
             Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base
               t0))
           | _ :: _ ->
             Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0))))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0)))
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (match indices with
        | [] ->
          Error (Not_enough_input_dag_nodes (Compilers.Coq_type.Coq_base t0))
        | _ :: _ ->
          Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0))))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    Error (Invalid_argument_type (Compilers.Coq_type.Coq_base t0))
  | Compilers.Coq_base.Coq_type.Coq_unit -> Success ((Obj.magic ()), indices)

(** val build_var :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (idx, idx list) sum list ->
    (equivalenceCheckingError, var * (idx, idx list) sum list) errorT **)

let build_var t0 indices =
  match t0 with
  | Compilers.Coq_type.Coq_base t1 -> build_base_var t1 indices
  | Compilers.Coq_type.Coq_arrow (_, _) -> Error (Invalid_argument_type t0)

(** val build_input_var :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (idx, idx list) sum list ->
    (equivalenceCheckingError, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, var)
    Compilers.Coq_type.for_each_lhs_of_arrow * (idx, idx list) sum list)
    errorT **)

let rec build_input_var t0 indices =
  match t0 with
  | Compilers.Coq_type.Coq_base _ -> Success ((Obj.magic ()), indices)
  | Compilers.Coq_type.Coq_arrow (a, b) ->
    bind0 (build_var a indices) (fun vA ->
      let (vA0, indices0) = vA in
      bind0 (build_input_var b indices0) (fun vB ->
        let (vB0, indices1) = vB in Success ((Obj.magic (vA0, vB0)), indices1)))

type symex_T = __

(** val symex_T_return :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> var -> symex_T **)

let symex_T_return = function
| Compilers.Coq_type.Coq_base _ -> Obj.magic symex_return
| Compilers.Coq_type.Coq_arrow (_, _) ->
  (fun _ -> assert false (* absurd case *))

(** val symex_T_error :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> equivalenceCheckingError -> symex_T **)

let rec symex_T_error t0 err0 =
  match t0 with
  | Compilers.Coq_type.Coq_base _ -> Obj.magic symex_error err0
  | Compilers.Coq_type.Coq_arrow (_, d) ->
    Obj.magic (fun _ -> symex_T_error d err0)

(** val symex_T_bind_base :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> 'a1 symexM -> ('a1 -> symex_T) -> symex_T **)

let rec symex_T_bind_base = function
| Compilers.Coq_type.Coq_base _ -> Obj.magic symex_bind
| Compilers.Coq_type.Coq_arrow (_, d) ->
  (fun v f ->
    Obj.magic (fun x -> symex_T_bind_base d v (fun w -> Obj.magic f w x)))

(** val symex_ident :
    Options.symbolic_options_computed_opt -> description ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> symex_T **)

let symex_ident opts descr t0 idc =
  let symex_mod_zrange = fun idx0 pat ->
    let { lower = l; upper = u } = pat in
    let u0 = Coq_Z.succ u in
    let lu = Coq_Z.log2 u0 in
    if (&&) (Coq_Z.eqb l Z0) (Coq_Z.eqb u0 (Coq_Z.pow (Zpos (XO XH)) lu))
    then app1 opts descr ((Slice (N0, (Coq_Z.to_N lu))), (idx0 :: []))
    else symex_error (Unhandled_cast (l, u0))
  in
  (match idc with
   | Coq3_Compilers.Coq_ident_Literal (t1, v) ->
     (match t1 with
      | Coq3_Compilers.Z ->
        (fun v0 -> Obj.magic app1 opts descr ((Const0 (Obj.magic v0)), []))
      | Coq3_Compilers.Coq_bool ->
        (fun _ ->
          symex_T_error (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)) (Unhandled_identifier (t0, idc)))
      | Coq3_Compilers.Coq_nat -> (fun v0 -> Obj.magic symex_return v0)
      | Coq3_Compilers.Coq_zrange -> (fun v0 -> Obj.magic symex_return v0)
      | Coq3_Compilers.Coq_string ->
        (fun _ ->
          symex_T_error (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_string)) (Unhandled_identifier (t0, idc)))) v
   | Coq3_Compilers.Coq_ident_comment _ ->
     Obj.magic (fun _ -> symex_return ())
   | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
     Obj.magic (fun _ -> symex_return ())
   | Coq3_Compilers.Coq_ident_value_barrier -> Obj.magic symex_return
   | Coq3_Compilers.Coq_ident_Nat_succ ->
     Obj.magic (fun v ->
       symex_return
         (Obj.magic Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_succ v))
   | Coq3_Compilers.Coq_ident_Nat_pred ->
     Obj.magic (fun v ->
       symex_return
         (Obj.magic Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_pred v))
   | Coq3_Compilers.Coq_ident_Nat_max ->
     Obj.magic (fun a b ->
       symex_return
         (Obj.magic Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_max a b))
   | Coq3_Compilers.Coq_ident_Nat_mul ->
     Obj.magic (fun a b ->
       symex_return
         (Obj.magic Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_mul a b))
   | Coq3_Compilers.Coq_ident_Nat_add ->
     Obj.magic (fun a b ->
       symex_return
         (Obj.magic Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_add a b))
   | Coq3_Compilers.Coq_ident_Nat_sub ->
     Obj.magic (fun a b ->
       symex_return
         (Obj.magic Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_sub a b))
   | Coq3_Compilers.Coq_ident_Nat_eqb ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_nil _ -> Obj.magic symex_return []
   | Coq3_Compilers.Coq_ident_cons _ ->
     Obj.magic (fun x xs -> symex_return (x :: xs))
   | Coq3_Compilers.Coq_ident_tt -> Obj.magic symex_return ()
   | Coq3_Compilers.Coq_ident_pair (_, _) ->
     Obj.magic (fun a b -> symex_return (a, b))
   | Coq3_Compilers.Coq_ident_fst (_, _) ->
     Obj.magic (fun a -> symex_return (fst a))
   | Coq3_Compilers.Coq_ident_snd (_, _) ->
     Obj.magic (fun a -> symex_return (snd a))
   | Coq3_Compilers.Coq_ident_prod_rect (t1, t2, t3) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t3))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       (t1, t2))), (Compilers.Coq_type.Coq_base t3))))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_bool_rect t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
       (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
       (Compilers.Coq_type.Coq_base t1))))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_bool_rect_nodep t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
       (Compilers.Coq_type.Coq_base t1))))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_nat_rect t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base t1))))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_eager_nat_rect t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base t1))))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_nat_rect_arrow (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))))) (Unhandled_identifier (t0,
       idc))
   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))))) (Unhandled_identifier (t0,
       idc))
   | Coq3_Compilers.Coq_ident_list_rect (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_base t2))))))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_eager_list_rect (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_base t2))))))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_list_rect_arrow (t1, t2, t3) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t3))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base t3))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t3))))))))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t3))))))))) (Unhandled_identifier (t0,
       idc))
   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t1, t2, t3) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t3))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base t3))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t3))))))))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_base t3))))))))) (Unhandled_identifier (t0,
       idc))
   | Coq3_Compilers.Coq_ident_list_case (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_base t2))))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_base t2))))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_List_length _ ->
     Obj.magic (fun ls -> symex_return (length ls))
   | Coq3_Compilers.Coq_ident_List_seq ->
     Obj.magic (fun a b ->
       symex_return
         (Obj.magic Coq3_Compilers.ident_interp (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat))))))) Coq3_Compilers.Coq_ident_List_seq a
           b))
   | Coq3_Compilers.Coq_ident_List_firstn _ ->
     Obj.magic (fun n3 ls -> symex_return (firstn n3 ls))
   | Coq3_Compilers.Coq_ident_List_skipn _ ->
     Obj.magic (fun n3 ls -> symex_return (skipn n3 ls))
   | Coq3_Compilers.Coq_ident_List_repeat _ ->
     Obj.magic (fun v n3 -> symex_return (repeat v n3))
   | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
     Obj.magic (fun ls1 ls2 -> symex_return (combine ls1 ls2))
   | Coq3_Compilers.Coq_ident_List_map (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t2)))))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_List_app _ ->
     Obj.magic (fun ls1 ls2 -> symex_return (app ls1 ls2))
   | Coq3_Compilers.Coq_ident_List_rev _ ->
     Obj.magic (fun ls -> symex_return (rev1 ls))
   | Coq3_Compilers.Coq_ident_List_flat_map (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t2)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t2)))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_List_partition t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_list t1),
       (Compilers.Coq_base.Coq_type.Coq_list t1)))))))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_List_filter t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_List_fold_right (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t2)), (Compilers.Coq_type.Coq_base t1))))))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_List_update_nth t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)))))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_List_nth_default _ ->
     Obj.magic (fun default0 ls n3 ->
       symex_return (nth_default default0 ls n3))
   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
     Obj.magic (fun default0 ls n3 ->
       symex_return (nth_default default0 ls n3))
   | Coq3_Compilers.Coq_ident_Z_add ->
     Obj.magic (fun x y -> app1 opts descr (AddZ, (x :: (y :: []))))
   | Coq3_Compilers.Coq_ident_Z_mul ->
     Obj.magic (fun x y -> app1 opts descr (MulZ, (x :: (y :: []))))
   | Coq3_Compilers.Coq_ident_Z_pow ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_sub ->
     Obj.magic (fun x y ->
       symex_bind (app1 opts descr (NegZ, (y :: []))) (fun y' ->
         app1 opts descr (AddZ, (x :: (y' :: [])))))
   | Coq3_Compilers.Coq_ident_Z_opp ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_div ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_modulo ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_eqb ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_leb ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_ltb ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_geb ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_gtb ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_log2 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_log2_up ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_of_nat ->
     Obj.magic (fun n3 -> app1 opts descr ((Const0 (Coq_Z.of_nat n3)), []))
   | Coq3_Compilers.Coq_ident_Z_to_nat ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_shiftr ->
     Obj.magic (fun x y -> app1 opts descr (ShrZ, (x :: (y :: []))))
   | Coq3_Compilers.Coq_ident_Z_shiftl ->
     Obj.magic (fun x y -> app1 opts descr (ShlZ, (x :: (y :: []))))
   | Coq3_Compilers.Coq_ident_Z_land ->
     Obj.magic (fun x y -> app1 opts descr (AndZ, (x :: (y :: []))))
   | Coq3_Compilers.Coq_ident_Z_lor ->
     Obj.magic (fun x y -> app1 opts descr (OrZ, (x :: (y :: []))))
   | Coq3_Compilers.Coq_ident_Z_min ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_max ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_mul_split ->
     Obj.magic (fun bs x y ->
       symex_bind (revealWidth bs) (fun vs ->
         symex_bind (app1 opts descr ((Const0 (Coq_Z.of_N vs)), []))
           (fun s0 ->
           symex_bind (app1 opts descr (MulZ, (x :: (y :: [])))) (fun v ->
             symex_bind (app1 opts descr ((Slice (N0, vs)), (v :: [])))
               (fun lo ->
               symex_bind (app1 opts descr (ShrZ, (v :: (s0 :: []))))
                 (fun hi -> symex_return (lo, hi)))))))
   | Coq3_Compilers.Coq_ident_Z_mul_high ->
     Obj.magic (fun bs x y ->
       symex_bind (revealWidth bs) (fun vs ->
         symex_bind (app1 opts descr ((Const0 (Coq_Z.of_N vs)), []))
           (fun s0 ->
           symex_bind (app1 opts descr (MulZ, (x :: (y :: [])))) (fun v ->
             app1 opts descr (ShrZ, (v :: (s0 :: [])))))))
   | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
     Obj.magic (fun s0 x y ->
       symex_bind (revealWidth s0) (fun s1 ->
         symex_bind (app1 opts descr ((Add0 s1), (x :: (y :: [])))) (fun a ->
           symex_bind (app1 opts descr ((AddcarryZ s1), (x :: (y :: []))))
             (fun c0 -> symex_return (a, c0)))))
   | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
     Obj.magic (fun x y z0 ->
       app1 opts descr (AddZ, (x :: (y :: (z0 :: [])))))
   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
     Obj.magic (fun s0 x y z0 ->
       symex_bind (revealWidth s0) (fun s1 ->
         symex_bind (app1 opts descr ((Add0 s1), (x :: (y :: (z0 :: [])))))
           (fun a ->
           symex_bind
             (app1 opts descr ((AddcarryZ s1), (x :: (y :: (z0 :: [])))))
             (fun c0 -> symex_return (a, c0)))))
   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
     Obj.magic (fun s0 x y ->
       symex_bind (revealWidth s0) (fun s1 ->
         symex_bind (app1 opts descr ((Neg1 s1), (y :: []))) (fun y' ->
           symex_bind (app1 opts descr ((Add0 s1), (x :: (y' :: []))))
             (fun a ->
             symex_bind (app1 opts descr ((SubborrowZ s1), (x :: (y :: []))))
               (fun c0 -> symex_return (a, c0))))))
   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
     Obj.magic (fun s0 z0 x y ->
       symex_bind (revealWidth s0) (fun s1 ->
         symex_bind (app1 opts descr ((Neg1 s1), (y :: []))) (fun y' ->
           symex_bind (app1 opts descr ((Neg1 s1), (z0 :: []))) (fun z' ->
             symex_bind
               (app1 opts descr ((Add0 s1), (x :: (y' :: (z' :: [])))))
               (fun a ->
               symex_bind
                 (app1 opts descr ((SubborrowZ s1), (x :: (y :: (z0 :: [])))))
                 (fun c0 -> symex_return (a, c0)))))))
   | Coq3_Compilers.Coq_ident_Z_ltz ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_zselect ->
     Obj.magic (fun c0 x y ->
       app1 opts descr (Selectznz, (c0 :: (x :: (y :: [])))))
   | Coq3_Compilers.Coq_ident_Z_add_modulo ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
     Obj.magic (fun s0 x y ->
       symex_bind (revealConstant s0) (fun s1 ->
         app1 opts descr ((Shl0 s1), (x :: (y :: [])))))
   | Coq3_Compilers.Coq_ident_Z_bneg ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_lxor ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_rshi ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_cc_m ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Z_cast ->
     Obj.magic (fun r0 v_idx ->
       symex_bind (symex_mod_zrange v_idx r0) symex_return)
   | Coq3_Compilers.Coq_ident_Z_cast2 ->
     Obj.magic (fun pat ->
       let (r1, r2) = pat in
       (fun pat0 ->
       let (v1_idx, v2_idx) = pat0 in
       symex_bind (symex_mod_zrange v1_idx r1) (fun idx1 ->
         symex_bind (symex_mod_zrange v2_idx r2) (fun idx2 ->
           symex_return (idx1, idx2)))))
   | Coq3_Compilers.Coq_ident_Some t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_option t1)))) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_None t1 ->
     symex_T_error (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_option t1)) (Unhandled_identifier
       (t0, idc))
   | Coq3_Compilers.Coq_ident_option_rect (t1, t2) ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_option t1)),
       (Compilers.Coq_type.Coq_base t2))))))) (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_Build_zrange ->
     Obj.magic (fun _ _ -> symex_error (Unhandled_identifier (t0, idc)))
   | Coq3_Compilers.Coq_ident_zrange_rect t1 ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t1)))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_add ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_addc ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_sub ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_subb ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_mulll ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_mullh ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_mulhl ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_mulhh ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_rshi ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_selc ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_selm ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_sell ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc))
   | Coq3_Compilers.Coq_ident_fancy_addm ->
     symex_T_error (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
       (Unhandled_identifier (t0, idc)))

(** val symex_expr :
    Options.symbolic_options_computed_opt -> description ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, var)
    Compilers.Coq_expr.expr -> symex_T **)

let rec symex_expr opts descr _ e =
  let x = fun _ -> Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
  in
  (match e with
   | Compilers.Coq_expr.Ident (t0, idc) -> symex_ident opts descr t0 idc
   | Compilers.Coq_expr.Var (t0, v) -> symex_T_return t0 v
   | Compilers.Coq_expr.Abs (s0, d, f) ->
     (match s0 with
      | Compilers.Coq_type.Coq_base _ ->
        (fun f0 -> Obj.magic (fun v -> symex_expr opts descr d (f0 v)))
      | Compilers.Coq_type.Coq_arrow (_, _) ->
        (fun _ -> Obj.magic (fun _ -> assert false (* absurd case *)))) f
   | Compilers.Coq_expr.App (s0, d, f, x0) ->
     (match s0 with
      | Compilers.Coq_type.Coq_base t0 ->
        (fun f0 x1 ->
          let ef =
            symex_expr opts descr (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), d)) f0
          in
          let ex = symex_expr opts descr (Compilers.Coq_type.Coq_base t0) x1
          in
          symex_T_bind_base d (Obj.magic ex) (Obj.magic ef))
      | Compilers.Coq_type.Coq_arrow (s1, d0) ->
        (fun f0 x1 ->
          symex_T_error d (Invalid_higher_order_application
            ((Compilers.Coq_type.Coq_arrow (s1, d0)), d, f0, x1)))) f x0
   | Compilers.Coq_expr.LetIn (a, b, x0, f) ->
     (match a with
      | Compilers.Coq_type.Coq_base t0 ->
        (fun x1 f0 ->
          let ef = fun v -> symex_expr opts descr b (f0 v) in
          let ex =
            symex_expr opts (Some ((fun pat ->
              let () = pat in show0 (x __ (Compilers.Coq_type.Coq_base t0)) x1),
              false)) (Compilers.Coq_type.Coq_base t0) x1
          in
          symex_T_bind_base b (Obj.magic ex) ef)
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun x1 _ ->
          symex_T_error b (Invalid_higher_order_let
            ((Compilers.Coq_type.Coq_arrow (s0, d)), x1)))) x0 f)

(** val symex_PHOAS_PHOAS :
    Options.symbolic_options_computed_opt -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, var)
    Compilers.Coq_type.for_each_lhs_of_arrow -> Old.Coq_dag.t ->
    (equivalenceCheckingError, base_var * Old.Coq_dag.t) errorT **)

let symex_PHOAS_PHOAS opts t0 expr1 input_var_data d =
  let ast =
    Compilers.Coq_invert_expr.smart_App_curried t0 (expr1 __) input_var_data
  in
  Obj.magic symex_expr opts None (Compilers.Coq_type.Coq_base
    (Compilers.Coq_type.final_codomain t0)) ast d

(** val symex_PHOAS :
    Options.symbolic_options_computed_opt -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (idx, idx list) sum
    list -> Old.Coq_dag.t -> (equivalenceCheckingError, (idx, idx list) sum
    list * Old.Coq_dag.t) errorT **)

let symex_PHOAS opts t0 expr1 inputs d =
  bind0 (build_input_var t0 inputs) (fun input_var_data ->
    let (input_var_data0, unused_inputs) = input_var_data in
    bind0
      (if Nat.eqb (length unused_inputs) O
       then Success ()
       else Error (Internal_error_extra_input_arguments (t0, unused_inputs)))
      (fun _ ->
      bind0 (symex_PHOAS_PHOAS opts t0 expr1 input_var_data0 d)
        (fun symevaled_PHOAS ->
        let (pHOAS_output, d0) = symevaled_PHOAS in
        bind0
          (simplify_base_var (Compilers.Coq_type.final_codomain t0)
            pHOAS_output) (fun pHOAS_output0 -> Success (pHOAS_output0, d0)))))

(** val init_symbolic_state_descr : description **)

let init_symbolic_state_descr =
  Some ((fun pat ->
    let () = pat in
    'i'::('n'::('i'::('t'::('_'::('s'::('y'::('m'::('b'::('o'::('l'::('i'::('c'::('_'::('s'::('t'::('a'::('t'::('e'::[]))))))))))))))))))),
    true)

(** val init_symbolic_state : Old.Coq_dag.t -> symbolic_state **)

let init_symbolic_state d =
  let (initial_reg_idxs, d0) =
    dag_gensym_n init_symbolic_state_descr (S (S (S (S (S (S (S (S (S (S (S
      (S (S (S (S (S O)))))))))))))))) d
  in
  { dag_state = d0; symbolic_reg_state =
  (from_list_default None (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
    O)))))))))))))))) (map (fun x -> Some x) initial_reg_idxs));
  symbolic_flag_state = (repeat1 None (S (S (S (S (S (S O)))))));
  symbolic_mem_state = [] }

(** val compute_stack_base :
    Options.symbolic_options_computed_opt -> description -> nat -> idx m **)

let compute_stack_base opts descr stack_size =
  bind2 (setRegFresh opts descr Rsp) (fun rsp_val ->
    bind2
      (app0 opts descr
        ((zconst (Npos (XO (XO (XO (XO (XO (XO XH)))))))
           (Coq_Z.mul (Zneg (XO (XO (XO XH)))) (Coq_Z.of_nat stack_size))),
        [])) (fun stack_size0 ->
      app0 opts descr ((Add0 (Npos (XO (XO (XO (XO (XO (XO XH)))))))),
        (rsp_val :: (stack_size0 :: [])))))

(** val build_merge_stack_placeholders :
    Options.symbolic_options_computed_opt -> description -> nat -> idx m **)

let build_merge_stack_placeholders opts descr stack_size =
  bind2 (lift_dag (build_inputarray descr stack_size))
    (fun stack_placeholders ->
    bind2 (compute_stack_base opts descr stack_size) (fun stack_base ->
      bind2
        (build_merge_array_addresses opts descr stack_base stack_placeholders)
        (fun _ -> ret0 stack_base)))

(** val loadArray :
    Options.symbolic_options_computed_opt -> description -> idx -> nat -> idx
    list m **)

let loadArray opts descr base1 len =
  mapM (fun i -> bind2 (compute_array_address opts descr base1 i) remove64)
    (seq O len)

(** val loadOutputs_internal :
    Options.symbolic_options_computed_opt -> description -> bool -> ((rEG,
    idx) sum, idx) sum list -> type_spec -> (idx, idx list) sum list m **)

let loadOutputs_internal opts descr dereference_scalar outputaddrs output_types =
  mapM (fun pat ->
    let (ocells, spec0) = pat in
    (match ocells with
     | Inl addr ->
       (match spec0 with
        | Some _ -> err (Coq_error.Coq_unsupported_memory_access_size N0)
        | None ->
          bind2
            (match addr with
             | Inl r0 ->
               if dereference_scalar
               then err (Coq_error.Coq_unsupported_memory_access_size N0)
               else getReg opts descr r0
             | Inr addr0 ->
               if dereference_scalar
               then remove64 addr0
               else err (Coq_error.Coq_unsupported_memory_access_size N0))
            (fun v -> ret0 (Inl v)))
     | Inr base1 ->
       (match spec0 with
        | Some len ->
          bind2 (loadArray opts descr base1 len) (fun v -> ret0 (Inr v))
        | None -> err (Coq_error.Coq_unsupported_memory_access_size N0))))
    (combine outputaddrs output_types)

(** val loadOutputs :
    Options.symbolic_options_computed_opt -> description -> bool -> ((rEG,
    idx) sum, idx) sum list -> type_spec -> (equivalenceCheckingError, (idx,
    idx list) sum list) errorT m **)

let loadOutputs opts descr dereference_scalar outputaddrs output_types s0 =
  if Nat.eqb (length outputaddrs) (length output_types)
  then (match loadOutputs_internal opts descr dereference_scalar outputaddrs
                output_types s0 with
        | Success v0 -> let (v, s1) = v0 in Success ((Success v), s1)
        | Error msg ->
          let (err0, s1) = msg in
          Success ((Error (Internal_error_output_load_failed
          ((match err0 with
            | Coq_error.Coq_get_flag (_, _) -> Some err0
            | Coq_error.Coq_get_reg (_, _) -> Some err0
            | Coq_error.Coq_load (_, _) -> Some err0
            | Coq_error.Coq_remove (_, _) -> Some err0
            | Coq_error.Coq_remove_has_duplicates (_, _, _) -> Some err0
            | Coq_error.Coq_store (_, _, _) -> Some err0
            | Coq_error.Coq_set_const (_, _) -> Some err0
            | Coq_error.Coq_expected_const (_, _) -> Some err0
            | Coq_error.Coq_unsupported_memory_access_size n3 ->
              (match n3 with
               | N0 -> None
               | Npos _ -> Some err0)
            | Coq_error.Coq_unsupported_label_in_memory _ -> Some err0
            | Coq_error.Coq_unsupported_label_argument _ -> Some err0
            | Coq_error.Coq_unimplemented_prefix _ -> Some err0
            | Coq_error.Coq_unimplemented_instruction _ -> Some err0
            | Coq_error.Coq_unsupported_line _ -> Some err0
            | Coq_error.Coq_ambiguous_operation_size _ -> Some err0),
          outputaddrs, s1))), s1))
  else Success ((Error (Internal_error_LoadOutputs_length_mismatch
         (outputaddrs, output_types))), s0)

(** val symex_asm_func_M :
    Options.symbolic_options_computed_opt -> bool -> rEG list -> type_spec ->
    nat -> (idx, idx list) sum list -> rEG list -> lines ->
    (equivalenceCheckingError, (idx, idx list) sum list) errorT m **)

let symex_asm_func_M opts =
  let dereference_input_scalars = false in
  (fun dereference_output_scalars callee_saved_registers output_types stack_size inputs reg_available asm ->
  bind2
    (lift_dag
      (build_inputs (Some ((fun pat ->
        let () = pat in
        'o'::('u'::('t'::('p'::('u'::('t'::('_'::('p'::('l'::('a'::('c'::('e'::('h'::('o'::('l'::('d'::('e'::('r'::('s'::[]))))))))))))))))))),
        true)) output_types)) (fun output_placeholders ->
    let n_outputs = length output_placeholders in
    bind2
      (build_merge_base_addresses opts (Some ((fun pat ->
        let () = pat in
        'i'::('n'::('p'::('u'::('t'::('a'::('d'::('d'::('r'::('s'::[])))))))))),
        true)) dereference_input_scalars inputs
        (skipn n_outputs reg_available)) (fun inputaddrs ->
      bind2
        (build_merge_base_addresses opts (Some ((fun pat ->
          let () = pat in
          'o'::('u'::('t'::('p'::('u'::('t'::('a'::('d'::('d'::('r'::('s'::[]))))))))))),
          true)) dereference_output_scalars output_placeholders
          (firstn n_outputs reg_available)) (fun outputaddrs ->
        bind2
          (build_merge_stack_placeholders opts (Some ((fun pat ->
            let () = pat in
            's'::('t'::('a'::('c'::('k'::('_'::('b'::('a'::('s'::('e'::[])))))))))),
            true)) stack_size) (fun stack_base ->
          bind2
            (mapM
              (getReg opts (Some ((fun pat ->
                let () = pat in
                'i'::('n'::('i'::('t'::('i'::('a'::('l'::('_'::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('_'::('v'::('a'::('l'::('u'::('e'::('s'::[]))))))))))))))))))))))),
                true))) callee_saved_registers)
            (fun initial_register_values ->
            bind2 (symexLines opts asm) (fun _ ->
              bind2
                (mapM
                  (getReg opts (Some ((fun pat ->
                    let () = pat in
                    'f'::('i'::('n'::('a'::('l'::('_'::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('_'::('v'::('a'::('l'::('u'::('e'::('s'::[]))))))))))))))))))))),
                    true))) callee_saved_registers)
                (fun final_register_values ->
                bind2
                  (loadArray opts (Some ((fun pat ->
                    let () = pat in
                    'l'::('o'::('a'::('d'::(' '::('f'::('i'::('n'::('a'::('l'::(' '::('s'::('t'::('a'::('c'::('k'::[])))))))))))))))),
                    true)) stack_base stack_size) (fun _ ->
                  let unsaved_registers =
                    filter (fun pat ->
                      let (_, y) = pat in
                      let (init, final) = y in negb (Coq_N.eqb init final))
                      (combine callee_saved_registers
                        (combine initial_register_values
                          final_register_values))
                  in
                  bind2
                    (loadOutputs opts (Some ((fun pat ->
                      let () = pat in
                      'a'::('s'::('m'::('_'::('o'::('u'::('t'::('p'::('u'::('t'::[])))))))))),
                      true)) dereference_output_scalars outputaddrs
                      output_types) (fun asm_output ->
                    let input_types =
                      map (fun v ->
                        match v with
                        | Inl _ -> None
                        | Inr ls -> Some (length ls)) inputs
                    in
                    bind2
                      (loadOutputs opts (Some ((fun pat ->
                        let () = pat in
                        'a'::('s'::('m'::('_'::('i'::('n'::('p'::('u'::('t'::(' '::('<'::('-'::(' '::('L'::('o'::('a'::('d'::('O'::('u'::('t'::('p'::('u'::('t'::('s'::[])))))))))))))))))))))))),
                        true)) dereference_input_scalars inputaddrs
                        input_types) (fun asm_input s0 -> Success
                      ((match asm_output with
                        | Success asm_output0 ->
                          (match asm_input with
                           | Success _ ->
                             (match unsaved_registers with
                              | [] ->
                                (match s0.symbolic_mem_state with
                                 | [] -> Success asm_output0
                                 | _ :: _ ->
                                   Error (Internal_error_lingering_memory s0))
                              | _ :: _ ->
                                Error (Registers_not_saved
                                  (unsaved_registers, s0)))
                           | Error err0 -> Error err0)
                        | Error err0 -> Error err0), s0))))))))))))

(** val symex_asm_func :
    Options.symbolic_options_computed_opt -> bool -> Old.Coq_dag.t -> rEG
    list -> type_spec -> nat -> (idx, idx list) sum list -> rEG list -> lines
    -> (equivalenceCheckingError, (idx, idx list) sum list * symbolic_state)
    errorT **)

let symex_asm_func opts dereference_output_scalars d callee_saved_registers output_types stack_size inputs reg_available asm =
  let num_reg_given = length reg_available in
  let num_reg_needed = add (length inputs) (length output_types) in
  if Nat.ltb num_reg_given num_reg_needed
  then Error (Not_enough_registers (num_reg_given, num_reg_needed))
  else let register_wide_enough = fun reg ->
         Coq_N.eqb (reg_size reg) (Npos (XO (XO (XO (XO (XO (XO XH)))))))
       in
       if negb (forallb register_wide_enough reg_available)
       then Error (Registers_too_narrow
              (filter (fun reg -> negb (register_wide_enough reg))
                reg_available))
       else if negb (forallb register_wide_enough callee_saved_registers)
            then Error (Callee_saved_registers_too_narrow
                   (filter (fun reg -> negb (register_wide_enough reg))
                     callee_saved_registers))
            else if negb
                      (list_beq rEG_beq
                        (remove_duplicates rEG_beq reg_available)
                        reg_available)
                 then Error (Duplicate_registers
                        (find_duplicates rEG_beq reg_available))
                 else (match symex_asm_func_M opts dereference_output_scalars
                               callee_saved_registers output_types stack_size
                               inputs reg_available asm
                               (init_symbolic_state d) with
                       | Success v ->
                         let (e, s0) = v in
                         (match e with
                          | Success asm_output -> Success (asm_output, s0)
                          | Error err0 -> Error err0)
                       | Error msg ->
                         let (e, s0) = msg in
                         Error (Symbolic_execution_failed (e, s0)))

(** val strip_ret : lines -> (equivalenceCheckingError, line list) errorT **)

let strip_ret asm =
  let isinstr = fun l ->
    match l.rawline with
    | SECTION _ -> false
    | GLOBAL _ -> false
    | LABEL _ -> false
    | ALIGN _ -> false
    | DEFAULT_REL -> false
    | EMPTY -> false
    | INSTR _ -> true
  in
  let notret = fun l ->
    match l.rawline with
    | SECTION _ -> true
    | GLOBAL _ -> true
    | LABEL _ -> true
    | ALIGN _ -> true
    | DEFAULT_REL -> true
    | EMPTY -> true
    | INSTR instr ->
      let op1 = instr.op in
      let args0 = instr.args in
      (match op1 with
       | Adc -> true
       | Adcx -> true
       | Add -> true
       | Adox -> true
       | And -> true
       | Bzhi -> true
       | Call -> true
       | Clc -> true
       | Cmovb -> true
       | Cmovc -> true
       | Cmovnz -> true
       | Cmovo -> true
       | Cmp -> true
       | Db0 -> true
       | Dd0 -> true
       | Dec -> true
       | Dq -> true
       | Dw -> true
       | Imul -> true
       | Inc -> true
       | Je -> true
       | Jmp -> true
       | Lea -> true
       | Mov -> true
       | Movzx -> true
       | Mul -> true
       | Mulx -> true
       | Or -> true
       | Pop -> true
       | Push -> true
       | Rcr -> true
       | Ret -> (match args0 with
                 | [] -> false
                 | _ :: _ -> true)
       | Sar -> true
       | Sbb -> true
       | Setc -> true
       | Seto -> true
       | Shl -> true
       | Shlx -> true
       | Shr -> true
       | Shrx -> true
       | Shrd -> true
       | Sub -> true
       | Test -> true
       | Xchg -> true
       | Xor -> true)
  in
  (match dropWhile notret asm with
   | [] -> Error Missing_ret
   | _ :: trailer ->
     if existsb isinstr trailer
     then Error (Code_after_ret ((filter isinstr trailer), trailer))
     else Success (takeWhile notret asm))

(** val check_equivalence :
    Options.symbolic_options_computed_opt -> assembly_calling_registers_opt
    -> assembly_stack_size_opt -> assembly_callee_saved_registers_opt ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (char list * lines) list ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    ((char list * lines) option * equivalenceCheckingError, unit) errorT **)

let check_equivalence symbolic_opts assembly_calling_registers' assembly_stack_size' assembly_callee_saved_registers' t0 asm expr1 arg_bounds0 out_bounds1 =
  let reg_available = assembly_calling_registers assembly_calling_registers'
  in
  bind0 (map_error (fun e -> (None, e)) (simplify_input_type t0 arg_bounds0))
    (fun input_types ->
    bind0
      (map_error (fun e -> (None, e))
        (simplify_base_type (Compilers.Coq_type.final_codomain t0)
          out_bounds1)) (fun output_types ->
      let (inputs, d) =
        build_inputs (Some ((fun pat ->
          let () = pat in
          'b'::('u'::('i'::('l'::('d'::('_'::('i'::('n'::('p'::('u'::('t'::('s'::[])))))))))))),
          true)) input_types Old.Coq_dag.empty
      in
      bind0
        (map_error (fun e -> (None, e))
          (symex_PHOAS symbolic_opts t0 expr1 inputs d)) (fun pHOAS_output ->
        let (pHOAS_output0, d0) = pHOAS_output in
        let first_new_idx_after_all_old_idxs = Some (Old.Coq_dag.size d0) in
        ErrorT.List.bind_list
          (map (fun label ->
            let (_, asm0) = label in
            bind0 (map_error (fun e -> ((Some label), e)) (strip_ret asm0))
              (fun asm1 ->
              let stack_size =
                Coq_N.to_nat
                  (assembly_stack_size assembly_callee_saved_registers'
                    assembly_stack_size' asm1)
              in
              bind0
                (map_error (fun e -> ((Some label), e))
                  (symex_asm_func symbolic_opts false d0
                    (assembly_callee_saved_registers
                      assembly_callee_saved_registers') output_types
                    stack_size inputs reg_available asm1))
                (fun symevaled_asm ->
                let (asm_output, s0) = symevaled_asm in
                if list_beq (sum_beq Coq_N.eqb (list_beq Coq_N.eqb))
                     asm_output pHOAS_output0
                then Success ()
                else Error ((Some label), (Unable_to_unify (asm_output,
                       pHOAS_output0, first_new_idx_after_all_old_idxs, s0))))))
            asm) (fun _ -> Success ()))))

(** val generate_assembly_of_hinted_expr :
    Options.symbolic_options_computed_opt -> assembly_calling_registers_opt
    -> assembly_stack_size_opt -> assembly_callee_saved_registers_opt ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (char list * lines) list ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    ((char list * lines) option * equivalenceCheckingError,
    (char list * lines) list) errorT **)

let generate_assembly_of_hinted_expr symbolic_opts assembly_calling_registers' assembly_stack_size' assembly_callee_saved_registers' t0 asm expr1 arg_bounds0 out_bounds1 =
  match check_equivalence symbolic_opts assembly_calling_registers'
          assembly_stack_size' assembly_callee_saved_registers' t0 asm expr1
          arg_bounds0 out_bounds1 with
  | Success v -> let () = v in Success asm
  | Error err0 -> Error err0

(** val parse_term_of_Qexpr : empty_set qexpr_poly -> (z * z) option **)

let rec parse_term_of_Qexpr v = match v with
| Qvar _ -> assert false (* absurd case *)
| Qv x -> bind (q_to_Z_strict x) (fun q0 -> Some ((Zpos XH), q0))
| Qeopp a ->
  bind (parse_term_of_Qexpr a) (fun v0 -> Some ((fst v0),
    (Coq_Z.opp (snd v0))))
| Qeadd (_, _) -> None
| Qesub (_, _) -> None
| Qemul (a, b) ->
  bind (parse_term_of_Qexpr b) (fun b0 ->
    bind (eval_Qexpr_strict a) (fun a0 ->
      bind (q_to_Z_strict a0) (fun a1 -> Some ((fst b0),
        (Coq_Z.mul a1 (snd b0))))))
| Qediv (_, _) -> None
| Qepow (_, _) ->
  bind (eval_Qexpr_strict v) (fun v0 ->
    bind (q_to_Z_strict v0) (fun v1 -> Some (v1, (Zpos XH))))

(** val qexpr_to_add_list :
    empty_set qexpr_poly -> empty_set qexpr_poly list **)

let rec qexpr_to_add_list v = match v with
| Qvar _ -> v :: []
| Qv _ -> v :: []
| Qeopp _ -> v :: []
| Qeadd (a, b) -> app (qexpr_to_add_list a) (qexpr_to_add_list b)
| Qesub (a, b) -> app (qexpr_to_add_list a) ((Qeopp b) :: [])
| Qemul (_, _) -> v :: []
| Qediv (_, _) -> v :: []
| Qepow (_, _) -> v :: []

(** val parse_prime_and_taps_of_Qexpr :
    empty_set qexpr_poly -> (z * (z * z) list) option **)

let parse_prime_and_taps_of_Qexpr v =
  match qexpr_to_add_list v with
  | [] -> None
  | p :: taps ->
    bind
      (Option.List.lift (map (fun v0 -> parse_term_of_Qexpr (Qeopp v0)) taps))
      (fun taps0 ->
      bind (eval_Qexpr_strict p) (fun p0 ->
        bind (q_to_Z_strict p0) (fun p1 -> Some (p1, taps0))))

(** val parseZ_arith_to_taps : char list -> (z * (z * z) list) option **)

let parseZ_arith_to_taps s0 =
  bind (parseQexpr_arith s0) parse_prime_and_taps_of_Qexpr

module Coq1_Raw =
 functor (X:Coq_OrderedType) ->
 struct
  module MX = Coq_OrderedTypeFacts(X)

  module PX = KeyOrderedType(X)

  type key = X.t

  type 'elt t = (X.t * 'elt) list

  (** val empty : 'a1 t **)

  let empty =
    []

  (** val is_empty : 'a1 t -> bool **)

  let is_empty = function
  | [] -> true
  | _ :: _ -> false

  (** val mem : key -> 'a1 t -> bool **)

  let mem k =
    let rec mem0 k0 = function
    | [] -> false
    | p :: l ->
      let (k', _) = p in
      (match X.compare k0 k' with
       | LT -> false
       | EQ -> true
       | GT -> mem0 k0 l)
    in mem0 k

  (** val find : key -> 'a1 t -> 'a1 option **)

  let find k =
    let rec find0 k0 = function
    | [] -> None
    | p :: s' ->
      let (k', x) = p in
      (match X.compare k0 k' with
       | LT -> None
       | EQ -> Some x
       | GT -> find0 k0 s')
    in find0 k

  (** val add : key -> 'a1 -> 'a1 t -> 'a1 t **)

  let add k =
    let rec add0 k0 x s0 = match s0 with
    | [] -> (k0, x) :: []
    | p :: l ->
      let (k', y) = p in
      (match X.compare k0 k' with
       | LT -> (k0, x) :: s0
       | EQ -> (k0, x) :: l
       | GT -> (k', y) :: (add0 k0 x l))
    in add0 k

  (** val remove : key -> 'a1 t -> 'a1 t **)

  let remove k =
    let rec remove2 k0 s0 = match s0 with
    | [] -> []
    | p :: l ->
      let (k', x) = p in
      (match X.compare k0 k' with
       | LT -> s0
       | EQ -> l
       | GT -> (k', x) :: (remove2 k0 l))
    in remove2 k

  (** val elements : 'a1 t -> 'a1 t **)

  let elements m4 =
    m4

  (** val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 **)

  let fold f m4 acc =
    let rec fold0 _ f0 m5 acc0 =
      match m5 with
      | [] -> acc0
      | p :: m'0 -> let (k, e) = p in fold0 __ f0 m'0 (f0 k e acc0)
    in fold0 __ f m4 acc

  (** val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool **)

  let equal cmp0 =
    let rec equal0 cmp1 m4 m'0 =
      match m4 with
      | [] -> (match m'0 with
               | [] -> true
               | _ :: _ -> false)
      | p :: l ->
        let (x, e) = p in
        (match m'0 with
         | [] -> false
         | p0 :: l' ->
           let (x', e') = p0 in
           (match X.compare x x' with
            | LT -> false
            | EQ -> (&&) (cmp1 e e') (equal0 cmp1 l l')
            | GT -> false))
    in equal0 cmp0

  (** val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t **)

  let map f =
    let rec map6 f0 = function
    | [] -> []
    | p :: m'0 -> let (k, e) = p in (k, (f0 e)) :: (map6 f0 m'0)
    in map6 f

  (** val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t **)

  let mapi f =
    let rec mapi0 f0 = function
    | [] -> []
    | p :: m'0 -> let (k, e) = p in (k, (f0 k e)) :: (mapi0 f0 m'0)
    in mapi0 f

  (** val option_cons :
      key -> 'a1 option -> (key * 'a1) list -> (key * 'a1) list **)

  let option_cons k o l =
    match o with
    | Some e -> (k, e) :: l
    | None -> l

  (** val map2_l :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a3 t **)

  let map2_l f =
    let rec map2_l0 = function
    | [] -> []
    | p :: l -> let (k, e) = p in option_cons k (f (Some e) None) (map2_l0 l)
    in map2_l0

  (** val map2_r :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a2 t -> 'a3 t **)

  let map2_r f =
    let rec map2_r0 = function
    | [] -> []
    | p :: l' ->
      let (k, e') = p in option_cons k (f None (Some e')) (map2_r0 l')
    in map2_r0

  (** val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t **)

  let map2 f =
    let rec map6 m4 = match m4 with
    | [] -> map2_r f
    | p :: l ->
      let (k, e) = p in
      let rec map2_aux m'0 = match m'0 with
      | [] -> map2_l f m4
      | p0 :: l' ->
        let (k', e') = p0 in
        (match X.compare k k' with
         | LT -> option_cons k (f (Some e) None) (map6 l m'0)
         | EQ -> option_cons k (f (Some e) (Some e')) (map6 l l')
         | GT -> option_cons k' (f None (Some e')) (map2_aux l'))
      in map2_aux
    in map6

  (** val combine : 'a1 t -> 'a2 t -> ('a1 option * 'a2 option) t **)

  let combine m4 =
    let rec combine1 m5 = match m5 with
    | [] -> map (fun e' -> (None, (Some e')))
    | p :: l ->
      let (k, e) = p in
      let rec combine_aux m'0 = match m'0 with
      | [] -> map (fun e0 -> ((Some e0), None)) m5
      | p0 :: l' ->
        let (k', e') = p0 in
        (match X.compare k k' with
         | LT -> (k, ((Some e), None)) :: (combine1 l m'0)
         | EQ -> (k, ((Some e), (Some e'))) :: (combine1 l l')
         | GT -> (k', (None, (Some e'))) :: (combine_aux l'))
      in combine_aux
    in combine1 m4

  (** val fold_right_pair :
      ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3 **)

  let fold_right_pair f l i =
    fold_right (fun p -> f (fst p) (snd p)) i l

  (** val map2_alt :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t ->
      (key * 'a3) list **)

  let map2_alt f m4 m'0 =
    let m5 = combine m4 m'0 in
    let m6 = map (fun p -> f (fst p) (snd p)) m5 in
    fold_right_pair option_cons m6 []

  (** val at_least_one :
      'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option **)

  let at_least_one o o' =
    match o with
    | Some _ -> Some (o, o')
    | None -> (match o' with
               | Some _ -> Some (o, o')
               | None -> None)

  (** val at_least_one_then_f :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option ->
      'a3 option **)

  let at_least_one_then_f f o o' =
    match o with
    | Some _ -> f o o'
    | None -> (match o' with
               | Some _ -> f o o'
               | None -> None)
 end

module type Int =
 sig
  type t

  val i2z : t -> z

  val _0 : t

  val _1 : t

  val _2 : t

  val _3 : t

  val add : t -> t -> t

  val opp : t -> t

  val sub : t -> t -> t

  val mul : t -> t -> t

  val max : t -> t -> t

  val eqb : t -> t -> bool

  val ltb : t -> t -> bool

  val leb : t -> t -> bool

  val gt_le_dec : t -> t -> bool

  val ge_lt_dec : t -> t -> bool

  val eq_dec : t -> t -> bool
 end

module MoreInt =
 functor (I:Int) ->
 struct
  type coq_ExprI =
  | EI0
  | EI1
  | EI2
  | EI3
  | EIadd of coq_ExprI * coq_ExprI
  | EIopp of coq_ExprI
  | EIsub of coq_ExprI * coq_ExprI
  | EImul of coq_ExprI * coq_ExprI
  | EImax of coq_ExprI * coq_ExprI
  | EIraw of I.t

  (** val coq_ExprI_rect :
      'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
      'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
      (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) ->
      coq_ExprI -> 'a1 **)

  let coq_ExprI_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 =
    let rec f9 = function
    | EI0 -> f
    | EI1 -> f0
    | EI2 -> f1
    | EI3 -> f2
    | EIadd (e0, e1) -> f3 e0 (f9 e0) e1 (f9 e1)
    | EIopp e0 -> f4 e0 (f9 e0)
    | EIsub (e0, e1) -> f5 e0 (f9 e0) e1 (f9 e1)
    | EImul (e0, e1) -> f6 e0 (f9 e0) e1 (f9 e1)
    | EImax (e0, e1) -> f7 e0 (f9 e0) e1 (f9 e1)
    | EIraw t0 -> f8 t0
    in f9

  (** val coq_ExprI_rec :
      'a1 -> 'a1 -> 'a1 -> 'a1 -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 ->
      'a1) -> (coq_ExprI -> 'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) ->
      (coq_ExprI -> 'a1 -> coq_ExprI -> 'a1 -> 'a1) -> (I.t -> 'a1) ->
      coq_ExprI -> 'a1 **)

  let coq_ExprI_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 =
    let rec f9 = function
    | EI0 -> f
    | EI1 -> f0
    | EI2 -> f1
    | EI3 -> f2
    | EIadd (e0, e1) -> f3 e0 (f9 e0) e1 (f9 e1)
    | EIopp e0 -> f4 e0 (f9 e0)
    | EIsub (e0, e1) -> f5 e0 (f9 e0) e1 (f9 e1)
    | EImul (e0, e1) -> f6 e0 (f9 e0) e1 (f9 e1)
    | EImax (e0, e1) -> f7 e0 (f9 e0) e1 (f9 e1)
    | EIraw t0 -> f8 t0
    in f9

  type coq_ExprZ =
  | EZadd of coq_ExprZ * coq_ExprZ
  | EZopp of coq_ExprZ
  | EZsub of coq_ExprZ * coq_ExprZ
  | EZmul of coq_ExprZ * coq_ExprZ
  | EZmax of coq_ExprZ * coq_ExprZ
  | EZofI of coq_ExprI
  | EZraw of z

  (** val coq_ExprZ_rect :
      (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
      'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ ->
      'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1 **)

  let coq_ExprZ_rect f f0 f1 f2 f3 f4 f5 =
    let rec f6 = function
    | EZadd (e0, e1) -> f e0 (f6 e0) e1 (f6 e1)
    | EZopp e0 -> f0 e0 (f6 e0)
    | EZsub (e0, e1) -> f1 e0 (f6 e0) e1 (f6 e1)
    | EZmul (e0, e1) -> f2 e0 (f6 e0) e1 (f6 e1)
    | EZmax (e0, e1) -> f3 e0 (f6 e0) e1 (f6 e1)
    | EZofI e0 -> f4 e0
    | EZraw z0 -> f5 z0
    in f6

  (** val coq_ExprZ_rec :
      (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 ->
      'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ ->
      'a1 -> coq_ExprZ -> 'a1 -> 'a1) -> (coq_ExprZ -> 'a1 -> coq_ExprZ ->
      'a1 -> 'a1) -> (coq_ExprI -> 'a1) -> (z -> 'a1) -> coq_ExprZ -> 'a1 **)

  let coq_ExprZ_rec f f0 f1 f2 f3 f4 f5 =
    let rec f6 = function
    | EZadd (e0, e1) -> f e0 (f6 e0) e1 (f6 e1)
    | EZopp e0 -> f0 e0 (f6 e0)
    | EZsub (e0, e1) -> f1 e0 (f6 e0) e1 (f6 e1)
    | EZmul (e0, e1) -> f2 e0 (f6 e0) e1 (f6 e1)
    | EZmax (e0, e1) -> f3 e0 (f6 e0) e1 (f6 e1)
    | EZofI e0 -> f4 e0
    | EZraw z0 -> f5 z0
    in f6

  type coq_ExprP =
  | EPeq of coq_ExprZ * coq_ExprZ
  | EPlt of coq_ExprZ * coq_ExprZ
  | EPle of coq_ExprZ * coq_ExprZ
  | EPgt of coq_ExprZ * coq_ExprZ
  | EPge of coq_ExprZ * coq_ExprZ
  | EPimpl of coq_ExprP * coq_ExprP
  | EPequiv of coq_ExprP * coq_ExprP
  | EPand of coq_ExprP * coq_ExprP
  | EPor of coq_ExprP * coq_ExprP
  | EPneg of coq_ExprP
  | EPraw

  (** val coq_ExprP_rect :
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
      'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
      (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
      coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1) ->
      coq_ExprP -> 'a1 **)

  let coq_ExprP_rect f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 =
    let rec f10 = function
    | EPeq (e0, e1) -> f e0 e1
    | EPlt (e0, e1) -> f0 e0 e1
    | EPle (e0, e1) -> f1 e0 e1
    | EPgt (e0, e1) -> f2 e0 e1
    | EPge (e0, e1) -> f3 e0 e1
    | EPimpl (e0, e1) -> f4 e0 (f10 e0) e1 (f10 e1)
    | EPequiv (e0, e1) -> f5 e0 (f10 e0) e1 (f10 e1)
    | EPand (e0, e1) -> f6 e0 (f10 e0) e1 (f10 e1)
    | EPor (e0, e1) -> f7 e0 (f10 e0) e1 (f10 e1)
    | EPneg e0 -> f8 e0 (f10 e0)
    | EPraw -> f9 __
    in f10

  (** val coq_ExprP_rec :
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprZ -> coq_ExprZ -> 'a1) ->
      (coq_ExprZ -> coq_ExprZ -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP ->
      'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) ->
      (coq_ExprP -> 'a1 -> coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 ->
      coq_ExprP -> 'a1 -> 'a1) -> (coq_ExprP -> 'a1 -> 'a1) -> (__ -> 'a1) ->
      coq_ExprP -> 'a1 **)

  let coq_ExprP_rec f f0 f1 f2 f3 f4 f5 f6 f7 f8 f9 =
    let rec f10 = function
    | EPeq (e0, e1) -> f e0 e1
    | EPlt (e0, e1) -> f0 e0 e1
    | EPle (e0, e1) -> f1 e0 e1
    | EPgt (e0, e1) -> f2 e0 e1
    | EPge (e0, e1) -> f3 e0 e1
    | EPimpl (e0, e1) -> f4 e0 (f10 e0) e1 (f10 e1)
    | EPequiv (e0, e1) -> f5 e0 (f10 e0) e1 (f10 e1)
    | EPand (e0, e1) -> f6 e0 (f10 e0) e1 (f10 e1)
    | EPor (e0, e1) -> f7 e0 (f10 e0) e1 (f10 e1)
    | EPneg e0 -> f8 e0 (f10 e0)
    | EPraw -> f9 __
    in f10

  (** val ei2i : coq_ExprI -> I.t **)

  let rec ei2i = function
  | EI0 -> I._0
  | EI1 -> I._1
  | EI2 -> I._2
  | EI3 -> I._3
  | EIadd (e1, e2) -> I.add (ei2i e1) (ei2i e2)
  | EIopp e0 -> I.opp (ei2i e0)
  | EIsub (e1, e2) -> I.sub (ei2i e1) (ei2i e2)
  | EImul (e1, e2) -> I.mul (ei2i e1) (ei2i e2)
  | EImax (e1, e2) -> I.max (ei2i e1) (ei2i e2)
  | EIraw i -> i

  (** val ez2z : coq_ExprZ -> z **)

  let rec ez2z = function
  | EZadd (e1, e2) -> Coq_Z.add (ez2z e1) (ez2z e2)
  | EZopp e0 -> Coq_Z.opp (ez2z e0)
  | EZsub (e1, e2) -> Coq_Z.sub (ez2z e1) (ez2z e2)
  | EZmul (e1, e2) -> Coq_Z.mul (ez2z e1) (ez2z e2)
  | EZmax (e1, e2) -> Coq_Z.max (ez2z e1) (ez2z e2)
  | EZofI e0 -> I.i2z (ei2i e0)
  | EZraw z0 -> z0

  (** val norm_ei : coq_ExprI -> coq_ExprZ **)

  let rec norm_ei = function
  | EI0 -> EZraw Z0
  | EI1 -> EZraw (Zpos XH)
  | EI2 -> EZraw (Zpos (XO XH))
  | EI3 -> EZraw (Zpos (XI XH))
  | EIadd (e1, e2) -> EZadd ((norm_ei e1), (norm_ei e2))
  | EIopp e0 -> EZopp (norm_ei e0)
  | EIsub (e1, e2) -> EZsub ((norm_ei e1), (norm_ei e2))
  | EImul (e1, e2) -> EZmul ((norm_ei e1), (norm_ei e2))
  | EImax (e1, e2) -> EZmax ((norm_ei e1), (norm_ei e2))
  | EIraw i -> EZofI (EIraw i)

  (** val norm_ez : coq_ExprZ -> coq_ExprZ **)

  let rec norm_ez = function
  | EZadd (e1, e2) -> EZadd ((norm_ez e1), (norm_ez e2))
  | EZopp e0 -> EZopp (norm_ez e0)
  | EZsub (e1, e2) -> EZsub ((norm_ez e1), (norm_ez e2))
  | EZmul (e1, e2) -> EZmul ((norm_ez e1), (norm_ez e2))
  | EZmax (e1, e2) -> EZmax ((norm_ez e1), (norm_ez e2))
  | EZofI e0 -> norm_ei e0
  | EZraw z0 -> EZraw z0

  (** val norm_ep : coq_ExprP -> coq_ExprP **)

  let rec norm_ep = function
  | EPeq (e1, e2) -> EPeq ((norm_ez e1), (norm_ez e2))
  | EPlt (e1, e2) -> EPlt ((norm_ez e1), (norm_ez e2))
  | EPle (e1, e2) -> EPle ((norm_ez e1), (norm_ez e2))
  | EPgt (e1, e2) -> EPgt ((norm_ez e1), (norm_ez e2))
  | EPge (e1, e2) -> EPge ((norm_ez e1), (norm_ez e2))
  | EPimpl (e1, e2) -> EPimpl ((norm_ep e1), (norm_ep e2))
  | EPequiv (e1, e2) -> EPequiv ((norm_ep e1), (norm_ep e2))
  | EPand (e1, e2) -> EPand ((norm_ep e1), (norm_ep e2))
  | EPor (e1, e2) -> EPor ((norm_ep e1), (norm_ep e2))
  | EPneg e0 -> EPneg (norm_ep e0)
  | EPraw -> EPraw
 end

module Z_as_Int =
 struct
  type t = z

  (** val _0 : z **)

  let _0 =
    Z0

  (** val _1 : z **)

  let _1 =
    Zpos XH

  (** val _2 : z **)

  let _2 =
    Zpos (XO XH)

  (** val _3 : z **)

  let _3 =
    Zpos (XI XH)

  (** val add : z -> z -> z **)

  let add =
    Coq_Z.add

  (** val opp : z -> z **)

  let opp =
    Coq_Z.opp

  (** val sub : z -> z -> z **)

  let sub =
    Coq_Z.sub

  (** val mul : z -> z -> z **)

  let mul =
    Coq_Z.mul

  (** val max : z -> z -> z **)

  let max =
    Coq_Z.max

  (** val eqb : z -> z -> bool **)

  let eqb =
    Coq_Z.eqb

  (** val ltb : z -> z -> bool **)

  let ltb =
    Coq_Z.ltb

  (** val leb : z -> z -> bool **)

  let leb =
    Coq_Z.leb

  (** val eq_dec : z -> z -> bool **)

  let eq_dec =
    Coq_Z.eq_dec

  (** val gt_le_dec : z -> z -> bool **)

  let gt_le_dec i j =
    let b = Coq_Z.ltb j i in
    (if b then (fun _ -> true) else (fun _ -> false)) __

  (** val ge_lt_dec : z -> z -> bool **)

  let ge_lt_dec i j =
    let b = Coq_Z.ltb i j in
    (if b then (fun _ -> false) else (fun _ -> true)) __

  (** val i2z : t -> z **)

  let i2z n3 =
    n3
 end

module Coq2_Raw =
 functor (I:Int) ->
 functor (X:Coq_OrderedType) ->
 struct
  type key = X.t

  type 'elt tree =
  | Leaf
  | Node of 'elt tree * key * 'elt * 'elt tree * I.t

  (** val tree_rect :
      'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t -> 'a2)
      -> 'a1 tree -> 'a2 **)

  let tree_rect f f0 =
    let rec f1 = function
    | Leaf -> f
    | Node (t1, k, y, t2, t3) -> f0 t1 (f1 t1) k y t2 (f1 t2) t3
    in f1

  (** val tree_rec :
      'a2 -> ('a1 tree -> 'a2 -> key -> 'a1 -> 'a1 tree -> 'a2 -> I.t -> 'a2)
      -> 'a1 tree -> 'a2 **)

  let tree_rec f f0 =
    let rec f1 = function
    | Leaf -> f
    | Node (t1, k, y, t2, t3) -> f0 t1 (f1 t1) k y t2 (f1 t2) t3
    in f1

  (** val height : 'a1 tree -> I.t **)

  let height = function
  | Leaf -> I._0
  | Node (_, _, _, _, h) -> h

  (** val cardinal : 'a1 tree -> nat **)

  let cardinal m4 =
    let rec cardinal0 = function
    | Leaf -> O
    | Node (l, _, _, r0, _) -> S (add (cardinal0 l) (cardinal0 r0))
    in cardinal0 m4

  (** val empty : 'a1 tree **)

  let empty =
    Leaf

  (** val is_empty : 'a1 tree -> bool **)

  let is_empty = function
  | Leaf -> true
  | Node (_, _, _, _, _) -> false

  (** val mem : X.t -> 'a1 tree -> bool **)

  let mem x =
    let rec mem0 x0 = function
    | Leaf -> false
    | Node (l, y, _, r0, _) ->
      (match X.compare x0 y with
       | LT -> mem0 x0 l
       | EQ -> true
       | GT -> mem0 x0 r0)
    in mem0 x

  (** val find : X.t -> 'a1 tree -> 'a1 option **)

  let find x =
    let rec find0 x0 = function
    | Leaf -> None
    | Node (l, y, d, r0, _) ->
      (match X.compare x0 y with
       | LT -> find0 x0 l
       | EQ -> Some d
       | GT -> find0 x0 r0)
    in find0 x

  (** val create : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree **)

  let create l x e r0 =
    Node (l, x, e, r0, (I.add (I.max (height l) (height r0)) I._1))

  (** val assert_false : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree **)

  let assert_false =
    create

  (** val bal : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree **)

  let bal l x d r0 =
    let hl = height l in
    let hr = height r0 in
    if I.gt_le_dec hl (I.add hr I._2)
    then (match l with
          | Leaf -> assert_false l x d r0
          | Node (ll, lx, ld, lr, _) ->
            if I.ge_lt_dec (height ll) (height lr)
            then create ll lx ld (create lr x d r0)
            else (match lr with
                  | Leaf -> assert_false l x d r0
                  | Node (lrl, lrx, lrd, lrr, _) ->
                    create (create ll lx ld lrl) lrx lrd (create lrr x d r0)))
    else if I.gt_le_dec hr (I.add hl I._2)
         then (match r0 with
               | Leaf -> assert_false l x d r0
               | Node (rl, rx, rd, rr, _) ->
                 if I.ge_lt_dec (height rr) (height rl)
                 then create (create l x d rl) rx rd rr
                 else (match rl with
                       | Leaf -> assert_false l x d r0
                       | Node (rll, rlx, rld, rlr, _) ->
                         create (create l x d rll) rlx rld
                           (create rlr rx rd rr)))
         else create l x d r0

  (** val add : key -> 'a1 -> 'a1 tree -> 'a1 tree **)

  let add x =
    let rec add0 x0 d = function
    | Leaf -> Node (Leaf, x0, d, Leaf, I._1)
    | Node (l, y, d', r0, h) ->
      (match X.compare x0 y with
       | LT -> bal (add0 x0 d l) y d' r0
       | EQ -> Node (l, y, d, r0, h)
       | GT -> bal l y d' (add0 x0 d r0))
    in add0 x

  (** val remove_min :
      'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree * (key * 'a1) **)

  let remove_min l =
    let rec remove_min0 l0 x d r0 =
      match l0 with
      | Leaf -> (r0, (x, d))
      | Node (ll, lx, ld, lr, _) ->
        let (l', m4) = remove_min0 ll lx ld lr in ((bal l' x d r0), m4)
    in remove_min0 l

  (** val merge : 'a1 tree -> 'a1 tree -> 'a1 tree **)

  let merge s1 s2 =
    match s1 with
    | Leaf -> s2
    | Node (_, _, _, _, _) ->
      (match s2 with
       | Leaf -> s1
       | Node (l2, x2, d2, r2, _) ->
         let (s2', p) = remove_min l2 x2 d2 r2 in
         let (x, d) = p in bal s1 x d s2')

  (** val remove : X.t -> 'a1 tree -> 'a1 tree **)

  let remove x =
    let rec remove2 x0 = function
    | Leaf -> Leaf
    | Node (l, y, d, r0, _) ->
      (match X.compare x0 y with
       | LT -> bal (remove2 x0 l) y d r0
       | EQ -> merge l r0
       | GT -> bal l y d (remove2 x0 r0))
    in remove2 x

  (** val join : 'a1 tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree **)

  let join l =
    let rec join0 l0 = match l0 with
    | Leaf -> add
    | Node (ll, lx, ld, lr, lh) ->
      (fun x d ->
        let rec join_aux r0 = match r0 with
        | Leaf -> add x d l0
        | Node (rl, rx, rd, rr, rh) ->
          if I.gt_le_dec lh (I.add rh I._2)
          then bal ll lx ld (join0 lr x d r0)
          else if I.gt_le_dec rh (I.add lh I._2)
               then bal (join_aux rl) rx rd rr
               else create l0 x d r0
        in join_aux)
    in join0 l

  type 'elt triple = { t_left : 'elt tree; t_opt : 'elt option;
                       t_right : 'elt tree }

  (** val t_left : 'a1 triple -> 'a1 tree **)

  let t_left t0 =
    t0.t_left

  (** val t_opt : 'a1 triple -> 'a1 option **)

  let t_opt t0 =
    t0.t_opt

  (** val t_right : 'a1 triple -> 'a1 tree **)

  let t_right t0 =
    t0.t_right

  (** val split : X.t -> 'a1 tree -> 'a1 triple **)

  let split x =
    let rec split0 x0 = function
    | Leaf -> { t_left = Leaf; t_opt = None; t_right = Leaf }
    | Node (l, y, d, r0, _) ->
      (match X.compare x0 y with
       | LT ->
         let { t_left = ll; t_opt = o; t_right = rl } = split0 x0 l in
         { t_left = ll; t_opt = o; t_right = (join rl y d r0) }
       | EQ -> { t_left = l; t_opt = (Some d); t_right = r0 }
       | GT ->
         let { t_left = rl; t_opt = o; t_right = rr } = split0 x0 r0 in
         { t_left = (join l y d rl); t_opt = o; t_right = rr })
    in split0 x

  (** val concat : 'a1 tree -> 'a1 tree -> 'a1 tree **)

  let concat m4 m5 =
    match m4 with
    | Leaf -> m5
    | Node (_, _, _, _, _) ->
      (match m5 with
       | Leaf -> m4
       | Node (l2, x2, d2, r2, _) ->
         let (m2', xd) = remove_min l2 x2 d2 r2 in
         join m4 (fst xd) (snd xd) m2')

  (** val elements_aux : (key * 'a1) list -> 'a1 tree -> (key * 'a1) list **)

  let elements_aux acc =
    let rec elements_aux0 acc0 = function
    | Leaf -> acc0
    | Node (l, x, d, r0, _) ->
      elements_aux0 ((x, d) :: (elements_aux0 acc0 r0)) l
    in elements_aux0 acc

  (** val elements : 'a1 tree -> (key * 'a1) list **)

  let elements m4 =
    elements_aux [] m4

  (** val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2 **)

  let fold f m4 x =
    let rec fold0 _ f0 m5 a =
      match m5 with
      | Leaf -> a
      | Node (l, x0, d, r0, _) -> fold0 __ f0 r0 (f0 x0 d (fold0 __ f0 l a))
    in fold0 __ f m4 x

  type 'elt enumeration =
  | End
  | More of key * 'elt * 'elt tree * 'elt enumeration

  (** val enumeration_rect :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2 **)

  let enumeration_rect f f0 =
    let rec f1 = function
    | End -> f
    | More (k, e0, t0, e1) -> f0 k e0 t0 e1 (f1 e1)
    in f1

  (** val enumeration_rec :
      'a2 -> (key -> 'a1 -> 'a1 tree -> 'a1 enumeration -> 'a2 -> 'a2) -> 'a1
      enumeration -> 'a2 **)

  let enumeration_rec f f0 =
    let rec f1 = function
    | End -> f
    | More (k, e0, t0, e1) -> f0 k e0 t0 e1 (f1 e1)
    in f1

  (** val cons : 'a1 tree -> 'a1 enumeration -> 'a1 enumeration **)

  let cons m4 =
    let rec cons0 m5 e =
      match m5 with
      | Leaf -> e
      | Node (l, x, d, r0, _) -> cons0 l (More (x, d, r0, e))
    in cons0 m4

  (** val equal_more :
      ('a1 -> 'a1 -> bool) -> X.t -> 'a1 -> ('a1 enumeration -> bool) -> 'a1
      enumeration -> bool **)

  let equal_more cmp0 x1 d1 cont = function
  | End -> false
  | More (x2, d2, r2, e3) ->
    (match X.compare x1 x2 with
     | LT -> false
     | EQ -> if cmp0 d1 d2 then cont (cons r2 e3) else false
     | GT -> false)

  (** val equal_cont :
      ('a1 -> 'a1 -> bool) -> 'a1 tree -> ('a1 enumeration -> bool) -> 'a1
      enumeration -> bool **)

  let equal_cont cmp0 =
    let rec equal_cont0 m4 cont e2 =
      match m4 with
      | Leaf -> cont e2
      | Node (l1, x1, d1, r1, _) ->
        equal_cont0 l1 (equal_more cmp0 x1 d1 (equal_cont0 r1 cont)) e2
    in equal_cont0

  (** val equal_end : 'a1 enumeration -> bool **)

  let equal_end = function
  | End -> true
  | More (_, _, _, _) -> false

  (** val equal : ('a1 -> 'a1 -> bool) -> 'a1 tree -> 'a1 tree -> bool **)

  let equal cmp0 m4 m5 =
    equal_cont cmp0 m4 equal_end (cons m5 End)

  (** val map : ('a1 -> 'a2) -> 'a1 tree -> 'a2 tree **)

  let rec map f = function
  | Leaf -> Leaf
  | Node (l, x, d, r0, h) -> Node ((map f l), x, (f d), (map f r0), h)

  (** val mapi : (key -> 'a1 -> 'a2) -> 'a1 tree -> 'a2 tree **)

  let rec mapi f = function
  | Leaf -> Leaf
  | Node (l, x, d, r0, h) -> Node ((mapi f l), x, (f x d), (mapi f r0), h)

  (** val map_option : (key -> 'a1 -> 'a2 option) -> 'a1 tree -> 'a2 tree **)

  let rec map_option f = function
  | Leaf -> Leaf
  | Node (l, x, d, r0, _) ->
    (match f x d with
     | Some d' -> join (map_option f l) x d' (map_option f r0)
     | None -> concat (map_option f l) (map_option f r0))

  (** val map2_opt :
      (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
      ('a2 tree -> 'a3 tree) -> 'a1 tree -> 'a2 tree -> 'a3 tree **)

  let map2_opt f mapl mapr =
    let rec map2_opt0 m4 m5 =
      match m4 with
      | Leaf -> mapr m5
      | Node (l1, x1, d1, r1, _) ->
        (match m5 with
         | Leaf -> mapl m4
         | Node (_, _, _, _, _) ->
           let { t_left = l2'; t_opt = o2; t_right = r2' } = split x1 m5 in
           (match f x1 d1 o2 with
            | Some e -> join (map2_opt0 l1 l2') x1 e (map2_opt0 r1 r2')
            | None -> concat (map2_opt0 l1 l2') (map2_opt0 r1 r2')))
    in map2_opt0

  (** val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 tree -> 'a2 tree -> 'a3
      tree **)

  let map2 f =
    map2_opt (fun _ d o -> f (Some d) o)
      (map_option (fun _ d -> f (Some d) None))
      (map_option (fun _ d' -> f None (Some d')))

  module Proofs =
   struct
    module MX = Coq_OrderedTypeFacts(X)

    module PX = KeyOrderedType(X)

    module L = Coq1_Raw(X)

    type 'elt coq_R_mem =
    | R_mem_0 of 'elt tree
    | R_mem_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t * 
       bool * 'elt coq_R_mem
    | R_mem_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_mem_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t * 
       bool * 'elt coq_R_mem

    (** val coq_R_mem_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2)
        -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2 **)

    let coq_R_mem_rect _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_mem_0 m4 -> f m4 __
      | R_mem_1 (m4, l, y, _x, r1, _x0, _res, r2) ->
        f0 m4 l y _x r1 _x0 __ __ __ _res r2 (f3 l _res r2)
      | R_mem_2 (m4, l, y, _x, r1, _x0) -> f1 m4 l y _x r1 _x0 __ __ __
      | R_mem_3 (m4, l, y, _x, r1, _x0, _res, r2) ->
        f2 m4 l y _x r1 _x0 __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    (** val coq_R_mem_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> I.t -> __ -> __ -> __ -> bool -> 'a1 coq_R_mem -> 'a2 -> 'a2)
        -> 'a1 tree -> bool -> 'a1 coq_R_mem -> 'a2 **)

    let coq_R_mem_rec _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_mem_0 m4 -> f m4 __
      | R_mem_1 (m4, l, y, _x, r1, _x0, _res, r2) ->
        f0 m4 l y _x r1 _x0 __ __ __ _res r2 (f3 l _res r2)
      | R_mem_2 (m4, l, y, _x, r1, _x0) -> f1 m4 l y _x r1 _x0 __ __ __
      | R_mem_3 (m4, l, y, _x, r1, _x0, _res, r2) ->
        f2 m4 l y _x r1 _x0 __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    type 'elt coq_R_find =
    | R_find_0 of 'elt tree
    | R_find_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt option * 'elt coq_R_find
    | R_find_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_find_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt option * 'elt coq_R_find

    (** val coq_R_find_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option -> 'a1 coq_R_find -> 'a2 **)

    let coq_R_find_rect _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_find_0 m4 -> f m4 __
      | R_find_1 (m4, l, y, d, r1, _x, _res, r2) ->
        f0 m4 l y d r1 _x __ __ __ _res r2 (f3 l _res r2)
      | R_find_2 (m4, l, y, d, r1, _x) -> f1 m4 l y d r1 _x __ __ __
      | R_find_3 (m4, l, y, d, r1, _x, _res, r2) ->
        f2 m4 l y d r1 _x __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    (** val coq_R_find_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 option -> 'a1 coq_R_find
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 option -> 'a1 coq_R_find -> 'a2 **)

    let coq_R_find_rec _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_find_0 m4 -> f m4 __
      | R_find_1 (m4, l, y, d, r1, _x, _res, r2) ->
        f0 m4 l y d r1 _x __ __ __ _res r2 (f3 l _res r2)
      | R_find_2 (m4, l, y, d, r1, _x) -> f1 m4 l y d r1 _x __ __ __
      | R_find_3 (m4, l, y, d, r1, _x, _res, r2) ->
        f2 m4 l y d r1 _x __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    type 'elt coq_R_bal =
    | R_bal_0 of 'elt tree * key * 'elt * 'elt tree
    | R_bal_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_2 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_3 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * 
       I.t
    | R_bal_4 of 'elt tree * key * 'elt * 'elt tree
    | R_bal_5 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_6 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t
    | R_bal_7 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * key * 
       'elt * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * 
       I.t
    | R_bal_8 of 'elt tree * key * 'elt * 'elt tree

    (** val coq_R_bal_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
        'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __
        -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2 **)

    let coq_R_bal_rect f f0 f1 f2 f3 f4 f5 f6 f7 _ _ _ _ _ = function
    | R_bal_0 (l, x, d, r1) -> f l x d r1 __ __ __
    | R_bal_1 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f0 l x d r1 __ __ x0 x1 x2 x3 x4 __ __ __
    | R_bal_2 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f1 l x d r1 __ __ x0 x1 x2 x3 x4 __ __ __ __
    | R_bal_3 (l, x, d, r1, x0, x1, x2, x3, x4, x5, x6, x7, x8, x9) ->
      f2 l x d r1 __ __ x0 x1 x2 x3 x4 __ __ __ x5 x6 x7 x8 x9 __
    | R_bal_4 (l, x, d, r1) -> f3 l x d r1 __ __ __ __ __
    | R_bal_5 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f4 l x d r1 __ __ __ __ x0 x1 x2 x3 x4 __ __ __
    | R_bal_6 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f5 l x d r1 __ __ __ __ x0 x1 x2 x3 x4 __ __ __ __
    | R_bal_7 (l, x, d, r1, x0, x1, x2, x3, x4, x5, x6, x7, x8, x9) ->
      f6 l x d r1 __ __ __ __ x0 x1 x2 x3 x4 __ __ __ x5 x6 x7 x8 x9 __
    | R_bal_8 (l, x, d, r1) -> f7 l x d r1 __ __ __ __

    (** val coq_R_bal_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key ->
        'a1 -> 'a1 tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1
        tree -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ ->
        'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __
        -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> __ -> 'a2) -> ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> __ ->
        __ -> __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ ->
        __ -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2) -> ('a1
        tree -> key -> 'a1 -> 'a1 tree -> __ -> __ -> __ -> __ -> 'a2) -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_bal -> 'a2 **)

    let coq_R_bal_rec f f0 f1 f2 f3 f4 f5 f6 f7 _ _ _ _ _ = function
    | R_bal_0 (l, x, d, r1) -> f l x d r1 __ __ __
    | R_bal_1 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f0 l x d r1 __ __ x0 x1 x2 x3 x4 __ __ __
    | R_bal_2 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f1 l x d r1 __ __ x0 x1 x2 x3 x4 __ __ __ __
    | R_bal_3 (l, x, d, r1, x0, x1, x2, x3, x4, x5, x6, x7, x8, x9) ->
      f2 l x d r1 __ __ x0 x1 x2 x3 x4 __ __ __ x5 x6 x7 x8 x9 __
    | R_bal_4 (l, x, d, r1) -> f3 l x d r1 __ __ __ __ __
    | R_bal_5 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f4 l x d r1 __ __ __ __ x0 x1 x2 x3 x4 __ __ __
    | R_bal_6 (l, x, d, r1, x0, x1, x2, x3, x4) ->
      f5 l x d r1 __ __ __ __ x0 x1 x2 x3 x4 __ __ __ __
    | R_bal_7 (l, x, d, r1, x0, x1, x2, x3, x4, x5, x6, x7, x8, x9) ->
      f6 l x d r1 __ __ __ __ x0 x1 x2 x3 x4 __ __ __ x5 x6 x7 x8 x9 __
    | R_bal_8 (l, x, d, r1) -> f7 l x d r1 __ __ __ __

    type 'elt coq_R_add =
    | R_add_0 of 'elt tree
    | R_add_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt tree * 'elt coq_R_add
    | R_add_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_add_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt tree * 'elt coq_R_add

    (** val coq_R_add_rect :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
        key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_add ->
        'a2 **)

    let coq_R_add_rect _ _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_add_0 m4 -> f m4 __
      | R_add_1 (m4, l, y, d', r1, h, _res, r2) ->
        f0 m4 l y d' r1 h __ __ __ _res r2 (f3 l _res r2)
      | R_add_2 (m4, l, y, d', r1, h) -> f1 m4 l y d' r1 h __ __ __
      | R_add_3 (m4, l, y, d', r1, h, _res, r2) ->
        f2 m4 l y d' r1 h __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    (** val coq_R_add_rec :
        key -> 'a1 -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key
        -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree ->
        key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1
        coq_R_add -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_add ->
        'a2 **)

    let coq_R_add_rec _ _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_add_0 m4 -> f m4 __
      | R_add_1 (m4, l, y, d', r1, h, _res, r2) ->
        f0 m4 l y d' r1 h __ __ __ _res r2 (f3 l _res r2)
      | R_add_2 (m4, l, y, d', r1, h) -> f1 m4 l y d' r1 h __ __ __
      | R_add_3 (m4, l, y, d', r1, h, _res, r2) ->
        f2 m4 l y d' r1 h __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    type 'elt coq_R_remove_min =
    | R_remove_min_0 of 'elt tree * key * 'elt * 'elt tree
    | R_remove_min_1 of 'elt tree * key * 'elt * 'elt tree * 'elt tree * 
       key * 'elt * 'elt tree * I.t * ('elt tree * (key * 'elt))
       * 'elt coq_R_remove_min * 'elt tree * (key * 'elt)

    (** val coq_R_remove_min_rect :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1
        tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 **)

    let coq_R_remove_min_rect f f0 =
      let rec f1 _ _ _ _ _ = function
      | R_remove_min_0 (l, x, d, r1) -> f l x d r1 __
      | R_remove_min_1 (l, x, d, r1, ll, lx, ld, lr, _x, _res, r2, l', m4) ->
        f0 l x d r1 ll lx ld lr _x __ _res r2 (f1 ll lx ld lr _res r2) l' m4
          __
      in f1

    (** val coq_R_remove_min_rec :
        ('a1 tree -> key -> 'a1 -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> key
        -> 'a1 -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 -> 'a1
        tree -> (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> key -> 'a1 -> 'a1
        tree -> ('a1 tree * (key * 'a1)) -> 'a1 coq_R_remove_min -> 'a2 **)

    let coq_R_remove_min_rec f f0 =
      let rec f1 _ _ _ _ _ = function
      | R_remove_min_0 (l, x, d, r1) -> f l x d r1 __
      | R_remove_min_1 (l, x, d, r1, ll, lx, ld, lr, _x, _res, r2, l', m4) ->
        f0 l x d r1 ll lx ld lr _x __ _res r2 (f1 ll lx ld lr _res r2) l' m4
          __
      in f1

    type 'elt coq_R_merge =
    | R_merge_0 of 'elt tree * 'elt tree
    | R_merge_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt * 'elt tree
       * I.t
    | R_merge_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt * 'elt tree
       * I.t * 'elt tree * key * 'elt * 'elt tree * I.t * 'elt tree
       * (key * 'elt) * key * 'elt

    (** val coq_R_merge_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1 tree
        -> 'a1 tree -> 'a1 coq_R_merge -> 'a2 **)

    let coq_R_merge_rect f f0 f1 _ _ _ = function
    | R_merge_0 (s1, s2) -> f s1 s2 __
    | R_merge_1 (s1, s2, _x, _x0, _x1, _x2, _x3) ->
      f0 s1 s2 _x _x0 _x1 _x2 _x3 __ __
    | R_merge_2 (s1, s2, _x, _x0, _x1, _x2, _x3, l2, x2, d2, r2, _x4, s2', p,
                 x, d) ->
      f1 s1 s2 _x _x0 _x1 _x2 _x3 __ l2 x2 d2 r2 _x4 __ s2' p __ x d __

    (** val coq_R_merge_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> key -> 'a1 -> __ -> 'a2) -> 'a1 tree -> 'a1 tree
        -> 'a1 tree -> 'a1 coq_R_merge -> 'a2 **)

    let coq_R_merge_rec f f0 f1 _ _ _ = function
    | R_merge_0 (s1, s2) -> f s1 s2 __
    | R_merge_1 (s1, s2, _x, _x0, _x1, _x2, _x3) ->
      f0 s1 s2 _x _x0 _x1 _x2 _x3 __ __
    | R_merge_2 (s1, s2, _x, _x0, _x1, _x2, _x3, l2, x2, d2, r2, _x4, s2', p,
                 x, d) ->
      f1 s1 s2 _x _x0 _x1 _x2 _x3 __ l2 x2 d2 r2 _x4 __ s2' p __ x d __

    type 'elt coq_R_remove =
    | R_remove_0 of 'elt tree
    | R_remove_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'elt tree * 'elt coq_R_remove
    | R_remove_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_remove_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'elt tree * 'elt coq_R_remove

    (** val coq_R_remove_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 **)

    let coq_R_remove_rect _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_remove_0 m4 -> f m4 __
      | R_remove_1 (m4, l, y, d, r1, _x, _res, r2) ->
        f0 m4 l y d r1 _x __ __ __ _res r2 (f3 l _res r2)
      | R_remove_2 (m4, l, y, d, r1, _x) -> f1 m4 l y d r1 _x __ __ __
      | R_remove_3 (m4, l, y, d, r1, _x, _res, r2) ->
        f2 m4 l y d r1 _x __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    (** val coq_R_remove_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree ->
        I.t -> __ -> __ -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 tree -> 'a1 coq_R_remove
        -> 'a2 -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 coq_R_remove -> 'a2 **)

    let coq_R_remove_rec _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_remove_0 m4 -> f m4 __
      | R_remove_1 (m4, l, y, d, r1, _x, _res, r2) ->
        f0 m4 l y d r1 _x __ __ __ _res r2 (f3 l _res r2)
      | R_remove_2 (m4, l, y, d, r1, _x) -> f1 m4 l y d r1 _x __ __ __
      | R_remove_3 (m4, l, y, d, r1, _x, _res, r2) ->
        f2 m4 l y d r1 _x __ __ __ _res r2 (f3 r1 _res r2)
      in f3

    type 'elt coq_R_concat =
    | R_concat_0 of 'elt tree * 'elt tree
    | R_concat_1 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
       * 'elt tree * I.t
    | R_concat_2 of 'elt tree * 'elt tree * 'elt tree * key * 'elt
       * 'elt tree * I.t * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt tree * (key * 'elt)

    (** val coq_R_concat_rect :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_concat -> 'a2 **)

    let coq_R_concat_rect f f0 f1 _ _ _ = function
    | R_concat_0 (m4, m5) -> f m4 m5 __
    | R_concat_1 (m4, m5, _x, _x0, _x1, _x2, _x3) ->
      f0 m4 m5 _x _x0 _x1 _x2 _x3 __ __
    | R_concat_2 (m4, m5, _x, _x0, _x1, _x2, _x3, l2, x2, d2, r2, _x4, m2', xd) ->
      f1 m4 m5 _x _x0 _x1 _x2 _x3 __ l2 x2 d2 r2 _x4 __ m2' xd __

    (** val coq_R_concat_rec :
        ('a1 tree -> 'a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> 'a1
        tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a1 tree ->
        (key * 'a1) -> __ -> 'a2) -> 'a1 tree -> 'a1 tree -> 'a1 tree -> 'a1
        coq_R_concat -> 'a2 **)

    let coq_R_concat_rec f f0 f1 _ _ _ = function
    | R_concat_0 (m4, m5) -> f m4 m5 __
    | R_concat_1 (m4, m5, _x, _x0, _x1, _x2, _x3) ->
      f0 m4 m5 _x _x0 _x1 _x2 _x3 __ __
    | R_concat_2 (m4, m5, _x, _x0, _x1, _x2, _x3, l2, x2, d2, r2, _x4, m2', xd) ->
      f1 m4 m5 _x _x0 _x1 _x2 _x3 __ l2 x2 d2 r2 _x4 __ m2' xd __

    type 'elt coq_R_split =
    | R_split_0 of 'elt tree
    | R_split_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option * 'elt tree
    | R_split_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
    | R_split_3 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * I.t
       * 'elt triple * 'elt coq_R_split * 'elt tree * 'elt option * 'elt tree

    (** val coq_R_split_rect :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
        -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree ->
        'a1 option -> 'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 **)

    let coq_R_split_rect _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_split_0 m4 -> f m4 __
      | R_split_1 (m4, l, y, d, r1, _x, _res, r2, ll, o, rl) ->
        f0 m4 l y d r1 _x __ __ __ _res r2 (f3 l _res r2) ll o rl __
      | R_split_2 (m4, l, y, d, r1, _x) -> f1 m4 l y d r1 _x __ __ __
      | R_split_3 (m4, l, y, d, r1, _x, _res, r2, rl, o, rr) ->
        f2 m4 l y d r1 _x __ __ __ _res r2 (f3 r1 _res r2) rl o rr __
      in f3

    (** val coq_R_split_rec :
        X.t -> ('a1 tree -> __ -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1
        -> 'a1 tree -> I.t -> __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split
        -> 'a2 -> 'a1 tree -> 'a1 option -> 'a1 tree -> __ -> 'a2) -> ('a1
        tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> __ -> __
        -> 'a2) -> ('a1 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t ->
        __ -> __ -> __ -> 'a1 triple -> 'a1 coq_R_split -> 'a2 -> 'a1 tree ->
        'a1 option -> 'a1 tree -> __ -> 'a2) -> 'a1 tree -> 'a1 triple -> 'a1
        coq_R_split -> 'a2 **)

    let coq_R_split_rec _ f f0 f1 f2 =
      let rec f3 _ _ = function
      | R_split_0 m4 -> f m4 __
      | R_split_1 (m4, l, y, d, r1, _x, _res, r2, ll, o, rl) ->
        f0 m4 l y d r1 _x __ __ __ _res r2 (f3 l _res r2) ll o rl __
      | R_split_2 (m4, l, y, d, r1, _x) -> f1 m4 l y d r1 _x __ __ __
      | R_split_3 (m4, l, y, d, r1, _x, _res, r2, rl, o, rr) ->
        f2 m4 l y d r1 _x __ __ __ _res r2 (f3 r1 _res r2) rl o rr __
      in f3

    type ('elt, 'x) coq_R_map_option =
    | R_map_option_0 of 'elt tree
    | R_map_option_1 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'x * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
       * ('elt, 'x) coq_R_map_option
    | R_map_option_2 of 'elt tree * 'elt tree * key * 'elt * 'elt tree * 
       I.t * 'x tree * ('elt, 'x) coq_R_map_option * 'x tree
       * ('elt, 'x) coq_R_map_option

    (** val coq_R_map_option_rect :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ -> 'a2
        tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3 **)

    let coq_R_map_option_rect _ f0 f1 f2 =
      let rec f _ _ = function
      | R_map_option_0 m4 -> f0 m4 __
      | R_map_option_1 (m4, l, x, d, r1, _x, d', _res0, r2, _res, r3) ->
        f1 m4 l x d r1 _x __ d' __ _res0 r2 (f l _res0 r2) _res r3
          (f r1 _res r3)
      | R_map_option_2 (m4, l, x, d, r1, _x, _res0, r2, _res, r3) ->
        f2 m4 l x d r1 _x __ __ _res0 r2 (f l _res0 r2) _res r3 (f r1 _res r3)
      in f

    (** val coq_R_map_option_rec :
        (key -> 'a1 -> 'a2 option) -> ('a1 tree -> __ -> 'a3) -> ('a1 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 -> __ -> 'a2
        tree -> ('a1, 'a2) coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a3) -> ('a1 tree -> 'a1 tree -> key ->
        'a1 -> 'a1 tree -> I.t -> __ -> __ -> 'a2 tree -> ('a1, 'a2)
        coq_R_map_option -> 'a3 -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3 -> 'a3) -> 'a1 tree -> 'a2 tree -> ('a1, 'a2) coq_R_map_option ->
        'a3 **)

    let coq_R_map_option_rec _ f0 f1 f2 =
      let rec f _ _ = function
      | R_map_option_0 m4 -> f0 m4 __
      | R_map_option_1 (m4, l, x, d, r1, _x, d', _res0, r2, _res, r3) ->
        f1 m4 l x d r1 _x __ d' __ _res0 r2 (f l _res0 r2) _res r3
          (f r1 _res r3)
      | R_map_option_2 (m4, l, x, d, r1, _x, _res0, r2, _res, r3) ->
        f2 m4 l x d r1 _x __ __ _res0 r2 (f l _res0 r2) _res r3 (f r1 _res r3)
      in f

    type ('elt, 'x0, 'x) coq_R_map2_opt =
    | R_map2_opt_0 of 'elt tree * 'x0 tree
    | R_map2_opt_1 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
       * 'elt tree * I.t
    | R_map2_opt_2 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
       * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t * 'x0 tree
       * 'x0 option * 'x0 tree * 'x * 'x tree
       * ('elt, 'x0, 'x) coq_R_map2_opt * 'x tree
       * ('elt, 'x0, 'x) coq_R_map2_opt
    | R_map2_opt_3 of 'elt tree * 'x0 tree * 'elt tree * key * 'elt
       * 'elt tree * I.t * 'x0 tree * key * 'x0 * 'x0 tree * I.t * 'x0 tree
       * 'x0 option * 'x0 tree * 'x tree * ('elt, 'x0, 'x) coq_R_map2_opt
       * 'x tree * ('elt, 'x0, 'x) coq_R_map2_opt

    (** val coq_R_map2_opt_rect :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> I.t ->
        __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 -> __ -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key ->
        'a2 -> 'a2 tree -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
        __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree ->
        'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 **)

    let coq_R_map2_opt_rect _ _ _ f0 f1 f2 f3 =
      let rec f _ _ _ = function
      | R_map2_opt_0 (m4, m5) -> f0 m4 m5 __
      | R_map2_opt_1 (m4, m5, l1, x1, d1, r1, _x) ->
        f1 m4 m5 l1 x1 d1 r1 _x __ __
      | R_map2_opt_2 (m4, m5, l1, x1, d1, r1, _x, _x0, _x1, _x2, _x3, _x4,
                      l2', o2, r2', e, _res0, r2, _res, r3) ->
        f2 m4 m5 l1 x1 d1 r1 _x __ _x0 _x1 _x2 _x3 _x4 __ l2' o2 r2' __ e __
          _res0 r2 (f l1 l2' _res0 r2) _res r3 (f r1 r2' _res r3)
      | R_map2_opt_3 (m4, m5, l1, x1, d1, r1, _x, _x0, _x1, _x2, _x3, _x4,
                      l2', o2, r2', _res0, r2, _res, r3) ->
        f3 m4 m5 l1 x1 d1 r1 _x __ _x0 _x1 _x2 _x3 _x4 __ l2' o2 r2' __ __
          _res0 r2 (f l1 l2' _res0 r2) _res r3 (f r1 r2' _res r3)
      in f

    (** val coq_R_map2_opt_rec :
        (key -> 'a1 -> 'a2 option -> 'a3 option) -> ('a1 tree -> 'a3 tree) ->
        ('a2 tree -> 'a3 tree) -> ('a1 tree -> 'a2 tree -> __ -> 'a4) -> ('a1
        tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __
        -> __ -> 'a4) -> ('a1 tree -> 'a2 tree -> 'a1 tree -> key -> 'a1 ->
        'a1 tree -> I.t -> __ -> 'a2 tree -> key -> 'a2 -> 'a2 tree -> I.t ->
        __ -> 'a2 tree -> 'a2 option -> 'a2 tree -> __ -> 'a3 -> __ -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3 tree -> ('a1,
        'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> ('a1 tree -> 'a2 tree ->
        'a1 tree -> key -> 'a1 -> 'a1 tree -> I.t -> __ -> 'a2 tree -> key ->
        'a2 -> 'a2 tree -> I.t -> __ -> 'a2 tree -> 'a2 option -> 'a2 tree ->
        __ -> __ -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a3
        tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 -> 'a4) -> 'a1 tree ->
        'a2 tree -> 'a3 tree -> ('a1, 'a2, 'a3) coq_R_map2_opt -> 'a4 **)

    let coq_R_map2_opt_rec _ _ _ f0 f1 f2 f3 =
      let rec f _ _ _ = function
      | R_map2_opt_0 (m4, m5) -> f0 m4 m5 __
      | R_map2_opt_1 (m4, m5, l1, x1, d1, r1, _x) ->
        f1 m4 m5 l1 x1 d1 r1 _x __ __
      | R_map2_opt_2 (m4, m5, l1, x1, d1, r1, _x, _x0, _x1, _x2, _x3, _x4,
                      l2', o2, r2', e, _res0, r2, _res, r3) ->
        f2 m4 m5 l1 x1 d1 r1 _x __ _x0 _x1 _x2 _x3 _x4 __ l2' o2 r2' __ e __
          _res0 r2 (f l1 l2' _res0 r2) _res r3 (f r1 r2' _res r3)
      | R_map2_opt_3 (m4, m5, l1, x1, d1, r1, _x, _x0, _x1, _x2, _x3, _x4,
                      l2', o2, r2', _res0, r2, _res, r3) ->
        f3 m4 m5 l1 x1 d1 r1 _x __ _x0 _x1 _x2 _x3 _x4 __ l2' o2 r2' __ __
          _res0 r2 (f l1 l2' _res0 r2) _res r3 (f r1 r2' _res r3)
      in f

    (** val fold' : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 tree -> 'a2 -> 'a2 **)

    let fold' f s0 =
      L.fold f (elements s0)

    (** val flatten_e : 'a1 enumeration -> (key * 'a1) list **)

    let flatten_e e =
      let rec flatten_e0 = function
      | End -> []
      | More (x, e1, t0, r0) -> (x, e1) :: (app (elements t0) (flatten_e0 r0))
      in flatten_e0 e
   end
 end

module AvlProofs =
 functor (I:Int) ->
 functor (X:Coq_OrderedType) ->
 struct
  module Raw = Coq2_Raw(I)(X)

  module II = MoreInt(I)
 end

module IntMake =
 functor (I:Int) ->
 functor (X:Coq_OrderedType) ->
 struct
  module E = X

  module AvlProofs = AvlProofs(I)(X)

  type 'elt bbst =
    'elt AvlProofs.Raw.tree
    (* singleton inductive, whose constructor was Bbst *)

  (** val this : 'a1 bbst -> 'a1 AvlProofs.Raw.tree **)

  let this b =
    b

  type 'elt t = 'elt bbst

  type key = E.t

  (** val empty : 'a1 t **)

  let empty =
    AvlProofs.Raw.empty

  (** val is_empty : 'a1 t -> bool **)

  let is_empty m4 =
    AvlProofs.Raw.is_empty (this m4)

  (** val add : key -> 'a1 -> 'a1 t -> 'a1 t **)

  let add x e m4 =
    AvlProofs.Raw.add x e (this m4)

  (** val remove : key -> 'a1 t -> 'a1 t **)

  let remove x m4 =
    AvlProofs.Raw.remove x (this m4)

  (** val mem : key -> 'a1 t -> bool **)

  let mem x m4 =
    AvlProofs.Raw.mem x (this m4)

  (** val find : key -> 'a1 t -> 'a1 option **)

  let find x m4 =
    AvlProofs.Raw.find x (this m4)

  (** val map : ('a1 -> 'a2) -> 'a1 t -> 'a2 t **)

  let map f m4 =
    AvlProofs.Raw.map f (this m4)

  (** val mapi : (key -> 'a1 -> 'a2) -> 'a1 t -> 'a2 t **)

  let mapi f m4 =
    AvlProofs.Raw.mapi f (this m4)

  (** val map2 :
      ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t **)

  let map2 f m4 m'0 =
    AvlProofs.Raw.map2 f (this m4) (this m'0)

  (** val elements : 'a1 t -> (key * 'a1) list **)

  let elements m4 =
    AvlProofs.Raw.elements (this m4)

  (** val cardinal : 'a1 t -> nat **)

  let cardinal m4 =
    AvlProofs.Raw.cardinal (this m4)

  (** val fold : (key -> 'a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 **)

  let fold f m4 i =
    AvlProofs.Raw.fold f (this m4) i

  (** val equal : ('a1 -> 'a1 -> bool) -> 'a1 t -> 'a1 t -> bool **)

  let equal cmp0 m4 m'0 =
    AvlProofs.Raw.equal cmp0 (this m4) (this m'0)
 end

module Make =
 functor (X:Coq_OrderedType) ->
 IntMake(Z_as_Int)(X)

module StringMap = Make(String_as_OT)

module MakeRaw =
 functor (I:Int) ->
 functor (X:OrderedType) ->
 struct
  type elt = X.t

  type tree =
  | Leaf
  | Node of I.t * tree * X.t * tree

  (** val empty : tree **)

  let empty =
    Leaf

  (** val is_empty : tree -> bool **)

  let is_empty = function
  | Leaf -> true
  | Node (_, _, _, _) -> false

  (** val mem : X.t -> tree -> bool **)

  let rec mem x = function
  | Leaf -> false
  | Node (_, l, k, r0) ->
    (match X.compare x k with
     | Eq -> true
     | Lt -> mem x l
     | Gt -> mem x r0)

  (** val min_elt : tree -> elt option **)

  let rec min_elt = function
  | Leaf -> None
  | Node (_, l, x, _) ->
    (match l with
     | Leaf -> Some x
     | Node (_, _, _, _) -> min_elt l)

  (** val max_elt : tree -> elt option **)

  let rec max_elt = function
  | Leaf -> None
  | Node (_, _, x, r0) ->
    (match r0 with
     | Leaf -> Some x
     | Node (_, _, _, _) -> max_elt r0)

  (** val choose : tree -> elt option **)

  let choose =
    min_elt

  (** val fold : (elt -> 'a1 -> 'a1) -> tree -> 'a1 -> 'a1 **)

  let rec fold f t0 base1 =
    match t0 with
    | Leaf -> base1
    | Node (_, l, x, r0) -> fold f r0 (f x (fold f l base1))

  (** val elements_aux : X.t list -> tree -> X.t list **)

  let rec elements_aux acc = function
  | Leaf -> acc
  | Node (_, l, x, r0) -> elements_aux (x :: (elements_aux acc r0)) l

  (** val elements : tree -> X.t list **)

  let elements =
    elements_aux []

  (** val rev_elements_aux : X.t list -> tree -> X.t list **)

  let rec rev_elements_aux acc = function
  | Leaf -> acc
  | Node (_, l, x, r0) -> rev_elements_aux (x :: (rev_elements_aux acc l)) r0

  (** val rev_elements : tree -> X.t list **)

  let rev_elements =
    rev_elements_aux []

  (** val cardinal : tree -> nat **)

  let rec cardinal = function
  | Leaf -> O
  | Node (_, l, _, r0) -> S (add (cardinal l) (cardinal r0))

  (** val maxdepth : tree -> nat **)

  let rec maxdepth = function
  | Leaf -> O
  | Node (_, l, _, r0) -> S (max (maxdepth l) (maxdepth r0))

  (** val mindepth : tree -> nat **)

  let rec mindepth = function
  | Leaf -> O
  | Node (_, l, _, r0) -> S (min (mindepth l) (mindepth r0))

  (** val for_all : (elt -> bool) -> tree -> bool **)

  let rec for_all f = function
  | Leaf -> true
  | Node (_, l, x, r0) ->
    if if f x then for_all f l else false then for_all f r0 else false

  (** val exists_ : (elt -> bool) -> tree -> bool **)

  let rec exists_ f = function
  | Leaf -> false
  | Node (_, l, x, r0) ->
    if if f x then true else exists_ f l then true else exists_ f r0

  type enumeration =
  | End
  | More of elt * tree * enumeration

  (** val cons : tree -> enumeration -> enumeration **)

  let rec cons s0 e =
    match s0 with
    | Leaf -> e
    | Node (_, l, x, r0) -> cons l (More (x, r0, e))

  (** val compare_more :
      X.t -> (enumeration -> comparison) -> enumeration -> comparison **)

  let compare_more x1 cont = function
  | End -> Gt
  | More (x2, r2, e3) ->
    (match X.compare x1 x2 with
     | Eq -> cont (cons r2 e3)
     | Lt -> Lt
     | Gt -> Gt)

  (** val compare_cont :
      tree -> (enumeration -> comparison) -> enumeration -> comparison **)

  let rec compare_cont s1 cont e2 =
    match s1 with
    | Leaf -> cont e2
    | Node (_, l1, x1, r1) ->
      compare_cont l1 (compare_more x1 (compare_cont r1 cont)) e2

  (** val compare_end : enumeration -> comparison **)

  let compare_end = function
  | End -> Eq
  | More (_, _, _) -> Lt

  (** val compare : tree -> tree -> comparison **)

  let compare s1 s2 =
    compare_cont s1 compare_end (cons s2 End)

  (** val equal : tree -> tree -> bool **)

  let equal s1 s2 =
    match compare s1 s2 with
    | Eq -> true
    | Lt -> false
    | Gt -> false

  (** val subsetl : (tree -> bool) -> X.t -> tree -> bool **)

  let rec subsetl subset_l1 x1 s2 = match s2 with
  | Leaf -> false
  | Node (_, l2, x2, r2) ->
    (match X.compare x1 x2 with
     | Eq -> subset_l1 l2
     | Lt -> subsetl subset_l1 x1 l2
     | Gt -> if mem x1 r2 then subset_l1 s2 else false)

  (** val subsetr : (tree -> bool) -> X.t -> tree -> bool **)

  let rec subsetr subset_r1 x1 s2 = match s2 with
  | Leaf -> false
  | Node (_, l2, x2, r2) ->
    (match X.compare x1 x2 with
     | Eq -> subset_r1 r2
     | Lt -> if mem x1 l2 then subset_r1 s2 else false
     | Gt -> subsetr subset_r1 x1 r2)

  (** val subset : tree -> tree -> bool **)

  let rec subset s1 s2 =
    match s1 with
    | Leaf -> true
    | Node (_, l1, x1, r1) ->
      (match s2 with
       | Leaf -> false
       | Node (_, l2, x2, r2) ->
         (match X.compare x1 x2 with
          | Eq -> if subset l1 l2 then subset r1 r2 else false
          | Lt -> if subsetl (subset l1) x1 l2 then subset r1 s2 else false
          | Gt -> if subsetr (subset r1) x1 r2 then subset l1 s2 else false))

  type t = tree

  (** val height : t -> I.t **)

  let height = function
  | Leaf -> I._0
  | Node (h, _, _, _) -> h

  (** val singleton : X.t -> tree **)

  let singleton x =
    Node (I._1, Leaf, x, Leaf)

  (** val create : t -> X.t -> t -> tree **)

  let create l x r0 =
    Node ((I.add (I.max (height l) (height r0)) I._1), l, x, r0)

  (** val assert_false : t -> X.t -> t -> tree **)

  let assert_false =
    create

  (** val bal : t -> X.t -> t -> tree **)

  let bal l x r0 =
    let hl = height l in
    let hr = height r0 in
    if I.ltb (I.add hr I._2) hl
    then (match l with
          | Leaf -> assert_false l x r0
          | Node (_, ll, lx, lr) ->
            if I.leb (height lr) (height ll)
            then create ll lx (create lr x r0)
            else (match lr with
                  | Leaf -> assert_false l x r0
                  | Node (_, lrl, lrx, lrr) ->
                    create (create ll lx lrl) lrx (create lrr x r0)))
    else if I.ltb (I.add hl I._2) hr
         then (match r0 with
               | Leaf -> assert_false l x r0
               | Node (_, rl, rx, rr) ->
                 if I.leb (height rl) (height rr)
                 then create (create l x rl) rx rr
                 else (match rl with
                       | Leaf -> assert_false l x r0
                       | Node (_, rll, rlx, rlr) ->
                         create (create l x rll) rlx (create rlr rx rr)))
         else create l x r0

  (** val add : X.t -> tree -> tree **)

  let rec add x = function
  | Leaf -> Node (I._1, Leaf, x, Leaf)
  | Node (h, l, y, r0) ->
    (match X.compare x y with
     | Eq -> Node (h, l, y, r0)
     | Lt -> bal (add x l) y r0
     | Gt -> bal l y (add x r0))

  (** val join : tree -> elt -> t -> t **)

  let rec join l = match l with
  | Leaf -> add
  | Node (lh, ll, lx, lr) ->
    (fun x ->
      let rec join_aux r0 = match r0 with
      | Leaf -> add x l
      | Node (rh, rl, rx, rr) ->
        if I.ltb (I.add rh I._2) lh
        then bal ll lx (join lr x r0)
        else if I.ltb (I.add lh I._2) rh
             then bal (join_aux rl) rx rr
             else create l x r0
      in join_aux)

  (** val remove_min : tree -> elt -> t -> t * elt **)

  let rec remove_min l x r0 =
    match l with
    | Leaf -> (r0, x)
    | Node (_, ll, lx, lr) ->
      let (l', m4) = remove_min ll lx lr in ((bal l' x r0), m4)

  (** val merge : tree -> tree -> tree **)

  let merge s1 s2 =
    match s1 with
    | Leaf -> s2
    | Node (_, _, _, _) ->
      (match s2 with
       | Leaf -> s1
       | Node (_, l2, x2, r2) ->
         let (s2', m4) = remove_min l2 x2 r2 in bal s1 m4 s2')

  (** val remove : X.t -> tree -> tree **)

  let rec remove x = function
  | Leaf -> Leaf
  | Node (_, l, y, r0) ->
    (match X.compare x y with
     | Eq -> merge l r0
     | Lt -> bal (remove x l) y r0
     | Gt -> bal l y (remove x r0))

  (** val concat : tree -> tree -> tree **)

  let concat s1 s2 =
    match s1 with
    | Leaf -> s2
    | Node (_, _, _, _) ->
      (match s2 with
       | Leaf -> s1
       | Node (_, l2, x2, r2) ->
         let (s2', m4) = remove_min l2 x2 r2 in join s1 m4 s2')

  type triple = { t_left : t; t_in : bool; t_right : t }

  (** val t_left : triple -> t **)

  let t_left t0 =
    t0.t_left

  (** val t_in : triple -> bool **)

  let t_in t0 =
    t0.t_in

  (** val t_right : triple -> t **)

  let t_right t0 =
    t0.t_right

  (** val split : X.t -> tree -> triple **)

  let rec split x = function
  | Leaf -> { t_left = Leaf; t_in = false; t_right = Leaf }
  | Node (_, l, y, r0) ->
    (match X.compare x y with
     | Eq -> { t_left = l; t_in = true; t_right = r0 }
     | Lt ->
       let { t_left = ll; t_in = b; t_right = rl } = split x l in
       { t_left = ll; t_in = b; t_right = (join rl y r0) }
     | Gt ->
       let { t_left = rl; t_in = b; t_right = rr } = split x r0 in
       { t_left = (join l y rl); t_in = b; t_right = rr })

  (** val inter : tree -> tree -> tree **)

  let rec inter s1 s2 =
    match s1 with
    | Leaf -> Leaf
    | Node (_, l1, x1, r1) ->
      (match s2 with
       | Leaf -> Leaf
       | Node (_, _, _, _) ->
         let { t_left = l2'; t_in = pres; t_right = r2' } = split x1 s2 in
         if pres
         then join (inter l1 l2') x1 (inter r1 r2')
         else concat (inter l1 l2') (inter r1 r2'))

  (** val diff : tree -> tree -> tree **)

  let rec diff s1 s2 =
    match s1 with
    | Leaf -> Leaf
    | Node (_, l1, x1, r1) ->
      (match s2 with
       | Leaf -> s1
       | Node (_, _, _, _) ->
         let { t_left = l2'; t_in = pres; t_right = r2' } = split x1 s2 in
         if pres
         then concat (diff l1 l2') (diff r1 r2')
         else join (diff l1 l2') x1 (diff r1 r2'))

  (** val union : tree -> tree -> tree **)

  let rec union s1 s2 =
    match s1 with
    | Leaf -> s2
    | Node (_, l1, x1, r1) ->
      (match s2 with
       | Leaf -> s1
       | Node (_, _, _, _) ->
         let { t_left = l2'; t_in = _; t_right = r2' } = split x1 s2 in
         join (union l1 l2') x1 (union r1 r2'))

  (** val filter : (elt -> bool) -> tree -> tree **)

  let rec filter f = function
  | Leaf -> Leaf
  | Node (_, l, x, r0) ->
    let l' = filter f l in
    let r'0 = filter f r0 in if f x then join l' x r'0 else concat l' r'0

  (** val partition : (elt -> bool) -> t -> t * t **)

  let rec partition f = function
  | Leaf -> (Leaf, Leaf)
  | Node (_, l, x, r0) ->
    let (l1, l2) = partition f l in
    let (r1, r2) = partition f r0 in
    if f x
    then ((join l1 x r1), (concat l2 r2))
    else ((concat l1 r1), (join l2 x r2))

  (** val ltb_tree : X.t -> tree -> bool **)

  let rec ltb_tree x = function
  | Leaf -> true
  | Node (_, l, y, r0) ->
    (match X.compare x y with
     | Eq -> false
     | Lt -> false
     | Gt -> (&&) (ltb_tree x l) (ltb_tree x r0))

  (** val gtb_tree : X.t -> tree -> bool **)

  let rec gtb_tree x = function
  | Leaf -> true
  | Node (_, l, y, r0) ->
    (match X.compare x y with
     | Eq -> false
     | Lt -> (&&) (gtb_tree x l) (gtb_tree x r0)
     | Gt -> false)

  (** val isok : tree -> bool **)

  let rec isok = function
  | Leaf -> true
  | Node (_, l, x, r0) ->
    (&&) ((&&) ((&&) (isok l) (isok r0)) (ltb_tree x l)) (gtb_tree x r0)

  module MX = OrderedTypeFacts(X)

  module L = MakeListOrdering(X)

  (** val flatten_e : enumeration -> elt list **)

  let rec flatten_e = function
  | End -> []
  | More (x, t0, r0) -> x :: (app (elements t0) (flatten_e r0))

  type coq_R_bal =
  | R_bal_0 of t * X.t * t
  | R_bal_1 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_2 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_3 of t * X.t * t * I.t * tree * X.t * tree * I.t * tree * X.t * tree
  | R_bal_4 of t * X.t * t
  | R_bal_5 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_6 of t * X.t * t * I.t * tree * X.t * tree
  | R_bal_7 of t * X.t * t * I.t * tree * X.t * tree * I.t * tree * X.t * tree
  | R_bal_8 of t * X.t * t

  type coq_R_remove_min =
  | R_remove_min_0 of tree * elt * t
  | R_remove_min_1 of tree * elt * t * I.t * tree * X.t * tree * (t * elt)
     * coq_R_remove_min * t * elt

  type coq_R_merge =
  | R_merge_0 of tree * tree
  | R_merge_1 of tree * tree * I.t * tree * X.t * tree
  | R_merge_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * elt

  type coq_R_concat =
  | R_concat_0 of tree * tree
  | R_concat_1 of tree * tree * I.t * tree * X.t * tree
  | R_concat_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * elt

  type coq_R_inter =
  | R_inter_0 of tree * tree
  | R_inter_1 of tree * tree * I.t * tree * X.t * tree
  | R_inter_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_inter * tree * coq_R_inter
  | R_inter_3 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_inter * tree * coq_R_inter

  type coq_R_diff =
  | R_diff_0 of tree * tree
  | R_diff_1 of tree * tree * I.t * tree * X.t * tree
  | R_diff_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_diff * tree * coq_R_diff
  | R_diff_3 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_diff * tree * coq_R_diff

  type coq_R_union =
  | R_union_0 of tree * tree
  | R_union_1 of tree * tree * I.t * tree * X.t * tree
  | R_union_2 of tree * tree * I.t * tree * X.t * tree * I.t * tree * 
     X.t * tree * t * bool * t * tree * coq_R_union * tree * coq_R_union
 end

module Coq_IntMake =
 functor (I:Int) ->
 functor (X:OrderedType) ->
 struct
  module Raw = MakeRaw(I)(X)

  module E =
   struct
    type t = X.t

    (** val compare : t -> t -> comparison **)

    let compare =
      X.compare

    (** val eq_dec : t -> t -> bool **)

    let eq_dec =
      X.eq_dec
   end

  type elt = X.t

  type t_ = Raw.t
    (* singleton inductive, whose constructor was Mkt *)

  (** val this : t_ -> Raw.t **)

  let this t0 =
    t0

  type t = t_

  (** val mem : elt -> t -> bool **)

  let mem x s0 =
    Raw.mem x (this s0)

  (** val add : elt -> t -> t **)

  let add x s0 =
    Raw.add x (this s0)

  (** val remove : elt -> t -> t **)

  let remove x s0 =
    Raw.remove x (this s0)

  (** val singleton : elt -> t **)

  let singleton =
    Raw.singleton

  (** val union : t -> t -> t **)

  let union s0 s' =
    Raw.union (this s0) (this s')

  (** val inter : t -> t -> t **)

  let inter s0 s' =
    Raw.inter (this s0) (this s')

  (** val diff : t -> t -> t **)

  let diff s0 s' =
    Raw.diff (this s0) (this s')

  (** val equal : t -> t -> bool **)

  let equal s0 s' =
    Raw.equal (this s0) (this s')

  (** val subset : t -> t -> bool **)

  let subset s0 s' =
    Raw.subset (this s0) (this s')

  (** val empty : t **)

  let empty =
    Raw.empty

  (** val is_empty : t -> bool **)

  let is_empty s0 =
    Raw.is_empty (this s0)

  (** val elements : t -> elt list **)

  let elements s0 =
    Raw.elements (this s0)

  (** val choose : t -> elt option **)

  let choose s0 =
    Raw.choose (this s0)

  (** val fold : (elt -> 'a1 -> 'a1) -> t -> 'a1 -> 'a1 **)

  let fold f s0 =
    Raw.fold f (this s0)

  (** val cardinal : t -> nat **)

  let cardinal s0 =
    Raw.cardinal (this s0)

  (** val filter : (elt -> bool) -> t -> t **)

  let filter f s0 =
    Raw.filter f (this s0)

  (** val for_all : (elt -> bool) -> t -> bool **)

  let for_all f s0 =
    Raw.for_all f (this s0)

  (** val exists_ : (elt -> bool) -> t -> bool **)

  let exists_ f s0 =
    Raw.exists_ f (this s0)

  (** val partition : (elt -> bool) -> t -> t * t **)

  let partition f s0 =
    let p = Raw.partition f (this s0) in ((fst p), (snd p))

  (** val eq_dec : t -> t -> bool **)

  let eq_dec s0 s'0 =
    let b = Raw.equal s0 s'0 in
    (if b then (fun _ -> true) else (fun _ -> false)) __

  (** val compare : t -> t -> comparison **)

  let compare s0 s' =
    Raw.compare (this s0) (this s')

  (** val min_elt : t -> elt option **)

  let min_elt s0 =
    Raw.min_elt (this s0)

  (** val max_elt : t -> elt option **)

  let max_elt s0 =
    Raw.max_elt (this s0)
 end

module Coq_Make =
 functor (X:OrderedType) ->
 Coq_IntMake(Z_as_Int)(X)

module StringSet = Coq_Make(Coq_String_as_OT)

type flag_status =
| Enabled
| Disabled

type full_flag_status =
| Explicit of flag_status
| Elided

(** val bool_of_flag_status : flag_status -> bool **)

let bool_of_flag_status = function
| Enabled -> true
| Disabled -> false

(** val bool_of_full_flag_status : full_flag_status -> bool -> bool **)

let bool_of_full_flag_status d default0 =
  match d with
  | Explicit d0 -> bool_of_flag_status d0
  | Elided -> default0

type flag_option_kind =
| All
| Alias of char list list

(** val simple : char list -> flag_option_kind **)

let simple s0 =
  Alias (s0 :: [])

(** val preparse_flag_opts :
    (char list * flag_option_kind) list -> char list list ->
    (flag_option_kind * flag_status) list **)

let preparse_flag_opts spec0 args0 =
  let spec1 =
    fold_left (fun acc pat -> let (s0, k) = pat in StringMap.add s0 k acc)
      spec0 StringMap.empty
  in
  let args1 =
    filter (fun s0 -> negb (eqb0 s0 []))
      (map trim (flat_map (split (','::[])) args0))
  in
  map (fun arg ->
    let (prefix1, shortened_arg) = ((substring O (S O) arg),
      (substring (S O) (length0 arg) arg))
    in
    let (status, arg0) =
      if eqb0 prefix1 ('-'::[])
      then (Disabled, shortened_arg)
      else if eqb0 prefix1 ('+'::[])
           then (Enabled, shortened_arg)
           else (Enabled, arg)
    in
    ((sequence_return (StringMap.find arg0 spec1) (simple arg0)), status))
    args1

(** val aggregate_flag_opts :
    (flag_option_kind * flag_status) list -> full_flag_status * flag_status
    StringMap.t **)

let aggregate_flag_opts args0 =
  fold_left (fun pat ->
    let (all_status, acc) = pat in
    (fun pat0 ->
    let (k, s0) = pat0 in
    (match k with
     | All -> ((Explicit s0), (StringMap.map (fun _ -> s0) acc))
     | Alias ls ->
       (all_status,
         (fold_left (fun acc0 arg -> StringMap.add arg s0 acc0) ls acc)))))
    args0 (Elided, StringMap.empty)

(** val format_flag_opts :
    char list list -> flag_status StringMap.t -> full_flag_status tuple **)

let rec format_flag_opts known_options status =
  match known_options with
  | [] -> Obj.magic ()
  | opt :: opts ->
    cons (length opts)
      (match StringMap.find opt status with
       | Some s0 -> Explicit s0
       | None -> Elided) (format_flag_opts opts status)

(** val post_parse_flag_opts :
    char list list -> (full_flag_status * flag_status StringMap.t) ->
    (full_flag_status * (char list * flag_status) list) * full_flag_status
    tuple **)

let post_parse_flag_opts known_options = function
| (all_status, status0) ->
  let known_options_set =
    fold_right StringSet.add StringSet.empty known_options
  in
  let unknown_options =
    filter (fun pat ->
      let (opt, _) = pat in negb (StringSet.mem opt known_options_set))
      (StringMap.elements status0)
  in
  ((all_status, unknown_options), (format_flag_opts known_options status0))

(** val post_parse_flag_opts_to_filter :
    char list list -> (full_flag_status * flag_status StringMap.t) ->
    (full_flag_status * (char list * flag_status) list) * (char list ->
    full_flag_status) **)

let post_parse_flag_opts_to_filter known_options = function
| (all_status, status0) ->
  let known_options_set =
    fold_right StringSet.add StringSet.empty known_options
  in
  let unknown_options =
    filter (fun pat ->
      let (opt, _) = pat in negb (StringSet.mem opt known_options_set))
      (StringMap.elements status0)
  in
  ((all_status, unknown_options), (fun s0 ->
  match StringMap.find s0 status0 with
  | Some s1 -> Explicit s1
  | None -> Elided))

(** val parse_flag_opts :
    (char list * flag_option_kind) list -> char list list -> char list list
    -> (full_flag_status * (char list * flag_status) list) * full_flag_status
    tuple **)

let parse_flag_opts spec0 known_options args0 =
  let res = preparse_flag_opts spec0 args0 in
  let res0 = aggregate_flag_opts res in
  post_parse_flag_opts known_options res0

(** val parse_flag_opts_to_filter :
    (char list * flag_option_kind) list -> char list list -> char list list
    -> (full_flag_status * (char list * flag_status) list) * (char list ->
    full_flag_status) **)

let parse_flag_opts_to_filter spec0 known_options args0 =
  let res = preparse_flag_opts spec0 args0 in
  let res0 = aggregate_flag_opts res in
  post_parse_flag_opts_to_filter known_options res0

(** val parse_flag_opts_to_bool_filter :
    bool -> (char list * flag_option_kind) list -> char list list ->
    char list list -> (char list * flag_status) list * (char list -> bool) **)

let parse_flag_opts_to_bool_filter default0 spec0 known_options args0 =
  let (p, filter0) = parse_flag_opts_to_filter spec0 known_options args0 in
  let (_, unknown) = p in
  (unknown, (fun s0 -> bool_of_full_flag_status (filter0 s0) default0))

module Coq_tree =
 struct
  type 't t =
  | Coq_empty
  | Coq_singleton of 't
  | Coq_app of 't t * 't t

  (** val smart_app : 'a1 t -> 'a1 t -> 'a1 t **)

  let smart_app x y =
    match x with
    | Coq_empty -> y
    | Coq_singleton _ ->
      (match y with
       | Coq_empty -> x
       | Coq_singleton _ -> Coq_app (x, y)
       | Coq_app (_, _) -> Coq_app (x, y))
    | Coq_app (_, _) ->
      (match y with
       | Coq_empty -> x
       | Coq_singleton _ -> Coq_app (x, y)
       | Coq_app (_, _) -> Coq_app (x, y))

  (** val fold : ('a1 -> 'a2 -> 'a2) -> 'a1 t -> 'a2 -> 'a2 **)

  let fold f =
    let rec fold0 v init =
      match v with
      | Coq_empty -> init
      | Coq_singleton v0 -> f v0 init
      | Coq_app (l, r0) -> fold0 l (fold0 r0 init)
    in fold0

  (** val to_list : 'a1 t -> 'a1 list **)

  let to_list v =
    fold (fun x x0 -> x :: x0) v []
 end

type ('dbg, 't) debugM = (unit -> 'dbg list) Coq_tree.t * 't

module Debug =
 struct
  (** val debug' : (unit -> 'a1 list) -> ('a1, unit) debugM **)

  let debug' msg =
    ((Coq_tree.Coq_singleton msg), ())

  (** val bind :
      ('a1, 'a2) debugM -> ('a2 -> ('a1, 'a3) debugM) -> ('a1, 'a3) debugM **)

  let bind x k =
    let (dbg1, a) = ((fst x), (snd x)) in
    let ka = k a in
    let (dbg2, b) = ((fst ka), (snd ka)) in
    ((Coq_tree.smart_app dbg1 dbg2), b)

  (** val sequence :
      ('a1, unit) debugM -> ('a1, 'a2) debugM -> ('a1, 'a2) debugM **)

  let sequence x k =
    bind x (fun pat -> let () = pat in k)

  (** val ret : 'a2 -> ('a1, 'a2) debugM **)

  let ret a =
    (Coq_tree.Coq_empty, a)

  (** val eval_result : ('a1, 'a2) debugM -> 'a2 **)

  let eval_result =
    snd

  (** val copy_debug_info : ('a1, 'a2) debugM -> ('a1, unit) debugM **)

  let copy_debug_info x =
    bind x (fun _ -> ret ())

  (** val with_debug_info :
      ('a1, 'a2) debugM -> ('a1, 'a3) debugM -> ('a1, 'a3) debugM **)

  let with_debug_info x y =
    sequence (copy_debug_info x) y

  (** val get_debug_info : ('a1, 'a2) debugM -> (unit -> 'a1 list) list **)

  let get_debug_info v =
    Coq_tree.to_list (fst v)
 end

(** val qfloor : q -> z **)

let qfloor x =
  let { qnum = n3; qden = d } = x in Coq_Z.div n3 (Zpos d)

(** val qceiling : q -> z **)

let qceiling x =
  Coq_Z.opp (qfloor (qopp x))

module Coq8_Compilers =
 struct
  module Coq_partial =
   struct
    type ('base_type, 'x) abstract_domain =
      ('base_type, 'x) Compilers.Coq_type.interp

    type ('base_type, 'ident, 'var, 'x) value = __

    type ('base_type, 'ident, 'var, 'x) value_with_lets =
      ('base_type, 'ident, 'var, ('base_type, 'ident, 'var, 'x) value)
      Coq_Compilers.UnderLets.coq_UnderLets

    (** val bottom :
        ('a1 -> 'a2) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2)
        abstract_domain **)

    let bottom bottom'0 =
      let rec bottom0 = function
      | Compilers.Coq_type.Coq_base t1 -> Obj.magic bottom'0 t1
      | Compilers.Coq_type.Coq_arrow (_, d) -> Obj.magic (fun _ -> bottom0 d)
      in bottom0

    (** val bottom_for_each_lhs_of_arrow :
        ('a1 -> 'a2) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, ('a1, 'a2)
        abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow **)

    let bottom_for_each_lhs_of_arrow bottom'0 =
      let rec bottom_for_each_lhs_of_arrow0 = function
      | Compilers.Coq_type.Coq_base _ -> Obj.magic ()
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        Obj.magic ((bottom bottom'0 s0), (bottom_for_each_lhs_of_arrow0 d))
      in bottom_for_each_lhs_of_arrow0

    (** val state_of_value :
        ('a1 -> 'a4) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3,
        'a4) value -> ('a1, 'a4) abstract_domain **)

    let state_of_value bottom'0 t0 x =
      (match t0 with
       | Compilers.Coq_type.Coq_base _ ->
         (fun pat -> let (st, _) = Obj.magic pat in st)
       | Compilers.Coq_type.Coq_arrow (s0, d) ->
         (fun _ -> bottom bottom'0 (Compilers.Coq_type.Coq_arrow (s0, d)))) x

    (** val bottomify :
        ('a1 -> 'a4) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3,
        'a4) value -> ('a1, 'a2, 'a3, 'a4) value_with_lets **)

    let bottomify bottom'0 t0 x =
      let rec bottomify0 = function
      | Compilers.Coq_type.Coq_base t2 ->
        (fun pat ->
          let (_, v) = Obj.magic pat in
          Coq_Compilers.UnderLets.Base (Obj.magic ((bottom'0 t2), v)))
      | Compilers.Coq_type.Coq_arrow (_, d) ->
        (fun f -> Coq_Compilers.UnderLets.Base
          (Obj.magic (fun x0 ->
            Coq_Compilers.UnderLets.splice (Obj.magic f x0) (fun fx ->
              bottomify0 d fx))))
      in bottomify0 t0 x

    (** val reify :
        (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr ->
        ('a1, 'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
        Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> bool ->
        bool -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3, 'a4) value
        -> ('a1, ('a1, 'a4) abstract_domain)
        Compilers.Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3, ('a1,
        'a2, 'a3) Compilers.Coq_expr.expr)
        Coq_Compilers.UnderLets.coq_UnderLets **)

    let reify annotate0 bottom'0 annotate_with_state is_let_bound t0 x x0 =
      let type_base0 = fun x1 -> Compilers.Coq_type.Coq_base x1 in
      let rec reify0 annotate_with_state0 is_let_bound0 = function
      | Compilers.Coq_type.Coq_base t2 ->
        (fun pat ->
          let (st, v) = Obj.magic pat in
          (fun pat0 ->
          let () = Obj.magic pat0 in
          if annotate_with_state0
          then annotate0 is_let_bound0 t2 st v
          else if is_let_bound0
               then Coq_Compilers.UnderLets.UnderLet ((type_base0 t2), v,
                      (fun v' -> Coq_Compilers.UnderLets.Base
                      (Compilers.Coq_expr.Var ((type_base0 t2), v'))))
               else Coq_Compilers.UnderLets.Base v))
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun f_e pat ->
          let (sv, dv) = Obj.magic pat in
          let sv0 =
            match s0 with
            | Compilers.Coq_type.Coq_base _ -> sv
            | Compilers.Coq_type.Coq_arrow (_, _) -> bottom bottom'0 s0
          in
          Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Abs (s0, d,
          (fun x1 ->
          Coq_Compilers.UnderLets.to_expr d
            (Coq_Compilers.UnderLets.splice
              (Obj.magic f_e
                (reflect0 annotate_with_state0 s0 (Compilers.Coq_expr.Var
                  (s0, x1)) sv0)) (fun fx ->
              reify0 annotate_with_state0 false d fx dv))))))
      and reflect0 annotate_with_state0 = function
      | Compilers.Coq_type.Coq_base _ -> (fun e st -> (st, e))
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun e absf ->
          Obj.magic (fun v ->
            let stv = state_of_value bottom'0 s0 v in
            Coq_Compilers.UnderLets.splice
              (reify0 annotate_with_state0 false s0 v
                (bottom_for_each_lhs_of_arrow bottom'0 s0)) (fun rv ->
              Coq_Compilers.UnderLets.Base
              (reflect0 annotate_with_state0 d (Compilers.Coq_expr.App (s0,
                d, e, rv)) (Obj.magic absf stv)))))
      in reify0 annotate_with_state is_let_bound t0 x x0

    (** val reflect :
        (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr ->
        ('a1, 'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
        Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> bool -> 'a1
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1, 'a4) abstract_domain -> ('a1, 'a2,
        'a3, 'a4) value **)

    let reflect annotate0 bottom'0 annotate_with_state t0 x x0 =
      let type_base0 = fun x1 -> Compilers.Coq_type.Coq_base x1 in
      let rec reify0 annotate_with_state0 is_let_bound = function
      | Compilers.Coq_type.Coq_base t2 ->
        (fun pat ->
          let (st, v) = pat in
          (fun pat0 ->
          let () = pat0 in
          if annotate_with_state0
          then annotate0 is_let_bound t2 st v
          else if is_let_bound
               then Coq_Compilers.UnderLets.UnderLet ((type_base0 t2), v,
                      (fun v' -> Coq_Compilers.UnderLets.Base
                      (Compilers.Coq_expr.Var ((type_base0 t2), v'))))
               else Coq_Compilers.UnderLets.Base v))
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun f_e pat ->
          let (sv, dv) = Obj.magic pat in
          let sv0 =
            match s0 with
            | Compilers.Coq_type.Coq_base _ -> sv
            | Compilers.Coq_type.Coq_arrow (_, _) -> bottom bottom'0 s0
          in
          Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Abs (s0, d,
          (fun x1 ->
          Coq_Compilers.UnderLets.to_expr d
            (Coq_Compilers.UnderLets.splice
              (Obj.magic f_e
                (reflect0 annotate_with_state0 s0 (Compilers.Coq_expr.Var
                  (s0, x1)) sv0)) (fun fx ->
              reify0 annotate_with_state0 false d fx dv))))))
      and reflect0 annotate_with_state0 = function
      | Compilers.Coq_type.Coq_base _ -> (fun e st -> Obj.magic (st, e))
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun e absf ->
          Obj.magic (fun v ->
            let stv = state_of_value bottom'0 s0 v in
            Coq_Compilers.UnderLets.splice
              (Obj.magic reify0 annotate_with_state0 false s0 v
                (bottom_for_each_lhs_of_arrow bottom'0 s0)) (fun rv ->
              Coq_Compilers.UnderLets.Base
              (reflect0 annotate_with_state0 d (Compilers.Coq_expr.App (s0,
                d, e, rv)) (Obj.magic absf stv)))))
      in reflect0 annotate_with_state t0 x x0

    (** val skip_annotations_for_App :
        ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr -> bool **)

    let skip_annotations_for_App skip_annotations_under t0 e =
      match Compilers.Coq_invert_expr.invert_AppIdent_curried t0 e with
      | Some s0 ->
        let ExistT (x, p) = s0 in
        let (idc, _) = p in skip_annotations_under x idc
      | None -> false

    (** val interp :
        (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr ->
        ('a1, 'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
        Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> ('a1
        Compilers.Coq_type.coq_type -> 'a2 -> bool) -> (bool -> 'a1
        Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a2, 'a3, 'a4)
        value_with_lets) -> bool -> 'a1 Compilers.Coq_type.coq_type -> ('a1,
        'a2, ('a1, 'a2, 'a3, 'a4) value_with_lets) Compilers.Coq_expr.expr ->
        ('a1, 'a2, 'a3, 'a4) value_with_lets **)

    let interp annotate0 bottom'0 skip_annotations_under interp_ident0 annotate_with_state t0 e =
      let rec interp0 annotate_with_state0 t1 e0 =
        let annotate_with_state1 =
          (&&) annotate_with_state0
            (negb (skip_annotations_for_App skip_annotations_under t1 e0))
        in
        (match e0 with
         | Compilers.Coq_expr.Ident (t2, idc) ->
           interp_ident0 annotate_with_state1 t2 idc
         | Compilers.Coq_expr.Var (_, v) -> v
         | Compilers.Coq_expr.Abs (_, d, f) ->
           Coq_Compilers.UnderLets.Base
             (Obj.magic (fun x ->
               interp0 annotate_with_state1 d
                 (f (Coq_Compilers.UnderLets.Base x))))
         | Compilers.Coq_expr.App (s0, d, f, x) ->
           (match s0 with
            | Compilers.Coq_type.Coq_base s1 ->
              (fun f0 x0 ->
                Coq_Compilers.UnderLets.splice
                  (interp0 annotate_with_state1 (Compilers.Coq_type.Coq_base
                    s1) x0) (fun x' ->
                  Coq_Compilers.UnderLets.splice
                    (Obj.magic interp0 annotate_with_state1
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base s1), d)) f0) (fun f' ->
                    f' x')))
            | Compilers.Coq_type.Coq_arrow (s', d') ->
              (fun f0 x0 ->
                Coq_Compilers.UnderLets.splice
                  (interp0 annotate_with_state1 (Compilers.Coq_type.Coq_arrow
                    (s', d')) x0) (fun x' ->
                  Coq_Compilers.UnderLets.splice
                    (bottomify bottom'0 (Compilers.Coq_type.Coq_arrow (s',
                      d')) x') (fun x'' ->
                    Coq_Compilers.UnderLets.splice
                      (Obj.magic interp0 annotate_with_state1
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow (s', d')), d)) f0)
                      (fun f' -> f' x''))))) f x
         | Compilers.Coq_expr.LetIn (a0, b, x, f) ->
           (match a0 with
            | Compilers.Coq_type.Coq_base a ->
              (fun x0 f0 ->
                Coq_Compilers.UnderLets.splice
                  (interp0 annotate_with_state1 (Compilers.Coq_type.Coq_base
                    a) x0) (fun x' ->
                  Coq_Compilers.UnderLets.splice
                    (reify annotate0 bottom'0 annotate_with_state1 true
                      (Compilers.Coq_type.Coq_base a) x' (Obj.magic ()))
                    (fun x'' ->
                    interp0 annotate_with_state1 b
                      (f0 (Coq_Compilers.UnderLets.Base
                        (reflect annotate0 bottom'0 annotate_with_state1
                          (Compilers.Coq_type.Coq_base a) x''
                          (state_of_value bottom'0
                            (Compilers.Coq_type.Coq_base a) x')))))))
            | Compilers.Coq_type.Coq_arrow (s0, d) ->
              (fun x0 f0 ->
                Coq_Compilers.UnderLets.splice
                  (interp0 annotate_with_state1 (Compilers.Coq_type.Coq_arrow
                    (s0, d)) x0) (fun x' ->
                  interp0 annotate_with_state1 b
                    (f0 (Coq_Compilers.UnderLets.Base x'))))) x f)
      in interp0 annotate_with_state t0 e

    (** val eval_with_bound' :
        (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr ->
        ('a1, 'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
        Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> ('a1
        Compilers.Coq_type.coq_type -> 'a2 -> bool) -> (bool -> 'a1
        Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a2, 'a3, 'a4)
        value_with_lets) -> bool -> 'a1 Compilers.Coq_type.coq_type -> ('a1,
        'a2, ('a1, 'a2, 'a3, 'a4) value_with_lets) Compilers.Coq_expr.expr ->
        ('a1, ('a1, 'a4) abstract_domain)
        Compilers.Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr **)

    let eval_with_bound' annotate0 bottom'0 skip_annotations_under interp_ident0 annotate_with_state t0 e st =
      Coq_Compilers.UnderLets.to_expr t0
        (Coq_Compilers.UnderLets.splice
          (interp annotate0 bottom'0 skip_annotations_under interp_ident0
            annotate_with_state t0 e) (fun e' ->
          reify annotate0 bottom'0 annotate_with_state false t0 e' st))

    (** val eta_expand_with_bound' :
        (bool -> 'a1 -> 'a4 -> ('a1, 'a2, 'a3) Compilers.Coq_expr.expr ->
        ('a1, 'a2, 'a3, ('a1, 'a2, 'a3) Compilers.Coq_expr.expr)
        Coq_Compilers.UnderLets.coq_UnderLets) -> ('a1 -> 'a4) -> 'a1
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr -> ('a1, ('a1, 'a4) abstract_domain)
        Compilers.Coq_type.for_each_lhs_of_arrow -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr **)

    let eta_expand_with_bound' annotate0 bottom'0 t0 e st =
      Coq_Compilers.UnderLets.to_expr t0
        (reify annotate0 bottom'0 true false t0
          (reflect annotate0 bottom'0 true t0 e (bottom bottom'0 t0)) st)

    (** val extract' :
        ('a1 -> 'a3) -> ('a1 Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a3)
        abstract_domain) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2,
        ('a1, 'a3) abstract_domain) Compilers.Coq_expr.expr -> ('a1, 'a3)
        abstract_domain **)

    let extract' bottom'0 ident_extract =
      let rec extract'0 _ = function
      | Compilers.Coq_expr.Ident (t0, idc) -> ident_extract t0 idc
      | Compilers.Coq_expr.Var (_, v) -> v
      | Compilers.Coq_expr.Abs (_, d, f) ->
        Obj.magic (fun v -> extract'0 d (f v))
      | Compilers.Coq_expr.App (s0, d, f, x) ->
        (match s0 with
         | Compilers.Coq_type.Coq_base s1 ->
           (fun f0 x0 ->
             Obj.magic extract'0 (Compilers.Coq_type.Coq_arrow
               ((Compilers.Coq_type.Coq_base s1), d)) f0
               (extract'0 (Compilers.Coq_type.Coq_base s1) x0))
         | Compilers.Coq_type.Coq_arrow (s', d') ->
           (fun f0 _ ->
             Obj.magic extract'0 (Compilers.Coq_type.Coq_arrow
               ((Compilers.Coq_type.Coq_arrow (s', d')), d)) f0
               (bottom bottom'0 (Compilers.Coq_type.Coq_arrow (s', d'))))) f x
      | Compilers.Coq_expr.LetIn (a, b, x, f) ->
        let_In (extract'0 a x) (fun y -> extract'0 b (f y))
      in extract'0

    (** val extract_gen :
        ('a1 -> 'a3) -> ('a1 Compilers.Coq_type.coq_type -> 'a2 -> ('a1, 'a3)
        abstract_domain) -> 'a1 Compilers.Coq_type.coq_type -> ('a1, 'a2,
        ('a1, 'a3) abstract_domain) Compilers.Coq_expr.expr -> ('a1, ('a1,
        'a3) abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow -> 'a3 **)

    let extract_gen bottom'0 ident_extract t0 e bound =
      Compilers.Coq_type.app_curried t0
        (extract' bottom'0 ident_extract t0 e) bound

    module Coq_ident =
     struct
      (** val update_annotation :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> 'a2 -> bool) -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr **)

      let update_annotation annotate_expr0 is_annotated_for0 t0 st e =
        let base1 = fun _ x -> Compilers.Coq_type.Coq_base x in
        (match e with
         | Compilers.Coq_expr.Ident (_, _) ->
           (match annotate_expr0 t0 st with
            | Some cst ->
              Compilers.Coq_expr.App ((base1 __ t0), (base1 __ t0), cst, e)
            | None -> e)
         | Compilers.Coq_expr.Var (_, _) ->
           (match annotate_expr0 t0 st with
            | Some cst ->
              Compilers.Coq_expr.App ((base1 __ t0), (base1 __ t0), cst, e)
            | None -> e)
         | Compilers.Coq_expr.Abs (_, _, _) ->
           (match annotate_expr0 t0 st with
            | Some cst ->
              Compilers.Coq_expr.App ((base1 __ t0), (base1 __ t0), cst, e)
            | None -> e)
         | Compilers.Coq_expr.App (s0, d, cst', _) ->
           (match annotate_expr0 t0 st with
            | Some cst ->
              if is_annotated_for0 (Compilers.Coq_type.Coq_arrow (s0, d)) t0
                   cst' st
              then e
              else Compilers.Coq_expr.App ((base1 __ t0), (base1 __ t0), cst,
                     e)
            | None -> e)
         | Compilers.Coq_expr.LetIn (_, _, _, _) ->
           (match annotate_expr0 t0 st with
            | Some cst ->
              Compilers.Coq_expr.App ((base1 __ t0), (base1 __ t0), cst, e)
            | None -> e))

      (** val annotate_with_expr :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> 'a2 -> bool) -> bool ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets **)

      let annotate_with_expr annotate_expr0 is_annotated_for0 is_let_bound t0 st e =
        let base1 = fun _ x -> Compilers.Coq_type.Coq_base x in
        let cst_e = update_annotation annotate_expr0 is_annotated_for0 t0 st e
        in
        if is_let_bound
        then Coq_Compilers.UnderLets.UnderLet ((base1 __ t0), cst_e,
               (fun v -> Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Var
               ((base1 __ t0), v))))
        else Coq_Compilers.UnderLets.Base cst_e

      (** val annotate_base :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> 'a2 -> bool) -> bool ->
          Coq3_Compilers.base -> 'a2 -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1,
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr)
          Coq_Compilers.UnderLets.coq_UnderLets **)

      let annotate_base annotate_expr0 is_annotated_for0 is_let_bound t0 st e =
        let type_base0 = fun x -> Compilers.Coq_base.Coq_type.Coq_type_base x
        in
        annotate_with_expr annotate_expr0 is_annotated_for0 is_let_bound
          (type_base0 t0) st e

      (** val annotate :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
          Compilers.Coq_type.interp) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          'a2 option option) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool)
          -> bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          -> 'a2 -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1,
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr)
          Coq_Compilers.UnderLets.coq_UnderLets **)

      let annotate annotate_expr0 abstract_interp_ident0 extract_list_state0 extract_option_state0 is_annotated_for0 is_let_bound t0 x x0 =
        let base1 = fun _ x1 -> Compilers.Coq_type.Coq_base x1 in
        let rec annotate0 is_let_bound0 = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
          annotate_base annotate_expr0 is_annotated_for0 is_let_bound0 t2
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          (fun st e ->
            match Compilers.Coq_invert_expr.invert_pair (fun _ x1 x2 _ ->
                    Coq3_Compilers.try_make_base_transport_cps x1 x2)
                    Coq3_Compilers.invertIdent a b e with
            | Some p ->
              let (x1, y) = p in
              let stx =
                Obj.magic abstract_interp_ident0
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                  (Compilers.Coq_type.Coq_base a)))
                  (Coq3_Compilers.Coq_ident_fst (a, b)) st
              in
              let sty =
                Obj.magic abstract_interp_ident0
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                  (Compilers.Coq_type.Coq_base b)))
                  (Coq3_Compilers.Coq_ident_snd (a, b)) st
              in
              Coq_Compilers.UnderLets.splice
                (annotate0 is_let_bound0 a stx x1) (fun x' ->
                Coq_Compilers.UnderLets.splice
                  (annotate0 is_let_bound0 b sty y) (fun y' ->
                  Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
                  ((Compilers.Coq_type.Coq_base b),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                  (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base a),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  b), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))),
                  (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base a),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  b), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))))),
                  (Coq3_Compilers.Coq_ident_pair (a, b)))), x')), y'))))
            | None ->
              annotate_with_expr annotate_expr0 is_annotated_for0
                is_let_bound0 (Compilers.Coq_base.Coq_type.Coq_prod (a, b))
                st e)
        | Compilers.Coq_base.Coq_type.Coq_list a ->
          (fun st e ->
            match extract_list_state0 a st with
            | Some ls_st ->
              (match Compilers.Coq_invert_expr.reflect_list (fun _ x1 x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x1 x2)
                       Coq3_Compilers.invertIdent a e with
               | Some ls_e ->
                 Coq_Compilers.UnderLets.splice_list
                   (map (fun pat ->
                     let (st', e') = pat in annotate0 is_let_bound0 a st' e')
                     (combine ls_st ls_e)) (fun retv ->
                   Coq_Compilers.UnderLets.Base
                   (Compilers.Coq_ident.reify_list Coq3_Compilers.buildIdent
                     a retv))
               | None ->
                 Coq_Compilers.UnderLets.splice_list
                   (map (fun pat ->
                     let (n3, st') = pat in
                     let e' = Compilers.Coq_expr.App
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       a), (Compilers.Coq_expr.App
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_list a)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       a))), (Compilers.Coq_expr.App
                       ((Compilers.Coq_type.Coq_base a),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_list a)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       a))))), (Compilers.Coq_expr.Ident
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base a),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_list a)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                       a))))))), (Coq3_Compilers.Coq_ident_List_nth_default
                       a))),
                       (Compilers.DefaultValue.Coq_expr.Coq_base.default
                         Coq3_Compilers.base_default
                         Coq3_Compilers.buildIdent a))), e)),
                       (Compilers.Coq_ident.smart_Literal
                         Coq3_Compilers.buildIdent
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat) (Obj.magic n3)))
                     in
                     annotate0 is_let_bound0 a st' e')
                     (combine (seq O (length ls_st)) ls_st)) (fun retv ->
                   Coq_Compilers.UnderLets.Base
                   (Compilers.Coq_ident.reify_list Coq3_Compilers.buildIdent
                     a retv)))
            | None ->
              annotate_with_expr annotate_expr0 is_annotated_for0
                is_let_bound0 (Compilers.Coq_base.Coq_type.Coq_list a) st e)
        | Compilers.Coq_base.Coq_type.Coq_option a ->
          (fun st e ->
            match extract_option_state0 a st with
            | Some v_st ->
              (match Compilers.Coq_invert_expr.reflect_option
                       (fun _ x1 x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x1 x2)
                       Coq3_Compilers.invertIdent a e with
               | Some v_e ->
                 Coq_Compilers.UnderLets.splice_option
                   (option_map (fun pat ->
                     let (st', e') = pat in annotate0 is_let_bound0 a st' e')
                     (combine0 v_st v_e)) (fun retv ->
                   Coq_Compilers.UnderLets.Base
                   (Compilers.Coq_ident.reify_option
                     Coq3_Compilers.buildIdent a retv))
               | None ->
                 annotate_with_expr annotate_expr0 is_annotated_for0
                   is_let_bound0 (Compilers.Coq_base.Coq_type.Coq_option a)
                   st e)
            | None ->
              annotate_with_expr annotate_expr0 is_annotated_for0
                is_let_bound0 (Compilers.Coq_base.Coq_type.Coq_option a) st e)
        | Compilers.Coq_base.Coq_type.Coq_unit ->
          (fun _ e ->
            if is_let_bound0
            then Coq_Compilers.UnderLets.UnderLet
                   ((base1 __ Compilers.Coq_base.Coq_type.Coq_unit), e,
                   (fun v -> Coq_Compilers.UnderLets.Base
                   (Compilers.Coq_expr.Var
                   ((base1 __ Compilers.Coq_base.Coq_type.Coq_unit), v))))
            else Coq_Compilers.UnderLets.Base e)
        in annotate0 is_let_bound t0 x x0

      (** val interp_ident :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2)
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
          Compilers.Coq_type.interp) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          'a2 option option) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool)
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1, 'a2) value option) -> bool ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1, 'a2) value_with_lets **)

      let interp_ident annotate_expr0 bottom'0 abstract_interp_ident0 extract_list_state0 extract_option_state0 is_annotated_for0 strip_annotation0 annotate_with_state _ idc =
        let base1 = fun _ x -> Compilers.Coq_type.Coq_base x in
        (match idc with
         | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
           let idc0 = Coq3_Compilers.Coq_ident_Literal (t0, y) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base t0)) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base t0))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base t0)), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base t0)) idc0))
         | Coq3_Compilers.Coq_ident_comment t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_comment t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit)))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit))) idc0))
         | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_comment_no_keep t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit)))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit))) idc0))
         | Coq3_Compilers.Coq_ident_value_barrier ->
           let idc0 = Coq3_Compilers.Coq_ident_value_barrier in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_Nat_succ ->
           let idc0 = Coq3_Compilers.Coq_ident_Nat_succ in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))) idc0))
         | Coq3_Compilers.Coq_ident_Nat_pred ->
           let idc0 = Coq3_Compilers.Coq_ident_Nat_pred in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))) idc0))
         | Coq3_Compilers.Coq_ident_Nat_max ->
           let idc0 = Coq3_Compilers.Coq_ident_Nat_max in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))))) idc0))
         | Coq3_Compilers.Coq_ident_Nat_mul ->
           let idc0 = Coq3_Compilers.Coq_ident_Nat_mul in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))))) idc0))
         | Coq3_Compilers.Coq_ident_Nat_add ->
           let idc0 = Coq3_Compilers.Coq_ident_Nat_add in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))))) idc0))
         | Coq3_Compilers.Coq_ident_Nat_sub ->
           let idc0 = Coq3_Compilers.Coq_ident_Nat_sub in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))))) idc0))
         | Coq3_Compilers.Coq_ident_Nat_eqb ->
           let idc0 = Coq3_Compilers.Coq_ident_Nat_eqb in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))) idc0))
         | Coq3_Compilers.Coq_ident_nil t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_nil t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)) idc0))
         | Coq3_Compilers.Coq_ident_cons t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_cons t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0))
         | Coq3_Compilers.Coq_ident_tt ->
           let idc0 = Coq3_Compilers.Coq_ident_tt in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit)
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit) idc0))
         | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_pair (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))) idc0))
         | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_fst (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                    (Compilers.Coq_type.Coq_base t0))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                (Compilers.Coq_type.Coq_base t0))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                (Compilers.Coq_type.Coq_base t0))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                  (Compilers.Coq_type.Coq_base t0))) idc0))
         | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_snd (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                    (Compilers.Coq_type.Coq_base t1))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                (Compilers.Coq_type.Coq_base t1))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                (Compilers.Coq_type.Coq_base t1))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                  (Compilers.Coq_type.Coq_base t1))) idc0))
         | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
           let idc0 = Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                    (Compilers.Coq_type.Coq_base t2))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t1),
                (Compilers.Coq_type.Coq_base t2))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                (Compilers.Coq_type.Coq_base t2)))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t1),
                (Compilers.Coq_type.Coq_base t2))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                (Compilers.Coq_type.Coq_base t2))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t2))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
                  (Compilers.Coq_type.Coq_base t2))))) idc0))
         | Coq3_Compilers.Coq_ident_bool_rect t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_bool_rect t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t0))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t0))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                    t0))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                t0))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                t0))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                  t0))))))) idc0))
         | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_bool_rect_nodep t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                    t0))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                t0))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                t0))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t0), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                  t0))))))) idc0))
         | Coq3_Compilers.Coq_ident_nat_rect t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_nat_rect t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t0))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t0))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    t0))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                t0))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                t0))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t0))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  t0))))))) idc0))
         | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_eager_nat_rect t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t0))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t0))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    t0))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                t0))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                t0))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t0))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  t0))))))) idc0))
         | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t1)))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t1))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t0), (Compilers.Coq_type.Coq_base t1))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))))))))) idc0))
         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)
           in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t1)))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t1))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t0), (Compilers.Coq_type.Coq_base t1))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))))))))) idc0))
         | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_list_rect (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t1))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base t1))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t1))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base t1))))))) idc0))
         | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t1))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base t1))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t1))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t1))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base t1))))))) idc0))
         | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
           let idc0 = Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t1),
                (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2)))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t1),
                (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t2))))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t2))))))))) idc0))
         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
           let idc0 = Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1,
             t2)
           in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t1),
                (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2)))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t1),
                (Compilers.Coq_type.Coq_base t2))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))))))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_base t2))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_base t2))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t2))))))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_base t2))))))))) idc0))
         | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_list_case (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base t1))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base t1))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base t1))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base t1))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base t1))))))) idc0))
         | Coq3_Compilers.Coq_ident_List_length t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_length t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))) idc0))
         | Coq3_Compilers.Coq_ident_List_seq ->
           let idc0 = Coq3_Compilers.Coq_ident_List_seq in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))))))) idc0))
         | Coq3_Compilers.Coq_ident_List_firstn t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_firstn t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0))
         | Coq3_Compilers.Coq_ident_List_skipn t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_skipn t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0))
         | Coq3_Compilers.Coq_ident_List_repeat t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_repeat t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0))
         | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_List_combine (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))) idc0))
         | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_List_map (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))) idc0))
         | Coq3_Compilers.Coq_ident_List_app t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_app t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0))
         | Coq3_Compilers.Coq_ident_List_rev t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_rev t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))) idc0))
         | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)))))) idc0))
         | Coq3_Compilers.Coq_ident_List_partition t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_partition t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_list t0),
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_list t0),
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_list t0),
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_list t0),
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))))) idc0))
         | Coq3_Compilers.Coq_ident_List_filter t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_filter t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))) idc0))
         | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t0))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)),
                    (Compilers.Coq_type.Coq_base t0))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)),
                (Compilers.Coq_type.Coq_base t0)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t1), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t1)),
                (Compilers.Coq_type.Coq_base t0))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t1),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t0), (Compilers.Coq_type.Coq_base t0))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t0), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base t0))))))) idc0))
         | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_update_nth t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t0))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t0))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t0))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))))) idc0))
         | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_List_nth_default t0 in
           let default0 =
             reflect
               (annotate annotate_expr0 abstract_interp_ident0
                 extract_list_state0 extract_option_state0 is_annotated_for0)
               bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
               ((Compilers.Coq_type.Coq_base t0),
               (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_list t0)),
               (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
               t0))))))) (Compilers.Coq_expr.Ident
               ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
               t0), (Compilers.Coq_type.Coq_arrow
               ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_list t0)),
               (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
               t0))))))), idc0))
               (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base t0),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list t0)),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 t0))))))) idc0)
           in
           Coq_Compilers.UnderLets.Base
           (Obj.magic (fun default_arg ->
             Coq_Compilers.UnderLets.splice (Obj.magic default0 default_arg)
               (fun default1 -> Coq_Compilers.UnderLets.Base (fun ls_arg ->
               Coq_Compilers.UnderLets.splice (default1 ls_arg)
                 (fun default2 -> Coq_Compilers.UnderLets.Base (fun n_arg ->
                 Coq_Compilers.UnderLets.splice (default2 n_arg)
                   (fun default3 ->
                   Coq_Compilers.UnderLets.splice
                     (reify
                       (annotate annotate_expr0 abstract_interp_ident0
                         extract_list_state0 extract_option_state0
                         is_annotated_for0) bottom'0 annotate_with_state
                       false
                       (base1 __ (Compilers.Coq_base.Coq_type.Coq_list t0))
                       ls_arg (Obj.magic ())) (fun ls' ->
                     Coq_Compilers.UnderLets.Base ((fst default3),
                     (match Compilers.Coq_invert_expr.reflect_list
                              (fun _ x x0 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x x0)
                              Coq3_Compilers.invertIdent t0 ls' with
                      | Some ls ->
                        (match Compilers.Coq_invert_expr.invert_Literal
                                 Coq3_Compilers.invertIdent
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_nat)) (snd n_arg) with
                         | Some n3 ->
                           nth_default (snd default_arg) ls (Obj.magic n3)
                         | None -> snd default3)
                      | None -> snd default3))))))))))
         | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_eager_List_nth_default t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    t0))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                t0))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list t0)),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                t0))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  t0))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_add ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_add in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_mul ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_mul in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_pow ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_pow in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_sub ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_sub in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_opp ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_opp in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_Z_div ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_div in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_modulo ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_modulo in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_eqb ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_eqb in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_leb ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_leb in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_ltb ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_ltb in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0 is_annotated_for0)
                bottom'0 annotate_with_state (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_geb ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_geb in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_gtb ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_gtb in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_bool)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_log2 ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_log2 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_Z_log2_up ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_log2_up in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_Z_of_nat ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_of_nat in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_Z_to_nat ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_to_nat in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)))) idc0))
         | Coq3_Compilers.Coq_ident_Z_shiftr ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_shiftr in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_shiftl ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_shiftl in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_land ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_land in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_lor ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_lor in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_min ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_min in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_max ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_max in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_mul_split ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_mul_split in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_mul_high ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_mul_high in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_add_get_carry in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_add_with_carry in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_add_with_get_carry in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_sub_get_borrow in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_ltz ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_ltz in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_zselect ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_zselect in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_add_modulo in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_truncating_shiftl in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_bneg ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_bneg in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_lnot_modulo in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_lxor ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_lxor in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_rshi ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_rshi in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_cc_m ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_cc_m in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_cast ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_cast in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_Z_cast2 ->
           let idc0 = Coq3_Compilers.Coq_ident_Z_cast2 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_zrange),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_zrange)))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))) idc0))
         | Coq3_Compilers.Coq_ident_Some t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_Some t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_option t0)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_option t0))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_option t0)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_option t0)))) idc0))
         | Coq3_Compilers.Coq_ident_None t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_None t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_option t0)) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_option t0))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_option t0)), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_option t0)) idc0))
         | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
           let idc0 = Coq3_Compilers.Coq_ident_option_rect (t0, t1) in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_option t0)),
                    (Compilers.Coq_type.Coq_base t1))))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base t0),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_option t0)),
                (Compilers.Coq_type.Coq_base t1)))))))
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                t0), (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit),
                (Compilers.Coq_type.Coq_base t1))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_option t0)),
                (Compilers.Coq_type.Coq_base t1))))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t1))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_option t0)),
                  (Compilers.Coq_type.Coq_base t1))))))) idc0))
         | Coq3_Compilers.Coq_ident_Build_zrange ->
           let idc0 = Coq3_Compilers.Coq_ident_Build_zrange in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_zrange)))))) idc0))
         | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
           let idc0 = Coq3_Compilers.Coq_ident_zrange_rect t0 in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t0))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                    t0))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                t0))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t0))))),
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                t0))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t0))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                  t0))))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_add ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_add in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_addc ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_addc in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_sub ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_sub in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_subb ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_subb in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_mulll ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_mulll in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_mullh ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_mullh in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_mulhl in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_mulhh in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_rshi ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_rshi in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_selc ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_selc in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_selm ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_selm in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_sell ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_sell in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0))
         | Coq3_Compilers.Coq_ident_fancy_addm ->
           let idc0 = Coq3_Compilers.Coq_ident_fancy_addm in
           Coq_Compilers.UnderLets.Base
           (match strip_annotation0 (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))) idc0 with
            | Some v -> v
            | None ->
              reflect
                (annotate annotate_expr0 abstract_interp_ident0
                  extract_list_state0 extract_option_state0
                  is_annotated_for0) bottom'0 annotate_with_state
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))) (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), idc0))
                (abstract_interp_ident0 (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) idc0)))

      (** val eval_with_bound :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2)
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
          Compilers.Coq_type.interp) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          'a2 option option) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool)
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1, 'a2) value option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool) ->
          bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1, 'a2) value_with_lets)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, 'a2) abstract_domain)
          Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr **)

      let eval_with_bound annotate_expr0 bottom'0 abstract_interp_ident0 extract_list_state0 extract_option_state0 is_annotated_for0 strip_annotation0 skip_annotations_under annotate_with_state t0 e st =
        eval_with_bound'
          (annotate annotate_expr0 abstract_interp_ident0 extract_list_state0
            extract_option_state0 is_annotated_for0) bottom'0
          skip_annotations_under
          (interp_ident annotate_expr0 bottom'0 abstract_interp_ident0
            extract_list_state0 extract_option_state0 is_annotated_for0
            strip_annotation0) annotate_with_state t0 e st

      (** val eta_expand_with_bound :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2)
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a2)
          Compilers.Coq_type.interp) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type -> 'a2 -> 'a2 list option) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a2 ->
          'a2 option option) -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr -> 'a2 -> bool)
          -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, 'a2) abstract_domain)
          Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
          Compilers.Coq_expr.expr **)

      let eta_expand_with_bound annotate_expr0 bottom'0 abstract_interp_ident0 extract_list_state0 extract_option_state0 is_annotated_for0 t0 e st =
        eta_expand_with_bound'
          (annotate annotate_expr0 abstract_interp_ident0 extract_list_state0
            extract_option_state0 is_annotated_for0) bottom'0 t0 e st

      (** val extract :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type -> 'a1)
          -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, 'a1)
          Compilers.Coq_type.interp) -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq3_Compilers.ident, (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, 'a1) abstract_domain)
          Compilers.Coq_expr.expr -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, 'a1) abstract_domain)
          Compilers.Coq_type.for_each_lhs_of_arrow -> 'a1 **)

      let extract =
        extract_gen
     end

    (** val default_relax_zrange : zrange -> zrange option **)

    let default_relax_zrange v =
      Some v

    (** val annotation_of_state :
        (zrange -> zrange option) ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> zrange
        option **)

    let annotation_of_state relax_zrange =
      let always_relax_zrange = fun range ->
        match relax_zrange (ZRange.normalize range) with
        | Some r0 -> r0
        | None -> range
      in
      (fun st -> option_map always_relax_zrange (Obj.magic st))

    (** val annotate_expr :
        (zrange -> zrange option) -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr option **)

    let annotate_expr relax_zrange t0 x =
      (match t0 with
       | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
         (match t1 with
          | Coq3_Compilers.Z ->
            (fun st ->
              bind (Obj.magic annotation_of_state relax_zrange st)
                (fun st' -> Some (Compilers.Coq_expr.App
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)),
                (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_zrange,
                st'))))))))
          | Coq3_Compilers.Coq_bool -> (fun _ -> None)
          | Coq3_Compilers.Coq_nat -> (fun _ -> None)
          | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
          | Coq3_Compilers.Coq_string -> (fun _ -> None))
       | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
         (match a with
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z ->
               (match b with
                | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                  (match t2 with
                   | Coq3_Compilers.Z ->
                     (fun pat ->
                       let (sta, stb) = Obj.magic pat in
                       bind (Obj.magic annotation_of_state relax_zrange sta)
                         (fun sta' ->
                         bind
                           (Obj.magic annotation_of_state relax_zrange stb)
                           (fun stb' -> Some (Compilers.Coq_expr.App
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))))))),
                           Coq3_Compilers.Coq_ident_Z_cast2)),
                           (Compilers.Coq_expr.App
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)))),
                           (Compilers.Coq_expr.App
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)))))),
                           (Compilers.Coq_expr.Ident
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_prod
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)))))))),
                           (Coq3_Compilers.Coq_ident_pair
                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange),
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange))))),
                           (Compilers.Coq_expr.Ident
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Coq3_Compilers.Coq_ident_Literal
                           (Coq3_Compilers.Coq_zrange, sta')))))),
                           (Compilers.Coq_expr.Ident
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Coq3_Compilers.Coq_ident_Literal
                           (Coq3_Compilers.Coq_zrange, stb')))))))))))
                   | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                   | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                   | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                   | Coq3_Compilers.Coq_string -> (fun _ -> None))
                | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                  (fun _ -> None)
                | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
                | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
                | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
             | Coq3_Compilers.Coq_bool -> (fun _ -> None)
             | Coq3_Compilers.Coq_nat -> (fun _ -> None)
             | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
             | Coq3_Compilers.Coq_string -> (fun _ -> None))
          | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> None)
          | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
          | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None))
       | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> None)
       | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> None)
       | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> None)) x

    (** val abstract_interp_ident :
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        Compilers.Coq_type.interp **)

    let abstract_interp_ident opts assume_cast_truncates t0 idc =
      Coq6_Compilers.ZRange.Coq_ident.Coq_option.interp
        (Coq6_Compilers.ZRange.Settings.AbstractInterpretation.shiftr_avoid_uint1
          opts) assume_cast_truncates t0 idc

    (** val always_strip_annotation :
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) value
        option **)

    let always_strip_annotation opts assume_cast_truncates _ = function
    | Coq3_Compilers.Coq_ident_Literal (_, _) -> None
    | Coq3_Compilers.Coq_ident_comment _ -> None
    | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
    | Coq3_Compilers.Coq_ident_value_barrier -> None
    | Coq3_Compilers.Coq_ident_Nat_succ -> None
    | Coq3_Compilers.Coq_ident_Nat_pred -> None
    | Coq3_Compilers.Coq_ident_Nat_max -> None
    | Coq3_Compilers.Coq_ident_Nat_mul -> None
    | Coq3_Compilers.Coq_ident_Nat_add -> None
    | Coq3_Compilers.Coq_ident_Nat_sub -> None
    | Coq3_Compilers.Coq_ident_Nat_eqb -> None
    | Coq3_Compilers.Coq_ident_nil _ -> None
    | Coq3_Compilers.Coq_ident_cons _ -> None
    | Coq3_Compilers.Coq_ident_tt -> None
    | Coq3_Compilers.Coq_ident_pair (_, _) -> None
    | Coq3_Compilers.Coq_ident_fst (_, _) -> None
    | Coq3_Compilers.Coq_ident_snd (_, _) -> None
    | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
    | Coq3_Compilers.Coq_ident_bool_rect _ -> None
    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
    | Coq3_Compilers.Coq_ident_nat_rect _ -> None
    | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
    | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
    | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
    | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
    | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
    | Coq3_Compilers.Coq_ident_List_length _ -> None
    | Coq3_Compilers.Coq_ident_List_seq -> None
    | Coq3_Compilers.Coq_ident_List_firstn _ -> None
    | Coq3_Compilers.Coq_ident_List_skipn _ -> None
    | Coq3_Compilers.Coq_ident_List_repeat _ -> None
    | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
    | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
    | Coq3_Compilers.Coq_ident_List_app _ -> None
    | Coq3_Compilers.Coq_ident_List_rev _ -> None
    | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
    | Coq3_Compilers.Coq_ident_List_partition _ -> None
    | Coq3_Compilers.Coq_ident_List_filter _ -> None
    | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
    | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
    | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
    | Coq3_Compilers.Coq_ident_Z_add -> None
    | Coq3_Compilers.Coq_ident_Z_mul -> None
    | Coq3_Compilers.Coq_ident_Z_pow -> None
    | Coq3_Compilers.Coq_ident_Z_sub -> None
    | Coq3_Compilers.Coq_ident_Z_opp -> None
    | Coq3_Compilers.Coq_ident_Z_div -> None
    | Coq3_Compilers.Coq_ident_Z_modulo -> None
    | Coq3_Compilers.Coq_ident_Z_eqb -> None
    | Coq3_Compilers.Coq_ident_Z_leb -> None
    | Coq3_Compilers.Coq_ident_Z_ltb -> None
    | Coq3_Compilers.Coq_ident_Z_geb -> None
    | Coq3_Compilers.Coq_ident_Z_gtb -> None
    | Coq3_Compilers.Coq_ident_Z_log2 -> None
    | Coq3_Compilers.Coq_ident_Z_log2_up -> None
    | Coq3_Compilers.Coq_ident_Z_of_nat -> None
    | Coq3_Compilers.Coq_ident_Z_to_nat -> None
    | Coq3_Compilers.Coq_ident_Z_shiftr -> None
    | Coq3_Compilers.Coq_ident_Z_shiftl -> None
    | Coq3_Compilers.Coq_ident_Z_land -> None
    | Coq3_Compilers.Coq_ident_Z_lor -> None
    | Coq3_Compilers.Coq_ident_Z_min -> None
    | Coq3_Compilers.Coq_ident_Z_max -> None
    | Coq3_Compilers.Coq_ident_Z_mul_split -> None
    | Coq3_Compilers.Coq_ident_Z_mul_high -> None
    | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
    | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
    | Coq3_Compilers.Coq_ident_Z_ltz -> None
    | Coq3_Compilers.Coq_ident_Z_zselect -> None
    | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
    | Coq3_Compilers.Coq_ident_Z_bneg -> None
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
    | Coq3_Compilers.Coq_ident_Z_lxor -> None
    | Coq3_Compilers.Coq_ident_Z_rshi -> None
    | Coq3_Compilers.Coq_ident_Z_cc_m -> None
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
    | Coq3_Compilers.Coq_ident_Z_cast ->
      let idc0 = Coq3_Compilers.Coq_ident_Z_cast in
      let tZ_type = Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z
      in
      Some
      (Obj.magic (fun pat ->
        let (r_orig, re) = pat in
        Coq_Compilers.UnderLets.Base (fun pat0 ->
        let (r_known, e) = pat0 in
        Coq_Compilers.UnderLets.Base
        ((Obj.magic abstract_interp_ident opts assume_cast_truncates
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           idc0 r_orig r_known),
        (let do_strip =
           match Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z) r_known with
           | Some r_known0 ->
             (match Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_zrange) r_orig with
              | Some r_orig0 ->
                Coq6_Compilers.ZRange.Coq_type.Coq_base.is_tighter_than
                  tZ_type r_known0 r_orig0
              | None -> false)
           | None -> false
         in
         if do_strip
         then e
         else Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), idc0)), re)), e))))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      let idc0 = Coq3_Compilers.Coq_ident_Z_cast2 in
      let tZ_type = Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
      in
      Some
      (Obj.magic (fun pat ->
        let (r_orig, re) = pat in
        Coq_Compilers.UnderLets.Base (fun pat0 ->
        let (r_known, e) = pat0 in
        Coq_Compilers.UnderLets.Base
        ((Obj.magic abstract_interp_ident opts assume_cast_truncates
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_zrange),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))) idc0 r_orig r_known),
        (let do_strip =
           match Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))) r_known with
           | Some r_known0 ->
             (match Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.lift_Some
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_zrange),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_zrange))) r_orig with
              | Some r_orig0 ->
                Coq6_Compilers.ZRange.Coq_type.Coq_base.is_tighter_than
                  tZ_type r_known0 r_orig0
              | None -> false)
           | None -> false
         in
         if do_strip
         then e
         else Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))), idc0)), re)), e))))))
    | Coq3_Compilers.Coq_ident_Some _ -> None
    | Coq3_Compilers.Coq_ident_None _ -> None
    | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
    | Coq3_Compilers.Coq_ident_Build_zrange -> None
    | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
    | Coq3_Compilers.Coq_ident_fancy_add -> None
    | Coq3_Compilers.Coq_ident_fancy_addc -> None
    | Coq3_Compilers.Coq_ident_fancy_sub -> None
    | Coq3_Compilers.Coq_ident_fancy_subb -> None
    | Coq3_Compilers.Coq_ident_fancy_mulll -> None
    | Coq3_Compilers.Coq_ident_fancy_mullh -> None
    | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
    | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
    | Coq3_Compilers.Coq_ident_fancy_rshi -> None
    | Coq3_Compilers.Coq_ident_fancy_selc -> None
    | Coq3_Compilers.Coq_ident_fancy_selm -> None
    | Coq3_Compilers.Coq_ident_fancy_sell -> None
    | Coq3_Compilers.Coq_ident_fancy_addm -> None

    (** val strip_annotation :
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        bool -> bool -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.ident -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) value
        option **)

    let strip_annotation opts assume_cast_truncates = function
    | true -> always_strip_annotation opts assume_cast_truncates
    | false -> (fun _ _ -> None)

    (** val is_annotated_for :
        (zrange -> zrange option) -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> bool **)

    let is_annotated_for relax_zrange t0 t' idc x =
      (match Coq5_Compilers.Coq_invert_expr.invert_Z_cast t0 idc with
       | Some r0 ->
         (match Coq5_Compilers.Coq_invert_expr.invert_Z_cast2 t0 idc with
          | Some p ->
            let (r1, r2) = p in
            (match t' with
             | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
               (match t1 with
                | Coq3_Compilers.Z ->
                  (fun r'0 ->
                    option_beq zrange_beq (Some r0)
                      (annotation_of_state relax_zrange r'0))
                | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                | Coq3_Compilers.Coq_zrange -> (fun _ -> false)
                | Coq3_Compilers.Coq_string -> (fun _ -> false))
             | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
               (match a with
                | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
                  (match t1 with
                   | Coq3_Compilers.Z ->
                     (match b with
                      | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                        (match t2 with
                         | Coq3_Compilers.Z ->
                           (fun pat ->
                             let (r1', r2') = Obj.magic pat in
                             (&&)
                               (option_beq zrange_beq (Some r1)
                                 (annotation_of_state relax_zrange r1'))
                               (option_beq zrange_beq (Some r2)
                                 (annotation_of_state relax_zrange r2')))
                         | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                         | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                         | Coq3_Compilers.Coq_zrange -> (fun _ -> false)
                         | Coq3_Compilers.Coq_string -> (fun _ -> false))
                      | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                        (fun _ -> false)
                      | Compilers.Coq_base.Coq_type.Coq_list _ ->
                        (fun _ -> false)
                      | Compilers.Coq_base.Coq_type.Coq_option _ ->
                        (fun _ -> false)
                      | Compilers.Coq_base.Coq_type.Coq_unit ->
                        (fun _ -> false))
                   | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                   | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                   | Coq3_Compilers.Coq_zrange -> (fun _ -> false)
                   | Coq3_Compilers.Coq_string -> (fun _ -> false))
                | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                  (fun _ -> false)
                | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
                | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> false)
                | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
             | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
          | None ->
            (match t' with
             | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
               (match t1 with
                | Coq3_Compilers.Z ->
                  (fun r'0 ->
                    option_beq zrange_beq (Some r0)
                      (annotation_of_state relax_zrange r'0))
                | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                | Coq3_Compilers.Coq_zrange -> (fun _ -> false)
                | Coq3_Compilers.Coq_string -> (fun _ -> false))
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false)))
       | None ->
         (match Coq5_Compilers.Coq_invert_expr.invert_Z_cast2 t0 idc with
          | Some p ->
            let (r1, r2) = p in
            (match t' with
             | Compilers.Coq_base.Coq_type.Coq_type_base _ -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
               (match a with
                | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
                  (match t1 with
                   | Coq3_Compilers.Z ->
                     (match b with
                      | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                        (match t2 with
                         | Coq3_Compilers.Z ->
                           (fun pat ->
                             let (r1', r2') = Obj.magic pat in
                             (&&)
                               (option_beq zrange_beq (Some r1)
                                 (annotation_of_state relax_zrange r1'))
                               (option_beq zrange_beq (Some r2)
                                 (annotation_of_state relax_zrange r2')))
                         | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                         | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                         | Coq3_Compilers.Coq_zrange -> (fun _ -> false)
                         | Coq3_Compilers.Coq_string -> (fun _ -> false))
                      | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                        (fun _ -> false)
                      | Compilers.Coq_base.Coq_type.Coq_list _ ->
                        (fun _ -> false)
                      | Compilers.Coq_base.Coq_type.Coq_option _ ->
                        (fun _ -> false)
                      | Compilers.Coq_base.Coq_type.Coq_unit ->
                        (fun _ -> false))
                   | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                   | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                   | Coq3_Compilers.Coq_zrange -> (fun _ -> false)
                   | Coq3_Compilers.Coq_string -> (fun _ -> false))
                | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                  (fun _ -> false)
                | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
                | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> false)
                | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
             | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> false)
             | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
          | None -> (fun _ -> false))) x

    (** val annotation_to_expr :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr -> (__ -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr) option **)

    let annotation_to_expr t0 idc =
      match Coq5_Compilers.Coq_invert_expr.invert_Z_cast t0 idc with
      | Some r0 ->
        (match Coq5_Compilers.Coq_invert_expr.invert_Z_cast2 t0 idc with
         | Some p ->
           let (r1, r2) = p in
           (match t0 with
            | Compilers.Coq_type.Coq_base _ -> None
            | Compilers.Coq_type.Coq_arrow (s0, d) ->
              (match s0 with
               | Compilers.Coq_type.Coq_base t1 ->
                 (match t1 with
                  | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                    (match t2 with
                     | Coq3_Compilers.Z ->
                       (match d with
                        | Compilers.Coq_type.Coq_base t3 ->
                          (match t3 with
                           | Compilers.Coq_base.Coq_type.Coq_type_base t4 ->
                             (match t4 with
                              | Coq3_Compilers.Z ->
                                Some (fun _ -> Compilers.Coq_expr.App
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_zrange)),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_expr.Ident
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_zrange)),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))))),
                                  Coq3_Compilers.Coq_ident_Z_cast)),
                                  (Compilers.Coq_expr.Ident
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_zrange)),
                                  (Coq3_Compilers.Coq_ident_Literal
                                  (Coq3_Compilers.Coq_zrange,
                                  (Obj.magic r0)))))))
                              | Coq3_Compilers.Coq_bool -> None
                              | Coq3_Compilers.Coq_nat -> None
                              | Coq3_Compilers.Coq_zrange -> None
                              | Coq3_Compilers.Coq_string -> None)
                           | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                             None
                           | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_unit -> None)
                        | Compilers.Coq_type.Coq_arrow (_, _) -> None)
                     | Coq3_Compilers.Coq_bool -> None
                     | Coq3_Compilers.Coq_nat -> None
                     | Coq3_Compilers.Coq_zrange -> None
                     | Coq3_Compilers.Coq_string -> None)
                  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
                    (match a with
                     | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                       (match t2 with
                        | Coq3_Compilers.Z ->
                          (match b with
                           | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                             (match t3 with
                              | Coq3_Compilers.Z ->
                                (match d with
                                 | Compilers.Coq_type.Coq_base t4 ->
                                   (match t4 with
                                    | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                                      None
                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                        a0, b0) ->
                                      (match a0 with
                                       | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                                         (match t5 with
                                          | Coq3_Compilers.Z ->
                                            (match b0 with
                                             | Compilers.Coq_base.Coq_type.Coq_type_base t6 ->
                                               (match t6 with
                                                | Coq3_Compilers.Z ->
                                                  Some (fun _ ->
                                                    Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))))),
                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                    (Coq3_Compilers.Coq_ident_pair
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    (Coq3_Compilers.Coq_zrange,
                                                    (Obj.magic r1))))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    (Coq3_Compilers.Coq_zrange,
                                                    (Obj.magic r2)))))))))
                                                | Coq3_Compilers.Coq_bool ->
                                                  None
                                                | Coq3_Compilers.Coq_nat ->
                                                  None
                                                | Coq3_Compilers.Coq_zrange ->
                                                  None
                                                | Coq3_Compilers.Coq_string ->
                                                  None)
                                             | Compilers.Coq_base.Coq_type.Coq_prod (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                               None
                                             | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                               None
                                             | Compilers.Coq_base.Coq_type.Coq_unit ->
                                               None)
                                          | Coq3_Compilers.Coq_bool -> None
                                          | Coq3_Compilers.Coq_nat -> None
                                          | Coq3_Compilers.Coq_zrange -> None
                                          | Coq3_Compilers.Coq_string -> None)
                                       | Compilers.Coq_base.Coq_type.Coq_prod (
                                           _, _) ->
                                         None
                                       | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                         None
                                       | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                         None
                                       | Compilers.Coq_base.Coq_type.Coq_unit ->
                                         None)
                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                      None
                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                      None
                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                      None)
                                 | Compilers.Coq_type.Coq_arrow (_, _) -> None)
                              | Coq3_Compilers.Coq_bool -> None
                              | Coq3_Compilers.Coq_nat -> None
                              | Coq3_Compilers.Coq_zrange -> None
                              | Coq3_Compilers.Coq_string -> None)
                           | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                             None
                           | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_unit -> None)
                        | Coq3_Compilers.Coq_bool -> None
                        | Coq3_Compilers.Coq_nat -> None
                        | Coq3_Compilers.Coq_zrange -> None
                        | Coq3_Compilers.Coq_string -> None)
                     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> None
                     | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                     | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                     | Compilers.Coq_base.Coq_type.Coq_unit -> None)
                  | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                  | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                  | Compilers.Coq_base.Coq_type.Coq_unit -> None)
               | Compilers.Coq_type.Coq_arrow (_, _) -> None))
         | None ->
           (match t0 with
            | Compilers.Coq_type.Coq_base _ -> None
            | Compilers.Coq_type.Coq_arrow (s0, d) ->
              (match s0 with
               | Compilers.Coq_type.Coq_base t1 ->
                 (match t1 with
                  | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                    (match t2 with
                     | Coq3_Compilers.Z ->
                       (match d with
                        | Compilers.Coq_type.Coq_base t3 ->
                          (match t3 with
                           | Compilers.Coq_base.Coq_type.Coq_type_base t4 ->
                             (match t4 with
                              | Coq3_Compilers.Z ->
                                Some (fun _ -> Compilers.Coq_expr.App
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_zrange)),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_expr.Ident
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_zrange)),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))))),
                                  Coq3_Compilers.Coq_ident_Z_cast)),
                                  (Compilers.Coq_expr.Ident
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_zrange)),
                                  (Coq3_Compilers.Coq_ident_Literal
                                  (Coq3_Compilers.Coq_zrange,
                                  (Obj.magic r0)))))))
                              | Coq3_Compilers.Coq_bool -> None
                              | Coq3_Compilers.Coq_nat -> None
                              | Coq3_Compilers.Coq_zrange -> None
                              | Coq3_Compilers.Coq_string -> None)
                           | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                             None
                           | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_unit -> None)
                        | Compilers.Coq_type.Coq_arrow (_, _) -> None)
                     | Coq3_Compilers.Coq_bool -> None
                     | Coq3_Compilers.Coq_nat -> None
                     | Coq3_Compilers.Coq_zrange -> None
                     | Coq3_Compilers.Coq_string -> None)
                  | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> None
                  | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                  | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                  | Compilers.Coq_base.Coq_type.Coq_unit -> None)
               | Compilers.Coq_type.Coq_arrow (_, _) -> None)))
      | None ->
        (match Coq5_Compilers.Coq_invert_expr.invert_Z_cast2 t0 idc with
         | Some p ->
           let (r1, r2) = p in
           (match t0 with
            | Compilers.Coq_type.Coq_base _ -> None
            | Compilers.Coq_type.Coq_arrow (s0, d) ->
              (match s0 with
               | Compilers.Coq_type.Coq_base t1 ->
                 (match t1 with
                  | Compilers.Coq_base.Coq_type.Coq_type_base _ -> None
                  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
                    (match a with
                     | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                       (match t2 with
                        | Coq3_Compilers.Z ->
                          (match b with
                           | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                             (match t3 with
                              | Coq3_Compilers.Z ->
                                (match d with
                                 | Compilers.Coq_type.Coq_base t4 ->
                                   (match t4 with
                                    | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                                      None
                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                        a0, b0) ->
                                      (match a0 with
                                       | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                                         (match t5 with
                                          | Coq3_Compilers.Z ->
                                            (match b0 with
                                             | Compilers.Coq_base.Coq_type.Coq_type_base t6 ->
                                               (match t6 with
                                                | Coq3_Compilers.Z ->
                                                  Some (fun _ ->
                                                    Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))))),
                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                    (Coq3_Compilers.Coq_ident_pair
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    (Coq3_Compilers.Coq_zrange,
                                                    (Obj.magic r1))))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    (Coq3_Compilers.Coq_zrange,
                                                    (Obj.magic r2)))))))))
                                                | Coq3_Compilers.Coq_bool ->
                                                  None
                                                | Coq3_Compilers.Coq_nat ->
                                                  None
                                                | Coq3_Compilers.Coq_zrange ->
                                                  None
                                                | Coq3_Compilers.Coq_string ->
                                                  None)
                                             | Compilers.Coq_base.Coq_type.Coq_prod (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                               None
                                             | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                               None
                                             | Compilers.Coq_base.Coq_type.Coq_unit ->
                                               None)
                                          | Coq3_Compilers.Coq_bool -> None
                                          | Coq3_Compilers.Coq_nat -> None
                                          | Coq3_Compilers.Coq_zrange -> None
                                          | Coq3_Compilers.Coq_string -> None)
                                       | Compilers.Coq_base.Coq_type.Coq_prod (
                                           _, _) ->
                                         None
                                       | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                         None
                                       | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                         None
                                       | Compilers.Coq_base.Coq_type.Coq_unit ->
                                         None)
                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                      None
                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                      None
                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                      None)
                                 | Compilers.Coq_type.Coq_arrow (_, _) -> None)
                              | Coq3_Compilers.Coq_bool -> None
                              | Coq3_Compilers.Coq_nat -> None
                              | Coq3_Compilers.Coq_zrange -> None
                              | Coq3_Compilers.Coq_string -> None)
                           | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                             None
                           | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                           | Compilers.Coq_base.Coq_type.Coq_unit -> None)
                        | Coq3_Compilers.Coq_bool -> None
                        | Coq3_Compilers.Coq_nat -> None
                        | Coq3_Compilers.Coq_zrange -> None
                        | Coq3_Compilers.Coq_string -> None)
                     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> None
                     | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                     | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                     | Compilers.Coq_base.Coq_type.Coq_unit -> None)
                  | Compilers.Coq_base.Coq_type.Coq_list _ -> None
                  | Compilers.Coq_base.Coq_type.Coq_option _ -> None
                  | Compilers.Coq_base.Coq_type.Coq_unit -> None)
               | Compilers.Coq_type.Coq_arrow (_, _) -> None))
         | None -> None)

    (** val bottom' :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

    let bottom' =
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None

    (** val extract_list_state :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp list option **)

    let extract_list_state _ st =
      Obj.magic st

    (** val extract_option_state :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp option
        option **)

    let extract_option_state _ st =
      Obj.magic st

    (** val eval_with_bound :
        (zrange -> zrange option) ->
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool) -> bool
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        value_with_lets) Compilers.Coq_expr.expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr **)

    let eval_with_bound relax_zrange opts assume_cast_truncates skip_annotations_under strip_preexisting_annotations t0 e bound =
      let annotate_with_state = true in
      Coq_ident.eval_with_bound (annotate_expr relax_zrange) bottom'
        (abstract_interp_ident opts assume_cast_truncates) extract_list_state
        extract_option_state (is_annotated_for relax_zrange)
        (strip_annotation opts assume_cast_truncates
          strip_preexisting_annotations) skip_annotations_under
        annotate_with_state t0 e bound

    (** val eta_expand_with_bound :
        (zrange -> zrange option) -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Compilers.Coq_expr.expr **)

    let eta_expand_with_bound relax_zrange t0 e bound =
      let assume_cast_truncates = false in
      let shiftr_avoid_uint2 = false in
      Coq_ident.eta_expand_with_bound (annotate_expr relax_zrange) bottom'
        (abstract_interp_ident shiftr_avoid_uint2 assume_cast_truncates)
        extract_list_state extract_option_state
        (is_annotated_for relax_zrange) t0 e bound

    (** val coq_EvalWithBound :
        (zrange -> zrange option) ->
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool) -> bool
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

    let coq_EvalWithBound relax_zrange opts assume_cast_truncates skip_annotations_under strip_preexisting_annotations t0 e bound =
      eval_with_bound relax_zrange opts assume_cast_truncates
        skip_annotations_under strip_preexisting_annotations t0
        (Obj.magic e __) bound

    (** val coq_EtaExpandWithBound :
        (zrange -> zrange option) -> Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

    let coq_EtaExpandWithBound relax_zrange t0 e bound =
      eta_expand_with_bound relax_zrange t0 (e __) bound

    (** val coq_EtaExpandWithListInfoFromBound :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

    let coq_EtaExpandWithListInfoFromBound t0 e bound =
      coq_EtaExpandWithBound default_relax_zrange t0 e
        (Compilers.Coq_type.map_for_each_lhs_of_arrow
          Coq6_Compilers.ZRange.Coq_type.Coq_option.strip_ranges t0 bound)

    (** val coq_Extract :
        Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
        bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type,
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp)
        abstract_domain) Compilers.Coq_type.for_each_lhs_of_arrow ->
        Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

    let coq_Extract opts assume_cast_truncates t0 e bound =
      Coq_ident.extract bottom'
        (abstract_interp_ident opts assume_cast_truncates) t0 (e __) bound
   end

  module CheckCasts =
   struct
    (** val get_casts :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type, __ -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr) sigT list) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type, __ -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr) sigT list **)

    let rec get_casts t0 e =
      match Coq_partial.annotation_to_expr t0 e with
      | Some e0 -> (ExistT (t0, e0)) :: []
      | None ->
        (match e with
         | Compilers.Coq_expr.Ident (_, _) -> []
         | Compilers.Coq_expr.Var (_, v) -> v
         | Compilers.Coq_expr.Abs (_, d, f) -> get_casts d (f [])
         | Compilers.Coq_expr.App (s0, d, f, x) ->
           app (get_casts (Compilers.Coq_type.Coq_arrow (s0, d)) f)
             (get_casts s0 x)
         | Compilers.Coq_expr.LetIn (a, b, x, f) ->
           app (get_casts a x) (get_casts b (f [])))

    (** val coq_GetUnsupportedCasts :
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type, __
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, __) Compilers.Coq_expr.expr) sigT list **)

    let coq_GetUnsupportedCasts t0 e =
      get_casts t0 (Obj.magic e __)
   end

  (** val coq_PartialEvaluateWithBounds :
      Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt -> (zrange ->
      zrange option) -> bool -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      Coq3_Compilers.ident -> bool) -> bool -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr **)

  let coq_PartialEvaluateWithBounds shiftr_avoid_uint2 relax_zrange assume_cast_truncates skip_annotations_under strip_preexisting_annotations t0 e bound =
    Coq_partial.coq_EvalWithBound relax_zrange shiftr_avoid_uint2
      assume_cast_truncates skip_annotations_under
      strip_preexisting_annotations t0 (fun _ ->
      Compilers.GeneralizeVar.coq_GeneralizeVar (fun _ x x0 _ ->
        Compilers.Coq_base.try_make_transport_cps (fun _ x1 x2 _ ->
          Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0) (fun _ ->
        Compilers.DefaultValue.Coq_expr.default Coq3_Compilers.base_default
          Coq3_Compilers.buildIdent) t0 (Obj.magic e __)) bound

  (** val coq_PartialEvaluateWithListInfoFromBounds :
      Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr **)

  let coq_PartialEvaluateWithListInfoFromBounds _ t0 e bound =
    Coq_partial.coq_EtaExpandWithListInfoFromBound t0 (fun _ ->
      Compilers.GeneralizeVar.coq_GeneralizeVar (fun _ x x0 _ ->
        Compilers.Coq_base.try_make_transport_cps (fun _ x1 x2 _ ->
          Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0) (fun _ ->
        Compilers.DefaultValue.Coq_expr.default Coq3_Compilers.base_default
          Coq3_Compilers.buildIdent) t0 (Obj.magic e __)) bound

  (** val coq_CheckedPartialEvaluateWithBounds :
      Coq6_Compilers.ZRange.Settings.shiftr_avoid_uint1_opt -> (zrange ->
      zrange option) -> bool -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      Coq3_Compilers.ident -> bool) -> bool -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr,
      (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp * (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type, __ ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr) sigT list) sum) sum **)

  let coq_CheckedPartialEvaluateWithBounds shiftr_avoid_uint2 relax_zrange assume_cast_truncates skip_annotations_under strip_preexisting_annotations t0 e b_in b_out =
    let_In (Compilers.GeneralizeVar.coq_ToFlat t0 e) (fun e0 ->
      let e1 = fun _ ->
        Compilers.GeneralizeVar.coq_FromFlat (fun _ x x0 _ ->
          Compilers.Coq_base.try_make_transport_cps (fun _ x1 x2 _ ->
            Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0) (fun _ ->
          Compilers.DefaultValue.Coq_expr.default Coq3_Compilers.base_default
            Coq3_Compilers.buildIdent) t0 e0
      in
      let b_computed =
        Coq_partial.coq_Extract shiftr_avoid_uint2 assume_cast_truncates t0
          e1 b_in
      in
      let unsupported_casts =
        if strip_preexisting_annotations
        then []
        else CheckCasts.coq_GetUnsupportedCasts t0 e1
      in
      (match unsupported_casts with
       | [] ->
         let e2 = fun _ ->
           coq_PartialEvaluateWithBounds shiftr_avoid_uint2 relax_zrange
             assume_cast_truncates skip_annotations_under
             strip_preexisting_annotations t0 e1 b_in
         in
         if Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.is_tighter_than
              (Compilers.Coq_type.final_codomain t0) b_computed b_out
         then Inl e2
         else Inr (Inl (b_computed, e2))
       | _ :: _ -> Inr (Inr unsupported_casts)))
 end

module Associational =
 struct
  (** val eval : (z * z) list -> z **)

  let eval p =
    fold_right Coq_Z.add Z0 (map (fun t0 -> Coq_Z.mul (fst t0) (snd t0)) p)

  (** val mul : (z * z) list -> (z * z) list -> (z * z) list **)

  let mul p q0 =
    flat_map (fun t0 ->
      map (fun t' -> ((Coq_Z.mul (fst t0) (fst t')),
        (Coq_Z.mul (snd t0) (snd t')))) q0) p

  (** val split : z -> (z * z) list -> (z * z) list * (z * z) list **)

  let split s0 p =
    let hi_lo =
      partition (fun t0 -> Coq_Z.eqb (Coq_Z.modulo (fst t0) s0) Z0) p
    in
    ((snd hi_lo),
    (map (fun t0 -> ((Coq_Z.div (fst t0) s0), (snd t0))) (fst hi_lo)))

  (** val reduce : z -> (z * z) list -> (z * z) list -> (z * z) list **)

  let reduce s0 c0 p =
    let lo_hi = split s0 p in app (fst lo_hi) (mul c0 (snd lo_hi))

  (** val repeat_reduce :
      nat -> z -> (z * z) list -> (z * z) list -> (z * z) list **)

  let repeat_reduce n3 s0 c0 p =
    let rec f = function
    | O -> (fun p0 -> p0)
    | S n5 ->
      (fun p0 ->
        let lo_hi = split s0 p0 in
        if Nat.eqb (length (snd lo_hi)) O
        then p0
        else let p1 = app (fst lo_hi) (mul c0 (snd lo_hi)) in f n5 p1)
    in f n3 p

  (** val let_bind_for_reduce_square :
      (z * z) list -> (z * z) list -> ((((z * z) * (z * z) list) * (z * z)
      list) * (z * z) list) list **)

  let let_bind_for_reduce_square c0 p =
    let two0 = ((Zpos XH), (Zpos (XO XH))) :: [] in
    map (fun t0 ->
      let_In (mul (t0 :: []) c0) (fun c_t ->
        let_In (mul c_t two0) (fun two_c_t ->
          let_In (mul (t0 :: []) two0) (fun two_t -> (((t0, c_t), two_c_t),
            two_t))))) p

  (** val reduce_square :
      z -> (z * z) list -> (z * z) list -> (z * z) list **)

  let reduce_square s0 c0 p =
    let p0 = let_bind_for_reduce_square c0 p in
    let div_s = map (fun t0 -> ((Coq_Z.div (fst t0) s0), (snd t0))) in
    let rec f = function
    | [] -> []
    | y :: l0 ->
      app
        (let (y0, two_t) = y in
         let (y1, two_c_t) = y0 in
         let (t0, c_t) = y1 in
         app
           (if Coq_Z.eqb (Coq_Z.modulo (Coq_Z.mul (fst t0) (fst t0)) s0) Z0
            then div_s (mul (t0 :: []) c_t)
            else mul (t0 :: []) (t0 :: []))
           (flat_map (fun pat ->
             let (y2, two_t') = pat in
             let (y3, two_c_t') = y2 in
             let (t', _) = y3 in
             if Coq_Z.eqb (Coq_Z.modulo (Coq_Z.mul (fst t0) (fst t')) s0) Z0
             then div_s
                    (if Coq_Z.leb (fst t') (fst t0)
                     then mul (t' :: []) two_c_t
                     else mul (t0 :: []) two_c_t')
             else if Coq_Z.leb (fst t') (fst t0)
                  then mul (t' :: []) two_t
                  else mul (t0 :: []) two_t') l0)) (f l0)
    in f p0

  (** val carryterm : z -> z -> (z * z) -> (z * z) list **)

  let carryterm w fw t0 =
    if Coq_Z.eqb (fst t0) w
    then let_In (snd t0) (fun t2 ->
           let_In (Coq_Z.div t2 fw) (fun d2 ->
             let_In (Coq_Z.modulo t2 fw) (fun m4 -> ((Coq_Z.mul w fw),
               d2) :: ((w, m4) :: []))))
    else t0 :: []

  (** val carry : z -> z -> (z * z) list -> (z * z) list **)

  let carry w fw p =
    flat_map (carryterm w fw) p
 end

module Positional =
 struct
  (** val to_associational : (nat -> z) -> nat -> z list -> (z * z) list **)

  let to_associational weight1 n3 xs =
    combine (map weight1 (seq O n3)) xs

  (** val eval : (nat -> z) -> nat -> z list -> z **)

  let eval weight1 n3 x =
    Associational.eval (to_associational weight1 n3 x)

  (** val zeros : nat -> z list **)

  let zeros n3 =
    repeat Z0 n3

  (** val add_to_nth : nat -> z -> z list -> z list **)

  let add_to_nth i x ls =
    update_nth i (fun y -> Coq_Z.add x y) ls

  (** val place : (nat -> z) -> (z * z) -> nat -> nat * z **)

  let place weight1 t0 i =
    let rec f = function
    | O -> (fun _ -> (O, (Coq_Z.mul (fst t0) (snd t0))))
    | S n4 ->
      (fun _ ->
        let i0 = S n4 in
        if Coq_Z.eqb (Coq_Z.modulo (fst t0) (weight1 i0)) Z0
        then (i0,
               (let c0 = Coq_Z.div (fst t0) (weight1 i0) in
                Coq_Z.mul c0 (snd t0)))
        else f n4 ())
    in f i ()

  (** val from_associational : (nat -> z) -> nat -> (z * z) list -> z list **)

  let from_associational weight1 n3 p =
    fold_right (fun t0 ls ->
      let_In (place weight1 t0 (pred n3)) (fun p0 ->
        add_to_nth (fst p0) (snd p0) ls)) (zeros n3) p

  (** val squaremod :
      (nat -> z) -> z -> (z * z) list -> nat -> z list -> z list **)

  let squaremod weight1 s0 c0 n3 a =
    let a_a = to_associational weight1 n3 a in
    let aa_a = Associational.reduce_square s0 c0 a_a in
    let aam_a = Associational.repeat_reduce (pred n3) s0 c0 aa_a in
    from_associational weight1 n3 aam_a

  (** val carry : (nat -> z) -> nat -> nat -> nat -> z list -> z list **)

  let carry weight1 n3 m4 index p =
    from_associational weight1 m4
      (Associational.carry (weight1 index)
        (Coq_Z.div (weight1 (S index)) (weight1 index))
        (to_associational weight1 n3 p))

  (** val carry_reduce :
      (nat -> z) -> nat -> z -> (z * z) list -> nat -> z list -> z list **)

  let carry_reduce weight1 n3 s0 c0 index p =
    from_associational weight1 n3
      (Associational.reduce s0 c0
        (to_associational weight1 (S n3) (carry weight1 n3 (S n3) index p)))

  (** val chained_carries :
      (nat -> z) -> nat -> z -> (z * z) list -> z list -> nat list -> z list **)

  let chained_carries weight1 n3 s0 c0 p idxs0 =
    fold_right (fun a b -> carry_reduce weight1 n3 s0 c0 a b) p (rev1 idxs0)

  (** val encode : (nat -> z) -> nat -> z -> (z * z) list -> z -> z list **)

  let encode weight1 n3 s0 c0 x =
    chained_carries weight1 n3 s0 c0
      (from_associational weight1 n3 (((Zpos XH), x) :: [])) (seq O n3)

  (** val scmul : (nat -> z) -> nat -> z -> z list -> z list **)

  let scmul weight1 n3 x a =
    let a0 = to_associational weight1 n3 a in
    let r0 = Associational.mul a0 (((Zpos XH), x) :: []) in
    from_associational weight1 n3 r0
 end

(** val weight : z -> z -> nat -> z **)

let weight limbwidth_num0 limbwidth_den0 i =
  Coq_Z.pow (Zpos (XO XH))
    (Coq_Z.opp
      (Coq_Z.div (Coq_Z.opp (Coq_Z.mul limbwidth_num0 (Coq_Z.of_nat i)))
        limbwidth_den0))

module Partition =
 struct
  (** val partition : (nat -> z) -> nat -> z -> z list **)

  let partition weight1 n3 x =
    map (fun i -> Coq_Z.div (Coq_Z.modulo x (weight1 (S i))) (weight1 i))
      (seq O n3)
 end

module Rows =
 struct
  (** val adjust_s : (nat -> z) -> nat -> z -> z * bool **)

  let adjust_s weight1 fuel0 s0 =
    fold_right (fun w_i res ->
      let (v, found_adjustment) = res in
      let res0 = (v, found_adjustment) in
      if found_adjustment
      then res0
      else if Coq_Z.eqb (Coq_Z.modulo w_i s0) Z0 then (w_i, true) else res0)
      (s0, false) (map weight1 (rev1 (seq O fuel0)))
 end

module Coq9_Compilers =
 struct
  module Subst01 =
   struct
    (** val contains_always_live_ident :
        ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> ('a1
        Compilers.Coq_type.coq_type -> 'a3) -> 'a1
        Compilers.Coq_type.coq_type -> ('a1, 'a2, 'a3)
        Compilers.Coq_expr.expr -> bool **)

    let contains_always_live_ident is_ident_always_live dummy t0 e =
      let rec contains_always_live_ident0 _ dummy0 _ = function
      | Compilers.Coq_expr.Ident (t1, idc) -> is_ident_always_live t1 idc
      | Compilers.Coq_expr.Var (_, _) -> false
      | Compilers.Coq_expr.Abs (s0, d, f) ->
        contains_always_live_ident0 __ dummy0 d (f (dummy0 s0))
      | Compilers.Coq_expr.App (s0, d, f, x) ->
        (||)
          (contains_always_live_ident0 __ dummy0
            (Compilers.Coq_type.Coq_arrow (s0, d)) f)
          (contains_always_live_ident0 __ dummy0 s0 x)
      | Compilers.Coq_expr.LetIn (tx, tC, ex, eC) ->
        (||) (contains_always_live_ident0 __ dummy0 tx ex)
          (contains_always_live_ident0 __ dummy0 tC (eC (dummy0 tx)))
      in contains_always_live_ident0 __ dummy t0 e

    (** val compute_live_counts' :
        'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
        Compilers.Coq_type.coq_type -> 'a3 -> bool) -> 'a2
        Compilers.Coq_type.coq_type -> ('a2, 'a3, positive)
        Compilers.Coq_expr.expr -> positive -> 'a1 PositiveMap.t ->
        positive * 'a1 PositiveMap.t **)

    let compute_live_counts' one1 incr incr_always_live is_ident_always_live =
      let rec compute_live_counts'0 _ e cur_idx live =
        match e with
        | Compilers.Coq_expr.Ident (_, _) -> (cur_idx, live)
        | Compilers.Coq_expr.Var (_, v) ->
          (cur_idx,
            (PositiveMap.add v
              (match PositiveMap.find v live with
               | Some n3 -> incr n3
               | None -> one1) live))
        | Compilers.Coq_expr.Abs (_, d, f) ->
          let (_, live0) =
            compute_live_counts'0 d (f cur_idx) (Coq_Pos.succ cur_idx) live
          in
          (cur_idx, live0)
        | Compilers.Coq_expr.App (s0, d, f, x) ->
          let (idx0, live0) =
            compute_live_counts'0 (Compilers.Coq_type.Coq_arrow (s0, d)) f
              cur_idx live
          in
          let (idx1, live1) = compute_live_counts'0 s0 x idx0 live0 in
          (idx1, live1)
        | Compilers.Coq_expr.LetIn (tx, tC, ex, eC) ->
          let (idx0, live0) =
            compute_live_counts'0 tC (eC cur_idx) (Coq_Pos.succ cur_idx) live
          in
          let live1 =
            if contains_always_live_ident is_ident_always_live (fun _ ->
                 cur_idx) tx ex
            then PositiveMap.add cur_idx
                   (incr_always_live (PositiveMap.find cur_idx live0)) live0
            else live0
          in
          if PositiveMap.mem cur_idx live1
          then compute_live_counts'0 tx ex idx0 live1
          else (idx0, live1)
      in compute_live_counts'0

    (** val compute_live_counts :
        'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
        Compilers.Coq_type.coq_type -> 'a3 -> bool) -> 'a2
        Compilers.Coq_type.coq_type -> ('a2, 'a3, positive)
        Compilers.Coq_expr.expr -> 'a1 PositiveMap.t **)

    let compute_live_counts one1 incr incr_always_live is_ident_always_live t0 e =
      snd
        (compute_live_counts' one1 incr incr_always_live is_ident_always_live
          t0 e XH PositiveMap.empty)

    (** val coq_ComputeLiveCounts :
        'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
        Compilers.Coq_type.coq_type -> 'a3 -> bool) -> 'a2
        Compilers.Coq_type.coq_type -> ('a2, 'a3) Compilers.Coq_expr.coq_Expr
        -> 'a1 PositiveMap.t **)

    let coq_ComputeLiveCounts one1 incr incr_always_live is_ident_always_live t0 e =
      compute_live_counts one1 incr incr_always_live is_ident_always_live t0
        (Obj.magic e __)

    (** val subst0n' :
        (__ -> __ -> __ -> (unit -> __) -> __) -> ('a1 -> bool) -> 'a1
        PositiveMap.t -> 'a2 Compilers.Coq_type.coq_type -> ('a2, 'a3, ('a2,
        'a3, 'a4) Compilers.Coq_expr.expr) Compilers.Coq_expr.expr ->
        positive -> positive * ('a2, 'a3, 'a4) Compilers.Coq_expr.expr **)

    let subst0n' doing_subst_debug should_subst live =
      let rec subst0n'0 _ e cur_idx =
        match e with
        | Compilers.Coq_expr.Ident (t0, idc) ->
          (cur_idx, (Compilers.Coq_expr.Ident (t0, idc)))
        | Compilers.Coq_expr.Var (_, v) -> (cur_idx, v)
        | Compilers.Coq_expr.Abs (s0, d, f) ->
          (cur_idx, (Compilers.Coq_expr.Abs (s0, d, (fun v ->
            snd
              (subst0n'0 d (f (Compilers.Coq_expr.Var (s0, v)))
                (Coq_Pos.succ cur_idx))))))
        | Compilers.Coq_expr.App (s0, d, f, x) ->
          let (idx0, f') =
            subst0n'0 (Compilers.Coq_type.Coq_arrow (s0, d)) f cur_idx
          in
          let (idx1, x') = subst0n'0 s0 x idx0 in
          (idx1, (Compilers.Coq_expr.App (s0, d, f', x')))
        | Compilers.Coq_expr.LetIn (tx, tC, ex, eC) ->
          let (_, ex') = subst0n'0 tx ex cur_idx in
          let eC' = fun v -> snd (subst0n'0 tC (eC v) (Coq_Pos.succ cur_idx))
          in
          if match PositiveMap.find cur_idx live with
             | Some n3 -> should_subst n3
             | None -> true
          then ((Coq_Pos.succ cur_idx),
                 (eC'
                   (Obj.magic doing_subst_debug __ __ ex' (fun pat ->
                     let () = pat in
                     ((Coq_Pos.succ cur_idx), (PositiveMap.elements live))))))
          else ((Coq_Pos.succ cur_idx), (Compilers.Coq_expr.LetIn (tx, tC,
                 ex', (fun v -> eC' (Compilers.Coq_expr.Var (tx, v))))))
      in subst0n'0

    (** val subst0n :
        (__ -> __ -> __ -> (unit -> __) -> __) -> ('a1 -> bool) -> 'a1
        PositiveMap.t -> 'a2 Compilers.Coq_type.coq_type -> ('a2, 'a3, ('a2,
        'a3, 'a4) Compilers.Coq_expr.expr) Compilers.Coq_expr.expr -> ('a2,
        'a3, 'a4) Compilers.Coq_expr.expr **)

    let subst0n doing_subst_debug should_subst live t0 e =
      snd (subst0n' doing_subst_debug should_subst live t0 e XH)

    (** val coq_Subst0n :
        'a1 -> ('a1 -> 'a1) -> ('a1 option -> 'a1) -> ('a2
        Compilers.Coq_type.coq_type -> 'a3 -> bool) -> (__ -> __ -> __ ->
        (unit -> __) -> __) -> ('a1 -> bool) -> 'a2
        Compilers.Coq_type.coq_type -> ('a2, 'a3) Compilers.Coq_expr.coq_Expr
        -> ('a2, 'a3, __) Compilers.Coq_expr.expr **)

    let coq_Subst0n one1 incr incr_always_live is_ident_always_live doing_subst_debug should_subst t0 e =
      subst0n doing_subst_debug should_subst
        (coq_ComputeLiveCounts one1 incr incr_always_live
          is_ident_always_live t0 e) t0 (Obj.magic e __)

    type one_or_more =
    | Coq_one
    | Coq_more

    (** val coq_Subst01 :
        ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
        Compilers.Coq_type.coq_type -> ('a1, 'a2) Compilers.Coq_expr.coq_Expr
        -> ('a1, 'a2, __) Compilers.Coq_expr.expr **)

    let coq_Subst01 is_ident_always_live t0 e =
      let incr = fun _ -> Coq_more in
      let should_subst = fun v ->
        match v with
        | Coq_one -> true
        | Coq_more -> false
      in
      coq_Subst0n Coq_one incr (fun _ -> Coq_more) is_ident_always_live
        (fun _ _ x _ -> x) should_subst t0 e
   end

  module DeadCodeElimination =
   struct
    (** val coq_OUGHT_TO_BE_UNUSED : 'a1 -> 'a2 -> 'a1 **)

    let coq_OUGHT_TO_BE_UNUSED v _ =
      v

    (** val coq_EliminateDead :
        ('a1 Compilers.Coq_type.coq_type -> 'a2 -> bool) -> 'a1
        Compilers.Coq_type.coq_type -> ('a1, 'a2) Compilers.Coq_expr.coq_Expr
        -> ('a1, 'a2, __) Compilers.Coq_expr.expr **)

    let coq_EliminateDead is_ident_always_live t0 e =
      Subst01.coq_Subst0n () (fun _ -> ()) (fun _ -> ()) is_ident_always_live
        (fun _ _ -> coq_OUGHT_TO_BE_UNUSED) (fun _ -> false) t0 e
   end
 end

module Coq10_Compilers =
 struct
  module Coq_pattern =
   struct
    module Coq_ident =
     struct
      (** val all_base0 : Coq3_Compilers.base list **)

      let all_base0 =
        Coq3_Compilers.Z :: (Coq3_Compilers.Coq_bool :: (Coq3_Compilers.Coq_nat :: (Coq3_Compilers.Coq_zrange :: (Coq3_Compilers.Coq_string :: []))))

      (** val all_idents0 : (__, __) Coq_Primitive.sigT list **)

      let all_idents0 =
        { Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_Literal (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_comment x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_comment_no_keep x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_value_barrier) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Nat_succ) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Nat_pred) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Nat_max) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Nat_mul) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Nat_add) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Nat_sub) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Nat_eqb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_nil x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_cons x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_tt) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_pair (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_fst (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_snd (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 x1 -> Coq3_Compilers.Coq_ident_prod_rect (x,
            x0, x1))) } :: ({ Coq_Primitive.projT1 = __;
          Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_bool_rect x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_bool_rect_nodep x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_nat_rect x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_eager_nat_rect x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_nat_rect_arrow (x,
            x0))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_list_rect (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_eager_list_rect
            (x, x0))) } :: ({ Coq_Primitive.projT1 = __;
          Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 x1 -> Coq3_Compilers.Coq_ident_list_rect_arrow
            (x, x0, x1))) } :: ({ Coq_Primitive.projT1 = __;
          Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 x1 ->
            Coq3_Compilers.Coq_ident_eager_list_rect_arrow (x, x0, x1))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_list_case (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_length x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_List_seq) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_firstn x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_skipn x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_repeat x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_List_combine (x,
            x0))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_List_map (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_app x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_rev x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_List_flat_map (x,
            x0))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_partition x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_filter x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_List_fold_right
            (x, x0))) } :: ({ Coq_Primitive.projT1 = __;
          Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_update_nth x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_List_nth_default x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_ident_eager_List_nth_default x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_add) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_mul) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_pow) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_sub) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_opp) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_div) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_modulo) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_eqb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_leb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_ltb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_geb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_gtb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_log2) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_log2_up) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_of_nat) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_to_nat) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_shiftr) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_shiftl) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_land) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_lor) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_min) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_max) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_mul_split) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_mul_high) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_add_get_carry) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_add_with_carry) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_add_with_get_carry) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_sub_get_borrow) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_ltz) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_zselect) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_add_modulo) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_truncating_shiftl) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_bneg) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_lnot_modulo) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_lxor) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_rshi) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_cc_m) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_cast) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Z_cast2) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_Some x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_None x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_ident_option_rect (x,
            x0))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_Build_zrange) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_ident_zrange_rect x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_add) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_addc) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_sub) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_subb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_mulll) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_mullh) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_mulhl) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_mulhh) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_rshi) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_selc) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_selm) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_sell) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_ident_fancy_addm) } :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

      (** val ident_index :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> nat **)

      let ident_index _ = function
      | Coq3_Compilers.Coq_ident_Literal (_, _) -> O
      | Coq3_Compilers.Coq_ident_comment _ -> S O
      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> S (S O)
      | Coq3_Compilers.Coq_ident_value_barrier -> S (S (S O))
      | Coq3_Compilers.Coq_ident_Nat_succ -> S (S (S (S O)))
      | Coq3_Compilers.Coq_ident_Nat_pred -> S (S (S (S (S O))))
      | Coq3_Compilers.Coq_ident_Nat_max -> S (S (S (S (S (S O)))))
      | Coq3_Compilers.Coq_ident_Nat_mul -> S (S (S (S (S (S (S O))))))
      | Coq3_Compilers.Coq_ident_Nat_add -> S (S (S (S (S (S (S (S O)))))))
      | Coq3_Compilers.Coq_ident_Nat_sub ->
        S (S (S (S (S (S (S (S (S O))))))))
      | Coq3_Compilers.Coq_ident_Nat_eqb ->
        S (S (S (S (S (S (S (S (S (S O)))))))))
      | Coq3_Compilers.Coq_ident_nil _ ->
        S (S (S (S (S (S (S (S (S (S (S O))))))))))
      | Coq3_Compilers.Coq_ident_cons _ ->
        S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))
      | Coq3_Compilers.Coq_ident_tt ->
        S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))
      | Coq3_Compilers.Coq_ident_pair (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))
      | Coq3_Compilers.Coq_ident_fst (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))
      | Coq3_Compilers.Coq_ident_snd (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))
      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))
      | Coq3_Compilers.Coq_ident_bool_rect _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))
      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))
      | Coq3_Compilers.Coq_ident_nat_rect _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))
      | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S O)))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S O))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S O)))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S O))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_list_case (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S O)))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_length _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S O))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_seq ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_firstn _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_skipn _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_repeat _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_map (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_app _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_rev _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_partition _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_filter _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_update_nth _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_List_nth_default _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_add ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_mul ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S O)))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_pow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S O))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_sub ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S O)))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_opp ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S O))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_div ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_modulo ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_eqb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_leb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_ltb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_geb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_gtb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_log2 ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_log2_up ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_of_nat ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_to_nat ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_shiftr ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_shiftl ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_land ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_lor ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_min ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_max ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_mul_split ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_mul_high ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_ltz ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_zselect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_bneg ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_lxor ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_rshi ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_cc_m ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_cast ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Z_cast2 ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Some _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_None _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_Build_zrange ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_zrange_rect _ ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_add ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_addc ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_sub ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_subb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_mulll ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_mullh ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_rshi ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_selc ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_selm ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_sell ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_ident_fancy_addm ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

      (** val eta_ident_cps_gen :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) **)

      let eta_ident_cps_gen f _ = function
      | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base t0))
          (Coq3_Compilers.Coq_ident_Literal (t0, y))
      | Coq3_Compilers.Coq_ident_comment t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_ident_comment t0)
      | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_ident_comment_no_keep t0)
      | Coq3_Compilers.Coq_ident_value_barrier ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_value_barrier
      | Coq3_Compilers.Coq_ident_Nat_succ ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_succ
      | Coq3_Compilers.Coq_ident_Nat_pred ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_pred
      | Coq3_Compilers.Coq_ident_Nat_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_max
      | Coq3_Compilers.Coq_ident_Nat_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_mul
      | Coq3_Compilers.Coq_ident_Nat_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_add
      | Coq3_Compilers.Coq_ident_Nat_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_sub
      | Coq3_Compilers.Coq_ident_Nat_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Nat_eqb
      | Coq3_Compilers.Coq_ident_nil t0 ->
        f (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)) (Coq3_Compilers.Coq_ident_nil t0)
      | Coq3_Compilers.Coq_ident_cons t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))))) (Coq3_Compilers.Coq_ident_cons t0)
      | Coq3_Compilers.Coq_ident_tt ->
        f (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit)
          Coq3_Compilers.Coq_ident_tt
      | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))))))) (Coq3_Compilers.Coq_ident_pair (t0, t1))
      | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t0))) (Coq3_Compilers.Coq_ident_fst
          (t0, t1))
      | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t1))) (Coq3_Compilers.Coq_ident_snd
          (t0, t1))
      | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t2)))))
          (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2))
      | Coq3_Compilers.Coq_ident_bool_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_bool_rect t0)
      | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_bool_rect_nodep t0)
      | Coq3_Compilers.Coq_ident_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_nat_rect t0)
      | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_eager_nat_rect t0)
      | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1))
      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1))
      | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_list_rect (t0, t1))
      | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1))
      | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2))
      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2))
      | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base t1))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_list_case (t0, t1))
      | Coq3_Compilers.Coq_ident_List_length t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) (Coq3_Compilers.Coq_ident_List_length t0)
      | Coq3_Compilers.Coq_ident_List_seq ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))) Coq3_Compilers.Coq_ident_List_seq
      | Coq3_Compilers.Coq_ident_List_firstn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_firstn t0)
      | Coq3_Compilers.Coq_ident_List_skipn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_skipn t0)
      | Coq3_Compilers.Coq_ident_List_repeat t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_repeat t0)
      | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
          (Coq3_Compilers.Coq_ident_List_combine (t0, t1))
      | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))))) (Coq3_Compilers.Coq_ident_List_map (t0, t1))
      | Coq3_Compilers.Coq_ident_List_app t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))))) (Coq3_Compilers.Coq_ident_List_app t0)
      | Coq3_Compilers.Coq_ident_List_rev t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))) (Coq3_Compilers.Coq_ident_List_rev t0)
      | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))))) (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1))
      | Coq3_Compilers.Coq_ident_List_partition t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_list t0),
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_ident_List_partition t0)
      | Coq3_Compilers.Coq_ident_List_filter t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_filter t0)
      | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1))
      | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_ident_List_update_nth t0)
      | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_List_nth_default t0)
      | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_eager_List_nth_default t0)
      | Coq3_Compilers.Coq_ident_Z_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_add
      | Coq3_Compilers.Coq_ident_Z_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_mul
      | Coq3_Compilers.Coq_ident_Z_pow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_pow
      | Coq3_Compilers.Coq_ident_Z_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_sub
      | Coq3_Compilers.Coq_ident_Z_opp ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_opp
      | Coq3_Compilers.Coq_ident_Z_div ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_div
      | Coq3_Compilers.Coq_ident_Z_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_modulo
      | Coq3_Compilers.Coq_ident_Z_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_eqb
      | Coq3_Compilers.Coq_ident_Z_leb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_leb
      | Coq3_Compilers.Coq_ident_Z_ltb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_ltb
      | Coq3_Compilers.Coq_ident_Z_geb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_geb
      | Coq3_Compilers.Coq_ident_Z_gtb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_gtb
      | Coq3_Compilers.Coq_ident_Z_log2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_log2
      | Coq3_Compilers.Coq_ident_Z_log2_up ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_log2_up
      | Coq3_Compilers.Coq_ident_Z_of_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_of_nat
      | Coq3_Compilers.Coq_ident_Z_to_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Z_to_nat
      | Coq3_Compilers.Coq_ident_Z_shiftr ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_shiftr
      | Coq3_Compilers.Coq_ident_Z_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_shiftl
      | Coq3_Compilers.Coq_ident_Z_land ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_land
      | Coq3_Compilers.Coq_ident_Z_lor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_lor
      | Coq3_Compilers.Coq_ident_Z_min ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_min
      | Coq3_Compilers.Coq_ident_Z_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_max
      | Coq3_Compilers.Coq_ident_Z_mul_split ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_mul_split
      | Coq3_Compilers.Coq_ident_Z_mul_high ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_mul_high
      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_add_get_carry
      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_add_with_carry
      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_ident_Z_add_with_get_carry
      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_sub_get_borrow
      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow
      | Coq3_Compilers.Coq_ident_Z_ltz ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_ltz
      | Coq3_Compilers.Coq_ident_Z_zselect ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_zselect
      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_add_modulo
      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_truncating_shiftl
      | Coq3_Compilers.Coq_ident_Z_bneg ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_bneg
      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_lnot_modulo
      | Coq3_Compilers.Coq_ident_Z_lxor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_lxor
      | Coq3_Compilers.Coq_ident_Z_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_rshi
      | Coq3_Compilers.Coq_ident_Z_cc_m ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_cc_m
      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth
      | Coq3_Compilers.Coq_ident_Z_cast ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_cast
      | Coq3_Compilers.Coq_ident_Z_cast2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_cast2
      | Coq3_Compilers.Coq_ident_Some t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option t0))))
          (Coq3_Compilers.Coq_ident_Some t0)
      | Coq3_Compilers.Coq_ident_None t0 ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option t0))
          (Coq3_Compilers.Coq_ident_None t0)
      | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_option_rect (t0, t1))
      | Coq3_Compilers.Coq_ident_Build_zrange ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange))))))
          Coq3_Compilers.Coq_ident_Build_zrange
      | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0)))))
          (Coq3_Compilers.Coq_ident_zrange_rect t0)
      | Coq3_Compilers.Coq_ident_fancy_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_add
      | Coq3_Compilers.Coq_ident_fancy_addc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_addc
      | Coq3_Compilers.Coq_ident_fancy_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_sub
      | Coq3_Compilers.Coq_ident_fancy_subb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_subb
      | Coq3_Compilers.Coq_ident_fancy_mulll ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mulll
      | Coq3_Compilers.Coq_ident_fancy_mullh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mullh
      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mulhl
      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mulhh
      | Coq3_Compilers.Coq_ident_fancy_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_rshi
      | Coq3_Compilers.Coq_ident_fancy_selc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_selc
      | Coq3_Compilers.Coq_ident_fancy_selm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_selm
      | Coq3_Compilers.Coq_ident_fancy_sell ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_sell
      | Coq3_Compilers.Coq_ident_fancy_addm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_addm

      (** val eta_ident_cps_gen_expand_literal :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) **)

      let eta_ident_cps_gen_expand_literal f _ = function
      | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
        (match t0 with
         | Coq3_Compilers.Z ->
           (fun y0 ->
             f (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
               (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z, y0)))
         | Coq3_Compilers.Coq_bool ->
           (fun y0 ->
             f (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_bool)) (Coq3_Compilers.Coq_ident_Literal
               (Coq3_Compilers.Coq_bool, y0)))
         | Coq3_Compilers.Coq_nat ->
           (fun y0 ->
             f (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_nat)) (Coq3_Compilers.Coq_ident_Literal
               (Coq3_Compilers.Coq_nat, y0)))
         | Coq3_Compilers.Coq_zrange ->
           (fun y0 ->
             f (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_zrange)) (Coq3_Compilers.Coq_ident_Literal
               (Coq3_Compilers.Coq_zrange, y0)))
         | Coq3_Compilers.Coq_string ->
           (fun y0 ->
             f (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_string)) (Coq3_Compilers.Coq_ident_Literal
               (Coq3_Compilers.Coq_string, y0)))) y
      | Coq3_Compilers.Coq_ident_comment t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_ident_comment t0)
      | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_ident_comment_no_keep t0)
      | Coq3_Compilers.Coq_ident_value_barrier ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_value_barrier
      | Coq3_Compilers.Coq_ident_Nat_succ ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_succ
      | Coq3_Compilers.Coq_ident_Nat_pred ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_pred
      | Coq3_Compilers.Coq_ident_Nat_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_max
      | Coq3_Compilers.Coq_ident_Nat_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_mul
      | Coq3_Compilers.Coq_ident_Nat_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_add
      | Coq3_Compilers.Coq_ident_Nat_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_sub
      | Coq3_Compilers.Coq_ident_Nat_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Nat_eqb
      | Coq3_Compilers.Coq_ident_nil t0 ->
        f (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)) (Coq3_Compilers.Coq_ident_nil t0)
      | Coq3_Compilers.Coq_ident_cons t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))))) (Coq3_Compilers.Coq_ident_cons t0)
      | Coq3_Compilers.Coq_ident_tt ->
        f (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit)
          Coq3_Compilers.Coq_ident_tt
      | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))))))) (Coq3_Compilers.Coq_ident_pair (t0, t1))
      | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t0))) (Coq3_Compilers.Coq_ident_fst
          (t0, t1))
      | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t1))) (Coq3_Compilers.Coq_ident_snd
          (t0, t1))
      | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t2)))))
          (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2))
      | Coq3_Compilers.Coq_ident_bool_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_bool_rect t0)
      | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_bool_rect_nodep t0)
      | Coq3_Compilers.Coq_ident_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_nat_rect t0)
      | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_eager_nat_rect t0)
      | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1))
      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1))
      | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_list_rect (t0, t1))
      | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1))
      | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2))
      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2))
      | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base t1))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_list_case (t0, t1))
      | Coq3_Compilers.Coq_ident_List_length t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) (Coq3_Compilers.Coq_ident_List_length t0)
      | Coq3_Compilers.Coq_ident_List_seq ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))) Coq3_Compilers.Coq_ident_List_seq
      | Coq3_Compilers.Coq_ident_List_firstn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_firstn t0)
      | Coq3_Compilers.Coq_ident_List_skipn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_skipn t0)
      | Coq3_Compilers.Coq_ident_List_repeat t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_repeat t0)
      | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
          (Coq3_Compilers.Coq_ident_List_combine (t0, t1))
      | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))))) (Coq3_Compilers.Coq_ident_List_map (t0, t1))
      | Coq3_Compilers.Coq_ident_List_app t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))))) (Coq3_Compilers.Coq_ident_List_app t0)
      | Coq3_Compilers.Coq_ident_List_rev t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))) (Coq3_Compilers.Coq_ident_List_rev t0)
      | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))))) (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1))
      | Coq3_Compilers.Coq_ident_List_partition t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_list t0),
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_ident_List_partition t0)
      | Coq3_Compilers.Coq_ident_List_filter t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_ident_List_filter t0)
      | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1))
      | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_ident_List_update_nth t0)
      | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_List_nth_default t0)
      | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_ident_eager_List_nth_default t0)
      | Coq3_Compilers.Coq_ident_Z_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_add
      | Coq3_Compilers.Coq_ident_Z_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_mul
      | Coq3_Compilers.Coq_ident_Z_pow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_pow
      | Coq3_Compilers.Coq_ident_Z_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_sub
      | Coq3_Compilers.Coq_ident_Z_opp ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_opp
      | Coq3_Compilers.Coq_ident_Z_div ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_div
      | Coq3_Compilers.Coq_ident_Z_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_modulo
      | Coq3_Compilers.Coq_ident_Z_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_eqb
      | Coq3_Compilers.Coq_ident_Z_leb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_leb
      | Coq3_Compilers.Coq_ident_Z_ltb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_ltb
      | Coq3_Compilers.Coq_ident_Z_geb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_geb
      | Coq3_Compilers.Coq_ident_Z_gtb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_gtb
      | Coq3_Compilers.Coq_ident_Z_log2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_log2
      | Coq3_Compilers.Coq_ident_Z_log2_up ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_log2_up
      | Coq3_Compilers.Coq_ident_Z_of_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_of_nat
      | Coq3_Compilers.Coq_ident_Z_to_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Z_to_nat
      | Coq3_Compilers.Coq_ident_Z_shiftr ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_shiftr
      | Coq3_Compilers.Coq_ident_Z_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_shiftl
      | Coq3_Compilers.Coq_ident_Z_land ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_land
      | Coq3_Compilers.Coq_ident_Z_lor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_lor
      | Coq3_Compilers.Coq_ident_Z_min ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_min
      | Coq3_Compilers.Coq_ident_Z_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_max
      | Coq3_Compilers.Coq_ident_Z_mul_split ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_mul_split
      | Coq3_Compilers.Coq_ident_Z_mul_high ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_mul_high
      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_add_get_carry
      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_add_with_carry
      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_ident_Z_add_with_get_carry
      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_sub_get_borrow
      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow
      | Coq3_Compilers.Coq_ident_Z_ltz ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_ltz
      | Coq3_Compilers.Coq_ident_Z_zselect ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_zselect
      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_add_modulo
      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_truncating_shiftl
      | Coq3_Compilers.Coq_ident_Z_bneg ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_Z_bneg
      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_lnot_modulo
      | Coq3_Compilers.Coq_ident_Z_lxor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_lxor
      | Coq3_Compilers.Coq_ident_Z_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_rshi
      | Coq3_Compilers.Coq_ident_Z_cc_m ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_cc_m
      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth
      | Coq3_Compilers.Coq_ident_Z_cast ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_Z_cast
      | Coq3_Compilers.Coq_ident_Z_cast2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_ident_Z_cast2
      | Coq3_Compilers.Coq_ident_Some t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option t0))))
          (Coq3_Compilers.Coq_ident_Some t0)
      | Coq3_Compilers.Coq_ident_None t0 ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option t0))
          (Coq3_Compilers.Coq_ident_None t0)
      | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_ident_option_rect (t0, t1))
      | Coq3_Compilers.Coq_ident_Build_zrange ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange))))))
          Coq3_Compilers.Coq_ident_Build_zrange
      | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0)))))
          (Coq3_Compilers.Coq_ident_zrange_rect t0)
      | Coq3_Compilers.Coq_ident_fancy_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_add
      | Coq3_Compilers.Coq_ident_fancy_addc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_addc
      | Coq3_Compilers.Coq_ident_fancy_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_sub
      | Coq3_Compilers.Coq_ident_fancy_subb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_ident_fancy_subb
      | Coq3_Compilers.Coq_ident_fancy_mulll ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mulll
      | Coq3_Compilers.Coq_ident_fancy_mullh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mullh
      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mulhl
      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_mulhh
      | Coq3_Compilers.Coq_ident_fancy_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_rshi
      | Coq3_Compilers.Coq_ident_fancy_selc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_selc
      | Coq3_Compilers.Coq_ident_fancy_selm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_selm
      | Coq3_Compilers.Coq_ident_fancy_sell ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_sell
      | Coq3_Compilers.Coq_ident_fancy_addm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
          Coq3_Compilers.Coq_ident_fancy_addm

      (** val eta_ident_cps :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> 'a1) -> 'a1 **)

      let eta_ident_cps _ idc f =
        match idc with
        | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
          f (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base t0))
            (Coq3_Compilers.Coq_ident_Literal (t0, y))
        | Coq3_Compilers.Coq_ident_comment t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit)))
            (Coq3_Compilers.Coq_ident_comment t0)
        | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit)))
            (Coq3_Compilers.Coq_ident_comment_no_keep t0)
        | Coq3_Compilers.Coq_ident_value_barrier ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_value_barrier
        | Coq3_Compilers.Coq_ident_Nat_succ ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_succ
        | Coq3_Compilers.Coq_ident_Nat_pred ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_pred
        | Coq3_Compilers.Coq_ident_Nat_max ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_max
        | Coq3_Compilers.Coq_ident_Nat_mul ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_mul
        | Coq3_Compilers.Coq_ident_Nat_add ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_add
        | Coq3_Compilers.Coq_ident_Nat_sub ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_sub
        | Coq3_Compilers.Coq_ident_Nat_eqb ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Nat_eqb
        | Coq3_Compilers.Coq_ident_nil t0 ->
          f (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Coq3_Compilers.Coq_ident_nil t0)
        | Coq3_Compilers.Coq_ident_cons t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
            (Coq3_Compilers.Coq_ident_cons t0)
        | Coq3_Compilers.Coq_ident_tt ->
          f (Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit) Coq3_Compilers.Coq_ident_tt
        | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))
            (Coq3_Compilers.Coq_ident_pair (t0, t1))
        | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
            (Compilers.Coq_type.Coq_base t0))) (Coq3_Compilers.Coq_ident_fst
            (t0, t1))
        | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
            (Compilers.Coq_type.Coq_base t1))) (Coq3_Compilers.Coq_ident_snd
            (t0, t1))
        | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
            (Compilers.Coq_type.Coq_base t2)))))
            (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2))
        | Coq3_Compilers.Coq_ident_bool_rect t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
            (Coq3_Compilers.Coq_ident_bool_rect t0)
        | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
            (Coq3_Compilers.Coq_ident_bool_rect_nodep t0)
        | Coq3_Compilers.Coq_ident_nat_rect t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
            (Coq3_Compilers.Coq_ident_nat_rect t0)
        | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
            (Coq3_Compilers.Coq_ident_eager_nat_rect t0)
        | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))))) (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1))
        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))))) (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0,
            t1))
        | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t1))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1)))))))
            (Coq3_Compilers.Coq_ident_list_rect (t0, t1))
        | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t1))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1)))))))
            (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1))
        | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t2)))))))))
            (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2))
        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t2)))))))))
            (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2))
        | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1)))))))
            (Coq3_Compilers.Coq_ident_list_case (t0, t1))
        | Coq3_Compilers.Coq_ident_List_length t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))) (Coq3_Compilers.Coq_ident_List_length
            t0)
        | Coq3_Compilers.Coq_ident_List_seq ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))))))) Coq3_Compilers.Coq_ident_List_seq
        | Coq3_Compilers.Coq_ident_List_firstn t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
            (Coq3_Compilers.Coq_ident_List_firstn t0)
        | Coq3_Compilers.Coq_ident_List_skipn t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
            (Coq3_Compilers.Coq_ident_List_skipn t0)
        | Coq3_Compilers.Coq_ident_List_repeat t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
            (Coq3_Compilers.Coq_ident_List_repeat t0)
        | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
            (Coq3_Compilers.Coq_ident_List_combine (t0, t1))
        | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1))))))
            (Coq3_Compilers.Coq_ident_List_map (t0, t1))
        | Coq3_Compilers.Coq_ident_List_app t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
            (Coq3_Compilers.Coq_ident_List_app t0)
        | Coq3_Compilers.Coq_ident_List_rev t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))
            (Coq3_Compilers.Coq_ident_List_rev t0)
        | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1))))))
            (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1))
        | Coq3_Compilers.Coq_ident_List_partition t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
            (Coq3_Compilers.Coq_ident_List_partition t0)
        | Coq3_Compilers.Coq_ident_List_filter t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
            (Coq3_Compilers.Coq_ident_List_filter t0)
        | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base t0)))))))
            (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1))
        | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
            (Coq3_Compilers.Coq_ident_List_update_nth t0)
        | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
            (Coq3_Compilers.Coq_ident_List_nth_default t0)
        | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
            (Coq3_Compilers.Coq_ident_eager_List_nth_default t0)
        | Coq3_Compilers.Coq_ident_Z_add ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_add
        | Coq3_Compilers.Coq_ident_Z_mul ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_mul
        | Coq3_Compilers.Coq_ident_Z_pow ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_pow
        | Coq3_Compilers.Coq_ident_Z_sub ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_sub
        | Coq3_Compilers.Coq_ident_Z_opp ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_Z_opp
        | Coq3_Compilers.Coq_ident_Z_div ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_div
        | Coq3_Compilers.Coq_ident_Z_modulo ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_modulo
        | Coq3_Compilers.Coq_ident_Z_eqb ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_eqb
        | Coq3_Compilers.Coq_ident_Z_leb ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_leb
        | Coq3_Compilers.Coq_ident_Z_ltb ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_ltb
        | Coq3_Compilers.Coq_ident_Z_geb ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_geb
        | Coq3_Compilers.Coq_ident_Z_gtb ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_gtb
        | Coq3_Compilers.Coq_ident_Z_log2 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_Z_log2
        | Coq3_Compilers.Coq_ident_Z_log2_up ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_Z_log2_up
        | Coq3_Compilers.Coq_ident_Z_of_nat ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_Z_of_nat
        | Coq3_Compilers.Coq_ident_Z_to_nat ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Z_to_nat
        | Coq3_Compilers.Coq_ident_Z_shiftr ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_shiftr
        | Coq3_Compilers.Coq_ident_Z_shiftl ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_shiftl
        | Coq3_Compilers.Coq_ident_Z_land ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_land
        | Coq3_Compilers.Coq_ident_Z_lor ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_lor
        | Coq3_Compilers.Coq_ident_Z_min ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_min
        | Coq3_Compilers.Coq_ident_Z_max ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_max
        | Coq3_Compilers.Coq_ident_Z_mul_split ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_mul_split
        | Coq3_Compilers.Coq_ident_Z_mul_high ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_ident_Z_mul_high
        | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))))
            Coq3_Compilers.Coq_ident_Z_add_get_carry
        | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_ident_Z_add_with_carry
        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))))))
            Coq3_Compilers.Coq_ident_Z_add_with_get_carry
        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))))
            Coq3_Compilers.Coq_ident_Z_sub_get_borrow
        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))))))
            Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow
        | Coq3_Compilers.Coq_ident_Z_ltz ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_ltz
        | Coq3_Compilers.Coq_ident_Z_zselect ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_ident_Z_zselect
        | Coq3_Compilers.Coq_ident_Z_add_modulo ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_ident_Z_add_modulo
        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))
            Coq3_Compilers.Coq_ident_Z_truncating_shiftl
        | Coq3_Compilers.Coq_ident_Z_bneg ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_Z_bneg
        | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_lnot_modulo
        | Coq3_Compilers.Coq_ident_Z_lxor ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_lxor
        | Coq3_Compilers.Coq_ident_Z_rshi ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_rshi
        | Coq3_Compilers.Coq_ident_Z_cc_m ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_cc_m
        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))
            Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth
        | Coq3_Compilers.Coq_ident_Z_cast ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_Z_cast
        | Coq3_Compilers.Coq_ident_Z_cast2 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_ident_Z_cast2
        | Coq3_Compilers.Coq_ident_Some t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_option t0))))
            (Coq3_Compilers.Coq_ident_Some t0)
        | Coq3_Compilers.Coq_ident_None t0 ->
          f (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_option t0))
            (Coq3_Compilers.Coq_ident_None t0)
        | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_option t0)),
            (Compilers.Coq_type.Coq_base t1)))))))
            (Coq3_Compilers.Coq_ident_option_rect (t0, t1))
        | Coq3_Compilers.Coq_ident_Build_zrange ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))))
            Coq3_Compilers.Coq_ident_Build_zrange
        | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base t0))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0)))))
            (Coq3_Compilers.Coq_ident_zrange_rect t0)
        | Coq3_Compilers.Coq_ident_fancy_add ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_fancy_add
        | Coq3_Compilers.Coq_ident_fancy_addc ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_fancy_addc
        | Coq3_Compilers.Coq_ident_fancy_sub ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_fancy_sub
        | Coq3_Compilers.Coq_ident_fancy_subb ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
            Coq3_Compilers.Coq_ident_fancy_subb
        | Coq3_Compilers.Coq_ident_fancy_mulll ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_mulll
        | Coq3_Compilers.Coq_ident_fancy_mullh ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_mullh
        | Coq3_Compilers.Coq_ident_fancy_mulhl ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_mulhl
        | Coq3_Compilers.Coq_ident_fancy_mulhh ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_mulhh
        | Coq3_Compilers.Coq_ident_fancy_rshi ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_rshi
        | Coq3_Compilers.Coq_ident_fancy_selc ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_selc
        | Coq3_Compilers.Coq_ident_fancy_selm ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_selm
        | Coq3_Compilers.Coq_ident_fancy_sell ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_sell
        | Coq3_Compilers.Coq_ident_fancy_addm ->
          f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            Coq3_Compilers.Coq_ident_fancy_addm

      (** val simple_idents :
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type, Coq3_Compilers.ident)
          Coq_Primitive.sigT list **)

      let simple_idents =
        { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_value_barrier } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Nat_succ } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Nat_pred } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Nat_max } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Nat_mul } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Nat_add } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Nat_sub } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Nat_eqb } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit);
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_tt } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_List_seq } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_add } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_mul } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_pow } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_sub } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_opp } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_div } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_modulo } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_eqb } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_leb } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_ltb } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_geb } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_gtb } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_log2 } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_log2_up } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_of_nat } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_to_nat } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_shiftr } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_shiftl } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_land } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_lor } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_min } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_max } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_mul_split } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_mul_high } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_add_get_carry } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_add_with_carry } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_add_with_get_carry } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_sub_get_borrow } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_ltz } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_zselect } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_add_modulo } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_truncating_shiftl } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_bneg } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_lnot_modulo } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_lxor } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_rshi } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_cc_m } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_cast } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Z_cast2 } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))))); Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_Build_zrange } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_add } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_addc } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_sub } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_subb } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_mulll } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_mullh } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_mulhl } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_mulhh } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_rshi } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_selc } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_selm } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_sell } :: ({ Coq_Primitive.projT1 =
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq_Primitive.projT2 =
          Coq3_Compilers.Coq_ident_fancy_addm } :: []))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

      (** val all_raw_idents : Coq3_Compilers.raw_ident list **)

      let all_raw_idents =
        Coq3_Compilers.Coq_raw_ident_Literal :: (Coq3_Compilers.Coq_raw_ident_comment :: (Coq3_Compilers.Coq_raw_ident_comment_no_keep :: (Coq3_Compilers.Coq_raw_ident_value_barrier :: (Coq3_Compilers.Coq_raw_ident_Nat_succ :: (Coq3_Compilers.Coq_raw_ident_Nat_pred :: (Coq3_Compilers.Coq_raw_ident_Nat_max :: (Coq3_Compilers.Coq_raw_ident_Nat_mul :: (Coq3_Compilers.Coq_raw_ident_Nat_add :: (Coq3_Compilers.Coq_raw_ident_Nat_sub :: (Coq3_Compilers.Coq_raw_ident_Nat_eqb :: (Coq3_Compilers.Coq_raw_ident_nil :: (Coq3_Compilers.Coq_raw_ident_cons :: (Coq3_Compilers.Coq_raw_ident_tt :: (Coq3_Compilers.Coq_raw_ident_pair :: (Coq3_Compilers.Coq_raw_ident_fst :: (Coq3_Compilers.Coq_raw_ident_snd :: (Coq3_Compilers.Coq_raw_ident_prod_rect :: (Coq3_Compilers.Coq_raw_ident_bool_rect :: (Coq3_Compilers.Coq_raw_ident_bool_rect_nodep :: (Coq3_Compilers.Coq_raw_ident_nat_rect :: (Coq3_Compilers.Coq_raw_ident_eager_nat_rect :: (Coq3_Compilers.Coq_raw_ident_nat_rect_arrow :: (Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow :: (Coq3_Compilers.Coq_raw_ident_list_rect :: (Coq3_Compilers.Coq_raw_ident_eager_list_rect :: (Coq3_Compilers.Coq_raw_ident_list_rect_arrow :: (Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow :: (Coq3_Compilers.Coq_raw_ident_list_case :: (Coq3_Compilers.Coq_raw_ident_List_length :: (Coq3_Compilers.Coq_raw_ident_List_seq :: (Coq3_Compilers.Coq_raw_ident_List_firstn :: (Coq3_Compilers.Coq_raw_ident_List_skipn :: (Coq3_Compilers.Coq_raw_ident_List_repeat :: (Coq3_Compilers.Coq_raw_ident_List_combine :: (Coq3_Compilers.Coq_raw_ident_List_map :: (Coq3_Compilers.Coq_raw_ident_List_app :: (Coq3_Compilers.Coq_raw_ident_List_rev :: (Coq3_Compilers.Coq_raw_ident_List_flat_map :: (Coq3_Compilers.Coq_raw_ident_List_partition :: (Coq3_Compilers.Coq_raw_ident_List_filter :: (Coq3_Compilers.Coq_raw_ident_List_fold_right :: (Coq3_Compilers.Coq_raw_ident_List_update_nth :: (Coq3_Compilers.Coq_raw_ident_List_nth_default :: (Coq3_Compilers.Coq_raw_ident_eager_List_nth_default :: (Coq3_Compilers.Coq_raw_ident_Z_add :: (Coq3_Compilers.Coq_raw_ident_Z_mul :: (Coq3_Compilers.Coq_raw_ident_Z_pow :: (Coq3_Compilers.Coq_raw_ident_Z_sub :: (Coq3_Compilers.Coq_raw_ident_Z_opp :: (Coq3_Compilers.Coq_raw_ident_Z_div :: (Coq3_Compilers.Coq_raw_ident_Z_modulo :: (Coq3_Compilers.Coq_raw_ident_Z_eqb :: (Coq3_Compilers.Coq_raw_ident_Z_leb :: (Coq3_Compilers.Coq_raw_ident_Z_ltb :: (Coq3_Compilers.Coq_raw_ident_Z_geb :: (Coq3_Compilers.Coq_raw_ident_Z_gtb :: (Coq3_Compilers.Coq_raw_ident_Z_log2 :: (Coq3_Compilers.Coq_raw_ident_Z_log2_up :: (Coq3_Compilers.Coq_raw_ident_Z_of_nat :: (Coq3_Compilers.Coq_raw_ident_Z_to_nat :: (Coq3_Compilers.Coq_raw_ident_Z_shiftr :: (Coq3_Compilers.Coq_raw_ident_Z_shiftl :: (Coq3_Compilers.Coq_raw_ident_Z_land :: (Coq3_Compilers.Coq_raw_ident_Z_lor :: (Coq3_Compilers.Coq_raw_ident_Z_min :: (Coq3_Compilers.Coq_raw_ident_Z_max :: (Coq3_Compilers.Coq_raw_ident_Z_mul_split :: (Coq3_Compilers.Coq_raw_ident_Z_mul_high :: (Coq3_Compilers.Coq_raw_ident_Z_add_get_carry :: (Coq3_Compilers.Coq_raw_ident_Z_add_with_carry :: (Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry :: (Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow :: (Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow :: (Coq3_Compilers.Coq_raw_ident_Z_ltz :: (Coq3_Compilers.Coq_raw_ident_Z_zselect :: (Coq3_Compilers.Coq_raw_ident_Z_add_modulo :: (Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl :: (Coq3_Compilers.Coq_raw_ident_Z_bneg :: (Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo :: (Coq3_Compilers.Coq_raw_ident_Z_lxor :: (Coq3_Compilers.Coq_raw_ident_Z_rshi :: (Coq3_Compilers.Coq_raw_ident_Z_cc_m :: (Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth :: (Coq3_Compilers.Coq_raw_ident_Z_cast :: (Coq3_Compilers.Coq_raw_ident_Z_cast2 :: (Coq3_Compilers.Coq_raw_ident_Some :: (Coq3_Compilers.Coq_raw_ident_None :: (Coq3_Compilers.Coq_raw_ident_option_rect :: (Coq3_Compilers.Coq_raw_ident_Build_zrange :: (Coq3_Compilers.Coq_raw_ident_zrange_rect :: (Coq3_Compilers.Coq_raw_ident_fancy_add :: (Coq3_Compilers.Coq_raw_ident_fancy_addc :: (Coq3_Compilers.Coq_raw_ident_fancy_sub :: (Coq3_Compilers.Coq_raw_ident_fancy_subb :: (Coq3_Compilers.Coq_raw_ident_fancy_mulll :: (Coq3_Compilers.Coq_raw_ident_fancy_mullh :: (Coq3_Compilers.Coq_raw_ident_fancy_mulhl :: (Coq3_Compilers.Coq_raw_ident_fancy_mulhh :: (Coq3_Compilers.Coq_raw_ident_fancy_rshi :: (Coq3_Compilers.Coq_raw_ident_fancy_selc :: (Coq3_Compilers.Coq_raw_ident_fancy_selm :: (Coq3_Compilers.Coq_raw_ident_fancy_sell :: (Coq3_Compilers.Coq_raw_ident_fancy_addm :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

      (** val ident_index0 : Coq3_Compilers.raw_ident -> nat **)

      let ident_index0 = function
      | Coq3_Compilers.Coq_raw_ident_Literal -> O
      | Coq3_Compilers.Coq_raw_ident_comment -> S O
      | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> S (S O)
      | Coq3_Compilers.Coq_raw_ident_value_barrier -> S (S (S O))
      | Coq3_Compilers.Coq_raw_ident_Nat_succ -> S (S (S (S O)))
      | Coq3_Compilers.Coq_raw_ident_Nat_pred -> S (S (S (S (S O))))
      | Coq3_Compilers.Coq_raw_ident_Nat_max -> S (S (S (S (S (S O)))))
      | Coq3_Compilers.Coq_raw_ident_Nat_mul -> S (S (S (S (S (S (S O))))))
      | Coq3_Compilers.Coq_raw_ident_Nat_add ->
        S (S (S (S (S (S (S (S O)))))))
      | Coq3_Compilers.Coq_raw_ident_Nat_sub ->
        S (S (S (S (S (S (S (S (S O))))))))
      | Coq3_Compilers.Coq_raw_ident_Nat_eqb ->
        S (S (S (S (S (S (S (S (S (S O)))))))))
      | Coq3_Compilers.Coq_raw_ident_nil ->
        S (S (S (S (S (S (S (S (S (S (S O))))))))))
      | Coq3_Compilers.Coq_raw_ident_cons ->
        S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))
      | Coq3_Compilers.Coq_raw_ident_tt ->
        S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))
      | Coq3_Compilers.Coq_raw_ident_pair ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fst ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_snd ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_prod_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_bool_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_nat_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_eager_nat_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_list_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S O)))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_eager_list_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S O))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_list_rect_arrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S O)))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S O))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_list_case ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S O)))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_length ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S O))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_seq ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_firstn ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_skipn ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_repeat ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_combine ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_map ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_app ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_rev ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_flat_map ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_partition ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_filter ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_fold_right ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_update_nth ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_List_nth_default ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_add ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_mul ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S O)))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_pow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S O))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_sub ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S O)))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_opp ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S O))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_div ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_modulo ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_eqb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_leb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_ltb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_geb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_gtb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_log2 ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_log2_up ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_of_nat ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_to_nat ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_shiftr ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_shiftl ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_land ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_lor ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_min ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_max ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_mul_split ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_mul_high ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_ltz ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_zselect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_add_modulo ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_bneg ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_lxor ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_rshi ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_cc_m ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_cast ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Z_cast2 ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Some ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_None ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_option_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_Build_zrange ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_zrange_rect ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_add ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_addc ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_sub ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_subb ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_mulll ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_mullh ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_mulhl ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_mulhh ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_rshi ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_selc ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_selm ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_sell ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S
          O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      | Coq3_Compilers.Coq_raw_ident_fancy_addm ->
        S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          (S (S (S (S (S (S (S (S (S (S (S (S (S (S
          O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

      (** val eta_ident_cps_gen0 :
          (Coq3_Compilers.raw_ident -> 'a1) -> (Coq3_Compilers.raw_ident ->
          'a1) **)

      let eta_ident_cps_gen0 f = function
      | Coq3_Compilers.Coq_raw_ident_Literal ->
        f Coq3_Compilers.Coq_raw_ident_Literal
      | Coq3_Compilers.Coq_raw_ident_comment ->
        f Coq3_Compilers.Coq_raw_ident_comment
      | Coq3_Compilers.Coq_raw_ident_comment_no_keep ->
        f Coq3_Compilers.Coq_raw_ident_comment_no_keep
      | Coq3_Compilers.Coq_raw_ident_value_barrier ->
        f Coq3_Compilers.Coq_raw_ident_value_barrier
      | Coq3_Compilers.Coq_raw_ident_Nat_succ ->
        f Coq3_Compilers.Coq_raw_ident_Nat_succ
      | Coq3_Compilers.Coq_raw_ident_Nat_pred ->
        f Coq3_Compilers.Coq_raw_ident_Nat_pred
      | Coq3_Compilers.Coq_raw_ident_Nat_max ->
        f Coq3_Compilers.Coq_raw_ident_Nat_max
      | Coq3_Compilers.Coq_raw_ident_Nat_mul ->
        f Coq3_Compilers.Coq_raw_ident_Nat_mul
      | Coq3_Compilers.Coq_raw_ident_Nat_add ->
        f Coq3_Compilers.Coq_raw_ident_Nat_add
      | Coq3_Compilers.Coq_raw_ident_Nat_sub ->
        f Coq3_Compilers.Coq_raw_ident_Nat_sub
      | Coq3_Compilers.Coq_raw_ident_Nat_eqb ->
        f Coq3_Compilers.Coq_raw_ident_Nat_eqb
      | Coq3_Compilers.Coq_raw_ident_nil -> f Coq3_Compilers.Coq_raw_ident_nil
      | Coq3_Compilers.Coq_raw_ident_cons ->
        f Coq3_Compilers.Coq_raw_ident_cons
      | Coq3_Compilers.Coq_raw_ident_tt -> f Coq3_Compilers.Coq_raw_ident_tt
      | Coq3_Compilers.Coq_raw_ident_pair ->
        f Coq3_Compilers.Coq_raw_ident_pair
      | Coq3_Compilers.Coq_raw_ident_fst -> f Coq3_Compilers.Coq_raw_ident_fst
      | Coq3_Compilers.Coq_raw_ident_snd -> f Coq3_Compilers.Coq_raw_ident_snd
      | Coq3_Compilers.Coq_raw_ident_prod_rect ->
        f Coq3_Compilers.Coq_raw_ident_prod_rect
      | Coq3_Compilers.Coq_raw_ident_bool_rect ->
        f Coq3_Compilers.Coq_raw_ident_bool_rect
      | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep ->
        f Coq3_Compilers.Coq_raw_ident_bool_rect_nodep
      | Coq3_Compilers.Coq_raw_ident_nat_rect ->
        f Coq3_Compilers.Coq_raw_ident_nat_rect
      | Coq3_Compilers.Coq_raw_ident_eager_nat_rect ->
        f Coq3_Compilers.Coq_raw_ident_eager_nat_rect
      | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow ->
        f Coq3_Compilers.Coq_raw_ident_nat_rect_arrow
      | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow ->
        f Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow
      | Coq3_Compilers.Coq_raw_ident_list_rect ->
        f Coq3_Compilers.Coq_raw_ident_list_rect
      | Coq3_Compilers.Coq_raw_ident_eager_list_rect ->
        f Coq3_Compilers.Coq_raw_ident_eager_list_rect
      | Coq3_Compilers.Coq_raw_ident_list_rect_arrow ->
        f Coq3_Compilers.Coq_raw_ident_list_rect_arrow
      | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow ->
        f Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow
      | Coq3_Compilers.Coq_raw_ident_list_case ->
        f Coq3_Compilers.Coq_raw_ident_list_case
      | Coq3_Compilers.Coq_raw_ident_List_length ->
        f Coq3_Compilers.Coq_raw_ident_List_length
      | Coq3_Compilers.Coq_raw_ident_List_seq ->
        f Coq3_Compilers.Coq_raw_ident_List_seq
      | Coq3_Compilers.Coq_raw_ident_List_firstn ->
        f Coq3_Compilers.Coq_raw_ident_List_firstn
      | Coq3_Compilers.Coq_raw_ident_List_skipn ->
        f Coq3_Compilers.Coq_raw_ident_List_skipn
      | Coq3_Compilers.Coq_raw_ident_List_repeat ->
        f Coq3_Compilers.Coq_raw_ident_List_repeat
      | Coq3_Compilers.Coq_raw_ident_List_combine ->
        f Coq3_Compilers.Coq_raw_ident_List_combine
      | Coq3_Compilers.Coq_raw_ident_List_map ->
        f Coq3_Compilers.Coq_raw_ident_List_map
      | Coq3_Compilers.Coq_raw_ident_List_app ->
        f Coq3_Compilers.Coq_raw_ident_List_app
      | Coq3_Compilers.Coq_raw_ident_List_rev ->
        f Coq3_Compilers.Coq_raw_ident_List_rev
      | Coq3_Compilers.Coq_raw_ident_List_flat_map ->
        f Coq3_Compilers.Coq_raw_ident_List_flat_map
      | Coq3_Compilers.Coq_raw_ident_List_partition ->
        f Coq3_Compilers.Coq_raw_ident_List_partition
      | Coq3_Compilers.Coq_raw_ident_List_filter ->
        f Coq3_Compilers.Coq_raw_ident_List_filter
      | Coq3_Compilers.Coq_raw_ident_List_fold_right ->
        f Coq3_Compilers.Coq_raw_ident_List_fold_right
      | Coq3_Compilers.Coq_raw_ident_List_update_nth ->
        f Coq3_Compilers.Coq_raw_ident_List_update_nth
      | Coq3_Compilers.Coq_raw_ident_List_nth_default ->
        f Coq3_Compilers.Coq_raw_ident_List_nth_default
      | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default ->
        f Coq3_Compilers.Coq_raw_ident_eager_List_nth_default
      | Coq3_Compilers.Coq_raw_ident_Z_add ->
        f Coq3_Compilers.Coq_raw_ident_Z_add
      | Coq3_Compilers.Coq_raw_ident_Z_mul ->
        f Coq3_Compilers.Coq_raw_ident_Z_mul
      | Coq3_Compilers.Coq_raw_ident_Z_pow ->
        f Coq3_Compilers.Coq_raw_ident_Z_pow
      | Coq3_Compilers.Coq_raw_ident_Z_sub ->
        f Coq3_Compilers.Coq_raw_ident_Z_sub
      | Coq3_Compilers.Coq_raw_ident_Z_opp ->
        f Coq3_Compilers.Coq_raw_ident_Z_opp
      | Coq3_Compilers.Coq_raw_ident_Z_div ->
        f Coq3_Compilers.Coq_raw_ident_Z_div
      | Coq3_Compilers.Coq_raw_ident_Z_modulo ->
        f Coq3_Compilers.Coq_raw_ident_Z_modulo
      | Coq3_Compilers.Coq_raw_ident_Z_eqb ->
        f Coq3_Compilers.Coq_raw_ident_Z_eqb
      | Coq3_Compilers.Coq_raw_ident_Z_leb ->
        f Coq3_Compilers.Coq_raw_ident_Z_leb
      | Coq3_Compilers.Coq_raw_ident_Z_ltb ->
        f Coq3_Compilers.Coq_raw_ident_Z_ltb
      | Coq3_Compilers.Coq_raw_ident_Z_geb ->
        f Coq3_Compilers.Coq_raw_ident_Z_geb
      | Coq3_Compilers.Coq_raw_ident_Z_gtb ->
        f Coq3_Compilers.Coq_raw_ident_Z_gtb
      | Coq3_Compilers.Coq_raw_ident_Z_log2 ->
        f Coq3_Compilers.Coq_raw_ident_Z_log2
      | Coq3_Compilers.Coq_raw_ident_Z_log2_up ->
        f Coq3_Compilers.Coq_raw_ident_Z_log2_up
      | Coq3_Compilers.Coq_raw_ident_Z_of_nat ->
        f Coq3_Compilers.Coq_raw_ident_Z_of_nat
      | Coq3_Compilers.Coq_raw_ident_Z_to_nat ->
        f Coq3_Compilers.Coq_raw_ident_Z_to_nat
      | Coq3_Compilers.Coq_raw_ident_Z_shiftr ->
        f Coq3_Compilers.Coq_raw_ident_Z_shiftr
      | Coq3_Compilers.Coq_raw_ident_Z_shiftl ->
        f Coq3_Compilers.Coq_raw_ident_Z_shiftl
      | Coq3_Compilers.Coq_raw_ident_Z_land ->
        f Coq3_Compilers.Coq_raw_ident_Z_land
      | Coq3_Compilers.Coq_raw_ident_Z_lor ->
        f Coq3_Compilers.Coq_raw_ident_Z_lor
      | Coq3_Compilers.Coq_raw_ident_Z_min ->
        f Coq3_Compilers.Coq_raw_ident_Z_min
      | Coq3_Compilers.Coq_raw_ident_Z_max ->
        f Coq3_Compilers.Coq_raw_ident_Z_max
      | Coq3_Compilers.Coq_raw_ident_Z_mul_split ->
        f Coq3_Compilers.Coq_raw_ident_Z_mul_split
      | Coq3_Compilers.Coq_raw_ident_Z_mul_high ->
        f Coq3_Compilers.Coq_raw_ident_Z_mul_high
      | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry ->
        f Coq3_Compilers.Coq_raw_ident_Z_add_get_carry
      | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry ->
        f Coq3_Compilers.Coq_raw_ident_Z_add_with_carry
      | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry ->
        f Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry
      | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow ->
        f Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow
      | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow ->
        f Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow
      | Coq3_Compilers.Coq_raw_ident_Z_ltz ->
        f Coq3_Compilers.Coq_raw_ident_Z_ltz
      | Coq3_Compilers.Coq_raw_ident_Z_zselect ->
        f Coq3_Compilers.Coq_raw_ident_Z_zselect
      | Coq3_Compilers.Coq_raw_ident_Z_add_modulo ->
        f Coq3_Compilers.Coq_raw_ident_Z_add_modulo
      | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl ->
        f Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl
      | Coq3_Compilers.Coq_raw_ident_Z_bneg ->
        f Coq3_Compilers.Coq_raw_ident_Z_bneg
      | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo ->
        f Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo
      | Coq3_Compilers.Coq_raw_ident_Z_lxor ->
        f Coq3_Compilers.Coq_raw_ident_Z_lxor
      | Coq3_Compilers.Coq_raw_ident_Z_rshi ->
        f Coq3_Compilers.Coq_raw_ident_Z_rshi
      | Coq3_Compilers.Coq_raw_ident_Z_cc_m ->
        f Coq3_Compilers.Coq_raw_ident_Z_cc_m
      | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth ->
        f Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth
      | Coq3_Compilers.Coq_raw_ident_Z_cast ->
        f Coq3_Compilers.Coq_raw_ident_Z_cast
      | Coq3_Compilers.Coq_raw_ident_Z_cast2 ->
        f Coq3_Compilers.Coq_raw_ident_Z_cast2
      | Coq3_Compilers.Coq_raw_ident_Some ->
        f Coq3_Compilers.Coq_raw_ident_Some
      | Coq3_Compilers.Coq_raw_ident_None ->
        f Coq3_Compilers.Coq_raw_ident_None
      | Coq3_Compilers.Coq_raw_ident_option_rect ->
        f Coq3_Compilers.Coq_raw_ident_option_rect
      | Coq3_Compilers.Coq_raw_ident_Build_zrange ->
        f Coq3_Compilers.Coq_raw_ident_Build_zrange
      | Coq3_Compilers.Coq_raw_ident_zrange_rect ->
        f Coq3_Compilers.Coq_raw_ident_zrange_rect
      | Coq3_Compilers.Coq_raw_ident_fancy_add ->
        f Coq3_Compilers.Coq_raw_ident_fancy_add
      | Coq3_Compilers.Coq_raw_ident_fancy_addc ->
        f Coq3_Compilers.Coq_raw_ident_fancy_addc
      | Coq3_Compilers.Coq_raw_ident_fancy_sub ->
        f Coq3_Compilers.Coq_raw_ident_fancy_sub
      | Coq3_Compilers.Coq_raw_ident_fancy_subb ->
        f Coq3_Compilers.Coq_raw_ident_fancy_subb
      | Coq3_Compilers.Coq_raw_ident_fancy_mulll ->
        f Coq3_Compilers.Coq_raw_ident_fancy_mulll
      | Coq3_Compilers.Coq_raw_ident_fancy_mullh ->
        f Coq3_Compilers.Coq_raw_ident_fancy_mullh
      | Coq3_Compilers.Coq_raw_ident_fancy_mulhl ->
        f Coq3_Compilers.Coq_raw_ident_fancy_mulhl
      | Coq3_Compilers.Coq_raw_ident_fancy_mulhh ->
        f Coq3_Compilers.Coq_raw_ident_fancy_mulhh
      | Coq3_Compilers.Coq_raw_ident_fancy_rshi ->
        f Coq3_Compilers.Coq_raw_ident_fancy_rshi
      | Coq3_Compilers.Coq_raw_ident_fancy_selc ->
        f Coq3_Compilers.Coq_raw_ident_fancy_selc
      | Coq3_Compilers.Coq_raw_ident_fancy_selm ->
        f Coq3_Compilers.Coq_raw_ident_fancy_selm
      | Coq3_Compilers.Coq_raw_ident_fancy_sell ->
        f Coq3_Compilers.Coq_raw_ident_fancy_sell
      | Coq3_Compilers.Coq_raw_ident_fancy_addm ->
        f Coq3_Compilers.Coq_raw_ident_fancy_addm

      (** val raw_ident_infos_of :
          Coq3_Compilers.raw_ident -> (Coq3_Compilers.base,
          Coq3_Compilers.ident)
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.ident_infos **)

      let raw_ident_infos_of = function
      | Coq3_Compilers.Coq_raw_ident_Literal ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = (__ :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          __ :: []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type =
          (fun d _ -> Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base (fst (Obj.magic d))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun d _ a ->
          Coq3_Compilers.Coq_ident_Literal ((fst (Obj.magic d)),
          (fst (Obj.magic a)))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let (a, b) = Obj.magic x in
           (fun x0 ->
           let (b0, u) = Obj.magic x0 in
           if (match a with
               | Coq3_Compilers.Z ->
                 (fun x1 ->
                   match x1 with
                   | Coq3_Compilers.Z -> true
                   | Coq3_Compilers.Coq_bool -> false
                   | Coq3_Compilers.Coq_nat -> false
                   | Coq3_Compilers.Coq_zrange -> false
                   | Coq3_Compilers.Coq_string -> false)
               | Coq3_Compilers.Coq_bool ->
                 (fun x1 ->
                   match x1 with
                   | Coq3_Compilers.Z -> false
                   | Coq3_Compilers.Coq_bool -> true
                   | Coq3_Compilers.Coq_nat -> false
                   | Coq3_Compilers.Coq_zrange -> false
                   | Coq3_Compilers.Coq_string -> false)
               | Coq3_Compilers.Coq_nat ->
                 (fun x1 ->
                   match x1 with
                   | Coq3_Compilers.Z -> false
                   | Coq3_Compilers.Coq_bool -> false
                   | Coq3_Compilers.Coq_nat -> true
                   | Coq3_Compilers.Coq_zrange -> false
                   | Coq3_Compilers.Coq_string -> false)
               | Coq3_Compilers.Coq_zrange ->
                 (fun x1 ->
                   match x1 with
                   | Coq3_Compilers.Z -> false
                   | Coq3_Compilers.Coq_bool -> false
                   | Coq3_Compilers.Coq_nat -> false
                   | Coq3_Compilers.Coq_zrange -> true
                   | Coq3_Compilers.Coq_string -> false)
               | Coq3_Compilers.Coq_string ->
                 (fun x1 ->
                   match x1 with
                   | Coq3_Compilers.Z -> false
                   | Coq3_Compilers.Coq_bool -> false
                   | Coq3_Compilers.Coq_nat -> false
                   | Coq3_Compilers.Coq_zrange -> false
                   | Coq3_Compilers.Coq_string -> true)) b0
           then if (let () = b in (fun x1 -> let () = x1 in true)) u
                then true
                else false
           else false)) y);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun x x0 y ->
          prod_beq0
            (Coq3_Compilers.base_interp_beq (fst (Obj.magic x))
              (fst (Obj.magic x))) (fun _ _ -> true) (Obj.magic x0)
            (Obj.magic y));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun x x0 y ->
          reflect_eq_prod
            (Coq3_Compilers.base_interp_beq (fst (Obj.magic x))
              (fst (Obj.magic x))) (fun _ _ -> true)
            (Coq3_Compilers.reflect_base_interp_beq (fst (Obj.magic x)))
            reflect_eq_unit (Obj.magic x0) (Obj.magic y));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_comment ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_comment (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_comment_no_keep ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_comment_no_keep (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_value_barrier ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_value_barrier) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Nat_succ ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Nat_succ) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Nat_pred ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Nat_pred) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Nat_max ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Nat_max) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Nat_mul ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Nat_mul) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Nat_add ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Nat_add) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Nat_sub ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Nat_sub) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Nat_eqb ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Nat_eqb) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_nil ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_nil (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_cons ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_cons (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_tt ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_tt) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_pair ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((fst (Obj.magic i)), (fst (snd (Obj.magic i))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_pair ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_fst ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_fst ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_snd ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_snd ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_prod_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: [])));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (fst (snd (snd (Obj.magic i))))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((fst (Obj.magic i)), (fst (snd (Obj.magic i)))))),
          (Compilers.Coq_type.Coq_base (fst (snd (snd (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_prod_rect ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))), (fst (snd (snd (Obj.magic i)))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true))) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true)) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y)
              (reflect_eq_prod (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true) (fun x y ->
                Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                  Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit))) }
      | Coq3_Compilers.Coq_raw_ident_bool_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_bool_rect (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_bool_rect_nodep (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_nat_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (Obj.magic i))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_nat_rect (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_eager_nat_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (Obj.magic i))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_eager_nat_rect (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i))))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_nat_rect_arrow ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i))))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_eager_nat_rect_arrow ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_list_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_list_rect ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_eager_list_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_eager_list_rect ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_list_rect_arrow ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: [])));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (snd (Obj.magic i))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (snd (Obj.magic i))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (fst (snd (snd (Obj.magic i))))))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (fst (snd (snd (Obj.magic i)))))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_list_rect_arrow ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))), (fst (snd (snd (Obj.magic i)))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true))) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true)) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y)
              (reflect_eq_prod (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true) (fun x y ->
                Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                  Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit))) }
      | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: [])));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (snd (Obj.magic i))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (snd (Obj.magic i))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (fst (snd (snd (Obj.magic i))))))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (fst (snd (snd (Obj.magic i)))))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_eager_list_rect_arrow
          ((fst (Obj.magic i)), (fst (snd (Obj.magic i))),
          (fst (snd (snd (Obj.magic i)))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true))) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (prod_beq0 (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true)) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y)
              (reflect_eq_prod (fun x y ->
                Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq
                  x y) (fun _ _ -> true) (fun x y ->
                Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                  Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit))) }
      | Coq3_Compilers.Coq_raw_ident_list_case ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_list_case ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_List_length ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_length (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_seq ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_List_seq) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_firstn ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_firstn (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_skipn ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_skipn (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_repeat ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_repeat (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_combine ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (snd (Obj.magic i))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_prod ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i)))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_combine ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_List_map ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (snd (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_map ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_List_app ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_app (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_rev ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_rev (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_flat_map ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (snd (Obj.magic i))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (fst (snd (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_flat_map ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_List_partition ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))),
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_partition (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_filter ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_filter (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_fold_right ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (snd (Obj.magic i))))),
          (Compilers.Coq_type.Coq_base (fst (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_fold_right ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
              (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_List_update_nth ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list (fst (Obj.magic i))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_update_nth (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_List_nth_default ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_List_nth_default (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (fst (Obj.magic i)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_eager_List_nth_default
          (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_add ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_add) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_mul ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_mul) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_pow ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_pow) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_sub ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_sub) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_opp ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_opp) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_div ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_div) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_modulo ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_modulo) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_eqb ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_eqb) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_leb ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_leb) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_ltb ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_ltb) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_geb ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_geb) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_gtb ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_gtb) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_log2 ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_log2) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_log2_up ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_log2_up) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_of_nat ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_of_nat) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_to_nat ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_to_nat) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_shiftr ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_shiftr) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_shiftl ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_shiftl) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_land ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_land) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_lor ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_lor) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_min ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_min) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_max ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_max) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_mul_split ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_mul_split) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_mul_high ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_mul_high) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_add_get_carry) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_add_with_carry) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_add_with_get_carry) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_sub_get_borrow) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_ltz ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_ltz) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_zselect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_zselect) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_add_modulo ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_add_modulo) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_truncating_shiftl) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_bneg ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_bneg) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_lnot_modulo) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_lxor ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_lxor) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_rshi ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_rshi) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_cc_m ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_cc_m) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_cast ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_cast) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Z_cast2 ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Z_cast2) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_Some ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (fst (Obj.magic i))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option (fst (Obj.magic i))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_Some (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_None ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
          (fst (Obj.magic i))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_None (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_option_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (fst (Obj.magic i))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i)))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          (fst (snd (Obj.magic i)))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option (fst (Obj.magic i)))),
          (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic i))))))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_option_rect ((fst (Obj.magic i)),
          (fst (snd (Obj.magic i))))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x
                y) (fun _ _ -> true)));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (prod_beq0 (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x
                y) (fun _ _ -> true)) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y)
            (reflect_eq_prod (fun x y ->
              Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x
                y) (fun _ _ -> true) (fun x y ->
              Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
                Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit)) }
      | Coq3_Compilers.Coq_raw_ident_Build_zrange ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_Build_zrange) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_zrange_rect ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types =
          (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.BaseType :: []);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ i ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (fst (Obj.magic i))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
          (fst (Obj.magic i)))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ i _ ->
          Coq3_Compilers.Coq_ident_zrange_rect (fst (Obj.magic i))) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (Obj.magic prod_beq0 (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_prod (fun x y ->
            Compilers.Coq_base.Coq_type.type_beq Coq3_Compilers.base_beq x y)
            (fun _ _ -> true) (fun x y ->
            Compilers.Coq_base.reflect_type_beq Coq3_Compilers.base_beq
              Coq3_Compilers.reflect_base_beq x y) reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_add ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_add) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_addc ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_addc) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_sub ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_sub) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_subb ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_subb) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_mulll ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_mulll) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_mullh ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_mullh) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_mulhl ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_mulhl) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_mulhh ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_mulhh) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_rshi ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_rshi) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_selc ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_selc) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_selm ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_selm) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_sell ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_sell) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }
      | Coq3_Compilers.Coq_raw_ident_fancy_addm ->
        { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.preinfos =
          { Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types = [];
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args = (fun _ ->
          []); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_type = (fun _ _ ->
          Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))));
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_ident = (fun _ _ _ ->
          Coq3_Compilers.Coq_ident_fancy_addm) };
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.dep_types_dec_transparent =
          (fun x y ->
          (let () = Obj.magic x in (fun x0 -> let () = Obj.magic x0 in true))
            y); Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_beq =
          (fun _ _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_args_reflect =
          (fun _ -> Obj.magic reflect_eq_unit);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_beq =
          (fun _ _ -> true);
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.indep_types_reflect =
          (Obj.magic reflect_eq_unit) }

      (** val split_raw_ident_gen :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          (Coq3_Compilers.raw_ident, (Coq3_Compilers.base,
          Coq3_Compilers.ident)
          Coq0_Compilers.Coq_pattern.Raw.Coq_ident.ident_args)
          Coq_Primitive.sigT **)

      let split_raw_ident_gen _ = function
      | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Literal;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 =
          (Obj.magic (t0, ())); Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (y, ()))) } }
      | Coq3_Compilers.Coq_ident_comment t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_comment;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_comment_no_keep;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_value_barrier ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_value_barrier;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Nat_succ ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_succ;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Nat_pred ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_pred;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Nat_max ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_max;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Nat_mul ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_mul;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Nat_add ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_add;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Nat_sub ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_sub;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Nat_eqb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_eqb;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_nil t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_nil;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_cons t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_cons;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_tt ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_tt;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_pair;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fst;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_snd;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_prod_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, (t2, ())))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_bool_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_bool_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_bool_rect_nodep;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_nat_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_nat_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_eager_nat_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_nat_rect_arrow;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_list_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_list_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_list_rect_arrow;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, (t2, ())))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, (t2, ())))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_list_case;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_length t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_length;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_seq ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_seq;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_firstn t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_firstn;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_skipn t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_skipn;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_repeat t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_repeat;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_combine;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_map;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_app t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_app;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_rev t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_rev;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_flat_map;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_partition t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_partition;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_filter t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_filter;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_List_fold_right;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_List_update_nth;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_List_nth_default;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_List_nth_default;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_add ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_add;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_mul ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_mul;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_pow ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_pow;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_sub ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_sub;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_opp ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_opp;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_div ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_div;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_modulo ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_modulo;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_eqb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_eqb;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_leb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_leb;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_ltb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_ltb;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_geb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_geb;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_gtb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_gtb;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_log2 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_log2;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_log2_up ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_log2_up;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_of_nat ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_of_nat;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_to_nat ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_to_nat;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_shiftr ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_shiftr;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_shiftl ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_shiftl;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_land ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_land;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_lor ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_lor;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_min ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_min;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_max ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_max;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_mul_split ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_mul_split;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_mul_high ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_mul_high;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_add_get_carry;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_add_with_carry;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_ltz ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_ltz;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_zselect ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_zselect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_add_modulo;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_bneg ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_bneg;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_lxor ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_lxor;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_rshi ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_rshi;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_cc_m ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_cc_m;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_cast ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_cast;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Z_cast2 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_cast2;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Some t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Some;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_None t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_None;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_option_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, (t1, ()))),
          (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_Build_zrange ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Build_zrange;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_zrange_rect;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_add ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_add;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_addc ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_addc;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_sub ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_sub;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_subb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_subb;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_mulll ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mulll;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_mullh ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mullh;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mulhl;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mulhh;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_rshi ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_rshi;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_selc ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_selc;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_selm ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_selm;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_sell ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_sell;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }
      | Coq3_Compilers.Coq_ident_fancy_addm ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_addm;
          Coq_Primitive.projT2 = { Coq_Primitive.projT1 = (Obj.magic ());
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) } }

      (** val raw_invert_bind_args :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          Coq3_Compilers.raw_ident -> __ option **)

      let raw_invert_bind_args _ idc pidc =
        match idc with
        | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (t0, ());
                 Coq_Primitive.projT2 = ((), (y, ())) })
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_comment t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_value_barrier ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Nat_succ ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Nat_pred ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Nat_max ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Nat_mul ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Nat_add ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Nat_sub ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Nat_eqb ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_nil t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_cons t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_tt ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, (t2, ()))), ()) })
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_bool_rect t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_nat_rect t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, (t2, ()))), ()) })
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, (t2, ()))), ()) })
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_length t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_seq ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_firstn t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_skipn t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_repeat t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_app t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_rev t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_partition t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_filter t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_add ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_mul ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_pow ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_sub ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_opp ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_div ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_modulo ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_eqb ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_leb ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_ltb ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_geb ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_gtb ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_log2 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_log2_up ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_of_nat ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_to_nat ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_shiftr ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_shiftl ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_land ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_lor ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_min ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_max ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_mul_split ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_mul_high ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_ltz ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_zselect ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_add_modulo ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_bneg ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_lxor ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_rshi ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_cc_m ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_cast ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Z_cast2 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Some t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_None t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, (t1, ())), ()) })
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_Build_zrange ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((t0, ()), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_add ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_addc ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_sub ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_subb ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_mulll ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_mullh ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_mulhl ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_mulhh ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_rshi ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_selc ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_selm ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_sell ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) })
           | Coq3_Compilers.Coq_raw_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_ident_fancy_addm ->
          (match pidc with
           | Coq3_Compilers.Coq_raw_ident_Literal -> None
           | Coq3_Compilers.Coq_raw_ident_comment -> None
           | Coq3_Compilers.Coq_raw_ident_comment_no_keep -> None
           | Coq3_Compilers.Coq_raw_ident_value_barrier -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_max -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_add -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_nil -> None
           | Coq3_Compilers.Coq_raw_ident_cons -> None
           | Coq3_Compilers.Coq_raw_ident_tt -> None
           | Coq3_Compilers.Coq_raw_ident_pair -> None
           | Coq3_Compilers.Coq_raw_ident_fst -> None
           | Coq3_Compilers.Coq_raw_ident_snd -> None
           | Coq3_Compilers.Coq_raw_ident_prod_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect -> None
           | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect -> None
           | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect -> None
           | Coq3_Compilers.Coq_raw_ident_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow -> None
           | Coq3_Compilers.Coq_raw_ident_list_case -> None
           | Coq3_Compilers.Coq_raw_ident_List_length -> None
           | Coq3_Compilers.Coq_raw_ident_List_seq -> None
           | Coq3_Compilers.Coq_raw_ident_List_firstn -> None
           | Coq3_Compilers.Coq_raw_ident_List_skipn -> None
           | Coq3_Compilers.Coq_raw_ident_List_repeat -> None
           | Coq3_Compilers.Coq_raw_ident_List_combine -> None
           | Coq3_Compilers.Coq_raw_ident_List_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_app -> None
           | Coq3_Compilers.Coq_raw_ident_List_rev -> None
           | Coq3_Compilers.Coq_raw_ident_List_flat_map -> None
           | Coq3_Compilers.Coq_raw_ident_List_partition -> None
           | Coq3_Compilers.Coq_raw_ident_List_filter -> None
           | Coq3_Compilers.Coq_raw_ident_List_fold_right -> None
           | Coq3_Compilers.Coq_raw_ident_List_update_nth -> None
           | Coq3_Compilers.Coq_raw_ident_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul -> None
           | Coq3_Compilers.Coq_raw_ident_Z_pow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub -> None
           | Coq3_Compilers.Coq_raw_ident_Z_opp -> None
           | Coq3_Compilers.Coq_raw_ident_Z_div -> None
           | Coq3_Compilers.Coq_raw_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_leb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_geb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_raw_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_raw_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_raw_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_land -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_min -> None
           | Coq3_Compilers.Coq_raw_ident_Z_max -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_raw_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_raw_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_raw_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_raw_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_raw_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_raw_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_raw_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast -> None
           | Coq3_Compilers.Coq_raw_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_raw_ident_Some -> None
           | Coq3_Compilers.Coq_raw_ident_None -> None
           | Coq3_Compilers.Coq_raw_ident_option_rect -> None
           | Coq3_Compilers.Coq_raw_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_raw_ident_zrange_rect -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_add -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_raw_ident_fancy_addm ->
             Some
               (Obj.magic { Coq_Primitive.projT1 = (); Coq_Primitive.projT2 =
                 ((), ()) }))

      (** val invert_bind_args_unknown :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          Coq3_Compilers.raw_ident -> __ option **)

      let invert_bind_args_unknown =
        raw_invert_bind_args

      (** val all_pattern_idents : (__, __) Coq_Primitive.sigT list **)

      let all_pattern_idents =
        { Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_Literal x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_comment x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_pattern_ident_comment_no_keep x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_value_barrier) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Nat_succ) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Nat_pred) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Nat_max) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Nat_mul) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Nat_add) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Nat_sub) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Nat_eqb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_nil x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_cons x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_tt) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_pattern_ident_pair (x,
            x0))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_pattern_ident_fst (x,
            x0))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_pattern_ident_snd (x,
            x0))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 x1 ->
            Coq3_Compilers.Coq_pattern_ident_prod_rect (x, x0, x1))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_bool_rect x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_nat_rect x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_pattern_ident_eager_nat_rect x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_pattern_ident_list_rect
            (x, x0))) } :: ({ Coq_Primitive.projT1 = __;
          Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_pattern_ident_eager_list_rect (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 x1 ->
            Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (x, x0, x1))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 x1 ->
            Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (x, x0,
            x1))) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_pattern_ident_list_case
            (x, x0))) } :: ({ Coq_Primitive.projT1 = __;
          Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_List_length
            x)) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_List_seq) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_List_firstn
            x)) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_List_skipn x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_List_repeat
            x)) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_pattern_ident_List_combine (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 -> Coq3_Compilers.Coq_pattern_ident_List_map
            (x, x0))) } :: ({ Coq_Primitive.projT1 = __;
          Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_List_app x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_List_rev x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_pattern_ident_List_flat_map (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_pattern_ident_List_partition x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_List_filter
            x)) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_pattern_ident_List_fold_right (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_pattern_ident_List_update_nth x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_pattern_ident_List_nth_default x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x ->
            Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_add) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_mul) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_pow) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_sub) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_opp) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_div) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_modulo) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_eqb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_leb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_ltb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_geb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_gtb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_log2) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_log2_up) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_of_nat) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_to_nat) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_shiftr) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_shiftl) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_land) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_lor) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_min) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_max) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_mul_split) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_mul_high) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_ltz) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_zselect) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_add_modulo) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_bneg) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_lxor) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_rshi) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_cc_m) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_cast) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Z_cast2) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_Some x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_None x)) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x x0 ->
            Coq3_Compilers.Coq_pattern_ident_option_rect (x, x0))) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_Build_zrange) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic (fun x -> Coq3_Compilers.Coq_pattern_ident_zrange_rect
            x)) } :: ({ Coq_Primitive.projT1 = __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_add) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_addc) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_sub) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_subb) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_mulll) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_mullh) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_mulhl) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_mulhh) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_rshi) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_selc) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_selm) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_sell) } :: ({ Coq_Primitive.projT1 =
          __; Coq_Primitive.projT2 =
          (Obj.magic Coq3_Compilers.Coq_pattern_ident_fancy_addm) } :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

      (** val eta_ident_cps_gen1 :
          (Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1)
          -> (Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1) **)

      let eta_ident_cps_gen1 f _ = function
      | Coq3_Compilers.Coq_pattern_ident_Literal t0 ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base t0))
          (Coq3_Compilers.Coq_pattern_ident_Literal t0)
      | Coq3_Compilers.Coq_pattern_ident_comment t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_pattern_ident_comment t0)
      | Coq3_Compilers.Coq_pattern_ident_comment_no_keep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_pattern_ident_comment_no_keep t0)
      | Coq3_Compilers.Coq_pattern_ident_value_barrier ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_value_barrier
      | Coq3_Compilers.Coq_pattern_ident_Nat_succ ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_pattern_ident_Nat_succ
      | Coq3_Compilers.Coq_pattern_ident_Nat_pred ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_pattern_ident_Nat_pred
      | Coq3_Compilers.Coq_pattern_ident_Nat_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_max
      | Coq3_Compilers.Coq_pattern_ident_Nat_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_mul
      | Coq3_Compilers.Coq_pattern_ident_Nat_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_add
      | Coq3_Compilers.Coq_pattern_ident_Nat_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_sub
      | Coq3_Compilers.Coq_pattern_ident_Nat_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_eqb
      | Coq3_Compilers.Coq_pattern_ident_nil t0 ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))
          (Coq3_Compilers.Coq_pattern_ident_nil t0)
      | Coq3_Compilers.Coq_pattern_ident_cons t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_cons t0)
      | Coq3_Compilers.Coq_pattern_ident_tt ->
        f (Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)
          Coq3_Compilers.Coq_pattern_ident_tt
      | Coq3_Compilers.Coq_pattern_ident_pair (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_pair (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_fst (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t0)))
          (Coq3_Compilers.Coq_pattern_ident_fst (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_snd (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t1)))
          (Coq3_Compilers.Coq_pattern_ident_snd (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_prod_rect (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t2)))))
          (Coq3_Compilers.Coq_pattern_ident_prod_rect (t0, t1, t2))
      | Coq3_Compilers.Coq_pattern_ident_bool_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_bool_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep t0)
      | Coq3_Compilers.Coq_pattern_ident_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_nat_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_nat_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (t0,
          t1))
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow
          (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_list_rect (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_list_rect (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (t0, t1, t2))
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (t0, t1,
          t2))
      | Coq3_Compilers.Coq_pattern_ident_list_case (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_list_case (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_length t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))
          (Coq3_Compilers.Coq_pattern_ident_List_length t0)
      | Coq3_Compilers.Coq_pattern_ident_List_seq ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))))
          Coq3_Compilers.Coq_pattern_ident_List_seq
      | Coq3_Compilers.Coq_pattern_ident_List_firstn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_firstn t0)
      | Coq3_Compilers.Coq_pattern_ident_List_skipn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_skipn t0)
      | Coq3_Compilers.Coq_pattern_ident_List_repeat t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_repeat t0)
      | Coq3_Compilers.Coq_pattern_ident_List_combine (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
          (Coq3_Compilers.Coq_pattern_ident_List_combine (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1))))))
          (Coq3_Compilers.Coq_pattern_ident_List_map (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_app t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_app t0)
      | Coq3_Compilers.Coq_pattern_ident_List_rev t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))
          (Coq3_Compilers.Coq_pattern_ident_List_rev t0)
      | Coq3_Compilers.Coq_pattern_ident_List_flat_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1))))))
          (Coq3_Compilers.Coq_pattern_ident_List_flat_map (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_partition t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_pattern_ident_List_partition t0)
      | Coq3_Compilers.Coq_pattern_ident_List_filter t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_filter t0)
      | Coq3_Compilers.Coq_pattern_ident_List_fold_right (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_List_fold_right (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_update_nth t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_pattern_ident_List_update_nth t0)
      | Coq3_Compilers.Coq_pattern_ident_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_List_nth_default t0)
      | Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default t0)
      | Coq3_Compilers.Coq_pattern_ident_Z_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_add
      | Coq3_Compilers.Coq_pattern_ident_Z_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_mul
      | Coq3_Compilers.Coq_pattern_ident_Z_pow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_pow
      | Coq3_Compilers.Coq_pattern_ident_Z_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_sub
      | Coq3_Compilers.Coq_pattern_ident_Z_opp ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_opp
      | Coq3_Compilers.Coq_pattern_ident_Z_div ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_div
      | Coq3_Compilers.Coq_pattern_ident_Z_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_modulo
      | Coq3_Compilers.Coq_pattern_ident_Z_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_eqb
      | Coq3_Compilers.Coq_pattern_ident_Z_leb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_leb
      | Coq3_Compilers.Coq_pattern_ident_Z_ltb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_ltb
      | Coq3_Compilers.Coq_pattern_ident_Z_geb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_geb
      | Coq3_Compilers.Coq_pattern_ident_Z_gtb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_gtb
      | Coq3_Compilers.Coq_pattern_ident_Z_log2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_log2
      | Coq3_Compilers.Coq_pattern_ident_Z_log2_up ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_log2_up
      | Coq3_Compilers.Coq_pattern_ident_Z_of_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_of_nat
      | Coq3_Compilers.Coq_pattern_ident_Z_to_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_pattern_ident_Z_to_nat
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftr ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_shiftr
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_shiftl
      | Coq3_Compilers.Coq_pattern_ident_Z_land ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_land
      | Coq3_Compilers.Coq_pattern_ident_Z_lor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_lor
      | Coq3_Compilers.Coq_pattern_ident_Z_min ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_min
      | Coq3_Compilers.Coq_pattern_ident_Z_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_max
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_split ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_mul_split
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_high ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_pattern_ident_Z_mul_high
      | Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow
      | Coq3_Compilers.Coq_pattern_ident_Z_ltz ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_ltz
      | Coq3_Compilers.Coq_pattern_ident_Z_zselect ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_pattern_ident_Z_zselect
      | Coq3_Compilers.Coq_pattern_ident_Z_add_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_modulo
      | Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl
      | Coq3_Compilers.Coq_pattern_ident_Z_bneg ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_bneg
      | Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo
      | Coq3_Compilers.Coq_pattern_ident_Z_lxor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_lxor
      | Coq3_Compilers.Coq_pattern_ident_Z_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_pattern_ident_Z_rshi
      | Coq3_Compilers.Coq_pattern_ident_Z_cc_m ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_cc_m
      | Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth
      | Coq3_Compilers.Coq_pattern_ident_Z_cast ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_cast
      | Coq3_Compilers.Coq_pattern_ident_Z_cast2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_pattern_ident_Z_cast2
      | Coq3_Compilers.Coq_pattern_ident_Some t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option t0))))
          (Coq3_Compilers.Coq_pattern_ident_Some t0)
      | Coq3_Compilers.Coq_pattern_ident_None t0 ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option t0))
          (Coq3_Compilers.Coq_pattern_ident_None t0)
      | Coq3_Compilers.Coq_pattern_ident_option_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_option_rect (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_Build_zrange ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange))))))
          Coq3_Compilers.Coq_pattern_ident_Build_zrange
      | Coq3_Compilers.Coq_pattern_ident_zrange_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0)))))
          (Coq3_Compilers.Coq_pattern_ident_zrange_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_fancy_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_add
      | Coq3_Compilers.Coq_pattern_ident_fancy_addc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_addc
      | Coq3_Compilers.Coq_pattern_ident_fancy_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_sub
      | Coq3_Compilers.Coq_pattern_ident_fancy_subb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_subb
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulll ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mulll
      | Coq3_Compilers.Coq_pattern_ident_fancy_mullh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mullh
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mulhl
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mulhh
      | Coq3_Compilers.Coq_pattern_ident_fancy_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_rshi
      | Coq3_Compilers.Coq_pattern_ident_fancy_selc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_selc
      | Coq3_Compilers.Coq_pattern_ident_fancy_selm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_selm
      | Coq3_Compilers.Coq_pattern_ident_fancy_sell ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_sell
      | Coq3_Compilers.Coq_pattern_ident_fancy_addm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_addm

      (** val eta_ident_cps_gen_expand_literal0 :
          (Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1)
          -> (Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> 'a1) **)

      let eta_ident_cps_gen_expand_literal0 f _ = function
      | Coq3_Compilers.Coq_pattern_ident_Literal t0 ->
        (match t0 with
         | Coq3_Compilers.Z ->
           f (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)) (Coq3_Compilers.Coq_pattern_ident_Literal
             Coq3_Compilers.Z)
         | Coq3_Compilers.Coq_bool ->
           f (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool))
             (Coq3_Compilers.Coq_pattern_ident_Literal
             Coq3_Compilers.Coq_bool)
         | Coq3_Compilers.Coq_nat ->
           f (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat))
             (Coq3_Compilers.Coq_pattern_ident_Literal Coq3_Compilers.Coq_nat)
         | Coq3_Compilers.Coq_zrange ->
           f (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange))
             (Coq3_Compilers.Coq_pattern_ident_Literal
             Coq3_Compilers.Coq_zrange)
         | Coq3_Compilers.Coq_string ->
           f (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_string))
             (Coq3_Compilers.Coq_pattern_ident_Literal
             Coq3_Compilers.Coq_string))
      | Coq3_Compilers.Coq_pattern_ident_comment t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_pattern_ident_comment t0)
      | Coq3_Compilers.Coq_pattern_ident_comment_no_keep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)))
          (Coq3_Compilers.Coq_pattern_ident_comment_no_keep t0)
      | Coq3_Compilers.Coq_pattern_ident_value_barrier ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_value_barrier
      | Coq3_Compilers.Coq_pattern_ident_Nat_succ ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_pattern_ident_Nat_succ
      | Coq3_Compilers.Coq_pattern_ident_Nat_pred ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_pattern_ident_Nat_pred
      | Coq3_Compilers.Coq_pattern_ident_Nat_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_max
      | Coq3_Compilers.Coq_pattern_ident_Nat_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_mul
      | Coq3_Compilers.Coq_pattern_ident_Nat_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_add
      | Coq3_Compilers.Coq_pattern_ident_Nat_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_sub
      | Coq3_Compilers.Coq_pattern_ident_Nat_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))))))
          Coq3_Compilers.Coq_pattern_ident_Nat_eqb
      | Coq3_Compilers.Coq_pattern_ident_nil t0 ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))
          (Coq3_Compilers.Coq_pattern_ident_nil t0)
      | Coq3_Compilers.Coq_pattern_ident_cons t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_cons t0)
      | Coq3_Compilers.Coq_pattern_ident_tt ->
        f (Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)
          Coq3_Compilers.Coq_pattern_ident_tt
      | Coq3_Compilers.Coq_pattern_ident_pair (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_pair (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_fst (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t0)))
          (Coq3_Compilers.Coq_pattern_ident_fst (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_snd (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t1)))
          (Coq3_Compilers.Coq_pattern_ident_snd (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_prod_rect (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))),
          (Compilers.Coq_type.Coq_base t2)))))
          (Coq3_Compilers.Coq_pattern_ident_prod_rect (t0, t1, t2))
      | Coq3_Compilers.Coq_pattern_ident_bool_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_bool_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep t0)
      | Coq3_Compilers.Coq_pattern_ident_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_nat_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_nat_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (t0,
          t1))
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))) (Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow
          (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_list_rect (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_list_rect (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (t0, t1, t2))
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (t0, t1, t2) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2)))))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (t0, t1,
          t2))
      | Coq3_Compilers.Coq_pattern_ident_list_case (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_list_case (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_length t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))
          (Coq3_Compilers.Coq_pattern_ident_List_length t0)
      | Coq3_Compilers.Coq_pattern_ident_List_seq ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))))
          Coq3_Compilers.Coq_pattern_ident_List_seq
      | Coq3_Compilers.Coq_pattern_ident_List_firstn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_firstn t0)
      | Coq3_Compilers.Coq_pattern_ident_List_skipn t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_skipn t0)
      | Coq3_Compilers.Coq_pattern_ident_List_repeat t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_repeat t0)
      | Coq3_Compilers.Coq_pattern_ident_List_combine (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
          (Coq3_Compilers.Coq_pattern_ident_List_combine (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1))))))
          (Coq3_Compilers.Coq_pattern_ident_List_map (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_app t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_app t0)
      | Coq3_Compilers.Coq_pattern_ident_List_rev t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))
          (Coq3_Compilers.Coq_pattern_ident_List_rev t0)
      | Coq3_Compilers.Coq_pattern_ident_List_flat_map (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1))))))
          (Coq3_Compilers.Coq_pattern_ident_List_flat_map (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_partition t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_pattern_ident_List_partition t0)
      | Coq3_Compilers.Coq_pattern_ident_List_filter t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))
          (Coq3_Compilers.Coq_pattern_ident_List_filter t0)
      | Coq3_Compilers.Coq_pattern_ident_List_fold_right (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_List_fold_right (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_List_update_nth t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0))))))))
          (Coq3_Compilers.Coq_pattern_ident_List_update_nth t0)
      | Coq3_Compilers.Coq_pattern_ident_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_List_nth_default t0)
      | Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
          (Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default t0)
      | Coq3_Compilers.Coq_pattern_ident_Z_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_add
      | Coq3_Compilers.Coq_pattern_ident_Z_mul ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_mul
      | Coq3_Compilers.Coq_pattern_ident_Z_pow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_pow
      | Coq3_Compilers.Coq_pattern_ident_Z_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_sub
      | Coq3_Compilers.Coq_pattern_ident_Z_opp ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_opp
      | Coq3_Compilers.Coq_pattern_ident_Z_div ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_div
      | Coq3_Compilers.Coq_pattern_ident_Z_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_modulo
      | Coq3_Compilers.Coq_pattern_ident_Z_eqb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_eqb
      | Coq3_Compilers.Coq_pattern_ident_Z_leb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_leb
      | Coq3_Compilers.Coq_pattern_ident_Z_ltb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_ltb
      | Coq3_Compilers.Coq_pattern_ident_Z_geb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_geb
      | Coq3_Compilers.Coq_pattern_ident_Z_gtb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_pattern_ident_Z_gtb
      | Coq3_Compilers.Coq_pattern_ident_Z_log2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_log2
      | Coq3_Compilers.Coq_pattern_ident_Z_log2_up ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_log2_up
      | Coq3_Compilers.Coq_pattern_ident_Z_of_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_of_nat
      | Coq3_Compilers.Coq_pattern_ident_Z_to_nat ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_pattern_ident_Z_to_nat
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftr ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_shiftr
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_shiftl
      | Coq3_Compilers.Coq_pattern_ident_Z_land ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_land
      | Coq3_Compilers.Coq_pattern_ident_Z_lor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_lor
      | Coq3_Compilers.Coq_pattern_ident_Z_min ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_min
      | Coq3_Compilers.Coq_pattern_ident_Z_max ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_max
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_split ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_mul_split
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_high ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_pattern_ident_Z_mul_high
      | Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow
      | Coq3_Compilers.Coq_pattern_ident_Z_ltz ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_ltz
      | Coq3_Compilers.Coq_pattern_ident_Z_zselect ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_pattern_ident_Z_zselect
      | Coq3_Compilers.Coq_pattern_ident_Z_add_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_add_modulo
      | Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl
      | Coq3_Compilers.Coq_pattern_ident_Z_bneg ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_Z_bneg
      | Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))
          Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo
      | Coq3_Compilers.Coq_pattern_ident_Z_lxor ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_lxor
      | Coq3_Compilers.Coq_pattern_ident_Z_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_pattern_ident_Z_rshi
      | Coq3_Compilers.Coq_pattern_ident_Z_cc_m ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_cc_m
      | Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))
          Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth
      | Coq3_Compilers.Coq_pattern_ident_Z_cast ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_Z_cast
      | Coq3_Compilers.Coq_pattern_ident_Z_cast2 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_pattern_ident_Z_cast2
      | Coq3_Compilers.Coq_pattern_ident_Some t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option t0))))
          (Coq3_Compilers.Coq_pattern_ident_Some t0)
      | Coq3_Compilers.Coq_pattern_ident_None t0 ->
        f (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option t0))
          (Coq3_Compilers.Coq_pattern_ident_None t0)
      | Coq3_Compilers.Coq_pattern_ident_option_rect (t0, t1) ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option t0)),
          (Compilers.Coq_type.Coq_base t1)))))))
          (Coq3_Compilers.Coq_pattern_ident_option_rect (t0, t1))
      | Coq3_Compilers.Coq_pattern_ident_Build_zrange ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange))))))
          Coq3_Compilers.Coq_pattern_ident_Build_zrange
      | Coq3_Compilers.Coq_pattern_ident_zrange_rect t0 ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0)))))
          (Coq3_Compilers.Coq_pattern_ident_zrange_rect t0)
      | Coq3_Compilers.Coq_pattern_ident_fancy_add ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_add
      | Coq3_Compilers.Coq_pattern_ident_fancy_addc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_addc
      | Coq3_Compilers.Coq_pattern_ident_fancy_sub ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_sub
      | Coq3_Compilers.Coq_pattern_ident_fancy_subb ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))) Coq3_Compilers.Coq_pattern_ident_fancy_subb
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulll ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mulll
      | Coq3_Compilers.Coq_pattern_ident_fancy_mullh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mullh
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhl ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mulhl
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhh ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_mulhh
      | Coq3_Compilers.Coq_pattern_ident_fancy_rshi ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_rshi
      | Coq3_Compilers.Coq_pattern_ident_fancy_selc ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_selc
      | Coq3_Compilers.Coq_pattern_ident_fancy_selm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_selm
      | Coq3_Compilers.Coq_pattern_ident_fancy_sell ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_sell
      | Coq3_Compilers.Coq_pattern_ident_fancy_addm ->
        f (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))),
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))) Coq3_Compilers.Coq_pattern_ident_fancy_addm

      (** val split_types :
          Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident ->
          (Coq3_Compilers.raw_ident, __ * __) Coq_Primitive.sigT **)

      let split_types _ = function
      | Coq3_Compilers.Coq_pattern_ident_Literal t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Literal;
          Coq_Primitive.projT2 = ((Obj.magic (t0, ())), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_comment t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_comment;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_comment_no_keep t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_comment_no_keep;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_value_barrier ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_value_barrier;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Nat_succ ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_succ;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Nat_pred ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_pred;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Nat_max ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_max;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Nat_mul ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_mul;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Nat_add ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_add;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Nat_sub ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_sub;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Nat_eqb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Nat_eqb;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_nil t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_nil;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_cons t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_cons;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_tt ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_tt;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_pair (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_pair;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_fst (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fst;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_snd (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_snd;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_prod_rect (t0, t1, t2) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_prod_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, (t2, ()))))) }
      | Coq3_Compilers.Coq_pattern_ident_bool_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_bool_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_bool_rect_nodep;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_nat_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_nat_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_eager_nat_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_nat_rect_arrow;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (t0, t1) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_list_rect (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_list_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect (t0, t1) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_list_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (t0, t1, t2) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_list_rect_arrow;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, (t2, ()))))) }
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (t0, t1, t2) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, (t2, ()))))) }
      | Coq3_Compilers.Coq_pattern_ident_list_case (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_list_case;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_List_length t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_length;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_seq ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_seq;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_List_firstn t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_firstn;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_skipn t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_skipn;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_repeat t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_repeat;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_combine (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_combine;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_List_map (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_map;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_List_app t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_app;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_rev t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_rev;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_flat_map (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_flat_map;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_List_partition t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_partition;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_filter t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_List_filter;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_fold_right (t0, t1) ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_List_fold_right;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_List_update_nth t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_List_update_nth;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_List_nth_default t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_List_nth_default;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default t0 ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_eager_List_nth_default;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_Z_add ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_add;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_mul ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_mul;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_pow ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_pow;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_sub ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_sub;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_opp ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_opp;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_div ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_div;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_modulo ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_modulo;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_eqb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_eqb;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_leb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_leb;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_ltb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_ltb;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_geb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_geb;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_gtb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_gtb;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_log2 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_log2;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_log2_up ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_log2_up;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_of_nat ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_of_nat;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_to_nat ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_to_nat;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftr ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_shiftr;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftl ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_shiftl;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_land ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_land;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_lor ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_lor;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_min ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_min;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_max ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_max;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_split ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_mul_split;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_high ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_mul_high;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_add_get_carry;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_add_with_carry;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_ltz ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_ltz;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_zselect ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_zselect;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_add_modulo ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_add_modulo;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_bneg ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_bneg;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_lxor ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_lxor;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_rshi ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_rshi;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_cc_m ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_cc_m;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth ->
        { Coq_Primitive.projT1 =
          Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_cast ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_cast;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Z_cast2 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Z_cast2;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_Some t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Some;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_None t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_None;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_option_rect (t0, t1) ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_option_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()),
          (Obj.magic (t0, (t1, ())))) }
      | Coq3_Compilers.Coq_pattern_ident_Build_zrange ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_Build_zrange;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_zrange_rect t0 ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_zrange_rect;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic (t0, ()))) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_add ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_add;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_addc ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_addc;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_sub ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_sub;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_subb ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_subb;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulll ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mulll;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_mullh ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mullh;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhl ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mulhl;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhh ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_mulhh;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_rshi ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_rshi;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_selc ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_selc;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_selm ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_selm;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_sell ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_sell;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }
      | Coq3_Compilers.Coq_pattern_ident_fancy_addm ->
        { Coq_Primitive.projT1 = Coq3_Compilers.Coq_raw_ident_fancy_addm;
          Coq_Primitive.projT2 = ((Obj.magic ()), (Obj.magic ())) }

      (** val add_types_from_raw_sig :
          Coq3_Compilers.raw_ident -> __ -> __ -> (Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type, Coq3_Compilers.pattern_ident)
          Coq_Primitive.sigT **)

      let add_types_from_raw_sig ridc dt idt =
        (match ridc with
         | Coq3_Compilers.Coq_raw_ident_Literal ->
           (fun dt0 _ -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             (fst (Obj.magic dt0)))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_Literal
             (fst (Obj.magic dt0))) })
         | Coq3_Compilers.Coq_raw_ident_comment ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)));
             Coq_Primitive.projT2 = (Coq3_Compilers.Coq_pattern_ident_comment
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_comment_no_keep ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit)));
             Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_comment_no_keep
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_value_barrier ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_value_barrier })
         | Coq3_Compilers.Coq_raw_ident_Nat_succ ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Nat_succ })
         | Coq3_Compilers.Coq_raw_ident_Nat_pred ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Nat_pred })
         | Coq3_Compilers.Coq_raw_ident_Nat_max ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Nat_max })
         | Coq3_Compilers.Coq_raw_ident_Nat_mul ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Nat_mul })
         | Coq3_Compilers.Coq_raw_ident_Nat_add ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Nat_add })
         | Coq3_Compilers.Coq_raw_ident_Nat_sub ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Nat_sub })
         | Coq3_Compilers.Coq_raw_ident_Nat_eqb ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Nat_eqb })
         | Coq3_Compilers.Coq_raw_ident_nil ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_nil (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_cons ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_cons (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_tt ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit);
             Coq_Primitive.projT2 = Coq3_Compilers.Coq_pattern_ident_tt })
         | Coq3_Compilers.Coq_raw_ident_pair ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))))))));
             Coq_Primitive.projT2 = (Coq3_Compilers.Coq_pattern_ident_pair
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_fst ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_base (fst (Obj.magic idt0)))));
             Coq_Primitive.projT2 = (Coq3_Compilers.Coq_pattern_ident_fst
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_snd ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0))))));
             Coq_Primitive.projT2 = (Coq3_Compilers.Coq_pattern_ident_snd
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_prod_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_prod_rect
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))),
             (fst (snd (snd (Obj.magic idt0)))))) })
         | Coq3_Compilers.Coq_raw_ident_bool_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_bool_rect
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_bool_rect_nodep ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_nat_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_nat_rect
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_eager_nat_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_eager_nat_rect
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_nat_rect_arrow ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_eager_nat_rect_arrow ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_list_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_list_rect
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_eager_list_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_eager_list_rect
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_list_rect_arrow ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0)))))))))))));
             Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_list_rect_arrow
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))),
             (fst (snd (snd (Obj.magic idt0)))))) })
         | Coq3_Compilers.Coq_raw_ident_eager_list_rect_arrow ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0))))))))))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_base
             (fst (snd (snd (Obj.magic idt0)))))))))))));
             Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))),
             (fst (snd (snd (Obj.magic idt0)))))) })
         | Coq3_Compilers.Coq_raw_ident_list_case ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_list_case
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_List_length ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_length
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_seq ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_List_seq })
         | Coq3_Compilers.Coq_raw_ident_List_firstn ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_firstn
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_skipn ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_skipn
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_repeat ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_repeat
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_combine ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (snd (Obj.magic idt0))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0)))))))))));
             Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_combine
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_List_map ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (snd (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_map
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_List_app ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_app
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_rev ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_rev
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_flat_map ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (snd (Obj.magic idt0))))))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (snd (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_flat_map
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_List_partition ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_partition
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_filter ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_filter
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_fold_right ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (snd (Obj.magic idt0))))), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_fold_right
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_List_update_nth ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_update_nth
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_List_nth_default ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_List_nth_default
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_eager_List_nth_default ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_Z_add ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_add })
         | Coq3_Compilers.Coq_raw_ident_Z_mul ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_mul })
         | Coq3_Compilers.Coq_raw_ident_Z_pow ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_pow })
         | Coq3_Compilers.Coq_raw_ident_Z_sub ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_sub })
         | Coq3_Compilers.Coq_raw_ident_Z_opp ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_opp })
         | Coq3_Compilers.Coq_raw_ident_Z_div ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_div })
         | Coq3_Compilers.Coq_raw_ident_Z_modulo ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_modulo })
         | Coq3_Compilers.Coq_raw_ident_Z_eqb ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_eqb })
         | Coq3_Compilers.Coq_raw_ident_Z_leb ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_leb })
         | Coq3_Compilers.Coq_raw_ident_Z_ltb ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_ltb })
         | Coq3_Compilers.Coq_raw_ident_Z_geb ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_geb })
         | Coq3_Compilers.Coq_raw_ident_Z_gtb ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_gtb })
         | Coq3_Compilers.Coq_raw_ident_Z_log2 ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_log2 })
         | Coq3_Compilers.Coq_raw_ident_Z_log2_up ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_log2_up })
         | Coq3_Compilers.Coq_raw_ident_Z_of_nat ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_of_nat })
         | Coq3_Compilers.Coq_raw_ident_Z_to_nat ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_to_nat })
         | Coq3_Compilers.Coq_raw_ident_Z_shiftr ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_shiftr })
         | Coq3_Compilers.Coq_raw_ident_Z_shiftl ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_shiftl })
         | Coq3_Compilers.Coq_raw_ident_Z_land ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_land })
         | Coq3_Compilers.Coq_raw_ident_Z_lor ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_lor })
         | Coq3_Compilers.Coq_raw_ident_Z_min ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_min })
         | Coq3_Compilers.Coq_raw_ident_Z_max ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_max })
         | Coq3_Compilers.Coq_raw_ident_Z_mul_split ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_mul_split })
         | Coq3_Compilers.Coq_raw_ident_Z_mul_high ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_mul_high })
         | Coq3_Compilers.Coq_raw_ident_Z_add_get_carry ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry })
         | Coq3_Compilers.Coq_raw_ident_Z_add_with_carry ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry })
         | Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry })
         | Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow })
         | Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow })
         | Coq3_Compilers.Coq_raw_ident_Z_ltz ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_ltz })
         | Coq3_Compilers.Coq_raw_ident_Z_zselect ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_zselect })
         | Coq3_Compilers.Coq_raw_ident_Z_add_modulo ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_add_modulo })
         | Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl })
         | Coq3_Compilers.Coq_raw_ident_Z_bneg ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_bneg })
         | Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo })
         | Coq3_Compilers.Coq_raw_ident_Z_lxor ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_lxor })
         | Coq3_Compilers.Coq_raw_ident_Z_rshi ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_rshi })
         | Coq3_Compilers.Coq_raw_ident_Z_cc_m ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_cc_m })
         | Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth })
         | Coq3_Compilers.Coq_raw_ident_Z_cast ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_cast })
         | Coq3_Compilers.Coq_raw_ident_Z_cast2 ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Z_cast2 })
         | Coq3_Compilers.Coq_raw_ident_Some ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option
             (fst (Obj.magic idt0)))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_Some (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_None ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option
             (fst (Obj.magic idt0)))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_None (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_option_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base (fst (Obj.magic idt0))),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
             (Compilers.Coq_type.Coq_base (fst (snd (Obj.magic idt0)))))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_option
             (fst (Obj.magic idt0)))), (Compilers.Coq_type.Coq_base
             (fst (snd (Obj.magic idt0)))))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_option_rect
             ((fst (Obj.magic idt0)), (fst (snd (Obj.magic idt0))))) })
         | Coq3_Compilers.Coq_raw_ident_Build_zrange ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_Build_zrange })
         | Coq3_Compilers.Coq_raw_ident_zrange_rect ->
           (fun _ idt0 -> { Coq_Primitive.projT1 =
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
             (fst (Obj.magic idt0))))))); Coq_Primitive.projT2 =
             (Coq3_Compilers.Coq_pattern_ident_zrange_rect
             (fst (Obj.magic idt0))) })
         | Coq3_Compilers.Coq_raw_ident_fancy_add ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_add })
         | Coq3_Compilers.Coq_raw_ident_fancy_addc ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_addc })
         | Coq3_Compilers.Coq_raw_ident_fancy_sub ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_sub })
         | Coq3_Compilers.Coq_raw_ident_fancy_subb ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_subb })
         | Coq3_Compilers.Coq_raw_ident_fancy_mulll ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_mulll })
         | Coq3_Compilers.Coq_raw_ident_fancy_mullh ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_mullh })
         | Coq3_Compilers.Coq_raw_ident_fancy_mulhl ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_mulhl })
         | Coq3_Compilers.Coq_raw_ident_fancy_mulhh ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_mulhh })
         | Coq3_Compilers.Coq_raw_ident_fancy_rshi ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_rshi })
         | Coq3_Compilers.Coq_raw_ident_fancy_selc ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_selc })
         | Coq3_Compilers.Coq_raw_ident_fancy_selm ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_selm })
         | Coq3_Compilers.Coq_raw_ident_fancy_sell ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_sell })
         | Coq3_Compilers.Coq_raw_ident_fancy_addm ->
           (fun _ _ -> { Coq_Primitive.projT1 = (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))),
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))); Coq_Primitive.projT2 =
             Coq3_Compilers.Coq_pattern_ident_fancy_addm })) dt idt

      (** val arg_types_unfolded :
          Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> __
          list **)

      let arg_types_unfolded _ = function
      | Coq3_Compilers.Coq_pattern_ident_Literal _ -> __ :: []
      | Coq3_Compilers.Coq_pattern_ident_comment _ -> []
      | Coq3_Compilers.Coq_pattern_ident_comment_no_keep _ -> []
      | Coq3_Compilers.Coq_pattern_ident_value_barrier -> []
      | Coq3_Compilers.Coq_pattern_ident_Nat_succ -> []
      | Coq3_Compilers.Coq_pattern_ident_Nat_pred -> []
      | Coq3_Compilers.Coq_pattern_ident_Nat_max -> []
      | Coq3_Compilers.Coq_pattern_ident_Nat_mul -> []
      | Coq3_Compilers.Coq_pattern_ident_Nat_add -> []
      | Coq3_Compilers.Coq_pattern_ident_Nat_sub -> []
      | Coq3_Compilers.Coq_pattern_ident_Nat_eqb -> []
      | Coq3_Compilers.Coq_pattern_ident_nil _ -> []
      | Coq3_Compilers.Coq_pattern_ident_cons _ -> []
      | Coq3_Compilers.Coq_pattern_ident_tt -> []
      | Coq3_Compilers.Coq_pattern_ident_pair (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_fst (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_snd (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_prod_rect (_, _, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_bool_rect _ -> []
      | Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep _ -> []
      | Coq3_Compilers.Coq_pattern_ident_nat_rect _ -> []
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect _ -> []
      | Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_list_rect (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (_, _, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (_, _, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_list_case (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_List_length _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_seq -> []
      | Coq3_Compilers.Coq_pattern_ident_List_firstn _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_skipn _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_repeat _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_combine (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_List_map (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_List_app _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_rev _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_flat_map (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_List_partition _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_filter _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_fold_right (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_List_update_nth _ -> []
      | Coq3_Compilers.Coq_pattern_ident_List_nth_default _ -> []
      | Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default _ -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_add -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_mul -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_pow -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_sub -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_opp -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_div -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_modulo -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_eqb -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_leb -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_ltb -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_geb -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_gtb -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_log2 -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_log2_up -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_of_nat -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_to_nat -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftr -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftl -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_land -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_lor -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_min -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_max -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_split -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_high -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_ltz -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_zselect -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_add_modulo -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_bneg -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_lxor -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_rshi -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_cc_m -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_cast -> []
      | Coq3_Compilers.Coq_pattern_ident_Z_cast2 -> []
      | Coq3_Compilers.Coq_pattern_ident_Some _ -> []
      | Coq3_Compilers.Coq_pattern_ident_None _ -> []
      | Coq3_Compilers.Coq_pattern_ident_option_rect (_, _) -> []
      | Coq3_Compilers.Coq_pattern_ident_Build_zrange -> []
      | Coq3_Compilers.Coq_pattern_ident_zrange_rect _ -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_add -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_addc -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_sub -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_subb -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulll -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_mullh -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhl -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhh -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_rshi -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_selc -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_selm -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_sell -> []
      | Coq3_Compilers.Coq_pattern_ident_fancy_addm -> []

      (** val type_of_list_arg_types_beq_unfolded :
          Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident -> __
          -> __ -> bool **)

      let type_of_list_arg_types_beq_unfolded _ = function
      | Coq3_Compilers.Coq_pattern_ident_Literal t0 ->
        (fun x0 y ->
          prod_beq0 (Coq3_Compilers.base_interp_beq t0 t0) (fun _ _ -> true)
            (Obj.magic x0) (Obj.magic y))
      | Coq3_Compilers.Coq_pattern_ident_comment _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_comment_no_keep _ ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_value_barrier -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Nat_succ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Nat_pred -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Nat_max -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Nat_mul -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Nat_add -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Nat_sub -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Nat_eqb -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_nil _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_cons _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_tt -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_pair (_, _) -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fst (_, _) -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_snd (_, _) -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_prod_rect (_, _, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_bool_rect _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep _ ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_nat_rect _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (_, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (_, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_list_rect (_, _) -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect (_, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (_, _, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (_, _, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_list_case (_, _) -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_length _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_seq -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_firstn _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_skipn _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_repeat _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_combine (_, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_map (_, _) -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_app _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_rev _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_flat_map (_, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_partition _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_filter _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_fold_right (_, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_update_nth _ ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_List_nth_default _ ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default _ ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_add -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_mul -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_pow -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_sub -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_opp -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_div -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_modulo -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_eqb -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_leb -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_ltb -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_geb -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_gtb -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_log2 -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_log2_up -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_of_nat -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_to_nat -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftr -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_shiftl -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_land -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_lor -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_min -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_max -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_split -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_mul_high -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_ltz -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_zselect -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_add_modulo -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_bneg -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_lxor -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_rshi -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_cc_m -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_cast -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Z_cast2 -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Some _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_None _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_option_rect (_, _) ->
        (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_Build_zrange -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_zrange_rect _ -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_add -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_addc -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_sub -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_subb -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulll -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_mullh -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhl -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_mulhh -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_rshi -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_selc -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_selm -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_sell -> (fun _ _ -> true)
      | Coq3_Compilers.Coq_pattern_ident_fancy_addm -> (fun _ _ -> true)

      (** val to_typed_unfolded :
          Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.pattern_ident ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          PositiveMap.tree -> __ -> Coq3_Compilers.ident **)

      let to_typed_unfolded _ idc evm =
        match idc with
        | Coq3_Compilers.Coq_pattern_ident_Literal t0 ->
          (fun args0 -> Coq3_Compilers.Coq_ident_Literal (t0,
            (fst (Obj.magic args0))))
        | Coq3_Compilers.Coq_pattern_ident_comment t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_comment
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_comment_no_keep t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_comment_no_keep
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_value_barrier ->
          (fun _ -> Coq3_Compilers.Coq_ident_value_barrier)
        | Coq3_Compilers.Coq_pattern_ident_Nat_succ ->
          (fun _ -> Coq3_Compilers.Coq_ident_Nat_succ)
        | Coq3_Compilers.Coq_pattern_ident_Nat_pred ->
          (fun _ -> Coq3_Compilers.Coq_ident_Nat_pred)
        | Coq3_Compilers.Coq_pattern_ident_Nat_max ->
          (fun _ -> Coq3_Compilers.Coq_ident_Nat_max)
        | Coq3_Compilers.Coq_pattern_ident_Nat_mul ->
          (fun _ -> Coq3_Compilers.Coq_ident_Nat_mul)
        | Coq3_Compilers.Coq_pattern_ident_Nat_add ->
          (fun _ -> Coq3_Compilers.Coq_ident_Nat_add)
        | Coq3_Compilers.Coq_pattern_ident_Nat_sub ->
          (fun _ -> Coq3_Compilers.Coq_ident_Nat_sub)
        | Coq3_Compilers.Coq_pattern_ident_Nat_eqb ->
          (fun _ -> Coq3_Compilers.Coq_ident_Nat_eqb)
        | Coq3_Compilers.Coq_pattern_ident_nil t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_nil
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_cons t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_cons
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_tt ->
          (fun _ -> Coq3_Compilers.Coq_ident_tt)
        | Coq3_Compilers.Coq_pattern_ident_pair (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_pair
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_fst (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_fst
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_snd (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_snd
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_prod_rect (t0, t1, t2) ->
          (fun _ -> Coq3_Compilers.Coq_ident_prod_rect
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t2 evm)))
        | Coq3_Compilers.Coq_pattern_ident_bool_rect t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_bool_rect
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_bool_rect_nodep
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_nat_rect t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_nat_rect
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_eager_nat_rect
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_nat_rect_arrow
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_eager_nat_rect_arrow
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_list_rect (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_list_rect
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_eager_list_rect (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_eager_list_rect
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (t0, t1, t2) ->
          (fun _ -> Coq3_Compilers.Coq_ident_list_rect_arrow
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t2 evm)))
        | Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (t0, t1, t2) ->
          (fun _ -> Coq3_Compilers.Coq_ident_eager_list_rect_arrow
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t2 evm)))
        | Coq3_Compilers.Coq_pattern_ident_list_case (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_list_case
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_List_length t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_length
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_seq ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_seq)
        | Coq3_Compilers.Coq_pattern_ident_List_firstn t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_firstn
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_skipn t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_skipn
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_repeat t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_repeat
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_combine (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_combine
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_List_map (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_map
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_List_app t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_app
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_rev t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_rev
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_flat_map (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_flat_map
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_List_partition t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_partition
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_filter t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_filter
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_fold_right (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_fold_right
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_List_update_nth t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_update_nth
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_List_nth_default t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_List_nth_default
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_eager_List_nth_default
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_Z_add ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_add)
        | Coq3_Compilers.Coq_pattern_ident_Z_mul ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_mul)
        | Coq3_Compilers.Coq_pattern_ident_Z_pow ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_pow)
        | Coq3_Compilers.Coq_pattern_ident_Z_sub ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_sub)
        | Coq3_Compilers.Coq_pattern_ident_Z_opp ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_opp)
        | Coq3_Compilers.Coq_pattern_ident_Z_div ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_div)
        | Coq3_Compilers.Coq_pattern_ident_Z_modulo ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_modulo)
        | Coq3_Compilers.Coq_pattern_ident_Z_eqb ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_eqb)
        | Coq3_Compilers.Coq_pattern_ident_Z_leb ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_leb)
        | Coq3_Compilers.Coq_pattern_ident_Z_ltb ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_ltb)
        | Coq3_Compilers.Coq_pattern_ident_Z_geb ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_geb)
        | Coq3_Compilers.Coq_pattern_ident_Z_gtb ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_gtb)
        | Coq3_Compilers.Coq_pattern_ident_Z_log2 ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_log2)
        | Coq3_Compilers.Coq_pattern_ident_Z_log2_up ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_log2_up)
        | Coq3_Compilers.Coq_pattern_ident_Z_of_nat ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_of_nat)
        | Coq3_Compilers.Coq_pattern_ident_Z_to_nat ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_to_nat)
        | Coq3_Compilers.Coq_pattern_ident_Z_shiftr ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_shiftr)
        | Coq3_Compilers.Coq_pattern_ident_Z_shiftl ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_shiftl)
        | Coq3_Compilers.Coq_pattern_ident_Z_land ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_land)
        | Coq3_Compilers.Coq_pattern_ident_Z_lor ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_lor)
        | Coq3_Compilers.Coq_pattern_ident_Z_min ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_min)
        | Coq3_Compilers.Coq_pattern_ident_Z_max ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_max)
        | Coq3_Compilers.Coq_pattern_ident_Z_mul_split ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_mul_split)
        | Coq3_Compilers.Coq_pattern_ident_Z_mul_high ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_mul_high)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_add_get_carry)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_add_with_carry)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_add_with_get_carry)
        | Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_sub_get_borrow)
        | Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)
        | Coq3_Compilers.Coq_pattern_ident_Z_ltz ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_ltz)
        | Coq3_Compilers.Coq_pattern_ident_Z_zselect ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_zselect)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_modulo ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_add_modulo)
        | Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_truncating_shiftl)
        | Coq3_Compilers.Coq_pattern_ident_Z_bneg ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_bneg)
        | Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_lnot_modulo)
        | Coq3_Compilers.Coq_pattern_ident_Z_lxor ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_lxor)
        | Coq3_Compilers.Coq_pattern_ident_Z_rshi ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_rshi)
        | Coq3_Compilers.Coq_pattern_ident_Z_cc_m ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_cc_m)
        | Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)
        | Coq3_Compilers.Coq_pattern_ident_Z_cast ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_cast)
        | Coq3_Compilers.Coq_pattern_ident_Z_cast2 ->
          (fun _ -> Coq3_Compilers.Coq_ident_Z_cast2)
        | Coq3_Compilers.Coq_pattern_ident_Some t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_Some
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_None t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_None
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_option_rect (t0, t1) ->
          (fun _ -> Coq3_Compilers.Coq_ident_option_rect
            ((Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm),
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t1 evm)))
        | Coq3_Compilers.Coq_pattern_ident_Build_zrange ->
          (fun _ -> Coq3_Compilers.Coq_ident_Build_zrange)
        | Coq3_Compilers.Coq_pattern_ident_zrange_rect t0 ->
          (fun _ -> Coq3_Compilers.Coq_ident_zrange_rect
            (Coq0_Compilers.Coq_pattern.Coq_base.subst_default t0 evm))
        | Coq3_Compilers.Coq_pattern_ident_fancy_add ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_add)
        | Coq3_Compilers.Coq_pattern_ident_fancy_addc ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_addc)
        | Coq3_Compilers.Coq_pattern_ident_fancy_sub ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_sub)
        | Coq3_Compilers.Coq_pattern_ident_fancy_subb ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_subb)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mulll ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_mulll)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mullh ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_mullh)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mulhl ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_mulhl)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mulhh ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_mulhh)
        | Coq3_Compilers.Coq_pattern_ident_fancy_rshi ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_rshi)
        | Coq3_Compilers.Coq_pattern_ident_fancy_selc ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_selc)
        | Coq3_Compilers.Coq_pattern_ident_fancy_selm ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_selm)
        | Coq3_Compilers.Coq_pattern_ident_fancy_sell ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_sell)
        | Coq3_Compilers.Coq_pattern_ident_fancy_addm ->
          (fun _ -> Coq3_Compilers.Coq_ident_fancy_addm)

      (** val of_typed_ident_unfolded :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
          Coq3_Compilers.pattern_ident **)

      let of_typed_ident_unfolded _ = function
      | Coq3_Compilers.Coq_ident_Literal (t0, _) ->
        Coq3_Compilers.Coq_pattern_ident_Literal t0
      | Coq3_Compilers.Coq_ident_comment t0 ->
        Coq3_Compilers.Coq_pattern_ident_comment
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
        Coq3_Compilers.Coq_pattern_ident_comment_no_keep
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_value_barrier ->
        Coq3_Compilers.Coq_pattern_ident_value_barrier
      | Coq3_Compilers.Coq_ident_Nat_succ ->
        Coq3_Compilers.Coq_pattern_ident_Nat_succ
      | Coq3_Compilers.Coq_ident_Nat_pred ->
        Coq3_Compilers.Coq_pattern_ident_Nat_pred
      | Coq3_Compilers.Coq_ident_Nat_max ->
        Coq3_Compilers.Coq_pattern_ident_Nat_max
      | Coq3_Compilers.Coq_ident_Nat_mul ->
        Coq3_Compilers.Coq_pattern_ident_Nat_mul
      | Coq3_Compilers.Coq_ident_Nat_add ->
        Coq3_Compilers.Coq_pattern_ident_Nat_add
      | Coq3_Compilers.Coq_ident_Nat_sub ->
        Coq3_Compilers.Coq_pattern_ident_Nat_sub
      | Coq3_Compilers.Coq_ident_Nat_eqb ->
        Coq3_Compilers.Coq_pattern_ident_Nat_eqb
      | Coq3_Compilers.Coq_ident_nil t0 ->
        Coq3_Compilers.Coq_pattern_ident_nil
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_cons t0 ->
        Coq3_Compilers.Coq_pattern_ident_cons
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_tt -> Coq3_Compilers.Coq_pattern_ident_tt
      | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_pair
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_fst
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_snd
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
        Coq3_Compilers.Coq_pattern_ident_prod_rect
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t2))
      | Coq3_Compilers.Coq_ident_bool_rect t0 ->
        Coq3_Compilers.Coq_pattern_ident_bool_rect
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
        Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_nat_rect t0 ->
        Coq3_Compilers.Coq_pattern_ident_nat_rect
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
        Coq3_Compilers.Coq_pattern_ident_eager_nat_rect
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_list_rect
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_eager_list_rect
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
        Coq3_Compilers.Coq_pattern_ident_list_rect_arrow
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t2))
      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
        Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t2))
      | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_list_case
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_List_length t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_length
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_seq ->
        Coq3_Compilers.Coq_pattern_ident_List_seq
      | Coq3_Compilers.Coq_ident_List_firstn t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_firstn
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_skipn t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_skipn
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_repeat t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_repeat
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_List_combine
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_List_map
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_List_app t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_app
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_rev t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_rev
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_List_flat_map
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_List_partition t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_partition
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_filter t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_filter
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_List_fold_right
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_update_nth
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
        Coq3_Compilers.Coq_pattern_ident_List_nth_default
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
        Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_Z_add ->
        Coq3_Compilers.Coq_pattern_ident_Z_add
      | Coq3_Compilers.Coq_ident_Z_mul ->
        Coq3_Compilers.Coq_pattern_ident_Z_mul
      | Coq3_Compilers.Coq_ident_Z_pow ->
        Coq3_Compilers.Coq_pattern_ident_Z_pow
      | Coq3_Compilers.Coq_ident_Z_sub ->
        Coq3_Compilers.Coq_pattern_ident_Z_sub
      | Coq3_Compilers.Coq_ident_Z_opp ->
        Coq3_Compilers.Coq_pattern_ident_Z_opp
      | Coq3_Compilers.Coq_ident_Z_div ->
        Coq3_Compilers.Coq_pattern_ident_Z_div
      | Coq3_Compilers.Coq_ident_Z_modulo ->
        Coq3_Compilers.Coq_pattern_ident_Z_modulo
      | Coq3_Compilers.Coq_ident_Z_eqb ->
        Coq3_Compilers.Coq_pattern_ident_Z_eqb
      | Coq3_Compilers.Coq_ident_Z_leb ->
        Coq3_Compilers.Coq_pattern_ident_Z_leb
      | Coq3_Compilers.Coq_ident_Z_ltb ->
        Coq3_Compilers.Coq_pattern_ident_Z_ltb
      | Coq3_Compilers.Coq_ident_Z_geb ->
        Coq3_Compilers.Coq_pattern_ident_Z_geb
      | Coq3_Compilers.Coq_ident_Z_gtb ->
        Coq3_Compilers.Coq_pattern_ident_Z_gtb
      | Coq3_Compilers.Coq_ident_Z_log2 ->
        Coq3_Compilers.Coq_pattern_ident_Z_log2
      | Coq3_Compilers.Coq_ident_Z_log2_up ->
        Coq3_Compilers.Coq_pattern_ident_Z_log2_up
      | Coq3_Compilers.Coq_ident_Z_of_nat ->
        Coq3_Compilers.Coq_pattern_ident_Z_of_nat
      | Coq3_Compilers.Coq_ident_Z_to_nat ->
        Coq3_Compilers.Coq_pattern_ident_Z_to_nat
      | Coq3_Compilers.Coq_ident_Z_shiftr ->
        Coq3_Compilers.Coq_pattern_ident_Z_shiftr
      | Coq3_Compilers.Coq_ident_Z_shiftl ->
        Coq3_Compilers.Coq_pattern_ident_Z_shiftl
      | Coq3_Compilers.Coq_ident_Z_land ->
        Coq3_Compilers.Coq_pattern_ident_Z_land
      | Coq3_Compilers.Coq_ident_Z_lor ->
        Coq3_Compilers.Coq_pattern_ident_Z_lor
      | Coq3_Compilers.Coq_ident_Z_min ->
        Coq3_Compilers.Coq_pattern_ident_Z_min
      | Coq3_Compilers.Coq_ident_Z_max ->
        Coq3_Compilers.Coq_pattern_ident_Z_max
      | Coq3_Compilers.Coq_ident_Z_mul_split ->
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split
      | Coq3_Compilers.Coq_ident_Z_mul_high ->
        Coq3_Compilers.Coq_pattern_ident_Z_mul_high
      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry
      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry
      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry
      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow
      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow
      | Coq3_Compilers.Coq_ident_Z_ltz ->
        Coq3_Compilers.Coq_pattern_ident_Z_ltz
      | Coq3_Compilers.Coq_ident_Z_zselect ->
        Coq3_Compilers.Coq_pattern_ident_Z_zselect
      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
        Coq3_Compilers.Coq_pattern_ident_Z_add_modulo
      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
        Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl
      | Coq3_Compilers.Coq_ident_Z_bneg ->
        Coq3_Compilers.Coq_pattern_ident_Z_bneg
      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
        Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo
      | Coq3_Compilers.Coq_ident_Z_lxor ->
        Coq3_Compilers.Coq_pattern_ident_Z_lxor
      | Coq3_Compilers.Coq_ident_Z_rshi ->
        Coq3_Compilers.Coq_pattern_ident_Z_rshi
      | Coq3_Compilers.Coq_ident_Z_cc_m ->
        Coq3_Compilers.Coq_pattern_ident_Z_cc_m
      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth
      | Coq3_Compilers.Coq_ident_Z_cast ->
        Coq3_Compilers.Coq_pattern_ident_Z_cast
      | Coq3_Compilers.Coq_ident_Z_cast2 ->
        Coq3_Compilers.Coq_pattern_ident_Z_cast2
      | Coq3_Compilers.Coq_ident_Some t0 ->
        Coq3_Compilers.Coq_pattern_ident_Some
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_None t0 ->
        Coq3_Compilers.Coq_pattern_ident_None
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
        Coq3_Compilers.Coq_pattern_ident_option_rect
          ((Coq0_Compilers.Coq_pattern.Coq_base.relax t0),
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t1))
      | Coq3_Compilers.Coq_ident_Build_zrange ->
        Coq3_Compilers.Coq_pattern_ident_Build_zrange
      | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
        Coq3_Compilers.Coq_pattern_ident_zrange_rect
          (Coq0_Compilers.Coq_pattern.Coq_base.relax t0)
      | Coq3_Compilers.Coq_ident_fancy_add ->
        Coq3_Compilers.Coq_pattern_ident_fancy_add
      | Coq3_Compilers.Coq_ident_fancy_addc ->
        Coq3_Compilers.Coq_pattern_ident_fancy_addc
      | Coq3_Compilers.Coq_ident_fancy_sub ->
        Coq3_Compilers.Coq_pattern_ident_fancy_sub
      | Coq3_Compilers.Coq_ident_fancy_subb ->
        Coq3_Compilers.Coq_pattern_ident_fancy_subb
      | Coq3_Compilers.Coq_ident_fancy_mulll ->
        Coq3_Compilers.Coq_pattern_ident_fancy_mulll
      | Coq3_Compilers.Coq_ident_fancy_mullh ->
        Coq3_Compilers.Coq_pattern_ident_fancy_mullh
      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
        Coq3_Compilers.Coq_pattern_ident_fancy_mulhl
      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
        Coq3_Compilers.Coq_pattern_ident_fancy_mulhh
      | Coq3_Compilers.Coq_ident_fancy_rshi ->
        Coq3_Compilers.Coq_pattern_ident_fancy_rshi
      | Coq3_Compilers.Coq_ident_fancy_selc ->
        Coq3_Compilers.Coq_pattern_ident_fancy_selc
      | Coq3_Compilers.Coq_ident_fancy_selm ->
        Coq3_Compilers.Coq_pattern_ident_fancy_selm
      | Coq3_Compilers.Coq_ident_fancy_sell ->
        Coq3_Compilers.Coq_pattern_ident_fancy_sell
      | Coq3_Compilers.Coq_ident_fancy_addm ->
        Coq3_Compilers.Coq_pattern_ident_fancy_addm

      (** val arg_types_of_typed_ident_unfolded :
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> __ **)

      let arg_types_of_typed_ident_unfolded _ = function
      | Coq3_Compilers.Coq_ident_Literal (_, y) -> Obj.magic (y, ())
      | Coq3_Compilers.Coq_ident_comment _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_value_barrier -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Nat_succ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Nat_pred -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Nat_max -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Nat_mul -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Nat_add -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Nat_sub -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Nat_eqb -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_nil _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_cons _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_tt -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_pair (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fst (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_snd (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_bool_rect _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_nat_rect _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
        Obj.magic ()
      | Coq3_Compilers.Coq_ident_list_case (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_length _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_seq -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_firstn _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_skipn _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_repeat _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_map (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_app _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_rev _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_partition _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_filter _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_update_nth _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_List_nth_default _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_add -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_mul -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_pow -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_sub -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_opp -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_div -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_modulo -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_eqb -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_leb -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_ltb -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_geb -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_gtb -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_log2 -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_log2_up -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_of_nat -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_to_nat -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_shiftr -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_shiftl -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_land -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_lor -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_min -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_max -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_mul_split -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_mul_high -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_ltz -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_zselect -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_add_modulo -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_bneg -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_lxor -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_rshi -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_cc_m -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_cast -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Z_cast2 -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Some _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_None _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_Build_zrange -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_zrange_rect _ -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_add -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_addc -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_sub -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_subb -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_mulll -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_mullh -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_mulhl -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_mulhh -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_rshi -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_selc -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_selm -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_sell -> Obj.magic ()
      | Coq3_Compilers.Coq_ident_fancy_addm -> Obj.magic ()

      (** val unify :
          Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.pattern_ident -> Coq3_Compilers.ident -> __ option **)

      let unify _ _ pidc idc =
        match pidc with
        | Coq3_Compilers.Coq_pattern_ident_Literal t0 ->
          (match t0 with
           | Coq3_Compilers.Z ->
             (match idc with
              | Coq3_Compilers.Coq_ident_Literal (t1, x) ->
                (match t1 with
                 | Coq3_Compilers.Z -> (fun x0 -> Some (Obj.magic (x0, ())))
                 | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                 | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                 | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                 | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
              | Coq3_Compilers.Coq_ident_comment _ -> None
              | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
              | Coq3_Compilers.Coq_ident_value_barrier -> None
              | Coq3_Compilers.Coq_ident_Nat_succ -> None
              | Coq3_Compilers.Coq_ident_Nat_pred -> None
              | Coq3_Compilers.Coq_ident_Nat_max -> None
              | Coq3_Compilers.Coq_ident_Nat_mul -> None
              | Coq3_Compilers.Coq_ident_Nat_add -> None
              | Coq3_Compilers.Coq_ident_Nat_sub -> None
              | Coq3_Compilers.Coq_ident_Nat_eqb -> None
              | Coq3_Compilers.Coq_ident_nil _ -> None
              | Coq3_Compilers.Coq_ident_cons _ -> None
              | Coq3_Compilers.Coq_ident_tt -> None
              | Coq3_Compilers.Coq_ident_pair (_, _) -> None
              | Coq3_Compilers.Coq_ident_fst (_, _) -> None
              | Coq3_Compilers.Coq_ident_snd (_, _) -> None
              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_bool_rect _ -> None
              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                None
              | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_length _ -> None
              | Coq3_Compilers.Coq_ident_List_seq -> None
              | Coq3_Compilers.Coq_ident_List_firstn _ -> None
              | Coq3_Compilers.Coq_ident_List_skipn _ -> None
              | Coq3_Compilers.Coq_ident_List_repeat _ -> None
              | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_app _ -> None
              | Coq3_Compilers.Coq_ident_List_rev _ -> None
              | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_partition _ -> None
              | Coq3_Compilers.Coq_ident_List_filter _ -> None
              | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
              | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_Z_add -> None
              | Coq3_Compilers.Coq_ident_Z_mul -> None
              | Coq3_Compilers.Coq_ident_Z_pow -> None
              | Coq3_Compilers.Coq_ident_Z_sub -> None
              | Coq3_Compilers.Coq_ident_Z_opp -> None
              | Coq3_Compilers.Coq_ident_Z_div -> None
              | Coq3_Compilers.Coq_ident_Z_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_eqb -> None
              | Coq3_Compilers.Coq_ident_Z_leb -> None
              | Coq3_Compilers.Coq_ident_Z_ltb -> None
              | Coq3_Compilers.Coq_ident_Z_geb -> None
              | Coq3_Compilers.Coq_ident_Z_gtb -> None
              | Coq3_Compilers.Coq_ident_Z_log2 -> None
              | Coq3_Compilers.Coq_ident_Z_log2_up -> None
              | Coq3_Compilers.Coq_ident_Z_of_nat -> None
              | Coq3_Compilers.Coq_ident_Z_to_nat -> None
              | Coq3_Compilers.Coq_ident_Z_shiftr -> None
              | Coq3_Compilers.Coq_ident_Z_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_land -> None
              | Coq3_Compilers.Coq_ident_Z_lor -> None
              | Coq3_Compilers.Coq_ident_Z_min -> None
              | Coq3_Compilers.Coq_ident_Z_max -> None
              | Coq3_Compilers.Coq_ident_Z_mul_split -> None
              | Coq3_Compilers.Coq_ident_Z_mul_high -> None
              | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_ltz -> None
              | Coq3_Compilers.Coq_ident_Z_zselect -> None
              | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_bneg -> None
              | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_lxor -> None
              | Coq3_Compilers.Coq_ident_Z_rshi -> None
              | Coq3_Compilers.Coq_ident_Z_cc_m -> None
              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
              | Coq3_Compilers.Coq_ident_Z_cast -> None
              | Coq3_Compilers.Coq_ident_Z_cast2 -> None
              | Coq3_Compilers.Coq_ident_Some _ -> None
              | Coq3_Compilers.Coq_ident_None _ -> None
              | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_Build_zrange -> None
              | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
              | Coq3_Compilers.Coq_ident_fancy_add -> None
              | Coq3_Compilers.Coq_ident_fancy_addc -> None
              | Coq3_Compilers.Coq_ident_fancy_sub -> None
              | Coq3_Compilers.Coq_ident_fancy_subb -> None
              | Coq3_Compilers.Coq_ident_fancy_mulll -> None
              | Coq3_Compilers.Coq_ident_fancy_mullh -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
              | Coq3_Compilers.Coq_ident_fancy_rshi -> None
              | Coq3_Compilers.Coq_ident_fancy_selc -> None
              | Coq3_Compilers.Coq_ident_fancy_selm -> None
              | Coq3_Compilers.Coq_ident_fancy_sell -> None
              | Coq3_Compilers.Coq_ident_fancy_addm -> None)
           | Coq3_Compilers.Coq_bool ->
             (match idc with
              | Coq3_Compilers.Coq_ident_Literal (t1, x) ->
                (match t1 with
                 | Coq3_Compilers.Z -> (fun _ -> None)
                 | Coq3_Compilers.Coq_bool ->
                   (fun x0 -> Some (Obj.magic (x0, ())))
                 | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                 | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                 | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
              | Coq3_Compilers.Coq_ident_comment _ -> None
              | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
              | Coq3_Compilers.Coq_ident_value_barrier -> None
              | Coq3_Compilers.Coq_ident_Nat_succ -> None
              | Coq3_Compilers.Coq_ident_Nat_pred -> None
              | Coq3_Compilers.Coq_ident_Nat_max -> None
              | Coq3_Compilers.Coq_ident_Nat_mul -> None
              | Coq3_Compilers.Coq_ident_Nat_add -> None
              | Coq3_Compilers.Coq_ident_Nat_sub -> None
              | Coq3_Compilers.Coq_ident_Nat_eqb -> None
              | Coq3_Compilers.Coq_ident_nil _ -> None
              | Coq3_Compilers.Coq_ident_cons _ -> None
              | Coq3_Compilers.Coq_ident_tt -> None
              | Coq3_Compilers.Coq_ident_pair (_, _) -> None
              | Coq3_Compilers.Coq_ident_fst (_, _) -> None
              | Coq3_Compilers.Coq_ident_snd (_, _) -> None
              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_bool_rect _ -> None
              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                None
              | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_length _ -> None
              | Coq3_Compilers.Coq_ident_List_seq -> None
              | Coq3_Compilers.Coq_ident_List_firstn _ -> None
              | Coq3_Compilers.Coq_ident_List_skipn _ -> None
              | Coq3_Compilers.Coq_ident_List_repeat _ -> None
              | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_app _ -> None
              | Coq3_Compilers.Coq_ident_List_rev _ -> None
              | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_partition _ -> None
              | Coq3_Compilers.Coq_ident_List_filter _ -> None
              | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
              | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_Z_add -> None
              | Coq3_Compilers.Coq_ident_Z_mul -> None
              | Coq3_Compilers.Coq_ident_Z_pow -> None
              | Coq3_Compilers.Coq_ident_Z_sub -> None
              | Coq3_Compilers.Coq_ident_Z_opp -> None
              | Coq3_Compilers.Coq_ident_Z_div -> None
              | Coq3_Compilers.Coq_ident_Z_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_eqb -> None
              | Coq3_Compilers.Coq_ident_Z_leb -> None
              | Coq3_Compilers.Coq_ident_Z_ltb -> None
              | Coq3_Compilers.Coq_ident_Z_geb -> None
              | Coq3_Compilers.Coq_ident_Z_gtb -> None
              | Coq3_Compilers.Coq_ident_Z_log2 -> None
              | Coq3_Compilers.Coq_ident_Z_log2_up -> None
              | Coq3_Compilers.Coq_ident_Z_of_nat -> None
              | Coq3_Compilers.Coq_ident_Z_to_nat -> None
              | Coq3_Compilers.Coq_ident_Z_shiftr -> None
              | Coq3_Compilers.Coq_ident_Z_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_land -> None
              | Coq3_Compilers.Coq_ident_Z_lor -> None
              | Coq3_Compilers.Coq_ident_Z_min -> None
              | Coq3_Compilers.Coq_ident_Z_max -> None
              | Coq3_Compilers.Coq_ident_Z_mul_split -> None
              | Coq3_Compilers.Coq_ident_Z_mul_high -> None
              | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_ltz -> None
              | Coq3_Compilers.Coq_ident_Z_zselect -> None
              | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_bneg -> None
              | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_lxor -> None
              | Coq3_Compilers.Coq_ident_Z_rshi -> None
              | Coq3_Compilers.Coq_ident_Z_cc_m -> None
              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
              | Coq3_Compilers.Coq_ident_Z_cast -> None
              | Coq3_Compilers.Coq_ident_Z_cast2 -> None
              | Coq3_Compilers.Coq_ident_Some _ -> None
              | Coq3_Compilers.Coq_ident_None _ -> None
              | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_Build_zrange -> None
              | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
              | Coq3_Compilers.Coq_ident_fancy_add -> None
              | Coq3_Compilers.Coq_ident_fancy_addc -> None
              | Coq3_Compilers.Coq_ident_fancy_sub -> None
              | Coq3_Compilers.Coq_ident_fancy_subb -> None
              | Coq3_Compilers.Coq_ident_fancy_mulll -> None
              | Coq3_Compilers.Coq_ident_fancy_mullh -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
              | Coq3_Compilers.Coq_ident_fancy_rshi -> None
              | Coq3_Compilers.Coq_ident_fancy_selc -> None
              | Coq3_Compilers.Coq_ident_fancy_selm -> None
              | Coq3_Compilers.Coq_ident_fancy_sell -> None
              | Coq3_Compilers.Coq_ident_fancy_addm -> None)
           | Coq3_Compilers.Coq_nat ->
             (match idc with
              | Coq3_Compilers.Coq_ident_Literal (t1, x) ->
                (match t1 with
                 | Coq3_Compilers.Z -> (fun _ -> None)
                 | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                 | Coq3_Compilers.Coq_nat ->
                   (fun x0 -> Some (Obj.magic (x0, ())))
                 | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                 | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
              | Coq3_Compilers.Coq_ident_comment _ -> None
              | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
              | Coq3_Compilers.Coq_ident_value_barrier -> None
              | Coq3_Compilers.Coq_ident_Nat_succ -> None
              | Coq3_Compilers.Coq_ident_Nat_pred -> None
              | Coq3_Compilers.Coq_ident_Nat_max -> None
              | Coq3_Compilers.Coq_ident_Nat_mul -> None
              | Coq3_Compilers.Coq_ident_Nat_add -> None
              | Coq3_Compilers.Coq_ident_Nat_sub -> None
              | Coq3_Compilers.Coq_ident_Nat_eqb -> None
              | Coq3_Compilers.Coq_ident_nil _ -> None
              | Coq3_Compilers.Coq_ident_cons _ -> None
              | Coq3_Compilers.Coq_ident_tt -> None
              | Coq3_Compilers.Coq_ident_pair (_, _) -> None
              | Coq3_Compilers.Coq_ident_fst (_, _) -> None
              | Coq3_Compilers.Coq_ident_snd (_, _) -> None
              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_bool_rect _ -> None
              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                None
              | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_length _ -> None
              | Coq3_Compilers.Coq_ident_List_seq -> None
              | Coq3_Compilers.Coq_ident_List_firstn _ -> None
              | Coq3_Compilers.Coq_ident_List_skipn _ -> None
              | Coq3_Compilers.Coq_ident_List_repeat _ -> None
              | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_app _ -> None
              | Coq3_Compilers.Coq_ident_List_rev _ -> None
              | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_partition _ -> None
              | Coq3_Compilers.Coq_ident_List_filter _ -> None
              | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
              | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_Z_add -> None
              | Coq3_Compilers.Coq_ident_Z_mul -> None
              | Coq3_Compilers.Coq_ident_Z_pow -> None
              | Coq3_Compilers.Coq_ident_Z_sub -> None
              | Coq3_Compilers.Coq_ident_Z_opp -> None
              | Coq3_Compilers.Coq_ident_Z_div -> None
              | Coq3_Compilers.Coq_ident_Z_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_eqb -> None
              | Coq3_Compilers.Coq_ident_Z_leb -> None
              | Coq3_Compilers.Coq_ident_Z_ltb -> None
              | Coq3_Compilers.Coq_ident_Z_geb -> None
              | Coq3_Compilers.Coq_ident_Z_gtb -> None
              | Coq3_Compilers.Coq_ident_Z_log2 -> None
              | Coq3_Compilers.Coq_ident_Z_log2_up -> None
              | Coq3_Compilers.Coq_ident_Z_of_nat -> None
              | Coq3_Compilers.Coq_ident_Z_to_nat -> None
              | Coq3_Compilers.Coq_ident_Z_shiftr -> None
              | Coq3_Compilers.Coq_ident_Z_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_land -> None
              | Coq3_Compilers.Coq_ident_Z_lor -> None
              | Coq3_Compilers.Coq_ident_Z_min -> None
              | Coq3_Compilers.Coq_ident_Z_max -> None
              | Coq3_Compilers.Coq_ident_Z_mul_split -> None
              | Coq3_Compilers.Coq_ident_Z_mul_high -> None
              | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_ltz -> None
              | Coq3_Compilers.Coq_ident_Z_zselect -> None
              | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_bneg -> None
              | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_lxor -> None
              | Coq3_Compilers.Coq_ident_Z_rshi -> None
              | Coq3_Compilers.Coq_ident_Z_cc_m -> None
              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
              | Coq3_Compilers.Coq_ident_Z_cast -> None
              | Coq3_Compilers.Coq_ident_Z_cast2 -> None
              | Coq3_Compilers.Coq_ident_Some _ -> None
              | Coq3_Compilers.Coq_ident_None _ -> None
              | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_Build_zrange -> None
              | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
              | Coq3_Compilers.Coq_ident_fancy_add -> None
              | Coq3_Compilers.Coq_ident_fancy_addc -> None
              | Coq3_Compilers.Coq_ident_fancy_sub -> None
              | Coq3_Compilers.Coq_ident_fancy_subb -> None
              | Coq3_Compilers.Coq_ident_fancy_mulll -> None
              | Coq3_Compilers.Coq_ident_fancy_mullh -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
              | Coq3_Compilers.Coq_ident_fancy_rshi -> None
              | Coq3_Compilers.Coq_ident_fancy_selc -> None
              | Coq3_Compilers.Coq_ident_fancy_selm -> None
              | Coq3_Compilers.Coq_ident_fancy_sell -> None
              | Coq3_Compilers.Coq_ident_fancy_addm -> None)
           | Coq3_Compilers.Coq_zrange ->
             (match idc with
              | Coq3_Compilers.Coq_ident_Literal (t1, x) ->
                (match t1 with
                 | Coq3_Compilers.Z -> (fun _ -> None)
                 | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                 | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                 | Coq3_Compilers.Coq_zrange ->
                   (fun x0 -> Some (Obj.magic (x0, ())))
                 | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
              | Coq3_Compilers.Coq_ident_comment _ -> None
              | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
              | Coq3_Compilers.Coq_ident_value_barrier -> None
              | Coq3_Compilers.Coq_ident_Nat_succ -> None
              | Coq3_Compilers.Coq_ident_Nat_pred -> None
              | Coq3_Compilers.Coq_ident_Nat_max -> None
              | Coq3_Compilers.Coq_ident_Nat_mul -> None
              | Coq3_Compilers.Coq_ident_Nat_add -> None
              | Coq3_Compilers.Coq_ident_Nat_sub -> None
              | Coq3_Compilers.Coq_ident_Nat_eqb -> None
              | Coq3_Compilers.Coq_ident_nil _ -> None
              | Coq3_Compilers.Coq_ident_cons _ -> None
              | Coq3_Compilers.Coq_ident_tt -> None
              | Coq3_Compilers.Coq_ident_pair (_, _) -> None
              | Coq3_Compilers.Coq_ident_fst (_, _) -> None
              | Coq3_Compilers.Coq_ident_snd (_, _) -> None
              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_bool_rect _ -> None
              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                None
              | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_length _ -> None
              | Coq3_Compilers.Coq_ident_List_seq -> None
              | Coq3_Compilers.Coq_ident_List_firstn _ -> None
              | Coq3_Compilers.Coq_ident_List_skipn _ -> None
              | Coq3_Compilers.Coq_ident_List_repeat _ -> None
              | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_app _ -> None
              | Coq3_Compilers.Coq_ident_List_rev _ -> None
              | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_partition _ -> None
              | Coq3_Compilers.Coq_ident_List_filter _ -> None
              | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
              | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_Z_add -> None
              | Coq3_Compilers.Coq_ident_Z_mul -> None
              | Coq3_Compilers.Coq_ident_Z_pow -> None
              | Coq3_Compilers.Coq_ident_Z_sub -> None
              | Coq3_Compilers.Coq_ident_Z_opp -> None
              | Coq3_Compilers.Coq_ident_Z_div -> None
              | Coq3_Compilers.Coq_ident_Z_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_eqb -> None
              | Coq3_Compilers.Coq_ident_Z_leb -> None
              | Coq3_Compilers.Coq_ident_Z_ltb -> None
              | Coq3_Compilers.Coq_ident_Z_geb -> None
              | Coq3_Compilers.Coq_ident_Z_gtb -> None
              | Coq3_Compilers.Coq_ident_Z_log2 -> None
              | Coq3_Compilers.Coq_ident_Z_log2_up -> None
              | Coq3_Compilers.Coq_ident_Z_of_nat -> None
              | Coq3_Compilers.Coq_ident_Z_to_nat -> None
              | Coq3_Compilers.Coq_ident_Z_shiftr -> None
              | Coq3_Compilers.Coq_ident_Z_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_land -> None
              | Coq3_Compilers.Coq_ident_Z_lor -> None
              | Coq3_Compilers.Coq_ident_Z_min -> None
              | Coq3_Compilers.Coq_ident_Z_max -> None
              | Coq3_Compilers.Coq_ident_Z_mul_split -> None
              | Coq3_Compilers.Coq_ident_Z_mul_high -> None
              | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_ltz -> None
              | Coq3_Compilers.Coq_ident_Z_zselect -> None
              | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_bneg -> None
              | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_lxor -> None
              | Coq3_Compilers.Coq_ident_Z_rshi -> None
              | Coq3_Compilers.Coq_ident_Z_cc_m -> None
              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
              | Coq3_Compilers.Coq_ident_Z_cast -> None
              | Coq3_Compilers.Coq_ident_Z_cast2 -> None
              | Coq3_Compilers.Coq_ident_Some _ -> None
              | Coq3_Compilers.Coq_ident_None _ -> None
              | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_Build_zrange -> None
              | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
              | Coq3_Compilers.Coq_ident_fancy_add -> None
              | Coq3_Compilers.Coq_ident_fancy_addc -> None
              | Coq3_Compilers.Coq_ident_fancy_sub -> None
              | Coq3_Compilers.Coq_ident_fancy_subb -> None
              | Coq3_Compilers.Coq_ident_fancy_mulll -> None
              | Coq3_Compilers.Coq_ident_fancy_mullh -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
              | Coq3_Compilers.Coq_ident_fancy_rshi -> None
              | Coq3_Compilers.Coq_ident_fancy_selc -> None
              | Coq3_Compilers.Coq_ident_fancy_selm -> None
              | Coq3_Compilers.Coq_ident_fancy_sell -> None
              | Coq3_Compilers.Coq_ident_fancy_addm -> None)
           | Coq3_Compilers.Coq_string ->
             (match idc with
              | Coq3_Compilers.Coq_ident_Literal (t1, x) ->
                (match t1 with
                 | Coq3_Compilers.Z -> (fun _ -> None)
                 | Coq3_Compilers.Coq_bool -> (fun _ -> None)
                 | Coq3_Compilers.Coq_nat -> (fun _ -> None)
                 | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
                 | Coq3_Compilers.Coq_string ->
                   (fun x0 -> Some (Obj.magic (x0, ())))) x
              | Coq3_Compilers.Coq_ident_comment _ -> None
              | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
              | Coq3_Compilers.Coq_ident_value_barrier -> None
              | Coq3_Compilers.Coq_ident_Nat_succ -> None
              | Coq3_Compilers.Coq_ident_Nat_pred -> None
              | Coq3_Compilers.Coq_ident_Nat_max -> None
              | Coq3_Compilers.Coq_ident_Nat_mul -> None
              | Coq3_Compilers.Coq_ident_Nat_add -> None
              | Coq3_Compilers.Coq_ident_Nat_sub -> None
              | Coq3_Compilers.Coq_ident_Nat_eqb -> None
              | Coq3_Compilers.Coq_ident_nil _ -> None
              | Coq3_Compilers.Coq_ident_cons _ -> None
              | Coq3_Compilers.Coq_ident_tt -> None
              | Coq3_Compilers.Coq_ident_pair (_, _) -> None
              | Coq3_Compilers.Coq_ident_fst (_, _) -> None
              | Coq3_Compilers.Coq_ident_snd (_, _) -> None
              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_bool_rect _ -> None
              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
              | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                None
              | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_length _ -> None
              | Coq3_Compilers.Coq_ident_List_seq -> None
              | Coq3_Compilers.Coq_ident_List_firstn _ -> None
              | Coq3_Compilers.Coq_ident_List_skipn _ -> None
              | Coq3_Compilers.Coq_ident_List_repeat _ -> None
              | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_app _ -> None
              | Coq3_Compilers.Coq_ident_List_rev _ -> None
              | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_partition _ -> None
              | Coq3_Compilers.Coq_ident_List_filter _ -> None
              | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
              | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
              | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
              | Coq3_Compilers.Coq_ident_Z_add -> None
              | Coq3_Compilers.Coq_ident_Z_mul -> None
              | Coq3_Compilers.Coq_ident_Z_pow -> None
              | Coq3_Compilers.Coq_ident_Z_sub -> None
              | Coq3_Compilers.Coq_ident_Z_opp -> None
              | Coq3_Compilers.Coq_ident_Z_div -> None
              | Coq3_Compilers.Coq_ident_Z_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_eqb -> None
              | Coq3_Compilers.Coq_ident_Z_leb -> None
              | Coq3_Compilers.Coq_ident_Z_ltb -> None
              | Coq3_Compilers.Coq_ident_Z_geb -> None
              | Coq3_Compilers.Coq_ident_Z_gtb -> None
              | Coq3_Compilers.Coq_ident_Z_log2 -> None
              | Coq3_Compilers.Coq_ident_Z_log2_up -> None
              | Coq3_Compilers.Coq_ident_Z_of_nat -> None
              | Coq3_Compilers.Coq_ident_Z_to_nat -> None
              | Coq3_Compilers.Coq_ident_Z_shiftr -> None
              | Coq3_Compilers.Coq_ident_Z_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_land -> None
              | Coq3_Compilers.Coq_ident_Z_lor -> None
              | Coq3_Compilers.Coq_ident_Z_min -> None
              | Coq3_Compilers.Coq_ident_Z_max -> None
              | Coq3_Compilers.Coq_ident_Z_mul_split -> None
              | Coq3_Compilers.Coq_ident_Z_mul_high -> None
              | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
              | Coq3_Compilers.Coq_ident_Z_ltz -> None
              | Coq3_Compilers.Coq_ident_Z_zselect -> None
              | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
              | Coq3_Compilers.Coq_ident_Z_bneg -> None
              | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
              | Coq3_Compilers.Coq_ident_Z_lxor -> None
              | Coq3_Compilers.Coq_ident_Z_rshi -> None
              | Coq3_Compilers.Coq_ident_Z_cc_m -> None
              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
              | Coq3_Compilers.Coq_ident_Z_cast -> None
              | Coq3_Compilers.Coq_ident_Z_cast2 -> None
              | Coq3_Compilers.Coq_ident_Some _ -> None
              | Coq3_Compilers.Coq_ident_None _ -> None
              | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
              | Coq3_Compilers.Coq_ident_Build_zrange -> None
              | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
              | Coq3_Compilers.Coq_ident_fancy_add -> None
              | Coq3_Compilers.Coq_ident_fancy_addc -> None
              | Coq3_Compilers.Coq_ident_fancy_sub -> None
              | Coq3_Compilers.Coq_ident_fancy_subb -> None
              | Coq3_Compilers.Coq_ident_fancy_mulll -> None
              | Coq3_Compilers.Coq_ident_fancy_mullh -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
              | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
              | Coq3_Compilers.Coq_ident_fancy_rshi -> None
              | Coq3_Compilers.Coq_ident_fancy_selc -> None
              | Coq3_Compilers.Coq_ident_fancy_selm -> None
              | Coq3_Compilers.Coq_ident_fancy_sell -> None
              | Coq3_Compilers.Coq_ident_fancy_addm -> None))
        | Coq3_Compilers.Coq_pattern_ident_comment _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_comment_no_keep _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_value_barrier ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Nat_succ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Nat_pred ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Nat_max ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Nat_mul ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Nat_add ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Nat_sub ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Nat_eqb ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_nil _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_cons _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_tt ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_pair (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fst (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_snd (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_prod_rect (_, _, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_bool_rect _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_bool_rect_nodep _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_nat_rect _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_eager_nat_rect_arrow (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_list_rect (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_eager_list_rect (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_list_rect_arrow (_, _, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_eager_list_rect_arrow (_, _, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_list_case (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_length _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_seq ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_firstn _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_skipn _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_repeat _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_combine (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_map (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_app _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_rev _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_flat_map (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_partition _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_filter _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_fold_right (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_update_nth _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_List_nth_default _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_eager_List_nth_default _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_add ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_mul ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_pow ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_sub ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_opp ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_div ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_modulo ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_eqb ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_leb ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_ltb ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_geb ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_gtb ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_log2 ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_log2_up ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_of_nat ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_to_nat ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_shiftr ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_shiftl ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_land ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_lor ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_min ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_max ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_mul_split ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_mul_high ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_ltz ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_zselect ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_add_modulo ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_bneg ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_lxor ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_rshi ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_cc_m ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_cast ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Z_cast2 ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Some _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_None _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_option_rect (_, _) ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
             Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_Build_zrange ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_zrange_rect _ ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_add ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_addc ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_sub ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_subb ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mulll ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mullh ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mulhl ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_mulhh ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_rshi ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_selc ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_selm ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_sell ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> Some (Obj.magic ())
           | Coq3_Compilers.Coq_ident_fancy_addm -> None)
        | Coq3_Compilers.Coq_pattern_ident_fancy_addm ->
          (match idc with
           | Coq3_Compilers.Coq_ident_Literal (t0, x) ->
             (match t0 with
              | Coq3_Compilers.Z -> (fun _ -> None)
              | Coq3_Compilers.Coq_bool -> (fun _ -> None)
              | Coq3_Compilers.Coq_nat -> (fun _ -> None)
              | Coq3_Compilers.Coq_zrange -> (fun _ -> None)
              | Coq3_Compilers.Coq_string -> (fun _ -> None)) x
           | Coq3_Compilers.Coq_ident_comment _ -> None
           | Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
           | Coq3_Compilers.Coq_ident_value_barrier -> None
           | Coq3_Compilers.Coq_ident_Nat_succ -> None
           | Coq3_Compilers.Coq_ident_Nat_pred -> None
           | Coq3_Compilers.Coq_ident_Nat_max -> None
           | Coq3_Compilers.Coq_ident_Nat_mul -> None
           | Coq3_Compilers.Coq_ident_Nat_add -> None
           | Coq3_Compilers.Coq_ident_Nat_sub -> None
           | Coq3_Compilers.Coq_ident_Nat_eqb -> None
           | Coq3_Compilers.Coq_ident_nil _ -> None
           | Coq3_Compilers.Coq_ident_cons _ -> None
           | Coq3_Compilers.Coq_ident_tt -> None
           | Coq3_Compilers.Coq_ident_pair (_, _) -> None
           | Coq3_Compilers.Coq_ident_fst (_, _) -> None
           | Coq3_Compilers.Coq_ident_snd (_, _) -> None
           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_bool_rect _ -> None
           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
           | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
           | Coq3_Compilers.Coq_ident_list_case (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_length _ -> None
           | Coq3_Compilers.Coq_ident_List_seq -> None
           | Coq3_Compilers.Coq_ident_List_firstn _ -> None
           | Coq3_Compilers.Coq_ident_List_skipn _ -> None
           | Coq3_Compilers.Coq_ident_List_repeat _ -> None
           | Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_app _ -> None
           | Coq3_Compilers.Coq_ident_List_rev _ -> None
           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_partition _ -> None
           | Coq3_Compilers.Coq_ident_List_filter _ -> None
           | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
           | Coq3_Compilers.Coq_ident_List_update_nth _ -> None
           | Coq3_Compilers.Coq_ident_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
           | Coq3_Compilers.Coq_ident_Z_add -> None
           | Coq3_Compilers.Coq_ident_Z_mul -> None
           | Coq3_Compilers.Coq_ident_Z_pow -> None
           | Coq3_Compilers.Coq_ident_Z_sub -> None
           | Coq3_Compilers.Coq_ident_Z_opp -> None
           | Coq3_Compilers.Coq_ident_Z_div -> None
           | Coq3_Compilers.Coq_ident_Z_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_eqb -> None
           | Coq3_Compilers.Coq_ident_Z_leb -> None
           | Coq3_Compilers.Coq_ident_Z_ltb -> None
           | Coq3_Compilers.Coq_ident_Z_geb -> None
           | Coq3_Compilers.Coq_ident_Z_gtb -> None
           | Coq3_Compilers.Coq_ident_Z_log2 -> None
           | Coq3_Compilers.Coq_ident_Z_log2_up -> None
           | Coq3_Compilers.Coq_ident_Z_of_nat -> None
           | Coq3_Compilers.Coq_ident_Z_to_nat -> None
           | Coq3_Compilers.Coq_ident_Z_shiftr -> None
           | Coq3_Compilers.Coq_ident_Z_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_land -> None
           | Coq3_Compilers.Coq_ident_Z_lor -> None
           | Coq3_Compilers.Coq_ident_Z_min -> None
           | Coq3_Compilers.Coq_ident_Z_max -> None
           | Coq3_Compilers.Coq_ident_Z_mul_split -> None
           | Coq3_Compilers.Coq_ident_Z_mul_high -> None
           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
           | Coq3_Compilers.Coq_ident_Z_ltz -> None
           | Coq3_Compilers.Coq_ident_Z_zselect -> None
           | Coq3_Compilers.Coq_ident_Z_add_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
           | Coq3_Compilers.Coq_ident_Z_bneg -> None
           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
           | Coq3_Compilers.Coq_ident_Z_lxor -> None
           | Coq3_Compilers.Coq_ident_Z_rshi -> None
           | Coq3_Compilers.Coq_ident_Z_cc_m -> None
           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
           | Coq3_Compilers.Coq_ident_Z_cast -> None
           | Coq3_Compilers.Coq_ident_Z_cast2 -> None
           | Coq3_Compilers.Coq_ident_Some _ -> None
           | Coq3_Compilers.Coq_ident_None _ -> None
           | Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
           | Coq3_Compilers.Coq_ident_Build_zrange -> None
           | Coq3_Compilers.Coq_ident_zrange_rect _ -> None
           | Coq3_Compilers.Coq_ident_fancy_add -> None
           | Coq3_Compilers.Coq_ident_fancy_addc -> None
           | Coq3_Compilers.Coq_ident_fancy_sub -> None
           | Coq3_Compilers.Coq_ident_fancy_subb -> None
           | Coq3_Compilers.Coq_ident_fancy_mulll -> None
           | Coq3_Compilers.Coq_ident_fancy_mullh -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhl -> None
           | Coq3_Compilers.Coq_ident_fancy_mulhh -> None
           | Coq3_Compilers.Coq_ident_fancy_rshi -> None
           | Coq3_Compilers.Coq_ident_fancy_selc -> None
           | Coq3_Compilers.Coq_ident_fancy_selm -> None
           | Coq3_Compilers.Coq_ident_fancy_sell -> None
           | Coq3_Compilers.Coq_ident_fancy_addm -> Some (Obj.magic ()))

      (** val unify_unknown :
          Coq3_Compilers.base
          Compilers.Coq_pattern.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          Coq3_Compilers.pattern_ident -> Coq3_Compilers.ident -> __ option **)

      let unify_unknown =
        unify
     end
   end
 end

(** val nbe_rewrite_rulesT : (bool * __) list **)

let nbe_rewrite_rulesT =
  (false, __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((true,
    __) :: ((true, __) :: ((true, __) :: ((true, __) :: ((true,
    __) :: ((true, __) :: ((true, __) :: ((true, __) :: ((true,
    __) :: []))))))))))))))))))))))))

(** val unfold_value_barrier_rewrite_rulesT : (bool * __) list **)

let unfold_value_barrier_rewrite_rulesT =
  (false, __) :: []

(** val arith_rewrite_rulesT : z -> (bool * __) list **)

let arith_rewrite_rulesT _ =
  (false, __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val arith_with_casts_rewrite_rulesT : bool -> (bool * __) list **)

let arith_with_casts_rewrite_rulesT _ =
  (false, __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((true,
    __) :: ((true, __) :: ((true, __) :: ((true, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((true, __) :: ((false,
    __) :: []))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val strip_literal_casts_rewrite_rulesT : (bool * __) list **)

let strip_literal_casts_rewrite_rulesT =
  (false, __) :: []

(** val add_assoc_left_rewrite_rulesT : (bool * __) list **)

let add_assoc_left_rewrite_rulesT =
  (false, __) :: ((false, __) :: [])

(** val flatten_thunked_rects_rewrite_rulesT : (bool * __) list **)

let flatten_thunked_rects_rewrite_rulesT =
  (false, __) :: []

(** val relax_bitwidth_adc_sbb_rewrite_rulesT : z list -> (bool * __) list **)

let relax_bitwidth_adc_sbb_rewrite_rulesT _ =
  (false, __) :: ((false, __) :: ((false, __) :: ((false, __) :: [])))

(** val fancy_rewrite_rulesT : (bool * __) list **)

let fancy_rewrite_rulesT =
  []

(** val fancy_with_casts_rewrite_rulesT :
    (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
    (bool * __) list **)

let fancy_with_casts_rewrite_rulesT _ _ _ _ =
  (false, __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: []))))))))))))))))))))))))))))))))))))))))))))

(** val mul_split_rewrite_rulesT : z -> z -> (bool * __) list **)

let mul_split_rewrite_rulesT _ _ =
  (false, __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: []))))))))))))

(** val multiret_split_rewrite_rulesT : z -> z -> (bool * __) list **)

let multiret_split_rewrite_rulesT _ _ =
  (true, __) :: ((true, __) :: ((true, __) :: ((true, __) :: ((true,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
    __) :: ((true, __) :: ((true, __) :: []))))))))))))))))))

(** val noselect_rewrite_rulesT : z -> (bool * __) list **)

let noselect_rewrite_rulesT _ =
  (false, __) :: ((false, __) :: [])

module Coq11_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_rule_data) sigT list **)

    let rewrite_rules =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_pattern_ident_value_barrier)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.value_barrier x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        Coq3_Compilers.Coq_pattern_ident_Nat_succ)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_nat, (Obj.magic Nat.succ x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        Coq3_Compilers.Coq_pattern_ident_Nat_pred)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_nat, (Obj.magic Nat.pred x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_max)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_nat, (Obj.magic Nat.max x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_nat, (Obj.magic Nat.mul x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_nat, (Obj.magic Nat.add x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_nat, (Obj.magic Nat.sub x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_eqb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_bool, (Obj.magic Nat.eqb x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit);
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_pattern_ident_tt)) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit),
          Coq3_Compilers.Coq_ident_tt))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))),
        Coq3_Compilers.Coq_pattern_ident_List_seq)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 ->
          Compilers.Coq_ident.reify_list
            { Compilers.Coq_ident.ident_Literal = (fun t0 x1 ->
            Coq3_Compilers.Coq_ident_Literal (t0, x1));
            Compilers.Coq_ident.ident_nil = (fun t0 ->
            Coq3_Compilers.Coq_ident_nil t0);
            Compilers.Coq_ident.ident_cons = (fun t0 ->
            Coq3_Compilers.Coq_ident_cons t0);
            Compilers.Coq_ident.ident_Some = (fun t0 ->
            Coq3_Compilers.Coq_ident_Some t0);
            Compilers.Coq_ident.ident_None = (fun t0 ->
            Coq3_Compilers.Coq_ident_None t0);
            Compilers.Coq_ident.ident_pair = (fun a b ->
            Coq3_Compilers.Coq_ident_pair (a, b));
            Compilers.Coq_ident.ident_tt = Coq3_Compilers.Coq_ident_tt }
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)
            (map (fun v -> Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, (Obj.magic v))))) (seq x x0)))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.add x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.mul x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_pow)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.pow x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.sub x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.opp x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_div)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.div x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_modulo)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.modulo x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_eqb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.eqb x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_leb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.leb x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_ltb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.ltb x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_geb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.geb x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_gtb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.gtb x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_log2)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.log2 x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_log2_up)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.log2_up x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_of_nat)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.of_nat x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        Coq3_Compilers.Coq_pattern_ident_Z_to_nat)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_nat, (Obj.magic Coq_Z.to_nat x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.shiftr x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.shiftl x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.coq_land x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.coq_lor x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_min)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.min x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_max)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.max x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 ->
          let (a, b) = Coq1_Z.mul_split x x0 x1 in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_high)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.mul_high x x0 x1)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 ->
          let (a, b) = Coq1_Z.add_get_carry_full x x0 x1 in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.add_with_carry x x0 x1)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 ->
          let (a, b) = Coq1_Z.add_with_get_carry_full x x0 x1 x2 in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 ->
          let (a, b) = Coq1_Z.sub_get_borrow_full x x0 x1 in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 ->
          let (a, b) = Coq1_Z.sub_with_get_borrow_full x x0 x1 x2 in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.ltz x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.zselect x x0 x1)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_modulo)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.add_modulo x x0 x1)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.truncating_shiftl x x0 x1)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_bneg)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.bneg x)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.lnot_modulo x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lxor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_Z.coq_lxor x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_rshi)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.rshi x x0 x1 x2)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cc_m)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.cc_m x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.combine_at_bitwidth x x0 x1)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.cast x x0)))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 ->
          let (a, b) = Coq_ident.cast2 (x, x0) (x1, x2) in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_pattern_ident_Build_zrange)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
          (Coq3_Compilers.Coq_zrange,
          (Obj.magic { lower = x; upper = x0 })))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_fancy_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 ->
          let (a, b) = Coq_ident.Coq_fancy.add ((x, x0), (x1, x2)) in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_pattern_ident_fancy_addc)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 x3 ->
          let (a, b) = Coq_ident.Coq_fancy.addc ((x, x0), ((x1, x2), x3)) in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_fancy_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 ->
          let (a, b) = Coq_ident.Coq_fancy.sub ((x, x0), (x1, x2)) in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_pattern_ident_fancy_subb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 x3 ->
          let (a, b) = Coq_ident.Coq_fancy.subb ((x, x0), ((x1, x2), x3)) in
          Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic a))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic b)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mulll)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.mulll (x, (x0, x1)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mullh)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.mullh (x, (x0, x1)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mulhl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.mulhl (x, (x0, x1)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mulhh)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.mulhh (x, (x0, x1)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_rshi)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.rshi ((x, x0), (x1, x2)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_selc)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.selc ((x, x0), x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_selm)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 x2 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.selm (x, ((x0, x1), x2)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_sell)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.sell ((x, x0), x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_addm)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq_ident.Coq_fancy.addm ((x, x0), x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 _ x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x1))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x _ t1 ->
          if t1
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))), x)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   Coq3_Compilers.Coq_ident_tt)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 t1 ->
          if t1
          then None
          else Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))), x0)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   Coq3_Compilers.Coq_ident_tt))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_prod_rect
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
            (Compilers.Coq_type.Coq_base t0))))), x0)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            t2), x2))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_repeat
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 t1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_eager_nat_rect
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v)))))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, t1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_app
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_eager_list_rect (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x0)))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_fold_right
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x2 x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base t0))))))),
            (Coq3_Compilers.Coq_ident_eager_list_rect (t1, t0)))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0), (fun _ ->
            Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
            x0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0))))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), x)), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), v)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v0)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_rect
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x2 x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
            (Compilers.Coq_type.Coq_base t1) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t1))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t1))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t1))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1))))))),
            (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t1))), x)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base t1))))))), x0)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_rect_arrow
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
        XH)))))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x3 x4 _ ->
              Coq3_Compilers.try_make_base_transport_cps x3 x4)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
            (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
            (Compilers.Coq_type.Coq_base t0))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t2),
            (Compilers.Coq_type.Coq_base t0))))))))),
            (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t1, t2, t0)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))), x)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
            t0))))))))), x0)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), x1)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t2),
            x2))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_case
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq3_Compilers.Coq_pattern_ident_nil
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 x _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), x)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            Coq3_Compilers.Coq_ident_tt))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_case
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_cons
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 _ x1 x2 x3 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)) false
            (Compilers.Coq_type.Coq_base t1) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base t1))))), x1)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
            x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_map
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Coq3_Compilers.Coq_ident_eager_list_rect (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t1))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Coq3_Compilers.Coq_ident_nil t1))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
            (Coq3_Compilers.Coq_ident_cons t1))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            t0), v)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), v0)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_nat_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x x0 t1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))))),
            (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), x)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))))), x0)))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, t1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))))),
        (Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x x0 t2 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x2 x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
            (Compilers.Coq_type.Coq_base t1) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))))), (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0,
            t1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))))))), x0)))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, t2)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_nth_default
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x x0 t1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))))),
            (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, t1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_combine
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
            (Coq3_Compilers.Coq_ident_list_rect_arrow (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t1),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Coq3_Compilers.Coq_ident_nil
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))),
            (fun v -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))), (fun v0 ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun v1 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))),
            (Coq3_Compilers.Coq_ident_list_case (t1,
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Coq3_Compilers.Coq_ident_nil
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))), (fun v2 ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun v3 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
            (Coq3_Compilers.Coq_ident_cons
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))),
            (Coq3_Compilers.Coq_ident_pair (t0, t1)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), v)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
            v2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))), v0)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), v3)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), v1)))))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x)))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), x0))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_firstn
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Coq3_Compilers.Coq_ident_nat_rect_arrow
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_list_case (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v1 ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v2 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), v)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, t1)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_skipn
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Coq3_Compilers.Coq_ident_nat_rect_arrow
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v ->
            Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v)))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_list_case (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v1 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), v)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, t1)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        (Coq3_Compilers.Coq_pattern_ident_List_length
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))))),
            (Coq3_Compilers.Coq_ident_list_rect (t0,
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (fun _ -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic O))))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))), (fun _ -> Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))), (fun _ -> Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), v)))))))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq3_Compilers.Coq_pattern_ident_List_rev
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_list_rect (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_List_app t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_flat_map
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
            (Coq3_Compilers.Coq_ident_list_rect (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t1))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Coq3_Compilers.Coq_ident_nil t1))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
            (Coq3_Compilers.Coq_ident_List_app t1))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)))), x)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
            v)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1)), v0)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_partition
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Coq3_Compilers.Coq_ident_list_rect (t0,
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_prod_rect
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v1 ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v2 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Coq3_Compilers.Coq_ident_bool_rect
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))), x)), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), v0)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_filter
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_list_rect (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_bool_rect
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)))), x)), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v)))))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_update_nth
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
            (Coq3_Compilers.Coq_ident_nat_rect_arrow
            ((Compilers.Coq_base.Coq_type.Coq_list t0),
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_list_case (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v0 ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v1 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t0))), x)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            t0), v0)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v)))))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
            (Coq3_Compilers.Coq_ident_list_case (t0,
            (Compilers.Coq_base.Coq_type.Coq_list t0))))),
            (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
            Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Coq3_Compilers.Coq_ident_nil t0))))))), (Compilers.Coq_expr.Abs
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v1 ->
            Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v2 ->
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
            (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), v1)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)))), v)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, t1)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) })) :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_tt,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        O)))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        (Some (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_value_barrier,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Nat_succ,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Nat_pred,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S O)),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O)))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_log2,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_log2_up,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_of_nat,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_to_nat,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_bneg,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_add,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_addc,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_sub,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_subb,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S O))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_mulll,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S O)))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_mullh,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S O))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_mulhl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_mulhh,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_rshi,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_selc,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_selm,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_sell,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fancy_addm,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_fst,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_snd,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_length,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_rev,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])))))))))))))))))))))))))),
        (Some (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Nat_max,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S O))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Nat_mul,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S O)))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Nat_add,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S O))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Nat_sub,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S
        O)))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Nat_eqb,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S
        O))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_seq,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S O))))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S O)))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_mul,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S O))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_pow,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S O)))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S O))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_div,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_modulo,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O)))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_eqb,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_leb,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_ltb,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_geb,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_gtb,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_lor,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_min,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_max,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_ltz,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_lnot_modulo,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_lxor,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_cc_m,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_cast2,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Build_zrange,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_prod_rect,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_List_repeat,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_List_app,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_map,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_combine,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_firstn,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_skipn,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_flat_map,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_partition,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_List_filter,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])))))))))))))))))))))))))))))))))))))))),
        (Some (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_mul_split,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S O)))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_mul_high,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S O))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S O)))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add_with_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S O))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_zselect,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add_modulo,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_truncating_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_bool_rect,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_List_fold_right,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_list_rect,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_list_case,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_nil,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_cons,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_nat_rect,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_List_nth_default,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_List_update_nth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])))))))))))))))),
        (Some (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S O)))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_rshi,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_list_rect_arrow,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_nat_rect_arrow,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []))))), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_rule_data,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_rule_data) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
          (Obj.magic Coq1_Z.value_barrier x)))))) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic Nat.succ x)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic Nat.pred x)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic Nat.max x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic Nat.mul x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic Nat.add x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic Nat.sub x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_bool, (Obj.magic Nat.eqb x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            Coq3_Compilers.Coq_ident_tt))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 ->
            Compilers.Coq_ident.reify_list
              { Compilers.Coq_ident.ident_Literal = (fun t0 x1 ->
              Coq3_Compilers.Coq_ident_Literal (t0, x1));
              Compilers.Coq_ident.ident_nil = (fun t0 ->
              Coq3_Compilers.Coq_ident_nil t0);
              Compilers.Coq_ident.ident_cons = (fun t0 ->
              Coq3_Compilers.Coq_ident_cons t0);
              Compilers.Coq_ident.ident_Some = (fun t0 ->
              Coq3_Compilers.Coq_ident_Some t0);
              Compilers.Coq_ident.ident_None = (fun t0 ->
              Coq3_Compilers.Coq_ident_None t0);
              Compilers.Coq_ident.ident_pair = (fun a b ->
              Coq3_Compilers.Coq_ident_pair (a, b));
              Compilers.Coq_ident.ident_tt = Coq3_Compilers.Coq_ident_tt }
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)
              (map (fun v -> Compilers.Coq_expr.Ident
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
                (Coq3_Compilers.Coq_nat, (Obj.magic v))))) (seq x x0)))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.add x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.mul x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.pow x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.sub x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.opp x)))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.div x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.modulo x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.eqb x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.leb x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.ltb x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.geb x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_bool, (Obj.magic Coq_Z.gtb x x0)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.log2 x)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.log2_up x)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.of_nat x)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_nat, (Obj.magic Coq_Z.to_nat x)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.shiftr x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.shiftl x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.coq_land x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.coq_lor x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.min x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.max x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 ->
            let (a, b) = Coq1_Z.mul_split x x0 x1 in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.mul_high x x0 x1)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 ->
            let (a, b) = Coq1_Z.add_get_carry_full x x0 x1 in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.add_with_carry x x0 x1)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 ->
            let (a, b) = Coq1_Z.add_with_get_carry_full x x0 x1 x2 in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 ->
            let (a, b) = Coq1_Z.sub_get_borrow_full x x0 x1 in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 ->
            let (a, b) = Coq1_Z.sub_with_get_borrow_full x x0 x1 x2 in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.ltz x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.zselect x x0 x1)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.add_modulo x x0 x1)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.truncating_shiftl x x0 x1)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.bneg x)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.lnot_modulo x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.coq_lxor x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.rshi x x0 x1 x2)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.cc_m x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq1_Z.combine_at_bitwidth x x0 x1)))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.cast x x0)))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 ->
            let (a, b) = Coq_ident.cast2 (x, x0) (x1, x2) in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange,
            (Obj.magic { lower = x; upper = x0 })))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 ->
            let (a, b) = Coq_ident.Coq_fancy.add ((x, x0), (x1, x2)) in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 x3 ->
            let (a, b) = Coq_ident.Coq_fancy.addc ((x, x0), ((x1, x2), x3)) in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 ->
            let (a, b) = Coq_ident.Coq_fancy.sub ((x, x0), (x1, x2)) in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 x3 ->
            let (a, b) = Coq_ident.Coq_fancy.subb ((x, x0), ((x1, x2), x3)) in
            Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic a))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic b)))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.mulll (x, (x0, x1)))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.mullh (x, (x0, x1)))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.mulhl (x, (x0, x1)))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.mulhh (x, (x0, x1)))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.rshi ((x, x0), (x1, x2)))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.selc ((x, x0), x1))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 x2 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.selm (x, ((x0, x1), x2)))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.sell ((x, x0), x1))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = false;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = false;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x x0 x1 -> Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_ident.Coq_fancy.addm ((x, x0), x1))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ x0 _ -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x1)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x0))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 _ x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x0)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x1))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x _ t1 ->
            if t1
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base t0)
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0))), x)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     Coq3_Compilers.Coq_ident_tt)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ x0 t1 ->
            if t1
            then None
            else Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base t0)
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0))), x0)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     Coq3_Compilers.Coq_ident_tt))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t0))))), x0)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              t2), x2))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 t1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x1)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_eager_nat_rect
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x0)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v)))))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, t1))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x x0 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_eager_list_rect (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x0)))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x2 x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t0))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t0))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t0))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t0))))))),
              (Coq3_Compilers.Coq_ident_eager_list_rect (t1, t0)))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0), (fun _ ->
              Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t0))))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t0))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_base t0), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t0))))), x)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
              v)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              t0), v0)))))))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), x1))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x2 x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
              (Compilers.Coq_type.Coq_base t1) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t1))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t1))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t1))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base t1))))))),
              (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t1))), x)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t1))))))), x0)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x1))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x3 x4 _ ->
                Coq3_Compilers.try_make_base_transport_cps x3 x4)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t0))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t0))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t0))))))))),
              (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t1, t2,
              t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))), x)))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t0))))))))), x0)))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), x1)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t2),
              x2))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 x _ -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0))), x)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              Coq3_Compilers.Coq_ident_tt))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 _ x1 x2 x3 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x0)) false
              (Compilers.Coq_type.Coq_base t1) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base t1))))), x1)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x x0 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Coq3_Compilers.Coq_ident_eager_list_rect (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t1))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Coq3_Compilers.Coq_ident_nil t1))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
              (Coq3_Compilers.Coq_ident_cons t1))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))), x)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), v0)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x x0 t1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t0))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t0))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t0))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              t0))))))), (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t0))), x)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t0))))), x0)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, t1))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x x0 t2 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x2 x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
              (Compilers.Coq_type.Coq_base t1) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))))))))), (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow
              (t0, t1)))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))), x)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base t1))))))), x0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, t2)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x1))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x x0 t1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              t0))))))), (Coq3_Compilers.Coq_ident_eager_List_nth_default
              t0))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              t0), x)))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, t1))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x x0 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))))),
              (Coq3_Compilers.Coq_ident_list_rect_arrow (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t1),
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Coq3_Compilers.Coq_ident_nil
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))),
              (fun v -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
              (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))), (fun v0 ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun v1 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))),
              (Coq3_Compilers.Coq_ident_list_case (t1,
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Coq3_Compilers.Coq_ident_nil
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))), (fun v2 ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))), (fun v3 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
              (Coq3_Compilers.Coq_ident_cons
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))),
              (Coq3_Compilers.Coq_ident_pair (t0, t1)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              v)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              t1), v2)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))), v0)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), v3)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), v1)))))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), x0))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Coq3_Compilers.Coq_ident_nat_rect_arrow
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_list_case (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v1 ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v2 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), v)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, t1)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Coq3_Compilers.Coq_ident_nat_rect_arrow
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v ->
              Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v)))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_list_case (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v1 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), v)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, t1)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))))),
              (Coq3_Compilers.Coq_ident_list_rect (t0,
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Abs
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (fun _ -> Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, (Obj.magic O))))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))), (fun _ -> Compilers.Coq_expr.Abs
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))), (fun _ -> Compilers.Coq_expr.Abs
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))),
              Coq3_Compilers.Coq_ident_Nat_succ)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), v)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x0 x1)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_list_rect (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_List_app t0))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x x0 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))),
              (Coq3_Compilers.Coq_ident_list_rect (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t1))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Coq3_Compilers.Coq_ident_nil t1))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
              (Coq3_Compilers.Coq_ident_List_app t1))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))), x)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              v)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)), v0)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x x0 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Coq3_Compilers.Coq_ident_list_rect (t0,
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_prod_rect
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v1 ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v2 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Coq3_Compilers.Coq_ident_bool_rect
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))), x)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), v0)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x x0 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_list_rect (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_bool_rect
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))), x)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v)))))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) };
          Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x x0 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x1 x2)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))),
              (Coq3_Compilers.Coq_ident_nat_rect_arrow
              ((Compilers.Coq_base.Coq_type.Coq_list t0),
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_list_case (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v0 ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v1 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t0), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t0))), x)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v0)))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v1)))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v)))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))), (fun _ ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v0 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
              (Coq3_Compilers.Coq_ident_list_case (t0,
              (Compilers.Coq_base.Coq_type.Coq_list t0))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun _ ->
              Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Coq3_Compilers.Coq_ident_nil t0))))))),
              (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), (fun v1 ->
              Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), (fun v2 ->
              Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
              (Coq3_Compilers.Coq_ident_cons t0))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), v1)))),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)))), v)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v2)))))))))))),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), v0)))))))))))),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_nat, t1)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x0))))))) };
          Primitive.snd =
          () } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } }) }

    (** val all_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_pattern_ident_value_barrier)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        Coq3_Compilers.Coq_pattern_ident_Nat_succ)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        Coq3_Compilers.Coq_pattern_ident_Nat_pred)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_max)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_eqb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit);
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_pattern_ident_tt)) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))),
        Coq3_Compilers.Coq_pattern_ident_List_seq)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_pow)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_div)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_modulo)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_eqb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_leb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_ltb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_geb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_gtb)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_log2)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_log2_up)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_of_nat)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        Coq3_Compilers.Coq_pattern_ident_Z_to_nat)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_min)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_max)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_high)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_modulo)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_truncating_shiftl)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_bneg)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_lnot_modulo)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lxor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_rshi)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cc_m)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_pattern_ident_Build_zrange)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_fancy_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_pattern_ident_fancy_addc)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_fancy_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_pattern_ident_fancy_subb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mulll)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mullh)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mulhl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_mulhh)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_rshi)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_selc)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_selm)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_sell)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_fancy_addm)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_prod_rect
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_repeat
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_app
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_fold_right
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_rect
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_rect_arrow
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
        XH)))))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_case
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq3_Compilers.Coq_pattern_ident_nil
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_list_case
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_cons
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_map
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_nat_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))))),
        (Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_nth_default
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_combine
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_firstn
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_skipn
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))),
        (Coq3_Compilers.Coq_pattern_ident_List_length
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq3_Compilers.Coq_pattern_ident_List_rev
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_flat_map
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_partition
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_filter
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_List_update_nth
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
        XH)))))) } :: []))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
        (Obj.magic pr2_rewrite_rules)

    (** val rewrite_head :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head do_again _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Z)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Z,
                                        (Obj.magic Coq1_Z.value_barrier
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_value_barrier)), x))))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat))
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Coq_nat)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_nat)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Coq_nat,
                                        (Obj.magic Nat.succ
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
          x))))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat))
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Coq_nat)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_nat)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Coq_nat,
                                        (Obj.magic Nat.pred
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
          x))))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_nat))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Coq_nat)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1 in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2 in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Coq_nat)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_nat)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_nat,
                                               (Obj.magic Nat.max
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_nat))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Coq_nat)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1 in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2 in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Coq_nat)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_nat)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_nat,
                                               (Obj.magic Nat.mul
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_nat))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Coq_nat)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1 in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2 in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Coq_nat)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_nat)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_nat,
                                               (Obj.magic Nat.add
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_nat))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Coq_nat)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1 in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2 in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Coq_nat)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_nat)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_nat,
                                               (Obj.magic Nat.sub
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_nat))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Coq_nat)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1 in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2 in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Coq_nat)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_bool)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_bool,
                                               (Obj.magic Nat.eqb
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      sequence_return0
        (Compilers.Coq_base.try_make_transport_cps (fun _ x x0 _ ->
          Coq3_Compilers.try_make_base_transport_cps x x0)
          Compilers.Coq_base.Coq_type.Coq_unit
          Compilers.Coq_base.Coq_type.Coq_unit (fun tr ->
          match tr with
          | Some v ->
            Compilers.Coq_base.try_make_transport_cps (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)
              Compilers.Coq_base.Coq_type.Coq_unit
              Compilers.Coq_base.Coq_type.Coq_unit (fun tr' ->
              match tr' with
              | Some v0 ->
                Some
                  (Obj.magic (Coq_Compilers.UnderLets.Base
                    (v0
                      (v (Compilers.Coq_expr.Ident
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        Coq3_Compilers.Coq_ident_tt))))))
              | None -> None)
          | None -> None))
        (Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit),
          Coq3_Compilers.Coq_ident_tt))))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, x0) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t0))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH)))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t0)))
                                  (Coq3_Compilers.Coq_pattern_ident_fst
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_fst
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some v ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some _ ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b1 t0
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t0 t0
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                b1)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b1),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0))),
          (Coq3_Compilers.Coq_ident_fst (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, _) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t1))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t1)))
                                  (Coq3_Compilers.Coq_pattern_ident_snd
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_snd
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some _ ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b0 t1
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t1 t1
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                b0)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b0),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1))),
          (Coq3_Compilers.Coq_ident_snd (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x0 with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x1) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t3, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t3 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x3 y ->
                               match x3 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XI XH))))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XI XH))))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XI XH))))))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base t0),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base t1),
                               (Compilers.Coq_type.Coq_base t2))))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t2))))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base t0),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base t1),
                               (Compilers.Coq_type.Coq_base t2))))))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x3, _) =
                                  let (x3, _) = args0.Coq_Primitive.projT2 in
                                  x3
                                in
                                x3)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x3, _) =
                                  let (_, y) =
                                    let (x3, _) = args0.Coq_Primitive.projT2
                                    in
                                    x3
                                  in
                                  y
                                in
                                x3)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x3, _) =
                                   let (x3, _) = args0.Coq_Primitive.projT2 in
                                   x3
                                 in
                                 x3),
                               (let (x3, _) =
                                  let (_, y) =
                                    let (x3, _) = args0.Coq_Primitive.projT2
                                    in
                                    x3
                                  in
                                  y
                                in
                                x3)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, b0) = a in
                         let (a1, b1) = a0 in
                         let (_, b2) = a1 in
                         let (_, _) = b2 in
                         let (a2, _) = b1 in
                         let (_, _) = a2 in
                         let (_, b3) = b0 in
                         let (_, b4) = b3 in
                         let (a3, b5) = b in
                         let (a4, b6) = a3 in
                         let (_, b7) = a4 in
                         let (_, b8) = b7 in
                         let (_, _) = b8 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x3 y ->
                                match x3 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b6),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b5),
                              (Compilers.Coq_type.Coq_base b4))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b6,
                              b5))), (Compilers.Coq_type.Coq_base b4))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b6),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b5),
                              (Compilers.Coq_type.Coq_base b4))))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b6),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b5),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b6,
                              b5))))))), (Compilers.Coq_type.Coq_base b6))),
                              (Compilers.Coq_type.Coq_base b5)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base t0),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base t1),
                              (Compilers.Coq_type.Coq_base t2))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t2))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base t0),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base t1),
                              (Compilers.Coq_type.Coq_base t2))))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x3, _) =
                                 let (x3, _) = args0.Coq_Primitive.projT2 in
                                 x3
                               in
                               x3)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x3, _) =
                                 let (_, y) =
                                   let (x3, _) = args0.Coq_Primitive.projT2 in
                                   x3
                                 in
                                 y
                               in
                               x3)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x3, _) =
                                  let (x3, _) = args0.Coq_Primitive.projT2 in
                                  x3
                                in
                                x3),
                              (let (x3, _) =
                                 let (_, y) =
                                   let (x3, _) = args0.Coq_Primitive.projT2 in
                                   x3
                                 in
                                 y
                               in
                               x3)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH)), (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XI XH))))))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XI XH))))))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base t0),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base t1),
                                  (Compilers.Coq_type.Coq_base t2))))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t2)))))
                                  (Coq3_Compilers.Coq_pattern_ident_prod_rect
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XI XH))))
                                  (Coq3_Compilers.Coq_ident_prod_rect (t0,
                                  t1, t2))) (fun _ ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x3 x4 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x3 x4) t0 b6 (fun a5 ->
                                  match a5 with
                                  | Some x' ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) t1 b5 (fun a6 ->
                                      match a6 with
                                      | Some x'0 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) t2 b4 (fun a7 ->
                                          match a7 with
                                          | Some x'1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                XH)),
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                (XO XH))),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                XH),
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                (XO XH)))))))))
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (let (x3, _) =
                                                   let (x3, _) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   x3
                                                 in
                                                 x3)),
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (let (x3, _) =
                                                   let (_, y) =
                                                     let (x3, _) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     x3
                                                   in
                                                   y
                                                 in
                                                 x3)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                ((let (x3, _) =
                                                    let (x3, _) =
                                                      args0.Coq_Primitive.projT2
                                                    in
                                                    x3
                                                  in
                                                  x3),
                                                (let (x3, _) =
                                                   let (_, y) =
                                                     let (x3, _) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     x3
                                                   in
                                                   y
                                                 in
                                                 x3))))))))
                                                (Coq3_Compilers.Coq_pattern_ident_pair
                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                XH),
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                (XO XH))))
                                                (Coq3_Compilers.Coq_ident_pair
                                                ((let (x3, _) =
                                                    let (x3, _) =
                                                      args0.Coq_Primitive.projT2
                                                    in
                                                    x3
                                                  in
                                                  x3),
                                                (let (x3, _) =
                                                   let (_, y) =
                                                     let (x3, _) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     x3
                                                   in
                                                   y
                                                 in
                                                 x3)))) (fun _ ->
                                              Compilers.Coq_type.try_make_transport_cps
                                                (fun _ x3 x4 _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x5 x6 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x5 x6) x3 x4) s1
                                                (Compilers.Coq_type.Coq_base
                                                b6) (fun tro ->
                                                match tro with
                                                | Some v ->
                                                  Compilers.Coq_type.try_make_transport_cps
                                                    (fun _ x3 x4 _ ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x5 x6 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x5 x6) x3 x4) s0
                                                    (Compilers.Coq_type.Coq_base
                                                    b5) (fun tro0 ->
                                                    match tro0 with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4) b6 b6
                                                        (fun a8 ->
                                                        match a8 with
                                                        | Some x'2 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4) b5 b5
                                                            (fun a9 ->
                                                            match a9 with
                                                            | Some x'3 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x3 x4 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x3 x4) b4
                                                                b4
                                                                (fun a10 ->
                                                                match a10 with
                                                                | Some x'4 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b6
                                                                    b6
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b5
                                                                    b5
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b4
                                                                    t2
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) t2
                                                                    t2
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b4)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b4),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b6),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b4))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b6),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b4))))),
                                                                    (Obj.magic
                                                                    x'4
                                                                    (x'3
                                                                    (x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b6),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None -> None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t2),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
          (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2))), (fun x1 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
              x2)))))))))), x0))))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x1 with
             | Compilers.Coq_expr.Ident (t1, idc0) ->
               sequence
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x2 y ->
                           match x2 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool))))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base t0))))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))) with
                   | Some vars0 ->
                     let (a, _) = Obj.magic vars0 in
                     let (a0, b) = a in
                     let (a1, b0) = a0 in
                     let (a2, b1) = a1 in
                     let (_, _) = a2 in
                     let (a3, b2) = b1 in
                     let (_, _) = a3 in
                     let (_, _) = b2 in
                     let (_, _) = b0 in
                     let (_, b3) = b in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                            match x2 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base b3))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool))))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base t0))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x2, _) = args0.Coq_Primitive.projT1 in x2)))))
                     then bind1
                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))))))) (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base t0)))))))
                              (Coq3_Compilers.Coq_pattern_ident_bool_rect
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)) (Coq3_Compilers.Coq_ident_bool_rect t0))
                            (fun _ ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x2 x3 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x2
                                x3) Compilers.Coq_base.Coq_type.Coq_unit
                              Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                              match a4 with
                              | Some x' ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x2 x3 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x2 x3) t0 b3 (fun a5 ->
                                  match a5 with
                                  | Some x'0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x2 x3 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x2 x3)
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      (fun a6 ->
                                      match a6 with
                                      | Some _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3) t0 b3 (fun a7 ->
                                          match a7 with
                                          | Some _ ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_bool))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Coq_bool)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                (fun a8 ->
                                                match a8 with
                                                | Some x'1 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3) b3 b3 (fun a9 ->
                                                    match a9 with
                                                    | Some x'2 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        (fun a10 ->
                                                        match a10 with
                                                        | Some _ ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3) b3 b3
                                                            (fun a11 ->
                                                            match a11 with
                                                            | Some _ ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x2 x3 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x2 x3) b3
                                                                t0 (fun tr ->
                                                                match tr with
                                                                | Some v ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t0
                                                                    t0
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))),
                                                                    (Obj.magic
                                                                    x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    Coq3_Compilers.Coq_ident_tt)))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None))
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x2 y ->
                           match x2 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool))))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base t0))))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))) with
                   | Some vars0 ->
                     let (a, _) = Obj.magic vars0 in
                     let (a0, b) = a in
                     let (a1, b0) = a0 in
                     let (a2, b1) = a1 in
                     let (_, _) = a2 in
                     let (a3, b2) = b1 in
                     let (_, _) = a3 in
                     let (_, _) = b2 in
                     let (_, _) = b0 in
                     let (_, b3) = b in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                            match x2 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base b3))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool))))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base t0))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x2, _) = args0.Coq_Primitive.projT1 in x2)))))
                     then bind1
                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))))))) (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base t0)))))))
                              (Coq3_Compilers.Coq_pattern_ident_bool_rect
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)) (Coq3_Compilers.Coq_ident_bool_rect t0))
                            (fun _ ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x2 x3 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x2
                                x3) Compilers.Coq_base.Coq_type.Coq_unit
                              Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                              match a4 with
                              | Some _ ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x2 x3 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x2 x3) t0 b3 (fun a5 ->
                                  match a5 with
                                  | Some _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x2 x3 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x2 x3)
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      (fun a6 ->
                                      match a6 with
                                      | Some x' ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3) t0 b3 (fun a7 ->
                                          match a7 with
                                          | Some x'0 ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_bool))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Coq_bool)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                (fun a8 ->
                                                match a8 with
                                                | Some _ ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3) b3 b3 (fun a9 ->
                                                    match a9 with
                                                    | Some _ ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        (fun a10 ->
                                                        match a10 with
                                                        | Some x'1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3) b3 b3
                                                            (fun a11 ->
                                                            match a11 with
                                                            | Some x'2 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x2 x3 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x2 x3) b3
                                                                t0 (fun tr ->
                                                                match tr with
                                                                | Some v ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t0
                                                                    t0
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2
                                                                    then None
                                                                    else 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))),
                                                                    (Obj.magic
                                                                    x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x0)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    Coq3_Compilers.Coq_ident_tt))))))
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None))
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))))),
          (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1))))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x1 with
             | Compilers.Coq_expr.Ident (t1, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x2 y ->
                         match x2 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))))))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))))))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat))))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base t0))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base t0),
                         (Compilers.Coq_type.Coq_base t0))))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_base t0))))))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base t0))))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base t0),
                         (Compilers.Coq_type.Coq_base t0))))))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))) with
                 | Some vars0 ->
                   let (a, _) = Obj.magic vars0 in
                   let (a0, b) = a in
                   let (a1, b0) = a0 in
                   let (a2, b1) = a1 in
                   let (_, _) = a2 in
                   let (a3, b2) = b1 in
                   let (_, b3) = a3 in
                   let (_, _) = b3 in
                   let (_, _) = b2 in
                   let (_, _) = b0 in
                   let (_, b4) = b in
                   let (_, b5) = b4 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                          match x2 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base b5))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base b5),
                        (Compilers.Coq_type.Coq_base b5))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_base b5))))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base b5))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base b5),
                        (Compilers.Coq_type.Coq_base b5))))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat))))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base t0))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_base t0))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_base t0))))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base t0))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_base t0))))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x2, _) = args0.Coq_Primitive.projT1 in x2)))))
                   then bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)))), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)))))), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)))))))) (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            Compilers.Coq_base.Coq_type.Coq_unit),
                            (Compilers.Coq_type.Coq_base t0))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base t0),
                            (Compilers.Coq_type.Coq_base t0))))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base t0)))))))
                            (Coq3_Compilers.Coq_pattern_ident_nat_rect
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)) (Coq3_Compilers.Coq_ident_nat_rect t0))
                          (fun _ ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x2 x3 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x2 x3)
                            Compilers.Coq_base.Coq_type.Coq_unit
                            Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                            match a4 with
                            | Some x' ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x2 x3 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x2
                                  x3) t0 b5 (fun a5 ->
                                match a5 with
                                | Some x'0 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x2 x3 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x2 x3)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Coq_nat)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Coq_nat) (fun a6 ->
                                    match a6 with
                                    | Some x'1 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x2 x3 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x2 x3) t0 b5 (fun a7 ->
                                        match a7 with
                                        | Some x'2 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x2 x3) t0 b5 (fun a8 ->
                                            match a8 with
                                            | Some x'3 ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x2, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x2)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Coq_nat)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x2, _) =
                                                      args0.Coq_Primitive.projT1
                                                    in
                                                    x2),
                                                  (let (x2, _) =
                                                     let (_, y) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x2)))) (fun xv ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x2 x3 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x2 x3)
                                                  Compilers.Coq_base.Coq_type.Coq_unit
                                                  Compilers.Coq_base.Coq_type.Coq_unit
                                                  (fun a9 ->
                                                  match a9 with
                                                  | Some x'4 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x2 x3 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x2 x3) b5 b5
                                                      (fun a10 ->
                                                      match a10 with
                                                      | Some x'5 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x2 x3 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x2 x3)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)
                                                          (fun a11 ->
                                                          match a11 with
                                                          | Some x'6 ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x2 x3 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x2 x3) b5 b5
                                                              (fun a12 ->
                                                              match a12 with
                                                              | Some x'7 ->
                                                                Compilers.Coq_base.try_make_transport_cps
                                                                  (fun _ x2 x3 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) b5
                                                                  b5
                                                                  (fun a13 ->
                                                                  match a13 with
                                                                  | Some x'8 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) b5
                                                                    t0
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t0
                                                                    t0
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))))))),
                                                                    (Coq3_Compilers.Coq_ident_eager_nat_rect
                                                                    b5))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))),
                                                                    (Obj.magic
                                                                    x'5
                                                                    (x'4
                                                                    (x'0
                                                                    (x' x)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b5),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b5))))),
                                                                    (Obj.magic
                                                                    x'8
                                                                    (x'7
                                                                    (x'6
                                                                    (x'3
                                                                    (x'2
                                                                    (x'1 x0)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_nat,
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                  | None ->
                                                                    None)
                                                              | None -> None)
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))))),
          (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0))), (fun x2 -> Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t0), (fun x3 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1))))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 ->
        sequence_return0
          (match x1 with
           | Compilers.Coq_expr.Ident (t2, idc0) ->
             bind1
               (Obj.magic
                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                 t2 idc0 Coq3_Compilers.Coq_raw_ident_Literal) (fun args0 ->
               match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                       (fun x3 y ->
                       match x3 with
                       | Coq3_Compilers.Z ->
                         (match y with
                          | Coq3_Compilers.Z -> true
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_bool ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> true
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_nat ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> true
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_zrange ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> true
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_string ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> true))
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                       XH))))), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                       XH))))), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                       XH))))))))), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                       XH))))))))))), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                       XH))))))), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                       XH))))), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                       XH))))))))))), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)))),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                       XH)))) (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t1))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t1))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t1))))))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t1))))))))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t1))))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t1))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t1))))))))),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       (let (x3, _) = args0.Coq_Primitive.projT1 in x3))))),
                       (Compilers.Coq_type.Coq_base t0))) with
               | Some vars0 ->
                 let (a, b) = Obj.magic vars0 in
                 let (a0, _) = a in
                 let (a1, b0) = a0 in
                 let (a2, b1) = a1 in
                 let (a3, b2) = a2 in
                 let (_, _) = a3 in
                 let (a4, b3) = b2 in
                 let (_, b4) = a4 in
                 let (a5, b5) = b4 in
                 let (_, _) = a5 in
                 let (_, _) = b5 in
                 let (_, b6) = b3 in
                 let (_, _) = b6 in
                 let (_, _) = b1 in
                 let (_, b7) = b0 in
                 let (a6, b8) = b7 in
                 let (_, _) = a6 in
                 let (_, b9) = b8 in
                 if Compilers.Coq_type.type_beq
                      (Compilers.Coq_base.Coq_type.type_beq (fun x3 y ->
                        match x3 with
                        | Coq3_Compilers.Z ->
                          (match y with
                           | Coq3_Compilers.Z -> true
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_bool ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> true
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_nat ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> true
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_zrange ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> true
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_string ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> true)))
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b9))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b9))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b9))))))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b9))))))))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b9))))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b9))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b9))))))))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)))),
                      (Compilers.Coq_type.Coq_base b)))
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t1))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t1))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t1))))))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t1))))))))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t1))))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t1))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t1))))))))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      (let (x3, _) = args0.Coq_Primitive.projT1 in x3))))),
                      (Compilers.Coq_type.Coq_base t0)))
                 then bind1
                        (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          (XO XH))))), (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_nat)),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          (XO XH))))), (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          (XO XH))))))))), (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_nat)),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          (XO XH))))))))))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base t0),
                          (Compilers.Coq_type.Coq_base t1))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_nat)),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base t0),
                          (Compilers.Coq_type.Coq_base t1))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base t0),
                          (Compilers.Coq_type.Coq_base t1))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_nat)),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base t0),
                          (Compilers.Coq_type.Coq_base t1)))))))))
                          (Coq3_Compilers.Coq_pattern_ident_nat_rect_arrow
                          ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH),
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          (XO XH)))) (Coq3_Compilers.Coq_ident_nat_rect_arrow
                          (t0, t1))) (fun _ ->
                        Compilers.Coq_base.try_make_transport_cps
                          (fun _ x3 x4 _ ->
                          Coq3_Compilers.try_make_base_transport_cps x3 x4)
                          t0 b (fun a7 ->
                          match a7 with
                          | Some x' ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x3 x4 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x3
                                x4) t1 b9 (fun a8 ->
                              match a8 with
                              | Some x'0 ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x3 x4 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x3 x4)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_nat)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_nat) (fun a9 ->
                                  match a9 with
                                  | Some x'1 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) t0 b (fun a10 ->
                                      match a10 with
                                      | Some x'2 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) t1 b9 (fun a11 ->
                                          match a11 with
                                          | Some x'3 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x3 x4 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x3 x4) t0 b (fun a12 ->
                                              match a12 with
                                              | Some x'4 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x3 x4 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x3 x4) t1 b9 (fun a13 ->
                                                  match a13 with
                                                  | Some x'5 ->
                                                    bind1
                                                      (Obj.magic
                                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_nat))
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x3, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x3)))
                                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                                        Coq3_Compilers.Coq_nat)
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        ((let (x3, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x3),
                                                        (let (x3, _) =
                                                           let (_, y) =
                                                             args0.Coq_Primitive.projT2
                                                           in
                                                           y
                                                         in
                                                         x3)))) (fun xv ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4) t0 b
                                                        (fun tro ->
                                                        match tro with
                                                        | Some v ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4) b b
                                                            (fun a14 ->
                                                            match a14 with
                                                            | Some x'6 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x3 x4 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x3 x4) b9
                                                                b9
                                                                (fun a15 ->
                                                                match a15 with
                                                                | Some x'7 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)
                                                                    (fun a16 ->
                                                                    match a16 with
                                                                    | Some x'8 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b
                                                                    b
                                                                    (fun a17 ->
                                                                    match a17 with
                                                                    | Some x'9 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b9
                                                                    b9
                                                                    (fun a18 ->
                                                                    match a18 with
                                                                    | Some x'10 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b
                                                                    b
                                                                    (fun a19 ->
                                                                    match a19 with
                                                                    | Some x'11 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b9
                                                                    b9
                                                                    (fun a20 ->
                                                                    match a20 with
                                                                    | Some x'12 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b
                                                                    b
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b9
                                                                    t1
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) t1
                                                                    t1
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))))))))),
                                                                    (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow
                                                                    (b,
                                                                    b9)))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Obj.magic
                                                                    x'7
                                                                    (x'6
                                                                    (x'0
                                                                    (x' x)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b9))))))),
                                                                    (Obj.magic
                                                                    x'12
                                                                    (x'11
                                                                    (x'10
                                                                    (x'9
                                                                    (x'8
                                                                    (x'5
                                                                    (x'4
                                                                    (x'3
                                                                    (x'2
                                                                    (x'1 x0)))))))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_nat,
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Obj.magic
                                                                    v0
                                                                    (v x2)))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None)
                          | None -> None))
                 else None
               | None -> None)
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, _, _) -> None
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1), (fun x3 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x3)))))))), (Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))))), (fun x3 -> Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (fun x4 -> Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1), (fun x5 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
              Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
              t1))), x4)), x6))) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2))))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x2 y ->
                     match x2 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))))))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t1))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t1))))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_base t1))))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t1))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t1))))))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, b0) = a in
               let (a1, b1) = a0 in
               let (a2, b2) = a1 in
               let (_, _) = a2 in
               let (a3, b3) = b2 in
               let (_, b4) = a3 in
               let (_, b5) = b4 in
               let (_, _) = b5 in
               let (_, _) = b3 in
               let (_, _) = b1 in
               let (_, b6) = b0 in
               let (_, b7) = b6 in
               let (_, b8) = b7 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                      match x2 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base b8))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b8),
                    (Compilers.Coq_type.Coq_base b8))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base b8))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base b8))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b8),
                    (Compilers.Coq_type.Coq_base b8))))))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t1))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base t1))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    Compilers.Coq_base.Coq_type.Coq_unit),
                    (Compilers.Coq_type.Coq_base t1))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t1))))))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))))))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base t1))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t1),
                        (Compilers.Coq_type.Coq_base t1))))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base t1)))))))
                        (Coq3_Compilers.Coq_pattern_ident_list_rect
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        (XO XH)))) (Coq3_Compilers.Coq_ident_list_rect (t0,
                        t1))) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x2 x3 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x2 x3)
                        Compilers.Coq_base.Coq_type.Coq_unit
                        Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                        match a4 with
                        | Some x' ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x2 x3 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x2 x3)
                            t1 b8 (fun a5 ->
                            match a5 with
                            | Some x'0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x2 x3 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x2
                                  x3) t0 b (fun a6 ->
                                match a6 with
                                | Some x'1 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x2 x3 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x2 x3)
                                    (Compilers.Coq_base.Coq_type.Coq_list t0)
                                    (Compilers.Coq_base.Coq_type.Coq_list b)
                                    (fun a7 ->
                                    match a7 with
                                    | Some x'2 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x2 x3 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x2 x3) t1 b8 (fun a8 ->
                                        match a8 with
                                        | Some x'3 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x2 x3) t1 b8 (fun a9 ->
                                            match a9 with
                                            | Some x'4 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                t0)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                b) (fun tro ->
                                                match tro with
                                                | Some v ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    Compilers.Coq_base.Coq_type.Coq_unit
                                                    Compilers.Coq_base.Coq_type.Coq_unit
                                                    (fun a10 ->
                                                    match a10 with
                                                    | Some x'5 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3) b8 b8
                                                        (fun a11 ->
                                                        match a11 with
                                                        | Some x'6 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3) b b
                                                            (fun a12 ->
                                                            match a12 with
                                                            | Some x'7 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x2 x3 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x2 x3)
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)
                                                                (fun a13 ->
                                                                match a13 with
                                                                | Some x'8 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) b8
                                                                    b8
                                                                    (fun a14 ->
                                                                    match a14 with
                                                                    | Some x'9 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) b8
                                                                    b8
                                                                    (fun a15 ->
                                                                    match a15 with
                                                                    | Some x'10 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) b8
                                                                    t1
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t1
                                                                    t1
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b8),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b8),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b8),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))))))),
                                                                    (Coq3_Compilers.Coq_ident_eager_list_rect
                                                                    (b,
                                                                    b8)))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))),
                                                                    (Obj.magic
                                                                    x'6
                                                                    (x'5
                                                                    (x'0
                                                                    (x' x)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b8),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b8))))))),
                                                                    (Obj.magic
                                                                    x'10
                                                                    (x'9
                                                                    (x'8
                                                                    (x'7
                                                                    (x'4
                                                                    (x'3
                                                                    (x'2
                                                                    (x'1 x0)))))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Obj.magic
                                                                    v0
                                                                    (v x1)))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t1))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))))))),
          (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1))), (fun x3 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t1), (fun x4 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x2)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
              x4)))))))))))), x1))))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x3 y ->
                     match x3 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                     XH))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                     XH))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                     XH))))))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                     XH))))))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                     XH))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                     XH))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                     XH))))))))))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))) (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t2))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t2))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t2))))))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t2))))))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t2))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t2))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_base t2))))))))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                     (Compilers.Coq_type.Coq_base t1))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, b0) = a in
               let (a1, b1) = a0 in
               let (a2, b2) = a1 in
               let (a3, b3) = a2 in
               let (_, _) = a3 in
               let (a4, b4) = b3 in
               let (_, b5) = a4 in
               let (_, b6) = b5 in
               let (a5, b7) = b6 in
               let (_, _) = a5 in
               let (_, _) = b7 in
               let (_, b8) = b4 in
               let (_, _) = b8 in
               let (_, _) = b2 in
               let (_, b9) = b1 in
               let (_, b10) = b9 in
               let (a6, b11) = b10 in
               let (_, _) = a6 in
               let (_, b12) = b11 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x3 y ->
                      match x3 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b12))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b12))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b12))))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b12))))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b12))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b12))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b12))))))))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b0)))),
                    (Compilers.Coq_type.Coq_base b)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_base t2))))))))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                    (Compilers.Coq_type.Coq_base t1)))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                        XH))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                        XH))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                        XH))))))))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                        XH))))))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t1),
                        (Compilers.Coq_type.Coq_base t2))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t1),
                        (Compilers.Coq_type.Coq_base t2))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t1),
                        (Compilers.Coq_type.Coq_base t2))))))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t1),
                        (Compilers.Coq_type.Coq_base t2)))))))))
                        (Coq3_Compilers.Coq_pattern_ident_list_rect_arrow
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        (XO XH)),
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XI
                        XH)))) (Coq3_Compilers.Coq_ident_list_rect_arrow (t0,
                        t1, t2))) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x3 x4 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x3 x4) t1
                        b (fun a7 ->
                        match a7 with
                        | Some x' ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x3 x4 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x3 x4)
                            t2 b12 (fun a8 ->
                            match a8 with
                            | Some x'0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x3 x4 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x3
                                  x4) t0 b0 (fun a9 ->
                                match a9 with
                                | Some x'1 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x3 x4 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x3 x4)
                                    (Compilers.Coq_base.Coq_type.Coq_list t0)
                                    (Compilers.Coq_base.Coq_type.Coq_list b0)
                                    (fun a10 ->
                                    match a10 with
                                    | Some x'2 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x3 x4 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x3 x4) t1 b (fun a11 ->
                                        match a11 with
                                        | Some x'3 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x3 x4 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x3 x4) t2 b12 (fun a12 ->
                                            match a12 with
                                            | Some x'4 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x3 x4 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x3 x4) t1 b (fun a13 ->
                                                match a13 with
                                                | Some x'5 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x3 x4 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x3 x4) t2 b12
                                                    (fun a14 ->
                                                    match a14 with
                                                    | Some x'6 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4)
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        t0)
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        b0) (fun tro ->
                                                        match tro with
                                                        | Some v ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4) t1 b
                                                            (fun tro0 ->
                                                            match tro0 with
                                                            | Some v0 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x3 x4 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x3 x4) b b
                                                                (fun a15 ->
                                                                match a15 with
                                                                | Some x'7 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    b12 b12
                                                                    (fun a16 ->
                                                                    match a16 with
                                                                    | Some x'8 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b0
                                                                    b0
                                                                    (fun a17 ->
                                                                    match a17 with
                                                                    | Some x'9 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)
                                                                    (fun a18 ->
                                                                    match a18 with
                                                                    | Some x'10 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b
                                                                    b
                                                                    (fun a19 ->
                                                                    match a19 with
                                                                    | Some x'11 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    b12 b12
                                                                    (fun a20 ->
                                                                    match a20 with
                                                                    | Some x'12 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b
                                                                    b
                                                                    (fun a21 ->
                                                                    match a21 with
                                                                    | Some x'13 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    b12 b12
                                                                    (fun a22 ->
                                                                    match a22 with
                                                                    | Some x'14 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) b
                                                                    b
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    b12 t2
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4) t2
                                                                    t2
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))))))))),
                                                                    (Coq3_Compilers.Coq_ident_eager_list_rect_arrow
                                                                    (b0, b,
                                                                    b12)))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Obj.magic
                                                                    x'8
                                                                    (x'7
                                                                    (x'0
                                                                    (x' x)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b12))))))))),
                                                                    (Obj.magic
                                                                    x'14
                                                                    (x'13
                                                                    (x'12
                                                                    (x'11
                                                                    (x'10
                                                                    (x'9
                                                                    (x'6
                                                                    (x'5
                                                                    (x'4
                                                                    (x'3
                                                                    (x'2
                                                                    (x'1 x0)))))))))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b0)),
                                                                    (Obj.magic
                                                                    v1
                                                                    (v x1)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Obj.magic
                                                                    v2
                                                                    (v0 x2)))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2))))))))),
          (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2), (fun x3 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
              x3)))))))), (Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
          t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_base t2), (fun x6 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x3)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
              Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              t2))), x5)), x7))) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)),
          x2))))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x1 with
             | Compilers.Coq_expr.Ident (t2, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t2 idc0 Coq3_Compilers.Coq_raw_ident_nil) (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x2 y ->
                         match x2 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                         XH))))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                         XH))))))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                         XH))))))))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                         XH))))))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                         XH))))))))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))))) (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base t1))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base t0),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)),
                         (Compilers.Coq_type.Coq_base t1))))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)),
                         (Compilers.Coq_type.Coq_base t1))))))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         Compilers.Coq_base.Coq_type.Coq_unit),
                         (Compilers.Coq_type.Coq_base t1))))),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base t0),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)),
                         (Compilers.Coq_type.Coq_base t1))))))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list
                         (let (x2, _) =
                            let (x2, _) = args0.Coq_Primitive.projT2 in x2
                          in
                          x2))))) with
                 | Some vars0 ->
                   let (a, b) = Obj.magic vars0 in
                   let (a0, b0) = a in
                   let (a1, b1) = a0 in
                   let (a2, b2) = a1 in
                   let (_, _) = a2 in
                   let (a3, b3) = b2 in
                   let (_, b4) = a3 in
                   let (_, _) = b4 in
                   let (_, _) = b3 in
                   let (_, _) = b1 in
                   let (_, b5) = b0 in
                   let (_, b6) = b5 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                          match x2 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base b6))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base b),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)),
                        (Compilers.Coq_type.Coq_base b6))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)),
                        (Compilers.Coq_type.Coq_base b6))))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base b6))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base b),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)),
                        (Compilers.Coq_type.Coq_base b6))))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b))))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base t1))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base t1))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base t1))))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        Compilers.Coq_base.Coq_type.Coq_unit),
                        (Compilers.Coq_type.Coq_base t1))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base t1))))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (let (x2, _) =
                           let (x2, _) = args0.Coq_Primitive.projT2 in x2
                         in
                         x2)))))
                   then bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            (XO XH))))), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            (XO XH))))))), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            (XO XH))))))))) (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            Compilers.Coq_base.Coq_type.Coq_unit),
                            (Compilers.Coq_type.Coq_base t1))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base t0),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0)),
                            (Compilers.Coq_type.Coq_base t1))))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0)),
                            (Compilers.Coq_type.Coq_base t1)))))))
                            (Coq3_Compilers.Coq_pattern_ident_list_case
                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH),
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            (XO XH)))) (Coq3_Compilers.Coq_ident_list_case
                            (t0, t1))) (fun _ ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x2 x3 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x2 x3)
                            Compilers.Coq_base.Coq_type.Coq_unit
                            Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                            match a4 with
                            | Some x' ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x2 x3 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x2
                                  x3) t1 b6 (fun a5 ->
                                match a5 with
                                | Some x'0 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x2 x3 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x2 x3) t0 b (fun a6 ->
                                    match a6 with
                                    | Some _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x2 x3 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x2 x3)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        t0)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        b) (fun a7 ->
                                        match a7 with
                                        | Some _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x2 x3) t1 b6 (fun a8 ->
                                            match a8 with
                                            | Some _ ->
                                              bind1
                                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                  XH)))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  (let (x2, _) =
                                                     let (x2, _) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     x2
                                                   in
                                                   x2)))
                                                  (Coq3_Compilers.Coq_pattern_ident_nil
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                  XH))
                                                  (Coq3_Compilers.Coq_ident_nil
                                                  (let (x2, _) =
                                                     let (x2, _) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     x2
                                                   in
                                                   x2))) (fun _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x2 x3 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x2 x3)
                                                  Compilers.Coq_base.Coq_type.Coq_unit
                                                  Compilers.Coq_base.Coq_type.Coq_unit
                                                  (fun a9 ->
                                                  match a9 with
                                                  | Some x'1 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x2 x3 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x2 x3) b6 b6
                                                      (fun a10 ->
                                                      match a10 with
                                                      | Some x'2 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x2 x3 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x2 x3) b b
                                                          (fun a11 ->
                                                          match a11 with
                                                          | Some _ ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x2 x3 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x2 x3)
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              b)
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              b) (fun a12 ->
                                                              match a12 with
                                                              | Some _ ->
                                                                Compilers.Coq_base.try_make_transport_cps
                                                                  (fun _ x2 x3 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) b6
                                                                  b6
                                                                  (fun a13 ->
                                                                  match a13 with
                                                                  | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) b6
                                                                    t1
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t1
                                                                    t1
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b6)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b6),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b6))),
                                                                    (Obj.magic
                                                                    x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    Coq3_Compilers.Coq_ident_tt)))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                  | None ->
                                                                    None)
                                                              | None -> None)
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x2) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, x3) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_cons)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x4 y ->
                               match x4 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               Compilers.Coq_base.Coq_type.Coq_unit),
                               (Compilers.Coq_type.Coq_base t1))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base t0),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_list t0)),
                               (Compilers.Coq_type.Coq_base t1))))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_list t0)),
                               (Compilers.Coq_type.Coq_base t1))))))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               Compilers.Coq_base.Coq_type.Coq_unit),
                               (Compilers.Coq_type.Coq_base t1))))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base t0),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_list t0)),
                               (Compilers.Coq_type.Coq_base t1))))))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x4, _) =
                                  let (x4, _) = args0.Coq_Primitive.projT2 in
                                  x4
                                in
                                x4)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_list
                               (let (x4, _) =
                                  let (x4, _) = args0.Coq_Primitive.projT2 in
                                  x4
                                in
                                x4))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_list
                               (let (x4, _) =
                                  let (x4, _) = args0.Coq_Primitive.projT2 in
                                  x4
                                in
                                x4))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, b0) = a in
                         let (a1, b1) = a0 in
                         let (a2, b2) = a1 in
                         let (_, _) = a2 in
                         let (a3, b3) = b2 in
                         let (_, b4) = a3 in
                         let (_, _) = b4 in
                         let (_, _) = b3 in
                         let (_, _) = b1 in
                         let (_, b5) = b0 in
                         let (_, b6) = b5 in
                         let (a4, b7) = b in
                         let (a5, _) = a4 in
                         let (_, b8) = a5 in
                         let (_, _) = b8 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x4 y ->
                                match x4 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base b6))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b7),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list b7)),
                              (Compilers.Coq_type.Coq_base b6))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list b7)),
                              (Compilers.Coq_type.Coq_base b6))))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base b6))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b7),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list b7)),
                              (Compilers.Coq_type.Coq_base b6))))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b7),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list b7)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list b7)))))),
                              (Compilers.Coq_type.Coq_base b7))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list b7))))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base t0),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list t0)),
                              (Compilers.Coq_type.Coq_base t1))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list t0)),
                              (Compilers.Coq_type.Coq_base t1))))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t1))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base t0),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list t0)),
                              (Compilers.Coq_type.Coq_base t1))))))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x4, _) =
                                 let (x4, _) = args0.Coq_Primitive.projT2 in
                                 x4
                               in
                               x4)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (let (x4, _) =
                                 let (x4, _) = args0.Coq_Primitive.projT2 in
                                 x4
                               in
                               x4))), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (let (x4, _) =
                                 let (x4, _) = args0.Coq_Primitive.projT2 in
                                 x4
                               in
                               x4))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH)), (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))))))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                  (Compilers.Coq_type.Coq_base t1))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base t0),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                                  (Compilers.Coq_type.Coq_base t1))))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                                  (Compilers.Coq_type.Coq_base t1)))))))
                                  (Coq3_Compilers.Coq_pattern_ident_list_case
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))
                                  (Coq3_Compilers.Coq_ident_list_case (t0,
                                  t1))) (fun _ ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x4 x5 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x4 x5)
                                  Compilers.Coq_base.Coq_type.Coq_unit
                                  Compilers.Coq_base.Coq_type.Coq_unit
                                  (fun a6 ->
                                  match a6 with
                                  | Some _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x4 x5 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x4 x5) t1 b6 (fun a7 ->
                                      match a7 with
                                      | Some _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x4 x5 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x4 x5) t0 b7 (fun a8 ->
                                          match a8 with
                                          | Some x' ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x4 x5 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x4 x5)
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              t0)
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              b7) (fun a9 ->
                                              match a9 with
                                              | Some x'0 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x4 x5 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x4 x5) t1 b6 (fun a10 ->
                                                  match a10 with
                                                  | Some x'1 ->
                                                    bind1
                                                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                        XH)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                        XH))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                        XH)))))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args0.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args0.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args0.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)))))))
                                                        (Coq3_Compilers.Coq_pattern_ident_cons
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                                        XH))
                                                        (Coq3_Compilers.Coq_ident_cons
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args0.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4))) (fun _ ->
                                                      Compilers.Coq_type.try_make_transport_cps
                                                        (fun _ x4 x5 _ ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x6 x7 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x6 x7) x4 x5) s1
                                                        (Compilers.Coq_type.Coq_base
                                                        b7) (fun tro ->
                                                        match tro with
                                                        | Some v ->
                                                          Compilers.Coq_type.try_make_transport_cps
                                                            (fun _ x4 x5 _ ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x6 x7 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x6 x7) x4 x5)
                                                            s0
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b7)) (fun tro0 ->
                                                            match tro0 with
                                                            | Some v0 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x4 x5 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x4 x5)
                                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                                (fun a11 ->
                                                                match a11 with
                                                                | Some _ ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5) b6
                                                                    b6
                                                                    (fun a12 ->
                                                                    match a12 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5) b7
                                                                    b7
                                                                    (fun a13 ->
                                                                    match a13 with
                                                                    | Some x'2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)
                                                                    (fun a14 ->
                                                                    match a14 with
                                                                    | Some x'3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5) b6
                                                                    b6
                                                                    (fun a15 ->
                                                                    match a15 with
                                                                    | Some x'4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5) b7
                                                                    b7
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5) b6
                                                                    t1
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5) t1
                                                                    t1
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b6)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b6),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b7),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b6))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b7),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b6))))),
                                                                    (Obj.magic
                                                                    x'4
                                                                    (x'3
                                                                    (x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x0)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b7),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b7)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x2))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base t1))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base t1))))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))))))),
          (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t1), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1))), (fun x2 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base t1), (fun x3 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x2)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1))))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x0 y ->
                     match x0 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (_, _) = a in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                      match x0 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat))))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat))))
                        (Coq3_Compilers.Coq_pattern_ident_List_length
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))
                        (Coq3_Compilers.Coq_ident_List_length t0)) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x0 x1 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x0 x1)
                        (Compilers.Coq_base.Coq_type.Coq_list t0)
                        (Compilers.Coq_base.Coq_type.Coq_list b) (fun tro ->
                        match tro with
                        | Some v ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_list b)
                            (Compilers.Coq_base.Coq_type.Coq_list b)
                            (fun tr ->
                            match tr with
                            | Some v0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat) (fun tr0 ->
                                match tr0 with
                                | Some v1 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x0 x1 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x0 x1)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Coq_nat)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Coq_nat) (fun tr' ->
                                    match tr' with
                                    | Some v2 ->
                                      Some
                                        (Coq_Compilers.UnderLets.splice
                                          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                              Coq3_Compilers.baseHasNat
                                              Coq3_Compilers.buildIdent
                                              Coq3_Compilers.buildEagerIdent
                                              Coq3_Compilers.toRestrictedIdent
                                              Coq3_Compilers.invertIdent
                                              Coq3_Compilers.baseHasNatCorrect
                                              (fun _ x0 x1 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x0 x1)) true
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat))
                                            (Compilers.Coq_expr.App
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)), (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_expr.App
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base b),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))))))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)), (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))),
                                            (Compilers.Coq_expr.App
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base b),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))))))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)), (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))))),
                                            (Compilers.Coq_expr.Ident
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base b),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))))))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)), (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))))))),
                                            (Coq3_Compilers.Coq_ident_list_rect
                                            (b,
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat))))),
                                            (Compilers.Coq_expr.Abs
                                            ((Compilers.Coq_type.Coq_base
                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (fun _ ->
                                            Compilers.Coq_expr.Ident
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Coq3_Compilers.Coq_ident_Literal
                                            (Coq3_Compilers.Coq_nat,
                                            (Obj.magic O))))))))),
                                            (Compilers.Coq_expr.Abs
                                            ((Compilers.Coq_type.Coq_base b),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))))),
                                            (fun _ -> Compilers.Coq_expr.Abs
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))),
                                            (fun _ -> Compilers.Coq_expr.Abs
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (fun v3 -> Compilers.Coq_expr.App
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_expr.Ident
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)))),
                                            Coq3_Compilers.Coq_ident_Nat_succ)),
                                            (Compilers.Coq_expr.Var
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_nat)),
                                            v3)))))))))))),
                                            (Compilers.Coq_expr.Var
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)), (Obj.magic v0 (v x)))))))
                                          (fun fv ->
                                          Coq_Compilers.UnderLets.splice
                                            (do_again
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_nat)
                                              (v1 fv)) (fun fv0 ->
                                            Coq_Compilers.UnderLets.Base
                                            (v2 fv0))))
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
          t0))), x))))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_nat))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Coq_nat)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Coq_nat)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_list
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat))
                                   (Compilers.Coq_base.Coq_type.Coq_list
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_nat)) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_list
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat))
                                       (Compilers.Coq_base.Coq_type.Coq_list
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_nat)) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v
                                               (Compilers.Coq_ident.reify_list
                                                 { Compilers.Coq_ident.ident_Literal =
                                                 (fun t2 x1 ->
                                                 Coq3_Compilers.Coq_ident_Literal
                                                 (t2, x1));
                                                 Compilers.Coq_ident.ident_nil =
                                                 (fun t2 ->
                                                 Coq3_Compilers.Coq_ident_nil
                                                 t2);
                                                 Compilers.Coq_ident.ident_cons =
                                                 (fun t2 ->
                                                 Coq3_Compilers.Coq_ident_cons
                                                 t2);
                                                 Compilers.Coq_ident.ident_Some =
                                                 (fun t2 ->
                                                 Coq3_Compilers.Coq_ident_Some
                                                 t2);
                                                 Compilers.Coq_ident.ident_None =
                                                 (fun t2 ->
                                                 Coq3_Compilers.Coq_ident_None
                                                 t2);
                                                 Compilers.Coq_ident.ident_pair =
                                                 (fun a b ->
                                                 Coq3_Compilers.Coq_ident_pair
                                                 (a, b));
                                                 Compilers.Coq_ident.ident_tt =
                                                 Coq3_Compilers.Coq_ident_tt }
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_nat)
                                                 (map (fun v1 ->
                                                   Compilers.Coq_expr.Ident
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_nat)),
                                                   (Coq3_Compilers.Coq_ident_Literal
                                                   (Coq3_Compilers.Coq_nat,
                                                   (Obj.magic v1)))))
                                                   (seq
                                                     (let (x1, _) = xv in x1)
                                                     (let (x1, _) = xv0 in x1)))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t1, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x1 y ->
                         match x1 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))))))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))))) (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
                 | Some vars0 ->
                   let (a, b) = Obj.magic vars0 in
                   let (a0, _) = a in
                   let (_, b0) = a0 in
                   let (_, _) = b0 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                          match x1 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b))))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0))))
                   then bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))))))) (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                            (Coq3_Compilers.Coq_pattern_ident_List_firstn
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)) (Coq3_Compilers.Coq_ident_List_firstn t0))
                          (fun _ ->
                          bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))
                              (Coq3_Compilers.Coq_pattern_ident_Literal
                              Coq3_Compilers.Coq_nat)
                              (Coq3_Compilers.Coq_ident_Literal
                              ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1),
                              (let (x1, _) =
                                 let (_, y) = args0.Coq_Primitive.projT2 in y
                               in
                               x1)))) (fun xv ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2) (Compilers.Coq_base.Coq_type.Coq_list t0)
                              (Compilers.Coq_base.Coq_type.Coq_list b)
                              (fun tro ->
                              match tro with
                              | Some v ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_list b)
                                  (Compilers.Coq_base.Coq_type.Coq_list b)
                                  (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      b)
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      t0) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          t0)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          t0) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            Some
                                              (Coq_Compilers.UnderLets.splice
                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                    Coq3_Compilers.baseHasNat
                                                    Coq3_Compilers.buildIdent
                                                    Coq3_Compilers.buildEagerIdent
                                                    Coq3_Compilers.toRestrictedIdent
                                                    Coq3_Compilers.invertIdent
                                                    Coq3_Compilers.baseHasNatCorrect
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)) true
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)) (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))))),
                                                  (Coq3_Compilers.Coq_ident_nat_rect_arrow
                                                  ((Compilers.Coq_base.Coq_type.Coq_list
                                                  b),
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun _ ->
                                                  Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Coq3_Compilers.Coq_ident_nil
                                                  b))))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))), (fun _ ->
                                                  Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))), (fun v3 ->
                                                  Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun v4 ->
                                                  Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Coq3_Compilers.Coq_ident_list_case
                                                  (b,
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun _ ->
                                                  Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Coq3_Compilers.Coq_ident_nil
                                                  b))))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))), (fun v5 ->
                                                  Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun v6 ->
                                                  Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Coq3_Compilers.Coq_ident_cons
                                                  b))),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  b), v5)))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))), v3)),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), v6)))))))))))),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), v4)))))))))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  (Coq3_Compilers.Coq_nat,
                                                  (let (x1, _) = xv in x1))))))),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Obj.magic v0 (v x0)))))))
                                                (fun fv ->
                                                Coq_Compilers.UnderLets.splice
                                                  (do_again
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t0) (v1 fv)) (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v2 fv0))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None)))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
          (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0))))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t1, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x1 y ->
                         match x1 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))))))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))))) (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
                 | Some vars0 ->
                   let (a, b) = Obj.magic vars0 in
                   let (a0, _) = a in
                   let (_, b0) = a0 in
                   let (_, _) = b0 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                          match x1 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b))))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0))))
                   then bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))))))) (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                            (Coq3_Compilers.Coq_pattern_ident_List_skipn
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)) (Coq3_Compilers.Coq_ident_List_skipn t0))
                          (fun _ ->
                          bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat))
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))
                              (Coq3_Compilers.Coq_pattern_ident_Literal
                              Coq3_Compilers.Coq_nat)
                              (Coq3_Compilers.Coq_ident_Literal
                              ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1),
                              (let (x1, _) =
                                 let (_, y) = args0.Coq_Primitive.projT2 in y
                               in
                               x1)))) (fun xv ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2) (Compilers.Coq_base.Coq_type.Coq_list t0)
                              (Compilers.Coq_base.Coq_type.Coq_list b)
                              (fun tro ->
                              match tro with
                              | Some v ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_list b)
                                  (Compilers.Coq_base.Coq_type.Coq_list b)
                                  (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      b)
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      t0) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          t0)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          t0) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            Some
                                              (Coq_Compilers.UnderLets.splice
                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                    Coq3_Compilers.baseHasNat
                                                    Coq3_Compilers.buildIdent
                                                    Coq3_Compilers.buildEagerIdent
                                                    Coq3_Compilers.toRestrictedIdent
                                                    Coq3_Compilers.invertIdent
                                                    Coq3_Compilers.baseHasNatCorrect
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)) true
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)) (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))))),
                                                  (Coq3_Compilers.Coq_ident_nat_rect_arrow
                                                  ((Compilers.Coq_base.Coq_type.Coq_list
                                                  b),
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun v3 ->
                                                  Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), v3)))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))), (fun _ ->
                                                  Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))), (fun v3 ->
                                                  Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun v4 ->
                                                  Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Coq3_Compilers.Coq_ident_list_case
                                                  (b,
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun _ ->
                                                  Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Coq3_Compilers.Coq_ident_nil
                                                  b))))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))), (fun _ ->
                                                  Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun v5 ->
                                                  Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))), v3)),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), v5)))))))))),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), v4)))))))))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  (Coq3_Compilers.Coq_nat,
                                                  (let (x1, _) = xv in x1))))))),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Obj.magic v0 (v x0)))))))
                                                (fun fv ->
                                                Coq_Compilers.UnderLets.splice
                                                  (do_again
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t0) (v1 fv)) (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v2 fv0))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None)))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
          (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0))))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x0 with
             | Compilers.Coq_expr.Ident (t1, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x1 y ->
                         match x1 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))))))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat))))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base t0),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                         (Compilers.Coq_type.Coq_base t0))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                 | Some vars0 ->
                   let (a, _) = Obj.magic vars0 in
                   let (a0, b) = a in
                   let (_, b0) = a0 in
                   let (_, _) = b0 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                          match x1 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base b),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)))))),
                        (Compilers.Coq_type.Coq_base b))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat))))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                        (Compilers.Coq_type.Coq_base t0))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                   then bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))))))) (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base t0),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                            (Coq3_Compilers.Coq_pattern_ident_List_repeat
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)) (Coq3_Compilers.Coq_ident_List_repeat t0))
                          (fun _ ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            t0 b (fun tro ->
                            match tro with
                            | Some v ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_nat))
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))
                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                  Coq3_Compilers.Coq_nat)
                                  (Coq3_Compilers.Coq_ident_Literal
                                  ((let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1),
                                  (let (x1, _) =
                                     let (_, y) = args0.Coq_Primitive.projT2
                                     in
                                     y
                                   in
                                   x1)))) (fun xv ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2) b b (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      b)
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      t0) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          t0)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          t0) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            Some
                                              (Coq_Compilers.UnderLets.splice
                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                    Coq3_Compilers.baseHasNat
                                                    Coq3_Compilers.buildIdent
                                                    Coq3_Compilers.buildEagerIdent
                                                    Coq3_Compilers.toRestrictedIdent
                                                    Coq3_Compilers.invertIdent
                                                    Coq3_Compilers.baseHasNatCorrect
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)) false
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)) (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))))),
                                                  (Coq3_Compilers.Coq_ident_eager_nat_rect
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  Compilers.Coq_base.Coq_type.Coq_unit),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun _ ->
                                                  Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Coq3_Compilers.Coq_ident_nil
                                                  b))))))),
                                                  (Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))), (fun _ ->
                                                  Compilers.Coq_expr.Abs
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), (fun v3 ->
                                                  Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_expr.App
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)))))),
                                                  (Coq3_Compilers.Coq_ident_cons
                                                  b))),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  b),
                                                  (Obj.magic v0 (v x)))))),
                                                  (Compilers.Coq_expr.Var
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  b)), v3)))))))))),
                                                  (Compilers.Coq_expr.Ident
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)),
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  (Coq3_Compilers.Coq_nat,
                                                  (let (x1, _) = xv in x1))))))))
                                                (fun fv ->
                                                Coq_Compilers.UnderLets.Base
                                                (v2 (v1 fv))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
          (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0))))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x1 y ->
                     match x1 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))))))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))))) (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, b0) = a in
               let (_, b1) = a0 in
               let (_, b2) = b1 in
               let (_, _) = b2 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                      match x1 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod (b0, b)))))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b0)))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH)))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        (XO XH)))))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t1)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
                        (Coq3_Compilers.Coq_pattern_ident_List_combine
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        (XO XH)))) (Coq3_Compilers.Coq_ident_List_combine
                        (t0, t1))) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x1 x2 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x1 x2)
                        (Compilers.Coq_base.Coq_type.Coq_list t0)
                        (Compilers.Coq_base.Coq_type.Coq_list b0) (fun tro ->
                        match tro with
                        | Some v ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_list t1)
                            (Compilers.Coq_base.Coq_type.Coq_list b)
                            (fun tro0 ->
                            match tro0 with
                            | Some v0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2) (Compilers.Coq_base.Coq_type.Coq_list
                                b0) (Compilers.Coq_base.Coq_type.Coq_list b0)
                                (fun tr ->
                                match tr with
                                | Some v1 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_list b)
                                    (Compilers.Coq_base.Coq_type.Coq_list b)
                                    (fun tr0 ->
                                    match tr0 with
                                    | Some v2 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        (b0, b)))
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        (t0, t1))) (fun tr1 ->
                                        match tr1 with
                                        | Some v3 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                            (t0, t1)))
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                            (t0, t1))) (fun tr' ->
                                            match tr' with
                                            | Some v4 ->
                                              Some
                                                (Coq_Compilers.UnderLets.splice
                                                  (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                      Coq3_Compilers.baseHasNat
                                                      Coq3_Compilers.buildIdent
                                                      Coq3_Compilers.buildEagerIdent
                                                      Coq3_Compilers.toRestrictedIdent
                                                      Coq3_Compilers.invertIdent
                                                      Coq3_Compilers.baseHasNatCorrect
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2)) true
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b0),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b0),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b0),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))))))),
                                                    (Coq3_Compilers.Coq_ident_list_rect_arrow
                                                    (b0,
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b),
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))))),
                                                    (Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))), (fun _ ->
                                                    Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Coq3_Compilers.Coq_ident_nil
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))))))),
                                                    (Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    b0),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))))),
                                                    (fun v5 ->
                                                    Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))), (fun _ ->
                                                    Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))), (fun v6 ->
                                                    Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))), (fun v7 ->
                                                    Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))))),
                                                    (Coq3_Compilers.Coq_ident_list_case
                                                    (b,
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))))),
                                                    (Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))), (fun _ ->
                                                    Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Coq3_Compilers.Coq_ident_nil
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))))))),
                                                    (Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))), (fun v8 ->
                                                    Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))), (fun v9 ->
                                                    Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))))),
                                                    (Coq3_Compilers.Coq_ident_cons
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    b0),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b0),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b))))))),
                                                    (Coq3_Compilers.Coq_ident_pair
                                                    (b0, b)))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    b0), v5)))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    b), v8)))))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    (b0, b)))))), v6)),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)), v9)))))))))))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)), v7)))))))))))))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b0)),
                                                    (Obj.magic v1 (v x)))))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Obj.magic v2 (v0 x0)))))))
                                                  (fun fv ->
                                                  Coq_Compilers.UnderLets.splice
                                                    (do_again
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                                      (t0, t1))) (v3 fv))
                                                    (fun fv0 ->
                                                    Coq_Compilers.UnderLets.Base
                                                    (v4 fv0))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
          (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0))))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x1 y ->
                     match x1 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base t1))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base t1))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, b0) = a in
               let (a1, b1) = a0 in
               let (_, _) = a1 in
               let (_, _) = b1 in
               let (_, b2) = b0 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                      match x1 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b2))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b2)))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base b2))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t1))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH)))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_base t1))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t1))))))
                        (Coq3_Compilers.Coq_pattern_ident_List_map
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        (XO XH)))) (Coq3_Compilers.Coq_ident_List_map (t0,
                        t1))) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x1 x2 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x1 x2) t0
                        b (fun a2 ->
                        match a2 with
                        | Some x' ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            t1 b2 (fun a3 ->
                            match a3 with
                            | Some x'0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2) (Compilers.Coq_base.Coq_type.Coq_list
                                t0) (Compilers.Coq_base.Coq_type.Coq_list b)
                                (fun tro ->
                                match tro with
                                | Some v ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2) b b (fun a4 ->
                                    match a4 with
                                    | Some x'1 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2) b2 b2 (fun a5 ->
                                        match a5 with
                                        | Some x'2 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b) (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                b2)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                t1) (fun tr0 ->
                                                match tr0 with
                                                | Some v1 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t1)
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t1) (fun tr' ->
                                                    match tr' with
                                                    | Some v2 ->
                                                      Some
                                                        (Coq_Compilers.UnderLets.splice
                                                          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                              Coq3_Compilers.baseHasNat
                                                              Coq3_Compilers.buildIdent
                                                              Coq3_Compilers.buildEagerIdent
                                                              Coq3_Compilers.toRestrictedIdent
                                                              Coq3_Compilers.invertIdent
                                                              Coq3_Compilers.baseHasNatCorrect
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)) false
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2))
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Coq3_Compilers.Coq_ident_eager_list_rect
                                                            (b,
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)), (fun _ ->
                                                            Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Coq3_Compilers.Coq_ident_nil
                                                            b2))))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))),
                                                            (fun v3 ->
                                                            Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))), (fun _ ->
                                                            Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)), (fun v4 ->
                                                            Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            b2),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b2),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))),
                                                            (Coq3_Compilers.Coq_ident_cons
                                                            b2))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_base
                                                            b2),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_base
                                                            b2))),
                                                            (Obj.magic x'2
                                                              (x'1
                                                                (x'0 (x' x)))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            b), v3)))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            v4)))))))))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Obj.magic v0
                                                              (v x0)))))))
                                                          (fun fv ->
                                                          Coq_Compilers.UnderLets.Base
                                                          (v2 (v1 fv))))
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
          (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t1), (fun x1 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x1)))))))), x0))))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x1 y ->
                     match x1 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH))))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, _) = a in
               let (_, b0) = a0 in
               let (_, _) = b0 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                      match x1 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                        (Coq3_Compilers.Coq_pattern_ident_List_app
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))
                        (Coq3_Compilers.Coq_ident_List_app t0)) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x1 x2 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x1 x2)
                        (Compilers.Coq_base.Coq_type.Coq_list t0)
                        (Compilers.Coq_base.Coq_type.Coq_list b) (fun tro ->
                        match tro with
                        | Some v ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_list t0)
                            (Compilers.Coq_base.Coq_type.Coq_list b)
                            (fun tro0 ->
                            match tro0 with
                            | Some v0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2) (Compilers.Coq_base.Coq_type.Coq_list
                                b) (Compilers.Coq_base.Coq_type.Coq_list b)
                                (fun tr ->
                                match tr with
                                | Some v1 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_list b)
                                    (Compilers.Coq_base.Coq_type.Coq_list b)
                                    (fun tr0 ->
                                    match tr0 with
                                    | Some v2 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        b)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        t0) (fun tr1 ->
                                        match tr1 with
                                        | Some v3 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            t0)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            t0) (fun tr' ->
                                            match tr' with
                                            | Some v4 ->
                                              Some
                                                (Coq_Compilers.UnderLets.splice
                                                  (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                      Coq3_Compilers.baseHasNat
                                                      Coq3_Compilers.buildIdent
                                                      Coq3_Compilers.buildEagerIdent
                                                      Coq3_Compilers.toRestrictedIdent
                                                      Coq3_Compilers.invertIdent
                                                      Coq3_Compilers.baseHasNatCorrect
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2)) false
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b))
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))))))),
                                                    (Coq3_Compilers.Coq_ident_eager_list_rect
                                                    (b,
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b))))),
                                                    (Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)), (fun _ ->
                                                    Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Obj.magic v2 (v0 x0)))))))),
                                                    (Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))))), (fun v5 ->
                                                    Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))), (fun _ ->
                                                    Compilers.Coq_expr.Abs
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)), (fun v6 ->
                                                    Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_expr.App
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))),
                                                    (Compilers.Coq_expr.Ident
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    b),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)))))),
                                                    (Coq3_Compilers.Coq_ident_cons
                                                    b))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    b), v5)))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)), v6)))))))))))),
                                                    (Compilers.Coq_expr.Var
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)),
                                                    (Obj.magic v1 (v x)))))))
                                                  (fun fv ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v4 (v3 fv))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0))))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x ->
        sequence_return0
          (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                   (fun x0 y ->
                   match x0 with
                   | Coq3_Compilers.Z ->
                     (match y with
                      | Coq3_Compilers.Z -> true
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_bool ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> true
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_nat ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> true
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_zrange ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> true
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_string ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> true))
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t0)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
           | Some vars0 ->
             let (a, b) = Obj.magic vars0 in
             let (_, _) = a in
             if Compilers.Coq_type.type_beq
                  (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                    match x0 with
                    | Coq3_Compilers.Z ->
                      (match y with
                       | Coq3_Compilers.Z -> true
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_bool ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> true
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_nat ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> true
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_zrange ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> true
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_string ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> true)))
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list b)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list b)))),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list b))))
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0))))
             then bind1
                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                      XH))))) (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list t0)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list t0))))
                      (Coq3_Compilers.Coq_pattern_ident_List_rev
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))
                      (Coq3_Compilers.Coq_ident_List_rev t0)) (fun _ ->
                    Compilers.Coq_base.try_make_transport_cps
                      (fun _ x0 x1 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x0 x1)
                      (Compilers.Coq_base.Coq_type.Coq_list t0)
                      (Compilers.Coq_base.Coq_type.Coq_list b) (fun tro ->
                      match tro with
                      | Some v ->
                        Compilers.Coq_base.try_make_transport_cps
                          (fun _ x0 x1 _ ->
                          Coq3_Compilers.try_make_base_transport_cps x0 x1)
                          (Compilers.Coq_base.Coq_type.Coq_list b)
                          (Compilers.Coq_base.Coq_type.Coq_list b) (fun tr ->
                          match tr with
                          | Some v0 ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x0 x1 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x0
                                x1) (Compilers.Coq_base.Coq_type.Coq_list b)
                              (Compilers.Coq_base.Coq_type.Coq_list t0)
                              (fun tr0 ->
                              match tr0 with
                              | Some v1 ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x0 x1 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x0 x1)
                                  (Compilers.Coq_base.Coq_type.Coq_list t0)
                                  (Compilers.Coq_base.Coq_type.Coq_list t0)
                                  (fun tr' ->
                                  match tr' with
                                  | Some v2 ->
                                    Some
                                      (Coq_Compilers.UnderLets.splice
                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                            Coq3_Compilers.baseHasNat
                                            Coq3_Compilers.buildIdent
                                            Coq3_Compilers.buildEagerIdent
                                            Coq3_Compilers.toRestrictedIdent
                                            Coq3_Compilers.invertIdent
                                            Coq3_Compilers.baseHasNatCorrect
                                            (fun _ x0 x1 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x0 x1)) true
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)) (Compilers.Coq_expr.App
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_expr.App
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base b),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))), (Compilers.Coq_expr.App
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base b),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))), (Compilers.Coq_expr.Ident
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base b),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))))),
                                          (Coq3_Compilers.Coq_ident_list_rect
                                          (b,
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b))))), (Compilers.Coq_expr.Abs
                                          ((Compilers.Coq_type.Coq_base
                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (fun _ ->
                                          Compilers.Coq_expr.Ident
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Coq3_Compilers.Coq_ident_nil
                                          b))))))), (Compilers.Coq_expr.Abs
                                          ((Compilers.Coq_type.Coq_base b),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))), (fun v3 ->
                                          Compilers.Coq_expr.Abs
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))), (fun _ ->
                                          Compilers.Coq_expr.Abs
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (fun v4 ->
                                          Compilers.Coq_expr.App
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_expr.App
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))), (Compilers.Coq_expr.Ident
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))),
                                          (Coq3_Compilers.Coq_ident_List_app
                                          b))), (Compilers.Coq_expr.Var
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), v4)))),
                                          (Compilers.Coq_expr.App
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_expr.App
                                          ((Compilers.Coq_type.Coq_base b),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))), (Compilers.Coq_expr.Ident
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base b),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)))))),
                                          (Coq3_Compilers.Coq_ident_cons
                                          b))), (Compilers.Coq_expr.Var
                                          ((Compilers.Coq_type.Coq_base b),
                                          v3)))), (Compilers.Coq_expr.Ident
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Coq3_Compilers.Coq_ident_nil
                                          b))))))))))))))),
                                          (Compilers.Coq_expr.Var
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)), (Obj.magic v0 (v x)))))))
                                        (fun fv ->
                                        Coq_Compilers.UnderLets.splice
                                          (do_again
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            t0) (v1 fv)) (fun fv0 ->
                                          Coq_Compilers.UnderLets.Base
                                          (v2 fv0))))
                                  | None -> None)
                              | None -> None)
                          | None -> None)
                      | None -> None))
             else None
           | None -> None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))),
          (Coq3_Compilers.Coq_ident_List_rev t0))), x))))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x1 y ->
                     match x1 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, b0) = a in
               let (a1, b1) = a0 in
               let (_, _) = a1 in
               let (_, _) = b1 in
               let (_, b2) = b0 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                      match x1 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b2)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b2)))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b2)))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH)))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH)))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t1))))))
                        (Coq3_Compilers.Coq_pattern_ident_List_flat_map
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        (XO XH)))) (Coq3_Compilers.Coq_ident_List_flat_map
                        (t0, t1))) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x1 x2 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x1 x2) t0
                        b (fun a2 ->
                        match a2 with
                        | Some x' ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_list t1)
                            (Compilers.Coq_base.Coq_type.Coq_list b2)
                            (fun a3 ->
                            match a3 with
                            | Some x'0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2) (Compilers.Coq_base.Coq_type.Coq_list
                                t0) (Compilers.Coq_base.Coq_type.Coq_list b)
                                (fun tro ->
                                match tro with
                                | Some v ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2) b b (fun a4 ->
                                    match a4 with
                                    | Some x'1 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        b2)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        b2) (fun a5 ->
                                        match a5 with
                                        | Some x'2 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b) (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                b2)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                t1) (fun tr0 ->
                                                match tr0 with
                                                | Some v1 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t1)
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t1) (fun tr' ->
                                                    match tr' with
                                                    | Some v2 ->
                                                      Some
                                                        (Coq_Compilers.UnderLets.splice
                                                          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                              Coq3_Compilers.baseHasNat
                                                              Coq3_Compilers.buildIdent
                                                              Coq3_Compilers.buildEagerIdent
                                                              Coq3_Compilers.toRestrictedIdent
                                                              Coq3_Compilers.invertIdent
                                                              Coq3_Compilers.baseHasNatCorrect
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)) true
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2))
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))))),
                                                            (Coq3_Compilers.Coq_ident_list_rect
                                                            (b,
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)), (fun _ ->
                                                            Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Coq3_Compilers.Coq_ident_nil
                                                            b2))))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))),
                                                            (fun v3 ->
                                                            Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))), (fun _ ->
                                                            Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)), (fun v4 ->
                                                            Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))))),
                                                            (Coq3_Compilers.Coq_ident_List_app
                                                            b2))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)))),
                                                            (Obj.magic x'2
                                                              (x'1
                                                                (x'0 (x' x)))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            b), v3)))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b2)),
                                                            v4)))))))))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Obj.magic v0
                                                              (v x0)))))))
                                                          (fun fv ->
                                                          Coq_Compilers.UnderLets.splice
                                                            (do_again
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              t1) (v1 fv))
                                                            (fun fv0 ->
                                                            Coq_Compilers.UnderLets.Base
                                                            (v2 fv0))))
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (fun x1 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t1))
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x1)))))))), x0))))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x1 y ->
                     match x1 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH))))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_list t0),
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)))))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, b0) = a in
               let (a1, b1) = a0 in
               let (_, _) = a1 in
               let (_, b2) = b1 in
               let (_, _) = b2 in
               let (_, _) = b0 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                      match x1 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_list b),
                    (Compilers.Coq_base.Coq_type.Coq_list b)))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0)),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_list t0),
                    (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t0))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)),
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH))))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool)))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_prod
                        ((Compilers.Coq_base.Coq_type.Coq_list t0),
                        (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
                        (Coq3_Compilers.Coq_pattern_ident_List_partition
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))
                        (Coq3_Compilers.Coq_ident_List_partition t0))
                      (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x1 x2 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x1 x2) t0
                        b (fun a2 ->
                        match a2 with
                        | Some x' ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_bool)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_bool) (fun a3 ->
                            match a3 with
                            | Some x'0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2) (Compilers.Coq_base.Coq_type.Coq_list
                                t0) (Compilers.Coq_base.Coq_type.Coq_list b)
                                (fun tro ->
                                match tro with
                                | Some v ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2) b b (fun a4 ->
                                    match a4 with
                                    | Some x'1 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_bool)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_bool) (fun a5 ->
                                        match a5 with
                                        | Some x'2 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b)
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            b) (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2)
                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                ((Compilers.Coq_base.Coq_type.Coq_list
                                                b),
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                b)))
                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                ((Compilers.Coq_base.Coq_type.Coq_list
                                                t0),
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                t0))) (fun tr0 ->
                                                match tr0 with
                                                | Some v1 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_list
                                                    t0),
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t0)))
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_list
                                                    t0),
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t0))) (fun tr' ->
                                                    match tr' with
                                                    | Some v2 ->
                                                      Some
                                                        (Coq_Compilers.UnderLets.splice
                                                          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                              Coq3_Compilers.baseHasNat
                                                              Coq3_Compilers.buildIdent
                                                              Coq3_Compilers.buildEagerIdent
                                                              Coq3_Compilers.toRestrictedIdent
                                                              Coq3_Compilers.invertIdent
                                                              Coq3_Compilers.baseHasNatCorrect
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)) true
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b))))
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))))),
                                                            (Coq3_Compilers.Coq_ident_list_rect
                                                            (b,
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b))))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))), (fun _ ->
                                                            Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Coq3_Compilers.Coq_ident_nil
                                                            b))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Coq3_Compilers.Coq_ident_nil
                                                            b))))))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (fun v3 ->
                                                            Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (fun _ ->
                                                            Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))), (fun v4 ->
                                                            Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Coq3_Compilers.Coq_ident_prod_rect
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b))))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (fun v5 ->
                                                            Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))), (fun v6 ->
                                                            Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_bool)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_bool)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_bool)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_bool)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))))),
                                                            (Coq3_Compilers.Coq_ident_bool_rect
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))), (fun _ ->
                                                            Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b))))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Coq3_Compilers.Coq_ident_cons
                                                            b))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            b), v3)))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)), v5)))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)), v6)))))))),
                                                            (Compilers.Coq_expr.Abs
                                                            ((Compilers.Coq_type.Coq_base
                                                            Compilers.Coq_base.Coq_type.Coq_unit),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))), (fun _ ->
                                                            Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))))),
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)), v5)))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            (Compilers.Coq_expr.Ident
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))))),
                                                            (Coq3_Compilers.Coq_ident_cons
                                                            b))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            b), v3)))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            v6)))))))))),
                                                            (Compilers.Coq_expr.App
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_bool)),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_bool)))),
                                                            (Obj.magic x'2
                                                              (x'1
                                                                (x'0 (x' x)))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            b),
                                                            v3)))))))))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                                            b),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)))),
                                                            v4)))))))))))),
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)),
                                                            (Obj.magic v0
                                                              (v x0)))))))
                                                          (fun fv ->
                                                          Coq_Compilers.UnderLets.splice
                                                            (do_again
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_list
                                                              t0),
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              t0))) (v1 fv))
                                                            (fun fv0 ->
                                                            Coq_Compilers.UnderLets.Base
                                                            (v2 fv0))))
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_list t0),
          (Compilers.Coq_base.Coq_type.Coq_list t0)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_list t0),
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_list t0),
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
          (Coq3_Compilers.Coq_ident_List_partition t0))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (fun x1 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool))
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x1)))))))), x0))))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                   (fun x1 y ->
                   match x1 with
                   | Coq3_Compilers.Z ->
                     (match y with
                      | Coq3_Compilers.Z -> true
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_bool ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> true
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_nat ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> true
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_zrange ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> true
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_string ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> true))
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                   XH))))))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t0),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t0)),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base t0),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
           | Some vars0 ->
             let (a, b) = Obj.magic vars0 in
             let (a0, b0) = a in
             let (a1, b1) = a0 in
             let (_, _) = a1 in
             let (_, _) = b1 in
             let (_, _) = b0 in
             if Compilers.Coq_type.type_beq
                  (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                    match x1 with
                    | Coq3_Compilers.Z ->
                      (match y with
                       | Coq3_Compilers.Z -> true
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_bool ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> true
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_nat ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> true
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_zrange ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> true
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_string ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> true)))
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base b),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list b)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list b)))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  b), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list b))))
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base t0),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t0), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t0))))
             then bind1
                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                      XH))))))) (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list t0)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list t0))))))
                      (Coq3_Compilers.Coq_pattern_ident_List_filter
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))
                      (Coq3_Compilers.Coq_ident_List_filter t0)) (fun _ ->
                    Compilers.Coq_base.try_make_transport_cps
                      (fun _ x1 x2 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x1 x2) t0 b
                      (fun a2 ->
                      match a2 with
                      | Some x' ->
                        Compilers.Coq_base.try_make_transport_cps
                          (fun _ x1 x2 _ ->
                          Coq3_Compilers.try_make_base_transport_cps x1 x2)
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool) (fun a3 ->
                          match a3 with
                          | Some x'0 ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2) (Compilers.Coq_base.Coq_type.Coq_list t0)
                              (Compilers.Coq_base.Coq_type.Coq_list b)
                              (fun tro ->
                              match tro with
                              | Some v ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2) b b (fun a4 ->
                                  match a4 with
                                  | Some x'1 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Coq_bool)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Coq_bool) (fun a5 ->
                                      match a5 with
                                      | Some x'2 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b) (fun tr ->
                                          match tr with
                                          | Some v0 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              b)
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              t0) (fun tr0 ->
                                              match tr0 with
                                              | Some v1 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2)
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  t0)
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  t0) (fun tr' ->
                                                  match tr' with
                                                  | Some v2 ->
                                                    Some
                                                      (Coq_Compilers.UnderLets.splice
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) true
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b))
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))),
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))))),
                                                          (Coq3_Compilers.Coq_ident_list_rect
                                                          (b,
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b))))),
                                                          (Compilers.Coq_expr.Abs
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)), (fun _ ->
                                                          Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Coq3_Compilers.Coq_ident_nil
                                                          b))))))),
                                                          (Compilers.Coq_expr.Abs
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))), (fun v3 ->
                                                          Compilers.Coq_expr.Abs
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))), (fun _ ->
                                                          Compilers.Coq_expr.Abs
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)), (fun v4 ->
                                                          Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))),
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))))),
                                                          (Coq3_Compilers.Coq_ident_bool_rect
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_expr.Abs
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)), (fun _ ->
                                                          Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))),
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)))))),
                                                          (Coq3_Compilers.Coq_ident_cons
                                                          b))),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          b), v3)))),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)), v4)))))))),
                                                          (Compilers.Coq_expr.Abs
                                                          ((Compilers.Coq_type.Coq_base
                                                          Compilers.Coq_base.Coq_type.Coq_unit),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)), (fun _ ->
                                                          Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)), v4)))))),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)))),
                                                          (Obj.magic x'2
                                                            (x'1
                                                              (x'0 (x' x)))))),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          v3)))))))))))))),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Obj.magic v0
                                                            (v x0)))))))
                                                        (fun fv ->
                                                        Coq_Compilers.UnderLets.splice
                                                          (do_again
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            t0) (v1 fv))
                                                          (fun fv0 ->
                                                          Coq_Compilers.UnderLets.Base
                                                          (v2 fv0))))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None)
                          | None -> None)
                      | None -> None))
             else None
           | None -> None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
          (Coq3_Compilers.Coq_ident_List_filter t0))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (fun x1 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool))
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x1)))))))), x0))))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x2 y ->
                     match x2 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH)))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH)))))))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                     XH)))))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                     XH)))))) (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base t0))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)),
                     (Compilers.Coq_type.Coq_base t0))))))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t1),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_type.Coq_base t0))))))),
                     (Compilers.Coq_type.Coq_base t0))),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list t1)))) with
             | Some vars0 ->
               let (a, b) = Obj.magic vars0 in
               let (a0, b0) = a in
               let (a1, b1) = a0 in
               let (a2, b2) = a1 in
               let (_, b3) = a2 in
               let (_, _) = b3 in
               let (_, b4) = b2 in
               let (_, _) = b4 in
               let (_, b5) = b1 in
               let (_, _) = b5 in
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                      match x2 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b0),
                    (Compilers.Coq_type.Coq_base b0))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b)),
                    (Compilers.Coq_type.Coq_base b0))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base b0),
                    (Compilers.Coq_type.Coq_base b0))))))),
                    (Compilers.Coq_type.Coq_base b0))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list b))))
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t0))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1)),
                    (Compilers.Coq_type.Coq_base t0))))))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t1),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base t0),
                    (Compilers.Coq_type.Coq_base t0))))))),
                    (Compilers.Coq_type.Coq_base t0))),
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list t1))))
               then bind1
                      (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)))))), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
                        XH)))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH)))))))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t1),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_base t0))))),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t1)),
                        (Compilers.Coq_type.Coq_base t0)))))))
                        (Coq3_Compilers.Coq_pattern_ident_List_fold_right
                        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        XH), (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                        (XO XH)))) (Coq3_Compilers.Coq_ident_List_fold_right
                        (t0, t1))) (fun _ ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x2 x3 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x2 x3) t1
                        b (fun a3 ->
                        match a3 with
                        | Some x' ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x2 x3 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x2 x3)
                            t0 b0 (fun a4 ->
                            match a4 with
                            | Some x'0 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x2 x3 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x2
                                  x3) t0 b0 (fun a5 ->
                                match a5 with
                                | Some x'1 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x2 x3 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x2 x3) t0 b0 (fun tro ->
                                    match tro with
                                    | Some v ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x2 x3 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x2 x3)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        t1)
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        b) (fun tro0 ->
                                        match tro0 with
                                        | Some v0 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x2 x3) b b (fun a6 ->
                                            match a6 with
                                            | Some x'2 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3) b0 b0 (fun a7 ->
                                                match a7 with
                                                | Some x'3 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3) b0 b0 (fun a8 ->
                                                    match a8 with
                                                    | Some x'4 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3) b0 b0
                                                        (fun tr ->
                                                        match tr with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3)
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b)
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            b) (fun tr0 ->
                                                            match tr0 with
                                                            | Some v2 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x2 x3 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x2 x3) b0
                                                                t0
                                                                (fun tr1 ->
                                                                match tr1 with
                                                                | Some v3 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t0
                                                                    t0
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))))))),
                                                                    (Coq3_Compilers.Coq_ident_eager_list_rect
                                                                    (b,
                                                                    b0)))),
                                                                    (Compilers.Coq_expr.Abs
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (fun _ ->
                                                                    Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Obj.magic
                                                                    v1
                                                                    (v x0)))))))),
                                                                    (Compilers.Coq_expr.Abs
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.Abs
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))),
                                                                    (fun _ ->
                                                                    Compilers.Coq_expr.Abs
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (fun v6 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b0))))),
                                                                    (Obj.magic
                                                                    x'4
                                                                    (x'3
                                                                    (x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b),
                                                                    v5)))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b0),
                                                                    v6)))))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    b)),
                                                                    (Obj.magic
                                                                    v2
                                                                    (v0 x1)))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv))))
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None))
               else None
             | None -> None) None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1)),
          (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t1)), (Compilers.Coq_type.Coq_base t0))))))),
          (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (fun x2 ->
          Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0), (fun x3 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1),
              x2)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x3)))))))))), x0)), x1))))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (t1, idc0) ->
             bind1
               (Obj.magic
                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                 t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal) (fun args0 ->
               match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                       (fun x2 y ->
                       match x2 with
                       | Coq3_Compilers.Z ->
                         (match y with
                          | Coq3_Compilers.Z -> true
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_bool ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> true
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_nat ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> true
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_zrange ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> true
                          | Coq3_Compilers.Coq_string -> false)
                       | Coq3_Compilers.Coq_string ->
                         (match y with
                          | Coq3_Compilers.Z -> false
                          | Coq3_Compilers.Coq_bool -> false
                          | Coq3_Compilers.Coq_nat -> false
                          | Coq3_Compilers.Coq_zrange -> false
                          | Coq3_Compilers.Coq_string -> true))
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                       XH)))), (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                       XH))), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                       XH))))))))), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                       XH)))))), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                       XH))))) (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Coq_nat)),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t0))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_list t0)),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))),
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base t0),
                       (Compilers.Coq_type.Coq_base t0))))),
                       (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_list t0)))) with
               | Some vars0 ->
                 let (a, b) = Obj.magic vars0 in
                 let (a0, b0) = a in
                 let (a1, _) = a0 in
                 let (_, b1) = a1 in
                 let (a2, b2) = b1 in
                 let (_, _) = a2 in
                 let (_, _) = b2 in
                 let (_, _) = b0 in
                 if Compilers.Coq_type.type_beq
                      (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                        match x2 with
                        | Coq3_Compilers.Z ->
                          (match y with
                           | Coq3_Compilers.Z -> true
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_bool ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> true
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_nat ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> true
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_zrange ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> true
                           | Coq3_Compilers.Coq_string -> false)
                        | Coq3_Compilers.Coq_string ->
                          (match y with
                           | Coq3_Compilers.Z -> false
                           | Coq3_Compilers.Coq_bool -> false
                           | Coq3_Compilers.Coq_nat -> false
                           | Coq3_Compilers.Coq_zrange -> false
                           | Coq3_Compilers.Coq_string -> true)))
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list b)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list b)))))))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base b),
                      (Compilers.Coq_type.Coq_base b))))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list b))))
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t0))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list t0)),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base t0),
                      (Compilers.Coq_type.Coq_base t0))))),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list t0))))
                 then bind1
                        (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_nat)),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH)))), (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH))), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH))))))))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_nat)),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base t0),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list t0)),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
                          (Coq3_Compilers.Coq_pattern_ident_List_update_nth
                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                          XH)) (Coq3_Compilers.Coq_ident_List_update_nth t0))
                        (fun _ ->
                        bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat))
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x2, _) = args0.Coq_Primitive.projT1 in x2)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Coq_nat)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x2, _) = args0.Coq_Primitive.projT1 in x2),
                            (let (x2, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x2)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x2 x3 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x2 x3)
                            t0 b (fun a3 ->
                            match a3 with
                            | Some x' ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x2 x3 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x2
                                  x3) t0 b (fun a4 ->
                                match a4 with
                                | Some x'0 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x2 x3 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x2 x3)
                                    (Compilers.Coq_base.Coq_type.Coq_list t0)
                                    (Compilers.Coq_base.Coq_type.Coq_list b)
                                    (fun tro ->
                                    match tro with
                                    | Some v ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x2 x3 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x2 x3) b b (fun a5 ->
                                        match a5 with
                                        | Some x'1 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x2 x3) b b (fun a6 ->
                                            match a6 with
                                            | Some x'2 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                b)
                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                b) (fun tr ->
                                                match tr with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    b)
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    t0) (fun tr0 ->
                                                    match tr0 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        t0)
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        t0) (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x2 x3 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                true
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b))
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))))))),
                                                                (Coq3_Compilers.Coq_ident_nat_rect_arrow
                                                                ((Compilers.Coq_base.Coq_type.Coq_list
                                                                b),
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b))))),
                                                                (Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (fun v3 ->
                                                                Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                Compilers.Coq_base.Coq_type.Coq_unit),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                Compilers.Coq_base.Coq_type.Coq_unit),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))))),
                                                                (Coq3_Compilers.Coq_ident_list_case
                                                                (b,
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b))))),
                                                                (Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                Compilers.Coq_base.Coq_type.Coq_unit),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (fun _ ->
                                                                Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Coq3_Compilers.Coq_ident_nil
                                                                b))))))),
                                                                (Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (fun v4 ->
                                                                Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (fun v5 ->
                                                                Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Coq3_Compilers.Coq_ident_cons
                                                                b))),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_base
                                                                b))),
                                                                (Obj.magic
                                                                  x'2
                                                                  (x'1
                                                                    (x'0
                                                                    (x' x0)))))),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b), v4)))))),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                v5)))))))))),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                v3)))))))),
                                                                (Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (fun _ ->
                                                                Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (fun v3 ->
                                                                Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (fun v4 ->
                                                                Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                Compilers.Coq_base.Coq_type.Coq_unit),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                Compilers.Coq_base.Coq_type.Coq_unit),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))))),
                                                                (Coq3_Compilers.Coq_ident_list_case
                                                                (b,
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b))))),
                                                                (Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                Compilers.Coq_base.Coq_type.Coq_unit),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (fun _ ->
                                                                Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Coq3_Compilers.Coq_ident_nil
                                                                b))))))),
                                                                (Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (fun v5 ->
                                                                Compilers.Coq_expr.Abs
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (fun v6 ->
                                                                Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                b),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))))),
                                                                (Coq3_Compilers.Coq_ident_cons
                                                                b))),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b), v5)))),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)))), v3)),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                v6)))))))))))),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                v4)))))))))))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_nat)),
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                (Coq3_Compilers.Coq_nat,
                                                                (let (
                                                                   x2, _) =
                                                                   xv
                                                                 in
                                                                 x2))))))),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_list
                                                                b)),
                                                                (Obj.magic v0
                                                                  (v x1)))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.splice
                                                                (do_again
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  t0)
                                                                  (v1 fv))
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 fv0))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)))
                 else None
               | None -> None)
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, _, _) -> None
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
          (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_base t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
              x2)))))))), x1))))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x1 with
             | Compilers.Coq_expr.Ident (t1, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x2 y ->
                         match x2 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))), (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))))))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH)))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                         XH))))), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat))))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base t0),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)),
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat)),
                         (Compilers.Coq_type.Coq_base t0))))))),
                         (Compilers.Coq_type.Coq_base t0))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))) with
                 | Some vars0 ->
                   let (a, _) = Obj.magic vars0 in
                   let (a0, b) = a in
                   let (a1, _) = a0 in
                   let (_, b0) = a1 in
                   let (_, b1) = b0 in
                   let (_, _) = b1 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                          match x2 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base b),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_base b))))))),
                        (Compilers.Coq_type.Coq_base b))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list b)))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat))))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base t0),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)),
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)),
                        (Compilers.Coq_type.Coq_base t0))))))),
                        (Compilers.Coq_type.Coq_base t0))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x2, _) = args0.Coq_Primitive.projT1 in x2)))))
                   then bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH))), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)))))))) (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base t0),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list t0)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base t0)))))))
                            (Coq3_Compilers.Coq_pattern_ident_List_nth_default
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                            XH)) (Coq3_Compilers.Coq_ident_List_nth_default
                            t0)) (fun _ ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x2 x3 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x2 x3)
                            t0 b (fun tro ->
                            match tro with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x2 x3 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x2
                                  x3) (Compilers.Coq_base.Coq_type.Coq_list
                                t0) (Compilers.Coq_base.Coq_type.Coq_list b)
                                (fun tro0 ->
                                match tro0 with
                                | Some v0 ->
                                  bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Coq_nat))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args0.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Coq_nat)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x2 x3 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x2 x3) b b (fun tr ->
                                      match tr with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b)
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          b) (fun tr0 ->
                                          match tr0 with
                                          | Some v2 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3) b t0 (fun tr1 ->
                                              match tr1 with
                                              | Some v3 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x2 x3 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x2 x3) t0 t0 (fun tr' ->
                                                  match tr' with
                                                  | Some v4 ->
                                                    Some
                                                      (Coq_Compilers.UnderLets.splice
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          b)
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)),
                                                          (Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)),
                                                          (Compilers.Coq_type.Coq_base
                                                          b))),
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)),
                                                          (Compilers.Coq_type.Coq_base
                                                          b))))),
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)),
                                                          (Compilers.Coq_type.Coq_base
                                                          b))))))),
                                                          (Coq3_Compilers.Coq_ident_eager_List_nth_default
                                                          b))),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          b),
                                                          (Obj.magic v1
                                                            (v x)))))),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          b)),
                                                          (Obj.magic v2
                                                            (v0 x0)))))),
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)),
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          (Coq3_Compilers.Coq_nat,
                                                          (let (x2, _) = xv
                                                           in
                                                           x2))))))))
                                                        (fun fv ->
                                                        Coq_Compilers.UnderLets.Base
                                                        (v4 (v3 fv))))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t0)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0))))))),
          (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.add
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_add)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.mul
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_mul)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.pow
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_pow)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.sub
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_sub)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Z)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Z,
                                        (Obj.magic Coq_Z.opp
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_Z_opp)), x))))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.div
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_div)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.modulo
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_bool)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_bool,
                                               (Obj.magic Coq_Z.eqb
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_bool)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_bool,
                                               (Obj.magic Coq_Z.leb
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_bool)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_bool,
                                               (Obj.magic Coq_Z.ltb
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_bool)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_bool,
                                               (Obj.magic Coq_Z.geb
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_bool) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_bool) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_bool)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_bool,
                                               (Obj.magic Coq_Z.gtb
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Z)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Z,
                                        (Obj.magic Coq_Z.log2
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_Z_log2)), x))))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Z)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Z,
                                        (Obj.magic Coq_Z.log2_up
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_Z_log2_up)), x))))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_nat))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat))
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Coq_nat)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Z,
                                        (Obj.magic Coq_Z.of_nat
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_Z_of_nat)), x))))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Z)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Coq_nat) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_nat)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Coq_nat,
                                        (Obj.magic Coq_Z.to_nat
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
          x))))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.shiftr
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.shiftl
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.coq_land
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_land)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.coq_lor
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_lor)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.min
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_min)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.max
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_max)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (let (a0, b) =
                                                         Coq1_Z.mul_split
                                                           (let (x2, _) = xv
                                                            in
                                                            x2)
                                                           (let (x2, _) = xv0
                                                            in
                                                            x2)
                                                           (let (x2, _) = xv1
                                                            in
                                                            x2)
                                                       in
                                                       Compilers.Coq_expr.App
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))),
                                                       (Compilers.Coq_expr.App
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))))))),
                                                       (Coq3_Compilers.Coq_ident_pair
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Coq3_Compilers.Coq_ident_Literal
                                                       (Coq3_Compilers.Z,
                                                       (Obj.magic a0))))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Coq3_Compilers.Coq_ident_Literal
                                                       (Coq3_Compilers.Z,
                                                       (Obj.magic b))))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
          x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      (Coq3_Compilers.Z,
                                                      (Obj.magic
                                                        Coq1_Z.mul_high
                                                        (let (x2, _) = xv in
                                                         x2)
                                                        (let (x2, _) = xv0 in
                                                         x2)
                                                        (let (x2, _) = xv1 in
                                                         x2)))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_mul_high)),
          x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (let (a0, b) =
                                                         Coq1_Z.add_get_carry_full
                                                           (let (x2, _) = xv
                                                            in
                                                            x2)
                                                           (let (x2, _) = xv0
                                                            in
                                                            x2)
                                                           (let (x2, _) = xv1
                                                            in
                                                            x2)
                                                       in
                                                       Compilers.Coq_expr.App
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))),
                                                       (Compilers.Coq_expr.App
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))))))),
                                                       (Coq3_Compilers.Coq_ident_pair
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Coq3_Compilers.Coq_ident_Literal
                                                       (Coq3_Compilers.Z,
                                                       (Obj.magic a0))))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Coq3_Compilers.Coq_ident_Literal
                                                       (Coq3_Compilers.Z,
                                                       (Obj.magic b))))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))),
          Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      (Coq3_Compilers.Z,
                                                      (Obj.magic
                                                        Coq1_Z.add_with_carry
                                                        (let (x2, _) = xv in
                                                         x2)
                                                        (let (x2, _) = xv0 in
                                                         x2)
                                                        (let (x2, _) = xv1 in
                                                         x2)))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))),
          Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                        bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                            t3 idc3 Coq3_Compilers.Coq_raw_ident_Literal)
                          (fun args0 ->
                          bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                              t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                            (fun args1 ->
                            bind1
                              (Obj.magic
                                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                              (fun args2 ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                  t0 idc0
                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                (fun args3 ->
                                match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                        (fun x3 y ->
                                        match x3 with
                                        | Coq3_Compilers.Z ->
                                          (match y with
                                           | Coq3_Compilers.Z -> true
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_bool ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> true
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_nat ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> true
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_zrange ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             true
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_string ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             true))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args3.Coq_Primitive.projT1
                                         in
                                         x3))), (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args2.Coq_Primitive.projT1
                                         in
                                         x3))))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x3))))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x3))))) with
                                | Some vars0 ->
                                  let (a, _) = Obj.magic vars0 in
                                  let (a0, _) = a in
                                  let (_, _) = a0 in
                                  if Compilers.Coq_type.type_beq
                                       (Compilers.Coq_base.Coq_type.type_beq
                                         (fun x3 y ->
                                         match x3 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true)))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args3.Coq_Primitive.projT1
                                        in
                                        x3))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x3))))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args1.Coq_Primitive.projT1
                                        in
                                        x3))))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x3)))))
                                  then bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args3.Coq_Primitive.projT1
                                            in
                                            x3)))
                                           (Coq3_Compilers.Coq_pattern_ident_Literal
                                           Coq3_Compilers.Z)
                                           (Coq3_Compilers.Coq_ident_Literal
                                           ((let (x3, _) =
                                               args3.Coq_Primitive.projT1
                                             in
                                             x3),
                                           (let (x3, _) =
                                              let (_, y) =
                                                args3.Coq_Primitive.projT2
                                              in
                                              y
                                            in
                                            x3)))) (fun xv ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x3, _) =
                                                args2.Coq_Primitive.projT1
                                              in
                                              x3)))
                                             (Coq3_Compilers.Coq_pattern_ident_Literal
                                             Coq3_Compilers.Z)
                                             (Coq3_Compilers.Coq_ident_Literal
                                             ((let (x3, _) =
                                                 args2.Coq_Primitive.projT1
                                               in
                                               x3),
                                             (let (x3, _) =
                                                let (_, y) =
                                                  args2.Coq_Primitive.projT2
                                                in
                                                y
                                              in
                                              x3)))) (fun xv0 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x3, _) =
                                                  args1.Coq_Primitive.projT1
                                                in
                                                x3)))
                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                               Coq3_Compilers.Z)
                                               (Coq3_Compilers.Coq_ident_Literal
                                               ((let (x3, _) =
                                                   args1.Coq_Primitive.projT1
                                                 in
                                                 x3),
                                               (let (x3, _) =
                                                  let (_, y) =
                                                    args1.Coq_Primitive.projT2
                                                  in
                                                  y
                                                in
                                                x3)))) (fun xv1 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 (let (x3, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x3)))
                                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                                 Coq3_Compilers.Z)
                                                 (Coq3_Compilers.Coq_ident_Literal
                                                 ((let (x3, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x3),
                                                 (let (x3, _) =
                                                    let (_, y) =
                                                      args0.Coq_Primitive.projT2
                                                    in
                                                    y
                                                  in
                                                  x3)))) (fun xv2 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x3 x4)
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)))
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)))
                                                 (fun tr ->
                                                 match tr with
                                                 | Some v ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x3 x4)
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (fun tr' ->
                                                     match tr' with
                                                     | Some v0 ->
                                                       Some
                                                         (Coq_Compilers.UnderLets.Base
                                                         (v0
                                                           (v
                                                             (let (a1, b) =
                                                                Coq1_Z.add_with_get_carry_full
                                                                  (let (
                                                                    x3, _) =
                                                                    xv
                                                                   in
                                                                   x3)
                                                                  (let (
                                                                    x3, _) =
                                                                    xv0
                                                                   in
                                                                   x3)
                                                                  (let (
                                                                    x3, _) =
                                                                    xv1
                                                                   in
                                                                   x3)
                                                                  (let (
                                                                    x3, _) =
                                                                    xv2
                                                                   in
                                                                   x3)
                                                              in
                                                              Compilers.Coq_expr.App
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_expr.App
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))),
                                                              (Compilers.Coq_expr.Ident
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))))),
                                                              (Coq3_Compilers.Coq_ident_pair
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))))),
                                                              (Compilers.Coq_expr.Ident
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              (Coq3_Compilers.Z,
                                                              (Obj.magic a1))))))),
                                                              (Compilers.Coq_expr.Ident
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              (Coq3_Compilers.Z,
                                                              (Obj.magic b))))))))))
                                                     | None -> None)
                                                 | None -> None)))))
                                  else None
                                | None -> None))))
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))))),
          Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
          x2))))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (let (a0, b) =
                                                         Coq1_Z.sub_get_borrow_full
                                                           (let (x2, _) = xv
                                                            in
                                                            x2)
                                                           (let (x2, _) = xv0
                                                            in
                                                            x2)
                                                           (let (x2, _) = xv1
                                                            in
                                                            x2)
                                                       in
                                                       Compilers.Coq_expr.App
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))),
                                                       (Compilers.Coq_expr.App
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))))))),
                                                       (Coq3_Compilers.Coq_ident_pair
                                                       ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z),
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Coq3_Compilers.Coq_ident_Literal
                                                       (Coq3_Compilers.Z,
                                                       (Obj.magic a0))))))),
                                                       (Compilers.Coq_expr.Ident
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)),
                                                       (Coq3_Compilers.Coq_ident_Literal
                                                       (Coq3_Compilers.Z,
                                                       (Obj.magic b))))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))),
          Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                        bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                            t3 idc3 Coq3_Compilers.Coq_raw_ident_Literal)
                          (fun args0 ->
                          bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                              t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                            (fun args1 ->
                            bind1
                              (Obj.magic
                                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                              (fun args2 ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                  t0 idc0
                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                (fun args3 ->
                                match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                        (fun x3 y ->
                                        match x3 with
                                        | Coq3_Compilers.Z ->
                                          (match y with
                                           | Coq3_Compilers.Z -> true
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_bool ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> true
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_nat ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> true
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_zrange ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             true
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_string ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             true))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args3.Coq_Primitive.projT1
                                         in
                                         x3))), (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args2.Coq_Primitive.projT1
                                         in
                                         x3))))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x3))))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x3))))) with
                                | Some vars0 ->
                                  let (a, _) = Obj.magic vars0 in
                                  let (a0, _) = a in
                                  let (_, _) = a0 in
                                  if Compilers.Coq_type.type_beq
                                       (Compilers.Coq_base.Coq_type.type_beq
                                         (fun x3 y ->
                                         match x3 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true)))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args3.Coq_Primitive.projT1
                                        in
                                        x3))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x3))))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args1.Coq_Primitive.projT1
                                        in
                                        x3))))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x3)))))
                                  then bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args3.Coq_Primitive.projT1
                                            in
                                            x3)))
                                           (Coq3_Compilers.Coq_pattern_ident_Literal
                                           Coq3_Compilers.Z)
                                           (Coq3_Compilers.Coq_ident_Literal
                                           ((let (x3, _) =
                                               args3.Coq_Primitive.projT1
                                             in
                                             x3),
                                           (let (x3, _) =
                                              let (_, y) =
                                                args3.Coq_Primitive.projT2
                                              in
                                              y
                                            in
                                            x3)))) (fun xv ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x3, _) =
                                                args2.Coq_Primitive.projT1
                                              in
                                              x3)))
                                             (Coq3_Compilers.Coq_pattern_ident_Literal
                                             Coq3_Compilers.Z)
                                             (Coq3_Compilers.Coq_ident_Literal
                                             ((let (x3, _) =
                                                 args2.Coq_Primitive.projT1
                                               in
                                               x3),
                                             (let (x3, _) =
                                                let (_, y) =
                                                  args2.Coq_Primitive.projT2
                                                in
                                                y
                                              in
                                              x3)))) (fun xv0 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x3, _) =
                                                  args1.Coq_Primitive.projT1
                                                in
                                                x3)))
                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                               Coq3_Compilers.Z)
                                               (Coq3_Compilers.Coq_ident_Literal
                                               ((let (x3, _) =
                                                   args1.Coq_Primitive.projT1
                                                 in
                                                 x3),
                                               (let (x3, _) =
                                                  let (_, y) =
                                                    args1.Coq_Primitive.projT2
                                                  in
                                                  y
                                                in
                                                x3)))) (fun xv1 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 (let (x3, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x3)))
                                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                                 Coq3_Compilers.Z)
                                                 (Coq3_Compilers.Coq_ident_Literal
                                                 ((let (x3, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x3),
                                                 (let (x3, _) =
                                                    let (_, y) =
                                                      args0.Coq_Primitive.projT2
                                                    in
                                                    y
                                                  in
                                                  x3)))) (fun xv2 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x3 x4)
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)))
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)))
                                                 (fun tr ->
                                                 match tr with
                                                 | Some v ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x3 x4)
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (fun tr' ->
                                                     match tr' with
                                                     | Some v0 ->
                                                       Some
                                                         (Coq_Compilers.UnderLets.Base
                                                         (v0
                                                           (v
                                                             (let (a1, b) =
                                                                Coq1_Z.sub_with_get_borrow_full
                                                                  (let (
                                                                    x3, _) =
                                                                    xv
                                                                   in
                                                                   x3)
                                                                  (let (
                                                                    x3, _) =
                                                                    xv0
                                                                   in
                                                                   x3)
                                                                  (let (
                                                                    x3, _) =
                                                                    xv1
                                                                   in
                                                                   x3)
                                                                  (let (
                                                                    x3, _) =
                                                                    xv2
                                                                   in
                                                                   x3)
                                                              in
                                                              Compilers.Coq_expr.App
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_expr.App
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))),
                                                              (Compilers.Coq_expr.Ident
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))))),
                                                              (Coq3_Compilers.Coq_ident_pair
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))))),
                                                              (Compilers.Coq_expr.Ident
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              (Coq3_Compilers.Z,
                                                              (Obj.magic a1))))))),
                                                              (Compilers.Coq_expr.Ident
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              (Coq3_Compilers.Z,
                                                              (Obj.magic b))))))))))
                                                     | None -> None)
                                                 | None -> None)))))
                                  else None
                                | None -> None))))
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))))),
          Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
          x2))))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq1_Z.ltz
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      (Coq3_Compilers.Z,
                                                      (Obj.magic
                                                        Coq1_Z.zselect
                                                        (let (x2, _) = xv in
                                                         x2)
                                                        (let (x2, _) = xv0 in
                                                         x2)
                                                        (let (x2, _) = xv1 in
                                                         x2)))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
          x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      (Coq3_Compilers.Z,
                                                      (Obj.magic
                                                        Coq1_Z.add_modulo
                                                        (let (x2, _) = xv in
                                                         x2)
                                                        (let (x2, _) = xv0 in
                                                         x2)
                                                        (let (x2, _) = xv1 in
                                                         x2)))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_add_modulo)),
          x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      (Coq3_Compilers.Z,
                                                      (Obj.magic
                                                        Coq1_Z.truncating_shiftl
                                                        (let (x2, _) = xv in
                                                         x2)
                                                        (let (x2, _) = xv0 in
                                                         x2)
                                                        (let (x2, _) = xv1 in
                                                         x2)))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))),
          Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x0 y ->
                         match x0 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x0, _) = args0.Coq_Primitive.projT1 in x0))) with
                 | Some _ ->
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                          match x0 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x0, _) = args0.Coq_Primitive.projT1 in x0)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Z)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x0, _) = args0.Coq_Primitive.projT1 in x0),
                            (let (x0, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x0)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tr ->
                            match tr with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr' ->
                                match tr' with
                                | Some v0 ->
                                  Some (Coq_Compilers.UnderLets.Base
                                    (v0
                                      (v (Compilers.Coq_expr.Ident
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Coq3_Compilers.Coq_ident_Literal
                                        (Coq3_Compilers.Z,
                                        (Obj.magic Coq1_Z.bneg
                                          (let (x0, _) = xv in x0)))))))))
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_Z_bneg)), x))))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq1_Z.lnot_modulo
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_Z.coq_lxor
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                        bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                            t3 idc3 Coq3_Compilers.Coq_raw_ident_Literal)
                          (fun args0 ->
                          bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                              t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                            (fun args1 ->
                            bind1
                              (Obj.magic
                                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                              (fun args2 ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                  t0 idc0
                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                (fun args3 ->
                                match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                        (fun x3 y ->
                                        match x3 with
                                        | Coq3_Compilers.Z ->
                                          (match y with
                                           | Coq3_Compilers.Z -> true
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_bool ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> true
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_nat ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> true
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_zrange ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             true
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_string ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             true))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args3.Coq_Primitive.projT1
                                         in
                                         x3))), (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args2.Coq_Primitive.projT1
                                         in
                                         x3))))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x3))))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x3))))) with
                                | Some vars0 ->
                                  let (a, _) = Obj.magic vars0 in
                                  let (a0, _) = a in
                                  let (_, _) = a0 in
                                  if Compilers.Coq_type.type_beq
                                       (Compilers.Coq_base.Coq_type.type_beq
                                         (fun x3 y ->
                                         match x3 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true)))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args3.Coq_Primitive.projT1
                                        in
                                        x3))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x3))))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args1.Coq_Primitive.projT1
                                        in
                                        x3))))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x3, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x3)))))
                                  then bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args3.Coq_Primitive.projT1
                                            in
                                            x3)))
                                           (Coq3_Compilers.Coq_pattern_ident_Literal
                                           Coq3_Compilers.Z)
                                           (Coq3_Compilers.Coq_ident_Literal
                                           ((let (x3, _) =
                                               args3.Coq_Primitive.projT1
                                             in
                                             x3),
                                           (let (x3, _) =
                                              let (_, y) =
                                                args3.Coq_Primitive.projT2
                                              in
                                              y
                                            in
                                            x3)))) (fun xv ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x3, _) =
                                                args2.Coq_Primitive.projT1
                                              in
                                              x3)))
                                             (Coq3_Compilers.Coq_pattern_ident_Literal
                                             Coq3_Compilers.Z)
                                             (Coq3_Compilers.Coq_ident_Literal
                                             ((let (x3, _) =
                                                 args2.Coq_Primitive.projT1
                                               in
                                               x3),
                                             (let (x3, _) =
                                                let (_, y) =
                                                  args2.Coq_Primitive.projT2
                                                in
                                                y
                                              in
                                              x3)))) (fun xv0 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x3, _) =
                                                  args1.Coq_Primitive.projT1
                                                in
                                                x3)))
                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                               Coq3_Compilers.Z)
                                               (Coq3_Compilers.Coq_ident_Literal
                                               ((let (x3, _) =
                                                   args1.Coq_Primitive.projT1
                                                 in
                                                 x3),
                                               (let (x3, _) =
                                                  let (_, y) =
                                                    args1.Coq_Primitive.projT2
                                                  in
                                                  y
                                                in
                                                x3)))) (fun xv1 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 (let (x3, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x3)))
                                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                                 Coq3_Compilers.Z)
                                                 (Coq3_Compilers.Coq_ident_Literal
                                                 ((let (x3, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x3),
                                                 (let (x3, _) =
                                                    let (_, y) =
                                                      args0.Coq_Primitive.projT2
                                                    in
                                                    y
                                                  in
                                                  x3)))) (fun xv2 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x3 x4)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z) (fun tr ->
                                                 match tr with
                                                 | Some v ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x3 x4)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (fun tr' ->
                                                     match tr' with
                                                     | Some v0 ->
                                                       Some
                                                         (Coq_Compilers.UnderLets.Base
                                                         (v0
                                                           (v
                                                             (Compilers.Coq_expr.Ident
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)),
                                                             (Coq3_Compilers.Coq_ident_Literal
                                                             (Coq3_Compilers.Z,
                                                             (Obj.magic
                                                               Coq1_Z.rshi
                                                               (let (
                                                                  x3, _) = xv
                                                                in
                                                                x3)
                                                               (let (
                                                                  x3, _) =
                                                                  xv0
                                                                in
                                                                x3)
                                                               (let (
                                                                  x3, _) =
                                                                  xv1
                                                                in
                                                                x3)
                                                               (let (
                                                                  x3, _) =
                                                                  xv2
                                                                in
                                                                x3)))))))))
                                                     | None -> None)
                                                 | None -> None)))))
                                  else None
                                | None -> None))))
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
          x0)), x1)), x2))))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq1_Z.cc_m
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  (match x1 with
                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args1 ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args2 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args2.Coq_Primitive.projT1
                                    in
                                    x2))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args1.Coq_Primitive.projT1
                                    in
                                    x2))))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x2, _) = args0.Coq_Primitive.projT1
                                    in
                                    x2))))) with
                           | Some vars0 ->
                             let (a, _) = Obj.magic vars0 in
                             let (_, _) = a in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args2.Coq_Primitive.projT1
                                   in
                                   x2))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args1.Coq_Primitive.projT1
                                   in
                                   x2))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x2, _) = args0.Coq_Primitive.projT1
                                   in
                                   x2)))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x2, _) =
                                         args2.Coq_Primitive.projT1
                                       in
                                       x2)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x2, _) =
                                          args2.Coq_Primitive.projT1
                                        in
                                        x2),
                                      (let (x2, _) =
                                         let (_, y) =
                                           args2.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x2)))) (fun xv ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args1.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2),
                                          (let (x2, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x2)))) (fun xv1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v0 ->
                                                Some
                                                  (Coq_Compilers.UnderLets.Base
                                                  (v0
                                                    (v
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      (Coq3_Compilers.Z,
                                                      (Obj.magic
                                                        Coq1_Z.combine_at_bitwidth
                                                        (let (x2, _) = xv in
                                                         x2)
                                                        (let (x2, _) = xv0 in
                                                         x2)
                                                        (let (x2, _) = xv1 in
                                                         x2)))))))))
                                              | None -> None)
                                          | None -> None))))
                             else None
                           | None -> None)))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))),
          Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_zrange)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_zrange)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Coq_zrange))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Coq_zrange)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Z,
                                               (Obj.magic Coq_ident.cast
                                                 (let (x1, _) = xv in x1)
                                                 (let (x1, _) = xv0 in x1)))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cast)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x1) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x2) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x1 with
                         | Compilers.Coq_expr.Ident (t2, idc2) ->
                           (match x0 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f1, x3) ->
                              (match f1 with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                 (match f2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x4 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       (match x3 with
                                        | Compilers.Coq_expr.Ident (t5, idc5) ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t5 idc5
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args0 ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t4 idc4
                                                Coq3_Compilers.Coq_raw_ident_Literal)
                                              (fun args1 ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                  t3 idc3
                                                  Coq3_Compilers.Coq_raw_ident_pair)
                                                (fun args2 ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                    t2 idc2
                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                  (fun args3 ->
                                                  bind1
                                                    (Obj.magic
                                                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                      t1 idc1
                                                      Coq3_Compilers.Coq_raw_ident_Literal)
                                                    (fun args4 ->
                                                    bind1
                                                      (Obj.magic
                                                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                        t0 idc0
                                                        Coq3_Compilers.Coq_raw_ident_pair)
                                                      (fun args5 ->
                                                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                              (fun x5 y ->
                                                              match x5 with
                                                              | Coq3_Compilers.Z ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_bool ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_nat ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_string ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   true))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)))))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)))),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))))))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x5, _) =
                                                                 let (
                                                                   x5, _) =
                                                                   args5.Coq_Primitive.projT2
                                                                 in
                                                                 x5
                                                               in
                                                               x5)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x5, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                   in
                                                                   x5
                                                                 in
                                                                 y
                                                               in
                                                               x5)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((let (
                                                                  x5, _) =
                                                                  let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                x5),
                                                              (let (x5, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                   in
                                                                   x5
                                                                 in
                                                                 y
                                                               in
                                                               x5)))))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x5, _) =
                                                                 args4.Coq_Primitive.projT1
                                                               in
                                                               x5))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x5, _) =
                                                                 args3.Coq_Primitive.projT1
                                                               in
                                                               x5))))),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x5, _) =
                                                                 let (
                                                                   x5, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x5
                                                               in
                                                               x5)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x5, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x5
                                                                 in
                                                                 y
                                                               in
                                                               x5)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((let (
                                                                  x5, _) =
                                                                  let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                x5),
                                                              (let (x5, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x5
                                                                 in
                                                                 y
                                                               in
                                                               x5)))))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x5, _) =
                                                                 args1.Coq_Primitive.projT1
                                                               in
                                                               x5))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x5, _) =
                                                                 args0.Coq_Primitive.projT1
                                                               in
                                                               x5))))))) with
                                                      | Some vars0 ->
                                                        let (a, b) =
                                                          Obj.magic vars0
                                                        in
                                                        let (a0, _) = a in
                                                        let (a1, _) = a0 in
                                                        let (_, b0) = a1 in
                                                        let (_, b1) = b0 in
                                                        let (_, _) = b1 in
                                                        let (a2, _) = b in
                                                        let (a3, _) = a2 in
                                                        let (_, b2) = a3 in
                                                        let (_, b3) = b2 in
                                                        let (_, _) = b3 in
                                                        if Compilers.Coq_type.type_beq
                                                             (Compilers.Coq_base.Coq_type.type_beq
                                                               (fun x5 y ->
                                                               match x5 with
                                                               | Coq3_Compilers.Z ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_string ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange),
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z),
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z))))))
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x5, _) =
                                                                let (
                                                                  x5, _) =
                                                                  args5.Coq_Primitive.projT2
                                                                in
                                                                x5
                                                              in
                                                              x5)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                y
                                                              in
                                                              x5)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((let (x5, _) =
                                                                 let (
                                                                   x5, _) =
                                                                   args5.Coq_Primitive.projT2
                                                                 in
                                                                 x5
                                                               in
                                                               x5),
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                y
                                                              in
                                                              x5)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x5, _) =
                                                                args4.Coq_Primitive.projT1
                                                              in
                                                              x5))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x5, _) =
                                                                args3.Coq_Primitive.projT1
                                                              in
                                                              x5))))),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x5, _) =
                                                                let (
                                                                  x5, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x5
                                                              in
                                                              x5)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                y
                                                              in
                                                              x5)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((let (x5, _) =
                                                                 let (
                                                                   x5, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x5
                                                               in
                                                               x5),
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                y
                                                              in
                                                              x5)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x5, _) =
                                                                args1.Coq_Primitive.projT1
                                                              in
                                                              x5))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x5, _) =
                                                                args0.Coq_Primitive.projT1
                                                              in
                                                              x5)))))))
                                                        then bind1
                                                               (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange),
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange))))))))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (let (
                                                                    x5, _) =
                                                                    let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                  in
                                                                  x5)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    y
                                                                  in
                                                                  x5)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((let (
                                                                    x5, _) =
                                                                    let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                   in
                                                                   x5),
                                                                 (let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    y
                                                                  in
                                                                  x5))))))))
                                                                 (Coq3_Compilers.Coq_pattern_ident_pair
                                                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange),
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)))
                                                                 (Coq3_Compilers.Coq_ident_pair
                                                                 ((let (
                                                                    x5, _) =
                                                                    let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                   in
                                                                   x5),
                                                                 (let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x5, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    y
                                                                  in
                                                                  x5))))
                                                               (fun _ ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Coq_zrange))
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x5, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                   Coq3_Compilers.Coq_zrange)
                                                                   (Coq3_Compilers.Coq_ident_Literal
                                                                   ((
                                                                    let (
                                                                    x5, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                   (let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                 (fun xv ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                   (fun xv0 ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    x5)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    y
                                                                    in
                                                                    x5)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x5
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (
                                                                    let (
                                                                    a4, b4) =
                                                                    Coq_ident.cast2
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5))
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    xv1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv2
                                                                    in
                                                                    x5))
                                                                    in
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    a4))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    b4))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))))
                                                        else None
                                                      | None -> None))))))
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, _, _) ->
                                          None
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, _, _) -> None
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)), x)),
          x0))))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               (match x0 with
                | Compilers.Coq_expr.Ident (t1, idc1) ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args0 ->
                    bind1
                      (Obj.magic
                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                        t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                      (fun args1 ->
                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                      | Some vars0 ->
                        let (_, _) = Obj.magic vars0 in
                        if Compilers.Coq_type.type_beq
                             (Compilers.Coq_base.Coq_type.type_beq
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true)))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                        then bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args1.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args1.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args1.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1)))
                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                   Coq3_Compilers.Z)
                                   (Coq3_Compilers.Coq_ident_Literal
                                   ((let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1),
                                   (let (x1, _) =
                                      let (_, y) = args0.Coq_Primitive.projT2
                                      in
                                      y
                                    in
                                    x1)))) (fun xv0 ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x1 x2 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x1 x2)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_zrange)
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Coq_zrange) (fun tr ->
                                   match tr with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x1 x2 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x1 x2)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_zrange)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_zrange) (fun tr' ->
                                       match tr' with
                                       | Some v0 ->
                                         Some (Coq_Compilers.UnderLets.Base
                                           (v0
                                             (v (Compilers.Coq_expr.Ident
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_zrange)),
                                               (Coq3_Compilers.Coq_ident_Literal
                                               (Coq3_Compilers.Coq_zrange,
                                               (Obj.magic { lower =
                                                 (let (x1, _) = xv in x1);
                                                 upper =
                                                 (let (x1, _) = xv0 in x1) }))))))))
                                       | None -> None)
                                   | None -> None)))
                        else None
                      | None -> None))
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))))),
          Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0))))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (_, _) ->
                                       None
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f3, x4) ->
                                       (match f3 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x5) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             (match x5 with
                                              | Compilers.Coq_expr.Ident (
                                                  t5, idc5) ->
                                                (match x4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t6, idc6) ->
                                                   bind1
                                                     (Obj.magic
                                                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t6 idc6
                                                       Coq3_Compilers.Coq_raw_ident_Literal)
                                                     (fun args0 ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t5 idc5
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args1 ->
                                                       bind1
                                                         (Obj.magic
                                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t4 idc4
                                                           Coq3_Compilers.Coq_raw_ident_pair)
                                                         (fun args2 ->
                                                         bind1
                                                           (Obj.magic
                                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                             t3 idc3
                                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                                           (fun args3 ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t2 idc2
                                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                                             (fun args4 ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t1 idc1
                                                                 Coq3_Compilers.Coq_raw_ident_pair)
                                                               (fun args5 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t0 idc0
                                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                                 (fun args6 ->
                                                                 match 
                                                                 Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                   (fun x6 y ->
                                                                   match x6 with
                                                                   | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))))))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))) with
                                                                 | Some vars0 ->
                                                                   let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                   in
                                                                   let (
                                                                    a0, b0) =
                                                                    a
                                                                   in
                                                                   let (
                                                                    a1, b1) =
                                                                    a0
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a1
                                                                   in
                                                                   let (
                                                                    a2, b2) =
                                                                    b1
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a2
                                                                   in
                                                                   let (
                                                                    a3, b3) =
                                                                    b2
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a3
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b3
                                                                   in
                                                                   let (
                                                                    a4, _) =
                                                                    b0
                                                                   in
                                                                   let (
                                                                    a5, _) =
                                                                    a4
                                                                   in
                                                                   let (
                                                                    _, b4) =
                                                                    a5
                                                                   in
                                                                   let (
                                                                    _, b5) =
                                                                    b4
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b5
                                                                   in
                                                                   let (
                                                                    a6, _) =
                                                                    b
                                                                   in
                                                                   let (
                                                                    a7, _) =
                                                                    a6
                                                                   in
                                                                   let (
                                                                    _, b6) =
                                                                    a7
                                                                   in
                                                                   let (
                                                                    _, b7) =
                                                                    b6
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b7
                                                                   in
                                                                   if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x6 y ->
                                                                    match x6 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))))))
                                                                   then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (
                                                                    let (
                                                                    a8, b8) =
                                                                    Coq_ident.Coq_fancy.add
                                                                    (((
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6)),
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    xv1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv2
                                                                    in
                                                                    x6)))
                                                                    in
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    a8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    b8))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))
                                                                   else None
                                                                 | None ->
                                                                   None)))))))
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_fancy_add)), x))))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (_, _) ->
                                       None
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f3, x4) ->
                                       (match f3 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x5) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             (match x5 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f5, x6) ->
                                                (match f5 with
                                                 | Compilers.Coq_expr.Ident (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, f6, x7) ->
                                                   (match f6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t6, idc6) ->
                                                         (match x6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              t7, idc7) ->
                                                            (match x4 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t8, idc8) ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t8 idc8
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args0 ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args1 ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, b1) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    a4, b3) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    a5, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    a6, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a7, _) =
                                                                    a6
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    a7
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    a8, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a9, b6) =
                                                                    a8
                                                                    in
                                                                    let (
                                                                    a10, b7) =
                                                                    a9
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a10
                                                                    in
                                                                    let (
                                                                    _, b8) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    a11, _) =
                                                                    b8
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a11
                                                                    in
                                                                    let (
                                                                    a12, _) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    a13, _) =
                                                                    a12
                                                                    in
                                                                    let (
                                                                    _, b9) =
                                                                    a13
                                                                    in
                                                                    let (
                                                                    _, b10) =
                                                                    b9
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b10
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (
                                                                    let (
                                                                    a14, b11) =
                                                                    Coq_ident.Coq_fancy.addc
                                                                    (((
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)),
                                                                    (((
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    x8)))
                                                                    in
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    a14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    b11))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_fancy_addc)), x))))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (_, _) ->
                                       None
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f3, x4) ->
                                       (match f3 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x5) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             (match x5 with
                                              | Compilers.Coq_expr.Ident (
                                                  t5, idc5) ->
                                                (match x4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t6, idc6) ->
                                                   bind1
                                                     (Obj.magic
                                                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t6 idc6
                                                       Coq3_Compilers.Coq_raw_ident_Literal)
                                                     (fun args0 ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t5 idc5
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args1 ->
                                                       bind1
                                                         (Obj.magic
                                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t4 idc4
                                                           Coq3_Compilers.Coq_raw_ident_pair)
                                                         (fun args2 ->
                                                         bind1
                                                           (Obj.magic
                                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                             t3 idc3
                                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                                           (fun args3 ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t2 idc2
                                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                                             (fun args4 ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t1 idc1
                                                                 Coq3_Compilers.Coq_raw_ident_pair)
                                                               (fun args5 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t0 idc0
                                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                                 (fun args6 ->
                                                                 match 
                                                                 Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                   (fun x6 y ->
                                                                   match x6 with
                                                                   | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))))))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))) with
                                                                 | Some vars0 ->
                                                                   let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                   in
                                                                   let (
                                                                    a0, b0) =
                                                                    a
                                                                   in
                                                                   let (
                                                                    a1, b1) =
                                                                    a0
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a1
                                                                   in
                                                                   let (
                                                                    a2, b2) =
                                                                    b1
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a2
                                                                   in
                                                                   let (
                                                                    a3, b3) =
                                                                    b2
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a3
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b3
                                                                   in
                                                                   let (
                                                                    a4, _) =
                                                                    b0
                                                                   in
                                                                   let (
                                                                    a5, _) =
                                                                    a4
                                                                   in
                                                                   let (
                                                                    _, b4) =
                                                                    a5
                                                                   in
                                                                   let (
                                                                    _, b5) =
                                                                    b4
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b5
                                                                   in
                                                                   let (
                                                                    a6, _) =
                                                                    b
                                                                   in
                                                                   let (
                                                                    a7, _) =
                                                                    a6
                                                                   in
                                                                   let (
                                                                    _, b6) =
                                                                    a7
                                                                   in
                                                                   let (
                                                                    _, b7) =
                                                                    b6
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b7
                                                                   in
                                                                   if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x6 y ->
                                                                    match x6 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))))))
                                                                   then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (
                                                                    let (
                                                                    a8, b8) =
                                                                    Coq_ident.Coq_fancy.sub
                                                                    (((
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6)),
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    xv1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv2
                                                                    in
                                                                    x6)))
                                                                    in
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    a8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    b8))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))
                                                                   else None
                                                                 | None ->
                                                                   None)))))))
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_fancy_sub)), x))))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (_, _) ->
                                       None
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f3, x4) ->
                                       (match f3 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x5) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             (match x5 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f5, x6) ->
                                                (match f5 with
                                                 | Compilers.Coq_expr.Ident (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, f6, x7) ->
                                                   (match f6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t6, idc6) ->
                                                         (match x6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              t7, idc7) ->
                                                            (match x4 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t8, idc8) ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t8 idc8
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args0 ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args1 ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, b1) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    a4, b3) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    a5, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    a6, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a7, _) =
                                                                    a6
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    a7
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    a8, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a9, b6) =
                                                                    a8
                                                                    in
                                                                    let (
                                                                    a10, b7) =
                                                                    a9
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a10
                                                                    in
                                                                    let (
                                                                    _, b8) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    a11, _) =
                                                                    b8
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a11
                                                                    in
                                                                    let (
                                                                    a12, _) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    a13, _) =
                                                                    a12
                                                                    in
                                                                    let (
                                                                    _, b9) =
                                                                    a13
                                                                    in
                                                                    let (
                                                                    _, b10) =
                                                                    b9
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b10
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (
                                                                    let (
                                                                    a14, b11) =
                                                                    Coq_ident.Coq_fancy.subb
                                                                    (((
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)),
                                                                    (((
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    x8)))
                                                                    in
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    a14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    b11))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_fancy_subb)), x))))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f1, x2) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x3) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x3 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x2 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t4 idc4
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                           (fun args1 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_pair)
                                             (fun args2 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                               (fun args3 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args4 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x4 y ->
                                                         match x4 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args3.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x4))))))) with
                                                 | Some vars0 ->
                                                   let (a, b) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, _) = a in
                                                   let (_, b0) = a0 in
                                                   let (a1, b1) = b0 in
                                                   let (_, _) = a1 in
                                                   let (_, b2) = b1 in
                                                   let (_, _) = b2 in
                                                   let (a2, _) = b in
                                                   let (a3, _) = a2 in
                                                   let (_, b3) = a3 in
                                                   let (_, b4) = b3 in
                                                   let (_, _) = b4 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x4 y ->
                                                          match x4 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args4.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args3.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args2.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x4)))))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (x4, _) =
                                                                 args4.Coq_Primitive.projT2
                                                               in
                                                               x4
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)))) (fun _ ->
                                                          bind1
                                                            (Obj.magic
                                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x4, _) =
                                                                 args3.Coq_Primitive.projT1
                                                               in
                                                               x4)))
                                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                                              Coq3_Compilers.Z)
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              ((let (
                                                                  x4, _) =
                                                                  args3.Coq_Primitive.projT1
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   args3.Coq_Primitive.projT2
                                                                 in
                                                                 y
                                                               in
                                                               x4))))
                                                            (fun xv ->
                                                            bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))))))
                                                                (Coq3_Compilers.Coq_pattern_ident_pair
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (Coq3_Compilers.Coq_ident_pair
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x4)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Z)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                  (let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x4))))
                                                                (fun xv0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x4))))
                                                                  (fun xv1 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.mulll
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4),
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv1
                                                                    in
                                                                    x4)))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                   else None
                                                 | None -> None)))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_mulll)), x))))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f1, x2) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x3) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x3 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x2 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t4 idc4
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                           (fun args1 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_pair)
                                             (fun args2 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                               (fun args3 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args4 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x4 y ->
                                                         match x4 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args3.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x4))))))) with
                                                 | Some vars0 ->
                                                   let (a, b) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, _) = a in
                                                   let (_, b0) = a0 in
                                                   let (a1, b1) = b0 in
                                                   let (_, _) = a1 in
                                                   let (_, b2) = b1 in
                                                   let (_, _) = b2 in
                                                   let (a2, _) = b in
                                                   let (a3, _) = a2 in
                                                   let (_, b3) = a3 in
                                                   let (_, b4) = b3 in
                                                   let (_, _) = b4 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x4 y ->
                                                          match x4 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args4.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args3.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args2.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x4)))))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (x4, _) =
                                                                 args4.Coq_Primitive.projT2
                                                               in
                                                               x4
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)))) (fun _ ->
                                                          bind1
                                                            (Obj.magic
                                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x4, _) =
                                                                 args3.Coq_Primitive.projT1
                                                               in
                                                               x4)))
                                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                                              Coq3_Compilers.Z)
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              ((let (
                                                                  x4, _) =
                                                                  args3.Coq_Primitive.projT1
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   args3.Coq_Primitive.projT2
                                                                 in
                                                                 y
                                                               in
                                                               x4))))
                                                            (fun xv ->
                                                            bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))))))
                                                                (Coq3_Compilers.Coq_pattern_ident_pair
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (Coq3_Compilers.Coq_ident_pair
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x4)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Z)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                  (let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x4))))
                                                                (fun xv0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x4))))
                                                                  (fun xv1 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.mullh
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4),
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv1
                                                                    in
                                                                    x4)))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                   else None
                                                 | None -> None)))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_mullh)), x))))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f1, x2) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x3) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x3 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x2 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t4 idc4
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                           (fun args1 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_pair)
                                             (fun args2 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                               (fun args3 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args4 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x4 y ->
                                                         match x4 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args3.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x4))))))) with
                                                 | Some vars0 ->
                                                   let (a, b) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, _) = a in
                                                   let (_, b0) = a0 in
                                                   let (a1, b1) = b0 in
                                                   let (_, _) = a1 in
                                                   let (_, b2) = b1 in
                                                   let (_, _) = b2 in
                                                   let (a2, _) = b in
                                                   let (a3, _) = a2 in
                                                   let (_, b3) = a3 in
                                                   let (_, b4) = b3 in
                                                   let (_, _) = b4 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x4 y ->
                                                          match x4 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args4.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args3.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args2.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x4)))))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (x4, _) =
                                                                 args4.Coq_Primitive.projT2
                                                               in
                                                               x4
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)))) (fun _ ->
                                                          bind1
                                                            (Obj.magic
                                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x4, _) =
                                                                 args3.Coq_Primitive.projT1
                                                               in
                                                               x4)))
                                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                                              Coq3_Compilers.Z)
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              ((let (
                                                                  x4, _) =
                                                                  args3.Coq_Primitive.projT1
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   args3.Coq_Primitive.projT2
                                                                 in
                                                                 y
                                                               in
                                                               x4))))
                                                            (fun xv ->
                                                            bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))))))
                                                                (Coq3_Compilers.Coq_pattern_ident_pair
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (Coq3_Compilers.Coq_ident_pair
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x4)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Z)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                  (let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x4))))
                                                                (fun xv0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x4))))
                                                                  (fun xv1 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.mulhl
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4),
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv1
                                                                    in
                                                                    x4)))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                   else None
                                                 | None -> None)))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_mulhl)), x))))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f1, x2) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x3) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x3 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x2 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t4 idc4
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                           (fun args1 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_pair)
                                             (fun args2 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                               (fun args3 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args4 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x4 y ->
                                                         match x4 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args3.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x4))))))) with
                                                 | Some vars0 ->
                                                   let (a, b) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, _) = a in
                                                   let (_, b0) = a0 in
                                                   let (a1, b1) = b0 in
                                                   let (_, _) = a1 in
                                                   let (_, b2) = b1 in
                                                   let (_, _) = b2 in
                                                   let (a2, _) = b in
                                                   let (a3, _) = a2 in
                                                   let (_, b3) = a3 in
                                                   let (_, b4) = b3 in
                                                   let (_, _) = b4 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x4 y ->
                                                          match x4 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args4.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args3.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args2.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x4)))))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (x4, _) =
                                                                 args4.Coq_Primitive.projT2
                                                               in
                                                               x4
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)))) (fun _ ->
                                                          bind1
                                                            (Obj.magic
                                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x4, _) =
                                                                 args3.Coq_Primitive.projT1
                                                               in
                                                               x4)))
                                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                                              Coq3_Compilers.Z)
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              ((let (
                                                                  x4, _) =
                                                                  args3.Coq_Primitive.projT1
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   args3.Coq_Primitive.projT2
                                                                 in
                                                                 y
                                                               in
                                                               x4))))
                                                            (fun xv ->
                                                            bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))))))
                                                                (Coq3_Compilers.Coq_pattern_ident_pair
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (Coq3_Compilers.Coq_ident_pair
                                                                ((let (
                                                                    x4, _) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x4
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x4)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Z)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                  (let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x4))))
                                                                (fun xv0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x4))))
                                                                  (fun xv1 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.mulhh
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4),
                                                                    ((
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv1
                                                                    in
                                                                    x4)))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                   else None
                                                 | None -> None)))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_mulhh)), x))))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (_, _) ->
                                       None
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f3, x4) ->
                                       (match f3 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x5) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             (match x5 with
                                              | Compilers.Coq_expr.Ident (
                                                  t5, idc5) ->
                                                (match x4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t6, idc6) ->
                                                   bind1
                                                     (Obj.magic
                                                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t6 idc6
                                                       Coq3_Compilers.Coq_raw_ident_Literal)
                                                     (fun args0 ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t5 idc5
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args1 ->
                                                       bind1
                                                         (Obj.magic
                                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t4 idc4
                                                           Coq3_Compilers.Coq_raw_ident_pair)
                                                         (fun args2 ->
                                                         bind1
                                                           (Obj.magic
                                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                             t3 idc3
                                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                                           (fun args3 ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t2 idc2
                                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                                             (fun args4 ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t1 idc1
                                                                 Coq3_Compilers.Coq_raw_ident_pair)
                                                               (fun args5 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t0 idc0
                                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                                 (fun args6 ->
                                                                 match 
                                                                 Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                   (fun x6 y ->
                                                                   match x6 with
                                                                   | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))))))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))) with
                                                                 | Some vars0 ->
                                                                   let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                   in
                                                                   let (
                                                                    a0, b0) =
                                                                    a
                                                                   in
                                                                   let (
                                                                    a1, b1) =
                                                                    a0
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a1
                                                                   in
                                                                   let (
                                                                    a2, b2) =
                                                                    b1
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a2
                                                                   in
                                                                   let (
                                                                    a3, b3) =
                                                                    b2
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a3
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b3
                                                                   in
                                                                   let (
                                                                    a4, _) =
                                                                    b0
                                                                   in
                                                                   let (
                                                                    a5, _) =
                                                                    a4
                                                                   in
                                                                   let (
                                                                    _, b4) =
                                                                    a5
                                                                   in
                                                                   let (
                                                                    _, b5) =
                                                                    b4
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b5
                                                                   in
                                                                   let (
                                                                    a6, _) =
                                                                    b
                                                                   in
                                                                   let (
                                                                    a7, _) =
                                                                    a6
                                                                   in
                                                                   let (
                                                                    _, b6) =
                                                                    a7
                                                                   in
                                                                   let (
                                                                    _, b7) =
                                                                    b6
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b7
                                                                   in
                                                                   if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x6 y ->
                                                                    match x6 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))))))
                                                                   then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.rshi
                                                                    (((
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6)),
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    xv1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv2
                                                                    in
                                                                    x6)))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))
                                                                   else None
                                                                 | None ->
                                                                   None)))))))
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_rshi)), x))))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t4 idc4
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                           (fun args1 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                             (fun args2 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_pair)
                                               (fun args3 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args4 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x4 y ->
                                                         match x4 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args3.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args3.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args2.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x4))))) with
                                                 | Some vars0 ->
                                                   let (a, _) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, b) = a in
                                                   let (a1, b0) = a0 in
                                                   let (_, _) = a1 in
                                                   let (_, b1) = b0 in
                                                   let (a2, _) = b1 in
                                                   let (_, _) = a2 in
                                                   let (a3, _) = b in
                                                   let (a4, _) = a3 in
                                                   let (_, b2) = a4 in
                                                   let (_, b3) = b2 in
                                                   let (_, _) = b3 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x4 y ->
                                                          match x4 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args4.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args3.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args2.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x4)))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (x4, _) =
                                                                 args4.Coq_Primitive.projT2
                                                               in
                                                               x4
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)))) (fun _ ->
                                                          bind1
                                                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))))))))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x4, _) =
                                                                 let (
                                                                   x4, _) =
                                                                   args3.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               x4)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((let (
                                                                  x4, _) =
                                                                  let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                  in
                                                                  x4
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4))))))))
                                                              (Coq3_Compilers.Coq_pattern_ident_pair
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))
                                                              (Coq3_Compilers.Coq_ident_pair
                                                              ((let (
                                                                  x4, _) =
                                                                  let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                  in
                                                                  x4
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4))))
                                                            (fun _ ->
                                                            bind1
                                                              (Obj.magic
                                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x4, _) =
                                                                   args2.Coq_Primitive.projT1
                                                                 in
                                                                 x4)))
                                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                Coq3_Compilers.Z)
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                ((let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))
                                                              (fun xv ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x4)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Z)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                  (let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x4))))
                                                                (fun xv0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x4))))
                                                                  (fun xv1 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.selc
                                                                    (((
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4)),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv1
                                                                    in
                                                                    x4))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                   else None
                                                 | None -> None)))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_selc)), x))))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f1, x2) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x3) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x3 with
                                  | Compilers.Coq_expr.Ident (_, _) -> None
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, f3, x4) ->
                                    (match f3 with
                                     | Compilers.Coq_expr.Ident (_, _) ->
                                       None
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f4, x5) ->
                                       (match f4 with
                                        | Compilers.Coq_expr.Ident (t3, idc3) ->
                                          (match x5 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             (match x4 with
                                              | Compilers.Coq_expr.Ident (
                                                  t5, idc5) ->
                                                (match x2 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t6, idc6) ->
                                                   bind1
                                                     (Obj.magic
                                                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t6 idc6
                                                       Coq3_Compilers.Coq_raw_ident_Literal)
                                                     (fun args0 ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t5 idc5
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args1 ->
                                                       bind1
                                                         (Obj.magic
                                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t4 idc4
                                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                                         (fun args2 ->
                                                         bind1
                                                           (Obj.magic
                                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                             t3 idc3
                                                             Coq3_Compilers.Coq_raw_ident_pair)
                                                           (fun args3 ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t2 idc2
                                                               Coq3_Compilers.Coq_raw_ident_pair)
                                                             (fun args4 ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t1 idc1
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args5 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t0 idc0
                                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                                 (fun args6 ->
                                                                 match 
                                                                 Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                   (fun x6 y ->
                                                                   match x6 with
                                                                   | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))))))
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                   (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))) with
                                                                 | Some vars0 ->
                                                                   let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                   in
                                                                   let (
                                                                    a0, _) =
                                                                    a
                                                                   in
                                                                   let (
                                                                    _, b0) =
                                                                    a0
                                                                   in
                                                                   let (
                                                                    a1, b1) =
                                                                    b0
                                                                   in
                                                                   let (
                                                                    a2, _) =
                                                                    a1
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a2
                                                                   in
                                                                   let (
                                                                    _, b2) =
                                                                    b1
                                                                   in
                                                                   let (
                                                                    a3, _) =
                                                                    b2
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a3
                                                                   in
                                                                   let (
                                                                    a4, _) =
                                                                    b
                                                                   in
                                                                   let (
                                                                    a5, b3) =
                                                                    a4
                                                                   in
                                                                   let (
                                                                    a6, b4) =
                                                                    a5
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a6
                                                                   in
                                                                   let (
                                                                    _, b5) =
                                                                    b4
                                                                   in
                                                                   let (
                                                                    a7, _) =
                                                                    b5
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    a7
                                                                   in
                                                                   let (
                                                                    a8, _) =
                                                                    b3
                                                                   in
                                                                   let (
                                                                    a9, _) =
                                                                    a8
                                                                   in
                                                                   let (
                                                                    _, b6) =
                                                                    a9
                                                                   in
                                                                   let (
                                                                    _, b7) =
                                                                    b6
                                                                   in
                                                                   let (
                                                                    _, _) =
                                                                    b7
                                                                   in
                                                                   if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x6 y ->
                                                                    match x6 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))))))
                                                                   then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.selm
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6),
                                                                    (((
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv1
                                                                    in
                                                                    x6)),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv2
                                                                    in
                                                                    x6)))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))
                                                                   else None
                                                                 | None ->
                                                                   None)))))))
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, _, _) ->
                                          None
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_selm)), x))))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t4 idc4
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                           (fun args1 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                             (fun args2 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_pair)
                                               (fun args3 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args4 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x4 y ->
                                                         match x4 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args3.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args3.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args2.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x4))))) with
                                                 | Some vars0 ->
                                                   let (a, _) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, b) = a in
                                                   let (a1, b0) = a0 in
                                                   let (_, _) = a1 in
                                                   let (_, b1) = b0 in
                                                   let (a2, _) = b1 in
                                                   let (_, _) = a2 in
                                                   let (a3, _) = b in
                                                   let (a4, _) = a3 in
                                                   let (_, b2) = a4 in
                                                   let (_, b3) = b2 in
                                                   let (_, _) = b3 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x4 y ->
                                                          match x4 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args4.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args3.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args2.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x4)))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (x4, _) =
                                                                 args4.Coq_Primitive.projT2
                                                               in
                                                               x4
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)))) (fun _ ->
                                                          bind1
                                                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))))))))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x4, _) =
                                                                 let (
                                                                   x4, _) =
                                                                   args3.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               x4)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((let (
                                                                  x4, _) =
                                                                  let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                  in
                                                                  x4
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4))))))))
                                                              (Coq3_Compilers.Coq_pattern_ident_pair
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))
                                                              (Coq3_Compilers.Coq_ident_pair
                                                              ((let (
                                                                  x4, _) =
                                                                  let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                  in
                                                                  x4
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4))))
                                                            (fun _ ->
                                                            bind1
                                                              (Obj.magic
                                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x4, _) =
                                                                   args2.Coq_Primitive.projT1
                                                                 in
                                                                 x4)))
                                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                Coq3_Compilers.Z)
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                ((let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))
                                                              (fun xv ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x4)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Z)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                  (let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x4))))
                                                                (fun xv0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x4))))
                                                                  (fun xv1 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.sell
                                                                    (((
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4)),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv1
                                                                    in
                                                                    x4))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                   else None
                                                 | None -> None)))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_sell)), x))))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, f1, x2) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x3) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x3 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x0 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t4 idc4
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         bind1
                                           (Obj.magic
                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                           (fun args1 ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                             (fun args2 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_pair)
                                               (fun args3 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args4 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x4 y ->
                                                         match x4 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args4.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (x4, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args3.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x4, _) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           x4),
                                                         (let (x4, _) =
                                                            let (_, y) =
                                                              let (x4, _) =
                                                                args3.Coq_Primitive.projT2
                                                              in
                                                              x4
                                                            in
                                                            y
                                                          in
                                                          x4)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args2.Coq_Primitive.projT1
                                                          in
                                                          x4))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x4, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x4))))) with
                                                 | Some vars0 ->
                                                   let (a, _) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, b) = a in
                                                   let (a1, b0) = a0 in
                                                   let (_, _) = a1 in
                                                   let (_, b1) = b0 in
                                                   let (a2, _) = b1 in
                                                   let (_, _) = a2 in
                                                   let (a3, _) = b in
                                                   let (a4, _) = a3 in
                                                   let (_, b2) = a4 in
                                                   let (_, b3) = b2 in
                                                   let (_, _) = b3 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x4 y ->
                                                          match x4 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args4.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args4.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args4.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (x4, _) =
                                                             args3.Coq_Primitive.projT2
                                                           in
                                                           x4
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x4, _) =
                                                            let (x4, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x4
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             let (x4, _) =
                                                               args3.Coq_Primitive.projT2
                                                             in
                                                             x4
                                                           in
                                                           y
                                                         in
                                                         x4)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args2.Coq_Primitive.projT1
                                                         in
                                                         x4))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x4)))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (x4, _) =
                                                                 args4.Coq_Primitive.projT2
                                                               in
                                                               x4
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x4, _) =
                                                                let (
                                                                  x4, _) =
                                                                  args4.Coq_Primitive.projT2
                                                                in
                                                                x4
                                                              in
                                                              x4),
                                                            (let (x4, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x4, _) =
                                                                   args4.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               y
                                                             in
                                                             x4)))) (fun _ ->
                                                          bind1
                                                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))))))))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x4, _) =
                                                                 let (
                                                                   x4, _) =
                                                                   args3.Coq_Primitive.projT2
                                                                 in
                                                                 x4
                                                               in
                                                               x4)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((let (
                                                                  x4, _) =
                                                                  let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                  in
                                                                  x4
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4))))))))
                                                              (Coq3_Compilers.Coq_pattern_ident_pair
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))
                                                              (Coq3_Compilers.Coq_ident_pair
                                                              ((let (
                                                                  x4, _) =
                                                                  let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                  in
                                                                  x4
                                                                in
                                                                x4),
                                                              (let (x4, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x4, _) =
                                                                    args3.Coq_Primitive.projT2
                                                                   in
                                                                   x4
                                                                 in
                                                                 y
                                                               in
                                                               x4))))
                                                            (fun _ ->
                                                            bind1
                                                              (Obj.magic
                                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x4, _) =
                                                                   args2.Coq_Primitive.projT1
                                                                 in
                                                                 x4)))
                                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                Coq3_Compilers.Z)
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                ((let (
                                                                    x4, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                  in
                                                                  x4),
                                                                (let (
                                                                   x4, _) =
                                                                   let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   y
                                                                 in
                                                                 x4))))
                                                              (fun xv ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x4)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Z)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x4, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                  (let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x4))))
                                                                (fun xv0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x4))))
                                                                  (fun xv1 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_ident.Coq_fancy.addm
                                                                    (((
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4)),
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv1
                                                                    in
                                                                    x4))))))))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                   else None
                                                 | None -> None)))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_fancy_addm)), x))))

    (** val rewrite_head_no_dtree0 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 do_again =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None all_rewrite_rules do_again

    (** val rewrite_head1 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteNBE :
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteNBE opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false, __) :: ((false, __) :: ((false, __) :: ((false,
            __) :: ((false,
            __) :: nbe_rewrite_rulesT)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
        t0 e
   end

  (** val coq_PartialEvaluate :
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr **)

  let coq_PartialEvaluate =
    RewriteRules.coq_RewriteNBE
 end

module Coq12_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x0)))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x1)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2))))))) })) :: [])

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_Nat_add,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Nat_add,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2))))))) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))),
              Coq3_Compilers.Coq_ident_Nat_add)), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))),
              Coq3_Compilers.Coq_ident_Nat_add)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), x0)))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), x1)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), x2))))))) }; Primitive.snd = () }) }

    (** val all_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))),
        Coq3_Compilers.Coq_pattern_ident_Nat_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))) } :: [])) (Obj.magic pr2_rewrite_rules)

    (** val rewrite_head :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x0 with
           | Compilers.Coq_expr.Ident (_, _) -> None
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (s0, _, f, x1) ->
             (match f with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                (match f0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   bind1
                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Nat_add)
                     (fun _ ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x3 y ->
                             match x3 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat))))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)),
                             (Compilers.Coq_type.Coq_arrow (s1, s0)))) with
                     | Some vars0 ->
                       let (_, b) = Obj.magic vars0 in
                       let (_, _) = b in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x3 y ->
                              match x3 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat))))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_arrow (s1, s0))))
                       then Compilers.Coq_base.try_make_transport_cps
                              (fun _ x3 x4 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x3 x4)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_nat) (fun tro ->
                              match tro with
                              | Some v ->
                                Compilers.Coq_type.try_make_transport_cps
                                  (fun _ x3 x4 _ ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x5 x6 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x5 x6) x3 x4) s1
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Coq_nat)) (fun tro0 ->
                                  match tro0 with
                                  | Some v0 ->
                                    Compilers.Coq_type.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x5 x6 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x5 x6) x3 x4) s0
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Coq_nat)) (fun tro1 ->
                                      match tro1 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Coq_nat)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Coq_nat) (fun tr ->
                                          match tr with
                                          | Some v2 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x3 x4 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x3 x4)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_nat)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_nat)
                                              (fun tr0 ->
                                              match tr0 with
                                              | Some v3 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x3 x4 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x3 x4)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_nat)
                                                  (fun tr1 ->
                                                  match tr1 with
                                                  | Some v4 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x3 x4 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x3 x4)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_nat)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_nat)
                                                      (fun tr2 ->
                                                      match tr2 with
                                                      | Some v5 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x3 x4 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x3 x4)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_nat)
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v6 ->
                                                            Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                  false
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat))
                                                                  (Compilers.Coq_expr.App
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_expr.App
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)))),
                                                                  (Compilers.Coq_expr.Ident
                                                                  ((Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)))))),
                                                                  Coq3_Compilers.Coq_ident_Nat_add)),
                                                                  (Compilers.Coq_expr.App
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_expr.App
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)))),
                                                                  (Compilers.Coq_expr.Ident
                                                                  ((Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)))))),
                                                                  Coq3_Compilers.Coq_ident_Nat_add)),
                                                                  (Compilers.Coq_expr.Var
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (Obj.magic
                                                                    v2 
                                                                    (v x)))))),
                                                                  (Compilers.Coq_expr.Var
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))))),
                                                                  (Compilers.Coq_expr.Var
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_nat)),
                                                                  (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                (fun fv ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v6 (v5 fv))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None)
                       else None
                     | None -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x0 with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x1) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     bind1
                       (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_add)
                       (fun _ ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x3 y ->
                               match x3 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)),
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z))))))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)),
                               (Compilers.Coq_type.Coq_arrow (s1, s0)))) with
                       | Some vars0 ->
                         let (_, b) = Obj.magic vars0 in
                         let (_, _) = b in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x3 y ->
                                match x3 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_arrow (s1, s0))))
                         then Compilers.Coq_base.try_make_transport_cps
                                (fun _ x3 x4 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x3
                                  x4)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tro ->
                                match tro with
                                | Some v ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x3 x4 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x5 x6 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x5 x6) x3 x4) s1
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)) (fun tro0 ->
                                    match tro0 with
                                    | Some v0 ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x3 x4 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x5 x6 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x5 x6) x3 x4) s0
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)) (fun tro1 ->
                                        match tro1 with
                                        | Some v1 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x3 x4 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x3 x4)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr ->
                                            match tr with
                                            | Some v2 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x3 x4 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x3 x4)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr0 ->
                                                match tr0 with
                                                | Some v3 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x3 x4 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x3 x4)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v4 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr2 ->
                                                        match tr2 with
                                                        | Some v5 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v6 ->
                                                              Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v2 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                  (fun fv ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v6 (v5 fv))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_add)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cast)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 do_again =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None all_rewrite_rules do_again

    (** val rewrite_head1 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteAddAssocLeft :
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteAddAssocLeft opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            add_assoc_left_rewrite_rulesT;
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S
            O)); Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S O)) t0 e
   end
 end

module Coq13_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules max_const_val =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 _ x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x1))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 (Zpos XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.eqb t0 (Zpos XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_div)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 t0 ->
          if Coq_Z.eqb t0 (Zpos XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_modulo)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 ->
          if Coq_Z.eqb t0 (Zpos XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ ->
          if Coq_Z.eqb t0 (Zneg XH)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.gtb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.gtb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.gtb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.gtb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
            (Obj.magic Coq_Z.mul t0 t1)))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 ->
          if Coq_Z.ltb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 t0 ->
          if (&&) (Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0)))
               (negb (Coq_Z.eqb t0 (Zpos (XO XH))))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftl)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 ->
          if (&&) (Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0)))
               (negb (Coq_Z.eqb t0 (Zpos (XO XH))))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftl)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_div)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 t0 ->
          if Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_modulo)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 t0 ->
          if Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub t0 (Zpos XH)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 ->
          if (&&) (Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val))
               (Coq_Z.leb (Coq_Z.abs t1) (Coq_Z.abs max_const_val))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t1))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 x1 t1 ->
          if (&&) (Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val))
               (Coq_Z.leb (Coq_Z.abs t1) (Coq_Z.abs max_const_val))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t1))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 x1 ->
          if Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 ->
          if Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))),
            Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))),
            Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 t0 x1 x2 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 t0 x1 x2 ->
          if Coq_Z.eqb t0 Z0
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 x3 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x4 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x4)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))))),
            Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 x3 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x4 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x4)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))))),
            Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x3)))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 ->
          if Coq_Compilers.SubstVarLike.is_recursively_var_or_ident
               Coq3_Compilers.ident_is_var_like (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
               x0
          then None
          else Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Obj.magic x0))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v))))))))) })) :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_fst,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_snd,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []))), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S O)),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S O))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S O)))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S O))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S
        O)))))), (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S O)))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S
        O))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        O)))))))), Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []),
        None, (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S O))))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        (Some (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S O)))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S O))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S O)))))))))))), (Coq1_Compilers.RewriteRules.Compile.Swap
        ((S O), (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_mul,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S O))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O)))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O)))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_mul,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_mul,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_mul,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S O))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S O)))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))))))))))))))))))))))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_div,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_modulo,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_lor,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S O)))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S O))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S O)))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S O))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))) :: []))))))),
        (Some (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S O))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S (S O))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules max_const_val =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 _ x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x0)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x1))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 (Zpos XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.eqb t0 (Zpos XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 t0 ->
            if Coq_Z.eqb t0 (Zpos XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 ->
            if Coq_Z.eqb t0 (Zpos XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ ->
            if Coq_Z.eqb t0 (Zneg XH)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.gtb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.gtb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.gtb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.gtb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x0)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
              (Obj.magic Coq_Z.mul t0 t1)))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 ->
            if Coq_Z.ltb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 t0 ->
            if (&&) (Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0)))
                 (negb (Coq_Z.eqb t0 (Zpos (XO XH))))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftl)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 ->
            if (&&) (Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0)))
                 (negb (Coq_Z.eqb t0 (Zpos (XO XH))))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftl)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 t0 ->
            if Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 t0 ->
            if Coq_Z.eqb t0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t0))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub t0 (Zpos XH)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 ->
            if (&&) (Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val))
                 (Coq_Z.leb (Coq_Z.abs t1) (Coq_Z.abs max_const_val))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t1))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 x1 t1 ->
            if (&&) (Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val))
                 (Coq_Z.leb (Coq_Z.abs t1) (Coq_Z.abs max_const_val))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t1))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 x1 ->
            if Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 ->
            if Coq_Z.leb (Coq_Z.abs t0) (Coq_Z.abs max_const_val)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))),
              Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))),
              Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 t0 x1 x2 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 t0 x1 x2 ->
            if Coq_Z.eqb t0 Z0
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 x2 x3 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x4)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))))),
              Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 x2 x3 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x4)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))))),
              Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x3)))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 ->
            if Coq_Compilers.SubstVarLike.is_recursively_var_or_ident
                 Coq3_Compilers.ident_is_var_like
                 (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z)) x0
            then None
            else Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Obj.magic x0))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v))))))))) }; Primitive.snd =
          () } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } }) }

    (** val all_rewrite_rules :
        z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules max_const_val =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_div)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_modulo)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_div)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_modulo)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: []))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
        (Obj.magic pr2_rewrite_rules max_const_val)

    (** val rewrite_head :
        z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head max_const_val _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, x0) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t0))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH)))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t0)))
                                  (Coq3_Compilers.Coq_pattern_ident_fst
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_fst
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some v ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some _ ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b1 t0
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t0 t0
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                b1)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b1),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0))),
          (Coq3_Compilers.Coq_ident_fst (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, _) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t1))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t1)))
                                  (Coq3_Compilers.Coq_pattern_ident_snd
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_snd
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some _ ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b0 t1
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t1 t1
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                b0)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b0),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1))),
          (Coq3_Compilers.Coq_ident_snd (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (sequence
              (match x with
               | Compilers.Coq_expr.Ident (t0, idc0) ->
                 bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))))
                     then bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))
                              (Coq3_Compilers.Coq_pattern_ident_Literal
                              Coq3_Compilers.Z)
                              (Coq3_Compilers.Coq_ident_Literal
                              ((let (x1, _) = args0.Coq_Primitive.projT1 in x1),
                              (let (x1, _) =
                                 let (_, y) = args0.Coq_Primitive.projT2 in y
                               in
                               x1)))) (fun xv ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1 x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some v ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1)
                                                    Z0
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v0 (v x0)))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v2 (v1 fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None)
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, _, _) -> None
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (sequence
                (match x0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                       then Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1 x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some v ->
                                bind1
                                  (Obj.magic
                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1)))
                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                    Coq3_Compilers.Z)
                                    (Coq3_Compilers.Coq_ident_Literal
                                    ((let (x1, _) = args0.Coq_Primitive.projT1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) = args0.Coq_Primitive.projT2
                                       in
                                       y
                                     in
                                     x1)))) (fun xv ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some v0 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v1 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v2 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      Z0
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Obj.magic v0
                                                            (v x)))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v2 (v1 fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None))
                              | None -> None)
                       else None
                     | None -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (s0, _, f, x1) ->
                   (match f with
                    | Compilers.Coq_expr.Ident (t0, idc0) ->
                      (match x with
                       | Compilers.Coq_expr.Ident (_, _) -> None
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                         (match f0 with
                          | Compilers.Coq_expr.Ident (t1, idc1) ->
                            bind1
                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                              (fun _ ->
                              bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                  t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                                (fun _ ->
                                match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                        (fun x3 y ->
                                        match x3 with
                                        | Coq3_Compilers.Z ->
                                          (match y with
                                           | Coq3_Compilers.Z -> true
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_bool ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> true
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_nat ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> true
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_zrange ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             true
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_string ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             true))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow (s1,
                                        s0)) with
                                | Some vars0 ->
                                  let (_, _) = Obj.magic vars0 in
                                  if Compilers.Coq_type.type_beq
                                       (Compilers.Coq_base.Coq_type.type_beq
                                         (fun x3 y ->
                                         match x3 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true)))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))))
                                       (Compilers.Coq_type.Coq_arrow (s1,
                                       s0))
                                  then Compilers.Coq_type.try_make_transport_cps
                                         (fun _ x3 x4 _ ->
                                         Compilers.Coq_base.try_make_transport_cps
                                           (fun _ x5 x6 _ ->
                                           Coq3_Compilers.try_make_base_transport_cps
                                             x5 x6) x3 x4) s1
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)) (fun tro ->
                                         match tro with
                                         | Some v ->
                                           Compilers.Coq_type.try_make_transport_cps
                                             (fun _ x3 x4 _ ->
                                             Compilers.Coq_base.try_make_transport_cps
                                               (fun _ x5 x6 _ ->
                                               Coq3_Compilers.try_make_base_transport_cps
                                                 x5 x6) x3 x4) s0
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)) (fun tro0 ->
                                             match tro0 with
                                             | Some v0 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x3 x4)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z) (fun tr ->
                                                 match tr with
                                                 | Some v1 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x3 x4)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (fun tr0 ->
                                                     match tr0 with
                                                     | Some v2 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x3 x4)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (fun tr1 ->
                                                         match tr1 with
                                                         | Some v3 ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x3 x4 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x3 x4)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (fun tr' ->
                                                             match tr' with
                                                             | Some v4 ->
                                                               Some
                                                                 (Coq_Compilers.UnderLets.splice
                                                                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))))
                                                                   (fun fv ->
                                                                   Coq_Compilers.UnderLets.Base
                                                                   (v4
                                                                    (v3 fv))))
                                                             | None -> None)
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                         | None -> None)
                                  else None
                                | None -> None))
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (_, _, _, _) -> None
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                (sequence
                  (match x with
                   | Compilers.Coq_expr.Ident (_, _) -> None
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (s0, _, f, x1) ->
                     (match f with
                      | Compilers.Coq_expr.Ident (t0, idc0) ->
                        bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                            t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                          (fun _ ->
                          match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                  (fun x2 y ->
                                  match x2 with
                                  | Coq3_Compilers.Z ->
                                    (match y with
                                     | Coq3_Compilers.Z -> true
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_bool ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> true
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_nat ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> true
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_zrange ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> true
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_string ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> true))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow (s0,
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))) with
                          | Some vars0 ->
                            let (_, _) = Obj.magic vars0 in
                            if Compilers.Coq_type.type_beq
                                 (Compilers.Coq_base.Coq_type.type_beq
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true)))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))))
                                 (Compilers.Coq_type.Coq_arrow (s0,
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))))
                            then Compilers.Coq_type.try_make_transport_cps
                                   (fun _ x2 x3 _ ->
                                   Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x4 x5 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x4 x5) x2 x3) s0
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)) (fun tro ->
                                   match tro with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x2 x3 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x2 x3)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tro0 ->
                                       match tro0 with
                                       | Some v0 ->
                                         Compilers.Coq_base.try_make_transport_cps
                                           (fun _ x2 x3 _ ->
                                           Coq3_Compilers.try_make_base_transport_cps
                                             x2 x3)
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z) (fun tr ->
                                           match tr with
                                           | Some v1 ->
                                             Compilers.Coq_base.try_make_transport_cps
                                               (fun _ x2 x3 _ ->
                                               Coq3_Compilers.try_make_base_transport_cps
                                                 x2 x3)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z) (fun tr0 ->
                                               match tr0 with
                                               | Some v2 ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x2 x3 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x2 x3)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (fun tr1 ->
                                                   match tr1 with
                                                   | Some v3 ->
                                                     Compilers.Coq_base.try_make_transport_cps
                                                       (fun _ x2 x3 _ ->
                                                       Coq3_Compilers.try_make_base_transport_cps
                                                         x2 x3)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (fun tr' ->
                                                       match tr' with
                                                       | Some v4 ->
                                                         Some
                                                           (Coq_Compilers.UnderLets.splice
                                                             (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                               (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                 Coq3_Compilers.baseHasNat
                                                                 Coq3_Compilers.buildIdent
                                                                 Coq3_Compilers.buildEagerIdent
                                                                 Coq3_Compilers.toRestrictedIdent
                                                                 Coq3_Compilers.invertIdent
                                                                 Coq3_Compilers.baseHasNatCorrect
                                                                 (fun _ x2 x3 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x2 x3))
                                                               false
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (Compilers.Coq_expr.App
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_expr.App
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))),
                                                               (Compilers.Coq_expr.Ident
                                                               ((Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))))),
                                                               Coq3_Compilers.Coq_ident_Z_sub)),
                                                               (Compilers.Coq_expr.Var
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Obj.magic v2
                                                                 (v0 x0)))))),
                                                               (Compilers.Coq_expr.Var
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (v1
                                                                 (v
                                                                   (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                             (fun fv ->
                                                             Coq_Compilers.UnderLets.Base
                                                             (v4 (v3 fv))))
                                                       | None -> None)
                                                   | None -> None)
                                               | None -> None)
                                           | None -> None)
                                       | None -> None)
                                   | None -> None)
                            else None
                          | None -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  (match x0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x with
                      | Compilers.Coq_expr.Ident (_, _) -> None
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (s0, _, f, x1) ->
                        (match f with
                         | Compilers.Coq_expr.Ident (t1, idc1) ->
                           sequence
                             (bind1
                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                               (fun _ ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t0 idc0
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                         (fun x2 y ->
                                         match x2 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))
                                         (Compilers.Coq_type.Coq_arrow (s0,
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x2, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x2))))) with
                                 | Some vars0 ->
                                   let (_, _) = Obj.magic vars0 in
                                   if Compilers.Coq_type.type_beq
                                        (Compilers.Coq_base.Coq_type.type_beq
                                          (fun x2 y ->
                                          match x2 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true)))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow (s0,
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x2)))))
                                   then Compilers.Coq_type.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x4 x5) x2 x3) s0
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)) (fun tro ->
                                          match tro with
                                          | Some v ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Z)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr ->
                                                match tr with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr0 ->
                                                    match tr0 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          bind1
                                                            (if Coq_Z.gtb
                                                                  (let (
                                                                    x2, _) =
                                                                    xv
                                                                   in
                                                                   x2) Z0
                                                             then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                             else None)
                                                            (fun fv -> Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              fv (fun fv0 ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv0)))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                          | None -> None)
                                   else None
                                 | None -> None)))
                             (bind1
                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                               (fun _ ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t0 idc0
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                         (fun x2 y ->
                                         match x2 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))
                                         (Compilers.Coq_type.Coq_arrow (s0,
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x2, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x2))))) with
                                 | Some vars0 ->
                                   let (_, _) = Obj.magic vars0 in
                                   if Compilers.Coq_type.type_beq
                                        (Compilers.Coq_base.Coq_type.type_beq
                                          (fun x2 y ->
                                          match x2 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true)))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow (s0,
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x2)))))
                                   then Compilers.Coq_type.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x4 x5) x2 x3) s0
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)) (fun tro ->
                                          match tro with
                                          | Some v ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Z)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr ->
                                                match tr with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr0 ->
                                                    match tr0 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          bind1
                                                            (if Coq_Z.ltb
                                                                  (let (
                                                                    x2, _) =
                                                                    xv
                                                                   in
                                                                   x2) Z0
                                                             then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2)))))))))))
                                                             else None)
                                                            (fun fv -> Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              fv (fun fv0 ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv0)))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                          | None -> None)
                                   else None
                                 | None -> None)))
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, _, _) -> None
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (s0, _, f, x1) ->
                     (match f with
                      | Compilers.Coq_expr.Ident (t0, idc0) ->
                        sequence
                          (bind1
                            (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                              t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                            (fun _ ->
                            match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                    (fun x2 y ->
                                    match x2 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)), s0)) with
                            | Some vars0 ->
                              let (_, _) = Obj.magic vars0 in
                              if Compilers.Coq_type.type_beq
                                   (Compilers.Coq_base.Coq_type.type_beq
                                     (fun x2 y ->
                                     match x2 with
                                     | Coq3_Compilers.Z ->
                                       (match y with
                                        | Coq3_Compilers.Z -> true
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_bool ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> true
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_nat ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> true
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_zrange ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> true
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_string ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> true)))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)), s0))
                              then Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x2 x3 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x2 x3)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z) (fun tro ->
                                     match tro with
                                     | Some v ->
                                       Compilers.Coq_type.try_make_transport_cps
                                         (fun _ x2 x3 _ ->
                                         Compilers.Coq_base.try_make_transport_cps
                                           (fun _ x4 x5 _ ->
                                           Coq3_Compilers.try_make_base_transport_cps
                                             x4 x5) x2 x3) s0
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)) (fun tro0 ->
                                         match tro0 with
                                         | Some v0 ->
                                           Compilers.Coq_base.try_make_transport_cps
                                             (fun _ x2 x3 _ ->
                                             Coq3_Compilers.try_make_base_transport_cps
                                               x2 x3)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z) (fun tr ->
                                             match tr with
                                             | Some v1 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x2 x3 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x2 x3)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (fun tr0 ->
                                                 match tr0 with
                                                 | Some v2 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x2 x3 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x2 x3)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (fun tr1 ->
                                                     match tr1 with
                                                     | Some v3 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x2 x3 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x2 x3)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (fun tr' ->
                                                         match tr' with
                                                         | Some v4 ->
                                                           Some
                                                             (Coq_Compilers.UnderLets.splice
                                                               (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                 (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                   Coq3_Compilers.baseHasNat
                                                                   Coq3_Compilers.buildIdent
                                                                   Coq3_Compilers.buildEagerIdent
                                                                   Coq3_Compilers.toRestrictedIdent
                                                                   Coq3_Compilers.invertIdent
                                                                   Coq3_Compilers.baseHasNatCorrect
                                                                   (fun _ x2 x3 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                 false
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))),
                                                                 Coq3_Compilers.Coq_ident_Z_sub)),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Obj.magic
                                                                   v1 
                                                                   (v x)))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (v2
                                                                   (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                               (fun fv ->
                                                               Coq_Compilers.UnderLets.Base
                                                               (v4 (v3 fv))))
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                         | None -> None)
                                     | None -> None)
                              else None
                            | None -> None))
                          (match x with
                           | Compilers.Coq_expr.Ident (t1, idc1) ->
                             sequence
                               (bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t1 idc1
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 bind1
                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Z_opp)
                                   (fun _ ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x2 y ->
                                           match x2 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2))), s0)) with
                                   | Some vars0 ->
                                     let (_, _) = Obj.magic vars0 in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x2 y ->
                                            match x2 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2))), s0))
                                     then bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x2, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x2)))
                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                              Coq3_Compilers.Z)
                                              (Coq3_Compilers.Coq_ident_Literal
                                              ((let (x2, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x2),
                                              (let (x2, _) =
                                                 let (_, y) =
                                                   args0.Coq_Primitive.projT2
                                                 in
                                                 y
                                               in
                                               x2)))) (fun xv ->
                                            Compilers.Coq_type.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x4 x5) x2 x3) s0
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)) (fun tro ->
                                              match tro with
                                              | Some v ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x2 x3 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x2 x3)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr ->
                                                  match tr with
                                                  | Some v0 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x2 x3 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x2 x3)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr0 ->
                                                      match tr0 with
                                                      | Some v1 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x2 x3 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x2 x3)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v2 ->
                                                            bind1
                                                              (if Coq_Z.gtb
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2) Z0
                                                               then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                               else None)
                                                              (fun fv -> Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                fv
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 (v1 fv0)))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None))
                                     else None
                                   | None -> None)))
                               (bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t1 idc1
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 bind1
                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Z_opp)
                                   (fun _ ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x2 y ->
                                           match x2 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2))), s0)) with
                                   | Some vars0 ->
                                     let (_, _) = Obj.magic vars0 in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x2 y ->
                                            match x2 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2))), s0))
                                     then bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x2, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x2)))
                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                              Coq3_Compilers.Z)
                                              (Coq3_Compilers.Coq_ident_Literal
                                              ((let (x2, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x2),
                                              (let (x2, _) =
                                                 let (_, y) =
                                                   args0.Coq_Primitive.projT2
                                                 in
                                                 y
                                               in
                                               x2)))) (fun xv ->
                                            Compilers.Coq_type.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x4 x5) x2 x3) s0
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)) (fun tro ->
                                              match tro with
                                              | Some v ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x2 x3 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x2 x3)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr ->
                                                  match tr with
                                                  | Some v0 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x2 x3 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x2 x3)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr0 ->
                                                      match tr0 with
                                                      | Some v1 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x2 x3 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x2 x3)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v2 ->
                                                            bind1
                                                              (if Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2) Z0
                                                               then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))))
                                                               else None)
                                                              (fun fv -> Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                fv
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 (v1 fv0)))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None))
                                     else None
                                   | None -> None)))
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)))) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_add)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (sequence
              (match x with
               | Compilers.Coq_expr.Ident (t0, idc0) ->
                 bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))))
                     then bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))
                              (Coq3_Compilers.Coq_pattern_ident_Literal
                              Coq3_Compilers.Z)
                              (Coq3_Compilers.Coq_ident_Literal
                              ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1),
                              (let (x1, _) =
                                 let (_, y) = args0.Coq_Primitive.projT2 in y
                               in
                               x1)))) (fun xv ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some _ ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v0 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1)
                                                    Z0
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        (Coq3_Compilers.Z,
                                                        (Obj.magic Z0))))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v0 (v fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None)
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, _, _) -> None
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (sequence
                (match x0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                       then Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some _ ->
                                bind1
                                  (Obj.magic
                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1)))
                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                    Coq3_Compilers.Z)
                                    (Coq3_Compilers.Coq_ident_Literal
                                    ((let (x1, _) =
                                        args0.Coq_Primitive.projT1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       y
                                     in
                                     x1)))) (fun xv ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v0 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      Z0
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          (Coq3_Compilers.Z,
                                                          (Obj.magic Z0))))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v0 (v fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None))
                              | None -> None)
                       else None
                     | None -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                (sequence
                  (match x with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)),
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z))))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               (let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)))) with
                       | Some vars0 ->
                         let (_, _) = Obj.magic vars0 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                         then bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))
                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                  Coq3_Compilers.Z)
                                  (Coq3_Compilers.Coq_ident_Literal
                                  ((let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1),
                                  (let (x1, _) =
                                     let (_, y) = args0.Coq_Primitive.projT2
                                     in
                                     y
                                   in
                                   x1)))) (fun xv ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tro ->
                                  match tro with
                                  | Some v ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr ->
                                      match tr with
                                      | Some v0 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr0 ->
                                          match tr0 with
                                          | Some v1 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v2 ->
                                                bind1
                                                  (if Coq_Z.eqb
                                                        (let (x1, _) = xv in
                                                         x1) (Zpos XH)
                                                   then Some
                                                          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                              Coq3_Compilers.baseHasNat
                                                              Coq3_Compilers.buildIdent
                                                              Coq3_Compilers.buildEagerIdent
                                                              Coq3_Compilers.toRestrictedIdent
                                                              Coq3_Compilers.invertIdent
                                                              Coq3_Compilers.baseHasNatCorrect
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)) false
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Obj.magic v0
                                                              (v x0)))))
                                                   else None) (fun fv -> Some
                                                  (Coq_Compilers.UnderLets.splice
                                                    fv (fun fv0 ->
                                                    Coq_Compilers.UnderLets.Base
                                                    (v2 (v1 fv0)))))
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  (sequence
                    (match x0 with
                     | Compilers.Coq_expr.Ident (t0, idc0) ->
                       sequence
                         (bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args0 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x1 y ->
                                   match x1 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1))))) with
                           | Some vars0 ->
                             let (_, _) = Obj.magic vars0 in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x1 y ->
                                    match x1 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))))
                             then Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tro ->
                                    match tro with
                                    | Some v ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x1, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x1)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x1, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x1),
                                          (let (x1, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x1)))) (fun xv ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v0 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr0 ->
                                              match tr0 with
                                              | Some v1 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr' ->
                                                  match tr' with
                                                  | Some v2 ->
                                                    bind1
                                                      (if Coq_Z.eqb
                                                            (let (x1, _) = xv
                                                             in
                                                             x1) (Zpos XH)
                                                       then Some
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Obj.magic v0
                                                                  (v x)))))
                                                       else None) (fun fv ->
                                                      Some
                                                      (Coq_Compilers.UnderLets.splice
                                                        fv (fun fv0 ->
                                                        Coq_Compilers.UnderLets.Base
                                                        (v2 (v1 fv0)))))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None))
                                    | None -> None)
                             else None
                           | None -> None))
                         (match x with
                          | Compilers.Coq_expr.Ident (_, _) -> None
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (s0, _, f, x1) ->
                            (match f with
                             | Compilers.Coq_expr.Ident (t1, idc1) ->
                               bind1
                                 (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t1 idc1
                                   Coq3_Compilers.Coq_raw_ident_Z_opp)
                                 (fun _ ->
                                 bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args0 ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x2 y ->
                                           match x2 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))
                                           (Compilers.Coq_type.Coq_arrow (s0,
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x2, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x2))))) with
                                   | Some vars0 ->
                                     let (_, _) = Obj.magic vars0 in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x2 y ->
                                            match x2 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                          (Compilers.Coq_type.Coq_arrow (s0,
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x2, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x2)))))
                                     then Compilers.Coq_type.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x4 x5 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x4 x5) x2 x3) s0
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)) (fun tro ->
                                            match tro with
                                            | Some v ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x2, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x2)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Z)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x2, _) =
                                                      args0.Coq_Primitive.projT1
                                                    in
                                                    x2),
                                                  (let (x2, _) =
                                                     let (_, y) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x2)))) (fun xv ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x2 x3 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x2 x3)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr ->
                                                  match tr with
                                                  | Some v0 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x2 x3 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x2 x3)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr0 ->
                                                      match tr0 with
                                                      | Some v1 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x2 x3 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x2 x3)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v2 ->
                                                            bind1
                                                              (if Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2) (Zneg
                                                                    XH)
                                                               then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))
                                                               else None)
                                                              (fun fv -> Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                fv
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 (v1 fv0)))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None))
                                            | None -> None)
                                     else None
                                   | None -> None))
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, _, _) -> None
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (s0, _, f, x1) ->
                       (match f with
                        | Compilers.Coq_expr.Ident (t0, idc0) ->
                          (match x with
                           | Compilers.Coq_expr.Ident (t1, idc1) ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t1 idc1
                                 Coq3_Compilers.Coq_raw_ident_Literal)
                               (fun args0 ->
                               bind1
                                 (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t0 idc0
                                   Coq3_Compilers.Coq_raw_ident_Z_opp)
                                 (fun _ ->
                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                         (fun x2 y ->
                                         match x2 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x2, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x2))), s0)) with
                                 | Some vars0 ->
                                   let (_, _) = Obj.magic vars0 in
                                   if Compilers.Coq_type.type_beq
                                        (Compilers.Coq_base.Coq_type.type_beq
                                          (fun x2 y ->
                                          match x2 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true)))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x2))), s0))
                                   then bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x2, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x2)))
                                            (Coq3_Compilers.Coq_pattern_ident_Literal
                                            Coq3_Compilers.Z)
                                            (Coq3_Compilers.Coq_ident_Literal
                                            ((let (x2, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x2),
                                            (let (x2, _) =
                                               let (_, y) =
                                                 args0.Coq_Primitive.projT2
                                               in
                                               y
                                             in
                                             x2)))) (fun xv ->
                                          Compilers.Coq_type.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x4 x5 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x4 x5) x2 x3) s0
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)) (fun tro ->
                                            match tro with
                                            | Some v ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr ->
                                                match tr with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr0 ->
                                                    match tr0 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          bind1
                                                            (if Coq_Z.eqb
                                                                  (let (
                                                                    x2, _) =
                                                                    xv
                                                                   in
                                                                   x2) (Zneg
                                                                  XH)
                                                             then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))
                                                             else None)
                                                            (fun fv -> Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              fv (fun fv0 ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv0)))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None))
                                   else None
                                 | None -> None))
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    (sequence
                      (match x with
                       | Compilers.Coq_expr.Ident (t0, idc0) ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args0 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x1 y ->
                                   match x1 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))) with
                           | Some vars0 ->
                             let (_, _) = Obj.magic vars0 in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x1 y ->
                                    match x1 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x1, _) =
                                         args0.Coq_Primitive.projT1
                                       in
                                       x1)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x1, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x1),
                                      (let (x1, _) =
                                         let (_, y) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x1)))) (fun xv ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tro ->
                                      match tro with
                                      | Some v ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v0 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr0 ->
                                              match tr0 with
                                              | Some v1 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr' ->
                                                  match tr' with
                                                  | Some v2 ->
                                                    bind1
                                                      (if Coq_Z.eqb
                                                            (let (x1, _) = xv
                                                             in
                                                             x1) (Zneg XH)
                                                       then Some
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                Coq3_Compilers.Coq_ident_Z_opp)),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Obj.magic v0
                                                                  (v x0)))))))
                                                       else None) (fun fv ->
                                                      Some
                                                      (Coq_Compilers.UnderLets.splice
                                                        fv (fun fv0 ->
                                                        Coq_Compilers.UnderLets.Base
                                                        (v2 (v1 fv0)))))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None))
                             else None
                           | None -> None)
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      (sequence
                        (match x0 with
                         | Compilers.Coq_expr.Ident (t0, idc0) ->
                           bind1
                             (Obj.magic
                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                               t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                             (fun args0 ->
                             match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                     (fun x1 y ->
                                     match x1 with
                                     | Coq3_Compilers.Z ->
                                       (match y with
                                        | Coq3_Compilers.Z -> true
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_bool ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> true
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_nat ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> true
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_zrange ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> true
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_string ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> true))
                                     (Compilers.Coq_type.Coq_arrow
                                     ((Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)),
                                     (Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z))))
                                     (Compilers.Coq_type.Coq_arrow
                                     ((Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)),
                                     (Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     (let (x1, _) =
                                        args0.Coq_Primitive.projT1
                                      in
                                      x1))))) with
                             | Some vars0 ->
                               let (_, _) = Obj.magic vars0 in
                               if Compilers.Coq_type.type_beq
                                    (Compilers.Coq_base.Coq_type.type_beq
                                      (fun x1 y ->
                                      match x1 with
                                      | Coq3_Compilers.Z ->
                                        (match y with
                                         | Coq3_Compilers.Z -> true
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_bool ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> true
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_nat ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> true
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_zrange ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> true
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_string ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> true)))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1)))))
                               then Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tro ->
                                      match tro with
                                      | Some v ->
                                        bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x1, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x1)))
                                            (Coq3_Compilers.Coq_pattern_ident_Literal
                                            Coq3_Compilers.Z)
                                            (Coq3_Compilers.Coq_ident_Literal
                                            ((let (x1, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x1),
                                            (let (x1, _) =
                                               let (_, y) =
                                                 args0.Coq_Primitive.projT2
                                               in
                                               y
                                             in
                                             x1)))) (fun xv ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr0 ->
                                                match tr0 with
                                                | Some v1 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr' ->
                                                    match tr' with
                                                    | Some v2 ->
                                                      bind1
                                                        (if Coq_Z.eqb
                                                              (let (x1, _) =
                                                                 xv
                                                               in
                                                               x1) (Zneg XH)
                                                         then Some
                                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                  false
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_expr.App
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)),
                                                                  (Compilers.Coq_expr.Ident
                                                                  ((Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))),
                                                                  Coq3_Compilers.Coq_ident_Z_opp)),
                                                                  (Compilers.Coq_expr.Var
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)),
                                                                  (Obj.magic
                                                                    v0 
                                                                    (v x)))))))
                                                         else None)
                                                        (fun fv -> Some
                                                        (Coq_Compilers.UnderLets.splice
                                                          fv (fun fv0 ->
                                                          Coq_Compilers.UnderLets.Base
                                                          (v2 (v1 fv0)))))
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None))
                                      | None -> None)
                               else None
                             | None -> None)
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (s0, _, f, x1) ->
                           (match f with
                            | Compilers.Coq_expr.Ident (t0, idc0) ->
                              (match x with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                                 (match f0 with
                                  | Compilers.Coq_expr.Ident (t1, idc1) ->
                                    bind1
                                      (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                        t1 idc1
                                        Coq3_Compilers.Coq_raw_ident_Z_opp)
                                      (fun _ ->
                                      bind1
                                        (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t0 idc0
                                          Coq3_Compilers.Coq_raw_ident_Z_opp)
                                        (fun _ ->
                                        match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                (fun x3 y ->
                                                match x3 with
                                                | Coq3_Compilers.Z ->
                                                  (match y with
                                                   | Coq3_Compilers.Z -> true
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_bool ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     true
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_nat ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_zrange ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_string ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     true))
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))))
                                                (Compilers.Coq_type.Coq_arrow
                                                (s1, s0)) with
                                        | Some vars0 ->
                                          let (_, _) = Obj.magic vars0 in
                                          if Compilers.Coq_type.type_beq
                                               (Compilers.Coq_base.Coq_type.type_beq
                                                 (fun x3 y ->
                                                 match x3 with
                                                 | Coq3_Compilers.Z ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      true
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_bool ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      true
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_nat ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      true
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      true
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_string ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      true)))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))))
                                               (Compilers.Coq_type.Coq_arrow
                                               (s1, s0))
                                          then Compilers.Coq_type.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x5 x6 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x5 x6) x3 x4) s1
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (fun tro ->
                                                 match tro with
                                                 | Some v ->
                                                   Compilers.Coq_type.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Compilers.Coq_base.try_make_transport_cps
                                                       (fun _ x5 x6 _ ->
                                                       Coq3_Compilers.try_make_base_transport_cps
                                                         x5 x6) x3 x4) s0
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))
                                                     (fun tro0 ->
                                                     match tro0 with
                                                     | Some v0 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x3 x4)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (fun tr ->
                                                         match tr with
                                                         | Some v1 ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x3 x4 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x3 x4)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (fun tr0 ->
                                                             match tr0 with
                                                             | Some v2 ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x3 x4 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x3 x4)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (fun tr1 ->
                                                                 match tr1 with
                                                                 | Some v3 ->
                                                                   Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv))))
                                                                    | None ->
                                                                    None)
                                                                 | None ->
                                                                   None)
                                                             | None -> None)
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                          else None
                                        | None -> None))
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        (sequence
                          (match x with
                           | Compilers.Coq_expr.Ident (_, _) -> None
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (s0, _, f, x1) ->
                             (match f with
                              | Compilers.Coq_expr.Ident (t0, idc0) ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                    t0 idc0
                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                  (fun _ ->
                                  match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                          (fun x2 y ->
                                          match x2 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                          (Compilers.Coq_type.Coq_arrow (s0,
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))) with
                                  | Some vars0 ->
                                    let (_, _) = Obj.magic vars0 in
                                    if Compilers.Coq_type.type_beq
                                         (Compilers.Coq_base.Coq_type.type_beq
                                           (fun x2 y ->
                                           match x2 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true)))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))
                                         (Compilers.Coq_type.Coq_arrow (s0,
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))
                                    then Compilers.Coq_type.try_make_transport_cps
                                           (fun _ x2 x3 _ ->
                                           Compilers.Coq_base.try_make_transport_cps
                                             (fun _ x4 x5 _ ->
                                             Coq3_Compilers.try_make_base_transport_cps
                                               x4 x5) x2 x3) s0
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)) (fun tro ->
                                           match tro with
                                           | Some v ->
                                             Compilers.Coq_base.try_make_transport_cps
                                               (fun _ x2 x3 _ ->
                                               Coq3_Compilers.try_make_base_transport_cps
                                                 x2 x3)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z) (fun tro0 ->
                                               match tro0 with
                                               | Some v0 ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x2 x3 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x2 x3)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (fun tr ->
                                                   match tr with
                                                   | Some v1 ->
                                                     Compilers.Coq_base.try_make_transport_cps
                                                       (fun _ x2 x3 _ ->
                                                       Coq3_Compilers.try_make_base_transport_cps
                                                         x2 x3)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (fun tr0 ->
                                                       match tr0 with
                                                       | Some v2 ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x2 x3 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x2 x3)
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)
                                                           (fun tr1 ->
                                                           match tr1 with
                                                           | Some v3 ->
                                                             Compilers.Coq_base.try_make_transport_cps
                                                               (fun _ x2 x3 _ ->
                                                               Coq3_Compilers.try_make_base_transport_cps
                                                                 x2 x3)
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)
                                                               (fun tr' ->
                                                               match tr' with
                                                               | Some v4 ->
                                                                 Some
                                                                   (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v2
                                                                    (v0 x0)))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv))))
                                                               | None -> None)
                                                           | None -> None)
                                                       | None -> None)
                                                   | None -> None)
                                               | None -> None)
                                           | None -> None)
                                    else None
                                  | None -> None)
                              | Compilers.Coq_expr.Var (_, _) -> None
                              | Compilers.Coq_expr.Abs (_, _, _) -> None
                              | Compilers.Coq_expr.App (_, _, _, _) -> None
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          (sequence
                            (match x0 with
                             | Compilers.Coq_expr.Ident (t0, idc0) ->
                               (match x with
                                | Compilers.Coq_expr.Ident (t1, idc1) ->
                                  bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                      t1 idc1
                                      Coq3_Compilers.Coq_raw_ident_Literal)
                                    (fun args0 ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                        t0 idc0
                                        Coq3_Compilers.Coq_raw_ident_Literal)
                                      (fun args1 ->
                                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                              (fun x1 y ->
                                              match x1 with
                                              | Coq3_Compilers.Z ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> true
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_bool ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   true
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_nat ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   true
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_zrange ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   true
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_string ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   true))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x1, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x1))),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x1, _) =
                                                 args1.Coq_Primitive.projT1
                                               in
                                               x1))))) with
                                      | Some vars0 ->
                                        let (_, _) = Obj.magic vars0 in
                                        if Compilers.Coq_type.type_beq
                                             (Compilers.Coq_base.Coq_type.type_beq
                                               (fun x1 y ->
                                               match x1 with
                                               | Coq3_Compilers.Z ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> true
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_bool ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    true
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_nat ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    true
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_zrange ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    true
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_string ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    true)))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x1, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x1))),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x1, _) =
                                                args1.Coq_Primitive.projT1
                                              in
                                              x1)))))
                                        then bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 (let (x1, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x1)))
                                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                                 Coq3_Compilers.Z)
                                                 (Coq3_Compilers.Coq_ident_Literal
                                                 ((let (x1, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x1),
                                                 (let (x1, _) =
                                                    let (_, y) =
                                                      args0.Coq_Primitive.projT2
                                                    in
                                                    y
                                                  in
                                                  x1)))) (fun xv ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z))
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   (let (x1, _) =
                                                      args1.Coq_Primitive.projT1
                                                    in
                                                    x1)))
                                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                                   Coq3_Compilers.Z)
                                                   (Coq3_Compilers.Coq_ident_Literal
                                                   ((let (x1, _) =
                                                       args1.Coq_Primitive.projT1
                                                     in
                                                     x1),
                                                   (let (x1, _) =
                                                      let (_, y) =
                                                        args1.Coq_Primitive.projT2
                                                      in
                                                      y
                                                    in
                                                    x1)))) (fun xv0 ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x1 x2 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x1 x2)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (fun tr ->
                                                   match tr with
                                                   | Some v ->
                                                     Compilers.Coq_base.try_make_transport_cps
                                                       (fun _ x1 x2 _ ->
                                                       Coq3_Compilers.try_make_base_transport_cps
                                                         x1 x2)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (fun tr' ->
                                                       match tr' with
                                                       | Some v0 ->
                                                         Some
                                                           (Coq_Compilers.UnderLets.splice
                                                             (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                               (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                 Coq3_Compilers.baseHasNat
                                                                 Coq3_Compilers.buildIdent
                                                                 Coq3_Compilers.buildEagerIdent
                                                                 Coq3_Compilers.toRestrictedIdent
                                                                 Coq3_Compilers.invertIdent
                                                                 Coq3_Compilers.baseHasNatCorrect
                                                                 (fun _ x1 x2 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x1 x2))
                                                               false
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (Compilers.Coq_expr.Ident
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               (Coq3_Compilers.Z,
                                                               (Obj.magic
                                                                 Coq_Z.mul
                                                                 (let (
                                                                    x1, _) =
                                                                    xv
                                                                  in
                                                                  x1)
                                                                 (let (
                                                                    x1, _) =
                                                                    xv0
                                                                  in
                                                                  x1)))))))
                                                             (fun fv ->
                                                             Coq_Compilers.UnderLets.Base
                                                             (v0 (v fv))))
                                                       | None -> None)
                                                   | None -> None)))
                                        else None
                                      | None -> None))
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, _, _) -> None
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (s0, _, f, x1) ->
                               (match f with
                                | Compilers.Coq_expr.Ident (t0, idc0) ->
                                  bind1
                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                      t0 idc0
                                      Coq3_Compilers.Coq_raw_ident_Z_opp)
                                    (fun _ ->
                                    match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                            (fun x2 y ->
                                            match x2 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)), s0)) with
                                    | Some vars0 ->
                                      let (_, _) = Obj.magic vars0 in
                                      if Compilers.Coq_type.type_beq
                                           (Compilers.Coq_base.Coq_type.type_beq
                                             (fun x2 y ->
                                             match x2 with
                                             | Coq3_Compilers.Z ->
                                               (match y with
                                                | Coq3_Compilers.Z -> true
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_bool ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  true
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_nat ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_zrange ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_string ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  true)))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)), s0))
                                      then Compilers.Coq_base.try_make_transport_cps
                                             (fun _ x2 x3 _ ->
                                             Coq3_Compilers.try_make_base_transport_cps
                                               x2 x3)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z) (fun tro ->
                                             match tro with
                                             | Some v ->
                                               Compilers.Coq_type.try_make_transport_cps
                                                 (fun _ x2 x3 _ ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x4 x5 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x4 x5) x2 x3) s0
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (fun tro0 ->
                                                 match tro0 with
                                                 | Some v0 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x2 x3 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x2 x3)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (fun tr ->
                                                     match tr with
                                                     | Some v1 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x2 x3 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x2 x3)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (fun tr0 ->
                                                         match tr0 with
                                                         | Some v2 ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x2 x3 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x2 x3)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (fun tr1 ->
                                                             match tr1 with
                                                             | Some v3 ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x2 x3 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x2 x3)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (fun tr' ->
                                                                 match tr' with
                                                                 | Some v4 ->
                                                                   Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v1 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv))))
                                                                 | None ->
                                                                   None)
                                                             | None -> None)
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                      else None
                                    | None -> None)
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, _, _) -> None
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                            (sequence
                              (match x with
                               | Compilers.Coq_expr.Ident (t0, idc0) ->
                                 bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args0 ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x1 y ->
                                           match x1 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x1, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x1))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)))) with
                                   | Some vars0 ->
                                     let (_, _) = Obj.magic vars0 in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x1 y ->
                                            match x1 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x1, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x1))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                     then bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x1, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x1)))
                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                              Coq3_Compilers.Z)
                                              (Coq3_Compilers.Coq_ident_Literal
                                              ((let (x1, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x1),
                                              (let (x1, _) =
                                                 let (_, y) =
                                                   args0.Coq_Primitive.projT2
                                                 in
                                                 y
                                               in
                                               x1)))) (fun xv ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tro ->
                                              match tro with
                                              | Some v ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr ->
                                                  match tr with
                                                  | Some v0 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr0 ->
                                                      match tr0 with
                                                      | Some v1 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v2 ->
                                                            bind1
                                                              (if Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1) Z0
                                                               then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0
                                                                    (v x0)))))))))
                                                               else None)
                                                              (fun fv -> Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                fv
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 (v1 fv0)))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None))
                                     else None
                                   | None -> None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                              (sequence
                                (match x0 with
                                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                                   sequence
                                     (bind1
                                       (Obj.magic
                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                         t0 idc0
                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                       (fun args0 ->
                                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                               (fun x1 y ->
                                               match x1 with
                                               | Coq3_Compilers.Z ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> true
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_bool ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    true
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_nat ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    true
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_zrange ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    true
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_string ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    true))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x1, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x1))))) with
                                       | Some vars0 ->
                                         let (_, _) = Obj.magic vars0 in
                                         if Compilers.Coq_type.type_beq
                                              (Compilers.Coq_base.Coq_type.type_beq
                                                (fun x1 y ->
                                                match x1 with
                                                | Coq3_Compilers.Z ->
                                                  (match y with
                                                   | Coq3_Compilers.Z -> true
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_bool ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     true
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_nat ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_zrange ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_string ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     true)))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x1, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x1)))))
                                         then Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tro ->
                                                match tro with
                                                | Some v ->
                                                  bind1
                                                    (Obj.magic
                                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x1, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x1)))
                                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                                      Coq3_Compilers.Z)
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      ((let (x1, _) =
                                                          args0.Coq_Primitive.projT1
                                                        in
                                                        x1),
                                                      (let (x1, _) =
                                                         let (_, y) =
                                                           args0.Coq_Primitive.projT2
                                                         in
                                                         y
                                                       in
                                                       x1)))) (fun xv ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr ->
                                                      match tr with
                                                      | Some v0 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr0 ->
                                                          match tr0 with
                                                          | Some v1 ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (fun tr' ->
                                                              match tr' with
                                                              | Some v2 ->
                                                                bind1
                                                                  (if 
                                                                    Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1) Z0
                                                                   then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1)))))))))))
                                                                   else None)
                                                                  (fun fv ->
                                                                  Some
                                                                  (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                              | None -> None)
                                                          | None -> None)
                                                      | None -> None))
                                                | None -> None)
                                         else None
                                       | None -> None))
                                     (bind1
                                       (Obj.magic
                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                         t0 idc0
                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                       (fun args0 ->
                                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                               (fun x1 y ->
                                               match x1 with
                                               | Coq3_Compilers.Z ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> true
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_bool ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    true
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_nat ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    true
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_zrange ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    true
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_string ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    true))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x1, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x1))))) with
                                       | Some vars0 ->
                                         let (_, _) = Obj.magic vars0 in
                                         if Compilers.Coq_type.type_beq
                                              (Compilers.Coq_base.Coq_type.type_beq
                                                (fun x1 y ->
                                                match x1 with
                                                | Coq3_Compilers.Z ->
                                                  (match y with
                                                   | Coq3_Compilers.Z -> true
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_bool ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     true
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_nat ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_zrange ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_string ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     true)))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x1, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x1)))))
                                         then Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tro ->
                                                match tro with
                                                | Some v ->
                                                  bind1
                                                    (Obj.magic
                                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x1, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x1)))
                                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                                      Coq3_Compilers.Z)
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      ((let (x1, _) =
                                                          args0.Coq_Primitive.projT1
                                                        in
                                                        x1),
                                                      (let (x1, _) =
                                                         let (_, y) =
                                                           args0.Coq_Primitive.projT2
                                                         in
                                                         y
                                                       in
                                                       x1)))) (fun xv ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr ->
                                                      match tr with
                                                      | Some v0 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr0 ->
                                                          match tr0 with
                                                          | Some v1 ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (fun tr' ->
                                                              match tr' with
                                                              | Some v2 ->
                                                                bind1
                                                                  (if 
                                                                    (&&)
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1))))
                                                                    (negb
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1) (Zpos
                                                                    (XO XH))))
                                                                   then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftl)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1)))))))))
                                                                   else None)
                                                                  (fun fv ->
                                                                  Some
                                                                  (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                              | None -> None)
                                                          | None -> None)
                                                      | None -> None))
                                                | None -> None)
                                         else None
                                       | None -> None))
                                 | Compilers.Coq_expr.Var (_, _) -> None
                                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                                 | Compilers.Coq_expr.App (_, _, _, _) ->
                                   None
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   None)
                                (match x with
                                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                                   sequence
                                     (bind1
                                       (Obj.magic
                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                         t0 idc0
                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                       (fun args0 ->
                                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                               (fun x1 y ->
                                               match x1 with
                                               | Coq3_Compilers.Z ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> true
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_bool ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    true
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_nat ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    true
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_zrange ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    true
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_string ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    true))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x1, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x1))),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)))) with
                                       | Some vars0 ->
                                         let (_, _) = Obj.magic vars0 in
                                         if Compilers.Coq_type.type_beq
                                              (Compilers.Coq_base.Coq_type.type_beq
                                                (fun x1 y ->
                                                match x1 with
                                                | Coq3_Compilers.Z ->
                                                  (match y with
                                                   | Coq3_Compilers.Z -> true
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_bool ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     true
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_nat ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_zrange ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_string ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     true)))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x1, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x1))),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))))
                                         then bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x1, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x1)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Z)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x1, _) =
                                                      args0.Coq_Primitive.projT1
                                                    in
                                                    x1),
                                                  (let (x1, _) =
                                                     let (_, y) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x1)))) (fun xv ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tro ->
                                                  match tro with
                                                  | Some v ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr ->
                                                      match tr with
                                                      | Some v0 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr0 ->
                                                          match tr0 with
                                                          | Some v1 ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (fun tr' ->
                                                              match tr' with
                                                              | Some v2 ->
                                                                bind1
                                                                  (if 
                                                                    (&&)
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1))))
                                                                    (negb
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1) (Zpos
                                                                    (XO XH))))
                                                                   then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftl)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0
                                                                    (v x0)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1)))))))))
                                                                   else None)
                                                                  (fun fv ->
                                                                  Some
                                                                  (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                              | None -> None)
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None))
                                         else None
                                       | None -> None))
                                     (sequence
                                       (match x0 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (s0, _, f,
                                                                  x1) ->
                                          (match f with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               s1, _, f0, x2) ->
                                             (match f0 with
                                              | Compilers.Coq_expr.Ident (
                                                  t1, idc1) ->
                                                sequence
                                                  (match x2 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t2, idc2) ->
                                                     (match x1 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          s2, _, f1, x3) ->
                                                        (match f1 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             s3, _, f2, x4) ->
                                                           (match f2 with
                                                            | Compilers.Coq_expr.Ident (
                                                                t3, idc3) ->
                                                              bind1
                                                                (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                  t3 idc3
                                                                  Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                (fun _ ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                  (fun args0 ->
                                                                  bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x5 y ->
                                                                    match x5 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x5 y ->
                                                                    match x5 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (Coq_Z.leb
                                                                    (Coq_Z.abs
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5))
                                                                    (Coq_Z.abs
                                                                    max_const_val))
                                                                    (Coq_Z.leb
                                                                    (Coq_Z.abs
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5))
                                                                    (Coq_Z.abs
                                                                    max_const_val))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x5))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None))))
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                  (sequence
                                                    (match x1 with
                                                     | Compilers.Coq_expr.Ident (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, f1, x3) ->
                                                       (match f1 with
                                                        | Compilers.Coq_expr.Ident (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            s2, _, f2, x4) ->
                                                          (match f2 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t2, idc2) ->
                                                             (match x3 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  t3, idc3) ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                  (fun args0 ->
                                                                  bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x5 y ->
                                                                    match x5 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    (s1,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x5 y ->
                                                                    match x5 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    (s1,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (Coq_Z.leb
                                                                    (Coq_Z.abs
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5))
                                                                    (Coq_Z.abs
                                                                    max_const_val))
                                                                    (Coq_Z.leb
                                                                    (Coq_Z.abs
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5))
                                                                    (Coq_Z.abs
                                                                    max_const_val))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x5))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    else None
                                                                    | None ->
                                                                    None))))
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                    (bind1
                                                      (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                        t1 idc1
                                                        Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                      (fun _ ->
                                                      bind1
                                                        (Obj.magic
                                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                          t0 idc0
                                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                                        (fun args0 ->
                                                        match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                (fun x3 y ->
                                                                match x3 with
                                                                | Coq3_Compilers.Z ->
                                                                  (match y with
                                                                   | Coq3_Compilers.Z ->
                                                                    true
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  (match y with
                                                                   | Coq3_Compilers.Z ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  (match y with
                                                                   | Coq3_Compilers.Z ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  (match y with
                                                                   | Coq3_Compilers.Z ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                | Coq3_Compilers.Coq_string ->
                                                                  (match y with
                                                                   | Coq3_Compilers.Z ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                   | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                (s1, s0)))) with
                                                        | Some vars0 ->
                                                          let (_, b) =
                                                            Obj.magic vars0
                                                          in
                                                          let (_, _) = b in
                                                          if Compilers.Coq_type.type_beq
                                                               (Compilers.Coq_base.Coq_type.type_beq
                                                                 (fun x3 y ->
                                                                 match x3 with
                                                                 | Coq3_Compilers.Z ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))))))
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3))),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               (s1, s0))))
                                                          then bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x3, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x3)))
                                                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                   Coq3_Compilers.Z)
                                                                   (Coq3_Compilers.Coq_ident_Literal
                                                                   ((
                                                                    let (
                                                                    x3, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x3),
                                                                   (let (
                                                                    x3, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x3))))
                                                                 (fun xv ->
                                                                 Compilers.Coq_type.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6) x3
                                                                    x4) s1
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))
                                                                   (fun tro ->
                                                                   match tro with
                                                                   | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6) x3
                                                                    x4) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.leb
                                                                    (Coq_Z.abs
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3))
                                                                    (Coq_Z.abs
                                                                    max_const_val)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x3))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None))
                                                          else None
                                                        | None -> None))))
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                       (bind1
                                         (Obj.magic
                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                           t0 idc0
                                           Coq3_Compilers.Coq_raw_ident_Literal)
                                         (fun args0 ->
                                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                 (fun x1 y ->
                                                 match x1 with
                                                 | Coq3_Compilers.Z ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      true
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_bool ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      true
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_nat ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      true
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      true
                                                    | Coq3_Compilers.Coq_string ->
                                                      false)
                                                 | Coq3_Compilers.Coq_string ->
                                                   (match y with
                                                    | Coq3_Compilers.Z ->
                                                      false
                                                    | Coq3_Compilers.Coq_bool ->
                                                      false
                                                    | Coq3_Compilers.Coq_nat ->
                                                      false
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      false
                                                    | Coq3_Compilers.Coq_string ->
                                                      true))
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))))
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 (let (x1, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x1))),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)))) with
                                         | Some vars0 ->
                                           let (_, _) = Obj.magic vars0 in
                                           if Compilers.Coq_type.type_beq
                                                (Compilers.Coq_base.Coq_type.type_beq
                                                  (fun x1 y ->
                                                  match x1 with
                                                  | Coq3_Compilers.Z ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       true
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_bool ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       true
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_nat ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       true
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       true
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_string ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       true)))
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))))
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x1, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x1))),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))))
                                           then bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x1, _) =
                                                       args0.Coq_Primitive.projT1
                                                     in
                                                     x1)))
                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                    Coq3_Compilers.Z)
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    ((let (x1, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x1),
                                                    (let (x1, _) =
                                                       let (_, y) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       y
                                                     in
                                                     x1)))) (fun xv ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tro ->
                                                    match tro with
                                                    | Some v ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr ->
                                                        match tr with
                                                        | Some v0 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr0 ->
                                                            match tr0 with
                                                            | Some v1 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x1 x2 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x1 x2)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (fun tr' ->
                                                                match tr' with
                                                                | Some v2 ->
                                                                  bind1
                                                                    (
                                                                    if 
                                                                    Coq_Z.leb
                                                                    (Coq_Z.abs
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    x1))
                                                                    (Coq_Z.abs
                                                                    max_const_val)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0
                                                                    (v x0)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x1, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x1))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None))
                                           else None
                                         | None -> None)))
                                 | Compilers.Coq_expr.Var (_, _) -> None
                                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                                 | Compilers.Coq_expr.App (_, _, _, _) ->
                                   None
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   None))))))))))) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_mul)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (sequence
              (match x with
               | Compilers.Coq_expr.Ident (t0, idc0) ->
                 sequence
                   (match x0 with
                    | Compilers.Coq_expr.Ident (_, _) -> None
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (s0, _, f, x1) ->
                      (match f with
                       | Compilers.Coq_expr.Ident (t1, idc1) ->
                         bind1
                           (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                           (fun _ ->
                           bind1
                             (Obj.magic
                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                               t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                             (fun args0 ->
                             match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                     (fun x2 y ->
                                     match x2 with
                                     | Coq3_Compilers.Z ->
                                       (match y with
                                        | Coq3_Compilers.Z -> true
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_bool ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> true
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_nat ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> true
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_zrange ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> true
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_string ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> true))
                                     (Compilers.Coq_type.Coq_arrow
                                     ((Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)),
                                     (Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z))))
                                     (Compilers.Coq_type.Coq_arrow
                                     ((Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     (let (x2, _) =
                                        args0.Coq_Primitive.projT1
                                      in
                                      x2))), s0)) with
                             | Some vars0 ->
                               let (_, _) = Obj.magic vars0 in
                               if Compilers.Coq_type.type_beq
                                    (Compilers.Coq_base.Coq_type.type_beq
                                      (fun x2 y ->
                                      match x2 with
                                      | Coq3_Compilers.Z ->
                                        (match y with
                                         | Coq3_Compilers.Z -> true
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_bool ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> true
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_nat ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> true
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_zrange ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> true
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_string ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> true)))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x2, _) = args0.Coq_Primitive.projT1
                                     in
                                     x2))), s0))
                               then bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x2, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x2)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x2, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x2),
                                        (let (x2, _) =
                                           let (_, y) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x2)))) (fun xv ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x2 x3 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x4 x5 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x4 x5) x2 x3) s0
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)) (fun tro ->
                                        match tro with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x2 x3)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr0 ->
                                                match tr0 with
                                                | Some v1 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr' ->
                                                    match tr' with
                                                    | Some v2 ->
                                                      bind1
                                                        (if Coq_Z.eqb
                                                              (let (x2, _) =
                                                                 xv
                                                               in
                                                               x2) Z0
                                                         then Some
                                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                  false
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (Compilers.Coq_expr.Var
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)),
                                                                  (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))
                                                         else None)
                                                        (fun fv -> Some
                                                        (Coq_Compilers.UnderLets.splice
                                                          fv (fun fv0 ->
                                                          Coq_Compilers.UnderLets.Base
                                                          (v2 (v1 fv0)))))
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None))
                               else None
                             | None -> None))
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   (bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                       then bind1
                              (Obj.magic
                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                (let (x1, _) = args0.Coq_Primitive.projT1 in
                                 x1)))
                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                Coq3_Compilers.Z)
                                (Coq3_Compilers.Coq_ident_Literal
                                ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                  x1),
                                (let (x1, _) =
                                   let (_, y) = args0.Coq_Primitive.projT2 in
                                   y
                                 in
                                 x1)))) (fun xv ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tro ->
                                match tro with
                                | Some v ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some v0 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v1 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v2 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      Z0
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.App
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)))),
                                                          Coq3_Compilers.Coq_ident_Z_opp)),
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Obj.magic v0
                                                            (v x0)))))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v2 (v1 fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None))
                       else None
                     | None -> None))
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, _, _) -> None
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (sequence
                (match x0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                       then Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some v ->
                                bind1
                                  (Obj.magic
                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1)))
                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                    Coq3_Compilers.Z)
                                    (Coq3_Compilers.Coq_ident_Literal
                                    ((let (x1, _) =
                                        args0.Coq_Primitive.projT1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       y
                                     in
                                     x1)))) (fun xv ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some v0 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v1 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v2 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      Z0
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Var
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Obj.magic v0
                                                            (v x)))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v2 (v1 fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None))
                              | None -> None)
                       else None
                     | None -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (s0, _, f, x1) ->
                   (match f with
                    | Compilers.Coq_expr.Ident (t0, idc0) ->
                      (match x with
                       | Compilers.Coq_expr.Ident (_, _) -> None
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                         (match f0 with
                          | Compilers.Coq_expr.Ident (t1, idc1) ->
                            bind1
                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                              (fun _ ->
                              bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                  t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                                (fun _ ->
                                match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                        (fun x3 y ->
                                        match x3 with
                                        | Coq3_Compilers.Z ->
                                          (match y with
                                           | Coq3_Compilers.Z -> true
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_bool ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> true
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_nat ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> true
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_zrange ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             true
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_string ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             true))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow (s1,
                                        s0)) with
                                | Some vars0 ->
                                  let (_, _) = Obj.magic vars0 in
                                  if Compilers.Coq_type.type_beq
                                       (Compilers.Coq_base.Coq_type.type_beq
                                         (fun x3 y ->
                                         match x3 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true)))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))))
                                       (Compilers.Coq_type.Coq_arrow (s1,
                                       s0))
                                  then Compilers.Coq_type.try_make_transport_cps
                                         (fun _ x3 x4 _ ->
                                         Compilers.Coq_base.try_make_transport_cps
                                           (fun _ x5 x6 _ ->
                                           Coq3_Compilers.try_make_base_transport_cps
                                             x5 x6) x3 x4) s1
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)) (fun tro ->
                                         match tro with
                                         | Some v ->
                                           Compilers.Coq_type.try_make_transport_cps
                                             (fun _ x3 x4 _ ->
                                             Compilers.Coq_base.try_make_transport_cps
                                               (fun _ x5 x6 _ ->
                                               Coq3_Compilers.try_make_base_transport_cps
                                                 x5 x6) x3 x4) s0
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)) (fun tro0 ->
                                             match tro0 with
                                             | Some v0 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x3 x4)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z) (fun tr ->
                                                 match tr with
                                                 | Some v1 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x3 x4)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (fun tr0 ->
                                                     match tr0 with
                                                     | Some v2 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x3 x4)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (fun tr1 ->
                                                         match tr1 with
                                                         | Some v3 ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x3 x4 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x3 x4)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (fun tr' ->
                                                             match tr' with
                                                             | Some v4 ->
                                                               Some
                                                                 (Coq_Compilers.UnderLets.splice
                                                                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))))
                                                                   (fun fv ->
                                                                   Coq_Compilers.UnderLets.Base
                                                                   (v4
                                                                    (v3 fv))))
                                                             | None -> None)
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                         | None -> None)
                                  else None
                                | None -> None))
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (_, _, _, _) -> None
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                (sequence
                  (match x with
                   | Compilers.Coq_expr.Ident (_, _) -> None
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (s0, _, f, x1) ->
                     (match f with
                      | Compilers.Coq_expr.Ident (t0, idc0) ->
                        bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                            t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                          (fun _ ->
                          match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                  (fun x2 y ->
                                  match x2 with
                                  | Coq3_Compilers.Z ->
                                    (match y with
                                     | Coq3_Compilers.Z -> true
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_bool ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> true
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_nat ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> true
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_zrange ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> true
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_string ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> true))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow (s0,
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))) with
                          | Some vars0 ->
                            let (_, _) = Obj.magic vars0 in
                            if Compilers.Coq_type.type_beq
                                 (Compilers.Coq_base.Coq_type.type_beq
                                   (fun x2 y ->
                                   match x2 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true)))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))))
                                 (Compilers.Coq_type.Coq_arrow (s0,
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))))
                            then Compilers.Coq_type.try_make_transport_cps
                                   (fun _ x2 x3 _ ->
                                   Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x4 x5 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x4 x5) x2 x3) s0
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)) (fun tro ->
                                   match tro with
                                   | Some v ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x2 x3 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x2 x3)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tro0 ->
                                       match tro0 with
                                       | Some v0 ->
                                         Compilers.Coq_base.try_make_transport_cps
                                           (fun _ x2 x3 _ ->
                                           Coq3_Compilers.try_make_base_transport_cps
                                             x2 x3)
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z) (fun tr ->
                                           match tr with
                                           | Some v1 ->
                                             Compilers.Coq_base.try_make_transport_cps
                                               (fun _ x2 x3 _ ->
                                               Coq3_Compilers.try_make_base_transport_cps
                                                 x2 x3)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z) (fun tr0 ->
                                               match tr0 with
                                               | Some v2 ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x2 x3 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x2 x3)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (fun tr1 ->
                                                   match tr1 with
                                                   | Some v3 ->
                                                     Compilers.Coq_base.try_make_transport_cps
                                                       (fun _ x2 x3 _ ->
                                                       Coq3_Compilers.try_make_base_transport_cps
                                                         x2 x3)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (fun tr' ->
                                                       match tr' with
                                                       | Some v4 ->
                                                         Some
                                                           (Coq_Compilers.UnderLets.splice
                                                             (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                               (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                 Coq3_Compilers.baseHasNat
                                                                 Coq3_Compilers.buildIdent
                                                                 Coq3_Compilers.buildEagerIdent
                                                                 Coq3_Compilers.toRestrictedIdent
                                                                 Coq3_Compilers.invertIdent
                                                                 Coq3_Compilers.baseHasNatCorrect
                                                                 (fun _ x2 x3 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x2 x3))
                                                               false
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (Compilers.Coq_expr.App
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_expr.Ident
                                                               ((Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))),
                                                               Coq3_Compilers.Coq_ident_Z_opp)),
                                                               (Compilers.Coq_expr.App
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_expr.App
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))),
                                                               (Compilers.Coq_expr.Ident
                                                               ((Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))))),
                                                               Coq3_Compilers.Coq_ident_Z_add)),
                                                               (Compilers.Coq_expr.Var
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (v1
                                                                 (v
                                                                   (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))),
                                                               (Compilers.Coq_expr.Var
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Obj.magic v2
                                                                 (v0 x0)))))))))
                                                             (fun fv ->
                                                             Coq_Compilers.UnderLets.Base
                                                             (v4 (v3 fv))))
                                                       | None -> None)
                                                   | None -> None)
                                               | None -> None)
                                           | None -> None)
                                       | None -> None)
                                   | None -> None)
                            else None
                          | None -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  (sequence
                    (match x0 with
                     | Compilers.Coq_expr.Ident (_, _) -> None
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (s0, _, f, x1) ->
                       (match f with
                        | Compilers.Coq_expr.Ident (t0, idc0) ->
                          sequence
                            (bind1
                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                              (fun _ ->
                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                      (fun x2 y ->
                                      match x2 with
                                      | Coq3_Compilers.Z ->
                                        (match y with
                                         | Coq3_Compilers.Z -> true
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_bool ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> true
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_nat ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> true
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_zrange ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> true
                                         | Coq3_Compilers.Coq_string -> false)
                                      | Coq3_Compilers.Coq_string ->
                                        (match y with
                                         | Coq3_Compilers.Z -> false
                                         | Coq3_Compilers.Coq_bool -> false
                                         | Coq3_Compilers.Coq_nat -> false
                                         | Coq3_Compilers.Coq_zrange -> false
                                         | Coq3_Compilers.Coq_string -> true))
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))))
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)), s0)) with
                              | Some vars0 ->
                                let (_, _) = Obj.magic vars0 in
                                if Compilers.Coq_type.type_beq
                                     (Compilers.Coq_base.Coq_type.type_beq
                                       (fun x2 y ->
                                       match x2 with
                                       | Coq3_Compilers.Z ->
                                         (match y with
                                          | Coq3_Compilers.Z -> true
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_bool ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> true
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_nat ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> true
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_zrange ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange -> true
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_string ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string -> true)))
                                     (Compilers.Coq_type.Coq_arrow
                                     ((Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)),
                                     (Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z))))
                                     (Compilers.Coq_type.Coq_arrow
                                     ((Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)), s0))
                                then Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x2 x3 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x2 x3)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z) (fun tro ->
                                       match tro with
                                       | Some v ->
                                         Compilers.Coq_type.try_make_transport_cps
                                           (fun _ x2 x3 _ ->
                                           Compilers.Coq_base.try_make_transport_cps
                                             (fun _ x4 x5 _ ->
                                             Coq3_Compilers.try_make_base_transport_cps
                                               x4 x5) x2 x3) s0
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)) (fun tro0 ->
                                           match tro0 with
                                           | Some v0 ->
                                             Compilers.Coq_base.try_make_transport_cps
                                               (fun _ x2 x3 _ ->
                                               Coq3_Compilers.try_make_base_transport_cps
                                                 x2 x3)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z)
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z) (fun tr ->
                                               match tr with
                                               | Some v1 ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x2 x3 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x2 x3)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)
                                                   (fun tr0 ->
                                                   match tr0 with
                                                   | Some v2 ->
                                                     Compilers.Coq_base.try_make_transport_cps
                                                       (fun _ x2 x3 _ ->
                                                       Coq3_Compilers.try_make_base_transport_cps
                                                         x2 x3)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)
                                                       (fun tr1 ->
                                                       match tr1 with
                                                       | Some v3 ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x2 x3 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x2 x3)
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)
                                                           (fun tr' ->
                                                           match tr' with
                                                           | Some v4 ->
                                                             Some
                                                               (Coq_Compilers.UnderLets.splice
                                                                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                   false
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))
                                                                   (Compilers.Coq_expr.App
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_expr.App
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_expr.Ident
                                                                   ((Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))))),
                                                                   Coq3_Compilers.Coq_ident_Z_add)),
                                                                   (Compilers.Coq_expr.Var
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (Obj.magic
                                                                    v1 
                                                                    (v x)))))),
                                                                   (Compilers.Coq_expr.Var
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)),
                                                                   (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                 (fun fv ->
                                                                 Coq_Compilers.UnderLets.Base
                                                                 (v4 (v3 fv))))
                                                           | None -> None)
                                                       | None -> None)
                                                   | None -> None)
                                               | None -> None)
                                           | None -> None)
                                       | None -> None)
                                else None
                              | None -> None))
                            (match x with
                             | Compilers.Coq_expr.Ident (t1, idc1) ->
                               sequence
                                 (bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t1 idc1
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args0 ->
                                   bind1
                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                       t0 idc0
                                       Coq3_Compilers.Coq_raw_ident_Z_opp)
                                     (fun _ ->
                                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                             (fun x2 y ->
                                             match x2 with
                                             | Coq3_Compilers.Z ->
                                               (match y with
                                                | Coq3_Compilers.Z -> true
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_bool ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  true
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_nat ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_zrange ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_string ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  true))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x2, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x2))), s0)) with
                                     | Some vars0 ->
                                       let (_, _) = Obj.magic vars0 in
                                       if Compilers.Coq_type.type_beq
                                            (Compilers.Coq_base.Coq_type.type_beq
                                              (fun x2 y ->
                                              match x2 with
                                              | Coq3_Compilers.Z ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> true
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_bool ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   true
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_nat ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   true
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_zrange ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   true
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_string ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   true)))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x2, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x2))), s0))
                                       then bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Z)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_type.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x4 x5 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x4 x5) x2 x3) s0
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (fun tro ->
                                                match tro with
                                                | Some v ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v2 ->
                                                              bind1
                                                                (if Coq_Z.gtb
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2) Z0
                                                                 then 
                                                                   Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                 else None)
                                                                (fun fv ->
                                                                Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  fv
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2
                                                                    (v1 fv0)))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                       else None
                                     | None -> None)))
                                 (bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t1 idc1
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args0 ->
                                   bind1
                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                       t0 idc0
                                       Coq3_Compilers.Coq_raw_ident_Z_opp)
                                     (fun _ ->
                                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                             (fun x2 y ->
                                             match x2 with
                                             | Coq3_Compilers.Z ->
                                               (match y with
                                                | Coq3_Compilers.Z -> true
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_bool ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  true
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_nat ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_zrange ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_string ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  true))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x2, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x2))), s0)) with
                                     | Some vars0 ->
                                       let (_, _) = Obj.magic vars0 in
                                       if Compilers.Coq_type.type_beq
                                            (Compilers.Coq_base.Coq_type.type_beq
                                              (fun x2 y ->
                                              match x2 with
                                              | Coq3_Compilers.Z ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> true
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_bool ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   true
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_nat ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   true
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_zrange ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   true
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_string ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   true)))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x2, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x2))), s0))
                                       then bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Z)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_type.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x4 x5 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x4 x5) x2 x3) s0
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (fun tro ->
                                                match tro with
                                                | Some v ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v2 ->
                                                              bind1
                                                                (if Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2) Z0
                                                                 then 
                                                                   Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2)))))))))
                                                                 else None)
                                                                (fun fv ->
                                                                Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  fv
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2
                                                                    (v1 fv0)))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                       else None
                                     | None -> None)))
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, _, _) -> None
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    (sequence
                      (match x with
                       | Compilers.Coq_expr.Ident (t0, idc0) ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args0 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x1 y ->
                                   match x1 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1))), (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))) with
                           | Some vars0 ->
                             let (_, _) = Obj.magic vars0 in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x1 y ->
                                    match x1 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                             then bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x1, _) =
                                         args0.Coq_Primitive.projT1
                                       in
                                       x1)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x1, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x1),
                                      (let (x1, _) =
                                         let (_, y) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x1)))) (fun xv ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tro ->
                                      match tro with
                                      | Some v ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v0 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr0 ->
                                              match tr0 with
                                              | Some v1 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr' ->
                                                  match tr' with
                                                  | Some v2 ->
                                                    bind1
                                                      (if Coq_Z.ltb
                                                            (let (x1, _) = xv
                                                             in
                                                             x1) Z0
                                                       then Some
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                Coq3_Compilers.Coq_ident_Z_opp)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))))),
                                                                Coq3_Compilers.Coq_ident_Z_add)),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                (Coq3_Compilers.Z,
                                                                (Obj.magic
                                                                  Coq_Z.opp
                                                                  (let (
                                                                    x1, _) =
                                                                    xv
                                                                   in
                                                                   x1)))))))),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Obj.magic v0
                                                                  (v x0)))))))))
                                                       else None) (fun fv ->
                                                      Some
                                                      (Coq_Compilers.UnderLets.splice
                                                        fv (fun fv0 ->
                                                        Coq_Compilers.UnderLets.Base
                                                        (v2 (v1 fv0)))))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None))
                             else None
                           | None -> None)
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (s0, _, f, x1) ->
                         (match f with
                          | Compilers.Coq_expr.Ident (t0, idc0) ->
                            (match x0 with
                             | Compilers.Coq_expr.Ident (t1, idc1) ->
                               sequence
                                 (bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t1 idc1
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args0 ->
                                   bind1
                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                       t0 idc0
                                       Coq3_Compilers.Coq_raw_ident_Z_opp)
                                     (fun _ ->
                                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                             (fun x2 y ->
                                             match x2 with
                                             | Coq3_Compilers.Z ->
                                               (match y with
                                                | Coq3_Compilers.Z -> true
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_bool ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  true
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_nat ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_zrange ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_string ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  true))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))))
                                             (Compilers.Coq_type.Coq_arrow
                                             (s0,
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x2, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x2))))) with
                                     | Some vars0 ->
                                       let (_, _) = Obj.magic vars0 in
                                       if Compilers.Coq_type.type_beq
                                            (Compilers.Coq_base.Coq_type.type_beq
                                              (fun x2 y ->
                                              match x2 with
                                              | Coq3_Compilers.Z ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> true
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_bool ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   true
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_nat ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   true
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_zrange ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   true
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_string ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   true)))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))
                                            (Compilers.Coq_type.Coq_arrow
                                            (s0, (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x2, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x2)))))
                                       then Compilers.Coq_type.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x4 x5) x2 x3) s0
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)) (fun tro ->
                                              match tro with
                                              | Some v ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x2, _) =
                                                       args0.Coq_Primitive.projT1
                                                     in
                                                     x2)))
                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                    Coq3_Compilers.Z)
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    ((let (x2, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x2),
                                                    (let (x2, _) =
                                                       let (_, y) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       y
                                                     in
                                                     x2)))) (fun xv ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v2 ->
                                                              bind1
                                                                (if Coq_Z.gtb
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2) Z0
                                                                 then 
                                                                   Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x2))))))))))
                                                                 else None)
                                                                (fun fv ->
                                                                Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  fv
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2
                                                                    (v1 fv0)))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None))
                                              | None -> None)
                                       else None
                                     | None -> None)))
                                 (bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t1 idc1
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args0 ->
                                   bind1
                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                       t0 idc0
                                       Coq3_Compilers.Coq_raw_ident_Z_opp)
                                     (fun _ ->
                                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                             (fun x2 y ->
                                             match x2 with
                                             | Coq3_Compilers.Z ->
                                               (match y with
                                                | Coq3_Compilers.Z -> true
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_bool ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  true
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_nat ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_zrange ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_string ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  true))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))))
                                             (Compilers.Coq_type.Coq_arrow
                                             (s0,
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x2, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x2))))) with
                                     | Some vars0 ->
                                       let (_, _) = Obj.magic vars0 in
                                       if Compilers.Coq_type.type_beq
                                            (Compilers.Coq_base.Coq_type.type_beq
                                              (fun x2 y ->
                                              match x2 with
                                              | Coq3_Compilers.Z ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> true
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_bool ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   true
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_nat ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   true
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_zrange ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   true
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_string ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   true)))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))
                                            (Compilers.Coq_type.Coq_arrow
                                            (s0, (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x2, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x2)))))
                                       then Compilers.Coq_type.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x4 x5) x2 x3) s0
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)) (fun tro ->
                                              match tro with
                                              | Some v ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x2, _) =
                                                       args0.Coq_Primitive.projT1
                                                     in
                                                     x2)))
                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                    Coq3_Compilers.Z)
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    ((let (x2, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x2),
                                                    (let (x2, _) =
                                                       let (_, y) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       y
                                                     in
                                                     x2)))) (fun xv ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v2 ->
                                                              bind1
                                                                (if Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2) Z0
                                                                 then 
                                                                   Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2)))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                 else None)
                                                                (fun fv ->
                                                                Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  fv
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2
                                                                    (v1 fv0)))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None))
                                              | None -> None)
                                       else None
                                     | None -> None)))
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, _, _) -> None
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (_, _, _, _) -> None
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      (match x0 with
                       | Compilers.Coq_expr.Ident (t0, idc0) ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args0 ->
                           match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                   (fun x1 y ->
                                   match x1 with
                                   | Coq3_Compilers.Z ->
                                     (match y with
                                      | Coq3_Compilers.Z -> true
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> true
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> true
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> true
                                      | Coq3_Compilers.Coq_string -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (match y with
                                      | Coq3_Compilers.Z -> false
                                      | Coq3_Compilers.Coq_bool -> false
                                      | Coq3_Compilers.Coq_nat -> false
                                      | Coq3_Compilers.Coq_zrange -> false
                                      | Coq3_Compilers.Coq_string -> true))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   (let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1))))) with
                           | Some vars0 ->
                             let (_, _) = Obj.magic vars0 in
                             if Compilers.Coq_type.type_beq
                                  (Compilers.Coq_base.Coq_type.type_beq
                                    (fun x1 y ->
                                    match x1 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true)))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))))
                             then Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tro ->
                                    match tro with
                                    | Some v ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x1, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x1)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Z)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x1, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x1),
                                          (let (x1, _) =
                                             let (_, y) =
                                               args0.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x1)))) (fun xv ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr ->
                                          match tr with
                                          | Some v0 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr0 ->
                                              match tr0 with
                                              | Some v1 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr' ->
                                                  match tr' with
                                                  | Some v2 ->
                                                    bind1
                                                      (if Coq_Z.ltb
                                                            (let (x1, _) = xv
                                                             in
                                                             x1) Z0
                                                       then Some
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_expr.App
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))))),
                                                                Coq3_Compilers.Coq_ident_Z_add)),
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Obj.magic v0
                                                                  (v x)))))),
                                                                (Compilers.Coq_expr.Ident
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                (Coq3_Compilers.Z,
                                                                (Obj.magic
                                                                  Coq_Z.opp
                                                                  (let (
                                                                    x1, _) =
                                                                    xv
                                                                   in
                                                                   x1)))))))))
                                                       else None) (fun fv ->
                                                      Some
                                                      (Coq_Compilers.UnderLets.splice
                                                        fv (fun fv0 ->
                                                        Coq_Compilers.UnderLets.Base
                                                        (v2 (v1 fv0)))))
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None))
                                    | None -> None)
                             else None
                           | None -> None)
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None))))))
            None) (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_sub)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (t0, idc0) ->
                  bind1
                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp) (fun _ ->
                    match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                            (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true))
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) s0 with
                    | Some _ ->
                      if Compilers.Coq_type.type_beq
                           (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true)))
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)) s0
                      then Compilers.Coq_type.try_make_transport_cps
                             (fun _ x1 x2 _ ->
                             Compilers.Coq_base.try_make_transport_cps
                               (fun _ x3 x4 _ ->
                               Coq3_Compilers.try_make_base_transport_cps x3
                                 x4) x1 x2) s0 (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)) (fun tro ->
                             match tro with
                             | Some v ->
                               Compilers.Coq_base.try_make_transport_cps
                                 (fun _ x1 x2 _ ->
                                 Coq3_Compilers.try_make_base_transport_cps
                                   x1 x2)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z) (fun tr ->
                                 match tr with
                                 | Some v0 ->
                                   Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x1 x2 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x1 x2)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z) (fun tr0 ->
                                     match tr0 with
                                     | Some v1 ->
                                       Compilers.Coq_base.try_make_transport_cps
                                         (fun _ x1 x2 _ ->
                                         Coq3_Compilers.try_make_base_transport_cps
                                           x1 x2)
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z) (fun tr' ->
                                         match tr' with
                                         | Some v2 ->
                                           Some
                                             (Coq_Compilers.UnderLets.splice
                                               (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                 (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                   Coq3_Compilers.baseHasNat
                                                   Coq3_Compilers.buildIdent
                                                   Coq3_Compilers.buildEagerIdent
                                                   Coq3_Compilers.toRestrictedIdent
                                                   Coq3_Compilers.invertIdent
                                                   Coq3_Compilers.baseHasNatCorrect
                                                   (fun _ x1 x2 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x1 x2)) false
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (Compilers.Coq_expr.Var
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)),
                                                 (v0
                                                   (v
                                                     (Coq1_Compilers.RewriteRules.Compile.reflect
                                                       false s0 x0))))))
                                               (fun fv ->
                                               Coq_Compilers.UnderLets.Base
                                               (v2 (v1 fv))))
                                         | None -> None)
                                     | None -> None)
                                 | None -> None)
                             | None -> None)
                      else None
                    | None -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
            (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                     (fun x0 y ->
                     match x0 with
                     | Coq3_Compilers.Z ->
                       (match y with
                        | Coq3_Compilers.Z -> true
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_bool ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> true
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_nat ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> true
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_zrange ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> true
                        | Coq3_Compilers.Coq_string -> false)
                     | Coq3_Compilers.Coq_string ->
                       (match y with
                        | Coq3_Compilers.Z -> false
                        | Coq3_Compilers.Coq_bool -> false
                        | Coq3_Compilers.Coq_nat -> false
                        | Coq3_Compilers.Coq_zrange -> false
                        | Coq3_Compilers.Coq_string -> true))
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) with
             | Some _ ->
               if Compilers.Coq_type.type_beq
                    (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                      match x0 with
                      | Coq3_Compilers.Z ->
                        (match y with
                         | Coq3_Compilers.Z -> true
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_bool ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> true
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_nat ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> true
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_zrange ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> true
                         | Coq3_Compilers.Coq_string -> false)
                      | Coq3_Compilers.Coq_string ->
                        (match y with
                         | Coq3_Compilers.Z -> false
                         | Coq3_Compilers.Coq_bool -> false
                         | Coq3_Compilers.Coq_nat -> false
                         | Coq3_Compilers.Coq_zrange -> false
                         | Coq3_Compilers.Coq_string -> true)))
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))
               then Compilers.Coq_base.try_make_transport_cps
                      (fun _ x0 x1 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x0 x1)
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z) (fun tro ->
                      match tro with
                      | Some v ->
                        Compilers.Coq_base.try_make_transport_cps
                          (fun _ x0 x1 _ ->
                          Coq3_Compilers.try_make_base_transport_cps x0 x1)
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) (fun tr ->
                          match tr with
                          | Some v0 ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x0 x1 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x0
                                x1)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tr0 ->
                              match tr0 with
                              | Some v1 ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x0 x1 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x0 x1)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr' ->
                                  match tr' with
                                  | Some v2 ->
                                    bind1
                                      (if Coq_Compilers.SubstVarLike.is_recursively_var_or_ident
                                            Coq3_Compilers.ident_is_var_like
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)) (v0 (v x))
                                       then None
                                       else Some
                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                  Coq3_Compilers.baseHasNat
                                                  Coq3_Compilers.buildIdent
                                                  Coq3_Compilers.buildEagerIdent
                                                  Coq3_Compilers.toRestrictedIdent
                                                  Coq3_Compilers.invertIdent
                                                  Coq3_Compilers.baseHasNatCorrect
                                                  (fun _ x0 x1 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x0 x1)) false
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (Compilers.Coq_expr.LetIn
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_expr.Var
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Obj.magic v0 (v x)))),
                                                (fun v3 ->
                                                Compilers.Coq_expr.App
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_expr.Ident
                                                ((Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)))),
                                                Coq3_Compilers.Coq_ident_Z_opp)),
                                                (Compilers.Coq_expr.Var
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)), v3))))))))
                                      (fun fv -> Some
                                      (Coq_Compilers.UnderLets.splice fv
                                        (fun fv0 ->
                                        Coq_Compilers.UnderLets.Base
                                        (v2 (v1 fv0)))))
                                  | None -> None)
                              | None -> None)
                          | None -> None)
                      | None -> None)
               else None
             | None -> None)) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_Z_opp)), x))))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x0 with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               sequence
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                     then Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tro ->
                            match tro with
                            | Some v ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))
                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                  Coq3_Compilers.Z)
                                  (Coq3_Compilers.Coq_ident_Literal
                                  ((let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1),
                                  (let (x1, _) =
                                     let (_, y) = args0.Coq_Primitive.projT2
                                     in
                                     y
                                   in
                                   x1)))) (fun xv ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1)
                                                    (Zpos XH)
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v0 (v x)))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v2 (v1 fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                            | None -> None)
                     else None
                   | None -> None))
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                     then Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tro ->
                            match tro with
                            | Some v ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))
                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                  Coq3_Compilers.Z)
                                  (Coq3_Compilers.Coq_ident_Literal
                                  ((let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1),
                                  (let (x1, _) =
                                     let (_, y) = args0.Coq_Primitive.projT2
                                     in
                                     y
                                   in
                                   x1)))) (fun xv ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1)
                                                    (Coq_Z.pow (Zpos (XO XH))
                                                      (Coq_Z.log2
                                                        (let (x1, _) = xv in
                                                         x1)))
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v0 (v x)))))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        (Coq3_Compilers.Z,
                                                        (Obj.magic Coq_Z.log2
                                                          (let (x1, _) = xv
                                                           in
                                                           x1)))))))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v2 (v1 fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                            | None -> None)
                     else None
                   | None -> None))
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_div)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x0 with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               sequence
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                     then Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tro ->
                            match tro with
                            | Some _ ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))
                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                  Coq3_Compilers.Z)
                                  (Coq3_Compilers.Coq_ident_Literal
                                  ((let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1),
                                  (let (x1, _) =
                                     let (_, y) = args0.Coq_Primitive.projT2
                                     in
                                     y
                                   in
                                   x1)))) (fun xv ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v0 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1)
                                                    (Zpos XH)
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        (Coq3_Compilers.Z,
                                                        (Obj.magic Z0))))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v0 (v fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                            | None -> None)
                     else None
                   | None -> None))
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                     then Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tro ->
                            match tro with
                            | Some v ->
                              bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))
                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                  Coq3_Compilers.Z)
                                  (Coq3_Compilers.Coq_ident_Literal
                                  ((let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1),
                                  (let (x1, _) =
                                     let (_, y) = args0.Coq_Primitive.projT2
                                     in
                                     y
                                   in
                                   x1)))) (fun xv ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1)
                                                    (Coq_Z.pow (Zpos (XO XH))
                                                      (Coq_Z.log2
                                                        (let (x1, _) = xv in
                                                         x1)))
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        Coq3_Compilers.Coq_ident_Z_land)),
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v0 (v x)))))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        (Coq3_Compilers.Z,
                                                        (Obj.magic Coq_Z.sub
                                                          (let (x1, _) = xv
                                                           in
                                                           x1) (Zpos XH)))))))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v2 (v1 fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                            | None -> None)
                     else None
                   | None -> None))
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (sequence
              (match x0 with
               | Compilers.Coq_expr.Ident (t0, idc0) ->
                 sequence
                   (bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                       then Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some _ ->
                                bind1
                                  (Obj.magic
                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1)))
                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                    Coq3_Compilers.Z)
                                    (Coq3_Compilers.Coq_ident_Literal
                                    ((let (x1, _) =
                                        args0.Coq_Primitive.projT1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       y
                                     in
                                     x1)))) (fun xv ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v0 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      Z0
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          (Coq3_Compilers.Z,
                                                          (Obj.magic Z0))))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v0 (v fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None))
                              | None -> None)
                       else None
                     | None -> None))
                   (bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                       then Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some _ ->
                                bind1
                                  (Obj.magic
                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1)))
                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                    Coq3_Compilers.Z)
                                    (Coq3_Compilers.Coq_ident_Literal
                                    ((let (x1, _) =
                                        args0.Coq_Primitive.projT1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       y
                                     in
                                     x1)))) (fun xv ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v0 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      Z0
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          (Coq3_Compilers.Z,
                                                          (Obj.magic Z0))))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v0 (v fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None))
                              | None -> None)
                       else None
                     | None -> None))
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, _, _) -> None
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (sequence
                (match x with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                       then bind1
                              (Obj.magic
                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                (let (x1, _) = args0.Coq_Primitive.projT1 in
                                 x1)))
                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                Coq3_Compilers.Z)
                                (Coq3_Compilers.Coq_ident_Literal
                                ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                  x1),
                                (let (x1, _) =
                                   let (_, y) = args0.Coq_Primitive.projT2 in
                                   y
                                 in
                                 x1)))) (fun xv ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tro ->
                                match tro with
                                | Some _ ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v0 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      Z0
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          (Coq3_Compilers.Z,
                                                          (Obj.magic Z0))))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v0 (v fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None))
                       else None
                     | None -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                (sequence
                  (match x0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)),
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z))))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)),
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               (let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1))))) with
                       | Some vars0 ->
                         let (_, _) = Obj.magic vars0 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                         then Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tro ->
                                match tro with
                                | Some v ->
                                  bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x1, _) =
                                         args0.Coq_Primitive.projT1
                                       in
                                       x1)))
                                      (Coq3_Compilers.Coq_pattern_ident_Literal
                                      Coq3_Compilers.Z)
                                      (Coq3_Compilers.Coq_ident_Literal
                                      ((let (x1, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x1),
                                      (let (x1, _) =
                                         let (_, y) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         y
                                       in
                                       x1)))) (fun xv ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr ->
                                      match tr with
                                      | Some v0 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr0 ->
                                          match tr0 with
                                          | Some v1 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v2 ->
                                                bind1
                                                  (if Coq_Z.eqb
                                                        (let (x1, _) = xv in
                                                         x1) (Zneg XH)
                                                   then Some
                                                          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                              Coq3_Compilers.baseHasNat
                                                              Coq3_Compilers.buildIdent
                                                              Coq3_Compilers.buildEagerIdent
                                                              Coq3_Compilers.toRestrictedIdent
                                                              Coq3_Compilers.invertIdent
                                                              Coq3_Compilers.baseHasNatCorrect
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)) false
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Obj.magic v0
                                                              (v x)))))
                                                   else None) (fun fv -> Some
                                                  (Coq_Compilers.UnderLets.splice
                                                    fv (fun fv0 ->
                                                    Coq_Compilers.UnderLets.Base
                                                    (v2 (v1 fv0)))))
                                              | None -> None)
                                          | None -> None)
                                      | None -> None))
                                | None -> None)
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  (match x with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)),
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z))))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               (let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Z)))) with
                       | Some vars0 ->
                         let (_, _) = Obj.magic vars0 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))
                         then bind1
                                (Obj.magic
                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  (let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1)))
                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                  Coq3_Compilers.Z)
                                  (Coq3_Compilers.Coq_ident_Literal
                                  ((let (x1, _) = args0.Coq_Primitive.projT1
                                    in
                                    x1),
                                  (let (x1, _) =
                                     let (_, y) = args0.Coq_Primitive.projT2
                                     in
                                     y
                                   in
                                   x1)))) (fun xv ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tro ->
                                  match tro with
                                  | Some v ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr ->
                                      match tr with
                                      | Some v0 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr0 ->
                                          match tr0 with
                                          | Some v1 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tr' ->
                                              match tr' with
                                              | Some v2 ->
                                                bind1
                                                  (if Coq_Z.eqb
                                                        (let (x1, _) = xv in
                                                         x1) (Zneg XH)
                                                   then Some
                                                          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                              Coq3_Compilers.baseHasNat
                                                              Coq3_Compilers.buildIdent
                                                              Coq3_Compilers.buildEagerIdent
                                                              Coq3_Compilers.toRestrictedIdent
                                                              Coq3_Compilers.invertIdent
                                                              Coq3_Compilers.baseHasNatCorrect
                                                              (fun _ x1 x2 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x1 x2)) false
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))
                                                            (Compilers.Coq_expr.Var
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Obj.magic v0
                                                              (v x0)))))
                                                   else None) (fun fv -> Some
                                                  (Coq_Compilers.UnderLets.splice
                                                    fv (fun fv0 ->
                                                    Coq_Compilers.UnderLets.Base
                                                    (v2 (v1 fv0)))))
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)
                                  | None -> None))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)))) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_land)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x0 with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x1 y ->
                         match x1 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                 | Some vars0 ->
                   let (_, _) = Obj.magic vars0 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                          match x1 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                   then Compilers.Coq_base.try_make_transport_cps
                          (fun _ x1 x2 _ ->
                          Coq3_Compilers.try_make_base_transport_cps x1 x2)
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z) (fun tro ->
                          match tro with
                          | Some v ->
                            bind1
                              (Obj.magic
                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                (let (x1, _) = args0.Coq_Primitive.projT1 in
                                 x1)))
                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                Coq3_Compilers.Z)
                                (Coq3_Compilers.Coq_ident_Literal
                                ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                  x1),
                                (let (x1, _) =
                                   let (_, y) = args0.Coq_Primitive.projT2 in
                                   y
                                 in
                                 x1)))) (fun xv ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr ->
                                match tr with
                                | Some v0 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr0 ->
                                    match tr0 with
                                    | Some v1 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr' ->
                                        match tr' with
                                        | Some v2 ->
                                          bind1
                                            (if Coq_Z.eqb
                                                  (let (x1, _) = xv in x1) Z0
                                             then Some
                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                      (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                        Coq3_Compilers.baseHasNat
                                                        Coq3_Compilers.buildIdent
                                                        Coq3_Compilers.buildEagerIdent
                                                        Coq3_Compilers.toRestrictedIdent
                                                        Coq3_Compilers.invertIdent
                                                        Coq3_Compilers.baseHasNatCorrect
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2)) false
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))
                                                      (Compilers.Coq_expr.Var
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Obj.magic v0 (v x)))))
                                             else None) (fun fv -> Some
                                            (Coq_Compilers.UnderLets.splice
                                              fv (fun fv0 ->
                                              Coq_Compilers.UnderLets.Base
                                              (v2 (v1 fv0)))))
                                        | None -> None)
                                    | None -> None)
                                | None -> None))
                          | None -> None)
                   else None
                 | None -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
            (sequence
              (match x with
               | Compilers.Coq_expr.Ident (t0, idc0) ->
                 bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))))
                     then bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))
                              (Coq3_Compilers.Coq_pattern_ident_Literal
                              Coq3_Compilers.Z)
                              (Coq3_Compilers.Coq_ident_Literal
                              ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1),
                              (let (x1, _) =
                                 let (_, y) = args0.Coq_Primitive.projT2 in y
                               in
                               x1)))) (fun xv ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some v ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some v0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v1 ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v2 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1)
                                                    Z0
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v0 (v x0)))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v2 (v1 fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None)
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, _, _) -> None
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (sequence
                (match x0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                       then Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some _ ->
                                bind1
                                  (Obj.magic
                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    (let (x1, _) = args0.Coq_Primitive.projT1
                                     in
                                     x1)))
                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                    Coq3_Compilers.Z)
                                    (Coq3_Compilers.Coq_ident_Literal
                                    ((let (x1, _) =
                                        args0.Coq_Primitive.projT1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       y
                                     in
                                     x1)))) (fun xv ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v0 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      (Zneg XH)
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          (Coq3_Compilers.Z,
                                                          (Obj.magic (Zneg
                                                            XH)))))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v0 (v fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None))
                              | None -> None)
                       else None
                     | None -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                (match x with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   bind1
                     (Obj.magic
                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                       t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                     (fun args0 ->
                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                             (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z))))
                             (Compilers.Coq_type.Coq_arrow
                             ((Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)))) with
                     | Some vars0 ->
                       let (_, _) = Obj.magic vars0 in
                       if Compilers.Coq_type.type_beq
                            (Compilers.Coq_base.Coq_type.type_beq
                              (fun x1 y ->
                              match x1 with
                              | Coq3_Compilers.Z ->
                                (match y with
                                 | Coq3_Compilers.Z -> true
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_bool ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> true
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_nat ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> true
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_zrange ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> true
                                 | Coq3_Compilers.Coq_string -> false)
                              | Coq3_Compilers.Coq_string ->
                                (match y with
                                 | Coq3_Compilers.Z -> false
                                 | Coq3_Compilers.Coq_bool -> false
                                 | Coq3_Compilers.Coq_nat -> false
                                 | Coq3_Compilers.Coq_zrange -> false
                                 | Coq3_Compilers.Coq_string -> true)))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                       then bind1
                              (Obj.magic
                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                (let (x1, _) = args0.Coq_Primitive.projT1 in
                                 x1)))
                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                Coq3_Compilers.Z)
                                (Coq3_Compilers.Coq_ident_Literal
                                ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                  x1),
                                (let (x1, _) =
                                   let (_, y) = args0.Coq_Primitive.projT2 in
                                   y
                                 in
                                 x1)))) (fun xv ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tro ->
                                match tro with
                                | Some _ ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr ->
                                    match tr with
                                    | Some _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr0 ->
                                        match tr0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr' ->
                                            match tr' with
                                            | Some v0 ->
                                              bind1
                                                (if Coq_Z.eqb
                                                      (let (x1, _) = xv in x1)
                                                      (Zneg XH)
                                                 then Some
                                                        (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                          (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                            Coq3_Compilers.baseHasNat
                                                            Coq3_Compilers.buildIdent
                                                            Coq3_Compilers.buildEagerIdent
                                                            Coq3_Compilers.toRestrictedIdent
                                                            Coq3_Compilers.invertIdent
                                                            Coq3_Compilers.baseHasNatCorrect
                                                            (fun _ x1 x2 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x1 x2)) false
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_expr.Ident
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          (Coq3_Compilers.Z,
                                                          (Obj.magic (Zneg
                                                            XH)))))))
                                                 else None) (fun fv -> Some
                                                (Coq_Compilers.UnderLets.splice
                                                  fv (fun fv0 ->
                                                  Coq_Compilers.UnderLets.Base
                                                  (v0 (v fv0)))))
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None))
                       else None
                     | None -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None))))
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_lor)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x1 with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x2) ->
               (match f with
                | Compilers.Coq_expr.Ident (t0, idc0) ->
                  bind1
                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp) (fun _ ->
                    match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                            (fun x3 y ->
                            match x3 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))), s0)) with
                    | Some vars0 ->
                      let (a, _) = Obj.magic vars0 in
                      let (_, _) = a in
                      if Compilers.Coq_type.type_beq
                           (Compilers.Coq_base.Coq_type.type_beq (fun x3 y ->
                             match x3 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true)))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))), s0))
                      then Compilers.Coq_base.try_make_transport_cps
                             (fun _ x3 x4 _ ->
                             Coq3_Compilers.try_make_base_transport_cps x3 x4)
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z) (fun tro ->
                             match tro with
                             | Some v ->
                               Compilers.Coq_base.try_make_transport_cps
                                 (fun _ x3 x4 _ ->
                                 Coq3_Compilers.try_make_base_transport_cps
                                   x3 x4)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z) (fun tro0 ->
                                 match tro0 with
                                 | Some v0 ->
                                   Compilers.Coq_type.try_make_transport_cps
                                     (fun _ x3 x4 _ ->
                                     Compilers.Coq_base.try_make_transport_cps
                                       (fun _ x5 x6 _ ->
                                       Coq3_Compilers.try_make_base_transport_cps
                                         x5 x6) x3 x4) s0
                                     (Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)) (fun tro1 ->
                                     match tro1 with
                                     | Some v1 ->
                                       Compilers.Coq_base.try_make_transport_cps
                                         (fun _ x3 x4 _ ->
                                         Coq3_Compilers.try_make_base_transport_cps
                                           x3 x4)
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z) (fun tr ->
                                         match tr with
                                         | Some v2 ->
                                           Compilers.Coq_base.try_make_transport_cps
                                             (fun _ x3 x4 _ ->
                                             Coq3_Compilers.try_make_base_transport_cps
                                               x3 x4)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z) (fun tr0 ->
                                             match tr0 with
                                             | Some v3 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x3 x4)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (fun tr1 ->
                                                 match tr1 with
                                                 | Some v4 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x3 x4)
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (fun tr2 ->
                                                     match tr2 with
                                                     | Some v5 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x3 x4)
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))
                                                         (fun tr' ->
                                                         match tr' with
                                                         | Some v6 ->
                                                           Some
                                                             (Coq_Compilers.UnderLets.splice
                                                               (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                 (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                   Coq3_Compilers.baseHasNat
                                                                   Coq3_Compilers.buildIdent
                                                                   Coq3_Compilers.buildEagerIdent
                                                                   Coq3_Compilers.toRestrictedIdent
                                                                   Coq3_Compilers.invertIdent
                                                                   Coq3_Compilers.baseHasNatCorrect
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                 false
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))
                                                                 (Compilers.Coq_expr.LetIn
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))))),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))))))),
                                                                 Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Obj.magic
                                                                   v2 
                                                                   (v x)))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Obj.magic
                                                                   v3
                                                                   (v0 x0)))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (v4
                                                                   (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x2))))))),
                                                                 (fun v7 ->
                                                                 Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))))),
                                                                 (Coq3_Compilers.Coq_ident_pair
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Coq3_Compilers.Coq_ident_fst
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 v7)))))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 Coq3_Compilers.Coq_ident_Z_opp)),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Coq3_Compilers.Coq_ident_snd
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 v7)))))))))))
                                                               (fun fv ->
                                                               Coq_Compilers.UnderLets.Base
                                                               (v6 (v5 fv))))
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                         | None -> None)
                                     | None -> None)
                                 | None -> None)
                             | None -> None)
                      else None
                    | None -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
            (match x0 with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x2) ->
               (match f with
                | Compilers.Coq_expr.Ident (t0, idc0) ->
                  bind1
                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp) (fun _ ->
                    match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                            (fun x3 y ->
                            match x3 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), s0)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))) with
                    | Some vars0 ->
                      let (a, _) = Obj.magic vars0 in
                      let (_, _) = a in
                      if Compilers.Coq_type.type_beq
                           (Compilers.Coq_base.Coq_type.type_beq (fun x3 y ->
                             match x3 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true)))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)), s0)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z))))
                      then Compilers.Coq_base.try_make_transport_cps
                             (fun _ x3 x4 _ ->
                             Coq3_Compilers.try_make_base_transport_cps x3 x4)
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z) (fun tro ->
                             match tro with
                             | Some v ->
                               Compilers.Coq_type.try_make_transport_cps
                                 (fun _ x3 x4 _ ->
                                 Compilers.Coq_base.try_make_transport_cps
                                   (fun _ x5 x6 _ ->
                                   Coq3_Compilers.try_make_base_transport_cps
                                     x5 x6) x3 x4) s0
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)) (fun tro0 ->
                                 match tro0 with
                                 | Some v0 ->
                                   Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x3 x4 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x3 x4)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z) (fun tro1 ->
                                     match tro1 with
                                     | Some v1 ->
                                       Compilers.Coq_base.try_make_transport_cps
                                         (fun _ x3 x4 _ ->
                                         Coq3_Compilers.try_make_base_transport_cps
                                           x3 x4)
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z) (fun tr ->
                                         match tr with
                                         | Some v2 ->
                                           Compilers.Coq_base.try_make_transport_cps
                                             (fun _ x3 x4 _ ->
                                             Coq3_Compilers.try_make_base_transport_cps
                                               x3 x4)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z) (fun tr0 ->
                                             match tr0 with
                                             | Some v3 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x3 x4 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x3 x4)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (fun tr1 ->
                                                 match tr1 with
                                                 | Some v4 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x3 x4 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x3 x4)
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z),
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))
                                                     (fun tr2 ->
                                                     match tr2 with
                                                     | Some v5 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x3 x4)
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z),
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))
                                                         (fun tr' ->
                                                         match tr' with
                                                         | Some v6 ->
                                                           Some
                                                             (Coq_Compilers.UnderLets.splice
                                                               (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                 (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                   Coq3_Compilers.baseHasNat
                                                                   Coq3_Compilers.buildIdent
                                                                   Coq3_Compilers.buildEagerIdent
                                                                   Coq3_Compilers.toRestrictedIdent
                                                                   Coq3_Compilers.invertIdent
                                                                   Coq3_Compilers.baseHasNatCorrect
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                 false
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))
                                                                 (Compilers.Coq_expr.LetIn
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))))),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))))))),
                                                                 Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Obj.magic
                                                                   v2 
                                                                   (v x)))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Obj.magic
                                                                   v4
                                                                   (v1 x1)))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (v3
                                                                   (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x2))))))),
                                                                 (fun v7 ->
                                                                 Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))))))),
                                                                 (Coq3_Compilers.Coq_ident_pair
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Coq3_Compilers.Coq_ident_fst
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 v7)))))),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 Coq3_Compilers.Coq_ident_Z_opp)),
                                                                 (Compilers.Coq_expr.App
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_expr.Ident
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Coq3_Compilers.Coq_ident_snd
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))),
                                                                 (Compilers.Coq_expr.Var
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 v7)))))))))))
                                                               (fun fv ->
                                                               Coq_Compilers.UnderLets.Base
                                                               (v6 (v5 fv))))
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                         | None -> None)
                                     | None -> None)
                                 | None -> None)
                             | None -> None)
                      else None
                    | None -> None)
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, _, _) -> None
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None))
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))),
          Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 ->
        sequence_return0
          (match x0 with
           | Compilers.Coq_expr.Ident (t0, idc0) ->
             sequence
               (match x2 with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s0, _, f, x3) ->
                  (match f with
                   | Compilers.Coq_expr.Ident (t1, idc1) ->
                     bind1
                       (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                       (fun _ ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args0 ->
                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                 (fun x4 y ->
                                 match x4 with
                                 | Coq3_Compilers.Z ->
                                   (match y with
                                    | Coq3_Compilers.Z -> true
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_bool ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> true
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_nat ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> true
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_zrange ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> true
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_string ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> true))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)))),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)))),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x4, _) = args0.Coq_Primitive.projT1 in
                                  x4))))), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)))), s0)) with
                         | Some vars0 ->
                           let (a, _) = Obj.magic vars0 in
                           let (a0, _) = a in
                           let (_, _) = a0 in
                           if Compilers.Coq_type.type_beq
                                (Compilers.Coq_base.Coq_type.type_beq
                                  (fun x4 y ->
                                  match x4 with
                                  | Coq3_Compilers.Z ->
                                    (match y with
                                     | Coq3_Compilers.Z -> true
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_bool ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> true
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_nat ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> true
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_zrange ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> true
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_string ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> true)))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                (let (x4, _) = args0.Coq_Primitive.projT1 in
                                 x4))))), (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))), s0))
                           then Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x4 x5 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x4 x5)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tro ->
                                  match tro with
                                  | Some v ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x4, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x4)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x4, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x4),
                                        (let (x4, _) =
                                           let (_, y) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x4)))) (fun xv ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x4 x5 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x4 x5)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tro0 ->
                                        match tro0 with
                                        | Some v0 ->
                                          Compilers.Coq_type.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x6 x7 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x6 x7) x4 x5) s0
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)) (fun tro1 ->
                                            match tro1 with
                                            | Some v1 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x4 x5)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr ->
                                                match tr with
                                                | Some v2 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x4 x5 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x4 x5)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr0 ->
                                                    match tr0 with
                                                    | Some v3 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x4 x5 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x4 x5)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr1 ->
                                                        match tr1 with
                                                        | Some v4 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x4 x5 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x4 x5)
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))
                                                            (fun tr2 ->
                                                            match tr2 with
                                                            | Some v5 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x4 x5 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x4 x5)
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (fun tr' ->
                                                                match tr' with
                                                                | Some v6 ->
                                                                  bind1
                                                                    (
                                                                    if 
                                                                    Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4) Z0
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v2 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v3
                                                                    (v0 x1)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None))
                                  | None -> None)
                           else None
                         | None -> None))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               (match x1 with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s0, _, f, x3) ->
                  (match f with
                   | Compilers.Coq_expr.Ident (t1, idc1) ->
                     bind1
                       (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                       (fun _ ->
                       bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                         (fun args0 ->
                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                 (fun x4 y ->
                                 match x4 with
                                 | Coq3_Compilers.Z ->
                                   (match y with
                                    | Coq3_Compilers.Z -> true
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_bool ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> true
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_nat ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> true
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_zrange ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> true
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_string ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> true))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)))),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)))),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x4, _) = args0.Coq_Primitive.projT1 in
                                  x4))))), s0)), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)))) with
                         | Some vars0 ->
                           let (a, _) = Obj.magic vars0 in
                           let (a0, _) = a in
                           let (_, _) = a0 in
                           if Compilers.Coq_type.type_beq
                                (Compilers.Coq_base.Coq_type.type_beq
                                  (fun x4 y ->
                                  match x4 with
                                  | Coq3_Compilers.Z ->
                                    (match y with
                                     | Coq3_Compilers.Z -> true
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_bool ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> true
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_nat ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> true
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_zrange ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> true
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_string ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> true)))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                (let (x4, _) = args0.Coq_Primitive.projT1 in
                                 x4))))), s0)), (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))))
                           then Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x4 x5 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x4 x5)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tro ->
                                  match tro with
                                  | Some v ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x4, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x4)))
                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                        Coq3_Compilers.Z)
                                        (Coq3_Compilers.Coq_ident_Literal
                                        ((let (x4, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x4),
                                        (let (x4, _) =
                                           let (_, y) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           y
                                         in
                                         x4)))) (fun xv ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x4 x5 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x6 x7 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x6 x7) x4 x5) s0
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)) (fun tro0 ->
                                        match tro0 with
                                        | Some v0 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x4 x5)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tro1 ->
                                            match tro1 with
                                            | Some v1 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x4 x5)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr ->
                                                match tr with
                                                | Some v2 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x4 x5 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x4 x5)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr0 ->
                                                    match tr0 with
                                                    | Some v3 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x4 x5 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x4 x5)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr1 ->
                                                        match tr1 with
                                                        | Some v4 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x4 x5 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x4 x5)
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))
                                                            (fun tr2 ->
                                                            match tr2 with
                                                            | Some v5 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x4 x5 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x4 x5)
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (fun tr' ->
                                                                match tr' with
                                                                | Some v6 ->
                                                                  bind1
                                                                    (
                                                                    if 
                                                                    Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4) Z0
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v2 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v4
                                                                    (v1 x2)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None))
                                  | None -> None)
                           else None
                         | None -> None))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (s0, _, f, x3) ->
             (match f with
              | Compilers.Coq_expr.Ident (t0, idc0) ->
                sequence
                  (match x1 with
                   | Compilers.Coq_expr.Ident (_, _) -> None
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (s1, _, f0, x4) ->
                     (match f0 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                            t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                          (fun _ ->
                          bind1
                            (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                              t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                            (fun _ ->
                            match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                    (fun x5 y ->
                                    match x5 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)), s0)), s1)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))) with
                            | Some vars0 ->
                              let (a, _) = Obj.magic vars0 in
                              let (a0, _) = a in
                              let (_, _) = a0 in
                              if Compilers.Coq_type.type_beq
                                   (Compilers.Coq_base.Coq_type.type_beq
                                     (fun x5 y ->
                                     match x5 with
                                     | Coq3_Compilers.Z ->
                                       (match y with
                                        | Coq3_Compilers.Z -> true
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_bool ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> true
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_nat ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> true
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_zrange ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> true
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_string ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> true)))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)), s0)), s1)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                              then Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x5 x6 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x5 x6)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z) (fun tro ->
                                     match tro with
                                     | Some v ->
                                       Compilers.Coq_type.try_make_transport_cps
                                         (fun _ x5 x6 _ ->
                                         Compilers.Coq_base.try_make_transport_cps
                                           (fun _ x7 x8 _ ->
                                           Coq3_Compilers.try_make_base_transport_cps
                                             x7 x8) x5 x6) s0
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)) (fun tro0 ->
                                         match tro0 with
                                         | Some v0 ->
                                           Compilers.Coq_type.try_make_transport_cps
                                             (fun _ x5 x6 _ ->
                                             Compilers.Coq_base.try_make_transport_cps
                                               (fun _ x7 x8 _ ->
                                               Coq3_Compilers.try_make_base_transport_cps
                                                 x7 x8) x5 x6) s1
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)) (fun tro1 ->
                                             match tro1 with
                                             | Some v1 ->
                                               Compilers.Coq_base.try_make_transport_cps
                                                 (fun _ x5 x6 _ ->
                                                 Coq3_Compilers.try_make_base_transport_cps
                                                   x5 x6)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)
                                                 (fun tro2 ->
                                                 match tro2 with
                                                 | Some v2 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x5 x6 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x5 x6)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (fun tr ->
                                                     match tr with
                                                     | Some v3 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x5 x6 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x5 x6)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (fun tr0 ->
                                                         match tr0 with
                                                         | Some v4 ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x5 x6 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x5 x6)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (fun tr1 ->
                                                             match tr1 with
                                                             | Some v5 ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (fun tr2 ->
                                                                 match tr2 with
                                                                 | Some v6 ->
                                                                   Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr3 ->
                                                                    match tr3 with
                                                                    | Some v7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v8 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v3 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v6
                                                                    (v2 x2)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v5
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v8
                                                                    (v7 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                 | None ->
                                                                   None)
                                                             | None -> None)
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                         | None -> None)
                                     | None -> None)
                              else None
                            | None -> None))
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  (match x2 with
                   | Compilers.Coq_expr.Ident (_, _) -> None
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (s1, _, f0, x4) ->
                     (match f0 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        bind1
                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                            t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_opp)
                          (fun _ ->
                          bind1
                            (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                              t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_opp)
                            (fun _ ->
                            match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                    (fun x5 y ->
                                    match x5 with
                                    | Coq3_Compilers.Z ->
                                      (match y with
                                       | Coq3_Compilers.Z -> true
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> true
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> true
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> true
                                       | Coq3_Compilers.Coq_string -> false)
                                    | Coq3_Compilers.Coq_string ->
                                      (match y with
                                       | Coq3_Compilers.Z -> false
                                       | Coq3_Compilers.Coq_bool -> false
                                       | Coq3_Compilers.Coq_nat -> false
                                       | Coq3_Compilers.Coq_zrange -> false
                                       | Coq3_Compilers.Coq_string -> true))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)), s0)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))), s1)) with
                            | Some vars0 ->
                              let (a, _) = Obj.magic vars0 in
                              let (a0, _) = a in
                              let (_, _) = a0 in
                              if Compilers.Coq_type.type_beq
                                   (Compilers.Coq_base.Coq_type.type_beq
                                     (fun x5 y ->
                                     match x5 with
                                     | Coq3_Compilers.Z ->
                                       (match y with
                                        | Coq3_Compilers.Z -> true
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_bool ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> true
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_nat ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> true
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_zrange ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> true
                                        | Coq3_Compilers.Coq_string -> false)
                                     | Coq3_Compilers.Coq_string ->
                                       (match y with
                                        | Coq3_Compilers.Z -> false
                                        | Coq3_Compilers.Coq_bool -> false
                                        | Coq3_Compilers.Coq_nat -> false
                                        | Coq3_Compilers.Coq_zrange -> false
                                        | Coq3_Compilers.Coq_string -> true)))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z))))
                                   (Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_arrow
                                   ((Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)), s0)),
                                   (Compilers.Coq_type.Coq_base
                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                   Coq3_Compilers.Z)))), s1))
                              then Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x5 x6 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x5 x6)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z) (fun tro ->
                                     match tro with
                                     | Some v ->
                                       Compilers.Coq_type.try_make_transport_cps
                                         (fun _ x5 x6 _ ->
                                         Compilers.Coq_base.try_make_transport_cps
                                           (fun _ x7 x8 _ ->
                                           Coq3_Compilers.try_make_base_transport_cps
                                             x7 x8) x5 x6) s0
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)) (fun tro0 ->
                                         match tro0 with
                                         | Some v0 ->
                                           Compilers.Coq_base.try_make_transport_cps
                                             (fun _ x5 x6 _ ->
                                             Coq3_Compilers.try_make_base_transport_cps
                                               x5 x6)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z) (fun tro1 ->
                                             match tro1 with
                                             | Some v1 ->
                                               Compilers.Coq_type.try_make_transport_cps
                                                 (fun _ x5 x6 _ ->
                                                 Compilers.Coq_base.try_make_transport_cps
                                                   (fun _ x7 x8 _ ->
                                                   Coq3_Compilers.try_make_base_transport_cps
                                                     x7 x8) x5 x6) s1
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))
                                                 (fun tro2 ->
                                                 match tro2 with
                                                 | Some v2 ->
                                                   Compilers.Coq_base.try_make_transport_cps
                                                     (fun _ x5 x6 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x5 x6)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)
                                                     (fun tr ->
                                                     match tr with
                                                     | Some v3 ->
                                                       Compilers.Coq_base.try_make_transport_cps
                                                         (fun _ x5 x6 _ ->
                                                         Coq3_Compilers.try_make_base_transport_cps
                                                           x5 x6)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)
                                                         (fun tr0 ->
                                                         match tr0 with
                                                         | Some v4 ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x5 x6 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x5 x6)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)
                                                             (fun tr1 ->
                                                             match tr1 with
                                                             | Some v5 ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)
                                                                 (fun tr2 ->
                                                                 match tr2 with
                                                                 | Some v6 ->
                                                                   Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr3 ->
                                                                    match tr3 with
                                                                    | Some v7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v8 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v3 
                                                                    (v x)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v5
                                                                    (v1 x1)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v6
                                                                    (v2
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v8
                                                                    (v7 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                 | None ->
                                                                   None)
                                                             | None -> None)
                                                         | None -> None)
                                                     | None -> None)
                                                 | None -> None)
                                             | None -> None)
                                         | None -> None)
                                     | None -> None)
                              else None
                            | None -> None))
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, _, _) -> None
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))))),
          Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
          x2))))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cast)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 max_const_val =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None (all_rewrite_rules max_const_val)

    (** val rewrite_head1 :
        z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteArith :
        z ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteArith max_const_val opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            (arith_rewrite_rulesT max_const_val);
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules max_const_val));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules max_const_val));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head max_const_val));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1 max_const_val)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) t0 e
   end
 end

module Coq14_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        bool -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules adc_no_carry_to_add0 =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 _ x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x1))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x _ t1 ->
          if t1
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))), x)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   Coq3_Compilers.Coq_ident_tt)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 t1 ->
          if t1
          then None
          else Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))), x0)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   Coq3_Compilers.Coq_ident_tt))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ ->
          if Coq_Z.eqb t0.lower t0.upper
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t0.lower))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 t1 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x t0 t1 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 _ ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x ->
          if (&&)
               ((&&)
                 (is_tighter_than_bool (ZRange.normalize t3)
                   (ZRange.opp (ZRange.normalize t2)))
                 (is_bounded_by_bool Z0 (ZRange.normalize t0)))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x ->
          if is_tighter_than_bool (ZRange.normalize t1)
               (ZRange.opp (ZRange.normalize t0))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ _ t1 t2 ->
          if (&&)
               ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (is_bounded_by_bool Z0 (ZRange.normalize t1)))
               (Coq_Z.eqb t2 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 _ _ ->
          if (&&)
               ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (is_bounded_by_bool Z0 (ZRange.normalize t1)))
               (Coq_Z.eqb t2 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x t2 t3 ->
          if (&&)
               ((&&) (is_tighter_than_bool (ZRange.normalize t1) t0)
                 (is_bounded_by_bool (Zneg XH) (ZRange.normalize t2)))
               (Coq_Z.eqb t3 (Zneg XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x ->
          if (&&)
               ((&&) (is_tighter_than_bool (ZRange.normalize t3) t0)
                 (is_bounded_by_bool (Zneg XH) (ZRange.normalize t1)))
               (Coq_Z.eqb t2 (Zneg XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x t2 t3 ->
          if (&&)
               ((&&) (is_tighter_than_bool (ZRange.normalize t1) t0)
                 (is_bounded_by_bool Z0 (ZRange.normalize t2)))
               (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x ->
          if (&&)
               ((&&) (is_tighter_than_bool (ZRange.normalize t3) t0)
                 (is_bounded_by_bool Z0 (ZRange.normalize t1)))
               (Coq_Z.eqb t2 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ _ t1 t2 ->
          if (&&)
               ((&&) (is_bounded_by_bool (Zneg XH) (ZRange.normalize t0))
                 (is_bounded_by_bool (Zneg XH) (ZRange.normalize t1)))
               (Coq_Z.eqb t2 (Zneg XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 _ _ ->
          if (&&)
               ((&&) (is_bounded_by_bool (Zneg XH) (ZRange.normalize t0))
                 (is_bounded_by_bool (Zneg XH) (ZRange.normalize t1)))
               (Coq_Z.eqb t2 (Zneg XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_leb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.leb (ZRange.normalize t0).upper
               (ZRange.normalize t1).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_leb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.ltb (ZRange.normalize t1).upper
               (ZRange.normalize t0).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_ltb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.ltb (ZRange.normalize t0).upper
               (ZRange.normalize t1).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_ltb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.leb (ZRange.normalize t1).upper
               (ZRange.normalize t0).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_geb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.leb (ZRange.normalize t1).upper
               (ZRange.normalize t0).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_geb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.ltb (ZRange.normalize t0).upper
               (ZRange.normalize t1).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_gtb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.ltb (ZRange.normalize t1).upper
               (ZRange.normalize t0).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_gtb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.leb (ZRange.normalize t0).upper
               (ZRange.normalize t1).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.ltb (ZRange.normalize t0).upper
               (ZRange.normalize t1).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic (Zpos XH)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 _ ->
          if Coq_Z.leb (ZRange.normalize t1).upper
               (ZRange.normalize t0).lower
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 t2 ->
          if (&&) (is_bounded_by_bool t2 (ZRange.normalize t1))
               (Coq_Z.ltb (ZRange.normalize t0).upper t2)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic (Zpos XH)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ t1 t2 ->
          if (&&) (is_bounded_by_bool t2 (ZRange.normalize t1))
               (Coq_Z.leb t2 (ZRange.normalize t0).lower)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 _ ->
          if (&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
               (Coq_Z.ltb t1 (ZRange.normalize t2).lower)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic (Zpos XH)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 _ ->
          if (&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
               (Coq_Z.leb (ZRange.normalize t2).upper t1)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 t1 _ ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ _ t0 t1 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x ->
          if (&&)
               ((&&)
                 ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t2))
                   (is_bounded_by_bool t1 (ZRange.normalize t0)))
                 (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                   upper = (Coq_Z.sub t1 (Zpos XH)) }))
               (Coq_Z.eqb t3 (Zpos XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x t3 t4 ->
          if (&&)
               ((&&)
                 ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t3))
                   (is_bounded_by_bool t1 (ZRange.normalize t0)))
                 (is_tighter_than_bool (ZRange.normalize t2) { lower = Z0;
                   upper = (Coq_Z.sub t1 (Zpos XH)) }))
               (Coq_Z.eqb t4 (Zpos XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 ->
          if (&&)
               ((&&)
                 ((&&) (is_tighter_than_bool (ZRange.normalize t1) t0)
                   (is_tighter_than_bool (ZRange.normalize t1) { lower = Z0;
                     upper = t3 }))
                 (is_bounded_by_bool t3 (ZRange.normalize t2)))
               (Coq_Z.eqb t3 (Coq_Z.ones (Coq_Z.succ (Coq_Z.log2 t3))))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x0 ->
          if (&&)
               ((&&)
                 ((&&) (is_tighter_than_bool (ZRange.normalize t3) t0)
                   (is_tighter_than_bool (ZRange.normalize t3) { lower = Z0;
                     upper = t2 }))
                 (is_bounded_by_bool t2 (ZRange.normalize t1)))
               (Coq_Z.eqb t2 (Coq_Z.ones (Coq_Z.succ (Coq_Z.log2 t2))))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&) adc_no_carry_to_add0
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                       (ZRange.normalize t5))) { lower = Z0; upper =
                   (Coq_Z.sub t3 (Zpos XH)) }))
               (zrange_beq t1 { lower = Z0; upper = Z0 })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 ((&&) adc_no_carry_to_add0
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.four_corners Coq_Z.add
                       (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                         (ZRange.normalize t5)) (ZRange.normalize t6)))
                   { lower = Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
               (zrange_beq t1 { lower = Z0; upper = Z0 })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&) adc_no_carry_to_add0
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.four_corners Coq_Z.sub (ZRange.normalize t4)
                       (ZRange.normalize t5))) { lower = Z0; upper =
                   (Coq_Z.sub t3 (Zpos XH)) }))
               (zrange_beq t1 { lower = Z0; upper = Z0 })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 ((&&) adc_no_carry_to_add0
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.four_corners Coq_Z.sub
                       (ZRange.four_corners Coq_Z.sub (ZRange.normalize t5)
                         (ZRange.normalize t6)) (ZRange.normalize t4)))
                   { lower = Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
               (zrange_beq t1 { lower = Z0; upper = Z0 })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
          if is_tighter_than_bool (ZRange.normalize t3)
               (ZRange.opp (ZRange.normalize t2))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 t2 t3 x2 ->
          if is_tighter_than_bool (ZRange.normalize t3)
               (ZRange.opp (ZRange.normalize t2))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 ->
          if (&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
               (Coq_Z.ltb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t2))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))))),
                   (fun v -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 t2 t3 ->
          if (&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
               (Coq_Z.ltb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t2))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))))),
                   (fun v -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 x3 ->
          if (&&)
               (is_tighter_than_bool (ZRange.normalize t5)
                 (ZRange.opp (ZRange.normalize t4)))
               (is_tighter_than_bool (ZRange.normalize t3)
                 (ZRange.opp (ZRange.normalize t2)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x4)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x3)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 t4 t5 x3 ->
          if (&&)
               (is_tighter_than_bool (ZRange.normalize t5)
                 (ZRange.opp (ZRange.normalize t4)))
               (is_tighter_than_bool (ZRange.normalize t3)
                 (ZRange.opp (ZRange.normalize t2)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x4)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x3)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 t4 t5 x1 x2 ->
          if (&&)
               ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                 (is_tighter_than_bool (ZRange.normalize t5)
                   (ZRange.opp (ZRange.normalize t4)))) (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 t4 t5 x1 x2 ->
          if (&&)
               ((&&) (Coq_Z.ltb t3 Z0)
                 (is_bounded_by_bool t3 (ZRange.normalize t2)))
               (is_tighter_than_bool (ZRange.normalize t5)
                 (ZRange.opp (ZRange.normalize t4)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t2))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 ->
          if (&&)
               ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                 (is_tighter_than_bool (ZRange.normalize t5)
                   (ZRange.opp (ZRange.normalize t4)))) (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 ->
          if (&&)
               ((&&) (Coq_Z.ltb t3 Z0)
                 (is_bounded_by_bool t3 (ZRange.normalize t2)))
               (is_tighter_than_bool (ZRange.normalize t5)
                 (ZRange.opp (ZRange.normalize t4)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t2))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 ->
          if (&&)
               ((&&) (Coq_Z.leb t5 Z0)
                 (is_bounded_by_bool t5 (ZRange.normalize t4)))
               (is_tighter_than_bool (ZRange.normalize t3)
                 (ZRange.opp (ZRange.normalize t2)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t4))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                   (fun v -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 t4 t5 ->
          if (&&)
               ((&&) (Coq_Z.leb t5 Z0)
                 (is_bounded_by_bool t5 (ZRange.normalize t4)))
               (is_tighter_than_bool (ZRange.normalize t3)
                 (ZRange.opp (ZRange.normalize t2)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t4))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                   (fun v -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 t4 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&) ((&&) (Coq_Z.leb t5 Z0) (Coq_Z.leb t3 Z0))
                   (Coq_Z.ltb (Coq_Z.add t5 t3) Z0))
                 (is_bounded_by_bool t5 (ZRange.normalize t4)))
               (is_bounded_by_bool t3 (ZRange.normalize t2))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t2))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t4))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                   (fun v -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 ->
          if (&&)
               ((&&)
                 ((&&) ((&&) (Coq_Z.leb t5 Z0) (Coq_Z.leb t3 Z0))
                   (Coq_Z.ltb (Coq_Z.add t5 t3) Z0))
                 (is_bounded_by_bool t5 (ZRange.normalize t4)))
               (is_bounded_by_bool t3 (ZRange.normalize t2))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t2))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t4))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                   (fun v -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic ZRange.opp t1))))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 ->
          if (&&)
               ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                 (is_bounded_by_bool t3 (ZRange.normalize t2)))
               (is_bounded_by_bool t5 (ZRange.normalize t4))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (fst (Obj.magic Coq1_Z.add_get_carry_full t1 t3 t5)))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (snd (Obj.magic Coq1_Z.add_get_carry_full t1 t3 t5)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x ->
          if (&&)
               ((&&)
                 ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                   (is_bounded_by_bool Z0 (ZRange.normalize t2)))
                 (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                   upper = (Coq_Z.sub t1 (Zpos XH)) })) (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x t3 t4 ->
          if (&&)
               ((&&)
                 ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                   (is_bounded_by_bool Z0 (ZRange.normalize t3)))
                 (is_tighter_than_bool (ZRange.normalize t2) { lower = Z0;
                   upper = (Coq_Z.sub t1 (Zpos XH)) })) (Coq_Z.eqb t4 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
               (Coq_Z.eqb t1 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 t7 ->
          if (&&)
               ((&&)
                 ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_bounded_by_bool t5 (ZRange.normalize t4)))
               (is_bounded_by_bool t7 (ZRange.normalize t6))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (fst
                     (Obj.magic Coq1_Z.add_with_get_carry_full t1 t3 t5 t7)))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (snd
                     (Obj.magic Coq1_Z.add_with_get_carry_full t1 t3 t5 t7)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                       (is_bounded_by_bool Z0 (ZRange.normalize t2)))
                     (is_bounded_by_bool Z0 (ZRange.normalize t4)))
                   (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                     upper = (Coq_Z.sub t1 (Zpos XH)) })) (Coq_Z.eqb t3 Z0))
               (Coq_Z.eqb t5 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                       (is_bounded_by_bool Z0 (ZRange.normalize t2)))
                     (is_bounded_by_bool Z0 (ZRange.normalize t5)))
                   (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                     upper = (Coq_Z.sub t1 (Zpos XH)) })) (Coq_Z.eqb t3 Z0))
               (Coq_Z.eqb t6 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
               (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x t5 t6 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t5))
                         (is_bounded_by_bool Z0 (ZRange.normalize t7)))
                       (is_tighter_than_bool (ZRange.normalize t4) { lower =
                         Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                     (is_bounded_by_bool Z0 (ZRange.normalize t1)))
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (Coq_Z.eqb t6 Z0)) (Coq_Z.eqb t8 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper = Z0 }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 x2 x3 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x4 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x4)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))))),
            Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x3)))))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))),
            Coq3_Compilers.Coq_ident_Z_add_with_carry)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            v))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))),
            Coq3_Compilers.Coq_ident_Z_add_get_carry)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 x2 x3 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x4 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x4)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))))),
            Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x3)))))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))),
            Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))),
            Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))), (fun v -> Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_fst
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v)))))))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Coq3_Compilers.Coq_ident_snd
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            v))))))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 ->
          if is_tighter_than_bool (ZRange.normalize t1) (ZRange.normalize t0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))
          else None)) })) :: []))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_fst,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_snd,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S O))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []))), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S O)))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S O)))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S O))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O)))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))))))))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_lor,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O)))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []))), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_carry,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S O))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S
        O)))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S
        O))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        O)))))))), (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S O)))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S O))))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_leb,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_ltb,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_geb,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_gtb,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_ltz,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S O)))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S O))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_cast2,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_mul_split,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []))), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S O)))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S O))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))))) :: []),
        (Some (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S (S O))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_opp,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S (S O))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S (S O))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S O))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])))))))))), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_bool_rect,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S O))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_mul_split,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S O)))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S O))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S O)))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add_with_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])))), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        bool -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules adc_no_carry_to_add0 =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 _ x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x0)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x1))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x _ t1 ->
            if t1
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base t0)
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0))), x)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     Coq3_Compilers.Coq_ident_tt)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ x0 t1 ->
            if t1
            then None
            else Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base t0)
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     (Compilers.Coq_type.Coq_base t0))), x0)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     Compilers.Coq_base.Coq_type.Coq_unit),
                     Coq3_Compilers.Coq_ident_tt))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ ->
            if Coq_Z.eqb t0.lower t0.upper
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t0.lower))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 t1 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x t0 t1 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 _ ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x ->
            if (&&)
                 ((&&)
                   (is_tighter_than_bool (ZRange.normalize t3)
                     (ZRange.opp (ZRange.normalize t2)))
                   (is_bounded_by_bool Z0 (ZRange.normalize t0)))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x ->
            if is_tighter_than_bool (ZRange.normalize t1)
                 (ZRange.opp (ZRange.normalize t0))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ _ t1 t2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                   (is_bounded_by_bool Z0 (ZRange.normalize t1)))
                 (Coq_Z.eqb t2 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 _ _ ->
            if (&&)
                 ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                   (is_bounded_by_bool Z0 (ZRange.normalize t1)))
                 (Coq_Z.eqb t2 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x t2 t3 ->
            if (&&)
                 ((&&) (is_tighter_than_bool (ZRange.normalize t1) t0)
                   (is_bounded_by_bool (Zneg XH) (ZRange.normalize t2)))
                 (Coq_Z.eqb t3 (Zneg XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x ->
            if (&&)
                 ((&&) (is_tighter_than_bool (ZRange.normalize t3) t0)
                   (is_bounded_by_bool (Zneg XH) (ZRange.normalize t1)))
                 (Coq_Z.eqb t2 (Zneg XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x t2 t3 ->
            if (&&)
                 ((&&) (is_tighter_than_bool (ZRange.normalize t1) t0)
                   (is_bounded_by_bool Z0 (ZRange.normalize t2)))
                 (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x ->
            if (&&)
                 ((&&) (is_tighter_than_bool (ZRange.normalize t3) t0)
                   (is_bounded_by_bool Z0 (ZRange.normalize t1)))
                 (Coq_Z.eqb t2 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ _ t1 t2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool (Zneg XH) (ZRange.normalize t0))
                   (is_bounded_by_bool (Zneg XH) (ZRange.normalize t1)))
                 (Coq_Z.eqb t2 (Zneg XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 _ _ ->
            if (&&)
                 ((&&) (is_bounded_by_bool (Zneg XH) (ZRange.normalize t0))
                   (is_bounded_by_bool (Zneg XH) (ZRange.normalize t1)))
                 (Coq_Z.eqb t2 (Zneg XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic (Zneg XH)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.leb (ZRange.normalize t0).upper
                 (ZRange.normalize t1).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.ltb (ZRange.normalize t1).upper
                 (ZRange.normalize t0).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.ltb (ZRange.normalize t0).upper
                 (ZRange.normalize t1).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.leb (ZRange.normalize t1).upper
                 (ZRange.normalize t0).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.leb (ZRange.normalize t1).upper
                 (ZRange.normalize t0).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.ltb (ZRange.normalize t0).upper
                 (ZRange.normalize t1).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.ltb (ZRange.normalize t1).upper
                 (ZRange.normalize t0).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic true))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.leb (ZRange.normalize t0).upper
                 (ZRange.normalize t1).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_bool)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_bool, (Obj.magic false))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.ltb (ZRange.normalize t0).upper
                 (ZRange.normalize t1).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic (Zpos XH)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 _ ->
            if Coq_Z.leb (ZRange.normalize t1).upper
                 (ZRange.normalize t0).lower
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 t2 ->
            if (&&) (is_bounded_by_bool t2 (ZRange.normalize t1))
                 (Coq_Z.ltb (ZRange.normalize t0).upper t2)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic (Zpos XH)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ t1 t2 ->
            if (&&) (is_bounded_by_bool t2 (ZRange.normalize t1))
                 (Coq_Z.leb t2 (ZRange.normalize t0).lower)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 _ ->
            if (&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                 (Coq_Z.ltb t1 (ZRange.normalize t2).lower)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic (Zpos XH)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 _ ->
            if (&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                 (Coq_Z.leb (ZRange.normalize t2).upper t1)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 t1 _ ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ _ t0 t1 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x ->
            if (&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t2))
                     (is_bounded_by_bool t1 (ZRange.normalize t0)))
                   (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                     upper = (Coq_Z.sub t1 (Zpos XH)) }))
                 (Coq_Z.eqb t3 (Zpos XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x t3 t4 ->
            if (&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t3))
                     (is_bounded_by_bool t1 (ZRange.normalize t0)))
                   (is_tighter_than_bool (ZRange.normalize t2) { lower = Z0;
                     upper = (Coq_Z.sub t1 (Zpos XH)) }))
                 (Coq_Z.eqb t4 (Zpos XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 ->
            if (&&)
                 ((&&)
                   ((&&) (is_tighter_than_bool (ZRange.normalize t1) t0)
                     (is_tighter_than_bool (ZRange.normalize t1) { lower =
                       Z0; upper = t3 }))
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (Coq_Z.eqb t3 (Coq_Z.ones (Coq_Z.succ (Coq_Z.log2 t3))))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x0 ->
            if (&&)
                 ((&&)
                   ((&&) (is_tighter_than_bool (ZRange.normalize t3) t0)
                     (is_tighter_than_bool (ZRange.normalize t3) { lower =
                       Z0; upper = t2 }))
                   (is_bounded_by_bool t2 (ZRange.normalize t1)))
                 (Coq_Z.eqb t2 (Coq_Z.ones (Coq_Z.succ (Coq_Z.log2 t2))))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&) adc_no_carry_to_add0
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (is_tighter_than_bool
                     (ZRange.normalize
                       (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                         (ZRange.normalize t5))) { lower = Z0; upper =
                     (Coq_Z.sub t3 (Zpos XH)) }))
                 (zrange_beq t1 { lower = Z0; upper = Z0 })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&)
                   ((&&) adc_no_carry_to_add0
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (is_tighter_than_bool
                     (ZRange.normalize
                       (ZRange.four_corners Coq_Z.add
                         (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                           (ZRange.normalize t5)) (ZRange.normalize t6)))
                     { lower = Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                 (zrange_beq t1 { lower = Z0; upper = Z0 })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&) adc_no_carry_to_add0
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (is_tighter_than_bool
                     (ZRange.normalize
                       (ZRange.four_corners Coq_Z.sub (ZRange.normalize t4)
                         (ZRange.normalize t5))) { lower = Z0; upper =
                     (Coq_Z.sub t3 (Zpos XH)) }))
                 (zrange_beq t1 { lower = Z0; upper = Z0 })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&)
                   ((&&) adc_no_carry_to_add0
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (is_tighter_than_bool
                     (ZRange.normalize
                       (ZRange.four_corners Coq_Z.sub
                         (ZRange.four_corners Coq_Z.sub (ZRange.normalize t5)
                           (ZRange.normalize t6)) (ZRange.normalize t4)))
                     { lower = Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                 (zrange_beq t1 { lower = Z0; upper = Z0 })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
            if is_tighter_than_bool (ZRange.normalize t3)
                 (ZRange.opp (ZRange.normalize t2))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 t2 t3 x2 ->
            if is_tighter_than_bool (ZRange.normalize t3)
                 (ZRange.opp (ZRange.normalize t2))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 ->
            if (&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                 (Coq_Z.ltb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))))),
                     (fun v -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 t2 t3 ->
            if (&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                 (Coq_Z.ltb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))))),
                     (fun v -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 x3 ->
            if (&&)
                 (is_tighter_than_bool (ZRange.normalize t5)
                   (ZRange.opp (ZRange.normalize t4)))
                 (is_tighter_than_bool (ZRange.normalize t3)
                   (ZRange.opp (ZRange.normalize t2)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x4))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x3)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 t4 t5 x3 ->
            if (&&)
                 (is_tighter_than_bool (ZRange.normalize t5)
                   (ZRange.opp (ZRange.normalize t4)))
                 (is_tighter_than_bool (ZRange.normalize t3)
                   (ZRange.opp (ZRange.normalize t2)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x4))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x3)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 t4 t5 x1 x2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                   (is_tighter_than_bool (ZRange.normalize t5)
                     (ZRange.opp (ZRange.normalize t4)))) (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 t4 t5 x1 x2 ->
            if (&&)
                 ((&&) (Coq_Z.ltb t3 Z0)
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_tighter_than_bool (ZRange.normalize t5)
                   (ZRange.opp (ZRange.normalize t4)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                   (is_tighter_than_bool (ZRange.normalize t5)
                     (ZRange.opp (ZRange.normalize t4)))) (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 ->
            if (&&)
                 ((&&) (Coq_Z.ltb t3 Z0)
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_tighter_than_bool (ZRange.normalize t5)
                   (ZRange.opp (ZRange.normalize t4)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 x2 ->
            if (&&)
                 ((&&) (Coq_Z.leb t5 Z0)
                   (is_bounded_by_bool t5 (ZRange.normalize t4)))
                 (is_tighter_than_bool (ZRange.normalize t3)
                   (ZRange.opp (ZRange.normalize t2)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t4))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                     (fun v -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 t4 t5 ->
            if (&&)
                 ((&&) (Coq_Z.leb t5 Z0)
                   (is_bounded_by_bool t5 (ZRange.normalize t4)))
                 (is_tighter_than_bool (ZRange.normalize t3)
                   (ZRange.opp (ZRange.normalize t2)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t3))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t4))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                     (fun v -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 t4 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&) ((&&) (Coq_Z.leb t5 Z0) (Coq_Z.leb t3 Z0))
                     (Coq_Z.ltb (Coq_Z.add t5 t3) Z0))
                   (is_bounded_by_bool t5 (ZRange.normalize t4)))
                 (is_bounded_by_bool t3 (ZRange.normalize t2))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t4))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                     (fun v -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 t4 t5 ->
            if (&&)
                 ((&&)
                   ((&&) ((&&) (Coq_Z.leb t5 Z0) (Coq_Z.leb t3 Z0))
                     (Coq_Z.ltb (Coq_Z.add t5 t3) Z0))
                   (is_bounded_by_bool t5 (ZRange.normalize t4)))
                 (is_bounded_by_bool t3 (ZRange.normalize t2))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t3))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t4))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t5))))))))))),
                     (fun v -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic ZRange.opp t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (is_bounded_by_bool t5 (ZRange.normalize t4))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (fst (Obj.magic Coq1_Z.add_get_carry_full t1 t3 t5)))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (snd (Obj.magic Coq1_Z.add_get_carry_full t1 t3 t5)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x ->
            if (&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                     (is_bounded_by_bool Z0 (ZRange.normalize t2)))
                   (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                     upper = (Coq_Z.sub t1 (Zpos XH)) })) (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x t3 t4 ->
            if (&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                     (is_bounded_by_bool Z0 (ZRange.normalize t3)))
                   (is_tighter_than_bool (ZRange.normalize t2) { lower = Z0;
                     upper = (Coq_Z.sub t1 (Zpos XH)) })) (Coq_Z.eqb t4 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t0))
                 (Coq_Z.eqb t1 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 t7 ->
            if (&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (is_bounded_by_bool t5 (ZRange.normalize t4)))
                 (is_bounded_by_bool t7 (ZRange.normalize t6))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (fst
                       (Obj.magic Coq1_Z.add_with_get_carry_full t1 t3 t5 t7)))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (snd
                       (Obj.magic Coq1_Z.add_with_get_carry_full t1 t3 t5 t7)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                         (is_bounded_by_bool Z0 (ZRange.normalize t2)))
                       (is_bounded_by_bool Z0 (ZRange.normalize t4)))
                     (is_tighter_than_bool (ZRange.normalize t6) { lower =
                       Z0; upper = (Coq_Z.sub t1 (Zpos XH)) }))
                   (Coq_Z.eqb t3 Z0)) (Coq_Z.eqb t5 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                         (is_bounded_by_bool Z0 (ZRange.normalize t2)))
                       (is_bounded_by_bool Z0 (ZRange.normalize t5)))
                     (is_tighter_than_bool (ZRange.normalize t4) { lower =
                       Z0; upper = (Coq_Z.sub t1 (Zpos XH)) }))
                   (Coq_Z.eqb t3 Z0)) (Coq_Z.eqb t6 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x t5 t6 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (is_bounded_by_bool Z0 (ZRange.normalize t5))
                           (is_bounded_by_bool Z0 (ZRange.normalize t7)))
                         (is_tighter_than_bool (ZRange.normalize t4)
                           { lower = Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                       (is_bounded_by_bool Z0 (ZRange.normalize t1)))
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (Coq_Z.eqb t6 Z0)) (Coq_Z.eqb t8 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper = Z0 }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 x2 x3 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x4)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))))),
              Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x3)))))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))),
              Coq3_Compilers.Coq_ident_Z_add_with_carry)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              v))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))),
              Coq3_Compilers.Coq_ident_Z_add_get_carry)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 x2 x3 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x4 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x4)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))))),
              Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x3)))))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))),
              Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
              (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))),
              Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2)))))), (fun v -> Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v)))))))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))))),
              (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), v))))))))))))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 ->
            if is_tighter_than_bool (ZRange.normalize t1)
                 (ZRange.normalize t0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))
            else None)) }; Primitive.snd =
          () } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } }) }

    (** val all_rewrite_rules :
        bool -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules adc_no_carry_to_add0 =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_bool))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_sub)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_lor)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_leb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_leb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_ltb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_ltb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_geb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_geb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_gtb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))),
        Coq3_Compilers.Coq_pattern_ident_Z_gtb)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_ltz)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), Coq3_Compilers.Coq_pattern_ident_Z_opp)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: [])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
        (Obj.magic pr2_rewrite_rules adc_no_carry_to_add0)

    (** val rewrite_head :
        bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head adc_no_carry_to_add0 do_again _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, x0) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t0))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH)))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t0)))
                                  (Coq3_Compilers.Coq_pattern_ident_fst
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_fst
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some v ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some v0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some _ ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b1 t0
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t0 t0
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                b1)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b1),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0))),
          (Coq3_Compilers.Coq_ident_fst (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x0) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, _) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t1))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t1)))
                                  (Coq3_Compilers.Coq_pattern_ident_snd
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_snd
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some _ ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b0 t1
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t1 t1
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                b0)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b0),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1))),
          (Coq3_Compilers.Coq_ident_snd (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x1 with
             | Compilers.Coq_expr.Ident (t1, idc0) ->
               sequence
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x2 y ->
                           match x2 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool))))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base t0))))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))) with
                   | Some vars0 ->
                     let (a, _) = Obj.magic vars0 in
                     let (a0, b) = a in
                     let (a1, b0) = a0 in
                     let (a2, b1) = a1 in
                     let (_, _) = a2 in
                     let (a3, b2) = b1 in
                     let (_, _) = a3 in
                     let (_, _) = b2 in
                     let (_, _) = b0 in
                     let (_, b3) = b in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                            match x2 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base b3))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool))))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base t0))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x2, _) = args0.Coq_Primitive.projT1 in x2)))))
                     then bind1
                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))))))) (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base t0)))))))
                              (Coq3_Compilers.Coq_pattern_ident_bool_rect
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)) (Coq3_Compilers.Coq_ident_bool_rect t0))
                            (fun _ ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x2 x3 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x2 x3)
                              Compilers.Coq_base.Coq_type.Coq_unit
                              Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                              match a4 with
                              | Some x' ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x2 x3 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x2 x3) t0 b3 (fun a5 ->
                                  match a5 with
                                  | Some x'0 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x2 x3 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x2 x3)
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      (fun a6 ->
                                      match a6 with
                                      | Some _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3) t0 b3 (fun a7 ->
                                          match a7 with
                                          | Some _ ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_bool))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Coq_bool)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                (fun a8 ->
                                                match a8 with
                                                | Some x'1 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3) b3 b3 (fun a9 ->
                                                    match a9 with
                                                    | Some x'2 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        (fun a10 ->
                                                        match a10 with
                                                        | Some _ ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3) b3 b3
                                                            (fun a11 ->
                                                            match a11 with
                                                            | Some _ ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x2 x3 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x2 x3) b3
                                                                t0 (fun tr ->
                                                                match tr with
                                                                | Some v ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t0
                                                                    t0
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))),
                                                                    (Obj.magic
                                                                    x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    Coq3_Compilers.Coq_ident_tt)))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                | None -> None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None))
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t1 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x2 y ->
                           match x2 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                           XH)))))), (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool))))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_bool)),
                           (Compilers.Coq_type.Coq_base t0))))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           Compilers.Coq_base.Coq_type.Coq_unit),
                           (Compilers.Coq_type.Coq_base t0))))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x2, _) = args0.Coq_Primitive.projT1 in x2))))) with
                   | Some vars0 ->
                     let (a, _) = Obj.magic vars0 in
                     let (a0, b) = a in
                     let (a1, b0) = a0 in
                     let (a2, b1) = a1 in
                     let (_, _) = a2 in
                     let (a3, b2) = b1 in
                     let (_, _) = a3 in
                     let (_, _) = b2 in
                     let (_, _) = b0 in
                     let (_, b3) = b in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                            match x2 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base b3))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base b3))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool))))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_bool)),
                          (Compilers.Coq_type.Coq_base t0))))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          Compilers.Coq_base.Coq_type.Coq_unit),
                          (Compilers.Coq_type.Coq_base t0))))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x2, _) = args0.Coq_Primitive.projT1 in x2)))))
                     then bind1
                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)))))))) (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              Compilers.Coq_base.Coq_type.Coq_unit),
                              (Compilers.Coq_type.Coq_base t0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_bool)),
                              (Compilers.Coq_type.Coq_base t0)))))))
                              (Coq3_Compilers.Coq_pattern_ident_bool_rect
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                              XH)) (Coq3_Compilers.Coq_ident_bool_rect t0))
                            (fun _ ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x2 x3 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x2 x3)
                              Compilers.Coq_base.Coq_type.Coq_unit
                              Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                              match a4 with
                              | Some _ ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x2 x3 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x2 x3) t0 b3 (fun a5 ->
                                  match a5 with
                                  | Some _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x2 x3 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x2 x3)
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      Compilers.Coq_base.Coq_type.Coq_unit
                                      (fun a6 ->
                                      match a6 with
                                      | Some x' ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3) t0 b3 (fun a7 ->
                                          match a7 with
                                          | Some x'0 ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_bool))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x2, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x2)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Coq_bool)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x2, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x2),
                                                (let (x2, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x2)))) (fun xv ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                Compilers.Coq_base.Coq_type.Coq_unit
                                                (fun a8 ->
                                                match a8 with
                                                | Some _ ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x2 x3 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x2 x3) b3 b3 (fun a9 ->
                                                    match a9 with
                                                    | Some _ ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x2 x3 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x2 x3)
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        Compilers.Coq_base.Coq_type.Coq_unit
                                                        (fun a10 ->
                                                        match a10 with
                                                        | Some x'1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x2 x3 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x2 x3) b3 b3
                                                            (fun a11 ->
                                                            match a11 with
                                                            | Some x'2 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x2 x3 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x2 x3) b3
                                                                t0 (fun tr ->
                                                                match tr with
                                                                | Some v ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t0
                                                                    t0
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    let (
                                                                    x2, _) =
                                                                    xv
                                                                    in
                                                                    x2
                                                                    then None
                                                                    else 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))),
                                                                    (Obj.magic
                                                                    x'2
                                                                    (x'1
                                                                    (x'0
                                                                    (x' x0)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    Coq3_Compilers.Coq_ident_tt))))))
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                | None -> None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None))
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))))),
          (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1))))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
            x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (sequence
              (match x with
               | Compilers.Coq_expr.Ident (_, _) -> None
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, f, x1) ->
                 (match f with
                  | Compilers.Coq_expr.Ident (_, _) -> None
                  | Compilers.Coq_expr.Var (_, _) -> None
                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                  | Compilers.Coq_expr.App (_, _, f0, x2) ->
                    (match f0 with
                     | Compilers.Coq_expr.Ident (t0, idc0) ->
                       (match x2 with
                        | Compilers.Coq_expr.Ident (t1, idc1) ->
                          (match x1 with
                           | Compilers.Coq_expr.Ident (t2, idc2) ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t2 idc2
                                 Coq3_Compilers.Coq_raw_ident_Literal)
                               (fun args0 ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t1 idc1
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args1 ->
                                 bind1
                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Z_cast)
                                   (fun _ ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x3 y ->
                                           match x3 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_zrange)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args1.Coq_Primitive.projT1
                                            in
                                            x3))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x3))))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)))) with
                                   | Some vars0 ->
                                     let (a, _) = Obj.magic vars0 in
                                     let (_, _) = a in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x3 y ->
                                            match x3 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Coq_zrange)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x3, _) =
                                             args1.Coq_Primitive.projT1
                                           in
                                           x3))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x3, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x3))))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                     then bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_zrange))
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x3, _) =
                                                 args1.Coq_Primitive.projT1
                                               in
                                               x3)))
                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                              Coq3_Compilers.Coq_zrange)
                                              (Coq3_Compilers.Coq_ident_Literal
                                              ((let (x3, _) =
                                                  args1.Coq_Primitive.projT1
                                                in
                                                x3),
                                              (let (x3, _) =
                                                 let (_, y) =
                                                   args1.Coq_Primitive.projT2
                                                 in
                                                 y
                                               in
                                               x3)))) (fun xv ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x3, _) =
                                                   args0.Coq_Primitive.projT1
                                                 in
                                                 x3)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Z)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x3, _) =
                                                    args0.Coq_Primitive.projT1
                                                  in
                                                  x3),
                                                (let (x3, _) =
                                                   let (_, y) =
                                                     args0.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x3)))) (fun xv0 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x3 x4 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x3 x4)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tro ->
                                                match tro with
                                                | Some v ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x3 x4 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x3 x4)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v2 ->
                                                              bind1
                                                                (if (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3) Z0)
                                                                 then 
                                                                   Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0
                                                                    (v x0)))))
                                                                 else None)
                                                                (fun fv ->
                                                                Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  fv
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2
                                                                    (v1 fv0)))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)))
                                     else None
                                   | None -> None)))
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (_, _, _, _) -> None
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (match x0 with
               | Compilers.Coq_expr.Ident (_, _) -> None
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, f, x1) ->
                 (match f with
                  | Compilers.Coq_expr.Ident (_, _) -> None
                  | Compilers.Coq_expr.Var (_, _) -> None
                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                  | Compilers.Coq_expr.App (_, _, f0, x2) ->
                    (match f0 with
                     | Compilers.Coq_expr.Ident (t0, idc0) ->
                       (match x2 with
                        | Compilers.Coq_expr.Ident (t1, idc1) ->
                          (match x1 with
                           | Compilers.Coq_expr.Ident (t2, idc2) ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t2 idc2
                                 Coq3_Compilers.Coq_raw_ident_Literal)
                               (fun args0 ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t1 idc1
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args1 ->
                                 bind1
                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Z_cast)
                                   (fun _ ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x3 y ->
                                           match x3 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_zrange)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args1.Coq_Primitive.projT1
                                            in
                                            x3))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x3))))))) with
                                   | Some vars0 ->
                                     let (_, b) = Obj.magic vars0 in
                                     let (_, _) = b in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x3 y ->
                                            match x3 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Coq_zrange)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x3, _) =
                                             args1.Coq_Primitive.projT1
                                           in
                                           x3))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x3, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x3)))))))
                                     then Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x3 x4 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x3 x4)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tro ->
                                            match tro with
                                            | Some v ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x3, _) =
                                                     args1.Coq_Primitive.projT1
                                                   in
                                                   x3)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Coq_zrange)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x3, _) =
                                                      args1.Coq_Primitive.projT1
                                                    in
                                                    x3),
                                                  (let (x3, _) =
                                                     let (_, y) =
                                                       args1.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x3)))) (fun xv ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x3, _) =
                                                       args0.Coq_Primitive.projT1
                                                     in
                                                     x3)))
                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                    Coq3_Compilers.Z)
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    ((let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3),
                                                    (let (x3, _) =
                                                       let (_, y) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       y
                                                     in
                                                     x3)))) (fun xv0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x3 x4 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x3 x4)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v2 ->
                                                              bind1
                                                                (if (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3) Z0)
                                                                 then 
                                                                   Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0 
                                                                    (v x)))))
                                                                 else None)
                                                                (fun fv ->
                                                                Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  fv
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2
                                                                    (v1 fv0)))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)))
                                            | None -> None)
                                     else None
                                   | None -> None)))
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (_, _, _, _) -> None
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_add)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (sequence
              (match x0 with
               | Compilers.Coq_expr.Ident (_, _) -> None
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, f, x1) ->
                 (match f with
                  | Compilers.Coq_expr.Ident (_, _) -> None
                  | Compilers.Coq_expr.Var (_, _) -> None
                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                  | Compilers.Coq_expr.App (_, _, f0, x2) ->
                    (match f0 with
                     | Compilers.Coq_expr.Ident (t0, idc0) ->
                       (match x2 with
                        | Compilers.Coq_expr.Ident (t1, idc1) ->
                          (match x1 with
                           | Compilers.Coq_expr.Ident (t2, idc2) ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t2 idc2
                                 Coq3_Compilers.Coq_raw_ident_Literal)
                               (fun args0 ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t1 idc1
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args1 ->
                                 bind1
                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Z_cast)
                                   (fun _ ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x3 y ->
                                           match x3 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_zrange)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args1.Coq_Primitive.projT1
                                            in
                                            x3))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x3, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x3))))))) with
                                   | Some vars0 ->
                                     let (_, b) = Obj.magic vars0 in
                                     let (_, _) = b in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x3 y ->
                                            match x3 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Coq_zrange)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x3, _) =
                                             args1.Coq_Primitive.projT1
                                           in
                                           x3))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x3, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x3)))))))
                                     then Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x3 x4 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x3 x4)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tro ->
                                            match tro with
                                            | Some v ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x3, _) =
                                                     args1.Coq_Primitive.projT1
                                                   in
                                                   x3)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Coq_zrange)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x3, _) =
                                                      args1.Coq_Primitive.projT1
                                                    in
                                                    x3),
                                                  (let (x3, _) =
                                                     let (_, y) =
                                                       args1.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x3)))) (fun xv ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x3, _) =
                                                       args0.Coq_Primitive.projT1
                                                     in
                                                     x3)))
                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                    Coq3_Compilers.Z)
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    ((let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3),
                                                    (let (x3, _) =
                                                       let (_, y) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       y
                                                     in
                                                     x3)))) (fun xv0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x3 x4 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x3 x4)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v0 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v1 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr' ->
                                                            match tr' with
                                                            | Some v2 ->
                                                              bind1
                                                                (if (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3) Z0)
                                                                 then 
                                                                   Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0 
                                                                    (v x)))))
                                                                 else None)
                                                                (fun fv ->
                                                                Some
                                                                (Coq_Compilers.UnderLets.splice
                                                                  fv
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2
                                                                    (v1 fv0)))))
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)))
                                            | None -> None)
                                     else None
                                   | None -> None)))
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (_, _, _, _) -> None
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (match x with
               | Compilers.Coq_expr.Ident (_, _) -> None
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, f, x1) ->
                 (match f with
                  | Compilers.Coq_expr.Ident (_, _) -> None
                  | Compilers.Coq_expr.Var (_, _) -> None
                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                  | Compilers.Coq_expr.App (_, _, f0, x2) ->
                    (match f0 with
                     | Compilers.Coq_expr.Ident (t0, idc0) ->
                       (match x2 with
                        | Compilers.Coq_expr.Ident (t1, idc1) ->
                          (match x1 with
                           | Compilers.Coq_expr.Ident (t2, idc2) ->
                             sequence
                               (bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t2 idc2
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t1 idc1
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args1 ->
                                   bind1
                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                       t0 idc0
                                       Coq3_Compilers.Coq_raw_ident_Z_cast)
                                     (fun _ ->
                                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                             (fun x3 y ->
                                             match x3 with
                                             | Coq3_Compilers.Z ->
                                               (match y with
                                                | Coq3_Compilers.Z -> true
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_bool ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  true
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_nat ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_zrange ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_string ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  true))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Coq_zrange)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)))),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x3, _) =
                                                args1.Coq_Primitive.projT1
                                              in
                                              x3))),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x3, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x3))))),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)))) with
                                     | Some vars0 ->
                                       let (a, _) = Obj.magic vars0 in
                                       let (_, _) = a in
                                       if Compilers.Coq_type.type_beq
                                            (Compilers.Coq_base.Coq_type.type_beq
                                              (fun x3 y ->
                                              match x3 with
                                              | Coq3_Compilers.Z ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> true
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_bool ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   true
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_nat ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   true
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_zrange ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   true
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_string ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   true)))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_zrange)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x3, _) =
                                               args1.Coq_Primitive.projT1
                                             in
                                             x3))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x3, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x3))))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))
                                       then bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_zrange))
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                (let (x3, _) =
                                                   args1.Coq_Primitive.projT1
                                                 in
                                                 x3)))
                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                Coq3_Compilers.Coq_zrange)
                                                (Coq3_Compilers.Coq_ident_Literal
                                                ((let (x3, _) =
                                                    args1.Coq_Primitive.projT1
                                                  in
                                                  x3),
                                                (let (x3, _) =
                                                   let (_, y) =
                                                     args1.Coq_Primitive.projT2
                                                   in
                                                   y
                                                 in
                                                 x3)))) (fun xv ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x3, _) =
                                                     args0.Coq_Primitive.projT1
                                                   in
                                                   x3)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Z)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x3, _) =
                                                      args0.Coq_Primitive.projT1
                                                    in
                                                    x3),
                                                  (let (x3, _) =
                                                     let (_, y) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x3)))) (fun xv0 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x3 x4 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x3 x4)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tro ->
                                                  match tro with
                                                  | Some v ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x3 x4 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x3 x4)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr ->
                                                      match tr with
                                                      | Some v0 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x3 x4 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x3 x4)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr0 ->
                                                          match tr0 with
                                                          | Some v1 ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x3 x4 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x3 x4)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (fun tr' ->
                                                              match tr' with
                                                              | Some v2 ->
                                                                bind1
                                                                  (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3) Z0)
                                                                   then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v0
                                                                    (v x0)))))))
                                                                   else None)
                                                                  (fun fv ->
                                                                  Some
                                                                  (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                              | None -> None)
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)))
                                       else None
                                     | None -> None))))
                               (match x0 with
                                | Compilers.Coq_expr.Ident (_, _) -> None
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, f1, x3) ->
                                  (match f1 with
                                   | Compilers.Coq_expr.Ident (_, _) -> None
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                     (match f2 with
                                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                                        (match x4 with
                                         | Compilers.Coq_expr.Ident (
                                             t4, idc4) ->
                                           (match x3 with
                                            | Compilers.Coq_expr.Ident (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                _, _, f3, x5) ->
                                              (match f3 with
                                               | Compilers.Coq_expr.Ident (
                                                   t5, idc5) ->
                                                 (match x5 with
                                                  | Compilers.Coq_expr.Ident (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      s0, _, f4, x6) ->
                                                    (match f4 with
                                                     | Compilers.Coq_expr.Ident (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, f5, x7) ->
                                                       (match f5 with
                                                        | Compilers.Coq_expr.Ident (
                                                            t6, idc6) ->
                                                          (match x7 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t7, idc7) ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t7 idc7
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args0 ->
                                                               bind1
                                                                 (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t6 idc6
                                                                   Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                 (fun _ ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s0)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s0))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8))))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x6))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                         | Compilers.Coq_expr.Var (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Abs (_, _, _) ->
                                           None
                                         | Compilers.Coq_expr.App (_, _, _, _) ->
                                           None
                                         | Compilers.Coq_expr.LetIn (
                                             _, _, _, _) ->
                                           None)
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (_, _, _, _) -> None
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_sub)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (_, _) -> None
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, f, x0) ->
             (match f with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, f0, x1) ->
                (match f0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   (match x1 with
                    | Compilers.Coq_expr.Ident (t1, idc1) ->
                      (match x0 with
                       | Compilers.Coq_expr.Ident (_, _) -> None
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, f1, x2) ->
                         (match f1 with
                          | Compilers.Coq_expr.Ident (t2, idc2) ->
                            (match x2 with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (s0, _, f2, x3) ->
                               (match f2 with
                                | Compilers.Coq_expr.Ident (_, _) -> None
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, f3, x4) ->
                                  (match f3 with
                                   | Compilers.Coq_expr.Ident (t3, idc3) ->
                                     (match x4 with
                                      | Compilers.Coq_expr.Ident (t4, idc4) ->
                                        bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t4 idc4
                                            Coq3_Compilers.Coq_raw_ident_Literal)
                                          (fun args0 ->
                                          bind1
                                            (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t3 idc3
                                              Coq3_Compilers.Coq_raw_ident_Z_cast)
                                            (fun _ ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t2 idc2
                                                Coq3_Compilers.Coq_raw_ident_Z_opp)
                                              (fun _ ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                  t1 idc1
                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                (fun args1 ->
                                                bind1
                                                  (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                    t0 idc0
                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                  (fun _ ->
                                                  match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                          (fun x5 y ->
                                                          match x5 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true))
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))))))
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          (let (x5, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x5))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          (let (x5, _) =
                                                             args0.Coq_Primitive.projT1
                                                           in
                                                           x5))), s0)))) with
                                                  | Some vars0 ->
                                                    let (_, b) =
                                                      Obj.magic vars0
                                                    in
                                                    let (_, _) = b in
                                                    if Compilers.Coq_type.type_beq
                                                         (Compilers.Coq_base.Coq_type.type_beq
                                                           (fun x5 y ->
                                                           match x5 with
                                                           | Coq3_Compilers.Z ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                true
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_bool ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                true
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_nat ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                true
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                true
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_string ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                true)))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x5, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x5))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x5, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x5))), s0))))
                                                    then bind1
                                                           (Obj.magic
                                                             Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange))
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x5, _) =
                                                                args1.Coq_Primitive.projT1
                                                              in
                                                              x5)))
                                                             (Coq3_Compilers.Coq_pattern_ident_Literal
                                                             Coq3_Compilers.Coq_zrange)
                                                             (Coq3_Compilers.Coq_ident_Literal
                                                             ((let (x5, _) =
                                                                 args1.Coq_Primitive.projT1
                                                               in
                                                               x5),
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  args1.Coq_Primitive.projT2
                                                                in
                                                                y
                                                              in
                                                              x5))))
                                                           (fun xv ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x5, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x5)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x5),
                                                               (let (
                                                                  x5, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x5))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x5 x6 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x7 x8 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x7 x8) x5
                                                                 x6) s0
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro ->
                                                               match tro with
                                                               | Some v ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x5 x6 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None)))
                                                    else None
                                                  | None -> None)))))
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, _, _) ->
                                     None
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (_, _, _, _) -> None
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_Z_opp)), x))))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (s1, _, f1, _) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x2) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    sequence
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.leb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    true))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.ltb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    false))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (s1, _, f1, _) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x2) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    sequence
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.ltb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    true))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.leb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    false))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (s1, _, f1, _) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x2) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    sequence
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.leb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    true))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.ltb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    false))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x1) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x1 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (s1, _, f1, _) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x2) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    sequence
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.ltb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    true))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x3 y ->
                                                      match x3 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x3))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x3, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x3))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x3 y ->
                                                       match x3 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x3))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x3, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x3)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x3, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x3),
                                                         (let (x3, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x3)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x3 x4 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x5 x6) x3 x4) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x3, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x3)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x3, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x3),
                                                               (let (
                                                                  x3, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x3))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x3 x4 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x5 x6) x3
                                                                 x4) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x3 x4 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.leb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_bool,
                                                                    (Obj.magic
                                                                    false))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)),
          x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x1) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x2) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x1 with
                         | Compilers.Coq_expr.Ident (t2, idc2) ->
                           bind1
                             (Obj.magic
                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                               t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                             (fun args0 ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t1 idc1
                                 Coq3_Compilers.Coq_raw_ident_Literal)
                               (fun args1 ->
                               bind1
                                 (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t0 idc0
                                   Coq3_Compilers.Coq_raw_ident_Z_cast)
                                 (fun _ ->
                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                         (fun x3 y ->
                                         match x3 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Coq_zrange)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)))),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x3, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x3))), (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x3, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x3))))),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)))) with
                                 | Some vars0 ->
                                   let (a, _) = Obj.magic vars0 in
                                   let (_, _) = a in
                                   if Compilers.Coq_type.type_beq
                                        (Compilers.Coq_base.Coq_type.type_beq
                                          (fun x3 y ->
                                          match x3 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true)))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_zrange)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x3))), (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x3))))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))
                                   then bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_zrange))
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x3, _) =
                                               args1.Coq_Primitive.projT1
                                             in
                                             x3)))
                                            (Coq3_Compilers.Coq_pattern_ident_Literal
                                            Coq3_Compilers.Coq_zrange)
                                            (Coq3_Compilers.Coq_ident_Literal
                                            ((let (x3, _) =
                                                args1.Coq_Primitive.projT1
                                              in
                                              x3),
                                            (let (x3, _) =
                                               let (_, y) =
                                                 args1.Coq_Primitive.projT2
                                               in
                                               y
                                             in
                                             x3)))) (fun xv ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x3, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x3)))
                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                              Coq3_Compilers.Z)
                                              (Coq3_Compilers.Coq_ident_Literal
                                              ((let (x3, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x3),
                                              (let (x3, _) =
                                                 let (_, y) =
                                                   args0.Coq_Primitive.projT2
                                                 in
                                                 y
                                               in
                                               x3)))) (fun xv0 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x3 x4 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x3 x4)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tro ->
                                              match tro with
                                              | Some _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x3 x4 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x3 x4)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr ->
                                                  match tr with
                                                  | Some _ ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x3 x4 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x3 x4)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr0 ->
                                                      match tr0 with
                                                      | Some v ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x3 x4 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x3 x4)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v0 ->
                                                            bind1
                                                              (if (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3) Z0)
                                                               then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))
                                                               else None)
                                                              (fun fv -> Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                fv
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v0 (v fv0)))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None)))
                                   else None
                                 | None -> None)))
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, _, _) -> None
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (sequence
              (match x0 with
               | Compilers.Coq_expr.Ident (_, _) -> None
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (_, _, f, x2) ->
                 (match f with
                  | Compilers.Coq_expr.Ident (_, _) -> None
                  | Compilers.Coq_expr.Var (_, _) -> None
                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                  | Compilers.Coq_expr.App (_, _, f0, x3) ->
                    (match f0 with
                     | Compilers.Coq_expr.Ident (t0, idc0) ->
                       (match x3 with
                        | Compilers.Coq_expr.Ident (t1, idc1) ->
                          (match x2 with
                           | Compilers.Coq_expr.Ident (t2, idc2) ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t2 idc2
                                 Coq3_Compilers.Coq_raw_ident_Literal)
                               (fun args0 ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t1 idc1
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args1 ->
                                 bind1
                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t0 idc0
                                     Coq3_Compilers.Coq_raw_ident_Z_cast)
                                   (fun _ ->
                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                           (fun x4 y ->
                                           match x4 with
                                           | Coq3_Compilers.Z ->
                                             (match y with
                                              | Coq3_Compilers.Z -> true
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_bool ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                true
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_nat ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                true
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_zrange ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                true
                                              | Coq3_Compilers.Coq_string ->
                                                false)
                                           | Coq3_Compilers.Coq_string ->
                                             (match y with
                                              | Coq3_Compilers.Z -> false
                                              | Coq3_Compilers.Coq_bool ->
                                                false
                                              | Coq3_Compilers.Coq_nat ->
                                                false
                                              | Coq3_Compilers.Coq_zrange ->
                                                false
                                              | Coq3_Compilers.Coq_string ->
                                                true))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_zrange)),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)))))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z))))
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)),
                                           (Compilers.Coq_type.Coq_arrow
                                           ((Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x4, _) =
                                              args1.Coq_Primitive.projT1
                                            in
                                            x4))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           (let (x4, _) =
                                              args0.Coq_Primitive.projT1
                                            in
                                            x4))))))),
                                           (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Z)))) with
                                   | Some vars0 ->
                                     let (a, _) = Obj.magic vars0 in
                                     let (_, b) = a in
                                     let (_, _) = b in
                                     if Compilers.Coq_type.type_beq
                                          (Compilers.Coq_base.Coq_type.type_beq
                                            (fun x4 y ->
                                            match x4 with
                                            | Coq3_Compilers.Z ->
                                              (match y with
                                               | Coq3_Compilers.Z -> true
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_bool ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 true
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_nat ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 true
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_zrange ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 true
                                               | Coq3_Compilers.Coq_string ->
                                                 false)
                                            | Coq3_Compilers.Coq_string ->
                                              (match y with
                                               | Coq3_Compilers.Z -> false
                                               | Coq3_Compilers.Coq_bool ->
                                                 false
                                               | Coq3_Compilers.Coq_nat ->
                                                 false
                                               | Coq3_Compilers.Coq_zrange ->
                                                 false
                                               | Coq3_Compilers.Coq_string ->
                                                 true)))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Coq_zrange)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x4, _) =
                                             args1.Coq_Primitive.projT1
                                           in
                                           x4))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x4, _) =
                                             args0.Coq_Primitive.projT1
                                           in
                                           x4))))))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))
                                     then Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x4 x5)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tro ->
                                            match tro with
                                            | Some _ ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x4, _) =
                                                     args1.Coq_Primitive.projT1
                                                   in
                                                   x4)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Coq_zrange)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x4, _) =
                                                      args1.Coq_Primitive.projT1
                                                    in
                                                    x4),
                                                  (let (x4, _) =
                                                     let (_, y) =
                                                       args1.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x4)))) (fun xv ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x4, _) =
                                                       args0.Coq_Primitive.projT1
                                                     in
                                                     x4)))
                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                    Coq3_Compilers.Z)
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    ((let (x4, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x4),
                                                    (let (x4, _) =
                                                       let (_, y) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       y
                                                     in
                                                     x4)))) (fun xv0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x4 x5 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x4 x5)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tro0 ->
                                                    match tro0 with
                                                    | Some _ ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x4 x5 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x4 x5)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr ->
                                                        match tr with
                                                        | Some _ ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x4 x5 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x4 x5)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr0 ->
                                                            match tr0 with
                                                            | Some _ ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x4 x5 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x4 x5)
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z),
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))
                                                                (fun tr1 ->
                                                                match tr1 with
                                                                | Some v ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)))
                                            | None -> None)
                                     else None
                                   | None -> None)))
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (_, _, _, _) -> None
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              (match x1 with
               | Compilers.Coq_expr.Ident (_, _) -> None
               | Compilers.Coq_expr.Var (_, _) -> None
               | Compilers.Coq_expr.Abs (_, _, _) -> None
               | Compilers.Coq_expr.App (s0, _, f, x2) ->
                 (match f with
                  | Compilers.Coq_expr.Ident (_, _) -> None
                  | Compilers.Coq_expr.Var (_, _) -> None
                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                  | Compilers.Coq_expr.App (_, _, f0, x3) ->
                    (match f0 with
                     | Compilers.Coq_expr.Ident (t0, idc0) ->
                       (match x3 with
                        | Compilers.Coq_expr.Ident (t1, idc1) ->
                          sequence
                            (match x2 with
                             | Compilers.Coq_expr.Ident (t2, idc2) ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t2 idc2
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t1 idc1
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args1 ->
                                   bind1
                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                       t0 idc0
                                       Coq3_Compilers.Coq_raw_ident_Z_cast)
                                     (fun _ ->
                                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                             (fun x4 y ->
                                             match x4 with
                                             | Coq3_Compilers.Z ->
                                               (match y with
                                                | Coq3_Compilers.Z -> true
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_bool ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  true
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_nat ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_zrange ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_string ->
                                                  false)
                                             | Coq3_Compilers.Coq_string ->
                                               (match y with
                                                | Coq3_Compilers.Z -> false
                                                | Coq3_Compilers.Coq_bool ->
                                                  false
                                                | Coq3_Compilers.Coq_nat ->
                                                  false
                                                | Coq3_Compilers.Coq_zrange ->
                                                  false
                                                | Coq3_Compilers.Coq_string ->
                                                  true))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)))),
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Coq_zrange)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z))))))
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             Coq3_Compilers.Z)))),
                                             (Compilers.Coq_type.Coq_arrow
                                             ((Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x4, _) =
                                                args1.Coq_Primitive.projT1
                                              in
                                              x4))),
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                             (let (x4, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x4))))))) with
                                     | Some vars0 ->
                                       let (a, b) = Obj.magic vars0 in
                                       let (_, _) = a in
                                       let (_, _) = b in
                                       if Compilers.Coq_type.type_beq
                                            (Compilers.Coq_base.Coq_type.type_beq
                                              (fun x4 y ->
                                              match x4 with
                                              | Coq3_Compilers.Z ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> true
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_bool ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   true
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_nat ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   true
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_zrange ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   true
                                                 | Coq3_Compilers.Coq_string ->
                                                   false)
                                              | Coq3_Compilers.Coq_string ->
                                                (match y with
                                                 | Coq3_Compilers.Z -> false
                                                 | Coq3_Compilers.Coq_bool ->
                                                   false
                                                 | Coq3_Compilers.Coq_nat ->
                                                   false
                                                 | Coq3_Compilers.Coq_zrange ->
                                                   false
                                                 | Coq3_Compilers.Coq_string ->
                                                   true)))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_zrange)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))))
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x4, _) =
                                               args1.Coq_Primitive.projT1
                                             in
                                             x4))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x4, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x4)))))))
                                       then Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x4 x5 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x4 x5)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z) (fun tro ->
                                              match tro with
                                              | Some _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x4 x5 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x4 x5)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tro0 ->
                                                  match tro0 with
                                                  | Some _ ->
                                                    bind1
                                                      (Obj.magic
                                                        Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange))
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x4, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x4)))
                                                        (Coq3_Compilers.Coq_pattern_ident_Literal
                                                        Coq3_Compilers.Coq_zrange)
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        ((let (x4, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x4),
                                                        (let (x4, _) =
                                                           let (_, y) =
                                                             args1.Coq_Primitive.projT2
                                                           in
                                                           y
                                                         in
                                                         x4)))) (fun xv ->
                                                      bind1
                                                        (Obj.magic
                                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          (let (x4, _) =
                                                             args0.Coq_Primitive.projT1
                                                           in
                                                           x4)))
                                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                                          Coq3_Compilers.Z)
                                                          (Coq3_Compilers.Coq_ident_Literal
                                                          ((let (x4, _) =
                                                              args0.Coq_Primitive.projT1
                                                            in
                                                            x4),
                                                          (let (x4, _) =
                                                             let (_, y) =
                                                               args0.Coq_Primitive.projT2
                                                             in
                                                             y
                                                           in
                                                           x4)))) (fun xv0 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x4 x5 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x4 x5)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr ->
                                                          match tr with
                                                          | Some _ ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x4 x5 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x4 x5)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)
                                                              (fun tr0 ->
                                                              match tr0 with
                                                              | Some _ ->
                                                                Compilers.Coq_base.try_make_transport_cps
                                                                  (fun _ x4 x5 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                  (Compilers.Coq_base.Coq_type.Coq_prod
                                                                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z),
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))
                                                                  (Compilers.Coq_base.Coq_type.Coq_prod
                                                                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z),
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))
                                                                  (fun tr1 ->
                                                                  match tr1 with
                                                                  | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                  | None ->
                                                                    None)
                                                              | None -> None)
                                                          | None -> None)))
                                                  | None -> None)
                                              | None -> None)
                                       else None
                                     | None -> None)))
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, _, _) -> None
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                            (match x with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, f1, x4) ->
                               (match f1 with
                                | Compilers.Coq_expr.Ident (_, _) -> None
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, f2, x5) ->
                                  (match f2 with
                                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                                     (match x5 with
                                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                                        (match x4 with
                                         | Compilers.Coq_expr.Ident (
                                             t4, idc4) ->
                                           (match x0 with
                                            | Compilers.Coq_expr.Ident (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                s1, _, f3, x6) ->
                                              (match f3 with
                                               | Compilers.Coq_expr.Ident (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, f4, x7) ->
                                                 (match f4 with
                                                  | Compilers.Coq_expr.Ident (
                                                      t5, idc5) ->
                                                    (match x7 with
                                                     | Compilers.Coq_expr.Ident (
                                                         t6, idc6) ->
                                                       sequence
                                                         (match x6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              t7, idc7) ->
                                                            bind1
                                                              (Obj.magic
                                                                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                t7 idc7
                                                                Coq3_Compilers.Coq_raw_ident_Literal)
                                                              (fun args0 ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                  t6 idc6
                                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                                (fun args1 ->
                                                                bind1
                                                                  (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                  (fun _ ->
                                                                  bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (Zpos XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    x8))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8) (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8) (Zpos
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x2))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                         (match x2 with
                                                          | Compilers.Coq_expr.Ident (
                                                              t7, idc7) ->
                                                            bind1
                                                              (Obj.magic
                                                                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                t7 idc7
                                                                Coq3_Compilers.Coq_raw_ident_Literal)
                                                              (fun args0 ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                  t6 idc6
                                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                                (fun args1 ->
                                                                bind1
                                                                  (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                  (fun _ ->
                                                                  bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (Zpos XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8) (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    x8) (Zpos
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                         | Compilers.Coq_expr.Var (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Abs (_, _, _) ->
                                           None
                                         | Compilers.Coq_expr.App (_, _, _, _) ->
                                           None
                                         | Compilers.Coq_expr.LetIn (
                                             _, _, _, _) ->
                                           None)
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, _, _) ->
                                     None
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (_, _, _, _) -> None
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (_, _, _, _) -> None
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
          x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x2) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x3) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x3 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x2 with
                         | Compilers.Coq_expr.Ident (t2, idc2) ->
                           (match x0 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (s0, _, f1, x4) ->
                              (match f1 with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, f2, x5) ->
                                 (match f2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x5 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       sequence
                                         (match x4 with
                                          | Compilers.Coq_expr.Ident (
                                              t5, idc5) ->
                                            (match x1 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 s1, _, f3, x6) ->
                                               (match f3 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f4, x7) ->
                                                  (match f4 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t6, idc6) ->
                                                     (match x7 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t7, idc7) ->
                                                        sequence
                                                          (match x6 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t8, idc8) ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t8 idc8
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args0 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t7 idc7
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args1 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv4
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    x8)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (fst
                                                                    (Obj.magic
                                                                    Coq1_Z.add_get_carry_full
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv4
                                                                    in
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (snd
                                                                    (Obj.magic
                                                                    Coq1_Z.add_get_carry_full
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv4
                                                                    in
                                                                    x8))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                          (bind1
                                                            (Obj.magic
                                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                              t7 idc7
                                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                                            (fun args0 ->
                                                            bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                t6 idc6
                                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                  t5 idc5
                                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                                (fun args1 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                  (fun args2 ->
                                                                  bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s1)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s1))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8)))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    x8))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8) (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, _,
                                                                    _) ->
                                            None
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                         (match x1 with
                                          | Compilers.Coq_expr.Ident (
                                              _, _) ->
                                            None
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, f3,
                                                                    x6) ->
                                            (match f3 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f4, x7) ->
                                               (match f4 with
                                                | Compilers.Coq_expr.Ident (
                                                    t5, idc5) ->
                                                  (match x7 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t6, idc6) ->
                                                     (match x6 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t7, idc7) ->
                                                        bind1
                                                          (Obj.magic
                                                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                            t7 idc7
                                                            Coq3_Compilers.Coq_raw_ident_Literal)
                                                          (fun args0 ->
                                                          bind1
                                                            (Obj.magic
                                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                              t6 idc6
                                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                                            (fun args1 ->
                                                            bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                t5 idc5
                                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                  t4 idc4
                                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                                (fun args2 ->
                                                                bind1
                                                                  (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                  (fun _ ->
                                                                  bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8)))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8) (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv3
                                                                    in
                                                                    x8) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x4))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, _, _) -> None
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))),
          Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (_, _) -> None
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, f, x2) ->
             (match f with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, f0, x3) ->
                (match f0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   (match x3 with
                    | Compilers.Coq_expr.Ident (t1, idc1) ->
                      (match x2 with
                       | Compilers.Coq_expr.Ident (t2, idc2) ->
                         bind1
                           (Obj.magic
                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                             t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                           (fun args0 ->
                           bind1
                             (Obj.magic
                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                               t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                             (fun args1 ->
                             bind1
                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t0 idc0 Coq3_Compilers.Coq_raw_ident_Z_cast)
                               (fun _ ->
                               match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                       (fun x4 y ->
                                       match x4 with
                                       | Coq3_Compilers.Z ->
                                         (match y with
                                          | Coq3_Compilers.Z -> true
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_bool ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> true
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_nat ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> true
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_zrange ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange -> true
                                          | Coq3_Compilers.Coq_string ->
                                            false)
                                       | Coq3_Compilers.Coq_string ->
                                         (match y with
                                          | Coq3_Compilers.Z -> false
                                          | Coq3_Compilers.Coq_bool -> false
                                          | Coq3_Compilers.Coq_nat -> false
                                          | Coq3_Compilers.Coq_zrange ->
                                            false
                                          | Coq3_Compilers.Coq_string -> true))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Coq_zrange)),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z))))
                                       (Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_arrow
                                       ((Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x4, _) =
                                          args1.Coq_Primitive.projT1
                                        in
                                        x4))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       (let (x4, _) =
                                          args0.Coq_Primitive.projT1
                                        in
                                        x4))))), (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))),
                                       (Compilers.Coq_type.Coq_base
                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                       Coq3_Compilers.Z)))) with
                               | Some vars0 ->
                                 let (a, _) = Obj.magic vars0 in
                                 let (a0, _) = a in
                                 let (_, _) = a0 in
                                 if Compilers.Coq_type.type_beq
                                      (Compilers.Coq_base.Coq_type.type_beq
                                        (fun x4 y ->
                                        match x4 with
                                        | Coq3_Compilers.Z ->
                                          (match y with
                                           | Coq3_Compilers.Z -> true
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_bool ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> true
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_nat ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> true
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_zrange ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             true
                                           | Coq3_Compilers.Coq_string ->
                                             false)
                                        | Coq3_Compilers.Coq_string ->
                                          (match y with
                                           | Coq3_Compilers.Z -> false
                                           | Coq3_Compilers.Coq_bool -> false
                                           | Coq3_Compilers.Coq_nat -> false
                                           | Coq3_Compilers.Coq_zrange ->
                                             false
                                           | Coq3_Compilers.Coq_string ->
                                             true)))
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Coq_zrange)),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))))
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x4, _) =
                                         args1.Coq_Primitive.projT1
                                       in
                                       x4))), (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      (let (x4, _) =
                                         args0.Coq_Primitive.projT1
                                       in
                                       x4))))), (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))))
                                 then bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Coq_zrange))
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          (let (x4, _) =
                                             args1.Coq_Primitive.projT1
                                           in
                                           x4)))
                                          (Coq3_Compilers.Coq_pattern_ident_Literal
                                          Coq3_Compilers.Coq_zrange)
                                          (Coq3_Compilers.Coq_ident_Literal
                                          ((let (x4, _) =
                                              args1.Coq_Primitive.projT1
                                            in
                                            x4),
                                          (let (x4, _) =
                                             let (_, y) =
                                               args1.Coq_Primitive.projT2
                                             in
                                             y
                                           in
                                           x4)))) (fun xv ->
                                        bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x4, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x4)))
                                            (Coq3_Compilers.Coq_pattern_ident_Literal
                                            Coq3_Compilers.Z)
                                            (Coq3_Compilers.Coq_ident_Literal
                                            ((let (x4, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x4),
                                            (let (x4, _) =
                                               let (_, y) =
                                                 args0.Coq_Primitive.projT2
                                               in
                                               y
                                             in
                                             x4)))) (fun xv0 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x4 x5)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tro ->
                                            match tro with
                                            | Some v ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x4 x5)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (fun tro0 ->
                                                match tro0 with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x4 x5 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x4 x5)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)
                                                    (fun tr ->
                                                    match tr with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x4 x5 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x4 x5)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr0 ->
                                                        match tr0 with
                                                        | Some v2 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x4 x5 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x4 x5)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr1 ->
                                                            match tr1 with
                                                            | Some v3 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x4 x5 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x4 x5)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (fun tr' ->
                                                                match tr' with
                                                                | Some v4 ->
                                                                  bind1
                                                                    (
                                                                    if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv0
                                                                    in
                                                                    x4) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v1
                                                                    (v x0)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Obj.magic
                                                                    v2
                                                                    (v0 x1)))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)))
                                 else None
                               | None -> None)))
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))),
          Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (_, _) -> None
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, f, x3) ->
             (match f with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, f0, x4) ->
                (match f0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   (match x4 with
                    | Compilers.Coq_expr.Ident (t1, idc1) ->
                      (match x3 with
                       | Compilers.Coq_expr.Ident (t2, idc2) ->
                         (match x0 with
                          | Compilers.Coq_expr.Ident (_, _) -> None
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (_, _, f1, x5) ->
                            (match f1 with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, f2, x6) ->
                               (match f2 with
                                | Compilers.Coq_expr.Ident (t3, idc3) ->
                                  (match x6 with
                                   | Compilers.Coq_expr.Ident (t4, idc4) ->
                                     (match x5 with
                                      | Compilers.Coq_expr.Ident (t5, idc5) ->
                                        (match x1 with
                                         | Compilers.Coq_expr.Ident (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Var (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Abs (_, _, _) ->
                                           None
                                         | Compilers.Coq_expr.App (s0, _, f3,
                                                                   x7) ->
                                           (match f3 with
                                            | Compilers.Coq_expr.Ident (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                _, _, f4, x8) ->
                                              (match f4 with
                                               | Compilers.Coq_expr.Ident (
                                                   t6, idc6) ->
                                                 (match x8 with
                                                  | Compilers.Coq_expr.Ident (
                                                      t7, idc7) ->
                                                    sequence
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t8, idc8) ->
                                                         (match x2 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              s1, _, f5, x9) ->
                                                            (match f5 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f6,
                                                                 x10) ->
                                                               (match f6 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                  (match x10 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    sequence
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, b1) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    x11))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv6
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv5
                                                                    in
                                                                    x11)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (fst
                                                                    (Obj.magic
                                                                    Coq1_Z.add_with_get_carry_full
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv6
                                                                    in
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (snd
                                                                    (Obj.magic
                                                                    Coq1_Z.add_with_get_carry_full
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv6
                                                                    in
                                                                    x11))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s1)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, b1) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s1))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11)))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11))))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    x11))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv5
                                                                    in
                                                                    x11))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11) Z0))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                      (match x2 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, f5, x9) ->
                                                         (match f5 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, f6, x10) ->
                                                            (match f6 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t8, idc8) ->
                                                               (match x10 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                  (match x9 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, b0) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, b1) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) = b
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11)))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11))))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    x11))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11) Z0))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv5
                                                                    in
                                                                    x11) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                         | Compilers.Coq_expr.LetIn (
                                             _, _, _, _) ->
                                           None)
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, _, _) ->
                                     None
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, _, _) -> None
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))))),
          Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
          x2))))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, x1) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x2) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x0 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (s1, _, f1, x3) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x4) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x4 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    sequence
                                      (bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t3 idc3
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args0 ->
                                        bind1
                                          (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t2 idc2
                                            Coq3_Compilers.Coq_raw_ident_Z_cast)
                                          (fun _ ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t1 idc1
                                              Coq3_Compilers.Coq_raw_ident_Literal)
                                            (fun args1 ->
                                            bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t0 idc0
                                                Coq3_Compilers.Coq_raw_ident_Z_cast)
                                              (fun _ ->
                                              match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                      (fun x5 y ->
                                                      match x5 with
                                                      | Coq3_Compilers.Z ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           true
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_bool ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           true
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_nat ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_string ->
                                                           false)
                                                      | Coq3_Compilers.Coq_string ->
                                                        (match y with
                                                         | Coq3_Compilers.Z ->
                                                           false
                                                         | Coq3_Compilers.Coq_bool ->
                                                           false
                                                         | Coq3_Compilers.Coq_nat ->
                                                           false
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           false
                                                         | Coq3_Compilers.Coq_string ->
                                                           true))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))))))
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x5, _) =
                                                         args1.Coq_Primitive.projT1
                                                       in
                                                       x5))), s0)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      (let (x5, _) =
                                                         args0.Coq_Primitive.projT1
                                                       in
                                                       x5))), s1)))) with
                                              | Some vars0 ->
                                                let (a, b) = Obj.magic vars0
                                                in
                                                let (_, _) = a in
                                                let (_, _) = b in
                                                if Compilers.Coq_type.type_beq
                                                     (Compilers.Coq_base.Coq_type.type_beq
                                                       (fun x5 y ->
                                                       match x5 with
                                                       | Coq3_Compilers.Z ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            true
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_bool ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            true
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_nat ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            true
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            true
                                                          | Coq3_Compilers.Coq_string ->
                                                            false)
                                                       | Coq3_Compilers.Coq_string ->
                                                         (match y with
                                                          | Coq3_Compilers.Z ->
                                                            false
                                                          | Coq3_Compilers.Coq_bool ->
                                                            false
                                                          | Coq3_Compilers.Coq_nat ->
                                                            false
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            false
                                                          | Coq3_Compilers.Coq_string ->
                                                            true)))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z)))),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Z))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x5, _) =
                                                        args1.Coq_Primitive.projT1
                                                      in
                                                      x5))), s0)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                                     (let (x5, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x5))), s1))))
                                                then bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x5, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x5)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x5, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x5),
                                                         (let (x5, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x5)))) (fun xv ->
                                                       Compilers.Coq_type.try_make_transport_cps
                                                         (fun _ x5 x6 _ ->
                                                         Compilers.Coq_base.try_make_transport_cps
                                                           (fun _ x7 x8 _ ->
                                                           Coq3_Compilers.try_make_base_transport_cps
                                                             x7 x8) x5 x6) s0
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))
                                                         (fun tro ->
                                                         match tro with
                                                         | Some _ ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               (let (
                                                                  x5, _) =
                                                                  args0.Coq_Primitive.projT1
                                                                in
                                                                x5)))
                                                               (Coq3_Compilers.Coq_pattern_ident_Literal
                                                               Coq3_Compilers.Coq_zrange)
                                                               (Coq3_Compilers.Coq_ident_Literal
                                                               ((let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x5),
                                                               (let (
                                                                  x5, _) =
                                                                  let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  y
                                                                in
                                                                x5))))
                                                             (fun xv0 ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x5 x6 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x7 x8 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x7 x8) x5
                                                                 x6) s1
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x5 x6 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.ltb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    (Zpos
                                                                    XH)))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None))
                                                         | None -> None))
                                                else None
                                              | None -> None)))))
                                      (sequence
                                        (bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t3 idc3
                                            Coq3_Compilers.Coq_raw_ident_Literal)
                                          (fun args0 ->
                                          bind1
                                            (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t2 idc2
                                              Coq3_Compilers.Coq_raw_ident_Z_cast)
                                            (fun _ ->
                                            bind1
                                              (Obj.magic
                                                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t1 idc1
                                                Coq3_Compilers.Coq_raw_ident_Literal)
                                              (fun args1 ->
                                              bind1
                                                (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                  t0 idc0
                                                  Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                (fun _ ->
                                                match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                        (fun x5 y ->
                                                        match x5 with
                                                        | Coq3_Compilers.Z ->
                                                          (match y with
                                                           | Coq3_Compilers.Z ->
                                                             true
                                                           | Coq3_Compilers.Coq_bool ->
                                                             false
                                                           | Coq3_Compilers.Coq_nat ->
                                                             false
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             false
                                                           | Coq3_Compilers.Coq_string ->
                                                             false)
                                                        | Coq3_Compilers.Coq_bool ->
                                                          (match y with
                                                           | Coq3_Compilers.Z ->
                                                             false
                                                           | Coq3_Compilers.Coq_bool ->
                                                             true
                                                           | Coq3_Compilers.Coq_nat ->
                                                             false
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             false
                                                           | Coq3_Compilers.Coq_string ->
                                                             false)
                                                        | Coq3_Compilers.Coq_nat ->
                                                          (match y with
                                                           | Coq3_Compilers.Z ->
                                                             false
                                                           | Coq3_Compilers.Coq_bool ->
                                                             false
                                                           | Coq3_Compilers.Coq_nat ->
                                                             true
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             false
                                                           | Coq3_Compilers.Coq_string ->
                                                             false)
                                                        | Coq3_Compilers.Coq_zrange ->
                                                          (match y with
                                                           | Coq3_Compilers.Z ->
                                                             false
                                                           | Coq3_Compilers.Coq_bool ->
                                                             false
                                                           | Coq3_Compilers.Coq_nat ->
                                                             false
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             true
                                                           | Coq3_Compilers.Coq_string ->
                                                             false)
                                                        | Coq3_Compilers.Coq_string ->
                                                          (match y with
                                                           | Coq3_Compilers.Z ->
                                                             false
                                                           | Coq3_Compilers.Coq_bool ->
                                                             false
                                                           | Coq3_Compilers.Coq_nat ->
                                                             false
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             false
                                                           | Coq3_Compilers.Coq_string ->
                                                             true))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x5, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x5))), s0)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x5, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x5))), s1)))) with
                                                | Some vars0 ->
                                                  let (a, b) =
                                                    Obj.magic vars0
                                                  in
                                                  let (_, _) = a in
                                                  let (_, _) = b in
                                                  if Compilers.Coq_type.type_beq
                                                       (Compilers.Coq_base.Coq_type.type_beq
                                                         (fun x5 y ->
                                                         match x5 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true)))
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z)))),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Z))))))
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       (let (x5, _) =
                                                          args1.Coq_Primitive.projT1
                                                        in
                                                        x5))), s0)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       (let (x5, _) =
                                                          args0.Coq_Primitive.projT1
                                                        in
                                                        x5))), s1))))
                                                  then bind1
                                                         (Obj.magic
                                                           Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange))
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           (let (x5, _) =
                                                              args1.Coq_Primitive.projT1
                                                            in
                                                            x5)))
                                                           (Coq3_Compilers.Coq_pattern_ident_Literal
                                                           Coq3_Compilers.Coq_zrange)
                                                           (Coq3_Compilers.Coq_ident_Literal
                                                           ((let (x5, _) =
                                                               args1.Coq_Primitive.projT1
                                                             in
                                                             x5),
                                                           (let (x5, _) =
                                                              let (_, y) =
                                                                args1.Coq_Primitive.projT2
                                                              in
                                                              y
                                                            in
                                                            x5)))) (fun xv ->
                                                         Compilers.Coq_type.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x7 x8 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x7 x8) x5 x6)
                                                           s0
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z))
                                                           (fun tro ->
                                                           match tro with
                                                           | Some _ ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange))
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                  in
                                                                  x5)))
                                                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                 Coq3_Compilers.Coq_zrange)
                                                                 (Coq3_Compilers.Coq_ident_Literal
                                                                 ((let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                   in
                                                                   x5),
                                                                 (let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                  in
                                                                  x5))))
                                                               (fun xv0 ->
                                                               Compilers.Coq_type.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x7 x8 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                   x6) s1
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))
                                                                 (fun tro0 ->
                                                                 match tro0 with
                                                                 | Some _ ->
                                                                   Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    Coq_Z.leb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5)).upper
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5)).lower
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                 | None ->
                                                                   None))
                                                           | None -> None))
                                                  else None
                                                | None -> None)))))
                                        (sequence
                                          (match x3 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             sequence
                                               (bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t4 idc4
                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                 (fun args0 ->
                                                 bind1
                                                   (Obj.magic
                                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                     t3 idc3
                                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                                   (fun args1 ->
                                                   bind1
                                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t2 idc2
                                                       Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                     (fun _ ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t1 idc1
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args2 ->
                                                       bind1
                                                         (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t0 idc0
                                                           Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                         (fun _ ->
                                                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                 (fun x5 y ->
                                                                 match x5 with
                                                                 | Coq3_Compilers.Z ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 s0)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                  in
                                                                  x5))))))) with
                                                         | Some vars0 ->
                                                           let (a, b) =
                                                             Obj.magic vars0
                                                           in
                                                           let (_, _) = a in
                                                           let (_, _) = b in
                                                           if Compilers.Coq_type.type_beq
                                                                (Compilers.Coq_base.Coq_type.type_beq
                                                                  (fun x5 y ->
                                                                  match x5 with
                                                                  | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args2.Coq_Primitive.projT1
                                                                 in
                                                                 x5))), s0)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args1.Coq_Primitive.projT1
                                                                 in
                                                                 x5))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x5)))))))
                                                           then bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                  (fun xv ->
                                                                  Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv1
                                                                    in
                                                                    x5)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5)))
                                                                    (Coq_Z.ltb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5)).upper
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv1
                                                                    in
                                                                    x5))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    (Zpos
                                                                    XH)))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                           else None
                                                         | None -> None))))))
                                               (bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t4 idc4
                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                 (fun args0 ->
                                                 bind1
                                                   (Obj.magic
                                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                     t3 idc3
                                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                                   (fun args1 ->
                                                   bind1
                                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t2 idc2
                                                       Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                     (fun _ ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t1 idc1
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args2 ->
                                                       bind1
                                                         (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t0 idc0
                                                           Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                         (fun _ ->
                                                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                 (fun x5 y ->
                                                                 match x5 with
                                                                 | Coq3_Compilers.Z ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 s0)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                  in
                                                                  x5))))))) with
                                                         | Some vars0 ->
                                                           let (a, b) =
                                                             Obj.magic vars0
                                                           in
                                                           let (_, _) = a in
                                                           let (_, _) = b in
                                                           if Compilers.Coq_type.type_beq
                                                                (Compilers.Coq_base.Coq_type.type_beq
                                                                  (fun x5 y ->
                                                                  match x5 with
                                                                  | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args2.Coq_Primitive.projT1
                                                                 in
                                                                 x5))), s0)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args1.Coq_Primitive.projT1
                                                                 in
                                                                 x5))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x5)))))))
                                                           then bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                  (fun xv ->
                                                                  Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv1
                                                                    in
                                                                    x5)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5)))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv1
                                                                    in
                                                                    x5)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5)).lower)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                           else None
                                                         | None -> None))))))
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                          (match x1 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             sequence
                                               (bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t4 idc4
                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                 (fun args0 ->
                                                 bind1
                                                   (Obj.magic
                                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                     t3 idc3
                                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                                   (fun args1 ->
                                                   bind1
                                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t2 idc2
                                                       Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                     (fun _ ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t1 idc1
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args2 ->
                                                       bind1
                                                         (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t0 idc0
                                                           Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                         (fun _ ->
                                                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                 (fun x5 y ->
                                                                 match x5 with
                                                                 | Coq3_Compilers.Z ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                  in
                                                                  x5))))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 s1)))) with
                                                         | Some vars0 ->
                                                           let (a, b) =
                                                             Obj.magic vars0
                                                           in
                                                           let (_, _) = a in
                                                           let (_, _) = b in
                                                           if Compilers.Coq_type.type_beq
                                                                (Compilers.Coq_base.Coq_type.type_beq
                                                                  (fun x5 y ->
                                                                  match x5 with
                                                                  | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args2.Coq_Primitive.projT1
                                                                 in
                                                                 x5))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x5))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args1.Coq_Primitive.projT1
                                                                 in
                                                                 x5))),
                                                                s1))))
                                                           then bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                  (fun xv ->
                                                                  bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5)))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv1
                                                                    in
                                                                    x5)).lower)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    (Zpos
                                                                    XH)))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                           else None
                                                         | None -> None))))))
                                               (bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t4 idc4
                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                 (fun args0 ->
                                                 bind1
                                                   (Obj.magic
                                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                     t3 idc3
                                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                                   (fun args1 ->
                                                   bind1
                                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t2 idc2
                                                       Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                     (fun _ ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t1 idc1
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args2 ->
                                                       bind1
                                                         (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t0 idc0
                                                           Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                         (fun _ ->
                                                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                 (fun x5 y ->
                                                                 match x5 with
                                                                 | Coq3_Compilers.Z ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                  in
                                                                  x5))))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                  in
                                                                  x5))),
                                                                 s1)))) with
                                                         | Some vars0 ->
                                                           let (a, b) =
                                                             Obj.magic vars0
                                                           in
                                                           let (_, _) = a in
                                                           let (_, _) = b in
                                                           if Compilers.Coq_type.type_beq
                                                                (Compilers.Coq_base.Coq_type.type_beq
                                                                  (fun x5 y ->
                                                                  match x5 with
                                                                  | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args2.Coq_Primitive.projT1
                                                                 in
                                                                 x5))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x5))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x5, _) =
                                                                   args1.Coq_Primitive.projT1
                                                                 in
                                                                 x5))),
                                                                s1))))
                                                           then bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                  (fun xv ->
                                                                  bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x5, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x5),
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x5))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                    x6) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5)))
                                                                    (Coq_Z.leb
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv1
                                                                    in
                                                                    x5)).upper
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                           else None
                                                         | None -> None))))))
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)))
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (t0, idc0) ->
               sequence
                 (bind1
                   (Obj.magic
                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                     t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                   (fun args0 ->
                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                           (fun x1 y ->
                           match x1 with
                           | Coq3_Compilers.Z ->
                             (match y with
                              | Coq3_Compilers.Z -> true
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_bool ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> true
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_nat ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> true
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_zrange ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> true
                              | Coq3_Compilers.Coq_string -> false)
                           | Coq3_Compilers.Coq_string ->
                             (match y with
                              | Coq3_Compilers.Z -> false
                              | Coq3_Compilers.Coq_bool -> false
                              | Coq3_Compilers.Coq_nat -> false
                              | Coq3_Compilers.Coq_zrange -> false
                              | Coq3_Compilers.Coq_string -> true))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) with
                   | Some vars0 ->
                     let (_, _) = Obj.magic vars0 in
                     if Compilers.Coq_type.type_beq
                          (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true)))
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Coq_zrange)),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))))
                     then bind1
                            (Obj.magic
                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Coq_zrange))
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))
                              (Coq3_Compilers.Coq_pattern_ident_Literal
                              Coq3_Compilers.Coq_zrange)
                              (Coq3_Compilers.Coq_ident_Literal
                              ((let (x1, _) = args0.Coq_Primitive.projT1 in
                                x1),
                              (let (x1, _) =
                                 let (_, y) = args0.Coq_Primitive.projT2 in y
                               in
                               x1)))) (fun xv ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1
                                x2)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) (fun tro ->
                              match tro with
                              | Some _ ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x1 x2 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x1 x2)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z) (fun tr ->
                                  match tr with
                                  | Some _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x1 x2)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z) (fun tr0 ->
                                      match tr0 with
                                      | Some v ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x1 x2)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) (fun tr' ->
                                          match tr' with
                                          | Some v0 ->
                                            bind1
                                              (if Coq_Z.eqb
                                                    (let (x1, _) = xv in x1).lower
                                                    (let (x1, _) = xv in x1).upper
                                               then Some
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        Coq3_Compilers.Coq_ident_Z_cast)),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)),
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        (Coq3_Compilers.Coq_zrange,
                                                        (let (x1, _) = xv in
                                                         Obj.magic x1))))))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Coq3_Compilers.Coq_ident_Literal
                                                        (Coq3_Compilers.Z,
                                                        (Obj.magic
                                                          (let (x1, _) = xv
                                                           in
                                                           x1).lower))))))))
                                               else None) (fun fv -> Some
                                              (Coq_Compilers.UnderLets.splice
                                                fv (fun fv0 ->
                                                Coq_Compilers.UnderLets.Base
                                                (v0 (v fv0)))))
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None))
                     else None
                   | None -> None))
                 (match x0 with
                  | Compilers.Coq_expr.Ident (_, _) -> None
                  | Compilers.Coq_expr.Var (_, _) -> None
                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                  | Compilers.Coq_expr.App (s0, _, f, x1) ->
                    (match f with
                     | Compilers.Coq_expr.Ident (_, _) -> None
                     | Compilers.Coq_expr.Var (_, _) -> None
                     | Compilers.Coq_expr.Abs (_, _, _) -> None
                     | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                       (match f0 with
                        | Compilers.Coq_expr.Ident (t1, idc1) ->
                          sequence
                            (match x2 with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (s2, _, f1, x3) ->
                               (match f1 with
                                | Compilers.Coq_expr.Ident (_, _) -> None
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                  (match f2 with
                                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                                     (match x4 with
                                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                                        (match x1 with
                                         | Compilers.Coq_expr.Ident (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Var (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Abs (_, _, _) ->
                                           None
                                         | Compilers.Coq_expr.App (s3, _, f3,
                                                                   x5) ->
                                           (match f3 with
                                            | Compilers.Coq_expr.Ident (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                _, _, f4, x6) ->
                                              (match f4 with
                                               | Compilers.Coq_expr.Ident (
                                                   t4, idc4) ->
                                                 (match x6 with
                                                  | Compilers.Coq_expr.Ident (
                                                      t5, idc5) ->
                                                    sequence
                                                      (match x5 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t6, idc6) ->
                                                         bind1
                                                           (Obj.magic
                                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                             t6 idc6
                                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                                           (fun args0 ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t5 idc5
                                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                                             (fun args1 ->
                                                             bind1
                                                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t4 idc4
                                                                 Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                               (fun _ ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t3 idc3
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args2 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun _ ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7)))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                      (sequence
                                                        (match x3 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t6 idc6
                                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                                             (fun args0 ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t5 idc5
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args1 ->
                                                               bind1
                                                                 (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t4 idc4
                                                                   Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                 (fun _ ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args2 ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun _ ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7)))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                        (sequence
                                                          (match x5 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t6, idc6) ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t6 idc6
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args0 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t5 idc5
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args1 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))
                                                                    (is_bounded_by_bool
                                                                    (Zneg XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7) (Zneg
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x3))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                          (sequence
                                                            (match x3 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t6, idc6) ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t6 idc6
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args0 ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args1 ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7))
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))
                                                                    (is_bounded_by_bool
                                                                    (Zneg XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7) (Zneg
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x5))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                            (sequence
                                                              (match x5 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   t6, idc6) ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args0 ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7) }))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.succ
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7)))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x3))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                              (match x3 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   t6, idc6) ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args0 ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7))
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7) }))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.succ
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7)))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x5))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)))))
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                         | Compilers.Coq_expr.LetIn (
                                             _, _, _, _) ->
                                           None)
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, _, _) ->
                                     None
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                            (sequence
                              (match x2 with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (s2, _, f1, x3) ->
                                 (match f1 with
                                  | Compilers.Coq_expr.Ident (_, _) -> None
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                    (match f2 with
                                     | Compilers.Coq_expr.Ident (t2, idc2) ->
                                       (match x4 with
                                        | Compilers.Coq_expr.Ident (t3, idc3) ->
                                          (match x1 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               s3, _, f3, x5) ->
                                             (match f3 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f4, x6) ->
                                                (match f4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t4, idc4) ->
                                                   (match x6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      sequence
                                                        (match x5 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t6 idc6
                                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                                             (fun args0 ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t5 idc5
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args1 ->
                                                               bind1
                                                                 (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t4 idc4
                                                                   Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                 (fun _ ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args2 ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_lor)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x3))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                        (sequence
                                                          (match x3 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t6, idc6) ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t6 idc6
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args0 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t5 idc5
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args1 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_lor)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7))
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x5))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                          (sequence
                                                            (match x5 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t6, idc6) ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t6 idc6
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args0 ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args1 ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_lor)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun _ ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (Zneg XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7)))
                                                                    (is_bounded_by_bool
                                                                    (Zneg XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7) (Zneg
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    (Zneg
                                                                    XH)))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                            (match x3 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t6, idc6) ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t6 idc6
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args0 ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args1 ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_lor)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s3))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun _ ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (Zneg XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7)))
                                                                    (is_bounded_by_bool
                                                                    (Zneg XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7) (Zneg
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    (Zneg
                                                                    XH)))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v0
                                                                    (v fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)))
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, _, _) ->
                                          None
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                              (match x2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 bind1
                                   (Obj.magic
                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                     t2 idc2
                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                   (fun args0 ->
                                   bind1
                                     (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                       t1 idc1
                                       Coq3_Compilers.Coq_raw_ident_Z_cast)
                                     (fun _ ->
                                     bind1
                                       (Obj.magic
                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                         t0 idc0
                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                       (fun args1 ->
                                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                               (fun x3 y ->
                                               match x3 with
                                               | Coq3_Compilers.Z ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> true
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_bool ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    true
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_nat ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    true
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_zrange ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    true
                                                  | Coq3_Compilers.Coq_string ->
                                                    false)
                                               | Coq3_Compilers.Coq_string ->
                                                 (match y with
                                                  | Coq3_Compilers.Z -> false
                                                  | Coq3_Compilers.Coq_bool ->
                                                    false
                                                  | Coq3_Compilers.Coq_nat ->
                                                    false
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    false
                                                  | Coq3_Compilers.Coq_string ->
                                                    true))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_zrange)),
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Coq_zrange)),
                                               (Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                               Coq3_Compilers.Z))))))
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x3, _) =
                                                  args1.Coq_Primitive.projT1
                                                in
                                                x3))),
                                               (Compilers.Coq_type.Coq_arrow
                                               ((Compilers.Coq_type.Coq_base
                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                               (let (x3, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x3))), s0)))) with
                                       | Some vars0 ->
                                         let (_, b) = Obj.magic vars0 in
                                         let (_, _) = b in
                                         if Compilers.Coq_type.type_beq
                                              (Compilers.Coq_base.Coq_type.type_beq
                                                (fun x3 y ->
                                                match x3 with
                                                | Coq3_Compilers.Z ->
                                                  (match y with
                                                   | Coq3_Compilers.Z -> true
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_bool ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     true
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_nat ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_zrange ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_string ->
                                                     false)
                                                | Coq3_Compilers.Coq_string ->
                                                  (match y with
                                                   | Coq3_Compilers.Z ->
                                                     false
                                                   | Coq3_Compilers.Coq_bool ->
                                                     false
                                                   | Coq3_Compilers.Coq_nat ->
                                                     false
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     false
                                                   | Coq3_Compilers.Coq_string ->
                                                     true)))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_zrange)),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_zrange)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))))))
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x3, _) =
                                                 args1.Coq_Primitive.projT1
                                               in
                                               x3))),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x3, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x3))), s0))))
                                         then bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange))
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x3, _) =
                                                     args1.Coq_Primitive.projT1
                                                   in
                                                   x3)))
                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                  Coq3_Compilers.Coq_zrange)
                                                  (Coq3_Compilers.Coq_ident_Literal
                                                  ((let (x3, _) =
                                                      args1.Coq_Primitive.projT1
                                                    in
                                                    x3),
                                                  (let (x3, _) =
                                                     let (_, y) =
                                                       args1.Coq_Primitive.projT2
                                                     in
                                                     y
                                                   in
                                                   x3)))) (fun xv ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange))
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x3, _) =
                                                       args0.Coq_Primitive.projT1
                                                     in
                                                     x3)))
                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                    Coq3_Compilers.Coq_zrange)
                                                    (Coq3_Compilers.Coq_ident_Literal
                                                    ((let (x3, _) =
                                                        args0.Coq_Primitive.projT1
                                                      in
                                                      x3),
                                                    (let (x3, _) =
                                                       let (_, y) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       y
                                                     in
                                                     x3)))) (fun xv0 ->
                                                  Compilers.Coq_type.try_make_transport_cps
                                                    (fun _ x3 x4 _ ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x5 x6 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x5 x6) x3 x4) s0
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (fun tro ->
                                                    match tro with
                                                    | Some v ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x3 x4 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x3 x4)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr ->
                                                        match tr with
                                                        | Some v0 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x3 x4 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x3 x4)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr0 ->
                                                            match tr0 with
                                                            | Some v1 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x3 x4 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x3 x4)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (fun tr' ->
                                                                match tr' with
                                                                | Some v2 ->
                                                                  bind1
                                                                    (
                                                                    if 
                                                                    is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)))
                                         else None
                                       | None -> None)))
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None))
                        | Compilers.Coq_expr.Var (_, _) -> None
                        | Compilers.Coq_expr.Abs (_, _, _) -> None
                        | Compilers.Coq_expr.App (s2, _, f1, x3) ->
                          (match f1 with
                           | Compilers.Coq_expr.Ident (t1, idc1) ->
                             bind1
                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t1 idc1
                                 Coq3_Compilers.Coq_raw_ident_Z_add_with_carry)
                               (fun _ ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t0 idc0
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                         (fun x4 y ->
                                         match x4 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Coq_zrange)),
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)))),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x4, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x4))),
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_arrow (s2,
                                         s1)), s0)))) with
                                 | Some vars0 ->
                                   let (_, b) = Obj.magic vars0 in
                                   let (a, _) = b in
                                   let (_, _) = a in
                                   if Compilers.Coq_type.type_beq
                                        (Compilers.Coq_base.Coq_type.type_beq
                                          (fun x4 y ->
                                          match x4 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true)))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_zrange)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x4, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x4))), (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow (s2,
                                        s1)), s0))))
                                   then bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_zrange))
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x4, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x4)))
                                            (Coq3_Compilers.Coq_pattern_ident_Literal
                                            Coq3_Compilers.Coq_zrange)
                                            (Coq3_Compilers.Coq_ident_Literal
                                            ((let (x4, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x4),
                                            (let (x4, _) =
                                               let (_, y) =
                                                 args0.Coq_Primitive.projT2
                                               in
                                               y
                                             in
                                             x4)))) (fun xv ->
                                          Compilers.Coq_type.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x6 x7 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x6 x7) x4 x5) s2
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)) (fun tro ->
                                            match tro with
                                            | Some v ->
                                              Compilers.Coq_type.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x6 x7 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x6 x7) x4 x5) s1
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (fun tro0 ->
                                                match tro0 with
                                                | Some v0 ->
                                                  Compilers.Coq_type.try_make_transport_cps
                                                    (fun _ x4 x5 _ ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x6 x7 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x6 x7) x4 x5) s0
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (fun tro1 ->
                                                    match tro1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x4 x5 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x4 x5)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr ->
                                                        match tr with
                                                        | Some v2 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x4 x5 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x4 x5)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr0 ->
                                                            match tr0 with
                                                            | Some v3 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x4 x5 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x4 x5)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (fun tr1 ->
                                                                match tr1 with
                                                                | Some v4 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_with_carry)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None))
                                   else None
                                 | None -> None))
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (_, _, _, _) -> None
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, _, _) -> None
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cast)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (_, _) -> None
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, f, x1) ->
             (match f with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, f0, x2) ->
                (match f0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   (match x2 with
                    | Compilers.Coq_expr.Ident (t1, idc1) ->
                      (match x1 with
                       | Compilers.Coq_expr.Ident (t2, idc2) ->
                         (match x0 with
                          | Compilers.Coq_expr.Ident (_, _) -> None
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (s0, _, f1, x3) ->
                            (match f1 with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (s1, _, f2, x4) ->
                               (match f2 with
                                | Compilers.Coq_expr.Ident (t3, idc3) ->
                                  bind1
                                    (Obj.magic
                                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                      t3 idc3
                                      Coq3_Compilers.Coq_raw_ident_pair)
                                    (fun args0 ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                        t2 idc2
                                        Coq3_Compilers.Coq_raw_ident_Literal)
                                      (fun args1 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t1 idc1
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args2 ->
                                        bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t0 idc0
                                            Coq3_Compilers.Coq_raw_ident_pair)
                                          (fun args3 ->
                                          match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                  (fun x5 y ->
                                                  match x5 with
                                                  | Coq3_Compilers.Z ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       true
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_bool ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       true
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_nat ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       true
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_zrange ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       true
                                                     | Coq3_Compilers.Coq_string ->
                                                       false)
                                                  | Coq3_Compilers.Coq_string ->
                                                    (match y with
                                                     | Coq3_Compilers.Z ->
                                                       false
                                                     | Coq3_Compilers.Coq_bool ->
                                                       false
                                                     | Coq3_Compilers.Coq_nat ->
                                                       false
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       false
                                                     | Coq3_Compilers.Coq_string ->
                                                       true))
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange),
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange)))))))),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange)))),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Coq_zrange)))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z),
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)))))))),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)))),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z))))))
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (let (x5, _) =
                                                     let (x5, _) =
                                                       args3.Coq_Primitive.projT2
                                                     in
                                                     x5
                                                   in
                                                   x5)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (let (x5, _) =
                                                     let (_, y) =
                                                       let (x5, _) =
                                                         args3.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     y
                                                   in
                                                   x5)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_prod
                                                  ((let (x5, _) =
                                                      let (x5, _) =
                                                        args3.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    x5),
                                                  (let (x5, _) =
                                                     let (_, y) =
                                                       let (x5, _) =
                                                         args3.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     y
                                                   in
                                                   x5)))))))),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x5, _) =
                                                     args2.Coq_Primitive.projT1
                                                   in
                                                   x5))))),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  (let (x5, _) =
                                                     args1.Coq_Primitive.projT1
                                                   in
                                                   x5))))),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (let (x5, _) =
                                                     let (x5, _) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     x5
                                                   in
                                                   x5)),
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (let (x5, _) =
                                                     let (_, y) =
                                                       let (x5, _) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     y
                                                   in
                                                   x5)),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_prod
                                                  ((let (x5, _) =
                                                      let (x5, _) =
                                                        args0.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    x5),
                                                  (let (x5, _) =
                                                     let (_, y) =
                                                       let (x5, _) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     y
                                                   in
                                                   x5)))))))), s1)), s0)))) with
                                          | Some vars0 ->
                                            let (a, b) = Obj.magic vars0 in
                                            let (a0, _) = a in
                                            let (a1, _) = a0 in
                                            let (_, b0) = a1 in
                                            let (_, b1) = b0 in
                                            let (_, _) = b1 in
                                            let (a2, _) = b in
                                            let (a3, _) = a2 in
                                            let (_, b2) = a3 in
                                            let (_, b3) = b2 in
                                            let (_, _) = b3 in
                                            if Compilers.Coq_type.type_beq
                                                 (Compilers.Coq_base.Coq_type.type_beq
                                                   (fun x5 y ->
                                                   match x5 with
                                                   | Coq3_Compilers.Z ->
                                                     (match y with
                                                      | Coq3_Compilers.Z ->
                                                        true
                                                      | Coq3_Compilers.Coq_bool ->
                                                        false
                                                      | Coq3_Compilers.Coq_nat ->
                                                        false
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        false
                                                      | Coq3_Compilers.Coq_string ->
                                                        false)
                                                   | Coq3_Compilers.Coq_bool ->
                                                     (match y with
                                                      | Coq3_Compilers.Z ->
                                                        false
                                                      | Coq3_Compilers.Coq_bool ->
                                                        true
                                                      | Coq3_Compilers.Coq_nat ->
                                                        false
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        false
                                                      | Coq3_Compilers.Coq_string ->
                                                        false)
                                                   | Coq3_Compilers.Coq_nat ->
                                                     (match y with
                                                      | Coq3_Compilers.Z ->
                                                        false
                                                      | Coq3_Compilers.Coq_bool ->
                                                        false
                                                      | Coq3_Compilers.Coq_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        false
                                                      | Coq3_Compilers.Coq_string ->
                                                        false)
                                                   | Coq3_Compilers.Coq_zrange ->
                                                     (match y with
                                                      | Coq3_Compilers.Z ->
                                                        false
                                                      | Coq3_Compilers.Coq_bool ->
                                                        false
                                                      | Coq3_Compilers.Coq_nat ->
                                                        false
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        true
                                                      | Coq3_Compilers.Coq_string ->
                                                        false)
                                                   | Coq3_Compilers.Coq_string ->
                                                     (match y with
                                                      | Coq3_Compilers.Z ->
                                                        false
                                                      | Coq3_Compilers.Coq_bool ->
                                                        false
                                                      | Coq3_Compilers.Coq_nat ->
                                                        false
                                                      | Coq3_Compilers.Coq_zrange ->
                                                        false
                                                      | Coq3_Compilers.Coq_string ->
                                                        true)))
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange)),
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange)),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange),
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange)))))))),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange)))),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange)))),
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)),
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)))))))),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z)))),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z))))))
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (let (x5, _) =
                                                    let (x5, _) =
                                                      args3.Coq_Primitive.projT2
                                                    in
                                                    x5
                                                  in
                                                  x5)),
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (let (x5, _) =
                                                    let (_, y) =
                                                      let (x5, _) =
                                                        args3.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    y
                                                  in
                                                  x5)),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((let (x5, _) =
                                                     let (x5, _) =
                                                       args3.Coq_Primitive.projT2
                                                     in
                                                     x5
                                                   in
                                                   x5),
                                                 (let (x5, _) =
                                                    let (_, y) =
                                                      let (x5, _) =
                                                        args3.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    y
                                                  in
                                                  x5)))))))),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 (let (x5, _) =
                                                    args2.Coq_Primitive.projT1
                                                  in
                                                  x5))))),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 (let (x5, _) =
                                                    args1.Coq_Primitive.projT1
                                                  in
                                                  x5))))),
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (let (x5, _) =
                                                    let (x5, _) =
                                                      args0.Coq_Primitive.projT2
                                                    in
                                                    x5
                                                  in
                                                  x5)),
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (let (x5, _) =
                                                    let (_, y) =
                                                      let (x5, _) =
                                                        args0.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    y
                                                  in
                                                  x5)),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((let (x5, _) =
                                                     let (x5, _) =
                                                       args0.Coq_Primitive.projT2
                                                     in
                                                     x5
                                                   in
                                                   x5),
                                                 (let (x5, _) =
                                                    let (_, y) =
                                                      let (x5, _) =
                                                        args0.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    y
                                                  in
                                                  x5)))))))), s1)), s0))))
                                            then bind1
                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                     ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange),
                                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange))))))))
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (let (x5, _) =
                                                        let (x5, _) =
                                                          args3.Coq_Primitive.projT2
                                                        in
                                                        x5
                                                      in
                                                      x5)),
                                                     (Compilers.Coq_type.Coq_arrow
                                                     ((Compilers.Coq_type.Coq_base
                                                     (let (x5, _) =
                                                        let (_, y) =
                                                          let (x5, _) =
                                                            args3.Coq_Primitive.projT2
                                                          in
                                                          x5
                                                        in
                                                        y
                                                      in
                                                      x5)),
                                                     (Compilers.Coq_type.Coq_base
                                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                                     ((let (x5, _) =
                                                         let (x5, _) =
                                                           args3.Coq_Primitive.projT2
                                                         in
                                                         x5
                                                       in
                                                       x5),
                                                     (let (x5, _) =
                                                        let (_, y) =
                                                          let (x5, _) =
                                                            args3.Coq_Primitive.projT2
                                                          in
                                                          x5
                                                        in
                                                        y
                                                      in
                                                      x5))))))))
                                                     (Coq3_Compilers.Coq_pattern_ident_pair
                                                     ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange),
                                                     (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                     Coq3_Compilers.Coq_zrange)))
                                                     (Coq3_Compilers.Coq_ident_pair
                                                     ((let (x5, _) =
                                                         let (x5, _) =
                                                           args3.Coq_Primitive.projT2
                                                         in
                                                         x5
                                                       in
                                                       x5),
                                                     (let (x5, _) =
                                                        let (_, y) =
                                                          let (x5, _) =
                                                            args3.Coq_Primitive.projT2
                                                          in
                                                          x5
                                                        in
                                                        y
                                                      in
                                                      x5)))) (fun _ ->
                                                   bind1
                                                     (Obj.magic
                                                       Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange))
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_type_base
                                                       (let (x5, _) =
                                                          args2.Coq_Primitive.projT1
                                                        in
                                                        x5)))
                                                       (Coq3_Compilers.Coq_pattern_ident_Literal
                                                       Coq3_Compilers.Coq_zrange)
                                                       (Coq3_Compilers.Coq_ident_Literal
                                                       ((let (x5, _) =
                                                           args2.Coq_Primitive.projT1
                                                         in
                                                         x5),
                                                       (let (x5, _) =
                                                          let (_, y) =
                                                            args2.Coq_Primitive.projT2
                                                          in
                                                          y
                                                        in
                                                        x5)))) (fun xv ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x5, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x5)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x5, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x5),
                                                         (let (x5, _) =
                                                            let (_, y) =
                                                              args1.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x5)))) (fun xv0 ->
                                                       bind1
                                                         (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                           ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z),
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z))))))))
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (let (x5, _) =
                                                              let (x5, _) =
                                                                args0.Coq_Primitive.projT2
                                                              in
                                                              x5
                                                            in
                                                            x5)),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (let (x5, _) =
                                                              let (_, y) =
                                                                let (
                                                                  x5, _) =
                                                                  args0.Coq_Primitive.projT2
                                                                in
                                                                x5
                                                              in
                                                              y
                                                            in
                                                            x5)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                                           ((let (x5, _) =
                                                               let (x5, _) =
                                                                 args0.Coq_Primitive.projT2
                                                               in
                                                               x5
                                                             in
                                                             x5),
                                                           (let (x5, _) =
                                                              let (_, y) =
                                                                let (
                                                                  x5, _) =
                                                                  args0.Coq_Primitive.projT2
                                                                in
                                                                x5
                                                              in
                                                              y
                                                            in
                                                            x5))))))))
                                                           (Coq3_Compilers.Coq_pattern_ident_pair
                                                           ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z),
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)))
                                                           (Coq3_Compilers.Coq_ident_pair
                                                           ((let (x5, _) =
                                                               let (x5, _) =
                                                                 args0.Coq_Primitive.projT2
                                                               in
                                                               x5
                                                             in
                                                             x5),
                                                           (let (x5, _) =
                                                              let (_, y) =
                                                                let (
                                                                  x5, _) =
                                                                  args0.Coq_Primitive.projT2
                                                                in
                                                                x5
                                                              in
                                                              y
                                                            in
                                                            x5)))) (fun _ ->
                                                         Compilers.Coq_type.try_make_transport_cps
                                                           (fun _ x5 x6 _ ->
                                                           Compilers.Coq_base.try_make_transport_cps
                                                             (fun _ x7 x8 _ ->
                                                             Coq3_Compilers.try_make_base_transport_cps
                                                               x7 x8) x5 x6)
                                                           s1
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z))
                                                           (fun tro ->
                                                           match tro with
                                                           | Some v ->
                                                             Compilers.Coq_type.try_make_transport_cps
                                                               (fun _ x5 x6 _ ->
                                                               Compilers.Coq_base.try_make_transport_cps
                                                                 (fun _ x7 x8 _ ->
                                                                 Coq3_Compilers.try_make_base_transport_cps
                                                                   x7 x8) x5
                                                                 x6) s0
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))
                                                               (fun tro0 ->
                                                               match tro0 with
                                                               | Some v0 ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x5 x6 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)
                                                                   (fun tr ->
                                                                   match tr with
                                                                   | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v3 fv))
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4 fv0))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None)
                                                               | None -> None)
                                                           | None -> None)))))
                                            else None
                                          | None -> None))))
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (s2, _, f3, x5) ->
                                  (match f3 with
                                   | Compilers.Coq_expr.Ident (t3, idc3) ->
                                     sequence
                                       (sequence
                                         (match x5 with
                                          | Compilers.Coq_expr.Ident (
                                              _, _) ->
                                            None
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, f4,
                                                                    x6) ->
                                            (match f4 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    t4, idc4) ->
                                                  (match x7 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t5, idc5) ->
                                                     (match x6 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t6, idc6) ->
                                                        (match x4 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             s3, _, f6, x8) ->
                                                           (match f6 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   t7, idc7) ->
                                                                 (match x9 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    adc_no_carry_to_add0
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.four_corners
                                                                    Coq_Z.add
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12))))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v3 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                         (sequence
                                           (match x4 with
                                            | Compilers.Coq_expr.Ident (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                _, _, f4, x6) ->
                                              (match f4 with
                                               | Compilers.Coq_expr.Ident (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, f5, x7) ->
                                                 (match f5 with
                                                  | Compilers.Coq_expr.Ident (
                                                      t4, idc4) ->
                                                    (match x7 with
                                                     | Compilers.Coq_expr.Ident (
                                                         t5, idc5) ->
                                                       (match x6 with
                                                        | Compilers.Coq_expr.Ident (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, f6, x8) ->
                                                          (match f6 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t6, idc6) ->
                                                             (match x8 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  s3, _, f7,
                                                                  x9) ->
                                                                (match f7 with
                                                                 | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                   (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s3)))))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s3)))))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11)))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x9))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None)
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                           (sequence
                                             (match x3 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f4, x6) ->
                                                (match f4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, f5, x7) ->
                                                   (match f5 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t4, idc4) ->
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t5, idc5) ->
                                                         (match x6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, f6, x8) ->
                                                            (match f6 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t6, idc6) ->
                                                               (match x8 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f7, x9) ->
                                                                  (match f7 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s3)))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    s3))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11)))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x9))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                             (sequence
                                               (match x4 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f4, x6) ->
                                                  (match f4 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f5, x7) ->
                                                     (match f5 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t4, idc4) ->
                                                        (match x7 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t5, idc5) ->
                                                           (match x6 with
                                                            | Compilers.Coq_expr.Ident (
                                                                t6, idc6) ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                  t6 idc6
                                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                                (fun args0 ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                  (fun args1 ->
                                                                  bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8)))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8) Z0)
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                               (sequence
                                                 (match x3 with
                                                  | Compilers.Coq_expr.Ident (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, f4, x6) ->
                                                    (match f4 with
                                                     | Compilers.Coq_expr.Ident (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, f5, x7) ->
                                                       (match f5 with
                                                        | Compilers.Coq_expr.Ident (
                                                            t4, idc4) ->
                                                          (match x7 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t5, idc5) ->
                                                             (match x6 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  t6, idc6) ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                  (fun args0 ->
                                                                  bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x8 y ->
                                                                    match x8 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s2,
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x8, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x8
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    x8 x9) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x8, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x8),
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x8))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8)))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8) Z0)
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv1
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv2
                                                                    in
                                                                    x8)))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv
                                                                    in
                                                                    x8))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x8, _) =
                                                                    xv0
                                                                    in
                                                                    x8)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                                 (bind1
                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                     t3 idc3
                                                     Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                   (fun _ ->
                                                   bind1
                                                     (Obj.magic
                                                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t2 idc2
                                                       Coq3_Compilers.Coq_raw_ident_Literal)
                                                     (fun args0 ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                         t1 idc1
                                                         Coq3_Compilers.Coq_raw_ident_Literal)
                                                       (fun args1 ->
                                                       bind1
                                                         (Obj.magic
                                                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                           t0 idc0
                                                           Coq3_Compilers.Coq_raw_ident_pair)
                                                         (fun args2 ->
                                                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                 (fun x6 y ->
                                                                 match x6 with
                                                                 | Coq3_Compilers.Z ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange),
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)))))))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                  in
                                                                  x6)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                  in
                                                                  x6)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                   in
                                                                   x6),
                                                                 (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                  in
                                                                  x6)))))))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                  in
                                                                  x6))))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                  in
                                                                  x6))))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_arrow
                                                                 (s2, s1)),
                                                                 s0)))) with
                                                         | Some vars0 ->
                                                           let (a, b) =
                                                             Obj.magic vars0
                                                           in
                                                           let (a0, _) = a in
                                                           let (a1, _) = a0
                                                           in
                                                           let (_, b0) = a1
                                                           in
                                                           let (_, b1) = b0
                                                           in
                                                           let (_, _) = b1 in
                                                           let (a2, _) = b in
                                                           let (_, _) = a2 in
                                                           if Compilers.Coq_type.type_beq
                                                                (Compilers.Coq_base.Coq_type.type_beq
                                                                  (fun x6 y ->
                                                                  match x6 with
                                                                  | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange),
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)))))))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x6
                                                                 in
                                                                 x6)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                   in
                                                                   y
                                                                 in
                                                                 x6)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                  in
                                                                  x6),
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                   in
                                                                   y
                                                                 in
                                                                 x6)))))))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x6, _) =
                                                                   args1.Coq_Primitive.projT1
                                                                 in
                                                                 x6))))),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x6, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x6))))),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_arrow
                                                                (s2, s1)),
                                                                s0))))
                                                           then bind1
                                                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    (
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                  (fun _ ->
                                                                  bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                           else None
                                                         | None -> None))))))))))
                                       (sequence
                                         (sequence
                                           (match x5 with
                                            | Compilers.Coq_expr.Ident (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                _, _, f4, x6) ->
                                              (match f4 with
                                               | Compilers.Coq_expr.Ident (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, f5, x7) ->
                                                 (match f5 with
                                                  | Compilers.Coq_expr.Ident (
                                                      t4, idc4) ->
                                                    (match x7 with
                                                     | Compilers.Coq_expr.Ident (
                                                         t5, idc5) ->
                                                       (match x6 with
                                                        | Compilers.Coq_expr.Ident (
                                                            t6, idc6) ->
                                                          (match x4 with
                                                           | Compilers.Coq_expr.Ident (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               s3, _, f6, x8) ->
                                                             (match f6 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, f7,
                                                                  x9) ->
                                                                (match f7 with
                                                                 | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                   (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    adc_no_carry_to_add0
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.four_corners
                                                                    Coq_Z.sub
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12))))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v3 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None)
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                           (bind1
                                             (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t3 idc3
                                               Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                             (fun _ ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t2 idc2
                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                               (fun args0 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t1 idc1
                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                 (fun args1 ->
                                                 bind1
                                                   (Obj.magic
                                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                     t0 idc0
                                                     Coq3_Compilers.Coq_raw_ident_pair)
                                                   (fun args2 ->
                                                   match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                           (fun x6 y ->
                                                           match x6 with
                                                           | Coq3_Compilers.Z ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                true
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_bool ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                true
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_nat ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                true
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                true
                                                              | Coq3_Compilers.Coq_string ->
                                                                false)
                                                           | Coq3_Compilers.Coq_string ->
                                                             (match y with
                                                              | Coq3_Compilers.Z ->
                                                                false
                                                              | Coq3_Compilers.Coq_bool ->
                                                                false
                                                              | Coq3_Compilers.Coq_nat ->
                                                                false
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                false
                                                              | Coq3_Compilers.Coq_string ->
                                                                true))
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                           ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange),
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)))))))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)))),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z))))))
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (let (x6, _) =
                                                              let (x6, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x6
                                                            in
                                                            x6)),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (let (x6, _) =
                                                              let (_, y) =
                                                                let (
                                                                  x6, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x6
                                                              in
                                                              y
                                                            in
                                                            x6)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                                           ((let (x6, _) =
                                                               let (x6, _) =
                                                                 args2.Coq_Primitive.projT2
                                                               in
                                                               x6
                                                             in
                                                             x6),
                                                           (let (x6, _) =
                                                              let (_, y) =
                                                                let (
                                                                  x6, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x6
                                                              in
                                                              y
                                                            in
                                                            x6)))))))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           (let (x6, _) =
                                                              args1.Coq_Primitive.projT1
                                                            in
                                                            x6))))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           (let (x6, _) =
                                                              args0.Coq_Primitive.projT1
                                                            in
                                                            x6))))),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           (s2, s1)), s0)))) with
                                                   | Some vars0 ->
                                                     let (a, b) =
                                                       Obj.magic vars0
                                                     in
                                                     let (a0, _) = a in
                                                     let (a1, _) = a0 in
                                                     let (_, b0) = a1 in
                                                     let (_, b1) = b0 in
                                                     let (_, _) = b1 in
                                                     let (a2, _) = b in
                                                     let (_, _) = a2 in
                                                     if Compilers.Coq_type.type_beq
                                                          (Compilers.Coq_base.Coq_type.type_beq
                                                            (fun x6 y ->
                                                            match x6 with
                                                            | Coq3_Compilers.Z ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 true
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_bool ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 true
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_nat ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_string ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 true)))
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange),
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange)))))))),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange)))),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_zrange)))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)))),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))))))
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (let (x6, _) =
                                                             let (x6, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x6
                                                           in
                                                           x6)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (let (x6, _) =
                                                             let (_, y) =
                                                               let (x6, _) =
                                                                 args2.Coq_Primitive.projT2
                                                               in
                                                               x6
                                                             in
                                                             y
                                                           in
                                                           x6)),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                                          ((let (x6, _) =
                                                              let (x6, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x6
                                                            in
                                                            x6),
                                                          (let (x6, _) =
                                                             let (_, y) =
                                                               let (x6, _) =
                                                                 args2.Coq_Primitive.projT2
                                                               in
                                                               x6
                                                             in
                                                             y
                                                           in
                                                           x6)))))))),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          (let (x6, _) =
                                                             args1.Coq_Primitive.projT1
                                                           in
                                                           x6))))),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          (let (x6, _) =
                                                             args0.Coq_Primitive.projT1
                                                           in
                                                           x6))))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_arrow
                                                          (s2, s1)), s0))))
                                                     then bind1
                                                            (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange))))))))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x6, _) =
                                                                 let (
                                                                   x6, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x6
                                                               in
                                                               x6)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x6, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x6
                                                                 in
                                                                 y
                                                               in
                                                               x6)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((let (
                                                                  x6, _) =
                                                                  let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x6
                                                                in
                                                                x6),
                                                              (let (x6, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x6
                                                                 in
                                                                 y
                                                               in
                                                               x6))))))))
                                                              (Coq3_Compilers.Coq_pattern_ident_pair
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)))
                                                              (Coq3_Compilers.Coq_ident_pair
                                                              ((let (
                                                                  x6, _) =
                                                                  let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x6
                                                                in
                                                                x6),
                                                              (let (x6, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x6
                                                                 in
                                                                 y
                                                               in
                                                               x6))))
                                                            (fun _ ->
                                                            bind1
                                                              (Obj.magic
                                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange))
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x6, _) =
                                                                   args1.Coq_Primitive.projT1
                                                                 in
                                                                 x6)))
                                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                Coq3_Compilers.Coq_zrange)
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                ((let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                  in
                                                                  x6),
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                   in
                                                                   y
                                                                 in
                                                                 x6))))
                                                              (fun xv ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_zrange))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                   in
                                                                   x6)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Coq_zrange)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                  (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x6))))
                                                                (fun xv0 ->
                                                                Compilers.Coq_type.try_make_transport_cps
                                                                  (fun _ x6 x7 _ ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s2
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))
                                                                  (fun tro ->
                                                                  match tro with
                                                                  | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                  | None ->
                                                                    None))))
                                                     else None
                                                   | None -> None))))))
                                         (bind1
                                           (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                             t3 idc3
                                             Coq3_Compilers.Coq_raw_ident_Z_mul_split)
                                           (fun _ ->
                                           bind1
                                             (Obj.magic
                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                               t2 idc2
                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                             (fun args0 ->
                                             bind1
                                               (Obj.magic
                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t1 idc1
                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                               (fun args1 ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t0 idc0
                                                   Coq3_Compilers.Coq_raw_ident_pair)
                                                 (fun args2 ->
                                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                         (fun x6 y ->
                                                         match x6 with
                                                         | Coq3_Compilers.Z ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              true
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_bool ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              true
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_nat ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_zrange ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_string ->
                                                              false)
                                                         | Coq3_Compilers.Coq_string ->
                                                           (match y with
                                                            | Coq3_Compilers.Z ->
                                                              false
                                                            | Coq3_Compilers.Coq_bool ->
                                                              false
                                                            | Coq3_Compilers.Coq_nat ->
                                                              false
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              false
                                                            | Coq3_Compilers.Coq_string ->
                                                              true))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                         ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange),
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange)))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z)))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Z))))))
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x6, _) =
                                                            let (x6, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x6
                                                          in
                                                          x6)),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_base
                                                         (let (x6, _) =
                                                            let (_, y) =
                                                              let (x6, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x6
                                                            in
                                                            y
                                                          in
                                                          x6)),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_prod
                                                         ((let (x6, _) =
                                                             let (x6, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x6
                                                           in
                                                           x6),
                                                         (let (x6, _) =
                                                            let (_, y) =
                                                              let (x6, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x6
                                                            in
                                                            y
                                                          in
                                                          x6)))))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x6, _) =
                                                            args1.Coq_Primitive.projT1
                                                          in
                                                          x6))))),
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x6, _) =
                                                            args0.Coq_Primitive.projT1
                                                          in
                                                          x6))))),
                                                         (Compilers.Coq_type.Coq_arrow
                                                         ((Compilers.Coq_type.Coq_arrow
                                                         (s2, s1)), s0)))) with
                                                 | Some vars0 ->
                                                   let (a, b) =
                                                     Obj.magic vars0
                                                   in
                                                   let (a0, _) = a in
                                                   let (a1, _) = a0 in
                                                   let (_, b0) = a1 in
                                                   let (_, b1) = b0 in
                                                   let (_, _) = b1 in
                                                   let (a2, _) = b in
                                                   let (_, _) = a2 in
                                                   if Compilers.Coq_type.type_beq
                                                        (Compilers.Coq_base.Coq_type.type_beq
                                                          (fun x6 y ->
                                                          match x6 with
                                                          | Coq3_Compilers.Z ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               true
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_bool ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               true
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_nat ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               true
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_zrange ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               true
                                                             | Coq3_Compilers.Coq_string ->
                                                               false)
                                                          | Coq3_Compilers.Coq_string ->
                                                            (match y with
                                                             | Coq3_Compilers.Z ->
                                                               false
                                                             | Coq3_Compilers.Coq_bool ->
                                                               false
                                                             | Coq3_Compilers.Coq_nat ->
                                                               false
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               false
                                                             | Coq3_Compilers.Coq_string ->
                                                               true)))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Coq_zrange)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))))
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x6, _) =
                                                           let (x6, _) =
                                                             args2.Coq_Primitive.projT2
                                                           in
                                                           x6
                                                         in
                                                         x6)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (let (x6, _) =
                                                           let (_, y) =
                                                             let (x6, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x6
                                                           in
                                                           y
                                                         in
                                                         x6)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((let (x6, _) =
                                                            let (x6, _) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            x6
                                                          in
                                                          x6),
                                                        (let (x6, _) =
                                                           let (_, y) =
                                                             let (x6, _) =
                                                               args2.Coq_Primitive.projT2
                                                             in
                                                             x6
                                                           in
                                                           y
                                                         in
                                                         x6)))))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x6, _) =
                                                           args1.Coq_Primitive.projT1
                                                         in
                                                         x6))))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        (let (x6, _) =
                                                           args0.Coq_Primitive.projT1
                                                         in
                                                         x6))))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        (s2, s1)), s0))))
                                                   then bind1
                                                          (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange))))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x6, _) =
                                                               let (x6, _) =
                                                                 args2.Coq_Primitive.projT2
                                                               in
                                                               x6
                                                             in
                                                             x6)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x6, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x6, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x6
                                                               in
                                                               y
                                                             in
                                                             x6)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x6, _) =
                                                                let (
                                                                  x6, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x6
                                                              in
                                                              x6),
                                                            (let (x6, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x6, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x6
                                                               in
                                                               y
                                                             in
                                                             x6))))))))
                                                            (Coq3_Compilers.Coq_pattern_ident_pair
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)))
                                                            (Coq3_Compilers.Coq_ident_pair
                                                            ((let (x6, _) =
                                                                let (
                                                                  x6, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x6
                                                              in
                                                              x6),
                                                            (let (x6, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x6, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x6
                                                               in
                                                               y
                                                             in
                                                             x6)))) (fun _ ->
                                                          bind1
                                                            (Obj.magic
                                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange))
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x6, _) =
                                                                 args1.Coq_Primitive.projT1
                                                               in
                                                               x6)))
                                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                                              Coq3_Compilers.Coq_zrange)
                                                              (Coq3_Compilers.Coq_ident_Literal
                                                              ((let (
                                                                  x6, _) =
                                                                  args1.Coq_Primitive.projT1
                                                                in
                                                                x6),
                                                              (let (x6, _) =
                                                                 let (
                                                                   _, y) =
                                                                   args1.Coq_Primitive.projT2
                                                                 in
                                                                 y
                                                               in
                                                               x6))))
                                                            (fun xv ->
                                                            bind1
                                                              (Obj.magic
                                                                Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange))
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                (let (
                                                                   x6, _) =
                                                                   args0.Coq_Primitive.projT1
                                                                 in
                                                                 x6)))
                                                                (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                Coq3_Compilers.Coq_zrange)
                                                                (Coq3_Compilers.Coq_ident_Literal
                                                                ((let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                  in
                                                                  x6),
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                   in
                                                                   y
                                                                 in
                                                                 x6))))
                                                              (fun xv0 ->
                                                              Compilers.Coq_type.try_make_transport_cps
                                                                (fun _ x6 x7 _ ->
                                                                Compilers.Coq_base.try_make_transport_cps
                                                                  (fun _ x8 x9 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                  x7) s2
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z))
                                                                (fun tro ->
                                                                match tro with
                                                                | Some v ->
                                                                  Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul_split)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None))))
                                                   else None
                                                 | None -> None))))))
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (s3, _, f4, x6) ->
                                     (match f4 with
                                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                                        sequence
                                          (sequence
                                            (match x6 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f6, x8) ->
                                                  (match f6 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t4, idc4) ->
                                                     (match x8 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        (match x7 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           (match x5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                s4, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f8,
                                                                   x10) ->
                                                                 (match f8 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s6, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    adc_no_carry_to_add0
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.four_corners
                                                                    Coq_Z.add
                                                                    (ZRange.four_corners
                                                                    Coq_Z.add
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15))))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v5 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                            (sequence
                                              (match x5 with
                                               | Compilers.Coq_expr.Ident (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   s4, _, f5, x7) ->
                                                 (match f5 with
                                                  | Compilers.Coq_expr.Ident (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, f6, x8) ->
                                                    (match f6 with
                                                     | Compilers.Coq_expr.Ident (
                                                         t4, idc4) ->
                                                       (match x8 with
                                                        | Compilers.Coq_expr.Ident (
                                                            t5, idc5) ->
                                                          sequence
                                                            (match x7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t6, idc6) ->
                                                               sequence
                                                                 (match x4 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, f7,
                                                                    x9) ->
                                                                    (match f7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b2) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14) Z0)
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x12))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b2) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14) Z0)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14))))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x12))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 (sequence
                                                                   (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f7,
                                                                    x9) ->
                                                                    (match f7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14) Z0)
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x12))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14) Z0)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14))))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x12))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   (sequence
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f7,
                                                                    x9) ->
                                                                    (match f7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b2) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11) Z0)
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11) Z0))
                                                                    (Coq_Z.ltb
                                                                    (Coq_Z.add
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)) Z0))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    x11))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11)))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f7,
                                                                    x9) ->
                                                                    (match f7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x11 y ->
                                                                    match x11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11))))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x11, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x11
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    x11 x12)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x11, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x11),
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x11))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11) Z0)
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11) Z0))
                                                                    (Coq_Z.ltb
                                                                    (Coq_Z.add
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)) Z0))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    x11))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11)))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv1
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv2
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv3
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv4
                                                                    in
                                                                    x11)))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv
                                                                    in
                                                                    x11))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x11, _) =
                                                                    xv0
                                                                    in
                                                                    x11)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))))),
                                                                    s1)),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))))),
                                                                    s1)),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv1
                                                                    in
                                                                    x9)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv2
                                                                    in
                                                                    x9) Z0)
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv0
                                                                    in
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv0
                                                                    in
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv0
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv0
                                                                    in
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f7, x9) ->
                                                               (match f7 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                  (match x9 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    sequence
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s6, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x17 y ->
                                                                    match x17 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s5)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s6)))))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b2) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x17 y ->
                                                                    match x17 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s5)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s6)))))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro2 ->
                                                                    match tro2 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v6 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr3 ->
                                                                    match tr3 with
                                                                    | Some v7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v8 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv4
                                                                    in
                                                                    x17))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv3
                                                                    in
                                                                    x17))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv2
                                                                    in
                                                                    x17))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv1
                                                                    in
                                                                    x17))))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v6
                                                                    (v2
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v5
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x15))))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v8
                                                                    (v7 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s6, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x17 y ->
                                                                    match x17 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s5)))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s6)))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x17 y ->
                                                                    match x17 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s5)))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17))),
                                                                    s6))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x17, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x17
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x17, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x17),
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x17))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    x17 x18)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro2 ->
                                                                    match tro2 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v6 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr3 ->
                                                                    match tr3 with
                                                                    | Some v7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v8 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv4
                                                                    in
                                                                    x17))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv3
                                                                    in
                                                                    x17))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv2
                                                                    in
                                                                    x17))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv1
                                                                    in
                                                                    x17))))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v5
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v6
                                                                    (v2
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x15))))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv
                                                                    in
                                                                    x17))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x17, _) =
                                                                    xv0
                                                                    in
                                                                    x17)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v8
                                                                    (v7 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b2) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14) Z0)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14))))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_opp)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s5)))))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x14
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14) Z0)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14))
                                                                    (ZRange.opp
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14))))
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_Z_opp)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    ZRange.opp
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                            (match x6 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f7, x9) ->
                                                               (match f7 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                  (match f8 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args9 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15)))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv6
                                                                    in
                                                                    x15))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15) Z0))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv7
                                                                    in
                                                                    x15) Z0)
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv6
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))),
                                                                    (fun v3 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v3)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                              (bind1
                                                (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                  t3 idc3
                                                  Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                (fun _ ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                    t2 idc2
                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                  (fun args0 ->
                                                  bind1
                                                    (Obj.magic
                                                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                      t1 idc1
                                                      Coq3_Compilers.Coq_raw_ident_Literal)
                                                    (fun args1 ->
                                                    bind1
                                                      (Obj.magic
                                                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                        t0 idc0
                                                        Coq3_Compilers.Coq_raw_ident_pair)
                                                      (fun args2 ->
                                                      match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                              (fun x7 y ->
                                                              match x7 with
                                                              | Coq3_Compilers.Z ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_bool ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_nat ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_string ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   true))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange),
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)))))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Coq_zrange)))),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))))))
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x7, _) =
                                                                 let (
                                                                   x7, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x7
                                                               in
                                                               x7)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (let (x7, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x7
                                                                 in
                                                                 y
                                                               in
                                                               x7)),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((let (
                                                                  x7, _) =
                                                                  let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x7
                                                                in
                                                                x7),
                                                              (let (x7, _) =
                                                                 let (
                                                                   _, y) =
                                                                   let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x7
                                                                 in
                                                                 y
                                                               in
                                                               x7)))))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x7, _) =
                                                                 args1.Coq_Primitive.projT1
                                                               in
                                                               x7))))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              (let (x7, _) =
                                                                 args0.Coq_Primitive.projT1
                                                               in
                                                               x7))))),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_arrow
                                                              (s3, s2)),
                                                              s1)), s0)))) with
                                                      | Some vars0 ->
                                                        let (a, b) =
                                                          Obj.magic vars0
                                                        in
                                                        let (a0, _) = a in
                                                        let (a1, _) = a0 in
                                                        let (_, b0) = a1 in
                                                        let (_, b1) = b0 in
                                                        let (_, _) = b1 in
                                                        let (a2, _) = b in
                                                        let (a3, _) = a2 in
                                                        let (_, _) = a3 in
                                                        if Compilers.Coq_type.type_beq
                                                             (Compilers.Coq_base.Coq_type.type_beq
                                                               (fun x7 y ->
                                                               match x7 with
                                                               | Coq3_Compilers.Z ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                               | Coq3_Compilers.Coq_string ->
                                                                 (match y with
                                                                  | Coq3_Compilers.Z ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange),
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z))))))
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x7, _) =
                                                                let (
                                                                  x7, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x7
                                                              in
                                                              x7)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x7, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x7
                                                                in
                                                                y
                                                              in
                                                              x7)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((let (x7, _) =
                                                                 let (
                                                                   x7, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x7
                                                               in
                                                               x7),
                                                             (let (x7, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x7
                                                                in
                                                                y
                                                              in
                                                              x7)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x7, _) =
                                                                args1.Coq_Primitive.projT1
                                                              in
                                                              x7))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x7, _) =
                                                                args0.Coq_Primitive.projT1
                                                              in
                                                              x7))))),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             (s3, s2)), s1)),
                                                             s0))))
                                                        then bind1
                                                               (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange),
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange))))))))
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (let (
                                                                    x7, _) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                  in
                                                                  x7)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                    in
                                                                    y
                                                                  in
                                                                  x7)),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((let (
                                                                    x7, _) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                   in
                                                                   x7),
                                                                 (let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                    in
                                                                    y
                                                                  in
                                                                  x7))))))))
                                                                 (Coq3_Compilers.Coq_pattern_ident_pair
                                                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange),
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange)))
                                                                 (Coq3_Compilers.Coq_ident_pair
                                                                 ((let (
                                                                    x7, _) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                   in
                                                                   x7),
                                                                 (let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                    in
                                                                    y
                                                                  in
                                                                  x7))))
                                                               (fun _ ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Coq_zrange))
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                   Coq3_Compilers.Coq_zrange)
                                                                   (Coq3_Compilers.Coq_ident_Literal
                                                                   ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                   (let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                 (fun xv ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                   (fun xv0 ->
                                                                   Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro2 ->
                                                                    match tro2 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v6 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr3 ->
                                                                    match tr3 with
                                                                    | Some v7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v8 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v5
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v6
                                                                    (v2
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v8
                                                                    (v7 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                        else None
                                                      | None -> None)))))))
                                          (sequence
                                            (match x6 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f6, x8) ->
                                                  (match f6 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t4, idc4) ->
                                                     (match x8 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        (match x7 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           (match x5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                s4, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f8,
                                                                   x10) ->
                                                                 (match f8 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s6, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    adc_no_carry_to_add0
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.four_corners
                                                                    Coq_Z.sub
                                                                    (ZRange.four_corners
                                                                    Coq_Z.sub
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15))))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x9))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    Z0 }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v5 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                            (bind1
                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                t3 idc3
                                                Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                              (fun _ ->
                                              bind1
                                                (Obj.magic
                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                  t2 idc2
                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                (fun args0 ->
                                                bind1
                                                  (Obj.magic
                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                    t1 idc1
                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                  (fun args1 ->
                                                  bind1
                                                    (Obj.magic
                                                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                      t0 idc0
                                                      Coq3_Compilers.Coq_raw_ident_pair)
                                                    (fun args2 ->
                                                    match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                            (fun x7 y ->
                                                            match x7 with
                                                            | Coq3_Compilers.Z ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 true
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_bool ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 true
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_nat ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_zrange ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_string ->
                                                                 false)
                                                            | Coq3_Compilers.Coq_string ->
                                                              (match y with
                                                               | Coq3_Compilers.Z ->
                                                                 false
                                                               | Coq3_Compilers.Coq_bool ->
                                                                 false
                                                               | Coq3_Compilers.Coq_nat ->
                                                                 false
                                                               | Coq3_Compilers.Coq_zrange ->
                                                                 false
                                                               | Coq3_Compilers.Coq_string ->
                                                                 true))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange),
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)))))))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x7, _) =
                                                               let (x7, _) =
                                                                 args2.Coq_Primitive.projT2
                                                               in
                                                               x7
                                                             in
                                                             x7)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x7, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x7, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x7
                                                               in
                                                               y
                                                             in
                                                             x7)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x7, _) =
                                                                let (
                                                                  x7, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x7
                                                              in
                                                              x7),
                                                            (let (x7, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x7, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x7
                                                               in
                                                               y
                                                             in
                                                             x7)))))))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            (let (x7, _) =
                                                               args1.Coq_Primitive.projT1
                                                             in
                                                             x7))))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            (let (x7, _) =
                                                               args0.Coq_Primitive.projT1
                                                             in
                                                             x7))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            (s3, s2)), s1)),
                                                            s0)))) with
                                                    | Some vars0 ->
                                                      let (a, b) =
                                                        Obj.magic vars0
                                                      in
                                                      let (a0, _) = a in
                                                      let (a1, _) = a0 in
                                                      let (_, b0) = a1 in
                                                      let (_, b1) = b0 in
                                                      let (_, _) = b1 in
                                                      let (a2, _) = b in
                                                      let (a3, _) = a2 in
                                                      let (_, _) = a3 in
                                                      if Compilers.Coq_type.type_beq
                                                           (Compilers.Coq_base.Coq_type.type_beq
                                                             (fun x7 y ->
                                                             match x7 with
                                                             | Coq3_Compilers.Z ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  true
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_bool ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  true
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_nat ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  true
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  true
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_string ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  true)))
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                                           ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange),
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)))))))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange)))),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z)))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Z))))))
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (let (x7, _) =
                                                              let (x7, _) =
                                                                args2.Coq_Primitive.projT2
                                                              in
                                                              x7
                                                            in
                                                            x7)),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_base
                                                           (let (x7, _) =
                                                              let (_, y) =
                                                                let (
                                                                  x7, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x7
                                                              in
                                                              y
                                                            in
                                                            x7)),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                                           ((let (x7, _) =
                                                               let (x7, _) =
                                                                 args2.Coq_Primitive.projT2
                                                               in
                                                               x7
                                                             in
                                                             x7),
                                                           (let (x7, _) =
                                                              let (_, y) =
                                                                let (
                                                                  x7, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x7
                                                              in
                                                              y
                                                            in
                                                            x7)))))))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           (let (x7, _) =
                                                              args1.Coq_Primitive.projT1
                                                            in
                                                            x7))))),
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           (let (x7, _) =
                                                              args0.Coq_Primitive.projT1
                                                            in
                                                            x7))))),
                                                           (Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           ((Compilers.Coq_type.Coq_arrow
                                                           (s3, s2)), s1)),
                                                           s0))))
                                                      then bind1
                                                             (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange),
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange))))))))
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (let (
                                                                  x7, _) =
                                                                  let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x7
                                                                in
                                                                x7)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (let (
                                                                  x7, _) =
                                                                  let (
                                                                    _, y) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                  in
                                                                  y
                                                                in
                                                                x7)),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_prod
                                                               ((let (
                                                                   x7, _) =
                                                                   let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x7
                                                                 in
                                                                 x7),
                                                               (let (
                                                                  x7, _) =
                                                                  let (
                                                                    _, y) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                  in
                                                                  y
                                                                in
                                                                x7))))))))
                                                               (Coq3_Compilers.Coq_pattern_ident_pair
                                                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange),
                                                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Coq_zrange)))
                                                               (Coq3_Compilers.Coq_ident_pair
                                                               ((let (
                                                                   x7, _) =
                                                                   let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x7
                                                                 in
                                                                 x7),
                                                               (let (
                                                                  x7, _) =
                                                                  let (
                                                                    _, y) =
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x7
                                                                  in
                                                                  y
                                                                in
                                                                x7))))
                                                             (fun _ ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Coq_zrange))
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 (let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                  in
                                                                  x7)))
                                                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                 Coq3_Compilers.Coq_zrange)
                                                                 (Coq3_Compilers.Coq_ident_Literal
                                                                 ((let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x7),
                                                                 (let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                  in
                                                                  x7))))
                                                               (fun xv ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Coq_zrange))
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   (let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                   (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                   Coq3_Compilers.Coq_zrange)
                                                                   (Coq3_Compilers.Coq_ident_Literal
                                                                   ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                   (let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                 (fun xv0 ->
                                                                 Compilers.Coq_type.try_make_transport_cps
                                                                   (fun _ x7 x8 _ ->
                                                                   Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s3
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))
                                                                   (fun tro ->
                                                                   match tro with
                                                                   | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro2 ->
                                                                    match tro2 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v6 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr3 ->
                                                                    match tr3 with
                                                                    | Some v7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v8 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v5
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v6
                                                                    (v2
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v8
                                                                    (v7 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                   | None ->
                                                                    None))))
                                                      else None
                                                    | None -> None))))))
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)), x)),
          x0))))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 adc_no_carry_to_add0 =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None (all_rewrite_rules adc_no_carry_to_add0)

    (** val rewrite_head1 :
        bool -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteArithWithCasts :
        bool ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteArithWithCasts adc_no_carry_to_add0 opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            (arith_with_casts_rewrite_rulesT adc_no_carry_to_add0);
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules adc_no_carry_to_add0));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules adc_no_carry_to_add0));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S
            O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head adc_no_carry_to_add0));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1 adc_no_carry_to_add0)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
        t0 e
   end
 end

module Coq15_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 ->
          if is_bounded_by_bool t1 (ZRange.normalize t0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t1))))))
          else None)) })) :: []

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 ->
          if is_bounded_by_bool t1 (ZRange.normalize t0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t1))))))
          else None)) }; Primitive.snd = (Obj.magic ()) }

    (** val all_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: []) (Obj.magic pr2_rewrite_rules)

    (** val rewrite_head :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (t0, idc0) ->
             (match x0 with
              | Compilers.Coq_expr.Ident (t1, idc1) ->
                bind1
                  (Obj.magic
                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                    t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                  (fun args0 ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args1 ->
                    match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                            (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_zrange)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                    | Some vars0 ->
                      let (_, _) = Obj.magic vars0 in
                      if Compilers.Coq_type.type_beq
                           (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true)))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                      then bind1
                             (Obj.magic
                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Coq_zrange))
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               (let (x1, _) = args1.Coq_Primitive.projT1 in
                                x1)))
                               (Coq3_Compilers.Coq_pattern_ident_Literal
                               Coq3_Compilers.Coq_zrange)
                               (Coq3_Compilers.Coq_ident_Literal
                               ((let (x1, _) = args1.Coq_Primitive.projT1 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) = args1.Coq_Primitive.projT2 in
                                  y
                                in
                                x1)))) (fun xv ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args0.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args0.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv0 ->
                               Compilers.Coq_base.try_make_transport_cps
                                 (fun _ x1 x2 _ ->
                                 Coq3_Compilers.try_make_base_transport_cps
                                   x1 x2)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z) (fun tr ->
                                 match tr with
                                 | Some v ->
                                   Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x1 x2 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x1 x2)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z) (fun tr' ->
                                     match tr' with
                                     | Some v0 ->
                                       bind1
                                         (if is_bounded_by_bool
                                               (let (x1, _) = xv0 in x1)
                                               (ZRange.normalize
                                                 (let (x1, _) = xv in x1))
                                          then Some
                                                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                     Coq3_Compilers.baseHasNat
                                                     Coq3_Compilers.buildIdent
                                                     Coq3_Compilers.buildEagerIdent
                                                     Coq3_Compilers.toRestrictedIdent
                                                     Coq3_Compilers.invertIdent
                                                     Coq3_Compilers.baseHasNatCorrect
                                                     (fun _ x1 x2 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x1 x2)) false
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z))
                                                   (Compilers.Coq_expr.Ident
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Coq3_Compilers.Coq_ident_Literal
                                                   (Coq3_Compilers.Z,
                                                   (let (x1, _) = xv0 in
                                                    Obj.magic x1))))))
                                          else None) (fun fv -> Some
                                         (Coq_Compilers.UnderLets.splice fv
                                           (fun fv0 ->
                                           Coq_Compilers.UnderLets.Base
                                           (v0 (v fv0)))))
                                     | None -> None)
                                 | None -> None)))
                      else None
                    | None -> None))
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, _, _) -> None
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, _, _) -> None
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cast)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 do_again =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None all_rewrite_rules do_again

    (** val rewrite_head1 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteStripLiteralCasts :
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteStripLiteralCasts opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            strip_literal_casts_rewrite_rulesT;
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S O);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S O) t0 e
   end
 end

module Coq16_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x2 x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            t0))))))), (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), x)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            Coq3_Compilers.Coq_ident_tt)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), x0)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            Coq3_Compilers.Coq_ident_tt)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), x1))))))) })) :: []

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_bool_rect,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x2 x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
            t0))))))), (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), x)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            Coq3_Compilers.Coq_ident_tt)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            (Compilers.Coq_type.Coq_base t0))), x0)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit),
            Coq3_Compilers.Coq_ident_tt)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_bool)), x1))))))) }; Primitive.snd =
        (Obj.magic ()) }

    (** val all_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))))),
        (Coq3_Compilers.Coq_pattern_ident_bool_rect
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool))))) } :: []) (Obj.magic pr2_rewrite_rules)

    (** val rewrite_head :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                   (fun x2 y ->
                   match x2 with
                   | Coq3_Compilers.Z ->
                     (match y with
                      | Coq3_Compilers.Z -> true
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_bool ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> true
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_nat ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> true
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_zrange ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> true
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_string ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> true))
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                   XH)))))))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))) (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                   t0))))))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   Compilers.Coq_base.Coq_type.Coq_unit),
                   (Compilers.Coq_type.Coq_base t0))))),
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_bool)))) with
           | Some vars0 ->
             let (a, _) = Obj.magic vars0 in
             let (a0, b) = a in
             let (a1, b0) = a0 in
             let (a2, b1) = a1 in
             let (_, _) = a2 in
             let (a3, b2) = b1 in
             let (_, _) = a3 in
             let (_, _) = b2 in
             let (_, _) = b0 in
             let (_, b3) = b in
             if Compilers.Coq_type.type_beq
                  (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                    match x2 with
                    | Coq3_Compilers.Z ->
                      (match y with
                       | Coq3_Compilers.Z -> true
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_bool ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> true
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_nat ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> true
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_zrange ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> true
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_string ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> true)))
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base b3))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base b3))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                  b3))))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base b3))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base b3))))),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)))) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))),
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                  t0))))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))))),
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit),
                  (Compilers.Coq_type.Coq_base t0))))),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool))))
             then bind1
                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                      XH)))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      Compilers.Coq_pattern.Coq_base.Coq_type.Coq_unit),
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                      XH)))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                      XH)))))))) (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      Compilers.Coq_base.Coq_type.Coq_unit),
                      (Compilers.Coq_type.Coq_base t0))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      Compilers.Coq_base.Coq_type.Coq_unit),
                      (Compilers.Coq_type.Coq_base t0))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
                      t0))))))) (Coq3_Compilers.Coq_pattern_ident_bool_rect
                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))
                      (Coq3_Compilers.Coq_ident_bool_rect t0)) (fun _ ->
                    Compilers.Coq_base.try_make_transport_cps
                      (fun _ x2 x3 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x2 x3)
                      Compilers.Coq_base.Coq_type.Coq_unit
                      Compilers.Coq_base.Coq_type.Coq_unit (fun a4 ->
                      match a4 with
                      | Some x' ->
                        Compilers.Coq_base.try_make_transport_cps
                          (fun _ x2 x3 _ ->
                          Coq3_Compilers.try_make_base_transport_cps x2 x3)
                          t0 b3 (fun a5 ->
                          match a5 with
                          | Some x'0 ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x2 x3 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x2 x3)
                              Compilers.Coq_base.Coq_type.Coq_unit
                              Compilers.Coq_base.Coq_type.Coq_unit (fun a6 ->
                              match a6 with
                              | Some x'1 ->
                                Compilers.Coq_base.try_make_transport_cps
                                  (fun _ x2 x3 _ ->
                                  Coq3_Compilers.try_make_base_transport_cps
                                    x2 x3) t0 b3 (fun a7 ->
                                  match a7 with
                                  | Some x'2 ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x2 x3 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x2 x3)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Coq_bool)
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Coq_bool) (fun tro ->
                                      match tro with
                                      | Some v ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x2 x3 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x2 x3)
                                          Compilers.Coq_base.Coq_type.Coq_unit
                                          Compilers.Coq_base.Coq_type.Coq_unit
                                          (fun a8 ->
                                          match a8 with
                                          | Some x'3 ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x2 x3 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x2 x3) b3 b3 (fun a9 ->
                                              match a9 with
                                              | Some x'4 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x2 x3 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x2 x3)
                                                  Compilers.Coq_base.Coq_type.Coq_unit
                                                  Compilers.Coq_base.Coq_type.Coq_unit
                                                  (fun a10 ->
                                                  match a10 with
                                                  | Some x'5 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x2 x3 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x2 x3) b3 b3
                                                      (fun a11 ->
                                                      match a11 with
                                                      | Some x'6 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x2 x3 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x2 x3)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Coq_bool)
                                                          (fun tr ->
                                                          match tr with
                                                          | Some v0 ->
                                                            Compilers.Coq_base.try_make_transport_cps
                                                              (fun _ x2 x3 _ ->
                                                              Coq3_Compilers.try_make_base_transport_cps
                                                                x2 x3) b3 t0
                                                              (fun tr0 ->
                                                              match tr0 with
                                                              | Some v1 ->
                                                                Compilers.Coq_base.try_make_transport_cps
                                                                  (fun _ x2 x3 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3) t0
                                                                  t0
                                                                  (fun tr' ->
                                                                  match tr' with
                                                                  | Some v2 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x2 x3 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x2 x3))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3)
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))))))),
                                                                    (Coq3_Compilers.Coq_ident_bool_rect_nodep
                                                                    b3))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))),
                                                                    (Obj.magic
                                                                    x'4
                                                                    (x'3
                                                                    (x'0
                                                                    (x' x)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    Coq3_Compilers.Coq_ident_tt)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    b3))),
                                                                    (Obj.magic
                                                                    x'6
                                                                    (x'5
                                                                    (x'2
                                                                    (x'1 x0)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    Coq3_Compilers.Coq_ident_tt)))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    (Obj.magic
                                                                    v0 
                                                                    (v x1)))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv))))
                                                                  | None ->
                                                                    None)
                                                              | None -> None)
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)
                                  | None -> None)
                              | None -> None)
                          | None -> None)
                      | None -> None))
             else None
           | None -> None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0))))))),
          (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
          (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
          t0), (fun x2 ->
          Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
            (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1))))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cast)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 do_again =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None all_rewrite_rules do_again

    (** val rewrite_head1 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteFlattenThunkedRects :
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteFlattenThunkedRects opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            flatten_thunked_rects_rewrite_rulesT;
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S O);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S O) t0 e
   end
 end

module Coq17_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        z -> z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules bitwidth lgcarrymax =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 ->
          if zrange_beq t0 t1
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 x1 ->
          if (&&)
               ((&&)
                 ((&&) (Coq_Z.leb Z0 bitwidth)
                   (zrange_beq t0 { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                 (zrange_beq t1 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t2 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_mul_split)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = (Coq_Z.pow (Zpos (XO XH)) bitwidth);
                     upper = (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (Coq_Z.leb Z0 bitwidth)
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t2 bitwidth))
                   (zrange_beq t3 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x2 x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_mul_split)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = (Coq_Z.pow (Zpos (XO XH)) bitwidth);
                     upper = (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))), (fun v1 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 t4 x1 t5 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (Coq_Z.leb Z0 bitwidth)
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t2 { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                   (Coq_Z.eqb t3 bitwidth))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_mul_split)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = (Coq_Z.pow (Zpos (XO XH)) bitwidth);
                     upper = (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))), (fun v1 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 t6 t7 x1 t8 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&) (Coq_Z.leb Z0 bitwidth)
                                 (Coq_Z.leb (Zpos XH) lgcarrymax))
                               (zrange_beq t0 { lower = Z0; upper =
                                 (Coq_Z.sub
                                   (Coq_Z.pow (Zpos (XO XH))
                                     (Coq_Z.mul (Zpos (XO XH)) bitwidth))
                                   (Zpos XH)) }))
                             (zrange_beq t1 { lower = Z0; upper =
                               (Coq_Z.sub
                                 (Coq_Z.pow (Zpos (XO XH))
                                   (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                                 XH)) })) (Coq_Z.eqb t2 bitwidth))
                         (zrange_beq t3 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t4 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t5 { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                   (Coq_Z.eqb t6 bitwidth))
                 (zrange_beq t7 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t8 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x3 x4 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x3 x4)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = (Coq_Z.pow (Zpos (XO XH)) bitwidth);
                     upper = (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = (Coq_Z.pow (Zpos (XO XH)) bitwidth);
                     upper = (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v0)))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 t4 x1 t5 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.leb Z0 bitwidth)
                           (Coq_Z.leb (Zpos XH) lgcarrymax))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t2 { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                   (Coq_Z.eqb t3 bitwidth))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = (Coq_Z.pow (Zpos (XO XH)) bitwidth);
                     upper = (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.leb Z0 bitwidth)
                           (Coq_Z.leb (Zpos XH) lgcarrymax))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t2 bitwidth))
                   (zrange_beq t3 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x2 x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x2 x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = (Coq_Z.pow (Zpos (XO XH)) bitwidth);
                     upper = (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 ->
          if (&&)
               ((&&)
                 ((&&) ((&&) (Coq_Z.ltb Z0 t3) (Coq_Z.ltb t3 bitwidth))
                   (zrange_beq t0 { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                 (zrange_beq t1 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t2 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t3))))))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub bitwidth t3))))))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x t4 _ t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.ltb Z0 t6)
                           (Coq_Z.ltb t6 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t2 bitwidth))
                   (zrange_beq t3 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t6))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 x t6 _ ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.ltb Z0 t2)
                           (Coq_Z.ltb t2 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t3 { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                   (Coq_Z.eqb t4 bitwidth))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t6 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t2))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) ((&&) (Coq_Z.ltb Z0 t6) (Coq_Z.ltb t6 bitwidth))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t2 bitwidth))
                   (zrange_beq t3 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t6))))))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub bitwidth t6))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) ((&&) (Coq_Z.ltb Z0 t6) (Coq_Z.ltb t6 bitwidth))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t2 bitwidth))
                   (zrange_beq t3 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x1 x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t6))))))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub bitwidth t6))))))))))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t6))))))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 _ t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.ltb Z0 bitwidth)
                           (is_bounded_by_bool bitwidth
                             (ZRange.normalize t5)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t2 bitwidth))
                   (zrange_beq t3 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (Coq_Z.eqb t6 bitwidth)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))
          else None)) })) :: []))))))))))))

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_mul,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S O)),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S O))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_add,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S O)))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S O))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S
        O)))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S
        O))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S O))))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        O)))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S O)))))))))), (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S
        (S (S (S (S (S (S (S (S (S (S O))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S O)))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])))))), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules bitwidth lgcarrymax =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 ->
          if zrange_beq t0 t1
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))
          else None)) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 x1 ->
            if (&&)
                 ((&&)
                   ((&&) (Coq_Z.leb Z0 bitwidth)
                     (zrange_beq t0 { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                   (zrange_beq t1 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t2 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_mul_split)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth); upper =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.leb Z0 bitwidth)
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub
                               (Coq_Z.pow (Zpos (XO XH))
                                 (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                               XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                       (Coq_Z.eqb t2 bitwidth))
                     (zrange_beq t3 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x2 x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x2 x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_mul_split)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth); upper =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))), (fun v1 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 t4 x1 t5 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.leb Z0 bitwidth)
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub
                               (Coq_Z.pow (Zpos (XO XH))
                                 (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                               XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t2 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t3 bitwidth))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_mul_split)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth); upper =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))), (fun v1 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 t6 t7 x1 t8 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&)
                                 ((&&) (Coq_Z.leb Z0 bitwidth)
                                   (Coq_Z.leb (Zpos XH) lgcarrymax))
                                 (zrange_beq t0 { lower = Z0; upper =
                                   (Coq_Z.sub
                                     (Coq_Z.pow (Zpos (XO XH))
                                       (Coq_Z.mul (Zpos (XO XH)) bitwidth))
                                     (Zpos XH)) }))
                               (zrange_beq t1 { lower = Z0; upper =
                                 (Coq_Z.sub
                                   (Coq_Z.pow (Zpos (XO XH))
                                     (Coq_Z.mul (Zpos (XO XH)) bitwidth))
                                   (Zpos XH)) })) (Coq_Z.eqb t2 bitwidth))
                           (zrange_beq t3 { lower = Z0; upper =
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)) }))
                         (zrange_beq t4 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t5 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t6 bitwidth))
                   (zrange_beq t7 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t8 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x3 x4 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x3 x4))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth); upper =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth); upper =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v0)))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 t4 x1 t5 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.leb Z0 bitwidth)
                             (Coq_Z.leb (Zpos XH) lgcarrymax))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub
                               (Coq_Z.pow (Zpos (XO XH))
                                 (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                               XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t2 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t3 bitwidth))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth); upper =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.leb Z0 bitwidth)
                             (Coq_Z.leb (Zpos XH) lgcarrymax))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub
                               (Coq_Z.pow (Zpos (XO XH))
                                 (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                               XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) })) (Coq_Z.eqb t2 bitwidth))
                     (zrange_beq t3 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x2 x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x2 x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth); upper =
                       (Coq_Z.pow (Zpos (XO XH)) bitwidth) }))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), v)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 ->
            if (&&)
                 ((&&)
                   ((&&) ((&&) (Coq_Z.ltb Z0 t3) (Coq_Z.ltb t3 bitwidth))
                     (zrange_beq t0 { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                   (zrange_beq t1 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t2 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t3))))))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub bitwidth t3))))))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x t4 _ t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.ltb Z0 t6)
                             (Coq_Z.ltb t6
                               (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) })) (Coq_Z.eqb t2 bitwidth))
                     (zrange_beq t3 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t6))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 x t6 _ ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.ltb Z0 t2)
                             (Coq_Z.ltb t2
                               (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t3 { lower = Z0; upper =
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))
                     (Coq_Z.eqb t4 bitwidth))
                   (zrange_beq t5 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t6 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x0 x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t2))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.ltb Z0 t6) (Coq_Z.ltb t6 bitwidth))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) })) (Coq_Z.eqb t2 bitwidth))
                     (zrange_beq t3 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x1 x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_lor)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t6))))))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub bitwidth t6))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.ltb Z0 t6) (Coq_Z.ltb t6 bitwidth))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub
                               (Coq_Z.pow (Zpos (XO XH))
                                 (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                               XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) })) (Coq_Z.eqb t2 bitwidth))
                     (zrange_beq t3 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x1 x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x1 x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_lor)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t6))))))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub bitwidth t6))))))))))))))),
                     (fun v -> Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t6))))))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos XH)) }))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic bitwidth))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 _ t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.ltb Z0 bitwidth)
                             (is_bounded_by_bool bitwidth
                               (ZRange.normalize t5)))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub
                             (Coq_Z.pow (Zpos (XO XH))
                               (Coq_Z.mul (Zpos (XO XH)) bitwidth)) (Zpos
                             XH)) })) (Coq_Z.eqb t2 bitwidth))
                     (zrange_beq t3 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) })) (Coq_Z.eqb t6 bitwidth)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))
            else None)) }; Primitive.snd = () } } } } } } } } } } } }) }

    (** val all_rewrite_rules :
        z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules bitwidth lgcarrymax =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_add)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_combine_at_bitwidth)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: [])))))))))))))
        (Obj.magic pr2_rewrite_rules bitwidth lgcarrymax)

    (** val rewrite_head :
        z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head bitwidth lgcarrymax _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (t0, idc0) ->
             (match x0 with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (s0, _, f, x1) ->
                (match f with
                 | Compilers.Coq_expr.Ident (_, _) -> None
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, f0, x2) ->
                   (match f0 with
                    | Compilers.Coq_expr.Ident (t1, idc1) ->
                      sequence
                        (match x2 with
                         | Compilers.Coq_expr.Ident (t2, idc2) ->
                           bind1
                             (Obj.magic
                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                               t2 idc2 Coq3_Compilers.Coq_raw_ident_Literal)
                             (fun args0 ->
                             bind1
                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t1 idc1 Coq3_Compilers.Coq_raw_ident_Z_cast)
                               (fun _ ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t0 idc0
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args1 ->
                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                         (fun x3 y ->
                                         match x3 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Coq_zrange)),
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Coq_zrange)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x3, _) =
                                            args1.Coq_Primitive.projT1
                                          in
                                          x3))),
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x3, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x3))), s0)))) with
                                 | Some vars0 ->
                                   let (_, b) = Obj.magic vars0 in
                                   let (_, _) = b in
                                   if Compilers.Coq_type.type_beq
                                        (Compilers.Coq_base.Coq_type.type_beq
                                          (fun x3 y ->
                                          match x3 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true)))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_zrange)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_zrange)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args1.Coq_Primitive.projT1
                                         in
                                         x3))), (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x3, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x3))), s0))))
                                   then bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_zrange))
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x3, _) =
                                               args1.Coq_Primitive.projT1
                                             in
                                             x3)))
                                            (Coq3_Compilers.Coq_pattern_ident_Literal
                                            Coq3_Compilers.Coq_zrange)
                                            (Coq3_Compilers.Coq_ident_Literal
                                            ((let (x3, _) =
                                                args1.Coq_Primitive.projT1
                                              in
                                              x3),
                                            (let (x3, _) =
                                               let (_, y) =
                                                 args1.Coq_Primitive.projT2
                                               in
                                               y
                                             in
                                             x3)))) (fun xv ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_zrange))
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              (let (x3, _) =
                                                 args0.Coq_Primitive.projT1
                                               in
                                               x3)))
                                              (Coq3_Compilers.Coq_pattern_ident_Literal
                                              Coq3_Compilers.Coq_zrange)
                                              (Coq3_Compilers.Coq_ident_Literal
                                              ((let (x3, _) =
                                                  args0.Coq_Primitive.projT1
                                                in
                                                x3),
                                              (let (x3, _) =
                                                 let (_, y) =
                                                   args0.Coq_Primitive.projT2
                                                 in
                                                 y
                                               in
                                               x3)))) (fun xv0 ->
                                            Compilers.Coq_type.try_make_transport_cps
                                              (fun _ x3 x4 _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x5 x6 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x5 x6) x3 x4) s0
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)) (fun tro ->
                                              match tro with
                                              | Some v ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x3 x4 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x3 x4)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)
                                                  (fun tr ->
                                                  match tr with
                                                  | Some v0 ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x3 x4 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x3 x4)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)
                                                      (fun tr0 ->
                                                      match tr0 with
                                                      | Some v1 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x3 x4 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x3 x4)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v2 ->
                                                            bind1
                                                              (if zrange_beq
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv
                                                                    in
                                                                    x3)
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    x3)
                                                               then Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x3 x4 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x3 x4))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x3, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))
                                                               else None)
                                                              (fun fv -> Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                fv
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 (v1 fv0)))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None)))
                                   else None
                                 | None -> None)))
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, _, _) -> None
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                        (sequence
                          (match x2 with
                           | Compilers.Coq_expr.Ident (_, _) -> None
                           | Compilers.Coq_expr.Var (_, _) -> None
                           | Compilers.Coq_expr.Abs (_, _, _) -> None
                           | Compilers.Coq_expr.App (s1, _, f1, x3) ->
                             (match f1 with
                              | Compilers.Coq_expr.Ident (_, _) -> None
                              | Compilers.Coq_expr.Var (_, _) -> None
                              | Compilers.Coq_expr.Abs (_, _, _) -> None
                              | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                (match f2 with
                                 | Compilers.Coq_expr.Ident (t2, idc2) ->
                                   (match x4 with
                                    | Compilers.Coq_expr.Ident (t3, idc3) ->
                                      (match x1 with
                                       | Compilers.Coq_expr.Ident (_, _) ->
                                         None
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         None
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         None
                                       | Compilers.Coq_expr.App (s2, _, f3,
                                                                 x5) ->
                                         (match f3 with
                                          | Compilers.Coq_expr.Ident (
                                              _, _) ->
                                            None
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, f4,
                                                                    x6) ->
                                            (match f4 with
                                             | Compilers.Coq_expr.Ident (
                                                 t4, idc4) ->
                                               (match x6 with
                                                | Compilers.Coq_expr.Ident (
                                                    t5, idc5) ->
                                                  sequence
                                                    (bind1
                                                      (Obj.magic
                                                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                        t5 idc5
                                                        Coq3_Compilers.Coq_raw_ident_Literal)
                                                      (fun args0 ->
                                                      bind1
                                                        (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                          t4 idc4
                                                          Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                        (fun _ ->
                                                        bind1
                                                          (Obj.magic
                                                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                            t3 idc3
                                                            Coq3_Compilers.Coq_raw_ident_Literal)
                                                          (fun args1 ->
                                                          bind1
                                                            (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                              t2 idc2
                                                              Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                            (fun _ ->
                                                            bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                t1 idc1
                                                                Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                  t0 idc0
                                                                  Coq3_Compilers.Coq_raw_ident_Literal)
                                                                (fun args2 ->
                                                                match 
                                                                Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                  (fun x7 y ->
                                                                  match x7 with
                                                                  | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                  | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_zrange)),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_zrange)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_zrange)),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))))))))
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                   in
                                                                   x7))),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x7))),
                                                                  s1)),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                   in
                                                                   x7))),
                                                                  s2)))))) with
                                                                | Some vars0 ->
                                                                  let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                  in
                                                                  let (
                                                                    a, b0) =
                                                                    b
                                                                  in
                                                                  let (
                                                                    _, _) = a
                                                                  in
                                                                  let (
                                                                    _, _) =
                                                                    b0
                                                                  in
                                                                  if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s2))))))
                                                                  then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    bitwidth)
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul_split)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth);
                                                                    upper =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x3))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v5)))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))
                                                                  else None
                                                                | None ->
                                                                  None)))))))
                                                    (sequence
                                                      (match x3 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, f5, x7) ->
                                                         (match f5 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, f6, x8) ->
                                                            (match f6 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f7, x9) ->
                                                               (match f7 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                  (match x9 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    bitwidth)
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul_split)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth);
                                                                    upper =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x12))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                      (match x5 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, f5, x7) ->
                                                         (match f5 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, f6, x8) ->
                                                            (match f6 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f7, x9) ->
                                                               (match f7 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                  (match x9 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    bitwidth)
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul_split)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth);
                                                                    upper =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x3))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x10))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x3))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x12))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None))
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         None)
                                    | Compilers.Coq_expr.Var (_, _) -> None
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      None
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      None
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      None)
                                 | Compilers.Coq_expr.Var (_, _) -> None
                                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                                 | Compilers.Coq_expr.App (_, _, _, _) ->
                                   None
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   None)
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          (sequence
                            (match x2 with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (s1, _, f1, x3) ->
                               (match f1 with
                                | Compilers.Coq_expr.Ident (_, _) -> None
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                  (match f2 with
                                   | Compilers.Coq_expr.Ident (t2, idc2) ->
                                     (match x4 with
                                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                                        sequence
                                          (match x3 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, f3, x5) ->
                                             (match f3 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f4, x6) ->
                                                (match f4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, f5, x7) ->
                                                   (match f5 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t4, idc4) ->
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t5, idc5) ->
                                                         (match x6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              s2, _, f6, x8) ->
                                                            (match f6 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f7, x9) ->
                                                               (match f7 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                  (match x9 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x5 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s2)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s5)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b6) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s2)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s5))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro2 ->
                                                                    match tro2 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v6 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr3 ->
                                                                    match tr3 with
                                                                    | Some v7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v8 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    bitwidth)
                                                                    (Coq_Z.leb
                                                                    (Zpos XH)
                                                                    lgcarrymax))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv
                                                                    in
                                                                    x21)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv0
                                                                    in
                                                                    x21)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv1
                                                                    in
                                                                    x21)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv3
                                                                    in
                                                                    x21)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv4
                                                                    in
                                                                    x21)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv5
                                                                    in
                                                                    x21)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv6
                                                                    in
                                                                    x21)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv7
                                                                    in
                                                                    x21)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth);
                                                                    upper =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v5
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x17))))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth);
                                                                    upper =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v6
                                                                    (v2
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x19))))))))))),
                                                                    (fun v10 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v9)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v10)))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v8
                                                                    (v7 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                          (match x1 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               s2, _, f3, x5) ->
                                             (match f3 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f4, x6) ->
                                                (match f4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t4, idc4) ->
                                                   (match x6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      sequence
                                                        (match x5 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, f5, x7) ->
                                                           (match f5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f6, x8) ->
                                                              (match f6 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f7,
                                                                   x9) ->
                                                                 (match f7 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    bitwidth)
                                                                    (Coq_Z.leb
                                                                    (Zpos XH)
                                                                    lgcarrymax))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth);
                                                                    upper =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x3))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x10))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x12))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                        (match x3 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, f5, x7) ->
                                                           (match f5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f6, x8) ->
                                                              (match f6 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f7,
                                                                   x9) ->
                                                                 (match f7 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s4)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    bitwidth)
                                                                    (Coq_Z.leb
                                                                    (Zpos XH)
                                                                    lgcarrymax))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth);
                                                                    upper =
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_snd
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x12))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Coq3_Compilers.Coq_ident_fst
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    v7)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, _, _) ->
                                     None
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                            (sequence
                              (match x2 with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (s1, _, f1, x3) ->
                                 (match f1 with
                                  | Compilers.Coq_expr.Ident (_, _) -> None
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                    (match f2 with
                                     | Compilers.Coq_expr.Ident (t2, idc2) ->
                                       (match x4 with
                                        | Compilers.Coq_expr.Ident (t3, idc3) ->
                                          (match x1 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, f3, x5) ->
                                             (match f3 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f4, x6) ->
                                                (match f4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t4, idc4) ->
                                                   (match x6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      (match x5 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t6, idc6) ->
                                                         bind1
                                                           (Obj.magic
                                                             Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                             t6 idc6
                                                             Coq3_Compilers.Coq_raw_ident_Literal)
                                                           (fun args0 ->
                                                           bind1
                                                             (Obj.magic
                                                               Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                               t5 idc5
                                                               Coq3_Compilers.Coq_raw_ident_Literal)
                                                             (fun args1 ->
                                                             bind1
                                                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t4 idc4
                                                                 Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                               (fun _ ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t3 idc3
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args2 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x7 y ->
                                                                    match x7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    x7 x8) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x7, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x7),
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x7))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv
                                                                    in
                                                                    x7)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv0
                                                                    in
                                                                    x7)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv1
                                                                    in
                                                                    x7)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x7 x8 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x3))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x7))))))))))),
                                                                    (fun v3 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x3))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    bitwidth
                                                                    (
                                                                    let (
                                                                    x7, _) =
                                                                    xv2
                                                                    in
                                                                    x7)))))))))))),
                                                                    (fun v4 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v3)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v4)))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, _, _) ->
                                          None
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                              (sequence
                                (match x2 with
                                 | Compilers.Coq_expr.Ident (_, _) -> None
                                 | Compilers.Coq_expr.Var (_, _) -> None
                                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                                 | Compilers.Coq_expr.App (_, _, f1, x3) ->
                                   (match f1 with
                                    | Compilers.Coq_expr.Ident (_, _) -> None
                                    | Compilers.Coq_expr.Var (_, _) -> None
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      None
                                    | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (t2, idc2) ->
                                         (match x4 with
                                          | Compilers.Coq_expr.Ident (
                                              t3, idc3) ->
                                            (match x3 with
                                             | Compilers.Coq_expr.Ident (
                                                 t4, idc4) ->
                                               (match x1 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f3, x5) ->
                                                  (match f3 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f4, x6) ->
                                                     (match f4 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        (match x6 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           (match x5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f5, x7) ->
                                                              (match f5 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f6,
                                                                   x8) ->
                                                                 (match f6 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, f7,
                                                                    x9) ->
                                                                    (match f7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f10, _) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x12) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x10))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f3, x5) ->
                                               (match f3 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f4, x6) ->
                                                  (match f4 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f5, x7) ->
                                                     (match f5 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t4, idc4) ->
                                                        (match x7 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t5, idc5) ->
                                                           (match x6 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                s1, _, f6, x8) ->
                                                              (match f6 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f7,
                                                                   x9) ->
                                                                 (match f7 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x5 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f8, _) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x10) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x11) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x12) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, _,
                                                                    _) ->
                                            None
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         None
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         None
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         None
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         None)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      None)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   None)
                                (match x2 with
                                 | Compilers.Coq_expr.Ident (_, _) -> None
                                 | Compilers.Coq_expr.Var (_, _) -> None
                                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                                 | Compilers.Coq_expr.App (_, _, f1, x3) ->
                                   (match f1 with
                                    | Compilers.Coq_expr.Ident (_, _) -> None
                                    | Compilers.Coq_expr.Var (_, _) -> None
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      None
                                    | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (t2, idc2) ->
                                         (match x4 with
                                          | Compilers.Coq_expr.Ident (
                                              t3, idc3) ->
                                            (match x3 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f3, x5) ->
                                               (match f3 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f4, x6) ->
                                                  (match f4 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f5, x7) ->
                                                     (match f5 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t4, idc4) ->
                                                        (match x7 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t5, idc5) ->
                                                           (match x6 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                s1, _, f6, x8) ->
                                                              (match f6 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f7,
                                                                   x9) ->
                                                                 (match f7 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x5 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    x14))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_lor)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    bitwidth
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    x14)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    (sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    x14))
                                                                    (Coq_Z.ltb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_lor)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_truncating_shiftl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    bitwidth
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    x14)))))))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x14))))))))))),
                                                                    (fun v6 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    bitwidth))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v6)))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_combine_at_bitwidth)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x14 y ->
                                                                    match x14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    s2)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    x14 x15)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x14, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x14),
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x14))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    bitwidth)
                                                                    (is_bounded_by_bool
                                                                    bitwidth
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv4
                                                                    in
                                                                    x14))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv0
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv1
                                                                    in
                                                                    x14)
                                                                    bitwidth))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv2
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv3
                                                                    in
                                                                    x14)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x14, _) =
                                                                    xv5
                                                                    in
                                                                    x14)
                                                                    bitwidth)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x10))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, _,
                                                                    _) ->
                                            None
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         None
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         None
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         None
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         None)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      None)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   None)))))
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, _, _) -> None
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cast)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 bitwidth lgcarrymax =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None (all_rewrite_rules bitwidth lgcarrymax)

    (** val rewrite_head1 :
        z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteMulSplit :
        z -> z ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteMulSplit bitwidth lgcarrymax opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            (mul_split_rewrite_rulesT bitwidth lgcarrymax);
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules bitwidth lgcarrymax));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules bitwidth lgcarrymax));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S (S
            (S (S (S (S (S (S (S (S (S (S O)))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head bitwidth lgcarrymax));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1 bitwidth lgcarrymax)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))) t0 e
   end
 end

module Coq18_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        z -> z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules bitwidth lgcarrymax =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) true
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 _ x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)) true
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x1))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
               (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
               (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 x2 t2 t3 ->
          if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
               (Coq_Z.eqb t3 Z0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun _ t0 _ x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0)) false
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x1))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 ->
          if (&&)
               ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                 (is_bounded_by_bool t1
                   (ZRange.normalize { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })))
               (negb
                 (zrange_beq t0 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x0)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t1))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.leb Z0 lgcarrymax)
                           (Coq_Z.leb lgcarrymax bitwidth))
                         (is_bounded_by_bool
                           (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                           (ZRange.normalize t2)))
                       (zrange_beq t0 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t1 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.leb Z0 lgcarrymax)
                             (Coq_Z.leb lgcarrymax bitwidth))
                           (is_bounded_by_bool
                             (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (ZRange.normalize t2)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                           (Zpos XH)) }))
                     (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t6 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v1 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v2 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v3)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.leb Z0 lgcarrymax)
                           (Coq_Z.leb lgcarrymax bitwidth))
                         (is_bounded_by_bool
                           (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                           (ZRange.normalize t2)))
                       (zrange_beq t0 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t1 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.leb Z0 lgcarrymax)
                             (Coq_Z.leb lgcarrymax bitwidth))
                           (is_bounded_by_bool
                             (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (ZRange.normalize t2)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                           (Zpos XH)) }))
                     (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t6 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))), (fun v1 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))))), (fun v2 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v3)))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.leb Z0 lgcarrymax)
                           (Coq_Z.leb lgcarrymax bitwidth))
                         (is_bounded_by_bool
                           (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                           (ZRange.normalize t2)))
                       (zrange_beq t0 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t1 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_mul_high)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&) (Coq_Z.leb Z0 lgcarrymax)
                               (Coq_Z.leb lgcarrymax bitwidth))
                             (Coq_Z.eqb t3
                               (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                           ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                             (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                         (Coq_Z.ltb bitwidth
                           (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                       (is_bounded_by_bool t3 (ZRange.normalize t2)))
                     (zrange_beq t0 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t1 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v1 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))))),
                   (fun v2 -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v2)))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&) (Coq_Z.leb Z0 lgcarrymax)
                                 (Coq_Z.leb lgcarrymax bitwidth))
                               (Coq_Z.eqb t3
                                 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                             ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                               (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                           (Coq_Z.ltb (Coq_Z.add bitwidth (Zpos XH))
                             (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                         (is_bounded_by_bool t3 (ZRange.normalize t2)))
                       (zrange_beq t0 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t1 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t6 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v1 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v2 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v4 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v3)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))))),
                   (fun v5 -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v4)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v5)))))))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&) (Coq_Z.leb Z0 lgcarrymax)
                               (Coq_Z.leb lgcarrymax bitwidth))
                             (Coq_Z.eqb t3
                               (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                           ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                             (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                         (Coq_Z.ltb bitwidth
                           (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                       (is_bounded_by_bool t3 (ZRange.normalize t2)))
                     (zrange_beq t0 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t1 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t5 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v1 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.log2 t3))))))))))))))), (fun v2 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v2)))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&) (Coq_Z.leb Z0 lgcarrymax)
                                 (Coq_Z.leb lgcarrymax bitwidth))
                               (Coq_Z.eqb t3
                                 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                             ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                               (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                           (Coq_Z.ltb bitwidth
                             (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                         (is_bounded_by_bool t3 (ZRange.normalize t2)))
                       (zrange_beq t0 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t1 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t6 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (fun v ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))), (fun v1 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_ltz)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))))), (fun v2 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v4 ->
                   Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v3)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_Z_shiftr)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.log2 t3))))))))))))))), (fun v5 ->
                   Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v4)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v5)))))))))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x2)) true
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 x1 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&) (Coq_Z.eqb t0.lower Z0)
                           (Coq_Z.eqb t1.lower Z0))
                         (Coq_Z.leb Z0
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)))) (Coq_Z.leb Z0 t0.upper))
                     (Coq_Z.leb Z0 t1.upper))
                   (Coq1_Z.divideb (Coq_Z.add t0.upper (Zpos XH))
                     (Coq_Z.add
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) (Zpos XH))))
                 (Coq1_Z.divideb (Coq_Z.add t1.upper (Zpos XH))
                   (Coq_Z.add
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) (Zpos XH))))
               ((||)
                 (negb
                   (Coq_Z.eqb t0.upper
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH))))
                 (negb
                   (Coq_Z.eqb t1.upper
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)))))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) true
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_mul_split)),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))
          else None)) })) :: []))))))))))))))))))

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_fst,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S O))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_snd,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S
        O)))))), Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast2,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        O)))))))), (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S
        (S (S (S (S (S (S (S (S (S O))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S O)))))))))), (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_mul_split,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S O)))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []))), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S O)),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S O))))))))), (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S
        (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S O))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S (S O))),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S O)))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S O))))))))))), (Coq1_Compilers.RewriteRules.Compile.TryLeaf
        ((S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S
        O))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules bitwidth lgcarrymax =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 _ x0 _ -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) true
            (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x0))))) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 _ x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x0)) true
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x1))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 t3 x1 x2 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 x2 t2 t3 ->
            if (&&) (is_bounded_by_bool Z0 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 Z0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 _ x0 _ -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x1)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x0))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun _ t0 _ x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x0)) false
              (Compilers.Coq_type.Coq_base t0) (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base t0), x1))))) }; Primitive.snd =
          { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t1 (ZRange.normalize t0))
                   (is_bounded_by_bool t1
                     (ZRange.normalize { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) })))
                 (negb
                   (zrange_beq t0 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x0 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x0))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t1))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.leb Z0 lgcarrymax)
                             (Coq_Z.leb lgcarrymax bitwidth))
                           (is_bounded_by_bool
                             (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (ZRange.normalize t2)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                           (Zpos XH)) }))
                     (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&) (Coq_Z.leb Z0 lgcarrymax)
                               (Coq_Z.leb lgcarrymax bitwidth))
                             (is_bounded_by_bool
                               (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (ZRange.normalize t2)))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                             (Zpos XH)) }))
                       (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                     (zrange_beq t4 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t5 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t6 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v1 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v2 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v3)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.leb Z0 lgcarrymax)
                             (Coq_Z.leb lgcarrymax bitwidth))
                           (is_bounded_by_bool
                             (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (ZRange.normalize t2)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                           (Zpos XH)) }))
                     (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&) (Coq_Z.leb Z0 lgcarrymax)
                               (Coq_Z.leb lgcarrymax bitwidth))
                             (is_bounded_by_bool
                               (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (ZRange.normalize t2)))
                           (zrange_beq t0 { lower = Z0; upper =
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)) }))
                         (zrange_beq t1 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                             (Zpos XH)) }))
                       (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                     (zrange_beq t4 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t5 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t6 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))), (fun v1 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))))), (fun v2 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v3)))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.leb Z0 lgcarrymax)
                             (Coq_Z.leb lgcarrymax bitwidth))
                           (is_bounded_by_bool
                             (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (ZRange.normalize t2)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) bitwidth)))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_mul)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_mul_high)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.pow (Zpos (XO XH)) bitwidth))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&) (Coq_Z.leb Z0 lgcarrymax)
                                 (Coq_Z.leb lgcarrymax bitwidth))
                               (Coq_Z.eqb t3
                                 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                             ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                               (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                           (Coq_Z.ltb bitwidth
                             (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                         (is_bounded_by_bool t3 (ZRange.normalize t2)))
                       (zrange_beq t0 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t1 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v1 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.log2 t3))))))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))))),
                     (fun v2 -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v2)))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&)
                                 ((&&) (Coq_Z.leb Z0 lgcarrymax)
                                   (Coq_Z.leb lgcarrymax bitwidth))
                                 (Coq_Z.eqb t3
                                   (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                               ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                                 (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                             (Coq_Z.ltb (Coq_Z.add bitwidth (Zpos XH))
                               (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                           (is_bounded_by_bool t3 (ZRange.normalize t2)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                           (Zpos XH)) }))
                     (zrange_beq t4 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t5 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t6 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v1 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v2 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v4 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.log2 t3))))))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v3)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))))),
                     (fun v5 -> Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v4)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v5)))))))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&) (Coq_Z.leb Z0 lgcarrymax)
                                 (Coq_Z.leb lgcarrymax bitwidth))
                               (Coq_Z.eqb t3
                                 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                             ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                               (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                           (Coq_Z.ltb bitwidth
                             (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                         (is_bounded_by_bool t3 (ZRange.normalize t2)))
                       (zrange_beq t0 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) }))
                     (zrange_beq t1 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t4 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t5 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v1 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.log2 t3))))))))))))))), (fun v2 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v2)))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               ((&&)
                                 ((&&) (Coq_Z.leb Z0 lgcarrymax)
                                   (Coq_Z.leb lgcarrymax bitwidth))
                                 (Coq_Z.eqb t3
                                   (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                               ((&&) (Coq_Z.ltb Z0 (Coq_Z.log2 t3))
                                 (Coq_Z.ltb (Coq_Z.log2 t3) bitwidth)))
                             (Coq_Z.ltb bitwidth
                               (Coq_Z.add (Coq_Z.log2 t3) lgcarrymax)))
                           (is_bounded_by_bool t3 (ZRange.normalize t2)))
                         (zrange_beq t0 { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                             (Zpos XH)) }))
                       (zrange_beq t1 { lower = Z0; upper =
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax)
                           (Zpos XH)) }))
                     (zrange_beq t4 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))
                   (zrange_beq t5 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                       XH)) }))
                 (zrange_beq t6 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))))), (fun v0 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))), (fun v1 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_ltz)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))))), (fun v2 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v2)))))))), (fun v3 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub t3 (Zpos XH)))))))))))), (fun v4 ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v3)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub bitwidth (Coq_Z.log2 t3)))))))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_shiftr)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.log2 t3))))))))))))))), (fun v5 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v4)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) lgcarrymax) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v5)))))))))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x2)) true
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t1)))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = true;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 x1 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&) (Coq_Z.eqb t0.lower Z0)
                             (Coq_Z.eqb t1.lower Z0))
                           (Coq_Z.leb Z0
                             (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                               (Zpos XH)))) (Coq_Z.leb Z0 t0.upper))
                       (Coq_Z.leb Z0 t1.upper))
                     (Coq1_Z.divideb (Coq_Z.add t0.upper (Zpos XH))
                       (Coq_Z.add
                         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                           XH)) (Zpos XH))))
                   (Coq1_Z.divideb (Coq_Z.add t1.upper (Zpos XH))
                     (Coq_Z.add
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) (Zpos XH))))
                 ((||)
                   (negb
                     (Coq_Z.eqb t0.upper
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH))))
                   (negb
                     (Coq_Z.eqb t1.upper
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)))))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3)) true
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t1))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_mul_split)),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))
            else None)) }; Primitive.snd =
          () } } } } } } } } } } } } } } } } } }) }

    (** val all_rewrite_rules :
        z -> z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules bitwidth lgcarrymax =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)))),
        (Coq3_Compilers.Coq_pattern_ident_fst
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq3_Compilers.Coq_pattern_ident_snd
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH))))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO XH)))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var XH))))),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var (XO
        XH)))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_mul_split)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: [])))))))))))))))))))
        (Obj.magic pr2_rewrite_rules bitwidth lgcarrymax)

    (** val rewrite_head :
        z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head bitwidth lgcarrymax do_again _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (s0, _, f, _) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s1, _, f0, x0) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t2, idc0) ->
                     sequence
                       (bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                         (fun args0 ->
                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                 (fun x1 y ->
                                 match x1 with
                                 | Coq3_Compilers.Z ->
                                   (match y with
                                    | Coq3_Compilers.Z -> true
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_bool ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> true
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_nat ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> true
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_zrange ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> true
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_string ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> true))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH),
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))))), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH)))), (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH)), (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH),
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))))))))),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH)))), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                 t1))), (Compilers.Coq_type.Coq_base t0))),
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (let (x1, _) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  x1)), (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (let (x1, _) =
                                    let (_, y) =
                                      let (x1, _) = args0.Coq_Primitive.projT2
                                      in
                                      x1
                                    in
                                    y
                                  in
                                  x1)), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                 ((let (x1, _) =
                                     let (x1, _) = args0.Coq_Primitive.projT2
                                     in
                                     x1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) =
                                      let (x1, _) = args0.Coq_Primitive.projT2
                                      in
                                      x1
                                    in
                                    y
                                  in
                                  x1)))))))), s1)), s0)))) with
                         | Some vars0 ->
                           let (a, b) = Obj.magic vars0 in
                           let (a0, _) = a in
                           let (_, _) = a0 in
                           let (a1, b0) = b in
                           let (a2, b1) = a1 in
                           let (_, b2) = a2 in
                           let (_, b3) = b2 in
                           let (_, _) = b3 in
                           if Compilers.Coq_type.type_beq
                                (Compilers.Coq_base.Coq_type.type_beq
                                  (fun x1 y ->
                                  match x1 with
                                  | Coq3_Compilers.Z ->
                                    (match y with
                                     | Coq3_Compilers.Z -> true
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_bool ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> true
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_nat ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> true
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_zrange ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> true
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_string ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> true)))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                                b0))), (Compilers.Coq_type.Coq_base b1))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base b1),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base b0),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                                b0))))))), (Compilers.Coq_type.Coq_base
                                b1))), (Compilers.Coq_type.Coq_base b0)))))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                t1))), (Compilers.Coq_type.Coq_base t0))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1)), (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (let (x1, _) =
                                   let (_, y) =
                                     let (x1, _) = args0.Coq_Primitive.projT2
                                     in
                                     x1
                                   in
                                   y
                                 in
                                 x1)), (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod
                                ((let (x1, _) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  x1),
                                (let (x1, _) =
                                   let (_, y) =
                                     let (x1, _) = args0.Coq_Primitive.projT2
                                     in
                                     x1
                                   in
                                   y
                                 in
                                 x1)))))))), s1)), s0))))
                           then bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)))) (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    (t0, t1))), (Compilers.Coq_type.Coq_base
                                    t0)))
                                    (Coq3_Compilers.Coq_pattern_ident_fst
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_fst
                                    (t0, t1))) (fun _ ->
                                  bind1
                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      XH)), (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      (XO XH))), (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      XH),
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      (XO XH)))))))))
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (let (x1, _) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       x1)), (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (let (x1, _) =
                                         let (_, y) =
                                           let (x1, _) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           x1
                                         in
                                         y
                                       in
                                       x1)), (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                      ((let (x1, _) =
                                          let (x1, _) =
                                            args0.Coq_Primitive.projT2
                                          in
                                          x1
                                        in
                                        x1),
                                      (let (x1, _) =
                                         let (_, y) =
                                           let (x1, _) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           x1
                                         in
                                         y
                                       in
                                       x1))))))))
                                      (Coq3_Compilers.Coq_pattern_ident_pair
                                      ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      XH),
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      (XO XH))))
                                      (Coq3_Compilers.Coq_ident_pair
                                      ((let (x1, _) =
                                          let (x1, _) =
                                            args0.Coq_Primitive.projT2
                                          in
                                          x1
                                        in
                                        x1),
                                      (let (x1, _) =
                                         let (_, y) =
                                           let (x1, _) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           x1
                                         in
                                         y
                                       in
                                       x1)))) (fun _ ->
                                    Compilers.Coq_type.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x3 x4 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x3 x4) x1 x2) s1
                                      (Compilers.Coq_type.Coq_base b1)
                                      (fun tro ->
                                      match tro with
                                      | Some v ->
                                        Compilers.Coq_type.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x3 x4 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x3 x4) x1 x2) s0
                                          (Compilers.Coq_type.Coq_base b0)
                                          (fun tro0 ->
                                          match tro0 with
                                          | Some _ ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2) b1 b1 (fun tr ->
                                              match tr with
                                              | Some v0 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2) b0 b0 (fun tr0 ->
                                                  match tr0 with
                                                  | Some _ ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2) b1 t0
                                                      (fun tr1 ->
                                                      match tr1 with
                                                      | Some v1 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2) t0 t0
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v2 ->
                                                            Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                  true
                                                                  (Compilers.Coq_type.Coq_base
                                                                  b1)
                                                                  (Compilers.Coq_expr.Var
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  b1),
                                                                  (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x0))))))
                                                                (fun fv ->
                                                                Coq_Compilers.UnderLets.splice
                                                                  (Obj.magic
                                                                    do_again
                                                                    t0
                                                                    (v1 fv))
                                                                  (fun fv0 ->
                                                                  Coq_Compilers.UnderLets.Base
                                                                  (v2 fv0))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)))
                           else None
                         | None -> None))
                       (bind1
                         (Obj.magic
                           Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                           t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                         (fun args0 ->
                         match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                 (fun x1 y ->
                                 match x1 with
                                 | Coq3_Compilers.Z ->
                                   (match y with
                                    | Coq3_Compilers.Z -> true
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_bool ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> true
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_nat ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> true
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_zrange ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> true
                                    | Coq3_Compilers.Coq_string -> false)
                                 | Coq3_Compilers.Coq_string ->
                                   (match y with
                                    | Coq3_Compilers.Z -> false
                                    | Coq3_Compilers.Coq_bool -> false
                                    | Coq3_Compilers.Coq_nat -> false
                                    | Coq3_Compilers.Coq_zrange -> false
                                    | Coq3_Compilers.Coq_string -> true))
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH),
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))))), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH)))), (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH)), (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                 ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH),
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))))))))),
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 XH)))), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                 (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                 t1))), (Compilers.Coq_type.Coq_base t0))),
                                 (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (let (x1, _) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  x1)), (Compilers.Coq_type.Coq_arrow
                                 ((Compilers.Coq_type.Coq_base
                                 (let (x1, _) =
                                    let (_, y) =
                                      let (x1, _) = args0.Coq_Primitive.projT2
                                      in
                                      x1
                                    in
                                    y
                                  in
                                  x1)), (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                 ((let (x1, _) =
                                     let (x1, _) = args0.Coq_Primitive.projT2
                                     in
                                     x1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) =
                                      let (x1, _) = args0.Coq_Primitive.projT2
                                      in
                                      x1
                                    in
                                    y
                                  in
                                  x1)))))))), s1)), s0)))) with
                         | Some vars0 ->
                           let (a, b) = Obj.magic vars0 in
                           let (a0, _) = a in
                           let (_, _) = a0 in
                           let (a1, b0) = b in
                           let (a2, b1) = a1 in
                           let (_, b2) = a2 in
                           let (_, b3) = b2 in
                           let (_, _) = b3 in
                           if Compilers.Coq_type.type_beq
                                (Compilers.Coq_base.Coq_type.type_beq
                                  (fun x1 y ->
                                  match x1 with
                                  | Coq3_Compilers.Z ->
                                    (match y with
                                     | Coq3_Compilers.Z -> true
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_bool ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> true
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_nat ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> true
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_zrange ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> true
                                     | Coq3_Compilers.Coq_string -> false)
                                  | Coq3_Compilers.Coq_string ->
                                    (match y with
                                     | Coq3_Compilers.Z -> false
                                     | Coq3_Compilers.Coq_bool -> false
                                     | Coq3_Compilers.Coq_nat -> false
                                     | Coq3_Compilers.Coq_zrange -> false
                                     | Coq3_Compilers.Coq_string -> true)))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                                b0))), (Compilers.Coq_type.Coq_base b1))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base b1),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base b0),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                                b0))))))), (Compilers.Coq_type.Coq_base
                                b1))), (Compilers.Coq_type.Coq_base b0)))))
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                t1))), (Compilers.Coq_type.Coq_base t0))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1)), (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (let (x1, _) =
                                   let (_, y) =
                                     let (x1, _) = args0.Coq_Primitive.projT2
                                     in
                                     x1
                                   in
                                   y
                                 in
                                 x1)), (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod
                                ((let (x1, _) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  x1),
                                (let (x1, _) =
                                   let (_, y) =
                                     let (x1, _) = args0.Coq_Primitive.projT2
                                     in
                                     x1
                                   in
                                   y
                                 in
                                 x1)))))))), s1)), s0))))
                           then bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)))) (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    (t0, t1))), (Compilers.Coq_type.Coq_base
                                    t0)))
                                    (Coq3_Compilers.Coq_pattern_ident_fst
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_fst
                                    (t0, t1))) (fun _ ->
                                  bind1
                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      XH)), (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      (XO XH))), (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      XH),
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      (XO XH)))))))))
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (let (x1, _) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       x1)), (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (let (x1, _) =
                                         let (_, y) =
                                           let (x1, _) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           x1
                                         in
                                         y
                                       in
                                       x1)), (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                      ((let (x1, _) =
                                          let (x1, _) =
                                            args0.Coq_Primitive.projT2
                                          in
                                          x1
                                        in
                                        x1),
                                      (let (x1, _) =
                                         let (_, y) =
                                           let (x1, _) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           x1
                                         in
                                         y
                                       in
                                       x1))))))))
                                      (Coq3_Compilers.Coq_pattern_ident_pair
                                      ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      XH),
                                      (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                      (XO XH))))
                                      (Coq3_Compilers.Coq_ident_pair
                                      ((let (x1, _) =
                                          let (x1, _) =
                                            args0.Coq_Primitive.projT2
                                          in
                                          x1
                                        in
                                        x1),
                                      (let (x1, _) =
                                         let (_, y) =
                                           let (x1, _) =
                                             args0.Coq_Primitive.projT2
                                           in
                                           x1
                                         in
                                         y
                                       in
                                       x1)))) (fun _ ->
                                    Compilers.Coq_type.try_make_transport_cps
                                      (fun _ x1 x2 _ ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x3 x4 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x3 x4) x1 x2) s1
                                      (Compilers.Coq_type.Coq_base b1)
                                      (fun tro ->
                                      match tro with
                                      | Some v ->
                                        Compilers.Coq_type.try_make_transport_cps
                                          (fun _ x1 x2 _ ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x3 x4 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x3 x4) x1 x2) s0
                                          (Compilers.Coq_type.Coq_base b0)
                                          (fun tro0 ->
                                          match tro0 with
                                          | Some _ ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x1 x2 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x1 x2) b1 b1 (fun tr ->
                                              match tr with
                                              | Some v0 ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x1 x2 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x1 x2) b0 b0 (fun tr0 ->
                                                  match tr0 with
                                                  | Some _ ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x1 x2 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x1 x2) b1 t0
                                                      (fun tr1 ->
                                                      match tr1 with
                                                      | Some v1 ->
                                                        Compilers.Coq_base.try_make_transport_cps
                                                          (fun _ x1 x2 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x1 x2) t0 t0
                                                          (fun tr' ->
                                                          match tr' with
                                                          | Some v2 ->
                                                            Some
                                                              (Coq_Compilers.UnderLets.splice
                                                                (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                  (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x1 x2 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                  false
                                                                  (Compilers.Coq_type.Coq_base
                                                                  b1)
                                                                  (Compilers.Coq_expr.Var
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  b1),
                                                                  (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x0))))))
                                                                (fun fv ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 (v1 fv))))
                                                          | None -> None)
                                                      | None -> None)
                                                  | None -> None)
                                              | None -> None)
                                          | None -> None)
                                      | None -> None)))
                           else None
                         | None -> None))
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t0))),
          (Coq3_Compilers.Coq_ident_fst (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (_, _) -> None
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (s0, _, f, x0) ->
             (match f with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (s1, _, f0, _) ->
                (match f0 with
                 | Compilers.Coq_expr.Ident (t2, idc0) ->
                   sequence
                     (bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t1))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t1)))
                                  (Coq3_Compilers.Coq_pattern_ident_snd
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_snd
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some _ ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b0 t1
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t1 t1
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                true
                                                                (Compilers.Coq_type.Coq_base
                                                                b0)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b0),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.splice
                                                                (Obj.magic
                                                                  do_again t1
                                                                  (v1 fv))
                                                                (fun fv0 ->
                                                                Coq_Compilers.UnderLets.Base
                                                                (v2 fv0))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None))
                     (bind1
                       (Obj.magic
                         Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                         t2 idc0 Coq3_Compilers.Coq_raw_ident_pair)
                       (fun args0 ->
                       match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                               (fun x1 y ->
                               match x1 with
                               | Coq3_Compilers.Z ->
                                 (match y with
                                  | Coq3_Compilers.Z -> true
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_bool ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> true
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_nat ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> true
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_zrange ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> true
                                  | Coq3_Compilers.Coq_string -> false)
                               | Coq3_Compilers.Coq_string ->
                                 (match y with
                                  | Coq3_Compilers.Z -> false
                                  | Coq3_Compilers.Coq_bool -> false
                                  | Coq3_Compilers.Coq_nat -> false
                                  | Coq3_Compilers.Coq_zrange -> false
                                  | Coq3_Compilers.Coq_string -> true))
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                               ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH),
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               XH)))), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                               (XO XH))))))) (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                               t1))), (Compilers.Coq_type.Coq_base t1))),
                               (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1)), (Compilers.Coq_type.Coq_arrow
                               ((Compilers.Coq_type.Coq_base
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)), (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_prod
                               ((let (x1, _) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) =
                                    let (x1, _) = args0.Coq_Primitive.projT2
                                    in
                                    x1
                                  in
                                  y
                                in
                                x1)))))))), s1)), s0)))) with
                       | Some vars0 ->
                         let (a, b) = Obj.magic vars0 in
                         let (a0, _) = a in
                         let (_, _) = a0 in
                         let (a1, b0) = b in
                         let (a2, b1) = a1 in
                         let (_, b2) = a2 in
                         let (_, b3) = b2 in
                         let (_, _) = b3 in
                         if Compilers.Coq_type.type_beq
                              (Compilers.Coq_base.Coq_type.type_beq
                                (fun x1 y ->
                                match x1 with
                                | Coq3_Compilers.Z ->
                                  (match y with
                                   | Coq3_Compilers.Z -> true
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_bool ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> true
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_nat ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> true
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> true
                                   | Coq3_Compilers.Coq_string -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (match y with
                                   | Coq3_Compilers.Z -> false
                                   | Coq3_Compilers.Coq_bool -> false
                                   | Coq3_Compilers.Coq_nat -> false
                                   | Coq3_Compilers.Coq_zrange -> false
                                   | Coq3_Compilers.Coq_string -> true)))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))), (Compilers.Coq_type.Coq_base b0))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b1),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base b0),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (b1,
                              b0))))))), (Compilers.Coq_type.Coq_base b1))),
                              (Compilers.Coq_type.Coq_base b0)))))
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                              t1))), (Compilers.Coq_type.Coq_base t1))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (x1, _) = args0.Coq_Primitive.projT2 in
                                 x1
                               in
                               x1)), (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)), (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((let (x1, _) =
                                  let (x1, _) = args0.Coq_Primitive.projT2 in
                                  x1
                                in
                                x1),
                              (let (x1, _) =
                                 let (_, y) =
                                   let (x1, _) = args0.Coq_Primitive.projT2 in
                                   x1
                                 in
                                 y
                               in
                               x1)))))))), s1)), s0))))
                         then bind1
                                (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))), (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH))))) (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod (t0,
                                  t1))), (Compilers.Coq_type.Coq_base t1)))
                                  (Coq3_Compilers.Coq_pattern_ident_snd
                                  ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  XH),
                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                  (XO XH)))) (Coq3_Compilers.Coq_ident_snd
                                  (t0, t1))) (fun _ ->
                                bind1
                                  (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH))), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))))))))
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (x1, _) =
                                         args0.Coq_Primitive.projT2
                                       in
                                       x1
                                     in
                                     x1)), (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)), (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1))))))))
                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    XH),
                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_var
                                    (XO XH)))) (Coq3_Compilers.Coq_ident_pair
                                    ((let (x1, _) =
                                        let (x1, _) =
                                          args0.Coq_Primitive.projT2
                                        in
                                        x1
                                      in
                                      x1),
                                    (let (x1, _) =
                                       let (_, y) =
                                         let (x1, _) =
                                           args0.Coq_Primitive.projT2
                                         in
                                         x1
                                       in
                                       y
                                     in
                                     x1)))) (fun _ ->
                                  Compilers.Coq_type.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Compilers.Coq_base.try_make_transport_cps
                                      (fun _ x3 x4 _ ->
                                      Coq3_Compilers.try_make_base_transport_cps
                                        x3 x4) x1 x2) s1
                                    (Compilers.Coq_type.Coq_base b1)
                                    (fun tro ->
                                    match tro with
                                    | Some _ ->
                                      Compilers.Coq_type.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Compilers.Coq_base.try_make_transport_cps
                                          (fun _ x3 x4 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x3 x4) x1 x2) s0
                                        (Compilers.Coq_type.Coq_base b0)
                                        (fun tro0 ->
                                        match tro0 with
                                        | Some v ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x1 x2 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x1 x2) b1 b1 (fun tr ->
                                            match tr with
                                            | Some _ ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x1 x2 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x1 x2) b0 b0 (fun tr0 ->
                                                match tr0 with
                                                | Some v0 ->
                                                  Compilers.Coq_base.try_make_transport_cps
                                                    (fun _ x1 x2 _ ->
                                                    Coq3_Compilers.try_make_base_transport_cps
                                                      x1 x2) b0 t1
                                                    (fun tr1 ->
                                                    match tr1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2) t1 t1
                                                        (fun tr' ->
                                                        match tr' with
                                                        | Some v2 ->
                                                          Some
                                                            (Coq_Compilers.UnderLets.splice
                                                              (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                  Coq3_Compilers.baseHasNat
                                                                  Coq3_Compilers.buildIdent
                                                                  Coq3_Compilers.buildEagerIdent
                                                                  Coq3_Compilers.toRestrictedIdent
                                                                  Coq3_Compilers.invertIdent
                                                                  Coq3_Compilers.baseHasNatCorrect
                                                                  (fun _ x1 x2 _ ->
                                                                  Coq3_Compilers.try_make_base_transport_cps
                                                                    x1 x2))
                                                                false
                                                                (Compilers.Coq_type.Coq_base
                                                                b0)
                                                                (Compilers.Coq_expr.Var
                                                                ((Compilers.Coq_type.Coq_base
                                                                b0),
                                                                (v0
                                                                  (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x0))))))
                                                              (fun fv ->
                                                              Coq_Compilers.UnderLets.Base
                                                              (v2 (v1 fv))))
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)))
                         else None
                       | None -> None))
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (t0, t1))), (Compilers.Coq_type.Coq_base t1))),
          (Coq3_Compilers.Coq_ident_snd (t0, t1)))), x))))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0),
            x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (t0, idc0) ->
             (match x0 with
              | Compilers.Coq_expr.Ident (t1, idc1) ->
                bind1
                  (Obj.magic
                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                    t1 idc1 Coq3_Compilers.Coq_raw_ident_Literal)
                  (fun args0 ->
                  bind1
                    (Obj.magic
                      Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                      t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                    (fun args1 ->
                    match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                            (fun x1 y ->
                            match x1 with
                            | Coq3_Compilers.Z ->
                              (match y with
                               | Coq3_Compilers.Z -> true
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_bool ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> true
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_nat ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> true
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_zrange ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> true
                               | Coq3_Compilers.Coq_string -> false)
                            | Coq3_Compilers.Coq_string ->
                              (match y with
                               | Coq3_Compilers.Z -> false
                               | Coq3_Compilers.Coq_bool -> false
                               | Coq3_Compilers.Coq_nat -> false
                               | Coq3_Compilers.Coq_zrange -> false
                               | Coq3_Compilers.Coq_string -> true))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_zrange)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1))))) with
                    | Some vars0 ->
                      let (_, _) = Obj.magic vars0 in
                      if Compilers.Coq_type.type_beq
                           (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                             match x1 with
                             | Coq3_Compilers.Z ->
                               (match y with
                                | Coq3_Compilers.Z -> true
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_bool ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> true
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_nat ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> true
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> true
                                | Coq3_Compilers.Coq_string -> false)
                             | Coq3_Compilers.Coq_string ->
                               (match y with
                                | Coq3_Compilers.Z -> false
                                | Coq3_Compilers.Coq_bool -> false
                                | Coq3_Compilers.Coq_nat -> false
                                | Coq3_Compilers.Coq_zrange -> false
                                | Coq3_Compilers.Coq_string -> true)))
                           (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Coq_zrange)),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                           ((Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args1.Coq_Primitive.projT1 in x1))),
                           (Compilers.Coq_type.Coq_base
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))))
                      then bind1
                             (Obj.magic
                               Coq10_Compilers.Coq_pattern.Coq_ident.unify
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                               Coq3_Compilers.Coq_zrange))
                               (Compilers.Coq_type.Coq_base
                               (Compilers.Coq_base.Coq_type.Coq_type_base
                               (let (x1, _) = args1.Coq_Primitive.projT1 in
                                x1)))
                               (Coq3_Compilers.Coq_pattern_ident_Literal
                               Coq3_Compilers.Coq_zrange)
                               (Coq3_Compilers.Coq_ident_Literal
                               ((let (x1, _) = args1.Coq_Primitive.projT1 in
                                 x1),
                               (let (x1, _) =
                                  let (_, y) = args1.Coq_Primitive.projT2 in
                                  y
                                in
                                x1)))) (fun xv ->
                             bind1
                               (Obj.magic
                                 Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z))
                                 (Compilers.Coq_type.Coq_base
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 (let (x1, _) = args0.Coq_Primitive.projT1 in
                                  x1)))
                                 (Coq3_Compilers.Coq_pattern_ident_Literal
                                 Coq3_Compilers.Z)
                                 (Coq3_Compilers.Coq_ident_Literal
                                 ((let (x1, _) = args0.Coq_Primitive.projT1
                                   in
                                   x1),
                                 (let (x1, _) =
                                    let (_, y) = args0.Coq_Primitive.projT2
                                    in
                                    y
                                  in
                                  x1)))) (fun xv0 ->
                               Compilers.Coq_base.try_make_transport_cps
                                 (fun _ x1 x2 _ ->
                                 Coq3_Compilers.try_make_base_transport_cps
                                   x1 x2)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z)
                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                 Coq3_Compilers.Z) (fun tr ->
                                 match tr with
                                 | Some v ->
                                   Compilers.Coq_base.try_make_transport_cps
                                     (fun _ x1 x2 _ ->
                                     Coq3_Compilers.try_make_base_transport_cps
                                       x1 x2)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z)
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Z) (fun tr' ->
                                     match tr' with
                                     | Some v0 ->
                                       bind1
                                         (if (&&)
                                               ((&&)
                                                 (is_bounded_by_bool
                                                   (let (x1, _) = xv0 in x1)
                                                   (ZRange.normalize
                                                     (let (x1, _) = xv in x1)))
                                                 (is_bounded_by_bool
                                                   (let (x1, _) = xv0 in x1)
                                                   (ZRange.normalize
                                                     { lower = Z0; upper =
                                                     (Coq_Z.sub
                                                       (Coq_Z.pow (Zpos (XO
                                                         XH)) bitwidth) (Zpos
                                                       XH)) })))
                                               (negb
                                                 (zrange_beq
                                                   (let (x1, _) = xv in x1)
                                                   { lower = Z0; upper =
                                                   (Coq_Z.sub
                                                     (Coq_Z.pow (Zpos (XO
                                                       XH)) bitwidth) (Zpos
                                                     XH)) }))
                                          then Some
                                                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                     Coq3_Compilers.baseHasNat
                                                     Coq3_Compilers.buildIdent
                                                     Coq3_Compilers.buildEagerIdent
                                                     Coq3_Compilers.toRestrictedIdent
                                                     Coq3_Compilers.invertIdent
                                                     Coq3_Compilers.baseHasNatCorrect
                                                     (fun _ x1 x2 _ ->
                                                     Coq3_Compilers.try_make_base_transport_cps
                                                       x1 x2)) false
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z))
                                                   (Compilers.Coq_expr.App
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Compilers.Coq_expr.App
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)))),
                                                   (Compilers.Coq_expr.Ident
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)))))),
                                                   Coq3_Compilers.Coq_ident_Z_cast)),
                                                   (Compilers.Coq_expr.Ident
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)),
                                                   (Coq3_Compilers.Coq_ident_Literal
                                                   (Coq3_Compilers.Coq_zrange,
                                                   (Obj.magic { lower = Z0;
                                                     upper =
                                                     (Coq_Z.sub
                                                       (Coq_Z.pow (Zpos (XO
                                                         XH)) bitwidth) (Zpos
                                                       XH)) }))))))),
                                                   (Compilers.Coq_expr.Ident
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Coq3_Compilers.Coq_ident_Literal
                                                   (Coq3_Compilers.Z,
                                                   (let (x1, _) = xv0 in
                                                    Obj.magic x1))))))))
                                          else None) (fun fv -> Some
                                         (Coq_Compilers.UnderLets.splice fv
                                           (fun fv0 ->
                                           Coq_Compilers.UnderLets.Base
                                           (v0 (v fv0)))))
                                     | None -> None)
                                 | None -> None)))
                      else None
                    | None -> None))
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, _, _) -> None
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, _, _) -> None
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cast)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x1) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x2) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x1 with
                         | Compilers.Coq_expr.Ident (t2, idc2) ->
                           (match x0 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (s0, _, f1, x3) ->
                              (match f1 with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (s1, _, f2, x4) ->
                                 (match f2 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    bind1
                                      (Obj.magic
                                        Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                        t3 idc3
                                        Coq3_Compilers.Coq_raw_ident_pair)
                                      (fun args0 ->
                                      bind1
                                        (Obj.magic
                                          Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                          t2 idc2
                                          Coq3_Compilers.Coq_raw_ident_Literal)
                                        (fun args1 ->
                                        bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                            t1 idc1
                                            Coq3_Compilers.Coq_raw_ident_Literal)
                                          (fun args2 ->
                                          bind1
                                            (Obj.magic
                                              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                              t0 idc0
                                              Coq3_Compilers.Coq_raw_ident_pair)
                                            (fun args3 ->
                                            match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                    (fun x5 y ->
                                                    match x5 with
                                                    | Coq3_Compilers.Z ->
                                                      (match y with
                                                       | Coq3_Compilers.Z ->
                                                         true
                                                       | Coq3_Compilers.Coq_bool ->
                                                         false
                                                       | Coq3_Compilers.Coq_nat ->
                                                         false
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         false
                                                       | Coq3_Compilers.Coq_string ->
                                                         false)
                                                    | Coq3_Compilers.Coq_bool ->
                                                      (match y with
                                                       | Coq3_Compilers.Z ->
                                                         false
                                                       | Coq3_Compilers.Coq_bool ->
                                                         true
                                                       | Coq3_Compilers.Coq_nat ->
                                                         false
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         false
                                                       | Coq3_Compilers.Coq_string ->
                                                         false)
                                                    | Coq3_Compilers.Coq_nat ->
                                                      (match y with
                                                       | Coq3_Compilers.Z ->
                                                         false
                                                       | Coq3_Compilers.Coq_bool ->
                                                         false
                                                       | Coq3_Compilers.Coq_nat ->
                                                         true
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         false
                                                       | Coq3_Compilers.Coq_string ->
                                                         false)
                                                    | Coq3_Compilers.Coq_zrange ->
                                                      (match y with
                                                       | Coq3_Compilers.Z ->
                                                         false
                                                       | Coq3_Compilers.Coq_bool ->
                                                         false
                                                       | Coq3_Compilers.Coq_nat ->
                                                         false
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         true
                                                       | Coq3_Compilers.Coq_string ->
                                                         false)
                                                    | Coq3_Compilers.Coq_string ->
                                                      (match y with
                                                       | Coq3_Compilers.Z ->
                                                         false
                                                       | Coq3_Compilers.Coq_bool ->
                                                         false
                                                       | Coq3_Compilers.Coq_nat ->
                                                         false
                                                       | Coq3_Compilers.Coq_zrange ->
                                                         false
                                                       | Coq3_Compilers.Coq_string ->
                                                         true))
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange),
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))))))
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (let (x5, _) =
                                                       let (x5, _) =
                                                         args3.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     x5)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (let (x5, _) =
                                                       let (_, y) =
                                                         let (x5, _) =
                                                           args3.Coq_Primitive.projT2
                                                         in
                                                         x5
                                                       in
                                                       y
                                                     in
                                                     x5)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((let (x5, _) =
                                                        let (x5, _) =
                                                          args3.Coq_Primitive.projT2
                                                        in
                                                        x5
                                                      in
                                                      x5),
                                                    (let (x5, _) =
                                                       let (_, y) =
                                                         let (x5, _) =
                                                           args3.Coq_Primitive.projT2
                                                         in
                                                         x5
                                                       in
                                                       y
                                                     in
                                                     x5)))))))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x5, _) =
                                                       args2.Coq_Primitive.projT1
                                                     in
                                                     x5))))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    (let (x5, _) =
                                                       args1.Coq_Primitive.projT1
                                                     in
                                                     x5))))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (let (x5, _) =
                                                       let (x5, _) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     x5)),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (let (x5, _) =
                                                       let (_, y) =
                                                         let (x5, _) =
                                                           args0.Coq_Primitive.projT2
                                                         in
                                                         x5
                                                       in
                                                       y
                                                     in
                                                     x5)),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((let (x5, _) =
                                                        let (x5, _) =
                                                          args0.Coq_Primitive.projT2
                                                        in
                                                        x5
                                                      in
                                                      x5),
                                                    (let (x5, _) =
                                                       let (_, y) =
                                                         let (x5, _) =
                                                           args0.Coq_Primitive.projT2
                                                         in
                                                         x5
                                                       in
                                                       y
                                                     in
                                                     x5)))))))), s1)), s0)))) with
                                            | Some vars0 ->
                                              let (a, b) = Obj.magic vars0 in
                                              let (a0, _) = a in
                                              let (a1, _) = a0 in
                                              let (_, b0) = a1 in
                                              let (_, b1) = b0 in
                                              let (_, _) = b1 in
                                              let (a2, _) = b in
                                              let (a3, _) = a2 in
                                              let (_, b2) = a3 in
                                              let (_, b3) = b2 in
                                              let (_, _) = b3 in
                                              if Compilers.Coq_type.type_beq
                                                   (Compilers.Coq_base.Coq_type.type_beq
                                                     (fun x5 y ->
                                                     match x5 with
                                                     | Coq3_Compilers.Z ->
                                                       (match y with
                                                        | Coq3_Compilers.Z ->
                                                          true
                                                        | Coq3_Compilers.Coq_bool ->
                                                          false
                                                        | Coq3_Compilers.Coq_nat ->
                                                          false
                                                        | Coq3_Compilers.Coq_zrange ->
                                                          false
                                                        | Coq3_Compilers.Coq_string ->
                                                          false)
                                                     | Coq3_Compilers.Coq_bool ->
                                                       (match y with
                                                        | Coq3_Compilers.Z ->
                                                          false
                                                        | Coq3_Compilers.Coq_bool ->
                                                          true
                                                        | Coq3_Compilers.Coq_nat ->
                                                          false
                                                        | Coq3_Compilers.Coq_zrange ->
                                                          false
                                                        | Coq3_Compilers.Coq_string ->
                                                          false)
                                                     | Coq3_Compilers.Coq_nat ->
                                                       (match y with
                                                        | Coq3_Compilers.Z ->
                                                          false
                                                        | Coq3_Compilers.Coq_bool ->
                                                          false
                                                        | Coq3_Compilers.Coq_nat ->
                                                          true
                                                        | Coq3_Compilers.Coq_zrange ->
                                                          false
                                                        | Coq3_Compilers.Coq_string ->
                                                          false)
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       (match y with
                                                        | Coq3_Compilers.Z ->
                                                          false
                                                        | Coq3_Compilers.Coq_bool ->
                                                          false
                                                        | Coq3_Compilers.Coq_nat ->
                                                          false
                                                        | Coq3_Compilers.Coq_zrange ->
                                                          true
                                                        | Coq3_Compilers.Coq_string ->
                                                          false)
                                                     | Coq3_Compilers.Coq_string ->
                                                       (match y with
                                                        | Coq3_Compilers.Z ->
                                                          false
                                                        | Coq3_Compilers.Coq_bool ->
                                                          false
                                                        | Coq3_Compilers.Coq_nat ->
                                                          false
                                                        | Coq3_Compilers.Coq_zrange ->
                                                          false
                                                        | Coq3_Compilers.Coq_string ->
                                                          true)))
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange),
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)))))))),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)))),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Coq_zrange)))),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z),
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)))))))),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z)))),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z))))))
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (let (x5, _) =
                                                      let (x5, _) =
                                                        args3.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    x5)),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (let (x5, _) =
                                                      let (_, y) =
                                                        let (x5, _) =
                                                          args3.Coq_Primitive.projT2
                                                        in
                                                        x5
                                                      in
                                                      y
                                                    in
                                                    x5)),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                   ((let (x5, _) =
                                                       let (x5, _) =
                                                         args3.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     x5),
                                                   (let (x5, _) =
                                                      let (_, y) =
                                                        let (x5, _) =
                                                          args3.Coq_Primitive.projT2
                                                        in
                                                        x5
                                                      in
                                                      y
                                                    in
                                                    x5)))))))),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   (let (x5, _) =
                                                      args2.Coq_Primitive.projT1
                                                    in
                                                    x5))))),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   (let (x5, _) =
                                                      args1.Coq_Primitive.projT1
                                                    in
                                                    x5))))),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (let (x5, _) =
                                                      let (x5, _) =
                                                        args0.Coq_Primitive.projT2
                                                      in
                                                      x5
                                                    in
                                                    x5)),
                                                   (Compilers.Coq_type.Coq_arrow
                                                   ((Compilers.Coq_type.Coq_base
                                                   (let (x5, _) =
                                                      let (_, y) =
                                                        let (x5, _) =
                                                          args0.Coq_Primitive.projT2
                                                        in
                                                        x5
                                                      in
                                                      y
                                                    in
                                                    x5)),
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                   ((let (x5, _) =
                                                       let (x5, _) =
                                                         args0.Coq_Primitive.projT2
                                                       in
                                                       x5
                                                     in
                                                     x5),
                                                   (let (x5, _) =
                                                      let (_, y) =
                                                        let (x5, _) =
                                                          args0.Coq_Primitive.projT2
                                                        in
                                                        x5
                                                      in
                                                      y
                                                    in
                                                    x5)))))))), s1)), s0))))
                                              then bind1
                                                     (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                       ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange),
                                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange))))))))
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (let (x5, _) =
                                                          let (x5, _) =
                                                            args3.Coq_Primitive.projT2
                                                          in
                                                          x5
                                                        in
                                                        x5)),
                                                       (Compilers.Coq_type.Coq_arrow
                                                       ((Compilers.Coq_type.Coq_base
                                                       (let (x5, _) =
                                                          let (_, y) =
                                                            let (x5, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x5
                                                          in
                                                          y
                                                        in
                                                        x5)),
                                                       (Compilers.Coq_type.Coq_base
                                                       (Compilers.Coq_base.Coq_type.Coq_prod
                                                       ((let (x5, _) =
                                                           let (x5, _) =
                                                             args3.Coq_Primitive.projT2
                                                           in
                                                           x5
                                                         in
                                                         x5),
                                                       (let (x5, _) =
                                                          let (_, y) =
                                                            let (x5, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x5
                                                          in
                                                          y
                                                        in
                                                        x5))))))))
                                                       (Coq3_Compilers.Coq_pattern_ident_pair
                                                       ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange),
                                                       (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                       Coq3_Compilers.Coq_zrange)))
                                                       (Coq3_Compilers.Coq_ident_pair
                                                       ((let (x5, _) =
                                                           let (x5, _) =
                                                             args3.Coq_Primitive.projT2
                                                           in
                                                           x5
                                                         in
                                                         x5),
                                                       (let (x5, _) =
                                                          let (_, y) =
                                                            let (x5, _) =
                                                              args3.Coq_Primitive.projT2
                                                            in
                                                            x5
                                                          in
                                                          y
                                                        in
                                                        x5)))) (fun _ ->
                                                     bind1
                                                       (Obj.magic
                                                         Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                         Coq3_Compilers.Coq_zrange))
                                                         (Compilers.Coq_type.Coq_base
                                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                                         (let (x5, _) =
                                                            args2.Coq_Primitive.projT1
                                                          in
                                                          x5)))
                                                         (Coq3_Compilers.Coq_pattern_ident_Literal
                                                         Coq3_Compilers.Coq_zrange)
                                                         (Coq3_Compilers.Coq_ident_Literal
                                                         ((let (x5, _) =
                                                             args2.Coq_Primitive.projT1
                                                           in
                                                           x5),
                                                         (let (x5, _) =
                                                            let (_, y) =
                                                              args2.Coq_Primitive.projT2
                                                            in
                                                            y
                                                          in
                                                          x5)))) (fun xv ->
                                                       bind1
                                                         (Obj.magic
                                                           Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                           Coq3_Compilers.Coq_zrange))
                                                           (Compilers.Coq_type.Coq_base
                                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                                           (let (x5, _) =
                                                              args1.Coq_Primitive.projT1
                                                            in
                                                            x5)))
                                                           (Coq3_Compilers.Coq_pattern_ident_Literal
                                                           Coq3_Compilers.Coq_zrange)
                                                           (Coq3_Compilers.Coq_ident_Literal
                                                           ((let (x5, _) =
                                                               args1.Coq_Primitive.projT1
                                                             in
                                                             x5),
                                                           (let (x5, _) =
                                                              let (_, y) =
                                                                args1.Coq_Primitive.projT2
                                                              in
                                                              y
                                                            in
                                                            x5))))
                                                         (fun xv0 ->
                                                         bind1
                                                           (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z),
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z))))))))
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x5, _) =
                                                                let (
                                                                  x5, _) =
                                                                  args0.Coq_Primitive.projT2
                                                                in
                                                                x5
                                                              in
                                                              x5)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                y
                                                              in
                                                              x5)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((let (x5, _) =
                                                                 let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT2
                                                                 in
                                                                 x5
                                                               in
                                                               x5),
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                y
                                                              in
                                                              x5))))))))
                                                             (Coq3_Compilers.Coq_pattern_ident_pair
                                                             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z),
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)))
                                                             (Coq3_Compilers.Coq_ident_pair
                                                             ((let (x5, _) =
                                                                 let (
                                                                   x5, _) =
                                                                   args0.Coq_Primitive.projT2
                                                                 in
                                                                 x5
                                                               in
                                                               x5),
                                                             (let (x5, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x5, _) =
                                                                    args0.Coq_Primitive.projT2
                                                                  in
                                                                  x5
                                                                in
                                                                y
                                                              in
                                                              x5))))
                                                           (fun _ ->
                                                           Compilers.Coq_type.try_make_transport_cps
                                                             (fun _ x5 x6 _ ->
                                                             Compilers.Coq_base.try_make_transport_cps
                                                               (fun _ x7 x8 _ ->
                                                               Coq3_Compilers.try_make_base_transport_cps
                                                                 x7 x8) x5 x6)
                                                             s1
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z))
                                                             (fun tro ->
                                                             match tro with
                                                             | Some v ->
                                                               Compilers.Coq_type.try_make_transport_cps
                                                                 (fun _ x5 x6 _ ->
                                                                 Compilers.Coq_base.try_make_transport_cps
                                                                   (fun _ x7 x8 _ ->
                                                                   Coq3_Compilers.try_make_base_transport_cps
                                                                    x7 x8) x5
                                                                   x6) s0
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))
                                                                 (fun tro0 ->
                                                                 match tro0 with
                                                                 | Some v0 ->
                                                                   Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x5 x6 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x5 x6))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv
                                                                    in
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x5, _) =
                                                                    xv0
                                                                    in
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v3 fv))
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4 fv0))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                 | None ->
                                                                   None)
                                                             | None -> None)))))
                                              else None
                                            | None -> None))))
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (s2, _, f3, x5) ->
                                    (match f3 with
                                     | Compilers.Coq_expr.Ident (t3, idc3) ->
                                       sequence
                                         (match x5 with
                                          | Compilers.Coq_expr.Ident (
                                              _, _) ->
                                            None
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, f4,
                                                                    x6) ->
                                            (match f4 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    t4, idc4) ->
                                                  (match x7 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t5, idc5) ->
                                                     (match x6 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t6, idc6) ->
                                                        (match x4 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             s3, _, f6, x8) ->
                                                           (match f6 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   t7, idc7) ->
                                                                 (match x9 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (is_bounded_by_bool
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))))),
                                                                    (fun v6 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v6)))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))
                                                                    (Coq_Z.ltb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12))
                                                                    bitwidth)))
                                                                    (Coq_Z.ltb
                                                                    bitwidth
                                                                    (Coq_Z.add
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12))
                                                                    lgcarrymax)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))))),
                                                                    (fun v6 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Zpos
                                                                    XH)))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v6)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    bitwidth
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12))))))))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                         (sequence
                                           (match x5 with
                                            | Compilers.Coq_expr.Ident (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                _, _, f4, x6) ->
                                              (match f4 with
                                               | Compilers.Coq_expr.Ident (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, f5, x7) ->
                                                 (match f5 with
                                                  | Compilers.Coq_expr.Ident (
                                                      t4, idc4) ->
                                                    (match x7 with
                                                     | Compilers.Coq_expr.Ident (
                                                         t5, idc5) ->
                                                       (match x6 with
                                                        | Compilers.Coq_expr.Ident (
                                                            t6, idc6) ->
                                                          (match x4 with
                                                           | Compilers.Coq_expr.Ident (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               s3, _, f6, x8) ->
                                                             (match f6 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, f7,
                                                                  x9) ->
                                                                (match f7 with
                                                                 | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                   (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (is_bounded_by_bool
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))))),
                                                                    (fun v6 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v6)))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))
                                                                    (Coq_Z.ltb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12))
                                                                    bitwidth)))
                                                                    (Coq_Z.ltb
                                                                    bitwidth
                                                                    (Coq_Z.add
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12))
                                                                    lgcarrymax)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))))),
                                                                    (fun v6 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Zpos
                                                                    XH)))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v6)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    bitwidth
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12))))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None)
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                           (sequence
                                             (match x5 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f4, x6) ->
                                                (match f4 with
                                                 | Compilers.Coq_expr.Ident (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, f5, x7) ->
                                                   (match f5 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t4, idc4) ->
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t5, idc5) ->
                                                         (match x6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              t6, idc6) ->
                                                            (match x4 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 s3, _, f6,
                                                                 x8) ->
                                                               (match f6 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, f7,
                                                                    x9) ->
                                                                  (match f7 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul_split)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (is_bounded_by_bool
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))),
                                                                    (fun v5 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul_high)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))))),
                                                                    (fun v6 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v5)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v6)))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                             (bind1
                                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                 t3 idc3
                                                 Coq3_Compilers.Coq_raw_ident_Z_mul_split)
                                               (fun _ ->
                                               bind1
                                                 (Obj.magic
                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                   t2 idc2
                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                 (fun args0 ->
                                                 bind1
                                                   (Obj.magic
                                                     Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                     t1 idc1
                                                     Coq3_Compilers.Coq_raw_ident_Literal)
                                                   (fun args1 ->
                                                   bind1
                                                     (Obj.magic
                                                       Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                       t0 idc0
                                                       Coq3_Compilers.Coq_raw_ident_pair)
                                                     (fun args2 ->
                                                     match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                             (fun x6 y ->
                                                             match x6 with
                                                             | Coq3_Compilers.Z ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  true
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_bool ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  true
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_nat ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  true
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_zrange ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  true
                                                                | Coq3_Compilers.Coq_string ->
                                                                  false)
                                                             | Coq3_Compilers.Coq_string ->
                                                               (match y with
                                                                | Coq3_Compilers.Z ->
                                                                  false
                                                                | Coq3_Compilers.Coq_bool ->
                                                                  false
                                                                | Coq3_Compilers.Coq_nat ->
                                                                  false
                                                                | Coq3_Compilers.Coq_zrange ->
                                                                  false
                                                                | Coq3_Compilers.Coq_string ->
                                                                  true))
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                             ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange),
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Coq_zrange)))),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z)))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                             Coq3_Compilers.Z))))))
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x6, _) =
                                                                let (
                                                                  x6, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x6
                                                              in
                                                              x6)),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_base
                                                             (let (x6, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x6
                                                                in
                                                                y
                                                              in
                                                              x6)),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_prod
                                                             ((let (x6, _) =
                                                                 let (
                                                                   x6, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x6
                                                               in
                                                               x6),
                                                             (let (x6, _) =
                                                                let (
                                                                  _, y) =
                                                                  let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                  in
                                                                  x6
                                                                in
                                                                y
                                                              in
                                                              x6)))))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x6, _) =
                                                                args1.Coq_Primitive.projT1
                                                              in
                                                              x6))))),
                                                             (Compilers.Coq_type.Coq_base
                                                             (Compilers.Coq_base.Coq_type.Coq_type_base
                                                             (let (x6, _) =
                                                                args0.Coq_Primitive.projT1
                                                              in
                                                              x6))))),
                                                             (Compilers.Coq_type.Coq_arrow
                                                             ((Compilers.Coq_type.Coq_arrow
                                                             (s2, s1)),
                                                             s0)))) with
                                                     | Some vars0 ->
                                                       let (a, b) =
                                                         Obj.magic vars0
                                                       in
                                                       let (a0, _) = a in
                                                       let (a1, _) = a0 in
                                                       let (_, b0) = a1 in
                                                       let (_, b1) = b0 in
                                                       let (_, _) = b1 in
                                                       let (a2, _) = b in
                                                       let (_, _) = a2 in
                                                       if Compilers.Coq_type.type_beq
                                                            (Compilers.Coq_base.Coq_type.type_beq
                                                              (fun x6 y ->
                                                              match x6 with
                                                              | Coq3_Compilers.Z ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_bool ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_nat ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   true
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   false)
                                                              | Coq3_Compilers.Coq_string ->
                                                                (match y with
                                                                 | Coq3_Compilers.Z ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_bool ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_nat ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_zrange ->
                                                                   false
                                                                 | Coq3_Compilers.Coq_string ->
                                                                   true)))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange),
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)))))))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Coq_zrange)))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))))))
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x6, _) =
                                                               let (x6, _) =
                                                                 args2.Coq_Primitive.projT2
                                                               in
                                                               x6
                                                             in
                                                             x6)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (let (x6, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x6, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x6
                                                               in
                                                               y
                                                             in
                                                             x6)),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((let (x6, _) =
                                                                let (
                                                                  x6, _) =
                                                                  args2.Coq_Primitive.projT2
                                                                in
                                                                x6
                                                              in
                                                              x6),
                                                            (let (x6, _) =
                                                               let (_, y) =
                                                                 let (
                                                                   x6, _) =
                                                                   args2.Coq_Primitive.projT2
                                                                 in
                                                                 x6
                                                               in
                                                               y
                                                             in
                                                             x6)))))))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            (let (x6, _) =
                                                               args1.Coq_Primitive.projT1
                                                             in
                                                             x6))))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            (let (x6, _) =
                                                               args0.Coq_Primitive.projT1
                                                             in
                                                             x6))))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_arrow
                                                            (s2, s1)), s0))))
                                                       then bind1
                                                              (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange))))))))
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                   in
                                                                   x6
                                                                 in
                                                                 x6)),
                                                                (Compilers.Coq_type.Coq_arrow
                                                                ((Compilers.Coq_type.Coq_base
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                   in
                                                                   y
                                                                 in
                                                                 x6)),
                                                                (Compilers.Coq_type.Coq_base
                                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                                ((let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                  in
                                                                  x6),
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                   in
                                                                   y
                                                                 in
                                                                 x6))))))))
                                                                (Coq3_Compilers.Coq_pattern_ident_pair
                                                                ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange),
                                                                (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Coq_zrange)))
                                                                (Coq3_Compilers.Coq_ident_pair
                                                                ((let (
                                                                    x6, _) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                  in
                                                                  x6),
                                                                (let (
                                                                   x6, _) =
                                                                   let (
                                                                    _, y) =
                                                                    let (
                                                                    x6, _) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    x6
                                                                   in
                                                                   y
                                                                 in
                                                                 x6))))
                                                              (fun _ ->
                                                              bind1
                                                                (Obj.magic
                                                                  Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Coq_zrange))
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  (let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                   in
                                                                   x6)))
                                                                  (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                  Coq3_Compilers.Coq_zrange)
                                                                  (Coq3_Compilers.Coq_ident_Literal
                                                                  ((let (
                                                                    x6, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                  (let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                   in
                                                                   x6))))
                                                                (fun xv ->
                                                                bind1
                                                                  (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x6),
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x6))))
                                                                  (fun xv0 ->
                                                                  Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x8 x9 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x8 x9) x6
                                                                    x7) s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6).lower
                                                                    Z0)
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6).lower
                                                                    Z0))
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH))))
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6).upper))
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6).upper))
                                                                    (Coq1_Z.divideb
                                                                    (Coq_Z.add
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6).upper
                                                                    (Zpos
                                                                    XH))
                                                                    (Coq_Z.add
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH))
                                                                    (Zpos
                                                                    XH))))
                                                                    (Coq1_Z.divideb
                                                                    (Coq_Z.add
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6).upper
                                                                    (Zpos
                                                                    XH))
                                                                    (Coq_Z.add
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH))
                                                                    (Zpos
                                                                    XH))))
                                                                    ((||)
                                                                    (negb
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    x6).upper
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH))))
                                                                    (negb
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    x6).upper
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x6 x7 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x6 x7))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x6, _) =
                                                                    xv0
                                                                    in
                                                                    Obj.magic
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_mul_split)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v5 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                       else None
                                                     | None -> None)))))))
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (s3, _, f4, x6) ->
                                       (match f4 with
                                        | Compilers.Coq_expr.Ident (t3, idc3) ->
                                          sequence
                                            (match x5 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 s4, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f6, x8) ->
                                                  (match f6 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t4, idc4) ->
                                                     (match x8 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        sequence
                                                          (match x7 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t6, idc6) ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t6 idc6
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args0 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t5 idc5
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args1 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))))),
                                                                    s1)),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))))),
                                                                    s1)),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv1
                                                                    in
                                                                    x9)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv2
                                                                    in
                                                                    x9) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv0
                                                                    in
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v5 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                          (match x6 with
                                                           | Compilers.Coq_expr.Ident (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, f7, x9) ->
                                                             (match f7 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, f8,
                                                                  x10) ->
                                                                (match f8 with
                                                                 | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                   (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s6, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (is_bounded_by_bool
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))),
                                                                    (fun v10 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v10)))))))),
                                                                    (fun v11 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v11)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))
                                                                    (Coq_Z.ltb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15))
                                                                    bitwidth)))
                                                                    (Coq_Z.ltb
                                                                    (Coq_Z.add
                                                                    bitwidth
                                                                    (Zpos
                                                                    XH))
                                                                    (Coq_Z.add
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15))
                                                                    lgcarrymax)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))),
                                                                    (fun v10 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v10)))))))),
                                                                    (fun v11 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Zpos
                                                                    XH)))))))))))),
                                                                    (fun v12 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v11)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    bitwidth
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15))))))))))))))))),
                                                                    (fun v13 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v12)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v13)))))))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None)
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                            (sequence
                                              (match x5 with
                                               | Compilers.Coq_expr.Ident (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, f5, x7) ->
                                                 (match f5 with
                                                  | Compilers.Coq_expr.Ident (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, f6, x8) ->
                                                    (match f6 with
                                                     | Compilers.Coq_expr.Ident (
                                                         t4, idc4) ->
                                                       (match x8 with
                                                        | Compilers.Coq_expr.Ident (
                                                            t5, idc5) ->
                                                          (match x7 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t6, idc6) ->
                                                             bind1
                                                               (Obj.magic
                                                                 Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                 t6 idc6
                                                                 Coq3_Compilers.Coq_raw_ident_Literal)
                                                               (fun args0 ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t5 idc5
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args1 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))))),
                                                                    s1)),
                                                                    s0)))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, _) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))))),
                                                                    s1)),
                                                                    s0))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv1
                                                                    in
                                                                    x9)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv2
                                                                    in
                                                                    x9) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv0
                                                                    in
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x3))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v5 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                              (match x3 with
                                               | Compilers.Coq_expr.Ident (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   s4, _, f5, x7) ->
                                                 (match f5 with
                                                  | Compilers.Coq_expr.Ident (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Var (
                                                      _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.Abs (
                                                      _, _, _) ->
                                                    None
                                                  | Compilers.Coq_expr.App (
                                                      _, _, f6, x8) ->
                                                    (match f6 with
                                                     | Compilers.Coq_expr.Ident (
                                                         t4, idc4) ->
                                                       (match x8 with
                                                        | Compilers.Coq_expr.Ident (
                                                            t5, idc5) ->
                                                          sequence
                                                            (match x7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t6, idc6) ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t6 idc6
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args0 ->
                                                                 bind1
                                                                   (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                   (fun args1 ->
                                                                   bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args4 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    s2)),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, _) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x9 y ->
                                                                    match x9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    s2)),
                                                                    s1)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x9, _) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    x9
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x11 x12 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x11 x12)
                                                                    x9 x10)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x9, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x9),
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x9))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    (is_bounded_by_bool
                                                                    Z0
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv1
                                                                    in
                                                                    x9)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv2
                                                                    in
                                                                    x9) Z0)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x9 x10 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x9 x10))
                                                                    true
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv
                                                                    in
                                                                    x9))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x9, _) =
                                                                    xv0
                                                                    in
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x6))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x5))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.splice
                                                                    (do_again
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (v5 fv0))
                                                                    (fun fv1 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6 fv1)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                            (match x6 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f7, x9) ->
                                                               (match f7 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                  (match f8 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t6, idc6) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x5 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s6, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (is_bounded_by_bool
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x7))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))))),
                                                                    (fun v10 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v10)))))))),
                                                                    (fun v11 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v11)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s6)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s4))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    lgcarrymax)
                                                                    (Coq_Z.leb
                                                                    lgcarrymax
                                                                    bitwidth))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))
                                                                    ((&&)
                                                                    (Coq_Z.ltb
                                                                    Z0
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))
                                                                    (Coq_Z.ltb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15))
                                                                    bitwidth)))
                                                                    (Coq_Z.ltb
                                                                    bitwidth
                                                                    (Coq_Z.add
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15))
                                                                    lgcarrymax)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Obj.magic
                                                                    Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x7))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x13))))))))))),
                                                                    (fun v9 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_ltz)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))))),
                                                                    (fun v10 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v10)))))))),
                                                                    (fun v11 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Zpos
                                                                    XH)))))))))))),
                                                                    (fun v12 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v11)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    bitwidth
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15))))))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_shiftr)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v9)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))))))))))))),
                                                                    (fun v13 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v12)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    lgcarrymax)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v13)))))))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                  | Compilers.Coq_expr.LetIn (
                                                      _, _, _, _) ->
                                                    None)
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None))
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, _, _) ->
                                          None
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, _, _) -> None
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)), x)),
          x0))))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 bitwidth lgcarrymax =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None (all_rewrite_rules bitwidth lgcarrymax)

    (** val rewrite_head1 :
        z -> z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteMultiRetSplit :
        z -> z ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteMultiRetSplit bitwidth lgcarrymax opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            (multiret_split_rewrite_rulesT bitwidth lgcarrymax);
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules bitwidth lgcarrymax));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules bitwidth lgcarrymax));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            O)))))))))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head bitwidth lgcarrymax));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1 bitwidth lgcarrymax)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))) t0 e
   end
 end

module Coq19_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        z -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules bitwidth =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x t2 t3 t4 t5 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (zrange_beq t0 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) })
                     (zrange_beq t2 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) })) (Coq_Z.eqb t3 Z0))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (Coq_Z.eqb t5
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_zselect)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                     (Zpos XH)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x0 t2 x1 t3 x2 ->
          if (&&)
               ((&&)
                 ((&&) (Coq_Z.leb Z0 bitwidth)
                   (zrange_beq t0 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t2 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (zrange_beq t3 { lower = Z0; upper =
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_zselect)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                     (Zpos XH)))))))))))), (fun v -> Compilers.Coq_expr.LetIn
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lxor)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                     (Zpos XH)))))))))))), (fun v0 -> Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v)))))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), v0)))))))))))))))))
          else None)) })) :: [])

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_zselect,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        z -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules bitwidth =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 x t2 t3 t4 t5 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (zrange_beq t0 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) })
                     (zrange_beq t2 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) })) (Coq_Z.eqb t3 Z0))
                 (zrange_beq t4 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
               (Coq_Z.eqb t5
                 (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x0 x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x0 x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_zselect)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange,
                   (Obj.magic { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                     (Zpos XH)))))))))))))
          else None)) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 x0 t2 x1 t3 x2 ->
            if (&&)
                 ((&&)
                   ((&&) (Coq_Z.leb Z0 bitwidth)
                     (zrange_beq t0 { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))
                   (zrange_beq t2 { lower = Z0; upper =
                     (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) }))
                 (zrange_beq t3 { lower = Z0; upper =
                   (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.LetIn
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_zselect)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                       (Zpos XH)))))))))))), (fun v ->
                     Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_lxor)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth)
                       (Zpos XH)))))))))))), (fun v0 ->
                     Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_lor)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v)))))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_land)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange,
                     (Obj.magic { lower = Z0; upper =
                       (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth) (Zpos
                         XH)) }))))))), (Compilers.Coq_expr.Var
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), v0)))))))))))))))))
            else None)) }; Primitive.snd = () }) }

    (** val all_rewrite_rules :
        z -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules bitwidth =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: []))
        (Obj.magic pr2_rewrite_rules bitwidth)

    (** val rewrite_head :
        z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head bitwidth _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (t0, idc0) ->
             (match x0 with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, f, x1) ->
                (match f with
                 | Compilers.Coq_expr.Ident (_, _) -> None
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, f0, x2) ->
                   (match f0 with
                    | Compilers.Coq_expr.Ident (_, _) -> None
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, f1, x3) ->
                      (match f1 with
                       | Compilers.Coq_expr.Ident (t1, idc1) ->
                         (match x3 with
                          | Compilers.Coq_expr.Ident (_, _) -> None
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (s0, _, f2, x4) ->
                            (match f2 with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, f3, x5) ->
                               (match f3 with
                                | Compilers.Coq_expr.Ident (t2, idc2) ->
                                  (match x5 with
                                   | Compilers.Coq_expr.Ident (t3, idc3) ->
                                     (match x2 with
                                      | Compilers.Coq_expr.Ident (_, _) ->
                                        None
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (s1, _, f4, x6) ->
                                        (match f4 with
                                         | Compilers.Coq_expr.Ident (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Var (_, _) ->
                                           None
                                         | Compilers.Coq_expr.Abs (_, _, _) ->
                                           None
                                         | Compilers.Coq_expr.App (_, _, f5,
                                                                   x7) ->
                                           (match f5 with
                                            | Compilers.Coq_expr.Ident (
                                                t4, idc4) ->
                                              (match x7 with
                                               | Compilers.Coq_expr.Ident (
                                                   t5, idc5) ->
                                                 sequence
                                                   (match x6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t6, idc6) ->
                                                      (match x1 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, f6, x8) ->
                                                         (match f6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, f7, x9) ->
                                                            (match f7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t7, idc7) ->
                                                               (match x9 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                  (match x8 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_zselect)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x10 y ->
                                                                    match x10 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a0, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x10 y ->
                                                                    match x10 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    x10 x11)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv
                                                                    in
                                                                    x10)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv1
                                                                    in
                                                                    x10)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv2
                                                                    in
                                                                    x10) Z0))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv3
                                                                    in
                                                                    x10)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv4
                                                                    in
                                                                    x10)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_zselect)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv0
                                                                    in
                                                                    x10))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x4))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                   (match x1 with
                                                    | Compilers.Coq_expr.Ident (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        s2, _, f6, x8) ->
                                                      (match f6 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, f7, x9) ->
                                                         (match f7 with
                                                          | Compilers.Coq_expr.Ident (
                                                              t6, idc6) ->
                                                            (match x9 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t7, idc7) ->
                                                               bind1
                                                                 (Obj.magic
                                                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                   t7 idc7
                                                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                                                 (fun args0 ->
                                                                 bind1
                                                                   (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                   (fun _ ->
                                                                   bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_zselect)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x10 y ->
                                                                    match x10 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a0, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x10 y ->
                                                                    match x10 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s0)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv0 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    x10 x11)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    x10 x11)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x10, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x10),
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x10))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    x10 x11)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    bitwidth)
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv
                                                                    in
                                                                    x10)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv1
                                                                    in
                                                                    x10)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (zrange_beq
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv2
                                                                    in
                                                                    x10)
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x10 x11 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x10 x11))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_zselect)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x10, _) =
                                                                    xv0
                                                                    in
                                                                    x10))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x4))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)))))))))))),
                                                                    (fun v7 ->
                                                                    Compilers.Coq_expr.LetIn
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_lxor)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)))))))))))),
                                                                    (fun v8 ->
                                                                    Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_lor)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v7)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_land)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x6))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (Obj.magic
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    bitwidth)
                                                                    (Zpos
                                                                    XH)) }))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    v8)))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                               | Compilers.Coq_expr.Var (
                                                   _, _) ->
                                                 None
                                               | Compilers.Coq_expr.Abs (
                                                   _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.App (
                                                   _, _, _, _) ->
                                                 None
                                               | Compilers.Coq_expr.LetIn (
                                                   _, _, _, _) ->
                                                 None)
                                            | Compilers.Coq_expr.Var (
                                                _, _) ->
                                              None
                                            | Compilers.Coq_expr.Abs (
                                                _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.App (
                                                _, _, _, _) ->
                                              None
                                            | Compilers.Coq_expr.LetIn (
                                                _, _, _, _) ->
                                              None)
                                         | Compilers.Coq_expr.LetIn (
                                             _, _, _, _) ->
                                           None)
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, _, _) ->
                                     None
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, _, _) -> None
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, _, _) -> None
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cast)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 bitwidth =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None (all_rewrite_rules bitwidth)

    (** val rewrite_head1 :
        z -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteNoSelect :
        z ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteNoSelect bitwidth opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            (noselect_rewrite_rulesT bitwidth);
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules bitwidth));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules bitwidth));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S
            O)); Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head bitwidth));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1 bitwidth)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S O)) t0 e
   end
 end

module Coq20_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        z list -> (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules which_bitwidths =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.four_corners_and_zero Coq_Z.div
                       (ZRange.four_corners Coq_Z.add
                         (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                           (ZRange.normalize t5)) (ZRange.normalize t6))
                       (ZRange.normalize t2))) t1)
                 (is_tighter_than_bool (ZRange.normalize t1) t0))
               (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.four_corners_and_zero Coq_Z.div
                       (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                         (ZRange.normalize t5)) (ZRange.normalize t2))) t1)
                 (is_tighter_than_bool (ZRange.normalize t1) t0))
               (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.opp
                       (ZRange.four_corners_and_zero Coq_Z.div
                         (ZRange.four_corners Coq_Z.sub
                           (ZRange.four_corners Coq_Z.sub
                             (ZRange.normalize t5) (ZRange.normalize t6))
                           (ZRange.normalize t4)) (ZRange.normalize t2)))) t1)
                 (is_tighter_than_bool (ZRange.normalize t1) t0))
               (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&)
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.opp
                       (ZRange.four_corners_and_zero Coq_Z.div
                         (ZRange.four_corners Coq_Z.sub (ZRange.normalize t4)
                           (ZRange.normalize t5)) (ZRange.normalize t2)))) t1)
                 (is_tighter_than_bool (ZRange.normalize t1) t0))
               (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))),
                   Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))
          else None)) })) :: [])))

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast2,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S O))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S O)),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        z list -> ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules which_bitwidths =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&)
                 (is_tighter_than_bool
                   (ZRange.normalize
                     (ZRange.four_corners_and_zero Coq_Z.div
                       (ZRange.four_corners Coq_Z.add
                         (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                           (ZRange.normalize t5)) (ZRange.normalize t6))
                       (ZRange.normalize t2))) t1)
                 (is_tighter_than_bool (ZRange.normalize t1) t0))
               (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))))),
                   Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))
          else None)) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   (is_tighter_than_bool
                     (ZRange.normalize
                       (ZRange.four_corners_and_zero Coq_Z.div
                         (ZRange.four_corners Coq_Z.add (ZRange.normalize t4)
                           (ZRange.normalize t5)) (ZRange.normalize t2))) t1)
                   (is_tighter_than_bool (ZRange.normalize t1) t0))
                 (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&)
                   (is_tighter_than_bool
                     (ZRange.normalize
                       (ZRange.opp
                         (ZRange.four_corners_and_zero Coq_Z.div
                           (ZRange.four_corners Coq_Z.sub
                             (ZRange.four_corners Coq_Z.sub
                               (ZRange.normalize t5) (ZRange.normalize t6))
                             (ZRange.normalize t4)) (ZRange.normalize t2))))
                     t1) (is_tighter_than_bool (ZRange.normalize t1) t0))
                 (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&)
                   (is_tighter_than_bool
                     (ZRange.normalize
                       (ZRange.opp
                         (ZRange.four_corners_and_zero Coq_Z.div
                           (ZRange.four_corners Coq_Z.sub
                             (ZRange.normalize t4) (ZRange.normalize t5))
                           (ZRange.normalize t2)))) t1)
                   (is_tighter_than_bool (ZRange.normalize t1) t0))
                 (existsb (Coq_Z.eqb (Coq_Z.log2 t3)) which_bitwidths)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t3))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))
            else None)) }; Primitive.snd = () } } }) }

    (** val all_rewrite_rules :
        z list -> ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules which_bitwidths =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: []))))
        (Obj.magic pr2_rewrite_rules which_bitwidths)

    (** val rewrite_head :
        z list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head which_bitwidths _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cast)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (_, _) -> None
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, f, x1) ->
             (match f with
              | Compilers.Coq_expr.Ident (_, _) -> None
              | Compilers.Coq_expr.Var (_, _) -> None
              | Compilers.Coq_expr.Abs (_, _, _) -> None
              | Compilers.Coq_expr.App (_, _, f0, x2) ->
                (match f0 with
                 | Compilers.Coq_expr.Ident (t0, idc0) ->
                   (match x2 with
                    | Compilers.Coq_expr.Ident (t1, idc1) ->
                      (match x1 with
                       | Compilers.Coq_expr.Ident (t2, idc2) ->
                         (match x0 with
                          | Compilers.Coq_expr.Ident (_, _) -> None
                          | Compilers.Coq_expr.Var (_, _) -> None
                          | Compilers.Coq_expr.Abs (_, _, _) -> None
                          | Compilers.Coq_expr.App (_, _, f1, x3) ->
                            (match f1 with
                             | Compilers.Coq_expr.Ident (_, _) -> None
                             | Compilers.Coq_expr.Var (_, _) -> None
                             | Compilers.Coq_expr.Abs (_, _, _) -> None
                             | Compilers.Coq_expr.App (_, _, f2, x4) ->
                               (match f2 with
                                | Compilers.Coq_expr.Ident (_, _) -> None
                                | Compilers.Coq_expr.Var (_, _) -> None
                                | Compilers.Coq_expr.Abs (_, _, _) -> None
                                | Compilers.Coq_expr.App (_, _, f3, x5) ->
                                  (match f3 with
                                   | Compilers.Coq_expr.Ident (t3, idc3) ->
                                     sequence
                                       (match x5 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x6) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, f5, x7) ->
                                             (match f5 with
                                              | Compilers.Coq_expr.Ident (
                                                  t4, idc4) ->
                                                (match x7 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t5, idc5) ->
                                                   (match x6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t6, idc6) ->
                                                      (match x4 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           s0, _, f6, x8) ->
                                                         (match f6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, f7, x9) ->
                                                            (match f7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t7, idc7) ->
                                                               (match x9 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                  (match x3 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.div
                                                                    (ZRange.four_corners
                                                                    Coq_Z.add
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12))))
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12))
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12)))
                                                                    (existsb
                                                                    (Coq_Z.eqb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))
                                                                    which_bitwidths)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x10))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                       (match x5 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x6) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, f5, x7) ->
                                             (match f5 with
                                              | Compilers.Coq_expr.Ident (
                                                  t4, idc4) ->
                                                (match x7 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t5, idc5) ->
                                                   (match x6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t6, idc6) ->
                                                      (match x4 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           s0, _, f6, x8) ->
                                                         (match f6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, f7, x9) ->
                                                            (match f7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 t7, idc7) ->
                                                               (match x9 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                  (match x3 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.opp
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.div
                                                                    (ZRange.four_corners
                                                                    Coq_Z.sub
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12)))))
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12))
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12)))
                                                                    (existsb
                                                                    (Coq_Z.eqb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))
                                                                    which_bitwidths)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x10))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                   | Compilers.Coq_expr.Var (_, _) -> None
                                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                                   | Compilers.Coq_expr.App (_, _, f4, x6) ->
                                     (match f4 with
                                      | Compilers.Coq_expr.Ident (t3, idc3) ->
                                        sequence
                                          (match x6 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, f5, x7) ->
                                             (match f5 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f6, x8) ->
                                                (match f6 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t4, idc4) ->
                                                   (match x8 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t6, idc6) ->
                                                         (match x5 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              s0, _, f7, x9) ->
                                                            (match f7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f8,
                                                                 x10) ->
                                                               (match f8 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                  (match x10 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.div
                                                                    (ZRange.four_corners
                                                                    Coq_Z.add
                                                                    (ZRange.four_corners
                                                                    Coq_Z.add
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15))))
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15))
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15)))
                                                                    (existsb
                                                                    (Coq_Z.eqb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))
                                                                    which_bitwidths)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x13))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                          (match x6 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, f5, x7) ->
                                             (match f5 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, f6, x8) ->
                                                (match f6 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t4, idc4) ->
                                                   (match x8 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      (match x7 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t6, idc6) ->
                                                         (match x5 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              s0, _, f7, x9) ->
                                                            (match f7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f8,
                                                                 x10) ->
                                                               (match f8 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                  (match x10 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (ZRange.opp
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.div
                                                                    (ZRange.four_corners
                                                                    Coq_Z.sub
                                                                    (ZRange.four_corners
                                                                    Coq_Z.sub
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15)))))
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15))
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15)))
                                                                    (existsb
                                                                    (Coq_Z.eqb
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))
                                                                    which_bitwidths)
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x13))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                      | Compilers.Coq_expr.Var (_, _) -> None
                                      | Compilers.Coq_expr.Abs (_, _, _) ->
                                        None
                                      | Compilers.Coq_expr.App (_, _, _, _) ->
                                        None
                                      | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                        None)
                                   | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                     None)
                                | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                  None)
                             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                          | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                       | Compilers.Coq_expr.Var (_, _) -> None
                       | Compilers.Coq_expr.Abs (_, _, _) -> None
                       | Compilers.Coq_expr.App (_, _, _, _) -> None
                       | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                    | Compilers.Coq_expr.Var (_, _) -> None
                    | Compilers.Coq_expr.Abs (_, _, _) -> None
                    | Compilers.Coq_expr.App (_, _, _, _) -> None
                    | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                 | Compilers.Coq_expr.Var (_, _) -> None
                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                 | Compilers.Coq_expr.App (_, _, _, _) -> None
                 | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)), x)),
          x0))))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        z list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 which_bitwidths =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None (all_rewrite_rules which_bitwidths)

    (** val rewrite_head1 :
        z list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteRelaxBitwidthAdcSbb :
        z list ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteRelaxBitwidthAdcSbb which_bitwidths opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            (relax_bitwidth_adc_sbb_rewrite_rulesT which_bitwidths);
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules which_bitwidths));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules which_bitwidths));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S (S
            (S O))));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head which_bitwidths));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1 which_bitwidths)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S (S (S O)))) t0 e
   end
 end

module Coq21_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules =
      []

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Failure

    (** val pr2_rewrite_rules : unit **)

    let pr2_rewrite_rules =
      ()

    (** val all_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules =
      combine_hlist [] (Obj.magic pr2_rewrite_rules)

    (** val rewrite_head :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cast)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 do_again =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None all_rewrite_rules do_again

    (** val rewrite_head1 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteToFancy :
        (z -> z -> z option) -> (z -> z -> z option) ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteToFancy _ _ opts t0 x =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x0 x1 _ ->
        Coq3_Compilers.try_make_base_transport_cps x0 x1)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            fancy_rewrite_rulesT;
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        O t0 x
   end
 end

module Coq22_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
        (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules invert_low0 invert_high0 value_range0 flag_range0 =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (Coq_Z.eqb t3
                               (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3)))
                             (is_bounded_by_bool t3 (ZRange.normalize t2)))
                           (is_bounded_by_bool t11 (ZRange.normalize t10)))
                         (is_bounded_by_bool t9 (ZRange.normalize t8)))
                       (is_tighter_than_bool
                         (ZRange.four_corners_and_zero Coq_Z.shiftl
                           (ZRange.normalize t6)
                           (ZRange.normalize (ZRange.constant t11)))
                         (ZRange.normalize t5)))
                     (is_tighter_than_bool
                       (ZRange.land_bounds (ZRange.normalize t7)
                         (ZRange.normalize (ZRange.constant t9)))
                       (ZRange.normalize t6)))
                   (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                     upper = (Coq_Z.sub t3 (Zpos XH)) }))
                 (Coq_Z.eqb t9 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
               ((&&) (Coq_Z.leb Z0 t11) (Coq_Z.leb t11 (Coq_Z.log2 t3)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (Coq_Z.eqb t3
                               (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3)))
                             (Coq_Z.eqb t9
                               (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
                           ((&&) (Coq_Z.leb Z0 t11)
                             (Coq_Z.leb t11 (Coq_Z.log2 t3))))
                         (is_bounded_by_bool t3 (ZRange.normalize t2)))
                       (is_bounded_by_bool t9 (ZRange.normalize t8)))
                     (is_bounded_by_bool t11 (ZRange.normalize t10)))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftl
                       (ZRange.normalize t6)
                       (ZRange.normalize (ZRange.constant t11)))
                     (ZRange.normalize t5)))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t7)
                     (ZRange.normalize (ZRange.constant t9)))
                   (ZRange.normalize t6)))
               (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x0 t7 t8 t9 t10 t11 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (is_bounded_by_bool t3 (ZRange.normalize t2))
                             (is_bounded_by_bool t8 (ZRange.normalize t7)))
                           (is_bounded_by_bool t10 (ZRange.normalize t9)))
                         (Coq_Z.eqb t3
                           (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                       (is_tighter_than_bool
                         (ZRange.four_corners_and_zero Coq_Z.shiftl
                           (ZRange.normalize t5)
                           (ZRange.normalize (ZRange.constant t10)))
                         (ZRange.normalize t4)))
                     (is_tighter_than_bool
                       (ZRange.land_bounds (ZRange.normalize t6)
                         (ZRange.normalize (ZRange.constant t8)))
                       (ZRange.normalize t5)))
                   (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                     upper = (Coq_Z.sub t3 (Zpos XH)) }))
                 (Coq_Z.eqb t8 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t10))))
               ((&&) (Coq_Z.leb Z0 t10) (Coq_Z.leb t10 (Coq_Z.log2 t3)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t10))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t11)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                     (is_bounded_by_bool t8 (ZRange.normalize t7)))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5)))
               (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t8))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 x0 t6 t7 t8 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                     (is_bounded_by_bool t7 (ZRange.normalize t6)))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t5)
                     (ZRange.normalize (ZRange.constant t7)))
                   (ZRange.normalize t4)))
               (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t7))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t8)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
               (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 t8 x2 t9 t10 t11 t12 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (is_bounded_by_bool t3 (ZRange.normalize t2))
                             (is_bounded_by_bool t10 (ZRange.normalize t9)))
                           (is_bounded_by_bool t12 (ZRange.normalize t11)))
                         (Coq_Z.eqb t3
                           (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                       (is_tighter_than_bool
                         (ZRange.four_corners_and_zero Coq_Z.shiftl
                           (ZRange.normalize t7)
                           (ZRange.normalize (ZRange.constant t12)))
                         (ZRange.normalize t6)))
                     (is_tighter_than_bool
                       (ZRange.land_bounds (ZRange.normalize t8)
                         (ZRange.normalize (ZRange.constant t10)))
                       (ZRange.normalize t7)))
                   (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                     upper = (Coq_Z.sub t3 (Zpos XH)) }))
                 (Coq_Z.eqb t10 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t12))))
               ((&&) (Coq_Z.leb Z0 t12) (Coq_Z.leb t12 (Coq_Z.log2 t3)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_addc)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t12))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 t12 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (is_bounded_by_bool t3 (ZRange.normalize t2))
                             (is_bounded_by_bool t9 (ZRange.normalize t8)))
                           (is_bounded_by_bool t11 (ZRange.normalize t10)))
                         (Coq_Z.eqb t3
                           (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                       (is_tighter_than_bool
                         (ZRange.four_corners_and_zero Coq_Z.shiftl
                           (ZRange.normalize t6)
                           (ZRange.normalize (ZRange.constant t11)))
                         (ZRange.normalize t5)))
                     (is_tighter_than_bool (ZRange.normalize t5) { lower =
                       Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t7)
                       (ZRange.normalize (ZRange.constant t9)))
                     (ZRange.normalize t6)))
                 (Coq_Z.eqb t9 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
               ((&&) (Coq_Z.leb Z0 t11) (Coq_Z.leb t11 (Coq_Z.log2 t3)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_addc)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t12)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 x2 t8 t9 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                     (is_bounded_by_bool t9 (ZRange.normalize t8)))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t7)
                     (ZRange.normalize (ZRange.constant t9)))
                   (ZRange.normalize t6)))
               (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_addc)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t9))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 t9 x2 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                     (is_bounded_by_bool t8 (ZRange.normalize t7)))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5)))
               (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_addc)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t8))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t9)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
               (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_addc)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (is_bounded_by_bool t3 (ZRange.normalize t2))
                             (is_bounded_by_bool t9 (ZRange.normalize t8)))
                           (is_bounded_by_bool t11 (ZRange.normalize t10)))
                         (Coq_Z.eqb t3
                           (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                       (is_tighter_than_bool
                         (ZRange.four_corners_and_zero Coq_Z.shiftl
                           (ZRange.normalize t6)
                           (ZRange.normalize (ZRange.constant t11)))
                         (ZRange.normalize t5)))
                     (is_tighter_than_bool (ZRange.normalize t5) { lower =
                       Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t7)
                       (ZRange.normalize (ZRange.constant t9)))
                     (ZRange.normalize t6)))
                 (Coq_Z.eqb t9 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
               ((&&) (Coq_Z.leb Z0 t11) (Coq_Z.leb t11 (Coq_Z.log2 t3)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                     (is_bounded_by_bool t8 (ZRange.normalize t7)))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5)))
               (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t8))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
          if (&&)
               ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
               (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_sub)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 t8 x2 t9 t10 t11 t12 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (is_bounded_by_bool t3 (ZRange.normalize t2))
                             (is_bounded_by_bool t10 (ZRange.normalize t9)))
                           (is_bounded_by_bool t12 (ZRange.normalize t11)))
                         (Coq_Z.eqb t3
                           (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                       (is_tighter_than_bool
                         (ZRange.four_corners_and_zero Coq_Z.shiftl
                           (ZRange.normalize t7)
                           (ZRange.normalize (ZRange.constant t12)))
                         (ZRange.normalize t6)))
                     (is_tighter_than_bool (ZRange.normalize t6) { lower =
                       Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t8)
                       (ZRange.normalize (ZRange.constant t10)))
                     (ZRange.normalize t7)))
                 (Coq_Z.eqb t10 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t12))))
               ((&&) (Coq_Z.leb Z0 t12) (Coq_Z.leb t12 (Coq_Z.log2 t3)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_subb)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t12))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 x2 t8 t9 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                     (is_bounded_by_bool t9 (ZRange.normalize t8)))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t7)
                     (ZRange.normalize (ZRange.constant t9)))
                   (ZRange.normalize t6)))
               (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_subb)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t9))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
               (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                 upper = (Coq_Z.sub t3 (Zpos XH)) })
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_subb)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_rshi)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 x0 t4 x1 t5 t6 ->
          if (&&)
               ((&&) (is_bounded_by_bool t2 (ZRange.normalize t1))
                 (is_bounded_by_bool t6 (ZRange.normalize t5)))
               (Coq_Z.eqb t2 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t2)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_rshi)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t2))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t6))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t3)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cc_m)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                 (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
               (is_tighter_than_bool
                 (ZRange.two_corners (Coq1_Z.cc_m t3) (ZRange.normalize t4))
                 (ZRange.normalize t1))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_selm)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t6)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
          if (&&)
               ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t2))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant (Zpos XH)))
                     (ZRange.normalize t4)) (ZRange.normalize t1)))
               (Coq_Z.eqb t3 (Zpos XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_sell)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t6)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 x1 t6 x2 ->
          if (&&)
               ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t3))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant (Zpos XH))))
                   (ZRange.normalize t1))) (Coq_Z.eqb t4 (Zpos XH))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x3)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_sell)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t5)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t6)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x2)))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
            (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_fancy_selc)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2))))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_modulo)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 x1 x2 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x3 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x3)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            Coq3_Compilers.Coq_ident_fancy_addm)), (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
            ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2))))))))) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_low0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)) t2)
                         None))
                     (is_bounded_by_bool t2 (ZRange.normalize t1)))
                   (is_bounded_by_bool t6 (ZRange.normalize t5)))
                 (Coq_Z.eqb t6
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize t4)
                   (ZRange.normalize (ZRange.constant t6)))
                 (ZRange.normalize t3))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_low0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)) t2 with
                    | Some x -> Obj.magic x
                    | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x0 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_low0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)) t2)
                         None))
                     (is_bounded_by_bool t2 (ZRange.normalize t1)))
                   (is_bounded_by_bool t5 (ZRange.normalize t4)))
                 (Coq_Z.eqb t5
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize (ZRange.constant t5))
                   (ZRange.normalize t6)) (ZRange.normalize t3))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_low0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)) t2 with
                    | Some x -> Obj.magic x
                    | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   (negb
                     (option_beq0 Coq_Z.eqb
                       (invert_low0 (Coq_Z.mul (Zpos (XO XH)) t6) t2) None))
                   (is_bounded_by_bool t2 (ZRange.normalize t1)))
                 (is_bounded_by_bool t6 (ZRange.normalize t5)))
               (is_tighter_than_bool
                 (ZRange.four_corners_and_zero Coq_Z.shiftr
                   (ZRange.normalize t4)
                   (ZRange.normalize (ZRange.constant t6)))
                 (ZRange.normalize t3))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mullh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t6))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_low0 (Coq_Z.mul (Zpos (XO XH)) t6) t2 with
                    | Some x -> Obj.magic x
                    | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x0 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_high0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)) t2)
                         None))
                     (is_bounded_by_bool t2 (ZRange.normalize t1)))
                   (is_bounded_by_bool t5 (ZRange.normalize t4)))
                 (Coq_Z.eqb t5
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize (ZRange.constant t5))
                   (ZRange.normalize t6)) (ZRange.normalize t3))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_high0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)) t2 with
                    | Some x -> Obj.magic x
                    | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_high0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)) t2)
                         None))
                     (is_bounded_by_bool t2 (ZRange.normalize t1)))
                   (is_bounded_by_bool t6 (ZRange.normalize t5)))
                 (Coq_Z.eqb t6
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize t4)
                   (ZRange.normalize (ZRange.constant t6)))
                 (ZRange.normalize t3))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_high0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)) t2 with
                    | Some x -> Obj.magic x
                    | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   (negb
                     (option_beq0 Coq_Z.eqb
                       (invert_high0 (Coq_Z.mul (Zpos (XO XH)) t6) t2) None))
                   (is_bounded_by_bool t2 (ZRange.normalize t1)))
                 (is_bounded_by_bool t6 (ZRange.normalize t5)))
               (is_tighter_than_bool
                 (ZRange.four_corners_and_zero Coq_Z.shiftr
                   (ZRange.normalize t4)
                   (ZRange.normalize (ZRange.constant t6)))
                 (ZRange.normalize t3))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t6))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_high0 (Coq_Z.mul (Zpos (XO XH)) t6) t2 with
                    | Some x -> Obj.magic x
                    | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_low0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)) t6)
                         None))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (Coq_Z.eqb t3
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize (ZRange.constant t3))
                   (ZRange.normalize t4)) (ZRange.normalize t1))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_low0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)) t6 with
                    | Some y -> Obj.magic y
                    | None -> Obj.magic Z0))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_low0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)) t6)
                         None))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (is_bounded_by_bool t4 (ZRange.normalize t3)))
                 (Coq_Z.eqb t4
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize t2)
                   (ZRange.normalize (ZRange.constant t4)))
                 (ZRange.normalize t1))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_low0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)) t6 with
                    | Some y -> Obj.magic y
                    | None -> Obj.magic Z0))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_high0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)) t6)
                         None))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (is_bounded_by_bool t3 (ZRange.normalize t2)))
                 (Coq_Z.eqb t3
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize (ZRange.constant t3))
                   (ZRange.normalize t4)) (ZRange.normalize t1))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mullh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_high0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)) t6 with
                    | Some y -> Obj.magic y
                    | None -> Obj.magic Z0))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_high0
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)) t6)
                         None))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (is_bounded_by_bool t4 (ZRange.normalize t3)))
                 (Coq_Z.eqb t4
                   (Coq_Z.sub
                     (Coq_Z.pow (Zpos (XO XH))
                       (Coq_Z.div
                         (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)) (Zpos
                         (XO XH)))) (Zpos XH))))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize t2)
                   (ZRange.normalize (ZRange.constant t4)))
                 (ZRange.normalize t1))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mullh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_high0
                            (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)) t6 with
                    | Some y -> Obj.magic y
                    | None -> Obj.magic Z0))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   (negb
                     (option_beq0 Coq_Z.eqb
                       (invert_low0 (Coq_Z.mul (Zpos (XO XH)) t4) t6) None))
                   (is_bounded_by_bool t6 (ZRange.normalize t5)))
                 (is_bounded_by_bool t4 (ZRange.normalize t3)))
               (is_tighter_than_bool
                 (ZRange.four_corners_and_zero Coq_Z.shiftr
                   (ZRange.normalize t2)
                   (ZRange.normalize (ZRange.constant t4)))
                 (ZRange.normalize t1))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_low0 (Coq_Z.mul (Zpos (XO XH)) t4) t6 with
                    | Some y -> Obj.magic y
                    | None -> Obj.magic Z0))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
          if (&&)
               ((&&)
                 ((&&)
                   (negb
                     (option_beq0 Coq_Z.eqb
                       (invert_high0 (Coq_Z.mul (Zpos (XO XH)) t4) t6) None))
                   (is_bounded_by_bool t6 (ZRange.normalize t5)))
                 (is_bounded_by_bool t4 (ZRange.normalize t3)))
               (is_tighter_than_bool
                 (ZRange.four_corners_and_zero Coq_Z.shiftr
                   (ZRange.normalize t2)
                   (ZRange.normalize (ZRange.constant t4)))
                 (ZRange.normalize t1))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (match invert_high0 (Coq_Z.mul (Zpos (XO XH)) t4) t6 with
                    | Some y -> Obj.magic y
                    | None -> Obj.magic Z0))))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 t8 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t7 (ZRange.normalize t6)))
                     (Coq_Z.eqb t3
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (Coq_Z.eqb t7
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t3))
                     (ZRange.normalize t4)) (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize (ZRange.constant t7))
                   (ZRange.normalize t8)) (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 t7 t8 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                       (is_bounded_by_bool t7 (ZRange.normalize t6)))
                     (Coq_Z.eqb t4
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (Coq_Z.eqb t7
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize (ZRange.constant t7))
                   (ZRange.normalize t8)) (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t3
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (Coq_Z.eqb t8
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t3))
                     (ZRange.normalize t4)) (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize t6)
                   (ZRange.normalize (ZRange.constant t8)))
                 (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t4
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (Coq_Z.eqb t8
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize t6)
                   (ZRange.normalize (ZRange.constant t8)))
                 (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulll)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                     (is_bounded_by_bool t8 (ZRange.normalize t7)))
                   (Coq_Z.eqb t3
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t8) (Zpos (XO
                           XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t3))
                     (ZRange.normalize t4)) (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.four_corners_and_zero Coq_Z.shiftr
                   (ZRange.normalize t6)
                   (ZRange.normalize (ZRange.constant t8)))
                 (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mullh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t8))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                     (is_bounded_by_bool t8 (ZRange.normalize t7)))
                   (Coq_Z.eqb t4
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t8) (Zpos (XO
                           XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.four_corners_and_zero Coq_Z.shiftr
                   (ZRange.normalize t6)
                   (ZRange.normalize (ZRange.constant t8)))
                 (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mullh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t8))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 t7 t8 x1 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t7 (ZRange.normalize t6))
                     (is_bounded_by_bool t4 (ZRange.normalize t3)))
                   (Coq_Z.eqb t7
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t4) (Zpos (XO
                           XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize (ZRange.constant t7))
                   (ZRange.normalize t8)) (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t8 (ZRange.normalize t7))
                     (is_bounded_by_bool t4 (ZRange.normalize t3)))
                   (Coq_Z.eqb t8
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t4) (Zpos (XO
                           XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.land_bounds (ZRange.normalize t6)
                   (ZRange.normalize (ZRange.constant t8)))
                 (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhl)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                     (is_bounded_by_bool t8 (ZRange.normalize t7)))
                   (Coq_Z.eqb t4 t8))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1)))
               (is_tighter_than_bool
                 (ZRange.four_corners_and_zero Coq_Z.shiftr
                   (ZRange.normalize t6)
                   (ZRange.normalize (ZRange.constant t8)))
                 (ZRange.normalize t5))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))),
                   Coq3_Compilers.Coq_ident_fancy_mulhh)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z,
                   (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) })) :: ((ExistT
        ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 x0 ->
          if (||) (is_tighter_than_bool t0 value_range0)
               (is_tighter_than_bool t0 flag_range0)
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x1)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))
          else None)) })) :: []))))))))))))))))))))))))))))))))))))))))))))

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast2,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_pair,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S O),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S O)),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S O))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S O)))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S O))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S O))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S O)))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S O))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S
        O)))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S
        O))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        O)))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S O))))))))), Coq1_Compilers.RewriteRules.Compile.Failure))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S O)))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftl,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O)))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O)))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_mul,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S O)))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S O))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S O)))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S O))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))))))))))))))))))))))))))))))))))) :: []),
        None, Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S O))))))))))))))))))))))))))))))))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S O)))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_shiftr,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_zselect,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cc_m,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: ((Coq3_Compilers.Coq_raw_ident_Z_land,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S O))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_rshi,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S O),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Swap ((S (S O)),
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_cast,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Literal,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S O))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S
        O)))))))))))))))))))))))))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: [])), (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_Z_add_modulo,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf ((S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S O)))))))))))))))))))))),
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
        ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules invert_low0 invert_high0 value_range0 flag_range0 =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 ->
          if (&&)
               ((&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             (Coq_Z.eqb t3
                               (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3)))
                             (is_bounded_by_bool t3 (ZRange.normalize t2)))
                           (is_bounded_by_bool t11 (ZRange.normalize t10)))
                         (is_bounded_by_bool t9 (ZRange.normalize t8)))
                       (is_tighter_than_bool
                         (ZRange.four_corners_and_zero Coq_Z.shiftl
                           (ZRange.normalize t6)
                           (ZRange.normalize (ZRange.constant t11)))
                         (ZRange.normalize t5)))
                     (is_tighter_than_bool
                       (ZRange.land_bounds (ZRange.normalize t7)
                         (ZRange.normalize (ZRange.constant t9)))
                       (ZRange.normalize t6)))
                   (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                     upper = (Coq_Z.sub t3 (Zpos XH)) }))
                 (Coq_Z.eqb t9 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
               ((&&) (Coq_Z.leb Z0 t11) (Coq_Z.leb t11 (Coq_Z.log2 t3)))
          then Some
                 (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                   (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                     Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                     Coq3_Compilers.buildEagerIdent
                     Coq3_Compilers.toRestrictedIdent
                     Coq3_Compilers.invertIdent
                     Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                     Coq3_Compilers.try_make_base_transport_cps x x2)) false
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))),
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))),
                   Coq3_Compilers.Coq_ident_Z_cast2)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)))))))),
                   (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t0)))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t1)))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))),
                   Coq3_Compilers.Coq_ident_fancy_add)),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))), (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                   (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_prod
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z),
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, t4)))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
                   (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Coq_zrange)),
                   (Coq3_Compilers.Coq_ident_Literal
                   (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                   (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), x1)))))))))))))
          else None)) }; Primitive.snd =
        (Obj.magic { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               (Coq_Z.eqb t3
                                 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3)))
                               (Coq_Z.eqb t9
                                 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
                             ((&&) (Coq_Z.leb Z0 t11)
                               (Coq_Z.leb t11 (Coq_Z.log2 t3))))
                           (is_bounded_by_bool t3 (ZRange.normalize t2)))
                         (is_bounded_by_bool t9 (ZRange.normalize t8)))
                       (is_bounded_by_bool t11 (ZRange.normalize t10)))
                     (is_tighter_than_bool
                       (ZRange.four_corners_and_zero Coq_Z.shiftl
                         (ZRange.normalize t6)
                         (ZRange.normalize (ZRange.constant t11)))
                       (ZRange.normalize t5)))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t7)
                       (ZRange.normalize (ZRange.constant t9)))
                     (ZRange.normalize t6)))
                 (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x0 t7 t8 t9 t10 t11 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               (is_bounded_by_bool t3 (ZRange.normalize t2))
                               (is_bounded_by_bool t8 (ZRange.normalize t7)))
                             (is_bounded_by_bool t10 (ZRange.normalize t9)))
                           (Coq_Z.eqb t3
                             (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                         (is_tighter_than_bool
                           (ZRange.four_corners_and_zero Coq_Z.shiftl
                             (ZRange.normalize t5)
                             (ZRange.normalize (ZRange.constant t10)))
                           (ZRange.normalize t4)))
                       (is_tighter_than_bool
                         (ZRange.land_bounds (ZRange.normalize t6)
                           (ZRange.normalize (ZRange.constant t8)))
                         (ZRange.normalize t5)))
                     (is_tighter_than_bool (ZRange.normalize t4) { lower =
                       Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                   (Coq_Z.eqb t8 (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t10))))
                 ((&&) (Coq_Z.leb Z0 t10) (Coq_Z.leb t10 (Coq_Z.log2 t3)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t10))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t11)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t6)
                       (ZRange.normalize (ZRange.constant t8)))
                     (ZRange.normalize t5)))
                 (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t8))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 x0 t6 t7 t8 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t7 (ZRange.normalize t6)))
                     (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t5)
                       (ZRange.normalize (ZRange.constant t7)))
                     (ZRange.normalize t4)))
                 (is_tighter_than_bool (ZRange.normalize t4) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t7))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t8)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_add)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic
            (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 t8 x2 t9 t10 t11 t12 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               (is_bounded_by_bool t3 (ZRange.normalize t2))
                               (is_bounded_by_bool t10 (ZRange.normalize t9)))
                             (is_bounded_by_bool t12 (ZRange.normalize t11)))
                           (Coq_Z.eqb t3
                             (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                         (is_tighter_than_bool
                           (ZRange.four_corners_and_zero Coq_Z.shiftl
                             (ZRange.normalize t7)
                             (ZRange.normalize (ZRange.constant t12)))
                           (ZRange.normalize t6)))
                       (is_tighter_than_bool
                         (ZRange.land_bounds (ZRange.normalize t8)
                           (ZRange.normalize (ZRange.constant t10)))
                         (ZRange.normalize t7)))
                     (is_tighter_than_bool (ZRange.normalize t6) { lower =
                       Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                   (Coq_Z.eqb t10
                     (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t12))))
                 ((&&) (Coq_Z.leb Z0 t12) (Coq_Z.leb t12 (Coq_Z.log2 t3)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_addc)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t12))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic
            (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 t12 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               (is_bounded_by_bool t3 (ZRange.normalize t2))
                               (is_bounded_by_bool t9 (ZRange.normalize t8)))
                             (is_bounded_by_bool t11 (ZRange.normalize t10)))
                           (Coq_Z.eqb t3
                             (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                         (is_tighter_than_bool
                           (ZRange.four_corners_and_zero Coq_Z.shiftl
                             (ZRange.normalize t6)
                             (ZRange.normalize (ZRange.constant t11)))
                           (ZRange.normalize t5)))
                       (is_tighter_than_bool (ZRange.normalize t5) { lower =
                         Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                     (is_tighter_than_bool
                       (ZRange.land_bounds (ZRange.normalize t7)
                         (ZRange.normalize (ZRange.constant t9)))
                       (ZRange.normalize t6)))
                   (Coq_Z.eqb t9
                     (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
                 ((&&) (Coq_Z.leb Z0 t11) (Coq_Z.leb t11 (Coq_Z.log2 t3)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_addc)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t12)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 x2 t8 t9 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t9 (ZRange.normalize t8)))
                     (Coq_Z.eqb t3
                       (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t7)
                       (ZRange.normalize (ZRange.constant t9)))
                     (ZRange.normalize t6)))
                 (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_addc)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t9))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 t9 x2 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t3
                       (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t6)
                       (ZRange.normalize (ZRange.constant t8)))
                     (ZRange.normalize t5)))
                 (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_addc)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t8))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t9)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_addc)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 x1 t8 t9 t10 t11 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               (is_bounded_by_bool t3 (ZRange.normalize t2))
                               (is_bounded_by_bool t9 (ZRange.normalize t8)))
                             (is_bounded_by_bool t11 (ZRange.normalize t10)))
                           (Coq_Z.eqb t3
                             (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                         (is_tighter_than_bool
                           (ZRange.four_corners_and_zero Coq_Z.shiftl
                             (ZRange.normalize t6)
                             (ZRange.normalize (ZRange.constant t11)))
                           (ZRange.normalize t5)))
                       (is_tighter_than_bool (ZRange.normalize t5) { lower =
                         Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                     (is_tighter_than_bool
                       (ZRange.land_bounds (ZRange.normalize t7)
                         (ZRange.normalize (ZRange.constant t9)))
                       (ZRange.normalize t6)))
                   (Coq_Z.eqb t9
                     (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t11))))
                 ((&&) (Coq_Z.leb Z0 t11) (Coq_Z.leb t11 (Coq_Z.log2 t3)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t11))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t3
                       (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t6)
                       (ZRange.normalize (ZRange.constant t8)))
                     (ZRange.normalize t5)))
                 (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t8))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool (ZRange.normalize t5) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_sub)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t5))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic
            (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 t8 x2 t9 t10 t11 t12 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&)
                         ((&&)
                           ((&&)
                             ((&&)
                               (is_bounded_by_bool t3 (ZRange.normalize t2))
                               (is_bounded_by_bool t10 (ZRange.normalize t9)))
                             (is_bounded_by_bool t12 (ZRange.normalize t11)))
                           (Coq_Z.eqb t3
                             (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                         (is_tighter_than_bool
                           (ZRange.four_corners_and_zero Coq_Z.shiftl
                             (ZRange.normalize t7)
                             (ZRange.normalize (ZRange.constant t12)))
                           (ZRange.normalize t6)))
                       (is_tighter_than_bool (ZRange.normalize t6) { lower =
                         Z0; upper = (Coq_Z.sub t3 (Zpos XH)) }))
                     (is_tighter_than_bool
                       (ZRange.land_bounds (ZRange.normalize t8)
                         (ZRange.normalize (ZRange.constant t10)))
                       (ZRange.normalize t7)))
                   (Coq_Z.eqb t10
                     (Coq_Z.ones (Coq_Z.sub (Coq_Z.log2 t3) t12))))
                 ((&&) (Coq_Z.leb Z0 t12) (Coq_Z.leb t12 (Coq_Z.log2 t3)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_subb)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t12))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 t7 x2 t8 t9 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t9 (ZRange.normalize t8)))
                     (Coq_Z.eqb t3
                       (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t7)
                       (ZRange.normalize (ZRange.constant t9)))
                     (ZRange.normalize t6)))
                 (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_subb)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.opp t9))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t7))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool (ZRange.normalize t6) { lower = Z0;
                   upper = (Coq_Z.sub t3 (Zpos XH)) })
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))),
                     Coq3_Compilers.Coq_ident_Z_cast2)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t1)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_fancy_subb)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Z0))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 x0 t4 x1 t5 t6 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t2 (ZRange.normalize t1))
                   (is_bounded_by_bool t6 (ZRange.normalize t5)))
                 (Coq_Z.eqb t2 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t2)))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_rshi)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t2))))))),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic t6))))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t3)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t4)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                   (Coq_Z.eqb t3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 t3))))
                 (is_tighter_than_bool
                   (ZRange.two_corners (Coq1_Z.cc_m t3)
                     (ZRange.normalize t4)) (ZRange.normalize t1))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_selm)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z, (Obj.magic Coq_Z.log2 t3))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t6)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 x1 t6 x2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t2))
                   (is_tighter_than_bool
                     (ZRange.land_bounds
                       (ZRange.normalize (ZRange.constant (Zpos XH)))
                       (ZRange.normalize t4)) (ZRange.normalize t1)))
                 (Coq_Z.eqb t3 (Zpos XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_sell)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t6)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 x1 t6 x2 ->
            if (&&)
                 ((&&) (is_bounded_by_bool (Zpos XH) (ZRange.normalize t3))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t2)
                       (ZRange.normalize (ZRange.constant (Zpos XH))))
                     (ZRange.normalize t1))) (Coq_Z.eqb t4 (Zpos XH))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x3))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_sell)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t5)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t6)))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x2)))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_cast)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Coq3_Compilers.Coq_ident_Literal
              (Coq3_Compilers.Coq_zrange, t0)))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_fancy_selc)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2))))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun x0 x1 x2 -> Some
            (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
              (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                Coq3_Compilers.buildEagerIdent
                Coq3_Compilers.toRestrictedIdent Coq3_Compilers.invertIdent
                Coq3_Compilers.baseHasNatCorrect (fun _ x x3 _ ->
                Coq3_Compilers.try_make_base_transport_cps x x3)) false
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_fancy_addm)),
              (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_expr.Var
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x1)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              x2))))))))) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_low0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6))
                             t2) None))
                       (is_bounded_by_bool t2 (ZRange.normalize t1)))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (Coq_Z.eqb t6
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t4)
                     (ZRange.normalize (ZRange.constant t6)))
                   (ZRange.normalize t3))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_low0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6))
                              t2 with
                      | Some x -> Obj.magic x
                      | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x0 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_low0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5))
                             t2) None))
                       (is_bounded_by_bool t2 (ZRange.normalize t1)))
                     (is_bounded_by_bool t5 (ZRange.normalize t4)))
                   (Coq_Z.eqb t5
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t5))
                     (ZRange.normalize t6)) (ZRange.normalize t3))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_low0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5))
                              t2 with
                      | Some x -> Obj.magic x
                      | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_low0 (Coq_Z.mul (Zpos (XO XH)) t6) t2) None))
                     (is_bounded_by_bool t2 (ZRange.normalize t1)))
                   (is_bounded_by_bool t6 (ZRange.normalize t5)))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t4)
                     (ZRange.normalize (ZRange.constant t6)))
                   (ZRange.normalize t3))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mullh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t6))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_low0 (Coq_Z.mul (Zpos (XO XH)) t6) t2 with
                      | Some x -> Obj.magic x
                      | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 t5 t6 x0 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_high0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5))
                             t2) None))
                       (is_bounded_by_bool t2 (ZRange.normalize t1)))
                     (is_bounded_by_bool t5 (ZRange.normalize t4)))
                   (Coq_Z.eqb t5
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t5))
                     (ZRange.normalize t6)) (ZRange.normalize t3))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_high0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t5))
                              t2 with
                      | Some x -> Obj.magic x
                      | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_high0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6))
                             t2) None))
                       (is_bounded_by_bool t2 (ZRange.normalize t1)))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (Coq_Z.eqb t6
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t4)
                     (ZRange.normalize (ZRange.constant t6)))
                   (ZRange.normalize t3))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_high0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t6))
                              t2 with
                      | Some x -> Obj.magic x
                      | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_high0 (Coq_Z.mul (Zpos (XO XH)) t6) t2)
                         None))
                     (is_bounded_by_bool t2 (ZRange.normalize t1)))
                   (is_bounded_by_bool t6 (ZRange.normalize t5)))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t4)
                     (ZRange.normalize (ZRange.constant t6)))
                   (ZRange.normalize t3))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t6))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_high0 (Coq_Z.mul (Zpos (XO XH)) t6) t2 with
                      | Some x -> Obj.magic x
                      | None -> Obj.magic Z0))))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_low0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                             t6) None))
                       (is_bounded_by_bool t6 (ZRange.normalize t5)))
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (Coq_Z.eqb t3
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t3))
                     (ZRange.normalize t4)) (ZRange.normalize t1))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_low0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                              t6 with
                      | Some y -> Obj.magic y
                      | None -> Obj.magic Z0))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_low0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                             t6) None))
                       (is_bounded_by_bool t6 (ZRange.normalize t5)))
                     (is_bounded_by_bool t4 (ZRange.normalize t3)))
                   (Coq_Z.eqb t4
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_low0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                              t6 with
                      | Some y -> Obj.magic y
                      | None -> Obj.magic Z0))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_high0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                             t6) None))
                       (is_bounded_by_bool t6 (ZRange.normalize t5)))
                     (is_bounded_by_bool t3 (ZRange.normalize t2)))
                   (Coq_Z.eqb t3
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t3))
                     (ZRange.normalize t4)) (ZRange.normalize t1))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mullh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_high0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                              t6 with
                      | Some y -> Obj.magic y
                      | None -> Obj.magic Z0))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       (negb
                         (option_beq0 Coq_Z.eqb
                           (invert_high0
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                             t6) None))
                       (is_bounded_by_bool t6 (ZRange.normalize t5)))
                     (is_bounded_by_bool t4 (ZRange.normalize t3)))
                   (Coq_Z.eqb t4
                     (Coq_Z.sub
                       (Coq_Z.pow (Zpos (XO XH))
                         (Coq_Z.div
                           (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                           (Zpos (XO XH)))) (Zpos XH))))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mullh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_high0
                              (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                              t6 with
                      | Some y -> Obj.magic y
                      | None -> Obj.magic Z0))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_low0 (Coq_Z.mul (Zpos (XO XH)) t4) t6) None))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (is_bounded_by_bool t4 (ZRange.normalize t3)))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_low0 (Coq_Z.mul (Zpos (XO XH)) t4) t6 with
                      | Some y -> Obj.magic y
                      | None -> Obj.magic Z0))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 ->
            if (&&)
                 ((&&)
                   ((&&)
                     (negb
                       (option_beq0 Coq_Z.eqb
                         (invert_high0 (Coq_Z.mul (Zpos (XO XH)) t4) t6)
                         None))
                     (is_bounded_by_bool t6 (ZRange.normalize t5)))
                   (is_bounded_by_bool t4 (ZRange.normalize t3)))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t2)
                     (ZRange.normalize (ZRange.constant t4)))
                   (ZRange.normalize t1))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (match invert_high0 (Coq_Z.mul (Zpos (XO XH)) t4) t6 with
                      | Some y -> Obj.magic y
                      | None -> Obj.magic Z0))))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 t7 t8 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                         (is_bounded_by_bool t7 (ZRange.normalize t6)))
                       (Coq_Z.eqb t3
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.div
                               (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                               (Zpos (XO XH)))) (Zpos XH))))
                     (Coq_Z.eqb t7
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.land_bounds
                       (ZRange.normalize (ZRange.constant t3))
                       (ZRange.normalize t4)) (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t7))
                     (ZRange.normalize t8)) (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 t7 t8 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                         (is_bounded_by_bool t7 (ZRange.normalize t6)))
                       (Coq_Z.eqb t4
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.div
                               (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                               (Zpos (XO XH)))) (Zpos XH))))
                     (Coq_Z.eqb t7
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t2)
                       (ZRange.normalize (ZRange.constant t4)))
                     (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t7))
                     (ZRange.normalize t8)) (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                         (is_bounded_by_bool t8 (ZRange.normalize t7)))
                       (Coq_Z.eqb t3
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.div
                               (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                               (Zpos (XO XH)))) (Zpos XH))))
                     (Coq_Z.eqb t8
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.land_bounds
                       (ZRange.normalize (ZRange.constant t3))
                       (ZRange.normalize t4)) (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t3)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&)
                       ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                         (is_bounded_by_bool t8 (ZRange.normalize t7)))
                       (Coq_Z.eqb t4
                         (Coq_Z.sub
                           (Coq_Z.pow (Zpos (XO XH))
                             (Coq_Z.div
                               (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                               (Zpos (XO XH)))) (Zpos XH))))
                     (Coq_Z.eqb t8
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div
                             (Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4))
                             (Zpos (XO XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t2)
                       (ZRange.normalize (ZRange.constant t4)))
                     (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulll)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) (Coq_Z.log2_up t4)))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 t3 t4 x0 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t3 (ZRange.normalize t2))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t3
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t8) (Zpos (XO
                             XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.land_bounds
                       (ZRange.normalize (ZRange.constant t3))
                       (ZRange.normalize t4)) (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mullh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t8))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t4))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t4
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t8) (Zpos (XO
                             XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.land_bounds (ZRange.normalize t2)
                       (ZRange.normalize (ZRange.constant t4)))
                     (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mullh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t8))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 t7 t8 x1 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t7 (ZRange.normalize t6))
                       (is_bounded_by_bool t4 (ZRange.normalize t3)))
                     (Coq_Z.eqb t7
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t4) (Zpos (XO
                             XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t2)
                       (ZRange.normalize (ZRange.constant t4)))
                     (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.land_bounds
                     (ZRange.normalize (ZRange.constant t7))
                     (ZRange.normalize t8)) (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t8))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t8 (ZRange.normalize t7))
                       (is_bounded_by_bool t4 (ZRange.normalize t3)))
                     (Coq_Z.eqb t8
                       (Coq_Z.sub
                         (Coq_Z.pow (Zpos (XO XH))
                           (Coq_Z.div (Coq_Z.mul (Zpos (XO XH)) t4) (Zpos (XO
                             XH)))) (Zpos XH))))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t2)
                       (ZRange.normalize (ZRange.constant t4)))
                     (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.land_bounds (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhl)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 t1 t2 x0 t3 t4 t5 t6 x1 t7 t8 ->
            if (&&)
                 ((&&)
                   ((&&)
                     ((&&) (is_bounded_by_bool t4 (ZRange.normalize t3))
                       (is_bounded_by_bool t8 (ZRange.normalize t7)))
                     (Coq_Z.eqb t4 t8))
                   (is_tighter_than_bool
                     (ZRange.four_corners_and_zero Coq_Z.shiftr
                       (ZRange.normalize t2)
                       (ZRange.normalize (ZRange.constant t4)))
                     (ZRange.normalize t1)))
                 (is_tighter_than_bool
                   (ZRange.four_corners_and_zero Coq_Z.shiftr
                     (ZRange.normalize t6)
                     (ZRange.normalize (ZRange.constant t8)))
                   (ZRange.normalize t5))
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x2))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, t0)))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))),
                     Coq3_Compilers.Coq_ident_fancy_mulhh)),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))))),
                     (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Z,
                     (Obj.magic Coq_Z.mul (Zpos (XO XH)) t4))))))),
                     (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_prod
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_pair
                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z),
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t2))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t6))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x1)))))))))))))
            else None)) }; Primitive.snd = { Primitive.fst =
          { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
          Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
          Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
          Coq1_Compilers.RewriteRules.Compile.rew_replacement =
          (Obj.magic (fun t0 x0 ->
            if (||) (is_tighter_than_bool t0 value_range0)
                 (is_tighter_than_bool t0 flag_range0)
            then Some
                   (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                     (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                       Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
                       Coq3_Compilers.buildEagerIdent
                       Coq3_Compilers.toRestrictedIdent
                       Coq3_Compilers.invertIdent
                       Coq3_Compilers.baseHasNatCorrect (fun _ x x1 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x x1))
                     false (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)) (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_expr.App
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
                     ((Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Compilers.Coq_type.Coq_arrow
                     ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)))))),
                     Coq3_Compilers.Coq_ident_Z_cast)),
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Coq_zrange)),
                     (Coq3_Compilers.Coq_ident_Literal
                     (Coq3_Compilers.Coq_zrange, (Obj.magic t0))))))),
                     (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_type_base
                     Coq3_Compilers.Z)), x0)))))
            else None)) }; Primitive.snd =
          () } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } } }) }

    (** val all_rewrite_rules :
        (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules invert_low0 invert_high0 value_range0 flag_range0 =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_with_get_carry)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftl)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_pattern_ident_Z_cast2)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))))),
        (Coq3_Compilers.Coq_pattern_ident_pair
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z),
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_sub_with_get_borrow)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_rshi)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cc_m)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_zselect)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_pattern_ident_Z_add_modulo)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_land)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_mul)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_shiftr)),
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Z))))))))))))) } :: ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_pattern_ident_Z_cast)),
        (Coq1_Compilers.Coq_pattern.Ident ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)),
        (Coq3_Compilers.Coq_pattern_ident_Literal
        Coq3_Compilers.Coq_zrange))))), (Coq1_Compilers.Coq_pattern.Wildcard
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: [])))))))))))))))))))))))))))))))))))))))))))))
        (Obj.magic pr2_rewrite_rules invert_low0 invert_high0 value_range0
          flag_range0)

    (** val rewrite_head :
        (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head invert_low0 invert_high0 value_range0 flag_range0 _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_value_barrier)), x)))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 ->
        sequence_return0
          (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                   (fun x2 y ->
                   match x2 with
                   | Coq3_Compilers.Z ->
                     (match y with
                      | Coq3_Compilers.Z -> true
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_bool ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> true
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_nat ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> true
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_zrange ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> true
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_string ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> true))
                   (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_arrow
                   ((Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)))) with
           | Some vars0 ->
             let (a, _) = Obj.magic vars0 in
             let (_, _) = a in
             if Compilers.Coq_type.type_beq
                  (Compilers.Coq_base.Coq_type.type_beq (fun x2 y ->
                    match x2 with
                    | Coq3_Compilers.Z ->
                      (match y with
                       | Coq3_Compilers.Z -> true
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_bool ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> true
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_nat ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> true
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_zrange ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> true
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_string ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> true)))
                  (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))
             then Compilers.Coq_base.try_make_transport_cps (fun _ x2 x3 _ ->
                    Coq3_Compilers.try_make_base_transport_cps x2 x3)
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z) (fun tro ->
                    match tro with
                    | Some v ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x2 x3 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x2 x3)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) (fun tro0 ->
                        match tro0 with
                        | Some v0 ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x2 x3 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x2 x3)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tro1 ->
                            match tro1 with
                            | Some v1 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x2 x3 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x2
                                  x3)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr ->
                                match tr with
                                | Some v2 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x2 x3 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x2 x3)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr0 ->
                                    match tr0 with
                                    | Some v3 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x2 x3 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x2 x3)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr1 ->
                                        match tr1 with
                                        | Some v4 ->
                                          Compilers.Coq_base.try_make_transport_cps
                                            (fun _ x2 x3 _ ->
                                            Coq3_Compilers.try_make_base_transport_cps
                                              x2 x3)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z) (fun tr2 ->
                                            match tr2 with
                                            | Some v5 ->
                                              Compilers.Coq_base.try_make_transport_cps
                                                (fun _ x2 x3 _ ->
                                                Coq3_Compilers.try_make_base_transport_cps
                                                  x2 x3)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z) (fun tr' ->
                                                match tr' with
                                                | Some v6 ->
                                                  Some
                                                    (Coq_Compilers.UnderLets.splice
                                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                          Coq3_Compilers.baseHasNat
                                                          Coq3_Compilers.buildIdent
                                                          Coq3_Compilers.buildEagerIdent
                                                          Coq3_Compilers.toRestrictedIdent
                                                          Coq3_Compilers.invertIdent
                                                          Coq3_Compilers.baseHasNatCorrect
                                                          (fun _ x2 x3 _ ->
                                                          Coq3_Compilers.try_make_base_transport_cps
                                                            x2 x3)) false
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        Coq3_Compilers.Coq_ident_fancy_addm)),
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Coq3_Compilers.Coq_ident_pair
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))),
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_expr.App
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))),
                                                        (Compilers.Coq_expr.Ident
                                                        ((Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))),
                                                        (Coq3_Compilers.Coq_ident_pair
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))))),
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v2 (v x)))))),
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v3
                                                          (v0 x0)))))))),
                                                        (Compilers.Coq_expr.Var
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Obj.magic v4
                                                          (v1 x1)))))))))
                                                      (fun fv ->
                                                      Coq_Compilers.UnderLets.Base
                                                      (v6 (v5 fv))))
                                                | None -> None)
                                            | None -> None)
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None)
                        | None -> None)
                    | None -> None)
             else None
           | None -> None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_add_modulo)),
          x)), x0)), x1))))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (match x with
           | Compilers.Coq_expr.Ident (t0, idc0) ->
             sequence
               (match x0 with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (s0, _, f, x1) ->
                  (match f with
                   | Compilers.Coq_expr.Ident (_, _) -> None
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (s1, _, f0, x2) ->
                     (match f0 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x2 with
                         | Compilers.Coq_expr.Ident (_, _) -> None
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f1, x3) ->
                           (match f1 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f2, x4) ->
                              (match f2 with
                               | Compilers.Coq_expr.Ident (t2, idc2) ->
                                 (match x4 with
                                  | Compilers.Coq_expr.Ident (t3, idc3) ->
                                    (match x3 with
                                     | Compilers.Coq_expr.Ident (t4, idc4) ->
                                       (match x1 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f3,
                                                                  x5) ->
                                          (match f3 with
                                           | Compilers.Coq_expr.Ident (
                                               _, _) ->
                                             None
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, f4, x6) ->
                                             (match f4 with
                                              | Compilers.Coq_expr.Ident (
                                                  t5, idc5) ->
                                                (match x6 with
                                                 | Compilers.Coq_expr.Ident (
                                                     t6, idc6) ->
                                                   (match x5 with
                                                    | Compilers.Coq_expr.Ident (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, f5, x7) ->
                                                      (match f5 with
                                                       | Compilers.Coq_expr.Ident (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, f6, x8) ->
                                                         (match f6 with
                                                          | Compilers.Coq_expr.Ident (
                                                              t7, idc7) ->
                                                            sequence
                                                              (match x8 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   s2, _, f7,
                                                                   x9) ->
                                                                 (match f7 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    sequence
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13) with
                                                                    | Some x13 ->
                                                                    Obj.magic
                                                                    x13
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x9))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13) with
                                                                    | Some x13 ->
                                                                    Obj.magic
                                                                    x13
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x11))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13) with
                                                                    | Some x13 ->
                                                                    Obj.magic
                                                                    x13
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x11))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13) with
                                                                    | Some x13 ->
                                                                    Obj.magic
                                                                    x13
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x9))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                              (match x8 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   s2, _, f7,
                                                                   x9) ->
                                                                 (match f7 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mullh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13) with
                                                                    | Some x13 ->
                                                                    Obj.magic
                                                                    x13
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x9))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, _) = a
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13) with
                                                                    | Some x13 ->
                                                                    Obj.magic
                                                                    x13
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x9))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              _, _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  _, _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f3, x5) ->
                                       (match f3 with
                                        | Compilers.Coq_expr.Ident (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, f4,
                                                                  x6) ->
                                          (match f4 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             sequence
                                               (match x6 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    s2, _, f5, x7) ->
                                                  (match f5 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f6, x8) ->
                                                     (match f6 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        (match x8 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           sequence
                                                             (match x7 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  t7, idc7) ->
                                                                (match x5 with
                                                                 | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f7, x9) ->
                                                                   (match f7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13) with
                                                                    | Some y ->
                                                                    Obj.magic
                                                                    y
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None)
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                             (match x5 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  s3, _, f7,
                                                                  x9) ->
                                                                (match f7 with
                                                                 | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                   (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    sequence
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13) with
                                                                    | Some y ->
                                                                    Obj.magic
                                                                    y
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mullh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13) with
                                                                    | Some y ->
                                                                    Obj.magic
                                                                    y
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mullh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13) with
                                                                    | Some y ->
                                                                    Obj.magic
                                                                    y
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x17))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x17))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x15))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulll)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2_up
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x15))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mullh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x15))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mullh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x15))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None)
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                               (match x6 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    s2, _, f5, x7) ->
                                                  (match f5 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f6, x8) ->
                                                     (match f6 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        (match x8 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           (match x5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f8,
                                                                   x10) ->
                                                                 (match f8 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_low0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13) with
                                                                    | Some y ->
                                                                    Obj.magic
                                                                    y
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v2 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (negb
                                                                    (option_beq0
                                                                    Coq_Z.eqb
                                                                    (invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13))
                                                                    None))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v0
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (match 
                                                                    invert_high0
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13) with
                                                                    | Some y ->
                                                                    Obj.magic
                                                                    y
                                                                    | None ->
                                                                    Obj.magic
                                                                    Z0))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v2
                                                                    (v1 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    sequence
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4)))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s4))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x17))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.div
                                                                    (Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))
                                                                    (Zpos (XO
                                                                    XH))))
                                                                    (Zpos
                                                                    XH))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhl)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x15))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_mul)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a0, b2) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, b3) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    a1, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x19 y ->
                                                                    match x19 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    x19 x20)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x19, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x19),
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x19))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv2
                                                                    in
                                                                    x19)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv6
                                                                    in
                                                                    x19))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19)))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv0
                                                                    in
                                                                    x19))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    x19))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv7
                                                                    in
                                                                    x19))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv4
                                                                    in
                                                                    x19)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x19 x20 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x19 x20))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv
                                                                    in
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_mulhh)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.mul
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv3
                                                                    in
                                                                    x19)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x19, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x19))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x15))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, _, _) ->
                                    None
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, _, _) -> None
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (s2, _, f1, x3) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (t1, idc1) ->
                           sequence
                             (match x3 with
                              | Compilers.Coq_expr.Ident (_, _) -> None
                              | Compilers.Coq_expr.Var (_, _) -> None
                              | Compilers.Coq_expr.Abs (_, _, _) -> None
                              | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                (match f2 with
                                 | Compilers.Coq_expr.Ident (_, _) -> None
                                 | Compilers.Coq_expr.Var (_, _) -> None
                                 | Compilers.Coq_expr.Abs (_, _, _) -> None
                                 | Compilers.Coq_expr.App (_, _, f3, x5) ->
                                   (match f3 with
                                    | Compilers.Coq_expr.Ident (t2, idc2) ->
                                      (match x5 with
                                       | Compilers.Coq_expr.Ident (t3, idc3) ->
                                         (match x4 with
                                          | Compilers.Coq_expr.Ident (
                                              _, _) ->
                                            None
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, f4,
                                                                    x6) ->
                                            (match f4 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    t4, idc4) ->
                                                  sequence
                                                    (match x7 with
                                                     | Compilers.Coq_expr.Ident (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         _, _, f6, x8) ->
                                                       (match f6 with
                                                        | Compilers.Coq_expr.Ident (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, f7, x9) ->
                                                          (match f7 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t5, idc5) ->
                                                             (match x9 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  t6, idc6) ->
                                                                (match x8 with
                                                                 | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                   (match x6 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x2 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cc_m)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_zselect)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x16 y ->
                                                                    match x16 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s5)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a0, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    a1, b3) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x16 y ->
                                                                    match x16 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s3)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s5))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv2
                                                                    in
                                                                    x16)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv1
                                                                    in
                                                                    x16)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv2
                                                                    in
                                                                    x16)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv2
                                                                    in
                                                                    x16)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.two_corners
                                                                    (Coq1_Z.cc_m
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv2
                                                                    in
                                                                    x16))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv3
                                                                    in
                                                                    x16)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv0
                                                                    in
                                                                    x16)))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_selm)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv2
                                                                    in
                                                                    x16)))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv4
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x12))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv5
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x14))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                 | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None
                                                                 | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                   None)
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                    (match x7 with
                                                     | Compilers.Coq_expr.Ident (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Var (
                                                         _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.Abs (
                                                         _, _, _) ->
                                                       None
                                                     | Compilers.Coq_expr.App (
                                                         s3, _, f6, x8) ->
                                                       (match f6 with
                                                        | Compilers.Coq_expr.Ident (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Var (
                                                            _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.Abs (
                                                            _, _, _) ->
                                                          None
                                                        | Compilers.Coq_expr.App (
                                                            _, _, f7, x9) ->
                                                          (match f7 with
                                                           | Compilers.Coq_expr.Ident (
                                                               t5, idc5) ->
                                                             (match x9 with
                                                              | Compilers.Coq_expr.Ident (
                                                                  t6, idc6) ->
                                                                sequence
                                                                  (match x8 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x6 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x2 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s6, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_zselect)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x16 y ->
                                                                    match x16 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s4)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s6)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a0, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    a1, b3) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x16 y ->
                                                                    match x16 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s4)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s5)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s6))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s6
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (Zpos XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv1
                                                                    in
                                                                    x16)))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (Zpos
                                                                    XH)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv3
                                                                    in
                                                                    x16)))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv0
                                                                    in
                                                                    x16))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv2
                                                                    in
                                                                    x16)
                                                                    (Zpos
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_sell)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv3
                                                                    in
                                                                    Obj.magic
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv4
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x12))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv5
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s6
                                                                    x14))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  (match x6 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, f8,
                                                                    x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x2 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s4, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s5, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_zselect)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x16 y ->
                                                                    match x16 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s5)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a0, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    _, b2) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    a1, b3) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x16 y ->
                                                                    match x16 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16))),
                                                                    s5))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv1 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x16, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x16),
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x16))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    x16 x17)
                                                                    s5
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (Zpos XH)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv2
                                                                    in
                                                                    x16)))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv1
                                                                    in
                                                                    x16))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (Zpos
                                                                    XH))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv0
                                                                    in
                                                                    x16))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv3
                                                                    in
                                                                    x16)
                                                                    (Zpos
                                                                    XH))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x16 x17 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x16 x17))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_sell)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv1
                                                                    in
                                                                    Obj.magic
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv4
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x12))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x16, _) =
                                                                    xv5
                                                                    in
                                                                    x16))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s5
                                                                    x14))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                              | Compilers.Coq_expr.Var (
                                                                  _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.Abs (
                                                                  _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.App (
                                                                  _, _, _, _) ->
                                                                None
                                                              | Compilers.Coq_expr.LetIn (
                                                                  _, _, _, _) ->
                                                                None)
                                                           | Compilers.Coq_expr.Var (
                                                               _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.Abs (
                                                               _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.App (
                                                               _, _, _, _) ->
                                                             None
                                                           | Compilers.Coq_expr.LetIn (
                                                               _, _, _, _) ->
                                                             None)
                                                        | Compilers.Coq_expr.LetIn (
                                                            _, _, _, _) ->
                                                          None)
                                                     | Compilers.Coq_expr.LetIn (
                                                         _, _, _, _) ->
                                                       None)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         None
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         None
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         None
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         None)
                                    | Compilers.Coq_expr.Var (_, _) -> None
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      None
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      None
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      None)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   None)
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                             (bind1
                               (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                 t1 idc1
                                 Coq3_Compilers.Coq_raw_ident_Z_zselect)
                               (fun _ ->
                               bind1
                                 (Obj.magic
                                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                   t0 idc0
                                   Coq3_Compilers.Coq_raw_ident_Literal)
                                 (fun args0 ->
                                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                         (fun x4 y ->
                                         match x4 with
                                         | Coq3_Compilers.Z ->
                                           (match y with
                                            | Coq3_Compilers.Z -> true
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool -> true
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> true
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              true
                                            | Coq3_Compilers.Coq_string ->
                                              false)
                                         | Coq3_Compilers.Coq_string ->
                                           (match y with
                                            | Coq3_Compilers.Z -> false
                                            | Coq3_Compilers.Coq_bool ->
                                              false
                                            | Coq3_Compilers.Coq_nat -> false
                                            | Coq3_Compilers.Coq_zrange ->
                                              false
                                            | Coq3_Compilers.Coq_string ->
                                              true))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Coq_zrange)),
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z)))),
                                         (Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                         Coq3_Compilers.Z))))))
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_base
                                         (Compilers.Coq_base.Coq_type.Coq_type_base
                                         (let (x4, _) =
                                            args0.Coq_Primitive.projT1
                                          in
                                          x4))),
                                         (Compilers.Coq_type.Coq_arrow
                                         ((Compilers.Coq_type.Coq_arrow (s2,
                                         s1)), s0)))) with
                                 | Some vars0 ->
                                   let (_, b) = Obj.magic vars0 in
                                   let (a, _) = b in
                                   let (_, _) = a in
                                   if Compilers.Coq_type.type_beq
                                        (Compilers.Coq_base.Coq_type.type_beq
                                          (fun x4 y ->
                                          match x4 with
                                          | Coq3_Compilers.Z ->
                                            (match y with
                                             | Coq3_Compilers.Z -> true
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               true
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat -> true
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_string ->
                                               false)
                                          | Coq3_Compilers.Coq_string ->
                                            (match y with
                                             | Coq3_Compilers.Z -> false
                                             | Coq3_Compilers.Coq_bool ->
                                               false
                                             | Coq3_Compilers.Coq_nat ->
                                               false
                                             | Coq3_Compilers.Coq_zrange ->
                                               false
                                             | Coq3_Compilers.Coq_string ->
                                               true)))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_zrange)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        (let (x4, _) =
                                           args0.Coq_Primitive.projT1
                                         in
                                         x4))), (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_arrow (s2,
                                        s1)), s0))))
                                   then bind1
                                          (Obj.magic
                                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Coq_zrange))
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            (let (x4, _) =
                                               args0.Coq_Primitive.projT1
                                             in
                                             x4)))
                                            (Coq3_Compilers.Coq_pattern_ident_Literal
                                            Coq3_Compilers.Coq_zrange)
                                            (Coq3_Compilers.Coq_ident_Literal
                                            ((let (x4, _) =
                                                args0.Coq_Primitive.projT1
                                              in
                                              x4),
                                            (let (x4, _) =
                                               let (_, y) =
                                                 args0.Coq_Primitive.projT2
                                               in
                                               y
                                             in
                                             x4)))) (fun xv ->
                                          Compilers.Coq_type.try_make_transport_cps
                                            (fun _ x4 x5 _ ->
                                            Compilers.Coq_base.try_make_transport_cps
                                              (fun _ x6 x7 _ ->
                                              Coq3_Compilers.try_make_base_transport_cps
                                                x6 x7) x4 x5) s2
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)) (fun tro ->
                                            match tro with
                                            | Some v ->
                                              Compilers.Coq_type.try_make_transport_cps
                                                (fun _ x4 x5 _ ->
                                                Compilers.Coq_base.try_make_transport_cps
                                                  (fun _ x6 x7 _ ->
                                                  Coq3_Compilers.try_make_base_transport_cps
                                                    x6 x7) x4 x5) s1
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))
                                                (fun tro0 ->
                                                match tro0 with
                                                | Some v0 ->
                                                  Compilers.Coq_type.try_make_transport_cps
                                                    (fun _ x4 x5 _ ->
                                                    Compilers.Coq_base.try_make_transport_cps
                                                      (fun _ x6 x7 _ ->
                                                      Coq3_Compilers.try_make_base_transport_cps
                                                        x6 x7) x4 x5) s0
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))
                                                    (fun tro1 ->
                                                    match tro1 with
                                                    | Some v1 ->
                                                      Compilers.Coq_base.try_make_transport_cps
                                                        (fun _ x4 x5 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x4 x5)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)
                                                        (fun tr ->
                                                        match tr with
                                                        | Some v2 ->
                                                          Compilers.Coq_base.try_make_transport_cps
                                                            (fun _ x4 x5 _ ->
                                                            Coq3_Compilers.try_make_base_transport_cps
                                                              x4 x5)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)
                                                            (fun tr0 ->
                                                            match tr0 with
                                                            | Some v3 ->
                                                              Compilers.Coq_base.try_make_transport_cps
                                                                (fun _ x4 x5 _ ->
                                                                Coq3_Compilers.try_make_base_transport_cps
                                                                  x4 x5)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                Coq3_Compilers.Z)
                                                                (fun tr1 ->
                                                                match tr1 with
                                                                | Some v4 ->
                                                                  Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x4 x5 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x4 x5))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x4, _) =
                                                                    xv
                                                                    in
                                                                    x4))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_selc)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x3))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x2))))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x1))))))))))))
                                                                    (fun fv ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                | None ->
                                                                  None)
                                                            | None -> None)
                                                        | None -> None)
                                                    | None -> None)
                                                | None -> None)
                                            | None -> None))
                                   else None
                                 | None -> None)))
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, f2, x4) ->
                           (match f2 with
                            | Compilers.Coq_expr.Ident (t1, idc1) ->
                              (match x4 with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, f3, x5) ->
                                 (match f3 with
                                  | Compilers.Coq_expr.Ident (_, _) -> None
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, f4, x6) ->
                                    (match f4 with
                                     | Compilers.Coq_expr.Ident (t2, idc2) ->
                                       (match x6 with
                                        | Compilers.Coq_expr.Ident (t3, idc3) ->
                                          (match x5 with
                                           | Compilers.Coq_expr.Ident (
                                               t4, idc4) ->
                                             (match x3 with
                                              | Compilers.Coq_expr.Ident (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Var (
                                                  _, _) ->
                                                None
                                              | Compilers.Coq_expr.Abs (
                                                  _, _, _) ->
                                                None
                                              | Compilers.Coq_expr.App (
                                                  s3, _, f5, x7) ->
                                                (match f5 with
                                                 | Compilers.Coq_expr.Ident (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Var (
                                                     _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.Abs (
                                                     _, _, _) ->
                                                   None
                                                 | Compilers.Coq_expr.App (
                                                     _, _, f6, x8) ->
                                                   (match f6 with
                                                    | Compilers.Coq_expr.Ident (
                                                        t5, idc5) ->
                                                      (match x8 with
                                                       | Compilers.Coq_expr.Ident (
                                                           t6, idc6) ->
                                                         (match x2 with
                                                          | Compilers.Coq_expr.Ident (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Var (
                                                              _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.Abs (
                                                              _, _, _) ->
                                                            None
                                                          | Compilers.Coq_expr.App (
                                                              s4, _, f7, x9) ->
                                                            (match f7 with
                                                             | Compilers.Coq_expr.Ident (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Var (
                                                                 _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.Abs (
                                                                 _, _, _) ->
                                                               None
                                                             | Compilers.Coq_expr.App (
                                                                 _, _, f8,
                                                                 x10) ->
                                                               (match f8 with
                                                                | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                  (match x10 with
                                                                   | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x1 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Z_rshi)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    _, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a, b0) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a0, b1) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, b2) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b0
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x13 y ->
                                                                    match x13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s3)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    s4)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))))))))
                                                                    then 
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv2 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    x13 x14)
                                                                    s4
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x13, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x13),
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x13))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv0
                                                                    in
                                                                    x13)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    x13)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv4
                                                                    in
                                                                    x13))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x13 x14 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x13 x14))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    Coq3_Compilers.Coq_ident_fancy_rshi)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv1
                                                                    in
                                                                    x13)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x13))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv2
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x7))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x13, _) =
                                                                    xv3
                                                                    in
                                                                    x13))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s4
                                                                    x9))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                   | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                   | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                  None
                                                                | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None
                                                                | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                  None)
                                                             | Compilers.Coq_expr.LetIn (
                                                                 _, _, _, _) ->
                                                               None)
                                                          | Compilers.Coq_expr.LetIn (
                                                              _, _, _, _) ->
                                                            None)
                                                       | Compilers.Coq_expr.Var (
                                                           _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.Abs (
                                                           _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.App (
                                                           _, _, _, _) ->
                                                         None
                                                       | Compilers.Coq_expr.LetIn (
                                                           _, _, _, _) ->
                                                         None)
                                                    | Compilers.Coq_expr.Var (
                                                        _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.Abs (
                                                        _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.App (
                                                        _, _, _, _) ->
                                                      None
                                                    | Compilers.Coq_expr.LetIn (
                                                        _, _, _, _) ->
                                                      None)
                                                 | Compilers.Coq_expr.LetIn (
                                                     _, _, _, _) ->
                                                   None)
                                              | Compilers.Coq_expr.LetIn (
                                                  _, _, _, _) ->
                                                None)
                                           | Compilers.Coq_expr.Var (_, _) ->
                                             None
                                           | Compilers.Coq_expr.Abs (
                                               _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.App (
                                               _, _, _, _) ->
                                             None
                                           | Compilers.Coq_expr.LetIn (
                                               _, _, _, _) ->
                                             None)
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, _, _) ->
                                          None
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, _, _) ->
                                       None
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, _, _) -> None
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
               (bind1
                 (Obj.magic
                   Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                   t0 idc0 Coq3_Compilers.Coq_raw_ident_Literal)
                 (fun args0 ->
                 match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                         (fun x1 y ->
                         match x1 with
                         | Coq3_Compilers.Z ->
                           (match y with
                            | Coq3_Compilers.Z -> true
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_bool ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> true
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_nat ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> true
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_zrange ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> true
                            | Coq3_Compilers.Coq_string -> false)
                         | Coq3_Compilers.Coq_string ->
                           (match y with
                            | Coq3_Compilers.Z -> false
                            | Coq3_Compilers.Coq_bool -> false
                            | Coq3_Compilers.Coq_nat -> false
                            | Coq3_Compilers.Coq_zrange -> false
                            | Coq3_Compilers.Coq_string -> true))
                         (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Coq_zrange)),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                         ((Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                         (Compilers.Coq_type.Coq_base
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z)))) with
                 | Some vars0 ->
                   let (_, _) = Obj.magic vars0 in
                   if Compilers.Coq_type.type_beq
                        (Compilers.Coq_base.Coq_type.type_beq (fun x1 y ->
                          match x1 with
                          | Coq3_Compilers.Z ->
                            (match y with
                             | Coq3_Compilers.Z -> true
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_bool ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> true
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_nat ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> true
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_zrange ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> true
                             | Coq3_Compilers.Coq_string -> false)
                          | Coq3_Compilers.Coq_string ->
                            (match y with
                             | Coq3_Compilers.Z -> false
                             | Coq3_Compilers.Coq_bool -> false
                             | Coq3_Compilers.Coq_nat -> false
                             | Coq3_Compilers.Coq_zrange -> false
                             | Coq3_Compilers.Coq_string -> true)))
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)))) (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        (let (x1, _) = args0.Coq_Primitive.projT1 in x1))),
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))))
                   then bind1
                          (Obj.magic
                            Coq10_Compilers.Coq_pattern.Coq_ident.unify
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_zrange))
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            (let (x1, _) = args0.Coq_Primitive.projT1 in x1)))
                            (Coq3_Compilers.Coq_pattern_ident_Literal
                            Coq3_Compilers.Coq_zrange)
                            (Coq3_Compilers.Coq_ident_Literal
                            ((let (x1, _) = args0.Coq_Primitive.projT1 in x1),
                            (let (x1, _) =
                               let (_, y) = args0.Coq_Primitive.projT2 in y
                             in
                             x1)))) (fun xv ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x1 x2 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x1 x2)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tro ->
                            match tro with
                            | Some v ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x1 x2 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x1
                                  x2)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr ->
                                match tr with
                                | Some v0 ->
                                  Compilers.Coq_base.try_make_transport_cps
                                    (fun _ x1 x2 _ ->
                                    Coq3_Compilers.try_make_base_transport_cps
                                      x1 x2)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z) (fun tr0 ->
                                    match tr0 with
                                    | Some v1 ->
                                      Compilers.Coq_base.try_make_transport_cps
                                        (fun _ x1 x2 _ ->
                                        Coq3_Compilers.try_make_base_transport_cps
                                          x1 x2)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z) (fun tr' ->
                                        match tr' with
                                        | Some v2 ->
                                          bind1
                                            (if (||)
                                                  (is_tighter_than_bool
                                                    (let (x1, _) = xv in x1)
                                                    value_range0)
                                                  (is_tighter_than_bool
                                                    (let (x1, _) = xv in x1)
                                                    flag_range0)
                                             then Some
                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                      (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                        Coq3_Compilers.baseHasNat
                                                        Coq3_Compilers.buildIdent
                                                        Coq3_Compilers.buildEagerIdent
                                                        Coq3_Compilers.toRestrictedIdent
                                                        Coq3_Compilers.invertIdent
                                                        Coq3_Compilers.baseHasNatCorrect
                                                        (fun _ x1 x2 _ ->
                                                        Coq3_Compilers.try_make_base_transport_cps
                                                          x1 x2)) false
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))
                                                      (Compilers.Coq_expr.App
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Compilers.Coq_expr.App
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))))),
                                                      Coq3_Compilers.Coq_ident_Z_cast)),
                                                      (Compilers.Coq_expr.Ident
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Coq_zrange)),
                                                      (Coq3_Compilers.Coq_ident_Literal
                                                      (Coq3_Compilers.Coq_zrange,
                                                      (let (x1, _) = xv in
                                                       Obj.magic x1))))))),
                                                      (Compilers.Coq_expr.Var
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Obj.magic v0 (v x0)))))))
                                             else None) (fun fv -> Some
                                            (Coq_Compilers.UnderLets.splice
                                              fv (fun fv0 ->
                                              Coq_Compilers.UnderLets.Base
                                              (v2 (v1 fv0)))))
                                        | None -> None)
                                    | None -> None)
                                | None -> None)
                            | None -> None))
                   else None
                 | None -> None))
           | Compilers.Coq_expr.Var (_, _) -> None
           | Compilers.Coq_expr.Abs (_, _, _) -> None
           | Compilers.Coq_expr.App (_, _, _, _) -> None
           | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          Coq3_Compilers.Coq_ident_Z_cast)), x)), x0))))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 ->
        sequence_return0
          (sequence
            (match x with
             | Compilers.Coq_expr.Ident (_, _) -> None
             | Compilers.Coq_expr.Var (_, _) -> None
             | Compilers.Coq_expr.Abs (_, _, _) -> None
             | Compilers.Coq_expr.App (_, _, f, x1) ->
               (match f with
                | Compilers.Coq_expr.Ident (_, _) -> None
                | Compilers.Coq_expr.Var (_, _) -> None
                | Compilers.Coq_expr.Abs (_, _, _) -> None
                | Compilers.Coq_expr.App (_, _, f0, x2) ->
                  (match f0 with
                   | Compilers.Coq_expr.Ident (t0, idc0) ->
                     (match x2 with
                      | Compilers.Coq_expr.Ident (t1, idc1) ->
                        (match x1 with
                         | Compilers.Coq_expr.Ident (t2, idc2) ->
                           (match x0 with
                            | Compilers.Coq_expr.Ident (_, _) -> None
                            | Compilers.Coq_expr.Var (_, _) -> None
                            | Compilers.Coq_expr.Abs (_, _, _) -> None
                            | Compilers.Coq_expr.App (_, _, f1, x3) ->
                              (match f1 with
                               | Compilers.Coq_expr.Ident (_, _) -> None
                               | Compilers.Coq_expr.Var (_, _) -> None
                               | Compilers.Coq_expr.Abs (_, _, _) -> None
                               | Compilers.Coq_expr.App (_, _, f2, x4) ->
                                 (match f2 with
                                  | Compilers.Coq_expr.Ident (_, _) -> None
                                  | Compilers.Coq_expr.Var (_, _) -> None
                                  | Compilers.Coq_expr.Abs (_, _, _) -> None
                                  | Compilers.Coq_expr.App (_, _, f3, x5) ->
                                    (match f3 with
                                     | Compilers.Coq_expr.Ident (t3, idc3) ->
                                       sequence
                                         (match x5 with
                                          | Compilers.Coq_expr.Ident (
                                              _, _) ->
                                            None
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, f4,
                                                                    x6) ->
                                            (match f4 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    t4, idc4) ->
                                                  (match x7 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t5, idc5) ->
                                                     (match x6 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t6, idc6) ->
                                                        (match x4 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             s0, _, f6, x8) ->
                                                           (match f6 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   t7, idc7) ->
                                                                 (match x9 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    sequence
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f19, x21) ->
                                                                    (match f19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t19,
                                                                    idc19) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f20, x22) ->
                                                                    (match f20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f21, x23) ->
                                                                    (match f21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t20,
                                                                    idc20) ->
                                                                    (match x23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t21,
                                                                    idc21) ->
                                                                    (match x22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t22,
                                                                    idc22) ->
                                                                    sequence
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t22 idc22
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t21 idc21
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t20 idc20
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t19 idc19
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args10 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args11 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args12 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a4, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b6) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    a5, b7) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args11.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv10 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv1
                                                                    in
                                                                    x24))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv7
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftl
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv6
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)))))
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv0
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv3
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv6
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x18))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))))))))
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t22 idc22
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t21 idc21
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t20 idc20
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t19 idc19
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args10 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args11 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args12 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a4, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b6) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    a5, b7) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args11.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv10 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)))))
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv1
                                                                    in
                                                                    x24))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv7
                                                                    in
                                                                    x24))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftl
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv6
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv0
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv3
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv6
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x18))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f19, x21) ->
                                                                    (match f19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t19,
                                                                    idc19) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f20, x22) ->
                                                                    (match f20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f21, x23) ->
                                                                    (match f21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t20,
                                                                    idc20) ->
                                                                    (match x23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t21,
                                                                    idc21) ->
                                                                    (match x22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t22,
                                                                    idc22) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t22 idc22
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t21 idc21
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t20 idc20
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t19 idc19
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args10 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args11 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args12 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s1)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    a4, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b6) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    a5, b7) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s1))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args11.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv10 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv1
                                                                    in
                                                                    x24)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv7
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv6
                                                                    in
                                                                    x24))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftl
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv3
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv7
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv3
                                                                    in
                                                                    x24))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv7
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24)))))
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv0
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x18))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                                    | None ->
                                                                    None)))))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args9 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x18 y ->
                                                                    match x18 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a4, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x18 y ->
                                                                    match x18 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x20 x21 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x20 x21)
                                                                    x18 x19)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x20 x21 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x20 x21)
                                                                    x18 x19)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv1
                                                                    in
                                                                    x18)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv7
                                                                    in
                                                                    x18)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv6
                                                                    in
                                                                    x18))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv5
                                                                    in
                                                                    x18))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv7
                                                                    in
                                                                    x18))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv4
                                                                    in
                                                                    x18))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv4
                                                                    in
                                                                    x18))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv
                                                                    in
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv0
                                                                    in
                                                                    x18))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv7
                                                                    in
                                                                    x18)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv3
                                                                    in
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x14))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args9 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x18 y ->
                                                                    match x18 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s1)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    a4, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x18 y ->
                                                                    match x18 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s1))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x20 x21 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x20 x21)
                                                                    x18 x19)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x20 x21 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x20 x21)
                                                                    x18 x19)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv1
                                                                    in
                                                                    x18)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv6
                                                                    in
                                                                    x18)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv5
                                                                    in
                                                                    x18))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv4
                                                                    in
                                                                    x18))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv6
                                                                    in
                                                                    x18))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv3
                                                                    in
                                                                    x18))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv3
                                                                    in
                                                                    x18))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv
                                                                    in
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv0
                                                                    in
                                                                    x18))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv6
                                                                    in
                                                                    x18)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv7
                                                                    in
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x10))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x14))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None))))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_add)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x10))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                         (match x5 with
                                          | Compilers.Coq_expr.Ident (
                                              _, _) ->
                                            None
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            None
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            None
                                          | Compilers.Coq_expr.App (_, _, f4,
                                                                    x6) ->
                                            (match f4 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    t4, idc4) ->
                                                  (match x7 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t5, idc5) ->
                                                     (match x6 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t6, idc6) ->
                                                        (match x4 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             s0, _, f6, x8) ->
                                                           (match f6 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   t7, idc7) ->
                                                                 (match x9 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f8, x10) ->
                                                                    (match f8 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, f9,
                                                                    x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    sequence
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    sequence
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f19, x21) ->
                                                                    (match f19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t19,
                                                                    idc19) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f20, x22) ->
                                                                    (match f20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f21, x23) ->
                                                                    (match f21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t20,
                                                                    idc20) ->
                                                                    (match x23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t21,
                                                                    idc21) ->
                                                                    (match x22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t22,
                                                                    idc22) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t22 idc22
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t21 idc21
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t20 idc20
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t19 idc19
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args10 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args11 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args12 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a4, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b6) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    a5, b7) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x24 y ->
                                                                    match x24 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x24, _) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    x24
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args11.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x26 x27 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x26 x27)
                                                                    x24 x25)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x24, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x24),
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x24))))
                                                                    (fun xv10 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv1
                                                                    in
                                                                    x24)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv7
                                                                    in
                                                                    x24))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv9
                                                                    in
                                                                    x24))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftl
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv4
                                                                    in
                                                                    x24))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv6
                                                                    in
                                                                    x24))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv5
                                                                    in
                                                                    x24))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv8
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)))))
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    x24)
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x24 x25 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x24 x25))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv0
                                                                    in
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv2
                                                                    in
                                                                    x24)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv10
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv3
                                                                    in
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x24, _) =
                                                                    xv6
                                                                    in
                                                                    Obj.magic
                                                                    x24))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x18))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args9 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x18 y ->
                                                                    match x18 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b4) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a4, b5) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b5
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x18 y ->
                                                                    match x18 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    s2)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x18, _) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    x18
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x20 x21 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x20 x21)
                                                                    x18 x19)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x20 x21 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x20 x21)
                                                                    x18 x19)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x18, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x18),
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x18))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv1
                                                                    in
                                                                    x18)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv7
                                                                    in
                                                                    x18)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv6
                                                                    in
                                                                    x18))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv5
                                                                    in
                                                                    x18))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv7
                                                                    in
                                                                    x18))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv4
                                                                    in
                                                                    x18))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv4
                                                                    in
                                                                    x18))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x18 x19 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x18 x19))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv
                                                                    in
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv0
                                                                    in
                                                                    x18))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv2
                                                                    in
                                                                    x18)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv7
                                                                    in
                                                                    x18)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv3
                                                                    in
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x18, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x18))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x14))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args6 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x12 y ->
                                                                    match x12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12))),
                                                                    s1))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x12, _) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    x12
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x12, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x12),
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x12))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x14 x15 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x14 x15)
                                                                    x12 x13)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v4 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv1
                                                                    in
                                                                    x12)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    x12))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x12 x13 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x12 x13))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv
                                                                    in
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv0
                                                                    in
                                                                    x12))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_sub)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv2
                                                                    in
                                                                    x12)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv3
                                                                    in
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v1
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x8))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x12, _) =
                                                                    xv4
                                                                    in
                                                                    Obj.magic
                                                                    x12))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x10))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v4
                                                                    (v3 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            None)
                                     | Compilers.Coq_expr.Var (_, _) -> None
                                     | Compilers.Coq_expr.Abs (_, _, _) ->
                                       None
                                     | Compilers.Coq_expr.App (_, _, f4, x6) ->
                                       (match f4 with
                                        | Compilers.Coq_expr.Ident (t3, idc3) ->
                                          sequence
                                            (match x6 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f6, x8) ->
                                                  (match f6 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t4, idc4) ->
                                                     (match x8 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        (match x7 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           (match x5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                s0, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f8,
                                                                   x10) ->
                                                                 (match f8 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f19, x21) ->
                                                                    (match f19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f20, x22) ->
                                                                    (match f20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f21, x23) ->
                                                                    (match f21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f22, x24) ->
                                                                    (match f22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t19,
                                                                    idc19) ->
                                                                    (match x24 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t20,
                                                                    idc20) ->
                                                                    (match x23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t21,
                                                                    idc21) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f23, x25) ->
                                                                    (match f23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f24, x26) ->
                                                                    (match f24 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t22,
                                                                    idc22) ->
                                                                    (match x26 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t23,
                                                                    idc23) ->
                                                                    (match x25 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t24,
                                                                    idc24) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t24 idc24
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t23 idc23
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t22 idc22
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t21 idc21
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t20 idc20
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t19 idc19
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args10 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args11 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args12 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args13 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x27 y ->
                                                                    match x27 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a5, b6) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, b7) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    a6, b8) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b8
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b6
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x27 y ->
                                                                    match x27 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args11.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv10 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv11 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv1
                                                                    in
                                                                    x27)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv9
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv8
                                                                    in
                                                                    x27))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    x27))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftl
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv6
                                                                    in
                                                                    x27))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv5
                                                                    in
                                                                    x27))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv7
                                                                    in
                                                                    x27))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv9
                                                                    in
                                                                    x27))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv6
                                                                    in
                                                                    x27))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv5
                                                                    in
                                                                    x27))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv9
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27))
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27)))))
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv0
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_addc)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    Obj.magic
                                                                    x27))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv3
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv4
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv7
                                                                    in
                                                                    Obj.magic
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x21))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f19, x21) ->
                                                                    (match f19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f20, x22) ->
                                                                    (match f20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f21, x23) ->
                                                                    (match f21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f22, x24) ->
                                                                    (match f22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t19,
                                                                    idc19) ->
                                                                    (match x24 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t20,
                                                                    idc20) ->
                                                                    (match x23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t21,
                                                                    idc21) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f23, x25) ->
                                                                    (match f23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f24, x26) ->
                                                                    (match f24 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t22,
                                                                    idc22) ->
                                                                    (match x26 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t23,
                                                                    idc23) ->
                                                                    (match x25 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t24,
                                                                    idc24) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t24 idc24
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t23 idc23
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t22 idc22
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t21 idc21
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t20 idc20
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t19 idc19
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args10 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args11 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args12 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args13 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x27 y ->
                                                                    match x27 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    a5, b6) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, b7) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    a6, b8) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b8
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x27 y ->
                                                                    match x27 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args11.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv10 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv11 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv1
                                                                    in
                                                                    x27)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv8
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv7
                                                                    in
                                                                    x27))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv9
                                                                    in
                                                                    x27))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftl
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv5
                                                                    in
                                                                    x27))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    x27))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv4
                                                                    in
                                                                    x27))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv4
                                                                    in
                                                                    x27))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv6
                                                                    in
                                                                    x27))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv8
                                                                    in
                                                                    x27))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv5
                                                                    in
                                                                    x27))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv8
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27))
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    x27)))))
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    x27))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv0
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_addc)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    Obj.magic
                                                                    x27))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv3
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x13))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv6
                                                                    in
                                                                    Obj.magic
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x21))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args10 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a5, b6) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b6
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv8 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv1
                                                                    in
                                                                    x21)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv8
                                                                    in
                                                                    x21)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv7
                                                                    in
                                                                    x21))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv6
                                                                    in
                                                                    x21))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv8
                                                                    in
                                                                    x21))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv5
                                                                    in
                                                                    x21))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv5
                                                                    in
                                                                    x21))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv0
                                                                    in
                                                                    x21))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_addc)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv8
                                                                    in
                                                                    x21)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv3
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv4
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv6
                                                                    in
                                                                    Obj.magic
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x17))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (sequence
                                                                    (match x11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args10 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    a5, b6) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv4 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv8 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv1
                                                                    in
                                                                    x21)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv7
                                                                    in
                                                                    x21)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv6
                                                                    in
                                                                    x21))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv5
                                                                    in
                                                                    x21))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv7
                                                                    in
                                                                    x21))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv4
                                                                    in
                                                                    x21))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv4
                                                                    in
                                                                    x21))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv0
                                                                    in
                                                                    x21))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_addc)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv7
                                                                    in
                                                                    x21)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv3
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv8
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x13))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x17))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_add_with_get_carry)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_addc)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x13))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                            (match x6 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               None
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               None
                                             | Compilers.Coq_expr.App (
                                                 _, _, f5, x7) ->
                                               (match f5 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  None
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  None
                                                | Compilers.Coq_expr.App (
                                                    _, _, f6, x8) ->
                                                  (match f6 with
                                                   | Compilers.Coq_expr.Ident (
                                                       t4, idc4) ->
                                                     (match x8 with
                                                      | Compilers.Coq_expr.Ident (
                                                          t5, idc5) ->
                                                        (match x7 with
                                                         | Compilers.Coq_expr.Ident (
                                                             t6, idc6) ->
                                                           (match x5 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              None
                                                            | Compilers.Coq_expr.App (
                                                                s0, _, f7, x9) ->
                                                              (match f7 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 None
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f8,
                                                                   x10) ->
                                                                 (match f8 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    t7, idc7) ->
                                                                    (match x10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t8, idc8) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s1, _,
                                                                    f9, x11) ->
                                                                    (match f9 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f10, x12) ->
                                                                    (match f10 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t9, idc9) ->
                                                                    (match x12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t10,
                                                                    idc10) ->
                                                                    (match x3 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, _,
                                                                    f11, x13) ->
                                                                    (match f11 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f12, x14) ->
                                                                    (match f12 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t11,
                                                                    idc11) ->
                                                                    (match x14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t12,
                                                                    idc12) ->
                                                                    sequence
                                                                    (match x13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f13, x15) ->
                                                                    (match f13 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f14, x16) ->
                                                                    (match f14 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t13,
                                                                    idc13) ->
                                                                    sequence
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f19, x21) ->
                                                                    (match f19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f20, x22) ->
                                                                    (match f20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f21, x23) ->
                                                                    (match f21 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f22, x24) ->
                                                                    (match f22 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t19,
                                                                    idc19) ->
                                                                    (match x24 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t20,
                                                                    idc20) ->
                                                                    (match x23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t21,
                                                                    idc21) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f23, x25) ->
                                                                    (match f23 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f24, x26) ->
                                                                    (match f24 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t22,
                                                                    idc22) ->
                                                                    (match x26 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t23,
                                                                    idc23) ->
                                                                    (match x25 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t24,
                                                                    idc24) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t24 idc24
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t23 idc23
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t22 idc22
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t21 idc21
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t20 idc20
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t19 idc19
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_land)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftl)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args10 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args11 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args12 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args13 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x27 y ->
                                                                    match x27 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a5, b6) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, b7) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    a6, b8) =
                                                                    b7
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a6
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b8
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b6
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x27 y ->
                                                                    match x27 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x27, _) =
                                                                    args13.Coq_Primitive.projT2
                                                                    in
                                                                    x27
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args12.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args12.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args11.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args11.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args10.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv7 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x29 x30 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x29 x30)
                                                                    x27 x28)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv10 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x27, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x27),
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x27))))
                                                                    (fun xv11 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv1
                                                                    in
                                                                    x27)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv9
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv8
                                                                    in
                                                                    x27))))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv10
                                                                    in
                                                                    x27))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftl
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv6
                                                                    in
                                                                    x27))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv5
                                                                    in
                                                                    x27))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv5
                                                                    in
                                                                    x27))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.land_bounds
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv7
                                                                    in
                                                                    x27))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv9
                                                                    in
                                                                    x27))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv6
                                                                    in
                                                                    x27))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv9
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.ones
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27))
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27)))))
                                                                    ((&&)
                                                                    (Coq_Z.leb
                                                                    Z0
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27))
                                                                    (Coq_Z.leb
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    x27)
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27))))
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x27 x28 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x27 x28))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv0
                                                                    in
                                                                    x27))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_subb)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv2
                                                                    in
                                                                    x27)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv11
                                                                    in
                                                                    Obj.magic
                                                                    x27))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv3
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv4
                                                                    in
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x27, _) =
                                                                    xv7
                                                                    in
                                                                    Obj.magic
                                                                    x27))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x21))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))))
                                                                    | None ->
                                                                    None))))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (match x16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, _,
                                                                    f15, x17) ->
                                                                    (match f15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f16, x18) ->
                                                                    (match f16 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t14,
                                                                    idc14) ->
                                                                    (match x18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t15,
                                                                    idc15) ->
                                                                    (match x15 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f17, x19) ->
                                                                    (match f17 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _,
                                                                    f18, x20) ->
                                                                    (match f18 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t16,
                                                                    idc16) ->
                                                                    (match x20 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t17,
                                                                    idc17) ->
                                                                    (match x19 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    t18,
                                                                    idc18) ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t18 idc18
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t17 idc17
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t16 idc16
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t15 idc15
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t14 idc14
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t13 idc13
                                                                    Coq3_Compilers.Coq_raw_ident_Z_shiftr)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args7 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args8 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args9 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args10 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))))))))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, b5) =
                                                                    b2
                                                                    in
                                                                    let (
                                                                    a5, b6) =
                                                                    b5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a5
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b6
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x21 y ->
                                                                    match x21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    s3)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))))))))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x21, _) =
                                                                    args10.Coq_Primitive.projT2
                                                                    in
                                                                    x21
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args9.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args9.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args8.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args8.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args7.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv6 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x23 x24 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x23 x24)
                                                                    x21 x22)
                                                                    s3
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv7 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x21, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x21),
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x21))))
                                                                    (fun xv8 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv1
                                                                    in
                                                                    x21)))
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv8
                                                                    in
                                                                    x21)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv7
                                                                    in
                                                                    x21))))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.four_corners_and_zero
                                                                    Coq_Z.shiftr
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv6
                                                                    in
                                                                    x21))
                                                                    (ZRange.normalize
                                                                    (ZRange.constant
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv8
                                                                    in
                                                                    x21))))
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv5
                                                                    in
                                                                    x21))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv5
                                                                    in
                                                                    x21))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x21 x22 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x21 x22))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv0
                                                                    in
                                                                    x21))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_subb)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv2
                                                                    in
                                                                    x21)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.opp
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv8
                                                                    in
                                                                    x21)))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv3
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv4
                                                                    in
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x21, _) =
                                                                    xv6
                                                                    in
                                                                    Obj.magic
                                                                    x21))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s3
                                                                    x17))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None)))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None)))))))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    (bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t12 idc12
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args0 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t11 idc11
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t10 idc10
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args1 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t9 idc9
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t8 idc8
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args2 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t7 idc7
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t6 idc6
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args3 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t5 idc5
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args4 ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t4 idc4
                                                                    Coq3_Compilers.Coq_raw_ident_Z_cast)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t3 idc3
                                                                    Coq3_Compilers.Coq_raw_ident_Z_sub_with_get_borrow)
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t2 idc2
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args5 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t1 idc1
                                                                    Coq3_Compilers.Coq_raw_ident_Literal)
                                                                    (fun args6 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args
                                                                    t0 idc0
                                                                    Coq3_Compilers.Coq_raw_ident_pair)
                                                                    (fun args7 ->
                                                                    match 
                                                                    Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2)))))) with
                                                                    | Some vars0 ->
                                                                    let (
                                                                    a, b) =
                                                                    Obj.magic
                                                                    vars0
                                                                    in
                                                                    let (
                                                                    a0, _) =
                                                                    a
                                                                    in
                                                                    let (
                                                                    a1, _) =
                                                                    a0
                                                                    in
                                                                    let (
                                                                    _, b0) =
                                                                    a1
                                                                    in
                                                                    let (
                                                                    _, b1) =
                                                                    b0
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b1
                                                                    in
                                                                    let (
                                                                    a2, b2) =
                                                                    b
                                                                    in
                                                                    let (
                                                                    a3, b3) =
                                                                    a2
                                                                    in
                                                                    let (
                                                                    a4, b4) =
                                                                    a3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    a4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b4
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    b2
                                                                    in
                                                                    if 
                                                                    Compilers.Coq_type.type_beq
                                                                    (Compilers.Coq_base.Coq_type.type_beq
                                                                    (fun x15 y ->
                                                                    match x15 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    false)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (match y with
                                                                    | Coq3_Compilers.Z ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    true)))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15))))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s0)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s1)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15))),
                                                                    s2))))))
                                                                    then 
                                                                    bind1
                                                                    (Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))))))
                                                                    (Coq3_Compilers.Coq_pattern_ident_pair
                                                                    ((Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    let (
                                                                    x15, _) =
                                                                    args7.Coq_Primitive.projT2
                                                                    in
                                                                    x15
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun _ ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args6.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args6.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args5.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args5.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args4.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args4.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv1 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Z)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args3.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args3.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv2 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args2.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args2.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv3 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s0
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro ->
                                                                    match tro with
                                                                    | Some v ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args1.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args1.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv4 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s1
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro0 ->
                                                                    match tro0 with
                                                                    | Some v0 ->
                                                                    bind1
                                                                    (Obj.magic
                                                                    Coq10_Compilers.Coq_pattern.Coq_ident.unify
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15)))
                                                                    (Coq3_Compilers.Coq_pattern_ident_Literal
                                                                    Coq3_Compilers.Coq_zrange)
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    ((
                                                                    let (
                                                                    x15, _) =
                                                                    args0.Coq_Primitive.projT1
                                                                    in
                                                                    x15),
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    let (
                                                                    _, y) =
                                                                    args0.Coq_Primitive.projT2
                                                                    in
                                                                    y
                                                                    in
                                                                    x15))))
                                                                    (fun xv5 ->
                                                                    Compilers.Coq_type.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x17 x18 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x17 x18)
                                                                    x15 x16)
                                                                    s2
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    (fun tro1 ->
                                                                    match tro1 with
                                                                    | Some v1 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr ->
                                                                    match tr with
                                                                    | Some v2 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr0 ->
                                                                    match tr0 with
                                                                    | Some v3 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (fun tr1 ->
                                                                    match tr1 with
                                                                    | Some v4 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr2 ->
                                                                    match tr2 with
                                                                    | Some v5 ->
                                                                    Compilers.Coq_base.try_make_transport_cps
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16)
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    (fun tr' ->
                                                                    match tr' with
                                                                    | Some v6 ->
                                                                    bind1
                                                                    (if 
                                                                    (&&)
                                                                    ((&&)
                                                                    (is_bounded_by_bool
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv1
                                                                    in
                                                                    x15)))
                                                                    (Coq_Z.eqb
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))
                                                                    (is_tighter_than_bool
                                                                    (ZRange.normalize
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    x15))
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)
                                                                    (Zpos
                                                                    XH)) })
                                                                    then 
                                                                    Some
                                                                    (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                                                    Coq3_Compilers.baseHasNat
                                                                    Coq3_Compilers.buildIdent
                                                                    Coq3_Compilers.buildEagerIdent
                                                                    Coq3_Compilers.toRestrictedIdent
                                                                    Coq3_Compilers.invertIdent
                                                                    Coq3_Compilers.baseHasNatCorrect
                                                                    (fun _ x15 x16 _ ->
                                                                    Coq3_Compilers.try_make_base_transport_cps
                                                                    x15 x16))
                                                                    false
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast2)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv0
                                                                    in
                                                                    x15))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_fancy_subb)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Coq_Z.log2
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv2
                                                                    in
                                                                    x15)))))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Z,
                                                                    (Obj.magic
                                                                    Z0))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))),
                                                                    (Coq3_Compilers.Coq_ident_pair
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv3
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v2
                                                                    (v
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s0
                                                                    x9))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv4
                                                                    in
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v3
                                                                    (v0
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s1
                                                                    x11))))))))))),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_expr.App
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))),
                                                                    Coq3_Compilers.Coq_ident_Z_cast)),
                                                                    (Compilers.Coq_expr.Ident
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    (Coq3_Compilers.Coq_ident_Literal
                                                                    (Coq3_Compilers.Coq_zrange,
                                                                    (
                                                                    let (
                                                                    x15, _) =
                                                                    xv5
                                                                    in
                                                                    Obj.magic
                                                                    x15))))))),
                                                                    (Compilers.Coq_expr.Var
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (v4
                                                                    (v1
                                                                    (Coq1_Compilers.RewriteRules.Compile.reflect
                                                                    false s2
                                                                    x13))))))))))))))))
                                                                    else None)
                                                                    (fun fv ->
                                                                    Some
                                                                    (Coq_Compilers.UnderLets.splice
                                                                    fv
                                                                    (fun fv0 ->
                                                                    Coq_Compilers.UnderLets.Base
                                                                    (v6
                                                                    (v5 fv0)))))
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None)
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None))
                                                                    | None ->
                                                                    None)))))))
                                                                    else None
                                                                    | None ->
                                                                    None))))))))))))))
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    None)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 None)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              None)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           None
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           None)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        None
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        None)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     None
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     None)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  None)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               None)
                                        | Compilers.Coq_expr.Var (_, _) ->
                                          None
                                        | Compilers.Coq_expr.Abs (_, _, _) ->
                                          None
                                        | Compilers.Coq_expr.App (_, _, _, _) ->
                                          None
                                        | Compilers.Coq_expr.LetIn (_, _, _,
                                                                    _) ->
                                          None)
                                     | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                       None)
                                  | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                    None)
                               | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                 None)
                            | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                         | Compilers.Coq_expr.Var (_, _) -> None
                         | Compilers.Coq_expr.Abs (_, _, _) -> None
                         | Compilers.Coq_expr.App (_, _, _, _) -> None
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                      | Compilers.Coq_expr.Var (_, _) -> None
                      | Compilers.Coq_expr.Abs (_, _, _) -> None
                      | Compilers.Coq_expr.App (_, _, _, _) -> None
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                   | Compilers.Coq_expr.Var (_, _) -> None
                   | Compilers.Coq_expr.Abs (_, _, _) -> None
                   | Compilers.Coq_expr.App (_, _, _, _) -> None
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> None)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> None) None)
          (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_cast2)), x)),
          x0))))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 invert_low0 invert_high0 value_range0 flag_range0 =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None
        (all_rewrite_rules invert_low0 invert_high0 value_range0 flag_range0)

    (** val rewrite_head1 :
        (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteToFancyWithCasts :
        (z -> z -> z option) -> (z -> z -> z option) -> zrange -> zrange ->
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteToFancyWithCasts invert_low0 invert_high0 value_range0 flag_range0 opts t0 x =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x0 x1 _ ->
        Coq3_Compilers.try_make_base_transport_cps x0 x1)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x0 x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x0 x1));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            (fancy_with_casts_rewrite_rulesT invert_low0 invert_high0
              value_range0 flag_range0);
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ ->
              rewrite_rules invert_low0 invert_high0 value_range0 flag_range0));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ ->
              all_rewrite_rules invert_low0 invert_high0 value_range0
                flag_range0));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
            O)))))))))))))))))))))))))))))))))))))))))))));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ ->
              rewrite_head invert_low0 invert_high0 value_range0 flag_range0));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ ->
              rewrite_head1 invert_low0 invert_high0 value_range0 flag_range0)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S (S
        O))))))))))))))))))))))))))))))))))))))))))))) t0 x
   end
 end

module Coq23_Compilers =
 struct
  module RewriteRules =
   struct
    (** val rewrite_rules :
        (Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleT list **)

    let rewrite_rules =
      (ExistT ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_pattern_ident_value_barrier)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) },
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0))))) })) :: []

    (** val dtree :
        Coq3_Compilers.raw_ident
        Coq1_Compilers.RewriteRules.Compile.decision_tree **)

    let dtree =
      Coq1_Compilers.RewriteRules.Compile.Switch ([], (Some
        (Coq1_Compilers.RewriteRules.Compile.Switch
        (((Coq3_Compilers.Coq_raw_ident_value_barrier,
        (Coq1_Compilers.RewriteRules.Compile.TryLeaf (O,
        Coq1_Compilers.RewriteRules.Compile.Failure))) :: []), None,
        Coq1_Compilers.RewriteRules.Compile.Failure))),
        Coq1_Compilers.RewriteRules.Compile.Failure)

    (** val pr2_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.ident, 'a1,
        Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP,
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) hlist)
        Primitive.prod **)

    let pr2_rewrite_rules =
      { Primitive.fst =
        { Coq1_Compilers.RewriteRules.Compile.rew_should_do_again = false;
        Coq1_Compilers.RewriteRules.Compile.rew_with_opt = true;
        Coq1_Compilers.RewriteRules.Compile.rew_under_lets = true;
        Coq1_Compilers.RewriteRules.Compile.rew_replacement =
        (Obj.magic (fun x0 -> Some
          (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
            (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
              Coq3_Compilers.baseHasNat Coq3_Compilers.buildIdent
              Coq3_Compilers.buildEagerIdent Coq3_Compilers.toRestrictedIdent
              Coq3_Compilers.invertIdent Coq3_Compilers.baseHasNatCorrect
              (fun _ x x1 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x1)) false
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x0))))) }; Primitive.snd = (Obj.magic ()) }

    (** val all_rewrite_rules :
        ((Coq3_Compilers.base, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.Coq_pattern.anypattern, (Coq3_Compilers.base,
        Coq3_Compilers.ident, 'a1, Coq3_Compilers.pattern_ident)
        Coq1_Compilers.RewriteRules.Compile.rewrite_ruleTP) sigT list **)

    let all_rewrite_rules =
      combine_hlist ({ Coq1_Compilers.Coq_pattern.type_of_anypattern =
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z));
        Coq1_Compilers.Coq_pattern.pattern_of_anypattern =
        (Coq1_Compilers.Coq_pattern.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Coq1_Compilers.Coq_pattern.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_pattern_ident_value_barrier)),
        (Coq1_Compilers.Coq_pattern.Wildcard (Compilers.Coq_type.Coq_base
        (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))) } :: []) (Obj.magic pr2_rewrite_rules)

    (** val rewrite_head :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1) Coq1_Compilers.RewriteRules.Compile.value' **)

    let rewrite_head _ _ = function
    | Coq3_Compilers.Coq_ident_Literal (t0, y) ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base t0)),
        (Coq3_Compilers.Coq_ident_Literal (t0, y)))))
    | Coq3_Compilers.Coq_ident_comment t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment t0))), x)))
    | Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit))),
        (Coq3_Compilers.Coq_ident_comment_no_keep t0))), x)))
    | Coq3_Compilers.Coq_ident_value_barrier ->
      Obj.magic (fun x ->
        sequence_return0
          (match Coq1_Compilers.Coq_pattern.Coq_type.unify_extracted
                   (fun x0 y ->
                   match x0 with
                   | Coq3_Compilers.Z ->
                     (match y with
                      | Coq3_Compilers.Z -> true
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_bool ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> true
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_nat ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> true
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_zrange ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> true
                      | Coq3_Compilers.Coq_string -> false)
                   | Coq3_Compilers.Coq_string ->
                     (match y with
                      | Coq3_Compilers.Z -> false
                      | Coq3_Compilers.Coq_bool -> false
                      | Coq3_Compilers.Coq_nat -> false
                      | Coq3_Compilers.Coq_zrange -> false
                      | Coq3_Compilers.Coq_string -> true))
                   (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_pattern.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z)) with
           | Some _ ->
             if Compilers.Coq_type.type_beq
                  (Compilers.Coq_base.Coq_type.type_beq (fun x0 y ->
                    match x0 with
                    | Coq3_Compilers.Z ->
                      (match y with
                       | Coq3_Compilers.Z -> true
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_bool ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> true
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_nat ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> true
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_zrange ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> true
                       | Coq3_Compilers.Coq_string -> false)
                    | Coq3_Compilers.Coq_string ->
                      (match y with
                       | Coq3_Compilers.Z -> false
                       | Coq3_Compilers.Coq_bool -> false
                       | Coq3_Compilers.Coq_nat -> false
                       | Coq3_Compilers.Coq_zrange -> false
                       | Coq3_Compilers.Coq_string -> true)))
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))
             then Compilers.Coq_base.try_make_transport_cps (fun _ x0 x1 _ ->
                    Coq3_Compilers.try_make_base_transport_cps x0 x1)
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z) (fun tro ->
                    match tro with
                    | Some v ->
                      Compilers.Coq_base.try_make_transport_cps
                        (fun _ x0 x1 _ ->
                        Coq3_Compilers.try_make_base_transport_cps x0 x1)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z) (fun tr ->
                        match tr with
                        | Some v0 ->
                          Compilers.Coq_base.try_make_transport_cps
                            (fun _ x0 x1 _ ->
                            Coq3_Compilers.try_make_base_transport_cps x0 x1)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z) (fun tr0 ->
                            match tr0 with
                            | Some v1 ->
                              Compilers.Coq_base.try_make_transport_cps
                                (fun _ x0 x1 _ ->
                                Coq3_Compilers.try_make_base_transport_cps x0
                                  x1)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z) (fun tr' ->
                                match tr' with
                                | Some v2 ->
                                  Some
                                    (Coq_Compilers.UnderLets.splice
                                      (Coq1_Compilers.RewriteRules.Reify.expr_value_to_rewrite_rule_replacement
                                        (Coq1_Compilers.RewriteRules.Compile.reflect_ident_iota
                                          Coq3_Compilers.baseHasNat
                                          Coq3_Compilers.buildIdent
                                          Coq3_Compilers.buildEagerIdent
                                          Coq3_Compilers.toRestrictedIdent
                                          Coq3_Compilers.invertIdent
                                          Coq3_Compilers.baseHasNatCorrect
                                          (fun _ x0 x1 _ ->
                                          Coq3_Compilers.try_make_base_transport_cps
                                            x0 x1)) false
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))
                                        (Compilers.Coq_expr.Var
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Obj.magic v0 (v x))))) (fun fv ->
                                      Coq_Compilers.UnderLets.Base
                                      (v2 (v1 fv))))
                                | None -> None)
                            | None -> None)
                        | None -> None)
                    | None -> None)
             else None
           | None -> None) (Coq_Compilers.UnderLets.Base
          (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          Coq3_Compilers.Coq_ident_value_barrier)), x))))
    | Coq3_Compilers.Coq_ident_Nat_succ ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)), x)))
    | Coq3_Compilers.Coq_ident_Nat_pred ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)), x)))
    | Coq3_Compilers.Coq_ident_Nat_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_Nat_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_nil t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Coq3_Compilers.Coq_ident_nil t0))))
    | Coq3_Compilers.Coq_ident_cons t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_cons t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_tt ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        Coq3_Compilers.Coq_ident_tt)))
    | Coq3_Compilers.Coq_ident_pair (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))))))), (Coq3_Compilers.Coq_ident_pair (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_fst (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t0))), (Coq3_Compilers.Coq_ident_fst
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_snd (t0, t1) ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t1))), (Coq3_Compilers.Coq_ident_snd
        (t0, t1)))), x)))
    | Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        (t0, t1))), (Compilers.Coq_type.Coq_base t2))))),
        (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2),
        (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2)))))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_bool_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_bool_rect_nodep t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_nat_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x2)) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))))))))),
        (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_base t1))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x5 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), x3)) (fun x6 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
            t1))), x4)), x6))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t0), x5)))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t1))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))))), (fun x2 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t1))), (fun x3 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t1),
        (fun x4 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x4)))))))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2))))))))),
        (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x3)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))))), (fun x3 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))))), (fun x4 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
        t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t1), (Compilers.Coq_type.Coq_base t2))), (fun x5 ->
        Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_base t2), (fun x6 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t2)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x4)) (fun x7 ->
            Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.App
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
            t2))), x5)), x7))) (Compilers.Coq_expr.Var
            ((Compilers.Coq_type.Coq_base t1), x6)))))))))))))), x1)), x2)))
    | Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_list_case (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base t1))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base t1), (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list t0)), x3)))))))))), x1)))
    | Coq3_Compilers.Coq_ident_List_length t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
        t0))), x)))
    | Coq3_Compilers.Coq_ident_List_seq ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
        x)), x0)))
    | Coq3_Compilers.Coq_ident_List_firstn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_firstn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_skipn t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_skipn t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_repeat t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_repeat t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))),
        (Coq3_Compilers.Coq_ident_List_combine (t0, t1)))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))))),
        (Coq3_Compilers.Coq_ident_List_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_app t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Coq3_Compilers.Coq_ident_List_app t0))), x)), x0)))
    | Coq3_Compilers.Coq_ident_List_rev t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Coq3_Compilers.Coq_ident_List_rev t0))), x)))
    | Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)))))), (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list t1))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_partition t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list t0),
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))))),
        (Coq3_Compilers.Coq_ident_List_partition t0))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_filter t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)))))),
        (Coq3_Compilers.Coq_ident_List_filter t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (fun x1 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_bool))
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x1)))))))),
        x0)))
    | Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t1)), (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        t0), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t1)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t1),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0))), (fun x2 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0),
        (fun x3 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t1), x2))
            (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x3)))))))))),
        x0)), x1)))
    | Coq3_Compilers.Coq_ident_List_update_nth t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)))))))), (Coq3_Compilers.Coq_ident_List_update_nth t0))), x)),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        x1)))
    | Coq3_Compilers.Coq_ident_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_List_nth_default t0))), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list t0)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base t0))))))),
        (Coq3_Compilers.Coq_ident_eager_List_nth_default t0))), x)), x0)),
        x1)))
    | Coq3_Compilers.Coq_ident_Z_add ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_add)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_mul)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_pow ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_pow)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_sub ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_sub)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_opp ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_opp)), x)))
    | Coq3_Compilers.Coq_ident_Z_div ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_div)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_eqb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_leb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_ltb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_geb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_gtb ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_gtb)), x)),
        x0)))
    | Coq3_Compilers.Coq_ident_Z_log2 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2)), x)))
    | Coq3_Compilers.Coq_ident_Z_log2_up ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_log2_up)), x)))
    | Coq3_Compilers.Coq_ident_Z_of_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_of_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_to_nat ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)), x)))
    | Coq3_Compilers.Coq_ident_Z_shiftr ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftr)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_shiftl ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_shiftl)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_land ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_land)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_min ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_min)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_max ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_max)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_mul_split ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_mul_split)),
        x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_mul_high ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_mul_high)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_add_get_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_carry)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_add_with_get_carry)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_get_borrow)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))))),
        Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow)), x)), x0)), x1)),
        x2)))
    | Coq3_Compilers.Coq_ident_Z_ltz ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_ltz)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_zselect ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_zselect)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_add_modulo)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_bneg ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_Z_bneg)), x)))
    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lnot_modulo)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_lxor ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_lxor)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_rshi ->
      Obj.magic (fun x x0 x1 x2 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)))))))))), Coq3_Compilers.Coq_ident_Z_rshi)), x)),
        x0)), x1)), x2)))
    | Coq3_Compilers.Coq_ident_Z_cc_m ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cc_m)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth)), x)), x0)), x1)))
    | Coq3_Compilers.Coq_ident_Z_cast ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_Z_cast)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Z_cast2 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange),
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
        Coq3_Compilers.Coq_ident_Z_cast2)), x)), x0)))
    | Coq3_Compilers.Coq_ident_Some t0 ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)))),
        (Coq3_Compilers.Coq_ident_Some t0))), x)))
    | Coq3_Compilers.Coq_ident_None t0 ->
      Obj.magic (Coq_Compilers.UnderLets.Base (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Coq3_Compilers.Coq_ident_None t0))))
    | Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
      Obj.magic (fun x x0 x1 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_option t0)),
        (Compilers.Coq_type.Coq_base t1))))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
        t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
        (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_option
        t0)), (Compilers.Coq_type.Coq_base t1))))))),
        (Coq3_Compilers.Coq_ident_option_rect (t0, t1)))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_type.Coq_base t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base t0), x2)))))))),
        (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
        Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
        t1), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t1)
          (x0 (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit), x2)))))))), x1)))
    | Coq3_Compilers.Coq_ident_Build_zrange ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_expr.App
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_expr.Ident
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)))))),
        Coq3_Compilers.Coq_ident_Build_zrange)), x)), x0)))
    | Coq3_Compilers.Coq_ident_zrange_rect t0 ->
      Obj.magic (fun x x0 -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0),
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))),
        (Coq3_Compilers.Coq_ident_zrange_rect t0))), (Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0))), (fun x1 -> Compilers.Coq_expr.Abs
        ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base t0), (fun x2 ->
        Coq_Compilers.UnderLets.to_expr (Compilers.Coq_type.Coq_base t0)
          (x (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x1)) (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            x2)))))))))), x0)))
    | Coq3_Compilers.Coq_ident_fancy_add ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_add)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_addc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sub ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_sub)), x)))
    | Coq3_Compilers.Coq_ident_fancy_subb ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        Coq3_Compilers.Coq_ident_fancy_subb)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulll ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulll)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mullh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mullh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhl)), x)))
    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_mulhh)), x)))
    | Coq3_Compilers.Coq_ident_fancy_rshi ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_rshi)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selc ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selc)), x)))
    | Coq3_Compilers.Coq_ident_fancy_selm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_selm)), x)))
    | Coq3_Compilers.Coq_ident_fancy_sell ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_sell)), x)))
    | Coq3_Compilers.Coq_ident_fancy_addm ->
      Obj.magic (fun x -> Coq_Compilers.UnderLets.Base
        (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        Coq3_Compilers.Coq_ident_fancy_addm)), x)))

    (** val rewrite_head_no_dtree0 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head_no_dtree0 do_again =
      Coq1_Compilers.RewriteRules.Compile.assemble_identifier_rewriters
        (Obj.magic (fun _ x x0 _ ->
          Compilers.Classes.try_make_transport_base_cps
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) } x x0))
        (Obj.magic { Compilers.Classes.base_beq =
          (Obj.magic Coq3_Compilers.base_beq);
          Compilers.Classes.base_interp_beq =
          (Obj.magic Coq3_Compilers.base_interp_beq);
          Compilers.Classes.try_make_transport_base_cps =
          (Obj.magic (fun _ x x0 _ ->
            Coq3_Compilers.try_make_base_transport_cps x x0));
          Compilers.Classes.baseHasNat =
          (Obj.magic Coq3_Compilers.baseHasNat);
          Compilers.Classes.buildIdent =
          (Obj.magic Coq3_Compilers.buildIdent);
          Compilers.Classes.toRestrictedIdent =
          (Obj.magic Coq3_Compilers.toRestrictedIdent);
          Compilers.Classes.buildEagerIdent =
          (Obj.magic Coq3_Compilers.buildEagerIdent);
          Compilers.Classes.invertIdent =
          (Obj.magic Coq3_Compilers.invertIdent);
          Compilers.Classes.defaultBase =
          (Obj.magic Coq3_Compilers.base_default);
          Compilers.Classes.reflect_base_beq =
          (Obj.magic Coq3_Compilers.reflect_base_beq);
          Compilers.Classes.reflect_base_interp_beq =
          (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
          Compilers.Classes.baseHasNatCorrect =
          (Obj.magic Coq3_Compilers.baseHasNatCorrect) }.Compilers.Classes.base_beq)
        (fun _ ->
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
        (Coq0_Compilers.Coq_pattern.Coq_ident.arg_types
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of
          (Obj.magic (fun _ ->
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen
              { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
              Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
              (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
              (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
              Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
              (Obj.magic (fun _ ->
                Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
              (Obj.magic
                Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
              Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
              (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }))
          (Obj.magic
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types))
        (Obj.magic { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify)
        Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown
        { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
        Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
        (fun _ ->
        Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
        (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
        Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
        (Obj.magic (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
        Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
        Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
        (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args
        (Obj.magic
          Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.type_of (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.to_typed (fun _ ->
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) })
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        (Coq0_Compilers.Coq_pattern.Raw.Coq_ident.is_simple
          { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_base0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
          Coq10_Compilers.Coq_pattern.Coq_ident.ident_index;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
          (fun _ ->
          Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
          (fun _ -> Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
          Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
          (Obj.magic (fun _ ->
            Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
          (Obj.magic
            Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
          Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded;
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
          Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
          (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }.Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of)
        None all_rewrite_rules do_again

    (** val rewrite_head1 :
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value) Compilers.Coq_expr.expr ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1, (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
        Compilers.Coq_expr.expr) Coq_Compilers.UnderLets.coq_UnderLets) ->
        Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
        (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
        Coq3_Compilers.ident, 'a1)
        Coq1_Compilers.RewriteRules.Compile.value_with_lets **)

    let rewrite_head1 =
      rewrite_head_no_dtree0

    (** val coq_RewriteUnfoldValueBarrier :
        Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions
        -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
        Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
        Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
        Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
        Compilers.Coq_expr.expr **)

    let coq_RewriteUnfoldValueBarrier opts t0 e =
      Coq1_Compilers.RewriteRules.Compile.coq_Rewrite
        Coq3_Compilers.ident_is_var_like Coq3_Compilers.buildIdent
        Coq3_Compilers.invertIdent (fun _ x x0 _ ->
        Coq3_Compilers.try_make_base_transport_cps x x0)
        (Obj.magic (fun _ ->
          Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_gen
            (Obj.magic Coq3_Compilers.ident_interp)
            { Compilers.Classes.base_beq =
            (Obj.magic Coq3_Compilers.base_beq);
            Compilers.Classes.base_interp_beq =
            (Obj.magic Coq3_Compilers.base_interp_beq);
            Compilers.Classes.try_make_transport_base_cps =
            (Obj.magic (fun _ x x0 _ ->
              Coq3_Compilers.try_make_base_transport_cps x x0));
            Compilers.Classes.baseHasNat =
            (Obj.magic Coq3_Compilers.baseHasNat);
            Compilers.Classes.buildIdent =
            (Obj.magic Coq3_Compilers.buildIdent);
            Compilers.Classes.toRestrictedIdent =
            (Obj.magic Coq3_Compilers.toRestrictedIdent);
            Compilers.Classes.buildEagerIdent =
            (Obj.magic Coq3_Compilers.buildEagerIdent);
            Compilers.Classes.invertIdent =
            (Obj.magic Coq3_Compilers.invertIdent);
            Compilers.Classes.defaultBase =
            (Obj.magic Coq3_Compilers.base_default);
            Compilers.Classes.reflect_base_beq =
            (Obj.magic Coq3_Compilers.reflect_base_beq);
            Compilers.Classes.reflect_base_interp_beq =
            (Obj.magic Coq3_Compilers.reflect_base_interp_beq);
            Compilers.Classes.baseHasNatCorrect =
            (Obj.magic Coq3_Compilers.baseHasNatCorrect) }
            { Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_base =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_base0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_idents0;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_ident_cps =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.simple_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.simple_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_raw_idents =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.all_raw_idents);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_index =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.ident_index0);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_raw_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.raw_ident_infos_of =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_ident_infos_of);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_raw_ident_gen =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.split_raw_ident_gen);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.raw_invert_bind_args);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.invert_bind_args_unknown =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.invert_bind_args_unknown);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.all_pattern_idents =
            Coq10_Compilers.Coq_pattern.Coq_ident.all_pattern_idents;
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen1));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.eta_pattern_ident_cps_gen_expand_literal =
            (Obj.magic (fun _ ->
              Coq10_Compilers.Coq_pattern.Coq_ident.eta_ident_cps_gen_expand_literal0));
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.split_types =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.split_types);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.add_types_from_raw_sig =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.add_types_from_raw_sig);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.to_typed_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.to_typed_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.type_of_list_arg_types_beq_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.type_of_list_arg_types_beq_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.arg_types_of_typed_ident_unfolded =
            (Obj.magic
              Coq10_Compilers.Coq_pattern.Coq_ident.arg_types_of_typed_ident_unfolded);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify);
            Coq0_Compilers.Coq_pattern.Coq_ident.GoalType.unify_unknown =
            (Obj.magic Coq10_Compilers.Coq_pattern.Coq_ident.unify_unknown) }
            { Coq1_Compilers.RewriteRules.Make.GoalType.ident_is_var_like =
            (Obj.magic Coq3_Compilers.ident_is_var_like);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules_specs =
            unfold_value_barrier_rewrite_rulesT;
            Coq1_Compilers.RewriteRules.Make.GoalType.dummy_count = O;
            Coq1_Compilers.RewriteRules.Make.GoalType.dtree =
            (Obj.magic dtree);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_rules =
            (Obj.magic (fun _ -> rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.all_rewrite_rules =
            (Obj.magic (fun _ -> all_rewrite_rules));
            Coq1_Compilers.RewriteRules.Make.GoalType.default_fuel = (S O);
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head =
            (Obj.magic (fun _ -> rewrite_head));
            Coq1_Compilers.RewriteRules.Make.GoalType.rewrite_head_no_dtree =
            (Obj.magic (fun _ -> rewrite_head1)) }
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree
            opts.Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions))
        (S O) t0 e
   end
 end

(** val relax_zrange_gen_ranges : zrange list -> zrange -> zrange option **)

let relax_zrange_gen_ranges possible_ranges r0 =
  fold_right (fun r'0 default0 ->
    if is_tighter_than_bool r0 r'0 then Some r'0 else default0) None
    possible_ranges

type kind_of_range =
| Signed
| Unsigned

(** val ranges_of_bitwidths : (z * kind_of_range) list -> zrange list **)

let ranges_of_bitwidths bws =
  map (fun pat ->
    let (bw, k) = pat in
    (match k with
     | Signed ->
       { lower =
         (Coq_Z.opp (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub bw (Zpos XH))));
         upper =
         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub bw (Zpos XH))) (Zpos
           XH)) }
     | Unsigned ->
       { lower = Z0; upper =
         (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bw) (Zpos XH)) })) bws

(** val relax_zrange_gen : bool -> z list -> zrange -> zrange option **)

let relax_zrange_gen only_signed0 possible_values =
  relax_zrange_gen_ranges
    (ranges_of_bitwidths
      (flat_map (fun k -> map (fun bw -> (bw, k)) possible_values)
        (if only_signed0 then Signed :: [] else Unsigned :: (Signed :: []))))

module Coq_typedef =
 struct
  type typedef = { name : char list; description : (char list -> char list) }

  (** val name :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> typedef ->
      char list **)

  let name _ _ typedef0 =
    typedef0.name

  (** val description :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> typedef ->
      char list -> char list **)

  let description _ _ typedef0 =
    typedef0.description
 end

type low_level_rewriter_method_opt =
| Precomputed_decision_tree
| Unreduced_decision_tree
| Unreduced_naive

(** val default_low_level_rewriter_method : low_level_rewriter_method_opt **)

let default_low_level_rewriter_method =
  Precomputed_decision_tree

type machine_wordsize_opt = z

(** val machine_wordsize : machine_wordsize_opt -> z **)

let machine_wordsize machine_wordsize_opt0 =
  machine_wordsize_opt0

type static_opt = bool

type inline_internal_opt = bool

type inline_opt = bool

type internal_static_opt = bool

type use_mul_for_cmovznz_opt = bool

type emit_primitives_opt = bool

type only_signed_opt = bool

type no_select_opt = bool

(** val no_select : no_select_opt -> bool **)

let no_select no_select_opt0 =
  no_select_opt0

type no_select_size_opt = z option

type should_split_mul_opt = bool

(** val should_split_mul : should_split_mul_opt -> bool **)

let should_split_mul should_split_mul_opt0 =
  should_split_mul_opt0

type split_mul_to_opt = (z * z) option

type should_split_multiret_opt = bool

(** val should_split_multiret : should_split_multiret_opt -> bool **)

let should_split_multiret should_split_multiret_opt0 =
  should_split_multiret_opt0

type split_multiret_to_opt = (z * z) option

type widen_carry_opt = bool

(** val widen_carry : widen_carry_opt -> bool **)

let widen_carry widen_carry_opt0 =
  widen_carry_opt0

type widen_bytes_opt = bool

(** val widen_bytes : widen_bytes_opt -> bool **)

let widen_bytes widen_bytes_opt0 =
  widen_bytes_opt0

type debug_rewriting_opt = bool

type to_fancy_args = { invert_low : (z -> z -> z option);
                       invert_high : (z -> z -> z option);
                       value_range : zrange; flag_range : zrange }

type translate_to_fancy_opt = to_fancy_args option

(** val default_translate_to_fancy : translate_to_fancy_opt **)

let default_translate_to_fancy =
  None

type unfold_value_barrier_opt = bool

type assembly_hints_lines_opt = (char list * char list list) list

type error_on_unused_assembly_functions_opt = bool

type ignore_unique_asm_names_opt = bool

type synthesis_output_kind =
| Normal_output
| Assembly_output

(** val typedef_info_of_typedef :
    Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    Coq_typedef.typedef -> ((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT **)

let typedef_info_of_typedef relax_zrange t0 bounds1 td =
  (((td.Coq_typedef.name, td.Coq_typedef.description),
    (Coq7_Compilers.ToString.Coq_int.Coq_option.Coq_interp.to_union t0
      (Coq7_Compilers.ToString.Coq_int.Coq_option.Coq_interp.of_zrange_relaxed
        t0
        (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.map_ranges
          relax_zrange t0 bounds1)))), (ExistT (t0, bounds1)))

module Pipeline =
 struct
  type coq_BoundsPipelineOptions = { coq_AbstractInterpretation_opts : 
                                     Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options;
                                     low_level_rewriter_method : low_level_rewriter_method_opt;
                                     only_signed : only_signed_opt;
                                     no_select_size : no_select_size_opt;
                                     split_mul_to : split_mul_to_opt;
                                     split_multiret_to : split_multiret_to_opt;
                                     unfold_value_barrier : unfold_value_barrier_opt;
                                     relax_adc_sbb_return_carry_to_bitwidth : 
                                     Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt;
                                     translate_to_fancy : translate_to_fancy_opt;
                                     debug_rewriting : debug_rewriting_opt }

  (** val coq_AbstractInterpretation_opts :
      coq_BoundsPipelineOptions ->
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options **)

  let coq_AbstractInterpretation_opts boundsPipelineOptions =
    boundsPipelineOptions.coq_AbstractInterpretation_opts

  (** val low_level_rewriter_method :
      coq_BoundsPipelineOptions -> low_level_rewriter_method_opt **)

  let low_level_rewriter_method boundsPipelineOptions =
    boundsPipelineOptions.low_level_rewriter_method

  (** val only_signed : coq_BoundsPipelineOptions -> only_signed_opt **)

  let only_signed boundsPipelineOptions =
    boundsPipelineOptions.only_signed

  (** val no_select_size : coq_BoundsPipelineOptions -> no_select_size_opt **)

  let no_select_size boundsPipelineOptions =
    boundsPipelineOptions.no_select_size

  (** val split_mul_to : coq_BoundsPipelineOptions -> split_mul_to_opt **)

  let split_mul_to boundsPipelineOptions =
    boundsPipelineOptions.split_mul_to

  (** val split_multiret_to :
      coq_BoundsPipelineOptions -> split_multiret_to_opt **)

  let split_multiret_to boundsPipelineOptions =
    boundsPipelineOptions.split_multiret_to

  (** val unfold_value_barrier :
      coq_BoundsPipelineOptions -> unfold_value_barrier_opt **)

  let unfold_value_barrier boundsPipelineOptions =
    boundsPipelineOptions.unfold_value_barrier

  (** val relax_adc_sbb_return_carry_to_bitwidth :
      coq_BoundsPipelineOptions ->
      Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt **)

  let relax_adc_sbb_return_carry_to_bitwidth boundsPipelineOptions =
    boundsPipelineOptions.relax_adc_sbb_return_carry_to_bitwidth

  (** val translate_to_fancy :
      coq_BoundsPipelineOptions -> translate_to_fancy_opt **)

  let translate_to_fancy boundsPipelineOptions =
    boundsPipelineOptions.translate_to_fancy

  (** val debug_rewriting :
      coq_BoundsPipelineOptions -> debug_rewriting_opt **)

  let debug_rewriting boundsPipelineOptions =
    boundsPipelineOptions.debug_rewriting

  (** val with_dead_code_elimination : coq_BoundsPipelineOptions -> bool **)

  let with_dead_code_elimination _ =
    true

  (** val with_let_bind_return : coq_BoundsPipelineOptions -> bool **)

  let with_let_bind_return _ =
    true

  (** val adc_no_carry_to_add : coq_BoundsPipelineOptions -> bool **)

  let adc_no_carry_to_add boundsPipelineOptions =
    match boundsPipelineOptions.translate_to_fancy with
    | Some _ -> false
    | None -> true

  type coq_ErrorMessage =
  | Computed_bounds_are_not_tight_enough of Coq3_Compilers.base
                                            Compilers.Coq_base.Coq_type.coq_type
                                            Compilers.Coq_type.coq_type
     * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
     * Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
       Compilers.Coq_type.for_each_lhs_of_arrow
  | No_modular_inverse of char list * z * z
  | Value_not_leZ of char list * z * z
  | Value_not_leQ of char list * q * q
  | Value_not_ltZ of char list * z * z
  | Value_not_lt_listZ of char list * z list * z list
  | Value_not_le_listZ of char list * z list * z list
  | Values_not_provably_distinctZ of char list * z * z
  | Values_not_provably_equalZ of char list * z * z
  | Values_not_provably_equal_listZ of char list * z list * z list
  | Unsupported_casts_in_input of Coq3_Compilers.base
                                  Compilers.Coq_base.Coq_type.coq_type
                                  Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
       Compilers.Coq_type.coq_type, (Coq3_Compilers.base
       Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, char list)
       Compilers.Coq_expr.expr) sigT list
  | Stringification_failed of Coq3_Compilers.base
                              Compilers.Coq_base.Coq_type.coq_type
                              Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr * char list
  | Invalid_argument of char list
  | Assembly_parsing_error of char list * parseValidatedError
  | Assembly_without_any_global_labels of char list list
  | Unused_global_assembly_labels of (char list * char list list) list
     * char list list
  | Equivalence_checking_failure_pre_asm of Coq3_Compilers.base
                                            Compilers.Coq_base.Coq_type.coq_type
                                            Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
       Compilers.Coq_type.for_each_lhs_of_arrow * equivalenceCheckingError
  | Equivalence_checking_failure of Coq3_Compilers.base
                                    Compilers.Coq_base.Coq_type.coq_type
                                    Compilers.Coq_type.coq_type
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr * char list * 
     lines
     * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
       Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
       Compilers.Coq_type.for_each_lhs_of_arrow * equivalenceCheckingError

  module M =
   struct
    (** val bind :
        (char list, (coq_ErrorMessage, 'a1) errorT) debugM -> ('a1 ->
        (char list, (coq_ErrorMessage, 'a2) errorT) debugM) -> (char list,
        (coq_ErrorMessage, 'a2) errorT) debugM **)

    let bind x k =
      Debug.bind x (fun x0 ->
        match x0 with
        | Success x1 -> k x1
        | Error err0 -> Debug.ret (Error err0))
   end

  type coq_ExtendedSynthesisResult = { lines : char list list;
                                       ident_infos : Coq7_Compilers.ToString.ident_infos;
                                       arg_bounds : (Coq3_Compilers.base
                                                    Compilers.Coq_base.Coq_type.coq_type,
                                                    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
                                                    Compilers.Coq_type.for_each_lhs_of_arrow;
                                       out_bounds : Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp;
                                       arg_typedefs : (Coq3_Compilers.base
                                                      Compilers.Coq_base.Coq_type.coq_type,
                                                      Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
                                                      Compilers.Coq_type.for_each_lhs_of_arrow;
                                       out_typedefs : Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data;
                                       expr : (Coq3_Compilers.base
                                              Compilers.Coq_base.Coq_type.coq_type,
                                              Coq3_Compilers.ident)
                                              Compilers.Coq_expr.coq_Expr }

  (** val lines :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult -> char list
      list **)

  let lines _ e =
    e.lines

  (** val ident_infos :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
      Coq7_Compilers.ToString.ident_infos **)

  let ident_infos _ e =
    e.ident_infos

  (** val arg_bounds :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow **)

  let arg_bounds _ e =
    e.arg_bounds

  (** val out_bounds :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp **)

  let out_bounds _ e =
    e.out_bounds

  (** val expr :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> coq_ExtendedSynthesisResult ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let expr _ e =
    e.expr __

  (** val find_too_loose_base_bounds :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (bool * (nat * nat) list) * (zrange * zrange) list **)

  let rec find_too_loose_base_bounds = function
  | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
    (match t1 with
     | Coq3_Compilers.Z ->
       (fun a b ->
         match Obj.magic a with
         | Some a0 ->
           (match Obj.magic b with
            | Some b0 ->
              if is_tighter_than_bool a0 b0
              then ((false, []), [])
              else ((false, []), ((a0, b0) :: []))
            | None -> ((false, []), []))
         | None ->
           (match Obj.magic b with
            | Some _ -> ((true, []), [])
            | None -> ((false, []), [])))
     | Coq3_Compilers.Coq_bool -> (fun _ _ -> ((false, []), []))
     | Coq3_Compilers.Coq_nat -> (fun _ _ -> ((false, []), []))
     | Coq3_Compilers.Coq_zrange -> (fun _ _ -> ((false, []), []))
     | Coq3_Compilers.Coq_string -> (fun _ _ -> ((false, []), [])))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun pat ->
      let (ra, rb) = Obj.magic pat in
      (fun pat0 ->
      let (ra', rb') = Obj.magic pat0 in
      let (p, ls1) = find_too_loose_base_bounds a ra ra' in
      let (b1, lens1) = p in
      let (p0, ls2) = find_too_loose_base_bounds b rb rb' in
      let (b2, lens2) = p0 in
      ((((||) b1 b2), (app lens1 lens2)), (app ls1 ls2))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (fun ls1 ls2 ->
      match Obj.magic ls1 with
      | Some ls3 ->
        (match Obj.magic ls2 with
         | Some ls4 ->
           fold_right (fun pat ->
             let (y, err0) = pat in
             let (b, len) = y in
             (fun pat0 ->
             let (y0, errs) = pat0 in
             let (bs, lens) = y0 in
             ((((||) b bs), (app len lens)), (app err0 errs)))) ((false,
             (if Nat.eqb (length ls3) (length ls4)
              then []
              else ((length ls3), (length ls4)) :: [])), [])
             (map (fun pat ->
               let (a0, b) = pat in find_too_loose_base_bounds a a0 b)
               (combine ls3 ls4))
         | None -> ((false, []), []))
      | None ->
        (match Obj.magic ls2 with
         | Some _ -> ((true, []), [])
         | None -> ((false, []), [])))
  | Compilers.Coq_base.Coq_type.Coq_option a ->
    (fun a0 b ->
      match Obj.magic a0 with
      | Some o ->
        (match o with
         | Some a1 ->
           (match Obj.magic b with
            | Some o0 ->
              (match o0 with
               | Some b0 -> find_too_loose_base_bounds a a1 b0
               | None -> ((false, []), []))
            | None -> ((false, []), []))
         | None ->
           (match Obj.magic b with
            | Some o0 ->
              (match o0 with
               | Some _ -> ((false, []), [])
               | None -> ((false, []), []))
            | None -> ((false, []), [])))
      | None ->
        (match Obj.magic b with
         | Some _ -> ((true, []), [])
         | None -> ((false, []), [])))
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (fun pat ->
      let () = Obj.magic pat in
      (fun pat0 -> let () = Obj.magic pat0 in ((false, []), [])))

  (** val find_too_loose_bounds :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> (bool * (nat * nat)
      list) * (zrange * zrange) list **)

  let find_too_loose_bounds = function
  | Compilers.Coq_type.Coq_base t1 -> find_too_loose_base_bounds t1
  | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ _ -> ((false, []), []))

  (** val explain_too_loose_bounds :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type ->
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> char list **)

  let explain_too_loose_bounds t0 b1 b2 =
    let (p, bs) = find_too_loose_bounds t0 b1 b2 in
    let (none_some, lens) = p in
    concat0 (newLine::[])
      (app
        (if none_some
         then ('F'::('o'::('u'::('n'::('d'::(' '::('N'::('o'::('n'::('e'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('S'::('o'::('m'::('e'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::[])))))))))))))))))))))))))))))))))) :: []
         else [])
        (app
          (map (fun pat ->
            let (l1, l2) = pat in
            append
              ('F'::('o'::('u'::('n'::('d'::(' '::('a'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('l'::('e'::('n'::('g'::('t'::('h'::(' '::[])))))))))))))))))))))))
              (append (show0 Decimal.show_nat l1)
                (append
                  (' '::('w'::('h'::('e'::('r'::('e'::(' '::('a'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('l'::('e'::('n'::('g'::('t'::('h'::(' '::[]))))))))))))))))))))))))
                  (append (show0 Decimal.show_nat l2)
                    (' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::('.'::[]))))))))))))))))))
            lens)
          (map (fun pat ->
            let (b3, b4) = pat in
            append
              ('T'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::[])))))))))))
              (append (show0 show_zrange b3)
                (append
                  (' '::('a'::('r'::('e'::(' '::('l'::('o'::('o'::('s'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::[])))))))))))))))))))))))))))))))))))))
                  (show0 show_zrange b4)))) bs)))

  (** val show_lines_Expr_with_and_without_casts :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr showLines **)

  let show_lines_Expr_with_and_without_casts t0 syntax_tree =
    app
      (let x = true in
       show_lines
         (Coq7_Compilers.ToString.PHOAS.Coq_expr.show_lines_Expr
           Coq7_Compilers.Options.PHOAS.default_with_casts x t0) syntax_tree)
      (app
        (('W'::('h'::('i'::('c'::('h'::(' '::('w'::('i'::('t'::('h'::(' '::('s'::('o'::('m'::('e'::(' '::('c'::('a'::('s'::('t'::('s'::(' '::('e'::('l'::('i'::('d'::('e'::('d'::(' '::('i'::('s'::(':'::[])))))))))))))))))))))))))))))))) :: [])
        (let x = false in
         show_lines
           (Coq7_Compilers.ToString.PHOAS.Coq_expr.show_lines_Expr
             Coq7_Compilers.Options.PHOAS.default_with_casts x t0) syntax_tree))

  (** val show_lines_Expr :
      machine_wordsize_opt -> Coq7_Compilers.ToString.coq_OutputLanguageAPI
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow -> bool ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr showLines **)

  let show_lines_Expr machine_wordsize0 output_api t0 arg_bounds0 include_input_bounds syntax_tree =
    match output_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            Coq6_Compilers.ZRange.Settings.AbstractInterpretation.default_Options
            (fun r0 -> r0)
            Coq7_Compilers.Options.default_language_naming_conventions
            Coq7_Compilers.Options.default_documentation_options
            Coq7_Compilers.Options.default_output_options machine_wordsize0
            false false false false false [] ('f'::[]) t0 syntax_tree
            (fun _ _ -> []) None arg_bounds0
            (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
              (Compilers.Coq_type.final_codomain t0))
            (Compilers.Coq_type.forall_each_lhs_of_arrow
              Coq7_Compilers.ToString.OfPHOAS.var_typedef_data_None t0)
            (Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data_None
              (Compilers.Coq_type.final_codomain t0)) with
    | Inl p ->
      let (e_lines, _) = p in
      app
        (('T'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('a'::('x'::(' '::('t'::('r'::('e'::('e'::(':'::[])))))))))))))))) :: [])
        (app (show_lines_Expr_with_and_without_casts t0 syntax_tree)
          (app
            ([] :: (('w'::('h'::('i'::('c'::('h'::(' '::('c'::('a'::('n'::(' '::('b'::('e'::(' '::('p'::('r'::('e'::('t'::('t'::('y'::('-'::('p'::('r'::('i'::('n'::('t'::('e'::('d'::(' '::('a'::('s'::(':'::[]))))))))))))))))))))))))))))))) :: []))
            (app e_lines
              (app ([] :: [])
                (if include_input_bounds
                 then (append
                        ('w'::('i'::('t'::('h'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::[]))))))))))))))))))
                        (append
                          (show_lvl
                            (Coq7_Compilers.ToString.PHOAS.Coq_type.show_lvl_for_each_lhs_of_arrow
                              Coq7_Compilers.ToString.ZRange.Coq_type.Coq_option.show_lvl_interp
                              t0) arg_bounds0 (Level.Coq_level Z0))
                          (append ('.'::[]) (newLine::[])))) :: []
                 else [])))))
    | Inr errs ->
      app
        ((append
           ('('::('U'::('n'::('p'::('r'::('i'::('n'::('t'::('i'::('b'::('l'::('e'::(' '::('s'::('y'::('n'::('t'::('a'::('x'::(' '::('t'::('r'::('e'::('e'::(' '::('u'::('s'::('e'::('d'::(' '::('i'::('n'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('a'::('n'::('a'::('l'::('y'::('s'::('i'::('s'::(')'::[])))))))))))))))))))))))))))))))))))))))))))))))))
           (newLine::[])) :: [])
        (app
          (('S'::('t'::('r'::('i'::('n'::('g'::('i'::('f'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(' '::('f'::('a'::('i'::('l'::('e'::('d'::(' '::('o'::('n'::(' '::('t'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('a'::('x'::(' '::('t'::('r'::('e'::('e'::(':'::[])))))))))))))))))))))))))))))))))))))))))) :: [])
          (app (show_lines_Expr_with_and_without_casts t0 syntax_tree)
            (errs :: [])))

  (** val show_lines_ErrorMessage :
      machine_wordsize_opt -> Coq7_Compilers.ToString.coq_OutputLanguageAPI
      -> coq_ErrorMessage showLines **)

  let show_lines_ErrorMessage machine_wordsize0 output_api = function
  | Computed_bounds_are_not_tight_enough (t0, computed_bounds,
                                          expected_bounds, syntax_tree,
                                          arg_bounds0) ->
    app
      ((append
         ('C'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::[]))))))))))))))))
         (append
           (show_lvl
             (Coq7_Compilers.ToString.ZRange.Coq_type.Coq_base.Coq_option.show_lvl_interp
               (Compilers.Coq_type.final_codomain t0)) computed_bounds
             (Level.Coq_level Z0))
           (append
             (' '::('a'::('r'::('e'::(' '::('n'::('o'::('t'::(' '::('t'::('i'::('g'::('h'::('t'::(' '::('e'::('n'::('o'::('u'::('g'::('h'::(' '::('('::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('n'::('o'::('t'::(' '::('l'::('o'::('o'::('s'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))
             (append
               (show_lvl
                 (Coq7_Compilers.ToString.ZRange.Coq_type.Coq_base.Coq_option.show_lvl_interp
                   (Compilers.Coq_type.final_codomain t0)) expected_bounds
                 (Level.Coq_level Z0)) (')'::('.'::[])))))) :: [])
      (app
        ((explain_too_loose_bounds (Compilers.Coq_type.Coq_base
           (Compilers.Coq_type.final_codomain t0)) computed_bounds
           expected_bounds) :: [])
        (show_lines_Expr machine_wordsize0 output_api t0 arg_bounds0 true
          syntax_tree))
  | No_modular_inverse (descr, v, m4) ->
    (append
      ('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('c'::('o'::('m'::('p'::('u'::('t'::('e'::(' '::('a'::(' '::('m'::('o'::('d'::('u'::('l'::('a'::('r'::(' '::('i'::('n'::('v'::('e'::('r'::('s'::('e'::(' '::('('::[])))))))))))))))))))))))))))))))))))))
      (append descr
        (append (')'::(' '::('f'::('o'::('r'::(' '::[]))))))
          (append (show0 Decimal.show_Z v)
            (append (' '::('m'::('o'::('d'::(' '::[])))))
              (show0 Decimal.show_Z m4)))))) :: []
  | Value_not_leZ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::(' '::('n'::('o'::('t'::(' '::('\226'::('\137'::('\164'::(' '::('('::[])))))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append (show0 Decimal.show_Z lhs)
            (append (' '::('\226'::('\137'::('\164'::(' '::[])))))
              (show0 Decimal.show_Z rhs)))))) :: []
  | Value_not_leQ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::(' '::('n'::('o'::('t'::(' '::('\226'::('\137'::('\164'::(' '::('('::[])))))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append (show0 Decimal.show_Q lhs)
            (append (' '::('\226'::('\137'::('\164'::(' '::[])))))
              (show0 Decimal.show_Q rhs)))))) :: []
  | Value_not_ltZ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::(' '::('n'::('o'::('t'::(' '::('<'::(' '::('('::[])))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append (show0 Decimal.show_Z lhs)
            (append (' '::('<'::(' '::[]))) (show0 Decimal.show_Z rhs)))))) :: []
  | Value_not_lt_listZ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::(' '::('n'::('o'::('t'::(' '::('<'::(' '::('('::[])))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append
            (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_Z)) lhs)
            (append (' '::('<'::(' '::[])))
              (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_Z))
                rhs)))))) :: []
  | Value_not_le_listZ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::(' '::('n'::('o'::('t'::(' '::('\226'::('\137'::('\164'::(' '::('('::[])))))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append
            (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_Z)) lhs)
            (append (' '::('\226'::('\137'::('\164'::(' '::[])))))
              (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_Z))
                rhs)))))) :: []
  | Values_not_provably_distinctZ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::('s'::(' '::('n'::('o'::('t'::(' '::('p'::('r'::('o'::('v'::('a'::('b'::('l'::('y'::(' '::('d'::('i'::('s'::('t'::('i'::('n'::('c'::('t'::(' '::('('::[]))))))))))))))))))))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append (show0 Decimal.show_Z lhs)
            (append (' '::('\226'::('\137'::('\160'::(' '::[])))))
              (show0 Decimal.show_Z rhs)))))) :: []
  | Values_not_provably_equalZ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::('s'::(' '::('n'::('o'::('t'::(' '::('p'::('r'::('o'::('v'::('a'::('b'::('l'::('y'::(' '::('e'::('q'::('u'::('a'::('l'::(' '::('('::[])))))))))))))))))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append (show0 Decimal.show_Z lhs)
            (append (' '::('='::(' '::[]))) (show0 Decimal.show_Z rhs)))))) :: []
  | Values_not_provably_equal_listZ (descr, lhs, rhs) ->
    (append
      ('V'::('a'::('l'::('u'::('e'::('s'::(' '::('n'::('o'::('t'::(' '::('p'::('r'::('o'::('v'::('a'::('b'::('l'::('y'::(' '::('e'::('q'::('u'::('a'::('l'::(' '::('('::[])))))))))))))))))))))))))))
      (append descr
        (append
          (')'::(' '::(':'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[])))))))))))))
          (append
            (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_Z)) lhs)
            (append (' '::('='::(' '::[])))
              (show0 (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_Z))
                rhs)))))) :: []
  | Unsupported_casts_in_input (t0, e0, ls) ->
    app
      (('U'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('c'::('a'::('s'::('t'::('s'::(' '::('i'::('n'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('s'::('y'::('n'::('t'::('a'::('x'::(' '::('t'::('r'::('e'::('e'::(':'::[]))))))))))))))))))))))))))))))))))))))) :: [])
      (app
        (show_lines
          (Coq7_Compilers.ToString.PHOAS.Coq_expr.show_lines_Expr
            Coq7_Compilers.Options.PHOAS.default_with_casts
            Coq7_Compilers.Options.PHOAS.default_with_all_casts t0) e0)
        ((append
           ('U'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('c'::('a'::('s'::('t'::('s'::(':'::(' '::[])))))))))))))))))))
           (show_list (fun v ->
             show0
               (Coq7_Compilers.ToString.PHOAS.Coq_expr.show_expr
                 Coq7_Compilers.Options.PHOAS.default_with_casts
                 Coq7_Compilers.Options.PHOAS.default_with_all_casts
                 (projT1 v)) (projT2 v)) ls)) :: []))
  | Stringification_failed (t0, e0, err0) ->
    app
      (('S'::('t'::('r'::('i'::('n'::('g'::('i'::('f'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(' '::('f'::('a'::('i'::('l'::('e'::('d'::(' '::('o'::('n'::(' '::('t'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('a'::('x'::(' '::('t'::('r'::('e'::('e'::(':'::[])))))))))))))))))))))))))))))))))))))))))) :: [])
      (app (show_lines_Expr_with_and_without_casts t0 e0) (err0 :: []))
  | Invalid_argument msg ->
    (append
      ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(':'::(' '::[]))))))))))))))))))
      msg) :: []
  | Assembly_parsing_error (fname, msgs) ->
    app
      ((append
         ('I'::('n'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('f'::('i'::('l'::('e'::(' '::[])))))))))))))))))
         (append fname (':'::[]))) :: [])
      (show_lines show_lines_ParseValidatedError msgs)
  | Assembly_without_any_global_labels fnames ->
    (match fnames with
     | [] ->
       ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('A'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::('_'::('w'::('i'::('t'::('h'::('o'::('u'::('t'::('_'::('a'::('n'::('y'::('_'::('g'::('l'::('o'::('b'::('a'::('l'::('_'::('l'::('a'::('b'::('e'::('l'::('s'::(' '::('['::(']'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []
     | _ :: _ ->
       (append
         ('T'::('h'::('e'::('r'::('e'::(' '::('a'::('r'::('e'::(' '::('n'::('o'::(' '::('g'::('l'::('o'::('b'::('a'::('l'::(' '::('l'::('a'::('b'::('e'::('l'::('s'::(' '::('i'::('n'::(' '::[]))))))))))))))))))))))))))))))
         (append (concat0 (','::(' '::[])) fnames) ('.'::[]))) :: [])
  | Unused_global_assembly_labels (fname_labels, valid_requests) ->
    (append
      ('T'::('h'::('e'::(' '::('f'::('o'::('l'::('l'::('o'::('w'::('i'::('n'::('g'::(' '::('g'::('l'::('o'::('b'::('a'::('l'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(' '::('p'::('r'::('e'::('s'::('e'::('n'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('h'::('i'::('n'::('t'::('s'::(' '::('f'::('i'::('l'::('e'::(' '::('b'::('u'::('t'::(' '::('d'::('o'::(' '::('n'::('o'::('t'::(' '::('c'::('o'::('r'::('r'::('e'::('s'::('p'::('o'::('n'::('d'::(' '::('t'::('o'::(' '::('a'::('n'::('y'::(' '::('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
      (append
        (concat0 (','::(' '::[]))
          (map (fun pat ->
            let (fname, labels) = pat in
            append (concat0 (','::(' '::[])) labels)
              (append (' '::('('::('i'::('n'::(' '::[])))))
                (append fname (')'::[])))) fname_labels))
        (append
          (' '::('('::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('o'::('n'::('e'::(' '::('o'::('f'::(':'::(' '::[])))))))))))))))))))
          (append (concat0 (','::(' '::[])) valid_requests) (')'::[]))))) :: []
  | Equivalence_checking_failure_pre_asm (t0, e0, arg_bounds0, err0) ->
    app
      (('E'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('p'::('r'::('e'::('p'::('a'::('r'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('h'::('e'::('c'::('k'::(' '::('f'::('o'::('r'::(' '::('e'::('q'::('u'::('i'::('v'::('a'::('l'::('e'::('n'::('c'::('e'::(' '::('o'::('f'::(' '::('s'::('y'::('n'::('t'::('a'::('x'::(' '::('t'::('r'::('e'::('e'::(' '::('a'::('n'::('d'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
      (app
        (show_lines_Expr machine_wordsize0 output_api t0 arg_bounds0 false e0)
        (app
          ([] :: (('('::('n'::('o'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(')'::[]))))))))))))) :: []))
          (app
            ([] :: (('E'::('q'::('u'::('i'::('v'::('a'::('l'::('e'::('n'::('c'::('e'::(' '::('c'::('h'::('e'::('c'::('k'::('i'::('n'::('g'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::[]))))))))))))))))))))))))))) :: []))
            (show_lines show_lines_EquivalenceCheckingError err0))))
  | Equivalence_checking_failure (t0, e0, asm_fname, asm, arg_bounds0, err0) ->
    app
      (('E'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('c'::('h'::('e'::('c'::('k'::('i'::('n'::('g'::(' '::('f'::('o'::('r'::(' '::('e'::('q'::('u'::('i'::('v'::('a'::('l'::('e'::('n'::('c'::('e'::(' '::('o'::('f'::(' '::('s'::('y'::('n'::('t'::('a'::('x'::(' '::('t'::('r'::('e'::('e'::(' '::('a'::('n'::('d'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(':'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
      (app
        (show_lines_Expr machine_wordsize0 output_api t0 arg_bounds0 false e0)
        (app
          ([] :: ((append
                    ('A'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('('::('i'::('n'::(' '::[])))))))))))))
                    (append asm_fname (')'::(':'::[])))) :: []))
          (app
            (match symbolic_state_of_EquivalenceCheckingError err0 with
             | Some s0 -> show_lines_AnnotatedLines (asm, s0)
             | None -> show_lines show_lines_Lines asm)
            (app
              ([] :: (('E'::('q'::('u'::('i'::('v'::('a'::('l'::('e'::('n'::('c'::('e'::(' '::('c'::('h'::('e'::('c'::('k'::('i'::('n'::('g'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::[]))))))))))))))))))))))))))) :: []))
              (show_lines show_lines_EquivalenceCheckingError err0)))))

  (** val debug_after_rewrite :
      debug_rewriting_opt -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (char list, unit)
      debugM **)

  let debug_after_rewrite debug_rewriting0 t0 descr e =
    if debug_rewriting0
    then Debug.debug' (fun pat ->
           let () = pat in
           app
             ((append
                ('A'::('f'::('t'::('e'::('r'::(' '::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))))
                (append descr (':'::[]))) :: [])
             (let x = true in
              show_lines
                (Coq7_Compilers.ToString.PHOAS.Coq_expr.show_lines_Expr
                  Coq7_Compilers.Options.PHOAS.default_with_casts x t0) e))
    else Debug.ret ()

  (** val wrap_debug_rewrite :
      debug_rewriting_opt -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      char list -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (char list, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) debugM **)

  let wrap_debug_rewrite debug_rewriting0 t0 descr doRewrite e =
    let e0 = doRewrite e in
    Debug.sequence (debug_after_rewrite debug_rewriting0 t0 descr e0)
      (Debug.ret e0)

  (** val coq_RewriteAndEliminateDeadAndInline_gen :
      debug_rewriting_opt -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      char list -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (char list, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) debugM) -> bool -> bool -> bool ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (char list,
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr) debugM **)

  let coq_RewriteAndEliminateDeadAndInline_gen debug_rewriting0 t0 descr doRewrite with_dead_code_elimination0 with_subst01 with_let_bind_return0 e =
    Debug.bind (doRewrite e) (fun e0 ->
      let_In (Compilers.GeneralizeVar.coq_ToFlat t0 e0) (fun e1 ->
        let e2 = fun _ ->
          Compilers.GeneralizeVar.coq_FromFlat (fun _ x x0 _ ->
            Compilers.Coq_base.try_make_transport_cps (fun _ x1 x2 _ ->
              Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0)
            (fun _ ->
            Compilers.DefaultValue.Coq_expr.default
              Coq3_Compilers.base_default Coq3_Compilers.buildIdent) t0 e1
        in
        Debug.bind
          (if with_subst01
           then wrap_debug_rewrite debug_rewriting0 t0
                  (append
                    ('s'::('u'::('b'::('s'::('t'::('0'::('1'::(' '::('f'::('o'::('r'::(' '::[]))))))))))))
                    descr) (fun x _ ->
                  Coq9_Compilers.Subst01.coq_Subst01
                    Coq5_Compilers.Coq_ident.is_comment t0 x) e2
           else if with_dead_code_elimination0
                then wrap_debug_rewrite debug_rewriting0 t0
                       (append
                         ('D'::('C'::('E'::(' '::('f'::('o'::('r'::(' '::[]))))))))
                         descr) (fun x _ ->
                       Coq9_Compilers.DeadCodeElimination.coq_EliminateDead
                         Coq5_Compilers.Coq_ident.is_comment t0 x) e2
                else Debug.ret e2) (fun e3 ->
          Debug.bind
            (if with_let_bind_return0
             then wrap_debug_rewrite debug_rewriting0 t0
                    (append
                      ('L'::('e'::('t'::('B'::('i'::('n'::('d'::('R'::('e'::('t'::('u'::('r'::('n'::(' '::('f'::('o'::('r'::(' '::[]))))))))))))))))))
                      descr) (fun x _ ->
                    Coq_Compilers.UnderLets.coq_LetBindReturn
                      (fun _ x0 x1 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x0 x1)
                      Coq3_Compilers.invertIdent Coq3_Compilers.buildIdent
                      Coq3_Compilers.ident_is_var_like t0 x) e3
             else Debug.ret e3) (fun e4 ->
            Debug.bind (doRewrite e4) (fun e5 ->
              let_In (Compilers.GeneralizeVar.coq_ToFlat t0 e5) (fun e6 ->
                let e7 = fun _ ->
                  Compilers.GeneralizeVar.coq_FromFlat (fun _ x x0 _ ->
                    Compilers.Coq_base.try_make_transport_cps
                      (fun _ x1 x2 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0)
                    (fun _ ->
                    Compilers.DefaultValue.Coq_expr.default
                      Coq3_Compilers.base_default Coq3_Compilers.buildIdent)
                    t0 e6
                in
                Debug.bind
                  (if with_dead_code_elimination0
                   then wrap_debug_rewrite debug_rewriting0 t0
                          (append
                            ('D'::('C'::('E'::(' '::('a'::('f'::('t'::('e'::('r'::(' '::[]))))))))))
                            descr) (fun x _ ->
                          Coq9_Compilers.DeadCodeElimination.coq_EliminateDead
                            Coq5_Compilers.Coq_ident.is_comment t0 x) e7
                   else Debug.ret e7) Debug.ret))))))

  (** val coq_RewriteAndEliminateDeadAndInline :
      debug_rewriting_opt -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      char list -> ((Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) -> bool -> bool -> bool ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> (char list,
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr) debugM **)

  let coq_RewriteAndEliminateDeadAndInline debug_rewriting0 t0 descr doRewrite with_dead_code_elimination0 with_subst01 with_let_bind_return0 e =
    coq_RewriteAndEliminateDeadAndInline_gen debug_rewriting0 t0 descr
      (wrap_debug_rewrite debug_rewriting0 t0 descr doRewrite)
      with_dead_code_elimination0 with_subst01 with_let_bind_return0 e

  (** val opts_of_method :
      low_level_rewriter_method_opt ->
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.coq_RewriterOptions **)

  let opts_of_method low_level_rewriter_method0 =
    { Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_decision_tree =
      (match low_level_rewriter_method0 with
       | Precomputed_decision_tree -> true
       | Unreduced_decision_tree -> true
       | Unreduced_naive -> false);
      Coq2_Compilers.RewriteRules.GoalType.DefaultOptionType.use_precomputed_functions =
      (match low_level_rewriter_method0 with
       | Precomputed_decision_tree -> true
       | Unreduced_decision_tree -> false
       | Unreduced_naive -> false) }

  (** val coq_PreBoundsPipeline :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      low_level_rewriter_method_opt -> only_signed_opt ->
      unfold_value_barrier_opt -> translate_to_fancy_opt ->
      debug_rewriting_opt -> bool -> bool -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow -> (char list,
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr) debugM **)

  let coq_PreBoundsPipeline opts low_level_rewriter_method0 _ unfold_value_barrier0 translate_to_fancy0 debug_rewriting0 =
    let with_dead_code_elimination0 = true in
    (fun with_subst01 with_let_bind_return0 t0 e arg_bounds0 ->
    let opts0 = opts_of_method low_level_rewriter_method0 in
    let e0 = fun _ ->
      Coq8_Compilers.coq_PartialEvaluateWithListInfoFromBounds
        (Coq6_Compilers.ZRange.Settings.AbstractInterpretation.shiftr_avoid_uint1
          opts) t0 e arg_bounds0
    in
    Debug.bind
      (wrap_debug_rewrite debug_rewriting0 t0
        ('P'::('a'::('r'::('t'::('i'::('a'::('l'::('E'::('v'::('a'::('l'::('u'::('a'::('t'::('e'::[])))))))))))))))
        (fun x _ -> Coq11_Compilers.coq_PartialEvaluate opts0 t0 x) e0)
      (fun e1 ->
      Debug.bind
        (if unfold_value_barrier0
         then wrap_debug_rewrite debug_rewriting0 t0
                ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('U'::('n'::('f'::('o'::('l'::('d'::('V'::('a'::('l'::('u'::('e'::('B'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))))))))))))))
                (fun x _ ->
                Coq23_Compilers.RewriteRules.coq_RewriteUnfoldValueBarrier
                  opts0 t0 x) e1
         else Debug.ret e1) (fun e2 ->
        Debug.bind
          (coq_RewriteAndEliminateDeadAndInline debug_rewriting0 t0
            ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('A'::('r'::('i'::('t'::('h'::('_'::('0'::[]))))))))))))))
            (fun x _ ->
            Coq13_Compilers.RewriteRules.coq_RewriteArith Z0 opts0 t0 x)
            with_dead_code_elimination0 with_subst01 with_let_bind_return0 e2)
          (fun e3 ->
          Debug.bind
            (wrap_debug_rewrite debug_rewriting0 t0
              ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('A'::('r'::('i'::('t'::('h'::('_'::('2'::('\226'::('\129'::('\184'::[])))))))))))))))))
              (fun x _ ->
              Coq13_Compilers.RewriteRules.coq_RewriteArith
                (Coq_Z.pow (Zpos (XO XH)) (Zpos (XO (XO (XO XH))))) opts0 t0 x)
              e3) (fun e4 ->
            Debug.bind
              (match translate_to_fancy0 with
               | Some t1 ->
                 let invert_low0 = t1.invert_low in
                 let invert_high0 = t1.invert_high in
                 wrap_debug_rewrite debug_rewriting0 t0
                   ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('T'::('o'::('F'::('a'::('n'::('c'::('y'::[]))))))))))))))
                   (fun x _ ->
                   Coq21_Compilers.RewriteRules.coq_RewriteToFancy
                     invert_low0 invert_high0 opts0 t0 x) e4
               | None -> Debug.ret e4) (fun e5 ->
              let_In (Compilers.GeneralizeVar.coq_ToFlat t0 e5) (fun e6 ->
                let e7 = fun _ ->
                  Compilers.GeneralizeVar.coq_FromFlat (fun _ x x0 _ ->
                    Compilers.Coq_base.try_make_transport_cps
                      (fun _ x1 x2 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0)
                    (fun _ ->
                    Compilers.DefaultValue.Coq_expr.default
                      Coq3_Compilers.base_default Coq3_Compilers.buildIdent)
                    t0 e6
                in
                Debug.ret e7)))))))

  (** val coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRectsWithDebug :
      low_level_rewriter_method_opt -> debug_rewriting_opt -> nat ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (char list, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) debugM -> (char list, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) debugM **)

  let coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRectsWithDebug low_level_rewriter_method0 debug_rewriting0 n3 t0 e =
    let opts = opts_of_method low_level_rewriter_method0 in
    Debug.bind e (fun e0 ->
      Debug.bind
        (wrap_debug_rewrite debug_rewriting0 t0
          ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('F'::('l'::('a'::('t'::('t'::('e'::('n'::('T'::('h'::('u'::('n'::('k'::('e'::('d'::('R'::('e'::('c'::('t'::('s'::[]))))))))))))))))))))))))))
          (fun x _ ->
          Coq16_Compilers.RewriteRules.coq_RewriteFlattenThunkedRects opts t0
            x) e0) (fun e1 ->
        Debug.bind
          (wrap_debug_rewrite debug_rewriting0 t0
            (append ('r'::('e'::('p'::('e'::('a'::('t'::(' '::[])))))))
              (append (show0 Decimal.show_nat n3)
                (' '::('R'::('e'::('w'::('r'::('i'::('t'::('e'::('A'::('d'::('d'::('A'::('s'::('s'::('o'::('c'::('L'::('e'::('f'::('t'::[]))))))))))))))))))))))
            (fun e2 ->
            fold_right (fun f -> f) e2
              (repeat (fun x _ ->
                Coq12_Compilers.RewriteRules.coq_RewriteAddAssocLeft opts t0 x)
                n3)) e1) Debug.ret))

  (** val coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects :
      low_level_rewriter_method_opt -> debug_rewriting_opt -> nat ->
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (char list, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) debugM -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
      Compilers.Coq_expr.expr **)

  let coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects low_level_rewriter_method0 debug_rewriting0 n3 t0 e =
    Debug.eval_result
      (coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRectsWithDebug
        low_level_rewriter_method0 debug_rewriting0 n3 t0 e) __

  (** val coq_BoundsPipelineWithDebug :
      coq_BoundsPipelineOptions -> bool -> z list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (char list, (coq_ErrorMessage, (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
      Compilers.Coq_expr.coq_Expr) errorT) debugM **)

  let coq_BoundsPipelineWithDebug opts with_subst01 possible_values =
    let relax_zrange = relax_zrange_gen opts.only_signed possible_values in
    (fun t0 e arg_bounds0 out_bounds1 ->
    let assume_cast_truncates = false in
    let opts0 = opts_of_method opts.low_level_rewriter_method in
    Debug.bind
      (coq_PreBoundsPipeline opts.coq_AbstractInterpretation_opts
        opts.low_level_rewriter_method opts.only_signed
        opts.unfold_value_barrier opts.translate_to_fancy
        opts.debug_rewriting with_subst01 (with_let_bind_return opts) t0 e
        arg_bounds0) (fun e0 ->
      let e' =
        Coq8_Compilers.coq_CheckedPartialEvaluateWithBounds
          (Coq6_Compilers.ZRange.Settings.AbstractInterpretation.shiftr_avoid_uint1
            opts.coq_AbstractInterpretation_opts) (fun _ -> None)
          assume_cast_truncates Coq5_Compilers.Coq_ident.is_comment false t0
          e0 arg_bounds0
          (Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.coq_None
            (Compilers.Coq_type.final_codomain t0))
      in
      Debug.bind
        (match e' with
         | Inl e1 ->
           Debug.sequence
             (debug_after_rewrite opts.debug_rewriting t0
               ('C'::('h'::('e'::('c'::('k'::('e'::('d'::('P'::('a'::('r'::('t'::('i'::('a'::('l'::('E'::('v'::('a'::('l'::('u'::('a'::('t'::('e'::('W'::('i'::('t'::('h'::('B'::('o'::('u'::('n'::('d'::('s'::[]))))))))))))))))))))))))))))))))
               e1)
             (Debug.bind
               (coq_RewriteAndEliminateDeadAndInline opts.debug_rewriting t0
                 ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('A'::('r'::('i'::('t'::('h'::('W'::('i'::('t'::('h'::('C'::('a'::('s'::('t'::('s'::[])))))))))))))))))))))
                 (fun x _ ->
                 Coq14_Compilers.RewriteRules.coq_RewriteArithWithCasts
                   (adc_no_carry_to_add opts) opts0 t0 x)
                 (with_dead_code_elimination opts) with_subst01
                 (with_let_bind_return opts) e1) (fun e2 ->
               let_In (Compilers.GeneralizeVar.coq_ToFlat t0 e2) (fun e3 ->
                 let e4 = fun _ ->
                   Compilers.GeneralizeVar.coq_FromFlat (fun _ x x0 _ ->
                     Compilers.Coq_base.try_make_transport_cps
                       (fun _ x1 x2 _ ->
                       Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0)
                     (fun _ ->
                     Compilers.DefaultValue.Coq_expr.default
                       Coq3_Compilers.base_default Coq3_Compilers.buildIdent)
                     t0 e3
                 in
                 let e'0 =
                   Coq8_Compilers.coq_CheckedPartialEvaluateWithBounds
                     (Coq6_Compilers.ZRange.Settings.AbstractInterpretation.shiftr_avoid_uint1
                       opts.coq_AbstractInterpretation_opts) (fun _ -> None)
                     assume_cast_truncates
                     Coq5_Compilers.Coq_ident.is_comment true t0 e4
                     arg_bounds0 out_bounds1
                 in
                 (match e'0 with
                  | Inl e5 ->
                    Debug.sequence
                      (debug_after_rewrite opts.debug_rewriting t0
                        ('C'::('h'::('e'::('c'::('k'::('e'::('d'::('P'::('a'::('r'::('t'::('i'::('a'::('l'::('E'::('v'::('a'::('l'::('u'::('a'::('t'::('e'::('W'::('i'::('t'::('h'::('B'::('o'::('u'::('n'::('d'::('s'::(' '::('2'::[]))))))))))))))))))))))))))))))))))
                        e5)
                      (let_In (Compilers.GeneralizeVar.coq_ToFlat t0 e5)
                        (fun e6 ->
                        let e7 = fun _ ->
                          Compilers.GeneralizeVar.coq_FromFlat
                            (fun _ x x0 _ ->
                            Compilers.Coq_base.try_make_transport_cps
                              (fun _ x1 x2 _ ->
                              Coq3_Compilers.try_make_base_transport_cps x1 x2)
                              x x0) (fun _ ->
                            Compilers.DefaultValue.Coq_expr.default
                              Coq3_Compilers.base_default
                              Coq3_Compilers.buildIdent) t0 e6
                        in
                        let e'1 =
                          Coq8_Compilers.coq_CheckedPartialEvaluateWithBounds
                            (Coq6_Compilers.ZRange.Settings.AbstractInterpretation.shiftr_avoid_uint1
                              opts.coq_AbstractInterpretation_opts)
                            relax_zrange assume_cast_truncates
                            Coq5_Compilers.Coq_ident.is_comment true t0 e7
                            arg_bounds0 out_bounds1
                        in
                        (match e'1 with
                         | Inl e8 ->
                           Debug.sequence
                             (debug_after_rewrite opts.debug_rewriting t0
                               ('C'::('h'::('e'::('c'::('k'::('e'::('d'::('P'::('a'::('r'::('t'::('i'::('a'::('l'::('E'::('v'::('a'::('l'::('u'::('a'::('t'::('e'::('W'::('i'::('t'::('h'::('B'::('o'::('u'::('n'::('d'::('s'::(' '::('3'::[]))))))))))))))))))))))))))))))))))
                               e8) (Debug.ret (Inl e8))
                         | Inr e8 -> Debug.ret (Inr (Obj.magic e8)))))
                  | Inr v -> Debug.ret (Inr (Obj.magic v))))))
         | Inr v -> Debug.ret (Inr (Obj.magic v))) (fun e'0 ->
        match e'0 with
        | Inl e1 ->
          Debug.bind
            (match opts.split_mul_to with
             | Some p ->
               let (max_bitwidth, lgcarrymax) = p in
               wrap_debug_rewrite opts.debug_rewriting t0
                 ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('M'::('u'::('l'::('S'::('p'::('l'::('i'::('t'::[])))))))))))))))
                 (fun x _ ->
                 Coq17_Compilers.RewriteRules.coq_RewriteMulSplit
                   max_bitwidth lgcarrymax opts0 t0 x) e1
             | None -> Debug.ret e1) (fun e2 ->
            Debug.bind
              (match opts.split_multiret_to with
               | Some p ->
                 let (max_bitwidth, lgcarrymax) = p in
                 coq_RewriteAndEliminateDeadAndInline opts.debug_rewriting t0
                   ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('M'::('u'::('l'::('t'::('i'::('R'::('e'::('t'::('S'::('p'::('l'::('i'::('t'::[]))))))))))))))))))))
                   (fun x _ ->
                   Coq18_Compilers.RewriteRules.coq_RewriteMultiRetSplit
                     max_bitwidth lgcarrymax opts0 t0 x)
                   (with_dead_code_elimination opts) with_subst01
                   (with_let_bind_return opts) e2
               | None -> Debug.ret e2) (fun e3 ->
              let rewrote_E_so_should_rewrite_arith_again =
                match opts.split_mul_to with
                | Some _ -> true
                | None ->
                  (match opts.split_multiret_to with
                   | Some _ -> true
                   | None -> false)
              in
              Debug.bind
                (if rewrote_E_so_should_rewrite_arith_again
                 then coq_RewriteAndEliminateDeadAndInline
                        opts.debug_rewriting t0
                        ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('A'::('r'::('i'::('t'::('h'::('W'::('i'::('t'::('h'::('C'::('a'::('s'::('t'::('s'::[])))))))))))))))))))))
                        (fun x _ ->
                        Coq14_Compilers.RewriteRules.coq_RewriteArithWithCasts
                          (adc_no_carry_to_add opts) opts0 t0 x)
                        (with_dead_code_elimination opts) with_subst01
                        (with_let_bind_return opts) e3
                 else Debug.ret e3) (fun e4 ->
                Debug.bind
                  (match opts.relax_adc_sbb_return_carry_to_bitwidth with
                   | [] -> Debug.ret e4
                   | _ :: _ ->
                     wrap_debug_rewrite opts.debug_rewriting t0
                       ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('R'::('e'::('l'::('a'::('x'::('B'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('A'::('d'::('c'::('S'::('b'::('b'::[]))))))))))))))))))))))))))
                       (fun x _ ->
                       Coq20_Compilers.RewriteRules.coq_RewriteRelaxBitwidthAdcSbb
                         opts.relax_adc_sbb_return_carry_to_bitwidth opts0 t0
                         x) e4) (fun e5 ->
                  Debug.bind
                    (match opts.translate_to_fancy with
                     | Some t1 ->
                       let invert_low0 = t1.invert_low in
                       let invert_high0 = t1.invert_high in
                       let value_range0 = t1.value_range in
                       let flag_range0 = t1.flag_range in
                       wrap_debug_rewrite opts.debug_rewriting t0
                         ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('T'::('o'::('F'::('a'::('n'::('c'::('y'::('W'::('i'::('t'::('h'::('C'::('a'::('s'::('t'::('s'::[])))))))))))))))))))))))
                         (fun x _ ->
                         Coq22_Compilers.RewriteRules.coq_RewriteToFancyWithCasts
                           invert_low0 invert_high0 value_range0 flag_range0
                           opts0 t0 x) e5
                     | None -> Debug.ret e5) (fun e6 ->
                    Debug.bind
                      (match opts.no_select_size with
                       | Some bitwidth ->
                         wrap_debug_rewrite opts.debug_rewriting t0
                           ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('N'::('o'::('S'::('e'::('l'::('e'::('c'::('t'::[])))))))))))))))
                           (fun x _ ->
                           Coq19_Compilers.RewriteRules.coq_RewriteNoSelect
                             bitwidth opts0 t0 x) e6
                       | None -> Debug.ret e6) (fun e7 ->
                      Debug.bind
                        (wrap_debug_rewrite opts.debug_rewriting t0
                          ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('S'::('t'::('r'::('i'::('p'::('L'::('i'::('t'::('e'::('r'::('a'::('l'::('C'::('a'::('s'::('t'::('s'::[]))))))))))))))))))))))))
                          (fun x _ ->
                          Coq15_Compilers.RewriteRules.coq_RewriteStripLiteralCasts
                            opts0 t0 x) e7) (fun e8 -> Debug.ret (Success e8))))))))
        | Inr s0 ->
          (match s0 with
           | Inl p ->
             let (b, e1) = p in
             Debug.ret (Error (Computed_bounds_are_not_tight_enough (t0, b,
               out_bounds1, e1, arg_bounds0)))
           | Inr unsupported_casts ->
             Debug.ret (Error (Unsupported_casts_in_input (t0, e0,
               (map (fun pat ->
                 let ExistT (t1, e1) = pat in ExistT (t1, (e1 __)))
                 unsupported_casts))))))))
 end

(** val bytes_n : z -> nat **)

let bytes_n s0 =
  Coq_Z.to_nat
    (Coq_Z.opp
      (Coq_Z.div (Coq_Z.opp (Coq_Z.mul (Coq_Z.log2_up s0) (Zpos XH))) (Zpos
        (XO (XO (XO XH))))))

(** val qabs : q -> q **)

let qabs x =
  let { qnum = n3; qden = d } = x in { qnum = (Coq_Z.abs n3); qden = d }

(** val uweight : z -> nat -> z **)

let uweight lgr =
  weight lgr (Zpos XH)

(** val fueled_lub :
    ('a1 -> 'a1 -> bool) -> ('a1 -> 'a1 -> 'a1) -> nat -> ('a1 -> 'a1) -> 'a1
    -> bool * 'a1 **)

let rec fueled_lub aeq join0 fuel0 f x =
  match fuel0 with
  | O -> (false, x)
  | S n3 ->
    let fx = join0 x (f x) in
    if aeq x fx then (true, fx) else fueled_lub aeq join0 n3 f fx

(** val reified_id_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_id_gen =
  Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (fun v -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v)))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), (fun x ->
    Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), x)))))

(** val reified_selectznz_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_selectznz_gen =
  Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    (fun v -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    v)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (Coq3_Compilers.Coq_ident_List_map ((Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun q0 ->
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    Coq3_Compilers.Coq_ident_Z_zselect)), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), cond)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), p)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), q0)))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    (Coq3_Compilers.Coq_ident_List_combine
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    if_nonzero)))))))))))))

(** val reified_mulx_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_mulx_gen =
  Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun v0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun v1 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    v1)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))),
    (fun xy -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (Coq3_Compilers.Coq_ident_pair
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (Coq3_Compilers.Coq_ident_bool_rect
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun _ ->
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), xy)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), v0)), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), xy)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    bitwidth)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_bool_rect
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun _ ->
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_shiftr)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), xy)))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    bitwidth)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun _ ->
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), xy)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_geb)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    bitwidth)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic Z0))))))))))))))))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun n3 ->
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), v)), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_shiftl)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), n3)))))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun x ->
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zneg XH)))))))))))

(** val reified_addcarryx_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_addcarryx_gen =
  Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (fun v -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    v)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))),
    (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (Coq3_Compilers.Coq_ident_pair
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))))))))))))))

(** val reified_subborrowx_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_subborrowx_gen =
  Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    (fun v -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))),
    v)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))))),
    (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (Coq3_Compilers.Coq_ident_pair
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    Coq3_Compilers.Coq_ident_Z_opp)), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))))))))))))))))

(** val reified_value_barrier_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_value_barrier_gen =
  Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    Coq3_Compilers.Coq_ident_value_barrier)

(** val reified_cmovznz_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_cmovznz_gen =
  Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun v0 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    v0)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (fun z0 -> Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun nz ->
    Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic Z0))))))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    Coq3_Compilers.Coq_ident_Z_bneg)), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    Coq3_Compilers.Coq_ident_Z_bneg)), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), cond)))))))))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))), (fun t0 -> Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), v)), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), t0)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), z0)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), nz)))))))))))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), (fun t0 -> Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (fun z0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (fun nz -> Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_value_barrier)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t0)))))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), nz)))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_value_barrier)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lnot_modulo)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t0)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), z0)))))))))))))))

(** val reified_cmovznz_by_mul_gen :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reified_cmovznz_by_mul_gen =
  Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    (fun v0 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
    v0)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (fun z0 -> Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), (fun nz ->
    Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), cond)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos XH)))))))))), (fun t0 -> Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))))))), v)), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), t0)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), z0)))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), nz)))))))))))))))))), (Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), (fun t0 -> Compilers.Coq_expr.Abs
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (fun z0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (fun nz -> Compilers.Coq_expr.App
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_value_barrier)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t0)))))),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), nz)))))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_value_barrier)),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lnot_modulo)),
    (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t0)))),
    (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
    ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
    (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
    (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), bitwidth)))))))))), (Compilers.Coq_expr.Var
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), z0)))))))))))))))

(** val request_present : char list list -> char list -> bool **)

let request_present requests request =
  existsb (eqb0 request) requests

(** val check_args_of_list :
    (bool * (bool * Pipeline.coq_ErrorMessage)) list ->
    (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage,
    'a1) errorT **)

let check_args_of_list check_args_descr res =
  fold_right (fun pat ->
    let (precondition, y) = pat in
    let (b, e) = y in (fun k -> if implb precondition b then k else Error e))
    res check_args_descr

module Coq0_Options =
 struct
  type coq_PipelineOptions = { absint_opts : Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options;
                               widen_carry : widen_carry_opt;
                               widen_bytes : widen_bytes_opt;
                               unfold_value_barrier : unfold_value_barrier_opt;
                               should_split_multiret : should_split_multiret_opt;
                               should_split_mul : should_split_mul_opt;
                               output_options : Coq7_Compilers.Options.output_options_opt;
                               only_signed : only_signed_opt;
                               no_select : no_select_opt;
                               low_level_rewriter_method : low_level_rewriter_method_opt;
                               debug_rewriting : debug_rewriting_opt }

  (** val absint_opts :
      coq_PipelineOptions ->
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options **)

  let absint_opts pipelineOptions =
    pipelineOptions.absint_opts

  (** val widen_carry : coq_PipelineOptions -> widen_carry_opt **)

  let widen_carry pipelineOptions =
    pipelineOptions.widen_carry

  (** val widen_bytes : coq_PipelineOptions -> widen_bytes_opt **)

  let widen_bytes pipelineOptions =
    pipelineOptions.widen_bytes

  (** val unfold_value_barrier :
      coq_PipelineOptions -> unfold_value_barrier_opt **)

  let unfold_value_barrier pipelineOptions =
    pipelineOptions.unfold_value_barrier

  (** val should_split_multiret :
      coq_PipelineOptions -> should_split_multiret_opt **)

  let should_split_multiret pipelineOptions =
    pipelineOptions.should_split_multiret

  (** val should_split_mul : coq_PipelineOptions -> should_split_mul_opt **)

  let should_split_mul pipelineOptions =
    pipelineOptions.should_split_mul

  (** val output_options :
      coq_PipelineOptions -> Coq7_Compilers.Options.output_options_opt **)

  let output_options pipelineOptions =
    pipelineOptions.output_options

  (** val only_signed : coq_PipelineOptions -> only_signed_opt **)

  let only_signed pipelineOptions =
    pipelineOptions.only_signed

  (** val no_select : coq_PipelineOptions -> no_select_opt **)

  let no_select pipelineOptions =
    pipelineOptions.no_select

  (** val low_level_rewriter_method :
      coq_PipelineOptions -> low_level_rewriter_method_opt **)

  let low_level_rewriter_method pipelineOptions =
    pipelineOptions.low_level_rewriter_method

  (** val debug_rewriting : coq_PipelineOptions -> debug_rewriting_opt **)

  let debug_rewriting pipelineOptions =
    pipelineOptions.debug_rewriting

  type coq_PipelineToStringOptions = { static : static_opt;
                                       language_naming_conventions : 
                                       Coq7_Compilers.Options.language_naming_conventions_opt;
                                       internal_static : internal_static_opt;
                                       inline_internal : inline_internal_opt;
                                       inline : inline_opt;
                                       documentation_options : Coq7_Compilers.Options.documentation_options_opt }

  (** val static : coq_PipelineToStringOptions -> static_opt **)

  let static pipelineToStringOptions =
    pipelineToStringOptions.static

  (** val language_naming_conventions :
      coq_PipelineToStringOptions ->
      Coq7_Compilers.Options.language_naming_conventions_opt **)

  let language_naming_conventions pipelineToStringOptions =
    pipelineToStringOptions.language_naming_conventions

  (** val internal_static :
      coq_PipelineToStringOptions -> internal_static_opt **)

  let internal_static pipelineToStringOptions =
    pipelineToStringOptions.internal_static

  (** val inline_internal :
      coq_PipelineToStringOptions -> inline_internal_opt **)

  let inline_internal pipelineToStringOptions =
    pipelineToStringOptions.inline_internal

  (** val inline : coq_PipelineToStringOptions -> inline_opt **)

  let inline pipelineToStringOptions =
    pipelineToStringOptions.inline

  (** val documentation_options :
      coq_PipelineToStringOptions ->
      Coq7_Compilers.Options.documentation_options_opt **)

  let documentation_options pipelineToStringOptions =
    pipelineToStringOptions.documentation_options

  type coq_SynthesisOptions = { use_mul_for_cmovznz : use_mul_for_cmovznz_opt;
                                package_namev : Coq7_Compilers.Options.package_name_opt;
                                ignore_unique_asm_names : ignore_unique_asm_names_opt;
                                error_on_unused_assembly_functions : 
                                error_on_unused_assembly_functions_opt;
                                emit_primitives : emit_primitives_opt;
                                class_namev : Coq7_Compilers.Options.class_name_opt;
                                assembly_hints_lines : assembly_hints_lines_opt;
                                equivalence_checker_options : Coq_Options.equivalence_checker_options_opt }

  (** val use_mul_for_cmovznz :
      coq_SynthesisOptions -> use_mul_for_cmovznz_opt **)

  let use_mul_for_cmovznz synthesisOptions =
    synthesisOptions.use_mul_for_cmovznz

  (** val package_namev :
      coq_SynthesisOptions -> Coq7_Compilers.Options.package_name_opt **)

  let package_namev synthesisOptions =
    synthesisOptions.package_namev

  (** val ignore_unique_asm_names :
      coq_SynthesisOptions -> ignore_unique_asm_names_opt **)

  let ignore_unique_asm_names synthesisOptions =
    synthesisOptions.ignore_unique_asm_names

  (** val error_on_unused_assembly_functions :
      coq_SynthesisOptions -> error_on_unused_assembly_functions_opt **)

  let error_on_unused_assembly_functions synthesisOptions =
    synthesisOptions.error_on_unused_assembly_functions

  (** val emit_primitives : coq_SynthesisOptions -> emit_primitives_opt **)

  let emit_primitives synthesisOptions =
    synthesisOptions.emit_primitives

  (** val class_namev :
      coq_SynthesisOptions -> Coq7_Compilers.Options.class_name_opt **)

  let class_namev synthesisOptions =
    synthesisOptions.class_namev

  (** val assembly_hints_lines :
      coq_SynthesisOptions -> assembly_hints_lines_opt **)

  let assembly_hints_lines synthesisOptions =
    synthesisOptions.assembly_hints_lines

  (** val equivalence_checker_options :
      coq_SynthesisOptions -> Coq_Options.equivalence_checker_options_opt **)

  let equivalence_checker_options synthesisOptions =
    synthesisOptions.equivalence_checker_options
 end

(** val word_bound :
    machine_wordsize_opt -> Coq6_Compilers.ZRange.Coq_type.interp **)

let word_bound machine_wordsize0 =
  Obj.magic { lower = Z0; upper =
    (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) }

(** val saturated_bounds :
    nat -> machine_wordsize_opt ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let saturated_bounds n3 machine_wordsize0 =
  repeat (Obj.magic (Some (word_bound machine_wordsize0))) n3

(** val possible_values_of_machine_wordsize :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list **)

let possible_values_of_machine_wordsize pipeline_opts machine_wordsize0 =
  if widen_carry pipeline_opts.Coq0_Options.widen_carry
  then Z0 :: (machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO XH))
                                      machine_wordsize0) :: []))
  else Z0 :: ((Zpos
         XH) :: (machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO XH))
                                         machine_wordsize0) :: [])))

(** val possible_values_of_machine_wordsize_with_bytes :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list **)

let possible_values_of_machine_wordsize_with_bytes pipeline_opts machine_wordsize0 =
  if widen_carry pipeline_opts.Coq0_Options.widen_carry
  then Z0 :: (if widen_bytes pipeline_opts.Coq0_Options.widen_bytes
              then machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO XH))
                                           machine_wordsize0) :: [])
              else (Zpos (XO (XO (XO
                     XH)))) :: (machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO
                                                        XH))
                                                        machine_wordsize0) :: [])))
  else Z0 :: ((Zpos
         XH) :: (if widen_bytes pipeline_opts.Coq0_Options.widen_bytes
                 then machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO XH))
                                              machine_wordsize0) :: [])
                 else (Zpos (XO (XO (XO
                        XH)))) :: (machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO
                                                           XH))
                                                           machine_wordsize0) :: []))))

(** val no_select_size0 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    no_select_size_opt **)

let no_select_size0 pipeline_opts machine_wordsize0 =
  if no_select pipeline_opts.Coq0_Options.no_select
  then Some machine_wordsize0
  else None

(** val split_mul_to0 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_mul_to_opt **)

let split_mul_to0 pipeline_opts machine_wordsize0 =
  let possible_values =
    possible_values_of_machine_wordsize pipeline_opts machine_wordsize0
  in
  if should_split_mul pipeline_opts.Coq0_Options.should_split_mul
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x) possible_values)))
  else None

(** val split_multiret_to0 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_multiret_to_opt **)

let split_multiret_to0 pipeline_opts machine_wordsize0 =
  let possible_values =
    possible_values_of_machine_wordsize pipeline_opts machine_wordsize0
  in
  if should_split_multiret pipeline_opts.Coq0_Options.should_split_multiret
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x) possible_values)))
  else None

(** val absint_opts_with_no_shiftr_avoid_uint1 :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options **)

let absint_opts_with_no_shiftr_avoid_uint1 =
  false

(** val sselectznz :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> nat -> machine_wordsize_opt
    -> char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sselectznz output_language_api pipeline_opts pipeline_to_string_opts n3 machine_wordsize0 =
  let possible_values_with_bytes =
    possible_values_of_machine_wordsize_with_bytes pipeline_opts
      machine_wordsize0
  in
  (fun prefix1 ->
  ((append prefix1
     ('s'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::[])))))))))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      absint_opts_with_no_shiftr_avoid_uint1;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size0 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to0 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to0 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false possible_values_with_bytes (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))
      (fun _ -> reified_selectznz_gen)
      (Obj.magic ((Some { lower = Z0; upper = (Zpos XH) }), ((Some
        (saturated_bounds n3 machine_wordsize0)), ((Some
        (saturated_bounds n3 machine_wordsize0)), ()))))
      (Obj.magic (Some (saturated_bounds n3 machine_wordsize0)))) (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if false then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if false then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some { lower = Z0; upper = (Zpos XH) }), ((Some
        (saturated_bounds n3 machine_wordsize0)), ((Some
        (saturated_bounds n3 machine_wordsize0)), ())))
      in
      let out_bounds1 = Some (saturated_bounds n3 machine_wordsize0) in
      let arg_typedefs0 = (None, (None, (None, ()))) in
      let out_typedefs0 = None in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          absint_opts_with_no_shiftr_avoid_uint1 (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              possible_values_with_bytes r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              ('s'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::[])))))))))))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))) e'0 (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     ('s'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::[])))))))))))
                 (' '::('i'::('s'::(' '::('a'::(' '::('m'::('u'::('l'::('t'::('i'::('-'::('l'::('i'::('m'::('b'::(' '::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('a'::('l'::(' '::('s'::('e'::('l'::('e'::('c'::('t'::('.'::[])))))))))))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (Obj.magic
                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                  (Compilers.Coq_type.final_codomain
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))))))) out_var_data)
                (append (' '::('='::(' '::[])))
                  (append ('('::[])
                    (append
                      (append ('i'::('f'::(' '::[])))
                        (append
                          (append
                            (fst
                              (Obj.magic
                                Compilers.Coq_type.map_for_each_lhs_of_arrow
                                Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))))))))) arg_var_data))
                            (append (' '::('='::(' '::[])))
                              (Decimal.show_lvl_Z Z0
                                (Level.next (Level.Coq_level (Zpos (XO (XI
                                  (XI (XO (XO (XO XH))))))))))))
                          (append
                            (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                            (append
                              (fst
                                (snd
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))))) arg_var_data)))
                              (append
                                (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                (fst
                                  (snd
                                    (snd
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))))))))
                                        arg_var_data))))))))) (')'::[])))))) :: ([] :: [])))))
          None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z))))))))), e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val smulx :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
    char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let smulx output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 =
  let possible_values_with_bytes =
    possible_values_of_machine_wordsize_with_bytes pipeline_opts
      machine_wordsize0
  in
  (fun prefix1 s0 ->
  ((append prefix1
     (append ('m'::('u'::('l'::('x'::('_'::('u'::[]))))))
       (Coq0_Z.to_string s0))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      absint_opts_with_no_shiftr_avoid_uint1;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size0 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to0 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to0 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false possible_values_with_bytes (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
      (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
        (fun _ -> reified_mulx_gen) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (fun _ -> Obj.magic s0)))
      (Obj.magic ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ())))
      (Obj.magic ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), (Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) })))) (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if true then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if true then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ()))
      in
      let out_bounds1 = ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), (Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }))
      in
      let arg_typedefs0 = (None, (None, ())) in
      let out_typedefs0 = (None, None) in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          absint_opts_with_no_shiftr_avoid_uint1 (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              possible_values_with_bytes r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              (append ('m'::('u'::('l'::('x'::('_'::('u'::[]))))))
                (Coq0_Z.to_string s0)))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          e'0 (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     (append ('m'::('u'::('l'::('x'::('_'::('u'::[]))))))
                       (Coq0_Z.to_string s0))))
                 (' '::('i'::('s'::(' '::('a'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(','::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('f'::('u'::('l'::('l'::(' '::('d'::('o'::('u'::('b'::('l'::('e'::('-'::('w'::('i'::('d'::('t'::('h'::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (fst
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))) out_var_data))
                (append (' '::('='::(' '::[])))
                  (append
                    (append ('('::[])
                      (append
                        (append
                          (fst
                            (Obj.magic
                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z),
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)))))))) arg_var_data))
                          (append (' '::[])
                            (append ('*'::[])
                              (append (' '::[])
                                (fst
                                  (snd
                                    (Obj.magic
                                      Compilers.Coq_type.map_for_each_lhs_of_arrow
                                      Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)),
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z),
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))))))) arg_var_data)))))))
                        (')'::[])))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (append
                            (Decimal.show_lvl_Z (Zpos (XO XH))
                              (Level.Coq_level (Zpos (XI (XO (XI (XI XH)))))))
                            (append []
                              (append ('^'::[])
                                (append []
                                  (Decimal.show_lvl_Z s0 (Level.Coq_level
                                    (Zpos (XO (XI (XI (XI XH)))))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (snd
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))) out_var_data))
                (append (' '::('='::(' '::[])))
                  (append ('\226'::('\140'::('\138'::[])))
                    (append
                      (append
                        (append
                          (fst
                            (Obj.magic
                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z),
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)))))))) arg_var_data))
                          (append (' '::[])
                            (append ('*'::[])
                              (append (' '::[])
                                (fst
                                  (snd
                                    (Obj.magic
                                      Compilers.Coq_type.map_for_each_lhs_of_arrow
                                      Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)),
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z),
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))))))) arg_var_data)))))))
                        (append (' '::[])
                          (append ('/'::[])
                            (append (' '::[])
                              (append
                                (Decimal.show_lvl_Z (Zpos (XO XH))
                                  (Level.Coq_level (Zpos (XI (XO (XI (XI
                                  XH)))))))
                                (append []
                                  (append ('^'::[])
                                    (append []
                                      (Decimal.show_lvl_Z s0 (Level.Coq_level
                                        (Zpos (XO (XI (XI (XI XH)))))))))))))))
                      ('\226'::('\140'::('\139'::[])))))))) :: ([] :: []))))))
          None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))), e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val saddcarryx :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
    char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let saddcarryx output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 =
  let possible_values_with_bytes =
    possible_values_of_machine_wordsize_with_bytes pipeline_opts
      machine_wordsize0
  in
  (fun prefix1 s0 ->
  ((append prefix1
     (append
       ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::('_'::('u'::[])))))))))))
       (Coq0_Z.to_string s0))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      absint_opts_with_no_shiftr_avoid_uint1;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size0 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to0 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to0 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false possible_values_with_bytes (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))
      (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))
        (fun _ -> reified_addcarryx_gen) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (fun _ -> Obj.magic s0)))
      (Obj.magic ((Some { lower = Z0; upper = (Zpos XH) }), ((Some { lower =
        Z0; upper = (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }),
        ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ()))))
      (Obj.magic ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), (Some
        (if existsb (Coq_Z.eqb s0)
              (Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth
                pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_)
         then { lower = Z0; upper =
                (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }
         else { lower = Z0; upper = (Zpos XH) }))))) (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if true then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if true then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some { lower = Z0; upper = (Zpos XH) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ())))
      in
      let out_bounds1 = ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), (Some
        (if existsb (Coq_Z.eqb s0)
              (Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth
                pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_)
         then { lower = Z0; upper =
                (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }
         else { lower = Z0; upper = (Zpos XH) })))
      in
      let arg_typedefs0 = (None, (None, (None, ()))) in
      let out_typedefs0 = (None, None) in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          absint_opts_with_no_shiftr_avoid_uint1 (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              possible_values_with_bytes r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              (append
                ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::('_'::('u'::[])))))))))))
                (Coq0_Z.to_string s0)))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) e'0 (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     (append
                       ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::('_'::('u'::[])))))))))))
                       (Coq0_Z.to_string s0))))
                 (' '::('i'::('s'::(' '::('a'::('n'::(' '::('a'::('d'::('d'::('i'::('t'::('i'::('o'::('n'::(' '::('w'::('i'::('t'::('h'::(' '::('c'::('a'::('r'::('r'::('y'::('.'::[]))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (fst
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))))) out_var_data))
                (append (' '::('='::(' '::[])))
                  (append
                    (append ('('::[])
                      (append
                        (append
                          (append
                            (fst
                              (Obj.magic
                                Compilers.Coq_type.map_for_each_lhs_of_arrow
                                Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod
                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z),
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))))))))) arg_var_data))
                            (append (' '::[])
                              (append ('+'::[])
                                (append (' '::[])
                                  (fst
                                    (snd
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z),
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))))))
                                        arg_var_data)))))))
                          (append (' '::[])
                            (append ('+'::[])
                              (append (' '::[])
                                (fst
                                  (snd
                                    (snd
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z),
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))))))
                                        arg_var_data)))))))) (')'::[])))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (append
                            (Decimal.show_lvl_Z (Zpos (XO XH))
                              (Level.Coq_level (Zpos (XI (XO (XI (XI XH)))))))
                            (append []
                              (append ('^'::[])
                                (append []
                                  (Decimal.show_lvl_Z s0 (Level.Coq_level
                                    (Zpos (XO (XI (XI (XI XH)))))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (snd
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))))) out_var_data))
                (append (' '::('='::(' '::[])))
                  (append ('\226'::('\140'::('\138'::[])))
                    (append
                      (append
                        (append ('('::[])
                          (append
                            (append
                              (append
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z),
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))))))) arg_var_data))
                                (append (' '::[])
                                  (append ('+'::[])
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z),
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))))))))
                                            arg_var_data)))))))
                              (append (' '::[])
                                (append ('+'::[])
                                  (append (' '::[])
                                    (fst
                                      (snd
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z),
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))))))))
                                            arg_var_data)))))))) (')'::[])))
                        (append (' '::[])
                          (append ('/'::[])
                            (append (' '::[])
                              (append
                                (Decimal.show_lvl_Z (Zpos (XO XH))
                                  (Level.Coq_level (Zpos (XI (XO (XI (XI
                                  XH)))))))
                                (append []
                                  (append ('^'::[])
                                    (append []
                                      (Decimal.show_lvl_Z s0 (Level.Coq_level
                                        (Zpos (XO (XI (XI (XI XH)))))))))))))))
                      ('\226'::('\140'::('\139'::[])))))))) :: ([] :: []))))))
          None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))))), e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val ssubborrowx :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
    char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let ssubborrowx output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 =
  let possible_values_with_bytes =
    possible_values_of_machine_wordsize_with_bytes pipeline_opts
      machine_wordsize0
  in
  (fun prefix1 s0 ->
  ((append prefix1
     (append
       ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::('_'::('u'::[]))))))))))))
       (Coq0_Z.to_string s0))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      absint_opts_with_no_shiftr_avoid_uint1;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size0 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to0 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to0 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false possible_values_with_bytes (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))
      (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))
        (fun _ -> reified_subborrowx_gen) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (fun _ -> Obj.magic s0)))
      (Obj.magic ((Some { lower = Z0; upper = (Zpos XH) }), ((Some { lower =
        Z0; upper = (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }),
        ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ()))))
      (Obj.magic ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), (Some
        (if existsb (Coq_Z.eqb s0)
              (Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth
                pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_)
         then { lower = Z0; upper =
                (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }
         else { lower = Z0; upper = (Zpos XH) }))))) (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if true then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if true then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some { lower = Z0; upper = (Zpos XH) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ())))
      in
      let out_bounds1 = ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), (Some
        (if existsb (Coq_Z.eqb s0)
              (Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth
                pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_)
         then { lower = Z0; upper =
                (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }
         else { lower = Z0; upper = (Zpos XH) })))
      in
      let arg_typedefs0 = (None, (None, (None, ()))) in
      let out_typedefs0 = (None, None) in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          absint_opts_with_no_shiftr_avoid_uint1 (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              possible_values_with_bytes r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              (append
                ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::('_'::('u'::[]))))))))))))
                (Coq0_Z.to_string s0)))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z)))))))))) e'0 (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     (append
                       ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::('_'::('u'::[]))))))))))))
                       (Coq0_Z.to_string s0))))
                 (' '::('i'::('s'::(' '::('a'::(' '::('s'::('u'::('b'::('t'::('r'::('a'::('c'::('t'::('i'::('o'::('n'::(' '::('w'::('i'::('t'::('h'::(' '::('b'::('o'::('r'::('r'::('o'::('w'::('.'::[])))))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (fst
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))))) out_var_data))
                (append (' '::('='::(' '::[])))
                  (append
                    (append ('('::[])
                      (append
                        (append
                          (append
                            (append ('-'::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_prod
                                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z),
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))))))))) arg_var_data)))
                            (append (' '::[])
                              (append ('+'::[])
                                (append (' '::[])
                                  (fst
                                    (snd
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z),
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))))))
                                        arg_var_data)))))))
                          (append (' '::[])
                            (append ('+'::[])
                              (append (' '::[])
                                (append ('-'::[])
                                  (fst
                                    (snd
                                      (snd
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))))))))
                                          arg_var_data))))))))) (')'::[])))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (append
                            (Decimal.show_lvl_Z (Zpos (XO XH))
                              (Level.Coq_level (Zpos (XI (XO (XI (XI XH)))))))
                            (append []
                              (append ('^'::[])
                                (append []
                                  (Decimal.show_lvl_Z s0 (Level.Coq_level
                                    (Zpos (XO (XI (XI (XI XH)))))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (snd
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))))) out_var_data))
                (append (' '::('='::(' '::[])))
                  (append ('-'::[])
                    (append ('\226'::('\140'::('\138'::[])))
                      (append
                        (append
                          (append ('('::[])
                            (append
                              (append
                                (append
                                  (append ('-'::[])
                                    (fst
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z),
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))))))
                                        arg_var_data)))
                                  (append (' '::[])
                                    (append ('+'::[])
                                      (append (' '::[])
                                        (fst
                                          (snd
                                            (Obj.magic
                                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))))))))))
                                              arg_var_data)))))))
                                (append (' '::[])
                                  (append ('+'::[])
                                    (append (' '::[])
                                      (append ('-'::[])
                                        (fst
                                          (snd
                                            (snd
                                              (Obj.magic
                                                Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z),
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))))))))))
                                                arg_var_data)))))))))
                              (')'::[])))
                          (append (' '::[])
                            (append ('/'::[])
                              (append (' '::[])
                                (append
                                  (Decimal.show_lvl_Z (Zpos (XO XH))
                                    (Level.Coq_level (Zpos (XI (XO (XI (XI
                                    XH)))))))
                                  (append []
                                    (append ('^'::[])
                                      (append []
                                        (Decimal.show_lvl_Z s0
                                          (Level.Coq_level (Zpos (XO (XI (XI
                                          (XI XH)))))))))))))))
                        ('\226'::('\140'::('\139'::[]))))))))) :: ([] :: []))))))
          None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))))), e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val svalue_barrier :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
    char list -> Coq7_Compilers.ToString.Coq_int.coq_type ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let svalue_barrier output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 =
  let possible_values_with_bytes =
    possible_values_of_machine_wordsize_with_bytes pipeline_opts
      machine_wordsize0
  in
  (fun prefix1 s0 ->
  ((append prefix1
     (append
       ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::('_'::[]))))))))))))))
       (append
         (if Coq7_Compilers.ToString.Coq_int.is_unsigned s0
          then 'u'::[]
          else [])
         (Coq0_Z.to_string (Coq7_Compilers.ToString.Coq_int.bitwidth_of s0))))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      absint_opts_with_no_shiftr_avoid_uint1;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size0 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to0 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to0 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false possible_values_with_bytes (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (fun _ -> reified_value_barrier_gen)
      (Obj.magic ((Some (Coq7_Compilers.ToString.Coq_int.to_zrange s0)), ()))
      (Obj.magic (Some (Coq7_Compilers.ToString.Coq_int.to_zrange s0))))
    (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if true then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if true then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some
        (Coq7_Compilers.ToString.Coq_int.to_zrange s0)), ())
      in
      let out_bounds1 = Some (Coq7_Compilers.ToString.Coq_int.to_zrange s0) in
      let arg_typedefs0 = (None, ()) in
      let out_typedefs0 = None in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          absint_opts_with_no_shiftr_avoid_uint1 (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              possible_values_with_bytes r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              (append
                ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::('_'::[]))))))))))))))
                (append
                  (if Coq7_Compilers.ToString.Coq_int.is_unsigned s0
                   then 'u'::[]
                   else [])
                  (Coq0_Z.to_string
                    (Coq7_Compilers.ToString.Coq_int.bitwidth_of s0))))))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))) e'0
          (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     (append
                       ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::('_'::[]))))))))))))))
                       (append
                         (if Coq7_Compilers.ToString.Coq_int.is_unsigned s0
                          then 'u'::[]
                          else [])
                         (Coq0_Z.to_string
                           (Coq7_Compilers.ToString.Coq_int.bitwidth_of s0))))))
                 (' '::('i'::('s'::(' '::('a'::(' '::('s'::('i'::('n'::('g'::('l'::('e'::('-'::('w'::('o'::('r'::('d'::(' '::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('a'::('l'::(' '::('m'::('o'::('v'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (Obj.magic
                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                  (Compilers.Coq_type.final_codomain
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))) out_var_data)
                (append (' '::('='::(' '::[])))
                  (fst
                    (Obj.magic Compilers.Coq_type.map_for_each_lhs_of_arrow
                      Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))) arg_var_data))))) :: ([] :: [])))))
          None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
           e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val scmovznz :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
    char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scmovznz output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 =
  let possible_values_with_bytes =
    possible_values_of_machine_wordsize_with_bytes pipeline_opts
      machine_wordsize0
  in
  (fun prefix1 s0 ->
  ((append prefix1
     (append
       ('c'::('m'::('o'::('v'::('z'::('n'::('z'::('_'::('u'::[])))))))))
       (Coq0_Z.to_string s0))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      absint_opts_with_no_shiftr_avoid_uint1;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size0 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to0 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to0 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false possible_values_with_bytes (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))) (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
        (fun _ -> reified_cmovznz_gen) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (fun _ -> Obj.magic s0)))
      (Obj.magic ((Some { lower = Z0; upper = (Zpos XH) }), ((Some { lower =
        Z0; upper = (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }),
        ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ()))))
      (Obj.magic (Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }))) (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if true then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if true then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some { lower = Z0; upper = (Zpos XH) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ())))
      in
      let out_bounds1 = Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }
      in
      let arg_typedefs0 = (None, (None, (None, ()))) in
      let out_typedefs0 = None in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          absint_opts_with_no_shiftr_avoid_uint1 (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              possible_values_with_bytes r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              (append
                ('c'::('m'::('o'::('v'::('z'::('n'::('z'::('_'::('u'::[])))))))))
                (Coq0_Z.to_string s0)))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          e'0 (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     (append
                       ('c'::('m'::('o'::('v'::('z'::('n'::('z'::('_'::('u'::[])))))))))
                       (Coq0_Z.to_string s0))))
                 (' '::('i'::('s'::(' '::('a'::(' '::('s'::('i'::('n'::('g'::('l'::('e'::('-'::('w'::('o'::('r'::('d'::(' '::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('a'::('l'::(' '::('m'::('o'::('v'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (Obj.magic
                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                  (Compilers.Coq_type.final_codomain
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))) out_var_data)
                (append (' '::('='::(' '::[])))
                  (append ('('::[])
                    (append
                      (append ('i'::('f'::(' '::[])))
                        (append
                          (append
                            (fst
                              (Obj.magic
                                Compilers.Coq_type.map_for_each_lhs_of_arrow
                                Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))))))) arg_var_data))
                            (append (' '::('='::(' '::[])))
                              (Decimal.show_lvl_Z Z0
                                (Level.next (Level.Coq_level (Zpos (XO (XI
                                  (XI (XO (XO (XO XH))))))))))))
                          (append
                            (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                            (append
                              (fst
                                (snd
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))))) arg_var_data)))
                              (append
                                (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                (fst
                                  (snd
                                    (snd
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))))))) arg_var_data)))))))))
                      (')'::[])))))) :: ([] :: []))))) None
          (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))), e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val scmovznz_by_mul :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt ->
    char list -> z -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scmovznz_by_mul output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 =
  let possible_values_with_bytes =
    possible_values_of_machine_wordsize_with_bytes pipeline_opts
      machine_wordsize0
  in
  (fun prefix1 s0 ->
  ((append prefix1
     (append
       ('c'::('m'::('o'::('v'::('z'::('n'::('z'::('_'::('u'::[])))))))))
       (Coq0_Z.to_string s0))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      absint_opts_with_no_shiftr_avoid_uint1;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size0 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to0 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to0 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false possible_values_with_bytes (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))) (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
        (fun _ -> reified_cmovznz_by_mul_gen) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (fun _ -> Obj.magic s0)))
      (Obj.magic ((Some { lower = Z0; upper = (Zpos XH) }), ((Some { lower =
        Z0; upper = (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }),
        ((Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ()))))
      (Obj.magic (Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }))) (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if true then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if true then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some { lower = Z0; upper = (Zpos XH) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ((Some
        { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }), ())))
      in
      let out_bounds1 = Some { lower = Z0; upper =
        (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }
      in
      let arg_typedefs0 = (None, (None, (None, ()))) in
      let out_typedefs0 = None in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          absint_opts_with_no_shiftr_avoid_uint1 (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              possible_values_with_bytes r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              (append
                ('c'::('m'::('o'::('v'::('z'::('n'::('z'::('_'::('u'::[])))))))))
                (Coq0_Z.to_string s0)))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          e'0 (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     (append
                       ('c'::('m'::('o'::('v'::('z'::('n'::('z'::('_'::('u'::[])))))))))
                       (Coq0_Z.to_string s0))))
                 (' '::('i'::('s'::(' '::('a'::(' '::('s'::('i'::('n'::('g'::('l'::('e'::('-'::('w'::('o'::('r'::('d'::(' '::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('a'::('l'::(' '::('m'::('o'::('v'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (Obj.magic
                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                  (Compilers.Coq_type.final_codomain
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))) out_var_data)
                (append (' '::('='::(' '::[])))
                  (append ('('::[])
                    (append
                      (append ('i'::('f'::(' '::[])))
                        (append
                          (append
                            (fst
                              (Obj.magic
                                Compilers.Coq_type.map_for_each_lhs_of_arrow
                                Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))))))) arg_var_data))
                            (append (' '::('='::(' '::[])))
                              (Decimal.show_lvl_Z Z0
                                (Level.next (Level.Coq_level (Zpos (XO (XI
                                  (XI (XO (XO (XO XH))))))))))))
                          (append
                            (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                            (append
                              (fst
                                (snd
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))))) arg_var_data)))
                              (append
                                (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                (fst
                                  (snd
                                    (snd
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))))))) arg_var_data)))))))))
                      (')'::[])))))) :: ([] :: []))))) None
          (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))), e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val aggregate_infos :
    (char list * (char list, (Pipeline.coq_ErrorMessage, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    Pipeline.coq_ExtendedSynthesisResult) sigT) errorT) debugM) list ->
    Coq7_Compilers.ToString.ident_infos **)

let aggregate_infos ls =
  fold_right Coq7_Compilers.ToString.ident_info_union
    Coq7_Compilers.ToString.ident_info_empty
    (map (fun pat ->
      let (_, res) = pat in
      (match Debug.eval_result res with
       | Success v0 -> let ExistT (_, v) = v0 in v.Pipeline.ident_infos
       | Error _ -> Coq7_Compilers.ToString.ident_info_empty)) ls)

(** val push_sig_type :
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type, char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM) sigT -> char list * (char list, (Pipeline.coq_ErrorMessage,
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type, Pipeline.coq_ExtendedSynthesisResult) sigT)
    errorT) debugM **)

let push_sig_type = function
| ExistT (t0, p) ->
  let (n3, v0) = p in
  (n3,
  (Debug.bind v0 (fun v1 ->
    Debug.ret (bind0 v1 (fun v2 -> Success (ExistT (t0, v2)))))))

(** val extra_synthesis :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt -> char list ->
    Coq7_Compilers.ToString.ident_infos -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT
    list * Coq7_Compilers.ToString.ident_infos **)

let extra_synthesis output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts machine_wordsize0 function_name_prefix infos =
  let infos0 =
    output_language_api.Coq7_Compilers.ToString.strip_special_infos
      machine_wordsize0 infos
  in
  let mk = fun x x0 -> ExistT (x, x0) in
  let ls_addcarryx =
    flat_map (fun lg_split ->
      (mk (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))
        (saddcarryx output_language_api pipeline_opts pipeline_to_string_opts
          machine_wordsize0 function_name_prefix (Zpos lg_split))) :: (
      (mk (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))
        (ssubborrowx output_language_api pipeline_opts
          pipeline_to_string_opts machine_wordsize0 function_name_prefix
          (Zpos lg_split))) :: []))
      (PositiveSet.elements
        infos0.Coq7_Compilers.ToString.addcarryx_lg_splits)
  in
  let ls_mulx =
    map (fun lg_split ->
      mk (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
        (smulx output_language_api pipeline_opts pipeline_to_string_opts
          machine_wordsize0 function_name_prefix (Zpos lg_split)))
      (PositiveSet.elements infos0.Coq7_Compilers.ToString.mulx_lg_splits)
  in
  let ls_value_barrier =
    map (fun bw ->
      mk (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
        (svalue_barrier output_language_api pipeline_opts
          pipeline_to_string_opts machine_wordsize0 function_name_prefix bw))
      (Coq7_Compilers.ToString.IntSet.elements
        infos0.Coq7_Compilers.ToString.value_barrier_bitwidths)
  in
  let ls_cmov =
    map (fun ty ->
      mk (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
        ((if synthesis_opts.Coq0_Options.use_mul_for_cmovznz
          then scmovznz_by_mul output_language_api pipeline_opts
                 pipeline_to_string_opts machine_wordsize0
          else scmovznz output_language_api pipeline_opts
                 pipeline_to_string_opts machine_wordsize0)
          function_name_prefix
          (Coq7_Compilers.ToString.Coq_int.bitwidth_of ty)))
      (Coq7_Compilers.ToString.IntSet.elements
        infos0.Coq7_Compilers.ToString.cmovznz_bitwidths)
  in
  let ls = app ls_addcarryx (app ls_mulx (app ls_value_barrier ls_cmov)) in
  let infos1 = aggregate_infos (map push_sig_type ls) in (ls, infos1)

(** val union_extra_infos_of_extra_synthesis :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt ->
    Coq7_Compilers.ToString.ident_infos -> Coq7_Compilers.ToString.ident_infos **)

let union_extra_infos_of_extra_synthesis output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts machine_wordsize0 infos =
  let (fs, _) =
    extra_synthesis output_language_api pipeline_opts pipeline_to_string_opts
      synthesis_opts machine_wordsize0 [] infos
  in
  let fuel0 = add (S O) (length fs) in
  snd
    (fueled_lub Coq7_Compilers.ToString.ident_infos_equal
      Coq7_Compilers.ToString.ident_info_union fuel0 (fun infos0 ->
      snd
        (extra_synthesis output_language_api pipeline_opts
          pipeline_to_string_opts synthesis_opts machine_wordsize0 [] infos0))
      infos)

(** val synthesize_of_name :
    char list -> (char list * (char list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list ->
    (char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type, char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM) sigT option list) -> char list -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage, (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    Pipeline.coq_ExtendedSynthesisResult) sigT) errorT) debugM **)

let synthesize_of_name valid_names5 known_functions5 extra_special_synthesis0 function_name_prefix name0 =
  fold_right (fun v default0 ->
    match v with
    | Some y ->
      let ExistT (t0, y0) = y in
      let (n3, res) = y0 in
      (n3,
      (Debug.bind res (fun res0 ->
        Debug.ret (bind0 res0 (fun res1 -> Success (ExistT (t0, res1)))))))
    | None -> default0) (name0,
    (Debug.ret (Error (Pipeline.Invalid_argument
      (append
        ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('r'::('e'::('q'::('u'::('e'::('s'::('t'::(' '::('t'::('o'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::(' '::('"'::[]))))))))))))))))))))))))))))))))))))
        (append name0
          (append
            ('"'::(';'::(' '::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('a'::('m'::('e'::('s'::(' '::('a'::('r'::('e'::(' '::[])))))))))))))))))))
            (append valid_names5 ('.'::[])))))))))
    (app
      (map (fun pat ->
        let (expected_name, resf) = pat in
        if eqb0 name0 expected_name
        then Some (resf function_name_prefix)
        else None) known_functions5) (extra_special_synthesis0 name0))

(** val parse_asm_files_lines :
    (char list * char list list) list -> (Pipeline.coq_ErrorMessage,
    (char list * (lines * (char list * lines) list)) list) errorT **)

let rec parse_asm_files_lines = function
| [] -> Success []
| p :: ls0 ->
  let (fname, lines0) = p in
  (match parse_validated lines0 with
   | Success v ->
     bind0 (parse_asm_files_lines ls0) (fun vs -> Success ((fname,
       (split_code_to_functions v)) :: vs))
   | Error err0 -> Error (Pipeline.Assembly_parsing_error (fname, err0)))

(** val parse_asm_hints :
    Coq0_Options.coq_SynthesisOptions -> (Pipeline.coq_ErrorMessage,
    (char list * (lines * (char list * lines) list)) list) errorT **)

let parse_asm_hints synthesis_opts =
  parse_asm_files_lines synthesis_opts.Coq0_Options.assembly_hints_lines

(** val split_to_assembly_functions :
    Coq0_Options.coq_SynthesisOptions -> (char list * (char list * 'a1) list)
    list -> (char list * 'a2) list -> (((char list * ((char list * 'a1)
    list * 'a2)) list * (char list * 'a2)
    list) * (char list * (char list * 'a1) list) list) * char list list **)

let split_to_assembly_functions synthesis_opts assembly_data normal_data =
  let assembly_files_without_globals =
    filter (fun pat -> let (_, ls) = pat in Nat.eqb (length ls) O)
      assembly_data
  in
  let assembly_files_without_globals0 =
    map (fun pat -> let (fname, _) = pat in fname)
      assembly_files_without_globals
  in
  let assembly_data0 =
    filter (fun pat -> let (_, ls) = pat in negb (Nat.eqb (length ls) O))
      assembly_data
  in
  if (&&)
       ((&&) synthesis_opts.Coq0_Options.ignore_unique_asm_names
         (forallb (fun pat ->
           let (_, data) = pat in Nat.eqb (length data) (S O)) assembly_data0))
       (Nat.eqb (length normal_data) (S O))
  then (match normal_data with
        | [] ->
          ((([], normal_data), assembly_data0),
            assembly_files_without_globals0)
        | p :: l ->
          let (n3, b) = p in
          (match l with
           | [] ->
             (((((n3,
               ((flat_map (fun pat ->
                  let (fname, asm_ls) = pat in
                  map (fun pat0 -> let (_, a) = pat0 in (fname, a)) asm_ls)
                  assembly_data0), b)) :: []), []), []),
               assembly_files_without_globals0)
           | _ :: _ ->
             ((([], normal_data), assembly_data0),
               assembly_files_without_globals0)))
  else let assembly_data1 =
         flat_map (fun pat ->
           let (fname, asm_ls) = pat in
           map (fun pat0 ->
             let (func_name, a) = pat0 in (func_name, (fname, a))) asm_ls)
           assembly_data0
       in
       let assembly_data2 =
         Coq_List.groupAllBy (fun pat ->
           let (n3, _) = pat in (fun pat0 -> let (n4, _) = pat0 in eqb0 n3 n4))
           assembly_data1
       in
       let assembly_data3 =
         Option.List.map (fun ls ->
           match ls with
           | [] -> None
           | y :: _ -> let (n3, _) = y in Some (n3, (map snd ls)))
           assembly_data2
       in
       let ls =
         map (fun pat ->
           let (n3, normal_data0) = pat in
           ((n3, normal_data0),
           (find (fun pat0 -> let (n4, _) = pat0 in eqb0 n3 n4)
             assembly_data3))) normal_data
       in
       let (lsAB, lsB) =
         partition (fun pat ->
           let (_, o) = pat in (match o with
                                | Some _ -> true
                                | None -> false)) ls
       in
       let lsA =
         filter (fun pat ->
           let (n3, _) = pat in
           negb
             (existsb (fun pat0 -> let (n4, _) = pat0 in eqb0 n3 n4)
               normal_data)) assembly_data3
       in
       let lsA0 =
         flat_map (fun pat ->
           let (function_name, ls0) = pat in
           map (fun pat0 ->
             let (file_name, v) = pat0 in (file_name, (function_name, v))) ls0)
           lsA
       in
       let lsA1 =
         Coq_List.groupAllBy (fun pat ->
           let (n3, _) = pat in (fun pat0 -> let (n4, _) = pat0 in eqb0 n3 n4))
           lsA0
       in
       let lsA2 =
         Option.List.map (fun ls0 ->
           match ls0 with
           | [] -> None
           | y :: _ -> let (n3, _) = y in Some (n3, (map snd ls0))) lsA1
       in
       ((((Option.List.map (fun pat ->
            let (y, assembly_data4) = pat in
            let (n3, normal_data0) = y in
            (match assembly_data4 with
             | Some y0 ->
               let (_, assembly_data5) = y0 in
               Some (n3, (assembly_data5, normal_data0))
             | None -> None)) lsAB), (map fst lsB)), lsA2),
       assembly_files_without_globals0)

(** val synthesize :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt -> char list ->
    (char list * (char list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list ->
    (char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type, char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM) sigT option list) -> (((char list * (char list ->
    char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
    option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list ->
    (char list list -> (Pipeline.coq_ErrorMessage, char list list) errorT ->
    (Pipeline.coq_ErrorMessage, char list list) errorT) -> char list list ->
    char list -> char list list ->
    ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

let synthesize output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts machine_wordsize0 valid_names5 known_functions5 extra_special_synthesis0 all_typedefs check_args5 comment_header function_name_prefix requests =
  let requests0 =
    match requests with
    | [] -> map fst known_functions5
    | _ :: _ -> requests
  in
  let ls =
    map
      (synthesize_of_name valid_names5 known_functions5
        extra_special_synthesis0 function_name_prefix) requests0
  in
  let (asm_ls, ls0) =
    match parse_asm_hints synthesis_opts with
    | Success asm_hints ->
      (match asm_hints with
       | [] -> ([], ls)
       | _ :: _ ->
         let asm_ls_prefix =
           map (fun pat ->
             let (fname, y) = pat in
             let (prefix1, _) = y in
             ((Assembly_output,
             (append
               ('h'::('e'::('a'::('d'::('e'::('r'::('-'::('p'::('r'::('e'::('f'::('i'::('x'::(' '::('f'::('o'::('r'::(' '::[]))))))))))))))))))
               fname)),
             (Debug.ret (Success (show_lines show_lines_Lines prefix1)))))
             asm_hints
         in
         let function_asms =
           map (fun pat ->
             let (fname, y) = pat in
             let (_, function_asms) = y in (fname, function_asms)) asm_hints
         in
         let valid_function_names = map fst ls in
         let (p, asm_missing_globals) =
           split_to_assembly_functions synthesis_opts function_asms ls
         in
         let (p0, unused_asm_ls) = p in
         let (asm_ls, ls0) = p0 in
         let asm_ls_check =
           if negb (Nat.eqb (length asm_missing_globals) O)
           then ((Assembly_output, ('c'::('h'::('e'::('c'::('k'::[])))))),
                  (Debug.ret (Error
                    (Pipeline.Assembly_without_any_global_labels
                    asm_missing_globals)))) :: []
           else []
         in
         let asm_ls_check0 =
           app asm_ls_check
             (if (&&)
                   synthesis_opts.Coq0_Options.error_on_unused_assembly_functions
                   (Nat.ltb O (length unused_asm_ls))
              then ((Assembly_output, ('c'::('h'::('e'::('c'::('k'::[])))))),
                     (Debug.ret (Error
                       (Pipeline.Unused_global_assembly_labels
                       ((map (fun pat ->
                          let (file_name, labels) = pat in
                          (file_name, (map fst labels))) unused_asm_ls),
                       valid_function_names))))) :: []
              else [])
         in
         let asm_ls0 =
           map (fun pat ->
             let (name0, y) = pat in
             let (asm_fname_and_lines, synthesis_res) = y in
             (name0,
             (Pipeline.M.bind synthesis_res (fun synthesis_res0 ->
               let ExistT (x, synthesis_res1) = synthesis_res0 in
               (match generate_assembly_of_hinted_expr
                        (Options.default_rewriting_passes
                          synthesis_opts.Coq0_Options.equivalence_checker_options.Coq_Options.symbolic_options_.Options.asm_rewriting_pipeline
                          synthesis_opts.Coq0_Options.equivalence_checker_options.Coq_Options.symbolic_options_.Options.asm_rewriting_pass_filter)
                        synthesis_opts.Coq0_Options.equivalence_checker_options.Coq_Options.assembly_conventions_.assembly_calling_registers_
                        synthesis_opts.Coq0_Options.equivalence_checker_options.Coq_Options.assembly_conventions_.assembly_stack_size_
                        synthesis_opts.Coq0_Options.equivalence_checker_options.Coq_Options.assembly_conventions_.assembly_callee_saved_registers_
                        x asm_fname_and_lines (fun _ ->
                        Pipeline.expr x synthesis_res1)
                        synthesis_res1.Pipeline.arg_bounds
                        synthesis_res1.Pipeline.out_bounds with
                | Success lines0 ->
                  Debug.ret (Success
                    (flat_map (fun pat0 ->
                      let (_, lines1) = pat0 in
                      show_lines show_lines_Lines lines1) lines0))
                | Error msg ->
                  let (o, err0) = msg in
                  (match o with
                   | Some p1 ->
                     let (fname, asm_lines) = p1 in
                     Debug.ret (Error (Pipeline.Equivalence_checking_failure
                       (x, (fun _ -> Pipeline.expr x synthesis_res1), fname,
                       asm_lines, synthesis_res1.Pipeline.arg_bounds, err0)))
                   | None ->
                     Debug.ret (Error
                       (Pipeline.Equivalence_checking_failure_pre_asm (x,
                       (fun _ -> Pipeline.expr x synthesis_res1),
                       synthesis_res1.Pipeline.arg_bounds, err0)))))))))
             asm_ls
         in
         let asm_ls1 =
           map (fun pat ->
             let (name0, lines0) = pat in ((Assembly_output, name0), lines0))
             asm_ls0
         in
         ((match asm_ls1 with
           | [] -> asm_ls_check0
           | _ :: _ -> app asm_ls_check0 (app asm_ls_prefix asm_ls1)), ls0))
    | Error err0 ->
      ((((Assembly_output,
        ('p'::('a'::('r'::('s'::('i'::('n'::('g'::[])))))))),
        (Debug.ret (Error err0))) :: []), ls)
  in
  let infos = aggregate_infos ls0 in
  let infos0 =
    union_extra_infos_of_extra_synthesis output_language_api pipeline_opts
      pipeline_to_string_opts synthesis_opts machine_wordsize0 infos
  in
  let (extra_ls, extra_infos) =
    extra_synthesis output_language_api pipeline_opts pipeline_to_string_opts
      synthesis_opts machine_wordsize0 function_name_prefix infos0
  in
  let extra_bit_widths = extra_infos.Coq7_Compilers.ToString.bitwidths_used in
  let res =
    app
      (if synthesis_opts.Coq0_Options.emit_primitives
       then map push_sig_type extra_ls
       else []) ls0
  in
  let res0 =
    map (fun pat ->
      let (name0, res0) = pat in
      ((Normal_output, name0),
      (Pipeline.M.bind res0 (fun res1 ->
        Debug.ret (Success (projT2 res1).Pipeline.lines))))) res
  in
  let infos1 =
    Coq7_Compilers.ToString.ident_info_union infos0
      (Coq7_Compilers.ToString.ident_info_of_bitwidths_used extra_bit_widths)
  in
  let header0 =
    app comment_header
      (output_language_api.Coq7_Compilers.ToString.header
        pipeline_to_string_opts.Coq0_Options.language_naming_conventions
        pipeline_to_string_opts.Coq0_Options.documentation_options
        synthesis_opts.Coq0_Options.package_namev
        synthesis_opts.Coq0_Options.class_namev
        pipeline_opts.Coq0_Options.output_options machine_wordsize0
        ((||) pipeline_to_string_opts.Coq0_Options.internal_static
          pipeline_to_string_opts.Coq0_Options.static)
        pipeline_to_string_opts.Coq0_Options.static function_name_prefix
        infos1 all_typedefs)
  in
  let footer0 =
    output_language_api.Coq7_Compilers.ToString.footer
      pipeline_to_string_opts.Coq0_Options.language_naming_conventions
      pipeline_to_string_opts.Coq0_Options.documentation_options
      synthesis_opts.Coq0_Options.package_namev
      synthesis_opts.Coq0_Options.class_namev machine_wordsize0
      ((||) pipeline_to_string_opts.Coq0_Options.internal_static
        pipeline_to_string_opts.Coq0_Options.static)
      pipeline_to_string_opts.Coq0_Options.static function_name_prefix infos1
  in
  app (((Normal_output,
    (append
      ('c'::('h'::('e'::('c'::('k'::('_'::('a'::('r'::('g'::('s'::[]))))))))))
      (append (newLine::[]) (concat0 (newLine::[]) header0)))),
    (Debug.ret (check_args5 requests0 (Success header0)))) :: [])
    (app asm_ls
      (app res0
        (match footer0 with
         | [] -> []
         | _ :: _ ->
           ((Normal_output, ('f'::('o'::('o'::('t'::('e'::('r'::[]))))))),
             (Debug.ret (Success footer0))) :: [])))

module SaturatedSolinas =
 struct
  (** val reified_mul_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_mul_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun v28 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), v28)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun c0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun log2base -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun nreductions0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      log2base)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      log2base)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      nreductions0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun c0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun nreductions0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v26)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      nreductions0)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v22)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v22)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v21)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v23)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v18)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v13)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v14)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v11)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v7)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v3)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zneg XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun fuel0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun s0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun w_i -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun res -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun v3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun found_adjustment -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun res0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w_i)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic true))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w_i)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found_adjustment)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found_adjustment)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic false))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      fuel0)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))
 end

(** val override_pipeline_opts :
    Coq0_Options.coq_PipelineOptions -> Coq0_Options.coq_PipelineOptions **)

let override_pipeline_opts pipeline_opts =
  { Coq0_Options.absint_opts = pipeline_opts.Coq0_Options.absint_opts;
    Coq0_Options.widen_carry = pipeline_opts.Coq0_Options.widen_carry;
    Coq0_Options.widen_bytes = true; Coq0_Options.unfold_value_barrier =
    pipeline_opts.Coq0_Options.unfold_value_barrier;
    Coq0_Options.should_split_multiret =
    pipeline_opts.Coq0_Options.should_split_multiret;
    Coq0_Options.should_split_mul =
    pipeline_opts.Coq0_Options.should_split_mul;
    Coq0_Options.output_options = pipeline_opts.Coq0_Options.output_options;
    Coq0_Options.only_signed = pipeline_opts.Coq0_Options.only_signed;
    Coq0_Options.no_select = pipeline_opts.Coq0_Options.no_select;
    Coq0_Options.low_level_rewriter_method =
    pipeline_opts.Coq0_Options.low_level_rewriter_method;
    Coq0_Options.debug_rewriting =
    pipeline_opts.Coq0_Options.debug_rewriting }

(** val possible_values_of_machine_wordsize0 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list **)

let possible_values_of_machine_wordsize0 pipeline_opts machine_wordsize0 =
  if widen_carry
       (override_pipeline_opts pipeline_opts).Coq0_Options.widen_carry
  then Z0 :: (machine_wordsize0 :: [])
  else Z0 :: ((Zpos XH) :: (machine_wordsize0 :: []))

(** val n0 : z -> machine_wordsize_opt -> nat **)

let n0 s0 machine_wordsize0 =
  Coq_Z.to_nat
    (qceiling
      (qdiv (inject_Z (Coq_Z.log2_up s0)) (inject_Z machine_wordsize0)))

(** val m0 : z -> (z * z) list -> z **)

let m0 s0 c0 =
  Coq_Z.sub s0 (Associational.eval c0)

(** val nreductions : z -> (z * z) list -> machine_wordsize_opt -> nat **)

let nreductions s0 c0 machine_wordsize0 =
  let i =
    fold_right Coq_Z.max Z0
      (map (fun t0 -> Coq_Z.div (Coq_Z.log2 (fst t0)) machine_wordsize0) c0)
  in
  if Coq_Z.leb (Coq_Z.sub (Coq_Z.of_nat (n0 s0 machine_wordsize0)) i) (Zpos
       XH)
  then n0 s0 machine_wordsize0
  else Coq_Z.to_nat
         (qceiling
           (qdiv (inject_Z (Coq_Z.of_nat (n0 s0 machine_wordsize0)))
             (qminus
               (qminus (inject_Z (Coq_Z.of_nat (n0 s0 machine_wordsize0)))
                 (inject_Z i)) { qnum = (Zpos XH); qden = XH })))

(** val no_select_size1 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    no_select_size_opt **)

let no_select_size1 pipeline_opts machine_wordsize0 =
  if no_select (override_pipeline_opts pipeline_opts).Coq0_Options.no_select
  then Some machine_wordsize0
  else None

(** val split_mul_to1 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_mul_to_opt **)

let split_mul_to1 pipeline_opts machine_wordsize0 =
  if should_split_mul
       (override_pipeline_opts pipeline_opts).Coq0_Options.should_split_mul
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize0 pipeline_opts
               machine_wordsize0))))
  else None

(** val split_multiret_to1 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_multiret_to_opt **)

let split_multiret_to1 pipeline_opts machine_wordsize0 =
  if should_split_multiret
       (override_pipeline_opts pipeline_opts).Coq0_Options.should_split_multiret
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize0 pipeline_opts
               machine_wordsize0))))
  else None

(** val check_args :
    z -> (z * z) list -> machine_wordsize_opt -> char list list ->
    (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage,
    'a1) errorT **)

let check_args s0 c0 machine_wordsize0 _ res =
  check_args_of_list
    (map (fun v -> (true, v))
      (((Coq_Z.ltb Z0 (Coq_Z.sub s0 (Associational.eval c0))),
      (Pipeline.Value_not_ltZ
      (('s'::(' '::('-'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::(' '::('\226'::('\137'::('\164'::(' '::('0'::[])))))))))))))))))))))))))))))),
      Z0,
      (Coq_Z.sub s0 (Associational.eval c0))))) :: (((negb (Coq_Z.eqb s0 Z0)),
      (Pipeline.Values_not_provably_distinctZ
      (('s'::(' '::('\226'::('\137'::('\160'::(' '::('0'::[]))))))), s0,
      Z0))) :: (((negb (Nat.eqb (n0 s0 machine_wordsize0) O)),
      (Pipeline.Values_not_provably_distinctZ
      (('n'::(' '::('\226'::('\137'::('\160'::(' '::('0'::[]))))))),
      (Coq_Z.of_nat (n0 s0 machine_wordsize0)),
      Z0))) :: (((Coq_Z.ltb Z0 machine_wordsize0), (Pipeline.Value_not_ltZ
      (('0'::(' '::('<'::(' '::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::[])))))))))))))))))))),
      Z0, machine_wordsize0))) :: []))))) res

(** val smul :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
    machine_wordsize_opt -> char list -> char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM **)

let smul output_language_api pipeline_opts pipeline_to_string_opts s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('m'::('u'::('l'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        (override_pipeline_opts pipeline_opts).Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        (override_pipeline_opts pipeline_opts).Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed =
        (override_pipeline_opts pipeline_opts).Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size1 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to1 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to1 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        (override_pipeline_opts pipeline_opts).Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        (override_pipeline_opts pipeline_opts).Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        (override_pipeline_opts pipeline_opts).Coq0_Options.debug_rewriting }
        false
        (possible_values_of_machine_wordsize0 pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)),
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)))))))))))))))) (fun _ ->
                  SaturatedSolinas.reified_mul_gen) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ ->
              Obj.magic n0 s0 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ ->
            Obj.magic nreductions s0 c0 machine_wordsize0)))
        (Obj.magic ((Some
          (saturated_bounds (n0 s0 machine_wordsize0) machine_wordsize0)),
          ((Some
          (saturated_bounds (n0 s0 machine_wordsize0) machine_wordsize0)),
          ())))
        (Obj.magic ((Some
          (saturated_bounds (n0 s0 machine_wordsize0) machine_wordsize0)),
          None))) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (saturated_bounds (n0 s0 machine_wordsize0) machine_wordsize0)),
          ((Some
          (saturated_bounds (n0 s0 machine_wordsize0) machine_wordsize0)),
          ()))
        in
        let out_bounds1 = ((Some
          (saturated_bounds (n0 s0 machine_wordsize0) machine_wordsize0)),
          None)
        in
        let arg_typedefs0 = (None, (None, ())) in
        let out_typedefs0 = (None, None) in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            (override_pipeline_opts pipeline_opts).Coq0_Options.absint_opts
            (fun r0 ->
            sequence_return0
              (relax_zrange_gen
                (override_pipeline_opts pipeline_opts).Coq0_Options.only_signed
                (possible_values_of_machine_wordsize0 pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            (override_pipeline_opts pipeline_opts).Coq0_Options.output_options
            machine_wordsize0 true internal_static1 is_internal' static0
            inline' prefix1
            (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
                   (' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[]))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('('::[])
                      (append
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))))) out_var_data))))
                          (append (' '::[])
                            (append ('+'::[])
                              (append (' '::[])
                                (append
                                  (append
                                    ('w'::('e'::('i'::('g'::('h'::('t'::[]))))))
                                    (append (' '::[])
                                      (Decimal.show_lvl_nat
                                        (n0 s0 machine_wordsize0)
                                        (Level.next (Level.Coq_level (Zpos
                                          (XO (XI (XO XH)))))))))
                                  (append (' '::[])
                                    (append ('*'::[])
                                      (append (' '::[])
                                        (snd
                                          (Obj.magic
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                            (Compilers.Coq_type.final_codomain
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))))))))
                                            out_var_data)))))))))) (')'::[])))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (Decimal.show_lvl_Z (m0 s0 c0) (Level.Coq_level
                            (Zpos (XI (XI (XI (XO (XO XH))))))))))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                            ((Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[])
                            (Decimal.show_lvl_Z (m0 s0 c0) (Level.Coq_level
                              (Zpos (XI (XI (XI (XO (XO XH))))))))))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z)))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val known_functions :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
    machine_wordsize_opt -> (char list * (char list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list **)

let known_functions output_language_api pipeline_opts pipeline_to_string_opts s0 c0 machine_wordsize0 =
  (('m'::('u'::('l'::[]))), (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
    (smul output_language_api pipeline_opts pipeline_to_string_opts s0 c0
      machine_wordsize0 s1)))) :: []

(** val valid_names : char list **)

let valid_names =
  'm'::('u'::('l'::[]))

(** val synthesize0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> z -> (z * z) list ->
    machine_wordsize_opt -> char list list -> char list -> char list list ->
    ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

let synthesize0 output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts s0 c0 machine_wordsize0 comment_header function_name_prefix requests =
  synthesize output_language_api (override_pipeline_opts pipeline_opts)
    pipeline_to_string_opts synthesis_opts machine_wordsize0 valid_names
    (known_functions output_language_api pipeline_opts
      pipeline_to_string_opts s0 c0 machine_wordsize0) (fun _ -> []) []
    (check_args s0 c0 machine_wordsize0)
    (output_language_api.Coq7_Compilers.ToString.comment_file_header_block
      (app comment_header
        ([] :: (('C'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::[])))))))))))))))) :: ([] :: (
        (append
          (' '::(' '::('#'::(' '::('r'::('e'::('d'::('u'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('='::(' '::[])))))))))))))))))
          (show0 Decimal.show_nat (nreductions s0 c0 machine_wordsize0))) :: []))))))
    function_name_prefix requests

module TAPOrder =
 struct
  type t = z * z

  (** val leb : t -> t -> bool **)

  let leb x y =
    Coq_Z.geb (snd x) (snd y)
 end

module TAPSort = Sort(TAPOrder)

type tight_upperbound_fraction_opt = q

(** val carry_chains : nat -> z -> (z * z) list -> nat list **)

let carry_chains n3 s0 c0 =
  let limbwidth =
    qdiv (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
      (inject_Z (Coq_Z.of_nat n3))
  in
  let p =
    app (((Coq_Z.div s0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 s0))),
      (Coq_Z.log2 s0)) :: [])
      (TAPSort.sort
        (map (fun pat -> let (w, v) = pat in ((Coq_Z.opp v), (Coq_Z.log2 w)))
          c0))
  in
  if Nat.ltb (S (S O)) (length p)
  then let starts =
         map (fun pat ->
           let (_, w) = pat in
           Coq_Z.modulo
             (Coq_Z.sub (qfloor (qdiv (inject_Z w) limbwidth)) (Zpos XH))
             (Coq_Z.of_nat n3)) (tl p)
       in
       let chain2 =
         flat_map (fun n' ->
           map (fun j ->
             Coq_Z.modulo (Coq_Z.add j (Coq_Z.of_nat n')) (Coq_Z.of_nat n3))
             starts) (seq (S O) (pred n3))
       in
       let chain3 = remove_duplicates Coq_Z.eqb chain2 in
       let chain4 =
         map (fun x ->
           Coq_Z.modulo (Coq_Z.add x (Zpos XH)) (Coq_Z.of_nat n3)) starts
       in
       map Coq_Z.to_nat (app starts (app chain3 chain4))
  else app (seq O n3) (O :: ((S O) :: []))

(** val default_tight_upperbound_fraction : q **)

let default_tight_upperbound_fraction =
  { qnum = (Zpos XH); qden = XH }

(** val coef : z **)

let coef =
  Zpos (XO XH)

(** val prime_upperbound_list : nat -> z -> (z * z) list -> z list **)

let prime_upperbound_list n3 s0 c0 =
  let limbwidth =
    qdiv (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
      (inject_Z (Coq_Z.of_nat n3))
  in
  Partition.partition (weight limbwidth.qnum (Zpos limbwidth.qden)) n3
    (Coq_Z.sub
      (Coq_Z.pow (Zpos (XO XH))
        (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0)))) (Zpos XH))

(** val tight_upperbounds :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list **)

let tight_upperbounds tight_upperbound_fraction n3 s0 c0 =
  map (fun v ->
    qceiling
      (qabs
        (qmult tight_upperbound_fraction
          (qplus (inject_Z v) { qnum = (Zpos XH); qden = XH }))))
    (prime_upperbound_list n3 s0 c0)

(** val headspace_add_count : nat **)

let headspace_add_count =
  S (S O)

(** val headspace_sub_count : nat **)

let headspace_sub_count =
  S O

(** val distribute_balance_step :
    nat -> z -> (z * z) list -> z list -> nat -> z list -> z list **)

let distribute_balance_step n3 s0 c0 =
  let limbwidth =
    qdiv (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
      (inject_Z (Coq_Z.of_nat n3))
  in
  (fun minvalues i b ->
  let bi = nth_default Z0 b i in
  let mi = nth_default Z0 minvalues i in
  if Coq_Z.ltb bi mi
  then let fw =
         Coq_Z.div (weight limbwidth.qnum (Zpos limbwidth.qden) (S i))
           (weight limbwidth.qnum (Zpos limbwidth.qden) i)
       in
       let x =
         Coq_Z.add (Coq_Z.div (Coq_Z.sub mi bi) fw)
           (Coq_Z.b2z
             (negb (Coq_Z.eqb (Coq_Z.modulo (Coq_Z.sub mi bi) fw) Z0)))
       in
       let zero1 = ((weight limbwidth.qnum (Zpos limbwidth.qden) i),
         (Coq_Z.mul x fw)) :: (((weight limbwidth.qnum (Zpos limbwidth.qden)
                                  (S i)), (Coq_Z.opp x)) :: [])
       in
       let ba =
         app
           (Positional.to_associational
             (weight limbwidth.qnum (Zpos limbwidth.qden)) n3 b) zero1
       in
       Positional.from_associational
         (weight limbwidth.qnum (Zpos limbwidth.qden)) n3 ba
  else b)

(** val distribute_balance :
    nat -> z -> (z * z) list -> z list -> z list -> z list **)

let distribute_balance n3 s0 c0 minvalues b =
  fold_right (distribute_balance_step n3 s0 c0 minvalues) b
    (rev1 (seq O (sub n3 (S O))))

(** val balance :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list **)

let balance tight_upperbound_fraction n3 s0 c0 =
  let limbwidth =
    qdiv (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
      (inject_Z (Coq_Z.of_nat n3))
  in
  let b =
    Positional.encode (weight limbwidth.qnum (Zpos limbwidth.qden)) n3 s0 c0
      (Coq_Z.sub s0 (Associational.eval c0))
  in
  let b0 =
    Positional.scmul (weight limbwidth.qnum (Zpos limbwidth.qden)) n3 coef b
  in
  distribute_balance n3 s0 c0
    (tight_upperbounds tight_upperbound_fraction n3 s0 c0) b0

(** val loose_upperbounds :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list **)

let loose_upperbounds tight_upperbound_fraction n3 s0 c0 =
  map (fun pat ->
    let (v, bal0) = pat in
    Coq_Z.add v
      (Coq_Z.max (Coq_Z.mul (Coq_Z.of_nat headspace_add_count) v)
        (Coq_Z.mul (Coq_Z.of_nat headspace_sub_count) bal0)))
    (combine (tight_upperbounds tight_upperbound_fraction n3 s0 c0)
      (balance tight_upperbound_fraction n3 s0 c0))

(** val tight_bounds :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> zrange
    option list **)

let tight_bounds tight_upperbound_fraction n3 s0 c0 =
  map (fun u -> Some { lower = Z0; upper = u })
    (tight_upperbounds tight_upperbound_fraction n3 s0 c0)

(** val loose_bounds :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> zrange
    option list **)

let loose_bounds tight_upperbound_fraction n3 s0 c0 =
  map (fun u -> Some { lower = Z0; upper = u })
    (loose_upperbounds tight_upperbound_fraction n3 s0 c0)

(** val overflow_free :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z -> bool **)

let overflow_free tight_upperbound_fraction n3 s0 c0 machine_wordsize0 =
  let limbwidth =
    qdiv (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
      (inject_Z (Coq_Z.of_nat n3))
  in
  let v =
    Positional.squaremod (weight limbwidth.qnum (Zpos limbwidth.qden)) s0 c0
      n3 (loose_upperbounds tight_upperbound_fraction n3 s0 c0)
  in
  forallb (fun k ->
    Coq_Z.ltb (Coq_Z.log2 k) (Coq_Z.mul (Zpos (XO XH)) machine_wordsize0)) v

type maybeLimbCount =
| NumLimbs of nat
| Auto of nat

(** val get_possible_limbs :
    tight_upperbound_fraction_opt -> z -> (z * z) list -> z -> nat list **)

let get_possible_limbs tight_upperbound_fraction s0 c0 machine_wordsize0 =
  let num_bits_p = Coq_Z.log2_up s0 in
  let nlimbs_saturated =
    Coq_Z.to_nat
      (qceiling (qdiv (inject_Z num_bits_p) (inject_Z machine_wordsize0)))
  in
  filter (fun n3 ->
    overflow_free tight_upperbound_fraction n3 s0 c0 machine_wordsize0)
    (seq nlimbs_saturated nlimbs_saturated)

(** val get_num_limbs :
    tight_upperbound_fraction_opt -> z -> (z * z) list -> z -> maybeLimbCount
    -> nat option **)

let get_num_limbs tight_upperbound_fraction s0 c0 machine_wordsize0 = function
| NumLimbs n4 -> Some n4
| Auto idx0 ->
  nth_error
    (get_possible_limbs tight_upperbound_fraction s0 c0 machine_wordsize0)
    idx0

module UnsaturatedSolinas =
 struct
  (** val reified_carry_mul_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_carry_mul_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v15 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v15)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun f -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun g -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v14)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v8)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      g)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun idxs0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v13)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ab_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun abm_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      abm_a)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v3)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      ab_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v4)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun repeat_reduce_n' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      repeat_reduce_n')), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p1)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_carry_square_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_carry_square_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v17 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v17)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v16)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v10)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun idxs0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun aa_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun aam_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      aam_a)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v5)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      aa_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v8)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v6)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun repeat_reduce_n' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      repeat_reduce_n')), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p1)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun div_s -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_list_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun ts -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun acc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun y -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun two_t -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun y0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun two_c_t -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c_t -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      div_s)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c_t)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun pat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun y1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun two_t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun y2 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun two_c_t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      div_s)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two_c_t)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two_c_t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two_t)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two_t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t1)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      y2)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      y1)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      pat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      ts)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      y0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      acc)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v2)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun two0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (fun c_t -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c_t)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two0)))), (fun two_c_t -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two0)))), (fun two_t -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c_t)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two_c_t)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      two_t)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_carry_scmul_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_carry_scmul_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v16 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v16)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v12)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v15)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ab_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun abm_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      abm_a)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v14)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      ab_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun repeat_reduce_n' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      repeat_reduce_n')), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p1)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v12)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun idxs0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v7)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v6)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v0)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_carry_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_carry_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v13 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v13)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v12)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun idxs0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v7)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v2)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v5)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_add_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_add_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v6)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v1)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_sub_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_sub_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v9 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v9)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v8)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ca -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), ca)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      _b)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun negA -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      negA)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun cx -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v1)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_opp_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_opp_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v10)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v0)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ca -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), ca)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      _b)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun negA -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      negA)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun cx -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v0)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_carry_add_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_carry_add_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v14 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v14)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun f -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun g -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      g)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun idxs0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v12)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v7)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v1)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_carry_sub_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_carry_sub_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v1 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v2 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v3 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v4 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v5 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v6 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v7 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v8 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v9 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v10 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v11 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v12 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v13 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v14 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v15 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v16 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun v17 ->
      Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), v17)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun f -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun g -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v16)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v8)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      g)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun idxs0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v13)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ca -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), ca)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      _b)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun negA -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      negA)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun cx -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v1)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_carry_opp_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_carry_opp_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v18 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v18)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v17)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun idxs0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v16)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v12)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v11)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v0)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun balance0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ca -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), ca)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      _b)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      balance0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun negA -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      negA)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun cx -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      cx)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v0)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_eval_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_eval_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (fun v3 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), v3)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v2)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_bytes_eval_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_bytes_eval_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v4 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v3)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v2)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2_up)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))))))))))

  (** val reified_to_bytes_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_to_bytes_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v29 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v29)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun limbwidth_num0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun limbwidth_den0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v28 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v1)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v14)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v28)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun sw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun dw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun dn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_flattened -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r1 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), r1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_assoc)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), sw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v24)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun digit -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun fw -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun sum_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun digit -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun tl1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun flatten_column_tl -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v22)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun y -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun tl'0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v22)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      flatten_column_tl)), (fun rec0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun sum_carry -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun carry' -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry')))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl'0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl1)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      n3)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      c0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))),
      (fun sum0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v17)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v18)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v16)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2_up)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun r0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v12)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v9)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun qq -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      qq)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v5)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun n3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_shiftl)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      n3)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zneg XH)))))))))))

  (** val reified_from_bytes_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_from_bytes_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v15)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v14)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v14 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v14)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun sw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun dw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun dn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_flattened -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r1 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), r1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_assoc)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), sw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v10)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun digit -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun fw -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun sum_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun digit -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun tl1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun flatten_column_tl -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun y -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun tl'0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      flatten_column_tl)), (fun rec0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun sum_carry -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun carry' -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry')))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl'0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl1)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      n3)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      c0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))),
      (fun sum0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v4)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2_up)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))))))))))
 end

(** val idxs : nat -> z -> (z * z) list -> nat list **)

let idxs =
  carry_chains

(** val n_bytes : z -> nat **)

let n_bytes =
  bytes_n

(** val prime_bytes_upperbound_list : z -> z list **)

let prime_bytes_upperbound_list s0 =
  Partition.partition (weight (Zpos (XO (XO (XO XH)))) (Zpos XH))
    (n_bytes s0) (Coq_Z.sub s0 (Zpos XH))

(** val tight_bounds_typedef :
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> Coq_typedef.typedef **)

let tight_bounds_typedef pipeline_to_string_opts _ _ _ _ =
  { Coq_typedef.name =
    ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))));
    Coq_typedef.description = (fun name0 ->
    append
      (Coq7_Compilers.Options.text_before_type_name
        pipeline_to_string_opts.Coq0_Options.documentation_options)
      (append name0
        (' '::('i'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('t'::('i'::('g'::('h'::('t'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::('.'::[])))))))))))))))))))))))))))))))))))))))) }

(** val loose_bounds_typedef :
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> Coq_typedef.typedef **)

let loose_bounds_typedef pipeline_to_string_opts _ _ _ _ =
  { Coq_typedef.name =
    ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))));
    Coq_typedef.description = (fun name0 ->
    append
      (Coq7_Compilers.Options.text_before_type_name
        pipeline_to_string_opts.Coq0_Options.documentation_options)
      (append name0
        (' '::('i'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('l'::('o'::('o'::('s'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::('.'::[])))))))))))))))))))))))))))))))))))))))) }

(** val prime_bytes_bounds :
    z -> Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let prime_bytes_bounds s0 =
  map (fun v -> Obj.magic (Some { lower = Z0; upper = v }))
    (prime_bytes_upperbound_list s0)

(** val m1 : z -> (z * z) list -> z **)

let m1 s0 c0 =
  Coq_Z.sub s0 (Associational.eval c0)

(** val m_enc_min :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list **)

let m_enc_min tight_upperbound_fraction n3 s0 c0 =
  let wt =
    weight
      (qdiv (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
        (inject_Z (Coq_Z.of_nat n3))).qnum (Zpos
      (qdiv (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
        (inject_Z (Coq_Z.of_nat n3))).qden)
  in
  let fw = map (fun i -> Coq_Z.div (wt (S i)) (wt i)) (seq O n3) in
  let m_enc_min0 =
    map2 Coq_Z.sub (tight_upperbounds tight_upperbound_fraction n3 s0 c0) fw
  in
  if forallb (Coq_Z.eqb Z0) m_enc_min0
  then set_nth (sub n3 (S O)) (Zpos XH) m_enc_min0
  else m_enc_min0

(** val m_enc :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list -> z list **)

let m_enc tight_upperbound_fraction n3 s0 c0 =
  let m4 =
    Positional.encode
      (weight
        (qdiv
          (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
          (inject_Z (Coq_Z.of_nat n3))).qnum (Zpos
        (qdiv
          (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
          (inject_Z (Coq_Z.of_nat n3))).qden)) n3 s0 c0 (m1 s0 c0)
  in
  distribute_balance n3 s0 c0 (m_enc_min tight_upperbound_fraction n3 s0 c0)
    m4

(** val no_select_size2 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    no_select_size_opt **)

let no_select_size2 pipeline_opts machine_wordsize0 =
  if no_select pipeline_opts.Coq0_Options.no_select
  then Some machine_wordsize0
  else None

(** val split_mul_to2 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_mul_to_opt **)

let split_mul_to2 pipeline_opts machine_wordsize0 =
  if should_split_mul pipeline_opts.Coq0_Options.should_split_mul
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize pipeline_opts
               machine_wordsize0))))
  else None

(** val split_multiret_to2 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_multiret_to_opt **)

let split_multiret_to2 pipeline_opts machine_wordsize0 =
  if should_split_multiret pipeline_opts.Coq0_Options.should_split_multiret
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize pipeline_opts
               machine_wordsize0))))
  else None

(** val check_args0 :
    tight_upperbound_fraction_opt -> nat -> z -> (z * z) list ->
    machine_wordsize_opt -> char list list -> (Pipeline.coq_ErrorMessage,
    'a1) errorT -> (Pipeline.coq_ErrorMessage, 'a1) errorT **)

let check_args0 tight_upperbound_fraction n3 s0 c0 machine_wordsize0 requests res =
  check_args_of_list
    (app
      (map (fun v -> (true, v))
        (((qle_bool { qnum = (Zpos XH); qden = XH }
            (qdiv
              (inject_Z
                (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
              (inject_Z (Coq_Z.of_nat n3)))), (Pipeline.Value_not_leQ
        (('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::(' '::('<'::(' '::('1'::[]))))))))))))),
        { qnum = (Zpos XH); qden = XH },
        (qdiv
          (inject_Z (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
          (inject_Z (Coq_Z.of_nat n3)))))) :: (((Coq_Z.leb (Coq_Z.of_nat n3)
                                                  (Coq_Z.log2_up
                                                    (Coq_Z.sub s0
                                                      (Associational.eval c0)))),
        (Pipeline.Value_not_leZ
        (('Z'::('.'::('l'::('o'::('g'::('2'::('_'::('u'::('p'::(' '::('('::('s'::(' '::('-'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::(')'::(' '::('<'::(' '::('n'::[])))))))))))))))))))))))))))))))))))))))),
        (Coq_Z.of_nat n3),
        (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0)))))) :: ((
        (Coq_Z.ltb (Associational.eval c0) s0), (Pipeline.Value_not_ltZ
        (('s'::(' '::('\226'::('\137'::('\164'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::[])))))))))))))))))))))))))),
        (Associational.eval c0), s0))) :: (((Coq_Z.ltb Z0 s0),
        (Pipeline.Value_not_ltZ
        (('s'::(' '::('\226'::('\137'::('\164'::(' '::('0'::[]))))))), Z0,
        s0))) :: (((negb (Nat.eqb n3 O)),
        (Pipeline.Values_not_provably_distinctZ
        (('n'::(' '::('='::(' '::('0'::[]))))), (Coq_Z.of_nat n3),
        (Coq_Z.of_nat O)))) :: (((Coq_Z.ltb Z0 machine_wordsize0),
        (Pipeline.Value_not_ltZ
        (('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::(' '::('\226'::('\137'::('\164'::(' '::('0'::[])))))))))))))))))))))),
        Z0,
        machine_wordsize0))) :: ((let v1 =
                                    Coq_Z.sub s0 (Associational.eval c0)
                                  in
                                  let v2 =
                                    weight
                                      (qdiv
                                        (inject_Z
                                          (Coq_Z.log2_up
                                            (Coq_Z.sub s0
                                              (Associational.eval c0))))
                                        (inject_Z (Coq_Z.of_nat n3))).qnum
                                      (Zpos
                                      (qdiv
                                        (inject_Z
                                          (Coq_Z.log2_up
                                            (Coq_Z.sub s0
                                              (Associational.eval c0))))
                                        (inject_Z (Coq_Z.of_nat n3))).qden) n3
                                  in
                                  ((Coq_Z.leb v1 v2), (Pipeline.Value_not_leZ
                                  (('w'::('e'::('i'::('g'::('h'::('t'::(' '::('n'::(' '::('<'::(' '::('s'::(' '::('-'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::[]))))))))))))))))))))))))))))))))))),
                                  v1, v2)))) :: ((let v1 =
                                                    fold_right Coq_Z.max Z0
                                                      (prime_bytes_upperbound_list
                                                        s0)
                                                  in
                                                  let v2 =
                                                    Coq_Z.sub
                                                      (Coq_Z.pow (Zpos (XO
                                                        XH))
                                                        machine_wordsize0)
                                                      (Zpos XH)
                                                  in
                                                  ((Coq_Z.leb v1 v2),
                                                  (Pipeline.Value_not_leZ
                                                  (('m'::('a'::('x'::('('::('p'::('r'::('i'::('m'::('e'::('_'::('b'::('y'::('t'::('e'::('s'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(')'::(' '::('>'::(' '::('2'::('^'::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::('-'::('1'::[]))))))))))))))))))))))))))))))))))))))))))))))))))),
                                                  v1, v2)))) :: ((let v1 =
                                                                    fold_right
                                                                    Coq_Z.max
                                                                    Z0
                                                                    (tight_upperbounds
                                                                    tight_upperbound_fraction
                                                                    n3 s0 c0)
                                                                  in
                                                                  let v2 =
                                                                    Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    machine_wordsize0)
                                                                    (Zpos XH)
                                                                  in
                                                                  ((Coq_Z.leb
                                                                    v1 v2),
                                                                  (Pipeline.Value_not_leZ
                                                                  (('m'::('a'::('x'::('('::('t'::('i'::('g'::('h'::('t'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(')'::(' '::('>'::(' '::('2'::('^'::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::('-'::('1'::[]))))))))))))))))))))))))))))))))))))))))))))),
                                                                  v1, v2)))) :: (
        (let v1 =
           fold_right Coq_Z.max Z0
             (loose_upperbounds tight_upperbound_fraction n3 s0 c0)
         in
         let v2 =
           Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)
         in
         ((Coq_Z.leb v1 v2), (Pipeline.Value_not_leZ
         (('m'::('a'::('x'::('('::('l'::('o'::('o'::('s'::('e'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(')'::(' '::('>'::(' '::('2'::('^'::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::('-'::('1'::[]))))))))))))))))))))))))))))))))))))))))))))),
         v1, v2)))) :: [])))))))))))
      (app
        (map (fun v ->
          ((request_present requests
             ('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))), v))
          (((Coq_Z.ltb Z0 (Associational.eval c0)), (Pipeline.Value_not_ltZ
          (('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::(' '::('\226'::('\137'::('\164'::(' '::('0'::(' '::('('::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[])))))))))))))))))))))))))))))))))))))))))))))))),
          Z0,
          (Associational.eval c0)))) :: ((let v2 =
                                            weight
                                              (qdiv
                                                (inject_Z
                                                  (Coq_Z.log2_up
                                                    (Coq_Z.sub s0
                                                      (Associational.eval c0))))
                                                (inject_Z (Coq_Z.of_nat n3))).qnum
                                              (Zpos
                                              (qdiv
                                                (inject_Z
                                                  (Coq_Z.log2_up
                                                    (Coq_Z.sub s0
                                                      (Associational.eval c0))))
                                                (inject_Z (Coq_Z.of_nat n3))).qden)
                                              n3
                                          in
                                          ((Coq_Z.eqb s0 v2),
                                          (Pipeline.Values_not_provably_equalZ
                                          (('s'::(' '::('\226'::('\137'::('\160'::(' '::('w'::('e'::('i'::('g'::('h'::('t'::(' '::('n'::(' '::('('::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[])))))))))))))))))))))))))))))))))))),
                                          s0, v2)))) :: ((let v1 =
                                                            map
                                                              (Coq_Z.coq_land
                                                                (Coq_Z.ones
                                                                  machine_wordsize0))
                                                              (m_enc
                                                                tight_upperbound_fraction
                                                                n3 s0 c0)
                                                          in
                                                          let v2 =
                                                            m_enc
                                                              tight_upperbound_fraction
                                                              n3 s0 c0
                                                          in
                                                          ((list_beq
                                                             Coq_Z.eqb v1 v2),
                                                          (Pipeline.Values_not_provably_equal_listZ
                                                          (('m'::('a'::('p'::(' '::('m'::('a'::('s'::('k'::(' '::('m'::('_'::('e'::('n'::('c'::(' '::('\226'::('\137'::('\160'::(' '::('m'::('_'::('e'::('n'::('c'::(' '::('('::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[])))))))))))))))))))))))))))))))))))))))))))))),
                                                          v1, v2)))) :: (
          (let v1 =
             Positional.eval
               (weight
                 (qdiv
                   (inject_Z
                     (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                   (inject_Z (Coq_Z.of_nat n3))).qnum (Zpos
                 (qdiv
                   (inject_Z
                     (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                   (inject_Z (Coq_Z.of_nat n3))).qden)) n3
               (m_enc tight_upperbound_fraction n3 s0 c0)
           in
           let v2 = Coq_Z.sub s0 (Associational.eval c0) in
           ((Coq_Z.eqb v1 v2), (Pipeline.Values_not_provably_equalZ
           (('e'::('v'::('a'::('l'::(' '::('m'::('_'::('e'::('n'::('c'::(' '::('\226'::('\137'::('\160'::(' '::('s'::(' '::('-'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::(' '::('('::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
           v1, v2)))) :: ((let v1 =
                             Positional.eval
                               (weight
                                 (qdiv
                                   (inject_Z
                                     (Coq_Z.log2_up
                                       (Coq_Z.sub s0 (Associational.eval c0))))
                                   (inject_Z (Coq_Z.of_nat n3))).qnum (Zpos
                                 (qdiv
                                   (inject_Z
                                     (Coq_Z.log2_up
                                       (Coq_Z.sub s0 (Associational.eval c0))))
                                   (inject_Z (Coq_Z.of_nat n3))).qden)) n3
                               (tight_upperbounds tight_upperbound_fraction
                                 n3 s0 c0)
                           in
                           let v2 =
                             Coq_Z.mul (Zpos (XO XH))
                               (Positional.eval
                                 (weight
                                   (qdiv
                                     (inject_Z
                                       (Coq_Z.log2_up
                                         (Coq_Z.sub s0
                                           (Associational.eval c0))))
                                     (inject_Z (Coq_Z.of_nat n3))).qnum (Zpos
                                   (qdiv
                                     (inject_Z
                                       (Coq_Z.log2_up
                                         (Coq_Z.sub s0
                                           (Associational.eval c0))))
                                     (inject_Z (Coq_Z.of_nat n3))).qden)) n3
                                 (m_enc tight_upperbound_fraction n3 s0 c0))
                           in
                           ((Coq_Z.ltb v1 v2), (Pipeline.Value_not_ltZ
                           (('2'::(' '::('*'::(' '::('e'::('v'::('a'::('l'::(' '::('m'::('_'::('e'::('n'::('c'::(' '::('\226'::('\137'::('\164'::(' '::('e'::('v'::('a'::('l'::(' '::('t'::('i'::('g'::('h'::('t'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('('::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
                           v1, v2)))) :: []))))))
        (((request_present requests
            ('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))),
        ((Coq_Z.ltb (Zpos XH) s0), (Pipeline.Value_not_ltZ
        (('s'::(' '::('\226'::('\137'::('\164'::(' '::('1'::(' '::('('::('n'::('e'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[]))))))))))))))))))))))))))))),
        (Zpos XH), s0)))) :: []))) res

(** val scarry_mul :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scarry_mul output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1
     ('c'::('a'::('r'::('r'::('y'::('_'::('m'::('u'::('l'::[])))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))))) (fun _ ->
                    UnsaturatedSolinas.reified_carry_mul_gen) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ ->
                    Obj.magic (Zpos
                      (qdiv
                        (inject_Z
                          (Coq_Z.log2_up
                            (Coq_Z.sub s0 (Associational.eval c0))))
                        (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))) (fun _ -> Obj.magic idxs n3 s0 c0)))
        (Obj.magic ((Some (loose_bounds tight_upperbound_fraction n3 s0 c0)),
          ((Some (loose_bounds tight_upperbound_fraction n3 s0 c0)), ())))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)), ((Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)), ()))
        in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ((Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('c'::('a'::('r'::('r'::('y'::('_'::('m'::('u'::('l'::[])))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('c'::('a'::('r'::('r'::('y'::('_'::('m'::('u'::('l'::[])))))))))))
                   (' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::(' '::('a'::('n'::('d'::(' '::('r'::('e'::('d'::('u'::('c'::('e'::('s'::(' '::('t'::('h'::('e'::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val scarry_square :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scarry_square output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1
     ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))) (fun _ ->
                    UnsaturatedSolinas.reified_carry_square_gen) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ ->
                    Obj.magic (Zpos
                      (qdiv
                        (inject_Z
                          (Coq_Z.log2_up
                            (Coq_Z.sub s0 (Associational.eval c0))))
                        (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))) (fun _ -> Obj.magic idxs n3 s0 c0)))
        (Obj.magic ((Some (loose_bounds tight_upperbound_fraction n3 s0 c0)),
          ()))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)), ())
        in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))))))))
                   (' '::('s'::('q'::('u'::('a'::('r'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('a'::('n'::('d'::(' '::('r'::('e'::('d'::('u'::('c'::('e'::('s'::(' '::('t'::('h'::('e'::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))) arg_var_data))))))))
                          (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val scarry_scmul_const :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list -> z ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scarry_scmul_const output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 x =
  ((append prefix1
     (append
       ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('c'::('m'::('u'::('l'::('_'::[]))))))))))))
       (Coq0_Z.to_string x))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))) (fun _ ->
                    Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))))))))))) (fun _ ->
                      UnsaturatedSolinas.reified_carry_scmul_gen) (fun _ ->
                      Compilers.GallinaReify.coq_Reify_as
                        Coq3_Compilers.buildIdent
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (fun _ ->
                        Obj.magic
                          (qdiv
                            (inject_Z
                              (Coq_Z.log2_up
                                (Coq_Z.sub s0 (Associational.eval c0))))
                            (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic (Zpos
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))) (fun _ -> Obj.magic idxs n3 s0 c0)))
          (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic x)))
        (Obj.magic ((Some (loose_bounds tight_upperbound_fraction n3 s0 c0)),
          ()))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)), ())
        in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                (append
                  ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('c'::('m'::('u'::('l'::('_'::[]))))))))))))
                  (Coq0_Z.to_string x)))) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       (append
                         ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('c'::('m'::('u'::('l'::('_'::[]))))))))))))
                         (Coq0_Z.to_string x))))
                   (append
                     (' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('b'::('y'::(' '::[])))))))))))))))))))))))))))))))
                     (append (Coq0_Z.to_string x)
                       (' '::('a'::('n'::('d'::(' '::('r'::('e'::('d'::('u'::('c'::('e'::('s'::(' '::('t'::('h'::('e'::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('.'::[])))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (Decimal.show_lvl_Z x (Level.Coq_level (Zpos (XO
                              (XO (XO (XI (XO XH))))))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))) arg_var_data))))))))
                          (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val scarry :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scarry output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('c'::('a'::('r'::('r'::('y'::[])))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))) (fun _ ->
                    UnsaturatedSolinas.reified_carry_gen) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ ->
                    Obj.magic (Zpos
                      (qdiv
                        (inject_Z
                          (Coq_Z.log2_up
                            (Coq_Z.sub s0 (Associational.eval c0))))
                        (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))) (fun _ -> Obj.magic idxs n3 s0 c0)))
        (Obj.magic ((Some (loose_bounds tight_upperbound_fraction n3 s0 c0)),
          ()))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)), ())
        in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1 ('c'::('a'::('r'::('r'::('y'::[])))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1 ('c'::('a'::('r'::('r'::('y'::[])))))))
                   (' '::('r'::('e'::('d'::('u'::('c'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('.'::[]))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('e'::('v'::('a'::('l'::[]))))
                        (append (' '::[])
                          (fst
                            (Obj.magic
                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))) arg_var_data))))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sadd :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sadd output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('a'::('d'::('d'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              UnsaturatedSolinas.reified_add_gen) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ ->
                Obj.magic
                  (qdiv
                    (inject_Z
                      (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                    (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ ->
              Obj.magic (Zpos
                (qdiv
                  (inject_Z
                    (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                  (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3)))
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())))
        (Obj.magic (Some (loose_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ()))
        in
        let out_bounds1 = Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('a'::('d'::('d'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('a'::('d'::('d'::[])))))
                   (' '::('a'::('d'::('d'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[]))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('+'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val ssub :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let ssub output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('s'::('u'::('b'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                UnsaturatedSolinas.reified_sub_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ ->
                  Obj.magic
                    (qdiv
                      (inject_Z
                        (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                      (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ ->
                Obj.magic (Zpos
                  (qdiv
                    (inject_Z
                      (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                    (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            (fun _ -> Obj.magic balance tight_upperbound_fraction n3 s0 c0)))
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())))
        (Obj.magic (Some (loose_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ()))
        in
        let out_bounds1 = Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('s'::('u'::('b'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('s'::('u'::('b'::[])))))
                   (' '::('s'::('u'::('b'::('t'::('r'::('a'::('c'::('t'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[])))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('-'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sopp :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sopp output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('o'::('p'::('p'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                UnsaturatedSolinas.reified_opp_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ ->
                  Obj.magic
                    (qdiv
                      (inject_Z
                        (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                      (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ ->
                Obj.magic (Zpos
                  (qdiv
                    (inject_Z
                      (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                    (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            (fun _ -> Obj.magic balance tight_upperbound_fraction n3 s0 c0)))
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ()))
        (Obj.magic (Some (loose_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())
        in
        let out_bounds1 = Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('o'::('p'::('p'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('o'::('p'::('p'::[])))))
                   (' '::('n'::('e'::('g'::('a'::('t'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('.'::[]))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('-'::[])
                        (append ('e'::('v'::('a'::('l'::[]))))
                          (append (' '::[])
                            (fst
                              (Obj.magic
                                Compilers.Coq_type.map_for_each_lhs_of_arrow
                                Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))))) arg_var_data)))))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val scarry_add :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scarry_add output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1
     ('c'::('a'::('r'::('r'::('y'::('_'::('a'::('d'::('d'::[])))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat))) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))))) (fun _ ->
                    UnsaturatedSolinas.reified_carry_add_gen) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ ->
                    Obj.magic (Zpos
                      (qdiv
                        (inject_Z
                          (Coq_Z.log2_up
                            (Coq_Z.sub s0 (Associational.eval c0))))
                        (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))) (fun _ -> Obj.magic idxs n3 s0 c0)))
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ()))
        in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('c'::('a'::('r'::('r'::('y'::('_'::('a'::('d'::('d'::[])))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('c'::('a'::('r'::('r'::('y'::('_'::('a'::('d'::('d'::[])))))))))))
                   (' '::('a'::('d'::('d'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[]))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('+'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val scarry_sub :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scarry_sub output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1
     ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('u'::('b'::[])))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))))) (fun _ ->
                    Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))))))))))))) (fun _ ->
                      UnsaturatedSolinas.reified_carry_sub_gen) (fun _ ->
                      Compilers.GallinaReify.coq_Reify_as
                        Coq3_Compilers.buildIdent
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (fun _ ->
                        Obj.magic
                          (qdiv
                            (inject_Z
                              (Coq_Z.log2_up
                                (Coq_Z.sub s0 (Associational.eval c0))))
                            (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic (Zpos
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))) (fun _ -> Obj.magic idxs n3 s0 c0)))
          (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            (fun _ -> Obj.magic balance tight_upperbound_fraction n3 s0 c0)))
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ()))
        in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('u'::('b'::[])))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('u'::('b'::[])))))))))))
                   (' '::('s'::('u'::('b'::('t'::('r'::('a'::('c'::('t'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[])))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('-'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val scarry_opp :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let scarry_opp output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1
     ('c'::('a'::('r'::('r'::('y'::('_'::('o'::('p'::('p'::[])))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat))) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))) (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_prod
                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z),
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))) (fun _ ->
                    Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_prod
                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z),
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat))),
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))))))))))))))))) (fun _ ->
                      UnsaturatedSolinas.reified_carry_opp_gen) (fun _ ->
                      Compilers.GallinaReify.coq_Reify_as
                        Coq3_Compilers.buildIdent
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)) (fun _ ->
                        Obj.magic
                          (qdiv
                            (inject_Z
                              (Coq_Z.log2_up
                                (Coq_Z.sub s0 (Associational.eval c0))))
                            (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic (Zpos
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_prod
                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z),
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))) (fun _ -> Obj.magic idxs n3 s0 c0)))
          (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            (fun _ -> Obj.magic balance tight_upperbound_fraction n3 s0 c0)))
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ()))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())
        in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('c'::('a'::('r'::('r'::('y'::('_'::('o'::('p'::('p'::[])))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('c'::('a'::('r'::('r'::('y'::('_'::('o'::('p'::('p'::[])))))))))))
                   (' '::('n'::('e'::('g'::('a'::('t'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('.'::[]))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('-'::[])
                        (append ('e'::('v'::('a'::('l'::[]))))
                          (append (' '::[])
                            (fst
                              (Obj.magic
                                Compilers.Coq_type.map_for_each_lhs_of_arrow
                                Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))))) arg_var_data)))))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val srelax :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let srelax output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('r'::('e'::('l'::('a'::('x'::[])))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ -> reified_id_gen)
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ()))
        (Obj.magic (Some (loose_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())
        in
        let out_bounds1 = Some
          (loose_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('l'::('o'::('o'::('s'::('e'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1 ('r'::('e'::('l'::('a'::('x'::[])))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1 ('r'::('e'::('l'::('a'::('x'::[])))))))
                   (' '::('i'::('s'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('t'::('y'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::('f'::('r'::('o'::('m'::(' '::('t'::('i'::('g'::('h'::('t'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::(' '::('t'::('o'::(' '::('l'::('o'::('o'::('s'::('e'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))))) out_var_data)
                  (append (' '::('='::(' '::[])))
                    (fst
                      (Obj.magic Compilers.Coq_type.map_for_each_lhs_of_arrow
                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))))) arg_var_data))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sto_bytes :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sto_bytes output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize_with_bytes pipeline_opts
          machine_wordsize0) (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))) (fun _ ->
                    UnsaturatedSolinas.reified_to_bytes_gen) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ ->
                      Obj.magic
                        (qdiv
                          (inject_Z
                            (Coq_Z.log2_up
                              (Coq_Z.sub s0 (Associational.eval c0))))
                          (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ ->
                    Obj.magic (Zpos
                      (qdiv
                        (inject_Z
                          (Coq_Z.log2_up
                            (Coq_Z.sub s0 (Associational.eval c0))))
                        (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            (fun _ -> Obj.magic m_enc tight_upperbound_fraction n3 s0 c0)))
        (Obj.magic ((Some (tight_bounds tight_upperbound_fraction n3 s0 c0)),
          ())) (Obj.magic (Some (prime_bytes_bounds s0)))) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)), ())
        in
        let out_bounds1 = Some (prime_bytes_bounds s0) in
        let arg_typedefs0 = ((Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))),
          ())
        in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize_with_bytes pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))
                   (' '::('s'::('e'::('r'::('i'::('a'::('l'::('i'::('z'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::(' '::('b'::('y'::('t'::('e'::('s'::(' '::('i'::('n'::(' '::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::(' '::('o'::('r'::('d'::('e'::('r'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))))) out_var_data)
                  (append (' '::('='::(' '::[])))
                    (append ('m'::('a'::('p'::(' '::[]))))
                      (append
                        (append ('('::[])
                          (append
                            (append ('\206'::('\187'::[]))
                              (append (' '::[])
                                (append ('x'::[])
                                  (append (','::(' '::[]))
                                    (append ('\226'::('\140'::('\138'::[])))
                                      (append
                                        (append
                                          (append ('('::[])
                                            (append
                                              (append
                                                (append ('('::[])
                                                  (append
                                                    (append
                                                      (append
                                                        ('e'::('v'::('a'::('l'::[]))))
                                                        (append (' '::[])
                                                          (fst
                                                            (Obj.magic
                                                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))
                                                              arg_var_data))))
                                                      (append (' '::[])
                                                        (append
                                                          ('m'::('o'::('d'::[])))
                                                          (append (' '::[])
                                                            ('m'::[])))))
                                                    (')'::[])))
                                                (append (' '::[])
                                                  (append
                                                    ('m'::('o'::('d'::[])))
                                                    (append (' '::[])
                                                      (append
                                                        (Decimal.show_lvl_Z
                                                          (Zpos (XO XH))
                                                          (Level.Coq_level
                                                          (Zpos (XI (XO (XI
                                                          (XI XH)))))))
                                                        (append []
                                                          (append ('^'::[])
                                                            (append []
                                                              (append
                                                                ('('::[])
                                                                (append
                                                                  (append
                                                                    (Decimal.show_lvl_Z
                                                                    (Zpos (XO
                                                                    (XO (XO
                                                                    XH))))
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XO (XO
                                                                    (XI (XO
                                                                    XH))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('*'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('('::[])
                                                                    (append
                                                                    (append
                                                                    ('x'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('+'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (Decimal.show_lvl_nat
                                                                    (S O)
                                                                    (Level.Coq_level
                                                                    (Zpos (XI
                                                                    (XO (XO
                                                                    (XO (XI
                                                                    XH))))))))))))
                                                                    (')'::[])))))))
                                                                  (')'::[])))))))))))
                                              (')'::[])))
                                          (append (' '::[])
                                            (append ('/'::[])
                                              (append (' '::[])
                                                (append
                                                  (Decimal.show_lvl_Z (Zpos
                                                    (XO XH)) (Level.Coq_level
                                                    (Zpos (XI (XO (XI (XI
                                                    XH)))))))
                                                  (append []
                                                    (append ('^'::[])
                                                      (append []
                                                        (append ('('::[])
                                                          (append
                                                            (append
                                                              (Decimal.show_lvl_Z
                                                                (Zpos (XO (XO
                                                                (XO XH))))
                                                                (Level.Coq_level
                                                                (Zpos (XO (XO
                                                                (XO (XI (XO
                                                                XH))))))))
                                                              (append
                                                                (' '::[])
                                                                (append
                                                                  ('*'::[])
                                                                  (append
                                                                    (' '::[])
                                                                    ('x'::[])))))
                                                            (')'::[])))))))))))
                                        ('\226'::('\140'::('\139'::[])))))))))
                            (')'::[])))
                        (append (' '::[])
                          (append ('['::[])
                            (append
                              (Decimal.show_lvl_nat O
                                (Level.next (Level.Coq_level (Zpos (XO (XI
                                  (XO XH)))))))
                              (append ('.'::('.'::[]))
                                (append
                                  (Decimal.show_lvl_nat (pred (n_bytes s0))
                                    (Level.next (Level.Coq_level (Zpos (XO
                                      (XI (XO XH))))))) (']'::[]))))))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sfrom_bytes :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sfrom_bytes output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1
     ('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size2 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to2 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to2 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize_with_bytes pipeline_opts
          machine_wordsize0) (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                UnsaturatedSolinas.reified_from_bytes_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ ->
                  Obj.magic
                    (qdiv
                      (inject_Z
                        (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                      (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ ->
                Obj.magic (Zpos
                  (qdiv
                    (inject_Z
                      (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                    (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic s0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3)))
        (Obj.magic ((Some (prime_bytes_bounds s0)), ()))
        (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some (prime_bytes_bounds s0)), ()) in
        let out_bounds1 = Some
          (tight_bounds tight_upperbound_fraction n3 s0 c0)
        in
        let arg_typedefs0 = (None, ()) in
        let out_typedefs0 = Some
          ('t'::('i'::('g'::('h'::('t'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize_with_bytes pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))))
                   (' '::('d'::('e'::('s'::('e'::('r'::('i'::('a'::('l'::('i'::('z'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('f'::('r'::('o'::('m'::(' '::('b'::('y'::('t'::('e'::('s'::(' '::('i'::('n'::(' '::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::(' '::('o'::('r'::('d'::('e'::('r'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append
                        ('b'::('y'::('t'::('e'::('s'::('_'::('e'::('v'::('a'::('l'::(' '::[])))))))))))
                        (fst
                          (Obj.magic
                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))) arg_var_data)))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val reval :
    Coq0_Options.coq_PipelineOptions -> tight_upperbound_fraction_opt -> nat
    -> z -> (z * z) list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
    Compilers.Coq_expr.expr **)

let reval pipeline_opts tight_upperbound_fraction n3 s0 c0 =
  Pipeline.coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects
    pipeline_opts.Coq0_Options.low_level_rewriter_method
    pipeline_opts.Coq0_Options.debug_rewriting n3
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z))))
    (Pipeline.coq_PreBoundsPipeline pipeline_opts.Coq0_Options.absint_opts
      pipeline_opts.Coq0_Options.low_level_rewriter_method
      pipeline_opts.Coq0_Options.only_signed
      pipeline_opts.Coq0_Options.unfold_value_barrier
      default_translate_to_fancy pipeline_opts.Coq0_Options.debug_rewriting
      true false (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z)))))))) (fun _ ->
            UnsaturatedSolinas.reified_eval_gen) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ ->
              Obj.magic
                (qdiv
                  (inject_Z
                    (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                  (inject_Z (Coq_Z.of_nat n3))).qnum))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ ->
            Obj.magic (Zpos
              (qdiv
                (inject_Z
                  (Coq_Z.log2_up (Coq_Z.sub s0 (Associational.eval c0))))
                (inject_Z (Coq_Z.of_nat n3))).qden)))) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (fun _ -> Obj.magic n3)))
      (Obj.magic ((Some (loose_bounds tight_upperbound_fraction n3 s0 c0)),
        ())))

(** val seval :
    Coq0_Options.coq_PipelineOptions -> tight_upperbound_fraction_opt -> nat
    -> z -> (z * z) list -> char list -> char list **)

let seval pipeline_opts tight_upperbound_fraction n3 s0 c0 arg_name =
  show0
    (Obj.magic Coq7_Compilers.ToString.PHOAS.Coq_expr.show_expr
      Coq7_Compilers.Options.PHOAS.default_with_casts
      Coq7_Compilers.Options.PHOAS.default_with_all_casts
      (Compilers.Coq_type.Coq_base
      (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
    (Compilers.Coq_invert_expr.smart_App_curried
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))
      (reval pipeline_opts tight_upperbound_fraction n3 s0 c0)
      (Obj.magic (arg_name, ())))

(** val rbytes_eval :
    Coq0_Options.coq_PipelineOptions -> z -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
    Compilers.Coq_expr.expr **)

let rbytes_eval pipeline_opts s0 =
  Pipeline.coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects
    pipeline_opts.Coq0_Options.low_level_rewriter_method
    pipeline_opts.Coq0_Options.debug_rewriting (n_bytes s0)
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z))))
    (Pipeline.coq_PreBoundsPipeline pipeline_opts.Coq0_Options.absint_opts
      pipeline_opts.Coq0_Options.low_level_rewriter_method
      pipeline_opts.Coq0_Options.only_signed
      pipeline_opts.Coq0_Options.unfold_value_barrier
      default_translate_to_fancy pipeline_opts.Coq0_Options.debug_rewriting
      true false (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
        (fun _ -> UnsaturatedSolinas.reified_bytes_eval_gen) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (fun _ -> Obj.magic s0)))
      (Obj.magic ((Some (prime_bytes_bounds s0)), ())))

(** val sbytes_eval :
    Coq0_Options.coq_PipelineOptions -> z -> char list -> char list **)

let sbytes_eval pipeline_opts s0 arg_name =
  show0
    (Obj.magic Coq7_Compilers.ToString.PHOAS.Coq_expr.show_expr
      Coq7_Compilers.Options.PHOAS.default_with_casts
      Coq7_Compilers.Options.PHOAS.default_with_all_casts
      (Compilers.Coq_type.Coq_base
      (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
    (Compilers.Coq_invert_expr.smart_App_curried
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (rbytes_eval pipeline_opts s0)
      (Obj.magic (arg_name, ())))

(** val sselectznz0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> nat -> machine_wordsize_opt
    -> char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sselectznz0 =
  sselectznz

(** val known_functions0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt ->
    (char list * (char list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list **)

let known_functions0 output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 =
  (('c'::('a'::('r'::('r'::('y'::('_'::('m'::('u'::('l'::[]))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (scarry_mul output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('c'::('a'::('r'::('r'::('y'::('_'::('s'::('q'::('u'::('a'::('r'::('e'::[])))))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (scarry_square output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('c'::('a'::('r'::('r'::('y'::[]))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (scarry output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('a'::('d'::('d'::[]))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (sadd output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('s'::('u'::('b'::[]))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (ssub output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('o'::('p'::('p'::[]))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sopp output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('c'::('a'::('r'::('r'::('y'::('_'::('a'::('d'::('d'::[]))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (scarry_add output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('c'::('a'::('r'::('r'::('y'::('_'::('s'::('u'::('b'::[]))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (scarry_sub output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('c'::('a'::('r'::('r'::('y'::('_'::('o'::('p'::('p'::[]))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (scarry_opp output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('r'::('e'::('l'::('a'::('x'::[]))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (srelax output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('s'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::[]))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    (sselectznz0 output_language_api pipeline_opts pipeline_to_string_opts n3
      machine_wordsize0 s1)))) :: ((('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[])))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sto_bytes output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: ((('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[])))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sfrom_bytes output_language_api pipeline_opts pipeline_to_string_opts
      tight_upperbound_fraction n3 s0 c0 machine_wordsize0 s1)))) :: []))))))))))))

(** val valid_names0 : char list **)

let valid_names0 =
  'c'::('a'::('r'::('r'::('y'::('_'::('m'::('u'::('l'::(','::(' '::('c'::('a'::('r'::('r'::('y'::('_'::('s'::('q'::('u'::('a'::('r'::('e'::(','::(' '::('c'::('a'::('r'::('r'::('y'::(','::(' '::('a'::('d'::('d'::(','::(' '::('s'::('u'::('b'::(','::(' '::('o'::('p'::('p'::(','::(' '::('c'::('a'::('r'::('r'::('y'::('_'::('a'::('d'::('d'::(','::(' '::('c'::('a'::('r'::('r'::('y'::('_'::('s'::('u'::('b'::(','::(' '::('c'::('a'::('r'::('r'::('y'::('_'::('o'::('p'::('p'::(','::(' '::('r'::('e'::('l'::('a'::('x'::(','::(' '::('s'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::(','::(' '::('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::(','::(' '::('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::(','::(' '::('o'::('r'::(' '::('\''::('c'::('a'::('r'::('r'::('y'::('_'::('s'::('c'::('m'::('u'::('l'::('\''::(' '::('f'::('o'::('l'::('l'::('o'::('w'::('e'::('d'::(' '::('b'::('y'::(' '::('a'::(' '::('d'::('e'::('c'::('i'::('m'::('a'::('l'::(' '::('l'::('i'::('t'::('e'::('r'::('a'::('l'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val extra_special_synthesis :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> tight_upperbound_fraction_opt
    -> nat -> z -> (z * z) list -> machine_wordsize_opt -> char list ->
    char list -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type, char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM) sigT option list **)

let extra_special_synthesis output_language_api pipeline_opts pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 function_name_prefix name0 =
  (if prefix
        ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('c'::('m'::('u'::('l'::[])))))))))))
        name0
   then let sc =
          substring
            (length0
              ('c'::('a'::('r'::('r'::('y'::('_'::('s'::('c'::('m'::('u'::('l'::[]))))))))))))
            (length0 name0) name0
        in
        bind1 (Coq0_Z.of_string sc) (fun scZ ->
          if eqb0 sc (Coq0_Z.to_string scZ)
          then Some (ExistT ((Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Z))))),
                 (scarry_scmul_const output_language_api pipeline_opts
                   pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0
                   machine_wordsize0 function_name_prefix scZ)))
          else None)
   else None) :: []

(** val synthesize1 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> tight_upperbound_fraction_opt -> nat
    -> z -> (z * z) list -> machine_wordsize_opt -> char list list ->
    char list -> char list list ->
    ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

let synthesize1 output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts tight_upperbound_fraction n3 s0 c0 machine_wordsize0 comment_header function_name_prefix requests =
  synthesize output_language_api pipeline_opts pipeline_to_string_opts
    synthesis_opts machine_wordsize0 valid_names0
    (known_functions0 output_language_api pipeline_opts
      pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0
      machine_wordsize0)
    (extra_special_synthesis output_language_api pipeline_opts
      pipeline_to_string_opts tight_upperbound_fraction n3 s0 c0
      machine_wordsize0 function_name_prefix)
    ((typedef_info_of_typedef (fun r0 ->
       sequence_return0
         (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
           (possible_values_of_machine_wordsize_with_bytes pipeline_opts
             (machine_wordsize machine_wordsize0)) r0) r0)
       (Compilers.Coq_base.Coq_type.Coq_list
       (Coq5_Compilers.Coercions.type_base Coq3_Compilers.Z))
       (Obj.magic (Some (tight_bounds tight_upperbound_fraction n3 s0 c0)))
       (tight_bounds_typedef pipeline_to_string_opts
         tight_upperbound_fraction n3 s0 c0)) :: ((typedef_info_of_typedef
                                                    (fun r0 ->
                                                    sequence_return0
                                                      (relax_zrange_gen
                                                        pipeline_opts.Coq0_Options.only_signed
                                                        (possible_values_of_machine_wordsize_with_bytes
                                                          pipeline_opts
                                                          (machine_wordsize
                                                            machine_wordsize0))
                                                        r0) r0)
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Coq5_Compilers.Coercions.type_base
                                                      Coq3_Compilers.Z))
                                                    (Obj.magic (Some
                                                      (loose_bounds
                                                        tight_upperbound_fraction
                                                        n3 s0 c0)))
                                                    (loose_bounds_typedef
                                                      pipeline_to_string_opts
                                                      tight_upperbound_fraction
                                                      n3 s0 c0)) :: []))
    (check_args0 tight_upperbound_fraction n3 s0 c0 machine_wordsize0)
    (output_language_api.Coq7_Compilers.ToString.comment_file_header_block
      (app comment_header
        (app
          ([] :: (('C'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::[])))))))))))))))) :: []))
          (map (fun s1 -> append (' '::(' '::[])) s1)
            (app
              (Coq7_Compilers.ToString.prefix_and_indent
                ('c'::('a'::('r'::('r'::('y'::('_'::('c'::('h'::('a'::('i'::('n'::(' '::('='::(' '::[]))))))))))))))
                ((show0
                   (show_of_ShowLevel (show_lvl_list Decimal.show_lvl_nat))
                   (idxs n3 s0 c0)) :: []))
              (app
                (Coq7_Compilers.ToString.prefix_and_indent
                  ('e'::('v'::('a'::('l'::(' '::('z'::(' '::('='::(' '::[])))))))))
                  ((seval pipeline_opts tight_upperbound_fraction n3 s0 c0
                     ('z'::[])) :: []))
                (app
                  (Coq7_Compilers.ToString.prefix_and_indent
                    ('b'::('y'::('t'::('e'::('s'::('_'::('e'::('v'::('a'::('l'::(' '::('z'::(' '::('='::(' '::[])))))))))))))))
                    ((sbytes_eval pipeline_opts s0 ('z'::[])) :: []))
                  (Coq7_Compilers.ToString.prefix_and_indent
                    ('b'::('a'::('l'::('a'::('n'::('c'::('e'::(' '::('='::(' '::[]))))))))))
                    ((show0
                       (show_of_ShowLevel (show_lvl_list Hex.show_lvl_Z))
                       (balance tight_upperbound_fraction n3 s0 c0)) :: [])))))))))
    function_name_prefix requests

module Coq2_Z =
 struct
  (** val egcd_by_wf_step :
      z -> (z -> __ -> z -> ((z * z) * z) option) -> z -> ((z * z) * z) option **)

  let egcd_by_wf_step a egcd b =
    (if Coq_Z.ltb Z0 a
     then (fun _ ->
            match egcd (Coq_Z.modulo b a) __ a with
            | Some p ->
              let (p0, x) = p in
              let (g, y) = p0 in
              Some ((g, (Coq_Z.sub x (Coq_Z.mul (Coq_Z.div b a) y))), y)
            | None -> None)
     else (fun _ ->
            if Coq_Z.eqb a Z0 then Some ((b, Z0), (Zpos XH)) else None)) __

  (** val egcd_by_wf : z -> z -> ((z * z) * z) option **)

  let egcd_by_wf a b =
    let rec fix_F x _ =
      egcd_by_wf_step x (fun y _ -> fix_F y __)
    in fix_F a __ b

  (** val modinv_of_egcd :
      (z -> z -> ((z * z) * z) option) -> z -> z -> z option **)

  let modinv_of_egcd egcd a m4 =
    if Coq_Z.ltb a Z0
    then (match egcd (Coq_Z.opp a) m4 with
          | Some p ->
            let (p0, _) = p in
            let (g, x) = p0 in
            if negb (Coq_Z.eqb g (Zpos XH))
            then None
            else Some (Coq_Z.modulo (Coq_Z.opp x) m4)
          | None -> None)
    else (match egcd a m4 with
          | Some p ->
            let (p0, _) = p in
            let (g, x) = p0 in
            if negb (Coq_Z.eqb g (Zpos XH))
            then None
            else Some (Coq_Z.modulo x m4)
          | None -> None)

  (** val modinv_by_wf : z -> z -> z option **)

  let modinv_by_wf a m4 =
    modinv_of_egcd egcd_by_wf a m4

  (** val modinv_opt : z -> z -> z option **)

  let modinv_opt =
    modinv_by_wf

  (** val modinv : z -> z -> z **)

  let modinv a m4 =
    sequence_return (modinv_opt a m4) Z0
 end

module Coq3_Z =
 struct
  (** val modexp_pos : z -> positive -> z -> z **)

  let modexp_pos a p m4 =
    Coq_Pos.iter (fun z0 -> Coq_Z.modulo (Coq_Z.mul a z0) m4)
      (Coq_Z.modulo (Zpos XH) m4) p

  (** val modexp : z -> z -> z -> z **)

  let modexp a p m4 =
    match p with
    | Z0 -> Coq_Z.modulo (Zpos XH) m4
    | Zpos p0 -> modexp_pos a p0 m4
    | Zneg _ -> Z0
 end

module WordByWordMontgomery =
 struct
  (** val reified_mul_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_mul_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v36 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v36)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m'0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun conditional_sub ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v29)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun zero1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v33)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun count -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun count' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun redc_loop_count' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      redc_loop_count')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count')))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun pred_A_numlimbs -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun pat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s')))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pat)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun divmod ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun scmul0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun addT ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun drop_high_addT' ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun pred_A_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (fun a_a -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a' -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (fun s1 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s1)))))), (fun s2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (fun q0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      drop_high_addT')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), q0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))), (fun s3 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s3)))))), (fun s4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s4)))))))))))))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v31 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v31)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v31 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v31)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v29 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v28)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v29)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v19)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v22)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v21)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v13)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v14)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v15)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v4)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v3)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v4)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v3)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_add_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_add_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v16 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v16)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun lgr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun addT -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun conditional_sub -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun r_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v15 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v15)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v9)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v13 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v13)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v5)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_sub_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_sub_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v14)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun lgr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun r0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun r_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sub_then_maybe_add -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      sub_then_maybe_add)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v12)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun q0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p_minus_q -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun rr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun res -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun c' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      res)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p_minus_q)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      rr)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v9)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v5)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_opp_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_opp_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v5 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v6 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v7 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v8 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v9 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v10 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v11 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v12 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v13 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v14 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v15 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v15)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun lgr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun zero1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun r_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v12)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun lgr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun r0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun r_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sub_then_maybe_add -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      sub_then_maybe_add)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v12)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun q0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p_minus_q -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun rr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun res -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun c' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      res)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v11)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p_minus_q)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      rr)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v9)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v5)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_to_bytes_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_to_bytes_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v5 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v6 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v7 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v8 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v9 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v10 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v11 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v12 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v13 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v14 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v15 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v16 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v16)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2_up)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v14)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v14 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v14)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun sw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun dw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun dn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_flattened -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r1 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), r1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_assoc)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), sw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v10)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun digit -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun fw -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun sum_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun digit -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun tl1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun flatten_column_tl -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun y -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun tl'0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      flatten_column_tl)), (fun rec0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun sum_carry -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun carry' -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry')))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl'0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl1)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      n3)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      c0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))),
      (fun sum0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v4)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2_up)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))))))))))

  (** val reified_from_bytes_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_from_bytes_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v15)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v14)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v14 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v14)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun sw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun dw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun dn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_flattened -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r1 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), r1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_assoc)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), sw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v10)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun digit -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun fw -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun sum_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun digit -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun tl1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun flatten_column_tl -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun y -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun tl'0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      flatten_column_tl)), (fun rec0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun sum_carry -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun carry' -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry')))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl'0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl1)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      n3)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      c0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))),
      (fun sum0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v4)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2_up)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))))))))))

  (** val reified_nonzero_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_nonzero_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun v0 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v0)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun a -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun a -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))))))

  (** val reified_eval_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_eval_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v5 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v5)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun bitwidth -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v4)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun lgr -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v3)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v2)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_bytes_eval_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_bytes_eval_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun v6 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v5)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun lgr -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v4)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v3)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun s0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2_up)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO XH))))))))))))))))))

  (** val reified_square_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_square_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v36 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v37 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v37)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v36)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m'0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun conditional_sub ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v29)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun zero1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v33)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun count -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun count' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun redc_loop_count' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      redc_loop_count')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count')))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun pred_A_numlimbs -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun pat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s')))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pat)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun divmod ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun scmul0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun addT ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun drop_high_addT' ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun pred_A_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (fun a_a -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a' -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (fun s1 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s1)))))), (fun s2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (fun q0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      drop_high_addT')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), q0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))), (fun s3 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s3)))))), (fun s4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s4)))))))))))))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v31 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v31)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v31 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v31)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v6)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v29 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v28)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v29)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v19)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v22)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v21)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v13)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v14)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v15)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v4)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v3)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v2)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v4)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v3)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_encode_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_encode_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v36 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v37 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v38 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v39 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v39)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v39 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v38)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      v39)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v38 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v37)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v38)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v36)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m'0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun conditional_sub ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v31)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun zero1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun count -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun count' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun redc_loop_count' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      redc_loop_count')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v33)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count')))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun pred_A_numlimbs -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun pat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s')))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pat)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun divmod ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun scmul0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun addT ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun drop_high_addT' ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun pred_A_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (fun a_a -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a' -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (fun s1 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s1)))))), (fun s2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (fun q0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      drop_high_addT')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), q0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))), (fun s3 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s3)))))), (fun s4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s4)))))))))))))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v30 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v30)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v18)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_from_montgomery_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_from_montgomery_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v36 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v37 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v38 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v38)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v38 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v37)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v38)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v36)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m'0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun conditional_sub ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v31)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun zero1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun count -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun count' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun redc_loop_count' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      redc_loop_count')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v33)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count')))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun pred_A_numlimbs -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun pat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s')))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pat)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun divmod ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun scmul0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun addT ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun drop_high_addT' ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun pred_A_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (fun a_a -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a' -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (fun s1 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s1)))))), (fun s2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (fun q0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      drop_high_addT')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), q0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))), (fun s3 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s3)))))), (fun s4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s4)))))))))))))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v30 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v30)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v18)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_to_montgomery_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_to_montgomery_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v36 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v37 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v38 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v38)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v38 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v37)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v38)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v36)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m'0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun conditional_sub ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v31)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun zero1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun count -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun count' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun redc_loop_count' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      redc_loop_count')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v33)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count')))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun pred_A_numlimbs -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun pat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s')))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pat)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun divmod ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun scmul0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun addT ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun drop_high_addT' ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun pred_A_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (fun a_a -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a' -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (fun s1 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s1)))))), (fun s2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (fun q0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      drop_high_addT')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), q0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))), (fun s3 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s3)))))), (fun s4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s4)))))))))))))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v30 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v30)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v18)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_one_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_one_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v5 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v6 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v7 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v8 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v9 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v10 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v11 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v12 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v13 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v14 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v15 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v16 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v17 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v18 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v19 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v20 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v21 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v22 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v23 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v24 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v25 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v26 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v27 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v28 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v29 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v30 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v31 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v32 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v33 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v34 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v35 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v36 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v37 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v38 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v39 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun v40 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v40)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m'0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v39)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v39 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v38)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      v39)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v38 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v37)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m'0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v38)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun bitwidth -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m'0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v36)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m'0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun conditional_sub ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v31)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v36 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v36)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun zero1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun a_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun k -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v35 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v35)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun count -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun count' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun redc_loop_count' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a_S -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      redc_loop_count')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v33)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count')))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_S)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      count)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v34 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v34)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun pred_A_numlimbs -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun pat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s')))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pat)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v33 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v33)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun r0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun divmod ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun scmul0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun addT ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun drop_high_addT' ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun r_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun pred_A_numlimbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun b -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun k -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      pred_A_numlimbs)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (fun a_a -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a' -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      a_a)))), (fun a0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (fun s1 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s1)))))), (fun s2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), k)))))),
      (fun q0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      drop_high_addT')), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), s1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      scmul0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), q0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))), (fun s3 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      divmod)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s3)))))), (fun s4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      s4)))))))))))))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v27)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v26)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v6)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v30 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v30)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v25)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v18)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v15)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v5)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))
 end

module WordByWordMontgomeryInversion =
 struct
  (** val reified_divstep_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_divstep_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v1 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v2 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v3 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v4 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v5 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v6 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v7 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v8 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v9 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v10 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v11 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v12 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v13 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v14 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v15 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v16 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v17 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v18 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v19 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v20 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v21 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v22 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v23 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v24 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v25 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v26 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v27 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v28 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v29 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v30 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v31 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (fun v32 ->
      Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), v32)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))), (fun machine_wordsize0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun sat_limbs0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun mont_limbs ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun m4 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun d -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun f -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun g -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun v32 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sat_limbs0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      mont_limbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      g)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v32)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun machine_wordsize0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun sat_limbs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun mont_limbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun data -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v31 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun g -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun d -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun f -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      g)))))), (fun cond -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d)))))),
      (fun d' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), g)))),
      (fun f' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), g)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sat_limbs0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))), (fun g' -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v31)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), r0)))),
      (fun v' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v'' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), r0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v27)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      mont_limbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v31)))))), (fun r'0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), g')))),
      (fun g0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun d'' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), g0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v28)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sat_limbs0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f')))),
      (fun f'' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun g'' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), g0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v28)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      mont_limbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), v')))),
      (fun v''' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun r'' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d'')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f')))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      g'')))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v'')))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r'')))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      mont_limbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r'0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v''')))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sat_limbs0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sat_limbs0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), g')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f'')))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_add_get_carry)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d')))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      mont_limbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), v')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v')))))))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p1)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      data)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun machine_wordsize0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_shiftr)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))),
      Coq3_Compilers.Coq_ident_Z_truncating_shiftl)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v29)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun m4 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun a -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lor)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_shiftr)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v26)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun lgr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun zero1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun r_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), n3)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      zero1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v24)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun lgr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun r0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun r_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sub_then_maybe_add -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      sub_then_maybe_add)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), v24)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), r0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), b)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun q0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p_minus_q -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun rr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun res -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun c' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      res)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v13)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p_minus_q)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      rr)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v18)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun mask0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      mask0)))), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_land)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m_enc0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v21)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m_enc0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun lgr -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun addT -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun conditional_sub -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun r_numlimbs -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      conditional_sub)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      addT)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      r_numlimbs)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun arg -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v19)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      arg)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v17)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      n4)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v21 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v21)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      lgr)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun v19 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v19)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v18)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n_in -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n_out -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_out)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n_in)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun machine_wordsize0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v4)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lnot_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), i)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun machine_wordsize0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun f -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun g -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v13)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v6)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      g)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), p)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), q0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v7)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v9)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v5)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))), v3)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun cond -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun if_zero -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun if_nonzero -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun pat -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun p -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun q0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      cond)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), p)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      q0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_zero)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      if_nonzero)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun m4 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun a -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a)))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_shiftr)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), b)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun m4 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun a -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_add_get_carry)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_lnot_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun f -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))))))

  (** val reified_msat_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_msat_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun v -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun v0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun v1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun v2 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v2)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun bitwidth -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v1)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      bitwidth)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_eval_twos_complement_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_eval_twos_complement_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun v5 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v5)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun machine_wordsize0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun f -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v3)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), f)))),
      (fun eval_f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v4)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      eval_f)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun m4 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun a -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_ltb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), a)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), m4)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v2)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))
 end

(** val s : z -> z **)

let s m4 =
  Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2_up m4)

(** val c : z -> z **)

let c m4 =
  Coq_Z.sub (s m4) m4

(** val n1 : z -> machine_wordsize_opt -> nat **)

let n1 m4 machine_wordsize0 =
  Coq_Z.to_nat
    (qceiling
      (qdiv (inject_Z (Coq_Z.log2_up (s m4))) (inject_Z machine_wordsize0)))

(** val sat_limbs : z -> machine_wordsize_opt -> nat **)

let sat_limbs m4 machine_wordsize0 =
  add (n1 m4 machine_wordsize0) (S O)

(** val r : machine_wordsize_opt -> z **)

let r machine_wordsize0 =
  Coq_Z.pow (Zpos (XO XH)) machine_wordsize0

(** val r' : z -> machine_wordsize_opt -> z **)

let r' m4 machine_wordsize0 =
  Coq2_Z.modinv (r machine_wordsize0) m4

(** val m' : z -> machine_wordsize_opt -> z **)

let m' m4 machine_wordsize0 =
  Coq2_Z.modinv (Coq_Z.opp m4) (r machine_wordsize0)

(** val n_bytes0 : z -> nat **)

let n_bytes0 m4 =
  bytes_n (s m4)

(** val divstep_precompmod : z -> z **)

let divstep_precompmod m4 =
  let bits = Coq_Z.add (Coq_Z.log2 m4) (Zpos XH) in
  let i =
    if Coq_Z.ltb bits (Zpos (XO (XI (XI (XI (XO XH))))))
    then Coq_Z.div
           (Coq_Z.add (Coq_Z.mul (Zpos (XI (XO (XO (XO (XI XH)))))) bits)
             (Zpos (XO (XO (XO (XO (XI (XO XH)))))))) (Zpos (XI (XO (XO (XO
           XH)))))
    else Coq_Z.div
           (Coq_Z.add (Coq_Z.mul (Zpos (XI (XO (XO (XO (XI XH)))))) bits)
             (Zpos (XI (XO (XO (XI (XI XH))))))) (Zpos (XI (XO (XO (XO XH)))))
  in
  let k = Coq_Z.div (Coq_Z.add m4 (Zpos XH)) (Zpos (XO XH)) in
  Coq3_Z.modexp k i m4

(** val prime_upperbound_list0 : z -> machine_wordsize_opt -> z list **)

let prime_upperbound_list0 m4 machine_wordsize0 =
  Partition.partition (uweight machine_wordsize0) (n1 m4 machine_wordsize0)
    (Coq_Z.sub (s m4) (Zpos XH))

(** val prime_bytes_upperbound_list0 : z -> z list **)

let prime_bytes_upperbound_list0 m4 =
  Partition.partition (weight (Zpos (XO (XO (XO XH)))) (Zpos XH))
    (n_bytes0 m4) (Coq_Z.sub (s m4) (Zpos XH))

(** val prime_bounds :
    z -> machine_wordsize_opt ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let prime_bounds m4 machine_wordsize0 =
  map (fun v -> Obj.magic (Some { lower = Z0; upper = v }))
    (prime_upperbound_list0 m4 machine_wordsize0)

(** val prime_bytes_bounds0 :
    z -> Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let prime_bytes_bounds0 m4 =
  map (fun v -> Obj.magic (Some { lower = Z0; upper = v }))
    (prime_bytes_upperbound_list0 m4)

(** val divstep_input :
    z -> machine_wordsize_opt -> zrange option * (zrange option list
    option * (zrange option list option * (zrange option list
    option * (zrange option list option * unit)))) **)

let divstep_input m4 machine_wordsize0 =
  ((Some { lower = Z0; upper =
    (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) }),
    ((Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (sat_limbs m4 machine_wordsize0))), ((Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (sat_limbs m4 machine_wordsize0))), ((Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (n1 m4 machine_wordsize0))), ((Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (n1 m4 machine_wordsize0))), ())))))

(** val divstep_output :
    z -> machine_wordsize_opt -> (((zrange option * zrange option list
    option) * zrange option list option) * zrange option list
    option) * zrange option list option **)

let divstep_output m4 machine_wordsize0 =
  (((((Some { lower = Z0; upper =
    (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) }),
    (Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (sat_limbs m4 machine_wordsize0)))), (Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (sat_limbs m4 machine_wordsize0)))), (Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (n1 m4 machine_wordsize0)))), (Some
    (repeat (Some { lower = Z0; upper =
      (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) machine_wordsize0) (Zpos XH)) })
      (n1 m4 machine_wordsize0))))

(** val bounds :
    z -> machine_wordsize_opt ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let bounds m4 machine_wordsize0 =
  saturated_bounds (n1 m4 machine_wordsize0) machine_wordsize0

(** val larger_bounds :
    z -> machine_wordsize_opt ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let larger_bounds m4 machine_wordsize0 =
  saturated_bounds (sat_limbs m4 machine_wordsize0) machine_wordsize0

(** val montgomery_domain_bounds :
    z -> machine_wordsize_opt ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let montgomery_domain_bounds m4 machine_wordsize0 =
  saturated_bounds (n1 m4 machine_wordsize0) machine_wordsize0

(** val non_montgomery_domain_bounds :
    z -> machine_wordsize_opt ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let non_montgomery_domain_bounds m4 machine_wordsize0 =
  saturated_bounds (n1 m4 machine_wordsize0) machine_wordsize0

(** val montgomery_domain_bounds_typedef :
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    Coq_typedef.typedef **)

let montgomery_domain_bounds_typedef pipeline_to_string_opts _ _ =
  { Coq_typedef.name =
    ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))));
    Coq_typedef.description = (fun name0 ->
    append
      (Coq7_Compilers.Options.text_before_type_name
        pipeline_to_string_opts.Coq0_Options.documentation_options)
      (append name0
        (' '::('i'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))) }

(** val non_montgomery_domain_bounds_typedef :
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    Coq_typedef.typedef **)

let non_montgomery_domain_bounds_typedef pipeline_to_string_opts _ _ =
  { Coq_typedef.name =
    ('n'::('o'::('n'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))))));
    Coq_typedef.description = (fun name0 ->
    append
      (Coq7_Compilers.Options.text_before_type_name
        pipeline_to_string_opts.Coq0_Options.documentation_options)
      (append name0
        (' '::('i'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('N'::('O'::('T'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))) }

(** val no_select_size3 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    no_select_size_opt **)

let no_select_size3 pipeline_opts machine_wordsize0 =
  if no_select pipeline_opts.Coq0_Options.no_select
  then Some machine_wordsize0
  else None

(** val split_mul_to3 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_mul_to_opt **)

let split_mul_to3 pipeline_opts machine_wordsize0 =
  if should_split_mul pipeline_opts.Coq0_Options.should_split_mul
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize pipeline_opts
               machine_wordsize0))))
  else None

(** val split_multiret_to3 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_multiret_to_opt **)

let split_multiret_to3 pipeline_opts machine_wordsize0 =
  if should_split_multiret pipeline_opts.Coq0_Options.should_split_multiret
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize pipeline_opts
               machine_wordsize0))))
  else None

(** val check_args1 :
    z -> machine_wordsize_opt -> char list list ->
    (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage,
    'a1) errorT **)

let check_args1 m4 machine_wordsize0 _ res =
  check_args_of_list
    (map (fun v -> (true, v)) (((Coq_Z.ltb (Zpos XH) machine_wordsize0),
      (Pipeline.Value_not_ltZ
      (('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::(' '::('<'::('='::(' '::('1'::[]))))))))))))))))))))),
      (Zpos XH), machine_wordsize0))) :: (((Coq_Z.ltb Z0 (c m4)),
      (Pipeline.Value_not_ltZ
      (('c'::(' '::('\226'::('\137'::('\164'::(' '::('0'::[]))))))), Z0,
      (c m4)))) :: (((Coq_Z.ltb (Zpos XH) m4), (Pipeline.Value_not_ltZ
      (('m'::(' '::('\226'::('\137'::('\164'::(' '::('1'::[]))))))), (Zpos
      XH), m4))) :: (((negb (Nat.eqb (n1 m4 machine_wordsize0) O)),
      (Pipeline.Values_not_provably_distinctZ
      (('n'::(' '::('='::(' '::('0'::[]))))),
      (Coq_Z.of_nat (n1 m4 machine_wordsize0)),
      (Coq_Z.of_nat O)))) :: (((negb (Coq_Z.eqb (r' m4 machine_wordsize0) Z0)),
      (Pipeline.No_modular_inverse
      (('r'::('\226'::('\129'::('\187'::('\194'::('\185'::(' '::('m'::('o'::('d'::(' '::('m'::[])))))))))))),
      (r machine_wordsize0),
      m4))) :: (((Coq_Z.eqb
                   (Coq_Z.modulo
                     (Coq_Z.mul (r machine_wordsize0)
                       (r' m4 machine_wordsize0)) m4) (Zpos XH)),
      (Pipeline.Values_not_provably_equalZ
      (('('::('r'::(' '::('*'::(' '::('r'::('\''::(')'::(' '::('m'::('o'::('d'::(' '::('m'::(' '::('\226'::('\137'::('\160'::(' '::('1'::[])))))))))))))))))))),
      (Coq_Z.modulo
        (Coq_Z.mul (r machine_wordsize0) (r' m4 machine_wordsize0)) m4),
      (Zpos
      XH)))) :: (((Coq_Z.eqb
                    (Coq_Z.modulo (Coq_Z.mul m4 (m' m4 machine_wordsize0))
                      (r machine_wordsize0))
                    (Coq_Z.modulo (Zneg XH) (r machine_wordsize0))),
      (Pipeline.Values_not_provably_equalZ
      (('('::('m'::(' '::('*'::(' '::('m'::('\''::(')'::(' '::('m'::('o'::('d'::(' '::('r'::(' '::('\226'::('\137'::('\160'::(' '::('('::('-'::('1'::(')'::(' '::('m'::('o'::('d'::(' '::('r'::[]))))))))))))))))))))))))))))),
      (Coq_Z.modulo (Coq_Z.mul m4 (m' m4 machine_wordsize0))
        (r machine_wordsize0)),
      (Coq_Z.modulo (Zneg XH) (r machine_wordsize0))))) :: (((Coq_Z.leb
                                                               (s m4)
                                                               (Coq_Z.pow
                                                                 (r
                                                                   machine_wordsize0)
                                                                 (Coq_Z.of_nat
                                                                   (n1 m4
                                                                    machine_wordsize0)))),
      (Pipeline.Value_not_leZ
      (('r'::('^'::('n'::(' '::('\226'::('\137'::('\164'::(' '::('s'::[]))))))))),
      (s m4),
      (Coq_Z.pow (r machine_wordsize0)
        (Coq_Z.of_nat (n1 m4 machine_wordsize0)))))) :: (((Coq_Z.leb 
                                                            (s m4)
                                                            (uweight
                                                              machine_wordsize0
                                                              (n1 m4
                                                                machine_wordsize0))),
      (Pipeline.Value_not_leZ
      (('w'::('e'::('i'::('g'::('h'::('t'::(' '::('n'::(' '::('<'::(' '::('s'::(' '::('('::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[])))))))))))))))))))))))))))))))))))),
      (s m4),
      (uweight machine_wordsize0 (n1 m4 machine_wordsize0))))) :: (((Coq_Z.leb
                                                                    (s m4)
                                                                    (uweight
                                                                    (Zpos (XO
                                                                    (XO (XO
                                                                    XH))))
                                                                    (n_bytes0
                                                                    m4))),
      (Pipeline.Value_not_leZ
      (('b'::('y'::('t'::('e'::('s'::('_'::('w'::('e'::('i'::('g'::('h'::('t'::(' '::('n'::('_'::('b'::('y'::('t'::('e'::('s'::(' '::('<'::(' '::('s'::(' '::('('::('n'::('e'::('e'::('d'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::(')'::[])))))))))))))))))))))))))))))))))))))))))))))))),
      (s m4),
      (uweight (Zpos (XO (XO (XO XH)))) (n_bytes0 m4))))) :: []))))))))))) res

(** val smul0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let smul0 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('m'::('u'::('l'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                WordByWordMontgomery.reified_mul_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
              (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ ->
                Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic m4))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m' m4 machine_wordsize0)))
        (Obj.magic ((Some (montgomery_domain_bounds m4 machine_wordsize0)),
          ((Some (montgomery_domain_bounds m4 machine_wordsize0)), ())))
        (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ()))
        in
        let out_bounds1 = Some (montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
                   (' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (snd
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data)))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))))) out_var_data)))
                            (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (append ('('::[])
                                  (append
                                    (append
                                      ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                      (append (' '::[])
                                        (fst
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data)))) (')'::[])))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (append ('('::[])
                                        (append
                                          (append
                                            ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                            (append (' '::[])
                                              (fst
                                                (snd
                                                  (Obj.magic
                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))))
                                                    arg_var_data)))))
                                          (')'::[]))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: [])))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val ssquare :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let ssquare output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                WordByWordMontgomery.reified_square_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
              (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ ->
                Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic m4))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m' m4 machine_wordsize0)))
        (Obj.magic ((Some (montgomery_domain_bounds m4 machine_wordsize0)),
          ()))
        (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ())
        in
        let out_bounds1 = Some (montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1 ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))
                   (' '::('s'::('q'::('u'::('a'::('r'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))) out_var_data)))
                            (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (append ('('::[])
                                  (append
                                    (append
                                      ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                      (append (' '::[])
                                        (fst
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))
                                            arg_var_data)))) (')'::[])))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (append ('('::[])
                                        (append
                                          (append
                                            ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                            (append (' '::[])
                                              (fst
                                                (Obj.magic
                                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                  (Compilers.Coq_type.Coq_arrow
                                                  ((Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z))),
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)))))
                                                  arg_var_data)))) (')'::[])))))))))
                          (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sadd0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sadd0 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('a'::('d'::('d'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              WordByWordMontgomery.reified_add_gen) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ ->
              Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m4)))
        (Obj.magic ((Some (montgomery_domain_bounds m4 machine_wordsize0)),
          ((Some (montgomery_domain_bounds m4 machine_wordsize0)), ())))
        (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ()))
        in
        let out_bounds1 = Some (montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('a'::('d'::('d'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('a'::('d'::('d'::[])))))
                   (' '::('a'::('d'::('d'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (snd
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data)))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))))) out_var_data)))
                            (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (append ('('::[])
                                  (append
                                    (append
                                      ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                      (append (' '::[])
                                        (fst
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data)))) (')'::[])))))
                            (append (' '::[])
                              (append ('+'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (append ('('::[])
                                        (append
                                          (append
                                            ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                            (append (' '::[])
                                              (fst
                                                (snd
                                                  (Obj.magic
                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))))
                                                    arg_var_data)))))
                                          (')'::[]))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: [])))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val ssub0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let ssub0 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('s'::('u'::('b'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              WordByWordMontgomery.reified_sub_gen) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ ->
              Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m4)))
        (Obj.magic ((Some (montgomery_domain_bounds m4 machine_wordsize0)),
          ((Some (montgomery_domain_bounds m4 machine_wordsize0)), ())))
        (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ()))
        in
        let out_bounds1 = Some (montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ()))
        in
        let out_typedefs0 = Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('s'::('u'::('b'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('s'::('u'::('b'::[])))))
                   (' '::('s'::('u'::('b'::('t'::('r'::('a'::('c'::('t'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (snd
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data)))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))))) out_var_data)))
                            (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (append ('('::[])
                                  (append
                                    (append
                                      ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                      (append (' '::[])
                                        (fst
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data)))) (')'::[])))))
                            (append (' '::[])
                              (append ('-'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (append ('('::[])
                                        (append
                                          (append
                                            ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                            (append (' '::[])
                                              (fst
                                                (snd
                                                  (Obj.magic
                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))),
                                                    (Compilers.Coq_type.Coq_arrow
                                                    ((Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z))),
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z)))))))
                                                    arg_var_data)))))
                                          (')'::[]))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: [])))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sopp0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sopp0 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('o'::('p'::('p'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              WordByWordMontgomery.reified_opp_gen) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ ->
              Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m4)))
        (Obj.magic ((Some (montgomery_domain_bounds m4 machine_wordsize0)),
          ()))
        (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ())
        in
        let out_bounds1 = Some (montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('o'::('p'::('p'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('o'::('p'::('p'::[])))))
                   (' '::('n'::('e'::('g'::('a'::('t'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))) out_var_data)))
                            (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('-'::[])
                        (append ('e'::('v'::('a'::('l'::[]))))
                          (append (' '::[])
                            (append ('('::[])
                              (append
                                (append
                                  ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                  (append (' '::[])
                                    (fst
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))) arg_var_data))))
                                (')'::[]))))))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sfrom_montgomery :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sfrom_montgomery output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1
     ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                WordByWordMontgomery.reified_from_montgomery_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
              (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ ->
                Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic m4))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m' m4 machine_wordsize0)))
        (Obj.magic ((Some (montgomery_domain_bounds m4 machine_wordsize0)),
          ()))
        (Obj.magic (Some (non_montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (montgomery_domain_bounds m4 machine_wordsize0)), ())
        in
        let out_bounds1 = Some
          (non_montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = ((Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('n'::('o'::('n'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))))
                   (' '::('t'::('r'::('a'::('n'::('s'::('l'::('a'::('t'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('o'::('u'::('t'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append
                                    (append ('('::('('::('2'::('^'::[]))))
                                      (append
                                        (Coq0_Z.to_string machine_wordsize0)
                                        (')'::('\226'::('\129'::('\187'::('\194'::('\185'::(' '::('m'::('o'::('d'::(' '::('m'::(')'::[])))))))))))))))
                                    (append []
                                      (append ('^'::[])
                                        (append []
                                          (Decimal.show_lvl_nat
                                            (n1 m4 machine_wordsize0)
                                            (Level.Coq_level (Zpos (XO (XI
                                            (XI (XI XH)))))))))))))))
                          (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sto_montgomery :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sto_montgomery output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1
     ('t'::('o'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                WordByWordMontgomery.reified_to_montgomery_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
              (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ ->
                Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic m4))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m' m4 machine_wordsize0)))
        (Obj.magic ((Some
          (non_montgomery_domain_bounds m4 machine_wordsize0)), ()))
        (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (non_montgomery_domain_bounds m4 machine_wordsize0)), ())
        in
        let out_bounds1 = Some (montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = ((Some
          ('n'::('o'::('n'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))))))),
          ())
        in
        let out_typedefs0 = Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('t'::('o'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('t'::('o'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                   (' '::('t'::('r'::('a'::('n'::('s'::('l'::('a'::('t'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('i'::('n'::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))))) out_var_data)))
                            (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('e'::('v'::('a'::('l'::[]))))
                        (append (' '::[])
                          (fst
                            (Obj.magic
                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))))) arg_var_data))))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val snonzero :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let snonzero output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('n'::('o'::('n'::('z'::('e'::('r'::('o'::[])))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
        (fun _ -> WordByWordMontgomery.reified_nonzero_gen)
        (Obj.magic ((Some (bounds m4 machine_wordsize0)), ()))
        (Obj.magic (Some { lower = Z0; upper =
          (Coq_Z.sub (r machine_wordsize0) (Zpos XH)) }))) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some (bounds m4 machine_wordsize0)), ()) in
        let out_bounds1 = Some { lower = Z0; upper =
          (Coq_Z.sub (r machine_wordsize0) (Zpos XH)) }
        in
        let arg_typedefs0 = (None, ()) in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('n'::('o'::('n'::('z'::('e'::('r'::('o'::[])))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('n'::('o'::('n'::('z'::('e'::('r'::('o'::[])))))))))
                   (' '::('o'::('u'::('t'::('p'::('u'::('t'::('s'::(' '::('a'::(' '::('s'::('i'::('n'::('g'::('l'::('e'::(' '::('n'::('o'::('n'::('-'::('z'::('e'::('r'::('o'::(' '::('w'::('o'::('r'::('d'::(' '::('i'::('f'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('i'::('s'::(' '::('n'::('o'::('n'::('-'::('z'::('e'::('r'::('o'::(' '::('a'::('n'::('d'::(' '::('z'::('e'::('r'::('o'::(' '::('o'::('t'::('h'::('e'::('r'::('w'::('i'::('s'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (Obj.magic
                      Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                      (Compilers.Coq_type.final_codomain
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))))) out_var_data)
                    (append (' '::('='::(' '::[])))
                      (Decimal.show_lvl_Z Z0
                        (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO
                          (XO (XO XH))))))))))))
                  (append (' '::[])
                    (append ('\226'::('\134'::('\148'::[])))
                      (append (' '::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (append ('('::[])
                                  (append
                                    (append
                                      ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                      (append (' '::[])
                                        (fst
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))) arg_var_data))))
                                    (')'::[])))))
                            (append (' '::[])
                              (append ('m'::('o'::('d'::[])))
                                (append (' '::[]) ('m'::[])))))
                          (append (' '::('='::(' '::[])))
                            (Decimal.show_lvl_Z Z0
                              (Level.next (Level.Coq_level (Zpos (XO (XI (XI
                                (XO (XO (XO XH))))))))))))))))) :: ([] :: [])))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
             e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sto_bytes0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sto_bytes0 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize_with_bytes pipeline_opts
          machine_wordsize0) (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              WordByWordMontgomery.reified_to_bytes_gen) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ ->
              Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m4)))
        (Obj.magic ((Some (prime_bounds m4 machine_wordsize0)), ()))
        (Obj.magic (Some (prime_bytes_bounds0 m4)))) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some (prime_bounds m4 machine_wordsize0)), ()) in
        let out_bounds1 = Some (prime_bytes_bounds0 m4) in
        let arg_typedefs0 = (None, ()) in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize_with_bytes pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))
                   (' '::('s'::('e'::('r'::('i'::('a'::('l'::('i'::('z'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('N'::('O'::('T'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::(' '::('t'::('o'::(' '::('b'::('y'::('t'::('e'::('s'::(' '::('i'::('n'::(' '::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::(' '::('o'::('r'::('d'::('e'::('r'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Obj.magic
                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                    (Compilers.Coq_type.final_codomain
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))))) out_var_data)
                  (append (' '::('='::(' '::[])))
                    (append ('m'::('a'::('p'::(' '::[]))))
                      (append
                        (append ('('::[])
                          (append
                            (append ('\206'::('\187'::[]))
                              (append (' '::[])
                                (append ('x'::[])
                                  (append (','::(' '::[]))
                                    (append ('\226'::('\140'::('\138'::[])))
                                      (append
                                        (append
                                          (append ('('::[])
                                            (append
                                              (append
                                                (append ('('::[])
                                                  (append
                                                    (append
                                                      (append
                                                        ('e'::('v'::('a'::('l'::[]))))
                                                        (append (' '::[])
                                                          (fst
                                                            (Obj.magic
                                                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))
                                                              arg_var_data))))
                                                      (append (' '::[])
                                                        (append
                                                          ('m'::('o'::('d'::[])))
                                                          (append (' '::[])
                                                            ('m'::[])))))
                                                    (')'::[])))
                                                (append (' '::[])
                                                  (append
                                                    ('m'::('o'::('d'::[])))
                                                    (append (' '::[])
                                                      (append
                                                        (Decimal.show_lvl_Z
                                                          (Zpos (XO XH))
                                                          (Level.Coq_level
                                                          (Zpos (XI (XO (XI
                                                          (XI XH)))))))
                                                        (append []
                                                          (append ('^'::[])
                                                            (append []
                                                              (append
                                                                ('('::[])
                                                                (append
                                                                  (append
                                                                    (Decimal.show_lvl_Z
                                                                    (Zpos (XO
                                                                    (XO (XO
                                                                    XH))))
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XO (XO
                                                                    (XI (XO
                                                                    XH))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('*'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('('::[])
                                                                    (append
                                                                    (append
                                                                    ('x'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('+'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (Decimal.show_lvl_nat
                                                                    (S O)
                                                                    (Level.Coq_level
                                                                    (Zpos (XI
                                                                    (XO (XO
                                                                    (XO (XI
                                                                    XH))))))))))))
                                                                    (')'::[])))))))
                                                                  (')'::[])))))))))))
                                              (')'::[])))
                                          (append (' '::[])
                                            (append ('/'::[])
                                              (append (' '::[])
                                                (append
                                                  (Decimal.show_lvl_Z (Zpos
                                                    (XO XH)) (Level.Coq_level
                                                    (Zpos (XI (XO (XI (XI
                                                    XH)))))))
                                                  (append []
                                                    (append ('^'::[])
                                                      (append []
                                                        (append ('('::[])
                                                          (append
                                                            (append
                                                              (Decimal.show_lvl_Z
                                                                (Zpos (XO (XO
                                                                (XO XH))))
                                                                (Level.Coq_level
                                                                (Zpos (XO (XO
                                                                (XO (XI (XO
                                                                XH))))))))
                                                              (append
                                                                (' '::[])
                                                                (append
                                                                  ('*'::[])
                                                                  (append
                                                                    (' '::[])
                                                                    ('x'::[])))))
                                                            (')'::[])))))))))))
                                        ('\226'::('\140'::('\139'::[])))))))))
                            (')'::[])))
                        (append (' '::[])
                          (append ('['::[])
                            (append
                              (Decimal.show_lvl_nat O
                                (Level.next (Level.Coq_level (Zpos (XO (XI
                                  (XO XH)))))))
                              (append ('.'::('.'::[]))
                                (append
                                  (Decimal.show_lvl_nat (pred (n_bytes0 m4))
                                    (Level.next (Level.Coq_level (Zpos (XO
                                      (XI (XO XH))))))) (']'::[]))))))))))) :: ([] :: [])))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sfrom_bytes0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sfrom_bytes0 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1
     ('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize_with_bytes pipeline_opts
          machine_wordsize0) (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                WordByWordMontgomery.reified_from_bytes_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
              (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic (Zpos XH)))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic s m4))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ ->
            Obj.magic n1 m4 machine_wordsize0)))
        (Obj.magic ((Some (prime_bytes_bounds0 m4)), ()))
        (Obj.magic (Some (prime_bounds m4 machine_wordsize0)))) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some (prime_bytes_bounds0 m4)), ()) in
        let out_bounds1 = Some (prime_bounds m4 machine_wordsize0) in
        let arg_typedefs0 = (None, ()) in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize_with_bytes pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[]))))))))))))
                   (' '::('d'::('e'::('s'::('e'::('r'::('i'::('a'::('l'::('i'::('z'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('N'::('O'::('T'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::(' '::('f'::('r'::('o'::('m'::(' '::('b'::('y'::('t'::('e'::('s'::(' '::('i'::('n'::(' '::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::(' '::('o'::('r'::('d'::('e'::('r'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append
                            ('b'::('y'::('t'::('e'::('s'::('_'::('e'::('v'::('a'::('l'::[]))))))))))
                            (append (' '::[])
                              (fst
                                (Obj.magic
                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                  (Compilers.Coq_type.Coq_arrow
                                  ((Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))),
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z))))) arg_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append
                        ('b'::('y'::('t'::('e'::('s'::('_'::('e'::('v'::('a'::('l'::(' '::[])))))))))))
                        (fst
                          (Obj.magic
                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))) arg_var_data)))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sone :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sone output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('s'::('e'::('t'::('_'::('o'::('n'::('e'::[])))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))) (fun _ ->
                WordByWordMontgomery.reified_one_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
              (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ ->
                Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic m4))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m' m4 machine_wordsize0))) (Obj.magic ())
        (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = () in
        let out_bounds1 = Some (montgomery_domain_bounds m4 machine_wordsize0)
        in
        let arg_typedefs0 = () in
        let out_typedefs0 = Some
          ('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('_'::('d'::('o'::('m'::('a'::('i'::('n'::('_'::('f'::('i'::('e'::('l'::('d'::('_'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))
        in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('s'::('e'::('t'::('_'::('o'::('n'::('e'::[])))))))))
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            e'0 (fun _ out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('s'::('e'::('t'::('_'::('o'::('n'::('e'::[])))))))))
                   (' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('o'::('n'::('e'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('d'::('o'::('m'::('a'::('i'::('n'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))) out_var_data)))
                            (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (Decimal.show_lvl_Z (Zpos XH) (Level.Coq_level (Zpos
                        (XI (XI (XI (XO (XO XH))))))))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[]) ('m'::[])))))))) :: ((append
                                                                   (' '::(' '::[]))
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val reval0 :
    Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reval0 pipeline_opts m4 machine_wordsize0 =
  Pipeline.coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects
    pipeline_opts.Coq0_Options.low_level_rewriter_method
    pipeline_opts.Coq0_Options.debug_rewriting (n1 m4 machine_wordsize0)
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z))))
    (Pipeline.coq_PreBoundsPipeline pipeline_opts.Coq0_Options.absint_opts
      pipeline_opts.Coq0_Options.low_level_rewriter_method
      pipeline_opts.Coq0_Options.only_signed
      pipeline_opts.Coq0_Options.unfold_value_barrier
      default_translate_to_fancy pipeline_opts.Coq0_Options.debug_rewriting
      true false (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          (fun _ -> WordByWordMontgomery.reified_eval_gen) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (fun _ -> Obj.magic n1 m4 machine_wordsize0)))
      (Obj.magic ((Some (montgomery_domain_bounds m4 machine_wordsize0)), ())))

(** val seval0 :
    Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt ->
    char list -> char list **)

let seval0 pipeline_opts m4 machine_wordsize0 arg_name =
  show0
    (Obj.magic Coq7_Compilers.ToString.PHOAS.Coq_expr.show_expr
      Coq7_Compilers.Options.PHOAS.default_with_casts
      Coq7_Compilers.Options.PHOAS.default_with_all_casts
      (Compilers.Coq_type.Coq_base
      (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
    (Compilers.Coq_invert_expr.smart_App_curried
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (reval0 pipeline_opts m4 machine_wordsize0)
      (Obj.magic (arg_name, ())))

(** val rbytes_eval0 :
    Coq0_Options.coq_PipelineOptions -> z -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, __)
    Compilers.Coq_expr.expr **)

let rbytes_eval0 pipeline_opts m4 =
  Pipeline.coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects
    pipeline_opts.Coq0_Options.low_level_rewriter_method
    pipeline_opts.Coq0_Options.debug_rewriting (n_bytes0 m4)
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z))))
    (Pipeline.coq_PreBoundsPipeline pipeline_opts.Coq0_Options.absint_opts
      pipeline_opts.Coq0_Options.low_level_rewriter_method
      pipeline_opts.Coq0_Options.only_signed
      pipeline_opts.Coq0_Options.unfold_value_barrier
      default_translate_to_fancy pipeline_opts.Coq0_Options.debug_rewriting
      true false (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
        (fun _ -> WordByWordMontgomery.reified_bytes_eval_gen) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (fun _ -> Obj.magic s m4)))
      (Obj.magic ((Some (prime_bytes_bounds0 m4)), ())))

(** val sbytes_eval0 :
    Coq0_Options.coq_PipelineOptions -> z -> char list -> char list **)

let sbytes_eval0 pipeline_opts m4 arg_name =
  show0
    (Obj.magic Coq7_Compilers.ToString.PHOAS.Coq_expr.show_expr
      Coq7_Compilers.Options.PHOAS.default_with_casts
      Coq7_Compilers.Options.PHOAS.default_with_all_casts
      (Compilers.Coq_type.Coq_base
      (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
    (Compilers.Coq_invert_expr.smart_App_curried
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (rbytes_eval0 pipeline_opts m4)
      (Obj.magic (arg_name, ())))

(** val reval_twos_complement :
    Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

let reval_twos_complement pipeline_opts m4 machine_wordsize0 =
  Pipeline.coq_RepeatRewriteAddAssocLeftAndFlattenThunkedRects
    pipeline_opts.Coq0_Options.low_level_rewriter_method
    pipeline_opts.Coq0_Options.debug_rewriting (n1 m4 machine_wordsize0)
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z))))
    (Pipeline.coq_PreBoundsPipeline pipeline_opts.Coq0_Options.absint_opts
      pipeline_opts.Coq0_Options.low_level_rewriter_method
      pipeline_opts.Coq0_Options.only_signed
      pipeline_opts.Coq0_Options.unfold_value_barrier
      default_translate_to_fancy pipeline_opts.Coq0_Options.debug_rewriting
      true false (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))) (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
          (fun _ ->
          WordByWordMontgomeryInversion.reified_eval_twos_complement_gen)
          (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (fun _ -> Obj.magic n1 m4 machine_wordsize0)))
      (Obj.magic ((Some (bounds m4 machine_wordsize0)), ())))

(** val seval_twos_complement :
    Coq0_Options.coq_PipelineOptions -> z -> machine_wordsize_opt ->
    char list -> char list **)

let seval_twos_complement pipeline_opts m4 machine_wordsize0 arg_name =
  show0
    (Obj.magic Coq7_Compilers.ToString.PHOAS.Coq_expr.show_expr
      Coq7_Compilers.Options.PHOAS.default_with_casts
      Coq7_Compilers.Options.PHOAS.default_with_all_casts
      (Compilers.Coq_type.Coq_base
      (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
        ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
    (Compilers.Coq_invert_expr.smart_App_curried
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))
      (reval_twos_complement pipeline_opts m4 machine_wordsize0)
      (Obj.magic (arg_name, ())))

(** val sselectznz1 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sselectznz1 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  sselectznz output_language_api pipeline_opts pipeline_to_string_opts
    (n1 m4 machine_wordsize0) machine_wordsize0 prefix1

(** val smsat :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let smsat output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('m'::('s'::('a'::('t'::[]))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))) (fun _ ->
              WordByWordMontgomeryInversion.reified_msat_gen) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ ->
              Obj.magic sat_limbs m4 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m4))) (Obj.magic ())
        (Obj.magic (Some (larger_bounds m4 machine_wordsize0)))) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = () in
        let out_bounds1 = Some (larger_bounds m4 machine_wordsize0) in
        let arg_typedefs0 = () in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name (append prefix1 ('m'::('s'::('a'::('t'::[]))))))
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            e'0 (fun _ out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1 ('m'::('s'::('a'::('t'::[]))))))
                   (' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::('t'::('h'::('e'::(' '::('s'::('a'::('t'::('u'::('r'::('a'::('t'::('e'::('d'::(' '::('r'::('e'::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('p'::('r'::('i'::('m'::('e'::(' '::('m'::('o'::('d'::('u'::('l'::('u'::('s'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                    (append (' '::[])
                      (Obj.magic
                        Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                        (Compilers.Coq_type.final_codomain
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)))) out_var_data)))
                  (append (' '::('='::(' '::[]))) ('m'::[])))) :: ((append
                                                                    (' '::(' '::[]))
                                                                    (append
                                                                    (Decimal.show_lvl_Z
                                                                    Z0
                                                                    (Level.next
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    (XO
                                                                    XH))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('\226'::('\137'::('\164'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    out_var_data)))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sdivstep_precomp :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sdivstep_precomp output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1
     ('d'::('i'::('v'::('s'::('t'::('e'::('p'::('_'::('p'::('r'::('e'::('c'::('o'::('m'::('p'::[])))))))))))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } true
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))) (fun _ ->
                  WordByWordMontgomery.reified_encode_gen) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
                (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)) (fun _ ->
                  Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic m4))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic m' m4 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic divstep_precompmod m4))) (Obj.magic ())
        (Obj.magic (Some (bounds m4 machine_wordsize0)))) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = () in
        let out_bounds1 = Some (bounds m4 machine_wordsize0) in
        let arg_typedefs0 = () in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('d'::('i'::('v'::('s'::('t'::('e'::('p'::('_'::('p'::('r'::('e'::('c'::('o'::('m'::('p'::[])))))))))))))))))
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
            e'0 (fun _ out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('d'::('i'::('v'::('s'::('t'::('e'::('p'::('_'::('p'::('r'::('e'::('c'::('o'::('m'::('p'::[])))))))))))))))))
                   (' '::('r'::('e'::('t'::('u'::('r'::('n'::('s'::(' '::('t'::('h'::('e'::(' '::('p'::('r'::('e'::('c'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('f'::('o'::('r'::(' '::('B'::('e'::('r'::('n'::('s'::('t'::('e'::('i'::('n'::('-'::('Y'::('a'::('n'::('g'::('-'::('i'::('n'::('v'::('e'::('r'::('s'::('i'::('o'::('n'::(' '::('('::('i'::('n'::(' '::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('f'::('o'::('r'::('m'::(')'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append ('e'::('v'::('a'::('l'::[]))))
                    (append (' '::[])
                      (append ('('::[])
                        (append
                          (append
                            ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                            (append (' '::[])
                              (Obj.magic
                                Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                (Compilers.Coq_type.final_codomain
                                  (Compilers.Coq_type.Coq_base
                                  (Compilers.Coq_base.Coq_type.Coq_list
                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                  Coq3_Compilers.Z)))) out_var_data)))
                          (')'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('\226'::('\140'::('\138'::[])))
                        (append
                          (append
                            (append ('('::[])
                              (append
                                (append ('m'::[])
                                  (append (' '::[])
                                    (append ('-'::[])
                                      (append (' '::[])
                                        (Decimal.show_lvl_Z (Zpos XH)
                                          (Level.Coq_level (Zpos (XI (XO (XO
                                          (XO (XI XH)))))))))))) (')'::[])))
                            (append (' '::[])
                              (append ('/'::[])
                                (append (' '::[])
                                  (Decimal.show_lvl_Z (Zpos (XO XH))
                                    (Level.Coq_level (Zpos (XI (XI (XI (XO
                                    (XO XH))))))))))))
                          ('\226'::('\140'::('\139'::[])))))
                      (append []
                        (append ('^'::[])
                          (append []
                            (append ('('::[])
                              (append
                                (append ('i'::('f'::(' '::[])))
                                  (append
                                    (append
                                      (append
                                        ('\226'::('\140'::('\138'::('l'::('o'::('g'::('2'::(' '::('m'::('\226'::('\140'::('\139'::[]))))))))))))
                                        (append (' '::[])
                                          (append ('+'::[])
                                            (append (' '::[])
                                              (Decimal.show_lvl_Z (Zpos XH)
                                                (Level.Coq_level (Zpos (XI
                                                (XO (XO (XO (XI XH))))))))))))
                                      (append (' '::[])
                                        (append ('<'::[])
                                          (append (' '::[])
                                            (Decimal.show_lvl_Z (Zpos (XO (XI
                                              (XI (XI (XO XH))))))
                                              (Level.next (Level.Coq_level
                                                (Zpos (XO (XI (XI (XO (XO (XO
                                                XH))))))))))))))
                                    (append
                                      (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                                      (append
                                        (append
                                          ('\226'::('\140'::('\138'::[])))
                                          (append
                                            (append
                                              (append ('('::[])
                                                (append
                                                  (append
                                                    (append
                                                      (Decimal.show_lvl_Z
                                                        (Zpos (XI (XO (XO (XO
                                                        (XI XH))))))
                                                        (Level.Coq_level
                                                        (Zpos (XO (XO (XO (XI
                                                        (XO XH))))))))
                                                      (append (' '::[])
                                                        (append ('*'::[])
                                                          (append (' '::[])
                                                            (append ('('::[])
                                                              (append
                                                                (append
                                                                  ('\226'::('\140'::('\138'::('l'::('o'::('g'::('2'::(' '::('m'::('\226'::('\140'::('\139'::[]))))))))))))
                                                                  (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('+'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (Decimal.show_lvl_Z
                                                                    (Zpos XH)
                                                                    (Level.Coq_level
                                                                    (Zpos (XI
                                                                    (XO (XO
                                                                    (XO (XI
                                                                    XH))))))))))))
                                                                (')'::[])))))))
                                                    (append (' '::[])
                                                      (append ('+'::[])
                                                        (append (' '::[])
                                                          (Decimal.show_lvl_Z
                                                            (Zpos (XO (XO (XO
                                                            (XO (XI (XO
                                                            XH)))))))
                                                            (Level.Coq_level
                                                            (Zpos (XI (XO (XO
                                                            (XO (XI XH))))))))))))
                                                  (')'::[])))
                                              (append (' '::[])
                                                (append ('/'::[])
                                                  (append (' '::[])
                                                    (Decimal.show_lvl_Z (Zpos
                                                      (XI (XO (XO (XO XH)))))
                                                      (Level.Coq_level (Zpos
                                                      (XI (XI (XI (XO (XO
                                                      XH))))))))))))
                                            ('\226'::('\140'::('\139'::[])))))
                                        (append
                                          (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                          (append
                                            ('\226'::('\140'::('\138'::[])))
                                            (append
                                              (append
                                                (append ('('::[])
                                                  (append
                                                    (append
                                                      (append
                                                        (Decimal.show_lvl_Z
                                                          (Zpos (XI (XO (XO
                                                          (XO (XI XH))))))
                                                          (Level.Coq_level
                                                          (Zpos (XO (XO (XO
                                                          (XI (XO XH))))))))
                                                        (append (' '::[])
                                                          (append ('*'::[])
                                                            (append (' '::[])
                                                              (append
                                                                ('('::[])
                                                                (append
                                                                  (append
                                                                    ('\226'::('\140'::('\138'::('l'::('o'::('g'::('2'::(' '::('m'::('\226'::('\140'::('\139'::[]))))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('+'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (Decimal.show_lvl_Z
                                                                    (Zpos XH)
                                                                    (Level.Coq_level
                                                                    (Zpos (XI
                                                                    (XO (XO
                                                                    (XO (XI
                                                                    XH))))))))))))
                                                                  (')'::[])))))))
                                                      (append (' '::[])
                                                        (append ('+'::[])
                                                          (append (' '::[])
                                                            (Decimal.show_lvl_Z
                                                              (Zpos (XI (XO
                                                              (XO (XI (XI
                                                              XH))))))
                                                              (Level.Coq_level
                                                              (Zpos (XI (XO
                                                              (XO (XO (XI
                                                              XH))))))))))))
                                                    (')'::[])))
                                                (append (' '::[])
                                                  (append ('/'::[])
                                                    (append (' '::[])
                                                      (Decimal.show_lvl_Z
                                                        (Zpos (XI (XO (XO (XO
                                                        XH)))))
                                                        (Level.Coq_level
                                                        (Zpos (XI (XI (XI (XO
                                                        (XO XH))))))))))))
                                              ('\226'::('\140'::('\139'::[]))))))))))
                                (')'::[])))))))))) :: ((append
                                                         (' '::(' '::[]))
                                                         (append
                                                           (Decimal.show_lvl_Z
                                                             Z0
                                                             (Level.next
                                                               (Level.Coq_level
                                                               (Zpos (XO (XI
                                                               (XI (XO (XO
                                                               (XO XH))))))))))
                                                           (append (' '::[])
                                                             (append
                                                               ('\226'::('\137'::('\164'::[])))
                                                               (append
                                                                 (' '::[])
                                                                 (append
                                                                   (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (Obj.magic
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                    (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))
                                                                    out_var_data)))
                                                                   (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('<'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[])))))))))) :: ([] :: []))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val sdivstep :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sdivstep output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 prefix1 =
  ((append prefix1 ('d'::('i'::('v'::('s'::('t'::('e'::('p'::[])))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        pipeline_opts.Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        pipeline_opts.Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size3 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to3 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to3 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        pipeline_opts.Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        pipeline_opts.Coq0_Options.debug_rewriting } false
        (possible_values_of_machine_wordsize pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_prod
        ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))))))))))))))) (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_prod
          ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Z))))))))))))))) (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)))), (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))))))))))) (fun _ ->
                WordByWordMontgomeryInversion.reified_divstep_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ -> Obj.magic machine_wordsize0)))
              (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ ->
                Obj.magic sat_limbs m4 machine_wordsize0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ ->
              Obj.magic n1 m4 machine_wordsize0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (fun _ -> Obj.magic m4)))
        (Obj.magic divstep_input m4 machine_wordsize0)
        (Obj.magic divstep_output m4 machine_wordsize0)) (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = divstep_input m4 machine_wordsize0 in
        let out_bounds1 = divstep_output m4 machine_wordsize0 in
        let arg_typedefs0 = (None, (None, (None, (None, (None, ()))))) in
        let out_typedefs0 = ((((None, None), None), None), None) in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
            sequence_return0
              (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
                (possible_values_of_machine_wordsize pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
            internal_static1 is_internal' static0 inline' prefix1
            (adjust_name
              (append prefix1
                ('d'::('i'::('v'::('s'::('t'::('e'::('p'::[])))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))))))))) e'0
            (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('d'::('i'::('v'::('s'::('t'::('e'::('p'::[])))))))))
                   (' '::('c'::('o'::('m'::('p'::('u'::('t'::('e'::('s'::(' '::('a'::(' '::('d'::('i'::('v'::('s'::('t'::('e'::('p'::('.'::[])))))))))))))))))))))) :: [])
              ([] :: (('P'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[])))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (snd
                                  (snd
                                    (snd
                                      (Obj.magic
                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))))))))))))))
                                        arg_var_data)))))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (fst
                                (snd
                                  (snd
                                    (snd
                                      (snd
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))))))))))))))
                                          arg_var_data))))))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (fst
                    (fst
                      (fst
                        (fst
                          (Obj.magic
                            Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                            (Compilers.Coq_type.final_codomain
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))),
                              (Compilers.Coq_type.Coq_arrow
                              ((Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))),
                              (Compilers.Coq_type.Coq_base
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z),
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)))),
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)))),
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)))),
                              (Compilers.Coq_base.Coq_type.Coq_list
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z)))))))))))))))) out_var_data)))))
                  (append (' '::('='::(' '::[])))
                    (append ('('::[])
                      (append
                        (append ('i'::('f'::(' '::[])))
                          (append
                            (append
                              (append
                                (Decimal.show_lvl_Z Z0
                                  (Level.next (Level.Coq_level (Zpos (XO (XI
                                    (XI (XO (XO (XO XH))))))))))
                                (append (' '::[])
                                  (append ('<'::[])
                                    (append (' '::[])
                                      (fst
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))))))))))))))
                                          arg_var_data))))))
                              (append (' '::[])
                                (append ('\226'::('\136'::('\167'::[])))
                                  (append (' '::[])
                                    (append
                                      (append ('('::[])
                                        (append
                                          (append
                                            ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                            (append (' '::[])
                                              (fst
                                                (snd
                                                  (snd
                                                    (Obj.magic
                                                      Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                      Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))))))))))))))
                                                      arg_var_data))))))
                                          (')'::[])))
                                      (' '::('i'::('s'::(' '::('o'::('d'::('d'::[]))))))))))))
                            (append
                              (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                              (append
                                (append
                                  (Decimal.show_lvl_Z (Zpos XH)
                                    (Level.Coq_level (Zpos (XO (XI (XO (XO
                                    (XI XH))))))))
                                  (append (' '::[])
                                    (append ('-'::[])
                                      (append (' '::[])
                                        (fst
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                            ((Compilers.Coq_base.Coq_type.Coq_prod
                                            ((Compilers.Coq_base.Coq_type.Coq_prod
                                            ((Compilers.Coq_base.Coq_type.Coq_prod
                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z),
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))),
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))),
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))),
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))))))))))
                                            arg_var_data))))))
                                (append
                                  (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                  (append
                                    (Decimal.show_lvl_Z (Zpos XH)
                                      (Level.Coq_level (Zpos (XO (XI (XO (XO
                                      (XI XH))))))))
                                    (append (' '::[])
                                      (append ('+'::[])
                                        (append (' '::[])
                                          (fst
                                            (Obj.magic
                                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))),
                                              (Compilers.Coq_type.Coq_arrow
                                              ((Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z))),
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z),
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))),
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))),
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))),
                                              (Compilers.Coq_base.Coq_type.Coq_list
                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Z)))))))))))))))
                                              arg_var_data)))))))))))
                        (')'::[])))))) :: ((append (' '::(' '::[]))
                                             (append
                                               (append
                                                 ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                 (append (' '::[])
                                                   (snd
                                                     (fst
                                                       (fst
                                                         (fst
                                                           (Obj.magic
                                                             Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                             (Compilers.Coq_type.final_codomain
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))),
                                                               (Compilers.Coq_type.Coq_arrow
                                                               ((Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))),
                                                               (Compilers.Coq_type.Coq_base
                                                               (Compilers.Coq_base.Coq_type.Coq_prod
                                                               ((Compilers.Coq_base.Coq_type.Coq_prod
                                                               ((Compilers.Coq_base.Coq_type.Coq_prod
                                                               ((Compilers.Coq_base.Coq_type.Coq_prod
                                                               ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z),
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))),
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))),
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z)))),
                                                               (Compilers.Coq_base.Coq_type.Coq_list
                                                               (Compilers.Coq_base.Coq_type.Coq_type_base
                                                               Coq3_Compilers.Z))))))))))))))))
                                                             out_var_data)))))))
                                               (append
                                                 (' '::('='::(' '::[])))
                                                 (append ('('::[])
                                                   (append
                                                     (append
                                                       ('i'::('f'::(' '::[])))
                                                       (append
                                                         (append
                                                           (append
                                                             (Decimal.show_lvl_Z
                                                               Z0
                                                               (Level.next
                                                                 (Level.Coq_level
                                                                 (Zpos (XO
                                                                 (XI (XI (XO
                                                                 (XO (XO
                                                                 XH))))))))))
                                                             (append
                                                               (' '::[])
                                                               (append
                                                                 ('<'::[])
                                                                 (append
                                                                   (' '::[])
                                                                   (fst
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))
                                                           (append (' '::[])
                                                             (append
                                                               ('\226'::('\136'::('\167'::[])))
                                                               (append
                                                                 (' '::[])
                                                                 (append
                                                                   (append
                                                                    ('('::[])
                                                                    (append
                                                                    (append
                                                                    ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (fst
                                                                    (snd
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))
                                                                    (')'::[])))
                                                                   (' '::('i'::('s'::(' '::('o'::('d'::('d'::[]))))))))))))
                                                         (append
                                                           (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                                                           (append
                                                             (append
                                                               ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                               (append
                                                                 (' '::[])
                                                                 (fst
                                                                   (snd
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))
                                                             (append
                                                               (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                                               (append
                                                                 ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                                 (append
                                                                   (' '::[])
                                                                   (fst
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))))))
                                                     (')'::[])))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                    (append (' '::[])
                      (snd
                        (fst
                          (fst
                            (Obj.magic
                              Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                              (Compilers.Coq_type.final_codomain
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_arrow
                                ((Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))),
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_prod
                                ((Compilers.Coq_base.Coq_type.Coq_prod
                                ((Compilers.Coq_base.Coq_type.Coq_prod
                                ((Compilers.Coq_base.Coq_type.Coq_prod
                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z),
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))),
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))),
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))),
                                (Compilers.Coq_base.Coq_type.Coq_list
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z)))))))))))))))) out_var_data))))))
                  (append (' '::('='::(' '::[])))
                    (append ('('::[])
                      (append
                        (append ('i'::('f'::(' '::[])))
                          (append
                            (append
                              (append
                                (Decimal.show_lvl_Z Z0
                                  (Level.next (Level.Coq_level (Zpos (XO (XI
                                    (XI (XO (XO (XO XH))))))))))
                                (append (' '::[])
                                  (append ('<'::[])
                                    (append (' '::[])
                                      (fst
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))))))))))))))
                                          arg_var_data))))))
                              (append (' '::[])
                                (append ('\226'::('\136'::('\167'::[])))
                                  (append (' '::[])
                                    (append
                                      (append ('('::[])
                                        (append
                                          (append
                                            ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                            (append (' '::[])
                                              (fst
                                                (snd
                                                  (snd
                                                    (Obj.magic
                                                      Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                      Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))))))))))))))
                                                      arg_var_data))))))
                                          (')'::[])))
                                      (' '::('i'::('s'::(' '::('o'::('d'::('d'::[]))))))))))))
                            (append
                              (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                              (append
                                (append ('\226'::('\140'::('\138'::[])))
                                  (append
                                    (append
                                      (append ('('::[])
                                        (append
                                          (append
                                            (append
                                              ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                              (append (' '::[])
                                                (fst
                                                  (snd
                                                    (snd
                                                      (Obj.magic
                                                        Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                        Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_type.Coq_arrow
                                                        ((Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z))),
                                                        (Compilers.Coq_type.Coq_base
                                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z),
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))),
                                                        (Compilers.Coq_base.Coq_type.Coq_list
                                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                                        Coq3_Compilers.Z)))))))))))))))
                                                        arg_var_data))))))
                                            (append (' '::[])
                                              (append ('-'::[])
                                                (append (' '::[])
                                                  (append
                                                    ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                    (append (' '::[])
                                                      (fst
                                                        (snd
                                                          (Obj.magic
                                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_type.Coq_arrow
                                                            ((Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z))),
                                                            (Compilers.Coq_type.Coq_base
                                                            (Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_prod
                                                            ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))),
                                                            (Compilers.Coq_base.Coq_type.Coq_list
                                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                                            Coq3_Compilers.Z)))))))))))))))
                                                            arg_var_data)))))))))
                                          (')'::[])))
                                      (append (' '::[])
                                        (append ('/'::[])
                                          (append (' '::[])
                                            (Decimal.show_lvl_Z (Zpos (XO
                                              XH)) (Level.Coq_level (Zpos (XI
                                              (XI (XI (XO (XO XH))))))))))))
                                    ('\226'::('\140'::('\139'::[])))))
                                (append
                                  (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                  (append ('\226'::('\140'::('\138'::[])))
                                    (append
                                      (append
                                        (append ('('::[])
                                          (append
                                            (append
                                              (append
                                                ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                (append (' '::[])
                                                  (fst
                                                    (snd
                                                      (snd
                                                        (Obj.magic
                                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))),
                                                          (Compilers.Coq_type.Coq_arrow
                                                          ((Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z))),
                                                          (Compilers.Coq_type.Coq_base
                                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z),
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)))),
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)))),
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)))),
                                                          (Compilers.Coq_base.Coq_type.Coq_list
                                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                                          Coq3_Compilers.Z)))))))))))))))
                                                          arg_var_data))))))
                                              (append (' '::[])
                                                (append ('+'::[])
                                                  (append (' '::[])
                                                    (append
                                                      (append ('('::[])
                                                        (append
                                                          (append
                                                            (append
                                                              ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                              (append
                                                                (' '::[])
                                                                (fst
                                                                  (snd
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))
                                                            (append (' '::[])
                                                              (append
                                                                ('m'::('o'::('d'::[])))
                                                                (append
                                                                  (' '::[])
                                                                  (Decimal.show_lvl_Z
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Level.Coq_level
                                                                    (Zpos (XI
                                                                    (XI (XI
                                                                    (XO (XO
                                                                    XH))))))))))))
                                                          (')'::[])))
                                                      (append (' '::[])
                                                        (append ('*'::[])
                                                          (append (' '::[])
                                                            (append
                                                              ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                              (append
                                                                (' '::[])
                                                                (fst
                                                                  (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data)))))))))))))
                                            (')'::[])))
                                        (append (' '::[])
                                          (append ('/'::[])
                                            (append (' '::[])
                                              (Decimal.show_lvl_Z (Zpos (XO
                                                XH)) (Level.Coq_level (Zpos
                                                (XI (XI (XI (XO (XO XH))))))))))))
                                      ('\226'::('\140'::('\139'::[]))))))))))
                        (')'::[])))))) :: ((append (' '::(' '::[]))
                                             (append
                                               (append
                                                 (append
                                                   ('e'::('v'::('a'::('l'::[]))))
                                                   (append (' '::[])
                                                     (append ('('::[])
                                                       (append
                                                         (append
                                                           ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                                           (append (' '::[])
                                                             (snd
                                                               (fst
                                                                 (Obj.magic
                                                                   Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                                   (Compilers.Coq_type.final_codomain
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))))))
                                                                   out_var_data)))))
                                                         (')'::[])))))
                                                 (append (' '::[])
                                                   (append
                                                     ('m'::('o'::('d'::[])))
                                                     (append (' '::[])
                                                       ('m'::[])))))
                                               (append
                                                 (' '::('='::(' '::[])))
                                                 (append ('('::[])
                                                   (append
                                                     (append
                                                       ('i'::('f'::(' '::[])))
                                                       (append
                                                         (append
                                                           (append
                                                             (Decimal.show_lvl_Z
                                                               Z0
                                                               (Level.next
                                                                 (Level.Coq_level
                                                                 (Zpos (XO
                                                                 (XI (XI (XO
                                                                 (XO (XO
                                                                 XH))))))))))
                                                             (append
                                                               (' '::[])
                                                               (append
                                                                 ('<'::[])
                                                                 (append
                                                                   (' '::[])
                                                                   (fst
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))
                                                           (append (' '::[])
                                                             (append
                                                               ('\226'::('\136'::('\167'::[])))
                                                               (append
                                                                 (' '::[])
                                                                 (append
                                                                   (append
                                                                    ('('::[])
                                                                    (append
                                                                    (append
                                                                    ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (fst
                                                                    (snd
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))
                                                                    (')'::[])))
                                                                   (' '::('i'::('s'::(' '::('o'::('d'::('d'::[]))))))))))))
                                                         (append
                                                           (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                                                           (append
                                                             (append
                                                               (append
                                                                 ('('::[])
                                                                 (append
                                                                   (append
                                                                    (Decimal.show_lvl_Z
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XO (XO
                                                                    (XI (XO
                                                                    XH))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('*'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('('::[])
                                                                    (append
                                                                    (append
                                                                    ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (fst
                                                                    (snd
                                                                    (snd
                                                                    (snd
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))))
                                                                    (')'::[])))))))))
                                                                   (')'::[])))
                                                               (append
                                                                 (' '::[])
                                                                 (append
                                                                   ('m'::('o'::('d'::[])))
                                                                   (append
                                                                    (' '::[])
                                                                    ('m'::[])))))
                                                             (append
                                                               (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                                               (append
                                                                 (append
                                                                   ('('::[])
                                                                   (append
                                                                    (append
                                                                    (Decimal.show_lvl_Z
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Level.Coq_level
                                                                    (Zpos (XO
                                                                    (XO (XO
                                                                    (XI (XO
                                                                    XH))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('*'::[])
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('e'::('v'::('a'::('l'::[]))))
                                                                    (append
                                                                    (' '::[])
                                                                    (append
                                                                    ('('::[])
                                                                    (append
                                                                    (append
                                                                    ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                                                    (append
                                                                    (' '::[])
                                                                    (fst
                                                                    (snd
                                                                    (snd
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data)))))))
                                                                    (')'::[])))))))))
                                                                    (')'::[])))
                                                                 (append
                                                                   (' '::[])
                                                                   (append
                                                                    ('m'::('o'::('d'::[])))
                                                                    (append
                                                                    (' '::[])
                                                                    ('m'::[]))))))))))
                                                     (')'::[])))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (append ('('::[])
                          (append
                            (append
                              ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                              (append (' '::[])
                                (snd
                                  (Obj.magic
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                    (Compilers.Coq_type.final_codomain
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)),
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))),
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))),
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))),
                                      (Compilers.Coq_type.Coq_arrow
                                      ((Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))),
                                      (Compilers.Coq_type.Coq_base
                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z),
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))),
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))),
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z)))),
                                      (Compilers.Coq_base.Coq_type.Coq_list
                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                      Coq3_Compilers.Z))))))))))))))))
                                    out_var_data)))) (')'::[])))))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[]) ('m'::[])))))
                  (append (' '::('='::(' '::[])))
                    (append ('('::[])
                      (append
                        (append ('i'::('f'::(' '::[])))
                          (append
                            (append
                              (append
                                (Decimal.show_lvl_Z Z0
                                  (Level.next (Level.Coq_level (Zpos (XO (XI
                                    (XI (XO (XO (XO XH))))))))))
                                (append (' '::[])
                                  (append ('<'::[])
                                    (append (' '::[])
                                      (fst
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))))))))))))))
                                          arg_var_data))))))
                              (append (' '::[])
                                (append ('\226'::('\136'::('\167'::[])))
                                  (append (' '::[])
                                    (append
                                      (append ('('::[])
                                        (append
                                          (append
                                            ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                            (append (' '::[])
                                              (fst
                                                (snd
                                                  (snd
                                                    (Obj.magic
                                                      Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                      Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_prod
                                                      ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))),
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))))))))))))))
                                                      arg_var_data))))))
                                          (')'::[])))
                                      (' '::('i'::('s'::(' '::('o'::('d'::('d'::[]))))))))))))
                            (append
                              (' '::('t'::('h'::('e'::('n'::(' '::[]))))))
                              (append
                                (append
                                  (append ('('::[])
                                    (append
                                      (append
                                        (append
                                          ('e'::('v'::('a'::('l'::[]))))
                                          (append (' '::[])
                                            (append ('('::[])
                                              (append
                                                (append
                                                  ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                                  (append (' '::[])
                                                    (fst
                                                      (snd
                                                        (snd
                                                          (snd
                                                            (Obj.magic
                                                              Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                              Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))),
                                                              (Compilers.Coq_type.Coq_arrow
                                                              ((Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z))),
                                                              (Compilers.Coq_type.Coq_base
                                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_prod
                                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z),
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))),
                                                              (Compilers.Coq_base.Coq_type.Coq_list
                                                              (Compilers.Coq_base.Coq_type.Coq_type_base
                                                              Coq3_Compilers.Z)))))))))))))))
                                                              arg_var_data)))))))
                                                (')'::[])))))
                                        (append (' '::[])
                                          (append ('-'::[])
                                            (append (' '::[])
                                              (append
                                                ('e'::('v'::('a'::('l'::[]))))
                                                (append (' '::[])
                                                  (append ('('::[])
                                                    (append
                                                      (append
                                                        ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                                        (append (' '::[])
                                                          (fst
                                                            (snd
                                                              (snd
                                                                (snd
                                                                  (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data)))))))
                                                      (')'::[])))))))))
                                      (')'::[])))
                                  (append (' '::[])
                                    (append ('m'::('o'::('d'::[])))
                                      (append (' '::[]) ('m'::[])))))
                                (append
                                  (' '::('e'::('l'::('s'::('e'::(' '::[]))))))
                                  (append
                                    (append ('('::[])
                                      (append
                                        (append
                                          (append
                                            ('e'::('v'::('a'::('l'::[]))))
                                            (append (' '::[])
                                              (append ('('::[])
                                                (append
                                                  (append
                                                    ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                                    (append (' '::[])
                                                      (fst
                                                        (snd
                                                          (snd
                                                            (snd
                                                              (snd
                                                                (Obj.magic
                                                                  Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                  Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))),
                                                                  (Compilers.Coq_type.Coq_arrow
                                                                  ((Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z))),
                                                                  (Compilers.Coq_type.Coq_base
                                                                  (Compilers.Coq_base.Coq_type.Coq_prod
                                                                  ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                  ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                  ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                  ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z),
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))),
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))),
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))),
                                                                  (Compilers.Coq_base.Coq_type.Coq_list
                                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                  Coq3_Compilers.Z)))))))))))))))
                                                                  arg_var_data))))))))
                                                  (')'::[])))))
                                          (append (' '::[])
                                            (append ('+'::[])
                                              (append (' '::[])
                                                (append
                                                  (append ('('::[])
                                                    (append
                                                      (append
                                                        (append
                                                          ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::[]))))))))))))))))))))
                                                          (append (' '::[])
                                                            (fst
                                                              (snd
                                                                (snd
                                                                  (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data))))))
                                                        (append (' '::[])
                                                          (append
                                                            ('m'::('o'::('d'::[])))
                                                            (append (' '::[])
                                                              (Decimal.show_lvl_Z
                                                                (Zpos (XO
                                                                XH))
                                                                (Level.Coq_level
                                                                (Zpos (XI (XI
                                                                (XI (XO (XO
                                                                XH))))))))))))
                                                      (')'::[])))
                                                  (append (' '::[])
                                                    (append ('*'::[])
                                                      (append (' '::[])
                                                        (append
                                                          ('e'::('v'::('a'::('l'::[]))))
                                                          (append (' '::[])
                                                            (append ('('::[])
                                                              (append
                                                                (append
                                                                  ('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[])))))))))))))))
                                                                  (append
                                                                    (' '::[])
                                                                    (fst
                                                                    (snd
                                                                    (snd
                                                                    (snd
                                                                    (Obj.magic
                                                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))))
                                                                    arg_var_data)))))))
                                                                (')'::[])))))))))))))
                                        (')'::[])))
                                    (append (' '::[])
                                      (append ('m'::('o'::('d'::[])))
                                        (append (' '::[]) ('m'::[]))))))))))
                        (')'::[])))))) :: ((append (' '::(' '::[]))
                                             (append
                                               (Decimal.show_lvl_Z Z0
                                                 (Level.next (Level.Coq_level
                                                   (Zpos (XO (XI (XI (XO (XO
                                                   (XO XH))))))))))
                                               (append (' '::[])
                                                 (append
                                                   ('\226'::('\137'::('\164'::[])))
                                                   (append (' '::[])
                                                     (append
                                                       (append
                                                         ('e'::('v'::('a'::('l'::[]))))
                                                         (append (' '::[])
                                                           (snd
                                                             (Obj.magic
                                                               Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                                               (Compilers.Coq_type.final_codomain
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))),
                                                                 (Compilers.Coq_type.Coq_arrow
                                                                 ((Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))),
                                                                 (Compilers.Coq_type.Coq_base
                                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z),
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z)))),
                                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                 Coq3_Compilers.Z))))))))))))))))
                                                               out_var_data))))
                                                       (append (' '::[])
                                                         (append ('<'::[])
                                                           (append (' '::[])
                                                             ('m'::[])))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (snd
                                (Obj.magic
                                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                  (Compilers.Coq_type.final_codomain
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z),
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))),
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))),
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)))),
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))))))))))))
                                  out_var_data))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (snd
                                (fst
                                  (fst
                                    (fst
                                      (Obj.magic
                                        Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                        (Compilers.Coq_type.final_codomain
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_prod
                                          ((Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z)))),
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))))))))))))))
                                        out_var_data)))))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (Decimal.show_lvl_Z Z0
                    (Level.next (Level.Coq_level (Zpos (XO (XI (XI (XO (XO
                      (XO XH))))))))))
                  (append (' '::[])
                    (append ('\226'::('\137'::('\164'::[])))
                      (append (' '::[])
                        (append
                          (append ('e'::('v'::('a'::('l'::[]))))
                            (append (' '::[])
                              (snd
                                (fst
                                  (fst
                                    (Obj.magic
                                      Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                                      (Compilers.Coq_type.final_codomain
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_prod
                                        ((Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))),
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z))))))))))))))))
                                      out_var_data))))))
                          (append (' '::[])
                            (append ('<'::[]) (append (' '::[]) ('m'::[])))))))))) :: ([] :: []))))))))))))))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_base.Coq_type.Coq_prod
             ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))))))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val known_functions1 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> machine_wordsize_opt ->
    (char list * (char list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list **)

let known_functions1 output_language_api pipeline_opts pipeline_to_string_opts m4 machine_wordsize0 =
  (('m'::('u'::('l'::[]))), (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (smul0 output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('s'::('q'::('u'::('a'::('r'::('e'::[])))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (ssquare output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('a'::('d'::('d'::[]))), (fun s0 ->
    ExistT ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (sadd0 output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('s'::('u'::('b'::[]))), (fun s0 ->
    ExistT ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (ssub0 output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('o'::('p'::('p'::[]))), (fun s0 ->
    ExistT ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sopp0 output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[]))))))))))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sfrom_montgomery output_language_api pipeline_opts
      pipeline_to_string_opts m4 machine_wordsize0 s0)))) :: ((('t'::('o'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[]))))))))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sto_montgomery output_language_api pipeline_opts pipeline_to_string_opts
      m4 machine_wordsize0 s0)))) :: ((('n'::('o'::('n'::('z'::('e'::('r'::('o'::[]))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)))),
    (snonzero output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('s'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::[]))))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
    (sselectznz1 output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::[])))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sto_bytes0 output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::[])))))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sfrom_bytes0 output_language_api pipeline_opts pipeline_to_string_opts
      m4 machine_wordsize0 s0)))) :: ((('o'::('n'::('e'::[]))), (fun s0 ->
    ExistT ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (sone output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('m'::('s'::('a'::('t'::[])))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (smsat output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: ((('d'::('i'::('v'::('s'::('t'::('e'::('p'::('_'::('p'::('r'::('e'::('c'::('o'::('m'::('p'::[]))))))))))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (sdivstep_precomp output_language_api pipeline_opts
      pipeline_to_string_opts m4 machine_wordsize0 s0)))) :: ((('d'::('i'::('v'::('s'::('t'::('e'::('p'::[]))))))),
    (fun s0 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_prod
    ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base
    Coq3_Compilers.Z))))))))))))))),
    (sdivstep output_language_api pipeline_opts pipeline_to_string_opts m4
      machine_wordsize0 s0)))) :: []))))))))))))))

(** val valid_names1 : char list **)

let valid_names1 =
  'm'::('u'::('l'::(','::(' '::('s'::('q'::('u'::('a'::('r'::('e'::(','::(' '::('a'::('d'::('d'::(','::(' '::('s'::('u'::('b'::(','::(' '::('o'::('p'::('p'::(','::(' '::('f'::('r'::('o'::('m'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(','::(' '::('t'::('o'::('_'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(','::(' '::('n'::('o'::('n'::('z'::('e'::('r'::('o'::(','::(' '::('s'::('e'::('l'::('e'::('c'::('t'::('z'::('n'::('z'::(','::(' '::('t'::('o'::('_'::('b'::('y'::('t'::('e'::('s'::(','::(' '::('f'::('r'::('o'::('m'::('_'::('b'::('y'::('t'::('e'::('s'::(','::(' '::('o'::('n'::('e'::(','::(' '::('m'::('s'::('a'::('t'::(','::(' '::('d'::('i'::('v'::('s'::('t'::('e'::('p'::('_'::('p'::('r'::('e'::('c'::('o'::('m'::('p'::(','::(' '::('d'::('i'::('v'::('s'::('t'::('e'::('p'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val synthesize2 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> z -> machine_wordsize_opt ->
    char list list -> char list -> char list list ->
    ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

let synthesize2 output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts m4 machine_wordsize0 comment_header function_name_prefix requests =
  synthesize output_language_api pipeline_opts pipeline_to_string_opts
    synthesis_opts machine_wordsize0 valid_names1
    (known_functions1 output_language_api pipeline_opts
      pipeline_to_string_opts m4 machine_wordsize0) (fun _ -> [])
    ((typedef_info_of_typedef (fun r0 ->
       sequence_return0
         (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
           (possible_values_of_machine_wordsize_with_bytes pipeline_opts
             (machine_wordsize machine_wordsize0)) r0) r0)
       (Compilers.Coq_base.Coq_type.Coq_list
       (Coq5_Compilers.Coercions.type_base Coq3_Compilers.Z))
       (Obj.magic (Some (montgomery_domain_bounds m4 machine_wordsize0)))
       (montgomery_domain_bounds_typedef pipeline_to_string_opts m4
         machine_wordsize0)) :: ((typedef_info_of_typedef (fun r0 ->
                                   sequence_return0
                                     (relax_zrange_gen
                                       pipeline_opts.Coq0_Options.only_signed
                                       (possible_values_of_machine_wordsize_with_bytes
                                         pipeline_opts
                                         (machine_wordsize machine_wordsize0))
                                       r0) r0)
                                   (Compilers.Coq_base.Coq_type.Coq_list
                                   (Coq5_Compilers.Coercions.type_base
                                     Coq3_Compilers.Z))
                                   (Obj.magic (Some
                                     (non_montgomery_domain_bounds m4
                                       machine_wordsize0)))
                                   (non_montgomery_domain_bounds_typedef
                                     pipeline_to_string_opts m4
                                     machine_wordsize0)) :: []))
    (check_args1 m4 machine_wordsize0)
    (output_language_api.Coq7_Compilers.ToString.comment_file_header_block
      (app comment_header
        (app
          ([] :: (('C'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::[])))))))))))))))) :: []))
          (map (fun s0 -> append (' '::(' '::[])) s0)
            (app
              (Coq7_Compilers.ToString.prefix_and_indent
                ('e'::('v'::('a'::('l'::(' '::('z'::(' '::('='::(' '::[])))))))))
                ((seval0 pipeline_opts m4 machine_wordsize0 ('z'::[])) :: []))
              (app
                (Coq7_Compilers.ToString.prefix_and_indent
                  ('b'::('y'::('t'::('e'::('s'::('_'::('e'::('v'::('a'::('l'::(' '::('z'::(' '::('='::(' '::[])))))))))))))))
                  ((sbytes_eval0 pipeline_opts m4 ('z'::[])) :: []))
                (Coq7_Compilers.ToString.prefix_and_indent
                  ('t'::('w'::('o'::('s'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('_'::('e'::('v'::('a'::('l'::(' '::('z'::(' '::('='::(' '::[])))))))))))))))))))))))))
                  ((seval_twos_complement pipeline_opts m4 machine_wordsize0
                     ('z'::[])) :: [])))))))) function_name_prefix requests

module BaseConversion =
 struct
  (** val reified_convert_bases_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_convert_bases_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v14 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v14)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun src_limbwidth_num ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun src_limbwidth_den ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun dst_limbwidth_num -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun dst_limbwidth_den -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun src_n -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun dst_n -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun f -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v13)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      src_limbwidth_num)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      src_limbwidth_den)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      dst_limbwidth_num)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      dst_limbwidth_den)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      src_n)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dst_n)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      f)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun src_limbwidth_num ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun src_limbwidth_den ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun dst_limbwidth_num -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun dst_limbwidth_den -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun src_n -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun dst_n -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun v13 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v12)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      src_limbwidth_num)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      src_limbwidth_den)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      dst_limbwidth_num)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      dst_limbwidth_den)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      src_n)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dst_n)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      v13)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun sw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun dw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun sn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun dn -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_cols0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_flattened -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r1 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), r1)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v11)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      r0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_flattened)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v6)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p_cols)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), dw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      dn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_assoc)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), sw)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      sn)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), v9)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))), a)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun digit -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun acc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun fw -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v8)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (fun sum_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      acc)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      acc_carry)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun add_split -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun digit -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun tl1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun flatten_column_tl -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun y -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun tl'0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      flatten_column_tl)), (fun rec0 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      add_split)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun sum_carry -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      rec0)))))), (fun carry' -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      carry')))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl'0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      tl1)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      digit)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      n3)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      c0)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun y -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), y)))),
      (fun sum0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      sum0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v3)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))
 end

type bounds0 =
| Exactly of z list
| Use_prime
| Use_bitwidth

(** val show_bounds : bounds0 show **)

let show_bounds = function
| Exactly l -> show_list PowersOfTwo.show_Z l
| Use_prime -> 'u'::('s'::('e'::('_'::('p'::('r'::('i'::('m'::('e'::[]))))))))
| Use_bitwidth ->
  'u'::('s'::('e'::('_'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::[])))))))))))

(** val in_bounds :
    z -> nat -> q -> q option -> bounds0 ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let in_bounds s0 src_n src_limbwidth inbounds_multiplier inbounds =
  let in_upperbounds =
    map (fun v ->
      qceiling
        (qmult (sequence_return0 inbounds_multiplier (inject_Z (Zpos XH)))
          (inject_Z v)))
      (let encode0 =
         Partition.partition
           (weight src_limbwidth.qnum (Zpos src_limbwidth.qden)) src_n
       in
       match inbounds with
       | Exactly l -> l
       | Use_prime -> encode0 (Coq_Z.sub s0 (Zpos XH))
       | Use_bitwidth ->
         encode0
           (Coq_Z.sub
             (weight src_limbwidth.qnum (Zpos src_limbwidth.qden) src_n)
             (Zpos XH)))
  in
  map (fun u -> Obj.magic (Some { lower = Z0; upper = u })) in_upperbounds

(** val out_bounds0 :
    z -> nat -> q -> q -> q option -> bounds0 ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let out_bounds0 s0 src_n src_limbwidth dst_limbwidth outbounds_multiplier outbounds =
  let dst_n =
    let max0 =
      match outbounds with
      | Exactly l -> Inl (length l)
      | Use_prime -> Inr s0
      | Use_bitwidth ->
        Inr (weight src_limbwidth.qnum (Zpos src_limbwidth.qden) src_n)
    in
    (match max0 with
     | Inl len -> len
     | Inr max1 ->
       Coq_Z.to_nat
         (qceiling (qdiv (inject_Z (Coq_Z.log2_up max1)) dst_limbwidth)))
  in
  let out_upperbounds =
    map (fun v ->
      qceiling
        (qmult (sequence_return0 outbounds_multiplier (inject_Z (Zpos XH)))
          (inject_Z v)))
      (let encode0 =
         Partition.partition
           (weight dst_limbwidth.qnum (Zpos dst_limbwidth.qden)) dst_n
       in
       match outbounds with
       | Exactly l -> l
       | Use_prime -> encode0 (Coq_Z.sub s0 (Zpos XH))
       | Use_bitwidth ->
         encode0
           (Coq_Z.sub
             (weight dst_limbwidth.qnum (Zpos dst_limbwidth.qden) dst_n)
             (Zpos XH)))
  in
  map (fun u -> Obj.magic (Some { lower = Z0; upper = u })) out_upperbounds

(** val no_select_size4 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    no_select_size_opt **)

let no_select_size4 pipeline_opts machine_wordsize0 =
  if no_select pipeline_opts.Coq0_Options.no_select
  then Some machine_wordsize0
  else None

(** val split_mul_to4 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_mul_to_opt **)

let split_mul_to4 pipeline_opts machine_wordsize0 =
  if should_split_mul pipeline_opts.Coq0_Options.should_split_mul
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize_with_bytes pipeline_opts
               machine_wordsize0))))
  else None

(** val split_multiret_to4 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_multiret_to_opt **)

let split_multiret_to4 pipeline_opts machine_wordsize0 =
  if should_split_multiret pipeline_opts.Coq0_Options.should_split_multiret
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize_with_bytes pipeline_opts
               machine_wordsize0))))
  else None

(** val check_args2 :
    z -> (z * z) list -> nat -> q -> q -> machine_wordsize_opt -> q option ->
    q option -> bounds0 -> bounds0 -> char list list ->
    (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage,
    'a1) errorT **)

let check_args2 s0 c0 src_n src_limbwidth dst_limbwidth machine_wordsize0 inbounds_multiplier outbounds_multiplier inbounds outbounds _ res =
  let in_upperbounds =
    map (fun v ->
      qceiling
        (qmult (sequence_return0 inbounds_multiplier (inject_Z (Zpos XH)))
          (inject_Z v)))
      (let encode0 =
         Partition.partition
           (weight src_limbwidth.qnum (Zpos src_limbwidth.qden)) src_n
       in
       match inbounds with
       | Exactly l -> l
       | Use_prime -> encode0 (Coq_Z.sub s0 (Zpos XH))
       | Use_bitwidth ->
         encode0
           (Coq_Z.sub
             (weight src_limbwidth.qnum (Zpos src_limbwidth.qden) src_n)
             (Zpos XH)))
  in
  let dst_n =
    let max0 =
      match outbounds with
      | Exactly l -> Inl (length l)
      | Use_prime -> Inr s0
      | Use_bitwidth ->
        Inr (weight src_limbwidth.qnum (Zpos src_limbwidth.qden) src_n)
    in
    (match max0 with
     | Inl len -> len
     | Inr max1 ->
       Coq_Z.to_nat
         (qceiling (qdiv (inject_Z (Coq_Z.log2_up max1)) dst_limbwidth)))
  in
  let out_upperbounds =
    map (fun v ->
      qceiling
        (qmult (sequence_return0 outbounds_multiplier (inject_Z (Zpos XH)))
          (inject_Z v)))
      (let encode0 =
         Partition.partition
           (weight dst_limbwidth.qnum (Zpos dst_limbwidth.qden)) dst_n
       in
       match outbounds with
       | Exactly l -> l
       | Use_prime -> encode0 (Coq_Z.sub s0 (Zpos XH))
       | Use_bitwidth ->
         encode0
           (Coq_Z.sub
             (weight dst_limbwidth.qnum (Zpos dst_limbwidth.qden) dst_n)
             (Zpos XH)))
  in
  check_args_of_list
    (map (fun v -> (true, v))
      (((qle_bool { qnum = (Zpos XH); qden = XH } src_limbwidth),
      (Pipeline.Value_not_leQ
      (('s'::('r'::('c'::('_'::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::(' '::('<'::(' '::('1'::[]))))))))))))))))),
      { qnum = (Zpos XH); qden = XH },
      src_limbwidth))) :: (((qle_bool { qnum = (Zpos XH); qden = XH }
                              dst_limbwidth), (Pipeline.Value_not_leQ
      (('d'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::(' '::('<'::(' '::('1'::[]))))))))))))))))),
      { qnum = (Zpos XH); qden = XH },
      dst_limbwidth))) :: (((negb (Nat.eqb src_n O)),
      (Pipeline.Values_not_provably_distinctZ
      (('s'::('r'::('c'::('_'::('n'::(' '::('='::(' '::('0'::[]))))))))),
      (Coq_Z.of_nat src_n),
      (Coq_Z.of_nat O)))) :: (((negb (Nat.eqb dst_n O)),
      (Pipeline.Values_not_provably_distinctZ
      (('d'::('s'::('t'::('_'::('n'::(' '::('='::(' '::('0'::[]))))))))),
      (Coq_Z.of_nat dst_n),
      (Coq_Z.of_nat O)))) :: (((Nat.eqb
                                 (length
                                   (in_bounds s0 src_n src_limbwidth
                                     inbounds_multiplier inbounds)) src_n),
      (Pipeline.Values_not_provably_equalZ
      (('l'::('e'::('n'::('g'::('t'::('h'::(' '::('i'::('n'::('_'::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('\226'::('\137'::('\160'::(' '::('s'::('r'::('c'::('_'::('n'::[])))))))))))))))))))))))))),
      (Coq_Z.of_nat
        (length
          (in_bounds s0 src_n src_limbwidth inbounds_multiplier inbounds))),
      (Coq_Z.of_nat src_n)))) :: (((Nat.eqb (length in_upperbounds) src_n),
      (Pipeline.Values_not_provably_equalZ
      (('l'::('e'::('n'::('g'::('t'::('h'::(' '::('i'::('n'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('\226'::('\137'::('\160'::(' '::('s'::('r'::('c'::('_'::('n'::[]))))))))))))))))))))))))))))))),
      (Coq_Z.of_nat (length in_upperbounds)),
      (Coq_Z.of_nat src_n)))) :: (((Nat.eqb
                                     (length
                                       (out_bounds0 s0 src_n src_limbwidth
                                         dst_limbwidth outbounds_multiplier
                                         outbounds)) dst_n),
      (Pipeline.Values_not_provably_equalZ
      (('l'::('e'::('n'::('g'::('t'::('h'::(' '::('o'::('u'::('t'::('_'::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('\226'::('\137'::('\160'::(' '::('d'::('s'::('t'::('_'::('n'::[]))))))))))))))))))))))))))),
      (Coq_Z.of_nat
        (length
          (out_bounds0 s0 src_n src_limbwidth dst_limbwidth
            outbounds_multiplier outbounds))),
      (Coq_Z.of_nat dst_n)))) :: (((Nat.eqb (length out_upperbounds) dst_n),
      (Pipeline.Values_not_provably_equalZ
      (('l'::('e'::('n'::('g'::('t'::('h'::(' '::('o'::('u'::('t'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('\226'::('\137'::('\160'::(' '::('d'::('s'::('t'::('_'::('n'::[])))))))))))))))))))))))))))))))),
      (Coq_Z.of_nat (length out_upperbounds)),
      (Coq_Z.of_nat dst_n)))) :: (((Coq_Z.ltb (Associational.eval c0) s0),
      (Pipeline.Value_not_ltZ
      (('s'::(' '::('\226'::('\137'::('\164'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::[])))))))))))))))))))))))))),
      (Associational.eval c0), s0))) :: (((negb (Coq_Z.eqb s0 Z0)),
      (Pipeline.Values_not_provably_distinctZ
      (('s'::(' '::('='::(' '::('0'::[]))))), s0,
      Z0))) :: ((let eval_in_upperbounds =
                   Positional.eval
                     (weight src_limbwidth.qnum (Zpos src_limbwidth.qden))
                     src_n in_upperbounds
                 in
                 let dst_weight_n =
                   weight dst_limbwidth.qnum (Zpos dst_limbwidth.qden) dst_n
                 in
                 ((Coq_Z.ltb eval_in_upperbounds dst_weight_n),
                 (Pipeline.Value_not_ltZ
                 (('d'::('s'::('t'::('_'::('w'::('e'::('i'::('g'::('h'::('t'::(' '::('d'::('s'::('t'::('_'::('n'::(' '::('\226'::('\137'::('\164'::(' '::('s'::('r'::('c'::('_'::('e'::('v'::('a'::('l'::(' '::('i'::('n'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::[])))))))))))))))))))))))))))))))))))))))))))),
                 eval_in_upperbounds, dst_weight_n)))) :: (((Coq_Z.ltb Z0
                                                              machine_wordsize0),
      (Pipeline.Value_not_ltZ
      (('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::(' '::('\226'::('\137'::('\164'::(' '::('0'::[])))))))))))))))))))))),
      Z0,
      machine_wordsize0))) :: ((let v1 =
                                  fold_right Coq_Z.max Z0 in_upperbounds
                                in
                                let v2 =
                                  Coq_Z.sub
                                    (Coq_Z.pow (Zpos (XO XH))
                                      machine_wordsize0) (Zpos XH)
                                in
                                ((Coq_Z.leb v1 v2), (Pipeline.Value_not_leZ
                                (('m'::('a'::('x'::('('::('i'::('n'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(')'::(' '::('>'::(' '::('2'::('^'::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::('-'::('1'::[])))))))))))))))))))))))))))))))))))))))))),
                                v1, v2)))) :: ((let v1 =
                                                  fold_right Coq_Z.max Z0
                                                    out_upperbounds
                                                in
                                                let v2 =
                                                  Coq_Z.sub
                                                    (Coq_Z.pow (Zpos (XO XH))
                                                      machine_wordsize0)
                                                    (Zpos XH)
                                                in
                                                ((Coq_Z.leb v1 v2),
                                                (Pipeline.Value_not_leZ
                                                (('m'::('a'::('x'::('('::('o'::('u'::('t'::('_'::('u'::('p'::('p'::('e'::('r'::('b'::('o'::('u'::('n'::('d'::('s'::(')'::(' '::('>'::(' '::('2'::('^'::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::('-'::('1'::[]))))))))))))))))))))))))))))))))))))))))))),
                                                v1, v2)))) :: [])))))))))))))))
    res

(** val sconvert_bases :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> nat -> q -> q ->
    machine_wordsize_opt -> q option -> q option -> bounds0 -> bounds0 ->
    char list -> char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let sconvert_bases output_language_api pipeline_opts pipeline_to_string_opts s0 src_n src_limbwidth dst_limbwidth machine_wordsize0 inbounds_multiplier outbounds_multiplier inbounds outbounds =
  let dst_n =
    let max0 =
      match outbounds with
      | Exactly l -> Inl (length l)
      | Use_prime -> Inr s0
      | Use_bitwidth ->
        Inr (weight src_limbwidth.qnum (Zpos src_limbwidth.qden) src_n)
    in
    (match max0 with
     | Inl len -> len
     | Inr max1 ->
       Coq_Z.to_nat
         (qceiling (qdiv (inject_Z (Coq_Z.log2_up max1)) dst_limbwidth)))
  in
  (fun prefix1 ->
  ((append prefix1
     ('c'::('o'::('n'::('v'::('e'::('r'::('t'::('_'::('b'::('a'::('s'::('e'::('s'::[])))))))))))))),
  (Debug.bind
    (Pipeline.coq_BoundsPipelineWithDebug
      { Pipeline.coq_AbstractInterpretation_opts =
      pipeline_opts.Coq0_Options.absint_opts;
      Pipeline.low_level_rewriter_method =
      pipeline_opts.Coq0_Options.low_level_rewriter_method;
      Pipeline.only_signed = pipeline_opts.Coq0_Options.only_signed;
      Pipeline.no_select_size =
      (no_select_size4 pipeline_opts machine_wordsize0);
      Pipeline.split_mul_to =
      (split_mul_to4 pipeline_opts machine_wordsize0);
      Pipeline.split_multiret_to =
      (split_multiret_to4 pipeline_opts machine_wordsize0);
      Pipeline.unfold_value_barrier =
      pipeline_opts.Coq0_Options.unfold_value_barrier;
      Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
      pipeline_opts.Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
      Pipeline.translate_to_fancy = default_translate_to_fancy;
      Pipeline.debug_rewriting = pipeline_opts.Coq0_Options.debug_rewriting }
      false
      (possible_values_of_machine_wordsize_with_bytes pipeline_opts
        machine_wordsize0) (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
      (fun _ ->
      Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))))) (fun _ ->
                  BaseConversion.reified_convert_bases_gen) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ -> Obj.magic src_limbwidth.qnum)))
                (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ ->
                  Obj.magic (Zpos src_limbwidth.qden)))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic dst_limbwidth.qnum))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (fun _ -> Obj.magic (Zpos dst_limbwidth.qden)))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic src_n))) (fun _ ->
        Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
          (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (fun _ -> Obj.magic dst_n)))
      (Obj.magic ((Some
        (in_bounds s0 src_n src_limbwidth inbounds_multiplier inbounds)), ()))
      (Obj.magic (Some
        (out_bounds0 s0 src_n src_limbwidth dst_limbwidth
          outbounds_multiplier outbounds)))) (fun e' ->
    match e' with
    | Success e'0 ->
      let static0 = pipeline_to_string_opts.Coq0_Options.static in
      let internal_static0 =
        pipeline_to_string_opts.Coq0_Options.internal_static
      in
      let internal_static1 = (||) static0 internal_static0 in
      let is_internal' = if false then internal_static1 else static0 in
      let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
      let inline_internal0 =
        pipeline_to_string_opts.Coq0_Options.inline_internal
      in
      let inline_internal1 = (||) inline_internal0 inline0 in
      let inline' = if false then inline_internal1 else inline0 in
      let adjust_name =
        Coq7_Compilers.Options.convert_to_naming_convention
          (if is_internal'
           then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
           else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
      in
      let arg_bounds0 = ((Some
        (in_bounds s0 src_n src_limbwidth inbounds_multiplier inbounds)), ())
      in
      let out_bounds1 = Some
        (out_bounds0 s0 src_n src_limbwidth dst_limbwidth
          outbounds_multiplier outbounds)
      in
      let arg_typedefs0 = (None, ()) in
      let out_typedefs0 = None in
      let e =
        output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
          pipeline_opts.Coq0_Options.absint_opts (fun r0 ->
          sequence_return0
            (relax_zrange_gen pipeline_opts.Coq0_Options.only_signed
              (possible_values_of_machine_wordsize_with_bytes pipeline_opts
                machine_wordsize0) r0) r0)
          pipeline_to_string_opts.Coq0_Options.language_naming_conventions
          pipeline_to_string_opts.Coq0_Options.documentation_options
          pipeline_opts.Coq0_Options.output_options machine_wordsize0 true
          internal_static1 is_internal' static0 inline' prefix1
          (adjust_name
            (append prefix1
              ('c'::('o'::('n'::('v'::('e'::('r'::('t'::('_'::('b'::('a'::('s'::('e'::('s'::[])))))))))))))))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          e'0 (fun arg_var_data out_var_data ->
          app
            ((append
               (Coq7_Compilers.Options.text_before_function_name
                 pipeline_to_string_opts.Coq0_Options.documentation_options)
               (append
                 (adjust_name
                   (append prefix1
                     ('c'::('o'::('n'::('v'::('e'::('r'::('t'::('_'::('b'::('a'::('s'::('e'::('s'::[])))))))))))))))
                 (append
                   (' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('f'::('r'::('o'::('m'::(' '::('b'::('a'::('s'::('e'::(' '::[]))))))))))))))))))))))))))))))))))))
                   (append (Decimal.show_Q src_limbwidth)
                     (append
                       (' '::('t'::('o'::(' '::('b'::('a'::('s'::('e'::(' '::[])))))))))
                       (append (Decimal.show_Q dst_limbwidth)
                         (' '::('i'::('n'::(' '::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::(' '::('o'::('r'::('d'::('e'::('r'::('.'::[])))))))))))))))))))))))))))))) :: [])
            ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
            (append (' '::(' '::[]))
              (append
                (Obj.magic
                  Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                  (Compilers.Coq_type.final_codomain
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)))))) out_var_data)
                (append (' '::('='::(' '::[])))
                  (append ('m'::('a'::('p'::(' '::[]))))
                    (append
                      (append ('('::[])
                        (append
                          (append ('\206'::('\187'::[]))
                            (append (' '::[])
                              (append ('x'::[])
                                (append (','::(' '::[]))
                                  (append ('\226'::('\140'::('\138'::[])))
                                    (append
                                      (append
                                        (append ('('::[])
                                          (append
                                            (append
                                              (append
                                                ('s'::('r'::('c'::('_'::('e'::('v'::('a'::('l'::[]))))))))
                                                (append (' '::[])
                                                  (fst
                                                    (Obj.magic
                                                      Compilers.Coq_type.map_for_each_lhs_of_arrow
                                                      Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                                      (Compilers.Coq_type.Coq_arrow
                                                      ((Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z))),
                                                      (Compilers.Coq_type.Coq_base
                                                      (Compilers.Coq_base.Coq_type.Coq_list
                                                      (Compilers.Coq_base.Coq_type.Coq_type_base
                                                      Coq3_Compilers.Z)))))
                                                      arg_var_data))))
                                              (append (' '::[])
                                                (append
                                                  ('m'::('o'::('d'::[])))
                                                  (append (' '::[])
                                                    (append
                                                      ('d'::('s'::('t'::('_'::('w'::('e'::('i'::('g'::('h'::('t'::[]))))))))))
                                                      (append (' '::[])
                                                        (append ('('::[])
                                                          (append
                                                            (append ('x'::[])
                                                              (append
                                                                (' '::[])
                                                                (append
                                                                  ('+'::[])
                                                                  (append
                                                                    (' '::[])
                                                                    (Decimal.show_lvl_nat
                                                                    (S O)
                                                                    (Level.Coq_level
                                                                    (Zpos (XI
                                                                    (XO (XO
                                                                    (XO (XI
                                                                    XH))))))))))))
                                                            (')'::[])))))))))
                                            (')'::[])))
                                        (append (' '::[])
                                          (append ('/'::[])
                                            (append (' '::[])
                                              (append
                                                ('d'::('s'::('t'::('_'::('w'::('e'::('i'::('g'::('h'::('t'::[]))))))))))
                                                (append (' '::[]) ('x'::[])))))))
                                      ('\226'::('\140'::('\139'::[])))))))))
                          (')'::[])))
                      (append (' '::[])
                        (append ('['::[])
                          (append
                            (Decimal.show_lvl_nat O
                              (Level.next (Level.Coq_level (Zpos (XO (XI (XO
                                XH)))))))
                            (append ('.'::('.'::[]))
                              (append
                                (Decimal.show_lvl_nat (pred dst_n)
                                  (Level.next (Level.Coq_level (Zpos (XO (XI
                                    (XO XH))))))) (']'::[]))))))))))) :: ([] :: [])))))
          None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
          (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
      in
      (match e with
       | Inl p ->
         let (lines0, infos) = p in
         Debug.ret (Success { Pipeline.lines = lines0; Pipeline.ident_infos =
           infos; Pipeline.arg_bounds = (Obj.magic arg_bounds0);
           Pipeline.out_bounds = (Obj.magic out_bounds1);
           Pipeline.arg_typedefs = (Obj.magic arg_typedefs0);
           Pipeline.out_typedefs = (Obj.magic out_typedefs0); Pipeline.expr =
           e'0 })
       | Inr err0 ->
         Debug.ret (Error (Pipeline.Stringification_failed
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
           e'0, err0))))
    | Error err0 -> Debug.ret (Error err0)))))

(** val known_functions2 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> nat -> q -> q ->
    machine_wordsize_opt -> q option -> q option -> bounds0 -> bounds0 ->
    (char list * (char list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list **)

let known_functions2 output_language_api pipeline_opts pipeline_to_string_opts s0 src_n src_limbwidth dst_limbwidth machine_wordsize0 inbounds_multiplier outbounds_multiplier inbounds outbounds =
  (('c'::('o'::('n'::('v'::('e'::('r'::('t'::('_'::('b'::('a'::('s'::('e'::('s'::[]))))))))))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (sconvert_bases output_language_api pipeline_opts pipeline_to_string_opts
      s0 src_n src_limbwidth dst_limbwidth machine_wordsize0
      inbounds_multiplier outbounds_multiplier inbounds outbounds s1)))) :: []

(** val valid_names2 : char list **)

let valid_names2 =
  'c'::('o'::('n'::('v'::('e'::('r'::('t'::('_'::('b'::('a'::('s'::('e'::('s'::[]))))))))))))

(** val synthesize3 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> z -> (z * z) list -> nat -> q -> q
    -> machine_wordsize_opt -> q option -> q option -> bounds0 -> bounds0 ->
    char list list -> char list -> char list list ->
    ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

let synthesize3 output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts s0 c0 src_n src_limbwidth dst_limbwidth machine_wordsize0 inbounds_multiplier outbounds_multiplier inbounds outbounds =
  let dst_n =
    let max0 =
      match outbounds with
      | Exactly l -> Inl (length l)
      | Use_prime -> Inr s0
      | Use_bitwidth ->
        Inr (weight src_limbwidth.qnum (Zpos src_limbwidth.qden) src_n)
    in
    (match max0 with
     | Inl len -> len
     | Inr max1 ->
       Coq_Z.to_nat
         (qceiling (qdiv (inject_Z (Coq_Z.log2_up max1)) dst_limbwidth)))
  in
  (fun comment_header function_name_prefix requests ->
  synthesize output_language_api pipeline_opts pipeline_to_string_opts
    synthesis_opts machine_wordsize0 valid_names2
    (known_functions2 output_language_api pipeline_opts
      pipeline_to_string_opts s0 src_n src_limbwidth dst_limbwidth
      machine_wordsize0 inbounds_multiplier outbounds_multiplier inbounds
      outbounds) (fun _ -> []) []
    (check_args2 s0 c0 src_n src_limbwidth dst_limbwidth machine_wordsize0
      inbounds_multiplier outbounds_multiplier inbounds outbounds)
    (output_language_api.Coq7_Compilers.ToString.comment_file_header_block
      (app comment_header
        ([] :: (('C'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::[])))))))))))))))) :: (
        (append
          (' '::(' '::('d'::('s'::('t'::('_'::('n'::(' '::('='::(' '::[]))))))))))
          (show0 Decimal.show_nat dst_n)) :: []))))) function_name_prefix
    requests)

module Coq_dettman_multiplication_mod_ops =
 struct
  (** val limbwidth_num : z -> nat -> z **)

  let limbwidth_num s0 last_limb_width =
    Coq_Z.sub (Coq_Z.log2 s0) (Coq_Z.of_nat last_limb_width)

  (** val limbwidth_den : nat -> z **)

  let limbwidth_den n3 =
    Coq_Z.sub (Coq_Z.of_nat n3) (Zpos XH)

  (** val weight : z -> nat -> nat -> nat -> z **)

  let weight s0 n3 last_limb_width =
    weight (limbwidth_num s0 last_limb_width) (limbwidth_den n3)
 end

module DettmanMultiplication =
 struct
  (** val reified_mul_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_mul_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (fun v36 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v36)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun c0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun register_width ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun last_limb_width -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun last_reduction -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), v2)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_limb_width)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun register_width ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun last_reduction -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_assoc)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b_assoc)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun register_width -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun last_reduction -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x5 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x6 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x6)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), v10)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v26)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), v10)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v26)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), v10)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XI XH))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun c' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v24)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun from -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun to0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun before -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v29)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      to0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      before)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v28)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun quot0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      quot0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun register_width ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v24)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v24)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v24)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun from -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun to0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun before -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v23)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      to0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      before)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v4)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun thing -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      thing)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      thing)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun weight1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c')))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v19)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v16)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun from -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun to0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun before -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), to0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      before)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), b)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun d -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun d -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_filter
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun eqb2 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l')))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v6)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), eqb2)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l')))))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun f -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun found -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v5)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), f)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic false))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun b1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun b2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic true))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b2)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b1)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun last_limb_width -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_limb_width)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun last_limb_width -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_limb_width)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun n3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))

  (** val reified_square_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_square_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v36 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun v37 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v37)))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun register_width -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun last_limb_width -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun last_reduction -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v36)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))), v2)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_limb_width)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun register_width -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun last_reduction -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun a_assoc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a_assoc)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      a)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun register_width -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun last_reduction -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x5 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x6 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x6)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v34)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), v10)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x5)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x4)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), v10)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v33)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), v10)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_reduction)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XI XH))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun c' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v31)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun from -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun to0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun before -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      to0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      before)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v29)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun quot0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      quot0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun register_width ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      register_width)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun idxs0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), v26)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      idxs0)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x1)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun c' -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun from -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun to0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun before -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v24)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      to0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      before)))))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v23)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun thing -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      thing)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      thing)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v22)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun _ -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun weight1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      c')))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v19)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      b)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun m4 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun index -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v18)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      m4)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      index)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v16)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v17)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      x)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun from -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun to0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun before -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v9)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v12)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), to0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      from)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      before)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v11)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun w -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun fw -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (fun t2 -> Compilers.Coq_expr.LetIn
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun d2 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), t2)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), fw)))),
      (fun m4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      fw)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      m4)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      w)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Z_to_nat)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), b)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun d -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), d)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v7)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun d -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_filter
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      d)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      a)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun eqb2 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l')))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v6)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), eqb2)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l')))))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun f -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun found -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v5)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), f)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic false))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun b1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun b2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic true))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b2)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b1)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_list_rect
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun ts -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun acc -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (fun two_t2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      two_t2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      ts)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      acc)))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun n3 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun last_limb_width -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_limb_width)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun s0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun last_limb_width -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_log2)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      last_limb_width)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun n3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))
 end

(** val override_pipeline_opts0 :
    Coq0_Options.coq_PipelineOptions -> Coq0_Options.coq_PipelineOptions **)

let override_pipeline_opts0 pipeline_opts =
  { Coq0_Options.absint_opts = pipeline_opts.Coq0_Options.absint_opts;
    Coq0_Options.widen_carry = pipeline_opts.Coq0_Options.widen_carry;
    Coq0_Options.widen_bytes = true; Coq0_Options.unfold_value_barrier =
    pipeline_opts.Coq0_Options.unfold_value_barrier;
    Coq0_Options.should_split_multiret =
    pipeline_opts.Coq0_Options.should_split_multiret;
    Coq0_Options.should_split_mul =
    pipeline_opts.Coq0_Options.should_split_mul;
    Coq0_Options.output_options = pipeline_opts.Coq0_Options.output_options;
    Coq0_Options.only_signed = pipeline_opts.Coq0_Options.only_signed;
    Coq0_Options.no_select = pipeline_opts.Coq0_Options.no_select;
    Coq0_Options.low_level_rewriter_method =
    pipeline_opts.Coq0_Options.low_level_rewriter_method;
    Coq0_Options.debug_rewriting =
    pipeline_opts.Coq0_Options.debug_rewriting }

(** val possible_values_of_machine_wordsize1 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list **)

let possible_values_of_machine_wordsize1 pipeline_opts machine_wordsize0 =
  if widen_carry
       (override_pipeline_opts0 pipeline_opts).Coq0_Options.widen_carry
  then Z0 :: (machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO XH))
                                      machine_wordsize0) :: []))
  else Z0 :: ((Zpos
         XH) :: (machine_wordsize0 :: ((Coq_Z.mul (Zpos (XO XH))
                                         machine_wordsize0) :: [])))

(** val m2 : z -> (z * z) list -> z **)

let m2 s0 c_ =
  Coq_Z.sub s0 (Associational.eval c_)

(** val input_magnitude : q option -> q **)

let input_magnitude inbounds_multiplier =
  sequence_return0 inbounds_multiplier (inject_Z (Zpos XH))

(** val output_magnitude_first_limbs : q option -> q **)

let output_magnitude_first_limbs inbounds_multiplier =
  qplus
    (qdiv (input_magnitude inbounds_multiplier) { qnum = (Zpos (XO XH));
      qden = XH })
    (qdiv { qnum = (Zpos XH); qden = XH } { qnum = (Zpos (XO XH)); qden =
      XH })

(** val output_magnitude_last_limb : q option -> q **)

let output_magnitude_last_limb inbounds_multiplier =
  qplus
    (qdiv (input_magnitude inbounds_multiplier) { qnum = (Zpos (XO XH));
      qden = XH })
    (qdiv { qnum = (Zpos XH); qden = XH } { qnum = (Zpos (XO (XO XH)));
      qden = XH })

(** val weightf : z -> nat -> nat -> nat -> z **)

let weightf =
  Coq_dettman_multiplication_mod_ops.weight

(** val input_bounds :
    z -> nat -> nat -> q option ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let input_bounds s0 n3 last_limb_width inbounds_multiplier =
  app
    (fold_left (fun l i ->
      (Obj.magic (Some { lower = Z0; upper =
        (qceiling
          (qmult
            (qmult { qnum = (Zpos (XO XH)); qden = XH }
              (input_magnitude inbounds_multiplier))
            (qminus
              (qdiv (inject_Z (weightf s0 n3 last_limb_width (add i (S O))))
                (inject_Z (weightf s0 n3 last_limb_width i))) { qnum = (Zpos
              XH); qden = XH }))) })) :: l) (seq O (sub n3 (S O))) [])
    ((Obj.magic (Some { lower = Z0; upper =
       (qceiling
         (qmult
           (qmult { qnum = (Zpos (XO XH)); qden = XH }
             (input_magnitude inbounds_multiplier))
           (qminus
             (qpower { qnum = (Zpos (XO XH)); qden = XH }
               (Coq_Z.of_nat last_limb_width)) { qnum = (Zpos XH); qden =
             XH }))) })) :: [])

(** val output_bounds :
    z -> nat -> nat -> q option ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp list **)

let output_bounds s0 n3 last_limb_width inbounds_multiplier =
  app
    (fold_left (fun l i ->
      (Obj.magic (Some { lower = Z0; upper =
        (qceiling
          (qmult
            (qmult { qnum = (Zpos (XO XH)); qden = XH }
              (output_magnitude_first_limbs inbounds_multiplier))
            (qminus
              (qdiv (inject_Z (weightf s0 n3 last_limb_width (add i (S O))))
                (inject_Z (weightf s0 n3 last_limb_width i))) { qnum = (Zpos
              XH); qden = XH }))) })) :: l) (seq O (sub n3 (S O))) [])
    ((Obj.magic (Some { lower = Z0; upper =
       (qceiling
         (qmult
           (qmult { qnum = (Zpos (XO XH)); qden = XH }
             (output_magnitude_last_limb inbounds_multiplier))
           (qminus
             (qpower { qnum = (Zpos (XO XH)); qden = XH }
               (Coq_Z.of_nat last_limb_width)) { qnum = (Zpos XH); qden =
             XH }))) })) :: [])

(** val no_select_size5 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    no_select_size_opt **)

let no_select_size5 pipeline_opts machine_wordsize0 =
  if no_select (override_pipeline_opts0 pipeline_opts).Coq0_Options.no_select
  then Some machine_wordsize0
  else None

(** val split_mul_to5 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_mul_to_opt **)

let split_mul_to5 pipeline_opts machine_wordsize0 =
  if should_split_mul
       (override_pipeline_opts0 pipeline_opts).Coq0_Options.should_split_mul
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize1 pipeline_opts
               machine_wordsize0))))
  else None

(** val split_multiret_to5 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_multiret_to_opt **)

let split_multiret_to5 pipeline_opts machine_wordsize0 =
  if should_split_multiret
       (override_pipeline_opts0 pipeline_opts).Coq0_Options.should_split_multiret
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize1 pipeline_opts
               machine_wordsize0))))
  else None

(** val check_args3 :
    machine_wordsize_opt -> z -> (z * z) list -> nat -> nat -> char list list
    -> (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage,
    'a1) errorT **)

let check_args3 machine_wordsize0 s0 c_ n3 last_limb_width _ res =
  check_args_of_list
    (map (fun v -> (true, v))
      (((negb (Coq_Z.eqb (Coq_Z.sub s0 (Associational.eval c_)) Z0)),
      (Pipeline.Values_not_provably_distinctZ
      (('s'::(' '::('-'::(' '::('c'::(' '::('<'::('>'::(' '::('0'::[])))))))))),
      (Coq_Z.sub s0 (Associational.eval c_)),
      Z0))) :: (((Coq_Z.leb (Zpos (XO (XO XH))) (Coq_Z.of_nat n3)),
      (Pipeline.Value_not_leZ (('4'::(' '::('<'::('='::(' '::('n'::[])))))),
      (Zpos (XO (XO XH))),
      (Coq_Z.of_nat n3)))) :: (((Coq_Z.leb
                                  (Coq_Z.mul (Coq_Z.of_nat last_limb_width)
                                    (Coq_Z.of_nat n3)) (Coq_Z.log2 s0)),
      (Pipeline.Value_not_leZ
      (('l'::('a'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('_'::('w'::('i'::('d'::('t'::('h'::(' '::('*'::(' '::('n'::(' '::('<'::('='::(' '::('Z'::('.'::('l'::('o'::('g'::('2'::(' '::('s'::[]))))))))))))))))))))))))))))))),
      (Coq_Z.mul (Coq_Z.of_nat last_limb_width) (Coq_Z.of_nat n3)),
      (Coq_Z.log2 s0)))) :: (((Coq_Z.leb (Zpos XH)
                                (Coq_Z.of_nat last_limb_width)),
      (Pipeline.Value_not_leZ
      (('1'::(' '::('<'::('='::(' '::('l'::('a'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('_'::('w'::('i'::('d'::('t'::('h'::[])))))))))))))))))))),
      (Zpos XH),
      (Coq_Z.of_nat last_limb_width)))) :: (((Coq_Z.eqb
                                               (Coq_Z.pow (Zpos (XO XH))
                                                 (Coq_Z.log2 s0)) s0),
      (Pipeline.Values_not_provably_equalZ
      (('2'::(' '::('^'::(' '::('('::('Z'::('.'::('l'::('o'::('g'::('2'::(' '::('s'::(')'::(' '::('='::(' '::('s'::[])))))))))))))))))),
      (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 s0)),
      s0))) :: (((Coq_Z.leb
                   (Coq_Z.sub (Coq_Z.log2 s0) (Coq_Z.of_nat last_limb_width))
                   (Coq_Z.mul (Coq_Z.of_nat (Coq_Z.to_nat machine_wordsize0))
                     (Coq_Z.sub (Coq_Z.of_nat n3) (Zpos XH)))),
      (Pipeline.Value_not_leZ
      (('Z'::('.'::('l'::('o'::('g'::('2'::(' '::('s'::(' '::('-'::(' '::('l'::('a'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('_'::('w'::('i'::('d'::('t'::('h'::(' '::('<'::('='::(' '::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::(' '::('*'::(' '::('('::('n'::(' '::('-'::(' '::('1'::(')'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))),
      (Coq_Z.sub (Coq_Z.log2 s0) (Coq_Z.of_nat last_limb_width)),
      (Coq_Z.mul (Coq_Z.of_nat (Coq_Z.to_nat machine_wordsize0))
        (Coq_Z.sub (Coq_Z.of_nat n3) (Zpos XH)))))) :: (((Coq_Z.leb
                                                           (Coq_Z.log2 s0)
                                                           (Coq_Z.div
                                                             (Coq_Z.mul
                                                               (Coq_Z.of_nat
                                                                 n3)
                                                               (Coq_Z.sub
                                                                 (Coq_Z.log2
                                                                   s0)
                                                                 (Coq_Z.of_nat
                                                                   last_limb_width)))
                                                             (Coq_Z.sub
                                                               (Coq_Z.of_nat
                                                                 n3) (Zpos
                                                               XH)))),
      (Pipeline.Value_not_leZ
      (('Z'::('.'::('l'::('o'::('g'::('2'::(' '::('s'::(' '::('<'::('='::(' '::('n'::(' '::('*'::(' '::('('::('Z'::('.'::('l'::('o'::('g'::('2'::(' '::('s'::(' '::('-'::(' '::('l'::('a'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('_'::('w'::('i'::('d'::('t'::('h'::(')'::(' '::('/'::(' '::('('::('n'::(' '::('-'::(' '::('1'::(')'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))),
      (Coq_Z.log2 s0),
      (Coq_Z.div
        (Coq_Z.mul (Coq_Z.of_nat n3)
          (Coq_Z.sub (Coq_Z.log2 s0) (Coq_Z.of_nat last_limb_width)))
        (Coq_Z.sub (Coq_Z.of_nat n3) (Zpos XH)))))) :: [])))))))) res

(** val smul1 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt -> z ->
    (z * z) list -> nat -> nat -> nat -> q option -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let smul1 output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 s0 c_ n3 last_limb_width last_reduction inbounds_multiplier prefix1 =
  ((append prefix1 ('m'::('u'::('l'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size5 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to5 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to5 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.debug_rewriting }
        false
        (possible_values_of_machine_wordsize1 pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))))) (fun _ ->
                    DettmanMultiplication.reified_mul_gen) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ ->
                    Obj.magic Associational.eval c_))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)) (fun _ ->
                  Obj.magic Coq_Z.to_nat machine_wordsize0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic last_limb_width)))
          (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic last_reduction)))
        (Obj.magic ((Some
          (input_bounds s0 n3 last_limb_width inbounds_multiplier)), ((Some
          (input_bounds s0 n3 last_limb_width inbounds_multiplier)), ())))
        (Obj.magic (Some
          (output_bounds s0 n3 last_limb_width inbounds_multiplier))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (input_bounds s0 n3 last_limb_width inbounds_multiplier)), ((Some
          (input_bounds s0 n3 last_limb_width inbounds_multiplier)), ()))
        in
        let out_bounds1 = Some
          (output_bounds s0 n3 last_limb_width inbounds_multiplier)
        in
        let arg_typedefs0 = (None, (None, ())) in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            (override_pipeline_opts0 pipeline_opts).Coq0_Options.absint_opts
            (fun r0 ->
            sequence_return0
              (relax_zrange_gen
                (override_pipeline_opts0 pipeline_opts).Coq0_Options.only_signed
                (possible_values_of_machine_wordsize1 pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            (override_pipeline_opts0 pipeline_opts).Coq0_Options.output_options
            machine_wordsize0 true internal_static1 is_internal' static0
            inline' prefix1
            (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
                   (' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[]))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (Decimal.show_lvl_Z (m2 s0 c_) (Level.Coq_level
                            (Zpos (XI (XI (XI (XO (XO XH))))))))))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[])
                            (Decimal.show_lvl_Z (m2 s0 c_) (Level.Coq_level
                              (Zpos (XI (XI (XI (XO (XO XH))))))))))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val ssquare0 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt -> z ->
    (z * z) list -> nat -> nat -> nat -> q option -> char list ->
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM **)

let ssquare0 output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 s0 c_ n3 last_limb_width last_reduction inbounds_multiplier prefix1 =
  ((append prefix1 ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size5 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to5 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to5 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        (override_pipeline_opts0 pipeline_opts).Coq0_Options.debug_rewriting }
        false
        (possible_values_of_machine_wordsize1 pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z))))))))))))) (fun _ ->
                  Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z))))))))))))))) (fun _ ->
                    DettmanMultiplication.reified_square_gen) (fun _ ->
                    Compilers.GallinaReify.coq_Reify_as
                      Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)) (fun _ -> Obj.magic s0))) (fun _ ->
                  Compilers.GallinaReify.coq_Reify_as
                    Coq3_Compilers.buildIdent (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Z)) (fun _ ->
                    Obj.magic Associational.eval c_))) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat)) (fun _ ->
                  Obj.magic Coq_Z.to_nat machine_wordsize0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic n3))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic last_limb_width)))
          (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ -> Obj.magic last_reduction)))
        (Obj.magic ((Some
          (input_bounds s0 n3 last_limb_width inbounds_multiplier)), ()))
        (Obj.magic (Some
          (output_bounds s0 n3 last_limb_width inbounds_multiplier))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (input_bounds s0 n3 last_limb_width inbounds_multiplier)), ())
        in
        let out_bounds1 = Some
          (output_bounds s0 n3 last_limb_width inbounds_multiplier)
        in
        let arg_typedefs0 = (None, ()) in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            (override_pipeline_opts0 pipeline_opts).Coq0_Options.absint_opts
            (fun r0 ->
            sequence_return0
              (relax_zrange_gen
                (override_pipeline_opts0 pipeline_opts).Coq0_Options.only_signed
                (possible_values_of_machine_wordsize1 pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            (override_pipeline_opts0 pipeline_opts).Coq0_Options.output_options
            machine_wordsize0 true internal_static1 is_internal' static0
            inline' prefix1
            (adjust_name
              (append prefix1 ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))
                   (' '::('s'::('q'::('u'::('a'::('r'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('.'::[]))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (Decimal.show_lvl_Z (m2 s0 c_) (Level.Coq_level
                            (Zpos (XI (XI (XI (XO (XO XH))))))))))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))) arg_var_data))))))))
                          (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[])
                            (Decimal.show_lvl_Z (m2 s0 c_) (Level.Coq_level
                              (Zpos (XI (XI (XI (XO (XO XH))))))))))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val known_functions3 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> machine_wordsize_opt -> z ->
    (z * z) list -> nat -> nat -> nat -> q option -> (char list * (char list
    -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type, char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM) sigT)) list **)

let known_functions3 output_language_api pipeline_opts pipeline_to_string_opts machine_wordsize0 s0 c_ n3 last_limb_width last_reduction inbounds_multiplier =
  (('m'::('u'::('l'::[]))), (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (smul1 output_language_api pipeline_opts pipeline_to_string_opts
      machine_wordsize0 s0 c_ n3 last_limb_width last_reduction
      inbounds_multiplier s1)))) :: ((('s'::('q'::('u'::('a'::('r'::('e'::[])))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (ssquare0 output_language_api pipeline_opts pipeline_to_string_opts
      machine_wordsize0 s0 c_ n3 last_limb_width last_reduction
      inbounds_multiplier s1)))) :: [])

(** val valid_names3 : char list **)

let valid_names3 =
  'm'::('u'::('l'::(','::(' '::('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))))

(** val synthesize4 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> machine_wordsize_opt -> z -> (z * z)
    list -> nat -> nat -> nat -> q option -> char list list -> char list ->
    char list list -> ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

let synthesize4 output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts machine_wordsize0 s0 c_ n3 last_limb_width last_reduction inbounds_multiplier comment_header function_name_prefix requests =
  synthesize output_language_api (override_pipeline_opts0 pipeline_opts)
    pipeline_to_string_opts synthesis_opts machine_wordsize0 valid_names3
    (known_functions3 output_language_api pipeline_opts
      pipeline_to_string_opts machine_wordsize0 s0 c_ n3 last_limb_width
      last_reduction inbounds_multiplier) (fun _ -> []) []
    (check_args3 machine_wordsize0 s0 c_ n3 last_limb_width)
    (output_language_api.Coq7_Compilers.ToString.comment_file_header_block
      (app comment_header
        ([] :: (('C'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::[])))))))))))))))) :: ([] :: ([] :: []))))))
    function_name_prefix requests

module SolinasReduction =
 struct
  (** val reified_mul_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_mul_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun v33 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v33)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun machine_wordsize0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun weight1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun up_bound0 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v32)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v31)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v26)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      q0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO (XO (XO (XO XH)))))))))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun machine_wordsize0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun coef0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun r0 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      hi)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v30)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v28)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v27)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO (XO (XO (XO XH)))))))))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v29)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zneg XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun fuel0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun s0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun w_i -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun res -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun v27 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun found_adjustment -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun res0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w_i)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic true))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w_i)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found_adjustment)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v27)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found_adjustment)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic false))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      fuel0)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun bounds1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun ls -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), v24)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun r0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun v'' -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v22)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      v'')))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v'')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r0)))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun f -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun ls1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun ls2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v22)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic true))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))))), v23)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), f)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      ls1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (fun f -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (fun l1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (fun l2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), f)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      l1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun b1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun b2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b2)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic false))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b1)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v17)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v17)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v16)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v16)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v18)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v11)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v9)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v6)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))

  (** val reified_square_gen :
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident, __) Compilers.Coq_expr.expr **)

  let reified_square_gen =
    Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v3 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v4 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v5 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v6 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v7 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v8 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v9 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v10 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v11 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v12 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v13 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v14 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v15 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v16 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v17 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v18 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v19 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v20 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v21 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v22 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v23 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v24 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v25 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v26 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v27 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v28 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v29 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v30 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v31 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v32 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v33 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v34 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v35 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun v36 -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), v36)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun machine_wordsize0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun weight1 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun up_bound0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun base1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun double0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun square_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun square_rows -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun square0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      square0)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      square0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      square0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S O))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S O))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun q_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun pq -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p_a2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_a0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_rows0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun r_flat0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bound4 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun bounds2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun coef0 -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), Coq3_Compilers.Coq_ident_Z_zselect)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (fun hi -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun hi' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), hi)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), v35)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound4)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_nth_default
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_flat)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound2)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      up_bound0)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), v34)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v29)), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v28)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      bound0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      pq_rows)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_mul)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      pq_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Nat_eqb)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S O))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_sub)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      double0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      square_rows)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S (S (S (S (S O))))))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      square_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      v24)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S (S (S (S (S O))))))))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      carry2)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      carry2)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v22)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v1)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S O))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      p)))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO XH)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO (XO (XO (XO XH)))))))))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun p -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun machine_wordsize0 ->
      Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (fun base1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun c0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun s' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun lo_hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun coef0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun hi -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun r0 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      r0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      hi)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      coef0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      lo_hi)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v33)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      c0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v31)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s')))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), v30)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO (XO (XO (XO XH)))))))))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v32)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zneg XH)))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun hi_lo -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      hi_lo)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_partition
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun t0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (fun weight1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun fuel0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun s0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun w_i -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun res -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_prod_rect
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun v30 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun found_adjustment -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun res0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w_i)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic true))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), w_i)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found_adjustment)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v30)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      found_adjustment)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      res)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic false))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      fuel0)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun ls -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun y -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun bounds1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun ls -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), v27)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun r0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun v'' -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      v'')))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_leb)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), v'')))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      r0)))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      bounds1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (fun f -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun ls1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun ls2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), v25)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic true))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))))), v26)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), f)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      ls1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      ls2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (fun f -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (fun l1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (fun l2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), f)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      l1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (fun b1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (fun b2 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))))), (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b2)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_bool,
      (Obj.magic false))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      b1)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun base1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v23)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun base1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun state -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun a -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun b -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      b)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))), a)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))), a)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun machine_wordsize0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun base1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun prod0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun prod1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry1_a -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry1_rows -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry1 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun prod2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry2_rows -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun carry3 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      carry3)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      carry2)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      carry2)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      carry1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      carry2_rows)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S (S (S (S O)))))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      prod2)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v21)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S (S (S (S O)))))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      carry1_rows)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v14)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S (S (S (S (S O)))))))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      carry1_a)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      prod0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      prod1)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S (S O)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S (S O))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v3)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      base1)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_firstn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_skipn
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic (S O)))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v0)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      machine_wordsize0)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO (XO (XO (XO (XO (XO XH)))))))))))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun default0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v20)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v17)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v17)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v16)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v16)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v16)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v15)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun next_row -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun out_carry -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_add)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      out_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v19)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      state)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      next_row)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      start_state)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun row1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))))), v18)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))), (fun weight1 ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (fun start_state ->
      Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun row1 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun row2 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (fun next0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (fun low_high' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))), (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high')))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low_high -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun low -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun high -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))),
      Coq3_Compilers.Coq_ident_Z_add_with_get_carry)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      high)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      next0)))))), (fun sum_carry -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      low)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      sum_carry)))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      low_high)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      state)))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_rev
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row1)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      row2)))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun default0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v13)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v7)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v12)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), v8)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun start_state -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun state -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun cols'_row -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_app
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_snd ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      cols'_row)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z))))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      v11)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Coq3_Compilers.Coq_ident_fst ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      state)))))))))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      start_state)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun inp -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_pair ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun c0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      v10)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), v9)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      inp)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun l -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun _ -> Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun _ -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun m4 -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      m4)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun default0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun l -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), (Coq3_Compilers.Coq_ident_list_case
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (fun _ -> Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      default0)))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun x -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun _ -> Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      x)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      l)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun x -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (fun a -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun b -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))))), Coq3_Compilers.Coq_ident_Nat_max)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      a)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      b)))))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_List_length
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      c0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      x)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun p -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_fold_right
      ((Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun ls -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v5)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_pred)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (fun p0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      v6)), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      p0)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      ls)))))))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      v4)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun x -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_List_update_nth
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (fun y -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_cons
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), x)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      y)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))), (Coq3_Compilers.Coq_ident_nat_rect_arrow
      (Compilers.Coq_base.Coq_type.Coq_unit,
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (fun i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (fun place_i' -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun i0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      (Coq3_Compilers.Coq_ident_bool_rect
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun c0 -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), c0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun _ -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      place_i')), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_bool)))))), Coq3_Compilers.Coq_ident_Z_eqb)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_modulo)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i0)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic Z0))))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat)))), Coq3_Compilers.Coq_ident_Nat_succ)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i')))))))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      Compilers.Coq_base.Coq_type.Coq_unit),
      Coq3_Compilers.Coq_ident_tt)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (fun n3 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_List_repeat
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Coq3_Compilers.Coq_ident_nil
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun p -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun q0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t0 -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_flat_map
      ((Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))))),
      v2)), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      q0)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      p)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun s0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun t0 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun t' -> Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))),
      Coq3_Compilers.Coq_ident_Z_mul_split)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), s0)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))), (fun xy -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_cons (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))),
      (Coq3_Compilers.Coq_ident_pair
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_fst
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      t')))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      s0)))))), (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Coq3_Compilers.Coq_ident_snd
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
      xy)))))))), (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Coq3_Compilers.Coq_ident_nil (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))))))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (fun weight1 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (fun n3 -> Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (fun xs -> Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_prod
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))))),
      (Coq3_Compilers.Coq_ident_List_combine
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
      (Coq3_Compilers.Coq_ident_List_map
      ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat),
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), weight1)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Coq_nat))))))), Coq3_Compilers.Coq_ident_List_seq)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Coq_nat,
      (Obj.magic O))))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      n3)))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_list
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
      xs)))))))))))))), (Compilers.Coq_expr.Abs ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun lgr -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))))), v)), (Compilers.Coq_expr.Var
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)), lgr)))),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos XH)))))))))))))), (Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), (fun limbwidth_num0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (fun limbwidth_den0 -> Compilers.Coq_expr.Abs
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (fun i -> Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_pow)),
      (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Coq3_Compilers.Coq_ident_Literal (Coq3_Compilers.Z,
      (Obj.magic (Zpos (XO XH))))))))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_div)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_opp)),
      (Compilers.Coq_expr.App ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))))), Coq3_Compilers.Coq_ident_Z_mul)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_num0)))), (Compilers.Coq_expr.App
      ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)), (Compilers.Coq_expr.Ident
      ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_type_base
      Coq3_Compilers.Z)))), Coq3_Compilers.Coq_ident_Z_of_nat)),
      (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
      i)))))))))), (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base
      (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
      limbwidth_den0)))))))))))))))
 end

(** val override_pipeline_opts1 :
    Coq0_Options.coq_PipelineOptions -> Coq0_Options.coq_PipelineOptions **)

let override_pipeline_opts1 pipeline_opts =
  { Coq0_Options.absint_opts = pipeline_opts.Coq0_Options.absint_opts;
    Coq0_Options.widen_carry = pipeline_opts.Coq0_Options.widen_carry;
    Coq0_Options.widen_bytes = true; Coq0_Options.unfold_value_barrier =
    pipeline_opts.Coq0_Options.unfold_value_barrier;
    Coq0_Options.should_split_multiret =
    pipeline_opts.Coq0_Options.should_split_multiret;
    Coq0_Options.should_split_mul =
    pipeline_opts.Coq0_Options.should_split_mul;
    Coq0_Options.output_options = pipeline_opts.Coq0_Options.output_options;
    Coq0_Options.only_signed = pipeline_opts.Coq0_Options.only_signed;
    Coq0_Options.no_select = pipeline_opts.Coq0_Options.no_select;
    Coq0_Options.low_level_rewriter_method =
    pipeline_opts.Coq0_Options.low_level_rewriter_method;
    Coq0_Options.debug_rewriting =
    pipeline_opts.Coq0_Options.debug_rewriting }

(** val possible_values_of_machine_wordsize2 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt -> z list **)

let possible_values_of_machine_wordsize2 pipeline_opts machine_wordsize0 =
  if widen_carry
       (override_pipeline_opts1 pipeline_opts).Coq0_Options.widen_carry
  then Z0 :: (machine_wordsize0 :: [])
  else Z0 :: ((Zpos XH) :: (machine_wordsize0 :: []))

(** val n2 : z -> machine_wordsize_opt -> nat **)

let n2 s0 machine_wordsize0 =
  Coq_Z.to_nat
    (qceiling
      (qdiv (inject_Z (Coq_Z.log2_up s0)) (inject_Z machine_wordsize0)))

(** val m3 : z -> (z * z) list -> z **)

let m3 s0 c0 =
  Coq_Z.sub s0 (Associational.eval c0)

(** val weight0 : machine_wordsize_opt -> nat -> z **)

let weight0 =
  uweight

(** val up_bound : machine_wordsize_opt -> z **)

let up_bound machine_wordsize0 =
  Coq_Z.pow (Zpos (XO XH)) (Coq_Z.div machine_wordsize0 (Zpos (XO (XO XH))))

(** val base0 : machine_wordsize_opt -> z **)

let base0 machine_wordsize0 =
  Coq_Z.pow (Zpos (XO XH)) machine_wordsize0

(** val no_select_size6 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    no_select_size_opt **)

let no_select_size6 pipeline_opts machine_wordsize0 =
  if no_select (override_pipeline_opts1 pipeline_opts).Coq0_Options.no_select
  then Some machine_wordsize0
  else None

(** val split_mul_to6 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_mul_to_opt **)

let split_mul_to6 pipeline_opts machine_wordsize0 =
  if should_split_mul
       (override_pipeline_opts1 pipeline_opts).Coq0_Options.should_split_mul
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize2 pipeline_opts
               machine_wordsize0))))
  else None

(** val split_multiret_to6 :
    Coq0_Options.coq_PipelineOptions -> machine_wordsize_opt ->
    split_multiret_to_opt **)

let split_multiret_to6 pipeline_opts machine_wordsize0 =
  if should_split_multiret
       (override_pipeline_opts1 pipeline_opts).Coq0_Options.should_split_multiret
  then Some (machine_wordsize0,
         (fold_right Coq_Z.min machine_wordsize0
           (filter (fun x -> Coq_Z.leb (Zpos XH) x)
             (possible_values_of_machine_wordsize2 pipeline_opts
               machine_wordsize0))))
  else None

(** val check_args4 :
    z -> (z * z) list -> machine_wordsize_opt -> char list list ->
    (Pipeline.coq_ErrorMessage, 'a1) errorT -> (Pipeline.coq_ErrorMessage,
    'a1) errorT **)

let check_args4 s0 c0 machine_wordsize0 _ res =
  check_args_of_list
    (map (fun v -> (true, v)) (((Coq_Z.ltb Z0 s0), (Pipeline.Value_not_ltZ
      (('0'::(' '::('<'::(' '::('s'::[]))))), Z0,
      s0))) :: (((Coq_Z.ltb Z0 (Associational.eval c0)),
      (Pipeline.Value_not_ltZ
      (('0'::(' '::('<'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::[])))))))))))))))))))))))),
      Z0,
      (Associational.eval c0)))) :: (((Coq_Z.ltb Z0
                                        (Coq_Z.sub s0 (Associational.eval c0))),
      (Pipeline.Value_not_ltZ
      (('0'::(' '::('<'::(' '::('s'::(' '::('-'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::[])))))))))))))))))))))))))))),
      Z0,
      (Coq_Z.sub s0 (Associational.eval c0))))) :: (((negb (Coq_Z.eqb s0 Z0)),
      (Pipeline.Values_not_provably_distinctZ
      (('s'::(' '::('\226'::('\137'::('\160'::(' '::('0'::[]))))))), s0,
      Z0))) :: (((negb (Nat.eqb (n2 s0 machine_wordsize0) O)),
      (Pipeline.Values_not_provably_distinctZ
      (('n'::(' '::('\226'::('\137'::('\160'::(' '::('0'::[]))))))),
      (Coq_Z.of_nat (n2 s0 machine_wordsize0)),
      Z0))) :: (((Coq_Z.eqb (Coq_Z.of_nat (n2 s0 machine_wordsize0)) (Zpos
                   (XO (XO XH)))), (Pipeline.Values_not_provably_equalZ
      (('n'::(' '::('='::(' '::('4'::[]))))),
      (Coq_Z.of_nat (n2 s0 machine_wordsize0)), (Zpos (XO (XO
      XH)))))) :: (((Coq_Z.ltb Z0 machine_wordsize0), (Pipeline.Value_not_ltZ
      (('0'::(' '::('<'::(' '::('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::[])))))))))))))))))))),
      Z0,
      machine_wordsize0))) :: (((Coq_Z.eqb machine_wordsize0 (Zpos (XO (XO
                                  (XO (XO (XO (XO XH)))))))),
      (Pipeline.Values_not_provably_equalZ
      (('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::(' '::('='::(' '::('6'::('4'::[]))))))))))))))))))))),
      machine_wordsize0, (Zpos (XO (XO (XO (XO (XO (XO
      XH)))))))))) :: (((Nat.ltb (S O) (n2 s0 machine_wordsize0)),
      (Pipeline.Value_not_ltZ (('1'::(' '::('<'::(' '::('n'::[]))))), (Zpos
      XH),
      (Coq_Z.of_nat (n2 s0 machine_wordsize0))))) :: (((Coq_Z.eqb
                                                         (fst
                                                           (Rows.adjust_s
                                                             (weight0
                                                               machine_wordsize0)
                                                             (S (S
                                                             (n2 s0
                                                               machine_wordsize0)))
                                                             s0))
                                                         (weight0
                                                           machine_wordsize0
                                                           (n2 s0
                                                             machine_wordsize0))),
      (Pipeline.Values_not_provably_equalZ
      (('f'::('s'::('t'::(' '::('('::('R'::('o'::('w'::('s'::('.'::('a'::('d'::('j'::('u'::('s'::('t'::('_'::('s'::(' '::('w'::('e'::('i'::('g'::('h'::('t'::(' '::('('::('S'::(' '::('('::('S'::(' '::('n'::(')'::(')'::(' '::('s'::(')'::(' '::('='::(' '::('w'::('e'::('i'::('g'::('h'::('t'::(' '::('n'::[]))))))))))))))))))))))))))))))))))))))))))))))))),
      (fst
        (Rows.adjust_s (weight0 machine_wordsize0) (S (S
          (n2 s0 machine_wordsize0))) s0)),
      (weight0 machine_wordsize0 (n2 s0 machine_wordsize0))))) :: (((snd
                                                                    (Rows.adjust_s
                                                                    (weight0
                                                                    machine_wordsize0)
                                                                    (S (S
                                                                    (n2 s0
                                                                    machine_wordsize0)))
                                                                    s0)),
      (Pipeline.Invalid_argument
      ('t'::('m'::('p'::[]))))) :: (((Coq_Z.ltb
                                       (Coq_Z.mul
                                         (Coq_Z.div
                                           (weight0 machine_wordsize0
                                             (n2 s0 machine_wordsize0)) s0)
                                         (Associational.eval c0))
                                       (up_bound machine_wordsize0)),
      (Pipeline.Value_not_ltZ
      (('w'::('e'::('i'::('g'::('h'::('t'::(' '::('n'::(' '::('/'::(' '::('s'::(' '::('*'::(' '::('A'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('o'::('n'::('a'::('l'::('.'::('e'::('v'::('a'::('l'::(' '::('c'::(' '::('<'::(' '::('u'::('p'::('_'::('b'::('o'::('u'::('n'::('d'::[])))))))))))))))))))))))))))))))))))))))))))))),
      (Coq_Z.mul
        (Coq_Z.div (weight0 machine_wordsize0 (n2 s0 machine_wordsize0)) s0)
        (Associational.eval c0)),
      (up_bound machine_wordsize0)))) :: []))))))))))))) res

(** val smul2 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
    machine_wordsize_opt -> char list -> char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM **)

let smul2 output_language_api pipeline_opts pipeline_to_string_opts s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('m'::('u'::('l'::[])))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size6 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to6 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to6 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.debug_rewriting }
        false
        (possible_values_of_machine_wordsize2 pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))))) (fun _ ->
                SolinasReduction.reified_mul_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ ->
                  Obj.magic base0 machine_wordsize0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic s0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ ->
            Obj.magic n2 s0 machine_wordsize0)))
        (Obj.magic ((Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)),
          ((Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)),
          ())))
        (Obj.magic (Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)),
          ((Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)),
          ()))
        in
        let out_bounds1 = Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)
        in
        let arg_typedefs0 = (None, (None, ())) in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            (override_pipeline_opts1 pipeline_opts).Coq0_Options.absint_opts
            (fun r0 ->
            sequence_return0
              (relax_zrange_gen
                (override_pipeline_opts1 pipeline_opts).Coq0_Options.only_signed
                (possible_values_of_machine_wordsize2 pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            (override_pipeline_opts1 pipeline_opts).Coq0_Options.output_options
            machine_wordsize0 true internal_static1 is_internal' static0
            inline' prefix1
            (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name (append prefix1 ('m'::('u'::('l'::[])))))
                   (' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('s'::(' '::('t'::('w'::('o'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::('.'::[]))))))))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (Decimal.show_lvl_Z (m3 s0 c0) (Level.Coq_level
                            (Zpos (XI (XI (XI (XO (XO XH))))))))))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (snd
                                          (Obj.magic
                                            Compilers.Coq_type.map_for_each_lhs_of_arrow
                                            Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_arrow
                                            ((Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z))),
                                            (Compilers.Coq_type.Coq_base
                                            (Compilers.Coq_base.Coq_type.Coq_list
                                            (Compilers.Coq_base.Coq_type.Coq_type_base
                                            Coq3_Compilers.Z)))))))
                                            arg_var_data))))))))) (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[])
                            (Decimal.show_lvl_Z (m3 s0 c0) (Level.Coq_level
                              (Zpos (XI (XI (XI (XO (XO XH))))))))))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val ssquare1 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
    machine_wordsize_opt -> char list -> char list * (char list,
    (Pipeline.coq_ErrorMessage, Pipeline.coq_ExtendedSynthesisResult) errorT)
    debugM **)

let ssquare1 output_language_api pipeline_opts pipeline_to_string_opts s0 c0 machine_wordsize0 prefix1 =
  ((append prefix1 ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))),
    (Debug.bind
      (Pipeline.coq_BoundsPipelineWithDebug
        { Pipeline.coq_AbstractInterpretation_opts =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.absint_opts;
        Pipeline.low_level_rewriter_method =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.low_level_rewriter_method;
        Pipeline.only_signed =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.only_signed;
        Pipeline.no_select_size =
        (no_select_size6 pipeline_opts machine_wordsize0);
        Pipeline.split_mul_to =
        (split_mul_to6 pipeline_opts machine_wordsize0);
        Pipeline.split_multiret_to =
        (split_multiret_to6 pipeline_opts machine_wordsize0);
        Pipeline.unfold_value_barrier =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.unfold_value_barrier;
        Pipeline.relax_adc_sbb_return_carry_to_bitwidth =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.output_options.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_;
        Pipeline.translate_to_fancy = default_translate_to_fancy;
        Pipeline.debug_rewriting =
        (override_pipeline_opts1 pipeline_opts).Coq0_Options.debug_rewriting }
        false
        (possible_values_of_machine_wordsize2 pipeline_opts machine_wordsize0)
        (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
        (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
        (fun _ ->
        Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
          (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
          (fun _ ->
          Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_prod
            ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
            ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Z))))))) (fun _ ->
            Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))))))) (fun _ ->
              Compilers.Coq_expr.coq_APP (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_prod
                ((Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z), (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                ((Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_list
                (Compilers.Coq_base.Coq_type.Coq_type_base
                Coq3_Compilers.Z))))))))))) (fun _ ->
                SolinasReduction.reified_square_gen) (fun _ ->
                Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Z)) (fun _ ->
                  Obj.magic base0 machine_wordsize0))) (fun _ ->
              Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
                (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
                (fun _ -> Obj.magic s0))) (fun _ ->
            Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z))))) (fun _ -> Obj.magic c0))) (fun _ ->
          Compilers.GallinaReify.coq_Reify_as Coq3_Compilers.buildIdent
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_type_base
            Coq3_Compilers.Coq_nat)) (fun _ ->
            Obj.magic n2 s0 machine_wordsize0)))
        (Obj.magic ((Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)),
          ()))
        (Obj.magic (Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0))))
      (fun e' ->
      match e' with
      | Success e'0 ->
        let static0 = pipeline_to_string_opts.Coq0_Options.static in
        let internal_static0 =
          pipeline_to_string_opts.Coq0_Options.internal_static
        in
        let internal_static1 = (||) static0 internal_static0 in
        let is_internal' = if false then internal_static1 else static0 in
        let inline0 = pipeline_to_string_opts.Coq0_Options.inline in
        let inline_internal0 =
          pipeline_to_string_opts.Coq0_Options.inline_internal
        in
        let inline_internal1 = (||) inline_internal0 inline0 in
        let inline' = if false then inline_internal1 else inline0 in
        let adjust_name =
          Coq7_Compilers.Options.convert_to_naming_convention
            (if is_internal'
             then pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.private_function_naming_convention
             else pipeline_to_string_opts.Coq0_Options.language_naming_conventions.Coq7_Compilers.Options.public_function_naming_convention)
        in
        let arg_bounds0 = ((Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)), ())
        in
        let out_bounds1 = Some
          (saturated_bounds (n2 s0 machine_wordsize0) machine_wordsize0)
        in
        let arg_typedefs0 = (None, ()) in
        let out_typedefs0 = None in
        let e =
          output_language_api.Coq7_Compilers.ToString.coq_ToFunctionLines
            (override_pipeline_opts1 pipeline_opts).Coq0_Options.absint_opts
            (fun r0 ->
            sequence_return0
              (relax_zrange_gen
                (override_pipeline_opts1 pipeline_opts).Coq0_Options.only_signed
                (possible_values_of_machine_wordsize2 pipeline_opts
                  machine_wordsize0) r0) r0)
            pipeline_to_string_opts.Coq0_Options.language_naming_conventions
            pipeline_to_string_opts.Coq0_Options.documentation_options
            (override_pipeline_opts1 pipeline_opts).Coq0_Options.output_options
            machine_wordsize0 true internal_static1 is_internal' static0
            inline' prefix1
            (adjust_name
              (append prefix1 ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))
            (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
            (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list
            (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
            e'0 (fun arg_var_data out_var_data ->
            app
              ((append
                 (Coq7_Compilers.Options.text_before_function_name
                   pipeline_to_string_opts.Coq0_Options.documentation_options)
                 (append
                   (adjust_name
                     (append prefix1
                       ('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))
                   (' '::('s'::('q'::('u'::('a'::('r'::('e'::('s'::(' '::('a'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('.'::[]))))))))))))))))))))))))))) :: [])
              ([] :: (('P'::('o'::('s'::('t'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::(':'::[]))))))))))))))) :: (
              (append (' '::(' '::[]))
                (append
                  (append
                    (append ('e'::('v'::('a'::('l'::[]))))
                      (append (' '::[])
                        (Obj.magic
                          Coq7_Compilers.ToString.OfPHOAS.names_of_base_var_data
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))), (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)))))) out_var_data)))
                    (append (' '::[])
                      (append ('m'::('o'::('d'::[])))
                        (append (' '::[])
                          (Decimal.show_lvl_Z (m3 s0 c0) (Level.Coq_level
                            (Zpos (XI (XI (XI (XO (XO XH))))))))))))
                  (append (' '::('='::(' '::[])))
                    (append
                      (append ('('::[])
                        (append
                          (append
                            (append ('e'::('v'::('a'::('l'::[]))))
                              (append (' '::[])
                                (fst
                                  (Obj.magic
                                    Compilers.Coq_type.map_for_each_lhs_of_arrow
                                    Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                    (Compilers.Coq_type.Coq_arrow
                                    ((Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))),
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_list
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z))))) arg_var_data))))
                            (append (' '::[])
                              (append ('*'::[])
                                (append (' '::[])
                                  (append ('e'::('v'::('a'::('l'::[]))))
                                    (append (' '::[])
                                      (fst
                                        (Obj.magic
                                          Compilers.Coq_type.map_for_each_lhs_of_arrow
                                          Coq7_Compilers.ToString.OfPHOAS.names_of_var_data
                                          (Compilers.Coq_type.Coq_arrow
                                          ((Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))),
                                          (Compilers.Coq_type.Coq_base
                                          (Compilers.Coq_base.Coq_type.Coq_list
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z))))) arg_var_data))))))))
                          (')'::[])))
                      (append (' '::[])
                        (append ('m'::('o'::('d'::[])))
                          (append (' '::[])
                            (Decimal.show_lvl_Z (m3 s0 c0) (Level.Coq_level
                              (Zpos (XI (XI (XI (XO (XO XH))))))))))))))) :: ([] :: [])))))
            None (Obj.magic arg_bounds0) (Obj.magic out_bounds1)
            (Obj.magic arg_typedefs0) (Obj.magic out_typedefs0)
        in
        (match e with
         | Inl p ->
           let (lines0, infos) = p in
           Debug.ret (Success { Pipeline.lines = lines0;
             Pipeline.ident_infos = infos; Pipeline.arg_bounds =
             (Obj.magic arg_bounds0); Pipeline.out_bounds =
             (Obj.magic out_bounds1); Pipeline.arg_typedefs =
             (Obj.magic arg_typedefs0); Pipeline.out_typedefs =
             (Obj.magic out_typedefs0); Pipeline.expr = e'0 })
         | Inr err0 ->
           Debug.ret (Error (Pipeline.Stringification_failed
             ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
             (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Z))))), e'0, err0))))
      | Error err0 -> Debug.ret (Error err0))))

(** val known_functions4 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions -> z -> (z * z) list ->
    machine_wordsize_opt -> (char list * (char list -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type,
    char list * (char list, (Pipeline.coq_ErrorMessage,
    Pipeline.coq_ExtendedSynthesisResult) errorT) debugM) sigT)) list **)

let known_functions4 output_language_api pipeline_opts pipeline_to_string_opts s0 c0 machine_wordsize0 =
  (('m'::('u'::('l'::[]))), (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
    (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))),
    (smul2 output_language_api pipeline_opts pipeline_to_string_opts s0 c0
      machine_wordsize0 s1)))) :: ((('s'::('q'::('u'::('a'::('r'::('e'::[])))))),
    (fun s1 -> ExistT ((Compilers.Coq_type.Coq_arrow
    ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
    (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
    (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))),
    (ssquare1 output_language_api pipeline_opts pipeline_to_string_opts s0 c0
      machine_wordsize0 s1)))) :: [])

(** val valid_names4 : char list **)

let valid_names4 =
  'm'::('u'::('l'::(','::(' '::('s'::('q'::('u'::('a'::('r'::('e'::[]))))))))))

(** val synthesize5 :
    Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
    Coq0_Options.coq_PipelineOptions ->
    Coq0_Options.coq_PipelineToStringOptions ->
    Coq0_Options.coq_SynthesisOptions -> z -> (z * z) list ->
    machine_wordsize_opt -> char list list -> char list -> char list list ->
    ((synthesis_output_kind * char list) * (char list,
    (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

let synthesize5 output_language_api pipeline_opts pipeline_to_string_opts synthesis_opts s0 c0 machine_wordsize0 comment_header function_name_prefix requests =
  synthesize output_language_api (override_pipeline_opts1 pipeline_opts)
    pipeline_to_string_opts synthesis_opts machine_wordsize0 valid_names4
    (known_functions4 output_language_api pipeline_opts
      pipeline_to_string_opts s0 c0 machine_wordsize0) (fun _ -> []) []
    (check_args4 s0 c0 machine_wordsize0)
    (output_language_api.Coq7_Compilers.ToString.comment_file_header_block
      (app comment_header
        ([] :: (('C'::('o'::('m'::('p'::('u'::('t'::('e'::('d'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::[])))))))))))))))) :: ([] :: [])))))
    function_name_prefix requests

module Coq24_Compilers =
 struct
  module ToString =
   struct
    module IR =
     struct
      module Coq_type =
       struct
        type primitive =
        | Z
        | Zptr

        type coq_type =
        | Coq_type_primitive of primitive
        | Coq_prod of coq_type * coq_type
        | Coq_unit
       end

      type coq_Z_binop =
      | Z_land
      | Z_lor
      | Z_lxor
      | Z_add
      | Z_mul
      | Z_sub

      type coq_Z_unop =
      | Z_shiftr of z
      | Z_shiftl of z
      | Z_lnot of Coq7_Compilers.ToString.Coq_int.coq_type
      | Z_bneg
      | Z_value_barrier of Coq7_Compilers.ToString.Coq_int.coq_type

      type ident =
      | Coq_literal of z
      | List_nth of nat
      | Addr
      | Dereference
      | Coq_iunop of coq_Z_unop
      | Coq_ibinop of coq_Z_binop
      | Z_mul_split of z
      | Z_add_with_get_carry of z
      | Z_sub_with_get_borrow of z
      | Z_zselect of Coq7_Compilers.ToString.Coq_int.coq_type
      | Z_add_modulo
      | Z_static_cast of Coq7_Compilers.ToString.Coq_int.coq_type

      type arith_expr =
      | AppIdent of Coq_type.coq_type * Coq_type.coq_type * ident * arith_expr
      | Var of Coq_type.primitive * char list
      | Pair of Coq_type.coq_type * Coq_type.coq_type * arith_expr
         * arith_expr
      | TT

      type stmt =
      | Call of arith_expr
      | Comment of char list list
         * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
           Compilers.Coq_type.coq_type,
           Coq7_Compilers.ToString.OfPHOAS.var_data) sigT list
      | Assign of bool * Coq_type.primitive
         * Coq7_Compilers.ToString.Coq_int.coq_type option * char list
         * arith_expr
      | AssignZPtr of char list
         * Coq7_Compilers.ToString.Coq_int.coq_type option * arith_expr
      | DeclareVar of Coq_type.primitive
         * Coq7_Compilers.ToString.Coq_int.coq_type option * char list
      | AssignNth of char list * nat * arith_expr

      type expr = stmt list

      (** val invert_literal : Coq_type.coq_type -> arith_expr -> z option **)

      let invert_literal _ = function
      | AppIdent (_, _, idc, _) ->
        (match idc with
         | Coq_literal v -> Some v
         | List_nth _ -> None
         | Addr -> None
         | Dereference -> None
         | Coq_iunop _ -> None
         | Coq_ibinop _ -> None
         | Z_mul_split _ -> None
         | Z_add_with_get_carry _ -> None
         | Z_sub_with_get_borrow _ -> None
         | Z_zselect _ -> None
         | Z_add_modulo -> None
         | Z_static_cast _ -> None)
      | Var (_, _) -> None
      | Pair (_, _, _, _) -> None
      | TT -> None

      module Coq_ident_infos =
       struct
        (** val collect_infos_of_ident :
            Coq_type.coq_type -> Coq_type.coq_type -> ident ->
            Coq7_Compilers.ToString.ident_infos **)

        let collect_infos_of_ident _ _ = function
        | Coq_literal _ -> Coq7_Compilers.ToString.ident_info_empty
        | List_nth _ -> Coq7_Compilers.ToString.ident_info_empty
        | Addr -> Coq7_Compilers.ToString.ident_info_empty
        | Dereference -> Coq7_Compilers.ToString.ident_info_empty
        | Coq_iunop op1 ->
          (match op1 with
           | Z_shiftr _ -> Coq7_Compilers.ToString.ident_info_empty
           | Z_shiftl _ -> Coq7_Compilers.ToString.ident_info_empty
           | Z_lnot _ -> Coq7_Compilers.ToString.ident_info_empty
           | Z_bneg -> Coq7_Compilers.ToString.ident_info_empty
           | Z_value_barrier ty ->
             Coq7_Compilers.ToString.ident_info_of_value_barrier
               (Coq7_Compilers.ToString.IntSet.singleton ty))
        | Coq_ibinop _ -> Coq7_Compilers.ToString.ident_info_empty
        | Z_mul_split lg2s ->
          Coq7_Compilers.ToString.ident_info_of_mulx
            (PositiveSet.add (Coq_Z.to_pos lg2s) PositiveSet.empty)
        | Z_add_with_get_carry lg2s ->
          Coq7_Compilers.ToString.ident_info_of_addcarryx
            (PositiveSet.add (Coq_Z.to_pos lg2s) PositiveSet.empty)
        | Z_sub_with_get_borrow lg2s ->
          Coq7_Compilers.ToString.ident_info_of_addcarryx
            (PositiveSet.add (Coq_Z.to_pos lg2s) PositiveSet.empty)
        | Z_zselect ty ->
          Coq7_Compilers.ToString.ident_info_of_cmovznz
            (Coq7_Compilers.ToString.IntSet.singleton ty)
        | Z_add_modulo -> Coq7_Compilers.ToString.ident_info_empty
        | Z_static_cast ty ->
          Coq7_Compilers.ToString.ident_info_of_bitwidths_used
            (Coq7_Compilers.ToString.IntSet.singleton ty)

        (** val collect_infos_of_arith_expr :
            Coq_type.coq_type -> arith_expr ->
            Coq7_Compilers.ToString.ident_infos **)

        let rec collect_infos_of_arith_expr _ = function
        | AppIdent (s0, d, idc, arg) ->
          Coq7_Compilers.ToString.ident_info_union
            (collect_infos_of_ident s0 d idc)
            (collect_infos_of_arith_expr s0 arg)
        | Var (_, _) -> Coq7_Compilers.ToString.ident_info_empty
        | Pair (a, b, a0, b0) ->
          Coq7_Compilers.ToString.ident_info_union
            (collect_infos_of_arith_expr a a0)
            (collect_infos_of_arith_expr b b0)
        | TT -> Coq7_Compilers.ToString.ident_info_empty

        (** val collect_infos_of_stmt :
            stmt -> Coq7_Compilers.ToString.ident_infos **)

        let collect_infos_of_stmt = function
        | Call val0 -> collect_infos_of_arith_expr Coq_type.Coq_unit val0
        | Comment (_, _) -> Coq7_Compilers.ToString.ident_info_empty
        | Assign (_, t0, sz0, _, val0) ->
          (match sz0 with
           | Some sz ->
             Coq7_Compilers.ToString.ident_info_union
               (Coq7_Compilers.ToString.ident_info_of_bitwidths_used
                 (Coq7_Compilers.ToString.IntSet.singleton sz))
               (collect_infos_of_arith_expr (Coq_type.Coq_type_primitive t0)
                 val0)
           | None ->
             collect_infos_of_arith_expr (Coq_type.Coq_type_primitive t0) val0)
        | AssignZPtr (_, sz0, val0) ->
          (match sz0 with
           | Some sz ->
             Coq7_Compilers.ToString.ident_info_union
               (Coq7_Compilers.ToString.ident_info_of_bitwidths_used
                 (Coq7_Compilers.ToString.IntSet.singleton sz))
               (collect_infos_of_arith_expr (Coq_type.Coq_type_primitive
                 Coq_type.Z) val0)
           | None ->
             collect_infos_of_arith_expr (Coq_type.Coq_type_primitive
               Coq_type.Z) val0)
        | DeclareVar (_, sz0, _) ->
          (match sz0 with
           | Some sz ->
             Coq7_Compilers.ToString.ident_info_of_bitwidths_used
               (Coq7_Compilers.ToString.IntSet.singleton sz)
           | None -> Coq7_Compilers.ToString.ident_info_empty)
        | AssignNth (_, _, val0) ->
          collect_infos_of_arith_expr (Coq_type.Coq_type_primitive
            Coq_type.Z) val0

        (** val collect_infos_of_base_typedef_data :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
            Coq7_Compilers.ToString.ident_infos **)

        let rec collect_infos_of_base_typedef_data = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z ->
             (fun n3 ->
               match Obj.magic n3 with
               | Some n4 ->
                 Coq7_Compilers.ToString.ident_info_of_typedefs (n4 :: [])
               | None -> Coq7_Compilers.ToString.ident_info_empty)
           | Coq3_Compilers.Coq_bool ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
           | Coq3_Compilers.Coq_nat ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
           | Coq3_Compilers.Coq_zrange ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
           | Coq3_Compilers.Coq_string ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty))
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          (fun pat ->
            let (tda, tdb) = Obj.magic pat in
            Coq7_Compilers.ToString.ident_info_union
              (collect_infos_of_base_typedef_data a tda)
              (collect_infos_of_base_typedef_data b tdb))
        | Compilers.Coq_base.Coq_type.Coq_list a ->
          (match a with
           | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
             (match t1 with
              | Coq3_Compilers.Z ->
                (fun n3 ->
                  match Obj.magic n3 with
                  | Some n4 ->
                    Coq7_Compilers.ToString.ident_info_of_typedefs (n4 :: [])
                  | None -> Coq7_Compilers.ToString.ident_info_empty)
              | Coq3_Compilers.Coq_bool ->
                (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
              | Coq3_Compilers.Coq_nat ->
                (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
              | Coq3_Compilers.Coq_zrange ->
                (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
              | Coq3_Compilers.Coq_string ->
                (fun _ -> Coq7_Compilers.ToString.ident_info_empty))
           | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
           | Compilers.Coq_base.Coq_type.Coq_list _ ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
           | Compilers.Coq_base.Coq_type.Coq_option _ ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
           | Compilers.Coq_base.Coq_type.Coq_unit ->
             (fun _ -> Coq7_Compilers.ToString.ident_info_empty))
        | Compilers.Coq_base.Coq_type.Coq_option _ ->
          (fun _ -> Coq7_Compilers.ToString.ident_info_empty)
        | Compilers.Coq_base.Coq_type.Coq_unit ->
          (fun _ -> Coq7_Compilers.ToString.ident_info_empty)

        (** val collect_infos_of_typedef_data :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data ->
            Coq7_Compilers.ToString.ident_infos **)

        let collect_infos_of_typedef_data = function
        | Compilers.Coq_type.Coq_base t1 ->
          collect_infos_of_base_typedef_data t1
        | Compilers.Coq_type.Coq_arrow (_, _) ->
          (fun pat ->
            let () = Obj.magic pat in Coq7_Compilers.ToString.ident_info_empty)

        (** val collect_infos_of_arg_typedef_data :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq7_Compilers.ToString.ident_infos **)

        let rec collect_infos_of_arg_typedef_data = function
        | Compilers.Coq_type.Coq_base _ ->
          (fun pat ->
            let () = Obj.magic pat in Coq7_Compilers.ToString.ident_info_empty)
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          (fun pat ->
            let (td, tds) = Obj.magic pat in
            Coq7_Compilers.ToString.ident_info_union
              (collect_infos_of_typedef_data s0 td)
              (collect_infos_of_arg_typedef_data d tds))

        (** val collect_infos :
            expr -> Coq7_Compilers.ToString.ident_infos **)

        let collect_infos e =
          fold_right Coq7_Compilers.ToString.ident_info_union
            Coq7_Compilers.ToString.ident_info_empty
            (map collect_infos_of_stmt e)

        (** val collect_all_infos :
            Coq7_Compilers.Options.skip_typedefs_opt -> expr ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
            Coq7_Compilers.ToString.ident_infos **)

        let collect_all_infos skip_typedefs0 e t0 intypedefs outtypedefs =
          Coq7_Compilers.ToString.ident_info_union (collect_infos e)
            (if skip_typedefs0
             then Coq7_Compilers.ToString.ident_info_empty
             else Coq7_Compilers.ToString.ident_info_union
                    (collect_infos_of_arg_typedef_data t0 intypedefs)
                    (collect_infos_of_typedef_data
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_type.final_codomain t0)) outtypedefs))
       end

      module Coq_name_infos =
       struct
        (** val mem : char list -> char list list -> bool **)

        let mem v m4 =
          existsb (fun s0 -> eqb0 v s0) m4

        (** val add : char list -> char list list -> char list list **)

        let add v m4 =
          if mem v m4 then m4 else v :: m4

        (** val union : char list list -> char list list -> char list list **)

        let union m4 m5 =
          let (l1, l2) = ((length m4), (length m5)) in
          let (m6, m7) = if Nat.leb l1 l2 then (m4, m5) else (m5, m4) in
          fold_right add m7 m6

        (** val empty : char list list **)

        let empty =
          []

        (** val singleton : char list -> char list list **)

        let singleton v =
          add v empty

        (** val of_list : char list list -> char list list **)

        let of_list v =
          v

        (** val collect_live_of_arith_expr :
            (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) ->
            (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) ->
            Coq_type.coq_type -> arith_expr -> char list list **)

        let collect_live_of_arith_expr consider_retargs_live =
          let consider_addr_dead = fun _ _ idc ->
            match idc with
            | Coq_literal _ -> true
            | List_nth _ -> true
            | Addr -> false
            | Dereference -> true
            | Coq_iunop _ -> true
            | Coq_ibinop _ -> true
            | Z_mul_split _ -> true
            | Z_add_with_get_carry _ -> true
            | Z_sub_with_get_borrow _ -> true
            | Z_zselect _ -> true
            | Z_add_modulo -> true
            | Z_static_cast _ -> true
          in
          let rec collect_live_of_arith_expr0 consider_args_live _ = function
          | AppIdent (s0, d, idc, arg) ->
            if consider_args_live s0 d idc
            then collect_live_of_arith_expr0
                   (if consider_retargs_live s0 d idc
                    then consider_args_live
                    else consider_addr_dead) s0 arg
            else empty
          | Var (_, v) -> singleton v
          | Pair (a, b, a0, b0) ->
            union (collect_live_of_arith_expr0 consider_args_live a a0)
              (collect_live_of_arith_expr0 consider_args_live b b0)
          | TT -> empty
          in collect_live_of_arith_expr0

        (** val collect_live_of_stmt :
            (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) -> stmt
            -> char list list **)

        let collect_live_of_stmt consider_retargs_live = function
        | Call val0 ->
          collect_live_of_arith_expr consider_retargs_live (fun _ _ _ ->
            true) Coq_type.Coq_unit val0
        | Comment (_, live_vars) ->
          of_list
            (flat_map (fun v ->
              Coq7_Compilers.ToString.OfPHOAS.names_list_of_var_data
                (projT1 v) (projT2 v)) live_vars)
        | Assign (_, t0, _, _, val0) ->
          collect_live_of_arith_expr consider_retargs_live (fun _ _ _ ->
            true) (Coq_type.Coq_type_primitive t0) val0
        | AssignZPtr (_, _, val0) ->
          collect_live_of_arith_expr consider_retargs_live (fun _ _ _ ->
            true) (Coq_type.Coq_type_primitive Coq_type.Z) val0
        | DeclareVar (_, _, _) -> empty
        | AssignNth (_, _, val0) ->
          collect_live_of_arith_expr consider_retargs_live (fun _ _ _ ->
            true) (Coq_type.Coq_type_primitive Coq_type.Z) val0

        (** val collect_live :
            (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) -> expr
            -> char list list **)

        let collect_live consider_retargs_live e =
          fold_right union empty
            (map (collect_live_of_stmt consider_retargs_live) e)

        (** val rename_if_dead :
            (char list -> char list) -> char list list -> char list ->
            char list **)

        let rename_if_dead rename_dead live v =
          if mem v live then v else rename_dead v

        (** val adjust_dead_of_arith_expr :
            (char list -> char list) -> char list list -> Coq_type.coq_type
            -> arith_expr -> arith_expr **)

        let adjust_dead_of_arith_expr rename_dead live =
          let rec adjust_dead_of_arith_expr0 _ = function
          | AppIdent (s0, d, idc, arg) ->
            AppIdent (s0, d, idc, (adjust_dead_of_arith_expr0 s0 arg))
          | Var (t0, v) -> Var (t0, (rename_if_dead rename_dead live v))
          | Pair (a, b, a0, b0) ->
            Pair (a, b, (adjust_dead_of_arith_expr0 a a0),
              (adjust_dead_of_arith_expr0 b b0))
          | TT -> TT
          in adjust_dead_of_arith_expr0

        (** val adjust_dead_of_stmt :
            (char list -> char list) -> char list list -> stmt -> stmt list **)

        let adjust_dead_of_stmt rename_dead live e = match e with
        | Call val0 ->
          (Call
            (adjust_dead_of_arith_expr rename_dead live Coq_type.Coq_unit
              val0)) :: []
        | Comment (_, _) -> e :: []
        | Assign (declare, t0, sz, name0, val0) ->
          (Assign (declare, t0, sz, name0,
            (adjust_dead_of_arith_expr rename_dead live
              (Coq_type.Coq_type_primitive t0) val0))) :: []
        | AssignZPtr (name0, sz, val0) ->
          (AssignZPtr (name0, sz,
            (adjust_dead_of_arith_expr rename_dead live
              (Coq_type.Coq_type_primitive Coq_type.Z) val0))) :: []
        | DeclareVar (t0, sz, name0) ->
          if mem name0 live then (DeclareVar (t0, sz, name0)) :: [] else []
        | AssignNth (name0, n3, val0) ->
          (AssignNth (name0, n3,
            (adjust_dead_of_arith_expr rename_dead live
              (Coq_type.Coq_type_primitive Coq_type.Z) val0))) :: []

        (** val adjust_dead_of_expr :
            (char list -> char list) -> char list list -> expr -> expr **)

        let adjust_dead_of_expr rename_dead live e =
          flat_map (adjust_dead_of_stmt rename_dead live) e

        (** val adjust_dead :
            (Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool) ->
            (char list -> char list) -> expr -> expr **)

        let adjust_dead consider_retargs_live rename_dead e =
          adjust_dead_of_expr rename_dead
            (collect_live consider_retargs_live e) e
       end

      module LiftDeclare =
       struct
        (** val split_declare : stmt -> stmt list * stmt list **)

        let split_declare e = match e with
        | Call _ -> ([], (e :: []))
        | Comment (_, _) -> ([], (e :: []))
        | Assign (declare, t0, sz, name0, val0) ->
          if declare
          then (((DeclareVar (t0, sz, name0)) :: []), ((Assign (false, t0,
                 sz, name0, val0)) :: []))
          else ([], (e :: []))
        | AssignZPtr (_, _, _) -> ([], (e :: []))
        | DeclareVar (_, _, _) -> ((e :: []), [])
        | AssignNth (_, _, _) -> ([], (e :: []))

        (** val split_declarations : expr -> expr * expr **)

        let split_declarations e =
          let ls = map split_declare e in
          ((flat_map fst ls), (flat_map snd ls))

        (** val lift_declarations : expr -> expr **)

        let lift_declarations e =
          let (decls, rest) = split_declarations e in app decls rest
       end

      module OfPHOAS =
       struct
        type arith_expr_for_base = __

        type arith_expr_for = __

        type coq_LanguageCasts = { bin_op_natural_output : (coq_Z_binop ->
                                                           (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
                                                           ->
                                                           Coq7_Compilers.ToString.Coq_int.coq_type);
                                   bin_op_casts : (coq_Z_binop ->
                                                  Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option ->
                                                  (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
                                                  ->
                                                  Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option * (Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option * Coq7_Compilers.ToString.Coq_int.coq_type
                                                  option));
                                   un_op_casts : (coq_Z_unop ->
                                                 Coq7_Compilers.ToString.Coq_int.coq_type
                                                 option ->
                                                 Coq7_Compilers.ToString.Coq_int.coq_type
                                                 ->
                                                 Coq7_Compilers.ToString.Coq_int.coq_type
                                                 option * Coq7_Compilers.ToString.Coq_int.coq_type
                                                 option);
                                   upcast_on_assignment : bool;
                                   upcast_on_funcall : bool;
                                   explicit_pointer_variables : bool }

        (** val bin_op_natural_output :
            coq_LanguageCasts -> coq_Z_binop ->
            (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
            -> Coq7_Compilers.ToString.Coq_int.coq_type **)

        let bin_op_natural_output languageCasts =
          languageCasts.bin_op_natural_output

        (** val bin_op_casts :
            coq_LanguageCasts -> coq_Z_binop ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
            -> Coq7_Compilers.ToString.Coq_int.coq_type
            option * (Coq7_Compilers.ToString.Coq_int.coq_type
            option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

        let bin_op_casts languageCasts =
          languageCasts.bin_op_casts

        (** val un_op_casts :
            coq_LanguageCasts -> coq_Z_unop ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            Coq7_Compilers.ToString.Coq_int.coq_type ->
            Coq7_Compilers.ToString.Coq_int.coq_type
            option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

        let un_op_casts languageCasts =
          languageCasts.un_op_casts

        (** val upcast_on_assignment : coq_LanguageCasts -> bool **)

        let upcast_on_assignment languageCasts =
          languageCasts.upcast_on_assignment

        (** val upcast_on_funcall : coq_LanguageCasts -> bool **)

        let upcast_on_funcall languageCasts =
          languageCasts.upcast_on_funcall

        (** val explicit_pointer_variables : coq_LanguageCasts -> bool **)

        let explicit_pointer_variables languageCasts =
          languageCasts.explicit_pointer_variables

        type consider_retargs_live_opt =
          Coq_type.coq_type -> Coq_type.coq_type -> ident -> bool

        type rename_dead_opt = char list -> char list

        type lift_declarations_opt = bool

        (** val bin_op_natural_output_opt :
            coq_LanguageCasts -> coq_Z_binop ->
            (Coq7_Compilers.ToString.Coq_int.coq_type
            option * Coq7_Compilers.ToString.Coq_int.coq_type option) ->
            Coq7_Compilers.ToString.Coq_int.coq_type option **)

        let bin_op_natural_output_opt lang_casts idc = function
        | (t1, t2) ->
          (match t1 with
           | Some t3 ->
             (match t2 with
              | Some t4 ->
                Some (lang_casts.bin_op_natural_output idc (t3, t4))
              | None -> None)
           | None -> None)

        (** val bin_op_casts_opt :
            coq_LanguageCasts -> coq_Z_binop ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            (Coq7_Compilers.ToString.Coq_int.coq_type
            option * Coq7_Compilers.ToString.Coq_int.coq_type option) ->
            Coq7_Compilers.ToString.Coq_int.coq_type
            option * (Coq7_Compilers.ToString.Coq_int.coq_type
            option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

        let bin_op_casts_opt lang_casts idc tout = function
        | (t1, t2) ->
          (match t1 with
           | Some t3 ->
             (match t2 with
              | Some t4 -> lang_casts.bin_op_casts idc tout (t3, t4)
              | None -> (tout, (None, None)))
           | None -> (tout, (None, None)))

        (** val un_op_casts_opt :
            coq_LanguageCasts -> coq_Z_unop ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            Coq7_Compilers.ToString.Coq_int.coq_type
            option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

        let un_op_casts_opt lang_casts idc tout = function
        | Some t2 -> lang_casts.un_op_casts idc tout t2
        | None -> (tout, None)

        (** val coq_Zcast :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            bool -> Coq7_Compilers.ToString.Coq_int.coq_type option ->
            arith_expr_for_base -> arith_expr_for_base **)

        let coq_Zcast language_specific_cast_adjustment always desired_type pat =
          let (e, known_type) = Obj.magic pat in
          let eq_known_type_desired_type =
            bind known_type (fun known_type0 ->
              bind desired_type (fun desired_type0 -> Some
                (Coq7_Compilers.ToString.Coq_int.type_beq known_type0
                  desired_type0)))
          in
          if always
          then if language_specific_cast_adjustment
               then (match desired_type with
                     | Some desired_type0 ->
                       Obj.magic ((AppIdent ((Coq_type.Coq_type_primitive
                         Coq_type.Z), (Coq_type.Coq_type_primitive
                         Coq_type.Z), (Z_static_cast desired_type0), e)),
                         (Some desired_type0))
                     | None -> Obj.magic (e, known_type))
               else (match desired_type with
                     | Some desired_type0 ->
                       Obj.magic ((AppIdent ((Coq_type.Coq_type_primitive
                         Coq_type.Z), (Coq_type.Coq_type_primitive
                         Coq_type.Z), (Z_static_cast desired_type0), e)),
                         (Some desired_type0))
                     | None -> Obj.magic (e, known_type))
          else if language_specific_cast_adjustment
               then (match desired_type with
                     | Some desired_type0 ->
                       (match eq_known_type_desired_type with
                        | Some b ->
                          if b
                          then Obj.magic (e, known_type)
                          else Obj.magic ((AppIdent
                                 ((Coq_type.Coq_type_primitive Coq_type.Z),
                                 (Coq_type.Coq_type_primitive Coq_type.Z),
                                 (Z_static_cast desired_type0), e)), (Some
                                 desired_type0))
                        | None ->
                          Obj.magic ((AppIdent ((Coq_type.Coq_type_primitive
                            Coq_type.Z), (Coq_type.Coq_type_primitive
                            Coq_type.Z), (Z_static_cast desired_type0), e)),
                            (Some desired_type0)))
                     | None -> Obj.magic (e, known_type))
               else Obj.magic (e, known_type)

        (** val get_Zcast_down_if_needed :
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            Coq7_Compilers.ToString.Coq_int.coq_type option **)

        let get_Zcast_down_if_needed desired_type known_type =
          match desired_type with
          | Some desired_type0 ->
            (match known_type with
             | Some known_type0 ->
               if Coq7_Compilers.ToString.Coq_int.is_tighter_than known_type0
                    desired_type0
               then None
               else Some desired_type0
             | None -> Some desired_type0)
          | None -> None

        (** val coq_Zcast_down_if_needed :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            arith_expr_for_base -> arith_expr_for_base **)

        let coq_Zcast_down_if_needed language_specific_cast_adjustment desired_type pat =
          let (e, known_type) = Obj.magic pat in
          coq_Zcast language_specific_cast_adjustment false
            (get_Zcast_down_if_needed desired_type known_type)
            (Obj.magic (e, known_type))

        (** val cast_down_if_needed :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            arith_expr_for_base -> arith_expr_for_base **)

        let cast_down_if_needed language_specific_cast_adjustment =
          let rec cast_down_if_needed0 = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z ->
               Obj.magic coq_Zcast_down_if_needed
                 language_specific_cast_adjustment
             | Coq3_Compilers.Coq_bool -> (fun _ x -> x)
             | Coq3_Compilers.Coq_nat -> (fun _ x -> x)
             | Coq3_Compilers.Coq_zrange -> (fun _ x -> x)
             | Coq3_Compilers.Coq_string -> (fun _ x -> x))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (r1, r2) = Obj.magic pat in
              (fun pat0 ->
              let (e1, e2) = Obj.magic pat0 in
              Obj.magic ((cast_down_if_needed0 a r1 e1),
                (cast_down_if_needed0 b r2 e2))))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun r1 ls ->
              match Obj.magic r1 with
              | Some r2 ->
                Obj.magic map (fun pat ->
                  let (r0, e) = pat in cast_down_if_needed0 a r0 e)
                  (combine r2 (Obj.magic ls))
              | None -> ls)
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun r1 ls ->
              match Obj.magic r1 with
              | Some r2 ->
                Obj.magic option_map (fun pat ->
                  let (r0, e) = pat in cast_down_if_needed0 a r0 e)
                  (combine0 r2 (Obj.magic ls))
              | None -> ls)
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ x -> x)
          in cast_down_if_needed0

        (** val get_Zcast_up_if_needed :
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            Coq7_Compilers.ToString.Coq_int.coq_type option **)

        let get_Zcast_up_if_needed desired_type known_type =
          match desired_type with
          | Some desired_type0 ->
            (match known_type with
             | Some known_type0 ->
               if Coq7_Compilers.ToString.Coq_int.is_tighter_than
                    desired_type0 known_type0
               then None
               else Some desired_type0
             | None -> None)
          | None -> None

        (** val coq_Zcast_up_if_needed :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq7_Compilers.ToString.Coq_int.coq_type option ->
            arith_expr_for_base -> arith_expr_for_base **)

        let coq_Zcast_up_if_needed language_specific_cast_adjustment desired_type pat =
          let (e, known_type) = Obj.magic pat in
          coq_Zcast language_specific_cast_adjustment false
            (get_Zcast_up_if_needed desired_type known_type)
            (Obj.magic (e, known_type))

        (** val cast_up_if_needed :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            arith_expr_for_base -> arith_expr_for_base **)

        let cast_up_if_needed language_specific_cast_adjustment =
          let rec cast_up_if_needed0 = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z ->
               Obj.magic coq_Zcast_up_if_needed
                 language_specific_cast_adjustment
             | Coq3_Compilers.Coq_bool -> (fun _ x -> x)
             | Coq3_Compilers.Coq_nat -> (fun _ x -> x)
             | Coq3_Compilers.Coq_zrange -> (fun _ x -> x)
             | Coq3_Compilers.Coq_string -> (fun _ x -> x))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (r1, r2) = Obj.magic pat in
              (fun pat0 ->
              let (e1, e2) = Obj.magic pat0 in
              Obj.magic ((cast_up_if_needed0 a r1 e1),
                (cast_up_if_needed0 b r2 e2))))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun r1 ls ->
              match Obj.magic r1 with
              | Some r2 ->
                Obj.magic map (fun pat ->
                  let (r0, e) = pat in cast_up_if_needed0 a r0 e)
                  (combine r2 (Obj.magic ls))
              | None -> ls)
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun r1 ls ->
              match Obj.magic r1 with
              | Some r2 ->
                Obj.magic option_map (fun pat ->
                  let (r0, e) = pat in cast_up_if_needed0 a r0 e)
                  (combine0 r2 (Obj.magic ls))
              | None -> ls)
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ x -> x)
          in cast_up_if_needed0

        (** val cast :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            bool -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            -> Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            arith_expr_for_base -> arith_expr_for_base **)

        let cast language_specific_cast_adjustment =
          let rec cast0 always = function
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z ->
               Obj.magic coq_Zcast language_specific_cast_adjustment always
             | Coq3_Compilers.Coq_bool -> (fun _ x -> x)
             | Coq3_Compilers.Coq_nat -> (fun _ x -> x)
             | Coq3_Compilers.Coq_zrange -> (fun _ x -> x)
             | Coq3_Compilers.Coq_string -> (fun _ x -> x))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (r1, r2) = Obj.magic pat in
              (fun pat0 ->
              let (e1, e2) = Obj.magic pat0 in
              Obj.magic ((cast0 always a r1 e1), (cast0 always b r2 e2))))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (fun r1 ls ->
              match Obj.magic r1 with
              | Some r2 ->
                Obj.magic map (fun pat ->
                  let (r0, e) = pat in cast0 always a r0 e)
                  (combine r2 (Obj.magic ls))
              | None -> ls)
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun r1 ls ->
              match Obj.magic r1 with
              | Some r2 ->
                Obj.magic option_map (fun pat ->
                  let (r0, e) = pat in cast0 always a r0 e)
                  (combine0 r2 (Obj.magic ls))
              | None -> ls)
          | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ x -> x)
          in cast0

        (** val arith_bin_arith_expr_of_PHOAS_ident :
            coq_LanguageCasts ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            coq_Z_binop -> Coq7_Compilers.ToString.Coq_int.coq_type option ->
            arith_expr_for -> arith_expr_for **)

        let arith_bin_arith_expr_of_PHOAS_ident lang_casts language_specific_cast_adjustment idc desired_type pat =
          let (a, a0) = Obj.magic pat in
          let (e1, t1) = a in
          let (e2, t2) = a0 in
          let (cstout, p) =
            bin_op_casts_opt lang_casts idc desired_type (t1, t2)
          in
          let (cst1, cst2) = p in
          let typ =
            bin_op_natural_output_opt lang_casts idc ((sequence cst1 t1),
              (sequence cst2 t2))
          in
          let (a1, a2) =
            ((coq_Zcast language_specific_cast_adjustment false cst1
               (Obj.magic (e1, t1))),
            (coq_Zcast language_specific_cast_adjustment false cst2
              (Obj.magic (e2, t2))))
          in
          let (e3, _) = Obj.magic a1 in
          let (e4, _) = Obj.magic a2 in
          coq_Zcast language_specific_cast_adjustment false cstout
            (Obj.magic ((AppIdent ((Coq_type.Coq_prod
              ((Coq_type.Coq_type_primitive Coq_type.Z),
              (Coq_type.Coq_type_primitive Coq_type.Z))),
              (Coq_type.Coq_type_primitive Coq_type.Z), (Coq_ibinop idc),
              (Pair ((Coq_type.Coq_type_primitive Coq_type.Z),
              (Coq_type.Coq_type_primitive Coq_type.Z), e3, e4)))), typ))

        (** val arith_un_arith_expr_of_PHOAS_ident :
            coq_LanguageCasts ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            coq_Z_unop -> Coq7_Compilers.ToString.Coq_int.coq_type option ->
            arith_expr_for -> arith_expr_for **)

        let arith_un_arith_expr_of_PHOAS_ident lang_casts language_specific_cast_adjustment idc desired_type pat =
          let (e, t0) = Obj.magic pat in
          let (cstout, cst) = un_op_casts_opt lang_casts idc desired_type t0
          in
          let typ = sequence cst t0 in
          let (e0, _) =
            Obj.magic coq_Zcast language_specific_cast_adjustment false cst
              (e, t0)
          in
          coq_Zcast language_specific_cast_adjustment false cstout
            (Obj.magic ((AppIdent ((Coq_type.Coq_type_primitive Coq_type.Z),
              (Coq_type.Coq_type_primitive Coq_type.Z), (Coq_iunop idc),
              e0)), typ))

        (** val maybe_log2 : z -> z option **)

        let maybe_log2 s0 =
          if Coq_Z.eqb (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 s0)) s0
          then Some (Coq_Z.log2 s0)
          else None

        (** val maybe_loglog2 : z -> nat option **)

        let maybe_loglog2 s0 =
          bind (maybe_log2 s0) (fun v ->
            bind (maybe_log2 v) (fun v0 ->
              if Coq_Z.leb Z0 v0 then Some (Coq_Z.to_nat v0) else None))

        (** val arith_expr_of_PHOAS_literal_Z :
            Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt -> z
            -> Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            arith_expr_for_base **)

        let arith_expr_of_PHOAS_literal_Z relax_zrange language_specific_cast_adjustment =
          let t0 = Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z
          in
          (fun v r0 ->
          cast_down_if_needed language_specific_cast_adjustment
            (Compilers.Coq_type.final_codomain
              (Coq5_Compilers.Coercions.base t0)) r0
            (Obj.magic ((AppIdent (Coq_type.Coq_unit,
              (Coq_type.Coq_type_primitive Coq_type.Z), (Coq_literal v),
              TT)), (Some
              (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                (relax_zrange { lower = v; upper = v }))))))

        (** val arith_expr_of_PHOAS_ident :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
            char list list) sum, arith_expr_for_base)
            Compilers.Coq_type.interpM_final **)

        let arith_expr_of_PHOAS_ident lang_casts relax_zrange language_specific_cast_adjustment t0 idc = match idc with
        | Coq3_Compilers.Coq_ident_Literal (t1, v) ->
          (match t1 with
           | Coq3_Compilers.Z ->
             (fun v0 r0 ->
               Obj.magic (Inl
                 (arith_expr_of_PHOAS_literal_Z relax_zrange
                   language_specific_cast_adjustment (Obj.magic v0) r0)))
           | Coq3_Compilers.Coq_bool -> (fun v0 _ -> Obj.magic (Inl v0))
           | Coq3_Compilers.Coq_nat -> (fun v0 _ -> Obj.magic (Inl v0))
           | Coq3_Compilers.Coq_zrange -> (fun v0 _ -> Obj.magic (Inl v0))
           | Coq3_Compilers.Coq_string -> (fun v0 _ -> Obj.magic (Inl v0))) v
        | Coq3_Compilers.Coq_ident_comment t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_comment_no_keep t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_value_barrier ->
          (fun r0 ->
            Obj.magic (fun pat ->
              let (x, rx) = pat in
              (match rx with
               | Some ty ->
                 Inl
                   (cast_down_if_needed language_specific_cast_adjustment
                     (Compilers.Coq_type.final_codomain
                       (Compilers.Coq_type.Coq_arrow
                       ((Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z))))) r0
                     (Obj.magic ((AppIdent ((Coq_type.Coq_type_primitive
                       Coq_type.Z), (Coq_type.Coq_type_primitive Coq_type.Z),
                       (Coq_iunop (Z_value_barrier ty)), x)), (Some ty))))
               | None ->
                 Inr
                   (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('u'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('s'::('i'::('z'::('e'::(' '::('f'::('o'::('r'::(' '::('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))))))))))))))))))))))))))))))))))) :: []))))
        | Coq3_Compilers.Coq_ident_Nat_succ ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Nat_pred ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Nat_max ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Nat_mul ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Nat_add ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Nat_sub ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Nat_eqb ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_nil _ -> (fun _ -> Obj.magic (Inl []))
        | Coq3_Compilers.Coq_ident_cons t1 ->
          (fun r0 ->
            Obj.magic (fun x xs -> Inl
              (cast_down_if_needed language_specific_cast_adjustment
                (Compilers.Coq_type.final_codomain
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  t1), (Compilers.Coq_type.Coq_arrow
                  ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1)),
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list t1))))))) r0
                (Obj.magic (x :: xs)))))
        | Coq3_Compilers.Coq_ident_tt -> (fun _ -> Obj.magic (Inl ()))
        | Coq3_Compilers.Coq_ident_pair (_, _) ->
          (fun _ ->
            Obj.magic (fun _ _ -> Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fst (a, b) ->
          (fun r0 ->
            Obj.magic (fun xy -> Inl
              (cast_down_if_needed language_specific_cast_adjustment
                (Compilers.Coq_type.final_codomain
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                  (Compilers.Coq_type.Coq_base a)))) r0 (fst xy))))
        | Coq3_Compilers.Coq_ident_snd (a, b) ->
          (fun r0 ->
            Obj.magic (fun xy -> Inl
              (cast_down_if_needed language_specific_cast_adjustment
                (Compilers.Coq_type.final_codomain
                  (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                  (Compilers.Coq_type.Coq_base b)))) r0 (snd xy))))
        | Coq3_Compilers.Coq_ident_prod_rect (t1, t2, t3) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t3))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (t1, t2))),
              (Compilers.Coq_type.Coq_base t3))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_bool_rect t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              t1))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_bool_rect_nodep t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base
              t1))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_nat_rect t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              t1))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              t1))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_eager_nat_rect t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              t1))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              t1))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_nat_rect_arrow (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              t2))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              t2))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_list_rect (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t2))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t2))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_eager_list_rect (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t2))))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t2))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_list_rect_arrow (t1, t2, t3) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t3))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t3))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t3))))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t3))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t1, t2, t3) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t3))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t3))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t2), (Compilers.Coq_type.Coq_base
              t3))))))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_base t3))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_list_case (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t2))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base t2))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_length t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_seq ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_firstn t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_skipn t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_repeat t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_combine (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t2)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (t1, t2)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_map (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t2)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_app t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_rev t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_flat_map (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t2)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t2)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_partition t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_list t1),
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_filter t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_fold_right (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t2), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              t1))))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t2)),
              (Compilers.Coq_type.Coq_base t1))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_update_nth t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t1))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_List_nth_default t1 ->
          (match t1 with
           | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
             (match t2 with
              | Coq3_Compilers.Z ->
                (fun r0 ->
                  Obj.magic (fun _ ls n3 ->
                    nth_default (Inr
                      ((append
                         ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[])))))))))))))))))))
                         (show0
                           (Obj.magic
                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_interp
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Coq_nat)) n3)) :: []))
                      (map (fun x -> Inl
                        (cast_down_if_needed
                          language_specific_cast_adjustment
                          (Compilers.Coq_type.final_codomain
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))),
                            (Compilers.Coq_type.Coq_arrow
                            ((Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Coq_nat)),
                            (Compilers.Coq_type.Coq_base
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z))))))))) r0 x)) ls) n3))
              | Coq3_Compilers.Coq_bool ->
                (fun _ ->
                  Compilers.Coq_type.interpM_return
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_bool)))))))) (Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                       (show0
                         (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                           t0) idc)) :: [])))
              | Coq3_Compilers.Coq_nat ->
                (fun _ ->
                  Compilers.Coq_type.interpM_return
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)))))))) (Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                       (show0
                         (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                           t0) idc)) :: [])))
              | Coq3_Compilers.Coq_zrange ->
                (fun _ ->
                  Compilers.Coq_type.interpM_return
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_zrange)))))))) (Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                       (show0
                         (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                           t0) idc)) :: [])))
              | Coq3_Compilers.Coq_string ->
                (fun _ ->
                  Compilers.Coq_type.interpM_return
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_string)),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_list
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_string))),
                    (Compilers.Coq_type.Coq_arrow
                    ((Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_base.Coq_type.Coq_type_base
                    Coq3_Compilers.Coq_string)))))))) (Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                       (show0
                         (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                           t0) idc)) :: []))))
           | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
             (fun _ ->
               Compilers.Coq_type.interpM_return
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_prod (a, b)))),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))))))) (Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                    (show0
                      (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                      idc)) :: [])))
           | Compilers.Coq_base.Coq_type.Coq_list a ->
             (fun _ ->
               Compilers.Coq_type.interpM_return
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list a)),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_list a))),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list a)))))))) (Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                    (show0
                      (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                      idc)) :: [])))
           | Compilers.Coq_base.Coq_type.Coq_option a ->
             (fun _ ->
               Compilers.Coq_type.interpM_return
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_option a)),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_option a))),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_option a)))))))) (Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                    (show0
                      (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                      idc)) :: [])))
           | Compilers.Coq_base.Coq_type.Coq_unit ->
             (fun _ ->
               Compilers.Coq_type.interpM_return
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 Compilers.Coq_base.Coq_type.Coq_unit),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 Compilers.Coq_base.Coq_type.Coq_unit)),
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 Compilers.Coq_base.Coq_type.Coq_unit))))))) (Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                    (show0
                      (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                      idc)) :: []))))
        | Coq3_Compilers.Coq_ident_eager_List_nth_default t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list t1)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              t1))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_add ->
          (fun r0 ->
            Obj.magic (fun x y -> Inl
              (arith_bin_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_add (Obj.magic r0)
                (Obj.magic (x, y)))))
        | Coq3_Compilers.Coq_ident_Z_mul ->
          (fun r0 ->
            Obj.magic (fun x y -> Inl
              (arith_bin_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_mul (Obj.magic r0)
                (Obj.magic (x, y)))))
        | Coq3_Compilers.Coq_ident_Z_pow ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_sub ->
          (fun r0 ->
            Obj.magic (fun x y -> Inl
              (arith_bin_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_sub (Obj.magic r0)
                (Obj.magic (x, y)))))
        | Coq3_Compilers.Coq_ident_Z_opp ->
          (fun r0 ->
            Obj.magic (fun x ->
              let zero1 = ((AppIdent (Coq_type.Coq_unit,
                (Coq_type.Coq_type_primitive Coq_type.Z), (Coq_literal Z0),
                TT)), (Some
                (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                  (relax_zrange { lower = Z0; upper = Z0 }))))
              in
              Inl
              (arith_bin_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_sub (Obj.magic r0)
                (Obj.magic (zero1, x)))))
        | Coq3_Compilers.Coq_ident_Z_div ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_modulo ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_eqb ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_leb ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_ltb ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_geb ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_gtb ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_bool)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_log2 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_log2_up ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_of_nat ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_to_nat ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_shiftr ->
          (fun r0 ->
            Obj.magic (fun e pat ->
              let (offset, _) = pat in
              (match invert_literal (Coq_type.Coq_type_primitive Coq_type.Z)
                       offset with
               | Some offset0 ->
                 Inl
                   (arith_un_arith_expr_of_PHOAS_ident lang_casts
                     language_specific_cast_adjustment (Z_shiftr offset0)
                     (Obj.magic r0) e)
               | None ->
                 Inr
                   (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('r'::('i'::('g'::('h'::('t'::('-'::('s'::('h'::('i'::('f'::('t'::(' '::('b'::('y'::(' '::('a'::(' '::('n'::('o'::('n'::('-'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::[])))))))))))))))))))))))))))))))))))) :: []))))
        | Coq3_Compilers.Coq_ident_Z_shiftl ->
          (fun r0 ->
            Obj.magic (fun e pat ->
              let (offset, _) = pat in
              (match invert_literal (Coq_type.Coq_type_primitive Coq_type.Z)
                       offset with
               | Some offset0 ->
                 Inl
                   (arith_un_arith_expr_of_PHOAS_ident lang_casts
                     language_specific_cast_adjustment (Z_shiftl offset0)
                     (Obj.magic r0) e)
               | None ->
                 Inr
                   (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('l'::('e'::('f'::('t'::('-'::('s'::('h'::('i'::('f'::('t'::(' '::('b'::('y'::(' '::('a'::(' '::('n'::('o'::('n'::('-'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::[]))))))))))))))))))))))))))))))))))) :: []))))
        | Coq3_Compilers.Coq_ident_Z_land ->
          (fun r0 ->
            Obj.magic (fun x y -> Inl
              (arith_bin_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_land (Obj.magic r0)
                (Obj.magic (x, y)))))
        | Coq3_Compilers.Coq_ident_Z_lor ->
          (fun r0 ->
            Obj.magic (fun x y -> Inl
              (arith_bin_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_lor (Obj.magic r0)
                (Obj.magic (x, y)))))
        | Coq3_Compilers.Coq_ident_Z_min ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_max ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_mul_split ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_mul_high ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_ltz ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_zselect ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_add_modulo ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
          (fun r0 ->
            Obj.magic (fun pat ->
              let (bitwidth, _) = pat in
              (fun e pat0 ->
              let (offset, _) = pat0 in
              (match invert_literal (Coq_type.Coq_type_primitive Coq_type.Z)
                       bitwidth with
               | Some bitwidth0 ->
                 (match invert_literal (Coq_type.Coq_type_primitive
                          Coq_type.Z) offset with
                  | Some offset0 ->
                    let rpre_out = Some
                      (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                        { lower = Z0; upper =
                        (Coq_Z.max (Coq_Z.pow (Zpos (XO XH)) offset0)
                          (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth0)
                            (Zpos XH))) })
                    in
                    let shifted =
                      arith_un_arith_expr_of_PHOAS_ident lang_casts
                        language_specific_cast_adjustment (Z_shiftl offset0)
                        rpre_out e
                    in
                    let truncated =
                      arith_bin_arith_expr_of_PHOAS_ident lang_casts
                        language_specific_cast_adjustment Z_land
                        (Obj.magic r0)
                        (Obj.magic (shifted,
                          (arith_expr_of_PHOAS_literal_Z relax_zrange
                            language_specific_cast_adjustment
                            (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) bitwidth0)
                              (Zpos XH))
                            (Obj.magic (Some
                              (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                { lower = Z0; upper =
                                (Coq_Z.sub
                                  (Coq_Z.pow (Zpos (XO XH)) bitwidth0) (Zpos
                                  XH)) }))))))
                    in
                    Inl truncated
                  | None ->
                    Inr
                      (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('('::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('i'::('n'::('g'::(')'::(' '::('l'::('e'::('f'::('t'::('-'::('s'::('h'::('i'::('f'::('t'::(' '::('b'::('y'::(' '::('a'::(' '::('n'::('o'::('n'::('-'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::[])))))))))))))))))))))))))))))))))))))))))))))))) :: []))
               | None ->
                 (match invert_literal (Coq_type.Coq_type_primitive
                          Coq_type.Z) offset with
                  | Some _ ->
                    Inr
                      (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('l'::('e'::('f'::('t'::('-'::('s'::('h'::('i'::('f'::('t'::(' '::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::('d'::(' '::('t'::('o'::(' '::('a'::(' '::('n'::('o'::('n'::('-'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
                  | None ->
                    Inr
                      (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('('::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('i'::('n'::('g'::(')'::(' '::('l'::('e'::('f'::('t'::('-'::('s'::('h'::('i'::('f'::('t'::(' '::('b'::('y'::(' '::('a'::(' '::('n'::('o'::('n'::('-'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::[])))))))))))))))))))))))))))))))))))))))))))))))) :: []))))))
        | Coq3_Compilers.Coq_ident_Z_bneg ->
          (fun r0 ->
            Obj.magic (fun x -> Inl
              (arith_un_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_bneg (Obj.magic r0) x)))
        | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
          (fun rout ->
            Obj.magic (fun pat ->
              let (e, r0) = pat in
              (fun pat0 ->
              let (modulus, _) = pat0 in
              (match invert_literal (Coq_type.Coq_type_primitive Coq_type.Z)
                       modulus with
               | Some modulus0 ->
                 (match maybe_loglog2 modulus0 with
                  | Some lgbitwidth ->
                    let ty = Coq7_Compilers.ToString.Coq_int.Coq_unsigned
                      lgbitwidth
                    in
                    let rin' = Some ty in
                    let (e0, _) =
                      Obj.magic coq_Zcast language_specific_cast_adjustment
                        false rin' (e, r0)
                    in
                    Inl
                    (cast_down_if_needed language_specific_cast_adjustment
                      (Compilers.Coq_type.final_codomain
                        (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))))))) rout
                      (cast_up_if_needed language_specific_cast_adjustment
                        (Compilers.Coq_type.final_codomain
                          (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_arrow
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z)), (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))))))) rout
                        (Obj.magic ((AppIdent ((Coq_type.Coq_type_primitive
                          Coq_type.Z), (Coq_type.Coq_type_primitive
                          Coq_type.Z), (Coq_iunop (Z_lnot ty)), e0)), rin'))))
                  | None ->
                    Inr
                      ((append
                         ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('m'::('o'::('d'::('u'::('l'::('u'::('s'::(' '::('f'::('o'::('r'::(' '::('Z'::('.'::('l'::('n'::('o'::('t'::(' '::('('::('n'::('o'::('t'::(' '::('2'::('^'::('('::('2'::('^'::('_'::(')'::(')'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))
                         (show0 Decimal.show_Z modulus0)) :: []))
               | None ->
                 Inr
                   (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('o'::('n'::('-'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('m'::('o'::('d'::('u'::('l'::('u'::('s'::(' '::('f'::('o'::('r'::(' '::('Z'::('.'::('l'::('n'::('o'::('t'::[])))))))))))))))))))))))))))))))))))))) :: [])))))
        | Coq3_Compilers.Coq_ident_Z_lxor ->
          (fun r0 ->
            Obj.magic (fun x y -> Inl
              (arith_bin_arith_expr_of_PHOAS_ident lang_casts
                language_specific_cast_adjustment Z_lxor (Obj.magic r0)
                (Obj.magic (x, y)))))
        | Coq3_Compilers.Coq_ident_Z_rshi ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_cc_m ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_cast ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Z_cast2 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))), (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Some t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_option t1)))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_None t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_option t1)) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_option_rect (t1, t2) ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              t1), (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_base t2))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_option t1)),
              (Compilers.Coq_type.Coq_base t2))))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_Build_zrange ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_zrange_rect t1 ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
              (Compilers.Coq_type.Coq_base t1))))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base
              t1))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_add ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_addc ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_sub ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_subb ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_mulll ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_mullh ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_mulhl ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_mulhh ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_rshi ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_selc ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_selm ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_sell ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))
        | Coq3_Compilers.Coq_ident_fancy_addm ->
          (fun _ ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_prod
              ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Z)))), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
              (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('i'::('n'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])))

        (** val collect_args_and_apply_unknown_casts :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type ->
            (Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
            char list list) sum, arith_expr_for_base)
            Compilers.Coq_type.interpM_final) -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (__, char list list) sum,
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (arith_expr_for_base, char list list) sum)
            Compilers.Coq_type.interpM_final **)

        let rec collect_args_and_apply_unknown_casts = function
        | Compilers.Coq_type.Coq_base _ -> (fun v -> Obj.magic (Inl v))
        | Compilers.Coq_type.Coq_arrow (s0, d) ->
          (match s0 with
           | Compilers.Coq_type.Coq_base s1 ->
             (fun f ->
               Obj.magic (fun x ->
                 match x
                         (Coq7_Compilers.ToString.Coq_int.Coq_option.coq_None
                           s1) with
                 | Inl x' ->
                   collect_args_and_apply_unknown_casts d (fun rout ->
                     Obj.magic f rout x')
                 | Inr errs -> Compilers.Coq_type.interpM_return d (Inr errs)))
           | Compilers.Coq_type.Coq_arrow (s1, d0) ->
             (fun _ ->
               Compilers.Coq_type.interpM_return
                 (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
                 (s1, d0)), d)) (Inr
                 (('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('h'::('i'::('g'::('h'::('e'::('r'::('-'::('o'::('r'::('d'::('e'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::[]))))))))))))))))))))))))))))) :: []))))

        (** val collect_args_and_apply_known_casts :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
            ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
            char list list) sum,
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (arith_expr_for_base, char list list) sum)
            Compilers.Coq_type.interpM_final, char list list) sum **)

        let collect_args_and_apply_known_casts language_specific_cast_adjustment =
          let bind2_err = fun _ _ _ v1 v2 f ->
            match v1 with
            | Inl x1 ->
              (match v2 with
               | Inl x2 -> f x1 x2
               | Inr err0 -> Inr err0)
            | Inr err1 ->
              (match v2 with
               | Inl _ -> Inr err1
               | Inr err2 -> Inr (app err1 err2))
          in
          (fun t0 idc ->
          match idc with
          | Coq3_Compilers.Coq_ident_Literal (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_comment _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_value_barrier ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Nat_succ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Nat_pred ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Nat_max ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Nat_mul ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Nat_add ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Nat_sub ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Nat_eqb ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_nil _ ->
            Inl (Obj.magic (Inl (fun _ -> Inl [])))
          | Coq3_Compilers.Coq_ident_cons t1 ->
            Inl
              (Obj.magic (fun x xs -> Inl (fun rls ->
                let mkcons = fun r0 rs ->
                  bind2_err __ __ __ (x r0) (xs rs) (fun x0 xs0 -> Inl
                    (x0 :: xs0))
                in
                (match rls with
                 | Some y ->
                   (match y with
                    | [] ->
                      mkcons
                        (Coq7_Compilers.ToString.Coq_int.Coq_option.coq_None
                          t1)
                        (Coq7_Compilers.ToString.Coq_int.Coq_option.coq_None
                          (Compilers.Coq_base.Coq_type.Coq_list t1))
                    | r0 :: rs -> Obj.magic mkcons r0 (Some rs))
                 | None ->
                   mkcons
                     (Coq7_Compilers.ToString.Coq_int.Coq_option.coq_None t1)
                     (Coq7_Compilers.ToString.Coq_int.Coq_option.coq_None
                       (Compilers.Coq_base.Coq_type.Coq_list t1))))))
          | Coq3_Compilers.Coq_ident_tt ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_pair (_, _) ->
            Inl
              (Obj.magic (fun ea eb -> Inl (fun pat ->
                let (ra, rb) = pat in
                bind2_err __ __ __ (ea ra) (eb rb) (fun ea' eb' -> Inl (ea',
                  eb')))))
          | Coq3_Compilers.Coq_ident_fst (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_snd (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_bool_rect _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_nat_rect _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_list_case (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_length _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_seq ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_firstn _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_skipn _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_repeat _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_map (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_app _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_rev _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_partition _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_filter _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_add ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_mul ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_pow ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_sub ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_opp ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_div ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_modulo ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_eqb ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_leb ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_ltb ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_geb ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_gtb ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_log2 ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_log2_up ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_of_nat ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_to_nat ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_shiftr ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_shiftl ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_land ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_lor ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_min ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_max ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_mul_split ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_mul_high ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_ltz ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_zselect ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_bneg ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_lxor ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_rshi ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_cc_m ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Z_cast ->
            Inl
              (Obj.magic (fun r0 arg ->
                match r0 () with
                | Inl r1 ->
                  let r2 = Some
                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed r1)
                  in
                  Inl (fun r'0 ->
                  if language_specific_cast_adjustment
                  then (match arg r2 with
                        | Inl arg0 ->
                          Inl
                            (coq_Zcast_down_if_needed
                              language_specific_cast_adjustment r'0 arg0)
                        | Inr err0 -> Inr err0)
                  else (match arg None with
                        | Inl arg0 ->
                          Inl
                            (coq_Zcast language_specific_cast_adjustment true
                              r2 arg0)
                        | Inr err0 -> Inr err0))
                | Inr err0 -> Inr err0))
          | Coq3_Compilers.Coq_ident_Z_cast2 ->
            Inl
              (Obj.magic (fun r0 arg ->
                match r0 ((), ()) with
                | Inl r1 ->
                  let r2 = ((Some
                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                      (fst r1))), (Some
                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                      (snd r1))))
                  in
                  Inl (fun r'0 ->
                  if language_specific_cast_adjustment
                  then (match arg r2 with
                        | Inl arg0 ->
                          Inl
                            (cast_down_if_needed
                              language_specific_cast_adjustment
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z),
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))) r'0 arg0)
                        | Inr err0 -> Inr err0)
                  else (match arg (None, None) with
                        | Inl arg0 ->
                          Inl
                            (cast language_specific_cast_adjustment true
                              (Compilers.Coq_base.Coq_type.Coq_prod
                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z),
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z))) (Obj.magic r2) arg0)
                        | Inr err0 -> Inr err0))
                | Inr err0 -> Inr err0))
          | Coq3_Compilers.Coq_ident_Some _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_None _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_Build_zrange ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_add ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_addc ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_sub ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_subb ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_mulll ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_mullh ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_rshi ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_selc ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_selm ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_sell ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: [])
          | Coq3_Compilers.Coq_ident_fancy_addm ->
            Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('r'::('e'::(' '::('c'::('a'::('s'::('t'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(' '::('w'::('a'::('s'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident t0)
                   idc)) :: []))

        (** val collect_args_and_apply_casts :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.ident ->
            (Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, (__,
            char list list) sum, arith_expr_for_base)
            Compilers.Coq_type.interpM_final) -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (__, char list list) sum,
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (arith_expr_for_base, char list list) sum)
            Compilers.Coq_type.interpM_final **)

        let collect_args_and_apply_casts language_specific_cast_adjustment t0 idc convert_no_cast =
          match collect_args_and_apply_known_casts
                  language_specific_cast_adjustment t0 idc with
          | Inl res -> res
          | Inr _ -> collect_args_and_apply_unknown_casts t0 convert_no_cast

        (** val arith_expr_of_base_PHOAS_Var :
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (arith_expr_for_base, char list list) sum **)

        let arith_expr_of_base_PHOAS_Var language_specific_cast_adjustment =
          let bind2_err = fun _ _ _ v1 v2 f ->
            match v1 with
            | Inl x1 ->
              (match v2 with
               | Inl x2 -> f x1 x2
               | Inr err0 -> Inr err0)
            | Inr err1 ->
              (match v2 with
               | Inl _ -> Inr err1
               | Inr err2 -> Inr (app err1 err2))
          in
          let rec arith_expr_of_base_PHOAS_Var0 t0 = match t0 with
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z ->
               (fun pat ->
                 let (p, _) = Obj.magic pat in
                 let (p0, r0) = p in
                 let (n3, is_ptr) = p0 in
                 (fun r'0 ->
                 let v =
                   if is_ptr
                   then AppIdent ((Coq_type.Coq_type_primitive
                          Coq_type.Zptr), (Coq_type.Coq_type_primitive
                          Coq_type.Z), Dereference, (Var (Coq_type.Zptr, n3)))
                   else Var (Coq_type.Z, n3)
                 in
                 Inl
                 (cast_down_if_needed language_specific_cast_adjustment
                   (Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z) r'0 (Obj.magic (v, r0)))))
             | Coq3_Compilers.Coq_bool ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Coq3_Compilers.Coq_nat ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Coq3_Compilers.Coq_zrange ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Coq3_Compilers.Coq_string ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: [])))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (da, db) = Obj.magic pat in
              (fun pat0 ->
              let (ra, rb) = Obj.magic pat0 in
              Obj.magic bind2_err __ __ __
                (arith_expr_of_base_PHOAS_Var0 a da ra)
                (arith_expr_of_base_PHOAS_Var0 b db rb) (fun ea eb -> Inl
                (ea, eb))))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (match a with
             | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
               (match t1 with
                | Coq3_Compilers.Z ->
                  (fun pat ->
                    let (p, _) = Obj.magic pat in
                    let (p0, len) = p in
                    let (n3, r0) = p0 in
                    (fun _ -> Inl
                    (Obj.magic map (fun i -> ((AppIdent
                      ((Coq_type.Coq_type_primitive Coq_type.Zptr),
                      (Coq_type.Coq_type_primitive Coq_type.Z), (List_nth i),
                      (Var (Coq_type.Zptr, n3)))), r0)) (seq O len))))
                | Coq3_Compilers.Coq_bool ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: []))
                | Coq3_Compilers.Coq_nat ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: []))
                | Coq3_Compilers.Coq_zrange ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: []))
                | Coq3_Compilers.Coq_string ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: [])))
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Compilers.Coq_base.Coq_type.Coq_list _ ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Compilers.Coq_base.Coq_type.Coq_option _ ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Compilers.Coq_base.Coq_type.Coq_unit ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: [])))
          | Compilers.Coq_base.Coq_type.Coq_option _ ->
            (fun _ _ -> Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                 (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                   t0)) :: []))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            (fun _ _ -> Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                 (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                   t0)) :: []))
          in arith_expr_of_base_PHOAS_Var0

        (** val arith_expr_of_PHOAS :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            (__, char list list) sum,
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (arith_expr_for_base, char list list) sum)
            Compilers.Coq_type.interpM_final **)

        let arith_expr_of_PHOAS lang_casts relax_zrange language_specific_cast_adjustment =
          let rec arith_expr_of_PHOAS0 t0 = function
          | Compilers.Coq_expr.Ident (t1, idc) ->
            collect_args_and_apply_casts language_specific_cast_adjustment t1
              idc
              (arith_expr_of_PHOAS_ident lang_casts relax_zrange
                language_specific_cast_adjustment t1 idc)
          | Compilers.Coq_expr.Var (t1, v) ->
            (match t1 with
             | Compilers.Coq_type.Coq_base t2 ->
               (fun v0 ->
                 Obj.magic (Inl
                   (arith_expr_of_base_PHOAS_Var
                     language_specific_cast_adjustment t2 v0)))
             | Compilers.Coq_type.Coq_arrow (s0, d) ->
               (fun _ ->
                 Compilers.Coq_type.interpM_return
                   (Compilers.Coq_type.Coq_arrow (s0, d)) (Inr
                   ((append
                      ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('o'::('n'::('-'::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('l'::('e'::('t'::('-'::('b'::('o'::('u'::('n'::('d'::(' '::('V'::('a'::('r'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))
                      (show0
                        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                        t0)) :: [])))) v
          | Compilers.Coq_expr.Abs (s0, d, _) ->
            Compilers.Coq_type.interpM_return (Compilers.Coq_type.Coq_arrow
              (s0, d)) (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('o'::('n'::('-'::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('l'::('e'::('t'::('-'::('b'::('o'::('u'::('n'::('d'::(' '::('A'::('b'::('s'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                     Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) t0)) :: []))
          | Compilers.Coq_expr.App (s0, d, f, x) ->
            (match s0 with
             | Compilers.Coq_type.Coq_base s1 ->
               (fun f0 x0 ->
                 let x' =
                   arith_expr_of_PHOAS0 (Compilers.Coq_type.Coq_base s1) x0
                 in
                 (match Obj.magic x' with
                  | Inl x'0 ->
                    Obj.magic arith_expr_of_PHOAS0
                      (Compilers.Coq_type.Coq_arrow
                      ((Compilers.Coq_type.Coq_base s1), d)) f0 x'0
                  | Inr errs -> Compilers.Coq_type.interpM_return d (Inr errs)))
             | Compilers.Coq_type.Coq_arrow (_, _) ->
               (fun _ _ ->
                 Compilers.Coq_type.interpM_return d (Inr
                   ((append
                      ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('o'::('n'::('-'::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('l'::('e'::('t'::('-'::('b'::('o'::('u'::('n'::('d'::(' '::('A'::('p'::('p'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))
                      (show0
                        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                        t0)) :: [])))) f x
          | Compilers.Coq_expr.LetIn (_, b, _, _) ->
            Compilers.Coq_type.interpM_return b (Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('o'::('n'::('-'::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('l'::('e'::('t'::('-'::('b'::('o'::('u'::('n'::('d'::(' '::('L'::('e'::('t'::('I'::('n'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))
                 (show0
                   (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                     Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) t0)) :: []))
          in arith_expr_of_PHOAS0

        (** val arith_expr_of_base_PHOAS :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr ->
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            (arith_expr_for_base, char list list) sum **)

        let arith_expr_of_base_PHOAS lang_casts relax_zrange language_specific_cast_adjustment t0 e rout =
          match Obj.magic arith_expr_of_PHOAS lang_casts relax_zrange
                  language_specific_cast_adjustment
                  (Compilers.Coq_type.Coq_base t0) e with
          | Inl e' -> e' rout
          | Inr err0 -> Inr err0

        (** val result_upcast :
            coq_LanguageCasts ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            arith_expr_for_base -> arith_expr_for_base **)

        let result_upcast lang_casts language_specific_cast_adjustment t0 =
          if lang_casts.upcast_on_assignment
          then cast language_specific_cast_adjustment false t0
          else (fun _ e -> e)

        (** val funcall_upcast :
            coq_LanguageCasts ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.Coq_int.Coq_option.interp ->
            arith_expr_for_base -> arith_expr_for_base **)

        let funcall_upcast lang_casts language_specific_cast_adjustment t0 =
          if lang_casts.upcast_on_funcall
          then cast language_specific_cast_adjustment false t0
          else (fun _ e -> e)

        (** val make_return_assignment_of_base_arith :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr -> (expr, char list list) sum **)

        let make_return_assignment_of_base_arith lang_casts relax_zrange language_specific_cast_adjustment =
          let bind2_err = fun _ _ _ v1 v2 f ->
            match v1 with
            | Inl x1 ->
              (match v2 with
               | Inl x2 -> f x1 x2
               | Inr err0 -> Inr err0)
            | Inr err1 ->
              (match v2 with
               | Inl _ -> Inr err1
               | Inr err2 -> Inr (app err1 err2))
          in
          let rec make_return_assignment_of_base_arith0 t0 = match t0 with
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z ->
               (fun pat ->
                 let (p, _) = Obj.magic pat in
                 let (p0, r0) = p in
                 let (n3, is_ptr) = p0 in
                 (fun e ->
                 match arith_expr_of_base_PHOAS lang_casts relax_zrange
                         language_specific_cast_adjustment
                         (Compilers.Coq_base.Coq_type.Coq_type_base
                         Coq3_Compilers.Z) e r0 with
                 | Inl rhs ->
                   let (e0, r1) =
                     Obj.magic result_upcast lang_casts
                       language_specific_cast_adjustment
                       (Compilers.Coq_base.Coq_type.Coq_type_base
                       Coq3_Compilers.Z) r0 rhs
                   in
                   Inl
                   (if is_ptr
                    then (AssignZPtr (n3, r1, e0)) :: []
                    else (Assign (false, Coq_type.Z, r1, n3, e0)) :: [])
                 | Inr err0 -> Inr err0))
             | Coq3_Compilers.Coq_bool ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Coq3_Compilers.Coq_nat ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Coq3_Compilers.Coq_zrange ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Coq3_Compilers.Coq_string ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: [])))
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun pat ->
              let (rva, rvb) = Obj.magic pat in
              (fun e ->
              match Compilers.Coq_invert_expr.invert_pair (fun _ x x0 _ ->
                      Coq3_Compilers.try_make_base_transport_cps x x0)
                      Coq3_Compilers.invertIdent a b e with
              | Some p ->
                let (ea, eb) = p in
                bind2_err __ __ __
                  (make_return_assignment_of_base_arith0 a rva ea)
                  (make_return_assignment_of_base_arith0 b rvb eb)
                  (fun ea' eb' -> Inl (app ea' eb'))
              | None ->
                Inr
                  ((append
                     ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('o'::('n'::('-'::('p'::('a'::('i'::('r'::(' '::('e'::('x'::('p'::('r'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::[]))))))))))))))))))))))))))))))
                     (show0
                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                       t0)) :: [])))
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (match a with
             | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
               (match t1 with
                | Coq3_Compilers.Z ->
                  (fun pat ->
                    let (p, _) = Obj.magic pat in
                    let (p0, len) = p in
                    let (n3, r0) = p0 in
                    (fun e ->
                    match arith_expr_of_base_PHOAS lang_casts relax_zrange
                            language_specific_cast_adjustment
                            (Compilers.Coq_base.Coq_type.Coq_list
                            (Compilers.Coq_base.Coq_type.Coq_type_base
                            Coq3_Compilers.Z)) e
                            (Obj.magic (Some (repeat r0 len))) with
                    | Inl ls ->
                      Inl
                        (map (fun pat0 ->
                          let (i, rhs) = pat0 in
                          let (e0, _) =
                            Obj.magic result_upcast lang_casts
                              language_specific_cast_adjustment
                              (Compilers.Coq_base.Coq_type.Coq_type_base
                              Coq3_Compilers.Z) r0 rhs
                          in
                          AssignNth (n3, i, e0))
                          (combine (seq O len) (Obj.magic ls)))
                    | Inr err0 -> Inr err0))
                | Coq3_Compilers.Coq_bool ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: []))
                | Coq3_Compilers.Coq_nat ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: []))
                | Coq3_Compilers.Coq_zrange ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: []))
                | Coq3_Compilers.Coq_string ->
                  (fun _ _ -> Inr
                    ((append
                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                       (show0
                         Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                         t0)) :: [])))
             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Compilers.Coq_base.Coq_type.Coq_list _ ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Compilers.Coq_base.Coq_type.Coq_option _ ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: []))
             | Compilers.Coq_base.Coq_type.Coq_unit ->
               (fun _ _ -> Inr
                 ((append
                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                    (show0
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show t0)) :: [])))
          | Compilers.Coq_base.Coq_type.Coq_option _ ->
            (fun _ _ -> Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
                 (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                   t0)) :: []))
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            (fun _ _ -> Inr
              ((append
                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))
                 (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                   t0)) :: []))
          in make_return_assignment_of_base_arith0

        (** val make_return_assignment_of_arith :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.var_data -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
            -> (expr, char list list) sum **)

        let make_return_assignment_of_arith lang_casts relax_zrange language_specific_cast_adjustment t0 = match t0 with
        | Compilers.Coq_type.Coq_base t1 ->
          make_return_assignment_of_base_arith lang_casts relax_zrange
            language_specific_cast_adjustment t1
        | Compilers.Coq_type.Coq_arrow (_, _) ->
          (fun _ _ -> Inr
            ((append
               ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('e'::('x'::('p'::('r'::(':'::(' '::[]))))))))))))))))))))))
               (show0
                 (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show) t0)) :: []))

        (** val report_type_mismatch :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> char list **)

        let report_type_mismatch expected given =
          append
            ('T'::('y'::('p'::('e'::(' '::('m'::('i'::('s'::('m'::('a'::('t'::('c'::('h'::(';'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::[]))))))))))))))))))))))))
            (append
              (show0
                (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                  Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                expected)
              (append
                (' '::('b'::('u'::('t'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::[])))))))))))
                (append
                  (show0
                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                      Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                    given) ('.'::[]))))

        (** val arith_expr_of_PHOAS_args :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr) Compilers.Coq_type.for_each_lhs_of_arrow
            -> ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr * (arith_expr * Coq7_Compilers.ToString.Coq_int.coq_type
            option)) Compilers.Coq_type.for_each_lhs_of_arrow, char list
            list) sum **)

        let arith_expr_of_PHOAS_args lang_casts relax_zrange language_specific_cast_adjustment =
          let bind2_err = fun _ _ _ v1 v2 f ->
            match v1 with
            | Inl x1 ->
              (match v2 with
               | Inl x2 -> f x1 x2
               | Inr err0 -> Inr err0)
            | Inr err1 ->
              (match v2 with
               | Inl _ -> Inr err1
               | Inr err2 -> Inr (app err1 err2))
          in
          let rec arith_expr_of_PHOAS_args0 = function
          | Compilers.Coq_type.Coq_base _ ->
            (fun pat -> let () = Obj.magic pat in Inl (Obj.magic ()))
          | Compilers.Coq_type.Coq_arrow (s0, d) ->
            (match s0 with
             | Compilers.Coq_type.Coq_base t1 ->
               (match t1 with
                | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                  (match t2 with
                   | Coq3_Compilers.Z ->
                     (fun pat ->
                       let (arg, args0) = Obj.magic pat in
                       Obj.magic bind2_err __ __ __
                         (arith_expr_of_base_PHOAS lang_casts relax_zrange
                           language_specific_cast_adjustment
                           (Compilers.Coq_base.Coq_type.Coq_type_base
                           Coq3_Compilers.Z) arg
                           (Coq7_Compilers.ToString.Coq_int.Coq_option.coq_None
                             (Compilers.Coq_base.Coq_type.Coq_type_base
                             Coq3_Compilers.Z)))
                         (arith_expr_of_PHOAS_args0 d args0)
                         (fun arg' args' -> Inl ((arg, arg'), args')))
                   | Coq3_Compilers.Coq_bool ->
                     (fun pat ->
                       let (_, args0) = Obj.magic pat in
                       bind2_err __ __ __ (Inr
                         ((append
                            ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                            (show0
                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                              s0)) :: []))
                         (arith_expr_of_PHOAS_args0 d args0) (fun _ _ -> Inr
                         (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: [])))
                   | Coq3_Compilers.Coq_nat ->
                     (fun pat ->
                       let (_, args0) = Obj.magic pat in
                       bind2_err __ __ __ (Inr
                         ((append
                            ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                            (show0
                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                              s0)) :: []))
                         (arith_expr_of_PHOAS_args0 d args0) (fun _ _ -> Inr
                         (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: [])))
                   | Coq3_Compilers.Coq_zrange ->
                     (fun pat ->
                       let (_, args0) = Obj.magic pat in
                       bind2_err __ __ __ (Inr
                         ((append
                            ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                            (show0
                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                              s0)) :: []))
                         (arith_expr_of_PHOAS_args0 d args0) (fun _ _ -> Inr
                         (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: [])))
                   | Coq3_Compilers.Coq_string ->
                     (fun pat ->
                       let (_, args0) = Obj.magic pat in
                       bind2_err __ __ __ (Inr
                         ((append
                            ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                            (show0
                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                              s0)) :: []))
                         (arith_expr_of_PHOAS_args0 d args0) (fun _ _ -> Inr
                         (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: []))))
                | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                  (fun pat ->
                    let (_, args0) = Obj.magic pat in
                    bind2_err __ __ __ (Inr
                      ((append
                         ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                         (show0
                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                           s0)) :: [])) (arith_expr_of_PHOAS_args0 d args0)
                      (fun _ _ -> Inr
                      (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: [])))
                | Compilers.Coq_base.Coq_type.Coq_list _ ->
                  (fun pat ->
                    let (_, args0) = Obj.magic pat in
                    bind2_err __ __ __ (Inr
                      ((append
                         ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                         (show0
                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                           s0)) :: [])) (arith_expr_of_PHOAS_args0 d args0)
                      (fun _ _ -> Inr
                      (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: [])))
                | Compilers.Coq_base.Coq_type.Coq_option _ ->
                  (fun pat ->
                    let (_, args0) = Obj.magic pat in
                    bind2_err __ __ __ (Inr
                      ((append
                         ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                         (show0
                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                           s0)) :: [])) (arith_expr_of_PHOAS_args0 d args0)
                      (fun _ _ -> Inr
                      (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: [])))
                | Compilers.Coq_base.Coq_type.Coq_unit ->
                  (fun pat ->
                    let (_, args0) = Obj.magic pat in
                    bind2_err __ __ __ (Inr
                      ((append
                         ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                         (show0
                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                           s0)) :: [])) (arith_expr_of_PHOAS_args0 d args0)
                      (fun _ _ -> Inr
                      (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: []))))
             | Compilers.Coq_type.Coq_arrow (_, _) ->
               (fun pat ->
                 let (_, args0) = Obj.magic pat in
                 bind2_err __ __ __ (Inr
                   ((append
                      ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('\226'::('\132'::('\164'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))
                      (show0
                        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                        s0)) :: [])) (arith_expr_of_PHOAS_args0 d args0)
                   (fun _ _ -> Inr
                   (('I'::('m'::('p'::('o'::('s'::('s'::('i'::('b'::('l'::('e'::('!'::(' '::('('::('t'::('y'::('p'::('e'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('g'::('o'::('t'::(' '::('l'::('o'::('s'::('t'::(' '::('s'::('o'::('m'::('e'::('w'::('h'::('e'::('r'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: []))))
          in arith_expr_of_PHOAS_args0

        (** val base_var_names_of_string_opt :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            char list -> Coq7_Compilers.ToString.OfPHOAS.base_var_names option **)

        let rec base_var_names_of_string_opt t0 n3 =
          match t0 with
          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
            (match t1 with
             | Coq3_Compilers.Z -> Some (Obj.magic n3)
             | Coq3_Compilers.Coq_bool -> None
             | Coq3_Compilers.Coq_nat -> None
             | Coq3_Compilers.Coq_zrange -> None
             | Coq3_Compilers.Coq_string -> None)
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            bind
              (base_var_names_of_string_opt a
                (append n3 ('\226'::('\130'::('\129'::[]))))) (fun a0 ->
              bind
                (base_var_names_of_string_opt b
                  (append n3 ('\226'::('\130'::('\130'::[]))))) (fun b0 ->
                Some (Obj.magic (a0, b0))))
          | Compilers.Coq_base.Coq_type.Coq_list _ -> Some (Obj.magic n3)
          | Compilers.Coq_base.Coq_type.Coq_option _ -> None
          | Compilers.Coq_base.Coq_type.Coq_unit -> Some (Obj.magic ())

        (** val string_of_base_var_names :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_names -> char list **)

        let rec string_of_base_var_names = function
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z -> (fun n3 -> Obj.magic n3)
           | Coq3_Compilers.Coq_bool ->
             (fun _ -> assert false (* absurd case *))
           | Coq3_Compilers.Coq_nat ->
             (fun _ -> assert false (* absurd case *))
           | Coq3_Compilers.Coq_zrange ->
             (fun _ -> assert false (* absurd case *))
           | Coq3_Compilers.Coq_string ->
             (fun _ -> assert false (* absurd case *)))
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          (fun x ->
            let a0 = string_of_base_var_names a (fst (Obj.magic x)) in
            let b0 = string_of_base_var_names b (snd (Obj.magic x)) in
            let len_a = length0 a0 in
            let len_b = length0 b0 in
            let (a1, a_tl) = ((substring O (sub len_a (S O)) a0),
              (substring (sub len_a (S O)) (S O) a0))
            in
            let (b1, b_tl) = ((substring O (sub len_b (S O)) b0),
              (substring (sub len_b (S O)) (S O) b0))
            in
            if (&&)
                 ((&&) ((&&) (Nat.eqb len_a len_b) (eqb0 a1 b1))
                   (eqb0 a_tl ('\226'::('\130'::('\129'::[])))))
                 (eqb0 b_tl ('\226'::('\130'::('\130'::[]))))
            then a1
            else append ('('::[])
                   (append a1 (append (','::[]) (append b1 (')'::[])))))
        | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun n3 -> Obj.magic n3)
        | Compilers.Coq_base.Coq_type.Coq_option _ ->
          (fun _ -> assert false (* absurd case *))
        | Compilers.Coq_base.Coq_type.Coq_unit ->
          (fun pat -> let () = Obj.magic pat in '('::(')'::[]))

        (** val var_names_of_string_opt :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> char list ->
            Coq7_Compilers.ToString.OfPHOAS.var_names option **)

        let var_names_of_string_opt t0 n3 =
          match t0 with
          | Compilers.Coq_type.Coq_base t1 ->
            base_var_names_of_string_opt t1 n3
          | Compilers.Coq_type.Coq_arrow (_, _) -> None

        (** val string_of_var_names :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.var_names -> char list **)

        let string_of_var_names = function
        | Compilers.Coq_type.Coq_base t1 -> string_of_base_var_names t1
        | Compilers.Coq_type.Coq_arrow (_, _) ->
          (fun _ -> assert false (* absurd case *))

        (** val var_data_of_string_opt :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> char list ->
            Coq7_Compilers.ToString.OfPHOAS.var_data option **)

        let var_data_of_string_opt t0 n3 =
          option_map (Coq7_Compilers.ToString.OfPHOAS.var_data_of_names t0)
            (var_names_of_string_opt t0 n3)

        (** val string_of_var_data :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type ->
            Coq7_Compilers.ToString.OfPHOAS.var_data -> char list **)

        let string_of_var_data t0 v =
          string_of_var_names t0
            (Coq7_Compilers.ToString.OfPHOAS.names_of_var_data t0 v)

        (** val extract_var_data_list :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data) sigT list **)

        let rec extract_var_data_list _ = function
        | Compilers.Coq_expr.Ident (_, _) -> []
        | Compilers.Coq_expr.Var (t0, v) -> (ExistT (t0, v)) :: []
        | Compilers.Coq_expr.Abs (s0, d, f) ->
          (match var_data_of_string_opt s0
                   ('('::('F'::('A'::('K'::('E'::('_'::('e'::('x'::('t'::('r'::('a'::('c'::('t'::('_'::('v'::('a'::('r'::('_'::('d'::('a'::('t'::('a'::('_'::('l'::('i'::('s'::('t'::(')'::[])))))))))))))))))))))))))))) with
           | Some d0 -> extract_var_data_list d (f d0)
           | None -> [])
        | Compilers.Coq_expr.App (s0, d, f, x) ->
          app
            (extract_var_data_list (Compilers.Coq_type.Coq_arrow (s0, d)) f)
            (extract_var_data_list s0 x)
        | Compilers.Coq_expr.LetIn (a, b, x, f) ->
          app (extract_var_data_list a x)
            (match var_data_of_string_opt a
                     ('('::('F'::('A'::('K'::('E'::('_'::('e'::('x'::('t'::('r'::('a'::('c'::('t'::('_'::('v'::('a'::('r'::('_'::('d'::('a'::('t'::('a'::('_'::('l'::('i'::('s'::('t'::(')'::[])))))))))))))))))))))))))))) with
             | Some d -> extract_var_data_list b (f d)
             | None -> [])

        (** val bounds_check :
            Coq7_Compilers.Options.relax_zrange_opt -> bool -> char list ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> z ->
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data) Compilers.Coq_expr.expr
            -> Coq7_Compilers.ToString.Coq_int.coq_type option -> (unit,
            char list list) sum **)

        let bounds_check relax_zrange do_bounds_check descr t0 idc s0 t' ev found =
          if negb do_bounds_check
          then Inl ()
          else let x = fun _ ->
                 Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
               in
               (match found with
                | Some ty ->
                  if Coq7_Compilers.ToString.Coq_int.is_tighter_than ty
                       (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                         (relax_zrange { lower = Z0; upper =
                           (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) s0) (Zpos XH)) }))
                  then Inl ()
                  else Inr
                         ((append
                            ('F'::('i'::('n'::('a'::('l'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('c'::('h'::('e'::('c'::('k'::(' '::('f'::('a'::('i'::('l'::('e'::('d'::(' '::('o'::('n'::(' '::[])))))))))))))))))))))))))))))
                            (append descr
                              (append (' '::[])
                                (append
                                  (show0
                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                      t0) idc)
                                  (append
                                    (';'::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('e'::('d'::(' '::('a'::('n'::(' '::('u'::('n'::('s'::('i'::('g'::('n'::('e'::('d'::(' '::[])))))))))))))))))))))))
                                    (append (Coq0_Z.to_string s0)
                                      (append
                                        ('-'::('b'::('i'::('t'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('('::('r'::('e'::('l'::('a'::('x'::('e'::('d'::(' '::('t'::('o'::(' '::[]))))))))))))))))))))))))
                                        (append
                                          (show0
                                            Coq7_Compilers.ToString.Coq_int.show_type
                                            (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                              (relax_zrange { lower = Z0;
                                                upper =
                                                (Coq_Z.sub
                                                  (Coq_Z.pow (Zpos (XO XH))
                                                    s0) (Zpos XH)) })))
                                          (append
                                            (')'::(','::(' '::('b'::('u'::('t'::(' '::('f'::('o'::('u'::('n'::('d'::(' '::('a'::(' '::[])))))))))))))))
                                            (append
                                              (show0
                                                Coq7_Compilers.ToString.Coq_int.show_type
                                                ty) ('.'::[]))))))))))) :: [])
                | None ->
                  Inr
                    ((append
                       ('M'::('i'::('s'::('s'::('i'::('n'::('g'::(' '::('r'::('a'::('n'::('g'::('e'::(' '::('o'::('n'::(' '::[])))))))))))))))))
                       (append descr
                         (append (' '::[])
                           (append
                             (show0
                               (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                 t0) idc)
                             (append (':'::(' '::[])) (show0 (x __ t') ev)))))) :: []))

        (** val declare_name :
            coq_LanguageCasts -> char list -> positive -> (positive ->
            char list option) -> Coq7_Compilers.ToString.Coq_int.coq_type
            option -> (((expr * char list) * bool) * arith_expr, char list
            list) sum **)

        let declare_name lang_casts =
          let bind2_err = fun _ _ _ v1 v2 f ->
            match v1 with
            | Inl x1 ->
              (match v2 with
               | Inl x2 -> f x1 x2
               | Inr err0 -> Inr err0)
            | Inr err1 ->
              (match v2 with
               | Inl _ -> Inr err1
               | Inr err2 -> Inr (app err1 err2))
          in
          (fun descr count make_name r0 ->
          bind2_err __ __ __
            (fst
              ((match make_name count with
                | Some n3 -> Inl n3
                | None ->
                  Inr
                    ((append
                       ('V'::('a'::('r'::('i'::('a'::('b'::('l'::('e'::(' '::('n'::('a'::('m'::('i'::('n'::('g'::('-'::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('d'::('o'::('e'::('s'::(' '::('n'::('o'::('t'::(' '::('s'::('u'::('p'::('p'::('o'::('r'::('t'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))
                       (show0 Decimal.show_positive count)) :: [])),
              (match r0 with
               | Some r1 -> Inl r1
               | None ->
                 Inr
                   ((append
                      ('M'::('i'::('s'::('s'::('i'::('n'::('g'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('t'::('y'::('p'::('e'::(' '::('a'::('n'::('n'::('o'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::[])))))))))))))))))))))))))))))))))))
                      descr) :: []))))
            (snd
              ((match make_name count with
                | Some n3 -> Inl n3
                | None ->
                  Inr
                    ((append
                       ('V'::('a'::('r'::('i'::('a'::('b'::('l'::('e'::(' '::('n'::('a'::('m'::('i'::('n'::('g'::('-'::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('d'::('o'::('e'::('s'::(' '::('n'::('o'::('t'::(' '::('s'::('u'::('p'::('p'::('o'::('r'::('t'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))
                       (show0 Decimal.show_positive count)) :: [])),
              (match r0 with
               | Some r1 -> Inl r1
               | None ->
                 Inr
                   ((append
                      ('M'::('i'::('s'::('s'::('i'::('n'::('g'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('t'::('y'::('p'::('e'::(' '::('a'::('n'::('n'::('o'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::[])))))))))))))))))))))))))))))))))))
                      descr) :: [])))) (fun n3 r1 -> Inl
            (if lang_casts.explicit_pointer_variables
             then (((((DeclareVar (Coq_type.Zptr, (Some r1), n3)) :: []),
                    n3), true), (Var (Coq_type.Zptr, n3)))
             else (((((DeclareVar (Coq_type.Z, (Some r1), n3)) :: []), n3),
                    false), (AppIdent ((Coq_type.Coq_type_primitive
                    Coq_type.Z), (Coq_type.Coq_type_primitive Coq_type.Zptr),
                    Addr, (Var (Coq_type.Z, n3))))))))

        (** val size_of_type :
            Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
            positive **)

        let rec size_of_type = function
        | Compilers.Coq_base.Coq_type.Coq_type_base _ -> XH
        | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
          Coq_Pos.add (size_of_type a) (size_of_type b)
        | Compilers.Coq_base.Coq_type.Coq_list _ -> XH
        | Compilers.Coq_base.Coq_type.Coq_option _ -> XH
        | Compilers.Coq_base.Coq_type.Coq_unit -> XH

        (** val make_assign_expr_of_PHOAS :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
            -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type ->
            (Coq7_Compilers.ToString.OfPHOAS.var_data ->
            Coq7_Compilers.ToString.OfPHOAS.var_data -> (expr, char list
            list) sum) -> positive -> (positive -> char list option) ->
            Coq7_Compilers.ToString.OfPHOAS.var_data -> (expr, char list
            list) sum **)

        let make_assign_expr_of_PHOAS lang_casts relax_zrange language_specific_cast_adjustment relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check s0 e1 s' _ e2 count make_name v =
          match Compilers.Coq_type.try_transport (fun _ x x0 _ ->
                  Compilers.Coq_base.try_make_transport_cps (fun _ x1 x2 _ ->
                    Coq3_Compilers.try_make_base_transport_cps x1 x2) x x0)
                  s0 s' e1 with
          | Some e3 ->
            (match let x = fun _ ->
                     Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
                   in
                   (match s' with
                    | Compilers.Coq_type.Coq_base t0 ->
                      (match t0 with
                       | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
                         (match t1 with
                          | Coq3_Compilers.Z ->
                            (fun e count0 make_name0 ->
                              let (rout, e0) =
                                match Coq5_Compilers.Coq_invert_expr.invert_App_Z_cast
                                        e with
                                | Some p ->
                                  let (r0, e0) = p in
                                  ((Some
                                  (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                    r0)), e0)
                                | None -> (None, e)
                              in
                              let res_ref =
                                bind
                                  (Compilers.Coq_invert_expr.invert_AppIdent_curried
                                    (Compilers.Coq_type.Coq_base
                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                    Coq3_Compilers.Z)) e0) (fun idc_args ->
                                  let ExistT (x0, p) = idc_args in
                                  let (idc, args0) = p in
                                  bind
                                    (match idc with
                                     | Coq3_Compilers.Coq_ident_Literal (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_comment _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_value_barrier ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Nat_succ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Nat_pred ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Nat_max ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Nat_mul ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Nat_add ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Nat_sub ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                       None
                                     | Coq3_Compilers.Coq_ident_nil _ -> None
                                     | Coq3_Compilers.Coq_ident_cons _ -> None
                                     | Coq3_Compilers.Coq_ident_tt -> None
                                     | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_prod_rect (
                                         _, _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_list_rect (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_eager_list_rect (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                         _, _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                         _, _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_list_case (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_length _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_seq ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_combine (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_map (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_app _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_rev _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_flat_map (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_partition _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_filter _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_fold_right (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_add -> None
                                     | Coq3_Compilers.Coq_ident_Z_mul -> None
                                     | Coq3_Compilers.Coq_ident_Z_pow -> None
                                     | Coq3_Compilers.Coq_ident_Z_sub -> None
                                     | Coq3_Compilers.Coq_ident_Z_opp -> None
                                     | Coq3_Compilers.Coq_ident_Z_div -> None
                                     | Coq3_Compilers.Coq_ident_Z_modulo ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_eqb -> None
                                     | Coq3_Compilers.Coq_ident_Z_leb -> None
                                     | Coq3_Compilers.Coq_ident_Z_ltb -> None
                                     | Coq3_Compilers.Coq_ident_Z_geb -> None
                                     | Coq3_Compilers.Coq_ident_Z_gtb -> None
                                     | Coq3_Compilers.Coq_ident_Z_log2 -> None
                                     | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_land -> None
                                     | Coq3_Compilers.Coq_ident_Z_lor -> None
                                     | Coq3_Compilers.Coq_ident_Z_min -> None
                                     | Coq3_Compilers.Coq_ident_Z_max -> None
                                     | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_ltz -> None
                                     | Coq3_Compilers.Coq_ident_Z_zselect ->
                                       Some (fun rout0 pat ->
                                         let (y, y0) = Obj.magic pat in
                                         let (econdv, y1) = y in
                                         let (econd, rcond) = y1 in
                                         let (y2, y3) = y0 in
                                         let (_, y4) = y2 in
                                         let (e4, r1) = y4 in
                                         let (y5, y6) = y3 in
                                         let (_, y7) = y5 in
                                         let (e5, r2) = y7 in
                                         let () = y6 in
                                         (match bounds_check relax_zrange
                                                  do_bounds_check
                                                  ('f'::('i'::('r'::('s'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                  x0 idc (Zpos XH)
                                                  (Compilers.Coq_type.Coq_base
                                                  (Compilers.Coq_base.Coq_type.Coq_type_base
                                                  Coq3_Compilers.Z)) econdv
                                                  rcond with
                                          | Inl _ ->
                                            let (a, a0) =
                                              Obj.magic funcall_upcast
                                                lang_casts
                                                language_specific_cast_adjustment
                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z),
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z))) (rout0,
                                                rout0) ((e4, r1), (e5, r2))
                                            in
                                            let (e6, _) = a in
                                            let (e7, _) = a0 in
                                            (match match rout0 with
                                                   | Some rout1 -> Inl rout1
                                                   | None ->
                                                     Inr
                                                       (('M'::('i'::('s'::('s'::('i'::('n'::('g'::(' '::('c'::('a'::('s'::('t'::(' '::('a'::('n'::('n'::('o'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('o'::('n'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('o'::('f'::(' '::('Z'::('.'::('z'::('s'::('e'::('l'::('e'::('c'::('t'::[])))))))))))))))))))))))))))))))))))))))))))))) :: []) with
                                             | Inl ty ->
                                               Inl (fun retptr -> (Call
                                                 (AppIdent
                                                 ((Coq_type.Coq_prod
                                                 ((Coq_type.Coq_type_primitive
                                                 Coq_type.Zptr),
                                                 (Coq_type.Coq_prod
                                                 ((Coq_type.Coq_prod
                                                 ((Coq_type.Coq_type_primitive
                                                 Coq_type.Z),
                                                 (Coq_type.Coq_type_primitive
                                                 Coq_type.Z))),
                                                 (Coq_type.Coq_type_primitive
                                                 Coq_type.Z))))),
                                                 Coq_type.Coq_unit,
                                                 (Z_zselect ty), (Pair
                                                 ((Coq_type.Coq_type_primitive
                                                 Coq_type.Zptr),
                                                 (Coq_type.Coq_prod
                                                 ((Coq_type.Coq_prod
                                                 ((Coq_type.Coq_type_primitive
                                                 Coq_type.Z),
                                                 (Coq_type.Coq_type_primitive
                                                 Coq_type.Z))),
                                                 (Coq_type.Coq_type_primitive
                                                 Coq_type.Z))), retptr, (Pair
                                                 ((Coq_type.Coq_prod
                                                 ((Coq_type.Coq_type_primitive
                                                 Coq_type.Z),
                                                 (Coq_type.Coq_type_primitive
                                                 Coq_type.Z))),
                                                 (Coq_type.Coq_type_primitive
                                                 Coq_type.Z), (Pair
                                                 ((Coq_type.Coq_type_primitive
                                                 Coq_type.Z),
                                                 (Coq_type.Coq_type_primitive
                                                 Coq_type.Z), econd, e6)),
                                                 e7))))))) :: [])
                                             | Inr err0 -> Inr err0)
                                          | Inr err0 -> Inr err0))
                                     | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_bneg -> None
                                     | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_lxor -> None
                                     | Coq3_Compilers.Coq_ident_Z_rshi -> None
                                     | Coq3_Compilers.Coq_ident_Z_cc_m -> None
                                     | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Z_cast -> None
                                     | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Some _ -> None
                                     | Coq3_Compilers.Coq_ident_None _ -> None
                                     | Coq3_Compilers.Coq_ident_option_rect (
                                         _, _) ->
                                       None
                                     | Coq3_Compilers.Coq_ident_Build_zrange ->
                                       None
                                     | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_add ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_addc ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_sub ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_subb ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_selc ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_selm ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_sell ->
                                       None
                                     | Coq3_Compilers.Coq_ident_fancy_addm ->
                                       None) (fun recognize -> Some
                                    (match arith_expr_of_PHOAS_args
                                             lang_casts relax_zrange
                                             language_specific_cast_adjustment
                                             x0 args0 with
                                     | Inl args1 ->
                                       (match recognize rout args1 with
                                        | Inl idce ->
                                          (match declare_name lang_casts
                                                   (show0
                                                     (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                       x0) idc) count0
                                                   make_name0 rout with
                                           | Inl v0 ->
                                             let (p0, retv) = v0 in
                                             let (p1, is_ptr) = p0 in
                                             let (decls, n3) = p1 in
                                             Inl ((app decls (idce retv)),
                                             (((n3, is_ptr), rout), None))
                                           | Inr err0 -> Inr err0)
                                        | Inr err0 -> Inr err0)
                                     | Inr err0 -> Inr err0)))
                              in
                              (match res_ref with
                               | Some s1 ->
                                 (match s1 with
                                  | Inl res -> Inl res
                                  | Inr err0 -> Inr err0)
                               | None ->
                                 (match arith_expr_of_base_PHOAS lang_casts
                                          relax_zrange
                                          language_specific_cast_adjustment
                                          (Compilers.Coq_base.Coq_type.Coq_type_base
                                          Coq3_Compilers.Z) e (Obj.magic None) with
                                  | Inl e4 ->
                                    let (e5, r1) = Obj.magic e4 in
                                    (match make_name0 count0 with
                                     | Some n3 ->
                                       Inl (((Assign (true, Coq_type.Z, r1,
                                         n3, e5)) :: []), (((n3, false), r1),
                                         None))
                                     | None ->
                                       Inr
                                         ((append
                                            ('V'::('a'::('r'::('i'::('a'::('b'::('l'::('e'::(' '::('n'::('a'::('m'::('i'::('n'::('g'::('-'::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('d'::('o'::('e'::('s'::(' '::('n'::('o'::('t'::(' '::('s'::('u'::('p'::('p'::('o'::('r'::('t'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))
                                            (show0 Decimal.show_positive
                                              count0)) :: []))
                                  | Inr err0 -> Inr err0)))
                          | Coq3_Compilers.Coq_bool ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_bool))) e)
                                       (')'::[]))))) :: []))
                          | Coq3_Compilers.Coq_nat ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_nat))) e)
                                       (')'::[]))))) :: []))
                          | Coq3_Compilers.Coq_zrange ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_zrange))) e)
                                       (')'::[]))))) :: []))
                          | Coq3_Compilers.Coq_string ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_type_base
                                           Coq3_Compilers.Coq_string))) e)
                                       (')'::[]))))) :: [])))
                       | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
                         (match a with
                          | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
                            (match t1 with
                             | Coq3_Compilers.Z ->
                               (match b with
                                | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                                  (match t2 with
                                   | Coq3_Compilers.Z ->
                                     (fun e count0 make_name0 ->
                                       let x0 = fun _ ->
                                         Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
                                       in
                                       let (p, e0) =
                                         match Coq5_Compilers.Coq_invert_expr.invert_App_Z_cast2
                                                 e with
                                         | Some p ->
                                           let (p0, e0) = p in
                                           let (r1, r2) = p0 in
                                           (((Some
                                           (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                             r1)), (Some
                                           (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                             r2))), e0)
                                         | None -> ((None, None), e)
                                       in
                                       let (rout1, rout2) = p in
                                       (match Compilers.Coq_invert_expr.invert_AppIdent_curried
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z),
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Z)))) e0 with
                                        | Some s1 ->
                                          let ExistT (t3, p0) = s1 in
                                          let (idc, args0) = p0 in
                                          (match arith_expr_of_PHOAS_args
                                                   lang_casts relax_zrange
                                                   language_specific_cast_adjustment
                                                   t3 args0 with
                                           | Inl args1 ->
                                             (match (match t3 with
                                                     | Compilers.Coq_type.Coq_base t4 ->
                                                       (fun _ idc0 _ _ -> Inr
                                                         ((append
                                                            ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                            (append
                                                              (show0
                                                                (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                  Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                t3)
                                                              (append
                                                                (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                (append
                                                                  (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_base
                                                                    t4)) idc0)
                                                                  (')'::[]))))) :: []))
                                                     | Compilers.Coq_type.Coq_arrow (
                                                         s2, d) ->
                                                       (match s2 with
                                                        | Compilers.Coq_type.Coq_base t4 ->
                                                          (match t4 with
                                                           | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                                                             (match t5 with
                                                              | Coq3_Compilers.Z ->
                                                                (match d with
                                                                 | Compilers.Coq_type.Coq_base t6 ->
                                                                   (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    t6))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                 | Compilers.Coq_type.Coq_arrow (
                                                                    s3, d0) ->
                                                                   (match s3 with
                                                                    | Compilers.Coq_type.Coq_base t6 ->
                                                                    (match t6 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t7 ->
                                                                    (match t7 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match d0 with
                                                                    | Compilers.Coq_type.Coq_base t8 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    t8))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    s4, d1) ->
                                                                    (match s4 with
                                                                    | Compilers.Coq_type.Coq_base t8 ->
                                                                    (match t8 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t9 ->
                                                                    (match t9 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match d1 with
                                                                    | Compilers.Coq_type.Coq_base t10 ->
                                                                    (match t10 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t11 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    t11)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a0, b0) ->
                                                                    (match a0 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t11 ->
                                                                    (match t11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match b0 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t12 ->
                                                                    (match t12 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun do_bounds_check0 ->
                                                                    let t13 =
                                                                    Compilers.Coq_type.Coq_arrow
                                                                    ((Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))
                                                                    in
                                                                    (fun idc0 rout args2 ->
                                                                    let x1 =
                                                                    fun _ ->
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
                                                                    in
                                                                    let (
                                                                    p1, f) =
                                                                    Obj.magic
                                                                    args2
                                                                    in
                                                                    let (
                                                                    s5, _) =
                                                                    p1
                                                                    in
                                                                    let (
                                                                    p2, p3) =
                                                                    f
                                                                    in
                                                                    let (
                                                                    e1v, p4) =
                                                                    p2
                                                                    in
                                                                    let (
                                                                    e4, r1) =
                                                                    p4
                                                                    in
                                                                    let (
                                                                    p5, f0) =
                                                                    p3
                                                                    in
                                                                    let (
                                                                    e2v, p6) =
                                                                    p5
                                                                    in
                                                                    let (
                                                                    e5, r2) =
                                                                    p6
                                                                    in
                                                                    let () =
                                                                    f0
                                                                    in
                                                                    (
                                                                    match 
                                                                    bind
                                                                    (Obj.magic
                                                                    Coq5_Compilers.Coq_invert_expr.invert_Literal_through_cast
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    s5)
                                                                    (fun rs ->
                                                                    bind
                                                                    (maybe_log2
                                                                    (snd rs))
                                                                    (fun lg2s ->
                                                                    Some
                                                                    ((fst rs),
                                                                    lg2s))) with
                                                                    | Some p7 ->
                                                                    let (
                                                                    r0, s6) =
                                                                    p7
                                                                    in
                                                                    (
                                                                    match idc0 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    (match 
                                                                    match r0 with
                                                                    | Some r3 ->
                                                                    if 
                                                                    Coq6_Compilers.ZRange.Coq_type.is_bounded_by
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    r3
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    then 
                                                                    Inl ()
                                                                    else 
                                                                    Inr
                                                                    ((append
                                                                    ('L'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[]))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    Decimal.show_Z
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6))
                                                                    (append
                                                                    (' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('w'::('i'::('t'::('h'::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('c'::('a'::('s'::('t'::('e'::('d'::(' '::('r'::('a'::('n'::('g'::('e'::(' '::[]))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Obj.magic
                                                                    show_zrange)
                                                                    r3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::[])))))))))))))))))))))))))))
                                                                    (append
                                                                    ('f'::('i'::('r'::('s'::('t'::[])))))
                                                                    (append
                                                                    (' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::[])))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)
                                                                    (')'::[]))))))))) :: [])
                                                                    | None ->
                                                                    Inl () with
                                                                    | Inl _ ->
                                                                    (match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e1v r1 with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst rout) with
                                                                    | Inl x3 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl x4 ->
                                                                    Inl (x3,
                                                                    x4)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x3 ->
                                                                    let (
                                                                    _, _) = x2
                                                                    in
                                                                    let (
                                                                    _, _) = x3
                                                                    in
                                                                    Inl
                                                                    ((
                                                                    (option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos XH)) })))
                                                                    (fst rout)),
                                                                    (option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos XH)) })))
                                                                    (snd rout))),
                                                                    (fun retptr ->
                                                                    (Call
                                                                    (AppIdent
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))))),
                                                                    Coq_type.Coq_unit,
                                                                    (Z_mul_split
                                                                    s6),
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    retptr,
                                                                    (Pair
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    e4,
                                                                    e5))))))) :: []))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst rout) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    t13 idc0
                                                                    s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl _ ->
                                                                    Inr err2
                                                                    | Inr err3 ->
                                                                    Inr
                                                                    (app err2
                                                                    err3)) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    let idc1 =
                                                                    Coq3_Compilers.Coq_ident_Z_add_get_carry
                                                                    in
                                                                    let idc' =
                                                                    invert_Some0
                                                                    (match idc1 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    Some
                                                                    (Z_add_with_get_carry
                                                                    s6)
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    Some
                                                                    (Z_sub_with_get_borrow
                                                                    s6)
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    None)
                                                                    in
                                                                    (
                                                                    match 
                                                                    match r0 with
                                                                    | Some r3 ->
                                                                    if 
                                                                    Coq6_Compilers.ZRange.Coq_type.is_bounded_by
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    r3
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    then 
                                                                    Inl ()
                                                                    else 
                                                                    Inr
                                                                    ((append
                                                                    ('L'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[]))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    Decimal.show_Z
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6))
                                                                    (append
                                                                    (' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('w'::('i'::('t'::('h'::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('c'::('a'::('s'::('t'::('e'::('d'::(' '::('r'::('a'::('n'::('g'::('e'::(' '::[]))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Obj.magic
                                                                    show_zrange)
                                                                    r3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::[])))))))))))))))))))))))))))
                                                                    (append
                                                                    ('f'::('i'::('r'::('s'::('t'::[])))))
                                                                    (append
                                                                    (' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::[])))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))
                                                                    idc1)
                                                                    (')'::[]))))))))) :: [])
                                                                    | None ->
                                                                    Inl () with
                                                                    | Inl _ ->
                                                                    let (
                                                                    return_carry_borrow_width,
                                                                    round_up_return_carry) =
                                                                    if 
                                                                    existsb
                                                                    (Coq_Z.eqb
                                                                    s6)
                                                                    relax_adc_sbb_return_carry_to_bitwidth0
                                                                    then 
                                                                    (s6,
                                                                    (fun t14 ->
                                                                    option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos XH)) })))
                                                                    t14))
                                                                    else 
                                                                    ((Zpos
                                                                    XH),
                                                                    (fun x2 ->
                                                                    x2))
                                                                    in
                                                                    (
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e1v r1 with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst rout) with
                                                                    | Inl x3 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl x4 ->
                                                                    Inl (x3,
                                                                    x4)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x3 ->
                                                                    let (
                                                                    _, _) = x2
                                                                    in
                                                                    let (
                                                                    _, _) = x3
                                                                    in
                                                                    let (
                                                                    e6, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos XH)) }))
                                                                    (e4, r1)
                                                                    in
                                                                    let (
                                                                    e7, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos XH)) }))
                                                                    (e5, r2)
                                                                    in
                                                                    Inl
                                                                    ((
                                                                    (option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos XH)) })))
                                                                    (fst rout)),
                                                                    (round_up_return_carry
                                                                    (snd rout))),
                                                                    (fun retptr ->
                                                                    (Call
                                                                    (AppIdent
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))))),
                                                                    Coq_type.Coq_unit,
                                                                    (Obj.magic
                                                                    idc'),
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    retptr,
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Pair
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (AppIdent
                                                                    (Coq_type.Coq_unit,
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_literal
                                                                    Z0),
                                                                    TT)),
                                                                    e6)),
                                                                    e7))))))) :: []))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst rout) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd rout) with
                                                                    | Inl _ ->
                                                                    Inr err2
                                                                    | Inr err3 ->
                                                                    Inr
                                                                    (app err2
                                                                    err3)) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13) idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    let idc1 =
                                                                    Coq3_Compilers.Coq_ident_Z_sub_get_borrow
                                                                    in
                                                                    let idc' =
                                                                    invert_Some0
                                                                    (match idc1 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    Some
                                                                    (Z_add_with_get_carry
                                                                    s6)
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    Some
                                                                    (Z_sub_with_get_borrow
                                                                    s6)
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    None)
                                                                    in
                                                                    (
                                                                    match 
                                                                    match r0 with
                                                                    | Some r3 ->
                                                                    if 
                                                                    Coq6_Compilers.ZRange.Coq_type.is_bounded_by
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    r3
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    then 
                                                                    Inl ()
                                                                    else 
                                                                    Inr
                                                                    ((append
                                                                    ('L'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[]))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    Decimal.show_Z
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6))
                                                                    (append
                                                                    (' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('w'::('i'::('t'::('h'::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('c'::('a'::('s'::('t'::('e'::('d'::(' '::('r'::('a'::('n'::('g'::('e'::(' '::[]))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Obj.magic
                                                                    show_zrange)
                                                                    r3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::[])))))))))))))))))))))))))))
                                                                    (append
                                                                    ('f'::('i'::('r'::('s'::('t'::[])))))
                                                                    (append
                                                                    (' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::[])))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))
                                                                    idc1)
                                                                    (')'::[]))))))))) :: [])
                                                                    | None ->
                                                                    Inl () with
                                                                    | Inl _ ->
                                                                    let (
                                                                    return_carry_borrow_width,
                                                                    round_up_return_carry) =
                                                                    if 
                                                                    existsb
                                                                    (Coq_Z.eqb
                                                                    s6)
                                                                    relax_adc_sbb_return_carry_to_bitwidth0
                                                                    then 
                                                                    (s6,
                                                                    (fun t14 ->
                                                                    option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    t14))
                                                                    else 
                                                                    ((Zpos
                                                                    XH),
                                                                    (fun x2 ->
                                                                    x2))
                                                                    in
                                                                    (
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e1v r1 with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl x3 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl x4 ->
                                                                    Inl (x3,
                                                                    x4)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x3 ->
                                                                    let (
                                                                    _, _) =
                                                                    x2
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    x3
                                                                    in
                                                                    let (
                                                                    e6, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (e4, r1)
                                                                    in
                                                                    let (
                                                                    e7, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos
                                                                    XH)) }))
                                                                    (e5, r2)
                                                                    in
                                                                    Inl
                                                                    ((
                                                                    (option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s6)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (fst
                                                                    rout)),
                                                                    (round_up_return_carry
                                                                    (snd
                                                                    rout))),
                                                                    (fun retptr ->
                                                                    (Call
                                                                    (AppIdent
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))))),
                                                                    Coq_type.Coq_unit,
                                                                    (Obj.magic
                                                                    idc'),
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    retptr,
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Pair
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (AppIdent
                                                                    (Coq_type.Coq_unit,
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_literal
                                                                    Z0),
                                                                    TT)),
                                                                    e6)),
                                                                    e7))))))) :: []))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1 s6
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err2
                                                                    | Inr err3 ->
                                                                    Inr
                                                                    (app err2
                                                                    err3)) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)) :: []))
                                                                    | None ->
                                                                    Inr
                                                                    ((append
                                                                    ('E'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('a'::(' '::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('p'::('o'::('w'::('e'::('r'::(' '::('o'::('f'::(' '::('t'::('w'::('o'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::('\226'::('\132'::('\164'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (x1 __
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    s5)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('r'::('s'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t13)
                                                                    idc0)
                                                                    (')'::[]))))) :: []))))
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a1, b1) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a1,
                                                                    b1))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a1)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a1)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    Compilers.Coq_base.Coq_type.Coq_unit))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool),
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat),
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string),
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a1, b1) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a1,
                                                                    b1)),
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_list
                                                                    a1),
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_option
                                                                    a1),
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (Compilers.Coq_base.Coq_type.Coq_unit,
                                                                    b0))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a0)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a0)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    s5, d2) ->
                                                                    (match s5 with
                                                                    | Compilers.Coq_type.Coq_base t10 ->
                                                                    (match t10 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t11 ->
                                                                    (match t11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match d2 with
                                                                    | Compilers.Coq_type.Coq_base t12 ->
                                                                    (match t12 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t13 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    t13)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a0, b0) ->
                                                                    (match a0 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t13 ->
                                                                    (match t13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (match b0 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t14 ->
                                                                    (match t14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun do_bounds_check0 ->
                                                                    let t15 =
                                                                    Compilers.Coq_type.Coq_arrow
                                                                    ((Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))
                                                                    in
                                                                    (fun idc0 rout args2 ->
                                                                    let x1 =
                                                                    fun _ ->
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
                                                                    in
                                                                    let (
                                                                    p1, f) =
                                                                    Obj.magic
                                                                    args2
                                                                    in
                                                                    let (
                                                                    s6, _) =
                                                                    p1
                                                                    in
                                                                    let (
                                                                    p2, p3) =
                                                                    f
                                                                    in
                                                                    let (
                                                                    e1v, p4) =
                                                                    p2
                                                                    in
                                                                    let (
                                                                    e4, r1) =
                                                                    p4
                                                                    in
                                                                    let (
                                                                    p5, p6) =
                                                                    p3
                                                                    in
                                                                    let (
                                                                    e2v, p7) =
                                                                    p5
                                                                    in
                                                                    let (
                                                                    e5, r2) =
                                                                    p7
                                                                    in
                                                                    let (
                                                                    p8, f0) =
                                                                    p6
                                                                    in
                                                                    let (
                                                                    _, p9) =
                                                                    p8
                                                                    in
                                                                    let (
                                                                    e6, r3) =
                                                                    p9
                                                                    in
                                                                    let () =
                                                                    f0
                                                                    in
                                                                    (
                                                                    match 
                                                                    bind
                                                                    (Obj.magic
                                                                    Coq5_Compilers.Coq_invert_expr.invert_Literal_through_cast
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    s6)
                                                                    (fun rs ->
                                                                    bind
                                                                    (maybe_log2
                                                                    (snd rs))
                                                                    (fun lg2s ->
                                                                    Some
                                                                    ((fst rs),
                                                                    lg2s))) with
                                                                    | Some p10 ->
                                                                    let (
                                                                    r0, s7) =
                                                                    p10
                                                                    in
                                                                    (
                                                                    match idc0 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    let idc1 =
                                                                    Coq3_Compilers.Coq_ident_Z_add_with_get_carry
                                                                    in
                                                                    let idc' =
                                                                    invert_Some0
                                                                    (match idc1 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    Some
                                                                    (Z_add_with_get_carry
                                                                    s7)
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    Some
                                                                    (Z_sub_with_get_borrow
                                                                    s7)
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    None)
                                                                    in
                                                                    (
                                                                    match 
                                                                    match r0 with
                                                                    | Some r4 ->
                                                                    if 
                                                                    Coq6_Compilers.ZRange.Coq_type.is_bounded_by
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    r4
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    then 
                                                                    Inl ()
                                                                    else 
                                                                    Inr
                                                                    ((append
                                                                    ('L'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[]))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    Decimal.show_Z
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7))
                                                                    (append
                                                                    (' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('w'::('i'::('t'::('h'::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('c'::('a'::('s'::('t'::('e'::('d'::(' '::('r'::('a'::('n'::('g'::('e'::(' '::[]))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Obj.magic
                                                                    show_zrange)
                                                                    r4)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::[])))))))))))))))))))))))))))
                                                                    (append
                                                                    ('f'::('i'::('r'::('s'::('t'::[])))))
                                                                    (append
                                                                    (' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::[])))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))
                                                                    idc1)
                                                                    (')'::[]))))))))) :: [])
                                                                    | None ->
                                                                    Inl () with
                                                                    | Inl _ ->
                                                                    let (
                                                                    return_carry_borrow_width,
                                                                    round_up_return_carry) =
                                                                    if 
                                                                    existsb
                                                                    (Coq_Z.eqb
                                                                    s7)
                                                                    relax_adc_sbb_return_carry_to_bitwidth0
                                                                    then 
                                                                    (s7,
                                                                    (fun t16 ->
                                                                    option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    t16))
                                                                    else 
                                                                    ((Zpos
                                                                    XH),
                                                                    (fun x2 ->
                                                                    x2))
                                                                    in
                                                                    (
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    (Zpos XH)
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e1v r1 with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('t'::('h'::('i'::('r'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x3 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl x4 ->
                                                                    Inl (x3,
                                                                    x4)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x3 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl x4 ->
                                                                    let (
                                                                    x5, x6) =
                                                                    x3
                                                                    in
                                                                    Inl ((x5,
                                                                    x6), x4)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x3 ->
                                                                    let (
                                                                    _, _) =
                                                                    x2
                                                                    in
                                                                    let (
                                                                    p11, _) =
                                                                    x3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    p11
                                                                    in
                                                                    let (
                                                                    e7, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Zpos
                                                                    XH))
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (e4, r1)
                                                                    in
                                                                    let (
                                                                    e8, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (e5, r2)
                                                                    in
                                                                    let (
                                                                    e9, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (e6, r3)
                                                                    in
                                                                    Inl
                                                                    ((
                                                                    (option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (fst
                                                                    rout)),
                                                                    (round_up_return_carry
                                                                    (snd
                                                                    rout))),
                                                                    (fun retptr ->
                                                                    (Call
                                                                    (AppIdent
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))))),
                                                                    Coq_type.Coq_unit,
                                                                    (Obj.magic
                                                                    idc'),
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    retptr,
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Pair
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    e7, e8)),
                                                                    e9))))))) :: []))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('t'::('h'::('i'::('r'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err2
                                                                    | Inr err3 ->
                                                                    Inr
                                                                    (app err2
                                                                    err3)) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl x3 ->
                                                                    let (
                                                                    x4, x5) =
                                                                    x2
                                                                    in
                                                                    Inl ((x4,
                                                                    x5), x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err2
                                                                    | Inr err3 ->
                                                                    Inr
                                                                    (app err2
                                                                    err3)) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    let idc1 =
                                                                    Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow
                                                                    in
                                                                    let idc' =
                                                                    invert_Some0
                                                                    (match idc1 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    Some
                                                                    (Z_add_with_get_carry
                                                                    s7)
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    Some
                                                                    (Z_sub_with_get_borrow
                                                                    s7)
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    None
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    None)
                                                                    in
                                                                    (
                                                                    match 
                                                                    match r0 with
                                                                    | Some r4 ->
                                                                    if 
                                                                    Coq6_Compilers.ZRange.Coq_type.is_bounded_by
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    r4
                                                                    (Obj.magic
                                                                    Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    then 
                                                                    Inl ()
                                                                    else 
                                                                    Inr
                                                                    ((append
                                                                    ('L'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::[]))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    Decimal.show_Z
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7))
                                                                    (append
                                                                    (' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('w'::('i'::('t'::('h'::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('c'::('a'::('s'::('t'::('e'::('d'::(' '::('r'::('a'::('n'::('g'::('e'::(' '::[]))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Obj.magic
                                                                    show_zrange)
                                                                    r4)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::[])))))))))))))))))))))))))))
                                                                    (append
                                                                    ('f'::('i'::('r'::('s'::('t'::[])))))
                                                                    (append
                                                                    (' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::[])))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))))))))))))
                                                                    idc1)
                                                                    (')'::[]))))))))) :: [])
                                                                    | None ->
                                                                    Inl () with
                                                                    | Inl _ ->
                                                                    let (
                                                                    return_carry_borrow_width,
                                                                    round_up_return_carry) =
                                                                    if 
                                                                    existsb
                                                                    (Coq_Z.eqb
                                                                    s7)
                                                                    relax_adc_sbb_return_carry_to_bitwidth0
                                                                    then 
                                                                    (s7,
                                                                    (fun t16 ->
                                                                    option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    t16))
                                                                    else 
                                                                    ((Zpos
                                                                    XH),
                                                                    (fun x2 ->
                                                                    x2))
                                                                    in
                                                                    (
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    (Zpos XH)
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e1v r1 with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[]))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('t'::('h'::('i'::('r'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x3 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl x4 ->
                                                                    Inl (x3,
                                                                    x4)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x3 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl x4 ->
                                                                    let (
                                                                    x5, x6) =
                                                                    x3
                                                                    in
                                                                    Inl ((x5,
                                                                    x6), x4)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)) with
                                                                    | Inl x3 ->
                                                                    let (
                                                                    _, _) =
                                                                    x2
                                                                    in
                                                                    let (
                                                                    p11, _) =
                                                                    x3
                                                                    in
                                                                    let (
                                                                    _, _) =
                                                                    p11
                                                                    in
                                                                    let (
                                                                    e7, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH))
                                                                    (Zpos
                                                                    XH))
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (e4, r1)
                                                                    in
                                                                    let (
                                                                    e8, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (e5, r2)
                                                                    in
                                                                    let (
                                                                    e9, _) =
                                                                    Obj.magic
                                                                    result_upcast
                                                                    lang_casts
                                                                    language_specific_cast_adjustment
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)
                                                                    (Some
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (e6, r3)
                                                                    in
                                                                    Inl
                                                                    ((
                                                                    (option_map
                                                                    (Coq7_Compilers.ToString.Coq_int.union
                                                                    (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                                                                    (relax_zrange
                                                                    { lower =
                                                                    Z0;
                                                                    upper =
                                                                    (Coq_Z.sub
                                                                    (Coq_Z.pow
                                                                    (Zpos (XO
                                                                    XH)) s7)
                                                                    (Zpos
                                                                    XH)) })))
                                                                    (fst
                                                                    rout)),
                                                                    (round_up_return_carry
                                                                    (snd
                                                                    rout))),
                                                                    (fun retptr ->
                                                                    (Call
                                                                    (AppIdent
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))))),
                                                                    Coq_type.Coq_unit,
                                                                    (Obj.magic
                                                                    idc'),
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Zptr))),
                                                                    (Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    retptr,
                                                                    (Pair
                                                                    ((Coq_type.Coq_prod
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z))),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Pair
                                                                    ((Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    (Coq_type.Coq_type_primitive
                                                                    Coq_type.Z),
                                                                    e7, e8)),
                                                                    e9))))))) :: []))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err1 ->
                                                                    (match 
                                                                    match 
                                                                    match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('t'::('h'::('i'::('r'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::[])))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v r2 with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl x3 ->
                                                                    Inl (x2,
                                                                    x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('f'::('i'::('r'::('s'::('t'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[])))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1 s7
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (fst
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err2
                                                                    | Inr err3 ->
                                                                    Inr
                                                                    (app err2
                                                                    err3)) with
                                                                    | Inl x2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl x3 ->
                                                                    let (
                                                                    x4, x5) =
                                                                    x2
                                                                    in
                                                                    Inl ((x4,
                                                                    x5), x3)
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Inr err2 ->
                                                                    (match 
                                                                    bounds_check
                                                                    relax_zrange
                                                                    do_bounds_check0
                                                                    ('s'::('e'::('c'::('o'::('n'::('d'::(' '::('('::('c'::('a'::('r'::('r'::('y'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::[]))))))))))))))))))))))))))))))
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))))))))))))
                                                                    idc1
                                                                    return_carry_borrow_width
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z))
                                                                    e2v
                                                                    (snd
                                                                    rout) with
                                                                    | Inl _ ->
                                                                    Inr err2
                                                                    | Inr err3 ->
                                                                    Inr
                                                                    (app err2
                                                                    err3)) with
                                                                    | Inl _ ->
                                                                    Inr err1
                                                                    | Inr err2 ->
                                                                    Inr
                                                                    (app err1
                                                                    err2)))
                                                                    | Inr err0 ->
                                                                    Inr err0)
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: [])
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('t'::('t'::('e'::('m'::('p'::('t'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('w'::('i'::('t'::('h'::(' '::('2'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)) :: []))
                                                                    | None ->
                                                                    Inr
                                                                    ((append
                                                                    ('E'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('a'::(' '::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('p'::('o'::('w'::('e'::('r'::(' '::('o'::('f'::(' '::('t'::('w'::('o'::(' '::('o'::('f'::(' '::('t'::('y'::('p'::('e'::(' '::('\226'::('\132'::('\164'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (x1 __
                                                                    (Coq5_Compilers.Coercions.base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)))
                                                                    s6)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('r'::('s'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    t15)
                                                                    idc0)
                                                                    (')'::[]))))) :: []))))
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string)))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a1, b1) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a1,
                                                                    b1))))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a1)))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a1)))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z),
                                                                    Compilers.Coq_base.Coq_type.Coq_unit))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool),
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat),
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange),
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string),
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a1, b1) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a1,
                                                                    b1)),
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_list
                                                                    a1),
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a1 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    ((Compilers.Coq_base.Coq_type.Coq_option
                                                                    a1),
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (Compilers.Coq_base.Coq_type.Coq_unit,
                                                                    b0))))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a0)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a0)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    s6, d3) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    (s6,
                                                                    d3)))))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string)),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a0, b0) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a0,
                                                                    b0))),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a0)),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a0)),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    s6, d3) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s6,
                                                                    d3)),
                                                                    d2)))))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))))
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string)),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a0, b0) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a0,
                                                                    b0))),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a0)),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a0)),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    s5, d2) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s5,
                                                                    d2)),
                                                                    d1)))))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))))
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string)),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a0, b0) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a0,
                                                                    b0))),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a0)),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a0)),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    s4, d1) ->
                                                                    (fun _ idc0 _ _ ->
                                                                    Inr
                                                                    ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Z)),
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s4,
                                                                    d1)),
                                                                    d0)))))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))))
                                                              | Coq3_Compilers.Coq_bool ->
                                                                (fun _ idc0 _ _ ->
                                                                  Inr
                                                                  ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_bool)),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                              | Coq3_Compilers.Coq_nat ->
                                                                (fun _ idc0 _ _ ->
                                                                  Inr
                                                                  ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_nat)),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                              | Coq3_Compilers.Coq_zrange ->
                                                                (fun _ idc0 _ _ ->
                                                                  Inr
                                                                  ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_zrange)),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                              | Coq3_Compilers.Coq_string ->
                                                                (fun _ idc0 _ _ ->
                                                                  Inr
                                                                  ((append
                                                                    ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                    Coq3_Compilers.Coq_string)),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                           | Compilers.Coq_base.Coq_type.Coq_prod (
                                                               a0, b0) ->
                                                             (fun _ idc0 _ _ ->
                                                               Inr
                                                               ((append
                                                                  ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                  (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                                    (a0,
                                                                    b0))),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                           | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                                                             (fun _ idc0 _ _ ->
                                                               Inr
                                                               ((append
                                                                  ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                  (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_list
                                                                    a0)),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                           | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                                                             (fun _ idc0 _ _ ->
                                                               Inr
                                                               ((append
                                                                  ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                  (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_base.Coq_type.Coq_option
                                                                    a0)),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))
                                                           | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                             (fun _ idc0 _ _ ->
                                                               Inr
                                                               ((append
                                                                  ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                                  (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                    t3)
                                                                    (append
                                                                    (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_base
                                                                    Compilers.Coq_base.Coq_type.Coq_unit),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: [])))
                                                        | Compilers.Coq_type.Coq_arrow (
                                                            s3, d0) ->
                                                          (fun _ idc0 _ _ ->
                                                            Inr
                                                            ((append
                                                               ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('c'::('a'::('l'::('l'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))
                                                               (append
                                                                 (show0
                                                                   (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                                                   t3)
                                                                 (append
                                                                   (' '::('('::('w'::('h'::('e'::('n'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('h'::('a'::('n'::('d'::('l'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('e'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                                   (append
                                                                    (show0
                                                                    (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                    (Compilers.Coq_type.Coq_arrow
                                                                    ((Compilers.Coq_type.Coq_arrow
                                                                    (s3,
                                                                    d0)),
                                                                    d)))
                                                                    idc0)
                                                                    (')'::[]))))) :: []))))
                                                      do_bounds_check idc
                                                      (rout1, rout2) args1 with
                                              | Inl idce ->
                                                let (p1, idce0) = idce in
                                                let (rout3, rout4) = p1 in
                                                (match fst
                                                         ((declare_name
                                                            lang_casts
                                                            (show0
                                                              (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                t3) idc)
                                                            count0 make_name0
                                                            rout3),
                                                         (declare_name
                                                           lang_casts
                                                           (show0
                                                             (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                               t3) idc)
                                                           (Coq_Pos.succ
                                                             count0)
                                                           make_name0 rout4)) with
                                                 | Inl x1 ->
                                                   (match snd
                                                            ((declare_name
                                                               lang_casts
                                                               (show0
                                                                 (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                   t3) idc)
                                                               count0
                                                               make_name0
                                                               rout3),
                                                            (declare_name
                                                              lang_casts
                                                              (show0
                                                                (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                  t3) idc)
                                                              (Coq_Pos.succ
                                                                count0)
                                                              make_name0
                                                              rout4)) with
                                                    | Inl x2 ->
                                                      let (p2, retv1) = x1 in
                                                      let (p3, is_ptr1) = p2
                                                      in
                                                      let (decls1, n3) = p3
                                                      in
                                                      let (p4, retv2) = x2 in
                                                      let (p5, is_ptr2) = p4
                                                      in
                                                      let (decls2, n4) = p5
                                                      in
                                                      Inl
                                                      ((app decls1
                                                         (app decls2
                                                           (idce0 (Pair
                                                             ((Coq_type.Coq_type_primitive
                                                             Coq_type.Zptr),
                                                             (Coq_type.Coq_type_primitive
                                                             Coq_type.Zptr),
                                                             retv1, retv2))))),
                                                      ((((Obj.magic (n3,
                                                           is_ptr1)),
                                                      (Obj.magic rout3)),
                                                      None),
                                                      (Obj.magic (((n4,
                                                        is_ptr2), rout4),
                                                        None))))
                                                    | Inr err0 -> Inr err0)
                                                 | Inr err1 ->
                                                   (match snd
                                                            ((declare_name
                                                               lang_casts
                                                               (show0
                                                                 (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                   t3) idc)
                                                               count0
                                                               make_name0
                                                               rout3),
                                                            (declare_name
                                                              lang_casts
                                                              (show0
                                                                (Coq7_Compilers.ToString.PHOAS.Coq_ident.show_ident
                                                                  t3) idc)
                                                              (Coq_Pos.succ
                                                                count0)
                                                              make_name0
                                                              rout4)) with
                                                    | Inl _ -> Inr err1
                                                    | Inr err2 ->
                                                      Inr (app err1 err2)))
                                              | Inr err0 -> Inr err0)
                                           | Inr err0 -> Inr err0)
                                        | None ->
                                          Inr
                                            ((append
                                               ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('o'::('f'::(' '::('n'::('o'::('n'::('-'::('i'::('d'::('e'::('n'::('t'::('i'::('f'::('i'::('e'::('r'::('-'::('a'::('p'::('p'::('l'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))
                                               (show0
                                                 (x0 __
                                                   (Compilers.Coq_type.Coq_base
                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z),
                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                   Coq3_Compilers.Z))))) e0)) :: [])))
                                   | Coq3_Compilers.Coq_bool ->
                                     (fun e _ _ -> Inr
                                       ((append
                                          ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                          (append
                                            (show0
                                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                              s')
                                            (append
                                              (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                              (append
                                                (show0
                                                  (x __
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_bool)))))
                                                  e) (')'::[]))))) :: []))
                                   | Coq3_Compilers.Coq_nat ->
                                     (fun e _ _ -> Inr
                                       ((append
                                          ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                          (append
                                            (show0
                                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                              s')
                                            (append
                                              (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                              (append
                                                (show0
                                                  (x __
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_nat)))))
                                                  e) (')'::[]))))) :: []))
                                   | Coq3_Compilers.Coq_zrange ->
                                     (fun e _ _ -> Inr
                                       ((append
                                          ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                          (append
                                            (show0
                                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                              s')
                                            (append
                                              (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                              (append
                                                (show0
                                                  (x __
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_zrange)))))
                                                  e) (')'::[]))))) :: []))
                                   | Coq3_Compilers.Coq_string ->
                                     (fun e _ _ -> Inr
                                       ((append
                                          ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                          (append
                                            (show0
                                              (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                                Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                              s')
                                            (append
                                              (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                              (append
                                                (show0
                                                  (x __
                                                    (Compilers.Coq_type.Coq_base
                                                    (Compilers.Coq_base.Coq_type.Coq_prod
                                                    ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Z),
                                                    (Compilers.Coq_base.Coq_type.Coq_type_base
                                                    Coq3_Compilers.Coq_string)))))
                                                  e) (')'::[]))))) :: [])))
                                | Compilers.Coq_base.Coq_type.Coq_prod (
                                    a0, b0) ->
                                  (fun e _ _ -> Inr
                                    ((append
                                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                       (append
                                         (show0
                                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                           s')
                                         (append
                                           (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                           (append
                                             (show0
                                               (x __
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 (a0, b0)))))) e) (')'::[]))))) :: []))
                                | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                                  (fun e _ _ -> Inr
                                    ((append
                                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                       (append
                                         (show0
                                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                           s')
                                         (append
                                           (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                           (append
                                             (show0
                                               (x __
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_list
                                                 a0))))) e) (')'::[]))))) :: []))
                                | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                                  (fun e _ _ -> Inr
                                    ((append
                                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                       (append
                                         (show0
                                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                           s')
                                         (append
                                           (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                           (append
                                             (show0
                                               (x __
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 (Compilers.Coq_base.Coq_type.Coq_option
                                                 a0))))) e) (')'::[]))))) :: []))
                                | Compilers.Coq_base.Coq_type.Coq_unit ->
                                  (fun e _ _ -> Inr
                                    ((append
                                       ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                       (append
                                         (show0
                                           (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                             Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                           s')
                                         (append
                                           (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                           (append
                                             (show0
                                               (x __
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Z),
                                                 Compilers.Coq_base.Coq_type.Coq_unit))))
                                               e) (')'::[]))))) :: [])))
                             | Coq3_Compilers.Coq_bool ->
                               (fun e _ _ -> Inr
                                 ((append
                                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                    (append
                                      (show0
                                        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                        s')
                                      (append
                                        (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                        (append
                                          (show0
                                            (x __
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_bool), b))))
                                            e) (')'::[]))))) :: []))
                             | Coq3_Compilers.Coq_nat ->
                               (fun e _ _ -> Inr
                                 ((append
                                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                    (append
                                      (show0
                                        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                        s')
                                      (append
                                        (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                        (append
                                          (show0
                                            (x __
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_nat), b))))
                                            e) (')'::[]))))) :: []))
                             | Coq3_Compilers.Coq_zrange ->
                               (fun e _ _ -> Inr
                                 ((append
                                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                    (append
                                      (show0
                                        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                        s')
                                      (append
                                        (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                        (append
                                          (show0
                                            (x __
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_zrange),
                                              b)))) e) (')'::[]))))) :: []))
                             | Coq3_Compilers.Coq_string ->
                               (fun e _ _ -> Inr
                                 ((append
                                    ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                    (append
                                      (show0
                                        (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                          Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                        s')
                                      (append
                                        (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                        (append
                                          (show0
                                            (x __
                                              (Compilers.Coq_type.Coq_base
                                              (Compilers.Coq_base.Coq_type.Coq_prod
                                              ((Compilers.Coq_base.Coq_type.Coq_type_base
                                              Coq3_Compilers.Coq_string),
                                              b)))) e) (')'::[]))))) :: [])))
                          | Compilers.Coq_base.Coq_type.Coq_prod (a0, b0) ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                           ((Compilers.Coq_base.Coq_type.Coq_prod
                                           (a0, b0)), b)))) e) (')'::[]))))) :: []))
                          | Compilers.Coq_base.Coq_type.Coq_list a0 ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                           ((Compilers.Coq_base.Coq_type.Coq_list
                                           a0), b)))) e) (')'::[]))))) :: []))
                          | Compilers.Coq_base.Coq_type.Coq_option a0 ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                           ((Compilers.Coq_base.Coq_type.Coq_option
                                           a0), b)))) e) (')'::[]))))) :: []))
                          | Compilers.Coq_base.Coq_type.Coq_unit ->
                            (fun e _ _ -> Inr
                              ((append
                                 ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                                 (append
                                   (show0
                                     (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                       Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                     s')
                                   (append
                                     (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                     (append
                                       (show0
                                         (x __ (Compilers.Coq_type.Coq_base
                                           (Compilers.Coq_base.Coq_type.Coq_prod
                                           (Compilers.Coq_base.Coq_type.Coq_unit,
                                           b)))) e) (')'::[]))))) :: [])))
                       | Compilers.Coq_base.Coq_type.Coq_list a ->
                         (fun e _ _ -> Inr
                           ((append
                              ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                              (append
                                (show0
                                  (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                  s')
                                (append
                                  (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                  (append
                                    (show0
                                      (x __ (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_list
                                        a))) e) (')'::[]))))) :: []))
                       | Compilers.Coq_base.Coq_type.Coq_option a ->
                         (fun e _ _ -> Inr
                           ((append
                              ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                              (append
                                (show0
                                  (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                    Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                                  s')
                                (append
                                  (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                                  (append
                                    (show0
                                      (x __ (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_option
                                        a))) e) (')'::[]))))) :: []))
                       | Compilers.Coq_base.Coq_type.Coq_unit ->
                         (fun e _ _ ->
                           let x0 = fun _ ->
                             Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
                           in
                           let ret_err = Inr
                             ((append
                                ('N'::('o'::('t'::(' '::('a'::(' '::('c'::('o'::('m'::('m'::('e'::('n'::('t'::(' '::[]))))))))))))))
                                (show0
                                  (x0 __ (Compilers.Coq_type.Coq_base
                                    Compilers.Coq_base.Coq_type.Coq_unit)) e)) :: [])
                           in
                           (match Compilers.Coq_invert_expr.invert_AppIdent
                                    (Compilers.Coq_type.Coq_base
                                    Compilers.Coq_base.Coq_type.Coq_unit) e with
                            | Some s1 ->
                              let ExistT (t1, p) = s1 in
                              let (idc, arg) = p in
                              (match var_data_of_string_opt
                                       (Compilers.Coq_type.Coq_base
                                       Compilers.Coq_base.Coq_type.Coq_unit)
                                       ('('::(')'::[])) with
                               | Some retdata ->
                                 let should_keep_live =
                                   match idc with
                                   | Coq3_Compilers.Coq_ident_Literal (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_comment _ ->
                                     Some true
                                   | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                     Some false
                                   | Coq3_Compilers.Coq_ident_value_barrier ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Nat_succ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Nat_pred ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Nat_max -> None
                                   | Coq3_Compilers.Coq_ident_Nat_mul -> None
                                   | Coq3_Compilers.Coq_ident_Nat_add -> None
                                   | Coq3_Compilers.Coq_ident_Nat_sub -> None
                                   | Coq3_Compilers.Coq_ident_Nat_eqb -> None
                                   | Coq3_Compilers.Coq_ident_nil _ -> None
                                   | Coq3_Compilers.Coq_ident_cons _ -> None
                                   | Coq3_Compilers.Coq_ident_tt -> None
                                   | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_prod_rect (
                                       _, _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_list_rect (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_eager_list_rect (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                       _, _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                       _, _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_list_case (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_length _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_seq ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_combine (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_map (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_app _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_rev _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_flat_map (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_partition _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_filter _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_fold_right (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_add -> None
                                   | Coq3_Compilers.Coq_ident_Z_mul -> None
                                   | Coq3_Compilers.Coq_ident_Z_pow -> None
                                   | Coq3_Compilers.Coq_ident_Z_sub -> None
                                   | Coq3_Compilers.Coq_ident_Z_opp -> None
                                   | Coq3_Compilers.Coq_ident_Z_div -> None
                                   | Coq3_Compilers.Coq_ident_Z_modulo ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_eqb -> None
                                   | Coq3_Compilers.Coq_ident_Z_leb -> None
                                   | Coq3_Compilers.Coq_ident_Z_ltb -> None
                                   | Coq3_Compilers.Coq_ident_Z_geb -> None
                                   | Coq3_Compilers.Coq_ident_Z_gtb -> None
                                   | Coq3_Compilers.Coq_ident_Z_log2 -> None
                                   | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_land -> None
                                   | Coq3_Compilers.Coq_ident_Z_lor -> None
                                   | Coq3_Compilers.Coq_ident_Z_min -> None
                                   | Coq3_Compilers.Coq_ident_Z_max -> None
                                   | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_ltz -> None
                                   | Coq3_Compilers.Coq_ident_Z_zselect ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_bneg -> None
                                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_lxor -> None
                                   | Coq3_Compilers.Coq_ident_Z_rshi -> None
                                   | Coq3_Compilers.Coq_ident_Z_cc_m -> None
                                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Z_cast -> None
                                   | Coq3_Compilers.Coq_ident_Z_cast2 -> None
                                   | Coq3_Compilers.Coq_ident_Some _ -> None
                                   | Coq3_Compilers.Coq_ident_None _ -> None
                                   | Coq3_Compilers.Coq_ident_option_rect (
                                       _, _) ->
                                     None
                                   | Coq3_Compilers.Coq_ident_Build_zrange ->
                                     None
                                   | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_add ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_addc ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_sub ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_subb ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_selc ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_selm ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_sell ->
                                     None
                                   | Coq3_Compilers.Coq_ident_fancy_addm ->
                                     None
                                 in
                                 (match should_keep_live with
                                  | Some should_keep_live0 ->
                                    Inl (((Comment
                                      ((Coq7_Compilers.ToString.PHOAS.Coq_expr.show_lines_expr_gen
                                         Coq7_Compilers.Options.PHOAS.default_with_casts
                                         Coq7_Compilers.Options.PHOAS.default_with_all_casts
                                         string_of_var_data
                                         var_data_of_string_opt t1 arg),
                                      (if should_keep_live0
                                       then extract_var_data_list t1 arg
                                       else []))) :: []),
                                      (Obj.magic retdata))
                                  | None -> ret_err)
                               | None -> ret_err)
                            | None -> ret_err)))
                    | Compilers.Coq_type.Coq_arrow (s1, d) ->
                      (fun e _ _ -> Inr
                        ((append
                           ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('o'::('f'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('m'::('e'::('n'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))
                           (append
                             (show0
                               (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                               s')
                             (append
                               (' '::('('::('w'::('i'::('t'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::[]))))))))))))))))))
                               (append
                                 (show0
                                   (x __ (Compilers.Coq_type.Coq_arrow (s1,
                                     d))) e) (')'::[]))))) :: []))) e3 count
                     make_name with
             | Inl e1_vs ->
               let (e4, vs) = e1_vs in
               (match Obj.magic e2 vs v with
                | Inl e5 -> Inl (app e4 e5)
                | Inr err0 -> Inr err0)
             | Inr err0 -> Inr err0)
          | None -> Inr ((report_type_mismatch s' s0) :: [])

        (** val expr_of_base_PHOAS :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
            -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr -> positive -> (positive -> char list
            option) -> Coq7_Compilers.ToString.OfPHOAS.var_data -> (expr,
            char list list) sum **)

        let expr_of_base_PHOAS lang_casts relax_zrange language_specific_cast_adjustment =
          let rec expr_of_base_PHOAS0 relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check _ e count make_name =
            match e with
            | Compilers.Coq_expr.Ident (t0, idc) ->
              (fun v ->
                make_return_assignment_of_arith lang_casts relax_zrange
                  language_specific_cast_adjustment t0 v
                  (Compilers.Coq_expr.Ident (t0, idc)))
            | Compilers.Coq_expr.Var (t0, v) ->
              (fun v0 ->
                make_return_assignment_of_arith lang_casts relax_zrange
                  language_specific_cast_adjustment t0 v0
                  (Compilers.Coq_expr.Var (t0, v)))
            | Compilers.Coq_expr.Abs (s0, d, f) ->
              (fun v ->
                make_return_assignment_of_arith lang_casts relax_zrange
                  language_specific_cast_adjustment
                  (Compilers.Coq_type.Coq_arrow (s0, d)) v
                  (Compilers.Coq_expr.Abs (s0, d, f)))
            | Compilers.Coq_expr.App (s0, d, f, x) ->
              (fun v ->
                make_return_assignment_of_arith lang_casts relax_zrange
                  language_specific_cast_adjustment d v
                  (Compilers.Coq_expr.App (s0, d, f, x)))
            | Compilers.Coq_expr.LetIn (a, d, e1, e2) ->
              (match a with
               | Compilers.Coq_type.Coq_base s0 ->
                 (fun e3 e4 ->
                   make_assign_expr_of_PHOAS lang_casts relax_zrange
                     language_specific_cast_adjustment
                     relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check
                     (Compilers.Coq_type.Coq_base s0) e3
                     (Compilers.Coq_type.Coq_base s0) d (fun vs vd ->
                     expr_of_base_PHOAS0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       do_bounds_check d (e4 vs)
                       (Coq_Pos.add (size_of_type s0) count) make_name vd)
                     count make_name)
               | Compilers.Coq_type.Coq_arrow (s0, d0) ->
                 (fun e3 e4 v ->
                   make_return_assignment_of_arith lang_casts relax_zrange
                     language_specific_cast_adjustment d v
                     (Compilers.Coq_expr.LetIn ((Compilers.Coq_type.Coq_arrow
                     (s0, d0)), d, e3, e4)))) e1 e2
          in expr_of_base_PHOAS0

        (** val base_var_data_of_bounds_and_typedefs :
            Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type -> bool -> positive ->
            (positive -> char list option) ->
            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
            (positive * Coq7_Compilers.ToString.OfPHOAS.var_data) option **)

        let base_var_data_of_bounds_and_typedefs relax_zrange =
          let rec base_var_data_of_bounds_and_typedefs0 t0 is_ptr count make_name =
            match t0 with
            | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
              (match t1 with
               | Coq3_Compilers.Z ->
                 let t2 = Compilers.Coq_base.Coq_type.Coq_type_base
                   Coq3_Compilers.Z
                 in
                 (fun r0 typedefs ->
                 bind (make_name count) (fun n3 -> Some
                   ((Coq_Pos.succ count),
                   (Obj.magic (((n3, is_ptr),
                     (Coq7_Compilers.ToString.Coq_int.Coq_option.Coq_interp.of_zrange_relaxed
                       t2 (Obj.magic option_map relax_zrange r0))), typedefs)))))
               | Coq3_Compilers.Coq_bool -> (fun _ _ -> None)
               | Coq3_Compilers.Coq_nat -> (fun _ _ -> None)
               | Coq3_Compilers.Coq_zrange -> (fun _ _ -> None)
               | Coq3_Compilers.Coq_string -> (fun _ _ -> None))
            | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
              (fun pat ->
                let (ra, rb) = Obj.magic pat in
                (fun pat0 ->
                let (typedefsa, typedefsb) = Obj.magic pat0 in
                bind
                  (base_var_data_of_bounds_and_typedefs0 a is_ptr count
                    make_name ra typedefsa) (fun va ->
                  let (count0, va0) = va in
                  bind
                    (base_var_data_of_bounds_and_typedefs0 b is_ptr count0
                      make_name rb typedefsb) (fun vb ->
                    let (count1, vb0) = vb in
                    Some (count1, (Obj.magic (va0, vb0)))))))
            | Compilers.Coq_base.Coq_type.Coq_list a ->
              (match a with
               | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
                 (match t1 with
                  | Coq3_Compilers.Z ->
                    let t2 = Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)
                    in
                    (fun r0 typedefs ->
                    bind (Obj.magic r0) (fun ls ->
                      bind (make_name count) (fun n3 -> Some
                        ((Coq_Pos.succ count),
                        (Obj.magic (((n3,
                          (Coq7_Compilers.ToString.Coq_int.Coq_option.Coq_interp.to_union
                            t2
                            (Coq7_Compilers.ToString.Coq_int.Coq_option.Coq_interp.of_zrange_relaxed
                              t2
                              (Obj.magic (Some
                                (map (option_map relax_zrange) ls)))))),
                          (length ls)), typedefs))))))
                  | Coq3_Compilers.Coq_bool -> (fun _ _ -> None)
                  | Coq3_Compilers.Coq_nat -> (fun _ _ -> None)
                  | Coq3_Compilers.Coq_zrange -> (fun _ _ -> None)
                  | Coq3_Compilers.Coq_string -> (fun _ _ -> None))
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun _ _ -> None)
               | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> None)
               | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> None)
               | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> None))
            | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> None)
            | Compilers.Coq_base.Coq_type.Coq_unit ->
              (fun _ _ -> Some (count, (Obj.magic ())))
          in base_var_data_of_bounds_and_typedefs0

        (** val var_data_of_bounds_and_typedefs :
            Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> bool -> positive -> (positive -> char list option) ->
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data ->
            (positive * Coq7_Compilers.ToString.OfPHOAS.var_data) option **)

        let var_data_of_bounds_and_typedefs relax_zrange t0 is_ptr count make_name =
          match t0 with
          | Compilers.Coq_type.Coq_base t1 ->
            base_var_data_of_bounds_and_typedefs relax_zrange t1 is_ptr count
              make_name
          | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ _ -> None)

        (** val expr_of_PHOAS'_cps :
            Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr -> (positive -> char list option) ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow -> positive ->
            ((positive * ((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr)) -> ('a1, char list list) sum) -> ('a1,
            char list list) sum **)

        let expr_of_PHOAS'_cps relax_zrange t0 e make_in_name inbounds intypedefs count x =
          let rec expr_of_PHOAS'_cps0 t1 e0 make_in_name0 inbounds0 intypedefs0 count0 _ =
            let x0 = fun _ ->
              Coq7_Compilers.ToString.PHOAS.Coq_expr.partially_show_expr
            in
            (match t1 with
             | Compilers.Coq_type.Coq_base _ ->
               (fun e1 pat ->
                 let () = Obj.magic pat in
                 (fun pat0 ->
                 let () = Obj.magic pat0 in
                 (fun k -> Obj.magic k (count0, ((), e1)))))
             | Compilers.Coq_type.Coq_arrow (s0, d) ->
               (fun e1 pat ->
                 let (inbound, inbounds1) = Obj.magic pat in
                 (fun pat0 ->
                 let (intypedef, intypedefs1) = Obj.magic pat0 in
                 (fun k ->
                 match var_data_of_bounds_and_typedefs relax_zrange s0 false
                         count0 make_in_name0 inbound intypedef with
                 | Some p ->
                   let (count1, vs) = p in
                   (match Compilers.Coq_invert_expr.invert_Abs s0 d e1 with
                    | Some f ->
                      expr_of_PHOAS'_cps0 d (f vs) make_in_name0 inbounds1
                        intypedefs1 count1 __ (fun pat1 ->
                        let (count2, p0) = pat1 in
                        let (vss, rv) = p0 in
                        Obj.magic k (count2, ((vs, vss), rv)))
                    | None ->
                      Inr
                        ((append
                           ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('n'::('o'::('n'::('-'::('\206'::('\187'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::('o'::('f'::(' '::('a'::('r'::('r'::('o'::('w'::(' '::('t'::('y'::('p'::('e'::(' '::('('::[])))))))))))))))))))))))))))))))))))))))))
                           (append
                             (show0
                               (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                                 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                               t1)
                             (append (')'::(':'::(' '::[])))
                               (show0
                                 (x0 __ (Compilers.Coq_type.Coq_arrow (s0,
                                   d))) e1)))) :: []))
                 | None ->
                   Inr
                     ((append
                        ('U'::('n'::('a'::('b'::('l'::('e'::(' '::('t'::('o'::(' '::('b'::('i'::('n'::('d'::(' '::('n'::('a'::('m'::('e'::('s'::(' '::('f'::('o'::('r'::(' '::('a'::('l'::('l'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(' '::('a'::('n'::('d'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('a'::('t'::(' '::('t'::('y'::('p'::('e'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                        (show0
                          (Coq7_Compilers.ToString.PHOAS.Coq_type.show
                            Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show)
                          s0)) :: []))))) e0 inbounds0 intypedefs0
          in expr_of_PHOAS'_cps0 t0 e make_in_name inbounds intypedefs count
               __ x

        (** val expr_of_PHOAS'_cont :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            consider_retargs_live_opt -> rename_dead_opt ->
            lift_declarations_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
            -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (positive -> char list option) ->
            Coq7_Compilers.ToString.OfPHOAS.var_data -> (positive ->
            positive) -> (positive * ((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr)) -> (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
            char list list) sum **)

        let expr_of_PHOAS'_cont lang_casts relax_zrange consider_retargs_live rename_dead lift_declarations0 language_specific_cast_adjustment relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check t0 make_name out_data in_to_body_count = function
        | (count, p) ->
          let (d, e) = p in
          (match expr_of_base_PHOAS lang_casts relax_zrange
                   language_specific_cast_adjustment
                   relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check
                   (Coq5_Compilers.Coercions.base
                     (Compilers.Coq_type.final_codomain t0)) e
                   (in_to_body_count count) make_name out_data with
           | Inl rv ->
             let rv0 =
               Coq_name_infos.adjust_dead consider_retargs_live rename_dead rv
             in
             let rv1 =
               if lift_declarations0
               then LiftDeclare.lift_declarations rv0
               else rv0
             in
             Inl ((d, out_data), rv1)
           | Inr err0 -> Inr err0)

        (** val expr_of_PHOAS_cont :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            consider_retargs_live_opt -> rename_dead_opt ->
            lift_declarations_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
            -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (positive -> char list option) -> (positive -> positive) ->
            (positive * (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr)) -> (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
            char list list) sum **)

        let expr_of_PHOAS_cont lang_casts relax_zrange consider_retargs_live rename_dead lift_declarations0 language_specific_cast_adjustment relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check t0 make_name in_to_body_count = function
        | (count, p) ->
          let (p0, e) = p in
          let (din, dout) = p0 in
          expr_of_PHOAS'_cont lang_casts relax_zrange consider_retargs_live
            rename_dead lift_declarations0 language_specific_cast_adjustment
            relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check t0
            make_name dout in_to_body_count (count, (din, e))

        (** val expr_of_PHOAS_cps :
            Coq7_Compilers.Options.relax_zrange_opt -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident, Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr -> (positive -> char list option) ->
            (positive -> char list option) -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data -> positive ->
            (positive -> positive) -> ((positive * (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr)) -> ('a1, char list list) sum) -> ('a1,
            char list list) sum **)

        let expr_of_PHOAS_cps relax_zrange t0 e make_in_name make_out_name inbounds outbounds intypedefs outtypedefs count out_to_in_count k =
          match var_data_of_bounds_and_typedefs relax_zrange
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_type.final_codomain t0)) true count
                  make_out_name outbounds outtypedefs with
          | Some vd ->
            let (count0, dout) = vd in
            let count1 = out_to_in_count count0 in
            expr_of_PHOAS'_cps relax_zrange t0 e make_in_name inbounds
              intypedefs count1 (fun pat ->
              let (count2, p) = pat in
              let (din, e0) = p in k (count2, ((din, dout), e0)))
          | None ->
            Inr
              ((append
                 ('U'::('n'::('a'::('b'::('l'::('e'::(' '::('t'::('o'::(' '::('b'::('i'::('n'::('d'::(' '::('n'::('a'::('m'::('e'::('s'::(' '::('f'::('o'::('r'::(' '::('a'::('l'::('l'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(' '::('a'::('n'::('d'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('a'::('t'::(' '::('t'::('y'::('p'::('e'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show
                   (Compilers.Coq_type.final_codomain t0))) :: [])

        (** val coq_ExprOfPHOAS_cont :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            consider_retargs_live_opt -> rename_dead_opt ->
            lift_declarations_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
            -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> char list list option -> (positive * (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr)) -> (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
            char list list) sum **)

        let coq_ExprOfPHOAS_cont lang_casts relax_zrange consider_retargs_live rename_dead lift_declarations0 language_specific_cast_adjustment =
          let make_name_gen = fun name_list prefix1 ->
            match name_list with
            | Some ls -> (fun p -> nth_error ls (pred (Coq_Pos.to_nat p)))
            | None ->
              (fun p -> Some (append prefix1 (Coq0_Z.to_string (Zpos p))))
          in
          let make_name = fun name_list -> make_name_gen name_list ('x'::[])
          in
          let reset_if_names_given = fun name_list ->
            match name_list with
            | Some _ -> (fun p -> p)
            | None -> (fun _ -> XH)
          in
          (fun relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check t0 name_list ->
          expr_of_PHOAS_cont lang_casts relax_zrange consider_retargs_live
            rename_dead lift_declarations0 language_specific_cast_adjustment
            relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check t0
            (make_name name_list) (reset_if_names_given name_list))

        (** val coq_ExprOfPHOAS_with_opt_outbounds_cps :
            Coq7_Compilers.Options.relax_zrange_opt ->
            Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
            Compilers.Coq_expr.coq_Expr -> char list list option ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp option
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
            ((positive * (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr)) -> ('a1, char list list) sum) -> ('a1,
            char list list) sum **)

        let coq_ExprOfPHOAS_with_opt_outbounds_cps relax_zrange absint_opts0 t0 e name_list inbounds outbounds intypedefs outtypedefs k =
          let make_name_gen = fun name_list0 prefix1 ->
            match name_list0 with
            | Some ls -> (fun p -> nth_error ls (pred (Coq_Pos.to_nat p)))
            | None ->
              (fun p -> Some (append prefix1 (Coq0_Z.to_string (Zpos p))))
          in
          let make_in_name = fun name_list0 ->
            make_name_gen name_list0 ('a'::('r'::('g'::[])))
          in
          let make_out_name = fun name_list0 ->
            make_name_gen name_list0 ('o'::('u'::('t'::[])))
          in
          let reset_if_names_given = fun name_list0 ->
            match name_list0 with
            | Some _ -> (fun p -> p)
            | None -> (fun _ -> XH)
          in
          let outbounds0 =
            sequence_return0 outbounds
              (Coq8_Compilers.Coq_partial.coq_Extract absint_opts0 true t0 e
                inbounds)
          in
          expr_of_PHOAS_cps relax_zrange t0 (e __) (make_in_name name_list)
            (make_out_name name_list) inbounds outbounds0 intypedefs
            outtypedefs XH (reset_if_names_given name_list) k

        (** val coq_ExprOfPHOAS_cps :
            Coq7_Compilers.Options.relax_zrange_opt ->
            Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
            Compilers.Coq_expr.coq_Expr -> char list list option ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
            ((positive * (((Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_expr.expr)) -> ('a1, char list list) sum) -> ('a1,
            char list list) sum **)

        let coq_ExprOfPHOAS_cps relax_zrange absint_opts0 t0 e name_list inbounds intypedefs outtypedefs k =
          coq_ExprOfPHOAS_with_opt_outbounds_cps relax_zrange absint_opts0 t0
            e name_list inbounds None intypedefs outtypedefs k

        (** val var_data_of_PHOAS_bounds :
            Coq7_Compilers.Options.relax_zrange_opt ->
            Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
            -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
            Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
            Compilers.Coq_expr.coq_Expr -> char list list option ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
            (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
            ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data,
            char list list) sum **)

        let var_data_of_PHOAS_bounds relax_zrange absint_opts0 t0 e name_list inbounds outbounds intypedefs outtypedefs =
          coq_ExprOfPHOAS_with_opt_outbounds_cps relax_zrange absint_opts0 t0
            e name_list inbounds (Some outbounds) intypedefs outtypedefs
            (fun pat ->
            let (_, p) = pat in
            let (p0, _) = p in let (din, dout) = p0 in Inl (din, dout))

        (** val coq_ExprOfPHOAS :
            coq_LanguageCasts -> Coq7_Compilers.Options.relax_zrange_opt ->
            consider_retargs_live_opt -> rename_dead_opt ->
            lift_declarations_opt ->
            Coq7_Compilers.Options.language_specific_cast_adjustment_opt ->
            Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
            ->
            Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt
            -> bool -> Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type
            -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr -> char list
            list option -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
            Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
            Compilers.Coq_type.for_each_lhs_of_arrow ->
            Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data ->
            (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
            Coq7_Compilers.ToString.OfPHOAS.var_data)
            Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * expr,
            char list list) sum **)

        let coq_ExprOfPHOAS lang_casts relax_zrange consider_retargs_live rename_dead lift_declarations0 language_specific_cast_adjustment absint_opts0 relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check t0 e name_list inbounds intypedefs outtypedefs =
          coq_ExprOfPHOAS_cps relax_zrange absint_opts0 t0 e name_list
            inbounds intypedefs outtypedefs
            (coq_ExprOfPHOAS_cont lang_casts relax_zrange
              consider_retargs_live rename_dead lift_declarations0
              language_specific_cast_adjustment
              relax_adc_sbb_return_carry_to_bitwidth0 do_bounds_check t0
              name_list)
       end
     end
   end
 end

module Coq25_Compilers =
 struct
  module ToString =
   struct
    module C =
     struct
      (** val comment_block : char list list -> char list list **)

      let comment_block =
        map (fun line0 ->
          append ('/'::('*'::(' '::[])))
            (append line0 (' '::('*'::('/'::[])))))

      (** val coq_FIAT_INLINE : char list -> char list **)

      let coq_FIAT_INLINE prefix1 =
        append (to_upper0 prefix1)
          ('F'::('I'::('A'::('T'::('_'::('I'::('N'::('L'::('I'::('N'::('E'::[])))))))))))

      module String =
       struct
        (** val stdint_bitwidths : z list **)

        let stdint_bitwidths =
          (Zpos (XO (XO (XO XH)))) :: ((Zpos (XO (XO (XO (XO
            XH))))) :: ((Zpos (XO (XO (XO (XO (XO XH)))))) :: ((Zpos (XO (XO
            (XO (XO (XO (XO XH))))))) :: [])))

        module Coq_int =
         struct
          module Coq_type =
           struct
            (** val to_string_opt_typedef :
                Coq7_Compilers.Options.language_naming_conventions_opt ->
                Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
                Coq7_Compilers.ToString.Coq_int.coq_type -> char list option
                -> char list **)

            let to_string_opt_typedef language_naming_conventions0 skip_typedefs0 prefix1 t0 typedef0 =
              Coq7_Compilers.ToString.Coq_int.to_string_gen_opt_typedef
                language_naming_conventions0 skip_typedefs0 stdint_bitwidths
                ('u'::('i'::('n'::('t'::[])))) ('i'::('n'::('t'::[])))
                ('_'::('t'::[])) [] false false prefix1 t0 typedef0

            (** val to_string :
                Coq7_Compilers.Options.language_naming_conventions_opt ->
                char list -> Coq7_Compilers.ToString.Coq_int.coq_type ->
                char list **)

            let to_string language_naming_conventions0 prefix1 t0 =
              to_string_opt_typedef language_naming_conventions0 true prefix1
                t0 None

            (** val to_literal_macro_string :
                Coq7_Compilers.ToString.Coq_int.coq_type -> char list option **)

            let to_literal_macro_string t0 =
              if Coq_Z.ltb (Coq7_Compilers.ToString.Coq_int.bitwidth_of t0)
                   (Zpos (XO (XO (XO XH))))
              then None
              else Some
                     (append
                       (if Coq7_Compilers.ToString.Coq_int.is_unsigned t0
                        then 'U'::[]
                        else [])
                       (append ('I'::('N'::('T'::[])))
                         (append
                           (Coq0_Z.to_string
                             (Coq7_Compilers.ToString.Coq_int.bitwidth_of t0))
                           ('_'::('C'::[])))))
           end
         end

        module Coq_type =
         struct
          module Coq_primitive =
           struct
            (** val to_string_opt_typedef :
                Coq7_Compilers.Options.language_naming_conventions_opt ->
                Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
                Coq24_Compilers.ToString.IR.Coq_type.primitive ->
                Coq7_Compilers.ToString.Coq_int.coq_type option -> char list
                option -> char list **)

            let to_string_opt_typedef language_naming_conventions0 skip_typedefs0 prefix1 t0 r0 typedef0 =
              append
                (match r0 with
                 | Some int_t ->
                   Coq_int.Coq_type.to_string_opt_typedef
                     language_naming_conventions0 skip_typedefs0 prefix1
                     int_t typedef0
                 | None -> '\226'::('\132'::('\164'::[])))
                (match t0 with
                 | Coq24_Compilers.ToString.IR.Coq_type.Z -> []
                 | Coq24_Compilers.ToString.IR.Coq_type.Zptr -> '*'::[])

            (** val to_string :
                Coq7_Compilers.Options.language_naming_conventions_opt ->
                char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive
                -> Coq7_Compilers.ToString.Coq_int.coq_type option ->
                char list **)

            let to_string language_naming_conventions0 prefix1 t0 r0 =
              to_string_opt_typedef language_naming_conventions0 true prefix1
                t0 r0 None
           end
         end

        (** val value_barrier_name :
            Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
            char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list **)

        let value_barrier_name language_naming_conventions0 static0 prefix1 ty =
          Coq7_Compilers.ToString.format_special_function_name_ty
            language_naming_conventions0 static0 prefix1
            ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))
            ty

        (** val value_barrier_func :
            Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
            char list -> Coq7_Compilers.ToString.Coq_int.coq_type ->
            char list list **)

        let value_barrier_func language_naming_conventions0 static0 prefix1 ty =
          [] :: ((append
                   ('#'::('i'::('f'::(' '::('!'::('d'::('e'::('f'::('i'::('n'::('e'::('d'::('('::[])))))))))))))
                   (append (to_upper0 prefix1)
                     ('N'::('O'::('_'::('A'::('S'::('M'::(')'::(' '::('&'::('&'::(' '::('('::('d'::('e'::('f'::('i'::('n'::('e'::('d'::('('::('_'::('_'::('G'::('N'::('U'::('C'::('_'::('_'::(')'::(' '::('|'::('|'::(' '::('d'::('e'::('f'::('i'::('n'::('e'::('d'::('('::('_'::('_'::('c'::('l'::('a'::('n'::('g'::('_'::('_'::(')'::(')'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
            (append
              (if static0
               then 's'::('t'::('a'::('t'::('i'::('c'::(' '::[]))))))
               else [])
              (append
                ('_'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::('_'::('_'::(' '::[])))))))))))
                (append
                  (Coq_int.Coq_type.to_string language_naming_conventions0
                    prefix1 ty)
                  (append (' '::[])
                    (append
                      (value_barrier_name language_naming_conventions0
                        static0 prefix1 ty)
                      (append ('('::[])
                        (append
                          (Coq_int.Coq_type.to_string
                            language_naming_conventions0 prefix1 ty)
                          (' '::('a'::(')'::(' '::('{'::[])))))))))))) :: ((' '::(' '::('_'::('_'::('a'::('s'::('m'::('_'::('_'::('('::('"'::('"'::(' '::(':'::(' '::('"'::('+'::('r'::('"'::('('::('a'::(')'::(' '::(':'::(' '::('/'::('*'::(' '::('n'::('o'::(' '::('i'::('n'::('p'::('u'::('t'::('s'::(' '::('*'::('/'::(')'::(';'::[])))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('a'::(';'::[]))))))))))) :: (('}'::[]) :: (('#'::('e'::('l'::('s'::('e'::[]))))) :: (
            (append
              ('#'::(' '::(' '::('d'::('e'::('f'::('i'::('n'::('e'::(' '::[]))))))))))
              (append
                (value_barrier_name language_naming_conventions0 static0
                  prefix1 ty)
                ('('::('x'::(')'::(' '::('('::('x'::(')'::[]))))))))) :: (('#'::('e'::('n'::('d'::('i'::('f'::[])))))) :: []))))))))

        (** val make_typedef :
            Coq7_Compilers.Options.language_naming_conventions_opt ->
            Coq7_Compilers.Options.documentation_options_opt -> char list ->
            (((char list * (char list ->
            char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
            option) * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT)
            -> char list list **)

        let make_typedef language_naming_conventions0 documentation_options0 prefix1 typedef0 =
          let (p, description0) =
            Coq7_Compilers.ToString.name_and_type_and_describe_typedef
              language_naming_conventions0 documentation_options0 prefix1
              false typedef0
          in
          let (name0, p0) = p in
          let (ty, array_len) = p0 in
          app (comment_block description0)
            (match array_len with
             | Some o ->
               (match o with
                | Some len ->
                  (append
                    ('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::[]))))))))
                    (append
                      (Coq_type.Coq_primitive.to_string
                        language_naming_conventions0 prefix1
                        Coq24_Compilers.ToString.IR.Coq_type.Z ty)
                      (append (' '::[])
                        (append name0
                          (append ('['::[])
                            (append (Coq0_Z.to_string (Coq_Z.of_nat len))
                              (']'::(';'::[])))))))) :: []
                | None ->
                  (append
                    ('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::[]))))))))
                    (append
                      (Coq_type.Coq_primitive.to_string
                        language_naming_conventions0 prefix1
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr ty)
                      (append (' '::[]) (append name0 (';'::[]))))) :: [])
             | None ->
               (append
                 ('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::[]))))))))
                 (append
                   (Coq_type.Coq_primitive.to_string
                     language_naming_conventions0 prefix1
                     Coq24_Compilers.ToString.IR.Coq_type.Z ty)
                   (append (' '::[]) (append name0 (';'::[]))))) :: [])

        (** val header :
            Coq7_Compilers.Options.language_naming_conventions_opt ->
            Coq7_Compilers.Options.documentation_options_opt ->
            Coq7_Compilers.Options.package_name_opt ->
            Coq7_Compilers.Options.class_name_opt ->
            Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
            char list -> Coq7_Compilers.ToString.ident_infos ->
            (((char list * (char list ->
            char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
            option) * (Coq3_Compilers.base
            Compilers.Coq_base.Coq_type.coq_type,
            Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT)
            list -> char list list **)

        let header language_naming_conventions0 documentation_options0 _ _ output_options0 _ internal_static0 _ prefix1 infos typedef_map =
          let bitwidths_used0 = infos.Coq7_Compilers.ToString.bitwidths_used
          in
          let value_barrier_bitwidths0 =
            infos.Coq7_Compilers.ToString.value_barrier_bitwidths
          in
          let fIAT_EXTENSION =
            append (to_upper0 prefix1)
              ('F'::('I'::('A'::('T'::('_'::('E'::('X'::('T'::('E'::('N'::('S'::('I'::('O'::('N'::[]))))))))))))))
          in
          app
            ([] :: (('#'::('i'::('n'::('c'::('l'::('u'::('d'::('e'::(' '::('<'::('s'::('t'::('d'::('i'::('n'::('t'::('.'::('h'::('>'::[]))))))))))))))))))) :: []))
            (app
              (if (||)
                    (Coq7_Compilers.ToString.IntSet.mem
                      (Coq7_Compilers.ToString.Coq_int.Coq_unsigned O)
                      bitwidths_used0)
                    (Coq7_Compilers.ToString.IntSet.mem
                      (Coq7_Compilers.ToString.Coq_int.signed_counterpart_of
                        (Coq7_Compilers.ToString.Coq_int.Coq_unsigned O))
                      bitwidths_used0)
               then (append
                      ('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::('u'::('n'::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('c'::('h'::('a'::('r'::(' '::[]))))))))))))))))))))))
                      (append
                        (Coq_int.Coq_type.to_string
                          language_naming_conventions0 prefix1
                          (Coq7_Compilers.ToString.Coq_int.Coq_unsigned O))
                        (';'::[]))) :: ((append
                                          ('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('c'::('h'::('a'::('r'::(' '::[]))))))))))))))))))))
                                          (append
                                            (Coq_int.Coq_type.to_string
                                              language_naming_conventions0
                                              prefix1
                                              (Coq7_Compilers.ToString.Coq_int.signed_counterpart_of
                                                (Coq7_Compilers.ToString.Coq_int.Coq_unsigned
                                                O))) (';'::[]))) :: [])
               else [])
              (app
                (let gnuc_defines =
                   app
                     (if (||)
                           (Coq7_Compilers.ToString.IntSet.mem
                             (Coq7_Compilers.ToString.Coq_int.Coq_unsigned (S
                             (S (S (S (S (S (S O)))))))) bitwidths_used0)
                           (Coq7_Compilers.ToString.IntSet.mem
                             (Coq7_Compilers.ToString.Coq_int.Coq_signed (S
                             (S (S (S (S (S (S O)))))))) bitwidths_used0)
                      then (fIAT_EXTENSION,
                             ('_'::('_'::('e'::('x'::('t'::('e'::('n'::('s'::('i'::('o'::('n'::('_'::('_'::[])))))))))))))) :: []
                      else []) (((coq_FIAT_INLINE prefix1),
                     ('_'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::('_'::('_'::[]))))))))))) :: [])
                 in
                 app
                   (('#'::('i'::('f'::(' '::('d'::('e'::('f'::('i'::('n'::('e'::('d'::('('::('_'::('_'::('G'::('N'::('U'::('C'::('_'::('_'::(')'::(' '::('|'::('|'::(' '::('d'::('e'::('f'::('i'::('n'::('e'::('d'::('('::('_'::('_'::('c'::('l'::('a'::('n'::('g'::('_'::('_'::(')'::[]))))))))))))))))))))))))))))))))))))))))))) :: [])
                   (app
                     (map (fun pat ->
                       let (mACRO, primitive0) = pat in
                       append
                         ('#'::(' '::(' '::('d'::('e'::('f'::('i'::('n'::('e'::(' '::[]))))))))))
                         (append mACRO (append (' '::[]) primitive0)))
                       gnuc_defines)
                     (app (('#'::('e'::('l'::('s'::('e'::[]))))) :: [])
                       (app
                         (map (fun pat ->
                           let (mACRO, _) = pat in
                           append
                             ('#'::(' '::(' '::('d'::('e'::('f'::('i'::('n'::('e'::(' '::[]))))))))))
                             mACRO) gnuc_defines)
                         (('#'::('e'::('n'::('d'::('i'::('f'::[])))))) :: [])))))
                (app
                  (if (||)
                        (Coq7_Compilers.ToString.IntSet.mem
                          (Coq7_Compilers.ToString.Coq_int.Coq_unsigned (S (S
                          (S (S (S (S (S O)))))))) bitwidths_used0)
                        (Coq7_Compilers.ToString.IntSet.mem
                          (Coq7_Compilers.ToString.Coq_int.Coq_signed (S (S
                          (S (S (S (S (S O)))))))) bitwidths_used0)
                   then [] :: ((append fIAT_EXTENSION
                                 (append
                                   (' '::('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('_'::('_'::('i'::('n'::('t'::('1'::('2'::('8'::(' '::[])))))))))))))))))))))))))
                                   (append
                                     (Coq_int.Coq_type.to_string
                                       language_naming_conventions0 prefix1
                                       (Coq7_Compilers.ToString.Coq_int.Coq_signed
                                       (S (S (S (S (S (S (S O)))))))))
                                     (';'::[])))) :: ((append fIAT_EXTENSION
                                                        (append
                                                          (' '::('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::('u'::('n'::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('_'::('_'::('i'::('n'::('t'::('1'::('2'::('8'::(' '::[])))))))))))))))))))))))))))
                                                          (append
                                                            (Coq_int.Coq_type.to_string
                                                              language_naming_conventions0
                                                              prefix1
                                                              (Coq7_Compilers.ToString.Coq_int.Coq_unsigned
                                                              (S (S (S (S (S
                                                              (S (S O)))))))))
                                                            (';'::[])))) :: []))
                   else [])
                  (app
                    (if Coq7_Compilers.Options.skip_typedefs
                          output_options0.Coq7_Compilers.Options.skip_typedefs_
                     then []
                     else flat_map (fun td_name ->
                            match find (fun pat ->
                                    let (y, _) = pat in
                                    let (y1, _) = y in
                                    let (name0, _) = y1 in eqb0 td_name name0)
                                    typedef_map with
                            | Some td_info ->
                              app ([] :: [])
                                (make_typedef language_naming_conventions0
                                  documentation_options0 prefix1 td_info)
                            | None ->
                              (append
                                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('f'::('i'::('n'::('d'::(' '::('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::('i'::('n'::('f'::('o'::(' '::('f'::('o'::('r'::(' '::('\''::[])))))))))))))))))))))))))))))))))))))))))
                                (append td_name ('\''::('"'::(';'::[]))))) :: [])
                            infos.Coq7_Compilers.ToString.typedefs_used)
                    (app
                      ([] :: (('#'::('i'::('f'::(' '::('('::('-'::('1'::(' '::('&'::(' '::('3'::(')'::(' '::('!'::('='::(' '::('3'::[]))))))))))))))))) :: (('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('T'::('h'::('i'::('s'::(' '::('c'::('o'::('d'::('e'::(' '::('o'::('n'::('l'::('y'::(' '::('w'::('o'::('r'::('k'::('s'::(' '::('o'::('n'::(' '::('a'::(' '::('t'::('w'::('o'::('\''::('s'::(' '::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('s'::('y'::('s'::('t'::('e'::('m'::('"'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (('#'::('e'::('n'::('d'::('i'::('f'::[])))))) :: []))))
                      (app
                        (flat_map
                          (value_barrier_func language_naming_conventions0
                            internal_static0 prefix1)
                          (Coq7_Compilers.ToString.IntSet.elements
                            value_barrier_bitwidths0)) ([] :: [])))))))
       end

      module Coq_primitive =
       struct
        (** val to_string :
            char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z
            -> char list **)

        let to_string _ t0 v =
          match t0 with
          | Coq24_Compilers.ToString.IR.Coq_type.Z ->
            (match String.Coq_int.Coq_type.to_literal_macro_string
                     (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed
                       { lower = v; upper = v }) with
             | Some macro ->
               append macro (append ('('::[]) (append (of_Z v) (')'::[])))
             | None -> of_Z v)
          | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
            append
              ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('a'::('d'::('d'::('r'::('e'::('s'::('s'::(' '::[]))))))))))))))))))))))))
              (append (of_Z v) ('"'::(';'::[])))
       end

      (** val arith_to_string :
          Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
          char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
          Coq24_Compilers.ToString.IR.arith_expr -> char list **)

      let rec arith_to_string language_naming_conventions0 internal_static0 prefix1 _ e =
        let special_name_ty = fun name0 ty ->
          Coq7_Compilers.ToString.format_special_function_name_ty
            language_naming_conventions0 internal_static0 prefix1 name0 ty
        in
        let special_name = fun name0 bw ->
          Coq7_Compilers.ToString.format_special_function_name
            language_naming_conventions0 internal_static0 prefix1 name0 false
            bw
        in
        (match e with
         | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc, e0) ->
           (match idc with
            | Coq24_Compilers.ToString.IR.Coq_literal v ->
              (fun _ ->
                Coq_primitive.to_string prefix1
                  Coq24_Compilers.ToString.IR.Coq_type.Z v)
            | Coq24_Compilers.ToString.IR.List_nth n3 ->
              (fun e1 ->
                match e1 with
                | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                | Coq24_Compilers.ToString.IR.Var (_, v) ->
                  append ('('::[])
                    (append v
                      (append ('['::[])
                        (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
                          (']'::(')'::[])))))
                | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                | Coq24_Compilers.ToString.IR.TT ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
            | Coq24_Compilers.ToString.IR.Addr ->
              (fun e1 ->
                match e1 with
                | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                | Coq24_Compilers.ToString.IR.Var (_, v) -> append ('&'::[]) v
                | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                | Coq24_Compilers.ToString.IR.TT ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
            | Coq24_Compilers.ToString.IR.Dereference ->
              (fun e1 ->
                append ('('::(' '::('*'::[])))
                  (append
                    (arith_to_string language_naming_conventions0
                      internal_static0 prefix1
                      (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                      Coq24_Compilers.ToString.IR.Coq_type.Zptr) e1)
                    (' '::(')'::[]))))
            | Coq24_Compilers.ToString.IR.Coq_iunop op1 ->
              (match op1 with
               | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
                 (fun e1 ->
                   append ('('::[])
                     (append
                       (arith_to_string language_naming_conventions0
                         internal_static0 prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                       (append (' '::('>'::('>'::(' '::[]))))
                         (append (Coq0_Z.to_string offset) (')'::[])))))
               | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
                 (fun e1 ->
                   append ('('::[])
                     (append
                       (arith_to_string language_naming_conventions0
                         internal_static0 prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                       (append (' '::('<'::('<'::(' '::[]))))
                         (append (Coq0_Z.to_string offset) (')'::[])))))
               | Coq24_Compilers.ToString.IR.Z_lnot _ ->
                 (fun e1 ->
                   append ('('::('~'::[]))
                     (append
                       (arith_to_string language_naming_conventions0
                         internal_static0 prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                       (')'::[])))
               | Coq24_Compilers.ToString.IR.Z_bneg ->
                 (fun e1 ->
                   append ('('::('!'::[]))
                     (append
                       (arith_to_string language_naming_conventions0
                         internal_static0 prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                       (')'::[])))
               | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
                 (fun e1 ->
                   append
                     (String.value_barrier_name language_naming_conventions0
                       internal_static0 prefix1 ty)
                     (append ('('::[])
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_static0 prefix1
                           (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                           Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                         (')'::[])))))
            | Coq24_Compilers.ToString.IR.Coq_ibinop op1 ->
              (match op1 with
               | Coq24_Compilers.ToString.IR.Z_land ->
                 (fun e1 ->
                   match e1 with
                   | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Var (_, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                     append ('('::[])
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_static0 prefix1 a e2)
                         (append (' '::('&'::(' '::[])))
                           (append
                             (arith_to_string language_naming_conventions0
                               internal_static0 prefix1 b e3) (')'::[]))))
                   | Coq24_Compilers.ToString.IR.TT ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
               | Coq24_Compilers.ToString.IR.Z_lor ->
                 (fun e1 ->
                   match e1 with
                   | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Var (_, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                     append ('('::[])
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_static0 prefix1 a e2)
                         (append (' '::('|'::(' '::[])))
                           (append
                             (arith_to_string language_naming_conventions0
                               internal_static0 prefix1 b e3) (')'::[]))))
                   | Coq24_Compilers.ToString.IR.TT ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
               | Coq24_Compilers.ToString.IR.Z_lxor ->
                 (fun e1 ->
                   match e1 with
                   | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Var (_, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                     append ('('::[])
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_static0 prefix1 a e2)
                         (append (' '::('^'::(' '::[])))
                           (append
                             (arith_to_string language_naming_conventions0
                               internal_static0 prefix1 b e3) (')'::[]))))
                   | Coq24_Compilers.ToString.IR.TT ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
               | Coq24_Compilers.ToString.IR.Z_add ->
                 (fun e1 ->
                   match e1 with
                   | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Var (_, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                     append ('('::[])
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_static0 prefix1 a x1)
                         (append (' '::('+'::(' '::[])))
                           (append
                             (arith_to_string language_naming_conventions0
                               internal_static0 prefix1 b x2) (')'::[]))))
                   | Coq24_Compilers.ToString.IR.TT ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
               | Coq24_Compilers.ToString.IR.Z_mul ->
                 (fun e1 ->
                   match e1 with
                   | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Var (_, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                     append ('('::[])
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_static0 prefix1 a x1)
                         (append (' '::('*'::(' '::[])))
                           (append
                             (arith_to_string language_naming_conventions0
                               internal_static0 prefix1 b x2) (')'::[]))))
                   | Coq24_Compilers.ToString.IR.TT ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
               | Coq24_Compilers.ToString.IR.Z_sub ->
                 (fun e1 ->
                   match e1 with
                   | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Var (_, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                     append ('('::[])
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_static0 prefix1 a x1)
                         (append (' '::('-'::(' '::[])))
                           (append
                             (arith_to_string language_naming_conventions0
                               internal_static0 prefix1 b x2) (')'::[]))))
                   | Coq24_Compilers.ToString.IR.TT ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))))
            | Coq24_Compilers.ToString.IR.Z_mul_split lg2s ->
              (fun e1 ->
                append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                  (append ('('::[])
                    (append
                      (arith_to_string language_naming_conventions0
                        internal_static0 prefix1
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                      (')'::[]))))
            | Coq24_Compilers.ToString.IR.Z_add_with_get_carry lg2s ->
              (fun e1 ->
                append
                  (special_name
                    ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                    lg2s)
                  (append ('('::[])
                    (append
                      (arith_to_string language_naming_conventions0
                        internal_static0 prefix1
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z))),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                      (')'::[]))))
            | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow lg2s ->
              (fun e1 ->
                append
                  (special_name
                    ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                    lg2s)
                  (append ('('::[])
                    (append
                      (arith_to_string language_naming_conventions0
                        internal_static0 prefix1
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z))),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                      (')'::[]))))
            | Coq24_Compilers.ToString.IR.Z_zselect ty ->
              (fun e1 ->
                append
                  (special_name_ty
                    ('c'::('m'::('o'::('v'::('z'::('n'::('z'::[]))))))) ty)
                  (append ('('::[])
                    (append
                      (arith_to_string language_naming_conventions0
                        internal_static0 prefix1
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                        ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z))),
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                      (')'::[]))))
            | Coq24_Compilers.ToString.IR.Z_add_modulo ->
              (fun e1 ->
                match e1 with
                | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                | Coq24_Compilers.ToString.IR.Var (_, _) ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                | Coq24_Compilers.ToString.IR.Pair (_, _, a, _) ->
                  (match a with
                   | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Var (_, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
                   | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('a'::('d'::('d'::('m'::('o'::('d'::('u'::('l'::('o'::(';'::[]))))))))))))))))
                   | Coq24_Compilers.ToString.IR.TT ->
                     '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
                | Coq24_Compilers.ToString.IR.TT ->
                  '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
            | Coq24_Compilers.ToString.IR.Z_static_cast int_t ->
              (fun e1 ->
                append ('('::[])
                  (append
                    (String.Coq_type.Coq_primitive.to_string
                      language_naming_conventions0 prefix1
                      Coq24_Compilers.ToString.IR.Coq_type.Z (Some int_t))
                    (append (')'::[])
                      (arith_to_string language_naming_conventions0
                        internal_static0 prefix1
                        (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                        Coq24_Compilers.ToString.IR.Coq_type.Z) e1))))) e0
         | Coq24_Compilers.ToString.IR.Var (_, v) -> v
         | Coq24_Compilers.ToString.IR.Pair (a, b, a0, b0) ->
           append
             (arith_to_string language_naming_conventions0 internal_static0
               prefix1 a a0)
             (append (','::(' '::[]))
               (arith_to_string language_naming_conventions0 internal_static0
                 prefix1 b b0))
         | Coq24_Compilers.ToString.IR.TT ->
           '#'::('e'::('r'::('r'::('o'::('r'::(' '::('t'::('t'::(';'::[]))))))))))

      (** val stmt_to_string :
          Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
          char list -> Coq24_Compilers.ToString.IR.stmt -> char list **)

      let stmt_to_string language_naming_conventions0 internal_static0 prefix1 = function
      | Coq24_Compilers.ToString.IR.Call val0 ->
        append
          (arith_to_string language_naming_conventions0 internal_static0
            prefix1 Coq24_Compilers.ToString.IR.Coq_type.Coq_unit val0)
          (';'::[])
      | Coq24_Compilers.ToString.IR.Comment (lines0, _) ->
        concat0 (newLine::[])
          (comment_block
            (Coq7_Compilers.ToString.preprocess_comment_block lines0))
      | Coq24_Compilers.ToString.IR.Assign (declare, t0, sz, name0, val0) ->
        if declare
        then append
               (String.Coq_type.Coq_primitive.to_string
                 language_naming_conventions0 prefix1 t0 sz)
               (append (' '::[])
                 (append name0
                   (append (' '::('='::(' '::[])))
                     (append
                       (arith_to_string language_naming_conventions0
                         internal_static0 prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         t0) val0) (';'::[])))))
        else append name0
               (append (' '::('='::(' '::[])))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_static0 prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     t0) val0) (';'::[])))
      | Coq24_Compilers.ToString.IR.AssignZPtr (name0, _, val0) ->
        append ('*'::[])
          (append name0
            (append (' '::('='::(' '::[])))
              (append
                (arith_to_string language_naming_conventions0
                  internal_static0 prefix1
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (';'::[]))))
      | Coq24_Compilers.ToString.IR.DeclareVar (t0, sz, name0) ->
        append
          (String.Coq_type.Coq_primitive.to_string
            language_naming_conventions0 prefix1 t0 sz)
          (append (' '::[]) (append name0 (';'::[])))
      | Coq24_Compilers.ToString.IR.AssignNth (name0, n3, val0) ->
        append name0
          (append ('['::[])
            (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
              (append (']'::(' '::('='::(' '::[]))))
                (append
                  (arith_to_string language_naming_conventions0
                    internal_static0 prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (';'::[])))))

      (** val to_strings :
          Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
          char list -> Coq24_Compilers.ToString.IR.expr -> char list list **)

      let to_strings language_naming_conventions0 internal_static0 prefix1 e =
        map
          (stmt_to_string language_naming_conventions0 internal_static0
            prefix1) e

      (** val to_base_arg_list :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list **)

      let rec to_base_arg_list language_naming_conventions0 skip_typedefs0 prefix1 = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z ->
           (fun pat ->
             let (p, typedef0) = Obj.magic pat in
             let (p0, r0) = p in
             let (n3, _) = p0 in
             (append
               (String.Coq_type.Coq_primitive.to_string_opt_typedef
                 language_naming_conventions0 skip_typedefs0 prefix1
                 Coq24_Compilers.ToString.IR.Coq_type.Z r0 typedef0)
               (append (' '::[]) n3)) :: [])
         | Coq3_Compilers.Coq_bool ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: [])
         | Coq3_Compilers.Coq_nat ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: [])
         | Coq3_Compilers.Coq_zrange ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: [])
         | Coq3_Compilers.Coq_string ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: []))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun pat ->
          let (va, vb) = Obj.magic pat in
          app
            (to_base_arg_list language_naming_conventions0 skip_typedefs0
              prefix1 a va)
            (to_base_arg_list language_naming_conventions0 skip_typedefs0
              prefix1 b vb))
      | Compilers.Coq_base.Coq_type.Coq_list a ->
        (match a with
         | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
           (match t1 with
            | Coq3_Compilers.Z ->
              (fun pat ->
                let (p, typedef0) = Obj.magic pat in
                let (p0, len) = p in
                let (n3, r0) = p0 in
                (append ('c'::('o'::('n'::('s'::('t'::(' '::[]))))))
                  (match if skip_typedefs0 then None else typedef0 with
                   | Some typedef1 ->
                     append
                       (Coq7_Compilers.ToString.format_typedef_name
                         language_naming_conventions0 prefix1 false typedef1)
                       (append (' '::[]) n3)
                   | None ->
                     append
                       (String.Coq_type.Coq_primitive.to_string
                         language_naming_conventions0 prefix1
                         Coq24_Compilers.ToString.IR.Coq_type.Z r0)
                       (append (' '::[])
                         (append n3
                           (append ('['::[])
                             (append (Coq0_Z.to_string (Coq_Z.of_nat len))
                               (']'::[]))))))) :: [])
            | Coq3_Compilers.Coq_bool ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
            | Coq3_Compilers.Coq_nat ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
            | Coq3_Compilers.Coq_zrange ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
            | Coq3_Compilers.Coq_string ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: []))
         | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
         | Compilers.Coq_base.Coq_type.Coq_list _ ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
         | Compilers.Coq_base.Coq_type.Coq_option _ ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
         | Compilers.Coq_base.Coq_type.Coq_unit ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: []))
      | Compilers.Coq_base.Coq_type.Coq_option _ ->
        (fun _ ->
          ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::(';'::[])))))))))))))) :: [])
      | Compilers.Coq_base.Coq_type.Coq_unit ->
        (fun _ ->
          ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('u'::('n'::('i'::('t'::(';'::[])))))))))))) :: [])

      (** val to_arg_list :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list **)

      let to_arg_list language_naming_conventions0 skip_typedefs0 prefix1 = function
      | Compilers.Coq_type.Coq_base t1 ->
        to_base_arg_list language_naming_conventions0 skip_typedefs0 prefix1
          t1
      | Compilers.Coq_type.Coq_arrow (_, _) ->
        (fun _ ->
          ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('a'::('r'::('r'::('o'::('w'::(';'::[]))))))))))))) :: [])

      (** val to_arg_list_for_each_lhs_of_arrow :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow -> char list list **)

      let rec to_arg_list_for_each_lhs_of_arrow language_naming_conventions0 skip_typedefs0 prefix1 = function
      | Compilers.Coq_type.Coq_base _ -> (fun _ -> [])
      | Compilers.Coq_type.Coq_arrow (s0, d) ->
        (fun pat ->
          let (x, xs) = Obj.magic pat in
          app
            (to_arg_list language_naming_conventions0 skip_typedefs0 prefix1
              s0 x)
            (to_arg_list_for_each_lhs_of_arrow language_naming_conventions0
              skip_typedefs0 prefix1 d xs))

      (** val to_base_retarg_list :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list **)

      let rec to_base_retarg_list language_naming_conventions0 skip_typedefs0 prefix1 = function
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z ->
           (fun pat ->
             let (p, typedef0) = Obj.magic pat in
             let (p0, r0) = p in
             let (n3, _) = p0 in
             (append
               (match typedef0 with
                | Some typedef1 ->
                  append
                    (Coq7_Compilers.ToString.format_typedef_name
                      language_naming_conventions0 prefix1 false typedef1)
                    ('*'::[])
                | None ->
                  String.Coq_type.Coq_primitive.to_string
                    language_naming_conventions0 prefix1
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr r0)
               (append (' '::[]) n3)) :: [])
         | Coq3_Compilers.Coq_bool ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: [])
         | Coq3_Compilers.Coq_nat ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: [])
         | Coq3_Compilers.Coq_zrange ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: [])
         | Coq3_Compilers.Coq_string ->
           (fun _ ->
             (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
               (append
                 (show0
                   Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                   t1) (';'::[]))) :: []))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun pat ->
          let (va, vb) = Obj.magic pat in
          app
            (to_base_retarg_list language_naming_conventions0 skip_typedefs0
              prefix1 a va)
            (to_base_retarg_list language_naming_conventions0 skip_typedefs0
              prefix1 b vb))
      | Compilers.Coq_base.Coq_type.Coq_list a ->
        (match a with
         | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
           (match t1 with
            | Coq3_Compilers.Z ->
              (fun pat ->
                let (p, typedef0) = Obj.magic pat in
                let (p0, len) = p in
                let (n3, r0) = p0 in
                (match if skip_typedefs0 then None else typedef0 with
                 | Some typedef1 ->
                   append
                     (Coq7_Compilers.ToString.format_typedef_name
                       language_naming_conventions0 prefix1 false typedef1)
                     (append (' '::[]) n3)
                 | None ->
                   append
                     (String.Coq_type.Coq_primitive.to_string
                       language_naming_conventions0 prefix1
                       Coq24_Compilers.ToString.IR.Coq_type.Z r0)
                     (append (' '::[])
                       (append n3
                         (append ('['::[])
                           (append (Coq0_Z.to_string (Coq_Z.of_nat len))
                             (']'::[])))))) :: [])
            | Coq3_Compilers.Coq_bool ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
            | Coq3_Compilers.Coq_nat ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
            | Coq3_Compilers.Coq_zrange ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
            | Coq3_Compilers.Coq_string ->
              (fun _ ->
                ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: []))
         | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
         | Compilers.Coq_base.Coq_type.Coq_list _ ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
         | Compilers.Coq_base.Coq_type.Coq_option _ ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
         | Compilers.Coq_base.Coq_type.Coq_unit ->
           (fun _ ->
             ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: []))
      | Compilers.Coq_base.Coq_type.Coq_option _ ->
        (fun _ ->
          ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::(';'::[])))))))))))))) :: [])
      | Compilers.Coq_base.Coq_type.Coq_unit ->
        (fun _ ->
          ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('u'::('n'::('i'::('t'::(';'::[])))))))))))) :: [])

      (** val to_retarg_list :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.skip_typedefs_opt -> char list ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list **)

      let to_retarg_list language_naming_conventions0 skip_typedefs0 prefix1 = function
      | Compilers.Coq_type.Coq_base t1 ->
        to_base_retarg_list language_naming_conventions0 skip_typedefs0
          prefix1 t1
      | Compilers.Coq_type.Coq_arrow (_, _) ->
        (fun _ ->
          ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('a'::('r'::('r'::('o'::('w'::(';'::[]))))))))))))) :: [])

      (** val integer_promote_type :
          Coq7_Compilers.ToString.Coq_int.coq_type ->
          Coq7_Compilers.ToString.Coq_int.coq_type **)

      let integer_promote_type t0 =
        if Coq7_Compilers.ToString.Coq_int.is_tighter_than t0
             (Coq7_Compilers.ToString.Coq_int.Coq_signed (S (S (S (S (S
             O))))))
        then Coq7_Compilers.ToString.Coq_int.Coq_signed (S (S (S (S (S O)))))
        else t0

      (** val rank : Coq7_Compilers.ToString.Coq_int.coq_type -> z **)

      let rank =
        Coq7_Compilers.ToString.Coq_int.bitwidth_of

      (** val coq_C_common_type :
          Coq7_Compilers.ToString.Coq_int.coq_type ->
          Coq7_Compilers.ToString.Coq_int.coq_type ->
          Coq7_Compilers.ToString.Coq_int.coq_type **)

      let coq_C_common_type t1 t2 =
        let t3 = integer_promote_type t1 in
        let t4 = integer_promote_type t2 in
        if Coq7_Compilers.ToString.Coq_int.type_beq t3 t4
        then t3
        else if bool_beq (Coq7_Compilers.ToString.Coq_int.is_signed t3)
                  (Coq7_Compilers.ToString.Coq_int.is_signed t4)
             then if Coq_Z.geb (rank t3) (rank t4) then t3 else t4
             else if (&&) (Coq7_Compilers.ToString.Coq_int.is_unsigned t3)
                       (Coq_Z.geb (rank t3) (rank t4))
                  then t3
                  else if (&&)
                            (Coq7_Compilers.ToString.Coq_int.is_unsigned t4)
                            (Coq_Z.geb (rank t4) (rank t3))
                       then t4
                       else if (&&)
                                 (Coq7_Compilers.ToString.Coq_int.is_signed
                                   t3)
                                 (Coq7_Compilers.ToString.Coq_int.is_tighter_than
                                   t4 t3)
                            then t3
                            else if (&&)
                                      (Coq7_Compilers.ToString.Coq_int.is_signed
                                        t4)
                                      (Coq7_Compilers.ToString.Coq_int.is_tighter_than
                                        t3 t4)
                                 then t4
                                 else if Coq7_Compilers.ToString.Coq_int.is_signed
                                           t3
                                      then Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of
                                             t3
                                      else Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of
                                             t4

      (** val coq_C_bin_op_natural_output :
          Coq24_Compilers.ToString.IR.coq_Z_binop ->
          (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
          -> Coq7_Compilers.ToString.Coq_int.coq_type **)

      let coq_C_bin_op_natural_output _ = function
      | (t1, t2) -> coq_C_common_type t1 t2

      (** val coq_C_bin_op_casts :
          Coq24_Compilers.ToString.IR.coq_Z_binop ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
          -> Coq7_Compilers.ToString.Coq_int.coq_type
          option * (Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

      let coq_C_bin_op_casts _ desired_type = function
      | (t1, t2) ->
        (match desired_type with
         | Some _ ->
           let t3 = integer_promote_type t1 in
           let t4 = integer_promote_type t2 in
           let (t1o, t2o) =
             if Coq7_Compilers.ToString.Coq_int.is_tighter_than t4 t3
             then ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
                     desired_type (Some t3)), None)
             else (None,
                    (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
                      desired_type (Some t4)))
           in
           let ct =
             coq_C_common_type (sequence_return0 t1o t3)
               (sequence_return0 t2o t4)
           in
           ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
              desired_type (Some ct)), (t1o, t2o))
         | None -> (None, (None, None)))

      (** val coq_C_un_op_casts :
          Coq24_Compilers.ToString.IR.coq_Z_unop ->
          Coq7_Compilers.ToString.Coq_int.coq_type option ->
          Coq7_Compilers.ToString.Coq_int.coq_type ->
          Coq7_Compilers.ToString.Coq_int.coq_type
          option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

      let coq_C_un_op_casts idc desired_type t0 =
        let t1 = integer_promote_type t0 in
        (match idc with
         | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
           let t' =
             Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0;
               upper = (Coq_Z.pow (Zpos (XO XH)) offset) } t1
           in
           ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
              desired_type (Some t')),
           (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed (Some
             t') (Some t1)))
         | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
           let rpre_out =
             match desired_type with
             | Some rout ->
               Some
                 (Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0;
                   upper = (Coq_Z.pow (Zpos (XO XH)) offset) }
                   (Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of
                     rout))
             | None ->
               Some
                 (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower =
                   Z0; upper = (Coq_Z.pow (Zpos (XO XH)) offset) })
           in
           ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
              desired_type rpre_out),
           (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
             rpre_out (Some t1)))
         | Coq24_Compilers.ToString.IR.Z_lnot ty ->
           ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
              desired_type (Some ty)), (Some ty))
         | Coq24_Compilers.ToString.IR.Z_bneg -> (None, None)
         | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
           ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
              desired_type (Some ty)), None))

      (** val coq_CLanguageCasts :
          Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts **)

      let coq_CLanguageCasts =
        { Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_natural_output =
          coq_C_bin_op_natural_output;
          Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_casts =
          coq_C_bin_op_casts;
          Coq24_Compilers.ToString.IR.OfPHOAS.un_op_casts =
          coq_C_un_op_casts;
          Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_assignment = false;
          Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_funcall = false;
          Coq24_Compilers.ToString.IR.OfPHOAS.explicit_pointer_variables =
          false }

      (** val to_function_lines :
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> bool ->
          bool -> char list -> char list -> Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
          (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
          -> char list list **)

      let to_function_lines language_naming_conventions0 skip_typedefs0 internal_static0 static0 _ inline0 prefix1 name0 t0 = function
      | (p, body) ->
        let (args0, rets) = p in
        app
          ((append
             (if static0
              then 's'::('t'::('a'::('t'::('i'::('c'::(' '::[]))))))
              else [])
             (append
               (if inline0
                then append (coq_FIAT_INLINE prefix1) (' '::[])
                else [])
               (append ('v'::('o'::('i'::('d'::(' '::[])))))
                 (append name0
                   (append ('('::[])
                     (append
                       (concat0 (','::(' '::[]))
                         (app
                           (to_retarg_list language_naming_conventions0
                             skip_typedefs0 prefix1
                             (Compilers.Coq_type.Coq_base
                             (Compilers.Coq_type.final_codomain t0)) rets)
                           (to_arg_list_for_each_lhs_of_arrow
                             language_naming_conventions0 skip_typedefs0
                             prefix1 t0 args0))) (')'::(' '::('{'::[]))))))))) :: 
          (map (fun s0 -> append (' '::(' '::[])) s0)
            (to_strings language_naming_conventions0 internal_static0 prefix1
              body))) (('}'::[]) :: [])

      (** val consider_retargs_live_opt_instance_0 :
          Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt **)

      let consider_retargs_live_opt_instance_0 _ _ _ =
        true

      (** val rename_dead_opt_instance_0 :
          Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt **)

      let rename_dead_opt_instance_0 s0 =
        s0

      (** val lift_declarations_opt_instance_0 :
          Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt **)

      let lift_declarations_opt_instance_0 =
        true

      (** val coq_ToFunctionLines :
          Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options
          -> Coq7_Compilers.Options.relax_zrange_opt ->
          Coq7_Compilers.Options.language_naming_conventions_opt ->
          Coq7_Compilers.Options.documentation_options_opt ->
          Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
          bool -> bool -> bool -> char list -> char list ->
          Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
          Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
          Compilers.Coq_expr.coq_Expr -> ((Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) ->
          char list list option -> (Coq3_Compilers.base
          Compilers.Coq_base.Coq_type.coq_type,
          Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
          (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
          Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
          Compilers.Coq_type.for_each_lhs_of_arrow ->
          Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
          list * Coq7_Compilers.ToString.ident_infos, char list) sum **)

      let coq_ToFunctionLines absint_opts0 relax_zrange language_naming_conventions0 _ output_options0 _ do_bounds_check internal_static0 static0 all_static inline0 prefix1 name0 t0 e comment0 name_list inbounds outbounds intypedefs outtypedefs =
        match Coq24_Compilers.ToString.IR.OfPHOAS.coq_ExprOfPHOAS
                coq_CLanguageCasts relax_zrange
                consider_retargs_live_opt_instance_0
                rename_dead_opt_instance_0 lift_declarations_opt_instance_0
                output_options0.Coq7_Compilers.Options.language_specific_cast_adjustment_
                absint_opts0
                output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_
                do_bounds_check t0 e name_list inbounds intypedefs outtypedefs with
        | Inl p ->
          let (p0, f) = p in
          let (indata, outdata) = p0 in
          Inl
          ((app (('/'::('*'::[])) :: [])
             (app
               (map (fun s0 ->
                 if Nat.eqb (length0 s0) O
                 then ' '::('*'::[])
                 else append (' '::('*'::(' '::[]))) s0)
                 (comment0 indata outdata))
               (app
                 (match Coq7_Compilers.ToString.OfPHOAS.input_bounds_to_string
                          output_options0.Coq7_Compilers.Options.skip_typedefs_
                          t0 indata inbounds with
                  | [] -> []
                  | s0 :: l ->
                    app
                      ((' '::('*'::(' '::('I'::('n'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[])))))))))))))))) :: [])
                      (map (fun v ->
                        append (' '::('*'::(' '::(' '::(' '::[]))))) v)
                        (s0 :: l)))
                 (app
                   (match Coq7_Compilers.ToString.OfPHOAS.bound_to_string
                            output_options0.Coq7_Compilers.Options.skip_typedefs_
                            (Compilers.Coq_type.final_codomain t0) outdata
                            outbounds with
                    | [] -> []
                    | s0 :: l ->
                      app
                        ((' '::('*'::(' '::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[]))))))))))))))))) :: [])
                        (map (fun v ->
                          append (' '::('*'::(' '::(' '::(' '::[]))))) v)
                          (s0 :: l)))
                   (app ((' '::('*'::('/'::[]))) :: [])
                     (to_function_lines language_naming_conventions0
                       output_options0.Coq7_Compilers.Options.skip_typedefs_
                       internal_static0 static0 all_static inline0 prefix1
                       name0 t0 ((indata, outdata), f))))))),
          (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_all_infos
            output_options0.Coq7_Compilers.Options.skip_typedefs_ f t0
            intypedefs outtypedefs))
        | Inr errs ->
          (match errs with
           | [] ->
             Inr
               (append
                 ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))))))))))))))))))
                 (append name0 (' '::('t'::('o'::(' '::('C'::[])))))))
           | err0 :: l ->
             (match l with
              | [] ->
                Inr
                  (append
                    ('E'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))))))))
                    (append name0
                      (append (' '::('t'::('o'::(' '::('C'::(':'::[]))))))
                        (append (newLine::[]) err0))))
              | _ :: _ ->
                Inr
                  (append
                    ('E'::('r'::('r'::('o'::('r'::('s'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))
                    (append name0
                      (append (' '::('t'::('o'::(' '::('C'::(':'::[]))))))
                        (append (newLine::[]) (concat0 (newLine::[]) errs)))))))

      (** val coq_OutputCAPI :
          Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

      let coq_OutputCAPI =
        { Coq7_Compilers.ToString.comment_block = comment_block;
          Coq7_Compilers.ToString.comment_file_header_block = comment_block;
          Coq7_Compilers.ToString.coq_ToFunctionLines = coq_ToFunctionLines;
          Coq7_Compilers.ToString.header = String.header;
          Coq7_Compilers.ToString.footer = (fun _ _ _ _ _ _ _ _ _ -> []);
          Coq7_Compilers.ToString.strip_special_infos = (fun _ infos ->
          Coq7_Compilers.ToString.ident_info_with_value_barrier infos
            Coq7_Compilers.ToString.IntSet.empty) }
     end
   end
 end

module Rust =
 struct
  (** val comment_module_header_block : char list list -> char list list **)

  let comment_module_header_block =
    map (fun line0 -> append ('/'::('/'::('!'::(' '::[])))) line0)

  (** val comment_block : char list list -> char list list **)

  let comment_block =
    map (fun line0 ->
      append ('/'::('*'::('*'::(' '::[]))))
        (append line0 (' '::('*'::('/'::[])))))

  (** val stdint_bitwidths : z list **)

  let stdint_bitwidths =
    (Zpos (XO (XO (XO XH)))) :: ((Zpos (XO (XO (XO (XO XH))))) :: ((Zpos (XO
      (XO (XO (XO (XO XH)))))) :: ((Zpos (XO (XO (XO (XO (XO (XO
      XH))))))) :: ((Zpos (XO (XO (XO (XO (XO (XO (XO XH)))))))) :: []))))

  (** val int_type_to_string_opt_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list option ->
      char list **)

  let int_type_to_string_opt_typedef language_naming_conventions0 skip_typedefs0 private0 all_private prefix1 t0 typedef0 =
    Coq7_Compilers.ToString.Coq_int.to_string_gen_opt_typedef
      language_naming_conventions0 skip_typedefs0 stdint_bitwidths ('u'::[])
      ('i'::[]) [] [] private0 all_private prefix1 t0 typedef0

  (** val int_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list **)

  let int_type_to_string language_naming_conventions0 private0 prefix1 t0 =
    int_type_to_string_opt_typedef language_naming_conventions0 true private0
      private0 prefix1 t0 None

  (** val make_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt -> char list -> bool
      -> bool -> (((char list * (char list ->
      char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
      char list list **)

  let make_typedef language_naming_conventions0 documentation_options0 prefix1 internal_private private0 typedef0 =
    let (p, description0) =
      Coq7_Compilers.ToString.name_and_type_and_describe_typedef
        language_naming_conventions0 documentation_options0 prefix1 private0
        typedef0
    in
    let (name0, p0) = p in
    let (ty, array_len) = p0 in
    app (comment_block description0)
      ((let ty_string =
          match ty with
          | Some ty0 ->
            int_type_to_string language_naming_conventions0 internal_private
              prefix1 ty0
          | None -> '\226'::('\132'::('\164'::[]))
        in
        let visibility = if private0 then [] else 'p'::('u'::('b'::(' '::[])))
        in
        (match array_len with
         | Some o ->
           (match o with
            | Some len ->
              append
                ('#'::('['::('d'::('e'::('r'::('i'::('v'::('e'::('('::('C'::('l'::('o'::('n'::('e'::(','::(' '::('C'::('o'::('p'::('y'::(')'::(']'::[]))))))))))))))))))))))
                (append (newLine::[])
                  (append visibility
                    (append
                      ('s'::('t'::('r'::('u'::('c'::('t'::(' '::[])))))))
                      (append name0
                        (append ('('::('p'::('u'::('b'::(' '::('['::[]))))))
                          (append ty_string
                            (append (';'::(' '::[]))
                              (append (Coq0_Z.to_string (Coq_Z.of_nat len))
                                (append (']'::(')'::(';'::[])))
                                  (append (newLine::[])
                                    (append (newLine::[])
                                      (append
                                        ('i'::('m'::('p'::('l'::(' '::('c'::('o'::('r'::('e'::(':'::(':'::('o'::('p'::('s'::(':'::(':'::('I'::('n'::('d'::('e'::('x'::('<'::('u'::('s'::('i'::('z'::('e'::('>'::(' '::('f'::('o'::('r'::(' '::[])))))))))))))))))))))))))))))))))
                                        (append name0
                                          (append (' '::('{'::[]))
                                            (append (newLine::[])
                                              (append
                                                (' '::(' '::(' '::(' '::('t'::('y'::('p'::('e'::(' '::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('='::(' '::[]))))))))))))))))))
                                                (append ty_string
                                                  (append (';'::[])
                                                    (append (newLine::[])
                                                      (append
                                                        (' '::(' '::(' '::(' '::('#'::('['::('i'::('n'::('l'::('i'::('n'::('e'::(']'::[])))))))))))))
                                                        (append (newLine::[])
                                                          (append
                                                            (' '::(' '::(' '::(' '::('f'::('n'::(' '::('i'::('n'::('d'::('e'::('x'::('('::('&'::('s'::('e'::('l'::('f'::(','::(' '::('i'::('n'::('d'::('e'::('x'::(':'::(' '::('u'::('s'::('i'::('z'::('e'::(')'::(' '::('-'::('>'::(' '::('&'::('S'::('e'::('l'::('f'::(':'::(':'::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('{'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                            (append
                                                              (newLine::[])
                                                              (append
                                                                (' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('&'::('s'::('e'::('l'::('f'::('.'::('0'::('['::('i'::('n'::('d'::('e'::('x'::(']'::[]))))))))))))))))))))))
                                                                (append
                                                                  (newLine::[])
                                                                  (append
                                                                    (' '::(' '::(' '::(' '::('}'::[])))))
                                                                    (append
                                                                    (newLine::[])
                                                                    (append
                                                                    ('}'::[])
                                                                    (append
                                                                    (newLine::[])
                                                                    (append
                                                                    (newLine::[])
                                                                    (append
                                                                    ('i'::('m'::('p'::('l'::(' '::('c'::('o'::('r'::('e'::(':'::(':'::('o'::('p'::('s'::(':'::(':'::('I'::('n'::('d'::('e'::('x'::('M'::('u'::('t'::('<'::('u'::('s'::('i'::('z'::('e'::('>'::(' '::('f'::('o'::('r'::(' '::[]))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    name0
                                                                    (append
                                                                    (' '::('{'::[]))
                                                                    (append
                                                                    (newLine::[])
                                                                    (append
                                                                    (' '::(' '::(' '::(' '::('#'::('['::('i'::('n'::('l'::('i'::('n'::('e'::(']'::[])))))))))))))
                                                                    (append
                                                                    (newLine::[])
                                                                    (append
                                                                    (' '::(' '::(' '::(' '::('f'::('n'::(' '::('i'::('n'::('d'::('e'::('x'::('_'::('m'::('u'::('t'::('('::('&'::('m'::('u'::('t'::(' '::('s'::('e'::('l'::('f'::(','::(' '::('i'::('n'::('d'::('e'::('x'::(':'::(' '::('u'::('s'::('i'::('z'::('e'::(')'::(' '::('-'::('>'::(' '::('&'::('m'::('u'::('t'::(' '::('S'::('e'::('l'::('f'::(':'::(':'::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('{'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                                                                    (append
                                                                    (newLine::[])
                                                                    (append
                                                                    (' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('&'::('m'::('u'::('t'::(' '::('s'::('e'::('l'::('f'::('.'::('0'::('['::('i'::('n'::('d'::('e'::('x'::(']'::[]))))))))))))))))))))))))))
                                                                    (append
                                                                    (newLine::[])
                                                                    (append
                                                                    (' '::(' '::(' '::(' '::('}'::[])))))
                                                                    (append
                                                                    (newLine::[])
                                                                    ('}'::[])))))))))))))))))))))))))))))))))))))))))))
            | None ->
              append visibility
                (append ('t'::('y'::('p'::('e'::(' '::[])))))
                  (append name0
                    (append
                      (' '::('='::(' '::('*'::('m'::('u'::('t'::(' '::[]))))))))
                      (append ty_string (';'::[]))))))
         | None ->
           append visibility
             (append ('t'::('y'::('p'::('e'::(' '::[])))))
               (append name0
                 (append (' '::('='::(' '::[]))) (append ty_string (';'::[]))))))) :: [])

  (** val header :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.package_name_opt ->
      Coq7_Compilers.Options.class_name_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
      char list -> Coq7_Compilers.ToString.ident_infos ->
      (((char list * (char list ->
      char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list
      -> char list list **)

  let header language_naming_conventions0 documentation_options0 _ _ output_options0 _ internal_private private0 prefix1 infos typedef_map =
    let bitwidths_used0 = infos.Coq7_Compilers.ToString.bitwidths_used in
    let type_prefix =
      if internal_private
      then 't'::('y'::('p'::('e'::(' '::[]))))
      else 'p'::('u'::('b'::(' '::('t'::('y'::('p'::('e'::(' '::[]))))))))
    in
    app
      ([] :: (('#'::('!'::('['::('a'::('l'::('l'::('o'::('w'::('('::('u'::('n'::('u'::('s'::('e'::('d'::('_'::('p'::('a'::('r'::('e'::('n'::('s'::(')'::(']'::[])))))))))))))))))))))))) :: (('#'::('!'::('['::('a'::('l'::('l'::('o'::('w'::('('::('n'::('o'::('n'::('_'::('c'::('a'::('m'::('e'::('l'::('_'::('c'::('a'::('s'::('e'::('_'::('t'::('y'::('p'::('e'::('s'::(')'::(']'::[]))))))))))))))))))))))))))))))) :: ([] :: []))))
      (app
        (flat_map (fun bw ->
          let type_suffix = fun b ->
            Coq7_Compilers.ToString.Coq_int.of_bitwidth b bw
          in
          let typedef_name = fun b ->
            int_type_to_string language_naming_conventions0 internal_private
              prefix1 (type_suffix b)
          in
          let type_comment = fun name0 ->
            concat0 (newLine::[])
              (comment_block
                ((append name0
                   (append
                     (' '::('r'::('e'::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('s'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('o'::('f'::(' '::[]))))))))))))))))))))))
                     (append (show0 Decimal.show_Z bw)
                       (' '::('b'::('i'::('t'::('s'::(','::(' '::('s'::('t'::('o'::('r'::('e'::('d'::(' '::('i'::('n'::(' '::('o'::('n'::('e'::(' '::('b'::('y'::('t'::('e'::('.'::[]))))))))))))))))))))))))))))) :: []))
          in
          if (||)
               (Coq7_Compilers.ToString.IntSet.mem (type_suffix false)
                 bitwidths_used0)
               (Coq7_Compilers.ToString.IntSet.mem (type_suffix true)
                 bitwidths_used0)
          then (append (type_comment (typedef_name false))
                 (append (newLine::[])
                   (append type_prefix
                     (append (typedef_name false)
                       (' '::('='::(' '::('u'::('8'::(';'::[])))))))))) :: (
                 (append (type_comment (typedef_name true))
                   (append (newLine::[])
                     (append type_prefix
                       (append (typedef_name true)
                         (' '::('='::(' '::('i'::('8'::(';'::[])))))))))) :: [])
          else []) ((Zpos XH) :: ((Zpos (XO XH)) :: [])))
        (app
          (if Coq7_Compilers.Options.skip_typedefs
                output_options0.Coq7_Compilers.Options.skip_typedefs_
           then []
           else flat_map (fun td_name ->
                  match find (fun pat ->
                          let (y, _) = pat in
                          let (y1, _) = y in
                          let (name0, _) = y1 in eqb0 td_name name0)
                          typedef_map with
                  | Some td_info ->
                    app ([] :: [])
                      (make_typedef language_naming_conventions0
                        documentation_options0 prefix1 internal_private
                        private0 td_info)
                  | None ->
                    (append
                      ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('f'::('i'::('n'::('d'::(' '::('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::('i'::('n'::('f'::('o'::(' '::('f'::('o'::('r'::(' '::('\''::[])))))))))))))))))))))))))))))))))))))))))
                      (append td_name ('\''::('"'::(';'::[]))))) :: [])
                  infos.Coq7_Compilers.ToString.typedefs_used) ([] :: [])))

  (** val cast_literal :
      char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list
      option **)

  let cast_literal _ t0 =
    if Coq_Z.ltb (Coq7_Compilers.ToString.Coq_int.bitwidth_of t0) (Zpos (XO
         (XO (XO XH))))
    then None
    else None

  (** val primitive_type_to_string_opt_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list option ->
      char list **)

  let primitive_type_to_string_opt_typedef language_naming_conventions0 skip_typedefs0 private0 all_private prefix1 t0 r0 typedef0 =
    append
      (match t0 with
       | Coq24_Compilers.ToString.IR.Coq_type.Z -> []
       | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
         '&'::('m'::('u'::('t'::(' '::[])))))
      (match r0 with
       | Some int_t ->
         int_type_to_string_opt_typedef language_naming_conventions0
           skip_typedefs0 private0 all_private prefix1 int_t typedef0
       | None -> '\226'::('\132'::('\164'::[])))

  (** val primitive_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list **)

  let primitive_type_to_string language_naming_conventions0 private0 prefix1 t0 r0 =
    primitive_type_to_string_opt_typedef language_naming_conventions0 true
      private0 private0 prefix1 t0 r0 None

  (** val primitive_array_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> nat -> char list
      option -> char list **)

  let primitive_array_type_to_string language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 t0 r0 len typedef0 =
    match if skip_typedefs0 then None else typedef0 with
    | Some typedef1 ->
      Coq7_Compilers.ToString.format_typedef_name
        language_naming_conventions0 prefix1 all_private typedef1
    | None ->
      append ('['::[])
        (append
          (primitive_type_to_string language_naming_conventions0
            internal_private prefix1 t0 r0)
          (append (';'::(' '::[]))
            (append (Coq0_Z.to_string (Coq_Z.of_nat len)) (']'::[]))))

  (** val int_literal_to_string :
      char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
      char list **)

  let int_literal_to_string prefix1 t0 v =
    match t0 with
    | Coq24_Compilers.ToString.IR.Coq_type.Z ->
      (match cast_literal prefix1
               (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower =
                 v; upper = v }) with
       | Some cast0 ->
         append ('('::[]) (append (of_Z v) (append cast0 (')'::[])))
       | None -> of_Z v)
    | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
      append
        ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('a'::('d'::('d'::('r'::('e'::('s'::('s'::(' '::[]))))))))))))))))))))))))
        (append (of_Z v) ('"'::(';'::[])))

  (** val arith_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
      Coq24_Compilers.ToString.IR.arith_expr -> char list **)

  let rec arith_to_string language_naming_conventions0 internal_private prefix1 _ e =
    let special_name_ty = fun name0 ty ->
      Coq7_Compilers.ToString.format_special_function_name_ty
        language_naming_conventions0 internal_private prefix1 name0 ty
    in
    let special_name = fun name0 bw ->
      Coq7_Compilers.ToString.format_special_function_name
        language_naming_conventions0 internal_private prefix1 name0 false bw
    in
    (match e with
     | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc, e0) ->
       (match idc with
        | Coq24_Compilers.ToString.IR.Coq_literal v ->
          (fun _ ->
            int_literal_to_string prefix1
              Coq24_Compilers.ToString.IR.Coq_type.Z v)
        | Coq24_Compilers.ToString.IR.List_nth n3 ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              append ('('::[])
                (append v
                  (append ('['::[])
                    (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
                      (']'::(')'::[])))))
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
        | Coq24_Compilers.ToString.IR.Addr ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              append ('&'::('m'::('u'::('t'::(' '::[]))))) v
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
        | Coq24_Compilers.ToString.IR.Dereference ->
          (fun e1 ->
            append ('('::(' '::('*'::[])))
              (append
                (arith_to_string language_naming_conventions0
                  internal_private prefix1
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Zptr) e1)
                (' '::(')'::[]))))
        | Coq24_Compilers.ToString.IR.Coq_iunop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('>'::('>'::(' '::[]))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('<'::('<'::(' '::[]))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_lnot _ ->
             (fun e1 ->
               append ('('::('!'::[]))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_bneg ->
             (fun e1 ->
               append ('('::('!'::[]))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
             (fun e1 ->
               append
                 (special_name_ty
                   ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))
                   ty)
                 (append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1
                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                       Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))))
        | Coq24_Compilers.ToString.IR.Coq_ibinop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_land ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('&'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('|'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lxor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('^'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_add ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('+'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_mul ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('*'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_sub ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('-'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_mul_split lg2s ->
          (fun e1 ->
            append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_with_get_carry lg2s ->
          (fun e1 ->
            append
              (special_name
                ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow lg2s ->
          (fun e1 ->
            append
              (special_name
                ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_zselect ty ->
          (fun e1 ->
            append
              (special_name_ty
                ('c'::('m'::('o'::('v'::('z'::('n'::('z'::[]))))))) ty)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_modulo ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
            | Coq24_Compilers.ToString.IR.Pair (_, _, a, _) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[]))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('a'::('d'::('d'::('m'::('o'::('d'::('u'::('l'::('o'::(';'::[]))))))))))))))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              '#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::(';'::[])))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_static_cast int_t ->
          (fun e1 ->
            append ('('::[])
              (append
                (arith_to_string language_naming_conventions0
                  internal_private prefix1
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                (append (' '::('a'::('s'::(' '::[]))))
                  (append
                    (primitive_type_to_string language_naming_conventions0
                      internal_private prefix1
                      Coq24_Compilers.ToString.IR.Coq_type.Z (Some int_t))
                    (')'::[])))))) e0
     | Coq24_Compilers.ToString.IR.Var (_, v) -> v
     | Coq24_Compilers.ToString.IR.Pair (a, b, a0, b0) ->
       append
         (arith_to_string language_naming_conventions0 internal_private
           prefix1 a a0)
         (append (','::(' '::[]))
           (arith_to_string language_naming_conventions0 internal_private
             prefix1 b b0))
     | Coq24_Compilers.ToString.IR.TT ->
       '#'::('e'::('r'::('r'::('o'::('r'::(' '::('t'::('t'::(';'::[]))))))))))

  (** val stmt_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.stmt -> char list **)

  let stmt_to_string language_naming_conventions0 internal_private prefix1 = function
  | Coq24_Compilers.ToString.IR.Call val0 ->
    append
      (arith_to_string language_naming_conventions0 internal_private prefix1
        Coq24_Compilers.ToString.IR.Coq_type.Coq_unit val0) (';'::[])
  | Coq24_Compilers.ToString.IR.Comment (lines0, _) ->
    concat0 (newLine::[])
      (comment_block
        (Coq7_Compilers.ToString.preprocess_comment_block lines0))
  | Coq24_Compilers.ToString.IR.Assign (declare, t0, sz, name0, val0) ->
    if declare
    then append ('l'::('e'::('t'::(' '::[]))))
           (append name0
             (append (':'::(' '::[]))
               (append
                 (primitive_type_to_string language_naming_conventions0
                   internal_private prefix1 t0 sz)
                 (append (' '::('='::(' '::[])))
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1
                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                       t0) val0) (';'::[]))))))
    else '#'::('e'::('r'::('r'::('o'::('r'::(' '::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('t'::('o'::(' '::('n'::('o'::('n'::('-'::('m'::('u'::('t'::('a'::('b'::('l'::('e'::(' '::('v'::('a'::('r'::('i'::('a'::('b'::('l'::('e'::(';'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))
  | Coq24_Compilers.ToString.IR.AssignZPtr (name0, _, val0) ->
    append ('*'::[])
      (append name0
        (append (' '::('='::(' '::[])))
          (append
            (arith_to_string language_naming_conventions0 internal_private
              prefix1
              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
              Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (';'::[]))))
  | Coq24_Compilers.ToString.IR.DeclareVar (t0, sz, name0) ->
    append ('l'::('e'::('t'::(' '::('m'::('u'::('t'::(' '::[]))))))))
      (append name0
        (append (':'::(' '::[]))
          (append
            (primitive_type_to_string language_naming_conventions0
              internal_private prefix1 t0 sz)
            (' '::('='::(' '::('0'::(';'::[]))))))))
  | Coq24_Compilers.ToString.IR.AssignNth (name0, n3, val0) ->
    append name0
      (append ('['::[])
        (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
          (append (']'::(' '::('='::(' '::[]))))
            (append
              (arith_to_string language_naming_conventions0 internal_private
                prefix1
                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (';'::[])))))

  (** val to_strings :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.expr -> char list list **)

  let to_strings language_naming_conventions0 internal_private prefix1 e =
    map
      (stmt_to_string language_naming_conventions0 internal_private prefix1) e

  type coq_Mode =
  | In
  | Out

  (** val to_base_arg_list :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      -> Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list **)

  let rec to_base_arg_list language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 mode = function
  | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
    (match t1 with
     | Coq3_Compilers.Z ->
       let typ =
         match mode with
         | In -> Coq24_Compilers.ToString.IR.Coq_type.Z
         | Out -> Coq24_Compilers.ToString.IR.Coq_type.Zptr
       in
       (fun pat ->
       let (p, typedef0) = Obj.magic pat in
       let (p0, r0) = p in
       let (n3, _) = p0 in
       (append n3
         (append (':'::(' '::[]))
           (primitive_type_to_string_opt_typedef language_naming_conventions0
             skip_typedefs0 internal_private all_private prefix1 typ r0
             typedef0))) :: [])
     | Coq3_Compilers.Coq_bool ->
       (fun _ ->
         (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) (';'::[]))) :: [])
     | Coq3_Compilers.Coq_nat ->
       (fun _ ->
         (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) (';'::[]))) :: [])
     | Coq3_Compilers.Coq_zrange ->
       (fun _ ->
         (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) (';'::[]))) :: [])
     | Coq3_Compilers.Coq_string ->
       (fun _ ->
         (append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) (';'::[]))) :: []))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun pat ->
      let (va, vb) = Obj.magic pat in
      app
        (to_base_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 mode a va)
        (to_base_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 mode b vb))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun pat ->
            let (p, typedef0) = Obj.magic pat in
            let (p0, len) = p in
            let (n3, r0) = p0 in
            let modifier =
              match mode with
              | In -> '&'::[]
              | Out -> '&'::('m'::('u'::('t'::(' '::[]))))
            in
            (append n3
              (append (':'::(' '::[]))
                (append modifier
                  (primitive_array_type_to_string
                    language_naming_conventions0 skip_typedefs0
                    internal_private all_private prefix1
                    Coq24_Compilers.ToString.IR.Coq_type.Z r0 len typedef0)))) :: [])
        | Coq3_Compilers.Coq_bool ->
          (fun _ ->
            ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_nat ->
          (fun _ ->
            ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_zrange ->
          (fun _ ->
            ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_string ->
          (fun _ ->
            ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: []))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun _ ->
         ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun _ ->
         ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun _ ->
         ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (fun _ ->
         ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(';'::[])))))))))))))))))))))) :: []))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    (fun _ ->
      ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::(';'::[])))))))))))))) :: [])
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (fun _ ->
      ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('u'::('n'::('i'::('t'::(';'::[])))))))))))) :: [])

  (** val to_arg_list :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
      -> char list list **)

  let to_arg_list language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 mode = function
  | Compilers.Coq_type.Coq_base t1 ->
    to_base_arg_list language_naming_conventions0 skip_typedefs0
      internal_private all_private prefix1 mode t1
  | Compilers.Coq_type.Coq_arrow (_, _) ->
    (fun _ ->
      ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('a'::('r'::('r'::('o'::('w'::(';'::[]))))))))))))) :: [])

  (** val to_arg_list_for_each_lhs_of_arrow :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow -> char list list **)

  let rec to_arg_list_for_each_lhs_of_arrow language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ -> [])
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (fun pat ->
      let (x, xs) = Obj.magic pat in
      app
        (to_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 In s0 x)
        (to_arg_list_for_each_lhs_of_arrow language_naming_conventions0
          skip_typedefs0 internal_private all_private prefix1 d xs))

  (** val coq_Rust_bin_op_natural_output :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type **)

  let coq_Rust_bin_op_natural_output _ = function
  | (t1, t2) -> Coq7_Compilers.ToString.Coq_int.union t1 t2

  (** val coq_Rust_bin_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type
      option * (Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

  let coq_Rust_bin_op_casts _ desired_type = function
  | (t1, t2) ->
    (match desired_type with
     | Some desired_type0 ->
       let ct = Coq7_Compilers.ToString.Coq_int.union t1 t2 in
       let desired_type' = Some
         (Coq7_Compilers.ToString.Coq_int.union ct desired_type0)
       in
       ((Some desired_type0),
       ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
          desired_type' (Some t1)),
       (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
         desired_type' (Some t2))))
     | None -> (None, (None, None)))

  (** val coq_Rust_un_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_unop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      Coq7_Compilers.ToString.Coq_int.coq_type ->
      Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

  let coq_Rust_un_op_casts idc desired_type t0 =
    match idc with
    | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
      let t' =
        Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0; upper =
          (Coq_Z.pow (Zpos (XO XH)) offset) } t0
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some t')),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed (Some t')
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
      let rpre_out =
        match desired_type with
        | Some rout ->
          Some
            (Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) }
              (Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of rout))
        | None ->
          Some
            (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) })
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type rpre_out),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed rpre_out
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_lnot ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))
    | Coq24_Compilers.ToString.IR.Z_bneg -> (None, None)
    | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))

  (** val coq_RustLanguageCasts :
      Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts **)

  let coq_RustLanguageCasts =
    { Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_natural_output =
      coq_Rust_bin_op_natural_output;
      Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_casts =
      coq_Rust_bin_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.un_op_casts = coq_Rust_un_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_assignment = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_funcall = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.explicit_pointer_variables = false }

  (** val to_function_lines :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> bool ->
      bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
      -> char list list **)

  let to_function_lines language_naming_conventions0 skip_typedefs0 internal_private private0 all_private inline0 prefix1 name0 t0 = function
  | (p, body) ->
    let (args0, rets) = p in
    (append
      (if inline0
       then append
              ('#'::('['::('i'::('n'::('l'::('i'::('n'::('e'::(']'::[])))))))))
              (newLine::[])
       else [])
      (append
        (if private0
         then 'f'::('n'::(' '::[]))
         else 'p'::('u'::('b'::(' '::('f'::('n'::(' '::[])))))))
        (append name0
          (append ('('::[])
            (append
              (concat0 (','::(' '::[]))
                (app
                  (to_arg_list language_naming_conventions0 skip_typedefs0
                    internal_private all_private prefix1 Out
                    (Compilers.Coq_type.Coq_base
                    (Compilers.Coq_type.final_codomain t0)) rets)
                  (to_arg_list_for_each_lhs_of_arrow
                    language_naming_conventions0 skip_typedefs0
                    internal_private all_private prefix1 t0 args0)))
              (')'::(' '::('{'::[])))))))) :: (app
                                                (map (fun s0 ->
                                                  append (' '::(' '::[])) s0)
                                                  (to_strings
                                                    language_naming_conventions0
                                                    internal_private prefix1
                                                    body)) (('}'::[]) :: []))

  (** val consider_retargs_live_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt **)

  let consider_retargs_live_opt_instance_0 _ _ _ =
    true

  (** val rename_dead_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt **)

  let rename_dead_opt_instance_0 s0 =
    s0

  (** val lift_declarations_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt **)

  let lift_declarations_opt_instance_0 =
    false

  (** val coq_ToFunctionLines :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      Coq7_Compilers.Options.relax_zrange_opt ->
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool
      -> bool -> bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) ->
      char list list option -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
      list * Coq7_Compilers.ToString.ident_infos, char list) sum **)

  let coq_ToFunctionLines absint_opts0 relax_zrange language_naming_conventions0 _ output_options0 _ do_bounds_check internal_private private0 all_private inline0 prefix1 name0 t0 e comment0 name_list inbounds outbounds intypedefs outtypedefs =
    match Coq24_Compilers.ToString.IR.OfPHOAS.coq_ExprOfPHOAS
            coq_RustLanguageCasts relax_zrange
            consider_retargs_live_opt_instance_0 rename_dead_opt_instance_0
            lift_declarations_opt_instance_0
            output_options0.Coq7_Compilers.Options.language_specific_cast_adjustment_
            absint_opts0
            output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_
            do_bounds_check t0 e name_list inbounds intypedefs outtypedefs with
    | Inl p ->
      let (p0, f) = p in
      let (indata, outdata) = p0 in
      Inl
      ((app
         (map (fun s0 ->
           if Nat.eqb (length0 s0) O
           then '/'::('/'::('/'::[]))
           else append ('/'::('/'::('/'::(' '::[])))) s0)
           (comment0 indata outdata))
         (app
           (match Coq7_Compilers.ToString.OfPHOAS.input_bounds_to_string
                    output_options0.Coq7_Compilers.Options.skip_typedefs_ t0
                    indata inbounds with
            | [] -> []
            | s0 :: l ->
              app
                (('/'::('/'::('/'::(' '::('I'::('n'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[]))))))))))))))))) :: [])
                (map (fun v ->
                  append ('/'::('/'::('/'::(' '::(' '::(' '::[])))))) v)
                  (s0 :: l)))
           (app
             (match Coq7_Compilers.ToString.OfPHOAS.bound_to_string
                      output_options0.Coq7_Compilers.Options.skip_typedefs_
                      (Compilers.Coq_type.final_codomain t0) outdata outbounds with
              | [] -> []
              | s0 :: l ->
                app
                  (('/'::('/'::('/'::(' '::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[])))))))))))))))))) :: [])
                  (map (fun v ->
                    append ('/'::('/'::('/'::(' '::(' '::(' '::[])))))) v)
                    (s0 :: l)))
             (to_function_lines language_naming_conventions0
               output_options0.Coq7_Compilers.Options.skip_typedefs_
               internal_private private0 all_private inline0 prefix1 name0 t0
               ((indata, outdata), f))))),
      (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_all_infos
        output_options0.Coq7_Compilers.Options.skip_typedefs_ f t0 intypedefs
        outtypedefs))
    | Inr errs ->
      (match errs with
       | [] ->
         Inr
           (append
             ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))))))))))))))))))
             (append name0
               (' '::('t'::('o'::(' '::('R'::('u'::('s'::('t'::[]))))))))))
       | err0 :: l ->
         (match l with
          | [] ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('R'::('u'::('s'::('t'::(':'::[])))))))))
                    (append (newLine::[]) err0))))
          | _ :: _ ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::('s'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('R'::('u'::('s'::('t'::(':'::[])))))))))
                    (append (newLine::[]) (concat0 (newLine::[]) errs)))))))

  (** val coq_OutputRustAPI :
      Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

  let coq_OutputRustAPI =
    { Coq7_Compilers.ToString.comment_block = comment_block;
      Coq7_Compilers.ToString.comment_file_header_block =
      comment_module_header_block;
      Coq7_Compilers.ToString.coq_ToFunctionLines = coq_ToFunctionLines;
      Coq7_Compilers.ToString.header = header;
      Coq7_Compilers.ToString.footer = (fun _ _ _ _ _ _ _ _ _ -> []);
      Coq7_Compilers.ToString.strip_special_infos = (fun _ infos -> infos) }
 end

module Go =
 struct
  (** val comment_block : char list list -> char list list **)

  let comment_block lines0 = match lines0 with
  | [] -> []
  | line0 :: l ->
    (match line0 with
     | [] ->
       (match l with
        | [] -> [] :: []
        | _ :: _ ->
          map (fun s0 ->
            if Nat.eqb (length0 s0) O
            then '/'::('/'::[])
            else append ('/'::('/'::(' '::[]))) s0) lines0)
     | _::_ ->
       (match l with
        | [] -> (append ('/'::('/'::(' '::[]))) line0) :: []
        | _ :: _ ->
          map (fun s0 ->
            if Nat.eqb (length0 s0) O
            then '/'::('/'::[])
            else append ('/'::('/'::(' '::[]))) s0) lines0))

  (** val comment_block_extra_newlines : char list list -> char list list **)

  let comment_block_extra_newlines lines0 = match lines0 with
  | [] -> []
  | line0 :: l ->
    (match line0 with
     | [] ->
       (match l with
        | [] -> [] :: []
        | _ :: _ ->
          tl
            (flat_map (fun s0 ->
              ('/'::('/'::[])) :: ((if Nat.eqb (length0 s0) O
                                    then '/'::('/'::[])
                                    else append ('/'::('/'::(' '::[]))) s0) :: []))
              lines0))
     | _::_ ->
       (match l with
        | [] -> (append ('/'::('/'::(' '::[]))) line0) :: []
        | _ :: _ ->
          tl
            (flat_map (fun s0 ->
              ('/'::('/'::[])) :: ((if Nat.eqb (length0 s0) O
                                    then '/'::('/'::[])
                                    else append ('/'::('/'::(' '::[]))) s0) :: []))
              lines0)))

  (** val stdint_bitwidths : z list **)

  let stdint_bitwidths =
    (Zpos (XO (XO (XO XH)))) :: ((Zpos (XO (XO (XO (XO XH))))) :: ((Zpos (XO
      (XO (XO (XO (XO XH)))))) :: ((Zpos (XO (XO (XO (XO (XO (XO
      XH))))))) :: [])))

  (** val bits_std_bitwidths : z list **)

  let bits_std_bitwidths =
    (Zpos (XO (XO (XO (XO (XO XH)))))) :: ((Zpos (XO (XO (XO (XO (XO (XO
      XH))))))) :: [])

  (** val is_bits_standard_bitwidth : z -> bool **)

  let is_bits_standard_bitwidth bw =
    existsb (Coq_Z.eqb bw) bits_std_bitwidths

  (** val is_nonbits_special_bitwidth : z -> bool **)

  let is_nonbits_special_bitwidth bw =
    negb (is_bits_standard_bitwidth bw)

  (** val int_type_to_string_opt_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list option ->
      char list **)

  let int_type_to_string_opt_typedef language_naming_conventions0 skip_typedefs0 private0 all_private prefix1 t0 typedef0 =
    Coq7_Compilers.ToString.Coq_int.to_string_gen_opt_typedef
      language_naming_conventions0 skip_typedefs0 stdint_bitwidths
      ('u'::('i'::('n'::('t'::[])))) ('i'::('n'::('t'::[]))) [] [] private0
      all_private prefix1 t0 typedef0

  (** val int_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list **)

  let int_type_to_string language_naming_conventions0 private0 prefix1 t0 =
    int_type_to_string_opt_typedef language_naming_conventions0 true private0
      private0 prefix1 t0 None

  (** val make_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt -> char list -> bool
      -> bool -> (((char list * (char list ->
      char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
      char list list **)

  let make_typedef language_naming_conventions0 documentation_options0 prefix1 internal_private private0 typedef0 =
    let (p, description0) =
      Coq7_Compilers.ToString.name_and_type_and_describe_typedef
        language_naming_conventions0 documentation_options0 prefix1 private0
        typedef0
    in
    let (name0, p0) = p in
    let (ty, array_len) = p0 in
    app (comment_block_extra_newlines description0)
      ((append ('t'::('y'::('p'::('e'::(' '::[])))))
         (append name0
           (append (' '::[])
             (append
               (match array_len with
                | Some o ->
                  (match o with
                   | Some len ->
                     append ('['::[])
                       (append (Coq0_Z.to_string (Coq_Z.of_nat len))
                         (']'::[]))
                   | None -> '['::(']'::[]))
                | None -> [])
               (match ty with
                | Some ty0 ->
                  int_type_to_string language_naming_conventions0
                    internal_private prefix1 ty0
                | None -> '\226'::('\132'::('\164'::[]))))))) :: [])

  (** val header :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.package_name_opt ->
      Coq7_Compilers.Options.class_name_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
      char list -> Coq7_Compilers.ToString.ident_infos ->
      (((char list * (char list ->
      char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list
      -> char list list **)

  let header language_naming_conventions0 documentation_options0 package_namev0 _ output_options0 machine_wordsize0 internal_private private0 prefix1 infos typedef_map =
    let bitwidths_used0 = infos.Coq7_Compilers.ToString.bitwidths_used in
    let needs_bits_import =
      PositiveSet.exists_ (fun bw -> is_bits_standard_bitwidth (Zpos bw))
        (PositiveSet.union infos.Coq7_Compilers.ToString.addcarryx_lg_splits
          infos.Coq7_Compilers.ToString.mulx_lg_splits)
    in
    let type_prefix = 't'::('y'::('p'::('e'::(' '::[])))) in
    let special_addcarryx_lg_splits =
      filter (fun bw ->
        negb
          (existsb (Coq_Z.eqb bw)
            (Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth
              output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_)))
        (filter is_bits_standard_bitwidth
          (map (fun x -> Zpos x)
            (PositiveSet.elements
              infos.Coq7_Compilers.ToString.addcarryx_lg_splits)))
    in
    let carry_type =
      if (||)
           (Coq7_Compilers.ToString.IntSet.mem
             (Coq7_Compilers.ToString.Coq_int.Coq_unsigned O) bitwidths_used0)
           (Coq7_Compilers.ToString.IntSet.mem
             (Coq7_Compilers.ToString.Coq_int.signed_counterpart_of
               (Coq7_Compilers.ToString.Coq_int.Coq_unsigned O))
             bitwidths_used0)
      then int_type_to_string language_naming_conventions0 internal_private
             prefix1 (Coq7_Compilers.ToString.Coq_int.Coq_unsigned O)
      else if (||)
                (Coq7_Compilers.ToString.IntSet.mem
                  (Coq7_Compilers.ToString.Coq_int.Coq_unsigned (S (S (S
                  O)))) bitwidths_used0)
                (Coq7_Compilers.ToString.IntSet.mem
                  (Coq7_Compilers.ToString.Coq_int.Coq_signed (S (S (S O))))
                  bitwidths_used0)
           then int_type_to_string language_naming_conventions0
                  internal_private prefix1
                  (Coq7_Compilers.ToString.Coq_int.Coq_unsigned (S (S (S O))))
           else int_type_to_string language_naming_conventions0
                  internal_private prefix1
                  (Coq7_Compilers.ToString.Coq_int.of_bitwidth false
                    machine_wordsize0)
    in
    strip_trailing_newlines
      (app
        (app
          (if documentation_options0.Coq7_Compilers.Options.newline_before_package_declaration
           then [] :: []
           else [])
          ((append ('p'::('a'::('c'::('k'::('a'::('g'::('e'::(' '::[]))))))))
             (Coq7_Compilers.Options.package_name package_namev0
               language_naming_conventions0 prefix1)) :: ([] :: [])))
        (app
          (if needs_bits_import
           then ('i'::('m'::('p'::('o'::('r'::('t'::(' '::('"'::('m'::('a'::('t'::('h'::('/'::('b'::('i'::('t'::('s'::('"'::[])))))))))))))))))) :: ([] :: [])
           else [])
          (app
            (let typedefs =
               let carry_bitwidth = Zpos (XO (XO (XO (XO (XO (XO XH)))))) in
               let carry_typedef_comment =
                 append
                   (' '::('/'::('/'::(' '::('W'::('e'::(' '::('u'::('s'::('e'::(' '::('u'::('i'::('n'::('t'::[])))))))))))))))
                   (append (Coq0_Z.to_string carry_bitwidth)
                     (' '::('i'::('n'::('s'::('t'::('e'::('a'::('d'::(' '::('o'::('f'::(' '::('a'::(' '::('m'::('o'::('r'::('e'::(' '::('n'::('a'::('r'::('r'::('o'::('w'::(' '::('t'::('y'::('p'::('e'::(' '::('f'::('o'::('r'::(' '::('p'::('e'::('r'::('f'::('o'::('r'::('m'::('a'::('n'::('c'::('e'::(' '::('r'::('e'::('a'::('s'::('o'::('n'::('s'::(';'::(' '::('s'::('e'::('e'::(' '::('h'::('t'::('t'::('p'::('s'::(':'::('/'::('/'::('g'::('i'::('t'::('h'::('u'::('b'::('.'::('c'::('o'::('m'::('/'::('m'::('i'::('t'::('-'::('p'::('l'::('v'::('/'::('f'::('i'::('a'::('t'::('-'::('c'::('r'::('y'::('p'::('t'::('o'::('/'::('p'::('u'::('l'::('l'::('/'::('1'::('0'::('0'::('6'::('#'::('i'::('s'::('s'::('u'::('e'::('c'::('o'::('m'::('m'::('e'::('n'::('t'::('-'::('8'::('9'::('2'::('6'::('2'::('5'::('9'::('2'::('7'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
               in
               flat_map (fun bw ->
                 if (||)
                      (Coq7_Compilers.ToString.IntSet.mem
                        (Coq7_Compilers.ToString.Coq_int.of_bitwidth false bw)
                        bitwidths_used0)
                      (Coq7_Compilers.ToString.IntSet.mem
                        (Coq7_Compilers.ToString.Coq_int.of_bitwidth true bw)
                        bitwidths_used0)
                 then (append type_prefix
                        (append
                          (int_type_to_string language_naming_conventions0
                            internal_private prefix1
                            (Coq7_Compilers.ToString.Coq_int.of_bitwidth
                              false bw))
                          (append (' '::('u'::('i'::('n'::('t'::[])))))
                            (append (Coq0_Z.to_string carry_bitwidth)
                              carry_typedef_comment)))) :: ((append
                                                              type_prefix
                                                              (append
                                                                (int_type_to_string
                                                                  language_naming_conventions0
                                                                  internal_private
                                                                  prefix1
                                                                  (Coq7_Compilers.ToString.Coq_int.of_bitwidth
                                                                    true bw))
                                                                (append
                                                                  (' '::('i'::('n'::('t'::[]))))
                                                                  (append
                                                                    (Coq0_Z.to_string
                                                                    carry_bitwidth)
                                                                    carry_typedef_comment)))) :: [])
                 else []) ((Zpos XH) :: ((Zpos (XO XH)) :: []))
             in
             let typedefs0 =
               app typedefs
                 (if Coq7_Compilers.Options.skip_typedefs
                       output_options0.Coq7_Compilers.Options.skip_typedefs_
                  then []
                  else flat_map (fun td_name ->
                         match find (fun pat ->
                                 let (y, _) = pat in
                                 let (y1, _) = y in
                                 let (name0, _) = y1 in eqb0 td_name name0)
                                 typedef_map with
                         | Some td_info ->
                           app ([] :: [])
                             (make_typedef language_naming_conventions0
                               documentation_options0 prefix1
                               internal_private private0 td_info)
                         | None ->
                           (append
                             ('v'::('a'::('r'::(' '::('_'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('G'::('o'::('_'::('C'::('o'::('u'::('l'::('d'::('_'::('n'::('o'::('t'::('_'::('f'::('i'::('n'::('d'::('_'::('t'::('y'::('p'::('e'::('d'::('e'::('f'::('_'::('i'::('n'::('f'::('o'::('_'::('f'::('o'::('r'::('_'::[])))))))))))))))))))))))))))))))))))))))))))))))))
                             td_name) :: [])
                         infos.Coq7_Compilers.ToString.typedefs_used)
             in
             (match typedefs0 with
              | [] -> []
              | _ :: _ -> app typedefs0 ([] :: [])))
            (app
              (if (||)
                    (Coq7_Compilers.ToString.IntSet.mem
                      (Coq7_Compilers.ToString.Coq_int.Coq_unsigned (S (S (S
                      (S (S (S (S O)))))))) bitwidths_used0)
                    (Coq7_Compilers.ToString.IntSet.mem
                      (Coq7_Compilers.ToString.Coq_int.Coq_signed (S (S (S (S
                      (S (S (S O)))))))) bitwidths_used0)
               then ('v'::('a'::('r'::(' '::('_'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('G'::('o'::('_'::('o'::('u'::('t'::('p'::('u'::('t'::('_'::('d'::('o'::('e'::('s'::('_'::('n'::('o'::('t'::('_'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('_'::('1'::('2'::('8'::('_'::('b'::('i'::('t'::('_'::('i'::('n'::('t'::('e'::('g'::('e'::('r'::('s'::('_'::('_'::('_'::('i'::('n'::('s'::('t'::('e'::('a'::('d'::('_'::('u'::('s'::('e'::('_'::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::('_'::('r'::('u'::('l'::('e'::('s'::('_'::('f'::('o'::('r'::('_'::('r'::('e'::('m'::('o'::('v'::('i'::('n'::('g'::('_'::('1'::('2'::('8'::('_'::('b'::('i'::('t'::('_'::('i'::('n'::('t'::('e'::('g'::('e'::('r'::('s'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []
               else [])
              (tl
                (flat_map (fun bw ->
                  let s_bw = Coq0_Z.to_string bw in
                  flat_map (fun pat ->
                    let (newname, bitsname) = pat in
                    app ([] :: [])
                      (app
                        (comment_block
                          ((append
                             (Coq7_Compilers.Options.text_before_function_name
                               documentation_options0)
                             (append newname
                               (append
                                 (' '::('i'::('s'::(' '::('a'::(' '::('t'::('h'::('i'::('n'::(' '::('w'::('r'::('a'::('p'::('p'::('e'::('r'::(' '::('a'::('r'::('o'::('u'::('n'::('d'::(' '::[]))))))))))))))))))))))))))
                                 (append bitsname
                                   (append
                                     (' '::('t'::('h'::('a'::('t'::(' '::('u'::('s'::('e'::('s'::(' '::[])))))))))))
                                     (append carry_type
                                       (append
                                         (' '::('r'::('a'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('u'::('i'::('n'::('t'::[])))))))))))))))))
                                         s_bw))))))) :: []))
                        ((append ('f'::('u'::('n'::('c'::(' '::[])))))
                           (append newname
                             (append
                               ('('::('x'::(' '::('u'::('i'::('n'::('t'::[])))))))
                               (append s_bw
                                 (append
                                   (','::(' '::('y'::(' '::('u'::('i'::('n'::('t'::[]))))))))
                                   (append s_bw
                                     (append
                                       (','::(' '::('c'::('a'::('r'::('r'::('y'::(' '::[]))))))))
                                       (append carry_type
                                         (append
                                           (')'::(' '::('('::('u'::('i'::('n'::('t'::[])))))))
                                           (append s_bw
                                             (append (','::(' '::[]))
                                               (append carry_type
                                                 (')'::(' '::('{'::[]))))))))))))))) :: (
                        (append (tab::[])
                          (append
                            ('s'::('u'::('m'::(','::(' '::('c'::('a'::('r'::('r'::('y'::('O'::('u'::('t'::(' '::(':'::('='::(' '::[])))))))))))))))))
                            (append bitsname
                              (append
                                ('('::('x'::(','::(' '::('y'::(','::(' '::('u'::('i'::('n'::('t'::[])))))))))))
                                (append s_bw
                                  ('('::('c'::('a'::('r'::('r'::('y'::(')'::(')'::[]))))))))))))) :: (
                        (append (tab::[])
                          (append
                            ('r'::('e'::('t'::('u'::('r'::('n'::(' '::('s'::('u'::('m'::(','::(' '::[]))))))))))))
                            (append carry_type
                              ('('::('c'::('a'::('r'::('r'::('y'::('O'::('u'::('t'::(')'::[]))))))))))))) :: (('}'::[]) :: []))))))
                    (((Coq7_Compilers.ToString.format_special_function_name
                        language_naming_conventions0 internal_private prefix1
                        ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                        false bw),
                    (append
                      ('b'::('i'::('t'::('s'::('.'::('A'::('d'::('d'::[]))))))))
                      s_bw)) :: (((Coq7_Compilers.ToString.format_special_function_name
                                    language_naming_conventions0
                                    internal_private prefix1
                                    ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                    false bw),
                    (append
                      ('b'::('i'::('t'::('s'::('.'::('S'::('u'::('b'::[]))))))))
                      s_bw)) :: []))) special_addcarryx_lg_splits))))))

  (** val cast_literal :
      char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list
      option **)

  let cast_literal _ t0 =
    if Coq_Z.ltb (Coq7_Compilers.ToString.Coq_int.bitwidth_of t0) (Zpos (XO
         (XO (XO XH))))
    then None
    else None

  (** val primitive_type_to_string_opt_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list option ->
      char list **)

  let primitive_type_to_string_opt_typedef language_naming_conventions0 skip_typedefs0 private0 all_private prefix1 t0 r0 typedef0 =
    append
      (match t0 with
       | Coq24_Compilers.ToString.IR.Coq_type.Z -> []
       | Coq24_Compilers.ToString.IR.Coq_type.Zptr -> '*'::[])
      (match r0 with
       | Some int_t ->
         int_type_to_string_opt_typedef language_naming_conventions0
           skip_typedefs0 private0 all_private prefix1 int_t typedef0
       | None -> '\226'::('\132'::('\164'::[])))

  (** val primitive_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list **)

  let primitive_type_to_string language_naming_conventions0 private0 prefix1 t0 r0 =
    primitive_type_to_string_opt_typedef language_naming_conventions0 true
      private0 private0 prefix1 t0 r0 None

  (** val primitive_array_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> nat -> char list
      option -> char list **)

  let primitive_array_type_to_string language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 t0 r0 len typedef0 =
    match if skip_typedefs0 then None else typedef0 with
    | Some typedef1 ->
      Coq7_Compilers.ToString.format_typedef_name
        language_naming_conventions0 prefix1 all_private typedef1
    | None ->
      append ('['::[])
        (append (Coq0_Z.to_string (Coq_Z.of_nat len))
          (append (']'::[])
            (primitive_type_to_string language_naming_conventions0
              internal_private prefix1 t0 r0)))

  (** val int_literal_to_string :
      char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
      char list **)

  let int_literal_to_string prefix1 t0 v =
    match t0 with
    | Coq24_Compilers.ToString.IR.Coq_type.Z ->
      (match cast_literal prefix1
               (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower =
                 v; upper = v }) with
       | Some cast0 ->
         append ('('::[]) (append (of_Z v) (append cast0 (')'::[])))
       | None -> of_Z v)
    | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
      append
        ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('l'::('i'::('t'::('e'::('r'::('a'::('l'::('_'::('a'::('d'::('d'::('r'::('e'::('s'::('s'::('_'::[])))))))))))))))))))))))))))))
        (of_Z v)

  (** val arith_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt ->
      bool -> char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
      Coq24_Compilers.ToString.IR.arith_expr -> char list **)

  let rec arith_to_string language_naming_conventions0 relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1 _ e =
    let special_name_ty = fun name0 ty ->
      Coq7_Compilers.ToString.format_special_function_name_ty
        language_naming_conventions0 internal_private prefix1 name0 ty
    in
    let special_name = fun name0 bw ->
      Coq7_Compilers.ToString.format_special_function_name
        language_naming_conventions0 internal_private prefix1 name0 false bw
    in
    (match e with
     | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc, e0) ->
       (match idc with
        | Coq24_Compilers.ToString.IR.Coq_literal v ->
          (fun _ ->
            int_literal_to_string prefix1
              Coq24_Compilers.ToString.IR.Coq_type.Z v)
        | Coq24_Compilers.ToString.IR.List_nth n3 ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              append v
                (append ('['::[])
                  (append (Coq0_Z.to_string (Coq_Z.of_nat n3)) (']'::[])))
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Addr ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) -> append ('&'::[]) v
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Dereference ->
          (fun e1 ->
            append ('('::(' '::('*'::[])))
              (append
                (arith_to_string language_naming_conventions0
                  relax_adc_sbb_return_carry_to_bitwidth0 internal_private
                  prefix1
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Zptr) e1)
                (' '::(')'::[]))))
        | Coq24_Compilers.ToString.IR.Coq_iunop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     relax_adc_sbb_return_carry_to_bitwidth0 internal_private
                     prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('>'::('>'::(' '::[]))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     relax_adc_sbb_return_carry_to_bitwidth0 internal_private
                     prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('<'::('<'::(' '::[]))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_lnot _ ->
             (fun e1 ->
               append ('('::('^'::[]))
                 (append
                   (arith_to_string language_naming_conventions0
                     relax_adc_sbb_return_carry_to_bitwidth0 internal_private
                     prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_bneg ->
             (fun e1 ->
               append
                 ('('::('!'::('/'::('*'::(' '::('T'::('O'::('D'::('O'::(':'::(' '::('F'::('I'::('X'::(' '::('M'::('E'::(' '::('*'::('/'::(' '::[])))))))))))))))))))))
                 (append
                   (arith_to_string language_naming_conventions0
                     relax_adc_sbb_return_carry_to_bitwidth0 internal_private
                     prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
             (fun e1 ->
               append
                 (special_name_ty
                   ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))
                   ty)
                 (append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       internal_private prefix1
                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                       Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))))
        | Coq24_Compilers.ToString.IR.Coq_ibinop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_land ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       internal_private prefix1 a e2)
                     (append (' '::('&'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           relax_adc_sbb_return_carry_to_bitwidth0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       internal_private prefix1 a e2)
                     (append (' '::('|'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           relax_adc_sbb_return_carry_to_bitwidth0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lxor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       internal_private prefix1 a e2)
                     (append (' '::('^'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           relax_adc_sbb_return_carry_to_bitwidth0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_add ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       internal_private prefix1 a x1)
                     (append (' '::('+'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           relax_adc_sbb_return_carry_to_bitwidth0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_mul ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       internal_private prefix1 a x1)
                     (append (' '::('*'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           relax_adc_sbb_return_carry_to_bitwidth0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_sub ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       relax_adc_sbb_return_carry_to_bitwidth0
                       internal_private prefix1 a x1)
                     (append (' '::('-'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           relax_adc_sbb_return_carry_to_bitwidth0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_mul_split lg2s ->
          (fun e1 ->
            if is_bits_standard_bitwidth lg2s
            then (match e1 with
                  | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                    append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[])))
                  | Coq24_Compilers.ToString.IR.Var (_, _) ->
                    append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[])))
                  | Coq24_Compilers.ToString.IR.Pair (_, b, a, args0) ->
                    (match a with
                     | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                       append
                         (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[])))
                     | Coq24_Compilers.ToString.IR.Var (_, _) ->
                       append
                         (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[])))
                     | Coq24_Compilers.ToString.IR.Pair (_, _, a0, b0) ->
                       (match a0 with
                        | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc0, lo) ->
                          (match idc0 with
                           | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.List_nth _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Addr ->
                             (fun lo0 ->
                               match b0 with
                               | Coq24_Compilers.ToString.IR.AppIdent (
                                   _, _, idc1, hi) ->
                                 (match idc1 with
                                  | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.List_nth _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Addr ->
                                    (fun hi0 ->
                                      append
                                        (append
                                          (arith_to_string
                                            language_naming_conventions0
                                            relax_adc_sbb_return_carry_to_bitwidth0
                                            internal_private prefix1
                                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                            Coq24_Compilers.ToString.IR.Coq_type.Z)
                                            hi0)
                                          (append (','::(' '::[]))
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)
                                              lo0)))
                                        (append
                                          (' '::('='::(' '::('b'::('i'::('t'::('s'::('.'::('M'::('u'::('l'::[])))))))))))
                                          (append (Coq0_Z.to_string lg2s)
                                            (append ('('::[])
                                              (append
                                                (arith_to_string
                                                  language_naming_conventions0
                                                  relax_adc_sbb_return_carry_to_bitwidth0
                                                  internal_private prefix1 b
                                                  args0) (')'::[]))))))
                                  | Coq24_Compilers.ToString.IR.Dereference ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('m'::('u'::('l'::('x'::[])))) lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))) hi
                               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                                 append
                                   (special_name
                                     ('m'::('u'::('l'::('x'::[])))) lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[])))
                               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                                 append
                                   (special_name
                                     ('m'::('u'::('l'::('x'::[])))) lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[])))
                               | Coq24_Compilers.ToString.IR.TT ->
                                 append
                                   (special_name
                                     ('m'::('u'::('l'::('x'::[])))) lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Dereference ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                             (fun _ ->
                               append
                                 (special_name ('m'::('u'::('l'::('x'::[]))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))) lo
                        | Coq24_Compilers.ToString.IR.Var (_, _) ->
                          append
                            (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[])))
                        | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                          append
                            (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[])))
                        | Coq24_Compilers.ToString.IR.TT ->
                          append
                            (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[]))))
                     | Coq24_Compilers.ToString.IR.TT ->
                       append
                         (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[]))))
                  | Coq24_Compilers.ToString.IR.TT ->
                    append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[]))))
            else append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
                   (append ('('::[])
                     (append
                       (arith_to_string language_naming_conventions0
                         relax_adc_sbb_return_carry_to_bitwidth0
                         internal_private prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                       (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_with_get_carry lg2s ->
          (fun e1 ->
            let (func_name, wrap_carry) =
              if existsb (Coq_Z.eqb lg2s)
                   relax_adc_sbb_return_carry_to_bitwidth0
              then ((append
                      ('b'::('i'::('t'::('s'::('.'::('A'::('d'::('d'::[]))))))))
                      (Coq0_Z.to_string lg2s)), (fun c0 ->
                     append ('u'::('i'::('n'::('t'::[]))))
                       (append (Coq0_Z.to_string lg2s)
                         (append ('('::[]) (append c0 (')'::[]))))))
              else ((special_name
                      ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                      lg2s), (fun c0 -> c0))
            in
            if is_bits_standard_bitwidth lg2s
            then (match e1 with
                  | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                    append
                      (special_name
                        ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                        lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[])))
                  | Coq24_Compilers.ToString.IR.Var (_, _) ->
                    append
                      (special_name
                        ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                        lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[])))
                  | Coq24_Compilers.ToString.IR.Pair (_, _, a, b) ->
                    (match a with
                     | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                       append
                         (special_name
                           ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                           lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[])))
                     | Coq24_Compilers.ToString.IR.Var (_, _) ->
                       append
                         (special_name
                           ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                           lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[])))
                     | Coq24_Compilers.ToString.IR.Pair (_, _, a0, b0) ->
                       (match a0 with
                        | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc0, v) ->
                          (match idc0 with
                           | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.List_nth _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Addr ->
                             (fun v0 ->
                               match b0 with
                               | Coq24_Compilers.ToString.IR.AppIdent (
                                   _, _, idc1, c0) ->
                                 (match idc1 with
                                  | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.List_nth _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Addr ->
                                    (fun c1 ->
                                      match b with
                                      | Coq24_Compilers.ToString.IR.AppIdent (
                                          _, _, _, _) ->
                                        append
                                          (special_name
                                            ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                            lg2s)
                                          (append ('('::[])
                                            (append
                                              (arith_to_string
                                                language_naming_conventions0
                                                relax_adc_sbb_return_carry_to_bitwidth0
                                                internal_private prefix1
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                e1) (')'::[])))
                                      | Coq24_Compilers.ToString.IR.Var (
                                          _, _) ->
                                        append
                                          (special_name
                                            ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                            lg2s)
                                          (append ('('::[])
                                            (append
                                              (arith_to_string
                                                language_naming_conventions0
                                                relax_adc_sbb_return_carry_to_bitwidth0
                                                internal_private prefix1
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                e1) (')'::[])))
                                      | Coq24_Compilers.ToString.IR.Pair (
                                          _, b1, a1, y) ->
                                        (match a1 with
                                         | Coq24_Compilers.ToString.IR.AppIdent (
                                             _, _, _, _) ->
                                           append
                                             (special_name
                                               ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                               lg2s)
                                             (append ('('::[])
                                               (append
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                   e1) (')'::[])))
                                         | Coq24_Compilers.ToString.IR.Var (
                                             _, _) ->
                                           append
                                             (special_name
                                               ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                               lg2s)
                                             (append ('('::[])
                                               (append
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                   e1) (')'::[])))
                                         | Coq24_Compilers.ToString.IR.Pair (
                                             a2, b2, cin, x) ->
                                           append
                                             (append
                                               (arith_to_string
                                                 language_naming_conventions0
                                                 relax_adc_sbb_return_carry_to_bitwidth0
                                                 internal_private prefix1
                                                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                 Coq24_Compilers.ToString.IR.Coq_type.Z)
                                                 v0)
                                               (append (','::(' '::[]))
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)
                                                   c1)))
                                             (append (' '::('='::(' '::[])))
                                               (append func_name
                                                 (append ('('::[])
                                                   (append
                                                     (arith_to_string
                                                       language_naming_conventions0
                                                       relax_adc_sbb_return_carry_to_bitwidth0
                                                       internal_private
                                                       prefix1 b2 x)
                                                     (append (','::(' '::[]))
                                                       (append
                                                         (arith_to_string
                                                           language_naming_conventions0
                                                           relax_adc_sbb_return_carry_to_bitwidth0
                                                           internal_private
                                                           prefix1 b1 y)
                                                         (append
                                                           (','::(' '::[]))
                                                           (append
                                                             (wrap_carry
                                                               (arith_to_string
                                                                 language_naming_conventions0
                                                                 relax_adc_sbb_return_carry_to_bitwidth0
                                                                 internal_private
                                                                 prefix1 a2
                                                                 cin))
                                                             (')'::[])))))))))
                                         | Coq24_Compilers.ToString.IR.TT ->
                                           append
                                             (special_name
                                               ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                               lg2s)
                                             (append ('('::[])
                                               (append
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                   e1) (')'::[]))))
                                      | Coq24_Compilers.ToString.IR.TT ->
                                        append
                                          (special_name
                                            ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                            lg2s)
                                          (append ('('::[])
                                            (append
                                              (arith_to_string
                                                language_naming_conventions0
                                                relax_adc_sbb_return_carry_to_bitwidth0
                                                internal_private prefix1
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Dereference ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))) c0
                               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                                 append
                                   (special_name
                                     ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                     lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[])))
                               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                                 append
                                   (special_name
                                     ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                     lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[])))
                               | Coq24_Compilers.ToString.IR.TT ->
                                 append
                                   (special_name
                                     ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                     lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Dereference ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))) v
                        | Coq24_Compilers.ToString.IR.Var (_, _) ->
                          append
                            (special_name
                              ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                              lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[])))
                        | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                          append
                            (special_name
                              ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                              lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[])))
                        | Coq24_Compilers.ToString.IR.TT ->
                          append
                            (special_name
                              ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                              lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[]))))
                     | Coq24_Compilers.ToString.IR.TT ->
                       append
                         (special_name
                           ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                           lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[]))))
                  | Coq24_Compilers.ToString.IR.TT ->
                    append
                      (special_name
                        ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                        lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[]))))
            else append
                   (special_name
                     ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                     lg2s)
                   (append ('('::[])
                     (append
                       (arith_to_string language_naming_conventions0
                         relax_adc_sbb_return_carry_to_bitwidth0
                         internal_private prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                       (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow lg2s ->
          (fun e1 ->
            let (func_name, wrap_carry) =
              if existsb (Coq_Z.eqb lg2s)
                   relax_adc_sbb_return_carry_to_bitwidth0
              then ((append
                      ('b'::('i'::('t'::('s'::('.'::('S'::('u'::('b'::[]))))))))
                      (Coq0_Z.to_string lg2s)), (fun c0 ->
                     append ('u'::('i'::('n'::('t'::[]))))
                       (append (Coq0_Z.to_string lg2s)
                         (append ('('::[]) (append c0 (')'::[]))))))
              else ((special_name
                      ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                      lg2s), (fun c0 -> c0))
            in
            if is_bits_standard_bitwidth lg2s
            then (match e1 with
                  | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                    append
                      (special_name
                        ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                        lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[])))
                  | Coq24_Compilers.ToString.IR.Var (_, _) ->
                    append
                      (special_name
                        ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                        lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[])))
                  | Coq24_Compilers.ToString.IR.Pair (_, _, a, b0) ->
                    (match a with
                     | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                       append
                         (special_name
                           ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                           lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[])))
                     | Coq24_Compilers.ToString.IR.Var (_, _) ->
                       append
                         (special_name
                           ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                           lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                             (')'::[])))
                     | Coq24_Compilers.ToString.IR.Pair (_, _, a0, b1) ->
                       (match a0 with
                        | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc0, v) ->
                          (match idc0 with
                           | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.List_nth _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Addr ->
                             (fun v0 ->
                               match b1 with
                               | Coq24_Compilers.ToString.IR.AppIdent (
                                   _, _, idc1, b) ->
                                 (match idc1 with
                                  | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.List_nth _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Addr ->
                                    (fun b2 ->
                                      match b0 with
                                      | Coq24_Compilers.ToString.IR.AppIdent (
                                          _, _, _, _) ->
                                        append
                                          (special_name
                                            ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                            lg2s)
                                          (append ('('::[])
                                            (append
                                              (arith_to_string
                                                language_naming_conventions0
                                                relax_adc_sbb_return_carry_to_bitwidth0
                                                internal_private prefix1
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                e1) (')'::[])))
                                      | Coq24_Compilers.ToString.IR.Var (
                                          _, _) ->
                                        append
                                          (special_name
                                            ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                            lg2s)
                                          (append ('('::[])
                                            (append
                                              (arith_to_string
                                                language_naming_conventions0
                                                relax_adc_sbb_return_carry_to_bitwidth0
                                                internal_private prefix1
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                e1) (')'::[])))
                                      | Coq24_Compilers.ToString.IR.Pair (
                                          _, b3, a1, y) ->
                                        (match a1 with
                                         | Coq24_Compilers.ToString.IR.AppIdent (
                                             _, _, _, _) ->
                                           append
                                             (special_name
                                               ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                               lg2s)
                                             (append ('('::[])
                                               (append
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                   e1) (')'::[])))
                                         | Coq24_Compilers.ToString.IR.Var (
                                             _, _) ->
                                           append
                                             (special_name
                                               ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                               lg2s)
                                             (append ('('::[])
                                               (append
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                   e1) (')'::[])))
                                         | Coq24_Compilers.ToString.IR.Pair (
                                             a2, b4, bin, x) ->
                                           append
                                             (append
                                               (arith_to_string
                                                 language_naming_conventions0
                                                 relax_adc_sbb_return_carry_to_bitwidth0
                                                 internal_private prefix1
                                                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                 Coq24_Compilers.ToString.IR.Coq_type.Z)
                                                 v0)
                                               (append (','::(' '::[]))
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)
                                                   b2)))
                                             (append (' '::('='::(' '::[])))
                                               (append func_name
                                                 (append ('('::[])
                                                   (append
                                                     (arith_to_string
                                                       language_naming_conventions0
                                                       relax_adc_sbb_return_carry_to_bitwidth0
                                                       internal_private
                                                       prefix1 b4 x)
                                                     (append (','::(' '::[]))
                                                       (append
                                                         (arith_to_string
                                                           language_naming_conventions0
                                                           relax_adc_sbb_return_carry_to_bitwidth0
                                                           internal_private
                                                           prefix1 b3 y)
                                                         (append
                                                           (','::(' '::[]))
                                                           (append
                                                             (wrap_carry
                                                               (arith_to_string
                                                                 language_naming_conventions0
                                                                 relax_adc_sbb_return_carry_to_bitwidth0
                                                                 internal_private
                                                                 prefix1 a2
                                                                 bin))
                                                             (')'::[])))))))))
                                         | Coq24_Compilers.ToString.IR.TT ->
                                           append
                                             (special_name
                                               ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                               lg2s)
                                             (append ('('::[])
                                               (append
                                                 (arith_to_string
                                                   language_naming_conventions0
                                                   relax_adc_sbb_return_carry_to_bitwidth0
                                                   internal_private prefix1
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                   ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                   Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                   e1) (')'::[]))))
                                      | Coq24_Compilers.ToString.IR.TT ->
                                        append
                                          (special_name
                                            ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                            lg2s)
                                          (append ('('::[])
                                            (append
                                              (arith_to_string
                                                language_naming_conventions0
                                                relax_adc_sbb_return_carry_to_bitwidth0
                                                internal_private prefix1
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Dereference ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))
                                  | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                                    (fun _ ->
                                      append
                                        (special_name
                                          ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                          lg2s)
                                        (append ('('::[])
                                          (append
                                            (arith_to_string
                                              language_naming_conventions0
                                              relax_adc_sbb_return_carry_to_bitwidth0
                                              internal_private prefix1
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                              ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                              Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                              e1) (')'::[]))))) b
                               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                                 append
                                   (special_name
                                     ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                     lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[])))
                               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                                 append
                                   (special_name
                                     ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                     lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[])))
                               | Coq24_Compilers.ToString.IR.TT ->
                                 append
                                   (special_name
                                     ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                     lg2s)
                                   (append ('('::[])
                                     (append
                                       (arith_to_string
                                         language_naming_conventions0
                                         relax_adc_sbb_return_carry_to_bitwidth0
                                         internal_private prefix1
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                         Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                         e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Dereference ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))
                           | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                             (fun _ ->
                               append
                                 (special_name
                                   ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                   lg2s)
                                 (append ('('::[])
                                   (append
                                     (arith_to_string
                                       language_naming_conventions0
                                       relax_adc_sbb_return_carry_to_bitwidth0
                                       internal_private prefix1
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                       ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                       Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                       e1) (')'::[]))))) v
                        | Coq24_Compilers.ToString.IR.Var (_, _) ->
                          append
                            (special_name
                              ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                              lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[])))
                        | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                          append
                            (special_name
                              ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                              lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[])))
                        | Coq24_Compilers.ToString.IR.TT ->
                          append
                            (special_name
                              ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                              lg2s)
                            (append ('('::[])
                              (append
                                (arith_to_string language_naming_conventions0
                                  relax_adc_sbb_return_carry_to_bitwidth0
                                  internal_private prefix1
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                  ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                  Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                  e1) (')'::[]))))
                     | Coq24_Compilers.ToString.IR.TT ->
                       append
                         (special_name
                           ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                           lg2s)
                         (append ('('::[])
                           (append
                             (arith_to_string language_naming_conventions0
                               relax_adc_sbb_return_carry_to_bitwidth0
                               internal_private prefix1
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                               ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z))),
                               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                               Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                               e1) (')'::[]))))
                  | Coq24_Compilers.ToString.IR.TT ->
                    append
                      (special_name
                        ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                        lg2s)
                      (append ('('::[])
                        (append
                          (arith_to_string language_naming_conventions0
                            relax_adc_sbb_return_carry_to_bitwidth0
                            internal_private prefix1
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))),
                            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                            Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                          (')'::[]))))
            else append
                   (special_name
                     ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                     lg2s)
                   (append ('('::[])
                     (append
                       (arith_to_string language_naming_conventions0
                         relax_adc_sbb_return_carry_to_bitwidth0
                         internal_private prefix1
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                         ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z))),
                         (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                         Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                       (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_zselect ty ->
          (fun e1 ->
            append
              (special_name_ty
                ('c'::('m'::('o'::('v'::('z'::('n'::('z'::[]))))))) ty)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    relax_adc_sbb_return_carry_to_bitwidth0 internal_private
                    prefix1 (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1)
                  (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_modulo ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Pair (_, _, a, _) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('a'::('d'::('d'::('m'::('o'::('d'::('u'::('l'::('o'::[])))))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_static_cast int_t ->
          (fun e1 ->
            append
              (primitive_type_to_string language_naming_conventions0
                internal_private prefix1
                Coq24_Compilers.ToString.IR.Coq_type.Z (Some int_t))
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    relax_adc_sbb_return_carry_to_bitwidth0 internal_private
                    prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))))
         e0
     | Coq24_Compilers.ToString.IR.Var (_, v) -> v
     | Coq24_Compilers.ToString.IR.Pair (a, b, a0, b0) ->
       append
         (arith_to_string language_naming_conventions0
           relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1 a
           a0)
         (append (','::(' '::[]))
           (arith_to_string language_naming_conventions0
             relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1
             b b0))
     | Coq24_Compilers.ToString.IR.TT ->
       'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('t'::('t'::[])))))))))))))))))))))

  (** val consider_retargs_live_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt **)

  let consider_retargs_live_opt_instance_0 _ _ = function
  | Coq24_Compilers.ToString.IR.Coq_literal _ -> true
  | Coq24_Compilers.ToString.IR.List_nth _ -> true
  | Coq24_Compilers.ToString.IR.Addr -> true
  | Coq24_Compilers.ToString.IR.Dereference -> true
  | Coq24_Compilers.ToString.IR.Coq_iunop _ -> true
  | Coq24_Compilers.ToString.IR.Coq_ibinop _ -> true
  | Coq24_Compilers.ToString.IR.Z_mul_split lg2s ->
    is_nonbits_special_bitwidth lg2s
  | Coq24_Compilers.ToString.IR.Z_add_with_get_carry lg2s ->
    is_nonbits_special_bitwidth lg2s
  | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow lg2s ->
    is_nonbits_special_bitwidth lg2s
  | Coq24_Compilers.ToString.IR.Z_zselect _ -> true
  | Coq24_Compilers.ToString.IR.Z_add_modulo -> true
  | Coq24_Compilers.ToString.IR.Z_static_cast _ -> true

  (** val rename_dead_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt **)

  let rename_dead_opt_instance_0 _ =
    '_'::[]

  (** val lift_declarations_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt **)

  let lift_declarations_opt_instance_0 =
    false

  (** val stmt_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt ->
      bool -> char list -> Coq24_Compilers.ToString.IR.stmt -> char list **)

  let stmt_to_string language_naming_conventions0 relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1 = function
  | Coq24_Compilers.ToString.IR.Call val0 ->
    arith_to_string language_naming_conventions0
      relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1
      Coq24_Compilers.ToString.IR.Coq_type.Coq_unit val0
  | Coq24_Compilers.ToString.IR.Comment (lines0, _) ->
    concat0 (newLine::[])
      (comment_block
        (Coq7_Compilers.ToString.preprocess_comment_block lines0))
  | Coq24_Compilers.ToString.IR.Assign (declare, t0, _, name0, val0) ->
    if declare
    then append name0
           (append (' '::(':'::('='::(' '::[]))))
             (arith_to_string language_naming_conventions0
               relax_adc_sbb_return_carry_to_bitwidth0 internal_private
               prefix1
               (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive t0)
               val0))
    else 'v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('t'::('r'::('y'::('i'::('n'::('g'::('_'::('t'::('o'::('_'::('a'::('s'::('s'::('i'::('g'::('n'::('_'::('v'::('a'::('l'::('u'::('e'::('_'::('t'::('o'::('_'::('n'::('o'::('n'::('_'::('m'::('u'::('t'::('a'::('b'::('l'::('e'::('_'::('v'::('a'::('r'::('i'::('a'::('b'::('l'::('e'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
  | Coq24_Compilers.ToString.IR.AssignZPtr (name0, _, val0) ->
    append ('*'::[])
      (append name0
        (append (' '::('='::(' '::[])))
          (arith_to_string language_naming_conventions0
            relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z) val0)))
  | Coq24_Compilers.ToString.IR.DeclareVar (t0, sz, name0) ->
    append ('v'::('a'::('r'::(' '::[]))))
      (append name0
        (append (' '::[])
          (primitive_type_to_string language_naming_conventions0
            internal_private prefix1 t0 sz)))
  | Coq24_Compilers.ToString.IR.AssignNth (name0, n3, val0) ->
    append name0
      (append ('['::[])
        (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
          (append (']'::(' '::('='::(' '::[]))))
            (arith_to_string language_naming_conventions0
              relax_adc_sbb_return_carry_to_bitwidth0 internal_private
              prefix1
              (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
              Coq24_Compilers.ToString.IR.Coq_type.Z) val0))))

  (** val to_strings :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_opt ->
      bool -> char list -> Coq24_Compilers.ToString.IR.expr -> char list list **)

  let to_strings language_naming_conventions0 relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1 e =
    map
      (stmt_to_string language_naming_conventions0
        relax_adc_sbb_return_carry_to_bitwidth0 internal_private prefix1) e

  type coq_Mode =
  | In
  | Out

  (** val to_base_arg_list :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      -> Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list **)

  let rec to_base_arg_list language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 mode = function
  | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
    (match t1 with
     | Coq3_Compilers.Z ->
       let typ =
         match mode with
         | In -> Coq24_Compilers.ToString.IR.Coq_type.Z
         | Out -> Coq24_Compilers.ToString.IR.Coq_type.Zptr
       in
       (fun pat ->
       let (p, typedef0) = Obj.magic pat in
       let (p0, r0) = p in
       let (n3, _) = p0 in
       (append n3
         (append (' '::[])
           (primitive_type_to_string_opt_typedef language_naming_conventions0
             skip_typedefs0 internal_private all_private prefix1 typ r0
             typedef0))) :: [])
     | Coq3_Compilers.Coq_bool ->
       (fun _ ->
         (append
           ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::[])))))))))))))))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: [])
     | Coq3_Compilers.Coq_nat ->
       (fun _ ->
         (append
           ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::[])))))))))))))))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: [])
     | Coq3_Compilers.Coq_zrange ->
       (fun _ ->
         (append
           ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::[])))))))))))))))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: [])
     | Coq3_Compilers.Coq_string ->
       (fun _ ->
         (append
           ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::[])))))))))))))))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: []))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun pat ->
      let (va, vb) = Obj.magic pat in
      app
        (to_base_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 mode a va)
        (to_base_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 mode b vb))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun pat ->
            let (p, typedef0) = Obj.magic pat in
            let (p0, len) = p in
            let (n3, r0) = p0 in
            (append n3
              (append (' '::('*'::[]))
                (primitive_array_type_to_string language_naming_conventions0
                  skip_typedefs0 internal_private all_private prefix1
                  Coq24_Compilers.ToString.IR.Coq_type.Z r0 len typedef0))) :: [])
        | Coq3_Compilers.Coq_bool ->
          (fun _ ->
            ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_nat ->
          (fun _ ->
            ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_zrange ->
          (fun _ ->
            ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_string ->
          (fun _ ->
            ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: []))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun _ ->
         ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun _ ->
         ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun _ ->
         ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (fun _ ->
         ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[]))))))))))))))))))))))))))))))) :: []))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    (fun _ ->
      ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('o'::('p'::('t'::('i'::('o'::('n'::[]))))))))))))))))))))))))) :: [])
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (fun _ ->
      ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('u'::('n'::('i'::('t'::[]))))))))))))))))))))))) :: [])

  (** val to_arg_list :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
      -> char list list **)

  let to_arg_list language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 mode = function
  | Compilers.Coq_type.Coq_base t1 ->
    to_base_arg_list language_naming_conventions0 skip_typedefs0
      internal_private all_private prefix1 mode t1
  | Compilers.Coq_type.Coq_arrow (_, _) ->
    (fun _ ->
      ('v'::('a'::('r'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('a'::('r'::('r'::('o'::('w'::[])))))))))))))))))))))))) :: [])

  (** val to_arg_list_for_each_lhs_of_arrow :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow -> char list list **)

  let rec to_arg_list_for_each_lhs_of_arrow language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ -> [])
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (fun pat ->
      let (x, xs) = Obj.magic pat in
      app
        (to_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 In s0 x)
        (to_arg_list_for_each_lhs_of_arrow language_naming_conventions0
          skip_typedefs0 internal_private all_private prefix1 d xs))

  (** val coq_Go_bin_op_natural_output :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type **)

  let coq_Go_bin_op_natural_output _ = function
  | (t1, t2) -> Coq7_Compilers.ToString.Coq_int.union t1 t2

  (** val bin_op_commutes_with_mod_pow2 :
      Coq24_Compilers.ToString.IR.coq_Z_binop -> bool **)

  let bin_op_commutes_with_mod_pow2 = function
  | Coq24_Compilers.ToString.IR.Z_land -> true
  | Coq24_Compilers.ToString.IR.Z_lor -> true
  | Coq24_Compilers.ToString.IR.Z_lxor -> true
  | Coq24_Compilers.ToString.IR.Z_add -> true
  | Coq24_Compilers.ToString.IR.Z_mul -> true
  | Coq24_Compilers.ToString.IR.Z_sub -> true

  (** val coq_Go_bin_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type
      option * (Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

  let coq_Go_bin_op_casts idc desired_type = function
  | (t1, t2) ->
    (match desired_type with
     | Some desired_type0 ->
       let ct = Coq7_Compilers.ToString.Coq_int.union t1 t2 in
       if bin_op_commutes_with_mod_pow2 idc
       then (None, ((Some desired_type0), (Some desired_type0)))
       else let desired_type' = Some
              (Coq7_Compilers.ToString.Coq_int.union ct desired_type0)
            in
            (desired_type',
            ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
               desired_type' (Some t1)),
            (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
              desired_type' (Some t2))))
     | None -> (None, (None, None)))

  (** val coq_Go_un_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_unop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      Coq7_Compilers.ToString.Coq_int.coq_type ->
      Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

  let coq_Go_un_op_casts idc desired_type t0 =
    match idc with
    | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
      let t' =
        Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0; upper =
          (Coq_Z.pow (Zpos (XO XH)) offset) } t0
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some t')),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed (Some t')
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
      let rpre_out =
        match desired_type with
        | Some rout ->
          Some
            (Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) }
              (Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of rout))
        | None ->
          Some
            (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) })
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type rpre_out),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed rpre_out
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_lnot ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))
    | Coq24_Compilers.ToString.IR.Z_bneg -> (None, None)
    | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))

  (** val coq_GoLanguageCasts :
      Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts **)

  let coq_GoLanguageCasts =
    { Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_natural_output =
      coq_Go_bin_op_natural_output;
      Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_casts = coq_Go_bin_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.un_op_casts = coq_Go_un_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_assignment = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_funcall = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.explicit_pointer_variables = false }

  (** val to_function_lines :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.output_options_opt -> bool -> bool -> bool ->
      bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
      -> char list list **)

  let to_function_lines language_naming_conventions0 output_options0 internal_private _ all_private _ prefix1 name0 t0 = function
  | (p, body) ->
    let (args0, rets) = p in
    (append ('f'::('u'::('n'::('c'::(' '::[])))))
      (append name0
        (append ('('::[])
          (append
            (concat0 (','::(' '::[]))
              (app
                (to_arg_list language_naming_conventions0
                  output_options0.Coq7_Compilers.Options.skip_typedefs_
                  internal_private all_private prefix1 Out
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_type.final_codomain t0)) rets)
                (to_arg_list_for_each_lhs_of_arrow
                  language_naming_conventions0
                  output_options0.Coq7_Compilers.Options.skip_typedefs_
                  internal_private all_private prefix1 t0 args0)))
            (')'::(' '::('{'::[]))))))) :: (app
                                             (map (fun s0 ->
                                               append (tab::[]) s0)
                                               (to_strings
                                                 language_naming_conventions0
                                                 output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_
                                                 internal_private prefix1
                                                 body)) (('}'::[]) :: []))

  (** val strip_special_infos :
      Coq7_Compilers.ToString.ident_infos ->
      Coq7_Compilers.ToString.ident_infos **)

  let strip_special_infos infos =
    Coq7_Compilers.ToString.ident_info_diff infos
      (fold_right Coq7_Compilers.ToString.ident_info_union
        Coq7_Compilers.ToString.ident_info_empty
        (flat_map (fun bw ->
          (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_infos_of_ident
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z),
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z)))))
            Coq24_Compilers.ToString.IR.Coq_type.Coq_unit
            (Coq24_Compilers.ToString.IR.Z_mul_split bw)) :: ((Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_infos_of_ident
                                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                                Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                                                                ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                                Coq24_Compilers.ToString.IR.Coq_type.Z),
                                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                                Coq24_Compilers.ToString.IR.Coq_type.Z))),
                                                                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                                                                Coq24_Compilers.ToString.IR.Coq_type.Z)))))
                                                                Coq24_Compilers.ToString.IR.Coq_type.Coq_unit
                                                                (Coq24_Compilers.ToString.IR.Z_add_with_get_carry
                                                                bw)) :: (
          (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_infos_of_ident
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Zptr),
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
            ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z),
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z))),
            (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z)))))
            Coq24_Compilers.ToString.IR.Coq_type.Coq_unit
            (Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow bw)) :: [])))
          bits_std_bitwidths))

  (** val coq_ToFunctionLines :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      Coq7_Compilers.Options.relax_zrange_opt ->
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool
      -> bool -> bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) ->
      char list list option -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
      list * Coq7_Compilers.ToString.ident_infos, char list) sum **)

  let coq_ToFunctionLines absint_opts0 relax_zrange language_naming_conventions0 _ output_options0 _ do_bounds_check internal_private private0 all_private inline0 prefix1 name0 t0 e comment0 name_list inbounds outbounds intypedefs outtypedefs =
    match Coq24_Compilers.ToString.IR.OfPHOAS.coq_ExprOfPHOAS
            coq_GoLanguageCasts relax_zrange
            consider_retargs_live_opt_instance_0 rename_dead_opt_instance_0
            lift_declarations_opt_instance_0
            output_options0.Coq7_Compilers.Options.language_specific_cast_adjustment_
            absint_opts0
            output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_
            do_bounds_check t0 e name_list inbounds intypedefs outtypedefs with
    | Inl p ->
      let (p0, f) = p in
      let (indata, outdata) = p0 in
      Inl
      ((app
         (comment_block
           (app (comment0 indata outdata)
             (app
               (match Coq7_Compilers.ToString.OfPHOAS.input_bounds_to_string
                        output_options0.Coq7_Compilers.Options.skip_typedefs_
                        t0 indata inbounds with
                | [] -> []
                | s0 :: l ->
                  app
                    (('I'::('n'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[]))))))))))))) :: [])
                    (map (fun v -> append (' '::(' '::[])) v) (s0 :: l)))
               (match Coq7_Compilers.ToString.OfPHOAS.bound_to_string
                        output_options0.Coq7_Compilers.Options.skip_typedefs_
                        (Compilers.Coq_type.final_codomain t0) outdata
                        outbounds with
                | [] -> []
                | s0 :: l ->
                  app
                    (('O'::('u'::('t'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[])))))))))))))) :: [])
                    (map (fun v -> append (' '::(' '::[])) v) (s0 :: l))))))
         (to_function_lines language_naming_conventions0 output_options0
           internal_private private0 all_private inline0 prefix1 name0 t0
           ((indata, outdata), f))),
      (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_all_infos
        output_options0.Coq7_Compilers.Options.skip_typedefs_ f t0 intypedefs
        outtypedefs))
    | Inr errs ->
      (match errs with
       | [] ->
         Inr
           (append
             ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))))))))))))))))))
             (append name0 (' '::('t'::('o'::(' '::('G'::('o'::[]))))))))
       | err0 :: l ->
         (match l with
          | [] ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))))))))
                (append name0
                  (append (' '::('t'::('o'::(' '::('G'::('o'::(':'::[])))))))
                    (append (newLine::[]) err0))))
          | _ :: _ ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::('s'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))
                (append name0
                  (append (' '::('t'::('o'::(' '::('G'::('o'::(':'::[])))))))
                    (append (newLine::[]) (concat0 (newLine::[]) errs)))))))

  (** val coq_OutputGoAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

  let coq_OutputGoAPI =
    { Coq7_Compilers.ToString.comment_block = comment_block;
      Coq7_Compilers.ToString.comment_file_header_block =
      comment_block_extra_newlines;
      Coq7_Compilers.ToString.coq_ToFunctionLines = coq_ToFunctionLines;
      Coq7_Compilers.ToString.header = header;
      Coq7_Compilers.ToString.footer = (fun _ _ _ _ _ _ _ _ _ -> []);
      Coq7_Compilers.ToString.strip_special_infos = (fun _ ->
      strip_special_infos) }
 end

module Java =
 struct
  (** val comment_block : char list list -> char list list **)

  let comment_block =
    map (fun line0 ->
      append ('/'::('*'::(' '::[]))) (append line0 (' '::('*'::('/'::[])))))

  (** val header :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.package_name_opt ->
      Coq7_Compilers.Options.class_name_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
      char list -> Coq7_Compilers.ToString.ident_infos ->
      (((char list * (char list ->
      char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list
      -> char list list **)

  let header language_naming_conventions0 _ package_namev0 class_namev0 _ _ _ _ prefix1 _ _ =
    [] :: ((append ('p'::('a'::('c'::('k'::('a'::('g'::('e'::(' '::[]))))))))
             (append
               (Coq7_Compilers.Options.package_name package_namev0
                 language_naming_conventions0 prefix1) (';'::[]))) :: ([] :: (
      (append
        ('p'::('u'::('b'::('l'::('i'::('c'::(' '::('f'::('i'::('n'::('a'::('l'::(' '::('c'::('l'::('a'::('s'::('s'::(' '::[])))))))))))))))))))
        (append
          (Coq7_Compilers.Options.class_name class_namev0
            language_naming_conventions0 prefix1) (' '::('{'::[])))) :: ([] :: (('s'::('t'::('a'::('t'::('i'::('c'::(' '::('c'::('l'::('a'::('s'::('s'::(' '::('B'::('o'::('x'::('<'::('T'::('>'::(' '::('{'::[]))))))))))))))))))))) :: ((' '::(' '::('p'::('r'::('i'::('v'::('a'::('t'::('e'::(' '::('T'::(' '::('v'::('a'::('l'::('u'::('e'::(';'::[])))))))))))))))))) :: ((' '::(' '::('p'::('u'::('b'::('l'::('i'::('c'::(' '::('B'::('o'::('x'::('('::('T'::(' '::('v'::('a'::('l'::('u'::('e'::(')'::(' '::('{'::(' '::('t'::('h'::('i'::('s'::('.'::('v'::('a'::('l'::('u'::('e'::(' '::('='::(' '::('v'::('a'::('l'::('u'::('e'::(';'::(' '::('}'::[]))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('p'::('u'::('b'::('l'::('i'::('c'::(' '::('v'::('o'::('i'::('d'::(' '::('s'::('e'::('t'::('('::('T'::(' '::('v'::('a'::('l'::('u'::('e'::(')'::(' '::('{'::(' '::('t'::('h'::('i'::('s'::('.'::('v'::('a'::('l'::('u'::('e'::(' '::('='::(' '::('v'::('a'::('l'::('u'::('e'::(';'::(' '::('}'::[])))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('p'::('u'::('b'::('l'::('i'::('c'::(' '::('T'::(' '::('g'::('e'::('t'::('('::(')'::(' '::('{'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('t'::('h'::('i'::('s'::('.'::('v'::('a'::('l'::('u'::('e'::(';'::(' '::('}'::[]))))))))))))))))))))))))))))))))))))))) :: (('}'::[]) :: ([] :: ([] :: []))))))))))))

  (** val footer :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.package_name_opt ->
      Coq7_Compilers.Options.class_name_opt -> z -> bool -> bool -> char list
      -> Coq7_Compilers.ToString.ident_infos -> char list list **)

  let footer _ _ _ _ _ _ _ _ _ =
    ('}'::[]) :: []

  (** val int_type_to_string :
      bool -> char list -> Coq7_Compilers.ToString.Coq_int.coq_type ->
      char list **)

  let int_type_to_string use_class prefix1 t0 =
    let bw = Coq7_Compilers.ToString.Coq_int.bitwidth_of t0 in
    if Coq_Z.eqb bw (Zpos XH)
    then if use_class
         then 'I'::('n'::('t'::('e'::('g'::('e'::('r'::[]))))))
         else 'i'::('n'::('t'::[]))
    else if Coq_Z.eqb bw (Zpos (XO (XO (XO XH))))
         then if use_class
              then 'B'::('y'::('t'::('e'::[])))
              else 'b'::('y'::('t'::('e'::[])))
         else if Coq_Z.eqb bw (Zpos (XO (XO (XO (XO XH)))))
              then if use_class
                   then 'S'::('h'::('o'::('r'::('t'::[]))))
                   else 's'::('h'::('o'::('r'::('t'::[]))))
              else if Coq_Z.eqb bw (Zpos (XO (XO (XO (XO (XO XH))))))
                   then if use_class
                        then 'I'::('n'::('t'::('e'::('g'::('e'::('r'::[]))))))
                        else 'i'::('n'::('t'::[]))
                   else if Coq_Z.eqb bw (Zpos (XO (XO (XO (XO (XO (XO
                             XH)))))))
                        then if use_class
                             then 'L'::('o'::('n'::('g'::[])))
                             else 'l'::('o'::('n'::('g'::[])))
                        else append prefix1
                               (append
                                 (if Coq7_Compilers.ToString.Coq_int.is_unsigned
                                       t0
                                  then 'u'::('i'::('n'::('t'::[])))
                                  else 'i'::('n'::('t'::[])))
                                 (Coq0_Z.to_string
                                   (Coq7_Compilers.ToString.Coq_int.bitwidth_of
                                     t0)))

  (** val primitive_type_to_string :
      bool -> char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list **)

  let primitive_type_to_string use_class prefix1 t0 r0 =
    (match t0 with
     | Coq24_Compilers.ToString.IR.Coq_type.Z -> (fun t1 -> t1 use_class)
     | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
       (fun t1 ->
         append ('B'::('o'::('x'::('<'::[])))) (append (t1 true) ('>'::[]))))
      (fun use_class0 ->
      match r0 with
      | Some int_t -> int_type_to_string use_class0 prefix1 int_t
      | None -> '\226'::('\132'::('\164'::[])))

  (** val int_literal_to_string :
      char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
      char list **)

  let int_literal_to_string _ t0 v =
    match t0 with
    | Coq24_Compilers.ToString.IR.Coq_type.Z ->
      append (of_Z v)
        (if Coq_Z.gtb
              (Coq7_Compilers.ToString.Coq_int.bitwidth_of
                (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower =
                  v; upper = v })) (Zpos (XO (XO (XO (XO (XO XH))))))
         then 'L'::[]
         else [])
    | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
      append
        ('e'::('r'::('r'::('o'::('r'::('_'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::('_'::('a'::('d'::('d'::('r'::('e'::('s'::('s'::('_'::[]))))))))))))))))))))))
        (of_Z v)

  (** val arith_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
      Coq24_Compilers.ToString.IR.arith_expr -> char list **)

  let rec arith_to_string language_naming_conventions0 internal_private prefix1 _ e =
    let special_name_ty = fun name0 ty ->
      Coq7_Compilers.ToString.format_special_function_name_ty
        language_naming_conventions0 internal_private prefix1 name0 ty
    in
    let special_name = fun name0 bw ->
      Coq7_Compilers.ToString.format_special_function_name
        language_naming_conventions0 internal_private prefix1 name0 false bw
    in
    (match e with
     | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc, e0) ->
       (match idc with
        | Coq24_Compilers.ToString.IR.Coq_literal v ->
          (fun _ ->
            int_literal_to_string prefix1
              Coq24_Compilers.ToString.IR.Coq_type.Z v)
        | Coq24_Compilers.ToString.IR.List_nth n3 ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              append ('('::[])
                (append v
                  (append ('['::[])
                    (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
                      (']'::(')'::[])))))
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Addr ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              append
                ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('a'::('n'::('n'::('o'::('t'::('_'::('t'::('a'::('k'::('e'::('_'::('r'::('e'::('f'::('e'::('r'::('e'::('n'::('c'::('e'::('_'::('i'::('n'::('_'::('J'::('a'::('v'::('a'::('_'::('t'::('o'::('_'::[])))))))))))))))))))))))))))))))))))))))
                v
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Dereference ->
          (fun e1 ->
            append ('('::[])
              (append
                (arith_to_string language_naming_conventions0
                  internal_private prefix1
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Zptr) e1)
                (')'::('.'::('g'::('e'::('t'::('('::(')'::[])))))))))
        | Coq24_Compilers.ToString.IR.Coq_iunop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('>'::('>'::('>'::(' '::[])))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('<'::('<'::(' '::[]))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_lnot _ ->
             (fun e1 ->
               append ('('::('~'::[]))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_bneg ->
             (fun e1 ->
               append
                 ('('::('!'::('/'::('*'::(' '::('T'::('O'::('D'::('O'::(':'::(' '::('F'::('I'::('X'::(' '::('M'::('E'::(' '::('*'::('/'::(' '::[])))))))))))))))))))))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
             (fun e1 ->
               append
                 (special_name_ty
                   ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))
                   ty)
                 (append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1
                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                       Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))))
        | Coq24_Compilers.ToString.IR.Coq_ibinop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_land ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('&'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('|'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lxor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('^'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_add ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('+'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_mul ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('*'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_sub ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('-'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_mul_split lg2s ->
          (fun e1 ->
            append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_with_get_carry lg2s ->
          (fun e1 ->
            append
              (special_name
                ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow lg2s ->
          (fun e1 ->
            append
              (special_name
                ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_zselect ty ->
          (fun e1 ->
            append
              (special_name_ty
                ('c'::('m'::('o'::('v'::('z'::('n'::('z'::[])))))))
                (Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of ty))
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_modulo ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Pair (_, _, a, _) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('a'::('d'::('d'::('m'::('o'::('d'::('u'::('l'::('o'::[])))))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.TT ->
                 'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              'i'::('n'::('t'::(' '::('_'::('e'::('r'::('r'::('o'::('r'::(' '::('='::(' '::('e'::('r'::('r'::('o'::('r'::('_'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_static_cast int_t ->
          (fun e1 ->
            append ('('::[])
              (append
                (primitive_type_to_string false prefix1
                  Coq24_Compilers.ToString.IR.Coq_type.Z (Some int_t))
                (append
                  (')'::(' '::('I'::('n'::('t'::('e'::('g'::('e'::('r'::('.'::('t'::('o'::('U'::('n'::('s'::('i'::('g'::('n'::('e'::('d'::('L'::('o'::('n'::('g'::('('::('('::('('::('N'::('u'::('m'::('b'::('e'::('r'::(')'::(' '::('('::[]))))))))))))))))))))))))))))))))))))
                  (append
                    (arith_to_string language_naming_conventions0
                      internal_private prefix1
                      (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                      Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                    (')'::(')'::('.'::('i'::('n'::('t'::('V'::('a'::('l'::('u'::('e'::('('::(')'::(')'::[])))))))))))))))))))
         e0
     | Coq24_Compilers.ToString.IR.Var (_, v) -> v
     | Coq24_Compilers.ToString.IR.Pair (a, b, a0, b0) ->
       append
         (arith_to_string language_naming_conventions0 internal_private
           prefix1 a a0)
         (append (','::(' '::[]))
           (arith_to_string language_naming_conventions0 internal_private
             prefix1 b b0))
     | Coq24_Compilers.ToString.IR.TT ->
       'e'::('r'::('r'::('o'::('r'::('_'::('t'::('t'::[]))))))))

  (** val consider_retargs_live_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt **)

  let consider_retargs_live_opt_instance_0 _ _ _ =
    true

  (** val rename_dead_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt **)

  let rename_dead_opt_instance_0 s0 =
    s0

  (** val lift_declarations_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt **)

  let lift_declarations_opt_instance_0 =
    false

  (** val stmt_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.stmt -> char list **)

  let stmt_to_string language_naming_conventions0 internal_private prefix1 = function
  | Coq24_Compilers.ToString.IR.Call val0 ->
    append
      (arith_to_string language_naming_conventions0 internal_private prefix1
        Coq24_Compilers.ToString.IR.Coq_type.Coq_unit val0) (';'::[])
  | Coq24_Compilers.ToString.IR.Comment (lines0, _) ->
    concat0 (newLine::[])
      (comment_block
        (Coq7_Compilers.ToString.preprocess_comment_block lines0))
  | Coq24_Compilers.ToString.IR.Assign (declare, t0, sz, name0, val0) ->
    if declare
    then append (primitive_type_to_string false prefix1 t0 sz)
           (append (' '::[])
             (append name0
               (append (' '::('='::(' '::[])))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     t0) val0) (';'::[])))))
    else 'e'::('r'::('r'::('o'::('r'::('_'::('t'::('r'::('y'::('i'::('n'::('g'::('_'::('t'::('o'::('_'::('a'::('s'::('s'::('i'::('g'::('n'::('_'::('v'::('a'::('l'::('u'::('e'::('_'::('t'::('o'::('_'::('n'::('o'::('n'::('_'::('m'::('u'::('t'::('a'::('b'::('l'::('e'::('_'::('v'::('a'::('r'::('i'::('a'::('b'::('l'::('e'::(';'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))
  | Coq24_Compilers.ToString.IR.AssignZPtr (name0, _, val0) ->
    append name0
      (append ('.'::('s'::('e'::('t'::('('::[])))))
        (append
          (arith_to_string language_naming_conventions0 internal_private
            prefix1 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (')'::(';'::[]))))
  | Coq24_Compilers.ToString.IR.DeclareVar (_, sz, name0) ->
    append
      (primitive_type_to_string true prefix1
        Coq24_Compilers.ToString.IR.Coq_type.Zptr sz)
      (append (' '::[])
        (append name0
          (append (' '::('='::(' '::('n'::('e'::('w'::(' '::[])))))))
            (append
              (primitive_type_to_string true prefix1
                Coq24_Compilers.ToString.IR.Coq_type.Zptr sz)
              (append ('('::('('::[]))
                (append
                  (primitive_type_to_string false prefix1
                    Coq24_Compilers.ToString.IR.Coq_type.Z sz)
                  (')'::('0'::(')'::(';'::[]))))))))))
  | Coq24_Compilers.ToString.IR.AssignNth (name0, n3, val0) ->
    append name0
      (append ('['::[])
        (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
          (append (']'::(' '::('='::(' '::[]))))
            (append
              (arith_to_string language_naming_conventions0 internal_private
                prefix1
                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (';'::[])))))

  (** val to_strings :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.expr -> char list list **)

  let to_strings language_naming_conventions0 internal_private prefix1 e =
    map
      (stmt_to_string language_naming_conventions0 internal_private prefix1) e

  type coq_Mode =
  | In
  | Out

  (** val to_base_arg_list :
      char list -> coq_Mode -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type ->
      Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list **)

  let rec to_base_arg_list prefix1 mode = function
  | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
    (match t1 with
     | Coq3_Compilers.Z ->
       let typ =
         match mode with
         | In -> Coq24_Compilers.ToString.IR.Coq_type.Z
         | Out -> Coq24_Compilers.ToString.IR.Coq_type.Zptr
       in
       (fun pat ->
       let (p, _) = Obj.magic pat in
       let (p0, r0) = p in
       let (n3, _) = p0 in
       (append (primitive_type_to_string false prefix1 typ r0)
         (append (' '::[]) n3)) :: [])
     | Coq3_Compilers.Coq_bool ->
       (fun _ ->
         (append ('e'::('r'::('r'::('o'::('r'::('_'::[]))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: [])
     | Coq3_Compilers.Coq_nat ->
       (fun _ ->
         (append ('e'::('r'::('r'::('o'::('r'::('_'::[]))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: [])
     | Coq3_Compilers.Coq_zrange ->
       (fun _ ->
         (append ('e'::('r'::('r'::('o'::('r'::('_'::[]))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: [])
     | Coq3_Compilers.Coq_string ->
       (fun _ ->
         (append ('e'::('r'::('r'::('o'::('r'::('_'::[]))))))
           (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
             t1)) :: []))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun pat ->
      let (va, vb) = Obj.magic pat in
      app (to_base_arg_list prefix1 mode a va)
        (to_base_arg_list prefix1 mode b vb))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun pat ->
            let (p, _) = Obj.magic pat in
            let (p0, _) = p in
            let (n3, r0) = p0 in
            (match mode with
             | In ->
               (append
                 (append ('f'::('i'::('n'::('a'::('l'::(' '::[]))))))
                   (primitive_type_to_string false prefix1
                     Coq24_Compilers.ToString.IR.Coq_type.Z r0))
                 (append ('['::(']'::(' '::[]))) n3)) :: []
             | Out ->
               (append
                 (primitive_type_to_string false prefix1
                   Coq24_Compilers.ToString.IR.Coq_type.Z r0)
                 (append ('['::(']'::(' '::[]))) n3)) :: []))
        | Coq3_Compilers.Coq_bool ->
          (fun _ ->
            ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_nat ->
          (fun _ ->
            ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_zrange ->
          (fun _ ->
            ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_string ->
          (fun _ ->
            ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: []))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun _ ->
         ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun _ ->
         ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun _ ->
         ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (fun _ ->
         ('e'::('r'::('r'::('o'::('r'::('_'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::('_'::('l'::('i'::('s'::('t'::[])))))))))))))))))) :: []))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    (fun _ ->
      ('e'::('r'::('r'::('o'::('r'::('_'::('o'::('p'::('t'::('i'::('o'::('n'::[])))))))))))) :: [])
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (fun _ ->
      ('e'::('r'::('r'::('o'::('r'::('_'::('u'::('n'::('i'::('t'::[])))))))))) :: [])

  (** val to_arg_list :
      char list -> coq_Mode -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list **)

  let to_arg_list prefix1 mode = function
  | Compilers.Coq_type.Coq_base t1 -> to_base_arg_list prefix1 mode t1
  | Compilers.Coq_type.Coq_arrow (_, _) ->
    (fun _ ->
      ('e'::('r'::('r'::('o'::('r'::('_'::('a'::('r'::('r'::('o'::('w'::[]))))))))))) :: [])

  (** val to_arg_list_for_each_lhs_of_arrow :
      char list -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow -> char list list **)

  let rec to_arg_list_for_each_lhs_of_arrow prefix1 = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ -> [])
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (fun pat ->
      let (x, xs) = Obj.magic pat in
      app (to_arg_list prefix1 In s0 x)
        (to_arg_list_for_each_lhs_of_arrow prefix1 d xs))

  (** val coq_Java_bin_op_natural_output :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type **)

  let coq_Java_bin_op_natural_output _ = function
  | (t1, t2) -> Coq7_Compilers.ToString.Coq_int.union t1 t2

  (** val bin_op_commutes_with_mod_pow2 :
      Coq24_Compilers.ToString.IR.coq_Z_binop -> bool **)

  let bin_op_commutes_with_mod_pow2 = function
  | Coq24_Compilers.ToString.IR.Z_land -> true
  | Coq24_Compilers.ToString.IR.Z_lor -> true
  | Coq24_Compilers.ToString.IR.Z_lxor -> true
  | Coq24_Compilers.ToString.IR.Z_add -> true
  | Coq24_Compilers.ToString.IR.Z_mul -> true
  | Coq24_Compilers.ToString.IR.Z_sub -> true

  (** val coq_Java_bin_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type
      option * (Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

  let coq_Java_bin_op_casts idc desired_type = function
  | (t1, t2) ->
    (match desired_type with
     | Some desired_type0 ->
       let ct = Coq7_Compilers.ToString.Coq_int.union t1 t2 in
       if bin_op_commutes_with_mod_pow2 idc
       then (None, ((Some desired_type0), (Some desired_type0)))
       else let desired_type' = Some
              (Coq7_Compilers.ToString.Coq_int.union ct desired_type0)
            in
            (desired_type',
            ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
               desired_type' (Some t1)),
            (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
              desired_type' (Some t2))))
     | None -> (None, (None, None)))

  (** val coq_Java_un_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_unop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      Coq7_Compilers.ToString.Coq_int.coq_type ->
      Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

  let coq_Java_un_op_casts idc desired_type t0 =
    match idc with
    | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
      let t' =
        Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0; upper =
          (Coq_Z.pow (Zpos (XO XH)) offset) } t0
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some t')),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed (Some t')
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
      let rpre_out =
        match desired_type with
        | Some rout ->
          Some
            (Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) }
              (Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of rout))
        | None ->
          Some
            (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) })
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type rpre_out),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed rpre_out
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_lnot ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))
    | Coq24_Compilers.ToString.IR.Z_bneg -> (None, None)
    | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))

  (** val coq_JavaLanguageCasts :
      Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts **)

  let coq_JavaLanguageCasts =
    { Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_natural_output =
      coq_Java_bin_op_natural_output;
      Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_casts =
      coq_Java_bin_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.un_op_casts = coq_Java_un_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_assignment = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_funcall = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.explicit_pointer_variables = true }

  (** val to_function_lines :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool -> bool
      -> bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
      -> char list list **)

  let to_function_lines language_naming_conventions0 internal_private internal _ prefix1 name0 t0 = function
  | (p, body) ->
    let (args0, rets) = p in
    (append
      (append
        (if internal
         then []
         else 'p'::('u'::('b'::('l'::('i'::('c'::(' '::[])))))))
        (append
          ('s'::('t'::('a'::('t'::('i'::('c'::(' '::('v'::('o'::('i'::('d'::(' '::[]))))))))))))
          name0))
      (append ('('::[])
        (append
          (concat0 (','::(' '::[]))
            (app
              (to_arg_list prefix1 Out (Compilers.Coq_type.Coq_base
                (Compilers.Coq_type.final_codomain t0)) rets)
              (to_arg_list_for_each_lhs_of_arrow prefix1 t0 args0)))
          (')'::(' '::('{'::[])))))) :: (app
                                          (map (fun s0 ->
                                            append (' '::(' '::[])) s0)
                                            (to_strings
                                              language_naming_conventions0
                                              internal_private prefix1 body))
                                          (('}'::[]) :: []))

  (** val javadoc_replace : char list -> char list **)

  let javadoc_replace s0 =
    replace ('<'::[]) ('&'::('l'::('t'::(';'::[]))))
      (replace ('>'::[]) ('&'::('g'::('t'::(';'::[])))) s0)

  (** val javadoc_format : char list list -> char list list **)

  let javadoc_format ls =
    app (('/'::('*'::('*'::[]))) :: [])
      (app (map (fun s0 -> append s0 (' '::('<'::('p'::('>'::[]))))) ls)
        ((' '::('*'::('/'::[]))) :: []))

  (** val coq_ToFunctionLines :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      Coq7_Compilers.Options.relax_zrange_opt ->
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool
      -> bool -> bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) ->
      char list list option -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
      list * Coq7_Compilers.ToString.ident_infos, char list) sum **)

  let coq_ToFunctionLines absint_opts0 relax_zrange language_naming_conventions0 _ output_options0 _ do_bounds_check internal_private internal _ inline0 prefix1 name0 t0 e comment0 name_list inbounds outbounds intypedefs outtypedefs =
    match Coq24_Compilers.ToString.IR.OfPHOAS.coq_ExprOfPHOAS
            coq_JavaLanguageCasts relax_zrange
            consider_retargs_live_opt_instance_0 rename_dead_opt_instance_0
            lift_declarations_opt_instance_0
            output_options0.Coq7_Compilers.Options.language_specific_cast_adjustment_
            absint_opts0
            output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_
            do_bounds_check t0 e name_list inbounds intypedefs outtypedefs with
    | Inl p ->
      let (p0, f) = p in
      let (indata, outdata) = p0 in
      Inl
      ((app
         (javadoc_format
           (app
             (map (fun s0 ->
               if Nat.eqb (length0 s0) O
               then ' '::('*'::[])
               else append (' '::('*'::(' '::[]))) (javadoc_replace s0))
               (comment0 indata outdata))
             (app
               (match Coq7_Compilers.ToString.OfPHOAS.input_bounds_to_string
                        output_options0.Coq7_Compilers.Options.skip_typedefs_
                        t0 indata inbounds with
                | [] -> []
                | s0 :: l ->
                  app
                    ((' '::('*'::(' '::('I'::('n'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[])))))))))))))))) :: [])
                    (map (fun v ->
                      append (' '::('*'::(' '::(' '::(' '::[])))))
                        (javadoc_replace v)) (s0 :: l)))
               (match Coq7_Compilers.ToString.OfPHOAS.bound_to_string
                        output_options0.Coq7_Compilers.Options.skip_typedefs_
                        (Compilers.Coq_type.final_codomain t0) outdata
                        outbounds with
                | [] -> []
                | s0 :: l ->
                  app
                    ((' '::('*'::(' '::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[]))))))))))))))))) :: [])
                    (map (fun v ->
                      append (' '::('*'::(' '::(' '::(' '::[])))))
                        (javadoc_replace v)) (s0 :: l))))))
         (to_function_lines language_naming_conventions0 internal_private
           internal inline0 prefix1 name0 t0 ((indata, outdata), f))),
      (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_all_infos
        output_options0.Coq7_Compilers.Options.skip_typedefs_ f t0 intypedefs
        outtypedefs))
    | Inr errs ->
      (match errs with
       | [] ->
         Inr
           (append
             ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))))))))))))))))))
             (append name0
               (' '::('t'::('o'::(' '::('J'::('a'::('v'::('a'::[]))))))))))
       | err0 :: l ->
         (match l with
          | [] ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('J'::('a'::('v'::('a'::(':'::[])))))))))
                    (append (newLine::[]) err0))))
          | _ :: _ ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::('s'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('J'::('a'::('v'::('a'::(':'::[])))))))))
                    (append (newLine::[]) (concat0 (newLine::[]) errs)))))))

  (** val coq_OutputJavaAPI :
      Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

  let coq_OutputJavaAPI =
    { Coq7_Compilers.ToString.comment_block = comment_block;
      Coq7_Compilers.ToString.comment_file_header_block = comment_block;
      Coq7_Compilers.ToString.coq_ToFunctionLines = coq_ToFunctionLines;
      Coq7_Compilers.ToString.header = header;
      Coq7_Compilers.ToString.footer = footer;
      Coq7_Compilers.ToString.strip_special_infos = (fun _ infos -> infos) }
 end

module JSON =
 struct
  (** val indent : char list -> char list list -> char list list **)

  let indent indent0 =
    map (fun s0 -> append indent0 s0)

  (** val int_bitwidth_to_string : bool -> z -> char list **)

  let int_bitwidth_to_string signed1 bitwidth =
    append (if signed1 then 'i'::[] else 'u'::[]) (Coq0_Z.to_string bitwidth)

  (** val int_type_to_string :
      Coq7_Compilers.ToString.Coq_int.coq_type -> char list **)

  let int_type_to_string t0 =
    int_bitwidth_to_string (Coq7_Compilers.ToString.Coq_int.is_signed t0)
      (Coq7_Compilers.ToString.Coq_int.bitwidth_of t0)

  (** val primitive_type_to_string :
      Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list **)

  let primitive_type_to_string t0 r0 =
    append
      (match t0 with
       | Coq24_Compilers.ToString.IR.Coq_type.Z -> []
       | Coq24_Compilers.ToString.IR.Coq_type.Zptr -> '*'::[])
      (match r0 with
       | Some int_t -> int_type_to_string int_t
       | None -> '('::('a'::('u'::('t'::('o'::(')'::[]))))))

  (** val int_literal_to_string :
      Coq24_Compilers.ToString.IR.Coq_type.primitive -> z -> char list **)

  let int_literal_to_string t0 v =
    match t0 with
    | Coq24_Compilers.ToString.IR.Coq_type.Z -> of_Z v
    | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
      append
        ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('a'::('d'::('d'::('r'::('e'::('s'::('s'::(' '::[]))))))))))))))))))))))))
        (append (of_Z v) ('"'::(';'::[])))

  type op_data = { datatype : char list; name : char list list;
                   operation : char list;
                   parameters : (char list * char list) list;
                   arguments : char list list list }

  (** val datatype : op_data -> char list **)

  let datatype o =
    o.datatype

  (** val name : op_data -> char list list **)

  let name o =
    o.name

  (** val operation : op_data -> char list **)

  let operation o =
    o.operation

  (** val parameters : op_data -> (char list * char list) list **)

  let parameters o =
    o.parameters

  (** val arguments : op_data -> char list list list **)

  let arguments o =
    o.arguments

  (** val comma_concat : char list list list -> char list list **)

  let comma_concat ls =
    let ret1 =
      flat_map (fun s0 ->
        match s0 with
        | [] -> []
        | _ :: _ -> app s0 ((','::[]) :: [])) ls
    in
    firstn (sub (length ret1) (S O)) ret1

  (** val op_data_to_JSON : op_data -> char list list **)

  let op_data_to_JSON v =
    app
      (('{'::[]) :: ((append
                       (' '::('"'::('d'::('a'::('t'::('a'::('t'::('y'::('p'::('e'::('"'::(':'::(' '::('"'::[]))))))))))))))
                       (append v.datatype ('"'::(','::[])))) :: ((append
                                                                   (' '::('"'::('n'::('a'::('m'::('e'::('"'::(':'::(' '::('['::[]))))))))))
                                                                   (append
                                                                    (concat0
                                                                    (','::(' '::[]))
                                                                    (map
                                                                    (fun n3 ->
                                                                    append
                                                                    ('"'::[])
                                                                    (append
                                                                    n3
                                                                    ('"'::[])))
                                                                    v.name))
                                                                    (']'::(','::[])))) :: (
      (append
        (' '::('"'::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('"'::(':'::(' '::('"'::[])))))))))))))))
        (append v.operation ('"'::(','::[])))) :: []))))
      (app
        (match v.parameters with
         | [] -> []
         | _ :: _ ->
           (append
             (' '::('"'::('p'::('a'::('r'::('a'::('m'::('e'::('t'::('e'::('r'::('s'::('"'::(':'::(' '::('{'::[]))))))))))))))))
             (append
               (concat0 (','::(' '::[]))
                 (map (fun pat ->
                   let (n3, val0) = pat in
                   append ('"'::[])
                     (append n3 (append ('"'::(':'::(' '::[]))) val0)))
                   v.parameters)) ('}'::(','::[])))) :: [])
        (app
          ((' '::('"'::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::('"'::(':'::(' '::('['::[]))))))))))))))) :: [])
          (app (indent (' '::(' '::[])) (comma_concat v.arguments))
            ((' '::(']'::[])) :: (('}'::[]) :: [])))))

  (** val arith_to_string :
      char list list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      Coq24_Compilers.ToString.IR.arith_expr -> char list list list **)

  let rec arith_to_string outargs _ sz e =
    let handle_op = fun sz0 op1 params outargs0 inargs ->
      (op_data_to_JSON { datatype =
        (match sz0 with
         | Some ty -> int_type_to_string ty
         | None -> '('::('a'::('u'::('t'::('o'::(')'::[])))))); name =
        outargs0; operation = op1; parameters = params; arguments = inargs }) :: []
    in
    let handle_op_size = fun lg2s op1 outargs0 inargs ->
      handle_op sz op1 ((('s'::('i'::('z'::('e'::[])))),
        (Decimal.show_Z lg2s)) :: []) outargs0 inargs
    in
    let handle_op1 = fun op1 t0 inargs ->
      handle_op sz op1 [] outargs (arith_to_string [] t0 sz inargs)
    in
    let wrap_value = fun res ->
      match outargs with
      | [] -> res
      | _ :: _ -> handle_op sz ('='::[]) [] outargs res
    in
    (match e with
     | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc, args0) ->
       (match idc with
        | Coq24_Compilers.ToString.IR.Coq_literal v ->
          (fun _ ->
            wrap_value
              (((append ('"'::[])
                  (append
                    (int_literal_to_string
                      Coq24_Compilers.ToString.IR.Coq_type.Z v) ('"'::[]))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.List_nth n3 ->
          (fun args1 ->
            match args1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              wrap_value
                (((append ('"'::[])
                    (append v
                      (append ('['::[])
                        (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
                          (']'::('"'::[])))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.TT ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.Addr ->
          (fun args1 ->
            match args1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              wrap_value
                (((append ('"'::('&'::[])) (append v ('"'::[]))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.TT ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.Dereference ->
          (fun args1 ->
            match args1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              handle_op sz
                ('d'::('e'::('r'::('e'::('f'::('e'::('r'::('e'::('n'::('c'::('e'::[])))))))))))
                [] []
                (arith_to_string []
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Zptr) sz args1)
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              wrap_value
                (((append ('"'::('*'::[])) (append v ('"'::[]))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              handle_op sz
                ('d'::('e'::('r'::('e'::('f'::('e'::('r'::('e'::('n'::('c'::('e'::[])))))))))))
                [] []
                (arith_to_string []
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Zptr) sz args1)
            | Coq24_Compilers.ToString.IR.TT ->
              handle_op sz
                ('d'::('e'::('r'::('e'::('f'::('e'::('r'::('e'::('n'::('c'::('e'::[])))))))))))
                [] []
                (arith_to_string []
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Zptr) sz args1))
        | Coq24_Compilers.ToString.IR.Coq_iunop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
             (fun args1 ->
               handle_op sz ('>'::('>'::[])) [] outargs
                 (app
                   (arith_to_string []
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) sz args1)
                   (((append ('"'::[])
                       (append (Coq0_Z.to_string offset) ('"'::[]))) :: []) :: [])))
           | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
             (fun args1 ->
               handle_op sz ('<'::('<'::[])) [] outargs
                 (app
                   (arith_to_string []
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) sz args1)
                   (((append ('"'::[])
                       (append (Coq0_Z.to_string offset) ('"'::[]))) :: []) :: [])))
           | Coq24_Compilers.ToString.IR.Z_lnot _ ->
             (fun args1 ->
               handle_op1 ('~'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z) args1)
           | Coq24_Compilers.ToString.IR.Z_bneg ->
             (fun args1 ->
               handle_op1 ('!'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z) args1)
           | Coq24_Compilers.ToString.IR.Z_value_barrier _ ->
             (fun args1 ->
               arith_to_string outargs
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z) sz args1))
        | Coq24_Compilers.ToString.IR.Coq_ibinop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_land ->
             (fun args1 ->
               handle_op1 ('&'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                 ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z),
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z))) args1)
           | Coq24_Compilers.ToString.IR.Z_lor ->
             (fun args1 ->
               handle_op1 ('|'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                 ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z),
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z))) args1)
           | Coq24_Compilers.ToString.IR.Z_lxor ->
             (fun args1 ->
               handle_op1 ('^'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                 ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z),
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z))) args1)
           | Coq24_Compilers.ToString.IR.Z_add ->
             (fun args1 ->
               handle_op1 ('+'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                 ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z),
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z))) args1)
           | Coq24_Compilers.ToString.IR.Z_mul ->
             (fun args1 ->
               handle_op1 ('*'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                 ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z),
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z))) args1)
           | Coq24_Compilers.ToString.IR.Z_sub ->
             (fun args1 ->
               handle_op1 ('-'::[])
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                 ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z),
                 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                 Coq24_Compilers.ToString.IR.Coq_type.Z))) args1))
        | Coq24_Compilers.ToString.IR.Z_mul_split lg2s ->
          (fun args1 ->
            match args1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Pair (_, b, a, args2) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.Pair (_, _, a0, b0) ->
                 (match a0 with
                  | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc0, arg) ->
                    (match idc0 with
                     | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.List_nth _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Addr ->
                       (fun arg0 ->
                         match arg0 with
                         | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                         | Coq24_Compilers.ToString.IR.Var (_, x1) ->
                           (match b0 with
                            | Coq24_Compilers.ToString.IR.AppIdent (_, _,
                                                                    idc1, arg1) ->
                              (match idc1 with
                               | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.List_nth _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Addr ->
                                 (fun arg2 ->
                                   match arg2 with
                                   | Coq24_Compilers.ToString.IR.AppIdent (
                                       _, _, _, _) ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                                   | Coq24_Compilers.ToString.IR.Var (
                                       _, x2) ->
                                     let sz' = Some
                                       (Coq7_Compilers.ToString.Coq_int.of_bitwidth_up
                                         false lg2s)
                                     in
                                     wrap_value
                                       (handle_op_size lg2s
                                         ('m'::('u'::('l'::('x'::[]))))
                                         (x1 :: (x2 :: []))
                                         (arith_to_string [] b sz' args2))
                                   | Coq24_Compilers.ToString.IR.Pair (
                                       _, _, _, _) ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                                   | Coq24_Compilers.ToString.IR.TT ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Dereference ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])))
                                arg1
                            | Coq24_Compilers.ToString.IR.Var (_, _) ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                            | Coq24_Compilers.ToString.IR.TT ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                         | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                         | Coq24_Compilers.ToString.IR.TT ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Dereference ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])))
                      arg
                  | Coq24_Compilers.ToString.IR.Var (_, _) ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                  | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                  | Coq24_Compilers.ToString.IR.TT ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
               | Coq24_Compilers.ToString.IR.TT ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
            | Coq24_Compilers.ToString.IR.TT ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.Z_add_with_get_carry lg2s ->
          (fun args1 ->
            match args1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Pair (_, b, a, args2) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.Pair (_, _, a0, b0) ->
                 (match a0 with
                  | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc0, arg) ->
                    (match idc0 with
                     | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.List_nth _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Addr ->
                       (fun arg0 ->
                         match arg0 with
                         | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                         | Coq24_Compilers.ToString.IR.Var (_, x1) ->
                           (match b0 with
                            | Coq24_Compilers.ToString.IR.AppIdent (_, _,
                                                                    idc1, arg1) ->
                              (match idc1 with
                               | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.List_nth _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Addr ->
                                 (fun arg2 ->
                                   match arg2 with
                                   | Coq24_Compilers.ToString.IR.AppIdent (
                                       _, _, _, _) ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                                   | Coq24_Compilers.ToString.IR.Var (
                                       _, x2) ->
                                     let sz' = Some
                                       (Coq7_Compilers.ToString.Coq_int.of_bitwidth_up
                                         false lg2s)
                                     in
                                     wrap_value
                                       (handle_op_size lg2s
                                         ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                                         (x1 :: (x2 :: []))
                                         (arith_to_string [] b sz' args2))
                                   | Coq24_Compilers.ToString.IR.Pair (
                                       _, _, _, _) ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                                   | Coq24_Compilers.ToString.IR.TT ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Dereference ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])))
                                arg1
                            | Coq24_Compilers.ToString.IR.Var (_, _) ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                            | Coq24_Compilers.ToString.IR.TT ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                         | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                         | Coq24_Compilers.ToString.IR.TT ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Dereference ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])))
                      arg
                  | Coq24_Compilers.ToString.IR.Var (_, _) ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                  | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                  | Coq24_Compilers.ToString.IR.TT ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
               | Coq24_Compilers.ToString.IR.TT ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
            | Coq24_Compilers.ToString.IR.TT ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow lg2s ->
          (fun args1 ->
            match args1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Pair (_, b, a, args2) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.Pair (_, _, a0, b0) ->
                 (match a0 with
                  | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc0, arg) ->
                    (match idc0 with
                     | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.List_nth _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Addr ->
                       (fun arg0 ->
                         match arg0 with
                         | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                         | Coq24_Compilers.ToString.IR.Var (_, x1) ->
                           (match b0 with
                            | Coq24_Compilers.ToString.IR.AppIdent (_, _,
                                                                    idc1, arg1) ->
                              (match idc1 with
                               | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.List_nth _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Addr ->
                                 (fun arg2 ->
                                   match arg2 with
                                   | Coq24_Compilers.ToString.IR.AppIdent (
                                       _, _, _, _) ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                                   | Coq24_Compilers.ToString.IR.Var (
                                       _, x2) ->
                                     let sz' = Some
                                       (Coq7_Compilers.ToString.Coq_int.of_bitwidth_up
                                         false lg2s)
                                     in
                                     wrap_value
                                       (handle_op_size lg2s
                                         ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                                         (x1 :: (x2 :: []))
                                         (arith_to_string [] b sz' args2))
                                   | Coq24_Compilers.ToString.IR.Pair (
                                       _, _, _, _) ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                                   | Coq24_Compilers.ToString.IR.TT ->
                                     wrap_value
                                       ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Dereference ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                               | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                                 (fun _ ->
                                   wrap_value
                                     ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])))
                                arg1
                            | Coq24_Compilers.ToString.IR.Var (_, _) ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                            | Coq24_Compilers.ToString.IR.TT ->
                              wrap_value
                                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                         | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                         | Coq24_Compilers.ToString.IR.TT ->
                           wrap_value
                             ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Dereference ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                     | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                       (fun _ ->
                         wrap_value
                           ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])))
                      arg
                  | Coq24_Compilers.ToString.IR.Var (_, _) ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                  | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                  | Coq24_Compilers.ToString.IR.TT ->
                    wrap_value
                      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
               | Coq24_Compilers.ToString.IR.TT ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
            | Coq24_Compilers.ToString.IR.TT ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.Z_zselect ty ->
          (fun args1 ->
            match args1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
            | Coq24_Compilers.ToString.IR.Pair (_, b, a, args2) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc0, arg) ->
                 (match idc0 with
                  | Coq24_Compilers.ToString.IR.Coq_literal _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.List_nth _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Addr ->
                    (fun arg0 ->
                      match arg0 with
                      | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                        wrap_value
                          ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                      | Coq24_Compilers.ToString.IR.Var (_, v) ->
                        wrap_value
                          (handle_op (Some ty)
                            ('c'::('m'::('o'::('v'::('z'::('n'::('z'::[])))))))
                            [] (v :: [])
                            (arith_to_string [] b (Some ty) args2))
                      | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                        wrap_value
                          ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
                      | Coq24_Compilers.ToString.IR.TT ->
                        wrap_value
                          ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Dereference ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Coq_iunop _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Coq_ibinop _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Z_mul_split _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Z_add_with_get_carry _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Z_zselect _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Z_add_modulo ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
                  | Coq24_Compilers.ToString.IR.Z_static_cast _ ->
                    (fun _ ->
                      wrap_value
                        ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])))
                   arg
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: [])
               | Coq24_Compilers.ToString.IR.TT ->
                 wrap_value
                   ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
            | Coq24_Compilers.ToString.IR.TT ->
              wrap_value
                ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('b'::('a'::('d'::('_'::('a'::('r'::('g'::[])))))))))))))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.Z_add_modulo ->
          (fun _ ->
            wrap_value
              ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('a'::('d'::('d'::('m'::('o'::('d'::('u'::('l'::('o'::[])))))))))))))))) :: []) :: []))
        | Coq24_Compilers.ToString.IR.Z_static_cast int_t ->
          (fun args1 ->
            handle_op (Some int_t)
              ('s'::('t'::('a'::('t'::('i'::('c'::('_'::('c'::('a'::('s'::('t'::[])))))))))))
              [] outargs
              (arith_to_string []
                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                Coq24_Compilers.ToString.IR.Coq_type.Z) (Some int_t) args1)))
         args0
     | Coq24_Compilers.ToString.IR.Var (_, v) ->
       wrap_value (((append ('"'::[]) (append v ('"'::[]))) :: []) :: [])
     | Coq24_Compilers.ToString.IR.Pair (a, b, a0, b0) ->
       wrap_value
         (app (arith_to_string [] a sz a0) (arith_to_string [] b sz b0))
     | Coq24_Compilers.ToString.IR.TT ->
       wrap_value
         ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('t'::('t'::[]))))))))) :: []) :: []))

  (** val stmt_to_string :
      Coq24_Compilers.ToString.IR.stmt -> char list list **)

  let stmt_to_string e =
    concat
      (match e with
       | Coq24_Compilers.ToString.IR.Call val0 ->
         arith_to_string [] Coq24_Compilers.ToString.IR.Coq_type.Coq_unit
           None val0
       | Coq24_Compilers.ToString.IR.Comment (_, _) -> []
       | Coq24_Compilers.ToString.IR.Assign (_, t0, sz, name0, val0) ->
         arith_to_string (name0 :: [])
           (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive t0) sz
           val0
       | Coq24_Compilers.ToString.IR.AssignZPtr (name0, sz, val0) ->
         arith_to_string (name0 :: [])
           (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
           Coq24_Compilers.ToString.IR.Coq_type.Z) sz val0
       | Coq24_Compilers.ToString.IR.DeclareVar (_, _, _) -> []
       | Coq24_Compilers.ToString.IR.AssignNth (name0, n3, val0) ->
         let name1 =
           append name0
             (append ('['::[])
               (append (Coq0_Z.to_string (Coq_Z.of_nat n3)) (']'::[])))
         in
         arith_to_string (name1 :: [])
           (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
           Coq24_Compilers.ToString.IR.Coq_type.Z) None val0)

  (** val to_strings : Coq24_Compilers.ToString.IR.expr -> char list list **)

  let to_strings e =
    comma_concat (map stmt_to_string e)

  (** val to_base_arg_list :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
      Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      ((char list * char list) * (char list * char list)) list **)

  let rec to_base_arg_list t0 =
    let show_Z0 = fun s0 ->
      append ('"'::[]) (append (Hex.show_Z s0) ('"'::[]))
    in
    let opt_to_json = fun _ f b ->
      match b with
      | Some v -> f v
      | None ->
        (('n'::('u'::('l'::('l'::[])))), ('n'::('u'::('l'::('l'::[])))))
    in
    let zrange_to_json = fun b -> ((show_Z0 b.lower), (show_Z0 b.upper)) in
    let opt_zrange_to_json = fun b -> opt_to_json __ zrange_to_json b in
    let opt_zrange_list_to_json = fun ls ->
      let ls0 = map opt_zrange_to_json ls in
      ((append ('['::[])
         (append (concat0 (','::(' '::[])) (map fst ls0)) (']'::[]))),
      (append ('['::[])
        (append (concat0 (','::(' '::[])) (map snd ls0)) (']'::[]))))
    in
    let opt_opt_zrange_list_to_json = fun ls ->
      opt_to_json __ opt_zrange_list_to_json ls
    in
    (match t0 with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun pat ->
            let (p, _) = Obj.magic pat in
            let (p0, r0) = p in
            let (n3, _) = p0 in
            (fun b ->
            (((primitive_type_to_string
                Coq24_Compilers.ToString.IR.Coq_type.Z r0), n3),
            (Obj.magic opt_zrange_to_json b)) :: []))
        | Coq3_Compilers.Coq_bool ->
          (fun _ _ ->
            (((append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
                (show0
                  Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                  t1)), []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: [])
        | Coq3_Compilers.Coq_nat ->
          (fun _ _ ->
            (((append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
                (show0
                  Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                  t1)), []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: [])
        | Coq3_Compilers.Coq_zrange ->
          (fun _ _ ->
            (((append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
                (show0
                  Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                  t1)), []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: [])
        | Coq3_Compilers.Coq_string ->
          (fun _ _ ->
            (((append ('#'::('e'::('r'::('r'::('o'::('r'::(' '::[])))))))
                (show0
                  Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
                  t1)), []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: []))
     | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
       (fun pat ->
         let (va, vb) = Obj.magic pat in
         (fun pat0 ->
         let (ba, bb) = Obj.magic pat0 in
         app (to_base_arg_list a va ba) (to_base_arg_list b vb bb)))
     | Compilers.Coq_base.Coq_type.Coq_list a ->
       (match a with
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z ->
             (fun pat ->
               let (p, _) = Obj.magic pat in
               let (p0, len) = p in
               let (n3, r0) = p0 in
               (fun b ->
               (((append
                   (primitive_type_to_string
                     Coq24_Compilers.ToString.IR.Coq_type.Z r0)
                   (append ('['::[])
                     (append (Coq0_Z.to_string (Coq_Z.of_nat len)) (']'::[])))),
               n3), (Obj.magic opt_opt_zrange_list_to_json b)) :: []))
           | Coq3_Compilers.Coq_bool ->
             (fun _ _ ->
               ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
               []), (('n'::('u'::('l'::('l'::[])))),
               ('n'::('u'::('l'::('l'::[])))))) :: [])
           | Coq3_Compilers.Coq_nat ->
             (fun _ _ ->
               ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
               []), (('n'::('u'::('l'::('l'::[])))),
               ('n'::('u'::('l'::('l'::[])))))) :: [])
           | Coq3_Compilers.Coq_zrange ->
             (fun _ _ ->
               ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
               []), (('n'::('u'::('l'::('l'::[])))),
               ('n'::('u'::('l'::('l'::[])))))) :: [])
           | Coq3_Compilers.Coq_string ->
             (fun _ _ ->
               ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
               []), (('n'::('u'::('l'::('l'::[])))),
               ('n'::('u'::('l'::('l'::[])))))) :: []))
        | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
          (fun _ _ ->
            ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
            []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: [])
        | Compilers.Coq_base.Coq_type.Coq_list _ ->
          (fun _ _ ->
            ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
            []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: [])
        | Compilers.Coq_base.Coq_type.Coq_option _ ->
          (fun _ _ ->
            ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
            []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: [])
        | Compilers.Coq_base.Coq_type.Coq_unit ->
          (fun _ _ ->
            ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::[]))))))))))))))))))))),
            []), (('n'::('u'::('l'::('l'::[])))),
            ('n'::('u'::('l'::('l'::[])))))) :: []))
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun _ _ ->
         ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::[]))))))))))))),
         []), (('n'::('u'::('l'::('l'::[])))),
         ('n'::('u'::('l'::('l'::[])))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (fun _ _ ->
         ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('u'::('n'::('i'::('t'::[]))))))))))),
         []), (('n'::('u'::('l'::('l'::[])))),
         ('n'::('u'::('l'::('l'::[])))))) :: []))

  (** val to_arg_list :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
      -> Coq6_Compilers.ZRange.Coq_type.Coq_option.interp ->
      ((char list * char list) * (char list * char list)) list **)

  let to_arg_list = function
  | Compilers.Coq_type.Coq_base t1 -> to_base_arg_list t1
  | Compilers.Coq_type.Coq_arrow (_, _) ->
    (fun _ _ ->
      ((('#'::('e'::('r'::('r'::('o'::('r'::(' '::('a'::('r'::('r'::('o'::('w'::[])))))))))))),
      []), (('n'::('u'::('l'::('l'::[])))),
      ('n'::('u'::('l'::('l'::[])))))) :: [])

  (** val to_arg_list_for_each_lhs_of_arrow :
      Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      ((char list * char list) * (char list * char list)) list **)

  let rec to_arg_list_for_each_lhs_of_arrow = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ _ -> [])
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (fun pat ->
      let (x, xs) = Obj.magic pat in
      (fun pat0 ->
      let (b, bs) = Obj.magic pat0 in
      app (to_arg_list s0 x b) (to_arg_list_for_each_lhs_of_arrow d xs bs)))

  (** val coq_JSON_bin_op_natural_output :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type **)

  let coq_JSON_bin_op_natural_output _ = function
  | (t1, t2) -> Coq7_Compilers.ToString.Coq_int.union t1 t2

  (** val bin_op_commutes_with_mod_pow2 :
      Coq24_Compilers.ToString.IR.coq_Z_binop -> bool **)

  let bin_op_commutes_with_mod_pow2 = function
  | Coq24_Compilers.ToString.IR.Z_land -> true
  | Coq24_Compilers.ToString.IR.Z_lor -> true
  | Coq24_Compilers.ToString.IR.Z_lxor -> true
  | Coq24_Compilers.ToString.IR.Z_add -> true
  | Coq24_Compilers.ToString.IR.Z_mul -> true
  | Coq24_Compilers.ToString.IR.Z_sub -> true

  (** val coq_JSON_bin_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type
      option * (Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

  let coq_JSON_bin_op_casts idc desired_type = function
  | (t1, t2) ->
    (match desired_type with
     | Some desired_type0 ->
       let ct = Coq7_Compilers.ToString.Coq_int.union t1 t2 in
       if bin_op_commutes_with_mod_pow2 idc
       then (None, ((Some desired_type0), (Some desired_type0)))
       else let desired_type' = Some
              (Coq7_Compilers.ToString.Coq_int.union ct desired_type0)
            in
            (desired_type',
            ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
               desired_type' (Some t1)),
            (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
              desired_type' (Some t2))))
     | None -> (None, (None, None)))

  (** val coq_JSON_un_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_unop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      Coq7_Compilers.ToString.Coq_int.coq_type ->
      Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

  let coq_JSON_un_op_casts idc desired_type t0 =
    match idc with
    | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
      let t' =
        Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0; upper =
          (Coq_Z.pow (Zpos (XO XH)) offset) } t0
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some t')),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed (Some t')
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
      let rpre_out =
        match desired_type with
        | Some rout ->
          Some
            (Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) }
              (Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of rout))
        | None ->
          Some
            (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) })
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type rpre_out),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed rpre_out
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_lnot ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))
    | Coq24_Compilers.ToString.IR.Z_bneg -> (None, None)
    | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))

  (** val coq_JSONLanguageCasts :
      Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts **)

  let coq_JSONLanguageCasts =
    { Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_natural_output =
      coq_JSON_bin_op_natural_output;
      Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_casts =
      coq_JSON_bin_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.un_op_casts = coq_JSON_un_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_assignment = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_funcall = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.explicit_pointer_variables = false }

  (** val to_function_lines :
      bool -> bool -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
      -> char list list **)

  let to_function_lines _ _ name0 t0 inbounds outbounds = function
  | (p, body) ->
    let (args0, rets) = p in
    let args_list_to_string = fun ls ->
      append ('['::[])
        (append
          (concat0 (','::(' '::[]))
            (map (fun pat ->
              let (y, y0) = pat in
              let (typ, name1) = y in
              let (lbound, ubound) = y0 in
              append
                ('{'::('"'::('d'::('a'::('t'::('a'::('t'::('y'::('p'::('e'::('"'::(':'::(' '::('"'::[]))))))))))))))
                (append typ
                  (append
                    ('"'::(','::(' '::('"'::('n'::('a'::('m'::('e'::('"'::(':'::(' '::('"'::[]))))))))))))
                    (append name1
                      (append
                        ('"'::(','::(' '::('"'::('l'::('b'::('o'::('u'::('n'::('d'::('"'::(':'::(' '::[])))))))))))))
                        (append lbound
                          (append
                            (','::(' '::('"'::('u'::('b'::('o'::('u'::('n'::('d'::('"'::(':'::(' '::[]))))))))))))
                            (append ubound ('}'::[]))))))))) ls)) (']'::[]))
    in
    app (('{'::[]) :: [])
      (app
        ((append
           ('"'::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('"'::(':'::(' '::('"'::[]))))))))))))))
           (append name0 ('"'::(','::[])))) :: ((append
                                                  ('"'::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::('"'::(':'::(' '::[])))))))))))))
                                                  (append
                                                    (args_list_to_string
                                                      (to_arg_list_for_each_lhs_of_arrow
                                                        t0 args0 inbounds))
                                                    (','::[]))) :: ((append
                                                                    ('"'::('r'::('e'::('t'::('u'::('r'::('n'::('s'::('"'::(':'::(' '::[])))))))))))
                                                                    (append
                                                                    (args_list_to_string
                                                                    (to_arg_list
                                                                    (Compilers.Coq_type.Coq_base
                                                                    (Compilers.Coq_type.final_codomain
                                                                    t0)) rets
                                                                    outbounds))
                                                                    (','::[]))) :: (('"'::('b'::('o'::('d'::('y'::('"'::(':'::(' '::('['::[]))))))))) :: []))))
        (app (to_strings body) ((']'::[]) :: (('}'::[]) :: []))))

  (** val consider_retargs_live_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt **)

  let consider_retargs_live_opt_instance_0 _ _ _ =
    false

  (** val rename_dead_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt **)

  let rename_dead_opt_instance_0 _ =
    '_'::[]

  (** val lift_declarations_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt **)

  let lift_declarations_opt_instance_0 =
    false

  (** val coq_ToFunctionLines :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      Coq7_Compilers.Options.relax_zrange_opt ->
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool
      -> bool -> bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) ->
      char list list option -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
      list * Coq7_Compilers.ToString.ident_infos, char list) sum **)

  let coq_ToFunctionLines absint_opts0 relax_zrange _ _ output_options0 _ do_bounds_check _ static0 _ inline0 _ name0 t0 e _ name_list inbounds outbounds intypedefs outtypedefs =
    match Coq24_Compilers.ToString.IR.OfPHOAS.coq_ExprOfPHOAS
            coq_JSONLanguageCasts relax_zrange
            consider_retargs_live_opt_instance_0 rename_dead_opt_instance_0
            lift_declarations_opt_instance_0
            output_options0.Coq7_Compilers.Options.language_specific_cast_adjustment_
            absint_opts0
            output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_
            do_bounds_check t0 e name_list inbounds intypedefs outtypedefs with
    | Inl p ->
      let (p0, f) = p in
      let (indata, outdata) = p0 in
      Inl
      ((to_function_lines static0 inline0 name0 t0 inbounds outbounds
         ((indata, outdata), f)),
      (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_all_infos
        output_options0.Coq7_Compilers.Options.skip_typedefs_ f t0 intypedefs
        outtypedefs))
    | Inr errs ->
      (match errs with
       | [] ->
         Inr
           (append
             ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))))))))))))))))))
             (append name0
               (' '::('t'::('o'::(' '::('J'::('S'::('O'::('N'::[]))))))))))
       | err0 :: l ->
         (match l with
          | [] ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('J'::('S'::('O'::('N'::(':'::[])))))))))
                    (append (newLine::[]) err0))))
          | _ :: _ ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::('s'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('J'::('S'::('O'::('N'::(':'::[])))))))))
                    (append (newLine::[]) (concat0 (newLine::[]) errs)))))))

  (** val coq_OutputJSONAPI :
      Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

  let coq_OutputJSONAPI =
    { Coq7_Compilers.ToString.comment_block = (fun _ -> []);
      Coq7_Compilers.ToString.comment_file_header_block = (fun _ -> []);
      Coq7_Compilers.ToString.coq_ToFunctionLines = coq_ToFunctionLines;
      Coq7_Compilers.ToString.header = (fun _ _ _ _ _ _ _ _ _ _ _ -> []);
      Coq7_Compilers.ToString.footer = (fun _ _ _ _ _ _ _ _ _ -> []);
      Coq7_Compilers.ToString.strip_special_infos = (fun _ infos -> infos) }
 end

module Zig =
 struct
  (** val comment_module_header_block : char list list -> char list list **)

  let comment_module_header_block =
    map (fun line0 -> append ('/'::('/'::(' '::[]))) line0)

  (** val comment_block : char list list -> char list list **)

  let comment_block =
    map (fun line0 -> append ('/'::('/'::(' '::[]))) line0)

  (** val int_type_to_string_opt_typedef :
      Coq7_Compilers.Options.skip_typedefs_opt ->
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq7_Compilers.ToString.Coq_int.coq_type -> char list
      option -> char list **)

  let int_type_to_string_opt_typedef skip_typedefs0 language_naming_conventions0 typedef_private prefix1 t0 typedef0 =
    match if skip_typedefs0 then None else typedef0 with
    | Some typedef1 ->
      Coq7_Compilers.ToString.format_typedef_name
        language_naming_conventions0 prefix1 typedef_private typedef1
    | None ->
      append
        (if Coq7_Compilers.ToString.Coq_int.is_unsigned t0
         then 'u'::[]
         else 'i'::[])
        (Coq0_Z.to_string (Coq7_Compilers.ToString.Coq_int.bitwidth_of t0))

  (** val int_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.ToString.Coq_int.coq_type -> char list **)

  let int_type_to_string language_naming_conventions0 t0 =
    int_type_to_string_opt_typedef true language_naming_conventions0 false []
      t0 None

  (** val primitive_type_to_string_opt_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> char list ->
      Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list option ->
      char list **)

  let primitive_type_to_string_opt_typedef language_naming_conventions0 skip_typedefs0 all_private prefix1 t0 r0 typedef0 =
    append
      (match t0 with
       | Coq24_Compilers.ToString.IR.Coq_type.Z -> []
       | Coq24_Compilers.ToString.IR.Coq_type.Zptr -> '*'::[])
      (match r0 with
       | Some int_t ->
         int_type_to_string_opt_typedef skip_typedefs0
           language_naming_conventions0 all_private prefix1 int_t typedef0
       | None -> '\226'::('\132'::('\164'::[])))

  (** val primitive_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> char list **)

  let primitive_type_to_string language_naming_conventions0 t0 r0 =
    primitive_type_to_string_opt_typedef language_naming_conventions0 true
      false [] t0 r0 None

  (** val primitive_array_type_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> char list ->
      Coq24_Compilers.ToString.IR.Coq_type.primitive ->
      Coq7_Compilers.ToString.Coq_int.coq_type option -> nat -> char list
      option -> char list **)

  let primitive_array_type_to_string language_naming_conventions0 skip_typedefs0 all_private prefix1 t0 r0 len typedef0 =
    match if skip_typedefs0 then None else typedef0 with
    | Some typedef1 ->
      Coq7_Compilers.ToString.format_typedef_name
        language_naming_conventions0 prefix1 all_private typedef1
    | None ->
      append ('['::[])
        (append (Coq0_Z.to_string (Coq_Z.of_nat len))
          (append (']'::[])
            (primitive_type_to_string language_naming_conventions0 t0 r0)))

  (** val make_typedef :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt -> char list -> bool
      -> (((char list * (char list ->
      char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) ->
      char list list **)

  let make_typedef language_naming_conventions0 documentation_options0 prefix1 private0 typedef0 =
    let (p, description0) =
      Coq7_Compilers.ToString.name_and_type_and_describe_typedef
        language_naming_conventions0 documentation_options0 prefix1 private0
        typedef0
    in
    let (name0, p0) = p in
    let (ty, array_len) = p0 in
    app (comment_block description0)
      ((append
         (if private0
          then 'c'::('o'::('n'::('s'::('t'::(' '::[])))))
          else 'p'::('u'::('b'::(' '::('c'::('o'::('n'::('s'::('t'::(' '::[]))))))))))
         (append name0
           (append (' '::('='::(' '::[])))
             (let ty_string =
                match ty with
                | Some ty0 ->
                  int_type_to_string language_naming_conventions0 ty0
                | None -> '\226'::('\132'::('\164'::[]))
              in
              append
                (match array_len with
                 | Some o ->
                   (match o with
                    | Some len ->
                      append ('['::[])
                        (append (Coq0_Z.to_string (Coq_Z.of_nat len))
                          (append (']'::[]) ty_string))
                    | None -> append ('*'::[]) ty_string)
                 | None -> ty_string) (';'::[]))))) :: [])

  (** val header :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.package_name_opt ->
      Coq7_Compilers.Options.class_name_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool ->
      char list -> Coq7_Compilers.ToString.ident_infos ->
      (((char list * (char list ->
      char list)) * Coq7_Compilers.ToString.Coq_int.coq_type
      option) * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp) sigT) list
      -> char list list **)

  let header language_naming_conventions0 documentation_options0 _ _ output_options0 _ _ private0 prefix1 infos typedef_map =
    app
      ([] :: (('c'::('o'::('n'::('s'::('t'::(' '::('s'::('t'::('d'::(' '::('='::(' '::('@'::('i'::('m'::('p'::('o'::('r'::('t'::('('::('"'::('s'::('t'::('d'::('"'::(')'::(';'::[]))))))))))))))))))))))))))) :: (('c'::('o'::('n'::('s'::('t'::(' '::('m'::('o'::('d'::('e'::(' '::('='::(' '::('@'::('i'::('m'::('p'::('o'::('r'::('t'::('('::('"'::('b'::('u'::('i'::('l'::('t'::('i'::('n'::('"'::(')'::('.'::('m'::('o'::('d'::('e'::(';'::(' '::('/'::('/'::(' '::('C'::('h'::('e'::('c'::('k'::('e'::('d'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('i'::('s'::(' '::('d'::('i'::('s'::('a'::('b'::('l'::('e'::('d'::(' '::('i'::('n'::(' '::('n'::('o'::('n'::('-'::('d'::('e'::('b'::('u'::('g'::(' '::('m'::('o'::('d'::('e'::('s'::(' '::('t'::('o'::(' '::('a'::('v'::('o'::('i'::('d'::(' '::('s'::('i'::('d'::('e'::(' '::('c'::('h'::('a'::('n'::('n'::('e'::('l'::('s'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ([] :: (('i'::('n'::('l'::('i'::('n'::('e'::(' '::('f'::('n'::(' '::('c'::('a'::('s'::('t'::('('::('c'::('o'::('m'::('p'::('t'::('i'::('m'::('e'::(' '::('D'::('e'::('s'::('t'::('T'::('y'::('p'::('e'::(':'::(' '::('t'::('y'::('p'::('e'::(','::(' '::('t'::('a'::('r'::('g'::('e'::('t'::(':'::(' '::('a'::('n'::('y'::('t'::('y'::('p'::('e'::(')'::(' '::('D'::('e'::('s'::('t'::('T'::('y'::('p'::('e'::(' '::('{'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::('@'::('s'::('e'::('t'::('E'::('v'::('a'::('l'::('B'::('r'::('a'::('n'::('c'::('h'::('Q'::('u'::('o'::('t'::('a'::('('::('1'::('0'::('0'::('0'::('0'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::('i'::('f'::(' '::('('::('@'::('t'::('y'::('p'::('e'::('I'::('n'::('f'::('o'::('('::('@'::('T'::('y'::('p'::('e'::('O'::('f'::('('::('t'::('a'::('r'::('g'::('e'::('t'::(')'::(')'::(' '::('='::('='::(' '::('.'::('I'::('n'::('t'::(')'::(' '::('{'::[]))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('c'::('o'::('n'::('s'::('t'::(' '::('d'::('e'::('s'::('t'::(' '::('='::(' '::('@'::('t'::('y'::('p'::('e'::('I'::('n'::('f'::('o'::('('::('D'::('e'::('s'::('t'::('T'::('y'::('p'::('e'::(')'::('.'::('I'::('n'::('t'::(';'::[]))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('c'::('o'::('n'::('s'::('t'::(' '::('s'::('o'::('u'::('r'::('c'::('e'::(' '::('='::(' '::('@'::('t'::('y'::('p'::('e'::('I'::('n'::('f'::('o'::('('::('@'::('T'::('y'::('p'::('e'::('O'::('f'::('('::('t'::('a'::('r'::('g'::('e'::('t'::(')'::(')'::('.'::('I'::('n'::('t'::(';'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('i'::('f'::(' '::('('::('d'::('e'::('s'::('t'::('.'::('b'::('i'::('t'::('s'::(' '::('<'::(' '::('s'::('o'::('u'::('r'::('c'::('e'::('.'::('b'::('i'::('t'::('s'::(')'::(' '::('{'::[])))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('c'::('o'::('n'::('s'::('t'::(' '::('T'::(' '::('='::(' '::('s'::('t'::('d'::('.'::('m'::('e'::('t'::('a'::('.'::('I'::('n'::('t'::('('::('s'::('o'::('u'::('r'::('c'::('e'::('.'::('s'::('i'::('g'::('n'::('e'::('d'::('n'::('e'::('s'::('s'::(','::(' '::('d'::('e'::('s'::('t'::('.'::('b'::('i'::('t'::('s'::(')'::(';'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('@'::('b'::('i'::('t'::('C'::('a'::('s'::('t'::('('::('@'::('a'::('s'::('('::('T'::(','::(' '::('@'::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::('('::('t'::('a'::('r'::('g'::('e'::('t'::(')'::(')'::(')'::(';'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::('}'::[]))))))))) :: ((' '::(' '::(' '::(' '::('}'::[]))))) :: ((' '::(' '::(' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('t'::('a'::('r'::('g'::('e'::('t'::(';'::[])))))))))))))))))) :: (('}'::[]) :: []))))))))))))))))
      (if Coq7_Compilers.Options.skip_typedefs
            output_options0.Coq7_Compilers.Options.skip_typedefs_
       then []
       else flat_map (fun td_name ->
              match find (fun pat ->
                      let (y, _) = pat in
                      let (y1, _) = y in
                      let (name0, _) = y1 in eqb0 td_name name0) typedef_map with
              | Some td_info ->
                app ([] :: [])
                  (make_typedef language_naming_conventions0
                    documentation_options0 prefix1 private0 td_info)
              | None ->
                (append
                  ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('f'::('i'::('n'::('d'::(' '::('t'::('y'::('p'::('e'::('d'::('e'::('f'::(' '::('i'::('n'::('f'::('o'::(' '::('f'::('o'::('r'::(' '::('\''::[])))))))))))))))))))))))))))))))))))))))))))))))))
                  (append td_name ('\''::('"'::(')'::(';'::[])))))) :: [])
              infos.Coq7_Compilers.ToString.typedefs_used)

  (** val int_literal_to_string :
      char list -> Coq24_Compilers.ToString.IR.Coq_type.primitive -> z ->
      char list **)

  let int_literal_to_string _ t0 v =
    match t0 with
    | Coq24_Compilers.ToString.IR.Coq_type.Z -> of_Z v
    | Coq24_Compilers.ToString.IR.Coq_type.Zptr ->
      append
        ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('a'::('d'::('d'::('r'::('e'::('s'::('s'::(' '::[]))))))))))))))))))))))))))))))))
        (append (of_Z v) ('"'::(')'::(';'::[]))))

  (** val arith_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.Coq_type.coq_type ->
      Coq24_Compilers.ToString.IR.arith_expr -> char list **)

  let rec arith_to_string language_naming_conventions0 internal_private prefix1 _ e =
    let special_name_ty = fun name0 ty ->
      Coq7_Compilers.ToString.format_special_function_name_ty
        language_naming_conventions0 internal_private prefix1 name0 ty
    in
    let special_name = fun name0 bw ->
      Coq7_Compilers.ToString.format_special_function_name
        language_naming_conventions0 internal_private prefix1 name0 false bw
    in
    (match e with
     | Coq24_Compilers.ToString.IR.AppIdent (_, _, idc, e0) ->
       (match idc with
        | Coq24_Compilers.ToString.IR.Coq_literal v ->
          (fun _ ->
            int_literal_to_string prefix1
              Coq24_Compilers.ToString.IR.Coq_type.Z v)
        | Coq24_Compilers.ToString.IR.List_nth n3 ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) ->
              append ('('::[])
                (append v
                  (append ('['::[])
                    (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
                      (']'::(')'::[])))))
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Addr ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, v) -> append ('&'::[]) v
            | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Dereference ->
          (fun e1 ->
            append ('('::(' '::[]))
              (append
                (arith_to_string language_naming_conventions0
                  internal_private prefix1
                  (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                  Coq24_Compilers.ToString.IR.Coq_type.Zptr) e1)
                ('.'::('*'::(' '::(')'::[]))))))
        | Coq24_Compilers.ToString.IR.Coq_iunop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('>'::('>'::(' '::[]))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
             (fun e1 ->
               append ('('::[])
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1)
                   (append (' '::('<'::('<'::(' '::[]))))
                     (append (Coq0_Z.to_string offset) (')'::[])))))
           | Coq24_Compilers.ToString.IR.Z_lnot _ ->
             (fun e1 ->
               append ('('::('~'::[]))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_bneg ->
             (fun e1 ->
               append ('('::('~'::[]))
                 (append
                   (arith_to_string language_naming_conventions0
                     internal_private prefix1
                     (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                     Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))
           | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
             (fun e1 ->
               append
                 (special_name_ty
                   ('v'::('a'::('l'::('u'::('e'::('_'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))
                   ty)
                 (append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1
                       (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                       Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[])))))
        | Coq24_Compilers.ToString.IR.Coq_ibinop op1 ->
          (match op1 with
           | Coq24_Compilers.ToString.IR.Z_land ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('&'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('|'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_lxor ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, e2, e3) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a e2)
                     (append (' '::('^'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b e3) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_add ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('+'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_mul ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('*'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
           | Coq24_Compilers.ToString.IR.Z_sub ->
             (fun e1 ->
               match e1 with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (a, b, x1, x2) ->
                 append ('('::[])
                   (append
                     (arith_to_string language_naming_conventions0
                       internal_private prefix1 a x1)
                     (append (' '::('-'::(' '::[])))
                       (append
                         (arith_to_string language_naming_conventions0
                           internal_private prefix1 b x2) (')'::[]))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_mul_split lg2s ->
          (fun e1 ->
            append (special_name ('m'::('u'::('l'::('x'::[])))) lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_with_get_carry lg2s ->
          (fun e1 ->
            append
              (special_name
                ('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::[])))))))))
                lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_sub_with_get_borrow lg2s ->
          (fun e1 ->
            append
              (special_name
                ('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::[]))))))))))
                lg2s)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_zselect ty ->
          (fun e1 ->
            append
              (special_name_ty
                ('c'::('m'::('o'::('v'::('z'::('n'::('z'::[]))))))) ty)
              (append ('('::[])
                (append
                  (arith_to_string language_naming_conventions0
                    internal_private prefix1
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Zptr),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_prod
                    ((Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))),
                    (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                    Coq24_Compilers.ToString.IR.Coq_type.Z))))) e1) (')'::[]))))
        | Coq24_Compilers.ToString.IR.Z_add_modulo ->
          (fun e1 ->
            match e1 with
            | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Var (_, _) ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.Pair (_, _, a, _) ->
              (match a with
               | Coq24_Compilers.ToString.IR.AppIdent (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Var (_, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[])))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.Pair (_, _, _, _) ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('a'::('d'::('d'::('m'::('o'::('d'::('u'::('l'::('o'::('"'::(')'::(';'::[])))))))))))))))))))))))))))
               | Coq24_Compilers.ToString.IR.TT ->
                 '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
            | Coq24_Compilers.ToString.IR.TT ->
              '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('b'::('a'::('d'::('_'::('a'::('r'::('g'::('"'::(')'::(';'::[]))))))))))))))))))))))))))
        | Coq24_Compilers.ToString.IR.Z_static_cast int_t ->
          (fun e1 ->
            append ('c'::('a'::('s'::('t'::('('::[])))))
              (append
                (primitive_type_to_string language_naming_conventions0
                  Coq24_Compilers.ToString.IR.Coq_type.Z (Some int_t))
                (append (','::(' '::[]))
                  (append
                    (arith_to_string language_naming_conventions0
                      internal_private prefix1
                      (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                      Coq24_Compilers.ToString.IR.Coq_type.Z) e1) (')'::[]))))))
         e0
     | Coq24_Compilers.ToString.IR.Var (_, v) -> v
     | Coq24_Compilers.ToString.IR.Pair (a, b, a0, b0) ->
       append
         (arith_to_string language_naming_conventions0 internal_private
           prefix1 a a0)
         (append (','::(' '::[]))
           (arith_to_string language_naming_conventions0 internal_private
             prefix1 b b0))
     | Coq24_Compilers.ToString.IR.TT ->
       '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('t'::('t'::('"'::(')'::(';'::[])))))))))))))))))))))

  (** val stmt_to_string :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.stmt -> char list **)

  let stmt_to_string language_naming_conventions0 internal_private prefix1 = function
  | Coq24_Compilers.ToString.IR.Call val0 ->
    append
      (arith_to_string language_naming_conventions0 internal_private prefix1
        Coq24_Compilers.ToString.IR.Coq_type.Coq_unit val0) (';'::[])
  | Coq24_Compilers.ToString.IR.Comment (lines0, _) ->
    concat0 (newLine::[])
      (comment_block
        (Coq7_Compilers.ToString.preprocess_comment_block lines0))
  | Coq24_Compilers.ToString.IR.Assign (declare, t0, _, name0, val0) ->
    if declare
    then append ('c'::('o'::('n'::('s'::('t'::(' '::[]))))))
           (append name0
             (append (' '::('='::(' '::[])))
               (append
                 (arith_to_string language_naming_conventions0
                   internal_private prefix1
                   (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                   t0) val0) (';'::[]))))
    else '@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('t'::('r'::('y'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('t'::('o'::(' '::('n'::('o'::('n'::('-'::('m'::('u'::('t'::('a'::('b'::('l'::('e'::(' '::('v'::('a'::('r'::('i'::('a'::('b'::('l'::('e'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
  | Coq24_Compilers.ToString.IR.AssignZPtr (name0, _, val0) ->
    append name0
      (append ('.'::('*'::(' '::('='::(' '::[])))))
        (append
          (arith_to_string language_naming_conventions0 internal_private
            prefix1 (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
            Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (';'::[])))
  | Coq24_Compilers.ToString.IR.DeclareVar (t0, sz, name0) ->
    append ('v'::('a'::('r'::(' '::[]))))
      (append name0
        (append (':'::(' '::[]))
          (append
            (primitive_type_to_string language_naming_conventions0 t0 sz)
            (' '::('='::(' '::('u'::('n'::('d'::('e'::('f'::('i'::('n'::('e'::('d'::(';'::[]))))))))))))))))
  | Coq24_Compilers.ToString.IR.AssignNth (name0, n3, val0) ->
    append name0
      (append ('['::[])
        (append (Coq0_Z.to_string (Coq_Z.of_nat n3))
          (append (']'::(' '::('='::(' '::[]))))
            (append
              (arith_to_string language_naming_conventions0 internal_private
                prefix1
                (Coq24_Compilers.ToString.IR.Coq_type.Coq_type_primitive
                Coq24_Compilers.ToString.IR.Coq_type.Z) val0) (';'::[])))))

  (** val to_strings :
      Coq7_Compilers.Options.language_naming_conventions_opt -> bool ->
      char list -> Coq24_Compilers.ToString.IR.expr -> char list list **)

  let to_strings language_naming_conventions0 internal_private prefix1 e =
    map
      (stmt_to_string language_naming_conventions0 internal_private prefix1) e

  type coq_Mode =
  | In
  | Out

  (** val to_base_arg_list :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      -> Coq7_Compilers.ToString.OfPHOAS.base_var_data -> char list list **)

  let rec to_base_arg_list language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 mode = function
  | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
    (match t1 with
     | Coq3_Compilers.Z ->
       let typ =
         match mode with
         | In -> Coq24_Compilers.ToString.IR.Coq_type.Z
         | Out -> Coq24_Compilers.ToString.IR.Coq_type.Zptr
       in
       (fun pat ->
       let (p, typedef0) = Obj.magic pat in
       let (p0, r0) = p in
       let (n3, _) = p0 in
       (append n3
         (append (':'::(' '::[]))
           (primitive_type_to_string_opt_typedef language_naming_conventions0
             skip_typedefs0 all_private prefix1 typ r0 typedef0))) :: [])
     | Coq3_Compilers.Coq_bool ->
       (fun _ ->
         (append
           ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::[]))))))))))))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) ('"'::(')'::(';'::[]))))) :: [])
     | Coq3_Compilers.Coq_nat ->
       (fun _ ->
         (append
           ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::[]))))))))))))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) ('"'::(')'::(';'::[]))))) :: [])
     | Coq3_Compilers.Coq_zrange ->
       (fun _ ->
         (append
           ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::[]))))))))))))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) ('"'::(')'::(';'::[]))))) :: [])
     | Coq3_Compilers.Coq_string ->
       (fun _ ->
         (append
           ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::[]))))))))))))))))
           (append
             (show0 Coq7_Compilers.ToString.PHOAS.Coq_type.Coq_base.show_base
               t1) ('"'::(')'::(';'::[]))))) :: []))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun pat ->
      let (va, vb) = Obj.magic pat in
      app
        (to_base_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 mode a va)
        (to_base_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 mode b vb))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun pat ->
            let (p, typedef0) = Obj.magic pat in
            let (p0, len) = p in
            let (n3, r0) = p0 in
            let modifier = match mode with
                           | In -> []
                           | Out -> '*'::[] in
            (append n3
              (append (':'::(' '::[]))
                (append modifier
                  (primitive_array_type_to_string
                    language_naming_conventions0 skip_typedefs0 all_private
                    prefix1 Coq24_Compilers.ToString.IR.Coq_type.Z r0 len
                    typedef0)))) :: [])
        | Coq3_Compilers.Coq_bool ->
          (fun _ ->
            ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_nat ->
          (fun _ ->
            ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_zrange ->
          (fun _ ->
            ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: [])
        | Coq3_Compilers.Coq_string ->
          (fun _ ->
            ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: []))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun _ ->
         ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun _ ->
         ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun _ ->
         ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: [])
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (fun _ ->
         ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('c'::('o'::('m'::('p'::('l'::('e'::('x'::(' '::('l'::('i'::('s'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))))))))))) :: []))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    (fun _ ->
      ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('o'::('p'::('t'::('i'::('o'::('n'::('"'::(')'::(';'::[]))))))))))))))))))))))))) :: [])
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (fun _ ->
      ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('u'::('n'::('i'::('t'::('"'::(')'::(';'::[]))))))))))))))))))))))) :: [])

  (** val to_arg_list :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> coq_Mode -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> Coq7_Compilers.ToString.OfPHOAS.var_data
      -> char list list **)

  let to_arg_list language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 mode = function
  | Compilers.Coq_type.Coq_base t1 ->
    to_base_arg_list language_naming_conventions0 skip_typedefs0
      internal_private all_private prefix1 mode t1
  | Compilers.Coq_type.Coq_arrow (_, _) ->
    (fun _ ->
      ('@'::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('E'::('r'::('r'::('o'::('r'::('('::('"'::('a'::('r'::('r'::('o'::('w'::('"'::(')'::(';'::[])))))))))))))))))))))))) :: [])

  (** val to_arg_list_for_each_lhs_of_arrow :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> char list
      -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow -> char list list **)

  let rec to_arg_list_for_each_lhs_of_arrow language_naming_conventions0 skip_typedefs0 internal_private all_private prefix1 = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ -> [])
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (fun pat ->
      let (x, xs) = Obj.magic pat in
      app
        (to_arg_list language_naming_conventions0 skip_typedefs0
          internal_private all_private prefix1 In s0 x)
        (to_arg_list_for_each_lhs_of_arrow language_naming_conventions0
          skip_typedefs0 internal_private all_private prefix1 d xs))

  (** val coq_Zig_bin_op_natural_output :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type **)

  let coq_Zig_bin_op_natural_output _ = function
  | (t1, t2) -> Coq7_Compilers.ToString.Coq_int.union t1 t2

  (** val coq_Zig_bin_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_binop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      (Coq7_Compilers.ToString.Coq_int.coq_type * Coq7_Compilers.ToString.Coq_int.coq_type)
      -> Coq7_Compilers.ToString.Coq_int.coq_type
      option * (Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option) **)

  let coq_Zig_bin_op_casts _ desired_type = function
  | (t1, t2) ->
    (match desired_type with
     | Some desired_type0 ->
       let ct = Coq7_Compilers.ToString.Coq_int.union t1 t2 in
       let desired_type' = Some
         (Coq7_Compilers.ToString.Coq_int.union ct desired_type0)
       in
       ((Some desired_type0),
       ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
          desired_type' (Some t1)),
       (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed
         desired_type' (Some t2))))
     | None -> (None, (None, None)))

  (** val coq_Zig_un_op_casts :
      Coq24_Compilers.ToString.IR.coq_Z_unop ->
      Coq7_Compilers.ToString.Coq_int.coq_type option ->
      Coq7_Compilers.ToString.Coq_int.coq_type ->
      Coq7_Compilers.ToString.Coq_int.coq_type
      option * Coq7_Compilers.ToString.Coq_int.coq_type option **)

  let coq_Zig_un_op_casts idc desired_type t0 =
    match idc with
    | Coq24_Compilers.ToString.IR.Z_shiftr offset ->
      let t' =
        Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0; upper =
          (Coq_Z.pow (Zpos (XO XH)) offset) } t0
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some t')),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed (Some t')
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_shiftl offset ->
      let rpre_out =
        match desired_type with
        | Some rout ->
          Some
            (Coq7_Compilers.ToString.Coq_int.union_zrange { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) }
              (Coq7_Compilers.ToString.Coq_int.unsigned_counterpart_of rout))
        | None ->
          Some
            (Coq7_Compilers.ToString.Coq_int.of_zrange_relaxed { lower = Z0;
              upper = (Coq_Z.pow (Zpos (XO XH)) offset) })
      in
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type rpre_out),
      (Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_up_if_needed rpre_out
        (Some t0)))
    | Coq24_Compilers.ToString.IR.Z_lnot ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))
    | Coq24_Compilers.ToString.IR.Z_bneg -> (None, None)
    | Coq24_Compilers.ToString.IR.Z_value_barrier ty ->
      ((Coq24_Compilers.ToString.IR.OfPHOAS.get_Zcast_down_if_needed
         desired_type (Some ty)), (Some ty))

  (** val coq_ZigLanguageCasts :
      Coq24_Compilers.ToString.IR.OfPHOAS.coq_LanguageCasts **)

  let coq_ZigLanguageCasts =
    { Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_natural_output =
      coq_Zig_bin_op_natural_output;
      Coq24_Compilers.ToString.IR.OfPHOAS.bin_op_casts =
      coq_Zig_bin_op_casts; Coq24_Compilers.ToString.IR.OfPHOAS.un_op_casts =
      coq_Zig_un_op_casts;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_assignment = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.upcast_on_funcall = true;
      Coq24_Compilers.ToString.IR.OfPHOAS.explicit_pointer_variables = false }

  (** val to_function_lines :
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.skip_typedefs_opt -> bool -> bool -> bool ->
      bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow * Coq7_Compilers.ToString.OfPHOAS.var_data) * Coq24_Compilers.ToString.IR.expr)
      -> char list list **)

  let to_function_lines language_naming_conventions0 skip_typedefs0 internal_private private0 all_private inline0 prefix1 name0 t0 = function
  | (p, body) ->
    let (args0, rets) = p in
    (append
      (if (||) private0 inline0
       then 'i'::('n'::('l'::('i'::('n'::('e'::(' '::('f'::('n'::(' '::[])))))))))
       else 'p'::('u'::('b'::(' '::('f'::('n'::(' '::[])))))))
      (append name0
        (append ('('::[])
          (append
            (concat0 (','::(' '::[]))
              (app
                (to_arg_list language_naming_conventions0 skip_typedefs0
                  internal_private all_private prefix1 Out
                  (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_type.final_codomain t0)) rets)
                (to_arg_list_for_each_lhs_of_arrow
                  language_naming_conventions0 skip_typedefs0
                  internal_private all_private prefix1 t0 args0)))
            (')'::(' '::('v'::('o'::('i'::('d'::(' '::('{'::[])))))))))))) :: 
    (app
      ((' '::(' '::(' '::(' '::('@'::('s'::('e'::('t'::('R'::('u'::('n'::('t'::('i'::('m'::('e'::('S'::('a'::('f'::('e'::('t'::('y'::('('::('m'::('o'::('d'::('e'::(' '::('='::('='::(' '::('.'::('D'::('e'::('b'::('u'::('g'::(')'::(';'::[])))))))))))))))))))))))))))))))))))))) :: ([] :: []))
      (app
        (map (fun s0 -> append (' '::(' '::(' '::(' '::[])))) s0)
          (to_strings language_naming_conventions0 internal_private prefix1
            body)) (('}'::[]) :: [])))

  (** val consider_retargs_live_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.consider_retargs_live_opt **)

  let consider_retargs_live_opt_instance_0 _ _ _ =
    true

  (** val rename_dead_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.rename_dead_opt **)

  let rename_dead_opt_instance_0 s0 =
    s0

  (** val lift_declarations_opt_instance_0 :
      Coq24_Compilers.ToString.IR.OfPHOAS.lift_declarations_opt **)

  let lift_declarations_opt_instance_0 =
    false

  (** val coq_ToFunctionLines :
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
      Coq7_Compilers.Options.relax_zrange_opt ->
      Coq7_Compilers.Options.language_naming_conventions_opt ->
      Coq7_Compilers.Options.documentation_options_opt ->
      Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool
      -> bool -> bool -> char list -> char list -> Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
      ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) ->
      char list list option -> (Coq3_Compilers.base
      Compilers.Coq_base.Coq_type.coq_type,
      Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
      (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
      Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
      Compilers.Coq_type.for_each_lhs_of_arrow ->
      Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
      list * Coq7_Compilers.ToString.ident_infos, char list) sum **)

  let coq_ToFunctionLines absint_opts0 relax_zrange language_naming_conventions0 _ output_options0 _ do_bounds_check internal_private private0 all_private inline0 prefix1 name0 t0 e comment0 name_list inbounds outbounds intypedefs outtypedefs =
    match Coq24_Compilers.ToString.IR.OfPHOAS.coq_ExprOfPHOAS
            coq_ZigLanguageCasts relax_zrange
            consider_retargs_live_opt_instance_0 rename_dead_opt_instance_0
            lift_declarations_opt_instance_0
            output_options0.Coq7_Compilers.Options.language_specific_cast_adjustment_
            absint_opts0
            output_options0.Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_
            do_bounds_check t0 e name_list inbounds intypedefs outtypedefs with
    | Inl p ->
      let (p0, f) = p in
      let (indata, outdata) = p0 in
      Inl
      ((app
         (map (fun s0 ->
           if Nat.eqb (length0 s0) O
           then '/'::('/'::('/'::[]))
           else append ('/'::('/'::('/'::(' '::[])))) s0)
           (comment0 indata outdata))
         (app
           (match Coq7_Compilers.ToString.OfPHOAS.input_bounds_to_string
                    output_options0.Coq7_Compilers.Options.skip_typedefs_ t0
                    indata inbounds with
            | [] -> []
            | s0 :: l ->
              app
                (('/'::('/'::('/'::(' '::('I'::('n'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[]))))))))))))))))) :: [])
                (map (fun v ->
                  append ('/'::('/'::('/'::(' '::(' '::(' '::[])))))) v)
                  (s0 :: l)))
           (app
             (match Coq7_Compilers.ToString.OfPHOAS.bound_to_string
                      output_options0.Coq7_Compilers.Options.skip_typedefs_
                      (Compilers.Coq_type.final_codomain t0) outdata outbounds with
              | [] -> []
              | s0 :: l ->
                app
                  (('/'::('/'::('/'::(' '::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[])))))))))))))))))) :: [])
                  (map (fun v ->
                    append ('/'::('/'::('/'::(' '::(' '::(' '::[])))))) v)
                    (s0 :: l)))
             (to_function_lines language_naming_conventions0
               output_options0.Coq7_Compilers.Options.skip_typedefs_
               internal_private private0 all_private inline0 prefix1 name0 t0
               ((indata, outdata), f))))),
      (Coq24_Compilers.ToString.IR.Coq_ident_infos.collect_all_infos
        output_options0.Coq7_Compilers.Options.skip_typedefs_ f t0 intypedefs
        outtypedefs))
    | Inr errs ->
      (match errs with
       | [] ->
         Inr
           (append
             ('U'::('n'::('k'::('n'::('o'::('w'::('n'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))))))))))))))))))
             (append name0
               (' '::('t'::('o'::(' '::('Z'::('i'::('g'::[])))))))))
       | err0 :: l ->
         (match l with
          | [] ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('Z'::('i'::('g'::(':'::[]))))))))
                    (append (newLine::[]) err0))))
          | _ :: _ ->
            Inr
              (append
                ('E'::('r'::('r'::('o'::('r'::('s'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('v'::('e'::('r'::('t'::('i'::('n'::('g'::(' '::[])))))))))))))))))))))
                (append name0
                  (append
                    (' '::('t'::('o'::(' '::('Z'::('i'::('g'::(':'::[]))))))))
                    (append (newLine::[]) (concat0 (newLine::[]) errs)))))))

  (** val coq_OutputZigAPI : Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

  let coq_OutputZigAPI =
    { Coq7_Compilers.ToString.comment_block = comment_block;
      Coq7_Compilers.ToString.comment_file_header_block =
      comment_module_header_block;
      Coq7_Compilers.ToString.coq_ToFunctionLines = coq_ToFunctionLines;
      Coq7_Compilers.ToString.header = header;
      Coq7_Compilers.ToString.footer = (fun _ _ _ _ _ _ _ _ _ -> []);
      Coq7_Compilers.ToString.strip_special_infos = (fun _ infos -> infos) }
 end

type base_system =
| Bin
| Hex
| Oct
| Dec0

type spec =
| Unit
| Bool
| String
| Int of base_system list
| Nat of base_system list
| Tuple of spec list
| Symbol of char list list
| CustomSymbol of (char list * __) list
| Custom of (char list -> __ option) * char list

type key0 =
| Long_key of char list
| Short_key of char list

type doc = char list list

type usage_msg = char list list

type spec_data = __

type spec_data_with_key = (char list * spec_data) list

type opt_spec_data = __

type keyed_spec_list_data = __

type spec_list_data = __

(** val update_type_of_list : __ list -> ('a1 -> 'a2) -> __ -> __ **)

let rec update_type_of_list ts f =
  match ts with
  | [] -> Obj.magic f
  | _ :: ts0 ->
    update_type_of_list ts0 (fun pat ->
      let (t1, t0) = Obj.magic pat in Obj.magic ((f t1), t0))

(** val update_type_of_list2 : __ list -> (__ -> __) -> __ -> __ **)

let rec update_type_of_list2 = function
| [] -> (fun f pat -> let (t0, t1) = Obj.magic pat in Obj.magic (t0, (f t1)))
| _ :: ts0 ->
  (fun f v ->
    let v0 =
      update_type_of_list ts0 (fun pat ->
        let (y, c0) = pat in let (a, b) = y in (a, (b, c0))) v
    in
    update_type_of_list ts0 (fun pat ->
      let (a, y) = pat in let (b, c0) = y in ((a, b), c0))
      (update_type_of_list2 ts0 f v0))

(** val cons_type_of_list : __ list -> 'a1 -> __ -> __ **)

let cons_type_of_list xs v =
  update_type_of_list xs (fun x -> (v, x))

(** val cons_type_of_list' : __ list -> 'a1 -> __ -> __ **)

let cons_type_of_list' xs v =
  match xs with
  | [] -> (fun _ -> Obj.magic v)
  | _ :: l -> cons_type_of_list l v

(** val uncons_type_of_list : __ list -> __ -> 'a1 * __ **)

let rec uncons_type_of_list = function
| [] -> (fun v -> ((Obj.magic v), (Obj.magic ())))
| _ :: ls0 ->
  (fun v ->
    let (p, vs) = uncons_type_of_list ls0 v in
    let (v0, v') = Obj.magic p in (v0, (cons_type_of_list' ls0 v' vs)))

(** val split_type_of_list_' : __ list -> __ list -> __ -> __ * __ **)

let rec split_type_of_list_' ls1 ls2 =
  match ls1 with
  | [] -> uncons_type_of_list (app [] ls2)
  | _ :: ls3 -> split_type_of_list_' ls3 ls2

(** val split_type_of_list' : __ list -> __ list -> __ -> __ * __ **)

let split_type_of_list' ls1 ls2 =
  match ls1 with
  | [] -> (fun x -> ((Obj.magic ()), x))
  | _ :: l -> split_type_of_list_' l ls2

(** val make_symlist :
    char list -> char list -> char list -> char list list -> char list **)

let make_symlist prefix1 sep suffix = function
| [] -> '<'::('n'::('o'::('n'::('e'::('>'::[])))))
| h :: t0 ->
  append
    (fold_left (fun x y -> append x (append sep y)) t0 (append prefix1 h))
    suffix

(** val doc_length : doc -> nat **)

let doc_length d =
  fold_right Nat.add O (map length0 d)

(** val print_key : key0 -> char list **)

let print_key = function
| Long_key k0 -> append ('-'::('-'::[])) k0
| Short_key k0 -> append ('-'::[]) k0

(** val print_key_list : key0 list -> char list **)

let print_key_list k = match k with
| [] -> '<'::('n'::('o'::('n'::('e'::('>'::[])))))
| _ :: _ -> concat0 (','::(' '::[])) (map print_key k)

(** val print_spec_parts :
    (((key0 list, char list) sum * spec) * doc) -> char list * char list list **)

let print_spec_parts = function
| (p, d) ->
  let (k, s0) = p in
  if Nat.ltb O (doc_length d)
  then ((append (' '::(' '::[]))
          (append (match k with
                   | Inl k0 -> print_key_list k0
                   | Inr k0 -> k0)
            (append (' '::[])
              (match s0 with
               | Unit -> []
               | Bool -> []
               | String -> []
               | Int _ -> []
               | Nat _ -> []
               | Tuple _ -> []
               | Symbol syms ->
                 make_symlist ('{'::[]) ('|'::[]) ('}'::[]) syms
               | CustomSymbol syms ->
                 make_symlist ('{'::[]) ('|'::[]) ('}'::[]) (map fst syms)
               | Custom (_, _) -> [])))),
         (app ((hd [] d) :: [])
           (app (tl d) (if Nat.eqb (length (tl d)) O then [] else [] :: []))))
  else ([], [])

(** val print_spec_short : char list -> spec -> char list **)

let print_spec_short k = function
| Unit -> k
| Bool -> k
| String -> k
| Int _ -> k
| Nat _ -> k
| Tuple _ -> k
| Symbol syms -> make_symlist ('{'::[]) ('|'::[]) ('}'::[]) syms
| CustomSymbol syms ->
  make_symlist ('{'::[]) ('|'::[]) ('}'::[]) (map fst syms)
| Custom (_, _) -> k

(** val help_specs : ((key0 list * spec) * doc) list **)

let help_specs =
  ((((Short_key ('h'::[])) :: ((Long_key
    ('h'::('e'::('l'::('p'::[]))))) :: [])), Unit),
    (('D'::('i'::('s'::('p'::('l'::('a'::('y'::(' '::('t'::('h'::('i'::('s'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::[])))))))))))))))))))))))))))) :: [])) :: []

(** val arg_matches_key : char list -> key0 -> bool **)

let arg_matches_key arg k =
  eqb0 arg (print_key k)

(** val arg_matches_key_list : char list -> key0 list -> bool **)

let arg_matches_key_list arg k =
  fold_right (||) false (map (arg_matches_key arg) k)

(** val parse_bool_opt : char list -> bool option **)

let parse_bool_opt s0 =
  if eqb0 s0 ('t'::('r'::('u'::('e'::[]))))
  then Some true
  else if eqb0 s0 ('f'::('a'::('l'::('s'::('e'::[])))))
       then Some false
       else None

(** val print_base_system : base_system -> char list **)

let print_base_system = function
| Bin -> 'b'::('i'::('n'::('a'::('r'::('y'::[])))))
| Hex ->
  'h'::('e'::('x'::('a'::('d'::('e'::('c'::('i'::('m'::('a'::('l'::[]))))))))))
| Oct -> 'o'::('c'::('t'::('a'::('l'::[]))))
| Dec0 -> 'd'::('e'::('c'::('i'::('m'::('a'::('l'::[]))))))

(** val print_base_systems : base_system list -> char list **)

let print_base_systems b =
  match rev1 b with
  | [] -> '<'::('m'::('a'::('g'::('i'::('c'::('a'::('l'::('>'::[]))))))))
  | b0 :: bs ->
    (match bs with
     | [] -> print_base_system b0
     | b1 :: l ->
       (match l with
        | [] ->
          append (print_base_system b1)
            (append (' '::('o'::('r'::(' '::[])))) (print_base_system b0))
        | _ :: _ ->
          concat0 (','::(' '::[]))
            (app (map print_base_system (rev1 bs))
              ((append ('o'::('r'::(' '::[]))) (print_base_system b0)) :: []))))

(** val parse_int_as_opt : base_system -> char list -> z option **)

let parse_int_as_opt b s0 =
  let (to_Z2, of_Z2) =
    match b with
    | Bin -> (to_Z0, of_Z0)
    | Hex -> (to_Z, of_Z)
    | Oct -> (to_Z1, of_Z1)
    | Dec0 ->
      ((fun s1 -> sequence_return (Coq0_Z.of_string s1) Z0), Coq0_Z.to_string)
  in
  let v = to_Z2 s0 in let s' = of_Z2 v in if eqb0 s0 s' then Some v else None

(** val parse_int_opt :
    base_system list -> char list -> (base_system * z) option **)

let parse_int_opt b s0 =
  fold_right (fun b0 default0 ->
    match parse_int_as_opt b0 s0 with
    | Some v -> Some (b0, v)
    | None -> default0) None b

(** val parse_nat_opt :
    base_system list -> char list -> (base_system * nat) option **)

let parse_nat_opt b s0 =
  option_map (fun pat -> let (b0, z0) = pat in (b0, (Coq_Z.to_nat z0)))
    (parse_int_opt b s0)

type parse_error =
| Help of char list
| Missing of char list * char list
| Wrong of char list * char list * char list * char list
| No_keyed_arg of char list * char list list
| Missing_prog_name
| Too_many_args of char list * char list list
| Out_of_fuel of char list
| Internal_error of char list * char list

type 't parse_result = (parse_error, 't) errorT

(** val parse_args_via_spec :
    spec -> char list list -> parse_error -> (char list -> char list ->
    parse_error) -> (spec_data * char list list) parse_result **)

let rec parse_args_via_spec s0 argv missing wrong =
  match s0 with
  | Unit -> Success ((Obj.magic ()), argv)
  | Bool ->
    (match argv with
     | [] -> Error missing
     | arg :: argv0 ->
       bind0
         (match parse_bool_opt arg with
          | Some b -> Success (Obj.magic b)
          | None ->
            Error
              (wrong arg
                ('a'::(' '::('b'::('o'::('o'::('l'::('e'::('a'::('n'::[])))))))))))
         (fun v -> Success (v, argv0)))
  | String ->
    (match argv with
     | [] -> Error missing
     | arg :: argv0 -> Success ((Obj.magic arg), argv0))
  | Int b ->
    (match argv with
     | [] -> Error missing
     | arg :: argv0 ->
       bind0
         (match parse_int_opt b arg with
          | Some v -> Success (Obj.magic v)
          | None ->
            Error
              (wrong arg
                (append ('a'::(' '::[]))
                  (append (print_base_systems b)
                    (' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::[]))))))))))))
         (fun v -> Success (v, argv0)))
  | Nat b ->
    (match argv with
     | [] -> Error missing
     | arg :: argv0 ->
       bind0
         (match parse_nat_opt b arg with
          | Some v -> Success (Obj.magic v)
          | None ->
            Error
              (wrong arg
                (append ('a'::(' '::[]))
                  (append (print_base_systems b)
                    (' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::[]))))))))))))
         (fun v -> Success (v, argv0)))
  | Tuple ls0 ->
    (match ls0 with
     | [] -> Success ((Obj.magic ()), argv)
     | l :: ls ->
       bind0 (parse_args_via_spec l argv missing wrong) (fun lv ->
         let (lv0, argv0) = lv in
         let rec f = function
         | [] -> (fun _ lv1 argv1 -> Success (lv1, argv1))
         | y :: l1 ->
           (fun _ lv1 argv1 ->
             bind0 (parse_args_via_spec y argv1 missing wrong) (fun xv ->
               let (xv0, argv2) = xv in Obj.magic f l1 __ (lv1, xv0) argv2))
         in f ls __ lv0 argv0))
  | Symbol syms ->
    (match argv with
     | [] -> Error missing
     | arg :: argv0 ->
       if existsb (fun s1 -> eqb0 arg s1) syms
       then Success ((Obj.magic arg), argv0)
       else Error
              (wrong arg
                (append
                  ('o'::('n'::('e'::(' '::('o'::('f'::(':'::(' '::[]))))))))
                  (make_symlist [] (' '::[]) [] syms))))
  | CustomSymbol syms ->
    (match argv with
     | [] -> Error missing
     | arg :: argv0 ->
       (match find (fun pat -> let (s1, _) = pat in eqb0 arg s1) syms with
        | Some p -> let (_, v) = p in Success (v, argv0)
        | None ->
          Error
            (wrong arg
              (append
                ('o'::('n'::('e'::(' '::('o'::('f'::(':'::(' '::[]))))))))
                (make_symlist [] (' '::[]) [] (map fst syms))))))
  | Custom (parse, expected_descr) ->
    (match argv with
     | [] -> Error missing
     | arg :: argv0 ->
       bind0
         (match parse arg with
          | Some v -> Success v
          | None -> Error (wrong arg expected_descr)) (fun v -> Success (v,
         argv0)))

type arg_spec = { named_args : ((key0 list * spec) * doc) list;
                  anon_args : ((char list * spec) * doc) list;
                  anon_opt_args : ((char list * spec) * doc) list;
                  anon_opt_repeated_arg : ((char list * spec) * doc) option }

type shouldBlockIndent =
| NoIndent
| ArbitraryIndent
| IndentUpTo of nat

(** val spaces : nat -> char list **)

let spaces n3 =
  string_of_list_ascii (repeat ' ' n3)

(** val maybe_block_indent :
    shouldBlockIndent -> nat -> char list -> char list list -> char list list **)

let maybe_block_indent should_block_indent indent0 lhs rhs =
  let lhs0 = append lhs (' '::(' '::[])) in
  let indent1 =
    match should_block_indent with
    | NoIndent -> spaces (length0 lhs0)
    | ArbitraryIndent -> spaces indent0
    | IndentUpTo n3 -> spaces (Nat.min indent0 n3)
  in
  (append lhs0
    (append (substring O (sub (length0 indent1) (length0 lhs0)) indent1)
      (hd [] rhs))) :: (map (fun s0 -> append indent1 s0) (tl rhs))

(** val usage_string :
    shouldBlockIndent -> arg_spec -> usage_msg -> char list list **)

let usage_string should_block_indent specs err0 =
  app err0
    (app ((newLine::[]) :: [])
      (let spec_parts =
         app
           (map (fun pat ->
             let (y, d) = pat in
             let (k, s0) = y in print_spec_parts (((Inl k), s0), d))
             (app specs.named_args help_specs))
           (map (fun pat ->
             let (y, d) = pat in
             let (k, s0) = y in print_spec_parts (((Inr k), s0), d))
             (app specs.anon_args
               (app specs.anon_opt_args
                 (match specs.anon_opt_repeated_arg with
                  | Some v -> v :: []
                  | None -> []))))
       in
       let max_length =
         fold_right Nat.max O (map length0 (map fst spec_parts))
       in
       flat_map (fun pat ->
         let (lhs, rhs) = pat in
         maybe_block_indent should_block_indent (add (S (S O)) max_length)
           lhs rhs) spec_parts))

type arg_spec_results =
  ((keyed_spec_list_data * spec_list_data) * spec_list_data) * __

(** val consume_one_named_arg :
    char list -> char list list -> ((key0 list * spec) * doc) -> parse_error
    -> (char list -> char list -> parse_error) -> ((spec_data_with_key ->
    spec_data_with_key) * char list list) option parse_result **)

let consume_one_named_arg arg argv named_arg missing wrong =
  if arg_matches_key_list arg (fst (fst named_arg))
  then bind0 (parse_args_via_spec (snd (fst named_arg)) argv missing wrong)
         (fun res -> Success (Some ((fun data_so_far ->
         app data_so_far ((arg, (fst res)) :: [])), (snd res))))
  else Success None

(** val consume_named_arg :
    char list -> char list list -> ((key0 list * spec) * doc) list ->
    (char list -> parse_error) -> (char list -> char list -> char list ->
    parse_error) -> ((keyed_spec_list_data ->
    keyed_spec_list_data) * char list list) parse_result **)

let rec consume_named_arg arg argv named_args0 missing wrong =
  match named_args0 with
  | [] -> Success ((fun data_so_far -> data_so_far), (arg :: argv))
  | p :: named_args1 ->
    let (p0, d) = p in
    let (k, s0) = p0 in
    bind0
      (consume_one_named_arg arg argv ((k, s0), d) (missing arg) (wrong arg))
      (fun lv ->
      match lv with
      | Some p1 ->
        let (upd, argv0) = p1 in
        Success ((update_type_of_list (map (Obj.magic __) named_args1) upd),
        argv0)
      | None ->
        bind0 (consume_named_arg arg argv named_args1 missing wrong)
          (fun rec0 ->
          let (upd, argv0) = rec0 in
          Success
          (((match named_args1 with
             | [] -> (fun _ x -> x)
             | p1 :: xs ->
               let (p2, _) = p1 in
               let (_, _) = p2 in
               update_type_of_list2
                 (let rec map6 = function
                  | [] -> []
                  | _ :: t0 -> __ :: (map6 t0)
                  in map6 xs)) upd), argv0)))

(** val consume_help_or_named_arg :
    char list -> char list list -> ((key0 list * spec) * doc) list ->
    (char list -> parse_error) -> (char list -> char list -> char list ->
    parse_error) -> parse_error -> ((keyed_spec_list_data ->
    keyed_spec_list_data) * char list list) parse_result **)

let consume_help_or_named_arg arg argv named_args0 missing wrong help =
  if arg_matches_key_list arg ((Short_key ('h'::[])) :: ((Long_key
       ('h'::('e'::('l'::('p'::[]))))) :: []))
  then Error help
  else consume_named_arg arg argv named_args0 missing wrong

(** val consume_one_anon_arg :
    bool -> char list list -> spec -> parse_error -> (char list -> char list
    -> parse_error) -> (opt_spec_data * char list list) parse_result **)

let consume_one_anon_arg opt argv s0 missing wrong =
  match parse_args_via_spec s0 argv missing wrong with
  | Success v0 ->
    let (v, argv0) = v0 in
    Success ((if opt then Obj.magic (Some v) else v), argv0)
  | Error err0 -> if opt then Success ((Obj.magic None), argv) else Error err0

(** val build_type_of_list_map : 'a1 list -> 'a3 -> ('a1 -> 'a2) -> __ **)

let rec build_type_of_list_map ls v vf =
  match ls with
  | [] -> Obj.magic v
  | l' :: ls0 -> build_type_of_list_map ls0 (Obj.magic (v, (vf l'))) vf

(** val cons_spec_list_data :
    bool -> char list -> spec -> doc -> ((char list * spec) * doc) list ->
    opt_spec_data -> spec_list_data -> spec_list_data **)

let cons_spec_list_data _ _ _ _ = function
| [] -> (fun v _ -> v)
| p :: l ->
  let (p0, _) = p in
  let (_, _) = p0 in
  (fun v vs ->
  cons_type_of_list
    (let rec map6 = function
     | [] -> []
     | _ :: t0 -> __ :: (map6 t0)
     in map6 l) v vs)

(** val empty_spec_list_data_opt :
    ((char list * spec) * doc) list -> spec_list_data **)

let empty_spec_list_data_opt = function
| [] -> Obj.magic ()
| p :: l ->
  let (p0, _) = p in
  let (_, _) = p0 in
  build_type_of_list_map l None (fun pat ->
    let (p1, _) = pat in let (_, _) = p1 in None)

(** val empty_opt_repeated_arg : (('a1 * spec) * 'a2) option -> __ **)

let empty_opt_repeated_arg = function
| Some p -> let (p0, _) = p in let (_, _) = p0 in Obj.magic []
| None -> Obj.magic ()

(** val consume_args :
    nat -> char list list -> arg_spec -> (char list -> parse_error) ->
    (char list -> char list -> char list -> parse_error) -> (char list list
    -> parse_error) -> (char list -> parse_error) -> (char list list ->
    parse_error) -> parse_error -> parse_error -> ((((keyed_spec_list_data ->
    keyed_spec_list_data) * spec_list_data) * spec_list_data) * __)
    parse_result **)

let rec consume_args fuel0 argv s0 missing wrong too_many internal_error no_keyed_arg help out_of_fuel =
  let do_recr = fun s1 fuel' argv' ->
    if list_beq eqb0 argv argv'
    then (match argv' with
          | [] ->
            Error
              (internal_error
                ('E'::('n'::('c'::('o'::('u'::('n'::('t'::('e'::('r'::('e'::('d'::(' '::('e'::('m'::('p'::('t'::('y'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('l'::('i'::('s'::('t'::(' '::('w'::('h'::('e'::('n'::(' '::('d'::('o'::('i'::('n'::('g'::(' '::('r'::('e'::('c'::('u'::('r'::('s'::('i'::('o'::('n'::(' '::('i'::('n'::(' '::('c'::('o'::('n'::('s'::('u'::('m'::('e'::('_'::('a'::('r'::('g'::('s'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
          | arg :: _ ->
            if startswith ('-'::[]) arg
            then Error (no_keyed_arg (arg :: []))
            else Error (too_many argv'))
    else consume_args fuel' argv' s1 missing wrong too_many internal_error
           no_keyed_arg help out_of_fuel
  in
  (match argv with
   | [] ->
     (match s0.anon_args with
      | [] ->
        Success ((((fun data -> data), (Obj.magic ())),
          (empty_spec_list_data_opt s0.anon_opt_args)),
          (empty_opt_repeated_arg s0.anon_opt_repeated_arg))
      | p :: _ -> let (p0, _) = p in let (k, _) = p0 in Error (missing k))
   | arg :: argv0 ->
     (match fuel0 with
      | O -> Error out_of_fuel
      | S fuel' ->
        if startswith ('-'::[]) arg
        then bind0
               (consume_help_or_named_arg arg argv0 s0.named_args missing
                 wrong help) (fun res ->
               let (upd0, argv1) = res in
               bind0 (do_recr s0 fuel' argv1) (fun res0 ->
                 let (p, anon_opt_repeated_data) = res0 in
                 let (p0, anon_opt_data) = p in
                 let (upd1, anon_data) = p0 in
                 Success ((((fun data -> upd1 (upd0 data)), anon_data),
                 anon_opt_data), anon_opt_repeated_data)))
        else let sna = s0.named_args in
             (match s0.anon_args with
              | [] ->
                (match s0.anon_opt_args with
                 | [] ->
                   (match s0.anon_opt_repeated_arg with
                    | Some p ->
                      let (p0, d) = p in
                      let (k, s1) = p0 in
                      bind0
                        (consume_one_anon_arg false (arg :: argv0) s1
                          (missing k) (wrong k)) (fun res ->
                        let (v, argv1) = res in
                        bind0
                          (Obj.magic do_recr { named_args = sna; anon_args =
                            []; anon_opt_args = []; anon_opt_repeated_arg =
                            (Some ((k, s1), d)) } fuel' argv1) (fun res0 ->
                          let (p1, vs) = res0 in
                          let (p2, s2) = p1 in
                          let (upd, s3) = p2 in
                          let () = s3 in
                          let () = s2 in
                          Success (((upd, (Obj.magic ())), (Obj.magic ())),
                          (Obj.magic (v :: vs)))))
                    | None -> Error (too_many (arg :: argv0)))
                 | p :: saoa ->
                   let (p0, d) = p in
                   let (k, s1) = p0 in
                   bind0
                     (consume_one_anon_arg true (arg :: argv0) s1 (missing k)
                       (wrong k)) (fun res ->
                     let (v, argv1) = res in
                     bind0
                       (Obj.magic do_recr { named_args = sna; anon_args = [];
                         anon_opt_args = saoa; anon_opt_repeated_arg =
                         s0.anon_opt_repeated_arg } fuel' argv1) (fun res0 ->
                       let (p1, rest) = res0 in
                       let (p2, vs) = p1 in
                       let (upd, s2) = p2 in
                       let () = s2 in
                       Success (((upd, (Obj.magic ())),
                       (cons_spec_list_data true k s1 d { named_args = sna;
                         anon_args = []; anon_opt_args = saoa;
                         anon_opt_repeated_arg =
                         s0.anon_opt_repeated_arg }.anon_opt_args v vs)),
                       rest))))
              | p :: saa ->
                let (p0, d) = p in
                let (k, s1) = p0 in
                bind0
                  (consume_one_anon_arg false (arg :: argv0) s1 (missing k)
                    (wrong k)) (fun res ->
                  let (v, argv1) = res in
                  bind0
                    (do_recr { named_args = sna; anon_args = saa;
                      anon_opt_args = s0.anon_opt_args;
                      anon_opt_repeated_arg = s0.anon_opt_repeated_arg }
                      fuel' argv1) (fun res0 ->
                    let (p1, rest) = res0 in
                    let (p2, rest_opt) = p1 in
                    let (upd, vs) = p2 in
                    Success (((upd,
                    (cons_spec_list_data false k s1 d { named_args = sna;
                      anon_args = saa; anon_opt_args = s0.anon_opt_args;
                      anon_opt_repeated_arg =
                      s0.anon_opt_repeated_arg }.anon_args v vs)), rest_opt),
                    rest))))))

(** val default_named_result : spec -> spec_data_with_key **)

let default_named_result _ =
  []

(** val default_named_results' :
    ((key0 list * spec) * doc) list -> 'a1 -> __ **)

let rec default_named_results' ss t0 =
  match ss with
  | [] -> Obj.magic t0
  | p :: ss0 ->
    let (p0, _) = p in
    let (_, s0) = p0 in
    default_named_results' ss0 (Obj.magic (t0, (default_named_result s0)))

(** val default_named_results :
    ((key0 list * spec) * doc) list -> keyed_spec_list_data **)

let default_named_results = function
| [] -> Obj.magic ()
| p :: ss ->
  let (p0, _) = p in
  let (_, s0) = p0 in default_named_results' ss (default_named_result s0)

type prog_name_countT = nat

(** val parse_argv :
    prog_name_countT -> char list list -> arg_spec -> arg_spec_results
    parse_result **)

let parse_argv prog_name_count argv arg_spec0 =
  if Nat.ltb (length argv) prog_name_count
  then Error Missing_prog_name
  else let (prog_names, argv0) = ((firstn prog_name_count argv),
         (skipn prog_name_count argv))
       in
       let prog_name = concat0 (' '::[]) prog_names in
       bind0
         (consume_args
           (add (S (S (S (S (S (S (S (S (S (S O)))))))))) (length argv0))
           argv0 arg_spec0 (fun x -> Missing (prog_name, x)) (fun x x0 x1 ->
           Wrong (prog_name, x, x0, x1)) (fun x -> Too_many_args (prog_name,
           x)) (fun x -> Internal_error (prog_name, x)) (fun x ->
           No_keyed_arg (prog_name, x)) (Help prog_name) (Out_of_fuel
           prog_name)) (fun res ->
         let (p, anon_opt_repeated_data) = res in
         let (p0, anon_opt_data) = p in
         let (upd, anon_data) = p0 in
         Success ((((upd (default_named_results arg_spec0.named_args)),
         anon_data), anon_opt_data), anon_opt_repeated_data))

(** val is_real_error : parse_error -> bool **)

let is_real_error = function
| Help _ -> false
| Missing (_, _) -> true
| Wrong (_, _, _, _) -> true
| No_keyed_arg (_, _) -> true
| Missing_prog_name -> true
| Too_many_args (_, _) -> true
| Out_of_fuel _ -> true
| Internal_error (_, _) -> true

(** val make_usage : char list -> arg_spec -> char list **)

let make_usage prog_name spec0 =
  append ('U'::('S'::('A'::('G'::('E'::(':'::(' '::[])))))))
    (append prog_name
      (append
        (' '::('['::('O'::('P'::('T'::('S'::('.'::('.'::('.'::(']'::(' '::[])))))))))))
        (concat0 (' '::[])
          (app
            (map (fun pat ->
              let (y, _) = pat in let (k, s0) = y in print_spec_short k s0)
              spec0.anon_args)
            (app
              (map (fun pat ->
                let (y, _) = pat in
                let (k, s0) = y in
                append ('['::[]) (append (print_spec_short k s0) (']'::[])))
                spec0.anon_opt_args)
              (match spec0.anon_opt_repeated_arg with
               | Some p ->
                 let (p0, _) = p in
                 let (k, s0) = p0 in
                 (append ('['::[])
                   (append (print_spec_short k s0)
                     ('.'::('.'::('.'::(']'::[])))))) :: []
               | None -> []))))))

(** val show_list_parse_error :
    shouldBlockIndent -> arg_spec -> parse_error -> char list list **)

let show_list_parse_error should_block_indent spec0 err0 =
  let mk_usage = fun prog_name err1 ->
    app
      (usage_string should_block_indent spec0
        (app err1 ((newLine::[]) :: ((make_usage prog_name spec0) :: []))))
      ((newLine::[]) :: [])
  in
  (match err0 with
   | Help prog_name -> mk_usage prog_name []
   | Missing (prog_name, opt_name) ->
     mk_usage prog_name
       ((append prog_name
          (append
            (':'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::(' '::('\''::[]))))))))))
            (append opt_name
              ('\''::(' '::('n'::('e'::('e'::('d'::('s'::(' '::('a'::('n'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('.'::[]))))))))))))))))))))))) :: [])
   | Wrong (prog_name, opt_name, got, expected) ->
     mk_usage prog_name
       ((append prog_name
          (append
            (':'::(' '::('w'::('r'::('o'::('n'::('g'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('\''::[]))))))))))))))))))
            (append got
              (append
                ('\''::(';'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::(' '::('\''::[])))))))))))
                (append opt_name
                  (append
                    ('\''::(' '::('e'::('x'::('p'::('e'::('c'::('t'::('s'::(' '::[]))))))))))
                    (append expected ('.'::[])))))))) :: [])
   | No_keyed_arg (prog_name, invalid_args) ->
     mk_usage prog_name
       ((append prog_name
          (append
            (':'::(' '::('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('k'::('e'::('y'::('e'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[]))))))))))))))))))))))))))))))))
            (concat0 (' '::[]) invalid_args))) :: [])
   | Missing_prog_name ->
     (append
       ('E'::('m'::('p'::('t'::('y'::(' '::('a'::('r'::('g'::('v'::[]))))))))))
       (newLine::[])) :: []
   | Too_many_args (prog_name, remaining) ->
     mk_usage prog_name
       ((append prog_name
          (append
            (':'::(' '::('u'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::[]))))))))))))))))))))))))))
            (concat0 (' '::[]) remaining))) :: [])
   | Out_of_fuel prog_name ->
     mk_usage prog_name
       ((append prog_name
          (':'::(' '::('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('f'::('a'::('t'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('w'::('h'::('i'::('l'::('e'::(' '::('p'::('a'::('r'::('s'::('i'::('n'::('g'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::(' '::('l'::('i'::('n'::('e'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(':'::(' '::('O'::('u'::('t'::(' '::('o'::('f'::(' '::('f'::('u'::('e'::('l'::(' '::('('::('p'::('r'::('o'::('b'::('a'::('b'::('l'::('y'::(' '::('a'::(' '::('b'::('u'::('g'::('g'::('e'::('d'::(' '::('c'::('o'::('m'::('m'::('a'::('n'::('d'::(' '::('l'::('i'::('n'::('e'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('s'::('p'::('e'::('c'::('i'::('f'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
   | Internal_error (prog_name, msg) ->
     mk_usage prog_name
       ((append prog_name
          (append
            (':'::(' '::('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('('::('p'::('l'::('e'::('a'::('s'::('e'::(' '::('r'::('e'::('p'::('o'::('r'::('t'::(' '::('a'::('s'::(' '::('a'::(' '::('b'::('u'::('g'::(')'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))
            msg)) :: []))

(** val default_should_block_indent : shouldBlockIndent **)

let default_should_block_indent =
  ArbitraryIndent

module ForExtraction =
 struct
  type coq_SynthesisKind =
  | Coq_word_by_word_montgomery
  | Coq_unsaturated_solinas
  | Coq_saturated_solinas
  | Coq_dettman_multiplication
  | Coq_solinas_reduction
  | Coq_base_conversion

  (** val parse_SynthesisKind_list : (char list * coq_SynthesisKind) list **)

  let parse_SynthesisKind_list =
    (('w'::('o'::('r'::('d'::('-'::('b'::('y'::('-'::('w'::('o'::('r'::('d'::('-'::('m'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::[]))))))))))))))))))))))),
      Coq_word_by_word_montgomery) :: ((('u'::('n'::('s'::('a'::('t'::('u'::('r'::('a'::('t'::('e'::('d'::('-'::('s'::('o'::('l'::('i'::('n'::('a'::('s'::[]))))))))))))))))))),
      Coq_unsaturated_solinas) :: ((('s'::('a'::('t'::('u'::('r'::('a'::('t'::('e'::('d'::('-'::('s'::('o'::('l'::('i'::('n'::('a'::('s'::[]))))))))))))))))),
      Coq_saturated_solinas) :: ((('d'::('e'::('t'::('t'::('m'::('a'::('n'::('-'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::[])))))))))))))))))))))),
      Coq_dettman_multiplication) :: ((('s'::('o'::('l'::('i'::('n'::('a'::('s'::('-'::('r'::('e'::('d'::('u'::('c'::('t'::('i'::('o'::('n'::[]))))))))))))))))),
      Coq_solinas_reduction) :: ((('b'::('a'::('s'::('e'::('-'::('c'::('o'::('n'::('v'::('e'::('r'::('s'::('i'::('o'::('n'::[]))))))))))))))),
      Coq_base_conversion) :: [])))))

  (** val parse_string_and :
      (char list -> 'a1 option) -> char list -> (char list * 'a1) option **)

  let parse_string_and parse_T s0 =
    option_map (fun x -> (s0, x)) (parse_T s0)

  (** val parse_Z : char list -> z option **)

  let parse_Z =
    parseZ_arith_strict

  (** val parse_N : char list -> n option **)

  let parse_N =
    parseN_arith_strict

  (** val parse_nat : char list -> nat option **)

  let parse_nat =
    parsenat_arith_strict

  (** val parse_Q : char list -> q option **)

  let parse_Q =
    parseQ_arith_strict

  (** val parse_list_Z : char list -> z list option **)

  let parse_list_Z s0 =
    bind (finalize (parse_list parse_Qexpr) s0) (fun ls ->
      Option.List.bind_list (map eval_Qexpr_strict ls) (fun ls0 ->
        Option.List.bind_list (map q_to_Z_strict ls0) (fun ls1 -> Some ls1)))

  (** val parse_list_REG : char list -> rEG list option **)

  let parse_list_REG s0 =
    finalize (parse_comma_list parse_REG) s0

  (** val parse_list_rewrite_pass :
      char list -> RewritePass.rewrite_pass list option **)

  let parse_list_rewrite_pass s0 =
    finalize (parse_comma_list RewritePass.parse_rewrite_pass) s0

  (** val parse_comma_list_Z : char list -> z list option **)

  let parse_comma_list_Z s0 =
    bind (finalize (parse_comma_list parse_Qexpr) s0) (fun ls ->
      Option.List.bind_list (map eval_Qexpr_strict ls) (fun ls0 ->
        Option.List.bind_list (map q_to_Z_strict ls0) (fun ls1 -> Some ls1)))

  (** val parse_callee_saved_registers :
      char list -> assembly_callee_saved_registers_opt option **)

  let parse_callee_saved_registers s0 =
    finalize parse_assembly_callee_saved_registers_opt s0

  (** val parse_n : char list -> maybeLimbCount option **)

  let parse_n n3 =
    match parse_nat n3 with
    | Some n4 -> Some (NumLimbs n4)
    | None ->
      let idx1 = length0 ('('::('a'::('u'::('t'::('o'::[]))))) in
      let autov = substring O idx1 n3 in
      let numv = substring idx1 (length0 n3) n3 in
      let numv0 = substring O (sub (length0 numv) (S O)) numv in
      let lastch = substring (sub (length0 n3) (S O)) (S O) n3 in
      if (&&) (eqb0 lastch (')'::[]))
           (eqb0 autov ('('::('a'::('u'::('t'::('o'::[]))))))
      then let numv1 = if eqb0 numv0 [] then Some O else parse_nat numv0 in
           option_map (fun x -> Auto x) numv1
      else None

  (** val parse_sc : char list -> (z * (z * z) list) option **)

  let parse_sc =
    parseZ_arith_to_taps

  (** val parse_machine_wordsize : char list -> z option **)

  let parse_machine_wordsize =
    parse_Z

  (** val parse_m : char list -> z option **)

  let parse_m =
    parse_Z

  (** val parse_case_convention : char list -> capitalization_data option **)

  let parse_case_convention =
    parse_capitalization_data_strict

  (** val valid_case_conventions : char list **)

  let valid_case_conventions =
    'f'::('l'::('a'::('t'::(' '::('c'::('a'::('s'::('e'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('f'::('l'::('a'::('t'::('c'::('a'::('s'::('e'::(')'::(','::(' '::('u'::('p'::('p'::('e'::('r'::(' '::('f'::('l'::('a'::('t'::(' '::('c'::('a'::('s'::('e'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('U'::('P'::('P'::('E'::('R'::(' '::('F'::('L'::('A'::('T'::(' '::('C'::('A'::('S'::('E'::(','::(' '::('U'::('P'::('P'::('E'::('R'::('F'::('L'::('A'::('T'::('C'::('A'::('S'::('E'::(')'::(','::(' '::('c'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('l'::('o'::('w'::('e'::('r'::(' '::('c'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::(','::(' '::('l'::('o'::('w'::('e'::('r'::('C'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::(','::(' '::('d'::('r'::('o'::('m'::('e'::('d'::('a'::('r'::('y'::('C'::('a'::('s'::('e'::(')'::(','::(' '::('P'::('a'::('s'::('c'::('a'::('l'::('C'::('a'::('s'::('e'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('U'::('p'::('p'::('e'::('r'::('C'::('a'::('m'::('e'::('l'::('C'::('a'::('s'::('e'::(','::(' '::('U'::('p'::('p'::('e'::('r'::(' '::('C'::('a'::('m'::('e'::('l'::(' '::('C'::('a'::('s'::('e'::(','::(' '::('S'::('t'::('u'::('d'::('l'::('y'::('C'::('a'::('s'::('e'::(')'::(','::(' '::('s'::('n'::('a'::('k'::('e'::('_'::('c'::('a'::('s'::('e'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('p'::('o'::('t'::('h'::('o'::('l'::('e'::('_'::('c'::('a'::('s'::('e'::(')'::(','::(' '::('S'::('C'::('R'::('E'::('A'::('M'::('I'::('N'::('G'::('_'::('S'::('N'::('A'::('K'::('E'::('_'::('C'::('A'::('S'::('E'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('M'::('A'::('C'::('R'::('O'::('_'::('C'::('A'::('S'::('E'::(','::(' '::('C'::('O'::('N'::('S'::('T'::('A'::('N'::('T'::('_'::('C'::('A'::('S'::('E'::(')'::(','::(' '::('c'::('a'::('m'::('e'::('l'::('_'::('S'::('n'::('a'::('k'::('e'::('_'::('C'::('a'::('s'::('e'::(','::(' '::('P'::('a'::('s'::('c'::('a'::('l'::('_'::('S'::('n'::('a'::('k'::('e'::('_'::('C'::('a'::('s'::('e'::(','::(' '::('k'::('e'::('b'::('a'::('b'::('-'::('c'::('a'::('s'::('e'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('d'::('a'::('s'::('h'::('-'::('c'::('a'::('s'::('e'::(','::(' '::('l'::('i'::('s'::('p'::('-'::('c'::('a'::('s'::('e'::(')'::(','::(' '::('d'::('o'::('n'::('e'::('r'::('|'::('c'::('a'::('s'::('e'::(','::(' '::('T'::('R'::('A'::('I'::('N'::('-'::('C'::('A'::('S'::('E'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('C'::('O'::('B'::('O'::('L'::('-'::('C'::('A'::('S'::('E'::(','::(' '::('S'::('C'::('R'::('E'::('A'::('M'::('I'::('N'::('G'::('-'::('K'::('E'::('B'::('A'::('B'::('-'::('C'::('A'::('S'::('E'::(')'::(','::(' '::('T'::('r'::('a'::('i'::('n'::('-'::('C'::('a'::('s'::('e'::(' '::('('::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::('l'::('y'::(':'::(' '::('H'::('T'::('T'::('P'::('-'::('H'::('e'::('a'::('d'::('e'::('r'::('-'::('C'::('a'::('s'::('e'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

  (** val parse_src_n : char list -> nat option **)

  let parse_src_n =
    parse_nat

  (** val parse_limbwidth : char list -> q option **)

  let parse_limbwidth =
    parse_Q

  (** val parse_bounds_multiplier :
      char list option -> char list * q option option **)

  let parse_bounds_multiplier s0 =
    let s1 = sequence_return0 s0 [] in
    (s1,
    (if string_dec s1 []
     then Some None
     else option_map (fun x -> Some x) (parse_Q s1)))

  (** val parse_dirbounds_multiplier :
      char list -> (char list option, char list list) sum -> char list * (q
      option, char list list) sum **)

  let parse_dirbounds_multiplier dir = function
  | Inl s1 ->
    let (s2, q0) = parse_bounds_multiplier s1 in
    (s2,
    (match q0 with
     | Some q1 -> Inl q1
     | None ->
       Inr
         ((append
            ('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::('\''::[])))))))))))))))))
            (append s2
              (append
                ('\''::(' '::('a'::('s'::(' '::('a'::(' '::('\226'::('\132'::('\154'::(' '::('f'::('o'::('r'::(' '::('-'::('-'::[])))))))))))))))))
                (append dir
                  ('b'::('o'::('u'::('n'::('d'::('s'::('-'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::[]))))))))))))))))))))) :: [])))
  | Inr opts ->
    ([], (Inr
      ((append
         ('A'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('-'::('-'::[])))))))))))
         (append dir
           (append
             ('b'::('o'::('u'::('n'::('d'::('s'::('-'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::(' '::('c'::('a'::('n'::(' '::('o'::('n'::('l'::('y'::(' '::('b'::('e'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::(' '::('o'::('n'::('c'::('e'::(';'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::(' '::('w'::('i'::('t'::('h'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
             (concat0 (','::(' '::[])) opts)))) :: [])))

  (** val parse_bounds_list :
      char list option -> char list * z list option option **)

  let parse_bounds_list = function
  | Some s1 -> (s1, (option_map (fun x -> Some x) (parse_list_Z s1)))
  | None -> ([], (Some None))

  (** val parse_dirbounds :
      char list -> (char list option, char list list) sum -> bool ->
      char list * (bounds0, char list list) sum **)

  let parse_dirbounds dir s0 use_bitwidth =
    match s0 with
    | Inl s1 ->
      let (s2, ls) = parse_bounds_list s1 in
      (s2,
      (match ls with
       | Some o ->
         (match o with
          | Some ls0 ->
            if use_bitwidth
            then let err1 =
                   match ls with
                   | Some _ ->
                     if use_bitwidth
                     then (append
                            ('C'::('a'::('n'::('n'::('o'::('t'::(' '::('p'::('a'::('s'::('s'::(' '::('b'::('o'::('t'::('h'::(' '::('-'::('-'::('u'::('s'::('e'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::[]))))))))))))))))))))))))))))))))
                            (append dir
                              (append
                                (' '::('a'::('n'::('d'::(' '::('-'::('-'::[])))))))
                                (append dir
                                  (append
                                    ('b'::('o'::('u'::('n'::('d'::('s'::('='::[])))))))
                                    s2))))) :: []
                     else []
                   | None -> []
                 in
                 let err2 =
                   match ls with
                   | Some _ -> []
                   | None ->
                     (append
                       ('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::[]))))))))))))))))
                       (append dir
                         (append
                           ('b'::('o'::('u'::('n'::('d'::('s'::(' '::('('::[]))))))))
                           (append s2 (')'::[]))))) :: []
                 in
                 Inr (app err1 err2)
            else Inl (Exactly ls0)
          | None -> if use_bitwidth then Inl Use_bitwidth else Inl Use_prime)
       | None ->
         let err1 =
           match ls with
           | Some _ ->
             if use_bitwidth
             then (append
                    ('C'::('a'::('n'::('n'::('o'::('t'::(' '::('p'::('a'::('s'::('s'::(' '::('b'::('o'::('t'::('h'::(' '::('-'::('-'::('u'::('s'::('e'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::[]))))))))))))))))))))))))))))))))
                    (append dir
                      (append
                        (' '::('a'::('n'::('d'::(' '::('-'::('-'::[])))))))
                        (append dir
                          (append
                            ('b'::('o'::('u'::('n'::('d'::('s'::('='::[])))))))
                            s2))))) :: []
             else []
           | None -> []
         in
         let err2 =
           match ls with
           | Some _ -> []
           | None ->
             (append
               ('C'::('o'::('u'::('l'::('d'::(' '::('n'::('o'::('t'::(' '::('p'::('a'::('r'::('s'::('e'::(' '::[]))))))))))))))))
               (append dir
                 (append
                   ('b'::('o'::('u'::('n'::('d'::('s'::(' '::('('::[]))))))))
                   (append s2 (')'::[]))))) :: []
         in
         Inr (app err1 err2)))
    | Inr opts ->
      ([], (Inr
        (app
          ((append
             ('A'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('-'::('-'::[])))))))))))
             (append dir
               (append
                 ('b'::('o'::('u'::('n'::('d'::('s'::(' '::('c'::('a'::('n'::(' '::('o'::('n'::('l'::('y'::(' '::('b'::('e'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::(' '::('o'::('n'::('c'::('e'::(';'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::(' '::('w'::('i'::('t'::('h'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                 (concat0 (','::(' '::[])) opts)))) :: [])
          (if use_bitwidth
           then (append
                  ('C'::('a'::('n'::('n'::('o'::('t'::(' '::('p'::('a'::('s'::('s'::(' '::('b'::('o'::('t'::('h'::(' '::('-'::('-'::('u'::('s'::('e'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::[]))))))))))))))))))))))))))))))))
                  (append dir
                    (append
                      (' '::('a'::('n'::('d'::(' '::('-'::('-'::[])))))))
                      (append dir
                        ('b'::('o'::('u'::('n'::('d'::('s'::[])))))))))) :: []
           else []))))

  (** val show_c : (z * z) list show **)

  let show_c =
    show_list (show_prod PowersOfTwo.show_Z Decimal.show_Z)

  (** val quote : char list -> char list **)

  let quote s0 =
    if (||)
         (existsb (fun ch ->
           existsb (fun badch -> (=) badch ch)
             (' ' :: ('$' :: ('\'' :: ('"' :: ('\\' :: ('#' :: ('=' :: ('!' :: ('>' :: ('<' :: ('|' :: (';' :: ('{' :: ('}' :: ('(' :: (')' :: ('[' :: (']' :: ('*' :: ('?' :: ('~' :: ('&' :: ('`' :: ('/' :: [])))))))))))))))))))))))))
           (list_ascii_of_string s0)) (Nat.eqb (length0 s0) O)
    then append ('\''::[])
           (append
             (replace ('\''::[]) ('\''::('"'::('\''::('"'::('\''::[]))))) s0)
             ('\''::[]))
    else s0

  (** val known_debug_options_with_spec : (char list * char list) list **)

  let known_debug_options_with_spec =
    (('o'::('n'::('-'::('s'::('u'::('c'::('c'::('e'::('s'::('s'::[])))))))))),
      ('I'::('n'::(' '::('a'::('d'::('d'::('i'::('t'::('i'::('o'::('n'::(' '::('t'::('o'::(' '::('p'::('r'::('i'::('n'::('t'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('d'::('e'::('b'::('u'::('g'::(' '::('i'::('n'::('f'::('o'::('r'::('m'::('a'::('t'::('i'::('o'::('n'::(' '::('w'::('h'::('e'::('n'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('s'::(' '::('f'::('a'::('i'::('l'::('s'::(','::(' '::('a'::('l'::('s'::('o'::(' '::('p'::('r'::('i'::('n'::('t'::(' '::('i'::('t'::(' '::('w'::('h'::('e'::('n'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('s'::(' '::('s'::('u'::('c'::('c'::('e'::('e'::('d'::('s'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::[]))))))))),
      ('P'::('r'::('i'::('n'::('t'::(' '::('t'::('h'::('e'::(' '::('A'::('S'::('T'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('a'::('n'::('d'::(' '::('a'::('f'::('t'::('e'::('r'::(' '::('e'::('a'::('c'::('h'::(' '::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::(' '::('p'::('a'::('s'::('s'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])

  (** val known_debug_options : char list list **)

  let known_debug_options =
    ('o'::('n'::('-'::('s'::('u'::('c'::('c'::('e'::('s'::('s'::[])))))))))) :: (('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::[]))))))))) :: [])

  (** val special_debug_options : (char list * flag_option_kind) list **)

  let special_debug_options =
    (('a'::('l'::('l'::[]))), All) :: []

  (** val default_debug : char list **)

  let default_debug =
    'r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::[]))))))))

  (** val known_asm_rewriting_pass_flags : char list list **)

  let known_asm_rewriting_pass_flags =
    ('a'::('d'::('d'::('b'::('y'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))) :: (('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('b'::('i'::('t'::[])))))))))))) :: (('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))) :: (('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('b'::('i'::('t'::[]))))))))))))))) :: (('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))))))) :: (('c'::('o'::('m'::('b'::('i'::('n'::('e'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::[])))))))))))))) :: (('c'::('o'::('n'::('s'::('t'::('p'::('r'::('o'::('p'::[]))))))))) :: (('c'::('o'::('n'::('s'::('t'::('s'::('_'::('c'::('o'::('m'::('m'::('u'::('t'::('a'::('t'::('i'::('v'::('e'::[])))))))))))))))))) :: (('d'::('r'::('o'::('p'::('_'::('i'::('d'::('e'::('n'::('t'::('i'::('t'::('y'::[]))))))))))))) :: (('f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))) :: (('f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('b'::('o'::('u'::('n'::('d'::('e'::('d'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))))))))))) :: (('f'::('o'::('l'::('d'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::('_'::('t'::('o'::('_'::('a'::('n'::('d'::[])))))))))))))))))) :: (('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('0'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))))) :: (('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))))))) :: (('s'::('h'::('i'::('f'::('t'::('_'::('t'::('o'::('_'::('m'::('u'::('l'::[])))))))))))) :: (('s'::('l'::('i'::('c'::('e'::('0'::[])))))) :: (('s'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('Z'::[]))))))))))))))))) :: (('s'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('Z'::[])))))))))))))))))) :: (('s'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))) :: (('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))) :: (('u'::('n'::('a'::('r'::('y'::('_'::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::[])))))))))))))) :: (('x'::('o'::('r'::('_'::('s'::('a'::('m'::('e'::[])))))))) :: [])))))))))))))))))))))

  (** val known_asm_rewriting_pass_flags_with_spec :
      (char list * char list) list **)

  let known_asm_rewriting_pass_flags_with_spec =
    (('a'::('d'::('d'::('b'::('y'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))),
      ('R'::('e'::('p'::('l'::('a'::('c'::('e'::('s'::(' '::('('::('a'::('d'::('d'::(' '::('8'::(','::(' '::('a'::('r'::('g'::('s'::(')'::(' '::('w'::('i'::('t'::('h'::(' '::('('::('a'::('d'::('d'::(' '::('6'::('4'::(','::(' '::('a'::('r'::('g'::('s'::(')'::(' '::('w'::('h'::('e'::('n'::(' '::('d'::('o'::('i'::('n'::('g'::(' '::('s'::('o'::(' '::('d'::('o'::('e'::('s'::('n'::('\''::('t'::(' '::('c'::('h'::('a'::('n'::('g'::('e'::(' '::('s'::('e'::('m'::('a'::('n'::('t'::('i'::('c'::('s'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('b'::('i'::('t'::[])))))))))))),
      ('S'::('i'::('m'::('p'::('l'::('i'::('f'::('i'::('e'::('s'::(' '::('('::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::(' '::('s'::(','::(' '::('['::('c'::('o'::('n'::('s'::('t'::(' '::('a'::(';'::(' '::('b'::(']'::(')'::(' '::('w'::('h'::('e'::('n'::(' '::('b'::(' '::('i'::('s'::(' '::('k'::('n'::('o'::('w'::('n'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('a'::(' '::('s'::('i'::('n'::('g'::('l'::('e'::(' '::('b'::('i'::('t'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))),
      ('R'::('e'::('p'::('l'::('a'::('c'::('e'::('s'::(' '::('('::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::(' '::('_'::(','::(' '::('a'::('r'::('g'::('s'::(')'::(' '::('w'::('i'::('t'::('h'::(' '::('0'::(' '::('w'::('h'::('e'::('n'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('a'::('n'::('a'::('l'::('y'::('s'::('i'::('s'::(' '::('c'::('a'::('n'::(' '::('p'::('r'::('o'::('v'::('e'::(' '::('t'::('h'::('e'::('r'::('e'::('\''::('s'::(' '::('n'::('o'::(' '::('c'::('a'::('r'::('r'::('y'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('b'::('i'::('t'::[]))))))))))))))),
      ('S'::('i'::('m'::('p'::('l'::('i'::('f'::('i'::('e'::('s'::(' '::('('::('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::(' '::('s'::(','::(' '::('['::('c'::('o'::('n'::('s'::('t'::(' '::('a'::(';'::(' '::('b'::(']'::(')'::(' '::('w'::('h'::('e'::('n'::(' '::('b'::(' '::('i'::('s'::(' '::('k'::('n'::('o'::('w'::('n'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('a'::(' '::('s'::('i'::('n'::('g'::('l'::('e'::(' '::('b'::('i'::('t'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::('_'::('s'::('m'::('a'::('l'::('l'::[]))))))))))))))))),
      ('R'::('e'::('p'::('l'::('a'::('c'::('e'::('s'::(' '::('('::('a'::('d'::('d'::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::(' '::('_'::(','::(' '::('a'::('r'::('g'::('s'::(')'::(' '::('w'::('h'::('e'::('n'::(' '::('t'::('h'::('e'::('r'::('e'::(' '::('a'::('r'::('e'::(' '::('a'::('t'::(' '::('m'::('o'::('s'::('t'::(' '::('3'::(' '::('a'::('r'::('g'::('s'::(' '::('a'::('n'::('d'::(' '::('w'::('h'::('e'::('n'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('a'::('n'::('a'::('l'::('y'::('s'::('i'::('s'::(' '::('c'::('a'::('n'::(' '::('p'::('r'::('o'::('v'::('e'::(' '::('t'::('h'::('e'::('r'::('e'::('\''::('s'::(' '::('n'::('o'::(' '::('o'::('v'::('e'::('r'::('f'::('l'::('o'::('w'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('c'::('o'::('m'::('b'::('i'::('n'::('e'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::[])))))))))))))),
      ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('s'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::(' '::('l'::('i'::('k'::('e'::(' '::('('::('x'::(' '::('+'::(' '::('x'::(' '::('*'::(' '::('5'::(')'::(' '::('i'::('n'::('t'::('o'::(' '::('('::('x'::(' '::('*'::(' '::('6'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('c'::('o'::('n'::('s'::('t'::('p'::('r'::('o'::('p'::[]))))))))),
      ('P'::('e'::('r'::('f'::('o'::('r'::('m'::('s'::(' '::('c'::('o'::('n'::('s'::('t'::('a'::('n'::('t'::(' '::('p'::('r'::('o'::('p'::('a'::('g'::('a'::('t'::('i'::('o'::('n'::(','::(' '::('e'::('v'::('a'::('l'::('u'::('a'::('t'::('i'::('n'::('g'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('a'::('r'::('e'::(' '::('k'::('n'::('o'::('w'::('n'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('c'::('o'::('n'::('s'::('t'::('a'::('n'::('t'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('c'::('o'::('n'::('s'::('t'::('s'::('_'::('c'::('o'::('m'::('m'::('u'::('t'::('a'::('t'::('i'::('v'::('e'::[])))))))))))))))))),
      ('M'::('o'::('v'::('e'::('s'::(' '::('a'::('l'::('l'::(' '::('c'::('o'::('n'::('s'::('t'::('a'::('n'::('t'::('s'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('b'::('e'::('g'::('i'::('n'::('n'::('i'::('n'::('g'::(' '::('o'::('f'::(' '::('c'::('o'::('m'::('m'::('u'::('t'::('a'::('t'::('i'::('v'::('e'::(' '::('n'::('-'::('a'::('r'::('y'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::(' '::('l'::('i'::('s'::('t'::('s'::(','::(' '::('a'::('d'::('d'::('i'::('t'::('i'::('o'::('n'::('a'::('l'::('l'::('y'::(' '::('c'::('o'::('m'::('b'::('i'::('n'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('c'::('o'::('n'::('s'::('t'::('a'::('n'::('t'::('s'::(' '::('i'::('n'::('t'::('o'::(' '::('a'::(' '::('s'::('i'::('n'::('g'::('l'::('e'::(' '::('n'::('o'::('d'::('e'::(' '::('w'::('h'::('e'::('n'::(' '::('t'::('h'::('e'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::(' '::('i'::('s'::(' '::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('d'::('r'::('o'::('p'::('_'::('i'::('d'::('e'::('n'::('t'::('i'::('t'::('y'::[]))))))))))))),
      ('D'::('r'::('o'::('p'::('s'::(' '::('c'::('o'::('n'::('s'::('t'::('a'::('n'::('t'::(' '::('i'::('d'::('e'::('n'::('t'::('i'::('t'::('y'::(' '::('s'::('u'::('b'::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::(','::(' '::('s'::('u'::('c'::('h'::(' '::('a'::('s'::(' '::('0'::('s'::(' '::('i'::('n'::(' '::('a'::('d'::('d'::(' '::('a'::('n'::('d'::(' '::('1'::('s'::(' '::('i'::('n'::(' '::('m'::('u'::('l'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))),
      ('F'::('l'::('a'::('t'::('t'::('e'::('n'::('s'::(' '::('n'::('e'::('s'::('t'::('e'::('d'::(' '::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(','::(' '::('s'::('u'::('c'::('h'::(' '::('a'::('s'::(' '::('t'::('u'::('r'::('n'::('i'::('n'::('g'::(' '::('('::('a'::('d'::('d'::(' '::('['::('x'::(';'::(' '::('a'::('d'::('d'::(' '::('['::('y'::(';'::(' '::('z'::(']'::(']'::(')'::(' '::('i'::('n'::('t'::('o'::(' '::('('::('a'::('d'::('d'::(' '::('['::('x'::(';'::(' '::('y'::(';'::(' '::('z'::(']'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('f'::('l'::('a'::('t'::('t'::('e'::('n'::('_'::('b'::('o'::('u'::('n'::('d'::('e'::('d'::('_'::('a'::('s'::('s'::('o'::('c'::('i'::('a'::('t'::('i'::('v'::('e'::[]))))))))))))))))))))))))))),
      ('F'::('l'::('a'::('t'::('t'::('e'::('n'::('s'::(' '::('s'::('o'::('m'::('e'::(' '::('n'::('e'::('s'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(' '::('s'::('u'::('c'::('h'::(' '::('a'::('s'::(' '::('a'::('d'::('d'::(' '::('i'::('n'::('s'::('i'::('d'::('e'::(' '::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('f'::('o'::('l'::('d'::('_'::('c'::('o'::('n'::('s'::('t'::('s'::('_'::('t'::('o'::('_'::('a'::('n'::('d'::[])))))))))))))))))),
      ('T'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::('s'::(' '::('c'::('o'::('n'::('s'::('t'::('a'::('n'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(' '::('t'::('o'::(' '::('b'::('i'::('t'::('w'::('i'::('s'::('e'::(' '::('a'::('n'::('d'::(','::(' '::('d'::('r'::('o'::('p'::('p'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::('m'::(' '::('i'::('f'::(' '::('t'::('h'::('e'::('y'::(' '::('p'::('r'::('o'::('v'::('a'::('b'::('l'::('y'::(' '::('d'::('o'::(' '::('n'::('o'::('t'::(' '::('c'::('h'::('a'::('n'::('g'::('e'::(' '::('t'::('h'::('e'::(' '::('r'::('e'::('s'::('u'::('l'::('t'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('0'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))))),
      ('S'::('i'::('m'::('p'::('l'::('i'::('f'::('i'::('e'::('s'::(' '::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::(' '::('w'::('h'::('e'::('n'::(' '::('t'::('h'::('e'::(' '::('s'::('l'::('i'::('c'::('e'::(' '::('b'::('e'::('i'::('n'::('g'::(' '::('s'::('e'::('t'::(' '::('f'::('u'::('l'::('l'::('y'::(' '::('o'::('v'::('e'::('r'::('w'::('r'::('i'::('t'::('e'::('s'::(' '::('t'::('h'::('e'::(' '::('o'::('r'::('i'::('g'::('i'::('n'::('a'::('l'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))))))),
      ('S'::('i'::('m'::('p'::('l'::('i'::('f'::('i'::('e'::('s'::(' '::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::(' '::('a'::('p'::('p'::('l'::('i'::('e'::('d'::(' '::('t'::('o'::(' '::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[])))))))))))))))))))))))))))))))))))))))))) :: ((('s'::('h'::('i'::('f'::('t'::('_'::('t'::('o'::('_'::('m'::('u'::('l'::[])))))))))))),
      ('R'::('e'::('w'::('r'::('i'::('t'::('e'::('s'::(' '::('s'::('h'::('l'::(' '::('t'::('o'::(' '::('a'::('n'::(' '::('e'::('q'::('u'::('i'::('v'::('a'::('l'::('e'::('n'::('t'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::[]))))))))))))))))))))))))))))))))))))))))))))) :: ((('s'::('l'::('i'::('c'::('e'::('0'::[])))))),
      ('M'::('e'::('r'::('g'::('e'::('s'::(' '::('('::('s'::('l'::('i'::('c'::('e'::(' '::('0'::(' '::('s'::(')'::(' '::('i'::('n'::('t'::('o'::(' '::('a'::('d'::('d'::('Z'::(','::('m'::('u'::('l'::('Z'::(','::('n'::('e'::('g'::('Z'::(','::('s'::('h'::('l'::('Z'::(','::('s'::('h'::('r'::('Z'::(','::('a'::('n'::('d'::('Z'::(','::('o'::('r'::('Z'::(','::('x'::('o'::('r'::('Z'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('s'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('Z'::[]))))))))))))))))),
      ('M'::('e'::('r'::('g'::('e'::('s'::(' '::('('::('s'::('l'::('i'::('c'::('e'::(' '::('0'::(' '::('1'::(')'::(' '::('i'::('n'::('t'::('o'::(' '::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('Z'::[])))))))))))))))))))))))))))))))))) :: ((('s'::('l'::('i'::('c'::('e'::('0'::('1'::('_'::('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('Z'::[])))))))))))))))))),
      ('M'::('e'::('r'::('g'::('e'::('s'::(' '::('('::('s'::('l'::('i'::('c'::('e'::(' '::('0'::(' '::('1'::(')'::(' '::('i'::('n'::('t'::('o'::(' '::('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('Z'::[]))))))))))))))))))))))))))))))))))) :: ((('s'::('l'::('i'::('c'::('e'::('_'::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[]))))))))))))))),
      ('S'::('i'::('m'::('p'::('l'::('i'::('f'::('i'::('e'::('s'::(' '::('s'::('l'::('i'::('c'::('e'::(' '::('a'::('p'::('p'::('l'::('i'::('e'::('d'::(' '::('t'::('o'::(' '::('s'::('e'::('t'::('_'::('s'::('l'::('i'::('c'::('e'::[])))))))))))))))))))))))))))))))))))))) :: ((('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::('_'::('s'::('m'::('a'::('l'::('l'::[])))))))))))))),
      ('S'::('i'::('m'::('p'::('l'::('i'::('f'::('i'::('e'::('s'::(' '::('s'::('l'::('i'::('c'::('e'::(' '::('w'::('h'::('e'::('n'::(' '::('i'::('t'::('\''::('s'::(' '::('a'::(' '::('n'::('o'::('-'::('o'::('p'::[]))))))))))))))))))))))))))))))))))) :: ((('u'::('n'::('a'::('r'::('y'::('_'::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('e'::[])))))))))))))),
      ('S'::('o'::('m'::('e'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(' '::('e'::('q'::('u'::('i'::('v'::('a'::('l'::('e'::('n'::('t'::(' '::('t'::('o'::(' '::('t'::('r'::('u'::('n'::('c'::('a'::('t'::('i'::('o'::('n'::(' '::('w'::('h'::('e'::('n'::(' '::('a'::('p'::('p'::('l'::('i'::('e'::('d'::(' '::('t'::('o'::(' '::('o'::('n'::('l'::('y'::(' '::('o'::('n'::('e'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(';'::(' '::('t'::('h'::('i'::('s'::(' '::('p'::('a'::('s'::('s'::(' '::('c'::('a'::('n'::('o'::('n'::('i'::('c'::('a'::('l'::('i'::('z'::('e'::('s'::(' '::('s'::('u'::('c'::('h'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((('x'::('o'::('r'::('_'::('s'::('a'::('m'::('e'::[])))))))),
      ('R'::('e'::('p'::('l'::('a'::('c'::('e'::('s'::(' '::('x'::('o'::('r'::(' '::('x'::(' '::('x'::(' '::('w'::('i'::('t'::('h'::(' '::('0'::[])))))))))))))))))))))))) :: [])))))))))))))))))))))

  (** val special_asm_rewriting_pass_flags :
      (char list * flag_option_kind) list **)

  let special_asm_rewriting_pass_flags =
    (('a'::('l'::('l'::[]))), All) :: []

  (** val default_asm_rewriting_passes : char list **)

  let default_asm_rewriting_passes =
    'a'::('l'::('l'::[]))

  (** val coq_CollectErrors :
      machine_wordsize_opt -> Coq7_Compilers.ToString.coq_OutputLanguageAPI
      -> ((synthesis_output_kind * char list) * (char list,
      (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list ->
      ((char list, char list list list * char list list list) debugM,
      (char list, char list list) debugM list) sum **)

  let coq_CollectErrors machine_wordsize0 output_language_api res =
    let header0 = hd [] (map snd (map fst res)) in
    let res0 =
      fold_right (fun pat ->
        let (y, res0) = pat in
        let (kind, name0) = y in
        (fun rest ->
        match Debug.eval_result res0 with
        | Success v ->
          (match rest with
           | Inl ls ->
             Inl
               (Debug.sequence (Debug.copy_debug_info res0)
                 (Debug.bind ls (fun ls0 ->
                   Debug.ret
                     (match kind with
                      | Normal_output ->
                        let (ls_normal, ls_asm) = ls0 in
                        ((v :: ls_normal), ls_asm)
                      | Assembly_output ->
                        let (ls_normal, ls_asm) = ls0 in
                        (ls_normal, (v :: ls_asm))))))
           | Inr ls -> Inr ls)
        | Error err0 ->
          let in_name =
            append ('I'::('n'::(' '::[]))) (append name0 (':'::[]))
          in
          let cur =
            match show_lines
                    (Pipeline.show_lines_ErrorMessage machine_wordsize0
                      output_language_api) err0 with
            | [] -> in_name :: []
            | serr :: l ->
              (match l with
               | [] -> (append in_name (append (' '::[]) serr)) :: []
               | s0 :: l0 -> in_name :: (serr :: (s0 :: l0)))
          in
          let rest0 = match rest with
                      | Inl _ -> []
                      | Inr rest0 -> rest0 in
          Inr ((Debug.with_debug_info res0 (Debug.ret cur)) :: rest0))) (Inl
        (Debug.ret ([], []))) res
    in
    (match res0 with
     | Inl ls -> Inl ls
     | Inr err0 -> Inr ((Debug.ret (header0 :: [])) :: err0))

  type supported_languagesT =
    (char list * Coq7_Compilers.ToString.coq_OutputLanguageAPI) list

  (** val default_supported_languages : supported_languagesT **)

  let default_supported_languages =
    (('C'::[]),
      Coq25_Compilers.ToString.C.coq_OutputCAPI) :: ((('R'::('u'::('s'::('t'::[])))),
      Rust.coq_OutputRustAPI) :: ((('G'::('o'::[])),
      Go.coq_OutputGoAPI) :: ((('J'::('a'::('v'::('a'::[])))),
      Java.coq_OutputJavaAPI) :: ((('J'::('S'::('O'::('N'::[])))),
      JSON.coq_OutputJSONAPI) :: ((('Z'::('i'::('g'::[]))),
      Zig.coq_OutputZigAPI) :: [])))))

  (** val describe_flag_options :
      char list -> char list -> (char list * flag_option_kind) list ->
      (char list * char list) list -> char list list **)

  let describe_flag_options kind all_descr special_options known_options_with_spec =
    let len =
      fold_right Nat.max O
        (map length0
          (app (map fst known_options_with_spec) (map fst special_options)))
    in
    let fill = fun s0 -> append s0 (repeat0 ' ' (sub len (length0 s0))) in
    app
      ((append ('V'::('a'::('l'::('i'::('d'::(' '::[]))))))
         (append kind (' '::('f'::('l'::('a'::('g'::('s'::(':'::[]))))))))) :: [])
      (app
        (flat_map (fun pat ->
          let (opt, k) = pat in
          (match k with
           | All ->
             (append ('-'::(' '::[]))
               (append (fill opt) (append (tab::[]) all_descr))) :: []
           | Alias _ -> [])) special_options)
        (app
          (map (fun pat ->
            let (opt, descr) = pat in
            append ('-'::(' '::[]))
              (append (fill opt) (append (tab::[]) descr)))
            known_options_with_spec)
          (flat_map (fun pat ->
            let (opt, k) = pat in
            (match k with
             | All -> []
             | Alias ls ->
               (append ('-'::(' '::[]))
                 (append (fill opt)
                   (append (tab::[])
                     (append
                       ('a'::('n'::(' '::('a'::('l'::('i'::('a'::('s'::(' '::('f'::('o'::('r'::(' '::[])))))))))))))
                       (concat0 (','::[]) ls))))) :: [])) special_options)))

  (** val synthesis_kind_spec : (char list * spec) * doc **)

  let synthesis_kind_spec =
    ((('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('s'::('_'::('k'::('i'::('n'::('d'::[])))))))))))))),
      (CustomSymbol (Obj.magic parse_SynthesisKind_list))),
      (('T'::('h'::('e'::(' '::('a'::('l'::('g'::('o'::('r'::('i'::('t'::('h'::('m'::(' '::('f'::('o'::('r'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::('.'::(' '::(' '::('F'::('u'::('r'::('t'::('h'::('e'::('r'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('d'::('e'::('p'::('e'::('n'::('d'::(' '::('o'::('n'::(' '::('t'::('h'::('e'::(' '::('c'::('h'::('o'::('i'::('c'::('e'::(' '::('o'::('f'::(' '::('a'::('l'::('g'::('o'::('r'::('i'::('t'::('h'::('m'::(','::(' '::('a'::('n'::('d'::(' '::('c'::('a'::('n'::(' '::('b'::('e'::(' '::('v'::('i'::('e'::('w'::('e'::('d'::(' '::('b'::('y'::(' '::('p'::('a'::('s'::('s'::('i'::('n'::('g'::(' '::('-'::('h'::(' '::('a'::('f'::('t'::('e'::('r'::(' '::('t'::('h'::('i'::('s'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('.'::(' '::(' '::('N'::('o'::('t'::('e'::(' '::('t'::('h'::('a'::('t'::(' '::('n'::('o'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('o'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('-'::('h'::(' '::('a'::('r'::('e'::(' '::('p'::('e'::('r'::('m'::('i'::('t'::('t'::('e'::('d'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('t'::('h'::('i'::('s'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val curve_description_spec : (char list * spec) * doc **)

  let curve_description_spec =
    ((('c'::('u'::('r'::('v'::('e'::('_'::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::[]))))))))))))))))),
      String),
      (('A'::(' '::('s'::('t'::('r'::('i'::('n'::('g'::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('w'::('i'::('l'::('l'::(' '::('b'::('e'::(' '::('p'::('r'::('e'::('f'::('i'::('x'::('e'::('d'::(' '::('t'::('o'::(' '::('e'::('v'::('e'::('r'::('y'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('n'::('a'::('m'::('e'::(' '::('g'::('e'::('n'::('e'::('r'::('a'::('t'::('e'::('d'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val lang_default :
      supported_languagesT ->
      char list * Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

  let lang_default supported_languages =
    hd (('C'::[]), Coq25_Compilers.ToString.C.coq_OutputCAPI)
      supported_languages

  (** val lang_spec : supported_languagesT -> (key0 list * spec) * doc **)

  let lang_spec supported_languages =
    let supported_language_names = map fst supported_languages in
    ((((Long_key ('l'::('a'::('n'::('g'::[]))))) :: []), (CustomSymbol
    (Obj.magic supported_languages))),
    ((append
       ('T'::('h'::('e'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::(' '::('c'::('o'::('d'::('e'::(' '::('s'::('h'::('o'::('u'::('l'::('d'::(' '::('b'::('e'::(' '::('e'::('m'::('i'::('t'::('t'::('e'::('d'::(' '::('i'::('n'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::('s'::(' '::('t'::('o'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
       (append (hd ('C'::[]) supported_language_names)
         (' '::('i'::('f'::(' '::('n'::('o'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::(' '::('i'::('s'::(' '::('g'::('i'::('v'::('e'::('n'::('.'::(' '::(' '::('C'::('a'::('s'::('e'::('-'::('s'::('e'::('n'::('s'::('i'::('t'::('i'::('v'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val no_prefix_fiat_spec : (key0 list * spec) * doc **)

  let no_prefix_fiat_spec =
    ((((Long_key
      ('n'::('o'::('-'::('p'::('r'::('e'::('f'::('i'::('x'::('-'::('f'::('i'::('a'::('t'::[]))))))))))))))) :: []),
      Unit),
      (('D'::('o'::('n'::('\''::('t'::(' '::('p'::('r'::('e'::('f'::('i'::('x'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('w'::('i'::('t'::('h'::(' '::('f'::('i'::('a'::('t'::('_'::[]))))))))))))))))))))))))))))))))) :: []))

  (** val package_name_spec : (key0 list * spec) * doc **)

  let package_name_spec =
    ((((Long_key
      ('p'::('a'::('c'::('k'::('a'::('g'::('e'::('-'::('n'::('a'::('m'::('e'::[]))))))))))))) :: []),
      String),
      (('T'::('h'::('e'::(' '::('n'::('a'::('m'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('p'::('a'::('c'::('k'::('a'::('g'::('e'::(','::(' '::('f'::('o'::('r'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('s'::('u'::('p'::('p'::('o'::('r'::('t'::(' '::('i'::('t'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val class_name_spec : (key0 list * spec) * doc **)

  let class_name_spec =
    ((((Long_key
      ('c'::('l'::('a'::('s'::('s'::('-'::('n'::('a'::('m'::('e'::[]))))))))))) :: []),
      String),
      (('T'::('h'::('e'::(' '::('n'::('a'::('m'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('c'::('l'::('a'::('s'::('s'::(','::(' '::('f'::('o'::('r'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('s'::('u'::('p'::('p'::('o'::('r'::('t'::(' '::('i'::('t'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val private_function_case_spec : (key0 list * spec) * doc **)

  let private_function_case_spec =
    ((((Long_key
      ('p'::('r'::('i'::('v'::('a'::('t'::('e'::('-'::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('-'::('c'::('a'::('s'::('e'::[])))))))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_case_convention),
      ('C'::('O'::('N'::('V'::('E'::('N'::('T'::('I'::('O'::('N'::[]))))))))))))),
      (('T'::('h'::('e'::(' '::('c'::('a'::('s'::('e'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::('n'::('o'::('n'::('-'::('e'::('x'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('n'::('a'::('m'::('e'::('s'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::('i'::('s'::(' '::('t'::('o'::(' '::('n'::('o'::('t'::(' '::('a'::('d'::('j'::('u'::('s'::('t'::(' '::('c'::('a'::('s'::('e'::(','::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('i'::('n'::('g'::(' '::('i'::('n'::(','::(' '::('r'::('o'::('u'::('g'::('h'::('l'::('y'::(','::(' '::('s'::('n'::('a'::('k'::('e'::('_'::('c'::('a'::('s'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('V'::('a'::('l'::('i'::('d'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(':'::(' '::[])))))))))))))))))))
        (append valid_case_conventions ('.'::[]))) :: [])))

  (** val public_function_case_spec : (key0 list * spec) * doc **)

  let public_function_case_spec =
    ((((Long_key
      ('p'::('u'::('b'::('l'::('i'::('c'::('-'::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('-'::('c'::('a'::('s'::('e'::[]))))))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_case_convention),
      ('C'::('O'::('N'::('V'::('E'::('N'::('T'::('I'::('O'::('N'::[]))))))))))))),
      (('T'::('h'::('e'::(' '::('c'::('a'::('s'::('e'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::('e'::('x'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('n'::('a'::('m'::('e'::('s'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::('i'::('s'::(' '::('t'::('o'::(' '::('n'::('o'::('t'::(' '::('a'::('d'::('j'::('u'::('s'::('t'::(' '::('c'::('a'::('s'::('e'::(','::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('i'::('n'::('g'::(' '::('i'::('n'::(','::(' '::('r'::('o'::('u'::('g'::('h'::('l'::('y'::(','::(' '::('s'::('n'::('a'::('k'::('e'::('_'::('c'::('a'::('s'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('V'::('a'::('l'::('i'::('d'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(':'::(' '::[])))))))))))))))))))
        (append valid_case_conventions ('.'::[]))) :: [])))

  (** val private_type_case_spec : (key0 list * spec) * doc **)

  let private_type_case_spec =
    ((((Long_key
      ('p'::('r'::('i'::('v'::('a'::('t'::('e'::('-'::('t'::('y'::('p'::('e'::('-'::('c'::('a'::('s'::('e'::[])))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_case_convention),
      ('C'::('O'::('N'::('V'::('E'::('N'::('T'::('I'::('O'::('N'::[]))))))))))))),
      (('T'::('h'::('e'::(' '::('c'::('a'::('s'::('e'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::('n'::('o'::('n'::('-'::('e'::('x'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('n'::('a'::('m'::('e'::('s'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::('i'::('s'::(' '::('t'::('o'::(' '::('n'::('o'::('t'::(' '::('a'::('d'::('j'::('u'::('s'::('t'::(' '::('c'::('a'::('s'::('e'::(','::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('i'::('n'::('g'::(' '::('i'::('n'::(','::(' '::('r'::('o'::('u'::('g'::('h'::('l'::('y'::(','::(' '::('s'::('n'::('a'::('k'::('e'::('_'::('c'::('a'::('s'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('V'::('a'::('l'::('i'::('d'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(':'::(' '::[])))))))))))))))))))
        (append valid_case_conventions ('.'::[]))) :: [])))

  (** val public_type_case_spec : (key0 list * spec) * doc **)

  let public_type_case_spec =
    ((((Long_key
      ('p'::('u'::('b'::('l'::('i'::('c'::('-'::('t'::('y'::('p'::('e'::('-'::('c'::('a'::('s'::('e'::[]))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_case_convention),
      ('C'::('O'::('N'::('V'::('E'::('N'::('T'::('I'::('O'::('N'::[]))))))))))))),
      (('T'::('h'::('e'::(' '::('c'::('a'::('s'::('e'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::('e'::('x'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('t'::('y'::('p'::('e'::(' '::('n'::('a'::('m'::('e'::('s'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::('i'::('s'::(' '::('t'::('o'::(' '::('n'::('o'::('t'::(' '::('a'::('d'::('j'::('u'::('s'::('t'::(' '::('c'::('a'::('s'::('e'::(','::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('i'::('n'::('g'::(' '::('i'::('n'::(','::(' '::('r'::('o'::('u'::('g'::('h'::('l'::('y'::(','::(' '::('s'::('n'::('a'::('k'::('e'::('_'::('c'::('a'::('s'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('V'::('a'::('l'::('i'::('d'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(':'::(' '::[])))))))))))))))))))
        (append valid_case_conventions ('.'::[]))) :: [])))

  (** val class_case_spec : (key0 list * spec) * doc **)

  let class_case_spec =
    ((((Long_key
      ('c'::('l'::('a'::('s'::('s'::('-'::('c'::('a'::('s'::('e'::[]))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_case_convention),
      ('C'::('O'::('N'::('V'::('E'::('N'::('T'::('I'::('O'::('N'::[]))))))))))))),
      (('T'::('h'::('e'::(' '::('c'::('a'::('s'::('e'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::('t'::('h'::('e'::(' '::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::('c'::('l'::('a'::('s'::('s'::(' '::('n'::('a'::('m'::('e'::('.'::(' '::(' '::('O'::('n'::('l'::('y'::(' '::('m'::('e'::('a'::('n'::('i'::('n'::('g'::('f'::('u'::('l'::(' '::('w'::('h'::('e'::('n'::(' '::('t'::('h'::('e'::(' '::('c'::('l'::('a'::('s'::('s'::(' '::('n'::('a'::('m'::('e'::(' '::('i'::('s'::(' '::('i'::('n'::('f'::('e'::('r'::('r'::('e'::('d'::(' '::('f'::('r'::('o'::('m'::(' '::('c'::('u'::('r'::('v'::('e'::('_'::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(','::(' '::('r'::('a'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::('e'::('x'::('p'::('l'::('i'::('c'::('i'::('t'::('l'::('y'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::('-'::('c'::('l'::('a'::('s'::('s'::('-'::('n'::('a'::('m'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('V'::('a'::('l'::('i'::('d'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(':'::(' '::[])))))))))))))))))))
        (append valid_case_conventions ('.'::[]))) :: [])))

  (** val package_case_spec : (key0 list * spec) * doc **)

  let package_case_spec =
    ((((Long_key
      ('p'::('a'::('c'::('k'::('a'::('g'::('e'::('-'::('c'::('a'::('s'::('e'::[]))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_case_convention),
      ('C'::('O'::('N'::('V'::('E'::('N'::('T'::('I'::('O'::('N'::[]))))))))))))),
      (('T'::('h'::('e'::(' '::('c'::('a'::('s'::('e'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::(' '::('f'::('o'::('r'::(' '::('t'::('h'::('e'::(' '::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::('p'::('a'::('c'::('k'::('a'::('g'::('e'::(' '::('n'::('a'::('m'::('e'::('.'::(' '::(' '::('O'::('n'::('l'::('y'::(' '::('m'::('e'::('a'::('n'::('i'::('n'::('g'::('f'::('u'::('l'::(' '::('w'::('h'::('e'::('n'::(' '::('t'::('h'::('e'::(' '::('p'::('a'::('c'::('k'::('a'::('g'::('e'::(' '::('n'::('a'::('m'::('e'::(' '::('i'::('s'::(' '::('i'::('n'::('f'::('e'::('r'::('r'::('e'::('d'::(' '::('f'::('r'::('o'::('m'::(' '::('c'::('u'::('r'::('v'::('e'::('_'::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(','::(' '::('r'::('a'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::('e'::('x'::('p'::('l'::('i'::('c'::('i'::('t'::('l'::('y'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::('-'::('p'::('a'::('c'::('k'::('a'::('g'::('e'::('-'::('n'::('a'::('m'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('V'::('a'::('l'::('i'::('d'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(':'::(' '::[])))))))))))))))))))
        (append valid_case_conventions ('.'::[]))) :: [])))

  (** val static_spec : (key0 list * spec) * doc **)

  let static_spec =
    ((((Long_key ('s'::('t'::('a'::('t'::('i'::('c'::[]))))))) :: []), Unit),
      (('D'::('e'::('c'::('l'::('a'::('r'::('e'::(' '::('t'::('h'::('e'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('s'::(' '::('s'::('t'::('a'::('t'::('i'::('c'::(','::(' '::('i'::('.'::('e'::('.'::(','::(' '::('l'::('o'::('c'::('a'::('l'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('l'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val internal_static_spec : (key0 list * spec) * doc **)

  let internal_static_spec =
    ((((Long_key
      ('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::('-'::('s'::('t'::('a'::('t'::('i'::('c'::[])))))))))))))))) :: []),
      Unit),
      (('D'::('e'::('c'::('l'::('a'::('r'::('e'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('s'::(' '::('s'::('t'::('a'::('t'::('i'::('c'::(','::(' '::('i'::('.'::('e'::('.'::(','::(' '::('l'::('o'::('c'::('a'::('l'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('l'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val inline_spec : (key0 list * spec) * doc **)

  let inline_spec =
    ((((Long_key ('i'::('n'::('l'::('i'::('n'::('e'::[]))))))) :: []), Unit),
      (('D'::('e'::('c'::('l'::('a'::('r'::('e'::(' '::('a'::('l'::('l'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('s'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::('.'::[])))))))))))))))))))))))))))))))) :: []))

  (** val inline_internal_spec : (key0 list * spec) * doc **)

  let inline_internal_spec =
    ((((Long_key
      ('i'::('n'::('l'::('i'::('n'::('e'::('-'::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::[])))))))))))))))) :: []),
      Unit),
      (('D'::('e'::('c'::('l'::('a'::('r'::('e'::(' '::('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('s'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))) :: []))

  (** val only_signed_spec : (key0 list * spec) * doc **)

  let only_signed_spec =
    ((((Long_key
      ('o'::('n'::('l'::('y'::('-'::('s'::('i'::('g'::('n'::('e'::('d'::[])))))))))))) :: []),
      Unit),
      (('O'::('n'::('l'::('y'::(' '::('a'::('l'::('l'::('o'::('w'::(' '::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('t'::('y'::('p'::('e'::('s'::('.'::[])))))))))))))))))))))))))))))))) :: []))

  (** val no_select_spec : (key0 list * spec) * doc **)

  let no_select_spec =
    ((((Long_key
      ('n'::('o'::('-'::('s'::('e'::('l'::('e'::('c'::('t'::[])))))))))) :: []),
      Unit),
      (('U'::('s'::('e'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('d'::('o'::('n'::('\''::('t'::(' '::('r'::('e'::('q'::('u'::('i'::('r'::('e'::(' '::('c'::('m'::('o'::('v'::('.'::[])))))))))))))))))))))))))))))))))))))))) :: []))

  (** val no_wide_int_spec : (key0 list * spec) * doc **)

  let no_wide_int_spec =
    ((((Long_key
      ('n'::('o'::('-'::('w'::('i'::('d'::('e'::('-'::('i'::('n'::('t'::[])))))))))))) :: []),
      Unit),
      (('D'::('o'::('n'::('\''::('t'::(' '::('u'::('s'::('e'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::('s'::(' '::('w'::('i'::('d'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('.'::[]))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val widen_carry_spec : (key0 list * spec) * doc **)

  let widen_carry_spec =
    ((((Long_key
      ('w'::('i'::('d'::('e'::('n'::('-'::('c'::('a'::('r'::('r'::('y'::[])))))))))))) :: []),
      Unit),
      (('W'::('i'::('d'::('e'::('n'::(' '::('c'::('a'::('r'::('r'::('y'::(' '::('b'::('i'::('t'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('t'::('y'::('p'::('e'::('s'::(' '::('t'::('o'::(' '::('e'::('i'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('e'::(' '::('b'::('y'::('t'::('e'::(' '::('t'::('y'::('p'::('e'::(','::(' '::('o'::('r'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('f'::('u'::('l'::('l'::(' '::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::(' '::('i'::('f'::(' '::('-'::('-'::('w'::('i'::('d'::('e'::('n'::('-'::('b'::('y'::('t'::('e'::('s'::(' '::('i'::('s'::(' '::('a'::('l'::('s'::('o'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val widen_bytes_spec : (key0 list * spec) * doc **)

  let widen_bytes_spec =
    ((((Long_key
      ('w'::('i'::('d'::('e'::('n'::('-'::('b'::('y'::('t'::('e'::('s'::[])))))))))))) :: []),
      Unit),
      (('W'::('i'::('d'::('e'::('n'::(' '::('b'::('y'::('t'::('e'::(' '::('t'::('y'::('p'::('e'::('s'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('f'::('u'::('l'::('l'::(' '::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('.'::[])))))))))))))))))))))))))))))))))))))) :: []))

  (** val split_multiret_spec : (key0 list * spec) * doc **)

  let split_multiret_spec =
    ((((Long_key
      ('s'::('p'::('l'::('i'::('t'::('-'::('m'::('u'::('l'::('t'::('i'::('r'::('e'::('t'::[]))))))))))))))) :: []),
      Unit),
      (('D'::('o'::('n'::('\''::('t'::(' '::('a'::('l'::('l'::('o'::('w'::(' '::('i'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('t'::('o'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('t'::('w'::('o'::(' '::('r'::('e'::('s'::('u'::('l'::('t'::('s'::('.'::(' '::('T'::('h'::('i'::('s'::(' '::('s'::('h'::('o'::('u'::('l'::('d'::(' '::('a'::('l'::('w'::('a'::('y'::('s'::(' '::('b'::('e'::(' '::('s'::('e'::('t'::(' '::('f'::('o'::('r'::(' '::('b'::('e'::('d'::('r'::('o'::('c'::('k'::('2'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val value_barrier_spec : (key0 list * spec) * doc **)

  let value_barrier_spec =
    ((((Long_key
      ('u'::('s'::('e'::('-'::('v'::('a'::('l'::('u'::('e'::('-'::('b'::('a'::('r'::('r'::('i'::('e'::('r'::[])))))))))))))))))) :: []),
      Unit),
      (('G'::('u'::('a'::('r'::('d'::(' '::('s'::('o'::('m'::('e'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::(' '::('w'::('i'::('t'::('h'::(' '::('a'::('n'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('b'::('a'::('r'::('r'::('i'::('e'::('r'::(' '::('t'::('o'::(' '::('p'::('r'::('e'::('v'::('e'::('n'::('t'::(' '::('c'::('o'::('m'::('p'::('i'::('l'::('e'::('r'::('s'::(' '::('f'::('r'::('o'::('m'::(' '::('g'::('e'::('n'::('e'::('r'::('a'::('t'::('i'::('n'::('g'::(' '::('n'::('o'::('n'::('-'::('c'::('o'::('n'::('s'::('t'::('a'::('n'::('t'::('-'::('t'::('i'::('m'::('e'::(' '::('c'::('o'::('d'::('e'::(' '::('f'::('o'::('r'::(' '::('c'::('m'::('o'::('v'::('z'::('n'::('z'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val no_primitives_spec : (key0 list * spec) * doc **)

  let no_primitives_spec =
    ((((Long_key
      ('n'::('o'::('-'::('p'::('r'::('i'::('m'::('i'::('t'::('i'::('v'::('e'::('s'::[])))))))))))))) :: []),
      Unit),
      (('S'::('u'::('p'::('p'::('r'::('e'::('s'::('s'::(' '::('t'::('h'::('e'::(' '::('g'::('e'::('n'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('d'::('i'::('e'::('s'::(' '::('o'::('f'::(' '::('p'::('r'::('i'::('m'::('i'::('t'::('i'::('v'::('e'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(' '::('s'::('u'::('c'::('h'::(' '::('a'::('s'::(' '::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::(','::(' '::('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::(','::(' '::('c'::('m'::('o'::('v'::('z'::('n'::('z'::(','::(' '::('m'::('u'::('l'::('x'::(','::(' '::('e'::('t'::('c'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val no_field_element_typedefs_spec : (key0 list * spec) * doc **)

  let no_field_element_typedefs_spec =
    ((((Long_key
      ('n'::('o'::('-'::('f'::('i'::('e'::('l'::('d'::('-'::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('-'::('t'::('y'::('p'::('e'::('d'::('e'::('f'::('s'::[])))))))))))))))))))))))))) :: []),
      Unit),
      (('D'::('o'::(' '::('n'::('o'::('t'::(' '::('u'::('s'::('e'::(' '::('t'::('y'::('p'::('e'::(' '::('a'::('l'::('i'::('a'::('s'::('e'::('s'::(' '::('f'::('o'::('r'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::('s'::(' '::('b'::('a'::('s'::('e'::('d'::(' '::('o'::('n'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(','::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('-'::('d'::('o'::('m'::('a'::('i'::('n'::(' '::('v'::('s'::(' '::('n'::('o'::('t'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::('-'::('d'::('o'::('m'::('a'::('i'::('n'::(','::(' '::('e'::('t'::('c'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val emit_all_casts_spec : (key0 list * spec) * doc **)

  let emit_all_casts_spec =
    ((((Long_key
      ('e'::('m'::('i'::('t'::('-'::('a'::('l'::('l'::('-'::('c'::('a'::('s'::('t'::('s'::[]))))))))))))))) :: []),
      Unit),
      (('R'::('a'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('p'::('e'::('r'::('f'::('o'::('r'::('m'::('i'::('n'::('g'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::('-'::('s'::('p'::('e'::('c'::('i'::('f'::('i'::('c'::(' '::('c'::('a'::('s'::('t'::('-'::('a'::('d'::('j'::('u'::('s'::('t'::('m'::('e'::('n'::('t'::(','::(' '::('j'::('u'::('s'::('t'::(' '::('e'::('m'::('i'::('t'::(' '::('a'::('l'::('l'::(' '::('c'::('a'::('s'::('t'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('a'::('r'::('e'::(' '::('p'::('r'::('e'::('s'::('e'::('n'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('t'::('e'::('r'::('m'::('e'::('d'::('i'::('a'::('t'::('e'::(' '::('r'::('e'::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(','::(' '::('a'::('n'::('n'::('o'::('t'::('a'::('t'::('i'::('n'::('g'::(' '::('a'::('l'::('l'::(' '::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('i'::('o'::('n'::('s'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val relax_primitive_carry_to_bitwidth_spec :
      (key0 list * spec) * doc **)

  let relax_primitive_carry_to_bitwidth_spec =
    ((((Long_key
      ('r'::('e'::('l'::('a'::('x'::('-'::('p'::('r'::('i'::('m'::('i'::('t'::('i'::('v'::('e'::('-'::('c'::('a'::('r'::('r'::('y'::('-'::('t'::('o'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::[])))))))))))))))))))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_comma_list_Z),
      ('\226'::('\132'::('\164'::(','::('\226'::('\132'::('\164'::(','::('\226'::('\128'::('\166'::[])))))))))))))),
      (('F'::('o'::('r'::(' '::('a'::('n'::('y'::(' '::('('::('c'::('o'::('m'::('m'::('a'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(')'::(' '::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('s'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::(' '::('t'::('o'::(' '::('t'::('h'::('i'::('s'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(','::(' '::('u'::('s'::('e'::(' '::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::('s'::('i'::('z'::('e'::('d'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('r'::('a'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('i'::('g'::('h'::('t'::('e'::('r'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('f'::('o'::('r'::(' '::('t'::('h'::('e'::(' '::('c'::('a'::('r'::('r'::('y'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::(' '::('o'::('f'::(' '::('p'::('r'::('i'::('m'::('i'::('t'::('i'::('v'::('e'::('s'::(' '::('s'::('u'::('c'::('h'::(' '::('a'::('s'::(' '::('a'::('d'::('d'::('c'::('a'::('r'::('r'::('y'::('x'::(' '::('a'::('n'::('d'::(' '::('s'::('u'::('b'::('b'::('o'::('r'::('r'::('o'::('w'::('x'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val cmovznz_by_mul_spec : (key0 list * spec) * doc **)

  let cmovznz_by_mul_spec =
    ((((Long_key
      ('c'::('m'::('o'::('v'::('z'::('n'::('z'::('-'::('b'::('y'::('-'::('m'::('u'::('l'::[]))))))))))))))) :: []),
      Unit),
      (('U'::('s'::('e'::(' '::('a'::('n'::(' '::('a'::('l'::('t'::('e'::('r'::('n'::('a'::('t'::('i'::('v'::('e'::(' '::('i'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('o'::('f'::(' '::('c'::('m'::('o'::('v'::('z'::('n'::('z'::(' '::('u'::('s'::('i'::('n'::('g'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(' '::('r'::('a'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('b'::('i'::('t'::('w'::('i'::('s'::('e'::('-'::('a'::('n'::('d'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::('1'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val shiftr_avoid_uint1_spec : (key0 list * spec) * doc **)

  let shiftr_avoid_uint1_spec =
    ((((Long_key
      ('s'::('h'::('i'::('f'::('t'::('r'::('-'::('a'::('v'::('o'::('i'::('d'::('-'::('u'::('i'::('n'::('t'::('1'::[]))))))))))))))))))) :: []),
      Unit),
      (('A'::('v'::('o'::('i'::('d'::(' '::('u'::('i'::('n'::('t'::('1'::(' '::('t'::('y'::('p'::('e'::('s'::(' '::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('o'::('f'::(' '::('('::('>'::('>'::(')'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val tight_bounds_multiplier_default : q **)

  let tight_bounds_multiplier_default =
    default_tight_upperbound_fraction

  (** val tight_bounds_multiplier_spec : (key0 list * spec) * doc **)

  let tight_bounds_multiplier_spec =
    ((((Long_key
      ('t'::('i'::('g'::('h'::('t'::('-'::('b'::('o'::('u'::('n'::('d'::('s'::('-'::('m'::('u'::('l'::('-'::('b'::('y'::[])))))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_Q),
      ('\226'::('\132'::('\154'::[])))))),
      (('T'::('h'::('e'::(' '::('('::('i'::('m'::('p'::('r'::('o'::('p'::('e'::('r'::(')'::(' '::('f'::('r'::('a'::('c'::('t'::('i'::('o'::('n'::(' '::('b'::('y'::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('t'::('h'::('e'::(' '::('('::('t'::('i'::('g'::('h'::('t'::(')'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('o'::('f'::(' '::('e'::('a'::('c'::('h'::(' '::('l'::('i'::('m'::('b'::(' '::('a'::('r'::('e'::(' '::('s'::('c'::('a'::('l'::('e'::('d'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val n_spec : (char list * spec) * doc **)

  let n_spec =
    ((('n'::[]), (Custom ((Obj.magic parse_string_and parse_n),
      ('a'::('n'::(' '::('\226'::('\132'::('\149'::(' '::('o'::('r'::(' '::('t'::('h'::('e'::(' '::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('\''::('('::('a'::('u'::('t'::('o'::(')'::('\''::(' '::('o'::('r'::(' '::('\''::('('::('a'::('u'::('t'::('o'::('N'::(')'::('\''::(' '::('f'::('o'::('r'::(' '::('a'::(' '::('n'::('o'::('n'::('-'::('n'::('e'::('g'::('a'::('t'::('i'::('v'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('N'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))),
      (('T'::('h'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('o'::('f'::(' '::('l'::('i'::('m'::('b'::('s'::(','::(' '::('o'::('r'::(' '::('t'::('h'::('e'::(' '::('l'::('i'::('t'::('e'::('r'::('a'::('l'::(' '::('\''::('('::('a'::('u'::('t'::('o'::(')'::('\''::(' '::('o'::('r'::(' '::('\''::('('::('a'::('u'::('t'::('o'::('N'::(')'::('\''::(' '::('f'::('o'::('r'::(' '::('a'::(' '::('n'::('o'::('n'::('-'::('n'::('e'::('g'::('a'::('t'::('i'::('v'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('N'::(','::(' '::('t'::('o'::(' '::('a'::('u'::('t'::('o'::('m'::('a'::('t'::('i'::('c'::('a'::('l'::('l'::('y'::(' '::('g'::('u'::('e'::('s'::('s'::(' '::('t'::('h'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('o'::('f'::(' '::('l'::('i'::('m'::('b'::('s'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val n_nat_spec : (char list * spec) * doc **)

  let n_nat_spec =
    ((('n'::[]), (Custom ((Obj.magic parse_string_and parse_nat),
      ('\226'::('\132'::('\149'::[])))))),
      (('T'::('h'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('o'::('f'::(' '::('l'::('i'::('m'::('b'::('s'::[]))))))))))))))))))) :: []))

  (** val last_limb_width_spec : (char list * spec) * doc **)

  let last_limb_width_spec =
    ((('l'::('a'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('_'::('w'::('i'::('d'::('t'::('h'::[]))))))))))))))),
      (Custom ((Obj.magic parse_string_and parse_nat),
      ('\226'::('\132'::('\149'::[])))))),
      (('T'::('h'::('e'::(' '::('d'::('e'::('s'::('i'::('r'::('e'::('d'::(' '::('w'::('i'::('d'::('t'::('h'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('l'::('a'::('s'::('t'::(' '::('('::('m'::('o'::('s'::('t'::(' '::('s'::('i'::('g'::('n'::('i'::('f'::('i'::('c'::('a'::('n'::('t'::(')'::(' '::('l'::('i'::('m'::('b'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val last_reduction_spec : (char list * spec) * doc **)

  let last_reduction_spec =
    ((('l'::('a'::('s'::('t'::('_'::('r'::('e'::('d'::('u'::('c'::('t'::('i'::('o'::('n'::[])))))))))))))),
      (Custom ((Obj.magic parse_string_and parse_nat),
      ('\226'::('\132'::('\149'::[])))))),
      (('T'::('h'::('e'::(' '::('l'::('i'::('m'::('b'::(' '::('t'::('h'::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('n'::('a'::('l'::(' '::('m'::('o'::('d'::('u'::('l'::('a'::('r'::(' '::('r'::('e'::('d'::('u'::('c'::('t'::('i'::('o'::('n'::(' '::('l'::('a'::('n'::('d'::('s'::(' '::('i'::('n'::('.'::(' '::(' '::('S'::('h'::('o'::('u'::('l'::('d'::(' '::('b'::('e'::(' '::('b'::('e'::('t'::('w'::('e'::('e'::('n'::(' '::('1'::(' '::('a'::('n'::('d'::(' '::('l'::('i'::('m'::('b'::('s'::(' '::('-'::(' '::('3'::(','::(' '::('i'::('n'::('c'::('l'::('u'::('s'::('i'::('v'::('e'::('.'::(' '::(' '::('L'::('a'::('r'::('g'::('e'::('r'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::(' '::('c'::('o'::('r'::('r'::('e'::('s'::('p'::('o'::('n'::('d'::(' '::('t'::('o'::(' '::('a'::(' '::('f'::('a'::('s'::('t'::('e'::('r'::(' '::('a'::('l'::('g'::('o'::('r'::('i'::('t'::('h'::('m'::(' '::('b'::('u'::('t'::(' '::('l'::('o'::('o'::('s'::('e'::('r'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('o'::('n'::(' '::('t'::('h'::('e'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val sc_spec : (char list * spec) * doc **)

  let sc_spec =
    ((('s'::('-'::('c'::[]))), (Custom
      ((Obj.magic parse_string_and parse_sc),
      ('a'::('n'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::[])))))))))))))))))))))))),
      (('T'::('h'::('e'::(' '::('p'::('r'::('i'::('m'::('e'::(','::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('m'::('u'::('s'::('t'::(' '::('b'::('e'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('e'::('d'::(' '::('a'::('s'::(' '::('a'::(' '::('d'::('i'::('f'::('f'::('e'::('r'::('e'::('n'::('c'::('e'::(' '::('o'::('f'::(' '::('a'::(' '::('p'::('o'::('w'::('e'::('r'::(' '::('o'::('f'::(' '::('t'::('w'::('o'::(' '::('a'::('n'::('d'::(' '::('a'::(' '::('s'::('m'::('a'::('l'::('l'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('('::('e'::('.'::('g'::('.'::(','::(' '::('\''::('2'::('^'::('2'::('5'::('5'::(' '::('-'::(' '::('1'::('9'::('\''::(','::(' '::('\''::('2'::('^'::('4'::('4'::('8'::(' '::('-'::(' '::('2'::('^'::('2'::('2'::('4'::(' '::('-'::(' '::('1'::('\''::(')'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val m_spec : (char list * spec) * doc **)

  let m_spec =
    ((('m'::[]), (Custom ((Obj.magic parse_string_and parse_m),
      ('a'::('n'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::[])))))))))))))))))))))))),
      (('T'::('h'::('e'::(' '::('p'::('r'::('i'::('m'::('e'::(' '::('('::('e'::('.'::('g'::('.'::(','::(' '::('\''::('2'::('^'::('4'::('3'::('4'::(' '::('-'::(' '::('('::('2'::('^'::('2'::('1'::('6'::('*'::('3'::('^'::('1'::('3'::('7'::(' '::('-'::(' '::('1'::(')'::('\''::(')'::[]))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val machine_wordsize_spec : (char list * spec) * doc **)

  let machine_wordsize_spec =
    ((('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::[])))))))))))))))),
      (Custom ((Obj.magic parse_string_and parse_machine_wordsize),
      ('a'::('n'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::[]))))))))))))),
      (('T'::('h'::('e'::(' '::('m'::('a'::('c'::('h'::('i'::('n'::('e'::(' '::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::(' '::('('::('e'::('.'::('g'::('.'::(','::(' '::('3'::('2'::(' '::('o'::('r'::(' '::('6'::('4'::(')'::[]))))))))))))))))))))))))))))))))))))) :: []))

  (** val src_n_spec : (char list * spec) * doc **)

  let src_n_spec =
    ((('s'::('r'::('c'::('_'::('n'::[]))))), (Custom
      ((Obj.magic parse_string_and parse_src_n),
      ('\226'::('\132'::('\149'::[])))))),
      (('T'::('h'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('o'::('f'::(' '::('l'::('i'::('m'::('b'::('s'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::[])))))))))))))))))))))))))))))))) :: []))

  (** val src_limbwidth_spec : (char list * spec) * doc **)

  let src_limbwidth_spec =
    ((('s'::('r'::('c'::('_'::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::[]))))))))))))),
      (Custom ((Obj.magic parse_string_and parse_limbwidth),
      ('\226'::('\132'::('\149'::[])))))),
      (('T'::('h'::('e'::(' '::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::[])))))))))))))))))))))))))))))))))))))))) :: []))

  (** val dst_limbwidth_spec : (char list * spec) * doc **)

  let dst_limbwidth_spec =
    ((('d'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::[]))))))))))))),
      (Custom ((Obj.magic parse_string_and parse_limbwidth),
      ('\226'::('\132'::('\149'::[])))))),
      (('T'::('h'::('e'::(' '::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('e'::('l'::('d'::(' '::('e'::('l'::('e'::('m'::('e'::('n'::('t'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('e'::('d'::[]))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val use_bitwidth_in_spec : (key0 list * spec) * doc **)

  let use_bitwidth_in_spec =
    ((((Long_key
      ('u'::('s'::('e'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::('i'::('n'::[])))))))))))))))) :: []),
      Unit),
      (('I'::('n'::('s'::('t'::('e'::('a'::('d'::(' '::('o'::('f'::(' '::('u'::('s'::('i'::('n'::('g'::(' '::('a'::('n'::(' '::('u'::('p'::('p'::('e'::('r'::(' '::('b'::('o'::('u'::('n'::('d'::(' '::('o'::('f'::(' '::('s'::('-'::('1'::(' '::('o'::('n'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(','::(' '::('u'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::('m'::('a'::('x'::('i'::('m'::('u'::('m'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('t'::('h'::('a'::('t'::(' '::('c'::('a'::('n'::(' '::('b'::('e'::(' '::('p'::('r'::('o'::('p'::('e'::('r'::('l'::('y'::(' '::('r'::('e'::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('e'::('d'::(' '::('w'::('i'::('t'::('h'::(' '::('t'::('h'::('e'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::('b'::('a'::('s'::('e'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val use_bitwidth_out_spec : (key0 list * spec) * doc **)

  let use_bitwidth_out_spec =
    ((((Long_key
      ('u'::('s'::('e'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::('o'::('u'::('t'::[]))))))))))))))))) :: []),
      Unit),
      (('I'::('n'::('s'::('t'::('e'::('a'::('d'::(' '::('o'::('f'::(' '::('u'::('s'::('i'::('n'::('g'::(' '::('a'::('n'::(' '::('u'::('p'::('p'::('e'::('r'::(' '::('b'::('o'::('u'::('n'::('d'::(' '::('o'::('f'::(' '::('s'::('-'::('1'::(' '::('o'::('n'::(' '::('t'::('h'::('e'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(','::(' '::('u'::('s'::('e'::(' '::('t'::('h'::('e'::(' '::('m'::('a'::('x'::('i'::('m'::('u'::('m'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('t'::('h'::('a'::('t'::(' '::('c'::('a'::('n'::(' '::('b'::('e'::(' '::('p'::('r'::('o'::('p'::('e'::('r'::('l'::('y'::(' '::('r'::('e'::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('e'::('d'::(' '::('w'::('i'::('t'::('h'::(' '::('t'::('h'::('e'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::('b'::('a'::('s'::('e'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val default_inbounds_multiplier : z **)

  let default_inbounds_multiplier =
    Zpos XH

  (** val inbounds_multiplier_spec : (key0 list * spec) * doc **)

  let inbounds_multiplier_spec =
    ((((Long_key
      ('i'::('n'::('b'::('o'::('u'::('n'::('d'::('s'::('-'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::[])))))))))))))))))))) :: []),
      String),
      ((append
         ('T'::('h'::('e'::(' '::('('::('i'::('m'::('p'::('r'::('o'::('p'::('e'::('r'::(')'::(' '::('f'::('r'::('a'::('c'::('t'::('i'::('o'::('n'::(' '::('b'::('y'::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('o'::('f'::(' '::('e'::('a'::('c'::('h'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('l'::('i'::('m'::('b'::(' '::('a'::('r'::('e'::(' '::('s'::('c'::('a'::('l'::('e'::('d'::(' '::('('::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         (append (show0 Decimal.show_Z default_inbounds_multiplier) (')'::[]))) :: []))

  (** val default_outbounds_multiplier : z **)

  let default_outbounds_multiplier =
    Zpos XH

  (** val outbounds_multiplier_spec : (key0 list * spec) * doc **)

  let outbounds_multiplier_spec =
    ((((Long_key
      ('o'::('u'::('t'::('b'::('o'::('u'::('n'::('d'::('s'::('-'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::[]))))))))))))))))))))) :: []),
      String),
      ((append
         ('T'::('h'::('e'::(' '::('('::('i'::('m'::('p'::('r'::('o'::('p'::('e'::('r'::(')'::(' '::('f'::('r'::('a'::('c'::('t'::('i'::('o'::('n'::(' '::('b'::('y'::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('o'::('f'::(' '::('e'::('a'::('c'::('h'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('l'::('i'::('m'::('b'::(' '::('a'::('r'::('e'::(' '::('s'::('c'::('a'::('l'::('e'::('d'::(' '::('('::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         (append (show0 Decimal.show_Z default_outbounds_multiplier)
           (')'::[]))) :: []))

  (** val inbounds_spec : (key0 list * spec) * doc **)

  let inbounds_spec =
    ((((Long_key
      ('i'::('n'::('b'::('o'::('u'::('n'::('d'::('s'::[]))))))))) :: []),
      String),
      (('A'::(' '::('s'::('e'::('m'::('i'::('c'::('o'::('l'::('o'::('n'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(','::(' '::('s'::('q'::('u'::('a'::('r'::('e'::('-'::('b'::('r'::('a'::('c'::('k'::('e'::('d'::('-'::('s'::('u'::('r'::('r'::('o'::('u'::('n'::('d'::('e'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('b'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::('.'::(' '::(' '::('I'::('n'::('c'::('o'::('m'::('p'::('a'::('t'::('i'::('b'::('l'::('e'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::('-'::('u'::('s'::('e'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::('i'::('n'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val outbounds_spec : (key0 list * spec) * doc **)

  let outbounds_spec =
    ((((Long_key
      ('o'::('u'::('t'::('b'::('o'::('u'::('n'::('d'::('s'::[])))))))))) :: []),
      String),
      (('A'::(' '::('s'::('e'::('m'::('i'::('c'::('o'::('l'::('o'::('n'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(','::(' '::('s'::('q'::('u'::('a'::('r'::('e'::('-'::('b'::('r'::('a'::('c'::('k'::('e'::('d'::('-'::('s'::('u'::('r'::('r'::('o'::('u'::('n'::('d'::('e'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::('s'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('b'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::('.'::(' '::(' '::('I'::('n'::('c'::('o'::('m'::('p'::('a'::('t'::('i'::('b'::('l'::('e'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::('-'::('u'::('s'::('e'::('-'::('b'::('i'::('t'::('w'::('i'::('d'::('t'::('h'::('-'::('o'::('u'::('t'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val function_to_synthesize_spec :
      char list -> (char list * spec) * doc **)

  let function_to_synthesize_spec valid_names5 =
    ((('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('_'::('t'::('o'::('_'::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::[])))))))))))))))))))))),
      String),
      (('A'::(' '::('s'::('p'::('a'::('c'::('e'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('s'::('h'::('o'::('u'::('l'::('d'::(' '::('b'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::('.'::(' '::(' '::('I'::('f'::(' '::('n'::('o'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(' '::('g'::('i'::('v'::('e'::('n'::(','::(' '::('a'::('l'::('l'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('V'::('a'::('l'::('i'::('d'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('r'::('e'::(' '::[]))))))))))))))))))
        (append valid_names5 ('.'::[]))) :: [])))

  (** val hint_file_spec : (key0 list * spec) * doc **)

  let hint_file_spec =
    ((((Long_key
      ('h'::('i'::('n'::('t'::('s'::('-'::('f'::('i'::('l'::('e'::[]))))))))))) :: []),
      String),
      (('A'::('n'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('f'::('i'::('l'::('e'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('r'::('e'::('a'::('d'::(' '::('f'::('o'::('r'::(' '::('h'::('i'::('n'::('t'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('s'::(' '::('p'::('r'::('o'::('c'::('e'::('s'::('s'::('.'::(' '::(' '::('U'::('s'::('e'::(' '::('-'::(' '::('f'::('o'::('r'::(' '::('s'::('t'::('d'::('i'::('n'::('.'::(' '::(' '::('T'::('o'::(' '::('c'::('h'::('e'::('c'::('k'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('f'::('i'::('l'::('e'::('s'::(' '::('a'::('g'::('a'::('i'::('n'::('s'::('t'::(' '::('t'::('h'::('e'::(' '::('s'::('a'::('m'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('('::('s'::(')'::(','::(' '::('p'::('a'::('s'::('s'::(' '::('t'::('h'::('i'::('s'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val output_file_spec : (key0 list * spec) * doc **)

  let output_file_spec =
    ((((Long_key ('o'::('u'::('t'::('p'::('u'::('t'::[]))))))) :: ((Short_key
      ('o'::[])) :: [])), String),
      (('T'::('h'::('e'::(' '::('n'::('a'::('m'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('l'::('e'::(' '::('t'::('o'::(' '::('w'::('r'::('i'::('t'::('e'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('t'::('o'::('.'::(' '::(' '::('U'::('s'::('e'::(' '::('-'::(' '::('f'::('o'::('r'::(' '::('s'::('t'::('d'::('o'::('u'::('t'::('.'::(' '::(' '::('('::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::('-'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val asm_output_spec : (key0 list * spec) * doc **)

  let asm_output_spec =
    ((((Long_key
      ('o'::('u'::('t'::('p'::('u'::('t'::('-'::('a'::('s'::('m'::[]))))))))))) :: []),
      String),
      (('T'::('h'::('e'::(' '::('n'::('a'::('m'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('l'::('e'::(' '::('t'::('o'::(' '::('w'::('r'::('i'::('t'::('e'::(' '::('g'::('e'::('n'::('e'::('r'::('a'::('t'::('e'::('d'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('t'::('o'::('.'::(' '::(' '::('U'::('s'::('e'::(' '::('-'::(' '::('f'::('o'::('r'::(' '::('s'::('t'::('d'::('o'::('u'::('t'::('.'::(' '::(' '::('('::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::('-'::(')'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val asm_reg_spec : (key0 list * spec) * doc **)

  let asm_reg_spec =
    ((((Long_key ('a'::('s'::('m'::('-'::('r'::('e'::('g'::[])))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_list_REG),
      ('R'::('E'::('G'::[])))))),
      (('A'::(' '::('c'::('o'::('m'::('m'::('a'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('t'::('o'::(' '::('u'::('s'::('e'::(' '::('f'::('o'::('r'::(' '::('c'::('a'::('l'::('l'::('i'::('n'::('g'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::('s'::('.'::(' '::(' '::('O'::('n'::('l'::('y'::(' '::('r'::('e'::('l'::('e'::('v'::('a'::('n'::('t'::(' '::('w'::('h'::('e'::('n'::(' '::('-'::('-'::('h'::('i'::('n'::('t'::('s'::('-'::('f'::('i'::('l'::('e'::(' '::('i'::('s'::(' '::('s'::('p'::('e'::('c'::('i'::('f'::('i'::('e'::('d'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('D'::('e'::('f'::('a'::('u'::('l'::('t'::('s'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('S'::('y'::('s'::('t'::('e'::('m'::(' '::('V'::(' '::('A'::('M'::('D'::('6'::('4'::(' '::('A'::('B'::('I'::(' '::('o'::('f'::(' '::[]))))))))))))))))))))))))))))))))))))))
        (append
          (concat0 (','::[])
            (map (show0 show_REG) default_assembly_calling_registers))
          ('.'::(' '::(' '::('N'::('o'::('t'::('e'::(' '::('t'::('h'::('a'::('t'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('a'::('r'::('e'::(' '::('f'::('i'::('r'::('s'::('t'::(' '::('u'::('s'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::('s'::(' '::('a'::('n'::('d'::(' '::('t'::('h'::('e'::('n'::(' '::('i'::('n'::('p'::('u'::('t'::('s'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])))

  (** val asm_callee_saved_registers_spec : (key0 list * spec) * doc **)

  let asm_callee_saved_registers_spec =
    ((((Long_key
      ('a'::('s'::('m'::('-'::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::('-'::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::[]))))))))))))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_callee_saved_registers),
      ('R'::('E'::('G'::[])))))),
      ((append ('E'::('i'::('t'::('h'::('e'::('r'::(' '::('\''::[]))))))))
         (append
           (show0 show_assembly_callee_saved_registers_opt System_V_AMD64)
           (append
             ('\''::(' '::('('::('i'::('n'::('d'::('i'::('c'::('a'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))
             (append
               (concat0 (','::[])
                 (map (show0 show_REG)
                   system_v_amd64_assembly_callee_saved_registers))
               (append (')'::(','::(' '::('\''::[]))))
                 (append
                   (show0 show_assembly_callee_saved_registers_opt
                     Microsoft_x64)
                   (append
                     ('\''::(' '::('('::('i'::('n'::('d'::('i'::('c'::('a'::('t'::('i'::('n'::('g'::(' '::[]))))))))))))))
                     (append
                       (concat0 (','::[])
                         (map (show0 show_REG)
                           microsoft_x64_assembly_callee_saved_registers))
                       (')'::(','::(' '::('o'::('r'::(' '::('a'::(' '::('c'::('o'::('m'::('m'::('a'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('a'::('r'::('e'::(' '::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::(' '::('/'::(' '::('n'::('o'::('n'::('-'::('v'::('o'::('l'::('a'::('t'::('i'::('l'::('e'::('.'::(' '::(' '::('O'::('n'::('l'::('y'::(' '::('r'::('e'::('l'::('e'::('v'::('a'::('n'::('t'::(' '::('w'::('h'::('e'::('n'::(' '::('-'::('-'::('h'::('i'::('n'::('t'::('s'::('-'::('f'::('i'::('l'::('e'::(' '::('i'::('s'::(' '::('s'::('p'::('e'::('c'::('i'::('f'::('i'::('e'::('d'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
      (append
        ('D'::('e'::('f'::('a'::('u'::('l'::('t'::('s'::(' '::('t'::('o'::(' '::[]))))))))))))
        (append
          (show0 show_assembly_callee_saved_registers_opt
            default_assembly_callee_saved_registers) ('.'::[]))) :: [])))

  (** val asm_stack_size_spec : (key0 list * spec) * doc **)

  let asm_stack_size_spec =
    ((((Long_key
      ('a'::('s'::('m'::('-'::('s'::('t'::('a'::('c'::('k'::('-'::('s'::('i'::('z'::('e'::[]))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_N),
      ('\226'::('\132'::('\149'::[])))))),
      ((append
         ('T'::('h'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('o'::('f'::(' '::('b'::('y'::('t'::('e'::('s'::(' '::('o'::('f'::(' '::('s'::('t'::('a'::('c'::('k'::('.'::(' '::(' '::('O'::('n'::('l'::('y'::(' '::('r'::('e'::('l'::('e'::('v'::('a'::('n'::('t'::(' '::('w'::('h'::('e'::('n'::(' '::('-'::('-'::('h'::('i'::('n'::('t'::('s'::('-'::('f'::('i'::('l'::('e'::(' '::('i'::('s'::(' '::('s'::('p'::('e'::('c'::('i'::('f'::('i'::('e'::('d'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::('s'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::('a'::('l'::(' '::('s'::('i'::('z'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('r'::('e'::('d'::(' '::('z'::('o'::('n'::('e'::(' '::('('::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         (append
           (show0 Decimal.show_N system_v_amd64_assembly_stack_red_zone)
           (append
             (' '::('f'::('o'::('r'::(' '::('-'::('-'::('a'::('s'::('m'::('-'::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::('-'::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::[]))))))))))))))))))))))))))))))))))
             (append
               (show0 show_assembly_callee_saved_registers_opt System_V_AMD64)
               (append (','::(' '::('o'::('r'::(' '::[])))))
                 (append
                   (show0 Decimal.show_N
                     microsoft_x64_assembly_stack_red_zone)
                   (append
                     (' '::('f'::('o'::('r'::(' '::(' '::('-'::('-'::('a'::('s'::('m'::('-'::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::('-'::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::[])))))))))))))))))))))))))))))))))))
                     (append
                       (show0 show_assembly_callee_saved_registers_opt
                         Microsoft_x64)
                       (append (','::(' '::('o'::('r'::(' '::[])))))
                         (append
                           (show0 Decimal.show_N
                             (assembly_stack_red_zone (Explicit_registers [])))
                           (' '::('f'::('o'::('r'::(' '::('a'::('n'::(' '::('e'::('x'::('p'::('l'::('i'::('c'::('i'::('t'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('g'::('i'::('v'::('e'::('n'::(' '::('t'::('o'::(' '::('-'::('-'::('a'::('s'::('m'::('-'::('c'::('a'::('l'::('l'::('e'::('e'::('-'::('s'::('a'::('v'::('e'::('d'::('-'::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(')'::(' '::('p'::('l'::('u'::('s'::(' '::('t'::('h'::('e'::(' '::('m'::('a'::('x'::('i'::('m'::('u'::('m'::(' '::('s'::('t'::('a'::('t'::('i'::('c'::('a'::('l'::('l'::('y'::(' '::('k'::('n'::('o'::('w'::('a'::('b'::('l'::('e'::(' '::('i'::('n'::('c'::('r'::('e'::('a'::('s'::('e'::(' '::('t'::('o'::(' '::('`'::('r'::('s'::('p'::('`'::(' '::('('::('v'::('i'::('a'::(' '::('`'::('p'::('u'::('s'::('h'::('`'::(','::(' '::('`'::('p'::('o'::('p'::('`'::(','::(' '::('`'::('s'::('u'::('b'::('`'::(','::(' '::('`'::('a'::('d'::('d'::('`'::(','::(' '::('a'::('n'::('d'::(' '::('`'::('l'::('e'::('a'::('`'::(' '::('i'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('i'::('o'::('n'::('s'::(')'::(' '::('t'::('h'::('e'::(' '::('c'::('o'::('d'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val no_error_on_unused_asm_functions_spec : (key0 list * spec) * doc **)

  let no_error_on_unused_asm_functions_spec =
    ((((Long_key
      ('n'::('o'::('-'::('e'::('r'::('r'::('o'::('r'::('-'::('o'::('n'::('-'::('u'::('n'::('u'::('s'::('e'::('d'::('-'::('a'::('s'::('m'::('-'::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::[]))))))))))))))))))))))))))))))))) :: []),
      Unit),
      (('D'::('o'::('n'::('\''::('t'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('f'::(' '::('t'::('h'::('e'::('r'::('e'::(' '::('a'::('r'::('e'::(' '::('g'::('l'::('o'::('b'::('a'::('l'::(' '::('l'::('a'::('b'::('e'::('l'::('s'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('h'::('i'::('n'::('t'::('s'::('-'::('f'::('i'::('l'::('e'::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('a'::('r'::('e'::(' '::('n'::('o'::('t'::(' '::('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val asm_input_first_spec : (key0 list * spec) * doc **)

  let asm_input_first_spec =
    ((((Long_key
      ('a'::('s'::('m'::('-'::('i'::('n'::('p'::('u'::('t'::('-'::('f'::('i'::('r'::('s'::('t'::[])))))))))))))))) :: []),
      Unit),
      (('B'::('y'::(' '::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(','::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('p'::('o'::('i'::('n'::('t'::('e'::('r'::('s'::(' '::('a'::('r'::('e'::(' '::('a'::('s'::('s'::('u'::('m'::('e'::('d'::(' '::('t'::('o'::(' '::('c'::('o'::('m'::('e'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('C'::(' '::('c'::('o'::('d'::('e'::(' '::('t'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('h'::('i'::('n'::('t'::('s'::(' '::('a'::('r'::('e'::(' '::('b'::('a'::('s'::('e'::('d'::(' '::('o'::('n'::('.'::(' '::(' '::('T'::('h'::('i'::('s'::(' '::('f'::('l'::('a'::('g'::(' '::('r'::('e'::('v'::('e'::('r'::('s'::('e'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val asm_reg_rtl_spec : (key0 list * spec) * doc **)

  let asm_reg_rtl_spec =
    ((((Long_key
      ('a'::('s'::('m'::('-'::('r'::('e'::('g'::('-'::('r'::('t'::('l'::[])))))))))))) :: []),
      Unit),
      (('B'::('y'::(' '::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(','::(' '::('r'::('e'::('g'::('i'::('s'::('t'::('e'::('r'::('s'::(' '::('a'::('r'::('e'::(' '::('a'::('s'::('s'::('u'::('m'::('e'::('d'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('a'::('s'::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('t'::('o'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::(' '::('f'::('r'::('o'::('m'::(' '::('l'::('e'::('f'::('t'::(' '::('t'::('o'::(' '::('r'::('i'::('g'::('h'::('t'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('h'::('i'::('n'::('t'::('s'::(' '::('f'::('i'::('l'::('e'::('.'::(' '::(' '::('T'::('h'::('i'::('s'::(' '::('f'::('l'::('a'::('g'::(' '::('r'::('e'::('v'::('e'::('r'::('s'::('e'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('c'::('o'::('n'::('v'::('e'::('n'::('t'::('i'::('o'::('n'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('r'::('i'::('g'::('h'::('t'::('-'::('t'::('o'::('-'::('l'::('e'::('f'::('t'::('.'::(' '::(' '::('N'::('o'::('t'::('e'::(' '::('t'::('h'::('a'::('t'::(' '::('t'::('h'::('i'::('s'::(' '::('f'::('l'::('a'::('g'::(' '::('i'::('n'::('t'::('e'::('r'::('a'::('c'::('t'::('s'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::('-'::('a'::('s'::('m'::('-'::('i'::('n'::('p'::('u'::('t'::('-'::('f'::('i'::('r'::('s'::('t'::(','::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('d'::('e'::('t'::('e'::('r'::('m'::('i'::('n'::('e'::('s'::(' '::('w'::('h'::('e'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('e'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('p'::('o'::('i'::('n'::('t'::('e'::('r'::('s'::(' '::('a'::('r'::('e'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('l'::('e'::('f'::('t'::(' '::('o'::('r'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('r'::('i'::('g'::('h'::('t'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::('s'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val asm_error_on_unique_names_mismatch_spec :
      (key0 list * spec) * doc **)

  let asm_error_on_unique_names_mismatch_spec =
    ((((Long_key
      ('a'::('s'::('m'::('-'::('e'::('r'::('r'::('o'::('r'::('-'::('o'::('n'::('-'::('u'::('n'::('i'::('q'::('u'::('e'::('-'::('n'::('a'::('m'::('e'::('-'::('m'::('i'::('s'::('m'::('a'::('t'::('c'::('h'::[])))))))))))))))))))))))))))))))))) :: []),
      Unit),
      (('B'::('y'::(' '::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(','::(' '::('w'::('h'::('e'::('n'::(' '::('t'::('h'::('e'::('r'::('e'::('\''::('s'::(' '::('o'::('n'::('l'::('y'::(' '::('o'::('n'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('i'::('n'::(' '::('a'::(' '::('-'::('-'::('h'::('i'::('n'::('t'::('s'::('-'::('f'::('i'::('l'::('e'::(' '::('a'::('n'::('d'::(' '::('o'::('n'::('l'::('y'::(' '::('o'::('n'::('e'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(','::(' '::('t'::('h'::('e'::(' '::('n'::('a'::('m'::('e'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('i'::('s'::(' '::('i'::('g'::('n'::('o'::('r'::('e'::('d'::('.'::(' '::(' '::('P'::('a'::('s'::('s'::('i'::('n'::('g'::(' '::('t'::('h'::('i'::('s'::(' '::('f'::('l'::('a'::('g'::(' '::('d'::('i'::('s'::('a'::('b'::('l'::('e'::('s'::(' '::('t'::('h'::('i'::('s'::(' '::('b'::('e'::('h'::('a'::('v'::('i'::('o'::('r'::(','::(' '::('r'::('a'::('i'::('s'::('i'::('n'::('g'::(' '::('a'::('n'::(' '::('e'::('r'::('r'::('o'::('r'::(' '::('i'::('f'::(' '::('t'::('h'::('e'::(' '::('n'::('a'::('m'::('e'::('s'::(' '::('m'::('i'::('s'::('m'::('a'::('t'::('c'::('h'::(' '::('r'::('e'::('g'::('a'::('r'::('d'::('l'::('e'::('s'::('s'::(' '::('o'::('f'::(' '::('w'::('h'::('e'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('e'::('r'::('e'::(' '::('a'::('r'::('e'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('o'::('r'::(' '::('j'::('u'::('s'::('t'::(' '::('o'::('n'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val asm_rewriting_pipeline_spec : (key0 list * spec) * doc **)

  let asm_rewriting_pipeline_spec =
    ((((Long_key
      ('a'::('s'::('m'::('-'::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::('-'::('p'::('i'::('p'::('e'::('l'::('i'::('n'::('e'::[]))))))))))))))))))))))) :: []),
      (Custom ((Obj.magic parse_string_and parse_list_rewrite_pass),
      ('R'::('E'::('W'::('R'::('I'::('T'::('E'::('_'::('P'::('A'::('S'::('S'::[]))))))))))))))),
      ((append
         ('S'::('p'::('e'::('c'::('i'::('f'::('i'::('e'::('s'::(' '::('t'::('h'::('e'::(' '::('o'::('r'::('d'::('e'::('r'::(' '::('a'::('n'::('d'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('c'::('i'::('t'::('y'::(' '::('o'::('f'::(' '::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::(' '::('p'::('a'::('s'::('s'::('e'::('s'::(' '::('u'::('s'::('e'::('d'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('e'::('q'::('u'::('i'::('v'::('a'::('l'::('e'::('n'::('c'::('e'::(' '::('c'::('h'::('e'::('c'::('k'::('e'::('r'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         default_asm_rewriting_passes) :: []))

  (** val asm_rewriting_passes_spec : (key0 list * spec) * doc **)

  let asm_rewriting_passes_spec =
    ((((Long_key
      ('a'::('s'::('m'::('-'::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::('-'::('p'::('a'::('s'::('s'::('e'::('s'::[]))))))))))))))))))))) :: []),
      String),
      (app
        ((append
           ('A'::(' '::('c'::('o'::('m'::('m'::('a'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::(' '::('p'::('a'::('s'::('s'::('e'::('s'::(' '::('t'::('o'::(' '::('e'::('n'::('a'::('b'::('l'::('e'::('.'::(' '::(' '::('P'::('r'::('e'::('f'::('i'::('x'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::(' '::('t'::('o'::(' '::('d'::('i'::('s'::('a'::('b'::('l'::('e'::(' '::('a'::(' '::('p'::('a'::('s'::('s'::('.'::(' '::(' '::('T'::('h'::('i'::('s'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('n'::('l'::('y'::(' '::('i'::('m'::('p'::('a'::('c'::('t'::('s'::(' '::('p'::('a'::('s'::('s'::('e'::('s'::(' '::('l'::('i'::('s'::('t'::('e'::('d'::(' '::('i'::('n'::(' '::('-'::('-'::('a'::('s'::('m'::('-'::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::('-'::('p'::('i'::('p'::('e'::('l'::('i'::('n'::('e'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
           (if eqb0 default_asm_rewriting_passes []
            then '('::('n'::('o'::('n'::('e'::(')'::[])))))
            else default_asm_rewriting_passes)) :: [])
        (describe_flag_options
          ('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::(' '::('p'::('a'::('s'::('s'::[]))))))))))))))
          ('E'::('n'::('a'::('b'::('l'::('e'::(' '::('a'::('l'::('l'::(' '::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::(' '::('p'::('a'::('s'::('s'::('e'::('s'::[])))))))))))))))))))))))))))
          special_asm_rewriting_pass_flags
          known_asm_rewriting_pass_flags_with_spec)))

  (** val doc_text_before_function_name_spec : (key0 list * spec) * doc **)

  let doc_text_before_function_name_spec =
    ((((Long_key
      ('d'::('o'::('c'::('-'::('t'::('e'::('x'::('t'::('-'::('b'::('e'::('f'::('o'::('r'::('e'::('-'::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('-'::('n'::('a'::('m'::('e'::[])))))))))))))))))))))))))))))) :: []),
      String),
      ((append
         ('D'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('O'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::('A'::(' '::('c'::('u'::('s'::('t'::('o'::('m'::(' '::('s'::('t'::('r'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('i'::('n'::('s'::('e'::('r'::('t'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('t'::('h'::('e'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('n'::('a'::('m'::('e'::(' '::('i'::('n'::(' '::('e'::('a'::('c'::('h'::(' '::('d'::('o'::('c'::('s'::('t'::('r'::('i'::('n'::('g'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         Coq7_Compilers.Options.default_text_before_function_name) :: []))

  (** val doc_text_before_type_name_spec : (key0 list * spec) * doc **)

  let doc_text_before_type_name_spec =
    ((((Long_key
      ('d'::('o'::('c'::('-'::('t'::('e'::('x'::('t'::('-'::('b'::('e'::('f'::('o'::('r'::('e'::('-'::('t'::('y'::('p'::('e'::('-'::('n'::('a'::('m'::('e'::[])))))))))))))))))))))))))) :: []),
      String),
      ((append
         ('D'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('O'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::('A'::(' '::('c'::('u'::('s'::('t'::('o'::('m'::(' '::('s'::('t'::('r'::('i'::('n'::('g'::(' '::('t'::('o'::(' '::('i'::('n'::('s'::('e'::('r'::('t'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('t'::('h'::('e'::(' '::('t'::('y'::('p'::('e'::(' '::('n'::('a'::('m'::('e'::(' '::('i'::('n'::(' '::('e'::('a'::('c'::('h'::(' '::('d'::('o'::('c'::('s'::('t'::('r'::('i'::('n'::('g'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
         Coq7_Compilers.Options.default_text_before_type_name) :: []))

  (** val doc_newline_before_package_declaration_spec :
      (key0 list * spec) * doc **)

  let doc_newline_before_package_declaration_spec =
    ((((Long_key
      ('d'::('o'::('c'::('-'::('n'::('e'::('w'::('l'::('i'::('n'::('e'::('-'::('b'::('e'::('f'::('o'::('r'::('e'::('-'::('p'::('a'::('c'::('k'::('a'::('g'::('e'::('-'::('d'::('e'::('c'::('l'::('a'::('r'::('a'::('t'::('i'::('o'::('n'::[]))))))))))))))))))))))))))))))))))))))) :: []),
      Unit),
      (('D'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('O'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::('F'::('o'::('r'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('e'::('m'::('i'::('t'::(' '::('p'::('a'::('c'::('k'::('a'::('g'::('e'::(' '::('d'::('e'::('c'::('l'::('a'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(','::(' '::('a'::('d'::('d'::(' '::('a'::('n'::(' '::('e'::('x'::('t'::('r'::('a'::(' '::('n'::('e'::('w'::('l'::('i'::('n'::('e'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('t'::('h'::('e'::(' '::('d'::('e'::('c'::('l'::('a'::('r'::('a'::('t'::('i'::('o'::('n'::('.'::(' '::(' '::('P'::('r'::('i'::('m'::('a'::('r'::('i'::('l'::('y'::(' '::('u'::('s'::('e'::('f'::('u'::('l'::(' '::('t'::('o'::(' '::('d'::('e'::('t'::('a'::('c'::('h'::(' '::('t'::('h'::('e'::(' '::('h'::('e'::('a'::('d'::('e'::('r'::(' '::('f'::('r'::('o'::('m'::(' '::('t'::('h'::('e'::(' '::('G'::('o'::(' '::('p'::('a'::('c'::('k'::('a'::('g'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val doc_newline_in_typedef_bounds_spec : (key0 list * spec) * doc **)

  let doc_newline_in_typedef_bounds_spec =
    ((((Long_key
      ('d'::('o'::('c'::('-'::('n'::('e'::('w'::('l'::('i'::('n'::('e'::('-'::('i'::('n'::('-'::('t'::('y'::('p'::('e'::('d'::('e'::('f'::('-'::('b'::('o'::('u'::('n'::('d'::('s'::[])))))))))))))))))))))))))))))) :: []),
      Unit),
      (('D'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('O'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::('W'::('h'::('e'::('n'::(' '::('e'::('m'::('i'::('t'::('t'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('d'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('c'::('o'::('m'::('m'::('e'::('n'::('t'::(' '::('f'::('o'::('r'::(' '::('t'::('y'::('p'::('e'::('d'::('e'::('f'::('s'::(','::(' '::('i'::('n'::('s'::('e'::('r'::('t'::(' '::('a'::(' '::('n'::('e'::('w'::('l'::('i'::('n'::('e'::(' '::('b'::('e'::('t'::('w'::('e'::('e'::('n'::(' '::('"'::('B'::('o'::('u'::('n'::('d'::('s'::(':'::('"'::(' '::('a'::('n'::('d'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('r'::('a'::('t'::('h'::('e'::('r'::(' '::('t'::('h'::('a'::('n'::(' '::('a'::(' '::('s'::('p'::('a'::('c'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val doc_prepend_header_raw_spec : (key0 list * spec) * doc **)

  let doc_prepend_header_raw_spec =
    ((((Long_key
      ('d'::('o'::('c'::('-'::('p'::('r'::('e'::('p'::('e'::('n'::('d'::('-'::('h'::('e'::('a'::('d'::('e'::('r'::('-'::('r'::('a'::('w'::[]))))))))))))))))))))))) :: []),
      String),
      (('D'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('O'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::('P'::('r'::('e'::('p'::('e'::('n'::('d'::(' '::('a'::(' '::('l'::('i'::('n'::('e'::(' '::('b'::('e'::('f'::('o'::('r'::('e'::(' '::('t'::('h'::('e'::(' '::('d'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('h'::('e'::('a'::('d'::('e'::('r'::(' '::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('t'::('o'::('p'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('l'::('e'::('.'::(' '::(' '::('T'::('h'::('i'::('s'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('c'::('a'::('n'::(' '::('b'::('e'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::(' '::('t'::('o'::(' '::('i'::('n'::('s'::('e'::('r'::('t'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('l'::('i'::('n'::('e'::('s'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val doc_prepend_header_spec : (key0 list * spec) * doc **)

  let doc_prepend_header_spec =
    ((((Long_key
      ('d'::('o'::('c'::('-'::('p'::('r'::('e'::('p'::('e'::('n'::('d'::('-'::('h'::('e'::('a'::('d'::('e'::('r'::[]))))))))))))))))))) :: []),
      String),
      (('D'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('O'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::('P'::('r'::('e'::('p'::('e'::('n'::('d'::(' '::('a'::(' '::('l'::('i'::('n'::('e'::(' '::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('b'::('e'::('g'::('i'::('n'::('n'::('i'::('n'::('g'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('d'::('o'::('c'::('u'::('m'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::(' '::('h'::('e'::('a'::('d'::('e'::('r'::(' '::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('t'::('o'::('p'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('f'::('i'::('l'::('e'::('.'::(' '::(' '::('T'::('h'::('i'::('s'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('c'::('a'::('n'::(' '::('b'::('e'::(' '::('p'::('a'::('s'::('s'::('e'::('d'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('t'::('i'::('m'::('e'::('s'::(' '::('t'::('o'::(' '::('i'::('n'::('s'::('e'::('r'::('t'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('l'::('i'::('n'::('e'::('s'::('.'::(' '::(' '::('L'::('i'::('n'::('e'::('s'::(' '::('w'::('i'::('l'::('l'::(' '::('b'::('e'::(' '::('a'::('u'::('t'::('o'::('m'::('a'::('t'::('i'::('c'::('a'::('l'::('l'::('y'::(' '::('c'::('o'::('m'::('m'::('e'::('n'::('t'::('e'::('d'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: []))

  (** val debug_spec : (key0 list * spec) * doc **)

  let debug_spec =
    ((((Long_key ('d'::('e'::('b'::('u'::('g'::[])))))) :: ((Short_key
      ('d'::[])) :: [])), String),
      (app
        ((append
           ('A'::(' '::('c'::('o'::('m'::('m'::('a'::('-'::('s'::('e'::('p'::('a'::('r'::('a'::('t'::('e'::('d'::(' '::('l'::('i'::('s'::('t'::(' '::('o'::('f'::(' '::('d'::('e'::('b'::('u'::('g'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(' '::('t'::('o'::(' '::('t'::('u'::('r'::('n'::(' '::('o'::('n'::('.'::(' '::(' '::('U'::('s'::('e'::(' '::('-'::(' '::('t'::('o'::(' '::('d'::('i'::('s'::('a'::('b'::('l'::('e'::(' '::('a'::('n'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('.'::(' '::(' '::('D'::('e'::('f'::('a'::('u'::('l'::('t'::(' '::('d'::('e'::('b'::('u'::('g'::(' '::('o'::('p'::('t'::('i'::('o'::('n'::('s'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
           (if eqb0 default_debug []
            then '('::('n'::('o'::('n'::('e'::(')'::[])))))
            else default_debug)) :: [])
        (describe_flag_options ('d'::('e'::('b'::('u'::('g'::[])))))
          ('T'::('u'::('r'::('n'::(' '::('a'::('l'::('l'::(' '::('d'::('e'::('b'::('u'::('g'::('g'::('i'::('n'::('g'::(' '::('o'::('n'::[])))))))))))))))))))))
          special_debug_options known_debug_options_with_spec)))

  (** val collapse_list_default : 'a1 -> 'a1 list -> 'a1 **)

  let collapse_list_default default0 ls =
    hd default0 (rev1 ls)

  (** val join_errors :
      ('a1, char list list) sum -> ('a2, char list list) sum -> ('a1 * 'a2,
      char list list) sum **)

  let join_errors x y =
    match x with
    | Inl x0 -> (match y with
                 | Inl y0 -> Inl (x0, y0)
                 | Inr err0 -> Inr err0)
    | Inr err0 ->
      (match y with
       | Inl _ -> Inr err0
       | Inr errs2 -> Inr (app err0 errs2))

  type coq_ParsedSynthesizeOptions = { static : static_opt;
                                       internal_static : internal_static_opt;
                                       inline : inline_opt;
                                       inline_internal : inline_internal_opt;
                                       only_signed : only_signed_opt;
                                       no_select : no_select_opt;
                                       emit_primitives : emit_primitives_opt;
                                       output_options : Coq7_Compilers.Options.output_options_opt;
                                       use_mul_for_cmovznz : use_mul_for_cmovznz_opt;
                                       abstract_interpretation_options : 
                                       Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options;
                                       should_split_mul : should_split_mul_opt;
                                       should_split_multiret : should_split_multiret_opt;
                                       unfold_value_barrier : unfold_value_barrier_opt;
                                       widen_carry : widen_carry_opt;
                                       widen_bytes : widen_bytes_opt;
                                       ignore_unique_asm_names : ignore_unique_asm_names_opt;
                                       machine_wordsize : machine_wordsize_opt;
                                       internal_package_name : Coq7_Compilers.Options.package_name_opt;
                                       internal_class_name : Coq7_Compilers.Options.class_name_opt;
                                       language_naming_conventions : 
                                       Coq7_Compilers.Options.language_naming_conventions_opt;
                                       documentation_options : Coq7_Compilers.Options.documentation_options_opt;
                                       equivalence_checker_options : 
                                       Coq_Options.equivalence_checker_options_opt;
                                       error_on_unused_assembly_functions : 
                                       error_on_unused_assembly_functions_opt;
                                       no_prefix_fiat : bool;
                                       before_header_lines : char list list;
                                       extra_early_header_lines : char list
                                                                  list;
                                       debug_rewriting : debug_rewriting_opt;
                                       debug_on_success : bool }

  (** val static : coq_ParsedSynthesizeOptions -> static_opt **)

  let static parsedSynthesizeOptions =
    parsedSynthesizeOptions.static

  (** val internal_static :
      coq_ParsedSynthesizeOptions -> internal_static_opt **)

  let internal_static parsedSynthesizeOptions =
    parsedSynthesizeOptions.internal_static

  (** val inline : coq_ParsedSynthesizeOptions -> inline_opt **)

  let inline parsedSynthesizeOptions =
    parsedSynthesizeOptions.inline

  (** val inline_internal :
      coq_ParsedSynthesizeOptions -> inline_internal_opt **)

  let inline_internal parsedSynthesizeOptions =
    parsedSynthesizeOptions.inline_internal

  (** val only_signed : coq_ParsedSynthesizeOptions -> only_signed_opt **)

  let only_signed parsedSynthesizeOptions =
    parsedSynthesizeOptions.only_signed

  (** val no_select : coq_ParsedSynthesizeOptions -> no_select_opt **)

  let no_select parsedSynthesizeOptions =
    parsedSynthesizeOptions.no_select

  (** val emit_primitives :
      coq_ParsedSynthesizeOptions -> emit_primitives_opt **)

  let emit_primitives parsedSynthesizeOptions =
    parsedSynthesizeOptions.emit_primitives

  (** val output_options :
      coq_ParsedSynthesizeOptions -> Coq7_Compilers.Options.output_options_opt **)

  let output_options parsedSynthesizeOptions =
    parsedSynthesizeOptions.output_options

  (** val use_mul_for_cmovznz :
      coq_ParsedSynthesizeOptions -> use_mul_for_cmovznz_opt **)

  let use_mul_for_cmovznz parsedSynthesizeOptions =
    parsedSynthesizeOptions.use_mul_for_cmovznz

  (** val abstract_interpretation_options :
      coq_ParsedSynthesizeOptions ->
      Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options **)

  let abstract_interpretation_options parsedSynthesizeOptions =
    parsedSynthesizeOptions.abstract_interpretation_options

  (** val should_split_mul :
      coq_ParsedSynthesizeOptions -> should_split_mul_opt **)

  let should_split_mul parsedSynthesizeOptions =
    parsedSynthesizeOptions.should_split_mul

  (** val should_split_multiret :
      coq_ParsedSynthesizeOptions -> should_split_multiret_opt **)

  let should_split_multiret parsedSynthesizeOptions =
    parsedSynthesizeOptions.should_split_multiret

  (** val unfold_value_barrier :
      coq_ParsedSynthesizeOptions -> unfold_value_barrier_opt **)

  let unfold_value_barrier parsedSynthesizeOptions =
    parsedSynthesizeOptions.unfold_value_barrier

  (** val widen_carry : coq_ParsedSynthesizeOptions -> widen_carry_opt **)

  let widen_carry parsedSynthesizeOptions =
    parsedSynthesizeOptions.widen_carry

  (** val widen_bytes : coq_ParsedSynthesizeOptions -> widen_bytes_opt **)

  let widen_bytes parsedSynthesizeOptions =
    parsedSynthesizeOptions.widen_bytes

  (** val ignore_unique_asm_names :
      coq_ParsedSynthesizeOptions -> ignore_unique_asm_names_opt **)

  let ignore_unique_asm_names parsedSynthesizeOptions =
    parsedSynthesizeOptions.ignore_unique_asm_names

  (** val low_level_rewriter_method :
      coq_ParsedSynthesizeOptions -> low_level_rewriter_method_opt **)

  let low_level_rewriter_method _ =
    default_low_level_rewriter_method

  (** val machine_wordsize :
      coq_ParsedSynthesizeOptions -> machine_wordsize_opt **)

  let machine_wordsize parsedSynthesizeOptions =
    parsedSynthesizeOptions.machine_wordsize

  (** val internal_package_name :
      coq_ParsedSynthesizeOptions -> Coq7_Compilers.Options.package_name_opt **)

  let internal_package_name parsedSynthesizeOptions =
    parsedSynthesizeOptions.internal_package_name

  (** val internal_class_name :
      coq_ParsedSynthesizeOptions -> Coq7_Compilers.Options.class_name_opt **)

  let internal_class_name parsedSynthesizeOptions =
    parsedSynthesizeOptions.internal_class_name

  (** val language_naming_conventions :
      coq_ParsedSynthesizeOptions ->
      Coq7_Compilers.Options.language_naming_conventions_opt **)

  let language_naming_conventions parsedSynthesizeOptions =
    parsedSynthesizeOptions.language_naming_conventions

  (** val documentation_options :
      coq_ParsedSynthesizeOptions ->
      Coq7_Compilers.Options.documentation_options_opt **)

  let documentation_options parsedSynthesizeOptions =
    parsedSynthesizeOptions.documentation_options

  (** val equivalence_checker_options :
      coq_ParsedSynthesizeOptions ->
      Coq_Options.equivalence_checker_options_opt **)

  let equivalence_checker_options parsedSynthesizeOptions =
    parsedSynthesizeOptions.equivalence_checker_options

  (** val error_on_unused_assembly_functions :
      coq_ParsedSynthesizeOptions -> error_on_unused_assembly_functions_opt **)

  let error_on_unused_assembly_functions parsedSynthesizeOptions =
    parsedSynthesizeOptions.error_on_unused_assembly_functions

  (** val no_prefix_fiat : coq_ParsedSynthesizeOptions -> bool **)

  let no_prefix_fiat parsedSynthesizeOptions =
    parsedSynthesizeOptions.no_prefix_fiat

  (** val before_header_lines :
      coq_ParsedSynthesizeOptions -> char list list **)

  let before_header_lines parsedSynthesizeOptions =
    parsedSynthesizeOptions.before_header_lines

  (** val extra_early_header_lines :
      coq_ParsedSynthesizeOptions -> char list list **)

  let extra_early_header_lines parsedSynthesizeOptions =
    parsedSynthesizeOptions.extra_early_header_lines

  (** val debug_rewriting :
      coq_ParsedSynthesizeOptions -> debug_rewriting_opt **)

  let debug_rewriting parsedSynthesizeOptions =
    parsedSynthesizeOptions.debug_rewriting

  (** val debug_on_success : coq_ParsedSynthesizeOptions -> bool **)

  let debug_on_success parsedSynthesizeOptions =
    parsedSynthesizeOptions.debug_on_success

  type coq_SynthesizeOptions = { parsed_synthesize_options : coq_ParsedSynthesizeOptions;
                                 assembly_hints_lines : assembly_hints_lines_opt }

  (** val parsed_synthesize_options :
      coq_SynthesizeOptions -> coq_ParsedSynthesizeOptions **)

  let parsed_synthesize_options synthesizeOptions =
    synthesizeOptions.parsed_synthesize_options

  (** val assembly_hints_lines :
      coq_SynthesizeOptions -> assembly_hints_lines_opt **)

  let assembly_hints_lines synthesizeOptions =
    synthesizeOptions.assembly_hints_lines

  type coq_IODriverOptions = { hint_file_names : char list list;
                               output_file_name : char list;
                               asm_output_file_name : char list }

  (** val hint_file_names : coq_IODriverOptions -> char list list **)

  let hint_file_names iODriverOptions =
    iODriverOptions.hint_file_names

  (** val output_file_name : coq_IODriverOptions -> char list **)

  let output_file_name iODriverOptions =
    iODriverOptions.output_file_name

  (** val asm_output_file_name : coq_IODriverOptions -> char list **)

  let asm_output_file_name iODriverOptions =
    iODriverOptions.asm_output_file_name

  (** val with_read_concat_asm_files_cps :
      (char list -> (char list list -> 'a1) -> 'a1) -> char list list ->
      (assembly_hints_lines_opt -> 'a1) -> 'a1 **)

  let rec with_read_concat_asm_files_cps with_read_file0 = function
  | [] -> (fun k -> k [])
  | fname :: fnames ->
    (fun k ->
      with_read_file0 fname (fun lines0 ->
        with_read_concat_asm_files_cps with_read_file0 fnames (fun rest ->
          k ((fname, lines0) :: rest))))

  (** val common_optional_options :
      supported_languagesT -> ((key0 list * spec) * doc) list **)

  let common_optional_options supported_languages =
    (lang_spec supported_languages) :: (package_name_spec :: (class_name_spec :: (package_case_spec :: (class_case_spec :: (private_function_case_spec :: (public_function_case_spec :: (private_type_case_spec :: (public_type_case_spec :: (no_prefix_fiat_spec :: (static_spec :: (internal_static_spec :: (inline_spec :: (inline_internal_spec :: (no_wide_int_spec :: (widen_carry_spec :: (widen_bytes_spec :: (no_select_spec :: (split_multiret_spec :: (value_barrier_spec :: (no_primitives_spec :: (no_field_element_typedefs_spec :: (emit_all_casts_spec :: (relax_primitive_carry_to_bitwidth_spec :: (cmovznz_by_mul_spec :: (shiftr_avoid_uint1_spec :: (only_signed_spec :: (hint_file_spec :: (output_file_spec :: (asm_output_spec :: (asm_reg_spec :: (asm_callee_saved_registers_spec :: (asm_stack_size_spec :: (no_error_on_unused_asm_functions_spec :: (asm_input_first_spec :: (asm_reg_rtl_spec :: (asm_error_on_unique_names_mismatch_spec :: (asm_rewriting_pipeline_spec :: (asm_rewriting_passes_spec :: (doc_text_before_function_name_spec :: (doc_text_before_type_name_spec :: (doc_newline_before_package_declaration_spec :: (doc_newline_in_typedef_bounds_spec :: (doc_prepend_header_raw_spec :: (doc_prepend_header_spec :: (debug_spec :: [])))))))))))))))))))))))))))))))))))))))))))))

  (** val choose_one_of_many : 'a1 list -> 'a1 option **)

  let choose_one_of_many args0 =
    nth_error (rev1 args0) O

  (** val parse_common_optional_options :
      supported_languagesT -> machine_wordsize_opt -> keyed_spec_list_data ->
      ((coq_IODriverOptions * coq_ParsedSynthesizeOptions) * Coq7_Compilers.ToString.coq_OutputLanguageAPI,
      char list list) sum **)

  let parse_common_optional_options supported_languages machine_wordsizev data =
    let (p, debugv) = Obj.magic data in
    let (p0, doc_prepend_headerv) = p in
    let (p1, doc_prepend_header_rawv) = p0 in
    let (p2, doc_newline_in_typedef_boundsv) = p1 in
    let (p3, doc_newline_before_package_declarationv) = p2 in
    let (p4, doc_text_before_type_namev) = p3 in
    let (p5, doc_text_before_function_namev) = p4 in
    let (p6, asm_rewriting_passesv) = p5 in
    let (p7, asm_rewriting_pipelinev) = p6 in
    let (p8, asm_error_on_unique_names_mismatchv) = p7 in
    let (p9, asm_reg_rtlv) = p8 in
    let (p10, asm_input_firstv) = p9 in
    let (p11, no_error_on_unused_asm_functionsv) = p10 in
    let (p12, asm_stack_sizev) = p11 in
    let (p13, asm_callee_saved_registersv) = p12 in
    let (p14, asm_regv) = p13 in
    let (p15, asm_output_file_namev) = p14 in
    let (p16, output_file_namev) = p15 in
    let (p17, hint_file_namesv) = p16 in
    let (p18, only_signedv) = p17 in
    let (p19, shiftr_avoid_uint1v) = p18 in
    let (p20, cmovznz_by_mulv) = p19 in
    let (p21, relax_primitive_carry_to_bitwidthv) = p20 in
    let (p22, emit_all_castsv) = p21 in
    let (p23, no_field_element_typedefsv) = p22 in
    let (p24, no_primitivesv) = p23 in
    let (p25, value_barrierv) = p24 in
    let (p26, split_multiretv) = p25 in
    let (p27, no_selectv) = p26 in
    let (p28, widen_bytesv) = p27 in
    let (p29, widen_carryv) = p28 in
    let (p30, no_wide_intv) = p29 in
    let (p31, inline_internalv) = p30 in
    let (p32, inlinev) = p31 in
    let (p33, internal_staticv) = p32 in
    let (p34, staticv) = p33 in
    let (p35, no_prefix_fiatv) = p34 in
    let (p36, public_type_casev) = p35 in
    let (p37, private_type_casev) = p36 in
    let (p38, public_function_casev) = p37 in
    let (p39, private_function_casev) = p38 in
    let (p40, class_casev) = p39 in
    let (p41, package_casev) = p40 in
    let (p42, class_namev0) = p41 in
    let (langv, package_namev0) = p42 in
    let flag_to_bool = fun x -> bool_of_full_flag_status x false in
    let to_bool = fun ls -> Nat.ltb O (length ls) in
    let to_string_list = fun ls -> map snd ls in
    let to_N_list = fun ls -> map snd (map snd ls) in
    let to_Z_flat_list = fun ls -> flat_map snd (map snd ls) in
    let to_reg_list = fun ls ->
      match map snd (map snd ls) with
      | [] -> None
      | y :: l -> Some (concat (y :: l))
    in
    let to_rewriting_pipeline_list = fun ls ->
      match map snd (map snd ls) with
      | [] -> RewritePass.default_rewrite_pass_order
      | y :: l -> concat (y :: l)
    in
    let to_assembly_callee_saved_registers_opt = fun ls ->
      choose_one_of_many
        (map (fun pat -> let (_, y0) = pat in let (_, v) = y0 in v) ls)
    in
    let to_assembly_callee_saved_registers_default = fun ls default0 ->
      sequence_return0 (to_assembly_callee_saved_registers_opt ls) default0
    in
    let to_N_opt = fun ls -> choose_one_of_many (to_N_list ls) in
    let to_string_opt = fun ls -> choose_one_of_many (to_string_list ls) in
    let to_string_default = fun ls default0 ->
      sequence_return0 (to_string_opt ls) default0
    in
    let to_capitalization_data_opt = fun ls ->
      choose_one_of_many
        (map (fun pat -> let (_, y0) = pat in let (_, v) = y0 in v) ls)
    in
    let to_capitalization_convention_opt = fun ls ->
      option_map (fun d -> { capitalization_convention_data = d;
        only_lower_first_letters = true }) (to_capitalization_data_opt ls)
    in
    let (p43, t0) =
      parse_flag_opts special_debug_options known_debug_options
        (default_debug :: (map snd debugv))
    in
    let (_, unknown_debug_options) = p43 in
    let (debug_on_successv, debug_rewritingv) = Obj.magic t0 in
    let default_asm_rewriting_pass_status = true in
    let (unknown_asm_rewriting_passes, asm_rewriting_pass_filterv) =
      parse_flag_opts_to_bool_filter default_asm_rewriting_pass_status
        special_asm_rewriting_pass_flags known_asm_rewriting_pass_flags
        (default_asm_rewriting_passes :: (map snd asm_rewriting_passesv))
    in
    let res = (({ hint_file_names = (to_string_list hint_file_namesv);
      output_file_name = (to_string_default output_file_namev ('-'::[]));
      asm_output_file_name =
      (to_string_default asm_output_file_namev ('-'::[])) }, { static =
      (to_bool staticv); internal_static = (to_bool internal_staticv);
      inline = (to_bool inlinev); inline_internal =
      (to_bool inline_internalv); only_signed = (to_bool only_signedv);
      no_select = (to_bool no_selectv); emit_primitives =
      (negb (to_bool no_primitivesv)); output_options =
      { Coq7_Compilers.Options.skip_typedefs_ =
      (to_bool no_field_element_typedefsv);
      Coq7_Compilers.Options.relax_adc_sbb_return_carry_to_bitwidth_ =
      (to_Z_flat_list relax_primitive_carry_to_bitwidthv);
      Coq7_Compilers.Options.language_specific_cast_adjustment_ =
      (negb (to_bool emit_all_castsv)) }; use_mul_for_cmovznz =
      (to_bool cmovznz_by_mulv); abstract_interpretation_options =
      (to_bool shiftr_avoid_uint1v); should_split_mul =
      (to_bool no_wide_intv); should_split_multiret =
      (to_bool split_multiretv); unfold_value_barrier =
      (negb (to_bool value_barrierv)); widen_carry = (to_bool widen_carryv);
      widen_bytes = (to_bool widen_bytesv); ignore_unique_asm_names =
      (negb (to_bool asm_error_on_unique_names_mismatchv));
      machine_wordsize = machine_wordsizev; internal_package_name =
      (to_string_opt package_namev0); internal_class_name =
      (to_string_opt class_namev0); language_naming_conventions =
      { Coq7_Compilers.Options.public_function_naming_convention =
      (to_capitalization_convention_opt public_function_casev);
      Coq7_Compilers.Options.private_function_naming_convention =
      (to_capitalization_convention_opt private_function_casev);
      Coq7_Compilers.Options.public_type_naming_convention =
      (to_capitalization_convention_opt public_type_casev);
      Coq7_Compilers.Options.private_type_naming_convention =
      (to_capitalization_convention_opt private_type_casev);
      Coq7_Compilers.Options.variable_naming_convention = None;
      Coq7_Compilers.Options.package_naming_convention =
      (to_capitalization_convention_opt package_casev);
      Coq7_Compilers.Options.class_naming_convention =
      (to_capitalization_convention_opt class_casev) };
      documentation_options =
      { Coq7_Compilers.Options.text_before_function_name_opt =
      (to_string_opt doc_text_before_function_namev);
      Coq7_Compilers.Options.text_before_type_name_opt =
      (to_string_opt doc_text_before_type_namev);
      Coq7_Compilers.Options.newline_before_package_declaration =
      (to_bool doc_newline_before_package_declarationv);
      Coq7_Compilers.Options.newline_in_typedef_bounds =
      (to_bool doc_newline_in_typedef_boundsv) };
      equivalence_checker_options = { Coq_Options.assembly_conventions_ =
      { assembly_calling_registers_ = (to_reg_list asm_regv);
      assembly_stack_size_ = (to_N_opt asm_stack_sizev);
      assembly_output_first_ = (negb (to_bool asm_input_firstv));
      assembly_argument_registers_left_to_right_ =
      (negb (to_bool asm_reg_rtlv)); assembly_callee_saved_registers_ =
      (to_assembly_callee_saved_registers_default asm_callee_saved_registersv
        default_assembly_callee_saved_registers) };
      Coq_Options.symbolic_options_ = { Options.asm_rewriting_pipeline =
      (to_rewriting_pipeline_list asm_rewriting_pipelinev);
      Options.asm_rewriting_pass_filter = (fun p44 ->
      asm_rewriting_pass_filterv (RewritePass.show_rewrite_pass p44)) } };
      error_on_unused_assembly_functions =
      (negb (to_bool no_error_on_unused_asm_functionsv)); no_prefix_fiat =
      (to_bool no_prefix_fiatv); before_header_lines =
      (to_string_list doc_prepend_header_rawv); extra_early_header_lines =
      (to_string_list doc_prepend_headerv); debug_rewriting =
      (flag_to_bool debug_rewritingv); debug_on_success =
      (flag_to_bool debug_on_successv) }),
      (snd (hd (lang_default supported_languages) langv)))
    in
    let unknown_errs =
      fun descr sing_suffix plural_suffix arg unknown_opts ->
      match unknown_opts with
      | [] -> []
      | _ :: _ ->
        (append
          ('U'::('n'::('r'::('e'::('c'::('o'::('g'::('n'::('i'::('z'::('e'::('d'::(' '::[])))))))))))))
          (append descr
            (append
              (if Nat.ltb (S O) (length unknown_opts)
               then plural_suffix
               else sing_suffix)
              (append (' '::('('::('f'::('r'::('o'::('m'::(' '::[])))))))
                (append arg
                  (append (')'::(':'::(' '::[])))
                    (concat0 (','::(' '::[])) (map fst unknown_opts)))))))) :: []
    in
    let lang_errs =
      match langv with
      | [] -> []
      | _ :: l ->
        (match l with
         | [] -> []
         | _ :: _ ->
           (append
             ('O'::('n'::('l'::('y'::(' '::('o'::('n'::('e'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::(' '::('s'::('p'::('e'::('c'::('i'::('f'::('i'::('c'::('a'::('t'::('i'::('o'::('n'::(' '::('w'::('i'::('t'::('h'::(' '::('-'::('-'::('l'::('a'::('n'::('g'::(' '::('i'::('s'::(' '::('a'::('l'::('l'::('o'::('w'::('e'::('d'::(';'::(' '::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('e'::(' '::('l'::('a'::('n'::('g'::('u'::('a'::('g'::('e'::('s'::(' '::('w'::('e'::('r'::('e'::(' '::('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
             (concat0 (','::(' '::[])) (map fst langv))) :: [])
    in
    (match app lang_errs
             (app
               (unknown_errs
                 ('d'::('e'::('b'::('u'::('g'::(' '::('f'::('l'::('a'::('g'::[]))))))))))
                 [] ('s'::[])
                 ('-'::('-'::('d'::('e'::('b'::('u'::('g'::[])))))))
                 unknown_debug_options)
               (unknown_errs
                 ('a'::('s'::('s'::('e'::('m'::('b'::('l'::('y'::(' '::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::(' '::('p'::('a'::('s'::('s'::[])))))))))))))))))))))))
                 [] ('e'::('s'::[]))
                 ('-'::('-'::('a'::('s'::('m'::('-'::('r'::('e'::('w'::('r'::('i'::('t'::('i'::('n'::('g'::('-'::('p'::('a'::('s'::('s'::('e'::('s'::[]))))))))))))))))))))))
                 unknown_asm_rewriting_passes)) with
     | [] -> Inl res
     | s0 :: l -> Inr (s0 :: l))

  type coq_PipelineAPI = { spec : arg_spec;
                           parse_args : (coq_SynthesizeOptions ->
                                        arg_spec_results -> (__ * __,
                                        char list list) sum);
                           show_lines_args : ((__ * __) -> char list list);
                           coq_Synthesize : (Coq7_Compilers.ToString.coq_OutputLanguageAPI
                                            -> coq_SynthesizeOptions -> __ ->
                                            char list list -> char list ->
                                            ((synthesis_output_kind * char list) * (char list,
                                            (Pipeline.coq_ErrorMessage,
                                            char list list) errorT) debugM)
                                            list) }

  (** val spec : coq_PipelineAPI -> arg_spec **)

  let spec pipelineAPI =
    pipelineAPI.spec

  type coq_ParsedArgsT = __

  type coq_StringArgsT = __

  type coq_ArgsT = coq_StringArgsT * coq_ParsedArgsT

  (** val parse_args :
      coq_PipelineAPI -> coq_SynthesizeOptions -> arg_spec_results ->
      (coq_ArgsT, char list list) sum **)

  let parse_args pipelineAPI =
    pipelineAPI.parse_args

  (** val show_lines_args : coq_PipelineAPI -> coq_ArgsT -> char list list **)

  let show_lines_args pipelineAPI =
    pipelineAPI.show_lines_args

  (** val coq_Synthesize :
      coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
      coq_SynthesizeOptions -> coq_ParsedArgsT -> char list list -> char list
      -> ((synthesis_output_kind * char list) * (char list,
      (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

  let coq_Synthesize pipelineAPI =
    pipelineAPI.coq_Synthesize

  type 'a coq_IODriverAPI = { error : (char list list -> 'a);
                              ret : (unit -> 'a);
                              with_read_stdin : ((char list list -> 'a) -> 'a);
                              write_stdout_then : (char list list -> (unit ->
                                                  'a) -> 'a);
                              write_stderr_then : (char list list -> (unit ->
                                                  'a) -> 'a);
                              with_read_file : (char list -> (char list list
                                               -> 'a) -> 'a);
                              write_file_then : (char list -> char list list
                                                -> (unit -> 'a) -> 'a) }

  (** val error : 'a1 coq_IODriverAPI -> char list list -> 'a1 **)

  let error iODriverAPI =
    iODriverAPI.error

  (** val ret : 'a1 coq_IODriverAPI -> unit -> 'a1 **)

  let ret iODriverAPI =
    iODriverAPI.ret

  (** val with_read_stdin :
      'a1 coq_IODriverAPI -> (char list list -> 'a1) -> 'a1 **)

  let with_read_stdin iODriverAPI =
    iODriverAPI.with_read_stdin

  (** val write_stdout_then :
      'a1 coq_IODriverAPI -> char list list -> (unit -> 'a1) -> 'a1 **)

  let write_stdout_then iODriverAPI =
    iODriverAPI.write_stdout_then

  (** val write_stderr_then :
      'a1 coq_IODriverAPI -> char list list -> (unit -> 'a1) -> 'a1 **)

  let write_stderr_then iODriverAPI =
    iODriverAPI.write_stderr_then

  (** val with_read_file :
      'a1 coq_IODriverAPI -> char list -> (char list list -> 'a1) -> 'a1 **)

  let with_read_file iODriverAPI =
    iODriverAPI.with_read_file

  (** val write_file_then :
      'a1 coq_IODriverAPI -> char list -> char list list -> (unit -> 'a1) ->
      'a1 **)

  let write_file_then iODriverAPI =
    iODriverAPI.write_file_then

  module Parameterized =
   struct
    (** val coq_PipelineLines :
        coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
        coq_SynthesizeOptions -> char list -> char list -> char list ->
        coq_ArgsT -> ((synthesis_output_kind * char list) * (char list,
        (Pipeline.coq_ErrorMessage, char list list) errorT) debugM) list **)

    let coq_PipelineLines api0 output_language_api synthesize_opts invocation curve_description str_machine_wordsize args0 =
      let prefix1 =
        append
          (if synthesize_opts.parsed_synthesize_options.no_prefix_fiat
           then []
           else 'f'::('i'::('a'::('t'::('_'::[])))))
          (if eqb0 curve_description []
           then []
           else append curve_description ('_'::[]))
      in
      let header0 =
        app
          (app
            synthesize_opts.parsed_synthesize_options.extra_early_header_lines
            ((append
               ('A'::('u'::('t'::('o'::('g'::('e'::('n'::('e'::('r'::('a'::('t'::('e'::('d'::(':'::(' '::[])))))))))))))))
               invocation) :: ((if eqb0 curve_description []
                                then (match synthesize_opts.parsed_synthesize_options.internal_package_name with
                                      | Some pkg ->
                                        (match pkg with
                                         | [] ->
                                           (match synthesize_opts.parsed_synthesize_options.internal_class_name with
                                            | Some cls ->
                                              (match cls with
                                               | [] ->
                                                 append
                                                   ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))
                                                   curve_description
                                               | _::_ ->
                                                 append
                                                   ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(' '::('('::('v'::('i'::('a'::(' '::('p'::('a'::('c'::('k'::('a'::('g'::('e'::(' '::('n'::('a'::('m'::('e'::(')'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                                   pkg)
                                            | None ->
                                              append
                                                ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))
                                                curve_description)
                                         | _::_ ->
                                           append
                                             ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(' '::('('::('v'::('i'::('a'::(' '::('p'::('a'::('c'::('k'::('a'::('g'::('e'::(' '::('n'::('a'::('m'::('e'::(')'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))))
                                             pkg)
                                      | None ->
                                        (match synthesize_opts.parsed_synthesize_options.internal_class_name with
                                         | Some cls ->
                                           (match cls with
                                            | [] ->
                                              append
                                                ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))
                                                curve_description
                                            | _::_ ->
                                              append
                                                ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(' '::('('::('v'::('i'::('a'::(' '::('c'::('l'::('a'::('s'::('s'::(' '::('n'::('a'::('m'::('e'::(')'::(':'::(' '::[]))))))))))))))))))))))))))))))))))))
                                                cls)
                                         | None ->
                                           append
                                             ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))
                                             curve_description))
                                else append
                                       ('c'::('u'::('r'::('v'::('e'::(' '::('d'::('e'::('s'::('c'::('r'::('i'::('p'::('t'::('i'::('o'::('n'::(':'::(' '::[])))))))))))))))))))
                                       curve_description) :: ((append
                                                                ('m'::('a'::('c'::('h'::('i'::('n'::('e'::('_'::('w'::('o'::('r'::('d'::('s'::('i'::('z'::('e'::(' '::('='::(' '::[])))))))))))))))))))
                                                                (append
                                                                  (show0
                                                                    Decimal.show_Z
                                                                    synthesize_opts.parsed_synthesize_options.machine_wordsize)
                                                                  (append
                                                                    (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                                                    (append
                                                                    str_machine_wordsize
                                                                    ('"'::(')'::[])))))) :: []))))
          (api0.show_lines_args args0)
      in
      api0.coq_Synthesize output_language_api synthesize_opts (snd args0)
        header0 prefix1

    (** val coq_ProcessedLines :
        coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
        coq_SynthesizeOptions -> char list -> char list -> char list ->
        coq_ArgsT -> ((char list, char list list * char list list) debugM,
        char list list) sum **)

    let coq_ProcessedLines api0 output_language_api synthesize_opts invocation curve_description str_machine_wordsize args0 =
      match coq_CollectErrors
              synthesize_opts.parsed_synthesize_options.machine_wordsize
              output_language_api
              (coq_PipelineLines api0 output_language_api synthesize_opts
                invocation curve_description str_machine_wordsize args0) with
      | Inl ls ->
        let (ls_normal, ls_asm) = Debug.eval_result ls in
        let before_header =
          map (fun s0 -> append s0 (newLine::[]))
            synthesize_opts.parsed_synthesize_options.before_header_lines
        in
        let postprocess_lines = fun ls0 ->
          strip_trailing_newlines
            (flat_map (fun s0 ->
              app
                (map (fun s1 -> append s1 (newLine::[]))
                  (map strip_trailing_spaces s0)) ((newLine::[]) :: [])) ls0)
        in
        Inl
        (Debug.sequence (Debug.copy_debug_info ls)
          (Debug.ret ((app before_header (postprocess_lines ls_normal)),
            (postprocess_lines ls_asm))))
      | Inr l0 ->
        (match l0 with
         | [] -> Inr []
         | l :: ls ->
           let flatten_debug_info = fun ls0 ->
             let dbg =
               flat_map (fun f -> (newLine::[]) :: (f ()))
                 (Debug.get_debug_info ls0)
             in
             let ls1 = Debug.eval_result ls0 in app dbg ls1
           in
           Inr
           (app (flatten_debug_info l)
             (flat_map (fun e -> (newLine::[]) :: (flatten_debug_info e)) ls)))

    (** val coq_Pipeline :
        coq_PipelineAPI -> Coq7_Compilers.ToString.coq_OutputLanguageAPI ->
        coq_SynthesizeOptions -> char list -> char list -> char list ->
        coq_ArgsT -> (((char list list * char list list) * char list list) ->
        'a1) -> (char list list -> 'a1) -> 'a1 **)

    let coq_Pipeline api0 output_language_api synthesize_opts invocation curve_description str_machine_wordsize args0 success error0 =
      match coq_ProcessedLines api0 output_language_api synthesize_opts
              invocation curve_description str_machine_wordsize args0 with
      | Inl s0 ->
        let stderr =
          if synthesize_opts.parsed_synthesize_options.debug_on_success
          then flat_map (fun f -> (newLine::[]) :: (f ()))
                 (Debug.get_debug_info s0)
          else []
        in
        let (normal_ls, asm_ls) = Debug.eval_result s0 in
        success ((stderr, normal_ls), asm_ls)
      | Inr s0 -> error0 s0

    (** val coq_PipelineMain :
        coq_PipelineAPI -> prog_name_countT -> supported_languagesT -> 'a1
        coq_IODriverAPI -> char list list -> 'a1 **)

    let coq_PipelineMain api0 prog_name_count supported_languages io_driver argv =
      let with_read_file0 = fun fname ->
        if eqb0 fname ('-'::[])
        then io_driver.with_read_stdin
        else io_driver.with_read_file fname
      in
      let write_file_then0 = fun fname ->
        if eqb0 fname ('-'::[])
        then io_driver.write_stdout_then
        else io_driver.write_file_then fname
      in
      let invocation = concat0 (' '::[]) (map quote argv) in
      let full_spec = { named_args =
        (app (common_optional_options supported_languages)
          api0.spec.named_args); anon_args =
        (curve_description_spec :: (machine_wordsize_spec :: api0.spec.anon_args));
        anon_opt_args = api0.spec.anon_opt_args; anon_opt_repeated_arg =
        api0.spec.anon_opt_repeated_arg }
      in
      (match parse_argv prog_name_count argv full_spec with
       | Success v ->
         let (p, anon_opt_repeated_data) = v in
         let (p0, anon_opt_data) = p in
         let (named_data, anon_data) = p0 in
         let (common_named_data, named_data0) =
           split_type_of_list'
             (map (Obj.magic __)
               (common_optional_options supported_languages))
             (let rec map6 = function
              | [] -> []
              | _ :: t0 -> __ :: (map6 t0)
              in map6 api0.spec.named_args) named_data
         in
         let (y, anon_data0) =
           split_type_of_list' (__ :: (__ :: []))
             (let rec map6 = function
              | [] -> []
              | _ :: t0 -> __ :: (map6 t0)
              in map6 api0.spec.anon_args) anon_data
         in
         let (curve_description, y0) = Obj.magic y in
         let (str_machine_wordsize, machine_wordsize0) = y0 in
         (match parse_common_optional_options supported_languages
                  machine_wordsize0 common_named_data with
          | Inl p1 ->
            let (p2, output_language_api) = p1 in
            let (io_driver_opts, opts) = p2 in
            with_read_concat_asm_files_cps with_read_file0
              io_driver_opts.hint_file_names (fun assembly_hints_linesv ->
              let success = fun pat ->
                let (y1, asm_lines) = pat in
                let (stderr, normal_lines) = y1 in
                io_driver.write_stderr_then stderr (fun pat0 ->
                  let () = pat0 in
                  write_file_then0 io_driver_opts.output_file_name
                    normal_lines (fun pat1 ->
                    let () = pat1 in
                    (match asm_lines with
                     | [] ->
                       (match assembly_hints_linesv with
                        | [] -> io_driver.ret ()
                        | _ :: _ ->
                          write_file_then0
                            io_driver_opts.asm_output_file_name asm_lines
                            io_driver.ret)
                     | _ :: _ ->
                       write_file_then0 io_driver_opts.asm_output_file_name
                         asm_lines io_driver.ret)))
              in
              let opts0 = { parsed_synthesize_options = opts;
                assembly_hints_lines = assembly_hints_linesv }
              in
              (match api0.parse_args opts0 (((named_data0, anon_data0),
                       anon_opt_data), anon_opt_repeated_data) with
               | Inl args0 ->
                 coq_Pipeline api0 output_language_api opts0 invocation
                   curve_description str_machine_wordsize args0 success
                   io_driver.error
               | Inr errs -> io_driver.error errs))
          | Inr errs -> io_driver.error errs)
       | Error err0 ->
         let display =
           show_list_parse_error default_should_block_indent full_spec err0
         in
         if is_real_error err0
         then io_driver.error display
         else io_driver.write_stdout_then
                (map (fun s0 -> append s0 (newLine::[])) display)
                io_driver.ret)
   end

  module UnsaturatedSolinas =
   struct
    (** val api : coq_PipelineAPI **)

    let api =
      { spec = { named_args = (tight_bounds_multiplier_spec :: []);
        anon_args = (n_spec :: (sc_spec :: [])); anon_opt_args = [];
        anon_opt_repeated_arg = (Some
        (function_to_synthesize_spec valid_names0)) }; parse_args =
        (fun opts args0 ->
        let (p, requests) = args0 in
        let (p0, s0) = p in
        let (tight_bounds_multiplier, s1) = p0 in
        let (y, y0) = Obj.magic s1 in
        let (str_n, n3) = y in
        let (str_sc, p1) = y0 in
        let (s2, c0) = p1 in
        let () = Obj.magic s0 in
        let show_requests =
          match Obj.magic requests with
          | [] -> '('::('a'::('l'::('l'::(')'::[]))))
          | _ :: _ -> concat0 (','::(' '::[])) (Obj.magic requests)
        in
        let (str_tight_bounds_multiplier, tight_bounds_multiplier0) =
          collapse_list_default ([], tight_bounds_multiplier_default)
            (map snd (Obj.magic tight_bounds_multiplier))
        in
        (match get_num_limbs tight_bounds_multiplier0 s2 c0
                 opts.parsed_synthesize_options.machine_wordsize n3 with
         | Some n4 ->
           Inl
             ((Obj.magic (((str_n, str_sc), str_tight_bounds_multiplier),
                show_requests)),
             (Obj.magic ((((n4, s2), c0), tight_bounds_multiplier0),
               requests)))
         | None ->
           (match n3 with
            | NumLimbs n4 ->
              Inr
                ((append
                   ('I'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::(' '::('e'::('r'::('r'::('o'::('r'::(':'::(' '::('g'::('e'::('t'::('_'::('n'::('u'::('m'::('_'::('l'::('i'::('m'::('b'::('s'::(' '::('('::('o'::('n'::(' '::('('::[])))))))))))))))))))))))))))))))))))
                   (append (PowersOfTwo.show_Z s2)
                     (append (','::(' '::[]))
                       (append (show_c c0)
                         (append (','::(' '::[]))
                           (append
                             (show0 Decimal.show_Z
                               opts.parsed_synthesize_options.machine_wordsize)
                             (append (','::(' '::[]))
                               (append (show0 Decimal.show_nat n4)
                                 (')'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::('e'::('d'::(' '::('N'::('o'::('n'::('e'::(' '::('e'::('v'::('e'::('n'::(' '::('t'::('h'::('o'::('u'::('g'::('h'::(' '::('t'::('h'::('e'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('w'::('a'::('s'::(' '::('N'::('u'::('m'::('L'::('i'::('m'::('b'::('s'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])
            | Auto idx0 ->
              Inr
                ((append
                   ('I'::('n'::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::[]))))))))))))))
                   (append (show0 Decimal.show_nat idx0)
                     (append
                       (' '::('w'::('h'::('e'::('n'::(' '::('g'::('u'::('e'::('s'::('s'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::(' '::('n'::('u'::('m'::('b'::('e'::('r'::(' '::('o'::('f'::(' '::('l'::('i'::('m'::('b'::('s'::(' '::('f'::('o'::('r'::(' '::('s'::('-'::('c'::(' '::('='::(' '::[])))))))))))))))))))))))))))))))))))))))))))))
                       (append (PowersOfTwo.show_Z s2)
                         (append (' '::('-'::(' '::[])))
                           (append (show_c c0)
                             (append
                               (';'::(' '::('v'::('a'::('l'::('i'::('d'::(' '::('i'::('n'::('d'::('i'::('c'::('e'::('s'::(' '::('m'::('u'::('s'::('t'::(' '::('i'::('n'::('d'::('e'::('x'::(' '::('i'::('n'::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('l'::('i'::('s'::('t'::(' '::[])))))))))))))))))))))))))))))))))))))))))
                               (append
                                 (show0
                                   (show_of_ShowLevel
                                     (show_lvl_list Decimal.show_lvl_nat))
                                   (get_possible_limbs
                                     tight_bounds_multiplier0 s2 c0
                                     opts.parsed_synthesize_options.machine_wordsize))
                                 ('.'::[]))))))))) :: []))));
        show_lines_args = (fun pat ->
        let (p, p0) = pat in
        let (p1, show_requests) = Obj.magic p in
        let (p2, str_tight_bounds_multiplier) = p1 in
        let (str_n, str_sc) = p2 in
        let (p3, _) = Obj.magic p0 in
        let (p4, tight_bounds_multiplier) = p3 in
        let (p5, c0) = p4 in
        let (n3, s0) = p5 in
        (append
          ('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(':'::(' '::[]))))))))))))))))))))))
          show_requests) :: ((append ('n'::(' '::('='::(' '::[]))))
                               (append (show0 Decimal.show_nat n3)
                                 (append
                                   (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                   (append str_n ('"'::(')'::[])))))) :: (
        (append ('s'::('-'::('c'::(' '::('='::(' '::[]))))))
          (append (PowersOfTwo.show_Z s0)
            (append (' '::('-'::(' '::[])))
              (append (show_c c0)
                (append
                  (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                  (append str_sc ('"'::(')'::[])))))))) :: ((append
                                                              ('t'::('i'::('g'::('h'::('t'::('_'::('b'::('o'::('u'::('n'::('d'::('s'::('_'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::(' '::('='::(' '::[]))))))))))))))))))))))))))
                                                              (append
                                                                (show0
                                                                  Decimal.show_Q
                                                                  tight_bounds_multiplier)
                                                                (append
                                                                  (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                                                  (append
                                                                    str_tight_bounds_multiplier
                                                                    ('"'::(')'::[])))))) :: []))));
        coq_Synthesize = (fun output_language_api opts pat ->
        let (p, requests) = Obj.magic pat in
        let (p0, tight_bounds_multiplier) = p in
        let (p1, c0) = p0 in
        let (n3, s0) = p1 in
        (fun comment_header prefix1 ->
        synthesize1 output_language_api { Coq0_Options.absint_opts =
          opts.parsed_synthesize_options.abstract_interpretation_options;
          Coq0_Options.widen_carry =
          opts.parsed_synthesize_options.widen_carry;
          Coq0_Options.widen_bytes =
          opts.parsed_synthesize_options.widen_bytes;
          Coq0_Options.unfold_value_barrier =
          opts.parsed_synthesize_options.unfold_value_barrier;
          Coq0_Options.should_split_multiret =
          opts.parsed_synthesize_options.should_split_multiret;
          Coq0_Options.should_split_mul =
          opts.parsed_synthesize_options.should_split_mul;
          Coq0_Options.output_options =
          opts.parsed_synthesize_options.output_options;
          Coq0_Options.only_signed =
          opts.parsed_synthesize_options.only_signed;
          Coq0_Options.no_select = opts.parsed_synthesize_options.no_select;
          Coq0_Options.low_level_rewriter_method =
          (low_level_rewriter_method opts.parsed_synthesize_options);
          Coq0_Options.debug_rewriting =
          opts.parsed_synthesize_options.debug_rewriting }
          { Coq0_Options.static = opts.parsed_synthesize_options.static;
          Coq0_Options.language_naming_conventions =
          opts.parsed_synthesize_options.language_naming_conventions;
          Coq0_Options.internal_static =
          opts.parsed_synthesize_options.internal_static;
          Coq0_Options.inline_internal =
          opts.parsed_synthesize_options.inline_internal;
          Coq0_Options.inline = opts.parsed_synthesize_options.inline;
          Coq0_Options.documentation_options =
          opts.parsed_synthesize_options.documentation_options }
          { Coq0_Options.use_mul_for_cmovznz =
          opts.parsed_synthesize_options.use_mul_for_cmovznz;
          Coq0_Options.package_namev =
          opts.parsed_synthesize_options.internal_package_name;
          Coq0_Options.ignore_unique_asm_names =
          opts.parsed_synthesize_options.ignore_unique_asm_names;
          Coq0_Options.error_on_unused_assembly_functions =
          opts.parsed_synthesize_options.error_on_unused_assembly_functions;
          Coq0_Options.emit_primitives =
          opts.parsed_synthesize_options.emit_primitives;
          Coq0_Options.class_namev =
          opts.parsed_synthesize_options.internal_class_name;
          Coq0_Options.assembly_hints_lines = opts.assembly_hints_lines;
          Coq0_Options.equivalence_checker_options =
          opts.parsed_synthesize_options.equivalence_checker_options }
          tight_bounds_multiplier n3 s0 c0
          opts.parsed_synthesize_options.machine_wordsize comment_header
          prefix1 requests)) }

    (** val coq_PipelineMain :
        prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
        char list list -> 'a1 **)

    let coq_PipelineMain prog_name_count supported_languages io_driver argv =
      Parameterized.coq_PipelineMain api prog_name_count supported_languages
        io_driver argv
   end

  module WordByWordMontgomery =
   struct
    (** val api : coq_PipelineAPI **)

    let api =
      { spec = { named_args = []; anon_args = (m_spec :: []); anon_opt_args =
        []; anon_opt_repeated_arg = (Some
        (function_to_synthesize_spec valid_names1)) }; parse_args =
        (fun _ args0 ->
        let (p, requests) = args0 in
        let (p0, s0) = p in
        let (k, s1) = p0 in
        let () = Obj.magic k in
        let (str_m, m4) = Obj.magic s1 in
        let () = Obj.magic s0 in
        let show_requests =
          match Obj.magic requests with
          | [] -> '('::('a'::('l'::('l'::(')'::[]))))
          | _ :: _ -> concat0 (','::(' '::[])) (Obj.magic requests)
        in
        Inl ((Obj.magic (str_m, show_requests)), (Obj.magic (m4, requests))));
        show_lines_args = (fun pat ->
        let (p, p0) = pat in
        let (str_m, show_requests) = Obj.magic p in
        let (m4, _) = Obj.magic p0 in
        (append
          ('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(':'::(' '::[]))))))))))))))))))))))
          show_requests) :: ((append ('m'::(' '::('='::(' '::[]))))
                               (append (Hex.show_Z m4)
                                 (append
                                   (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                   (append str_m ('"'::(')'::[])))))) :: ((' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (('N'::('O'::('T'::('E'::(':'::(' '::('I'::('n'::(' '::('a'::('d'::('d'::('i'::('t'::('i'::('o'::('n'::(' '::('t'::('o'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('s'::('p'::('e'::('c'::('i'::('f'::('i'::('e'::('d'::(' '::('a'::('b'::('o'::('v'::('e'::(' '::('e'::('a'::('c'::('h'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(','::(' '::('a'::('l'::('l'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::('d'::(' '::('f'::('o'::('r'::(' '::('t'::('h'::('i'::('s'::(' '::('M'::('o'::('n'::('t'::('g'::('o'::('m'::('e'::('r'::('y'::(' '::('a'::('r'::('i'::('t'::('h'::('m'::('e'::('t'::('i'::('c'::(' '::('r'::('e'::('q'::('u'::('i'::('r'::('e'::(' '::('t'::('h'::('e'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('s'::('t'::('r'::('i'::('c'::('t'::('l'::('y'::(' '::('l'::('e'::('s'::('s'::(' '::('t'::('h'::('a'::('n'::(' '::('t'::('h'::('e'::(' '::('p'::('r'::('i'::('m'::('e'::(' '::('m'::('o'::('d'::('u'::('l'::('u'::('s'::(' '::('('::('m'::(')'::(','::(' '::('a'::('n'::('d'::(' '::('a'::('l'::('s'::('o'::(' '::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('r'::('e'::('q'::('u'::('i'::('r'::('e'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('t'::('o'::(' '::('b'::('e'::(' '::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('u'::('n'::('i'::('q'::('u'::('e'::(' '::('s'::('a'::('t'::('u'::('r'::('a'::('t'::('e'::('d'::(' '::('r'::('e'::('p'::('r'::('e'::('s'::('e'::('n'::('t'::('a'::('t'::('i'::('o'::('n'::('.'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('A'::('l'::('l'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::('s'::(' '::('a'::('l'::('s'::('o'::(' '::('e'::('n'::('s'::('u'::('r'::('e'::(' '::('t'::('h'::('a'::('t'::(' '::('t'::('h'::('e'::('s'::('e'::(' '::('t'::('w'::('o'::(' '::('p'::('r'::('o'::('p'::('e'::('r'::('t'::('i'::('e'::('s'::(' '::('a'::('r'::('e'::(' '::('t'::('r'::('u'::('e'::(' '::('o'::('f'::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: ((' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('v'::('a'::('l'::('u'::('e'::('s'::('.'::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::(' '::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])))))))));
        coq_Synthesize = (fun output_language_api opts pat ->
        let (m4, requests) = Obj.magic pat in
        (fun comment_header prefix1 ->
        synthesize2 output_language_api { Coq0_Options.absint_opts =
          opts.parsed_synthesize_options.abstract_interpretation_options;
          Coq0_Options.widen_carry =
          opts.parsed_synthesize_options.widen_carry;
          Coq0_Options.widen_bytes =
          opts.parsed_synthesize_options.widen_bytes;
          Coq0_Options.unfold_value_barrier =
          opts.parsed_synthesize_options.unfold_value_barrier;
          Coq0_Options.should_split_multiret =
          opts.parsed_synthesize_options.should_split_multiret;
          Coq0_Options.should_split_mul =
          opts.parsed_synthesize_options.should_split_mul;
          Coq0_Options.output_options =
          opts.parsed_synthesize_options.output_options;
          Coq0_Options.only_signed =
          opts.parsed_synthesize_options.only_signed;
          Coq0_Options.no_select = opts.parsed_synthesize_options.no_select;
          Coq0_Options.low_level_rewriter_method =
          (low_level_rewriter_method opts.parsed_synthesize_options);
          Coq0_Options.debug_rewriting =
          opts.parsed_synthesize_options.debug_rewriting }
          { Coq0_Options.static = opts.parsed_synthesize_options.static;
          Coq0_Options.language_naming_conventions =
          opts.parsed_synthesize_options.language_naming_conventions;
          Coq0_Options.internal_static =
          opts.parsed_synthesize_options.internal_static;
          Coq0_Options.inline_internal =
          opts.parsed_synthesize_options.inline_internal;
          Coq0_Options.inline = opts.parsed_synthesize_options.inline;
          Coq0_Options.documentation_options =
          opts.parsed_synthesize_options.documentation_options }
          { Coq0_Options.use_mul_for_cmovznz =
          opts.parsed_synthesize_options.use_mul_for_cmovznz;
          Coq0_Options.package_namev =
          opts.parsed_synthesize_options.internal_package_name;
          Coq0_Options.ignore_unique_asm_names =
          opts.parsed_synthesize_options.ignore_unique_asm_names;
          Coq0_Options.error_on_unused_assembly_functions =
          opts.parsed_synthesize_options.error_on_unused_assembly_functions;
          Coq0_Options.emit_primitives =
          opts.parsed_synthesize_options.emit_primitives;
          Coq0_Options.class_namev =
          opts.parsed_synthesize_options.internal_class_name;
          Coq0_Options.assembly_hints_lines = opts.assembly_hints_lines;
          Coq0_Options.equivalence_checker_options =
          opts.parsed_synthesize_options.equivalence_checker_options } m4
          opts.parsed_synthesize_options.machine_wordsize comment_header
          prefix1 requests)) }

    (** val coq_PipelineMain :
        prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
        char list list -> 'a1 **)

    let coq_PipelineMain prog_name_count supported_languages io_driver argv =
      Parameterized.coq_PipelineMain api prog_name_count supported_languages
        io_driver argv
   end

  module SaturatedSolinas =
   struct
    (** val api : coq_PipelineAPI **)

    let api =
      { spec = { named_args = []; anon_args = (sc_spec :: []);
        anon_opt_args = []; anon_opt_repeated_arg = (Some
        (function_to_synthesize_spec valid_names)) }; parse_args =
        (fun _ args0 ->
        let (p, requests) = args0 in
        let (p0, s0) = p in
        let (k, s1) = p0 in
        let () = Obj.magic k in
        let (str_sc, p1) = Obj.magic s1 in
        let (s2, c0) = p1 in
        let () = Obj.magic s0 in
        let show_requests =
          match Obj.magic requests with
          | [] -> '('::('a'::('l'::('l'::(')'::[]))))
          | _ :: _ -> concat0 (','::(' '::[])) (Obj.magic requests)
        in
        Inl ((Obj.magic (str_sc, show_requests)),
        (Obj.magic ((s2, c0), requests)))); show_lines_args = (fun pat ->
        let (p, p0) = pat in
        let (str_sc, show_requests) = Obj.magic p in
        let (p1, _) = Obj.magic p0 in
        let (s0, c0) = p1 in
        (append
          ('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(':'::(' '::[]))))))))))))))))))))))
          show_requests) :: ((append
                               ('s'::('-'::('c'::(' '::('='::(' '::[]))))))
                               (append (PowersOfTwo.show_Z s0)
                                 (append (' '::('-'::(' '::[])))
                                   (append (show_c c0)
                                     (append
                                       (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                       (append str_sc ('"'::(')'::[])))))))) :: []));
        coq_Synthesize = (fun output_language_api opts pat ->
        let (p, requests) = Obj.magic pat in
        let (s0, c0) = p in
        (fun comment_header prefix1 ->
        synthesize0 output_language_api { Coq0_Options.absint_opts =
          opts.parsed_synthesize_options.abstract_interpretation_options;
          Coq0_Options.widen_carry =
          opts.parsed_synthesize_options.widen_carry;
          Coq0_Options.widen_bytes =
          opts.parsed_synthesize_options.widen_bytes;
          Coq0_Options.unfold_value_barrier =
          opts.parsed_synthesize_options.unfold_value_barrier;
          Coq0_Options.should_split_multiret =
          opts.parsed_synthesize_options.should_split_multiret;
          Coq0_Options.should_split_mul =
          opts.parsed_synthesize_options.should_split_mul;
          Coq0_Options.output_options =
          opts.parsed_synthesize_options.output_options;
          Coq0_Options.only_signed =
          opts.parsed_synthesize_options.only_signed;
          Coq0_Options.no_select = opts.parsed_synthesize_options.no_select;
          Coq0_Options.low_level_rewriter_method =
          (low_level_rewriter_method opts.parsed_synthesize_options);
          Coq0_Options.debug_rewriting =
          opts.parsed_synthesize_options.debug_rewriting }
          { Coq0_Options.static = opts.parsed_synthesize_options.static;
          Coq0_Options.language_naming_conventions =
          opts.parsed_synthesize_options.language_naming_conventions;
          Coq0_Options.internal_static =
          opts.parsed_synthesize_options.internal_static;
          Coq0_Options.inline_internal =
          opts.parsed_synthesize_options.inline_internal;
          Coq0_Options.inline = opts.parsed_synthesize_options.inline;
          Coq0_Options.documentation_options =
          opts.parsed_synthesize_options.documentation_options }
          { Coq0_Options.use_mul_for_cmovznz =
          opts.parsed_synthesize_options.use_mul_for_cmovznz;
          Coq0_Options.package_namev =
          opts.parsed_synthesize_options.internal_package_name;
          Coq0_Options.ignore_unique_asm_names =
          opts.parsed_synthesize_options.ignore_unique_asm_names;
          Coq0_Options.error_on_unused_assembly_functions =
          opts.parsed_synthesize_options.error_on_unused_assembly_functions;
          Coq0_Options.emit_primitives =
          opts.parsed_synthesize_options.emit_primitives;
          Coq0_Options.class_namev =
          opts.parsed_synthesize_options.internal_class_name;
          Coq0_Options.assembly_hints_lines = opts.assembly_hints_lines;
          Coq0_Options.equivalence_checker_options =
          opts.parsed_synthesize_options.equivalence_checker_options } s0 c0
          opts.parsed_synthesize_options.machine_wordsize comment_header
          prefix1 requests)) }

    (** val coq_PipelineMain :
        prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
        char list list -> 'a1 **)

    let coq_PipelineMain prog_name_count supported_languages io_driver argv =
      Parameterized.coq_PipelineMain api prog_name_count supported_languages
        io_driver argv
   end

  module DettmanMultiplication =
   struct
    (** val api : coq_PipelineAPI **)

    let api =
      { spec = { named_args = (inbounds_multiplier_spec :: []); anon_args =
        (n_nat_spec :: (last_limb_width_spec :: (last_reduction_spec :: (sc_spec :: []))));
        anon_opt_args = []; anon_opt_repeated_arg = (Some
        (function_to_synthesize_spec valid_names3)) }; parse_args =
        (fun _ args0 ->
        let (p, requests) = args0 in
        let (p0, s0) = p in
        let (inbounds_multiplier, s1) = p0 in
        let (p1, y) = Obj.magic s1 in
        let (p2, y0) = p1 in
        let (y1, y2) = p2 in
        let (str_n, n3) = y1 in
        let (str_last_limb_width, last_limb_width) = y2 in
        let (str_last_reduction, last_reduction) = y0 in
        let (str_sc, p3) = y in
        let (s2, c0) = p3 in
        let () = Obj.magic s0 in
        let show_requests =
          match Obj.magic requests with
          | [] -> '('::('a'::('l'::('l'::(')'::[]))))
          | _ :: _ -> concat0 (','::(' '::[])) (Obj.magic requests)
        in
        let to_string_opt = fun ls -> choose_one_of_many (map snd ls) in
        let inbounds_multiplier0 = Obj.magic to_string_opt inbounds_multiplier
        in
        let (str_inbounds_multiplier, inbounds_multiplier1) =
          parse_dirbounds_multiplier ('i'::('n'::[])) (Inl
            inbounds_multiplier0)
        in
        (match inbounds_multiplier1 with
         | Inl inbounds_multiplier2 ->
           Inl
             ((Obj.magic (((((str_n, str_last_limb_width),
                str_last_reduction), str_sc), str_inbounds_multiplier),
                show_requests)),
             (Obj.magic ((((((n3, last_limb_width), last_reduction), s2),
               c0), inbounds_multiplier2), requests)))
         | Inr errs -> Inr errs)); show_lines_args = (fun pat ->
        let (p, p0) = pat in
        let (p1, show_requests) = Obj.magic p in
        let (p2, str_inbounds_multiplier) = p1 in
        let (p3, str_sc) = p2 in
        let (p4, str_last_reduction) = p3 in
        let (str_n, str_last_limb_width) = p4 in
        let (p5, _) = Obj.magic p0 in
        let (p6, inbounds_multiplier) = p5 in
        let (p7, c0) = p6 in
        let (p8, s0) = p7 in
        let (p9, last_reduction) = p8 in
        let (n3, last_limb_width) = p9 in
        (append
          ('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(':'::(' '::[]))))))))))))))))))))))
          show_requests) :: ((append ('n'::(' '::('='::(' '::[]))))
                               (append (show0 Decimal.show_nat n3)
                                 (append
                                   (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                   (append str_n ('"'::(')'::[])))))) :: (
        (append
          ('l'::('a'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('_'::('w'::('i'::('d'::('t'::('h'::(' '::('='::(' '::[]))))))))))))))))))
          (append (show0 Decimal.show_nat last_limb_width)
            (append
              (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
              (append str_last_limb_width ('"'::(')'::[])))))) :: ((append
                                                                    ('l'::('a'::('s'::('t'::('_'::('r'::('e'::('d'::('u'::('c'::('t'::('i'::('o'::('n'::(' '::('='::(' '::[])))))))))))))))))
                                                                    (append
                                                                    (show0
                                                                    Decimal.show_nat
                                                                    last_reduction)
                                                                    (append
                                                                    (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                                                    (append
                                                                    str_last_reduction
                                                                    ('"'::(')'::[])))))) :: (
        (append ('s'::('-'::('c'::(' '::('='::(' '::[]))))))
          (append (PowersOfTwo.show_Z s0)
            (append (' '::('-'::(' '::[])))
              (append (show_c c0)
                (append
                  (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                  (append str_sc ('"'::(')'::[])))))))) :: ((append
                                                              ('i'::('n'::('b'::('o'::('u'::('n'::('d'::('s'::('_'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::(':'::(' '::[])))))))))))))))))))))
                                                              (append
                                                                (show0
                                                                  (show_of_ShowLevel
                                                                    (show_lvl_option
                                                                    Decimal.show_lvl_Q))
                                                                  inbounds_multiplier)
                                                                (append
                                                                  (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                                                  (append
                                                                    str_inbounds_multiplier
                                                                    ('"'::(')'::[])))))) :: []))))));
        coq_Synthesize = (fun output_language_api opts pat ->
        let (p, requests) = Obj.magic pat in
        let (p0, inbounds_multiplier) = p in
        let (p1, c0) = p0 in
        let (p2, s0) = p1 in
        let (p3, last_reduction) = p2 in
        let (n3, last_limb_width) = p3 in
        (fun comment_header prefix1 ->
        synthesize4 output_language_api { Coq0_Options.absint_opts =
          opts.parsed_synthesize_options.abstract_interpretation_options;
          Coq0_Options.widen_carry =
          opts.parsed_synthesize_options.widen_carry;
          Coq0_Options.widen_bytes =
          opts.parsed_synthesize_options.widen_bytes;
          Coq0_Options.unfold_value_barrier =
          opts.parsed_synthesize_options.unfold_value_barrier;
          Coq0_Options.should_split_multiret =
          opts.parsed_synthesize_options.should_split_multiret;
          Coq0_Options.should_split_mul =
          opts.parsed_synthesize_options.should_split_mul;
          Coq0_Options.output_options =
          opts.parsed_synthesize_options.output_options;
          Coq0_Options.only_signed =
          opts.parsed_synthesize_options.only_signed;
          Coq0_Options.no_select = opts.parsed_synthesize_options.no_select;
          Coq0_Options.low_level_rewriter_method =
          (low_level_rewriter_method opts.parsed_synthesize_options);
          Coq0_Options.debug_rewriting =
          opts.parsed_synthesize_options.debug_rewriting }
          { Coq0_Options.static = opts.parsed_synthesize_options.static;
          Coq0_Options.language_naming_conventions =
          opts.parsed_synthesize_options.language_naming_conventions;
          Coq0_Options.internal_static =
          opts.parsed_synthesize_options.internal_static;
          Coq0_Options.inline_internal =
          opts.parsed_synthesize_options.inline_internal;
          Coq0_Options.inline = opts.parsed_synthesize_options.inline;
          Coq0_Options.documentation_options =
          opts.parsed_synthesize_options.documentation_options }
          { Coq0_Options.use_mul_for_cmovznz =
          opts.parsed_synthesize_options.use_mul_for_cmovznz;
          Coq0_Options.package_namev =
          opts.parsed_synthesize_options.internal_package_name;
          Coq0_Options.ignore_unique_asm_names =
          opts.parsed_synthesize_options.ignore_unique_asm_names;
          Coq0_Options.error_on_unused_assembly_functions =
          opts.parsed_synthesize_options.error_on_unused_assembly_functions;
          Coq0_Options.emit_primitives =
          opts.parsed_synthesize_options.emit_primitives;
          Coq0_Options.class_namev =
          opts.parsed_synthesize_options.internal_class_name;
          Coq0_Options.assembly_hints_lines = opts.assembly_hints_lines;
          Coq0_Options.equivalence_checker_options =
          opts.parsed_synthesize_options.equivalence_checker_options }
          opts.parsed_synthesize_options.machine_wordsize s0 c0 n3
          last_limb_width last_reduction inbounds_multiplier comment_header
          prefix1 requests)) }

    (** val coq_PipelineMain :
        prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
        char list list -> 'a1 **)

    let coq_PipelineMain prog_name_count supported_languages io_driver argv =
      Parameterized.coq_PipelineMain api prog_name_count supported_languages
        io_driver argv
   end

  module SolinasReduction =
   struct
    (** val api : coq_PipelineAPI **)

    let api =
      { spec = { named_args = []; anon_args = (sc_spec :: []);
        anon_opt_args = []; anon_opt_repeated_arg = (Some
        (function_to_synthesize_spec valid_names4)) }; parse_args =
        (fun _ args0 ->
        let (p, requests) = args0 in
        let (p0, s0) = p in
        let (k, s1) = p0 in
        let () = Obj.magic k in
        let (str_sc, p1) = Obj.magic s1 in
        let (s2, c0) = p1 in
        let () = Obj.magic s0 in
        let show_requests =
          match Obj.magic requests with
          | [] -> '('::('a'::('l'::('l'::(')'::[]))))
          | _ :: _ -> concat0 (','::(' '::[])) (Obj.magic requests)
        in
        Inl ((Obj.magic (str_sc, show_requests)),
        (Obj.magic ((s2, c0), requests)))); show_lines_args = (fun pat ->
        let (p, p0) = pat in
        let (str_sc, show_requests) = Obj.magic p in
        let (p1, _) = Obj.magic p0 in
        let (s0, c0) = p1 in
        (append
          ('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(':'::(' '::[]))))))))))))))))))))))
          show_requests) :: ((append
                               ('s'::('-'::('c'::(' '::('='::(' '::[]))))))
                               (append (PowersOfTwo.show_Z s0)
                                 (append (' '::('-'::(' '::[])))
                                   (append (show_c c0)
                                     (append
                                       (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                       (append str_sc ('"'::(')'::[])))))))) :: []));
        coq_Synthesize = (fun output_language_api opts pat ->
        let (p, requests) = Obj.magic pat in
        let (s0, c0) = p in
        (fun comment_header prefix1 ->
        synthesize5 output_language_api { Coq0_Options.absint_opts =
          opts.parsed_synthesize_options.abstract_interpretation_options;
          Coq0_Options.widen_carry =
          opts.parsed_synthesize_options.widen_carry;
          Coq0_Options.widen_bytes =
          opts.parsed_synthesize_options.widen_bytes;
          Coq0_Options.unfold_value_barrier =
          opts.parsed_synthesize_options.unfold_value_barrier;
          Coq0_Options.should_split_multiret =
          opts.parsed_synthesize_options.should_split_multiret;
          Coq0_Options.should_split_mul =
          opts.parsed_synthesize_options.should_split_mul;
          Coq0_Options.output_options =
          opts.parsed_synthesize_options.output_options;
          Coq0_Options.only_signed =
          opts.parsed_synthesize_options.only_signed;
          Coq0_Options.no_select = opts.parsed_synthesize_options.no_select;
          Coq0_Options.low_level_rewriter_method =
          (low_level_rewriter_method opts.parsed_synthesize_options);
          Coq0_Options.debug_rewriting =
          opts.parsed_synthesize_options.debug_rewriting }
          { Coq0_Options.static = opts.parsed_synthesize_options.static;
          Coq0_Options.language_naming_conventions =
          opts.parsed_synthesize_options.language_naming_conventions;
          Coq0_Options.internal_static =
          opts.parsed_synthesize_options.internal_static;
          Coq0_Options.inline_internal =
          opts.parsed_synthesize_options.inline_internal;
          Coq0_Options.inline = opts.parsed_synthesize_options.inline;
          Coq0_Options.documentation_options =
          opts.parsed_synthesize_options.documentation_options }
          { Coq0_Options.use_mul_for_cmovznz =
          opts.parsed_synthesize_options.use_mul_for_cmovznz;
          Coq0_Options.package_namev =
          opts.parsed_synthesize_options.internal_package_name;
          Coq0_Options.ignore_unique_asm_names =
          opts.parsed_synthesize_options.ignore_unique_asm_names;
          Coq0_Options.error_on_unused_assembly_functions =
          opts.parsed_synthesize_options.error_on_unused_assembly_functions;
          Coq0_Options.emit_primitives =
          opts.parsed_synthesize_options.emit_primitives;
          Coq0_Options.class_namev =
          opts.parsed_synthesize_options.internal_class_name;
          Coq0_Options.assembly_hints_lines = opts.assembly_hints_lines;
          Coq0_Options.equivalence_checker_options =
          opts.parsed_synthesize_options.equivalence_checker_options } s0 c0
          opts.parsed_synthesize_options.machine_wordsize comment_header
          prefix1 requests)) }

    (** val coq_PipelineMain :
        prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
        char list list -> 'a1 **)

    let coq_PipelineMain prog_name_count supported_languages io_driver argv =
      Parameterized.coq_PipelineMain api prog_name_count supported_languages
        io_driver argv
   end

  module BaseConversion =
   struct
    (** val api : coq_PipelineAPI **)

    let api =
      { spec = { named_args =
        (inbounds_multiplier_spec :: (outbounds_multiplier_spec :: (inbounds_spec :: (outbounds_spec :: (use_bitwidth_in_spec :: (use_bitwidth_out_spec :: []))))));
        anon_args =
        (src_n_spec :: (sc_spec :: (src_limbwidth_spec :: (dst_limbwidth_spec :: []))));
        anon_opt_args = []; anon_opt_repeated_arg = (Some
        (function_to_synthesize_spec valid_names2)) }; parse_args =
        (fun _ args0 ->
        let (p, requests) = args0 in
        let (p0, s0) = p in
        let (k, s1) = p0 in
        let (p1, use_bitwidth_out) = Obj.magic k in
        let (p2, use_bitwidth_in) = p1 in
        let (p3, outbounds) = p2 in
        let (p4, inbounds) = p3 in
        let (inbounds_multiplier, outbounds_multiplier) = p4 in
        let (p5, y) = Obj.magic s1 in
        let (p6, y0) = p5 in
        let (y1, y2) = p6 in
        let (str_src_n, src_n) = y1 in
        let (str_sc, p7) = y2 in
        let (s2, c0) = p7 in
        let (str_src_limbwidth, src_limbwidth) = y0 in
        let (str_dst_limbwidth, dst_limbwidth) = y in
        let () = Obj.magic s0 in
        let show_requests =
          match Obj.magic requests with
          | [] -> '('::('a'::('l'::('l'::(')'::[]))))
          | _ :: _ -> concat0 (','::(' '::[])) (Obj.magic requests)
        in
        let to_bool = fun ls -> Nat.ltb O (length ls) in
        let to_string_opt = fun ls -> choose_one_of_many (map snd ls) in
        let inbounds_multiplier0 = to_string_opt inbounds_multiplier in
        let outbounds_multiplier0 = to_string_opt outbounds_multiplier in
        let inbounds0 = to_string_opt inbounds in
        let outbounds0 = to_string_opt outbounds in
        let use_bitwidth_in0 = to_bool use_bitwidth_in in
        let use_bitwidth_out0 = to_bool use_bitwidth_out in
        let (str_inbounds_multiplier, inbounds_multiplier1) =
          parse_dirbounds_multiplier ('i'::('n'::[])) (Inl
            inbounds_multiplier0)
        in
        let (str_outbounds_multiplier, outbounds_multiplier1) =
          parse_dirbounds_multiplier ('o'::('u'::('t'::[]))) (Inl
            outbounds_multiplier0)
        in
        let (str_inbounds, inbounds1) =
          parse_dirbounds ('i'::('n'::[])) (Inl inbounds0) use_bitwidth_in0
        in
        let (str_outbounds, outbounds1) =
          parse_dirbounds ('o'::('u'::('t'::[]))) (Inl outbounds0)
            use_bitwidth_out0
        in
        (match join_errors
                 (join_errors inbounds_multiplier1 outbounds_multiplier1)
                 (join_errors inbounds1 outbounds1) with
         | Inl p8 ->
           let (p9, p10) = p8 in
           let (inbounds_multiplier2, outbounds_multiplier2) = p9 in
           let (inbounds2, outbounds2) = p10 in
           Inl
           ((Obj.magic ((((((((((str_src_n, str_sc), str_src_limbwidth),
              str_dst_limbwidth), str_inbounds_multiplier),
              str_outbounds_multiplier), use_bitwidth_in0),
              use_bitwidth_out0), str_inbounds), str_outbounds),
              show_requests)),
           (Obj.magic (((((((((src_n, s2), c0), src_limbwidth),
             dst_limbwidth), inbounds_multiplier2), outbounds_multiplier2),
             inbounds2), outbounds2), requests)))
         | Inr errs -> Inr errs)); show_lines_args = (fun pat ->
        let (p, p0) = pat in
        let (p1, show_requests) = Obj.magic p in
        let (p2, str_outbounds) = p1 in
        let (p3, str_inbounds) = p2 in
        let (p4, use_bitwidth_out) = p3 in
        let (p5, use_bitwidth_in) = p4 in
        let (p6, str_outbounds_multiplier) = p5 in
        let (p7, str_inbounds_multiplier) = p6 in
        let (p8, str_dst_limbwidth) = p7 in
        let (p9, str_src_limbwidth) = p8 in
        let (str_src_n, str_sc) = p9 in
        let (p10, _) = Obj.magic p0 in
        let (p11, outbounds) = p10 in
        let (p12, inbounds) = p11 in
        let (p13, outbounds_multiplier) = p12 in
        let (p14, inbounds_multiplier) = p13 in
        let (p15, dst_limbwidth) = p14 in
        let (p16, src_limbwidth) = p15 in
        let (p17, c0) = p16 in
        let (src_n, s0) = p17 in
        (append
          ('r'::('e'::('q'::('u'::('e'::('s'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(':'::(' '::[]))))))))))))))))))))))
          show_requests) :: ((append
                               ('s'::('r'::('c'::('_'::('n'::(' '::('='::(' '::[]))))))))
                               (append (show0 Decimal.show_nat src_n)
                                 (append
                                   (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                   (append str_src_n ('"'::(')'::[])))))) :: (
        (append ('s'::('-'::('c'::(' '::('='::(' '::[]))))))
          (append (PowersOfTwo.show_Z s0)
            (append (' '::('-'::(' '::[])))
              (append (show_c c0)
                (append
                  (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                  (append str_sc ('"'::(')'::[])))))))) :: ((append
                                                              ('s'::('r'::('c'::('_'::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::(' '::('='::(' '::[]))))))))))))))))
                                                              (append
                                                                (show0
                                                                  Decimal.show_Q
                                                                  src_limbwidth)
                                                                (append
                                                                  (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                                                  (append
                                                                    str_src_limbwidth
                                                                    ('"'::(')'::[])))))) :: (
        (append
          ('d'::('s'::('t'::('_'::('l'::('i'::('m'::('b'::('w'::('i'::('d'::('t'::('h'::(' '::('='::(' '::[]))))))))))))))))
          (append (show0 Decimal.show_Q dst_limbwidth)
            (append
              (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
              (append str_dst_limbwidth ('"'::(')'::[])))))) :: ((append
                                                                   ('i'::('n'::('b'::('o'::('u'::('n'::('d'::('s'::('_'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::(' '::('='::(' '::[]))))))))))))))))))))))
                                                                   (append
                                                                    (show0
                                                                    (show_of_ShowLevel
                                                                    (show_lvl_option
                                                                    Decimal.show_lvl_Q))
                                                                    inbounds_multiplier)
                                                                    (append
                                                                    (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                                                    (append
                                                                    str_inbounds_multiplier
                                                                    ('"'::(')'::[])))))) :: (
        (append
          ('o'::('u'::('t'::('b'::('o'::('u'::('n'::('d'::('s'::('_'::('m'::('u'::('l'::('t'::('i'::('p'::('l'::('i'::('e'::('r'::(' '::('='::(' '::[])))))))))))))))))))))))
          (append
            (show0 (show_of_ShowLevel (show_lvl_option Decimal.show_lvl_Q))
              outbounds_multiplier)
            (append
              (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
              (append str_outbounds_multiplier ('"'::(')'::[])))))) :: (
        (append
          ('i'::('n'::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('='::(' '::[])))))))))))
          (append (show0 show_bounds inbounds)
            (append
              (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
              (append str_inbounds
                (append
                  ('"'::(' '::('a'::('n'::('d'::(' '::('u'::('s'::('e'::('_'::('b'::('i'::('t'::('h'::('w'::('i'::('d'::('t'::('h'::('_'::('i'::('n'::(' '::('='::(' '::[])))))))))))))))))))))))))
                  (append
                    (show0 (show_of_ShowLevel show_lvl_bool) use_bitwidth_in)
                    (')'::[]))))))) :: ((append
                                          ('o'::('u'::('t'::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('='::(' '::[]))))))))))))
                                          (append
                                            (show0 show_bounds outbounds)
                                            (append
                                              (' '::('('::('f'::('r'::('o'::('m'::(' '::('"'::[]))))))))
                                              (append str_outbounds
                                                (append
                                                  ('"'::(' '::('a'::('n'::('d'::(' '::('u'::('s'::('e'::('_'::('b'::('i'::('t'::('h'::('w'::('i'::('d'::('t'::('h'::('_'::('o'::('u'::('t'::(' '::('='::(' '::[]))))))))))))))))))))))))))
                                                  (append
                                                    (show0
                                                      (show_of_ShowLevel
                                                        show_lvl_bool)
                                                      use_bitwidth_out)
                                                    (')'::[]))))))) :: [])))))))));
        coq_Synthesize = (fun output_language_api opts pat ->
        let (p, requests) = Obj.magic pat in
        let (p0, outbounds) = p in
        let (p1, inbounds) = p0 in
        let (p2, outbounds_multiplier) = p1 in
        let (p3, inbounds_multiplier) = p2 in
        let (p4, dst_limbwidth) = p3 in
        let (p5, src_limbwidth) = p4 in
        let (p6, c0) = p5 in
        let (src_n, s0) = p6 in
        (fun comment_header prefix1 ->
        synthesize3 output_language_api { Coq0_Options.absint_opts =
          opts.parsed_synthesize_options.abstract_interpretation_options;
          Coq0_Options.widen_carry =
          opts.parsed_synthesize_options.widen_carry;
          Coq0_Options.widen_bytes =
          opts.parsed_synthesize_options.widen_bytes;
          Coq0_Options.unfold_value_barrier =
          opts.parsed_synthesize_options.unfold_value_barrier;
          Coq0_Options.should_split_multiret =
          opts.parsed_synthesize_options.should_split_multiret;
          Coq0_Options.should_split_mul =
          opts.parsed_synthesize_options.should_split_mul;
          Coq0_Options.output_options =
          opts.parsed_synthesize_options.output_options;
          Coq0_Options.only_signed =
          opts.parsed_synthesize_options.only_signed;
          Coq0_Options.no_select = opts.parsed_synthesize_options.no_select;
          Coq0_Options.low_level_rewriter_method =
          (low_level_rewriter_method opts.parsed_synthesize_options);
          Coq0_Options.debug_rewriting =
          opts.parsed_synthesize_options.debug_rewriting }
          { Coq0_Options.static = opts.parsed_synthesize_options.static;
          Coq0_Options.language_naming_conventions =
          opts.parsed_synthesize_options.language_naming_conventions;
          Coq0_Options.internal_static =
          opts.parsed_synthesize_options.internal_static;
          Coq0_Options.inline_internal =
          opts.parsed_synthesize_options.inline_internal;
          Coq0_Options.inline = opts.parsed_synthesize_options.inline;
          Coq0_Options.documentation_options =
          opts.parsed_synthesize_options.documentation_options }
          { Coq0_Options.use_mul_for_cmovznz =
          opts.parsed_synthesize_options.use_mul_for_cmovznz;
          Coq0_Options.package_namev =
          opts.parsed_synthesize_options.internal_package_name;
          Coq0_Options.ignore_unique_asm_names =
          opts.parsed_synthesize_options.ignore_unique_asm_names;
          Coq0_Options.error_on_unused_assembly_functions =
          opts.parsed_synthesize_options.error_on_unused_assembly_functions;
          Coq0_Options.emit_primitives =
          opts.parsed_synthesize_options.emit_primitives;
          Coq0_Options.class_namev =
          opts.parsed_synthesize_options.internal_class_name;
          Coq0_Options.assembly_hints_lines = opts.assembly_hints_lines;
          Coq0_Options.equivalence_checker_options =
          opts.parsed_synthesize_options.equivalence_checker_options } s0 c0
          src_n src_limbwidth dst_limbwidth
          opts.parsed_synthesize_options.machine_wordsize inbounds_multiplier
          outbounds_multiplier inbounds outbounds comment_header prefix1
          requests)) }

    (** val coq_PipelineMain :
        prog_name_countT -> supported_languagesT -> 'a1 coq_IODriverAPI ->
        char list list -> 'a1 **)

    let coq_PipelineMain prog_name_count supported_languages io_driver argv =
      Parameterized.coq_PipelineMain api prog_name_count supported_languages
        io_driver argv
   end

  module FiatCrypto =
   struct
    (** val coq_PipelineMain :
        supported_languagesT -> 'a1 coq_IODriverAPI -> char list list -> 'a1 **)

    let coq_PipelineMain supported_languages io_driver argv =
      let spec0 = { named_args = []; anon_args = (synthesis_kind_spec :: []);
        anon_opt_args = []; anon_opt_repeated_arg = None }
      in
      (match parse_argv (S O) (firstn (S (S O)) argv) spec0 with
       | Success v ->
         let (p, _anon_opt_repeated_data) = v in
         let (p0, _anon_opt_data) = p in
         let (_named_data, anon_data) = p0 in
         let () = Obj.magic _named_data in
         let () = Obj.magic _anon_opt_data in
         let () = Obj.magic _anon_opt_repeated_data in
         let prog_name_count = S (S O) in
         (match Obj.magic anon_data with
          | Coq_word_by_word_montgomery ->
            WordByWordMontgomery.coq_PipelineMain prog_name_count
              supported_languages io_driver argv
          | Coq_unsaturated_solinas ->
            UnsaturatedSolinas.coq_PipelineMain prog_name_count
              supported_languages io_driver argv
          | Coq_saturated_solinas ->
            SaturatedSolinas.coq_PipelineMain prog_name_count
              supported_languages io_driver argv
          | Coq_dettman_multiplication ->
            DettmanMultiplication.coq_PipelineMain prog_name_count
              supported_languages io_driver argv
          | Coq_solinas_reduction ->
            SolinasReduction.coq_PipelineMain prog_name_count
              supported_languages io_driver argv
          | Coq_base_conversion ->
            BaseConversion.coq_PipelineMain prog_name_count
              supported_languages io_driver argv)
       | Error err0 ->
         let display =
           show_list_parse_error default_should_block_indent spec0 err0
         in
         if is_real_error err0
         then io_driver.error display
         else io_driver.write_stdout_then
                (map (fun s0 -> append s0 (newLine::[])) display)
                io_driver.ret)
   end
 end

type trace =
| Finished
| Err of char list list
| Read_stdin of (char list list -> trace)
| Write_stdout of char list list * trace
| Write_stderr of char list list * trace
| Read_file of char list * (char list list -> trace)
| Write_file of char list * char list list * trace

(** val iODriverTrace : trace ForExtraction.coq_IODriverAPI **)

let iODriverTrace =
  { ForExtraction.error = (fun x -> Err x); ForExtraction.ret = (fun pat ->
    let () = pat in Finished); ForExtraction.with_read_stdin = (fun x ->
    Read_stdin x); ForExtraction.write_stdout_then = (fun msg k ->
    Write_stdout (msg, (k ()))); ForExtraction.write_stderr_then =
    (fun msg k -> Write_stderr (msg, (k ()))); ForExtraction.with_read_file =
    (fun x x0 -> Read_file (x, x0)); ForExtraction.write_file_then =
    (fun name0 contents k -> Write_file (name0, contents, (k ()))) }

(** val split_stdout_stderr :
    (char list list, char list list) sum list -> char list list * char list
    list **)

let rec split_stdout_stderr = function
| [] -> ([], [])
| s0 :: ls0 ->
  (match s0 with
   | Inl stdout ->
     let (stdouts, stderrs) = split_stdout_stderr ls0 in
     ((app stdout stdouts), stderrs)
   | Inr stderr ->
     let (stdouts, stderrs) = split_stdout_stderr ls0 in
     (stdouts, (app stderr stderrs)))

(** val eval' :
    trace -> char list list list -> (char list * char list list) list ->
    ((char list list, char list list) sum list -> 'a1) -> (char list list,
    char list list) sum list -> (char list * char list list) list ->
    (char list list option * 'a1) * (char list * char list list) list **)

let rec eval' t0 stdin files fuse_stdout_stderr stdout_stderr_r_acc new_files =
  match t0 with
  | Finished ->
    ((None, (fuse_stdout_stderr (rev' stdout_stderr_r_acc))), new_files)
  | Err msg ->
    (((Some msg), (fuse_stdout_stderr (rev' stdout_stderr_r_acc))), new_files)
  | Read_stdin k ->
    let (inp, stdin0) =
      match stdin with
      | [] -> ([], [])
      | inp :: stdin0 -> (inp, stdin0)
    in
    eval' (k inp) stdin0 files fuse_stdout_stderr stdout_stderr_r_acc
      new_files
  | Write_stdout (msg, k) ->
    eval' k stdin files fuse_stdout_stderr ((Inl msg) :: stdout_stderr_r_acc)
      new_files
  | Write_stderr (msg, k) ->
    eval' k stdin files fuse_stdout_stderr ((Inr msg) :: stdout_stderr_r_acc)
      new_files
  | Read_file (name0, k) ->
    let contents =
      match find (fun pat -> let (fname, _) = pat in eqb0 fname name0)
              (app new_files files) with
      | Some p -> let (_, contents) = p in contents
      | None -> []
    in
    eval' (k contents) stdin files fuse_stdout_stderr stdout_stderr_r_acc
      new_files
  | Write_file (name0, contents, k) ->
    eval' k stdin files fuse_stdout_stderr stdout_stderr_r_acc ((name0,
      contents) :: new_files)

(** val eval_trace :
    trace -> char list list list -> (char list * char list list) list ->
    ((char list list, char list list) sum list -> 'a1) -> (char list list
    option * 'a1) * (char list * char list list) list **)

let eval_trace t0 stdin files fuse_stdout_stderr =
  eval' t0 stdin files fuse_stdout_stderr [] []

module type OCamlPrimitivesT =
 sig
  type coq_OCaml_string

  val string_length : coq_OCaml_string -> Int.t

  val string_get : coq_OCaml_string -> Int.t -> char

  val string_init : Int.t -> (Int.t -> char) -> coq_OCaml_string

  type 'x coq_OCaml_array

  val coq_Array_to_list : 'a1 coq_OCaml_array -> 'a1 list

  val coq_Array_of_list : 'a1 list -> 'a1 coq_OCaml_array
 end

module OCamlPrimitives =
 struct
  type coq_OCaml_string = string

  (** val string_length : coq_OCaml_string -> Int.t **)

  let string_length = String.length

  (** val string_get : coq_OCaml_string -> Int.t -> char **)

  let string_get = String.get

  (** val string_init : Int.t -> (Int.t -> char) -> coq_OCaml_string **)

  let string_init = String.init

  type 'a coq_OCaml_array = 'a array

  (** val coq_Array_to_list : 'a1 coq_OCaml_array -> 'a1 list **)

  let coq_Array_to_list = Array.to_list

  (** val coq_Array_of_list : 'a1 list -> 'a1 coq_OCaml_array **)

  let coq_Array_of_list = Array.of_list
 end

module type Js_of_ocamlPrimitivesT =
 sig
  type 'x coq_Js_t

  type js_string

  type 'x js_array

  val js_to_array :
    'a1 js_array coq_Js_t -> 'a1 OCamlPrimitives.coq_OCaml_array

  val js_to_string : js_string coq_Js_t -> OCamlPrimitives.coq_OCaml_string

  val js_of_array :
    'a1 OCamlPrimitives.coq_OCaml_array -> 'a1 js_array coq_Js_t

  val js_of_string : OCamlPrimitives.coq_OCaml_string -> js_string coq_Js_t

  val js_to_bool : bool coq_Js_t -> bool

  val js_of_bool : bool -> bool coq_Js_t

  type coq_Js_Unsafe_any

  val coq_Js_Unsafe_inject : 'a1 -> coq_Js_Unsafe_any

  val coq_Js_export : OCamlPrimitives.coq_OCaml_string -> 'a1 -> unit

  type 'x js_callback

  val js_wrap_callback : ('a1 -> 'a2) -> ('a1 -> 'a2) js_callback
 end

module Js_of_ocamlPrimitives =
 struct
  type 'a coq_Js_t = 'a Js_of_ocaml.Js.t

  type js_string = Js_of_ocaml.Js.js_string

  type 'a js_array = 'a Js_of_ocaml.Js.js_array

  (** val js_to_array :
      'a1 js_array coq_Js_t -> 'a1 OCamlPrimitives.coq_OCaml_array **)

  let js_to_array = Js_of_ocaml.Js.to_array

  (** val js_to_string :
      js_string coq_Js_t -> OCamlPrimitives.coq_OCaml_string **)

  let js_to_string = Js_of_ocaml.Js.to_string

  (** val js_of_array :
      'a1 OCamlPrimitives.coq_OCaml_array -> 'a1 js_array coq_Js_t **)

  let js_of_array = Js_of_ocaml.Js.array

  (** val js_of_string :
      OCamlPrimitives.coq_OCaml_string -> js_string coq_Js_t **)

  let js_of_string = Js_of_ocaml.Js.string

  (** val js_to_bool : bool coq_Js_t -> bool **)

  let js_to_bool = Js_of_ocaml.Js.to_bool

  (** val js_of_bool : bool -> bool coq_Js_t **)

  let js_of_bool = Js_of_ocaml.Js.bool

  type coq_Js_Unsafe_any = Js_of_ocaml.Js.Unsafe.any

  (** val coq_Js_Unsafe_inject : 'a1 -> coq_Js_Unsafe_any **)

  let coq_Js_Unsafe_inject = Js_of_ocaml.Js.Unsafe.inject

  (** val coq_Js_export : OCamlPrimitives.coq_OCaml_string -> 'a1 -> unit **)

  let coq_Js_export = Js_of_ocaml.Js.export

  type 'a js_callback = 'a Js_of_ocaml.Js.callback

  (** val js_wrap_callback : ('a1 -> 'a2) -> ('a1 -> 'a2) js_callback **)

  let js_wrap_callback = Js_of_ocaml.Js.wrap_callback
 end

(** val nat_of_int : Int.t -> nat **)

let rec nat_of_int x =
  (fun fO fS n -> if n=0 then fO () else fS (n-1))
    (fun _ -> O)
    (fun x' -> S (nat_of_int x'))
    x

(** val int_of_nat : nat -> Int.t **)

let rec int_of_nat = function
| O -> 0
| S x' -> (fun n -> n+1) (int_of_nat x')

(** val string_of_Coq_string :
    char list -> OCamlPrimitives.coq_OCaml_string **)

let string_of_Coq_string s0 =
  let s1 = list_ascii_of_string s0 in
  OCamlPrimitives.string_init (int_of_nat (length s1)) (fun n3 ->
    nth (nat_of_int n3) s1 '?')

(** val string_to_Coq_string :
    OCamlPrimitives.coq_OCaml_string -> char list **)

let string_to_Coq_string s0 =
  string_of_list_ascii
    (map (fun n3 -> OCamlPrimitives.string_get s0 (int_of_nat n3))
      (seq O (nat_of_int (OCamlPrimitives.string_length s0))))

(** val main_gen : (char list list -> trace) -> unit **)

let main_gen pipelineMain =
  let stdin = [] in
  let files = [] in
  let js_of_Coq_string = fun s0 ->
    Js_of_ocamlPrimitives.js_of_string (string_of_Coq_string s0)
  in
  let js_of_list_string = fun ls ->
    Js_of_ocamlPrimitives.js_of_array
      (OCamlPrimitives.coq_Array_of_list (map js_of_Coq_string ls))
  in
  let synthesize6 =
    Js_of_ocamlPrimitives.js_wrap_callback (fun argv ->
      let argv0 =
        map string_to_Coq_string
          (map Js_of_ocamlPrimitives.js_to_string
            (OCamlPrimitives.coq_Array_to_list
              (Js_of_ocamlPrimitives.js_to_array argv)))
      in
      let (p, new_files) =
        eval_trace (pipelineMain argv0) stdin files split_stdout_stderr
      in
      let (result, p0) = p in
      let (stdout, stderr) = p0 in
      Js_of_ocamlPrimitives.js_of_array
        (OCamlPrimitives.coq_Array_of_list
          ((Js_of_ocamlPrimitives.coq_Js_Unsafe_inject
             (Js_of_ocamlPrimitives.js_of_bool (is_None result))) :: (
          (Js_of_ocamlPrimitives.coq_Js_Unsafe_inject
            (js_of_list_string
              (match result with
               | Some msg -> msg
               | None -> []))) :: ((Js_of_ocamlPrimitives.coq_Js_Unsafe_inject
                                     (js_of_list_string stdout)) :: (
          (Js_of_ocamlPrimitives.coq_Js_Unsafe_inject
            (js_of_list_string stderr)) :: ((Js_of_ocamlPrimitives.coq_Js_Unsafe_inject
                                              (Js_of_ocamlPrimitives.js_of_array
                                                (OCamlPrimitives.coq_Array_of_list
                                                  (map (fun pat ->
                                                    let (name0, contents) =
                                                      pat
                                                    in
                                                    Js_of_ocamlPrimitives.js_of_array
                                                      (OCamlPrimitives.coq_Array_of_list
                                                        ((Js_of_ocamlPrimitives.coq_Js_Unsafe_inject
                                                           (js_of_Coq_string
                                                             name0)) :: (
                                                        (Js_of_ocamlPrimitives.coq_Js_Unsafe_inject
                                                          (js_of_list_string
                                                            contents)) :: []))))
                                                    new_files)))) :: [])))))))
  in
  let valid_synthesis_kinds =
    js_of_list_string (map fst ForExtraction.parse_SynthesisKind_list)
  in
  let () =
    Js_of_ocamlPrimitives.coq_Js_export
      (string_of_Coq_string
        ('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('z'::('e'::[])))))))))))
      synthesize6
  in
  let () =
    Js_of_ocamlPrimitives.coq_Js_export
      (string_of_Coq_string
        ('v'::('a'::('l'::('i'::('d'::('_'::('s'::('y'::('n'::('t'::('h'::('e'::('s'::('i'::('s'::('_'::('k'::('i'::('n'::('d'::('s'::[]))))))))))))))))))))))
      valid_synthesis_kinds
  in
  ()

module Coq_bopname =
 struct
  type bopname =
  | Coq_add
  | Coq_sub
  | Coq_mul
  | Coq_mulhuu
  | Coq_divu
  | Coq_remu
  | Coq_and
  | Coq_or
  | Coq_xor
  | Coq_sru
  | Coq_slu
  | Coq_srs
  | Coq_lts
  | Coq_ltu
  | Coq_eq
 end

module Coq_access_size =
 struct
  type access_size =
  | Coq_one
  | Coq_two
  | Coq_four
  | Coq_word
 end

module Coq_expr =
 struct
  type expr =
  | Coq_literal of z
  | Coq_var of char list
  | Coq_load of Coq_access_size.access_size * expr
  | Coq_inlinetable of Coq_access_size.access_size * char list * expr
  | Coq_op of Coq_bopname.bopname * expr * expr
  | Coq_ite of expr * expr * expr
 end

module Coq_cmd =
 struct
  type cmd =
  | Coq_skip
  | Coq_set of char list * Coq_expr.expr
  | Coq_unset of char list
  | Coq_store of Coq_access_size.access_size * Coq_expr.expr * Coq_expr.expr
  | Coq_stackalloc of char list * z * cmd
  | Coq_cond of Coq_expr.expr * cmd * cmd
  | Coq_seq of cmd * cmd
  | Coq_while of Coq_expr.expr * cmd
  | Coq_call of char list list * char list * Coq_expr.expr list
  | Coq_interact of char list list * char list * Coq_expr.expr list
 end

type func = (char list list * char list list) * Coq_cmd.cmd

module Coq0_expr =
 struct
  (** val vars : Coq_expr.expr -> char list list **)

  let rec vars = function
  | Coq_expr.Coq_literal _ -> []
  | Coq_expr.Coq_var x -> x :: []
  | Coq_expr.Coq_load (_, ea) -> vars ea
  | Coq_expr.Coq_inlinetable (_, _, index) -> vars index
  | Coq_expr.Coq_op (_, e1, e2) -> app (vars e1) (vars e2)
  | Coq_expr.Coq_ite (c0, e1, e2) -> app (vars c0) (app (vars e1) (vars e2))
 end

module Coq0_cmd =
 struct
  (** val vars : Coq_cmd.cmd -> char list list **)

  let rec vars = function
  | Coq_cmd.Coq_skip -> []
  | Coq_cmd.Coq_set (x, e) -> x :: (Coq0_expr.vars e)
  | Coq_cmd.Coq_unset x -> x :: []
  | Coq_cmd.Coq_store (_, ea, ev) ->
    app (Coq0_expr.vars ea) (Coq0_expr.vars ev)
  | Coq_cmd.Coq_stackalloc (x, _, body) -> x :: (vars body)
  | Coq_cmd.Coq_cond (eb, ct, cf) ->
    app (Coq0_expr.vars eb) (app (vars ct) (vars cf))
  | Coq_cmd.Coq_seq (c1, c2) -> app (vars c1) (vars c2)
  | Coq_cmd.Coq_while (e, c1) -> app (Coq0_expr.vars e) (vars c1)
  | Coq_cmd.Coq_call (binds, _, args0) ->
    app binds (flat_map Coq0_expr.vars args0)
  | Coq_cmd.Coq_interact (binds, _, args0) ->
    app binds (flat_map Coq0_expr.vars args0)
 end

(** val prelude : char list **)

let prelude =
  '#'::('i'::('n'::('c'::('l'::('u'::('d'::('e'::(' '::('<'::('s'::('t'::('d'::('i'::('n'::('t'::('.'::('h'::('>'::('\n'::('#'::('i'::('n'::('c'::('l'::('u'::('d'::('e'::(' '::('<'::('s'::('t'::('r'::('i'::('n'::('g'::('.'::('h'::('>'::('\n'::('#'::('i'::('n'::('c'::('l'::('u'::('d'::('e'::(' '::('<'::('a'::('s'::('s'::('e'::('r'::('t'::('.'::('h'::('>'::('\n'::('\n'::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('_'::('_'::('a'::('t'::('t'::('r'::('i'::('b'::('u'::('t'::('e'::('_'::('_'::('('::('('::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('o'::('r'::(')'::(')'::(' '::('v'::('o'::('i'::('d'::(' '::('_'::('b'::('r'::('2'::('_'::('p'::('r'::('e'::('c'::('o'::('n'::('d'::('i'::('t'::('i'::('o'::('n'::('s'::('('::('v'::('o'::('i'::('d'::(')'::(' '::('{'::('\n'::(' '::(' '::('s'::('t'::('a'::('t'::('i'::('c'::('_'::('a'::('s'::('s'::('e'::('r'::('t'::('('::('~'::('('::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('0'::(' '::('='::('='::(' '::('-'::('('::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('1'::(','::(' '::('"'::('t'::('w'::('o'::('\''::('s'::(' '::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('"'::(')'::(';'::('\n'::(' '::(' '::('a'::('s'::('s'::('e'::('r'::('t'::('('::('('::('('::('v'::('o'::('i'::('d'::(')'::('"'::('t'::('w'::('o'::('\''::('s'::(' '::('c'::('o'::('m'::('p'::('l'::('e'::('m'::('e'::('n'::('t'::('"'::(','::(' '::('~'::('('::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('0'::(' '::('='::('='::(' '::('-'::('('::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('1'::(')'::(')'::(';'::('\n'::(' '::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('u'::(' '::('='::(' '::('1'::(';'::('\n'::(' '::(' '::('a'::('s'::('s'::('e'::('r'::('t'::('('::('('::('('::('v'::('o'::('i'::('d'::(')'::('"'::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::('"'::(','::(' '::('1'::(' '::('='::('='::(' '::('*'::('('::('u'::('n'::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('c'::('h'::('a'::('r'::(' '::('*'::(')'::('&'::('u'::(')'::(')'::(';'::('\n'::(' '::(' '::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('i'::(' '::('='::(' '::('1'::(';'::('\n'::(' '::(' '::('a'::('s'::('s'::('e'::('r'::('t'::('('::('('::('('::('v'::('o'::('i'::('d'::(')'::('"'::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::('"'::(','::(' '::('1'::(' '::('='::('='::(' '::('*'::('('::('u'::('n'::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('c'::('h'::('a'::('r'::(' '::('*'::(')'::('&'::('i'::(')'::(')'::(';'::('\n'::('}'::('\n'::('\n'::('/'::('/'::(' '::('W'::('e'::(' '::('u'::('s'::('e'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::(' '::('t'::('o'::(' '::('w'::('o'::('r'::('k'::(' '::('a'::('r'::('o'::('u'::('n'::('d'::(' '::('-'::('f'::('s'::('t'::('r'::('i'::('c'::('t'::('-'::('a'::('l'::('i'::('a'::('s'::('i'::('n'::('g'::('.'::('\n'::('/'::('/'::(' '::('A'::(' '::('p'::('l'::('a'::('i'::('n'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::(' '::('i'::('s'::(' '::('e'::('n'::('o'::('u'::('g'::('h'::(' '::('o'::('n'::(' '::('c'::('l'::('a'::('n'::('g'::(' '::('1'::('0'::(','::(' '::('b'::('u'::('t'::(' '::('n'::('o'::('t'::(' '::('o'::('n'::(' '::('g'::('c'::('c'::(' '::('1'::('0'::(','::(' '::('w'::('h'::('i'::('c'::('h'::(' '::('f'::('a'::('i'::('l'::('s'::('\n'::('/'::('/'::(' '::('t'::('o'::(' '::('i'::('n'::('f'::('e'::('r'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('o'::('n'::(' '::('a'::('n'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('l'::('o'::('a'::('d'::('e'::('d'::(' '::('b'::('y'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::('.'::('\n'::('/'::('/'::(' '::('A'::('d'::('d'::('i'::('n'::('g'::(' '::('a'::(' '::('r'::('a'::('n'::('g'::('e'::(' '::('m'::('a'::('s'::('k'::(' '::('a'::('f'::('t'::('e'::('r'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::(' '::('i'::('n'::(' '::('t'::('u'::('r'::('n'::(' '::('m'::('a'::('k'::('e'::('s'::(' '::('s'::('l'::('o'::('w'::('e'::('r'::(' '::('c'::('o'::('d'::('e'::(' '::('i'::('n'::(' '::('c'::('l'::('a'::('n'::('g'::('.'::('\n'::('/'::('/'::(' '::('L'::('o'::('a'::('d'::('i'::('n'::('g'::(' '::('i'::('n'::('d'::('i'::('v'::('i'::('d'::('u'::('a'::('l'::(' '::('b'::('y'::('t'::('e'::('s'::(','::(' '::('s'::('h'::('i'::('f'::('t'::('i'::('n'::('g'::(' '::('t'::('h'::('e'::('m'::(' '::('t'::('o'::('g'::('e'::('t'::('h'::('e'::('r'::(','::(' '::('a'::('n'::('d'::(' '::('o'::('r'::('-'::('i'::('n'::('g'::(' '::('i'::('s'::(' '::('f'::('a'::('s'::('t'::('\n'::('/'::('/'::(' '::('o'::('n'::(' '::('c'::('l'::('a'::('n'::('g'::(' '::('a'::('n'::('d'::(' '::('s'::('o'::('m'::('e'::('t'::('i'::('m'::('e'::('s'::(' '::('o'::('n'::(' '::('G'::('C'::('C'::(','::(' '::('b'::('u'::('t'::(' '::('o'::('t'::('h'::('e'::('r'::(' '::('t'::('i'::('m'::('e'::('s'::(' '::('G'::('C'::('C'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::('s'::(' '::('i'::('n'::('d'::('i'::('v'::('i'::('d'::('u'::('a'::('l'::('\n'::('/'::('/'::(' '::('b'::('y'::('t'::('e'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('s'::(' '::('w'::('i'::('t'::('h'::('o'::('u'::('t'::(' '::('r'::('e'::('c'::('o'::('n'::('s'::('t'::('r'::('u'::('c'::('t'::('i'::('n'::('g'::(' '::('w'::('i'::('d'::('e'::('r'::(' '::('a'::('c'::('c'::('e'::('s'::('s'::('e'::('s'::('.'::('\n'::('/'::('/'::(' '::('T'::('h'::('e'::(' '::('l'::('i'::('t'::('t'::('l'::('e'::('-'::('e'::('n'::('d'::('i'::('a'::('n'::(' '::('i'::('d'::('i'::('o'::('m'::(' '::('b'::('e'::('l'::('o'::('w'::(' '::('s'::('e'::('e'::('m'::('s'::(' '::('f'::('a'::('s'::('t'::(' '::('i'::('n'::(' '::('g'::('c'::('c'::(' '::('9'::('+'::(' '::('a'::('n'::('d'::(' '::('c'::('l'::('a'::('n'::('g'::(' '::('1'::('0'::('.'::('\n'::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::(' '::(' '::('_'::('_'::('a'::('t'::('t'::('r'::('i'::('b'::('u'::('t'::('e'::('_'::('_'::('('::('('::('a'::('l'::('w'::('a'::('y'::('s'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::(','::(' '::('u'::('n'::('u'::('s'::('e'::('d'::(')'::(')'::('\n'::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('_'::('b'::('r'::('2'::('_'::('l'::('o'::('a'::('d'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('a'::(','::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('s'::('z'::(')'::(' '::('{'::('\n'::(' '::(' '::('s'::('w'::('i'::('t'::('c'::('h'::(' '::('('::('s'::('z'::(')'::(' '::('{'::('\n'::(' '::(' '::('c'::('a'::('s'::('e'::(' '::('1'::(':'::(' '::('{'::(' '::('u'::('i'::('n'::('t'::('8'::('_'::('t'::(' '::(' '::('r'::(' '::('='::(' '::('0'::(';'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::('('::('&'::('r'::(','::(' '::('('::('v'::('o'::('i'::('d'::('*'::(')'::('a'::(','::(' '::('1'::(')'::(';'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('r'::(';'::(' '::('}'::('\n'::(' '::(' '::('c'::('a'::('s'::('e'::(' '::('2'::(':'::(' '::('{'::(' '::('u'::('i'::('n'::('t'::('1'::('6'::('_'::('t'::(' '::('r'::(' '::('='::(' '::('0'::(';'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::('('::('&'::('r'::(','::(' '::('('::('v'::('o'::('i'::('d'::('*'::(')'::('a'::(','::(' '::('2'::(')'::(';'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('r'::(';'::(' '::('}'::('\n'::(' '::(' '::('c'::('a'::('s'::('e'::(' '::('4'::(':'::(' '::('{'::(' '::('u'::('i'::('n'::('t'::('3'::('2'::('_'::('t'::(' '::('r'::(' '::('='::(' '::('0'::(';'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::('('::('&'::('r'::(','::(' '::('('::('v'::('o'::('i'::('d'::('*'::(')'::('a'::(','::(' '::('4'::(')'::(';'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('r'::(';'::(' '::('}'::('\n'::(' '::(' '::('c'::('a'::('s'::('e'::(' '::('8'::(':'::(' '::('{'::(' '::('u'::('i'::('n'::('t'::('6'::('4'::('_'::('t'::(' '::('r'::(' '::('='::(' '::('0'::(';'::(' '::('m'::('e'::('m'::('c'::('p'::('y'::('('::('&'::('r'::(','::(' '::('('::('v'::('o'::('i'::('d'::('*'::(')'::('a'::(','::(' '::('8'::(')'::(';'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('r'::(';'::(' '::('}'::('\n'::(' '::(' '::('d'::('e'::('f'::('a'::('u'::('l'::('t'::(':'::(' '::('_'::('_'::('b'::('u'::('i'::('l'::('t'::('i'::('n'::('_'::('u'::('n'::('r'::('e'::('a'::('c'::('h'::('a'::('b'::('l'::('e'::('('::(')'::(';'::('\n'::(' '::(' '::('}'::('\n'::('}'::('\n'::('\n'::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::(' '::('_'::('_'::('a'::('t'::('t'::('r'::('i'::('b'::('u'::('t'::('e'::('_'::('_'::('('::('('::('a'::('l'::('w'::('a'::('y'::('s'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::(','::(' '::('u'::('n'::('u'::('s'::('e'::('d'::(')'::(')'::('\n'::('v'::('o'::('i'::('d'::(' '::('_'::('b'::('r'::('2'::('_'::('s'::('t'::('o'::('r'::('e'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('a'::(','::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('v'::(','::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('s'::('z'::(')'::(' '::('{'::('\n'::(' '::(' '::('m'::('e'::('m'::('c'::('p'::('y'::('('::('('::('v'::('o'::('i'::('d'::('*'::(')'::('a'::(','::(' '::('&'::('v'::(','::(' '::('s'::('z'::(')'::(';'::('\n'::('}'::('\n'::('\n'::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::(' '::('_'::('_'::('a'::('t'::('t'::('r'::('i'::('b'::('u'::('t'::('e'::('_'::('_'::('('::('('::('a'::('l'::('w'::('a'::('y'::('s'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::(','::(' '::('u'::('n'::('u'::('s'::('e'::('d'::(')'::(')'::('\n'::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('_'::('b'::('r'::('2'::('_'::('m'::('u'::('l'::('h'::('u'::('u'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('a'::(','::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('b'::(')'::(' '::('{'::('\n'::(' '::(' '::('#'::('i'::('f'::(' '::('('::('U'::('I'::('N'::('T'::('P'::('T'::('R'::('_'::('M'::('A'::('X'::(' '::('='::('='::(' '::('('::('U'::('I'::('N'::('T'::('M'::('A'::('X'::('_'::('C'::('('::('1'::(')'::('<'::('<'::('3'::('1'::(')'::(' '::('-'::(' '::('1'::(' '::('+'::(' '::('('::('U'::('I'::('N'::('T'::('M'::('A'::('X'::('_'::('C'::('('::('1'::(')'::('<'::('<'::('3'::('1'::(')'::(')'::('\n'::('\t'::(' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('('::('('::('u'::('i'::('n'::('t'::('6'::('4'::('_'::('t'::(')'::('a'::(' '::('*'::(' '::('b'::(')'::(' '::('>'::('>'::(' '::('3'::('2'::(';'::('\n'::(' '::(' '::('#'::('e'::('l'::('i'::('f'::(' '::('('::('U'::('I'::('N'::('T'::('P'::('T'::('R'::('_'::('M'::('A'::('X'::(' '::('='::('='::(' '::('('::('U'::('I'::('N'::('T'::('M'::('A'::('X'::('_'::('C'::('('::('1'::(')'::('<'::('<'::('6'::('3'::(')'::(' '::('-'::(' '::('1'::(' '::('+'::(' '::('('::('U'::('I'::('N'::('T'::('M'::('A'::('X'::('_'::('C'::('('::('1'::(')'::('<'::('<'::('6'::('3'::(')'::(')'::('\n'::(' '::(' '::(' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('('::('('::('u'::('n'::('s'::('i'::('g'::('n'::('e'::('d'::(' '::('_'::('_'::('i'::('n'::('t'::('1'::('2'::('8'::(')'::('a'::(' '::('*'::(' '::('b'::(')'::(' '::('>'::('>'::(' '::('6'::('4'::(';'::('\n'::(' '::(' '::('#'::('e'::('l'::('s'::('e'::('\n'::(' '::(' '::(' '::(' '::('#'::('e'::('r'::('r'::('o'::('r'::(' '::('"'::('3'::('2'::('-'::('b'::('i'::('t'::(' '::('o'::('r'::(' '::('6'::('4'::('-'::('b'::('i'::('t'::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('r'::('e'::('q'::('u'::('i'::('r'::('e'::('d'::('"'::('\n'::(' '::(' '::('#'::('e'::('n'::('d'::('i'::('f'::('\n'::('}'::('\n'::('\n'::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::(' '::('_'::('_'::('a'::('t'::('t'::('r'::('i'::('b'::('u'::('t'::('e'::('_'::('_'::('('::('('::('a'::('l'::('w'::('a'::('y'::('s'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::(','::(' '::('u'::('n'::('u'::('s'::('e'::('d'::(')'::(')'::('\n'::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('_'::('b'::('r'::('2'::('_'::('d'::('i'::('v'::('u'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('a'::(','::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('b'::(')'::(' '::('{'::('\n'::(' '::(' '::('i'::('f'::(' '::('('::('!'::('b'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('-'::('1'::(';'::('\n'::(' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('a'::('/'::('b'::(';'::('\n'::('}'::('\n'::('\n'::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::(' '::('_'::('_'::('a'::('t'::('t'::('r'::('i'::('b'::('u'::('t'::('e'::('_'::('_'::('('::('('::('a'::('l'::('w'::('a'::('y'::('s'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::(','::(' '::('u'::('n'::('u'::('s'::('e'::('d'::(')'::(')'::('\n'::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('_'::('b'::('r'::('2'::('_'::('r'::('e'::('m'::('u'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('a'::(','::(' '::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('b'::(')'::(' '::('{'::('\n'::(' '::(' '::('i'::('f'::(' '::('('::('!'::('b'::(')'::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('a'::(';'::('\n'::(' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('a'::('%'::('b'::(';'::('\n'::('}'::('\n'::('\n'::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('i'::('n'::('l'::('i'::('n'::('e'::(' '::('_'::('_'::('a'::('t'::('t'::('r'::('i'::('b'::('u'::('t'::('e'::('_'::('_'::('('::('('::('a'::('l'::('w'::('a'::('y'::('s'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::(','::(' '::('u'::('n'::('u'::('s'::('e'::('d'::(')'::(')'::('\n'::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('_'::('b'::('r'::('2'::('_'::('s'::('h'::('a'::('m'::('t'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::('a'::(')'::(' '::('{'::('\n'::(' '::(' '::('r'::('e'::('t'::('u'::('r'::('n'::(' '::('a'::('&'::('('::('s'::('i'::('z'::('e'::('o'::('f'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('*'::('8'::('-'::('1'::(')'::(';'::('\n'::('}'::('\n'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))

(** val lF0 : char list **)

let lF0 =
  '\n'::[]

(** val c_var : char list -> char list **)

let c_var =
  Obj.magic id

(** val c_fun : char list -> char list **)

let c_fun =
  Obj.magic id

(** val c_lit : z -> char list **)

let c_lit w =
  append
    ('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('('::('U'::('I'::('N'::('T'::('M'::('A'::('X'::('_'::('C'::('('::[]))))))))))))))))))))))
    (append (NilZero.string_of_int (Coq_Z.to_int w)) (')'::(')'::[])))

(** val c_byte_withoutcast : char -> char list **)

let c_byte_withoutcast b =
  NilZero.string_of_uint (N.to_uint (to_N0 b))

(** val c_bop : char list -> Coq_bopname.bopname -> char list -> char list **)

let c_bop e1 op1 e2 =
  match op1 with
  | Coq_bopname.Coq_add -> append e1 (append ('+'::[]) e2)
  | Coq_bopname.Coq_sub -> append e1 (append ('-'::[]) e2)
  | Coq_bopname.Coq_mul -> append e1 (append ('*'::[]) e2)
  | Coq_bopname.Coq_mulhuu ->
    append
      ('_'::('b'::('r'::('2'::('_'::('m'::('u'::('l'::('h'::('u'::('u'::('('::[]))))))))))))
      (append e1 (append (','::(' '::[])) (append e2 (')'::[]))))
  | Coq_bopname.Coq_divu ->
    append
      ('_'::('b'::('r'::('2'::('_'::('d'::('i'::('v'::('u'::('('::[]))))))))))
      (append e1 (append (','::(' '::[])) (append e2 (')'::[]))))
  | Coq_bopname.Coq_remu ->
    append
      ('_'::('b'::('r'::('2'::('_'::('r'::('e'::('m'::('u'::('('::[]))))))))))
      (append e1 (append (','::(' '::[])) (append e2 (')'::[]))))
  | Coq_bopname.Coq_and -> append e1 (append ('&'::[]) e2)
  | Coq_bopname.Coq_or -> append e1 (append ('|'::[]) e2)
  | Coq_bopname.Coq_xor -> append e1 (append ('^'::[]) e2)
  | Coq_bopname.Coq_sru ->
    append e1
      (append ('>'::('>'::[]))
        (append
          ('_'::('b'::('r'::('2'::('_'::('s'::('h'::('a'::('m'::('t'::[]))))))))))
          e2))
  | Coq_bopname.Coq_slu ->
    append e1
      (append ('<'::('<'::[]))
        (append
          ('_'::('b'::('r'::('2'::('_'::('s'::('h'::('a'::('m'::('t'::[]))))))))))
          e2))
  | Coq_bopname.Coq_srs ->
    append
      ('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('('::('('::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::[]))))))))))))))))))))))
      (append e1
        (append ('>'::('>'::[]))
          (append
            ('_'::('b'::('r'::('2'::('_'::('s'::('h'::('a'::('m'::('t'::[]))))))))))
            (append e2 (')'::[])))))
  | Coq_bopname.Coq_lts ->
    append
      ('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('('::('('::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::[]))))))))))))))))))))))
      (append e1
        (append ('<'::[])
          (append
            ('('::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::[]))))))))))
            (append e2 (')'::[])))))
  | Coq_bopname.Coq_ltu ->
    append
      ('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('('::[]))))))))))))
      (append e1 (append ('<'::[]) (append e2 (')'::[]))))
  | Coq_bopname.Coq_eq ->
    append
      ('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('('::[]))))))))))))
      (append e1 (append ('='::('='::[])) (append e2 (')'::[]))))

(** val c_size : Coq_access_size.access_size -> char list **)

let c_size = function
| Coq_access_size.Coq_one -> '1'::[]
| Coq_access_size.Coq_two -> '2'::[]
| Coq_access_size.Coq_four -> '4'::[]
| Coq_access_size.Coq_word ->
  's'::('i'::('z'::('e'::('o'::('f'::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::[]))))))))))))))))

(** val c_expr : Coq_expr.expr -> char list **)

let rec c_expr = function
| Coq_expr.Coq_literal v -> c_lit v
| Coq_expr.Coq_var x -> c_var x
| Coq_expr.Coq_load (s0, ea) ->
  append
    ('_'::('b'::('r'::('2'::('_'::('l'::('o'::('a'::('d'::('('::[]))))))))))
    (append (c_expr ea)
      (append (','::(' '::[])) (append (c_size s0) (')'::[]))))
| Coq_expr.Coq_inlinetable (s0, t0, index) ->
  append
    ('('::('{'::(' '::('s'::('t'::('a'::('t'::('i'::('c'::(' '::('c'::('o'::('n'::('s'::('t'::(' '::('u'::('i'::('n'::('t'::('8'::('_'::('t'::(' '::('_'::('i'::('n'::('l'::('i'::('n'::('e'::('t'::('a'::('b'::('l'::('e'::('['::[])))))))))))))))))))))))))))))))))))))
    (append (c_lit (Z.of_nat (length t0)))
      (append (']'::(' '::('='::(' '::('{'::[])))))
        (append (concat0 (','::(' '::[])) (map c_byte_withoutcast t0))
          (append
            ('}'::(';'::(' '::('_'::('b'::('r'::('2'::('_'::('l'::('o'::('a'::('d'::('('::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('&'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::('t'::('a'::('b'::('l'::('e'::('['::[]))))))))))))))))))))))))))))))))))))))
            (append (c_expr index)
              (append (']'::(','::(' '::[])))
                (append (c_size s0) (')'::(';'::(' '::('}'::(')'::[]))))))))))))
| Coq_expr.Coq_op (op1, e1, e2) ->
  c_bop (append ('('::[]) (append (c_expr e1) (')'::[]))) op1
    (append ('('::[]) (append (c_expr e2) (')'::[])))
| Coq_expr.Coq_ite (c0, e1, e2) ->
  (match e1 with
   | Coq_expr.Coq_literal v ->
     (match v with
      | Z0 ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Zpos p ->
        (match p with
         | XI _ ->
           append ('('::[])
             (append (c_expr c0)
               (append (')'::(' '::('?'::(' '::('('::[])))))
                 (append (c_expr e1)
                   (append (')'::(' '::(':'::(' '::('('::[])))))
                     (append (c_expr e2) (')'::[]))))))
         | XO _ ->
           append ('('::[])
             (append (c_expr c0)
               (append (')'::(' '::('?'::(' '::('('::[])))))
                 (append (c_expr e1)
                   (append (')'::(' '::(':'::(' '::('('::[])))))
                     (append (c_expr e2) (')'::[]))))))
         | XH ->
           (match e2 with
            | Coq_expr.Coq_literal _ ->
              append ('('::[])
                (append (c_expr c0)
                  (append (')'::(' '::('?'::(' '::('('::[])))))
                    (append (c_expr e1)
                      (append (')'::(' '::(':'::(' '::('('::[])))))
                        (append (c_expr e2) (')'::[]))))))
            | Coq_expr.Coq_var _ ->
              append ('('::[])
                (append (c_expr c0)
                  (append (')'::(' '::('?'::(' '::('('::[])))))
                    (append (c_expr e1)
                      (append (')'::(' '::(':'::(' '::('('::[])))))
                        (append (c_expr e2) (')'::[]))))))
            | Coq_expr.Coq_load (_, _) ->
              append ('('::[])
                (append (c_expr c0)
                  (append (')'::(' '::('?'::(' '::('('::[])))))
                    (append (c_expr e1)
                      (append (')'::(' '::(':'::(' '::('('::[])))))
                        (append (c_expr e2) (')'::[]))))))
            | Coq_expr.Coq_inlinetable (_, _, _) ->
              append ('('::[])
                (append (c_expr c0)
                  (append (')'::(' '::('?'::(' '::('('::[])))))
                    (append (c_expr e1)
                      (append (')'::(' '::(':'::(' '::('('::[])))))
                        (append (c_expr e2) (')'::[]))))))
            | Coq_expr.Coq_op (op1, e0, e3) ->
              (match op1 with
               | Coq_bopname.Coq_add ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_sub ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_mul ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_mulhuu ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_divu ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_remu ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_and ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_or ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_xor ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_sru ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_slu ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_srs ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_lts ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_bopname.Coq_ltu ->
                 (match e0 with
                  | Coq_expr.Coq_literal v0 ->
                    (match v0 with
                     | Z0 ->
                       append ('('::[])
                         (append (c_expr c0)
                           (append
                             (')'::(' '::('|'::('|'::(' '::('('::[]))))))
                             (append (c_expr e3) (')'::[]))))
                     | Zpos _ ->
                       append ('('::[])
                         (append (c_expr c0)
                           (append (')'::(' '::('?'::(' '::('('::[])))))
                             (append (c_expr e1)
                               (append (')'::(' '::(':'::(' '::('('::[])))))
                                 (append (c_expr e2) (')'::[]))))))
                     | Zneg _ ->
                       append ('('::[])
                         (append (c_expr c0)
                           (append (')'::(' '::('?'::(' '::('('::[])))))
                             (append (c_expr e1)
                               (append (')'::(' '::(':'::(' '::('('::[])))))
                                 (append (c_expr e2) (')'::[])))))))
                  | Coq_expr.Coq_var _ ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('?'::(' '::('('::[])))))
                          (append (c_expr e1)
                            (append (')'::(' '::(':'::(' '::('('::[])))))
                              (append (c_expr e2) (')'::[]))))))
                  | Coq_expr.Coq_load (_, _) ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('?'::(' '::('('::[])))))
                          (append (c_expr e1)
                            (append (')'::(' '::(':'::(' '::('('::[])))))
                              (append (c_expr e2) (')'::[]))))))
                  | Coq_expr.Coq_inlinetable (_, _, _) ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('?'::(' '::('('::[])))))
                          (append (c_expr e1)
                            (append (')'::(' '::(':'::(' '::('('::[])))))
                              (append (c_expr e2) (')'::[]))))))
                  | Coq_expr.Coq_op (_, _, _) ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('?'::(' '::('('::[])))))
                          (append (c_expr e1)
                            (append (')'::(' '::(':'::(' '::('('::[])))))
                              (append (c_expr e2) (')'::[]))))))
                  | Coq_expr.Coq_ite (_, _, _) ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('?'::(' '::('('::[])))))
                          (append (c_expr e1)
                            (append (')'::(' '::(':'::(' '::('('::[])))))
                              (append (c_expr e2) (')'::[])))))))
               | Coq_bopname.Coq_eq ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[])))))))
            | Coq_expr.Coq_ite (_, _, _) ->
              append ('('::[])
                (append (c_expr c0)
                  (append (')'::(' '::('?'::(' '::('('::[])))))
                    (append (c_expr e1)
                      (append (')'::(' '::(':'::(' '::('('::[])))))
                        (append (c_expr e2) (')'::[]))))))))
      | Zneg _ ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[])))))))
   | Coq_expr.Coq_var _ ->
     append ('('::[])
       (append (c_expr c0)
         (append (')'::(' '::('?'::(' '::('('::[])))))
           (append (c_expr e1)
             (append (')'::(' '::(':'::(' '::('('::[])))))
               (append (c_expr e2) (')'::[]))))))
   | Coq_expr.Coq_load (_, _) ->
     append ('('::[])
       (append (c_expr c0)
         (append (')'::(' '::('?'::(' '::('('::[])))))
           (append (c_expr e1)
             (append (')'::(' '::(':'::(' '::('('::[])))))
               (append (c_expr e2) (')'::[]))))))
   | Coq_expr.Coq_inlinetable (_, _, _) ->
     append ('('::[])
       (append (c_expr c0)
         (append (')'::(' '::('?'::(' '::('('::[])))))
           (append (c_expr e1)
             (append (')'::(' '::(':'::(' '::('('::[])))))
               (append (c_expr e2) (')'::[]))))))
   | Coq_expr.Coq_op (op1, e0, e3) ->
     (match op1 with
      | Coq_bopname.Coq_add ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_sub ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_mul ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_mulhuu ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_divu ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_remu ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_and ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_or ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_xor ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_sru ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_slu ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_srs ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_lts ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[]))))))
      | Coq_bopname.Coq_ltu ->
        (match e0 with
         | Coq_expr.Coq_literal v ->
           (match v with
            | Z0 ->
              (match e2 with
               | Coq_expr.Coq_literal v0 ->
                 (match v0 with
                  | Z0 ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('&'::('&'::(' '::('('::[]))))))
                          (append (c_expr e3) (')'::[]))))
                  | Zpos _ ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('?'::(' '::('('::[])))))
                          (append (c_expr e1)
                            (append (')'::(' '::(':'::(' '::('('::[])))))
                              (append (c_expr e2) (')'::[]))))))
                  | Zneg _ ->
                    append ('('::[])
                      (append (c_expr c0)
                        (append (')'::(' '::('?'::(' '::('('::[])))))
                          (append (c_expr e1)
                            (append (')'::(' '::(':'::(' '::('('::[])))))
                              (append (c_expr e2) (')'::[])))))))
               | Coq_expr.Coq_var _ ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_expr.Coq_load (_, _) ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_expr.Coq_inlinetable (_, _, _) ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_expr.Coq_op (_, _, _) ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[]))))))
               | Coq_expr.Coq_ite (_, _, _) ->
                 append ('('::[])
                   (append (c_expr c0)
                     (append (')'::(' '::('?'::(' '::('('::[])))))
                       (append (c_expr e1)
                         (append (')'::(' '::(':'::(' '::('('::[])))))
                           (append (c_expr e2) (')'::[])))))))
            | Zpos _ ->
              append ('('::[])
                (append (c_expr c0)
                  (append (')'::(' '::('?'::(' '::('('::[])))))
                    (append (c_expr e1)
                      (append (')'::(' '::(':'::(' '::('('::[])))))
                        (append (c_expr e2) (')'::[]))))))
            | Zneg _ ->
              append ('('::[])
                (append (c_expr c0)
                  (append (')'::(' '::('?'::(' '::('('::[])))))
                    (append (c_expr e1)
                      (append (')'::(' '::(':'::(' '::('('::[])))))
                        (append (c_expr e2) (')'::[])))))))
         | Coq_expr.Coq_var _ ->
           append ('('::[])
             (append (c_expr c0)
               (append (')'::(' '::('?'::(' '::('('::[])))))
                 (append (c_expr e1)
                   (append (')'::(' '::(':'::(' '::('('::[])))))
                     (append (c_expr e2) (')'::[]))))))
         | Coq_expr.Coq_load (_, _) ->
           append ('('::[])
             (append (c_expr c0)
               (append (')'::(' '::('?'::(' '::('('::[])))))
                 (append (c_expr e1)
                   (append (')'::(' '::(':'::(' '::('('::[])))))
                     (append (c_expr e2) (')'::[]))))))
         | Coq_expr.Coq_inlinetable (_, _, _) ->
           append ('('::[])
             (append (c_expr c0)
               (append (')'::(' '::('?'::(' '::('('::[])))))
                 (append (c_expr e1)
                   (append (')'::(' '::(':'::(' '::('('::[])))))
                     (append (c_expr e2) (')'::[]))))))
         | Coq_expr.Coq_op (_, _, _) ->
           append ('('::[])
             (append (c_expr c0)
               (append (')'::(' '::('?'::(' '::('('::[])))))
                 (append (c_expr e1)
                   (append (')'::(' '::(':'::(' '::('('::[])))))
                     (append (c_expr e2) (')'::[]))))))
         | Coq_expr.Coq_ite (_, _, _) ->
           append ('('::[])
             (append (c_expr c0)
               (append (')'::(' '::('?'::(' '::('('::[])))))
                 (append (c_expr e1)
                   (append (')'::(' '::(':'::(' '::('('::[])))))
                     (append (c_expr e2) (')'::[])))))))
      | Coq_bopname.Coq_eq ->
        append ('('::[])
          (append (c_expr c0)
            (append (')'::(' '::('?'::(' '::('('::[])))))
              (append (c_expr e1)
                (append (')'::(' '::(':'::(' '::('('::[])))))
                  (append (c_expr e2) (')'::[])))))))
   | Coq_expr.Coq_ite (_, _, _) ->
     append ('('::[])
       (append (c_expr c0)
         (append (')'::(' '::('?'::(' '::('('::[])))))
           (append (c_expr e1)
             (append (')'::(' '::(':'::(' '::('('::[])))))
               (append (c_expr e2) (')'::[])))))))

(** val list_uniq : ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list **)

let rec list_uniq eqb2 = function
| [] -> []
| a :: l' ->
  if existsb (eqb2 a) l' then list_uniq eqb2 l' else a :: (list_uniq eqb2 l')

(** val list_minus :
    ('a1 -> 'a1 -> bool) -> 'a1 list -> 'a1 list -> 'a1 list **)

let list_minus eqb2 x y =
  filter (fun x0 -> negb (existsb (eqb2 x0) y)) x

(** val c_call :
    char list list -> char list -> char list list -> char list **)

let c_call args0 f es =
  match args0 with
  | [] ->
    append f
      (append ('('::[])
        (append (concat0 (','::(' '::[])) es) (append (')'::(';'::[])) lF0)))
  | x :: _ ->
    append (last args0 x)
      (append (' '::('='::(' '::[])))
        (append f
          (append ('('::[])
            (append
              (concat0 (','::(' '::[]))
                (app es
                  (map (fun x0 -> append ('&'::[]) x0) (removelast args0))))
              (append (')'::(';'::[])) lF0)))))

(** val c_act : char list list -> char list -> char list list -> char list **)

let c_act =
  c_call

(** val c_cmd : char list -> Coq_cmd.cmd -> char list **)

let rec c_cmd indent0 = function
| Coq_cmd.Coq_skip ->
  append indent0
    (append ('/'::('*'::('s'::('k'::('i'::('p'::('*'::('/'::[])))))))) lF0)
| Coq_cmd.Coq_set (x, ev) ->
  append indent0
    (append (c_var x)
      (append (' '::('='::(' '::[])))
        (append (c_expr ev) (append (';'::[]) lF0))))
| Coq_cmd.Coq_unset x ->
  append indent0
    (append ('/'::('/'::(' '::('u'::('n'::('s'::('e'::('t'::(' '::[])))))))))
      (append (c_var x) lF0))
| Coq_cmd.Coq_store (s0, ea, ev) ->
  append indent0
    (append
      ('_'::('b'::('r'::('2'::('_'::('s'::('t'::('o'::('r'::('e'::('('::[])))))))))))
      (append (c_expr ea)
        (append (','::(' '::[]))
          (append (c_expr ev)
            (append (','::(' '::[]))
              (append (c_size s0) (append (')'::(';'::[])) lF0)))))))
| Coq_cmd.Coq_stackalloc (x, n3, body) ->
  let tmp =
    append
      ('_'::('b'::('r'::('2'::('_'::('s'::('t'::('a'::('c'::('k'::('a'::('l'::('l'::('o'::('c'::('_'::[]))))))))))))))))
      x
  in
  append indent0
    (append
      ('{'::(' '::('u'::('i'::('n'::('t'::('8'::('_'::('t'::(' '::[]))))))))))
      (append tmp
        (append ('['::[])
          (append (c_lit n3)
            (append
              (']'::(' '::('='::(' '::('{'::('0'::('}'::(';'::(' '::[])))))))))
              (append x
                (append
                  (' '::('='::(' '::('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::('&'::[])))))))))))))))
                  (append tmp
                    (append (';'::[])
                      (append lF0
                        (append (c_cmd indent0 body)
                          (append indent0 (append ('}'::[]) lF0)))))))))))))
| Coq_cmd.Coq_cond (eb, t0, f) ->
  append indent0
    (append ('i'::('f'::(' '::('('::[]))))
      (append (c_expr eb)
        (append (')'::(' '::('{'::[])))
          (append lF0
            (append (c_cmd (append (' '::(' '::[])) indent0) t0)
              (append indent0
                (append
                  ('}'::(' '::('e'::('l'::('s'::('e'::(' '::('{'::[]))))))))
                  (append lF0
                    (append (c_cmd (append (' '::(' '::[])) indent0) f)
                      (append indent0 (append ('}'::[]) lF0)))))))))))
| Coq_cmd.Coq_seq (c1, c2) -> append (c_cmd indent0 c1) (c_cmd indent0 c2)
| Coq_cmd.Coq_while (eb, c1) ->
  append indent0
    (append ('w'::('h'::('i'::('l'::('e'::(' '::('('::[])))))))
      (append (c_expr eb)
        (append (')'::(' '::('{'::[])))
          (append lF0
            (append (c_cmd (append (' '::(' '::[])) indent0) c1)
              (append indent0 (append ('}'::[]) lF0)))))))
| Coq_cmd.Coq_call (args0, f, es) ->
  append indent0 (c_call (map c_var args0) (c_fun f) (map c_expr es))
| Coq_cmd.Coq_interact (binds, action, es) ->
  append indent0 (c_act binds action (map c_expr es))

(** val rename_away_from : char list -> char list list -> char list **)

let rename_away_from x xs =
  let x' = append ('_'::[]) x in
  if existsb (eqb0 x') xs
  then append
         ('#'::('e'::('r'::('r'::('o'::('r'::(' '::('r'::('e'::('n'::('a'::('m'::('e'::('_'::('a'::('w'::('a'::('y'::('_'::('f'::('r'::('o'::('m'::(' '::('\''::[])))))))))))))))))))))))))
         (append x
           (append ('\''::(' '::('='::(' '::('\''::[])))))
             (append x' ('\''::[]))))
  else x'

(** val rename_outs :
    char list list -> char list list -> (char list * char list)
    list * char list list **)

let rec rename_outs outs used =
  match outs with
  | [] -> ([], used)
  | o :: outs' ->
    let rec0 = rename_outs outs' used in
    let (outrenames, used0) = ((fst rec0), (snd rec0)) in
    let optr = rename_away_from o used0 in
    (((o, optr) :: outrenames), (o :: used0))

(** val fmt_c_decl :
    char list -> char list list -> char list -> char list list -> char list **)

let fmt_c_decl rett args0 name0 retptrs =
  let argstring =
    match args0 with
    | [] ->
      (match retptrs with
       | [] -> 'v'::('o'::('i'::('d'::[])))
       | _ :: _ ->
         concat0 (','::(' '::[]))
           (app
             (map (fun a ->
               append
                 ('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::[]))))))))))
                 (c_var a)) args0)
             (map (fun r0 ->
               append
                 ('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::('*'::(' '::[])))))))))))
                 (c_var r0)) retptrs)))
    | _ :: _ ->
      concat0 (','::(' '::[]))
        (app
          (map (fun a ->
            append
              ('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::[]))))))))))
              (c_var a)) args0)
          (map (fun r0 ->
            append
              ('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::('*'::(' '::[])))))))))))
              (c_var r0)) retptrs))
  in
  append rett
    (append (' '::[])
      (append (c_fun name0) (append ('('::[]) (append argstring (')'::[])))))

(** val c_func :
    (char list * ((char list list * char list list) * Coq_cmd.cmd)) ->
    char list **)

let c_func = function
| (name0, y) ->
  let (y0, body) = y in
  let (args0, rets) = y0 in
  let decl_retvar_retrenames =
    match rets with
    | [] ->
      (((fmt_c_decl ('v'::('o'::('i'::('d'::[])))) args0 name0 []), None), [])
    | r0 :: _ ->
      let r1 = last rets r0 in
      let rets' = removelast rets in
      let retrenames = fst (rename_outs rets' (Coq0_cmd.vars body)) in
      (((fmt_c_decl
          ('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::[])))))))))
          args0 name0 (map snd retrenames)), (Some r1)), retrenames)
  in
  let decl = fst (fst decl_retvar_retrenames) in
  let retvar = snd (fst decl_retvar_retrenames) in
  let retrenames = snd decl_retvar_retrenames in
  let localvars =
    list_uniq eqb0
      (let allvars =
         app (match retvar with
              | Some v -> v :: []
              | None -> []) (Coq0_cmd.vars body)
       in
       list_minus eqb0 allvars args0)
  in
  append decl
    (append (' '::('{'::[]))
      (append lF0
        (let indent0 = ' '::(' '::[]) in
         append
           (match localvars with
            | [] -> []
            | _ :: _ ->
              append indent0
                (append
                  ('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(' '::[]))))))))))
                  (append (concat0 (','::(' '::[])) (map c_var localvars))
                    (append (';'::[]) lF0))))
           (append (c_cmd indent0 body)
             (append
               (concat0 []
                 (map (fun pat0 ->
                   let (o, optr) = pat0 in
                   append indent0
                     (append ('*'::[])
                       (append (c_var optr)
                         (append (' '::('='::(' '::[])))
                           (append (c_var o) (append (';'::[]) lF0))))))
                   retrenames))
               (append indent0
                 (append ('r'::('e'::('t'::('u'::('r'::('n'::[]))))))
                   (append
                     (match retvar with
                      | Some rv -> append (' '::[]) (c_var rv)
                      | None -> [])
                     (append (';'::[]) (append lF0 (append ('}'::[]) lF0)))))))))))

module Coq_word =
 struct
  type word = { unsigned : (__ -> z); signed : (__ -> z); of_Z : (z -> __);
                add : (__ -> __ -> __); sub : (__ -> __ -> __);
                opp : (__ -> __); coq_or : (__ -> __ -> __);
                coq_and : (__ -> __ -> __); xor : (__ -> __ -> __);
                not : (__ -> __); ndn : (__ -> __ -> __);
                mul : (__ -> __ -> __); mulhss : (__ -> __ -> __);
                mulhsu : (__ -> __ -> __); mulhuu : (__ -> __ -> __);
                divu : (__ -> __ -> __); divs : (__ -> __ -> __);
                modu : (__ -> __ -> __); mods : (__ -> __ -> __);
                slu : (__ -> __ -> __); sru : (__ -> __ -> __);
                srs : (__ -> __ -> __); eqb : (__ -> __ -> bool);
                ltu : (__ -> __ -> bool); lts : (__ -> __ -> bool);
                sextend : (z -> __ -> __) }

  type rep = __

  (** val ltu : z -> word -> rep -> rep -> bool **)

  let ltu _ word1 =
    word1.ltu
 end

type rep0 = z
  (* singleton inductive, whose constructor was mk *)

(** val unsigned0 : z -> rep0 -> z **)

let unsigned0 _ r0 =
  r0

(** val wrap : z -> z -> rep0 **)

let wrap width z0 =
  Coq_Z.modulo z0 (Coq_Z.pow (Zpos (XO XH)) width)

(** val signed0 : z -> rep0 -> z **)

let signed0 width =
  let wrap_value = fun z0 -> Coq_Z.modulo z0 (Coq_Z.pow (Zpos (XO XH)) width)
  in
  let swrap_value = fun z0 ->
    Coq_Z.sub
      (wrap_value
        (Coq_Z.add z0 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub width (Zpos XH)))))
      (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub width (Zpos XH)))
  in
  (fun w -> swrap_value (unsigned0 width w))

type special_cases = { div_by_zero : (z -> z); mod_by_zero : (z -> z);
                       adjust_too_big_shift_amount : (z -> z) }

(** val gen_word : z -> special_cases -> Coq_word.word **)

let gen_word width sp =
  let adjust_shift_amount = fun n3 ->
    if Coq_Z.ltb n3 width then n3 else sp.adjust_too_big_shift_amount n3
  in
  { Coq_word.unsigned = (Obj.magic unsigned0 width); Coq_word.signed =
  (Obj.magic signed0 width); Coq_word.of_Z = (Obj.magic wrap width);
  Coq_word.add = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.add (unsigned0 width (Obj.magic x))
      (unsigned0 width (Obj.magic y)))); Coq_word.sub = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.sub (unsigned0 width (Obj.magic x))
      (unsigned0 width (Obj.magic y)))); Coq_word.opp = (fun x ->
  Obj.magic wrap width (Coq_Z.opp (unsigned0 width (Obj.magic x))));
  Coq_word.coq_or = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.coq_lor (unsigned0 width (Obj.magic x))
      (unsigned0 width (Obj.magic y)))); Coq_word.coq_and = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.coq_land (unsigned0 width (Obj.magic x))
      (unsigned0 width (Obj.magic y)))); Coq_word.xor = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.coq_lxor (unsigned0 width (Obj.magic x))
      (unsigned0 width (Obj.magic y)))); Coq_word.not = (fun x ->
  Obj.magic wrap width (Coq_Z.lnot (unsigned0 width (Obj.magic x))));
  Coq_word.ndn = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.ldiff (unsigned0 width (Obj.magic x))
      (unsigned0 width (Obj.magic y)))); Coq_word.mul = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.mul (unsigned0 width (Obj.magic x))
      (unsigned0 width (Obj.magic y)))); Coq_word.mulhss = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.div
      (Coq_Z.mul (signed0 width (Obj.magic x)) (signed0 width (Obj.magic y)))
      (Coq_Z.pow (Zpos (XO XH)) width))); Coq_word.mulhsu = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.div
      (Coq_Z.mul (signed0 width (Obj.magic x))
        (unsigned0 width (Obj.magic y))) (Coq_Z.pow (Zpos (XO XH)) width)));
  Coq_word.mulhuu = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.div
      (Coq_Z.mul (unsigned0 width (Obj.magic x))
        (unsigned0 width (Obj.magic y))) (Coq_Z.pow (Zpos (XO XH)) width)));
  Coq_word.divu = (fun x y ->
  Obj.magic wrap width
    (if Coq_Z.eqb (unsigned0 width (Obj.magic y)) Z0
     then sp.div_by_zero (unsigned0 width (Obj.magic x))
     else Coq_Z.div (unsigned0 width (Obj.magic x))
            (unsigned0 width (Obj.magic y)))); Coq_word.divs = (fun x y ->
  Obj.magic wrap width
    (if Coq_Z.eqb (signed0 width (Obj.magic y)) Z0
     then sp.div_by_zero (signed0 width (Obj.magic x))
     else Coq_Z.quot (signed0 width (Obj.magic x))
            (signed0 width (Obj.magic y)))); Coq_word.modu = (fun x y ->
  Obj.magic wrap width
    (if Coq_Z.eqb (unsigned0 width (Obj.magic y)) Z0
     then sp.mod_by_zero (unsigned0 width (Obj.magic x))
     else Coq_Z.modulo (unsigned0 width (Obj.magic x))
            (unsigned0 width (Obj.magic y)))); Coq_word.mods = (fun x y ->
  Obj.magic wrap width
    (if Coq_Z.eqb (signed0 width (Obj.magic y)) Z0
     then sp.mod_by_zero (signed0 width (Obj.magic x))
     else Coq_Z.rem (signed0 width (Obj.magic x))
            (signed0 width (Obj.magic y)))); Coq_word.slu = (fun x y ->
  Obj.magic wrap width
    (Coq_Z.shiftl (unsigned0 width (Obj.magic x))
      (adjust_shift_amount (unsigned0 width (Obj.magic y))))); Coq_word.sru =
  (fun x y ->
  Obj.magic wrap width
    (Coq_Z.shiftr (unsigned0 width (Obj.magic x))
      (adjust_shift_amount (unsigned0 width (Obj.magic y))))); Coq_word.srs =
  (fun x y ->
  Obj.magic wrap width
    (Coq_Z.shiftr (signed0 width (Obj.magic x))
      (adjust_shift_amount (unsigned0 width (Obj.magic y))))); Coq_word.eqb =
  (fun x y ->
  Coq_Z.eqb (unsigned0 width (Obj.magic x)) (unsigned0 width (Obj.magic y)));
  Coq_word.ltu = (fun x y ->
  Coq_Z.ltb (unsigned0 width (Obj.magic x)) (unsigned0 width (Obj.magic y)));
  Coq_word.lts = (fun x y ->
  Coq_Z.ltb (signed0 width (Obj.magic x)) (signed0 width (Obj.magic y)));
  Coq_word.sextend = (fun oldwidth z0 ->
  Obj.magic wrap width
    (Coq_Z.sub
      (Coq_Z.modulo
        (Coq_Z.add (unsigned0 width (Obj.magic z0))
          (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub oldwidth (Zpos XH))))
        (Coq_Z.pow (Zpos (XO XH)) oldwidth))
      (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.sub oldwidth (Zpos XH))))) }

(** val default_special_case_handlers : z -> special_cases **)

let default_special_case_handlers width =
  { div_by_zero = (fun _ -> Zneg XH); mod_by_zero = (fun x -> x);
    adjust_too_big_shift_amount = (fun n3 ->
    Coq_Z.modulo n3 (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 width))) }

(** val word0 : z -> Coq_word.word **)

let word0 width =
  gen_word width (default_special_case_handlers width)

module Coq_map =
 struct
  type ('key, 'value) map = { get : (__ -> 'key -> 'value option);
                              empty : __; put : (__ -> 'key -> 'value -> __);
                              remove : (__ -> 'key -> __);
                              fold : (__ -> (__ -> 'key -> 'value -> __) ->
                                     __ -> __ -> __) }
 end

module Coq_parameters =
 struct
  type parameters =
    __ -> __ -> bool
    (* singleton inductive, whose constructor was Build_parameters *)

  type key = __

  type value = __

  (** val ltb : parameters -> key -> key -> bool **)

  let ltb parameters1 =
    parameters1
 end

(** val eqb1 :
    Coq_parameters.parameters -> Coq_parameters.key -> Coq_parameters.key ->
    bool **)

let eqb1 p k1 k2 =
  (&&) (negb (Coq_parameters.ltb p k1 k2)) (negb (Coq_parameters.ltb p k2 k1))

(** val put0 :
    Coq_parameters.parameters -> (Coq_parameters.key * Coq_parameters.value)
    list -> Coq_parameters.key -> Coq_parameters.value ->
    (Coq_parameters.key * Coq_parameters.value) list **)

let put0 p =
  let rec put1 m4 k v =
    match m4 with
    | [] -> (k, v) :: []
    | y :: m'0 ->
      let (k', v') = y in
      if Coq_parameters.ltb p k k'
      then (k, v) :: m4
      else if Coq_parameters.ltb p k' k
           then (k', v') :: (put1 m'0 k v)
           else (k, v) :: m'0
  in put1

(** val remove1 :
    Coq_parameters.parameters -> (Coq_parameters.key * Coq_parameters.value)
    list -> Coq_parameters.key -> (Coq_parameters.key * Coq_parameters.value)
    list **)

let remove1 p =
  let rec remove2 m4 k =
    match m4 with
    | [] -> []
    | y :: m'0 ->
      let (k', v') = y in
      if Coq_parameters.ltb p k k'
      then m4
      else if Coq_parameters.ltb p k' k
           then (k', v') :: (remove2 m'0 k)
           else m'0
  in remove2

type rep1 =
  (Coq_parameters.key * Coq_parameters.value) list
  (* singleton inductive, whose constructor was Build_rep *)

(** val value0 :
    Coq_parameters.parameters -> rep1 ->
    (Coq_parameters.key * Coq_parameters.value) list **)

let value0 _ r0 =
  r0

(** val lookup0 :
    Coq_parameters.parameters -> (Coq_parameters.key * Coq_parameters.value)
    list -> Coq_parameters.key -> Coq_parameters.value option **)

let lookup0 p l k =
  match find (fun p0 -> eqb1 p k (fst p0)) l with
  | Some p0 -> let (_, v) = p0 in Some v
  | None -> None

(** val map4 :
    Coq_parameters.parameters -> (Coq_parameters.key, Coq_parameters.value)
    Coq_map.map **)

let map4 p =
  let wrapped_put = fun m4 k v -> put0 p (value0 p m4) k v in
  let wrapped_remove = fun m4 k -> remove1 p (value0 p m4) k in
  { Coq_map.get = (fun m4 k -> lookup0 p (value0 p (Obj.magic m4)) k);
  Coq_map.empty = (Obj.magic []); Coq_map.put = (Obj.magic wrapped_put);
  Coq_map.remove = (Obj.magic wrapped_remove); Coq_map.fold =
  (fun _ f r0 m4 ->
  fold_right (fun pat -> let (k, v) = pat in (fun r1 -> f r1 k v)) r0
    (value0 p (Obj.magic m4))) }

(** val sortedList_parameters :
    z -> Coq_word.word -> Coq_parameters.parameters **)

let sortedList_parameters _ word1 =
  word1.Coq_word.ltu

(** val map5 : z -> Coq_word.word -> (Coq_word.rep, 'a1) Coq_map.map **)

let map5 width word1 =
  Obj.magic map4 (sortedList_parameters width word1)

module Coq_Ascii =
 struct
  (** val ltb : char -> char -> bool **)

  let ltb c0 d =
    N.ltb (n_of_ascii c0) (n_of_ascii d)
 end

(** val ltb0 : char list -> char list -> bool **)

let rec ltb0 a b =
  match a with
  | [] -> (match b with
           | [] -> false
           | _::_ -> true)
  | x::a' ->
    (match b with
     | [] -> false
     | y::b' -> if (=) x y then ltb0 a' b' else Coq_Ascii.ltb x y)

(** val build_parameters : Coq_parameters.parameters **)

let build_parameters =
  Obj.magic ltb0

(** val bytes_per_word : z -> z **)

let bytes_per_word width =
  Coq_Z.div (Coq_Z.add width (Zpos (XI (XI XH)))) (Zpos (XO (XO (XO XH))))

(** val bytes_per : z -> Coq_access_size.access_size -> nat **)

let bytes_per width = function
| Coq_access_size.Coq_one -> S O
| Coq_access_size.Coq_two -> S (S O)
| Coq_access_size.Coq_four -> S (S (S (S O)))
| Coq_access_size.Coq_word -> Z.to_nat (bytes_per_word width)

type parameters0 = unit

module Coq_rep =
 struct
  type rep = { rtype_of_ltype : (__ -> __); dummy_ltype : __;
               make_error : __; dummy_size : __ }

  type ltype = __

  type rtype = __

  type size = __

  (** val rtype_of_ltype :
      z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
      Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
      parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      -> rep -> ltype -> rtype **)

  let rtype_of_ltype _ _ _ _ _ _ _ _ rep2 =
    rep2.rtype_of_ltype

  (** val dummy_ltype :
      z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
      Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
      parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      -> rep -> ltype **)

  let dummy_ltype _ _ _ _ _ _ _ _ rep2 =
    rep2.dummy_ltype

  (** val make_error :
      z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
      Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
      parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      -> rep -> rtype **)

  let make_error _ _ _ _ _ _ _ _ rep2 =
    rep2.make_error

  (** val dummy_size :
      z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
      Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
      parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
      -> rep -> size **)

  let dummy_size _ _ _ _ _ _ _ _ rep2 =
    rep2.dummy_size

  (** val listZ_local :
      z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
      Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
      parameters0 -> rep -> rep **)

  let listZ_local _ _ _ _ _ _ _ zrep =
    { rtype_of_ltype = (Obj.magic map zrep.rtype_of_ltype); dummy_ltype =
      (Obj.magic []); make_error = (Obj.magic (zrep.make_error :: []));
      dummy_size = zrep.dummy_size }

  (** val coq_Z :
      z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
      Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
      parameters0 -> rep **)

  let coq_Z _ _ _ _ varname_gen error0 _ =
    { rtype_of_ltype = (Obj.magic (fun x -> Coq_expr.Coq_var x));
      dummy_ltype = (Obj.magic varname_gen O); make_error =
      (Obj.magic error0); dummy_size = (Obj.magic ()) }
 end

type base_ltype = __

type ltype0 = __

type base_rtype = __

type rtype0 = __

(** val base_make_error :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type -> base_rtype **)

let base_make_error width word1 mem0 locals varname_gen error0 parameters_sentinel listZ =
  let rec base_make_error0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
      parameters_sentinel).Coq_rep.make_error
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    Obj.magic ((base_make_error0 a), (base_make_error0 b))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> listZ.Coq_rep.make_error
        | Coq3_Compilers.Coq_bool ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.make_error
        | Coq3_Compilers.Coq_nat ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.make_error
        | Coq3_Compilers.Coq_zrange ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.make_error
        | Coq3_Compilers.Coq_string ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.make_error)
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.make_error
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.make_error
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.make_error
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.make_error)
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
      parameters_sentinel).Coq_rep.make_error
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
      parameters_sentinel).Coq_rep.make_error
  in base_make_error0

(** val make_error0 :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> rtype0 **)

let make_error0 width word1 mem0 locals varname_gen error0 parameters_sentinel listZ =
  let rec make_error1 = function
  | Compilers.Coq_type.Coq_base a ->
    base_make_error width word1 mem0 locals varname_gen error0
      parameters_sentinel listZ a
  | Compilers.Coq_type.Coq_arrow (_, b) -> Obj.magic (fun _ -> make_error1 b)
  in make_error1

(** val dummy_base_ltype :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type -> base_ltype **)

let dummy_base_ltype width word1 mem0 locals varname_gen error0 parameters_sentinel listZ =
  let rec dummy_base_ltype0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
      parameters_sentinel).Coq_rep.dummy_ltype
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    Obj.magic ((dummy_base_ltype0 a), (dummy_base_ltype0 b))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> listZ.Coq_rep.dummy_ltype
        | Coq3_Compilers.Coq_bool ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.dummy_ltype
        | Coq3_Compilers.Coq_nat ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.dummy_ltype
        | Coq3_Compilers.Coq_zrange ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.dummy_ltype
        | Coq3_Compilers.Coq_string ->
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel).Coq_rep.dummy_ltype)
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.dummy_ltype
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.dummy_ltype
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.dummy_ltype
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
         parameters_sentinel).Coq_rep.dummy_ltype)
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
      parameters_sentinel).Coq_rep.dummy_ltype
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
      parameters_sentinel).Coq_rep.dummy_ltype
  in dummy_base_ltype0

(** val dummy_ltype0 :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type -> ltype0 **)

let dummy_ltype0 width word1 mem0 locals varname_gen error0 parameters_sentinel listZ = function
| Compilers.Coq_type.Coq_base a ->
  dummy_base_ltype width word1 mem0 locals varname_gen error0
    parameters_sentinel listZ a
| Compilers.Coq_type.Coq_arrow (_, _) -> Obj.magic ()

(** val base_rtype_of_ltype :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type -> base_ltype -> base_rtype **)

let base_rtype_of_ltype _ _ _ _ _ _ _ listZ =
  let rec base_rtype_of_ltype0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    Obj.magic (fun x -> Coq_expr.Coq_var x)
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun x ->
      Obj.magic ((base_rtype_of_ltype0 a (fst (Obj.magic x))),
        (base_rtype_of_ltype0 b (snd (Obj.magic x)))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> listZ.Coq_rep.rtype_of_ltype
        | Coq3_Compilers.Coq_bool -> Obj.magic (fun x -> Coq_expr.Coq_var x)
        | Coq3_Compilers.Coq_nat -> Obj.magic (fun x -> Coq_expr.Coq_var x)
        | Coq3_Compilers.Coq_zrange -> Obj.magic (fun x -> Coq_expr.Coq_var x)
        | Coq3_Compilers.Coq_string -> Obj.magic (fun x -> Coq_expr.Coq_var x))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       Obj.magic (fun x -> Coq_expr.Coq_var x)
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       Obj.magic (fun x -> Coq_expr.Coq_var x)
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       Obj.magic (fun x -> Coq_expr.Coq_var x)
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       Obj.magic (fun x -> Coq_expr.Coq_var x))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    Obj.magic (fun x -> Coq_expr.Coq_var x)
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    Obj.magic (fun x -> Coq_expr.Coq_var x)
  in base_rtype_of_ltype0

(** val rtype_of_ltype0 :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq_rep.rep -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    ltype0 -> rtype0 **)

let rtype_of_ltype0 width word1 mem0 locals varname_gen error0 parameters_sentinel listZ =
  let rec rtype_of_ltype1 = function
  | Compilers.Coq_type.Coq_base b ->
    base_rtype_of_ltype width word1 mem0 locals varname_gen error0
      parameters_sentinel listZ b
  | Compilers.Coq_type.Coq_arrow (_, b) ->
    (fun _ ->
      Obj.magic (fun _ ->
        rtype_of_ltype1 b
          (dummy_ltype0 width word1 mem0 locals varname_gen error0
            parameters_sentinel listZ b)))
  in rtype_of_ltype1

type base_access_sizes = __

type access_sizes = __

type 'f baseonly = __

type 't base_listonly = __

type 'f base_listexcl = __

type 't listonly = 't base_listonly baseonly

type list_lengths = nat listonly

type listonly_base_ltype = base_ltype base_listonly

type listexcl_base_ltype = base_ltype base_listexcl

(** val flatten_base_ltype :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> base_ltype -> char list list **)

let flatten_base_ltype _ _ _ _ _ _ _ =
  let rec flatten_base_ltype0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    (fun x -> (Obj.magic x) :: [])
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun x ->
      app (flatten_base_ltype0 a (fst (Obj.magic x)))
        (flatten_base_ltype0 b (snd (Obj.magic x))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_bool -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_nat -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_zrange -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_string -> (fun x -> (Obj.magic x) :: []))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun x -> (Obj.magic x) :: [])
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun x -> (Obj.magic x) :: [])
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun x -> (Obj.magic x) :: [])
     | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> (Obj.magic x) :: []))
  | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun x -> (Obj.magic x) :: [])
  | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> (Obj.magic x) :: [])
  in flatten_base_ltype0

(** val flatten_argnames :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow -> char list list **)

let flatten_argnames width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec flatten_argnames0 = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ -> [])
  | Compilers.Coq_type.Coq_arrow (s0, b) ->
    (match s0 with
     | Compilers.Coq_type.Coq_base a ->
       (fun x ->
         app
           (flatten_base_ltype width word1 mem0 locals varname_gen error0
             parameters_sentinel a (fst (Obj.magic x)))
           (flatten_argnames0 b (snd (Obj.magic x))))
     | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> []))
  in flatten_argnames0

(** val flatten_listonly_base_ltype :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> listonly_base_ltype -> char list list **)

let flatten_listonly_base_ltype _ _ _ _ _ _ _ =
  let rec flatten_listonly_base_ltype0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ -> (fun _ -> [])
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun x ->
      app (flatten_listonly_base_ltype0 a (fst (Obj.magic x)))
        (flatten_listonly_base_ltype0 b (snd (Obj.magic x))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_bool -> (fun _ -> [])
        | Coq3_Compilers.Coq_nat -> (fun _ -> [])
        | Coq3_Compilers.Coq_zrange -> (fun _ -> [])
        | Coq3_Compilers.Coq_string -> (fun _ -> []))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> [])
     | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> [])
     | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> [])
     | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> []))
  | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> [])
  | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> [])
  in flatten_listonly_base_ltype0

(** val flatten_listexcl_base_ltype :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> listexcl_base_ltype -> char list list **)

let flatten_listexcl_base_ltype _ _ _ _ _ _ _ =
  let rec flatten_listexcl_base_ltype0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    (fun x -> (Obj.magic x) :: [])
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun x ->
      app (flatten_listexcl_base_ltype0 a (fst (Obj.magic x)))
        (flatten_listexcl_base_ltype0 b (snd (Obj.magic x))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> (fun _ -> [])
        | Coq3_Compilers.Coq_bool -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_nat -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_zrange -> (fun x -> (Obj.magic x) :: [])
        | Coq3_Compilers.Coq_string -> (fun x -> (Obj.magic x) :: []))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun x -> (Obj.magic x) :: [])
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun x -> (Obj.magic x) :: [])
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun x -> (Obj.magic x) :: [])
     | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> (Obj.magic x) :: []))
  | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun x -> (Obj.magic x) :: [])
  | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> (Obj.magic x) :: [])
  in flatten_listexcl_base_ltype0

(** val extract_listnames :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> base_ltype -> listonly_base_ltype * listexcl_base_ltype **)

let extract_listnames _ _ _ _ _ _ _ =
  let rec extract_listnames0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    (fun x -> ((Obj.magic ()), x))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun x ->
      let p1 = extract_listnames0 a (fst (Obj.magic x)) in
      let p2 = extract_listnames0 b (snd (Obj.magic x)) in
      ((Obj.magic ((fst p1), (fst p2))), (Obj.magic ((snd p1), (snd p2)))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> (fun x -> (x, (Obj.magic ())))
        | Coq3_Compilers.Coq_bool -> (fun x -> ((Obj.magic ()), x))
        | Coq3_Compilers.Coq_nat -> (fun x -> ((Obj.magic ()), x))
        | Coq3_Compilers.Coq_zrange -> (fun x -> ((Obj.magic ()), x))
        | Coq3_Compilers.Coq_string -> (fun x -> ((Obj.magic ()), x)))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun x -> ((Obj.magic ()), x))
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun x -> ((Obj.magic ()), x))
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun x -> ((Obj.magic ()), x))
     | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> ((Obj.magic ()), x)))
  | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun x -> ((Obj.magic ()), x))
  | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> ((Obj.magic ()), x))
  in extract_listnames0

(** val load_list_item :
    z -> Coq_access_size.access_size -> Coq_expr.expr -> nat -> Coq_expr.expr **)

let load_list_item width load_size start i =
  let nbytes = bytes_per width load_size in
  let offset = Coq_expr.Coq_literal (Coq_Z.of_nat (mul nbytes i)) in
  let loc = Coq_expr.Coq_op (Coq_bopname.Coq_add, start, offset) in
  Coq_expr.Coq_load (load_size, loc)

(** val load_list :
    z -> (nat -> char list) -> Coq_access_size.access_size -> Coq_expr.expr
    -> nat -> nat -> nat -> (nat * char list list) * Coq_cmd.cmd **)

let load_list width varname_gen =
  let rec load_list0 load_size start i rem0 nextn =
    match rem0 with
    | O -> ((O, []), Coq_cmd.Coq_skip)
    | S rem' ->
      let rec0 = load_list0 load_size start (S i) rem' (S nextn) in
      (((S (fst (fst rec0))), ((varname_gen nextn) :: (snd (fst rec0)))),
      (Coq_cmd.Coq_seq ((Coq_cmd.Coq_set ((varname_gen nextn),
      (load_list_item width load_size start i))), (snd rec0))))
  in load_list0

(** val load_all_lists :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> nat -> base_ltype -> nat base_listonly -> base_access_sizes ->
    (nat * base_ltype) * Coq_cmd.cmd **)

let load_all_lists width _ _ _ varname_gen _ _ =
  let rec load_all_lists0 t0 nextn =
    match t0 with
    | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
      (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
    | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
      (fun x l s0 ->
        let load1 =
          load_all_lists0 a nextn (fst (Obj.magic x)) (fst (Obj.magic l))
            (fst (Obj.magic s0))
        in
        let nextn1 = add nextn (fst (fst load1)) in
        let load2 =
          load_all_lists0 b nextn1 (snd (Obj.magic x)) (snd (Obj.magic l))
            (snd (Obj.magic s0))
        in
        let nvars = add (fst (fst load1)) (fst (fst load2)) in
        ((nvars, (Obj.magic ((snd (fst load1)), (snd (fst load2))))),
        (Coq_cmd.Coq_seq ((snd load1), (snd load2)))))
    | Compilers.Coq_base.Coq_type.Coq_list a ->
      (match a with
       | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
         (match t1 with
          | Coq3_Compilers.Z ->
            (fun x l s0 ->
              Obj.magic load_list width varname_gen s0 (Coq_expr.Coq_var
                (Obj.magic x)) O l nextn)
          | Coq3_Compilers.Coq_bool ->
            (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
          | Coq3_Compilers.Coq_nat ->
            (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
          | Coq3_Compilers.Coq_zrange ->
            (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
          | Coq3_Compilers.Coq_string ->
            (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip)))
       | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
         (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
       | Compilers.Coq_base.Coq_type.Coq_list _ ->
         (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
       | Compilers.Coq_base.Coq_type.Coq_option _ ->
         (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
       | Compilers.Coq_base.Coq_type.Coq_unit ->
         (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip)))
    | Compilers.Coq_base.Coq_type.Coq_option _ ->
      (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
    | Compilers.Coq_base.Coq_type.Coq_unit ->
      (fun x _ _ -> ((O, x), Coq_cmd.Coq_skip))
  in load_all_lists0

(** val load_arguments :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> nat -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, list_lengths)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, access_sizes)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (nat * (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow) * Coq_cmd.cmd **)

let load_arguments width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec load_arguments0 t0 nextn =
    match t0 with
    | Compilers.Coq_type.Coq_base _ ->
      (fun args0 _ _ -> ((O, args0), Coq_cmd.Coq_skip))
    | Compilers.Coq_type.Coq_arrow (s0, d) ->
      (match s0 with
       | Compilers.Coq_type.Coq_base s1 ->
         (fun args0 llengths sizes ->
           let load_fst =
             load_all_lists width word1 mem0 locals varname_gen error0
               parameters_sentinel s1 nextn (fst (Obj.magic args0))
               (fst (Obj.magic llengths)) (fst (Obj.magic sizes))
           in
           let nextn' = add nextn (fst (fst load_fst)) in
           let load_snd =
             load_arguments0 d nextn' (snd (Obj.magic args0))
               (snd (Obj.magic llengths)) (snd (Obj.magic sizes))
           in
           let nvars = add (fst (fst load_fst)) (fst (fst load_snd)) in
           let args' = ((snd (fst load_fst)), (snd (fst load_snd))) in
           let cmd0 = Coq_cmd.Coq_seq ((snd load_fst), (snd load_snd)) in
           ((nvars, (Obj.magic args')), cmd0))
       | Compilers.Coq_type.Coq_arrow (_, _) ->
         (fun args0 bounds1 sizes ->
           let load_snd =
             load_arguments0 d nextn (snd (Obj.magic args0))
               (snd (Obj.magic bounds1)) (snd (Obj.magic sizes))
           in
           (((fst (fst load_snd)), (Obj.magic ((), (snd (fst load_snd))))),
           (snd load_snd))))
  in load_arguments0

(** val store_list_item :
    z -> Coq_access_size.access_size -> Coq_expr.expr -> Coq_expr.expr -> nat
    -> Coq_cmd.cmd **)

let store_list_item width size0 start value1 i =
  let nbytes = bytes_per width size0 in
  let offset = Coq_expr.Coq_literal (Coq_Z.of_nat (mul nbytes i)) in
  let loc = Coq_expr.Coq_op (Coq_bopname.Coq_add, start, offset) in
  Coq_cmd.Coq_store (size0, loc, value1)

(** val store_list :
    z -> Coq_access_size.access_size -> Coq_expr.expr -> Coq_expr.expr list
    -> nat -> Coq_cmd.cmd **)

let store_list width =
  let rec store_list0 size0 start values i =
    match values with
    | [] -> Coq_cmd.Coq_skip
    | v :: values' ->
      Coq_cmd.Coq_seq ((store_list_item width size0 start v i),
        (store_list0 size0 start values' (S i)))
  in store_list0

(** val store_return_values :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> base_ltype -> base_ltype -> access_sizes -> list_lengths * Coq_cmd.cmd **)

let store_return_values width _ _ _ _ _ _ =
  let rec store_return_values0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
      (Coq_expr.Coq_var (Obj.magic x))))))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun x y s0 ->
      let a0 =
        store_return_values0 a (fst (Obj.magic x)) (fst (Obj.magic y))
          (fst (Obj.magic s0))
      in
      let b0 =
        store_return_values0 b (snd (Obj.magic x)) (snd (Obj.magic y))
          (snd (Obj.magic s0))
      in
      ((Obj.magic ((fst a0), (fst b0))), (Coq_cmd.Coq_seq ((snd a0),
      (snd b0)))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun x y s0 -> ((Obj.magic length x),
            (store_list width (Obj.magic s0) (Coq_expr.Coq_var (Obj.magic y))
              (map (fun x0 -> Coq_expr.Coq_var x0) (Obj.magic x)) O)))
        | Coq3_Compilers.Coq_bool ->
          (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
            (Coq_expr.Coq_var (Obj.magic x))))))
        | Coq3_Compilers.Coq_nat ->
          (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
            (Coq_expr.Coq_var (Obj.magic x))))))
        | Coq3_Compilers.Coq_zrange ->
          (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
            (Coq_expr.Coq_var (Obj.magic x))))))
        | Coq3_Compilers.Coq_string ->
          (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
            (Coq_expr.Coq_var (Obj.magic x)))))))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
         (Coq_expr.Coq_var (Obj.magic x))))))
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
         (Coq_expr.Coq_var (Obj.magic x))))))
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
         (Coq_expr.Coq_var (Obj.magic x))))))
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
         (Coq_expr.Coq_var (Obj.magic x)))))))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
      (Coq_expr.Coq_var (Obj.magic x))))))
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    (fun x y _ -> ((Obj.magic ()), (Coq_cmd.Coq_set ((Obj.magic y),
      (Coq_expr.Coq_var (Obj.magic x))))))
  in store_return_values0

(** val loosest_range : zrange option list -> zrange option **)

let rec loosest_range = function
| [] -> None
| x :: ranges' ->
  let y = loosest_range ranges' in
  (match x with
   | Some rx ->
     (match y with
      | Some ry -> if is_tighter_than_bool rx ry then Some ry else Some rx
      | None -> Some rx)
   | None -> None)

(** val access_size_to_zrange : z -> Coq_access_size.access_size -> zrange **)

let access_size_to_zrange width size0 =
  let bytes = Coq_Z.of_nat (bytes_per width size0) in
  { lower = Z0; upper =
  (Coq_Z.sub
    (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.mul bytes (Zpos (XO (XO (XO XH))))))
    (Zpos XH)) }

(** val zrange_to_access_size' :
    z -> zrange -> Coq_access_size.access_size list ->
    Coq_access_size.access_size option **)

let zrange_to_access_size' width r0 access_sizes0 =
  fold_right (fun nsize current ->
    match current with
    | Some csize ->
      let nr = access_size_to_zrange width nsize in
      let cr = access_size_to_zrange width csize in
      if (&&) (is_tighter_than_bool nr cr) (is_tighter_than_bool r0 nr)
      then Some nsize
      else Some csize
    | None ->
      let nr = access_size_to_zrange width nsize in
      if is_tighter_than_bool r0 nr then Some nsize else None) None
    access_sizes0

(** val zrange_to_access_size :
    z -> zrange -> Coq_access_size.access_size option **)

let zrange_to_access_size width =
  let all_access_sizes =
    Coq_access_size.Coq_one :: (Coq_access_size.Coq_two :: (Coq_access_size.Coq_four :: (Coq_access_size.Coq_word :: [])))
  in
  (fun r0 -> zrange_to_access_size' width r0 all_access_sizes)

(** val make_access_size :
    z -> zrange option list -> Coq_access_size.access_size option **)

let make_access_size width ranges =
  match loosest_range ranges with
  | Some r0 ->
    let wordr = access_size_to_zrange width Coq_access_size.Coq_word in
    if is_tighter_than_bool r0 wordr
    then (match zrange_to_access_size width r0 with
          | Some s0 ->
            let sr = access_size_to_zrange width s0 in
            if zrange_beq sr wordr
            then Some Coq_access_size.Coq_word
            else Some s0
          | None -> None)
    else None
  | None -> None

(** val make_base_access_sizes :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    base_access_sizes option **)

let make_base_access_sizes width _ _ _ _ _ _ =
  let rec make_base_access_sizes0 = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    (fun _ -> Some (Obj.magic ()))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    (fun r0 ->
      match make_base_access_sizes0 a (fst (Obj.magic r0)) with
      | Some s1 ->
        (match make_base_access_sizes0 b (snd (Obj.magic r0)) with
         | Some s2 -> Some (Obj.magic (s1, s2))
         | None -> None)
      | None -> None)
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun r0 ->
            match Obj.magic r0 with
            | Some ranges -> Obj.magic make_access_size width ranges
            | None -> None)
        | Coq3_Compilers.Coq_bool -> (fun _ -> Some (Obj.magic ()))
        | Coq3_Compilers.Coq_nat -> (fun _ -> Some (Obj.magic ()))
        | Coq3_Compilers.Coq_zrange -> (fun _ -> Some (Obj.magic ()))
        | Coq3_Compilers.Coq_string -> (fun _ -> Some (Obj.magic ())))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       (fun _ -> Some (Obj.magic ()))
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       (fun _ -> Some (Obj.magic ()))
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       (fun _ -> Some (Obj.magic ()))
     | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> Some (Obj.magic ())))
  | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> Some (Obj.magic ()))
  | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> Some (Obj.magic ()))
  in make_base_access_sizes0

(** val make_access_sizes_args :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, access_sizes)
    Compilers.Coq_type.for_each_lhs_of_arrow option **)

let make_access_sizes_args width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec make_access_sizes_args0 = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ -> Some (Obj.magic ()))
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (match s0 with
     | Compilers.Coq_type.Coq_base s1 ->
       (fun r0 ->
         match make_base_access_sizes width word1 mem0 locals varname_gen
                 error0 parameters_sentinel s1 (fst (Obj.magic r0)) with
         | Some ssizes ->
           (match make_access_sizes_args0 d (snd (Obj.magic r0)) with
            | Some dsizes -> Some (Obj.magic (ssizes, dsizes))
            | None -> None)
         | None -> None)
     | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None))
  in make_access_sizes_args0

(** val list_lengths_from_bounds :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp -> nat
    base_listonly option **)

let rec list_lengths_from_bounds = function
| Compilers.Coq_base.Coq_type.Coq_type_base _ ->
  (fun _ -> Some (Obj.magic ()))
| Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
  (fun x ->
    bind (list_lengths_from_bounds a (fst (Obj.magic x))) (fun x1 ->
      bind (list_lengths_from_bounds b (snd (Obj.magic x))) (fun x2 -> Some
        (Obj.magic (x1, x2)))))
| Compilers.Coq_base.Coq_type.Coq_list a ->
  (match a with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z ->
        (fun x -> option_map (Obj.magic length) (Obj.magic x))
      | Coq3_Compilers.Coq_bool -> (fun _ -> Some (Obj.magic ()))
      | Coq3_Compilers.Coq_nat -> (fun _ -> Some (Obj.magic ()))
      | Coq3_Compilers.Coq_zrange -> (fun _ -> Some (Obj.magic ()))
      | Coq3_Compilers.Coq_string -> (fun _ -> Some (Obj.magic ())))
   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
     (fun _ -> Some (Obj.magic ()))
   | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> Some (Obj.magic ()))
   | Compilers.Coq_base.Coq_type.Coq_option _ ->
     (fun _ -> Some (Obj.magic ()))
   | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> Some (Obj.magic ())))
| Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> Some (Obj.magic ()))
| Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> Some (Obj.magic ()))

(** val list_lengths_from_argbounds :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, list_lengths)
    Compilers.Coq_type.for_each_lhs_of_arrow option **)

let rec list_lengths_from_argbounds = function
| Compilers.Coq_type.Coq_base _ -> (fun _ -> Some (Obj.magic ()))
| Compilers.Coq_type.Coq_arrow (a, b) ->
  (match a with
   | Compilers.Coq_type.Coq_base a0 ->
     (fun x ->
       bind (list_lengths_from_bounds a0 (fst (Obj.magic x))) (fun x1 ->
         bind (list_lengths_from_argbounds b (snd (Obj.magic x))) (fun x2 ->
           Some (Obj.magic (x1, x2)))))
   | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> None))

(** val make_names :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> (nat -> char list) -> nat -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type -> nat * base_ltype **)

let make_names _ _ _ _ _ _ _ =
  let rec make_names0 name_gen nextn = function
  | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
    ((S nextn), (Obj.magic name_gen nextn))
  | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
    let resa = make_names0 name_gen nextn a in
    let resb = make_names0 name_gen (fst resa) b in
    ((fst resb), (Obj.magic ((snd resa), (snd resb))))
  | Compilers.Coq_base.Coq_type.Coq_list a ->
    (match a with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z -> ((S nextn), (Obj.magic name_gen nextn))
        | Coq3_Compilers.Coq_bool -> ((S nextn), (Obj.magic name_gen nextn))
        | Coq3_Compilers.Coq_nat -> ((S nextn), (Obj.magic name_gen nextn))
        | Coq3_Compilers.Coq_zrange -> ((S nextn), (Obj.magic name_gen nextn))
        | Coq3_Compilers.Coq_string -> ((S nextn), (Obj.magic name_gen nextn)))
     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
       ((S nextn), (Obj.magic name_gen nextn))
     | Compilers.Coq_base.Coq_type.Coq_list _ ->
       ((S nextn), (Obj.magic name_gen nextn))
     | Compilers.Coq_base.Coq_type.Coq_option _ ->
       ((S nextn), (Obj.magic name_gen nextn))
     | Compilers.Coq_base.Coq_type.Coq_unit ->
       ((S nextn), (Obj.magic name_gen nextn)))
  | Compilers.Coq_base.Coq_type.Coq_option _ ->
    ((S nextn), (Obj.magic name_gen nextn))
  | Compilers.Coq_base.Coq_type.Coq_unit ->
    ((S nextn), (Obj.magic name_gen nextn))
  in make_names0

(** val make_innames' :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> (nat -> char list) -> nat -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    nat * (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow **)

let make_innames' width word1 mem0 locals varname_gen error0 parameters_sentinel inname_gen =
  let rec make_innames'0 nextn = function
  | Compilers.Coq_type.Coq_base _ -> (nextn, (Obj.magic ()))
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (match s0 with
     | Compilers.Coq_type.Coq_base s1 ->
       let ress =
         make_names width word1 mem0 locals varname_gen error0
           parameters_sentinel inname_gen nextn s1
       in
       let resd = make_innames'0 (fst ress) d in
       ((fst resd), (Obj.magic ((snd ress), (snd resd))))
     | Compilers.Coq_type.Coq_arrow (_, _) ->
       let resd = make_innames'0 nextn d in
       ((fst resd), (Obj.magic ((), (snd resd)))))
  in make_innames'0

(** val make_innames :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> (nat -> char list) -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow **)

let make_innames width word1 mem0 locals varname_gen error0 parameters_sentinel inname_gen t0 =
  snd
    (make_innames' width word1 mem0 locals varname_gen error0
      parameters_sentinel inname_gen O t0)

(** val make_outnames :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> (nat -> char list) -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type -> base_ltype **)

let make_outnames width word1 mem0 locals varname_gen error0 parameters_sentinel outname_gen t0 =
  snd
    (make_names width word1 mem0 locals varname_gen error0
      parameters_sentinel outname_gen O t0)

(** val prefix_name_gen : char list -> nat -> char list **)

let prefix_name_gen pre x =
  append pre (Coq0_Z.to_string (Coq_Z.of_nat x))

(** val default_inname_gen : nat -> char list **)

let default_inname_gen =
  prefix_name_gen ('i'::('n'::[]))

(** val default_outname_gen : nat -> char list **)

let default_outname_gen =
  prefix_name_gen ('o'::('u'::('t'::[])))

(** val default_varname_gen : nat -> char list **)

let default_varname_gen =
  prefix_name_gen ('x'::[])

(** val eRROR : char list **)

let eRROR =
  'E'::('R'::('R'::('O'::('R'::[]))))

(** val error_free_expr : Coq_expr.expr -> bool **)

let rec error_free_expr = function
| Coq_expr.Coq_literal _ -> true
| Coq_expr.Coq_var x0 -> negb (eqb0 x0 eRROR)
| Coq_expr.Coq_load (_, a) -> error_free_expr a
| Coq_expr.Coq_inlinetable (_, _, index) -> error_free_expr index
| Coq_expr.Coq_op (_, x0, y) -> (&&) (error_free_expr x0) (error_free_expr y)
| Coq_expr.Coq_ite (c0, a, b) ->
  (&&) ((&&) (error_free_expr c0) (error_free_expr a)) (error_free_expr b)

(** val error_free_cmd : Coq_cmd.cmd -> bool **)

let rec error_free_cmd = function
| Coq_cmd.Coq_skip -> true
| Coq_cmd.Coq_set (_, v) -> error_free_expr v
| Coq_cmd.Coq_unset _ -> true
| Coq_cmd.Coq_store (_, a, v) -> (&&) (error_free_expr a) (error_free_expr v)
| Coq_cmd.Coq_stackalloc (_, _, x0) -> error_free_cmd x0
| Coq_cmd.Coq_cond (c0, t0, f) ->
  (&&) ((&&) (error_free_expr c0) (error_free_cmd t0)) (error_free_cmd f)
| Coq_cmd.Coq_seq (x0, y) -> (&&) (error_free_cmd x0) (error_free_cmd y)
| Coq_cmd.Coq_while (c0, b) -> (&&) (error_free_expr c0) (error_free_cmd b)
| Coq_cmd.Coq_call (_, _, args0) -> forallb error_free_expr args0
| Coq_cmd.Coq_interact (_, _, args0) -> forallb error_free_expr args0

(** val max_range : z -> zrange **)

let max_range width =
  { lower = Z0; upper =
    (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) width) (Zpos XH)) }

(** val range_good : z -> zrange -> bool **)

let range_good width r0 =
  zrange_beq r0 (max_range width)

(** val width_range : z -> zrange **)

let width_range width =
  { lower = Z0; upper = (Coq_Z.sub width (Zpos XH)) }

(** val cast_exempt :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let cast_exempt _ = function
| Compilers.Coq_expr.Ident (_, idc) ->
  (match idc with
   | Coq3_Compilers.Coq_ident_Literal (t1, _) ->
     (match t1 with
      | Coq3_Compilers.Z -> true
      | Coq3_Compilers.Coq_bool -> false
      | Coq3_Compilers.Coq_nat -> true
      | Coq3_Compilers.Coq_zrange -> false
      | Coq3_Compilers.Coq_string -> false)
   | Coq3_Compilers.Coq_ident_comment _ -> false
   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> false
   | Coq3_Compilers.Coq_ident_value_barrier -> false
   | Coq3_Compilers.Coq_ident_Nat_succ -> false
   | Coq3_Compilers.Coq_ident_Nat_pred -> false
   | Coq3_Compilers.Coq_ident_Nat_max -> false
   | Coq3_Compilers.Coq_ident_Nat_mul -> false
   | Coq3_Compilers.Coq_ident_Nat_add -> false
   | Coq3_Compilers.Coq_ident_Nat_sub -> false
   | Coq3_Compilers.Coq_ident_Nat_eqb -> false
   | Coq3_Compilers.Coq_ident_nil _ -> false
   | Coq3_Compilers.Coq_ident_cons _ -> false
   | Coq3_Compilers.Coq_ident_tt -> false
   | Coq3_Compilers.Coq_ident_pair (_, _) -> false
   | Coq3_Compilers.Coq_ident_fst (_, _) -> false
   | Coq3_Compilers.Coq_ident_snd (_, _) -> false
   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> false
   | Coq3_Compilers.Coq_ident_bool_rect _ -> false
   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> false
   | Coq3_Compilers.Coq_ident_nat_rect _ -> false
   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> false
   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> false
   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> false
   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> false
   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> false
   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> false
   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> false
   | Coq3_Compilers.Coq_ident_list_case (_, _) -> false
   | Coq3_Compilers.Coq_ident_List_length _ -> false
   | Coq3_Compilers.Coq_ident_List_seq -> false
   | Coq3_Compilers.Coq_ident_List_firstn _ -> false
   | Coq3_Compilers.Coq_ident_List_skipn _ -> false
   | Coq3_Compilers.Coq_ident_List_repeat _ -> false
   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> false
   | Coq3_Compilers.Coq_ident_List_map (_, _) -> false
   | Coq3_Compilers.Coq_ident_List_app _ -> false
   | Coq3_Compilers.Coq_ident_List_rev _ -> false
   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> false
   | Coq3_Compilers.Coq_ident_List_partition _ -> false
   | Coq3_Compilers.Coq_ident_List_filter _ -> false
   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> false
   | Coq3_Compilers.Coq_ident_List_update_nth _ -> false
   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> false
   | Coq3_Compilers.Coq_ident_Z_add -> false
   | Coq3_Compilers.Coq_ident_Z_mul -> false
   | Coq3_Compilers.Coq_ident_Z_pow -> false
   | Coq3_Compilers.Coq_ident_Z_sub -> false
   | Coq3_Compilers.Coq_ident_Z_opp -> false
   | Coq3_Compilers.Coq_ident_Z_div -> false
   | Coq3_Compilers.Coq_ident_Z_modulo -> false
   | Coq3_Compilers.Coq_ident_Z_eqb -> false
   | Coq3_Compilers.Coq_ident_Z_leb -> false
   | Coq3_Compilers.Coq_ident_Z_ltb -> false
   | Coq3_Compilers.Coq_ident_Z_geb -> false
   | Coq3_Compilers.Coq_ident_Z_gtb -> false
   | Coq3_Compilers.Coq_ident_Z_log2 -> false
   | Coq3_Compilers.Coq_ident_Z_log2_up -> false
   | Coq3_Compilers.Coq_ident_Z_of_nat -> false
   | Coq3_Compilers.Coq_ident_Z_to_nat -> false
   | Coq3_Compilers.Coq_ident_Z_shiftr -> false
   | Coq3_Compilers.Coq_ident_Z_shiftl -> false
   | Coq3_Compilers.Coq_ident_Z_land -> false
   | Coq3_Compilers.Coq_ident_Z_lor -> false
   | Coq3_Compilers.Coq_ident_Z_min -> false
   | Coq3_Compilers.Coq_ident_Z_max -> false
   | Coq3_Compilers.Coq_ident_Z_mul_split -> false
   | Coq3_Compilers.Coq_ident_Z_mul_high -> false
   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> false
   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> false
   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> false
   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> false
   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> false
   | Coq3_Compilers.Coq_ident_Z_ltz -> false
   | Coq3_Compilers.Coq_ident_Z_zselect -> false
   | Coq3_Compilers.Coq_ident_Z_add_modulo -> false
   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> false
   | Coq3_Compilers.Coq_ident_Z_bneg -> false
   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
   | Coq3_Compilers.Coq_ident_Z_lxor -> false
   | Coq3_Compilers.Coq_ident_Z_rshi -> false
   | Coq3_Compilers.Coq_ident_Z_cc_m -> false
   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> false
   | Coq3_Compilers.Coq_ident_Z_cast -> false
   | Coq3_Compilers.Coq_ident_Z_cast2 -> false
   | Coq3_Compilers.Coq_ident_Some _ -> false
   | Coq3_Compilers.Coq_ident_None _ -> false
   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> false
   | Coq3_Compilers.Coq_ident_Build_zrange -> false
   | Coq3_Compilers.Coq_ident_zrange_rect _ -> false
   | Coq3_Compilers.Coq_ident_fancy_add -> false
   | Coq3_Compilers.Coq_ident_fancy_addc -> false
   | Coq3_Compilers.Coq_ident_fancy_sub -> false
   | Coq3_Compilers.Coq_ident_fancy_subb -> false
   | Coq3_Compilers.Coq_ident_fancy_mulll -> false
   | Coq3_Compilers.Coq_ident_fancy_mullh -> false
   | Coq3_Compilers.Coq_ident_fancy_mulhl -> false
   | Coq3_Compilers.Coq_ident_fancy_mulhh -> false
   | Coq3_Compilers.Coq_ident_fancy_rshi -> false
   | Coq3_Compilers.Coq_ident_fancy_selc -> false
   | Coq3_Compilers.Coq_ident_fancy_selm -> false
   | Coq3_Compilers.Coq_ident_fancy_sell -> false
   | Coq3_Compilers.Coq_ident_fancy_addm -> false)
| Compilers.Coq_expr.Var (_, _) -> true
| Compilers.Coq_expr.Abs (_, _, _) -> false
| Compilers.Coq_expr.App (_, _, _, _) -> false
| Compilers.Coq_expr.LetIn (_, _, _, _) -> false

(** val invert_literal0 : Coq_expr.expr -> z option **)

let invert_literal0 = function
| Coq_expr.Coq_literal x0 -> Some x0
| Coq_expr.Coq_var _ -> None
| Coq_expr.Coq_load (_, _) -> None
| Coq_expr.Coq_inlinetable (_, _, _) -> None
| Coq_expr.Coq_op (_, _, _) -> None
| Coq_expr.Coq_ite (_, _, _) -> None

(** val literal_eqb : Coq_expr.expr -> z -> bool **)

let literal_eqb x y =
  match invert_literal0 x with
  | Some x0 -> Coq_Z.eqb x0 y
  | None -> false

(** val literal_ltwidth : z -> Coq_expr.expr -> bool **)

let literal_ltwidth width x =
  match invert_literal0 x with
  | Some x0 -> is_bounded_by_bool x0 (width_range width)
  | None -> false

(** val rshiftr :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rtype0 **)

let rshiftr width word1 mem0 locals varname_gen error0 parameters_sentinel =
  Obj.magic (fun x n3 ->
    if literal_ltwidth width n3
    then Coq_expr.Coq_op (Coq_bopname.Coq_sru, x, n3)
    else Obj.magic base_make_error width word1 mem0 locals varname_gen error0
           parameters_sentinel
           (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
               parameters_sentinel))
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))

(** val rshiftl :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rtype0 **)

let rshiftl width word1 mem0 locals varname_gen error0 parameters_sentinel =
  Obj.magic (fun x n3 ->
    if literal_ltwidth width n3
    then Coq_expr.Coq_op (Coq_bopname.Coq_slu, x, n3)
    else Obj.magic base_make_error width word1 mem0 locals varname_gen error0
           parameters_sentinel
           (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
               parameters_sentinel))
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))

(** val rtruncating_shiftl :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rtype0 **)

let rtruncating_shiftl width word1 mem0 locals varname_gen error0 parameters_sentinel =
  Obj.magic (fun s0 x n3 ->
    if literal_eqb s0 width
    then if literal_ltwidth width n3
         then Coq_expr.Coq_op (Coq_bopname.Coq_slu, x, n3)
         else Obj.magic make_error0 width word1 mem0 locals varname_gen
                error0 parameters_sentinel
                (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                  error0 parameters_sentinel
                  (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                    parameters_sentinel)) (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
    else Obj.magic base_make_error width word1 mem0 locals varname_gen error0
           parameters_sentinel
           (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
               parameters_sentinel))
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))

(** val rlnot_modulo :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rtype0 **)

let rlnot_modulo width word1 mem0 locals varname_gen error0 parameters_sentinel =
  Obj.magic (fun x m4 ->
    match invert_literal0 m4 with
    | Some m5 ->
      if Coq_Z.eqb (Coq_Z.pow (Zpos (XO XH)) (Coq_Z.log2 m5)) m5
      then Coq_expr.Coq_op (Coq_bopname.Coq_xor,
             (if Coq_Z.eqb (Coq_Z.log2 m5) width
              then x
              else Coq_expr.Coq_op (Coq_bopname.Coq_and, x,
                     (Coq_expr.Coq_literal (Coq_Z.ones (Coq_Z.log2 m5))))),
             (Coq_expr.Coq_literal (Coq_Z.ones (Coq_Z.log2 m5))))
      else Obj.magic make_error0 width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel)) (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
    | None ->
      Obj.magic make_error0 width word1 mem0 locals varname_gen error0
        parameters_sentinel
        (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel)) (Compilers.Coq_type.Coq_base
        (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))

(** val rselect :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rtype0 **)

let rselect width word1 mem0 locals varname_gen error0 parameters_sentinel =
  Obj.magic (fun c0 x y ->
    if literal_eqb x Z0
    then if literal_eqb y
              (Coq_Z.sub (Coq_Z.pow (Zpos (XO XH)) width) (Zpos XH))
         then Coq_expr.Coq_op (Coq_bopname.Coq_add, (Coq_expr.Coq_literal
                (Zneg XH)), (Coq_expr.Coq_op (Coq_bopname.Coq_eq, c0,
                (Coq_expr.Coq_literal Z0))))
         else Obj.magic base_make_error width word1 mem0 locals varname_gen
                error0 parameters_sentinel
                (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                  error0 parameters_sentinel
                  (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                    parameters_sentinel))
                (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)
    else Obj.magic base_make_error width word1 mem0 locals varname_gen error0
           parameters_sentinel
           (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
               parameters_sentinel))
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))

(** val rnth_default :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rtype0 **)

let rnth_default width word1 mem0 locals varname_gen error0 parameters_sentinel =
  Obj.magic (fun d l i ->
    match i with
    | Coq_expr.Coq_literal i0 -> nth_default d l (Coq_Z.to_nat i0)
    | Coq_expr.Coq_var _ ->
      base_make_error width word1 mem0 locals varname_gen error0
        parameters_sentinel
        (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel)) (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)
    | Coq_expr.Coq_load (_, _) ->
      base_make_error width word1 mem0 locals varname_gen error0
        parameters_sentinel
        (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel)) (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)
    | Coq_expr.Coq_inlinetable (_, _, _) ->
      base_make_error width word1 mem0 locals varname_gen error0
        parameters_sentinel
        (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel)) (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)
    | Coq_expr.Coq_op (_, _, _) ->
      base_make_error width word1 mem0 locals varname_gen error0
        parameters_sentinel
        (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel)) (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z)
    | Coq_expr.Coq_ite (_, _, _) ->
      base_make_error width word1 mem0 locals varname_gen error0
        parameters_sentinel
        (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel)) (Compilers.Coq_base.Coq_type.Coq_type_base
        Coq3_Compilers.Z))

(** val rmul_high :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> rtype0 **)

let rmul_high width word1 mem0 locals varname_gen error0 parameters_sentinel =
  Obj.magic (fun s0 x y ->
    if literal_eqb s0 (Coq_Z.pow (Zpos (XO XH)) width)
    then Coq_expr.Coq_op (Coq_bopname.Coq_mulhuu, x, y)
    else Obj.magic base_make_error width word1 mem0 locals varname_gen error0
           parameters_sentinel
           (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
               parameters_sentinel))
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))

(** val is_cast_literal_ident :
    z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool **)

let is_cast_literal_ident width _ = function
| Coq3_Compilers.Coq_ident_Literal (t0, r0) ->
  (match t0 with
   | Coq3_Compilers.Z -> (fun _ -> false)
   | Coq3_Compilers.Coq_bool -> (fun _ -> false)
   | Coq3_Compilers.Coq_nat -> (fun _ -> false)
   | Coq3_Compilers.Coq_zrange -> (fun r1 -> range_good width (Obj.magic r1))
   | Coq3_Compilers.Coq_string -> (fun _ -> false)) r0
| Coq3_Compilers.Coq_ident_comment _ -> false
| Coq3_Compilers.Coq_ident_comment_no_keep _ -> false
| Coq3_Compilers.Coq_ident_value_barrier -> false
| Coq3_Compilers.Coq_ident_Nat_succ -> false
| Coq3_Compilers.Coq_ident_Nat_pred -> false
| Coq3_Compilers.Coq_ident_Nat_max -> false
| Coq3_Compilers.Coq_ident_Nat_mul -> false
| Coq3_Compilers.Coq_ident_Nat_add -> false
| Coq3_Compilers.Coq_ident_Nat_sub -> false
| Coq3_Compilers.Coq_ident_Nat_eqb -> false
| Coq3_Compilers.Coq_ident_nil _ -> false
| Coq3_Compilers.Coq_ident_cons _ -> false
| Coq3_Compilers.Coq_ident_tt -> false
| Coq3_Compilers.Coq_ident_pair (_, _) -> false
| Coq3_Compilers.Coq_ident_fst (_, _) -> false
| Coq3_Compilers.Coq_ident_snd (_, _) -> false
| Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> false
| Coq3_Compilers.Coq_ident_bool_rect _ -> false
| Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> false
| Coq3_Compilers.Coq_ident_nat_rect _ -> false
| Coq3_Compilers.Coq_ident_eager_nat_rect _ -> false
| Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> false
| Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> false
| Coq3_Compilers.Coq_ident_list_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> false
| Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> false
| Coq3_Compilers.Coq_ident_list_case (_, _) -> false
| Coq3_Compilers.Coq_ident_List_length _ -> false
| Coq3_Compilers.Coq_ident_List_seq -> false
| Coq3_Compilers.Coq_ident_List_firstn _ -> false
| Coq3_Compilers.Coq_ident_List_skipn _ -> false
| Coq3_Compilers.Coq_ident_List_repeat _ -> false
| Coq3_Compilers.Coq_ident_List_combine (_, _) -> false
| Coq3_Compilers.Coq_ident_List_map (_, _) -> false
| Coq3_Compilers.Coq_ident_List_app _ -> false
| Coq3_Compilers.Coq_ident_List_rev _ -> false
| Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> false
| Coq3_Compilers.Coq_ident_List_partition _ -> false
| Coq3_Compilers.Coq_ident_List_filter _ -> false
| Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> false
| Coq3_Compilers.Coq_ident_List_update_nth _ -> false
| Coq3_Compilers.Coq_ident_List_nth_default _ -> false
| Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> false
| Coq3_Compilers.Coq_ident_Z_add -> false
| Coq3_Compilers.Coq_ident_Z_mul -> false
| Coq3_Compilers.Coq_ident_Z_pow -> false
| Coq3_Compilers.Coq_ident_Z_sub -> false
| Coq3_Compilers.Coq_ident_Z_opp -> false
| Coq3_Compilers.Coq_ident_Z_div -> false
| Coq3_Compilers.Coq_ident_Z_modulo -> false
| Coq3_Compilers.Coq_ident_Z_eqb -> false
| Coq3_Compilers.Coq_ident_Z_leb -> false
| Coq3_Compilers.Coq_ident_Z_ltb -> false
| Coq3_Compilers.Coq_ident_Z_geb -> false
| Coq3_Compilers.Coq_ident_Z_gtb -> false
| Coq3_Compilers.Coq_ident_Z_log2 -> false
| Coq3_Compilers.Coq_ident_Z_log2_up -> false
| Coq3_Compilers.Coq_ident_Z_of_nat -> false
| Coq3_Compilers.Coq_ident_Z_to_nat -> false
| Coq3_Compilers.Coq_ident_Z_shiftr -> false
| Coq3_Compilers.Coq_ident_Z_shiftl -> false
| Coq3_Compilers.Coq_ident_Z_land -> false
| Coq3_Compilers.Coq_ident_Z_lor -> false
| Coq3_Compilers.Coq_ident_Z_min -> false
| Coq3_Compilers.Coq_ident_Z_max -> false
| Coq3_Compilers.Coq_ident_Z_mul_split -> false
| Coq3_Compilers.Coq_ident_Z_mul_high -> false
| Coq3_Compilers.Coq_ident_Z_add_get_carry -> false
| Coq3_Compilers.Coq_ident_Z_add_with_carry -> false
| Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> false
| Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> false
| Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> false
| Coq3_Compilers.Coq_ident_Z_ltz -> false
| Coq3_Compilers.Coq_ident_Z_zselect -> false
| Coq3_Compilers.Coq_ident_Z_add_modulo -> false
| Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> false
| Coq3_Compilers.Coq_ident_Z_bneg -> false
| Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
| Coq3_Compilers.Coq_ident_Z_lxor -> false
| Coq3_Compilers.Coq_ident_Z_rshi -> false
| Coq3_Compilers.Coq_ident_Z_cc_m -> false
| Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> false
| Coq3_Compilers.Coq_ident_Z_cast -> false
| Coq3_Compilers.Coq_ident_Z_cast2 -> false
| Coq3_Compilers.Coq_ident_Some _ -> false
| Coq3_Compilers.Coq_ident_None _ -> false
| Coq3_Compilers.Coq_ident_option_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_Build_zrange -> false
| Coq3_Compilers.Coq_ident_zrange_rect _ -> false
| Coq3_Compilers.Coq_ident_fancy_add -> false
| Coq3_Compilers.Coq_ident_fancy_addc -> false
| Coq3_Compilers.Coq_ident_fancy_sub -> false
| Coq3_Compilers.Coq_ident_fancy_subb -> false
| Coq3_Compilers.Coq_ident_fancy_mulll -> false
| Coq3_Compilers.Coq_ident_fancy_mullh -> false
| Coq3_Compilers.Coq_ident_fancy_mulhl -> false
| Coq3_Compilers.Coq_ident_fancy_mulhh -> false
| Coq3_Compilers.Coq_ident_fancy_rshi -> false
| Coq3_Compilers.Coq_ident_fancy_selc -> false
| Coq3_Compilers.Coq_ident_fancy_selm -> false
| Coq3_Compilers.Coq_ident_fancy_sell -> false
| Coq3_Compilers.Coq_ident_fancy_addm -> false

(** val is_cast_literal :
    z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let is_cast_literal width _ = function
| Compilers.Coq_expr.Ident (t0, i) ->
  (match t0 with
   | Compilers.Coq_type.Coq_base t1 ->
     (match t1 with
      | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
        (match t2 with
         | Coq3_Compilers.Z -> (fun _ -> false)
         | Coq3_Compilers.Coq_bool -> (fun _ -> false)
         | Coq3_Compilers.Coq_nat -> (fun _ -> false)
         | Coq3_Compilers.Coq_zrange ->
           (fun i0 ->
             is_cast_literal_ident width (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_zrange)) i0)
         | Coq3_Compilers.Coq_string -> (fun _ -> false))
      | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
   | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> false)) i
| Compilers.Coq_expr.Var (_, _) -> false
| Compilers.Coq_expr.Abs (_, _, _) -> false
| Compilers.Coq_expr.App (_, _, _, _) -> false
| Compilers.Coq_expr.LetIn (_, _, _, _) -> false

(** val is_pair_range :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool **)

let is_pair_range _ = function
| Coq3_Compilers.Coq_ident_Literal (_, _) -> false
| Coq3_Compilers.Coq_ident_comment _ -> false
| Coq3_Compilers.Coq_ident_comment_no_keep _ -> false
| Coq3_Compilers.Coq_ident_value_barrier -> false
| Coq3_Compilers.Coq_ident_Nat_succ -> false
| Coq3_Compilers.Coq_ident_Nat_pred -> false
| Coq3_Compilers.Coq_ident_Nat_max -> false
| Coq3_Compilers.Coq_ident_Nat_mul -> false
| Coq3_Compilers.Coq_ident_Nat_add -> false
| Coq3_Compilers.Coq_ident_Nat_sub -> false
| Coq3_Compilers.Coq_ident_Nat_eqb -> false
| Coq3_Compilers.Coq_ident_nil _ -> false
| Coq3_Compilers.Coq_ident_cons _ -> false
| Coq3_Compilers.Coq_ident_tt -> false
| Coq3_Compilers.Coq_ident_pair (t0, t1) ->
  (match t0 with
   | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
     (match t2 with
      | Coq3_Compilers.Z -> false
      | Coq3_Compilers.Coq_bool -> false
      | Coq3_Compilers.Coq_nat -> false
      | Coq3_Compilers.Coq_zrange ->
        (match t1 with
         | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
           (match t3 with
            | Coq3_Compilers.Z -> false
            | Coq3_Compilers.Coq_bool -> false
            | Coq3_Compilers.Coq_nat -> false
            | Coq3_Compilers.Coq_zrange -> true
            | Coq3_Compilers.Coq_string -> false)
         | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> false
         | Compilers.Coq_base.Coq_type.Coq_list _ -> false
         | Compilers.Coq_base.Coq_type.Coq_option _ -> false
         | Compilers.Coq_base.Coq_type.Coq_unit -> false)
      | Coq3_Compilers.Coq_string -> false)
   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> false
   | Compilers.Coq_base.Coq_type.Coq_list _ -> false
   | Compilers.Coq_base.Coq_type.Coq_option _ -> false
   | Compilers.Coq_base.Coq_type.Coq_unit -> false)
| Coq3_Compilers.Coq_ident_fst (_, _) -> false
| Coq3_Compilers.Coq_ident_snd (_, _) -> false
| Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> false
| Coq3_Compilers.Coq_ident_bool_rect _ -> false
| Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> false
| Coq3_Compilers.Coq_ident_nat_rect _ -> false
| Coq3_Compilers.Coq_ident_eager_nat_rect _ -> false
| Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> false
| Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> false
| Coq3_Compilers.Coq_ident_list_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> false
| Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> false
| Coq3_Compilers.Coq_ident_list_case (_, _) -> false
| Coq3_Compilers.Coq_ident_List_length _ -> false
| Coq3_Compilers.Coq_ident_List_seq -> false
| Coq3_Compilers.Coq_ident_List_firstn _ -> false
| Coq3_Compilers.Coq_ident_List_skipn _ -> false
| Coq3_Compilers.Coq_ident_List_repeat _ -> false
| Coq3_Compilers.Coq_ident_List_combine (_, _) -> false
| Coq3_Compilers.Coq_ident_List_map (_, _) -> false
| Coq3_Compilers.Coq_ident_List_app _ -> false
| Coq3_Compilers.Coq_ident_List_rev _ -> false
| Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> false
| Coq3_Compilers.Coq_ident_List_partition _ -> false
| Coq3_Compilers.Coq_ident_List_filter _ -> false
| Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> false
| Coq3_Compilers.Coq_ident_List_update_nth _ -> false
| Coq3_Compilers.Coq_ident_List_nth_default _ -> false
| Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> false
| Coq3_Compilers.Coq_ident_Z_add -> false
| Coq3_Compilers.Coq_ident_Z_mul -> false
| Coq3_Compilers.Coq_ident_Z_pow -> false
| Coq3_Compilers.Coq_ident_Z_sub -> false
| Coq3_Compilers.Coq_ident_Z_opp -> false
| Coq3_Compilers.Coq_ident_Z_div -> false
| Coq3_Compilers.Coq_ident_Z_modulo -> false
| Coq3_Compilers.Coq_ident_Z_eqb -> false
| Coq3_Compilers.Coq_ident_Z_leb -> false
| Coq3_Compilers.Coq_ident_Z_ltb -> false
| Coq3_Compilers.Coq_ident_Z_geb -> false
| Coq3_Compilers.Coq_ident_Z_gtb -> false
| Coq3_Compilers.Coq_ident_Z_log2 -> false
| Coq3_Compilers.Coq_ident_Z_log2_up -> false
| Coq3_Compilers.Coq_ident_Z_of_nat -> false
| Coq3_Compilers.Coq_ident_Z_to_nat -> false
| Coq3_Compilers.Coq_ident_Z_shiftr -> false
| Coq3_Compilers.Coq_ident_Z_shiftl -> false
| Coq3_Compilers.Coq_ident_Z_land -> false
| Coq3_Compilers.Coq_ident_Z_lor -> false
| Coq3_Compilers.Coq_ident_Z_min -> false
| Coq3_Compilers.Coq_ident_Z_max -> false
| Coq3_Compilers.Coq_ident_Z_mul_split -> false
| Coq3_Compilers.Coq_ident_Z_mul_high -> false
| Coq3_Compilers.Coq_ident_Z_add_get_carry -> false
| Coq3_Compilers.Coq_ident_Z_add_with_carry -> false
| Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> false
| Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> false
| Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> false
| Coq3_Compilers.Coq_ident_Z_ltz -> false
| Coq3_Compilers.Coq_ident_Z_zselect -> false
| Coq3_Compilers.Coq_ident_Z_add_modulo -> false
| Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> false
| Coq3_Compilers.Coq_ident_Z_bneg -> false
| Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
| Coq3_Compilers.Coq_ident_Z_lxor -> false
| Coq3_Compilers.Coq_ident_Z_rshi -> false
| Coq3_Compilers.Coq_ident_Z_cc_m -> false
| Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> false
| Coq3_Compilers.Coq_ident_Z_cast -> false
| Coq3_Compilers.Coq_ident_Z_cast2 -> false
| Coq3_Compilers.Coq_ident_Some _ -> false
| Coq3_Compilers.Coq_ident_None _ -> false
| Coq3_Compilers.Coq_ident_option_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_Build_zrange -> false
| Coq3_Compilers.Coq_ident_zrange_rect _ -> false
| Coq3_Compilers.Coq_ident_fancy_add -> false
| Coq3_Compilers.Coq_ident_fancy_addc -> false
| Coq3_Compilers.Coq_ident_fancy_sub -> false
| Coq3_Compilers.Coq_ident_fancy_subb -> false
| Coq3_Compilers.Coq_ident_fancy_mulll -> false
| Coq3_Compilers.Coq_ident_fancy_mullh -> false
| Coq3_Compilers.Coq_ident_fancy_mulhl -> false
| Coq3_Compilers.Coq_ident_fancy_mulhh -> false
| Coq3_Compilers.Coq_ident_fancy_rshi -> false
| Coq3_Compilers.Coq_ident_fancy_selc -> false
| Coq3_Compilers.Coq_ident_fancy_selm -> false
| Coq3_Compilers.Coq_ident_fancy_sell -> false
| Coq3_Compilers.Coq_ident_fancy_addm -> false

(** val is_cast2_literal_App2 :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let is_cast2_literal_App2 _ = function
| Compilers.Coq_expr.Ident (t0, i) ->
  (match t0 with
   | Compilers.Coq_type.Coq_base _ -> (fun _ -> false)
   | Compilers.Coq_type.Coq_arrow (s0, d) ->
     (match s0 with
      | Compilers.Coq_type.Coq_base t1 ->
        (match t1 with
         | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
           (match t2 with
            | Coq3_Compilers.Z -> (fun _ -> false)
            | Coq3_Compilers.Coq_bool -> (fun _ -> false)
            | Coq3_Compilers.Coq_nat -> (fun _ -> false)
            | Coq3_Compilers.Coq_zrange ->
              (match d with
               | Compilers.Coq_type.Coq_base _ -> (fun _ -> false)
               | Compilers.Coq_type.Coq_arrow (s1, d0) ->
                 (match s1 with
                  | Compilers.Coq_type.Coq_base t3 ->
                    (match t3 with
                     | Compilers.Coq_base.Coq_type.Coq_type_base t4 ->
                       (match t4 with
                        | Coq3_Compilers.Z -> (fun _ -> false)
                        | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                        | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                        | Coq3_Compilers.Coq_zrange ->
                          (match d0 with
                           | Compilers.Coq_type.Coq_base t5 ->
                             (match t5 with
                              | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                                (fun _ -> false)
                              | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
                                (match a with
                                 | Compilers.Coq_base.Coq_type.Coq_type_base t6 ->
                                   (match t6 with
                                    | Coq3_Compilers.Z -> (fun _ -> false)
                                    | Coq3_Compilers.Coq_bool ->
                                      (fun _ -> false)
                                    | Coq3_Compilers.Coq_nat ->
                                      (fun _ -> false)
                                    | Coq3_Compilers.Coq_zrange ->
                                      (match b with
                                       | Compilers.Coq_base.Coq_type.Coq_type_base t7 ->
                                         (match t7 with
                                          | Coq3_Compilers.Z ->
                                            (fun _ -> false)
                                          | Coq3_Compilers.Coq_bool ->
                                            (fun _ -> false)
                                          | Coq3_Compilers.Coq_nat ->
                                            (fun _ -> false)
                                          | Coq3_Compilers.Coq_zrange ->
                                            (fun i0 ->
                                              is_pair_range
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_zrange)),
                                                (Compilers.Coq_type.Coq_arrow
                                                ((Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_zrange)),
                                                (Compilers.Coq_type.Coq_base
                                                (Compilers.Coq_base.Coq_type.Coq_prod
                                                ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_zrange),
                                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                                Coq3_Compilers.Coq_zrange))))))))
                                                i0)
                                          | Coq3_Compilers.Coq_string ->
                                            (fun _ -> false))
                                       | Compilers.Coq_base.Coq_type.Coq_prod (
                                           _, _) ->
                                         (fun _ -> false)
                                       | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                         (fun _ -> false)
                                       | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                         (fun _ -> false)
                                       | Compilers.Coq_base.Coq_type.Coq_unit ->
                                         (fun _ -> false))
                                    | Coq3_Compilers.Coq_string ->
                                      (fun _ -> false))
                                 | Compilers.Coq_base.Coq_type.Coq_prod (
                                     _, _) ->
                                   (fun _ -> false)
                                 | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                   (fun _ -> false)
                                 | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                   (fun _ -> false)
                                 | Compilers.Coq_base.Coq_type.Coq_unit ->
                                   (fun _ -> false))
                              | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                (fun _ -> false)
                              | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                (fun _ -> false)
                              | Compilers.Coq_base.Coq_type.Coq_unit ->
                                (fun _ -> false))
                           | Compilers.Coq_type.Coq_arrow (_, _) ->
                             (fun _ -> false))
                        | Coq3_Compilers.Coq_string -> (fun _ -> false))
                     | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                       (fun _ -> false)
                     | Compilers.Coq_base.Coq_type.Coq_list _ ->
                       (fun _ -> false)
                     | Compilers.Coq_base.Coq_type.Coq_option _ ->
                       (fun _ -> false)
                     | Compilers.Coq_base.Coq_type.Coq_unit ->
                       (fun _ -> false))
                  | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> false)))
            | Coq3_Compilers.Coq_string -> (fun _ -> false))
         | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> false)
         | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
         | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> false)
         | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
      | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> false))) i
| Compilers.Coq_expr.Var (_, _) -> false
| Compilers.Coq_expr.Abs (_, _, _) -> false
| Compilers.Coq_expr.App (_, _, _, _) -> false
| Compilers.Coq_expr.LetIn (_, _, _, _) -> false

(** val is_cast2_literal_App1 :
    z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let is_cast2_literal_App1 width _ = function
| Compilers.Coq_expr.Ident (_, _) -> false
| Compilers.Coq_expr.Var (_, _) -> false
| Compilers.Coq_expr.Abs (_, _, _) -> false
| Compilers.Coq_expr.App (s0, d, f, r1) ->
  (match s0 with
   | Compilers.Coq_type.Coq_base t0 ->
     (match t0 with
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_zrange ->
           (fun f0 r2 ->
             (match d with
              | Compilers.Coq_type.Coq_base _ -> (fun _ -> false)
              | Compilers.Coq_type.Coq_arrow (s1, d0) ->
                (match s1 with
                 | Compilers.Coq_type.Coq_base t2 ->
                   (match t2 with
                    | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                      (match t3 with
                       | Coq3_Compilers.Z -> (fun _ -> false)
                       | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                       | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                       | Coq3_Compilers.Coq_zrange ->
                         (match d0 with
                          | Compilers.Coq_type.Coq_base t4 ->
                            (match t4 with
                             | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
                               (match a with
                                | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                                  (match t5 with
                                   | Coq3_Compilers.Z -> (fun _ -> false)
                                   | Coq3_Compilers.Coq_bool ->
                                     (fun _ -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (fun _ -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (match b with
                                      | Compilers.Coq_base.Coq_type.Coq_type_base t6 ->
                                        (match t6 with
                                         | Coq3_Compilers.Z ->
                                           (fun _ -> false)
                                         | Coq3_Compilers.Coq_bool ->
                                           (fun _ -> false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (fun _ -> false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (fun f1 ->
                                             (&&)
                                               (is_cast2_literal_App2
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange)),
                                                 (Compilers.Coq_type.Coq_arrow
                                                 ((Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange)),
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_prod
                                                 ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange),
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange))))))))
                                                 f1)
                                               (is_cast_literal width
                                                 (Compilers.Coq_type.Coq_base
                                                 (Compilers.Coq_base.Coq_type.Coq_type_base
                                                 Coq3_Compilers.Coq_zrange))
                                                 r2))
                                         | Coq3_Compilers.Coq_string ->
                                           (fun _ -> false))
                                      | Compilers.Coq_base.Coq_type.Coq_prod (
                                          _, _) ->
                                        (fun _ -> false)
                                      | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                        (fun _ -> false)
                                      | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                        (fun _ -> false)
                                      | Compilers.Coq_base.Coq_type.Coq_unit ->
                                        (fun _ -> false))
                                   | Coq3_Compilers.Coq_string ->
                                     (fun _ -> false))
                                | Compilers.Coq_base.Coq_type.Coq_prod (
                                    _, _) ->
                                  (fun _ -> false)
                                | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                  (fun _ -> false)
                                | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                  (fun _ -> false)
                                | Compilers.Coq_base.Coq_type.Coq_unit ->
                                  (fun _ -> false))
                             | Compilers.Coq_base.Coq_type.Coq_list _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_option _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_unit ->
                               (fun _ -> false))
                          | Compilers.Coq_type.Coq_arrow (_, _) ->
                            (fun _ -> false))
                       | Coq3_Compilers.Coq_string -> (fun _ -> false))
                    | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
                 | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> false)))
               f0)
         | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
      | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
   | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ _ -> false)) f r1
| Compilers.Coq_expr.LetIn (_, _, _, _) -> false

(** val is_cast2_literal :
    z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let is_cast2_literal width _ = function
| Compilers.Coq_expr.Ident (_, _) -> false
| Compilers.Coq_expr.Var (_, _) -> false
| Compilers.Coq_expr.Abs (_, _, _) -> false
| Compilers.Coq_expr.App (s0, d, f, r2) ->
  (match s0 with
   | Compilers.Coq_type.Coq_base t0 ->
     (match t0 with
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_zrange ->
           (fun f0 r3 ->
             (match d with
              | Compilers.Coq_type.Coq_base t2 ->
                (match t2 with
                 | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                   (fun _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
                   (match a with
                    | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                      (match t3 with
                       | Coq3_Compilers.Z -> (fun _ -> false)
                       | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                       | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                       | Coq3_Compilers.Coq_zrange ->
                         (match b with
                          | Compilers.Coq_base.Coq_type.Coq_type_base t4 ->
                            (match t4 with
                             | Coq3_Compilers.Z -> (fun _ -> false)
                             | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                             | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                             | Coq3_Compilers.Coq_zrange ->
                               (fun f1 ->
                                 (&&)
                                   (is_cast2_literal_App1 width
                                     (Compilers.Coq_type.Coq_arrow
                                     ((Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Coq_zrange)),
                                     (Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_prod
                                     ((Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Coq_zrange),
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Coq_zrange)))))) f1)
                                   (is_cast_literal width
                                     (Compilers.Coq_type.Coq_base
                                     (Compilers.Coq_base.Coq_type.Coq_type_base
                                     Coq3_Compilers.Coq_zrange)) r3))
                             | Coq3_Compilers.Coq_string -> (fun _ -> false))
                          | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                            (fun _ -> false)
                          | Compilers.Coq_base.Coq_type.Coq_list _ ->
                            (fun _ -> false)
                          | Compilers.Coq_base.Coq_type.Coq_option _ ->
                            (fun _ -> false)
                          | Compilers.Coq_base.Coq_type.Coq_unit ->
                            (fun _ -> false))
                       | Coq3_Compilers.Coq_string -> (fun _ -> false))
                    | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
                 | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_option _ ->
                   (fun _ -> false)
                 | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
              | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> false)) f0)
         | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
      | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
   | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ _ -> false)) f r2
| Compilers.Coq_expr.LetIn (_, _, _, _) -> false

(** val is_cast_ident :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> bool **)

let is_cast_ident _ = function
| Coq3_Compilers.Coq_ident_Literal (_, _) -> false
| Coq3_Compilers.Coq_ident_comment _ -> false
| Coq3_Compilers.Coq_ident_comment_no_keep _ -> false
| Coq3_Compilers.Coq_ident_value_barrier -> false
| Coq3_Compilers.Coq_ident_Nat_succ -> false
| Coq3_Compilers.Coq_ident_Nat_pred -> false
| Coq3_Compilers.Coq_ident_Nat_max -> false
| Coq3_Compilers.Coq_ident_Nat_mul -> false
| Coq3_Compilers.Coq_ident_Nat_add -> false
| Coq3_Compilers.Coq_ident_Nat_sub -> false
| Coq3_Compilers.Coq_ident_Nat_eqb -> false
| Coq3_Compilers.Coq_ident_nil _ -> false
| Coq3_Compilers.Coq_ident_cons _ -> false
| Coq3_Compilers.Coq_ident_tt -> false
| Coq3_Compilers.Coq_ident_pair (_, _) -> false
| Coq3_Compilers.Coq_ident_fst (_, _) -> false
| Coq3_Compilers.Coq_ident_snd (_, _) -> false
| Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> false
| Coq3_Compilers.Coq_ident_bool_rect _ -> false
| Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> false
| Coq3_Compilers.Coq_ident_nat_rect _ -> false
| Coq3_Compilers.Coq_ident_eager_nat_rect _ -> false
| Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> false
| Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> false
| Coq3_Compilers.Coq_ident_list_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> false
| Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> false
| Coq3_Compilers.Coq_ident_list_case (_, _) -> false
| Coq3_Compilers.Coq_ident_List_length _ -> false
| Coq3_Compilers.Coq_ident_List_seq -> false
| Coq3_Compilers.Coq_ident_List_firstn _ -> false
| Coq3_Compilers.Coq_ident_List_skipn _ -> false
| Coq3_Compilers.Coq_ident_List_repeat _ -> false
| Coq3_Compilers.Coq_ident_List_combine (_, _) -> false
| Coq3_Compilers.Coq_ident_List_map (_, _) -> false
| Coq3_Compilers.Coq_ident_List_app _ -> false
| Coq3_Compilers.Coq_ident_List_rev _ -> false
| Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> false
| Coq3_Compilers.Coq_ident_List_partition _ -> false
| Coq3_Compilers.Coq_ident_List_filter _ -> false
| Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> false
| Coq3_Compilers.Coq_ident_List_update_nth _ -> false
| Coq3_Compilers.Coq_ident_List_nth_default _ -> false
| Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> false
| Coq3_Compilers.Coq_ident_Z_add -> false
| Coq3_Compilers.Coq_ident_Z_mul -> false
| Coq3_Compilers.Coq_ident_Z_pow -> false
| Coq3_Compilers.Coq_ident_Z_sub -> false
| Coq3_Compilers.Coq_ident_Z_opp -> false
| Coq3_Compilers.Coq_ident_Z_div -> false
| Coq3_Compilers.Coq_ident_Z_modulo -> false
| Coq3_Compilers.Coq_ident_Z_eqb -> false
| Coq3_Compilers.Coq_ident_Z_leb -> false
| Coq3_Compilers.Coq_ident_Z_ltb -> false
| Coq3_Compilers.Coq_ident_Z_geb -> false
| Coq3_Compilers.Coq_ident_Z_gtb -> false
| Coq3_Compilers.Coq_ident_Z_log2 -> false
| Coq3_Compilers.Coq_ident_Z_log2_up -> false
| Coq3_Compilers.Coq_ident_Z_of_nat -> false
| Coq3_Compilers.Coq_ident_Z_to_nat -> false
| Coq3_Compilers.Coq_ident_Z_shiftr -> false
| Coq3_Compilers.Coq_ident_Z_shiftl -> false
| Coq3_Compilers.Coq_ident_Z_land -> false
| Coq3_Compilers.Coq_ident_Z_lor -> false
| Coq3_Compilers.Coq_ident_Z_min -> false
| Coq3_Compilers.Coq_ident_Z_max -> false
| Coq3_Compilers.Coq_ident_Z_mul_split -> false
| Coq3_Compilers.Coq_ident_Z_mul_high -> false
| Coq3_Compilers.Coq_ident_Z_add_get_carry -> false
| Coq3_Compilers.Coq_ident_Z_add_with_carry -> false
| Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> false
| Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> false
| Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> false
| Coq3_Compilers.Coq_ident_Z_ltz -> false
| Coq3_Compilers.Coq_ident_Z_zselect -> false
| Coq3_Compilers.Coq_ident_Z_add_modulo -> false
| Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> false
| Coq3_Compilers.Coq_ident_Z_bneg -> false
| Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
| Coq3_Compilers.Coq_ident_Z_lxor -> false
| Coq3_Compilers.Coq_ident_Z_rshi -> false
| Coq3_Compilers.Coq_ident_Z_cc_m -> false
| Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> false
| Coq3_Compilers.Coq_ident_Z_cast -> true
| Coq3_Compilers.Coq_ident_Z_cast2 -> true
| Coq3_Compilers.Coq_ident_Some _ -> false
| Coq3_Compilers.Coq_ident_None _ -> false
| Coq3_Compilers.Coq_ident_option_rect (_, _) -> false
| Coq3_Compilers.Coq_ident_Build_zrange -> false
| Coq3_Compilers.Coq_ident_zrange_rect _ -> false
| Coq3_Compilers.Coq_ident_fancy_add -> false
| Coq3_Compilers.Coq_ident_fancy_addc -> false
| Coq3_Compilers.Coq_ident_fancy_sub -> false
| Coq3_Compilers.Coq_ident_fancy_subb -> false
| Coq3_Compilers.Coq_ident_fancy_mulll -> false
| Coq3_Compilers.Coq_ident_fancy_mullh -> false
| Coq3_Compilers.Coq_ident_fancy_mulhl -> false
| Coq3_Compilers.Coq_ident_fancy_mulhh -> false
| Coq3_Compilers.Coq_ident_fancy_rshi -> false
| Coq3_Compilers.Coq_ident_fancy_selc -> false
| Coq3_Compilers.Coq_ident_fancy_selm -> false
| Coq3_Compilers.Coq_ident_fancy_sell -> false
| Coq3_Compilers.Coq_ident_fancy_addm -> false

(** val is_cast_ident_expr :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let is_cast_ident_expr _ = function
| Compilers.Coq_expr.Ident (t0, i) -> is_cast_ident t0 i
| Compilers.Coq_expr.Var (_, _) -> false
| Compilers.Coq_expr.Abs (_, _, _) -> false
| Compilers.Coq_expr.App (_, _, _, _) -> false
| Compilers.Coq_expr.LetIn (_, _, _, _) -> false

(** val is_cast :
    z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let is_cast width _ = function
| Compilers.Coq_expr.Ident (_, _) -> false
| Compilers.Coq_expr.Var (_, _) -> false
| Compilers.Coq_expr.Abs (_, _, _) -> false
| Compilers.Coq_expr.App (s0, d, f, r0) ->
  (match s0 with
   | Compilers.Coq_type.Coq_base t0 ->
     (match t0 with
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
         | Coq3_Compilers.Coq_zrange ->
           (fun f0 r1 ->
             (match d with
              | Compilers.Coq_type.Coq_base _ -> (fun _ -> false)
              | Compilers.Coq_type.Coq_arrow (s1, d0) ->
                (match s1 with
                 | Compilers.Coq_type.Coq_base t2 ->
                   (match t2 with
                    | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                      (match t3 with
                       | Coq3_Compilers.Z ->
                         (match d0 with
                          | Compilers.Coq_type.Coq_base t4 ->
                            (match t4 with
                             | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                               (match t5 with
                                | Coq3_Compilers.Z ->
                                  (fun f1 ->
                                    (&&)
                                      (is_cast_ident_expr
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_zrange)),
                                        (Compilers.Coq_type.Coq_arrow
                                        ((Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)),
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Z)))))) f1)
                                      (is_cast_literal width
                                        (Compilers.Coq_type.Coq_base
                                        (Compilers.Coq_base.Coq_type.Coq_type_base
                                        Coq3_Compilers.Coq_zrange)) r1))
                                | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                                | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                                | Coq3_Compilers.Coq_zrange ->
                                  (fun _ -> false)
                                | Coq3_Compilers.Coq_string ->
                                  (fun _ -> false))
                             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_list _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_option _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_unit ->
                               (fun _ -> false))
                          | Compilers.Coq_type.Coq_arrow (_, _) ->
                            (fun _ -> false))
                       | Coq3_Compilers.Coq_bool -> (fun _ -> false)
                       | Coq3_Compilers.Coq_nat -> (fun _ -> false)
                       | Coq3_Compilers.Coq_zrange -> (fun _ -> false)
                       | Coq3_Compilers.Coq_string -> (fun _ -> false))
                    | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                      (fun _ -> false)
                    | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> false))
                 | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> false)))
               f0)
         | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (match a with
         | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
           (match t1 with
            | Coq3_Compilers.Z -> (fun _ _ -> false)
            | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
            | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
            | Coq3_Compilers.Coq_zrange ->
              (match b with
               | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                 (match t2 with
                  | Coq3_Compilers.Z -> (fun _ _ -> false)
                  | Coq3_Compilers.Coq_bool -> (fun _ _ -> false)
                  | Coq3_Compilers.Coq_nat -> (fun _ _ -> false)
                  | Coq3_Compilers.Coq_zrange ->
                    (fun f0 r1 ->
                      (match d with
                       | Compilers.Coq_type.Coq_base _ -> (fun _ -> false)
                       | Compilers.Coq_type.Coq_arrow (s1, d0) ->
                         (match s1 with
                          | Compilers.Coq_type.Coq_base t3 ->
                            (match t3 with
                             | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_prod (
                                 a0, b0) ->
                               (match a0 with
                                | Compilers.Coq_base.Coq_type.Coq_type_base t4 ->
                                  (match t4 with
                                   | Coq3_Compilers.Z ->
                                     (match b0 with
                                      | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                                        (match t5 with
                                         | Coq3_Compilers.Z ->
                                           (match d0 with
                                            | Compilers.Coq_type.Coq_base t6 ->
                                              (match t6 with
                                               | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                                                 (fun _ -> false)
                                               | Compilers.Coq_base.Coq_type.Coq_prod (
                                                   a1, b1) ->
                                                 (match a1 with
                                                  | Compilers.Coq_base.Coq_type.Coq_type_base t7 ->
                                                    (match t7 with
                                                     | Coq3_Compilers.Z ->
                                                       (match b1 with
                                                        | Compilers.Coq_base.Coq_type.Coq_type_base t8 ->
                                                          (match t8 with
                                                           | Coq3_Compilers.Z ->
                                                             (fun f1 ->
                                                               (&&)
                                                                 (is_cast_ident_expr
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Coq_zrange),
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Coq_zrange)))),
                                                                   (Compilers.Coq_type.Coq_arrow
                                                                   ((Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z)))),
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z),
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Z))))))))
                                                                   f1)
                                                                 (is_cast2_literal
                                                                   width
                                                                   (Compilers.Coq_type.Coq_base
                                                                   (Compilers.Coq_base.Coq_type.Coq_prod
                                                                   ((Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Coq_zrange),
                                                                   (Compilers.Coq_base.Coq_type.Coq_type_base
                                                                   Coq3_Compilers.Coq_zrange))))
                                                                   r1))
                                                           | Coq3_Compilers.Coq_bool ->
                                                             (fun _ -> false)
                                                           | Coq3_Compilers.Coq_nat ->
                                                             (fun _ -> false)
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             (fun _ -> false)
                                                           | Coq3_Compilers.Coq_string ->
                                                             (fun _ -> false))
                                                        | Compilers.Coq_base.Coq_type.Coq_prod (
                                                            _, _) ->
                                                          (fun _ -> false)
                                                        | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                          (fun _ -> false)
                                                        | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                          (fun _ -> false)
                                                        | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                          (fun _ -> false))
                                                     | Coq3_Compilers.Coq_bool ->
                                                       (fun _ -> false)
                                                     | Coq3_Compilers.Coq_nat ->
                                                       (fun _ -> false)
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       (fun _ -> false)
                                                     | Coq3_Compilers.Coq_string ->
                                                       (fun _ -> false))
                                                  | Compilers.Coq_base.Coq_type.Coq_prod (
                                                      _, _) ->
                                                    (fun _ -> false)
                                                  | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                    (fun _ -> false)
                                                  | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                    (fun _ -> false)
                                                  | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                    (fun _ -> false))
                                               | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                 (fun _ -> false)
                                               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                 (fun _ -> false)
                                               | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                 (fun _ -> false))
                                            | Compilers.Coq_type.Coq_arrow (
                                                _, _) ->
                                              (fun _ -> false))
                                         | Coq3_Compilers.Coq_bool ->
                                           (fun _ -> false)
                                         | Coq3_Compilers.Coq_nat ->
                                           (fun _ -> false)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (fun _ -> false)
                                         | Coq3_Compilers.Coq_string ->
                                           (fun _ -> false))
                                      | Compilers.Coq_base.Coq_type.Coq_prod (
                                          _, _) ->
                                        (fun _ -> false)
                                      | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                        (fun _ -> false)
                                      | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                        (fun _ -> false)
                                      | Compilers.Coq_base.Coq_type.Coq_unit ->
                                        (fun _ -> false))
                                   | Coq3_Compilers.Coq_bool ->
                                     (fun _ -> false)
                                   | Coq3_Compilers.Coq_nat ->
                                     (fun _ -> false)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (fun _ -> false)
                                   | Coq3_Compilers.Coq_string ->
                                     (fun _ -> false))
                                | Compilers.Coq_base.Coq_type.Coq_prod (
                                    _, _) ->
                                  (fun _ -> false)
                                | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                  (fun _ -> false)
                                | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                  (fun _ -> false)
                                | Compilers.Coq_base.Coq_type.Coq_unit ->
                                  (fun _ -> false))
                             | Compilers.Coq_base.Coq_type.Coq_list _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_option _ ->
                               (fun _ -> false)
                             | Compilers.Coq_base.Coq_type.Coq_unit ->
                               (fun _ -> false))
                          | Compilers.Coq_type.Coq_arrow (_, _) ->
                            (fun _ -> false))) f0)
                  | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                 (fun _ _ -> false)
               | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
            | Coq3_Compilers.Coq_string -> (fun _ _ -> false))
         | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ _ -> false)
         | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
         | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> false)
         | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
      | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> false)
      | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> false))
   | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ _ -> false)) f r0
| Compilers.Coq_expr.LetIn (_, _, _, _) -> false

(** val require_cast_for_arg :
    z -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, 'a1)
    Compilers.Coq_expr.expr -> bool **)

let require_cast_for_arg width _ = function
| Compilers.Coq_expr.Ident (_, idc) ->
  (match idc with
   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
   | Coq3_Compilers.Coq_ident_comment _ -> true
   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
   | Coq3_Compilers.Coq_ident_value_barrier -> true
   | Coq3_Compilers.Coq_ident_Nat_succ -> true
   | Coq3_Compilers.Coq_ident_Nat_pred -> true
   | Coq3_Compilers.Coq_ident_Nat_max -> true
   | Coq3_Compilers.Coq_ident_Nat_mul -> true
   | Coq3_Compilers.Coq_ident_Nat_add -> true
   | Coq3_Compilers.Coq_ident_Nat_sub -> true
   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
   | Coq3_Compilers.Coq_ident_nil _ -> true
   | Coq3_Compilers.Coq_ident_cons _ -> true
   | Coq3_Compilers.Coq_ident_tt -> true
   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> true
   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
   | Coq3_Compilers.Coq_ident_List_length _ -> true
   | Coq3_Compilers.Coq_ident_List_seq -> true
   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
   | Coq3_Compilers.Coq_ident_List_app _ -> true
   | Coq3_Compilers.Coq_ident_List_rev _ -> true
   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
   | Coq3_Compilers.Coq_ident_List_partition _ -> true
   | Coq3_Compilers.Coq_ident_List_filter _ -> true
   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
   | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
   | Coq3_Compilers.Coq_ident_Z_add -> true
   | Coq3_Compilers.Coq_ident_Z_mul -> true
   | Coq3_Compilers.Coq_ident_Z_pow -> true
   | Coq3_Compilers.Coq_ident_Z_sub -> true
   | Coq3_Compilers.Coq_ident_Z_opp -> true
   | Coq3_Compilers.Coq_ident_Z_div -> true
   | Coq3_Compilers.Coq_ident_Z_modulo -> true
   | Coq3_Compilers.Coq_ident_Z_eqb -> true
   | Coq3_Compilers.Coq_ident_Z_leb -> true
   | Coq3_Compilers.Coq_ident_Z_ltb -> true
   | Coq3_Compilers.Coq_ident_Z_geb -> true
   | Coq3_Compilers.Coq_ident_Z_gtb -> true
   | Coq3_Compilers.Coq_ident_Z_log2 -> true
   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
   | Coq3_Compilers.Coq_ident_Z_land -> true
   | Coq3_Compilers.Coq_ident_Z_lor -> true
   | Coq3_Compilers.Coq_ident_Z_min -> true
   | Coq3_Compilers.Coq_ident_Z_max -> true
   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
   | Coq3_Compilers.Coq_ident_Z_mul_high -> false
   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
   | Coq3_Compilers.Coq_ident_Z_ltz -> true
   | Coq3_Compilers.Coq_ident_Z_zselect -> true
   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
   | Coq3_Compilers.Coq_ident_Z_bneg -> true
   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
   | Coq3_Compilers.Coq_ident_Z_lxor -> true
   | Coq3_Compilers.Coq_ident_Z_rshi -> true
   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
   | Coq3_Compilers.Coq_ident_Z_cast -> true
   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
   | Coq3_Compilers.Coq_ident_Some _ -> true
   | Coq3_Compilers.Coq_ident_None _ -> true
   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
   | Coq3_Compilers.Coq_ident_Build_zrange -> true
   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
   | Coq3_Compilers.Coq_ident_fancy_add -> true
   | Coq3_Compilers.Coq_ident_fancy_addc -> true
   | Coq3_Compilers.Coq_ident_fancy_sub -> true
   | Coq3_Compilers.Coq_ident_fancy_subb -> true
   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
   | Coq3_Compilers.Coq_ident_fancy_selc -> true
   | Coq3_Compilers.Coq_ident_fancy_selm -> true
   | Coq3_Compilers.Coq_ident_fancy_sell -> true
   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
| Compilers.Coq_expr.Var (_, _) -> true
| Compilers.Coq_expr.Abs (_, _, _) -> true
| Compilers.Coq_expr.App (s0, d, f, x) ->
  (match s0 with
   | Compilers.Coq_type.Coq_base t0 ->
     (match t0 with
      | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
        (match t1 with
         | Coq3_Compilers.Z ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
         | Coq3_Compilers.Coq_bool ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
         | Coq3_Compilers.Coq_nat ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
         | Coq3_Compilers.Coq_zrange ->
           (fun f0 x0 ->
             (match d with
              | Compilers.Coq_type.Coq_base _ ->
                (fun f1 ->
                  match f1 with
                  | Compilers.Coq_expr.Ident (_, idc) ->
                    (match idc with
                     | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                     | Coq3_Compilers.Coq_ident_comment _ -> true
                     | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                     | Coq3_Compilers.Coq_ident_value_barrier -> true
                     | Coq3_Compilers.Coq_ident_Nat_succ -> true
                     | Coq3_Compilers.Coq_ident_Nat_pred -> true
                     | Coq3_Compilers.Coq_ident_Nat_max -> true
                     | Coq3_Compilers.Coq_ident_Nat_mul -> true
                     | Coq3_Compilers.Coq_ident_Nat_add -> true
                     | Coq3_Compilers.Coq_ident_Nat_sub -> true
                     | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                     | Coq3_Compilers.Coq_ident_nil _ -> true
                     | Coq3_Compilers.Coq_ident_cons _ -> true
                     | Coq3_Compilers.Coq_ident_tt -> true
                     | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                     | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                     | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                     | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                     | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                     | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                     | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                     | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                     | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                     | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                       true
                     | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                     | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                     | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                       true
                     | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                         _, _, _) ->
                       true
                     | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                     | Coq3_Compilers.Coq_ident_List_length _ -> true
                     | Coq3_Compilers.Coq_ident_List_seq -> true
                     | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                     | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                     | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                     | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                     | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                     | Coq3_Compilers.Coq_ident_List_app _ -> true
                     | Coq3_Compilers.Coq_ident_List_rev _ -> true
                     | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                     | Coq3_Compilers.Coq_ident_List_partition _ -> true
                     | Coq3_Compilers.Coq_ident_List_filter _ -> true
                     | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                     | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                     | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                     | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                       true
                     | Coq3_Compilers.Coq_ident_Z_add -> true
                     | Coq3_Compilers.Coq_ident_Z_mul -> true
                     | Coq3_Compilers.Coq_ident_Z_pow -> true
                     | Coq3_Compilers.Coq_ident_Z_sub -> true
                     | Coq3_Compilers.Coq_ident_Z_opp -> true
                     | Coq3_Compilers.Coq_ident_Z_div -> true
                     | Coq3_Compilers.Coq_ident_Z_modulo -> true
                     | Coq3_Compilers.Coq_ident_Z_eqb -> true
                     | Coq3_Compilers.Coq_ident_Z_leb -> true
                     | Coq3_Compilers.Coq_ident_Z_ltb -> true
                     | Coq3_Compilers.Coq_ident_Z_geb -> true
                     | Coq3_Compilers.Coq_ident_Z_gtb -> true
                     | Coq3_Compilers.Coq_ident_Z_log2 -> true
                     | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                     | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                     | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                     | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                     | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                     | Coq3_Compilers.Coq_ident_Z_land -> true
                     | Coq3_Compilers.Coq_ident_Z_lor -> true
                     | Coq3_Compilers.Coq_ident_Z_min -> true
                     | Coq3_Compilers.Coq_ident_Z_max -> true
                     | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                     | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                     | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                     | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                     | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                     | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                     | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                     | Coq3_Compilers.Coq_ident_Z_ltz -> true
                     | Coq3_Compilers.Coq_ident_Z_zselect -> true
                     | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                     | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                     | Coq3_Compilers.Coq_ident_Z_bneg -> true
                     | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                     | Coq3_Compilers.Coq_ident_Z_lxor -> true
                     | Coq3_Compilers.Coq_ident_Z_rshi -> true
                     | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                     | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                     | Coq3_Compilers.Coq_ident_Z_cast -> true
                     | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                     | Coq3_Compilers.Coq_ident_Some _ -> true
                     | Coq3_Compilers.Coq_ident_None _ -> true
                     | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                     | Coq3_Compilers.Coq_ident_Build_zrange -> true
                     | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                     | Coq3_Compilers.Coq_ident_fancy_add -> true
                     | Coq3_Compilers.Coq_ident_fancy_addc -> true
                     | Coq3_Compilers.Coq_ident_fancy_sub -> true
                     | Coq3_Compilers.Coq_ident_fancy_subb -> true
                     | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                     | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                     | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                     | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                     | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                     | Coq3_Compilers.Coq_ident_fancy_selc -> true
                     | Coq3_Compilers.Coq_ident_fancy_selm -> true
                     | Coq3_Compilers.Coq_ident_fancy_sell -> true
                     | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                  | Compilers.Coq_expr.Var (_, _) -> true
                  | Compilers.Coq_expr.Abs (_, _, _) -> true
                  | Compilers.Coq_expr.App (_, _, f2, _) ->
                    (match f2 with
                     | Compilers.Coq_expr.Ident (_, idc) ->
                       (match idc with
                        | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                        | Coq3_Compilers.Coq_ident_comment _ -> true
                        | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                        | Coq3_Compilers.Coq_ident_value_barrier -> true
                        | Coq3_Compilers.Coq_ident_Nat_succ -> true
                        | Coq3_Compilers.Coq_ident_Nat_pred -> true
                        | Coq3_Compilers.Coq_ident_Nat_max -> true
                        | Coq3_Compilers.Coq_ident_Nat_mul -> true
                        | Coq3_Compilers.Coq_ident_Nat_add -> true
                        | Coq3_Compilers.Coq_ident_Nat_sub -> true
                        | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                        | Coq3_Compilers.Coq_ident_nil _ -> true
                        | Coq3_Compilers.Coq_ident_cons _ -> true
                        | Coq3_Compilers.Coq_ident_tt -> true
                        | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                        | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                        | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                        | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                        | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                        | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                        | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                        | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                        | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                            _, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                        | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                            _, _, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                        | Coq3_Compilers.Coq_ident_List_length _ -> true
                        | Coq3_Compilers.Coq_ident_List_seq -> true
                        | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                        | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                        | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                        | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                        | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                        | Coq3_Compilers.Coq_ident_List_app _ -> true
                        | Coq3_Compilers.Coq_ident_List_rev _ -> true
                        | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_List_partition _ -> true
                        | Coq3_Compilers.Coq_ident_List_filter _ -> true
                        | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                        | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                        | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_add -> true
                        | Coq3_Compilers.Coq_ident_Z_mul -> true
                        | Coq3_Compilers.Coq_ident_Z_pow -> true
                        | Coq3_Compilers.Coq_ident_Z_sub -> true
                        | Coq3_Compilers.Coq_ident_Z_opp -> true
                        | Coq3_Compilers.Coq_ident_Z_div -> true
                        | Coq3_Compilers.Coq_ident_Z_modulo -> true
                        | Coq3_Compilers.Coq_ident_Z_eqb -> true
                        | Coq3_Compilers.Coq_ident_Z_leb -> true
                        | Coq3_Compilers.Coq_ident_Z_ltb -> true
                        | Coq3_Compilers.Coq_ident_Z_geb -> true
                        | Coq3_Compilers.Coq_ident_Z_gtb -> true
                        | Coq3_Compilers.Coq_ident_Z_log2 -> true
                        | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                        | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                        | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                        | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                        | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                        | Coq3_Compilers.Coq_ident_Z_land -> true
                        | Coq3_Compilers.Coq_ident_Z_lor -> true
                        | Coq3_Compilers.Coq_ident_Z_min -> true
                        | Coq3_Compilers.Coq_ident_Z_max -> true
                        | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                        | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                        | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                        | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_ltz -> true
                        | Coq3_Compilers.Coq_ident_Z_zselect -> true
                        | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                        | Coq3_Compilers.Coq_ident_Z_bneg -> true
                        | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                        | Coq3_Compilers.Coq_ident_Z_lxor -> true
                        | Coq3_Compilers.Coq_ident_Z_rshi -> true
                        | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_cast -> true
                        | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                        | Coq3_Compilers.Coq_ident_Some _ -> true
                        | Coq3_Compilers.Coq_ident_None _ -> true
                        | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                        | Coq3_Compilers.Coq_ident_Build_zrange -> true
                        | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                        | Coq3_Compilers.Coq_ident_fancy_add -> true
                        | Coq3_Compilers.Coq_ident_fancy_addc -> true
                        | Coq3_Compilers.Coq_ident_fancy_sub -> true
                        | Coq3_Compilers.Coq_ident_fancy_subb -> true
                        | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                        | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                        | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                        | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                        | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                        | Coq3_Compilers.Coq_ident_fancy_selc -> true
                        | Coq3_Compilers.Coq_ident_fancy_selm -> true
                        | Coq3_Compilers.Coq_ident_fancy_sell -> true
                        | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                     | Compilers.Coq_expr.Var (_, _) -> true
                     | Compilers.Coq_expr.Abs (_, _, _) -> true
                     | Compilers.Coq_expr.App (_, _, _, _) -> true
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                  | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
              | Compilers.Coq_type.Coq_arrow (s1, d0) ->
                (match s1 with
                 | Compilers.Coq_type.Coq_base t2 ->
                   (match t2 with
                    | Compilers.Coq_base.Coq_type.Coq_type_base t3 ->
                      (match t3 with
                       | Coq3_Compilers.Z ->
                         (match d0 with
                          | Compilers.Coq_type.Coq_base t4 ->
                            (match t4 with
                             | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                               (match t5 with
                                | Coq3_Compilers.Z ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         (match x0 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc0) ->
                                            (match idc0 with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 t8, r0) ->
                                               (match t8 with
                                                | Coq3_Compilers.Z ->
                                                  (fun _ -> true)
                                                | Coq3_Compilers.Coq_bool ->
                                                  (fun _ -> true)
                                                | Coq3_Compilers.Coq_nat ->
                                                  (fun _ -> true)
                                                | Coq3_Compilers.Coq_zrange ->
                                                  (fun r1 ->
                                                    negb
                                                      (range_good width
                                                        (Obj.magic r1)))
                                                | Coq3_Compilers.Coq_string ->
                                                  (fun _ -> true)) r0
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, _, _) ->
                                            true
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) -> true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) -> true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                | Coq3_Compilers.Coq_bool ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) -> true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) -> true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                | Coq3_Compilers.Coq_nat ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) -> true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) -> true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                | Coq3_Compilers.Coq_zrange ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) -> true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) -> true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                | Coq3_Compilers.Coq_string ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) -> true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true))
                             | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                             | Compilers.Coq_base.Coq_type.Coq_list _ ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                             | Compilers.Coq_base.Coq_type.Coq_option _ ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                             | Compilers.Coq_base.Coq_type.Coq_unit ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true))
                          | Compilers.Coq_type.Coq_arrow (_, _) ->
                            (fun f1 ->
                              match f1 with
                              | Compilers.Coq_expr.Ident (_, idc) ->
                                (match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_comment _ -> true
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> true
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> true
                                 | Coq3_Compilers.Coq_ident_Nat_max -> true
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> true
                                 | Coq3_Compilers.Coq_ident_Nat_add -> true
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> true
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                                 | Coq3_Compilers.Coq_ident_nil _ -> true
                                 | Coq3_Compilers.Coq_ident_cons _ -> true
                                 | Coq3_Compilers.Coq_ident_tt -> true
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_seq -> true
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul -> true
                                 | Coq3_Compilers.Coq_ident_Z_pow -> true
                                 | Coq3_Compilers.Coq_ident_Z_sub -> true
                                 | Coq3_Compilers.Coq_ident_Z_opp -> true
                                 | Coq3_Compilers.Coq_ident_Z_div -> true
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> true
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                 | Coq3_Compilers.Coq_ident_Z_leb -> true
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                 | Coq3_Compilers.Coq_ident_Z_geb -> true
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                                 | Coq3_Compilers.Coq_ident_Z_land -> true
                                 | Coq3_Compilers.Coq_ident_Z_lor -> true
                                 | Coq3_Compilers.Coq_ident_Z_min -> true
                                 | Coq3_Compilers.Coq_ident_Z_max -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> true
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_cast -> true
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> true
                                 | Coq3_Compilers.Coq_ident_None _ -> true
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   true
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_add -> true
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> true
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   true)
                              | Compilers.Coq_expr.Var (_, _) -> true
                              | Compilers.Coq_expr.Abs (_, _, _) -> true
                              | Compilers.Coq_expr.App (_, _, f2, _) ->
                                (match f2 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      false
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, _, _) ->
                                   true
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
                       | Coq3_Compilers.Coq_bool ->
                         (fun f1 ->
                           match f1 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                false
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, f2, _) ->
                             (match f2 with
                              | Compilers.Coq_expr.Ident (_, idc) ->
                                (match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_comment _ -> true
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> true
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> true
                                 | Coq3_Compilers.Coq_ident_Nat_max -> true
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> true
                                 | Coq3_Compilers.Coq_ident_Nat_add -> true
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> true
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                                 | Coq3_Compilers.Coq_ident_nil _ -> true
                                 | Coq3_Compilers.Coq_ident_cons _ -> true
                                 | Coq3_Compilers.Coq_ident_tt -> true
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_seq -> true
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul -> true
                                 | Coq3_Compilers.Coq_ident_Z_pow -> true
                                 | Coq3_Compilers.Coq_ident_Z_sub -> true
                                 | Coq3_Compilers.Coq_ident_Z_opp -> true
                                 | Coq3_Compilers.Coq_ident_Z_div -> true
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> true
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                 | Coq3_Compilers.Coq_ident_Z_leb -> true
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                 | Coq3_Compilers.Coq_ident_Z_geb -> true
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                                 | Coq3_Compilers.Coq_ident_Z_land -> true
                                 | Coq3_Compilers.Coq_ident_Z_lor -> true
                                 | Coq3_Compilers.Coq_ident_Z_min -> true
                                 | Coq3_Compilers.Coq_ident_Z_max -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> true
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_cast -> true
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> true
                                 | Coq3_Compilers.Coq_ident_None _ -> true
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   true
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_add -> true
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> true
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   true)
                              | Compilers.Coq_expr.Var (_, _) -> true
                              | Compilers.Coq_expr.Abs (_, _, _) -> true
                              | Compilers.Coq_expr.App (_, _, _, _) -> true
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                       | Coq3_Compilers.Coq_nat ->
                         (fun f1 ->
                           match f1 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                false
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, f2, _) ->
                             (match f2 with
                              | Compilers.Coq_expr.Ident (_, idc) ->
                                (match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_comment _ -> true
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> true
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> true
                                 | Coq3_Compilers.Coq_ident_Nat_max -> true
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> true
                                 | Coq3_Compilers.Coq_ident_Nat_add -> true
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> true
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                                 | Coq3_Compilers.Coq_ident_nil _ -> true
                                 | Coq3_Compilers.Coq_ident_cons _ -> true
                                 | Coq3_Compilers.Coq_ident_tt -> true
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_seq -> true
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul -> true
                                 | Coq3_Compilers.Coq_ident_Z_pow -> true
                                 | Coq3_Compilers.Coq_ident_Z_sub -> true
                                 | Coq3_Compilers.Coq_ident_Z_opp -> true
                                 | Coq3_Compilers.Coq_ident_Z_div -> true
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> true
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                 | Coq3_Compilers.Coq_ident_Z_leb -> true
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                 | Coq3_Compilers.Coq_ident_Z_geb -> true
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                                 | Coq3_Compilers.Coq_ident_Z_land -> true
                                 | Coq3_Compilers.Coq_ident_Z_lor -> true
                                 | Coq3_Compilers.Coq_ident_Z_min -> true
                                 | Coq3_Compilers.Coq_ident_Z_max -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> true
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_cast -> true
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> true
                                 | Coq3_Compilers.Coq_ident_None _ -> true
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   true
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_add -> true
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> true
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   true)
                              | Compilers.Coq_expr.Var (_, _) -> true
                              | Compilers.Coq_expr.Abs (_, _, _) -> true
                              | Compilers.Coq_expr.App (_, _, _, _) -> true
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                       | Coq3_Compilers.Coq_zrange ->
                         (fun f1 ->
                           match f1 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                false
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, f2, _) ->
                             (match f2 with
                              | Compilers.Coq_expr.Ident (_, idc) ->
                                (match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_comment _ -> true
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> true
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> true
                                 | Coq3_Compilers.Coq_ident_Nat_max -> true
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> true
                                 | Coq3_Compilers.Coq_ident_Nat_add -> true
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> true
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                                 | Coq3_Compilers.Coq_ident_nil _ -> true
                                 | Coq3_Compilers.Coq_ident_cons _ -> true
                                 | Coq3_Compilers.Coq_ident_tt -> true
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_seq -> true
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul -> true
                                 | Coq3_Compilers.Coq_ident_Z_pow -> true
                                 | Coq3_Compilers.Coq_ident_Z_sub -> true
                                 | Coq3_Compilers.Coq_ident_Z_opp -> true
                                 | Coq3_Compilers.Coq_ident_Z_div -> true
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> true
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                 | Coq3_Compilers.Coq_ident_Z_leb -> true
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                 | Coq3_Compilers.Coq_ident_Z_geb -> true
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                                 | Coq3_Compilers.Coq_ident_Z_land -> true
                                 | Coq3_Compilers.Coq_ident_Z_lor -> true
                                 | Coq3_Compilers.Coq_ident_Z_min -> true
                                 | Coq3_Compilers.Coq_ident_Z_max -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> true
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_cast -> true
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> true
                                 | Coq3_Compilers.Coq_ident_None _ -> true
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   true
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_add -> true
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> true
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   true)
                              | Compilers.Coq_expr.Var (_, _) -> true
                              | Compilers.Coq_expr.Abs (_, _, _) -> true
                              | Compilers.Coq_expr.App (_, _, _, _) -> true
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                       | Coq3_Compilers.Coq_string ->
                         (fun f1 ->
                           match f1 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                false
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, f2, _) ->
                             (match f2 with
                              | Compilers.Coq_expr.Ident (_, idc) ->
                                (match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_comment _ -> true
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> true
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> true
                                 | Coq3_Compilers.Coq_ident_Nat_max -> true
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> true
                                 | Coq3_Compilers.Coq_ident_Nat_add -> true
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> true
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                                 | Coq3_Compilers.Coq_ident_nil _ -> true
                                 | Coq3_Compilers.Coq_ident_cons _ -> true
                                 | Coq3_Compilers.Coq_ident_tt -> true
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_seq -> true
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul -> true
                                 | Coq3_Compilers.Coq_ident_Z_pow -> true
                                 | Coq3_Compilers.Coq_ident_Z_sub -> true
                                 | Coq3_Compilers.Coq_ident_Z_opp -> true
                                 | Coq3_Compilers.Coq_ident_Z_div -> true
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> true
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                 | Coq3_Compilers.Coq_ident_Z_leb -> true
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                 | Coq3_Compilers.Coq_ident_Z_geb -> true
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                                 | Coq3_Compilers.Coq_ident_Z_land -> true
                                 | Coq3_Compilers.Coq_ident_Z_lor -> true
                                 | Coq3_Compilers.Coq_ident_Z_min -> true
                                 | Coq3_Compilers.Coq_ident_Z_max -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> true
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_cast -> true
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> true
                                 | Coq3_Compilers.Coq_ident_None _ -> true
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   true
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_add -> true
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> true
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   true)
                              | Compilers.Coq_expr.Var (_, _) -> true
                              | Compilers.Coq_expr.Abs (_, _, _) -> true
                              | Compilers.Coq_expr.App (_, _, _, _) -> true
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
                    | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                      (fun f1 ->
                        match f1 with
                        | Compilers.Coq_expr.Ident (_, idc) ->
                          (match idc with
                           | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                           | Coq3_Compilers.Coq_ident_comment _ -> true
                           | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_value_barrier -> true
                           | Coq3_Compilers.Coq_ident_Nat_succ -> true
                           | Coq3_Compilers.Coq_ident_Nat_pred -> true
                           | Coq3_Compilers.Coq_ident_Nat_max -> true
                           | Coq3_Compilers.Coq_ident_Nat_mul -> true
                           | Coq3_Compilers.Coq_ident_Nat_add -> true
                           | Coq3_Compilers.Coq_ident_Nat_sub -> true
                           | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                           | Coq3_Compilers.Coq_ident_nil _ -> true
                           | Coq3_Compilers.Coq_ident_cons _ -> true
                           | Coq3_Compilers.Coq_ident_tt -> true
                           | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                           | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                           | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_length _ -> true
                           | Coq3_Compilers.Coq_ident_List_seq -> true
                           | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                           | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                           | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                           | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                           | Coq3_Compilers.Coq_ident_List_app _ -> true
                           | Coq3_Compilers.Coq_ident_List_rev _ -> true
                           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_partition _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_filter _ -> true
                           | Coq3_Compilers.Coq_ident_List_fold_right (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add -> true
                           | Coq3_Compilers.Coq_ident_Z_mul -> true
                           | Coq3_Compilers.Coq_ident_Z_pow -> true
                           | Coq3_Compilers.Coq_ident_Z_sub -> true
                           | Coq3_Compilers.Coq_ident_Z_opp -> true
                           | Coq3_Compilers.Coq_ident_Z_div -> true
                           | Coq3_Compilers.Coq_ident_Z_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_eqb -> true
                           | Coq3_Compilers.Coq_ident_Z_leb -> true
                           | Coq3_Compilers.Coq_ident_Z_ltb -> true
                           | Coq3_Compilers.Coq_ident_Z_geb -> true
                           | Coq3_Compilers.Coq_ident_Z_gtb -> true
                           | Coq3_Compilers.Coq_ident_Z_log2 -> true
                           | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                           | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                           | Coq3_Compilers.Coq_ident_Z_land -> true
                           | Coq3_Compilers.Coq_ident_Z_lor -> true
                           | Coq3_Compilers.Coq_ident_Z_min -> true
                           | Coq3_Compilers.Coq_ident_Z_max -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                           | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_ltz -> true
                           | Coq3_Compilers.Coq_ident_Z_zselect -> true
                           | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_bneg -> true
                           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                           | Coq3_Compilers.Coq_ident_Z_lxor -> true
                           | Coq3_Compilers.Coq_ident_Z_rshi -> true
                           | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_cast -> true
                           | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                           | Coq3_Compilers.Coq_ident_Some _ -> true
                           | Coq3_Compilers.Coq_ident_None _ -> true
                           | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_Build_zrange -> true
                           | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                           | Coq3_Compilers.Coq_ident_fancy_add -> true
                           | Coq3_Compilers.Coq_ident_fancy_addc -> true
                           | Coq3_Compilers.Coq_ident_fancy_sub -> true
                           | Coq3_Compilers.Coq_ident_fancy_subb -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                           | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                           | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                           | Coq3_Compilers.Coq_ident_fancy_selc -> true
                           | Coq3_Compilers.Coq_ident_fancy_selm -> true
                           | Coq3_Compilers.Coq_ident_fancy_sell -> true
                           | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                        | Compilers.Coq_expr.Var (_, _) -> true
                        | Compilers.Coq_expr.Abs (_, _, _) -> true
                        | Compilers.Coq_expr.App (_, _, f2, _) ->
                          (match f2 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                false
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, _, _) -> true
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                      (fun f1 ->
                        match f1 with
                        | Compilers.Coq_expr.Ident (_, idc) ->
                          (match idc with
                           | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                           | Coq3_Compilers.Coq_ident_comment _ -> true
                           | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_value_barrier -> true
                           | Coq3_Compilers.Coq_ident_Nat_succ -> true
                           | Coq3_Compilers.Coq_ident_Nat_pred -> true
                           | Coq3_Compilers.Coq_ident_Nat_max -> true
                           | Coq3_Compilers.Coq_ident_Nat_mul -> true
                           | Coq3_Compilers.Coq_ident_Nat_add -> true
                           | Coq3_Compilers.Coq_ident_Nat_sub -> true
                           | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                           | Coq3_Compilers.Coq_ident_nil _ -> true
                           | Coq3_Compilers.Coq_ident_cons _ -> true
                           | Coq3_Compilers.Coq_ident_tt -> true
                           | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                           | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                           | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_length _ -> true
                           | Coq3_Compilers.Coq_ident_List_seq -> true
                           | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                           | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                           | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                           | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                           | Coq3_Compilers.Coq_ident_List_app _ -> true
                           | Coq3_Compilers.Coq_ident_List_rev _ -> true
                           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_partition _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_filter _ -> true
                           | Coq3_Compilers.Coq_ident_List_fold_right (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add -> true
                           | Coq3_Compilers.Coq_ident_Z_mul -> true
                           | Coq3_Compilers.Coq_ident_Z_pow -> true
                           | Coq3_Compilers.Coq_ident_Z_sub -> true
                           | Coq3_Compilers.Coq_ident_Z_opp -> true
                           | Coq3_Compilers.Coq_ident_Z_div -> true
                           | Coq3_Compilers.Coq_ident_Z_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_eqb -> true
                           | Coq3_Compilers.Coq_ident_Z_leb -> true
                           | Coq3_Compilers.Coq_ident_Z_ltb -> true
                           | Coq3_Compilers.Coq_ident_Z_geb -> true
                           | Coq3_Compilers.Coq_ident_Z_gtb -> true
                           | Coq3_Compilers.Coq_ident_Z_log2 -> true
                           | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                           | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                           | Coq3_Compilers.Coq_ident_Z_land -> true
                           | Coq3_Compilers.Coq_ident_Z_lor -> true
                           | Coq3_Compilers.Coq_ident_Z_min -> true
                           | Coq3_Compilers.Coq_ident_Z_max -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                           | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_ltz -> true
                           | Coq3_Compilers.Coq_ident_Z_zselect -> true
                           | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_bneg -> true
                           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                           | Coq3_Compilers.Coq_ident_Z_lxor -> true
                           | Coq3_Compilers.Coq_ident_Z_rshi -> true
                           | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_cast -> true
                           | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                           | Coq3_Compilers.Coq_ident_Some _ -> true
                           | Coq3_Compilers.Coq_ident_None _ -> true
                           | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_Build_zrange -> true
                           | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                           | Coq3_Compilers.Coq_ident_fancy_add -> true
                           | Coq3_Compilers.Coq_ident_fancy_addc -> true
                           | Coq3_Compilers.Coq_ident_fancy_sub -> true
                           | Coq3_Compilers.Coq_ident_fancy_subb -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                           | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                           | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                           | Coq3_Compilers.Coq_ident_fancy_selc -> true
                           | Coq3_Compilers.Coq_ident_fancy_selm -> true
                           | Coq3_Compilers.Coq_ident_fancy_sell -> true
                           | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                        | Compilers.Coq_expr.Var (_, _) -> true
                        | Compilers.Coq_expr.Abs (_, _, _) -> true
                        | Compilers.Coq_expr.App (_, _, f2, _) ->
                          (match f2 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                false
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, _, _) -> true
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                      (fun f1 ->
                        match f1 with
                        | Compilers.Coq_expr.Ident (_, idc) ->
                          (match idc with
                           | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                           | Coq3_Compilers.Coq_ident_comment _ -> true
                           | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_value_barrier -> true
                           | Coq3_Compilers.Coq_ident_Nat_succ -> true
                           | Coq3_Compilers.Coq_ident_Nat_pred -> true
                           | Coq3_Compilers.Coq_ident_Nat_max -> true
                           | Coq3_Compilers.Coq_ident_Nat_mul -> true
                           | Coq3_Compilers.Coq_ident_Nat_add -> true
                           | Coq3_Compilers.Coq_ident_Nat_sub -> true
                           | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                           | Coq3_Compilers.Coq_ident_nil _ -> true
                           | Coq3_Compilers.Coq_ident_cons _ -> true
                           | Coq3_Compilers.Coq_ident_tt -> true
                           | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                           | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                           | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_length _ -> true
                           | Coq3_Compilers.Coq_ident_List_seq -> true
                           | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                           | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                           | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                           | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                           | Coq3_Compilers.Coq_ident_List_app _ -> true
                           | Coq3_Compilers.Coq_ident_List_rev _ -> true
                           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_partition _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_filter _ -> true
                           | Coq3_Compilers.Coq_ident_List_fold_right (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add -> true
                           | Coq3_Compilers.Coq_ident_Z_mul -> true
                           | Coq3_Compilers.Coq_ident_Z_pow -> true
                           | Coq3_Compilers.Coq_ident_Z_sub -> true
                           | Coq3_Compilers.Coq_ident_Z_opp -> true
                           | Coq3_Compilers.Coq_ident_Z_div -> true
                           | Coq3_Compilers.Coq_ident_Z_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_eqb -> true
                           | Coq3_Compilers.Coq_ident_Z_leb -> true
                           | Coq3_Compilers.Coq_ident_Z_ltb -> true
                           | Coq3_Compilers.Coq_ident_Z_geb -> true
                           | Coq3_Compilers.Coq_ident_Z_gtb -> true
                           | Coq3_Compilers.Coq_ident_Z_log2 -> true
                           | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                           | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                           | Coq3_Compilers.Coq_ident_Z_land -> true
                           | Coq3_Compilers.Coq_ident_Z_lor -> true
                           | Coq3_Compilers.Coq_ident_Z_min -> true
                           | Coq3_Compilers.Coq_ident_Z_max -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                           | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_ltz -> true
                           | Coq3_Compilers.Coq_ident_Z_zselect -> true
                           | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_bneg -> true
                           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                           | Coq3_Compilers.Coq_ident_Z_lxor -> true
                           | Coq3_Compilers.Coq_ident_Z_rshi -> true
                           | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_cast -> true
                           | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                           | Coq3_Compilers.Coq_ident_Some _ -> true
                           | Coq3_Compilers.Coq_ident_None _ -> true
                           | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_Build_zrange -> true
                           | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                           | Coq3_Compilers.Coq_ident_fancy_add -> true
                           | Coq3_Compilers.Coq_ident_fancy_addc -> true
                           | Coq3_Compilers.Coq_ident_fancy_sub -> true
                           | Coq3_Compilers.Coq_ident_fancy_subb -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                           | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                           | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                           | Coq3_Compilers.Coq_ident_fancy_selc -> true
                           | Coq3_Compilers.Coq_ident_fancy_selm -> true
                           | Coq3_Compilers.Coq_ident_fancy_sell -> true
                           | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                        | Compilers.Coq_expr.Var (_, _) -> true
                        | Compilers.Coq_expr.Abs (_, _, _) -> true
                        | Compilers.Coq_expr.App (_, _, f2, _) ->
                          (match f2 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                false
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, _, _) -> true
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                      (fun f1 ->
                        match f1 with
                        | Compilers.Coq_expr.Ident (_, idc) ->
                          (match idc with
                           | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                           | Coq3_Compilers.Coq_ident_comment _ -> true
                           | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_value_barrier -> true
                           | Coq3_Compilers.Coq_ident_Nat_succ -> true
                           | Coq3_Compilers.Coq_ident_Nat_pred -> true
                           | Coq3_Compilers.Coq_ident_Nat_max -> true
                           | Coq3_Compilers.Coq_ident_Nat_mul -> true
                           | Coq3_Compilers.Coq_ident_Nat_add -> true
                           | Coq3_Compilers.Coq_ident_Nat_sub -> true
                           | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                           | Coq3_Compilers.Coq_ident_nil _ -> true
                           | Coq3_Compilers.Coq_ident_cons _ -> true
                           | Coq3_Compilers.Coq_ident_tt -> true
                           | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                           | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                           | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_length _ -> true
                           | Coq3_Compilers.Coq_ident_List_seq -> true
                           | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                           | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                           | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                           | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                           | Coq3_Compilers.Coq_ident_List_app _ -> true
                           | Coq3_Compilers.Coq_ident_List_rev _ -> true
                           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_partition _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_filter _ -> true
                           | Coq3_Compilers.Coq_ident_List_fold_right (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add -> true
                           | Coq3_Compilers.Coq_ident_Z_mul -> true
                           | Coq3_Compilers.Coq_ident_Z_pow -> true
                           | Coq3_Compilers.Coq_ident_Z_sub -> true
                           | Coq3_Compilers.Coq_ident_Z_opp -> true
                           | Coq3_Compilers.Coq_ident_Z_div -> true
                           | Coq3_Compilers.Coq_ident_Z_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_eqb -> true
                           | Coq3_Compilers.Coq_ident_Z_leb -> true
                           | Coq3_Compilers.Coq_ident_Z_ltb -> true
                           | Coq3_Compilers.Coq_ident_Z_geb -> true
                           | Coq3_Compilers.Coq_ident_Z_gtb -> true
                           | Coq3_Compilers.Coq_ident_Z_log2 -> true
                           | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                           | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                           | Coq3_Compilers.Coq_ident_Z_land -> true
                           | Coq3_Compilers.Coq_ident_Z_lor -> true
                           | Coq3_Compilers.Coq_ident_Z_min -> true
                           | Coq3_Compilers.Coq_ident_Z_max -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                           | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_ltz -> true
                           | Coq3_Compilers.Coq_ident_Z_zselect -> true
                           | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_bneg -> true
                           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                           | Coq3_Compilers.Coq_ident_Z_lxor -> true
                           | Coq3_Compilers.Coq_ident_Z_rshi -> true
                           | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_cast -> true
                           | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                           | Coq3_Compilers.Coq_ident_Some _ -> true
                           | Coq3_Compilers.Coq_ident_None _ -> true
                           | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_Build_zrange -> true
                           | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                           | Coq3_Compilers.Coq_ident_fancy_add -> true
                           | Coq3_Compilers.Coq_ident_fancy_addc -> true
                           | Coq3_Compilers.Coq_ident_fancy_sub -> true
                           | Coq3_Compilers.Coq_ident_fancy_subb -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                           | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                           | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                           | Coq3_Compilers.Coq_ident_fancy_selc -> true
                           | Coq3_Compilers.Coq_ident_fancy_selm -> true
                           | Coq3_Compilers.Coq_ident_fancy_sell -> true
                           | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                        | Compilers.Coq_expr.Var (_, _) -> true
                        | Compilers.Coq_expr.Abs (_, _, _) -> true
                        | Compilers.Coq_expr.App (_, _, f2, _) ->
                          (match f2 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                false
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, _, _) -> true
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
                 | Compilers.Coq_type.Coq_arrow (_, _) ->
                   (fun f1 ->
                     match f1 with
                     | Compilers.Coq_expr.Ident (_, idc) ->
                       (match idc with
                        | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                        | Coq3_Compilers.Coq_ident_comment _ -> true
                        | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                        | Coq3_Compilers.Coq_ident_value_barrier -> true
                        | Coq3_Compilers.Coq_ident_Nat_succ -> true
                        | Coq3_Compilers.Coq_ident_Nat_pred -> true
                        | Coq3_Compilers.Coq_ident_Nat_max -> true
                        | Coq3_Compilers.Coq_ident_Nat_mul -> true
                        | Coq3_Compilers.Coq_ident_Nat_add -> true
                        | Coq3_Compilers.Coq_ident_Nat_sub -> true
                        | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                        | Coq3_Compilers.Coq_ident_nil _ -> true
                        | Coq3_Compilers.Coq_ident_cons _ -> true
                        | Coq3_Compilers.Coq_ident_tt -> true
                        | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                        | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                        | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                        | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                        | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                        | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                        | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                        | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                            _, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                        | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                            _, _, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                        | Coq3_Compilers.Coq_ident_List_length _ -> true
                        | Coq3_Compilers.Coq_ident_List_seq -> true
                        | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                        | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                        | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                        | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                        | Coq3_Compilers.Coq_ident_List_app _ -> true
                        | Coq3_Compilers.Coq_ident_List_rev _ -> true
                        | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_List_partition _ -> true
                        | Coq3_Compilers.Coq_ident_List_filter _ -> true
                        | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                          true
                        | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                        | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                        | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_add -> true
                        | Coq3_Compilers.Coq_ident_Z_mul -> true
                        | Coq3_Compilers.Coq_ident_Z_pow -> true
                        | Coq3_Compilers.Coq_ident_Z_sub -> true
                        | Coq3_Compilers.Coq_ident_Z_opp -> true
                        | Coq3_Compilers.Coq_ident_Z_div -> true
                        | Coq3_Compilers.Coq_ident_Z_modulo -> true
                        | Coq3_Compilers.Coq_ident_Z_eqb -> true
                        | Coq3_Compilers.Coq_ident_Z_leb -> true
                        | Coq3_Compilers.Coq_ident_Z_ltb -> true
                        | Coq3_Compilers.Coq_ident_Z_geb -> true
                        | Coq3_Compilers.Coq_ident_Z_gtb -> true
                        | Coq3_Compilers.Coq_ident_Z_log2 -> true
                        | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                        | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                        | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                        | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                        | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                        | Coq3_Compilers.Coq_ident_Z_land -> true
                        | Coq3_Compilers.Coq_ident_Z_lor -> true
                        | Coq3_Compilers.Coq_ident_Z_min -> true
                        | Coq3_Compilers.Coq_ident_Z_max -> true
                        | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                        | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                        | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                        | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                        | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                        | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_ltz -> true
                        | Coq3_Compilers.Coq_ident_Z_zselect -> true
                        | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                        | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_bneg -> true
                        | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                        | Coq3_Compilers.Coq_ident_Z_lxor -> true
                        | Coq3_Compilers.Coq_ident_Z_rshi -> true
                        | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                        | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                          true
                        | Coq3_Compilers.Coq_ident_Z_cast -> true
                        | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                        | Coq3_Compilers.Coq_ident_Some _ -> true
                        | Coq3_Compilers.Coq_ident_None _ -> true
                        | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                        | Coq3_Compilers.Coq_ident_Build_zrange -> true
                        | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                        | Coq3_Compilers.Coq_ident_fancy_add -> true
                        | Coq3_Compilers.Coq_ident_fancy_addc -> true
                        | Coq3_Compilers.Coq_ident_fancy_sub -> true
                        | Coq3_Compilers.Coq_ident_fancy_subb -> true
                        | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                        | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                        | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                        | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                        | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                        | Coq3_Compilers.Coq_ident_fancy_selc -> true
                        | Coq3_Compilers.Coq_ident_fancy_selm -> true
                        | Coq3_Compilers.Coq_ident_fancy_sell -> true
                        | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                     | Compilers.Coq_expr.Var (_, _) -> true
                     | Compilers.Coq_expr.Abs (_, _, _) -> true
                     | Compilers.Coq_expr.App (_, _, f2, _) ->
                       (match f2 with
                        | Compilers.Coq_expr.Ident (_, idc) ->
                          (match idc with
                           | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                           | Coq3_Compilers.Coq_ident_comment _ -> true
                           | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_value_barrier -> true
                           | Coq3_Compilers.Coq_ident_Nat_succ -> true
                           | Coq3_Compilers.Coq_ident_Nat_pred -> true
                           | Coq3_Compilers.Coq_ident_Nat_max -> true
                           | Coq3_Compilers.Coq_ident_Nat_mul -> true
                           | Coq3_Compilers.Coq_ident_Nat_add -> true
                           | Coq3_Compilers.Coq_ident_Nat_sub -> true
                           | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                           | Coq3_Compilers.Coq_ident_nil _ -> true
                           | Coq3_Compilers.Coq_ident_cons _ -> true
                           | Coq3_Compilers.Coq_ident_tt -> true
                           | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                           | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                           | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                           | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                           | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                             true
                           | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                               _, _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_length _ -> true
                           | Coq3_Compilers.Coq_ident_List_seq -> true
                           | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                           | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                           | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                           | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                           | Coq3_Compilers.Coq_ident_List_app _ -> true
                           | Coq3_Compilers.Coq_ident_List_rev _ -> true
                           | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_partition _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_filter _ -> true
                           | Coq3_Compilers.Coq_ident_List_fold_right (
                               _, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                             true
                           | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                             false
                           | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add -> true
                           | Coq3_Compilers.Coq_ident_Z_mul -> true
                           | Coq3_Compilers.Coq_ident_Z_pow -> true
                           | Coq3_Compilers.Coq_ident_Z_sub -> true
                           | Coq3_Compilers.Coq_ident_Z_opp -> true
                           | Coq3_Compilers.Coq_ident_Z_div -> true
                           | Coq3_Compilers.Coq_ident_Z_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_eqb -> true
                           | Coq3_Compilers.Coq_ident_Z_leb -> true
                           | Coq3_Compilers.Coq_ident_Z_ltb -> true
                           | Coq3_Compilers.Coq_ident_Z_geb -> true
                           | Coq3_Compilers.Coq_ident_Z_gtb -> true
                           | Coq3_Compilers.Coq_ident_Z_log2 -> true
                           | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                           | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                           | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                           | Coq3_Compilers.Coq_ident_Z_land -> true
                           | Coq3_Compilers.Coq_ident_Z_lor -> true
                           | Coq3_Compilers.Coq_ident_Z_min -> true
                           | Coq3_Compilers.Coq_ident_Z_max -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                           | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                           | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                           | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_ltz -> true
                           | Coq3_Compilers.Coq_ident_Z_zselect -> true
                           | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_bneg -> true
                           | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                           | Coq3_Compilers.Coq_ident_Z_lxor -> true
                           | Coq3_Compilers.Coq_ident_Z_rshi -> true
                           | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                           | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                             true
                           | Coq3_Compilers.Coq_ident_Z_cast -> true
                           | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                           | Coq3_Compilers.Coq_ident_Some _ -> true
                           | Coq3_Compilers.Coq_ident_None _ -> true
                           | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                             true
                           | Coq3_Compilers.Coq_ident_Build_zrange -> true
                           | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                           | Coq3_Compilers.Coq_ident_fancy_add -> true
                           | Coq3_Compilers.Coq_ident_fancy_addc -> true
                           | Coq3_Compilers.Coq_ident_fancy_sub -> true
                           | Coq3_Compilers.Coq_ident_fancy_subb -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                           | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                           | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                           | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                           | Coq3_Compilers.Coq_ident_fancy_selc -> true
                           | Coq3_Compilers.Coq_ident_fancy_selm -> true
                           | Coq3_Compilers.Coq_ident_fancy_sell -> true
                           | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                        | Compilers.Coq_expr.Var (_, _) -> true
                        | Compilers.Coq_expr.Abs (_, _, _) -> true
                        | Compilers.Coq_expr.App (_, _, _, _) -> true
                        | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                     | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))) f0)
         | Coq3_Compilers.Coq_string ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (match a with
         | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
           (match t1 with
            | Coq3_Compilers.Z ->
              (fun f0 _ ->
                match f0 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, f1, _) ->
                  (match f1 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, _, _) -> true
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
            | Coq3_Compilers.Coq_bool ->
              (fun f0 _ ->
                match f0 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, f1, _) ->
                  (match f1 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, _, _) -> true
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
            | Coq3_Compilers.Coq_nat ->
              (fun f0 _ ->
                match f0 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, f1, _) ->
                  (match f1 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, _, _) -> true
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
            | Coq3_Compilers.Coq_zrange ->
              (match b with
               | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
                 (match t2 with
                  | Coq3_Compilers.Z ->
                    (fun f0 _ ->
                      match f0 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, f1, _) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, idc) ->
                           (match idc with
                            | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                            | Coq3_Compilers.Coq_ident_comment _ -> true
                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_value_barrier -> true
                            | Coq3_Compilers.Coq_ident_Nat_succ -> true
                            | Coq3_Compilers.Coq_ident_Nat_pred -> true
                            | Coq3_Compilers.Coq_ident_Nat_max -> true
                            | Coq3_Compilers.Coq_ident_Nat_mul -> true
                            | Coq3_Compilers.Coq_ident_Nat_add -> true
                            | Coq3_Compilers.Coq_ident_Nat_sub -> true
                            | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                            | Coq3_Compilers.Coq_ident_nil _ -> true
                            | Coq3_Compilers.Coq_ident_cons _ -> true
                            | Coq3_Compilers.Coq_ident_tt -> true
                            | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                            | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                            | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                            | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_length _ -> true
                            | Coq3_Compilers.Coq_ident_List_seq -> true
                            | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                            | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                            | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                            | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_app _ -> true
                            | Coq3_Compilers.Coq_ident_List_rev _ -> true
                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_filter _ -> true
                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                              false
                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add -> true
                            | Coq3_Compilers.Coq_ident_Z_mul -> true
                            | Coq3_Compilers.Coq_ident_Z_pow -> true
                            | Coq3_Compilers.Coq_ident_Z_sub -> true
                            | Coq3_Compilers.Coq_ident_Z_opp -> true
                            | Coq3_Compilers.Coq_ident_Z_div -> true
                            | Coq3_Compilers.Coq_ident_Z_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_eqb -> true
                            | Coq3_Compilers.Coq_ident_Z_leb -> true
                            | Coq3_Compilers.Coq_ident_Z_ltb -> true
                            | Coq3_Compilers.Coq_ident_Z_geb -> true
                            | Coq3_Compilers.Coq_ident_Z_gtb -> true
                            | Coq3_Compilers.Coq_ident_Z_log2 -> true
                            | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                            | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                            | Coq3_Compilers.Coq_ident_Z_land -> true
                            | Coq3_Compilers.Coq_ident_Z_lor -> true
                            | Coq3_Compilers.Coq_ident_Z_min -> true
                            | Coq3_Compilers.Coq_ident_Z_max -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_ltz -> true
                            | Coq3_Compilers.Coq_ident_Z_zselect -> true
                            | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_bneg -> true
                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_lxor -> true
                            | Coq3_Compilers.Coq_ident_Z_rshi -> true
                            | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_cast -> true
                            | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                            | Coq3_Compilers.Coq_ident_Some _ -> true
                            | Coq3_Compilers.Coq_ident_None _ -> true
                            | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_Build_zrange -> true
                            | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                            | Coq3_Compilers.Coq_ident_fancy_add -> true
                            | Coq3_Compilers.Coq_ident_fancy_addc -> true
                            | Coq3_Compilers.Coq_ident_fancy_sub -> true
                            | Coq3_Compilers.Coq_ident_fancy_subb -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                            | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                            | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                            | Coq3_Compilers.Coq_ident_fancy_selc -> true
                            | Coq3_Compilers.Coq_ident_fancy_selm -> true
                            | Coq3_Compilers.Coq_ident_fancy_sell -> true
                            | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                         | Compilers.Coq_expr.Var (_, _) -> true
                         | Compilers.Coq_expr.Abs (_, _, _) -> true
                         | Compilers.Coq_expr.App (_, _, _, _) -> true
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                  | Coq3_Compilers.Coq_bool ->
                    (fun f0 _ ->
                      match f0 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, f1, _) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, idc) ->
                           (match idc with
                            | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                            | Coq3_Compilers.Coq_ident_comment _ -> true
                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_value_barrier -> true
                            | Coq3_Compilers.Coq_ident_Nat_succ -> true
                            | Coq3_Compilers.Coq_ident_Nat_pred -> true
                            | Coq3_Compilers.Coq_ident_Nat_max -> true
                            | Coq3_Compilers.Coq_ident_Nat_mul -> true
                            | Coq3_Compilers.Coq_ident_Nat_add -> true
                            | Coq3_Compilers.Coq_ident_Nat_sub -> true
                            | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                            | Coq3_Compilers.Coq_ident_nil _ -> true
                            | Coq3_Compilers.Coq_ident_cons _ -> true
                            | Coq3_Compilers.Coq_ident_tt -> true
                            | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                            | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                            | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                            | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_length _ -> true
                            | Coq3_Compilers.Coq_ident_List_seq -> true
                            | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                            | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                            | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                            | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_app _ -> true
                            | Coq3_Compilers.Coq_ident_List_rev _ -> true
                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_filter _ -> true
                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                              false
                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add -> true
                            | Coq3_Compilers.Coq_ident_Z_mul -> true
                            | Coq3_Compilers.Coq_ident_Z_pow -> true
                            | Coq3_Compilers.Coq_ident_Z_sub -> true
                            | Coq3_Compilers.Coq_ident_Z_opp -> true
                            | Coq3_Compilers.Coq_ident_Z_div -> true
                            | Coq3_Compilers.Coq_ident_Z_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_eqb -> true
                            | Coq3_Compilers.Coq_ident_Z_leb -> true
                            | Coq3_Compilers.Coq_ident_Z_ltb -> true
                            | Coq3_Compilers.Coq_ident_Z_geb -> true
                            | Coq3_Compilers.Coq_ident_Z_gtb -> true
                            | Coq3_Compilers.Coq_ident_Z_log2 -> true
                            | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                            | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                            | Coq3_Compilers.Coq_ident_Z_land -> true
                            | Coq3_Compilers.Coq_ident_Z_lor -> true
                            | Coq3_Compilers.Coq_ident_Z_min -> true
                            | Coq3_Compilers.Coq_ident_Z_max -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_ltz -> true
                            | Coq3_Compilers.Coq_ident_Z_zselect -> true
                            | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_bneg -> true
                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_lxor -> true
                            | Coq3_Compilers.Coq_ident_Z_rshi -> true
                            | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_cast -> true
                            | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                            | Coq3_Compilers.Coq_ident_Some _ -> true
                            | Coq3_Compilers.Coq_ident_None _ -> true
                            | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_Build_zrange -> true
                            | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                            | Coq3_Compilers.Coq_ident_fancy_add -> true
                            | Coq3_Compilers.Coq_ident_fancy_addc -> true
                            | Coq3_Compilers.Coq_ident_fancy_sub -> true
                            | Coq3_Compilers.Coq_ident_fancy_subb -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                            | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                            | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                            | Coq3_Compilers.Coq_ident_fancy_selc -> true
                            | Coq3_Compilers.Coq_ident_fancy_selm -> true
                            | Coq3_Compilers.Coq_ident_fancy_sell -> true
                            | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                         | Compilers.Coq_expr.Var (_, _) -> true
                         | Compilers.Coq_expr.Abs (_, _, _) -> true
                         | Compilers.Coq_expr.App (_, _, _, _) -> true
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                  | Coq3_Compilers.Coq_nat ->
                    (fun f0 _ ->
                      match f0 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, f1, _) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, idc) ->
                           (match idc with
                            | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                            | Coq3_Compilers.Coq_ident_comment _ -> true
                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_value_barrier -> true
                            | Coq3_Compilers.Coq_ident_Nat_succ -> true
                            | Coq3_Compilers.Coq_ident_Nat_pred -> true
                            | Coq3_Compilers.Coq_ident_Nat_max -> true
                            | Coq3_Compilers.Coq_ident_Nat_mul -> true
                            | Coq3_Compilers.Coq_ident_Nat_add -> true
                            | Coq3_Compilers.Coq_ident_Nat_sub -> true
                            | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                            | Coq3_Compilers.Coq_ident_nil _ -> true
                            | Coq3_Compilers.Coq_ident_cons _ -> true
                            | Coq3_Compilers.Coq_ident_tt -> true
                            | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                            | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                            | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                            | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_length _ -> true
                            | Coq3_Compilers.Coq_ident_List_seq -> true
                            | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                            | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                            | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                            | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_app _ -> true
                            | Coq3_Compilers.Coq_ident_List_rev _ -> true
                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_filter _ -> true
                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                              false
                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add -> true
                            | Coq3_Compilers.Coq_ident_Z_mul -> true
                            | Coq3_Compilers.Coq_ident_Z_pow -> true
                            | Coq3_Compilers.Coq_ident_Z_sub -> true
                            | Coq3_Compilers.Coq_ident_Z_opp -> true
                            | Coq3_Compilers.Coq_ident_Z_div -> true
                            | Coq3_Compilers.Coq_ident_Z_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_eqb -> true
                            | Coq3_Compilers.Coq_ident_Z_leb -> true
                            | Coq3_Compilers.Coq_ident_Z_ltb -> true
                            | Coq3_Compilers.Coq_ident_Z_geb -> true
                            | Coq3_Compilers.Coq_ident_Z_gtb -> true
                            | Coq3_Compilers.Coq_ident_Z_log2 -> true
                            | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                            | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                            | Coq3_Compilers.Coq_ident_Z_land -> true
                            | Coq3_Compilers.Coq_ident_Z_lor -> true
                            | Coq3_Compilers.Coq_ident_Z_min -> true
                            | Coq3_Compilers.Coq_ident_Z_max -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_ltz -> true
                            | Coq3_Compilers.Coq_ident_Z_zselect -> true
                            | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_bneg -> true
                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_lxor -> true
                            | Coq3_Compilers.Coq_ident_Z_rshi -> true
                            | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_cast -> true
                            | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                            | Coq3_Compilers.Coq_ident_Some _ -> true
                            | Coq3_Compilers.Coq_ident_None _ -> true
                            | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_Build_zrange -> true
                            | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                            | Coq3_Compilers.Coq_ident_fancy_add -> true
                            | Coq3_Compilers.Coq_ident_fancy_addc -> true
                            | Coq3_Compilers.Coq_ident_fancy_sub -> true
                            | Coq3_Compilers.Coq_ident_fancy_subb -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                            | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                            | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                            | Coq3_Compilers.Coq_ident_fancy_selc -> true
                            | Coq3_Compilers.Coq_ident_fancy_selm -> true
                            | Coq3_Compilers.Coq_ident_fancy_sell -> true
                            | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                         | Compilers.Coq_expr.Var (_, _) -> true
                         | Compilers.Coq_expr.Abs (_, _, _) -> true
                         | Compilers.Coq_expr.App (_, _, _, _) -> true
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                  | Coq3_Compilers.Coq_zrange ->
                    (fun f0 x0 ->
                      (match d with
                       | Compilers.Coq_type.Coq_base _ ->
                         (fun f1 ->
                           match f1 with
                           | Compilers.Coq_expr.Ident (_, idc) ->
                             (match idc with
                              | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_comment _ -> true
                              | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_value_barrier ->
                                true
                              | Coq3_Compilers.Coq_ident_Nat_succ -> true
                              | Coq3_Compilers.Coq_ident_Nat_pred -> true
                              | Coq3_Compilers.Coq_ident_Nat_max -> true
                              | Coq3_Compilers.Coq_ident_Nat_mul -> true
                              | Coq3_Compilers.Coq_ident_Nat_add -> true
                              | Coq3_Compilers.Coq_ident_Nat_sub -> true
                              | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                              | Coq3_Compilers.Coq_ident_nil _ -> true
                              | Coq3_Compilers.Coq_ident_cons _ -> true
                              | Coq3_Compilers.Coq_ident_tt -> true
                              | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                              | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                              | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                              | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                              | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                  _, _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_length _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_seq -> true
                              | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                              | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_combine (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_app _ -> true
                              | Coq3_Compilers.Coq_ident_List_rev _ -> true
                              | Coq3_Compilers.Coq_ident_List_flat_map (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_partition _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_filter _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_fold_right (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                true
                              | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add -> true
                              | Coq3_Compilers.Coq_ident_Z_mul -> true
                              | Coq3_Compilers.Coq_ident_Z_pow -> true
                              | Coq3_Compilers.Coq_ident_Z_sub -> true
                              | Coq3_Compilers.Coq_ident_Z_opp -> true
                              | Coq3_Compilers.Coq_ident_Z_div -> true
                              | Coq3_Compilers.Coq_ident_Z_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_eqb -> true
                              | Coq3_Compilers.Coq_ident_Z_leb -> true
                              | Coq3_Compilers.Coq_ident_Z_ltb -> true
                              | Coq3_Compilers.Coq_ident_Z_geb -> true
                              | Coq3_Compilers.Coq_ident_Z_gtb -> true
                              | Coq3_Compilers.Coq_ident_Z_log2 -> true
                              | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                              | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                              | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                              | Coq3_Compilers.Coq_ident_Z_land -> true
                              | Coq3_Compilers.Coq_ident_Z_lor -> true
                              | Coq3_Compilers.Coq_ident_Z_min -> true
                              | Coq3_Compilers.Coq_ident_Z_max -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                              | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                              | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_ltz -> true
                              | Coq3_Compilers.Coq_ident_Z_zselect -> true
                              | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                              | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_bneg -> true
                              | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                false
                              | Coq3_Compilers.Coq_ident_Z_lxor -> true
                              | Coq3_Compilers.Coq_ident_Z_rshi -> true
                              | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                              | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                true
                              | Coq3_Compilers.Coq_ident_Z_cast -> true
                              | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                              | Coq3_Compilers.Coq_ident_Some _ -> true
                              | Coq3_Compilers.Coq_ident_None _ -> true
                              | Coq3_Compilers.Coq_ident_option_rect (
                                  _, _) ->
                                true
                              | Coq3_Compilers.Coq_ident_Build_zrange -> true
                              | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                true
                              | Coq3_Compilers.Coq_ident_fancy_add -> true
                              | Coq3_Compilers.Coq_ident_fancy_addc -> true
                              | Coq3_Compilers.Coq_ident_fancy_sub -> true
                              | Coq3_Compilers.Coq_ident_fancy_subb -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                              | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                              | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                              | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                              | Coq3_Compilers.Coq_ident_fancy_selc -> true
                              | Coq3_Compilers.Coq_ident_fancy_selm -> true
                              | Coq3_Compilers.Coq_ident_fancy_sell -> true
                              | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                           | Compilers.Coq_expr.Var (_, _) -> true
                           | Compilers.Coq_expr.Abs (_, _, _) -> true
                           | Compilers.Coq_expr.App (_, _, f2, _) ->
                             (match f2 with
                              | Compilers.Coq_expr.Ident (_, idc) ->
                                (match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_comment _ -> true
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> true
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> true
                                 | Coq3_Compilers.Coq_ident_Nat_max -> true
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> true
                                 | Coq3_Compilers.Coq_ident_Nat_add -> true
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> true
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                                 | Coq3_Compilers.Coq_ident_nil _ -> true
                                 | Coq3_Compilers.Coq_ident_cons _ -> true
                                 | Coq3_Compilers.Coq_ident_tt -> true
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_seq -> true
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   false
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul -> true
                                 | Coq3_Compilers.Coq_ident_Z_pow -> true
                                 | Coq3_Compilers.Coq_ident_Z_sub -> true
                                 | Coq3_Compilers.Coq_ident_Z_opp -> true
                                 | Coq3_Compilers.Coq_ident_Z_div -> true
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> true
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                 | Coq3_Compilers.Coq_ident_Z_leb -> true
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                 | Coq3_Compilers.Coq_ident_Z_geb -> true
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                                 | Coq3_Compilers.Coq_ident_Z_land -> true
                                 | Coq3_Compilers.Coq_ident_Z_lor -> true
                                 | Coq3_Compilers.Coq_ident_Z_min -> true
                                 | Coq3_Compilers.Coq_ident_Z_max -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> true
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_cast -> true
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> true
                                 | Coq3_Compilers.Coq_ident_None _ -> true
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   true
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_add -> true
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> true
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   true)
                              | Compilers.Coq_expr.Var (_, _) -> true
                              | Compilers.Coq_expr.Abs (_, _, _) -> true
                              | Compilers.Coq_expr.App (_, _, _, _) -> true
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                           | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                       | Compilers.Coq_type.Coq_arrow (s1, d0) ->
                         (match s1 with
                          | Compilers.Coq_type.Coq_base t3 ->
                            (match t3 with
                             | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                             | Compilers.Coq_base.Coq_type.Coq_prod (
                                 a0, b0) ->
                               (match a0 with
                                | Compilers.Coq_base.Coq_type.Coq_type_base t4 ->
                                  (match t4 with
                                   | Coq3_Compilers.Z ->
                                     (match b0 with
                                      | Compilers.Coq_base.Coq_type.Coq_type_base t5 ->
                                        (match t5 with
                                         | Coq3_Compilers.Z ->
                                           (match d0 with
                                            | Compilers.Coq_type.Coq_base t6 ->
                                              (match t6 with
                                               | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                                                 (fun f1 ->
                                                   match f1 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, idc) ->
                                                     (match idc with
                                                      | Coq3_Compilers.Coq_ident_Literal (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_value_barrier ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nil _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_cons _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_tt ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_pair (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fst (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_snd (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_prod_rect (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_case (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_length _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_seq ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_combine (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_app _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_flat_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_fold_right (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_pow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_opp ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_div ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_leb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_geb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_land ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_min ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                        false
                                                      | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Some _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_None _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_option_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                        true)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f2, _) ->
                                                     (match f2 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     true)
                                               | Compilers.Coq_base.Coq_type.Coq_prod (
                                                   a1, b1) ->
                                                 (match a1 with
                                                  | Compilers.Coq_base.Coq_type.Coq_type_base t7 ->
                                                    (match t7 with
                                                     | Coq3_Compilers.Z ->
                                                       (match b1 with
                                                        | Compilers.Coq_base.Coq_type.Coq_type_base t8 ->
                                                          (match t8 with
                                                           | Coq3_Compilers.Z ->
                                                             (fun f1 ->
                                                               match f1 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    (match x0 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.App (
                                                                    s2, d1,
                                                                    f2, x1) ->
                                                                    (match s2 with
                                                                    | Compilers.Coq_type.Coq_base t10 ->
                                                                    (match t10 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t11 ->
                                                                    (match t11 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun f3 x2 ->
                                                                    (match d1 with
                                                                    | Compilers.Coq_type.Coq_base t12 ->
                                                                    (match t12 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a2, b2) ->
                                                                    (match a2 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t13 ->
                                                                    (match t13 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match b2 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t14 ->
                                                                    (match t14 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun f4 ->
                                                                    match f4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.App (
                                                                    s3, d2,
                                                                    f5, x3) ->
                                                                    (match s3 with
                                                                    | Compilers.Coq_type.Coq_base t15 ->
                                                                    (match t15 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t16 ->
                                                                    (match t16 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun f6 x4 ->
                                                                    (match d2 with
                                                                    | Compilers.Coq_type.Coq_base _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    s4, d3) ->
                                                                    (match s4 with
                                                                    | Compilers.Coq_type.Coq_base t17 ->
                                                                    (match t17 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t18 ->
                                                                    (match t18 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match d3 with
                                                                    | Compilers.Coq_type.Coq_base t19 ->
                                                                    (match t19 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    a3, b3) ->
                                                                    (match a3 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t20 ->
                                                                    (match t20 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (match b3 with
                                                                    | Compilers.Coq_base.Coq_type.Coq_type_base t21 ->
                                                                    (match t21 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun f7 ->
                                                                    match f7 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, idc0) ->
                                                                    (match idc0 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    (match x4 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, idc1) ->
                                                                    (match idc1 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    t26, r1) ->
                                                                    (match t26 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun r2 ->
                                                                    match x2 with
                                                                    | Compilers.Coq_expr.Ident (
                                                                    _, idc2) ->
                                                                    (match idc2 with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    t28, r3) ->
                                                                    (match t28 with
                                                                    | Coq3_Compilers.Z ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_bool ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_nat ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_zrange ->
                                                                    (fun r4 ->
                                                                    negb
                                                                    ((&&)
                                                                    (range_good
                                                                    width
                                                                    (Obj.magic
                                                                    r2))
                                                                    (range_good
                                                                    width
                                                                    (Obj.magic
                                                                    r4))))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ ->
                                                                    true)) r3
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ ->
                                                                    true)) r1
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                    | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true)))
                                                                    f6)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    _, _) ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ _ ->
                                                                    true))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    _, _) ->
                                                                    (fun _ _ ->
                                                                    true)) f5
                                                                    x3
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ ->
                                                                    true))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    _, _) ->
                                                                    (fun _ ->
                                                                    true)) f3)
                                                                    | Coq3_Compilers.Coq_string ->
                                                                    (fun _ _ ->
                                                                    true))
                                                                    | Compilers.Coq_base.Coq_type.Coq_prod (
                                                                    _, _) ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                                    (fun _ _ ->
                                                                    true)
                                                                    | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                                    (fun _ _ ->
                                                                    true))
                                                                    | Compilers.Coq_type.Coq_arrow (
                                                                    _, _) ->
                                                                    (fun _ _ ->
                                                                    true)) f2
                                                                    x1
                                                                    | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f2,
                                                                   _) ->
                                                                 (match f2 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, idc) ->
                                                                    (match idc with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                           | Coq3_Compilers.Coq_bool ->
                                                             (fun f1 ->
                                                               match f1 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f2,
                                                                   _) ->
                                                                 (match f2 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, idc) ->
                                                                    (match idc with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                           | Coq3_Compilers.Coq_nat ->
                                                             (fun f1 ->
                                                               match f1 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f2,
                                                                   _) ->
                                                                 (match f2 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, idc) ->
                                                                    (match idc with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                           | Coq3_Compilers.Coq_zrange ->
                                                             (fun f1 ->
                                                               match f1 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f2,
                                                                   _) ->
                                                                 (match f2 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, idc) ->
                                                                    (match idc with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                           | Coq3_Compilers.Coq_string ->
                                                             (fun f1 ->
                                                               match f1 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, f2,
                                                                   _) ->
                                                                 (match f2 with
                                                                  | Compilers.Coq_expr.Ident (
                                                                    _, idc) ->
                                                                    (match idc with
                                                                    | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                                  | Compilers.Coq_expr.Var (
                                                                    _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.Abs (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.App (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true
                                                                  | Compilers.Coq_expr.LetIn (
                                                                    _, _, _,
                                                                    _) ->
                                                                    true)
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true))
                                                        | Compilers.Coq_base.Coq_type.Coq_prod (
                                                            _, _) ->
                                                          (fun f1 ->
                                                            match f1 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f2, _) ->
                                                              (match f2 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true)
                                                        | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                          (fun f1 ->
                                                            match f1 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f2, _) ->
                                                              (match f2 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true)
                                                        | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                          (fun f1 ->
                                                            match f1 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f2, _) ->
                                                              (match f2 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true)
                                                        | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                          (fun f1 ->
                                                            match f1 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, f2, _) ->
                                                              (match f2 with
                                                               | Compilers.Coq_expr.Ident (
                                                                   _, idc) ->
                                                                 (match idc with
                                                                  | Coq3_Compilers.Coq_ident_Literal (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nil _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_cons _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_tt ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_pair (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fst (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_snd (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_prod_rect (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                    _, _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_list_case (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_seq ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_combine (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                    false
                                                                  | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_div ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_land ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_min ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_max ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Some _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_None _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_option_rect (
                                                                    _, _) ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                    true
                                                                  | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                    true)
                                                               | Compilers.Coq_expr.Var (
                                                                   _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.Abs (
                                                                   _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.App (
                                                                   _, _, _, _) ->
                                                                 true
                                                               | Compilers.Coq_expr.LetIn (
                                                                   _, _, _, _) ->
                                                                 true)
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true))
                                                     | Coq3_Compilers.Coq_bool ->
                                                       (fun f1 ->
                                                         match f1 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, f2, _) ->
                                                           (match f2 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true)
                                                     | Coq3_Compilers.Coq_nat ->
                                                       (fun f1 ->
                                                         match f1 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, f2, _) ->
                                                           (match f2 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true)
                                                     | Coq3_Compilers.Coq_zrange ->
                                                       (fun f1 ->
                                                         match f1 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, f2, _) ->
                                                           (match f2 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true)
                                                     | Coq3_Compilers.Coq_string ->
                                                       (fun f1 ->
                                                         match f1 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, f2, _) ->
                                                           (match f2 with
                                                            | Compilers.Coq_expr.Ident (
                                                                _, idc) ->
                                                              (match idc with
                                                               | Coq3_Compilers.Coq_ident_Literal (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_value_barrier ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nil _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_cons _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_tt ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_pair (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fst (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_snd (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_prod_rect (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                   _, _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_list_case (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_length _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_seq ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_combine (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_app _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                                 false
                                                               | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_pow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_opp ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_div ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_leb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_geb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_land ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_min ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_max ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Some _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_None _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_option_rect (
                                                                   _, _) ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_add ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                                 true
                                                               | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                                 true)
                                                            | Compilers.Coq_expr.Var (
                                                                _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.Abs (
                                                                _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.App (
                                                                _, _, _, _) ->
                                                              true
                                                            | Compilers.Coq_expr.LetIn (
                                                                _, _, _, _) ->
                                                              true)
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true))
                                                  | Compilers.Coq_base.Coq_type.Coq_prod (
                                                      _, _) ->
                                                    (fun f1 ->
                                                      match f1 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, f2, _) ->
                                                        (match f2 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true)
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true)
                                                  | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                    (fun f1 ->
                                                      match f1 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, f2, _) ->
                                                        (match f2 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true)
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true)
                                                  | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                    (fun f1 ->
                                                      match f1 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, f2, _) ->
                                                        (match f2 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true)
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true)
                                                  | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                    (fun f1 ->
                                                      match f1 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, f2, _) ->
                                                        (match f2 with
                                                         | Compilers.Coq_expr.Ident (
                                                             _, idc) ->
                                                           (match idc with
                                                            | Coq3_Compilers.Coq_ident_Literal (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_value_barrier ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nil _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_cons _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_tt ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_pair (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fst (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_snd (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_prod_rect (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                                _, _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_list_case (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_length _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_seq ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_combine (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_app _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                              false
                                                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_pow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_opp ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_div ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_leb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_geb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_land ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_min ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_max ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Some _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_None _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_option_rect (
                                                                _, _) ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_add ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                              true
                                                            | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                              true)
                                                         | Compilers.Coq_expr.Var (
                                                             _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.Abs (
                                                             _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.App (
                                                             _, _, _, _) ->
                                                           true
                                                         | Compilers.Coq_expr.LetIn (
                                                             _, _, _, _) ->
                                                           true)
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true))
                                               | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                                 (fun f1 ->
                                                   match f1 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, idc) ->
                                                     (match idc with
                                                      | Coq3_Compilers.Coq_ident_Literal (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_value_barrier ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nil _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_cons _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_tt ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_pair (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fst (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_snd (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_prod_rect (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_case (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_length _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_seq ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_combine (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_app _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_flat_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_fold_right (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_pow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_opp ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_div ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_leb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_geb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_land ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_min ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                        false
                                                      | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Some _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_None _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_option_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                        true)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f2, _) ->
                                                     (match f2 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     true)
                                               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                                 (fun f1 ->
                                                   match f1 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, idc) ->
                                                     (match idc with
                                                      | Coq3_Compilers.Coq_ident_Literal (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_value_barrier ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nil _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_cons _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_tt ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_pair (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fst (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_snd (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_prod_rect (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_case (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_length _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_seq ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_combine (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_app _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_flat_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_fold_right (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_pow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_opp ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_div ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_leb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_geb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_land ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_min ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                        false
                                                      | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Some _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_None _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_option_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                        true)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f2, _) ->
                                                     (match f2 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     true)
                                               | Compilers.Coq_base.Coq_type.Coq_unit ->
                                                 (fun f1 ->
                                                   match f1 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, idc) ->
                                                     (match idc with
                                                      | Coq3_Compilers.Coq_ident_Literal (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_value_barrier ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nil _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_cons _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_tt ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_pair (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fst (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_snd (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_prod_rect (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_case (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_length _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_seq ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_combine (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_app _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_flat_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_fold_right (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_pow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_opp ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_div ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_leb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_geb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_land ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_min ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                        false
                                                      | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Some _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_None _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_option_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                        true)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.App (
                                                       _, _, f2, _) ->
                                                     (match f2 with
                                                      | Compilers.Coq_expr.Ident (
                                                          _, idc) ->
                                                        (match idc with
                                                         | Coq3_Compilers.Coq_ident_Literal (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_value_barrier ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nil _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_cons _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_tt ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_pair (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fst (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_snd (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_prod_rect (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                             _, _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_list_case (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_length _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_seq ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_combine (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_app _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_flat_map (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_fold_right (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                           false
                                                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_pow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_opp ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_div ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_leb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_geb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_land ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_min ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_max ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Some _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_None _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_option_rect (
                                                             _, _) ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_add ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                           true
                                                         | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                           true)
                                                      | Compilers.Coq_expr.Var (
                                                          _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.Abs (
                                                          _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.App (
                                                          _, _, _, _) ->
                                                        true
                                                      | Compilers.Coq_expr.LetIn (
                                                          _, _, _, _) ->
                                                        true)
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     true))
                                            | Compilers.Coq_type.Coq_arrow (
                                                _, _) ->
                                              (fun f1 ->
                                                match f1 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, idc) ->
                                                  (match idc with
                                                   | Coq3_Compilers.Coq_ident_Literal (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_value_barrier ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nil _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_cons _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_tt ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_pair (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fst (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_snd (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_prod_rect (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_case (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_length _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_seq ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_combine (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_app _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_flat_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_fold_right (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_pow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_opp ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_div ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_leb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_geb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_land ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_min ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                     false
                                                   | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Some _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_None _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_option_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                     true)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  true
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.App (
                                                    _, _, f2, _) ->
                                                  (match f2 with
                                                   | Compilers.Coq_expr.Ident (
                                                       _, idc) ->
                                                     (match idc with
                                                      | Coq3_Compilers.Coq_ident_Literal (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_value_barrier ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nil _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_cons _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_tt ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_pair (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fst (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_snd (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_prod_rect (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                          _, _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_list_case (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_length _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_seq ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_combine (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_app _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_flat_map (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_fold_right (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                        false
                                                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_pow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_opp ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_div ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_leb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_geb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_land ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_min ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_max ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Some _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_None _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_option_rect (
                                                          _, _) ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_add ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                        true
                                                      | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                        true)
                                                   | Compilers.Coq_expr.Var (
                                                       _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.Abs (
                                                       _, _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.App (
                                                       _, _, _, _) ->
                                                     true
                                                   | Compilers.Coq_expr.LetIn (
                                                       _, _, _, _) ->
                                                     true)
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  true))
                                         | Coq3_Compilers.Coq_bool ->
                                           (fun f1 ->
                                             match f1 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, f2, _) ->
                                               (match f2 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, idc) ->
                                                  (match idc with
                                                   | Coq3_Compilers.Coq_ident_Literal (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_value_barrier ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nil _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_cons _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_tt ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_pair (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fst (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_snd (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_prod_rect (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_case (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_length _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_seq ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_combine (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_app _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_flat_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_fold_right (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                     false
                                                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_pow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_opp ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_div ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_leb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_geb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_land ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_min ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Some _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_None _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_option_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                     true)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  true
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  true)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true)
                                         | Coq3_Compilers.Coq_nat ->
                                           (fun f1 ->
                                             match f1 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, f2, _) ->
                                               (match f2 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, idc) ->
                                                  (match idc with
                                                   | Coq3_Compilers.Coq_ident_Literal (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_value_barrier ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nil _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_cons _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_tt ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_pair (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fst (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_snd (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_prod_rect (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_case (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_length _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_seq ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_combine (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_app _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_flat_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_fold_right (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                     false
                                                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_pow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_opp ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_div ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_leb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_geb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_land ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_min ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Some _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_None _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_option_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                     true)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  true
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  true)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true)
                                         | Coq3_Compilers.Coq_zrange ->
                                           (fun f1 ->
                                             match f1 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, f2, _) ->
                                               (match f2 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, idc) ->
                                                  (match idc with
                                                   | Coq3_Compilers.Coq_ident_Literal (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_value_barrier ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nil _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_cons _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_tt ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_pair (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fst (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_snd (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_prod_rect (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_case (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_length _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_seq ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_combine (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_app _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_flat_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_fold_right (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                     false
                                                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_pow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_opp ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_div ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_leb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_geb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_land ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_min ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Some _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_None _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_option_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                     true)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  true
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  true)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true)
                                         | Coq3_Compilers.Coq_string ->
                                           (fun f1 ->
                                             match f1 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, f2, _) ->
                                               (match f2 with
                                                | Compilers.Coq_expr.Ident (
                                                    _, idc) ->
                                                  (match idc with
                                                   | Coq3_Compilers.Coq_ident_Literal (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_value_barrier ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nil _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_cons _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_tt ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_pair (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fst (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_snd (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_prod_rect (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                       _, _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_list_case (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_length _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_seq ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_combine (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_app _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_flat_map (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_fold_right (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                     false
                                                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_pow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_opp ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_div ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_leb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_geb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_land ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_min ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_max ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Some _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_None _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_option_rect (
                                                       _, _) ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_add ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                     true
                                                   | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                     true)
                                                | Compilers.Coq_expr.Var (
                                                    _, _) ->
                                                  true
                                                | Compilers.Coq_expr.Abs (
                                                    _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.App (
                                                    _, _, _, _) ->
                                                  true
                                                | Compilers.Coq_expr.LetIn (
                                                    _, _, _, _) ->
                                                  true)
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true))
                                      | Compilers.Coq_base.Coq_type.Coq_prod (
                                          _, _) ->
                                        (fun f1 ->
                                          match f1 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               false
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, f2,
                                                                    _) ->
                                            (match f2 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                      | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                        (fun f1 ->
                                          match f1 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               false
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, f2,
                                                                    _) ->
                                            (match f2 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                      | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                        (fun f1 ->
                                          match f1 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               false
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, f2,
                                                                    _) ->
                                            (match f2 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                      | Compilers.Coq_base.Coq_type.Coq_unit ->
                                        (fun f1 ->
                                          match f1 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               false
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, f2,
                                                                    _) ->
                                            (match f2 with
                                             | Compilers.Coq_expr.Ident (
                                                 _, idc) ->
                                               (match idc with
                                                | Coq3_Compilers.Coq_ident_Literal (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_value_barrier ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_succ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_pred ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nil _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_cons _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_tt ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_pair (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fst (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_snd (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_prod_rect (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                    _, _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_list_case (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_length _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_seq ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_combine (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_app _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_rev _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_flat_map (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_partition _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_filter _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_fold_right (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                                  false
                                                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_pow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_opp ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_div ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_eqb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_leb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_geb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_gtb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_land ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_min ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_max ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_ltz ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_zselect ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_bneg ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_lxor ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Some _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_None _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_option_rect (
                                                    _, _) ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_Build_zrange ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_add ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sub ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_subb ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selc ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_selm ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_sell ->
                                                  true
                                                | Coq3_Compilers.Coq_ident_fancy_addm ->
                                                  true)
                                             | Compilers.Coq_expr.Var (
                                                 _, _) ->
                                               true
                                             | Compilers.Coq_expr.Abs (
                                                 _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.App (
                                                 _, _, _, _) ->
                                               true
                                             | Compilers.Coq_expr.LetIn (
                                                 _, _, _, _) ->
                                               true)
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true))
                                   | Coq3_Compilers.Coq_bool ->
                                     (fun f1 ->
                                       match f1 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            false
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, f2, _) ->
                                         (match f2 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               false
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, _,
                                                                    _) ->
                                            true
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                   | Coq3_Compilers.Coq_nat ->
                                     (fun f1 ->
                                       match f1 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            false
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, f2, _) ->
                                         (match f2 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               false
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, _,
                                                                    _) ->
                                            true
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                   | Coq3_Compilers.Coq_zrange ->
                                     (fun f1 ->
                                       match f1 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            false
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, f2, _) ->
                                         (match f2 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               false
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, _,
                                                                    _) ->
                                            true
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                   | Coq3_Compilers.Coq_string ->
                                     (fun f1 ->
                                       match f1 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            false
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, f2, _) ->
                                         (match f2 with
                                          | Compilers.Coq_expr.Ident (
                                              _, idc) ->
                                            (match idc with
                                             | Coq3_Compilers.Coq_ident_Literal (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_value_barrier ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_succ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_pred ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nil _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_cons _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_tt ->
                                               true
                                             | Coq3_Compilers.Coq_ident_pair (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fst (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_snd (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_prod_rect (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                                 _, _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_list_case (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_length _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_seq ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_combine (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_app _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_rev _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_flat_map (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_partition _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_filter _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_fold_right (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                               false
                                             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_pow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_opp ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_div ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_eqb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_leb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_geb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_gtb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_land ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_min ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_max ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_ltz ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_zselect ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_bneg ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_lxor ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Some _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_None _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_option_rect (
                                                 _, _) ->
                                               true
                                             | Coq3_Compilers.Coq_ident_Build_zrange ->
                                               true
                                             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_add ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sub ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_subb ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selc ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_selm ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_sell ->
                                               true
                                             | Coq3_Compilers.Coq_ident_fancy_addm ->
                                               true)
                                          | Compilers.Coq_expr.Var (_, _) ->
                                            true
                                          | Compilers.Coq_expr.Abs (_, _, _) ->
                                            true
                                          | Compilers.Coq_expr.App (_, _, _,
                                                                    _) ->
                                            true
                                          | Compilers.Coq_expr.LetIn (
                                              _, _, _, _) ->
                                            true)
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true))
                                | Compilers.Coq_base.Coq_type.Coq_prod (
                                    _, _) ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                | Compilers.Coq_base.Coq_type.Coq_list _ ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                | Compilers.Coq_base.Coq_type.Coq_option _ ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                | Compilers.Coq_base.Coq_type.Coq_unit ->
                                  (fun f1 ->
                                    match f1 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         false
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, f2, _) ->
                                      (match f2 with
                                       | Compilers.Coq_expr.Ident (_, idc) ->
                                         (match idc with
                                          | Coq3_Compilers.Coq_ident_Literal (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_value_barrier ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_succ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_pred ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nil _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_cons _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_tt ->
                                            true
                                          | Coq3_Compilers.Coq_ident_pair (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fst (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_snd (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_prod_rect (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                              _, _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_list_case (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_length _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_seq ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_combine (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_app _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_rev _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_flat_map (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_partition _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_filter _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_fold_right (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                            false
                                          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_pow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_opp ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_div ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_eqb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_leb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_geb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_gtb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_land ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_min ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_max ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_ltz ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_zselect ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_bneg ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_lxor ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Some _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_None _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_option_rect (
                                              _, _) ->
                                            true
                                          | Coq3_Compilers.Coq_ident_Build_zrange ->
                                            true
                                          | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_add ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sub ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_subb ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selc ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_selm ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_sell ->
                                            true
                                          | Coq3_Compilers.Coq_ident_fancy_addm ->
                                            true)
                                       | Compilers.Coq_expr.Var (_, _) ->
                                         true
                                       | Compilers.Coq_expr.Abs (_, _, _) ->
                                         true
                                       | Compilers.Coq_expr.App (_, _, _, _) ->
                                         true
                                       | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                         true)
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true))
                             | Compilers.Coq_base.Coq_type.Coq_list _ ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                             | Compilers.Coq_base.Coq_type.Coq_option _ ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                             | Compilers.Coq_base.Coq_type.Coq_unit ->
                               (fun f1 ->
                                 match f1 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      false
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, f2, _) ->
                                   (match f2 with
                                    | Compilers.Coq_expr.Ident (_, idc) ->
                                      (match idc with
                                       | Coq3_Compilers.Coq_ident_Literal (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_value_barrier ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_succ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_pred ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nil _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_cons _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_tt -> true
                                       | Coq3_Compilers.Coq_ident_pair (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fst (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_snd (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_prod_rect (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                           _, _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_list_case (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_length _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_seq ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_combine (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_app _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_rev _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_flat_map (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_partition _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_filter _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_fold_right (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                         false
                                       | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_pow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_opp ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_div ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_eqb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_leb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_geb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_gtb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_land ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_min ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_max ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_ltz ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_zselect ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_bneg ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_lxor ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cc_m ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Some _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_None _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_option_rect (
                                           _, _) ->
                                         true
                                       | Coq3_Compilers.Coq_ident_Build_zrange ->
                                         true
                                       | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_add ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sub ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_subb ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selc ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_selm ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_sell ->
                                         true
                                       | Coq3_Compilers.Coq_ident_fancy_addm ->
                                         true)
                                    | Compilers.Coq_expr.Var (_, _) -> true
                                    | Compilers.Coq_expr.Abs (_, _, _) ->
                                      true
                                    | Compilers.Coq_expr.App (_, _, _, _) ->
                                      true
                                    | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                      true)
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true))
                          | Compilers.Coq_type.Coq_arrow (_, _) ->
                            (fun f1 ->
                              match f1 with
                              | Compilers.Coq_expr.Ident (_, idc) ->
                                (match idc with
                                 | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_comment _ -> true
                                 | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_value_barrier ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Nat_succ -> true
                                 | Coq3_Compilers.Coq_ident_Nat_pred -> true
                                 | Coq3_Compilers.Coq_ident_Nat_max -> true
                                 | Coq3_Compilers.Coq_ident_Nat_mul -> true
                                 | Coq3_Compilers.Coq_ident_Nat_add -> true
                                 | Coq3_Compilers.Coq_ident_Nat_sub -> true
                                 | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                                 | Coq3_Compilers.Coq_ident_nil _ -> true
                                 | Coq3_Compilers.Coq_ident_cons _ -> true
                                 | Coq3_Compilers.Coq_ident_tt -> true
                                 | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_prod_rect (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                     _, _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_list_case (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_length _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_seq -> true
                                 | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_combine (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_app _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_rev _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_flat_map (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_partition _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_filter _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_fold_right (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul -> true
                                 | Coq3_Compilers.Coq_ident_Z_pow -> true
                                 | Coq3_Compilers.Coq_ident_Z_sub -> true
                                 | Coq3_Compilers.Coq_ident_Z_opp -> true
                                 | Coq3_Compilers.Coq_ident_Z_div -> true
                                 | Coq3_Compilers.Coq_ident_Z_modulo -> true
                                 | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                 | Coq3_Compilers.Coq_ident_Z_leb -> true
                                 | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                 | Coq3_Compilers.Coq_ident_Z_geb -> true
                                 | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                 | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                                 | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                                 | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                                 | Coq3_Compilers.Coq_ident_Z_land -> true
                                 | Coq3_Compilers.Coq_ident_Z_lor -> true
                                 | Coq3_Compilers.Coq_ident_Z_min -> true
                                 | Coq3_Compilers.Coq_ident_Z_max -> true
                                 | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                 | Coq3_Compilers.Coq_ident_Z_zselect -> true
                                 | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                 | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                   false
                                 | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                 | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                 | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                 | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Z_cast -> true
                                 | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                                 | Coq3_Compilers.Coq_ident_Some _ -> true
                                 | Coq3_Compilers.Coq_ident_None _ -> true
                                 | Coq3_Compilers.Coq_ident_option_rect (
                                     _, _) ->
                                   true
                                 | Coq3_Compilers.Coq_ident_Build_zrange ->
                                   true
                                 | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_add -> true
                                 | Coq3_Compilers.Coq_ident_fancy_addc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sub -> true
                                 | Coq3_Compilers.Coq_ident_fancy_subb ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selc ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_selm ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_sell ->
                                   true
                                 | Coq3_Compilers.Coq_ident_fancy_addm ->
                                   true)
                              | Compilers.Coq_expr.Var (_, _) -> true
                              | Compilers.Coq_expr.Abs (_, _, _) -> true
                              | Compilers.Coq_expr.App (_, _, f2, _) ->
                                (match f2 with
                                 | Compilers.Coq_expr.Ident (_, idc) ->
                                   (match idc with
                                    | Coq3_Compilers.Coq_ident_Literal (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_value_barrier ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_max ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nil _ -> true
                                    | Coq3_Compilers.Coq_ident_cons _ -> true
                                    | Coq3_Compilers.Coq_ident_tt -> true
                                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_prod_rect (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                        _, _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_list_case (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_length _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_seq ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_combine (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_app _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_flat_map (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_fold_right (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                                      false
                                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul -> true
                                    | Coq3_Compilers.Coq_ident_Z_pow -> true
                                    | Coq3_Compilers.Coq_ident_Z_sub -> true
                                    | Coq3_Compilers.Coq_ident_Z_opp -> true
                                    | Coq3_Compilers.Coq_ident_Z_div -> true
                                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_eqb -> true
                                    | Coq3_Compilers.Coq_ident_Z_leb -> true
                                    | Coq3_Compilers.Coq_ident_Z_ltb -> true
                                    | Coq3_Compilers.Coq_ident_Z_geb -> true
                                    | Coq3_Compilers.Coq_ident_Z_gtb -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2 -> true
                                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_land -> true
                                    | Coq3_Compilers.Coq_ident_Z_lor -> true
                                    | Coq3_Compilers.Coq_ident_Z_min -> true
                                    | Coq3_Compilers.Coq_ident_Z_max -> true
                                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_ltz -> true
                                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_bneg -> true
                                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_lxor -> true
                                    | Coq3_Compilers.Coq_ident_Z_rshi -> true
                                    | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Z_cast -> true
                                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Some _ -> true
                                    | Coq3_Compilers.Coq_ident_None _ -> true
                                    | Coq3_Compilers.Coq_ident_option_rect (
                                        _, _) ->
                                      true
                                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                                      true
                                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_add ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                                      true
                                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                                      true)
                                 | Compilers.Coq_expr.Var (_, _) -> true
                                 | Compilers.Coq_expr.Abs (_, _, _) -> true
                                 | Compilers.Coq_expr.App (_, _, _, _) ->
                                   true
                                 | Compilers.Coq_expr.LetIn (_, _, _, _) ->
                                   true)
                              | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)))
                        f0)
                  | Coq3_Compilers.Coq_string ->
                    (fun f0 _ ->
                      match f0 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, f1, _) ->
                        (match f1 with
                         | Compilers.Coq_expr.Ident (_, idc) ->
                           (match idc with
                            | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                            | Coq3_Compilers.Coq_ident_comment _ -> true
                            | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_value_barrier -> true
                            | Coq3_Compilers.Coq_ident_Nat_succ -> true
                            | Coq3_Compilers.Coq_ident_Nat_pred -> true
                            | Coq3_Compilers.Coq_ident_Nat_max -> true
                            | Coq3_Compilers.Coq_ident_Nat_mul -> true
                            | Coq3_Compilers.Coq_ident_Nat_add -> true
                            | Coq3_Compilers.Coq_ident_Nat_sub -> true
                            | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                            | Coq3_Compilers.Coq_ident_nil _ -> true
                            | Coq3_Compilers.Coq_ident_cons _ -> true
                            | Coq3_Compilers.Coq_ident_tt -> true
                            | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                            | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                            | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                            | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                            | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                              true
                            | Coq3_Compilers.Coq_ident_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                                _, _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_length _ -> true
                            | Coq3_Compilers.Coq_ident_List_seq -> true
                            | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                            | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                            | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                            | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_app _ -> true
                            | Coq3_Compilers.Coq_ident_List_rev _ -> true
                            | Coq3_Compilers.Coq_ident_List_flat_map (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_partition _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_filter _ -> true
                            | Coq3_Compilers.Coq_ident_List_fold_right (
                                _, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                              true
                            | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                              false
                            | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add -> true
                            | Coq3_Compilers.Coq_ident_Z_mul -> true
                            | Coq3_Compilers.Coq_ident_Z_pow -> true
                            | Coq3_Compilers.Coq_ident_Z_sub -> true
                            | Coq3_Compilers.Coq_ident_Z_opp -> true
                            | Coq3_Compilers.Coq_ident_Z_div -> true
                            | Coq3_Compilers.Coq_ident_Z_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_eqb -> true
                            | Coq3_Compilers.Coq_ident_Z_leb -> true
                            | Coq3_Compilers.Coq_ident_Z_ltb -> true
                            | Coq3_Compilers.Coq_ident_Z_geb -> true
                            | Coq3_Compilers.Coq_ident_Z_gtb -> true
                            | Coq3_Compilers.Coq_ident_Z_log2 -> true
                            | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                            | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                            | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                            | Coq3_Compilers.Coq_ident_Z_land -> true
                            | Coq3_Compilers.Coq_ident_Z_lor -> true
                            | Coq3_Compilers.Coq_ident_Z_min -> true
                            | Coq3_Compilers.Coq_ident_Z_max -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                            | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                            | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_ltz -> true
                            | Coq3_Compilers.Coq_ident_Z_zselect -> true
                            | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_bneg -> true
                            | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                            | Coq3_Compilers.Coq_ident_Z_lxor -> true
                            | Coq3_Compilers.Coq_ident_Z_rshi -> true
                            | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                            | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                              true
                            | Coq3_Compilers.Coq_ident_Z_cast -> true
                            | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                            | Coq3_Compilers.Coq_ident_Some _ -> true
                            | Coq3_Compilers.Coq_ident_None _ -> true
                            | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                              true
                            | Coq3_Compilers.Coq_ident_Build_zrange -> true
                            | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                            | Coq3_Compilers.Coq_ident_fancy_add -> true
                            | Coq3_Compilers.Coq_ident_fancy_addc -> true
                            | Coq3_Compilers.Coq_ident_fancy_sub -> true
                            | Coq3_Compilers.Coq_ident_fancy_subb -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                            | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                            | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                            | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                            | Coq3_Compilers.Coq_ident_fancy_selc -> true
                            | Coq3_Compilers.Coq_ident_fancy_selm -> true
                            | Coq3_Compilers.Coq_ident_fancy_sell -> true
                            | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                         | Compilers.Coq_expr.Var (_, _) -> true
                         | Compilers.Coq_expr.Abs (_, _, _) -> true
                         | Compilers.Coq_expr.App (_, _, _, _) -> true
                         | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
               | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
                 (fun f0 _ ->
                   match f0 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, f1, _) ->
                     (match f1 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           false
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, _, _) -> true
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
               | Compilers.Coq_base.Coq_type.Coq_list _ ->
                 (fun f0 _ ->
                   match f0 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, f1, _) ->
                     (match f1 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           false
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, _, _) -> true
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
               | Compilers.Coq_base.Coq_type.Coq_option _ ->
                 (fun f0 _ ->
                   match f0 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, f1, _) ->
                     (match f1 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           false
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, _, _) -> true
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
               | Compilers.Coq_base.Coq_type.Coq_unit ->
                 (fun f0 _ ->
                   match f0 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, f1, _) ->
                     (match f1 with
                      | Compilers.Coq_expr.Ident (_, idc) ->
                        (match idc with
                         | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                         | Coq3_Compilers.Coq_ident_comment _ -> true
                         | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                         | Coq3_Compilers.Coq_ident_value_barrier -> true
                         | Coq3_Compilers.Coq_ident_Nat_succ -> true
                         | Coq3_Compilers.Coq_ident_Nat_pred -> true
                         | Coq3_Compilers.Coq_ident_Nat_max -> true
                         | Coq3_Compilers.Coq_ident_Nat_mul -> true
                         | Coq3_Compilers.Coq_ident_Nat_add -> true
                         | Coq3_Compilers.Coq_ident_Nat_sub -> true
                         | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                         | Coq3_Compilers.Coq_ident_nil _ -> true
                         | Coq3_Compilers.Coq_ident_cons _ -> true
                         | Coq3_Compilers.Coq_ident_tt -> true
                         | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                         | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                         | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                         | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                         | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                         | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                             _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                         | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                             _, _, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_length _ -> true
                         | Coq3_Compilers.Coq_ident_List_seq -> true
                         | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                         | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                         | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                         | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                         | Coq3_Compilers.Coq_ident_List_app _ -> true
                         | Coq3_Compilers.Coq_ident_List_rev _ -> true
                         | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_partition _ -> true
                         | Coq3_Compilers.Coq_ident_List_filter _ -> true
                         | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                         | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                           false
                         | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_add -> true
                         | Coq3_Compilers.Coq_ident_Z_mul -> true
                         | Coq3_Compilers.Coq_ident_Z_pow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub -> true
                         | Coq3_Compilers.Coq_ident_Z_opp -> true
                         | Coq3_Compilers.Coq_ident_Z_div -> true
                         | Coq3_Compilers.Coq_ident_Z_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_eqb -> true
                         | Coq3_Compilers.Coq_ident_Z_leb -> true
                         | Coq3_Compilers.Coq_ident_Z_ltb -> true
                         | Coq3_Compilers.Coq_ident_Z_geb -> true
                         | Coq3_Compilers.Coq_ident_Z_gtb -> true
                         | Coq3_Compilers.Coq_ident_Z_log2 -> true
                         | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                         | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                         | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                         | Coq3_Compilers.Coq_ident_Z_land -> true
                         | Coq3_Compilers.Coq_ident_Z_lor -> true
                         | Coq3_Compilers.Coq_ident_Z_min -> true
                         | Coq3_Compilers.Coq_ident_Z_max -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                         | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                         | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                         | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                         | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_ltz -> true
                         | Coq3_Compilers.Coq_ident_Z_zselect -> true
                         | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_bneg -> true
                         | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                         | Coq3_Compilers.Coq_ident_Z_lxor -> true
                         | Coq3_Compilers.Coq_ident_Z_rshi -> true
                         | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                         | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                           true
                         | Coq3_Compilers.Coq_ident_Z_cast -> true
                         | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                         | Coq3_Compilers.Coq_ident_Some _ -> true
                         | Coq3_Compilers.Coq_ident_None _ -> true
                         | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                           true
                         | Coq3_Compilers.Coq_ident_Build_zrange -> true
                         | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                         | Coq3_Compilers.Coq_ident_fancy_add -> true
                         | Coq3_Compilers.Coq_ident_fancy_addc -> true
                         | Coq3_Compilers.Coq_ident_fancy_sub -> true
                         | Coq3_Compilers.Coq_ident_fancy_subb -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                         | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                         | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                         | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                         | Coq3_Compilers.Coq_ident_fancy_selc -> true
                         | Coq3_Compilers.Coq_ident_fancy_selm -> true
                         | Coq3_Compilers.Coq_ident_fancy_sell -> true
                         | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                      | Compilers.Coq_expr.Var (_, _) -> true
                      | Compilers.Coq_expr.Abs (_, _, _) -> true
                      | Compilers.Coq_expr.App (_, _, _, _) -> true
                      | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
            | Coq3_Compilers.Coq_string ->
              (fun f0 _ ->
                match f0 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, f1, _) ->
                  (match f1 with
                   | Compilers.Coq_expr.Ident (_, idc) ->
                     (match idc with
                      | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                      | Coq3_Compilers.Coq_ident_comment _ -> true
                      | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                      | Coq3_Compilers.Coq_ident_value_barrier -> true
                      | Coq3_Compilers.Coq_ident_Nat_succ -> true
                      | Coq3_Compilers.Coq_ident_Nat_pred -> true
                      | Coq3_Compilers.Coq_ident_Nat_max -> true
                      | Coq3_Compilers.Coq_ident_Nat_mul -> true
                      | Coq3_Compilers.Coq_ident_Nat_add -> true
                      | Coq3_Compilers.Coq_ident_Nat_sub -> true
                      | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                      | Coq3_Compilers.Coq_ident_nil _ -> true
                      | Coq3_Compilers.Coq_ident_cons _ -> true
                      | Coq3_Compilers.Coq_ident_tt -> true
                      | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                      | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                      | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                      | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                      | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                      | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                      | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (
                          _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                          _, _, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_length _ -> true
                      | Coq3_Compilers.Coq_ident_List_seq -> true
                      | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                      | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                      | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                      | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_app _ -> true
                      | Coq3_Compilers.Coq_ident_List_rev _ -> true
                      | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                      | Coq3_Compilers.Coq_ident_List_partition _ -> true
                      | Coq3_Compilers.Coq_ident_List_filter _ -> true
                      | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                        true
                      | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                      | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                      | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_add -> true
                      | Coq3_Compilers.Coq_ident_Z_mul -> true
                      | Coq3_Compilers.Coq_ident_Z_pow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub -> true
                      | Coq3_Compilers.Coq_ident_Z_opp -> true
                      | Coq3_Compilers.Coq_ident_Z_div -> true
                      | Coq3_Compilers.Coq_ident_Z_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_eqb -> true
                      | Coq3_Compilers.Coq_ident_Z_leb -> true
                      | Coq3_Compilers.Coq_ident_Z_ltb -> true
                      | Coq3_Compilers.Coq_ident_Z_geb -> true
                      | Coq3_Compilers.Coq_ident_Z_gtb -> true
                      | Coq3_Compilers.Coq_ident_Z_log2 -> true
                      | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                      | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                      | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_land -> true
                      | Coq3_Compilers.Coq_ident_Z_lor -> true
                      | Coq3_Compilers.Coq_ident_Z_min -> true
                      | Coq3_Compilers.Coq_ident_Z_max -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                      | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                      | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                      | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_ltz -> true
                      | Coq3_Compilers.Coq_ident_Z_zselect -> true
                      | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                      | Coq3_Compilers.Coq_ident_Z_bneg -> true
                      | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                      | Coq3_Compilers.Coq_ident_Z_lxor -> true
                      | Coq3_Compilers.Coq_ident_Z_rshi -> true
                      | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                      | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                        true
                      | Coq3_Compilers.Coq_ident_Z_cast -> true
                      | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                      | Coq3_Compilers.Coq_ident_Some _ -> true
                      | Coq3_Compilers.Coq_ident_None _ -> true
                      | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                      | Coq3_Compilers.Coq_ident_Build_zrange -> true
                      | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                      | Coq3_Compilers.Coq_ident_fancy_add -> true
                      | Coq3_Compilers.Coq_ident_fancy_addc -> true
                      | Coq3_Compilers.Coq_ident_fancy_sub -> true
                      | Coq3_Compilers.Coq_ident_fancy_subb -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                      | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                      | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                      | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                      | Coq3_Compilers.Coq_ident_fancy_selc -> true
                      | Coq3_Compilers.Coq_ident_fancy_selm -> true
                      | Coq3_Compilers.Coq_ident_fancy_sell -> true
                      | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                   | Compilers.Coq_expr.Var (_, _) -> true
                   | Compilers.Coq_expr.Abs (_, _, _) -> true
                   | Compilers.Coq_expr.App (_, _, _, _) -> true
                   | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
         | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
         | Compilers.Coq_base.Coq_type.Coq_list _ ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
         | Compilers.Coq_base.Coq_type.Coq_option _ ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
         | Compilers.Coq_base.Coq_type.Coq_unit ->
           (fun f0 _ ->
             match f0 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, f1, _) ->
               (match f1 with
                | Compilers.Coq_expr.Ident (_, idc) ->
                  (match idc with
                   | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                   | Coq3_Compilers.Coq_ident_comment _ -> true
                   | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                   | Coq3_Compilers.Coq_ident_value_barrier -> true
                   | Coq3_Compilers.Coq_ident_Nat_succ -> true
                   | Coq3_Compilers.Coq_ident_Nat_pred -> true
                   | Coq3_Compilers.Coq_ident_Nat_max -> true
                   | Coq3_Compilers.Coq_ident_Nat_mul -> true
                   | Coq3_Compilers.Coq_ident_Nat_add -> true
                   | Coq3_Compilers.Coq_ident_Nat_sub -> true
                   | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                   | Coq3_Compilers.Coq_ident_nil _ -> true
                   | Coq3_Compilers.Coq_ident_cons _ -> true
                   | Coq3_Compilers.Coq_ident_tt -> true
                   | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                   | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                   | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                   | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                   | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                   | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                   | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                       _, _, _) ->
                     true
                   | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_length _ -> true
                   | Coq3_Compilers.Coq_ident_List_seq -> true
                   | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                   | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                   | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                   | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_app _ -> true
                   | Coq3_Compilers.Coq_ident_List_rev _ -> true
                   | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_partition _ -> true
                   | Coq3_Compilers.Coq_ident_List_filter _ -> true
                   | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                   | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                   | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                   | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                     true
                   | Coq3_Compilers.Coq_ident_Z_add -> true
                   | Coq3_Compilers.Coq_ident_Z_mul -> true
                   | Coq3_Compilers.Coq_ident_Z_pow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub -> true
                   | Coq3_Compilers.Coq_ident_Z_opp -> true
                   | Coq3_Compilers.Coq_ident_Z_div -> true
                   | Coq3_Compilers.Coq_ident_Z_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_eqb -> true
                   | Coq3_Compilers.Coq_ident_Z_leb -> true
                   | Coq3_Compilers.Coq_ident_Z_ltb -> true
                   | Coq3_Compilers.Coq_ident_Z_geb -> true
                   | Coq3_Compilers.Coq_ident_Z_gtb -> true
                   | Coq3_Compilers.Coq_ident_Z_log2 -> true
                   | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                   | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                   | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_land -> true
                   | Coq3_Compilers.Coq_ident_Z_lor -> true
                   | Coq3_Compilers.Coq_ident_Z_min -> true
                   | Coq3_Compilers.Coq_ident_Z_max -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                   | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                   | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                   | Coq3_Compilers.Coq_ident_Z_ltz -> true
                   | Coq3_Compilers.Coq_ident_Z_zselect -> true
                   | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                   | Coq3_Compilers.Coq_ident_Z_bneg -> true
                   | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                   | Coq3_Compilers.Coq_ident_Z_lxor -> true
                   | Coq3_Compilers.Coq_ident_Z_rshi -> true
                   | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                   | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                   | Coq3_Compilers.Coq_ident_Z_cast -> true
                   | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                   | Coq3_Compilers.Coq_ident_Some _ -> true
                   | Coq3_Compilers.Coq_ident_None _ -> true
                   | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                   | Coq3_Compilers.Coq_ident_Build_zrange -> true
                   | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                   | Coq3_Compilers.Coq_ident_fancy_add -> true
                   | Coq3_Compilers.Coq_ident_fancy_addc -> true
                   | Coq3_Compilers.Coq_ident_fancy_sub -> true
                   | Coq3_Compilers.Coq_ident_fancy_subb -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                   | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                   | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                   | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                   | Coq3_Compilers.Coq_ident_fancy_selc -> true
                   | Coq3_Compilers.Coq_ident_fancy_selm -> true
                   | Coq3_Compilers.Coq_ident_fancy_sell -> true
                   | Coq3_Compilers.Coq_ident_fancy_addm -> true)
                | Compilers.Coq_expr.Var (_, _) -> true
                | Compilers.Coq_expr.Abs (_, _, _) -> true
                | Compilers.Coq_expr.App (_, _, _, _) -> true
                | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
      | Compilers.Coq_base.Coq_type.Coq_list _ ->
        (fun f0 _ ->
          match f0 with
          | Compilers.Coq_expr.Ident (_, idc) ->
            (match idc with
             | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
             | Coq3_Compilers.Coq_ident_comment _ -> true
             | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
             | Coq3_Compilers.Coq_ident_value_barrier -> true
             | Coq3_Compilers.Coq_ident_Nat_succ -> true
             | Coq3_Compilers.Coq_ident_Nat_pred -> true
             | Coq3_Compilers.Coq_ident_Nat_max -> true
             | Coq3_Compilers.Coq_ident_Nat_mul -> true
             | Coq3_Compilers.Coq_ident_Nat_add -> true
             | Coq3_Compilers.Coq_ident_Nat_sub -> true
             | Coq3_Compilers.Coq_ident_Nat_eqb -> true
             | Coq3_Compilers.Coq_ident_nil _ -> true
             | Coq3_Compilers.Coq_ident_cons _ -> true
             | Coq3_Compilers.Coq_ident_tt -> true
             | Coq3_Compilers.Coq_ident_pair (_, _) -> true
             | Coq3_Compilers.Coq_ident_fst (_, _) -> true
             | Coq3_Compilers.Coq_ident_snd (_, _) -> true
             | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_bool_rect _ -> true
             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
               true
             | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_length _ -> true
             | Coq3_Compilers.Coq_ident_List_seq -> true
             | Coq3_Compilers.Coq_ident_List_firstn _ -> true
             | Coq3_Compilers.Coq_ident_List_skipn _ -> true
             | Coq3_Compilers.Coq_ident_List_repeat _ -> true
             | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_app _ -> true
             | Coq3_Compilers.Coq_ident_List_rev _ -> true
             | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_partition _ -> true
             | Coq3_Compilers.Coq_ident_List_filter _ -> true
             | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
             | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
             | Coq3_Compilers.Coq_ident_Z_add -> true
             | Coq3_Compilers.Coq_ident_Z_mul -> true
             | Coq3_Compilers.Coq_ident_Z_pow -> true
             | Coq3_Compilers.Coq_ident_Z_sub -> true
             | Coq3_Compilers.Coq_ident_Z_opp -> true
             | Coq3_Compilers.Coq_ident_Z_div -> true
             | Coq3_Compilers.Coq_ident_Z_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_eqb -> true
             | Coq3_Compilers.Coq_ident_Z_leb -> true
             | Coq3_Compilers.Coq_ident_Z_ltb -> true
             | Coq3_Compilers.Coq_ident_Z_geb -> true
             | Coq3_Compilers.Coq_ident_Z_gtb -> true
             | Coq3_Compilers.Coq_ident_Z_log2 -> true
             | Coq3_Compilers.Coq_ident_Z_log2_up -> true
             | Coq3_Compilers.Coq_ident_Z_of_nat -> true
             | Coq3_Compilers.Coq_ident_Z_to_nat -> true
             | Coq3_Compilers.Coq_ident_Z_shiftr -> true
             | Coq3_Compilers.Coq_ident_Z_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_land -> true
             | Coq3_Compilers.Coq_ident_Z_lor -> true
             | Coq3_Compilers.Coq_ident_Z_min -> true
             | Coq3_Compilers.Coq_ident_Z_max -> true
             | Coq3_Compilers.Coq_ident_Z_mul_split -> true
             | Coq3_Compilers.Coq_ident_Z_mul_high -> true
             | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_ltz -> true
             | Coq3_Compilers.Coq_ident_Z_zselect -> true
             | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_bneg -> true
             | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
             | Coq3_Compilers.Coq_ident_Z_lxor -> true
             | Coq3_Compilers.Coq_ident_Z_rshi -> true
             | Coq3_Compilers.Coq_ident_Z_cc_m -> true
             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
             | Coq3_Compilers.Coq_ident_Z_cast -> true
             | Coq3_Compilers.Coq_ident_Z_cast2 -> true
             | Coq3_Compilers.Coq_ident_Some _ -> true
             | Coq3_Compilers.Coq_ident_None _ -> true
             | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_Build_zrange -> true
             | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
             | Coq3_Compilers.Coq_ident_fancy_add -> true
             | Coq3_Compilers.Coq_ident_fancy_addc -> true
             | Coq3_Compilers.Coq_ident_fancy_sub -> true
             | Coq3_Compilers.Coq_ident_fancy_subb -> true
             | Coq3_Compilers.Coq_ident_fancy_mulll -> true
             | Coq3_Compilers.Coq_ident_fancy_mullh -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
             | Coq3_Compilers.Coq_ident_fancy_rshi -> true
             | Coq3_Compilers.Coq_ident_fancy_selc -> true
             | Coq3_Compilers.Coq_ident_fancy_selm -> true
             | Coq3_Compilers.Coq_ident_fancy_sell -> true
             | Coq3_Compilers.Coq_ident_fancy_addm -> true)
          | Compilers.Coq_expr.Var (_, _) -> true
          | Compilers.Coq_expr.Abs (_, _, _) -> true
          | Compilers.Coq_expr.App (_, _, f1, _) ->
            (match f1 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, _, _) -> true
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
          | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
      | Compilers.Coq_base.Coq_type.Coq_option _ ->
        (fun f0 _ ->
          match f0 with
          | Compilers.Coq_expr.Ident (_, idc) ->
            (match idc with
             | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
             | Coq3_Compilers.Coq_ident_comment _ -> true
             | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
             | Coq3_Compilers.Coq_ident_value_barrier -> true
             | Coq3_Compilers.Coq_ident_Nat_succ -> true
             | Coq3_Compilers.Coq_ident_Nat_pred -> true
             | Coq3_Compilers.Coq_ident_Nat_max -> true
             | Coq3_Compilers.Coq_ident_Nat_mul -> true
             | Coq3_Compilers.Coq_ident_Nat_add -> true
             | Coq3_Compilers.Coq_ident_Nat_sub -> true
             | Coq3_Compilers.Coq_ident_Nat_eqb -> true
             | Coq3_Compilers.Coq_ident_nil _ -> true
             | Coq3_Compilers.Coq_ident_cons _ -> true
             | Coq3_Compilers.Coq_ident_tt -> true
             | Coq3_Compilers.Coq_ident_pair (_, _) -> true
             | Coq3_Compilers.Coq_ident_fst (_, _) -> true
             | Coq3_Compilers.Coq_ident_snd (_, _) -> true
             | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_bool_rect _ -> true
             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
               true
             | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_length _ -> true
             | Coq3_Compilers.Coq_ident_List_seq -> true
             | Coq3_Compilers.Coq_ident_List_firstn _ -> true
             | Coq3_Compilers.Coq_ident_List_skipn _ -> true
             | Coq3_Compilers.Coq_ident_List_repeat _ -> true
             | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_app _ -> true
             | Coq3_Compilers.Coq_ident_List_rev _ -> true
             | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_partition _ -> true
             | Coq3_Compilers.Coq_ident_List_filter _ -> true
             | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
             | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
             | Coq3_Compilers.Coq_ident_Z_add -> true
             | Coq3_Compilers.Coq_ident_Z_mul -> true
             | Coq3_Compilers.Coq_ident_Z_pow -> true
             | Coq3_Compilers.Coq_ident_Z_sub -> true
             | Coq3_Compilers.Coq_ident_Z_opp -> true
             | Coq3_Compilers.Coq_ident_Z_div -> true
             | Coq3_Compilers.Coq_ident_Z_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_eqb -> true
             | Coq3_Compilers.Coq_ident_Z_leb -> true
             | Coq3_Compilers.Coq_ident_Z_ltb -> true
             | Coq3_Compilers.Coq_ident_Z_geb -> true
             | Coq3_Compilers.Coq_ident_Z_gtb -> true
             | Coq3_Compilers.Coq_ident_Z_log2 -> true
             | Coq3_Compilers.Coq_ident_Z_log2_up -> true
             | Coq3_Compilers.Coq_ident_Z_of_nat -> true
             | Coq3_Compilers.Coq_ident_Z_to_nat -> true
             | Coq3_Compilers.Coq_ident_Z_shiftr -> true
             | Coq3_Compilers.Coq_ident_Z_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_land -> true
             | Coq3_Compilers.Coq_ident_Z_lor -> true
             | Coq3_Compilers.Coq_ident_Z_min -> true
             | Coq3_Compilers.Coq_ident_Z_max -> true
             | Coq3_Compilers.Coq_ident_Z_mul_split -> true
             | Coq3_Compilers.Coq_ident_Z_mul_high -> true
             | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_ltz -> true
             | Coq3_Compilers.Coq_ident_Z_zselect -> true
             | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_bneg -> true
             | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
             | Coq3_Compilers.Coq_ident_Z_lxor -> true
             | Coq3_Compilers.Coq_ident_Z_rshi -> true
             | Coq3_Compilers.Coq_ident_Z_cc_m -> true
             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
             | Coq3_Compilers.Coq_ident_Z_cast -> true
             | Coq3_Compilers.Coq_ident_Z_cast2 -> true
             | Coq3_Compilers.Coq_ident_Some _ -> true
             | Coq3_Compilers.Coq_ident_None _ -> true
             | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_Build_zrange -> true
             | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
             | Coq3_Compilers.Coq_ident_fancy_add -> true
             | Coq3_Compilers.Coq_ident_fancy_addc -> true
             | Coq3_Compilers.Coq_ident_fancy_sub -> true
             | Coq3_Compilers.Coq_ident_fancy_subb -> true
             | Coq3_Compilers.Coq_ident_fancy_mulll -> true
             | Coq3_Compilers.Coq_ident_fancy_mullh -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
             | Coq3_Compilers.Coq_ident_fancy_rshi -> true
             | Coq3_Compilers.Coq_ident_fancy_selc -> true
             | Coq3_Compilers.Coq_ident_fancy_selm -> true
             | Coq3_Compilers.Coq_ident_fancy_sell -> true
             | Coq3_Compilers.Coq_ident_fancy_addm -> true)
          | Compilers.Coq_expr.Var (_, _) -> true
          | Compilers.Coq_expr.Abs (_, _, _) -> true
          | Compilers.Coq_expr.App (_, _, f1, _) ->
            (match f1 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, _, _) -> true
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
          | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
      | Compilers.Coq_base.Coq_type.Coq_unit ->
        (fun f0 _ ->
          match f0 with
          | Compilers.Coq_expr.Ident (_, idc) ->
            (match idc with
             | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
             | Coq3_Compilers.Coq_ident_comment _ -> true
             | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
             | Coq3_Compilers.Coq_ident_value_barrier -> true
             | Coq3_Compilers.Coq_ident_Nat_succ -> true
             | Coq3_Compilers.Coq_ident_Nat_pred -> true
             | Coq3_Compilers.Coq_ident_Nat_max -> true
             | Coq3_Compilers.Coq_ident_Nat_mul -> true
             | Coq3_Compilers.Coq_ident_Nat_add -> true
             | Coq3_Compilers.Coq_ident_Nat_sub -> true
             | Coq3_Compilers.Coq_ident_Nat_eqb -> true
             | Coq3_Compilers.Coq_ident_nil _ -> true
             | Coq3_Compilers.Coq_ident_cons _ -> true
             | Coq3_Compilers.Coq_ident_tt -> true
             | Coq3_Compilers.Coq_ident_pair (_, _) -> true
             | Coq3_Compilers.Coq_ident_fst (_, _) -> true
             | Coq3_Compilers.Coq_ident_snd (_, _) -> true
             | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_bool_rect _ -> true
             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
               true
             | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_length _ -> true
             | Coq3_Compilers.Coq_ident_List_seq -> true
             | Coq3_Compilers.Coq_ident_List_firstn _ -> true
             | Coq3_Compilers.Coq_ident_List_skipn _ -> true
             | Coq3_Compilers.Coq_ident_List_repeat _ -> true
             | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_app _ -> true
             | Coq3_Compilers.Coq_ident_List_rev _ -> true
             | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_partition _ -> true
             | Coq3_Compilers.Coq_ident_List_filter _ -> true
             | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
             | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
             | Coq3_Compilers.Coq_ident_Z_add -> true
             | Coq3_Compilers.Coq_ident_Z_mul -> true
             | Coq3_Compilers.Coq_ident_Z_pow -> true
             | Coq3_Compilers.Coq_ident_Z_sub -> true
             | Coq3_Compilers.Coq_ident_Z_opp -> true
             | Coq3_Compilers.Coq_ident_Z_div -> true
             | Coq3_Compilers.Coq_ident_Z_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_eqb -> true
             | Coq3_Compilers.Coq_ident_Z_leb -> true
             | Coq3_Compilers.Coq_ident_Z_ltb -> true
             | Coq3_Compilers.Coq_ident_Z_geb -> true
             | Coq3_Compilers.Coq_ident_Z_gtb -> true
             | Coq3_Compilers.Coq_ident_Z_log2 -> true
             | Coq3_Compilers.Coq_ident_Z_log2_up -> true
             | Coq3_Compilers.Coq_ident_Z_of_nat -> true
             | Coq3_Compilers.Coq_ident_Z_to_nat -> true
             | Coq3_Compilers.Coq_ident_Z_shiftr -> true
             | Coq3_Compilers.Coq_ident_Z_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_land -> true
             | Coq3_Compilers.Coq_ident_Z_lor -> true
             | Coq3_Compilers.Coq_ident_Z_min -> true
             | Coq3_Compilers.Coq_ident_Z_max -> true
             | Coq3_Compilers.Coq_ident_Z_mul_split -> true
             | Coq3_Compilers.Coq_ident_Z_mul_high -> true
             | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_ltz -> true
             | Coq3_Compilers.Coq_ident_Z_zselect -> true
             | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_bneg -> true
             | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
             | Coq3_Compilers.Coq_ident_Z_lxor -> true
             | Coq3_Compilers.Coq_ident_Z_rshi -> true
             | Coq3_Compilers.Coq_ident_Z_cc_m -> true
             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
             | Coq3_Compilers.Coq_ident_Z_cast -> true
             | Coq3_Compilers.Coq_ident_Z_cast2 -> true
             | Coq3_Compilers.Coq_ident_Some _ -> true
             | Coq3_Compilers.Coq_ident_None _ -> true
             | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_Build_zrange -> true
             | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
             | Coq3_Compilers.Coq_ident_fancy_add -> true
             | Coq3_Compilers.Coq_ident_fancy_addc -> true
             | Coq3_Compilers.Coq_ident_fancy_sub -> true
             | Coq3_Compilers.Coq_ident_fancy_subb -> true
             | Coq3_Compilers.Coq_ident_fancy_mulll -> true
             | Coq3_Compilers.Coq_ident_fancy_mullh -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
             | Coq3_Compilers.Coq_ident_fancy_rshi -> true
             | Coq3_Compilers.Coq_ident_fancy_selc -> true
             | Coq3_Compilers.Coq_ident_fancy_selm -> true
             | Coq3_Compilers.Coq_ident_fancy_sell -> true
             | Coq3_Compilers.Coq_ident_fancy_addm -> true)
          | Compilers.Coq_expr.Var (_, _) -> true
          | Compilers.Coq_expr.Abs (_, _, _) -> true
          | Compilers.Coq_expr.App (_, _, f1, _) ->
            (match f1 with
             | Compilers.Coq_expr.Ident (_, idc) ->
               (match idc with
                | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
                | Coq3_Compilers.Coq_ident_comment _ -> true
                | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
                | Coq3_Compilers.Coq_ident_value_barrier -> true
                | Coq3_Compilers.Coq_ident_Nat_succ -> true
                | Coq3_Compilers.Coq_ident_Nat_pred -> true
                | Coq3_Compilers.Coq_ident_Nat_max -> true
                | Coq3_Compilers.Coq_ident_Nat_mul -> true
                | Coq3_Compilers.Coq_ident_Nat_add -> true
                | Coq3_Compilers.Coq_ident_Nat_sub -> true
                | Coq3_Compilers.Coq_ident_Nat_eqb -> true
                | Coq3_Compilers.Coq_ident_nil _ -> true
                | Coq3_Compilers.Coq_ident_cons _ -> true
                | Coq3_Compilers.Coq_ident_tt -> true
                | Coq3_Compilers.Coq_ident_pair (_, _) -> true
                | Coq3_Compilers.Coq_ident_fst (_, _) -> true
                | Coq3_Compilers.Coq_ident_snd (_, _) -> true
                | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_bool_rect _ -> true
                | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
                | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
                | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
                  true
                | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_length _ -> true
                | Coq3_Compilers.Coq_ident_List_seq -> true
                | Coq3_Compilers.Coq_ident_List_firstn _ -> true
                | Coq3_Compilers.Coq_ident_List_skipn _ -> true
                | Coq3_Compilers.Coq_ident_List_repeat _ -> true
                | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_app _ -> true
                | Coq3_Compilers.Coq_ident_List_rev _ -> true
                | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_partition _ -> true
                | Coq3_Compilers.Coq_ident_List_filter _ -> true
                | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
                | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
                | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
                | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
                | Coq3_Compilers.Coq_ident_Z_add -> true
                | Coq3_Compilers.Coq_ident_Z_mul -> true
                | Coq3_Compilers.Coq_ident_Z_pow -> true
                | Coq3_Compilers.Coq_ident_Z_sub -> true
                | Coq3_Compilers.Coq_ident_Z_opp -> true
                | Coq3_Compilers.Coq_ident_Z_div -> true
                | Coq3_Compilers.Coq_ident_Z_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_eqb -> true
                | Coq3_Compilers.Coq_ident_Z_leb -> true
                | Coq3_Compilers.Coq_ident_Z_ltb -> true
                | Coq3_Compilers.Coq_ident_Z_geb -> true
                | Coq3_Compilers.Coq_ident_Z_gtb -> true
                | Coq3_Compilers.Coq_ident_Z_log2 -> true
                | Coq3_Compilers.Coq_ident_Z_log2_up -> true
                | Coq3_Compilers.Coq_ident_Z_of_nat -> true
                | Coq3_Compilers.Coq_ident_Z_to_nat -> true
                | Coq3_Compilers.Coq_ident_Z_shiftr -> true
                | Coq3_Compilers.Coq_ident_Z_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_land -> true
                | Coq3_Compilers.Coq_ident_Z_lor -> true
                | Coq3_Compilers.Coq_ident_Z_min -> true
                | Coq3_Compilers.Coq_ident_Z_max -> true
                | Coq3_Compilers.Coq_ident_Z_mul_split -> true
                | Coq3_Compilers.Coq_ident_Z_mul_high -> true
                | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
                | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
                | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
                | Coq3_Compilers.Coq_ident_Z_ltz -> true
                | Coq3_Compilers.Coq_ident_Z_zselect -> true
                | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
                | Coq3_Compilers.Coq_ident_Z_bneg -> true
                | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
                | Coq3_Compilers.Coq_ident_Z_lxor -> true
                | Coq3_Compilers.Coq_ident_Z_rshi -> true
                | Coq3_Compilers.Coq_ident_Z_cc_m -> true
                | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
                | Coq3_Compilers.Coq_ident_Z_cast -> true
                | Coq3_Compilers.Coq_ident_Z_cast2 -> true
                | Coq3_Compilers.Coq_ident_Some _ -> true
                | Coq3_Compilers.Coq_ident_None _ -> true
                | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
                | Coq3_Compilers.Coq_ident_Build_zrange -> true
                | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
                | Coq3_Compilers.Coq_ident_fancy_add -> true
                | Coq3_Compilers.Coq_ident_fancy_addc -> true
                | Coq3_Compilers.Coq_ident_fancy_sub -> true
                | Coq3_Compilers.Coq_ident_fancy_subb -> true
                | Coq3_Compilers.Coq_ident_fancy_mulll -> true
                | Coq3_Compilers.Coq_ident_fancy_mullh -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
                | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
                | Coq3_Compilers.Coq_ident_fancy_rshi -> true
                | Coq3_Compilers.Coq_ident_fancy_selc -> true
                | Coq3_Compilers.Coq_ident_fancy_selm -> true
                | Coq3_Compilers.Coq_ident_fancy_sell -> true
                | Coq3_Compilers.Coq_ident_fancy_addm -> true)
             | Compilers.Coq_expr.Var (_, _) -> true
             | Compilers.Coq_expr.Abs (_, _, _) -> true
             | Compilers.Coq_expr.App (_, _, _, _) -> true
             | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
          | Compilers.Coq_expr.LetIn (_, _, _, _) -> true))
   | Compilers.Coq_type.Coq_arrow (_, _) ->
     (fun f0 _ ->
       match f0 with
       | Compilers.Coq_expr.Ident (_, idc) ->
         (match idc with
          | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
          | Coq3_Compilers.Coq_ident_comment _ -> true
          | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
          | Coq3_Compilers.Coq_ident_value_barrier -> true
          | Coq3_Compilers.Coq_ident_Nat_succ -> true
          | Coq3_Compilers.Coq_ident_Nat_pred -> true
          | Coq3_Compilers.Coq_ident_Nat_max -> true
          | Coq3_Compilers.Coq_ident_Nat_mul -> true
          | Coq3_Compilers.Coq_ident_Nat_add -> true
          | Coq3_Compilers.Coq_ident_Nat_sub -> true
          | Coq3_Compilers.Coq_ident_Nat_eqb -> true
          | Coq3_Compilers.Coq_ident_nil _ -> true
          | Coq3_Compilers.Coq_ident_cons _ -> true
          | Coq3_Compilers.Coq_ident_tt -> true
          | Coq3_Compilers.Coq_ident_pair (_, _) -> true
          | Coq3_Compilers.Coq_ident_fst (_, _) -> true
          | Coq3_Compilers.Coq_ident_snd (_, _) -> true
          | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
          | Coq3_Compilers.Coq_ident_bool_rect _ -> true
          | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
          | Coq3_Compilers.Coq_ident_nat_rect _ -> true
          | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
          | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
          | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
          | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
          | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
          | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
          | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> true
          | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
          | Coq3_Compilers.Coq_ident_List_length _ -> true
          | Coq3_Compilers.Coq_ident_List_seq -> true
          | Coq3_Compilers.Coq_ident_List_firstn _ -> true
          | Coq3_Compilers.Coq_ident_List_skipn _ -> true
          | Coq3_Compilers.Coq_ident_List_repeat _ -> true
          | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
          | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
          | Coq3_Compilers.Coq_ident_List_app _ -> true
          | Coq3_Compilers.Coq_ident_List_rev _ -> true
          | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
          | Coq3_Compilers.Coq_ident_List_partition _ -> true
          | Coq3_Compilers.Coq_ident_List_filter _ -> true
          | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
          | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
          | Coq3_Compilers.Coq_ident_List_nth_default _ -> true
          | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
          | Coq3_Compilers.Coq_ident_Z_add -> true
          | Coq3_Compilers.Coq_ident_Z_mul -> true
          | Coq3_Compilers.Coq_ident_Z_pow -> true
          | Coq3_Compilers.Coq_ident_Z_sub -> true
          | Coq3_Compilers.Coq_ident_Z_opp -> true
          | Coq3_Compilers.Coq_ident_Z_div -> true
          | Coq3_Compilers.Coq_ident_Z_modulo -> true
          | Coq3_Compilers.Coq_ident_Z_eqb -> true
          | Coq3_Compilers.Coq_ident_Z_leb -> true
          | Coq3_Compilers.Coq_ident_Z_ltb -> true
          | Coq3_Compilers.Coq_ident_Z_geb -> true
          | Coq3_Compilers.Coq_ident_Z_gtb -> true
          | Coq3_Compilers.Coq_ident_Z_log2 -> true
          | Coq3_Compilers.Coq_ident_Z_log2_up -> true
          | Coq3_Compilers.Coq_ident_Z_of_nat -> true
          | Coq3_Compilers.Coq_ident_Z_to_nat -> true
          | Coq3_Compilers.Coq_ident_Z_shiftr -> true
          | Coq3_Compilers.Coq_ident_Z_shiftl -> true
          | Coq3_Compilers.Coq_ident_Z_land -> true
          | Coq3_Compilers.Coq_ident_Z_lor -> true
          | Coq3_Compilers.Coq_ident_Z_min -> true
          | Coq3_Compilers.Coq_ident_Z_max -> true
          | Coq3_Compilers.Coq_ident_Z_mul_split -> true
          | Coq3_Compilers.Coq_ident_Z_mul_high -> true
          | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
          | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
          | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
          | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
          | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
          | Coq3_Compilers.Coq_ident_Z_ltz -> true
          | Coq3_Compilers.Coq_ident_Z_zselect -> true
          | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
          | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
          | Coq3_Compilers.Coq_ident_Z_bneg -> true
          | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> false
          | Coq3_Compilers.Coq_ident_Z_lxor -> true
          | Coq3_Compilers.Coq_ident_Z_rshi -> true
          | Coq3_Compilers.Coq_ident_Z_cc_m -> true
          | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
          | Coq3_Compilers.Coq_ident_Z_cast -> true
          | Coq3_Compilers.Coq_ident_Z_cast2 -> true
          | Coq3_Compilers.Coq_ident_Some _ -> true
          | Coq3_Compilers.Coq_ident_None _ -> true
          | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
          | Coq3_Compilers.Coq_ident_Build_zrange -> true
          | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
          | Coq3_Compilers.Coq_ident_fancy_add -> true
          | Coq3_Compilers.Coq_ident_fancy_addc -> true
          | Coq3_Compilers.Coq_ident_fancy_sub -> true
          | Coq3_Compilers.Coq_ident_fancy_subb -> true
          | Coq3_Compilers.Coq_ident_fancy_mulll -> true
          | Coq3_Compilers.Coq_ident_fancy_mullh -> true
          | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
          | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
          | Coq3_Compilers.Coq_ident_fancy_rshi -> true
          | Coq3_Compilers.Coq_ident_fancy_selc -> true
          | Coq3_Compilers.Coq_ident_fancy_selm -> true
          | Coq3_Compilers.Coq_ident_fancy_sell -> true
          | Coq3_Compilers.Coq_ident_fancy_addm -> true)
       | Compilers.Coq_expr.Var (_, _) -> true
       | Compilers.Coq_expr.Abs (_, _, _) -> true
       | Compilers.Coq_expr.App (_, _, f1, _) ->
         (match f1 with
          | Compilers.Coq_expr.Ident (_, idc) ->
            (match idc with
             | Coq3_Compilers.Coq_ident_Literal (_, _) -> true
             | Coq3_Compilers.Coq_ident_comment _ -> true
             | Coq3_Compilers.Coq_ident_comment_no_keep _ -> true
             | Coq3_Compilers.Coq_ident_value_barrier -> true
             | Coq3_Compilers.Coq_ident_Nat_succ -> true
             | Coq3_Compilers.Coq_ident_Nat_pred -> true
             | Coq3_Compilers.Coq_ident_Nat_max -> true
             | Coq3_Compilers.Coq_ident_Nat_mul -> true
             | Coq3_Compilers.Coq_ident_Nat_add -> true
             | Coq3_Compilers.Coq_ident_Nat_sub -> true
             | Coq3_Compilers.Coq_ident_Nat_eqb -> true
             | Coq3_Compilers.Coq_ident_nil _ -> true
             | Coq3_Compilers.Coq_ident_cons _ -> true
             | Coq3_Compilers.Coq_ident_tt -> true
             | Coq3_Compilers.Coq_ident_pair (_, _) -> true
             | Coq3_Compilers.Coq_ident_fst (_, _) -> true
             | Coq3_Compilers.Coq_ident_snd (_, _) -> true
             | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_bool_rect _ -> true
             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect _ -> true
             | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> true
             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
               true
             | Coq3_Compilers.Coq_ident_list_case (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_length _ -> true
             | Coq3_Compilers.Coq_ident_List_seq -> true
             | Coq3_Compilers.Coq_ident_List_firstn _ -> true
             | Coq3_Compilers.Coq_ident_List_skipn _ -> true
             | Coq3_Compilers.Coq_ident_List_repeat _ -> true
             | Coq3_Compilers.Coq_ident_List_combine (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_app _ -> true
             | Coq3_Compilers.Coq_ident_List_rev _ -> true
             | Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_partition _ -> true
             | Coq3_Compilers.Coq_ident_List_filter _ -> true
             | Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> true
             | Coq3_Compilers.Coq_ident_List_update_nth _ -> true
             | Coq3_Compilers.Coq_ident_List_nth_default _ -> false
             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> true
             | Coq3_Compilers.Coq_ident_Z_add -> true
             | Coq3_Compilers.Coq_ident_Z_mul -> true
             | Coq3_Compilers.Coq_ident_Z_pow -> true
             | Coq3_Compilers.Coq_ident_Z_sub -> true
             | Coq3_Compilers.Coq_ident_Z_opp -> true
             | Coq3_Compilers.Coq_ident_Z_div -> true
             | Coq3_Compilers.Coq_ident_Z_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_eqb -> true
             | Coq3_Compilers.Coq_ident_Z_leb -> true
             | Coq3_Compilers.Coq_ident_Z_ltb -> true
             | Coq3_Compilers.Coq_ident_Z_geb -> true
             | Coq3_Compilers.Coq_ident_Z_gtb -> true
             | Coq3_Compilers.Coq_ident_Z_log2 -> true
             | Coq3_Compilers.Coq_ident_Z_log2_up -> true
             | Coq3_Compilers.Coq_ident_Z_of_nat -> true
             | Coq3_Compilers.Coq_ident_Z_to_nat -> true
             | Coq3_Compilers.Coq_ident_Z_shiftr -> true
             | Coq3_Compilers.Coq_ident_Z_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_land -> true
             | Coq3_Compilers.Coq_ident_Z_lor -> true
             | Coq3_Compilers.Coq_ident_Z_min -> true
             | Coq3_Compilers.Coq_ident_Z_max -> true
             | Coq3_Compilers.Coq_ident_Z_mul_split -> true
             | Coq3_Compilers.Coq_ident_Z_mul_high -> true
             | Coq3_Compilers.Coq_ident_Z_add_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_carry -> true
             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> true
             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> true
             | Coq3_Compilers.Coq_ident_Z_ltz -> true
             | Coq3_Compilers.Coq_ident_Z_zselect -> true
             | Coq3_Compilers.Coq_ident_Z_add_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> true
             | Coq3_Compilers.Coq_ident_Z_bneg -> true
             | Coq3_Compilers.Coq_ident_Z_lnot_modulo -> true
             | Coq3_Compilers.Coq_ident_Z_lxor -> true
             | Coq3_Compilers.Coq_ident_Z_rshi -> true
             | Coq3_Compilers.Coq_ident_Z_cc_m -> true
             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> true
             | Coq3_Compilers.Coq_ident_Z_cast -> true
             | Coq3_Compilers.Coq_ident_Z_cast2 -> true
             | Coq3_Compilers.Coq_ident_Some _ -> true
             | Coq3_Compilers.Coq_ident_None _ -> true
             | Coq3_Compilers.Coq_ident_option_rect (_, _) -> true
             | Coq3_Compilers.Coq_ident_Build_zrange -> true
             | Coq3_Compilers.Coq_ident_zrange_rect _ -> true
             | Coq3_Compilers.Coq_ident_fancy_add -> true
             | Coq3_Compilers.Coq_ident_fancy_addc -> true
             | Coq3_Compilers.Coq_ident_fancy_sub -> true
             | Coq3_Compilers.Coq_ident_fancy_subb -> true
             | Coq3_Compilers.Coq_ident_fancy_mulll -> true
             | Coq3_Compilers.Coq_ident_fancy_mullh -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhl -> true
             | Coq3_Compilers.Coq_ident_fancy_mulhh -> true
             | Coq3_Compilers.Coq_ident_fancy_rshi -> true
             | Coq3_Compilers.Coq_ident_fancy_selc -> true
             | Coq3_Compilers.Coq_ident_fancy_selm -> true
             | Coq3_Compilers.Coq_ident_fancy_sell -> true
             | Coq3_Compilers.Coq_ident_fancy_addm -> true)
          | Compilers.Coq_expr.Var (_, _) -> true
          | Compilers.Coq_expr.Abs (_, _, _) -> true
          | Compilers.Coq_expr.App (_, _, _, _) -> true
          | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)
       | Compilers.Coq_expr.LetIn (_, _, _, _) -> true)) f x
| Compilers.Coq_expr.LetIn (_, _, _, _) -> true

(** val translate_binop :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> rtype0 option **)

let translate_binop _ _ _ _ _ _ _ _ = function
| Coq3_Compilers.Coq_ident_Literal (_, _) -> None
| Coq3_Compilers.Coq_ident_comment _ -> None
| Coq3_Compilers.Coq_ident_comment_no_keep _ -> None
| Coq3_Compilers.Coq_ident_value_barrier -> None
| Coq3_Compilers.Coq_ident_Nat_succ -> None
| Coq3_Compilers.Coq_ident_Nat_pred -> None
| Coq3_Compilers.Coq_ident_Nat_max -> None
| Coq3_Compilers.Coq_ident_Nat_mul -> None
| Coq3_Compilers.Coq_ident_Nat_add -> None
| Coq3_Compilers.Coq_ident_Nat_sub -> None
| Coq3_Compilers.Coq_ident_Nat_eqb -> None
| Coq3_Compilers.Coq_ident_nil _ -> None
| Coq3_Compilers.Coq_ident_cons _ -> None
| Coq3_Compilers.Coq_ident_tt -> None
| Coq3_Compilers.Coq_ident_pair (_, _) -> None
| Coq3_Compilers.Coq_ident_fst (_, _) -> None
| Coq3_Compilers.Coq_ident_snd (_, _) -> None
| Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> None
| Coq3_Compilers.Coq_ident_bool_rect _ -> None
| Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> None
| Coq3_Compilers.Coq_ident_nat_rect _ -> None
| Coq3_Compilers.Coq_ident_eager_nat_rect _ -> None
| Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> None
| Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> None
| Coq3_Compilers.Coq_ident_list_rect (_, _) -> None
| Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> None
| Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> None
| Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) -> None
| Coq3_Compilers.Coq_ident_list_case (_, _) -> None
| Coq3_Compilers.Coq_ident_List_length _ -> None
| Coq3_Compilers.Coq_ident_List_seq -> None
| Coq3_Compilers.Coq_ident_List_firstn _ -> None
| Coq3_Compilers.Coq_ident_List_skipn _ -> None
| Coq3_Compilers.Coq_ident_List_repeat _ -> None
| Coq3_Compilers.Coq_ident_List_combine (_, _) -> None
| Coq3_Compilers.Coq_ident_List_map (_, _) -> None
| Coq3_Compilers.Coq_ident_List_app _ -> None
| Coq3_Compilers.Coq_ident_List_rev _ -> None
| Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> None
| Coq3_Compilers.Coq_ident_List_partition _ -> None
| Coq3_Compilers.Coq_ident_List_filter _ -> None
| Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> None
| Coq3_Compilers.Coq_ident_List_update_nth _ -> None
| Coq3_Compilers.Coq_ident_List_nth_default _ -> None
| Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> None
| Coq3_Compilers.Coq_ident_Z_add ->
  Some (Obj.magic (fun x x0 -> Coq_expr.Coq_op (Coq_bopname.Coq_add, x, x0)))
| Coq3_Compilers.Coq_ident_Z_mul ->
  Some (Obj.magic (fun x x0 -> Coq_expr.Coq_op (Coq_bopname.Coq_mul, x, x0)))
| Coq3_Compilers.Coq_ident_Z_pow -> None
| Coq3_Compilers.Coq_ident_Z_sub ->
  Some (Obj.magic (fun x x0 -> Coq_expr.Coq_op (Coq_bopname.Coq_sub, x, x0)))
| Coq3_Compilers.Coq_ident_Z_opp -> None
| Coq3_Compilers.Coq_ident_Z_div -> None
| Coq3_Compilers.Coq_ident_Z_modulo -> None
| Coq3_Compilers.Coq_ident_Z_eqb -> None
| Coq3_Compilers.Coq_ident_Z_leb -> None
| Coq3_Compilers.Coq_ident_Z_ltb -> None
| Coq3_Compilers.Coq_ident_Z_geb -> None
| Coq3_Compilers.Coq_ident_Z_gtb -> None
| Coq3_Compilers.Coq_ident_Z_log2 -> None
| Coq3_Compilers.Coq_ident_Z_log2_up -> None
| Coq3_Compilers.Coq_ident_Z_of_nat -> None
| Coq3_Compilers.Coq_ident_Z_to_nat -> None
| Coq3_Compilers.Coq_ident_Z_shiftr -> None
| Coq3_Compilers.Coq_ident_Z_shiftl -> None
| Coq3_Compilers.Coq_ident_Z_land ->
  Some (Obj.magic (fun x x0 -> Coq_expr.Coq_op (Coq_bopname.Coq_and, x, x0)))
| Coq3_Compilers.Coq_ident_Z_lor ->
  Some (Obj.magic (fun x x0 -> Coq_expr.Coq_op (Coq_bopname.Coq_or, x, x0)))
| Coq3_Compilers.Coq_ident_Z_min -> None
| Coq3_Compilers.Coq_ident_Z_max -> None
| Coq3_Compilers.Coq_ident_Z_mul_split -> None
| Coq3_Compilers.Coq_ident_Z_mul_high -> None
| Coq3_Compilers.Coq_ident_Z_add_get_carry -> None
| Coq3_Compilers.Coq_ident_Z_add_with_carry -> None
| Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> None
| Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> None
| Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> None
| Coq3_Compilers.Coq_ident_Z_ltz ->
  Some (Obj.magic (fun x x0 -> Coq_expr.Coq_op (Coq_bopname.Coq_ltu, x, x0)))
| Coq3_Compilers.Coq_ident_Z_zselect -> None
| Coq3_Compilers.Coq_ident_Z_add_modulo -> None
| Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> None
| Coq3_Compilers.Coq_ident_Z_bneg -> None
| Coq3_Compilers.Coq_ident_Z_lnot_modulo -> None
| Coq3_Compilers.Coq_ident_Z_lxor ->
  Some (Obj.magic (fun x x0 -> Coq_expr.Coq_op (Coq_bopname.Coq_xor, x, x0)))
| Coq3_Compilers.Coq_ident_Z_rshi -> None
| Coq3_Compilers.Coq_ident_Z_cc_m -> None
| Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> None
| Coq3_Compilers.Coq_ident_Z_cast -> None
| Coq3_Compilers.Coq_ident_Z_cast2 -> None
| Coq3_Compilers.Coq_ident_Some _ -> None
| Coq3_Compilers.Coq_ident_None _ -> None
| Coq3_Compilers.Coq_ident_option_rect (_, _) -> None
| Coq3_Compilers.Coq_ident_Build_zrange -> None
| Coq3_Compilers.Coq_ident_zrange_rect _ -> None
| Coq3_Compilers.Coq_ident_fancy_add -> None
| Coq3_Compilers.Coq_ident_fancy_addc -> None
| Coq3_Compilers.Coq_ident_fancy_sub -> None
| Coq3_Compilers.Coq_ident_fancy_subb -> None
| Coq3_Compilers.Coq_ident_fancy_mulll -> None
| Coq3_Compilers.Coq_ident_fancy_mullh -> None
| Coq3_Compilers.Coq_ident_fancy_mulhl -> None
| Coq3_Compilers.Coq_ident_fancy_mulhh -> None
| Coq3_Compilers.Coq_ident_fancy_rshi -> None
| Coq3_Compilers.Coq_ident_fancy_selc -> None
| Coq3_Compilers.Coq_ident_fancy_selm -> None
| Coq3_Compilers.Coq_ident_fancy_sell -> None
| Coq3_Compilers.Coq_ident_fancy_addm -> None

(** val translate_ident :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> rtype0 **)

let translate_ident width word1 mem0 locals varname_gen error0 parameters_sentinel _ = function
| Coq3_Compilers.Coq_ident_Literal (t0, y) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base t0))
           (Coq3_Compilers.Coq_ident_Literal (t0, y)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base t0)))
| Coq3_Compilers.Coq_ident_comment t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit)))
           (Coq3_Compilers.Coq_ident_comment t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit))))
| Coq3_Compilers.Coq_ident_comment_no_keep t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit)))
           (Coq3_Compilers.Coq_ident_comment_no_keep t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit))))
| Coq3_Compilers.Coq_ident_value_barrier ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_value_barrier with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_Nat_succ ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_succ with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))
| Coq3_Compilers.Coq_ident_Nat_pred ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Nat_pred with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))
| Coq3_Compilers.Coq_ident_Nat_max ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_max with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))))
| Coq3_Compilers.Coq_ident_Nat_mul ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_mul with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))))
| Coq3_Compilers.Coq_ident_Nat_add ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_add with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))))
| Coq3_Compilers.Coq_ident_Nat_sub ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))))) Coq3_Compilers.Coq_ident_Nat_sub with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))))
| Coq3_Compilers.Coq_ident_Nat_eqb ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Nat_eqb with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))))
| Coq3_Compilers.Coq_ident_nil t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0))
           (Coq3_Compilers.Coq_ident_nil t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)))
| Coq3_Compilers.Coq_ident_cons t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t0)))))) (Coq3_Compilers.Coq_ident_cons t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)))))))
| Coq3_Compilers.Coq_ident_tt ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit) Coq3_Compilers.Coq_ident_tt with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit))
| Coq3_Compilers.Coq_ident_pair (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))
           (Coq3_Compilers.Coq_ident_pair (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
| Coq3_Compilers.Coq_ident_fst (_, _) -> Obj.magic fst
| Coq3_Compilers.Coq_ident_snd (_, _) -> Obj.magic snd
| Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_base t2))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))),
           (Compilers.Coq_type.Coq_base t2)))))
           (Coq3_Compilers.Coq_ident_prod_rect (t0, t1, t2)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       (t0, t1))), (Compilers.Coq_type.Coq_base t2))))))
| Coq3_Compilers.Coq_ident_bool_rect t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
           (Coq3_Compilers.Coq_ident_bool_rect t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base Compilers.Coq_base.Coq_type.Coq_unit),
       (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
       (Compilers.Coq_type.Coq_base t0))))))))
| Coq3_Compilers.Coq_ident_bool_rect_nodep t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_base t0)))))))
           (Coq3_Compilers.Coq_ident_bool_rect_nodep t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool)),
       (Compilers.Coq_type.Coq_base t0))))))))
| Coq3_Compilers.Coq_ident_nat_rect t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           t0))))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
           (Coq3_Compilers.Coq_ident_nat_rect t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base t0))))))))
| Coq3_Compilers.Coq_ident_eager_nat_rect t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           t0))))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
           (Coq3_Compilers.Coq_ident_eager_nat_rect t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t0))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base t0))))))))
| Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           t1))))))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           t1))))))))) (Coq3_Compilers.Coq_ident_nat_rect_arrow (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t1))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))))))))))
| Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           t1))))))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           t1))))))))) (Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (t0,
           t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t1))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))))))))))
| Coq3_Compilers.Coq_ident_list_rect (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_base t1))))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base t1)))))))
           (Coq3_Compilers.Coq_ident_list_rect (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base t1))))))))
| Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_base t1))))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base t1)))))))
           (Coq3_Compilers.Coq_ident_eager_list_rect (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t1))))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base t1))))))))
| Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
           t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           t1), (Compilers.Coq_type.Coq_base t2))))))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_base t2)))))))))
           (Coq3_Compilers.Coq_ident_list_rect_arrow (t0, t1, t2)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))))))
| Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base
           t2))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           t1), (Compilers.Coq_type.Coq_base t2))))))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_base t2)))))))))
           (Coq3_Compilers.Coq_ident_eager_list_rect_arrow (t0, t1, t2)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t1), (Compilers.Coq_type.Coq_base t2))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_base t2))))))))))
| Coq3_Compilers.Coq_ident_list_case (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base t1))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base t1)))))))
           (Coq3_Compilers.Coq_ident_list_case (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base t1))))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_base t1))))))))
| Coq3_Compilers.Coq_ident_List_length t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))) (Coq3_Compilers.Coq_ident_List_length
           t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))
| Coq3_Compilers.Coq_ident_List_seq ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat))))))) Coq3_Compilers.Coq_ident_List_seq with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_nat))))))))
| Coq3_Compilers.Coq_ident_List_firstn t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t0)))))) (Coq3_Compilers.Coq_ident_List_firstn t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)))))))
| Coq3_Compilers.Coq_ident_List_skipn t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t0)))))) (Coq3_Compilers.Coq_ident_List_skipn t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)))))))
| Coq3_Compilers.Coq_ident_List_repeat t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0))))))
           (Coq3_Compilers.Coq_ident_List_repeat t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)))))))
| Coq3_Compilers.Coq_ident_List_combine (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t1)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1))))))))
           (Coq3_Compilers.Coq_ident_List_combine (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       (Compilers.Coq_base.Coq_type.Coq_prod (t0, t1)))))))))
| Coq3_Compilers.Coq_ident_List_map (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t1)))))) (Coq3_Compilers.Coq_ident_List_map (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t1)))))))
| Coq3_Compilers.Coq_ident_List_app t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t0)))))) (Coq3_Compilers.Coq_ident_List_app t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)))))))
| Coq3_Compilers.Coq_ident_List_rev t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t0)))) (Coq3_Compilers.Coq_ident_List_rev t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)))))
| Coq3_Compilers.Coq_ident_List_flat_map (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t1)))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t1)))))) (Coq3_Compilers.Coq_ident_List_flat_map (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)))))))
| Coq3_Compilers.Coq_ident_List_partition t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_list t0),
           (Compilers.Coq_base.Coq_type.Coq_list t0))))))))
           (Coq3_Compilers.Coq_ident_List_partition t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_list t0),
       (Compilers.Coq_base.Coq_type.Coq_list t0)))))))))
| Coq3_Compilers.Coq_ident_List_filter t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t0)))))) (Coq3_Compilers.Coq_ident_List_filter t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)))))))
| Coq3_Compilers.Coq_ident_List_fold_right (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t0))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t1)),
           (Compilers.Coq_type.Coq_base t0)))))))
           (Coq3_Compilers.Coq_ident_List_fold_right (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t1),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t1)), (Compilers.Coq_type.Coq_base t0))))))))
| Coq3_Compilers.Coq_ident_List_update_nth t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t0))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
           t0)))))))) (Coq3_Compilers.Coq_ident_List_update_nth t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base t0))),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_list t0)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)))))))))
| Coq3_Compilers.Coq_ident_List_nth_default t0 ->
  (match t0 with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z ->
        rnth_default width word1 mem0 locals varname_gen error0
          parameters_sentinel
      | Coq3_Compilers.Coq_bool ->
        (match translate_binop width word1 mem0 locals varname_gen error0
                 parameters_sentinel (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_bool))), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_bool))))))))
                 (Coq3_Compilers.Coq_ident_List_nth_default
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_bool)) with
         | Some x -> x
         | None ->
           make_error0 width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_bool)))))))))
      | Coq3_Compilers.Coq_nat ->
        (match translate_binop width word1 mem0 locals varname_gen error0
                 parameters_sentinel (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))))))))
                 (Coq3_Compilers.Coq_ident_List_nth_default
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)) with
         | Some x -> x
         | None ->
           make_error0 width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)))))))))
      | Coq3_Compilers.Coq_zrange ->
        (match translate_binop width word1 mem0 locals varname_gen error0
                 parameters_sentinel (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_zrange))), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_zrange))))))))
                 (Coq3_Compilers.Coq_ident_List_nth_default
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_zrange)) with
         | Some x -> x
         | None ->
           make_error0 width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_zrange)))))))))
      | Coq3_Compilers.Coq_string ->
        (match translate_binop width word1 mem0 locals varname_gen error0
                 parameters_sentinel (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_string)), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_list
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_string))), (Compilers.Coq_type.Coq_arrow
                 ((Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_string))))))))
                 (Coq3_Compilers.Coq_ident_List_nth_default
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_string)) with
         | Some x -> x
         | None ->
           make_error0 width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_string)), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_list
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_string))), (Compilers.Coq_type.Coq_arrow
             ((Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
             (Compilers.Coq_base.Coq_type.Coq_type_base
             Coq3_Compilers.Coq_string))))))))))
   | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
     (match translate_binop width word1 mem0 locals varname_gen error0
              parameters_sentinel (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (a, b))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_prod (a, b)))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_prod (a, b)))))))))
              (Coq3_Compilers.Coq_ident_List_nth_default
              (Compilers.Coq_base.Coq_type.Coq_prod (a, b))) with
      | Some x -> x
      | None ->
        make_error0 width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
              parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
          (a, b))), (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_prod (a, b)))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))))))))
   | Compilers.Coq_base.Coq_type.Coq_list a ->
     (match translate_binop width word1 mem0 locals varname_gen error0
              parameters_sentinel (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list a)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_list a))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list a))))))))
              (Coq3_Compilers.Coq_ident_List_nth_default
              (Compilers.Coq_base.Coq_type.Coq_list a)) with
      | Some x -> x
      | None ->
        make_error0 width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
              parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
          a)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_list a))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list a)))))))))
   | Compilers.Coq_base.Coq_type.Coq_option a ->
     (match translate_binop width word1 mem0 locals varname_gen error0
              parameters_sentinel (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_option a)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              (Compilers.Coq_base.Coq_type.Coq_option a))),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_option a))))))))
              (Coq3_Compilers.Coq_ident_List_nth_default
              (Compilers.Coq_base.Coq_type.Coq_option a)) with
      | Some x -> x
      | None ->
        make_error0 width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
              parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option a)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_option a))),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_option a)))))))))
   | Compilers.Coq_base.Coq_type.Coq_unit ->
     (match translate_binop width word1 mem0 locals varname_gen error0
              parameters_sentinel (Compilers.Coq_type.Coq_arrow
              ((Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_list
              Compilers.Coq_base.Coq_type.Coq_unit)),
              (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
              (Compilers.Coq_base.Coq_type.Coq_type_base
              Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
              Compilers.Coq_base.Coq_type.Coq_unit)))))))
              (Coq3_Compilers.Coq_ident_List_nth_default
              Compilers.Coq_base.Coq_type.Coq_unit) with
      | Some x -> x
      | None ->
        make_error0 width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
              parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
          ((Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_list
          Compilers.Coq_base.Coq_type.Coq_unit)),
          (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
          Compilers.Coq_base.Coq_type.Coq_unit)))))))))
| Coq3_Compilers.Coq_ident_eager_List_nth_default t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_list t0)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base t0)))))))
           (Coq3_Compilers.Coq_ident_eager_List_nth_default t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_list
       t0)), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base t0))))))))
| Coq3_Compilers.Coq_ident_Z_add ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_add with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_mul ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_mul with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_pow ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_pow with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_sub ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_sub with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_opp ->
  Obj.magic (fun x -> Coq_expr.Coq_op (Coq_bopname.Coq_sub,
    (Coq_expr.Coq_literal Z0), x))
| Coq3_Compilers.Coq_ident_Z_div ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_div with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_modulo ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_modulo with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_eqb ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_eqb with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))))
| Coq3_Compilers.Coq_ident_Z_leb ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_leb with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))))
| Coq3_Compilers.Coq_ident_Z_ltb ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_ltb with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))))
| Coq3_Compilers.Coq_ident_Z_geb ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_geb with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))))
| Coq3_Compilers.Coq_ident_Z_gtb ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_bool)))))) Coq3_Compilers.Coq_ident_Z_gtb with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_bool)))))))
| Coq3_Compilers.Coq_ident_Z_log2 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_Z_log2 with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_Z_log2_up ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_Z_log2_up with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_Z_of_nat ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_Z_of_nat with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_Z_to_nat ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_nat)))) Coq3_Compilers.Coq_ident_Z_to_nat with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat)))))
| Coq3_Compilers.Coq_ident_Z_shiftr ->
  rshiftr width word1 mem0 locals varname_gen error0 parameters_sentinel
| Coq3_Compilers.Coq_ident_Z_shiftl ->
  rshiftl width word1 mem0 locals varname_gen error0 parameters_sentinel
| Coq3_Compilers.Coq_ident_Z_land ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_land with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_lor ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_lor with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_min ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_min with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_max ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_max with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_mul_split ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_mul_split with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))
| Coq3_Compilers.Coq_ident_Z_mul_high ->
  rmul_high width word1 mem0 locals varname_gen error0 parameters_sentinel
| Coq3_Compilers.Coq_ident_Z_add_get_carry ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_add_get_carry with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))
| Coq3_Compilers.Coq_ident_Z_add_with_carry ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_ident_Z_add_with_carry with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))
| Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z))))))))))))
           Coq3_Compilers.Coq_ident_Z_add_with_get_carry with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))))
| Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z))))))))))
           Coq3_Compilers.Coq_ident_Z_sub_get_borrow with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))
| Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z))))))))))))
           Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))))
| Coq3_Compilers.Coq_ident_Z_ltz ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_ltz with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_zselect ->
  rselect width word1 mem0 locals varname_gen error0 parameters_sentinel
| Coq3_Compilers.Coq_ident_Z_add_modulo ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))) Coq3_Compilers.Coq_ident_Z_add_modulo with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))
| Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
  rtruncating_shiftl width word1 mem0 locals varname_gen error0
    parameters_sentinel
| Coq3_Compilers.Coq_ident_Z_bneg ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_Z_bneg with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
  rlnot_modulo width word1 mem0 locals varname_gen error0 parameters_sentinel
| Coq3_Compilers.Coq_ident_Z_lxor ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_lxor with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_rshi ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z)))))))))) Coq3_Compilers.Coq_ident_Z_rshi with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))))
| Coq3_Compilers.Coq_ident_Z_cc_m ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_Z_cc_m with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Z))))))))
           Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))))
| Coq3_Compilers.Coq_ident_Z_cast -> Obj.magic (fun _ x -> x)
| Coq3_Compilers.Coq_ident_Z_cast2 -> Obj.magic (fun _ x -> x)
| Coq3_Compilers.Coq_ident_Some t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_option t0))))
           (Coq3_Compilers.Coq_ident_Some t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base t0), (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_option t0)))))
| Coq3_Compilers.Coq_ident_None t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_option t0))
           (Coq3_Compilers.Coq_ident_None t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_option t0)))
| Coq3_Compilers.Coq_ident_option_rect (t0, t1) ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           Compilers.Coq_base.Coq_type.Coq_unit),
           (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_option t0)),
           (Compilers.Coq_type.Coq_base t1)))))))
           (Coq3_Compilers.Coq_ident_option_rect (t0, t1)) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base t0),
       (Compilers.Coq_type.Coq_base t1))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       Compilers.Coq_base.Coq_type.Coq_unit), (Compilers.Coq_type.Coq_base
       t1))), (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_option t0)),
       (Compilers.Coq_type.Coq_base t1))))))))
| Coq3_Compilers.Coq_ident_Build_zrange ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_zrange))))))
           Coq3_Compilers.Coq_ident_Build_zrange with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)))))))
| Coq3_Compilers.Coq_ident_zrange_rect t0 ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
           (Compilers.Coq_type.Coq_base t0))))),
           (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base
           Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0)))))
           (Coq3_Compilers.Coq_ident_zrange_rect t0) with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_arrow ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)),
       (Compilers.Coq_type.Coq_base t0))))), (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base
       Coq3_Compilers.Coq_zrange)), (Compilers.Coq_type.Coq_base t0))))))
| Coq3_Compilers.Coq_ident_fancy_add ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_fancy_add with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_fancy_addc ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_fancy_addc with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_fancy_sub ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_fancy_sub with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_fancy_subb ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))))
           Coq3_Compilers.Coq_ident_fancy_subb with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))))
| Coq3_Compilers.Coq_ident_fancy_mulll ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_mulll with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_mullh ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_mullh with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_mulhl ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_mulhl with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_mulhh ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_mulhh with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_rshi ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_rshi with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_selc ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_selc with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_selm ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_selm with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_sell ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_sell with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))
| Coq3_Compilers.Coq_ident_fancy_addm ->
  (match translate_binop width word1 mem0 locals varname_gen error0
           parameters_sentinel (Compilers.Coq_type.Coq_arrow
           ((Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_prod
           ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
           (Compilers.Coq_type.Coq_base
           (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))))
           Coq3_Compilers.Coq_ident_fancy_addm with
   | Some x -> x
   | None ->
     make_error0 width word1 mem0 locals varname_gen error0
       parameters_sentinel
       (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
           parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
       ((Compilers.Coq_type.Coq_base (Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_prod
       ((Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))),
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))),
       (Compilers.Coq_type.Coq_base
       (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))))

(** val translate_cast_exempt :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> bool -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, ltype0)
    Compilers.Coq_expr.expr -> rtype0 **)

let translate_cast_exempt width word1 mem0 locals varname_gen error0 parameters_sentinel _ require_in_bounds = function
| Compilers.Coq_expr.Ident (t0, idc) ->
  (match t0 with
   | Compilers.Coq_type.Coq_base t1 ->
     (match t1 with
      | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
        (match t2 with
         | Coq3_Compilers.Z ->
           (fun idc0 ->
             match idc0 with
             | Coq3_Compilers.Coq_ident_Literal (t3, z0) ->
               (match t3 with
                | Coq3_Compilers.Z ->
                  (fun z1 ->
                    if require_in_bounds
                    then if is_bounded_by_bool (Obj.magic z1)
                              (max_range width)
                         then Obj.magic (Coq_expr.Coq_literal (Obj.magic z1))
                         else make_error0 width word1 mem0 locals varname_gen
                                error0 parameters_sentinel
                                (Coq_rep.listZ_local width word1 mem0 locals
                                  varname_gen error0 parameters_sentinel
                                  (Coq_rep.coq_Z width word1 mem0 locals
                                    varname_gen error0 parameters_sentinel))
                                (Compilers.Coq_type.Coq_base
                                (Compilers.Coq_base.Coq_type.Coq_type_base
                                Coq3_Compilers.Z))
                    else Obj.magic (Coq_expr.Coq_literal (Obj.magic z1)))
                | Coq3_Compilers.Coq_bool ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))
                | Coq3_Compilers.Coq_nat ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))
                | Coq3_Compilers.Coq_zrange ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))
                | Coq3_Compilers.Coq_string ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Z)))) z0
             | Coq3_Compilers.Coq_ident_comment _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_value_barrier ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Nat_succ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Nat_pred ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Nat_max ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Nat_mul ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Nat_add ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Nat_sub ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Nat_eqb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_nil _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_cons _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_tt ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_pair (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fst (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_snd (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_bool_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_nat_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_list_case (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_length _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_seq ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_firstn _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_skipn _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_repeat _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_map (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_app _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_rev _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_partition _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_filter _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_add ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_mul ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_pow ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_sub ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_opp ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_div ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_modulo ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_eqb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_leb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_ltb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_geb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_gtb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_log2 ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_log2_up ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_of_nat ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_to_nat ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_shiftr ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_shiftl ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_land ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_lor ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_min ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_max ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_mul_split ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_mul_high ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_ltz ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_zselect ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_bneg ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_lxor ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_rshi ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_cc_m ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_cast ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Z_cast2 ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Some _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_None _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_Build_zrange ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_add ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_addc ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_sub ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_subb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_mulll ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_mullh ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_rshi ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_selc ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_selm ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_sell ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
             | Coq3_Compilers.Coq_ident_fancy_addm ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z)))
         | Coq3_Compilers.Coq_bool ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_bool)))
         | Coq3_Compilers.Coq_nat ->
           (fun idc0 ->
             match idc0 with
             | Coq3_Compilers.Coq_ident_Literal (t3, n3) ->
               (match t3 with
                | Coq3_Compilers.Z ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)))
                | Coq3_Compilers.Coq_bool ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)))
                | Coq3_Compilers.Coq_nat ->
                  (fun n4 ->
                    Obj.magic (Coq_expr.Coq_literal
                      (Coq_Z.of_nat (Obj.magic n4))))
                | Coq3_Compilers.Coq_zrange ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)))
                | Coq3_Compilers.Coq_string ->
                  (fun _ ->
                    make_error0 width word1 mem0 locals varname_gen error0
                      parameters_sentinel
                      (Coq_rep.listZ_local width word1 mem0 locals
                        varname_gen error0 parameters_sentinel
                        (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                          error0 parameters_sentinel))
                      (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat)))) n3
             | Coq3_Compilers.Coq_ident_comment _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_value_barrier ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Nat_succ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Nat_pred ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Nat_max ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Nat_mul ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Nat_add ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Nat_sub ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Nat_eqb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_nil _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_cons _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_tt ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_pair (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fst (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_snd (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_bool_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_nat_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_list_case (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_length _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_seq ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_firstn _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_skipn _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_repeat _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_map (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_app _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_rev _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_partition _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_filter _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_update_nth _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_List_nth_default _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_add ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_mul ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_pow ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_sub ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_opp ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_div ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_modulo ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_eqb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_leb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_ltb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_geb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_gtb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_log2 ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_log2_up ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_of_nat ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_to_nat ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_shiftr ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_shiftl ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_land ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_lor ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_min ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_max ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_mul_split ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_mul_high ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_ltz ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_zselect ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_add_modulo ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_bneg ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_lxor ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_rshi ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_cc_m ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_cast ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Z_cast2 ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Some _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_None _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_Build_zrange ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_zrange_rect _ ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_add ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_addc ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_sub ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_subb ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_mulll ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_mullh ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_mulhl ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_mulhh ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_rshi ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_selc ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_selm ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_sell ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat))
             | Coq3_Compilers.Coq_ident_fancy_addm ->
               make_error0 width word1 mem0 locals varname_gen error0
                 parameters_sentinel
                 (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                   error0 parameters_sentinel
                   (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                     parameters_sentinel)) (Compilers.Coq_type.Coq_base
                 (Compilers.Coq_base.Coq_type.Coq_type_base
                 Coq3_Compilers.Coq_nat)))
         | Coq3_Compilers.Coq_zrange ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_zrange)))
         | Coq3_Compilers.Coq_string ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_string))))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun _ ->
          make_error0 width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
              parameters_sentinel
              (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                parameters_sentinel)) (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))
      | Compilers.Coq_base.Coq_type.Coq_list a ->
        (fun _ ->
          make_error0 width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
              parameters_sentinel
              (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                parameters_sentinel)) (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_list a)))
      | Compilers.Coq_base.Coq_type.Coq_option a ->
        (fun _ ->
          make_error0 width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
              parameters_sentinel
              (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                parameters_sentinel)) (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_option a)))
      | Compilers.Coq_base.Coq_type.Coq_unit ->
        (fun _ ->
          make_error0 width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
              parameters_sentinel
              (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                parameters_sentinel)) (Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit)))
   | Compilers.Coq_type.Coq_arrow (s0, d) ->
     (fun _ ->
       make_error0 width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
           parameters_sentinel
           (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
             parameters_sentinel)) (Compilers.Coq_type.Coq_arrow (s0, d))))
    idc
| Compilers.Coq_expr.Var (t0, x) ->
  (match t0 with
   | Compilers.Coq_type.Coq_base t1 ->
     (match t1 with
      | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
        (match t2 with
         | Coq3_Compilers.Z ->
           (fun x0 -> Obj.magic (Coq_expr.Coq_var (Obj.magic x0)))
         | Coq3_Compilers.Coq_bool ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_bool)))
         | Coq3_Compilers.Coq_nat ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_nat)))
         | Coq3_Compilers.Coq_zrange ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_zrange)))
         | Coq3_Compilers.Coq_string ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_type_base
               Coq3_Compilers.Coq_string))))
      | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
        (fun _ ->
          make_error0 width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
              parameters_sentinel
              (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                parameters_sentinel)) (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_prod (a, b))))
      | Compilers.Coq_base.Coq_type.Coq_list a ->
        (match a with
         | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
           (match t2 with
            | Coq3_Compilers.Z ->
              (fun x0 -> Obj.magic map (fun x1 -> Coq_expr.Coq_var x1) x0)
            | Coq3_Compilers.Coq_bool ->
              (fun _ ->
                make_error0 width word1 mem0 locals varname_gen error0
                  parameters_sentinel
                  (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                    error0 parameters_sentinel
                    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                      parameters_sentinel)) (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_bool))))
            | Coq3_Compilers.Coq_nat ->
              (fun _ ->
                make_error0 width word1 mem0 locals varname_gen error0
                  parameters_sentinel
                  (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                    error0 parameters_sentinel
                    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                      parameters_sentinel)) (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_nat))))
            | Coq3_Compilers.Coq_zrange ->
              (fun _ ->
                make_error0 width word1 mem0 locals varname_gen error0
                  parameters_sentinel
                  (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                    error0 parameters_sentinel
                    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                      parameters_sentinel)) (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_zrange))))
            | Coq3_Compilers.Coq_string ->
              (fun _ ->
                make_error0 width word1 mem0 locals varname_gen error0
                  parameters_sentinel
                  (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                    error0 parameters_sentinel
                    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                      parameters_sentinel)) (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_list
                  (Compilers.Coq_base.Coq_type.Coq_type_base
                  Coq3_Compilers.Coq_string)))))
         | Compilers.Coq_base.Coq_type.Coq_prod (a0, b) ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_list
               (Compilers.Coq_base.Coq_type.Coq_prod (a0, b)))))
         | Compilers.Coq_base.Coq_type.Coq_list a0 ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_list
               (Compilers.Coq_base.Coq_type.Coq_list a0))))
         | Compilers.Coq_base.Coq_type.Coq_option a0 ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_list
               (Compilers.Coq_base.Coq_type.Coq_option a0))))
         | Compilers.Coq_base.Coq_type.Coq_unit ->
           (fun _ ->
             make_error0 width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                 error0 parameters_sentinel
                 (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                   parameters_sentinel)) (Compilers.Coq_type.Coq_base
               (Compilers.Coq_base.Coq_type.Coq_list
               Compilers.Coq_base.Coq_type.Coq_unit))))
      | Compilers.Coq_base.Coq_type.Coq_option a ->
        (fun _ ->
          make_error0 width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
              parameters_sentinel
              (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                parameters_sentinel)) (Compilers.Coq_type.Coq_base
            (Compilers.Coq_base.Coq_type.Coq_option a)))
      | Compilers.Coq_base.Coq_type.Coq_unit ->
        (fun _ ->
          make_error0 width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
              parameters_sentinel
              (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                parameters_sentinel)) (Compilers.Coq_type.Coq_base
            Compilers.Coq_base.Coq_type.Coq_unit)))
   | Compilers.Coq_type.Coq_arrow (s0, d) ->
     (fun _ ->
       make_error0 width word1 mem0 locals varname_gen error0
         parameters_sentinel
         (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
           parameters_sentinel
           (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
             parameters_sentinel)) (Compilers.Coq_type.Coq_arrow (s0, d)))) x
| Compilers.Coq_expr.Abs (s0, d, _) ->
  make_error0 width word1 mem0 locals varname_gen error0 parameters_sentinel
    (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
      parameters_sentinel
      (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
        parameters_sentinel)) (Compilers.Coq_type.Coq_arrow (s0, d))
| Compilers.Coq_expr.App (_, d, _, _) ->
  make_error0 width word1 mem0 locals varname_gen error0 parameters_sentinel
    (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
      parameters_sentinel
      (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
        parameters_sentinel)) d
| Compilers.Coq_expr.LetIn (_, b, _, _) ->
  make_error0 width word1 mem0 locals varname_gen error0 parameters_sentinel
    (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
      parameters_sentinel
      (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
        parameters_sentinel)) b

(** val translate_expr :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> bool -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident, ltype0) Compilers.Coq_expr.expr -> rtype0 **)

let translate_expr width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec translate_expr0 require_cast t0 e =
    if cast_exempt t0 e
    then translate_cast_exempt width word1 mem0 locals varname_gen error0
           parameters_sentinel t0 require_cast e
    else if require_cast
         then (match e with
               | Compilers.Coq_expr.Ident (t1, _) ->
                 make_error0 width word1 mem0 locals varname_gen error0
                   parameters_sentinel
                   (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                     error0 parameters_sentinel
                     (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                       error0 parameters_sentinel)) t1
               | Compilers.Coq_expr.Var (t1, _) ->
                 make_error0 width word1 mem0 locals varname_gen error0
                   parameters_sentinel
                   (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                     error0 parameters_sentinel
                     (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                       error0 parameters_sentinel)) t1
               | Compilers.Coq_expr.Abs (s0, d, _) ->
                 make_error0 width word1 mem0 locals varname_gen error0
                   parameters_sentinel
                   (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                     error0 parameters_sentinel
                     (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                       error0 parameters_sentinel))
                   (Compilers.Coq_type.Coq_arrow (s0, d))
               | Compilers.Coq_expr.App (s0, d, f, x) ->
                 if is_cast width (Compilers.Coq_type.Coq_arrow (s0, d)) f
                 then Obj.magic translate_expr0 false
                        (Compilers.Coq_type.Coq_arrow (s0, d)) f
                        (translate_expr0 false s0 x)
                 else make_error0 width word1 mem0 locals varname_gen error0
                        parameters_sentinel
                        (Coq_rep.listZ_local width word1 mem0 locals
                          varname_gen error0 parameters_sentinel
                          (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                            error0 parameters_sentinel)) d
               | Compilers.Coq_expr.LetIn (_, b, _, _) ->
                 make_error0 width word1 mem0 locals varname_gen error0
                   parameters_sentinel
                   (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                     error0 parameters_sentinel
                     (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                       error0 parameters_sentinel)) b)
         else (match e with
               | Compilers.Coq_expr.Ident (t1, i) ->
                 translate_ident width word1 mem0 locals varname_gen error0
                   parameters_sentinel t1 i
               | Compilers.Coq_expr.Var (t1, x) ->
                 rtype_of_ltype0 width word1 mem0 locals varname_gen error0
                   parameters_sentinel
                   (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                     error0 parameters_sentinel
                     (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                       error0 parameters_sentinel)) t1 x
               | Compilers.Coq_expr.Abs (s0, d, _) ->
                 make_error0 width word1 mem0 locals varname_gen error0
                   parameters_sentinel
                   (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                     error0 parameters_sentinel
                     (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                       error0 parameters_sentinel))
                   (Compilers.Coq_type.Coq_arrow (s0, d))
               | Compilers.Coq_expr.App (s0, d, f, x) ->
                 let rc =
                   require_cast_for_arg width (Compilers.Coq_type.Coq_arrow
                     (s0, d)) f
                 in
                 Obj.magic translate_expr0 false
                   (Compilers.Coq_type.Coq_arrow (s0, d)) f
                   (translate_expr0 rc s0 x)
               | Compilers.Coq_expr.LetIn (_, b, _, _) ->
                 make_error0 width word1 mem0 locals varname_gen error0
                   parameters_sentinel
                   (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                     error0 parameters_sentinel
                     (Coq_rep.coq_Z width word1 mem0 locals varname_gen
                       error0 parameters_sentinel)) b)
  in translate_expr0

(** val assign_list :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> nat -> base_rtype -> (nat * base_ltype) * Coq_cmd.cmd **)

let assign_list _ _ _ _ varname_gen _ _ =
  let rec assign_list0 nextn xs =
    match Obj.magic xs with
    | [] -> ((O, (Obj.magic [])), Coq_cmd.Coq_skip)
    | x :: xs' ->
      let rec0 = Obj.magic assign_list0 (S nextn) xs' in
      (((S (fst (fst rec0))),
      (Obj.magic ((varname_gen nextn) :: (snd (fst rec0))))),
      (Coq_cmd.Coq_seq ((Coq_cmd.Coq_set ((varname_gen nextn), x)),
      (snd rec0))))
  in assign_list0

(** val assign_base :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> nat -> base_rtype -> (nat * base_ltype) * Coq_cmd.cmd **)

let assign_base width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec assign_base0 t0 nextn =
    match t0 with
    | Compilers.Coq_base.Coq_type.Coq_type_base _ ->
      (fun rhs ->
        let v = varname_gen nextn in
        (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
    | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
      (fun rhs ->
        let assign1 = assign_base0 a nextn (fst (Obj.magic rhs)) in
        let assign2 =
          assign_base0 b (add nextn (fst (fst assign1))) (snd (Obj.magic rhs))
        in
        (((add (fst (fst assign1)) (fst (fst assign2))),
        (Obj.magic ((snd (fst assign1)), (snd (fst assign2))))),
        (Coq_cmd.Coq_seq ((snd assign1), (snd assign2)))))
    | Compilers.Coq_base.Coq_type.Coq_list a ->
      (match a with
       | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
         (match t1 with
          | Coq3_Compilers.Z ->
            assign_list width word1 mem0 locals varname_gen error0
              parameters_sentinel nextn
          | Coq3_Compilers.Coq_bool ->
            (fun rhs ->
              let v = varname_gen nextn in
              (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
          | Coq3_Compilers.Coq_nat ->
            (fun rhs ->
              let v = varname_gen nextn in
              (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
          | Coq3_Compilers.Coq_zrange ->
            (fun rhs ->
              let v = varname_gen nextn in
              (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
          | Coq3_Compilers.Coq_string ->
            (fun rhs ->
              let v = varname_gen nextn in
              (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs))))))
       | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
         (fun rhs ->
           let v = varname_gen nextn in
           (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
       | Compilers.Coq_base.Coq_type.Coq_list _ ->
         (fun rhs ->
           let v = varname_gen nextn in
           (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
       | Compilers.Coq_base.Coq_type.Coq_option _ ->
         (fun rhs ->
           let v = varname_gen nextn in
           (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
       | Compilers.Coq_base.Coq_type.Coq_unit ->
         (fun rhs ->
           let v = varname_gen nextn in
           (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs))))))
    | Compilers.Coq_base.Coq_type.Coq_option _ ->
      (fun rhs ->
        let v = varname_gen nextn in
        (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
    | Compilers.Coq_base.Coq_type.Coq_unit ->
      (fun rhs ->
        let v = varname_gen nextn in
        (((S O), (Obj.magic v)), (Coq_cmd.Coq_set (v, (Obj.magic rhs)))))
  in assign_base0

(** val assign :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> nat -> rtype0 ->
    (nat * ltype0) * Coq_cmd.cmd **)

let assign width word1 mem0 locals varname_gen error0 parameters_sentinel t0 nextn =
  match t0 with
  | Compilers.Coq_type.Coq_base b ->
    assign_base width word1 mem0 locals varname_gen error0
      parameters_sentinel b nextn
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (fun _ -> ((O,
      (dummy_ltype0 width word1 mem0 locals varname_gen error0
        parameters_sentinel
        (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
            parameters_sentinel)) (Compilers.Coq_type.Coq_arrow (s0, d)))),
      Coq_cmd.Coq_skip))

(** val translate_ident2_for_cmd :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> Coq3_Compilers.ident -> ltype0 -> ltype0
    -> ltype0 option **)

let translate_ident2_for_cmd _ _ _ _ _ _ _ _ _ _ = function
| Coq3_Compilers.Coq_ident_Literal (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_comment _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_comment_no_keep _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_value_barrier -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Nat_succ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Nat_pred -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Nat_max -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Nat_mul -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Nat_add -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Nat_sub -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Nat_eqb -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_nil _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_cons t0 ->
  (match t0 with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z ->
        (fun x xs -> Some (Obj.magic (x :: (Obj.magic xs))))
      | Coq3_Compilers.Coq_bool -> (fun _ _ -> None)
      | Coq3_Compilers.Coq_nat -> (fun _ _ -> None)
      | Coq3_Compilers.Coq_zrange -> (fun _ _ -> None)
      | Coq3_Compilers.Coq_string -> (fun _ _ -> None))
   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ _ -> None)
   | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> None)
   | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> None)
   | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> None))
| Coq3_Compilers.Coq_ident_tt -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_pair (_, _) -> (fun x y -> Some (Obj.magic (x, y)))
| Coq3_Compilers.Coq_ident_fst (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_snd (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_prod_rect (_, _, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_bool_rect _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_bool_rect_nodep _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_nat_rect _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_eager_nat_rect _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_list_rect (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_eager_list_rect (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_eager_list_rect_arrow (_, _, _) ->
  (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_list_case (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_length _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_seq -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_firstn _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_skipn _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_repeat _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_combine (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_map (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_app _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_rev _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_flat_map (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_partition _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_filter _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_fold_right (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_update_nth _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_List_nth_default _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_eager_List_nth_default _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_add -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_mul -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_pow -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_sub -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_opp -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_div -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_modulo -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_eqb -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_leb -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_ltb -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_geb -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_gtb -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_log2 -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_log2_up -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_of_nat -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_to_nat -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_shiftr -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_shiftl -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_land -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_lor -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_min -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_max -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_mul_split -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_mul_high -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_add_get_carry -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_add_with_carry -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_add_with_get_carry -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_sub_get_borrow -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_ltz -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_zselect -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_add_modulo -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_truncating_shiftl -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_bneg -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_lnot_modulo -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_lxor -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_rshi -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_cc_m -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_cast -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Z_cast2 -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Some _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_None _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_option_rect (_, _) -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_Build_zrange -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_zrange_rect _ -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_add -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_addc -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_sub -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_subb -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_mulll -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_mullh -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_mulhl -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_mulhh -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_rshi -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_selc -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_selm -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_sell -> (fun _ _ -> None)
| Coq3_Compilers.Coq_ident_fancy_addm -> (fun _ _ -> None)

(** val translate_cmd :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, ltype0)
    Compilers.Coq_expr.expr -> nat -> (nat * ltype0) * Coq_cmd.cmd **)

let translate_cmd width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec translate_cmd0 _ e nextn =
    match e with
    | Compilers.Coq_expr.Ident (t0, i) ->
      (match t0 with
       | Compilers.Coq_type.Coq_base t1 ->
         (match t1 with
          | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
            (fun i0 ->
              let v =
                translate_expr width word1 mem0 locals varname_gen error0
                  parameters_sentinel true (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base t2))
                  (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_type_base t2)), i0))
              in
              assign width word1 mem0 locals varname_gen error0
                parameters_sentinel (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_type_base t2)) nextn v)
          | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
            (fun i0 ->
              let v =
                translate_expr width word1 mem0 locals varname_gen error0
                  parameters_sentinel true (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b)))
                  (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_prod (a, b))), i0))
              in
              assign width word1 mem0 locals varname_gen error0
                parameters_sentinel (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_prod (a, b))) nextn v)
          | Compilers.Coq_base.Coq_type.Coq_list a ->
            (match a with
             | Compilers.Coq_base.Coq_type.Coq_type_base t2 ->
               (match t2 with
                | Coq3_Compilers.Z ->
                  (fun i0 ->
                    match i0 with
                    | Coq3_Compilers.Coq_ident_Literal (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_comment _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_comment_no_keep _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_value_barrier ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Nat_succ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Nat_pred ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Nat_max ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Nat_mul ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Nat_add ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Nat_sub ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Nat_eqb ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_nil _ ->
                      ((O, (Obj.magic [])), Coq_cmd.Coq_skip)
                    | Coq3_Compilers.Coq_ident_cons _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_tt ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_pair (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fst (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_snd (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_prod_rect (_, _, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_bool_rect _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_bool_rect_nodep _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_nat_rect _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_eager_nat_rect _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_nat_rect_arrow (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_eager_nat_rect_arrow (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_list_rect (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_eager_list_rect (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_list_rect_arrow (_, _, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_eager_list_rect_arrow (
                        _, _, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_list_case (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_length _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_seq ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_firstn _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_skipn _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_repeat _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_combine (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_map (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_app _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_rev _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_flat_map (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_partition _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_filter _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_fold_right (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_update_nth _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_List_nth_default _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_eager_List_nth_default _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_add ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_mul ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_pow ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_sub ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_opp ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_div ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_modulo ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_eqb ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_leb ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_ltb ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_geb ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_gtb ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_log2 ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_log2_up ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_of_nat ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_to_nat ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_shiftr ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_shiftl ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_land ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_lor ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_min ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_max ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_mul_split ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_mul_high ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_add_get_carry ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_add_with_carry ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_add_with_get_carry ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_sub_get_borrow ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_sub_with_get_borrow ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_ltz ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_zselect ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_add_modulo ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_truncating_shiftl ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_bneg ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_lnot_modulo ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_lxor ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_rshi ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_cc_m ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_combine_at_bitwidth ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_cast ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Z_cast2 ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Some _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_None _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_option_rect (_, _) ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_Build_zrange ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_zrange_rect _ ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_add ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_addc ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_sub ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_subb ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_mulll ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_mullh ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_mulhl ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_mulhh ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_rshi ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_selc ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_selm ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_sell ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v
                    | Coq3_Compilers.Coq_ident_fancy_addm ->
                      let v =
                        translate_expr width word1 mem0 locals varname_gen
                          error0 parameters_sentinel true
                          (Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))) (Compilers.Coq_expr.Ident
                          ((Compilers.Coq_type.Coq_base
                          (Compilers.Coq_base.Coq_type.Coq_list
                          (Compilers.Coq_base.Coq_type.Coq_type_base
                          Coq3_Compilers.Z))), i0))
                      in
                      assign width word1 mem0 locals varname_gen error0
                        parameters_sentinel (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Z))) nextn v)
                | Coq3_Compilers.Coq_bool ->
                  (fun i0 ->
                    let v =
                      translate_expr width word1 mem0 locals varname_gen
                        error0 parameters_sentinel true
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool))) (Compilers.Coq_expr.Ident
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_bool))), i0))
                    in
                    assign width word1 mem0 locals varname_gen error0
                      parameters_sentinel (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_bool))) nextn v)
                | Coq3_Compilers.Coq_nat ->
                  (fun i0 ->
                    let v =
                      translate_expr width word1 mem0 locals varname_gen
                        error0 parameters_sentinel true
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat))) (Compilers.Coq_expr.Ident
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_nat))), i0))
                    in
                    assign width word1 mem0 locals varname_gen error0
                      parameters_sentinel (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_nat))) nextn v)
                | Coq3_Compilers.Coq_zrange ->
                  (fun i0 ->
                    let v =
                      translate_expr width word1 mem0 locals varname_gen
                        error0 parameters_sentinel true
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange)))
                        (Compilers.Coq_expr.Ident
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_zrange))), i0))
                    in
                    assign width word1 mem0 locals varname_gen error0
                      parameters_sentinel (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_zrange))) nextn v)
                | Coq3_Compilers.Coq_string ->
                  (fun i0 ->
                    let v =
                      translate_expr width word1 mem0 locals varname_gen
                        error0 parameters_sentinel true
                        (Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string)))
                        (Compilers.Coq_expr.Ident
                        ((Compilers.Coq_type.Coq_base
                        (Compilers.Coq_base.Coq_type.Coq_list
                        (Compilers.Coq_base.Coq_type.Coq_type_base
                        Coq3_Compilers.Coq_string))), i0))
                    in
                    assign width word1 mem0 locals varname_gen error0
                      parameters_sentinel (Compilers.Coq_type.Coq_base
                      (Compilers.Coq_base.Coq_type.Coq_list
                      (Compilers.Coq_base.Coq_type.Coq_type_base
                      Coq3_Compilers.Coq_string))) nextn v))
             | Compilers.Coq_base.Coq_type.Coq_prod (a0, b) ->
               (fun i0 ->
                 let v =
                   translate_expr width word1 mem0 locals varname_gen error0
                     parameters_sentinel true (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_prod (a0, b))))
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_prod (a0, b)))), i0))
                 in
                 assign width word1 mem0 locals varname_gen error0
                   parameters_sentinel (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_base.Coq_type.Coq_prod (a0, b)))) nextn v)
             | Compilers.Coq_base.Coq_type.Coq_list a0 ->
               (fun i0 ->
                 let v =
                   translate_expr width word1 mem0 locals varname_gen error0
                     parameters_sentinel true (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_list a0)))
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_list a0))), i0))
                 in
                 assign width word1 mem0 locals varname_gen error0
                   parameters_sentinel (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_base.Coq_type.Coq_list a0))) nextn v)
             | Compilers.Coq_base.Coq_type.Coq_option a0 ->
               (fun i0 ->
                 let v =
                   translate_expr width word1 mem0 locals varname_gen error0
                     parameters_sentinel true (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_option a0)))
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     (Compilers.Coq_base.Coq_type.Coq_option a0))), i0))
                 in
                 assign width word1 mem0 locals varname_gen error0
                   parameters_sentinel (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list
                   (Compilers.Coq_base.Coq_type.Coq_option a0))) nextn v)
             | Compilers.Coq_base.Coq_type.Coq_unit ->
               (fun i0 ->
                 let v =
                   translate_expr width word1 mem0 locals varname_gen error0
                     parameters_sentinel true (Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     Compilers.Coq_base.Coq_type.Coq_unit))
                     (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                     (Compilers.Coq_base.Coq_type.Coq_list
                     Compilers.Coq_base.Coq_type.Coq_unit)), i0))
                 in
                 assign width word1 mem0 locals varname_gen error0
                   parameters_sentinel (Compilers.Coq_type.Coq_base
                   (Compilers.Coq_base.Coq_type.Coq_list
                   Compilers.Coq_base.Coq_type.Coq_unit)) nextn v))
          | Compilers.Coq_base.Coq_type.Coq_option a ->
            (fun i0 ->
              let v =
                translate_expr width word1 mem0 locals varname_gen error0
                  parameters_sentinel true (Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_option a))
                  (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                  (Compilers.Coq_base.Coq_type.Coq_option a)), i0))
              in
              assign width word1 mem0 locals varname_gen error0
                parameters_sentinel (Compilers.Coq_type.Coq_base
                (Compilers.Coq_base.Coq_type.Coq_option a)) nextn v)
          | Compilers.Coq_base.Coq_type.Coq_unit ->
            (fun i0 ->
              let v =
                translate_expr width word1 mem0 locals varname_gen error0
                  parameters_sentinel true (Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit)
                  (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base
                  Compilers.Coq_base.Coq_type.Coq_unit), i0))
              in
              assign width word1 mem0 locals varname_gen error0
                parameters_sentinel (Compilers.Coq_type.Coq_base
                Compilers.Coq_base.Coq_type.Coq_unit) nextn v))
       | Compilers.Coq_type.Coq_arrow (s0, d) ->
         (fun i0 ->
           let v =
             translate_expr width word1 mem0 locals varname_gen error0
               parameters_sentinel true (Compilers.Coq_type.Coq_arrow (s0,
               d)) (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_arrow
               (s0, d)), i0))
           in
           assign width word1 mem0 locals varname_gen error0
             parameters_sentinel (Compilers.Coq_type.Coq_arrow (s0, d)) nextn
             v)) i
    | Compilers.Coq_expr.Var (t0, v) ->
      let v0 =
        translate_expr width word1 mem0 locals varname_gen error0
          parameters_sentinel true t0 (Compilers.Coq_expr.Var (t0, v))
      in
      assign width word1 mem0 locals varname_gen error0 parameters_sentinel
        t0 nextn v0
    | Compilers.Coq_expr.Abs (s0, d, _) ->
      ((O,
        (dummy_ltype0 width word1 mem0 locals varname_gen error0
          parameters_sentinel
          (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
            parameters_sentinel
            (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
              parameters_sentinel)) (Compilers.Coq_type.Coq_arrow (s0, d)))),
        Coq_cmd.Coq_skip)
    | Compilers.Coq_expr.App (s0, d, f, x) ->
      let e0 = Compilers.Coq_expr.App (s0, d, f, x) in
      let result_if_ident2 =
        bind
          (Compilers.Coq_invert_expr.invert_AppIdent2_cps d e0 translate_cmd0
            translate_cmd0) (fun ixy ->
          let ExistT (x0, p) = ixy in
          let (p0, translate_cmd_y) = p in
          let (i, translate_cmd_x) = p0 in
          let trx = translate_cmd_x nextn in
          let try0 = translate_cmd_y (add (fst (fst trx)) nextn) in
          bind
            (translate_ident2_for_cmd width word1 mem0 locals varname_gen
              error0 parameters_sentinel (fst x0) (snd x0) d i
              (snd (fst trx)) (snd (fst try0))) (fun vars0 -> Some
            (((add (fst (fst trx)) (fst (fst try0))), vars0),
            (Coq_cmd.Coq_seq ((snd trx), (snd try0))))))
      in
      (match result_if_ident2 with
       | Some res -> res
       | None ->
         let v =
           translate_expr width word1 mem0 locals varname_gen error0
             parameters_sentinel true d e0
         in
         assign width word1 mem0 locals varname_gen error0
           parameters_sentinel d nextn v)
    | Compilers.Coq_expr.LetIn (a, b, x, f) ->
      (match a with
       | Compilers.Coq_type.Coq_base t1 ->
         (fun x0 f0 ->
           (match b with
            | Compilers.Coq_type.Coq_base t2 ->
              (fun f1 ->
                let trx =
                  assign width word1 mem0 locals varname_gen error0
                    parameters_sentinel (Compilers.Coq_type.Coq_base t1)
                    nextn
                    (translate_expr width word1 mem0 locals varname_gen
                      error0 parameters_sentinel true
                      (Compilers.Coq_type.Coq_base t1) x0)
                in
                let trf =
                  translate_cmd0 (Compilers.Coq_type.Coq_base t2)
                    (f1 (snd (fst trx))) (add nextn (fst (fst trx)))
                in
                (((add (fst (fst trx)) (fst (fst trf))), (snd (fst trf))),
                (Coq_cmd.Coq_seq ((snd trx), (snd trf)))))
            | Compilers.Coq_type.Coq_arrow (s0, d) ->
              (fun _ -> ((O,
                (dummy_ltype0 width word1 mem0 locals varname_gen error0
                  parameters_sentinel
                  (Coq_rep.listZ_local width word1 mem0 locals varname_gen
                    error0 parameters_sentinel
                    (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                      parameters_sentinel)) (Compilers.Coq_type.Coq_arrow
                  (s0, d)))), Coq_cmd.Coq_skip))) f0)
       | Compilers.Coq_type.Coq_arrow (_, _) ->
         (fun _ _ -> ((O,
           (dummy_ltype0 width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel)) b)), Coq_cmd.Coq_skip))) x f
  in translate_cmd0

(** val translate_func' :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident, ltype0)
    Compilers.Coq_expr.expr -> nat -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    (nat * base_ltype) * Coq_cmd.cmd **)

let translate_func' width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec translate_func'0 _ e nextn =
    match e with
    | Compilers.Coq_expr.Ident (t0, idc) ->
      (match t0 with
       | Compilers.Coq_type.Coq_base b ->
         (fun idc0 _ ->
           translate_cmd width word1 mem0 locals varname_gen error0
             parameters_sentinel (Compilers.Coq_type.Coq_base b)
             (Compilers.Coq_expr.Ident ((Compilers.Coq_type.Coq_base b),
             idc0)) nextn)
       | Compilers.Coq_type.Coq_arrow (s0, d) ->
         (fun _ _ -> ((O,
           (dummy_base_ltype width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel))
             (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
               (s0, d))))), Coq_cmd.Coq_skip))) idc
    | Compilers.Coq_expr.Var (t0, v) ->
      (match t0 with
       | Compilers.Coq_type.Coq_base b ->
         (fun v0 _ ->
           translate_cmd width word1 mem0 locals varname_gen error0
             parameters_sentinel (Compilers.Coq_type.Coq_base b)
             (Compilers.Coq_expr.Var ((Compilers.Coq_type.Coq_base b), v0))
             nextn)
       | Compilers.Coq_type.Coq_arrow (s0, d) ->
         (fun _ _ -> ((O,
           (dummy_base_ltype width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel))
             (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
               (s0, d))))), Coq_cmd.Coq_skip))) v
    | Compilers.Coq_expr.Abs (s0, d, f) ->
      (match s0 with
       | Compilers.Coq_type.Coq_base _ ->
         (fun f0 args0 ->
           translate_func'0 d (f0 (fst (Obj.magic args0))) nextn
             (snd (Obj.magic args0)))
       | Compilers.Coq_type.Coq_arrow (s1, d0) ->
         (fun _ _ -> ((O,
           (dummy_base_ltype width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel))
             (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
               ((Compilers.Coq_type.Coq_arrow (s1, d0)), d))))),
           Coq_cmd.Coq_skip))) f
    | Compilers.Coq_expr.App (s0, d, f, x) ->
      (match d with
       | Compilers.Coq_type.Coq_base b ->
         (fun f0 _ ->
           translate_cmd width word1 mem0 locals varname_gen error0
             parameters_sentinel (Compilers.Coq_type.Coq_base b)
             (Compilers.Coq_expr.App (s0, (Compilers.Coq_type.Coq_base b),
             f0, x)) nextn)
       | Compilers.Coq_type.Coq_arrow (s1, d0) ->
         (fun _ _ -> ((O,
           (dummy_base_ltype width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel))
             (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
               (s1, d0))))), Coq_cmd.Coq_skip))) f
    | Compilers.Coq_expr.LetIn (a, b, x, f) ->
      (match b with
       | Compilers.Coq_type.Coq_base b0 ->
         (fun f0 _ ->
           translate_cmd width word1 mem0 locals varname_gen error0
             parameters_sentinel (Compilers.Coq_type.Coq_base b0)
             (Compilers.Coq_expr.LetIn (a, (Compilers.Coq_type.Coq_base b0),
             x, f0)) nextn)
       | Compilers.Coq_type.Coq_arrow (s0, d) ->
         (fun _ _ -> ((O,
           (dummy_base_ltype width word1 mem0 locals varname_gen error0
             parameters_sentinel
             (Coq_rep.listZ_local width word1 mem0 locals varname_gen error0
               parameters_sentinel
               (Coq_rep.coq_Z width word1 mem0 locals varname_gen error0
                 parameters_sentinel))
             (Compilers.Coq_type.final_codomain (Compilers.Coq_type.Coq_arrow
               (s0, d))))), Coq_cmd.Coq_skip))) f
  in translate_func'0

(** val translate_func :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, Coq3_Compilers.ident)
    Compilers.Coq_expr.coq_Expr -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, list_lengths)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, access_sizes)
    Compilers.Coq_type.for_each_lhs_of_arrow -> base_ltype ->
    base_access_sizes -> ((char list list * char list
    list) * Coq_cmd.cmd) * list_lengths **)

let translate_func width word1 mem0 locals varname_gen error0 parameters_sentinel t0 e argnames lengths argsizes rets retsizes =
  let load_args_out =
    load_arguments width word1 mem0 locals varname_gen error0
      parameters_sentinel t0 O argnames lengths argsizes
  in
  let nextn = fst (fst load_args_out) in
  let args0 = snd (fst load_args_out) in
  let load_args_cmd = snd load_args_out in
  let out =
    translate_func' width word1 mem0 locals varname_gen error0
      parameters_sentinel t0 (e __) nextn args0
  in
  let store_rets =
    store_return_values width word1 mem0 locals varname_gen error0
      parameters_sentinel (Compilers.Coq_type.final_codomain t0)
      (snd (fst out)) rets retsizes
  in
  let part =
    extract_listnames width word1 mem0 locals varname_gen error0
      parameters_sentinel (Compilers.Coq_type.final_codomain t0) rets
  in
  let out_ptrs =
    flatten_listonly_base_ltype width word1 mem0 locals varname_gen error0
      parameters_sentinel (Compilers.Coq_type.final_codomain t0) (fst part)
  in
  let innames =
    app out_ptrs
      (flatten_argnames width word1 mem0 locals varname_gen error0
        parameters_sentinel t0 argnames)
  in
  let outnames =
    flatten_listexcl_base_ltype width word1 mem0 locals varname_gen error0
      parameters_sentinel (Compilers.Coq_type.final_codomain t0) (snd part)
  in
  let body = Coq_cmd.Coq_seq ((Coq_cmd.Coq_seq (load_args_cmd, (snd out))),
    (snd store_rets))
  in
  (((innames, outnames), body), (fst store_rets))

(** val print_name :
    (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) -> char list **)

let print_name =
  fst

(** val print_type :
    (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) -> char list **)

let print_type n3 =
  Coq25_Compilers.ToString.C.String.Coq_type.Coq_primitive.to_string
    Coq7_Compilers.Options.default_language_naming_conventions []
    Coq24_Compilers.ToString.IR.Coq_type.Z (snd n3)

(** val print_cast :
    (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) -> char list **)

let print_cast n3 =
  append ('('::[]) (append (print_type n3) (')'::[]))

(** val flatten_base_var_data :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
    (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list **)

let rec flatten_base_var_data = function
| Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
  (match t1 with
   | Coq3_Compilers.Z ->
     (fun pat ->
       let (p, _) = Obj.magic pat in
       let (p0, ty) = p in let (n3, _) = p0 in (n3, ty) :: [])
   | Coq3_Compilers.Coq_bool -> (fun _ -> [])
   | Coq3_Compilers.Coq_nat -> (fun _ -> [])
   | Coq3_Compilers.Coq_zrange -> (fun _ -> [])
   | Coq3_Compilers.Coq_string -> (fun _ -> []))
| Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
  (fun x ->
    app (flatten_base_var_data a (fst (Obj.magic x)))
      (flatten_base_var_data b (snd (Obj.magic x))))
| Compilers.Coq_base.Coq_type.Coq_list _ ->
  (fun pat ->
    let (p, _) = Obj.magic pat in
    let (p0, _) = p in let (n3, ty) = p0 in (n3, ty) :: [])
| Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> [])
| Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> [])

(** val flatten_argnames_of_var_data :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list **)

let rec flatten_argnames_of_var_data = function
| Compilers.Coq_type.Coq_base _ -> (fun _ -> [])
| Compilers.Coq_type.Coq_arrow (s0, b) ->
  (match s0 with
   | Compilers.Coq_type.Coq_base a ->
     (fun x ->
       app (flatten_base_var_data a (fst (Obj.magic x)))
         (flatten_argnames_of_var_data b (snd (Obj.magic x))))
   | Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ -> []))

(** val flatten_listonly_base_var_data :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data base_listonly ->
    (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list **)

let rec flatten_listonly_base_var_data = function
| Compilers.Coq_base.Coq_type.Coq_type_base _ -> (fun _ -> [])
| Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
  (fun x ->
    app (flatten_listonly_base_var_data a (fst (Obj.magic x)))
      (flatten_listonly_base_var_data b (snd (Obj.magic x))))
| Compilers.Coq_base.Coq_type.Coq_list a ->
  (match a with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z ->
        flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Z))
      | Coq3_Compilers.Coq_bool -> (fun _ -> [])
      | Coq3_Compilers.Coq_nat -> (fun _ -> [])
      | Coq3_Compilers.Coq_zrange -> (fun _ -> [])
      | Coq3_Compilers.Coq_string -> (fun _ -> []))
   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ -> [])
   | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ -> [])
   | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> [])
   | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> []))
| Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ -> [])
| Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ -> [])

(** val flatten_listexcl_base_var_data :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data base_listexcl ->
    (char list * Coq7_Compilers.ToString.Coq_int.coq_type option) list **)

let rec flatten_listexcl_base_var_data = function
| Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
  flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_type_base t1)
| Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
  (fun x ->
    app (flatten_listexcl_base_var_data a (fst (Obj.magic x)))
      (flatten_listexcl_base_var_data b (snd (Obj.magic x))))
| Compilers.Coq_base.Coq_type.Coq_list a ->
  (match a with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z -> (fun _ -> [])
      | Coq3_Compilers.Coq_bool ->
        flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_bool))
      | Coq3_Compilers.Coq_nat ->
        flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base Coq3_Compilers.Coq_nat))
      | Coq3_Compilers.Coq_zrange ->
        flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_zrange))
      | Coq3_Compilers.Coq_string ->
        flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
          (Compilers.Coq_base.Coq_type.Coq_type_base
          Coq3_Compilers.Coq_string)))
   | Compilers.Coq_base.Coq_type.Coq_prod (a0, b) ->
     flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
       (Compilers.Coq_base.Coq_type.Coq_prod (a0, b)))
   | Compilers.Coq_base.Coq_type.Coq_list a0 ->
     flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
       (Compilers.Coq_base.Coq_type.Coq_list a0))
   | Compilers.Coq_base.Coq_type.Coq_option a0 ->
     flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
       (Compilers.Coq_base.Coq_type.Coq_option a0))
   | Compilers.Coq_base.Coq_type.Coq_unit ->
     flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_list
       Compilers.Coq_base.Coq_type.Coq_unit))
| Compilers.Coq_base.Coq_type.Coq_option a ->
  flatten_base_var_data (Compilers.Coq_base.Coq_type.Coq_option a)
| Compilers.Coq_base.Coq_type.Coq_unit ->
  flatten_base_var_data Compilers.Coq_base.Coq_type.Coq_unit

(** val extract_list_var_data :
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data
    base_listonly * Coq7_Compilers.ToString.OfPHOAS.base_var_data
    base_listexcl **)

let rec extract_list_var_data = function
| Compilers.Coq_base.Coq_type.Coq_type_base _ ->
  (fun x -> ((Obj.magic ()), x))
| Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
  (fun x ->
    let p1 = extract_list_var_data a (fst (Obj.magic x)) in
    let p2 = extract_list_var_data b (snd (Obj.magic x)) in
    ((Obj.magic ((fst p1), (fst p2))), (Obj.magic ((snd p1), (snd p2)))))
| Compilers.Coq_base.Coq_type.Coq_list a ->
  (match a with
   | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
     (match t1 with
      | Coq3_Compilers.Z -> (fun x -> (x, (Obj.magic ())))
      | Coq3_Compilers.Coq_bool -> (fun x -> ((Obj.magic ()), x))
      | Coq3_Compilers.Coq_nat -> (fun x -> ((Obj.magic ()), x))
      | Coq3_Compilers.Coq_zrange -> (fun x -> ((Obj.magic ()), x))
      | Coq3_Compilers.Coq_string -> (fun x -> ((Obj.magic ()), x)))
   | Compilers.Coq_base.Coq_type.Coq_prod (_, _) ->
     (fun x -> ((Obj.magic ()), x))
   | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun x -> ((Obj.magic ()), x))
   | Compilers.Coq_base.Coq_type.Coq_option _ ->
     (fun x -> ((Obj.magic ()), x))
   | Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> ((Obj.magic ()), x)))
| Compilers.Coq_base.Coq_type.Coq_option _ -> (fun x -> ((Obj.magic ()), x))
| Compilers.Coq_base.Coq_type.Coq_unit -> (fun x -> ((Obj.magic ()), x))

(** val make_base_var_data :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    -> base_ltype -> list_lengths ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data option **)

let make_base_var_data width _ _ _ _ _ _ =
  let rec make_base_var_data0 t0 =
    let int_type = Coq7_Compilers.ToString.Coq_int.Coq_unsigned
      (Coq_Z.to_nat width)
    in
    (match t0 with
     | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
       (match t1 with
        | Coq3_Compilers.Z ->
          (fun name0 _ ->
            let is_pointer = false in
            let typedef0 = None in
            Some
            (Obj.magic (((name0, is_pointer), (Some int_type)), typedef0)))
        | Coq3_Compilers.Coq_bool -> (fun _ _ -> None)
        | Coq3_Compilers.Coq_nat -> (fun _ _ -> None)
        | Coq3_Compilers.Coq_zrange -> (fun _ _ -> None)
        | Coq3_Compilers.Coq_string -> (fun _ _ -> None))
     | Compilers.Coq_base.Coq_type.Coq_prod (a, b) ->
       (fun x ll ->
         bind
           (make_base_var_data0 a (fst (Obj.magic x)) (fst (Obj.magic ll)))
           (fun x1 ->
           bind
             (make_base_var_data0 b (snd (Obj.magic x)) (snd (Obj.magic ll)))
             (fun x2 -> Some (Obj.magic (x1, x2)))))
     | Compilers.Coq_base.Coq_type.Coq_list a ->
       (match a with
        | Compilers.Coq_base.Coq_type.Coq_type_base t1 ->
          (match t1 with
           | Coq3_Compilers.Z ->
             (fun name0 len ->
               let typedef0 = None in
               Some (Obj.magic (((name0, (Some int_type)), len), typedef0)))
           | Coq3_Compilers.Coq_bool -> (fun _ _ -> None)
           | Coq3_Compilers.Coq_nat -> (fun _ _ -> None)
           | Coq3_Compilers.Coq_zrange -> (fun _ _ -> None)
           | Coq3_Compilers.Coq_string -> (fun _ _ -> None))
        | Compilers.Coq_base.Coq_type.Coq_prod (_, _) -> (fun _ _ -> None)
        | Compilers.Coq_base.Coq_type.Coq_list _ -> (fun _ _ -> None)
        | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> None)
        | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> None))
     | Compilers.Coq_base.Coq_type.Coq_option _ -> (fun _ _ -> None)
     | Compilers.Coq_base.Coq_type.Coq_unit -> (fun _ _ -> None))
  in make_base_var_data0

(** val make_var_data :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> ltype0 -> list_lengths ->
    Coq7_Compilers.ToString.OfPHOAS.var_data option **)

let make_var_data width word1 mem0 locals varname_gen error0 parameters_sentinel = function
| Compilers.Coq_type.Coq_base b ->
  make_base_var_data width word1 mem0 locals varname_gen error0
    parameters_sentinel b
| Compilers.Coq_type.Coq_arrow (_, _) -> (fun _ _ -> None)

(** val make_var_data_of_args :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, list_lengths)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow option **)

let make_var_data_of_args width word1 mem0 locals varname_gen error0 parameters_sentinel =
  let rec make_var_data_of_args0 = function
  | Compilers.Coq_type.Coq_base _ -> (fun _ _ -> Some (Obj.magic ()))
  | Compilers.Coq_type.Coq_arrow (s0, d) ->
    (fun names lengths ->
      bind
        (make_var_data width word1 mem0 locals varname_gen error0
          parameters_sentinel s0 (fst (Obj.magic names))
          (fst (Obj.magic lengths))) (fun x ->
        bind
          (make_var_data_of_args0 d (snd (Obj.magic names))
            (snd (Obj.magic lengths))) (fun y -> Some (Obj.magic (x, y)))))
  in make_var_data_of_args0

(** val make_header :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq7_Compilers.Options.skip_typedefs_opt ->
    Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, ltype0)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type, list_lengths)
    Compilers.Coq_type.for_each_lhs_of_arrow -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow -> ltype0 -> list_lengths ->
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp -> char list list option **)

let make_header width word1 mem0 locals varname_gen error0 parameters_sentinel skip_typedefs0 t0 innames inlengths inbounds outnames outlengths outbounds =
  match make_var_data_of_args width word1 mem0 locals varname_gen error0
          parameters_sentinel t0 innames inlengths with
  | Some indata ->
    (match make_base_var_data width word1 mem0 locals varname_gen error0
             parameters_sentinel (Compilers.Coq_type.final_codomain t0)
             outnames outlengths with
     | Some outdata ->
       Some
         (app (('/'::('*'::[])) :: [])
           (app
             ((' '::('*'::(' '::('I'::('n'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[])))))))))))))))) :: [])
             (app
               (map (fun v -> append (' '::('*'::(' '::(' '::(' '::[]))))) v)
                 (Coq7_Compilers.ToString.OfPHOAS.input_bounds_to_string
                   skip_typedefs0 t0 indata inbounds))
               (app
                 ((' '::('*'::(' '::('O'::('u'::('t'::('p'::('u'::('t'::(' '::('B'::('o'::('u'::('n'::('d'::('s'::(':'::[]))))))))))))))))) :: [])
                 (app
                   (map (fun v ->
                     append (' '::('*'::(' '::(' '::(' '::[]))))) v)
                     (Coq7_Compilers.ToString.OfPHOAS.bound_to_string
                       skip_typedefs0 (Compilers.Coq_type.final_codomain t0)
                       outdata outbounds)) ((' '::('*'::('/'::[]))) :: []))))))
     | None -> None)
  | None -> None

(** val bedrock_func_to_lines : (char list * func) -> char list list **)

let bedrock_func_to_lines f =
  (c_func f) :: []

(** val wrap_call :
    z -> Coq_word.word -> (Coq_word.rep, char) Coq_map.map -> (char list,
    Coq_word.rep) Coq_map.map -> (nat -> char list) -> Coq_expr.expr ->
    parameters0 -> Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type
    Compilers.Coq_type.coq_type -> (Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_data -> (char list * func) ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type, access_sizes)
    Compilers.Coq_type.for_each_lhs_of_arrow -> base_access_sizes -> char list **)

let wrap_call _ _ _ _ _ _ _ t0 indata outdata f _ _ =
  let part =
    extract_list_var_data (Compilers.Coq_type.final_codomain t0) outdata
  in
  let out_ptrs =
    flatten_listonly_base_var_data (Compilers.Coq_type.final_codomain t0)
      (fst part)
  in
  let innames = app out_ptrs (flatten_argnames_of_var_data t0 indata) in
  let outnames =
    flatten_listexcl_base_var_data (Compilers.Coq_type.final_codomain t0)
      (snd part)
  in
  let (name0, f0) = f in
  let (p, _) = f0 in
  let (_, rets) = p in
  let (precall, all_args) =
    match rets with
    | [] -> (name0, (app outnames innames))
    | _ :: _ ->
      (match outnames with
       | [] -> (name0, (app outnames innames))
       | r0 :: _ ->
         let r1 = last outnames r0 in
         let outnames' = removelast outnames in
         ((append ('*'::[])
            (append (print_name r1)
              (append (' '::('='::(' '::[]))) (append (print_cast r1) name0)))),
         (app outnames' innames)))
  in
  append (append precall ('('::[]))
    (append
      (concat0 (','::(' '::[]))
        (map (fun n3 ->
          append
            ('('::('u'::('i'::('n'::('t'::('p'::('t'::('r'::('_'::('t'::(')'::[])))))))))))
            (print_name n3)) all_args)) (')'::[]))

(** val decidable_Bitwidth : z -> decidable0 **)

let decidable_Bitwidth width =
  decidable_iff_to_impl
    (dec_or (dec_eq_Z0 width (Zpos (XO (XO (XO (XO (XO XH)))))))
      (dec_eq_Z0 width (Zpos (XO (XO (XO (XO (XO (XO XH)))))))))

(** val bedrock2_ToFunctionLines :
    Coq6_Compilers.ZRange.Settings.AbstractInterpretation.coq_Options ->
    Coq7_Compilers.Options.relax_zrange_opt ->
    Coq7_Compilers.Options.language_naming_conventions_opt ->
    Coq7_Compilers.Options.documentation_options_opt ->
    Coq7_Compilers.Options.output_options_opt -> z -> bool -> bool -> bool ->
    bool -> bool -> char list -> char list -> Coq3_Compilers.base
    Compilers.Coq_base.Coq_type.coq_type Compilers.Coq_type.coq_type ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq3_Compilers.ident) Compilers.Coq_expr.coq_Expr ->
    ((Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.var_data -> char list list) -> char list
    list option -> (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq6_Compilers.ZRange.Coq_type.Coq_option.interp)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq6_Compilers.ZRange.Coq_type.Coq_base.Coq_option.interp ->
    (Coq3_Compilers.base Compilers.Coq_base.Coq_type.coq_type,
    Coq7_Compilers.ToString.OfPHOAS.var_typedef_data)
    Compilers.Coq_type.for_each_lhs_of_arrow ->
    Coq7_Compilers.ToString.OfPHOAS.base_var_typedef_data -> (char list
    list * Coq7_Compilers.ToString.ident_infos, char list) sum **)

let bedrock2_ToFunctionLines opts relax_zrange language_naming_conventions0 _ output_options0 width _ _ static0 _ inline0 prefix1 name0 t0 e _ name_list inbounds outbounds intypedefs outtypedefs =
  if dec0 (dec_lt_Z Z0 width)
  then if dec0 (decidable_Bitwidth width)
       then let p = () in
            let innames =
              make_innames width (word0 width) (map5 width (word0 width))
                (Obj.magic map4 build_parameters) default_varname_gen
                (Coq_expr.Coq_var eRROR) p default_inname_gen t0
            in
            let outnames =
              make_outnames width (word0 width) (map5 width (word0 width))
                (Obj.magic map4 build_parameters) default_varname_gen
                (Coq_expr.Coq_var eRROR) p default_outname_gen
                (Compilers.Coq_type.final_codomain t0)
            in
            (match list_lengths_from_argbounds t0 inbounds with
             | Some inlengths ->
               (match make_access_sizes_args width (word0 width)
                        (map5 width (word0 width))
                        (Obj.magic map4 build_parameters) default_varname_gen
                        (Coq_expr.Coq_var eRROR) p t0 inbounds with
                | Some insizes ->
                  (match make_base_access_sizes width (word0 width)
                           (map5 width (word0 width))
                           (Obj.magic map4 build_parameters)
                           default_varname_gen (Coq_expr.Coq_var eRROR) p
                           (Compilers.Coq_type.final_codomain t0) outbounds with
                   | Some outsizes ->
                     let out =
                       translate_func width (word0 width)
                         (map5 width (word0 width))
                         (Obj.magic map4 build_parameters)
                         default_varname_gen (Coq_expr.Coq_var eRROR) p t0 e
                         innames inlengths insizes outnames outsizes
                     in
                     let f =
                       ((append
                          ('i'::('n'::('t'::('e'::('r'::('n'::('a'::('l'::('_'::[])))))))))
                          name0), (fst out))
                     in
                     let outlengths = snd out in
                     if error_free_cmd (snd (snd f))
                     then (match make_header width (word0 width)
                                   (map5 width (word0 width))
                                   (Obj.magic map4 build_parameters)
                                   default_varname_gen (Coq_expr.Coq_var
                                   eRROR) p
                                   output_options0.Coq7_Compilers.Options.skip_typedefs_
                                   t0 innames inlengths inbounds outnames
                                   outlengths outbounds with
                           | Some header0 ->
                             (match let relax_zrange0 = fun r0 ->
                                      sequence_return0
                                        (relax_zrange_gen false ((Zpos (XO
                                          (XO (XO XH)))) :: []) r0)
                                        (relax_zrange r0)
                                    in
                                    Coq24_Compilers.ToString.IR.OfPHOAS.var_data_of_PHOAS_bounds
                                      relax_zrange0 opts t0 e name_list
                                      inbounds outbounds intypedefs
                                      outtypedefs with
                              | Inl p0 ->
                                let (indata, outdata) = p0 in
                                Inl
                                ((app
                                   (app header0
                                     (app
                                       (('s'::('t'::('a'::('t'::('i'::('c'::[])))))) :: [])
                                       (bedrock_func_to_lines f)))
                                   (('/'::('*'::(' '::('N'::('O'::('T'::('E'::(':'::(' '::('T'::('h'::('e'::(' '::('f'::('o'::('l'::('l'::('o'::('w'::('i'::('n'::('g'::(' '::('w'::('r'::('a'::('p'::('p'::('e'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(' '::('i'::('s'::(' '::('n'::('o'::('t'::(' '::('c'::('o'::('v'::('e'::('r'::('e'::('d'::(' '::('b'::('y'::(' '::('C'::('o'::('q'::(' '::('p'::('r'::('o'::('o'::('f'::('s'::(' '::('*'::('/'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: (
                                   (append
                                     (append
                                       (if inline0
                                        then '_'::('_'::('i'::('n'::('l'::('i'::('n'::('e'::('_'::('_'::(' '::[]))))))))))
                                        else [])
                                       (append
                                         (if static0
                                          then 's'::('t'::('a'::('t'::('i'::('c'::(' '::[]))))))
                                          else [])
                                         (append
                                           ('v'::('o'::('i'::('d'::(' '::[])))))
                                           (append name0 ('('::[])))))
                                     (append
                                       (concat0 (','::(' '::[]))
                                         (app
                                           (Coq25_Compilers.ToString.C.to_retarg_list
                                             language_naming_conventions0
                                             output_options0.Coq7_Compilers.Options.skip_typedefs_
                                             prefix1
                                             (Compilers.Coq_type.Coq_base
                                             (Compilers.Coq_type.final_codomain
                                               t0)) outdata)
                                           (Coq25_Compilers.ToString.C.to_arg_list_for_each_lhs_of_arrow
                                             language_naming_conventions0
                                             output_options0.Coq7_Compilers.Options.skip_typedefs_
                                             prefix1 t0 indata)))
                                       (')'::(' '::('{'::[]))))) :: (
                                   (append (' '::(' '::[]))
                                     (append
                                       (wrap_call width (word0 width)
                                         (map5 width (word0 width))
                                         (Obj.magic map4 build_parameters)
                                         default_varname_gen
                                         (Coq_expr.Coq_var eRROR) p t0 indata
                                         outdata f insizes outsizes)
                                       (';'::[]))) :: (('}'::[]) :: ([] :: [])))))),
                                Coq7_Compilers.ToString.ident_info_empty)
                              | Inr errs -> Inr (concat0 (newLine::[]) errs))
                           | None ->
                             Inr
                               (concat0 (newLine::[])
                                 (('F'::('a'::('i'::('l'::('e'::('d'::(' '::('t'::('o'::(' '::('g'::('e'::('n'::('e'::('r'::('a'::('t'::('e'::(' '::('h'::('e'::('a'::('d'::('e'::('r'::(' '::('f'::('o'::('r'::(' '::('f'::('u'::('n'::('c'::('t'::('i'::('o'::('n'::(':'::[]))))))))))))))))))))))))))))))))))))))) :: 
                                 (bedrock_func_to_lines f))))
                     else let header0 =
                            match make_header width (word0 width)
                                    (map5 width (word0 width))
                                    (Obj.magic map4 build_parameters)
                                    default_varname_gen (Coq_expr.Coq_var
                                    eRROR) p
                                    output_options0.Coq7_Compilers.Options.skip_typedefs_
                                    t0 innames inlengths inbounds outnames
                                    outlengths outbounds with
                            | Some x -> x
                            | None -> []
                          in
                          Inr
                          (concat0 (newLine::[])
                            (app
                              (('E'::('R'::('R'::('O'::('R'::('-'::('C'::('O'::('N'::('T'::('A'::('I'::('N'::('I'::('N'::('G'::(' '::('O'::('U'::('T'::('P'::('U'::('T'::(':'::[])))))))))))))))))))))))) :: [])
                              (app header0
                                (app (bedrock_func_to_lines f)
                                  (('E'::('r'::('r'::('o'::('r'::(' '::('o'::('c'::('c'::('u'::('r'::('e'::('d'::(' '::('d'::('u'::('r'::('i'::('n'::('g'::(' '::('t'::('r'::('a'::('n'::('s'::('l'::('a'::('t'::('i'::('o'::('n'::(' '::('t'::('o'::(' '::('b'::('e'::('d'::('r'::('o'::('c'::('k'::('2'::('.'::(' '::('T'::('h'::('i'::('s'::(' '::('i'::('s'::(' '::('l'::('i'::('k'::('e'::('l'::('y'::(' '::('b'::('e'::('c'::('a'::('u'::('s'::('e'::(' '::('a'::(' '::('p'::('a'::('r'::('t'::(' '::('o'::('f'::(' '::('t'::('h'::('e'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('e'::('x'::('p'::('r'::('e'::('s'::('s'::('i'::('o'::('n'::(' '::('e'::('i'::('t'::('h'::('e'::('r'::(' '::('h'::('a'::('d'::(' '::('u'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::(' '::('t'::('y'::('p'::('e'::('s'::(' '::('('::('b'::('e'::('d'::('r'::('o'::('c'::('k'::('2'::(' '::('r'::('e'::('q'::('u'::('i'::('r'::('e'::('s'::(' '::('t'::('h'::('a'::('t'::(' '::('a'::('l'::('l'::(' '::('i'::('n'::('t'::('e'::('g'::('e'::('r'::('s'::(' '::('h'::('a'::('v'::('e'::(' '::('t'::('h'::('e'::(' '::('s'::('a'::('m'::('e'::(' '::('s'::('i'::('z'::('e'::(')'::(' '::('o'::('r'::(' '::('c'::('o'::('n'::('t'::('a'::('i'::('n'::('e'::('d'::(' '::('a'::('n'::(' '::('u'::('n'::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::(' '::('o'::('p'::('e'::('r'::('a'::('t'::('i'::('o'::('n'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))) :: [])))))
                   | None ->
                     Inr
                       ('E'::('r'::('r'::('o'::('r'::(' '::('d'::('e'::('t'::('e'::('r'::('m'::('i'::('n'::('i'::('n'::('g'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('s'::('i'::('z'::('e'::('s'::(' '::('f'::('o'::('r'::(' '::('o'::('u'::('t'::('p'::('u'::('t'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::('.'::(' '::('P'::('l'::('e'::('a'::('s'::('e'::(' '::('c'::('h'::('e'::('c'::('k'::(' '::('t'::('h'::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('f'::('i'::('t'::(' '::('w'::('i'::('t'::('h'::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('m'::('a'::('c'::('h'::('i'::('n'::('e'::(' '::('w'::('o'::('r'::('d'::(' '::('s'::('i'::('z'::('e'::('.'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
                | None ->
                  Inr
                    ('E'::('r'::('r'::('o'::('r'::(' '::('d'::('e'::('t'::('e'::('r'::('m'::('i'::('n'::('i'::('n'::('g'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('s'::('i'::('z'::('e'::('s'::(' '::('f'::('o'::('r'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::('.'::(' '::('P'::('l'::('e'::('a'::('s'::('e'::(' '::('c'::('h'::('e'::('c'::('k'::(' '::('t'::('h'::('a'::('t'::(' '::('t'::('h'::('e'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::(' '::('f'::('i'::('t'::(' '::('w'::('i'::('t'::('h'::('i'::('n'::(' '::('t'::('h'::('e'::(' '::('m'::('a'::('c'::('h'::('i'::('n'::('e'::(' '::('w'::('o'::('r'::('d'::(' '::('s'::('i'::('z'::('e'::('.'::[]))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
             | None ->
               Inr
                 ('E'::('r'::('r'::('o'::('r'::(' '::('d'::('e'::('t'::('e'::('r'::('m'::('i'::('n'::('i'::('n'::('g'::(' '::('a'::('r'::('g'::('u'::('m'::('e'::('n'::('t'::(' '::('l'::('e'::('n'::('g'::('t'::('h'::('s'::(' '::('f'::('r'::('o'::('m'::(' '::('i'::('n'::('p'::('u'::('t'::(' '::('b'::('o'::('u'::('n'::('d'::('s'::[])))))))))))))))))))))))))))))))))))))))))))))))))))))
       else Inr
              ('O'::('n'::('l'::('y'::(' '::('3'::('2'::('-'::('b'::('i'::('t'::(' '::('a'::('n'::('d'::(' '::('6'::('4'::('-'::('b'::('i'::('t'::(' '::('t'::('a'::('r'::('g'::('e'::('t'::('s'::(' '::('a'::('r'::('e'::(' '::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::[]))))))))))))))))))))))))))))))))))))))))))))
  else Inr
         ('O'::('n'::('l'::('y'::(' '::('3'::('2'::('-'::('b'::('i'::('t'::(' '::('a'::('n'::('d'::(' '::('6'::('4'::('-'::('b'::('i'::('t'::(' '::('t'::('a'::('r'::('g'::('e'::('t'::('s'::(' '::('a'::('r'::('e'::(' '::('s'::('u'::('p'::('p'::('o'::('r'::('t'::('e'::('d'::[]))))))))))))))))))))))))))))))))))))))))))))

(** val outputBedrock2API : Coq7_Compilers.ToString.coq_OutputLanguageAPI **)

let outputBedrock2API =
  { Coq7_Compilers.ToString.comment_block = (fun s0 ->
    map (fun line0 ->
      append ('/'::('*'::(' '::[]))) (append line0 (' '::('*'::('/'::[])))))
      s0); Coq7_Compilers.ToString.comment_file_header_block = (fun s0 ->
    map (fun line0 ->
      append ('/'::('*'::(' '::[]))) (append line0 (' '::('*'::('/'::[])))))
      s0); Coq7_Compilers.ToString.coq_ToFunctionLines =
    bedrock2_ToFunctionLines; Coq7_Compilers.ToString.header =
    (fun _ _ _ _ _ _ _ _ _ _ _ -> [] :: (prelude :: []));
    Coq7_Compilers.ToString.footer = (fun _ _ _ _ _ _ _ _ _ -> []);
    Coq7_Compilers.ToString.strip_special_infos = (fun _ infos -> infos) }

module Bedrock2Later =
 struct
  (** val bedrock2_supported_languages :
      ForExtraction.supported_languagesT **)

  let bedrock2_supported_languages =
    let bedrock2 =
      (('b'::('e'::('d'::('r'::('o'::('c'::('k'::('2'::[])))))))),
      outputBedrock2API)
    in
    (match ForExtraction.default_supported_languages with
     | [] -> bedrock2 :: []
     | l :: ls -> l :: (bedrock2 :: ls))

  module FiatCrypto =
   struct
    (** val main : unit **)

    let main =
      main_gen
        (ForExtraction.FiatCrypto.coq_PipelineMain
          bedrock2_supported_languages iODriverTrace)
   end
 end
